var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
(function () {
    'use strict';
    function isFunction(x) {
        return typeof x === 'function';
    }
    var _enable_super_gross_mode_that_will_cause_bad_things = false;
    var config = {
        Promise: undefined,
        set useDeprecatedSynchronousErrorHandling(value) {
            if (value) {
                var error = new Error();
                console.warn('DEPRECATED! RxJS was set to use deprecated synchronous error handling behavior by code at: \n' + error.stack);
            }
            else if (_enable_super_gross_mode_that_will_cause_bad_things) {
                console.log('RxJS: Back to a better error behavior. Thank you. <3');
            }
            _enable_super_gross_mode_that_will_cause_bad_things = value;
        },
        get useDeprecatedSynchronousErrorHandling() {
            return _enable_super_gross_mode_that_will_cause_bad_things;
        },
    };
    function hostReportError(err) {
        setTimeout(function () { throw err; }, 0);
    }
    var empty = {
        closed: true,
        next: function (value) { },
        error: function (err) {
            if (config.useDeprecatedSynchronousErrorHandling) {
                throw err;
            }
            else {
                hostReportError(err);
            }
        },
        complete: function () { }
    };
    var isArray = (function () { return Array.isArray || (function (x) { return x && typeof x.length === 'number'; }); })();
    function isObject(x) {
        return x !== null && typeof x === 'object';
    }
    var UnsubscriptionErrorImpl = (function () {
        function UnsubscriptionErrorImpl(errors) {
            Error.call(this);
            this.message = errors ?
                errors.length + " errors occurred during unsubscription:\n" + errors.map(function (err, i) { return i + 1 + ") " + err.toString(); }).join('\n  ') : '';
            this.name = 'UnsubscriptionError';
            this.errors = errors;
            return this;
        }
        UnsubscriptionErrorImpl.prototype = Object.create(Error.prototype);
        return UnsubscriptionErrorImpl;
    })();
    var UnsubscriptionError = UnsubscriptionErrorImpl;
    var Subscription = /** @class */ (function () {
        function Subscription(unsubscribe) {
            this.closed = false;
            this._parentOrParents = null;
            this._subscriptions = null;
            if (unsubscribe) {
                this._unsubscribe = unsubscribe;
            }
        }
        Subscription.prototype.unsubscribe = function () {
            var errors;
            if (this.closed) {
                return;
            }
            var _b = this, _parentOrParents = _b._parentOrParents, _unsubscribe = _b._unsubscribe, _subscriptions = _b._subscriptions;
            this.closed = true;
            this._parentOrParents = null;
            this._subscriptions = null;
            if (_parentOrParents instanceof Subscription) {
                _parentOrParents.remove(this);
            }
            else if (_parentOrParents !== null) {
                for (var index = 0; index < _parentOrParents.length; ++index) {
                    var parent_1 = _parentOrParents[index];
                    parent_1.remove(this);
                }
            }
            if (isFunction(_unsubscribe)) {
                try {
                    _unsubscribe.call(this);
                }
                catch (e) {
                    errors = e instanceof UnsubscriptionError ? flattenUnsubscriptionErrors(e.errors) : [e];
                }
            }
            if (isArray(_subscriptions)) {
                var index = -1;
                var len = _subscriptions.length;
                while (++index < len) {
                    var sub = _subscriptions[index];
                    if (isObject(sub)) {
                        try {
                            sub.unsubscribe();
                        }
                        catch (e) {
                            errors = errors || [];
                            if (e instanceof UnsubscriptionError) {
                                errors = errors.concat(flattenUnsubscriptionErrors(e.errors));
                            }
                            else {
                                errors.push(e);
                            }
                        }
                    }
                }
            }
            if (errors) {
                throw new UnsubscriptionError(errors);
            }
        };
        Subscription.prototype.add = function (teardown) {
            var subscription = teardown;
            if (!teardown) {
                return Subscription.EMPTY;
            }
            switch (typeof teardown) {
                case 'function':
                    subscription = new Subscription(teardown);
                case 'object':
                    if (subscription === this || subscription.closed || typeof subscription.unsubscribe !== 'function') {
                        return subscription;
                    }
                    else if (this.closed) {
                        subscription.unsubscribe();
                        return subscription;
                    }
                    else if (!(subscription instanceof Subscription)) {
                        var tmp = subscription;
                        subscription = new Subscription();
                        subscription._subscriptions = [tmp];
                    }
                    break;
                default: {
                    throw new Error('unrecognized teardown ' + teardown + ' added to Subscription.');
                }
            }
            var _parentOrParents = subscription._parentOrParents;
            if (_parentOrParents === null) {
                subscription._parentOrParents = this;
            }
            else if (_parentOrParents instanceof Subscription) {
                if (_parentOrParents === this) {
                    return subscription;
                }
                subscription._parentOrParents = [_parentOrParents, this];
            }
            else if (_parentOrParents.indexOf(this) === -1) {
                _parentOrParents.push(this);
            }
            else {
                return subscription;
            }
            var subscriptions = this._subscriptions;
            if (subscriptions === null) {
                this._subscriptions = [subscription];
            }
            else {
                subscriptions.push(subscription);
            }
            return subscription;
        };
        Subscription.prototype.remove = function (subscription) {
            var subscriptions = this._subscriptions;
            if (subscriptions) {
                var subscriptionIndex = subscriptions.indexOf(subscription);
                if (subscriptionIndex !== -1) {
                    subscriptions.splice(subscriptionIndex, 1);
                }
            }
        };
        return Subscription;
    }());
    Subscription.EMPTY = (function (empty) {
        empty.closed = true;
        return empty;
    }(new Subscription()));
    function flattenUnsubscriptionErrors(errors) {
        return errors.reduce(function (errs, err) { return errs.concat((err instanceof UnsubscriptionError) ? err.errors : err); }, []);
    }
    var rxSubscriber = (function () { return typeof Symbol === 'function'
        ? Symbol('rxSubscriber')
        : '@@rxSubscriber_' + Math.random(); })();
    var Subscriber = /** @class */ (function (_super) {
        __extends(Subscriber, _super);
        function Subscriber(destinationOrNext, error, complete) {
            var _this = _super.call(this) || this;
            _this.syncErrorValue = null;
            _this.syncErrorThrown = false;
            _this.syncErrorThrowable = false;
            _this.isStopped = false;
            switch (arguments.length) {
                case 0:
                    _this.destination = empty;
                    break;
                case 1:
                    if (!destinationOrNext) {
                        _this.destination = empty;
                        break;
                    }
                    if (typeof destinationOrNext === 'object') {
                        if (destinationOrNext instanceof Subscriber) {
                            _this.syncErrorThrowable = destinationOrNext.syncErrorThrowable;
                            _this.destination = destinationOrNext;
                            destinationOrNext.add(_this);
                        }
                        else {
                            _this.syncErrorThrowable = true;
                            _this.destination = new SafeSubscriber(_this, destinationOrNext);
                        }
                        break;
                    }
                default:
                    _this.syncErrorThrowable = true;
                    _this.destination = new SafeSubscriber(_this, destinationOrNext, error, complete);
                    break;
            }
            return _this;
        }
        Subscriber.prototype[rxSubscriber] = function () { return this; };
        Subscriber.create = function (next, error, complete) {
            var subscriber = new Subscriber(next, error, complete);
            subscriber.syncErrorThrowable = false;
            return subscriber;
        };
        Subscriber.prototype.next = function (value) {
            if (!this.isStopped) {
                this._next(value);
            }
        };
        Subscriber.prototype.error = function (err) {
            if (!this.isStopped) {
                this.isStopped = true;
                this._error(err);
            }
        };
        Subscriber.prototype.complete = function () {
            if (!this.isStopped) {
                this.isStopped = true;
                this._complete();
            }
        };
        Subscriber.prototype.unsubscribe = function () {
            if (this.closed) {
                return;
            }
            this.isStopped = true;
            _super.prototype.unsubscribe.call(this);
        };
        Subscriber.prototype._next = function (value) {
            this.destination.next(value);
        };
        Subscriber.prototype._error = function (err) {
            this.destination.error(err);
            this.unsubscribe();
        };
        Subscriber.prototype._complete = function () {
            this.destination.complete();
            this.unsubscribe();
        };
        Subscriber.prototype._unsubscribeAndRecycle = function () {
            var _parentOrParents = this._parentOrParents;
            this._parentOrParents = null;
            this.unsubscribe();
            this.closed = false;
            this.isStopped = false;
            this._parentOrParents = _parentOrParents;
            return this;
        };
        return Subscriber;
    }(Subscription));
    var SafeSubscriber = /** @class */ (function (_super) {
        __extends(SafeSubscriber, _super);
        function SafeSubscriber(_parentSubscriber, observerOrNext, error, complete) {
            var _this = _super.call(this) || this;
            _this._parentSubscriber = _parentSubscriber;
            var next;
            var context = _this;
            if (isFunction(observerOrNext)) {
                next = observerOrNext;
            }
            else if (observerOrNext) {
                next = observerOrNext.next;
                error = observerOrNext.error;
                complete = observerOrNext.complete;
                if (observerOrNext !== empty) {
                    context = Object.create(observerOrNext);
                    if (isFunction(context.unsubscribe)) {
                        _this.add(context.unsubscribe.bind(context));
                    }
                    context.unsubscribe = _this.unsubscribe.bind(_this);
                }
            }
            _this._context = context;
            _this._next = next;
            _this._error = error;
            _this._complete = complete;
            return _this;
        }
        SafeSubscriber.prototype.next = function (value) {
            if (!this.isStopped && this._next) {
                var _parentSubscriber = this._parentSubscriber;
                if (!config.useDeprecatedSynchronousErrorHandling || !_parentSubscriber.syncErrorThrowable) {
                    this.__tryOrUnsub(this._next, value);
                }
                else if (this.__tryOrSetError(_parentSubscriber, this._next, value)) {
                    this.unsubscribe();
                }
            }
        };
        SafeSubscriber.prototype.error = function (err) {
            if (!this.isStopped) {
                var _parentSubscriber = this._parentSubscriber;
                var useDeprecatedSynchronousErrorHandling = config.useDeprecatedSynchronousErrorHandling;
                if (this._error) {
                    if (!useDeprecatedSynchronousErrorHandling || !_parentSubscriber.syncErrorThrowable) {
                        this.__tryOrUnsub(this._error, err);
                        this.unsubscribe();
                    }
                    else {
                        this.__tryOrSetError(_parentSubscriber, this._error, err);
                        this.unsubscribe();
                    }
                }
                else if (!_parentSubscriber.syncErrorThrowable) {
                    this.unsubscribe();
                    if (useDeprecatedSynchronousErrorHandling) {
                        throw err;
                    }
                    hostReportError(err);
                }
                else {
                    if (useDeprecatedSynchronousErrorHandling) {
                        _parentSubscriber.syncErrorValue = err;
                        _parentSubscriber.syncErrorThrown = true;
                    }
                    else {
                        hostReportError(err);
                    }
                    this.unsubscribe();
                }
            }
        };
        SafeSubscriber.prototype.complete = function () {
            var _this = this;
            if (!this.isStopped) {
                var _parentSubscriber = this._parentSubscriber;
                if (this._complete) {
                    var wrappedComplete = function () { return _this._complete.call(_this._context); };
                    if (!config.useDeprecatedSynchronousErrorHandling || !_parentSubscriber.syncErrorThrowable) {
                        this.__tryOrUnsub(wrappedComplete);
                        this.unsubscribe();
                    }
                    else {
                        this.__tryOrSetError(_parentSubscriber, wrappedComplete);
                        this.unsubscribe();
                    }
                }
                else {
                    this.unsubscribe();
                }
            }
        };
        SafeSubscriber.prototype.__tryOrUnsub = function (fn, value) {
            try {
                fn.call(this._context, value);
            }
            catch (err) {
                this.unsubscribe();
                if (config.useDeprecatedSynchronousErrorHandling) {
                    throw err;
                }
                else {
                    hostReportError(err);
                }
            }
        };
        SafeSubscriber.prototype.__tryOrSetError = function (parent, fn, value) {
            if (!config.useDeprecatedSynchronousErrorHandling) {
                throw new Error('bad call');
            }
            try {
                fn.call(this._context, value);
            }
            catch (err) {
                if (config.useDeprecatedSynchronousErrorHandling) {
                    parent.syncErrorValue = err;
                    parent.syncErrorThrown = true;
                    return true;
                }
                else {
                    hostReportError(err);
                    return true;
                }
            }
            return false;
        };
        SafeSubscriber.prototype._unsubscribe = function () {
            var _parentSubscriber = this._parentSubscriber;
            this._context = null;
            this._parentSubscriber = null;
            _parentSubscriber.unsubscribe();
        };
        return SafeSubscriber;
    }(Subscriber));
    function canReportError(observer) {
        while (observer) {
            var closed_1 = observer.closed, destination = observer.destination, isStopped = observer.isStopped;
            if (closed_1 || isStopped) {
                return false;
            }
            else if (destination && destination instanceof Subscriber) {
                observer = destination;
            }
            else {
                observer = null;
            }
        }
        return true;
    }
    function toSubscriber(nextOrObserver, error, complete) {
        if (nextOrObserver) {
            if (nextOrObserver instanceof Subscriber) {
                return nextOrObserver;
            }
            if (nextOrObserver[rxSubscriber]) {
                return nextOrObserver[rxSubscriber]();
            }
        }
        if (!nextOrObserver && !error && !complete) {
            return new Subscriber(empty);
        }
        return new Subscriber(nextOrObserver, error, complete);
    }
    var observable = (function () { return typeof Symbol === 'function' && Symbol.observable || '@@observable'; })();
    function noop() { }
    function pipe() {
        var fns = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            fns[_i] = arguments[_i];
        }
        return pipeFromArray(fns);
    }
    function pipeFromArray(fns) {
        if (!fns) {
            return noop;
        }
        if (fns.length === 1) {
            return fns[0];
        }
        return function piped(input) {
            return fns.reduce(function (prev, fn) { return fn(prev); }, input);
        };
    }
    var Observable = /** @class */ (function () {
        function Observable(subscribe) {
            this._isScalar = false;
            if (subscribe) {
                this._subscribe = subscribe;
            }
        }
        Observable.prototype.lift = function (operator) {
            var observable = new Observable();
            observable.source = this;
            observable.operator = operator;
            return observable;
        };
        Observable.prototype.subscribe = function (observerOrNext, error, complete) {
            var operator = this.operator;
            var sink = toSubscriber(observerOrNext, error, complete);
            if (operator) {
                sink.add(operator.call(sink, this.source));
            }
            else {
                sink.add(this.source || (config.useDeprecatedSynchronousErrorHandling && !sink.syncErrorThrowable) ?
                    this._subscribe(sink) :
                    this._trySubscribe(sink));
            }
            if (config.useDeprecatedSynchronousErrorHandling) {
                if (sink.syncErrorThrowable) {
                    sink.syncErrorThrowable = false;
                    if (sink.syncErrorThrown) {
                        throw sink.syncErrorValue;
                    }
                }
            }
            return sink;
        };
        Observable.prototype._trySubscribe = function (sink) {
            try {
                return this._subscribe(sink);
            }
            catch (err) {
                if (config.useDeprecatedSynchronousErrorHandling) {
                    sink.syncErrorThrown = true;
                    sink.syncErrorValue = err;
                }
                if (canReportError(sink)) {
                    sink.error(err);
                }
                else {
                    console.warn(err);
                }
            }
        };
        Observable.prototype.forEach = function (next, promiseCtor) {
            var _this = this;
            promiseCtor = getPromiseCtor(promiseCtor);
            return new promiseCtor(function (resolve, reject) {
                var subscription;
                subscription = _this.subscribe(function (value) {
                    try {
                        next(value);
                    }
                    catch (err) {
                        reject(err);
                        if (subscription) {
                            subscription.unsubscribe();
                        }
                    }
                }, reject, resolve);
            });
        };
        Observable.prototype._subscribe = function (subscriber) {
            var source = this.source;
            return source && source.subscribe(subscriber);
        };
        Observable.prototype[observable] = function () {
            return this;
        };
        Observable.prototype.pipe = function () {
            var operations = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                operations[_i] = arguments[_i];
            }
            if (operations.length === 0) {
                return this;
            }
            return pipeFromArray(operations)(this);
        };
        Observable.prototype.toPromise = function (promiseCtor) {
            var _this = this;
            promiseCtor = getPromiseCtor(promiseCtor);
            return new promiseCtor(function (resolve, reject) {
                var value;
                _this.subscribe(function (x) { return value = x; }, function (err) { return reject(err); }, function () { return resolve(value); });
            });
        };
        return Observable;
    }());
    Observable.create = function (subscribe) {
        return new Observable(subscribe);
    };
    function getPromiseCtor(promiseCtor) {
        if (!promiseCtor) {
            promiseCtor = Promise;
        }
        if (!promiseCtor) {
            throw new Error('no Promise impl found');
        }
        return promiseCtor;
    }
    var ObjectUnsubscribedErrorImpl = (function () {
        function ObjectUnsubscribedErrorImpl() {
            Error.call(this);
            this.message = 'object unsubscribed';
            this.name = 'ObjectUnsubscribedError';
            return this;
        }
        ObjectUnsubscribedErrorImpl.prototype = Object.create(Error.prototype);
        return ObjectUnsubscribedErrorImpl;
    })();
    var ObjectUnsubscribedError = ObjectUnsubscribedErrorImpl;
    var SubjectSubscription = /** @class */ (function (_super) {
        __extends(SubjectSubscription, _super);
        function SubjectSubscription(subject, subscriber) {
            var _this = _super.call(this) || this;
            _this.subject = subject;
            _this.subscriber = subscriber;
            _this.closed = false;
            return _this;
        }
        SubjectSubscription.prototype.unsubscribe = function () {
            if (this.closed) {
                return;
            }
            this.closed = true;
            var subject = this.subject;
            var observers = subject.observers;
            this.subject = null;
            if (!observers || observers.length === 0 || subject.isStopped || subject.closed) {
                return;
            }
            var subscriberIndex = observers.indexOf(this.subscriber);
            if (subscriberIndex !== -1) {
                observers.splice(subscriberIndex, 1);
            }
        };
        return SubjectSubscription;
    }(Subscription));
    var SubjectSubscriber = /** @class */ (function (_super) {
        __extends(SubjectSubscriber, _super);
        function SubjectSubscriber(destination) {
            var _this = _super.call(this, destination) || this;
            _this.destination = destination;
            return _this;
        }
        return SubjectSubscriber;
    }(Subscriber));
    var Subject = /** @class */ (function (_super) {
        __extends(Subject, _super);
        function Subject() {
            var _this = _super.call(this) || this;
            _this.observers = [];
            _this.closed = false;
            _this.isStopped = false;
            _this.hasError = false;
            _this.thrownError = null;
            return _this;
        }
        Subject.prototype[rxSubscriber] = function () {
            return new SubjectSubscriber(this);
        };
        Subject.prototype.lift = function (operator) {
            var subject = new AnonymousSubject(this, this);
            subject.operator = operator;
            return subject;
        };
        Subject.prototype.next = function (value) {
            if (this.closed) {
                throw new ObjectUnsubscribedError();
            }
            if (!this.isStopped) {
                var observers = this.observers;
                var len = observers.length;
                var copy = observers.slice();
                for (var i_1 = 0; i_1 < len; i_1++) {
                    copy[i_1].next(value);
                }
            }
        };
        Subject.prototype.error = function (err) {
            if (this.closed) {
                throw new ObjectUnsubscribedError();
            }
            this.hasError = true;
            this.thrownError = err;
            this.isStopped = true;
            var observers = this.observers;
            var len = observers.length;
            var copy = observers.slice();
            for (var i_2 = 0; i_2 < len; i_2++) {
                copy[i_2].error(err);
            }
            this.observers.length = 0;
        };
        Subject.prototype.complete = function () {
            if (this.closed) {
                throw new ObjectUnsubscribedError();
            }
            this.isStopped = true;
            var observers = this.observers;
            var len = observers.length;
            var copy = observers.slice();
            for (var i_3 = 0; i_3 < len; i_3++) {
                copy[i_3].complete();
            }
            this.observers.length = 0;
        };
        Subject.prototype.unsubscribe = function () {
            this.isStopped = true;
            this.closed = true;
            this.observers = null;
        };
        Subject.prototype._trySubscribe = function (subscriber) {
            if (this.closed) {
                throw new ObjectUnsubscribedError();
            }
            else {
                return _super.prototype._trySubscribe.call(this, subscriber);
            }
        };
        Subject.prototype._subscribe = function (subscriber) {
            if (this.closed) {
                throw new ObjectUnsubscribedError();
            }
            else if (this.hasError) {
                subscriber.error(this.thrownError);
                return Subscription.EMPTY;
            }
            else if (this.isStopped) {
                subscriber.complete();
                return Subscription.EMPTY;
            }
            else {
                this.observers.push(subscriber);
                return new SubjectSubscription(this, subscriber);
            }
        };
        Subject.prototype.asObservable = function () {
            var observable = new Observable();
            observable.source = this;
            return observable;
        };
        return Subject;
    }(Observable));
    Subject.create = function (destination, source) {
        return new AnonymousSubject(destination, source);
    };
    var AnonymousSubject = /** @class */ (function (_super) {
        __extends(AnonymousSubject, _super);
        function AnonymousSubject(destination, source) {
            var _this = _super.call(this) || this;
            _this.destination = destination;
            _this.source = source;
            return _this;
        }
        AnonymousSubject.prototype.next = function (value) {
            var destination = this.destination;
            if (destination && destination.next) {
                destination.next(value);
            }
        };
        AnonymousSubject.prototype.error = function (err) {
            var destination = this.destination;
            if (destination && destination.error) {
                this.destination.error(err);
            }
        };
        AnonymousSubject.prototype.complete = function () {
            var destination = this.destination;
            if (destination && destination.complete) {
                this.destination.complete();
            }
        };
        AnonymousSubject.prototype._subscribe = function (subscriber) {
            var source = this.source;
            if (source) {
                return this.source.subscribe(subscriber);
            }
            else {
                return Subscription.EMPTY;
            }
        };
        return AnonymousSubject;
    }(Subject));
    function refCount() {
        return function refCountOperatorFunction(source) {
            return source.lift(new RefCountOperator(source));
        };
    }
    var RefCountOperator = /** @class */ (function () {
        function RefCountOperator(connectable) {
            this.connectable = connectable;
        }
        RefCountOperator.prototype.call = function (subscriber, source) {
            var connectable = this.connectable;
            connectable._refCount++;
            var refCounter = new RefCountSubscriber(subscriber, connectable);
            var subscription = source.subscribe(refCounter);
            if (!refCounter.closed) {
                refCounter.connection = connectable.connect();
            }
            return subscription;
        };
        return RefCountOperator;
    }());
    var RefCountSubscriber = /** @class */ (function (_super) {
        __extends(RefCountSubscriber, _super);
        function RefCountSubscriber(destination, connectable) {
            var _this = _super.call(this, destination) || this;
            _this.connectable = connectable;
            return _this;
        }
        RefCountSubscriber.prototype._unsubscribe = function () {
            var connectable = this.connectable;
            if (!connectable) {
                this.connection = null;
                return;
            }
            this.connectable = null;
            var refCount = connectable._refCount;
            if (refCount <= 0) {
                this.connection = null;
                return;
            }
            connectable._refCount = refCount - 1;
            if (refCount > 1) {
                this.connection = null;
                return;
            }
            var connection = this.connection;
            var sharedConnection = connectable._connection;
            this.connection = null;
            if (sharedConnection && (!connection || sharedConnection === connection)) {
                sharedConnection.unsubscribe();
            }
        };
        return RefCountSubscriber;
    }(Subscriber));
    var ConnectableObservable = /** @class */ (function (_super) {
        __extends(ConnectableObservable, _super);
        function ConnectableObservable(source, subjectFactory) {
            var _this = _super.call(this) || this;
            _this.source = source;
            _this.subjectFactory = subjectFactory;
            _this._refCount = 0;
            _this._isComplete = false;
            return _this;
        }
        ConnectableObservable.prototype._subscribe = function (subscriber) {
            return this.getSubject().subscribe(subscriber);
        };
        ConnectableObservable.prototype.getSubject = function () {
            var subject = this._subject;
            if (!subject || subject.isStopped) {
                this._subject = this.subjectFactory();
            }
            return this._subject;
        };
        ConnectableObservable.prototype.connect = function () {
            var connection = this._connection;
            if (!connection) {
                this._isComplete = false;
                connection = this._connection = new Subscription();
                connection.add(this.source
                    .subscribe(new ConnectableSubscriber(this.getSubject(), this)));
                if (connection.closed) {
                    this._connection = null;
                    connection = Subscription.EMPTY;
                }
            }
            return connection;
        };
        ConnectableObservable.prototype.refCount = function () {
            return refCount()(this);
        };
        return ConnectableObservable;
    }(Observable));
    var connectableObservableDescriptor = (function () {
        var connectableProto = ConnectableObservable.prototype;
        return {
            operator: { value: null },
            _refCount: { value: 0, writable: true },
            _subject: { value: null, writable: true },
            _connection: { value: null, writable: true },
            _subscribe: { value: connectableProto._subscribe },
            _isComplete: { value: connectableProto._isComplete, writable: true },
            getSubject: { value: connectableProto.getSubject },
            connect: { value: connectableProto.connect },
            refCount: { value: connectableProto.refCount }
        };
    })();
    var ConnectableSubscriber = /** @class */ (function (_super) {
        __extends(ConnectableSubscriber, _super);
        function ConnectableSubscriber(destination, connectable) {
            var _this = _super.call(this, destination) || this;
            _this.connectable = connectable;
            return _this;
        }
        ConnectableSubscriber.prototype._error = function (err) {
            this._unsubscribe();
            _super.prototype._error.call(this, err);
        };
        ConnectableSubscriber.prototype._complete = function () {
            this.connectable._isComplete = true;
            this._unsubscribe();
            _super.prototype._complete.call(this);
        };
        ConnectableSubscriber.prototype._unsubscribe = function () {
            var connectable = this.connectable;
            if (connectable) {
                this.connectable = null;
                var connection = connectable._connection;
                connectable._refCount = 0;
                connectable._subject = null;
                connectable._connection = null;
                if (connection) {
                    connection.unsubscribe();
                }
            }
        };
        return ConnectableSubscriber;
    }(SubjectSubscriber));
    var BehaviorSubject = /** @class */ (function (_super) {
        __extends(BehaviorSubject, _super);
        function BehaviorSubject(_value) {
            var _this = _super.call(this) || this;
            _this._value = _value;
            return _this;
        }
        Object.defineProperty(BehaviorSubject.prototype, "value", {
            get: function () {
                return this.getValue();
            },
            enumerable: true,
            configurable: true
        });
        BehaviorSubject.prototype._subscribe = function (subscriber) {
            var subscription = _super.prototype._subscribe.call(this, subscriber);
            if (subscription && !subscription.closed) {
                subscriber.next(this._value);
            }
            return subscription;
        };
        BehaviorSubject.prototype.getValue = function () {
            if (this.hasError) {
                throw this.thrownError;
            }
            else if (this.closed) {
                throw new ObjectUnsubscribedError();
            }
            else {
                return this._value;
            }
        };
        BehaviorSubject.prototype.next = function (value) {
            _super.prototype.next.call(this, this._value = value);
        };
        return BehaviorSubject;
    }(Subject));
    var Action = /** @class */ (function (_super) {
        __extends(Action, _super);
        function Action(scheduler, work) {
            return _super.call(this) || this;
        }
        Action.prototype.schedule = function (state, delay) {
            if (delay === void 0) { delay = 0; }
            return this;
        };
        return Action;
    }(Subscription));
    var AsyncAction = /** @class */ (function (_super) {
        __extends(AsyncAction, _super);
        function AsyncAction(scheduler, work) {
            var _this = _super.call(this, scheduler, work) || this;
            _this.scheduler = scheduler;
            _this.work = work;
            _this.pending = false;
            return _this;
        }
        AsyncAction.prototype.schedule = function (state, delay) {
            if (delay === void 0) { delay = 0; }
            if (this.closed) {
                return this;
            }
            this.state = state;
            var id = this.id;
            var scheduler = this.scheduler;
            if (id != null) {
                this.id = this.recycleAsyncId(scheduler, id, delay);
            }
            this.pending = true;
            this.delay = delay;
            this.id = this.id || this.requestAsyncId(scheduler, this.id, delay);
            return this;
        };
        AsyncAction.prototype.requestAsyncId = function (scheduler, id, delay) {
            if (delay === void 0) { delay = 0; }
            return setInterval(scheduler.flush.bind(scheduler, this), delay);
        };
        AsyncAction.prototype.recycleAsyncId = function (scheduler, id, delay) {
            if (delay === void 0) { delay = 0; }
            if (delay !== null && this.delay === delay && this.pending === false) {
                return id;
            }
            clearInterval(id);
            return undefined;
        };
        AsyncAction.prototype.execute = function (state, delay) {
            if (this.closed) {
                return new Error('executing a cancelled action');
            }
            this.pending = false;
            var error = this._execute(state, delay);
            if (error) {
                return error;
            }
            else if (this.pending === false && this.id != null) {
                this.id = this.recycleAsyncId(this.scheduler, this.id, null);
            }
        };
        AsyncAction.prototype._execute = function (state, delay) {
            var errored = false;
            var errorValue = undefined;
            try {
                this.work(state);
            }
            catch (e) {
                errored = true;
                errorValue = !!e && e || new Error(e);
            }
            if (errored) {
                this.unsubscribe();
                return errorValue;
            }
        };
        AsyncAction.prototype._unsubscribe = function () {
            var id = this.id;
            var scheduler = this.scheduler;
            var actions = scheduler.actions;
            var index = actions.indexOf(this);
            this.work = null;
            this.state = null;
            this.pending = false;
            this.scheduler = null;
            if (index !== -1) {
                actions.splice(index, 1);
            }
            if (id != null) {
                this.id = this.recycleAsyncId(scheduler, id, null);
            }
            this.delay = null;
        };
        return AsyncAction;
    }(Action));
    var QueueAction = /** @class */ (function (_super) {
        __extends(QueueAction, _super);
        function QueueAction(scheduler, work) {
            var _this = _super.call(this, scheduler, work) || this;
            _this.scheduler = scheduler;
            _this.work = work;
            return _this;
        }
        QueueAction.prototype.schedule = function (state, delay) {
            if (delay === void 0) { delay = 0; }
            if (delay > 0) {
                return _super.prototype.schedule.call(this, state, delay);
            }
            this.delay = delay;
            this.state = state;
            this.scheduler.flush(this);
            return this;
        };
        QueueAction.prototype.execute = function (state, delay) {
            return (delay > 0 || this.closed) ?
                _super.prototype.execute.call(this, state, delay) :
                this._execute(state, delay);
        };
        QueueAction.prototype.requestAsyncId = function (scheduler, id, delay) {
            if (delay === void 0) { delay = 0; }
            if ((delay !== null && delay > 0) || (delay === null && this.delay > 0)) {
                return _super.prototype.requestAsyncId.call(this, scheduler, id, delay);
            }
            return scheduler.flush(this);
        };
        return QueueAction;
    }(AsyncAction));
    var Scheduler = /** @class */ (function () {
        function Scheduler(SchedulerAction, now) {
            if (now === void 0) { now = Scheduler.now; }
            this.SchedulerAction = SchedulerAction;
            this.now = now;
        }
        Scheduler.prototype.schedule = function (work, delay, state) {
            if (delay === void 0) { delay = 0; }
            return new this.SchedulerAction(this, work).schedule(state, delay);
        };
        return Scheduler;
    }());
    Scheduler.now = function () { return Date.now(); };
    var AsyncScheduler = /** @class */ (function (_super) {
        __extends(AsyncScheduler, _super);
        function AsyncScheduler(SchedulerAction, now) {
            if (now === void 0) { now = Scheduler.now; }
            var _this = _super.call(this, SchedulerAction, function () {
                if (AsyncScheduler.delegate && AsyncScheduler.delegate !== _this) {
                    return AsyncScheduler.delegate.now();
                }
                else {
                    return now();
                }
            }) || this;
            _this.actions = [];
            _this.active = false;
            _this.scheduled = undefined;
            return _this;
        }
        AsyncScheduler.prototype.schedule = function (work, delay, state) {
            if (delay === void 0) { delay = 0; }
            if (AsyncScheduler.delegate && AsyncScheduler.delegate !== this) {
                return AsyncScheduler.delegate.schedule(work, delay, state);
            }
            else {
                return _super.prototype.schedule.call(this, work, delay, state);
            }
        };
        AsyncScheduler.prototype.flush = function (action) {
            var actions = this.actions;
            if (this.active) {
                actions.push(action);
                return;
            }
            var error;
            this.active = true;
            do {
                if (error = action.execute(action.state, action.delay)) {
                    break;
                }
            } while (action = actions.shift());
            this.active = false;
            if (error) {
                while (action = actions.shift()) {
                    action.unsubscribe();
                }
                throw error;
            }
        };
        return AsyncScheduler;
    }(Scheduler));
    var QueueScheduler = /** @class */ (function (_super) {
        __extends(QueueScheduler, _super);
        function QueueScheduler() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return QueueScheduler;
    }(AsyncScheduler));
    var queue = new QueueScheduler(QueueAction);
    var EMPTY = new Observable(function (subscriber) { return subscriber.complete(); });
    function empty$1(scheduler) {
        return scheduler ? emptyScheduled(scheduler) : EMPTY;
    }
    function emptyScheduled(scheduler) {
        return new Observable(function (subscriber) { return scheduler.schedule(function () { return subscriber.complete(); }); });
    }
    function isScheduler(value) {
        return value && typeof value.schedule === 'function';
    }
    var subscribeToArray = function (array) { return function (subscriber) {
        for (var i_4 = 0, len = array.length; i_4 < len && !subscriber.closed; i_4++) {
            subscriber.next(array[i_4]);
        }
        subscriber.complete();
    }; };
    function scheduleArray(input, scheduler) {
        return new Observable(function (subscriber) {
            var sub = new Subscription();
            var i = 0;
            sub.add(scheduler.schedule(function () {
                if (i === input.length) {
                    subscriber.complete();
                    return;
                }
                subscriber.next(input[i++]);
                if (!subscriber.closed) {
                    sub.add(this.schedule());
                }
            }));
            return sub;
        });
    }
    function fromArray(input, scheduler) {
        if (!scheduler) {
            return new Observable(subscribeToArray(input));
        }
        else {
            return scheduleArray(input, scheduler);
        }
    }
    function of() {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var scheduler = args[args.length - 1];
        if (isScheduler(scheduler)) {
            args.pop();
            return scheduleArray(args, scheduler);
        }
        else {
            return fromArray(args);
        }
    }
    function throwError(error, scheduler) {
        if (!scheduler) {
            return new Observable(function (subscriber) { return subscriber.error(error); });
        }
        else {
            return new Observable(function (subscriber) { return scheduler.schedule(dispatch, 0, { error: error, subscriber: subscriber }); });
        }
    }
    function dispatch(_b) {
        var error = _b.error, subscriber = _b.subscriber;
        subscriber.error(error);
    }
    var NotificationKind;
    (function (NotificationKind) {
        NotificationKind["NEXT"] = "N";
        NotificationKind["ERROR"] = "E";
        NotificationKind["COMPLETE"] = "C";
    })(NotificationKind || (NotificationKind = {}));
    var Notification = /** @class */ (function () {
        function Notification(kind, value, error) {
            this.kind = kind;
            this.value = value;
            this.error = error;
            this.hasValue = kind === 'N';
        }
        Notification.prototype.observe = function (observer) {
            switch (this.kind) {
                case 'N':
                    return observer.next && observer.next(this.value);
                case 'E':
                    return observer.error && observer.error(this.error);
                case 'C':
                    return observer.complete && observer.complete();
            }
        };
        Notification.prototype.do = function (next, error, complete) {
            var kind = this.kind;
            switch (kind) {
                case 'N':
                    return next && next(this.value);
                case 'E':
                    return error && error(this.error);
                case 'C':
                    return complete && complete();
            }
        };
        Notification.prototype.accept = function (nextOrObserver, error, complete) {
            if (nextOrObserver && typeof nextOrObserver.next === 'function') {
                return this.observe(nextOrObserver);
            }
            else {
                return this.do(nextOrObserver, error, complete);
            }
        };
        Notification.prototype.toObservable = function () {
            var kind = this.kind;
            switch (kind) {
                case 'N':
                    return of(this.value);
                case 'E':
                    return throwError(this.error);
                case 'C':
                    return empty$1();
            }
            throw new Error('unexpected notification kind value');
        };
        Notification.createNext = function (value) {
            if (typeof value !== 'undefined') {
                return new Notification('N', value);
            }
            return Notification.undefinedValueNotification;
        };
        Notification.createError = function (err) {
            return new Notification('E', undefined, err);
        };
        Notification.createComplete = function () {
            return Notification.completeNotification;
        };
        return Notification;
    }());
    Notification.completeNotification = new Notification('C');
    Notification.undefinedValueNotification = new Notification('N', undefined);
    function observeOn(scheduler, delay) {
        if (delay === void 0) { delay = 0; }
        return function observeOnOperatorFunction(source) {
            return source.lift(new ObserveOnOperator(scheduler, delay));
        };
    }
    var ObserveOnOperator = /** @class */ (function () {
        function ObserveOnOperator(scheduler, delay) {
            if (delay === void 0) { delay = 0; }
            this.scheduler = scheduler;
            this.delay = delay;
        }
        ObserveOnOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new ObserveOnSubscriber(subscriber, this.scheduler, this.delay));
        };
        return ObserveOnOperator;
    }());
    var ObserveOnSubscriber = /** @class */ (function (_super) {
        __extends(ObserveOnSubscriber, _super);
        function ObserveOnSubscriber(destination, scheduler, delay) {
            if (delay === void 0) { delay = 0; }
            var _this = _super.call(this, destination) || this;
            _this.scheduler = scheduler;
            _this.delay = delay;
            return _this;
        }
        ObserveOnSubscriber.dispatch = function (arg) {
            var notification = arg.notification, destination = arg.destination;
            notification.observe(destination);
            this.unsubscribe();
        };
        ObserveOnSubscriber.prototype.scheduleMessage = function (notification) {
            var destination = this.destination;
            destination.add(this.scheduler.schedule(ObserveOnSubscriber.dispatch, this.delay, new ObserveOnMessage(notification, this.destination)));
        };
        ObserveOnSubscriber.prototype._next = function (value) {
            this.scheduleMessage(Notification.createNext(value));
        };
        ObserveOnSubscriber.prototype._error = function (err) {
            this.scheduleMessage(Notification.createError(err));
            this.unsubscribe();
        };
        ObserveOnSubscriber.prototype._complete = function () {
            this.scheduleMessage(Notification.createComplete());
            this.unsubscribe();
        };
        return ObserveOnSubscriber;
    }(Subscriber));
    var ObserveOnMessage = /** @class */ (function () {
        function ObserveOnMessage(notification, destination) {
            this.notification = notification;
            this.destination = destination;
        }
        return ObserveOnMessage;
    }());
    var ReplaySubject = /** @class */ (function (_super) {
        __extends(ReplaySubject, _super);
        function ReplaySubject(bufferSize, windowTime, scheduler) {
            if (bufferSize === void 0) { bufferSize = Number.POSITIVE_INFINITY; }
            if (windowTime === void 0) { windowTime = Number.POSITIVE_INFINITY; }
            var _this = _super.call(this) || this;
            _this.scheduler = scheduler;
            _this._events = [];
            _this._infiniteTimeWindow = false;
            _this._bufferSize = bufferSize < 1 ? 1 : bufferSize;
            _this._windowTime = windowTime < 1 ? 1 : windowTime;
            if (windowTime === Number.POSITIVE_INFINITY) {
                _this._infiniteTimeWindow = true;
                _this.next = _this.nextInfiniteTimeWindow;
            }
            else {
                _this.next = _this.nextTimeWindow;
            }
            return _this;
        }
        ReplaySubject.prototype.nextInfiniteTimeWindow = function (value) {
            var _events = this._events;
            _events.push(value);
            if (_events.length > this._bufferSize) {
                _events.shift();
            }
            _super.prototype.next.call(this, value);
        };
        ReplaySubject.prototype.nextTimeWindow = function (value) {
            this._events.push(new ReplayEvent(this._getNow(), value));
            this._trimBufferThenGetEvents();
            _super.prototype.next.call(this, value);
        };
        ReplaySubject.prototype._subscribe = function (subscriber) {
            var _infiniteTimeWindow = this._infiniteTimeWindow;
            var _events = _infiniteTimeWindow ? this._events : this._trimBufferThenGetEvents();
            var scheduler = this.scheduler;
            var len = _events.length;
            var subscription;
            if (this.closed) {
                throw new ObjectUnsubscribedError();
            }
            else if (this.isStopped || this.hasError) {
                subscription = Subscription.EMPTY;
            }
            else {
                this.observers.push(subscriber);
                subscription = new SubjectSubscription(this, subscriber);
            }
            if (scheduler) {
                subscriber.add(subscriber = new ObserveOnSubscriber(subscriber, scheduler));
            }
            if (_infiniteTimeWindow) {
                for (var i_5 = 0; i_5 < len && !subscriber.closed; i_5++) {
                    subscriber.next(_events[i_5]);
                }
            }
            else {
                for (var i_6 = 0; i_6 < len && !subscriber.closed; i_6++) {
                    subscriber.next(_events[i_6].value);
                }
            }
            if (this.hasError) {
                subscriber.error(this.thrownError);
            }
            else if (this.isStopped) {
                subscriber.complete();
            }
            return subscription;
        };
        ReplaySubject.prototype._getNow = function () {
            return (this.scheduler || queue).now();
        };
        ReplaySubject.prototype._trimBufferThenGetEvents = function () {
            var now = this._getNow();
            var _bufferSize = this._bufferSize;
            var _windowTime = this._windowTime;
            var _events = this._events;
            var eventsCount = _events.length;
            var spliceCount = 0;
            while (spliceCount < eventsCount) {
                if ((now - _events[spliceCount].time) < _windowTime) {
                    break;
                }
                spliceCount++;
            }
            if (eventsCount > _bufferSize) {
                spliceCount = Math.max(spliceCount, eventsCount - _bufferSize);
            }
            if (spliceCount > 0) {
                _events.splice(0, spliceCount);
            }
            return _events;
        };
        return ReplaySubject;
    }(Subject));
    var ReplayEvent = /** @class */ (function () {
        function ReplayEvent(time, value) {
            this.time = time;
            this.value = value;
        }
        return ReplayEvent;
    }());
    var nextHandle = 1;
    var RESOLVED = (function () { return Promise.resolve(); })();
    var activeHandles = {};
    function findAndClearHandle(handle) {
        if (handle in activeHandles) {
            delete activeHandles[handle];
            return true;
        }
        return false;
    }
    var Immediate = {
        setImmediate: function (cb) {
            var handle = nextHandle++;
            activeHandles[handle] = true;
            RESOLVED.then(function () { return findAndClearHandle(handle) && cb(); });
            return handle;
        },
        clearImmediate: function (handle) {
            findAndClearHandle(handle);
        },
    };
    var AsapAction = /** @class */ (function (_super) {
        __extends(AsapAction, _super);
        function AsapAction(scheduler, work) {
            var _this = _super.call(this, scheduler, work) || this;
            _this.scheduler = scheduler;
            _this.work = work;
            return _this;
        }
        AsapAction.prototype.requestAsyncId = function (scheduler, id, delay) {
            if (delay === void 0) { delay = 0; }
            if (delay !== null && delay > 0) {
                return _super.prototype.requestAsyncId.call(this, scheduler, id, delay);
            }
            scheduler.actions.push(this);
            return scheduler.scheduled || (scheduler.scheduled = Immediate.setImmediate(scheduler.flush.bind(scheduler, null)));
        };
        AsapAction.prototype.recycleAsyncId = function (scheduler, id, delay) {
            if (delay === void 0) { delay = 0; }
            if ((delay !== null && delay > 0) || (delay === null && this.delay > 0)) {
                return _super.prototype.recycleAsyncId.call(this, scheduler, id, delay);
            }
            if (scheduler.actions.length === 0) {
                Immediate.clearImmediate(id);
                scheduler.scheduled = undefined;
            }
            return undefined;
        };
        return AsapAction;
    }(AsyncAction));
    var AsapScheduler = /** @class */ (function (_super) {
        __extends(AsapScheduler, _super);
        function AsapScheduler() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AsapScheduler.prototype.flush = function (action) {
            this.active = true;
            this.scheduled = undefined;
            var actions = this.actions;
            var error;
            var index = -1;
            var count = actions.length;
            action = action || actions.shift();
            do {
                if (error = action.execute(action.state, action.delay)) {
                    break;
                }
            } while (++index < count && (action = actions.shift()));
            this.active = false;
            if (error) {
                while (++index < count && (action = actions.shift())) {
                    action.unsubscribe();
                }
                throw error;
            }
        };
        return AsapScheduler;
    }(AsyncScheduler));
    var asap = new AsapScheduler(AsapAction);
    var async = new AsyncScheduler(AsyncAction);
    var AnimationFrameAction = /** @class */ (function (_super) {
        __extends(AnimationFrameAction, _super);
        function AnimationFrameAction(scheduler, work) {
            var _this = _super.call(this, scheduler, work) || this;
            _this.scheduler = scheduler;
            _this.work = work;
            return _this;
        }
        AnimationFrameAction.prototype.requestAsyncId = function (scheduler, id, delay) {
            if (delay === void 0) { delay = 0; }
            if (delay !== null && delay > 0) {
                return _super.prototype.requestAsyncId.call(this, scheduler, id, delay);
            }
            scheduler.actions.push(this);
            return scheduler.scheduled || (scheduler.scheduled = requestAnimationFrame(function () { return scheduler.flush(null); }));
        };
        AnimationFrameAction.prototype.recycleAsyncId = function (scheduler, id, delay) {
            if (delay === void 0) { delay = 0; }
            if ((delay !== null && delay > 0) || (delay === null && this.delay > 0)) {
                return _super.prototype.recycleAsyncId.call(this, scheduler, id, delay);
            }
            if (scheduler.actions.length === 0) {
                cancelAnimationFrame(id);
                scheduler.scheduled = undefined;
            }
            return undefined;
        };
        return AnimationFrameAction;
    }(AsyncAction));
    var AnimationFrameScheduler = /** @class */ (function (_super) {
        __extends(AnimationFrameScheduler, _super);
        function AnimationFrameScheduler() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AnimationFrameScheduler.prototype.flush = function (action) {
            this.active = true;
            this.scheduled = undefined;
            var actions = this.actions;
            var error;
            var index = -1;
            var count = actions.length;
            action = action || actions.shift();
            do {
                if (error = action.execute(action.state, action.delay)) {
                    break;
                }
            } while (++index < count && (action = actions.shift()));
            this.active = false;
            if (error) {
                while (++index < count && (action = actions.shift())) {
                    action.unsubscribe();
                }
                throw error;
            }
        };
        return AnimationFrameScheduler;
    }(AsyncScheduler));
    var animationFrame = new AnimationFrameScheduler(AnimationFrameAction);
    function identity(x) {
        return x;
    }
    var ArgumentOutOfRangeErrorImpl = (function () {
        function ArgumentOutOfRangeErrorImpl() {
            Error.call(this);
            this.message = 'argument out of range';
            this.name = 'ArgumentOutOfRangeError';
            return this;
        }
        ArgumentOutOfRangeErrorImpl.prototype = Object.create(Error.prototype);
        return ArgumentOutOfRangeErrorImpl;
    })();
    var ArgumentOutOfRangeError = ArgumentOutOfRangeErrorImpl;
    var EmptyErrorImpl = (function () {
        function EmptyErrorImpl() {
            Error.call(this);
            this.message = 'no elements in sequence';
            this.name = 'EmptyError';
            return this;
        }
        EmptyErrorImpl.prototype = Object.create(Error.prototype);
        return EmptyErrorImpl;
    })();
    var EmptyError = EmptyErrorImpl;
    function map(project, thisArg) {
        return function mapOperation(source) {
            if (typeof project !== 'function') {
                throw new TypeError('argument is not a function. Are you looking for `mapTo()`?');
            }
            return source.lift(new MapOperator(project, thisArg));
        };
    }
    var MapOperator = /** @class */ (function () {
        function MapOperator(project, thisArg) {
            this.project = project;
            this.thisArg = thisArg;
        }
        MapOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new MapSubscriber(subscriber, this.project, this.thisArg));
        };
        return MapOperator;
    }());
    var MapSubscriber = /** @class */ (function (_super) {
        __extends(MapSubscriber, _super);
        function MapSubscriber(destination, project, thisArg) {
            var _this = _super.call(this, destination) || this;
            _this.project = project;
            _this.count = 0;
            _this.thisArg = thisArg || _this;
            return _this;
        }
        MapSubscriber.prototype._next = function (value) {
            var result;
            try {
                result = this.project.call(this.thisArg, value, this.count++);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            this.destination.next(result);
        };
        return MapSubscriber;
    }(Subscriber));
    var OuterSubscriber = /** @class */ (function (_super) {
        __extends(OuterSubscriber, _super);
        function OuterSubscriber() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        OuterSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            this.destination.next(innerValue);
        };
        OuterSubscriber.prototype.notifyError = function (error, innerSub) {
            this.destination.error(error);
        };
        OuterSubscriber.prototype.notifyComplete = function (innerSub) {
            this.destination.complete();
        };
        return OuterSubscriber;
    }(Subscriber));
    var InnerSubscriber = /** @class */ (function (_super) {
        __extends(InnerSubscriber, _super);
        function InnerSubscriber(parent, outerValue, outerIndex) {
            var _this = _super.call(this) || this;
            _this.parent = parent;
            _this.outerValue = outerValue;
            _this.outerIndex = outerIndex;
            _this.index = 0;
            return _this;
        }
        InnerSubscriber.prototype._next = function (value) {
            this.parent.notifyNext(this.outerValue, value, this.outerIndex, this.index++, this);
        };
        InnerSubscriber.prototype._error = function (error) {
            this.parent.notifyError(error, this);
            this.unsubscribe();
        };
        InnerSubscriber.prototype._complete = function () {
            this.parent.notifyComplete(this);
            this.unsubscribe();
        };
        return InnerSubscriber;
    }(Subscriber));
    var subscribeToPromise = function (promise) { return function (subscriber) {
        promise.then(function (value) {
            if (!subscriber.closed) {
                subscriber.next(value);
                subscriber.complete();
            }
        }, function (err) { return subscriber.error(err); })
            .then(null, hostReportError);
        return subscriber;
    }; };
    function getSymbolIterator() {
        if (typeof Symbol !== 'function' || !Symbol.iterator) {
            return '@@iterator';
        }
        return Symbol.iterator;
    }
    var iterator = getSymbolIterator();
    var subscribeToIterable = function (iterable) { return function (subscriber) {
        var iterator$1 = iterable[iterator]();
        do {
            var item = iterator$1.next();
            if (item.done) {
                subscriber.complete();
                break;
            }
            subscriber.next(item.value);
            if (subscriber.closed) {
                break;
            }
        } while (true);
        if (typeof iterator$1.return === 'function') {
            subscriber.add(function () {
                if (iterator$1.return) {
                    iterator$1.return();
                }
            });
        }
        return subscriber;
    }; };
    var subscribeToObservable = function (obj) { return function (subscriber) {
        var obs = obj[observable]();
        if (typeof obs.subscribe !== 'function') {
            throw new TypeError('Provided object does not correctly implement Symbol.observable');
        }
        else {
            return obs.subscribe(subscriber);
        }
    }; };
    var isArrayLike = (function (x) { return x && typeof x.length === 'number' && typeof x !== 'function'; });
    function isPromise(value) {
        return !!value && typeof value.subscribe !== 'function' && typeof value.then === 'function';
    }
    var subscribeTo = function (result) {
        if (!!result && typeof result[observable] === 'function') {
            return subscribeToObservable(result);
        }
        else if (isArrayLike(result)) {
            return subscribeToArray(result);
        }
        else if (isPromise(result)) {
            return subscribeToPromise(result);
        }
        else if (!!result && typeof result[iterator] === 'function') {
            return subscribeToIterable(result);
        }
        else {
            var value = isObject(result) ? 'an invalid object' : "'" + result + "'";
            var msg = "You provided " + value + " where a stream was expected."
                + ' You can provide an Observable, Promise, Array, or Iterable.';
            throw new TypeError(msg);
        }
    };
    function subscribeToResult(outerSubscriber, result, outerValue, outerIndex, innerSubscriber) {
        if (innerSubscriber === void 0) { innerSubscriber = new InnerSubscriber(outerSubscriber, outerValue, outerIndex); }
        if (innerSubscriber.closed) {
            return undefined;
        }
        if (result instanceof Observable) {
            return result.subscribe(innerSubscriber);
        }
        return subscribeTo(result)(innerSubscriber);
    }
    var NONE = {};
    function combineLatest() {
        var observables = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            observables[_i] = arguments[_i];
        }
        var resultSelector = null;
        var scheduler = null;
        if (isScheduler(observables[observables.length - 1])) {
            scheduler = observables.pop();
        }
        if (typeof observables[observables.length - 1] === 'function') {
            resultSelector = observables.pop();
        }
        if (observables.length === 1 && isArray(observables[0])) {
            observables = observables[0];
        }
        return fromArray(observables, scheduler).lift(new CombineLatestOperator(resultSelector));
    }
    var CombineLatestOperator = /** @class */ (function () {
        function CombineLatestOperator(resultSelector) {
            this.resultSelector = resultSelector;
        }
        CombineLatestOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new CombineLatestSubscriber(subscriber, this.resultSelector));
        };
        return CombineLatestOperator;
    }());
    var CombineLatestSubscriber = /** @class */ (function (_super) {
        __extends(CombineLatestSubscriber, _super);
        function CombineLatestSubscriber(destination, resultSelector) {
            var _this = _super.call(this, destination) || this;
            _this.resultSelector = resultSelector;
            _this.active = 0;
            _this.values = [];
            _this.observables = [];
            return _this;
        }
        CombineLatestSubscriber.prototype._next = function (observable) {
            this.values.push(NONE);
            this.observables.push(observable);
        };
        CombineLatestSubscriber.prototype._complete = function () {
            var observables = this.observables;
            var len = observables.length;
            if (len === 0) {
                this.destination.complete();
            }
            else {
                this.active = len;
                this.toRespond = len;
                for (var i_7 = 0; i_7 < len; i_7++) {
                    var observable_1 = observables[i_7];
                    this.add(subscribeToResult(this, observable_1, observable_1, i_7));
                }
            }
        };
        CombineLatestSubscriber.prototype.notifyComplete = function (unused) {
            if ((this.active -= 1) === 0) {
                this.destination.complete();
            }
        };
        CombineLatestSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            var values = this.values;
            var oldVal = values[outerIndex];
            var toRespond = !this.toRespond
                ? 0
                : oldVal === NONE ? --this.toRespond : this.toRespond;
            values[outerIndex] = innerValue;
            if (toRespond === 0) {
                if (this.resultSelector) {
                    this._tryResultSelector(values);
                }
                else {
                    this.destination.next(values.slice());
                }
            }
        };
        CombineLatestSubscriber.prototype._tryResultSelector = function (values) {
            var result;
            try {
                result = this.resultSelector.apply(this, values);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            this.destination.next(result);
        };
        return CombineLatestSubscriber;
    }(OuterSubscriber));
    function scheduleObservable(input, scheduler) {
        return new Observable(function (subscriber) {
            var sub = new Subscription();
            sub.add(scheduler.schedule(function () {
                var observable$1 = input[observable]();
                sub.add(observable$1.subscribe({
                    next: function (value) { sub.add(scheduler.schedule(function () { return subscriber.next(value); })); },
                    error: function (err) { sub.add(scheduler.schedule(function () { return subscriber.error(err); })); },
                    complete: function () { sub.add(scheduler.schedule(function () { return subscriber.complete(); })); },
                }));
            }));
            return sub;
        });
    }
    function schedulePromise(input, scheduler) {
        return new Observable(function (subscriber) {
            var sub = new Subscription();
            sub.add(scheduler.schedule(function () { return input.then(function (value) {
                sub.add(scheduler.schedule(function () {
                    subscriber.next(value);
                    sub.add(scheduler.schedule(function () { return subscriber.complete(); }));
                }));
            }, function (err) {
                sub.add(scheduler.schedule(function () { return subscriber.error(err); }));
            }); }));
            return sub;
        });
    }
    function scheduleIterable(input, scheduler) {
        if (!input) {
            throw new Error('Iterable cannot be null');
        }
        return new Observable(function (subscriber) {
            var sub = new Subscription();
            var iterator$1;
            sub.add(function () {
                if (iterator$1 && typeof iterator$1.return === 'function') {
                    iterator$1.return();
                }
            });
            sub.add(scheduler.schedule(function () {
                iterator$1 = input[iterator]();
                sub.add(scheduler.schedule(function () {
                    if (subscriber.closed) {
                        return;
                    }
                    var value;
                    var done;
                    try {
                        var result = iterator$1.next();
                        value = result.value;
                        done = result.done;
                    }
                    catch (err) {
                        subscriber.error(err);
                        return;
                    }
                    if (done) {
                        subscriber.complete();
                    }
                    else {
                        subscriber.next(value);
                        this.schedule();
                    }
                }));
            }));
            return sub;
        });
    }
    function isInteropObservable(input) {
        return input && typeof input[observable] === 'function';
    }
    function isIterable(input) {
        return input && typeof input[iterator] === 'function';
    }
    function scheduled(input, scheduler) {
        if (input != null) {
            if (isInteropObservable(input)) {
                return scheduleObservable(input, scheduler);
            }
            else if (isPromise(input)) {
                return schedulePromise(input, scheduler);
            }
            else if (isArrayLike(input)) {
                return scheduleArray(input, scheduler);
            }
            else if (isIterable(input) || typeof input === 'string') {
                return scheduleIterable(input, scheduler);
            }
        }
        throw new TypeError((input !== null && typeof input || input) + ' is not observable');
    }
    function from(input, scheduler) {
        if (!scheduler) {
            if (input instanceof Observable) {
                return input;
            }
            return new Observable(subscribeTo(input));
        }
        else {
            return scheduled(input, scheduler);
        }
    }
    function mergeMap(project, resultSelector, concurrent) {
        if (concurrent === void 0) { concurrent = Number.POSITIVE_INFINITY; }
        if (typeof resultSelector === 'function') {
            return function (source) { return source.pipe(mergeMap(function (a, i) { return from(project(a, i)).pipe(map(function (b, ii) { return resultSelector(a, b, i, ii); })); }, concurrent)); };
        }
        else if (typeof resultSelector === 'number') {
            concurrent = resultSelector;
        }
        return function (source) { return source.lift(new MergeMapOperator(project, concurrent)); };
    }
    var MergeMapOperator = /** @class */ (function () {
        function MergeMapOperator(project, concurrent) {
            if (concurrent === void 0) { concurrent = Number.POSITIVE_INFINITY; }
            this.project = project;
            this.concurrent = concurrent;
        }
        MergeMapOperator.prototype.call = function (observer, source) {
            return source.subscribe(new MergeMapSubscriber(observer, this.project, this.concurrent));
        };
        return MergeMapOperator;
    }());
    var MergeMapSubscriber = /** @class */ (function (_super) {
        __extends(MergeMapSubscriber, _super);
        function MergeMapSubscriber(destination, project, concurrent) {
            if (concurrent === void 0) { concurrent = Number.POSITIVE_INFINITY; }
            var _this = _super.call(this, destination) || this;
            _this.project = project;
            _this.concurrent = concurrent;
            _this.hasCompleted = false;
            _this.buffer = [];
            _this.active = 0;
            _this.index = 0;
            return _this;
        }
        MergeMapSubscriber.prototype._next = function (value) {
            if (this.active < this.concurrent) {
                this._tryNext(value);
            }
            else {
                this.buffer.push(value);
            }
        };
        MergeMapSubscriber.prototype._tryNext = function (value) {
            var result;
            var index = this.index++;
            try {
                result = this.project(value, index);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            this.active++;
            this._innerSub(result, value, index);
        };
        MergeMapSubscriber.prototype._innerSub = function (ish, value, index) {
            var innerSubscriber = new InnerSubscriber(this, value, index);
            var destination = this.destination;
            destination.add(innerSubscriber);
            var innerSubscription = subscribeToResult(this, ish, undefined, undefined, innerSubscriber);
            if (innerSubscription !== innerSubscriber) {
                destination.add(innerSubscription);
            }
        };
        MergeMapSubscriber.prototype._complete = function () {
            this.hasCompleted = true;
            if (this.active === 0 && this.buffer.length === 0) {
                this.destination.complete();
            }
            this.unsubscribe();
        };
        MergeMapSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            this.destination.next(innerValue);
        };
        MergeMapSubscriber.prototype.notifyComplete = function (innerSub) {
            var buffer = this.buffer;
            this.remove(innerSub);
            this.active--;
            if (buffer.length > 0) {
                this._next(buffer.shift());
            }
            else if (this.active === 0 && this.hasCompleted) {
                this.destination.complete();
            }
        };
        return MergeMapSubscriber;
    }(OuterSubscriber));
    function mergeAll(concurrent) {
        if (concurrent === void 0) { concurrent = Number.POSITIVE_INFINITY; }
        return mergeMap(identity, concurrent);
    }
    function concatAll() {
        return mergeAll(1);
    }
    function concat() {
        var observables = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            observables[_i] = arguments[_i];
        }
        return concatAll()(of.apply(void 0, __spread(observables)));
    }
    function defer(observableFactory) {
        return new Observable(function (subscriber) {
            var input;
            try {
                input = observableFactory();
            }
            catch (err) {
                subscriber.error(err);
                return undefined;
            }
            var source = input ? from(input) : empty$1();
            return source.subscribe(subscriber);
        });
    }
    function forkJoin() {
        var sources = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            sources[_i] = arguments[_i];
        }
        if (sources.length === 1) {
            var first_1 = sources[0];
            if (isArray(first_1)) {
                return forkJoinInternal(first_1, null);
            }
            if (isObject(first_1) && Object.getPrototypeOf(first_1) === Object.prototype) {
                var keys = Object.keys(first_1);
                return forkJoinInternal(keys.map(function (key) { return first_1[key]; }), keys);
            }
        }
        if (typeof sources[sources.length - 1] === 'function') {
            var resultSelector_1 = sources.pop();
            sources = (sources.length === 1 && isArray(sources[0])) ? sources[0] : sources;
            return forkJoinInternal(sources, null).pipe(map(function (args) { return resultSelector_1.apply(void 0, __spread(args)); }));
        }
        return forkJoinInternal(sources, null);
    }
    function forkJoinInternal(sources, keys) {
        return new Observable(function (subscriber) {
            var len = sources.length;
            if (len === 0) {
                subscriber.complete();
                return;
            }
            var values = new Array(len);
            var completed = 0;
            var emitted = 0;
            var _loop_1 = function (i_8) {
                var source = from(sources[i_8]);
                var hasValue = false;
                subscriber.add(source.subscribe({
                    next: function (value) {
                        if (!hasValue) {
                            hasValue = true;
                            emitted++;
                        }
                        values[i_8] = value;
                    },
                    error: function (err) { return subscriber.error(err); },
                    complete: function () {
                        completed++;
                        if (completed === len || !hasValue) {
                            if (emitted === len) {
                                subscriber.next(keys ?
                                    keys.reduce(function (result, key, i) { return (result[key] = values[i], result); }, {}) :
                                    values);
                            }
                            subscriber.complete();
                        }
                    }
                }));
            };
            for (var i_8 = 0; i_8 < len; i_8++) {
                _loop_1(i_8);
            }
        });
    }
    function fromEvent(target, eventName, options, resultSelector) {
        if (isFunction(options)) {
            resultSelector = options;
            options = undefined;
        }
        if (resultSelector) {
            return fromEvent(target, eventName, options).pipe(map(function (args) { return isArray(args) ? resultSelector.apply(void 0, __spread(args)) : resultSelector(args); }));
        }
        return new Observable(function (subscriber) {
            function handler(e) {
                if (arguments.length > 1) {
                    subscriber.next(Array.prototype.slice.call(arguments));
                }
                else {
                    subscriber.next(e);
                }
            }
            setupSubscription(target, eventName, handler, subscriber, options);
        });
    }
    function setupSubscription(sourceObj, eventName, handler, subscriber, options) {
        var unsubscribe;
        if (isEventTarget(sourceObj)) {
            var source_1 = sourceObj;
            sourceObj.addEventListener(eventName, handler, options);
            unsubscribe = function () { return source_1.removeEventListener(eventName, handler, options); };
        }
        else if (isJQueryStyleEventEmitter(sourceObj)) {
            var source_2 = sourceObj;
            sourceObj.on(eventName, handler);
            unsubscribe = function () { return source_2.off(eventName, handler); };
        }
        else if (isNodeStyleEventEmitter(sourceObj)) {
            var source_3 = sourceObj;
            sourceObj.addListener(eventName, handler);
            unsubscribe = function () { return source_3.removeListener(eventName, handler); };
        }
        else if (sourceObj && sourceObj.length) {
            for (var i_9 = 0, len = sourceObj.length; i_9 < len; i_9++) {
                setupSubscription(sourceObj[i_9], eventName, handler, subscriber, options);
            }
        }
        else {
            throw new TypeError('Invalid event target');
        }
        subscriber.add(unsubscribe);
    }
    function isNodeStyleEventEmitter(sourceObj) {
        return sourceObj && typeof sourceObj.addListener === 'function' && typeof sourceObj.removeListener === 'function';
    }
    function isJQueryStyleEventEmitter(sourceObj) {
        return sourceObj && typeof sourceObj.on === 'function' && typeof sourceObj.off === 'function';
    }
    function isEventTarget(sourceObj) {
        return sourceObj && typeof sourceObj.addEventListener === 'function' && typeof sourceObj.removeEventListener === 'function';
    }
    function isNumeric(val) {
        return !isArray(val) && (val - parseFloat(val) + 1) >= 0;
    }
    function merge() {
        var observables = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            observables[_i] = arguments[_i];
        }
        var concurrent = Number.POSITIVE_INFINITY;
        var scheduler = null;
        var last = observables[observables.length - 1];
        if (isScheduler(last)) {
            scheduler = observables.pop();
            if (observables.length > 1 && typeof observables[observables.length - 1] === 'number') {
                concurrent = observables.pop();
            }
        }
        else if (typeof last === 'number') {
            concurrent = observables.pop();
        }
        if (scheduler === null && observables.length === 1 && observables[0] instanceof Observable) {
            return observables[0];
        }
        return mergeAll(concurrent)(fromArray(observables, scheduler));
    }
    function filter(predicate, thisArg) {
        return function filterOperatorFunction(source) {
            return source.lift(new FilterOperator(predicate, thisArg));
        };
    }
    var FilterOperator = /** @class */ (function () {
        function FilterOperator(predicate, thisArg) {
            this.predicate = predicate;
            this.thisArg = thisArg;
        }
        FilterOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new FilterSubscriber(subscriber, this.predicate, this.thisArg));
        };
        return FilterOperator;
    }());
    var FilterSubscriber = /** @class */ (function (_super) {
        __extends(FilterSubscriber, _super);
        function FilterSubscriber(destination, predicate, thisArg) {
            var _this = _super.call(this, destination) || this;
            _this.predicate = predicate;
            _this.thisArg = thisArg;
            _this.count = 0;
            return _this;
        }
        FilterSubscriber.prototype._next = function (value) {
            var result;
            try {
                result = this.predicate.call(this.thisArg, value, this.count++);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            if (result) {
                this.destination.next(value);
            }
        };
        return FilterSubscriber;
    }(Subscriber));
    function timer(dueTime, periodOrScheduler, scheduler) {
        if (dueTime === void 0) { dueTime = 0; }
        var period = -1;
        if (isNumeric(periodOrScheduler)) {
            period = Number(periodOrScheduler) < 1 && 1 || Number(periodOrScheduler);
        }
        else if (isScheduler(periodOrScheduler)) {
            scheduler = periodOrScheduler;
        }
        if (!isScheduler(scheduler)) {
            scheduler = async;
        }
        return new Observable(function (subscriber) {
            var due = isNumeric(dueTime)
                ? dueTime
                : (+dueTime - scheduler.now());
            return scheduler.schedule(dispatch$1, due, {
                index: 0, period: period, subscriber: subscriber
            });
        });
    }
    function dispatch$1(state) {
        var index = state.index, period = state.period, subscriber = state.subscriber;
        subscriber.next(index);
        if (subscriber.closed) {
            return;
        }
        else if (period === -1) {
            return subscriber.complete();
        }
        state.index = index + 1;
        this.schedule(state, period);
    }
    function audit(durationSelector) {
        return function auditOperatorFunction(source) {
            return source.lift(new AuditOperator(durationSelector));
        };
    }
    var AuditOperator = /** @class */ (function () {
        function AuditOperator(durationSelector) {
            this.durationSelector = durationSelector;
        }
        AuditOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new AuditSubscriber(subscriber, this.durationSelector));
        };
        return AuditOperator;
    }());
    var AuditSubscriber = /** @class */ (function (_super) {
        __extends(AuditSubscriber, _super);
        function AuditSubscriber(destination, durationSelector) {
            var _this = _super.call(this, destination) || this;
            _this.durationSelector = durationSelector;
            _this.hasValue = false;
            return _this;
        }
        AuditSubscriber.prototype._next = function (value) {
            this.value = value;
            this.hasValue = true;
            if (!this.throttled) {
                var duration = void 0;
                try {
                    var durationSelector = this.durationSelector;
                    duration = durationSelector(value);
                }
                catch (err) {
                    return this.destination.error(err);
                }
                var innerSubscription = subscribeToResult(this, duration);
                if (!innerSubscription || innerSubscription.closed) {
                    this.clearThrottle();
                }
                else {
                    this.add(this.throttled = innerSubscription);
                }
            }
        };
        AuditSubscriber.prototype.clearThrottle = function () {
            var _b = this, value = _b.value, hasValue = _b.hasValue, throttled = _b.throttled;
            if (throttled) {
                this.remove(throttled);
                this.throttled = null;
                throttled.unsubscribe();
            }
            if (hasValue) {
                this.value = null;
                this.hasValue = false;
                this.destination.next(value);
            }
        };
        AuditSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex) {
            this.clearThrottle();
        };
        AuditSubscriber.prototype.notifyComplete = function () {
            this.clearThrottle();
        };
        return AuditSubscriber;
    }(OuterSubscriber));
    function auditTime(duration, scheduler) {
        if (scheduler === void 0) { scheduler = async; }
        return audit(function () { return timer(duration, scheduler); });
    }
    function catchError(selector) {
        return function catchErrorOperatorFunction(source) {
            var operator = new CatchOperator(selector);
            var caught = source.lift(operator);
            return (operator.caught = caught);
        };
    }
    var CatchOperator = /** @class */ (function () {
        function CatchOperator(selector) {
            this.selector = selector;
        }
        CatchOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new CatchSubscriber(subscriber, this.selector, this.caught));
        };
        return CatchOperator;
    }());
    var CatchSubscriber = /** @class */ (function (_super) {
        __extends(CatchSubscriber, _super);
        function CatchSubscriber(destination, selector, caught) {
            var _this = _super.call(this, destination) || this;
            _this.selector = selector;
            _this.caught = caught;
            return _this;
        }
        CatchSubscriber.prototype.error = function (err) {
            if (!this.isStopped) {
                var result = void 0;
                try {
                    result = this.selector(err, this.caught);
                }
                catch (err2) {
                    _super.prototype.error.call(this, err2);
                    return;
                }
                this._unsubscribeAndRecycle();
                var innerSubscriber = new InnerSubscriber(this, undefined, undefined);
                this.add(innerSubscriber);
                var innerSubscription = subscribeToResult(this, result, undefined, undefined, innerSubscriber);
                if (innerSubscription !== innerSubscriber) {
                    this.add(innerSubscription);
                }
            }
        };
        return CatchSubscriber;
    }(OuterSubscriber));
    function concatMap(project, resultSelector) {
        return mergeMap(project, resultSelector, 1);
    }
    function debounceTime(dueTime, scheduler) {
        if (scheduler === void 0) { scheduler = async; }
        return function (source) { return source.lift(new DebounceTimeOperator(dueTime, scheduler)); };
    }
    var DebounceTimeOperator = /** @class */ (function () {
        function DebounceTimeOperator(dueTime, scheduler) {
            this.dueTime = dueTime;
            this.scheduler = scheduler;
        }
        DebounceTimeOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new DebounceTimeSubscriber(subscriber, this.dueTime, this.scheduler));
        };
        return DebounceTimeOperator;
    }());
    var DebounceTimeSubscriber = /** @class */ (function (_super) {
        __extends(DebounceTimeSubscriber, _super);
        function DebounceTimeSubscriber(destination, dueTime, scheduler) {
            var _this = _super.call(this, destination) || this;
            _this.dueTime = dueTime;
            _this.scheduler = scheduler;
            _this.debouncedSubscription = null;
            _this.lastValue = null;
            _this.hasValue = false;
            return _this;
        }
        DebounceTimeSubscriber.prototype._next = function (value) {
            this.clearDebounce();
            this.lastValue = value;
            this.hasValue = true;
            this.add(this.debouncedSubscription = this.scheduler.schedule(dispatchNext, this.dueTime, this));
        };
        DebounceTimeSubscriber.prototype._complete = function () {
            this.debouncedNext();
            this.destination.complete();
        };
        DebounceTimeSubscriber.prototype.debouncedNext = function () {
            this.clearDebounce();
            if (this.hasValue) {
                var lastValue = this.lastValue;
                this.lastValue = null;
                this.hasValue = false;
                this.destination.next(lastValue);
            }
        };
        DebounceTimeSubscriber.prototype.clearDebounce = function () {
            var debouncedSubscription = this.debouncedSubscription;
            if (debouncedSubscription !== null) {
                this.remove(debouncedSubscription);
                debouncedSubscription.unsubscribe();
                this.debouncedSubscription = null;
            }
        };
        return DebounceTimeSubscriber;
    }(Subscriber));
    function dispatchNext(subscriber) {
        subscriber.debouncedNext();
    }
    function defaultIfEmpty(defaultValue) {
        if (defaultValue === void 0) { defaultValue = null; }
        return function (source) { return source.lift(new DefaultIfEmptyOperator(defaultValue)); };
    }
    var DefaultIfEmptyOperator = /** @class */ (function () {
        function DefaultIfEmptyOperator(defaultValue) {
            this.defaultValue = defaultValue;
        }
        DefaultIfEmptyOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new DefaultIfEmptySubscriber(subscriber, this.defaultValue));
        };
        return DefaultIfEmptyOperator;
    }());
    var DefaultIfEmptySubscriber = /** @class */ (function (_super) {
        __extends(DefaultIfEmptySubscriber, _super);
        function DefaultIfEmptySubscriber(destination, defaultValue) {
            var _this = _super.call(this, destination) || this;
            _this.defaultValue = defaultValue;
            _this.isEmpty = true;
            return _this;
        }
        DefaultIfEmptySubscriber.prototype._next = function (value) {
            this.isEmpty = false;
            this.destination.next(value);
        };
        DefaultIfEmptySubscriber.prototype._complete = function () {
            if (this.isEmpty) {
                this.destination.next(this.defaultValue);
            }
            this.destination.complete();
        };
        return DefaultIfEmptySubscriber;
    }(Subscriber));
    function isDate(value) {
        return value instanceof Date && !isNaN(+value);
    }
    function delay(delay, scheduler) {
        if (scheduler === void 0) { scheduler = async; }
        var absoluteDelay = isDate(delay);
        var delayFor = absoluteDelay ? (+delay - scheduler.now()) : Math.abs(delay);
        return function (source) { return source.lift(new DelayOperator(delayFor, scheduler)); };
    }
    var DelayOperator = /** @class */ (function () {
        function DelayOperator(delay, scheduler) {
            this.delay = delay;
            this.scheduler = scheduler;
        }
        DelayOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new DelaySubscriber(subscriber, this.delay, this.scheduler));
        };
        return DelayOperator;
    }());
    var DelaySubscriber = /** @class */ (function (_super) {
        __extends(DelaySubscriber, _super);
        function DelaySubscriber(destination, delay, scheduler) {
            var _this = _super.call(this, destination) || this;
            _this.delay = delay;
            _this.scheduler = scheduler;
            _this.queue = [];
            _this.active = false;
            _this.errored = false;
            return _this;
        }
        DelaySubscriber.dispatch = function (state) {
            var source = state.source;
            var queue = source.queue;
            var scheduler = state.scheduler;
            var destination = state.destination;
            while (queue.length > 0 && (queue[0].time - scheduler.now()) <= 0) {
                queue.shift().notification.observe(destination);
            }
            if (queue.length > 0) {
                var delay_1 = Math.max(0, queue[0].time - scheduler.now());
                this.schedule(state, delay_1);
            }
            else {
                this.unsubscribe();
                source.active = false;
            }
        };
        DelaySubscriber.prototype._schedule = function (scheduler) {
            this.active = true;
            var destination = this.destination;
            destination.add(scheduler.schedule(DelaySubscriber.dispatch, this.delay, {
                source: this, destination: this.destination, scheduler: scheduler
            }));
        };
        DelaySubscriber.prototype.scheduleNotification = function (notification) {
            if (this.errored === true) {
                return;
            }
            var scheduler = this.scheduler;
            var message = new DelayMessage(scheduler.now() + this.delay, notification);
            this.queue.push(message);
            if (this.active === false) {
                this._schedule(scheduler);
            }
        };
        DelaySubscriber.prototype._next = function (value) {
            this.scheduleNotification(Notification.createNext(value));
        };
        DelaySubscriber.prototype._error = function (err) {
            this.errored = true;
            this.queue = [];
            this.destination.error(err);
            this.unsubscribe();
        };
        DelaySubscriber.prototype._complete = function () {
            this.scheduleNotification(Notification.createComplete());
            this.unsubscribe();
        };
        return DelaySubscriber;
    }(Subscriber));
    var DelayMessage = /** @class */ (function () {
        function DelayMessage(time, notification) {
            this.time = time;
            this.notification = notification;
        }
        return DelayMessage;
    }());
    function distinctUntilChanged(compare, keySelector) {
        return function (source) { return source.lift(new DistinctUntilChangedOperator(compare, keySelector)); };
    }
    var DistinctUntilChangedOperator = /** @class */ (function () {
        function DistinctUntilChangedOperator(compare, keySelector) {
            this.compare = compare;
            this.keySelector = keySelector;
        }
        DistinctUntilChangedOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new DistinctUntilChangedSubscriber(subscriber, this.compare, this.keySelector));
        };
        return DistinctUntilChangedOperator;
    }());
    var DistinctUntilChangedSubscriber = /** @class */ (function (_super) {
        __extends(DistinctUntilChangedSubscriber, _super);
        function DistinctUntilChangedSubscriber(destination, compare, keySelector) {
            var _this = _super.call(this, destination) || this;
            _this.keySelector = keySelector;
            _this.hasKey = false;
            if (typeof compare === 'function') {
                _this.compare = compare;
            }
            return _this;
        }
        DistinctUntilChangedSubscriber.prototype.compare = function (x, y) {
            return x === y;
        };
        DistinctUntilChangedSubscriber.prototype._next = function (value) {
            var key;
            try {
                var keySelector = this.keySelector;
                key = keySelector ? keySelector(value) : value;
            }
            catch (err) {
                return this.destination.error(err);
            }
            var result = false;
            if (this.hasKey) {
                try {
                    var compare_1 = this.compare;
                    result = compare_1(this.key, key);
                }
                catch (err) {
                    return this.destination.error(err);
                }
            }
            else {
                this.hasKey = true;
            }
            if (!result) {
                this.key = key;
                this.destination.next(value);
            }
        };
        return DistinctUntilChangedSubscriber;
    }(Subscriber));
    function throwIfEmpty(errorFactory) {
        if (errorFactory === void 0) { errorFactory = defaultErrorFactory; }
        return function (source) {
            return source.lift(new ThrowIfEmptyOperator(errorFactory));
        };
    }
    var ThrowIfEmptyOperator = /** @class */ (function () {
        function ThrowIfEmptyOperator(errorFactory) {
            this.errorFactory = errorFactory;
        }
        ThrowIfEmptyOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new ThrowIfEmptySubscriber(subscriber, this.errorFactory));
        };
        return ThrowIfEmptyOperator;
    }());
    var ThrowIfEmptySubscriber = /** @class */ (function (_super) {
        __extends(ThrowIfEmptySubscriber, _super);
        function ThrowIfEmptySubscriber(destination, errorFactory) {
            var _this = _super.call(this, destination) || this;
            _this.errorFactory = errorFactory;
            _this.hasValue = false;
            return _this;
        }
        ThrowIfEmptySubscriber.prototype._next = function (value) {
            this.hasValue = true;
            this.destination.next(value);
        };
        ThrowIfEmptySubscriber.prototype._complete = function () {
            if (!this.hasValue) {
                var err = void 0;
                try {
                    err = this.errorFactory();
                }
                catch (e) {
                    err = e;
                }
                this.destination.error(err);
            }
            else {
                return this.destination.complete();
            }
        };
        return ThrowIfEmptySubscriber;
    }(Subscriber));
    function defaultErrorFactory() {
        return new EmptyError();
    }
    function take(count) {
        return function (source) {
            if (count === 0) {
                return empty$1();
            }
            else {
                return source.lift(new TakeOperator(count));
            }
        };
    }
    var TakeOperator = /** @class */ (function () {
        function TakeOperator(total) {
            this.total = total;
            if (this.total < 0) {
                throw new ArgumentOutOfRangeError;
            }
        }
        TakeOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new TakeSubscriber(subscriber, this.total));
        };
        return TakeOperator;
    }());
    var TakeSubscriber = /** @class */ (function (_super) {
        __extends(TakeSubscriber, _super);
        function TakeSubscriber(destination, total) {
            var _this = _super.call(this, destination) || this;
            _this.total = total;
            _this.count = 0;
            return _this;
        }
        TakeSubscriber.prototype._next = function (value) {
            var total = this.total;
            var count = ++this.count;
            if (count <= total) {
                this.destination.next(value);
                if (count === total) {
                    this.destination.complete();
                    this.unsubscribe();
                }
            }
        };
        return TakeSubscriber;
    }(Subscriber));
    function every(predicate, thisArg) {
        return function (source) { return source.lift(new EveryOperator(predicate, thisArg, source)); };
    }
    var EveryOperator = /** @class */ (function () {
        function EveryOperator(predicate, thisArg, source) {
            this.predicate = predicate;
            this.thisArg = thisArg;
            this.source = source;
        }
        EveryOperator.prototype.call = function (observer, source) {
            return source.subscribe(new EverySubscriber(observer, this.predicate, this.thisArg, this.source));
        };
        return EveryOperator;
    }());
    var EverySubscriber = /** @class */ (function (_super) {
        __extends(EverySubscriber, _super);
        function EverySubscriber(destination, predicate, thisArg, source) {
            var _this = _super.call(this, destination) || this;
            _this.predicate = predicate;
            _this.thisArg = thisArg;
            _this.source = source;
            _this.index = 0;
            _this.thisArg = thisArg || _this;
            return _this;
        }
        EverySubscriber.prototype.notifyComplete = function (everyValueMatch) {
            this.destination.next(everyValueMatch);
            this.destination.complete();
        };
        EverySubscriber.prototype._next = function (value) {
            var result = false;
            try {
                result = this.predicate.call(this.thisArg, value, this.index++, this.source);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            if (!result) {
                this.notifyComplete(false);
            }
        };
        EverySubscriber.prototype._complete = function () {
            this.notifyComplete(true);
        };
        return EverySubscriber;
    }(Subscriber));
    function finalize(callback) {
        return function (source) { return source.lift(new FinallyOperator(callback)); };
    }
    var FinallyOperator = /** @class */ (function () {
        function FinallyOperator(callback) {
            this.callback = callback;
        }
        FinallyOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new FinallySubscriber(subscriber, this.callback));
        };
        return FinallyOperator;
    }());
    var FinallySubscriber = /** @class */ (function (_super) {
        __extends(FinallySubscriber, _super);
        function FinallySubscriber(destination, callback) {
            var _this = _super.call(this, destination) || this;
            _this.add(new Subscription(callback));
            return _this;
        }
        return FinallySubscriber;
    }(Subscriber));
    function first(predicate, defaultValue) {
        var hasDefaultValue = arguments.length >= 2;
        return function (source) { return source.pipe(predicate ? filter(function (v, i) { return predicate(v, i, source); }) : identity, take(1), hasDefaultValue ? defaultIfEmpty(defaultValue) : throwIfEmpty(function () { return new EmptyError(); })); };
    }
    function takeLast(count) {
        return function takeLastOperatorFunction(source) {
            if (count === 0) {
                return empty$1();
            }
            else {
                return source.lift(new TakeLastOperator(count));
            }
        };
    }
    var TakeLastOperator = /** @class */ (function () {
        function TakeLastOperator(total) {
            this.total = total;
            if (this.total < 0) {
                throw new ArgumentOutOfRangeError;
            }
        }
        TakeLastOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new TakeLastSubscriber(subscriber, this.total));
        };
        return TakeLastOperator;
    }());
    var TakeLastSubscriber = /** @class */ (function (_super) {
        __extends(TakeLastSubscriber, _super);
        function TakeLastSubscriber(destination, total) {
            var _this = _super.call(this, destination) || this;
            _this.total = total;
            _this.ring = new Array();
            _this.count = 0;
            return _this;
        }
        TakeLastSubscriber.prototype._next = function (value) {
            var ring = this.ring;
            var total = this.total;
            var count = this.count++;
            if (ring.length < total) {
                ring.push(value);
            }
            else {
                var index = count % total;
                ring[index] = value;
            }
        };
        TakeLastSubscriber.prototype._complete = function () {
            var destination = this.destination;
            var count = this.count;
            if (count > 0) {
                var total = this.count >= this.total ? this.total : this.count;
                var ring = this.ring;
                for (var i_10 = 0; i_10 < total; i_10++) {
                    var idx = (count++) % total;
                    destination.next(ring[idx]);
                }
            }
            destination.complete();
        };
        return TakeLastSubscriber;
    }(Subscriber));
    function last(predicate, defaultValue) {
        var hasDefaultValue = arguments.length >= 2;
        return function (source) { return source.pipe(predicate ? filter(function (v, i) { return predicate(v, i, source); }) : identity, takeLast(1), hasDefaultValue ? defaultIfEmpty(defaultValue) : throwIfEmpty(function () { return new EmptyError(); })); };
    }
    function scan(accumulator, seed) {
        var hasSeed = false;
        if (arguments.length >= 2) {
            hasSeed = true;
        }
        return function scanOperatorFunction(source) {
            return source.lift(new ScanOperator(accumulator, seed, hasSeed));
        };
    }
    var ScanOperator = /** @class */ (function () {
        function ScanOperator(accumulator, seed, hasSeed) {
            if (hasSeed === void 0) { hasSeed = false; }
            this.accumulator = accumulator;
            this.seed = seed;
            this.hasSeed = hasSeed;
        }
        ScanOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new ScanSubscriber(subscriber, this.accumulator, this.seed, this.hasSeed));
        };
        return ScanOperator;
    }());
    var ScanSubscriber = /** @class */ (function (_super) {
        __extends(ScanSubscriber, _super);
        function ScanSubscriber(destination, accumulator, _seed, hasSeed) {
            var _this = _super.call(this, destination) || this;
            _this.accumulator = accumulator;
            _this._seed = _seed;
            _this.hasSeed = hasSeed;
            _this.index = 0;
            return _this;
        }
        Object.defineProperty(ScanSubscriber.prototype, "seed", {
            get: function () {
                return this._seed;
            },
            set: function (value) {
                this.hasSeed = true;
                this._seed = value;
            },
            enumerable: true,
            configurable: true
        });
        ScanSubscriber.prototype._next = function (value) {
            if (!this.hasSeed) {
                this.seed = value;
                this.destination.next(value);
            }
            else {
                return this._tryNext(value);
            }
        };
        ScanSubscriber.prototype._tryNext = function (value) {
            var index = this.index++;
            var result;
            try {
                result = this.accumulator(this.seed, value, index);
            }
            catch (err) {
                this.destination.error(err);
            }
            this.seed = result;
            this.destination.next(result);
        };
        return ScanSubscriber;
    }(Subscriber));
    function reduce(accumulator, seed) {
        if (arguments.length >= 2) {
            return function reduceOperatorFunctionWithSeed(source) {
                return pipe(scan(accumulator, seed), takeLast(1), defaultIfEmpty(seed))(source);
            };
        }
        return function reduceOperatorFunction(source) {
            return pipe(scan(function (acc, value, index) { return accumulator(acc, value, index + 1); }), takeLast(1))(source);
        };
    }
    function multicast(subjectOrSubjectFactory, selector) {
        return function multicastOperatorFunction(source) {
            var subjectFactory;
            if (typeof subjectOrSubjectFactory === 'function') {
                subjectFactory = subjectOrSubjectFactory;
            }
            else {
                subjectFactory = function subjectFactory() {
                    return subjectOrSubjectFactory;
                };
            }
            if (typeof selector === 'function') {
                return source.lift(new MulticastOperator(subjectFactory, selector));
            }
            var connectable = Object.create(source, connectableObservableDescriptor);
            connectable.source = source;
            connectable.subjectFactory = subjectFactory;
            return connectable;
        };
    }
    var MulticastOperator = /** @class */ (function () {
        function MulticastOperator(subjectFactory, selector) {
            this.subjectFactory = subjectFactory;
            this.selector = selector;
        }
        MulticastOperator.prototype.call = function (subscriber, source) {
            var selector = this.selector;
            var subject = this.subjectFactory();
            var subscription = selector(subject).subscribe(subscriber);
            subscription.add(source.subscribe(subject));
            return subscription;
        };
        return MulticastOperator;
    }());
    function pairwise() {
        return function (source) { return source.lift(new PairwiseOperator()); };
    }
    var PairwiseOperator = /** @class */ (function () {
        function PairwiseOperator() {
        }
        PairwiseOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new PairwiseSubscriber(subscriber));
        };
        return PairwiseOperator;
    }());
    var PairwiseSubscriber = /** @class */ (function (_super) {
        __extends(PairwiseSubscriber, _super);
        function PairwiseSubscriber(destination) {
            var _this = _super.call(this, destination) || this;
            _this.hasPrev = false;
            return _this;
        }
        PairwiseSubscriber.prototype._next = function (value) {
            var pair;
            if (this.hasPrev) {
                pair = [this.prev, value];
            }
            else {
                this.hasPrev = true;
            }
            this.prev = value;
            if (pair) {
                this.destination.next(pair);
            }
        };
        return PairwiseSubscriber;
    }(Subscriber));
    function pluck() {
        var properties = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            properties[_i] = arguments[_i];
        }
        var length = properties.length;
        if (length === 0) {
            throw new Error('list of properties cannot be empty.');
        }
        return function (source) { return map(plucker(properties, length))(source); };
    }
    function plucker(props, length) {
        var mapper = function (x) {
            var currentProp = x;
            for (var i_11 = 0; i_11 < length; i_11++) {
                var p_1 = currentProp[props[i_11]];
                if (typeof p_1 !== 'undefined') {
                    currentProp = p_1;
                }
                else {
                    return undefined;
                }
            }
            return currentProp;
        };
        return mapper;
    }
    function shareSubjectFactory() {
        return new Subject();
    }
    function share() {
        return function (source) { return refCount()(multicast(shareSubjectFactory)(source)); };
    }
    function shareReplay(configOrBufferSize, windowTime, scheduler) {
        var config;
        if (configOrBufferSize && typeof configOrBufferSize === 'object') {
            config = configOrBufferSize;
        }
        else {
            config = {
                bufferSize: configOrBufferSize,
                windowTime: windowTime,
                refCount: false,
                scheduler: scheduler
            };
        }
        return function (source) { return source.lift(shareReplayOperator(config)); };
    }
    function shareReplayOperator(_b) {
        var _c = _b.bufferSize, bufferSize = _c === void 0 ? Number.POSITIVE_INFINITY : _c, _d = _b.windowTime, windowTime = _d === void 0 ? Number.POSITIVE_INFINITY : _d, useRefCount = _b.refCount, scheduler = _b.scheduler;
        var subject;
        var refCount = 0;
        var subscription;
        var hasError = false;
        var isComplete = false;
        return function shareReplayOperation(source) {
            refCount++;
            if (!subject || hasError) {
                hasError = false;
                subject = new ReplaySubject(bufferSize, windowTime, scheduler);
                subscription = source.subscribe({
                    next: function (value) { subject.next(value); },
                    error: function (err) {
                        hasError = true;
                        subject.error(err);
                    },
                    complete: function () {
                        isComplete = true;
                        subscription = undefined;
                        subject.complete();
                    },
                });
            }
            var innerSub = subject.subscribe(this);
            this.add(function () {
                refCount--;
                innerSub.unsubscribe();
                if (subscription && !isComplete && useRefCount && refCount === 0) {
                    subscription.unsubscribe();
                    subscription = undefined;
                    subject = undefined;
                }
            });
        };
    }
    function skip(count) {
        return function (source) { return source.lift(new SkipOperator(count)); };
    }
    var SkipOperator = /** @class */ (function () {
        function SkipOperator(total) {
            this.total = total;
        }
        SkipOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new SkipSubscriber(subscriber, this.total));
        };
        return SkipOperator;
    }());
    var SkipSubscriber = /** @class */ (function (_super) {
        __extends(SkipSubscriber, _super);
        function SkipSubscriber(destination, total) {
            var _this = _super.call(this, destination) || this;
            _this.total = total;
            _this.count = 0;
            return _this;
        }
        SkipSubscriber.prototype._next = function (x) {
            if (++this.count > this.total) {
                this.destination.next(x);
            }
        };
        return SkipSubscriber;
    }(Subscriber));
    function startWith() {
        var array = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            array[_i] = arguments[_i];
        }
        var scheduler = array[array.length - 1];
        if (isScheduler(scheduler)) {
            array.pop();
            return function (source) { return concat(array, source, scheduler); };
        }
        else {
            return function (source) { return concat(array, source); };
        }
    }
    function switchMap(project, resultSelector) {
        if (typeof resultSelector === 'function') {
            return function (source) { return source.pipe(switchMap(function (a, i) { return from(project(a, i)).pipe(map(function (b, ii) { return resultSelector(a, b, i, ii); })); })); };
        }
        return function (source) { return source.lift(new SwitchMapOperator(project)); };
    }
    var SwitchMapOperator = /** @class */ (function () {
        function SwitchMapOperator(project) {
            this.project = project;
        }
        SwitchMapOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new SwitchMapSubscriber(subscriber, this.project));
        };
        return SwitchMapOperator;
    }());
    var SwitchMapSubscriber = /** @class */ (function (_super) {
        __extends(SwitchMapSubscriber, _super);
        function SwitchMapSubscriber(destination, project) {
            var _this = _super.call(this, destination) || this;
            _this.project = project;
            _this.index = 0;
            return _this;
        }
        SwitchMapSubscriber.prototype._next = function (value) {
            var result;
            var index = this.index++;
            try {
                result = this.project(value, index);
            }
            catch (error) {
                this.destination.error(error);
                return;
            }
            this._innerSub(result, value, index);
        };
        SwitchMapSubscriber.prototype._innerSub = function (result, value, index) {
            var innerSubscription = this.innerSubscription;
            if (innerSubscription) {
                innerSubscription.unsubscribe();
            }
            var innerSubscriber = new InnerSubscriber(this, value, index);
            var destination = this.destination;
            destination.add(innerSubscriber);
            this.innerSubscription = subscribeToResult(this, result, undefined, undefined, innerSubscriber);
            if (this.innerSubscription !== innerSubscriber) {
                destination.add(this.innerSubscription);
            }
        };
        SwitchMapSubscriber.prototype._complete = function () {
            var innerSubscription = this.innerSubscription;
            if (!innerSubscription || innerSubscription.closed) {
                _super.prototype._complete.call(this);
            }
            this.unsubscribe();
        };
        SwitchMapSubscriber.prototype._unsubscribe = function () {
            this.innerSubscription = null;
        };
        SwitchMapSubscriber.prototype.notifyComplete = function (innerSub) {
            var destination = this.destination;
            destination.remove(innerSub);
            this.innerSubscription = null;
            if (this.isStopped) {
                _super.prototype._complete.call(this);
            }
        };
        SwitchMapSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            this.destination.next(innerValue);
        };
        return SwitchMapSubscriber;
    }(OuterSubscriber));
    function takeUntil(notifier) {
        return function (source) { return source.lift(new TakeUntilOperator(notifier)); };
    }
    var TakeUntilOperator = /** @class */ (function () {
        function TakeUntilOperator(notifier) {
            this.notifier = notifier;
        }
        TakeUntilOperator.prototype.call = function (subscriber, source) {
            var takeUntilSubscriber = new TakeUntilSubscriber(subscriber);
            var notifierSubscription = subscribeToResult(takeUntilSubscriber, this.notifier);
            if (notifierSubscription && !takeUntilSubscriber.seenValue) {
                takeUntilSubscriber.add(notifierSubscription);
                return source.subscribe(takeUntilSubscriber);
            }
            return takeUntilSubscriber;
        };
        return TakeUntilOperator;
    }());
    var TakeUntilSubscriber = /** @class */ (function (_super) {
        __extends(TakeUntilSubscriber, _super);
        function TakeUntilSubscriber(destination) {
            var _this = _super.call(this, destination) || this;
            _this.seenValue = false;
            return _this;
        }
        TakeUntilSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            this.seenValue = true;
            this.complete();
        };
        TakeUntilSubscriber.prototype.notifyComplete = function () {
        };
        return TakeUntilSubscriber;
    }(OuterSubscriber));
    function tap(nextOrObserver, error, complete) {
        return function tapOperatorFunction(source) {
            return source.lift(new DoOperator(nextOrObserver, error, complete));
        };
    }
    var DoOperator = /** @class */ (function () {
        function DoOperator(nextOrObserver, error, complete) {
            this.nextOrObserver = nextOrObserver;
            this.error = error;
            this.complete = complete;
        }
        DoOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new TapSubscriber(subscriber, this.nextOrObserver, this.error, this.complete));
        };
        return DoOperator;
    }());
    var TapSubscriber = /** @class */ (function (_super) {
        __extends(TapSubscriber, _super);
        function TapSubscriber(destination, observerOrNext, error, complete) {
            var _this = _super.call(this, destination) || this;
            _this._tapNext = noop;
            _this._tapError = noop;
            _this._tapComplete = noop;
            _this._tapError = error || noop;
            _this._tapComplete = complete || noop;
            if (isFunction(observerOrNext)) {
                _this._context = _this;
                _this._tapNext = observerOrNext;
            }
            else if (observerOrNext) {
                _this._context = observerOrNext;
                _this._tapNext = observerOrNext.next || noop;
                _this._tapError = observerOrNext.error || noop;
                _this._tapComplete = observerOrNext.complete || noop;
            }
            return _this;
        }
        TapSubscriber.prototype._next = function (value) {
            try {
                this._tapNext.call(this._context, value);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            this.destination.next(value);
        };
        TapSubscriber.prototype._error = function (err) {
            try {
                this._tapError.call(this._context, err);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            this.destination.error(err);
        };
        TapSubscriber.prototype._complete = function () {
            try {
                this._tapComplete.call(this._context);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            return this.destination.complete();
        };
        return TapSubscriber;
    }(Subscriber));
    function withLatestFrom() {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return function (source) {
            var project;
            if (typeof args[args.length - 1] === 'function') {
                project = args.pop();
            }
            var observables = args;
            return source.lift(new WithLatestFromOperator(observables, project));
        };
    }
    var WithLatestFromOperator = /** @class */ (function () {
        function WithLatestFromOperator(observables, project) {
            this.observables = observables;
            this.project = project;
        }
        WithLatestFromOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new WithLatestFromSubscriber(subscriber, this.observables, this.project));
        };
        return WithLatestFromOperator;
    }());
    var WithLatestFromSubscriber = /** @class */ (function (_super) {
        __extends(WithLatestFromSubscriber, _super);
        function WithLatestFromSubscriber(destination, observables, project) {
            var _this = _super.call(this, destination) || this;
            _this.observables = observables;
            _this.project = project;
            _this.toRespond = [];
            var len = observables.length;
            _this.values = new Array(len);
            for (var i_12 = 0; i_12 < len; i_12++) {
                _this.toRespond.push(i_12);
            }
            for (var i_13 = 0; i_13 < len; i_13++) {
                var observable_2 = observables[i_13];
                _this.add(subscribeToResult(_this, observable_2, observable_2, i_13));
            }
            return _this;
        }
        WithLatestFromSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
            this.values[outerIndex] = innerValue;
            var toRespond = this.toRespond;
            if (toRespond.length > 0) {
                var found = toRespond.indexOf(outerIndex);
                if (found !== -1) {
                    toRespond.splice(found, 1);
                }
            }
        };
        WithLatestFromSubscriber.prototype.notifyComplete = function () {
        };
        WithLatestFromSubscriber.prototype._next = function (value) {
            if (this.toRespond.length === 0) {
                var args = __spread([value], this.values);
                if (this.project) {
                    this._tryProject(args);
                }
                else {
                    this.destination.next(args);
                }
            }
        };
        WithLatestFromSubscriber.prototype._tryProject = function (args) {
            var result;
            try {
                result = this.project.apply(this, args);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            this.destination.next(result);
        };
        return WithLatestFromSubscriber;
    }(OuterSubscriber));
    /**
     * @license Angular v8.2.14
     * (c) 2010-2019 Google LLC. https://angular.io/
     * License: MIT
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    var ANNOTATIONS = '__annotations__';
    var PARAMETERS = '__parameters__';
    var PROP_METADATA = '__prop__metadata__';
    /**
     * @suppress {globalThis}
     */
    function makeDecorator(name, props, parentClass, additionalProcessing, typeFn) {
        var metaCtor = makeMetadataCtor(props);
        function DecoratorFactory() {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            if (this instanceof DecoratorFactory) {
                metaCtor.call.apply(metaCtor, __spread([this], args));
                return this;
            }
            var annotationInstance = new (DecoratorFactory.bind.apply(DecoratorFactory, __spread([void 0], args)))();
            return function TypeDecorator(cls) {
                if (typeFn)
                    typeFn.apply(void 0, __spread([cls], args));
                // Use of Object.defineProperty is important since it creates non-enumerable property which
                // prevents the property is copied during subclassing.
                var annotations = cls.hasOwnProperty(ANNOTATIONS) ?
                    cls[ANNOTATIONS] :
                    Object.defineProperty(cls, ANNOTATIONS, { value: [] })[ANNOTATIONS];
                annotations.push(annotationInstance);
                if (additionalProcessing)
                    additionalProcessing(cls);
                return cls;
            };
        }
        if (parentClass) {
            DecoratorFactory.prototype = Object.create(parentClass.prototype);
        }
        DecoratorFactory.prototype.ngMetadataName = name;
        DecoratorFactory.annotationCls = DecoratorFactory;
        return DecoratorFactory;
    }
    function makeMetadataCtor(props) {
        return function ctor() {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            if (props) {
                var values = props.apply(void 0, __spread(args));
                for (var propName in values) {
                    this[propName] = values[propName];
                }
            }
        };
    }
    function makeParamDecorator(name, props, parentClass) {
        var metaCtor = makeMetadataCtor(props);
        function ParamDecoratorFactory() {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            if (this instanceof ParamDecoratorFactory) {
                metaCtor.apply(this, args);
                return this;
            }
            var annotationInstance = new (ParamDecoratorFactory.bind.apply(ParamDecoratorFactory, __spread([void 0], args)))();
            ParamDecorator.annotation = annotationInstance;
            return ParamDecorator;
            function ParamDecorator(cls, unusedKey, index) {
                // Use of Object.defineProperty is important since it creates non-enumerable property which
                // prevents the property is copied during subclassing.
                var parameters = cls.hasOwnProperty(PARAMETERS) ?
                    cls[PARAMETERS] :
                    Object.defineProperty(cls, PARAMETERS, { value: [] })[PARAMETERS];
                // there might be gaps if some in between parameters do not have annotations.
                // we pad with nulls.
                while (parameters.length <= index) {
                    parameters.push(null);
                }
                (parameters[index] = parameters[index] || []).push(annotationInstance);
                return cls;
            }
        }
        if (parentClass) {
            ParamDecoratorFactory.prototype = Object.create(parentClass.prototype);
        }
        ParamDecoratorFactory.prototype.ngMetadataName = name;
        ParamDecoratorFactory.annotationCls = ParamDecoratorFactory;
        return ParamDecoratorFactory;
    }
    function makePropDecorator(name, props, parentClass, additionalProcessing) {
        var metaCtor = makeMetadataCtor(props);
        function PropDecoratorFactory() {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            if (this instanceof PropDecoratorFactory) {
                metaCtor.apply(this, args);
                return this;
            }
            var decoratorInstance = new (PropDecoratorFactory.bind.apply(PropDecoratorFactory, __spread([void 0], args)))();
            function PropDecorator(target, name) {
                var constructor = target.constructor;
                // Use of Object.defineProperty is important since it creates non-enumerable property which
                // prevents the property is copied during subclassing.
                var meta = constructor.hasOwnProperty(PROP_METADATA) ?
                    constructor[PROP_METADATA] :
                    Object.defineProperty(constructor, PROP_METADATA, { value: {} })[PROP_METADATA];
                meta[name] = meta.hasOwnProperty(name) && meta[name] || [];
                meta[name].unshift(decoratorInstance);
                if (additionalProcessing)
                    additionalProcessing.apply(void 0, __spread([target, name], args));
            }
            return PropDecorator;
        }
        if (parentClass) {
            PropDecoratorFactory.prototype = Object.create(parentClass.prototype);
        }
        PropDecoratorFactory.prototype.ngMetadataName = name;
        PropDecoratorFactory.annotationCls = PropDecoratorFactory;
        return PropDecoratorFactory;
    }
    // WARNING: interface has both a type and a value, skipping emit
    var ɵ0 = /**
     * @param {?} token
     * @return {?}
     */ function (token) { return ({ token: token }); };
    /**
     * Inject decorator and metadata.
     *
     * \@Annotation
     * \@publicApi
     * @type {?}
     */
    var Inject = makeParamDecorator('Inject', (ɵ0));
    // WARNING: interface has both a type and a value, skipping emit
    /**
     * Optional decorator and metadata.
     *
     * \@Annotation
     * \@publicApi
     * @type {?}
     */
    var Optional = makeParamDecorator('Optional');
    // WARNING: interface has both a type and a value, skipping emit
    /**
     * Self decorator and metadata.
     *
     * \@Annotation
     * \@publicApi
     * @type {?}
     */
    var Self = makeParamDecorator('Self');
    // WARNING: interface has both a type and a value, skipping emit
    /**
     * SkipSelf decorator and metadata.
     *
     * \@Annotation
     * \@publicApi
     * @type {?}
     */
    var SkipSelf = makeParamDecorator('SkipSelf');
    // WARNING: interface has both a type and a value, skipping emit
    /**
     * Host decorator and metadata.
     *
     * \@Annotation
     * \@publicApi
     * @type {?}
     */
    var Host = makeParamDecorator('Host');
    // WARNING: interface has both a type and a value, skipping emit
    var ɵ1 = /**
     * @param {?=} attributeName
     * @return {?}
     */ function (attributeName) { return ({ attributeName: attributeName }); };
    /**
     * Attribute decorator and metadata.
     *
     * \@Annotation
     * \@publicApi
     * @type {?}
     */
    var Attribute = makeParamDecorator('Attribute', (ɵ1));
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * Injection flags for DI.
     *
     * @publicApi
     */
    var InjectFlags;
    (function (InjectFlags) {
        // TODO(alxhub): make this 'const' when ngc no longer writes exports of it into ngfactory files.
        /** Check self and check parent injector if needed */
        InjectFlags[InjectFlags["Default"] = 0] = "Default";
        /**
         * Specifies that an injector should retrieve a dependency from any injector until reaching the
         * host element of the current component. (Only used with Element Injector)
         */
        InjectFlags[InjectFlags["Host"] = 1] = "Host";
        /** Don't ascend to ancestors of the node requesting injection. */
        InjectFlags[InjectFlags["Self"] = 2] = "Self";
        /** Skip the node that is requesting injection. */
        InjectFlags[InjectFlags["SkipSelf"] = 4] = "SkipSelf";
        /** Inject `defaultValue` instead if token not found. */
        InjectFlags[InjectFlags["Optional"] = 8] = "Optional";
    })(InjectFlags || (InjectFlags = {}));
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    function getClosureSafeProperty(objWithPropertyToExtract) {
        for (var key in objWithPropertyToExtract) {
            if (objWithPropertyToExtract[key] === getClosureSafeProperty) {
                return key;
            }
        }
        throw Error('Could not find renamed property on target object.');
    }
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * Construct an `InjectableDef` which defines how a token will be constructed by the DI system, and
     * in which injectors (if any) it will be available.
     *
     * This should be assigned to a static `ngInjectableDef` field on a type, which will then be an
     * `InjectableType`.
     *
     * Options:
     * * `providedIn` determines which injectors will include the injectable, by either associating it
     *   with an `@NgModule` or other `InjectorType`, or by specifying that this injectable should be
     *   provided in the `'root'` injector, which will be the application-level injector in most apps.
     * * `factory` gives the zero argument function which will create an instance of the injectable.
     *   The factory can call `inject` to access the `Injector` and request injection of dependencies.
     *
     * @codeGenApi
     */
    function ɵɵdefineInjectable(opts) {
        return {
            token: opts.token, providedIn: opts.providedIn || null, factory: opts.factory,
            value: undefined,
        };
    }
    /**
     * Construct an `InjectorDef` which configures an injector.
     *
     * This should be assigned to a static `ngInjectorDef` field on a type, which will then be an
     * `InjectorType`.
     *
     * Options:
     *
     * * `factory`: an `InjectorType` is an instantiable type, so a zero argument `factory` function to
     *   create the type must be provided. If that factory function needs to inject arguments, it can
     *   use the `inject` function.
     * * `providers`: an optional array of providers to add to the injector. Each provider must
     *   either have a factory or point to a type which has an `ngInjectableDef` static property (the
     *   type must be an `InjectableType`).
     * * `imports`: an optional array of imports of other `InjectorType`s or `InjectorTypeWithModule`s
     *   whose providers will also be added to the injector. Locally provided types will override
     *   providers from imports.
     *
     * @publicApi
     */
    function ɵɵdefineInjector(options) {
        return {
            factory: options.factory, providers: options.providers || [], imports: options.imports || [],
        };
    }
    /**
     * Read the `ngInjectableDef` for `type` in a way which is immune to accidentally reading inherited
     * value.
     *
     * @param type A type which may have its own (non-inherited) `ngInjectableDef`.
     */
    function getInjectableDef(type) {
        var def = type[NG_INJECTABLE_DEF];
        // The definition read above may come from a base class. `hasOwnProperty` is not sufficient to
        // distinguish this case, as in older browsers (e.g. IE10) static property inheritance is
        // implemented by copying the properties.
        //
        // Instead, the ngInjectableDef's token is compared to the type, and if they don't match then the
        // property was not defined directly on the type itself, and was likely inherited. The definition
        // is only returned if the type matches the def.token.
        return def && def.token === type ? def : null;
    }
    var NG_INJECTABLE_DEF = getClosureSafeProperty({ ngInjectableDef: getClosureSafeProperty });
    var NG_INJECTOR_DEF = getClosureSafeProperty({ ngInjectorDef: getClosureSafeProperty });
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    function stringify(token) {
        if (typeof token === 'string') {
            return token;
        }
        if (token instanceof Array) {
            return '[' + token.map(stringify).join(', ') + ']';
        }
        if (token == null) {
            return '' + token;
        }
        if (token.overriddenName) {
            return "" + token.overriddenName;
        }
        if (token.name) {
            return "" + token.name;
        }
        var res = token.toString();
        if (res == null) {
            return '' + res;
        }
        var newLineIndex = res.indexOf('\n');
        return newLineIndex === -1 ? res : res.substring(0, newLineIndex);
    }
    /** @type {?} */
    var __forward_ref__ = getClosureSafeProperty({ __forward_ref__: getClosureSafeProperty });
    /**
     * Allows to refer to references which are not yet defined.
     *
     * For instance, `forwardRef` is used when the `token` which we need to refer to for the purposes of
     * DI is declared, but not yet defined. It is also used when the `token` which we use when creating
     * a query is not yet defined.
     *
     * \@usageNotes
     * ### Example
     * {\@example core/di/ts/forward_ref/forward_ref_spec.ts region='forward_ref'}
     * \@publicApi
     * @param {?} forwardRefFn
     * @return {?}
     */
    function forwardRef(forwardRefFn) {
        (( /** @type {?} */(forwardRefFn))).__forward_ref__ = forwardRef;
        (( /** @type {?} */(forwardRefFn))).toString = ( /**
         * @return {?}
         */function () { return stringify(this()); });
        return (( /** @type {?} */(( /** @type {?} */(forwardRefFn)))));
    }
    /**
     * Lazily retrieves the reference value from a forwardRef.
     *
     * Acts as the identity function when given a non-forward-ref value.
     *
     * \@usageNotes
     * ### Example
     *
     * {\@example core/di/ts/forward_ref/forward_ref_spec.ts region='resolve_forward_ref'}
     *
     * @see `forwardRef`
     * \@publicApi
     * @template T
     * @param {?} type
     * @return {?}
     */
    function resolveForwardRef(type) {
        /** @type {?} */
        var fn = type;
        if (typeof fn === 'function' && fn.hasOwnProperty(__forward_ref__) &&
            fn.__forward_ref__ === forwardRef) {
            return fn();
        }
        else {
            return type;
        }
    }
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    var __globalThis = typeof globalThis !== 'undefined' && globalThis;
    var __window = typeof window !== 'undefined' && window;
    var __self = typeof self !== 'undefined' && typeof WorkerGlobalScope !== 'undefined' &&
        self instanceof WorkerGlobalScope && self;
    var __global = typeof global !== 'undefined' && global;
    // Always use __globalThis if available, which is the spec-defined global variable across all
    // environments, then fallback to __global first, because in Node tests both __global and
    // __window may be defined and _global should be __global in that case.
    var _global = __globalThis || __global || __window || __self;
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    var R3ResolvedDependencyType;
    (function (R3ResolvedDependencyType) {
        R3ResolvedDependencyType[R3ResolvedDependencyType["Token"] = 0] = "Token";
        R3ResolvedDependencyType[R3ResolvedDependencyType["Attribute"] = 1] = "Attribute";
        R3ResolvedDependencyType[R3ResolvedDependencyType["ChangeDetectorRef"] = 2] = "ChangeDetectorRef";
    })(R3ResolvedDependencyType || (R3ResolvedDependencyType = {}));
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Creates a token that can be used in a DI Provider.
     *
     * Use an `InjectionToken` whenever the type you are injecting is not reified (does not have a
     * runtime representation) such as when injecting an interface, callable type, array or
     * parameterized type.
     *
     * `InjectionToken` is parameterized on `T` which is the type of object which will be returned by
     * the `Injector`. This provides additional level of type safety.
     *
     * ```
     * interface MyInterface {...}
     * var myInterface = injector.get(new InjectionToken<MyInterface>('SomeToken'));
     * // myInterface is inferred to be MyInterface.
     * ```
     *
     * When creating an `InjectionToken`, you can optionally specify a factory function which returns
     * (possibly by creating) a default value of the parameterized type `T`. This sets up the
     * `InjectionToken` using this factory as a provider as if it was defined explicitly in the
     * application's root injector. If the factory function, which takes zero arguments, needs to inject
     * dependencies, it can do so using the `inject` function. See below for an example.
     *
     * Additionally, if a `factory` is specified you can also specify the `providedIn` option, which
     * overrides the above behavior and marks the token as belonging to a particular `\@NgModule`. As
     * mentioned above, `'root'` is the default value for `providedIn`.
     *
     * \@usageNotes
     * ### Basic Example
     *
     * ### Plain InjectionToken
     *
     * {\@example core/di/ts/injector_spec.ts region='InjectionToken'}
     *
     * ### Tree-shakable InjectionToken
     *
     * {\@example core/di/ts/injector_spec.ts region='ShakableInjectionToken'}
     *
     *
     * \@publicApi
     * @template T
     */
    var InjectionToken = /** @class */ (function () {
        /**
         * @param {?} _desc
         * @param {?=} options
         */
        function InjectionToken(_desc, options) {
            this._desc = _desc;
            /**
             * \@internal
             */
            this.ngMetadataName = 'InjectionToken';
            /** @nocollapse */ this.ngInjectableDef = undefined;
            if (typeof options == 'number') {
                // This is a special hack to assign __NG_ELEMENT_ID__ to this instance.
                // __NG_ELEMENT_ID__ is Used by Ivy to determine bloom filter id.
                // We are using it to assign `-1` which is used to identify `Injector`.
                (( /** @type {?} */(this))).__NG_ELEMENT_ID__ = options;
            }
            else if (options !== undefined) {
                /** @nocollapse */ this.ngInjectableDef = ɵɵdefineInjectable({
                    token: this,
                    providedIn: options.providedIn || 'root',
                    factory: options.factory,
                });
            }
        }
        /**
         * @return {?}
         */
        InjectionToken.prototype.toString = function () { return "InjectionToken " + this._desc; };
        return InjectionToken;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * An InjectionToken that gets the current `Injector` for `createInjector()`-style injectors.
     *
     * Requesting this token instead of `Injector` allows `StaticInjector` to be tree-shaken from a
     * project.
     *
     * \@publicApi
     * @type {?}
     */
    var INJECTOR = new InjectionToken('INJECTOR', ( /** @type {?} */(-1)));
    /** @type {?} */
    var _THROW_IF_NOT_FOUND = new Object();
    /** @type {?} */
    var THROW_IF_NOT_FOUND = _THROW_IF_NOT_FOUND;
    /** @type {?} */
    var NG_TEMP_TOKEN_PATH = 'ngTempTokenPath';
    /** @type {?} */
    var NG_TOKEN_PATH = 'ngTokenPath';
    /** @type {?} */
    var NEW_LINE = /\n/gm;
    /** @type {?} */
    var NO_NEW_LINE = 'ɵ';
    /** @type {?} */
    var SOURCE = '__source';
    var ɵ0$1 = getClosureSafeProperty;
    /** @type {?} */
    var USE_VALUE = getClosureSafeProperty({ provide: String, useValue: ɵ0$1 });
    /**
     * Current injector value used by `inject`.
     * - `undefined`: it is an error to call `inject`
     * - `null`: `inject` can be called but there is no injector (limp-mode).
     * - Injector instance: Use the injector for resolution.
     * @type {?}
     */
    var _currentInjector = undefined;
    /**
     * @param {?} injector
     * @return {?}
     */
    function setCurrentInjector(injector) {
        /** @type {?} */
        var former = _currentInjector;
        _currentInjector = injector;
        return former;
    }
    /**
     * Current implementation of inject.
     *
     * By default, it is `injectInjectorOnly`, which makes it `Injector`-only aware. It can be changed
     * to `directiveInject`, which brings in the `NodeInjector` system of ivy. It is designed this
     * way for two reasons:
     *  1. `Injector` should not depend on ivy logic.
     *  2. To maintain tree shake-ability we don't want to bring in unnecessary code.
     * @type {?}
     */
    var _injectImplementation;
    /**
     * Sets the current inject implementation.
     * @param {?} impl
     * @return {?}
     */
    function setInjectImplementation(impl) {
        /** @type {?} */
        var previous = _injectImplementation;
        _injectImplementation = impl;
        return previous;
    }
    /**
     * @template T
     * @param {?} token
     * @param {?=} flags
     * @return {?}
     */
    function injectInjectorOnly(token, flags) {
        if (flags === void 0) { flags = InjectFlags.Default; }
        if (_currentInjector === undefined) {
            throw new Error("inject() must be called from an injection context");
        }
        else if (_currentInjector === null) {
            return injectRootLimpMode(token, undefined, flags);
        }
        else {
            return _currentInjector.get(token, flags & InjectFlags.Optional ? null : undefined, flags);
        }
    }
    /**
     * @template T
     * @param {?} token
     * @param {?=} flags
     * @return {?}
     */
    function ɵɵinject(token, flags) {
        if (flags === void 0) { flags = InjectFlags.Default; }
        return (_injectImplementation || injectInjectorOnly)(token, flags);
    }
    /**
     * Injects a token from the currently active injector.
     *
     * Must be used in the context of a factory function such as one defined for an
     * `InjectionToken`. Throws an error if not called from such a context.
     *
     * Within such a factory function, using this function to request injection of a dependency
     * is faster and more type-safe than providing an additional array of dependencies
     * (as has been common with `useFactory` providers).
     *
     * \@param token The injection token for the dependency to be injected.
     * \@param flags Optional flags that control how injection is executed.
     * The flags correspond to injection strategies that can be specified with
     * parameter decorators `\@Host`, `\@Self`, `\@SkipSef`, and `\@Optional`.
     * \@return True if injection is successful, null otherwise.
     *
     * \@usageNotes
     *
     * ### Example
     *
     * {\@example core/di/ts/injector_spec.ts region='ShakableInjectionToken'}
     *
     * \@publicApi
     * @type {?}
     */
    var inject = ɵɵinject;
    /**
     * Injects `root` tokens in limp mode.
     *
     * If no injector exists, we can still inject tree-shakable providers which have `providedIn` set to
     * `"root"`. This is known as the limp mode injection. In such case the value is stored in the
     * `InjectableDef`.
     * @template T
     * @param {?} token
     * @param {?} notFoundValue
     * @param {?} flags
     * @return {?}
     */
    function injectRootLimpMode(token, notFoundValue, flags) {
        /** @type {?} */
        var injectableDef = getInjectableDef(token);
        if (injectableDef && injectableDef.providedIn == 'root') {
            return injectableDef.value === undefined ? injectableDef.value = injectableDef.factory() :
                injectableDef.value;
        }
        if (flags & InjectFlags.Optional)
            return null;
        if (notFoundValue !== undefined)
            return notFoundValue;
        throw new Error("Injector: NOT_FOUND [" + stringify(token) + "]");
    }
    /**
     * @param {?} types
     * @return {?}
     */
    function injectArgs(types) {
        /** @type {?} */
        var args = [];
        for (var i_14 = 0; i_14 < types.length; i_14++) {
            /** @type {?} */
            var arg = resolveForwardRef(types[i_14]);
            if (Array.isArray(arg)) {
                if (arg.length === 0) {
                    throw new Error('Arguments array must have arguments.');
                }
                /** @type {?} */
                var type = undefined;
                /** @type {?} */
                var flags = InjectFlags.Default;
                for (var j_1 = 0; j_1 < arg.length; j_1++) {
                    /** @type {?} */
                    var meta = arg[j_1];
                    if (meta instanceof Optional || meta.ngMetadataName === 'Optional' || meta === Optional) {
                        flags |= InjectFlags.Optional;
                    }
                    else if (meta instanceof SkipSelf || meta.ngMetadataName === 'SkipSelf' || meta === SkipSelf) {
                        flags |= InjectFlags.SkipSelf;
                    }
                    else if (meta instanceof Self || meta.ngMetadataName === 'Self' || meta === Self) {
                        flags |= InjectFlags.Self;
                    }
                    else if (meta instanceof Inject || meta === Inject) {
                        type = meta.token;
                    }
                    else {
                        type = meta;
                    }
                }
                args.push(ɵɵinject(( /** @type {?} */(type)), flags));
            }
            else {
                args.push(ɵɵinject(arg));
            }
        }
        return args;
    }
    var NullInjector = /** @class */ (function () {
        function NullInjector() {
        }
        /**
         * @param {?} token
         * @param {?=} notFoundValue
         * @return {?}
         */
        NullInjector.prototype.get = function (token, notFoundValue) {
            if (notFoundValue === void 0) { notFoundValue = THROW_IF_NOT_FOUND; }
            if (notFoundValue === THROW_IF_NOT_FOUND) {
                // Intentionally left behind: With dev tools open the debugger will stop here. There is no
                // reason why correctly written application should cause this exception.
                // TODO(misko): uncomment the next line once `ngDevMode` works with closure.
                // if(ngDevMode) debugger;
                /** @type {?} */
                var error = new Error("NullInjectorError: No provider for " + stringify(token) + "!");
                error.name = 'NullInjectorError';
                throw error;
            }
            return notFoundValue;
        };
        return NullInjector;
    }());
    /**
     * @param {?} e
     * @param {?} token
     * @param {?} injectorErrorName
     * @param {?} source
     * @return {?}
     */
    function catchInjectorError(e, token, injectorErrorName, source) {
        /** @type {?} */
        var tokenPath = e[NG_TEMP_TOKEN_PATH];
        if (token[SOURCE]) {
            tokenPath.unshift(token[SOURCE]);
        }
        e.message = formatError('\n' + e.message, tokenPath, injectorErrorName, source);
        e[NG_TOKEN_PATH] = tokenPath;
        e[NG_TEMP_TOKEN_PATH] = null;
        throw e;
    }
    /**
     * @param {?} text
     * @param {?} obj
     * @param {?} injectorErrorName
     * @param {?=} source
     * @return {?}
     */
    function formatError(text, obj, injectorErrorName, source) {
        if (source === void 0) { source = null; }
        text = text && text.charAt(0) === '\n' && text.charAt(1) == NO_NEW_LINE ? text.substr(2) : text;
        /** @type {?} */
        var context = stringify(obj);
        if (obj instanceof Array) {
            context = obj.map(stringify).join(' -> ');
        }
        else if (typeof obj === 'object') {
            /** @type {?} */
            var parts = ( /** @type {?} */([]));
            for (var key in obj) {
                if (obj.hasOwnProperty(key)) {
                    /** @type {?} */
                    var value = obj[key];
                    parts.push(key + ':' + (typeof value === 'string' ? JSON.stringify(value) : stringify(value)));
                }
            }
            context = "{" + parts.join(', ') + "}";
        }
        return "" + injectorErrorName + (source ? '(' + source + ')' : '') + "[" + context + "]: " + text.replace(NEW_LINE, '\n  ');
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * Represents an instance of an NgModule created via a {\@link NgModuleFactory}.
     *
     * `NgModuleRef` provides access to the NgModule Instance as well other objects related to this
     * NgModule Instance.
     *
     * \@publicApi
     * @abstract
     * @template T
     */
    var NgModuleRef = /** @class */ (function () {
        function NgModuleRef() {
        }
        return NgModuleRef;
    }());
    /**
     * \@publicApi
     * @abstract
     * @template T
     */
    var NgModuleFactory = /** @class */ (function () {
        function NgModuleFactory() {
        }
        return NgModuleFactory;
    }());
    /**
     * Flattens an array.
     */
    function flatten(list, dst) {
        if (dst === undefined)
            dst = list;
        for (var i_15 = 0; i_15 < list.length; i_15++) {
            var item = list[i_15];
            if (Array.isArray(item)) {
                // we need to inline it.
                if (dst === list) {
                    // Our assumption that the list was already flat was wrong and
                    // we need to clone flat since we need to write to it.
                    dst = list.slice(0, i_15);
                }
                flatten(item, dst);
            }
            else if (dst !== list) {
                dst.push(item);
            }
        }
        return dst;
    }
    function addToArray(arr, index, value) {
        // perf: array.push is faster than array.splice!
        if (index >= arr.length) {
            arr.push(value);
        }
        else {
            arr.splice(index, 0, value);
        }
    }
    function removeFromArray(arr, index) {
        // perf: array.pop is faster than array.splice!
        if (index >= arr.length - 1) {
            return arr.pop();
        }
        else {
            return arr.splice(index, 1)[0];
        }
    }
    function assertEqual(actual, expected, msg) {
        if (actual != expected) {
            throwError$1(msg);
        }
    }
    function assertNotEqual(actual, expected, msg) {
        if (actual == expected) {
            throwError$1(msg);
        }
    }
    function assertLessThan(actual, expected, msg) {
        if (actual >= expected) {
            throwError$1(msg);
        }
    }
    function assertGreaterThan(actual, expected, msg) {
        if (actual <= expected) {
            throwError$1(msg);
        }
    }
    function assertDefined(actual, msg) {
        if (actual == null) {
            throwError$1(msg);
        }
    }
    function throwError$1(msg) {
        // tslint:disable-next-line
        debugger; // Left intentionally for better debugger experience.
        throw new Error("ASSERTION ERROR: " + msg);
    }
    function assertDomNode(node) {
        // If we're in a worker, `Node` will not be defined.
        assertEqual((typeof Node !== 'undefined' && node instanceof Node) ||
            (typeof node === 'object' && node != null &&
                node.constructor.name === 'WebWorkerRenderNode'), true, "The provided value must be an instance of a DOM Node but got " + stringify(node));
    }
    function assertDataInRange(arr, index) {
        var maxLen = arr ? arr.length : 0;
        assertLessThan(index, maxLen, "Index expected to be less than " + maxLen + " but got " + index);
    }
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    function ngDevModeResetPerfCounters() {
        var locationString = typeof location !== 'undefined' ? location.toString() : '';
        var newCounters = {
            namedConstructors: locationString.indexOf('ngDevMode=namedConstructors') != -1,
            firstTemplatePass: 0,
            tNode: 0,
            tView: 0,
            rendererCreateTextNode: 0,
            rendererSetText: 0,
            rendererCreateElement: 0,
            rendererAddEventListener: 0,
            rendererSetAttribute: 0,
            rendererRemoveAttribute: 0,
            rendererSetProperty: 0,
            rendererSetClassName: 0,
            rendererAddClass: 0,
            rendererRemoveClass: 0,
            rendererSetStyle: 0,
            rendererRemoveStyle: 0,
            rendererDestroy: 0,
            rendererDestroyNode: 0,
            rendererMoveNode: 0,
            rendererRemoveNode: 0,
            rendererAppendChild: 0,
            rendererInsertBefore: 0,
            rendererCreateComment: 0,
            styleMap: 0,
            styleMapCacheMiss: 0,
            classMap: 0,
            classMapCacheMiss: 0,
            styleProp: 0,
            stylePropCacheMiss: 0,
            classProp: 0,
            classPropCacheMiss: 0,
            flushStyling: 0,
            classesApplied: 0,
            stylesApplied: 0,
            stylingWritePersistedState: 0,
            stylingReadPersistedState: 0,
        };
        // Make sure to refer to ngDevMode as ['ngDevMode'] for closure.
        var allowNgDevModeTrue = locationString.indexOf('ngDevMode=false') === -1;
        _global['ngDevMode'] = allowNgDevModeTrue && newCounters;
        return newCounters;
    }
    /**
     * This checks to see if the `ngDevMode` has been set. If yes,
     * then we honor it, otherwise we default to dev mode with additional checks.
     *
     * The idea is that unless we are doing production build where we explicitly
     * set `ngDevMode == false` we should be helping the developer by providing
     * as much early warning and errors as possible.
     *
     * NOTE: changes to the `ngDevMode` name must be synced with `compiler-cli/src/tooling.ts`.
     */
    if (typeof ngDevMode === 'undefined' || ngDevMode) {
        ngDevModeResetPerfCounters();
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /** @enum {number} */
    var ChangeDetectionStrategy = {
        /**
         * Use the `CheckOnce` strategy, meaning that automatic change detection is deactivated
         * until reactivated by setting the strategy to `Default` (`CheckAlways`).
         * Change detection can still be explicitly invoked.
         * This strategy applies to all child directives and cannot be overridden.
         */
        OnPush: 0,
        /**
         * Use the default `CheckAlways` strategy, in which change detection is automatic until
         * explicitly deactivated.
         */
        Default: 1,
    };
    ChangeDetectionStrategy[ChangeDetectionStrategy.OnPush] = 'OnPush';
    ChangeDetectionStrategy[ChangeDetectionStrategy.Default] = 'Default';
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /** @enum {number} */
    var ViewEncapsulation = {
        /**
         * Emulate `Native` scoping of styles by adding an attribute containing surrogate id to the Host
         * Element and pre-processing the style rules provided via {@link Component#styles styles} or
         * {@link Component#styleUrls styleUrls}, and adding the new Host Element attribute to all
         * selectors.
         *
         * This is the default option.
         */
        Emulated: 0,
        /**
         * @deprecated v6.1.0 - use {ViewEncapsulation.ShadowDom} instead.
         * Use the native encapsulation mechanism of the renderer.
         *
         * For the DOM this means using the deprecated [Shadow DOM
         * v0](https://w3c.github.io/webcomponents/spec/shadow/) and
         * creating a ShadowRoot for Component's Host Element.
         */
        Native: 1,
        /**
         * Don't provide any template or style encapsulation.
         */
        None: 2,
        /**
         * Use Shadow DOM to encapsulate styles.
         *
         * For the DOM this means using modern [Shadow
         * DOM](https://w3c.github.io/webcomponents/spec/shadow/) and
         * creating a ShadowRoot for Component's Host Element.
         */
        ShadowDom: 3,
    };
    ViewEncapsulation[ViewEncapsulation.Emulated] = 'Emulated';
    ViewEncapsulation[ViewEncapsulation.Native] = 'Native';
    ViewEncapsulation[ViewEncapsulation.None] = 'None';
    ViewEncapsulation[ViewEncapsulation.ShadowDom] = 'ShadowDom';
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * Convince closure compiler that the wrapped function has no side-effects.
     *
     * Closure compiler always assumes that `toString` has no side-effects. We use this quirk to
     * allow us to execute a function but have closure compiler mark the call as no-side-effects.
     * It is important that the return value for the `noSideEffects` function be assigned
     * to something which is retained otherwise the call to `noSideEffects` will be removed by closure
     * compiler.
     */
    function noSideEffects(fn) {
        return '' + { toString: fn };
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * This file contains reuseable "empty" symbols that can be used as default return values
     * in different parts of the rendering code. Because the same symbols are returned, this
     * allows for identity checks against these values to be consistently used by the framework
     * code.
     * @type {?}
     */
    var EMPTY_OBJ = {};
    /** @type {?} */
    var EMPTY_ARRAY = [];
    // freezing the values prevents any code from accidentally inserting new values in
    if (typeof ngDevMode !== 'undefined' && ngDevMode) {
        // These property accesses can be ignored because ngDevMode will be set to false
        // when optimizing code and the whole if statement will be dropped.
        // tslint:disable-next-line:no-toplevel-property-access
        Object.freeze(EMPTY_OBJ);
        // tslint:disable-next-line:no-toplevel-property-access
        Object.freeze(EMPTY_ARRAY);
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var NG_COMPONENT_DEF = getClosureSafeProperty({ ngComponentDef: getClosureSafeProperty });
    /** @type {?} */
    var NG_DIRECTIVE_DEF = getClosureSafeProperty({ ngDirectiveDef: getClosureSafeProperty });
    /** @type {?} */
    var NG_PIPE_DEF = getClosureSafeProperty({ ngPipeDef: getClosureSafeProperty });
    /** @type {?} */
    var NG_MODULE_DEF = getClosureSafeProperty({ ngModuleDef: getClosureSafeProperty });
    /** @type {?} */
    var NG_LOCALE_ID_DEF = getClosureSafeProperty({ ngLocaleIdDef: getClosureSafeProperty });
    /** @type {?} */
    var NG_BASE_DEF = getClosureSafeProperty({ ngBaseDef: getClosureSafeProperty });
    // TODO(misko): This is wrong. The NG_ELEMENT_ID should never be minified.
    /**
     * If a directive is diPublic, bloomAdd sets a property on the type with this constant as
     * the key and the directive's unique ID as the value. This allows us to map directives to their
     * bloom filter bit for DI.
     * @type {?}
     */
    var NG_ELEMENT_ID = getClosureSafeProperty({ __NG_ELEMENT_ID__: getClosureSafeProperty });
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var _renderCompCount = 0;
    /**
     * Create a component definition object.
     *
     *
     * # Example
     * ```
     * class MyDirective {
     *   // Generated by Angular Template Compiler
     *   // [Symbol] syntax will not be supported by TypeScript until v2.7
     *   static ngComponentDef = defineComponent({
     *     ...
     *   });
     * }
     * ```
     * \@codeGenApi
     * @template T
     * @param {?} componentDefinition
     * @return {?}
     */
    function ɵɵdefineComponent(componentDefinition) {
        /** @type {?} */
        var type = componentDefinition.type;
        /** @type {?} */
        var typePrototype = type.prototype;
        /** @type {?} */
        var declaredInputs = ( /** @type {?} */({}));
        /** @type {?} */
        var def = {
            type: type,
            providersResolver: null,
            consts: componentDefinition.consts,
            vars: componentDefinition.vars,
            factory: componentDefinition.factory,
            template: componentDefinition.template || ( /** @type {?} */(null)),
            ngContentSelectors: componentDefinition.ngContentSelectors,
            hostBindings: componentDefinition.hostBindings || null,
            contentQueries: componentDefinition.contentQueries || null,
            declaredInputs: declaredInputs,
            inputs: ( /** @type {?} */(null)),
            // assigned in noSideEffects
            outputs: ( /** @type {?} */(null)),
            // assigned in noSideEffects
            exportAs: componentDefinition.exportAs || null,
            onChanges: null,
            onInit: typePrototype.ngOnInit || null,
            doCheck: typePrototype.ngDoCheck || null,
            afterContentInit: typePrototype.ngAfterContentInit || null,
            afterContentChecked: typePrototype.ngAfterContentChecked || null,
            afterViewInit: typePrototype.ngAfterViewInit || null,
            afterViewChecked: typePrototype.ngAfterViewChecked || null,
            onDestroy: typePrototype.ngOnDestroy || null,
            onPush: componentDefinition.changeDetection === ChangeDetectionStrategy.OnPush,
            directiveDefs: ( /** @type {?} */(null)),
            // assigned in noSideEffects
            pipeDefs: ( /** @type {?} */(null)),
            // assigned in noSideEffects
            selectors: componentDefinition.selectors,
            viewQuery: componentDefinition.viewQuery || null,
            features: ( /** @type {?} */(componentDefinition.features)) || null,
            data: componentDefinition.data || {},
            // TODO(misko): convert ViewEncapsulation into const enum so that it can be used directly in the
            // next line. Also `None` should be 0 not 2.
            encapsulation: componentDefinition.encapsulation || ViewEncapsulation.Emulated,
            id: 'c',
            styles: componentDefinition.styles || EMPTY_ARRAY,
            _: ( /** @type {?} */(null)),
            setInput: null,
            schemas: componentDefinition.schemas || null,
            tView: null,
        };
        def._ = ( /** @type {?} */(noSideEffects(( /**
         * @return {?}
         */function () {
            /** @type {?} */
            var directiveTypes = ( /** @type {?} */(componentDefinition.directives));
            /** @type {?} */
            var feature = componentDefinition.features;
            /** @type {?} */
            var pipeTypes = ( /** @type {?} */(componentDefinition.pipes));
            def.id += _renderCompCount++;
            def.inputs = invertObject(componentDefinition.inputs, declaredInputs),
                def.outputs = invertObject(componentDefinition.outputs),
                feature && feature.forEach(( /**
                 * @param {?} fn
                 * @return {?}
                 */function (fn) { return fn(def); }));
            def.directiveDefs = directiveTypes ?
                ( /**
                 * @return {?}
                 */function () { return (typeof directiveTypes === 'function' ? directiveTypes() : directiveTypes)
                    .map(extractDirectiveDef); }) :
                null;
            def.pipeDefs = pipeTypes ?
                ( /**
                 * @return {?}
                 */function () { return (typeof pipeTypes === 'function' ? pipeTypes() : pipeTypes).map(extractPipeDef); }) :
                null;
            // Add ngInjectableDef so components are reachable through the module injector by default
            // (unless it has already been set by the @Injectable decorator). This is mostly to
            // support injecting components in tests. In real application code, components should
            // be retrieved through the node injector, so this isn't a problem.
            if (!type.hasOwnProperty(NG_INJECTABLE_DEF)) {
                (( /** @type {?} */(type)))[NG_INJECTABLE_DEF] =
                    ɵɵdefineInjectable({ token: type, factory: ( /** @type {?} */(componentDefinition.factory)) });
            }
        }))));
        return ( /** @type {?} */(def));
    }
    /**
     * @param {?} type
     * @return {?}
     */
    function extractDirectiveDef(type) {
        /** @type {?} */
        var def = getComponentDef(type) || getDirectiveDef(type);
        if (ngDevMode && !def) {
            throw new Error("'" + type.name + "' is neither 'ComponentType' or 'DirectiveType'.");
        }
        return ( /** @type {?} */(def));
    }
    /**
     * @param {?} type
     * @return {?}
     */
    function extractPipeDef(type) {
        /** @type {?} */
        var def = getPipeDef(type);
        if (ngDevMode && !def) {
            throw new Error("'" + type.name + "' is not a 'PipeType'.");
        }
        return ( /** @type {?} */(def));
    }
    /**
     * Inverts an inputs or outputs lookup such that the keys, which were the
     * minified keys, are part of the values, and the values are parsed so that
     * the publicName of the property is the new key
     *
     * e.g. for
     *
     * ```
     * class Comp {
     * \@Input()
     *   propName1: string;
     *
     * \@Input('publicName2')
     *   declaredPropName2: number;
     * }
     * ```
     *
     * will be serialized as
     *
     * ```
     * {
     *   propName1: 'propName1',
     *   declaredPropName2: ['publicName2', 'declaredPropName2'],
     * }
     * ```
     *
     * which is than translated by the minifier as:
     *
     * ```
     * {
     *   minifiedPropName1: 'propName1',
     *   minifiedPropName2: ['publicName2', 'declaredPropName2'],
     * }
     * ```
     *
     * becomes: (public name => minifiedName)
     *
     * ```
     * {
     *  'propName1': 'minifiedPropName1',
     *  'publicName2': 'minifiedPropName2',
     * }
     * ```
     *
     * Optionally the function can take `secondary` which will result in: (public name => declared name)
     *
     * ```
     * {
     *  'propName1': 'propName1',
     *  'publicName2': 'declaredPropName2',
     * }
     * ```
     *
     * @template T
     * @param {?=} obj
     * @param {?=} secondary
     * @return {?}
     */
    function invertObject(obj, secondary) {
        if (obj == null)
            return ( /** @type {?} */(EMPTY_OBJ));
        /** @type {?} */
        var newLookup = {};
        for (var minifiedKey in obj) {
            if (obj.hasOwnProperty(minifiedKey)) {
                /** @type {?} */
                var publicName = ( /** @type {?} */(obj[minifiedKey]));
                /** @type {?} */
                var declaredName = publicName;
                if (Array.isArray(publicName)) {
                    declaredName = publicName[1];
                    publicName = publicName[0];
                }
                newLookup[publicName] = minifiedKey;
                if (secondary) {
                    (secondary[publicName] = ( /** @type {?} */(declaredName)));
                }
            }
        }
        return newLookup;
    }
    /**
     * Create a directive definition object.
     *
     * # Example
     * ```ts
     * class MyDirective {
     *   // Generated by Angular Template Compiler
     *   // [Symbol] syntax will not be supported by TypeScript until v2.7
     *   static ngDirectiveDef = ɵɵdefineDirective({
     *     ...
     *   });
     * }
     * ```
     *
     * \@codeGenApi
     * @type {?}
     */
    var ɵɵdefineDirective = ( /** @type {?} */(( /** @type {?} */(ɵɵdefineComponent))));
    /**
     * The following getter methods retrieve the definition form the type. Currently the retrieval
     * honors inheritance, but in the future we may change the rule to require that definitions are
     * explicit. This would require some sort of migration strategy.
     * @template T
     * @param {?} type
     * @return {?}
     */
    function getComponentDef(type) {
        return (( /** @type {?} */(type)))[NG_COMPONENT_DEF] || null;
    }
    /**
     * @template T
     * @param {?} type
     * @return {?}
     */
    function getDirectiveDef(type) {
        return (( /** @type {?} */(type)))[NG_DIRECTIVE_DEF] || null;
    }
    /**
     * @template T
     * @param {?} type
     * @return {?}
     */
    function getPipeDef(type) {
        return (( /** @type {?} */(type)))[NG_PIPE_DEF] || null;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    // Below are constants for LView indices to help us look up LView members
    // without having to remember the specific indices.
    // Uglify will inline these when minifying so there shouldn't be a cost.
    /** @type {?} */
    var HOST = 0;
    /** @type {?} */
    var TVIEW = 1;
    /** @type {?} */
    var FLAGS = 2;
    /** @type {?} */
    var PARENT = 3;
    /** @type {?} */
    var NEXT = 4;
    /** @type {?} */
    var QUERIES = 5;
    /** @type {?} */
    var T_HOST = 6;
    /** @type {?} */
    var BINDING_INDEX = 7;
    /** @type {?} */
    var CLEANUP = 8;
    /** @type {?} */
    var CONTEXT = 9;
    /** @type {?} */
    var INJECTOR$1 = 10;
    /** @type {?} */
    var RENDERER_FACTORY = 11;
    /** @type {?} */
    var RENDERER = 12;
    /** @type {?} */
    var SANITIZER = 13;
    /** @type {?} */
    var CHILD_HEAD = 14;
    /** @type {?} */
    var CHILD_TAIL = 15;
    /** @type {?} */
    var DECLARATION_VIEW = 16;
    /** @type {?} */
    var DECLARATION_LCONTAINER = 17;
    /** @type {?} */
    var PREORDER_HOOK_FLAGS = 18;
    /**
     * Size of LView's header. Necessary to adjust for it when setting slots.
     * @type {?}
     */
    var HEADER_OFFSET = 19;
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Special location which allows easy identification of type. If we have an array which was
     * retrieved from the `LView` and that array has `true` at `TYPE` location, we know it is
     * `LContainer`.
     * @type {?}
     */
    var TYPE = 1;
    /**
     * Below are constants for LContainer indices to help us look up LContainer members
     * without having to remember the specific indices.
     * Uglify will inline these when minifying so there shouldn't be a cost.
     * @type {?}
     */
    var ACTIVE_INDEX = 2;
    // PARENT and NEXT are indices 3 and 4
    // As we already have these constants in LView, we don't need to re-create them.
    /** @type {?} */
    var MOVED_VIEWS = 5;
    // T_HOST is index 6
    // We already have this constants in LView, we don't need to re-create it.
    /** @type {?} */
    var NATIVE = 7;
    /**
     * Size of LContainer's header. Represents the index after which all views in the
     * container will be inserted. We need to keep a record of current views so we know
     * which views are already in the DOM (and don't need to be re-added) and so we can
     * remove views from the DOM when they are no longer required.
     * @type {?}
     */
    var CONTAINER_HEADER_OFFSET = 9;
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * True if `value` is `LView`.
     * @param {?} value wrapped value of `RNode`, `LView`, `LContainer`
     * @return {?}
     */
    function isLView(value) {
        return Array.isArray(value) && typeof value[TYPE] === 'object';
    }
    /**
     * True if `value` is `LContainer`.
     * @param {?} value wrapped value of `RNode`, `LView`, `LContainer`
     * @return {?}
     */
    function isLContainer(value) {
        return Array.isArray(value) && value[TYPE] === true;
    }
    /**
     * @param {?} tNode
     * @return {?}
     */
    function isComponent(tNode) {
        return (tNode.flags & 1 /* isComponent */) === 1 /* isComponent */;
    }
    /**
     * @template T
     * @param {?} def
     * @return {?}
     */
    function isComponentDef(def) {
        return (( /** @type {?} */(def))).template !== null;
    }
    /**
     * @param {?} target
     * @return {?}
     */
    function isRootView(target) {
        return (target[FLAGS] & 512 /* IsRoot */) !== 0;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} tNode
     * @param {?} lView
     * @return {?}
     */
    function assertTNodeForLView(tNode, lView) {
        tNode.hasOwnProperty('tView_') && assertEqual((( /** @type {?} */(( /** @type {?} */(tNode))))).tView_, lView[TVIEW], 'This TNode does not belong to this LView.');
    }
    /**
     * @param {?} actual
     * @param {?=} msg
     * @return {?}
     */
    function assertComponentType(actual, msg) {
        if (msg === void 0) { msg = 'Type passed in is not ComponentType, it does not have \'ngComponentDef\' property.'; }
        if (!getComponentDef(actual)) {
            throwError$1(msg);
        }
    }
    /**
     * @param {?} isParent
     * @return {?}
     */
    function assertPreviousIsParent(isParent) {
        assertEqual(isParent, true, 'previousOrParentTNode should be a parent');
    }
    /**
     * @param {?} value
     * @return {?}
     */
    function assertLContainer(value) {
        assertDefined(value, 'LContainer must be defined');
        assertEqual(isLContainer(value), true, 'Expecting LContainer');
    }
    /**
     * @param {?} value
     * @return {?}
     */
    function assertLViewOrUndefined(value) {
        value && assertEqual(isLView(value), true, 'Expecting LView or undefined or null');
    }
    /**
     * @param {?} value
     * @return {?}
     */
    function assertLView(value) {
        assertDefined(value, 'LView must be defined');
        assertEqual(isLView(value), true, 'Expecting LView');
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /** @type {?} */
    var TNODE = 8;
    /** @type {?} */
    var PARENT_INJECTOR = 8;
    /** @type {?} */
    var INJECTOR_BLOOM_PARENT_SIZE = 9;
    /** @type {?} */
    var NO_PARENT_INJECTOR = ( /** @type {?} */(-1));
    /**
     * Each injector is saved in 9 contiguous slots in `LView` and 9 contiguous slots in
     * `TView.data`. This allows us to store information about the current node's tokens (which
     * can be shared in `TView`) as well as the tokens of its ancestor nodes (which cannot be
     * shared, so they live in `LView`).
     *
     * Each of these slots (aside from the last slot) contains a bloom filter. This bloom filter
     * determines whether a directive is available on the associated node or not. This prevents us
     * from searching the directives array at this level unless it's probable the directive is in it.
     *
     * See: https://en.wikipedia.org/wiki/Bloom_filter for more about bloom filters.
     *
     * Because all injectors have been flattened into `LView` and `TViewData`, they cannot typed
     * using interfaces as they were previously. The start index of each `LInjector` and `TInjector`
     * will differ based on where it is flattened into the main array, so it's not possible to know
     * the indices ahead of time and save their types here. The interfaces are still included here
     * for documentation purposes.
     *
     * export interface LInjector extends Array<any> {
     *
     *    // Cumulative bloom for directive IDs 0-31  (IDs are % BLOOM_SIZE)
     *    [0]: number;
     *
     *    // Cumulative bloom for directive IDs 32-63
     *    [1]: number;
     *
     *    // Cumulative bloom for directive IDs 64-95
     *    [2]: number;
     *
     *    // Cumulative bloom for directive IDs 96-127
     *    [3]: number;
     *
     *    // Cumulative bloom for directive IDs 128-159
     *    [4]: number;
     *
     *    // Cumulative bloom for directive IDs 160 - 191
     *    [5]: number;
     *
     *    // Cumulative bloom for directive IDs 192 - 223
     *    [6]: number;
     *
     *    // Cumulative bloom for directive IDs 224 - 255
     *    [7]: number;
     *
     *    // We need to store a reference to the injector's parent so DI can keep looking up
     *    // the injector tree until it finds the dependency it's looking for.
     *    [PARENT_INJECTOR]: number;
     * }
     *
     * export interface TInjector extends Array<any> {
     *
     *    // Shared node bloom for directive IDs 0-31  (IDs are % BLOOM_SIZE)
     *    [0]: number;
     *
     *    // Shared node bloom for directive IDs 32-63
     *    [1]: number;
     *
     *    // Shared node bloom for directive IDs 64-95
     *    [2]: number;
     *
     *    // Shared node bloom for directive IDs 96-127
     *    [3]: number;
     *
     *    // Shared node bloom for directive IDs 128-159
     *    [4]: number;
     *
     *    // Shared node bloom for directive IDs 160 - 191
     *    [5]: number;
     *
     *    // Shared node bloom for directive IDs 192 - 223
     *    [6]: number;
     *
     *    // Shared node bloom for directive IDs 224 - 255
     *    [7]: number;
     *
     *    // Necessary to find directive indices for a particular node.
     *    [TNODE]: TElementNode|TElementContainerNode|TContainerNode;
     *  }
     */
    /**
     * Factory for creating instances of injectors in the NodeInjector.
     *
     * This factory is complicated by the fact that it can resolve `multi` factories as well.
     *
     * NOTE: Some of the fields are optional which means that this class has two hidden classes.
     * - One without `multi` support (most common)
     * - One with `multi` values, (rare).
     *
     * Since VMs can cache up to 4 inline hidden classes this is OK.
     *
     * - Single factory: Only `resolving` and `factory` is defined.
     * - `providers` factory: `componentProviders` is a number and `index = -1`.
     * - `viewProviders` factory: `componentProviders` is a number and `index` points to `providers`.
     */
    var NodeInjectorFactory = /** @class */ (function () {
        /**
         * @param {?} factory
         * @param {?} isViewProvider
         * @param {?} injectImplementation
         */
        function NodeInjectorFactory(factory, 
        /**
         * Set to `true` if the token is declared in `viewProviders` (or if it is component).
         */
        isViewProvider, injectImplementation) {
            this.factory = factory;
            /**
             * Marker set to true during factory invocation to see if we get into recursive loop.
             * Recursive loop causes an error to be displayed.
             */
            this.resolving = false;
            this.canSeeViewProviders = isViewProvider;
            this.injectImpl = injectImplementation;
        }
        return NodeInjectorFactory;
    }());
    /**
     * @param {?} obj
     * @return {?}
     */
    function isFactory(obj) {
        // See: https://jsperf.com/instanceof-vs-getprototypeof
        return obj !== null && typeof obj == 'object' &&
            Object.getPrototypeOf(obj) == NodeInjectorFactory.prototype;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} tNode
     * @param {?} type
     * @return {?}
     */
    function assertNodeType(tNode, type) {
        assertDefined(tNode, 'should be called with a TNode');
        assertEqual(tNode.type, type, "should be a " + typeName(type));
    }
    /**
     * @param {?} tNode
     * @param {...?} types
     * @return {?}
     */
    function assertNodeOfPossibleTypes(tNode) {
        var types = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            types[_i - 1] = arguments[_i];
        }
        assertDefined(tNode, 'should be called with a TNode');
        /** @type {?} */
        var found = types.some(( /**
         * @param {?} type
         * @return {?}
         */function (/**
         * @param {?} type
         * @return {?}
         */ type) { return tNode.type === type; }));
        assertEqual(found, true, "Should be one of " + types.map(typeName).join(', ') + " but got " + typeName(tNode.type));
    }
    /**
     * @param {?} type
     * @return {?}
     */
    function typeName(type) {
        if (type == 1 /* Projection */)
            return 'Projection';
        if (type == 0 /* Container */)
            return 'Container';
        if (type == 2 /* View */)
            return 'View';
        if (type == 3 /* Element */)
            return 'Element';
        if (type == 4 /* ElementContainer */)
            return 'ElementContainer';
        return '<unknown>';
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Adds all directive lifecycle hooks from the given `DirectiveDef` to the given `TView`.
     *
     * Must be run *only* on the first template pass.
     *
     * Sets up the pre-order hooks on the provided `tView`,
     * see {\@link HookData} for details about the data structure.
     *
     * @param {?} directiveIndex The index of the directive in LView
     * @param {?} directiveDef The definition containing the hooks to setup in tView
     * @param {?} tView The current TView
     * @param {?} nodeIndex The index of the node to which the directive is attached
     * @param {?} initialPreOrderHooksLength the number of pre-order hooks already registered before the
     * current process, used to know if the node index has to be added to the array. If it is -1,
     * the node index is never added.
     * @param {?} initialPreOrderCheckHooksLength same as previous for pre-order check hooks
     * @return {?}
     */
    function registerPreOrderHooks(directiveIndex, directiveDef, tView, nodeIndex, initialPreOrderHooksLength, initialPreOrderCheckHooksLength) {
        ngDevMode &&
            assertEqual(tView.firstTemplatePass, true, 'Should only be called on first template pass');
        var onChanges = directiveDef.onChanges, onInit = directiveDef.onInit, doCheck = directiveDef.doCheck;
        if (initialPreOrderHooksLength >= 0 &&
            (!tView.preOrderHooks || initialPreOrderHooksLength === tView.preOrderHooks.length) &&
            (onChanges || onInit || doCheck)) {
            (tView.preOrderHooks || (tView.preOrderHooks = [])).push(nodeIndex);
        }
        if (initialPreOrderCheckHooksLength >= 0 &&
            (!tView.preOrderCheckHooks ||
                initialPreOrderCheckHooksLength === tView.preOrderCheckHooks.length) &&
            (onChanges || doCheck)) {
            (tView.preOrderCheckHooks || (tView.preOrderCheckHooks = [])).push(nodeIndex);
        }
        if (onChanges) {
            (tView.preOrderHooks || (tView.preOrderHooks = [])).push(directiveIndex, onChanges);
            (tView.preOrderCheckHooks || (tView.preOrderCheckHooks = [])).push(directiveIndex, onChanges);
        }
        if (onInit) {
            (tView.preOrderHooks || (tView.preOrderHooks = [])).push(-directiveIndex, onInit);
        }
        if (doCheck) {
            (tView.preOrderHooks || (tView.preOrderHooks = [])).push(directiveIndex, doCheck);
            (tView.preOrderCheckHooks || (tView.preOrderCheckHooks = [])).push(directiveIndex, doCheck);
        }
    }
    /**
     *
     * Loops through the directives on the provided `tNode` and queues hooks to be
     * run that are not initialization hooks.
     *
     * Should be executed during `elementEnd()` and similar to
     * preserve hook execution order. Content, view, and destroy hooks for projected
     * components and directives must be called *before* their hosts.
     *
     * Sets up the content, view, and destroy hooks on the provided `tView`,
     * see {\@link HookData} for details about the data structure.
     *
     * NOTE: This does not set up `onChanges`, `onInit` or `doCheck`, those are set up
     * separately at `elementStart`.
     *
     * @param {?} tView The current TView
     * @param {?} tNode The TNode whose directives are to be searched for hooks to queue
     * @return {?}
     */
    function registerPostOrderHooks(tView, tNode) {
        if (tView.firstTemplatePass) {
            // It's necessary to loop through the directives at elementEnd() (rather than processing in
            // directiveCreate) so we can preserve the current hook order. Content, view, and destroy
            // hooks for projected components and directives must be called *before* their hosts.
            for (var i_16 = tNode.directiveStart, end = tNode.directiveEnd; i_16 < end; i_16++) {
                /** @type {?} */
                var directiveDef_1 = ( /** @type {?} */(tView.data[i_16]));
                if (directiveDef_1.afterContentInit) {
                    (tView.contentHooks || (tView.contentHooks = [])).push(-i_16, directiveDef_1.afterContentInit);
                }
                if (directiveDef_1.afterContentChecked) {
                    (tView.contentHooks || (tView.contentHooks = [])).push(i_16, directiveDef_1.afterContentChecked);
                    (tView.contentCheckHooks || (tView.contentCheckHooks = [])).push(i_16, directiveDef_1.afterContentChecked);
                }
                if (directiveDef_1.afterViewInit) {
                    (tView.viewHooks || (tView.viewHooks = [])).push(-i_16, directiveDef_1.afterViewInit);
                }
                if (directiveDef_1.afterViewChecked) {
                    (tView.viewHooks || (tView.viewHooks = [])).push(i_16, directiveDef_1.afterViewChecked);
                    (tView.viewCheckHooks || (tView.viewCheckHooks = [])).push(i_16, directiveDef_1.afterViewChecked);
                }
                if (directiveDef_1.onDestroy != null) {
                    (tView.destroyHooks || (tView.destroyHooks = [])).push(i_16, directiveDef_1.onDestroy);
                }
            }
        }
    }
    /**
     * Executing hooks requires complex logic as we need to deal with 2 constraints.
     *
     * 1. Init hooks (ngOnInit, ngAfterContentInit, ngAfterViewInit) must all be executed once and only
     * once, across many change detection cycles. This must be true even if some hooks throw, or if
     * some recursively trigger a change detection cycle.
     * To solve that, it is required to track the state of the execution of these init hooks.
     * This is done by storing and maintaining flags in the view: the {@link InitPhaseState},
     * and the index within that phase. They can be seen as a cursor in the following structure:
     * [[onInit1, onInit2], [afterContentInit1], [afterViewInit1, afterViewInit2, afterViewInit3]]
     * They are are stored as flags in LView[FLAGS].
     *
     * 2. Pre-order hooks can be executed in batches, because of the select instruction.
     * To be able to pause and resume their execution, we also need some state about the hook's array
     * that is being processed:
     * - the index of the next hook to be executed
     * - the number of init hooks already found in the processed part of the  array
     * They are are stored as flags in LView[PREORDER_HOOK_FLAGS].
     */
    /**
     * Executes necessary hooks at the start of executing a template.
     *
     * Executes hooks that are to be run during the initialization of a directive such
     * as `onChanges`, `onInit`, and `doCheck`.
     *
     * @param {?} currentView
     * @param {?} tView Static data for the view containing the hooks to be executed
     * @param {?} checkNoChangesMode Whether or not we're in checkNoChanges mode.
     * @param {?} currentNodeIndex
     * @return {?}
     */
    function executePreOrderHooks(currentView, tView, checkNoChangesMode, currentNodeIndex) {
        if (!checkNoChangesMode) {
            executeHooks(currentView, tView.preOrderHooks, tView.preOrderCheckHooks, checkNoChangesMode, 0 /* OnInitHooksToBeRun */, currentNodeIndex !== undefined ? currentNodeIndex : null);
        }
    }
    /**
     * Executes hooks against the given `LView` based off of whether or not
     * This is the first pass.
     *
     * @param {?} currentView The view instance data to run the hooks against
     * @param {?} firstPassHooks An array of hooks to run if we're in the first view pass
     * @param {?} checkHooks An Array of hooks to run if we're not in the first view pass.
     * @param {?} checkNoChangesMode Whether or not we're in no changes mode.
     * @param {?} initPhaseState the current state of the init phase
     * @param {?} currentNodeIndex 3 cases depending the the value:
     * - undefined: all hooks from the array should be executed (post-order case)
     * - null: execute hooks only from the saved index until the end of the array (pre-order case, when
     * flushing the remaining hooks)
     * - number: execute hooks only from the saved index until that node index exclusive (pre-order
     * case, when executing select(number))
     * @return {?}
     */
    function executeHooks(currentView, firstPassHooks, checkHooks, checkNoChangesMode, initPhaseState, currentNodeIndex) {
        if (checkNoChangesMode)
            return;
        /** @type {?} */
        var hooksToCall = (currentView[FLAGS] & 3 /* InitPhaseStateMask */) === initPhaseState ?
            firstPassHooks :
            checkHooks;
        if (hooksToCall) {
            callHooks(currentView, hooksToCall, initPhaseState, currentNodeIndex);
        }
        // The init phase state must be always checked here as it may have been recursively updated
        if (currentNodeIndex == null &&
            (currentView[FLAGS] & 3 /* InitPhaseStateMask */) === initPhaseState &&
            initPhaseState !== 3 /* InitPhaseCompleted */) {
            currentView[FLAGS] &= 1023 /* IndexWithinInitPhaseReset */;
            currentView[FLAGS] += 1 /* InitPhaseStateIncrementer */;
        }
    }
    /**
     * Calls lifecycle hooks with their contexts, skipping init hooks if it's not
     * the first LView pass
     *
     * @param {?} currentView The current view
     * @param {?} arr The array in which the hooks are found
     * @param {?} initPhase
     * @param {?} currentNodeIndex 3 cases depending the the value:
     * - undefined: all hooks from the array should be executed (post-order case)
     * - null: execute hooks only from the saved index until the end of the array (pre-order case, when
     * flushing the remaining hooks)
     * - number: execute hooks only from the saved index until that node index exclusive (pre-order
     * case, when executing select(number))
     * @return {?}
     */
    function callHooks(currentView, arr, initPhase, currentNodeIndex) {
        /** @type {?} */
        var startIndex = currentNodeIndex !== undefined ?
            (currentView[PREORDER_HOOK_FLAGS] & 65535 /* IndexOfTheNextPreOrderHookMaskMask */) :
            0;
        /** @type {?} */
        var nodeIndexLimit = currentNodeIndex != null ? currentNodeIndex : -1;
        /** @type {?} */
        var lastNodeIndexFound = 0;
        for (var i_17 = startIndex; i_17 < arr.length; i_17++) {
            /** @type {?} */
            var hook = ( /** @type {?} */(arr[i_17 + 1]));
            if (typeof hook === 'number') {
                lastNodeIndexFound = ( /** @type {?} */(arr[i_17]));
                if (currentNodeIndex != null && lastNodeIndexFound >= currentNodeIndex) {
                    break;
                }
            }
            else {
                /** @type {?} */
                var isInitHook = arr[i_17] < 0;
                if (isInitHook)
                    currentView[PREORDER_HOOK_FLAGS] += 65536 /* NumberOfInitHooksCalledIncrementer */;
                if (lastNodeIndexFound < nodeIndexLimit || nodeIndexLimit == -1) {
                    callHook(currentView, initPhase, arr, i_17);
                    currentView[PREORDER_HOOK_FLAGS] =
                        (currentView[PREORDER_HOOK_FLAGS] & 4294901760 /* NumberOfInitHooksCalledMask */) + i_17 +
                            2;
                }
                i_17++;
            }
        }
    }
    /**
     * Execute one hook against the current `LView`.
     *
     * @param {?} currentView The current view
     * @param {?} initPhase
     * @param {?} arr The array in which the hooks are found
     * @param {?} i The current index within the hook data array
     * @return {?}
     */
    function callHook(currentView, initPhase, arr, i) {
        /** @type {?} */
        var isInitHook = arr[i] < 0;
        /** @type {?} */
        var hook = ( /** @type {?} */(arr[i + 1]));
        /** @type {?} */
        var directiveIndex = isInitHook ? -arr[i] : ( /** @type {?} */(arr[i]));
        /** @type {?} */
        var directive = currentView[directiveIndex];
        if (isInitHook) {
            /** @type {?} */
            var indexWithintInitPhase = currentView[FLAGS] >> 10 /* IndexWithinInitPhaseShift */;
            // The init phase state must be always checked here as it may have been recursively
            // updated
            if (indexWithintInitPhase <
                (currentView[PREORDER_HOOK_FLAGS] >> 16 /* NumberOfInitHooksCalledShift */) &&
                (currentView[FLAGS] & 3 /* InitPhaseStateMask */) === initPhase) {
                currentView[FLAGS] += 1024 /* IndexWithinInitPhaseIncrementer */;
                hook.call(directive);
            }
        }
        else {
            hook.call(directive);
        }
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
    * @license
    * Copyright Google Inc. All Rights Reserved.
    *
    * Use of this source code is governed by an MIT-style license that can be
    * found in the LICENSE file at https://angular.io/license
    */
    /**
     * --------
     *
     * // TODO(matsko): add updateMask info
     *
     * This file contains all state-based logic for styling in Angular.
     *
     * Styling in Angular is evaluated with a series of styling-specific
     * template instructions which are called one after another each time
     * change detection occurs in Angular.
     *
     * Styling makes use of various temporary, state-based variables between
     * instructions so that it can better cache and optimize its values.
     * These values are usually populated and cleared when an element is
     * exited in change detection (once all the instructions are run for
     * that element).
     *
     * There are, however, situations where the state-based values
     * need to be stored and used at a later point. This ONLY occurs when
     * there are template-level as well as host-binding-level styling
     * instructions on the same element. The example below shows exactly
     * what could be:
     *
     * ```html
     * <!-- two sources of styling: the template and the directive -->
     * <div [style.width]="width" dir-that-sets-height></div>
     * ```
     *
     * If and when this situation occurs, the current styling state is
     * stored in a storage map value and then later accessed once the
     * host bindings are evaluated. Once styling for the current element
     * is over then the map entry will be cleared.
     *
     * To learn more about the algorithm see `TStylingContext`.
     *
     * --------
     */
    /** @type {?} */
    var _stylingState = null;
    /** @type {?} */
    var _stateStorage = new Map();
    // this value is not used outside this file and is only here
    // as a caching check for when the element changes.
    /** @type {?} */
    var _stylingElement = null;
    /** @type {?} */
    var STYLING_INDEX_START_VALUE = 1;
    /** @type {?} */
    var BIT_MASK_START_VALUE = 0;
    /**
     * @param {?} element
     * @param {?=} readFromMap
     * @return {?}
     */
    function getStylingState(element, readFromMap) {
        if (!_stylingElement || element !== _stylingElement) {
            _stylingElement = element;
            if (readFromMap) {
                _stylingState = _stateStorage.get(element) || null;
                ngDevMode && ngDevMode.stylingReadPersistedState++;
            }
            _stylingState = _stylingState || {
                classesBitMask: BIT_MASK_START_VALUE,
                classesIndex: STYLING_INDEX_START_VALUE,
                stylesBitMask: BIT_MASK_START_VALUE,
                stylesIndex: STYLING_INDEX_START_VALUE,
            };
        }
        return ( /** @type {?} */(_stylingState));
    }
    /**
     * @return {?}
     */
    function resetStylingState() {
        _stylingState = null;
        _stylingElement = null;
    }
    /**
     * @param {?} element
     * @param {?} state
     * @return {?}
     */
    function storeStylingState(element, state) {
        ngDevMode && ngDevMode.stylingWritePersistedState++;
        _stateStorage.set(element, state);
    }
    /**
     * @param {?} element
     * @return {?}
     */
    function deleteStylingStateFromStorage(element) {
        _stateStorage.delete(element);
    }
    /**
     * @return {?}
     */
    function resetAllStylingState() {
        resetStylingState();
        _stateStorage.clear();
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * This property will be monkey-patched on elements, components and directives
     * @type {?}
     */
    var MONKEY_PATCH_KEY_NAME = '__ngContext__';
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * For efficiency reasons we often put several different data types (`RNode`, `LView`, `LContainer`)
     * in same location in `LView`. This is because we don't want to pre-allocate space for it
     * because the storage is sparse. This file contains utilities for dealing with such data types.
     *
     * How do we know what is stored at a given location in `LView`.
     * - `Array.isArray(value) === false` => `RNode` (The normal storage value)
     * - `Array.isArray(value) === true` => then the `value[0]` represents the wrapped value.
     *   - `typeof value[TYPE] === 'object'` => `LView`
     *      - This happens when we have a component at a given location
     *   - `typeof value[TYPE] === true` => `LContainer`
     *      - This happens when we have `LContainer` binding at a given location.
     *
     *
     * NOTE: it is assumed that `Array.isArray` and `typeof` operations are very efficient.
     */
    /**
     * Returns `RNode`.
     * @param {?} value wrapped value of `RNode`, `LView`, `LContainer`
     * @return {?}
     */
    function unwrapRNode(value) {
        while (Array.isArray(value)) {
            value = ( /** @type {?} */(value[HOST]));
        }
        return ( /** @type {?} */(value));
    }
    /**
     * Retrieve an `RNode` for a given `TNode` and `LView`.
     *
     * This function guarantees in dev mode to retrieve a non-null `RNode`.
     *
     * @param {?} tNode
     * @param {?} lView
     * @return {?}
     */
    function getNativeByTNode(tNode, lView) {
        ngDevMode && assertTNodeForLView(tNode, lView);
        ngDevMode && assertDataInRange(lView, tNode.index);
        /** @type {?} */
        var node = unwrapRNode(lView[tNode.index]);
        ngDevMode && assertDomNode(node);
        return node;
    }
    /**
     * Retrieve an `RNode` or `null` for a given `TNode` and `LView`.
     *
     * Some `TNode`s don't have associated `RNode`s. For example `Projection`
     *
     * @param {?} tNode
     * @param {?} lView
     * @return {?}
     */
    function getNativeByTNodeOrNull(tNode, lView) {
        ngDevMode && assertTNodeForLView(tNode, lView);
        /** @type {?} */
        var index = tNode.index;
        /** @type {?} */
        var node = index == -1 ? null : unwrapRNode(lView[index]);
        ngDevMode && node !== null && assertDomNode(node);
        return node;
    }
    /**
     * @param {?} index
     * @param {?} view
     * @return {?}
     */
    function getTNode(index, view) {
        ngDevMode && assertGreaterThan(index, -1, 'wrong index for TNode');
        ngDevMode && assertLessThan(index, view[TVIEW].data.length, 'wrong index for TNode');
        return ( /** @type {?} */(view[TVIEW].data[index + HEADER_OFFSET]));
    }
    /**
     * @param {?} nodeIndex
     * @param {?} hostView
     * @return {?}
     */
    function getComponentViewByIndex(nodeIndex, hostView) {
        // Could be an LView or an LContainer. If LContainer, unwrap to find LView.
        /** @type {?} */
        var slotValue = hostView[nodeIndex];
        /** @type {?} */
        var lView = isLView(slotValue) ? slotValue : slotValue[HOST];
        return lView;
    }
    /**
     * Returns the monkey-patch value data present on the target (which could be
     * a component, directive or a DOM node).
     * @param {?} target
     * @return {?}
     */
    function readPatchedData(target) {
        ngDevMode && assertDefined(target, 'Target expected');
        return target[MONKEY_PATCH_KEY_NAME];
    }
    /**
     * @param {?} target
     * @return {?}
     */
    function readPatchedLView(target) {
        /** @type {?} */
        var value = readPatchedData(target);
        if (value) {
            return Array.isArray(value) ? value : (( /** @type {?} */(value))).lView;
        }
        return null;
    }
    /**
     * Returns a boolean for whether the view is attached to the change detection tree.
     *
     * Note: This determines whether a view should be checked, not whether it's inserted
     * into a container. For that, you'll want `viewAttachedToContainer` below.
     * @param {?} view
     * @return {?}
     */
    function viewAttachedToChangeDetector(view) {
        return (view[FLAGS] & 128 /* Attached */) === 128 /* Attached */;
    }
    /**
     * Resets the pre-order hook flags of the view.
     * @param {?} lView the LView on which the flags are reset
     * @return {?}
     */
    function resetPreOrderHookFlags(lView) {
        lView[PREORDER_HOOK_FLAGS] = 0;
    }
    /** @type {?} */
    var currentDirectiveDef = null;
    /**
     * @return {?}
     */
    function getCurrentDirectiveDef() {
        // top level variables should not be exported for performance reasons (PERF_NOTES.md)
        return currentDirectiveDef;
    }
    /**
     * @param {?} def
     * @return {?}
     */
    function setCurrentDirectiveDef(def) {
        currentDirectiveDef = def;
    }
    /**
     * @return {?}
     */
    function getLView() {
        return lView;
    }
    /**
     * Used as the starting directive id value.
     *
     * All subsequent directives are incremented from this value onwards.
     * The reason why this value is `1` instead of `0` is because the `0`
     * value is reserved for the template.
     * @type {?}
     */
    var MIN_DIRECTIVE_ID = 1;
    /** @type {?} */
    var activeDirectiveId = MIN_DIRECTIVE_ID;
    /**
     * Position depth (with respect from leaf to root) in a directive sub-class inheritance chain.
     * @type {?}
     */
    var activeDirectiveSuperClassDepthPosition = 0;
    /**
     * Total count of how many directives are a part of an inheritance chain.
     *
     * When directives are sub-classed (extended) from one to another, Angular
     * needs to keep track of exactly how many were encountered so it can accurately
     * generate the next directive id (once the next directive id is visited).
     * Normally the next directive id just a single incremented value from the
     * previous one, however, if the previous directive is a part of an inheritance
     * chain (a series of sub-classed directives) then the incremented value must
     * also take into account the total amount of sub-classed values.
     *
     * Note that this value resets back to zero once the next directive is
     * visited (when `incrementActiveDirectiveId` or `setActiveHostElement`
     * is called).
     * @type {?}
     */
    var activeDirectiveSuperClassHeight = 0;
    /**
     * Sets the active directive host element and resets the directive id value
     * (when the provided elementIndex value has changed).
     *
     * @param {?=} elementIndex the element index value for the host element where
     *                     the directive/component instance lives
     * @return {?}
     */
    function setActiveHostElement(elementIndex) {
        if (elementIndex === void 0) { elementIndex = null; }
        if (_selectedIndex !== elementIndex) {
            setSelectedIndex(elementIndex == null ? -1 : elementIndex);
            activeDirectiveId = elementIndex == null ? 0 : MIN_DIRECTIVE_ID;
            activeDirectiveSuperClassDepthPosition = 0;
            activeDirectiveSuperClassHeight = 0;
        }
    }
    /**
     * Returns the current id value of the current directive.
     *
     * For example we have an element that has two directives on it:
     * <div dir-one dir-two></div>
     *
     * dirOne->hostBindings() (id == 1)
     * dirTwo->hostBindings() (id == 2)
     *
     * Note that this is only active when `hostBinding` functions are being processed.
     *
     * Note that directive id values are specific to an element (this means that
     * the same id value could be present on another element with a completely
     * different set of directives).
     * @return {?}
     */
    function getActiveDirectiveId() {
        return activeDirectiveId;
    }
    /**
     * Increments the current directive id value.
     *
     * For example we have an element that has two directives on it:
     * <div dir-one dir-two></div>
     *
     * dirOne->hostBindings() (index = 1)
     * // increment
     * dirTwo->hostBindings() (index = 2)
     *
     * Depending on whether or not a previous directive had any inherited
     * directives present, that value will be incremented in addition
     * to the id jumping up by one.
     *
     * Note that this is only active when `hostBinding` functions are being processed.
     *
     * Note that directive id values are specific to an element (this means that
     * the same id value could be present on another element with a completely
     * different set of directives).
     * @return {?}
     */
    function incrementActiveDirectiveId() {
        activeDirectiveId += 1 + activeDirectiveSuperClassHeight;
        // because we are dealing with a new directive this
        // means we have exited out of the inheritance chain
        activeDirectiveSuperClassDepthPosition = 0;
        activeDirectiveSuperClassHeight = 0;
    }
    /**
     * Returns he current depth of the super/sub class inheritance chain.
     *
     * This will return how many inherited directive/component classes
     * exist in the current chain.
     *
     * ```typescript
     * \@Directive({ selector: '[super-dir]' })
     * class SuperDir {}
     *  / selector: '[sub-dir]' })
     * class SubDir extends SuperDir {}
     *
     * // if `<div sub-dir>` is used then the super class height is `1`
     * // if `<div super-dir>` is used then the super class height is `0`
     * ```
     * @return {?}
     */
    function getActiveDirectiveSuperClassHeight() {
        return activeDirectiveSuperClassHeight;
    }
    /**
     * Returns the current super class (reverse inheritance) depth for a directive.
     *
     * This is designed to help instruction code distinguish different hostBindings
     * calls from each other when a directive has extended from another directive.
     * Normally using the directive id value is enough, but with the case
     * of parent/sub-class directive inheritance more information is required.
     *
     * Note that this is only active when `hostBinding` functions are being processed.
     * @return {?}
     */
    function getActiveDirectiveSuperClassDepth() {
        return activeDirectiveSuperClassDepthPosition;
    }
    /**
     * Used to set the parent property when nodes are created and track query results.
     * @type {?}
     */
    var previousOrParentTNode;
    /**
     * @return {?}
     */
    function getPreviousOrParentTNode() {
        // top level variables should not be exported for performance reasons (PERF_NOTES.md)
        return previousOrParentTNode;
    }
    /**
     * @param {?} tNode
     * @param {?} _isParent
     * @return {?}
     */
    function setPreviousOrParentTNode(tNode, _isParent) {
        previousOrParentTNode = tNode;
        isParent = _isParent;
    }
    /**
     * @param {?} tNode
     * @param {?} view
     * @return {?}
     */
    function setTNodeAndViewData(tNode, view) {
        ngDevMode && assertLViewOrUndefined(view);
        previousOrParentTNode = tNode;
        lView = view;
    }
    /**
     * If `isParent` is:
     *  - `true`: then `previousOrParentTNode` points to a parent node.
     *  - `false`: then `previousOrParentTNode` points to previous node (sibling).
     * @type {?}
     */
    var isParent;
    /**
     * @return {?}
     */
    function getIsParent() {
        // top level variables should not be exported for performance reasons (PERF_NOTES.md)
        return isParent;
    }
    /**
     * Checks whether a given view is in creation mode
     * @param {?=} view
     * @return {?}
     */
    function isCreationMode(view) {
        if (view === void 0) { view = lView; }
        return (view[FLAGS] & 4 /* CreationMode */) === 4 /* CreationMode */;
    }
    /**
     * State of the current view being processed.
     *
     * An array of nodes (text, element, container, etc), pipes, their bindings, and
     * any local variables that need to be stored between invocations.
     * @type {?}
     */
    var lView;
    /**
     * The last viewData retrieved by nextContext().
     * Allows building nextContext() and reference() calls.
     *
     * e.g. const inner = x().$implicit; const outer = x().$implicit;
     * @type {?}
     */
    var contextLView = ( /** @type {?} */(null));
    /**
     * In this mode, any changes in bindings will throw an ExpressionChangedAfterChecked error.
     *
     * Necessary to support ChangeDetectorRef.checkNoChanges().
     * @type {?}
     */
    var checkNoChangesMode = false;
    /**
     * @return {?}
     */
    function getCheckNoChangesMode() {
        // top level variables should not be exported for performance reasons (PERF_NOTES.md)
        return checkNoChangesMode;
    }
    /**
     * @param {?} mode
     * @return {?}
     */
    function setCheckNoChangesMode(mode) {
        checkNoChangesMode = mode;
    }
    /**
     * The root index from which pure function instructions should calculate their binding
     * indices. In component views, this is TView.bindingStartIndex. In a host binding
     * context, this is the TView.expandoStartIndex + any dirs/hostVars before the given dir.
     * @type {?}
     */
    var bindingRootIndex = -1;
    /**
     * @param {?} value
     * @return {?}
     */
    function setBindingRoot(value) {
        bindingRootIndex = value;
    }
    /**
     * Swap the current state with a new state.
     *
     * For performance reasons we store the state in the top level of the module.
     * This way we minimize the number of properties to read. Whenever a new view
     * is entered we have to store the state for later, and when the view is
     * exited the state has to be restored
     *
     * @param {?} newView New state to become active
     * @param {?} hostTNode
     * @return {?} the previous state;
     */
    function enterView(newView, hostTNode) {
        ngDevMode && assertLViewOrUndefined(newView);
        /** @type {?} */
        var oldView = lView;
        if (newView) {
            /** @type {?} */
            var tView = newView[TVIEW];
            bindingRootIndex = tView.bindingStartIndex;
        }
        previousOrParentTNode = ( /** @type {?} */(hostTNode));
        isParent = true;
        lView = contextLView = newView;
        return oldView;
    }
    /**
     * Resets the application state.
     * @return {?}
     */
    function resetComponentState() {
        isParent = false;
        previousOrParentTNode = ( /** @type {?} */(null));
        setCurrentStyleSanitizer(null);
        resetAllStylingState();
    }
    /**
     * Used in lieu of enterView to make it clear when we are exiting a child view. This makes
     * the direction of traversal (up or down the view tree) a bit clearer.
     *
     * @param {?} newView New state to become active
     * @param {?} safeToRunHooks Whether the runtime is in a state where running lifecycle hooks is valid.
     * This is not always the case (for example, the application may have crashed and `leaveView` is
     * being executed while unwinding the call stack).
     * @return {?}
     */
    function leaveView(newView, safeToRunHooks) {
        /** @type {?} */
        var tView = lView[TVIEW];
        if (isCreationMode(lView)) {
            lView[FLAGS] &= ~4 /* CreationMode */;
        }
        else {
            try {
                resetPreOrderHookFlags(lView);
                safeToRunHooks && executeHooks(lView, tView.viewHooks, tView.viewCheckHooks, checkNoChangesMode, 2 /* AfterViewInitHooksToBeRun */, undefined);
            }
            finally {
                // Views are clean and in update mode after being checked, so these bits are cleared
                lView[FLAGS] &= ~(64 /* Dirty */ | 8 /* FirstLViewPass */);
                lView[BINDING_INDEX] = tView.bindingStartIndex;
            }
        }
        enterView(newView, null);
    }
    /** @type {?} */
    var _selectedIndex = -1;
    /**
     * Gets the most recent index passed to {\@link select}
     *
     * Used with {\@link property} instruction (and more in the future) to identify the index in the
     * current `LView` to act on.
     * @return {?}
     */
    function getSelectedIndex() {
        return _selectedIndex;
    }
    /**
     * Sets the most recent index passed to {\@link select}
     *
     * Used with {\@link property} instruction (and more in the future) to identify the index in the
     * current `LView` to act on.
     * @param {?} index
     * @return {?}
     */
    function setSelectedIndex(index) {
        _selectedIndex = index;
        // we have now jumped to another element
        // therefore the state is stale
        resetStylingState();
    }
    /** @type {?} */
    var _currentNamespace = null;
    /**
     * Sets the namespace used to create elements to `null`, which forces element creation to use
     * `createElement` rather than `createElementNS`.
     * @return {?}
     */
    function namespaceHTMLInternal() {
        _currentNamespace = null;
    }
    /**
     * @return {?}
     */
    function getNamespace() {
        return _currentNamespace;
    }
    /** @type {?} */
    var _currentSanitizer;
    /**
     * @param {?} sanitizer
     * @return {?}
     */
    function setCurrentStyleSanitizer(sanitizer) {
        _currentSanitizer = sanitizer;
    }
    /**
     * @return {?}
     */
    function getCurrentStyleSanitizer() {
        return _currentSanitizer;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Returns whether the values are different from a change detection stand point.
     *
     * Constraints are relaxed in checkNoChanges mode. See `devModeEqual` for details.
     * @param {?} a
     * @param {?} b
     * @return {?}
     */
    function isDifferent(a, b) {
        // NaN is the only value that is not equal to itself so the first
        // test checks if both a and b are not NaN
        return !(a !== a && b !== b) && a !== b;
    }
    /**
     * Used for stringify render output in Ivy.
     * Important! This function is very performance-sensitive and we should
     * be extra careful not to introduce megamorphic reads in it.
     * @param {?} value
     * @return {?}
     */
    function renderStringify(value) {
        if (typeof value === 'string')
            return value;
        if (value == null)
            return '';
        return '' + value;
    }
    /**
     * Used to stringify a value so that it can be displayed in an error message.
     * Important! This function contains a megamorphic read and should only be
     * used for error messages.
     * @param {?} value
     * @return {?}
     */
    function stringifyForError(value) {
        if (typeof value === 'function')
            return value.name || value.toString();
        if (typeof value === 'object' && value != null && typeof value.type === 'function') {
            return value.type.name || value.type.toString();
        }
        return renderStringify(value);
    }
    var ɵ0$2 = /**
     * @return {?}
     */ function () { return (typeof requestAnimationFrame !== 'undefined' && requestAnimationFrame || // browser only
        setTimeout // everything else
    ).bind(_global); };
    /** @type {?} */
    var defaultScheduler = ((ɵ0$2))();
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var MAP_BASED_ENTRY_PROP_NAME = '--MAP--';
    /** @type {?} */
    var TEMPLATE_DIRECTIVE_INDEX = 0;
    /**
     * Creates a new instance of the `TStylingContext`.
     *
     * The `TStylingContext` is used as a manifest of all style or all class bindings on
     * an element. Because it is a T-level data-structure, it is only created once per
     * tNode for styles and for classes. This function allocates a new instance of a
     * `TStylingContext` with the initial values (see `interfaces.ts` for more info).
     * @param {?=} initialStyling
     * @return {?}
     */
    function allocTStylingContext(initialStyling) {
        // because map-based bindings deal with a dynamic set of values, there
        // is no way to know ahead of time whether or not sanitization is required.
        // For this reason the configuration will always mark sanitization as active
        // (this means that when map-based values are applied then sanitization will
        // be checked against each property).
        /** @type {?} */
        var mapBasedConfig = 1 /* SanitizationRequired */;
        return [
            initialStyling || [''],
            0 /* Initial */,
            TEMPLATE_DIRECTIVE_INDEX,
            mapBasedConfig,
            0,
            MAP_BASED_ENTRY_PROP_NAME,
        ];
    }
    /**
     * Sets the provided directive as the last directive index in the provided `TStylingContext`.
     *
     * Styling in Angular can be applied from the template as well as multiple sources of
     * host bindings. This means that each binding function (the template function or the
     * hostBindings functions) will generate styling instructions as well as a styling
     * apply function (i.e. `stylingApply()`). Because host bindings functions and the
     * template function are independent from one another this means that the styling apply
     * function will be called multiple times. By tracking the last directive index (which
     * is what happens in this function) the styling algorithm knows exactly when to flush
     * styling (which is when the last styling apply function is executed).
     * @param {?} context
     * @param {?} lastDirectiveIndex
     * @return {?}
     */
    function updateLastDirectiveIndex(context, lastDirectiveIndex) {
        if (lastDirectiveIndex === TEMPLATE_DIRECTIVE_INDEX) {
            /** @type {?} */
            var currentValue = context[2 /* LastDirectiveIndexPosition */];
            if (currentValue > TEMPLATE_DIRECTIVE_INDEX) {
                // This means that a directive or two contained a host bindings function, but
                // now the template function also contains styling. When this combination of sources
                // comes up then we need to tell the context to store the state between updates
                // (because host bindings evaluation happens after template binding evaluation).
                markContextToPersistState(context);
            }
        }
        else {
            context[2 /* LastDirectiveIndexPosition */] = lastDirectiveIndex;
        }
    }
    /**
     * @param {?} context
     * @return {?}
     */
    function getConfig(context) {
        return context[1 /* ConfigPosition */];
    }
    /**
     * @param {?} context
     * @param {?} value
     * @return {?}
     */
    function setConfig(context, value) {
        context[1 /* ConfigPosition */] = value;
    }
    /**
     * @param {?} context
     * @param {?} index
     * @return {?}
     */
    function getProp(context, index) {
        return ( /** @type {?} */(context[index + 2 /* PropOffset */]));
    }
    /**
     * @param {?} context
     * @param {?} index
     * @return {?}
     */
    function getPropConfig(context, index) {
        return (( /** @type {?} */(context[index + 0 /* ConfigAndGuardOffset */]))) &
            1 /* Mask */;
    }
    /**
     * @param {?} context
     * @param {?} index
     * @return {?}
     */
    function isSanitizationRequired(context, index) {
        return (getPropConfig(context, index) & 1 /* SanitizationRequired */) > 0;
    }
    /**
     * @param {?} context
     * @param {?} index
     * @return {?}
     */
    function getGuardMask(context, index) {
        /** @type {?} */
        var configGuardValue = ( /** @type {?} */(context[index + 0 /* ConfigAndGuardOffset */]));
        return configGuardValue >> 1 /* TotalBits */;
    }
    /**
     * @param {?} context
     * @param {?} index
     * @param {?} maskValue
     * @return {?}
     */
    function setGuardMask(context, index, maskValue) {
        /** @type {?} */
        var config = getPropConfig(context, index);
        /** @type {?} */
        var guardMask = maskValue << 1 /* TotalBits */;
        context[index + 0 /* ConfigAndGuardOffset */] = config | guardMask;
    }
    /**
     * @param {?} context
     * @param {?} index
     * @return {?}
     */
    function getValuesCount(context, index) {
        return ( /** @type {?} */(context[index + 1 /* ValuesCountOffset */]));
    }
    /**
     * @param {?} context
     * @param {?} index
     * @param {?} offset
     * @return {?}
     */
    function getBindingValue(context, index, offset) {
        return ( /** @type {?} */(context[index + 3 /* BindingsStartOffset */ + offset]));
    }
    /**
     * @param {?} context
     * @param {?} index
     * @return {?}
     */
    function getDefaultValue(context, index) {
        /** @type {?} */
        var valuesCount = getValuesCount(context, index);
        return ( /** @type {?} */(context[index + 3 /* BindingsStartOffset */ + valuesCount - 1]));
    }
    /**
     * Temporary function which determines whether or not a context is
     * allowed to be flushed based on the provided directive index.
     * @param {?} context
     * @param {?} index
     * @return {?}
     */
    function allowStylingFlush(context, index) {
        return (context && index === context[2 /* LastDirectiveIndexPosition */]) ? true :
            false;
    }
    /**
     * @param {?} context
     * @return {?}
     */
    function lockContext(context) {
        setConfig(context, getConfig(context) | 1 /* Locked */);
    }
    /**
     * @param {?} context
     * @return {?}
     */
    function isContextLocked(context) {
        return (getConfig(context) & 1 /* Locked */) > 0;
    }
    /**
     * @param {?} context
     * @return {?}
     */
    function stateIsPersisted(context) {
        return (getConfig(context) & 2 /* PersistStateValues */) > 0;
    }
    /**
     * @param {?} context
     * @return {?}
     */
    function markContextToPersistState(context) {
        setConfig(context, getConfig(context) | 2 /* PersistStateValues */);
    }
    /**
     * @param {?} context
     * @return {?}
     */
    function getPropValuesStartPosition(context) {
        return 6 /* MapBindingsBindingsStartPosition */ +
            context[4 /* MapBindingsValuesCountPosition */];
    }
    /**
     * @param {?} a
     * @param {?} b
     * @return {?}
     */
    function hasValueChanged(a, b) {
        /** @type {?} */
        var compareValueA = Array.isArray(a) ? a[0 /* RawValuePosition */] : a;
        /** @type {?} */
        var compareValueB = Array.isArray(b) ? b[0 /* RawValuePosition */] : b;
        // these are special cases for String based values (which are created as artifacts
        // when sanitization is bypassed on a particular value)
        if (compareValueA instanceof String) {
            compareValueA = compareValueA.toString();
        }
        if (compareValueB instanceof String) {
            compareValueB = compareValueB.toString();
        }
        return isDifferent(compareValueA, compareValueB);
    }
    /**
     * Determines whether the provided styling value is truthy or falsy.
     * @param {?} value
     * @return {?}
     */
    function isStylingValueDefined(value) {
        // the reason why null is compared against is because
        // a CSS class value that is set to `false` must be
        // respected (otherwise it would be treated as falsy).
        // Empty string values are because developers usually
        // set a value to an empty string to remove it.
        return value != null && value !== '';
    }
    /**
     * @param {?} a
     * @param {?} b
     * @param {?=} separator
     * @return {?}
     */
    function concatString(a, b, separator) {
        if (separator === void 0) { separator = ' '; }
        return a + ((b.length && a.length) ? separator : '') + b;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    function hyphenate(value) {
        return value.replace(/[a-z][A-Z]/g, ( /**
         * @param {?} v
         * @return {?}
         */function (/**
         * @param {?} v
         * @return {?}
         */ v) { return v.charAt(0) + '-' + v.charAt(1); })).toLowerCase();
    }
    /**
     * Returns an instance of `StylingMapArray`.
     *
     * This function is designed to find an instance of `StylingMapArray` in case it is stored
     * inside of an instance of `TStylingContext`. When a styling context is created it
     * will copy over an initial styling values from the tNode (which are stored as a
     * `StylingMapArray` on the `tNode.classes` or `tNode.styles` values).
     * @param {?} value
     * @return {?}
     */
    function getStylingMapArray(value) {
        return isStylingContext(value) ?
            (( /** @type {?} */(value)))[0 /* InitialStylingValuePosition */] :
            value;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    function isStylingContext(value) {
        // the StylingMapArray is in the format of [initial, prop, string, prop, string]
        // and this is the defining value to distinguish between arrays
        return Array.isArray(value) &&
            value.length >= 6 /* MapBindingsBindingsStartPosition */ &&
            typeof value[1] !== 'string';
    }
    /**
     * @param {?} context
     * @return {?}
     */
    function getInitialStylingValue(context) {
        /** @type {?} */
        var map = getStylingMapArray(context);
        return map && (( /** @type {?} */(map[0 /* RawValuePosition */]))) || '';
    }
    /**
     * @param {?} tNode
     * @return {?}
     */
    function hasClassInput(tNode) {
        return (tNode.flags & 8 /* hasClassInput */) !== 0;
    }
    /**
     * @param {?} tNode
     * @return {?}
     */
    function hasStyleInput(tNode) {
        return (tNode.flags & 16 /* hasStyleInput */) !== 0;
    }
    /**
     * @param {?} map
     * @param {?} index
     * @return {?}
     */
    function getMapProp(map, index) {
        return ( /** @type {?} */(map[index + 0 /* PropOffset */]));
    }
    /**
     * @param {?} map
     * @param {?} index
     * @param {?} value
     * @return {?}
     */
    function setMapValue(map, index, value) {
        map[index + 1 /* ValueOffset */] = value;
    }
    /**
     * @param {?} map
     * @param {?} index
     * @return {?}
     */
    function getMapValue(map, index) {
        return ( /** @type {?} */(map[index + 1 /* ValueOffset */]));
    }
    /**
     * @param {?} classes
     * @return {?}
     */
    function forceClassesAsString(classes) {
        if (classes && typeof classes !== 'string') {
            classes = Object.keys(classes).join(' ');
        }
        return (( /** @type {?} */(classes))) || '';
    }
    /**
     * @param {?} styles
     * @return {?}
     */
    function forceStylesAsString(styles) {
        /** @type {?} */
        var str = '';
        if (styles) {
            /** @type {?} */
            var props_1 = Object.keys(styles);
            for (var i_18 = 0; i_18 < props_1.length; i_18++) {
                /** @type {?} */
                var prop = props_1[i_18];
                str = concatString(str, prop + ":" + styles[prop], ';');
            }
        }
        return str;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * The goal here is to make sure that the browser DOM API is the Renderer.
     * We do this by defining a subset of DOM API to be the renderer and than
     * use that time for rendering.
     *
     * At runtime we can then use the DOM api directly, in server or web-worker
     * it will be easy to implement such API.
     */
    /** @enum {number} */
    var RendererStyleFlags3 = {
        Important: 1,
        DashCase: 2,
    };
    RendererStyleFlags3[RendererStyleFlags3.Important] = 'Important';
    RendererStyleFlags3[RendererStyleFlags3.DashCase] = 'DashCase';
    /**
     * Returns whether the `renderer` is a `ProceduralRenderer3`
     * @param {?} renderer
     * @return {?}
     */
    function isProceduralRenderer(renderer) {
        return !!((( /** @type {?} */(renderer))).listen);
    }
    var ɵ0$3 = /**
     * @param {?} hostElement
     * @param {?} rendererType
     * @return {?}
     */ function (hostElement, rendererType) { return document; };
    /** @type {?} */
    var domRendererFactory3 = {
        createRenderer: (ɵ0$3)
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /// Parent Injector Utils ///////////////////////////////////////////////////////////////
    /**
     * @param {?} parentLocation
     * @return {?}
     */
    function hasParentInjector(parentLocation) {
        return parentLocation !== NO_PARENT_INJECTOR;
    }
    /**
     * @param {?} parentLocation
     * @return {?}
     */
    function getParentInjectorIndex(parentLocation) {
        return (( /** @type {?} */(( /** @type {?} */(parentLocation))))) & 32767 /* InjectorIndexMask */;
    }
    /**
     * @param {?} parentLocation
     * @return {?}
     */
    function getParentInjectorViewOffset(parentLocation) {
        return (( /** @type {?} */(( /** @type {?} */(parentLocation))))) >> 16 /* ViewOffsetShift */;
    }
    /**
     * Unwraps a parent injector location number to find the view offset from the current injector,
     * then walks up the declaration view tree until the view is found that contains the parent
     * injector.
     *
     * @param {?} location The location of the parent injector, which contains the view offset
     * @param {?} startView The LView instance from which to start walking up the view tree
     * @return {?} The LView instance that contains the parent injector
     */
    function getParentInjectorView(location, startView) {
        /** @type {?} */
        var viewOffset = getParentInjectorViewOffset(location);
        /** @type {?} */
        var parentView = startView;
        // For most cases, the parent injector can be found on the host node (e.g. for component
        // or container), but we must keep the loop here to support the rarer case of deeply nested
        // <ng-template> tags or inline views, where the parent injector might live many views
        // above the child injector.
        while (viewOffset > 0) {
            parentView = ( /** @type {?} */(parentView[DECLARATION_VIEW]));
            viewOffset--;
        }
        return parentView;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Gets the parent LView of the passed LView, if the PARENT is an LContainer, will get the parent of
     * that LContainer, which is an LView
     * @param {?} lView the lView whose parent to get
     * @return {?}
     */
    function getLViewParent(lView) {
        ngDevMode && assertLView(lView);
        /** @type {?} */
        var parent = lView[PARENT];
        return isLContainer(parent) ? ( /** @type {?} */(parent[PARENT])) : parent;
    }
    /**
     * Retrieve the root view from any component or `LView` by walking the parent `LView` until
     * reaching the root `LView`.
     *
     * @param {?} componentOrLView any component or `LView`
     * @return {?}
     */
    function getRootView(componentOrLView) {
        ngDevMode && assertDefined(componentOrLView, 'component');
        /** @type {?} */
        var lView = isLView(componentOrLView) ? componentOrLView : ( /** @type {?} */(readPatchedLView(componentOrLView)));
        while (lView && !(lView[FLAGS] & 512 /* IsRoot */)) {
            lView = ( /** @type {?} */(getLViewParent(lView)));
        }
        ngDevMode && assertLView(lView);
        return lView;
    }
    /**
     * Given an `LView`, find the closest declaration view which is not an embedded view.
     *
     * This method searches for the `LView` associated with the component which declared the `LView`.
     *
     * This function may return itself if the `LView` passed in is not an embedded `LView`. Otherwise
     * it walks the declaration parents until it finds a component view (non-embedded-view.)
     *
     * @param {?} lView LView for which we want a host element node
     * @return {?} The host node
     */
    function findComponentView(lView) {
        /** @type {?} */
        var rootTNode = lView[T_HOST];
        while (rootTNode !== null && rootTNode.type === 2 /* View */) {
            ngDevMode && assertDefined(lView[DECLARATION_VIEW], 'lView[DECLARATION_VIEW]');
            lView = ( /** @type {?} */(lView[DECLARATION_VIEW]));
            rootTNode = lView[T_HOST];
        }
        ngDevMode && assertLView(lView);
        return lView;
    }
    /**
     * Returns the `RootContext` instance that is associated with
     * the application where the target is situated. It does this by walking the parent views until it
     * gets to the root view, then getting the context off of that.
     *
     * @param {?} viewOrComponent the `LView` or component to get the root context for.
     * @return {?}
     */
    function getRootContext(viewOrComponent) {
        /** @type {?} */
        var rootView = getRootView(viewOrComponent);
        ngDevMode &&
            assertDefined(rootView[CONTEXT], 'RootView has no context. Perhaps it is disconnected?');
        return ( /** @type {?} */(rootView[CONTEXT]));
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Defines if the call to `inject` should include `viewProviders` in its resolution.
     *
     * This is set to true when we try to instantiate a component. This value is reset in
     * `getNodeInjectable` to a value which matches the declaration location of the token about to be
     * instantiated. This is done so that if we are injecting a token which was declared outside of
     * `viewProviders` we don't accidentally pull `viewProviders` in.
     *
     * Example:
     *
     * ```
     * \@Injectable()
     * class MyService {
     *   constructor(public value: String) {}
     * }
     *
     * \@Component({
     *   providers: [
     *     MyService,
     *     {provide: String, value: 'providers' }
     *   ]
     *   viewProviders: [
     *     {provide: String, value: 'viewProviders'}
     *   ]
     * })
     * class MyComponent {
     *   constructor(myService: MyService, value: String) {
     *     // We expect that Component can see into `viewProviders`.
     *     expect(value).toEqual('viewProviders');
     *     // `MyService` was not declared in `viewProviders` hence it can't see it.
     *     expect(myService.value).toEqual('providers');
     *   }
     * }
     *
     * ```
     * @type {?}
     */
    var includeViewProviders = true;
    /**
     * @param {?} v
     * @return {?}
     */
    function setIncludeViewProviders(v) {
        /** @type {?} */
        var oldValue = includeViewProviders;
        includeViewProviders = v;
        return oldValue;
    }
    /**
     * The number of slots in each bloom filter (used by DI). The larger this number, the fewer
     * directives that will share slots, and thus, the fewer false positives when checking for
     * the existence of a directive.
     * @type {?}
     */
    var BLOOM_SIZE = 256;
    /** @type {?} */
    var BLOOM_MASK = BLOOM_SIZE - 1;
    /**
     * Counter used to generate unique IDs for directives.
     * @type {?}
     */
    var nextNgElementId = 0;
    /**
     * Registers this directive as present in its node's injector by flipping the directive's
     * corresponding bit in the injector's bloom filter.
     *
     * @param {?} injectorIndex The index of the node injector where this token should be registered
     * @param {?} tView The TView for the injector's bloom filters
     * @param {?} type The directive token to register
     * @return {?}
     */
    function bloomAdd(injectorIndex, tView, type) {
        ngDevMode && assertEqual(tView.firstTemplatePass, true, 'expected firstTemplatePass to be true');
        /** @type {?} */
        var id = typeof type !== 'string' ? (( /** @type {?} */(type)))[NG_ELEMENT_ID] : type.charCodeAt(0) || 0;
        // Set a unique ID on the directive type, so if something tries to inject the directive,
        // we can easily retrieve the ID and hash it into the bloom bit that should be checked.
        if (id == null) {
            id = (( /** @type {?} */(type)))[NG_ELEMENT_ID] = nextNgElementId++;
        }
        // We only have BLOOM_SIZE (256) slots in our bloom filter (8 buckets * 32 bits each),
        // so all unique IDs must be modulo-ed into a number from 0 - 255 to fit into the filter.
        /** @type {?} */
        var bloomBit = id & BLOOM_MASK;
        // Create a mask that targets the specific bit associated with the directive.
        // JS bit operations are 32 bits, so this will be a number between 2^0 and 2^31, corresponding
        // to bit positions 0 - 31 in a 32 bit integer.
        /** @type {?} */
        var mask = 1 << bloomBit;
        // Use the raw bloomBit number to determine which bloom filter bucket we should check
        // e.g: bf0 = [0 - 31], bf1 = [32 - 63], bf2 = [64 - 95], bf3 = [96 - 127], etc
        /** @type {?} */
        var b7 = bloomBit & 0x80;
        /** @type {?} */
        var b6 = bloomBit & 0x40;
        /** @type {?} */
        var b5 = bloomBit & 0x20;
        /** @type {?} */
        var tData = ( /** @type {?} */(tView.data));
        if (b7) {
            b6 ? (b5 ? (tData[injectorIndex + 7] |= mask) : (tData[injectorIndex + 6] |= mask)) :
                (b5 ? (tData[injectorIndex + 5] |= mask) : (tData[injectorIndex + 4] |= mask));
        }
        else {
            b6 ? (b5 ? (tData[injectorIndex + 3] |= mask) : (tData[injectorIndex + 2] |= mask)) :
                (b5 ? (tData[injectorIndex + 1] |= mask) : (tData[injectorIndex] |= mask));
        }
    }
    /**
     * Creates (or gets an existing) injector for a given element or container.
     *
     * @param {?} tNode for which an injector should be retrieved / created.
     * @param {?} hostView View where the node is stored
     * @return {?} Node injector
     */
    function getOrCreateNodeInjectorForNode(tNode, hostView) {
        /** @type {?} */
        var existingInjectorIndex = getInjectorIndex(tNode, hostView);
        if (existingInjectorIndex !== -1) {
            return existingInjectorIndex;
        }
        /** @type {?} */
        var tView = hostView[TVIEW];
        if (tView.firstTemplatePass) {
            tNode.injectorIndex = hostView.length;
            insertBloom(tView.data, tNode); // foundation for node bloom
            insertBloom(hostView, null); // foundation for cumulative bloom
            insertBloom(tView.blueprint, null);
            ngDevMode && assertEqual(tNode.flags === 0 || tNode.flags === 1 /* isComponent */, true, 'expected tNode.flags to not be initialized');
        }
        /** @type {?} */
        var parentLoc = getParentInjectorLocation(tNode, hostView);
        /** @type {?} */
        var parentIndex = getParentInjectorIndex(parentLoc);
        /** @type {?} */
        var parentLView = getParentInjectorView(parentLoc, hostView);
        /** @type {?} */
        var injectorIndex = tNode.injectorIndex;
        // If a parent injector can't be found, its location is set to -1.
        // In that case, we don't need to set up a cumulative bloom
        if (hasParentInjector(parentLoc)) {
            /** @type {?} */
            var parentData = ( /** @type {?} */(parentLView[TVIEW].data));
            // Creates a cumulative bloom filter that merges the parent's bloom filter
            // and its own cumulative bloom (which contains tokens for all ancestors)
            for (var i_19 = 0; i_19 < 8; i_19++) {
                hostView[injectorIndex + i_19] = parentLView[parentIndex + i_19] | parentData[parentIndex + i_19];
            }
        }
        hostView[injectorIndex + PARENT_INJECTOR] = parentLoc;
        return injectorIndex;
    }
    /**
     * @param {?} arr
     * @param {?} footer
     * @return {?}
     */
    function insertBloom(arr, footer) {
        arr.push(0, 0, 0, 0, 0, 0, 0, 0, footer);
    }
    /**
     * @param {?} tNode
     * @param {?} hostView
     * @return {?}
     */
    function getInjectorIndex(tNode, hostView) {
        if (tNode.injectorIndex === -1 ||
            // If the injector index is the same as its parent's injector index, then the index has been
            // copied down from the parent node. No injector has been created yet on this node.
            (tNode.parent && tNode.parent.injectorIndex === tNode.injectorIndex) ||
            // After the first template pass, the injector index might exist but the parent values
            // might not have been calculated yet for this instance
            hostView[tNode.injectorIndex + PARENT_INJECTOR] == null) {
            return -1;
        }
        else {
            return tNode.injectorIndex;
        }
    }
    /**
     * Finds the index of the parent injector, with a view offset if applicable. Used to set the
     * parent injector initially.
     *
     * Returns a combination of number of `ViewData` we have to go up and index in that `Viewdata`
     * @param {?} tNode
     * @param {?} view
     * @return {?}
     */
    function getParentInjectorLocation(tNode, view) {
        if (tNode.parent && tNode.parent.injectorIndex !== -1) {
            return ( /** @type {?} */(tNode.parent.injectorIndex)); // ViewOffset is 0
        }
        // For most cases, the parent injector index can be found on the host node (e.g. for component
        // or container), so this loop will be skipped, but we must keep the loop here to support
        // the rarer case of deeply nested <ng-template> tags or inline views.
        /** @type {?} */
        var hostTNode = view[T_HOST];
        /** @type {?} */
        var viewOffset = 1;
        while (hostTNode && hostTNode.injectorIndex === -1) {
            view = ( /** @type {?} */(view[DECLARATION_VIEW]));
            hostTNode = view ? view[T_HOST] : null;
            viewOffset++;
        }
        return hostTNode ?
            hostTNode.injectorIndex | (viewOffset << 16 /* ViewOffsetShift */) :
            ( /** @type {?} */(-1));
    }
    /**
     * Makes a type or an injection token public to the DI system by adding it to an
     * injector's bloom filter.
     *
     * @param {?} injectorIndex
     * @param {?} tView
     * @param {?} token The type or the injection token to be made public
     * @return {?}
     */
    function diPublicInInjector(injectorIndex, tView, token) {
        bloomAdd(injectorIndex, tView, token);
    }
    /**
     * Returns the value associated to the given token from the NodeInjectors => ModuleInjector.
     *
     * Look for the injector providing the token by walking up the node injector tree and then
     * the module injector tree.
     *
     * This function patches `token` with `__NG_ELEMENT_ID__` which contains the id for the bloom
     * filter. Negative values are reserved for special objects.
     *   - `-1` is reserved for injecting `Injector` (implemented by `NodeInjector`)
     *
     * @template T
     * @param {?} tNode The Node where the search for the injector should start
     * @param {?} lView The `LView` that contains the `tNode`
     * @param {?} token The token to look for
     * @param {?=} flags Injection flags
     * @param {?=} notFoundValue The value to return when the injection flags is `InjectFlags.Optional`
     * @return {?} the value from the injector, `null` when not found, or `notFoundValue` if provided
     */
    function getOrCreateInjectable(tNode, lView, token, flags, notFoundValue) {
        if (flags === void 0) { flags = InjectFlags.Default; }
        if (tNode) {
            /** @type {?} */
            var bloomHash = bloomHashBitOrFactory(token);
            // If the ID stored here is a function, this is a special object like ElementRef or TemplateRef
            // so just call the factory function to create it.
            if (typeof bloomHash === 'function') {
                /** @type {?} */
                var savePreviousOrParentTNode = getPreviousOrParentTNode();
                /** @type {?} */
                var saveLView = getLView();
                setTNodeAndViewData(tNode, lView);
                try {
                    /** @type {?} */
                    var value = bloomHash();
                    if (value == null && !(flags & InjectFlags.Optional)) {
                        throw new Error("No provider for " + stringifyForError(token) + "!");
                    }
                    else {
                        return value;
                    }
                }
                finally {
                    setTNodeAndViewData(savePreviousOrParentTNode, saveLView);
                }
            }
            else if (typeof bloomHash == 'number') {
                if (bloomHash === -1) {
                    // `-1` is a special value used to identify `Injector` types.
                    return ( /** @type {?} */(new NodeInjector(tNode, lView)));
                }
                // If the token has a bloom hash, then it is a token which could be in NodeInjector.
                // A reference to the previous injector TView that was found while climbing the element
                // injector tree. This is used to know if viewProviders can be accessed on the current
                // injector.
                /** @type {?} */
                var previousTView = null;
                /** @type {?} */
                var injectorIndex = getInjectorIndex(tNode, lView);
                /** @type {?} */
                var parentLocation = NO_PARENT_INJECTOR;
                /** @type {?} */
                var hostTElementNode = flags & InjectFlags.Host ? findComponentView(lView)[T_HOST] : null;
                // If we should skip this injector, or if there is no injector on this node, start by
                // searching
                // the parent injector.
                if (injectorIndex === -1 || flags & InjectFlags.SkipSelf) {
                    parentLocation = injectorIndex === -1 ? getParentInjectorLocation(tNode, lView) :
                        lView[injectorIndex + PARENT_INJECTOR];
                    if (!shouldSearchParent(flags, false)) {
                        injectorIndex = -1;
                    }
                    else {
                        previousTView = lView[TVIEW];
                        injectorIndex = getParentInjectorIndex(parentLocation);
                        lView = getParentInjectorView(parentLocation, lView);
                    }
                }
                // Traverse up the injector tree until we find a potential match or until we know there
                // *isn't* a match.
                while (injectorIndex !== -1) {
                    parentLocation = lView[injectorIndex + PARENT_INJECTOR];
                    // Check the current injector. If it matches, see if it contains token.
                    /** @type {?} */
                    var tView = lView[TVIEW];
                    if (bloomHasToken(bloomHash, injectorIndex, tView.data)) {
                        // At this point, we have an injector which *may* contain the token, so we step through
                        // the providers and directives associated with the injector's corresponding node to get
                        // the instance.
                        /** @type {?} */
                        var instance = searchTokensOnInjector(injectorIndex, lView, token, previousTView, flags, hostTElementNode);
                        if (instance !== NOT_FOUND) {
                            return instance;
                        }
                    }
                    if (shouldSearchParent(flags, lView[TVIEW].data[injectorIndex + TNODE] === hostTElementNode) &&
                        bloomHasToken(bloomHash, injectorIndex, lView)) {
                        // The def wasn't found anywhere on this node, so it was a false positive.
                        // Traverse up the tree and continue searching.
                        previousTView = tView;
                        injectorIndex = getParentInjectorIndex(parentLocation);
                        lView = getParentInjectorView(parentLocation, lView);
                    }
                    else {
                        // If we should not search parent OR If the ancestor bloom filter value does not have the
                        // bit corresponding to the directive we can give up on traversing up to find the specific
                        // injector.
                        injectorIndex = -1;
                    }
                }
            }
        }
        if (flags & InjectFlags.Optional && notFoundValue === undefined) {
            // This must be set or the NullInjector will throw for optional deps
            notFoundValue = null;
        }
        if ((flags & (InjectFlags.Self | InjectFlags.Host)) === 0) {
            /** @type {?} */
            var moduleInjector = lView[INJECTOR$1];
            // switch to `injectInjectorOnly` implementation for module injector, since module injector
            // should not have access to Component/Directive DI scope (that may happen through
            // `directiveInject` implementation)
            /** @type {?} */
            var previousInjectImplementation = setInjectImplementation(undefined);
            try {
                if (moduleInjector) {
                    return moduleInjector.get(token, notFoundValue, flags & InjectFlags.Optional);
                }
                else {
                    return injectRootLimpMode(token, notFoundValue, flags & InjectFlags.Optional);
                }
            }
            finally {
                setInjectImplementation(previousInjectImplementation);
            }
        }
        if (flags & InjectFlags.Optional) {
            return notFoundValue;
        }
        else {
            throw new Error("NodeInjector: NOT_FOUND [" + stringifyForError(token) + "]");
        }
    }
    /** @type {?} */
    var NOT_FOUND = {};
    /**
     * @template T
     * @param {?} injectorIndex
     * @param {?} lView
     * @param {?} token
     * @param {?} previousTView
     * @param {?} flags
     * @param {?} hostTElementNode
     * @return {?}
     */
    function searchTokensOnInjector(injectorIndex, lView, token, previousTView, flags, hostTElementNode) {
        /** @type {?} */
        var currentTView = lView[TVIEW];
        /** @type {?} */
        var tNode = ( /** @type {?} */(currentTView.data[injectorIndex + TNODE]));
        // First, we need to determine if view providers can be accessed by the starting element.
        // There are two possibities
        /** @type {?} */
        var canAccessViewProviders = previousTView == null ?
            // 1) This is the first invocation `previousTView == null` which means that we are at the
            // `TNode` of where injector is starting to look. In such a case the only time we are allowed
            // to look into the ViewProviders is if:
            // - we are on a component
            // - AND the injector set `includeViewProviders` to true (implying that the token can see
            // ViewProviders because it is the Component or a Service which itself was declared in
            // ViewProviders)
            (isComponent(tNode) && includeViewProviders) :
            // 2) `previousTView != null` which means that we are now walking across the parent nodes.
            // In such a case we are only allowed to look into the ViewProviders if:
            // - We just crossed from child View to Parent View `previousTView != currentTView`
            // - AND the parent TNode is an Element.
            // This means that we just came from the Component's View and therefore are allowed to see
            // into the ViewProviders.
            (previousTView != currentTView && (tNode.type === 3 /* Element */));
        // This special case happens when there is a @host on the inject and when we are searching
        // on the host element node.
        /** @type {?} */
        var isHostSpecialCase = (flags & InjectFlags.Host) && hostTElementNode === tNode;
        /** @type {?} */
        var injectableIdx = locateDirectiveOrProvider(tNode, currentTView, token, canAccessViewProviders, isHostSpecialCase);
        if (injectableIdx !== null) {
            return getNodeInjectable(currentTView.data, lView, injectableIdx, ( /** @type {?} */(tNode)));
        }
        else {
            return NOT_FOUND;
        }
    }
    /**
     * Searches for the given token among the node's directives and providers.
     *
     * @template T
     * @param {?} tNode TNode on which directives are present.
     * @param {?} tView The tView we are currently processing
     * @param {?} token Provider token or type of a directive to look for.
     * @param {?} canAccessViewProviders Whether view providers should be considered.
     * @param {?} isHostSpecialCase Whether the host special case applies.
     * @return {?} Index of a found directive or provider, or null when none found.
     */
    function locateDirectiveOrProvider(tNode, tView, token, canAccessViewProviders, isHostSpecialCase) {
        /** @type {?} */
        var nodeProviderIndexes = tNode.providerIndexes;
        /** @type {?} */
        var tInjectables = tView.data;
        /** @type {?} */
        var injectablesStart = nodeProviderIndexes & 65535 /* ProvidersStartIndexMask */;
        /** @type {?} */
        var directivesStart = tNode.directiveStart;
        /** @type {?} */
        var directiveEnd = tNode.directiveEnd;
        /** @type {?} */
        var cptViewProvidersCount = nodeProviderIndexes >> 16 /* CptViewProvidersCountShift */;
        /** @type {?} */
        var startingIndex = canAccessViewProviders ? injectablesStart : injectablesStart + cptViewProvidersCount;
        // When the host special case applies, only the viewProviders and the component are visible
        /** @type {?} */
        var endIndex = isHostSpecialCase ? injectablesStart + cptViewProvidersCount : directiveEnd;
        for (var i_20 = startingIndex; i_20 < endIndex; i_20++) {
            /** @type {?} */
            var providerTokenOrDef = ( /** @type {?} */(tInjectables[i_20]));
            if (i_20 < directivesStart && token === providerTokenOrDef ||
                i_20 >= directivesStart && (( /** @type {?} */(providerTokenOrDef))).type === token) {
                return i_20;
            }
        }
        if (isHostSpecialCase) {
            /** @type {?} */
            var dirDef = ( /** @type {?} */(tInjectables[directivesStart]));
            if (dirDef && isComponentDef(dirDef) && dirDef.type === token) {
                return directivesStart;
            }
        }
        return null;
    }
    /**
     * Retrieve or instantiate the injectable from the `lData` at particular `index`.
     *
     * This function checks to see if the value has already been instantiated and if so returns the
     * cached `injectable`. Otherwise if it detects that the value is still a factory it
     * instantiates the `injectable` and caches the value.
     * @param {?} tData
     * @param {?} lData
     * @param {?} index
     * @param {?} tNode
     * @return {?}
     */
    function getNodeInjectable(tData, lData, index, tNode) {
        /** @type {?} */
        var value = lData[index];
        if (isFactory(value)) {
            /** @type {?} */
            var factory = value;
            if (factory.resolving) {
                throw new Error("Circular dep for " + stringifyForError(tData[index]));
            }
            /** @type {?} */
            var previousIncludeViewProviders = setIncludeViewProviders(factory.canSeeViewProviders);
            factory.resolving = true;
            /** @type {?} */
            var previousInjectImplementation = void 0;
            if (factory.injectImpl) {
                previousInjectImplementation = setInjectImplementation(factory.injectImpl);
            }
            /** @type {?} */
            var savePreviousOrParentTNode = getPreviousOrParentTNode();
            /** @type {?} */
            var saveLView = getLView();
            setTNodeAndViewData(tNode, lData);
            try {
                value = lData[index] = factory.factory(undefined, tData, lData, tNode);
            }
            finally {
                if (factory.injectImpl)
                    setInjectImplementation(previousInjectImplementation);
                setIncludeViewProviders(previousIncludeViewProviders);
                factory.resolving = false;
                setTNodeAndViewData(savePreviousOrParentTNode, saveLView);
            }
        }
        return value;
    }
    /**
     * Returns the bit in an injector's bloom filter that should be used to determine whether or not
     * the directive might be provided by the injector.
     *
     * When a directive is public, it is added to the bloom filter and given a unique ID that can be
     * retrieved on the Type. When the directive isn't public or the token is not a directive `null`
     * is returned as the node injector can not possibly provide that token.
     *
     * @param {?} token the injection token
     * @return {?} the matching bit to check in the bloom filter or `null` if the token is not known.
     *   When the returned value is negative then it represents special values such as `Injector`.
     */
    function bloomHashBitOrFactory(token) {
        ngDevMode && assertDefined(token, 'token must be defined');
        if (typeof token === 'string') {
            return token.charCodeAt(0) || 0;
        }
        /** @type {?} */
        var tokenId = (( /** @type {?} */(token)))[NG_ELEMENT_ID];
        // Negative token IDs are used for special objects such as `Injector`
        return (typeof tokenId === 'number' && tokenId > 0) ? tokenId & BLOOM_MASK : tokenId;
    }
    /**
     * @param {?} bloomHash
     * @param {?} injectorIndex
     * @param {?} injectorView
     * @return {?}
     */
    function bloomHasToken(bloomHash, injectorIndex, injectorView) {
        // Create a mask that targets the specific bit associated with the directive we're looking for.
        // JS bit operations are 32 bits, so this will be a number between 2^0 and 2^31, corresponding
        // to bit positions 0 - 31 in a 32 bit integer.
        /** @type {?} */
        var mask = 1 << bloomHash;
        /** @type {?} */
        var b7 = bloomHash & 0x80;
        /** @type {?} */
        var b6 = bloomHash & 0x40;
        /** @type {?} */
        var b5 = bloomHash & 0x20;
        // Our bloom filter size is 256 bits, which is eight 32-bit bloom filter buckets:
        // bf0 = [0 - 31], bf1 = [32 - 63], bf2 = [64 - 95], bf3 = [96 - 127], etc.
        // Get the bloom filter value from the appropriate bucket based on the directive's bloomBit.
        /** @type {?} */
        var value;
        if (b7) {
            value = b6 ? (b5 ? injectorView[injectorIndex + 7] : injectorView[injectorIndex + 6]) :
                (b5 ? injectorView[injectorIndex + 5] : injectorView[injectorIndex + 4]);
        }
        else {
            value = b6 ? (b5 ? injectorView[injectorIndex + 3] : injectorView[injectorIndex + 2]) :
                (b5 ? injectorView[injectorIndex + 1] : injectorView[injectorIndex]);
        }
        // If the bloom filter value has the bit corresponding to the directive's bloomBit flipped on,
        // this injector is a potential match.
        return !!(value & mask);
    }
    /**
     * Returns true if flags prevent parent injector from being searched for tokens
     * @param {?} flags
     * @param {?} isFirstHostTNode
     * @return {?}
     */
    function shouldSearchParent(flags, isFirstHostTNode) {
        return !(flags & InjectFlags.Self) && !(flags & InjectFlags.Host && isFirstHostTNode);
    }
    var NodeInjector = /** @class */ (function () {
        /**
         * @param {?} _tNode
         * @param {?} _lView
         */
        function NodeInjector(_tNode, _lView) {
            this._tNode = _tNode;
            this._lView = _lView;
        }
        /**
         * @param {?} token
         * @param {?=} notFoundValue
         * @return {?}
         */
        NodeInjector.prototype.get = function (token, notFoundValue) {
            return getOrCreateInjectable(this._tNode, this._lView, token, undefined, notFoundValue);
        };
        return NodeInjector;
    }());
    var ERROR_DEBUG_CONTEXT = 'ngDebugContext';
    var ERROR_ORIGINAL_ERROR = 'ngOriginalError';
    var ERROR_LOGGER = 'ngErrorLogger';
    function wrappedError(message, originalError) {
        var msg = message + " caused by: " + (originalError instanceof Error ? originalError.message : originalError);
        var error = Error(msg);
        error[ERROR_ORIGINAL_ERROR] = originalError;
        return error;
    }
    /**
     * @param {?} error
     * @return {?}
     */
    function getDebugContext(error) {
        return (( /** @type {?} */(error)))[ERROR_DEBUG_CONTEXT];
    }
    /**
     * @param {?} error
     * @return {?}
     */
    function getOriginalError(error) {
        return (( /** @type {?} */(error)))[ERROR_ORIGINAL_ERROR];
    }
    /**
     * @param {?} error
     * @return {?}
     */
    function getErrorLogger(error) {
        return (( /** @type {?} */(error)))[ERROR_LOGGER] || defaultErrorLogger;
    }
    /**
     * @param {?} console
     * @param {...?} values
     * @return {?}
     */
    function defaultErrorLogger(console) {
        var values = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            values[_i - 1] = arguments[_i];
        }
        console.error.apply(console, __spread(values));
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Provides a hook for centralized exception handling.
     *
     * The default implementation of `ErrorHandler` prints error messages to the `console`. To
     * intercept error handling, write a custom exception handler that replaces this default as
     * appropriate for your app.
     *
     * \@usageNotes
     * ### Example
     *
     * ```
     * class MyErrorHandler implements ErrorHandler {
     *   handleError(error) {
     *     // do something with the exception
     *   }
     * }
     *
     * \@NgModule({
     *   providers: [{provide: ErrorHandler, useClass: MyErrorHandler}]
     * })
     * class MyModule {}
     * ```
     *
     * \@publicApi
     */
    var ErrorHandler = /** @class */ (function () {
        function ErrorHandler() {
            /**
             * \@internal
             */
            this._console = console;
        }
        /**
         * @param {?} error
         * @return {?}
         */
        ErrorHandler.prototype.handleError = function (error) {
            /** @type {?} */
            var originalError = this._findOriginalError(error);
            /** @type {?} */
            var context = this._findContext(error);
            // Note: Browser consoles show the place from where console.error was called.
            // We can use this to give users additional information about the error.
            /** @type {?} */
            var errorLogger = getErrorLogger(error);
            errorLogger(this._console, "ERROR", error);
            if (originalError) {
                errorLogger(this._console, "ORIGINAL ERROR", originalError);
            }
            if (context) {
                errorLogger(this._console, 'ERROR CONTEXT', context);
            }
        };
        /**
         * \@internal
         * @param {?} error
         * @return {?}
         */
        ErrorHandler.prototype._findContext = function (error) {
            if (error) {
                return getDebugContext(error) ? getDebugContext(error) :
                    this._findContext(getOriginalError(error));
            }
            return null;
        };
        /**
         * \@internal
         * @param {?} error
         * @return {?}
         */
        ErrorHandler.prototype._findOriginalError = function (error) {
            /** @type {?} */
            var e = getOriginalError(error);
            while (e && getOriginalError(e)) {
                e = getOriginalError(e);
            }
            return e;
        };
        return ErrorHandler;
    }());
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * This file is used to control if the default rendering pipeline should be `ViewEngine` or `Ivy`.
     *
     * For more information on how to run and debug tests with either Ivy or View Engine (legacy),
     * please see [BAZEL.md](./docs/BAZEL.md).
     */
    var _devMode = true;
    var _runModeLocked = false;
    /**
     * Returns whether Angular is in development mode. After called once,
     * the value is locked and won't change any more.
     *
     * By default, this is true, unless a user calls `enableProdMode` before calling this.
     *
     * @publicApi
     */
    function isDevMode() {
        _runModeLocked = true;
        return _devMode;
    }
    /**
     * Disable Angular's development mode, which turns off assertions and other
     * checks within the framework.
     *
     * One important assertion this disables verifies that a change detection pass
     * does not result in additional changes to any bindings (also known as
     * unidirectional data flow).
     *
     * @publicApi
     */
    function enableProdMode() {
        if (_runModeLocked) {
            throw new Error('Cannot enable prod mode after platform setup.');
        }
        _devMode = false;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * This helper class is used to get hold of an inert tree of DOM elements containing dirty HTML
     * that needs sanitizing.
     * Depending upon browser support we must use one of three strategies for doing this.
     * Support: Safari 10.x -> XHR strategy
     * Support: Firefox -> DomParser strategy
     * Default: InertDocument strategy
     */
    var InertBodyHelper = /** @class */ (function () {
        /**
         * @param {?} defaultDoc
         */
        function InertBodyHelper(defaultDoc) {
            this.defaultDoc = defaultDoc;
            this.inertDocument = this.defaultDoc.implementation.createHTMLDocument('sanitization-inert');
            this.inertBodyElement = this.inertDocument.body;
            if (this.inertBodyElement == null) {
                // usually there should be only one body element in the document, but IE doesn't have any, so
                // we need to create one.
                /** @type {?} */
                var inertHtml = this.inertDocument.createElement('html');
                this.inertDocument.appendChild(inertHtml);
                this.inertBodyElement = this.inertDocument.createElement('body');
                inertHtml.appendChild(this.inertBodyElement);
            }
            this.inertBodyElement.innerHTML = '<svg><g onload="this.parentNode.remove()"></g></svg>';
            if (this.inertBodyElement.querySelector && !this.inertBodyElement.querySelector('svg')) {
                // We just hit the Safari 10.1 bug - which allows JS to run inside the SVG G element
                // so use the XHR strategy.
                this.getInertBodyElement = this.getInertBodyElement_XHR;
                return;
            }
            this.inertBodyElement.innerHTML =
                '<svg><p><style><img src="</style><img src=x onerror=alert(1)//">';
            if (this.inertBodyElement.querySelector && this.inertBodyElement.querySelector('svg img')) {
                // We just hit the Firefox bug - which prevents the inner img JS from being sanitized
                // so use the DOMParser strategy, if it is available.
                // If the DOMParser is not available then we are not in Firefox (Server/WebWorker?) so we
                // fall through to the default strategy below.
                if (isDOMParserAvailable()) {
                    this.getInertBodyElement = this.getInertBodyElement_DOMParser;
                    return;
                }
            }
            // None of the bugs were hit so it is safe for us to use the default InertDocument strategy
            this.getInertBodyElement = this.getInertBodyElement_InertDocument;
        }
        /**
         * Use XHR to create and fill an inert body element (on Safari 10.1)
         * See
         * https://github.com/cure53/DOMPurify/blob/a992d3a75031cb8bb032e5ea8399ba972bdf9a65/src/purify.js#L439-L449
         * @private
         * @param {?} html
         * @return {?}
         */
        InertBodyHelper.prototype.getInertBodyElement_XHR = function (html) {
            // We add these extra elements to ensure that the rest of the content is parsed as expected
            // e.g. leading whitespace is maintained and tags like `<meta>` do not get hoisted to the
            // `<head>` tag.
            html = '<body><remove></remove>' + html + '</body>';
            try {
                html = encodeURI(html);
            }
            catch (_a) {
                return null;
            }
            /** @type {?} */
            var xhr = new XMLHttpRequest();
            xhr.responseType = 'document';
            xhr.open('GET', 'data:text/html;charset=utf-8,' + html, false);
            xhr.send(undefined);
            /** @type {?} */
            var body = xhr.response.body;
            body.removeChild(( /** @type {?} */(body.firstChild)));
            return body;
        };
        /**
         * Use DOMParser to create and fill an inert body element (on Firefox)
         * See https://github.com/cure53/DOMPurify/releases/tag/0.6.7
         *
         * @private
         * @param {?} html
         * @return {?}
         */
        InertBodyHelper.prototype.getInertBodyElement_DOMParser = function (html) {
            // We add these extra elements to ensure that the rest of the content is parsed as expected
            // e.g. leading whitespace is maintained and tags like `<meta>` do not get hoisted to the
            // `<head>` tag.
            html = '<body><remove></remove>' + html + '</body>';
            try {
                /** @type {?} */
                var body = ( /** @type {?} */(new (( /** @type {?} */(window)))
                    .DOMParser()
                    .parseFromString(html, 'text/html')
                    .body));
                body.removeChild(( /** @type {?} */(body.firstChild)));
                return body;
            }
            catch (_a) {
                return null;
            }
        };
        /**
         * Use an HTML5 `template` element, if supported, or an inert body element created via
         * `createHtmlDocument` to create and fill an inert DOM element.
         * This is the default sane strategy to use if the browser does not require one of the specialised
         * strategies above.
         * @private
         * @param {?} html
         * @return {?}
         */
        InertBodyHelper.prototype.getInertBodyElement_InertDocument = function (html) {
            // Prefer using <template> element if supported.
            /** @type {?} */
            var templateEl = this.inertDocument.createElement('template');
            if ('content' in templateEl) {
                templateEl.innerHTML = html;
                return templateEl;
            }
            this.inertBodyElement.innerHTML = html;
            // Support: IE 9-11 only
            // strip custom-namespaced attributes on IE<=11
            if ((( /** @type {?} */(this.defaultDoc))).documentMode) {
                this.stripCustomNsAttrs(this.inertBodyElement);
            }
            return this.inertBodyElement;
        };
        /**
         * When IE9-11 comes across an unknown namespaced attribute e.g. 'xlink:foo' it adds 'xmlns:ns1'
         * attribute to declare ns1 namespace and prefixes the attribute with 'ns1' (e.g.
         * 'ns1:xlink:foo').
         *
         * This is undesirable since we don't want to allow any of these custom attributes. This method
         * strips them all.
         * @private
         * @param {?} el
         * @return {?}
         */
        InertBodyHelper.prototype.stripCustomNsAttrs = function (el) {
            /** @type {?} */
            var elAttrs = el.attributes;
            // loop backwards so that we can support removals.
            for (var i_21 = elAttrs.length - 1; 0 < i_21; i_21--) {
                /** @type {?} */
                var attrib = elAttrs.item(i_21);
                /** @type {?} */
                var attrName = ( /** @type {?} */(attrib)).name;
                if (attrName === 'xmlns:ns1' || attrName.indexOf('ns1:') === 0) {
                    el.removeAttribute(attrName);
                }
            }
            /** @type {?} */
            var childNode = ( /** @type {?} */(el.firstChild));
            while (childNode) {
                if (childNode.nodeType === Node.ELEMENT_NODE)
                    this.stripCustomNsAttrs(( /** @type {?} */(childNode)));
                childNode = childNode.nextSibling;
            }
        };
        return InertBodyHelper;
    }());
    /**
     * We need to determine whether the DOMParser exists in the global context.
     * The try-catch is because, on some browsers, trying to access this property
     * on window can actually throw an error.
     *
     * @suppress {uselessCode}
     * @return {?}
     */
    function isDOMParserAvailable() {
        try {
            return !!(( /** @type {?} */(window))).DOMParser;
        }
        catch (_a) {
            return false;
        }
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A pattern that recognizes a commonly useful subset of URLs that are safe.
     *
     * This regular expression matches a subset of URLs that will not cause script
     * execution if used in URL context within a HTML document. Specifically, this
     * regular expression matches if (comment from here on and regex copied from
     * Soy's EscapingConventions):
     * (1) Either an allowed protocol (http, https, mailto or ftp).
     * (2) or no protocol.  A protocol must be followed by a colon. The below
     *     allows that by allowing colons only after one of the characters [/?#].
     *     A colon after a hash (#) must be in the fragment.
     *     Otherwise, a colon after a (?) must be in a query.
     *     Otherwise, a colon after a single solidus (/) must be in a path.
     *     Otherwise, a colon after a double solidus (//) must be in the authority
     *     (before port).
     *
     * The pattern disallows &, used in HTML entity declarations before
     * one of the characters in [/?#]. This disallows HTML entities used in the
     * protocol name, which should never happen, e.g. "h&#116;tp" for "http".
     * It also disallows HTML entities in the first path part of a relative path,
     * e.g. "foo&lt;bar/baz".  Our existing escaping functions should not produce
     * that. More importantly, it disallows masking of a colon,
     * e.g. "javascript&#58;...".
     *
     * This regular expression was taken from the Closure sanitization library.
     * @type {?}
     */
    var SAFE_URL_PATTERN = /^(?:(?:https?|mailto|ftp|tel|file):|[^&:/?#]*(?:[/?#]|$))/gi;
    /**
     * A pattern that matches safe data URLs. Only matches image, video and audio types.
     * @type {?}
     */
    var DATA_URL_PATTERN = /^data:(?:image\/(?:bmp|gif|jpeg|jpg|png|tiff|webp)|video\/(?:mpeg|mp4|ogg|webm)|audio\/(?:mp3|oga|ogg|opus));base64,[a-z0-9+\/]+=*$/i;
    /**
     * @param {?} url
     * @return {?}
     */
    function _sanitizeUrl(url) {
        url = String(url);
        if (url.match(SAFE_URL_PATTERN) || url.match(DATA_URL_PATTERN))
            return url;
        if (isDevMode()) {
            console.warn("WARNING: sanitizing unsafe URL value " + url + " (see http://g.co/ng/security#xss)");
        }
        return 'unsafe:' + url;
    }
    /**
     * @param {?} srcset
     * @return {?}
     */
    function sanitizeSrcset(srcset) {
        srcset = String(srcset);
        return srcset.split(',').map(( /**
         * @param {?} srcset
         * @return {?}
         */function (srcset) { return _sanitizeUrl(srcset.trim()); })).join(', ');
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} tags
     * @return {?}
     */
    function tagSet(tags) {
        var e_1, _b;
        /** @type {?} */
        var res = {};
        try {
            for (var _c = __values(tags.split(',')), _d = _c.next(); !_d.done; _d = _c.next()) {
                var t_1 = _d.value;
                res[t_1] = true;
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return res;
    }
    /**
     * @param {...?} sets
     * @return {?}
     */
    function merge$1() {
        var sets = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            sets[_i] = arguments[_i];
        }
        var e_2, _b;
        /** @type {?} */
        var res = {};
        try {
            for (var sets_1 = __values(sets), sets_1_1 = sets_1.next(); !sets_1_1.done; sets_1_1 = sets_1.next()) {
                var s_1 = sets_1_1.value;
                for (var v in s_1) {
                    if (s_1.hasOwnProperty(v))
                        res[v] = true;
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (sets_1_1 && !sets_1_1.done && (_b = sets_1.return)) _b.call(sets_1);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return res;
    }
    // Good source of info about elements and attributes
    // http://dev.w3.org/html5/spec/Overview.html#semantics
    // http://simon.html5.org/html-elements
    // Safe Void Elements - HTML5
    // http://dev.w3.org/html5/spec/Overview.html#void-elements
    /** @type {?} */
    var VOID_ELEMENTS = tagSet('area,br,col,hr,img,wbr');
    // Elements that you can, intentionally, leave open (and which close themselves)
    // http://dev.w3.org/html5/spec/Overview.html#optional-tags
    /** @type {?} */
    var OPTIONAL_END_TAG_BLOCK_ELEMENTS = tagSet('colgroup,dd,dt,li,p,tbody,td,tfoot,th,thead,tr');
    /** @type {?} */
    var OPTIONAL_END_TAG_INLINE_ELEMENTS = tagSet('rp,rt');
    /** @type {?} */
    var OPTIONAL_END_TAG_ELEMENTS = merge$1(OPTIONAL_END_TAG_INLINE_ELEMENTS, OPTIONAL_END_TAG_BLOCK_ELEMENTS);
    // Safe Block Elements - HTML5
    /** @type {?} */
    var BLOCK_ELEMENTS = merge$1(OPTIONAL_END_TAG_BLOCK_ELEMENTS, tagSet('address,article,' +
        'aside,blockquote,caption,center,del,details,dialog,dir,div,dl,figure,figcaption,footer,h1,h2,h3,h4,h5,' +
        'h6,header,hgroup,hr,ins,main,map,menu,nav,ol,pre,section,summary,table,ul'));
    // Inline Elements - HTML5
    /** @type {?} */
    var INLINE_ELEMENTS = merge$1(OPTIONAL_END_TAG_INLINE_ELEMENTS, tagSet('a,abbr,acronym,audio,b,' +
        'bdi,bdo,big,br,cite,code,del,dfn,em,font,i,img,ins,kbd,label,map,mark,picture,q,ruby,rp,rt,s,' +
        'samp,small,source,span,strike,strong,sub,sup,time,track,tt,u,var,video'));
    /** @type {?} */
    var VALID_ELEMENTS = merge$1(VOID_ELEMENTS, BLOCK_ELEMENTS, INLINE_ELEMENTS, OPTIONAL_END_TAG_ELEMENTS);
    // Attributes that have href and hence need to be sanitized
    /** @type {?} */
    var URI_ATTRS = tagSet('background,cite,href,itemtype,longdesc,poster,src,xlink:href');
    // Attributes that have special href set hence need to be sanitized
    /** @type {?} */
    var SRCSET_ATTRS = tagSet('srcset');
    /** @type {?} */
    var HTML_ATTRS = tagSet('abbr,accesskey,align,alt,autoplay,axis,bgcolor,border,cellpadding,cellspacing,class,clear,color,cols,colspan,' +
        'compact,controls,coords,datetime,default,dir,download,face,headers,height,hidden,hreflang,hspace,' +
        'ismap,itemscope,itemprop,kind,label,lang,language,loop,media,muted,nohref,nowrap,open,preload,rel,rev,role,rows,rowspan,rules,' +
        'scope,scrolling,shape,size,sizes,span,srclang,start,summary,tabindex,target,title,translate,type,usemap,' +
        'valign,value,vspace,width');
    // Accessibility attributes as per WAI-ARIA 1.1 (W3C Working Draft 14 December 2018)
    /** @type {?} */
    var ARIA_ATTRS = tagSet('aria-activedescendant,aria-atomic,aria-autocomplete,aria-busy,aria-checked,aria-colcount,aria-colindex,' +
        'aria-colspan,aria-controls,aria-current,aria-describedby,aria-details,aria-disabled,aria-dropeffect,' +
        'aria-errormessage,aria-expanded,aria-flowto,aria-grabbed,aria-haspopup,aria-hidden,aria-invalid,' +
        'aria-keyshortcuts,aria-label,aria-labelledby,aria-level,aria-live,aria-modal,aria-multiline,' +
        'aria-multiselectable,aria-orientation,aria-owns,aria-placeholder,aria-posinset,aria-pressed,aria-readonly,' +
        'aria-relevant,aria-required,aria-roledescription,aria-rowcount,aria-rowindex,aria-rowspan,aria-selected,' +
        'aria-setsize,aria-sort,aria-valuemax,aria-valuemin,aria-valuenow,aria-valuetext');
    // NB: This currently consciously doesn't support SVG. SVG sanitization has had several security
    // issues in the past, so it seems safer to leave it out if possible. If support for binding SVG via
    // innerHTML is required, SVG attributes should be added here.
    // NB: Sanitization does not allow <form> elements or other active elements (<button> etc). Those
    // can be sanitized, but they increase security surface area without a legitimate use case, so they
    // are left out here.
    /** @type {?} */
    var VALID_ATTRS = merge$1(URI_ATTRS, SRCSET_ATTRS, HTML_ATTRS, ARIA_ATTRS);
    // Elements whose content should not be traversed/preserved, if the elements themselves are invalid.
    //
    // Typically, `<invalid>Some content</invalid>` would traverse (and in this case preserve)
    // `Some content`, but strip `invalid-element` opening/closing tags. For some elements, though, we
    // don't want to preserve the content, if the elements themselves are going to be removed.
    /** @type {?} */
    var SKIP_TRAVERSING_CONTENT_IF_INVALID_ELEMENTS = tagSet('script,style,template');
    /**
     * SanitizingHtmlSerializer serializes a DOM fragment, stripping out any unsafe elements and unsafe
     * attributes.
     */
    var SanitizingHtmlSerializer = /** @class */ (function () {
        function SanitizingHtmlSerializer() {
            // Explicitly track if something was stripped, to avoid accidentally warning of sanitization just
            // because characters were re-encoded.
            this.sanitizedSomething = false;
            this.buf = [];
        }
        /**
         * @param {?} el
         * @return {?}
         */
        SanitizingHtmlSerializer.prototype.sanitizeChildren = function (el) {
            // This cannot use a TreeWalker, as it has to run on Angular's various DOM adapters.
            // However this code never accesses properties off of `document` before deleting its contents
            // again, so it shouldn't be vulnerable to DOM clobbering.
            /** @type {?} */
            var current = ( /** @type {?} */(el.firstChild));
            /** @type {?} */
            var traverseContent = true;
            while (current) {
                if (current.nodeType === Node.ELEMENT_NODE) {
                    traverseContent = this.startElement(( /** @type {?} */(current)));
                }
                else if (current.nodeType === Node.TEXT_NODE) {
                    this.chars(( /** @type {?} */(current.nodeValue)));
                }
                else {
                    // Strip non-element, non-text nodes.
                    this.sanitizedSomething = true;
                }
                if (traverseContent && current.firstChild) {
                    current = ( /** @type {?} */(current.firstChild));
                    continue;
                }
                while (current) {
                    // Leaving the element. Walk up and to the right, closing tags as we go.
                    if (current.nodeType === Node.ELEMENT_NODE) {
                        this.endElement(( /** @type {?} */(current)));
                    }
                    /** @type {?} */
                    var next = this.checkClobberedElement(current, ( /** @type {?} */(current.nextSibling)));
                    if (next) {
                        current = next;
                        break;
                    }
                    current = this.checkClobberedElement(current, ( /** @type {?} */(current.parentNode)));
                }
            }
            return this.buf.join('');
        };
        /**
         * Sanitizes an opening element tag (if valid) and returns whether the element's contents should
         * be traversed. Element content must always be traversed (even if the element itself is not
         * valid/safe), unless the element is one of `SKIP_TRAVERSING_CONTENT_IF_INVALID_ELEMENTS`.
         *
         * @private
         * @param {?} element The element to sanitize.
         * @return {?} True if the element's contents should be traversed.
         */
        SanitizingHtmlSerializer.prototype.startElement = function (element) {
            /** @type {?} */
            var tagName = element.nodeName.toLowerCase();
            if (!VALID_ELEMENTS.hasOwnProperty(tagName)) {
                this.sanitizedSomething = true;
                return !SKIP_TRAVERSING_CONTENT_IF_INVALID_ELEMENTS.hasOwnProperty(tagName);
            }
            this.buf.push('<');
            this.buf.push(tagName);
            /** @type {?} */
            var elAttrs = element.attributes;
            for (var i_22 = 0; i_22 < elAttrs.length; i_22++) {
                /** @type {?} */
                var elAttr = elAttrs.item(i_22);
                /** @type {?} */
                var attrName = ( /** @type {?} */(elAttr)).name;
                /** @type {?} */
                var lower = attrName.toLowerCase();
                if (!VALID_ATTRS.hasOwnProperty(lower)) {
                    this.sanitizedSomething = true;
                    continue;
                }
                /** @type {?} */
                var value = ( /** @type {?} */(elAttr)).value;
                // TODO(martinprobst): Special case image URIs for data:image/...
                if (URI_ATTRS[lower])
                    value = _sanitizeUrl(value);
                if (SRCSET_ATTRS[lower])
                    value = sanitizeSrcset(value);
                this.buf.push(' ', attrName, '="', encodeEntities(value), '"');
            }
            this.buf.push('>');
            return true;
        };
        /**
         * @private
         * @param {?} current
         * @return {?}
         */
        SanitizingHtmlSerializer.prototype.endElement = function (current) {
            /** @type {?} */
            var tagName = current.nodeName.toLowerCase();
            if (VALID_ELEMENTS.hasOwnProperty(tagName) && !VOID_ELEMENTS.hasOwnProperty(tagName)) {
                this.buf.push('</');
                this.buf.push(tagName);
                this.buf.push('>');
            }
        };
        /**
         * @private
         * @param {?} chars
         * @return {?}
         */
        SanitizingHtmlSerializer.prototype.chars = function (chars) { this.buf.push(encodeEntities(chars)); };
        /**
         * @param {?} node
         * @param {?} nextNode
         * @return {?}
         */
        SanitizingHtmlSerializer.prototype.checkClobberedElement = function (node, nextNode) {
            if (nextNode &&
                (node.compareDocumentPosition(nextNode) &
                    Node.DOCUMENT_POSITION_CONTAINED_BY) === Node.DOCUMENT_POSITION_CONTAINED_BY) {
                throw new Error("Failed to sanitize html because the element is clobbered: " + (( /** @type {?} */(node))).outerHTML);
            }
            return nextNode;
        };
        return SanitizingHtmlSerializer;
    }());
    // Regular Expressions for parsing tags and attributes
    /** @type {?} */
    var SURROGATE_PAIR_REGEXP = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g;
    // ! to ~ is the ASCII range.
    /** @type {?} */
    var NON_ALPHANUMERIC_REGEXP = /([^\#-~ |!])/g;
    /**
     * Escapes all potentially dangerous characters, so that the
     * resulting string can be safely inserted into attribute or
     * element text.
     * @param {?} value
     * @return {?}
     */
    function encodeEntities(value) {
        return value.replace(/&/g, '&amp;')
            .replace(SURROGATE_PAIR_REGEXP, ( /**
     * @param {?} match
     * @return {?}
     */function (match) {
            /** @type {?} */
            var hi = match.charCodeAt(0);
            /** @type {?} */
            var low = match.charCodeAt(1);
            return '&#' + (((hi - 0xD800) * 0x400) + (low - 0xDC00) + 0x10000) + ';';
        }))
            .replace(NON_ALPHANUMERIC_REGEXP, ( /**
     * @param {?} match
     * @return {?}
     */function (match) { return '&#' + match.charCodeAt(0) + ';'; }))
            .replace(/</g, '&lt;')
            .replace(/>/g, '&gt;');
    }
    /** @type {?} */
    var inertBodyHelper;
    /**
     * Sanitizes the given unsafe, untrusted HTML fragment, and returns HTML text that is safe to add to
     * the DOM in a browser environment.
     * @param {?} defaultDoc
     * @param {?} unsafeHtmlInput
     * @return {?}
     */
    function _sanitizeHtml(defaultDoc, unsafeHtmlInput) {
        /** @type {?} */
        var inertBodyElement = null;
        try {
            inertBodyHelper = inertBodyHelper || new InertBodyHelper(defaultDoc);
            // Make sure unsafeHtml is actually a string (TypeScript types are not enforced at runtime).
            /** @type {?} */
            var unsafeHtml = unsafeHtmlInput ? String(unsafeHtmlInput) : '';
            inertBodyElement = inertBodyHelper.getInertBodyElement(unsafeHtml);
            // mXSS protection. Repeatedly parse the document to make sure it stabilizes, so that a browser
            // trying to auto-correct incorrect HTML cannot cause formerly inert HTML to become dangerous.
            /** @type {?} */
            var mXSSAttempts = 5;
            /** @type {?} */
            var parsedHtml = unsafeHtml;
            do {
                if (mXSSAttempts === 0) {
                    throw new Error('Failed to sanitize html because the input is unstable');
                }
                mXSSAttempts--;
                unsafeHtml = parsedHtml;
                parsedHtml = ( /** @type {?} */(inertBodyElement)).innerHTML;
                inertBodyElement = inertBodyHelper.getInertBodyElement(unsafeHtml);
            } while (unsafeHtml !== parsedHtml);
            /** @type {?} */
            var sanitizer = new SanitizingHtmlSerializer();
            /** @type {?} */
            var safeHtml = sanitizer.sanitizeChildren(( /** @type {?} */(getTemplateContent(( /** @type {?} */(inertBodyElement))))) || inertBodyElement);
            if (isDevMode() && sanitizer.sanitizedSomething) {
                console.warn('WARNING: sanitizing HTML stripped some content, see http://g.co/ng/security#xss');
            }
            return safeHtml;
        }
        finally {
            // In case anything goes wrong, clear out inertElement to reset the entire DOM structure.
            if (inertBodyElement) {
                /** @type {?} */
                var parent_2 = getTemplateContent(inertBodyElement) || inertBodyElement;
                while (parent_2.firstChild) {
                    parent_2.removeChild(parent_2.firstChild);
                }
            }
        }
    }
    /**
     * @param {?} el
     * @return {?}
     */
    function getTemplateContent(el) {
        return 'content' in (( /** @type {?} */(el))) && isTemplateElement(el) ?
            el.content :
            null;
    }
    /**
     * @param {?} el
     * @return {?}
     */
    function isTemplateElement(el) {
        return el.nodeType === Node.ELEMENT_NODE && el.nodeName === 'TEMPLATE';
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /** @enum {number} */
    var SecurityContext = {
        NONE: 0,
        HTML: 1,
        STYLE: 2,
        SCRIPT: 3,
        URL: 4,
        RESOURCE_URL: 5,
    };
    SecurityContext[SecurityContext.NONE] = 'NONE';
    SecurityContext[SecurityContext.HTML] = 'HTML';
    SecurityContext[SecurityContext.STYLE] = 'STYLE';
    SecurityContext[SecurityContext.SCRIPT] = 'SCRIPT';
    SecurityContext[SecurityContext.URL] = 'URL';
    SecurityContext[SecurityContext.RESOURCE_URL] = 'RESOURCE_URL';
    /**
     * Sanitizer is used by the views to sanitize potentially dangerous values.
     *
     * \@publicApi
     * @abstract
     */
    var Sanitizer = /** @class */ (function () {
        function Sanitizer() {
        }
        return Sanitizer;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Regular expression for safe style values.
     *
     * Quotes (" and ') are allowed, but a check must be done elsewhere to ensure they're balanced.
     *
     * ',' allows multiple values to be assigned to the same property (e.g. background-attachment or
     * font-family) and hence could allow multiple values to get injected, but that should pose no risk
     * of XSS.
     *
     * The function expression checks only for XSS safety, not for CSS validity.
     *
     * This regular expression was taken from the Closure sanitization library, and augmented for
     * transformation values.
     * @type {?}
     */
    var VALUES = '[-,."\'%_!# a-zA-Z0-9]+';
    /** @type {?} */
    var TRANSFORMATION_FNS = '(?:matrix|translate|scale|rotate|skew|perspective)(?:X|Y|Z|3d)?';
    /** @type {?} */
    var COLOR_FNS = '(?:rgb|hsl)a?';
    /** @type {?} */
    var GRADIENTS = '(?:repeating-)?(?:linear|radial)-gradient';
    /** @type {?} */
    var CSS3_FNS = '(?:calc|attr)';
    /** @type {?} */
    var FN_ARGS = '\\([-0-9.%, #a-zA-Z]+\\)';
    /** @type {?} */
    var SAFE_STYLE_VALUE = new RegExp("^(" + VALUES + "|" +
        ("(?:" + TRANSFORMATION_FNS + "|" + COLOR_FNS + "|" + GRADIENTS + "|" + CSS3_FNS + ")") +
        (FN_ARGS + ")$"), 'g');
    /**
     * Matches a `url(...)` value with an arbitrary argument as long as it does
     * not contain parentheses.
     *
     * The URL value still needs to be sanitized separately.
     *
     * `url(...)` values are a very common use case, e.g. for `background-image`. With carefully crafted
     * CSS style rules, it is possible to construct an information leak with `url` values in CSS, e.g.
     * by observing whether scroll bars are displayed, or character ranges used by a font face
     * definition.
     *
     * Angular only allows binding CSS values (as opposed to entire CSS rules), so it is unlikely that
     * binding a URL value without further cooperation from the page will cause an information leak, and
     * if so, it is just a leak, not a full blown XSS vulnerability.
     *
     * Given the common use case, low likelihood of attack vector, and low impact of an attack, this
     * code is permissive and allows URLs that sanitize otherwise.
     * @type {?}
     */
    var URL_RE = /^url\(([^)]+)\)$/;
    /**
     * Checks that quotes (" and ') are properly balanced inside a string. Assumes
     * that neither escape (\) nor any other character that could result in
     * breaking out of a string parsing context are allowed;
     * see http://www.w3.org/TR/css3-syntax/#string-token-diagram.
     *
     * This code was taken from the Closure sanitization library.
     * @param {?} value
     * @return {?}
     */
    function hasBalancedQuotes(value) {
        /** @type {?} */
        var outsideSingle = true;
        /** @type {?} */
        var outsideDouble = true;
        for (var i_23 = 0; i_23 < value.length; i_23++) {
            /** @type {?} */
            var c_1 = value.charAt(i_23);
            if (c_1 === '\'' && outsideDouble) {
                outsideSingle = !outsideSingle;
            }
            else if (c_1 === '"' && outsideSingle) {
                outsideDouble = !outsideDouble;
            }
        }
        return outsideSingle && outsideDouble;
    }
    /**
     * Sanitizes the given untrusted CSS style property value (i.e. not an entire object, just a single
     * value) and returns a value that is safe to use in a browser environment.
     * @param {?} value
     * @return {?}
     */
    function _sanitizeStyle(value) {
        value = String(value).trim(); // Make sure it's actually a string.
        if (!value)
            return '';
        // Single url(...) values are supported, but only for URLs that sanitize cleanly. See above for
        // reasoning behind this.
        /** @type {?} */
        var urlMatch = value.match(URL_RE);
        if ((urlMatch && _sanitizeUrl(urlMatch[1]) === urlMatch[1]) ||
            value.match(SAFE_STYLE_VALUE) && hasBalancedQuotes(value)) {
            return value; // Safe style values.
        }
        if (isDevMode()) {
            console.warn("WARNING: sanitizing unsafe style value " + value + " (see http://g.co/ng/security#xss).");
        }
        return 'unsafe';
    }
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * THIS FILE CONTAINS CODE WHICH SHOULD BE TREE SHAKEN AND NEVER CALLED FROM PRODUCTION CODE!!!
     */
    /**
     * Creates an `Array` construction with a given name. This is useful when
     * looking for memory consumption to see what time of array it is.
     *
     *
     * @param name Name to give to the constructor
     * @returns A subclass of `Array` if possible. This can only be done in
     *          environments which support `class` construct.
     */
    function createNamedArrayType(name) {
        // This should never be called in prod mode, so let's verify that is the case.
        if (ngDevMode) {
            try {
                // We need to do it this way so that TypeScript does not down-level the below code.
                var FunctionConstructor = createNamedArrayType.constructor;
                return (new FunctionConstructor('Array', "return class ABC extends Array{}"))(Array);
            }
            catch (e) {
                // If it does not work just give up and fall back to regular Array.
                return Array;
            }
        }
        else {
            throw new Error('Looks like we are in \'prod mode\', but we are creating a named Array type, which is wrong! Check your code');
        }
    }
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    function normalizeDebugBindingName(name) {
        // Attribute names with `$` (eg `x-y$`) are valid per spec, but unsupported by some browsers
        name = camelCaseToDashCase(name.replace(/[$@]/g, '_'));
        return "ng-reflect-" + name;
    }
    var CAMEL_CASE_REGEXP = /([A-Z])/g;
    function camelCaseToDashCase(input) {
        return input.replace(CAMEL_CASE_REGEXP, function () {
            var m = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                m[_i] = arguments[_i];
            }
            return '-' + m[1].toLowerCase();
        });
    }
    function normalizeDebugBindingValue(value) {
        try {
            // Limit the size of the value as otherwise the DOM just gets polluted.
            return value != null ? value.toString().slice(0, 30) : value;
        }
        catch (e) {
            return '[ERROR] Exception while trying to serialize the value';
        }
    }
    /**
     * Assigns the given data to the given target (which could be a component,
     * directive or DOM node instance) using monkey-patching.
     * @param {?} target
     * @param {?} data
     * @return {?}
     */
    function attachPatchData(target, data) {
        target[MONKEY_PATCH_KEY_NAME] = data;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // The first bit value reflects a map-based binding value's bit.
    // The reason why it's always activated for every entry in the map
    // is so that if any map-binding values update then all other prop
    // based bindings will pass the guard check automatically without
    // any extra code or flags.
    /**
     * --------
     *
     * This file contains the core logic for styling in Angular.
     *
     * All styling bindings (i.e. `[style]`, `[style.prop]`, `[class]` and `[class.name]`)
     * will have their values be applied through the logic in this file.
     *
     * When a binding is encountered (e.g. `<div [style.width]="w">`) then
     * the binding data will be populated into a `TStylingContext` data-structure.
     * There is only one `TStylingContext` per `TNode` and each element instance
     * will update its style/class binding values in concert with the styling
     * context.
     *
     * To learn more about the algorithm see `TStylingContext`.
     *
     * --------
     * @type {?}
     */
    var DEFAULT_GUARD_MASK_VALUE = 1;
    /**
     * The guard/update mask bit index location for map-based bindings.
     *
     * All map-based bindings (i.e. `[style]` and `[class]` )
     * @type {?}
     */
    var STYLING_INDEX_FOR_MAP_BINDING = 0;
    /**
     * Default fallback value for a styling binding.
     *
     * A value of `null` is used here which signals to the styling algorithm that
     * the styling value is not present. This way if there are no other values
     * detected then it will be removed once the style/class property is dirty and
     * diffed within the styling algorithm present in `flushStyling`.
     * @type {?}
     */
    var DEFAULT_BINDING_VALUE = null;
    /**
     * Default size count value for a new entry in a context.
     *
     * A value of `1` is used here because each entry in the context has a default
     * property.
     * @type {?}
     */
    var DEFAULT_SIZE_VALUE = 1;
    /** @type {?} */
    var deferredBindingQueue = [];
    /**
     * Visits a class-based binding and updates the new value (if changed).
     *
     * This function is called each time a class-based styling instruction
     * is executed. It's important that it's always called (even if the value
     * has not changed) so that the inner counter index value is incremented.
     * This way, each instruction is always guaranteed to get the same counter
     * state each time it's called (which then allows the `TStylingContext`
     * and the bit mask values to be in sync).
     * @param {?} context
     * @param {?} data
     * @param {?} element
     * @param {?} prop
     * @param {?} bindingIndex
     * @param {?} value
     * @param {?} deferRegistration
     * @param {?} forceUpdate
     * @return {?}
     */
    function updateClassBinding(context, data, element, prop, bindingIndex, value, deferRegistration, forceUpdate) {
        /** @type {?} */
        var isMapBased = !prop;
        /** @type {?} */
        var state = getStylingState(element, stateIsPersisted(context));
        /** @type {?} */
        var index = isMapBased ? STYLING_INDEX_FOR_MAP_BINDING : state.classesIndex++;
        /** @type {?} */
        var updated = updateBindingData(context, data, index, prop, bindingIndex, value, deferRegistration, forceUpdate, false);
        if (updated || forceUpdate) {
            // We flip the bit in the bitMask to reflect that the binding
            // at the `index` slot has changed. This identifies to the flushing
            // phase that the bindings for this particular CSS class need to be
            // applied again because on or more of the bindings for the CSS
            // class have changed.
            state.classesBitMask |= 1 << index;
            return true;
        }
        return false;
    }
    /**
     * Visits a style-based binding and updates the new value (if changed).
     *
     * This function is called each time a style-based styling instruction
     * is executed. It's important that it's always called (even if the value
     * has not changed) so that the inner counter index value is incremented.
     * This way, each instruction is always guaranteed to get the same counter
     * state each time it's called (which then allows the `TStylingContext`
     * and the bit mask values to be in sync).
     * @param {?} context
     * @param {?} data
     * @param {?} element
     * @param {?} prop
     * @param {?} bindingIndex
     * @param {?} value
     * @param {?} sanitizer
     * @param {?} deferRegistration
     * @param {?} forceUpdate
     * @return {?}
     */
    function updateStyleBinding(context, data, element, prop, bindingIndex, value, sanitizer, deferRegistration, forceUpdate) {
        /** @type {?} */
        var isMapBased = !prop;
        /** @type {?} */
        var state = getStylingState(element, stateIsPersisted(context));
        /** @type {?} */
        var index = isMapBased ? STYLING_INDEX_FOR_MAP_BINDING : state.stylesIndex++;
        /** @type {?} */
        var sanitizationRequired = isMapBased ?
            true :
            (sanitizer ? sanitizer(( /** @type {?} */(prop)), null, 1 /* ValidateProperty */) : false);
        /** @type {?} */
        var updated = updateBindingData(context, data, index, prop, bindingIndex, value, deferRegistration, forceUpdate, sanitizationRequired);
        if (updated || forceUpdate) {
            // We flip the bit in the bitMask to reflect that the binding
            // at the `index` slot has changed. This identifies to the flushing
            // phase that the bindings for this particular property need to be
            // applied again because on or more of the bindings for the CSS
            // property have changed.
            state.stylesBitMask |= 1 << index;
            return true;
        }
        return false;
    }
    /**
     * Called each time a binding value has changed within the provided `TStylingContext`.
     *
     * This function is designed to be called from `updateStyleBinding` and `updateClassBinding`.
     * If called during the first update pass, the binding will be registered in the context.
     * If the binding does get registered and the `deferRegistration` flag is true then the
     * binding data will be queued up until the context is later flushed in `applyStyling`.
     *
     * This function will also update binding slot in the provided `LStylingData` with the
     * new binding entry (if it has changed).
     *
     * @param {?} context
     * @param {?} data
     * @param {?} counterIndex
     * @param {?} prop
     * @param {?} bindingIndex
     * @param {?} value
     * @param {?} deferRegistration
     * @param {?} forceUpdate
     * @param {?} sanitizationRequired
     * @return {?} whether or not the binding value was updated in the `LStylingData`.
     */
    function updateBindingData(context, data, counterIndex, prop, bindingIndex, value, deferRegistration, forceUpdate, sanitizationRequired) {
        if (!isContextLocked(context)) {
            if (deferRegistration) {
                deferBindingRegistration(context, counterIndex, prop, bindingIndex, sanitizationRequired);
            }
            else {
                deferredBindingQueue.length && flushDeferredBindings();
                // this will only happen during the first update pass of the
                // context. The reason why we can't use `tNode.firstTemplatePass`
                // here is because its not guaranteed to be true when the first
                // update pass is executed (remember that all styling instructions
                // are run in the update phase, and, as a result, are no more
                // styling instructions that are run in the creation phase).
                registerBinding(context, counterIndex, prop, bindingIndex, sanitizationRequired);
            }
        }
        /** @type {?} */
        var changed = forceUpdate || hasValueChanged(data[bindingIndex], value);
        if (changed) {
            data[bindingIndex] = value;
        }
        return changed;
    }
    /**
     * Schedules a binding registration to be run at a later point.
     *
     * The reasoning for this feature is to ensure that styling
     * bindings are registered in the correct order for when
     * directives/components have a super/sub class inheritance
     * chains. Each directive's styling bindings must be
     * registered into the context in reverse order. Therefore all
     * bindings will be buffered in reverse order and then applied
     * after the inheritance chain exits.
     * @param {?} context
     * @param {?} counterIndex
     * @param {?} prop
     * @param {?} bindingIndex
     * @param {?} sanitizationRequired
     * @return {?}
     */
    function deferBindingRegistration(context, counterIndex, prop, bindingIndex, sanitizationRequired) {
        deferredBindingQueue.unshift(context, counterIndex, prop, bindingIndex, sanitizationRequired);
    }
    /**
     * Flushes the collection of deferred bindings and causes each entry
     * to be registered into the context.
     * @return {?}
     */
    function flushDeferredBindings() {
        /** @type {?} */
        var i = 0;
        while (i < deferredBindingQueue.length) {
            /** @type {?} */
            var context = ( /** @type {?} */(deferredBindingQueue[i++]));
            /** @type {?} */
            var count = ( /** @type {?} */(deferredBindingQueue[i++]));
            /** @type {?} */
            var prop = ( /** @type {?} */(deferredBindingQueue[i++]));
            /** @type {?} */
            var bindingIndex = ( /** @type {?} */(deferredBindingQueue[i++]));
            /** @type {?} */
            var sanitizationRequired = ( /** @type {?} */(deferredBindingQueue[i++]));
            registerBinding(context, count, prop, bindingIndex, sanitizationRequired);
        }
        deferredBindingQueue.length = 0;
    }
    /**
     * Registers the provided binding (prop + bindingIndex) into the context.
     *
     * This function is shared between bindings that are assigned immediately
     * (via `updateBindingData`) and at a deferred stage. When called, it will
     * figure out exactly where to place the binding data in the context.
     *
     * It is needed because it will either update or insert a styling property
     * into the context at the correct spot.
     *
     * When called, one of two things will happen:
     *
     * 1) If the property already exists in the context then it will just add
     *    the provided `bindingValue` to the end of the binding sources region
     *    for that particular property.
     *
     *    - If the binding value is a number then it will be added as a new
     *      binding index source next to the other binding sources for the property.
     *
     *    - Otherwise, if the binding value is a string/boolean/null type then it will
     *      replace the default value for the property if the default value is `null`.
     *
     * 2) If the property does not exist then it will be inserted into the context.
     *    The styling context relies on all properties being stored in alphabetical
     *    order, so it knows exactly where to store it.
     *
     *    When inserted, a default `null` value is created for the property which exists
     *    as the default value for the binding. If the bindingValue property is inserted
     *    and it is either a string, number or null value then that will replace the default
     *    value.
     *
     * Note that this function is also used for map-based styling bindings. They are treated
     * much the same as prop-based bindings, but, because they do not have a property value
     * (since it's a map), all map-based entries are stored in an already populated area of
     * the context at the top (which is reserved for map-based entries).
     * @param {?} context
     * @param {?} countId
     * @param {?} prop
     * @param {?} bindingValue
     * @param {?=} sanitizationRequired
     * @return {?}
     */
    function registerBinding(context, countId, prop, bindingValue, sanitizationRequired) {
        /** @type {?} */
        var registered = false;
        if (prop) {
            // prop-based bindings (e.g `<div [style.width]="w" [class.foo]="f">`)
            /** @type {?} */
            var found = false;
            /** @type {?} */
            var i_24 = getPropValuesStartPosition(context);
            while (i_24 < context.length) {
                /** @type {?} */
                var valuesCount = getValuesCount(context, i_24);
                /** @type {?} */
                var p_2 = getProp(context, i_24);
                found = prop <= p_2;
                if (found) {
                    // all style/class bindings are sorted by property name
                    if (prop < p_2) {
                        allocateNewContextEntry(context, i_24, prop, sanitizationRequired);
                    }
                    addBindingIntoContext(context, false, i_24, bindingValue, countId);
                    break;
                }
                i_24 += 3 /* BindingsStartOffset */ + valuesCount;
            }
            if (!found) {
                allocateNewContextEntry(context, context.length, prop, sanitizationRequired);
                addBindingIntoContext(context, false, i_24, bindingValue, countId);
                registered = true;
            }
        }
        else {
            // map-based bindings (e.g `<div [style]="s" [class]="{className:true}">`)
            // there is no need to allocate the map-based binding region into the context
            // since it is already there when the context is first created.
            addBindingIntoContext(context, true, 3 /* MapBindingsPosition */, bindingValue, countId);
            registered = true;
        }
        return registered;
    }
    /**
     * @param {?} context
     * @param {?} index
     * @param {?} prop
     * @param {?=} sanitizationRequired
     * @return {?}
     */
    function allocateNewContextEntry(context, index, prop, sanitizationRequired) {
        // 1,2: splice index locations
        // 3: each entry gets a config value (guard mask + flags)
        // 4. each entry gets a size value (which is always one because there is always a default binding
        // value)
        // 5. the property that is getting allocated into the context
        // 6. the default binding value (usually `null`)
        /** @type {?} */
        var config = sanitizationRequired ? 1 /* SanitizationRequired */ :
            0 /* Default */;
        context.splice(index, 0, config, DEFAULT_SIZE_VALUE, prop, DEFAULT_BINDING_VALUE);
        setGuardMask(context, index, DEFAULT_GUARD_MASK_VALUE);
    }
    /**
     * Inserts a new binding value into a styling property tuple in the `TStylingContext`.
     *
     * A bindingValue is inserted into a context during the first update pass
     * of a template or host bindings function. When this occurs, two things
     * happen:
     *
     * - If the bindingValue value is a number then it is treated as a bindingIndex
     *   value (a index in the `LView`) and it will be inserted next to the other
     *   binding index entries.
     *
     * - Otherwise the binding value will update the default value for the property
     *   and this will only happen if the default value is `null`.
     *
     * Note that this function also handles map-based bindings and will insert them
     * at the top of the context.
     * @param {?} context
     * @param {?} isMapBased
     * @param {?} index
     * @param {?} bindingValue
     * @param {?} countId
     * @return {?}
     */
    function addBindingIntoContext(context, isMapBased, index, bindingValue, countId) {
        /** @type {?} */
        var valuesCount = getValuesCount(context, index);
        /** @type {?} */
        var firstValueIndex = index + 3 /* BindingsStartOffset */;
        /** @type {?} */
        var lastValueIndex = firstValueIndex + valuesCount;
        if (!isMapBased) {
            // prop-based values all have default values, but map-based entries do not.
            // we want to access the index for the default value in this case and not just
            // the bindings...
            lastValueIndex--;
        }
        if (typeof bindingValue === 'number') {
            // the loop here will check to see if the binding already exists
            // for the property in the context. Why? The reason for this is
            // because the styling context is not "locked" until the first
            // flush has occurred. This means that if a repeated element
            // registers its styling bindings then it will register each
            // binding more than once (since its duplicated). This check
            // will prevent that from happening. Note that this only happens
            // when a binding is first encountered and not each time it is
            // updated.
            for (var i_25 = firstValueIndex; i_25 <= lastValueIndex; i_25++) {
                /** @type {?} */
                var indexAtPosition = context[i_25];
                if (indexAtPosition === bindingValue)
                    return;
            }
            context.splice(lastValueIndex, 0, bindingValue);
            (( /** @type {?} */(context[index + 1 /* ValuesCountOffset */])))++;
            // now that a new binding index has been added to the property
            // the guard mask bit value (at the `countId` position) needs
            // to be included into the existing mask value.
            /** @type {?} */
            var guardMask = getGuardMask(context, index) | (1 << countId);
            setGuardMask(context, index, guardMask);
        }
        else if (bindingValue !== null && context[lastValueIndex] == null) {
            context[lastValueIndex] = bindingValue;
        }
    }
    /**
     * Applies all pending style and class bindings to the provided element.
     *
     * This function will attempt to flush styling via the provided `classesContext`
     * and `stylesContext` context values. This function is designed to be run from
     * the `stylingApply()` instruction (which is run at the very end of styling
     * change detection) and will rely on any state values that are set from when
     * any styling bindings update.
     *
     * This function may be called multiple times on the same element because it can
     * be called from the template code as well as from host bindings. In order for
     * styling to be successfully flushed to the element (which will only happen once
     * despite this being called multiple times), the following criteria must be met:
     *
     * - `flushStyling` is called from the very last directive that has styling for
     *    the element (see `allowStylingFlush()`).
     * - one or more bindings for classes or styles has updated (this is checked by
     *   examining the classes or styles bit mask).
     *
     * If the style and class values are successfully applied to the element then
     * the temporary state values for the element will be cleared. Otherwise, if
     * this did not occur then the styling state is persisted (see `state.ts` for
     * more information on how this works).
     * @param {?} renderer
     * @param {?} data
     * @param {?} classesContext
     * @param {?} stylesContext
     * @param {?} element
     * @param {?} directiveIndex
     * @param {?} styleSanitizer
     * @return {?}
     */
    function flushStyling(renderer, data, classesContext, stylesContext, element, directiveIndex, styleSanitizer) {
        ngDevMode && ngDevMode.flushStyling++;
        /** @type {?} */
        var persistState = classesContext ? stateIsPersisted(classesContext) :
            (stylesContext ? stateIsPersisted(stylesContext) : false);
        /** @type {?} */
        var allowFlushClasses = allowStylingFlush(classesContext, directiveIndex);
        /** @type {?} */
        var allowFlushStyles = allowStylingFlush(stylesContext, directiveIndex);
        // deferred bindings are bindings which are scheduled to register with
        // the context at a later point. These bindings can only registered when
        // the context will be 100% flushed to the element.
        if (deferredBindingQueue.length && (allowFlushClasses || allowFlushStyles)) {
            flushDeferredBindings();
        }
        /** @type {?} */
        var state = getStylingState(element, persistState);
        /** @type {?} */
        var classesFlushed = maybeApplyStyling(renderer, element, data, classesContext, allowFlushClasses, state.classesBitMask, setClass, null);
        /** @type {?} */
        var stylesFlushed = maybeApplyStyling(renderer, element, data, stylesContext, allowFlushStyles, state.stylesBitMask, setStyle, styleSanitizer);
        if (classesFlushed && stylesFlushed) {
            resetStylingState();
            if (persistState) {
                deleteStylingStateFromStorage(element);
            }
        }
        else if (persistState) {
            storeStylingState(element, state);
        }
    }
    /**
     * @param {?} renderer
     * @param {?} element
     * @param {?} data
     * @param {?} context
     * @param {?} allowFlush
     * @param {?} bitMask
     * @param {?} styleSetter
     * @param {?} styleSanitizer
     * @return {?}
     */
    function maybeApplyStyling(renderer, element, data, context, allowFlush, bitMask, styleSetter, styleSanitizer) {
        if (allowFlush && context) {
            lockAndFinalizeContext(context);
            if (contextHasUpdates(context, bitMask)) {
                ngDevMode && (styleSanitizer ? ngDevMode.stylesApplied++ : ngDevMode.classesApplied++);
                applyStyling(( /** @type {?} */(context)), renderer, element, data, bitMask, styleSetter, styleSanitizer);
                return true;
            }
        }
        return allowFlush;
    }
    /**
     * @param {?} context
     * @param {?} bitMask
     * @return {?}
     */
    function contextHasUpdates(context, bitMask) {
        return context && bitMask > BIT_MASK_START_VALUE;
    }
    /**
     * Locks the context (so no more bindings can be added) and also copies over initial class/style
     * values into their binding areas.
     *
     * There are two main actions that take place in this function:
     *
     * - Locking the context:
     *   Locking the context is required so that the style/class instructions know NOT to
     *   register a binding again after the first update pass has run. If a locking bit was
     *   not used then it would need to scan over the context each time an instruction is run
     *   (which is expensive).
     *
     * - Patching initial values:
     *   Directives and component host bindings may include static class/style values which are
     *   bound to the host element. When this happens, the styling context will need to be informed
     *   so it can use these static styling values as defaults when a matching binding is falsy.
     *   These initial styling values are read from the initial styling values slot within the
     *   provided `TStylingContext` (which is an instance of a `StylingMapArray`). This inner map will
     *   be updated each time a host binding applies its static styling values (via `elementHostAttrs`)
     *   so these values are only read at this point because this is the very last point before the
     *   first style/class values are flushed to the element.
     * @param {?} context
     * @return {?}
     */
    function lockAndFinalizeContext(context) {
        if (!isContextLocked(context)) {
            /** @type {?} */
            var initialValues = getStylingMapArray(context);
            if (initialValues) {
                updateInitialStylingOnContext(context, initialValues);
            }
            lockContext(context);
        }
    }
    /**
     * Runs through the provided styling context and applies each value to
     * the provided element (via the renderer) if one or more values are present.
     *
     * This function will iterate over all entries present in the provided
     * `TStylingContext` array (both prop-based and map-based bindings).-
     *
     * Each entry, within the `TStylingContext` array, is stored alphabetically
     * and this means that each prop/value entry will be applied in order
     * (so long as it is marked dirty in the provided `bitMask` value).
     *
     * If there are any map-based entries present (which are applied to the
     * element via the `[style]` and `[class]` bindings) then those entries
     * will be applied as well. However, the code for that is not a part of
     * this function. Instead, each time a property is visited, then the
     * code below will call an external function called `stylingMapsSyncFn`
     * and, if present, it will keep the application of styling values in
     * map-based bindings up to sync with the application of prop-based
     * bindings.
     *
     * Visit `styling_next/map_based_bindings.ts` to learn more about how the
     * algorithm works for map-based styling bindings.
     *
     * Note that this function is not designed to be called in isolation (use
     * `applyClasses` and `applyStyles` to actually apply styling values).
     * @param {?} context
     * @param {?} renderer
     * @param {?} element
     * @param {?} bindingData
     * @param {?} bitMaskValue
     * @param {?} applyStylingFn
     * @param {?} sanitizer
     * @return {?}
     */
    function applyStyling(context, renderer, element, bindingData, bitMaskValue, applyStylingFn, sanitizer) {
        /** @type {?} */
        var bitMask = normalizeBitMaskValue(bitMaskValue);
        /** @type {?} */
        var stylingMapsSyncFn = getStylingMapsSyncFn();
        /** @type {?} */
        var mapsGuardMask = getGuardMask(context, 3 /* MapBindingsPosition */);
        /** @type {?} */
        var applyAllValues = (bitMask & mapsGuardMask) > 0;
        /** @type {?} */
        var mapsMode = applyAllValues ? 1 /* ApplyAllValues */ : 0 /* TraverseValues */;
        /** @type {?} */
        var i = getPropValuesStartPosition(context);
        while (i < context.length) {
            /** @type {?} */
            var valuesCount = getValuesCount(context, i);
            /** @type {?} */
            var guardMask = getGuardMask(context, i);
            if (bitMask & guardMask) {
                /** @type {?} */
                var valueApplied = false;
                /** @type {?} */
                var prop = getProp(context, i);
                /** @type {?} */
                var valuesCountUpToDefault = valuesCount - 1;
                /** @type {?} */
                var defaultValue = ( /** @type {?} */(getBindingValue(context, i, valuesCountUpToDefault)));
                // case 1: apply prop-based values
                // try to apply the binding values and see if a non-null
                // value gets set for the styling binding
                for (var j_2 = 0; j_2 < valuesCountUpToDefault; j_2++) {
                    /** @type {?} */
                    var bindingIndex = ( /** @type {?} */(getBindingValue(context, i, j_2)));
                    /** @type {?} */
                    var value = bindingData[bindingIndex];
                    if (isStylingValueDefined(value)) {
                        /** @type {?} */
                        var finalValue = sanitizer && isSanitizationRequired(context, i) ?
                            sanitizer(prop, value, 2 /* SanitizeOnly */) :
                            value;
                        applyStylingFn(renderer, element, prop, finalValue, bindingIndex);
                        valueApplied = true;
                        break;
                    }
                }
                // case 2: apply map-based values
                // traverse through each map-based styling binding and update all values up to
                // the provided `prop` value. If the property was not applied in the loop above
                // then it will be attempted to be applied in the maps sync code below.
                if (stylingMapsSyncFn) {
                    // determine whether or not to apply the target property or to skip it
                    /** @type {?} */
                    var mode = mapsMode | (valueApplied ? 4 /* SkipTargetProp */ :
                        2 /* ApplyTargetProp */);
                    /** @type {?} */
                    var valueAppliedWithinMap = stylingMapsSyncFn(context, renderer, element, bindingData, applyStylingFn, sanitizer, mode, prop, defaultValue);
                    valueApplied = valueApplied || valueAppliedWithinMap;
                }
                // case 3: apply the default value
                // if the value has not yet been applied then a truthy value does not exist in the
                // prop-based or map-based bindings code. If and when this happens, just apply the
                // default value (even if the default value is `null`).
                if (!valueApplied) {
                    applyStylingFn(renderer, element, prop, defaultValue);
                }
            }
            i += 3 /* BindingsStartOffset */ + valuesCount;
        }
        // the map-based styling entries may have not applied all their
        // values. For this reason, one more call to the sync function
        // needs to be issued at the end.
        if (stylingMapsSyncFn) {
            stylingMapsSyncFn(context, renderer, element, bindingData, applyStylingFn, sanitizer, mapsMode);
        }
    }
    /**
     * @param {?} value
     * @return {?}
     */
    function normalizeBitMaskValue(value) {
        // if pass => apply all values (-1 implies that all bits are flipped to true)
        if (value === true)
            return -1;
        // if pass => skip all values
        if (value === false)
            return 0;
        // return the bit mask value as is
        return value;
    }
    /** @type {?} */
    var _activeStylingMapApplyFn = null;
    /**
     * @return {?}
     */
    function getStylingMapsSyncFn() {
        return _activeStylingMapApplyFn;
    }
    /**
     * @param {?} fn
     * @return {?}
     */
    function setStylingMapsSyncFn(fn) {
        _activeStylingMapApplyFn = fn;
    }
    /**
     * Assigns a style value to a style property for the given element.
     * @type {?}
     */
    var setStyle = ( /**
     * @param {?} renderer
     * @param {?} native
     * @param {?} prop
     * @param {?} value
     * @return {?}
     */function (renderer, native, prop, value) {
        // the reason why this may be `null` is either because
        // it's a container element or it's a part of a test
        // environment that doesn't have styling. In either
        // case it's safe not to apply styling to the element.
        /** @type {?} */
        var nativeStyle = native.style;
        if (value) {
            // opacity, z-index and flexbox all have number values
            // and these need to be converted into strings so that
            // they can be assigned properly.
            value = value.toString();
            ngDevMode && ngDevMode.rendererSetStyle++;
            renderer && isProceduralRenderer(renderer) ?
                renderer.setStyle(native, prop, value, RendererStyleFlags3.DashCase) :
                (nativeStyle && nativeStyle.setProperty(prop, value));
        }
        else {
            ngDevMode && ngDevMode.rendererRemoveStyle++;
            renderer && isProceduralRenderer(renderer) ?
                renderer.removeStyle(native, prop, RendererStyleFlags3.DashCase) :
                (nativeStyle && nativeStyle.removeProperty(prop));
        }
    });
    /**
     * Adds/removes the provided className value to the provided element.
     * @type {?}
     */
    var setClass = ( /**
     * @param {?} renderer
     * @param {?} native
     * @param {?} className
     * @param {?} value
     * @return {?}
     */function (renderer, native, className, value) {
        if (className !== '') {
            // the reason why this may be `null` is either because
            // it's a container element or it's a part of a test
            // environment that doesn't have styling. In either
            // case it's safe not to apply styling to the element.
            /** @type {?} */
            var classList = native.classList;
            if (value) {
                ngDevMode && ngDevMode.rendererAddClass++;
                renderer && isProceduralRenderer(renderer) ? renderer.addClass(native, className) :
                    (classList && classList.add(className));
            }
            else {
                ngDevMode && ngDevMode.rendererRemoveClass++;
                renderer && isProceduralRenderer(renderer) ? renderer.removeClass(native, className) :
                    (classList && classList.remove(className));
            }
        }
    });
    /**
     * Registers all initial styling entries into the provided context.
     *
     * This function will iterate over all entries in the provided `initialStyling` ar}ray and register
     * them as default (initial) values in the provided context. Initial styling values in a context are
     * the default values that are to be applied unless overwritten by a binding.
     *
     * The reason why this function exists and isn't a part of the context construction is because
     * host binding is evaluated at a later stage after the element is created. This means that
     * if a directive or component contains any initial styling code (i.e. `<div class="foo">`)
     * then that initial styling data can only be applied once the styling for that element
     * is first applied (at the end of the update phase). Once that happens then the context will
     * update itself with the complete initial styling for the element.
     * @param {?} context
     * @param {?} initialStyling
     * @return {?}
     */
    function updateInitialStylingOnContext(context, initialStyling) {
        // `-1` is used here because all initial styling data is not a spart
        // of a binding (since it's static)
        /** @type {?} */
        var INITIAL_STYLING_COUNT_ID = -1;
        for (var i_26 = 1 /* ValuesStartPosition */; i_26 < initialStyling.length; i_26 += 2 /* TupleSize */) {
            /** @type {?} */
            var value = getMapValue(initialStyling, i_26);
            if (value) {
                /** @type {?} */
                var prop = getMapProp(initialStyling, i_26);
                registerBinding(context, INITIAL_STYLING_COUNT_ID, prop, value, false);
            }
        }
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    // WARNING: interface has both a type and a value, skipping emit
    /**
     * A special value which designates that a value has not changed.
     * @type {?}
     */
    var NO_CHANGE = ( /** @type {?} */({}));
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     * @param {?} obj
     * @param {?} debug
     * @return {?}
     */
    function attachDebugObject(obj, debug) {
        Object.defineProperty(obj, 'debug', { value: debug, enumerable: false });
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Used to apply styling values presently within any map-based bindings on an element.
     *
     * Angular supports map-based styling bindings which can be applied via the
     * `[style]` and `[class]` bindings which can be placed on any HTML element.
     * These bindings can work independently, together or alongside prop-based
     * styling bindings (e.g. `<div [style]="x" [style.width]="w">`).
     *
     * If a map-based styling binding is detected by the compiler, the following
     * AOT code is produced:
     *
     * ```typescript
     * styleMap(ctx.styles); // styles = {key:value}
     * classMap(ctx.classes); // classes = {key:value}|string
     * ```
     *
     * If and when either of the instructions above are evaluated, then the code
     * present in this file is included into the bundle. The mechanism used, to
     * activate support for map-based bindings at runtime is possible via the
     * `activeStylingMapFeature` function (which is also present in this file).
     *
     * # The Algorithm
     * Whenever a map-based binding updates (which is when the identity of the
     * map-value changes) then the map is iterated over and a `StylingMapArray` array
     * is produced. The `StylingMapArray` instance is stored in the binding location
     * where the `BINDING_INDEX` is situated when the `styleMap()` or `classMap()`
     * instruction were called. Once the binding changes, then the internal `bitMask`
     * value is marked as dirty.
     *
     * Styling values are applied once CD exits the element (which happens when
     * the `select(n)` instruction is called or the template function exits). When
     * this occurs, all prop-based bindings are applied. If a map-based binding is
     * present then a special flushing function (called a sync function) is made
     * available and it will be called each time a styling property is flushed.
     *
     * The flushing algorithm is designed to apply styling for a property (which is
     * a CSS property or a className value) one by one. If map-based bindings
     * are present, then the flushing algorithm will keep calling the maps styling
     * sync function each time a property is visited. This way, the flushing
     * behavior of map-based bindings will always be at the same property level
     * as the current prop-based property being iterated over (because everything
     * is alphabetically sorted).
     *
     * Let's imagine we have the following HTML template code:
     *
     * ```html
     * <div [style]="{width:'100px', height:'200px', 'z-index':'10'}"
     *      [style.width.px]="200">...</div>
     * ```
     *
     * When CD occurs, both the `[style]` and `[style.width]` bindings
     * are evaluated. Then when the styles are flushed on screen, the
     * following operations happen:
     *
     * 1. `[style.width]` is attempted to be written to the element.
     *
     * 2.  Once that happens, the algorithm instructs the map-based
     *     entries (`[style]` in this case) to "catch up" and apply
     *     all values up to the `width` value. When this happens the
     *     `height` value is applied to the element (since it is
     *     alphabetically situated before the `width` property).
     *
     * 3. Since there are no more prop-based entries anymore, the
     *    loop exits and then, just before the flushing ends, it
     *    instructs all map-based bindings to "finish up" applying
     *    their values.
     *
     * 4. The only remaining value within the map-based entries is
     *    the `z-index` value (`width` got skipped because it was
     *    successfully applied via the prop-based `[style.width]`
     *    binding). Since all map-based entries are told to "finish up",
     *    the `z-index` value is iterated over and it is then applied
     *    to the element.
     *
     * The most important thing to take note of here is that prop-based
     * bindings are evaluated in order alongside map-based bindings.
     * This allows all styling across an element to be applied in O(n)
     * time (a similar algorithm is that of the array merge algorithm
     * in merge sort).
     * @type {?}
     */
    var syncStylingMap = ( /**
     * @param {?} context
     * @param {?} renderer
     * @param {?} element
     * @param {?} data
     * @param {?} applyStylingFn
     * @param {?} sanitizer
     * @param {?} mode
     * @param {?=} targetProp
     * @param {?=} defaultValue
     * @return {?}
     */function (context, renderer, element, data, applyStylingFn, sanitizer, mode, targetProp, defaultValue) {
        /** @type {?} */
        var targetPropValueWasApplied = false;
        // once the map-based styling code is activate it is never deactivated. For this reason a
        // check to see if the current styling context has any map based bindings is required.
        /** @type {?} */
        var totalMaps = getValuesCount(context, 3 /* MapBindingsPosition */);
        if (totalMaps) {
            /** @type {?} */
            var runTheSyncAlgorithm = true;
            /** @type {?} */
            var loopUntilEnd = !targetProp;
            // If the code is told to finish up (run until the end), but the mode
            // hasn't been flagged to apply values (it only traverses values) then
            // there is no point in iterating over the array because nothing will
            // be applied to the element.
            if (loopUntilEnd && (mode & ~1 /* ApplyAllValues */)) {
                runTheSyncAlgorithm = false;
                targetPropValueWasApplied = true;
            }
            if (runTheSyncAlgorithm) {
                targetPropValueWasApplied = innerSyncStylingMap(context, renderer, element, data, applyStylingFn, sanitizer, mode, targetProp || null, 0, defaultValue || null);
            }
            if (loopUntilEnd) {
                resetSyncCursors();
            }
        }
        return targetPropValueWasApplied;
    });
    /**
     * Recursive function designed to apply map-based styling to an element one map at a time.
     *
     * This function is designed to be called from the `syncStylingMap` function and will
     * apply map-based styling data one map at a time to the provided `element`.
     *
     * This function is recursive and it will call itself if a follow-up map value is to be
     * processed. To learn more about how the algorithm works, see `syncStylingMap`.
     * @param {?} context
     * @param {?} renderer
     * @param {?} element
     * @param {?} data
     * @param {?} applyStylingFn
     * @param {?} sanitizer
     * @param {?} mode
     * @param {?} targetProp
     * @param {?} currentMapIndex
     * @param {?} defaultValue
     * @return {?}
     */
    function innerSyncStylingMap(context, renderer, element, data, applyStylingFn, sanitizer, mode, targetProp, currentMapIndex, defaultValue) {
        /** @type {?} */
        var targetPropValueWasApplied = false;
        /** @type {?} */
        var totalMaps = getValuesCount(context, 3 /* MapBindingsPosition */);
        if (currentMapIndex < totalMaps) {
            /** @type {?} */
            var bindingIndex = ( /** @type {?} */(getBindingValue(context, 3 /* MapBindingsPosition */, currentMapIndex)));
            /** @type {?} */
            var stylingMapArr = ( /** @type {?} */(data[bindingIndex]));
            /** @type {?} */
            var cursor = getCurrentSyncCursor(currentMapIndex);
            while (cursor < stylingMapArr.length) {
                /** @type {?} */
                var prop = getMapProp(stylingMapArr, cursor);
                /** @type {?} */
                var iteratedTooFar = targetProp && prop > targetProp;
                /** @type {?} */
                var isTargetPropMatched = !iteratedTooFar && prop === targetProp;
                /** @type {?} */
                var value = getMapValue(stylingMapArr, cursor);
                /** @type {?} */
                var valueIsDefined = isStylingValueDefined(value);
                // the recursive code is designed to keep applying until
                // it reaches or goes past the target prop. If and when
                // this happens then it will stop processing values, but
                // all other map values must also catch up to the same
                // point. This is why a recursive call is still issued
                // even if the code has iterated too far.
                /** @type {?} */
                var innerMode = iteratedTooFar ? mode : resolveInnerMapMode(mode, valueIsDefined, isTargetPropMatched);
                /** @type {?} */
                var innerProp = iteratedTooFar ? targetProp : prop;
                /** @type {?} */
                var valueApplied = innerSyncStylingMap(context, renderer, element, data, applyStylingFn, sanitizer, innerMode, innerProp, currentMapIndex + 1, defaultValue);
                if (iteratedTooFar) {
                    if (!targetPropValueWasApplied) {
                        targetPropValueWasApplied = valueApplied;
                    }
                    break;
                }
                if (!valueApplied && isValueAllowedToBeApplied(mode, isTargetPropMatched)) {
                    /** @type {?} */
                    var useDefault = isTargetPropMatched && !valueIsDefined;
                    /** @type {?} */
                    var valueToApply = useDefault ? defaultValue : value;
                    /** @type {?} */
                    var bindingIndexToApply = useDefault ? bindingIndex : null;
                    /** @type {?} */
                    var finalValue = sanitizer ?
                        sanitizer(prop, valueToApply, 3 /* ValidateAndSanitize */) :
                        valueToApply;
                    applyStylingFn(renderer, element, prop, finalValue, bindingIndexToApply);
                    valueApplied = true;
                }
                targetPropValueWasApplied = valueApplied && isTargetPropMatched;
                cursor += 2 /* TupleSize */;
            }
            setCurrentSyncCursor(currentMapIndex, cursor);
            // this is a fallback case in the event that the styling map is `null` for this
            // binding but there are other map-based bindings that need to be evaluated
            // afterwards. If the `prop` value is falsy then the intention is to cycle
            // through all of the properties in the remaining maps as well. If the current
            // styling map is too short then there are no values to iterate over. In either
            // case the follow-up maps need to be iterated over.
            if (stylingMapArr.length === 1 /* ValuesStartPosition */ || !targetProp) {
                return innerSyncStylingMap(context, renderer, element, data, applyStylingFn, sanitizer, mode, targetProp, currentMapIndex + 1, defaultValue);
            }
        }
        return targetPropValueWasApplied;
    }
    /**
     * Enables support for map-based styling bindings (e.g. `[style]` and `[class]` bindings).
     * @return {?}
     */
    function activateStylingMapFeature() {
        setStylingMapsSyncFn(syncStylingMap);
    }
    /**
     * Used to determine the mode for the inner recursive call.
     *
     * If an inner map is iterated on then this is done so for one
     * of two reasons:
     *
     * - value is being applied:
     *   if the value is being applied from this current styling
     *   map then there is no need to apply it in a deeper map.
     *
     * - value is being not applied:
     *   apply the value if it is found in a deeper map.
     *
     * When these reasons are encountered the flags will for the
     * inner map mode will be configured.
     * @param {?} currentMode
     * @param {?} valueIsDefined
     * @param {?} isExactMatch
     * @return {?}
     */
    function resolveInnerMapMode(currentMode, valueIsDefined, isExactMatch) {
        /** @type {?} */
        var innerMode = currentMode;
        if (!valueIsDefined && !(currentMode & 4 /* SkipTargetProp */) &&
            (isExactMatch || (currentMode & 1 /* ApplyAllValues */))) {
            // case 1: set the mode to apply the targeted prop value if it
            // ends up being encountered in another map value
            innerMode |= 2 /* ApplyTargetProp */;
            innerMode &= ~4 /* SkipTargetProp */;
        }
        else {
            // case 2: set the mode to skip the targeted prop value if it
            // ends up being encountered in another map value
            innerMode |= 4 /* SkipTargetProp */;
            innerMode &= ~2 /* ApplyTargetProp */;
        }
        return innerMode;
    }
    /**
     * Decides whether or not a prop/value entry will be applied to an element.
     *
     * To determine whether or not a value is to be applied,
     * the following procedure is evaluated:
     *
     * First check to see the current `mode` status:
     *  1. If the mode value permits all props to be applied then allow.
     *    - But do not allow if the current prop is set to be skipped.
     *  2. Otherwise if the current prop is permitted then allow.
     * @param {?} mode
     * @param {?} isTargetPropMatched
     * @return {?}
     */
    function isValueAllowedToBeApplied(mode, isTargetPropMatched) {
        /** @type {?} */
        var doApplyValue = (mode & 1 /* ApplyAllValues */) > 0;
        if (!doApplyValue) {
            if (mode & 2 /* ApplyTargetProp */) {
                doApplyValue = isTargetPropMatched;
            }
        }
        else if ((mode & 4 /* SkipTargetProp */) && isTargetPropMatched) {
            doApplyValue = false;
        }
        return doApplyValue;
    }
    /**
     * Used to keep track of concurrent cursor values for multiple map-based styling bindings present on
     * an element.
     * @type {?}
     */
    var MAP_CURSORS = [];
    /**
     * Used to reset the state of each cursor value being used to iterate over map-based styling
     * bindings.
     * @return {?}
     */
    function resetSyncCursors() {
        for (var i_27 = 0; i_27 < MAP_CURSORS.length; i_27++) {
            MAP_CURSORS[i_27] = 1 /* ValuesStartPosition */;
        }
    }
    /**
     * Returns an active cursor value at a given mapIndex location.
     * @param {?} mapIndex
     * @return {?}
     */
    function getCurrentSyncCursor(mapIndex) {
        if (mapIndex >= MAP_CURSORS.length) {
            MAP_CURSORS.push(1 /* ValuesStartPosition */);
        }
        return MAP_CURSORS[mapIndex];
    }
    /**
     * Sets a cursor value at a given mapIndex location.
     * @param {?} mapIndex
     * @param {?} indexValue
     * @return {?}
     */
    function setCurrentSyncCursor(mapIndex, indexValue) {
        MAP_CURSORS[mapIndex] = indexValue;
    }
    /**
     * Used to convert a {key:value} map into a `StylingMapArray` array.
     *
     * This function will either generate a new `StylingMapArray` instance
     * or it will patch the provided `newValues` map value into an
     * existing `StylingMapArray` value (this only happens if `bindingValue`
     * is an instance of `StylingMapArray`).
     *
     * If a new key/value map is provided with an old `StylingMapArray`
     * value then all properties will be overwritten with their new
     * values or with `null`. This means that the array will never
     * shrink in size (but it will also not be created and thrown
     * away whenever the {key:value} map entries change).
     * @param {?} bindingValue
     * @param {?} newValues
     * @param {?=} normalizeProps
     * @return {?}
     */
    function normalizeIntoStylingMap(bindingValue, newValues, normalizeProps) {
        /** @type {?} */
        var stylingMapArr = Array.isArray(bindingValue) ? bindingValue : [null];
        stylingMapArr[0 /* RawValuePosition */] = newValues || null;
        // because the new values may not include all the properties
        // that the old ones had, all values are set to `null` before
        // the new values are applied. This way, when flushed, the
        // styling algorithm knows exactly what style/class values
        // to remove from the element (since they are `null`).
        for (var j_3 = 1 /* ValuesStartPosition */; j_3 < stylingMapArr.length; j_3 += 2 /* TupleSize */) {
            setMapValue(stylingMapArr, j_3, null);
        }
        /** @type {?} */
        var props = null;
        /** @type {?} */
        var map;
        /** @type {?} */
        var allValuesTrue = false;
        if (typeof newValues === 'string') { // [class] bindings allow string values
            if (newValues.length) {
                props = newValues.split(/\s+/);
                allValuesTrue = true;
            }
        }
        else {
            props = newValues ? Object.keys(newValues) : null;
            map = newValues;
        }
        if (props) {
            for (var i_28 = 0; i_28 < props.length; i_28++) {
                /** @type {?} */
                var prop = ( /** @type {?} */(props[i_28]));
                /** @type {?} */
                var newProp = normalizeProps ? hyphenate(prop) : prop;
                /** @type {?} */
                var value = allValuesTrue ? true : ( /** @type {?} */(map))[prop];
                addItemToStylingMap(stylingMapArr, newProp, value, true);
            }
        }
        return stylingMapArr;
    }
    /**
     * Inserts the provided item into the provided styling array at the right spot.
     *
     * The `StylingMapArray` type is a sorted key/value array of entries. This means
     * that when a new entry is inserted it must be placed at the right spot in the
     * array. This function figures out exactly where to place it.
     * @param {?} stylingMapArr
     * @param {?} prop
     * @param {?} value
     * @param {?=} allowOverwrite
     * @return {?}
     */
    function addItemToStylingMap(stylingMapArr, prop, value, allowOverwrite) {
        for (var j_4 = 1 /* ValuesStartPosition */; j_4 < stylingMapArr.length; j_4 += 2 /* TupleSize */) {
            /** @type {?} */
            var propAtIndex = getMapProp(stylingMapArr, j_4);
            if (prop <= propAtIndex) {
                /** @type {?} */
                var applied = false;
                if (propAtIndex === prop) {
                    /** @type {?} */
                    var valueAtIndex = stylingMapArr[j_4];
                    if (allowOverwrite || !isStylingValueDefined(valueAtIndex)) {
                        applied = true;
                        setMapValue(stylingMapArr, j_4, value);
                    }
                }
                else {
                    applied = true;
                    stylingMapArr.splice(j_4, 0, prop, value);
                }
                return applied;
            }
        }
        stylingMapArr.push(prop, value);
        return true;
    }
    /**
     * Instantiates and attaches an instance of `TStylingContextDebug` to the provided context.
     * @param {?} context
     * @return {?}
     */
    function attachStylingDebugObject(context) {
        /** @type {?} */
        var debug = new TStylingContextDebug(context);
        attachDebugObject(context, debug);
        return debug;
    }
    /**
     * A human-readable debug summary of the styling data present within `TStylingContext`.
     *
     * This class is designed to be used within testing code or when an
     * application has `ngDevMode` activated.
     */
    var TStylingContextDebug = /** @class */ (function () {
        /**
         * @param {?} context
         */
        function TStylingContextDebug(context) {
            this.context = context;
        }
        Object.defineProperty(TStylingContextDebug.prototype, "isLocked", {
            /**
             * @return {?}
             */
            get: function () { return isContextLocked(this.context); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TStylingContextDebug.prototype, "entries", {
            /**
             * Returns a detailed summary of each styling entry in the context.
             *
             * See `TStylingTupleSummary`.
             * @return {?}
             */
            get: function () {
                /** @type {?} */
                var context = this.context;
                /** @type {?} */
                var entries = {};
                /** @type {?} */
                var start = 3 /* MapBindingsPosition */;
                /** @type {?} */
                var i = start;
                while (i < context.length) {
                    /** @type {?} */
                    var valuesCount = getValuesCount(context, i);
                    // the context may contain placeholder values which are populated ahead of time,
                    // but contain no actual binding values. In this situation there is no point in
                    // classifying this as an "entry" since no real data is stored here yet.
                    if (valuesCount) {
                        /** @type {?} */
                        var prop = getProp(context, i);
                        /** @type {?} */
                        var guardMask = getGuardMask(context, i);
                        /** @type {?} */
                        var defaultValue = getDefaultValue(context, i);
                        /** @type {?} */
                        var sanitizationRequired = isSanitizationRequired(context, i);
                        /** @type {?} */
                        var bindingsStartPosition = i + 3 /* BindingsStartOffset */;
                        /** @type {?} */
                        var sources = [];
                        for (var j_5 = 0; j_5 < valuesCount; j_5++) {
                            sources.push(( /** @type {?} */(context[bindingsStartPosition + j_5])));
                        }
                        entries[prop] = { prop: prop, guardMask: guardMask, sanitizationRequired: sanitizationRequired, valuesCount: valuesCount, defaultValue: defaultValue, sources: sources };
                    }
                    i += 3 /* BindingsStartOffset */ + valuesCount;
                }
                return entries;
            },
            enumerable: true,
            configurable: true
        });
        return TStylingContextDebug;
    }());
    /**
     * A human-readable debug summary of the styling data present for a `DebugNode` instance.
     *
     * This class is designed to be used within testing code or when an
     * application has `ngDevMode` activated.
     */
    var NodeStylingDebug = /** @class */ (function () {
        /**
         * @param {?} context
         * @param {?} _data
         * @param {?=} _isClassBased
         */
        function NodeStylingDebug(context, _data, _isClassBased) {
            this.context = context;
            this._data = _data;
            this._isClassBased = _isClassBased;
            this._sanitizer = null;
        }
        /**
         * Overrides the sanitizer used to process styles.
         * @param {?} sanitizer
         * @return {?}
         */
        NodeStylingDebug.prototype.overrideSanitizer = function (sanitizer) { this._sanitizer = sanitizer; };
        Object.defineProperty(NodeStylingDebug.prototype, "summary", {
            /**
             * Returns a detailed summary of each styling entry in the context and
             * what their runtime representation is.
             *
             * See `LStylingSummary`.
             * @return {?}
             */
            get: function () {
                /** @type {?} */
                var entries = {};
                this._mapValues(( /**
                 * @param {?} prop
                 * @param {?} value
                 * @param {?} bindingIndex
                 * @return {?}
                 */function (prop, value, bindingIndex) {
                    entries[prop] = { prop: prop, value: value, bindingIndex: bindingIndex };
                }));
                return entries;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NodeStylingDebug.prototype, "values", {
            /**
             * Returns a key/value map of all the styles/classes that were last applied to the element.
             * @return {?}
             */
            get: function () {
                /** @type {?} */
                var entries = {};
                this._mapValues(( /**
                 * @param {?} prop
                 * @param {?} value
                 * @return {?}
                 */function (prop, value) { entries[prop] = value; }));
                return entries;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @private
         * @param {?} fn
         * @return {?}
         */
        NodeStylingDebug.prototype._mapValues = function (fn) {
            // there is no need to store/track an element instance. The
            // element is only used when the styling algorithm attempts to
            // style the value (and we mock out the stylingApplyFn anyway).
            /** @type {?} */
            var mockElement = ( /** @type {?} */({}));
            /** @type {?} */
            var hasMaps = getValuesCount(this.context, 3 /* MapBindingsPosition */) > 0;
            if (hasMaps) {
                activateStylingMapFeature();
            }
            /** @type {?} */
            var mapFn = ( /**
             * @param {?} renderer
             * @param {?} element
             * @param {?} prop
             * @param {?} value
             * @param {?=} bindingIndex
             * @return {?}
             */function (renderer, element, prop, value, bindingIndex) { fn(prop, value, bindingIndex || null); });
            /** @type {?} */
            var sanitizer = this._isClassBased ? null : (this._sanitizer || getCurrentStyleSanitizer());
            applyStyling(this.context, null, mockElement, this._data, true, mapFn, sanitizer);
        };
        return NodeStylingDebug;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /*
     * This file contains conditionally attached classes which provide human readable (debug) level
     * information for `LView`, `LContainer` and other internal data structures. These data structures
     * are stored internally as array which makes it very difficult during debugging to reason about the
     * current state of the system.
     *
     * Patching the array with extra property does change the array's hidden class' but it does not
     * change the cost of access, therefore this patching should not have significant if any impact in
     * `ngDevMode` mode. (see: https://jsperf.com/array-vs-monkey-patch-array)
     *
     * So instead of seeing:
     * ```
     * Array(30) [Object, 659, null, …]
     * ```
     *
     * You get to see:
     * ```
     * LViewDebug {
     *   views: [...],
     *   flags: {attached: true, ...}
     *   nodes: [
     *     {html: '<div id="123">', ..., nodes: [
     *       {html: '<span>', ..., nodes: null}
     *     ]}
     *   ]
     * }
     * ```
     */
    /** @type {?} */
    var LViewArray = ngDevMode && createNamedArrayType('LView');
    /** @type {?} */
    var LVIEW_EMPTY;
    // can't initialize here or it will not be tree shaken, because `LView`
    // constructor could have side-effects.
    /**
     * This function clones a blueprint and creates LView.
     *
     * Simple slice will keep the same type, and we need it to be LView
     * @param {?} list
     * @return {?}
     */
    function cloneToLView(list) {
        if (LVIEW_EMPTY === undefined)
            LVIEW_EMPTY = new ( /** @type {?} */(LViewArray))();
        return ( /** @type {?} */(LVIEW_EMPTY.concat(list)));
    }
    /**
     * This class is a debug version of Object literal so that we can have constructor name show up in
     * debug tools in ngDevMode.
     * @type {?}
     */
    var TViewConstructor = /** @class */ (function () {
        /**
         * @param {?} id
         * @param {?} blueprint
         * @param {?} template
         * @param {?} queries
         * @param {?} viewQuery
         * @param {?} node
         * @param {?} data
         * @param {?} bindingStartIndex
         * @param {?} expandoStartIndex
         * @param {?} expandoInstructions
         * @param {?} firstTemplatePass
         * @param {?} staticViewQueries
         * @param {?} staticContentQueries
         * @param {?} preOrderHooks
         * @param {?} preOrderCheckHooks
         * @param {?} contentHooks
         * @param {?} contentCheckHooks
         * @param {?} viewHooks
         * @param {?} viewCheckHooks
         * @param {?} destroyHooks
         * @param {?} cleanup
         * @param {?} contentQueries
         * @param {?} components
         * @param {?} directiveRegistry
         * @param {?} pipeRegistry
         * @param {?} firstChild
         * @param {?} schemas
         */
        function TView(id, //
        blueprint, //
        template, //
        queries, //
        viewQuery, //
        node, //
        data, //
        bindingStartIndex, //
        expandoStartIndex, //
        expandoInstructions, //
        firstTemplatePass, //
        staticViewQueries, //
        staticContentQueries, //
        preOrderHooks, //
        preOrderCheckHooks, //
        contentHooks, //
        contentCheckHooks, //
        viewHooks, //
        viewCheckHooks, //
        destroyHooks, //
        cleanup, //
        contentQueries, //
        components, //
        directiveRegistry, //
        pipeRegistry, //
        firstChild, //
        schemas) {
            this.id = id;
            this.blueprint = blueprint;
            this.template = template;
            this.queries = queries;
            this.viewQuery = viewQuery;
            this.node = node;
            this.data = data;
            this.bindingStartIndex = bindingStartIndex;
            this.expandoStartIndex = expandoStartIndex;
            this.expandoInstructions = expandoInstructions;
            this.firstTemplatePass = firstTemplatePass;
            this.staticViewQueries = staticViewQueries;
            this.staticContentQueries = staticContentQueries;
            this.preOrderHooks = preOrderHooks;
            this.preOrderCheckHooks = preOrderCheckHooks;
            this.contentHooks = contentHooks;
            this.contentCheckHooks = contentCheckHooks;
            this.viewHooks = viewHooks;
            this.viewCheckHooks = viewCheckHooks;
            this.destroyHooks = destroyHooks;
            this.cleanup = cleanup;
            this.contentQueries = contentQueries;
            this.components = components;
            this.directiveRegistry = directiveRegistry;
            this.pipeRegistry = pipeRegistry;
            this.firstChild = firstChild;
            this.schemas = schemas;
        }
        return TView;
    }());
    /** @type {?} */
    var TNodeConstructor = /** @class */ (function () {
        /**
         * @param {?} tView_
         * @param {?} type
         * @param {?} index
         * @param {?} injectorIndex
         * @param {?} directiveStart
         * @param {?} directiveEnd
         * @param {?} propertyMetadataStartIndex
         * @param {?} propertyMetadataEndIndex
         * @param {?} flags
         * @param {?} providerIndexes
         * @param {?} tagName
         * @param {?} attrs
         * @param {?} localNames
         * @param {?} initialInputs
         * @param {?} inputs
         * @param {?} outputs
         * @param {?} tViews
         * @param {?} next
         * @param {?} projectionNext
         * @param {?} child
         * @param {?} parent
         * @param {?} projection
         * @param {?} styles
         * @param {?} classes
         */
        function TNode(tView_, //
        type, //
        index, //
        injectorIndex, //
        directiveStart, //
        directiveEnd, //
        propertyMetadataStartIndex, //
        propertyMetadataEndIndex, //
        flags, //
        providerIndexes, //
        tagName, //
        attrs, //
        localNames, //
        initialInputs, //
        inputs, //
        outputs, //
        tViews, //
        next, //
        projectionNext, //
        child, //
        parent, //
        projection, //
        styles, //
        classes) {
            this.tView_ = tView_;
            this.type = type;
            this.index = index;
            this.injectorIndex = injectorIndex;
            this.directiveStart = directiveStart;
            this.directiveEnd = directiveEnd;
            this.propertyMetadataStartIndex = propertyMetadataStartIndex;
            this.propertyMetadataEndIndex = propertyMetadataEndIndex;
            this.flags = flags;
            this.providerIndexes = providerIndexes;
            this.tagName = tagName;
            this.attrs = attrs;
            this.localNames = localNames;
            this.initialInputs = initialInputs;
            this.inputs = inputs;
            this.outputs = outputs;
            this.tViews = tViews;
            this.next = next;
            this.projectionNext = projectionNext;
            this.child = child;
            this.parent = parent;
            this.projection = projection;
            this.styles = styles;
            this.classes = classes;
        }
        Object.defineProperty(TNode.prototype, "type_", {
            /**
             * @return {?}
             */
            get: function () {
                switch (this.type) {
                    case 0 /* Container */:
                        return 'TNodeType.Container';
                    case 3 /* Element */:
                        return 'TNodeType.Element';
                    case 4 /* ElementContainer */:
                        return 'TNodeType.ElementContainer';
                    case 5 /* IcuContainer */:
                        return 'TNodeType.IcuContainer';
                    case 1 /* Projection */:
                        return 'TNodeType.Projection';
                    case 2 /* View */:
                        return 'TNodeType.View';
                    default:
                        return 'TNodeType.???';
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TNode.prototype, "flags_", {
            /**
             * @return {?}
             */
            get: function () {
                /** @type {?} */
                var flags = [];
                if (this.flags & 8 /* hasClassInput */)
                    flags.push('TNodeFlags.hasClassInput');
                if (this.flags & 4 /* hasContentQuery */)
                    flags.push('TNodeFlags.hasContentQuery');
                if (this.flags & 16 /* hasStyleInput */)
                    flags.push('TNodeFlags.hasStyleInput');
                if (this.flags & 1 /* isComponent */)
                    flags.push('TNodeFlags.isComponent');
                if (this.flags & 32 /* isDetached */)
                    flags.push('TNodeFlags.isDetached');
                if (this.flags & 2 /* isProjected */)
                    flags.push('TNodeFlags.isProjected');
                return flags.join('|');
            },
            enumerable: true,
            configurable: true
        });
        return TNode;
    }());
    /** @type {?} */
    var TViewData = ngDevMode && createNamedArrayType('TViewData');
    /** @type {?} */
    var TVIEWDATA_EMPTY;
    // can't initialize here or it will not be tree shaken, because `LView`
    // constructor could have side-effects.
    /**
     * This function clones a blueprint and creates TData.
     *
     * Simple slice will keep the same type, and we need it to be TData
     * @param {?} list
     * @return {?}
     */
    function cloneToTViewData(list) {
        if (TVIEWDATA_EMPTY === undefined)
            TVIEWDATA_EMPTY = new ( /** @type {?} */(TViewData))();
        return ( /** @type {?} */(TVIEWDATA_EMPTY.concat(list)));
    }
    /** @type {?} */
    var LViewBlueprint = ngDevMode && createNamedArrayType('LViewBlueprint');
    /** @type {?} */
    var MatchesArray = ngDevMode && createNamedArrayType('MatchesArray');
    /** @type {?} */
    var TViewComponents = ngDevMode && createNamedArrayType('TViewComponents');
    /** @type {?} */
    var TNodeLocalNames = ngDevMode && createNamedArrayType('TNodeLocalNames');
    /** @type {?} */
    var TNodeInitialInputs = ngDevMode && createNamedArrayType('TNodeInitialInputs');
    /** @type {?} */
    var TNodeInitialData = ngDevMode && createNamedArrayType('TNodeInitialData');
    /** @type {?} */
    var LCleanup = ngDevMode && createNamedArrayType('LCleanup');
    /** @type {?} */
    var TCleanup = ngDevMode && createNamedArrayType('TCleanup');
    /**
     * @param {?} lView
     * @return {?}
     */
    function attachLViewDebug(lView) {
        attachDebugObject(lView, new LViewDebug(lView));
    }
    /**
     * @param {?} obj
     * @return {?}
     */
    function toDebug(obj) {
        if (obj) {
            /** @type {?} */
            var debug = (( /** @type {?} */(obj))).debug;
            assertDefined(debug, 'Object does not have a debug representation.');
            return debug;
        }
        else {
            return obj;
        }
    }
    /**
     * Use this method to unwrap a native element in `LView` and convert it into HTML for easier
     * reading.
     *
     * @param {?} value possibly wrapped native DOM node.
     * @param {?=} includeChildren If `true` then the serialized HTML form will include child elements (same
     * as `outerHTML`). If `false` then the serialized HTML form will only contain the element itself
     * (will not serialize child elements).
     * @return {?}
     */
    function toHtml(value, includeChildren) {
        if (includeChildren === void 0) { includeChildren = false; }
        /** @type {?} */
        var node = ( /** @type {?} */(unwrapRNode(value)));
        if (node) {
            /** @type {?} */
            var isTextNode = node.nodeType === Node.TEXT_NODE;
            /** @type {?} */
            var outerHTML = (isTextNode ? node.textContent : node.outerHTML) || '';
            if (includeChildren || isTextNode) {
                return outerHTML;
            }
            else {
                /** @type {?} */
                var innerHTML = node.innerHTML;
                return outerHTML.split(innerHTML)[0] || null;
            }
        }
        else {
            return null;
        }
    }
    var LViewDebug = /** @class */ (function () {
        /**
         * @param {?} _raw_lView
         */
        function LViewDebug(_raw_lView) {
            this._raw_lView = _raw_lView;
        }
        Object.defineProperty(LViewDebug.prototype, "flags", {
            /**
             * Flags associated with the `LView` unpacked into a more readable state.
             * @return {?}
             */
            get: function () {
                /** @type {?} */
                var flags = this._raw_lView[FLAGS];
                return {
                    __raw__flags__: flags,
                    initPhaseState: flags & 3 /* InitPhaseStateMask */,
                    creationMode: !!(flags & 4 /* CreationMode */),
                    firstViewPass: !!(flags & 8 /* FirstLViewPass */),
                    checkAlways: !!(flags & 16 /* CheckAlways */),
                    dirty: !!(flags & 64 /* Dirty */),
                    attached: !!(flags & 128 /* Attached */),
                    destroyed: !!(flags & 256 /* Destroyed */),
                    isRoot: !!(flags & 512 /* IsRoot */),
                    indexWithinInitPhase: flags >> 10 /* IndexWithinInitPhaseShift */,
                };
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LViewDebug.prototype, "parent", {
            /**
             * @return {?}
             */
            get: function () { return toDebug(this._raw_lView[PARENT]); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LViewDebug.prototype, "host", {
            /**
             * @return {?}
             */
            get: function () { return toHtml(this._raw_lView[HOST], true); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LViewDebug.prototype, "context", {
            /**
             * @return {?}
             */
            get: function () { return this._raw_lView[CONTEXT]; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LViewDebug.prototype, "nodes", {
            /**
             * The tree of nodes associated with the current `LView`. The nodes have been normalized into a
             * tree structure with relevant details pulled out for readability.
             * @return {?}
             */
            get: function () {
                /** @type {?} */
                var lView = this._raw_lView;
                /** @type {?} */
                var tNode = lView[TVIEW].firstChild;
                return toDebugNodes(tNode, lView);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LViewDebug.prototype, "__other__", {
            /**
             * Additional information which is hidden behind a property. The extra level of indirection is
             * done so that the debug view would not be cluttered with properties which are only rarely
             * relevant to the developer.
             * @return {?}
             */
            get: function () {
                return {
                    tView: this._raw_lView[TVIEW],
                    cleanup: this._raw_lView[CLEANUP],
                    injector: this._raw_lView[INJECTOR$1],
                    rendererFactory: this._raw_lView[RENDERER_FACTORY],
                    renderer: this._raw_lView[RENDERER],
                    sanitizer: this._raw_lView[SANITIZER],
                    childHead: toDebug(this._raw_lView[CHILD_HEAD]),
                    next: toDebug(this._raw_lView[NEXT]),
                    childTail: toDebug(this._raw_lView[CHILD_TAIL]),
                    declarationView: toDebug(this._raw_lView[DECLARATION_VIEW]),
                    queries: null,
                    tHost: this._raw_lView[T_HOST],
                    bindingIndex: this._raw_lView[BINDING_INDEX],
                };
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LViewDebug.prototype, "childViews", {
            /**
             * Normalized view of child views (and containers) attached at this location.
             * @return {?}
             */
            get: function () {
                /** @type {?} */
                var childViews = [];
                /** @type {?} */
                var child = this.__other__.childHead;
                while (child) {
                    childViews.push(child);
                    child = child.__other__.next;
                }
                return childViews;
            },
            enumerable: true,
            configurable: true
        });
        return LViewDebug;
    }());
    /**
     * Turns a flat list of nodes into a tree by walking the associated `TNode` tree.
     *
     * @param {?} tNode
     * @param {?} lView
     * @return {?}
     */
    function toDebugNodes(tNode, lView) {
        if (tNode) {
            /** @type {?} */
            var debugNodes = [];
            /** @type {?} */
            var tNodeCursor = tNode;
            while (tNodeCursor) {
                /** @type {?} */
                var rawValue = lView[tNode.index];
                /** @type {?} */
                var native = unwrapRNode(rawValue);
                /** @type {?} */
                var componentLViewDebug = toDebug(readLViewValue(rawValue));
                /** @type {?} */
                var styles_1 = isStylingContext(tNode.styles) ?
                    new NodeStylingDebug(( /** @type {?} */(( /** @type {?} */(tNode.styles)))), lView) :
                    null;
                /** @type {?} */
                var classes = isStylingContext(tNode.classes) ?
                    new NodeStylingDebug(( /** @type {?} */(( /** @type {?} */(tNode.classes)))), lView, true) :
                    null;
                debugNodes.push({
                    html: toHtml(native),
                    native: ( /** @type {?} */(native)), styles: styles_1, classes: classes,
                    nodes: toDebugNodes(tNode.child, lView),
                    component: componentLViewDebug,
                });
                tNodeCursor = tNodeCursor.next;
            }
            return debugNodes;
        }
        else {
            return null;
        }
    }
    /**
     * Return an `LView` value if found.
     *
     * @param {?} value `LView` if any
     * @return {?}
     */
    function readLViewValue(value) {
        while (Array.isArray(value)) {
            // This check is not quite right, as it does not take into account `StylingContext`
            // This is why it is in debug, not in util.ts
            if (value.length >= HEADER_OFFSET - 1)
                return ( /** @type {?} */(value));
            value = value[HOST];
        }
        return null;
    }
    /**
     * @param {?} lView
     * @param {?} index
     * @return {?}
     */
    function selectInternal(lView, index) {
        // Flush the initial hooks for elements in the view that have been added up to this point.
        executePreOrderHooks(lView, lView[TVIEW], getCheckNoChangesMode(), index);
        // We must set the selected index *after* running the hooks, because hooks may have side-effects
        // that cause other template functions to run, thus updating the selected index, which is global
        // state. If we run `setSelectedIndex` *before* we run the hooks, in some cases the selected index
        // will be altered by the time we leave the `ɵɵselect` instruction.
        setSelectedIndex(index);
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ɵ0$5 = /**
     * @return {?}
     */ function () { return Promise.resolve(null); };
    /**
     * A permanent marker promise which signifies that the current CD tree is
     * clean.
     * @type {?}
     */
    var _CLEAN_PROMISE = ((ɵ0$5))();
    /**
     * Refreshes the view, executing the following steps in that order:
     * triggers init hooks, refreshes dynamic embedded views, triggers content hooks, sets host
     * bindings, refreshes child components.
     * Note: view hooks are triggered later when leaving the view.
     * @param {?} lView
     * @return {?}
     */
    function refreshDescendantViews(lView) {
        /** @type {?} */
        var tView = lView[TVIEW];
        /** @type {?} */
        var creationMode = isCreationMode(lView);
        // This needs to be set before children are processed to support recursive components
        tView.firstTemplatePass = false;
        // Resetting the bindingIndex of the current LView as the next steps may trigger change detection.
        lView[BINDING_INDEX] = tView.bindingStartIndex;
        // If this is a creation pass, we should not call lifecycle hooks or evaluate bindings.
        // This will be done in the update pass.
        if (!creationMode) {
            /** @type {?} */
            var checkNoChangesMode_1 = getCheckNoChangesMode();
            executePreOrderHooks(lView, tView, checkNoChangesMode_1, undefined);
            refreshDynamicEmbeddedViews(lView);
            // Content query results must be refreshed before content hooks are called.
            refreshContentQueries(tView, lView);
            resetPreOrderHookFlags(lView);
            executeHooks(lView, tView.contentHooks, tView.contentCheckHooks, checkNoChangesMode_1, 1 /* AfterContentInitHooksToBeRun */, undefined);
            setHostBindings(tView, lView);
        }
        // We resolve content queries specifically marked as `static` in creation mode. Dynamic
        // content queries are resolved during change detection (i.e. update mode), after embedded
        // views are refreshed (see block above).
        if (creationMode && tView.staticContentQueries) {
            refreshContentQueries(tView, lView);
        }
        // We must materialize query results before child components are processed
        // in case a child component has projected a container. The LContainer needs
        // to exist so the embedded views are properly attached by the container.
        if (!creationMode || tView.staticViewQueries) {
            executeViewQueryFn(2 /* Update */, tView, lView[CONTEXT]);
        }
        refreshChildComponents(lView, tView.components);
    }
    /**
     * Sets the host bindings for the current view.
     * @param {?} tView
     * @param {?} viewData
     * @return {?}
     */
    function setHostBindings(tView, viewData) {
        /** @type {?} */
        var selectedIndex = getSelectedIndex();
        try {
            if (tView.expandoInstructions) {
                /** @type {?} */
                var bindingRootIndex_1 = viewData[BINDING_INDEX] = tView.expandoStartIndex;
                setBindingRoot(bindingRootIndex_1);
                /** @type {?} */
                var currentDirectiveIndex = -1;
                /** @type {?} */
                var currentElementIndex = -1;
                for (var i_29 = 0; i_29 < tView.expandoInstructions.length; i_29++) {
                    /** @type {?} */
                    var instruction = tView.expandoInstructions[i_29];
                    if (typeof instruction === 'number') {
                        if (instruction <= 0) {
                            // Negative numbers mean that we are starting new EXPANDO block and need to update
                            // the current element and directive index.
                            currentElementIndex = -instruction;
                            setActiveHostElement(currentElementIndex);
                            // Injector block and providers are taken into account.
                            /** @type {?} */
                            var providerCount = (( /** @type {?} */(tView.expandoInstructions[++i_29])));
                            bindingRootIndex_1 += INJECTOR_BLOOM_PARENT_SIZE + providerCount;
                            currentDirectiveIndex = bindingRootIndex_1;
                        }
                        else {
                            // This is either the injector size (so the binding root can skip over directives
                            // and get to the first set of host bindings on this node) or the host var count
                            // (to get to the next set of host bindings on this node).
                            bindingRootIndex_1 += instruction;
                        }
                        setBindingRoot(bindingRootIndex_1);
                    }
                    else {
                        // If it's not a number, it's a host binding function that needs to be executed.
                        if (instruction !== null) {
                            viewData[BINDING_INDEX] = bindingRootIndex_1;
                            /** @type {?} */
                            var hostCtx = unwrapRNode(viewData[currentDirectiveIndex]);
                            instruction(2 /* Update */, hostCtx, currentElementIndex);
                            // Each directive gets a uniqueId value that is the same for both
                            // create and update calls when the hostBindings function is called. The
                            // directive uniqueId is not set anywhere--it is just incremented between
                            // each hostBindings call and is useful for helping instruction code
                            // uniquely determine which directive is currently active when executed.
                            incrementActiveDirectiveId();
                        }
                        currentDirectiveIndex++;
                    }
                }
            }
        }
        finally {
            setActiveHostElement(selectedIndex);
        }
    }
    /**
     * Refreshes all content queries declared by directives in a given view
     * @param {?} tView
     * @param {?} lView
     * @return {?}
     */
    function refreshContentQueries(tView, lView) {
        /** @type {?} */
        var contentQueries = tView.contentQueries;
        if (contentQueries !== null) {
            for (var i_30 = 0; i_30 < contentQueries.length; i_30 += 2) {
                /** @type {?} */
                var queryStartIdx = contentQueries[i_30];
                /** @type {?} */
                var directiveDefIdx = contentQueries[i_30 + 1];
                if (directiveDefIdx !== -1) {
                    /** @type {?} */
                    var directiveDef_2 = ( /** @type {?} */(tView.data[directiveDefIdx]));
                    ngDevMode &&
                        assertDefined(directiveDef_2.contentQueries, 'contentQueries function should be defined');
                    ( /** @type {?} */(directiveDef_2.contentQueries))(2 /* Update */, lView[directiveDefIdx], directiveDefIdx);
                }
            }
        }
    }
    /**
     * Refreshes child components in the current view.
     * @param {?} hostLView
     * @param {?} components
     * @return {?}
     */
    function refreshChildComponents(hostLView, components) {
        if (components != null) {
            for (var i_31 = 0; i_31 < components.length; i_31++) {
                componentRefresh(hostLView, components[i_31]);
            }
        }
    }
    /**
     * Creates a native element from a tag name, using a renderer.
     * @param {?} name the tag name
     * @param {?=} overriddenRenderer Optional A renderer to override the default one
     * @return {?} the element created
     */
    function elementCreate(name, overriddenRenderer) {
        /** @type {?} */
        var native;
        /** @type {?} */
        var rendererToUse = overriddenRenderer || getLView()[RENDERER];
        /** @type {?} */
        var namespace = getNamespace();
        if (isProceduralRenderer(rendererToUse)) {
            native = rendererToUse.createElement(name, namespace);
        }
        else {
            if (namespace === null) {
                native = rendererToUse.createElement(name);
            }
            else {
                native = rendererToUse.createElementNS(namespace, name);
            }
        }
        return native;
    }
    /**
     * @template T
     * @param {?} parentLView
     * @param {?} tView
     * @param {?} context
     * @param {?} flags
     * @param {?} host
     * @param {?} tHostNode
     * @param {?=} rendererFactory
     * @param {?=} renderer
     * @param {?=} sanitizer
     * @param {?=} injector
     * @return {?}
     */
    function createLView(parentLView, tView, context, flags, host, tHostNode, rendererFactory, renderer, sanitizer, injector) {
        /** @type {?} */
        var lView = ngDevMode ? cloneToLView(tView.blueprint) : ( /** @type {?} */(tView.blueprint.slice()));
        lView[HOST] = host;
        lView[FLAGS] = flags | 4 /* CreationMode */ | 128 /* Attached */ | 8 /* FirstLViewPass */;
        resetPreOrderHookFlags(lView);
        lView[PARENT] = lView[DECLARATION_VIEW] = parentLView;
        lView[CONTEXT] = context;
        lView[RENDERER_FACTORY] = ( /** @type {?} */((rendererFactory || parentLView && parentLView[RENDERER_FACTORY])));
        ngDevMode && assertDefined(lView[RENDERER_FACTORY], 'RendererFactory is required');
        lView[RENDERER] = ( /** @type {?} */((renderer || parentLView && parentLView[RENDERER])));
        ngDevMode && assertDefined(lView[RENDERER], 'Renderer is required');
        lView[SANITIZER] = sanitizer || parentLView && parentLView[SANITIZER] || ( /** @type {?} */(null));
        lView[( /** @type {?} */(INJECTOR$1))] = injector || parentLView && parentLView[INJECTOR$1] || null;
        lView[T_HOST] = tHostNode;
        ngDevMode && attachLViewDebug(lView);
        return lView;
    }
    /**
     * @param {?} tView
     * @param {?} tHostNode
     * @param {?} index
     * @param {?} type
     * @param {?} name
     * @param {?} attrs
     * @return {?}
     */
    function getOrCreateTNode(tView, tHostNode, index, type, name, attrs) {
        // Keep this function short, so that the VM will inline it.
        /** @type {?} */
        var adjustedIndex = index + HEADER_OFFSET;
        /** @type {?} */
        var tNode = ( /** @type {?} */(tView.data[adjustedIndex])) ||
            createTNodeAtIndex(tView, tHostNode, adjustedIndex, type, name, attrs, index);
        setPreviousOrParentTNode(tNode, true);
        return ( /** @type {?} */(tNode));
    }
    /**
     * @param {?} tView
     * @param {?} tHostNode
     * @param {?} adjustedIndex
     * @param {?} type
     * @param {?} name
     * @param {?} attrs
     * @param {?} index
     * @return {?}
     */
    function createTNodeAtIndex(tView, tHostNode, adjustedIndex, type, name, attrs, index) {
        /** @type {?} */
        var previousOrParentTNode = getPreviousOrParentTNode();
        /** @type {?} */
        var isParent = getIsParent();
        /** @type {?} */
        var parent = isParent ? previousOrParentTNode : previousOrParentTNode && previousOrParentTNode.parent;
        // Parents cannot cross component boundaries because components will be used in multiple places,
        // so it's only set if the view is the same.
        /** @type {?} */
        var parentInSameView = parent && parent !== tHostNode;
        /** @type {?} */
        var tParentNode = parentInSameView ? ( /** @type {?} */(parent)) : null;
        /** @type {?} */
        var tNode = tView.data[adjustedIndex] =
            createTNode(tView, tParentNode, type, adjustedIndex, name, attrs);
        // The first node is not always the one at index 0, in case of i18n, index 0 can be the
        // instruction `i18nStart` and the first node has the index 1 or more
        if (index === 0 || !tView.firstChild) {
            tView.firstChild = tNode;
        }
        // Now link ourselves into the tree.
        if (previousOrParentTNode) {
            if (isParent && previousOrParentTNode.child == null &&
                (tNode.parent !== null || previousOrParentTNode.type === 2 /* View */)) {
                // We are in the same view, which means we are adding content node to the parent view.
                previousOrParentTNode.child = tNode;
            }
            else if (!isParent) {
                previousOrParentTNode.next = tNode;
            }
        }
        return tNode;
    }
    /**
     * @param {?} tView
     * @param {?} tParentNode
     * @param {?} index
     * @param {?} lView
     * @return {?}
     */
    function assignTViewNodeToLView(tView, tParentNode, index, lView) {
        // View nodes are not stored in data because they can be added / removed at runtime (which
        // would cause indices to change). Their TNodes are instead stored in tView.node.
        /** @type {?} */
        var tNode = tView.node;
        if (tNode == null) {
            ngDevMode && tParentNode &&
                assertNodeOfPossibleTypes(tParentNode, 3 /* Element */, 0 /* Container */);
            tView.node = tNode = ( /** @type {?} */(createTNode(tView, ( /** @type {?} */(tParentNode)), //
            2 /* View */, index, null, null)));
        }
        return lView[T_HOST] = ( /** @type {?} */(tNode));
    }
    /**
     * Used for rendering embedded views (e.g. dynamically created views)
     *
     * Dynamically created views must store/retrieve their TViews differently from component views
     * because their template functions are nested in the template functions of their hosts, creating
     * closures. If their host template happens to be an embedded template in a loop (e.g. ngFor
     * inside
     * an ngFor), the nesting would mean we'd have multiple instances of the template function, so we
     * can't store TViews in the template function itself (as we do for comps). Instead, we store the
     * TView for dynamically created views on their host TNode, which only has one instance.
     * @template T
     * @param {?} viewToRender
     * @param {?} tView
     * @param {?} context
     * @return {?}
     */
    function renderEmbeddedTemplate(viewToRender, tView, context) {
        /** @type {?} */
        var _isParent = getIsParent();
        /** @type {?} */
        var _previousOrParentTNode = getPreviousOrParentTNode();
        /** @type {?} */
        var oldView;
        if (viewToRender[FLAGS] & 512 /* IsRoot */) {
            // This is a root view inside the view tree
            tickRootContext(getRootContext(viewToRender));
        }
        else {
            // Will become true if the `try` block executes with no errors.
            /** @type {?} */
            var safeToRunHooks = false;
            try {
                setPreviousOrParentTNode(( /** @type {?} */(null)), true);
                oldView = enterView(viewToRender, viewToRender[T_HOST]);
                resetPreOrderHookFlags(viewToRender);
                executeTemplate(viewToRender, ( /** @type {?} */(tView.template)), getRenderFlags(viewToRender), context);
                // This must be set to false immediately after the first creation run because in an
                // ngFor loop, all the views will be created together before update mode runs and turns
                // off firstTemplatePass. If we don't set it here, instances will perform directive
                // matching, etc again and again.
                tView.firstTemplatePass = false;
                refreshDescendantViews(viewToRender);
                safeToRunHooks = true;
            }
            finally {
                leaveView(( /** @type {?} */(oldView)), safeToRunHooks);
                setPreviousOrParentTNode(_previousOrParentTNode, _isParent);
            }
        }
    }
    /**
     * @template T
     * @param {?} hostView
     * @param {?} context
     * @param {?=} templateFn
     * @return {?}
     */
    function renderComponentOrTemplate(hostView, context, templateFn) {
        /** @type {?} */
        var rendererFactory = hostView[RENDERER_FACTORY];
        /** @type {?} */
        var oldView = enterView(hostView, hostView[T_HOST]);
        /** @type {?} */
        var normalExecutionPath = !getCheckNoChangesMode();
        /** @type {?} */
        var creationModeIsActive = isCreationMode(hostView);
        // Will become true if the `try` block executes with no errors.
        /** @type {?} */
        var safeToRunHooks = false;
        try {
            if (normalExecutionPath && !creationModeIsActive && rendererFactory.begin) {
                rendererFactory.begin();
            }
            if (creationModeIsActive) {
                // creation mode pass
                templateFn && executeTemplate(hostView, templateFn, 1 /* Create */, context);
                refreshDescendantViews(hostView);
                hostView[FLAGS] &= ~4 /* CreationMode */;
            }
            // update mode pass
            resetPreOrderHookFlags(hostView);
            templateFn && executeTemplate(hostView, templateFn, 2 /* Update */, context);
            refreshDescendantViews(hostView);
            safeToRunHooks = true;
        }
        finally {
            if (normalExecutionPath && !creationModeIsActive && rendererFactory.end) {
                rendererFactory.end();
            }
            leaveView(oldView, safeToRunHooks);
        }
    }
    /**
     * @template T
     * @param {?} lView
     * @param {?} templateFn
     * @param {?} rf
     * @param {?} context
     * @return {?}
     */
    function executeTemplate(lView, templateFn, rf, context) {
        namespaceHTMLInternal();
        /** @type {?} */
        var prevSelectedIndex = getSelectedIndex();
        try {
            setActiveHostElement(null);
            if (rf & 2 /* Update */) {
                // When we're updating, have an inherent ɵɵselect(0) so we don't have to generate that
                // instruction for most update blocks
                selectInternal(lView, 0);
            }
            templateFn(rf, context);
        }
        finally {
            setSelectedIndex(prevSelectedIndex);
        }
    }
    /**
     * This function returns the default configuration of rendering flags depending on when the
     * template is in creation mode or update mode. Update block and create block are
     * always run separately.
     * @param {?} view
     * @return {?}
     */
    function getRenderFlags(view) {
        return isCreationMode(view) ? 1 /* Create */ : 2 /* Update */;
    }
    /**
     * Gets TView from a template function or creates a new TView
     * if it doesn't already exist.
     *
     * @param {?} def ComponentDef
     * @return {?} TView
     */
    function getOrCreateTView(def) {
        return def.tView || (def.tView = createTView(-1, def.template, def.consts, def.vars, def.directiveDefs, def.pipeDefs, def.viewQuery, def.schemas));
    }
    /**
     * Creates a TView instance
     *
     * @param {?} viewIndex The viewBlockId for inline views, or -1 if it's a component/dynamic
     * @param {?} templateFn Template function
     * @param {?} consts The number of nodes, local refs, and pipes in this template
     * @param {?} vars
     * @param {?} directives Registry of directives for this view
     * @param {?} pipes Registry of pipes for this view
     * @param {?} viewQuery View queries for this view
     * @param {?} schemas Schemas for this view
     * @return {?}
     */
    function createTView(viewIndex, templateFn, consts, vars, directives, pipes, viewQuery, schemas) {
        ngDevMode && ngDevMode.tView++;
        /** @type {?} */
        var bindingStartIndex = HEADER_OFFSET + consts;
        // This length does not yet contain host bindings from child directives because at this point,
        // we don't know which directives are active on this template. As soon as a directive is matched
        // that has a host binding, we will update the blueprint with that def's hostVars count.
        /** @type {?} */
        var initialViewLength = bindingStartIndex + vars;
        /** @type {?} */
        var blueprint = createViewBlueprint(bindingStartIndex, initialViewLength);
        return blueprint[( /** @type {?} */(TVIEW))] = ngDevMode ?
            new TViewConstructor(viewIndex, // id: number,
            blueprint, // blueprint: LView,
            templateFn, // template: ComponentTemplate<{}>|null,
            null, // queries: TQueries|null
            viewQuery, ( /** @type {?} */(null)), // node: TViewNode|TElementNode|null,
            cloneToTViewData(blueprint).fill(null, bindingStartIndex), // data: TData,
            bindingStartIndex, // bindingStartIndex: number,
            initialViewLength, // expandoStartIndex: number,
            null, // expandoInstructions: ExpandoInstructions|null,
            true, // firstTemplatePass: boolean,
            false, // staticViewQueries: boolean,
            false, // staticContentQueries: boolean,
            null, // preOrderHooks: HookData|null,
            null, // preOrderCheckHooks: HookData|null,
            null, // contentHooks: HookData|null,
            null, // contentCheckHooks: HookData|null,
            null, // viewHooks: HookData|null,
            null, // viewCheckHooks: HookData|null,
            null, // destroyHooks: HookData|null,
            null, // cleanup: any[]|null,
            null, // contentQueries: number[]|null,
            null, // components: number[]|null,
            typeof directives === 'function' ?
                directives() :
                directives, // directiveRegistry: DirectiveDefList|null,
            typeof pipes === 'function' ? pipes() : pipes, // pipeRegistry: PipeDefList|null,
            null, // firstChild: TNode|null,
            schemas) :
            {
                id: viewIndex,
                blueprint: blueprint,
                template: templateFn,
                queries: null,
                viewQuery: viewQuery,
                node: ( /** @type {?} */(null)),
                data: blueprint.slice().fill(null, bindingStartIndex),
                bindingStartIndex: bindingStartIndex,
                expandoStartIndex: initialViewLength,
                expandoInstructions: null,
                firstTemplatePass: true,
                staticViewQueries: false,
                staticContentQueries: false,
                preOrderHooks: null,
                preOrderCheckHooks: null,
                contentHooks: null,
                contentCheckHooks: null,
                viewHooks: null,
                viewCheckHooks: null,
                destroyHooks: null,
                cleanup: null,
                contentQueries: null,
                components: null,
                directiveRegistry: typeof directives === 'function' ? directives() : directives,
                pipeRegistry: typeof pipes === 'function' ? pipes() : pipes,
                firstChild: null,
                schemas: schemas,
            };
    }
    /**
     * @param {?} bindingStartIndex
     * @param {?} initialViewLength
     * @return {?}
     */
    function createViewBlueprint(bindingStartIndex, initialViewLength) {
        /** @type {?} */
        var blueprint = ( /** @type {?} */(new (ngDevMode ? ( /** @type {?} */(LViewBlueprint)) : Array)(initialViewLength)
            .fill(null, 0, bindingStartIndex)
            .fill(NO_CHANGE, bindingStartIndex)));
        blueprint[BINDING_INDEX] = bindingStartIndex;
        return blueprint;
    }
    /**
     * @param {?} text
     * @param {?} token
     * @return {?}
     */
    function createError(text, token) {
        return new Error("Renderer: " + text + " [" + stringifyForError(token) + "]");
    }
    /**
     * Locates the host native element, used for bootstrapping existing nodes into rendering pipeline.
     *
     * @param {?} factory
     * @param {?} elementOrSelector Render element or CSS selector to locate the element.
     * @return {?}
     */
    function locateHostElement(factory, elementOrSelector) {
        /** @type {?} */
        var defaultRenderer = factory.createRenderer(null, null);
        /** @type {?} */
        var rNode = typeof elementOrSelector === 'string' ?
            (isProceduralRenderer(defaultRenderer) ?
                defaultRenderer.selectRootElement(elementOrSelector) :
                defaultRenderer.querySelector(elementOrSelector)) :
            elementOrSelector;
        if (ngDevMode && !rNode) {
            if (typeof elementOrSelector === 'string') {
                throw createError('Host node with selector not found:', elementOrSelector);
            }
            else {
                throw createError('Host node is required:', elementOrSelector);
            }
        }
        return rNode;
    }
    /**
     * Saves the cleanup function itself in LView.cleanupInstances.
     *
     * This is necessary for functions that are wrapped with their contexts, like in renderer2
     * listeners.
     *
     * On the first template pass, the index of the cleanup function is saved in TView.
     * @param {?} view
     * @param {?} cleanupFn
     * @return {?}
     */
    function storeCleanupFn(view, cleanupFn) {
        getCleanup(view).push(cleanupFn);
        if (view[TVIEW].firstTemplatePass) {
            getTViewCleanup(view).push(( /** @type {?} */(view[CLEANUP])).length - 1, null);
        }
    }
    /**
     * Constructs a TNode object from the arguments.
     *
     * @param {?} tView `TView` to which this `TNode` belongs (used only in `ngDevMode`)
     * @param {?} tParent
     * @param {?} type The type of the node
     * @param {?} adjustedIndex The index of the TNode in TView.data, adjusted for HEADER_OFFSET
     * @param {?} tagName The tag name of the node
     * @param {?} attrs The attributes defined on this node
     * @return {?} the TNode object
     */
    function createTNode(tView, tParent, type, adjustedIndex, tagName, attrs) {
        ngDevMode && ngDevMode.tNode++;
        /** @type {?} */
        var injectorIndex = tParent ? tParent.injectorIndex : -1;
        return ngDevMode ? new TNodeConstructor(tView, // tView_: TView
        type, // type: TNodeType
        adjustedIndex, // index: number
        injectorIndex, // injectorIndex: number
        -1, // directiveStart: number
        -1, // directiveEnd: number
        -1, // propertyMetadataStartIndex: number
        -1, // propertyMetadataEndIndex: number
        0, // flags: TNodeFlags
        0, // providerIndexes: TNodeProviderIndexes
        tagName, // tagName: string|null
        attrs, // attrs: (string|AttributeMarker|(string|SelectorFlags)[])[]|null
        null, // localNames: (string|number)[]|null
        undefined, // initialInputs: (string[]|null)[]|null|undefined
        undefined, // inputs: PropertyAliases|null|undefined
        undefined, // outputs: PropertyAliases|null|undefined
        null, // tViews: ITView|ITView[]|null
        null, // next: ITNode|null
        null, // projectionNext: ITNode|null
        null, // child: ITNode|null
        tParent, // parent: TElementNode|TContainerNode|null
        null, // projection: number|(ITNode|RNode[])[]|null
        null, // styles: TStylingContext|null
        null) :
            {
                type: type,
                index: adjustedIndex,
                injectorIndex: injectorIndex,
                directiveStart: -1,
                directiveEnd: -1,
                propertyMetadataStartIndex: -1,
                propertyMetadataEndIndex: -1,
                flags: 0,
                providerIndexes: 0,
                tagName: tagName,
                attrs: attrs,
                localNames: null,
                initialInputs: undefined,
                inputs: undefined,
                outputs: undefined,
                tViews: null,
                next: null,
                projectionNext: null,
                child: null,
                parent: tParent,
                projection: null,
                styles: null,
                classes: null,
            };
    }
    /**
     * Instantiate a root component.
     * @template T
     * @param {?} tView
     * @param {?} viewData
     * @param {?} def
     * @return {?}
     */
    function instantiateRootComponent(tView, viewData, def) {
        /** @type {?} */
        var rootTNode = getPreviousOrParentTNode();
        if (tView.firstTemplatePass) {
            if (def.providersResolver)
                def.providersResolver(def);
            generateExpandoInstructionBlock(tView, rootTNode, 1);
            baseResolveDirective(tView, viewData, def, def.factory);
        }
        /** @type {?} */
        var directive = getNodeInjectable(tView.data, viewData, viewData.length - 1, ( /** @type {?} */(rootTNode)));
        postProcessBaseDirective(viewData, rootTNode, directive);
        return directive;
    }
    /**
     * @param {?} def
     * @param {?} expando
     * @param {?} directive
     * @param {?} tNode
     * @param {?} firstTemplatePass
     * @return {?}
     */
    function invokeHostBindingsInCreationMode(def, expando, directive, tNode, firstTemplatePass) {
        /** @type {?} */
        var previousExpandoLength = expando.length;
        setCurrentDirectiveDef(def);
        /** @type {?} */
        var elementIndex = tNode.index - HEADER_OFFSET;
        ( /** @type {?} */(def.hostBindings))(1 /* Create */, directive, elementIndex);
        setCurrentDirectiveDef(null);
        // `hostBindings` function may or may not contain `allocHostVars` call
        // (e.g. it may not if it only contains host listeners), so we need to check whether
        // `expandoInstructions` has changed and if not - we still push `hostBindings` to
        // expando block, to make sure we execute it for DI cycle
        if (previousExpandoLength === expando.length && firstTemplatePass) {
            expando.push(def.hostBindings);
        }
    }
    /**
     * Generates a new block in TView.expandoInstructions for this node.
     *
     * Each expando block starts with the element index (turned negative so we can distinguish
     * it from the hostVar count) and the directive count. See more in VIEW_DATA.md.
     * @param {?} tView
     * @param {?} tNode
     * @param {?} directiveCount
     * @return {?}
     */
    function generateExpandoInstructionBlock(tView, tNode, directiveCount) {
        ngDevMode && assertEqual(tView.firstTemplatePass, true, 'Expando block should only be generated on first template pass.');
        /** @type {?} */
        var elementIndex = -(tNode.index - HEADER_OFFSET);
        /** @type {?} */
        var providerStartIndex = tNode.providerIndexes & 65535 /* ProvidersStartIndexMask */;
        /** @type {?} */
        var providerCount = tView.data.length - providerStartIndex;
        (tView.expandoInstructions || (tView.expandoInstructions = [])).push(elementIndex, providerCount, directiveCount);
    }
    /**
     * A lighter version of postProcessDirective() that is used for the root component.
     * @template T
     * @param {?} lView
     * @param {?} previousOrParentTNode
     * @param {?} directive
     * @return {?}
     */
    function postProcessBaseDirective(lView, previousOrParentTNode, directive) {
        /** @type {?} */
        var native = getNativeByTNode(previousOrParentTNode, lView);
        ngDevMode && assertEqual(lView[BINDING_INDEX], lView[TVIEW].bindingStartIndex, 'directives should be created before any bindings');
        ngDevMode && assertPreviousIsParent(getIsParent());
        attachPatchData(directive, lView);
        if (native) {
            attachPatchData(native, lView);
        }
    }
    /**
     * Stores index of component's host element so it will be queued for view refresh during CD.
     * @param {?} previousOrParentTNode
     * @return {?}
     */
    function queueComponentIndexForCheck(previousOrParentTNode) {
        /** @type {?} */
        var tView = getLView()[TVIEW];
        ngDevMode &&
            assertEqual(tView.firstTemplatePass, true, 'Should only be called in first template pass.');
        (tView.components || (tView.components = ngDevMode ? new ( /** @type {?} */(TViewComponents))() : [])).push(previousOrParentTNode.index);
    }
    /**
     * Initializes the flags on the current node, setting all indices to the initial index,
     * the directive count to 0, and adding the isComponent flag.
     * @param {?} tNode
     * @param {?} index the initial index
     * @param {?} numberOfDirectives
     * @return {?}
     */
    function initNodeFlags(tNode, index, numberOfDirectives) {
        /** @type {?} */
        var flags = tNode.flags;
        ngDevMode && assertEqual(flags === 0 || flags === 1 /* isComponent */, true, 'expected node flags to not be initialized');
        ngDevMode && assertNotEqual(numberOfDirectives, tNode.directiveEnd - tNode.directiveStart, 'Reached the max number of directives');
        // When the first directive is created on a node, save the index
        tNode.flags = flags & 1 /* isComponent */;
        tNode.directiveStart = index;
        tNode.directiveEnd = index + numberOfDirectives;
        tNode.providerIndexes = index;
    }
    /**
     * @template T
     * @param {?} tView
     * @param {?} viewData
     * @param {?} def
     * @param {?} directiveFactory
     * @return {?}
     */
    function baseResolveDirective(tView, viewData, def, directiveFactory) {
        tView.data.push(def);
        /** @type {?} */
        var nodeInjectorFactory = new NodeInjectorFactory(directiveFactory, isComponentDef(def), null);
        tView.blueprint.push(nodeInjectorFactory);
        viewData.push(nodeInjectorFactory);
    }
    //////////////////////////
    //// ViewContainer & View
    //////////////////////////
    // Not sure why I need to do `any` here but TS complains later.
    /** @type {?} */
    var LContainerArray = ngDevMode && createNamedArrayType('LContainer');
    /**
     * Goes over dynamic embedded views (ones created through ViewContainerRef APIs) and refreshes
     * them
     * by executing an associated template function.
     * @param {?} lView
     * @return {?}
     */
    function refreshDynamicEmbeddedViews(lView) {
        for (var current = lView[CHILD_HEAD]; current !== null; current = current[NEXT]) {
            // Note: current can be an LView or an LContainer instance, but here we are only interested
            // in LContainer. We can tell it's an LContainer because its length is less than the LView
            // header.
            if (current[ACTIVE_INDEX] === -1 && isLContainer(current)) {
                for (var i_32 = CONTAINER_HEADER_OFFSET; i_32 < current.length; i_32++) {
                    /** @type {?} */
                    var dynamicViewData = current[i_32];
                    // The directives and pipes are not needed here as an existing view is only being
                    // refreshed.
                    ngDevMode && assertDefined(dynamicViewData[TVIEW], 'TView must be allocated');
                    renderEmbeddedTemplate(dynamicViewData, dynamicViewData[TVIEW], ( /** @type {?} */(dynamicViewData[CONTEXT])));
                }
            }
        }
    }
    /////////////
    /**
     * Refreshes components by entering the component view and processing its bindings, queries, etc.
     *
     * @param {?} hostLView
     * @param {?} adjustedElementIndex  Element index in LView[] (adjusted for HEADER_OFFSET)
     * @return {?}
     */
    function componentRefresh(hostLView, adjustedElementIndex) {
        ngDevMode && assertDataInRange(hostLView, adjustedElementIndex);
        /** @type {?} */
        var componentView = getComponentViewByIndex(adjustedElementIndex, hostLView);
        ngDevMode &&
            assertNodeType(( /** @type {?} */(hostLView[TVIEW].data[adjustedElementIndex])), 3 /* Element */);
        // Only components in creation mode, attached CheckAlways
        // components or attached, dirty OnPush components should be checked
        if ((viewAttachedToChangeDetector(componentView) || isCreationMode(hostLView)) &&
            componentView[FLAGS] & (16 /* CheckAlways */ | 64 /* Dirty */)) {
            syncViewWithBlueprint(componentView);
            checkView(componentView, componentView[CONTEXT]);
        }
    }
    /**
     * Syncs an LView instance with its blueprint if they have gotten out of sync.
     *
     * Typically, blueprints and their view instances should always be in sync, so the loop here
     * will be skipped. However, consider this case of two components side-by-side:
     *
     * App template:
     * ```
     * <comp></comp>
     * <comp></comp>
     * ```
     *
     * The following will happen:
     * 1. App template begins processing.
     * 2. First <comp> is matched as a component and its LView is created.
     * 3. Second <comp> is matched as a component and its LView is created.
     * 4. App template completes processing, so it's time to check child templates.
     * 5. First <comp> template is checked. It has a directive, so its def is pushed to blueprint.
     * 6. Second <comp> template is checked. Its blueprint has been updated by the first
     * <comp> template, but its LView was created before this update, so it is out of sync.
     *
     * Note that embedded views inside ngFor loops will never be out of sync because these views
     * are processed as soon as they are created.
     *
     * @param {?} componentView The view to sync
     * @return {?}
     */
    function syncViewWithBlueprint(componentView) {
        /** @type {?} */
        var componentTView = componentView[TVIEW];
        for (var i_33 = componentView.length; i_33 < componentTView.blueprint.length; i_33++) {
            componentView[i_33] = componentTView.blueprint[i_33];
        }
    }
    /**
     * Adds LView or LContainer to the end of the current view tree.
     *
     * This structure will be used to traverse through nested views to remove listeners
     * and call onDestroy callbacks.
     *
     * @template T
     * @param {?} lView The view where LView or LContainer should be added
     * @param {?} lViewOrLContainer The LView or LContainer to add to the view tree
     * @return {?} The state passed in
     */
    function addToViewTree(lView, lViewOrLContainer) {
        // TODO(benlesh/misko): This implementation is incorrect, because it always adds the LContainer
        // to
        // the end of the queue, which means if the developer retrieves the LContainers from RNodes out
        // of
        // order, the change detection will run out of order, as the act of retrieving the the
        // LContainer
        // from the RNode is what adds it to the queue.
        if (lView[CHILD_HEAD]) {
            ( /** @type {?} */(lView[CHILD_TAIL]))[NEXT] = lViewOrLContainer;
        }
        else {
            lView[CHILD_HEAD] = lViewOrLContainer;
        }
        lView[CHILD_TAIL] = lViewOrLContainer;
        return lViewOrLContainer;
    }
    ///////////////////////////////
    //// Change detection
    ///////////////////////////////
    /**
     * Marks current view and all ancestors dirty.
     *
     * Returns the root view because it is found as a byproduct of marking the view tree
     * dirty, and can be used by methods that consume markViewDirty() to easily schedule
     * change detection. Otherwise, such methods would need to traverse up the view tree
     * an additional time to get the root view and schedule a tick on it.
     *
     * @param {?} lView The starting LView to mark dirty
     * @return {?} the root LView
     */
    function markViewDirty(lView) {
        while (lView) {
            lView[FLAGS] |= 64 /* Dirty */;
            /** @type {?} */
            var parent_3 = getLViewParent(lView);
            // Stop traversing up as soon as you find a root view that wasn't attached to any container
            if (isRootView(lView) && !parent_3) {
                return lView;
            }
            // continue otherwise
            lView = ( /** @type {?} */(parent_3));
        }
        return null;
    }
    /**
     * @param {?} rootContext
     * @return {?}
     */
    function tickRootContext(rootContext) {
        for (var i_34 = 0; i_34 < rootContext.components.length; i_34++) {
            /** @type {?} */
            var rootComponent = rootContext.components[i_34];
            renderComponentOrTemplate(( /** @type {?} */(readPatchedLView(rootComponent))), rootComponent);
        }
    }
    /**
     * @template T
     * @param {?} view
     * @param {?} context
     * @return {?}
     */
    function detectChangesInternal(view, context) {
        /** @type {?} */
        var rendererFactory = view[RENDERER_FACTORY];
        if (rendererFactory.begin)
            rendererFactory.begin();
        try {
            if (isCreationMode(view)) {
                checkView(view, context); // creation mode pass
            }
            checkView(view, context); // update mode pass
        }
        catch (error) {
            handleError(view, error);
            throw error;
        }
        finally {
            if (rendererFactory.end)
                rendererFactory.end();
        }
    }
    /**
     * Synchronously perform change detection on a root view and its components.
     *
     * @param {?} lView The view which the change detection should be performed on.
     * @return {?}
     */
    function detectChangesInRootView(lView) {
        tickRootContext(( /** @type {?} */(lView[CONTEXT])));
    }
    /**
     * @template T
     * @param {?} view
     * @param {?} context
     * @return {?}
     */
    function checkNoChangesInternal(view, context) {
        setCheckNoChangesMode(true);
        try {
            detectChangesInternal(view, context);
        }
        finally {
            setCheckNoChangesMode(false);
        }
    }
    /**
     * Checks the change detector on a root view and its components, and throws if any changes are
     * detected.
     *
     * This is used in development mode to verify that running change detection doesn't
     * introduce other changes.
     *
     * @param {?} lView The view which the change detection should be checked on.
     * @return {?}
     */
    function checkNoChangesInRootView(lView) {
        setCheckNoChangesMode(true);
        try {
            detectChangesInRootView(lView);
        }
        finally {
            setCheckNoChangesMode(false);
        }
    }
    /**
     * Checks the view of the component provided. Does not gate on dirty checks or execute doCheck.
     * @template T
     * @param {?} hostView
     * @param {?} component
     * @return {?}
     */
    function checkView(hostView, component) {
        /** @type {?} */
        var hostTView = hostView[TVIEW];
        /** @type {?} */
        var oldView = enterView(hostView, hostView[T_HOST]);
        /** @type {?} */
        var templateFn = ( /** @type {?} */(hostTView.template));
        /** @type {?} */
        var creationMode = isCreationMode(hostView);
        // Will become true if the `try` block executes with no errors.
        /** @type {?} */
        var safeToRunHooks = false;
        try {
            resetPreOrderHookFlags(hostView);
            creationMode && executeViewQueryFn(1 /* Create */, hostTView, component);
            executeTemplate(hostView, templateFn, getRenderFlags(hostView), component);
            refreshDescendantViews(hostView);
            safeToRunHooks = true;
        }
        finally {
            leaveView(oldView, safeToRunHooks);
        }
    }
    /**
     * @template T
     * @param {?} flags
     * @param {?} tView
     * @param {?} component
     * @return {?}
     */
    function executeViewQueryFn(flags, tView, component) {
        /** @type {?} */
        var viewQuery = tView.viewQuery;
        if (viewQuery !== null) {
            viewQuery(flags, component);
        }
    }
    /** @type {?} */
    var CLEAN_PROMISE = _CLEAN_PROMISE;
    /**
     * @param {?} view
     * @return {?}
     */
    function getCleanup(view) {
        // top level variables should not be exported for performance reasons (PERF_NOTES.md)
        return view[CLEANUP] || (view[CLEANUP] = ngDevMode ? new ( /** @type {?} */(LCleanup))() : []);
    }
    /**
     * @param {?} view
     * @return {?}
     */
    function getTViewCleanup(view) {
        return view[TVIEW].cleanup || (view[TVIEW].cleanup = ngDevMode ? new ( /** @type {?} */(TCleanup))() : []);
    }
    /**
     * Handles an error thrown in an LView.
     * @param {?} lView
     * @param {?} error
     * @return {?}
     */
    function handleError(lView, error) {
        /** @type {?} */
        var injector = lView[INJECTOR$1];
        /** @type {?} */
        var errorHandler = injector ? injector.get(ErrorHandler, null) : null;
        errorHandler && errorHandler.handleError(error);
    }
    /**
     * Set the inputs of directives at the current node to corresponding value.
     *
     * @param {?} lView the `LView` which contains the directives.
     * @param {?} inputs mapping between the public "input" name and privately-known,
     * possibly minified, property names to write to.
     * @param {?} value Value to set.
     * @return {?}
     */
    function setInputsForProperty(lView, inputs, value) {
        /** @type {?} */
        var tView = lView[TVIEW];
        for (var i_35 = 0; i_35 < inputs.length;) {
            /** @type {?} */
            var index = ( /** @type {?} */(inputs[i_35++]));
            /** @type {?} */
            var publicName = ( /** @type {?} */(inputs[i_35++]));
            /** @type {?} */
            var privateName = ( /** @type {?} */(inputs[i_35++]));
            /** @type {?} */
            var instance = lView[index];
            ngDevMode && assertDataInRange(lView, index);
            /** @type {?} */
            var def = ( /** @type {?} */(tView.data[index]));
            /** @type {?} */
            var setInput = def.setInput;
            if (setInput) {
                ( /** @type {?} */(def.setInput))(instance, value, publicName, privateName);
            }
            else {
                instance[privateName] = value;
            }
        }
    }
    /**
     * @param {?} tNode
     * @param {?} embeddedView
     * @return {?}
     */
    function getLContainer(tNode, embeddedView) {
        ngDevMode && assertLView(embeddedView);
        /** @type {?} */
        var container = ( /** @type {?} */(embeddedView[PARENT]));
        if (tNode.index === -1) {
            // This is a dynamically created view inside a dynamic container.
            // The parent isn't an LContainer if the embedded view hasn't been attached yet.
            return isLContainer(container) ? container : null;
        }
        else {
            ngDevMode && assertLContainer(container);
            // This is a inline view node (e.g. embeddedViewStart)
            return container;
        }
    }
    /**
     * NOTE: for performance reasons, the possible actions are inlined within the function instead of
     * being passed as an argument.
     * @param {?} action
     * @param {?} renderer
     * @param {?} parent
     * @param {?} lNodeToHandle
     * @param {?=} beforeNode
     * @return {?}
     */
    function executeActionOnElementOrContainer(action, renderer, parent, lNodeToHandle, beforeNode) {
        // If this slot was allocated for a text node dynamically created by i18n, the text node itself
        // won't be created until i18nApply() in the update block, so this node should be skipped.
        // For more info, see "ICU expressions should work inside an ngTemplateOutlet inside an ngFor"
        // in `i18n_spec.ts`.
        if (lNodeToHandle != null) {
            /** @type {?} */
            var lContainer = void 0;
            /** @type {?} */
            var isComponent_1 = false;
            // We are expecting an RNode, but in the case of a component or LContainer the `RNode` is
            // wrapped
            // in an array which needs to be unwrapped. We need to know if it is a component and if
            // it has LContainer so that we can process all of those cases appropriately.
            if (isLContainer(lNodeToHandle)) {
                lContainer = lNodeToHandle;
            }
            else if (isLView(lNodeToHandle)) {
                isComponent_1 = true;
                ngDevMode && assertDefined(lNodeToHandle[HOST], 'HOST must be defined for a component LView');
                lNodeToHandle = ( /** @type {?} */(lNodeToHandle[HOST]));
            }
            /** @type {?} */
            var rNode = unwrapRNode(lNodeToHandle);
            ngDevMode && assertDomNode(rNode);
            if (action === 0 /* Insert */) {
                nativeInsertBefore(renderer, ( /** @type {?} */(parent)), rNode, beforeNode || null);
            }
            else if (action === 1 /* Detach */) {
                nativeRemoveNode(renderer, rNode, isComponent_1);
            }
            else if (action === 2 /* Destroy */) {
                ngDevMode && ngDevMode.rendererDestroyNode++;
                ( /** @type {?} */((( /** @type {?} */(renderer))).destroyNode))(rNode);
            }
            if (lContainer != null) {
                executeActionOnContainer(renderer, action, lContainer, parent, beforeNode);
            }
        }
    }
    /**
     * Detach a `LView` from the DOM by detaching its nodes.
     *
     * @param {?} lView the `LView` to be detached.
     * @return {?}
     */
    function renderDetachView(lView) {
        executeActionOnView(lView[RENDERER], 1 /* Detach */, lView, null, null);
    }
    /**
     * Traverses down and up the tree of views and containers to remove listeners and
     * call onDestroy callbacks.
     *
     * Notes:
     *  - Because it's used for onDestroy calls, it needs to be bottom-up.
     *  - Must process containers instead of their views to avoid splicing
     *  when views are destroyed and re-added.
     *  - Using a while loop because it's faster than recursion
     *  - Destroy only called on movement to sibling or movement to parent (laterally or up)
     *
     * @param {?} rootView The view to destroy
     * @return {?}
     */
    function destroyViewTree(rootView) {
        // If the view has no children, we can clean it up and return early.
        /** @type {?} */
        var lViewOrLContainer = rootView[CHILD_HEAD];
        if (!lViewOrLContainer) {
            return cleanUpView(rootView);
        }
        while (lViewOrLContainer) {
            /** @type {?} */
            var next = null;
            if (isLView(lViewOrLContainer)) {
                // If LView, traverse down to child.
                next = lViewOrLContainer[CHILD_HEAD];
            }
            else {
                ngDevMode && assertLContainer(lViewOrLContainer);
                // If container, traverse down to its first LView.
                /** @type {?} */
                var firstView = lViewOrLContainer[CONTAINER_HEADER_OFFSET];
                if (firstView)
                    next = firstView;
            }
            if (!next) {
                // Only clean up view when moving to the side or up, as destroy hooks
                // should be called in order from the bottom up.
                while (lViewOrLContainer && !( /** @type {?} */(lViewOrLContainer))[NEXT] && lViewOrLContainer !== rootView) {
                    cleanUpView(lViewOrLContainer);
                    lViewOrLContainer = getParentState(lViewOrLContainer, rootView);
                }
                cleanUpView(lViewOrLContainer || rootView);
                next = lViewOrLContainer && ( /** @type {?} */(lViewOrLContainer))[NEXT];
            }
            lViewOrLContainer = next;
        }
    }
    /**
     * @param {?} declarationContainer
     * @param {?} lView
     * @return {?}
     */
    function detachMovedView(declarationContainer, lView) {
        ngDevMode && assertLContainer(declarationContainer);
        ngDevMode && assertDefined(declarationContainer[MOVED_VIEWS], 'A projected view should belong to a non-empty projected views collection');
        /** @type {?} */
        var projectedViews = ( /** @type {?} */(declarationContainer[MOVED_VIEWS]));
        /** @type {?} */
        var declaredViewIndex = projectedViews.indexOf(lView);
        projectedViews.splice(declaredViewIndex, 1);
    }
    /**
     * A standalone function which destroys an LView,
     * conducting cleanup (e.g. removing listeners, calling onDestroys).
     *
     * @param {?} lView The view to be destroyed.
     * @return {?}
     */
    function destroyLView(lView) {
        if (!(lView[FLAGS] & 256 /* Destroyed */)) {
            /** @type {?} */
            var renderer = lView[RENDERER];
            if (isProceduralRenderer(renderer) && renderer.destroyNode) {
                executeActionOnView(renderer, 2 /* Destroy */, lView, null, null);
            }
            destroyViewTree(lView);
        }
    }
    /**
     * Determines which LViewOrLContainer to jump to when traversing back up the
     * tree in destroyViewTree.
     *
     * Normally, the view's parent LView should be checked, but in the case of
     * embedded views, the container (which is the view node's parent, but not the
     * LView's parent) needs to be checked for a possible next property.
     *
     * @param {?} lViewOrLContainer The LViewOrLContainer for which we need a parent state
     * @param {?} rootView The rootView, so we don't propagate too far up the view tree
     * @return {?} The correct parent LViewOrLContainer
     */
    function getParentState(lViewOrLContainer, rootView) {
        /** @type {?} */
        var tNode;
        if (isLView(lViewOrLContainer) && (tNode = lViewOrLContainer[T_HOST]) &&
            tNode.type === 2 /* View */) {
            // if it's an embedded view, the state needs to go up to the container, in case the
            // container has a next
            return getLContainer(( /** @type {?} */(tNode)), lViewOrLContainer);
        }
        else {
            // otherwise, use parent view for containers or component views
            return lViewOrLContainer[PARENT] === rootView ? null : lViewOrLContainer[PARENT];
        }
    }
    /**
     * Calls onDestroys hooks for all directives and pipes in a given view and then removes all
     * listeners. Listeners are removed as the last step so events delivered in the onDestroys hooks
     * can be propagated to \@Output listeners.
     *
     * @param {?} view The LView to clean up
     * @return {?}
     */
    function cleanUpView(view) {
        if (isLView(view) && !(view[FLAGS] & 256 /* Destroyed */)) {
            // Usually the Attached flag is removed when the view is detached from its parent, however
            // if it's a root view, the flag won't be unset hence why we're also removing on destroy.
            view[FLAGS] &= ~128 /* Attached */;
            // Mark the LView as destroyed *before* executing the onDestroy hooks. An onDestroy hook
            // runs arbitrary user code, which could include its own `viewRef.destroy()` (or similar). If
            // We don't flag the view as destroyed before the hooks, this could lead to an infinite loop.
            // This also aligns with the ViewEngine behavior. It also means that the onDestroy hook is
            // really more of an "afterDestroy" hook if you think about it.
            view[FLAGS] |= 256 /* Destroyed */;
            executeOnDestroys(view);
            removeListeners(view);
            /** @type {?} */
            var hostTNode = view[T_HOST];
            // For component views only, the local renderer is destroyed as clean up time.
            if (hostTNode && hostTNode.type === 3 /* Element */ && isProceduralRenderer(view[RENDERER])) {
                ngDevMode && ngDevMode.rendererDestroy++;
                (( /** @type {?} */(view[RENDERER]))).destroy();
            }
            /** @type {?} */
            var declarationContainer = view[DECLARATION_LCONTAINER];
            // we are dealing with an embedded view that is still inserted into a container
            if (declarationContainer !== null && isLContainer(view[PARENT])) {
                // and this is a projected view
                if (declarationContainer !== view[PARENT]) {
                    detachMovedView(declarationContainer, view);
                }
                // For embedded views still attached to a container: remove query result from this view.
                /** @type {?} */
                var lQueries = view[QUERIES];
                if (lQueries !== null) {
                    lQueries.detachView(view[TVIEW]);
                }
            }
        }
    }
    /**
     * Removes listeners and unsubscribes from output subscriptions
     * @param {?} lView
     * @return {?}
     */
    function removeListeners(lView) {
        /** @type {?} */
        var tCleanup = lView[TVIEW].cleanup;
        if (tCleanup !== null) {
            /** @type {?} */
            var lCleanup = ( /** @type {?} */(lView[CLEANUP]));
            for (var i_36 = 0; i_36 < tCleanup.length - 1; i_36 += 2) {
                if (typeof tCleanup[i_36] === 'string') {
                    // This is a native DOM listener
                    /** @type {?} */
                    var idxOrTargetGetter = tCleanup[i_36 + 1];
                    /** @type {?} */
                    var target = typeof idxOrTargetGetter === 'function' ?
                        idxOrTargetGetter(lView) :
                        unwrapRNode(lView[idxOrTargetGetter]);
                    /** @type {?} */
                    var listener = lCleanup[tCleanup[i_36 + 2]];
                    /** @type {?} */
                    var useCaptureOrSubIdx = tCleanup[i_36 + 3];
                    if (typeof useCaptureOrSubIdx === 'boolean') {
                        // native DOM listener registered with Renderer3
                        target.removeEventListener(tCleanup[i_36], listener, useCaptureOrSubIdx);
                    }
                    else {
                        if (useCaptureOrSubIdx >= 0) {
                            // unregister
                            lCleanup[useCaptureOrSubIdx]();
                        }
                        else {
                            // Subscription
                            lCleanup[-useCaptureOrSubIdx].unsubscribe();
                        }
                    }
                    i_36 += 2;
                }
                else {
                    // This is a cleanup function that is grouped with the index of its context
                    /** @type {?} */
                    var context = lCleanup[tCleanup[i_36 + 1]];
                    tCleanup[i_36].call(context);
                }
            }
            lView[CLEANUP] = null;
        }
    }
    /**
     * Calls onDestroy hooks for this view
     * @param {?} view
     * @return {?}
     */
    function executeOnDestroys(view) {
        /** @type {?} */
        var tView = view[TVIEW];
        /** @type {?} */
        var destroyHooks;
        if (tView != null && (destroyHooks = tView.destroyHooks) != null) {
            for (var i_37 = 0; i_37 < destroyHooks.length; i_37 += 2) {
                /** @type {?} */
                var context = view[( /** @type {?} */(destroyHooks[i_37]))];
                // Only call the destroy hook if the context has been requested.
                if (!(context instanceof NodeInjectorFactory)) {
                    (( /** @type {?} */(destroyHooks[i_37 + 1]))).call(context);
                }
            }
        }
    }
    /**
     * Inserts a native node before another native node for a given parent using {\@link Renderer3}.
     * This is a utility function that can be used when native nodes were determined - it abstracts an
     * actual renderer being used.
     * @param {?} renderer
     * @param {?} parent
     * @param {?} child
     * @param {?} beforeNode
     * @return {?}
     */
    function nativeInsertBefore(renderer, parent, child, beforeNode) {
        ngDevMode && ngDevMode.rendererInsertBefore++;
        if (isProceduralRenderer(renderer)) {
            renderer.insertBefore(parent, child, beforeNode);
        }
        else {
            parent.insertBefore(child, beforeNode, true);
        }
    }
    /**
     * Removes a node from the DOM given its native parent.
     * @param {?} renderer
     * @param {?} parent
     * @param {?} child
     * @param {?=} isHostElement
     * @return {?}
     */
    function nativeRemoveChild(renderer, parent, child, isHostElement) {
        if (isProceduralRenderer(renderer)) {
            renderer.removeChild(parent, child, isHostElement);
        }
        else {
            parent.removeChild(child);
        }
    }
    /**
     * Returns a native parent of a given native node.
     * @param {?} renderer
     * @param {?} node
     * @return {?}
     */
    function nativeParentNode(renderer, node) {
        return ( /** @type {?} */((isProceduralRenderer(renderer) ? renderer.parentNode(node) : node.parentNode)));
    }
    /**
     * Removes a native node itself using a given renderer. To remove the node we are looking up its
     * parent from the native tree as not all platforms / browsers support the equivalent of
     * node.remove().
     *
     * @param {?} renderer A renderer to be used
     * @param {?} rNode The native node that should be removed
     * @param {?=} isHostElement A flag indicating if a node to be removed is a host of a component.
     * @return {?}
     */
    function nativeRemoveNode(renderer, rNode, isHostElement) {
        /** @type {?} */
        var nativeParent = nativeParentNode(renderer, rNode);
        if (nativeParent) {
            nativeRemoveChild(renderer, nativeParent, rNode, isHostElement);
        }
    }
    /**
     * `executeActionOnView` performs an operation on the view as specified in `action` (insert, detach,
     * destroy)
     *
     * Inserting a view without projection or containers at top level is simple. Just iterate over the
     * root nodes of the View, and for each node perform the `action`.
     *
     * Things get more complicated with containers and projections. That is because coming across:
     * - Container: implies that we have to insert/remove/destroy the views of that container as well
     *              which in turn can have their own Containers at the View roots.
     * - Projection: implies that we have to insert/remove/destroy the nodes of the projection. The
     *               complication is that the nodes we are projecting can themselves have Containers
     *               or other Projections.
     *
     * As you can see this is a very recursive problem. While the recursive implementation is not the
     * most efficient one, trying to unroll the nodes non-recursively results in very complex code that
     * is very hard (to maintain). We are sacrificing a bit of performance for readability using a
     * recursive implementation.
     *
     * @param {?} renderer Renderer to use
     * @param {?} action action to perform (insert, detach, destroy)
     * @param {?} lView The LView which needs to be inserted, detached, destroyed.
     * @param {?} renderParent parent DOM element for insertion/removal.
     * @param {?} beforeNode Before which node the insertions should happen.
     * @return {?}
     */
    function executeActionOnView(renderer, action, lView, renderParent, beforeNode) {
        /** @type {?} */
        var tView = lView[TVIEW];
        ngDevMode && assertNodeType(( /** @type {?} */(tView.node)), 2 /* View */);
        /** @type {?} */
        var viewRootTNode = ( /** @type {?} */(tView.node)).child;
        while (viewRootTNode !== null) {
            executeActionOnNode(renderer, action, lView, viewRootTNode, renderParent, beforeNode);
            viewRootTNode = viewRootTNode.next;
        }
    }
    /**
     * `executeActionOnProjection` performs an operation on the projection specified by `action`
     * (insert, detach, destroy).
     *
     * Inserting a projection requires us to locate the projected nodes from the parent component. The
     * complication is that those nodes themselves could be re-projected from their parent component.
     *
     * @param {?} renderer Renderer to use
     * @param {?} action action to perform (insert, detach, destroy)
     * @param {?} lView The LView which needs to be inserted, detached, destroyed.
     * @param {?} tProjectionNode projection TNode to process
     * @param {?} renderParent parent DOM element for insertion/removal.
     * @param {?} beforeNode Before which node the insertions should happen.
     * @return {?}
     */
    function executeActionOnProjection(renderer, action, lView, tProjectionNode, renderParent, beforeNode) {
        /** @type {?} */
        var componentLView = findComponentView(lView);
        /** @type {?} */
        var componentNode = ( /** @type {?} */(componentLView[T_HOST]));
        ngDevMode && assertDefined(componentNode.projection, 'Element nodes for which projection is processed must have projection defined.');
        /** @type {?} */
        var nodeToProject = ( /** @type {?} */(componentNode.projection))[tProjectionNode.projection];
        if (nodeToProject !== undefined) {
            if (Array.isArray(nodeToProject)) {
                for (var i_38 = 0; i_38 < nodeToProject.length; i_38++) {
                    /** @type {?} */
                    var rNode = nodeToProject[i_38];
                    ngDevMode && assertDomNode(rNode);
                    executeActionOnElementOrContainer(action, renderer, renderParent, rNode, beforeNode);
                }
            }
            else {
                /** @type {?} */
                var projectionTNode = nodeToProject;
                /** @type {?} */
                var projectedComponentLView = ( /** @type {?} */(componentLView[PARENT]));
                while (projectionTNode !== null) {
                    executeActionOnNode(renderer, action, projectedComponentLView, projectionTNode, renderParent, beforeNode);
                    projectionTNode = projectionTNode.projectionNext;
                }
            }
        }
    }
    /**
     * `executeActionOnContainer` performs an operation on the container and its views as specified by
     * `action` (insert, detach, destroy)
     *
     * Inserting a Container is complicated by the fact that the container may have Views which
     * themselves have containers or projections.
     *
     * @param {?} renderer Renderer to use
     * @param {?} action action to perform (insert, detach, destroy)
     * @param {?} lContainer The LContainer which needs to be inserted, detached, destroyed.
     * @param {?} renderParent parent DOM element for insertion/removal.
     * @param {?} beforeNode Before which node the insertions should happen.
     * @return {?}
     */
    function executeActionOnContainer(renderer, action, lContainer, renderParent, beforeNode) {
        ngDevMode && assertLContainer(lContainer);
        /** @type {?} */
        var anchor = lContainer[NATIVE];
        // LContainer has its own before node.
        /** @type {?} */
        var native = unwrapRNode(lContainer);
        // An LContainer can be created dynamically on any node by injecting ViewContainerRef.
        // Asking for a ViewContainerRef on an element will result in a creation of a separate anchor node
        // (comment in the DOM) that will be different from the LContainer's host node. In this particular
        // case we need to execute action on 2 nodes:
        // - container's host node (this is done in the executeNodeAction)
        // - container's host node (this is done here)
        if (anchor !== native) {
            executeActionOnElementOrContainer(action, renderer, renderParent, anchor, beforeNode);
        }
        for (var i_39 = CONTAINER_HEADER_OFFSET; i_39 < lContainer.length; i_39++) {
            /** @type {?} */
            var lView_1 = ( /** @type {?} */(lContainer[i_39]));
            executeActionOnView(renderer, action, lView_1, renderParent, anchor);
        }
    }
    /**
     * `executeActionOnElementContainerOrIcuContainer` performs an operation on the ng-container node
     * and its child nodes as specified by the `action` (insert, detach, destroy).
     *
     * @param {?} renderer Renderer to use
     * @param {?} action action to perform (insert, detach, destroy)
     * @param {?} lView The LView which needs to be inserted, detached, destroyed.
     * @param {?} tNode The TNode associated with the `ElementContainer` or `IcuContainer`.
     * @param {?} renderParent parent DOM element for insertion/removal.
     * @param {?} beforeNode Before which node the insertions should happen.
     * @return {?}
     */
    function executeActionOnElementContainerOrIcuContainer(renderer, action, lView, tNode, renderParent, beforeNode) {
        /** @type {?} */
        var node = lView[tNode.index];
        executeActionOnElementOrContainer(action, renderer, renderParent, node, beforeNode);
        /** @type {?} */
        var childTNode = tNode.child;
        while (childTNode) {
            executeActionOnNode(renderer, action, lView, childTNode, renderParent, beforeNode);
            childTNode = childTNode.next;
        }
    }
    /**
     * @param {?} renderer
     * @param {?} action
     * @param {?} lView
     * @param {?} tNode
     * @param {?} renderParent
     * @param {?} beforeNode
     * @return {?}
     */
    function executeActionOnNode(renderer, action, lView, tNode, renderParent, beforeNode) {
        /** @type {?} */
        var nodeType = tNode.type;
        if (!(tNode.flags & 32 /* isDetached */)) {
            if (nodeType === 4 /* ElementContainer */ || nodeType === 5 /* IcuContainer */) {
                executeActionOnElementContainerOrIcuContainer(renderer, action, lView, ( /** @type {?} */(tNode)), renderParent, beforeNode);
            }
            else if (nodeType === 1 /* Projection */) {
                executeActionOnProjection(renderer, action, lView, ( /** @type {?} */(tNode)), renderParent, beforeNode);
            }
            else {
                ngDevMode && assertNodeOfPossibleTypes(tNode, 3 /* Element */, 0 /* Container */);
                executeActionOnElementOrContainer(action, renderer, renderParent, lView[tNode.index], beforeNode);
            }
        }
    }
    /**
     * @template T
     */
    var ViewRef = /** @class */ (function () {
        /**
         * @param {?} _lView
         * @param {?} _context
         * @param {?} _componentIndex
         */
        function ViewRef(_lView, _context, _componentIndex) {
            this._context = _context;
            this._componentIndex = _componentIndex;
            this._appRef = null;
            this._viewContainerRef = null;
            /**
             * \@internal
             */
            this._tViewNode = null;
            this._lView = _lView;
        }
        Object.defineProperty(ViewRef.prototype, "rootNodes", {
            /**
             * @return {?}
             */
            get: function () {
                if (this._lView[HOST] == null) {
                    /** @type {?} */
                    var tView = ( /** @type {?} */(this._lView[T_HOST]));
                    return collectNativeNodes(this._lView, tView, []);
                }
                return [];
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ViewRef.prototype, "context", {
            /**
             * @return {?}
             */
            get: function () { return this._context ? this._context : this._lookUpContext(); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ViewRef.prototype, "destroyed", {
            /**
             * @return {?}
             */
            get: function () {
                return (this._lView[FLAGS] & 256 /* Destroyed */) === 256 /* Destroyed */;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        ViewRef.prototype.destroy = function () {
            if (this._appRef) {
                this._appRef.detachView(this);
            }
            else if (this._viewContainerRef) {
                /** @type {?} */
                var index = this._viewContainerRef.indexOf(this);
                if (index > -1) {
                    this._viewContainerRef.detach(index);
                }
                this._viewContainerRef = null;
            }
            destroyLView(this._lView);
        };
        /**
         * @param {?} callback
         * @return {?}
         */
        ViewRef.prototype.onDestroy = function (callback) { storeCleanupFn(this._lView, callback); };
        /**
         * Marks a view and all of its ancestors dirty.
         *
         * It also triggers change detection by calling `scheduleTick` internally, which coalesces
         * multiple `markForCheck` calls to into one change detection run.
         *
         * This can be used to ensure an {\@link ChangeDetectionStrategy#OnPush OnPush} component is
         * checked when it needs to be re-rendered but the two normal triggers haven't marked it
         * dirty (i.e. inputs haven't changed and events haven't fired in the view).
         *
         * <!-- TODO: Add a link to a chapter on OnPush components -->
         *
         * \@usageNotes
         * ### Example
         *
         * ```typescript
         * \@Component({
         *   selector: 'my-app',
         *   template: `Number of ticks: {{numberOfTicks}}`
         *   changeDetection: ChangeDetectionStrategy.OnPush,
         * })
         * class AppComponent {
         *   numberOfTicks = 0;
         *
         *   constructor(private ref: ChangeDetectorRef) {
         *     setInterval(() => {
         *       this.numberOfTicks++;
         *       // the following is required, otherwise the view will not be updated
         *       this.ref.markForCheck();
         *     }, 1000);
         *   }
         * }
         * ```
         * @return {?}
         */
        ViewRef.prototype.markForCheck = function () { markViewDirty(this._lView); };
        /**
         * Detaches the view from the change detection tree.
         *
         * Detached views will not be checked during change detection runs until they are
         * re-attached, even if they are dirty. `detach` can be used in combination with
         * {\@link ChangeDetectorRef#detectChanges detectChanges} to implement local change
         * detection checks.
         *
         * <!-- TODO: Add a link to a chapter on detach/reattach/local digest -->
         * <!-- TODO: Add a live demo once ref.detectChanges is merged into master -->
         *
         * \@usageNotes
         * ### Example
         *
         * The following example defines a component with a large list of readonly data.
         * Imagine the data changes constantly, many times per second. For performance reasons,
         * we want to check and update the list every five seconds. We can do that by detaching
         * the component's change detector and doing a local check every five seconds.
         *
         * ```typescript
         * class DataProvider {
         *   // in a real application the returned data will be different every time
         *   get data() {
         *     return [1,2,3,4,5];
         *   }
         * }
         *
         * \@Component({
         *   selector: 'giant-list',
         *   template: `
         *     <li *ngFor="let d of dataProvider.data">Data {{d}}</li>
         *   `,
         * })
         * class GiantList {
         *   constructor(private ref: ChangeDetectorRef, private dataProvider: DataProvider) {
         *     ref.detach();
         *     setInterval(() => {
         *       this.ref.detectChanges();
         *     }, 5000);
         *   }
         * }
         *  /
         *   selector: 'app',
         *   providers: [DataProvider],
         *   template: `
         *     <giant-list><giant-list>
         *   `,
         * })
         * class App {
         * }
         * ```
         * @return {?}
         */
        ViewRef.prototype.detach = function () { this._lView[FLAGS] &= ~128 /* Attached */; };
        /**
         * Re-attaches a view to the change detection tree.
         *
         * This can be used to re-attach views that were previously detached from the tree
         * using {\@link ChangeDetectorRef#detach detach}. Views are attached to the tree by default.
         *
         * <!-- TODO: Add a link to a chapter on detach/reattach/local digest -->
         *
         * \@usageNotes
         * ### Example
         *
         * The following example creates a component displaying `live` data. The component will detach
         * its change detector from the main change detector tree when the component's live property
         * is set to false.
         *
         * ```typescript
         * class DataProvider {
         *   data = 1;
         *
         *   constructor() {
         *     setInterval(() => {
         *       this.data = this.data * 2;
         *     }, 500);
         *   }
         * }
         *
         * \@Component({
         *   selector: 'live-data',
         *   inputs: ['live'],
         *   template: 'Data: {{dataProvider.data}}'
         * })
         * class LiveData {
         *   constructor(private ref: ChangeDetectorRef, private dataProvider: DataProvider) {}
         *
         *   set live(value) {
         *     if (value) {
         *       this.ref.reattach();
         *     } else {
         *       this.ref.detach();
         *     }
         *   }
         * }
         *  /
         *   selector: 'my-app',
         *   providers: [DataProvider],
         *   template: `
         *     Live Update: <input type="checkbox" [(ngModel)]="live">
         *     <live-data [live]="live"><live-data>
         *   `,
         * })
         * class AppComponent {
         *   live = true;
         * }
         * ```
         * @return {?}
         */
        ViewRef.prototype.reattach = function () { this._lView[FLAGS] |= 128 /* Attached */; };
        /**
         * Checks the view and its children.
         *
         * This can also be used in combination with {\@link ChangeDetectorRef#detach detach} to implement
         * local change detection checks.
         *
         * <!-- TODO: Add a link to a chapter on detach/reattach/local digest -->
         * <!-- TODO: Add a live demo once ref.detectChanges is merged into master -->
         *
         * \@usageNotes
         * ### Example
         *
         * The following example defines a component with a large list of readonly data.
         * Imagine, the data changes constantly, many times per second. For performance reasons,
         * we want to check and update the list every five seconds.
         *
         * We can do that by detaching the component's change detector and doing a local change detection
         * check every five seconds.
         *
         * See {\@link ChangeDetectorRef#detach detach} for more information.
         * @return {?}
         */
        ViewRef.prototype.detectChanges = function () { detectChangesInternal(this._lView, this.context); };
        /**
         * Checks the change detector and its children, and throws if any changes are detected.
         *
         * This is used in development mode to verify that running change detection doesn't
         * introduce other changes.
         * @return {?}
         */
        ViewRef.prototype.checkNoChanges = function () { checkNoChangesInternal(this._lView, this.context); };
        /**
         * @param {?} vcRef
         * @return {?}
         */
        ViewRef.prototype.attachToViewContainerRef = function (vcRef) {
            if (this._appRef) {
                throw new Error('This view is already attached directly to the ApplicationRef!');
            }
            this._viewContainerRef = vcRef;
        };
        /**
         * @return {?}
         */
        ViewRef.prototype.detachFromAppRef = function () {
            this._appRef = null;
            renderDetachView(this._lView);
        };
        /**
         * @param {?} appRef
         * @return {?}
         */
        ViewRef.prototype.attachToAppRef = function (appRef) {
            if (this._viewContainerRef) {
                throw new Error('This view is already attached to a ViewContainer!');
            }
            this._appRef = appRef;
        };
        /**
         * @private
         * @return {?}
         */
        ViewRef.prototype._lookUpContext = function () {
            return this._context = ( /** @type {?} */(( /** @type {?} */(getLViewParent(this._lView)))[this._componentIndex]));
        };
        return ViewRef;
    }());
    /**
     * \@internal
     * @template T
     */
    var RootViewRef = /** @class */ (function (_super) {
        __extends(RootViewRef, _super);
        /**
         * @param {?} _view
         */
        function RootViewRef(_view) {
            var _this = _super.call(this, _view, null, -1) || this;
            _this._view = _view;
            return _this;
        }
        /**
         * @return {?}
         */
        RootViewRef.prototype.detectChanges = function () { detectChangesInRootView(this._view); };
        /**
         * @return {?}
         */
        RootViewRef.prototype.checkNoChanges = function () { checkNoChangesInRootView(this._view); };
        Object.defineProperty(RootViewRef.prototype, "context", {
            /**
             * @return {?}
             */
            get: function () { return ( /** @type {?} */(null)); },
            enumerable: true,
            configurable: true
        });
        return RootViewRef;
    }(ViewRef));
    /**
     * @param {?} lView
     * @param {?} parentTNode
     * @param {?} result
     * @return {?}
     */
    function collectNativeNodes(lView, parentTNode, result) {
        /** @type {?} */
        var tNodeChild = parentTNode.child;
        while (tNodeChild) {
            /** @type {?} */
            var nativeNode = getNativeByTNodeOrNull(tNodeChild, lView);
            nativeNode && result.push(nativeNode);
            if (tNodeChild.type === 4 /* ElementContainer */) {
                collectNativeNodes(lView, tNodeChild, result);
            }
            else if (tNodeChild.type === 1 /* Projection */) {
                /** @type {?} */
                var componentView = findComponentView(lView);
                /** @type {?} */
                var componentHost = ( /** @type {?} */(componentView[T_HOST]));
                /** @type {?} */
                var parentView = getLViewParent(componentView);
                /** @type {?} */
                var currentProjectedNode = (( /** @type {?} */(componentHost.projection)))[( /** @type {?} */(tNodeChild.projection))];
                while (currentProjectedNode && parentView) {
                    result.push(getNativeByTNode(currentProjectedNode, parentView));
                    currentProjectedNode = currentProjectedNode.next;
                }
            }
            tNodeChild = tNodeChild.next;
        }
        return result;
    }
    /** @type {?} */
    var R3ElementRef;
    /**
     * Creates an ElementRef given a node.
     *
     * @param {?} ElementRefToken The ElementRef type
     * @param {?} tNode The node for which you'd like an ElementRef
     * @param {?} view The view to which the node belongs
     * @return {?} The ElementRef instance to use
     */
    function createElementRef(ElementRefToken, tNode, view) {
        if (!R3ElementRef) {
            // TODO: Fix class name, should be ElementRef, but there appears to be a rollup bug
            R3ElementRef = /** @class */ (function (_super) {
                __extends(ElementRef_, _super);
                function ElementRef_() {
                    return _super !== null && _super.apply(this, arguments) || this;
                }
                return ElementRef_;
            }(ElementRefToken));
        }
        return new R3ElementRef(( /** @type {?} */(getNativeByTNode(tNode, view))));
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Base class for Angular Views, provides change detection functionality.
     * A change-detection tree collects all views that are to be checked for changes.
     * Use the methods to add and remove views from the tree, initiate change-detection,
     * and explicitly mark views as _dirty_, meaning that they have changed and need to be rerendered.
     *
     * \@usageNotes
     *
     * The following examples demonstrate how to modify default change-detection behavior
     * to perform explicit detection when needed.
     *
     * ### Use `markForCheck()` with `CheckOnce` strategy
     *
     * The following example sets the `OnPush` change-detection strategy for a component
     * (`CheckOnce`, rather than the default `CheckAlways`), then forces a second check
     * after an interval. See [live demo](http://plnkr.co/edit/GC512b?p=preview).
     *
     * <code-example path="core/ts/change_detect/change-detection.ts"
     * region="mark-for-check"></code-example>
     *
     * ### Detach change detector to limit how often check occurs
     *
     * The following example defines a component with a large list of read-only data
     * that is expected to change constantly, many times per second.
     * To improve performance, we want to check and update the list
     * less often than the changes actually occur. To do that, we detach
     * the component's change detector and perform an explicit local check every five seconds.
     *
     * <code-example path="core/ts/change_detect/change-detection.ts" region="detach"></code-example>
     *
     *
     * ### Reattaching a detached component
     *
     * The following example creates a component displaying live data.
     * The component detaches its change detector from the main change detector tree
     * when the `live` property is set to false, and reattaches it when the property
     * becomes true.
     *
     * <code-example path="core/ts/change_detect/change-detection.ts" region="reattach"></code-example>
     *
     * \@publicApi
     * @abstract
     */
    var ChangeDetectorRef = /** @class */ (function () {
        function ChangeDetectorRef() {
        }
        return ChangeDetectorRef;
    }());
    /**
     * \@internal
     * @nocollapse
     */
    ChangeDetectorRef.__NG_ELEMENT_ID__ = ( /**
     * @return {?}
     */function () { return SWITCH_CHANGE_DETECTOR_REF_FACTORY(); });
    /** @type {?} */
    var SWITCH_CHANGE_DETECTOR_REF_FACTORY__PRE_R3__ = ( /**
     * @param {...?} args
     * @return {?}
     */function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
    });
    /** @type {?} */
    var SWITCH_CHANGE_DETECTOR_REF_FACTORY = SWITCH_CHANGE_DETECTOR_REF_FACTORY__PRE_R3__;
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @description
     *
     * Represents a type that a Component or other object is instances of.
     *
     * An example of a `Type` is `MyCustomComponent` class, which in JavaScript is be represented by
     * the `MyCustomComponent` constructor function.
     *
     * @publicApi
     */
    var Type = Function;
    function isType(v) {
        return typeof v === 'function';
    }
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * Attention: These regex has to hold even if the code is minified!
     */
    var DELEGATE_CTOR = /^function\s+\S+\(\)\s*{[\s\S]+\.apply\(this,\s*arguments\)/;
    var INHERITED_CLASS = /^class\s+[A-Za-z\d$_]*\s*extends\s+[^{]+{/;
    var INHERITED_CLASS_WITH_CTOR = /^class\s+[A-Za-z\d$_]*\s*extends\s+[^{]+{[\s\S]*constructor\s*\(/;
    var INHERITED_CLASS_WITH_DELEGATE_CTOR = /^class\s+[A-Za-z\d$_]*\s*extends\s+[^{]+{[\s\S]*constructor\s*\(\)\s*{\s+super\(\.\.\.arguments\)/;
    /**
     * Determine whether a stringified type is a class which delegates its constructor
     * to its parent.
     *
     * This is not trivial since compiled code can actually contain a constructor function
     * even if the original source code did not. For instance, when the child class contains
     * an initialized instance property.
     */
    function isDelegateCtor(typeStr) {
        return DELEGATE_CTOR.test(typeStr) || INHERITED_CLASS_WITH_DELEGATE_CTOR.test(typeStr) ||
            (INHERITED_CLASS.test(typeStr) && !INHERITED_CLASS_WITH_CTOR.test(typeStr));
    }
    var ReflectionCapabilities = /** @class */ (function () {
        function ReflectionCapabilities(reflect) {
            this._reflect = reflect || _global['Reflect'];
        }
        ReflectionCapabilities.prototype.isReflectionEnabled = function () { return true; };
        ReflectionCapabilities.prototype.factory = function (t) { return function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return new (t.bind.apply(t, __spread([void 0], args)))();
        }; };
        /** @internal */
        ReflectionCapabilities.prototype._zipTypesAndAnnotations = function (paramTypes, paramAnnotations) {
            var result;
            if (typeof paramTypes === 'undefined') {
                result = new Array(paramAnnotations.length);
            }
            else {
                result = new Array(paramTypes.length);
            }
            for (var i_40 = 0; i_40 < result.length; i_40++) {
                // TS outputs Object for parameters without types, while Traceur omits
                // the annotations. For now we preserve the Traceur behavior to aid
                // migration, but this can be revisited.
                if (typeof paramTypes === 'undefined') {
                    result[i_40] = [];
                }
                else if (paramTypes[i_40] && paramTypes[i_40] != Object) {
                    result[i_40] = [paramTypes[i_40]];
                }
                else {
                    result[i_40] = [];
                }
                if (paramAnnotations && paramAnnotations[i_40] != null) {
                    result[i_40] = result[i_40].concat(paramAnnotations[i_40]);
                }
            }
            return result;
        };
        ReflectionCapabilities.prototype._ownParameters = function (type, parentCtor) {
            var typeStr = type.toString();
            // If we have no decorators, we only have function.length as metadata.
            // In that case, to detect whether a child class declared an own constructor or not,
            // we need to look inside of that constructor to check whether it is
            // just calling the parent.
            // This also helps to work around for https://github.com/Microsoft/TypeScript/issues/12439
            // that sets 'design:paramtypes' to []
            // if a class inherits from another class but has no ctor declared itself.
            if (isDelegateCtor(typeStr)) {
                return null;
            }
            // Prefer the direct API.
            if (type.parameters && type.parameters !== parentCtor.parameters) {
                return type.parameters;
            }
            // API of tsickle for lowering decorators to properties on the class.
            var tsickleCtorParams = type.ctorParameters;
            if (tsickleCtorParams && tsickleCtorParams !== parentCtor.ctorParameters) {
                // Newer tsickle uses a function closure
                // Retain the non-function case for compatibility with older tsickle
                var ctorParameters = typeof tsickleCtorParams === 'function' ? tsickleCtorParams() : tsickleCtorParams;
                var paramTypes_1 = ctorParameters.map(function (ctorParam) { return ctorParam && ctorParam.type; });
                var paramAnnotations_1 = ctorParameters.map(function (ctorParam) { return ctorParam && convertTsickleDecoratorIntoMetadata(ctorParam.decorators); });
                return this._zipTypesAndAnnotations(paramTypes_1, paramAnnotations_1);
            }
            // API for metadata created by invoking the decorators.
            var paramAnnotations = type.hasOwnProperty(PARAMETERS) && type[PARAMETERS];
            var paramTypes = this._reflect && this._reflect.getOwnMetadata &&
                this._reflect.getOwnMetadata('design:paramtypes', type);
            if (paramTypes || paramAnnotations) {
                return this._zipTypesAndAnnotations(paramTypes, paramAnnotations);
            }
            // If a class has no decorators, at least create metadata
            // based on function.length.
            // Note: We know that this is a real constructor as we checked
            // the content of the constructor above.
            return new Array(type.length).fill(undefined);
        };
        ReflectionCapabilities.prototype.parameters = function (type) {
            // Note: only report metadata if we have at least one class decorator
            // to stay in sync with the static reflector.
            if (!isType(type)) {
                return [];
            }
            var parentCtor = getParentCtor(type);
            var parameters = this._ownParameters(type, parentCtor);
            if (!parameters && parentCtor !== Object) {
                parameters = this.parameters(parentCtor);
            }
            return parameters || [];
        };
        ReflectionCapabilities.prototype._ownAnnotations = function (typeOrFunc, parentCtor) {
            // Prefer the direct API.
            if (typeOrFunc.annotations && typeOrFunc.annotations !== parentCtor.annotations) {
                var annotations = typeOrFunc.annotations;
                if (typeof annotations === 'function' && annotations.annotations) {
                    annotations = annotations.annotations;
                }
                return annotations;
            }
            // API of tsickle for lowering decorators to properties on the class.
            if (typeOrFunc.decorators && typeOrFunc.decorators !== parentCtor.decorators) {
                return convertTsickleDecoratorIntoMetadata(typeOrFunc.decorators);
            }
            // API for metadata created by invoking the decorators.
            if (typeOrFunc.hasOwnProperty(ANNOTATIONS)) {
                return typeOrFunc[ANNOTATIONS];
            }
            return null;
        };
        ReflectionCapabilities.prototype.annotations = function (typeOrFunc) {
            if (!isType(typeOrFunc)) {
                return [];
            }
            var parentCtor = getParentCtor(typeOrFunc);
            var ownAnnotations = this._ownAnnotations(typeOrFunc, parentCtor) || [];
            var parentAnnotations = parentCtor !== Object ? this.annotations(parentCtor) : [];
            return parentAnnotations.concat(ownAnnotations);
        };
        ReflectionCapabilities.prototype._ownPropMetadata = function (typeOrFunc, parentCtor) {
            // Prefer the direct API.
            if (typeOrFunc.propMetadata &&
                typeOrFunc.propMetadata !== parentCtor.propMetadata) {
                var propMetadata = typeOrFunc.propMetadata;
                if (typeof propMetadata === 'function' && propMetadata.propMetadata) {
                    propMetadata = propMetadata.propMetadata;
                }
                return propMetadata;
            }
            // API of tsickle for lowering decorators to properties on the class.
            if (typeOrFunc.propDecorators &&
                typeOrFunc.propDecorators !== parentCtor.propDecorators) {
                var propDecorators_1 = typeOrFunc.propDecorators;
                var propMetadata_1 = {};
                Object.keys(propDecorators_1).forEach(function (prop) {
                    propMetadata_1[prop] = convertTsickleDecoratorIntoMetadata(propDecorators_1[prop]);
                });
                return propMetadata_1;
            }
            // API for metadata created by invoking the decorators.
            if (typeOrFunc.hasOwnProperty(PROP_METADATA)) {
                return typeOrFunc[PROP_METADATA];
            }
            return null;
        };
        ReflectionCapabilities.prototype.propMetadata = function (typeOrFunc) {
            if (!isType(typeOrFunc)) {
                return {};
            }
            var parentCtor = getParentCtor(typeOrFunc);
            var propMetadata = {};
            if (parentCtor !== Object) {
                var parentPropMetadata_1 = this.propMetadata(parentCtor);
                Object.keys(parentPropMetadata_1).forEach(function (propName) {
                    propMetadata[propName] = parentPropMetadata_1[propName];
                });
            }
            var ownPropMetadata = this._ownPropMetadata(typeOrFunc, parentCtor);
            if (ownPropMetadata) {
                Object.keys(ownPropMetadata).forEach(function (propName) {
                    var decorators = [];
                    if (propMetadata.hasOwnProperty(propName)) {
                        decorators.push.apply(decorators, __spread(propMetadata[propName]));
                    }
                    decorators.push.apply(decorators, __spread(ownPropMetadata[propName]));
                    propMetadata[propName] = decorators;
                });
            }
            return propMetadata;
        };
        ReflectionCapabilities.prototype.ownPropMetadata = function (typeOrFunc) {
            if (!isType(typeOrFunc)) {
                return {};
            }
            return this._ownPropMetadata(typeOrFunc, getParentCtor(typeOrFunc)) || {};
        };
        ReflectionCapabilities.prototype.hasLifecycleHook = function (type, lcProperty) {
            return type instanceof Type && lcProperty in type.prototype;
        };
        ReflectionCapabilities.prototype.guards = function (type) { return {}; };
        ReflectionCapabilities.prototype.getter = function (name) { return new Function('o', 'return o.' + name + ';'); };
        ReflectionCapabilities.prototype.setter = function (name) {
            return new Function('o', 'v', 'return o.' + name + ' = v;');
        };
        ReflectionCapabilities.prototype.method = function (name) {
            var functionBody = "if (!o." + name + ") throw new Error('\"" + name + "\" is undefined');\n        return o." + name + ".apply(o, args);";
            return new Function('o', 'args', functionBody);
        };
        // There is not a concept of import uri in Js, but this is useful in developing Dart applications.
        ReflectionCapabilities.prototype.importUri = function (type) {
            // StaticSymbol
            if (typeof type === 'object' && type['filePath']) {
                return type['filePath'];
            }
            // Runtime type
            return "./" + stringify(type);
        };
        ReflectionCapabilities.prototype.resourceUri = function (type) { return "./" + stringify(type); };
        ReflectionCapabilities.prototype.resolveIdentifier = function (name, moduleUrl, members, runtime) {
            return runtime;
        };
        ReflectionCapabilities.prototype.resolveEnum = function (enumIdentifier, name) { return enumIdentifier[name]; };
        return ReflectionCapabilities;
    }());
    function convertTsickleDecoratorIntoMetadata(decoratorInvocations) {
        if (!decoratorInvocations) {
            return [];
        }
        return decoratorInvocations.map(function (decoratorInvocation) {
            var decoratorType = decoratorInvocation.type;
            var annotationCls = decoratorType.annotationCls;
            var annotationArgs = decoratorInvocation.args ? decoratorInvocation.args : [];
            return new (annotationCls.bind.apply(annotationCls, __spread([void 0], annotationArgs)))();
        });
    }
    function getParentCtor(ctor) {
        var parentProto = ctor.prototype ? Object.getPrototypeOf(ctor.prototype) : null;
        var parentCtor = parentProto ? parentProto.constructor : null;
        // Note: We always use `Object` as the null value
        // to simplify checking later on.
        return parentCtor || Object;
    }
    var ɵ0$7 = getClosureSafeProperty;
    /** @type {?} */
    var USE_VALUE$1 = getClosureSafeProperty({ provide: String, useValue: ɵ0$7 });
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ɵ0$8 = getClosureSafeProperty;
    /** @type {?} */
    var USE_VALUE$2 = getClosureSafeProperty({ provide: String, useValue: ɵ0$8 });
    /** @type {?} */
    var EMPTY_ARRAY$1 = [];
    /**
     * @param {?} type
     * @param {?=} provider
     * @return {?}
     */
    function convertInjectableProviderToFactory(type, provider) {
        if (!provider) {
            /** @type {?} */
            var reflectionCapabilities = new ReflectionCapabilities();
            /** @type {?} */
            var deps_1 = reflectionCapabilities.parameters(type);
            // TODO - convert to flags.
            return ( /**
             * @return {?}
             */function () { return new (type.bind.apply(type, __spread([void 0], injectArgs(( /** @type {?} */(deps_1))))))(); });
        }
        if (USE_VALUE$2 in provider) {
            /** @type {?} */
            var valueProvider_1 = (( /** @type {?} */(provider)));
            return ( /**
             * @return {?}
             */function () { return valueProvider_1.useValue; });
        }
        else if ((( /** @type {?} */(provider))).useExisting) {
            /** @type {?} */
            var existingProvider_1 = (( /** @type {?} */(provider)));
            return ( /**
             * @return {?}
             */function () { return ɵɵinject(existingProvider_1.useExisting); });
        }
        else if ((( /** @type {?} */(provider))).useFactory) {
            /** @type {?} */
            var factoryProvider_1 = (( /** @type {?} */(provider)));
            return ( /**
             * @return {?}
             */function () { return factoryProvider_1.useFactory.apply(factoryProvider_1, __spread(injectArgs(factoryProvider_1.deps || EMPTY_ARRAY$1))); });
        }
        else if ((( /** @type {?} */(provider))).useClass) {
            /** @type {?} */
            var classProvider_1 = (( /** @type {?} */(provider)));
            /** @type {?} */
            var deps_2 = (( /** @type {?} */(provider))).deps;
            if (!deps_2) {
                /** @type {?} */
                var reflectionCapabilities = new ReflectionCapabilities();
                deps_2 = reflectionCapabilities.parameters(type);
            }
            return ( /**
             * @return {?}
             */function () {
                var _b;
                return new ((_b = classProvider_1.useClass).bind.apply(_b, __spread([void 0], injectArgs(deps_2))))();
            });
        }
        else {
            /** @type {?} */
            var deps_3 = (( /** @type {?} */(provider))).deps;
            if (!deps_3) {
                /** @type {?} */
                var reflectionCapabilities = new ReflectionCapabilities();
                deps_3 = reflectionCapabilities.parameters(type);
            }
            return ( /**
             * @return {?}
             */function () { return new (type.bind.apply(type, __spread([void 0], injectArgs(( /** @type {?} */(deps_3))))))(); });
        }
    }
    // WARNING: interface has both a type and a value, skipping emit
    var ɵ0$9 = /**
     * @param {?} type
     * @param {?} meta
     * @return {?}
     */ function (type, meta) { return SWITCH_COMPILE_INJECTABLE(( /** @type {?} */(type)), meta); };
    /**
     * Injectable decorator and metadata.
     *
     * \@Annotation
     * \@publicApi
     * @type {?}
     */
    var Injectable = makeDecorator('Injectable', undefined, undefined, undefined, (ɵ0$9));
    /**
     * Supports \@Injectable() in JIT mode for Render2.
     * @param {?} injectableType
     * @param {?=} options
     * @return {?}
     */
    function render2CompileInjectable(injectableType, options) {
        if (options && options.providedIn !== undefined && !getInjectableDef(injectableType)) {
            (( /** @type {?} */(injectableType))).ngInjectableDef = ɵɵdefineInjectable({
                token: injectableType,
                providedIn: options.providedIn,
                factory: convertInjectableProviderToFactory(injectableType, options),
            });
        }
    }
    /** @type {?} */
    var SWITCH_COMPILE_INJECTABLE__PRE_R3__ = render2CompileInjectable;
    /** @type {?} */
    var SWITCH_COMPILE_INJECTABLE = SWITCH_COMPILE_INJECTABLE__PRE_R3__;
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * An internal token whose presence in an injector indicates that the injector should treat itself
     * as a root scoped injector when processing requests for unknown tokens which may indicate
     * they are provided in the root scope.
     * @type {?}
     */
    var APP_ROOT = new InjectionToken('The presence of this token marks an injector as being the root injector.');
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} providers
     * @param {?} parent
     * @param {?} name
     * @return {?}
     */
    function INJECTOR_IMPL__PRE_R3__(providers, parent, name) {
        return new StaticInjector(providers, parent, name);
    }
    /** @type {?} */
    var INJECTOR_IMPL = INJECTOR_IMPL__PRE_R3__;
    /**
     * Concrete injectors implement this interface.
     *
     * For more details, see the ["Dependency Injection Guide"](guide/dependency-injection).
     *
     * \@usageNotes
     * ### Example
     *
     * {\@example core/di/ts/injector_spec.ts region='Injector'}
     *
     * `Injector` returns itself when given `Injector` as a token:
     *
     * {\@example core/di/ts/injector_spec.ts region='injectInjector'}
     *
     * \@publicApi
     * @abstract
     */
    var Injector = /** @class */ (function () {
        function Injector() {
        }
        /**
         * Create a new Injector which is configure using `StaticProvider`s.
         *
         * \@usageNotes
         * ### Example
         *
         * {\@example core/di/ts/provider_spec.ts region='ConstructorProvider'}
         * @param {?} options
         * @param {?=} parent
         * @return {?}
         */
        Injector.create = function (options, parent) {
            if (Array.isArray(options)) {
                return INJECTOR_IMPL(options, parent, '');
            }
            else {
                return INJECTOR_IMPL(options.providers, options.parent, options.name || '');
            }
        };
        return Injector;
    }());
    Injector.THROW_IF_NOT_FOUND = THROW_IF_NOT_FOUND;
    Injector.NULL = new NullInjector();
    /** @nocollapse */
    /** @nocollapse */ Injector.ngInjectableDef = ɵɵdefineInjectable({
        token: Injector,
        providedIn: ( /** @type {?} */('any')),
        factory: ( /**
         * @return {?}
         */function () { return ɵɵinject(INJECTOR); }),
    });
    /**
     * \@internal
     * @nocollapse
     */
    Injector.__NG_ELEMENT_ID__ = -1;
    /** @type {?} */
    var IDENT = ( /**
     * @template T
     * @param {?} value
     * @return {?}
     */function (value) {
        return value;
    });
    /** @type {?} */
    var EMPTY$1 = ( /** @type {?} */([]));
    /** @type {?} */
    var CIRCULAR$1 = IDENT;
    /** @type {?} */
    var MULTI_PROVIDER_FN = ( /**
     * @return {?}
     */function () {
        return Array.prototype.slice.call(arguments);
    });
    /** @type {?} */
    var NO_NEW_LINE$1 = 'ɵ';
    var StaticInjector = /** @class */ (function () {
        /**
         * @param {?} providers
         * @param {?=} parent
         * @param {?=} source
         */
        function StaticInjector(providers, parent, source) {
            if (parent === void 0) { parent = Injector.NULL; }
            if (source === void 0) { source = null; }
            this.parent = parent;
            this.source = source;
            /** @type {?} */
            var records = this._records = new Map();
            records.set(Injector, ( /** @type {?} */({ token: Injector, fn: IDENT, deps: EMPTY$1, value: this, useNew: false })));
            records.set(INJECTOR, ( /** @type {?} */({ token: INJECTOR, fn: IDENT, deps: EMPTY$1, value: this, useNew: false })));
            recursivelyProcessProviders(records, providers);
        }
        /**
         * @param {?} token
         * @param {?=} notFoundValue
         * @param {?=} flags
         * @return {?}
         */
        StaticInjector.prototype.get = function (token, notFoundValue, flags) {
            if (flags === void 0) { flags = InjectFlags.Default; }
            /** @type {?} */
            var record = this._records.get(token);
            try {
                return tryResolveToken(token, record, this._records, this.parent, notFoundValue, flags);
            }
            catch (e) {
                return catchInjectorError(e, token, 'StaticInjectorError', this.source);
            }
        };
        /**
         * @return {?}
         */
        StaticInjector.prototype.toString = function () {
            /** @type {?} */
            var tokens = ( /** @type {?} */([]));
            /** @type {?} */
            var records = this._records;
            records.forEach(( /**
             * @param {?} v
             * @param {?} token
             * @return {?}
             */function (v, token) { return tokens.push(stringify(token)); }));
            return "StaticInjector[" + tokens.join(', ') + "]";
        };
        return StaticInjector;
    }());
    /**
     * @param {?} provider
     * @return {?}
     */
    function resolveProvider(provider) {
        /** @type {?} */
        var deps = computeDeps(provider);
        /** @type {?} */
        var fn = IDENT;
        /** @type {?} */
        var value = EMPTY$1;
        /** @type {?} */
        var useNew = false;
        /** @type {?} */
        var provide = resolveForwardRef(provider.provide);
        if (USE_VALUE in provider) {
            // We need to use USE_VALUE in provider since provider.useValue could be defined as undefined.
            value = (( /** @type {?} */(provider))).useValue;
        }
        else if ((( /** @type {?} */(provider))).useFactory) {
            fn = (( /** @type {?} */(provider))).useFactory;
        }
        else if ((( /** @type {?} */(provider))).useExisting)
            ;
        else if ((( /** @type {?} */(provider))).useClass) {
            useNew = true;
            fn = resolveForwardRef((( /** @type {?} */(provider))).useClass);
        }
        else if (typeof provide == 'function') {
            useNew = true;
            fn = provide;
        }
        else {
            throw staticError('StaticProvider does not have [useValue|useFactory|useExisting|useClass] or [provide] is not newable', provider);
        }
        return { deps: deps, fn: fn, useNew: useNew, value: value };
    }
    /**
     * @param {?} token
     * @return {?}
     */
    function multiProviderMixError(token) {
        return staticError('Cannot mix multi providers and regular providers', token);
    }
    /**
     * @param {?} records
     * @param {?} provider
     * @return {?}
     */
    function recursivelyProcessProviders(records, provider) {
        if (provider) {
            provider = resolveForwardRef(provider);
            if (provider instanceof Array) {
                // if we have an array recurse into the array
                for (var i_41 = 0; i_41 < provider.length; i_41++) {
                    recursivelyProcessProviders(records, provider[i_41]);
                }
            }
            else if (typeof provider === 'function') {
                // Functions were supported in ReflectiveInjector, but are not here. For safety give useful
                // error messages
                throw staticError('Function/Class not supported', provider);
            }
            else if (provider && typeof provider === 'object' && provider.provide) {
                // At this point we have what looks like a provider: {provide: ?, ....}
                /** @type {?} */
                var token = resolveForwardRef(provider.provide);
                /** @type {?} */
                var resolvedProvider = resolveProvider(provider);
                if (provider.multi === true) {
                    // This is a multi provider.
                    /** @type {?} */
                    var multiProvider = records.get(token);
                    if (multiProvider) {
                        if (multiProvider.fn !== MULTI_PROVIDER_FN) {
                            throw multiProviderMixError(token);
                        }
                    }
                    else {
                        // Create a placeholder factory which will look up the constituents of the multi provider.
                        records.set(token, multiProvider = ( /** @type {?} */({
                            token: provider.provide,
                            deps: [],
                            useNew: false,
                            fn: MULTI_PROVIDER_FN,
                            value: EMPTY$1
                        })));
                    }
                    // Treat the provider as the token.
                    token = provider;
                    multiProvider.deps.push({ token: token, options: 6 /* Default */ });
                }
                /** @type {?} */
                var record = records.get(token);
                if (record && record.fn == MULTI_PROVIDER_FN) {
                    throw multiProviderMixError(token);
                }
                records.set(token, resolvedProvider);
            }
            else {
                throw staticError('Unexpected provider', provider);
            }
        }
    }
    /**
     * @param {?} token
     * @param {?} record
     * @param {?} records
     * @param {?} parent
     * @param {?} notFoundValue
     * @param {?} flags
     * @return {?}
     */
    function tryResolveToken(token, record, records, parent, notFoundValue, flags) {
        try {
            return resolveToken(token, record, records, parent, notFoundValue, flags);
        }
        catch (e) {
            // ensure that 'e' is of type Error.
            if (!(e instanceof Error)) {
                e = new Error(e);
            }
            /** @type {?} */
            var path = e[NG_TEMP_TOKEN_PATH] = e[NG_TEMP_TOKEN_PATH] || [];
            path.unshift(token);
            if (record && record.value == CIRCULAR$1) {
                // Reset the Circular flag.
                record.value = EMPTY$1;
            }
            throw e;
        }
    }
    /**
     * @param {?} token
     * @param {?} record
     * @param {?} records
     * @param {?} parent
     * @param {?} notFoundValue
     * @param {?} flags
     * @return {?}
     */
    function resolveToken(token, record, records, parent, notFoundValue, flags) {
        /** @type {?} */
        var value;
        if (record && !(flags & InjectFlags.SkipSelf)) {
            // If we don't have a record, this implies that we don't own the provider hence don't know how
            // to resolve it.
            value = record.value;
            if (value == CIRCULAR$1) {
                throw Error(NO_NEW_LINE$1 + 'Circular dependency');
            }
            else if (value === EMPTY$1) {
                record.value = CIRCULAR$1;
                /** @type {?} */
                var obj = undefined;
                /** @type {?} */
                var useNew = record.useNew;
                /** @type {?} */
                var fn = record.fn;
                /** @type {?} */
                var depRecords = record.deps;
                /** @type {?} */
                var deps = EMPTY$1;
                if (depRecords.length) {
                    deps = [];
                    for (var i_42 = 0; i_42 < depRecords.length; i_42++) {
                        /** @type {?} */
                        var depRecord = depRecords[i_42];
                        /** @type {?} */
                        var options = depRecord.options;
                        /** @type {?} */
                        var childRecord = options & 2 /* CheckSelf */ ? records.get(depRecord.token) : undefined;
                        deps.push(tryResolveToken(
                        // Current Token to resolve
                        depRecord.token, 
                        // A record which describes how to resolve the token.
                        // If undefined, this means we don't have such a record
                        childRecord, 
                        // Other records we know about.
                        records, 
                        // If we don't know how to resolve dependency and we should not check parent for it,
                        // than pass in Null injector.
                        !childRecord && !(options & 4 /* CheckParent */) ? Injector.NULL : parent, options & 1 /* Optional */ ? null : Injector.THROW_IF_NOT_FOUND, InjectFlags.Default));
                    }
                }
                record.value = value = useNew ? new ((( /** @type {?} */(fn))).bind.apply((( /** @type {?} */(fn))), __spread([void 0], deps)))() : fn.apply(obj, deps);
            }
        }
        else if (!(flags & InjectFlags.Self)) {
            value = parent.get(token, notFoundValue, InjectFlags.Default);
        }
        return value;
    }
    /**
     * @param {?} provider
     * @return {?}
     */
    function computeDeps(provider) {
        /** @type {?} */
        var deps = EMPTY$1;
        /** @type {?} */
        var providerDeps = (( /** @type {?} */(provider))).deps;
        if (providerDeps && providerDeps.length) {
            deps = [];
            for (var i_43 = 0; i_43 < providerDeps.length; i_43++) {
                /** @type {?} */
                var options = 6 /* Default */;
                /** @type {?} */
                var token = resolveForwardRef(providerDeps[i_43]);
                if (token instanceof Array) {
                    for (var j_6 = 0, annotations = token; j_6 < annotations.length; j_6++) {
                        /** @type {?} */
                        var annotation = annotations[j_6];
                        if (annotation instanceof Optional || annotation == Optional) {
                            options = options | 1 /* Optional */;
                        }
                        else if (annotation instanceof SkipSelf || annotation == SkipSelf) {
                            options = options & ~2 /* CheckSelf */;
                        }
                        else if (annotation instanceof Self || annotation == Self) {
                            options = options & ~4 /* CheckParent */;
                        }
                        else if (annotation instanceof Inject) {
                            token = (( /** @type {?} */(annotation))).token;
                        }
                        else {
                            token = resolveForwardRef(annotation);
                        }
                    }
                }
                deps.push({ token: token, options: options });
            }
        }
        else if ((( /** @type {?} */(provider))).useExisting) {
            /** @type {?} */
            var token = resolveForwardRef((( /** @type {?} */(provider))).useExisting);
            deps = [{ token: token, options: 6 /* Default */ }];
        }
        else if (!providerDeps && !(USE_VALUE in provider)) {
            // useValue & useExisting are the only ones which are exempt from deps all others need it.
            throw staticError('\'deps\' required', provider);
        }
        return deps;
    }
    /**
     * @param {?} text
     * @param {?} obj
     * @return {?}
     */
    function staticError(text, obj) {
        return new Error(formatError(text, obj, 'StaticInjectorError'));
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} keys
     * @return {?}
     */
    function findFirstClosedCycle(keys) {
        /** @type {?} */
        var res = [];
        for (var i_44 = 0; i_44 < keys.length; ++i_44) {
            if (res.indexOf(keys[i_44]) > -1) {
                res.push(keys[i_44]);
                return res;
            }
            res.push(keys[i_44]);
        }
        return res;
    }
    /**
     * @param {?} keys
     * @return {?}
     */
    function constructResolvingPath(keys) {
        if (keys.length > 1) {
            /** @type {?} */
            var reversed = findFirstClosedCycle(keys.slice().reverse());
            /** @type {?} */
            var tokenStrs = reversed.map(( /**
             * @param {?} k
             * @return {?}
             */function (/**
             * @param {?} k
             * @return {?}
             */ k) { return stringify(k.token); }));
            return ' (' + tokenStrs.join(' -> ') + ')';
        }
        return '';
    }
    /**
     * @param {?} injector
     * @param {?} key
     * @param {?} constructResolvingMessage
     * @param {?=} originalError
     * @return {?}
     */
    function injectionError(injector, key, constructResolvingMessage, originalError) {
        /** @type {?} */
        var keys = [key];
        /** @type {?} */
        var errMsg = constructResolvingMessage(keys);
        /** @type {?} */
        var error = ( /** @type {?} */((originalError ? wrappedError(errMsg, originalError) : Error(errMsg))));
        error.addKey = addKey;
        error.keys = keys;
        error.injectors = [injector];
        error.constructResolvingMessage = constructResolvingMessage;
        (( /** @type {?} */(error)))[ERROR_ORIGINAL_ERROR] = originalError;
        return error;
    }
    /**
     * @this {?}
     * @param {?} injector
     * @param {?} key
     * @return {?}
     */
    function addKey(injector, key) {
        this.injectors.push(injector);
        this.keys.push(key);
        // Note: This updated message won't be reflected in the `.stack` property
        this.message = this.constructResolvingMessage(this.keys);
    }
    /**
     * Thrown when trying to retrieve a dependency by key from {\@link Injector}, but the
     * {\@link Injector} does not have a {\@link Provider} for the given key.
     *
     * \@usageNotes
     * ### Example
     *
     * ```typescript
     * class A {
     *   constructor(b:B) {}
     * }
     *
     * expect(() => Injector.resolveAndCreate([A])).toThrowError();
     * ```
     * @param {?} injector
     * @param {?} key
     * @return {?}
     */
    function noProviderError(injector, key) {
        return injectionError(injector, key, ( /**
         * @param {?} keys
         * @return {?}
         */function (keys) {
            /** @type {?} */
            var first = stringify(keys[0].token);
            return "No provider for " + first + "!" + constructResolvingPath(keys);
        }));
    }
    /**
     * Thrown when dependencies form a cycle.
     *
     * \@usageNotes
     * ### Example
     *
     * ```typescript
     * var injector = Injector.resolveAndCreate([
     *   {provide: "one", useFactory: (two) => "two", deps: [[new Inject("two")]]},
     *   {provide: "two", useFactory: (one) => "one", deps: [[new Inject("one")]]}
     * ]);
     *
     * expect(() => injector.get("one")).toThrowError();
     * ```
     *
     * Retrieving `A` or `B` throws a `CyclicDependencyError` as the graph above cannot be constructed.
     * @param {?} injector
     * @param {?} key
     * @return {?}
     */
    function cyclicDependencyError(injector, key) {
        return injectionError(injector, key, ( /**
         * @param {?} keys
         * @return {?}
         */function (keys) {
            return "Cannot instantiate cyclic dependency!" + constructResolvingPath(keys);
        }));
    }
    /**
     * Thrown when a constructing type returns with an Error.
     *
     * The `InstantiationError` class contains the original error plus the dependency graph which caused
     * this object to be instantiated.
     *
     * \@usageNotes
     * ### Example
     *
     * ```typescript
     * class A {
     *   constructor() {
     *     throw new Error('message');
     *   }
     * }
     *
     * var injector = Injector.resolveAndCreate([A]);
     * try {
     *   injector.get(A);
     * } catch (e) {
     *   expect(e instanceof InstantiationError).toBe(true);
     *   expect(e.originalException.message).toEqual("message");
     *   expect(e.originalStack).toBeDefined();
     * }
     * ```
     * @param {?} injector
     * @param {?} originalException
     * @param {?} originalStack
     * @param {?} key
     * @return {?}
     */
    function instantiationError(injector, originalException, originalStack, key) {
        return injectionError(injector, key, ( /**
         * @param {?} keys
         * @return {?}
         */function (keys) {
            /** @type {?} */
            var first = stringify(keys[0].token);
            return originalException.message + ": Error during instantiation of " + first + "!" + constructResolvingPath(keys) + ".";
        }), originalException);
    }
    /**
     * Thrown when an object other then {\@link Provider} (or `Type`) is passed to {\@link Injector}
     * creation.
     *
     * \@usageNotes
     * ### Example
     *
     * ```typescript
     * expect(() => Injector.resolveAndCreate(["not a type"])).toThrowError();
     * ```
     * @param {?} provider
     * @return {?}
     */
    function invalidProviderError(provider) {
        return Error("Invalid provider - only instances of Provider and Type are allowed, got: " + provider);
    }
    /**
     * Thrown when the class has no annotation information.
     *
     * Lack of annotation information prevents the {\@link Injector} from determining which dependencies
     * need to be injected into the constructor.
     *
     * \@usageNotes
     * ### Example
     *
     * ```typescript
     * class A {
     *   constructor(b) {}
     * }
     *
     * expect(() => Injector.resolveAndCreate([A])).toThrowError();
     * ```
     *
     * This error is also thrown when the class not marked with {\@link Injectable} has parameter types.
     *
     * ```typescript
     * class B {}
     *
     * class A {
     *   constructor(b:B) {} // no information about the parameter types of A is available at runtime.
     * }
     *
     * expect(() => Injector.resolveAndCreate([A,B])).toThrowError();
     * ```
     *
     * @param {?} typeOrFunc
     * @param {?} params
     * @return {?}
     */
    function noAnnotationError(typeOrFunc, params) {
        /** @type {?} */
        var signature = [];
        for (var i_45 = 0, ii = params.length; i_45 < ii; i_45++) {
            /** @type {?} */
            var parameter = params[i_45];
            if (!parameter || parameter.length == 0) {
                signature.push('?');
            }
            else {
                signature.push(parameter.map(stringify).join(' '));
            }
        }
        return Error('Cannot resolve all parameters for \'' + stringify(typeOrFunc) + '\'(' +
            signature.join(', ') + '). ' +
            'Make sure that all the parameters are decorated with Inject or have valid type annotations and that \'' +
            stringify(typeOrFunc) + '\' is decorated with Injectable.');
    }
    /**
     * Thrown when getting an object by index.
     *
     * \@usageNotes
     * ### Example
     *
     * ```typescript
     * class A {}
     *
     * var injector = Injector.resolveAndCreate([A]);
     *
     * expect(() => injector.getAt(100)).toThrowError();
     * ```
     *
     * @param {?} index
     * @return {?}
     */
    function outOfBoundsError(index) {
        return Error("Index " + index + " is out-of-bounds.");
    }
    // TODO: add a working example after alpha38 is released
    /**
     * Thrown when a multi provider and a regular provider are bound to the same token.
     *
     * \@usageNotes
     * ### Example
     *
     * ```typescript
     * expect(() => Injector.resolveAndCreate([
     *   { provide: "Strings", useValue: "string1", multi: true},
     *   { provide: "Strings", useValue: "string2", multi: false}
     * ])).toThrowError();
     * ```
     * @param {?} provider1
     * @param {?} provider2
     * @return {?}
     */
    function mixingMultiProvidersWithRegularProvidersError(provider1, provider2) {
        return Error("Cannot mix multi providers and regular providers, got: " + provider1 + " " + provider2);
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A unique object used for retrieving items from the {\@link ReflectiveInjector}.
     *
     * Keys have:
     * - a system-wide unique `id`.
     * - a `token`.
     *
     * `Key` is used internally by {\@link ReflectiveInjector} because its system-wide unique `id` allows
     * the
     * injector to store created objects in a more efficient way.
     *
     * `Key` should not be created directly. {\@link ReflectiveInjector} creates keys automatically when
     * resolving
     * providers.
     *
     * @deprecated No replacement
     * \@publicApi
     */
    var ReflectiveKey = /** @class */ (function () {
        /**
         * Private
         * @param {?} token
         * @param {?} id
         */
        function ReflectiveKey(token, id) {
            this.token = token;
            this.id = id;
            if (!token) {
                throw new Error('Token must be defined!');
            }
            this.displayName = stringify(this.token);
        }
        /**
         * Retrieves a `Key` for a token.
         * @param {?} token
         * @return {?}
         */
        ReflectiveKey.get = function (token) {
            return _globalKeyRegistry.get(resolveForwardRef(token));
        };
        Object.defineProperty(ReflectiveKey, "numberOfKeys", {
            /**
             * @return {?} the number of keys registered in the system.
             */
            get: function () { return _globalKeyRegistry.numberOfKeys; },
            enumerable: true,
            configurable: true
        });
        return ReflectiveKey;
    }());
    var KeyRegistry = /** @class */ (function () {
        function KeyRegistry() {
            this._allKeys = new Map();
        }
        /**
         * @param {?} token
         * @return {?}
         */
        KeyRegistry.prototype.get = function (token) {
            if (token instanceof ReflectiveKey)
                return token;
            if (this._allKeys.has(token)) {
                return ( /** @type {?} */(this._allKeys.get(token)));
            }
            /** @type {?} */
            var newKey = new ReflectiveKey(token, ReflectiveKey.numberOfKeys);
            this._allKeys.set(token, newKey);
            return newKey;
        };
        Object.defineProperty(KeyRegistry.prototype, "numberOfKeys", {
            /**
             * @return {?}
             */
            get: function () { return this._allKeys.size; },
            enumerable: true,
            configurable: true
        });
        return KeyRegistry;
    }());
    /** @type {?} */
    var _globalKeyRegistry = new KeyRegistry();
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * Provides access to reflection data about symbols. Used internally by Angular
     * to power dependency injection and compilation.
     */
    var Reflector = /** @class */ (function () {
        function Reflector(reflectionCapabilities) {
            this.reflectionCapabilities = reflectionCapabilities;
        }
        Reflector.prototype.updateCapabilities = function (caps) { this.reflectionCapabilities = caps; };
        Reflector.prototype.factory = function (type) { return this.reflectionCapabilities.factory(type); };
        Reflector.prototype.parameters = function (typeOrFunc) {
            return this.reflectionCapabilities.parameters(typeOrFunc);
        };
        Reflector.prototype.annotations = function (typeOrFunc) {
            return this.reflectionCapabilities.annotations(typeOrFunc);
        };
        Reflector.prototype.propMetadata = function (typeOrFunc) {
            return this.reflectionCapabilities.propMetadata(typeOrFunc);
        };
        Reflector.prototype.hasLifecycleHook = function (type, lcProperty) {
            return this.reflectionCapabilities.hasLifecycleHook(type, lcProperty);
        };
        Reflector.prototype.getter = function (name) { return this.reflectionCapabilities.getter(name); };
        Reflector.prototype.setter = function (name) { return this.reflectionCapabilities.setter(name); };
        Reflector.prototype.method = function (name) { return this.reflectionCapabilities.method(name); };
        Reflector.prototype.importUri = function (type) { return this.reflectionCapabilities.importUri(type); };
        Reflector.prototype.resourceUri = function (type) { return this.reflectionCapabilities.resourceUri(type); };
        Reflector.prototype.resolveIdentifier = function (name, moduleUrl, members, runtime) {
            return this.reflectionCapabilities.resolveIdentifier(name, moduleUrl, members, runtime);
        };
        Reflector.prototype.resolveEnum = function (identifier, name) {
            return this.reflectionCapabilities.resolveEnum(identifier, name);
        };
        return Reflector;
    }());
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * The {@link Reflector} used internally in Angular to access metadata
     * about symbols.
     */
    var reflector = new Reflector(new ReflectionCapabilities());
    /**
     * `Dependency` is used by the framework to extend DI.
     * This is internal to Angular and should not be used directly.
     */
    var ReflectiveDependency = /** @class */ (function () {
        /**
         * @param {?} key
         * @param {?} optional
         * @param {?} visibility
         */
        function ReflectiveDependency(key, optional, visibility) {
            this.key = key;
            this.optional = optional;
            this.visibility = visibility;
        }
        /**
         * @param {?} key
         * @return {?}
         */
        ReflectiveDependency.fromKey = function (key) {
            return new ReflectiveDependency(key, false, null);
        };
        return ReflectiveDependency;
    }());
    /** @type {?} */
    var _EMPTY_LIST = [];
    var ResolvedReflectiveProvider_ = /** @class */ (function () {
        /**
         * @param {?} key
         * @param {?} resolvedFactories
         * @param {?} multiProvider
         */
        function ResolvedReflectiveProvider_(key, resolvedFactories, multiProvider) {
            this.key = key;
            this.resolvedFactories = resolvedFactories;
            this.multiProvider = multiProvider;
            this.resolvedFactory = this.resolvedFactories[0];
        }
        return ResolvedReflectiveProvider_;
    }());
    /**
     * An internal resolved representation of a factory function created by resolving `Provider`.
     * \@publicApi
     */
    var ResolvedReflectiveFactory = /** @class */ (function () {
        /**
         * @param {?} factory
         * @param {?} dependencies
         */
        function ResolvedReflectiveFactory(factory, dependencies) {
            this.factory = factory;
            this.dependencies = dependencies;
        }
        return ResolvedReflectiveFactory;
    }());
    /**
     * Resolve a single provider.
     * @param {?} provider
     * @return {?}
     */
    function resolveReflectiveFactory(provider) {
        /** @type {?} */
        var factoryFn;
        /** @type {?} */
        var resolvedDeps;
        if (provider.useClass) {
            /** @type {?} */
            var useClass = resolveForwardRef(provider.useClass);
            factoryFn = reflector.factory(useClass);
            resolvedDeps = _dependenciesFor(useClass);
        }
        else if (provider.useExisting) {
            factoryFn = ( /**
             * @param {?} aliasInstance
             * @return {?}
             */function (aliasInstance) { return aliasInstance; });
            resolvedDeps = [ReflectiveDependency.fromKey(ReflectiveKey.get(provider.useExisting))];
        }
        else if (provider.useFactory) {
            factoryFn = provider.useFactory;
            resolvedDeps = constructDependencies(provider.useFactory, provider.deps);
        }
        else {
            factoryFn = ( /**
             * @return {?}
             */function () { return provider.useValue; });
            resolvedDeps = _EMPTY_LIST;
        }
        return new ResolvedReflectiveFactory(factoryFn, resolvedDeps);
    }
    /**
     * Converts the `Provider` into `ResolvedProvider`.
     *
     * `Injector` internally only uses `ResolvedProvider`, `Provider` contains convenience provider
     * syntax.
     * @param {?} provider
     * @return {?}
     */
    function resolveReflectiveProvider(provider) {
        return new ResolvedReflectiveProvider_(ReflectiveKey.get(provider.provide), [resolveReflectiveFactory(provider)], provider.multi || false);
    }
    /**
     * Resolve a list of Providers.
     * @param {?} providers
     * @return {?}
     */
    function resolveReflectiveProviders(providers) {
        /** @type {?} */
        var normalized = _normalizeProviders(providers, []);
        /** @type {?} */
        var resolved = normalized.map(resolveReflectiveProvider);
        /** @type {?} */
        var resolvedProviderMap = mergeResolvedReflectiveProviders(resolved, new Map());
        return Array.from(resolvedProviderMap.values());
    }
    /**
     * Merges a list of ResolvedProviders into a list where each key is contained exactly once and
     * multi providers have been merged.
     * @param {?} providers
     * @param {?} normalizedProvidersMap
     * @return {?}
     */
    function mergeResolvedReflectiveProviders(providers, normalizedProvidersMap) {
        for (var i_46 = 0; i_46 < providers.length; i_46++) {
            /** @type {?} */
            var provider = providers[i_46];
            /** @type {?} */
            var existing = normalizedProvidersMap.get(provider.key.id);
            if (existing) {
                if (provider.multiProvider !== existing.multiProvider) {
                    throw mixingMultiProvidersWithRegularProvidersError(existing, provider);
                }
                if (provider.multiProvider) {
                    for (var j_7 = 0; j_7 < provider.resolvedFactories.length; j_7++) {
                        existing.resolvedFactories.push(provider.resolvedFactories[j_7]);
                    }
                }
                else {
                    normalizedProvidersMap.set(provider.key.id, provider);
                }
            }
            else {
                /** @type {?} */
                var resolvedProvider = void 0;
                if (provider.multiProvider) {
                    resolvedProvider = new ResolvedReflectiveProvider_(provider.key, provider.resolvedFactories.slice(), provider.multiProvider);
                }
                else {
                    resolvedProvider = provider;
                }
                normalizedProvidersMap.set(provider.key.id, resolvedProvider);
            }
        }
        return normalizedProvidersMap;
    }
    /**
     * @param {?} providers
     * @param {?} res
     * @return {?}
     */
    function _normalizeProviders(providers, res) {
        providers.forEach(( /**
         * @param {?} b
         * @return {?}
         */function (/**
         * @param {?} b
         * @return {?}
         */ b) {
            if (b instanceof Type) {
                res.push(( /** @type {?} */({ provide: b, useClass: b })));
            }
            else if (b && typeof b == 'object' && (( /** @type {?} */(b))).provide !== undefined) {
                res.push(( /** @type {?} */(b)));
            }
            else if (b instanceof Array) {
                _normalizeProviders(b, res);
            }
            else {
                throw invalidProviderError(b);
            }
        }));
        return res;
    }
    /**
     * @param {?} typeOrFunc
     * @param {?=} dependencies
     * @return {?}
     */
    function constructDependencies(typeOrFunc, dependencies) {
        if (!dependencies) {
            return _dependenciesFor(typeOrFunc);
        }
        else {
            /** @type {?} */
            var params_1 = dependencies.map(( /**
             * @param {?} t
             * @return {?}
             */function (/**
             * @param {?} t
             * @return {?}
             */ t) { return [t]; }));
            return dependencies.map(( /**
             * @param {?} t
             * @return {?}
             */function (/**
             * @param {?} t
             * @return {?}
             */ t) { return _extractToken(typeOrFunc, t, params_1); }));
        }
    }
    /**
     * @param {?} typeOrFunc
     * @return {?}
     */
    function _dependenciesFor(typeOrFunc) {
        /** @type {?} */
        var params = reflector.parameters(typeOrFunc);
        if (!params)
            return [];
        if (params.some(( /**
         * @param {?} p
         * @return {?}
         */function (/**
         * @param {?} p
         * @return {?}
         */ p) { return p == null; }))) {
            throw noAnnotationError(typeOrFunc, params);
        }
        return params.map(( /**
         * @param {?} p
         * @return {?}
         */function (/**
         * @param {?} p
         * @return {?}
         */ p) { return _extractToken(typeOrFunc, p, params); }));
    }
    /**
     * @param {?} typeOrFunc
     * @param {?} metadata
     * @param {?} params
     * @return {?}
     */
    function _extractToken(typeOrFunc, metadata, params) {
        /** @type {?} */
        var token = null;
        /** @type {?} */
        var optional = false;
        if (!Array.isArray(metadata)) {
            if (metadata instanceof Inject) {
                return _createDependency(metadata.token, optional, null);
            }
            else {
                return _createDependency(metadata, optional, null);
            }
        }
        /** @type {?} */
        var visibility = null;
        for (var i_47 = 0; i_47 < metadata.length; ++i_47) {
            /** @type {?} */
            var paramMetadata = metadata[i_47];
            if (paramMetadata instanceof Type) {
                token = paramMetadata;
            }
            else if (paramMetadata instanceof Inject) {
                token = paramMetadata.token;
            }
            else if (paramMetadata instanceof Optional) {
                optional = true;
            }
            else if (paramMetadata instanceof Self || paramMetadata instanceof SkipSelf) {
                visibility = paramMetadata;
            }
            else if (paramMetadata instanceof InjectionToken) {
                token = paramMetadata;
            }
        }
        token = resolveForwardRef(token);
        if (token != null) {
            return _createDependency(token, optional, visibility);
        }
        else {
            throw noAnnotationError(typeOrFunc, params);
        }
    }
    /**
     * @param {?} token
     * @param {?} optional
     * @param {?} visibility
     * @return {?}
     */
    function _createDependency(token, optional, visibility) {
        return new ReflectiveDependency(ReflectiveKey.get(token), optional, visibility);
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // Threshold for the dynamic version
    /** @type {?} */
    var UNDEFINED = new Object();
    /**
     * A ReflectiveDependency injection container used for instantiating objects and resolving
     * dependencies.
     *
     * An `Injector` is a replacement for a `new` operator, which can automatically resolve the
     * constructor dependencies.
     *
     * In typical use, application code asks for the dependencies in the constructor and they are
     * resolved by the `Injector`.
     *
     * \@usageNotes
     * ### Example
     *
     * The following example creates an `Injector` configured to create `Engine` and `Car`.
     *
     * ```typescript
     * \@Injectable()
     * class Engine {
     * }
     *
     * \@Injectable()
     * class Car {
     *   constructor(public engine:Engine) {}
     * }
     *
     * var injector = ReflectiveInjector.resolveAndCreate([Car, Engine]);
     * var car = injector.get(Car);
     * expect(car instanceof Car).toBe(true);
     * expect(car.engine instanceof Engine).toBe(true);
     * ```
     *
     * Notice, we don't use the `new` operator because we explicitly want to have the `Injector`
     * resolve all of the object's dependencies automatically.
     *
     * @deprecated from v5 - slow and brings in a lot of code, Use `Injector.create` instead.
     * \@publicApi
     * @abstract
     */
    var ReflectiveInjector = /** @class */ (function () {
        function ReflectiveInjector() {
        }
        /**
         * Turns an array of provider definitions into an array of resolved providers.
         *
         * A resolution is a process of flattening multiple nested arrays and converting individual
         * providers into an array of `ResolvedReflectiveProvider`s.
         *
         * \@usageNotes
         * ### Example
         *
         * ```typescript
         * \@Injectable()
         * class Engine {
         * }
         *  /
         * class Car {
         *   constructor(public engine:Engine) {}
         * }
         *
         * var providers = ReflectiveInjector.resolve([Car, [[Engine]]]);
         *
         * expect(providers.length).toEqual(2);
         *
         * expect(providers[0] instanceof ResolvedReflectiveProvider).toBe(true);
         * expect(providers[0].key.displayName).toBe("Car");
         * expect(providers[0].dependencies.length).toEqual(1);
         * expect(providers[0].factory).toBeDefined();
         *
         * expect(providers[1].key.displayName).toBe("Engine");
         * });
         * ```
         *
         * @param {?} providers
         * @return {?}
         */
        ReflectiveInjector.resolve = function (providers) {
            return resolveReflectiveProviders(providers);
        };
        /**
         * Resolves an array of providers and creates an injector from those providers.
         *
         * The passed-in providers can be an array of `Type`, `Provider`,
         * or a recursive array of more providers.
         *
         * \@usageNotes
         * ### Example
         *
         * ```typescript
         * \@Injectable()
         * class Engine {
         * }
         *  /
         * class Car {
         *   constructor(public engine:Engine) {}
         * }
         *
         * var injector = ReflectiveInjector.resolveAndCreate([Car, Engine]);
         * expect(injector.get(Car) instanceof Car).toBe(true);
         * ```
         * @param {?} providers
         * @param {?=} parent
         * @return {?}
         */
        ReflectiveInjector.resolveAndCreate = function (providers, parent) {
            /** @type {?} */
            var ResolvedReflectiveProviders = ReflectiveInjector.resolve(providers);
            return ReflectiveInjector.fromResolvedProviders(ResolvedReflectiveProviders, parent);
        };
        /**
         * Creates an injector from previously resolved providers.
         *
         * This API is the recommended way to construct injectors in performance-sensitive parts.
         *
         * \@usageNotes
         * ### Example
         *
         * ```typescript
         * \@Injectable()
         * class Engine {
         * }
         *  /
         * class Car {
         *   constructor(public engine:Engine) {}
         * }
         *
         * var providers = ReflectiveInjector.resolve([Car, Engine]);
         * var injector = ReflectiveInjector.fromResolvedProviders(providers);
         * expect(injector.get(Car) instanceof Car).toBe(true);
         * ```
         * @param {?} providers
         * @param {?=} parent
         * @return {?}
         */
        ReflectiveInjector.fromResolvedProviders = function (providers, parent) {
            return new ReflectiveInjector_(providers, parent);
        };
        return ReflectiveInjector;
    }());
    var ReflectiveInjector_ = /** @class */ (function () {
        /**
         * Private
         * @param {?} _providers
         * @param {?=} _parent
         */
        function ReflectiveInjector_(_providers, _parent) {
            /**
             * \@internal
             */
            this._constructionCounter = 0;
            this._providers = _providers;
            this.parent = _parent || null;
            /** @type {?} */
            var len = _providers.length;
            this.keyIds = new Array(len);
            this.objs = new Array(len);
            for (var i_48 = 0; i_48 < len; i_48++) {
                this.keyIds[i_48] = _providers[i_48].key.id;
                this.objs[i_48] = UNDEFINED;
            }
        }
        /**
         * @param {?} token
         * @param {?=} notFoundValue
         * @return {?}
         */
        ReflectiveInjector_.prototype.get = function (token, notFoundValue) {
            if (notFoundValue === void 0) { notFoundValue = THROW_IF_NOT_FOUND; }
            return this._getByKey(ReflectiveKey.get(token), null, notFoundValue);
        };
        /**
         * @param {?} providers
         * @return {?}
         */
        ReflectiveInjector_.prototype.resolveAndCreateChild = function (providers) {
            /** @type {?} */
            var ResolvedReflectiveProviders = ReflectiveInjector.resolve(providers);
            return this.createChildFromResolved(ResolvedReflectiveProviders);
        };
        /**
         * @param {?} providers
         * @return {?}
         */
        ReflectiveInjector_.prototype.createChildFromResolved = function (providers) {
            /** @type {?} */
            var inj = new ReflectiveInjector_(providers);
            (( /** @type {?} */(inj))).parent = this;
            return inj;
        };
        /**
         * @param {?} provider
         * @return {?}
         */
        ReflectiveInjector_.prototype.resolveAndInstantiate = function (provider) {
            return this.instantiateResolved(ReflectiveInjector.resolve([provider])[0]);
        };
        /**
         * @param {?} provider
         * @return {?}
         */
        ReflectiveInjector_.prototype.instantiateResolved = function (provider) {
            return this._instantiateProvider(provider);
        };
        /**
         * @param {?} index
         * @return {?}
         */
        ReflectiveInjector_.prototype.getProviderAtIndex = function (index) {
            if (index < 0 || index >= this._providers.length) {
                throw outOfBoundsError(index);
            }
            return this._providers[index];
        };
        /**
         * \@internal
         * @param {?} provider
         * @return {?}
         */
        ReflectiveInjector_.prototype._new = function (provider) {
            if (this._constructionCounter++ > this._getMaxNumberOfObjects()) {
                throw cyclicDependencyError(this, provider.key);
            }
            return this._instantiateProvider(provider);
        };
        /**
         * @private
         * @return {?}
         */
        ReflectiveInjector_.prototype._getMaxNumberOfObjects = function () { return this.objs.length; };
        /**
         * @private
         * @param {?} provider
         * @return {?}
         */
        ReflectiveInjector_.prototype._instantiateProvider = function (provider) {
            if (provider.multiProvider) {
                /** @type {?} */
                var res = new Array(provider.resolvedFactories.length);
                for (var i_49 = 0; i_49 < provider.resolvedFactories.length; ++i_49) {
                    res[i_49] = this._instantiate(provider, provider.resolvedFactories[i_49]);
                }
                return res;
            }
            else {
                return this._instantiate(provider, provider.resolvedFactories[0]);
            }
        };
        /**
         * @private
         * @param {?} provider
         * @param {?} ResolvedReflectiveFactory
         * @return {?}
         */
        ReflectiveInjector_.prototype._instantiate = function (provider, ResolvedReflectiveFactory) {
            var _this = this;
            /** @type {?} */
            var factory = ResolvedReflectiveFactory.factory;
            /** @type {?} */
            var deps;
            try {
                deps =
                    ResolvedReflectiveFactory.dependencies.map(( /**
                     * @param {?} dep
                     * @return {?}
                     */function (/**
                     * @param {?} dep
                     * @return {?}
                     */ dep) { return _this._getByReflectiveDependency(dep); }));
            }
            catch (e) {
                if (e.addKey) {
                    e.addKey(this, provider.key);
                }
                throw e;
            }
            /** @type {?} */
            var obj;
            try {
                obj = factory.apply(void 0, __spread(deps));
            }
            catch (e) {
                throw instantiationError(this, e, e.stack, provider.key);
            }
            return obj;
        };
        /**
         * @private
         * @param {?} dep
         * @return {?}
         */
        ReflectiveInjector_.prototype._getByReflectiveDependency = function (dep) {
            return this._getByKey(dep.key, dep.visibility, dep.optional ? null : THROW_IF_NOT_FOUND);
        };
        /**
         * @private
         * @param {?} key
         * @param {?} visibility
         * @param {?} notFoundValue
         * @return {?}
         */
        ReflectiveInjector_.prototype._getByKey = function (key, visibility, notFoundValue) {
            if (key === ReflectiveInjector_.INJECTOR_KEY) {
                return this;
            }
            if (visibility instanceof Self) {
                return this._getByKeySelf(key, notFoundValue);
            }
            else {
                return this._getByKeyDefault(key, notFoundValue, visibility);
            }
        };
        /**
         * @private
         * @param {?} keyId
         * @return {?}
         */
        ReflectiveInjector_.prototype._getObjByKeyId = function (keyId) {
            for (var i_50 = 0; i_50 < this.keyIds.length; i_50++) {
                if (this.keyIds[i_50] === keyId) {
                    if (this.objs[i_50] === UNDEFINED) {
                        this.objs[i_50] = this._new(this._providers[i_50]);
                    }
                    return this.objs[i_50];
                }
            }
            return UNDEFINED;
        };
        /**
         * \@internal
         * @param {?} key
         * @param {?} notFoundValue
         * @return {?}
         */
        ReflectiveInjector_.prototype._throwOrNull = function (key, notFoundValue) {
            if (notFoundValue !== THROW_IF_NOT_FOUND) {
                return notFoundValue;
            }
            else {
                throw noProviderError(this, key);
            }
        };
        /**
         * \@internal
         * @param {?} key
         * @param {?} notFoundValue
         * @return {?}
         */
        ReflectiveInjector_.prototype._getByKeySelf = function (key, notFoundValue) {
            /** @type {?} */
            var obj = this._getObjByKeyId(key.id);
            return (obj !== UNDEFINED) ? obj : this._throwOrNull(key, notFoundValue);
        };
        /**
         * \@internal
         * @param {?} key
         * @param {?} notFoundValue
         * @param {?} visibility
         * @return {?}
         */
        ReflectiveInjector_.prototype._getByKeyDefault = function (key, notFoundValue, visibility) {
            /** @type {?} */
            var inj;
            if (visibility instanceof SkipSelf) {
                inj = this.parent;
            }
            else {
                inj = this;
            }
            while (inj instanceof ReflectiveInjector_) {
                /** @type {?} */
                var inj_ = ( /** @type {?} */(inj));
                /** @type {?} */
                var obj = inj_._getObjByKeyId(key.id);
                if (obj !== UNDEFINED)
                    return obj;
                inj = inj_.parent;
            }
            if (inj !== null) {
                return inj.get(key.token, notFoundValue);
            }
            else {
                return this._throwOrNull(key, notFoundValue);
            }
        };
        Object.defineProperty(ReflectiveInjector_.prototype, "displayName", {
            /**
             * @return {?}
             */
            get: function () {
                /** @type {?} */
                var providers = _mapProviders(this, ( /**
                 * @param {?} b
                 * @return {?}
                 */function (b) { return ' "' + b.key.displayName + '" '; }))
                    .join(', ');
                return "ReflectiveInjector(providers: [" + providers + "])";
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        ReflectiveInjector_.prototype.toString = function () { return this.displayName; };
        return ReflectiveInjector_;
    }());
    ReflectiveInjector_.INJECTOR_KEY = ReflectiveKey.get(Injector);
    /**
     * @param {?} injector
     * @param {?} fn
     * @return {?}
     */
    function _mapProviders(injector, fn) {
        /** @type {?} */
        var res = new Array(injector._providers.length);
        for (var i_51 = 0; i_51 < injector._providers.length; ++i_51) {
            res[i_51] = fn(injector.getProviderAtIndex(i_51));
        }
        return res;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A DI token that you can use to create a virtual [provider](guide/glossary#provider)
     * that will populate the `entryComponents` field of components and NgModules
     * based on its `useValue` property value.
     * All components that are referenced in the `useValue` value (either directly
     * or in a nested array or map) are added to the `entryComponents` property.
     *
     * \@usageNotes
     *
     * The following example shows how the router can populate the `entryComponents`
     * field of an NgModule based on a router configuration that refers
     * to components.
     *
     * ```typescript
     * // helper function inside the router
     * function provideRoutes(routes) {
     *   return [
     *     {provide: ROUTES, useValue: routes},
     *     {provide: ANALYZE_FOR_ENTRY_COMPONENTS, useValue: routes, multi: true}
     *   ];
     * }
     *
     * // user code
     * let routes = [
     *   {path: '/root', component: RootComp},
     *   {path: '/teams', component: TeamsComp}
     * ];
     *
     * \@NgModule({
     *   providers: [provideRoutes(routes)]
     * })
     * class ModuleWithRoutes {}
     * ```
     *
     * \@publicApi
     * @type {?}
     */
    var ANALYZE_FOR_ENTRY_COMPONENTS = new InjectionToken('AnalyzeForEntryComponents');
    // WARNING: interface has both a type and a value, skipping emit
    /**
     * Base class for query metadata.
     *
     * @see `ContentChildren`.
     * @see `ContentChild`.
     * @see `ViewChildren`.
     * @see `ViewChild`.
     *
     * \@publicApi
     * @abstract
     */
    var Query = /** @class */ (function () {
        function Query() {
        }
        return Query;
    }());
    var ɵ0$b = /**
     * @param {?=} selector
     * @param {?=} data
     * @return {?}
     */ function (selector, data) {
        if (data === void 0) { data = {}; }
        return (Object.assign({ selector: selector, first: false, isViewQuery: false, descendants: false }, data));
    };
    /**
     * ContentChildren decorator and metadata.
     *
     *
     * \@Annotation
     * \@publicApi
     * @type {?}
     */
    var ContentChildren = makePropDecorator('ContentChildren', (ɵ0$b), Query);
    var ɵ1$3 = /**
     * @param {?=} selector
     * @param {?=} data
     * @return {?}
     */ function (selector, data) {
        if (data === void 0) { data = {}; }
        return (Object.assign({ selector: selector, first: true, isViewQuery: false, descendants: true }, data));
    };
    /**
     * ContentChild decorator and metadata.
     *
     *
     * \@Annotation
     *
     * \@publicApi
     * @type {?}
     */
    var ContentChild = makePropDecorator('ContentChild', (ɵ1$3), Query);
    var ɵ2 = /**
     * @param {?=} selector
     * @param {?=} data
     * @return {?}
     */ function (selector, data) {
        if (data === void 0) { data = {}; }
        return (Object.assign({ selector: selector, first: false, isViewQuery: true, descendants: true }, data));
    };
    /**
     * ViewChildren decorator and metadata.
     *
     * \@Annotation
     * \@publicApi
     * @type {?}
     */
    var ViewChildren = makePropDecorator('ViewChildren', (ɵ2), Query);
    var ɵ3 = /**
     * @param {?} selector
     * @param {?} data
     * @return {?}
     */ function (selector, data) { return (Object.assign({ selector: selector, first: true, isViewQuery: true, descendants: true }, data)); };
    /**
     * ViewChild decorator and metadata.
     *
     * \@Annotation
     * \@publicApi
     * @type {?}
     */
    var ViewChild = makePropDecorator('ViewChild', (ɵ3), Query);
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Allocates the necessary amount of slots for host vars.
     *
     * \@codeGenApi
     * @param {?} count Amount of vars to be allocated
     *
     * @return {?}
     */
    function ɵɵallocHostVars(count) {
        /** @type {?} */
        var lView = getLView();
        /** @type {?} */
        var tView = lView[TVIEW];
        if (!tView.firstTemplatePass)
            return;
        queueHostBindingForCheck(tView, ( /** @type {?} */(getCurrentDirectiveDef())), count);
        prefillHostVars(tView, lView, count);
    }
    /**
     * Stores host binding fn and number of host vars so it will be queued for binding refresh during
     * CD.
     * @param {?} tView
     * @param {?} def
     * @param {?} hostVars
     * @return {?}
     */
    function queueHostBindingForCheck(tView, def, hostVars) {
        ngDevMode &&
            assertEqual(tView.firstTemplatePass, true, 'Should only be called in first template pass.');
        /** @type {?} */
        var expando = ( /** @type {?} */(tView.expandoInstructions));
        /** @type {?} */
        var length = expando.length;
        // Check whether a given `hostBindings` function already exists in expandoInstructions,
        // which can happen in case directive definition was extended from base definition (as a part of
        // the `InheritDefinitionFeature` logic). If we found the same `hostBindings` function in the
        // list, we just increase the number of host vars associated with that function, but do not add it
        // into the list again.
        if (length >= 2 && expando[length - 2] === def.hostBindings) {
            expando[length - 1] = (( /** @type {?} */(expando[length - 1]))) + hostVars;
        }
        else {
            expando.push(( /** @type {?} */(def.hostBindings)), hostVars);
        }
    }
    /**
     * On the first template pass, we need to reserve space for host binding values
     * after directives are matched (so all directives are saved, then bindings).
     * Because we are updating the blueprint, we only need to do this once.
     * @param {?} tView
     * @param {?} lView
     * @param {?} totalHostVars
     * @return {?}
     */
    function prefillHostVars(tView, lView, totalHostVars) {
        ngDevMode &&
            assertEqual(tView.firstTemplatePass, true, 'Should only be called in first template pass.');
        for (var i_52 = 0; i_52 < totalHostVars; i_52++) {
            lView.push(NO_CHANGE);
            tView.blueprint.push(NO_CHANGE);
            tView.data.push(null);
        }
    }
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    var _symbolIterator = null;
    function getSymbolIterator$1() {
        if (!_symbolIterator) {
            var Symbol_1 = _global['Symbol'];
            if (Symbol_1 && Symbol_1.iterator) {
                _symbolIterator = Symbol_1.iterator;
            }
            else {
                // es6-shim specific logic
                var keys = Object.getOwnPropertyNames(Map.prototype);
                for (var i_53 = 0; i_53 < keys.length; ++i_53) {
                    var key = keys[i_53];
                    if (key !== 'entries' && key !== 'size' &&
                        Map.prototype[key] === Map.prototype['entries']) {
                        _symbolIterator = key;
                    }
                }
            }
        }
        return _symbolIterator;
    }
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    // JS has NaN !== NaN
    function looseIdentical(a, b) {
        return a === b || typeof a === 'number' && typeof b === 'number' && isNaN(a) && isNaN(b);
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} a
     * @param {?} b
     * @return {?}
     */
    function devModeEqual$1(a, b) {
        /** @type {?} */
        var isListLikeIterableA = isListLikeIterable$1(a);
        /** @type {?} */
        var isListLikeIterableB = isListLikeIterable$1(b);
        if (isListLikeIterableA && isListLikeIterableB) {
            return areIterablesEqual$1(a, b, devModeEqual$1);
        }
        else {
            /** @type {?} */
            var isAObject = a && (typeof a === 'object' || typeof a === 'function');
            /** @type {?} */
            var isBObject = b && (typeof b === 'object' || typeof b === 'function');
            if (!isListLikeIterableA && isAObject && !isListLikeIterableB && isBObject) {
                return true;
            }
            else {
                return looseIdentical(a, b);
            }
        }
    }
    /**
     * Indicates that the result of a {\@link Pipe} transformation has changed even though the
     * reference has not changed.
     *
     * Wrapped values are unwrapped automatically during the change detection, and the unwrapped value
     * is stored.
     *
     * Example:
     *
     * ```
     * if (this._latestValue === this._latestReturnedValue) {
     *    return this._latestReturnedValue;
     *  } else {
     *    this._latestReturnedValue = this._latestValue;
     *    return WrappedValue.wrap(this._latestValue); // this will force update
     *  }
     * ```
     *
     * \@publicApi
     */
    var WrappedValue = /** @class */ (function () {
        /**
         * @param {?} value
         */
        function WrappedValue(value) {
            this.wrapped = value;
        }
        /**
         * Creates a wrapped value.
         * @param {?} value
         * @return {?}
         */
        WrappedValue.wrap = function (value) { return new WrappedValue(value); };
        /**
         * Returns the underlying value of a wrapped value.
         * Returns the given `value` when it is not wrapped.
         *
         * @param {?} value
         * @return {?}
         */
        WrappedValue.unwrap = function (value) { return WrappedValue.isWrapped(value) ? value.wrapped : value; };
        /**
         * Returns true if `value` is a wrapped value.
         * @param {?} value
         * @return {?}
         */
        WrappedValue.isWrapped = function (value) { return value instanceof WrappedValue; };
        return WrappedValue;
    }());
    /**
     * @param {?} obj
     * @return {?}
     */
    function isListLikeIterable$1(obj) {
        if (!isJsObject$1(obj))
            return false;
        return Array.isArray(obj) ||
            (!(obj instanceof Map) && // JS Map are iterables but return entries as [k, v]
                getSymbolIterator$1() in obj); // JS Iterable have a Symbol.iterator prop
    }
    /**
     * @param {?} a
     * @param {?} b
     * @param {?} comparator
     * @return {?}
     */
    function areIterablesEqual$1(a, b, comparator) {
        /** @type {?} */
        var iterator1 = a[getSymbolIterator$1()]();
        /** @type {?} */
        var iterator2 = b[getSymbolIterator$1()]();
        while (true) {
            /** @type {?} */
            var item1 = iterator1.next();
            /** @type {?} */
            var item2 = iterator2.next();
            if (item1.done && item2.done)
                return true;
            if (item1.done || item2.done)
                return false;
            if (!comparator(item1.value, item2.value))
                return false;
        }
    }
    /**
     * @param {?} obj
     * @param {?} fn
     * @return {?}
     */
    function iterateListLike$1(obj, fn) {
        if (Array.isArray(obj)) {
            for (var i_54 = 0; i_54 < obj.length; i_54++) {
                fn(obj[i_54]);
            }
        }
        else {
            /** @type {?} */
            var iterator_1 = obj[getSymbolIterator$1()]();
            /** @type {?} */
            var item = void 0;
            while (!((item = iterator_1.next()).done)) {
                fn(item.value);
            }
        }
    }
    /**
     * @param {?} o
     * @return {?}
     */
    function isJsObject$1(o) {
        return o !== null && (typeof o === 'function' || typeof o === 'object');
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * --------
     *
     * This file contains the core logic for how styling instructions are processed in Angular.
     *
     * To learn more about the algorithm see `TStylingContext`.
     *
     * --------
     */
    /**
     * Temporary function to bridge styling functionality between this new
     * refactor (which is here inside of `styling_next/`) and the old
     * implementation (which lives inside of `styling/`).
     *
     * This function is executed during the creation block of an element.
     * Because the existing styling implementation issues a call to the
     * `styling()` instruction, this instruction will also get run. The
     * central idea here is that the directive index values are bound
     * into the context. The directive index is temporary and is only
     * required until the `select(n)` instruction is fully functional.
     *
     * \@codeGenApi
     * @return {?}
     */
    function ɵɵstyling() {
        /** @type {?} */
        var tView = getLView()[TVIEW];
        if (tView.firstTemplatePass) {
            updateLastDirectiveIndex$1(getPreviousOrParentTNode(), getActiveDirectiveStylingIndex());
        }
    }
    /**
     * Update style bindings using an object literal on an element.
     *
     * This instruction is meant to apply styling via the `[style]="exp"` template bindings.
     * When styles are applied to the element they will then be updated with respect to
     * any styles/classes set via `styleProp`. If any styles are set to falsy
     * then they will be removed from the element.
     *
     * Note that the styling instruction will not be applied until `stylingApply` is called.
     *
     * \@codeGenApi
     * @param {?} styles A key/value style map of the styles that will be applied to the given element.
     *        Any missing styles (that have already been applied to the element beforehand) will be
     *        removed (unset) from the element's styling.
     *
     * Note that this will apply the provided styleMap value to the host element if this function
     * is called within a host binding.
     *
     * @return {?}
     */
    function ɵɵstyleMap(styles) {
        /** @type {?} */
        var index = getSelectedIndex();
        /** @type {?} */
        var lView = getLView();
        /** @type {?} */
        var tNode = getTNode(index, lView);
        /** @type {?} */
        var context = getStylesContext(tNode);
        /** @type {?} */
        var directiveIndex = getActiveDirectiveStylingIndex();
        // if a value is interpolated then it may render a `NO_CHANGE` value.
        // in this case we do not need to do anything, but the binding index
        // still needs to be incremented because all styling binding values
        // are stored inside of the lView.
        /** @type {?} */
        var bindingIndex = lView[BINDING_INDEX]++;
        // inputs are only evaluated from a template binding into a directive, therefore,
        // there should not be a situation where a directive host bindings function
        // evaluates the inputs (this should only happen in the template function)
        if (!directiveIndex && hasStyleInput(tNode) && styles !== NO_CHANGE) {
            updateDirectiveInputValue(context, lView, tNode, bindingIndex, styles, false);
            styles = NO_CHANGE;
        }
        /** @type {?} */
        var updated = _stylingMap(index, context, bindingIndex, styles, false, deferStylingUpdate());
        if (ngDevMode) {
            ngDevMode.styleMap++;
            if (updated) {
                ngDevMode.styleMapCacheMiss++;
            }
        }
    }
    /**
     * Update class bindings using an object literal or class-string on an element.
     *
     * This instruction is meant to apply styling via the `[class]="exp"` template bindings.
     * When classes are applied to the element they will then be updated with
     * respect to any styles/classes set via `classProp`. If any
     * classes are set to falsy then they will be removed from the element.
     *
     * Note that the styling instruction will not be applied until `stylingApply` is called.
     * Note that this will the provided classMap value to the host element if this function is called
     * within a host binding.
     *
     * \@codeGenApi
     * @param {?} classes A key/value map or string of CSS classes that will be added to the
     *        given element. Any missing classes (that have already been applied to the element
     *        beforehand) will be removed (unset) from the element's list of CSS classes.
     *
     * @return {?}
     */
    function ɵɵclassMap(classes) {
        classMapInternal(getSelectedIndex(), classes);
    }
    /**
     * @param {?} elementIndex
     * @param {?} classes
     * @return {?}
     */
    function classMapInternal(elementIndex, classes) {
        /** @type {?} */
        var lView = getLView();
        /** @type {?} */
        var tNode = getTNode(elementIndex, lView);
        /** @type {?} */
        var context = getClassesContext(tNode);
        /** @type {?} */
        var directiveIndex = getActiveDirectiveStylingIndex();
        // if a value is interpolated then it may render a `NO_CHANGE` value.
        // in this case we do not need to do anything, but the binding index
        // still needs to be incremented because all styling binding values
        // are stored inside of the lView.
        /** @type {?} */
        var bindingIndex = lView[BINDING_INDEX]++;
        // inputs are only evaluated from a template binding into a directive, therefore,
        // there should not be a situation where a directive host bindings function
        // evaluates the inputs (this should only happen in the template function)
        if (!directiveIndex && hasClassInput(tNode) && classes !== NO_CHANGE) {
            updateDirectiveInputValue(context, lView, tNode, bindingIndex, classes, true);
            classes = NO_CHANGE;
        }
        /** @type {?} */
        var updated = _stylingMap(elementIndex, context, bindingIndex, classes, true, deferStylingUpdate());
        if (ngDevMode) {
            ngDevMode.classMap++;
            if (updated) {
                ngDevMode.classMapCacheMiss++;
            }
        }
    }
    /**
     * Shared function used to update a map-based styling binding for an element.
     *
     * When this function is called it will activate support for `[style]` and
     * `[class]` bindings in Angular.
     * @param {?} elementIndex
     * @param {?} context
     * @param {?} bindingIndex
     * @param {?} value
     * @param {?} isClassBased
     * @param {?} defer
     * @return {?}
     */
    function _stylingMap(elementIndex, context, bindingIndex, value, isClassBased, defer) {
        activateStylingMapFeature();
        /** @type {?} */
        var lView = getLView();
        /** @type {?} */
        var valueHasChanged = false;
        if (value !== NO_CHANGE) {
            /** @type {?} */
            var tNode = getTNode(elementIndex, lView);
            /** @type {?} */
            var native = ( /** @type {?} */(getNativeByTNode(tNode, lView)));
            /** @type {?} */
            var oldValue = lView[bindingIndex];
            valueHasChanged = hasValueChanged(oldValue, value);
            /** @type {?} */
            var stylingMapArr = normalizeIntoStylingMap(oldValue, value, !isClassBased);
            if (isClassBased) {
                updateClassBinding(context, lView, native, null, bindingIndex, stylingMapArr, defer, valueHasChanged);
            }
            else {
                /** @type {?} */
                var sanitizer = getCurrentStyleSanitizer();
                updateStyleBinding(context, lView, native, null, bindingIndex, stylingMapArr, sanitizer, defer, valueHasChanged);
            }
        }
        return valueHasChanged;
    }
    /**
     * Writes a value to a directive's `style` or `class` input binding (if it has changed).
     *
     * If a directive has a `\@Input` binding that is set on `style` or `class` then that value
     * will take priority over the underlying style/class styling bindings. This value will
     * be updated for the binding each time during change detection.
     *
     * When this occurs this function will attempt to write the value to the input binding
     * depending on the following situations:
     *
     * - If `oldValue !== newValue`
     * - If `newValue` is `null` (but this is skipped if it is during the first update pass--
     *    which is when the context is not locked yet)
     * @param {?} context
     * @param {?} lView
     * @param {?} tNode
     * @param {?} bindingIndex
     * @param {?} newValue
     * @param {?} isClassBased
     * @return {?}
     */
    function updateDirectiveInputValue(context, lView, tNode, bindingIndex, newValue, isClassBased) {
        /** @type {?} */
        var oldValue = lView[bindingIndex];
        if (oldValue !== newValue) {
            // even if the value has changed we may not want to emit it to the
            // directive input(s) in the event that it is falsy during the
            // first update pass.
            if (newValue || isContextLocked(context)) {
                /** @type {?} */
                var inputs = ( /** @type {?} */(( /** @type {?} */(tNode.inputs))[isClassBased ? 'class' : 'style']));
                /** @type {?} */
                var initialValue = getInitialStylingValue(context);
                /** @type {?} */
                var value = normalizeStylingDirectiveInputValue(initialValue, newValue, isClassBased);
                setInputsForProperty(lView, inputs, value);
            }
            lView[bindingIndex] = newValue;
        }
    }
    /**
     * Returns the appropriate directive input value for `style` or `class`.
     *
     * Earlier versions of Angular expect a binding value to be passed into directive code
     * exactly as it is unless there is a static value present (in which case both values
     * will be stringified and concatenated).
     * @param {?} initialValue
     * @param {?} bindingValue
     * @param {?} isClassBased
     * @return {?}
     */
    function normalizeStylingDirectiveInputValue(initialValue, bindingValue, isClassBased) {
        /** @type {?} */
        var value = bindingValue;
        // we only concat values if there is an initial value, otherwise we return the value as is.
        // Note that this is to satisfy backwards-compatibility in Angular.
        if (initialValue.length > 0) {
            if (isClassBased) {
                value = concatString(initialValue, forceClassesAsString(bindingValue));
            }
            else {
                value = concatString(initialValue, forceStylesAsString(( /** @type {?} */(bindingValue))), ';');
            }
        }
        return value;
    }
    /**
     * Flushes all styling code to the element.
     *
     * This function is designed to be called from the template and hostBindings
     * functions and may be called multiple times depending whether multiple
     * sources of styling exist. If called multiple times, only the last call
     * to `stlyingApply()` will render styling to the element.
     *
     * \@codeGenApi
     * @return {?}
     */
    function ɵɵstylingApply() {
        /** @type {?} */
        var elementIndex = getSelectedIndex();
        /** @type {?} */
        var lView = getLView();
        /** @type {?} */
        var tNode = getTNode(elementIndex, lView);
        /** @type {?} */
        var renderer = getRenderer(tNode, lView);
        /** @type {?} */
        var native = ( /** @type {?} */(getNativeByTNode(tNode, lView)));
        /** @type {?} */
        var directiveIndex = getActiveDirectiveStylingIndex();
        /** @type {?} */
        var sanitizer = getCurrentStyleSanitizer();
        flushStyling(renderer, lView, getClassesContext(tNode), getStylesContext(tNode), native, directiveIndex, sanitizer);
        setCurrentStyleSanitizer(null);
    }
    /**
     * @param {?} tNode
     * @param {?} lView
     * @return {?}
     */
    function getRenderer(tNode, lView) {
        return tNode.type === 3 /* Element */ ? lView[RENDERER] : null;
    }
    /**
     * @return {?}
     */
    function getActiveDirectiveStylingIndex() {
        // whenever a directive's hostBindings function is called a uniqueId value
        // is assigned. Normally this is enough to help distinguish one directive
        // from another for the styling context, but there are situations where a
        // sub-class directive could inherit and assign styling in concert with a
        // parent directive. To help the styling code distinguish between a parent
        // sub-classed directive the inheritance depth is taken into account as well.
        return getActiveDirectiveId() + getActiveDirectiveSuperClassDepth();
    }
    /**
     * Temporary function that will update the max directive index value in
     * both the classes and styles contexts present on the provided `tNode`.
     *
     * This code is only used because the `select(n)` code functionality is not
     * yet 100% functional. The `select(n)` instruction cannot yet evaluate host
     * bindings function code in sync with the associated template function code.
     * For this reason the styling algorithm needs to track the last directive index
     * value so that it knows exactly when to render styling to the element since
     * `stylingApply()` is called multiple times per CD (`stylingApply` will be
     * removed once `select(n)` is fixed).
     * @param {?} tNode
     * @param {?} directiveIndex
     * @return {?}
     */
    function updateLastDirectiveIndex$1(tNode, directiveIndex) {
        updateLastDirectiveIndex(getClassesContext(tNode), directiveIndex);
        updateLastDirectiveIndex(getStylesContext(tNode), directiveIndex);
    }
    /**
     * @param {?} tNode
     * @return {?}
     */
    function getStylesContext(tNode) {
        return getContext(tNode, false);
    }
    /**
     * @param {?} tNode
     * @return {?}
     */
    function getClassesContext(tNode) {
        return getContext(tNode, true);
    }
    /**
     * Returns/instantiates a styling context from/to a `tNode` instance.
     * @param {?} tNode
     * @param {?} isClassBased
     * @return {?}
     */
    function getContext(tNode, isClassBased) {
        /** @type {?} */
        var context = isClassBased ? tNode.classes : tNode.styles;
        if (!isStylingContext(context)) {
            context = allocTStylingContext(context);
            if (ngDevMode) {
                attachStylingDebugObject(( /** @type {?} */(context)));
            }
            if (isClassBased) {
                tNode.classes = context;
            }
            else {
                tNode.styles = context;
            }
        }
        return ( /** @type {?} */(context));
    }
    /**
     * Whether or not a style/class binding update should be applied later.
     *
     * This function will decide whether a binding should be applied immediately
     * or later (just before the styles/classes are flushed to the element). The
     * reason why this feature exists is because of super/sub directive inheritance.
     * Angular will evaluate host bindings on the super directive first and the sub
     * directive, but the styling bindings on the sub directive are of higher priority
     * than the super directive. For this reason all styling bindings that take place
     * in this circumstance will need to be deferred until later so that they can be
     * applied together and in a different order (the algorithm handles that part).
     * @return {?}
     */
    function deferStylingUpdate() {
        return getActiveDirectiveSuperClassHeight() > 0;
    }
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * Determine if the argument is shaped like a Promise
     */
    function isPromise$1(obj) {
        // allow any Promise/A+ compliant thenable.
        // It's up to the caller to ensure that obj.then conforms to the spec
        return !!obj && typeof obj.then === 'function';
    }
    /**
     * Determine if the argument is an Observable
     */
    function isObservable(obj) {
        // TODO: use isObservable once we update pass rxjs 6.1
        // https://github.com/ReactiveX/rxjs/blob/master/CHANGELOG.md#610-2018-05-03
        return !!obj && typeof obj.subscribe === 'function';
    }
    /**
     * Creates the root component view and the root component node.
     *
     * @param {?} rNode Render host element.
     * @param {?} def ComponentDef
     * @param {?} rootView The parent view where the host node is stored
     * @param {?} rendererFactory
     * @param {?} renderer The current renderer
     * @param {?=} sanitizer The sanitizer, if provided
     *
     * @return {?} Component view created
     */
    function createRootComponentView(rNode, def, rootView, rendererFactory, renderer, sanitizer) {
        resetComponentState();
        /** @type {?} */
        var tView = rootView[TVIEW];
        ngDevMode && assertDataInRange(rootView, 0 + HEADER_OFFSET);
        rootView[0 + HEADER_OFFSET] = rNode;
        /** @type {?} */
        var tNode = getOrCreateTNode(tView, null, 0, 3 /* Element */, null, null);
        /** @type {?} */
        var componentView = createLView(rootView, getOrCreateTView(def), null, def.onPush ? 64 /* Dirty */ : 16 /* CheckAlways */, rootView[HEADER_OFFSET], tNode, rendererFactory, renderer, sanitizer);
        if (tView.firstTemplatePass) {
            diPublicInInjector(getOrCreateNodeInjectorForNode(tNode, rootView), tView, def.type);
            tNode.flags = 1 /* isComponent */;
            initNodeFlags(tNode, rootView.length, 1);
            queueComponentIndexForCheck(tNode);
        }
        // Store component view at node index, with node as the HOST
        return rootView[HEADER_OFFSET] = componentView;
    }
    /**
     * Creates a root component and sets it up with features and host bindings. Shared by
     * renderComponent() and ViewContainerRef.createComponent().
     * @template T
     * @param {?} componentView
     * @param {?} componentDef
     * @param {?} rootView
     * @param {?} rootContext
     * @param {?} hostFeatures
     * @return {?}
     */
    function createRootComponent(componentView, componentDef, rootView, rootContext, hostFeatures) {
        /** @type {?} */
        var tView = rootView[TVIEW];
        // Create directive instance with factory() and store at next index in viewData
        /** @type {?} */
        var component = instantiateRootComponent(tView, rootView, componentDef);
        rootContext.components.push(component);
        componentView[CONTEXT] = component;
        hostFeatures && hostFeatures.forEach(( /**
         * @param {?} feature
         * @return {?}
         */function (feature) { return feature(component, componentDef); }));
        // We want to generate an empty QueryList for root content queries for backwards
        // compatibility with ViewEngine.
        if (componentDef.contentQueries) {
            componentDef.contentQueries(1 /* Create */, component, rootView.length - 1);
        }
        /** @type {?} */
        var rootTNode = getPreviousOrParentTNode();
        if (tView.firstTemplatePass && componentDef.hostBindings) {
            /** @type {?} */
            var elementIndex = rootTNode.index - HEADER_OFFSET;
            setActiveHostElement(elementIndex);
            /** @type {?} */
            var expando = ( /** @type {?} */(tView.expandoInstructions));
            invokeHostBindingsInCreationMode(componentDef, expando, component, rootTNode, tView.firstTemplatePass);
            setActiveHostElement(null);
        }
        return component;
    }
    /**
     * @param {?=} scheduler
     * @param {?=} playerHandler
     * @return {?}
     */
    function createRootContext(scheduler, playerHandler) {
        return {
            components: [],
            scheduler: scheduler || defaultScheduler,
            clean: CLEAN_PROMISE,
            playerHandler: playerHandler || null,
            flags: 0 /* Empty */
        };
    }
    /**
     * Used to enable lifecycle hooks on the root component.
     *
     * Include this feature when calling `renderComponent` if the root component
     * you are rendering has lifecycle hooks defined. Otherwise, the hooks won't
     * be called properly.
     *
     * Example:
     *
     * ```
     * renderComponent(AppComponent, {features: [RootLifecycleHooks]});
     * ```
     * @param {?} component
     * @param {?} def
     * @return {?}
     */
    function LifecycleHooksFeature(component, def) {
        /** @type {?} */
        var rootTView = ( /** @type {?} */(readPatchedLView(component)))[TVIEW];
        /** @type {?} */
        var dirIndex = rootTView.data.length - 1;
        registerPreOrderHooks(dirIndex, def, rootTView, -1, -1, -1);
        // TODO(misko): replace `as TNode` with createTNode call. (needs refactoring to lose dep on
        // LNode).
        registerPostOrderHooks(rootTView, ( /** @type {?} */({ directiveStart: dirIndex, directiveEnd: dirIndex + 1 })));
    }
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * Represents a basic change from a previous to a new value for a single
     * property on a directive instance. Passed as a value in a
     * {@link SimpleChanges} object to the `ngOnChanges` hook.
     *
     * @see `OnChanges`
     *
     * @publicApi
     */
    var SimpleChange = /** @class */ (function () {
        function SimpleChange(previousValue, currentValue, firstChange) {
            this.previousValue = previousValue;
            this.currentValue = currentValue;
            this.firstChange = firstChange;
        }
        /**
         * Check whether the new value is the first value assigned.
         */
        SimpleChange.prototype.isFirstChange = function () { return this.firstChange; };
        return SimpleChange;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * Represents a component created by a `ComponentFactory`.
     * Provides access to the component instance and related objects,
     * and provides the means of destroying the instance.
     *
     * \@publicApi
     * @abstract
     * @template C
     */
    var ComponentRef = /** @class */ (function () {
        function ComponentRef() {
        }
        return ComponentRef;
    }());
    /**
     * Base class for a factory that can create a component dynamically.
     * Instantiate a factory for a given type of component with `resolveComponentFactory()`.
     * Use the resulting `ComponentFactory.create()` method to create a component of that type.
     *
     * @see [Dynamic Components](guide/dynamic-component-loader)
     *
     * \@publicApi
     * @abstract
     * @template C
     */
    var ComponentFactory = /** @class */ (function () {
        function ComponentFactory() {
        }
        return ComponentFactory;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} component
     * @return {?}
     */
    function noComponentFactoryError(component) {
        /** @type {?} */
        var error = Error("No component factory found for " + stringify(component) + ". Did you add it to @NgModule.entryComponents?");
        (( /** @type {?} */(error)))[ERROR_COMPONENT] = component;
        return error;
    }
    /** @type {?} */
    var ERROR_COMPONENT = 'ngComponent';
    var _NullComponentFactoryResolver = /** @class */ (function () {
        function _NullComponentFactoryResolver() {
        }
        /**
         * @template T
         * @param {?} component
         * @return {?}
         */
        _NullComponentFactoryResolver.prototype.resolveComponentFactory = function (component) {
            throw noComponentFactoryError(component);
        };
        return _NullComponentFactoryResolver;
    }());
    /**
     * A simple registry that maps `Components` to generated `ComponentFactory` classes
     * that can be used to create instances of components.
     * Use to obtain the factory for a given component type,
     * then use the factory's `create()` method to create a component of that type.
     *
     * @see [Dynamic Components](guide/dynamic-component-loader)
     * \@publicApi
     * @abstract
     */
    var ComponentFactoryResolver = /** @class */ (function () {
        function ComponentFactoryResolver() {
        }
        return ComponentFactoryResolver;
    }());
    ComponentFactoryResolver.NULL = new _NullComponentFactoryResolver();
    var CodegenComponentFactoryResolver = /** @class */ (function () {
        /**
         * @param {?} factories
         * @param {?} _parent
         * @param {?} _ngModule
         */
        function CodegenComponentFactoryResolver(factories, _parent, _ngModule) {
            this._parent = _parent;
            this._ngModule = _ngModule;
            this._factories = new Map();
            for (var i_55 = 0; i_55 < factories.length; i_55++) {
                /** @type {?} */
                var factory = factories[i_55];
                this._factories.set(factory.componentType, factory);
            }
        }
        /**
         * @template T
         * @param {?} component
         * @return {?}
         */
        CodegenComponentFactoryResolver.prototype.resolveComponentFactory = function (component) {
            /** @type {?} */
            var factory = this._factories.get(component);
            if (!factory && this._parent) {
                factory = this._parent.resolveComponentFactory(component);
            }
            if (!factory) {
                throw noComponentFactoryError(component);
            }
            return new ComponentFactoryBoundToModule(factory, this._ngModule);
        };
        return CodegenComponentFactoryResolver;
    }());
    /**
     * @template C
     */
    var ComponentFactoryBoundToModule = /** @class */ (function (_super) {
        __extends(ComponentFactoryBoundToModule, _super);
        /**
         * @param {?} factory
         * @param {?} ngModule
         */
        function ComponentFactoryBoundToModule(factory, ngModule) {
            var _this = _super.call(this) || this;
            _this.factory = factory;
            _this.ngModule = ngModule;
            _this.selector = factory.selector;
            _this.componentType = factory.componentType;
            _this.ngContentSelectors = factory.ngContentSelectors;
            _this.inputs = factory.inputs;
            _this.outputs = factory.outputs;
            return _this;
        }
        /**
         * @param {?} injector
         * @param {?=} projectableNodes
         * @param {?=} rootSelectorOrNode
         * @param {?=} ngModule
         * @return {?}
         */
        ComponentFactoryBoundToModule.prototype.create = function (injector, projectableNodes, rootSelectorOrNode, ngModule) {
            return this.factory.create(injector, projectableNodes, rootSelectorOrNode, ngModule || this.ngModule);
        };
        return ComponentFactoryBoundToModule;
    }(ComponentFactory));
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    function noop$1() {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        // Do nothing.
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A wrapper around a native element inside of a View.
     *
     * An `ElementRef` is backed by a render-specific element. In the browser, this is usually a DOM
     * element.
     *
     * \@security Permitting direct access to the DOM can make your application more vulnerable to
     * XSS attacks. Carefully review any use of `ElementRef` in your code. For more detail, see the
     * [Security Guide](http://g.co/ng/security).
     *
     * \@publicApi
     * @template T
     */
    // Note: We don't expose things like `Injector`, `ViewContainer`, ... here,
    // i.e. users have to ask for what they need. With that, we can build better analysis tools
    // and could do better codegen in the future.
    var ElementRef = /** @class */ (function () {
        /**
         * @param {?} nativeElement
         */
        function ElementRef(nativeElement) {
            this.nativeElement = nativeElement;
        }
        return ElementRef;
    }());
    /**
     * \@internal
     * @nocollapse
     */
    ElementRef.__NG_ELEMENT_ID__ = ( /**
     * @return {?}
     */function () { return SWITCH_ELEMENT_REF_FACTORY(ElementRef); });
    /** @type {?} */
    var SWITCH_ELEMENT_REF_FACTORY__PRE_R3__ = noop$1;
    /** @type {?} */
    var SWITCH_ELEMENT_REF_FACTORY = SWITCH_ELEMENT_REF_FACTORY__PRE_R3__;
    /**
     * @deprecated Use the `Renderer2` instead.
     * \@publicApi
     * @abstract
     */
    var Renderer = /** @class */ (function () {
        function Renderer() {
        }
        return Renderer;
    }());
    /** @type {?} */
    var Renderer2Interceptor = new InjectionToken('Renderer2Interceptor');
    /**
     * Creates and initializes a custom renderer that implements the `Renderer2` base class.
     *
     * \@publicApi
     * @abstract
     */
    var RendererFactory2 = /** @class */ (function () {
        function RendererFactory2() {
        }
        return RendererFactory2;
    }());
    /** @enum {number} */
    var RendererStyleFlags2 = {
        /**
         * Marks a style as important.
         */
        Important: 1,
        /**
         * Marks a style as using dash case naming (this-is-dash-case).
         */
        DashCase: 2,
    };
    RendererStyleFlags2[RendererStyleFlags2.Important] = 'Important';
    RendererStyleFlags2[RendererStyleFlags2.DashCase] = 'DashCase';
    /**
     * Extend this base class to implement custom rendering. By default, Angular
     * renders a template into DOM. You can use custom rendering to intercept
     * rendering calls, or to render to something other than DOM.
     *
     * Create your custom renderer using `RendererFactory2`.
     *
     * Use a custom renderer to bypass Angular's templating and
     * make custom UI changes that can't be expressed declaratively.
     * For example if you need to set a property or an attribute whose name is
     * not statically known, use the `setProperty()` or
     * `setAttribute()` method.
     *
     * \@publicApi
     * @abstract
     */
    var Renderer2 = /** @class */ (function () {
        function Renderer2() {
        }
        return Renderer2;
    }());
    /**
     * \@internal
     * @nocollapse
     */
    Renderer2.__NG_ELEMENT_ID__ = ( /**
     * @return {?}
     */function () { return SWITCH_RENDERER2_FACTORY(); });
    /** @type {?} */
    var SWITCH_RENDERER2_FACTORY__PRE_R3__ = noop$1;
    /** @type {?} */
    var SWITCH_RENDERER2_FACTORY = SWITCH_RENDERER2_FACTORY__PRE_R3__;
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * \@description Represents the version of Angular
     *
     * \@publicApi
     */
    var Version = /** @class */ (function () {
        /**
         * @param {?} full
         */
        function Version(full) {
            this.full = full;
            this.major = full.split('.')[0];
            this.minor = full.split('.')[1];
            this.patch = full.split('.').slice(2).join('.');
        }
        return Version;
    }());
    /**
     * \@publicApi
     * @type {?}
     */
    var VERSION = new Version('8.2.14');
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DefaultIterableDifferFactory = /** @class */ (function () {
        function DefaultIterableDifferFactory() {
        }
        /**
         * @param {?} obj
         * @return {?}
         */
        DefaultIterableDifferFactory.prototype.supports = function (obj) { return isListLikeIterable$1(obj); };
        /**
         * @template V
         * @param {?=} trackByFn
         * @return {?}
         */
        DefaultIterableDifferFactory.prototype.create = function (trackByFn) {
            return new DefaultIterableDiffer(trackByFn);
        };
        return DefaultIterableDifferFactory;
    }());
    /** @type {?} */
    var trackByIdentity = ( /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */function (index, item) { return item; });
    /**
     * @deprecated v4.0.0 - Should not be part of public API.
     * \@publicApi
     * @template V
     */
    var DefaultIterableDiffer = /** @class */ (function () {
        /**
         * @param {?=} trackByFn
         */
        function DefaultIterableDiffer(trackByFn) {
            this.length = 0;
            // Keeps track of the used records at any point in time (during & across `_check()` calls)
            this._linkedRecords = null;
            // Keeps track of the removed records at any point in time during `_check()` calls.
            this._unlinkedRecords = null;
            this._previousItHead = null;
            this._itHead = null;
            this._itTail = null;
            this._additionsHead = null;
            this._additionsTail = null;
            this._movesHead = null;
            this._movesTail = null;
            this._removalsHead = null;
            this._removalsTail = null;
            // Keeps track of records where custom track by is the same, but item identity has changed
            this._identityChangesHead = null;
            this._identityChangesTail = null;
            this._trackByFn = trackByFn || trackByIdentity;
        }
        /**
         * @param {?} fn
         * @return {?}
         */
        DefaultIterableDiffer.prototype.forEachItem = function (fn) {
            /** @type {?} */
            var record;
            for (record = this._itHead; record !== null; record = record._next) {
                fn(record);
            }
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        DefaultIterableDiffer.prototype.forEachOperation = function (fn) {
            /** @type {?} */
            var nextIt = this._itHead;
            /** @type {?} */
            var nextRemove = this._removalsHead;
            /** @type {?} */
            var addRemoveOffset = 0;
            /** @type {?} */
            var moveOffsets = null;
            while (nextIt || nextRemove) {
                // Figure out which is the next record to process
                // Order: remove, add, move
                /** @type {?} */
                var record = !nextRemove ||
                    nextIt &&
                        ( /** @type {?} */(nextIt.currentIndex)) <
                            getPreviousIndex(nextRemove, addRemoveOffset, moveOffsets) ?
                    ( /** @type {?} */(nextIt)) :
                    nextRemove;
                /** @type {?} */
                var adjPreviousIndex = getPreviousIndex(record, addRemoveOffset, moveOffsets);
                /** @type {?} */
                var currentIndex = record.currentIndex;
                // consume the item, and adjust the addRemoveOffset and update moveDistance if necessary
                if (record === nextRemove) {
                    addRemoveOffset--;
                    nextRemove = nextRemove._nextRemoved;
                }
                else {
                    nextIt = ( /** @type {?} */(nextIt))._next;
                    if (record.previousIndex == null) {
                        addRemoveOffset++;
                    }
                    else {
                        // INVARIANT:  currentIndex < previousIndex
                        if (!moveOffsets)
                            moveOffsets = [];
                        /** @type {?} */
                        var localMovePreviousIndex = adjPreviousIndex - addRemoveOffset;
                        /** @type {?} */
                        var localCurrentIndex = ( /** @type {?} */(currentIndex)) - addRemoveOffset;
                        if (localMovePreviousIndex != localCurrentIndex) {
                            for (var i_56 = 0; i_56 < localMovePreviousIndex; i_56++) {
                                /** @type {?} */
                                var offset = i_56 < moveOffsets.length ? moveOffsets[i_56] : (moveOffsets[i_56] = 0);
                                /** @type {?} */
                                var index = offset + i_56;
                                if (localCurrentIndex <= index && index < localMovePreviousIndex) {
                                    moveOffsets[i_56] = offset + 1;
                                }
                            }
                            /** @type {?} */
                            var previousIndex = record.previousIndex;
                            moveOffsets[previousIndex] = localCurrentIndex - localMovePreviousIndex;
                        }
                    }
                }
                if (adjPreviousIndex !== currentIndex) {
                    fn(record, adjPreviousIndex, currentIndex);
                }
            }
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        DefaultIterableDiffer.prototype.forEachPreviousItem = function (fn) {
            /** @type {?} */
            var record;
            for (record = this._previousItHead; record !== null; record = record._nextPrevious) {
                fn(record);
            }
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        DefaultIterableDiffer.prototype.forEachAddedItem = function (fn) {
            /** @type {?} */
            var record;
            for (record = this._additionsHead; record !== null; record = record._nextAdded) {
                fn(record);
            }
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        DefaultIterableDiffer.prototype.forEachMovedItem = function (fn) {
            /** @type {?} */
            var record;
            for (record = this._movesHead; record !== null; record = record._nextMoved) {
                fn(record);
            }
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        DefaultIterableDiffer.prototype.forEachRemovedItem = function (fn) {
            /** @type {?} */
            var record;
            for (record = this._removalsHead; record !== null; record = record._nextRemoved) {
                fn(record);
            }
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        DefaultIterableDiffer.prototype.forEachIdentityChange = function (fn) {
            /** @type {?} */
            var record;
            for (record = this._identityChangesHead; record !== null; record = record._nextIdentityChange) {
                fn(record);
            }
        };
        /**
         * @param {?} collection
         * @return {?}
         */
        DefaultIterableDiffer.prototype.diff = function (collection) {
            if (collection == null)
                collection = [];
            if (!isListLikeIterable$1(collection)) {
                throw new Error("Error trying to diff '" + stringify(collection) + "'. Only arrays and iterables are allowed");
            }
            if (this.check(collection)) {
                return this;
            }
            else {
                return null;
            }
        };
        /**
         * @return {?}
         */
        DefaultIterableDiffer.prototype.onDestroy = function () { };
        /**
         * @param {?} collection
         * @return {?}
         */
        DefaultIterableDiffer.prototype.check = function (collection) {
            var _this = this;
            this._reset();
            /** @type {?} */
            var record = this._itHead;
            /** @type {?} */
            var mayBeDirty = false;
            /** @type {?} */
            var index;
            /** @type {?} */
            var item;
            /** @type {?} */
            var itemTrackBy;
            if (Array.isArray(collection)) {
                (( /** @type {?} */(this))).length = collection.length;
                for (var index_1 = 0; index_1 < this.length; index_1++) {
                    item = collection[index_1];
                    itemTrackBy = this._trackByFn(index_1, item);
                    if (record === null || !looseIdentical(record.trackById, itemTrackBy)) {
                        record = this._mismatch(record, item, itemTrackBy, index_1);
                        mayBeDirty = true;
                    }
                    else {
                        if (mayBeDirty) {
                            // TODO(misko): can we limit this to duplicates only?
                            record = this._verifyReinsertion(record, item, itemTrackBy, index_1);
                        }
                        if (!looseIdentical(record.item, item))
                            this._addIdentityChange(record, item);
                    }
                    record = record._next;
                }
            }
            else {
                index = 0;
                iterateListLike$1(collection, ( /**
                 * @param {?} item
                 * @return {?}
                 */function (item) {
                    itemTrackBy = _this._trackByFn(index, item);
                    if (record === null || !looseIdentical(record.trackById, itemTrackBy)) {
                        record = _this._mismatch(record, item, itemTrackBy, index);
                        mayBeDirty = true;
                    }
                    else {
                        if (mayBeDirty) {
                            // TODO(misko): can we limit this to duplicates only?
                            record = _this._verifyReinsertion(record, item, itemTrackBy, index);
                        }
                        if (!looseIdentical(record.item, item))
                            _this._addIdentityChange(record, item);
                    }
                    record = record._next;
                    index++;
                }));
                (( /** @type {?} */(this))).length = index;
            }
            this._truncate(record);
            (( /** @type {?} */(this))).collection = collection;
            return this.isDirty;
        };
        Object.defineProperty(DefaultIterableDiffer.prototype, "isDirty", {
            /* CollectionChanges is considered dirty if it has any additions, moves, removals, or identity
               * changes.
               */
            /**
             * @return {?}
             */
            get: function () {
                return this._additionsHead !== null || this._movesHead !== null ||
                    this._removalsHead !== null || this._identityChangesHead !== null;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Reset the state of the change objects to show no changes. This means set previousKey to
         * currentKey, and clear all of the queues (additions, moves, removals).
         * Set the previousIndexes of moved and added items to their currentIndexes
         * Reset the list of additions, moves and removals
         *
         * \@internal
         * @return {?}
         */
        DefaultIterableDiffer.prototype._reset = function () {
            if (this.isDirty) {
                /** @type {?} */
                var record = void 0;
                /** @type {?} */
                var nextRecord = void 0;
                for (record = this._previousItHead = this._itHead; record !== null; record = record._next) {
                    record._nextPrevious = record._next;
                }
                for (record = this._additionsHead; record !== null; record = record._nextAdded) {
                    record.previousIndex = record.currentIndex;
                }
                this._additionsHead = this._additionsTail = null;
                for (record = this._movesHead; record !== null; record = nextRecord) {
                    record.previousIndex = record.currentIndex;
                    nextRecord = record._nextMoved;
                }
                this._movesHead = this._movesTail = null;
                this._removalsHead = this._removalsTail = null;
                this._identityChangesHead = this._identityChangesTail = null;
                // TODO(vicb): when assert gets supported
                // assert(!this.isDirty);
            }
        };
        /**
         * This is the core function which handles differences between collections.
         *
         * - `record` is the record which we saw at this position last time. If null then it is a new
         *   item.
         * - `item` is the current item in the collection
         * - `index` is the position of the item in the collection
         *
         * \@internal
         * @param {?} record
         * @param {?} item
         * @param {?} itemTrackBy
         * @param {?} index
         * @return {?}
         */
        DefaultIterableDiffer.prototype._mismatch = function (record, item, itemTrackBy, index) {
            // The previous record after which we will append the current one.
            /** @type {?} */
            var previousRecord;
            if (record === null) {
                previousRecord = this._itTail;
            }
            else {
                previousRecord = record._prev;
                // Remove the record from the collection since we know it does not match the item.
                this._remove(record);
            }
            // Attempt to see if we have seen the item before.
            record = this._linkedRecords === null ? null : this._linkedRecords.get(itemTrackBy, index);
            if (record !== null) {
                // We have seen this before, we need to move it forward in the collection.
                // But first we need to check if identity changed, so we can update in view if necessary
                if (!looseIdentical(record.item, item))
                    this._addIdentityChange(record, item);
                this._moveAfter(record, previousRecord, index);
            }
            else {
                // Never seen it, check evicted list.
                record = this._unlinkedRecords === null ? null : this._unlinkedRecords.get(itemTrackBy, null);
                if (record !== null) {
                    // It is an item which we have evicted earlier: reinsert it back into the list.
                    // But first we need to check if identity changed, so we can update in view if necessary
                    if (!looseIdentical(record.item, item))
                        this._addIdentityChange(record, item);
                    this._reinsertAfter(record, previousRecord, index);
                }
                else {
                    // It is a new item: add it.
                    record =
                        this._addAfter(new IterableChangeRecord_(item, itemTrackBy), previousRecord, index);
                }
            }
            return record;
        };
        /**
         * This check is only needed if an array contains duplicates. (Short circuit of nothing dirty)
         *
         * Use case: `[a, a]` => `[b, a, a]`
         *
         * If we did not have this check then the insertion of `b` would:
         *   1) evict first `a`
         *   2) insert `b` at `0` index.
         *   3) leave `a` at index `1` as is. <-- this is wrong!
         *   3) reinsert `a` at index 2. <-- this is wrong!
         *
         * The correct behavior is:
         *   1) evict first `a`
         *   2) insert `b` at `0` index.
         *   3) reinsert `a` at index 1.
         *   3) move `a` at from `1` to `2`.
         *
         *
         * Double check that we have not evicted a duplicate item. We need to check if the item type may
         * have already been removed:
         * The insertion of b will evict the first 'a'. If we don't reinsert it now it will be reinserted
         * at the end. Which will show up as the two 'a's switching position. This is incorrect, since a
         * better way to think of it is as insert of 'b' rather then switch 'a' with 'b' and then add 'a'
         * at the end.
         *
         * \@internal
         * @param {?} record
         * @param {?} item
         * @param {?} itemTrackBy
         * @param {?} index
         * @return {?}
         */
        DefaultIterableDiffer.prototype._verifyReinsertion = function (record, item, itemTrackBy, index) {
            /** @type {?} */
            var reinsertRecord = this._unlinkedRecords === null ? null : this._unlinkedRecords.get(itemTrackBy, null);
            if (reinsertRecord !== null) {
                record = this._reinsertAfter(reinsertRecord, ( /** @type {?} */(record._prev)), index);
            }
            else if (record.currentIndex != index) {
                record.currentIndex = index;
                this._addToMoves(record, index);
            }
            return record;
        };
        /**
         * Get rid of any excess {\@link IterableChangeRecord_}s from the previous collection
         *
         * - `record` The first excess {\@link IterableChangeRecord_}.
         *
         * \@internal
         * @param {?} record
         * @return {?}
         */
        DefaultIterableDiffer.prototype._truncate = function (record) {
            // Anything after that needs to be removed;
            while (record !== null) {
                /** @type {?} */
                var nextRecord = record._next;
                this._addToRemovals(this._unlink(record));
                record = nextRecord;
            }
            if (this._unlinkedRecords !== null) {
                this._unlinkedRecords.clear();
            }
            if (this._additionsTail !== null) {
                this._additionsTail._nextAdded = null;
            }
            if (this._movesTail !== null) {
                this._movesTail._nextMoved = null;
            }
            if (this._itTail !== null) {
                this._itTail._next = null;
            }
            if (this._removalsTail !== null) {
                this._removalsTail._nextRemoved = null;
            }
            if (this._identityChangesTail !== null) {
                this._identityChangesTail._nextIdentityChange = null;
            }
        };
        /**
         * \@internal
         * @param {?} record
         * @param {?} prevRecord
         * @param {?} index
         * @return {?}
         */
        DefaultIterableDiffer.prototype._reinsertAfter = function (record, prevRecord, index) {
            if (this._unlinkedRecords !== null) {
                this._unlinkedRecords.remove(record);
            }
            /** @type {?} */
            var prev = record._prevRemoved;
            /** @type {?} */
            var next = record._nextRemoved;
            if (prev === null) {
                this._removalsHead = next;
            }
            else {
                prev._nextRemoved = next;
            }
            if (next === null) {
                this._removalsTail = prev;
            }
            else {
                next._prevRemoved = prev;
            }
            this._insertAfter(record, prevRecord, index);
            this._addToMoves(record, index);
            return record;
        };
        /**
         * \@internal
         * @param {?} record
         * @param {?} prevRecord
         * @param {?} index
         * @return {?}
         */
        DefaultIterableDiffer.prototype._moveAfter = function (record, prevRecord, index) {
            this._unlink(record);
            this._insertAfter(record, prevRecord, index);
            this._addToMoves(record, index);
            return record;
        };
        /**
         * \@internal
         * @param {?} record
         * @param {?} prevRecord
         * @param {?} index
         * @return {?}
         */
        DefaultIterableDiffer.prototype._addAfter = function (record, prevRecord, index) {
            this._insertAfter(record, prevRecord, index);
            if (this._additionsTail === null) {
                // TODO(vicb):
                // assert(this._additionsHead === null);
                this._additionsTail = this._additionsHead = record;
            }
            else {
                // TODO(vicb):
                // assert(_additionsTail._nextAdded === null);
                // assert(record._nextAdded === null);
                this._additionsTail = this._additionsTail._nextAdded = record;
            }
            return record;
        };
        /**
         * \@internal
         * @param {?} record
         * @param {?} prevRecord
         * @param {?} index
         * @return {?}
         */
        DefaultIterableDiffer.prototype._insertAfter = function (record, prevRecord, index) {
            // TODO(vicb):
            // assert(record != prevRecord);
            // assert(record._next === null);
            // assert(record._prev === null);
            // TODO(vicb):
            // assert(record != prevRecord);
            // assert(record._next === null);
            // assert(record._prev === null);
            /** @type {?} */
            var next = prevRecord === null ? this._itHead : prevRecord._next;
            // TODO(vicb):
            // assert(next != record);
            // assert(prevRecord != record);
            record._next = next;
            record._prev = prevRecord;
            if (next === null) {
                this._itTail = record;
            }
            else {
                next._prev = record;
            }
            if (prevRecord === null) {
                this._itHead = record;
            }
            else {
                prevRecord._next = record;
            }
            if (this._linkedRecords === null) {
                this._linkedRecords = new _DuplicateMap();
            }
            this._linkedRecords.put(record);
            record.currentIndex = index;
            return record;
        };
        /**
         * \@internal
         * @param {?} record
         * @return {?}
         */
        DefaultIterableDiffer.prototype._remove = function (record) {
            return this._addToRemovals(this._unlink(record));
        };
        /**
         * \@internal
         * @param {?} record
         * @return {?}
         */
        DefaultIterableDiffer.prototype._unlink = function (record) {
            if (this._linkedRecords !== null) {
                this._linkedRecords.remove(record);
            }
            /** @type {?} */
            var prev = record._prev;
            /** @type {?} */
            var next = record._next;
            // TODO(vicb):
            // assert((record._prev = null) === null);
            // assert((record._next = null) === null);
            if (prev === null) {
                this._itHead = next;
            }
            else {
                prev._next = next;
            }
            if (next === null) {
                this._itTail = prev;
            }
            else {
                next._prev = prev;
            }
            return record;
        };
        /**
         * \@internal
         * @param {?} record
         * @param {?} toIndex
         * @return {?}
         */
        DefaultIterableDiffer.prototype._addToMoves = function (record, toIndex) {
            // TODO(vicb):
            // assert(record._nextMoved === null);
            if (record.previousIndex === toIndex) {
                return record;
            }
            if (this._movesTail === null) {
                // TODO(vicb):
                // assert(_movesHead === null);
                this._movesTail = this._movesHead = record;
            }
            else {
                // TODO(vicb):
                // assert(_movesTail._nextMoved === null);
                this._movesTail = this._movesTail._nextMoved = record;
            }
            return record;
        };
        /**
         * @private
         * @param {?} record
         * @return {?}
         */
        DefaultIterableDiffer.prototype._addToRemovals = function (record) {
            if (this._unlinkedRecords === null) {
                this._unlinkedRecords = new _DuplicateMap();
            }
            this._unlinkedRecords.put(record);
            record.currentIndex = null;
            record._nextRemoved = null;
            if (this._removalsTail === null) {
                // TODO(vicb):
                // assert(_removalsHead === null);
                this._removalsTail = this._removalsHead = record;
                record._prevRemoved = null;
            }
            else {
                // TODO(vicb):
                // assert(_removalsTail._nextRemoved === null);
                // assert(record._nextRemoved === null);
                record._prevRemoved = this._removalsTail;
                this._removalsTail = this._removalsTail._nextRemoved = record;
            }
            return record;
        };
        /**
         * \@internal
         * @param {?} record
         * @param {?} item
         * @return {?}
         */
        DefaultIterableDiffer.prototype._addIdentityChange = function (record, item) {
            record.item = item;
            if (this._identityChangesTail === null) {
                this._identityChangesTail = this._identityChangesHead = record;
            }
            else {
                this._identityChangesTail = this._identityChangesTail._nextIdentityChange = record;
            }
            return record;
        };
        return DefaultIterableDiffer;
    }());
    /**
     * @template V
     */
    var IterableChangeRecord_ = /** @class */ (function () {
        /**
         * @param {?} item
         * @param {?} trackById
         */
        function IterableChangeRecord_(item, trackById) {
            this.item = item;
            this.trackById = trackById;
            this.currentIndex = null;
            this.previousIndex = null;
            /**
             * \@internal
             */
            this._nextPrevious = null;
            /**
             * \@internal
             */
            this._prev = null;
            /**
             * \@internal
             */
            this._next = null;
            /**
             * \@internal
             */
            this._prevDup = null;
            /**
             * \@internal
             */
            this._nextDup = null;
            /**
             * \@internal
             */
            this._prevRemoved = null;
            /**
             * \@internal
             */
            this._nextRemoved = null;
            /**
             * \@internal
             */
            this._nextAdded = null;
            /**
             * \@internal
             */
            this._nextMoved = null;
            /**
             * \@internal
             */
            this._nextIdentityChange = null;
        }
        return IterableChangeRecord_;
    }());
    // A linked list of CollectionChangeRecords with the same IterableChangeRecord_.item
    /**
     * @template V
     */
    var _DuplicateItemRecordList = /** @class */ (function () {
        function _DuplicateItemRecordList() {
            /**
             * \@internal
             */
            this._head = null;
            /**
             * \@internal
             */
            this._tail = null;
        }
        /**
         * Append the record to the list of duplicates.
         *
         * Note: by design all records in the list of duplicates hold the same value in record.item.
         * @param {?} record
         * @return {?}
         */
        _DuplicateItemRecordList.prototype.add = function (record) {
            if (this._head === null) {
                this._head = this._tail = record;
                record._nextDup = null;
                record._prevDup = null;
            }
            else {
                // TODO(vicb):
                // assert(record.item ==  _head.item ||
                //       record.item is num && record.item.isNaN && _head.item is num && _head.item.isNaN);
                ( /** @type {?} */(this._tail))._nextDup = record;
                record._prevDup = this._tail;
                record._nextDup = null;
                this._tail = record;
            }
        };
        // Returns a IterableChangeRecord_ having IterableChangeRecord_.trackById == trackById and
        // IterableChangeRecord_.currentIndex >= atOrAfterIndex
        /**
         * @param {?} trackById
         * @param {?} atOrAfterIndex
         * @return {?}
         */
        _DuplicateItemRecordList.prototype.get = function (trackById, atOrAfterIndex) {
            /** @type {?} */
            var record;
            for (record = this._head; record !== null; record = record._nextDup) {
                if ((atOrAfterIndex === null || atOrAfterIndex <= ( /** @type {?} */(record.currentIndex))) &&
                    looseIdentical(record.trackById, trackById)) {
                    return record;
                }
            }
            return null;
        };
        /**
         * Remove one {\@link IterableChangeRecord_} from the list of duplicates.
         *
         * Returns whether the list of duplicates is empty.
         * @param {?} record
         * @return {?}
         */
        _DuplicateItemRecordList.prototype.remove = function (record) {
            // TODO(vicb):
            // assert(() {
            //  // verify that the record being removed is in the list.
            //  for (IterableChangeRecord_ cursor = _head; cursor != null; cursor = cursor._nextDup) {
            //    if (identical(cursor, record)) return true;
            //  }
            //  return false;
            //});
            // TODO(vicb):
            // assert(() {
            //  // verify that the record being removed is in the list.
            //  for (IterableChangeRecord_ cursor = _head; cursor != null; cursor = cursor._nextDup) {
            //    if (identical(cursor, record)) return true;
            //  }
            //  return false;
            //});
            /** @type {?} */
            var prev = record._prevDup;
            /** @type {?} */
            var next = record._nextDup;
            if (prev === null) {
                this._head = next;
            }
            else {
                prev._nextDup = next;
            }
            if (next === null) {
                this._tail = prev;
            }
            else {
                next._prevDup = prev;
            }
            return this._head === null;
        };
        return _DuplicateItemRecordList;
    }());
    /**
     * @template V
     */
    var _DuplicateMap = /** @class */ (function () {
        function _DuplicateMap() {
            this.map = new Map();
        }
        /**
         * @param {?} record
         * @return {?}
         */
        _DuplicateMap.prototype.put = function (record) {
            /** @type {?} */
            var key = record.trackById;
            /** @type {?} */
            var duplicates = this.map.get(key);
            if (!duplicates) {
                duplicates = new _DuplicateItemRecordList();
                this.map.set(key, duplicates);
            }
            duplicates.add(record);
        };
        /**
         * Retrieve the `value` using key. Because the IterableChangeRecord_ value may be one which we
         * have already iterated over, we use the `atOrAfterIndex` to pretend it is not there.
         *
         * Use case: `[a, b, c, a, a]` if we are at index `3` which is the second `a` then asking if we
         * have any more `a`s needs to return the second `a`.
         * @param {?} trackById
         * @param {?} atOrAfterIndex
         * @return {?}
         */
        _DuplicateMap.prototype.get = function (trackById, atOrAfterIndex) {
            /** @type {?} */
            var key = trackById;
            /** @type {?} */
            var recordList = this.map.get(key);
            return recordList ? recordList.get(trackById, atOrAfterIndex) : null;
        };
        /**
         * Removes a {\@link IterableChangeRecord_} from the list of duplicates.
         *
         * The list of duplicates also is removed from the map if it gets empty.
         * @param {?} record
         * @return {?}
         */
        _DuplicateMap.prototype.remove = function (record) {
            /** @type {?} */
            var key = record.trackById;
            /** @type {?} */
            var recordList = ( /** @type {?} */(this.map.get(key)));
            // Remove the list of duplicates when it gets empty
            if (recordList.remove(record)) {
                this.map.delete(key);
            }
            return record;
        };
        Object.defineProperty(_DuplicateMap.prototype, "isEmpty", {
            /**
             * @return {?}
             */
            get: function () { return this.map.size === 0; },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        _DuplicateMap.prototype.clear = function () { this.map.clear(); };
        return _DuplicateMap;
    }());
    /**
     * @param {?} item
     * @param {?} addRemoveOffset
     * @param {?} moveOffsets
     * @return {?}
     */
    function getPreviousIndex(item, addRemoveOffset, moveOffsets) {
        /** @type {?} */
        var previousIndex = item.previousIndex;
        if (previousIndex === null)
            return previousIndex;
        /** @type {?} */
        var moveOffset = 0;
        if (moveOffsets && previousIndex < moveOffsets.length) {
            moveOffset = moveOffsets[previousIndex];
        }
        return previousIndex + addRemoveOffset + moveOffset;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template K, V
     */
    var DefaultKeyValueDifferFactory = /** @class */ (function () {
        function DefaultKeyValueDifferFactory() {
        }
        /**
         * @param {?} obj
         * @return {?}
         */
        DefaultKeyValueDifferFactory.prototype.supports = function (obj) { return obj instanceof Map || isJsObject$1(obj); };
        /**
         * @template K, V
         * @return {?}
         */
        DefaultKeyValueDifferFactory.prototype.create = function () { return new DefaultKeyValueDiffer(); };
        return DefaultKeyValueDifferFactory;
    }());
    /**
     * @template K, V
     */
    var DefaultKeyValueDiffer = /** @class */ (function () {
        function DefaultKeyValueDiffer() {
            this._records = new Map();
            this._mapHead = null;
            // _appendAfter is used in the check loop
            this._appendAfter = null;
            this._previousMapHead = null;
            this._changesHead = null;
            this._changesTail = null;
            this._additionsHead = null;
            this._additionsTail = null;
            this._removalsHead = null;
            this._removalsTail = null;
        }
        Object.defineProperty(DefaultKeyValueDiffer.prototype, "isDirty", {
            /**
             * @return {?}
             */
            get: function () {
                return this._additionsHead !== null || this._changesHead !== null ||
                    this._removalsHead !== null;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} fn
         * @return {?}
         */
        DefaultKeyValueDiffer.prototype.forEachItem = function (fn) {
            /** @type {?} */
            var record;
            for (record = this._mapHead; record !== null; record = record._next) {
                fn(record);
            }
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        DefaultKeyValueDiffer.prototype.forEachPreviousItem = function (fn) {
            /** @type {?} */
            var record;
            for (record = this._previousMapHead; record !== null; record = record._nextPrevious) {
                fn(record);
            }
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        DefaultKeyValueDiffer.prototype.forEachChangedItem = function (fn) {
            /** @type {?} */
            var record;
            for (record = this._changesHead; record !== null; record = record._nextChanged) {
                fn(record);
            }
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        DefaultKeyValueDiffer.prototype.forEachAddedItem = function (fn) {
            /** @type {?} */
            var record;
            for (record = this._additionsHead; record !== null; record = record._nextAdded) {
                fn(record);
            }
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        DefaultKeyValueDiffer.prototype.forEachRemovedItem = function (fn) {
            /** @type {?} */
            var record;
            for (record = this._removalsHead; record !== null; record = record._nextRemoved) {
                fn(record);
            }
        };
        /**
         * @param {?=} map
         * @return {?}
         */
        DefaultKeyValueDiffer.prototype.diff = function (map) {
            if (!map) {
                map = new Map();
            }
            else if (!(map instanceof Map || isJsObject$1(map))) {
                throw new Error("Error trying to diff '" + stringify(map) + "'. Only maps and objects are allowed");
            }
            return this.check(map) ? this : null;
        };
        /**
         * @return {?}
         */
        DefaultKeyValueDiffer.prototype.onDestroy = function () { };
        /**
         * Check the current state of the map vs the previous.
         * The algorithm is optimised for when the keys do no change.
         * @param {?} map
         * @return {?}
         */
        DefaultKeyValueDiffer.prototype.check = function (map) {
            var _this = this;
            this._reset();
            /** @type {?} */
            var insertBefore = this._mapHead;
            this._appendAfter = null;
            this._forEach(map, ( /**
             * @param {?} value
             * @param {?} key
             * @return {?}
             */function (value, key) {
                if (insertBefore && insertBefore.key === key) {
                    _this._maybeAddToChanges(insertBefore, value);
                    _this._appendAfter = insertBefore;
                    insertBefore = insertBefore._next;
                }
                else {
                    /** @type {?} */
                    var record = _this._getOrCreateRecordForKey(key, value);
                    insertBefore = _this._insertBeforeOrAppend(insertBefore, record);
                }
            }));
            // Items remaining at the end of the list have been deleted
            if (insertBefore) {
                if (insertBefore._prev) {
                    insertBefore._prev._next = null;
                }
                this._removalsHead = insertBefore;
                for (var record = insertBefore; record !== null; record = record._nextRemoved) {
                    if (record === this._mapHead) {
                        this._mapHead = null;
                    }
                    this._records.delete(record.key);
                    record._nextRemoved = record._next;
                    record.previousValue = record.currentValue;
                    record.currentValue = null;
                    record._prev = null;
                    record._next = null;
                }
            }
            // Make sure tails have no next records from previous runs
            if (this._changesTail)
                this._changesTail._nextChanged = null;
            if (this._additionsTail)
                this._additionsTail._nextAdded = null;
            return this.isDirty;
        };
        /**
         * Inserts a record before `before` or append at the end of the list when `before` is null.
         *
         * Notes:
         * - This method appends at `this._appendAfter`,
         * - This method updates `this._appendAfter`,
         * - The return value is the new value for the insertion pointer.
         * @private
         * @param {?} before
         * @param {?} record
         * @return {?}
         */
        DefaultKeyValueDiffer.prototype._insertBeforeOrAppend = function (before, record) {
            if (before) {
                /** @type {?} */
                var prev = before._prev;
                record._next = before;
                record._prev = prev;
                before._prev = record;
                if (prev) {
                    prev._next = record;
                }
                if (before === this._mapHead) {
                    this._mapHead = record;
                }
                this._appendAfter = before;
                return before;
            }
            if (this._appendAfter) {
                this._appendAfter._next = record;
                record._prev = this._appendAfter;
            }
            else {
                this._mapHead = record;
            }
            this._appendAfter = record;
            return null;
        };
        /**
         * @private
         * @param {?} key
         * @param {?} value
         * @return {?}
         */
        DefaultKeyValueDiffer.prototype._getOrCreateRecordForKey = function (key, value) {
            if (this._records.has(key)) {
                /** @type {?} */
                var record_1 = ( /** @type {?} */(this._records.get(key)));
                this._maybeAddToChanges(record_1, value);
                /** @type {?} */
                var prev = record_1._prev;
                /** @type {?} */
                var next = record_1._next;
                if (prev) {
                    prev._next = next;
                }
                if (next) {
                    next._prev = prev;
                }
                record_1._next = null;
                record_1._prev = null;
                return record_1;
            }
            /** @type {?} */
            var record = new KeyValueChangeRecord_(key);
            this._records.set(key, record);
            record.currentValue = value;
            this._addToAdditions(record);
            return record;
        };
        /**
         * \@internal
         * @return {?}
         */
        DefaultKeyValueDiffer.prototype._reset = function () {
            if (this.isDirty) {
                /** @type {?} */
                var record = void 0;
                // let `_previousMapHead` contain the state of the map before the changes
                this._previousMapHead = this._mapHead;
                for (record = this._previousMapHead; record !== null; record = record._next) {
                    record._nextPrevious = record._next;
                }
                // Update `record.previousValue` with the value of the item before the changes
                // We need to update all changed items (that's those which have been added and changed)
                for (record = this._changesHead; record !== null; record = record._nextChanged) {
                    record.previousValue = record.currentValue;
                }
                for (record = this._additionsHead; record != null; record = record._nextAdded) {
                    record.previousValue = record.currentValue;
                }
                this._changesHead = this._changesTail = null;
                this._additionsHead = this._additionsTail = null;
                this._removalsHead = null;
            }
        };
        // Add the record or a given key to the list of changes only when the value has actually changed
        /**
         * @private
         * @param {?} record
         * @param {?} newValue
         * @return {?}
         */
        DefaultKeyValueDiffer.prototype._maybeAddToChanges = function (record, newValue) {
            if (!looseIdentical(newValue, record.currentValue)) {
                record.previousValue = record.currentValue;
                record.currentValue = newValue;
                this._addToChanges(record);
            }
        };
        /**
         * @private
         * @param {?} record
         * @return {?}
         */
        DefaultKeyValueDiffer.prototype._addToAdditions = function (record) {
            if (this._additionsHead === null) {
                this._additionsHead = this._additionsTail = record;
            }
            else {
                ( /** @type {?} */(this._additionsTail))._nextAdded = record;
                this._additionsTail = record;
            }
        };
        /**
         * @private
         * @param {?} record
         * @return {?}
         */
        DefaultKeyValueDiffer.prototype._addToChanges = function (record) {
            if (this._changesHead === null) {
                this._changesHead = this._changesTail = record;
            }
            else {
                ( /** @type {?} */(this._changesTail))._nextChanged = record;
                this._changesTail = record;
            }
        };
        /**
         * \@internal
         * @private
         * @template K, V
         * @param {?} obj
         * @param {?} fn
         * @return {?}
         */
        DefaultKeyValueDiffer.prototype._forEach = function (obj, fn) {
            if (obj instanceof Map) {
                obj.forEach(fn);
            }
            else {
                Object.keys(obj).forEach(( /**
                 * @param {?} k
                 * @return {?}
                 */function (/**
                 * @param {?} k
                 * @return {?}
                 */ k) { return fn(obj[k], k); }));
            }
        };
        return DefaultKeyValueDiffer;
    }());
    /**
     * @template K, V
     */
    var KeyValueChangeRecord_ = /** @class */ (function () {
        /**
         * @param {?} key
         */
        function KeyValueChangeRecord_(key) {
            this.key = key;
            this.previousValue = null;
            this.currentValue = null;
            /**
             * \@internal
             */
            this._nextPrevious = null;
            /**
             * \@internal
             */
            this._next = null;
            /**
             * \@internal
             */
            this._prev = null;
            /**
             * \@internal
             */
            this._nextAdded = null;
            /**
             * \@internal
             */
            this._nextRemoved = null;
            /**
             * \@internal
             */
            this._nextChanged = null;
        }
        return KeyValueChangeRecord_;
    }());
    /**
     * A repository of different iterable diffing strategies used by NgFor, NgClass, and others.
     *
     * \@publicApi
     */
    var IterableDiffers = /** @class */ (function () {
        /**
         * @param {?} factories
         */
        function IterableDiffers(factories) {
            this.factories = factories;
        }
        /**
         * @param {?} factories
         * @param {?=} parent
         * @return {?}
         */
        IterableDiffers.create = function (factories, parent) {
            if (parent != null) {
                /** @type {?} */
                var copied = parent.factories.slice();
                factories = factories.concat(copied);
            }
            return new IterableDiffers(factories);
        };
        /**
         * Takes an array of {\@link IterableDifferFactory} and returns a provider used to extend the
         * inherited {\@link IterableDiffers} instance with the provided factories and return a new
         * {\@link IterableDiffers} instance.
         *
         * \@usageNotes
         * ### Example
         *
         * The following example shows how to extend an existing list of factories,
         * which will only be applied to the injector for this component and its children.
         * This step is all that's required to make a new {\@link IterableDiffer} available.
         *
         * ```
         * \@Component({
         *   viewProviders: [
         *     IterableDiffers.extend([new ImmutableListDiffer()])
         *   ]
         * })
         * ```
         * @param {?} factories
         * @return {?}
         */
        IterableDiffers.extend = function (factories) {
            return {
                provide: IterableDiffers,
                useFactory: ( /**
                 * @param {?} parent
                 * @return {?}
                 */function (parent) {
                    if (!parent) {
                        // Typically would occur when calling IterableDiffers.extend inside of dependencies passed
                        // to
                        // bootstrap(), which would override default pipes instead of extending them.
                        throw new Error('Cannot extend IterableDiffers without a parent injector');
                    }
                    return IterableDiffers.create(factories, parent);
                }),
                // Dependency technically isn't optional, but we can provide a better error message this way.
                deps: [[IterableDiffers, new SkipSelf(), new Optional()]]
            };
        };
        /**
         * @param {?} iterable
         * @return {?}
         */
        IterableDiffers.prototype.find = function (iterable) {
            /** @type {?} */
            var factory = this.factories.find(( /**
             * @param {?} f
             * @return {?}
             */function (/**
             * @param {?} f
             * @return {?}
             */ f) { return f.supports(iterable); }));
            if (factory != null) {
                return factory;
            }
            else {
                throw new Error("Cannot find a differ supporting object '" + iterable + "' of type '" + getTypeNameForDebugging(iterable) + "'");
            }
        };
        return IterableDiffers;
    }());
    /** @nocollapse */
    /** @nocollapse */ IterableDiffers.ngInjectableDef = ɵɵdefineInjectable({
        token: IterableDiffers,
        providedIn: 'root',
        factory: ( /**
         * @nocollapse @return {?}
         */function () { return new IterableDiffers([new DefaultIterableDifferFactory()]); })
    });
    /**
     * @param {?} type
     * @return {?}
     */
    function getTypeNameForDebugging(type) {
        return type['name'] || typeof type;
    }
    /**
     * A repository of different Map diffing strategies used by NgClass, NgStyle, and others.
     *
     * \@publicApi
     */
    var KeyValueDiffers = /** @class */ (function () {
        /**
         * @param {?} factories
         */
        function KeyValueDiffers(factories) {
            this.factories = factories;
        }
        /**
         * @template S
         * @param {?} factories
         * @param {?=} parent
         * @return {?}
         */
        KeyValueDiffers.create = function (factories, parent) {
            if (parent) {
                /** @type {?} */
                var copied = parent.factories.slice();
                factories = factories.concat(copied);
            }
            return new KeyValueDiffers(factories);
        };
        /**
         * Takes an array of {\@link KeyValueDifferFactory} and returns a provider used to extend the
         * inherited {\@link KeyValueDiffers} instance with the provided factories and return a new
         * {\@link KeyValueDiffers} instance.
         *
         * \@usageNotes
         * ### Example
         *
         * The following example shows how to extend an existing list of factories,
         * which will only be applied to the injector for this component and its children.
         * This step is all that's required to make a new {\@link KeyValueDiffer} available.
         *
         * ```
         * \@Component({
         *   viewProviders: [
         *     KeyValueDiffers.extend([new ImmutableMapDiffer()])
         *   ]
         * })
         * ```
         * @template S
         * @param {?} factories
         * @return {?}
         */
        KeyValueDiffers.extend = function (factories) {
            return {
                provide: KeyValueDiffers,
                useFactory: ( /**
                 * @param {?} parent
                 * @return {?}
                 */function (parent) {
                    if (!parent) {
                        // Typically would occur when calling KeyValueDiffers.extend inside of dependencies passed
                        // to bootstrap(), which would override default pipes instead of extending them.
                        throw new Error('Cannot extend KeyValueDiffers without a parent injector');
                    }
                    return KeyValueDiffers.create(factories, parent);
                }),
                // Dependency technically isn't optional, but we can provide a better error message this way.
                deps: [[KeyValueDiffers, new SkipSelf(), new Optional()]]
            };
        };
        /**
         * @param {?} kv
         * @return {?}
         */
        KeyValueDiffers.prototype.find = function (kv) {
            /** @type {?} */
            var factory = this.factories.find(( /**
             * @param {?} f
             * @return {?}
             */function (/**
             * @param {?} f
             * @return {?}
             */ f) { return f.supports(kv); }));
            if (factory) {
                return factory;
            }
            throw new Error("Cannot find a differ supporting object '" + kv + "'");
        };
        return KeyValueDiffers;
    }());
    /** @nocollapse */
    /** @nocollapse */ KeyValueDiffers.ngInjectableDef = ɵɵdefineInjectable({
        token: KeyValueDiffers,
        providedIn: 'root',
        factory: ( /**
         * @nocollapse @return {?}
         */function () { return new KeyValueDiffers([new DefaultKeyValueDifferFactory()]); })
    });
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Structural diffing for `Object`s and `Map`s.
     * @type {?}
     */
    var keyValDiff = [new DefaultKeyValueDifferFactory()];
    /**
     * Structural diffing for `Iterable` types such as `Array`s.
     * @type {?}
     */
    var iterableDiff = [new DefaultIterableDifferFactory()];
    /** @type {?} */
    var defaultIterableDiffers = new IterableDiffers(iterableDiff);
    /** @type {?} */
    var defaultKeyValueDiffers = new KeyValueDiffers(keyValDiff);
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Represents an embedded template that can be used to instantiate embedded views.
     * To instantiate embedded views based on a template, use the `ViewContainerRef`
     * method `createEmbeddedView()`.
     *
     * Access a `TemplateRef` instance by placing a directive on an `<ng-template>`
     * element (or directive prefixed with `*`). The `TemplateRef` for the embedded view
     * is injected into the constructor of the directive,
     * using the `TemplateRef` token.
     *
     * You can also use a `Query` to find a `TemplateRef` associated with
     * a component or a directive.
     *
     * @see `ViewContainerRef`
     * @see [Navigate the Component Tree with DI](guide/dependency-injection-navtree)
     *
     * \@publicApi
     * @abstract
     * @template C
     */
    var TemplateRef = /** @class */ (function () {
        function TemplateRef() {
        }
        return TemplateRef;
    }());
    /**
     * \@internal
     * @nocollapse
     */
    TemplateRef.__NG_ELEMENT_ID__ = ( /**
     * @return {?}
     */function () { return SWITCH_TEMPLATE_REF_FACTORY(TemplateRef, ElementRef); });
    /** @type {?} */
    var SWITCH_TEMPLATE_REF_FACTORY__PRE_R3__ = noop$1;
    /** @type {?} */
    var SWITCH_TEMPLATE_REF_FACTORY = SWITCH_TEMPLATE_REF_FACTORY__PRE_R3__;
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Represents a container where one or more views can be attached to a component.
     *
     * Can contain *host views* (created by instantiating a
     * component with the `createComponent()` method), and *embedded views*
     * (created by instantiating a `TemplateRef` with the `createEmbeddedView()` method).
     *
     * A view container instance can contain other view containers,
     * creating a [view hierarchy](guide/glossary#view-tree).
     *
     * @see `ComponentRef`
     * @see `EmbeddedViewRef`
     *
     * \@publicApi
     * @abstract
     */
    var ViewContainerRef = /** @class */ (function () {
        function ViewContainerRef() {
        }
        return ViewContainerRef;
    }());
    /**
     * \@internal
     * @nocollapse
     */
    ViewContainerRef.__NG_ELEMENT_ID__ = ( /**
     * @return {?}
     */function () { return SWITCH_VIEW_CONTAINER_REF_FACTORY(ViewContainerRef, ElementRef); });
    /** @type {?} */
    var SWITCH_VIEW_CONTAINER_REF_FACTORY__PRE_R3__ = noop$1;
    /** @type {?} */
    var SWITCH_VIEW_CONTAINER_REF_FACTORY = SWITCH_VIEW_CONTAINER_REF_FACTORY__PRE_R3__;
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} context
     * @param {?} oldValue
     * @param {?} currValue
     * @param {?} isFirstCheck
     * @return {?}
     */
    function expressionChangedAfterItHasBeenCheckedError(context, oldValue, currValue, isFirstCheck) {
        /** @type {?} */
        var msg = "ExpressionChangedAfterItHasBeenCheckedError: Expression has changed after it was checked. Previous value: '" + oldValue + "'. Current value: '" + currValue + "'.";
        if (isFirstCheck) {
            msg +=
                " It seems like the view has been created after its parent and its children have been dirty checked." +
                    " Has it been created in a change detection hook ?";
        }
        return viewDebugError(msg, context);
    }
    /**
     * @param {?} err
     * @param {?} context
     * @return {?}
     */
    function viewWrappedDebugError(err, context) {
        if (!(err instanceof Error)) {
            // errors that are not Error instances don't have a stack,
            // so it is ok to wrap them into a new Error object...
            err = new Error(err.toString());
        }
        _addDebugContext(err, context);
        return err;
    }
    /**
     * @param {?} msg
     * @param {?} context
     * @return {?}
     */
    function viewDebugError(msg, context) {
        /** @type {?} */
        var err = new Error(msg);
        _addDebugContext(err, context);
        return err;
    }
    /**
     * @param {?} err
     * @param {?} context
     * @return {?}
     */
    function _addDebugContext(err, context) {
        (( /** @type {?} */(err)))[ERROR_DEBUG_CONTEXT] = context;
        (( /** @type {?} */(err)))[ERROR_LOGGER] = context.logError.bind(context);
    }
    /**
     * @param {?} err
     * @return {?}
     */
    function isViewDebugError(err) {
        return !!getDebugContext(err);
    }
    /**
     * @param {?} action
     * @return {?}
     */
    function viewDestroyedError(action) {
        return new Error("ViewDestroyedError: Attempt to use a destroyed view: " + action);
    }
    // Called before each cycle of a view's check to detect whether this is in the
    // initState for which we need to call ngOnInit, ngAfterContentInit or ngAfterViewInit
    // lifecycle methods. Returns true if this check cycle should call lifecycle
    // methods.
    /**
     * @param {?} view
     * @param {?} priorInitState
     * @param {?} newInitState
     * @return {?}
     */
    function shiftInitState(view, priorInitState, newInitState) {
        // Only update the InitState if we are currently in the prior state.
        // For example, only move into CallingInit if we are in BeforeInit. Only
        // move into CallingContentInit if we are in CallingInit. Normally this will
        // always be true because of how checkCycle is called in checkAndUpdateView.
        // However, if checkAndUpdateView is called recursively or if an exception is
        // thrown while checkAndUpdateView is running, checkAndUpdateView starts over
        // from the beginning. This ensures the state is monotonically increasing,
        // terminating in the AfterInit state, which ensures the Init methods are called
        // at least once and only once.
        /** @type {?} */
        var state = view.state;
        /** @type {?} */
        var initState = state & 1792 /* InitState_Mask */;
        if (initState === priorInitState) {
            view.state = (state & ~1792 /* InitState_Mask */) | newInitState;
            view.initIndex = -1;
            return true;
        }
        return initState === newInitState;
    }
    // Returns true if the lifecycle init method should be called for the node with
    // the given init index.
    /**
     * @param {?} view
     * @param {?} initState
     * @param {?} index
     * @return {?}
     */
    function shouldCallLifecycleInitHook(view, initState, index) {
        if ((view.state & 1792 /* InitState_Mask */) === initState && view.initIndex <= index) {
            view.initIndex = index + 1;
            return true;
        }
        return false;
    }
    /**
     * Accessor for view.nodes, enforcing that every usage site stays monomorphic.
     * @param {?} view
     * @param {?} index
     * @return {?}
     */
    function asTextData(view, index) {
        return ( /** @type {?} */(view.nodes[index]));
    }
    /**
     * Accessor for view.nodes, enforcing that every usage site stays monomorphic.
     * @param {?} view
     * @param {?} index
     * @return {?}
     */
    function asElementData(view, index) {
        return ( /** @type {?} */(view.nodes[index]));
    }
    /**
     * Accessor for view.nodes, enforcing that every usage site stays monomorphic.
     * @param {?} view
     * @param {?} index
     * @return {?}
     */
    function asProviderData(view, index) {
        return ( /** @type {?} */(view.nodes[index]));
    }
    /**
     * Accessor for view.nodes, enforcing that every usage site stays monomorphic.
     * @param {?} view
     * @param {?} index
     * @return {?}
     */
    function asPureExpressionData(view, index) {
        return ( /** @type {?} */(view.nodes[index]));
    }
    /**
     * Accessor for view.nodes, enforcing that every usage site stays monomorphic.
     * @param {?} view
     * @param {?} index
     * @return {?}
     */
    function asQueryList(view, index) {
        return ( /** @type {?} */(view.nodes[index]));
    }
    // WARNING: interface has both a type and a value, skipping emit
    /**
     * This object is used to prevent cycles in the source files and to have a place where
     * debug mode can hook it. It is lazily filled when `isDevMode` is known.
     * @type {?}
     */
    var Services = {
        setCurrentNode: ( /** @type {?} */(undefined)),
        createRootView: ( /** @type {?} */(undefined)),
        createEmbeddedView: ( /** @type {?} */(undefined)),
        createComponentView: ( /** @type {?} */(undefined)),
        createNgModuleRef: ( /** @type {?} */(undefined)),
        overrideProvider: ( /** @type {?} */(undefined)),
        overrideComponentView: ( /** @type {?} */(undefined)),
        clearOverrides: ( /** @type {?} */(undefined)),
        checkAndUpdateView: ( /** @type {?} */(undefined)),
        checkNoChangesView: ( /** @type {?} */(undefined)),
        destroyView: ( /** @type {?} */(undefined)),
        resolveDep: ( /** @type {?} */(undefined)),
        createDebugContext: ( /** @type {?} */(undefined)),
        handleEvent: ( /** @type {?} */(undefined)),
        updateDirectives: ( /** @type {?} */(undefined)),
        updateRenderer: ( /** @type {?} */(undefined)),
        dirtyParentQueries: ( /** @type {?} */(undefined)),
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var NOOP = ( /**
     * @return {?}
     */function () { });
    /** @type {?} */
    var _tokenKeyCache = new Map();
    /**
     * @param {?} token
     * @return {?}
     */
    function tokenKey(token) {
        /** @type {?} */
        var key = _tokenKeyCache.get(token);
        if (!key) {
            key = stringify(token) + '_' + _tokenKeyCache.size;
            _tokenKeyCache.set(token, key);
        }
        return key;
    }
    /**
     * @param {?} view
     * @param {?} nodeIdx
     * @param {?} bindingIdx
     * @param {?} value
     * @return {?}
     */
    function unwrapValue(view, nodeIdx, bindingIdx, value) {
        if (WrappedValue.isWrapped(value)) {
            value = WrappedValue.unwrap(value);
            /** @type {?} */
            var globalBindingIdx = view.def.nodes[nodeIdx].bindingIndex + bindingIdx;
            /** @type {?} */
            var oldValue = WrappedValue.unwrap(view.oldValues[globalBindingIdx]);
            view.oldValues[globalBindingIdx] = new WrappedValue(oldValue);
        }
        return value;
    }
    /** @type {?} */
    var UNDEFINED_RENDERER_TYPE_ID = '$$undefined';
    /** @type {?} */
    var EMPTY_RENDERER_TYPE_ID = '$$empty';
    // Attention: this function is called as top level function.
    // Putting any logic in here will destroy closure tree shaking!
    /**
     * @param {?} values
     * @return {?}
     */
    function createRendererType2(values) {
        return {
            id: UNDEFINED_RENDERER_TYPE_ID,
            styles: values.styles,
            encapsulation: values.encapsulation,
            data: values.data
        };
    }
    /** @type {?} */
    var _renderCompCount$1 = 0;
    /**
     * @param {?=} type
     * @return {?}
     */
    function resolveRendererType2(type) {
        if (type && type.id === UNDEFINED_RENDERER_TYPE_ID) {
            // first time we see this RendererType2. Initialize it...
            /** @type {?} */
            var isFilled = ((type.encapsulation != null && type.encapsulation !== ViewEncapsulation.None) ||
                type.styles.length || Object.keys(type.data).length);
            if (isFilled) {
                type.id = "c" + _renderCompCount$1++;
            }
            else {
                type.id = EMPTY_RENDERER_TYPE_ID;
            }
        }
        if (type && type.id === EMPTY_RENDERER_TYPE_ID) {
            type = null;
        }
        return type || null;
    }
    /**
     * @param {?} view
     * @param {?} def
     * @param {?} bindingIdx
     * @param {?} value
     * @return {?}
     */
    function checkBinding(view, def, bindingIdx, value) {
        /** @type {?} */
        var oldValues = view.oldValues;
        if ((view.state & 2 /* FirstCheck */) ||
            !looseIdentical(oldValues[def.bindingIndex + bindingIdx], value)) {
            return true;
        }
        return false;
    }
    /**
     * @param {?} view
     * @param {?} def
     * @param {?} bindingIdx
     * @param {?} value
     * @return {?}
     */
    function checkAndUpdateBinding(view, def, bindingIdx, value) {
        if (checkBinding(view, def, bindingIdx, value)) {
            view.oldValues[def.bindingIndex + bindingIdx] = value;
            return true;
        }
        return false;
    }
    /**
     * @param {?} view
     * @param {?} def
     * @param {?} bindingIdx
     * @param {?} value
     * @return {?}
     */
    function checkBindingNoChanges(view, def, bindingIdx, value) {
        /** @type {?} */
        var oldValue = view.oldValues[def.bindingIndex + bindingIdx];
        if ((view.state & 1 /* BeforeFirstCheck */) || !devModeEqual$1(oldValue, value)) {
            /** @type {?} */
            var bindingName = def.bindings[bindingIdx].name;
            throw expressionChangedAfterItHasBeenCheckedError(Services.createDebugContext(view, def.nodeIndex), bindingName + ": " + oldValue, bindingName + ": " + value, (view.state & 1 /* BeforeFirstCheck */) !== 0);
        }
    }
    /**
     * @param {?} view
     * @return {?}
     */
    function markParentViewsForCheck(view) {
        /** @type {?} */
        var currView = view;
        while (currView) {
            if (currView.def.flags & 2 /* OnPush */) {
                currView.state |= 8 /* ChecksEnabled */;
            }
            currView = currView.viewContainerParent || currView.parent;
        }
    }
    /**
     * @param {?} view
     * @param {?} endView
     * @return {?}
     */
    function markParentViewsForCheckProjectedViews(view, endView) {
        /** @type {?} */
        var currView = view;
        while (currView && currView !== endView) {
            currView.state |= 64 /* CheckProjectedViews */;
            currView = currView.viewContainerParent || currView.parent;
        }
    }
    /**
     * @param {?} view
     * @param {?} nodeIndex
     * @param {?} eventName
     * @param {?} event
     * @return {?}
     */
    function dispatchEvent(view, nodeIndex, eventName, event) {
        try {
            /** @type {?} */
            var nodeDef = view.def.nodes[nodeIndex];
            /** @type {?} */
            var startView = nodeDef.flags & 33554432 /* ComponentView */ ?
                asElementData(view, nodeIndex).componentView :
                view;
            markParentViewsForCheck(startView);
            return Services.handleEvent(view, nodeIndex, eventName, event);
        }
        catch (e) {
            // Attention: Don't rethrow, as it would cancel Observable subscriptions!
            view.root.errorHandler.handleError(e);
        }
    }
    /**
     * @param {?} view
     * @return {?}
     */
    function declaredViewContainer(view) {
        if (view.parent) {
            /** @type {?} */
            var parentView = view.parent;
            return asElementData(parentView, ( /** @type {?} */(view.parentNodeDef)).nodeIndex);
        }
        return null;
    }
    /**
     * for component views, this is the host element.
     * for embedded views, this is the index of the parent node
     * that contains the view container.
     * @param {?} view
     * @return {?}
     */
    function viewParentEl(view) {
        /** @type {?} */
        var parentView = view.parent;
        if (parentView) {
            return ( /** @type {?} */(view.parentNodeDef)).parent;
        }
        else {
            return null;
        }
    }
    /**
     * @param {?} view
     * @param {?} def
     * @return {?}
     */
    function renderNode(view, def) {
        switch (def.flags & 201347067 /* Types */) {
            case 1 /* TypeElement */:
                return asElementData(view, def.nodeIndex).renderElement;
            case 2 /* TypeText */:
                return asTextData(view, def.nodeIndex).renderText;
        }
    }
    /**
     * @param {?} target
     * @param {?} name
     * @return {?}
     */
    function elementEventFullName(target, name) {
        return target ? target + ":" + name : name;
    }
    /**
     * @param {?} view
     * @return {?}
     */
    function isComponentView(view) {
        return !!view.parent && !!(( /** @type {?} */(view.parentNodeDef)).flags & 32768 /* Component */);
    }
    /**
     * @param {?} view
     * @return {?}
     */
    function isEmbeddedView(view) {
        return !!view.parent && !(( /** @type {?} */(view.parentNodeDef)).flags & 32768 /* Component */);
    }
    /**
     * @param {?} queryId
     * @return {?}
     */
    function filterQueryId(queryId) {
        return 1 << (queryId % 32);
    }
    /**
     * @param {?} matchedQueriesDsl
     * @return {?}
     */
    function splitMatchedQueriesDsl(matchedQueriesDsl) {
        /** @type {?} */
        var matchedQueries = {};
        /** @type {?} */
        var matchedQueryIds = 0;
        /** @type {?} */
        var references = {};
        if (matchedQueriesDsl) {
            matchedQueriesDsl.forEach(( /**
             * @param {?} __0
             * @return {?}
             */function (_b) {
                var _c = __read(_b, 2), queryId = _c[0], valueType = _c[1];
                if (typeof queryId === 'number') {
                    matchedQueries[queryId] = valueType;
                    matchedQueryIds |= filterQueryId(queryId);
                }
                else {
                    references[queryId] = valueType;
                }
            }));
        }
        return { matchedQueries: matchedQueries, references: references, matchedQueryIds: matchedQueryIds };
    }
    /**
     * @param {?} deps
     * @param {?=} sourceName
     * @return {?}
     */
    function splitDepsDsl(deps, sourceName) {
        return deps.map(( /**
         * @param {?} value
         * @return {?}
         */function (/**
         * @param {?} value
         * @return {?}
         */ value) {
            var _b;
            /** @type {?} */
            var token;
            /** @type {?} */
            var flags;
            if (Array.isArray(value)) {
                _b = __read(value, 2), flags = _b[0], token = _b[1];
            }
            else {
                flags = 0 /* None */;
                token = value;
            }
            if (token && (typeof token === 'function' || typeof token === 'object') && sourceName) {
                Object.defineProperty(token, SOURCE, { value: sourceName, configurable: true });
            }
            return { flags: flags, token: token, tokenKey: tokenKey(token) };
        }));
    }
    /**
     * @param {?} view
     * @param {?} renderHost
     * @param {?} def
     * @return {?}
     */
    function getParentRenderElement(view, renderHost, def) {
        /** @type {?} */
        var renderParent = def.renderParent;
        if (renderParent) {
            if ((renderParent.flags & 1 /* TypeElement */) === 0 ||
                (renderParent.flags & 33554432 /* ComponentView */) === 0 ||
                (( /** @type {?} */(renderParent.element)).componentRendererType &&
                    ( /** @type {?} */(( /** @type {?} */(renderParent.element)).componentRendererType)).encapsulation ===
                        ViewEncapsulation.Native)) {
                // only children of non components, or children of components with native encapsulation should
                // be attached.
                return asElementData(view, ( /** @type {?} */(def.renderParent)).nodeIndex).renderElement;
            }
        }
        else {
            return renderHost;
        }
    }
    /** @type {?} */
    var DEFINITION_CACHE = new WeakMap();
    /**
     * @template D
     * @param {?} factory
     * @return {?}
     */
    function resolveDefinition(factory) {
        /** @type {?} */
        var value = ( /** @type {?} */(( /** @type {?} */(DEFINITION_CACHE.get(factory)))));
        if (!value) {
            value = factory(( /**
             * @return {?}
             */function () { return NOOP; }));
            value.factory = factory;
            DEFINITION_CACHE.set(factory, value);
        }
        return value;
    }
    /**
     * @param {?} view
     * @return {?}
     */
    function rootRenderNodes(view) {
        /** @type {?} */
        var renderNodes = [];
        visitRootRenderNodes(view, 0 /* Collect */, undefined, undefined, renderNodes);
        return renderNodes;
    }
    /**
     * @param {?} view
     * @param {?} action
     * @param {?} parentNode
     * @param {?} nextSibling
     * @param {?=} target
     * @return {?}
     */
    function visitRootRenderNodes(view, action, parentNode, nextSibling, target) {
        // We need to re-compute the parent node in case the nodes have been moved around manually
        if (action === 3 /* RemoveChild */) {
            parentNode = view.renderer.parentNode(renderNode(view, ( /** @type {?} */(view.def.lastRenderRootNode))));
        }
        visitSiblingRenderNodes(view, action, 0, view.def.nodes.length - 1, parentNode, nextSibling, target);
    }
    /**
     * @param {?} view
     * @param {?} action
     * @param {?} startIndex
     * @param {?} endIndex
     * @param {?} parentNode
     * @param {?} nextSibling
     * @param {?=} target
     * @return {?}
     */
    function visitSiblingRenderNodes(view, action, startIndex, endIndex, parentNode, nextSibling, target) {
        for (var i_57 = startIndex; i_57 <= endIndex; i_57++) {
            /** @type {?} */
            var nodeDef = view.def.nodes[i_57];
            if (nodeDef.flags & (1 /* TypeElement */ | 2 /* TypeText */ | 8 /* TypeNgContent */)) {
                visitRenderNode(view, nodeDef, action, parentNode, nextSibling, target);
            }
            // jump to next sibling
            i_57 += nodeDef.childCount;
        }
    }
    /**
     * @param {?} view
     * @param {?} ngContentIndex
     * @param {?} action
     * @param {?} parentNode
     * @param {?} nextSibling
     * @param {?=} target
     * @return {?}
     */
    function visitProjectedRenderNodes(view, ngContentIndex, action, parentNode, nextSibling, target) {
        /** @type {?} */
        var compView = view;
        while (compView && !isComponentView(compView)) {
            compView = compView.parent;
        }
        /** @type {?} */
        var hostView = ( /** @type {?} */(compView)).parent;
        /** @type {?} */
        var hostElDef = viewParentEl(( /** @type {?} */(compView)));
        /** @type {?} */
        var startIndex = ( /** @type {?} */(hostElDef)).nodeIndex + 1;
        /** @type {?} */
        var endIndex = ( /** @type {?} */(hostElDef)).nodeIndex + ( /** @type {?} */(hostElDef)).childCount;
        for (var i_58 = startIndex; i_58 <= endIndex; i_58++) {
            /** @type {?} */
            var nodeDef = ( /** @type {?} */(hostView)).def.nodes[i_58];
            if (nodeDef.ngContentIndex === ngContentIndex) {
                visitRenderNode(( /** @type {?} */(hostView)), nodeDef, action, parentNode, nextSibling, target);
            }
            // jump to next sibling
            i_58 += nodeDef.childCount;
        }
        if (!( /** @type {?} */(hostView)).parent) {
            // a root view
            /** @type {?} */
            var projectedNodes = view.root.projectableNodes[ngContentIndex];
            if (projectedNodes) {
                for (var i_59 = 0; i_59 < projectedNodes.length; i_59++) {
                    execRenderNodeAction(view, projectedNodes[i_59], action, parentNode, nextSibling, target);
                }
            }
        }
    }
    /**
     * @param {?} view
     * @param {?} nodeDef
     * @param {?} action
     * @param {?} parentNode
     * @param {?} nextSibling
     * @param {?=} target
     * @return {?}
     */
    function visitRenderNode(view, nodeDef, action, parentNode, nextSibling, target) {
        if (nodeDef.flags & 8 /* TypeNgContent */) {
            visitProjectedRenderNodes(view, ( /** @type {?} */(nodeDef.ngContent)).index, action, parentNode, nextSibling, target);
        }
        else {
            /** @type {?} */
            var rn = renderNode(view, nodeDef);
            if (action === 3 /* RemoveChild */ && (nodeDef.flags & 33554432 /* ComponentView */) &&
                (nodeDef.bindingFlags & 48 /* CatSyntheticProperty */)) {
                // Note: we might need to do both actions.
                if (nodeDef.bindingFlags & (16 /* SyntheticProperty */)) {
                    execRenderNodeAction(view, rn, action, parentNode, nextSibling, target);
                }
                if (nodeDef.bindingFlags & (32 /* SyntheticHostProperty */)) {
                    /** @type {?} */
                    var compView = asElementData(view, nodeDef.nodeIndex).componentView;
                    execRenderNodeAction(compView, rn, action, parentNode, nextSibling, target);
                }
            }
            else {
                execRenderNodeAction(view, rn, action, parentNode, nextSibling, target);
            }
            if (nodeDef.flags & 16777216 /* EmbeddedViews */) {
                /** @type {?} */
                var embeddedViews = ( /** @type {?} */(asElementData(view, nodeDef.nodeIndex).viewContainer))._embeddedViews;
                for (var k = 0; k < embeddedViews.length; k++) {
                    visitRootRenderNodes(embeddedViews[k], action, parentNode, nextSibling, target);
                }
            }
            if (nodeDef.flags & 1 /* TypeElement */ && !( /** @type {?} */(nodeDef.element)).name) {
                visitSiblingRenderNodes(view, action, nodeDef.nodeIndex + 1, nodeDef.nodeIndex + nodeDef.childCount, parentNode, nextSibling, target);
            }
        }
    }
    /**
     * @param {?} view
     * @param {?} renderNode
     * @param {?} action
     * @param {?} parentNode
     * @param {?} nextSibling
     * @param {?=} target
     * @return {?}
     */
    function execRenderNodeAction(view, renderNode, action, parentNode, nextSibling, target) {
        /** @type {?} */
        var renderer = view.renderer;
        switch (action) {
            case 1 /* AppendChild */:
                renderer.appendChild(parentNode, renderNode);
                break;
            case 2 /* InsertBefore */:
                renderer.insertBefore(parentNode, renderNode, nextSibling);
                break;
            case 3 /* RemoveChild */:
                renderer.removeChild(parentNode, renderNode);
                break;
            case 0 /* Collect */:
                ( /** @type {?} */(target)).push(renderNode);
                break;
        }
    }
    /** @type {?} */
    var NS_PREFIX_RE = /^:([^:]+):(.+)$/;
    /**
     * @param {?} name
     * @return {?}
     */
    function splitNamespace(name) {
        if (name[0] === ':') {
            /** @type {?} */
            var match_1 = ( /** @type {?} */(name.match(NS_PREFIX_RE)));
            return [match_1[1], match_1[2]];
        }
        return ['', name];
    }
    /**
     * @param {?} bindings
     * @return {?}
     */
    function calcBindingFlags(bindings) {
        /** @type {?} */
        var flags = 0;
        for (var i_60 = 0; i_60 < bindings.length; i_60++) {
            flags |= bindings[i_60].flags;
        }
        return flags;
    }
    /**
     * @param {?} valueCount
     * @param {?} c0
     * @param {?} a1
     * @param {?} c1
     * @param {?=} a2
     * @param {?=} c2
     * @param {?=} a3
     * @param {?=} c3
     * @param {?=} a4
     * @param {?=} c4
     * @param {?=} a5
     * @param {?=} c5
     * @param {?=} a6
     * @param {?=} c6
     * @param {?=} a7
     * @param {?=} c7
     * @param {?=} a8
     * @param {?=} c8
     * @param {?=} a9
     * @param {?=} c9
     * @return {?}
     */
    function inlineInterpolate(valueCount, c0, a1, c1, a2, c2, a3, c3, a4, c4, a5, c5, a6, c6, a7, c7, a8, c8, a9, c9) {
        switch (valueCount) {
            case 1:
                return c0 + _toStringWithNull(a1) + c1;
            case 2:
                return c0 + _toStringWithNull(a1) + c1 + _toStringWithNull(a2) + c2;
            case 3:
                return c0 + _toStringWithNull(a1) + c1 + _toStringWithNull(a2) + c2 + _toStringWithNull(a3) +
                    c3;
            case 4:
                return c0 + _toStringWithNull(a1) + c1 + _toStringWithNull(a2) + c2 + _toStringWithNull(a3) +
                    c3 + _toStringWithNull(a4) + c4;
            case 5:
                return c0 + _toStringWithNull(a1) + c1 + _toStringWithNull(a2) + c2 + _toStringWithNull(a3) +
                    c3 + _toStringWithNull(a4) + c4 + _toStringWithNull(a5) + c5;
            case 6:
                return c0 + _toStringWithNull(a1) + c1 + _toStringWithNull(a2) + c2 + _toStringWithNull(a3) +
                    c3 + _toStringWithNull(a4) + c4 + _toStringWithNull(a5) + c5 + _toStringWithNull(a6) + c6;
            case 7:
                return c0 + _toStringWithNull(a1) + c1 + _toStringWithNull(a2) + c2 + _toStringWithNull(a3) +
                    c3 + _toStringWithNull(a4) + c4 + _toStringWithNull(a5) + c5 + _toStringWithNull(a6) +
                    c6 + _toStringWithNull(a7) + c7;
            case 8:
                return c0 + _toStringWithNull(a1) + c1 + _toStringWithNull(a2) + c2 + _toStringWithNull(a3) +
                    c3 + _toStringWithNull(a4) + c4 + _toStringWithNull(a5) + c5 + _toStringWithNull(a6) +
                    c6 + _toStringWithNull(a7) + c7 + _toStringWithNull(a8) + c8;
            case 9:
                return c0 + _toStringWithNull(a1) + c1 + _toStringWithNull(a2) + c2 + _toStringWithNull(a3) +
                    c3 + _toStringWithNull(a4) + c4 + _toStringWithNull(a5) + c5 + _toStringWithNull(a6) +
                    c6 + _toStringWithNull(a7) + c7 + _toStringWithNull(a8) + c8 + _toStringWithNull(a9) + c9;
            default:
                throw new Error("Does not support more than 9 expressions");
        }
    }
    /**
     * @param {?} v
     * @return {?}
     */
    function _toStringWithNull(v) {
        return v != null ? v.toString() : '';
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var UNDEFINED_VALUE = new Object();
    /** @type {?} */
    var InjectorRefTokenKey = tokenKey(Injector);
    /** @type {?} */
    var INJECTORRefTokenKey = tokenKey(INJECTOR);
    /** @type {?} */
    var NgModuleRefTokenKey = tokenKey(NgModuleRef);
    /**
     * @param {?} flags
     * @param {?} token
     * @param {?} value
     * @param {?} deps
     * @return {?}
     */
    function moduleProvideDef(flags, token, value, deps) {
        // Need to resolve forwardRefs as e.g. for `useValue` we
        // lowered the expression and then stopped evaluating it,
        // i.e. also didn't unwrap it.
        value = resolveForwardRef(value);
        /** @type {?} */
        var depDefs = splitDepsDsl(deps, stringify(token));
        return {
            // will bet set by the module definition
            index: -1,
            deps: depDefs, flags: flags, token: token, value: value
        };
    }
    /**
     * @param {?} providers
     * @return {?}
     */
    function moduleDef(providers) {
        /** @type {?} */
        var providersByKey = {};
        /** @type {?} */
        var modules = [];
        /** @type {?} */
        var isRoot = false;
        for (var i_61 = 0; i_61 < providers.length; i_61++) {
            /** @type {?} */
            var provider = providers[i_61];
            if (provider.token === APP_ROOT && provider.value === true) {
                isRoot = true;
            }
            if (provider.flags & 1073741824 /* TypeNgModule */) {
                modules.push(provider.token);
            }
            provider.index = i_61;
            providersByKey[tokenKey(provider.token)] = provider;
        }
        return {
            // Will be filled later...
            factory: null,
            providersByKey: providersByKey,
            providers: providers,
            modules: modules,
            isRoot: isRoot,
        };
    }
    /**
     * @param {?} data
     * @return {?}
     */
    function initNgModule(data) {
        /** @type {?} */
        var def = data._def;
        /** @type {?} */
        var providers = data._providers = new Array(def.providers.length);
        for (var i_62 = 0; i_62 < def.providers.length; i_62++) {
            /** @type {?} */
            var provDef = def.providers[i_62];
            if (!(provDef.flags & 4096 /* LazyProvider */)) {
                // Make sure the provider has not been already initialized outside this loop.
                if (providers[i_62] === undefined) {
                    providers[i_62] = _createProviderInstance(data, provDef);
                }
            }
        }
    }
    /**
     * @param {?} data
     * @param {?} depDef
     * @param {?=} notFoundValue
     * @return {?}
     */
    function resolveNgModuleDep(data, depDef, notFoundValue) {
        if (notFoundValue === void 0) { notFoundValue = Injector.THROW_IF_NOT_FOUND; }
        /** @type {?} */
        var former = setCurrentInjector(data);
        try {
            if (depDef.flags & 8 /* Value */) {
                return depDef.token;
            }
            if (depDef.flags & 2 /* Optional */) {
                notFoundValue = null;
            }
            if (depDef.flags & 1 /* SkipSelf */) {
                return data._parent.get(depDef.token, notFoundValue);
            }
            /** @type {?} */
            var tokenKey_1 = depDef.tokenKey;
            switch (tokenKey_1) {
                case InjectorRefTokenKey:
                case INJECTORRefTokenKey:
                case NgModuleRefTokenKey:
                    return data;
            }
            /** @type {?} */
            var providerDef_1 = data._def.providersByKey[tokenKey_1];
            /** @type {?} */
            var injectableDef = void 0;
            if (providerDef_1) {
                /** @type {?} */
                var providerInstance = data._providers[providerDef_1.index];
                if (providerInstance === undefined) {
                    providerInstance = data._providers[providerDef_1.index] =
                        _createProviderInstance(data, providerDef_1);
                }
                return providerInstance === UNDEFINED_VALUE ? undefined : providerInstance;
            }
            else if ((injectableDef = getInjectableDef(depDef.token)) && targetsModule(data, injectableDef)) {
                /** @type {?} */
                var index = data._providers.length;
                data._def.providers[index] = data._def.providersByKey[depDef.tokenKey] = {
                    flags: 1024 /* TypeFactoryProvider */ | 4096 /* LazyProvider */,
                    value: injectableDef.factory,
                    deps: [], index: index,
                    token: depDef.token,
                };
                data._providers[index] = UNDEFINED_VALUE;
                return (data._providers[index] =
                    _createProviderInstance(data, data._def.providersByKey[depDef.tokenKey]));
            }
            else if (depDef.flags & 4 /* Self */) {
                return notFoundValue;
            }
            return data._parent.get(depDef.token, notFoundValue);
        }
        finally {
            setCurrentInjector(former);
        }
    }
    /**
     * @param {?} ngModule
     * @param {?} scope
     * @return {?}
     */
    function moduleTransitivelyPresent(ngModule, scope) {
        return ngModule._def.modules.indexOf(scope) > -1;
    }
    /**
     * @param {?} ngModule
     * @param {?} def
     * @return {?}
     */
    function targetsModule(ngModule, def) {
        return def.providedIn != null && (moduleTransitivelyPresent(ngModule, def.providedIn) ||
            def.providedIn === 'root' && ngModule._def.isRoot);
    }
    /**
     * @param {?} ngModule
     * @param {?} providerDef
     * @return {?}
     */
    function _createProviderInstance(ngModule, providerDef) {
        /** @type {?} */
        var injectable;
        switch (providerDef.flags & 201347067 /* Types */) {
            case 512 /* TypeClassProvider */:
                injectable = _createClass(ngModule, providerDef.value, providerDef.deps);
                break;
            case 1024 /* TypeFactoryProvider */:
                injectable = _callFactory(ngModule, providerDef.value, providerDef.deps);
                break;
            case 2048 /* TypeUseExistingProvider */:
                injectable = resolveNgModuleDep(ngModule, providerDef.deps[0]);
                break;
            case 256 /* TypeValueProvider */:
                injectable = providerDef.value;
                break;
        }
        // The read of `ngOnDestroy` here is slightly expensive as it's megamorphic, so it should be
        // avoided if possible. The sequence of checks here determines whether ngOnDestroy needs to be
        // checked. It might not if the `injectable` isn't an object or if NodeFlags.OnDestroy is already
        // set (ngOnDestroy was detected statically).
        if (injectable !== UNDEFINED_VALUE && injectable !== null && typeof injectable === 'object' &&
            !(providerDef.flags & 131072 /* OnDestroy */) && typeof injectable.ngOnDestroy === 'function') {
            providerDef.flags |= 131072 /* OnDestroy */;
        }
        return injectable === undefined ? UNDEFINED_VALUE : injectable;
    }
    /**
     * @param {?} ngModule
     * @param {?} ctor
     * @param {?} deps
     * @return {?}
     */
    function _createClass(ngModule, ctor, deps) {
        /** @type {?} */
        var len = deps.length;
        switch (len) {
            case 0:
                return new ctor();
            case 1:
                return new ctor(resolveNgModuleDep(ngModule, deps[0]));
            case 2:
                return new ctor(resolveNgModuleDep(ngModule, deps[0]), resolveNgModuleDep(ngModule, deps[1]));
            case 3:
                return new ctor(resolveNgModuleDep(ngModule, deps[0]), resolveNgModuleDep(ngModule, deps[1]), resolveNgModuleDep(ngModule, deps[2]));
            default:
                /** @type {?} */
                var depValues = new Array(len);
                for (var i_63 = 0; i_63 < len; i_63++) {
                    depValues[i_63] = resolveNgModuleDep(ngModule, deps[i_63]);
                }
                return new (ctor.bind.apply(ctor, __spread([void 0], depValues)))();
        }
    }
    /**
     * @param {?} ngModule
     * @param {?} factory
     * @param {?} deps
     * @return {?}
     */
    function _callFactory(ngModule, factory, deps) {
        /** @type {?} */
        var len = deps.length;
        switch (len) {
            case 0:
                return factory();
            case 1:
                return factory(resolveNgModuleDep(ngModule, deps[0]));
            case 2:
                return factory(resolveNgModuleDep(ngModule, deps[0]), resolveNgModuleDep(ngModule, deps[1]));
            case 3:
                return factory(resolveNgModuleDep(ngModule, deps[0]), resolveNgModuleDep(ngModule, deps[1]), resolveNgModuleDep(ngModule, deps[2]));
            default:
                /** @type {?} */
                var depValues = Array(len);
                for (var i_64 = 0; i_64 < len; i_64++) {
                    depValues[i_64] = resolveNgModuleDep(ngModule, deps[i_64]);
                }
                return factory.apply(void 0, __spread(depValues));
        }
    }
    /**
     * @param {?} ngModule
     * @param {?} lifecycles
     * @return {?}
     */
    function callNgModuleLifecycle(ngModule, lifecycles) {
        /** @type {?} */
        var def = ngModule._def;
        /** @type {?} */
        var destroyed = new Set();
        for (var i_65 = 0; i_65 < def.providers.length; i_65++) {
            /** @type {?} */
            var provDef = def.providers[i_65];
            if (provDef.flags & 131072 /* OnDestroy */) {
                /** @type {?} */
                var instance = ngModule._providers[i_65];
                if (instance && instance !== UNDEFINED_VALUE) {
                    /** @type {?} */
                    var onDestroy = instance.ngOnDestroy;
                    if (typeof onDestroy === 'function' && !destroyed.has(instance)) {
                        onDestroy.apply(instance);
                        destroyed.add(instance);
                    }
                }
            }
        }
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} parentView
     * @param {?} elementData
     * @param {?} viewIndex
     * @param {?} view
     * @return {?}
     */
    function attachEmbeddedView(parentView, elementData, viewIndex, view) {
        /** @type {?} */
        var embeddedViews = ( /** @type {?} */(elementData.viewContainer))._embeddedViews;
        if (viewIndex === null || viewIndex === undefined) {
            viewIndex = embeddedViews.length;
        }
        view.viewContainerParent = parentView;
        addToArray(embeddedViews, ( /** @type {?} */(viewIndex)), view);
        attachProjectedView(elementData, view);
        Services.dirtyParentQueries(view);
        /** @type {?} */
        var prevView = ( /** @type {?} */(viewIndex)) > 0 ? embeddedViews[( /** @type {?} */(viewIndex)) - 1] : null;
        renderAttachEmbeddedView(elementData, prevView, view);
    }
    /**
     * @param {?} vcElementData
     * @param {?} view
     * @return {?}
     */
    function attachProjectedView(vcElementData, view) {
        /** @type {?} */
        var dvcElementData = declaredViewContainer(view);
        if (!dvcElementData || dvcElementData === vcElementData ||
            view.state & 16 /* IsProjectedView */) {
            return;
        }
        // Note: For performance reasons, we
        // - add a view to template._projectedViews only 1x throughout its lifetime,
        //   and remove it not until the view is destroyed.
        //   (hard, as when a parent view is attached/detached we would need to attach/detach all
        //    nested projected views as well, even across component boundaries).
        // - don't track the insertion order of views in the projected views array
        //   (hard, as when the views of the same template are inserted different view containers)
        view.state |= 16 /* IsProjectedView */;
        /** @type {?} */
        var projectedViews = dvcElementData.template._projectedViews;
        if (!projectedViews) {
            projectedViews = dvcElementData.template._projectedViews = [];
        }
        projectedViews.push(view);
        // Note: we are changing the NodeDef here as we cannot calculate
        // the fact whether a template is used for projection during compilation.
        markNodeAsProjectedTemplate(( /** @type {?} */(view.parent)).def, ( /** @type {?} */(view.parentNodeDef)));
    }
    /**
     * @param {?} viewDef
     * @param {?} nodeDef
     * @return {?}
     */
    function markNodeAsProjectedTemplate(viewDef, nodeDef) {
        if (nodeDef.flags & 4 /* ProjectedTemplate */) {
            return;
        }
        viewDef.nodeFlags |= 4 /* ProjectedTemplate */;
        nodeDef.flags |= 4 /* ProjectedTemplate */;
        /** @type {?} */
        var parentNodeDef = nodeDef.parent;
        while (parentNodeDef) {
            parentNodeDef.childFlags |= 4 /* ProjectedTemplate */;
            parentNodeDef = parentNodeDef.parent;
        }
    }
    /**
     * @param {?} elementData
     * @param {?=} viewIndex
     * @return {?}
     */
    function detachEmbeddedView(elementData, viewIndex) {
        /** @type {?} */
        var embeddedViews = ( /** @type {?} */(elementData.viewContainer))._embeddedViews;
        if (viewIndex == null || viewIndex >= embeddedViews.length) {
            viewIndex = embeddedViews.length - 1;
        }
        if (viewIndex < 0) {
            return null;
        }
        /** @type {?} */
        var view = embeddedViews[viewIndex];
        view.viewContainerParent = null;
        removeFromArray(embeddedViews, viewIndex);
        // See attachProjectedView for why we don't update projectedViews here.
        Services.dirtyParentQueries(view);
        renderDetachView$1(view);
        return view;
    }
    /**
     * @param {?} view
     * @return {?}
     */
    function detachProjectedView(view) {
        if (!(view.state & 16 /* IsProjectedView */)) {
            return;
        }
        /** @type {?} */
        var dvcElementData = declaredViewContainer(view);
        if (dvcElementData) {
            /** @type {?} */
            var projectedViews = dvcElementData.template._projectedViews;
            if (projectedViews) {
                removeFromArray(projectedViews, projectedViews.indexOf(view));
                Services.dirtyParentQueries(view);
            }
        }
    }
    /**
     * @param {?} elementData
     * @param {?} oldViewIndex
     * @param {?} newViewIndex
     * @return {?}
     */
    function moveEmbeddedView(elementData, oldViewIndex, newViewIndex) {
        /** @type {?} */
        var embeddedViews = ( /** @type {?} */(elementData.viewContainer))._embeddedViews;
        /** @type {?} */
        var view = embeddedViews[oldViewIndex];
        removeFromArray(embeddedViews, oldViewIndex);
        if (newViewIndex == null) {
            newViewIndex = embeddedViews.length;
        }
        addToArray(embeddedViews, newViewIndex, view);
        // Note: Don't need to change projectedViews as the order in there
        // as always invalid...
        Services.dirtyParentQueries(view);
        renderDetachView$1(view);
        /** @type {?} */
        var prevView = newViewIndex > 0 ? embeddedViews[newViewIndex - 1] : null;
        renderAttachEmbeddedView(elementData, prevView, view);
        return view;
    }
    /**
     * @param {?} elementData
     * @param {?} prevView
     * @param {?} view
     * @return {?}
     */
    function renderAttachEmbeddedView(elementData, prevView, view) {
        /** @type {?} */
        var prevRenderNode = prevView ? renderNode(prevView, ( /** @type {?} */(prevView.def.lastRenderRootNode))) :
            elementData.renderElement;
        /** @type {?} */
        var parentNode = view.renderer.parentNode(prevRenderNode);
        /** @type {?} */
        var nextSibling = view.renderer.nextSibling(prevRenderNode);
        // Note: We can't check if `nextSibling` is present, as on WebWorkers it will always be!
        // However, browsers automatically do `appendChild` when there is no `nextSibling`.
        visitRootRenderNodes(view, 2 /* InsertBefore */, parentNode, nextSibling, undefined);
    }
    /**
     * @param {?} view
     * @return {?}
     */
    function renderDetachView$1(view) {
        visitRootRenderNodes(view, 3 /* RemoveChild */, null, null, undefined);
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var EMPTY_CONTEXT = new Object();
    // Attention: this function is called as top level function.
    // Putting any logic in here will destroy closure tree shaking!
    /**
     * @param {?} selector
     * @param {?} componentType
     * @param {?} viewDefFactory
     * @param {?} inputs
     * @param {?} outputs
     * @param {?} ngContentSelectors
     * @return {?}
     */
    function createComponentFactory(selector, componentType, viewDefFactory, inputs, outputs, ngContentSelectors) {
        return new ComponentFactory_(selector, componentType, viewDefFactory, inputs, outputs, ngContentSelectors);
    }
    /**
     * @param {?} componentFactory
     * @return {?}
     */
    function getComponentViewDefinitionFactory(componentFactory) {
        return (( /** @type {?} */(componentFactory))).viewDefFactory;
    }
    var ComponentFactory_ = /** @class */ (function (_super) {
        __extends(ComponentFactory_, _super);
        /**
         * @param {?} selector
         * @param {?} componentType
         * @param {?} viewDefFactory
         * @param {?} _inputs
         * @param {?} _outputs
         * @param {?} ngContentSelectors
         */
        function ComponentFactory_(selector, componentType, viewDefFactory, _inputs, _outputs, ngContentSelectors) {
            var _this = 
            // Attention: this ctor is called as top level function.
            // Putting any logic in here will destroy closure tree shaking!
            _super.call(this) || this;
            _this.selector = selector;
            _this.componentType = componentType;
            _this._inputs = _inputs;
            _this._outputs = _outputs;
            _this.ngContentSelectors = ngContentSelectors;
            _this.viewDefFactory = viewDefFactory;
            return _this;
        }
        Object.defineProperty(ComponentFactory_.prototype, "inputs", {
            /**
             * @return {?}
             */
            get: function () {
                /** @type {?} */
                var inputsArr = [];
                /** @type {?} */
                var inputs = ( /** @type {?} */(this._inputs));
                for (var propName in inputs) {
                    /** @type {?} */
                    var templateName = inputs[propName];
                    inputsArr.push({ propName: propName, templateName: templateName });
                }
                return inputsArr;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ComponentFactory_.prototype, "outputs", {
            /**
             * @return {?}
             */
            get: function () {
                /** @type {?} */
                var outputsArr = [];
                for (var propName in this._outputs) {
                    /** @type {?} */
                    var templateName = this._outputs[propName];
                    outputsArr.push({ propName: propName, templateName: templateName });
                }
                return outputsArr;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Creates a new component.
         * @param {?} injector
         * @param {?=} projectableNodes
         * @param {?=} rootSelectorOrNode
         * @param {?=} ngModule
         * @return {?}
         */
        ComponentFactory_.prototype.create = function (injector, projectableNodes, rootSelectorOrNode, ngModule) {
            if (!ngModule) {
                throw new Error('ngModule should be provided');
            }
            /** @type {?} */
            var viewDef = resolveDefinition(this.viewDefFactory);
            /** @type {?} */
            var componentNodeIndex = ( /** @type {?} */(( /** @type {?} */(viewDef.nodes[0].element)).componentProvider)).nodeIndex;
            /** @type {?} */
            var view = Services.createRootView(injector, projectableNodes || [], rootSelectorOrNode, viewDef, ngModule, EMPTY_CONTEXT);
            /** @type {?} */
            var component = asProviderData(view, componentNodeIndex).instance;
            if (rootSelectorOrNode) {
                view.renderer.setAttribute(asElementData(view, 0).renderElement, 'ng-version', VERSION.full);
            }
            return new ComponentRef_(view, new ViewRef_(view), component);
        };
        return ComponentFactory_;
    }(ComponentFactory));
    var ComponentRef_ = /** @class */ (function (_super) {
        __extends(ComponentRef_, _super);
        /**
         * @param {?} _view
         * @param {?} _viewRef
         * @param {?} _component
         */
        function ComponentRef_(_view, _viewRef, _component) {
            var _this = _super.call(this) || this;
            _this._view = _view;
            _this._viewRef = _viewRef;
            _this._component = _component;
            _this._elDef = _this._view.def.nodes[0];
            _this.hostView = _viewRef;
            _this.changeDetectorRef = _viewRef;
            _this.instance = _component;
            return _this;
        }
        Object.defineProperty(ComponentRef_.prototype, "location", {
            /**
             * @return {?}
             */
            get: function () {
                return new ElementRef(asElementData(this._view, this._elDef.nodeIndex).renderElement);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ComponentRef_.prototype, "injector", {
            /**
             * @return {?}
             */
            get: function () { return new Injector_(this._view, this._elDef); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ComponentRef_.prototype, "componentType", {
            /**
             * @return {?}
             */
            get: function () { return ( /** @type {?} */(this._component.constructor)); },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        ComponentRef_.prototype.destroy = function () { this._viewRef.destroy(); };
        /**
         * @param {?} callback
         * @return {?}
         */
        ComponentRef_.prototype.onDestroy = function (callback) { this._viewRef.onDestroy(callback); };
        return ComponentRef_;
    }(ComponentRef));
    /**
     * @param {?} view
     * @param {?} elDef
     * @param {?} elData
     * @return {?}
     */
    function createViewContainerData(view, elDef, elData) {
        return new ViewContainerRef_(view, elDef, elData);
    }
    var ViewContainerRef_ = /** @class */ (function () {
        /**
         * @param {?} _view
         * @param {?} _elDef
         * @param {?} _data
         */
        function ViewContainerRef_(_view, _elDef, _data) {
            this._view = _view;
            this._elDef = _elDef;
            this._data = _data;
            /**
             * \@internal
             */
            this._embeddedViews = [];
        }
        Object.defineProperty(ViewContainerRef_.prototype, "element", {
            /**
             * @return {?}
             */
            get: function () { return new ElementRef(this._data.renderElement); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ViewContainerRef_.prototype, "injector", {
            /**
             * @return {?}
             */
            get: function () { return new Injector_(this._view, this._elDef); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ViewContainerRef_.prototype, "parentInjector", {
            /**
             * @deprecated No replacement
             * @return {?}
             */
            get: function () {
                /** @type {?} */
                var view = this._view;
                /** @type {?} */
                var elDef = this._elDef.parent;
                while (!elDef && view) {
                    elDef = viewParentEl(view);
                    view = ( /** @type {?} */(view.parent));
                }
                return view ? new Injector_(view, elDef) : new Injector_(this._view, null);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        ViewContainerRef_.prototype.clear = function () {
            /** @type {?} */
            var len = this._embeddedViews.length;
            for (var i_66 = len - 1; i_66 >= 0; i_66--) {
                /** @type {?} */
                var view = ( /** @type {?} */(detachEmbeddedView(this._data, i_66)));
                Services.destroyView(view);
            }
        };
        /**
         * @param {?} index
         * @return {?}
         */
        ViewContainerRef_.prototype.get = function (index) {
            /** @type {?} */
            var view = this._embeddedViews[index];
            if (view) {
                /** @type {?} */
                var ref = new ViewRef_(view);
                ref.attachToViewContainerRef(this);
                return ref;
            }
            return null;
        };
        Object.defineProperty(ViewContainerRef_.prototype, "length", {
            /**
             * @return {?}
             */
            get: function () { return this._embeddedViews.length; },
            enumerable: true,
            configurable: true
        });
        /**
         * @template C
         * @param {?} templateRef
         * @param {?=} context
         * @param {?=} index
         * @return {?}
         */
        ViewContainerRef_.prototype.createEmbeddedView = function (templateRef, context, index) {
            /** @type {?} */
            var viewRef = templateRef.createEmbeddedView(context || ( /** @type {?} */({})));
            this.insert(viewRef, index);
            return viewRef;
        };
        /**
         * @template C
         * @param {?} componentFactory
         * @param {?=} index
         * @param {?=} injector
         * @param {?=} projectableNodes
         * @param {?=} ngModuleRef
         * @return {?}
         */
        ViewContainerRef_.prototype.createComponent = function (componentFactory, index, injector, projectableNodes, ngModuleRef) {
            /** @type {?} */
            var contextInjector = injector || this.parentInjector;
            if (!ngModuleRef && !(componentFactory instanceof ComponentFactoryBoundToModule)) {
                ngModuleRef = contextInjector.get(NgModuleRef);
            }
            /** @type {?} */
            var componentRef = componentFactory.create(contextInjector, projectableNodes, undefined, ngModuleRef);
            this.insert(componentRef.hostView, index);
            return componentRef;
        };
        /**
         * @param {?} viewRef
         * @param {?=} index
         * @return {?}
         */
        ViewContainerRef_.prototype.insert = function (viewRef, index) {
            if (viewRef.destroyed) {
                throw new Error('Cannot insert a destroyed View in a ViewContainer!');
            }
            /** @type {?} */
            var viewRef_ = ( /** @type {?} */(viewRef));
            /** @type {?} */
            var viewData = viewRef_._view;
            attachEmbeddedView(this._view, this._data, index, viewData);
            viewRef_.attachToViewContainerRef(this);
            return viewRef;
        };
        /**
         * @param {?} viewRef
         * @param {?} currentIndex
         * @return {?}
         */
        ViewContainerRef_.prototype.move = function (viewRef, currentIndex) {
            if (viewRef.destroyed) {
                throw new Error('Cannot move a destroyed View in a ViewContainer!');
            }
            /** @type {?} */
            var previousIndex = this._embeddedViews.indexOf(viewRef._view);
            moveEmbeddedView(this._data, previousIndex, currentIndex);
            return viewRef;
        };
        /**
         * @param {?} viewRef
         * @return {?}
         */
        ViewContainerRef_.prototype.indexOf = function (viewRef) {
            return this._embeddedViews.indexOf((( /** @type {?} */(viewRef)))._view);
        };
        /**
         * @param {?=} index
         * @return {?}
         */
        ViewContainerRef_.prototype.remove = function (index) {
            /** @type {?} */
            var viewData = detachEmbeddedView(this._data, index);
            if (viewData) {
                Services.destroyView(viewData);
            }
        };
        /**
         * @param {?=} index
         * @return {?}
         */
        ViewContainerRef_.prototype.detach = function (index) {
            /** @type {?} */
            var view = detachEmbeddedView(this._data, index);
            return view ? new ViewRef_(view) : null;
        };
        return ViewContainerRef_;
    }());
    /**
     * @param {?} view
     * @return {?}
     */
    function createChangeDetectorRef(view) {
        return new ViewRef_(view);
    }
    var ViewRef_ = /** @class */ (function () {
        /**
         * @param {?} _view
         */
        function ViewRef_(_view) {
            this._view = _view;
            this._viewContainerRef = null;
            this._appRef = null;
        }
        Object.defineProperty(ViewRef_.prototype, "rootNodes", {
            /**
             * @return {?}
             */
            get: function () { return rootRenderNodes(this._view); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ViewRef_.prototype, "context", {
            /**
             * @return {?}
             */
            get: function () { return this._view.context; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ViewRef_.prototype, "destroyed", {
            /**
             * @return {?}
             */
            get: function () { return (this._view.state & 128 /* Destroyed */) !== 0; },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        ViewRef_.prototype.markForCheck = function () { markParentViewsForCheck(this._view); };
        /**
         * @return {?}
         */
        ViewRef_.prototype.detach = function () { this._view.state &= ~4 /* Attached */; };
        /**
         * @return {?}
         */
        ViewRef_.prototype.detectChanges = function () {
            /** @type {?} */
            var fs = this._view.root.rendererFactory;
            if (fs.begin) {
                fs.begin();
            }
            try {
                Services.checkAndUpdateView(this._view);
            }
            finally {
                if (fs.end) {
                    fs.end();
                }
            }
        };
        /**
         * @return {?}
         */
        ViewRef_.prototype.checkNoChanges = function () { Services.checkNoChangesView(this._view); };
        /**
         * @return {?}
         */
        ViewRef_.prototype.reattach = function () { this._view.state |= 4 /* Attached */; };
        /**
         * @param {?} callback
         * @return {?}
         */
        ViewRef_.prototype.onDestroy = function (callback) {
            if (!this._view.disposables) {
                this._view.disposables = [];
            }
            this._view.disposables.push(( /** @type {?} */(callback)));
        };
        /**
         * @return {?}
         */
        ViewRef_.prototype.destroy = function () {
            if (this._appRef) {
                this._appRef.detachView(this);
            }
            else if (this._viewContainerRef) {
                this._viewContainerRef.detach(this._viewContainerRef.indexOf(this));
            }
            Services.destroyView(this._view);
        };
        /**
         * @return {?}
         */
        ViewRef_.prototype.detachFromAppRef = function () {
            this._appRef = null;
            renderDetachView$1(this._view);
            Services.dirtyParentQueries(this._view);
        };
        /**
         * @param {?} appRef
         * @return {?}
         */
        ViewRef_.prototype.attachToAppRef = function (appRef) {
            if (this._viewContainerRef) {
                throw new Error('This view is already attached to a ViewContainer!');
            }
            this._appRef = appRef;
        };
        /**
         * @param {?} vcRef
         * @return {?}
         */
        ViewRef_.prototype.attachToViewContainerRef = function (vcRef) {
            if (this._appRef) {
                throw new Error('This view is already attached directly to the ApplicationRef!');
            }
            this._viewContainerRef = vcRef;
        };
        return ViewRef_;
    }());
    /**
     * @param {?} view
     * @param {?} def
     * @return {?}
     */
    function createTemplateData(view, def) {
        return new TemplateRef_(view, def);
    }
    var TemplateRef_ = /** @class */ (function (_super) {
        __extends(TemplateRef_, _super);
        /**
         * @param {?} _parentView
         * @param {?} _def
         */
        function TemplateRef_(_parentView, _def) {
            var _this = _super.call(this) || this;
            _this._parentView = _parentView;
            _this._def = _def;
            return _this;
        }
        /**
         * @param {?} context
         * @return {?}
         */
        TemplateRef_.prototype.createEmbeddedView = function (context) {
            return new ViewRef_(Services.createEmbeddedView(this._parentView, this._def, ( /** @type {?} */(( /** @type {?} */(this._def.element)).template)), context));
        };
        Object.defineProperty(TemplateRef_.prototype, "elementRef", {
            /**
             * @return {?}
             */
            get: function () {
                return new ElementRef(asElementData(this._parentView, this._def.nodeIndex).renderElement);
            },
            enumerable: true,
            configurable: true
        });
        return TemplateRef_;
    }(TemplateRef));
    /**
     * @param {?} view
     * @param {?} elDef
     * @return {?}
     */
    function createInjector$1(view, elDef) {
        return new Injector_(view, elDef);
    }
    var Injector_ = /** @class */ (function () {
        /**
         * @param {?} view
         * @param {?} elDef
         */
        function Injector_(view, elDef) {
            this.view = view;
            this.elDef = elDef;
        }
        /**
         * @param {?} token
         * @param {?=} notFoundValue
         * @return {?}
         */
        Injector_.prototype.get = function (token, notFoundValue) {
            if (notFoundValue === void 0) { notFoundValue = Injector.THROW_IF_NOT_FOUND; }
            /** @type {?} */
            var allowPrivateServices = this.elDef ? (this.elDef.flags & 33554432 /* ComponentView */) !== 0 : false;
            return Services.resolveDep(this.view, this.elDef, allowPrivateServices, { flags: 0 /* None */, token: token, tokenKey: tokenKey(token) }, notFoundValue);
        };
        return Injector_;
    }());
    /**
     * @param {?} view
     * @param {?} index
     * @return {?}
     */
    function nodeValue(view, index) {
        /** @type {?} */
        var def = view.def.nodes[index];
        if (def.flags & 1 /* TypeElement */) {
            /** @type {?} */
            var elData = asElementData(view, def.nodeIndex);
            return ( /** @type {?} */(def.element)).template ? elData.template : elData.renderElement;
        }
        else if (def.flags & 2 /* TypeText */) {
            return asTextData(view, def.nodeIndex).renderText;
        }
        else if (def.flags & (20224 /* CatProvider */ | 16 /* TypePipe */)) {
            return asProviderData(view, def.nodeIndex).instance;
        }
        throw new Error("Illegal state: read nodeValue for node index " + index);
    }
    /**
     * @param {?} view
     * @return {?}
     */
    function createRendererV1(view) {
        return new RendererAdapter(view.renderer);
    }
    var RendererAdapter = /** @class */ (function () {
        /**
         * @param {?} delegate
         */
        function RendererAdapter(delegate) {
            this.delegate = delegate;
        }
        /**
         * @param {?} selectorOrNode
         * @return {?}
         */
        RendererAdapter.prototype.selectRootElement = function (selectorOrNode) {
            return this.delegate.selectRootElement(selectorOrNode);
        };
        /**
         * @param {?} parent
         * @param {?} namespaceAndName
         * @return {?}
         */
        RendererAdapter.prototype.createElement = function (parent, namespaceAndName) {
            var _b = __read(splitNamespace(namespaceAndName), 2), ns = _b[0], name = _b[1];
            /** @type {?} */
            var el = this.delegate.createElement(name, ns);
            if (parent) {
                this.delegate.appendChild(parent, el);
            }
            return el;
        };
        /**
         * @param {?} hostElement
         * @return {?}
         */
        RendererAdapter.prototype.createViewRoot = function (hostElement) { return hostElement; };
        /**
         * @param {?} parentElement
         * @return {?}
         */
        RendererAdapter.prototype.createTemplateAnchor = function (parentElement) {
            /** @type {?} */
            var comment = this.delegate.createComment('');
            if (parentElement) {
                this.delegate.appendChild(parentElement, comment);
            }
            return comment;
        };
        /**
         * @param {?} parentElement
         * @param {?} value
         * @return {?}
         */
        RendererAdapter.prototype.createText = function (parentElement, value) {
            /** @type {?} */
            var node = this.delegate.createText(value);
            if (parentElement) {
                this.delegate.appendChild(parentElement, node);
            }
            return node;
        };
        /**
         * @param {?} parentElement
         * @param {?} nodes
         * @return {?}
         */
        RendererAdapter.prototype.projectNodes = function (parentElement, nodes) {
            for (var i_67 = 0; i_67 < nodes.length; i_67++) {
                this.delegate.appendChild(parentElement, nodes[i_67]);
            }
        };
        /**
         * @param {?} node
         * @param {?} viewRootNodes
         * @return {?}
         */
        RendererAdapter.prototype.attachViewAfter = function (node, viewRootNodes) {
            /** @type {?} */
            var parentElement = this.delegate.parentNode(node);
            /** @type {?} */
            var nextSibling = this.delegate.nextSibling(node);
            for (var i_68 = 0; i_68 < viewRootNodes.length; i_68++) {
                this.delegate.insertBefore(parentElement, viewRootNodes[i_68], nextSibling);
            }
        };
        /**
         * @param {?} viewRootNodes
         * @return {?}
         */
        RendererAdapter.prototype.detachView = function (viewRootNodes) {
            for (var i_69 = 0; i_69 < viewRootNodes.length; i_69++) {
                /** @type {?} */
                var node = viewRootNodes[i_69];
                /** @type {?} */
                var parentElement = this.delegate.parentNode(node);
                this.delegate.removeChild(parentElement, node);
            }
        };
        /**
         * @param {?} hostElement
         * @param {?} viewAllNodes
         * @return {?}
         */
        RendererAdapter.prototype.destroyView = function (hostElement, viewAllNodes) {
            for (var i_70 = 0; i_70 < viewAllNodes.length; i_70++) {
                ( /** @type {?} */(this.delegate.destroyNode))(viewAllNodes[i_70]);
            }
        };
        /**
         * @param {?} renderElement
         * @param {?} name
         * @param {?} callback
         * @return {?}
         */
        RendererAdapter.prototype.listen = function (renderElement, name, callback) {
            return this.delegate.listen(renderElement, name, ( /** @type {?} */(callback)));
        };
        /**
         * @param {?} target
         * @param {?} name
         * @param {?} callback
         * @return {?}
         */
        RendererAdapter.prototype.listenGlobal = function (target, name, callback) {
            return this.delegate.listen(target, name, ( /** @type {?} */(callback)));
        };
        /**
         * @param {?} renderElement
         * @param {?} propertyName
         * @param {?} propertyValue
         * @return {?}
         */
        RendererAdapter.prototype.setElementProperty = function (renderElement, propertyName, propertyValue) {
            this.delegate.setProperty(renderElement, propertyName, propertyValue);
        };
        /**
         * @param {?} renderElement
         * @param {?} namespaceAndName
         * @param {?=} attributeValue
         * @return {?}
         */
        RendererAdapter.prototype.setElementAttribute = function (renderElement, namespaceAndName, attributeValue) {
            var _b = __read(splitNamespace(namespaceAndName), 2), ns = _b[0], name = _b[1];
            if (attributeValue != null) {
                this.delegate.setAttribute(renderElement, name, attributeValue, ns);
            }
            else {
                this.delegate.removeAttribute(renderElement, name, ns);
            }
        };
        /**
         * @param {?} renderElement
         * @param {?} propertyName
         * @param {?} propertyValue
         * @return {?}
         */
        RendererAdapter.prototype.setBindingDebugInfo = function (renderElement, propertyName, propertyValue) { };
        /**
         * @param {?} renderElement
         * @param {?} className
         * @param {?} isAdd
         * @return {?}
         */
        RendererAdapter.prototype.setElementClass = function (renderElement, className, isAdd) {
            if (isAdd) {
                this.delegate.addClass(renderElement, className);
            }
            else {
                this.delegate.removeClass(renderElement, className);
            }
        };
        /**
         * @param {?} renderElement
         * @param {?} styleName
         * @param {?=} styleValue
         * @return {?}
         */
        RendererAdapter.prototype.setElementStyle = function (renderElement, styleName, styleValue) {
            if (styleValue != null) {
                this.delegate.setStyle(renderElement, styleName, styleValue);
            }
            else {
                this.delegate.removeStyle(renderElement, styleName);
            }
        };
        /**
         * @param {?} renderElement
         * @param {?} methodName
         * @param {?} args
         * @return {?}
         */
        RendererAdapter.prototype.invokeElementMethod = function (renderElement, methodName, args) {
            (( /** @type {?} */(renderElement)))[methodName].apply(renderElement, args);
        };
        /**
         * @param {?} renderNode
         * @param {?} text
         * @return {?}
         */
        RendererAdapter.prototype.setText = function (renderNode, text) { this.delegate.setValue(renderNode, text); };
        /**
         * @return {?}
         */
        RendererAdapter.prototype.animate = function () { throw new Error('Renderer.animate is no longer supported!'); };
        return RendererAdapter;
    }());
    /**
     * @param {?} moduleType
     * @param {?} parent
     * @param {?} bootstrapComponents
     * @param {?} def
     * @return {?}
     */
    function createNgModuleRef(moduleType, parent, bootstrapComponents, def) {
        return new NgModuleRef_(moduleType, parent, bootstrapComponents, def);
    }
    var NgModuleRef_ = /** @class */ (function () {
        /**
         * @param {?} _moduleType
         * @param {?} _parent
         * @param {?} _bootstrapComponents
         * @param {?} _def
         */
        function NgModuleRef_(_moduleType, _parent, _bootstrapComponents, _def) {
            this._moduleType = _moduleType;
            this._parent = _parent;
            this._bootstrapComponents = _bootstrapComponents;
            this._def = _def;
            this._destroyListeners = [];
            this._destroyed = false;
            this.injector = this;
            initNgModule(this);
        }
        /**
         * @param {?} token
         * @param {?=} notFoundValue
         * @param {?=} injectFlags
         * @return {?}
         */
        NgModuleRef_.prototype.get = function (token, notFoundValue, injectFlags) {
            if (notFoundValue === void 0) { notFoundValue = Injector.THROW_IF_NOT_FOUND; }
            if (injectFlags === void 0) { injectFlags = InjectFlags.Default; }
            /** @type {?} */
            var flags = 0 /* None */;
            if (injectFlags & InjectFlags.SkipSelf) {
                flags |= 1 /* SkipSelf */;
            }
            else if (injectFlags & InjectFlags.Self) {
                flags |= 4 /* Self */;
            }
            return resolveNgModuleDep(this, { token: token, tokenKey: tokenKey(token), flags: flags }, notFoundValue);
        };
        Object.defineProperty(NgModuleRef_.prototype, "instance", {
            /**
             * @return {?}
             */
            get: function () { return this.get(this._moduleType); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgModuleRef_.prototype, "componentFactoryResolver", {
            /**
             * @return {?}
             */
            get: function () { return this.get(ComponentFactoryResolver); },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        NgModuleRef_.prototype.destroy = function () {
            if (this._destroyed) {
                throw new Error("The ng module " + stringify(this.instance.constructor) + " has already been destroyed.");
            }
            this._destroyed = true;
            callNgModuleLifecycle(this, 131072 /* OnDestroy */);
            this._destroyListeners.forEach(( /**
             * @param {?} listener
             * @return {?}
             */function (listener) { return listener(); }));
        };
        /**
         * @param {?} callback
         * @return {?}
         */
        NgModuleRef_.prototype.onDestroy = function (callback) { this._destroyListeners.push(callback); };
        return NgModuleRef_;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var RendererV1TokenKey = tokenKey(Renderer);
    /** @type {?} */
    var Renderer2TokenKey = tokenKey(Renderer2);
    /** @type {?} */
    var ElementRefTokenKey = tokenKey(ElementRef);
    /** @type {?} */
    var ViewContainerRefTokenKey = tokenKey(ViewContainerRef);
    /** @type {?} */
    var TemplateRefTokenKey = tokenKey(TemplateRef);
    /** @type {?} */
    var ChangeDetectorRefTokenKey = tokenKey(ChangeDetectorRef);
    /** @type {?} */
    var InjectorRefTokenKey$1 = tokenKey(Injector);
    /** @type {?} */
    var INJECTORRefTokenKey$1 = tokenKey(INJECTOR);
    /**
     * @param {?} checkIndex
     * @param {?} flags
     * @param {?} matchedQueries
     * @param {?} childCount
     * @param {?} ctor
     * @param {?} deps
     * @param {?=} props
     * @param {?=} outputs
     * @return {?}
     */
    function directiveDef(checkIndex, flags, matchedQueries, childCount, ctor, deps, props, outputs) {
        /** @type {?} */
        var bindings = [];
        if (props) {
            for (var prop in props) {
                var _b = __read(props[prop], 2), bindingIndex = _b[0], nonMinifiedName = _b[1];
                bindings[bindingIndex] = {
                    flags: 8 /* TypeProperty */,
                    name: prop, nonMinifiedName: nonMinifiedName,
                    ns: null,
                    securityContext: null,
                    suffix: null
                };
            }
        }
        /** @type {?} */
        var outputDefs = [];
        if (outputs) {
            for (var propName in outputs) {
                outputDefs.push({ type: 1 /* DirectiveOutput */, propName: propName, target: null, eventName: outputs[propName] });
            }
        }
        flags |= 16384 /* TypeDirective */;
        return _def(checkIndex, flags, matchedQueries, childCount, ctor, ctor, deps, bindings, outputDefs);
    }
    /**
     * @param {?} flags
     * @param {?} ctor
     * @param {?} deps
     * @return {?}
     */
    function pipeDef(flags, ctor, deps) {
        flags |= 16 /* TypePipe */;
        return _def(-1, flags, null, 0, ctor, ctor, deps);
    }
    /**
     * @param {?} flags
     * @param {?} matchedQueries
     * @param {?} token
     * @param {?} value
     * @param {?} deps
     * @return {?}
     */
    function providerDef(flags, matchedQueries, token, value, deps) {
        return _def(-1, flags, matchedQueries, 0, token, value, deps);
    }
    /**
     * @param {?} checkIndex
     * @param {?} flags
     * @param {?} matchedQueriesDsl
     * @param {?} childCount
     * @param {?} token
     * @param {?} value
     * @param {?} deps
     * @param {?=} bindings
     * @param {?=} outputs
     * @return {?}
     */
    function _def(checkIndex, flags, matchedQueriesDsl, childCount, token, value, deps, bindings, outputs) {
        var _b = splitMatchedQueriesDsl(matchedQueriesDsl), matchedQueries = _b.matchedQueries, references = _b.references, matchedQueryIds = _b.matchedQueryIds;
        if (!outputs) {
            outputs = [];
        }
        if (!bindings) {
            bindings = [];
        }
        // Need to resolve forwardRefs as e.g. for `useValue` we
        // lowered the expression and then stopped evaluating it,
        // i.e. also didn't unwrap it.
        value = resolveForwardRef(value);
        /** @type {?} */
        var depDefs = splitDepsDsl(deps, stringify(token));
        return {
            // will bet set by the view definition
            nodeIndex: -1,
            parent: null,
            renderParent: null,
            bindingIndex: -1,
            outputIndex: -1,
            // regular values
            checkIndex: checkIndex,
            flags: flags,
            childFlags: 0,
            directChildFlags: 0,
            childMatchedQueries: 0, matchedQueries: matchedQueries, matchedQueryIds: matchedQueryIds, references: references,
            ngContentIndex: -1, childCount: childCount, bindings: bindings,
            bindingFlags: calcBindingFlags(bindings), outputs: outputs,
            element: null,
            provider: { token: token, value: value, deps: depDefs },
            text: null,
            query: null,
            ngContent: null
        };
    }
    /**
     * @param {?} view
     * @param {?} def
     * @return {?}
     */
    function createProviderInstance(view, def) {
        return _createProviderInstance$1(view, def);
    }
    /**
     * @param {?} view
     * @param {?} def
     * @return {?}
     */
    function createPipeInstance(view, def) {
        // deps are looked up from component.
        /** @type {?} */
        var compView = view;
        while (compView.parent && !isComponentView(compView)) {
            compView = compView.parent;
        }
        // pipes can see the private services of the component
        /** @type {?} */
        var allowPrivateServices = true;
        // pipes are always eager and classes!
        return createClass(( /** @type {?} */(compView.parent)), ( /** @type {?} */(viewParentEl(compView))), allowPrivateServices, ( /** @type {?} */(def.provider)).value, ( /** @type {?} */(def.provider)).deps);
    }
    /**
     * @param {?} view
     * @param {?} def
     * @return {?}
     */
    function createDirectiveInstance(view, def) {
        // components can see other private services, other directives can't.
        /** @type {?} */
        var allowPrivateServices = (def.flags & 32768 /* Component */) > 0;
        // directives are always eager and classes!
        /** @type {?} */
        var instance = createClass(view, ( /** @type {?} */(def.parent)), allowPrivateServices, ( /** @type {?} */(def.provider)).value, ( /** @type {?} */(def.provider)).deps);
        if (def.outputs.length) {
            for (var i_71 = 0; i_71 < def.outputs.length; i_71++) {
                /** @type {?} */
                var output = def.outputs[i_71];
                /** @type {?} */
                var outputObservable = instance[( /** @type {?} */(output.propName))];
                if (isObservable(outputObservable)) {
                    /** @type {?} */
                    var subscription = outputObservable.subscribe(eventHandlerClosure(view, ( /** @type {?} */(def.parent)).nodeIndex, output.eventName));
                    ( /** @type {?} */(view.disposables))[def.outputIndex + i_71] = subscription.unsubscribe.bind(subscription);
                }
                else {
                    throw new Error("@Output " + output.propName + " not initialized in '" + instance.constructor.name + "'.");
                }
            }
        }
        return instance;
    }
    /**
     * @param {?} view
     * @param {?} index
     * @param {?} eventName
     * @return {?}
     */
    function eventHandlerClosure(view, index, eventName) {
        return ( /**
         * @param {?} event
         * @return {?}
         */function (event) { return dispatchEvent(view, index, eventName, event); });
    }
    /**
     * @param {?} view
     * @param {?} def
     * @param {?} v0
     * @param {?} v1
     * @param {?} v2
     * @param {?} v3
     * @param {?} v4
     * @param {?} v5
     * @param {?} v6
     * @param {?} v7
     * @param {?} v8
     * @param {?} v9
     * @return {?}
     */
    function checkAndUpdateDirectiveInline(view, def, v0, v1, v2, v3, v4, v5, v6, v7, v8, v9) {
        /** @type {?} */
        var providerData = asProviderData(view, def.nodeIndex);
        /** @type {?} */
        var directive = providerData.instance;
        /** @type {?} */
        var changed = false;
        /** @type {?} */
        var changes = ( /** @type {?} */(undefined));
        /** @type {?} */
        var bindLen = def.bindings.length;
        if (bindLen > 0 && checkBinding(view, def, 0, v0)) {
            changed = true;
            changes = updateProp(view, providerData, def, 0, v0, changes);
        }
        if (bindLen > 1 && checkBinding(view, def, 1, v1)) {
            changed = true;
            changes = updateProp(view, providerData, def, 1, v1, changes);
        }
        if (bindLen > 2 && checkBinding(view, def, 2, v2)) {
            changed = true;
            changes = updateProp(view, providerData, def, 2, v2, changes);
        }
        if (bindLen > 3 && checkBinding(view, def, 3, v3)) {
            changed = true;
            changes = updateProp(view, providerData, def, 3, v3, changes);
        }
        if (bindLen > 4 && checkBinding(view, def, 4, v4)) {
            changed = true;
            changes = updateProp(view, providerData, def, 4, v4, changes);
        }
        if (bindLen > 5 && checkBinding(view, def, 5, v5)) {
            changed = true;
            changes = updateProp(view, providerData, def, 5, v5, changes);
        }
        if (bindLen > 6 && checkBinding(view, def, 6, v6)) {
            changed = true;
            changes = updateProp(view, providerData, def, 6, v6, changes);
        }
        if (bindLen > 7 && checkBinding(view, def, 7, v7)) {
            changed = true;
            changes = updateProp(view, providerData, def, 7, v7, changes);
        }
        if (bindLen > 8 && checkBinding(view, def, 8, v8)) {
            changed = true;
            changes = updateProp(view, providerData, def, 8, v8, changes);
        }
        if (bindLen > 9 && checkBinding(view, def, 9, v9)) {
            changed = true;
            changes = updateProp(view, providerData, def, 9, v9, changes);
        }
        if (changes) {
            directive.ngOnChanges(changes);
        }
        if ((def.flags & 65536 /* OnInit */) &&
            shouldCallLifecycleInitHook(view, 256 /* InitState_CallingOnInit */, def.nodeIndex)) {
            directive.ngOnInit();
        }
        if (def.flags & 262144 /* DoCheck */) {
            directive.ngDoCheck();
        }
        return changed;
    }
    /**
     * @param {?} view
     * @param {?} def
     * @param {?} values
     * @return {?}
     */
    function checkAndUpdateDirectiveDynamic(view, def, values) {
        /** @type {?} */
        var providerData = asProviderData(view, def.nodeIndex);
        /** @type {?} */
        var directive = providerData.instance;
        /** @type {?} */
        var changed = false;
        /** @type {?} */
        var changes = ( /** @type {?} */(undefined));
        for (var i_72 = 0; i_72 < values.length; i_72++) {
            if (checkBinding(view, def, i_72, values[i_72])) {
                changed = true;
                changes = updateProp(view, providerData, def, i_72, values[i_72], changes);
            }
        }
        if (changes) {
            directive.ngOnChanges(changes);
        }
        if ((def.flags & 65536 /* OnInit */) &&
            shouldCallLifecycleInitHook(view, 256 /* InitState_CallingOnInit */, def.nodeIndex)) {
            directive.ngOnInit();
        }
        if (def.flags & 262144 /* DoCheck */) {
            directive.ngDoCheck();
        }
        return changed;
    }
    /**
     * @param {?} view
     * @param {?} def
     * @return {?}
     */
    function _createProviderInstance$1(view, def) {
        // private services can see other private services
        /** @type {?} */
        var allowPrivateServices = (def.flags & 8192 /* PrivateProvider */) > 0;
        /** @type {?} */
        var providerDef = def.provider;
        switch (def.flags & 201347067 /* Types */) {
            case 512 /* TypeClassProvider */:
                return createClass(view, ( /** @type {?} */(def.parent)), allowPrivateServices, ( /** @type {?} */(providerDef)).value, ( /** @type {?} */(providerDef)).deps);
            case 1024 /* TypeFactoryProvider */:
                return callFactory(view, ( /** @type {?} */(def.parent)), allowPrivateServices, ( /** @type {?} */(providerDef)).value, ( /** @type {?} */(providerDef)).deps);
            case 2048 /* TypeUseExistingProvider */:
                return resolveDep(view, ( /** @type {?} */(def.parent)), allowPrivateServices, ( /** @type {?} */(providerDef)).deps[0]);
            case 256 /* TypeValueProvider */:
                return ( /** @type {?} */(providerDef)).value;
        }
    }
    /**
     * @param {?} view
     * @param {?} elDef
     * @param {?} allowPrivateServices
     * @param {?} ctor
     * @param {?} deps
     * @return {?}
     */
    function createClass(view, elDef, allowPrivateServices, ctor, deps) {
        /** @type {?} */
        var len = deps.length;
        switch (len) {
            case 0:
                return new ctor();
            case 1:
                return new ctor(resolveDep(view, elDef, allowPrivateServices, deps[0]));
            case 2:
                return new ctor(resolveDep(view, elDef, allowPrivateServices, deps[0]), resolveDep(view, elDef, allowPrivateServices, deps[1]));
            case 3:
                return new ctor(resolveDep(view, elDef, allowPrivateServices, deps[0]), resolveDep(view, elDef, allowPrivateServices, deps[1]), resolveDep(view, elDef, allowPrivateServices, deps[2]));
            default:
                /** @type {?} */
                var depValues = new Array(len);
                for (var i_73 = 0; i_73 < len; i_73++) {
                    depValues[i_73] = resolveDep(view, elDef, allowPrivateServices, deps[i_73]);
                }
                return new (ctor.bind.apply(ctor, __spread([void 0], depValues)))();
        }
    }
    /**
     * @param {?} view
     * @param {?} elDef
     * @param {?} allowPrivateServices
     * @param {?} factory
     * @param {?} deps
     * @return {?}
     */
    function callFactory(view, elDef, allowPrivateServices, factory, deps) {
        /** @type {?} */
        var len = deps.length;
        switch (len) {
            case 0:
                return factory();
            case 1:
                return factory(resolveDep(view, elDef, allowPrivateServices, deps[0]));
            case 2:
                return factory(resolveDep(view, elDef, allowPrivateServices, deps[0]), resolveDep(view, elDef, allowPrivateServices, deps[1]));
            case 3:
                return factory(resolveDep(view, elDef, allowPrivateServices, deps[0]), resolveDep(view, elDef, allowPrivateServices, deps[1]), resolveDep(view, elDef, allowPrivateServices, deps[2]));
            default:
                /** @type {?} */
                var depValues = Array(len);
                for (var i_74 = 0; i_74 < len; i_74++) {
                    depValues[i_74] = resolveDep(view, elDef, allowPrivateServices, deps[i_74]);
                }
                return factory.apply(void 0, __spread(depValues));
        }
    }
    // This default value is when checking the hierarchy for a token.
    //
    // It means both:
    // - the token is not provided by the current injector,
    // - only the element injectors should be checked (ie do not check module injectors
    //
    //          mod1
    //         /
    //       el1   mod2
    //         \  /
    //         el2
    //
    // When requesting el2.injector.get(token), we should check in the following order and return the
    // first found value:
    // - el2.injector.get(token, default)
    // - el1.injector.get(token, NOT_FOUND_CHECK_ONLY_ELEMENT_INJECTOR) -> do not check the module
    // - mod2.injector.get(token, default)
    /** @type {?} */
    var NOT_FOUND_CHECK_ONLY_ELEMENT_INJECTOR = {};
    /**
     * @param {?} view
     * @param {?} elDef
     * @param {?} allowPrivateServices
     * @param {?} depDef
     * @param {?=} notFoundValue
     * @return {?}
     */
    function resolveDep(view, elDef, allowPrivateServices, depDef, notFoundValue) {
        if (notFoundValue === void 0) { notFoundValue = Injector.THROW_IF_NOT_FOUND; }
        if (depDef.flags & 8 /* Value */) {
            return depDef.token;
        }
        /** @type {?} */
        var startView = view;
        if (depDef.flags & 2 /* Optional */) {
            notFoundValue = null;
        }
        /** @type {?} */
        var tokenKey = depDef.tokenKey;
        if (tokenKey === ChangeDetectorRefTokenKey) {
            // directives on the same element as a component should be able to control the change detector
            // of that component as well.
            allowPrivateServices = !!(elDef && ( /** @type {?} */(elDef.element)).componentView);
        }
        if (elDef && (depDef.flags & 1 /* SkipSelf */)) {
            allowPrivateServices = false;
            elDef = ( /** @type {?} */(elDef.parent));
        }
        /** @type {?} */
        var searchView = view;
        while (searchView) {
            if (elDef) {
                switch (tokenKey) {
                    case RendererV1TokenKey: {
                        /** @type {?} */
                        var compView = findCompView(searchView, elDef, allowPrivateServices);
                        return createRendererV1(compView);
                    }
                    case Renderer2TokenKey: {
                        /** @type {?} */
                        var compView = findCompView(searchView, elDef, allowPrivateServices);
                        return compView.renderer;
                    }
                    case ElementRefTokenKey:
                        return new ElementRef(asElementData(searchView, elDef.nodeIndex).renderElement);
                    case ViewContainerRefTokenKey:
                        return asElementData(searchView, elDef.nodeIndex).viewContainer;
                    case TemplateRefTokenKey: {
                        if (( /** @type {?} */(elDef.element)).template) {
                            return asElementData(searchView, elDef.nodeIndex).template;
                        }
                        break;
                    }
                    case ChangeDetectorRefTokenKey: {
                        /** @type {?} */
                        var cdView = findCompView(searchView, elDef, allowPrivateServices);
                        return createChangeDetectorRef(cdView);
                    }
                    case InjectorRefTokenKey$1:
                    case INJECTORRefTokenKey$1:
                        return createInjector$1(searchView, elDef);
                    default:
                        /** @type {?} */
                        var providerDef_2 = ( /** @type {?} */((allowPrivateServices ? ( /** @type {?} */(elDef.element)).allProviders :
                            ( /** @type {?} */(elDef.element)).publicProviders)))[tokenKey];
                        if (providerDef_2) {
                            /** @type {?} */
                            var providerData = asProviderData(searchView, providerDef_2.nodeIndex);
                            if (!providerData) {
                                providerData = { instance: _createProviderInstance$1(searchView, providerDef_2) };
                                searchView.nodes[providerDef_2.nodeIndex] = ( /** @type {?} */(providerData));
                            }
                            return providerData.instance;
                        }
                }
            }
            allowPrivateServices = isComponentView(searchView);
            elDef = ( /** @type {?} */(viewParentEl(searchView)));
            searchView = ( /** @type {?} */(searchView.parent));
            if (depDef.flags & 4 /* Self */) {
                searchView = null;
            }
        }
        /** @type {?} */
        var value = startView.root.injector.get(depDef.token, NOT_FOUND_CHECK_ONLY_ELEMENT_INJECTOR);
        if (value !== NOT_FOUND_CHECK_ONLY_ELEMENT_INJECTOR ||
            notFoundValue === NOT_FOUND_CHECK_ONLY_ELEMENT_INJECTOR) {
            // Return the value from the root element injector when
            // - it provides it
            //   (value !== NOT_FOUND_CHECK_ONLY_ELEMENT_INJECTOR)
            // - the module injector should not be checked
            //   (notFoundValue === NOT_FOUND_CHECK_ONLY_ELEMENT_INJECTOR)
            return value;
        }
        return startView.root.ngModule.injector.get(depDef.token, notFoundValue);
    }
    /**
     * @param {?} view
     * @param {?} elDef
     * @param {?} allowPrivateServices
     * @return {?}
     */
    function findCompView(view, elDef, allowPrivateServices) {
        /** @type {?} */
        var compView;
        if (allowPrivateServices) {
            compView = asElementData(view, elDef.nodeIndex).componentView;
        }
        else {
            compView = view;
            while (compView.parent && !isComponentView(compView)) {
                compView = compView.parent;
            }
        }
        return compView;
    }
    /**
     * @param {?} view
     * @param {?} providerData
     * @param {?} def
     * @param {?} bindingIdx
     * @param {?} value
     * @param {?} changes
     * @return {?}
     */
    function updateProp(view, providerData, def, bindingIdx, value, changes) {
        if (def.flags & 32768 /* Component */) {
            /** @type {?} */
            var compView = asElementData(view, ( /** @type {?} */(def.parent)).nodeIndex).componentView;
            if (compView.def.flags & 2 /* OnPush */) {
                compView.state |= 8 /* ChecksEnabled */;
            }
        }
        /** @type {?} */
        var binding = def.bindings[bindingIdx];
        /** @type {?} */
        var propName = ( /** @type {?} */(binding.name));
        // Note: This is still safe with Closure Compiler as
        // the user passed in the property name as an object has to `providerDef`,
        // so Closure Compiler will have renamed the property correctly already.
        providerData.instance[propName] = value;
        if (def.flags & 524288 /* OnChanges */) {
            changes = changes || {};
            /** @type {?} */
            var oldValue = WrappedValue.unwrap(view.oldValues[def.bindingIndex + bindingIdx]);
            /** @type {?} */
            var binding_1 = def.bindings[bindingIdx];
            changes[( /** @type {?} */(binding_1.nonMinifiedName))] =
                new SimpleChange(oldValue, value, (view.state & 2 /* FirstCheck */) !== 0);
        }
        view.oldValues[def.bindingIndex + bindingIdx] = value;
        return changes;
    }
    // This function calls the ngAfterContentCheck, ngAfterContentInit,
    // ngAfterViewCheck, and ngAfterViewInit lifecycle hooks (depending on the node
    // flags in lifecycle). Unlike ngDoCheck, ngOnChanges and ngOnInit, which are
    // called during a pre-order traversal of the view tree (that is calling the
    // parent hooks before the child hooks) these events are sent in using a
    // post-order traversal of the tree (children before parents). This changes the
    // meaning of initIndex in the view state. For ngOnInit, initIndex tracks the
    // expected nodeIndex which a ngOnInit should be called. When sending
    // ngAfterContentInit and ngAfterViewInit it is the expected count of
    // ngAfterContentInit or ngAfterViewInit methods that have been called. This
    // ensure that despite being called recursively or after picking up after an
    // exception, the ngAfterContentInit or ngAfterViewInit will be called on the
    // correct nodes. Consider for example, the following (where E is an element
    // and D is a directive)
    //  Tree:       pre-order index  post-order index
    //    E1        0                6
    //      E2      1                1
    //       D3     2                0
    //      E4      3                5
    //       E5     4                4
    //        E6    5                2
    //        E7    6                3
    // As can be seen, the post-order index has an unclear relationship to the
    // pre-order index (postOrderIndex === preOrderIndex - parentCount +
    // childCount). Since number of calls to ngAfterContentInit and ngAfterViewInit
    // are stable (will be the same for the same view regardless of exceptions or
    // recursion) we just need to count them which will roughly correspond to the
    // post-order index (it skips elements and directives that do not have
    // lifecycle hooks).
    //
    // For example, if an exception is raised in the E6.onAfterViewInit() the
    // initIndex is left at 3 (by shouldCallLifecycleInitHook() which set it to
    // initIndex + 1). When checkAndUpdateView() is called again D3, E2 and E6 will
    // not have their ngAfterViewInit() called but, starting with E7, the rest of
    // the view will begin getting ngAfterViewInit() called until a check and
    // pass is complete.
    //
    // This algorthim also handles recursion. Consider if E4's ngAfterViewInit()
    // indirectly calls E1's ChangeDetectorRef.detectChanges(). The expected
    // initIndex is set to 6, the recusive checkAndUpdateView() starts walk again.
    // D3, E2, E6, E7, E5 and E4 are skipped, ngAfterViewInit() is called on E1.
    // When the recursion returns the initIndex will be 7 so E1 is skipped as it
    // has already been called in the recursively called checkAnUpdateView().
    /**
     * @param {?} view
     * @param {?} lifecycles
     * @return {?}
     */
    function callLifecycleHooksChildrenFirst(view, lifecycles) {
        if (!(view.def.nodeFlags & lifecycles)) {
            return;
        }
        /** @type {?} */
        var nodes = view.def.nodes;
        /** @type {?} */
        var initIndex = 0;
        for (var i_75 = 0; i_75 < nodes.length; i_75++) {
            /** @type {?} */
            var nodeDef = nodes[i_75];
            /** @type {?} */
            var parent_4 = nodeDef.parent;
            if (!parent_4 && nodeDef.flags & lifecycles) {
                // matching root node (e.g. a pipe)
                callProviderLifecycles(view, i_75, nodeDef.flags & lifecycles, initIndex++);
            }
            if ((nodeDef.childFlags & lifecycles) === 0) {
                // no child matches one of the lifecycles
                i_75 += nodeDef.childCount;
            }
            while (parent_4 && (parent_4.flags & 1 /* TypeElement */) &&
                i_75 === parent_4.nodeIndex + parent_4.childCount) {
                // last child of an element
                if (parent_4.directChildFlags & lifecycles) {
                    initIndex = callElementProvidersLifecycles(view, parent_4, lifecycles, initIndex);
                }
                parent_4 = parent_4.parent;
            }
        }
    }
    /**
     * @param {?} view
     * @param {?} elDef
     * @param {?} lifecycles
     * @param {?} initIndex
     * @return {?}
     */
    function callElementProvidersLifecycles(view, elDef, lifecycles, initIndex) {
        for (var i_76 = elDef.nodeIndex + 1; i_76 <= elDef.nodeIndex + elDef.childCount; i_76++) {
            /** @type {?} */
            var nodeDef = view.def.nodes[i_76];
            if (nodeDef.flags & lifecycles) {
                callProviderLifecycles(view, i_76, nodeDef.flags & lifecycles, initIndex++);
            }
            // only visit direct children
            i_76 += nodeDef.childCount;
        }
        return initIndex;
    }
    /**
     * @param {?} view
     * @param {?} index
     * @param {?} lifecycles
     * @param {?} initIndex
     * @return {?}
     */
    function callProviderLifecycles(view, index, lifecycles, initIndex) {
        /** @type {?} */
        var providerData = asProviderData(view, index);
        if (!providerData) {
            return;
        }
        /** @type {?} */
        var provider = providerData.instance;
        if (!provider) {
            return;
        }
        Services.setCurrentNode(view, index);
        if (lifecycles & 1048576 /* AfterContentInit */ &&
            shouldCallLifecycleInitHook(view, 512 /* InitState_CallingAfterContentInit */, initIndex)) {
            provider.ngAfterContentInit();
        }
        if (lifecycles & 2097152 /* AfterContentChecked */) {
            provider.ngAfterContentChecked();
        }
        if (lifecycles & 4194304 /* AfterViewInit */ &&
            shouldCallLifecycleInitHook(view, 768 /* InitState_CallingAfterViewInit */, initIndex)) {
            provider.ngAfterViewInit();
        }
        if (lifecycles & 8388608 /* AfterViewChecked */) {
            provider.ngAfterViewChecked();
        }
        if (lifecycles & 131072 /* OnDestroy */) {
            provider.ngOnDestroy();
        }
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ComponentFactoryResolver$1 = /** @class */ (function (_super) {
        __extends(ComponentFactoryResolver$1, _super);
        /**
         * @param {?=} ngModule The NgModuleRef to which all resolved factories are bound.
         */
        function ComponentFactoryResolver$1(ngModule) {
            var _this = _super.call(this) || this;
            _this.ngModule = ngModule;
            return _this;
        }
        /**
         * @template T
         * @param {?} component
         * @return {?}
         */
        ComponentFactoryResolver$1.prototype.resolveComponentFactory = function (component) {
            ngDevMode && assertComponentType(component);
            /** @type {?} */
            var componentDef = ( /** @type {?} */(getComponentDef(component)));
            return new ComponentFactory$1(componentDef, this.ngModule);
        };
        return ComponentFactoryResolver$1;
    }(ComponentFactoryResolver));
    /**
     * @param {?} map
     * @return {?}
     */
    function toRefArray(map) {
        /** @type {?} */
        var array = [];
        for (var nonMinified in map) {
            if (map.hasOwnProperty(nonMinified)) {
                /** @type {?} */
                var minified = map[nonMinified];
                array.push({ propName: minified, templateName: nonMinified });
            }
        }
        return array;
    }
    /**
     * A change detection scheduler token for {\@link RootContext}. This token is the default value used
     * for the default `RootContext` found in the {\@link ROOT_CONTEXT} token.
     * @type {?}
     */
    var SCHEDULER = new InjectionToken('SCHEDULER_TOKEN', {
        providedIn: 'root',
        factory: ( /**
         * @return {?}
         */function () { return defaultScheduler; }),
    });
    /**
     * @param {?} rootViewInjector
     * @param {?} moduleInjector
     * @return {?}
     */
    function createChainedInjector(rootViewInjector, moduleInjector) {
        return {
            get: ( /**
             * @template T
             * @param {?} token
             * @param {?=} notFoundValue
             * @param {?=} flags
             * @return {?}
             */function (token, notFoundValue, flags) {
                /** @type {?} */
                var value = rootViewInjector.get(token, ( /** @type {?} */(NOT_FOUND_CHECK_ONLY_ELEMENT_INJECTOR)), flags);
                if (value !== NOT_FOUND_CHECK_ONLY_ELEMENT_INJECTOR ||
                    notFoundValue === NOT_FOUND_CHECK_ONLY_ELEMENT_INJECTOR) {
                    // Return the value from the root element injector when
                    // - it provides it
                    //   (value !== NOT_FOUND_CHECK_ONLY_ELEMENT_INJECTOR)
                    // - the module injector should not be checked
                    //   (notFoundValue === NOT_FOUND_CHECK_ONLY_ELEMENT_INJECTOR)
                    return value;
                }
                return moduleInjector.get(token, notFoundValue, flags);
            })
        };
    }
    /**
     * Render3 implementation of {\@link viewEngine_ComponentFactory}.
     * @template T
     */
    var ComponentFactory$1 = /** @class */ (function (_super) {
        __extends(ComponentFactory$1, _super);
        /**
         * @param {?} componentDef The component definition.
         * @param {?=} ngModule The NgModuleRef to which the factory is bound.
         */
        function ComponentFactory$1(componentDef, ngModule) {
            var _this = _super.call(this) || this;
            _this.componentDef = componentDef;
            _this.ngModule = ngModule;
            _this.componentType = componentDef.type;
            // default to 'div' in case this component has an attribute selector
            _this.selector = ( /** @type {?} */(componentDef.selectors[0][0])) || 'div';
            _this.ngContentSelectors =
                componentDef.ngContentSelectors ? componentDef.ngContentSelectors : [];
            _this.isBoundToModule = !!ngModule;
            return _this;
        }
        Object.defineProperty(ComponentFactory$1.prototype, "inputs", {
            /**
             * @return {?}
             */
            get: function () {
                return toRefArray(this.componentDef.inputs);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ComponentFactory$1.prototype, "outputs", {
            /**
             * @return {?}
             */
            get: function () {
                return toRefArray(this.componentDef.outputs);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} injector
         * @param {?=} projectableNodes
         * @param {?=} rootSelectorOrNode
         * @param {?=} ngModule
         * @return {?}
         */
        ComponentFactory$1.prototype.create = function (injector, projectableNodes, rootSelectorOrNode, ngModule) {
            ngModule = ngModule || this.ngModule;
            /** @type {?} */
            var rootViewInjector = ngModule ? createChainedInjector(injector, ngModule.injector) : injector;
            /** @type {?} */
            var rendererFactory = ( /** @type {?} */(rootViewInjector.get(RendererFactory2, domRendererFactory3)));
            /** @type {?} */
            var sanitizer = rootViewInjector.get(Sanitizer, null);
            // Ensure that the namespace for the root node is correct,
            // otherwise the browser might not render out the element properly.
            namespaceHTMLInternal();
            /** @type {?} */
            var hostRNode = rootSelectorOrNode ?
                locateHostElement(rendererFactory, rootSelectorOrNode) :
                elementCreate(this.selector, rendererFactory.createRenderer(null, this.componentDef));
            /** @type {?} */
            var rootFlags = this.componentDef.onPush ? 64 /* Dirty */ | 512 /* IsRoot */ :
                16 /* CheckAlways */ | 512 /* IsRoot */;
            // Check whether this Component needs to be isolated from other components, i.e. whether it
            // should be placed into its own (empty) root context or existing root context should be used.
            // Note: this is internal-only convention and might change in the future, so it should not be
            // relied upon externally.
            /** @type {?} */
            var isIsolated = typeof rootSelectorOrNode === 'string' &&
                /^#root-ng-internal-isolated-\d+/.test(rootSelectorOrNode);
            /** @type {?} */
            var rootContext = createRootContext();
            /** @type {?} */
            var renderer = rendererFactory.createRenderer(hostRNode, this.componentDef);
            if (rootSelectorOrNode && hostRNode) {
                ngDevMode && ngDevMode.rendererSetAttribute++;
                isProceduralRenderer(renderer) ?
                    renderer.setAttribute(hostRNode, 'ng-version', VERSION.full) :
                    hostRNode.setAttribute('ng-version', VERSION.full);
            }
            // Create the root view. Uses empty TView and ContentTemplate.
            /** @type {?} */
            var rootLView = createLView(null, createTView(-1, null, 1, 0, null, null, null, null), rootContext, rootFlags, null, null, rendererFactory, renderer, sanitizer, rootViewInjector);
            // rootView is the parent when bootstrapping
            /** @type {?} */
            var oldLView = enterView(rootLView, null);
            /** @type {?} */
            var component;
            /** @type {?} */
            var tElementNode;
            // Will become true if the `try` block executes with no errors.
            /** @type {?} */
            var safeToRunHooks = false;
            try {
                /** @type {?} */
                var componentView = createRootComponentView(hostRNode, this.componentDef, rootLView, rendererFactory, renderer);
                tElementNode = ( /** @type {?} */(getTNode(0, rootLView)));
                if (projectableNodes) {
                    // projectable nodes can be passed as array of arrays or an array of iterables (ngUpgrade
                    // case). Here we do normalize passed data structure to be an array of arrays to avoid
                    // complex checks down the line.
                    tElementNode.projection =
                        projectableNodes.map(( /**
                         * @param {?} nodesforSlot
                         * @return {?}
                         */function (nodesforSlot) { return Array.from(nodesforSlot); }));
                }
                // TODO: should LifecycleHooksFeature and other host features be generated by the compiler and
                // executed here?
                // Angular 5 reference: https://stackblitz.com/edit/lifecycle-hooks-vcref
                component = createRootComponent(componentView, this.componentDef, rootLView, rootContext, [LifecycleHooksFeature]);
                addToViewTree(rootLView, componentView);
                refreshDescendantViews(rootLView);
                safeToRunHooks = true;
            }
            finally {
                leaveView(oldLView, safeToRunHooks);
            }
            /** @type {?} */
            var componentRef = new ComponentRef$1(this.componentType, component, createElementRef(ElementRef, tElementNode, rootLView), rootLView, tElementNode);
            if (!rootSelectorOrNode || isIsolated) {
                // The host element of the internal or isolated root view is attached to the component's host
                // view node.
                ( /** @type {?} */(componentRef.hostView._tViewNode)).child = tElementNode;
            }
            return componentRef;
        };
        return ComponentFactory$1;
    }(ComponentFactory));
    /** @type {?} */
    var componentFactoryResolver = new ComponentFactoryResolver$1();
    /**
     * Represents an instance of a Component created via a {\@link ComponentFactory}.
     *
     * `ComponentRef` provides access to the Component Instance as well other objects related to this
     * Component Instance and allows you to destroy the Component Instance via the {\@link #destroy}
     * method.
     *
     * @template T
     */
    var ComponentRef$1 = /** @class */ (function (_super) {
        __extends(ComponentRef$1, _super);
        /**
         * @param {?} componentType
         * @param {?} instance
         * @param {?} location
         * @param {?} _rootLView
         * @param {?} _tNode
         */
        function ComponentRef$1(componentType, instance, location, _rootLView, _tNode) {
            var _this = _super.call(this) || this;
            _this.location = location;
            _this._rootLView = _rootLView;
            _this._tNode = _tNode;
            _this.destroyCbs = [];
            _this.instance = instance;
            _this.hostView = _this.changeDetectorRef = new RootViewRef(_rootLView);
            _this.hostView._tViewNode = assignTViewNodeToLView(_rootLView[TVIEW], null, -1, _rootLView);
            _this.componentType = componentType;
            return _this;
        }
        Object.defineProperty(ComponentRef$1.prototype, "injector", {
            /**
             * @return {?}
             */
            get: function () { return new NodeInjector(this._tNode, this._rootLView); },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        ComponentRef$1.prototype.destroy = function () {
            if (this.destroyCbs) {
                this.destroyCbs.forEach(( /**
                 * @param {?} fn
                 * @return {?}
                 */function (/**
                 * @param {?} fn
                 * @return {?}
                 */ fn) { return fn(); }));
                this.destroyCbs = null;
                !this.hostView.destroyed && this.hostView.destroy();
            }
        };
        /**
         * @param {?} callback
         * @return {?}
         */
        ComponentRef$1.prototype.onDestroy = function (callback) {
            if (this.destroyCbs) {
                this.destroyCbs.push(callback);
            }
        };
        return ComponentRef$1;
    }(ComponentRef));
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * NOTE: changes to the `ngI18nClosureMode` name must be synced with `compiler-cli/src/tooling.ts`.
     */
    if (typeof ngI18nClosureMode === 'undefined') {
        // These property accesses can be ignored because ngI18nClosureMode will be set to false
        // when optimizing code and the whole if statement will be dropped.
        // Make sure to refer to ngI18nClosureMode as ['ngI18nClosureMode'] for closure.
        // NOTE: we need to have it in IIFE so that the tree-shaker is happy.
        (function () {
            // tslint:disable-next-line:no-toplevel-property-access
            _global['ngI18nClosureMode'] =
                // TODO(FW-1250): validate that this actually, you know, works.
                // tslint:disable-next-line:no-toplevel-property-access
                typeof goog !== 'undefined' && typeof goog.getMsg === 'function';
        })();
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * This const is used to store the locale data registered with `registerLocaleData`
     * @type {?}
     */
    var LOCALE_DATA = {};
    /** @enum {number} */
    var LocaleDataIndex = {
        LocaleId: 0,
        DayPeriodsFormat: 1,
        DayPeriodsStandalone: 2,
        DaysFormat: 3,
        DaysStandalone: 4,
        MonthsFormat: 5,
        MonthsStandalone: 6,
        Eras: 7,
        FirstDayOfWeek: 8,
        WeekendRange: 9,
        DateFormat: 10,
        TimeFormat: 11,
        DateTimeFormat: 12,
        NumberSymbols: 13,
        NumberFormats: 14,
        CurrencySymbol: 15,
        CurrencyName: 16,
        Currencies: 17,
        PluralCase: 18,
        ExtraData: 19,
    };
    LocaleDataIndex[LocaleDataIndex.LocaleId] = 'LocaleId';
    LocaleDataIndex[LocaleDataIndex.DayPeriodsFormat] = 'DayPeriodsFormat';
    LocaleDataIndex[LocaleDataIndex.DayPeriodsStandalone] = 'DayPeriodsStandalone';
    LocaleDataIndex[LocaleDataIndex.DaysFormat] = 'DaysFormat';
    LocaleDataIndex[LocaleDataIndex.DaysStandalone] = 'DaysStandalone';
    LocaleDataIndex[LocaleDataIndex.MonthsFormat] = 'MonthsFormat';
    LocaleDataIndex[LocaleDataIndex.MonthsStandalone] = 'MonthsStandalone';
    LocaleDataIndex[LocaleDataIndex.Eras] = 'Eras';
    LocaleDataIndex[LocaleDataIndex.FirstDayOfWeek] = 'FirstDayOfWeek';
    LocaleDataIndex[LocaleDataIndex.WeekendRange] = 'WeekendRange';
    LocaleDataIndex[LocaleDataIndex.DateFormat] = 'DateFormat';
    LocaleDataIndex[LocaleDataIndex.TimeFormat] = 'TimeFormat';
    LocaleDataIndex[LocaleDataIndex.DateTimeFormat] = 'DateTimeFormat';
    LocaleDataIndex[LocaleDataIndex.NumberSymbols] = 'NumberSymbols';
    LocaleDataIndex[LocaleDataIndex.NumberFormats] = 'NumberFormats';
    LocaleDataIndex[LocaleDataIndex.CurrencySymbol] = 'CurrencySymbol';
    LocaleDataIndex[LocaleDataIndex.CurrencyName] = 'CurrencyName';
    LocaleDataIndex[LocaleDataIndex.Currencies] = 'Currencies';
    LocaleDataIndex[LocaleDataIndex.PluralCase] = 'PluralCase';
    LocaleDataIndex[LocaleDataIndex.ExtraData] = 'ExtraData';
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    // THIS CODE IS GENERATED - DO NOT MODIFY
    // See angular/tools/gulp-tasks/cldr/extract.js
    /** @type {?} */
    var u = undefined;
    /**
     * @param {?} n
     * @return {?}
     */
    function plural(n) {
        /** @type {?} */
        var i = Math.floor(Math.abs(n));
        /** @type {?} */
        var v = n.toString().replace(/^[^.]*\.?/, '').length;
        if (i === 1 && v === 0)
            return 1;
        return 5;
    }
    var localeEn = [
        'en', [['a', 'p'], ['AM', 'PM'], u], [['AM', 'PM'], u, u],
        [
            ['S', 'M', 'T', 'W', 'T', 'F', 'S'], ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'],
            ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'],
            ['Su', 'Mo', 'Tu', 'We', 'Th', 'Fr', 'Sa']
        ],
        u,
        [
            ['J', 'F', 'M', 'A', 'M', 'J', 'J', 'A', 'S', 'O', 'N', 'D'],
            ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'],
            [
                'January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September',
                'October', 'November', 'December'
            ]
        ],
        u, [['B', 'A'], ['BC', 'AD'], ['Before Christ', 'Anno Domini']], 0, [6, 0],
        ['M/d/yy', 'MMM d, y', 'MMMM d, y', 'EEEE, MMMM d, y'],
        ['h:mm a', 'h:mm:ss a', 'h:mm:ss a z', 'h:mm:ss a zzzz'], ['{1}, {0}', u, '{1} \'at\' {0}', u],
        ['.', ',', ';', '%', '+', '-', 'E', '×', '‰', '∞', 'NaN', ':'],
        ['#,##0.###', '#,##0%', '¤#,##0.00', '#E0'], '$', 'US Dollar', {}, plural
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Retrieves the plural function used by ICU expressions to determine the plural case to use
     * for a given locale.
     * @see `NgPlural` / [Internationalization (i18n) Guide](https://angular.io/guide/i18n)
     * @param {?} locale A locale code for the locale format rules to use.
     * @return {?} The plural function for the locale.
     */
    function getLocalePluralCase(locale) {
        /** @type {?} */
        var data = findLocaleData(locale);
        return data[LocaleDataIndex.PluralCase];
    }
    /**
     * Finds the locale data for a given locale.
     *
     * @see [Internationalization (i18n) Guide](https://angular.io/guide/i18n)
     * @param {?} locale The locale code.
     * @return {?} The locale data.
     */
    function findLocaleData(locale) {
        /** @type {?} */
        var normalizedLocale = locale.toLowerCase().replace(/_/g, '-');
        /** @type {?} */
        var match = LOCALE_DATA[normalizedLocale];
        if (match) {
            return match;
        }
        // let's try to find a parent locale
        /** @type {?} */
        var parentLocale = normalizedLocale.split('-')[0];
        match = LOCALE_DATA[parentLocale];
        if (match) {
            return match;
        }
        if (parentLocale === 'en') {
            return localeEn;
        }
        throw new Error("Missing locale data for the locale \"" + locale + "\".");
    }
    /**
     * The locale id that the application is using by default (for translations and ICU expressions).
     * @type {?}
     */
    var DEFAULT_LOCALE_ID = 'en-US';
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Use in components with the `\@Output` directive to emit custom events
     * synchronously or asynchronously, and register handlers for those events
     * by subscribing to an instance.
     *
     * \@usageNotes
     *
     * Extends
     * [RxJS `Subject`](https://rxjs.dev/api/index/class/Subject)
     * for Angular by adding the `emit()` method.
     *
     * In the following example, a component defines two output properties
     * that create event emitters. When the title is clicked, the emitter
     * emits an open or close event to toggle the current visibility state.
     *
     * ```html
     * \@Component({
     *   selector: 'zippy',
     *   template: `
     *   <div class="zippy">
     *     <div (click)="toggle()">Toggle</div>
     *     <div [hidden]="!visible">
     *       <ng-content></ng-content>
     *     </div>
     *  </div>`})
     * export class Zippy {
     *   visible: boolean = true;
     * \@Output() open: EventEmitter<any> = new EventEmitter();
     * \@Output() close: EventEmitter<any> = new EventEmitter();
     *
     *   toggle() {
     *     this.visible = !this.visible;
     *     if (this.visible) {
     *       this.open.emit(null);
     *     } else {
     *       this.close.emit(null);
     *     }
     *   }
     * }
     * ```
     *
     * Access the event object with the `$event` argument passed to the output event
     * handler:
     *
     * ```html
     * <zippy (open)="onOpen($event)" (close)="onClose($event)"></zippy>
     * ```
     *
     * @see [Observables in Angular](guide/observables-in-angular)
     * \@publicApi
     * @template T
     */
    var EventEmitter = /** @class */ (function (_super) {
        __extends(EventEmitter, _super);
        // tslint:disable-line
        /**
         * Creates an instance of this class that can
         * deliver events synchronously or asynchronously.
         *
         * @param {?=} isAsync When true, deliver events asynchronously.
         *
         */
        function EventEmitter(isAsync) {
            if (isAsync === void 0) { isAsync = false; }
            var _this = _super.call(this) || this;
            _this.__isAsync = isAsync;
            return _this;
        }
        /**
         * Emits an event containing a given value.
         * @param {?=} value The value to emit.
         * @return {?}
         */
        EventEmitter.prototype.emit = function (value) { _super.prototype.next.call(this, value); };
        /**
         * Registers handlers for events emitted by this instance.
         * @param {?=} generatorOrNext When supplied, a custom handler for emitted events.
         * @param {?=} error When supplied, a custom handler for an error notification
         * from this emitter.
         * @param {?=} complete When supplied, a custom handler for a completion
         * notification from this emitter.
         * @return {?}
         */
        EventEmitter.prototype.subscribe = function (generatorOrNext, error, complete) {
            /** @type {?} */
            var schedulerFn;
            /** @type {?} */
            var errorFn = ( /**
             * @param {?} err
             * @return {?}
             */function (err) { return null; });
            /** @type {?} */
            var completeFn = ( /**
             * @return {?}
             */function () { return null; });
            if (generatorOrNext && typeof generatorOrNext === 'object') {
                schedulerFn = this.__isAsync ? ( /**
                 * @param {?} value
                 * @return {?}
                 */function (value) {
                    setTimeout(( /**
                     * @return {?}
                     */function () { return generatorOrNext.next(value); }));
                }) : ( /**
                 * @param {?} value
                 * @return {?}
                 */function (value) { generatorOrNext.next(value); });
                if (generatorOrNext.error) {
                    errorFn = this.__isAsync ? ( /**
                     * @param {?} err
                     * @return {?}
                     */function (err) {
                        setTimeout(( /**
                         * @return {?}
                         */function () { return generatorOrNext.error(err); }));
                    }) :
                        ( /**
                         * @param {?} err
                         * @return {?}
                         */function (err) { generatorOrNext.error(err); });
                }
                if (generatorOrNext.complete) {
                    completeFn = this.__isAsync ? ( /**
                     * @return {?}
                     */function () {
                        setTimeout(( /**
                         * @return {?}
                         */function () { return generatorOrNext.complete(); }));
                    }) :
                        ( /**
                         * @return {?}
                         */function () { generatorOrNext.complete(); });
                }
            }
            else {
                schedulerFn = this.__isAsync ? ( /**
                 * @param {?} value
                 * @return {?}
                 */function (value) {
                    setTimeout(( /**
                     * @return {?}
                     */function () { return generatorOrNext(value); }));
                }) :
                    ( /**
                     * @param {?} value
                     * @return {?}
                     */function (value) { generatorOrNext(value); });
                if (error) {
                    errorFn =
                        this.__isAsync ? ( /**
                         * @param {?} err
                         * @return {?}
                         */function (err) {
                            setTimeout(( /**
                             * @return {?}
                             */function () { return error(err); }));
                        }) : ( /**
                         * @param {?} err
                         * @return {?}
                         */function (err) { error(err); });
                }
                if (complete) {
                    completeFn =
                        this.__isAsync ? ( /**
                         * @return {?}
                         */function () {
                            setTimeout(( /**
                             * @return {?}
                             */function () { return complete(); }));
                        }) : ( /**
                         * @return {?}
                         */function () { complete(); });
                }
            }
            /** @type {?} */
            var sink = _super.prototype.subscribe.call(this, schedulerFn, errorFn, completeFn);
            if (generatorOrNext instanceof Subscription) {
                generatorOrNext.add(sink);
            }
            return sink;
        };
        return EventEmitter;
    }(Subject));
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     * @this {?}
     * @return {?}
     */
    function symbolIterator() {
        return (( /** @type {?} */((( /** @type {?} */(( /** @type {?} */(this)))))._results)))[getSymbolIterator$1()]();
    }
    /**
     * An unmodifiable list of items that Angular keeps up to date when the state
     * of the application changes.
     *
     * The type of object that {\@link ViewChildren}, {\@link ContentChildren}, and {\@link QueryList}
     * provide.
     *
     * Implements an iterable interface, therefore it can be used in both ES6
     * javascript `for (var i of items)` loops as well as in Angular templates with
     * `*ngFor="let i of myList"`.
     *
     * Changes can be observed by subscribing to the changes `Observable`.
     *
     * NOTE: In the future this class will implement an `Observable` interface.
     *
     * \@usageNotes
     * ### Example
     * ```typescript
     * \@Component({...})
     * class Container {
     * \@ViewChildren(Item) items:QueryList<Item>;
     * }
     * ```
     *
     * \@publicApi
     * @template T
     */
    var QueryList = /** @class */ (function () {
        function QueryList() {
            this.dirty = true;
            this._results = [];
            this.changes = new EventEmitter();
            this.length = 0;
            // This function should be declared on the prototype, but doing so there will cause the class
            // declaration to have side-effects and become not tree-shakable. For this reason we do it in
            // the constructor.
            // [getSymbolIterator()](): Iterator<T> { ... }
            /** @type {?} */
            var symbol = getSymbolIterator$1();
            /** @type {?} */
            var proto = ( /** @type {?} */(QueryList.prototype));
            if (!proto[symbol])
                proto[symbol] = symbolIterator;
        }
        /**
         * See
         * [Array.map](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/map)
         * @template U
         * @param {?} fn
         * @return {?}
         */
        QueryList.prototype.map = function (fn) { return this._results.map(fn); };
        /**
         * See
         * [Array.filter](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/filter)
         * @param {?} fn
         * @return {?}
         */
        QueryList.prototype.filter = function (fn) {
            return this._results.filter(fn);
        };
        /**
         * See
         * [Array.find](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/find)
         * @param {?} fn
         * @return {?}
         */
        QueryList.prototype.find = function (fn) {
            return this._results.find(fn);
        };
        /**
         * See
         * [Array.reduce](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/reduce)
         * @template U
         * @param {?} fn
         * @param {?} init
         * @return {?}
         */
        QueryList.prototype.reduce = function (fn, init) {
            return this._results.reduce(fn, init);
        };
        /**
         * See
         * [Array.forEach](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/forEach)
         * @param {?} fn
         * @return {?}
         */
        QueryList.prototype.forEach = function (fn) { this._results.forEach(fn); };
        /**
         * See
         * [Array.some](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/some)
         * @param {?} fn
         * @return {?}
         */
        QueryList.prototype.some = function (fn) {
            return this._results.some(fn);
        };
        /**
         * Returns a copy of the internal results list as an Array.
         * @return {?}
         */
        QueryList.prototype.toArray = function () { return this._results.slice(); };
        /**
         * @return {?}
         */
        QueryList.prototype.toString = function () { return this._results.toString(); };
        /**
         * Updates the stored data of the query list, and resets the `dirty` flag to `false`, so that
         * on change detection, it will not notify of changes to the queries, unless a new change
         * occurs.
         *
         * @param {?} resultsTree The query results to store
         * @return {?}
         */
        QueryList.prototype.reset = function (resultsTree) {
            this._results = flatten(resultsTree);
            (( /** @type {?} */(this))).dirty = false;
            (( /** @type {?} */(this))).length = this._results.length;
            (( /** @type {?} */(this))).last = this._results[this.length - 1];
            (( /** @type {?} */(this))).first = this._results[0];
        };
        /**
         * Triggers a change event by emitting on the `changes` {\@link EventEmitter}.
         * @return {?}
         */
        QueryList.prototype.notifyOnChanges = function () { (( /** @type {?} */(this.changes))).emit(this); };
        /**
         * internal
         * @return {?}
         */
        QueryList.prototype.setDirty = function () { (( /** @type {?} */(this))).dirty = true; };
        /**
         * internal
         * @return {?}
         */
        QueryList.prototype.destroy = function () {
            (( /** @type {?} */(this.changes))).complete();
            (( /** @type {?} */(this.changes))).unsubscribe();
        };
        return QueryList;
    }());
    // WARNING: interface has both a type and a value, skipping emit
    var ɵ0$f = /**
     * @param {?=} dir
     * @return {?}
     */ function (dir) {
        if (dir === void 0) { dir = {}; }
        return dir;
    }, ɵ1$4 = /**
     * @param {?} type
     * @param {?} meta
     * @return {?}
     */ function (type, meta) { return SWITCH_COMPILE_DIRECTIVE(type, meta); };
    /**
     * Type of the Directive metadata.
     *
     * \@publicApi
     * @type {?}
     */
    var Directive = makeDecorator('Directive', (ɵ0$f), undefined, undefined, (ɵ1$4));
    // WARNING: interface has both a type and a value, skipping emit
    var ɵ2$1 = /**
     * @param {?=} c
     * @return {?}
     */ function (c) {
        if (c === void 0) { c = {}; }
        return (Object.assign({ changeDetection: ChangeDetectionStrategy.Default }, c));
    }, ɵ3$1 = /**
     * @param {?} type
     * @param {?} meta
     * @return {?}
     */ function (type, meta) { return SWITCH_COMPILE_COMPONENT(type, meta); };
    /**
     * Component decorator and metadata.
     *
     * \@Annotation
     * \@publicApi
     * @type {?}
     */
    var Component = makeDecorator('Component', (ɵ2$1), Directive, undefined, (ɵ3$1));
    // WARNING: interface has both a type and a value, skipping emit
    var ɵ4 = /**
     * @param {?} p
     * @return {?}
     */ function (p) { return (Object.assign({ pure: true }, p)); }, ɵ5 = /**
     * @param {?} type
     * @param {?} meta
     * @return {?}
     */ function (type, meta) { return SWITCH_COMPILE_PIPE(type, meta); };
    /**
     * \@Annotation
     * \@publicApi
     * @type {?}
     */
    var Pipe = makeDecorator('Pipe', (ɵ4), undefined, undefined, (ɵ5));
    // WARNING: interface has both a type and a value, skipping emit
    var ɵ6 = /**
     * @param {?=} bindingPropertyName
     * @return {?}
     */ function (bindingPropertyName) { return ({ bindingPropertyName: bindingPropertyName }); };
    /**
     * \@Annotation
     * \@publicApi
     * @type {?}
     */
    var Input = makePropDecorator('Input', (ɵ6));
    // WARNING: interface has both a type and a value, skipping emit
    var ɵ7 = /**
     * @param {?=} bindingPropertyName
     * @return {?}
     */ function (bindingPropertyName) { return ({ bindingPropertyName: bindingPropertyName }); };
    /**
     * \@Annotation
     * \@publicApi
     * @type {?}
     */
    var Output = makePropDecorator('Output', (ɵ7));
    // WARNING: interface has both a type and a value, skipping emit
    var ɵ8 = /**
     * @param {?=} hostPropertyName
     * @return {?}
     */ function (hostPropertyName) { return ({ hostPropertyName: hostPropertyName }); };
    /**
     * \@Annotation
     * \@publicApi
     * @type {?}
     */
    var HostBinding = makePropDecorator('HostBinding', (ɵ8));
    // WARNING: interface has both a type and a value, skipping emit
    var ɵ9 = /**
     * @param {?=} eventName
     * @param {?=} args
     * @return {?}
     */ function (eventName, args) { return ({ eventName: eventName, args: args }); };
    /**
     * Decorator that binds a DOM event to a host listener and supplies configuration metadata.
     * Angular invokes the supplied handler method when the host element emits the specified event,
     * and updates the bound element with the result.
     *
     * If the handler method returns false, applies `preventDefault` on the bound element.
     *
     * \@usageNotes
     *
     * The following example declares a directive
     * that attaches a click listener to a button and counts clicks.
     *
     * ```ts
     * \@Directive({selector: 'button[counting]'})
     * class CountClicks {
     *   numberOfClicks = 0;
     *
     * \@HostListener('click', ['$event.target'])
     *   onClick(btn) {
     *     console.log('button', btn, 'number of clicks:', this.numberOfClicks++);
     *  }
     * }
     *
     * \@Component({
     *   selector: 'app',
     *   template: '<button counting>Increment</button>',
     * })
     * class App {}
     * ```
     *
     * \@Annotation
     * \@publicApi
     * @type {?}
     */
    var HostListener = makePropDecorator('HostListener', (ɵ9));
    /** @type {?} */
    var SWITCH_COMPILE_COMPONENT__PRE_R3__ = noop$1;
    /** @type {?} */
    var SWITCH_COMPILE_DIRECTIVE__PRE_R3__ = noop$1;
    /** @type {?} */
    var SWITCH_COMPILE_PIPE__PRE_R3__ = noop$1;
    /** @type {?} */
    var SWITCH_COMPILE_COMPONENT = SWITCH_COMPILE_COMPONENT__PRE_R3__;
    /** @type {?} */
    var SWITCH_COMPILE_DIRECTIVE = SWITCH_COMPILE_DIRECTIVE__PRE_R3__;
    /** @type {?} */
    var SWITCH_COMPILE_PIPE = SWITCH_COMPILE_PIPE__PRE_R3__;
    // WARNING: interface has both a type and a value, skipping emit
    var ɵ0$g = /**
     * @param {?} ngModule
     * @return {?}
     */ function (ngModule) { return ngModule; }, ɵ1$5 = /**
     * Decorator that marks the following class as an NgModule, and supplies
     * configuration metadata for it.
     *
     * * The `declarations` and `entryComponents` options configure the compiler
     * with information about what belongs to the NgModule.
     * * The `providers` options configures the NgModule's injector to provide
     * dependencies the NgModule members.
     * * The `imports` and `exports` options bring in members from other modules, and make
     * this module's members available to others.
     * @param {?} type
     * @param {?} meta
     * @return {?}
     */ function (type, meta) { return SWITCH_COMPILE_NGMODULE(type, meta); };
    /**
     * \@Annotation
     * \@publicApi
     * @type {?}
     */
    var NgModule = makeDecorator('NgModule', (ɵ0$g), undefined, undefined, (ɵ1$5));
    /**
     * @param {?} moduleType
     * @param {?=} metadata
     * @return {?}
     */
    function preR3NgModuleCompile(moduleType, metadata) {
        /** @type {?} */
        var imports = (metadata && metadata.imports) || [];
        if (metadata && metadata.exports) {
            imports = __spread(imports, [metadata.exports]);
        }
        (( /** @type {?} */(moduleType))).ngInjectorDef = ɵɵdefineInjector({
            factory: convertInjectableProviderToFactory(moduleType, { useClass: moduleType }),
            providers: metadata && metadata.providers,
            imports: imports,
        });
    }
    /** @type {?} */
    var SWITCH_COMPILE_NGMODULE__PRE_R3__ = preR3NgModuleCompile;
    /** @type {?} */
    var SWITCH_COMPILE_NGMODULE = SWITCH_COMPILE_NGMODULE__PRE_R3__;
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A function that will be executed when an application is initialized.
     *
     * \@publicApi
     * @type {?}
     */
    var APP_INITIALIZER = new InjectionToken('Application Initializer');
    /**
     * A class that reflects the state of running {\@link APP_INITIALIZER}s.
     *
     * \@publicApi
     */
    var ApplicationInitStatus = /** @class */ (function () {
        /**
         * @param {?} appInits
         */
        function ApplicationInitStatus(appInits) {
            var _this = this;
            this.appInits = appInits;
            this.initialized = false;
            this.done = false;
            this.donePromise = new Promise(( /**
             * @param {?} res
             * @param {?} rej
             * @return {?}
             */function (res, rej) {
                _this.resolve = res;
                _this.reject = rej;
            }));
        }
        /**
         * \@internal
         * @return {?}
         */
        ApplicationInitStatus.prototype.runInitializers = function () {
            var _this = this;
            if (this.initialized) {
                return;
            }
            /** @type {?} */
            var asyncInitPromises = [];
            /** @type {?} */
            var complete = ( /**
             * @return {?}
             */function () {
                (( /** @type {?} */(_this))).done = true;
                _this.resolve();
            });
            if (this.appInits) {
                for (var i_77 = 0; i_77 < this.appInits.length; i_77++) {
                    /** @type {?} */
                    var initResult = this.appInits[i_77]();
                    if (isPromise$1(initResult)) {
                        asyncInitPromises.push(initResult);
                    }
                }
            }
            Promise.all(asyncInitPromises).then(( /**
             * @return {?}
             */function () { complete(); })).catch(( /**
             * @param {?} e
             * @return {?}
             */function (/**
             * @param {?} e
             * @return {?}
             */ e) { _this.reject(e); }));
            if (asyncInitPromises.length === 0) {
                complete();
            }
            this.initialized = true;
        };
        return ApplicationInitStatus;
    }());
    ApplicationInitStatus.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    ApplicationInitStatus.ctorParameters = function () { return [
        { type: Array, decorators: [{ type: Inject, args: [APP_INITIALIZER,] }, { type: Optional }] }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A DI Token representing a unique string id assigned to the application by Angular and used
     * primarily for prefixing application attributes and CSS styles when
     * {\@link ViewEncapsulation#Emulated ViewEncapsulation.Emulated} is being used.
     *
     * If you need to avoid randomly generated value to be used as an application id, you can provide
     * a custom value via a DI provider <!-- TODO: provider --> configuring the root {\@link Injector}
     * using this token.
     * \@publicApi
     * @type {?}
     */
    var APP_ID = new InjectionToken('AppId');
    /**
     * @return {?}
     */
    function _appIdRandomProviderFactory() {
        return "" + _randomChar() + _randomChar() + _randomChar();
    }
    /**
     * Providers that will generate a random APP_ID_TOKEN.
     * \@publicApi
     * @type {?}
     */
    var APP_ID_RANDOM_PROVIDER = {
        provide: APP_ID,
        useFactory: _appIdRandomProviderFactory,
        deps: ( /** @type {?} */([])),
    };
    /**
     * @return {?}
     */
    function _randomChar() {
        return String.fromCharCode(97 + Math.floor(Math.random() * 25));
    }
    /**
     * A function that will be executed when a platform is initialized.
     * \@publicApi
     * @type {?}
     */
    var PLATFORM_INITIALIZER = new InjectionToken('Platform Initializer');
    /**
     * A token that indicates an opaque platform id.
     * \@publicApi
     * @type {?}
     */
    var PLATFORM_ID = new InjectionToken('Platform ID');
    /**
     * All callbacks provided via this token will be called for every component that is bootstrapped.
     * Signature of the callback:
     *
     * `(componentRef: ComponentRef) => void`.
     *
     * \@publicApi
     * @type {?}
     */
    var APP_BOOTSTRAP_LISTENER = new InjectionToken('appBootstrapListener');
    /**
     * A token which indicates the root directory of the application
     * \@publicApi
     * @type {?}
     */
    var PACKAGE_ROOT_URL = new InjectionToken('Application Packages Root URL');
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Console = /** @class */ (function () {
        function Console() {
        }
        /**
         * @param {?} message
         * @return {?}
         */
        Console.prototype.log = function (message) {
            // tslint:disable-next-line:no-console
            console.log(message);
        };
        // Note: for reporting errors use `DOM.logError()` as it is platform specific
        /**
         * @param {?} message
         * @return {?}
         */
        Console.prototype.warn = function (message) {
            // tslint:disable-next-line:no-console
            console.warn(message);
        };
        return Console;
    }());
    Console.decorators = [
        { type: Injectable }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Provide this token to set the locale of your application.
     * It is used for i18n extraction, by i18n pipes (DatePipe, I18nPluralPipe, CurrencyPipe,
     * DecimalPipe and PercentPipe) and by ICU expressions.
     *
     * See the [i18n guide](guide/i18n#setting-up-locale) for more information.
     *
     * \@usageNotes
     * ### Example
     *
     * ```typescript
     * import { LOCALE_ID } from '\@angular/core';
     * import { platformBrowserDynamic } from '\@angular/platform-browser-dynamic';
     * import { AppModule } from './app/app.module';
     *
     * platformBrowserDynamic().bootstrapModule(AppModule, {
     *   providers: [{provide: LOCALE_ID, useValue: 'en-US' }]
     * });
     * ```
     *
     * \@publicApi
     * @type {?}
     */
    var LOCALE_ID$1 = new InjectionToken('LocaleId');
    /**
     * Use this token at bootstrap to provide the content of your translation file (`xtb`,
     * `xlf` or `xlf2`) when you want to translate your application in another language.
     *
     * See the [i18n guide](guide/i18n#merge) for more information.
     *
     * \@usageNotes
     * ### Example
     *
     * ```typescript
     * import { TRANSLATIONS } from '\@angular/core';
     * import { platformBrowserDynamic } from '\@angular/platform-browser-dynamic';
     * import { AppModule } from './app/app.module';
     *
     * // content of your translation file
     * const translations = '....';
     *
     * platformBrowserDynamic().bootstrapModule(AppModule, {
     *   providers: [{provide: TRANSLATIONS, useValue: translations }]
     * });
     * ```
     *
     * \@publicApi
     * @type {?}
     */
    var TRANSLATIONS$1 = new InjectionToken('Translations');
    /**
     * Provide this token at bootstrap to set the format of your {\@link TRANSLATIONS}: `xtb`,
     * `xlf` or `xlf2`.
     *
     * See the [i18n guide](guide/i18n#merge) for more information.
     *
     * \@usageNotes
     * ### Example
     *
     * ```typescript
     * import { TRANSLATIONS_FORMAT } from '\@angular/core';
     * import { platformBrowserDynamic } from '\@angular/platform-browser-dynamic';
     * import { AppModule } from './app/app.module';
     *
     * platformBrowserDynamic().bootstrapModule(AppModule, {
     *   providers: [{provide: TRANSLATIONS_FORMAT, useValue: 'xlf' }]
     * });
     * ```
     *
     * \@publicApi
     * @type {?}
     */
    var TRANSLATIONS_FORMAT = new InjectionToken('TranslationsFormat');
    /**
     * @return {?}
     */
    function _throwError() {
        throw new Error("Runtime compiler is not loaded");
    }
    /** @type {?} */
    var Compiler_compileModuleSync__PRE_R3__ = ( /** @type {?} */(_throwError));
    /** @type {?} */
    var Compiler_compileModuleSync = Compiler_compileModuleSync__PRE_R3__;
    /** @type {?} */
    var Compiler_compileModuleAsync__PRE_R3__ = ( /** @type {?} */(_throwError));
    /** @type {?} */
    var Compiler_compileModuleAsync = Compiler_compileModuleAsync__PRE_R3__;
    /** @type {?} */
    var Compiler_compileModuleAndAllComponentsSync__PRE_R3__ = ( /** @type {?} */(_throwError));
    /** @type {?} */
    var Compiler_compileModuleAndAllComponentsSync = Compiler_compileModuleAndAllComponentsSync__PRE_R3__;
    /** @type {?} */
    var Compiler_compileModuleAndAllComponentsAsync__PRE_R3__ = ( /** @type {?} */(_throwError));
    /** @type {?} */
    var Compiler_compileModuleAndAllComponentsAsync = Compiler_compileModuleAndAllComponentsAsync__PRE_R3__;
    /**
     * Low-level service for running the angular compiler during runtime
     * to create {\@link ComponentFactory}s, which
     * can later be used to create and render a Component instance.
     *
     * Each `\@NgModule` provides an own `Compiler` to its injector,
     * that will use the directives/pipes of the ng module for compilation
     * of components.
     *
     * \@publicApi
     */
    var Compiler = /** @class */ (function () {
        function Compiler() {
            /**
             * Compiles the given NgModule and all of its components. All templates of the components listed
             * in `entryComponents` have to be inlined.
             */
            this.compileModuleSync = Compiler_compileModuleSync;
            /**
             * Compiles the given NgModule and all of its components
             */
            this.compileModuleAsync = Compiler_compileModuleAsync;
            /**
             * Same as {\@link #compileModuleSync} but also creates ComponentFactories for all components.
             */
            this.compileModuleAndAllComponentsSync = Compiler_compileModuleAndAllComponentsSync;
            /**
             * Same as {\@link #compileModuleAsync} but also creates ComponentFactories for all components.
             */
            this.compileModuleAndAllComponentsAsync = Compiler_compileModuleAndAllComponentsAsync;
        }
        /**
         * Clears all caches.
         * @return {?}
         */
        Compiler.prototype.clearCache = function () { };
        /**
         * Clears the cache for the given component/ngModule.
         * @param {?} type
         * @return {?}
         */
        Compiler.prototype.clearCacheFor = function (type) { };
        /**
         * Returns the id for a given NgModule, if one is defined and known to the compiler.
         * @param {?} moduleType
         * @return {?}
         */
        Compiler.prototype.getModuleId = function (moduleType) { return undefined; };
        return Compiler;
    }());
    Compiler.decorators = [
        { type: Injectable }
    ];
    /**
     * Token to provide CompilerOptions in the platform injector.
     *
     * \@publicApi
     * @type {?}
     */
    var COMPILER_OPTIONS = new InjectionToken('compilerOptions');
    /**
     * A factory for creating a Compiler
     *
     * \@publicApi
     * @abstract
     */
    var CompilerFactory = /** @class */ (function () {
        function CompilerFactory() {
        }
        return CompilerFactory;
    }());
    /** @type {?} */
    var trace;
    /** @type {?} */
    var events;
    /**
     * @return {?}
     */
    function detectWTF() {
        /** @type {?} */
        var wtf = (( /** @type {?} */(_global)))['wtf'];
        if (wtf) {
            trace = wtf['trace'];
            if (trace) {
                events = trace['events'];
                return true;
            }
        }
        return false;
    }
    /**
     * @param {?} signature
     * @param {?=} flags
     * @return {?}
     */
    function createScope(signature, flags) {
        if (flags === void 0) { flags = null; }
        return events.createScope(signature, flags);
    }
    /**
     * @template T
     * @param {?} scope
     * @param {?=} returnValue
     * @return {?}
     */
    function leave(scope, returnValue) {
        trace.leaveScope(scope, returnValue);
        return returnValue;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * True if WTF is enabled.
     * @type {?}
     */
    var wtfEnabled = detectWTF();
    /**
     * @param {?=} arg0
     * @param {?=} arg1
     * @return {?}
     */
    function noopScope(arg0, arg1) {
        return null;
    }
    /**
     * Create trace scope.
     *
     * Scopes must be strictly nested and are analogous to stack frames, but
     * do not have to follow the stack frames. Instead it is recommended that they follow logical
     * nesting. You may want to use
     * [Event
     * Signatures](http://google.github.io/tracing-framework/instrumenting-code.html#custom-events)
     * as they are defined in WTF.
     *
     * Used to mark scope entry. The return value is used to leave the scope.
     *
     *     var myScope = wtfCreateScope('MyClass#myMethod(ascii someVal)');
     *
     *     someMethod() {
     *        var s = myScope('Foo'); // 'Foo' gets stored in tracing UI
     *        // DO SOME WORK HERE
     *        return wtfLeave(s, 123); // Return value 123
     *     }
     *
     * Note, adding try-finally block around the work to ensure that `wtfLeave` gets called can
     * negatively impact the performance of your application. For this reason we recommend that
     * you don't add them to ensure that `wtfLeave` gets called. In production `wtfLeave` is a noop and
     * so try-finally block has no value. When debugging perf issues, skipping `wtfLeave`, do to
     * exception, will produce incorrect trace, but presence of exception signifies logic error which
     * needs to be fixed before the app should be profiled. Add try-finally only when you expect that
     * an exception is expected during normal execution while profiling.
     *
     * \@publicApi
     * @deprecated the Web Tracing Framework is no longer supported in Angular
     * @type {?}
     */
    var wtfCreateScope = wtfEnabled ? createScope : ( /**
     * @param {?} signature
     * @param {?=} flags
     * @return {?}
     */function (signature, flags) { return noopScope; });
    /**
     * Used to mark end of Scope.
     *
     * - `scope` to end.
     * - `returnValue` (optional) to be passed to the WTF.
     *
     * Returns the `returnValue for easy chaining.
     * \@publicApi
     * @deprecated the Web Tracing Framework is no longer supported in Angular
     * @type {?}
     */
    var wtfLeave = wtfEnabled ? leave : ( /**
     * @param {?} s
     * @param {?=} r
     * @return {?}
     */function (s, r) { return r; });
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    var promise = (function () { return Promise.resolve(0); })();
    function scheduleMicroTask(fn) {
        if (typeof Zone === 'undefined') {
            // use promise to schedule microTask instead of use Zone
            promise.then(function () { fn && fn.apply(null, null); });
        }
        else {
            Zone.current.scheduleMicroTask('scheduleMicrotask', fn);
        }
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * An injectable service for executing work inside or outside of the Angular zone.
     *
     * The most common use of this service is to optimize performance when starting a work consisting of
     * one or more asynchronous tasks that don't require UI updates or error handling to be handled by
     * Angular. Such tasks can be kicked off via {\@link #runOutsideAngular} and if needed, these tasks
     * can reenter the Angular zone via {\@link #run}.
     *
     * <!-- TODO: add/fix links to:
     *   - docs explaining zones and the use of zones in Angular and change-detection
     *   - link to runOutsideAngular/run (throughout this file!)
     *   -->
     *
     * \@usageNotes
     * ### Example
     *
     * ```
     * import {Component, NgZone} from '\@angular/core';
     * import {NgIf} from '\@angular/common';
     *
     * \@Component({
     *   selector: 'ng-zone-demo',
     *   template: `
     *     <h2>Demo: NgZone</h2>
     *
     *     <p>Progress: {{progress}}%</p>
     *     <p *ngIf="progress >= 100">Done processing {{label}} of Angular zone!</p>
     *
     *     <button (click)="processWithinAngularZone()">Process within Angular zone</button>
     *     <button (click)="processOutsideOfAngularZone()">Process outside of Angular zone</button>
     *   `,
     * })
     * export class NgZoneDemo {
     *   progress: number = 0;
     *   label: string;
     *
     *   constructor(private _ngZone: NgZone) {}
     *
     *   // Loop inside the Angular zone
     *   // so the UI DOES refresh after each setTimeout cycle
     *   processWithinAngularZone() {
     *     this.label = 'inside';
     *     this.progress = 0;
     *     this._increaseProgress(() => console.log('Inside Done!'));
     *   }
     *
     *   // Loop outside of the Angular zone
     *   // so the UI DOES NOT refresh after each setTimeout cycle
     *   processOutsideOfAngularZone() {
     *     this.label = 'outside';
     *     this.progress = 0;
     *     this._ngZone.runOutsideAngular(() => {
     *       this._increaseProgress(() => {
     *         // reenter the Angular zone and display done
     *         this._ngZone.run(() => { console.log('Outside Done!'); });
     *       });
     *     });
     *   }
     *
     *   _increaseProgress(doneCallback: () => void) {
     *     this.progress += 1;
     *     console.log(`Current progress: ${this.progress}%`);
     *
     *     if (this.progress < 100) {
     *       window.setTimeout(() => this._increaseProgress(doneCallback), 10);
     *     } else {
     *       doneCallback();
     *     }
     *   }
     * }
     * ```
     *
     * \@publicApi
     */
    var NgZone = /** @class */ (function () {
        /**
         * @param {?} __0
         */
        function NgZone(_b) {
            var _c = _b.enableLongStackTrace, enableLongStackTrace = _c === void 0 ? false : _c;
            this.hasPendingMicrotasks = false;
            this.hasPendingMacrotasks = false;
            /**
             * Whether there are no outstanding microtasks or macrotasks.
             */
            this.isStable = true;
            /**
             * Notifies when code enters Angular Zone. This gets fired first on VM Turn.
             */
            this.onUnstable = new EventEmitter(false);
            /**
             * Notifies when there is no more microtasks enqueued in the current VM Turn.
             * This is a hint for Angular to do change detection, which may enqueue more microtasks.
             * For this reason this event can fire multiple times per VM Turn.
             */
            this.onMicrotaskEmpty = new EventEmitter(false);
            /**
             * Notifies when the last `onMicrotaskEmpty` has run and there are no more microtasks, which
             * implies we are about to relinquish VM turn.
             * This event gets called just once.
             */
            this.onStable = new EventEmitter(false);
            /**
             * Notifies that an error has been delivered.
             */
            this.onError = new EventEmitter(false);
            if (typeof Zone == 'undefined') {
                throw new Error("In this configuration Angular requires Zone.js");
            }
            Zone.assertZonePatched();
            /** @type {?} */
            var self = ( /** @type {?} */(( /** @type {?} */(this))));
            self._nesting = 0;
            self._outer = self._inner = Zone.current;
            if ((( /** @type {?} */(Zone)))['wtfZoneSpec']) {
                self._inner = self._inner.fork((( /** @type {?} */(Zone)))['wtfZoneSpec']);
            }
            if ((( /** @type {?} */(Zone)))['TaskTrackingZoneSpec']) {
                self._inner = self._inner.fork(new (( /** @type {?} */((( /** @type {?} */(Zone)))['TaskTrackingZoneSpec']))));
            }
            if (enableLongStackTrace && (( /** @type {?} */(Zone)))['longStackTraceZoneSpec']) {
                self._inner = self._inner.fork((( /** @type {?} */(Zone)))['longStackTraceZoneSpec']);
            }
            forkInnerZoneWithAngularBehavior(self);
        }
        /**
         * @return {?}
         */
        NgZone.isInAngularZone = function () { return Zone.current.get('isAngularZone') === true; };
        /**
         * @return {?}
         */
        NgZone.assertInAngularZone = function () {
            if (!NgZone.isInAngularZone()) {
                throw new Error('Expected to be in Angular Zone, but it is not!');
            }
        };
        /**
         * @return {?}
         */
        NgZone.assertNotInAngularZone = function () {
            if (NgZone.isInAngularZone()) {
                throw new Error('Expected to not be in Angular Zone, but it is!');
            }
        };
        /**
         * Executes the `fn` function synchronously within the Angular zone and returns value returned by
         * the function.
         *
         * Running functions via `run` allows you to reenter Angular zone from a task that was executed
         * outside of the Angular zone (typically started via {\@link #runOutsideAngular}).
         *
         * Any future tasks or microtasks scheduled from within this function will continue executing from
         * within the Angular zone.
         *
         * If a synchronous error happens it will be rethrown and not reported via `onError`.
         * @template T
         * @param {?} fn
         * @param {?=} applyThis
         * @param {?=} applyArgs
         * @return {?}
         */
        NgZone.prototype.run = function (fn, applyThis, applyArgs) {
            return ( /** @type {?} */((( /** @type {?} */(( /** @type {?} */(this)))))._inner.run(fn, applyThis, applyArgs)));
        };
        /**
         * Executes the `fn` function synchronously within the Angular zone as a task and returns value
         * returned by the function.
         *
         * Running functions via `run` allows you to reenter Angular zone from a task that was executed
         * outside of the Angular zone (typically started via {\@link #runOutsideAngular}).
         *
         * Any future tasks or microtasks scheduled from within this function will continue executing from
         * within the Angular zone.
         *
         * If a synchronous error happens it will be rethrown and not reported via `onError`.
         * @template T
         * @param {?} fn
         * @param {?=} applyThis
         * @param {?=} applyArgs
         * @param {?=} name
         * @return {?}
         */
        NgZone.prototype.runTask = function (fn, applyThis, applyArgs, name) {
            /** @type {?} */
            var zone = (( /** @type {?} */(( /** @type {?} */(this)))))._inner;
            /** @type {?} */
            var task = zone.scheduleEventTask('NgZoneEvent: ' + name, fn, EMPTY_PAYLOAD, noop$1$1, noop$1$1);
            try {
                return ( /** @type {?} */(zone.runTask(task, applyThis, applyArgs)));
            }
            finally {
                zone.cancelTask(task);
            }
        };
        /**
         * Same as `run`, except that synchronous errors are caught and forwarded via `onError` and not
         * rethrown.
         * @template T
         * @param {?} fn
         * @param {?=} applyThis
         * @param {?=} applyArgs
         * @return {?}
         */
        NgZone.prototype.runGuarded = function (fn, applyThis, applyArgs) {
            return ( /** @type {?} */((( /** @type {?} */(( /** @type {?} */(this)))))._inner.runGuarded(fn, applyThis, applyArgs)));
        };
        /**
         * Executes the `fn` function synchronously in Angular's parent zone and returns value returned by
         * the function.
         *
         * Running functions via {\@link #runOutsideAngular} allows you to escape Angular's zone and do
         * work that
         * doesn't trigger Angular change-detection or is subject to Angular's error handling.
         *
         * Any future tasks or microtasks scheduled from within this function will continue executing from
         * outside of the Angular zone.
         *
         * Use {\@link #run} to reenter the Angular zone and do work that updates the application model.
         * @template T
         * @param {?} fn
         * @return {?}
         */
        NgZone.prototype.runOutsideAngular = function (fn) {
            return ( /** @type {?} */((( /** @type {?} */(( /** @type {?} */(this)))))._outer.run(fn)));
        };
        return NgZone;
    }());
    /**
     * @return {?}
     */
    function noop$1$1() { }
    /** @type {?} */
    var EMPTY_PAYLOAD = {};
    /**
     * @param {?} zone
     * @return {?}
     */
    function checkStable(zone) {
        if (zone._nesting == 0 && !zone.hasPendingMicrotasks && !zone.isStable) {
            try {
                zone._nesting++;
                zone.onMicrotaskEmpty.emit(null);
            }
            finally {
                zone._nesting--;
                if (!zone.hasPendingMicrotasks) {
                    try {
                        zone.runOutsideAngular(( /**
                         * @return {?}
                         */function () { return zone.onStable.emit(null); }));
                    }
                    finally {
                        zone.isStable = true;
                    }
                }
            }
        }
    }
    /**
     * @param {?} zone
     * @return {?}
     */
    function forkInnerZoneWithAngularBehavior(zone) {
        zone._inner = zone._inner.fork({
            name: 'angular',
            properties: ( /** @type {?} */({ 'isAngularZone': true })),
            onInvokeTask: ( /**
             * @param {?} delegate
             * @param {?} current
             * @param {?} target
             * @param {?} task
             * @param {?} applyThis
             * @param {?} applyArgs
             * @return {?}
             */function (delegate, current, target, task, applyThis, applyArgs) {
                try {
                    onEnter(zone);
                    return delegate.invokeTask(target, task, applyThis, applyArgs);
                }
                finally {
                    onLeave(zone);
                }
            }),
            onInvoke: ( /**
             * @param {?} delegate
             * @param {?} current
             * @param {?} target
             * @param {?} callback
             * @param {?} applyThis
             * @param {?=} applyArgs
             * @param {?=} source
             * @return {?}
             */function (delegate, current, target, callback, applyThis, applyArgs, source) {
                try {
                    onEnter(zone);
                    return delegate.invoke(target, callback, applyThis, applyArgs, source);
                }
                finally {
                    onLeave(zone);
                }
            }),
            onHasTask: ( /**
             * @param {?} delegate
             * @param {?} current
             * @param {?} target
             * @param {?} hasTaskState
             * @return {?}
             */function (delegate, current, target, hasTaskState) {
                delegate.hasTask(target, hasTaskState);
                if (current === target) {
                    // We are only interested in hasTask events which originate from our zone
                    // (A child hasTask event is not interesting to us)
                    if (hasTaskState.change == 'microTask') {
                        zone.hasPendingMicrotasks = hasTaskState.microTask;
                        checkStable(zone);
                    }
                    else if (hasTaskState.change == 'macroTask') {
                        zone.hasPendingMacrotasks = hasTaskState.macroTask;
                    }
                }
            }),
            onHandleError: ( /**
             * @param {?} delegate
             * @param {?} current
             * @param {?} target
             * @param {?} error
             * @return {?}
             */function (delegate, current, target, error) {
                delegate.handleError(target, error);
                zone.runOutsideAngular(( /**
                 * @return {?}
                 */function () { return zone.onError.emit(error); }));
                return false;
            })
        });
    }
    /**
     * @param {?} zone
     * @return {?}
     */
    function onEnter(zone) {
        zone._nesting++;
        if (zone.isStable) {
            zone.isStable = false;
            zone.onUnstable.emit(null);
        }
    }
    /**
     * @param {?} zone
     * @return {?}
     */
    function onLeave(zone) {
        zone._nesting--;
        checkStable(zone);
    }
    /**
     * Provides a noop implementation of `NgZone` which does nothing. This zone requires explicit calls
     * to framework to perform rendering.
     */
    var NoopNgZone = /** @class */ (function () {
        function NoopNgZone() {
            this.hasPendingMicrotasks = false;
            this.hasPendingMacrotasks = false;
            this.isStable = true;
            this.onUnstable = new EventEmitter();
            this.onMicrotaskEmpty = new EventEmitter();
            this.onStable = new EventEmitter();
            this.onError = new EventEmitter();
        }
        /**
         * @param {?} fn
         * @return {?}
         */
        NoopNgZone.prototype.run = function (fn) { return fn(); };
        /**
         * @param {?} fn
         * @return {?}
         */
        NoopNgZone.prototype.runGuarded = function (fn) { return fn(); };
        /**
         * @param {?} fn
         * @return {?}
         */
        NoopNgZone.prototype.runOutsideAngular = function (fn) { return fn(); };
        /**
         * @template T
         * @param {?} fn
         * @return {?}
         */
        NoopNgZone.prototype.runTask = function (fn) { return fn(); };
        return NoopNgZone;
    }());
    /**
     * The Testability service provides testing hooks that can be accessed from
     * the browser and by services such as Protractor. Each bootstrapped Angular
     * application on the page will have an instance of Testability.
     * \@publicApi
     */
    var Testability = /** @class */ (function () {
        /**
         * @param {?} _ngZone
         */
        function Testability(_ngZone) {
            var _this = this;
            this._ngZone = _ngZone;
            this._pendingCount = 0;
            this._isZoneStable = true;
            /**
             * Whether any work was done since the last 'whenStable' callback. This is
             * useful to detect if this could have potentially destabilized another
             * component while it is stabilizing.
             * \@internal
             */
            this._didWork = false;
            this._callbacks = [];
            this.taskTrackingZone = null;
            this._watchAngularEvents();
            _ngZone.run(( /**
             * @return {?}
             */function () {
                _this.taskTrackingZone =
                    typeof Zone == 'undefined' ? null : Zone.current.get('TaskTrackingZone');
            }));
        }
        /**
         * @private
         * @return {?}
         */
        Testability.prototype._watchAngularEvents = function () {
            var _this = this;
            this._ngZone.onUnstable.subscribe({
                next: ( /**
                 * @return {?}
                 */function () {
                    _this._didWork = true;
                    _this._isZoneStable = false;
                })
            });
            this._ngZone.runOutsideAngular(( /**
             * @return {?}
             */function () {
                _this._ngZone.onStable.subscribe({
                    next: ( /**
                     * @return {?}
                     */function () {
                        NgZone.assertNotInAngularZone();
                        scheduleMicroTask(( /**
                         * @return {?}
                         */function () {
                            _this._isZoneStable = true;
                            _this._runCallbacksIfReady();
                        }));
                    })
                });
            }));
        };
        /**
         * Increases the number of pending request
         * @deprecated pending requests are now tracked with zones.
         * @return {?}
         */
        Testability.prototype.increasePendingRequestCount = function () {
            this._pendingCount += 1;
            this._didWork = true;
            return this._pendingCount;
        };
        /**
         * Decreases the number of pending request
         * @deprecated pending requests are now tracked with zones
         * @return {?}
         */
        Testability.prototype.decreasePendingRequestCount = function () {
            this._pendingCount -= 1;
            if (this._pendingCount < 0) {
                throw new Error('pending async requests below zero');
            }
            this._runCallbacksIfReady();
            return this._pendingCount;
        };
        /**
         * Whether an associated application is stable
         * @return {?}
         */
        Testability.prototype.isStable = function () {
            return this._isZoneStable && this._pendingCount === 0 && !this._ngZone.hasPendingMacrotasks;
        };
        /**
         * @private
         * @return {?}
         */
        Testability.prototype._runCallbacksIfReady = function () {
            var _this = this;
            if (this.isStable()) {
                // Schedules the call backs in a new frame so that it is always async.
                scheduleMicroTask(( /**
                 * @return {?}
                 */function () {
                    while (_this._callbacks.length !== 0) {
                        /** @type {?} */
                        var cb = ( /** @type {?} */(_this._callbacks.pop()));
                        clearTimeout(cb.timeoutId);
                        cb.doneCb(_this._didWork);
                    }
                    _this._didWork = false;
                }));
            }
            else {
                // Still not stable, send updates.
                /** @type {?} */
                var pending_1 = this.getPendingTasks();
                this._callbacks = this._callbacks.filter(( /**
                 * @param {?} cb
                 * @return {?}
                 */function (cb) {
                    if (cb.updateCb && cb.updateCb(pending_1)) {
                        clearTimeout(cb.timeoutId);
                        return false;
                    }
                    return true;
                }));
                this._didWork = true;
            }
        };
        /**
         * @private
         * @return {?}
         */
        Testability.prototype.getPendingTasks = function () {
            if (!this.taskTrackingZone) {
                return [];
            }
            // Copy the tasks data so that we don't leak tasks.
            return this.taskTrackingZone.macroTasks.map(( /**
             * @param {?} t
             * @return {?}
             */function (t) {
                return {
                    source: t.source,
                    // From TaskTrackingZone:
                    // https://github.com/angular/zone.js/blob/master/lib/zone-spec/task-tracking.ts#L40
                    creationLocation: ( /** @type {?} */((( /** @type {?} */(t))).creationLocation)),
                    data: t.data
                };
            }));
        };
        /**
         * @private
         * @param {?} cb
         * @param {?=} timeout
         * @param {?=} updateCb
         * @return {?}
         */
        Testability.prototype.addCallback = function (cb, timeout, updateCb) {
            var _this = this;
            /** @type {?} */
            var timeoutId = -1;
            if (timeout && timeout > 0) {
                timeoutId = setTimeout(( /**
                 * @return {?}
                 */function () {
                    _this._callbacks = _this._callbacks.filter(( /**
                     * @param {?} cb
                     * @return {?}
                     */function (cb) { return cb.timeoutId !== timeoutId; }));
                    cb(_this._didWork, _this.getPendingTasks());
                }), timeout);
            }
            this._callbacks.push(( /** @type {?} */({ doneCb: cb, timeoutId: timeoutId, updateCb: updateCb })));
        };
        /**
         * Wait for the application to be stable with a timeout. If the timeout is reached before that
         * happens, the callback receives a list of the macro tasks that were pending, otherwise null.
         *
         * @param {?} doneCb The callback to invoke when Angular is stable or the timeout expires
         *    whichever comes first.
         * @param {?=} timeout Optional. The maximum time to wait for Angular to become stable. If not
         *    specified, whenStable() will wait forever.
         * @param {?=} updateCb Optional. If specified, this callback will be invoked whenever the set of
         *    pending macrotasks changes. If this callback returns true doneCb will not be invoked
         *    and no further updates will be issued.
         * @return {?}
         */
        Testability.prototype.whenStable = function (doneCb, timeout, updateCb) {
            if (updateCb && !this.taskTrackingZone) {
                throw new Error('Task tracking zone is required when passing an update callback to ' +
                    'whenStable(). Is "zone.js/dist/task-tracking.js" loaded?');
            }
            // These arguments are 'Function' above to keep the public API simple.
            this.addCallback(( /** @type {?} */(doneCb)), timeout, ( /** @type {?} */(updateCb)));
            this._runCallbacksIfReady();
        };
        /**
         * Get the number of pending requests
         * @deprecated pending requests are now tracked with zones
         * @return {?}
         */
        Testability.prototype.getPendingRequestCount = function () { return this._pendingCount; };
        /**
         * Find providers by name
         * @param {?} using The root element to search from
         * @param {?} provider The name of binding variable
         * @param {?} exactMatch Whether using exactMatch
         * @return {?}
         */
        Testability.prototype.findProviders = function (using, provider, exactMatch) {
            // TODO(juliemr): implement.
            return [];
        };
        return Testability;
    }());
    Testability.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    Testability.ctorParameters = function () { return [
        { type: NgZone }
    ]; };
    /**
     * A global registry of {\@link Testability} instances for specific elements.
     * \@publicApi
     */
    var TestabilityRegistry = /** @class */ (function () {
        function TestabilityRegistry() {
            /**
             * \@internal
             */
            this._applications = new Map();
            _testabilityGetter.addToWindow(this);
        }
        /**
         * Registers an application with a testability hook so that it can be tracked
         * @param {?} token token of application, root element
         * @param {?} testability Testability hook
         * @return {?}
         */
        TestabilityRegistry.prototype.registerApplication = function (token, testability) {
            this._applications.set(token, testability);
        };
        /**
         * Unregisters an application.
         * @param {?} token token of application, root element
         * @return {?}
         */
        TestabilityRegistry.prototype.unregisterApplication = function (token) { this._applications.delete(token); };
        /**
         * Unregisters all applications
         * @return {?}
         */
        TestabilityRegistry.prototype.unregisterAllApplications = function () { this._applications.clear(); };
        /**
         * Get a testability hook associated with the application
         * @param {?} elem root element
         * @return {?}
         */
        TestabilityRegistry.prototype.getTestability = function (elem) { return this._applications.get(elem) || null; };
        /**
         * Get all registered testabilities
         * @return {?}
         */
        TestabilityRegistry.prototype.getAllTestabilities = function () { return Array.from(this._applications.values()); };
        /**
         * Get all registered applications(root elements)
         * @return {?}
         */
        TestabilityRegistry.prototype.getAllRootElements = function () { return Array.from(this._applications.keys()); };
        /**
         * Find testability of a node in the Tree
         * @param {?} elem node
         * @param {?=} findInAncestors whether finding testability in ancestors if testability was not found in
         * current node
         * @return {?}
         */
        TestabilityRegistry.prototype.findTestabilityInTree = function (elem, findInAncestors) {
            if (findInAncestors === void 0) { findInAncestors = true; }
            return _testabilityGetter.findTestabilityInTree(this, elem, findInAncestors);
        };
        return TestabilityRegistry;
    }());
    TestabilityRegistry.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    TestabilityRegistry.ctorParameters = function () { return []; };
    var _NoopGetTestability = /** @class */ (function () {
        function _NoopGetTestability() {
        }
        /**
         * @param {?} registry
         * @return {?}
         */
        _NoopGetTestability.prototype.addToWindow = function (registry) { };
        /**
         * @param {?} registry
         * @param {?} elem
         * @param {?} findInAncestors
         * @return {?}
         */
        _NoopGetTestability.prototype.findTestabilityInTree = function (registry, elem, findInAncestors) {
            return null;
        };
        return _NoopGetTestability;
    }());
    /**
     * Set the {\@link GetTestability} implementation used by the Angular testing framework.
     * \@publicApi
     * @param {?} getter
     * @return {?}
     */
    function setTestabilityGetter(getter) {
        _testabilityGetter = getter;
    }
    /** @type {?} */
    var _testabilityGetter = new _NoopGetTestability();
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var _platform;
    /** @type {?} */
    var compileNgModuleFactory = compileNgModuleFactory__PRE_R3__;
    /**
     * @template M
     * @param {?} injector
     * @param {?} options
     * @param {?} moduleType
     * @return {?}
     */
    function compileNgModuleFactory__PRE_R3__(injector, options, moduleType) {
        /** @type {?} */
        var compilerFactory = injector.get(CompilerFactory);
        /** @type {?} */
        var compiler = compilerFactory.createCompiler([options]);
        return compiler.compileModuleAsync(moduleType);
    }
    /** @type {?} */
    var isBoundToModule = isBoundToModule__PRE_R3__;
    /**
     * @template C
     * @param {?} cf
     * @return {?}
     */
    function isBoundToModule__PRE_R3__(cf) {
        return cf instanceof ComponentFactoryBoundToModule;
    }
    /** @type {?} */
    var ALLOW_MULTIPLE_PLATFORMS = new InjectionToken('AllowMultipleToken');
    /**
     * A token for third-party components that can register themselves with NgProbe.
     *
     * \@publicApi
     */
    var NgProbeToken = /** @class */ (function () {
        /**
         * @param {?} name
         * @param {?} token
         */
        function NgProbeToken(name, token) {
            this.name = name;
            this.token = token;
        }
        return NgProbeToken;
    }());
    /**
     * Creates a platform.
     * Platforms have to be eagerly created via this function.
     *
     * \@publicApi
     * @param {?} injector
     * @return {?}
     */
    function createPlatform(injector) {
        if (_platform && !_platform.destroyed &&
            !_platform.injector.get(ALLOW_MULTIPLE_PLATFORMS, false)) {
            throw new Error('There can be only one platform. Destroy the previous one to create a new one.');
        }
        _platform = injector.get(PlatformRef);
        /** @type {?} */
        var inits = injector.get(PLATFORM_INITIALIZER, null);
        if (inits)
            inits.forEach(( /**
             * @param {?} init
             * @return {?}
             */function (init) { return init(); }));
        return _platform;
    }
    /**
     * Creates a factory for a platform
     *
     * \@publicApi
     * @param {?} parentPlatformFactory
     * @param {?} name
     * @param {?=} providers
     * @return {?}
     */
    function createPlatformFactory(parentPlatformFactory, name, providers) {
        if (providers === void 0) { providers = []; }
        /** @type {?} */
        var desc = "Platform: " + name;
        /** @type {?} */
        var marker = new InjectionToken(desc);
        return ( /**
         * @param {?=} extraProviders
         * @return {?}
         */function (extraProviders) {
            if (extraProviders === void 0) { extraProviders = []; }
            /** @type {?} */
            var platform = getPlatform();
            if (!platform || platform.injector.get(ALLOW_MULTIPLE_PLATFORMS, false)) {
                if (parentPlatformFactory) {
                    parentPlatformFactory(providers.concat(extraProviders).concat({ provide: marker, useValue: true }));
                }
                else {
                    /** @type {?} */
                    var injectedProviders = providers.concat(extraProviders).concat({ provide: marker, useValue: true });
                    createPlatform(Injector.create({ providers: injectedProviders, name: desc }));
                }
            }
            return assertPlatform(marker);
        });
    }
    /**
     * Checks that there currently is a platform which contains the given token as a provider.
     *
     * \@publicApi
     * @param {?} requiredToken
     * @return {?}
     */
    function assertPlatform(requiredToken) {
        /** @type {?} */
        var platform = getPlatform();
        if (!platform) {
            throw new Error('No platform exists!');
        }
        if (!platform.injector.get(requiredToken, null)) {
            throw new Error('A platform with a different configuration has been created. Please destroy it first.');
        }
        return platform;
    }
    /**
     * Returns the current platform.
     *
     * \@publicApi
     * @return {?}
     */
    function getPlatform() {
        return _platform && !_platform.destroyed ? _platform : null;
    }
    /**
     * The Angular platform is the entry point for Angular on a web page. Each page
     * has exactly one platform, and services (such as reflection) which are common
     * to every Angular application running on the page are bound in its scope.
     *
     * A page's platform is initialized implicitly when a platform is created via a platform factory
     * (e.g. {\@link platformBrowser}), or explicitly by calling the {\@link createPlatform} function.
     *
     * \@publicApi
     */
    var PlatformRef = /** @class */ (function () {
        /**
         * \@internal
         * @param {?} _injector
         */
        function PlatformRef(_injector) {
            this._injector = _injector;
            this._modules = [];
            this._destroyListeners = [];
            this._destroyed = false;
        }
        /**
         * Creates an instance of an `\@NgModule` for the given platform
         * for offline compilation.
         *
         * \@usageNotes
         * ### Simple Example
         *
         * ```typescript
         * my_module.ts:
         *
         * \@NgModule({
         *   imports: [BrowserModule]
         * })
         * class MyModule {}
         *
         * main.ts:
         * import {MyModuleNgFactory} from './my_module.ngfactory';
         * import {platformBrowser} from '\@angular/platform-browser';
         *
         * let moduleRef = platformBrowser().bootstrapModuleFactory(MyModuleNgFactory);
         * ```
         * @template M
         * @param {?} moduleFactory
         * @param {?=} options
         * @return {?}
         */
        PlatformRef.prototype.bootstrapModuleFactory = function (moduleFactory, options) {
            var _this = this;
            // Note: We need to create the NgZone _before_ we instantiate the module,
            // as instantiating the module creates some providers eagerly.
            // So we create a mini parent injector that just contains the new NgZone and
            // pass that as parent to the NgModuleFactory.
            /** @type {?} */
            var ngZoneOption = options ? options.ngZone : undefined;
            /** @type {?} */
            var ngZone = getNgZone(ngZoneOption);
            /** @type {?} */
            var providers = [{ provide: NgZone, useValue: ngZone }];
            // Attention: Don't use ApplicationRef.run here,
            // as we want to be sure that all possible constructor calls are inside `ngZone.run`!
            return ngZone.run(( /**
             * @return {?}
             */function () {
                /** @type {?} */
                var ngZoneInjector = Injector.create({ providers: providers, parent: _this.injector, name: moduleFactory.moduleType.name });
                /** @type {?} */
                var moduleRef = ( /** @type {?} */(moduleFactory.create(ngZoneInjector)));
                /** @type {?} */
                var exceptionHandler = moduleRef.injector.get(ErrorHandler, null);
                if (!exceptionHandler) {
                    throw new Error('No ErrorHandler. Is platform module (BrowserModule) included?');
                }
                moduleRef.onDestroy(( /**
                 * @return {?}
                 */function () { return remove(_this._modules, moduleRef); }));
                ( /** @type {?} */(ngZone)).runOutsideAngular(( /**
                 * @return {?}
                 */function () { return ( /** @type {?} */(ngZone)).onError.subscribe({ next: ( /**
                         * @param {?} error
                         * @return {?}
                         */function (error) { exceptionHandler.handleError(error); }) }); }));
                return _callAndReportToErrorHandler(exceptionHandler, ( /** @type {?} */(ngZone)), ( /**
                 * @return {?}
                 */function () {
                    /** @type {?} */
                    var initStatus = moduleRef.injector.get(ApplicationInitStatus);
                    initStatus.runInitializers();
                    return initStatus.donePromise.then(( /**
                     * @return {?}
                     */function () {
                        _this._moduleDoBootstrap(moduleRef);
                        return moduleRef;
                    }));
                }));
            }));
        };
        /**
         * Creates an instance of an `\@NgModule` for a given platform using the given runtime compiler.
         *
         * \@usageNotes
         * ### Simple Example
         *
         * ```typescript
         * \@NgModule({
         *   imports: [BrowserModule]
         * })
         * class MyModule {}
         *
         * let moduleRef = platformBrowser().bootstrapModule(MyModule);
         * ```
         *
         * @template M
         * @param {?} moduleType
         * @param {?=} compilerOptions
         * @return {?}
         */
        PlatformRef.prototype.bootstrapModule = function (moduleType, compilerOptions) {
            var _this = this;
            if (compilerOptions === void 0) { compilerOptions = []; }
            /** @type {?} */
            var options = optionsReducer({}, compilerOptions);
            return compileNgModuleFactory(this.injector, options, moduleType)
                .then(( /**
         * @param {?} moduleFactory
         * @return {?}
         */function (/**
         * @param {?} moduleFactory
         * @return {?}
         */ moduleFactory) { return _this.bootstrapModuleFactory(moduleFactory, options); }));
        };
        /**
         * @private
         * @param {?} moduleRef
         * @return {?}
         */
        PlatformRef.prototype._moduleDoBootstrap = function (moduleRef) {
            /** @type {?} */
            var appRef = ( /** @type {?} */(moduleRef.injector.get(ApplicationRef)));
            if (moduleRef._bootstrapComponents.length > 0) {
                moduleRef._bootstrapComponents.forEach(( /**
                 * @param {?} f
                 * @return {?}
                 */function (/**
                 * @param {?} f
                 * @return {?}
                 */ f) { return appRef.bootstrap(f); }));
            }
            else if (moduleRef.instance.ngDoBootstrap) {
                moduleRef.instance.ngDoBootstrap(appRef);
            }
            else {
                throw new Error("The module " + stringify(moduleRef.instance.constructor) + " was bootstrapped, but it does not declare \"@NgModule.bootstrap\" components nor a \"ngDoBootstrap\" method. " +
                    "Please define one of these.");
            }
            this._modules.push(moduleRef);
        };
        /**
         * Register a listener to be called when the platform is disposed.
         * @param {?} callback
         * @return {?}
         */
        PlatformRef.prototype.onDestroy = function (callback) { this._destroyListeners.push(callback); };
        Object.defineProperty(PlatformRef.prototype, "injector", {
            /**
             * Retrieve the platform {\@link Injector}, which is the parent injector for
             * every Angular application on the page and provides singleton providers.
             * @return {?}
             */
            get: function () { return this._injector; },
            enumerable: true,
            configurable: true
        });
        /**
         * Destroy the Angular platform and all Angular applications on the page.
         * @return {?}
         */
        PlatformRef.prototype.destroy = function () {
            if (this._destroyed) {
                throw new Error('The platform has already been destroyed!');
            }
            this._modules.slice().forEach(( /**
             * @param {?} module
             * @return {?}
             */function (/**
             * @param {?} module
             * @return {?}
             */ module) { return module.destroy(); }));
            this._destroyListeners.forEach(( /**
             * @param {?} listener
             * @return {?}
             */function (/**
             * @param {?} listener
             * @return {?}
             */ listener) { return listener(); }));
            this._destroyed = true;
        };
        Object.defineProperty(PlatformRef.prototype, "destroyed", {
            /**
             * @return {?}
             */
            get: function () { return this._destroyed; },
            enumerable: true,
            configurable: true
        });
        return PlatformRef;
    }());
    PlatformRef.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    PlatformRef.ctorParameters = function () { return [
        { type: Injector }
    ]; };
    /**
     * @param {?=} ngZoneOption
     * @return {?}
     */
    function getNgZone(ngZoneOption) {
        /** @type {?} */
        var ngZone;
        if (ngZoneOption === 'noop') {
            ngZone = new NoopNgZone();
        }
        else {
            ngZone = (ngZoneOption === 'zone.js' ? undefined : ngZoneOption) ||
                new NgZone({ enableLongStackTrace: isDevMode() });
        }
        return ngZone;
    }
    /**
     * @param {?} errorHandler
     * @param {?} ngZone
     * @param {?} callback
     * @return {?}
     */
    function _callAndReportToErrorHandler(errorHandler, ngZone, callback) {
        try {
            /** @type {?} */
            var result = callback();
            if (isPromise$1(result)) {
                return result.catch(( /**
                 * @param {?} e
                 * @return {?}
                 */function (e) {
                    ngZone.runOutsideAngular(( /**
                     * @return {?}
                     */function () { return errorHandler.handleError(e); }));
                    // rethrow as the exception handler might not do it
                    throw e;
                }));
            }
            return result;
        }
        catch (e) {
            ngZone.runOutsideAngular(( /**
             * @return {?}
             */function () { return errorHandler.handleError(e); }));
            // rethrow as the exception handler might not do it
            throw e;
        }
    }
    /**
     * @template T
     * @param {?} dst
     * @param {?} objs
     * @return {?}
     */
    function optionsReducer(dst, objs) {
        if (Array.isArray(objs)) {
            dst = objs.reduce(optionsReducer, dst);
        }
        else {
            dst = Object.assign({}, dst, (( /** @type {?} */(objs))));
        }
        return dst;
    }
    /**
     * A reference to an Angular application running on a page.
     *
     * \@usageNotes
     *
     * {\@a is-stable-examples}
     * ### isStable examples and caveats
     *
     * Note two important points about `isStable`, demonstrated in the examples below:
     * - the application will never be stable if you start any kind
     * of recurrent asynchronous task when the application starts
     * (for example for a polling process, started with a `setInterval`, a `setTimeout`
     * or using RxJS operators like `interval`);
     * - the `isStable` Observable runs outside of the Angular zone.
     *
     * Let's imagine that you start a recurrent task
     * (here incrementing a counter, using RxJS `interval`),
     * and at the same time subscribe to `isStable`.
     *
     * ```
     * constructor(appRef: ApplicationRef) {
     *   appRef.isStable.pipe(
     *      filter(stable => stable)
     *   ).subscribe(() => console.log('App is stable now');
     *   interval(1000).subscribe(counter => console.log(counter));
     * }
     * ```
     * In this example, `isStable` will never emit `true`,
     * and the trace "App is stable now" will never get logged.
     *
     * If you want to execute something when the app is stable,
     * you have to wait for the application to be stable
     * before starting your polling process.
     *
     * ```
     * constructor(appRef: ApplicationRef) {
     *   appRef.isStable.pipe(
     *     first(stable => stable),
     *     tap(stable => console.log('App is stable now')),
     *     switchMap(() => interval(1000))
     *   ).subscribe(counter => console.log(counter));
     * }
     * ```
     * In this example, the trace "App is stable now" will be logged
     * and then the counter starts incrementing every second.
     *
     * Note also that this Observable runs outside of the Angular zone,
     * which means that the code in the subscription
     * to this Observable will not trigger the change detection.
     *
     * Let's imagine that instead of logging the counter value,
     * you update a field of your component
     * and display it in its template.
     *
     * ```
     * constructor(appRef: ApplicationRef) {
     *   appRef.isStable.pipe(
     *     first(stable => stable),
     *     switchMap(() => interval(1000))
     *   ).subscribe(counter => this.value = counter);
     * }
     * ```
     * As the `isStable` Observable runs outside the zone,
     * the `value` field will be updated properly,
     * but the template will not be refreshed!
     *
     * You'll have to manually trigger the change detection to update the template.
     *
     * ```
     * constructor(appRef: ApplicationRef, cd: ChangeDetectorRef) {
     *   appRef.isStable.pipe(
     *     first(stable => stable),
     *     switchMap(() => interval(1000))
     *   ).subscribe(counter => {
     *     this.value = counter;
     *     cd.detectChanges();
     *   });
     * }
     * ```
     *
     * Or make the subscription callback run inside the zone.
     *
     * ```
     * constructor(appRef: ApplicationRef, zone: NgZone) {
     *   appRef.isStable.pipe(
     *     first(stable => stable),
     *     switchMap(() => interval(1000))
     *   ).subscribe(counter => zone.run(() => this.value = counter));
     * }
     * ```
     *
     * \@publicApi
     */
    var ApplicationRef = /** @class */ (function () {
        /**
         * \@internal
         * @param {?} _zone
         * @param {?} _console
         * @param {?} _injector
         * @param {?} _exceptionHandler
         * @param {?} _componentFactoryResolver
         * @param {?} _initStatus
         */
        function ApplicationRef(_zone, _console, _injector, _exceptionHandler, _componentFactoryResolver, _initStatus) {
            var _this = this;
            this._zone = _zone;
            this._console = _console;
            this._injector = _injector;
            this._exceptionHandler = _exceptionHandler;
            this._componentFactoryResolver = _componentFactoryResolver;
            this._initStatus = _initStatus;
            this._bootstrapListeners = [];
            this._views = [];
            this._runningTick = false;
            this._enforceNoNewChanges = false;
            this._stable = true;
            /**
             * Get a list of component types registered to this application.
             * This list is populated even before the component is created.
             */
            this.componentTypes = [];
            /**
             * Get a list of components registered to this application.
             */
            this.components = [];
            this._enforceNoNewChanges = isDevMode();
            this._zone.onMicrotaskEmpty.subscribe({ next: ( /**
                     * @return {?}
                     */function () {
                    _this._zone.run(( /**
                     * @return {?}
                     */function () { _this.tick(); }));
                }) });
            /** @type {?} */
            var isCurrentlyStable = new Observable(( /**
             * @param {?} observer
             * @return {?}
             */function (observer) {
                _this._stable = _this._zone.isStable && !_this._zone.hasPendingMacrotasks &&
                    !_this._zone.hasPendingMicrotasks;
                _this._zone.runOutsideAngular(( /**
                 * @return {?}
                 */function () {
                    observer.next(_this._stable);
                    observer.complete();
                }));
            }));
            /** @type {?} */
            var isStable = new Observable(( /**
             * @param {?} observer
             * @return {?}
             */function (observer) {
                // Create the subscription to onStable outside the Angular Zone so that
                // the callback is run outside the Angular Zone.
                /** @type {?} */
                var stableSub;
                _this._zone.runOutsideAngular(( /**
                 * @return {?}
                 */function () {
                    stableSub = _this._zone.onStable.subscribe(( /**
                     * @return {?}
                     */function () {
                        NgZone.assertNotInAngularZone();
                        // Check whether there are no pending macro/micro tasks in the next tick
                        // to allow for NgZone to update the state.
                        scheduleMicroTask(( /**
                         * @return {?}
                         */function () {
                            if (!_this._stable && !_this._zone.hasPendingMacrotasks &&
                                !_this._zone.hasPendingMicrotasks) {
                                _this._stable = true;
                                observer.next(true);
                            }
                        }));
                    }));
                }));
                /** @type {?} */
                var unstableSub = _this._zone.onUnstable.subscribe(( /**
                 * @return {?}
                 */function () {
                    NgZone.assertInAngularZone();
                    if (_this._stable) {
                        _this._stable = false;
                        _this._zone.runOutsideAngular(( /**
                         * @return {?}
                         */function () { observer.next(false); }));
                    }
                }));
                return ( /**
                 * @return {?}
                 */function () {
                    stableSub.unsubscribe();
                    unstableSub.unsubscribe();
                });
            }));
            (( /** @type {?} */(this))).isStable =
                merge(isCurrentlyStable, isStable.pipe(share()));
        }
        /**
         * Bootstrap a new component at the root level of the application.
         *
         * \@usageNotes
         * ### Bootstrap process
         *
         * When bootstrapping a new root component into an application, Angular mounts the
         * specified application component onto DOM elements identified by the componentType's
         * selector and kicks off automatic change detection to finish initializing the component.
         *
         * Optionally, a component can be mounted onto a DOM element that does not match the
         * componentType's selector.
         *
         * ### Example
         * {\@example core/ts/platform/platform.ts region='longform'}
         * @template C
         * @param {?} componentOrFactory
         * @param {?=} rootSelectorOrNode
         * @return {?}
         */
        ApplicationRef.prototype.bootstrap = function (componentOrFactory, rootSelectorOrNode) {
            var _this = this;
            if (!this._initStatus.done) {
                throw new Error('Cannot bootstrap as there are still asynchronous initializers running. Bootstrap components in the `ngDoBootstrap` method of the root module.');
            }
            /** @type {?} */
            var componentFactory;
            if (componentOrFactory instanceof ComponentFactory) {
                componentFactory = componentOrFactory;
            }
            else {
                componentFactory =
                    ( /** @type {?} */(this._componentFactoryResolver.resolveComponentFactory(componentOrFactory)));
            }
            this.componentTypes.push(componentFactory.componentType);
            // Create a factory associated with the current module if it's not bound to some other
            /** @type {?} */
            var ngModule = isBoundToModule(componentFactory) ? null : this._injector.get(NgModuleRef);
            /** @type {?} */
            var selectorOrNode = rootSelectorOrNode || componentFactory.selector;
            /** @type {?} */
            var compRef = componentFactory.create(Injector.NULL, [], selectorOrNode, ngModule);
            compRef.onDestroy(( /**
             * @return {?}
             */function () { _this._unloadComponent(compRef); }));
            /** @type {?} */
            var testability = compRef.injector.get(Testability, null);
            if (testability) {
                compRef.injector.get(TestabilityRegistry)
                    .registerApplication(compRef.location.nativeElement, testability);
            }
            this._loadComponent(compRef);
            if (isDevMode()) {
                this._console.log("Angular is running in the development mode. Call enableProdMode() to enable the production mode.");
            }
            return compRef;
        };
        /**
         * Invoke this method to explicitly process change detection and its side-effects.
         *
         * In development mode, `tick()` also performs a second change detection cycle to ensure that no
         * further changes are detected. If additional changes are picked up during this second cycle,
         * bindings in the app have side-effects that cannot be resolved in a single change detection
         * pass.
         * In this case, Angular throws an error, since an Angular application can only have one change
         * detection pass during which all change detection must complete.
         * @return {?}
         */
        ApplicationRef.prototype.tick = function () {
            var _this = this;
            var e_3, _b, e_4, _c;
            if (this._runningTick) {
                throw new Error('ApplicationRef.tick is called recursively');
            }
            /** @type {?} */
            var scope = ApplicationRef._tickScope();
            try {
                this._runningTick = true;
                try {
                    for (var _d = __values(this._views), _e = _d.next(); !_e.done; _e = _d.next()) {
                        var view = _e.value;
                        view.detectChanges();
                    }
                }
                catch (e_3_1) { e_3 = { error: e_3_1 }; }
                finally {
                    try {
                        if (_e && !_e.done && (_b = _d.return)) _b.call(_d);
                    }
                    finally { if (e_3) throw e_3.error; }
                }
                if (this._enforceNoNewChanges) {
                    try {
                        for (var _f = __values(this._views), _g = _f.next(); !_g.done; _g = _f.next()) {
                            var view = _g.value;
                            view.checkNoChanges();
                        }
                    }
                    catch (e_4_1) { e_4 = { error: e_4_1 }; }
                    finally {
                        try {
                            if (_g && !_g.done && (_c = _f.return)) _c.call(_f);
                        }
                        finally { if (e_4) throw e_4.error; }
                    }
                }
            }
            catch (e) {
                // Attention: Don't rethrow as it could cancel subscriptions to Observables!
                this._zone.runOutsideAngular(( /**
                 * @return {?}
                 */function () { return _this._exceptionHandler.handleError(e); }));
            }
            finally {
                this._runningTick = false;
                wtfLeave(scope);
            }
        };
        /**
         * Attaches a view so that it will be dirty checked.
         * The view will be automatically detached when it is destroyed.
         * This will throw if the view is already attached to a ViewContainer.
         * @param {?} viewRef
         * @return {?}
         */
        ApplicationRef.prototype.attachView = function (viewRef) {
            /** @type {?} */
            var view = (( /** @type {?} */(viewRef)));
            this._views.push(view);
            view.attachToAppRef(this);
        };
        /**
         * Detaches a view from dirty checking again.
         * @param {?} viewRef
         * @return {?}
         */
        ApplicationRef.prototype.detachView = function (viewRef) {
            /** @type {?} */
            var view = (( /** @type {?} */(viewRef)));
            remove(this._views, view);
            view.detachFromAppRef();
        };
        /**
         * @private
         * @param {?} componentRef
         * @return {?}
         */
        ApplicationRef.prototype._loadComponent = function (componentRef) {
            this.attachView(componentRef.hostView);
            this.tick();
            this.components.push(componentRef);
            // Get the listeners lazily to prevent DI cycles.
            /** @type {?} */
            var listeners = this._injector.get(APP_BOOTSTRAP_LISTENER, []).concat(this._bootstrapListeners);
            listeners.forEach(( /**
             * @param {?} listener
             * @return {?}
             */function (listener) { return listener(componentRef); }));
        };
        /**
         * @private
         * @param {?} componentRef
         * @return {?}
         */
        ApplicationRef.prototype._unloadComponent = function (componentRef) {
            this.detachView(componentRef.hostView);
            remove(this.components, componentRef);
        };
        /**
         * \@internal
         * @return {?}
         */
        ApplicationRef.prototype.ngOnDestroy = function () {
            // TODO(alxhub): Dispose of the NgZone.
            this._views.slice().forEach(( /**
             * @param {?} view
             * @return {?}
             */function (view) { return view.destroy(); }));
        };
        Object.defineProperty(ApplicationRef.prototype, "viewCount", {
            /**
             * Returns the number of attached views.
             * @return {?}
             */
            get: function () { return this._views.length; },
            enumerable: true,
            configurable: true
        });
        return ApplicationRef;
    }());
    /**
     * \@internal
     */
    ApplicationRef._tickScope = wtfCreateScope('ApplicationRef#tick()');
    ApplicationRef.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    ApplicationRef.ctorParameters = function () { return [
        { type: NgZone },
        { type: Console },
        { type: Injector },
        { type: ErrorHandler },
        { type: ComponentFactoryResolver },
        { type: ApplicationInitStatus }
    ]; };
    /**
     * @template T
     * @param {?} list
     * @param {?} el
     * @return {?}
     */
    function remove(list, el) {
        /** @type {?} */
        var index = list.indexOf(el);
        if (index > -1) {
            list.splice(index, 1);
        }
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Used to load ng module factories.
     *
     * \@publicApi
     * @deprecated the `string` form of `loadChildren` is deprecated, and `NgModuleFactoryLoader` is
     * part of its implementation. See `LoadChildren` for more details.
     * @abstract
     */
    var NgModuleFactoryLoader = /** @class */ (function () {
        function NgModuleFactoryLoader() {
        }
        return NgModuleFactoryLoader;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var _SEPARATOR = '#';
    /** @type {?} */
    var FACTORY_CLASS_SUFFIX = 'NgFactory';
    /**
     * Configuration for SystemJsNgModuleLoader.
     * token.
     *
     * \@publicApi
     * @deprecated the `string` form of `loadChildren` is deprecated, and `SystemJsNgModuleLoaderConfig`
     * is part of its implementation. See `LoadChildren` for more details.
     * @abstract
     */
    var SystemJsNgModuleLoaderConfig = /** @class */ (function () {
        function SystemJsNgModuleLoaderConfig() {
        }
        return SystemJsNgModuleLoaderConfig;
    }());
    /** @type {?} */
    var DEFAULT_CONFIG = {
        factoryPathPrefix: '',
        factoryPathSuffix: '.ngfactory',
    };
    /**
     * NgModuleFactoryLoader that uses SystemJS to load NgModuleFactory
     * \@publicApi
     * @deprecated the `string` form of `loadChildren` is deprecated, and `SystemJsNgModuleLoader` is
     * part of its implementation. See `LoadChildren` for more details.
     */
    var SystemJsNgModuleLoader = /** @class */ (function () {
        /**
         * @param {?} _compiler
         * @param {?=} config
         */
        function SystemJsNgModuleLoader(_compiler, config) {
            this._compiler = _compiler;
            this._config = config || DEFAULT_CONFIG;
        }
        /**
         * @param {?} path
         * @return {?}
         */
        SystemJsNgModuleLoader.prototype.load = function (path) {
            /** @type {?} */
            var legacyOfflineMode = this._compiler instanceof Compiler;
            return legacyOfflineMode ? this.loadFactory(path) : this.loadAndCompile(path);
        };
        /**
         * @private
         * @param {?} path
         * @return {?}
         */
        SystemJsNgModuleLoader.prototype.loadAndCompile = function (path) {
            var _this = this;
            var _b = __read(path.split(_SEPARATOR), 2), module = _b[0], exportName = _b[1];
            if (exportName === undefined) {
                exportName = 'default';
            }
            return System.import(module)
                .then(( /**
         * @param {?} module
         * @return {?}
         */function (module) { return module[exportName]; }))
                .then(( /**
         * @param {?} type
         * @return {?}
         */function (type) { return checkNotEmpty(type, module, exportName); }))
                .then(( /**
         * @param {?} type
         * @return {?}
         */function (type) { return _this._compiler.compileModuleAsync(type); }));
        };
        /**
         * @private
         * @param {?} path
         * @return {?}
         */
        SystemJsNgModuleLoader.prototype.loadFactory = function (path) {
            var _b = __read(path.split(_SEPARATOR), 2), module = _b[0], exportName = _b[1];
            /** @type {?} */
            var factoryClassSuffix = FACTORY_CLASS_SUFFIX;
            if (exportName === undefined) {
                exportName = 'default';
                factoryClassSuffix = '';
            }
            return System.import(this._config.factoryPathPrefix + module + this._config.factoryPathSuffix)
                .then(( /**
         * @param {?} module
         * @return {?}
         */function (module) { return module[exportName + factoryClassSuffix]; }))
                .then(( /**
         * @param {?} factory
         * @return {?}
         */function (factory) { return checkNotEmpty(factory, module, exportName); }));
        };
        return SystemJsNgModuleLoader;
    }());
    SystemJsNgModuleLoader.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    SystemJsNgModuleLoader.ctorParameters = function () { return [
        { type: Compiler },
        { type: SystemJsNgModuleLoaderConfig, decorators: [{ type: Optional }] }
    ]; };
    /**
     * @param {?} value
     * @param {?} modulePath
     * @param {?} exportName
     * @return {?}
     */
    function checkNotEmpty(value, modulePath, exportName) {
        if (!value) {
            throw new Error("Cannot find '" + exportName + "' in '" + modulePath + "'");
        }
        return value;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@publicApi
     */
    var DebugEventListener = /** @class */ (function () {
        /**
         * @param {?} name
         * @param {?} callback
         */
        function DebugEventListener(name, callback) {
            this.name = name;
            this.callback = callback;
        }
        return DebugEventListener;
    }());
    // WARNING: interface has both a type and a value, skipping emit
    var DebugNode__PRE_R3__ = /** @class */ (function () {
        /**
         * @param {?} nativeNode
         * @param {?} parent
         * @param {?} _debugContext
         */
        function DebugNode__PRE_R3__(nativeNode, parent, _debugContext) {
            this.listeners = [];
            this.parent = null;
            this._debugContext = _debugContext;
            this.nativeNode = nativeNode;
            if (parent && parent instanceof DebugElement__PRE_R3__) {
                parent.addChild(this);
            }
        }
        Object.defineProperty(DebugNode__PRE_R3__.prototype, "injector", {
            /**
             * @return {?}
             */
            get: function () { return this._debugContext.injector; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DebugNode__PRE_R3__.prototype, "componentInstance", {
            /**
             * @return {?}
             */
            get: function () { return this._debugContext.component; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DebugNode__PRE_R3__.prototype, "context", {
            /**
             * @return {?}
             */
            get: function () { return this._debugContext.context; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DebugNode__PRE_R3__.prototype, "references", {
            /**
             * @return {?}
             */
            get: function () { return this._debugContext.references; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DebugNode__PRE_R3__.prototype, "providerTokens", {
            /**
             * @return {?}
             */
            get: function () { return this._debugContext.providerTokens; },
            enumerable: true,
            configurable: true
        });
        return DebugNode__PRE_R3__;
    }());
    // WARNING: interface has both a type and a value, skipping emit
    var DebugElement__PRE_R3__ = /** @class */ (function (_super) {
        __extends(DebugElement__PRE_R3__, _super);
        /**
         * @param {?} nativeNode
         * @param {?} parent
         * @param {?} _debugContext
         */
        function DebugElement__PRE_R3__(nativeNode, parent, _debugContext) {
            var _this = _super.call(this, nativeNode, parent, _debugContext) || this;
            _this.properties = {};
            _this.attributes = {};
            _this.classes = {};
            _this.styles = {};
            _this.childNodes = [];
            _this.nativeElement = nativeNode;
            return _this;
        }
        /**
         * @param {?} child
         * @return {?}
         */
        DebugElement__PRE_R3__.prototype.addChild = function (child) {
            if (child) {
                this.childNodes.push(child);
                (( /** @type {?} */(child))).parent = this;
            }
        };
        /**
         * @param {?} child
         * @return {?}
         */
        DebugElement__PRE_R3__.prototype.removeChild = function (child) {
            /** @type {?} */
            var childIndex = this.childNodes.indexOf(child);
            if (childIndex !== -1) {
                (( /** @type {?} */(child))).parent = null;
                this.childNodes.splice(childIndex, 1);
            }
        };
        /**
         * @param {?} child
         * @param {?} newChildren
         * @return {?}
         */
        DebugElement__PRE_R3__.prototype.insertChildrenAfter = function (child, newChildren) {
            var _this = this;
            var _b;
            /** @type {?} */
            var siblingIndex = this.childNodes.indexOf(child);
            if (siblingIndex !== -1) {
                (_b = this.childNodes).splice.apply(_b, __spread([siblingIndex + 1, 0], newChildren));
                newChildren.forEach(( /**
                 * @param {?} c
                 * @return {?}
                 */function (/**
                 * @param {?} c
                 * @return {?}
                 */ c) {
                    if (c.parent) {
                        (( /** @type {?} */(c.parent))).removeChild(c);
                    }
                    (( /** @type {?} */(child))).parent = _this;
                }));
            }
        };
        /**
         * @param {?} refChild
         * @param {?} newChild
         * @return {?}
         */
        DebugElement__PRE_R3__.prototype.insertBefore = function (refChild, newChild) {
            /** @type {?} */
            var refIndex = this.childNodes.indexOf(refChild);
            if (refIndex === -1) {
                this.addChild(newChild);
            }
            else {
                if (newChild.parent) {
                    (( /** @type {?} */(newChild.parent))).removeChild(newChild);
                }
                (( /** @type {?} */(newChild))).parent = this;
                this.childNodes.splice(refIndex, 0, newChild);
            }
        };
        /**
         * @param {?} predicate
         * @return {?}
         */
        DebugElement__PRE_R3__.prototype.query = function (predicate) {
            /** @type {?} */
            var results = this.queryAll(predicate);
            return results[0] || null;
        };
        /**
         * @param {?} predicate
         * @return {?}
         */
        DebugElement__PRE_R3__.prototype.queryAll = function (predicate) {
            /** @type {?} */
            var matches = [];
            _queryElementChildren(this, predicate, matches);
            return matches;
        };
        /**
         * @param {?} predicate
         * @return {?}
         */
        DebugElement__PRE_R3__.prototype.queryAllNodes = function (predicate) {
            /** @type {?} */
            var matches = [];
            _queryNodeChildren(this, predicate, matches);
            return matches;
        };
        Object.defineProperty(DebugElement__PRE_R3__.prototype, "children", {
            /**
             * @return {?}
             */
            get: function () {
                return ( /** @type {?} */(this
                    .childNodes //
                    .filter(( /**
             * @param {?} node
             * @return {?}
             */function (node) { return node instanceof DebugElement__PRE_R3__; }))));
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} eventName
         * @param {?} eventObj
         * @return {?}
         */
        DebugElement__PRE_R3__.prototype.triggerEventHandler = function (eventName, eventObj) {
            this.listeners.forEach(( /**
             * @param {?} listener
             * @return {?}
             */function (listener) {
                if (listener.name == eventName) {
                    listener.callback(eventObj);
                }
            }));
        };
        return DebugElement__PRE_R3__;
    }(DebugNode__PRE_R3__));
    /**
     * @param {?} element
     * @param {?} predicate
     * @param {?} matches
     * @return {?}
     */
    function _queryElementChildren(element, predicate, matches) {
        element.childNodes.forEach(( /**
         * @param {?} node
         * @return {?}
         */function (/**
         * @param {?} node
         * @return {?}
         */ node) {
            if (node instanceof DebugElement__PRE_R3__) {
                if (predicate(node)) {
                    matches.push(node);
                }
                _queryElementChildren(node, predicate, matches);
            }
        }));
    }
    /**
     * @param {?} parentNode
     * @param {?} predicate
     * @param {?} matches
     * @return {?}
     */
    function _queryNodeChildren(parentNode, predicate, matches) {
        if (parentNode instanceof DebugElement__PRE_R3__) {
            parentNode.childNodes.forEach(( /**
             * @param {?} node
             * @return {?}
             */function (/**
             * @param {?} node
             * @return {?}
             */ node) {
                if (predicate(node)) {
                    matches.push(node);
                }
                if (node instanceof DebugElement__PRE_R3__) {
                    _queryNodeChildren(node, predicate, matches);
                }
            }));
        }
    }
    // Need to keep the nodes in a global Map so that multiple angular apps are supported.
    /** @type {?} */
    var _nativeNodeToDebugNode = new Map();
    /**
     * @param {?} nativeNode
     * @return {?}
     */
    function getDebugNode__PRE_R3__(nativeNode) {
        return _nativeNodeToDebugNode.get(nativeNode) || null;
    }
    /**
     * \@publicApi
     * @type {?}
     */
    var getDebugNode = getDebugNode__PRE_R3__;
    /**
     * @param {?} node
     * @return {?}
     */
    function indexDebugNode(node) {
        _nativeNodeToDebugNode.set(node.nativeNode, node);
    }
    /**
     * @param {?} node
     * @return {?}
     */
    function removeDebugNodeFromIndex(node) {
        _nativeNodeToDebugNode.delete(node.nativeNode);
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var _CORE_PLATFORM_PROVIDERS = [
        // Set a default platform name for platforms that don't set it explicitly.
        { provide: PLATFORM_ID, useValue: 'unknown' },
        { provide: PlatformRef, deps: [Injector] },
        { provide: TestabilityRegistry, deps: [] },
        { provide: Console, deps: [] },
    ];
    /**
     * This platform has to be included in any other platform
     *
     * \@publicApi
     * @type {?}
     */
    var platformCore = createPlatformFactory(null, 'core', _CORE_PLATFORM_PROVIDERS);
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @return {?}
     */
    function _iterableDiffersFactory() {
        return defaultIterableDiffers;
    }
    /**
     * @return {?}
     */
    function _keyValueDiffersFactory() {
        return defaultKeyValueDiffers;
    }
    /**
     * @param {?=} locale
     * @return {?}
     */
    function _localeFactory(locale) {
        if (locale) {
            return locale;
        }
        // Use `goog.LOCALE` as default value for `LOCALE_ID` token for Closure Compiler.
        // Note: default `goog.LOCALE` value is `en`, when Angular used `en-US`. In order to preserve
        // backwards compatibility, we use Angular default value over Closure Compiler's one.
        if (ngI18nClosureMode && typeof goog !== 'undefined' && goog.LOCALE !== 'en') {
            return goog.LOCALE;
        }
        return DEFAULT_LOCALE_ID;
    }
    /**
     * A built-in [dependency injection token](guide/glossary#di-token)
     * that is used to configure the root injector for bootstrapping.
     * @type {?}
     */
    var APPLICATION_MODULE_PROVIDERS = [
        {
            provide: ApplicationRef,
            useClass: ApplicationRef,
            deps: [NgZone, Console, Injector, ErrorHandler, ComponentFactoryResolver, ApplicationInitStatus]
        },
        { provide: SCHEDULER, deps: [NgZone], useFactory: zoneSchedulerFactory },
        {
            provide: ApplicationInitStatus,
            useClass: ApplicationInitStatus,
            deps: [[new Optional(), APP_INITIALIZER]]
        },
        { provide: Compiler, useClass: Compiler, deps: [] },
        APP_ID_RANDOM_PROVIDER,
        { provide: IterableDiffers, useFactory: _iterableDiffersFactory, deps: [] },
        { provide: KeyValueDiffers, useFactory: _keyValueDiffersFactory, deps: [] },
        {
            provide: LOCALE_ID$1,
            useFactory: _localeFactory,
            deps: [[new Inject(LOCALE_ID$1), new Optional(), new SkipSelf()]]
        },
    ];
    /**
     * Schedule work at next available slot.
     *
     * In Ivy this is just `requestAnimationFrame`. For compatibility reasons when bootstrapped
     * using `platformRef.bootstrap` we need to use `NgZone.onStable` as the scheduling mechanism.
     * This overrides the scheduling mechanism in Ivy to `NgZone.onStable`.
     *
     * @param {?} ngZone NgZone to use for scheduling.
     * @return {?}
     */
    function zoneSchedulerFactory(ngZone) {
        /** @type {?} */
        var queue = [];
        ngZone.onStable.subscribe(( /**
         * @return {?}
         */function () {
            while (queue.length) {
                ( /** @type {?} */(queue.pop()))();
            }
        }));
        return ( /**
         * @param {?} fn
         * @return {?}
         */function (fn) { queue.push(fn); });
    }
    /**
     * Configures the root injector for an app with
     * providers of `\@angular/core` dependencies that `ApplicationRef` needs
     * to bootstrap components.
     *
     * Re-exported by `BrowserModule`, which is included automatically in the root
     * `AppModule` when you create a new app with the CLI `new` command.
     *
     * \@publicApi
     */
    var ApplicationModule = /** @class */ (function () {
        // Inject ApplicationRef to make it eager...
        /**
         * @param {?} appRef
         */
        function ApplicationModule(appRef) {
        }
        return ApplicationModule;
    }());
    ApplicationModule.decorators = [
        { type: NgModule, args: [{ providers: APPLICATION_MODULE_PROVIDERS },] }
    ];
    /** @nocollapse */
    ApplicationModule.ctorParameters = function () { return [
        { type: ApplicationRef }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} flags
     * @param {?} matchedQueriesDsl
     * @param {?} ngContentIndex
     * @param {?} childCount
     * @param {?=} handleEvent
     * @param {?=} templateFactory
     * @return {?}
     */
    function anchorDef(flags, matchedQueriesDsl, ngContentIndex, childCount, handleEvent, templateFactory) {
        flags |= 1 /* TypeElement */;
        var _b = splitMatchedQueriesDsl(matchedQueriesDsl), matchedQueries = _b.matchedQueries, references = _b.references, matchedQueryIds = _b.matchedQueryIds;
        /** @type {?} */
        var template = templateFactory ? resolveDefinition(templateFactory) : null;
        return {
            // will bet set by the view definition
            nodeIndex: -1,
            parent: null,
            renderParent: null,
            bindingIndex: -1,
            outputIndex: -1,
            // regular values
            flags: flags,
            checkIndex: -1,
            childFlags: 0,
            directChildFlags: 0,
            childMatchedQueries: 0, matchedQueries: matchedQueries, matchedQueryIds: matchedQueryIds, references: references, ngContentIndex: ngContentIndex, childCount: childCount,
            bindings: [],
            bindingFlags: 0,
            outputs: [],
            element: {
                ns: null,
                name: null,
                attrs: null, template: template,
                componentProvider: null,
                componentView: null,
                componentRendererType: null,
                publicProviders: null,
                allProviders: null,
                handleEvent: handleEvent || NOOP
            },
            provider: null,
            text: null,
            query: null,
            ngContent: null
        };
    }
    /**
     * @param {?} checkIndex
     * @param {?} flags
     * @param {?} matchedQueriesDsl
     * @param {?} ngContentIndex
     * @param {?} childCount
     * @param {?} namespaceAndName
     * @param {?=} fixedAttrs
     * @param {?=} bindings
     * @param {?=} outputs
     * @param {?=} handleEvent
     * @param {?=} componentView
     * @param {?=} componentRendererType
     * @return {?}
     */
    function elementDef(checkIndex, flags, matchedQueriesDsl, ngContentIndex, childCount, namespaceAndName, fixedAttrs, bindings, outputs, handleEvent, componentView, componentRendererType) {
        if (fixedAttrs === void 0) { fixedAttrs = []; }
        var _b;
        if (!handleEvent) {
            handleEvent = NOOP;
        }
        var _c = splitMatchedQueriesDsl(matchedQueriesDsl), matchedQueries = _c.matchedQueries, references = _c.references, matchedQueryIds = _c.matchedQueryIds;
        /** @type {?} */
        var ns = ( /** @type {?} */(null));
        /** @type {?} */
        var name = ( /** @type {?} */(null));
        if (namespaceAndName) {
            _b = __read(splitNamespace(namespaceAndName), 2), ns = _b[0], name = _b[1];
        }
        bindings = bindings || [];
        /** @type {?} */
        var bindingDefs = new Array(bindings.length);
        for (var i_78 = 0; i_78 < bindings.length; i_78++) {
            var _d = __read(bindings[i_78], 3), bindingFlags = _d[0], namespaceAndName_1 = _d[1], suffixOrSecurityContext = _d[2];
            var _e = __read(splitNamespace(namespaceAndName_1), 2), ns_1 = _e[0], name_1 = _e[1];
            /** @type {?} */
            var securityContext = ( /** @type {?} */(undefined));
            /** @type {?} */
            var suffix = ( /** @type {?} */(undefined));
            switch (bindingFlags & 15 /* Types */) {
                case 4 /* TypeElementStyle */:
                    suffix = ( /** @type {?} */(suffixOrSecurityContext));
                    break;
                case 1 /* TypeElementAttribute */:
                case 8 /* TypeProperty */:
                    securityContext = ( /** @type {?} */(suffixOrSecurityContext));
                    break;
            }
            bindingDefs[i_78] =
                { flags: bindingFlags, ns: ns_1, name: name_1, nonMinifiedName: name_1, securityContext: securityContext, suffix: suffix };
        }
        outputs = outputs || [];
        /** @type {?} */
        var outputDefs = new Array(outputs.length);
        for (var i_79 = 0; i_79 < outputs.length; i_79++) {
            var _f = __read(outputs[i_79], 2), target = _f[0], eventName = _f[1];
            outputDefs[i_79] = {
                type: 0 /* ElementOutput */,
                target: ( /** @type {?} */(target)), eventName: eventName,
                propName: null
            };
        }
        fixedAttrs = fixedAttrs || [];
        /** @type {?} */
        var attrs = ( /** @type {?} */(fixedAttrs.map(( /**
         * @param {?} __0
         * @return {?}
         */function (_b) {
            var _c = __read(_b, 2), namespaceAndName = _c[0], value = _c[1];
            var _d = __read(splitNamespace(namespaceAndName), 2), ns = _d[0], name = _d[1];
            return [ns, name, value];
        }))));
        componentRendererType = resolveRendererType2(componentRendererType);
        if (componentView) {
            flags |= 33554432 /* ComponentView */;
        }
        flags |= 1 /* TypeElement */;
        return {
            // will bet set by the view definition
            nodeIndex: -1,
            parent: null,
            renderParent: null,
            bindingIndex: -1,
            outputIndex: -1,
            // regular values
            checkIndex: checkIndex,
            flags: flags,
            childFlags: 0,
            directChildFlags: 0,
            childMatchedQueries: 0, matchedQueries: matchedQueries, matchedQueryIds: matchedQueryIds, references: references, ngContentIndex: ngContentIndex, childCount: childCount,
            bindings: bindingDefs,
            bindingFlags: calcBindingFlags(bindingDefs),
            outputs: outputDefs,
            element: {
                ns: ns,
                name: name,
                attrs: attrs,
                template: null,
                // will bet set by the view definition
                componentProvider: null,
                componentView: componentView || null,
                componentRendererType: componentRendererType,
                publicProviders: null,
                allProviders: null,
                handleEvent: handleEvent || NOOP,
            },
            provider: null,
            text: null,
            query: null,
            ngContent: null
        };
    }
    /**
     * @param {?} view
     * @param {?} renderHost
     * @param {?} def
     * @return {?}
     */
    function createElement(view, renderHost, def) {
        /** @type {?} */
        var elDef = ( /** @type {?} */(def.element));
        /** @type {?} */
        var rootSelectorOrNode = view.root.selectorOrNode;
        /** @type {?} */
        var renderer = view.renderer;
        /** @type {?} */
        var el;
        if (view.parent || !rootSelectorOrNode) {
            if (elDef.name) {
                el = renderer.createElement(elDef.name, elDef.ns);
            }
            else {
                el = renderer.createComment('');
            }
            /** @type {?} */
            var parentEl = getParentRenderElement(view, renderHost, def);
            if (parentEl) {
                renderer.appendChild(parentEl, el);
            }
        }
        else {
            // when using native Shadow DOM, do not clear the root element contents to allow slot projection
            /** @type {?} */
            var preserveContent = (!!elDef.componentRendererType &&
                elDef.componentRendererType.encapsulation === ViewEncapsulation.ShadowDom);
            el = renderer.selectRootElement(rootSelectorOrNode, preserveContent);
        }
        if (elDef.attrs) {
            for (var i_80 = 0; i_80 < elDef.attrs.length; i_80++) {
                var _b = __read(elDef.attrs[i_80], 3), ns = _b[0], name_2 = _b[1], value = _b[2];
                renderer.setAttribute(el, name_2, value, ns);
            }
        }
        return el;
    }
    /**
     * @param {?} view
     * @param {?} compView
     * @param {?} def
     * @param {?} el
     * @return {?}
     */
    function listenToElementOutputs(view, compView, def, el) {
        for (var i_81 = 0; i_81 < def.outputs.length; i_81++) {
            /** @type {?} */
            var output = def.outputs[i_81];
            /** @type {?} */
            var handleEventClosure = renderEventHandlerClosure(view, def.nodeIndex, elementEventFullName(output.target, output.eventName));
            /** @type {?} */
            var listenTarget = output.target;
            /** @type {?} */
            var listenerView = view;
            if (output.target === 'component') {
                listenTarget = null;
                listenerView = compView;
            }
            /** @type {?} */
            var disposable = ( /** @type {?} */(listenerView.renderer.listen(listenTarget || el, output.eventName, handleEventClosure)));
            ( /** @type {?} */(view.disposables))[def.outputIndex + i_81] = disposable;
        }
    }
    /**
     * @param {?} view
     * @param {?} index
     * @param {?} eventName
     * @return {?}
     */
    function renderEventHandlerClosure(view, index, eventName) {
        return ( /**
         * @param {?} event
         * @return {?}
         */function (event) { return dispatchEvent(view, index, eventName, event); });
    }
    /**
     * @param {?} view
     * @param {?} def
     * @param {?} v0
     * @param {?} v1
     * @param {?} v2
     * @param {?} v3
     * @param {?} v4
     * @param {?} v5
     * @param {?} v6
     * @param {?} v7
     * @param {?} v8
     * @param {?} v9
     * @return {?}
     */
    function checkAndUpdateElementInline(view, def, v0, v1, v2, v3, v4, v5, v6, v7, v8, v9) {
        /** @type {?} */
        var bindLen = def.bindings.length;
        /** @type {?} */
        var changed = false;
        if (bindLen > 0 && checkAndUpdateElementValue(view, def, 0, v0))
            changed = true;
        if (bindLen > 1 && checkAndUpdateElementValue(view, def, 1, v1))
            changed = true;
        if (bindLen > 2 && checkAndUpdateElementValue(view, def, 2, v2))
            changed = true;
        if (bindLen > 3 && checkAndUpdateElementValue(view, def, 3, v3))
            changed = true;
        if (bindLen > 4 && checkAndUpdateElementValue(view, def, 4, v4))
            changed = true;
        if (bindLen > 5 && checkAndUpdateElementValue(view, def, 5, v5))
            changed = true;
        if (bindLen > 6 && checkAndUpdateElementValue(view, def, 6, v6))
            changed = true;
        if (bindLen > 7 && checkAndUpdateElementValue(view, def, 7, v7))
            changed = true;
        if (bindLen > 8 && checkAndUpdateElementValue(view, def, 8, v8))
            changed = true;
        if (bindLen > 9 && checkAndUpdateElementValue(view, def, 9, v9))
            changed = true;
        return changed;
    }
    /**
     * @param {?} view
     * @param {?} def
     * @param {?} values
     * @return {?}
     */
    function checkAndUpdateElementDynamic(view, def, values) {
        /** @type {?} */
        var changed = false;
        for (var i_82 = 0; i_82 < values.length; i_82++) {
            if (checkAndUpdateElementValue(view, def, i_82, values[i_82]))
                changed = true;
        }
        return changed;
    }
    /**
     * @param {?} view
     * @param {?} def
     * @param {?} bindingIdx
     * @param {?} value
     * @return {?}
     */
    function checkAndUpdateElementValue(view, def, bindingIdx, value) {
        if (!checkAndUpdateBinding(view, def, bindingIdx, value)) {
            return false;
        }
        /** @type {?} */
        var binding = def.bindings[bindingIdx];
        /** @type {?} */
        var elData = asElementData(view, def.nodeIndex);
        /** @type {?} */
        var renderNode = elData.renderElement;
        /** @type {?} */
        var name = ( /** @type {?} */(binding.name));
        switch (binding.flags & 15 /* Types */) {
            case 1 /* TypeElementAttribute */:
                setElementAttribute(view, binding, renderNode, binding.ns, name, value);
                break;
            case 2 /* TypeElementClass */:
                setElementClass(view, renderNode, name, value);
                break;
            case 4 /* TypeElementStyle */:
                setElementStyle(view, binding, renderNode, name, value);
                break;
            case 8 /* TypeProperty */:
                /** @type {?} */
                var bindView = (def.flags & 33554432 /* ComponentView */ &&
                    binding.flags & 32 /* SyntheticHostProperty */) ?
                    elData.componentView :
                    view;
                setElementProperty(bindView, binding, renderNode, name, value);
                break;
        }
        return true;
    }
    /**
     * @param {?} view
     * @param {?} binding
     * @param {?} renderNode
     * @param {?} ns
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    function setElementAttribute(view, binding, renderNode, ns, name, value) {
        /** @type {?} */
        var securityContext = binding.securityContext;
        /** @type {?} */
        var renderValue = securityContext ? view.root.sanitizer.sanitize(securityContext, value) : value;
        renderValue = renderValue != null ? renderValue.toString() : null;
        /** @type {?} */
        var renderer = view.renderer;
        if (value != null) {
            renderer.setAttribute(renderNode, name, renderValue, ns);
        }
        else {
            renderer.removeAttribute(renderNode, name, ns);
        }
    }
    /**
     * @param {?} view
     * @param {?} renderNode
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    function setElementClass(view, renderNode, name, value) {
        /** @type {?} */
        var renderer = view.renderer;
        if (value) {
            renderer.addClass(renderNode, name);
        }
        else {
            renderer.removeClass(renderNode, name);
        }
    }
    /**
     * @param {?} view
     * @param {?} binding
     * @param {?} renderNode
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    function setElementStyle(view, binding, renderNode, name, value) {
        /** @type {?} */
        var renderValue = view.root.sanitizer.sanitize(SecurityContext.STYLE, ( /** @type {?} */(value)));
        if (renderValue != null) {
            renderValue = renderValue.toString();
            /** @type {?} */
            var unit = binding.suffix;
            if (unit != null) {
                renderValue = renderValue + unit;
            }
        }
        else {
            renderValue = null;
        }
        /** @type {?} */
        var renderer = view.renderer;
        if (renderValue != null) {
            renderer.setStyle(renderNode, name, renderValue);
        }
        else {
            renderer.removeStyle(renderNode, name);
        }
    }
    /**
     * @param {?} view
     * @param {?} binding
     * @param {?} renderNode
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    function setElementProperty(view, binding, renderNode, name, value) {
        /** @type {?} */
        var securityContext = binding.securityContext;
        /** @type {?} */
        var renderValue = securityContext ? view.root.sanitizer.sanitize(securityContext, value) : value;
        view.renderer.setProperty(renderNode, name, renderValue);
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} flags
     * @param {?} id
     * @param {?} bindings
     * @return {?}
     */
    function queryDef(flags, id, bindings) {
        /** @type {?} */
        var bindingDefs = [];
        for (var propName in bindings) {
            /** @type {?} */
            var bindingType = bindings[propName];
            bindingDefs.push({ propName: propName, bindingType: bindingType });
        }
        return {
            // will bet set by the view definition
            nodeIndex: -1,
            parent: null,
            renderParent: null,
            bindingIndex: -1,
            outputIndex: -1,
            // regular values
            // TODO(vicb): check
            checkIndex: -1, flags: flags,
            childFlags: 0,
            directChildFlags: 0,
            childMatchedQueries: 0,
            ngContentIndex: -1,
            matchedQueries: {},
            matchedQueryIds: 0,
            references: {},
            childCount: 0,
            bindings: [],
            bindingFlags: 0,
            outputs: [],
            element: null,
            provider: null,
            text: null,
            query: { id: id, filterId: filterQueryId(id), bindings: bindingDefs },
            ngContent: null
        };
    }
    /**
     * @return {?}
     */
    function createQuery() {
        return new QueryList();
    }
    /**
     * @param {?} view
     * @return {?}
     */
    function dirtyParentQueries(view) {
        /** @type {?} */
        var queryIds = view.def.nodeMatchedQueries;
        while (view.parent && isEmbeddedView(view)) {
            /** @type {?} */
            var tplDef = ( /** @type {?} */(view.parentNodeDef));
            view = view.parent;
            // content queries
            /** @type {?} */
            var end = tplDef.nodeIndex + tplDef.childCount;
            for (var i_83 = 0; i_83 <= end; i_83++) {
                /** @type {?} */
                var nodeDef = view.def.nodes[i_83];
                if ((nodeDef.flags & 67108864 /* TypeContentQuery */) &&
                    (nodeDef.flags & 536870912 /* DynamicQuery */) &&
                    (( /** @type {?} */(nodeDef.query)).filterId & queryIds) === ( /** @type {?} */(nodeDef.query)).filterId) {
                    asQueryList(view, i_83).setDirty();
                }
                if ((nodeDef.flags & 1 /* TypeElement */ && i_83 + nodeDef.childCount < tplDef.nodeIndex) ||
                    !(nodeDef.childFlags & 67108864 /* TypeContentQuery */) ||
                    !(nodeDef.childFlags & 536870912 /* DynamicQuery */)) {
                    // skip elements that don't contain the template element or no query.
                    i_83 += nodeDef.childCount;
                }
            }
        }
        // view queries
        if (view.def.nodeFlags & 134217728 /* TypeViewQuery */) {
            for (var i_84 = 0; i_84 < view.def.nodes.length; i_84++) {
                /** @type {?} */
                var nodeDef = view.def.nodes[i_84];
                if ((nodeDef.flags & 134217728 /* TypeViewQuery */) && (nodeDef.flags & 536870912 /* DynamicQuery */)) {
                    asQueryList(view, i_84).setDirty();
                }
                // only visit the root nodes
                i_84 += nodeDef.childCount;
            }
        }
    }
    /**
     * @param {?} view
     * @param {?} nodeDef
     * @return {?}
     */
    function checkAndUpdateQuery(view, nodeDef) {
        /** @type {?} */
        var queryList = asQueryList(view, nodeDef.nodeIndex);
        if (!queryList.dirty) {
            return;
        }
        /** @type {?} */
        var directiveInstance;
        /** @type {?} */
        var newValues = ( /** @type {?} */(undefined));
        if (nodeDef.flags & 67108864 /* TypeContentQuery */) {
            /** @type {?} */
            var elementDef_1 = ( /** @type {?} */(( /** @type {?} */(nodeDef.parent)).parent));
            newValues = calcQueryValues(view, elementDef_1.nodeIndex, elementDef_1.nodeIndex + elementDef_1.childCount, ( /** @type {?} */(nodeDef.query)), []);
            directiveInstance = asProviderData(view, ( /** @type {?} */(nodeDef.parent)).nodeIndex).instance;
        }
        else if (nodeDef.flags & 134217728 /* TypeViewQuery */) {
            newValues = calcQueryValues(view, 0, view.def.nodes.length - 1, ( /** @type {?} */(nodeDef.query)), []);
            directiveInstance = view.component;
        }
        queryList.reset(newValues);
        /** @type {?} */
        var bindings = ( /** @type {?} */(nodeDef.query)).bindings;
        /** @type {?} */
        var notify = false;
        for (var i_85 = 0; i_85 < bindings.length; i_85++) {
            /** @type {?} */
            var binding = bindings[i_85];
            /** @type {?} */
            var boundValue = void 0;
            switch (binding.bindingType) {
                case 0 /* First */:
                    boundValue = queryList.first;
                    break;
                case 1 /* All */:
                    boundValue = queryList;
                    notify = true;
                    break;
            }
            directiveInstance[binding.propName] = boundValue;
        }
        if (notify) {
            queryList.notifyOnChanges();
        }
    }
    /**
     * @param {?} view
     * @param {?} startIndex
     * @param {?} endIndex
     * @param {?} queryDef
     * @param {?} values
     * @return {?}
     */
    function calcQueryValues(view, startIndex, endIndex, queryDef, values) {
        for (var i_86 = startIndex; i_86 <= endIndex; i_86++) {
            /** @type {?} */
            var nodeDef = view.def.nodes[i_86];
            /** @type {?} */
            var valueType = nodeDef.matchedQueries[queryDef.id];
            if (valueType != null) {
                values.push(getQueryValue(view, nodeDef, valueType));
            }
            if (nodeDef.flags & 1 /* TypeElement */ && ( /** @type {?} */(nodeDef.element)).template &&
                (( /** @type {?} */(( /** @type {?} */(nodeDef.element)).template)).nodeMatchedQueries & queryDef.filterId) ===
                    queryDef.filterId) {
                /** @type {?} */
                var elementData = asElementData(view, i_86);
                // check embedded views that were attached at the place of their template,
                // but process child nodes first if some match the query (see issue #16568)
                if ((nodeDef.childMatchedQueries & queryDef.filterId) === queryDef.filterId) {
                    calcQueryValues(view, i_86 + 1, i_86 + nodeDef.childCount, queryDef, values);
                    i_86 += nodeDef.childCount;
                }
                if (nodeDef.flags & 16777216 /* EmbeddedViews */) {
                    /** @type {?} */
                    var embeddedViews = ( /** @type {?} */(elementData.viewContainer))._embeddedViews;
                    for (var k = 0; k < embeddedViews.length; k++) {
                        /** @type {?} */
                        var embeddedView = embeddedViews[k];
                        /** @type {?} */
                        var dvc = declaredViewContainer(embeddedView);
                        if (dvc && dvc === elementData) {
                            calcQueryValues(embeddedView, 0, embeddedView.def.nodes.length - 1, queryDef, values);
                        }
                    }
                }
                /** @type {?} */
                var projectedViews = elementData.template._projectedViews;
                if (projectedViews) {
                    for (var k = 0; k < projectedViews.length; k++) {
                        /** @type {?} */
                        var projectedView = projectedViews[k];
                        calcQueryValues(projectedView, 0, projectedView.def.nodes.length - 1, queryDef, values);
                    }
                }
            }
            if ((nodeDef.childMatchedQueries & queryDef.filterId) !== queryDef.filterId) {
                // if no child matches the query, skip the children.
                i_86 += nodeDef.childCount;
            }
        }
        return values;
    }
    /**
     * @param {?} view
     * @param {?} nodeDef
     * @param {?} queryValueType
     * @return {?}
     */
    function getQueryValue(view, nodeDef, queryValueType) {
        if (queryValueType != null) {
            // a match
            switch (queryValueType) {
                case 1 /* RenderElement */:
                    return asElementData(view, nodeDef.nodeIndex).renderElement;
                case 0 /* ElementRef */:
                    return new ElementRef(asElementData(view, nodeDef.nodeIndex).renderElement);
                case 2 /* TemplateRef */:
                    return asElementData(view, nodeDef.nodeIndex).template;
                case 3 /* ViewContainerRef */:
                    return asElementData(view, nodeDef.nodeIndex).viewContainer;
                case 4 /* Provider */:
                    return asProviderData(view, nodeDef.nodeIndex).instance;
            }
        }
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} ngContentIndex
     * @param {?} index
     * @return {?}
     */
    function ngContentDef(ngContentIndex, index) {
        return {
            // will bet set by the view definition
            nodeIndex: -1,
            parent: null,
            renderParent: null,
            bindingIndex: -1,
            outputIndex: -1,
            // regular values
            checkIndex: -1,
            flags: 8 /* TypeNgContent */,
            childFlags: 0,
            directChildFlags: 0,
            childMatchedQueries: 0,
            matchedQueries: {},
            matchedQueryIds: 0,
            references: {}, ngContentIndex: ngContentIndex,
            childCount: 0,
            bindings: [],
            bindingFlags: 0,
            outputs: [],
            element: null,
            provider: null,
            text: null,
            query: null,
            ngContent: { index: index }
        };
    }
    /**
     * @param {?} view
     * @param {?} renderHost
     * @param {?} def
     * @return {?}
     */
    function appendNgContent(view, renderHost, def) {
        /** @type {?} */
        var parentEl = getParentRenderElement(view, renderHost, def);
        if (!parentEl) {
            // Nothing to do if there is no parent element.
            return;
        }
        /** @type {?} */
        var ngContentIndex = ( /** @type {?} */(def.ngContent)).index;
        visitProjectedRenderNodes(view, ngContentIndex, 1 /* AppendChild */, parentEl, null, undefined);
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} checkIndex
     * @param {?} argCount
     * @return {?}
     */
    function purePipeDef(checkIndex, argCount) {
        // argCount + 1 to include the pipe as first arg
        return _pureExpressionDef(128 /* TypePurePipe */, checkIndex, new Array(argCount + 1));
    }
    /**
     * @param {?} checkIndex
     * @param {?} propToIndex
     * @return {?}
     */
    function pureObjectDef(checkIndex, propToIndex) {
        /** @type {?} */
        var keys = Object.keys(propToIndex);
        /** @type {?} */
        var nbKeys = keys.length;
        /** @type {?} */
        var propertyNames = new Array(nbKeys);
        for (var i_87 = 0; i_87 < nbKeys; i_87++) {
            /** @type {?} */
            var key = keys[i_87];
            /** @type {?} */
            var index = propToIndex[key];
            propertyNames[index] = key;
        }
        return _pureExpressionDef(64 /* TypePureObject */, checkIndex, propertyNames);
    }
    /**
     * @param {?} flags
     * @param {?} checkIndex
     * @param {?} propertyNames
     * @return {?}
     */
    function _pureExpressionDef(flags, checkIndex, propertyNames) {
        /** @type {?} */
        var bindings = new Array(propertyNames.length);
        for (var i_88 = 0; i_88 < propertyNames.length; i_88++) {
            /** @type {?} */
            var prop = propertyNames[i_88];
            bindings[i_88] = {
                flags: 8 /* TypeProperty */,
                name: prop,
                ns: null,
                nonMinifiedName: prop,
                securityContext: null,
                suffix: null
            };
        }
        return {
            // will bet set by the view definition
            nodeIndex: -1,
            parent: null,
            renderParent: null,
            bindingIndex: -1,
            outputIndex: -1,
            // regular values
            checkIndex: checkIndex,
            flags: flags,
            childFlags: 0,
            directChildFlags: 0,
            childMatchedQueries: 0,
            matchedQueries: {},
            matchedQueryIds: 0,
            references: {},
            ngContentIndex: -1,
            childCount: 0, bindings: bindings,
            bindingFlags: calcBindingFlags(bindings),
            outputs: [],
            element: null,
            provider: null,
            text: null,
            query: null,
            ngContent: null
        };
    }
    /**
     * @param {?} view
     * @param {?} def
     * @return {?}
     */
    function createPureExpression(view, def) {
        return { value: undefined };
    }
    /**
     * @param {?} view
     * @param {?} def
     * @param {?} v0
     * @param {?} v1
     * @param {?} v2
     * @param {?} v3
     * @param {?} v4
     * @param {?} v5
     * @param {?} v6
     * @param {?} v7
     * @param {?} v8
     * @param {?} v9
     * @return {?}
     */
    function checkAndUpdatePureExpressionInline(view, def, v0, v1, v2, v3, v4, v5, v6, v7, v8, v9) {
        /** @type {?} */
        var bindings = def.bindings;
        /** @type {?} */
        var changed = false;
        /** @type {?} */
        var bindLen = bindings.length;
        if (bindLen > 0 && checkAndUpdateBinding(view, def, 0, v0))
            changed = true;
        if (bindLen > 1 && checkAndUpdateBinding(view, def, 1, v1))
            changed = true;
        if (bindLen > 2 && checkAndUpdateBinding(view, def, 2, v2))
            changed = true;
        if (bindLen > 3 && checkAndUpdateBinding(view, def, 3, v3))
            changed = true;
        if (bindLen > 4 && checkAndUpdateBinding(view, def, 4, v4))
            changed = true;
        if (bindLen > 5 && checkAndUpdateBinding(view, def, 5, v5))
            changed = true;
        if (bindLen > 6 && checkAndUpdateBinding(view, def, 6, v6))
            changed = true;
        if (bindLen > 7 && checkAndUpdateBinding(view, def, 7, v7))
            changed = true;
        if (bindLen > 8 && checkAndUpdateBinding(view, def, 8, v8))
            changed = true;
        if (bindLen > 9 && checkAndUpdateBinding(view, def, 9, v9))
            changed = true;
        if (changed) {
            /** @type {?} */
            var data = asPureExpressionData(view, def.nodeIndex);
            /** @type {?} */
            var value = void 0;
            switch (def.flags & 201347067 /* Types */) {
                case 32 /* TypePureArray */:
                    value = new Array(bindings.length);
                    if (bindLen > 0)
                        value[0] = v0;
                    if (bindLen > 1)
                        value[1] = v1;
                    if (bindLen > 2)
                        value[2] = v2;
                    if (bindLen > 3)
                        value[3] = v3;
                    if (bindLen > 4)
                        value[4] = v4;
                    if (bindLen > 5)
                        value[5] = v5;
                    if (bindLen > 6)
                        value[6] = v6;
                    if (bindLen > 7)
                        value[7] = v7;
                    if (bindLen > 8)
                        value[8] = v8;
                    if (bindLen > 9)
                        value[9] = v9;
                    break;
                case 64 /* TypePureObject */:
                    value = {};
                    if (bindLen > 0)
                        value[( /** @type {?} */(bindings[0].name))] = v0;
                    if (bindLen > 1)
                        value[( /** @type {?} */(bindings[1].name))] = v1;
                    if (bindLen > 2)
                        value[( /** @type {?} */(bindings[2].name))] = v2;
                    if (bindLen > 3)
                        value[( /** @type {?} */(bindings[3].name))] = v3;
                    if (bindLen > 4)
                        value[( /** @type {?} */(bindings[4].name))] = v4;
                    if (bindLen > 5)
                        value[( /** @type {?} */(bindings[5].name))] = v5;
                    if (bindLen > 6)
                        value[( /** @type {?} */(bindings[6].name))] = v6;
                    if (bindLen > 7)
                        value[( /** @type {?} */(bindings[7].name))] = v7;
                    if (bindLen > 8)
                        value[( /** @type {?} */(bindings[8].name))] = v8;
                    if (bindLen > 9)
                        value[( /** @type {?} */(bindings[9].name))] = v9;
                    break;
                case 128 /* TypePurePipe */:
                    /** @type {?} */
                    var pipe_1 = v0;
                    switch (bindLen) {
                        case 1:
                            value = pipe_1.transform(v0);
                            break;
                        case 2:
                            value = pipe_1.transform(v1);
                            break;
                        case 3:
                            value = pipe_1.transform(v1, v2);
                            break;
                        case 4:
                            value = pipe_1.transform(v1, v2, v3);
                            break;
                        case 5:
                            value = pipe_1.transform(v1, v2, v3, v4);
                            break;
                        case 6:
                            value = pipe_1.transform(v1, v2, v3, v4, v5);
                            break;
                        case 7:
                            value = pipe_1.transform(v1, v2, v3, v4, v5, v6);
                            break;
                        case 8:
                            value = pipe_1.transform(v1, v2, v3, v4, v5, v6, v7);
                            break;
                        case 9:
                            value = pipe_1.transform(v1, v2, v3, v4, v5, v6, v7, v8);
                            break;
                        case 10:
                            value = pipe_1.transform(v1, v2, v3, v4, v5, v6, v7, v8, v9);
                            break;
                    }
                    break;
            }
            data.value = value;
        }
        return changed;
    }
    /**
     * @param {?} view
     * @param {?} def
     * @param {?} values
     * @return {?}
     */
    function checkAndUpdatePureExpressionDynamic(view, def, values) {
        /** @type {?} */
        var bindings = def.bindings;
        /** @type {?} */
        var changed = false;
        for (var i_89 = 0; i_89 < values.length; i_89++) {
            // Note: We need to loop over all values, so that
            // the old values are updates as well!
            if (checkAndUpdateBinding(view, def, i_89, values[i_89])) {
                changed = true;
            }
        }
        if (changed) {
            /** @type {?} */
            var data = asPureExpressionData(view, def.nodeIndex);
            /** @type {?} */
            var value = void 0;
            switch (def.flags & 201347067 /* Types */) {
                case 32 /* TypePureArray */:
                    value = values;
                    break;
                case 64 /* TypePureObject */:
                    value = {};
                    for (var i_90 = 0; i_90 < values.length; i_90++) {
                        value[( /** @type {?} */(bindings[i_90].name))] = values[i_90];
                    }
                    break;
                case 128 /* TypePurePipe */:
                    /** @type {?} */
                    var pipe_2 = values[0];
                    /** @type {?} */
                    var params = values.slice(1);
                    value = pipe_2.transform.apply(pipe_2, __spread(params));
                    break;
            }
            data.value = value;
        }
        return changed;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} checkIndex
     * @param {?} ngContentIndex
     * @param {?} staticText
     * @return {?}
     */
    function textDef(checkIndex, ngContentIndex, staticText) {
        /** @type {?} */
        var bindings = new Array(staticText.length - 1);
        for (var i_91 = 1; i_91 < staticText.length; i_91++) {
            bindings[i_91 - 1] = {
                flags: 8 /* TypeProperty */,
                name: null,
                ns: null,
                nonMinifiedName: null,
                securityContext: null,
                suffix: staticText[i_91],
            };
        }
        return {
            // will bet set by the view definition
            nodeIndex: -1,
            parent: null,
            renderParent: null,
            bindingIndex: -1,
            outputIndex: -1,
            // regular values
            checkIndex: checkIndex,
            flags: 2 /* TypeText */,
            childFlags: 0,
            directChildFlags: 0,
            childMatchedQueries: 0,
            matchedQueries: {},
            matchedQueryIds: 0,
            references: {}, ngContentIndex: ngContentIndex,
            childCount: 0, bindings: bindings,
            bindingFlags: 8 /* TypeProperty */,
            outputs: [],
            element: null,
            provider: null,
            text: { prefix: staticText[0] },
            query: null,
            ngContent: null,
        };
    }
    /**
     * @param {?} view
     * @param {?} renderHost
     * @param {?} def
     * @return {?}
     */
    function createText(view, renderHost, def) {
        /** @type {?} */
        var renderNode;
        /** @type {?} */
        var renderer = view.renderer;
        renderNode = renderer.createText(( /** @type {?} */(def.text)).prefix);
        /** @type {?} */
        var parentEl = getParentRenderElement(view, renderHost, def);
        if (parentEl) {
            renderer.appendChild(parentEl, renderNode);
        }
        return { renderText: renderNode };
    }
    /**
     * @param {?} view
     * @param {?} def
     * @param {?} v0
     * @param {?} v1
     * @param {?} v2
     * @param {?} v3
     * @param {?} v4
     * @param {?} v5
     * @param {?} v6
     * @param {?} v7
     * @param {?} v8
     * @param {?} v9
     * @return {?}
     */
    function checkAndUpdateTextInline(view, def, v0, v1, v2, v3, v4, v5, v6, v7, v8, v9) {
        /** @type {?} */
        var changed = false;
        /** @type {?} */
        var bindings = def.bindings;
        /** @type {?} */
        var bindLen = bindings.length;
        if (bindLen > 0 && checkAndUpdateBinding(view, def, 0, v0))
            changed = true;
        if (bindLen > 1 && checkAndUpdateBinding(view, def, 1, v1))
            changed = true;
        if (bindLen > 2 && checkAndUpdateBinding(view, def, 2, v2))
            changed = true;
        if (bindLen > 3 && checkAndUpdateBinding(view, def, 3, v3))
            changed = true;
        if (bindLen > 4 && checkAndUpdateBinding(view, def, 4, v4))
            changed = true;
        if (bindLen > 5 && checkAndUpdateBinding(view, def, 5, v5))
            changed = true;
        if (bindLen > 6 && checkAndUpdateBinding(view, def, 6, v6))
            changed = true;
        if (bindLen > 7 && checkAndUpdateBinding(view, def, 7, v7))
            changed = true;
        if (bindLen > 8 && checkAndUpdateBinding(view, def, 8, v8))
            changed = true;
        if (bindLen > 9 && checkAndUpdateBinding(view, def, 9, v9))
            changed = true;
        if (changed) {
            /** @type {?} */
            var value = ( /** @type {?} */(def.text)).prefix;
            if (bindLen > 0)
                value += _addInterpolationPart(v0, bindings[0]);
            if (bindLen > 1)
                value += _addInterpolationPart(v1, bindings[1]);
            if (bindLen > 2)
                value += _addInterpolationPart(v2, bindings[2]);
            if (bindLen > 3)
                value += _addInterpolationPart(v3, bindings[3]);
            if (bindLen > 4)
                value += _addInterpolationPart(v4, bindings[4]);
            if (bindLen > 5)
                value += _addInterpolationPart(v5, bindings[5]);
            if (bindLen > 6)
                value += _addInterpolationPart(v6, bindings[6]);
            if (bindLen > 7)
                value += _addInterpolationPart(v7, bindings[7]);
            if (bindLen > 8)
                value += _addInterpolationPart(v8, bindings[8]);
            if (bindLen > 9)
                value += _addInterpolationPart(v9, bindings[9]);
            /** @type {?} */
            var renderNode_1 = asTextData(view, def.nodeIndex).renderText;
            view.renderer.setValue(renderNode_1, value);
        }
        return changed;
    }
    /**
     * @param {?} view
     * @param {?} def
     * @param {?} values
     * @return {?}
     */
    function checkAndUpdateTextDynamic(view, def, values) {
        /** @type {?} */
        var bindings = def.bindings;
        /** @type {?} */
        var changed = false;
        for (var i_92 = 0; i_92 < values.length; i_92++) {
            // Note: We need to loop over all values, so that
            // the old values are updates as well!
            if (checkAndUpdateBinding(view, def, i_92, values[i_92])) {
                changed = true;
            }
        }
        if (changed) {
            /** @type {?} */
            var value = '';
            for (var i_93 = 0; i_93 < values.length; i_93++) {
                value = value + _addInterpolationPart(values[i_93], bindings[i_93]);
            }
            value = ( /** @type {?} */(def.text)).prefix + value;
            /** @type {?} */
            var renderNode_2 = asTextData(view, def.nodeIndex).renderText;
            view.renderer.setValue(renderNode_2, value);
        }
        return changed;
    }
    /**
     * @param {?} value
     * @param {?} binding
     * @return {?}
     */
    function _addInterpolationPart(value, binding) {
        /** @type {?} */
        var valueStr = value != null ? value.toString() : '';
        return valueStr + binding.suffix;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} flags
     * @param {?} nodes
     * @param {?=} updateDirectives
     * @param {?=} updateRenderer
     * @return {?}
     */
    function viewDef(flags, nodes, updateDirectives, updateRenderer) {
        // clone nodes and set auto calculated values
        /** @type {?} */
        var viewBindingCount = 0;
        /** @type {?} */
        var viewDisposableCount = 0;
        /** @type {?} */
        var viewNodeFlags = 0;
        /** @type {?} */
        var viewRootNodeFlags = 0;
        /** @type {?} */
        var viewMatchedQueries = 0;
        /** @type {?} */
        var currentParent = null;
        /** @type {?} */
        var currentRenderParent = null;
        /** @type {?} */
        var currentElementHasPublicProviders = false;
        /** @type {?} */
        var currentElementHasPrivateProviders = false;
        /** @type {?} */
        var lastRenderRootNode = null;
        for (var i_94 = 0; i_94 < nodes.length; i_94++) {
            /** @type {?} */
            var node = nodes[i_94];
            node.nodeIndex = i_94;
            node.parent = currentParent;
            node.bindingIndex = viewBindingCount;
            node.outputIndex = viewDisposableCount;
            node.renderParent = currentRenderParent;
            viewNodeFlags |= node.flags;
            viewMatchedQueries |= node.matchedQueryIds;
            if (node.element) {
                /** @type {?} */
                var elDef = node.element;
                elDef.publicProviders =
                    currentParent ? ( /** @type {?} */(currentParent.element)).publicProviders : Object.create(null);
                elDef.allProviders = elDef.publicProviders;
                // Note: We assume that all providers of an element are before any child element!
                currentElementHasPublicProviders = false;
                currentElementHasPrivateProviders = false;
                if (node.element.template) {
                    viewMatchedQueries |= node.element.template.nodeMatchedQueries;
                }
            }
            validateNode(currentParent, node, nodes.length);
            viewBindingCount += node.bindings.length;
            viewDisposableCount += node.outputs.length;
            if (!currentRenderParent && (node.flags & 3 /* CatRenderNode */)) {
                lastRenderRootNode = node;
            }
            if (node.flags & 20224 /* CatProvider */) {
                if (!currentElementHasPublicProviders) {
                    currentElementHasPublicProviders = true;
                    // Use prototypical inheritance to not get O(n^2) complexity...
                    ( /** @type {?} */(( /** @type {?} */(currentParent)).element)).publicProviders =
                        Object.create(( /** @type {?} */(( /** @type {?} */(currentParent)).element)).publicProviders);
                    ( /** @type {?} */(( /** @type {?} */(currentParent)).element)).allProviders = ( /** @type {?} */(( /** @type {?} */(currentParent)).element)).publicProviders;
                }
                /** @type {?} */
                var isPrivateService = (node.flags & 8192 /* PrivateProvider */) !== 0;
                /** @type {?} */
                var isComponent_2 = (node.flags & 32768 /* Component */) !== 0;
                if (!isPrivateService || isComponent_2) {
                    ( /** @type {?} */(( /** @type {?} */(( /** @type {?} */(currentParent)).element)).publicProviders))[tokenKey(( /** @type {?} */(node.provider)).token)] = node;
                }
                else {
                    if (!currentElementHasPrivateProviders) {
                        currentElementHasPrivateProviders = true;
                        // Use prototypical inheritance to not get O(n^2) complexity...
                        ( /** @type {?} */(( /** @type {?} */(currentParent)).element)).allProviders =
                            Object.create(( /** @type {?} */(( /** @type {?} */(currentParent)).element)).publicProviders);
                    }
                    ( /** @type {?} */(( /** @type {?} */(( /** @type {?} */(currentParent)).element)).allProviders))[tokenKey(( /** @type {?} */(node.provider)).token)] = node;
                }
                if (isComponent_2) {
                    ( /** @type {?} */(( /** @type {?} */(currentParent)).element)).componentProvider = node;
                }
            }
            if (currentParent) {
                currentParent.childFlags |= node.flags;
                currentParent.directChildFlags |= node.flags;
                currentParent.childMatchedQueries |= node.matchedQueryIds;
                if (node.element && node.element.template) {
                    currentParent.childMatchedQueries |= node.element.template.nodeMatchedQueries;
                }
            }
            else {
                viewRootNodeFlags |= node.flags;
            }
            if (node.childCount > 0) {
                currentParent = node;
                if (!isNgContainer(node)) {
                    currentRenderParent = node;
                }
            }
            else {
                // When the current node has no children, check if it is the last children of its parent.
                // When it is, propagate the flags up.
                // The loop is required because an element could be the last transitive children of several
                // elements. We loop to either the root or the highest opened element (= with remaining
                // children)
                while (currentParent && i_94 === currentParent.nodeIndex + currentParent.childCount) {
                    /** @type {?} */
                    var newParent = currentParent.parent;
                    if (newParent) {
                        newParent.childFlags |= currentParent.childFlags;
                        newParent.childMatchedQueries |= currentParent.childMatchedQueries;
                    }
                    currentParent = newParent;
                    // We also need to update the render parent & account for ng-container
                    if (currentParent && isNgContainer(currentParent)) {
                        currentRenderParent = currentParent.renderParent;
                    }
                    else {
                        currentRenderParent = currentParent;
                    }
                }
            }
        }
        /** @type {?} */
        var handleEvent = ( /**
         * @param {?} view
         * @param {?} nodeIndex
         * @param {?} eventName
         * @param {?} event
         * @return {?}
         */function (view, nodeIndex, eventName, event) { return ( /** @type {?} */(( /** @type {?} */(nodes[nodeIndex].element)).handleEvent))(view, eventName, event); });
        return {
            // Will be filled later...
            factory: null,
            nodeFlags: viewNodeFlags,
            rootNodeFlags: viewRootNodeFlags,
            nodeMatchedQueries: viewMatchedQueries, flags: flags,
            nodes: nodes,
            updateDirectives: updateDirectives || NOOP,
            updateRenderer: updateRenderer || NOOP, handleEvent: handleEvent,
            bindingCount: viewBindingCount,
            outputCount: viewDisposableCount, lastRenderRootNode: lastRenderRootNode
        };
    }
    /**
     * @param {?} node
     * @return {?}
     */
    function isNgContainer(node) {
        return (node.flags & 1 /* TypeElement */) !== 0 && ( /** @type {?} */(node.element)).name === null;
    }
    /**
     * @param {?} parent
     * @param {?} node
     * @param {?} nodeCount
     * @return {?}
     */
    function validateNode(parent, node, nodeCount) {
        /** @type {?} */
        var template = node.element && node.element.template;
        if (template) {
            if (!template.lastRenderRootNode) {
                throw new Error("Illegal State: Embedded templates without nodes are not allowed!");
            }
            if (template.lastRenderRootNode &&
                template.lastRenderRootNode.flags & 16777216 /* EmbeddedViews */) {
                throw new Error("Illegal State: Last root node of a template can't have embedded views, at index " + node.nodeIndex + "!");
            }
        }
        if (node.flags & 20224 /* CatProvider */) {
            /** @type {?} */
            var parentFlags = parent ? parent.flags : 0;
            if ((parentFlags & 1 /* TypeElement */) === 0) {
                throw new Error("Illegal State: StaticProvider/Directive nodes need to be children of elements or anchors, at index " + node.nodeIndex + "!");
            }
        }
        if (node.query) {
            if (node.flags & 67108864 /* TypeContentQuery */ &&
                (!parent || (parent.flags & 16384 /* TypeDirective */) === 0)) {
                throw new Error("Illegal State: Content Query nodes need to be children of directives, at index " + node.nodeIndex + "!");
            }
            if (node.flags & 134217728 /* TypeViewQuery */ && parent) {
                throw new Error("Illegal State: View Query nodes have to be top level nodes, at index " + node.nodeIndex + "!");
            }
        }
        if (node.childCount) {
            /** @type {?} */
            var parentEnd = parent ? parent.nodeIndex + parent.childCount : nodeCount - 1;
            if (node.nodeIndex <= parentEnd && node.nodeIndex + node.childCount > parentEnd) {
                throw new Error("Illegal State: childCount of node leads outside of parent, at index " + node.nodeIndex + "!");
            }
        }
    }
    /**
     * @param {?} parent
     * @param {?} anchorDef
     * @param {?} viewDef
     * @param {?=} context
     * @return {?}
     */
    function createEmbeddedView(parent, anchorDef, viewDef, context) {
        // embedded views are seen as siblings to the anchor, so we need
        // to get the parent of the anchor and use it as parentIndex.
        /** @type {?} */
        var view = createView(parent.root, parent.renderer, parent, anchorDef, viewDef);
        initView(view, parent.component, context);
        createViewNodes(view);
        return view;
    }
    /**
     * @param {?} root
     * @param {?} def
     * @param {?=} context
     * @return {?}
     */
    function createRootView(root, def, context) {
        /** @type {?} */
        var view = createView(root, root.renderer, null, null, def);
        initView(view, context, context);
        createViewNodes(view);
        return view;
    }
    /**
     * @param {?} parentView
     * @param {?} nodeDef
     * @param {?} viewDef
     * @param {?} hostElement
     * @return {?}
     */
    function createComponentView(parentView, nodeDef, viewDef, hostElement) {
        /** @type {?} */
        var rendererType = ( /** @type {?} */(nodeDef.element)).componentRendererType;
        /** @type {?} */
        var compRenderer;
        if (!rendererType) {
            compRenderer = parentView.root.renderer;
        }
        else {
            compRenderer = parentView.root.rendererFactory.createRenderer(hostElement, rendererType);
        }
        return createView(parentView.root, compRenderer, parentView, ( /** @type {?} */(nodeDef.element)).componentProvider, viewDef);
    }
    /**
     * @param {?} root
     * @param {?} renderer
     * @param {?} parent
     * @param {?} parentNodeDef
     * @param {?} def
     * @return {?}
     */
    function createView(root, renderer, parent, parentNodeDef, def) {
        /** @type {?} */
        var nodes = new Array(def.nodes.length);
        /** @type {?} */
        var disposables = def.outputCount ? new Array(def.outputCount) : null;
        /** @type {?} */
        var view = {
            def: def,
            parent: parent,
            viewContainerParent: null, parentNodeDef: parentNodeDef,
            context: null,
            component: null, nodes: nodes,
            state: 13 /* CatInit */, root: root, renderer: renderer,
            oldValues: new Array(def.bindingCount), disposables: disposables,
            initIndex: -1
        };
        return view;
    }
    /**
     * @param {?} view
     * @param {?} component
     * @param {?} context
     * @return {?}
     */
    function initView(view, component, context) {
        view.component = component;
        view.context = context;
    }
    /**
     * @param {?} view
     * @return {?}
     */
    function createViewNodes(view) {
        /** @type {?} */
        var renderHost;
        if (isComponentView(view)) {
            /** @type {?} */
            var hostDef = view.parentNodeDef;
            renderHost = asElementData(( /** @type {?} */(view.parent)), ( /** @type {?} */(( /** @type {?} */(hostDef)).parent)).nodeIndex).renderElement;
        }
        /** @type {?} */
        var def = view.def;
        /** @type {?} */
        var nodes = view.nodes;
        for (var i_95 = 0; i_95 < def.nodes.length; i_95++) {
            /** @type {?} */
            var nodeDef = def.nodes[i_95];
            Services.setCurrentNode(view, i_95);
            /** @type {?} */
            var nodeData = void 0;
            switch (nodeDef.flags & 201347067 /* Types */) {
                case 1 /* TypeElement */:
                    /** @type {?} */
                    var el = ( /** @type {?} */(createElement(view, renderHost, nodeDef)));
                    /** @type {?} */
                    var componentView = ( /** @type {?} */(undefined));
                    if (nodeDef.flags & 33554432 /* ComponentView */) {
                        /** @type {?} */
                        var compViewDef = resolveDefinition(( /** @type {?} */(( /** @type {?} */(nodeDef.element)).componentView)));
                        componentView = Services.createComponentView(view, nodeDef, compViewDef, el);
                    }
                    listenToElementOutputs(view, componentView, nodeDef, el);
                    nodeData = ( /** @type {?} */({
                        renderElement: el,
                        componentView: componentView,
                        viewContainer: null,
                        template: ( /** @type {?} */(nodeDef.element)).template ? createTemplateData(view, nodeDef) : undefined
                    }));
                    if (nodeDef.flags & 16777216 /* EmbeddedViews */) {
                        nodeData.viewContainer = createViewContainerData(view, nodeDef, nodeData);
                    }
                    break;
                case 2 /* TypeText */:
                    nodeData = ( /** @type {?} */(createText(view, renderHost, nodeDef)));
                    break;
                case 512 /* TypeClassProvider */:
                case 1024 /* TypeFactoryProvider */:
                case 2048 /* TypeUseExistingProvider */:
                case 256 /* TypeValueProvider */: {
                    nodeData = nodes[i_95];
                    if (!nodeData && !(nodeDef.flags & 4096 /* LazyProvider */)) {
                        /** @type {?} */
                        var instance = createProviderInstance(view, nodeDef);
                        nodeData = ( /** @type {?} */({ instance: instance }));
                    }
                    break;
                }
                case 16 /* TypePipe */: {
                    /** @type {?} */
                    var instance = createPipeInstance(view, nodeDef);
                    nodeData = ( /** @type {?} */({ instance: instance }));
                    break;
                }
                case 16384 /* TypeDirective */: {
                    nodeData = nodes[i_95];
                    if (!nodeData) {
                        /** @type {?} */
                        var instance = createDirectiveInstance(view, nodeDef);
                        nodeData = ( /** @type {?} */({ instance: instance }));
                    }
                    if (nodeDef.flags & 32768 /* Component */) {
                        /** @type {?} */
                        var compView = asElementData(view, ( /** @type {?} */(nodeDef.parent)).nodeIndex).componentView;
                        initView(compView, nodeData.instance, nodeData.instance);
                    }
                    break;
                }
                case 32 /* TypePureArray */:
                case 64 /* TypePureObject */:
                case 128 /* TypePurePipe */:
                    nodeData = ( /** @type {?} */(createPureExpression(view, nodeDef)));
                    break;
                case 67108864 /* TypeContentQuery */:
                case 134217728 /* TypeViewQuery */:
                    nodeData = ( /** @type {?} */(createQuery()));
                    break;
                case 8 /* TypeNgContent */:
                    appendNgContent(view, renderHost, nodeDef);
                    // no runtime data needed for NgContent...
                    nodeData = undefined;
                    break;
            }
            nodes[i_95] = nodeData;
        }
        // Create the ViewData.nodes of component views after we created everything else,
        // so that e.g. ng-content works
        execComponentViewsAction(view, ViewAction.CreateViewNodes);
        // fill static content and view queries
        execQueriesAction(view, 67108864 /* TypeContentQuery */ | 134217728 /* TypeViewQuery */, 268435456 /* StaticQuery */, 0 /* CheckAndUpdate */);
    }
    /**
     * @param {?} view
     * @return {?}
     */
    function checkNoChangesView(view) {
        markProjectedViewsForCheck(view);
        Services.updateDirectives(view, 1 /* CheckNoChanges */);
        execEmbeddedViewsAction(view, ViewAction.CheckNoChanges);
        Services.updateRenderer(view, 1 /* CheckNoChanges */);
        execComponentViewsAction(view, ViewAction.CheckNoChanges);
        // Note: We don't check queries for changes as we didn't do this in v2.x.
        // TODO(tbosch): investigate if we can enable the check again in v5.x with a nicer error message.
        view.state &= ~(64 /* CheckProjectedViews */ | 32 /* CheckProjectedView */);
    }
    /**
     * @param {?} view
     * @return {?}
     */
    function checkAndUpdateView(view) {
        if (view.state & 1 /* BeforeFirstCheck */) {
            view.state &= ~1 /* BeforeFirstCheck */;
            view.state |= 2 /* FirstCheck */;
        }
        else {
            view.state &= ~2 /* FirstCheck */;
        }
        shiftInitState(view, 0 /* InitState_BeforeInit */, 256 /* InitState_CallingOnInit */);
        markProjectedViewsForCheck(view);
        Services.updateDirectives(view, 0 /* CheckAndUpdate */);
        execEmbeddedViewsAction(view, ViewAction.CheckAndUpdate);
        execQueriesAction(view, 67108864 /* TypeContentQuery */, 536870912 /* DynamicQuery */, 0 /* CheckAndUpdate */);
        /** @type {?} */
        var callInit = shiftInitState(view, 256 /* InitState_CallingOnInit */, 512 /* InitState_CallingAfterContentInit */);
        callLifecycleHooksChildrenFirst(view, 2097152 /* AfterContentChecked */ | (callInit ? 1048576 /* AfterContentInit */ : 0));
        Services.updateRenderer(view, 0 /* CheckAndUpdate */);
        execComponentViewsAction(view, ViewAction.CheckAndUpdate);
        execQueriesAction(view, 134217728 /* TypeViewQuery */, 536870912 /* DynamicQuery */, 0 /* CheckAndUpdate */);
        callInit = shiftInitState(view, 512 /* InitState_CallingAfterContentInit */, 768 /* InitState_CallingAfterViewInit */);
        callLifecycleHooksChildrenFirst(view, 8388608 /* AfterViewChecked */ | (callInit ? 4194304 /* AfterViewInit */ : 0));
        if (view.def.flags & 2 /* OnPush */) {
            view.state &= ~8 /* ChecksEnabled */;
        }
        view.state &= ~(64 /* CheckProjectedViews */ | 32 /* CheckProjectedView */);
        shiftInitState(view, 768 /* InitState_CallingAfterViewInit */, 1024 /* InitState_AfterInit */);
    }
    /**
     * @param {?} view
     * @param {?} nodeDef
     * @param {?} argStyle
     * @param {?=} v0
     * @param {?=} v1
     * @param {?=} v2
     * @param {?=} v3
     * @param {?=} v4
     * @param {?=} v5
     * @param {?=} v6
     * @param {?=} v7
     * @param {?=} v8
     * @param {?=} v9
     * @return {?}
     */
    function checkAndUpdateNode(view, nodeDef, argStyle, v0, v1, v2, v3, v4, v5, v6, v7, v8, v9) {
        if (argStyle === 0 /* Inline */) {
            return checkAndUpdateNodeInline(view, nodeDef, v0, v1, v2, v3, v4, v5, v6, v7, v8, v9);
        }
        else {
            return checkAndUpdateNodeDynamic(view, nodeDef, v0);
        }
    }
    /**
     * @param {?} view
     * @return {?}
     */
    function markProjectedViewsForCheck(view) {
        /** @type {?} */
        var def = view.def;
        if (!(def.nodeFlags & 4 /* ProjectedTemplate */)) {
            return;
        }
        for (var i_96 = 0; i_96 < def.nodes.length; i_96++) {
            /** @type {?} */
            var nodeDef = def.nodes[i_96];
            if (nodeDef.flags & 4 /* ProjectedTemplate */) {
                /** @type {?} */
                var projectedViews = asElementData(view, i_96).template._projectedViews;
                if (projectedViews) {
                    for (var i_97 = 0; i_97 < projectedViews.length; i_97++) {
                        /** @type {?} */
                        var projectedView = projectedViews[i_97];
                        projectedView.state |= 32 /* CheckProjectedView */;
                        markParentViewsForCheckProjectedViews(projectedView, view);
                    }
                }
            }
            else if ((nodeDef.childFlags & 4 /* ProjectedTemplate */) === 0) {
                // a parent with leafs
                // no child is a component,
                // then skip the children
                i_96 += nodeDef.childCount;
            }
        }
    }
    /**
     * @param {?} view
     * @param {?} nodeDef
     * @param {?=} v0
     * @param {?=} v1
     * @param {?=} v2
     * @param {?=} v3
     * @param {?=} v4
     * @param {?=} v5
     * @param {?=} v6
     * @param {?=} v7
     * @param {?=} v8
     * @param {?=} v9
     * @return {?}
     */
    function checkAndUpdateNodeInline(view, nodeDef, v0, v1, v2, v3, v4, v5, v6, v7, v8, v9) {
        switch (nodeDef.flags & 201347067 /* Types */) {
            case 1 /* TypeElement */:
                return checkAndUpdateElementInline(view, nodeDef, v0, v1, v2, v3, v4, v5, v6, v7, v8, v9);
            case 2 /* TypeText */:
                return checkAndUpdateTextInline(view, nodeDef, v0, v1, v2, v3, v4, v5, v6, v7, v8, v9);
            case 16384 /* TypeDirective */:
                return checkAndUpdateDirectiveInline(view, nodeDef, v0, v1, v2, v3, v4, v5, v6, v7, v8, v9);
            case 32 /* TypePureArray */:
            case 64 /* TypePureObject */:
            case 128 /* TypePurePipe */:
                return checkAndUpdatePureExpressionInline(view, nodeDef, v0, v1, v2, v3, v4, v5, v6, v7, v8, v9);
            default:
                throw 'unreachable';
        }
    }
    /**
     * @param {?} view
     * @param {?} nodeDef
     * @param {?} values
     * @return {?}
     */
    function checkAndUpdateNodeDynamic(view, nodeDef, values) {
        switch (nodeDef.flags & 201347067 /* Types */) {
            case 1 /* TypeElement */:
                return checkAndUpdateElementDynamic(view, nodeDef, values);
            case 2 /* TypeText */:
                return checkAndUpdateTextDynamic(view, nodeDef, values);
            case 16384 /* TypeDirective */:
                return checkAndUpdateDirectiveDynamic(view, nodeDef, values);
            case 32 /* TypePureArray */:
            case 64 /* TypePureObject */:
            case 128 /* TypePurePipe */:
                return checkAndUpdatePureExpressionDynamic(view, nodeDef, values);
            default:
                throw 'unreachable';
        }
    }
    /**
     * @param {?} view
     * @param {?} nodeDef
     * @param {?} argStyle
     * @param {?=} v0
     * @param {?=} v1
     * @param {?=} v2
     * @param {?=} v3
     * @param {?=} v4
     * @param {?=} v5
     * @param {?=} v6
     * @param {?=} v7
     * @param {?=} v8
     * @param {?=} v9
     * @return {?}
     */
    function checkNoChangesNode(view, nodeDef, argStyle, v0, v1, v2, v3, v4, v5, v6, v7, v8, v9) {
        if (argStyle === 0 /* Inline */) {
            checkNoChangesNodeInline(view, nodeDef, v0, v1, v2, v3, v4, v5, v6, v7, v8, v9);
        }
        else {
            checkNoChangesNodeDynamic(view, nodeDef, v0);
        }
        // Returning false is ok here as we would have thrown in case of a change.
        return false;
    }
    /**
     * @param {?} view
     * @param {?} nodeDef
     * @param {?} v0
     * @param {?} v1
     * @param {?} v2
     * @param {?} v3
     * @param {?} v4
     * @param {?} v5
     * @param {?} v6
     * @param {?} v7
     * @param {?} v8
     * @param {?} v9
     * @return {?}
     */
    function checkNoChangesNodeInline(view, nodeDef, v0, v1, v2, v3, v4, v5, v6, v7, v8, v9) {
        /** @type {?} */
        var bindLen = nodeDef.bindings.length;
        if (bindLen > 0)
            checkBindingNoChanges(view, nodeDef, 0, v0);
        if (bindLen > 1)
            checkBindingNoChanges(view, nodeDef, 1, v1);
        if (bindLen > 2)
            checkBindingNoChanges(view, nodeDef, 2, v2);
        if (bindLen > 3)
            checkBindingNoChanges(view, nodeDef, 3, v3);
        if (bindLen > 4)
            checkBindingNoChanges(view, nodeDef, 4, v4);
        if (bindLen > 5)
            checkBindingNoChanges(view, nodeDef, 5, v5);
        if (bindLen > 6)
            checkBindingNoChanges(view, nodeDef, 6, v6);
        if (bindLen > 7)
            checkBindingNoChanges(view, nodeDef, 7, v7);
        if (bindLen > 8)
            checkBindingNoChanges(view, nodeDef, 8, v8);
        if (bindLen > 9)
            checkBindingNoChanges(view, nodeDef, 9, v9);
    }
    /**
     * @param {?} view
     * @param {?} nodeDef
     * @param {?} values
     * @return {?}
     */
    function checkNoChangesNodeDynamic(view, nodeDef, values) {
        for (var i_98 = 0; i_98 < values.length; i_98++) {
            checkBindingNoChanges(view, nodeDef, i_98, values[i_98]);
        }
    }
    /**
     * Workaround https://github.com/angular/tsickle/issues/497
     * @suppress {misplacedTypeAnnotation}
     * @param {?} view
     * @param {?} nodeDef
     * @return {?}
     */
    function checkNoChangesQuery(view, nodeDef) {
        /** @type {?} */
        var queryList = asQueryList(view, nodeDef.nodeIndex);
        if (queryList.dirty) {
            throw expressionChangedAfterItHasBeenCheckedError(Services.createDebugContext(view, nodeDef.nodeIndex), "Query " + ( /** @type {?} */(nodeDef.query)).id + " not dirty", "Query " + ( /** @type {?} */(nodeDef.query)).id + " dirty", (view.state & 1 /* BeforeFirstCheck */) !== 0);
        }
    }
    /**
     * @param {?} view
     * @return {?}
     */
    function destroyView(view) {
        if (view.state & 128 /* Destroyed */) {
            return;
        }
        execEmbeddedViewsAction(view, ViewAction.Destroy);
        execComponentViewsAction(view, ViewAction.Destroy);
        callLifecycleHooksChildrenFirst(view, 131072 /* OnDestroy */);
        if (view.disposables) {
            for (var i_99 = 0; i_99 < view.disposables.length; i_99++) {
                view.disposables[i_99]();
            }
        }
        detachProjectedView(view);
        if (view.renderer.destroyNode) {
            destroyViewNodes(view);
        }
        if (isComponentView(view)) {
            view.renderer.destroy();
        }
        view.state |= 128 /* Destroyed */;
    }
    /**
     * @param {?} view
     * @return {?}
     */
    function destroyViewNodes(view) {
        /** @type {?} */
        var len = view.def.nodes.length;
        for (var i_100 = 0; i_100 < len; i_100++) {
            /** @type {?} */
            var def = view.def.nodes[i_100];
            if (def.flags & 1 /* TypeElement */) {
                ( /** @type {?} */(view.renderer.destroyNode))(asElementData(view, i_100).renderElement);
            }
            else if (def.flags & 2 /* TypeText */) {
                ( /** @type {?} */(view.renderer.destroyNode))(asTextData(view, i_100).renderText);
            }
            else if (def.flags & 67108864 /* TypeContentQuery */ || def.flags & 134217728 /* TypeViewQuery */) {
                asQueryList(view, i_100).destroy();
            }
        }
    }
    /** @enum {number} */
    var ViewAction = {
        CreateViewNodes: 0,
        CheckNoChanges: 1,
        CheckNoChangesProjectedViews: 2,
        CheckAndUpdate: 3,
        CheckAndUpdateProjectedViews: 4,
        Destroy: 5,
    };
    ViewAction[ViewAction.CreateViewNodes] = 'CreateViewNodes';
    ViewAction[ViewAction.CheckNoChanges] = 'CheckNoChanges';
    ViewAction[ViewAction.CheckNoChangesProjectedViews] = 'CheckNoChangesProjectedViews';
    ViewAction[ViewAction.CheckAndUpdate] = 'CheckAndUpdate';
    ViewAction[ViewAction.CheckAndUpdateProjectedViews] = 'CheckAndUpdateProjectedViews';
    ViewAction[ViewAction.Destroy] = 'Destroy';
    /**
     * @param {?} view
     * @param {?} action
     * @return {?}
     */
    function execComponentViewsAction(view, action) {
        /** @type {?} */
        var def = view.def;
        if (!(def.nodeFlags & 33554432 /* ComponentView */)) {
            return;
        }
        for (var i_101 = 0; i_101 < def.nodes.length; i_101++) {
            /** @type {?} */
            var nodeDef = def.nodes[i_101];
            if (nodeDef.flags & 33554432 /* ComponentView */) {
                // a leaf
                callViewAction(asElementData(view, i_101).componentView, action);
            }
            else if ((nodeDef.childFlags & 33554432 /* ComponentView */) === 0) {
                // a parent with leafs
                // no child is a component,
                // then skip the children
                i_101 += nodeDef.childCount;
            }
        }
    }
    /**
     * @param {?} view
     * @param {?} action
     * @return {?}
     */
    function execEmbeddedViewsAction(view, action) {
        /** @type {?} */
        var def = view.def;
        if (!(def.nodeFlags & 16777216 /* EmbeddedViews */)) {
            return;
        }
        for (var i_102 = 0; i_102 < def.nodes.length; i_102++) {
            /** @type {?} */
            var nodeDef = def.nodes[i_102];
            if (nodeDef.flags & 16777216 /* EmbeddedViews */) {
                // a leaf
                /** @type {?} */
                var embeddedViews = ( /** @type {?} */(asElementData(view, i_102).viewContainer))._embeddedViews;
                for (var k = 0; k < embeddedViews.length; k++) {
                    callViewAction(embeddedViews[k], action);
                }
            }
            else if ((nodeDef.childFlags & 16777216 /* EmbeddedViews */) === 0) {
                // a parent with leafs
                // no child is a component,
                // then skip the children
                i_102 += nodeDef.childCount;
            }
        }
    }
    /**
     * @param {?} view
     * @param {?} action
     * @return {?}
     */
    function callViewAction(view, action) {
        /** @type {?} */
        var viewState = view.state;
        switch (action) {
            case ViewAction.CheckNoChanges:
                if ((viewState & 128 /* Destroyed */) === 0) {
                    if ((viewState & 12 /* CatDetectChanges */) === 12 /* CatDetectChanges */) {
                        checkNoChangesView(view);
                    }
                    else if (viewState & 64 /* CheckProjectedViews */) {
                        execProjectedViewsAction(view, ViewAction.CheckNoChangesProjectedViews);
                    }
                }
                break;
            case ViewAction.CheckNoChangesProjectedViews:
                if ((viewState & 128 /* Destroyed */) === 0) {
                    if (viewState & 32 /* CheckProjectedView */) {
                        checkNoChangesView(view);
                    }
                    else if (viewState & 64 /* CheckProjectedViews */) {
                        execProjectedViewsAction(view, action);
                    }
                }
                break;
            case ViewAction.CheckAndUpdate:
                if ((viewState & 128 /* Destroyed */) === 0) {
                    if ((viewState & 12 /* CatDetectChanges */) === 12 /* CatDetectChanges */) {
                        checkAndUpdateView(view);
                    }
                    else if (viewState & 64 /* CheckProjectedViews */) {
                        execProjectedViewsAction(view, ViewAction.CheckAndUpdateProjectedViews);
                    }
                }
                break;
            case ViewAction.CheckAndUpdateProjectedViews:
                if ((viewState & 128 /* Destroyed */) === 0) {
                    if (viewState & 32 /* CheckProjectedView */) {
                        checkAndUpdateView(view);
                    }
                    else if (viewState & 64 /* CheckProjectedViews */) {
                        execProjectedViewsAction(view, action);
                    }
                }
                break;
            case ViewAction.Destroy:
                // Note: destroyView recurses over all views,
                // so we don't need to special case projected views here.
                destroyView(view);
                break;
            case ViewAction.CreateViewNodes:
                createViewNodes(view);
                break;
        }
    }
    /**
     * @param {?} view
     * @param {?} action
     * @return {?}
     */
    function execProjectedViewsAction(view, action) {
        execEmbeddedViewsAction(view, action);
        execComponentViewsAction(view, action);
    }
    /**
     * @param {?} view
     * @param {?} queryFlags
     * @param {?} staticDynamicQueryFlag
     * @param {?} checkType
     * @return {?}
     */
    function execQueriesAction(view, queryFlags, staticDynamicQueryFlag, checkType) {
        if (!(view.def.nodeFlags & queryFlags) || !(view.def.nodeFlags & staticDynamicQueryFlag)) {
            return;
        }
        /** @type {?} */
        var nodeCount = view.def.nodes.length;
        for (var i_103 = 0; i_103 < nodeCount; i_103++) {
            /** @type {?} */
            var nodeDef = view.def.nodes[i_103];
            if ((nodeDef.flags & queryFlags) && (nodeDef.flags & staticDynamicQueryFlag)) {
                Services.setCurrentNode(view, nodeDef.nodeIndex);
                switch (checkType) {
                    case 0 /* CheckAndUpdate */:
                        checkAndUpdateQuery(view, nodeDef);
                        break;
                    case 1 /* CheckNoChanges */:
                        checkNoChangesQuery(view, nodeDef);
                        break;
                }
            }
            if (!(nodeDef.childFlags & queryFlags) || !(nodeDef.childFlags & staticDynamicQueryFlag)) {
                // no child has a matching query
                // then skip the children
                i_103 += nodeDef.childCount;
            }
        }
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var initialized = false;
    /**
     * @return {?}
     */
    function initServicesIfNeeded() {
        if (initialized) {
            return;
        }
        initialized = true;
        /** @type {?} */
        var services = isDevMode() ? createDebugServices() : createProdServices();
        Services.setCurrentNode = services.setCurrentNode;
        Services.createRootView = services.createRootView;
        Services.createEmbeddedView = services.createEmbeddedView;
        Services.createComponentView = services.createComponentView;
        Services.createNgModuleRef = services.createNgModuleRef;
        Services.overrideProvider = services.overrideProvider;
        Services.overrideComponentView = services.overrideComponentView;
        Services.clearOverrides = services.clearOverrides;
        Services.checkAndUpdateView = services.checkAndUpdateView;
        Services.checkNoChangesView = services.checkNoChangesView;
        Services.destroyView = services.destroyView;
        Services.resolveDep = resolveDep;
        Services.createDebugContext = services.createDebugContext;
        Services.handleEvent = services.handleEvent;
        Services.updateDirectives = services.updateDirectives;
        Services.updateRenderer = services.updateRenderer;
        Services.dirtyParentQueries = dirtyParentQueries;
    }
    /**
     * @return {?}
     */
    function createProdServices() {
        return {
            setCurrentNode: ( /**
             * @return {?}
             */function () { }),
            createRootView: createProdRootView,
            createEmbeddedView: createEmbeddedView,
            createComponentView: createComponentView,
            createNgModuleRef: createNgModuleRef,
            overrideProvider: NOOP,
            overrideComponentView: NOOP,
            clearOverrides: NOOP,
            checkAndUpdateView: checkAndUpdateView,
            checkNoChangesView: checkNoChangesView,
            destroyView: destroyView,
            createDebugContext: ( /**
             * @param {?} view
             * @param {?} nodeIndex
             * @return {?}
             */function (view, nodeIndex) { return new DebugContext_(view, nodeIndex); }),
            handleEvent: ( /**
             * @param {?} view
             * @param {?} nodeIndex
             * @param {?} eventName
             * @param {?} event
             * @return {?}
             */function (view, nodeIndex, eventName, event) { return view.def.handleEvent(view, nodeIndex, eventName, event); }),
            updateDirectives: ( /**
             * @param {?} view
             * @param {?} checkType
             * @return {?}
             */function (view, checkType) { return view.def.updateDirectives(checkType === 0 /* CheckAndUpdate */ ? prodCheckAndUpdateNode :
                prodCheckNoChangesNode, view); }),
            updateRenderer: ( /**
             * @param {?} view
             * @param {?} checkType
             * @return {?}
             */function (view, checkType) { return view.def.updateRenderer(checkType === 0 /* CheckAndUpdate */ ? prodCheckAndUpdateNode :
                prodCheckNoChangesNode, view); }),
        };
    }
    /**
     * @return {?}
     */
    function createDebugServices() {
        return {
            setCurrentNode: debugSetCurrentNode,
            createRootView: debugCreateRootView,
            createEmbeddedView: debugCreateEmbeddedView,
            createComponentView: debugCreateComponentView,
            createNgModuleRef: debugCreateNgModuleRef,
            overrideProvider: debugOverrideProvider,
            overrideComponentView: debugOverrideComponentView,
            clearOverrides: debugClearOverrides,
            checkAndUpdateView: debugCheckAndUpdateView,
            checkNoChangesView: debugCheckNoChangesView,
            destroyView: debugDestroyView,
            createDebugContext: ( /**
             * @param {?} view
             * @param {?} nodeIndex
             * @return {?}
             */function (view, nodeIndex) { return new DebugContext_(view, nodeIndex); }),
            handleEvent: debugHandleEvent,
            updateDirectives: debugUpdateDirectives,
            updateRenderer: debugUpdateRenderer,
        };
    }
    /**
     * @param {?} elInjector
     * @param {?} projectableNodes
     * @param {?} rootSelectorOrNode
     * @param {?} def
     * @param {?} ngModule
     * @param {?=} context
     * @return {?}
     */
    function createProdRootView(elInjector, projectableNodes, rootSelectorOrNode, def, ngModule, context) {
        /** @type {?} */
        var rendererFactory = ngModule.injector.get(RendererFactory2);
        return createRootView(createRootData(elInjector, ngModule, rendererFactory, projectableNodes, rootSelectorOrNode), def, context);
    }
    /**
     * @param {?} elInjector
     * @param {?} projectableNodes
     * @param {?} rootSelectorOrNode
     * @param {?} def
     * @param {?} ngModule
     * @param {?=} context
     * @return {?}
     */
    function debugCreateRootView(elInjector, projectableNodes, rootSelectorOrNode, def, ngModule, context) {
        /** @type {?} */
        var rendererFactory = ngModule.injector.get(RendererFactory2);
        /** @type {?} */
        var root = createRootData(elInjector, ngModule, new DebugRendererFactory2(rendererFactory), projectableNodes, rootSelectorOrNode);
        /** @type {?} */
        var defWithOverride = applyProviderOverridesToView(def);
        return callWithDebugContext(DebugAction.create, createRootView, null, [root, defWithOverride, context]);
    }
    /**
     * @param {?} elInjector
     * @param {?} ngModule
     * @param {?} rendererFactory
     * @param {?} projectableNodes
     * @param {?} rootSelectorOrNode
     * @return {?}
     */
    function createRootData(elInjector, ngModule, rendererFactory, projectableNodes, rootSelectorOrNode) {
        /** @type {?} */
        var sanitizer = ngModule.injector.get(Sanitizer);
        /** @type {?} */
        var errorHandler = ngModule.injector.get(ErrorHandler);
        /** @type {?} */
        var renderer = rendererFactory.createRenderer(null, null);
        return {
            ngModule: ngModule,
            injector: elInjector, projectableNodes: projectableNodes,
            selectorOrNode: rootSelectorOrNode, sanitizer: sanitizer, rendererFactory: rendererFactory, renderer: renderer, errorHandler: errorHandler
        };
    }
    /**
     * @param {?} parentView
     * @param {?} anchorDef
     * @param {?} viewDef
     * @param {?=} context
     * @return {?}
     */
    function debugCreateEmbeddedView(parentView, anchorDef, viewDef, context) {
        /** @type {?} */
        var defWithOverride = applyProviderOverridesToView(viewDef);
        return callWithDebugContext(DebugAction.create, createEmbeddedView, null, [parentView, anchorDef, defWithOverride, context]);
    }
    /**
     * @param {?} parentView
     * @param {?} nodeDef
     * @param {?} viewDef
     * @param {?} hostElement
     * @return {?}
     */
    function debugCreateComponentView(parentView, nodeDef, viewDef, hostElement) {
        /** @type {?} */
        var overrideComponentView = viewDefOverrides.get(( /** @type {?} */(( /** @type {?} */(( /** @type {?} */(nodeDef.element)).componentProvider)).provider)).token);
        if (overrideComponentView) {
            viewDef = overrideComponentView;
        }
        else {
            viewDef = applyProviderOverridesToView(viewDef);
        }
        return callWithDebugContext(DebugAction.create, createComponentView, null, [parentView, nodeDef, viewDef, hostElement]);
    }
    /**
     * @param {?} moduleType
     * @param {?} parentInjector
     * @param {?} bootstrapComponents
     * @param {?} def
     * @return {?}
     */
    function debugCreateNgModuleRef(moduleType, parentInjector, bootstrapComponents, def) {
        /** @type {?} */
        var defWithOverride = applyProviderOverridesToNgModule(def);
        return createNgModuleRef(moduleType, parentInjector, bootstrapComponents, defWithOverride);
    }
    /** @type {?} */
    var providerOverrides = new Map();
    /** @type {?} */
    var providerOverridesWithScope = new Map();
    /** @type {?} */
    var viewDefOverrides = new Map();
    /**
     * @param {?} override
     * @return {?}
     */
    function debugOverrideProvider(override) {
        providerOverrides.set(override.token, override);
        /** @type {?} */
        var injectableDef;
        if (typeof override.token === 'function' && (injectableDef = getInjectableDef(override.token)) &&
            typeof injectableDef.providedIn === 'function') {
            providerOverridesWithScope.set(( /** @type {?} */(override.token)), override);
        }
    }
    /**
     * @param {?} comp
     * @param {?} compFactory
     * @return {?}
     */
    function debugOverrideComponentView(comp, compFactory) {
        /** @type {?} */
        var hostViewDef = resolveDefinition(getComponentViewDefinitionFactory(compFactory));
        /** @type {?} */
        var compViewDef = resolveDefinition(( /** @type {?} */(( /** @type {?} */(hostViewDef.nodes[0].element)).componentView)));
        viewDefOverrides.set(comp, compViewDef);
    }
    /**
     * @return {?}
     */
    function debugClearOverrides() {
        providerOverrides.clear();
        providerOverridesWithScope.clear();
        viewDefOverrides.clear();
    }
    // Notes about the algorithm:
    // 1) Locate the providers of an element and check if one of them was overwritten
    // 2) Change the providers of that element
    //
    // We only create new datastructures if we need to, to keep perf impact
    // reasonable.
    /**
     * @param {?} def
     * @return {?}
     */
    function applyProviderOverridesToView(def) {
        if (providerOverrides.size === 0) {
            return def;
        }
        /** @type {?} */
        var elementIndicesWithOverwrittenProviders = findElementIndicesWithOverwrittenProviders(def);
        if (elementIndicesWithOverwrittenProviders.length === 0) {
            return def;
        }
        // clone the whole view definition,
        // as it maintains references between the nodes that are hard to update.
        def = ( /** @type {?} */(def.factory))(( /**
         * @return {?}
         */function () { return NOOP; }));
        for (var i_104 = 0; i_104 < elementIndicesWithOverwrittenProviders.length; i_104++) {
            applyProviderOverridesToElement(def, elementIndicesWithOverwrittenProviders[i_104]);
        }
        return def;
        /**
         * @param {?} def
         * @return {?}
         */
        function findElementIndicesWithOverwrittenProviders(def) {
            /** @type {?} */
            var elIndicesWithOverwrittenProviders = [];
            /** @type {?} */
            var lastElementDef = null;
            for (var i_105 = 0; i_105 < def.nodes.length; i_105++) {
                /** @type {?} */
                var nodeDef = def.nodes[i_105];
                if (nodeDef.flags & 1 /* TypeElement */) {
                    lastElementDef = nodeDef;
                }
                if (lastElementDef && nodeDef.flags & 3840 /* CatProviderNoDirective */ &&
                    providerOverrides.has(( /** @type {?} */(nodeDef.provider)).token)) {
                    elIndicesWithOverwrittenProviders.push(( /** @type {?} */(lastElementDef)).nodeIndex);
                    lastElementDef = null;
                }
            }
            return elIndicesWithOverwrittenProviders;
        }
        /**
         * @param {?} viewDef
         * @param {?} elIndex
         * @return {?}
         */
        function applyProviderOverridesToElement(viewDef, elIndex) {
            for (var i_106 = elIndex + 1; i_106 < viewDef.nodes.length; i_106++) {
                /** @type {?} */
                var nodeDef = viewDef.nodes[i_106];
                if (nodeDef.flags & 1 /* TypeElement */) {
                    // stop at the next element
                    return;
                }
                if (nodeDef.flags & 3840 /* CatProviderNoDirective */) {
                    /** @type {?} */
                    var provider = ( /** @type {?} */(nodeDef.provider));
                    /** @type {?} */
                    var override = providerOverrides.get(provider.token);
                    if (override) {
                        nodeDef.flags = (nodeDef.flags & ~3840 /* CatProviderNoDirective */) | override.flags;
                        provider.deps = splitDepsDsl(override.deps);
                        provider.value = override.value;
                    }
                }
            }
        }
    }
    // Notes about the algorithm:
    // We only create new datastructures if we need to, to keep perf impact
    // reasonable.
    /**
     * @param {?} def
     * @return {?}
     */
    function applyProviderOverridesToNgModule(def) {
        var _b = calcHasOverrides(def), hasOverrides = _b.hasOverrides, hasDeprecatedOverrides = _b.hasDeprecatedOverrides;
        if (!hasOverrides) {
            return def;
        }
        // clone the whole view definition,
        // as it maintains references between the nodes that are hard to update.
        def = ( /** @type {?} */(def.factory))(( /**
         * @return {?}
         */function () { return NOOP; }));
        applyProviderOverrides(def);
        return def;
        /**
         * @param {?} def
         * @return {?}
         */
        function calcHasOverrides(def) {
            /** @type {?} */
            var hasOverrides = false;
            /** @type {?} */
            var hasDeprecatedOverrides = false;
            if (providerOverrides.size === 0) {
                return { hasOverrides: hasOverrides, hasDeprecatedOverrides: hasDeprecatedOverrides };
            }
            def.providers.forEach(( /**
             * @param {?} node
             * @return {?}
             */function (/**
             * @param {?} node
             * @return {?}
             */ node) {
                /** @type {?} */
                var override = providerOverrides.get(node.token);
                if ((node.flags & 3840 /* CatProviderNoDirective */) && override) {
                    hasOverrides = true;
                    hasDeprecatedOverrides = hasDeprecatedOverrides || override.deprecatedBehavior;
                }
            }));
            def.modules.forEach(( /**
             * @param {?} module
             * @return {?}
             */function (/**
             * @param {?} module
             * @return {?}
             */ module) {
                providerOverridesWithScope.forEach(( /**
                 * @param {?} override
                 * @param {?} token
                 * @return {?}
                 */function (override, token) {
                    if (( /** @type {?} */(getInjectableDef(token))).providedIn === module) {
                        hasOverrides = true;
                        hasDeprecatedOverrides = hasDeprecatedOverrides || override.deprecatedBehavior;
                    }
                }));
            }));
            return { hasOverrides: hasOverrides, hasDeprecatedOverrides: hasDeprecatedOverrides };
        }
        /**
         * @param {?} def
         * @return {?}
         */
        function applyProviderOverrides(def) {
            for (var i_107 = 0; i_107 < def.providers.length; i_107++) {
                /** @type {?} */
                var provider = def.providers[i_107];
                if (hasDeprecatedOverrides) {
                    // We had a bug where me made
                    // all providers lazy. Keep this logic behind a flag
                    // for migrating existing users.
                    provider.flags |= 4096 /* LazyProvider */;
                }
                /** @type {?} */
                var override = providerOverrides.get(provider.token);
                if (override) {
                    provider.flags = (provider.flags & ~3840 /* CatProviderNoDirective */) | override.flags;
                    provider.deps = splitDepsDsl(override.deps);
                    provider.value = override.value;
                }
            }
            if (providerOverridesWithScope.size > 0) {
                /** @type {?} */
                var moduleSet_1 = new Set(def.modules);
                providerOverridesWithScope.forEach(( /**
                 * @param {?} override
                 * @param {?} token
                 * @return {?}
                 */function (override, token) {
                    if (moduleSet_1.has(( /** @type {?} */(getInjectableDef(token))).providedIn)) {
                        /** @type {?} */
                        var provider = {
                            token: token,
                            flags: override.flags | (hasDeprecatedOverrides ? 4096 /* LazyProvider */ : 0 /* None */),
                            deps: splitDepsDsl(override.deps),
                            value: override.value,
                            index: def.providers.length,
                        };
                        def.providers.push(provider);
                        def.providersByKey[tokenKey(token)] = provider;
                    }
                }));
            }
        }
    }
    /**
     * @param {?} view
     * @param {?} checkIndex
     * @param {?} argStyle
     * @param {?=} v0
     * @param {?=} v1
     * @param {?=} v2
     * @param {?=} v3
     * @param {?=} v4
     * @param {?=} v5
     * @param {?=} v6
     * @param {?=} v7
     * @param {?=} v8
     * @param {?=} v9
     * @return {?}
     */
    function prodCheckAndUpdateNode(view, checkIndex, argStyle, v0, v1, v2, v3, v4, v5, v6, v7, v8, v9) {
        /** @type {?} */
        var nodeDef = view.def.nodes[checkIndex];
        checkAndUpdateNode(view, nodeDef, argStyle, v0, v1, v2, v3, v4, v5, v6, v7, v8, v9);
        return (nodeDef.flags & 224 /* CatPureExpression */) ?
            asPureExpressionData(view, checkIndex).value :
            undefined;
    }
    /**
     * @param {?} view
     * @param {?} checkIndex
     * @param {?} argStyle
     * @param {?=} v0
     * @param {?=} v1
     * @param {?=} v2
     * @param {?=} v3
     * @param {?=} v4
     * @param {?=} v5
     * @param {?=} v6
     * @param {?=} v7
     * @param {?=} v8
     * @param {?=} v9
     * @return {?}
     */
    function prodCheckNoChangesNode(view, checkIndex, argStyle, v0, v1, v2, v3, v4, v5, v6, v7, v8, v9) {
        /** @type {?} */
        var nodeDef = view.def.nodes[checkIndex];
        checkNoChangesNode(view, nodeDef, argStyle, v0, v1, v2, v3, v4, v5, v6, v7, v8, v9);
        return (nodeDef.flags & 224 /* CatPureExpression */) ?
            asPureExpressionData(view, checkIndex).value :
            undefined;
    }
    /**
     * @param {?} view
     * @return {?}
     */
    function debugCheckAndUpdateView(view) {
        return callWithDebugContext(DebugAction.detectChanges, checkAndUpdateView, null, [view]);
    }
    /**
     * @param {?} view
     * @return {?}
     */
    function debugCheckNoChangesView(view) {
        return callWithDebugContext(DebugAction.checkNoChanges, checkNoChangesView, null, [view]);
    }
    /**
     * @param {?} view
     * @return {?}
     */
    function debugDestroyView(view) {
        return callWithDebugContext(DebugAction.destroy, destroyView, null, [view]);
    }
    /** @enum {number} */
    var DebugAction = {
        create: 0,
        detectChanges: 1,
        checkNoChanges: 2,
        destroy: 3,
        handleEvent: 4,
    };
    DebugAction[DebugAction.create] = 'create';
    DebugAction[DebugAction.detectChanges] = 'detectChanges';
    DebugAction[DebugAction.checkNoChanges] = 'checkNoChanges';
    DebugAction[DebugAction.destroy] = 'destroy';
    DebugAction[DebugAction.handleEvent] = 'handleEvent';
    /** @type {?} */
    var _currentAction;
    /** @type {?} */
    var _currentView;
    /** @type {?} */
    var _currentNodeIndex;
    /**
     * @param {?} view
     * @param {?} nodeIndex
     * @return {?}
     */
    function debugSetCurrentNode(view, nodeIndex) {
        _currentView = view;
        _currentNodeIndex = nodeIndex;
    }
    /**
     * @param {?} view
     * @param {?} nodeIndex
     * @param {?} eventName
     * @param {?} event
     * @return {?}
     */
    function debugHandleEvent(view, nodeIndex, eventName, event) {
        debugSetCurrentNode(view, nodeIndex);
        return callWithDebugContext(DebugAction.handleEvent, view.def.handleEvent, null, [view, nodeIndex, eventName, event]);
    }
    /**
     * @param {?} view
     * @param {?} checkType
     * @return {?}
     */
    function debugUpdateDirectives(view, checkType) {
        if (view.state & 128 /* Destroyed */) {
            throw viewDestroyedError(DebugAction[_currentAction]);
        }
        debugSetCurrentNode(view, nextDirectiveWithBinding(view, 0));
        return view.def.updateDirectives(debugCheckDirectivesFn, view);
        /**
         * @param {?} view
         * @param {?} nodeIndex
         * @param {?} argStyle
         * @param {...?} values
         * @return {?}
         */
        function debugCheckDirectivesFn(view, nodeIndex, argStyle) {
            var values = [];
            for (var _i = 3; _i < arguments.length; _i++) {
                values[_i - 3] = arguments[_i];
            }
            /** @type {?} */
            var nodeDef = view.def.nodes[nodeIndex];
            if (checkType === 0 /* CheckAndUpdate */) {
                debugCheckAndUpdateNode(view, nodeDef, argStyle, values);
            }
            else {
                debugCheckNoChangesNode(view, nodeDef, argStyle, values);
            }
            if (nodeDef.flags & 16384 /* TypeDirective */) {
                debugSetCurrentNode(view, nextDirectiveWithBinding(view, nodeIndex));
            }
            return (nodeDef.flags & 224 /* CatPureExpression */) ?
                asPureExpressionData(view, nodeDef.nodeIndex).value :
                undefined;
        }
    }
    /**
     * @param {?} view
     * @param {?} checkType
     * @return {?}
     */
    function debugUpdateRenderer(view, checkType) {
        if (view.state & 128 /* Destroyed */) {
            throw viewDestroyedError(DebugAction[_currentAction]);
        }
        debugSetCurrentNode(view, nextRenderNodeWithBinding(view, 0));
        return view.def.updateRenderer(debugCheckRenderNodeFn, view);
        /**
         * @param {?} view
         * @param {?} nodeIndex
         * @param {?} argStyle
         * @param {...?} values
         * @return {?}
         */
        function debugCheckRenderNodeFn(view, nodeIndex, argStyle) {
            var values = [];
            for (var _i = 3; _i < arguments.length; _i++) {
                values[_i - 3] = arguments[_i];
            }
            /** @type {?} */
            var nodeDef = view.def.nodes[nodeIndex];
            if (checkType === 0 /* CheckAndUpdate */) {
                debugCheckAndUpdateNode(view, nodeDef, argStyle, values);
            }
            else {
                debugCheckNoChangesNode(view, nodeDef, argStyle, values);
            }
            if (nodeDef.flags & 3 /* CatRenderNode */) {
                debugSetCurrentNode(view, nextRenderNodeWithBinding(view, nodeIndex));
            }
            return (nodeDef.flags & 224 /* CatPureExpression */) ?
                asPureExpressionData(view, nodeDef.nodeIndex).value :
                undefined;
        }
    }
    /**
     * @param {?} view
     * @param {?} nodeDef
     * @param {?} argStyle
     * @param {?} givenValues
     * @return {?}
     */
    function debugCheckAndUpdateNode(view, nodeDef, argStyle, givenValues) {
        /** @type {?} */
        var changed = (( /** @type {?} */(checkAndUpdateNode))).apply(void 0, __spread([view, nodeDef, argStyle], givenValues));
        if (changed) {
            /** @type {?} */
            var values = argStyle === 1 /* Dynamic */ ? givenValues[0] : givenValues;
            if (nodeDef.flags & 16384 /* TypeDirective */) {
                /** @type {?} */
                var bindingValues = {};
                for (var i_108 = 0; i_108 < nodeDef.bindings.length; i_108++) {
                    /** @type {?} */
                    var binding = nodeDef.bindings[i_108];
                    /** @type {?} */
                    var value = values[i_108];
                    if (binding.flags & 8 /* TypeProperty */) {
                        bindingValues[normalizeDebugBindingName(( /** @type {?} */(binding.nonMinifiedName)))] =
                            normalizeDebugBindingValue(value);
                    }
                }
                /** @type {?} */
                var elDef = ( /** @type {?} */(nodeDef.parent));
                /** @type {?} */
                var el = asElementData(view, elDef.nodeIndex).renderElement;
                if (!( /** @type {?} */(elDef.element)).name) {
                    // a comment.
                    view.renderer.setValue(el, "bindings=" + JSON.stringify(bindingValues, null, 2));
                }
                else {
                    // a regular element.
                    for (var attr in bindingValues) {
                        /** @type {?} */
                        var value = bindingValues[attr];
                        if (value != null) {
                            view.renderer.setAttribute(el, attr, value);
                        }
                        else {
                            view.renderer.removeAttribute(el, attr);
                        }
                    }
                }
            }
        }
    }
    /**
     * @param {?} view
     * @param {?} nodeDef
     * @param {?} argStyle
     * @param {?} values
     * @return {?}
     */
    function debugCheckNoChangesNode(view, nodeDef, argStyle, values) {
        (( /** @type {?} */(checkNoChangesNode))).apply(void 0, __spread([view, nodeDef, argStyle], values));
    }
    /**
     * @param {?} view
     * @param {?} nodeIndex
     * @return {?}
     */
    function nextDirectiveWithBinding(view, nodeIndex) {
        for (var i_109 = nodeIndex; i_109 < view.def.nodes.length; i_109++) {
            /** @type {?} */
            var nodeDef = view.def.nodes[i_109];
            if (nodeDef.flags & 16384 /* TypeDirective */ && nodeDef.bindings && nodeDef.bindings.length) {
                return i_109;
            }
        }
        return null;
    }
    /**
     * @param {?} view
     * @param {?} nodeIndex
     * @return {?}
     */
    function nextRenderNodeWithBinding(view, nodeIndex) {
        for (var i_110 = nodeIndex; i_110 < view.def.nodes.length; i_110++) {
            /** @type {?} */
            var nodeDef = view.def.nodes[i_110];
            if ((nodeDef.flags & 3 /* CatRenderNode */) && nodeDef.bindings && nodeDef.bindings.length) {
                return i_110;
            }
        }
        return null;
    }
    var DebugContext_ = /** @class */ (function () {
        /**
         * @param {?} view
         * @param {?} nodeIndex
         */
        function DebugContext_(view, nodeIndex) {
            this.view = view;
            this.nodeIndex = nodeIndex;
            if (nodeIndex == null) {
                this.nodeIndex = nodeIndex = 0;
            }
            this.nodeDef = view.def.nodes[nodeIndex];
            /** @type {?} */
            var elDef = this.nodeDef;
            /** @type {?} */
            var elView = view;
            while (elDef && (elDef.flags & 1 /* TypeElement */) === 0) {
                elDef = ( /** @type {?} */(elDef.parent));
            }
            if (!elDef) {
                while (!elDef && elView) {
                    elDef = ( /** @type {?} */(viewParentEl(elView)));
                    elView = ( /** @type {?} */(elView.parent));
                }
            }
            this.elDef = elDef;
            this.elView = elView;
        }
        Object.defineProperty(DebugContext_.prototype, "elOrCompView", {
            /**
             * @private
             * @return {?}
             */
            get: function () {
                // Has to be done lazily as we use the DebugContext also during creation of elements...
                return asElementData(this.elView, this.elDef.nodeIndex).componentView || this.view;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DebugContext_.prototype, "injector", {
            /**
             * @return {?}
             */
            get: function () { return createInjector$1(this.elView, this.elDef); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DebugContext_.prototype, "component", {
            /**
             * @return {?}
             */
            get: function () { return this.elOrCompView.component; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DebugContext_.prototype, "context", {
            /**
             * @return {?}
             */
            get: function () { return this.elOrCompView.context; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DebugContext_.prototype, "providerTokens", {
            /**
             * @return {?}
             */
            get: function () {
                /** @type {?} */
                var tokens = [];
                if (this.elDef) {
                    for (var i_111 = this.elDef.nodeIndex + 1; i_111 <= this.elDef.nodeIndex + this.elDef.childCount; i_111++) {
                        /** @type {?} */
                        var childDef = this.elView.def.nodes[i_111];
                        if (childDef.flags & 20224 /* CatProvider */) {
                            tokens.push(( /** @type {?} */(childDef.provider)).token);
                        }
                        i_111 += childDef.childCount;
                    }
                }
                return tokens;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DebugContext_.prototype, "references", {
            /**
             * @return {?}
             */
            get: function () {
                /** @type {?} */
                var references = {};
                if (this.elDef) {
                    collectReferences(this.elView, this.elDef, references);
                    for (var i_112 = this.elDef.nodeIndex + 1; i_112 <= this.elDef.nodeIndex + this.elDef.childCount; i_112++) {
                        /** @type {?} */
                        var childDef = this.elView.def.nodes[i_112];
                        if (childDef.flags & 20224 /* CatProvider */) {
                            collectReferences(this.elView, childDef, references);
                        }
                        i_112 += childDef.childCount;
                    }
                }
                return references;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DebugContext_.prototype, "componentRenderElement", {
            /**
             * @return {?}
             */
            get: function () {
                /** @type {?} */
                var elData = findHostElement(this.elOrCompView);
                return elData ? elData.renderElement : undefined;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DebugContext_.prototype, "renderNode", {
            /**
             * @return {?}
             */
            get: function () {
                return this.nodeDef.flags & 2 /* TypeText */ ? renderNode(this.view, this.nodeDef) :
                    renderNode(this.elView, this.elDef);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} console
         * @param {...?} values
         * @return {?}
         */
        DebugContext_.prototype.logError = function (console) {
            var values = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                values[_i - 1] = arguments[_i];
            }
            /** @type {?} */
            var logViewDef;
            /** @type {?} */
            var logNodeIndex;
            if (this.nodeDef.flags & 2 /* TypeText */) {
                logViewDef = this.view.def;
                logNodeIndex = this.nodeDef.nodeIndex;
            }
            else {
                logViewDef = this.elView.def;
                logNodeIndex = this.elDef.nodeIndex;
            }
            // Note: we only generate a log function for text and element nodes
            // to make the generated code as small as possible.
            /** @type {?} */
            var renderNodeIndex = getRenderNodeIndex(logViewDef, logNodeIndex);
            /** @type {?} */
            var currRenderNodeIndex = -1;
            /** @type {?} */
            var nodeLogger = ( /**
             * @return {?}
             */function () {
                var _b;
                currRenderNodeIndex++;
                if (currRenderNodeIndex === renderNodeIndex) {
                    return (_b = console.error).bind.apply(_b, __spread([console], values));
                }
                else {
                    return NOOP;
                }
            });
            ( /** @type {?} */(logViewDef.factory))(nodeLogger);
            if (currRenderNodeIndex < renderNodeIndex) {
                console.error('Illegal state: the ViewDefinitionFactory did not call the logger!');
                console.error.apply(console, __spread(values));
            }
        };
        return DebugContext_;
    }());
    /**
     * @param {?} viewDef
     * @param {?} nodeIndex
     * @return {?}
     */
    function getRenderNodeIndex(viewDef, nodeIndex) {
        /** @type {?} */
        var renderNodeIndex = -1;
        for (var i_113 = 0; i_113 <= nodeIndex; i_113++) {
            /** @type {?} */
            var nodeDef = viewDef.nodes[i_113];
            if (nodeDef.flags & 3 /* CatRenderNode */) {
                renderNodeIndex++;
            }
        }
        return renderNodeIndex;
    }
    /**
     * @param {?} view
     * @return {?}
     */
    function findHostElement(view) {
        while (view && !isComponentView(view)) {
            view = ( /** @type {?} */(view.parent));
        }
        if (view.parent) {
            return asElementData(view.parent, ( /** @type {?} */(viewParentEl(view))).nodeIndex);
        }
        return null;
    }
    /**
     * @param {?} view
     * @param {?} nodeDef
     * @param {?} references
     * @return {?}
     */
    function collectReferences(view, nodeDef, references) {
        for (var refName in nodeDef.references) {
            references[refName] = getQueryValue(view, nodeDef, nodeDef.references[refName]);
        }
    }
    /**
     * @param {?} action
     * @param {?} fn
     * @param {?} self
     * @param {?} args
     * @return {?}
     */
    function callWithDebugContext(action, fn, self, args) {
        /** @type {?} */
        var oldAction = _currentAction;
        /** @type {?} */
        var oldView = _currentView;
        /** @type {?} */
        var oldNodeIndex = _currentNodeIndex;
        try {
            _currentAction = action;
            /** @type {?} */
            var result = fn.apply(self, args);
            _currentView = oldView;
            _currentNodeIndex = oldNodeIndex;
            _currentAction = oldAction;
            return result;
        }
        catch (e) {
            if (isViewDebugError(e) || !_currentView) {
                throw e;
            }
            throw viewWrappedDebugError(e, ( /** @type {?} */(getCurrentDebugContext())));
        }
    }
    /**
     * @return {?}
     */
    function getCurrentDebugContext() {
        return _currentView ? new DebugContext_(_currentView, _currentNodeIndex) : null;
    }
    var DebugRendererFactory2 = /** @class */ (function () {
        /**
         * @param {?} delegate
         */
        function DebugRendererFactory2(delegate) {
            this.delegate = delegate;
        }
        /**
         * @param {?} element
         * @param {?} renderData
         * @return {?}
         */
        DebugRendererFactory2.prototype.createRenderer = function (element, renderData) {
            return new DebugRenderer2(this.delegate.createRenderer(element, renderData));
        };
        /**
         * @return {?}
         */
        DebugRendererFactory2.prototype.begin = function () {
            if (this.delegate.begin) {
                this.delegate.begin();
            }
        };
        /**
         * @return {?}
         */
        DebugRendererFactory2.prototype.end = function () {
            if (this.delegate.end) {
                this.delegate.end();
            }
        };
        /**
         * @return {?}
         */
        DebugRendererFactory2.prototype.whenRenderingDone = function () {
            if (this.delegate.whenRenderingDone) {
                return this.delegate.whenRenderingDone();
            }
            return Promise.resolve(null);
        };
        return DebugRendererFactory2;
    }());
    var DebugRenderer2 = /** @class */ (function () {
        /**
         * @param {?} delegate
         */
        function DebugRenderer2(delegate) {
            this.delegate = delegate;
            /**
             * Factory function used to create a `DebugContext` when a node is created.
             *
             * The `DebugContext` allows to retrieve information about the nodes that are useful in tests.
             *
             * The factory is configurable so that the `DebugRenderer2` could instantiate either a View Engine
             * or a Render context.
             */
            this.debugContextFactory = getCurrentDebugContext;
            this.data = this.delegate.data;
        }
        /**
         * @private
         * @param {?} nativeElement
         * @return {?}
         */
        DebugRenderer2.prototype.createDebugContext = function (nativeElement) { return this.debugContextFactory(nativeElement); };
        /**
         * @param {?} node
         * @return {?}
         */
        DebugRenderer2.prototype.destroyNode = function (node) {
            /** @type {?} */
            var debugNode = ( /** @type {?} */(getDebugNode(node)));
            removeDebugNodeFromIndex(debugNode);
            if (debugNode instanceof DebugNode__PRE_R3__) {
                debugNode.listeners.length = 0;
            }
            if (this.delegate.destroyNode) {
                this.delegate.destroyNode(node);
            }
        };
        /**
         * @return {?}
         */
        DebugRenderer2.prototype.destroy = function () { this.delegate.destroy(); };
        /**
         * @param {?} name
         * @param {?=} namespace
         * @return {?}
         */
        DebugRenderer2.prototype.createElement = function (name, namespace) {
            /** @type {?} */
            var el = this.delegate.createElement(name, namespace);
            /** @type {?} */
            var debugCtx = this.createDebugContext(el);
            if (debugCtx) {
                /** @type {?} */
                var debugEl = new DebugElement__PRE_R3__(el, null, debugCtx);
                (( /** @type {?} */(debugEl))).name = name;
                indexDebugNode(debugEl);
            }
            return el;
        };
        /**
         * @param {?} value
         * @return {?}
         */
        DebugRenderer2.prototype.createComment = function (value) {
            /** @type {?} */
            var comment = this.delegate.createComment(value);
            /** @type {?} */
            var debugCtx = this.createDebugContext(comment);
            if (debugCtx) {
                indexDebugNode(new DebugNode__PRE_R3__(comment, null, debugCtx));
            }
            return comment;
        };
        /**
         * @param {?} value
         * @return {?}
         */
        DebugRenderer2.prototype.createText = function (value) {
            /** @type {?} */
            var text = this.delegate.createText(value);
            /** @type {?} */
            var debugCtx = this.createDebugContext(text);
            if (debugCtx) {
                indexDebugNode(new DebugNode__PRE_R3__(text, null, debugCtx));
            }
            return text;
        };
        /**
         * @param {?} parent
         * @param {?} newChild
         * @return {?}
         */
        DebugRenderer2.prototype.appendChild = function (parent, newChild) {
            /** @type {?} */
            var debugEl = getDebugNode(parent);
            /** @type {?} */
            var debugChildEl = getDebugNode(newChild);
            if (debugEl && debugChildEl && debugEl instanceof DebugElement__PRE_R3__) {
                debugEl.addChild(debugChildEl);
            }
            this.delegate.appendChild(parent, newChild);
        };
        /**
         * @param {?} parent
         * @param {?} newChild
         * @param {?} refChild
         * @return {?}
         */
        DebugRenderer2.prototype.insertBefore = function (parent, newChild, refChild) {
            /** @type {?} */
            var debugEl = getDebugNode(parent);
            /** @type {?} */
            var debugChildEl = getDebugNode(newChild);
            /** @type {?} */
            var debugRefEl = ( /** @type {?} */(getDebugNode(refChild)));
            if (debugEl && debugChildEl && debugEl instanceof DebugElement__PRE_R3__) {
                debugEl.insertBefore(debugRefEl, debugChildEl);
            }
            this.delegate.insertBefore(parent, newChild, refChild);
        };
        /**
         * @param {?} parent
         * @param {?} oldChild
         * @return {?}
         */
        DebugRenderer2.prototype.removeChild = function (parent, oldChild) {
            /** @type {?} */
            var debugEl = getDebugNode(parent);
            /** @type {?} */
            var debugChildEl = getDebugNode(oldChild);
            if (debugEl && debugChildEl && debugEl instanceof DebugElement__PRE_R3__) {
                debugEl.removeChild(debugChildEl);
            }
            this.delegate.removeChild(parent, oldChild);
        };
        /**
         * @param {?} selectorOrNode
         * @param {?=} preserveContent
         * @return {?}
         */
        DebugRenderer2.prototype.selectRootElement = function (selectorOrNode, preserveContent) {
            /** @type {?} */
            var el = this.delegate.selectRootElement(selectorOrNode, preserveContent);
            /** @type {?} */
            var debugCtx = getCurrentDebugContext();
            if (debugCtx) {
                indexDebugNode(new DebugElement__PRE_R3__(el, null, debugCtx));
            }
            return el;
        };
        /**
         * @param {?} el
         * @param {?} name
         * @param {?} value
         * @param {?=} namespace
         * @return {?}
         */
        DebugRenderer2.prototype.setAttribute = function (el, name, value, namespace) {
            /** @type {?} */
            var debugEl = getDebugNode(el);
            if (debugEl && debugEl instanceof DebugElement__PRE_R3__) {
                /** @type {?} */
                var fullName = namespace ? namespace + ':' + name : name;
                debugEl.attributes[fullName] = value;
            }
            this.delegate.setAttribute(el, name, value, namespace);
        };
        /**
         * @param {?} el
         * @param {?} name
         * @param {?=} namespace
         * @return {?}
         */
        DebugRenderer2.prototype.removeAttribute = function (el, name, namespace) {
            /** @type {?} */
            var debugEl = getDebugNode(el);
            if (debugEl && debugEl instanceof DebugElement__PRE_R3__) {
                /** @type {?} */
                var fullName = namespace ? namespace + ':' + name : name;
                debugEl.attributes[fullName] = null;
            }
            this.delegate.removeAttribute(el, name, namespace);
        };
        /**
         * @param {?} el
         * @param {?} name
         * @return {?}
         */
        DebugRenderer2.prototype.addClass = function (el, name) {
            /** @type {?} */
            var debugEl = getDebugNode(el);
            if (debugEl && debugEl instanceof DebugElement__PRE_R3__) {
                debugEl.classes[name] = true;
            }
            this.delegate.addClass(el, name);
        };
        /**
         * @param {?} el
         * @param {?} name
         * @return {?}
         */
        DebugRenderer2.prototype.removeClass = function (el, name) {
            /** @type {?} */
            var debugEl = getDebugNode(el);
            if (debugEl && debugEl instanceof DebugElement__PRE_R3__) {
                debugEl.classes[name] = false;
            }
            this.delegate.removeClass(el, name);
        };
        /**
         * @param {?} el
         * @param {?} style
         * @param {?} value
         * @param {?} flags
         * @return {?}
         */
        DebugRenderer2.prototype.setStyle = function (el, style, value, flags) {
            /** @type {?} */
            var debugEl = getDebugNode(el);
            if (debugEl && debugEl instanceof DebugElement__PRE_R3__) {
                debugEl.styles[style] = value;
            }
            this.delegate.setStyle(el, style, value, flags);
        };
        /**
         * @param {?} el
         * @param {?} style
         * @param {?} flags
         * @return {?}
         */
        DebugRenderer2.prototype.removeStyle = function (el, style, flags) {
            /** @type {?} */
            var debugEl = getDebugNode(el);
            if (debugEl && debugEl instanceof DebugElement__PRE_R3__) {
                debugEl.styles[style] = null;
            }
            this.delegate.removeStyle(el, style, flags);
        };
        /**
         * @param {?} el
         * @param {?} name
         * @param {?} value
         * @return {?}
         */
        DebugRenderer2.prototype.setProperty = function (el, name, value) {
            /** @type {?} */
            var debugEl = getDebugNode(el);
            if (debugEl && debugEl instanceof DebugElement__PRE_R3__) {
                debugEl.properties[name] = value;
            }
            this.delegate.setProperty(el, name, value);
        };
        /**
         * @param {?} target
         * @param {?} eventName
         * @param {?} callback
         * @return {?}
         */
        DebugRenderer2.prototype.listen = function (target, eventName, callback) {
            if (typeof target !== 'string') {
                /** @type {?} */
                var debugEl = getDebugNode(target);
                if (debugEl) {
                    debugEl.listeners.push(new DebugEventListener(eventName, callback));
                }
            }
            return this.delegate.listen(target, eventName, callback);
        };
        /**
         * @param {?} node
         * @return {?}
         */
        DebugRenderer2.prototype.parentNode = function (node) { return this.delegate.parentNode(node); };
        /**
         * @param {?} node
         * @return {?}
         */
        DebugRenderer2.prototype.nextSibling = function (node) { return this.delegate.nextSibling(node); };
        /**
         * @param {?} node
         * @param {?} value
         * @return {?}
         */
        DebugRenderer2.prototype.setValue = function (node, value) { return this.delegate.setValue(node, value); };
        return DebugRenderer2;
    }());
    // Attention: this function is called as top level function.
    // Putting any logic in here will destroy closure tree shaking!
    /**
     * @param {?} ngModuleType
     * @param {?} bootstrapComponents
     * @param {?} defFactory
     * @return {?}
     */
    function createNgModuleFactory(ngModuleType, bootstrapComponents, defFactory) {
        return new NgModuleFactory_(ngModuleType, bootstrapComponents, defFactory);
    }
    /**
     * @param {?} def
     * @return {?}
     */
    function cloneNgModuleDefinition(def) {
        /** @type {?} */
        var providers = Array.from(def.providers);
        /** @type {?} */
        var modules = Array.from(def.modules);
        /** @type {?} */
        var providersByKey = {};
        for (var key in def.providersByKey) {
            providersByKey[key] = def.providersByKey[key];
        }
        return {
            factory: def.factory,
            isRoot: def.isRoot, providers: providers, modules: modules, providersByKey: providersByKey,
        };
    }
    var NgModuleFactory_ = /** @class */ (function (_super) {
        __extends(NgModuleFactory_, _super);
        /**
         * @param {?} moduleType
         * @param {?} _bootstrapComponents
         * @param {?} _ngModuleDefFactory
         */
        function NgModuleFactory_(moduleType, _bootstrapComponents, _ngModuleDefFactory) {
            var _this = 
            // Attention: this ctor is called as top level function.
            // Putting any logic in here will destroy closure tree shaking!
            _super.call(this) || this;
            _this.moduleType = moduleType;
            _this._bootstrapComponents = _bootstrapComponents;
            _this._ngModuleDefFactory = _ngModuleDefFactory;
            return _this;
        }
        /**
         * @param {?} parentInjector
         * @return {?}
         */
        NgModuleFactory_.prototype.create = function (parentInjector) {
            initServicesIfNeeded();
            // Clone the NgModuleDefinition so that any tree shakeable provider definition
            // added to this instance of the NgModuleRef doesn't affect the cached copy.
            // See https://github.com/angular/angular/issues/25018.
            /** @type {?} */
            var def = cloneNgModuleDefinition(resolveDefinition(this._ngModuleDefFactory));
            return Services.createNgModuleRef(this.moduleType, parentInjector || Injector.NULL, this._bootstrapComponents, def);
        };
        return NgModuleFactory_;
    }(NgModuleFactory));
    /**
     * @license Angular v8.2.14
     * (c) 2010-2019 Google LLC. https://angular.io/
     * License: MIT
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * This class should not be used directly by an application developer. Instead, use
     * {\@link Location}.
     *
     * `PlatformLocation` encapsulates all calls to DOM apis, which allows the Router to be platform
     * agnostic.
     * This means that we can have different implementation of `PlatformLocation` for the different
     * platforms that angular supports. For example, `\@angular/platform-browser` provides an
     * implementation specific to the browser environment, while `\@angular/platform-webworker` provides
     * one suitable for use with web workers.
     *
     * The `PlatformLocation` class is used directly by all implementations of {\@link LocationStrategy}
     * when they need to interact with the DOM apis like pushState, popState, etc...
     *
     * {\@link LocationStrategy} in turn is used by the {\@link Location} service which is used directly
     * by the {\@link Router} in order to navigate between routes. Since all interactions between {\@link
     * Router} /
     * {\@link Location} / {\@link LocationStrategy} and DOM apis flow through the `PlatformLocation`
     * class they are all platform independent.
     *
     * \@publicApi
     * @abstract
     */
    var PlatformLocation = /** @class */ (function () {
        function PlatformLocation() {
        }
        return PlatformLocation;
    }());
    /**
     * \@description
     * Indicates when a location is initialized.
     *
     * \@publicApi
     * @type {?}
     */
    var LOCATION_INITIALIZED = new InjectionToken('Location Initialized');
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Enables the `Location` service to read route state from the browser's URL.
     * Angular provides two strategies:
     * `HashLocationStrategy` and `PathLocationStrategy`.
     *
     * Applications should use the `Router` or `Location` services to
     * interact with application route state.
     *
     * For instance, `HashLocationStrategy` produces URLs like
     * <code class="no-auto-link">http://example.com#/foo</code>,
     * and `PathLocationStrategy` produces
     * <code class="no-auto-link">http://example.com/foo</code> as an equivalent URL.
     *
     * See these two classes for more.
     *
     * \@publicApi
     * @abstract
     */
    var LocationStrategy = /** @class */ (function () {
        function LocationStrategy() {
        }
        return LocationStrategy;
    }());
    /**
     * A predefined [DI token](guide/glossary#di-token) for the base href
     * to be used with the `PathLocationStrategy`.
     * The base href is the URL prefix that should be preserved when generating
     * and recognizing URLs.
     *
     * \@usageNotes
     *
     * The following example shows how to use this token to configure the root app injector
     * with a base href value, so that the DI framework can supply the dependency anywhere in the app.
     *
     * ```typescript
     * import {Component, NgModule} from '\@angular/core';
     * import {APP_BASE_HREF} from '\@angular/common';
     *
     * \@NgModule({
     *   providers: [{provide: APP_BASE_HREF, useValue: '/my/app'}]
     * })
     * class AppModule {}
     * ```
     *
     * \@publicApi
     * @type {?}
     */
    var APP_BASE_HREF = new InjectionToken('appBaseHref');
    /**
     * \@description
     *
     * A service that applications can use to interact with a browser's URL.
     *
     * Depending on the `LocationStrategy` used, `Location` persists
     * to the URL's path or the URL's hash segment.
     *
     * \@usageNotes
     *
     * It's better to use the `Router#navigate` service to trigger route changes. Use
     * `Location` only if you need to interact with or create normalized URLs outside of
     * routing.
     *
     * `Location` is responsible for normalizing the URL against the application's base href.
     * A normalized URL is absolute from the URL host, includes the application's base href, and has no
     * trailing slash:
     * - `/my/app/user/123` is normalized
     * - `my/app/user/123` **is not** normalized
     * - `/my/app/user/123/` **is not** normalized
     *
     * ### Example
     *
     * <code-example path='common/location/ts/path_location_component.ts'
     * region='LocationComponent'></code-example>
     *
     * \@publicApi
     */
    var Location = /** @class */ (function () {
        /**
         * @param {?} platformStrategy
         * @param {?} platformLocation
         */
        function Location(platformStrategy, platformLocation) {
            var _this = this;
            /**
             * \@internal
             */
            this._subject = new EventEmitter();
            /**
             * \@internal
             */
            this._urlChangeListeners = [];
            this._platformStrategy = platformStrategy;
            /** @type {?} */
            var browserBaseHref = this._platformStrategy.getBaseHref();
            this._platformLocation = platformLocation;
            this._baseHref = Location.stripTrailingSlash(_stripIndexHtml(browserBaseHref));
            this._platformStrategy.onPopState(( /**
             * @param {?} ev
             * @return {?}
             */function (ev) {
                _this._subject.emit({
                    'url': _this.path(true),
                    'pop': true,
                    'state': ev.state,
                    'type': ev.type,
                });
            }));
        }
        /**
         * Normalizes the URL path for this location.
         *
         * @param {?=} includeHash True to include an anchor fragment in the path.
         *
         * @return {?} The normalized URL path.
         */
        // TODO: vsavkin. Remove the boolean flag and always include hash once the deprecated router is
        // removed.
        Location.prototype.path = function (includeHash) {
            if (includeHash === void 0) { includeHash = false; }
            return this.normalize(this._platformStrategy.path(includeHash));
        };
        /**
         * Reports the current state of the location history.
         * @return {?} The current value of the `history.state` object.
         */
        Location.prototype.getState = function () { return this._platformLocation.getState(); };
        /**
         * Normalizes the given path and compares to the current normalized path.
         *
         * @param {?} path The given URL path.
         * @param {?=} query Query parameters.
         *
         * @return {?} True if the given URL path is equal to the current normalized path, false
         * otherwise.
         */
        Location.prototype.isCurrentPathEqualTo = function (path, query) {
            if (query === void 0) { query = ''; }
            return this.path() == this.normalize(path + Location.normalizeQueryParams(query));
        };
        /**
         * Normalizes a URL path by stripping any trailing slashes.
         *
         * @param {?} url String representing a URL.
         *
         * @return {?} The normalized URL string.
         */
        Location.prototype.normalize = function (url) {
            return Location.stripTrailingSlash(_stripBaseHref(this._baseHref, _stripIndexHtml(url)));
        };
        /**
         * Normalizes an external URL path.
         * If the given URL doesn't begin with a leading slash (`'/'`), adds one
         * before normalizing. Adds a hash if `HashLocationStrategy` is
         * in use, or the `APP_BASE_HREF` if the `PathLocationStrategy` is in use.
         *
         * @param {?} url String representing a URL.
         *
         * @return {?} A normalized platform-specific URL.
         */
        Location.prototype.prepareExternalUrl = function (url) {
            if (url && url[0] !== '/') {
                url = '/' + url;
            }
            return this._platformStrategy.prepareExternalUrl(url);
        };
        // TODO: rename this method to pushState
        /**
         * Changes the browser's URL to a normalized version of a given URL, and pushes a
         * new item onto the platform's history.
         *
         * @param {?} path  URL path to normalize.
         * @param {?=} query Query parameters.
         * @param {?=} state Location history state.
         *
         * @return {?}
         */
        Location.prototype.go = function (path, query, state) {
            if (query === void 0) { query = ''; }
            if (state === void 0) { state = null; }
            this._platformStrategy.pushState(state, '', path, query);
            this._notifyUrlChangeListeners(this.prepareExternalUrl(path + Location.normalizeQueryParams(query)), state);
        };
        /**
         * Changes the browser's URL to a normalized version of the given URL, and replaces
         * the top item on the platform's history stack.
         *
         * @param {?} path  URL path to normalize.
         * @param {?=} query Query parameters.
         * @param {?=} state Location history state.
         * @return {?}
         */
        Location.prototype.replaceState = function (path, query, state) {
            if (query === void 0) { query = ''; }
            if (state === void 0) { state = null; }
            this._platformStrategy.replaceState(state, '', path, query);
            this._notifyUrlChangeListeners(this.prepareExternalUrl(path + Location.normalizeQueryParams(query)), state);
        };
        /**
         * Navigates forward in the platform's history.
         * @return {?}
         */
        Location.prototype.forward = function () { this._platformStrategy.forward(); };
        /**
         * Navigates back in the platform's history.
         * @return {?}
         */
        Location.prototype.back = function () { this._platformStrategy.back(); };
        /**
         * Registers a URL change listener. Use to catch updates performed by the Angular
         * framework that are not detectible through "popstate" or "hashchange" events.
         *
         * @param {?} fn The change handler function, which take a URL and a location history state.
         * @return {?}
         */
        Location.prototype.onUrlChange = function (fn) {
            var _this = this;
            this._urlChangeListeners.push(fn);
            this.subscribe(( /**
             * @param {?} v
             * @return {?}
             */function (/**
             * @param {?} v
             * @return {?}
             */ v) { _this._notifyUrlChangeListeners(v.url, v.state); }));
        };
        /**
         * \@internal
         * @param {?=} url
         * @param {?=} state
         * @return {?}
         */
        Location.prototype._notifyUrlChangeListeners = function (url, state) {
            if (url === void 0) { url = ''; }
            this._urlChangeListeners.forEach(( /**
             * @param {?} fn
             * @return {?}
             */function (/**
             * @param {?} fn
             * @return {?}
             */ fn) { return fn(url, state); }));
        };
        /**
         * Subscribes to the platform's `popState` events.
         *
         * @param {?} onNext
         * @param {?=} onThrow
         * @param {?=} onReturn
         * @return {?} Subscribed events.
         */
        Location.prototype.subscribe = function (onNext, onThrow, onReturn) {
            return this._subject.subscribe({ next: onNext, error: onThrow, complete: onReturn });
        };
        /**
         * Normalizes URL parameters by prepending with `?` if needed.
         *
         * @param {?} params String of URL parameters.
         *
         * @return {?} The normalized URL parameters string.
         */
        Location.normalizeQueryParams = function (params) {
            return params && params[0] !== '?' ? '?' + params : params;
        };
        /**
         * Joins two parts of a URL with a slash if needed.
         *
         * @param {?} start  URL string
         * @param {?} end    URL string
         *
         *
         * @return {?} The joined URL string.
         */
        Location.joinWithSlash = function (start, end) {
            if (start.length == 0) {
                return end;
            }
            if (end.length == 0) {
                return start;
            }
            /** @type {?} */
            var slashes = 0;
            if (start.endsWith('/')) {
                slashes++;
            }
            if (end.startsWith('/')) {
                slashes++;
            }
            if (slashes == 2) {
                return start + end.substring(1);
            }
            if (slashes == 1) {
                return start + end;
            }
            return start + '/' + end;
        };
        /**
         * Removes a trailing slash from a URL string if needed.
         * Looks for the first occurrence of either `#`, `?`, or the end of the
         * line as `/` characters and removes the trailing slash if one exists.
         *
         * @param {?} url URL string.
         *
         * @return {?} The URL string, modified if needed.
         */
        Location.stripTrailingSlash = function (url) {
            /** @type {?} */
            var match = url.match(/#|\?|$/);
            /** @type {?} */
            var pathEndIdx = match && match.index || url.length;
            /** @type {?} */
            var droppedSlashIdx = pathEndIdx - (url[pathEndIdx - 1] === '/' ? 1 : 0);
            return url.slice(0, droppedSlashIdx) + url.slice(pathEndIdx);
        };
        return Location;
    }());
    Location.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    Location.ctorParameters = function () { return [
        { type: LocationStrategy },
        { type: PlatformLocation }
    ]; };
    /**
     * @param {?} baseHref
     * @param {?} url
     * @return {?}
     */
    function _stripBaseHref(baseHref, url) {
        return baseHref && url.startsWith(baseHref) ? url.substring(baseHref.length) : url;
    }
    /**
     * @param {?} url
     * @return {?}
     */
    function _stripIndexHtml(url) {
        return url.replace(/\/index.html$/, '');
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@description
     * A {\@link LocationStrategy} used to configure the {\@link Location} service to
     * represent its state in the
     * [hash fragment](https://en.wikipedia.org/wiki/Uniform_Resource_Locator#Syntax)
     * of the browser's URL.
     *
     * For instance, if you call `location.go('/foo')`, the browser's URL will become
     * `example.com#/foo`.
     *
     * \@usageNotes
     *
     * ### Example
     *
     * {\@example common/location/ts/hash_location_component.ts region='LocationComponent'}
     *
     * \@publicApi
     */
    var HashLocationStrategy = /** @class */ (function (_super) {
        __extends(HashLocationStrategy, _super);
        /**
         * @param {?} _platformLocation
         * @param {?=} _baseHref
         */
        function HashLocationStrategy(_platformLocation, _baseHref) {
            var _this = _super.call(this) || this;
            _this._platformLocation = _platformLocation;
            _this._baseHref = '';
            if (_baseHref != null) {
                _this._baseHref = _baseHref;
            }
            return _this;
        }
        /**
         * @param {?} fn
         * @return {?}
         */
        HashLocationStrategy.prototype.onPopState = function (fn) {
            this._platformLocation.onPopState(fn);
            this._platformLocation.onHashChange(fn);
        };
        /**
         * @return {?}
         */
        HashLocationStrategy.prototype.getBaseHref = function () { return this._baseHref; };
        /**
         * @param {?=} includeHash
         * @return {?}
         */
        HashLocationStrategy.prototype.path = function (includeHash) {
            if (includeHash === void 0) { includeHash = false; }
            // the hash value is always prefixed with a `#`
            // and if it is empty then it will stay empty
            /** @type {?} */
            var path = this._platformLocation.hash;
            if (path == null)
                path = '#';
            return path.length > 0 ? path.substring(1) : path;
        };
        /**
         * @param {?} internal
         * @return {?}
         */
        HashLocationStrategy.prototype.prepareExternalUrl = function (internal) {
            /** @type {?} */
            var url = Location.joinWithSlash(this._baseHref, internal);
            return url.length > 0 ? ('#' + url) : url;
        };
        /**
         * @param {?} state
         * @param {?} title
         * @param {?} path
         * @param {?} queryParams
         * @return {?}
         */
        HashLocationStrategy.prototype.pushState = function (state, title, path, queryParams) {
            /** @type {?} */
            var url = this.prepareExternalUrl(path + Location.normalizeQueryParams(queryParams));
            if (url.length == 0) {
                url = this._platformLocation.pathname;
            }
            this._platformLocation.pushState(state, title, url);
        };
        /**
         * @param {?} state
         * @param {?} title
         * @param {?} path
         * @param {?} queryParams
         * @return {?}
         */
        HashLocationStrategy.prototype.replaceState = function (state, title, path, queryParams) {
            /** @type {?} */
            var url = this.prepareExternalUrl(path + Location.normalizeQueryParams(queryParams));
            if (url.length == 0) {
                url = this._platformLocation.pathname;
            }
            this._platformLocation.replaceState(state, title, url);
        };
        /**
         * @return {?}
         */
        HashLocationStrategy.prototype.forward = function () { this._platformLocation.forward(); };
        /**
         * @return {?}
         */
        HashLocationStrategy.prototype.back = function () { this._platformLocation.back(); };
        return HashLocationStrategy;
    }(LocationStrategy));
    HashLocationStrategy.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    HashLocationStrategy.ctorParameters = function () { return [
        { type: PlatformLocation },
        { type: String, decorators: [{ type: Optional }, { type: Inject, args: [APP_BASE_HREF,] }] }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@description
     * A {\@link LocationStrategy} used to configure the {\@link Location} service to
     * represent its state in the
     * [path](https://en.wikipedia.org/wiki/Uniform_Resource_Locator#Syntax) of the
     * browser's URL.
     *
     * If you're using `PathLocationStrategy`, you must provide a {\@link APP_BASE_HREF}
     * or add a base element to the document. This URL prefix that will be preserved
     * when generating and recognizing URLs.
     *
     * For instance, if you provide an `APP_BASE_HREF` of `'/my/app'` and call
     * `location.go('/foo')`, the browser's URL will become
     * `example.com/my/app/foo`.
     *
     * Similarly, if you add `<base href='/my/app'/>` to the document and call
     * `location.go('/foo')`, the browser's URL will become
     * `example.com/my/app/foo`.
     *
     * \@usageNotes
     *
     * ### Example
     *
     * {\@example common/location/ts/path_location_component.ts region='LocationComponent'}
     *
     * \@publicApi
     */
    var PathLocationStrategy = /** @class */ (function (_super) {
        __extends(PathLocationStrategy, _super);
        /**
         * @param {?} _platformLocation
         * @param {?=} href
         */
        function PathLocationStrategy(_platformLocation, href) {
            var _this = _super.call(this) || this;
            _this._platformLocation = _platformLocation;
            if (href == null) {
                href = _this._platformLocation.getBaseHrefFromDOM();
            }
            if (href == null) {
                throw new Error("No base href set. Please provide a value for the APP_BASE_HREF token or add a base element to the document.");
            }
            _this._baseHref = href;
            return _this;
        }
        /**
         * @param {?} fn
         * @return {?}
         */
        PathLocationStrategy.prototype.onPopState = function (fn) {
            this._platformLocation.onPopState(fn);
            this._platformLocation.onHashChange(fn);
        };
        /**
         * @return {?}
         */
        PathLocationStrategy.prototype.getBaseHref = function () { return this._baseHref; };
        /**
         * @param {?} internal
         * @return {?}
         */
        PathLocationStrategy.prototype.prepareExternalUrl = function (internal) {
            return Location.joinWithSlash(this._baseHref, internal);
        };
        /**
         * @param {?=} includeHash
         * @return {?}
         */
        PathLocationStrategy.prototype.path = function (includeHash) {
            if (includeHash === void 0) { includeHash = false; }
            /** @type {?} */
            var pathname = this._platformLocation.pathname +
                Location.normalizeQueryParams(this._platformLocation.search);
            /** @type {?} */
            var hash = this._platformLocation.hash;
            return hash && includeHash ? "" + pathname + hash : pathname;
        };
        /**
         * @param {?} state
         * @param {?} title
         * @param {?} url
         * @param {?} queryParams
         * @return {?}
         */
        PathLocationStrategy.prototype.pushState = function (state, title, url, queryParams) {
            /** @type {?} */
            var externalUrl = this.prepareExternalUrl(url + Location.normalizeQueryParams(queryParams));
            this._platformLocation.pushState(state, title, externalUrl);
        };
        /**
         * @param {?} state
         * @param {?} title
         * @param {?} url
         * @param {?} queryParams
         * @return {?}
         */
        PathLocationStrategy.prototype.replaceState = function (state, title, url, queryParams) {
            /** @type {?} */
            var externalUrl = this.prepareExternalUrl(url + Location.normalizeQueryParams(queryParams));
            this._platformLocation.replaceState(state, title, externalUrl);
        };
        /**
         * @return {?}
         */
        PathLocationStrategy.prototype.forward = function () { this._platformLocation.forward(); };
        /**
         * @return {?}
         */
        PathLocationStrategy.prototype.back = function () { this._platformLocation.back(); };
        return PathLocationStrategy;
    }(LocationStrategy));
    PathLocationStrategy.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    PathLocationStrategy.ctorParameters = function () { return [
        { type: PlatformLocation },
        { type: String, decorators: [{ type: Optional }, { type: Inject, args: [APP_BASE_HREF,] }] }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    // THIS CODE IS GENERATED - DO NOT MODIFY
    // See angular/tools/gulp-tasks/cldr/extract.js
    /**
     * \@internal
     * @type {?}
     */
    var CURRENCIES_EN = {
        'ADP': [undefined, undefined, 0],
        'AFN': [undefined, undefined, 0],
        'ALL': [undefined, undefined, 0],
        'AMD': [undefined, undefined, 0],
        'AOA': [undefined, 'Kz'],
        'ARS': [undefined, '$'],
        'AUD': ['A$', '$'],
        'BAM': [undefined, 'KM'],
        'BBD': [undefined, '$'],
        'BDT': [undefined, '৳'],
        'BHD': [undefined, undefined, 3],
        'BIF': [undefined, undefined, 0],
        'BMD': [undefined, '$'],
        'BND': [undefined, '$'],
        'BOB': [undefined, 'Bs'],
        'BRL': ['R$'],
        'BSD': [undefined, '$'],
        'BWP': [undefined, 'P'],
        'BYN': [undefined, 'р.', 2],
        'BYR': [undefined, undefined, 0],
        'BZD': [undefined, '$'],
        'CAD': ['CA$', '$', 2],
        'CHF': [undefined, undefined, 2],
        'CLF': [undefined, undefined, 4],
        'CLP': [undefined, '$', 0],
        'CNY': ['CN¥', '¥'],
        'COP': [undefined, '$', 0],
        'CRC': [undefined, '₡', 2],
        'CUC': [undefined, '$'],
        'CUP': [undefined, '$'],
        'CZK': [undefined, 'Kč', 2],
        'DJF': [undefined, undefined, 0],
        'DKK': [undefined, 'kr', 2],
        'DOP': [undefined, '$'],
        'EGP': [undefined, 'E£'],
        'ESP': [undefined, '₧', 0],
        'EUR': ['€'],
        'FJD': [undefined, '$'],
        'FKP': [undefined, '£'],
        'GBP': ['£'],
        'GEL': [undefined, '₾'],
        'GIP': [undefined, '£'],
        'GNF': [undefined, 'FG', 0],
        'GTQ': [undefined, 'Q'],
        'GYD': [undefined, '$', 0],
        'HKD': ['HK$', '$'],
        'HNL': [undefined, 'L'],
        'HRK': [undefined, 'kn'],
        'HUF': [undefined, 'Ft', 2],
        'IDR': [undefined, 'Rp', 0],
        'ILS': ['₪'],
        'INR': ['₹'],
        'IQD': [undefined, undefined, 0],
        'IRR': [undefined, undefined, 0],
        'ISK': [undefined, 'kr', 0],
        'ITL': [undefined, undefined, 0],
        'JMD': [undefined, '$'],
        'JOD': [undefined, undefined, 3],
        'JPY': ['¥', undefined, 0],
        'KHR': [undefined, '៛'],
        'KMF': [undefined, 'CF', 0],
        'KPW': [undefined, '₩', 0],
        'KRW': ['₩', undefined, 0],
        'KWD': [undefined, undefined, 3],
        'KYD': [undefined, '$'],
        'KZT': [undefined, '₸'],
        'LAK': [undefined, '₭', 0],
        'LBP': [undefined, 'L£', 0],
        'LKR': [undefined, 'Rs'],
        'LRD': [undefined, '$'],
        'LTL': [undefined, 'Lt'],
        'LUF': [undefined, undefined, 0],
        'LVL': [undefined, 'Ls'],
        'LYD': [undefined, undefined, 3],
        'MGA': [undefined, 'Ar', 0],
        'MGF': [undefined, undefined, 0],
        'MMK': [undefined, 'K', 0],
        'MNT': [undefined, '₮', 0],
        'MRO': [undefined, undefined, 0],
        'MUR': [undefined, 'Rs', 0],
        'MXN': ['MX$', '$'],
        'MYR': [undefined, 'RM'],
        'NAD': [undefined, '$'],
        'NGN': [undefined, '₦'],
        'NIO': [undefined, 'C$'],
        'NOK': [undefined, 'kr', 2],
        'NPR': [undefined, 'Rs'],
        'NZD': ['NZ$', '$'],
        'OMR': [undefined, undefined, 3],
        'PHP': [undefined, '₱'],
        'PKR': [undefined, 'Rs', 0],
        'PLN': [undefined, 'zł'],
        'PYG': [undefined, '₲', 0],
        'RON': [undefined, 'lei'],
        'RSD': [undefined, undefined, 0],
        'RUB': [undefined, '₽'],
        'RUR': [undefined, 'р.'],
        'RWF': [undefined, 'RF', 0],
        'SBD': [undefined, '$'],
        'SEK': [undefined, 'kr', 2],
        'SGD': [undefined, '$'],
        'SHP': [undefined, '£'],
        'SLL': [undefined, undefined, 0],
        'SOS': [undefined, undefined, 0],
        'SRD': [undefined, '$'],
        'SSP': [undefined, '£'],
        'STD': [undefined, undefined, 0],
        'STN': [undefined, 'Db'],
        'SYP': [undefined, '£', 0],
        'THB': [undefined, '฿'],
        'TMM': [undefined, undefined, 0],
        'TND': [undefined, undefined, 3],
        'TOP': [undefined, 'T$'],
        'TRL': [undefined, undefined, 0],
        'TRY': [undefined, '₺'],
        'TTD': [undefined, '$'],
        'TWD': ['NT$', '$', 2],
        'TZS': [undefined, undefined, 0],
        'UAH': [undefined, '₴'],
        'UGX': [undefined, undefined, 0],
        'USD': ['$'],
        'UYI': [undefined, undefined, 0],
        'UYU': [undefined, '$'],
        'UZS': [undefined, undefined, 0],
        'VEF': [undefined, 'Bs'],
        'VND': ['₫', undefined, 0],
        'VUV': [undefined, undefined, 0],
        'XAF': ['FCFA', undefined, 0],
        'XCD': ['EC$', '$'],
        'XOF': ['CFA', undefined, 0],
        'XPF': ['CFPF', undefined, 0],
        'YER': [undefined, undefined, 0],
        'ZAR': [undefined, 'R'],
        'ZMK': [undefined, undefined, 0],
        'ZMW': [undefined, 'ZK'],
        'ZWD': [undefined, undefined, 0]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var NumberFormatStyle = {
        Decimal: 0,
        Percent: 1,
        Currency: 2,
        Scientific: 3,
    };
    NumberFormatStyle[NumberFormatStyle.Decimal] = 'Decimal';
    NumberFormatStyle[NumberFormatStyle.Percent] = 'Percent';
    NumberFormatStyle[NumberFormatStyle.Currency] = 'Currency';
    NumberFormatStyle[NumberFormatStyle.Scientific] = 'Scientific';
    /** @enum {number} */
    var Plural = {
        Zero: 0,
        One: 1,
        Two: 2,
        Few: 3,
        Many: 4,
        Other: 5,
    };
    Plural[Plural.Zero] = 'Zero';
    Plural[Plural.One] = 'One';
    Plural[Plural.Two] = 'Two';
    Plural[Plural.Few] = 'Few';
    Plural[Plural.Many] = 'Many';
    Plural[Plural.Other] = 'Other';
    /** @enum {number} */
    var FormStyle = {
        Format: 0,
        Standalone: 1,
    };
    FormStyle[FormStyle.Format] = 'Format';
    FormStyle[FormStyle.Standalone] = 'Standalone';
    /** @enum {number} */
    var TranslationWidth = {
        /** 1 character for `en-US`. For example: 'S' */
        Narrow: 0,
        /** 3 characters for `en-US`. For example: 'Sun' */
        Abbreviated: 1,
        /** Full length for `en-US`. For example: "Sunday" */
        Wide: 2,
        /** 2 characters for `en-US`, For example: "Su" */
        Short: 3,
    };
    TranslationWidth[TranslationWidth.Narrow] = 'Narrow';
    TranslationWidth[TranslationWidth.Abbreviated] = 'Abbreviated';
    TranslationWidth[TranslationWidth.Wide] = 'Wide';
    TranslationWidth[TranslationWidth.Short] = 'Short';
    /** @enum {number} */
    var FormatWidth = {
        /**
         * For `en-US`, 'M/d/yy, h:mm a'`
         * (Example: `6/15/15, 9:03 AM`)
         */
        Short: 0,
        /**
         * For `en-US`, `'MMM d, y, h:mm:ss a'`
         * (Example: `Jun 15, 2015, 9:03:01 AM`)
         */
        Medium: 1,
        /**
         * For `en-US`, `'MMMM d, y, h:mm:ss a z'`
         * (Example: `June 15, 2015 at 9:03:01 AM GMT+1`)
         */
        Long: 2,
        /**
         * For `en-US`, `'EEEE, MMMM d, y, h:mm:ss a zzzz'`
         * (Example: `Monday, June 15, 2015 at 9:03:01 AM GMT+01:00`)
         */
        Full: 3,
    };
    FormatWidth[FormatWidth.Short] = 'Short';
    FormatWidth[FormatWidth.Medium] = 'Medium';
    FormatWidth[FormatWidth.Long] = 'Long';
    FormatWidth[FormatWidth.Full] = 'Full';
    /** @enum {number} */
    var NumberSymbol = {
        /**
         * Decimal separator.
         * For `en-US`, the dot character.
         * Example : 2,345`.`67
         */
        Decimal: 0,
        /**
         * Grouping separator, typically for thousands.
         * For `en-US`, the comma character.
         * Example: 2`,`345.67
         */
        Group: 1,
        /**
         * List-item separator.
         * Example: "one, two, and three"
         */
        List: 2,
        /**
         * Sign for percentage (out of 100).
         * Example: 23.4%
         */
        PercentSign: 3,
        /**
         * Sign for positive numbers.
         * Example: +23
         */
        PlusSign: 4,
        /**
         * Sign for negative numbers.
         * Example: -23
         */
        MinusSign: 5,
        /**
         * Computer notation for exponential value (n times a power of 10).
         * Example: 1.2E3
         */
        Exponential: 6,
        /**
         * Human-readable format of exponential.
         * Example: 1.2x103
         */
        SuperscriptingExponent: 7,
        /**
         * Sign for permille (out of 1000).
         * Example: 23.4‰
         */
        PerMille: 8,
        /**
         * Infinity, can be used with plus and minus.
         * Example: ∞, +∞, -∞
         */
        Infinity: 9,
        /**
         * Not a number.
         * Example: NaN
         */
        NaN: 10,
        /**
         * Symbol used between time units.
         * Example: 10:52
         */
        TimeSeparator: 11,
        /**
         * Decimal separator for currency values (fallback to `Decimal`).
         * Example: $2,345.67
         */
        CurrencyDecimal: 12,
        /**
         * Group separator for currency values (fallback to `Group`).
         * Example: $2,345.67
         */
        CurrencyGroup: 13,
    };
    NumberSymbol[NumberSymbol.Decimal] = 'Decimal';
    NumberSymbol[NumberSymbol.Group] = 'Group';
    NumberSymbol[NumberSymbol.List] = 'List';
    NumberSymbol[NumberSymbol.PercentSign] = 'PercentSign';
    NumberSymbol[NumberSymbol.PlusSign] = 'PlusSign';
    NumberSymbol[NumberSymbol.MinusSign] = 'MinusSign';
    NumberSymbol[NumberSymbol.Exponential] = 'Exponential';
    NumberSymbol[NumberSymbol.SuperscriptingExponent] = 'SuperscriptingExponent';
    NumberSymbol[NumberSymbol.PerMille] = 'PerMille';
    NumberSymbol[NumberSymbol.Infinity] = 'Infinity';
    NumberSymbol[NumberSymbol.NaN] = 'NaN';
    NumberSymbol[NumberSymbol.TimeSeparator] = 'TimeSeparator';
    NumberSymbol[NumberSymbol.CurrencyDecimal] = 'CurrencyDecimal';
    NumberSymbol[NumberSymbol.CurrencyGroup] = 'CurrencyGroup';
    /**
     * Retrieves the locale ID from the currently loaded locale.
     * The loaded locale could be, for example, a global one rather than a regional one.
     * @see [Internationalization (i18n) Guide](https://angular.io/guide/i18n)
     *
     * \@publicApi
     * @param {?} locale A locale code, such as `fr-FR`.
     * @return {?} The locale code. For example, `fr`.
     */
    function getLocaleId(locale) {
        return findLocaleData(locale)[LocaleDataIndex.LocaleId];
    }
    /**
     * Retrieves day period strings for the given locale.
     *
     * @see [Internationalization (i18n) Guide](https://angular.io/guide/i18n)
     *
     * \@publicApi
     * @param {?} locale A locale code for the locale format rules to use.
     * @param {?} formStyle The required grammatical form.
     * @param {?} width The required character width.
     * @return {?} An array of localized period strings. For example, `[AM, PM]` for `en-US`.
     */
    function getLocaleDayPeriods(locale, formStyle, width) {
        /** @type {?} */
        var data = findLocaleData(locale);
        /** @type {?} */
        var amPmData = ( /** @type {?} */([data[LocaleDataIndex.DayPeriodsFormat], data[LocaleDataIndex.DayPeriodsStandalone]]));
        /** @type {?} */
        var amPm = getLastDefinedValue(amPmData, formStyle);
        return getLastDefinedValue(amPm, width);
    }
    /**
     * Retrieves days of the week for the given locale, using the Gregorian calendar.
     *
     * @see [Internationalization (i18n) Guide](https://angular.io/guide/i18n)
     *
     * \@publicApi
     * @param {?} locale A locale code for the locale format rules to use.
     * @param {?} formStyle The required grammatical form.
     * @param {?} width The required character width.
     * @return {?} An array of localized name strings.
     * For example,`[Sunday, Monday, ... Saturday]` for `en-US`.
     */
    function getLocaleDayNames(locale, formStyle, width) {
        /** @type {?} */
        var data = findLocaleData(locale);
        /** @type {?} */
        var daysData = ( /** @type {?} */([data[LocaleDataIndex.DaysFormat], data[LocaleDataIndex.DaysStandalone]]));
        /** @type {?} */
        var days = getLastDefinedValue(daysData, formStyle);
        return getLastDefinedValue(days, width);
    }
    /**
     * Retrieves months of the year for the given locale, using the Gregorian calendar.
     *
     * @see [Internationalization (i18n) Guide](https://angular.io/guide/i18n)
     *
     * \@publicApi
     * @param {?} locale A locale code for the locale format rules to use.
     * @param {?} formStyle The required grammatical form.
     * @param {?} width The required character width.
     * @return {?} An array of localized name strings.
     * For example,  `[January, February, ...]` for `en-US`.
     */
    function getLocaleMonthNames(locale, formStyle, width) {
        /** @type {?} */
        var data = findLocaleData(locale);
        /** @type {?} */
        var monthsData = ( /** @type {?} */([data[LocaleDataIndex.MonthsFormat], data[LocaleDataIndex.MonthsStandalone]]));
        /** @type {?} */
        var months = getLastDefinedValue(monthsData, formStyle);
        return getLastDefinedValue(months, width);
    }
    /**
     * Retrieves Gregorian-calendar eras for the given locale.
     * @see [Internationalization (i18n) Guide](https://angular.io/guide/i18n)
     *
     * \@publicApi
     * @param {?} locale A locale code for the locale format rules to use.
     * @param {?} width The required character width.
     * @return {?} An array of localized era strings.
     * For example, `[AD, BC]` for `en-US`.
     */
    function getLocaleEraNames(locale, width) {
        /** @type {?} */
        var data = findLocaleData(locale);
        /** @type {?} */
        var erasData = ( /** @type {?} */(data[LocaleDataIndex.Eras]));
        return getLastDefinedValue(erasData, width);
    }
    /**
     * Retrieves a localized date-value formating string.
     *
     * @see `FormatWidth` / [Internationalization (i18n) Guide](https://angular.io/guide/i18n)
     *
     * \@publicApi
     * @param {?} locale A locale code for the locale format rules to use.
     * @param {?} width The format type.
     * @return {?} The localized formating string.
     */
    function getLocaleDateFormat(locale, width) {
        /** @type {?} */
        var data = findLocaleData(locale);
        return getLastDefinedValue(data[LocaleDataIndex.DateFormat], width);
    }
    /**
     * Retrieves a localized time-value formatting string.
     *
     * @see `FormatWidth` / [Internationalization (i18n) Guide](https://angular.io/guide/i18n)
     * \@publicApi
     * @param {?} locale A locale code for the locale format rules to use.
     * @param {?} width The format type.
     * @return {?} The localized formatting string.
     */
    function getLocaleTimeFormat(locale, width) {
        /** @type {?} */
        var data = findLocaleData(locale);
        return getLastDefinedValue(data[LocaleDataIndex.TimeFormat], width);
    }
    /**
     * Retrieves a localized date-time formatting string.
     *
     * @see `FormatWidth` / [Internationalization (i18n) Guide](https://angular.io/guide/i18n)
     *
     * \@publicApi
     * @param {?} locale A locale code for the locale format rules to use.
     * @param {?} width The format type.
     * @return {?} The localized formatting string.
     */
    function getLocaleDateTimeFormat(locale, width) {
        /** @type {?} */
        var data = findLocaleData(locale);
        /** @type {?} */
        var dateTimeFormatData = ( /** @type {?} */(data[LocaleDataIndex.DateTimeFormat]));
        return getLastDefinedValue(dateTimeFormatData, width);
    }
    /**
     * Retrieves a localized number symbol that can be used to replace placeholders in number formats.
     * @see `NumberSymbol` / [Internationalization (i18n) Guide](https://angular.io/guide/i18n)
     *
     * \@publicApi
     * @param {?} locale The locale code.
     * @param {?} symbol The symbol to localize.
     * @return {?} The character for the localized symbol.
     */
    function getLocaleNumberSymbol(locale, symbol) {
        /** @type {?} */
        var data = findLocaleData(locale);
        /** @type {?} */
        var res = data[LocaleDataIndex.NumberSymbols][symbol];
        if (typeof res === 'undefined') {
            if (symbol === NumberSymbol.CurrencyDecimal) {
                return data[LocaleDataIndex.NumberSymbols][NumberSymbol.Decimal];
            }
            else if (symbol === NumberSymbol.CurrencyGroup) {
                return data[LocaleDataIndex.NumberSymbols][NumberSymbol.Group];
            }
        }
        return res;
    }
    /**
     * Retrieves a number format for a given locale.
     *
     * Numbers are formatted using patterns, like `#,###.00`. For example, the pattern `#,###.00`
     * when used to format the number 12345.678 could result in "12'345,678". That would happen if the
     * grouping separator for your language is an apostrophe, and the decimal separator is a comma.
     *
     * <b>Important:</b> The characters `.` `,` `0` `#` (and others below) are special placeholders
     * that stand for the decimal separator, and so on, and are NOT real characters.
     * You must NOT "translate" the placeholders. For example, don't change `.` to `,` even though in
     * your language the decimal point is written with a comma. The symbols should be replaced by the
     * local equivalents, using the appropriate `NumberSymbol` for your language.
     *
     * Here are the special characters used in number patterns:
     *
     * | Symbol | Meaning |
     * |--------|---------|
     * | . | Replaced automatically by the character used for the decimal point. |
     * | , | Replaced by the "grouping" (thousands) separator. |
     * | 0 | Replaced by a digit (or zero if there aren't enough digits). |
     * | # | Replaced by a digit (or nothing if there aren't enough). |
     * | ¤ | Replaced by a currency symbol, such as $ or USD. |
     * | % | Marks a percent format. The % symbol may change position, but must be retained. |
     * | E | Marks a scientific format. The E symbol may change position, but must be retained. |
     * | ' | Special characters used as literal characters are quoted with ASCII single quotes. |
     *
     * @see `NumberFormatStyle` / [CLDR website](http://cldr.unicode.org/translation/number-patterns) / [Internationalization (i18n) Guide](https://angular.io/guide/i18n)
     *
     * \@publicApi
     * @param {?} locale A locale code for the locale format rules to use.
     * @param {?} type The type of numeric value to be formatted (such as `Decimal` or `Currency`.)
     * @return {?} The localized format string.
     */
    function getLocaleNumberFormat(locale, type) {
        /** @type {?} */
        var data = findLocaleData(locale);
        return data[LocaleDataIndex.NumberFormats][type];
    }
    /**
     * Retrieves the currency values for a given locale.
     * @see [Internationalization (i18n) Guide](https://angular.io/guide/i18n)
     * @param {?} locale A locale code for the locale format rules to use.
     * @return {?} The currency values.
     */
    function getLocaleCurrencies(locale) {
        /** @type {?} */
        var data = findLocaleData(locale);
        return data[LocaleDataIndex.Currencies];
    }
    /**
     * \@alias core/ɵgetLocalePluralCase
     * \@publicApi
     * @type {?}
     */
    var getLocalePluralCase$1 = getLocalePluralCase;
    /**
     * @param {?} data
     * @return {?}
     */
    function checkFullData(data) {
        if (!data[LocaleDataIndex.ExtraData]) {
            throw new Error("Missing extra locale data for the locale \"" + data[LocaleDataIndex.LocaleId] + "\". Use \"registerLocaleData\" to load new data. See the \"I18n guide\" on angular.io to know more.");
        }
    }
    /**
     * Retrieves locale-specific rules used to determine which day period to use
     * when more than one period is defined for a locale.
     *
     * There is a rule for each defined day period. The
     * first rule is applied to the first day period and so on.
     * Fall back to AM/PM when no rules are available.
     *
     * A rule can specify a period as time range, or as a single time value.
     *
     * This functionality is only available when you have loaded the full locale data.
     * See the ["I18n guide"](guide/i18n#i18n-pipes).
     *
     * @see `getLocaleExtraDayPeriods()` / [Internationalization (i18n) Guide](https://angular.io/guide/i18n)
     *
     * \@publicApi
     * @param {?} locale A locale code for the locale format rules to use.
     * @return {?} The rules for the locale, a single time value or array of *from-time, to-time*,
     * or null if no periods are available.
     *
     */
    function getLocaleExtraDayPeriodRules(locale) {
        /** @type {?} */
        var data = findLocaleData(locale);
        checkFullData(data);
        /** @type {?} */
        var rules = data[LocaleDataIndex.ExtraData][2 /* ExtraDayPeriodsRules */] || [];
        return rules.map(( /**
         * @param {?} rule
         * @return {?}
         */function (rule) {
            if (typeof rule === 'string') {
                return extractTime(rule);
            }
            return [extractTime(rule[0]), extractTime(rule[1])];
        }));
    }
    /**
     * Retrieves locale-specific day periods, which indicate roughly how a day is broken up
     * in different languages.
     * For example, for `en-US`, periods are morning, noon, afternoon, evening, and midnight.
     *
     * This functionality is only available when you have loaded the full locale data.
     * See the ["I18n guide"](guide/i18n#i18n-pipes).
     *
     * @see `getLocaleExtraDayPeriodRules()` / [Internationalization (i18n) Guide](https://angular.io/guide/i18n)
     *
     * \@publicApi
     * @param {?} locale A locale code for the locale format rules to use.
     * @param {?} formStyle The required grammatical form.
     * @param {?} width The required character width.
     * @return {?} The translated day-period strings.
     */
    function getLocaleExtraDayPeriods(locale, formStyle, width) {
        /** @type {?} */
        var data = findLocaleData(locale);
        checkFullData(data);
        /** @type {?} */
        var dayPeriodsData = ( /** @type {?} */([
            data[LocaleDataIndex.ExtraData][0 /* ExtraDayPeriodFormats */],
            data[LocaleDataIndex.ExtraData][1 /* ExtraDayPeriodStandalone */]
        ]));
        /** @type {?} */
        var dayPeriods = getLastDefinedValue(dayPeriodsData, formStyle) || [];
        return getLastDefinedValue(dayPeriods, width) || [];
    }
    /**
     * Retrieves the first value that is defined in an array, going backwards from an index position.
     *
     * To avoid repeating the same data (as when the "format" and "standalone" forms are the same)
     * add the first value to the locale data arrays, and add other values only if they are different.
     *
     * @see [Internationalization (i18n) Guide](https://angular.io/guide/i18n)
     *
     * \@publicApi
     * @template T
     * @param {?} data The data array to retrieve from.
     * @param {?} index A 0-based index into the array to start from.
     * @return {?} The value immediately before the given index position.
     */
    function getLastDefinedValue(data, index) {
        for (var i_114 = index; i_114 > -1; i_114--) {
            if (typeof data[i_114] !== 'undefined') {
                return data[i_114];
            }
        }
        throw new Error('Locale data API: locale data undefined');
    }
    /**
     * Extracts the hours and minutes from a string like "15:45"
     * @param {?} time
     * @return {?}
     */
    function extractTime(time) {
        var _b = __read(time.split(':'), 2), h = _b[0], m = _b[1];
        return { hours: +h, minutes: +m };
    }
    /**
     * Retrieves the currency symbol for a given currency code.
     *
     * For example, for the default `en-US` locale, the code `USD` can
     * be represented by the narrow symbol `$` or the wide symbol `US$`.
     *
     * @see [Internationalization (i18n) Guide](https://angular.io/guide/i18n)
     *
     * \@publicApi
     * @param {?} code The currency code.
     * @param {?} format The format, `wide` or `narrow`.
     * @param {?=} locale A locale code for the locale format rules to use.
     *
     * @return {?} The symbol, or the currency code if no symbol is available.0
     */
    function getCurrencySymbol(code, format, locale) {
        if (locale === void 0) { locale = 'en'; }
        /** @type {?} */
        var currency = getLocaleCurrencies(locale)[code] || CURRENCIES_EN[code] || [];
        /** @type {?} */
        var symbolNarrow = currency[1 /* SymbolNarrow */];
        if (format === 'narrow' && typeof symbolNarrow === 'string') {
            return symbolNarrow;
        }
        return currency[0 /* Symbol */] || code;
    }
    // Most currencies have cents, that's why the default is 2
    /** @type {?} */
    var DEFAULT_NB_OF_CURRENCY_DIGITS = 2;
    /**
     * Reports the number of decimal digits for a given currency.
     * The value depends upon the presence of cents in that particular currency.
     *
     * @see [Internationalization (i18n) Guide](https://angular.io/guide/i18n)
     *
     * \@publicApi
     * @param {?} code The currency code.
     * @return {?} The number of decimal digits, typically 0 or 2.
     */
    function getNumberOfCurrencyDigits(code) {
        /** @type {?} */
        var digits;
        /** @type {?} */
        var currency = CURRENCIES_EN[code];
        if (currency) {
            digits = currency[2 /* NbOfDigits */];
        }
        return typeof digits === 'number' ? digits : DEFAULT_NB_OF_CURRENCY_DIGITS;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var ISO8601_DATE_REGEX = /^(\d{4})-?(\d\d)-?(\d\d)(?:T(\d\d)(?::?(\d\d)(?::?(\d\d)(?:\.(\d+))?)?)?(Z|([+-])(\d\d):?(\d\d))?)?$/;
    //    1        2       3         4          5          6          7          8  9     10      11
    /** @type {?} */
    var NAMED_FORMATS = {};
    /** @type {?} */
    var DATE_FORMATS_SPLIT = /((?:[^GyMLwWdEabBhHmsSzZO']+)|(?:'(?:[^']|'')*')|(?:G{1,5}|y{1,4}|M{1,5}|L{1,5}|w{1,2}|W{1}|d{1,2}|E{1,6}|a{1,5}|b{1,5}|B{1,5}|h{1,2}|H{1,2}|m{1,2}|s{1,2}|S{1,3}|z{1,4}|Z{1,5}|O{1,4}))([\s\S]*)/;
    /** @enum {number} */
    var ZoneWidth = {
        Short: 0,
        ShortGMT: 1,
        Long: 2,
        Extended: 3,
    };
    ZoneWidth[ZoneWidth.Short] = 'Short';
    ZoneWidth[ZoneWidth.ShortGMT] = 'ShortGMT';
    ZoneWidth[ZoneWidth.Long] = 'Long';
    ZoneWidth[ZoneWidth.Extended] = 'Extended';
    /** @enum {number} */
    var DateType = {
        FullYear: 0,
        Month: 1,
        Date: 2,
        Hours: 3,
        Minutes: 4,
        Seconds: 5,
        FractionalSeconds: 6,
        Day: 7,
    };
    DateType[DateType.FullYear] = 'FullYear';
    DateType[DateType.Month] = 'Month';
    DateType[DateType.Date] = 'Date';
    DateType[DateType.Hours] = 'Hours';
    DateType[DateType.Minutes] = 'Minutes';
    DateType[DateType.Seconds] = 'Seconds';
    DateType[DateType.FractionalSeconds] = 'FractionalSeconds';
    DateType[DateType.Day] = 'Day';
    /** @enum {number} */
    var TranslationType = {
        DayPeriods: 0,
        Days: 1,
        Months: 2,
        Eras: 3,
    };
    TranslationType[TranslationType.DayPeriods] = 'DayPeriods';
    TranslationType[TranslationType.Days] = 'Days';
    TranslationType[TranslationType.Months] = 'Months';
    TranslationType[TranslationType.Eras] = 'Eras';
    /**
     * \@ngModule CommonModule
     * \@description
     *
     * Formats a date according to locale rules.
     *
     * @see `DatePipe` / [Internationalization (i18n) Guide](https://angular.io/guide/i18n)
     *
     * \@publicApi
     * @param {?} value The date to format, as a Date, or a number (milliseconds since UTC epoch)
     * or an [ISO date-time string](https://www.w3.org/TR/NOTE-datetime).
     * @param {?} format The date-time components to include. See `DatePipe` for details.
     * @param {?} locale A locale code for the locale format rules to use.
     * @param {?=} timezone The time zone. A time zone offset from GMT (such as `'+0430'`),
     * or a standard UTC/GMT or continental US time zone abbreviation.
     * If not specified, uses host system settings.
     *
     * @return {?} The formatted date string.
     *
     */
    function formatDate(value, format, locale, timezone) {
        /** @type {?} */
        var date = toDate(value);
        /** @type {?} */
        var namedFormat = getNamedFormat(locale, format);
        format = namedFormat || format;
        /** @type {?} */
        var parts = [];
        /** @type {?} */
        var match;
        while (format) {
            match = DATE_FORMATS_SPLIT.exec(format);
            if (match) {
                parts = parts.concat(match.slice(1));
                /** @type {?} */
                var part = parts.pop();
                if (!part) {
                    break;
                }
                format = part;
            }
            else {
                parts.push(format);
                break;
            }
        }
        /** @type {?} */
        var dateTimezoneOffset = date.getTimezoneOffset();
        if (timezone) {
            dateTimezoneOffset = timezoneToOffset(timezone, dateTimezoneOffset);
            date = convertTimezoneToLocal(date, timezone, true);
        }
        /** @type {?} */
        var text = '';
        parts.forEach(( /**
         * @param {?} value
         * @return {?}
         */function (/**
         * @param {?} value
         * @return {?}
         */ value) {
            /** @type {?} */
            var dateFormatter = getDateFormatter(value);
            text += dateFormatter ?
                dateFormatter(date, locale, dateTimezoneOffset) :
                value === '\'\'' ? '\'' : value.replace(/(^'|'$)/g, '').replace(/''/g, '\'');
        }));
        return text;
    }
    /**
     * @param {?} locale
     * @param {?} format
     * @return {?}
     */
    function getNamedFormat(locale, format) {
        /** @type {?} */
        var localeId = getLocaleId(locale);
        NAMED_FORMATS[localeId] = NAMED_FORMATS[localeId] || {};
        if (NAMED_FORMATS[localeId][format]) {
            return NAMED_FORMATS[localeId][format];
        }
        /** @type {?} */
        var formatValue = '';
        switch (format) {
            case 'shortDate':
                formatValue = getLocaleDateFormat(locale, FormatWidth.Short);
                break;
            case 'mediumDate':
                formatValue = getLocaleDateFormat(locale, FormatWidth.Medium);
                break;
            case 'longDate':
                formatValue = getLocaleDateFormat(locale, FormatWidth.Long);
                break;
            case 'fullDate':
                formatValue = getLocaleDateFormat(locale, FormatWidth.Full);
                break;
            case 'shortTime':
                formatValue = getLocaleTimeFormat(locale, FormatWidth.Short);
                break;
            case 'mediumTime':
                formatValue = getLocaleTimeFormat(locale, FormatWidth.Medium);
                break;
            case 'longTime':
                formatValue = getLocaleTimeFormat(locale, FormatWidth.Long);
                break;
            case 'fullTime':
                formatValue = getLocaleTimeFormat(locale, FormatWidth.Full);
                break;
            case 'short':
                /** @type {?} */
                var shortTime = getNamedFormat(locale, 'shortTime');
                /** @type {?} */
                var shortDate = getNamedFormat(locale, 'shortDate');
                formatValue = formatDateTime(getLocaleDateTimeFormat(locale, FormatWidth.Short), [shortTime, shortDate]);
                break;
            case 'medium':
                /** @type {?} */
                var mediumTime = getNamedFormat(locale, 'mediumTime');
                /** @type {?} */
                var mediumDate = getNamedFormat(locale, 'mediumDate');
                formatValue = formatDateTime(getLocaleDateTimeFormat(locale, FormatWidth.Medium), [mediumTime, mediumDate]);
                break;
            case 'long':
                /** @type {?} */
                var longTime = getNamedFormat(locale, 'longTime');
                /** @type {?} */
                var longDate = getNamedFormat(locale, 'longDate');
                formatValue =
                    formatDateTime(getLocaleDateTimeFormat(locale, FormatWidth.Long), [longTime, longDate]);
                break;
            case 'full':
                /** @type {?} */
                var fullTime = getNamedFormat(locale, 'fullTime');
                /** @type {?} */
                var fullDate = getNamedFormat(locale, 'fullDate');
                formatValue =
                    formatDateTime(getLocaleDateTimeFormat(locale, FormatWidth.Full), [fullTime, fullDate]);
                break;
        }
        if (formatValue) {
            NAMED_FORMATS[localeId][format] = formatValue;
        }
        return formatValue;
    }
    /**
     * @param {?} str
     * @param {?} opt_values
     * @return {?}
     */
    function formatDateTime(str, opt_values) {
        if (opt_values) {
            str = str.replace(/\{([^}]+)}/g, ( /**
             * @param {?} match
             * @param {?} key
             * @return {?}
             */function (match, key) {
                return (opt_values != null && key in opt_values) ? opt_values[key] : match;
            }));
        }
        return str;
    }
    /**
     * @param {?} num
     * @param {?} digits
     * @param {?=} minusSign
     * @param {?=} trim
     * @param {?=} negWrap
     * @return {?}
     */
    function padNumber(num, digits, minusSign, trim, negWrap) {
        if (minusSign === void 0) { minusSign = '-'; }
        /** @type {?} */
        var neg = '';
        if (num < 0 || (negWrap && num <= 0)) {
            if (negWrap) {
                num = -num + 1;
            }
            else {
                num = -num;
                neg = minusSign;
            }
        }
        /** @type {?} */
        var strNum = String(num);
        while (strNum.length < digits) {
            strNum = '0' + strNum;
        }
        if (trim) {
            strNum = strNum.substr(strNum.length - digits);
        }
        return neg + strNum;
    }
    /**
     * @param {?} milliseconds
     * @param {?} digits
     * @return {?}
     */
    function formatFractionalSeconds(milliseconds, digits) {
        /** @type {?} */
        var strMs = padNumber(milliseconds, 3);
        return strMs.substr(0, digits);
    }
    /**
     * Returns a date formatter that transforms a date into its locale digit representation
     * @param {?} name
     * @param {?} size
     * @param {?=} offset
     * @param {?=} trim
     * @param {?=} negWrap
     * @return {?}
     */
    function dateGetter(name, size, offset, trim, negWrap) {
        if (offset === void 0) { offset = 0; }
        if (trim === void 0) { trim = false; }
        if (negWrap === void 0) { negWrap = false; }
        return ( /**
         * @param {?} date
         * @param {?} locale
         * @return {?}
         */function (date, locale) {
            /** @type {?} */
            var part = getDatePart(name, date);
            if (offset > 0 || part > -offset) {
                part += offset;
            }
            if (name === DateType.Hours) {
                if (part === 0 && offset === -12) {
                    part = 12;
                }
            }
            else if (name === DateType.FractionalSeconds) {
                return formatFractionalSeconds(part, size);
            }
            /** @type {?} */
            var localeMinus = getLocaleNumberSymbol(locale, NumberSymbol.MinusSign);
            return padNumber(part, size, localeMinus, trim, negWrap);
        });
    }
    /**
     * @param {?} part
     * @param {?} date
     * @return {?}
     */
    function getDatePart(part, date) {
        switch (part) {
            case DateType.FullYear:
                return date.getFullYear();
            case DateType.Month:
                return date.getMonth();
            case DateType.Date:
                return date.getDate();
            case DateType.Hours:
                return date.getHours();
            case DateType.Minutes:
                return date.getMinutes();
            case DateType.Seconds:
                return date.getSeconds();
            case DateType.FractionalSeconds:
                return date.getMilliseconds();
            case DateType.Day:
                return date.getDay();
            default:
                throw new Error("Unknown DateType value \"" + part + "\".");
        }
    }
    /**
     * Returns a date formatter that transforms a date into its locale string representation
     * @param {?} name
     * @param {?} width
     * @param {?=} form
     * @param {?=} extended
     * @return {?}
     */
    function dateStrGetter(name, width, form, extended) {
        if (form === void 0) { form = FormStyle.Format; }
        if (extended === void 0) { extended = false; }
        return ( /**
         * @param {?} date
         * @param {?} locale
         * @return {?}
         */function (date, locale) {
            return getDateTranslation(date, locale, name, width, form, extended);
        });
    }
    /**
     * Returns the locale translation of a date for a given form, type and width
     * @param {?} date
     * @param {?} locale
     * @param {?} name
     * @param {?} width
     * @param {?} form
     * @param {?} extended
     * @return {?}
     */
    function getDateTranslation(date, locale, name, width, form, extended) {
        switch (name) {
            case TranslationType.Months:
                return getLocaleMonthNames(locale, form, width)[date.getMonth()];
            case TranslationType.Days:
                return getLocaleDayNames(locale, form, width)[date.getDay()];
            case TranslationType.DayPeriods:
                /** @type {?} */
                var currentHours_1 = date.getHours();
                /** @type {?} */
                var currentMinutes_1 = date.getMinutes();
                if (extended) {
                    /** @type {?} */
                    var rules = getLocaleExtraDayPeriodRules(locale);
                    /** @type {?} */
                    var dayPeriods_1 = getLocaleExtraDayPeriods(locale, form, width);
                    /** @type {?} */
                    var result_1;
                    rules.forEach(( /**
                     * @param {?} rule
                     * @param {?} index
                     * @return {?}
                     */function (rule, index) {
                        if (Array.isArray(rule)) {
                            // morning, afternoon, evening, night
                            var _b = rule[0], hoursFrom = _b.hours, minutesFrom = _b.minutes;
                            var _c = rule[1], hoursTo = _c.hours, minutesTo = _c.minutes;
                            if (currentHours_1 >= hoursFrom && currentMinutes_1 >= minutesFrom &&
                                (currentHours_1 < hoursTo ||
                                    (currentHours_1 === hoursTo && currentMinutes_1 < minutesTo))) {
                                result_1 = dayPeriods_1[index];
                            }
                        }
                        else { // noon or midnight
                            // noon or midnight
                            var hours = rule.hours, minutes = rule.minutes;
                            if (hours === currentHours_1 && minutes === currentMinutes_1) {
                                result_1 = dayPeriods_1[index];
                            }
                        }
                    }));
                    if (result_1) {
                        return result_1;
                    }
                }
                // if no rules for the day periods, we use am/pm by default
                return getLocaleDayPeriods(locale, form, ( /** @type {?} */(width)))[currentHours_1 < 12 ? 0 : 1];
            case TranslationType.Eras:
                return getLocaleEraNames(locale, ( /** @type {?} */(width)))[date.getFullYear() <= 0 ? 0 : 1];
            default:
                // This default case is not needed by TypeScript compiler, as the switch is exhaustive.
                // However Closure Compiler does not understand that and reports an error in typed mode.
                // The `throw new Error` below works around the problem, and the unexpected: never variable
                // makes sure tsc still checks this code is unreachable.
                /** @type {?} */
                var unexpected = name;
                throw new Error("unexpected translation type " + unexpected);
        }
    }
    /**
     * Returns a date formatter that transforms a date and an offset into a timezone with ISO8601 or
     * GMT format depending on the width (eg: short = +0430, short:GMT = GMT+4, long = GMT+04:30,
     * extended = +04:30)
     * @param {?} width
     * @return {?}
     */
    function timeZoneGetter(width) {
        return ( /**
         * @param {?} date
         * @param {?} locale
         * @param {?} offset
         * @return {?}
         */function (date, locale, offset) {
            /** @type {?} */
            var zone = -1 * offset;
            /** @type {?} */
            var minusSign = getLocaleNumberSymbol(locale, NumberSymbol.MinusSign);
            /** @type {?} */
            var hours = zone > 0 ? Math.floor(zone / 60) : Math.ceil(zone / 60);
            switch (width) {
                case ZoneWidth.Short:
                    return ((zone >= 0) ? '+' : '') + padNumber(hours, 2, minusSign) +
                        padNumber(Math.abs(zone % 60), 2, minusSign);
                case ZoneWidth.ShortGMT:
                    return 'GMT' + ((zone >= 0) ? '+' : '') + padNumber(hours, 1, minusSign);
                case ZoneWidth.Long:
                    return 'GMT' + ((zone >= 0) ? '+' : '') + padNumber(hours, 2, minusSign) + ':' +
                        padNumber(Math.abs(zone % 60), 2, minusSign);
                case ZoneWidth.Extended:
                    if (offset === 0) {
                        return 'Z';
                    }
                    else {
                        return ((zone >= 0) ? '+' : '') + padNumber(hours, 2, minusSign) + ':' +
                            padNumber(Math.abs(zone % 60), 2, minusSign);
                    }
                default:
                    throw new Error("Unknown zone width \"" + width + "\"");
            }
        });
    }
    /** @type {?} */
    var JANUARY = 0;
    /** @type {?} */
    var THURSDAY = 4;
    /**
     * @param {?} year
     * @return {?}
     */
    function getFirstThursdayOfYear(year) {
        /** @type {?} */
        var firstDayOfYear = (new Date(year, JANUARY, 1)).getDay();
        return new Date(year, 0, 1 + ((firstDayOfYear <= THURSDAY) ? THURSDAY : THURSDAY + 7) - firstDayOfYear);
    }
    /**
     * @param {?} datetime
     * @return {?}
     */
    function getThursdayThisWeek(datetime) {
        return new Date(datetime.getFullYear(), datetime.getMonth(), datetime.getDate() + (THURSDAY - datetime.getDay()));
    }
    /**
     * @param {?} size
     * @param {?=} monthBased
     * @return {?}
     */
    function weekGetter(size, monthBased) {
        if (monthBased === void 0) { monthBased = false; }
        return ( /**
         * @param {?} date
         * @param {?} locale
         * @return {?}
         */function (date, locale) {
            /** @type {?} */
            var result;
            if (monthBased) {
                /** @type {?} */
                var nbDaysBefore1stDayOfMonth = new Date(date.getFullYear(), date.getMonth(), 1).getDay() - 1;
                /** @type {?} */
                var today = date.getDate();
                result = 1 + Math.floor((today + nbDaysBefore1stDayOfMonth) / 7);
            }
            else {
                /** @type {?} */
                var firstThurs = getFirstThursdayOfYear(date.getFullYear());
                /** @type {?} */
                var thisThurs = getThursdayThisWeek(date);
                /** @type {?} */
                var diff = thisThurs.getTime() - firstThurs.getTime();
                result = 1 + Math.round(diff / 6.048e8); // 6.048e8 ms per week
            }
            return padNumber(result, size, getLocaleNumberSymbol(locale, NumberSymbol.MinusSign));
        });
    }
    /** @type {?} */
    var DATE_FORMATS = {};
    // Based on CLDR formats:
    // See complete list: http://www.unicode.org/reports/tr35/tr35-dates.html#Date_Field_Symbol_Table
    // See also explanations: http://cldr.unicode.org/translation/date-time
    // TODO(ocombe): support all missing cldr formats: Y, U, Q, D, F, e, c, j, J, C, A, v, V, X, x
    /**
     * @param {?} format
     * @return {?}
     */
    function getDateFormatter(format) {
        if (DATE_FORMATS[format]) {
            return DATE_FORMATS[format];
        }
        /** @type {?} */
        var formatter;
        switch (format) {
            // Era name (AD/BC)
            case 'G':
            case 'GG':
            case 'GGG':
                formatter = dateStrGetter(TranslationType.Eras, TranslationWidth.Abbreviated);
                break;
            case 'GGGG':
                formatter = dateStrGetter(TranslationType.Eras, TranslationWidth.Wide);
                break;
            case 'GGGGG':
                formatter = dateStrGetter(TranslationType.Eras, TranslationWidth.Narrow);
                break;
            // 1 digit representation of the year, e.g. (AD 1 => 1, AD 199 => 199)
            case 'y':
                formatter = dateGetter(DateType.FullYear, 1, 0, false, true);
                break;
            // 2 digit representation of the year, padded (00-99). (e.g. AD 2001 => 01, AD 2010 => 10)
            case 'yy':
                formatter = dateGetter(DateType.FullYear, 2, 0, true, true);
                break;
            // 3 digit representation of the year, padded (000-999). (e.g. AD 2001 => 01, AD 2010 => 10)
            case 'yyy':
                formatter = dateGetter(DateType.FullYear, 3, 0, false, true);
                break;
            // 4 digit representation of the year (e.g. AD 1 => 0001, AD 2010 => 2010)
            case 'yyyy':
                formatter = dateGetter(DateType.FullYear, 4, 0, false, true);
                break;
            // Month of the year (1-12), numeric
            case 'M':
            case 'L':
                formatter = dateGetter(DateType.Month, 1, 1);
                break;
            case 'MM':
            case 'LL':
                formatter = dateGetter(DateType.Month, 2, 1);
                break;
            // Month of the year (January, ...), string, format
            case 'MMM':
                formatter = dateStrGetter(TranslationType.Months, TranslationWidth.Abbreviated);
                break;
            case 'MMMM':
                formatter = dateStrGetter(TranslationType.Months, TranslationWidth.Wide);
                break;
            case 'MMMMM':
                formatter = dateStrGetter(TranslationType.Months, TranslationWidth.Narrow);
                break;
            // Month of the year (January, ...), string, standalone
            case 'LLL':
                formatter =
                    dateStrGetter(TranslationType.Months, TranslationWidth.Abbreviated, FormStyle.Standalone);
                break;
            case 'LLLL':
                formatter =
                    dateStrGetter(TranslationType.Months, TranslationWidth.Wide, FormStyle.Standalone);
                break;
            case 'LLLLL':
                formatter =
                    dateStrGetter(TranslationType.Months, TranslationWidth.Narrow, FormStyle.Standalone);
                break;
            // Week of the year (1, ... 52)
            case 'w':
                formatter = weekGetter(1);
                break;
            case 'ww':
                formatter = weekGetter(2);
                break;
            // Week of the month (1, ...)
            case 'W':
                formatter = weekGetter(1, true);
                break;
            // Day of the month (1-31)
            case 'd':
                formatter = dateGetter(DateType.Date, 1);
                break;
            case 'dd':
                formatter = dateGetter(DateType.Date, 2);
                break;
            // Day of the Week
            case 'E':
            case 'EE':
            case 'EEE':
                formatter = dateStrGetter(TranslationType.Days, TranslationWidth.Abbreviated);
                break;
            case 'EEEE':
                formatter = dateStrGetter(TranslationType.Days, TranslationWidth.Wide);
                break;
            case 'EEEEE':
                formatter = dateStrGetter(TranslationType.Days, TranslationWidth.Narrow);
                break;
            case 'EEEEEE':
                formatter = dateStrGetter(TranslationType.Days, TranslationWidth.Short);
                break;
            // Generic period of the day (am-pm)
            case 'a':
            case 'aa':
            case 'aaa':
                formatter = dateStrGetter(TranslationType.DayPeriods, TranslationWidth.Abbreviated);
                break;
            case 'aaaa':
                formatter = dateStrGetter(TranslationType.DayPeriods, TranslationWidth.Wide);
                break;
            case 'aaaaa':
                formatter = dateStrGetter(TranslationType.DayPeriods, TranslationWidth.Narrow);
                break;
            // Extended period of the day (midnight, at night, ...), standalone
            case 'b':
            case 'bb':
            case 'bbb':
                formatter = dateStrGetter(TranslationType.DayPeriods, TranslationWidth.Abbreviated, FormStyle.Standalone, true);
                break;
            case 'bbbb':
                formatter = dateStrGetter(TranslationType.DayPeriods, TranslationWidth.Wide, FormStyle.Standalone, true);
                break;
            case 'bbbbb':
                formatter = dateStrGetter(TranslationType.DayPeriods, TranslationWidth.Narrow, FormStyle.Standalone, true);
                break;
            // Extended period of the day (midnight, night, ...), standalone
            case 'B':
            case 'BB':
            case 'BBB':
                formatter = dateStrGetter(TranslationType.DayPeriods, TranslationWidth.Abbreviated, FormStyle.Format, true);
                break;
            case 'BBBB':
                formatter =
                    dateStrGetter(TranslationType.DayPeriods, TranslationWidth.Wide, FormStyle.Format, true);
                break;
            case 'BBBBB':
                formatter = dateStrGetter(TranslationType.DayPeriods, TranslationWidth.Narrow, FormStyle.Format, true);
                break;
            // Hour in AM/PM, (1-12)
            case 'h':
                formatter = dateGetter(DateType.Hours, 1, -12);
                break;
            case 'hh':
                formatter = dateGetter(DateType.Hours, 2, -12);
                break;
            // Hour of the day (0-23)
            case 'H':
                formatter = dateGetter(DateType.Hours, 1);
                break;
            // Hour in day, padded (00-23)
            case 'HH':
                formatter = dateGetter(DateType.Hours, 2);
                break;
            // Minute of the hour (0-59)
            case 'm':
                formatter = dateGetter(DateType.Minutes, 1);
                break;
            case 'mm':
                formatter = dateGetter(DateType.Minutes, 2);
                break;
            // Second of the minute (0-59)
            case 's':
                formatter = dateGetter(DateType.Seconds, 1);
                break;
            case 'ss':
                formatter = dateGetter(DateType.Seconds, 2);
                break;
            // Fractional second
            case 'S':
                formatter = dateGetter(DateType.FractionalSeconds, 1);
                break;
            case 'SS':
                formatter = dateGetter(DateType.FractionalSeconds, 2);
                break;
            case 'SSS':
                formatter = dateGetter(DateType.FractionalSeconds, 3);
                break;
            // Timezone ISO8601 short format (-0430)
            case 'Z':
            case 'ZZ':
            case 'ZZZ':
                formatter = timeZoneGetter(ZoneWidth.Short);
                break;
            // Timezone ISO8601 extended format (-04:30)
            case 'ZZZZZ':
                formatter = timeZoneGetter(ZoneWidth.Extended);
                break;
            // Timezone GMT short format (GMT+4)
            case 'O':
            case 'OO':
            case 'OOO':
            // Should be location, but fallback to format O instead because we don't have the data yet
            case 'z':
            case 'zz':
            case 'zzz':
                formatter = timeZoneGetter(ZoneWidth.ShortGMT);
                break;
            // Timezone GMT long format (GMT+0430)
            case 'OOOO':
            case 'ZZZZ':
            // Should be location, but fallback to format O instead because we don't have the data yet
            case 'zzzz':
                formatter = timeZoneGetter(ZoneWidth.Long);
                break;
            default:
                return null;
        }
        DATE_FORMATS[format] = formatter;
        return formatter;
    }
    /**
     * @param {?} timezone
     * @param {?} fallback
     * @return {?}
     */
    function timezoneToOffset(timezone, fallback) {
        // Support: IE 9-11 only, Edge 13-15+
        // IE/Edge do not "understand" colon (`:`) in timezone
        timezone = timezone.replace(/:/g, '');
        /** @type {?} */
        var requestedTimezoneOffset = Date.parse('Jan 01, 1970 00:00:00 ' + timezone) / 60000;
        return isNaN(requestedTimezoneOffset) ? fallback : requestedTimezoneOffset;
    }
    /**
     * @param {?} date
     * @param {?} minutes
     * @return {?}
     */
    function addDateMinutes(date, minutes) {
        date = new Date(date.getTime());
        date.setMinutes(date.getMinutes() + minutes);
        return date;
    }
    /**
     * @param {?} date
     * @param {?} timezone
     * @param {?} reverse
     * @return {?}
     */
    function convertTimezoneToLocal(date, timezone, reverse) {
        /** @type {?} */
        var reverseValue = reverse ? -1 : 1;
        /** @type {?} */
        var dateTimezoneOffset = date.getTimezoneOffset();
        /** @type {?} */
        var timezoneOffset = timezoneToOffset(timezone, dateTimezoneOffset);
        return addDateMinutes(date, reverseValue * (timezoneOffset - dateTimezoneOffset));
    }
    /**
     * Converts a value to date.
     *
     * Supported input formats:
     * - `Date`
     * - number: timestamp
     * - string: numeric (e.g. "1234"), ISO and date strings in a format supported by
     *   [Date.parse()](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Date/parse).
     *   Note: ISO strings without time return a date without timeoffset.
     *
     * Throws if unable to convert to a date.
     * @param {?} value
     * @return {?}
     */
    function toDate(value) {
        if (isDate$1(value)) {
            return value;
        }
        if (typeof value === 'number' && !isNaN(value)) {
            return new Date(value);
        }
        if (typeof value === 'string') {
            value = value.trim();
            /** @type {?} */
            var parsedNb = parseFloat(value);
            // any string that only contains numbers, like "1234" but not like "1234hello"
            if (!isNaN(( /** @type {?} */(value)) - parsedNb)) {
                return new Date(parsedNb);
            }
            if (/^(\d{4}-\d{1,2}-\d{1,2})$/.test(value)) {
                /* For ISO Strings without time the day, month and year must be extracted from the ISO String
                      before Date creation to avoid time offset and errors in the new Date.
                      If we only replace '-' with ',' in the ISO String ("2015,01,01"), and try to create a new
                      date, some browsers (e.g. IE 9) will throw an invalid Date error.
                      If we leave the '-' ("2015-01-01") and try to create a new Date("2015-01-01") the timeoffset
                      is applied.
                      Note: ISO months are 0 for January, 1 for February, ... */
                var _b = __read(value.split('-').map(( /**
                 * @param {?} val
                 * @return {?}
                 */function (val) { return +val; })), 3), y = _b[0], m = _b[1], d_1 = _b[2];
                return new Date(y, m - 1, d_1);
            }
            /** @type {?} */
            var match_2;
            if (match_2 = value.match(ISO8601_DATE_REGEX)) {
                return isoStringToDate(match_2);
            }
        }
        /** @type {?} */
        var date = new Date(( /** @type {?} */(value)));
        if (!isDate$1(date)) {
            throw new Error("Unable to convert \"" + value + "\" into a date");
        }
        return date;
    }
    /**
     * Converts a date in ISO8601 to a Date.
     * Used instead of `Date.parse` because of browser discrepancies.
     * @param {?} match
     * @return {?}
     */
    function isoStringToDate(match) {
        /** @type {?} */
        var date = new Date(0);
        /** @type {?} */
        var tzHour = 0;
        /** @type {?} */
        var tzMin = 0;
        // match[8] means that the string contains "Z" (UTC) or a timezone like "+01:00" or "+0100"
        /** @type {?} */
        var dateSetter = match[8] ? date.setUTCFullYear : date.setFullYear;
        /** @type {?} */
        var timeSetter = match[8] ? date.setUTCHours : date.setHours;
        // if there is a timezone defined like "+01:00" or "+0100"
        if (match[9]) {
            tzHour = Number(match[9] + match[10]);
            tzMin = Number(match[9] + match[11]);
        }
        dateSetter.call(date, Number(match[1]), Number(match[2]) - 1, Number(match[3]));
        /** @type {?} */
        var h = Number(match[4] || 0) - tzHour;
        /** @type {?} */
        var m = Number(match[5] || 0) - tzMin;
        /** @type {?} */
        var s = Number(match[6] || 0);
        /** @type {?} */
        var ms = Math.round(parseFloat('0.' + (match[7] || 0)) * 1000);
        timeSetter.call(date, h, m, s, ms);
        return date;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    function isDate$1(value) {
        return value instanceof Date && !isNaN(value.valueOf());
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var NUMBER_FORMAT_REGEXP = /^(\d+)?\.((\d+)(-(\d+))?)?$/;
    /** @type {?} */
    var MAX_DIGITS = 22;
    /** @type {?} */
    var DECIMAL_SEP = '.';
    /** @type {?} */
    var ZERO_CHAR = '0';
    /** @type {?} */
    var PATTERN_SEP = ';';
    /** @type {?} */
    var GROUP_SEP = ',';
    /** @type {?} */
    var DIGIT_CHAR = '#';
    /** @type {?} */
    var CURRENCY_CHAR = '¤';
    /** @type {?} */
    var PERCENT_CHAR = '%';
    /**
     * Transforms a number to a locale string based on a style and a format.
     * @param {?} value
     * @param {?} pattern
     * @param {?} locale
     * @param {?} groupSymbol
     * @param {?} decimalSymbol
     * @param {?=} digitsInfo
     * @param {?=} isPercent
     * @return {?}
     */
    function formatNumberToLocaleString(value, pattern, locale, groupSymbol, decimalSymbol, digitsInfo, isPercent) {
        if (isPercent === void 0) { isPercent = false; }
        /** @type {?} */
        var formattedText = '';
        /** @type {?} */
        var isZero = false;
        if (!isFinite(value)) {
            formattedText = getLocaleNumberSymbol(locale, NumberSymbol.Infinity);
        }
        else {
            /** @type {?} */
            var parsedNumber = parseNumber(value);
            if (isPercent) {
                parsedNumber = toPercent(parsedNumber);
            }
            /** @type {?} */
            var minInt = pattern.minInt;
            /** @type {?} */
            var minFraction = pattern.minFrac;
            /** @type {?} */
            var maxFraction = pattern.maxFrac;
            if (digitsInfo) {
                /** @type {?} */
                var parts = digitsInfo.match(NUMBER_FORMAT_REGEXP);
                if (parts === null) {
                    throw new Error(digitsInfo + " is not a valid digit info");
                }
                /** @type {?} */
                var minIntPart = parts[1];
                /** @type {?} */
                var minFractionPart = parts[3];
                /** @type {?} */
                var maxFractionPart = parts[5];
                if (minIntPart != null) {
                    minInt = parseIntAutoRadix(minIntPart);
                }
                if (minFractionPart != null) {
                    minFraction = parseIntAutoRadix(minFractionPart);
                }
                if (maxFractionPart != null) {
                    maxFraction = parseIntAutoRadix(maxFractionPart);
                }
                else if (minFractionPart != null && minFraction > maxFraction) {
                    maxFraction = minFraction;
                }
            }
            roundNumber(parsedNumber, minFraction, maxFraction);
            /** @type {?} */
            var digits = parsedNumber.digits;
            /** @type {?} */
            var integerLen = parsedNumber.integerLen;
            /** @type {?} */
            var exponent = parsedNumber.exponent;
            /** @type {?} */
            var decimals = [];
            isZero = digits.every(( /**
             * @param {?} d
             * @return {?}
             */function (/**
             * @param {?} d
             * @return {?}
             */ d) { return !d; }));
            // pad zeros for small numbers
            for (; integerLen < minInt; integerLen++) {
                digits.unshift(0);
            }
            // pad zeros for small numbers
            for (; integerLen < 0; integerLen++) {
                digits.unshift(0);
            }
            // extract decimals digits
            if (integerLen > 0) {
                decimals = digits.splice(integerLen, digits.length);
            }
            else {
                decimals = digits;
                digits = [0];
            }
            // format the integer digits with grouping separators
            /** @type {?} */
            var groups = [];
            if (digits.length >= pattern.lgSize) {
                groups.unshift(digits.splice(-pattern.lgSize, digits.length).join(''));
            }
            while (digits.length > pattern.gSize) {
                groups.unshift(digits.splice(-pattern.gSize, digits.length).join(''));
            }
            if (digits.length) {
                groups.unshift(digits.join(''));
            }
            formattedText = groups.join(getLocaleNumberSymbol(locale, groupSymbol));
            // append the decimal digits
            if (decimals.length) {
                formattedText += getLocaleNumberSymbol(locale, decimalSymbol) + decimals.join('');
            }
            if (exponent) {
                formattedText += getLocaleNumberSymbol(locale, NumberSymbol.Exponential) + '+' + exponent;
            }
        }
        if (value < 0 && !isZero) {
            formattedText = pattern.negPre + formattedText + pattern.negSuf;
        }
        else {
            formattedText = pattern.posPre + formattedText + pattern.posSuf;
        }
        return formattedText;
    }
    /**
     * \@ngModule CommonModule
     * \@description
     *
     * Formats a number as currency using locale rules.
     *
     * @see `formatNumber()` / `DecimalPipe` / [Internationalization (i18n) Guide](https://angular.io/guide/i18n)
     *
     * \@publicApi
     * @param {?} value The number to format.
     * @param {?} locale A locale code for the locale format rules to use.
     * @param {?} currency A string containing the currency symbol or its name,
     * such as "$" or "Canadian Dollar". Used in output string, but does not affect the operation
     * of the function.
     * @param {?=} currencyCode The [ISO 4217](https://en.wikipedia.org/wiki/ISO_4217)
     * currency code, such as `USD` for the US dollar and `EUR` for the euro.
     * Used to determine the number of digits in the decimal part.
     * @param {?=} digitsInfo
     * @return {?} The formatted currency value.
     *
     */
    function formatCurrency(value, locale, currency, currencyCode, digitsInfo) {
        /** @type {?} */
        var format = getLocaleNumberFormat(locale, NumberFormatStyle.Currency);
        /** @type {?} */
        var pattern = parseNumberFormat(format, getLocaleNumberSymbol(locale, NumberSymbol.MinusSign));
        pattern.minFrac = getNumberOfCurrencyDigits(( /** @type {?} */(currencyCode)));
        pattern.maxFrac = pattern.minFrac;
        /** @type {?} */
        var res = formatNumberToLocaleString(value, pattern, locale, NumberSymbol.CurrencyGroup, NumberSymbol.CurrencyDecimal, digitsInfo);
        return res
            .replace(CURRENCY_CHAR, currency)
            // if we have 2 time the currency character, the second one is ignored
            .replace(CURRENCY_CHAR, '');
    }
    /**
     * \@ngModule CommonModule
     * \@description
     *
     * Formats a number as a percentage according to locale rules.
     *
     * @see `formatNumber()` / `DecimalPipe` / [Internationalization (i18n) Guide](https://angular.io/guide/i18n)
     * \@publicApi
     *
     * @param {?} value The number to format.
     * @param {?} locale A locale code for the locale format rules to use.
     * @param {?=} digitsInfo
     * @return {?} The formatted percentage value.
     *
     */
    function formatPercent(value, locale, digitsInfo) {
        /** @type {?} */
        var format = getLocaleNumberFormat(locale, NumberFormatStyle.Percent);
        /** @type {?} */
        var pattern = parseNumberFormat(format, getLocaleNumberSymbol(locale, NumberSymbol.MinusSign));
        /** @type {?} */
        var res = formatNumberToLocaleString(value, pattern, locale, NumberSymbol.Group, NumberSymbol.Decimal, digitsInfo, true);
        return res.replace(new RegExp(PERCENT_CHAR, 'g'), getLocaleNumberSymbol(locale, NumberSymbol.PercentSign));
    }
    /**
     * \@ngModule CommonModule
     * \@description
     *
     * Formats a number as text, with group sizing, separator, and other
     * parameters based on the locale.
     *
     * @see [Internationalization (i18n) Guide](https://angular.io/guide/i18n)
     *
     * \@publicApi
     * @param {?} value The number to format.
     * @param {?} locale A locale code for the locale format rules to use.
     * @param {?=} digitsInfo
     * @return {?} The formatted text string.
     */
    function formatNumber(value, locale, digitsInfo) {
        /** @type {?} */
        var format = getLocaleNumberFormat(locale, NumberFormatStyle.Decimal);
        /** @type {?} */
        var pattern = parseNumberFormat(format, getLocaleNumberSymbol(locale, NumberSymbol.MinusSign));
        return formatNumberToLocaleString(value, pattern, locale, NumberSymbol.Group, NumberSymbol.Decimal, digitsInfo);
    }
    /**
     * @param {?} format
     * @param {?=} minusSign
     * @return {?}
     */
    function parseNumberFormat(format, minusSign) {
        if (minusSign === void 0) { minusSign = '-'; }
        /** @type {?} */
        var p = {
            minInt: 1,
            minFrac: 0,
            maxFrac: 0,
            posPre: '',
            posSuf: '',
            negPre: '',
            negSuf: '',
            gSize: 0,
            lgSize: 0
        };
        /** @type {?} */
        var patternParts = format.split(PATTERN_SEP);
        /** @type {?} */
        var positive = patternParts[0];
        /** @type {?} */
        var negative = patternParts[1];
        /** @type {?} */
        var positiveParts = positive.indexOf(DECIMAL_SEP) !== -1 ?
            positive.split(DECIMAL_SEP) :
            [
                positive.substring(0, positive.lastIndexOf(ZERO_CHAR) + 1),
                positive.substring(positive.lastIndexOf(ZERO_CHAR) + 1)
            ];
        /** @type {?} */
        var integer = positiveParts[0];
        /** @type {?} */
        var fraction = positiveParts[1] || '';
        p.posPre = integer.substr(0, integer.indexOf(DIGIT_CHAR));
        for (var i_115 = 0; i_115 < fraction.length; i_115++) {
            /** @type {?} */
            var ch = fraction.charAt(i_115);
            if (ch === ZERO_CHAR) {
                p.minFrac = p.maxFrac = i_115 + 1;
            }
            else if (ch === DIGIT_CHAR) {
                p.maxFrac = i_115 + 1;
            }
            else {
                p.posSuf += ch;
            }
        }
        /** @type {?} */
        var groups = integer.split(GROUP_SEP);
        p.gSize = groups[1] ? groups[1].length : 0;
        p.lgSize = (groups[2] || groups[1]) ? (groups[2] || groups[1]).length : 0;
        if (negative) {
            /** @type {?} */
            var trunkLen = positive.length - p.posPre.length - p.posSuf.length;
            /** @type {?} */
            var pos = negative.indexOf(DIGIT_CHAR);
            p.negPre = negative.substr(0, pos).replace(/'/g, '');
            p.negSuf = negative.substr(pos + trunkLen).replace(/'/g, '');
        }
        else {
            p.negPre = minusSign + p.posPre;
            p.negSuf = p.posSuf;
        }
        return p;
    }
    // Transforms a parsed number into a percentage by multiplying it by 100
    /**
     * @param {?} parsedNumber
     * @return {?}
     */
    function toPercent(parsedNumber) {
        // if the number is 0, don't do anything
        if (parsedNumber.digits[0] === 0) {
            return parsedNumber;
        }
        // Getting the current number of decimals
        /** @type {?} */
        var fractionLen = parsedNumber.digits.length - parsedNumber.integerLen;
        if (parsedNumber.exponent) {
            parsedNumber.exponent += 2;
        }
        else {
            if (fractionLen === 0) {
                parsedNumber.digits.push(0, 0);
            }
            else if (fractionLen === 1) {
                parsedNumber.digits.push(0);
            }
            parsedNumber.integerLen += 2;
        }
        return parsedNumber;
    }
    /**
     * Parses a number.
     * Significant bits of this parse algorithm came from https://github.com/MikeMcl/big.js/
     * @param {?} num
     * @return {?}
     */
    function parseNumber(num) {
        /** @type {?} */
        var numStr = Math.abs(num) + '';
        /** @type {?} */
        var exponent = 0;
        /** @type {?} */
        var digits;
        /** @type {?} */
        var integerLen;
        /** @type {?} */
        var i;
        /** @type {?} */
        var j;
        /** @type {?} */
        var zeros;
        // Decimal point?
        if ((integerLen = numStr.indexOf(DECIMAL_SEP)) > -1) {
            numStr = numStr.replace(DECIMAL_SEP, '');
        }
        // Exponential form?
        if ((i = numStr.search(/e/i)) > 0) {
            // Work out the exponent.
            if (integerLen < 0)
                integerLen = i;
            integerLen += +numStr.slice(i + 1);
            numStr = numStr.substring(0, i);
        }
        else if (integerLen < 0) {
            // There was no decimal point or exponent so it is an integer.
            integerLen = numStr.length;
        }
        // Count the number of leading zeros.
        for (i = 0; numStr.charAt(i) === ZERO_CHAR; i++) { /* empty */
        }
        if (i === (zeros = numStr.length)) {
            // The digits are all zero.
            digits = [0];
            integerLen = 1;
        }
        else {
            // Count the number of trailing zeros
            zeros--;
            while (numStr.charAt(zeros) === ZERO_CHAR)
                zeros--;
            // Trailing zeros are insignificant so ignore them
            integerLen -= i;
            digits = [];
            // Convert string to array of digits without leading/trailing zeros.
            for (j = 0; i <= zeros; i++, j++) {
                digits[j] = Number(numStr.charAt(i));
            }
        }
        // If the number overflows the maximum allowed digits then use an exponent.
        if (integerLen > MAX_DIGITS) {
            digits = digits.splice(0, MAX_DIGITS - 1);
            exponent = integerLen - 1;
            integerLen = 1;
        }
        return { digits: digits, exponent: exponent, integerLen: integerLen };
    }
    /**
     * Round the parsed number to the specified number of decimal places
     * This function changes the parsedNumber in-place
     * @param {?} parsedNumber
     * @param {?} minFrac
     * @param {?} maxFrac
     * @return {?}
     */
    function roundNumber(parsedNumber, minFrac, maxFrac) {
        if (minFrac > maxFrac) {
            throw new Error("The minimum number of digits after fraction (" + minFrac + ") is higher than the maximum (" + maxFrac + ").");
        }
        /** @type {?} */
        var digits = parsedNumber.digits;
        /** @type {?} */
        var fractionLen = digits.length - parsedNumber.integerLen;
        /** @type {?} */
        var fractionSize = Math.min(Math.max(minFrac, fractionLen), maxFrac);
        // The index of the digit to where rounding is to occur
        /** @type {?} */
        var roundAt = fractionSize + parsedNumber.integerLen;
        /** @type {?} */
        var digit = digits[roundAt];
        if (roundAt > 0) {
            // Drop fractional digits beyond `roundAt`
            digits.splice(Math.max(parsedNumber.integerLen, roundAt));
            // Set non-fractional digits beyond `roundAt` to 0
            for (var j_8 = roundAt; j_8 < digits.length; j_8++) {
                digits[j_8] = 0;
            }
        }
        else {
            // We rounded to zero so reset the parsedNumber
            fractionLen = Math.max(0, fractionLen);
            parsedNumber.integerLen = 1;
            digits.length = Math.max(1, roundAt = fractionSize + 1);
            digits[0] = 0;
            for (var i_116 = 1; i_116 < roundAt; i_116++)
                digits[i_116] = 0;
        }
        if (digit >= 5) {
            if (roundAt - 1 < 0) {
                for (var k = 0; k > roundAt; k--) {
                    digits.unshift(0);
                    parsedNumber.integerLen++;
                }
                digits.unshift(1);
                parsedNumber.integerLen++;
            }
            else {
                digits[roundAt - 1]++;
            }
        }
        // Pad out with zeros to get the required fraction length
        for (; fractionLen < Math.max(0, fractionSize); fractionLen++)
            digits.push(0);
        /** @type {?} */
        var dropTrailingZeros = fractionSize !== 0;
        // Minimal length = nb of decimals required + current nb of integers
        // Any number besides that is optional and can be removed if it's a trailing 0
        /** @type {?} */
        var minLen = minFrac + parsedNumber.integerLen;
        // Do any carrying, e.g. a digit was rounded up to 10
        /** @type {?} */
        var carry = digits.reduceRight(( /**
         * @param {?} carry
         * @param {?} d
         * @param {?} i
         * @param {?} digits
         * @return {?}
         */function (carry, d, i, digits) {
            d = d + carry;
            digits[i] = d < 10 ? d : d - 10; // d % 10
            if (dropTrailingZeros) {
                // Do not keep meaningless fractional trailing zeros (e.g. 15.52000 --> 15.52)
                if (digits[i] === 0 && i >= minLen) {
                    digits.pop();
                }
                else {
                    dropTrailingZeros = false;
                }
            }
            return d >= 10 ? 1 : 0; // Math.floor(d / 10);
        }), 0);
        if (carry) {
            digits.unshift(carry);
            parsedNumber.integerLen++;
        }
    }
    /**
     * @param {?} text
     * @return {?}
     */
    function parseIntAutoRadix(text) {
        /** @type {?} */
        var result = parseInt(text);
        if (isNaN(result)) {
            throw new Error('Invalid integer literal when parsing ' + text);
        }
        return result;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @deprecated from v5
     * @type {?}
     */
    var DEPRECATED_PLURAL_FN = new InjectionToken('UseV4Plurals');
    /**
     * \@publicApi
     * @abstract
     */
    var NgLocalization = /** @class */ (function () {
        function NgLocalization() {
        }
        return NgLocalization;
    }());
    /**
     * Returns the plural category for a given value.
     * - "=value" when the case exists,
     * - the plural category otherwise
     * @param {?} value
     * @param {?} cases
     * @param {?} ngLocalization
     * @param {?=} locale
     * @return {?}
     */
    function getPluralCategory(value, cases, ngLocalization, locale) {
        /** @type {?} */
        var key = "=" + value;
        if (cases.indexOf(key) > -1) {
            return key;
        }
        key = ngLocalization.getPluralCategory(value, locale);
        if (cases.indexOf(key) > -1) {
            return key;
        }
        if (cases.indexOf('other') > -1) {
            return 'other';
        }
        throw new Error("No plural message found for value \"" + value + "\"");
    }
    /**
     * Returns the plural case based on the locale
     *
     * \@publicApi
     */
    var NgLocaleLocalization = /** @class */ (function (_super) {
        __extends(NgLocaleLocalization, _super);
        /**
         * @param {?} locale
         * @param {?=} deprecatedPluralFn
         */
        function NgLocaleLocalization(locale, deprecatedPluralFn) {
            var _this = _super.call(this) || this;
            _this.locale = locale;
            _this.deprecatedPluralFn = deprecatedPluralFn;
            return _this;
        }
        /**
         * @param {?} value
         * @param {?=} locale
         * @return {?}
         */
        NgLocaleLocalization.prototype.getPluralCategory = function (value, locale) {
            /** @type {?} */
            var plural = this.deprecatedPluralFn ? this.deprecatedPluralFn(locale || this.locale, value) :
                getLocalePluralCase$1(locale || this.locale)(value);
            switch (plural) {
                case Plural.Zero:
                    return 'zero';
                case Plural.One:
                    return 'one';
                case Plural.Two:
                    return 'two';
                case Plural.Few:
                    return 'few';
                case Plural.Many:
                    return 'many';
                default:
                    return 'other';
            }
        };
        return NgLocaleLocalization;
    }(NgLocalization));
    NgLocaleLocalization.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    NgLocaleLocalization.ctorParameters = function () { return [
        { type: String, decorators: [{ type: Inject, args: [LOCALE_ID$1,] }] },
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [DEPRECATED_PLURAL_FN,] }] }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @param {?} cookieStr
     * @param {?} name
     * @return {?}
     */
    function parseCookieValue(cookieStr, name) {
        var e_5, _b;
        name = encodeURIComponent(name);
        try {
            for (var _c = __values(cookieStr.split(';')), _d = _c.next(); !_d.done; _d = _c.next()) {
                var cookie = _d.value;
                /** @type {?} */
                var eqIndex = cookie.indexOf('=');
                var _e = __read(eqIndex == -1 ? [cookie, ''] : [cookie.slice(0, eqIndex), cookie.slice(eqIndex + 1)], 2), cookieName = _e[0], cookieValue = _e[1];
                if (cookieName.trim() === name) {
                    return decodeURIComponent(cookieValue);
                }
            }
        }
        catch (e_5_1) { e_5 = { error: e_5_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
            }
            finally { if (e_5) throw e_5.error; }
        }
        return null;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Used as a token for an injected service within the NgClass directive.
     *
     * NgClass behaves differenly whether or not VE is being used or not. If
     * present then the legacy ngClass diffing algorithm will be used as an
     * injected service. Otherwise the new diffing algorithm (which delegates
     * to the `[class]` binding) will be used. This toggle behavior is done so
     * via the ivy_switch mechanism.
     * @abstract
     */
    var NgClassImpl = /** @class */ (function () {
        function NgClassImpl() {
        }
        return NgClassImpl;
    }());
    var NgClassR2Impl = /** @class */ (function () {
        /**
         * @param {?} _iterableDiffers
         * @param {?} _keyValueDiffers
         * @param {?} _ngEl
         * @param {?} _renderer
         */
        function NgClassR2Impl(_iterableDiffers, _keyValueDiffers, _ngEl, _renderer) {
            this._iterableDiffers = _iterableDiffers;
            this._keyValueDiffers = _keyValueDiffers;
            this._ngEl = _ngEl;
            this._renderer = _renderer;
            this._initialClasses = [];
        }
        /**
         * @return {?}
         */
        NgClassR2Impl.prototype.getValue = function () { return null; };
        /**
         * @param {?} value
         * @return {?}
         */
        NgClassR2Impl.prototype.setClass = function (value) {
            this._removeClasses(this._initialClasses);
            this._initialClasses = typeof value === 'string' ? value.split(/\s+/) : [];
            this._applyClasses(this._initialClasses);
            this._applyClasses(this._rawClass);
        };
        /**
         * @param {?} value
         * @return {?}
         */
        NgClassR2Impl.prototype.setNgClass = function (value) {
            this._removeClasses(this._rawClass);
            this._applyClasses(this._initialClasses);
            this._iterableDiffer = null;
            this._keyValueDiffer = null;
            this._rawClass = typeof value === 'string' ? value.split(/\s+/) : value;
            if (this._rawClass) {
                if (isListLikeIterable$1(this._rawClass)) {
                    this._iterableDiffer = this._iterableDiffers.find(this._rawClass).create();
                }
                else {
                    this._keyValueDiffer = this._keyValueDiffers.find(this._rawClass).create();
                }
            }
        };
        /**
         * @return {?}
         */
        NgClassR2Impl.prototype.applyChanges = function () {
            if (this._iterableDiffer) {
                /** @type {?} */
                var iterableChanges = this._iterableDiffer.diff(( /** @type {?} */(this._rawClass)));
                if (iterableChanges) {
                    this._applyIterableChanges(iterableChanges);
                }
            }
            else if (this._keyValueDiffer) {
                /** @type {?} */
                var keyValueChanges = this._keyValueDiffer.diff(( /** @type {?} */(this._rawClass)));
                if (keyValueChanges) {
                    this._applyKeyValueChanges(keyValueChanges);
                }
            }
        };
        /**
         * @private
         * @param {?} changes
         * @return {?}
         */
        NgClassR2Impl.prototype._applyKeyValueChanges = function (changes) {
            var _this = this;
            changes.forEachAddedItem(( /**
             * @param {?} record
             * @return {?}
             */function (record) { return _this._toggleClass(record.key, record.currentValue); }));
            changes.forEachChangedItem(( /**
             * @param {?} record
             * @return {?}
             */function (record) { return _this._toggleClass(record.key, record.currentValue); }));
            changes.forEachRemovedItem(( /**
             * @param {?} record
             * @return {?}
             */function (record) {
                if (record.previousValue) {
                    _this._toggleClass(record.key, false);
                }
            }));
        };
        /**
         * @private
         * @param {?} changes
         * @return {?}
         */
        NgClassR2Impl.prototype._applyIterableChanges = function (changes) {
            var _this = this;
            changes.forEachAddedItem(( /**
             * @param {?} record
             * @return {?}
             */function (record) {
                if (typeof record.item === 'string') {
                    _this._toggleClass(record.item, true);
                }
                else {
                    throw new Error("NgClass can only toggle CSS classes expressed as strings, got " + stringify(record.item));
                }
            }));
            changes.forEachRemovedItem(( /**
             * @param {?} record
             * @return {?}
             */function (record) { return _this._toggleClass(record.item, false); }));
        };
        /**
         * Applies a collection of CSS classes to the DOM element.
         *
         * For argument of type Set and Array CSS class names contained in those collections are always
         * added.
         * For argument of type Map CSS class name in the map's key is toggled based on the value (added
         * for truthy and removed for falsy).
         * @private
         * @param {?} rawClassVal
         * @return {?}
         */
        NgClassR2Impl.prototype._applyClasses = function (rawClassVal) {
            var _this = this;
            if (rawClassVal) {
                if (Array.isArray(rawClassVal) || rawClassVal instanceof Set) {
                    (( /** @type {?} */(rawClassVal))).forEach(( /**
                     * @param {?} klass
                     * @return {?}
                     */function (klass) { return _this._toggleClass(klass, true); }));
                }
                else {
                    Object.keys(rawClassVal).forEach(( /**
                     * @param {?} klass
                     * @return {?}
                     */function (/**
                     * @param {?} klass
                     * @return {?}
                     */ klass) { return _this._toggleClass(klass, !!rawClassVal[klass]); }));
                }
            }
        };
        /**
         * Removes a collection of CSS classes from the DOM element. This is mostly useful for cleanup
         * purposes.
         * @private
         * @param {?} rawClassVal
         * @return {?}
         */
        NgClassR2Impl.prototype._removeClasses = function (rawClassVal) {
            var _this = this;
            if (rawClassVal) {
                if (Array.isArray(rawClassVal) || rawClassVal instanceof Set) {
                    (( /** @type {?} */(rawClassVal))).forEach(( /**
                     * @param {?} klass
                     * @return {?}
                     */function (klass) { return _this._toggleClass(klass, false); }));
                }
                else {
                    Object.keys(rawClassVal).forEach(( /**
                     * @param {?} klass
                     * @return {?}
                     */function (/**
                     * @param {?} klass
                     * @return {?}
                     */ klass) { return _this._toggleClass(klass, false); }));
                }
            }
        };
        /**
         * @private
         * @param {?} klass
         * @param {?} enabled
         * @return {?}
         */
        NgClassR2Impl.prototype._toggleClass = function (klass, enabled) {
            var _this = this;
            klass = klass.trim();
            if (klass) {
                klass.split(/\s+/g).forEach(( /**
                 * @param {?} klass
                 * @return {?}
                 */function (/**
                 * @param {?} klass
                 * @return {?}
                 */ klass) {
                    if (enabled) {
                        _this._renderer.addClass(_this._ngEl.nativeElement, klass);
                    }
                    else {
                        _this._renderer.removeClass(_this._ngEl.nativeElement, klass);
                    }
                }));
            }
        };
        return NgClassR2Impl;
    }());
    NgClassR2Impl.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    NgClassR2Impl.ctorParameters = function () { return [
        { type: IterableDiffers },
        { type: KeyValueDiffers },
        { type: ElementRef },
        { type: Renderer2 }
    ]; };
    // the implementation for both NgStyleR2Impl and NgStyleR3Impl are
    // not ivy_switch'd away, instead they are only hooked up into the
    // DI via NgStyle's directive's provider property.
    /** @type {?} */
    var NgClassImplProvider__PRE_R3__ = {
        provide: NgClassImpl,
        useClass: NgClassR2Impl
    };
    /** @type {?} */
    var NgClassImplProvider = NgClassImplProvider__PRE_R3__;
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /*
     * NgClass (as well as NgStyle) behaves differently when loaded in the VE and when not.
     *
     * If the VE is present (which is for older versions of Angular) then NgClass will inject
     * the legacy diffing algorithm as a service and delegate all styling changes to that.
     *
     * If the VE is not present then NgStyle will normalize (through the injected service) and
     * then write all styling changes to the `[style]` binding directly (through a host binding).
     * Then Angular will notice the host binding change and treat the changes as styling
     * changes and apply them via the core styling instructions that exist within Angular.
     */
    // used when the VE is present
    /** @type {?} */
    var ngClassDirectiveDef__PRE_R3__ = undefined;
    // used when the VE is not present (note the directive will
    // never be instantiated normally because it is apart of a
    // base class)
    var ɵ0$4 = /**
     * @return {?}
     */ function () { }, ɵ1$1 = /**
     * @return {?}
     */ function () { }, ɵ2$2 = /**
     * @param {?} rf
     * @param {?} ctx
     * @param {?} elIndex
     * @return {?}
     */ function (rf, ctx, elIndex) {
        if (rf & 1 /* Create */) {
            ɵɵallocHostVars(1);
            ɵɵstyling();
        }
        if (rf & 2 /* Update */) {
            ɵɵclassMap(ctx.getValue());
            ɵɵstylingApply();
        }
    };
    /** @type {?} */
    var ngClassDirectiveDef__POST_R3__ = ɵɵdefineDirective({
        type: ( /** @type {?} */((ɵ0$4))),
        selectors: ( /** @type {?} */(null)),
        factory: (ɵ1$1),
        hostBindings: (ɵ2$2)
    });
    /** @type {?} */
    var ngClassDirectiveDef = ngClassDirectiveDef__PRE_R3__;
    /**
     * Serves as the base non-VE container for NgClass.
     *
     * While this is a base class that NgClass extends from, the
     * class itself acts as a container for non-VE code to setup
     * a link to the `[class]` host binding (via the static
     * `ngDirectiveDef` property on the class).
     *
     * Note that the `ngDirectiveDef` property's code is switched
     * depending if VE is present or not (this allows for the
     * binding code to be set only for newer versions of Angular).
     *
     * \@publicApi
     */
    var NgClassBase = /** @class */ (function () {
        /**
         * @param {?} _delegate
         */
        function NgClassBase(_delegate) {
            this._delegate = _delegate;
        }
        /**
         * @return {?}
         */
        NgClassBase.prototype.getValue = function () { return this._delegate.getValue(); };
        return NgClassBase;
    }());
    /** @nocollapse */ NgClassBase.ngDirectiveDef = ngClassDirectiveDef;
    /**
     * \@ngModule CommonModule
     *
     * \@usageNotes
     * ```
     *     <some-element [ngClass]="'first second'">...</some-element>
     *
     *     <some-element [ngClass]="['first', 'second']">...</some-element>
     *
     *     <some-element [ngClass]="{'first': true, 'second': true, 'third': false}">...</some-element>
     *
     *     <some-element [ngClass]="stringExp|arrayExp|objExp">...</some-element>
     *
     *     <some-element [ngClass]="{'class1 class2 class3' : true}">...</some-element>
     * ```
     *
     * \@description
     *
     * Adds and removes CSS classes on an HTML element.
     *
     * The CSS classes are updated as follows, depending on the type of the expression evaluation:
     * - `string` - the CSS classes listed in the string (space delimited) are added,
     * - `Array` - the CSS classes declared as Array elements are added,
     * - `Object` - keys are CSS classes that get added when the expression given in the value
     *              evaluates to a truthy value, otherwise they are removed.
     *
     * \@publicApi
     */
    var NgClass = /** @class */ (function (_super) {
        __extends(NgClass, _super);
        /**
         * @param {?} delegate
         */
        function NgClass(delegate) {
            return _super.call(this, delegate) || this;
        }
        Object.defineProperty(NgClass.prototype, "klass", {
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this._delegate.setClass(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgClass.prototype, "ngClass", {
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._delegate.setNgClass(value);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        NgClass.prototype.ngDoCheck = function () { this._delegate.applyChanges(); };
        return NgClass;
    }(NgClassBase));
    NgClass.decorators = [
        { type: Directive, args: [{ selector: '[ngClass]', providers: [NgClassImplProvider] },] }
    ];
    /** @nocollapse */
    NgClass.ctorParameters = function () { return [
        { type: NgClassImpl }
    ]; };
    NgClass.propDecorators = {
        klass: [{ type: Input, args: ['class',] }],
        ngClass: [{ type: Input, args: ['ngClass',] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Instantiates a single {\@link Component} type and inserts its Host View into current View.
     * `NgComponentOutlet` provides a declarative approach for dynamic component creation.
     *
     * `NgComponentOutlet` requires a component type, if a falsy value is set the view will clear and
     * any existing component will get destroyed.
     *
     * \@usageNotes
     *
     * ### Fine tune control
     *
     * You can control the component creation process by using the following optional attributes:
     *
     * * `ngComponentOutletInjector`: Optional custom {\@link Injector} that will be used as parent for
     * the Component. Defaults to the injector of the current view container.
     *
     * * `ngComponentOutletContent`: Optional list of projectable nodes to insert into the content
     * section of the component, if exists.
     *
     * * `ngComponentOutletNgModuleFactory`: Optional module factory to allow dynamically loading other
     * module, then load a component from that module.
     *
     * ### Syntax
     *
     * Simple
     * ```
     * <ng-container *ngComponentOutlet="componentTypeExpression"></ng-container>
     * ```
     *
     * Customized injector/content
     * ```
     * <ng-container *ngComponentOutlet="componentTypeExpression;
     *                                   injector: injectorExpression;
     *                                   content: contentNodesExpression;">
     * </ng-container>
     * ```
     *
     * Customized ngModuleFactory
     * ```
     * <ng-container *ngComponentOutlet="componentTypeExpression;
     *                                   ngModuleFactory: moduleFactory;">
     * </ng-container>
     * ```
     *
     * ### A simple example
     *
     * {\@example common/ngComponentOutlet/ts/module.ts region='SimpleExample'}
     *
     * A more complete example with additional options:
     *
     * {\@example common/ngComponentOutlet/ts/module.ts region='CompleteExample'}
     *
     * \@publicApi
     * \@ngModule CommonModule
     */
    var NgComponentOutlet = /** @class */ (function () {
        /**
         * @param {?} _viewContainerRef
         */
        function NgComponentOutlet(_viewContainerRef) {
            this._viewContainerRef = _viewContainerRef;
            this._componentRef = null;
            this._moduleRef = null;
        }
        /**
         * @param {?} changes
         * @return {?}
         */
        NgComponentOutlet.prototype.ngOnChanges = function (changes) {
            this._viewContainerRef.clear();
            this._componentRef = null;
            if (this.ngComponentOutlet) {
                /** @type {?} */
                var elInjector = this.ngComponentOutletInjector || this._viewContainerRef.parentInjector;
                if (changes['ngComponentOutletNgModuleFactory']) {
                    if (this._moduleRef)
                        this._moduleRef.destroy();
                    if (this.ngComponentOutletNgModuleFactory) {
                        /** @type {?} */
                        var parentModule = elInjector.get(NgModuleRef);
                        this._moduleRef = this.ngComponentOutletNgModuleFactory.create(parentModule.injector);
                    }
                    else {
                        this._moduleRef = null;
                    }
                }
                /** @type {?} */
                var componentFactoryResolver_1 = this._moduleRef ? this._moduleRef.componentFactoryResolver :
                    elInjector.get(ComponentFactoryResolver);
                /** @type {?} */
                var componentFactory = componentFactoryResolver_1.resolveComponentFactory(this.ngComponentOutlet);
                this._componentRef = this._viewContainerRef.createComponent(componentFactory, this._viewContainerRef.length, elInjector, this.ngComponentOutletContent);
            }
        };
        /**
         * @return {?}
         */
        NgComponentOutlet.prototype.ngOnDestroy = function () {
            if (this._moduleRef)
                this._moduleRef.destroy();
        };
        return NgComponentOutlet;
    }());
    NgComponentOutlet.decorators = [
        { type: Directive, args: [{ selector: '[ngComponentOutlet]' },] }
    ];
    /** @nocollapse */
    NgComponentOutlet.ctorParameters = function () { return [
        { type: ViewContainerRef }
    ]; };
    NgComponentOutlet.propDecorators = {
        ngComponentOutlet: [{ type: Input }],
        ngComponentOutletInjector: [{ type: Input }],
        ngComponentOutletContent: [{ type: Input }],
        ngComponentOutletNgModuleFactory: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@publicApi
     * @template T
     */
    var NgForOfContext = /** @class */ (function () {
        /**
         * @param {?} $implicit
         * @param {?} ngForOf
         * @param {?} index
         * @param {?} count
         */
        function NgForOfContext($implicit, ngForOf, index, count) {
            this.$implicit = $implicit;
            this.ngForOf = ngForOf;
            this.index = index;
            this.count = count;
        }
        Object.defineProperty(NgForOfContext.prototype, "first", {
            /**
             * @return {?}
             */
            get: function () { return this.index === 0; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgForOfContext.prototype, "last", {
            /**
             * @return {?}
             */
            get: function () { return this.index === this.count - 1; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgForOfContext.prototype, "even", {
            /**
             * @return {?}
             */
            get: function () { return this.index % 2 === 0; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgForOfContext.prototype, "odd", {
            /**
             * @return {?}
             */
            get: function () { return !this.even; },
            enumerable: true,
            configurable: true
        });
        return NgForOfContext;
    }());
    /**
     * A [structural directive](guide/structural-directives) that renders
     * a template for each item in a collection.
     * The directive is placed on an element, which becomes the parent
     * of the cloned templates.
     *
     * The `ngForOf` directive is generally used in the
     * [shorthand form](guide/structural-directives#the-asterisk--prefix) `*ngFor`.
     * In this form, the template to be rendered for each iteration is the content
     * of an anchor element containing the directive.
     *
     * The following example shows the shorthand syntax with some options,
     * contained in an `<li>` element.
     *
     * ```
     * <li *ngFor="let item of items; index as i; trackBy: trackByFn">...</li>
     * ```
     *
     * The shorthand form expands into a long form that uses the `ngForOf` selector
     * on an `<ng-template>` element.
     * The content of the `<ng-template>` element is the `<li>` element that held the
     * short-form directive.
     *
     * Here is the expanded version of the short-form example.
     *
     * ```
     * <ng-template ngFor let-item [ngForOf]="items" let-i="index" [ngForTrackBy]="trackByFn">
     *   <li>...</li>
     * </ng-template>
     * ```
     *
     * Angular automatically expands the shorthand syntax as it compiles the template.
     * The context for each embedded view is logically merged to the current component
     * context according to its lexical position.
     *
     * When using the shorthand syntax, Angular allows only [one structural directive
     * on an element](guide/structural-directives#one-structural-directive-per-host-element).
     * If you want to iterate conditionally, for example,
     * put the `*ngIf` on a container element that wraps the `*ngFor` element.
     * For futher discussion, see
     * [Structural Directives](guide/structural-directives#one-per-element).
     *
     * \@usageNotes
     *
     * ### Local variables
     *
     * `NgForOf` provides exported values that can be aliased to local variables.
     * For example:
     *
     *  ```
     * <li *ngFor="let user of userObservable | async as users; index as i; first as isFirst">
     *    {{i}}/{{users.length}}. {{user}} <span *ngIf="isFirst">default</span>
     * </li>
     * ```
     *
     * The following exported values can be aliased to local variables:
     *
     * - `$implicit: T`: The value of the individual items in the iterable (`ngForOf`).
     * - `ngForOf: NgIterable<T>`: The value of the iterable expression. Useful when the expression is
     * more complex then a property access, for example when using the async pipe (`userStreams |
     * async`).
     * - `index: number`: The index of the current item in the iterable.
     * - `first: boolean`: True when the item is the first item in the iterable.
     * - `last: boolean`: True when the item is the last item in the iterable.
     * - `even: boolean`: True when the item has an even index in the iterable.
     * - `odd: boolean`: True when the item has an odd index in the iterable.
     *
     * ### Change propagation
     *
     * When the contents of the iterator changes, `NgForOf` makes the corresponding changes to the DOM:
     *
     * * When an item is added, a new instance of the template is added to the DOM.
     * * When an item is removed, its template instance is removed from the DOM.
     * * When items are reordered, their respective templates are reordered in the DOM.
     *
     * Angular uses object identity to track insertions and deletions within the iterator and reproduce
     * those changes in the DOM. This has important implications for animations and any stateful
     * controls that are present, such as `<input>` elements that accept user input. Inserted rows can
     * be animated in, deleted rows can be animated out, and unchanged rows retain any unsaved state
     * such as user input.
     * For more on animations, see [Transitions and Triggers](guide/transition-and-triggers).
     *
     * The identities of elements in the iterator can change while the data does not.
     * This can happen, for example, if the iterator is produced from an RPC to the server, and that
     * RPC is re-run. Even if the data hasn't changed, the second response produces objects with
     * different identities, and Angular must tear down the entire DOM and rebuild it (as if all old
     * elements were deleted and all new elements inserted).
     *
     * To avoid this expensive operation, you can customize the default tracking algorithm.
     * by supplying the `trackBy` option to `NgForOf`.
     * `trackBy` takes a function that has two arguments: `index` and `item`.
     * If `trackBy` is given, Angular tracks changes by the return value of the function.
     *
     * @see [Structural Directives](guide/structural-directives)
     * \@ngModule CommonModule
     * \@publicApi
     * @template T
     */
    var NgForOf = /** @class */ (function () {
        /**
         * @param {?} _viewContainer
         * @param {?} _template
         * @param {?} _differs
         */
        function NgForOf(_viewContainer, _template, _differs) {
            this._viewContainer = _viewContainer;
            this._template = _template;
            this._differs = _differs;
            this._ngForOfDirty = true;
            this._differ = null;
        }
        Object.defineProperty(NgForOf.prototype, "ngForOf", {
            /**
             * The value of the iterable expression, which can be used as a
             * [template input variable](guide/structural-directives#template-input-variable).
             * @param {?} ngForOf
             * @return {?}
             */
            set: function (ngForOf) {
                this._ngForOf = ngForOf;
                this._ngForOfDirty = true;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgForOf.prototype, "ngForTrackBy", {
            /**
             * @return {?}
             */
            get: function () { return this._trackByFn; },
            /**
             * A function that defines how to track changes for items in the iterable.
             *
             * When items are added, moved, or removed in the iterable,
             * the directive must re-render the appropriate DOM nodes.
             * To minimize churn in the DOM, only nodes that have changed
             * are re-rendered.
             *
             * By default, the change detector assumes that
             * the object instance identifies the node in the iterable.
             * When this function is supplied, the directive uses
             * the result of calling this function to identify the item node,
             * rather than the identity of the object itself.
             *
             * The function receives two inputs,
             * the iteration index and the node object ID.
             * @param {?} fn
             * @return {?}
             */
            set: function (fn) {
                if (isDevMode() && fn != null && typeof fn !== 'function') {
                    // TODO(vicb): use a log service once there is a public one available
                    if (( /** @type {?} */(console)) && ( /** @type {?} */(console.warn))) {
                        console.warn("trackBy must be a function, but received " + JSON.stringify(fn) + ". " +
                            "See https://angular.io/docs/ts/latest/api/common/index/NgFor-directive.html#!#change-propagation for more information.");
                    }
                }
                this._trackByFn = fn;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgForOf.prototype, "ngForTemplate", {
            /**
             * A reference to the template that is stamped out for each item in the iterable.
             * @see [template reference variable](guide/template-syntax#template-reference-variables--var-)
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                // TODO(TS2.1): make TemplateRef<Partial<NgForRowOf<T>>> once we move to TS v2.1
                // The current type is too restrictive; a template that just uses index, for example,
                // should be acceptable.
                if (value) {
                    this._template = value;
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Applies the changes when needed.
         * @return {?}
         */
        NgForOf.prototype.ngDoCheck = function () {
            if (this._ngForOfDirty) {
                this._ngForOfDirty = false;
                // React on ngForOf changes only once all inputs have been initialized
                /** @type {?} */
                var value = this._ngForOf;
                if (!this._differ && value) {
                    try {
                        this._differ = this._differs.find(value).create(this.ngForTrackBy);
                    }
                    catch (_a) {
                        throw new Error("Cannot find a differ supporting object '" + value + "' of type '" + getTypeName(value) + "'. NgFor only supports binding to Iterables such as Arrays.");
                    }
                }
            }
            if (this._differ) {
                /** @type {?} */
                var changes = this._differ.diff(this._ngForOf);
                if (changes)
                    this._applyChanges(changes);
            }
        };
        /**
         * @private
         * @param {?} changes
         * @return {?}
         */
        NgForOf.prototype._applyChanges = function (changes) {
            var _this = this;
            /** @type {?} */
            var insertTuples = [];
            changes.forEachOperation(( /**
             * @param {?} item
             * @param {?} adjustedPreviousIndex
             * @param {?} currentIndex
             * @return {?}
             */function (item, adjustedPreviousIndex, currentIndex) {
                if (item.previousIndex == null) {
                    /** @type {?} */
                    var view = _this._viewContainer.createEmbeddedView(_this._template, new NgForOfContext(( /** @type {?} */(null)), _this._ngForOf, -1, -1), currentIndex === null ? undefined : currentIndex);
                    /** @type {?} */
                    var tuple = new RecordViewTuple(item, view);
                    insertTuples.push(tuple);
                }
                else if (currentIndex == null) {
                    _this._viewContainer.remove(adjustedPreviousIndex === null ? undefined : adjustedPreviousIndex);
                }
                else if (adjustedPreviousIndex !== null) {
                    /** @type {?} */
                    var view = ( /** @type {?} */(_this._viewContainer.get(adjustedPreviousIndex)));
                    _this._viewContainer.move(view, currentIndex);
                    /** @type {?} */
                    var tuple = new RecordViewTuple(item, ( /** @type {?} */(view)));
                    insertTuples.push(tuple);
                }
            }));
            for (var i_117 = 0; i_117 < insertTuples.length; i_117++) {
                this._perViewChange(insertTuples[i_117].view, insertTuples[i_117].record);
            }
            for (var i_118 = 0, ilen = this._viewContainer.length; i_118 < ilen; i_118++) {
                /** @type {?} */
                var viewRef = ( /** @type {?} */(this._viewContainer.get(i_118)));
                viewRef.context.index = i_118;
                viewRef.context.count = ilen;
                viewRef.context.ngForOf = this._ngForOf;
            }
            changes.forEachIdentityChange(( /**
             * @param {?} record
             * @return {?}
             */function (record) {
                /** @type {?} */
                var viewRef = ( /** @type {?} */(_this._viewContainer.get(record.currentIndex)));
                viewRef.context.$implicit = record.item;
            }));
        };
        /**
         * @private
         * @param {?} view
         * @param {?} record
         * @return {?}
         */
        NgForOf.prototype._perViewChange = function (view, record) {
            view.context.$implicit = record.item;
        };
        /**
         * Asserts the correct type of the context for the template that `NgForOf` will render.
         *
         * The presence of this method is a signal to the Ivy template type-check compiler that the
         * `NgForOf` structural directive renders its template with a specific context type.
         * @template T
         * @param {?} dir
         * @param {?} ctx
         * @return {?}
         */
        NgForOf.ngTemplateContextGuard = function (dir, ctx) {
            return true;
        };
        return NgForOf;
    }());
    NgForOf.decorators = [
        { type: Directive, args: [{ selector: '[ngFor][ngForOf]' },] }
    ];
    /** @nocollapse */
    NgForOf.ctorParameters = function () { return [
        { type: ViewContainerRef },
        { type: TemplateRef },
        { type: IterableDiffers }
    ]; };
    NgForOf.propDecorators = {
        ngForOf: [{ type: Input }],
        ngForTrackBy: [{ type: Input }],
        ngForTemplate: [{ type: Input }]
    };
    /**
     * @template T
     */
    var RecordViewTuple = /** @class */ (function () {
        /**
         * @param {?} record
         * @param {?} view
         */
        function RecordViewTuple(record, view) {
            this.record = record;
            this.view = view;
        }
        return RecordViewTuple;
    }());
    /**
     * @param {?} type
     * @return {?}
     */
    function getTypeName(type) {
        return type['name'] || typeof type;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A structural directive that conditionally includes a template based on the value of
     * an expression coerced to Boolean.
     * When the expression evaluates to true, Angular renders the template
     * provided in a `then` clause, and when  false or null,
     * Angular renders the template provided in an optional `else` clause. The default
     * template for the `else` clause is blank.
     *
     * A [shorthand form](guide/structural-directives#the-asterisk--prefix) of the directive,
     * `*ngIf="condition"`, is generally used, provided
     * as an attribute of the anchor element for the inserted template.
     * Angular expands this into a more explicit version, in which the anchor element
     * is contained in an `<ng-template>` element.
     *
     * Simple form with shorthand syntax:
     *
     * ```
     * <div *ngIf="condition">Content to render when condition is true.</div>
     * ```
     *
     * Simple form with expanded syntax:
     *
     * ```
     * <ng-template [ngIf]="condition"><div>Content to render when condition is
     * true.</div></ng-template>
     * ```
     *
     * Form with an "else" block:
     *
     * ```
     * <div *ngIf="condition; else elseBlock">Content to render when condition is true.</div>
     * <ng-template #elseBlock>Content to render when condition is false.</ng-template>
     * ```
     *
     * Shorthand form with "then" and "else" blocks:
     *
     * ```
     * <div *ngIf="condition; then thenBlock else elseBlock"></div>
     * <ng-template #thenBlock>Content to render when condition is true.</ng-template>
     * <ng-template #elseBlock>Content to render when condition is false.</ng-template>
     * ```
     *
     * Form with storing the value locally:
     *
     * ```
     * <div *ngIf="condition as value; else elseBlock">{{value}}</div>
     * <ng-template #elseBlock>Content to render when value is null.</ng-template>
     * ```
     *
     * \@usageNotes
     *
     * The `*ngIf` directive is most commonly used to conditionally show an inline template,
     * as seen in the following  example.
     * The default `else` template is blank.
     *
     * {\@example common/ngIf/ts/module.ts region='NgIfSimple'}
     *
     * ### Showing an alternative template using `else`
     *
     * To display a template when `expression` evaluates to false, use an `else` template
     * binding as shown in the following example.
     * The `else` binding points to an `<ng-template>`  element labeled `#elseBlock`.
     * The template can be defined anywhere in the component view, but is typically placed right after
     * `ngIf` for readability.
     *
     * {\@example common/ngIf/ts/module.ts region='NgIfElse'}
     *
     * ### Using an external `then` template
     *
     * In the previous example, the then-clause template is specified inline, as the content of the
     * tag that contains the `ngIf` directive. You can also specify a template that is defined
     * externally, by referencing a labeled `<ng-template>` element. When you do this, you can
     * change which template to use at runtime, as shown in the following example.
     *
     * {\@example common/ngIf/ts/module.ts region='NgIfThenElse'}
     *
     * ### Storing a conditional result in a variable
     *
     * You might want to show a set of properties from the same object. If you are waiting
     * for asynchronous data, the object can be undefined.
     * In this case, you can use `ngIf` and store the result of the condition in a local
     * variable as shown in the the following example.
     *
     * {\@example common/ngIf/ts/module.ts region='NgIfAs'}
     *
     * This code uses only one `AsyncPipe`, so only one subscription is created.
     * The conditional statement stores the result of `userStream|async` in the local variable `user`.
     * You can then bind the local `user` repeatedly.
     *
     * The conditional displays the data only if `userStream` returns a value,
     * so you don't need to use the
     * [safe-navigation-operator](guide/template-syntax#safe-navigation-operator) (`?.`)
     * to guard against null values when accessing properties.
     * You can display an alternative template while waiting for the data.
     *
     * ### Shorthand syntax
     *
     * The shorthand syntax `*ngIf` expands into two separate template specifications
     * for the "then" and "else" clauses. For example, consider the following shorthand statement,
     * that is meant to show a loading page while waiting for data to be loaded.
     *
     * ```
     * <div class="hero-list" *ngIf="heroes else loading">
     *  ...
     * </div>
     *
     * <ng-template #loading>
     *  <div>Loading...</div>
     * </ng-template>
     * ```
     *
     * You can see that the "else" clause references the `<ng-template>`
     * with the `#loading` label, and the template for the "then" clause
     * is provided as the content of the anchor element.
     *
     * However, when Angular expands the shorthand syntax, it creates
     * another `<ng-template>` tag, with `ngIf` and `ngIfElse` directives.
     * The anchor element containing the template for the "then" clause becomes
     * the content of this unlabeled `<ng-template>` tag.
     *
     * ```
     * <ng-template [ngIf]="hero-list" [ngIfElse]="loading">
     *  <div class="hero-list">
     *   ...
     *  </div>
     * </ng-template>
     *
     * <ng-template #loading>
     *  <div>Loading...</div>
     * </ng-template>
     * ```
     *
     * The presence of the implicit template object has implications for the nesting of
     * structural directives. For more on this subject, see
     * [Structural Directives](https://angular.io/guide/structural-directives#one-per-element).
     *
     * \@ngModule CommonModule
     * \@publicApi
     */
    var NgIf = /** @class */ (function () {
        /**
         * @param {?} _viewContainer
         * @param {?} templateRef
         */
        function NgIf(_viewContainer, templateRef) {
            this._viewContainer = _viewContainer;
            this._context = new NgIfContext();
            this._thenTemplateRef = null;
            this._elseTemplateRef = null;
            this._thenViewRef = null;
            this._elseViewRef = null;
            this._thenTemplateRef = templateRef;
        }
        Object.defineProperty(NgIf.prototype, "ngIf", {
            /**
             * The Boolean expression to evaluate as the condition for showing a template.
             * @param {?} condition
             * @return {?}
             */
            set: function (condition) {
                this._context.$implicit = this._context.ngIf = condition;
                this._updateView();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgIf.prototype, "ngIfThen", {
            /**
             * A template to show if the condition expression evaluates to true.
             * @param {?} templateRef
             * @return {?}
             */
            set: function (templateRef) {
                assertTemplate('ngIfThen', templateRef);
                this._thenTemplateRef = templateRef;
                this._thenViewRef = null; // clear previous view if any.
                this._updateView();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgIf.prototype, "ngIfElse", {
            /**
             * A template to show if the condition expression evaluates to false.
             * @param {?} templateRef
             * @return {?}
             */
            set: function (templateRef) {
                assertTemplate('ngIfElse', templateRef);
                this._elseTemplateRef = templateRef;
                this._elseViewRef = null; // clear previous view if any.
                this._updateView();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @private
         * @return {?}
         */
        NgIf.prototype._updateView = function () {
            if (this._context.$implicit) {
                if (!this._thenViewRef) {
                    this._viewContainer.clear();
                    this._elseViewRef = null;
                    if (this._thenTemplateRef) {
                        this._thenViewRef =
                            this._viewContainer.createEmbeddedView(this._thenTemplateRef, this._context);
                    }
                }
            }
            else {
                if (!this._elseViewRef) {
                    this._viewContainer.clear();
                    this._thenViewRef = null;
                    if (this._elseTemplateRef) {
                        this._elseViewRef =
                            this._viewContainer.createEmbeddedView(this._elseTemplateRef, this._context);
                    }
                }
            }
        };
        return NgIf;
    }());
    NgIf.decorators = [
        { type: Directive, args: [{ selector: '[ngIf]' },] }
    ];
    /** @nocollapse */
    NgIf.ctorParameters = function () { return [
        { type: ViewContainerRef },
        { type: TemplateRef }
    ]; };
    NgIf.propDecorators = {
        ngIf: [{ type: Input }],
        ngIfThen: [{ type: Input }],
        ngIfElse: [{ type: Input }]
    };
    /**
     * \@publicApi
     */
    var NgIfContext = /** @class */ (function () {
        function NgIfContext() {
            this.$implicit = null;
            this.ngIf = null;
        }
        return NgIfContext;
    }());
    /**
     * @param {?} property
     * @param {?} templateRef
     * @return {?}
     */
    function assertTemplate(property, templateRef) {
        /** @type {?} */
        var isTemplateRefOrNull = !!(!templateRef || templateRef.createEmbeddedView);
        if (!isTemplateRefOrNull) {
            throw new Error(property + " must be a TemplateRef, but received '" + stringify(templateRef) + "'.");
        }
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SwitchView = /** @class */ (function () {
        /**
         * @param {?} _viewContainerRef
         * @param {?} _templateRef
         */
        function SwitchView(_viewContainerRef, _templateRef) {
            this._viewContainerRef = _viewContainerRef;
            this._templateRef = _templateRef;
            this._created = false;
        }
        /**
         * @return {?}
         */
        SwitchView.prototype.create = function () {
            this._created = true;
            this._viewContainerRef.createEmbeddedView(this._templateRef);
        };
        /**
         * @return {?}
         */
        SwitchView.prototype.destroy = function () {
            this._created = false;
            this._viewContainerRef.clear();
        };
        /**
         * @param {?} created
         * @return {?}
         */
        SwitchView.prototype.enforceState = function (created) {
            if (created && !this._created) {
                this.create();
            }
            else if (!created && this._created) {
                this.destroy();
            }
        };
        return SwitchView;
    }());
    /**
     * \@ngModule CommonModule
     *
     * \@description A structural directive that adds or removes templates (displaying or hiding views)
     * when the next match expression matches the switch expression.
     *
     * The `[ngSwitch]` directive on a container specifies an expression to match against.
     * The expressions to match are provided by `ngSwitchCase` directives on views within the container.
     * - Every view that matches is rendered.
     * - If there are no matches, a view with the `ngSwitchDefault` directive is rendered.
     * - Elements within the `[NgSwitch]` statement but outside of any `NgSwitchCase`
     * or `ngSwitchDefault` directive are preserved at the location.
     *
     * \@usageNotes
     * Define a container element for the directive, and specify the switch expression
     * to match against as an attribute:
     *
     * ```
     * <container-element [ngSwitch]="switch_expression">
     * ```
     *
     * Within the container, `*ngSwitchCase` statements specify the match expressions
     * as attributes. Include `*ngSwitchDefault` as the final case.
     *
     * ```
     * <container-element [ngSwitch]="switch_expression">
     *    <some-element *ngSwitchCase="match_expression_1">...</some-element>
     * ...
     *    <some-element *ngSwitchDefault>...</some-element>
     * </container-element>
     * ```
     *
     * ### Usage Examples
     *
     * The following example shows how to use more than one case to display the same view:
     *
     * ```
     * <container-element [ngSwitch]="switch_expression">
     *   <!-- the same view can be shown in more than one case -->
     *   <some-element *ngSwitchCase="match_expression_1">...</some-element>
     *   <some-element *ngSwitchCase="match_expression_2">...</some-element>
     *   <some-other-element *ngSwitchCase="match_expression_3">...</some-other-element>
     *   <!--default case when there are no matches -->
     *   <some-element *ngSwitchDefault>...</some-element>
     * </container-element>
     * ```
     *
     * The following example shows how cases can be nested:
     * ```
     * <container-element [ngSwitch]="switch_expression">
     *       <some-element *ngSwitchCase="match_expression_1">...</some-element>
     *       <some-element *ngSwitchCase="match_expression_2">...</some-element>
     *       <some-other-element *ngSwitchCase="match_expression_3">...</some-other-element>
     *       <ng-container *ngSwitchCase="match_expression_3">
     *         <!-- use a ng-container to group multiple root nodes -->
     *         <inner-element></inner-element>
     *         <inner-other-element></inner-other-element>
     *       </ng-container>
     *       <some-element *ngSwitchDefault>...</some-element>
     *     </container-element>
     * ```
     *
     * \@publicApi
     * @see `NgSwitchCase`
     * @see `NgSwitchDefault`
     * @see [Structural Directives](guide/structural-directives)
     *
     */
    var NgSwitch = /** @class */ (function () {
        function NgSwitch() {
            this._defaultUsed = false;
            this._caseCount = 0;
            this._lastCaseCheckIndex = 0;
            this._lastCasesMatched = false;
        }
        Object.defineProperty(NgSwitch.prototype, "ngSwitch", {
            /**
             * @param {?} newValue
             * @return {?}
             */
            set: function (newValue) {
                this._ngSwitch = newValue;
                if (this._caseCount === 0) {
                    this._updateDefaultCases(true);
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * \@internal
         * @return {?}
         */
        NgSwitch.prototype._addCase = function () { return this._caseCount++; };
        /**
         * \@internal
         * @param {?} view
         * @return {?}
         */
        NgSwitch.prototype._addDefault = function (view) {
            if (!this._defaultViews) {
                this._defaultViews = [];
            }
            this._defaultViews.push(view);
        };
        /**
         * \@internal
         * @param {?} value
         * @return {?}
         */
        NgSwitch.prototype._matchCase = function (value) {
            /** @type {?} */
            var matched = value == this._ngSwitch;
            this._lastCasesMatched = this._lastCasesMatched || matched;
            this._lastCaseCheckIndex++;
            if (this._lastCaseCheckIndex === this._caseCount) {
                this._updateDefaultCases(!this._lastCasesMatched);
                this._lastCaseCheckIndex = 0;
                this._lastCasesMatched = false;
            }
            return matched;
        };
        /**
         * @private
         * @param {?} useDefault
         * @return {?}
         */
        NgSwitch.prototype._updateDefaultCases = function (useDefault) {
            if (this._defaultViews && useDefault !== this._defaultUsed) {
                this._defaultUsed = useDefault;
                for (var i_119 = 0; i_119 < this._defaultViews.length; i_119++) {
                    /** @type {?} */
                    var defaultView = this._defaultViews[i_119];
                    defaultView.enforceState(useDefault);
                }
            }
        };
        return NgSwitch;
    }());
    NgSwitch.decorators = [
        { type: Directive, args: [{ selector: '[ngSwitch]' },] }
    ];
    NgSwitch.propDecorators = {
        ngSwitch: [{ type: Input }]
    };
    /**
     * \@ngModule CommonModule
     *
     * \@description
     * Provides a switch case expression to match against an enclosing `ngSwitch` expression.
     * When the expressions match, the given `NgSwitchCase` template is rendered.
     * If multiple match expressions match the switch expression value, all of them are displayed.
     *
     * \@usageNotes
     *
     * Within a switch container, `*ngSwitchCase` statements specify the match expressions
     * as attributes. Include `*ngSwitchDefault` as the final case.
     *
     * ```
     * <container-element [ngSwitch]="switch_expression">
     *   <some-element *ngSwitchCase="match_expression_1">...</some-element>
     *   ...
     *   <some-element *ngSwitchDefault>...</some-element>
     * </container-element>
     * ```
     *
     * Each switch-case statement contains an in-line HTML template or template reference
     * that defines the subtree to be selected if the value of the match expression
     * matches the value of the switch expression.
     *
     * Unlike JavaScript, which uses strict equality, Angular uses loose equality.
     * This means that the empty string, `""` matches 0.
     *
     * \@publicApi
     * @see `NgSwitch`
     * @see `NgSwitchDefault`
     *
     */
    var NgSwitchCase = /** @class */ (function () {
        /**
         * @param {?} viewContainer
         * @param {?} templateRef
         * @param {?} ngSwitch
         */
        function NgSwitchCase(viewContainer, templateRef, ngSwitch) {
            this.ngSwitch = ngSwitch;
            ngSwitch._addCase();
            this._view = new SwitchView(viewContainer, templateRef);
        }
        /**
         * Performs case matching. For internal use only.
         * @return {?}
         */
        NgSwitchCase.prototype.ngDoCheck = function () { this._view.enforceState(this.ngSwitch._matchCase(this.ngSwitchCase)); };
        return NgSwitchCase;
    }());
    NgSwitchCase.decorators = [
        { type: Directive, args: [{ selector: '[ngSwitchCase]' },] }
    ];
    /** @nocollapse */
    NgSwitchCase.ctorParameters = function () { return [
        { type: ViewContainerRef },
        { type: TemplateRef },
        { type: NgSwitch, decorators: [{ type: Host }] }
    ]; };
    NgSwitchCase.propDecorators = {
        ngSwitchCase: [{ type: Input }]
    };
    /**
     * \@ngModule CommonModule
     *
     * \@description
     *
     * Creates a view that is rendered when no `NgSwitchCase` expressions
     * match the `NgSwitch` expression.
     * This statement should be the final case in an `NgSwitch`.
     *
     * \@publicApi
     * @see `NgSwitch`
     * @see `NgSwitchCase`
     *
     */
    var NgSwitchDefault = /** @class */ (function () {
        /**
         * @param {?} viewContainer
         * @param {?} templateRef
         * @param {?} ngSwitch
         */
        function NgSwitchDefault(viewContainer, templateRef, ngSwitch) {
            ngSwitch._addDefault(new SwitchView(viewContainer, templateRef));
        }
        return NgSwitchDefault;
    }());
    NgSwitchDefault.decorators = [
        { type: Directive, args: [{ selector: '[ngSwitchDefault]' },] }
    ];
    /** @nocollapse */
    NgSwitchDefault.ctorParameters = function () { return [
        { type: ViewContainerRef },
        { type: TemplateRef },
        { type: NgSwitch, decorators: [{ type: Host }] }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@ngModule CommonModule
     *
     * \@usageNotes
     * ```
     * <some-element [ngPlural]="value">
     *   <ng-template ngPluralCase="=0">there is nothing</ng-template>
     *   <ng-template ngPluralCase="=1">there is one</ng-template>
     *   <ng-template ngPluralCase="few">there are a few</ng-template>
     * </some-element>
     * ```
     *
     * \@description
     *
     * Adds / removes DOM sub-trees based on a numeric value. Tailored for pluralization.
     *
     * Displays DOM sub-trees that match the switch expression value, or failing that, DOM sub-trees
     * that match the switch expression's pluralization category.
     *
     * To use this directive you must provide a container element that sets the `[ngPlural]` attribute
     * to a switch expression. Inner elements with a `[ngPluralCase]` will display based on their
     * expression:
     * - if `[ngPluralCase]` is set to a value starting with `=`, it will only display if the value
     *   matches the switch expression exactly,
     * - otherwise, the view will be treated as a "category match", and will only display if exact
     *   value matches aren't found and the value maps to its category for the defined locale.
     *
     * See http://cldr.unicode.org/index/cldr-spec/plural-rules
     *
     * \@publicApi
     */
    var NgPlural = /** @class */ (function () {
        /**
         * @param {?} _localization
         */
        function NgPlural(_localization) {
            this._localization = _localization;
            this._caseViews = {};
        }
        Object.defineProperty(NgPlural.prototype, "ngPlural", {
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._switchValue = value;
                this._updateView();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} value
         * @param {?} switchView
         * @return {?}
         */
        NgPlural.prototype.addCase = function (value, switchView) { this._caseViews[value] = switchView; };
        /**
         * @private
         * @return {?}
         */
        NgPlural.prototype._updateView = function () {
            this._clearViews();
            /** @type {?} */
            var cases = Object.keys(this._caseViews);
            /** @type {?} */
            var key = getPluralCategory(this._switchValue, cases, this._localization);
            this._activateView(this._caseViews[key]);
        };
        /**
         * @private
         * @return {?}
         */
        NgPlural.prototype._clearViews = function () {
            if (this._activeView)
                this._activeView.destroy();
        };
        /**
         * @private
         * @param {?} view
         * @return {?}
         */
        NgPlural.prototype._activateView = function (view) {
            if (view) {
                this._activeView = view;
                this._activeView.create();
            }
        };
        return NgPlural;
    }());
    NgPlural.decorators = [
        { type: Directive, args: [{ selector: '[ngPlural]' },] }
    ];
    /** @nocollapse */
    NgPlural.ctorParameters = function () { return [
        { type: NgLocalization }
    ]; };
    NgPlural.propDecorators = {
        ngPlural: [{ type: Input }]
    };
    /**
     * \@ngModule CommonModule
     *
     * \@description
     *
     * Creates a view that will be added/removed from the parent {\@link NgPlural} when the
     * given expression matches the plural expression according to CLDR rules.
     *
     * \@usageNotes
     * ```
     * <some-element [ngPlural]="value">
     *   <ng-template ngPluralCase="=0">...</ng-template>
     *   <ng-template ngPluralCase="other">...</ng-template>
     * </some-element>
     * ```
     *
     * See {\@link NgPlural} for more details and example.
     *
     * \@publicApi
     */
    var NgPluralCase = /** @class */ (function () {
        /**
         * @param {?} value
         * @param {?} template
         * @param {?} viewContainer
         * @param {?} ngPlural
         */
        function NgPluralCase(value, template, viewContainer, ngPlural) {
            this.value = value;
            /** @type {?} */
            var isANumber = !isNaN(Number(value));
            ngPlural.addCase(isANumber ? "=" + value : value, new SwitchView(viewContainer, template));
        }
        return NgPluralCase;
    }());
    NgPluralCase.decorators = [
        { type: Directive, args: [{ selector: '[ngPluralCase]' },] }
    ];
    /** @nocollapse */
    NgPluralCase.ctorParameters = function () { return [
        { type: String, decorators: [{ type: Attribute, args: ['ngPluralCase',] }] },
        { type: TemplateRef },
        { type: ViewContainerRef },
        { type: NgPlural, decorators: [{ type: Host }] }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Used as a token for an injected service within the NgStyle directive.
     *
     * NgStyle behaves differenly whether or not VE is being used or not. If
     * present then the legacy ngClass diffing algorithm will be used as an
     * injected service. Otherwise the new diffing algorithm (which delegates
     * to the `[style]` binding) will be used. This toggle behavior is done so
     * via the ivy_switch mechanism.
     * @abstract
     */
    var NgStyleImpl = /** @class */ (function () {
        function NgStyleImpl() {
        }
        return NgStyleImpl;
    }());
    var NgStyleR2Impl = /** @class */ (function () {
        /**
         * @param {?} _ngEl
         * @param {?} _differs
         * @param {?} _renderer
         */
        function NgStyleR2Impl(_ngEl, _differs, _renderer) {
            this._ngEl = _ngEl;
            this._differs = _differs;
            this._renderer = _renderer;
        }
        /**
         * @return {?}
         */
        NgStyleR2Impl.prototype.getValue = function () { return null; };
        /**
         * A map of style properties, specified as colon-separated
         * key-value pairs.
         * * The key is a style name, with an optional `.<unit>` suffix
         *    (such as 'top.px', 'font-style.em').
         * * The value is an expression to be evaluated.
         * @param {?} values
         * @return {?}
         */
        NgStyleR2Impl.prototype.setNgStyle = function (values) {
            this._ngStyle = values;
            if (!this._differ && values) {
                this._differ = this._differs.find(values).create();
            }
        };
        /**
         * Applies the new styles if needed.
         * @return {?}
         */
        NgStyleR2Impl.prototype.applyChanges = function () {
            if (this._differ) {
                /** @type {?} */
                var changes = this._differ.diff(this._ngStyle);
                if (changes) {
                    this._applyChanges(changes);
                }
            }
        };
        /**
         * @private
         * @param {?} changes
         * @return {?}
         */
        NgStyleR2Impl.prototype._applyChanges = function (changes) {
            var _this = this;
            changes.forEachRemovedItem(( /**
             * @param {?} record
             * @return {?}
             */function (record) { return _this._setStyle(record.key, null); }));
            changes.forEachAddedItem(( /**
             * @param {?} record
             * @return {?}
             */function (record) { return _this._setStyle(record.key, record.currentValue); }));
            changes.forEachChangedItem(( /**
             * @param {?} record
             * @return {?}
             */function (record) { return _this._setStyle(record.key, record.currentValue); }));
        };
        /**
         * @private
         * @param {?} nameAndUnit
         * @param {?} value
         * @return {?}
         */
        NgStyleR2Impl.prototype._setStyle = function (nameAndUnit, value) {
            var _b = __read(nameAndUnit.split('.'), 2), name = _b[0], unit = _b[1];
            value = value != null && unit ? "" + value + unit : value;
            if (value != null) {
                this._renderer.setStyle(this._ngEl.nativeElement, name, ( /** @type {?} */(value)));
            }
            else {
                this._renderer.removeStyle(this._ngEl.nativeElement, name);
            }
        };
        return NgStyleR2Impl;
    }());
    NgStyleR2Impl.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    NgStyleR2Impl.ctorParameters = function () { return [
        { type: ElementRef },
        { type: KeyValueDiffers },
        { type: Renderer2 }
    ]; };
    // the implementation for both NgClassR2Impl and NgClassR3Impl are
    // not ivy_switch'd away, instead they are only hooked up into the
    // DI via NgStyle's directive's provider property.
    /** @type {?} */
    var NgStyleImplProvider__PRE_R3__ = {
        provide: NgStyleImpl,
        useClass: NgStyleR2Impl
    };
    /** @type {?} */
    var NgStyleImplProvider = NgStyleImplProvider__PRE_R3__;
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /*
     * NgStyle (as well as NgClass) behaves differently when loaded in the VE and when not.
     *
     * If the VE is present (which is for older versions of Angular) then NgStyle will inject
     * the legacy diffing algorithm as a service and delegate all styling changes to that.
     *
     * If the VE is not present then NgStyle will normalize (through the injected service) and
     * then write all styling changes to the `[style]` binding directly (through a host binding).
     * Then Angular will notice the host binding change and treat the changes as styling
     * changes and apply them via the core styling instructions that exist within Angular.
     */
    // used when the VE is present
    /** @type {?} */
    var ngStyleDirectiveDef__PRE_R3__ = undefined;
    // used when the VE is not present (note the directive will
    // never be instantiated normally because it is apart of a
    // base class)
    var ɵ0$1$1 = /**
     * @return {?}
     */ function () { }, ɵ1$1$1 = /**
     * @return {?}
     */ function () { }, ɵ2$1$1 = /**
     * @param {?} rf
     * @param {?} ctx
     * @param {?} elIndex
     * @return {?}
     */ function (rf, ctx, elIndex) {
        if (rf & 1 /* Create */) {
            ɵɵstyling();
        }
        if (rf & 2 /* Update */) {
            ɵɵstyleMap(ctx.getValue());
            ɵɵstylingApply();
        }
    };
    /** @type {?} */
    var ngStyleDirectiveDef__POST_R3__ = ɵɵdefineDirective({
        type: ( /** @type {?} */((ɵ0$1$1))),
        selectors: ( /** @type {?} */(null)),
        factory: (ɵ1$1$1),
        hostBindings: (ɵ2$1$1)
    });
    /** @type {?} */
    var ngStyleDirectiveDef = ngStyleDirectiveDef__PRE_R3__;
    /**
     * Serves as the base non-VE container for NgStyle.
     *
     * While this is a base class that NgStyle extends from, the
     * class itself acts as a container for non-VE code to setup
     * a link to the `[style]` host binding (via the static
     * `ngDirectiveDef` property on the class).
     *
     * Note that the `ngDirectiveDef` property's code is switched
     * depending if VE is present or not (this allows for the
     * binding code to be set only for newer versions of Angular).
     *
     * \@publicApi
     */
    var NgStyleBase = /** @class */ (function () {
        /**
         * @param {?} _delegate
         */
        function NgStyleBase(_delegate) {
            this._delegate = _delegate;
        }
        /**
         * @return {?}
         */
        NgStyleBase.prototype.getValue = function () { return this._delegate.getValue(); };
        return NgStyleBase;
    }());
    /** @nocollapse */ NgStyleBase.ngDirectiveDef = ngStyleDirectiveDef;
    /**
     * \@ngModule CommonModule
     *
     * \@usageNotes
     *
     * Set the font of the containing element to the result of an expression.
     *
     * ```
     * <some-element [ngStyle]="{'font-style': styleExp}">...</some-element>
     * ```
     *
     * Set the width of the containing element to a pixel value returned by an expression.
     *
     * ```
     * <some-element [ngStyle]="{'max-width.px': widthExp}">...</some-element>
     * ```
     *
     * Set a collection of style values using an expression that returns key-value pairs.
     *
     * ```
     * <some-element [ngStyle]="objExp">...</some-element>
     * ```
     *
     * \@description
     *
     * An attribute directive that updates styles for the containing HTML element.
     * Sets one or more style properties, specified as colon-separated key-value pairs.
     * The key is a style name, with an optional `.<unit>` suffix
     * (such as 'top.px', 'font-style.em').
     * The value is an expression to be evaluated.
     * The resulting non-null value, expressed in the given unit,
     * is assigned to the given style property.
     * If the result of evaluation is null, the corresponding style is removed.
     *
     * \@publicApi
     */
    var NgStyle = /** @class */ (function (_super) {
        __extends(NgStyle, _super);
        /**
         * @param {?} delegate
         */
        function NgStyle(delegate) {
            return _super.call(this, delegate) || this;
        }
        Object.defineProperty(NgStyle.prototype, "ngStyle", {
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this._delegate.setNgStyle(value); },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        NgStyle.prototype.ngDoCheck = function () { this._delegate.applyChanges(); };
        return NgStyle;
    }(NgStyleBase));
    NgStyle.decorators = [
        { type: Directive, args: [{ selector: '[ngStyle]', providers: [NgStyleImplProvider] },] }
    ];
    /** @nocollapse */
    NgStyle.ctorParameters = function () { return [
        { type: NgStyleImpl }
    ]; };
    NgStyle.propDecorators = {
        ngStyle: [{ type: Input, args: ['ngStyle',] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@ngModule CommonModule
     *
     * \@description
     *
     * Inserts an embedded view from a prepared `TemplateRef`.
     *
     * You can attach a context object to the `EmbeddedViewRef` by setting `[ngTemplateOutletContext]`.
     * `[ngTemplateOutletContext]` should be an object, the object's keys will be available for binding
     * by the local template `let` declarations.
     *
     * \@usageNotes
     * ```
     * <ng-container *ngTemplateOutlet="templateRefExp; context: contextExp"></ng-container>
     * ```
     *
     * Using the key `$implicit` in the context object will set its value as default.
     *
     * ### Example
     *
     * {\@example common/ngTemplateOutlet/ts/module.ts region='NgTemplateOutlet'}
     *
     * \@publicApi
     */
    var NgTemplateOutlet = /** @class */ (function () {
        /**
         * @param {?} _viewContainerRef
         */
        function NgTemplateOutlet(_viewContainerRef) {
            this._viewContainerRef = _viewContainerRef;
            this._viewRef = null;
            /**
             * A context object to attach to the {\@link EmbeddedViewRef}. This should be an
             * object, the object's keys will be available for binding by the local template `let`
             * declarations.
             * Using the key `$implicit` in the context object will set its value as default.
             */
            this.ngTemplateOutletContext = null;
            /**
             * A string defining the template reference and optionally the context object for the template.
             */
            this.ngTemplateOutlet = null;
        }
        /**
         * @param {?} changes
         * @return {?}
         */
        NgTemplateOutlet.prototype.ngOnChanges = function (changes) {
            /** @type {?} */
            var recreateView = this._shouldRecreateView(changes);
            if (recreateView) {
                if (this._viewRef) {
                    this._viewContainerRef.remove(this._viewContainerRef.indexOf(this._viewRef));
                }
                if (this.ngTemplateOutlet) {
                    this._viewRef = this._viewContainerRef.createEmbeddedView(this.ngTemplateOutlet, this.ngTemplateOutletContext);
                }
            }
            else {
                if (this._viewRef && this.ngTemplateOutletContext) {
                    this._updateExistingContext(this.ngTemplateOutletContext);
                }
            }
        };
        /**
         * We need to re-create existing embedded view if:
         * - templateRef has changed
         * - context has changes
         *
         * We mark context object as changed when the corresponding object
         * shape changes (new properties are added or existing properties are removed).
         * In other words we consider context with the same properties as "the same" even
         * if object reference changes (see https://github.com/angular/angular/issues/13407).
         * @private
         * @param {?} changes
         * @return {?}
         */
        NgTemplateOutlet.prototype._shouldRecreateView = function (changes) {
            /** @type {?} */
            var ctxChange = changes['ngTemplateOutletContext'];
            return !!changes['ngTemplateOutlet'] || (ctxChange && this._hasContextShapeChanged(ctxChange));
        };
        /**
         * @private
         * @param {?} ctxChange
         * @return {?}
         */
        NgTemplateOutlet.prototype._hasContextShapeChanged = function (ctxChange) {
            var e_6, _b;
            /** @type {?} */
            var prevCtxKeys = Object.keys(ctxChange.previousValue || {});
            /** @type {?} */
            var currCtxKeys = Object.keys(ctxChange.currentValue || {});
            if (prevCtxKeys.length === currCtxKeys.length) {
                try {
                    for (var currCtxKeys_1 = __values(currCtxKeys), currCtxKeys_1_1 = currCtxKeys_1.next(); !currCtxKeys_1_1.done; currCtxKeys_1_1 = currCtxKeys_1.next()) {
                        var propName = currCtxKeys_1_1.value;
                        if (prevCtxKeys.indexOf(propName) === -1) {
                            return true;
                        }
                    }
                }
                catch (e_6_1) { e_6 = { error: e_6_1 }; }
                finally {
                    try {
                        if (currCtxKeys_1_1 && !currCtxKeys_1_1.done && (_b = currCtxKeys_1.return)) _b.call(currCtxKeys_1);
                    }
                    finally { if (e_6) throw e_6.error; }
                }
                return false;
            }
            else {
                return true;
            }
        };
        /**
         * @private
         * @param {?} ctx
         * @return {?}
         */
        NgTemplateOutlet.prototype._updateExistingContext = function (ctx) {
            var e_7, _b;
            try {
                for (var _c = __values(Object.keys(ctx)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var propName = _d.value;
                    (( /** @type {?} */(( /** @type {?} */(this._viewRef)).context)))[propName] = (( /** @type {?} */(this.ngTemplateOutletContext)))[propName];
                }
            }
            catch (e_7_1) { e_7 = { error: e_7_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
                }
                finally { if (e_7) throw e_7.error; }
            }
        };
        return NgTemplateOutlet;
    }());
    NgTemplateOutlet.decorators = [
        { type: Directive, args: [{ selector: '[ngTemplateOutlet]' },] }
    ];
    /** @nocollapse */
    NgTemplateOutlet.ctorParameters = function () { return [
        { type: ViewContainerRef }
    ]; };
    NgTemplateOutlet.propDecorators = {
        ngTemplateOutletContext: [{ type: Input }],
        ngTemplateOutlet: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A collection of Angular directives that are likely to be used in each and every Angular
     * application.
     * @type {?}
     */
    var COMMON_DIRECTIVES = [
        NgClass,
        NgComponentOutlet,
        NgForOf,
        NgIf,
        NgTemplateOutlet,
        NgStyle,
        NgSwitch,
        NgSwitchCase,
        NgSwitchDefault,
        NgPlural,
        NgPluralCase,
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} type
     * @param {?} value
     * @return {?}
     */
    function invalidPipeArgumentError(type, value) {
        return Error("InvalidPipeArgument: '" + value + "' for pipe '" + stringify(type) + "'");
    }
    /** @type {?} */
    var PATTERN_ALIASES = {
        // Keys are quoted so they do not get renamed during closure compilation.
        'yMMMdjms': datePartGetterFactory(combine([
            digitCondition('year', 1),
            nameCondition('month', 3),
            digitCondition('day', 1),
            digitCondition('hour', 1),
            digitCondition('minute', 1),
            digitCondition('second', 1),
        ])),
        'yMdjm': datePartGetterFactory(combine([
            digitCondition('year', 1), digitCondition('month', 1), digitCondition('day', 1),
            digitCondition('hour', 1), digitCondition('minute', 1)
        ])),
        'yMMMMEEEEd': datePartGetterFactory(combine([
            digitCondition('year', 1), nameCondition('month', 4), nameCondition('weekday', 4),
            digitCondition('day', 1)
        ])),
        'yMMMMd': datePartGetterFactory(combine([digitCondition('year', 1), nameCondition('month', 4), digitCondition('day', 1)])),
        'yMMMd': datePartGetterFactory(combine([digitCondition('year', 1), nameCondition('month', 3), digitCondition('day', 1)])),
        'yMd': datePartGetterFactory(combine([digitCondition('year', 1), digitCondition('month', 1), digitCondition('day', 1)])),
        'jms': datePartGetterFactory(combine([digitCondition('hour', 1), digitCondition('second', 1), digitCondition('minute', 1)])),
        'jm': datePartGetterFactory(combine([digitCondition('hour', 1), digitCondition('minute', 1)]))
    };
    /** @type {?} */
    var DATE_FORMATS$1 = {
        // Keys are quoted so they do not get renamed.
        'yyyy': datePartGetterFactory(digitCondition('year', 4)),
        'yy': datePartGetterFactory(digitCondition('year', 2)),
        'y': datePartGetterFactory(digitCondition('year', 1)),
        'MMMM': datePartGetterFactory(nameCondition('month', 4)),
        'MMM': datePartGetterFactory(nameCondition('month', 3)),
        'MM': datePartGetterFactory(digitCondition('month', 2)),
        'M': datePartGetterFactory(digitCondition('month', 1)),
        'LLLL': datePartGetterFactory(nameCondition('month', 4)),
        'L': datePartGetterFactory(nameCondition('month', 1)),
        'dd': datePartGetterFactory(digitCondition('day', 2)),
        'd': datePartGetterFactory(digitCondition('day', 1)),
        'HH': digitModifier(hourExtractor(datePartGetterFactory(hour12Modify(digitCondition('hour', 2), false)))),
        'H': hourExtractor(datePartGetterFactory(hour12Modify(digitCondition('hour', 1), false))),
        'hh': digitModifier(hourExtractor(datePartGetterFactory(hour12Modify(digitCondition('hour', 2), true)))),
        'h': hourExtractor(datePartGetterFactory(hour12Modify(digitCondition('hour', 1), true))),
        'jj': datePartGetterFactory(digitCondition('hour', 2)),
        'j': datePartGetterFactory(digitCondition('hour', 1)),
        'mm': digitModifier(datePartGetterFactory(digitCondition('minute', 2))),
        'm': datePartGetterFactory(digitCondition('minute', 1)),
        'ss': digitModifier(datePartGetterFactory(digitCondition('second', 2))),
        's': datePartGetterFactory(digitCondition('second', 1)),
        // while ISO 8601 requires fractions to be prefixed with `.` or `,`
        // we can be just safely rely on using `sss` since we currently don't support single or two digit
        // fractions
        'sss': datePartGetterFactory(digitCondition('second', 3)),
        'EEEE': datePartGetterFactory(nameCondition('weekday', 4)),
        'EEE': datePartGetterFactory(nameCondition('weekday', 3)),
        'EE': datePartGetterFactory(nameCondition('weekday', 2)),
        'E': datePartGetterFactory(nameCondition('weekday', 1)),
        'a': hourClockExtractor(datePartGetterFactory(hour12Modify(digitCondition('hour', 1), true))),
        'Z': timeZoneGetter$1('short'),
        'z': timeZoneGetter$1('long'),
        'ww': datePartGetterFactory({}),
        // Week of year, padded (00-53). Week 01 is the week with the
        // first Thursday of the year. not support ?
        'w': datePartGetterFactory({}),
        // Week of year (0-53). Week 1 is the week with the first Thursday
        // of the year not support ?
        'G': datePartGetterFactory(nameCondition('era', 1)),
        'GG': datePartGetterFactory(nameCondition('era', 2)),
        'GGG': datePartGetterFactory(nameCondition('era', 3)),
        'GGGG': datePartGetterFactory(nameCondition('era', 4))
    };
    /**
     * @param {?} inner
     * @return {?}
     */
    function digitModifier(inner) {
        return ( /**
         * @param {?} date
         * @param {?} locale
         * @return {?}
         */function (date, locale) {
            /** @type {?} */
            var result = inner(date, locale);
            return result.length == 1 ? '0' + result : result;
        });
    }
    /**
     * @param {?} inner
     * @return {?}
     */
    function hourClockExtractor(inner) {
        return ( /**
         * @param {?} date
         * @param {?} locale
         * @return {?}
         */function (date, locale) { return inner(date, locale).split(' ')[1]; });
    }
    /**
     * @param {?} inner
     * @return {?}
     */
    function hourExtractor(inner) {
        return ( /**
         * @param {?} date
         * @param {?} locale
         * @return {?}
         */function (date, locale) { return inner(date, locale).split(' ')[0]; });
    }
    /**
     * @param {?} date
     * @param {?} locale
     * @param {?} options
     * @return {?}
     */
    function intlDateFormat(date, locale, options) {
        return new Intl.DateTimeFormat(locale, options).format(date).replace(/[\u200e\u200f]/g, '');
    }
    /**
     * @param {?} timezone
     * @return {?}
     */
    function timeZoneGetter$1(timezone) {
        // To workaround `Intl` API restriction for single timezone let format with 24 hours
        /** @type {?} */
        var options = { hour: '2-digit', hour12: false, timeZoneName: timezone };
        return ( /**
         * @param {?} date
         * @param {?} locale
         * @return {?}
         */function (date, locale) {
            /** @type {?} */
            var result = intlDateFormat(date, locale, options);
            // Then extract first 3 letters that related to hours
            return result ? result.substring(3) : '';
        });
    }
    /**
     * @param {?} options
     * @param {?} value
     * @return {?}
     */
    function hour12Modify(options, value) {
        options.hour12 = value;
        return options;
    }
    /**
     * @param {?} prop
     * @param {?} len
     * @return {?}
     */
    function digitCondition(prop, len) {
        /** @type {?} */
        var result = {};
        result[prop] = len === 2 ? '2-digit' : 'numeric';
        return result;
    }
    /**
     * @param {?} prop
     * @param {?} len
     * @return {?}
     */
    function nameCondition(prop, len) {
        /** @type {?} */
        var result = {};
        if (len < 4) {
            result[prop] = len > 1 ? 'short' : 'narrow';
        }
        else {
            result[prop] = 'long';
        }
        return result;
    }
    /**
     * @param {?} options
     * @return {?}
     */
    function combine(options) {
        return options.reduce(( /**
         * @param {?} merged
         * @param {?} opt
         * @return {?}
         */function (merged, opt) { return (Object.assign({}, merged, opt)); }), {});
    }
    /**
     * @param {?} ret
     * @return {?}
     */
    function datePartGetterFactory(ret) {
        return ( /**
         * @param {?} date
         * @param {?} locale
         * @return {?}
         */function (date, locale) { return intlDateFormat(date, locale, ret); });
    }
    var ObservableStrategy = /** @class */ (function () {
        function ObservableStrategy() {
        }
        /**
         * @param {?} async
         * @param {?} updateLatestValue
         * @return {?}
         */
        ObservableStrategy.prototype.createSubscription = function (async, updateLatestValue) {
            return async.subscribe({ next: updateLatestValue, error: ( /**
                     * @param {?} e
                     * @return {?}
                     */function (e) { throw e; }) });
        };
        /**
         * @param {?} subscription
         * @return {?}
         */
        ObservableStrategy.prototype.dispose = function (subscription) { subscription.unsubscribe(); };
        /**
         * @param {?} subscription
         * @return {?}
         */
        ObservableStrategy.prototype.onDestroy = function (subscription) { subscription.unsubscribe(); };
        return ObservableStrategy;
    }());
    var PromiseStrategy = /** @class */ (function () {
        function PromiseStrategy() {
        }
        /**
         * @param {?} async
         * @param {?} updateLatestValue
         * @return {?}
         */
        PromiseStrategy.prototype.createSubscription = function (async, updateLatestValue) {
            return async.then(updateLatestValue, ( /**
             * @param {?} e
             * @return {?}
             */function (/**
             * @param {?} e
             * @return {?}
             */ e) { throw e; }));
        };
        /**
         * @param {?} subscription
         * @return {?}
         */
        PromiseStrategy.prototype.dispose = function (subscription) { };
        /**
         * @param {?} subscription
         * @return {?}
         */
        PromiseStrategy.prototype.onDestroy = function (subscription) { };
        return PromiseStrategy;
    }());
    /** @type {?} */
    var _promiseStrategy = new PromiseStrategy();
    /** @type {?} */
    var _observableStrategy = new ObservableStrategy();
    /**
     * \@ngModule CommonModule
     * \@description
     *
     * Unwraps a value from an asynchronous primitive.
     *
     * The `async` pipe subscribes to an `Observable` or `Promise` and returns the latest value it has
     * emitted. When a new value is emitted, the `async` pipe marks the component to be checked for
     * changes. When the component gets destroyed, the `async` pipe unsubscribes automatically to avoid
     * potential memory leaks.
     *
     * \@usageNotes
     *
     * ### Examples
     *
     * This example binds a `Promise` to the view. Clicking the `Resolve` button resolves the
     * promise.
     *
     * {\@example common/pipes/ts/async_pipe.ts region='AsyncPipePromise'}
     *
     * It's also possible to use `async` with Observables. The example below binds the `time` Observable
     * to the view. The Observable continuously updates the view with the current time.
     *
     * {\@example common/pipes/ts/async_pipe.ts region='AsyncPipeObservable'}
     *
     * \@publicApi
     */
    var AsyncPipe = /** @class */ (function () {
        /**
         * @param {?} _ref
         */
        function AsyncPipe(_ref) {
            this._ref = _ref;
            this._latestValue = null;
            this._latestReturnedValue = null;
            this._subscription = null;
            this._obj = null;
            this._strategy = ( /** @type {?} */(null));
        }
        /**
         * @return {?}
         */
        AsyncPipe.prototype.ngOnDestroy = function () {
            if (this._subscription) {
                this._dispose();
            }
        };
        /**
         * @param {?} obj
         * @return {?}
         */
        AsyncPipe.prototype.transform = function (obj) {
            if (!this._obj) {
                if (obj) {
                    this._subscribe(obj);
                }
                this._latestReturnedValue = this._latestValue;
                return this._latestValue;
            }
            if (obj !== this._obj) {
                this._dispose();
                return this.transform(( /** @type {?} */(obj)));
            }
            if (looseIdentical(this._latestValue, this._latestReturnedValue)) {
                return this._latestReturnedValue;
            }
            this._latestReturnedValue = this._latestValue;
            return WrappedValue.wrap(this._latestValue);
        };
        /**
         * @private
         * @param {?} obj
         * @return {?}
         */
        AsyncPipe.prototype._subscribe = function (obj) {
            var _this = this;
            this._obj = obj;
            this._strategy = this._selectStrategy(obj);
            this._subscription = this._strategy.createSubscription(obj, ( /**
             * @param {?} value
             * @return {?}
             */function (value) { return _this._updateLatestValue(obj, value); }));
        };
        /**
         * @private
         * @param {?} obj
         * @return {?}
         */
        AsyncPipe.prototype._selectStrategy = function (obj) {
            if (isPromise$1(obj)) {
                return _promiseStrategy;
            }
            if (isObservable(obj)) {
                return _observableStrategy;
            }
            throw invalidPipeArgumentError(AsyncPipe, obj);
        };
        /**
         * @private
         * @return {?}
         */
        AsyncPipe.prototype._dispose = function () {
            this._strategy.dispose(( /** @type {?} */(this._subscription)));
            this._latestValue = null;
            this._latestReturnedValue = null;
            this._subscription = null;
            this._obj = null;
        };
        /**
         * @private
         * @param {?} async
         * @param {?} value
         * @return {?}
         */
        AsyncPipe.prototype._updateLatestValue = function (async, value) {
            if (async === this._obj) {
                this._latestValue = value;
                this._ref.markForCheck();
            }
        };
        return AsyncPipe;
    }());
    AsyncPipe.decorators = [
        { type: Injectable },
        { type: Pipe, args: [{ name: 'async', pure: false },] }
    ];
    /** @nocollapse */
    AsyncPipe.ctorParameters = function () { return [
        { type: ChangeDetectorRef }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Transforms text to all lower case.
     *
     * @see `UpperCasePipe`
     * @see `TitleCasePipe`
     * \@usageNotes
     *
     * The following example defines a view that allows the user to enter
     * text, and then uses the pipe to convert the input text to all lower case.
     *
     * <code-example path="common/pipes/ts/lowerupper_pipe.ts" region='LowerUpperPipe'></code-example>
     *
     * \@ngModule CommonModule
     * \@publicApi
     */
    var LowerCasePipe = /** @class */ (function () {
        function LowerCasePipe() {
        }
        /**
         * @param {?} value The string to transform to lower case.
         * @return {?}
         */
        LowerCasePipe.prototype.transform = function (value) {
            if (!value)
                return value;
            if (typeof value !== 'string') {
                throw invalidPipeArgumentError(LowerCasePipe, value);
            }
            return value.toLowerCase();
        };
        return LowerCasePipe;
    }());
    LowerCasePipe.decorators = [
        { type: Injectable },
        { type: Pipe, args: [{ name: 'lowercase' },] }
    ];
    //
    // Regex below matches any Unicode word and compatible with ES5. In ES2018 the same result
    // can be achieved by using /\p{L}\S*/gu and also known as Unicode Property Escapes
    // (http://2ality.com/2017/07/regexp-unicode-property-escapes.html). Since there is no
    // transpilation of this functionality down to ES5 without external tool, the only solution is
    // to use already transpiled form. Example can be found here -
    // https://mothereff.in/regexpu#input=var+regex+%3D+/%5Cp%7BL%7D/u%3B&unicodePropertyEscape=1
    //
    /** @type {?} */
    var unicodeWordMatch = /(?:[A-Za-z\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08BD\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16F1-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2183\u2184\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005\u3006\u3031-\u3035\u303B\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312E\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FEA\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6E5\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AE\uA7B0-\uA7B7\uA7F7-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDE80-\uDE9C\uDEA0-\uDED0\uDF00-\uDF1F\uDF2D-\uDF40\uDF42-\uDF49\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF]|\uD801[\uDC00-\uDC9D\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE4\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2]|\uD804[\uDC03-\uDC37\uDC83-\uDCAF\uDCD0-\uDCE8\uDD03-\uDD26\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE80-\uDEAA\uDF00-\uDF19]|\uD806[\uDCA0-\uDCDF\uDCFF\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE83\uDE86-\uDE89\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46]|\uD808[\uDC00-\uDF99]|\uD809[\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDF00-\uDF44\uDF50\uDF93-\uDF9F\uDFE0\uDFE1]|\uD821[\uDC00-\uDFEC]|\uD822[\uDC00-\uDEF2]|\uD82C[\uDC00-\uDD1E\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB]|\uD83A[\uDC00-\uDCC4\uDD00-\uDD43]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D])\S*/g;
    /**
     * Transforms text to title case.
     * Capitalizes the first letter of each word, and transforms the
     * rest of the word to lower case.
     * Words are delimited by any whitespace character, such as a space, tab, or line-feed character.
     *
     * @see `LowerCasePipe`
     * @see `UpperCasePipe`
     *
     * \@usageNotes
     * The following example shows the result of transforming various strings into title case.
     *
     * <code-example path="common/pipes/ts/titlecase_pipe.ts" region='TitleCasePipe'></code-example>
     *
     * \@ngModule CommonModule
     * \@publicApi
     */
    var TitleCasePipe = /** @class */ (function () {
        function TitleCasePipe() {
        }
        /**
         * @param {?} value The string to transform to title case.
         * @return {?}
         */
        TitleCasePipe.prototype.transform = function (value) {
            if (!value)
                return value;
            if (typeof value !== 'string') {
                throw invalidPipeArgumentError(TitleCasePipe, value);
            }
            return value.replace(unicodeWordMatch, (( /**
             * @param {?} txt
             * @return {?}
             */function (/**
             * @param {?} txt
             * @return {?}
             */ txt) { return txt[0].toUpperCase() + txt.substr(1).toLowerCase(); })));
        };
        return TitleCasePipe;
    }());
    TitleCasePipe.decorators = [
        { type: Injectable },
        { type: Pipe, args: [{ name: 'titlecase' },] }
    ];
    /**
     * Transforms text to all upper case.
     * @see `LowerCasePipe`
     * @see `TitleCasePipe`
     *
     * \@ngModule CommonModule
     * \@publicApi
     */
    var UpperCasePipe = /** @class */ (function () {
        function UpperCasePipe() {
        }
        /**
         * @param {?} value The string to transform to upper case.
         * @return {?}
         */
        UpperCasePipe.prototype.transform = function (value) {
            if (!value)
                return value;
            if (typeof value !== 'string') {
                throw invalidPipeArgumentError(UpperCasePipe, value);
            }
            return value.toUpperCase();
        };
        return UpperCasePipe;
    }());
    UpperCasePipe.decorators = [
        { type: Injectable },
        { type: Pipe, args: [{ name: 'uppercase' },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // clang-format off
    /**
     * \@ngModule CommonModule
     * \@description
     *
     * Formats a date value according to locale rules.
     *
     * Only the `en-US` locale data comes with Angular. To localize dates
     * in another language, you must import the corresponding locale data.
     * See the [I18n guide](guide/i18n#i18n-pipes) for more information.
     *
     * @see `formatDate()`
     *
     *
     * \@usageNotes
     *
     * The result of this pipe is not reevaluated when the input is mutated. To avoid the need to
     * reformat the date on every change-detection cycle, treat the date as an immutable object
     * and change the reference when the pipe needs to run again.
     *
     * ### Pre-defined format options
     *
     * Examples are given in `en-US` locale.
     *
     * - `'short'`: equivalent to `'M/d/yy, h:mm a'` (`6/15/15, 9:03 AM`).
     * - `'medium'`: equivalent to `'MMM d, y, h:mm:ss a'` (`Jun 15, 2015, 9:03:01 AM`).
     * - `'long'`: equivalent to `'MMMM d, y, h:mm:ss a z'` (`June 15, 2015 at 9:03:01 AM
     * GMT+1`).
     * - `'full'`: equivalent to `'EEEE, MMMM d, y, h:mm:ss a zzzz'` (`Monday, June 15, 2015 at
     * 9:03:01 AM GMT+01:00`).
     * - `'shortDate'`: equivalent to `'M/d/yy'` (`6/15/15`).
     * - `'mediumDate'`: equivalent to `'MMM d, y'` (`Jun 15, 2015`).
     * - `'longDate'`: equivalent to `'MMMM d, y'` (`June 15, 2015`).
     * - `'fullDate'`: equivalent to `'EEEE, MMMM d, y'` (`Monday, June 15, 2015`).
     * - `'shortTime'`: equivalent to `'h:mm a'` (`9:03 AM`).
     * - `'mediumTime'`: equivalent to `'h:mm:ss a'` (`9:03:01 AM`).
     * - `'longTime'`: equivalent to `'h:mm:ss a z'` (`9:03:01 AM GMT+1`).
     * - `'fullTime'`: equivalent to `'h:mm:ss a zzzz'` (`9:03:01 AM GMT+01:00`).
     *
     * ### Custom format options
     *
     * You can construct a format string using symbols to specify the components
     * of a date-time value, as described in the following table.
     * Format details depend on the locale.
     * Fields marked with (*) are only available in the extra data set for the given locale.
     *
     *  | Field type         | Format      | Description                                                   | Example Value                                              |
     *  |--------------------|-------------|---------------------------------------------------------------|------------------------------------------------------------|
     *  | Era                | G, GG & GGG | Abbreviated                                                   | AD                                                         |
     *  |                    | GGGG        | Wide                                                          | Anno Domini                                                |
     *  |                    | GGGGG       | Narrow                                                        | A                                                          |
     *  | Year               | y           | Numeric: minimum digits                                       | 2, 20, 201, 2017, 20173                                    |
     *  |                    | yy          | Numeric: 2 digits + zero padded                               | 02, 20, 01, 17, 73                                         |
     *  |                    | yyy         | Numeric: 3 digits + zero padded                               | 002, 020, 201, 2017, 20173                                 |
     *  |                    | yyyy        | Numeric: 4 digits or more + zero padded                       | 0002, 0020, 0201, 2017, 20173                              |
     *  | Month              | M           | Numeric: 1 digit                                              | 9, 12                                                      |
     *  |                    | MM          | Numeric: 2 digits + zero padded                               | 09, 12                                                     |
     *  |                    | MMM         | Abbreviated                                                   | Sep                                                        |
     *  |                    | MMMM        | Wide                                                          | September                                                  |
     *  |                    | MMMMM       | Narrow                                                        | S                                                          |
     *  | Month standalone   | L           | Numeric: 1 digit                                              | 9, 12                                                      |
     *  |                    | LL          | Numeric: 2 digits + zero padded                               | 09, 12                                                     |
     *  |                    | LLL         | Abbreviated                                                   | Sep                                                        |
     *  |                    | LLLL        | Wide                                                          | September                                                  |
     *  |                    | LLLLL       | Narrow                                                        | S                                                          |
     *  | Week of year       | w           | Numeric: minimum digits                                       | 1... 53                                                    |
     *  |                    | ww          | Numeric: 2 digits + zero padded                               | 01... 53                                                   |
     *  | Week of month      | W           | Numeric: 1 digit                                              | 1... 5                                                     |
     *  | Day of month       | d           | Numeric: minimum digits                                       | 1                                                          |
     *  |                    | dd          | Numeric: 2 digits + zero padded                               | 01                                                          |
     *  | Week day           | E, EE & EEE | Abbreviated                                                   | Tue                                                        |
     *  |                    | EEEE        | Wide                                                          | Tuesday                                                    |
     *  |                    | EEEEE       | Narrow                                                        | T                                                          |
     *  |                    | EEEEEE      | Short                                                         | Tu                                                         |
     *  | Period             | a, aa & aaa | Abbreviated                                                   | am/pm or AM/PM                                             |
     *  |                    | aaaa        | Wide (fallback to `a` when missing)                           | ante meridiem/post meridiem                                |
     *  |                    | aaaaa       | Narrow                                                        | a/p                                                        |
     *  | Period*            | B, BB & BBB | Abbreviated                                                   | mid.                                                       |
     *  |                    | BBBB        | Wide                                                          | am, pm, midnight, noon, morning, afternoon, evening, night |
     *  |                    | BBBBB       | Narrow                                                        | md                                                         |
     *  | Period standalone* | b, bb & bbb | Abbreviated                                                   | mid.                                                       |
     *  |                    | bbbb        | Wide                                                          | am, pm, midnight, noon, morning, afternoon, evening, night |
     *  |                    | bbbbb       | Narrow                                                        | md                                                         |
     *  | Hour 1-12          | h           | Numeric: minimum digits                                       | 1, 12                                                      |
     *  |                    | hh          | Numeric: 2 digits + zero padded                               | 01, 12                                                     |
     *  | Hour 0-23          | H           | Numeric: minimum digits                                       | 0, 23                                                      |
     *  |                    | HH          | Numeric: 2 digits + zero padded                               | 00, 23                                                     |
     *  | Minute             | m           | Numeric: minimum digits                                       | 8, 59                                                      |
     *  |                    | mm          | Numeric: 2 digits + zero padded                               | 08, 59                                                     |
     *  | Second             | s           | Numeric: minimum digits                                       | 0... 59                                                    |
     *  |                    | ss          | Numeric: 2 digits + zero padded                               | 00... 59                                                   |
     *  | Fractional seconds | S           | Numeric: 1 digit                                              | 0... 9                                                     |
     *  |                    | SS          | Numeric: 2 digits + zero padded                               | 00... 99                                                   |
     *  |                    | SSS         | Numeric: 3 digits + zero padded (= milliseconds)              | 000... 999                                                 |
     *  | Zone               | z, zz & zzz | Short specific non location format (fallback to O)            | GMT-8                                                      |
     *  |                    | zzzz        | Long specific non location format (fallback to OOOO)          | GMT-08:00                                                  |
     *  |                    | Z, ZZ & ZZZ | ISO8601 basic format                                          | -0800                                                      |
     *  |                    | ZZZZ        | Long localized GMT format                                     | GMT-8:00                                                   |
     *  |                    | ZZZZZ       | ISO8601 extended format + Z indicator for offset 0 (= XXXXX)  | -08:00                                                     |
     *  |                    | O, OO & OOO | Short localized GMT format                                    | GMT-8                                                      |
     *  |                    | OOOO        | Long localized GMT format                                     | GMT-08:00                                                  |
     *
     * Note that timezone correction is not applied to an ISO string that has no time component, such as "2016-09-19"
     *
     * ### Format examples
     *
     * These examples transform a date into various formats,
     * assuming that `dateObj` is a JavaScript `Date` object for
     * year: 2015, month: 6, day: 15, hour: 21, minute: 43, second: 11,
     * given in the local time for the `en-US` locale.
     *
     * ```
     * {{ dateObj | date }}               // output is 'Jun 15, 2015'
     * {{ dateObj | date:'medium' }}      // output is 'Jun 15, 2015, 9:43:11 PM'
     * {{ dateObj | date:'shortTime' }}   // output is '9:43 PM'
     * {{ dateObj | date:'mm:ss' }}       // output is '43:11'
     * ```
     *
     * ### Usage example
     *
     * The following component uses a date pipe to display the current date in different formats.
     *
     * ```
     * \@Component({
     *  selector: 'date-pipe',
     *  template: `<div>
     *    <p>Today is {{today | date}}</p>
     *    <p>Or if you prefer, {{today | date:'fullDate'}}</p>
     *    <p>The time is {{today | date:'h:mm a z'}}</p>
     *  </div>`
     * })
     * // Get the current date and time as a date-time value.
     * export class DatePipeComponent {
     *   today: number = Date.now();
     * }
     * ```
     *
     * \@publicApi
     */
    // clang-format on
    var DatePipe = /** @class */ (function () {
        /**
         * @param {?} locale
         */
        function DatePipe(locale) {
            this.locale = locale;
        }
        /**
         * @param {?} value The date expression: a `Date` object,  a number
         * (milliseconds since UTC epoch), or an ISO string (https://www.w3.org/TR/NOTE-datetime).
         * @param {?=} format The date/time components to include, using predefined options or a
         * custom format string.
         * @param {?=} timezone A timezone offset (such as `'+0430'`), or a standard
         * UTC/GMT or continental US timezone abbreviation.
         * When not supplied, uses the end-user's local system timezone.
         * @param {?=} locale A locale code for the locale format rules to use.
         * When not supplied, uses the value of `LOCALE_ID`, which is `en-US` by default.
         * See [Setting your app locale](guide/i18n#setting-up-the-locale-of-your-app).
         * @return {?} A date string in the desired format.
         */
        DatePipe.prototype.transform = function (value, format, timezone, locale) {
            if (format === void 0) { format = 'mediumDate'; }
            if (value == null || value === '' || value !== value)
                return null;
            try {
                return formatDate(value, format, locale || this.locale, timezone);
            }
            catch (error) {
                throw invalidPipeArgumentError(DatePipe, error.message);
            }
        };
        return DatePipe;
    }());
    DatePipe.decorators = [
        { type: Injectable },
        { type: Pipe, args: [{ name: 'date', pure: true },] }
    ];
    /** @nocollapse */
    DatePipe.ctorParameters = function () { return [
        { type: String, decorators: [{ type: Inject, args: [LOCALE_ID$1,] }] }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var _INTERPOLATION_REGEXP = /#/g;
    /**
     * \@ngModule CommonModule
     * \@description
     *
     * Maps a value to a string that pluralizes the value according to locale rules.
     *
     * \@usageNotes
     *
     * ### Example
     *
     * {\@example common/pipes/ts/i18n_pipe.ts region='I18nPluralPipeComponent'}
     *
     * \@publicApi
     */
    var I18nPluralPipe = /** @class */ (function () {
        /**
         * @param {?} _localization
         */
        function I18nPluralPipe(_localization) {
            this._localization = _localization;
        }
        /**
         * @param {?} value the number to be formatted
         * @param {?} pluralMap an object that mimics the ICU format, see
         * http://userguide.icu-project.org/formatparse/messages.
         * @param {?=} locale a `string` defining the locale to use (uses the current {\@link LOCALE_ID} by
         * default).
         * @return {?}
         */
        I18nPluralPipe.prototype.transform = function (value, pluralMap, locale) {
            if (value == null)
                return '';
            if (typeof pluralMap !== 'object' || pluralMap === null) {
                throw invalidPipeArgumentError(I18nPluralPipe, pluralMap);
            }
            /** @type {?} */
            var key = getPluralCategory(value, Object.keys(pluralMap), this._localization, locale);
            return pluralMap[key].replace(_INTERPOLATION_REGEXP, value.toString());
        };
        return I18nPluralPipe;
    }());
    I18nPluralPipe.decorators = [
        { type: Injectable },
        { type: Pipe, args: [{ name: 'i18nPlural', pure: true },] }
    ];
    /** @nocollapse */
    I18nPluralPipe.ctorParameters = function () { return [
        { type: NgLocalization }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@ngModule CommonModule
     * \@description
     *
     * Generic selector that displays the string that matches the current value.
     *
     * If none of the keys of the `mapping` match the `value`, then the content
     * of the `other` key is returned when present, otherwise an empty string is returned.
     *
     * \@usageNotes
     *
     * ### Example
     *
     * {\@example common/pipes/ts/i18n_pipe.ts region='I18nSelectPipeComponent'}
     *
     * \@publicApi
     */
    var I18nSelectPipe = /** @class */ (function () {
        function I18nSelectPipe() {
        }
        /**
         * @param {?} value a string to be internationalized.
         * @param {?} mapping an object that indicates the text that should be displayed
         * for different values of the provided `value`.
         * @return {?}
         */
        I18nSelectPipe.prototype.transform = function (value, mapping) {
            if (value == null)
                return '';
            if (typeof mapping !== 'object' || typeof value !== 'string') {
                throw invalidPipeArgumentError(I18nSelectPipe, mapping);
            }
            if (mapping.hasOwnProperty(value)) {
                return mapping[value];
            }
            if (mapping.hasOwnProperty('other')) {
                return mapping['other'];
            }
            return '';
        };
        return I18nSelectPipe;
    }());
    I18nSelectPipe.decorators = [
        { type: Injectable },
        { type: Pipe, args: [{ name: 'i18nSelect', pure: true },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@ngModule CommonModule
     * \@description
     *
     * Converts a value into its JSON-format representation.  Useful for debugging.
     *
     * \@usageNotes
     *
     * The following component uses a JSON pipe to convert an object
     * to JSON format, and displays the string in both formats for comparison.
     *
     * {\@example common/pipes/ts/json_pipe.ts region='JsonPipe'}
     *
     * \@publicApi
     */
    var JsonPipe = /** @class */ (function () {
        function JsonPipe() {
        }
        /**
         * @param {?} value A value of any type to convert into a JSON-format string.
         * @return {?}
         */
        JsonPipe.prototype.transform = function (value) { return JSON.stringify(value, null, 2); };
        return JsonPipe;
    }());
    JsonPipe.decorators = [
        { type: Injectable },
        { type: Pipe, args: [{ name: 'json', pure: false },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template K, V
     * @param {?} key
     * @param {?} value
     * @return {?}
     */
    function makeKeyValuePair(key, value) {
        return { key: key, value: value };
    }
    /**
     * \@ngModule CommonModule
     * \@description
     *
     * Transforms Object or Map into an array of key value pairs.
     *
     * The output array will be ordered by keys.
     * By default the comparator will be by Unicode point value.
     * You can optionally pass a compareFn if your keys are complex types.
     *
     * \@usageNotes
     * ### Examples
     *
     * This examples show how an Object or a Map can be iterated by ngFor with the use of this keyvalue
     * pipe.
     *
     * {\@example common/pipes/ts/keyvalue_pipe.ts region='KeyValuePipe'}
     *
     * \@publicApi
     */
    var KeyValuePipe = /** @class */ (function () {
        /**
         * @param {?} differs
         */
        function KeyValuePipe(differs) {
            this.differs = differs;
            this.keyValues = [];
        }
        /**
         * @template K, V
         * @param {?} input
         * @param {?=} compareFn
         * @return {?}
         */
        KeyValuePipe.prototype.transform = function (input, compareFn) {
            var _this = this;
            if (compareFn === void 0) { compareFn = defaultComparator; }
            if (!input || (!(input instanceof Map) && typeof input !== 'object')) {
                return null;
            }
            if (!this.differ) {
                // make a differ for whatever type we've been passed in
                this.differ = this.differs.find(input).create();
            }
            /** @type {?} */
            var differChanges = this.differ.diff(( /** @type {?} */(input)));
            if (differChanges) {
                this.keyValues = [];
                differChanges.forEachItem(( /**
                 * @param {?} r
                 * @return {?}
                 */function (r) {
                    _this.keyValues.push(makeKeyValuePair(r.key, ( /** @type {?} */(r.currentValue))));
                }));
                this.keyValues.sort(compareFn);
            }
            return this.keyValues;
        };
        return KeyValuePipe;
    }());
    KeyValuePipe.decorators = [
        { type: Injectable },
        { type: Pipe, args: [{ name: 'keyvalue', pure: false },] }
    ];
    /** @nocollapse */
    KeyValuePipe.ctorParameters = function () { return [
        { type: KeyValueDiffers }
    ]; };
    /**
     * @template K, V
     * @param {?} keyValueA
     * @param {?} keyValueB
     * @return {?}
     */
    function defaultComparator(keyValueA, keyValueB) {
        /** @type {?} */
        var a = keyValueA.key;
        /** @type {?} */
        var b = keyValueB.key;
        // if same exit with 0;
        if (a === b)
            return 0;
        // make sure that undefined are at the end of the sort.
        if (a === undefined)
            return 1;
        if (b === undefined)
            return -1;
        // make sure that nulls are at the end of the sort.
        if (a === null)
            return 1;
        if (b === null)
            return -1;
        if (typeof a == 'string' && typeof b == 'string') {
            return a < b ? -1 : 1;
        }
        if (typeof a == 'number' && typeof b == 'number') {
            return a - b;
        }
        if (typeof a == 'boolean' && typeof b == 'boolean') {
            return a < b ? -1 : 1;
        }
        // `a` and `b` are of different types. Compare their string values.
        /** @type {?} */
        var aString = String(a);
        /** @type {?} */
        var bString = String(b);
        return aString == bString ? 0 : aString < bString ? -1 : 1;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@ngModule CommonModule
     * \@description
     *
     * Transforms a number into a string,
     * formatted according to locale rules that determine group sizing and
     * separator, decimal-point character, and other locale-specific
     * configurations.
     *
     * If no parameters are specified, the function rounds off to the nearest value using this
     * [rounding method](https://en.wikibooks.org/wiki/Arithmetic/Rounding).
     * The behavior differs from that of the JavaScript ```Math.round()``` function.
     * In the following case for example, the pipe rounds down where
     * ```Math.round()``` rounds up:
     *
     * ```html
     * -2.5 | number:'1.0-0'
     * > -3
     * Math.round(-2.5)
     * > -2
     * ```
     *
     * @see `formatNumber()`
     *
     * \@usageNotes
     * The following code shows how the pipe transforms numbers
     * into text strings, according to various format specifications,
     * where the caller's default locale is `en-US`.
     *
     * ### Example
     *
     * <code-example path="common/pipes/ts/number_pipe.ts" region='NumberPipe'></code-example>
     *
     * \@publicApi
     */
    var DecimalPipe = /** @class */ (function () {
        /**
         * @param {?} _locale
         */
        function DecimalPipe(_locale) {
            this._locale = _locale;
        }
        /**
         * @param {?} value The number to be formatted.
         * @param {?=} digitsInfo Decimal representation options, specified by a string
         * in the following format:<br>
         * <code>{minIntegerDigits}.{minFractionDigits}-{maxFractionDigits}</code>.
         *   - `minIntegerDigits`: The minimum number of integer digits before the decimal point.
         * Default is `1`.
         *   - `minFractionDigits`: The minimum number of digits after the decimal point.
         * Default is `0`.
         *   - `maxFractionDigits`: The maximum number of digits after the decimal point.
         * Default is `3`.
         * @param {?=} locale A locale code for the locale format rules to use.
         * When not supplied, uses the value of `LOCALE_ID`, which is `en-US` by default.
         * See [Setting your app locale](guide/i18n#setting-up-the-locale-of-your-app).
         * @return {?}
         */
        DecimalPipe.prototype.transform = function (value, digitsInfo, locale) {
            if (isEmpty(value))
                return null;
            locale = locale || this._locale;
            try {
                /** @type {?} */
                var num = strToNumber(value);
                return formatNumber(num, locale, digitsInfo);
            }
            catch (error) {
                throw invalidPipeArgumentError(DecimalPipe, error.message);
            }
        };
        return DecimalPipe;
    }());
    DecimalPipe.decorators = [
        { type: Injectable },
        { type: Pipe, args: [{ name: 'number' },] }
    ];
    /** @nocollapse */
    DecimalPipe.ctorParameters = function () { return [
        { type: String, decorators: [{ type: Inject, args: [LOCALE_ID$1,] }] }
    ]; };
    /**
     * \@ngModule CommonModule
     * \@description
     *
     * Transforms a number to a percentage
     * string, formatted according to locale rules that determine group sizing and
     * separator, decimal-point character, and other locale-specific
     * configurations.
     *
     * @see `formatPercent()`
     *
     * \@usageNotes
     * The following code shows how the pipe transforms numbers
     * into text strings, according to various format specifications,
     * where the caller's default locale is `en-US`.
     *
     * <code-example path="common/pipes/ts/percent_pipe.ts" region='PercentPipe'></code-example>
     *
     * \@publicApi
     */
    var PercentPipe = /** @class */ (function () {
        /**
         * @param {?} _locale
         */
        function PercentPipe(_locale) {
            this._locale = _locale;
        }
        /**
         *
         * @param {?} value The number to be formatted as a percentage.
         * @param {?=} digitsInfo Decimal representation options, specified by a string
         * in the following format:<br>
         * <code>{minIntegerDigits}.{minFractionDigits}-{maxFractionDigits}</code>.
         *   - `minIntegerDigits`: The minimum number of integer digits before the decimal point.
         * Default is `1`.
         *   - `minFractionDigits`: The minimum number of digits after the decimal point.
         * Default is `0`.
         *   - `maxFractionDigits`: The maximum number of digits after the decimal point.
         * Default is `0`.
         * @param {?=} locale A locale code for the locale format rules to use.
         * When not supplied, uses the value of `LOCALE_ID`, which is `en-US` by default.
         * See [Setting your app locale](guide/i18n#setting-up-the-locale-of-your-app).
         * @return {?}
         */
        PercentPipe.prototype.transform = function (value, digitsInfo, locale) {
            if (isEmpty(value))
                return null;
            locale = locale || this._locale;
            try {
                /** @type {?} */
                var num = strToNumber(value);
                return formatPercent(num, locale, digitsInfo);
            }
            catch (error) {
                throw invalidPipeArgumentError(PercentPipe, error.message);
            }
        };
        return PercentPipe;
    }());
    PercentPipe.decorators = [
        { type: Injectable },
        { type: Pipe, args: [{ name: 'percent' },] }
    ];
    /** @nocollapse */
    PercentPipe.ctorParameters = function () { return [
        { type: String, decorators: [{ type: Inject, args: [LOCALE_ID$1,] }] }
    ]; };
    /**
     * \@ngModule CommonModule
     * \@description
     *
     * Transforms a number to a currency string, formatted according to locale rules
     * that determine group sizing and separator, decimal-point character,
     * and other locale-specific configurations.
     *
     * @see `getCurrencySymbol()`
     * @see `formatCurrency()`
     *
     * \@usageNotes
     * The following code shows how the pipe transforms numbers
     * into text strings, according to various format specifications,
     * where the caller's default locale is `en-US`.
     *
     * <code-example path="common/pipes/ts/currency_pipe.ts" region='CurrencyPipe'></code-example>
     *
     * \@publicApi
     */
    var CurrencyPipe = /** @class */ (function () {
        /**
         * @param {?} _locale
         */
        function CurrencyPipe(_locale) {
            this._locale = _locale;
        }
        /**
         *
         * @param {?} value The number to be formatted as currency.
         * @param {?=} currencyCode The [ISO 4217](https://en.wikipedia.org/wiki/ISO_4217) currency code,
         * such as `USD` for the US dollar and `EUR` for the euro.
         * @param {?=} display The format for the currency indicator. One of the following:
         *   - `code`: Show the code (such as `USD`).
         *   - `symbol`(default): Show the symbol (such as `$`).
         *   - `symbol-narrow`: Use the narrow symbol for locales that have two symbols for their
         * currency.
         * For example, the Canadian dollar CAD has the symbol `CA$` and the symbol-narrow `$`. If the
         * locale has no narrow symbol, uses the standard symbol for the locale.
         *   - String: Use the given string value instead of a code or a symbol.
         * For example, an empty string will suppress the currency & symbol.
         *   - Boolean (marked deprecated in v5): `true` for symbol and false for `code`.
         *
         * @param {?=} digitsInfo Decimal representation options, specified by a string
         * in the following format:<br>
         * <code>{minIntegerDigits}.{minFractionDigits}-{maxFractionDigits}</code>.
         *   - `minIntegerDigits`: The minimum number of integer digits before the decimal point.
         * Default is `1`.
         *   - `minFractionDigits`: The minimum number of digits after the decimal point.
         * Default is `2`.
         *   - `maxFractionDigits`: The maximum number of digits after the decimal point.
         * Default is `2`.
         * If not provided, the number will be formatted with the proper amount of digits,
         * depending on what the [ISO 4217](https://en.wikipedia.org/wiki/ISO_4217) specifies.
         * For example, the Canadian dollar has 2 digits, whereas the Chilean peso has none.
         * @param {?=} locale A locale code for the locale format rules to use.
         * When not supplied, uses the value of `LOCALE_ID`, which is `en-US` by default.
         * See [Setting your app locale](guide/i18n#setting-up-the-locale-of-your-app).
         * @return {?}
         */
        CurrencyPipe.prototype.transform = function (value, currencyCode, display, digitsInfo, locale) {
            if (display === void 0) { display = 'symbol'; }
            if (isEmpty(value))
                return null;
            locale = locale || this._locale;
            if (typeof display === 'boolean') {
                if (( /** @type {?} */(console)) && ( /** @type {?} */(console.warn))) {
                    console.warn("Warning: the currency pipe has been changed in Angular v5. The symbolDisplay option (third parameter) is now a string instead of a boolean. The accepted values are \"code\", \"symbol\" or \"symbol-narrow\".");
                }
                display = display ? 'symbol' : 'code';
            }
            /** @type {?} */
            var currency = currencyCode || 'USD';
            if (display !== 'code') {
                if (display === 'symbol' || display === 'symbol-narrow') {
                    currency = getCurrencySymbol(currency, display === 'symbol' ? 'wide' : 'narrow', locale);
                }
                else {
                    currency = display;
                }
            }
            try {
                /** @type {?} */
                var num = strToNumber(value);
                return formatCurrency(num, locale, currency, currencyCode, digitsInfo);
            }
            catch (error) {
                throw invalidPipeArgumentError(CurrencyPipe, error.message);
            }
        };
        return CurrencyPipe;
    }());
    CurrencyPipe.decorators = [
        { type: Injectable },
        { type: Pipe, args: [{ name: 'currency' },] }
    ];
    /** @nocollapse */
    CurrencyPipe.ctorParameters = function () { return [
        { type: String, decorators: [{ type: Inject, args: [LOCALE_ID$1,] }] }
    ]; };
    /**
     * @param {?} value
     * @return {?}
     */
    function isEmpty(value) {
        return value == null || value === '' || value !== value;
    }
    /**
     * Transforms a string into a number (if needed).
     * @param {?} value
     * @return {?}
     */
    function strToNumber(value) {
        // Convert strings to numbers
        if (typeof value === 'string' && !isNaN(Number(value) - parseFloat(value))) {
            return Number(value);
        }
        if (typeof value !== 'number') {
            throw new Error(value + " is not a number");
        }
        return value;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@ngModule CommonModule
     * \@description
     *
     * Creates a new `Array` or `String` containing a subset (slice) of the elements.
     *
     * \@usageNotes
     *
     * All behavior is based on the expected behavior of the JavaScript API `Array.prototype.slice()`
     * and `String.prototype.slice()`.
     *
     * When operating on an `Array`, the returned `Array` is always a copy even when all
     * the elements are being returned.
     *
     * When operating on a blank value, the pipe returns the blank value.
     *
     * ### List Example
     *
     * This `ngFor` example:
     *
     * {\@example common/pipes/ts/slice_pipe.ts region='SlicePipe_list'}
     *
     * produces the following:
     *
     * ```html
     * <li>b</li>
     * <li>c</li>
     * ```
     *
     * ### String Examples
     *
     * {\@example common/pipes/ts/slice_pipe.ts region='SlicePipe_string'}
     *
     * \@publicApi
     */
    var SlicePipe = /** @class */ (function () {
        function SlicePipe() {
        }
        /**
         * @param {?} value
         * @param {?} start
         * @param {?=} end
         * @return {?}
         */
        SlicePipe.prototype.transform = function (value, start, end) {
            if (value == null)
                return value;
            if (!this.supports(value)) {
                throw invalidPipeArgumentError(SlicePipe, value);
            }
            return value.slice(start, end);
        };
        /**
         * @private
         * @param {?} obj
         * @return {?}
         */
        SlicePipe.prototype.supports = function (obj) { return typeof obj === 'string' || Array.isArray(obj); };
        return SlicePipe;
    }());
    SlicePipe.decorators = [
        { type: Injectable },
        { type: Pipe, args: [{ name: 'slice', pure: false },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A collection of Angular pipes that are likely to be used in each and every application.
     * @type {?}
     */
    var COMMON_PIPES = [
        AsyncPipe,
        UpperCasePipe,
        LowerCasePipe,
        JsonPipe,
        SlicePipe,
        DecimalPipe,
        PercentPipe,
        TitleCasePipe,
        CurrencyPipe,
        DatePipe,
        I18nPluralPipe,
        I18nSelectPipe,
        KeyValuePipe,
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // Note: This does not contain the location providers,
    // as they need some platform specific implementations to work.
    /**
     * Exports all the basic Angular directives and pipes,
     * such as `NgIf`, `NgForOf`, `DecimalPipe`, and so on.
     * Re-exported by `BrowserModule`, which is included automatically in the root
     * `AppModule` when you create a new app with the CLI `new` command.
     *
     * * The `providers` options configure the NgModule's injector to provide
     * localization dependencies to members.
     * * The `exports` options make the declared directives and pipes available for import
     * by other NgModules.
     *
     * \@publicApi
     */
    var CommonModule = /** @class */ (function () {
        function CommonModule() {
        }
        return CommonModule;
    }());
    CommonModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [COMMON_DIRECTIVES, COMMON_PIPES],
                    exports: [COMMON_DIRECTIVES, COMMON_PIPES],
                    providers: [
                        { provide: NgLocalization, useClass: NgLocaleLocalization },
                    ],
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A DI Token representing the main rendering context. In a browser this is the DOM Document.
     *
     * Note: Document might not be available in the Application Context when Application and Rendering
     * Contexts are not the same (e.g. when running the application in a Web Worker).
     *
     * \@publicApi
     * @type {?}
     */
    var DOCUMENT = new InjectionToken('DocumentToken');
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /** @type {?} */
    var PLATFORM_BROWSER_ID = 'browser';
    /** @type {?} */
    var PLATFORM_SERVER_ID = 'server';
    /**
     * Returns whether a platform id represents a browser platform.
     * \@publicApi
     * @param {?} platformId
     * @return {?}
     */
    function isPlatformBrowser(platformId) {
        return platformId === PLATFORM_BROWSER_ID;
    }
    /**
     * Returns whether a platform id represents a server platform.
     * \@publicApi
     * @param {?} platformId
     * @return {?}
     */
    function isPlatformServer(platformId) {
        return platformId === PLATFORM_SERVER_ID;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@publicApi
     * @type {?}
     */
    var VERSION$1 = new Version('8.2.14');
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Defines a scroll position manager. Implemented by `BrowserViewportScroller`.
     *
     * \@publicApi
     * @abstract
     */
    var ViewportScroller = /** @class */ (function () {
        function ViewportScroller() {
        }
        return ViewportScroller;
    }());
    // De-sugared tree-shakable injection
    // See #23917
    /** @nocollapse */
    /** @nocollapse */ ViewportScroller.ngInjectableDef = ɵɵdefineInjectable({
        token: ViewportScroller,
        providedIn: 'root',
        factory: ( /**
         * @nocollapse @return {?}
         */function () { return new BrowserViewportScroller(ɵɵinject(DOCUMENT), window, ɵɵinject(ErrorHandler)); })
    });
    /**
     * Manages the scroll position for a browser window.
     */
    var BrowserViewportScroller = /** @class */ (function () {
        /**
         * @param {?} document
         * @param {?} window
         * @param {?} errorHandler
         */
        function BrowserViewportScroller(document, window, errorHandler) {
            this.document = document;
            this.window = window;
            this.errorHandler = errorHandler;
            this.offset = ( /**
             * @return {?}
             */function () { return [0, 0]; });
        }
        /**
         * Configures the top offset used when scrolling to an anchor.
         * @param {?} offset A position in screen coordinates (a tuple with x and y values)
         * or a function that returns the top offset position.
         *
         * @return {?}
         */
        BrowserViewportScroller.prototype.setOffset = function (offset) {
            if (Array.isArray(offset)) {
                this.offset = ( /**
                 * @return {?}
                 */function () { return offset; });
            }
            else {
                this.offset = offset;
            }
        };
        /**
         * Retrieves the current scroll position.
         * @return {?} The position in screen coordinates.
         */
        BrowserViewportScroller.prototype.getScrollPosition = function () {
            if (this.supportScrollRestoration()) {
                return [this.window.scrollX, this.window.scrollY];
            }
            else {
                return [0, 0];
            }
        };
        /**
         * Sets the scroll position.
         * @param {?} position The new position in screen coordinates.
         * @return {?}
         */
        BrowserViewportScroller.prototype.scrollToPosition = function (position) {
            if (this.supportScrollRestoration()) {
                this.window.scrollTo(position[0], position[1]);
            }
        };
        /**
         * Scrolls to an anchor element.
         * @param {?} anchor The ID of the anchor element.
         * @return {?}
         */
        BrowserViewportScroller.prototype.scrollToAnchor = function (anchor) {
            if (this.supportScrollRestoration()) {
                // Escape anything passed to `querySelector` as it can throw errors and stop the application
                // from working if invalid values are passed.
                if (this.window.CSS && this.window.CSS.escape) {
                    anchor = this.window.CSS.escape(anchor);
                }
                else {
                    anchor = anchor.replace(/(\"|\'\ |:|\.|\[|\]|,|=)/g, '\\$1');
                }
                try {
                    /** @type {?} */
                    var elSelectedById = this.document.querySelector("#" + anchor);
                    if (elSelectedById) {
                        this.scrollToElement(elSelectedById);
                        return;
                    }
                    /** @type {?} */
                    var elSelectedByName = this.document.querySelector("[name='" + anchor + "']");
                    if (elSelectedByName) {
                        this.scrollToElement(elSelectedByName);
                        return;
                    }
                }
                catch (e) {
                    this.errorHandler.handleError(e);
                }
            }
        };
        /**
         * Disables automatic scroll restoration provided by the browser.
         * @param {?} scrollRestoration
         * @return {?}
         */
        BrowserViewportScroller.prototype.setHistoryScrollRestoration = function (scrollRestoration) {
            if (this.supportScrollRestoration()) {
                /** @type {?} */
                var history_1 = this.window.history;
                if (history_1 && history_1.scrollRestoration) {
                    history_1.scrollRestoration = scrollRestoration;
                }
            }
        };
        /**
         * @private
         * @param {?} el
         * @return {?}
         */
        BrowserViewportScroller.prototype.scrollToElement = function (el) {
            /** @type {?} */
            var rect = el.getBoundingClientRect();
            /** @type {?} */
            var left = rect.left + this.window.pageXOffset;
            /** @type {?} */
            var top = rect.top + this.window.pageYOffset;
            /** @type {?} */
            var offset = this.offset();
            this.window.scrollTo(left - offset[0], top - offset[1]);
        };
        /**
         * We only support scroll restoration when we can get a hold of window.
         * This means that we do not support this behavior when running in a web worker.
         *
         * Lifting this restriction right now would require more changes in the dom adapter.
         * Since webworkers aren't widely used, we will lift it once RouterScroller is
         * battle-tested.
         * @private
         * @return {?}
         */
        BrowserViewportScroller.prototype.supportScrollRestoration = function () {
            try {
                return !!this.window && !!this.window.scrollTo;
            }
            catch (_a) {
                return false;
            }
        };
        return BrowserViewportScroller;
    }());
    /**
     * @license Angular v8.2.14
     * (c) 2010-2019 Google LLC. https://angular.io/
     * License: MIT
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /** @type {?} */
    var _DOM = ( /** @type {?} */(null));
    /**
     * @return {?}
     */
    function getDOM() {
        return _DOM;
    }
    /**
     * @param {?} adapter
     * @return {?}
     */
    function setRootDomAdapter(adapter) {
        if (!_DOM) {
            _DOM = adapter;
        }
    }
    /* tslint:disable:requireParameterType */
    /**
     * Provides DOM operations in an environment-agnostic way.
     *
     * \@security Tread carefully! Interacting with the DOM directly is dangerous and
     * can introduce XSS risks.
     * @abstract
     */
    var DomAdapter = /** @class */ (function () {
        function DomAdapter() {
            this.resourceLoaderType = ( /** @type {?} */(null));
        }
        Object.defineProperty(DomAdapter.prototype, "attrToPropMap", {
            /**
             * Maps attribute names to their corresponding property names for cases
             * where attribute name doesn't match property name.
             * @return {?}
             */
            get: function () { return this._attrToPropMap; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this._attrToPropMap = value; },
            enumerable: true,
            configurable: true
        });
        return DomAdapter;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Provides DOM operations in any browser environment.
     *
     * \@security Tread carefully! Interacting with the DOM directly is dangerous and
     * can introduce XSS risks.
     * @abstract
     */
    var GenericBrowserDomAdapter = /** @class */ (function (_super) {
        __extends(GenericBrowserDomAdapter, _super);
        function GenericBrowserDomAdapter() {
            var _this = _super.call(this) || this;
            _this._animationPrefix = null;
            _this._transitionEnd = null;
            try {
                /** @type {?} */
                var element_1 = _this.createElement('div', document);
                if (_this.getStyle(element_1, 'animationName') != null) {
                    _this._animationPrefix = '';
                }
                else {
                    /** @type {?} */
                    var domPrefixes = ['Webkit', 'Moz', 'O', 'ms'];
                    for (var i_120 = 0; i_120 < domPrefixes.length; i_120++) {
                        if (_this.getStyle(element_1, domPrefixes[i_120] + 'AnimationName') != null) {
                            _this._animationPrefix = '-' + domPrefixes[i_120].toLowerCase() + '-';
                            break;
                        }
                    }
                }
                /** @type {?} */
                var transEndEventNames_1 = {
                    WebkitTransition: 'webkitTransitionEnd',
                    MozTransition: 'transitionend',
                    OTransition: 'oTransitionEnd otransitionend',
                    transition: 'transitionend'
                };
                Object.keys(transEndEventNames_1).forEach(( /**
                 * @param {?} key
                 * @return {?}
                 */function (key) {
                    if (_this.getStyle(element_1, key) != null) {
                        _this._transitionEnd = transEndEventNames_1[key];
                    }
                }));
            }
            catch (_a) {
                _this._animationPrefix = null;
                _this._transitionEnd = null;
            }
            return _this;
        }
        /**
         * @param {?} el
         * @return {?}
         */
        GenericBrowserDomAdapter.prototype.getDistributedNodes = function (el) { return (( /** @type {?} */(el))).getDistributedNodes(); };
        /**
         * @param {?} el
         * @param {?} baseUrl
         * @param {?} href
         * @return {?}
         */
        GenericBrowserDomAdapter.prototype.resolveAndSetHref = function (el, baseUrl, href) {
            el.href = href == null ? baseUrl : baseUrl + '/../' + href;
        };
        /**
         * @return {?}
         */
        GenericBrowserDomAdapter.prototype.supportsDOMEvents = function () { return true; };
        /**
         * @return {?}
         */
        GenericBrowserDomAdapter.prototype.supportsNativeShadowDOM = function () {
            return typeof (( /** @type {?} */(document.body))).createShadowRoot === 'function';
        };
        /**
         * @return {?}
         */
        GenericBrowserDomAdapter.prototype.getAnimationPrefix = function () { return this._animationPrefix ? this._animationPrefix : ''; };
        /**
         * @return {?}
         */
        GenericBrowserDomAdapter.prototype.getTransitionEnd = function () { return this._transitionEnd ? this._transitionEnd : ''; };
        /**
         * @return {?}
         */
        GenericBrowserDomAdapter.prototype.supportsAnimation = function () {
            return this._animationPrefix != null && this._transitionEnd != null;
        };
        return GenericBrowserDomAdapter;
    }(DomAdapter));
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var _attrToPropMap = {
        'class': 'className',
        'innerHtml': 'innerHTML',
        'readonly': 'readOnly',
        'tabindex': 'tabIndex',
    };
    /** @type {?} */
    var DOM_KEY_LOCATION_NUMPAD = 3;
    // Map to convert some key or keyIdentifier values to what will be returned by getEventKey
    /** @type {?} */
    var _keyMap = {
        // The following values are here for cross-browser compatibility and to match the W3C standard
        // cf http://www.w3.org/TR/DOM-Level-3-Events-key/
        '\b': 'Backspace',
        '\t': 'Tab',
        '\x7F': 'Delete',
        '\x1B': 'Escape',
        'Del': 'Delete',
        'Esc': 'Escape',
        'Left': 'ArrowLeft',
        'Right': 'ArrowRight',
        'Up': 'ArrowUp',
        'Down': 'ArrowDown',
        'Menu': 'ContextMenu',
        'Scroll': 'ScrollLock',
        'Win': 'OS'
    };
    // There is a bug in Chrome for numeric keypad keys:
    // https://code.google.com/p/chromium/issues/detail?id=155654
    // 1, 2, 3 ... are reported as A, B, C ...
    /** @type {?} */
    var _chromeNumKeyPadMap = {
        'A': '1',
        'B': '2',
        'C': '3',
        'D': '4',
        'E': '5',
        'F': '6',
        'G': '7',
        'H': '8',
        'I': '9',
        'J': '*',
        'K': '+',
        'M': '-',
        'N': '.',
        'O': '/',
        '\x60': '0',
        '\x90': 'NumLock'
    };
    var ɵ0$6 = /**
     * @return {?}
     */ function () {
        if (_global['Node']) {
            return _global['Node'].prototype.contains || ( /**
             * @this {?}
             * @param {?} node
             * @return {?}
             */function (node) {
                return !!(this.compareDocumentPosition(node) & 16);
            });
        }
        return ( /** @type {?} */(undefined));
    };
    /** @type {?} */
    var nodeContains = ((ɵ0$6))();
    /**
     * A `DomAdapter` powered by full browser DOM APIs.
     *
     * \@security Tread carefully! Interacting with the DOM directly is dangerous and
     * can introduce XSS risks.
     */
    /* tslint:disable:requireParameterType no-console */
    var BrowserDomAdapter = /** @class */ (function (_super) {
        __extends(BrowserDomAdapter, _super);
        function BrowserDomAdapter() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @param {?} templateHtml
         * @return {?}
         */
        BrowserDomAdapter.prototype.parse = function (templateHtml) { throw new Error('parse not implemented'); };
        /**
         * @return {?}
         */
        BrowserDomAdapter.makeCurrent = function () { setRootDomAdapter(new BrowserDomAdapter()); };
        /**
         * @param {?} element
         * @param {?} name
         * @return {?}
         */
        BrowserDomAdapter.prototype.hasProperty = function (element, name) { return name in element; };
        /**
         * @param {?} el
         * @param {?} name
         * @param {?} value
         * @return {?}
         */
        BrowserDomAdapter.prototype.setProperty = function (el, name, value) { (( /** @type {?} */(el)))[name] = value; };
        /**
         * @param {?} el
         * @param {?} name
         * @return {?}
         */
        BrowserDomAdapter.prototype.getProperty = function (el, name) { return (( /** @type {?} */(el)))[name]; };
        /**
         * @param {?} el
         * @param {?} methodName
         * @param {?} args
         * @return {?}
         */
        BrowserDomAdapter.prototype.invoke = function (el, methodName, args) { (( /** @type {?} */(el)))[methodName].apply((( /** @type {?} */(el))), __spread(args)); };
        // TODO(tbosch): move this into a separate environment class once we have it
        /**
         * @param {?} error
         * @return {?}
         */
        BrowserDomAdapter.prototype.logError = function (error) {
            if (window.console) {
                if (console.error) {
                    console.error(error);
                }
                else {
                    console.log(error);
                }
            }
        };
        /**
         * @param {?} error
         * @return {?}
         */
        BrowserDomAdapter.prototype.log = function (error) {
            if (window.console) {
                window.console.log && window.console.log(error);
            }
        };
        /**
         * @param {?} error
         * @return {?}
         */
        BrowserDomAdapter.prototype.logGroup = function (error) {
            if (window.console) {
                window.console.group && window.console.group(error);
            }
        };
        /**
         * @return {?}
         */
        BrowserDomAdapter.prototype.logGroupEnd = function () {
            if (window.console) {
                window.console.groupEnd && window.console.groupEnd();
            }
        };
        Object.defineProperty(BrowserDomAdapter.prototype, "attrToPropMap", {
            /**
             * @return {?}
             */
            get: function () { return _attrToPropMap; },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} nodeA
         * @param {?} nodeB
         * @return {?}
         */
        BrowserDomAdapter.prototype.contains = function (nodeA, nodeB) { return nodeContains.call(nodeA, nodeB); };
        /**
         * @param {?} el
         * @param {?} selector
         * @return {?}
         */
        BrowserDomAdapter.prototype.querySelector = function (el, selector) { return el.querySelector(selector); };
        /**
         * @param {?} el
         * @param {?} selector
         * @return {?}
         */
        BrowserDomAdapter.prototype.querySelectorAll = function (el, selector) { return el.querySelectorAll(selector); };
        /**
         * @param {?} el
         * @param {?} evt
         * @param {?} listener
         * @return {?}
         */
        BrowserDomAdapter.prototype.on = function (el, evt, listener) { el.addEventListener(evt, listener, false); };
        /**
         * @param {?} el
         * @param {?} evt
         * @param {?} listener
         * @return {?}
         */
        BrowserDomAdapter.prototype.onAndCancel = function (el, evt, listener) {
            el.addEventListener(evt, listener, false);
            // Needed to follow Dart's subscription semantic, until fix of
            // https://code.google.com/p/dart/issues/detail?id=17406
            return ( /**
             * @return {?}
             */function () { el.removeEventListener(evt, listener, false); });
        };
        /**
         * @param {?} el
         * @param {?} evt
         * @return {?}
         */
        BrowserDomAdapter.prototype.dispatchEvent = function (el, evt) { el.dispatchEvent(evt); };
        /**
         * @param {?} eventType
         * @return {?}
         */
        BrowserDomAdapter.prototype.createMouseEvent = function (eventType) {
            /** @type {?} */
            var evt = this.getDefaultDocument().createEvent('MouseEvent');
            evt.initEvent(eventType, true, true);
            return evt;
        };
        /**
         * @param {?} eventType
         * @return {?}
         */
        BrowserDomAdapter.prototype.createEvent = function (eventType) {
            /** @type {?} */
            var evt = this.getDefaultDocument().createEvent('Event');
            evt.initEvent(eventType, true, true);
            return evt;
        };
        /**
         * @param {?} evt
         * @return {?}
         */
        BrowserDomAdapter.prototype.preventDefault = function (evt) {
            evt.preventDefault();
            evt.returnValue = false;
        };
        /**
         * @param {?} evt
         * @return {?}
         */
        BrowserDomAdapter.prototype.isPrevented = function (evt) {
            return evt.defaultPrevented || evt.returnValue != null && !evt.returnValue;
        };
        /**
         * @param {?} el
         * @return {?}
         */
        BrowserDomAdapter.prototype.getInnerHTML = function (el) { return el.innerHTML; };
        /**
         * @param {?} el
         * @return {?}
         */
        BrowserDomAdapter.prototype.getTemplateContent = function (el) {
            return 'content' in el && this.isTemplateElement(el) ? (( /** @type {?} */(el))).content : null;
        };
        /**
         * @param {?} el
         * @return {?}
         */
        BrowserDomAdapter.prototype.getOuterHTML = function (el) { return el.outerHTML; };
        /**
         * @param {?} node
         * @return {?}
         */
        BrowserDomAdapter.prototype.nodeName = function (node) { return node.nodeName; };
        /**
         * @param {?} node
         * @return {?}
         */
        BrowserDomAdapter.prototype.nodeValue = function (node) { return node.nodeValue; };
        /**
         * @param {?} node
         * @return {?}
         */
        BrowserDomAdapter.prototype.type = function (node) { return node.type; };
        /**
         * @param {?} node
         * @return {?}
         */
        BrowserDomAdapter.prototype.content = function (node) {
            if (this.hasProperty(node, 'content')) {
                return (( /** @type {?} */(node))).content;
            }
            else {
                return node;
            }
        };
        /**
         * @param {?} el
         * @return {?}
         */
        BrowserDomAdapter.prototype.firstChild = function (el) { return el.firstChild; };
        /**
         * @param {?} el
         * @return {?}
         */
        BrowserDomAdapter.prototype.nextSibling = function (el) { return el.nextSibling; };
        /**
         * @param {?} el
         * @return {?}
         */
        BrowserDomAdapter.prototype.parentElement = function (el) { return el.parentNode; };
        /**
         * @param {?} el
         * @return {?}
         */
        BrowserDomAdapter.prototype.childNodes = function (el) { return el.childNodes; };
        /**
         * @param {?} el
         * @return {?}
         */
        BrowserDomAdapter.prototype.childNodesAsList = function (el) {
            /** @type {?} */
            var childNodes = el.childNodes;
            /** @type {?} */
            var res = new Array(childNodes.length);
            for (var i_121 = 0; i_121 < childNodes.length; i_121++) {
                res[i_121] = childNodes[i_121];
            }
            return res;
        };
        /**
         * @param {?} el
         * @return {?}
         */
        BrowserDomAdapter.prototype.clearNodes = function (el) {
            while (el.firstChild) {
                el.removeChild(el.firstChild);
            }
        };
        /**
         * @param {?} el
         * @param {?} node
         * @return {?}
         */
        BrowserDomAdapter.prototype.appendChild = function (el, node) { el.appendChild(node); };
        /**
         * @param {?} el
         * @param {?} node
         * @return {?}
         */
        BrowserDomAdapter.prototype.removeChild = function (el, node) { el.removeChild(node); };
        /**
         * @param {?} el
         * @param {?} newChild
         * @param {?} oldChild
         * @return {?}
         */
        BrowserDomAdapter.prototype.replaceChild = function (el, newChild, oldChild) { el.replaceChild(newChild, oldChild); };
        /**
         * @param {?} node
         * @return {?}
         */
        BrowserDomAdapter.prototype.remove = function (node) {
            if (node.parentNode) {
                node.parentNode.removeChild(node);
            }
            return node;
        };
        /**
         * @param {?} parent
         * @param {?} ref
         * @param {?} node
         * @return {?}
         */
        BrowserDomAdapter.prototype.insertBefore = function (parent, ref, node) { parent.insertBefore(node, ref); };
        /**
         * @param {?} parent
         * @param {?} ref
         * @param {?} nodes
         * @return {?}
         */
        BrowserDomAdapter.prototype.insertAllBefore = function (parent, ref, nodes) {
            nodes.forEach(( /**
             * @param {?} n
             * @return {?}
             */function (n) { return parent.insertBefore(n, ref); }));
        };
        /**
         * @param {?} parent
         * @param {?} ref
         * @param {?} node
         * @return {?}
         */
        BrowserDomAdapter.prototype.insertAfter = function (parent, ref, node) { parent.insertBefore(node, ref.nextSibling); };
        /**
         * @param {?} el
         * @param {?} value
         * @return {?}
         */
        BrowserDomAdapter.prototype.setInnerHTML = function (el, value) { el.innerHTML = value; };
        /**
         * @param {?} el
         * @return {?}
         */
        BrowserDomAdapter.prototype.getText = function (el) { return el.textContent; };
        /**
         * @param {?} el
         * @param {?} value
         * @return {?}
         */
        BrowserDomAdapter.prototype.setText = function (el, value) { el.textContent = value; };
        /**
         * @param {?} el
         * @return {?}
         */
        BrowserDomAdapter.prototype.getValue = function (el) { return el.value; };
        /**
         * @param {?} el
         * @param {?} value
         * @return {?}
         */
        BrowserDomAdapter.prototype.setValue = function (el, value) { el.value = value; };
        /**
         * @param {?} el
         * @return {?}
         */
        BrowserDomAdapter.prototype.getChecked = function (el) { return el.checked; };
        /**
         * @param {?} el
         * @param {?} value
         * @return {?}
         */
        BrowserDomAdapter.prototype.setChecked = function (el, value) { el.checked = value; };
        /**
         * @param {?} text
         * @return {?}
         */
        BrowserDomAdapter.prototype.createComment = function (text) { return this.getDefaultDocument().createComment(text); };
        /**
         * @param {?} html
         * @return {?}
         */
        BrowserDomAdapter.prototype.createTemplate = function (html) {
            /** @type {?} */
            var t = this.getDefaultDocument().createElement('template');
            t.innerHTML = html;
            return t;
        };
        /**
         * @param {?} tagName
         * @param {?=} doc
         * @return {?}
         */
        BrowserDomAdapter.prototype.createElement = function (tagName, doc) {
            doc = doc || this.getDefaultDocument();
            return doc.createElement(tagName);
        };
        /**
         * @param {?} ns
         * @param {?} tagName
         * @param {?=} doc
         * @return {?}
         */
        BrowserDomAdapter.prototype.createElementNS = function (ns, tagName, doc) {
            doc = doc || this.getDefaultDocument();
            return doc.createElementNS(ns, tagName);
        };
        /**
         * @param {?} text
         * @param {?=} doc
         * @return {?}
         */
        BrowserDomAdapter.prototype.createTextNode = function (text, doc) {
            doc = doc || this.getDefaultDocument();
            return doc.createTextNode(text);
        };
        /**
         * @param {?} attrName
         * @param {?} attrValue
         * @param {?=} doc
         * @return {?}
         */
        BrowserDomAdapter.prototype.createScriptTag = function (attrName, attrValue, doc) {
            doc = doc || this.getDefaultDocument();
            /** @type {?} */
            var el = ( /** @type {?} */(doc.createElement('SCRIPT')));
            el.setAttribute(attrName, attrValue);
            return el;
        };
        /**
         * @param {?} css
         * @param {?=} doc
         * @return {?}
         */
        BrowserDomAdapter.prototype.createStyleElement = function (css, doc) {
            doc = doc || this.getDefaultDocument();
            /** @type {?} */
            var style = ( /** @type {?} */(doc.createElement('style')));
            this.appendChild(style, this.createTextNode(css, doc));
            return style;
        };
        /**
         * @param {?} el
         * @return {?}
         */
        BrowserDomAdapter.prototype.createShadowRoot = function (el) { return (( /** @type {?} */(el))).createShadowRoot(); };
        /**
         * @param {?} el
         * @return {?}
         */
        BrowserDomAdapter.prototype.getShadowRoot = function (el) { return (( /** @type {?} */(el))).shadowRoot; };
        /**
         * @param {?} el
         * @return {?}
         */
        BrowserDomAdapter.prototype.getHost = function (el) { return (( /** @type {?} */(el))).host; };
        /**
         * @param {?} node
         * @return {?}
         */
        BrowserDomAdapter.prototype.clone = function (node) { return node.cloneNode(true); };
        /**
         * @param {?} element
         * @param {?} name
         * @return {?}
         */
        BrowserDomAdapter.prototype.getElementsByClassName = function (element, name) {
            return element.getElementsByClassName(name);
        };
        /**
         * @param {?} element
         * @param {?} name
         * @return {?}
         */
        BrowserDomAdapter.prototype.getElementsByTagName = function (element, name) {
            return element.getElementsByTagName(name);
        };
        /**
         * @param {?} element
         * @return {?}
         */
        BrowserDomAdapter.prototype.classList = function (element) { return Array.prototype.slice.call(element.classList, 0); };
        /**
         * @param {?} element
         * @param {?} className
         * @return {?}
         */
        BrowserDomAdapter.prototype.addClass = function (element, className) { element.classList.add(className); };
        /**
         * @param {?} element
         * @param {?} className
         * @return {?}
         */
        BrowserDomAdapter.prototype.removeClass = function (element, className) { element.classList.remove(className); };
        /**
         * @param {?} element
         * @param {?} className
         * @return {?}
         */
        BrowserDomAdapter.prototype.hasClass = function (element, className) {
            return element.classList.contains(className);
        };
        /**
         * @param {?} element
         * @param {?} styleName
         * @param {?} styleValue
         * @return {?}
         */
        BrowserDomAdapter.prototype.setStyle = function (element, styleName, styleValue) {
            element.style[styleName] = styleValue;
        };
        /**
         * @param {?} element
         * @param {?} stylename
         * @return {?}
         */
        BrowserDomAdapter.prototype.removeStyle = function (element, stylename) {
            // IE requires '' instead of null
            // see https://github.com/angular/angular/issues/7916
            element.style[stylename] = '';
        };
        /**
         * @param {?} element
         * @param {?} stylename
         * @return {?}
         */
        BrowserDomAdapter.prototype.getStyle = function (element, stylename) { return element.style[stylename]; };
        /**
         * @param {?} element
         * @param {?} styleName
         * @param {?=} styleValue
         * @return {?}
         */
        BrowserDomAdapter.prototype.hasStyle = function (element, styleName, styleValue) {
            /** @type {?} */
            var value = this.getStyle(element, styleName) || '';
            return styleValue ? value == styleValue : value.length > 0;
        };
        /**
         * @param {?} element
         * @return {?}
         */
        BrowserDomAdapter.prototype.tagName = function (element) { return element.tagName; };
        /**
         * @param {?} element
         * @return {?}
         */
        BrowserDomAdapter.prototype.attributeMap = function (element) {
            /** @type {?} */
            var res = new Map();
            /** @type {?} */
            var elAttrs = element.attributes;
            for (var i_122 = 0; i_122 < elAttrs.length; i_122++) {
                /** @type {?} */
                var attrib = elAttrs.item(i_122);
                res.set(attrib.name, attrib.value);
            }
            return res;
        };
        /**
         * @param {?} element
         * @param {?} attribute
         * @return {?}
         */
        BrowserDomAdapter.prototype.hasAttribute = function (element, attribute) {
            return element.hasAttribute(attribute);
        };
        /**
         * @param {?} element
         * @param {?} ns
         * @param {?} attribute
         * @return {?}
         */
        BrowserDomAdapter.prototype.hasAttributeNS = function (element, ns, attribute) {
            return element.hasAttributeNS(ns, attribute);
        };
        /**
         * @param {?} element
         * @param {?} attribute
         * @return {?}
         */
        BrowserDomAdapter.prototype.getAttribute = function (element, attribute) {
            return element.getAttribute(attribute);
        };
        /**
         * @param {?} element
         * @param {?} ns
         * @param {?} name
         * @return {?}
         */
        BrowserDomAdapter.prototype.getAttributeNS = function (element, ns, name) {
            return element.getAttributeNS(ns, name);
        };
        /**
         * @param {?} element
         * @param {?} name
         * @param {?} value
         * @return {?}
         */
        BrowserDomAdapter.prototype.setAttribute = function (element, name, value) { element.setAttribute(name, value); };
        /**
         * @param {?} element
         * @param {?} ns
         * @param {?} name
         * @param {?} value
         * @return {?}
         */
        BrowserDomAdapter.prototype.setAttributeNS = function (element, ns, name, value) {
            element.setAttributeNS(ns, name, value);
        };
        /**
         * @param {?} element
         * @param {?} attribute
         * @return {?}
         */
        BrowserDomAdapter.prototype.removeAttribute = function (element, attribute) { element.removeAttribute(attribute); };
        /**
         * @param {?} element
         * @param {?} ns
         * @param {?} name
         * @return {?}
         */
        BrowserDomAdapter.prototype.removeAttributeNS = function (element, ns, name) {
            element.removeAttributeNS(ns, name);
        };
        /**
         * @param {?} el
         * @return {?}
         */
        BrowserDomAdapter.prototype.templateAwareRoot = function (el) { return this.isTemplateElement(el) ? this.content(el) : el; };
        /**
         * @return {?}
         */
        BrowserDomAdapter.prototype.createHtmlDocument = function () {
            return document.implementation.createHTMLDocument('fakeTitle');
        };
        /**
         * @return {?}
         */
        BrowserDomAdapter.prototype.getDefaultDocument = function () { return document; };
        /**
         * @param {?} el
         * @return {?}
         */
        BrowserDomAdapter.prototype.getBoundingClientRect = function (el) {
            try {
                return el.getBoundingClientRect();
            }
            catch (_a) {
                return { top: 0, bottom: 0, left: 0, right: 0, width: 0, height: 0 };
            }
        };
        /**
         * @param {?} doc
         * @return {?}
         */
        BrowserDomAdapter.prototype.getTitle = function (doc) { return doc.title; };
        /**
         * @param {?} doc
         * @param {?} newTitle
         * @return {?}
         */
        BrowserDomAdapter.prototype.setTitle = function (doc, newTitle) { doc.title = newTitle || ''; };
        /**
         * @param {?} n
         * @param {?} selector
         * @return {?}
         */
        BrowserDomAdapter.prototype.elementMatches = function (n, selector) {
            if (this.isElementNode(n)) {
                return n.matches && n.matches(selector) ||
                    n.msMatchesSelector && n.msMatchesSelector(selector) ||
                    n.webkitMatchesSelector && n.webkitMatchesSelector(selector);
            }
            return false;
        };
        /**
         * @param {?} el
         * @return {?}
         */
        BrowserDomAdapter.prototype.isTemplateElement = function (el) {
            return this.isElementNode(el) && el.nodeName === 'TEMPLATE';
        };
        /**
         * @param {?} node
         * @return {?}
         */
        BrowserDomAdapter.prototype.isTextNode = function (node) { return node.nodeType === Node.TEXT_NODE; };
        /**
         * @param {?} node
         * @return {?}
         */
        BrowserDomAdapter.prototype.isCommentNode = function (node) { return node.nodeType === Node.COMMENT_NODE; };
        /**
         * @param {?} node
         * @return {?}
         */
        BrowserDomAdapter.prototype.isElementNode = function (node) { return node.nodeType === Node.ELEMENT_NODE; };
        /**
         * @param {?} node
         * @return {?}
         */
        BrowserDomAdapter.prototype.hasShadowRoot = function (node) {
            return node.shadowRoot != null && node instanceof HTMLElement;
        };
        /**
         * @param {?} node
         * @return {?}
         */
        BrowserDomAdapter.prototype.isShadowRoot = function (node) { return node instanceof DocumentFragment; };
        /**
         * @param {?} node
         * @return {?}
         */
        BrowserDomAdapter.prototype.importIntoDoc = function (node) { return document.importNode(this.templateAwareRoot(node), true); };
        /**
         * @param {?} node
         * @return {?}
         */
        BrowserDomAdapter.prototype.adoptNode = function (node) { return document.adoptNode(node); };
        /**
         * @param {?} el
         * @return {?}
         */
        BrowserDomAdapter.prototype.getHref = function (el) { return ( /** @type {?} */(el.getAttribute('href'))); };
        /**
         * @param {?} event
         * @return {?}
         */
        BrowserDomAdapter.prototype.getEventKey = function (event) {
            /** @type {?} */
            var key = event.key;
            if (key == null) {
                key = event.keyIdentifier;
                // keyIdentifier is defined in the old draft of DOM Level 3 Events implemented by Chrome and
                // Safari cf
                // http://www.w3.org/TR/2007/WD-DOM-Level-3-Events-20071221/events.html#Events-KeyboardEvents-Interfaces
                if (key == null) {
                    return 'Unidentified';
                }
                if (key.startsWith('U+')) {
                    key = String.fromCharCode(parseInt(key.substring(2), 16));
                    if (event.location === DOM_KEY_LOCATION_NUMPAD && _chromeNumKeyPadMap.hasOwnProperty(key)) {
                        // There is a bug in Chrome for numeric keypad keys:
                        // https://code.google.com/p/chromium/issues/detail?id=155654
                        // 1, 2, 3 ... are reported as A, B, C ...
                        key = (( /** @type {?} */(_chromeNumKeyPadMap)))[key];
                    }
                }
            }
            return _keyMap[key] || key;
        };
        /**
         * @param {?} doc
         * @param {?} target
         * @return {?}
         */
        BrowserDomAdapter.prototype.getGlobalEventTarget = function (doc, target) {
            if (target === 'window') {
                return window;
            }
            if (target === 'document') {
                return doc;
            }
            if (target === 'body') {
                return doc.body;
            }
            return null;
        };
        /**
         * @return {?}
         */
        BrowserDomAdapter.prototype.getHistory = function () { return window.history; };
        /**
         * @return {?}
         */
        BrowserDomAdapter.prototype.getLocation = function () { return window.location; };
        /**
         * @param {?} doc
         * @return {?}
         */
        BrowserDomAdapter.prototype.getBaseHref = function (doc) {
            /** @type {?} */
            var href = getBaseElementHref();
            return href == null ? null : relativePath(href);
        };
        /**
         * @return {?}
         */
        BrowserDomAdapter.prototype.resetBaseElement = function () { baseElement = null; };
        /**
         * @return {?}
         */
        BrowserDomAdapter.prototype.getUserAgent = function () { return window.navigator.userAgent; };
        /**
         * @param {?} element
         * @param {?} name
         * @param {?} value
         * @return {?}
         */
        BrowserDomAdapter.prototype.setData = function (element, name, value) {
            this.setAttribute(element, 'data-' + name, value);
        };
        /**
         * @param {?} element
         * @param {?} name
         * @return {?}
         */
        BrowserDomAdapter.prototype.getData = function (element, name) {
            return this.getAttribute(element, 'data-' + name);
        };
        /**
         * @param {?} element
         * @return {?}
         */
        BrowserDomAdapter.prototype.getComputedStyle = function (element) { return getComputedStyle(element); };
        // TODO(tbosch): move this into a separate environment class once we have it
        /**
         * @return {?}
         */
        BrowserDomAdapter.prototype.supportsWebAnimation = function () {
            return typeof (( /** @type {?} */(Element))).prototype['animate'] === 'function';
        };
        /**
         * @return {?}
         */
        BrowserDomAdapter.prototype.performanceNow = function () {
            // performance.now() is not available in all browsers, see
            // http://caniuse.com/#search=performance.now
            return window.performance && window.performance.now ? window.performance.now() :
                new Date().getTime();
        };
        /**
         * @return {?}
         */
        BrowserDomAdapter.prototype.supportsCookies = function () { return true; };
        /**
         * @param {?} name
         * @return {?}
         */
        BrowserDomAdapter.prototype.getCookie = function (name) { return parseCookieValue(document.cookie, name); };
        /**
         * @param {?} name
         * @param {?} value
         * @return {?}
         */
        BrowserDomAdapter.prototype.setCookie = function (name, value) {
            // document.cookie is magical, assigning into it assigns/overrides one cookie value, but does
            // not clear other cookies.
            document.cookie = encodeURIComponent(name) + '=' + encodeURIComponent(value);
        };
        return BrowserDomAdapter;
    }(GenericBrowserDomAdapter));
    /** @type {?} */
    var baseElement = null;
    /**
     * @return {?}
     */
    function getBaseElementHref() {
        if (!baseElement) {
            baseElement = ( /** @type {?} */(document.querySelector('base')));
            if (!baseElement) {
                return null;
            }
        }
        return baseElement.getAttribute('href');
    }
    // based on urlUtils.js in AngularJS 1
    /** @type {?} */
    var urlParsingNode;
    /**
     * @param {?} url
     * @return {?}
     */
    function relativePath(url) {
        if (!urlParsingNode) {
            urlParsingNode = document.createElement('a');
        }
        urlParsingNode.setAttribute('href', url);
        return (urlParsingNode.pathname.charAt(0) === '/') ? urlParsingNode.pathname :
            '/' + urlParsingNode.pathname;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @return {?}
     */
    function supportsState() {
        return !!window.history.pushState;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * `PlatformLocation` encapsulates all of the direct calls to platform APIs.
     * This class should not be used directly by an application developer. Instead, use
     * {\@link Location}.
     */
    var BrowserPlatformLocation = /** @class */ (function (_super) {
        __extends(BrowserPlatformLocation, _super);
        /**
         * @param {?} _doc
         */
        function BrowserPlatformLocation(_doc) {
            var _this = _super.call(this) || this;
            _this._doc = _doc;
            _this._init();
            return _this;
        }
        // This is moved to its own method so that `MockPlatformLocationStrategy` can overwrite it
        /**
         * \@internal
         * @return {?}
         */
        BrowserPlatformLocation.prototype._init = function () {
            (( /** @type {?} */(this))).location = getDOM().getLocation();
            this._history = getDOM().getHistory();
        };
        /**
         * @return {?}
         */
        BrowserPlatformLocation.prototype.getBaseHrefFromDOM = function () { return ( /** @type {?} */(getDOM().getBaseHref(this._doc))); };
        /**
         * @param {?} fn
         * @return {?}
         */
        BrowserPlatformLocation.prototype.onPopState = function (fn) {
            getDOM().getGlobalEventTarget(this._doc, 'window').addEventListener('popstate', fn, false);
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        BrowserPlatformLocation.prototype.onHashChange = function (fn) {
            getDOM().getGlobalEventTarget(this._doc, 'window').addEventListener('hashchange', fn, false);
        };
        Object.defineProperty(BrowserPlatformLocation.prototype, "href", {
            /**
             * @return {?}
             */
            get: function () { return this.location.href; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BrowserPlatformLocation.prototype, "protocol", {
            /**
             * @return {?}
             */
            get: function () { return this.location.protocol; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BrowserPlatformLocation.prototype, "hostname", {
            /**
             * @return {?}
             */
            get: function () { return this.location.hostname; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BrowserPlatformLocation.prototype, "port", {
            /**
             * @return {?}
             */
            get: function () { return this.location.port; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BrowserPlatformLocation.prototype, "pathname", {
            /**
             * @return {?}
             */
            get: function () { return this.location.pathname; },
            /**
             * @param {?} newPath
             * @return {?}
             */
            set: function (newPath) { this.location.pathname = newPath; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BrowserPlatformLocation.prototype, "search", {
            /**
             * @return {?}
             */
            get: function () { return this.location.search; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BrowserPlatformLocation.prototype, "hash", {
            /**
             * @return {?}
             */
            get: function () { return this.location.hash; },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} state
         * @param {?} title
         * @param {?} url
         * @return {?}
         */
        BrowserPlatformLocation.prototype.pushState = function (state, title, url) {
            if (supportsState()) {
                this._history.pushState(state, title, url);
            }
            else {
                this.location.hash = url;
            }
        };
        /**
         * @param {?} state
         * @param {?} title
         * @param {?} url
         * @return {?}
         */
        BrowserPlatformLocation.prototype.replaceState = function (state, title, url) {
            if (supportsState()) {
                this._history.replaceState(state, title, url);
            }
            else {
                this.location.hash = url;
            }
        };
        /**
         * @return {?}
         */
        BrowserPlatformLocation.prototype.forward = function () { this._history.forward(); };
        /**
         * @return {?}
         */
        BrowserPlatformLocation.prototype.back = function () { this._history.back(); };
        /**
         * @return {?}
         */
        BrowserPlatformLocation.prototype.getState = function () { return this._history.state; };
        return BrowserPlatformLocation;
    }(PlatformLocation));
    BrowserPlatformLocation.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    BrowserPlatformLocation.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * An id that identifies a particular application being bootstrapped, that should
     * match across the client/server boundary.
     * @type {?}
     */
    var TRANSITION_ID = new InjectionToken('TRANSITION_ID');
    /**
     * @param {?} transitionId
     * @param {?} document
     * @param {?} injector
     * @return {?}
     */
    function appInitializerFactory(transitionId, document, injector) {
        return ( /**
         * @return {?}
         */function () {
            // Wait for all application initializers to be completed before removing the styles set by
            // the server.
            injector.get(ApplicationInitStatus).donePromise.then(( /**
             * @return {?}
             */function () {
                /** @type {?} */
                var dom = getDOM();
                /** @type {?} */
                var styles = Array.prototype.slice.apply(dom.querySelectorAll(document, "style[ng-transition]"));
                styles.filter(( /**
                 * @param {?} el
                 * @return {?}
                 */function (/**
                 * @param {?} el
                 * @return {?}
                 */ el) { return dom.getAttribute(el, 'ng-transition') === transitionId; }))
                    .forEach(( /**
             * @param {?} el
             * @return {?}
             */function (/**
             * @param {?} el
             * @return {?}
             */ el) { return dom.remove(el); }));
            }));
        });
    }
    /** @type {?} */
    var SERVER_TRANSITION_PROVIDERS = [
        {
            provide: APP_INITIALIZER,
            useFactory: appInitializerFactory,
            deps: [TRANSITION_ID, DOCUMENT, Injector],
            multi: true
        },
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BrowserGetTestability = /** @class */ (function () {
        function BrowserGetTestability() {
        }
        /**
         * @return {?}
         */
        BrowserGetTestability.init = function () { setTestabilityGetter(new BrowserGetTestability()); };
        /**
         * @param {?} registry
         * @return {?}
         */
        BrowserGetTestability.prototype.addToWindow = function (registry) {
            _global['getAngularTestability'] = ( /**
             * @param {?} elem
             * @param {?=} findInAncestors
             * @return {?}
             */function (elem, findInAncestors) {
                if (findInAncestors === void 0) { findInAncestors = true; }
                /** @type {?} */
                var testability = registry.findTestabilityInTree(elem, findInAncestors);
                if (testability == null) {
                    throw new Error('Could not find testability for element.');
                }
                return testability;
            });
            _global['getAllAngularTestabilities'] = ( /**
             * @return {?}
             */function () { return registry.getAllTestabilities(); });
            _global['getAllAngularRootElements'] = ( /**
             * @return {?}
             */function () { return registry.getAllRootElements(); });
            /** @type {?} */
            var whenAllStable = ( /**
             * @param {?} callback
             * @return {?}
             */function (callback /** TODO #9100 */) {
                /** @type {?} */
                var testabilities = _global['getAllAngularTestabilities']();
                /** @type {?} */
                var count = testabilities.length;
                /** @type {?} */
                var didWork = false;
                /** @type {?} */
                var decrement = ( /**
                 * @param {?} didWork_
                 * @return {?}
                 */function (didWork_ /** TODO #9100 */) {
                    didWork = didWork || didWork_;
                    count--;
                    if (count == 0) {
                        callback(didWork);
                    }
                });
                testabilities.forEach(( /**
                 * @param {?} testability
                 * @return {?}
                 */function (testability /** TODO #9100 */) {
                    testability.whenStable(decrement);
                }));
            });
            if (!_global['frameworkStabilizers']) {
                _global['frameworkStabilizers'] = [];
            }
            _global['frameworkStabilizers'].push(whenAllStable);
        };
        /**
         * @param {?} registry
         * @param {?} elem
         * @param {?} findInAncestors
         * @return {?}
         */
        BrowserGetTestability.prototype.findTestabilityInTree = function (registry, elem, findInAncestors) {
            if (elem == null) {
                return null;
            }
            /** @type {?} */
            var t = registry.getTestability(elem);
            if (t != null) {
                return t;
            }
            else if (!findInAncestors) {
                return null;
            }
            if (getDOM().isShadowRoot(elem)) {
                return this.findTestabilityInTree(registry, getDOM().getHost(elem), true);
            }
            return this.findTestabilityInTree(registry, getDOM().parentElement(elem), true);
        };
        return BrowserGetTestability;
    }());
    /**
     * Exports the value under a given `name` in the global property `ng`. For example `ng.probe` if
     * `name` is `'probe'`.
     * @param {?} name Name under which it will be exported. Keep in mind this will be a property of the
     * global `ng` object.
     * @param {?} value The value to export.
     * @return {?}
     */
    function exportNgVar(name, value) {
        if (typeof COMPILED === 'undefined' || !COMPILED) {
            // Note: we can't export `ng` when using closure enhanced optimization as:
            // - closure declares globals itself for minified names, which sometimes clobber our `ng` global
            // - we can't declare a closure extern as the namespace `ng` is already used within Google
            //   for typings for angularJS (via `goog.provide('ng....')`).
            /** @type {?} */
            var ng = _global['ng'] = (( /** @type {?} */(_global['ng']))) || {};
            ng[name] = value;
        }
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ɵ0$1$2 = /**
     * @return {?}
     */ function () { return ({
        'ApplicationRef': ApplicationRef,
        'NgZone': NgZone,
    }); };
    /** @type {?} */
    var CORE_TOKENS = ((ɵ0$1$2))();
    /** @type {?} */
    var INSPECT_GLOBAL_NAME = 'probe';
    /** @type {?} */
    var CORE_TOKENS_GLOBAL_NAME = 'coreTokens';
    /**
     * Returns a {\@link DebugElement} for the given native DOM element, or
     * null if the given native element does not have an Angular view associated
     * with it.
     * @param {?} element
     * @return {?}
     */
    function inspectNativeElement(element) {
        return getDebugNode(element);
    }
    /**
     * @param {?} coreTokens
     * @return {?}
     */
    function _createNgProbe(coreTokens) {
        exportNgVar(INSPECT_GLOBAL_NAME, inspectNativeElement);
        exportNgVar(CORE_TOKENS_GLOBAL_NAME, Object.assign({}, CORE_TOKENS, _ngProbeTokensToMap(coreTokens || [])));
        return ( /**
         * @return {?}
         */function () { return inspectNativeElement; });
    }
    /**
     * @param {?} tokens
     * @return {?}
     */
    function _ngProbeTokensToMap(tokens) {
        return tokens.reduce(( /**
         * @param {?} prev
         * @param {?} t
         * @return {?}
         */function (prev, t) { return (prev[t.name] = t.token, prev); }), {});
    }
    /**
     * Providers which support debugging Angular applications (e.g. via `ng.probe`).
     * @type {?}
     */
    var ELEMENT_PROBE_PROVIDERS__PRE_R3__ = [
        {
            provide: APP_INITIALIZER,
            useFactory: _createNgProbe,
            deps: [
                [NgProbeToken, new Optional()],
            ],
            multi: true,
        },
    ];
    /** @type {?} */
    var ELEMENT_PROBE_PROVIDERS = ELEMENT_PROBE_PROVIDERS__PRE_R3__;
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The injection token for the event-manager plug-in service.
     *
     * \@publicApi
     * @type {?}
     */
    var EVENT_MANAGER_PLUGINS = new InjectionToken('EventManagerPlugins');
    /**
     * An injectable service that provides event management for Angular
     * through a browser plug-in.
     *
     * \@publicApi
     */
    var EventManager = /** @class */ (function () {
        /**
         * Initializes an instance of the event-manager service.
         * @param {?} plugins
         * @param {?} _zone
         */
        function EventManager(plugins, _zone) {
            var _this = this;
            this._zone = _zone;
            this._eventNameToPlugin = new Map();
            plugins.forEach(( /**
             * @template THIS
             * @this {THIS}
             * @param {?} p
             * @return {THIS}
             */function (/**
             * @template THIS
             * @this {THIS}
             * @param {?} p
             * @return {THIS}
             */ p) { return p.manager = _this; }));
            this._plugins = plugins.slice().reverse();
        }
        /**
         * Registers a handler for a specific element and event.
         *
         * @param {?} element The HTML element to receive event notifications.
         * @param {?} eventName The name of the event to listen for.
         * @param {?} handler A function to call when the notification occurs. Receives the
         * event object as an argument.
         * @return {?} A callback function that can be used to remove the handler.
         */
        EventManager.prototype.addEventListener = function (element, eventName, handler) {
            /** @type {?} */
            var plugin = this._findPluginFor(eventName);
            return plugin.addEventListener(element, eventName, handler);
        };
        /**
         * Registers a global handler for an event in a target view.
         *
         * @param {?} target A target for global event notifications. One of "window", "document", or "body".
         * @param {?} eventName The name of the event to listen for.
         * @param {?} handler A function to call when the notification occurs. Receives the
         * event object as an argument.
         * @return {?} A callback function that can be used to remove the handler.
         */
        EventManager.prototype.addGlobalEventListener = function (target, eventName, handler) {
            /** @type {?} */
            var plugin = this._findPluginFor(eventName);
            return plugin.addGlobalEventListener(target, eventName, handler);
        };
        /**
         * Retrieves the compilation zone in which event listeners are registered.
         * @return {?}
         */
        EventManager.prototype.getZone = function () { return this._zone; };
        /**
         * \@internal
         * @param {?} eventName
         * @return {?}
         */
        EventManager.prototype._findPluginFor = function (eventName) {
            /** @type {?} */
            var plugin = this._eventNameToPlugin.get(eventName);
            if (plugin) {
                return plugin;
            }
            /** @type {?} */
            var plugins = this._plugins;
            for (var i_123 = 0; i_123 < plugins.length; i_123++) {
                /** @type {?} */
                var plugin_1 = plugins[i_123];
                if (plugin_1.supports(eventName)) {
                    this._eventNameToPlugin.set(eventName, plugin_1);
                    return plugin_1;
                }
            }
            throw new Error("No event manager plugin found for event " + eventName);
        };
        return EventManager;
    }());
    EventManager.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    EventManager.ctorParameters = function () { return [
        { type: Array, decorators: [{ type: Inject, args: [EVENT_MANAGER_PLUGINS,] }] },
        { type: NgZone }
    ]; };
    /**
     * @abstract
     */
    var EventManagerPlugin = /** @class */ (function () {
        /**
         * @param {?} _doc
         */
        function EventManagerPlugin(_doc) {
            this._doc = _doc;
        }
        /**
         * @param {?} element
         * @param {?} eventName
         * @param {?} handler
         * @return {?}
         */
        EventManagerPlugin.prototype.addGlobalEventListener = function (element, eventName, handler) {
            /** @type {?} */
            var target = getDOM().getGlobalEventTarget(this._doc, element);
            if (!target) {
                throw new Error("Unsupported event target " + target + " for event " + eventName);
            }
            return this.addEventListener(target, eventName, handler);
        };
        return EventManagerPlugin;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SharedStylesHost = /** @class */ (function () {
        function SharedStylesHost() {
            /**
             * \@internal
             */
            this._stylesSet = new Set();
        }
        /**
         * @param {?} styles
         * @return {?}
         */
        SharedStylesHost.prototype.addStyles = function (styles) {
            var _this = this;
            /** @type {?} */
            var additions = new Set();
            styles.forEach(( /**
             * @param {?} style
             * @return {?}
             */function (/**
             * @param {?} style
             * @return {?}
             */ style) {
                if (!_this._stylesSet.has(style)) {
                    _this._stylesSet.add(style);
                    additions.add(style);
                }
            }));
            this.onStylesAdded(additions);
        };
        /**
         * @param {?} additions
         * @return {?}
         */
        SharedStylesHost.prototype.onStylesAdded = function (additions) { };
        /**
         * @return {?}
         */
        SharedStylesHost.prototype.getAllStyles = function () { return Array.from(this._stylesSet); };
        return SharedStylesHost;
    }());
    SharedStylesHost.decorators = [
        { type: Injectable }
    ];
    var DomSharedStylesHost = /** @class */ (function (_super) {
        __extends(DomSharedStylesHost, _super);
        /**
         * @param {?} _doc
         */
        function DomSharedStylesHost(_doc) {
            var _this = _super.call(this) || this;
            _this._doc = _doc;
            _this._hostNodes = new Set();
            _this._styleNodes = new Set();
            _this._hostNodes.add(_doc.head);
            return _this;
        }
        /**
         * @private
         * @param {?} styles
         * @param {?} host
         * @return {?}
         */
        DomSharedStylesHost.prototype._addStylesToHost = function (styles, host) {
            var _this = this;
            styles.forEach(( /**
             * @param {?} style
             * @return {?}
             */function (style) {
                /** @type {?} */
                var styleEl = _this._doc.createElement('style');
                styleEl.textContent = style;
                _this._styleNodes.add(host.appendChild(styleEl));
            }));
        };
        /**
         * @param {?} hostNode
         * @return {?}
         */
        DomSharedStylesHost.prototype.addHost = function (hostNode) {
            this._addStylesToHost(this._stylesSet, hostNode);
            this._hostNodes.add(hostNode);
        };
        /**
         * @param {?} hostNode
         * @return {?}
         */
        DomSharedStylesHost.prototype.removeHost = function (hostNode) { this._hostNodes.delete(hostNode); };
        /**
         * @param {?} additions
         * @return {?}
         */
        DomSharedStylesHost.prototype.onStylesAdded = function (additions) {
            var _this = this;
            this._hostNodes.forEach(( /**
             * @param {?} hostNode
             * @return {?}
             */function (/**
             * @param {?} hostNode
             * @return {?}
             */ hostNode) { return _this._addStylesToHost(additions, hostNode); }));
        };
        /**
         * @return {?}
         */
        DomSharedStylesHost.prototype.ngOnDestroy = function () {
            this._styleNodes.forEach(( /**
             * @param {?} styleNode
             * @return {?}
             */function (/**
             * @param {?} styleNode
             * @return {?}
             */ styleNode) { return getDOM().remove(styleNode); }));
        };
        return DomSharedStylesHost;
    }(SharedStylesHost));
    DomSharedStylesHost.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    DomSharedStylesHost.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var NAMESPACE_URIS = {
        'svg': 'http://www.w3.org/2000/svg',
        'xhtml': 'http://www.w3.org/1999/xhtml',
        'xlink': 'http://www.w3.org/1999/xlink',
        'xml': 'http://www.w3.org/XML/1998/namespace',
        'xmlns': 'http://www.w3.org/2000/xmlns/',
    };
    /** @type {?} */
    var COMPONENT_REGEX = /%COMP%/g;
    /** @type {?} */
    var COMPONENT_VARIABLE = '%COMP%';
    /** @type {?} */
    var HOST_ATTR = "_nghost-" + COMPONENT_VARIABLE;
    /** @type {?} */
    var CONTENT_ATTR = "_ngcontent-" + COMPONENT_VARIABLE;
    /**
     * @param {?} componentShortId
     * @return {?}
     */
    function shimContentAttribute(componentShortId) {
        return CONTENT_ATTR.replace(COMPONENT_REGEX, componentShortId);
    }
    /**
     * @param {?} componentShortId
     * @return {?}
     */
    function shimHostAttribute(componentShortId) {
        return HOST_ATTR.replace(COMPONENT_REGEX, componentShortId);
    }
    /**
     * @param {?} compId
     * @param {?} styles
     * @param {?} target
     * @return {?}
     */
    function flattenStyles(compId, styles, target) {
        for (var i_124 = 0; i_124 < styles.length; i_124++) {
            /** @type {?} */
            var style_1 = styles[i_124];
            if (Array.isArray(style_1)) {
                flattenStyles(compId, style_1, target);
            }
            else {
                style_1 = style_1.replace(COMPONENT_REGEX, compId);
                target.push(style_1);
            }
        }
        return target;
    }
    /**
     * @param {?} eventHandler
     * @return {?}
     */
    function decoratePreventDefault(eventHandler) {
        return ( /**
         * @param {?} event
         * @return {?}
         */function (event) {
            /** @type {?} */
            var allowDefaultBehavior = eventHandler(event);
            if (allowDefaultBehavior === false) {
                // TODO(tbosch): move preventDefault into event plugins...
                event.preventDefault();
                event.returnValue = false;
            }
        });
    }
    var DomRendererFactory2 = /** @class */ (function () {
        /**
         * @param {?} eventManager
         * @param {?} sharedStylesHost
         * @param {?} appId
         */
        function DomRendererFactory2(eventManager, sharedStylesHost, appId) {
            this.eventManager = eventManager;
            this.sharedStylesHost = sharedStylesHost;
            this.appId = appId;
            this.rendererByCompId = new Map();
            this.defaultRenderer = new DefaultDomRenderer2(eventManager);
        }
        /**
         * @param {?} element
         * @param {?} type
         * @return {?}
         */
        DomRendererFactory2.prototype.createRenderer = function (element, type) {
            if (!element || !type) {
                return this.defaultRenderer;
            }
            switch (type.encapsulation) {
                case ViewEncapsulation.Emulated: {
                    /** @type {?} */
                    var renderer = this.rendererByCompId.get(type.id);
                    if (!renderer) {
                        renderer = new EmulatedEncapsulationDomRenderer2(this.eventManager, this.sharedStylesHost, type, this.appId);
                        this.rendererByCompId.set(type.id, renderer);
                    }
                    (( /** @type {?} */(renderer))).applyToHost(element);
                    return renderer;
                }
                case ViewEncapsulation.Native:
                case ViewEncapsulation.ShadowDom:
                    return new ShadowDomRenderer(this.eventManager, this.sharedStylesHost, element, type);
                default: {
                    if (!this.rendererByCompId.has(type.id)) {
                        /** @type {?} */
                        var styles_2 = flattenStyles(type.id, type.styles, []);
                        this.sharedStylesHost.addStyles(styles_2);
                        this.rendererByCompId.set(type.id, this.defaultRenderer);
                    }
                    return this.defaultRenderer;
                }
            }
        };
        /**
         * @return {?}
         */
        DomRendererFactory2.prototype.begin = function () { };
        /**
         * @return {?}
         */
        DomRendererFactory2.prototype.end = function () { };
        return DomRendererFactory2;
    }());
    DomRendererFactory2.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    DomRendererFactory2.ctorParameters = function () { return [
        { type: EventManager },
        { type: DomSharedStylesHost },
        { type: String, decorators: [{ type: Inject, args: [APP_ID,] }] }
    ]; };
    var DefaultDomRenderer2 = /** @class */ (function () {
        /**
         * @param {?} eventManager
         */
        function DefaultDomRenderer2(eventManager) {
            this.eventManager = eventManager;
            this.data = Object.create(null);
        }
        /**
         * @return {?}
         */
        DefaultDomRenderer2.prototype.destroy = function () { };
        /**
         * @param {?} name
         * @param {?=} namespace
         * @return {?}
         */
        DefaultDomRenderer2.prototype.createElement = function (name, namespace) {
            if (namespace) {
                // In cases where Ivy (not ViewEngine) is giving us the actual namespace, the look up by key
                // will result in undefined, so we just return the namespace here.
                return document.createElementNS(NAMESPACE_URIS[namespace] || namespace, name);
            }
            return document.createElement(name);
        };
        /**
         * @param {?} value
         * @return {?}
         */
        DefaultDomRenderer2.prototype.createComment = function (value) { return document.createComment(value); };
        /**
         * @param {?} value
         * @return {?}
         */
        DefaultDomRenderer2.prototype.createText = function (value) { return document.createTextNode(value); };
        /**
         * @param {?} parent
         * @param {?} newChild
         * @return {?}
         */
        DefaultDomRenderer2.prototype.appendChild = function (parent, newChild) { parent.appendChild(newChild); };
        /**
         * @param {?} parent
         * @param {?} newChild
         * @param {?} refChild
         * @return {?}
         */
        DefaultDomRenderer2.prototype.insertBefore = function (parent, newChild, refChild) {
            if (parent) {
                parent.insertBefore(newChild, refChild);
            }
        };
        /**
         * @param {?} parent
         * @param {?} oldChild
         * @return {?}
         */
        DefaultDomRenderer2.prototype.removeChild = function (parent, oldChild) {
            if (parent) {
                parent.removeChild(oldChild);
            }
        };
        /**
         * @param {?} selectorOrNode
         * @param {?=} preserveContent
         * @return {?}
         */
        DefaultDomRenderer2.prototype.selectRootElement = function (selectorOrNode, preserveContent) {
            /** @type {?} */
            var el = typeof selectorOrNode === 'string' ? document.querySelector(selectorOrNode) :
                selectorOrNode;
            if (!el) {
                throw new Error("The selector \"" + selectorOrNode + "\" did not match any elements");
            }
            if (!preserveContent) {
                el.textContent = '';
            }
            return el;
        };
        /**
         * @param {?} node
         * @return {?}
         */
        DefaultDomRenderer2.prototype.parentNode = function (node) { return node.parentNode; };
        /**
         * @param {?} node
         * @return {?}
         */
        DefaultDomRenderer2.prototype.nextSibling = function (node) { return node.nextSibling; };
        /**
         * @param {?} el
         * @param {?} name
         * @param {?} value
         * @param {?=} namespace
         * @return {?}
         */
        DefaultDomRenderer2.prototype.setAttribute = function (el, name, value, namespace) {
            if (namespace) {
                name = namespace + ':' + name;
                // TODO(benlesh): Ivy may cause issues here because it's passing around
                // full URIs for namespaces, therefore this lookup will fail.
                /** @type {?} */
                var namespaceUri = NAMESPACE_URIS[namespace];
                if (namespaceUri) {
                    el.setAttributeNS(namespaceUri, name, value);
                }
                else {
                    el.setAttribute(name, value);
                }
            }
            else {
                el.setAttribute(name, value);
            }
        };
        /**
         * @param {?} el
         * @param {?} name
         * @param {?=} namespace
         * @return {?}
         */
        DefaultDomRenderer2.prototype.removeAttribute = function (el, name, namespace) {
            if (namespace) {
                // TODO(benlesh): Ivy may cause issues here because it's passing around
                // full URIs for namespaces, therefore this lookup will fail.
                /** @type {?} */
                var namespaceUri = NAMESPACE_URIS[namespace];
                if (namespaceUri) {
                    el.removeAttributeNS(namespaceUri, name);
                }
                else {
                    // TODO(benlesh): Since ivy is passing around full URIs for namespaces
                    // this could result in properties like `http://www.w3.org/2000/svg:cx="123"`,
                    // which is wrong.
                    el.removeAttribute(namespace + ":" + name);
                }
            }
            else {
                el.removeAttribute(name);
            }
        };
        /**
         * @param {?} el
         * @param {?} name
         * @return {?}
         */
        DefaultDomRenderer2.prototype.addClass = function (el, name) { el.classList.add(name); };
        /**
         * @param {?} el
         * @param {?} name
         * @return {?}
         */
        DefaultDomRenderer2.prototype.removeClass = function (el, name) { el.classList.remove(name); };
        /**
         * @param {?} el
         * @param {?} style
         * @param {?} value
         * @param {?} flags
         * @return {?}
         */
        DefaultDomRenderer2.prototype.setStyle = function (el, style, value, flags) {
            if (flags & RendererStyleFlags2.DashCase) {
                el.style.setProperty(style, value, !!(flags & RendererStyleFlags2.Important) ? 'important' : '');
            }
            else {
                el.style[style] = value;
            }
        };
        /**
         * @param {?} el
         * @param {?} style
         * @param {?} flags
         * @return {?}
         */
        DefaultDomRenderer2.prototype.removeStyle = function (el, style, flags) {
            if (flags & RendererStyleFlags2.DashCase) {
                el.style.removeProperty(style);
            }
            else {
                // IE requires '' instead of null
                // see https://github.com/angular/angular/issues/7916
                el.style[style] = '';
            }
        };
        /**
         * @param {?} el
         * @param {?} name
         * @param {?} value
         * @return {?}
         */
        DefaultDomRenderer2.prototype.setProperty = function (el, name, value) {
            checkNoSyntheticProp(name, 'property');
            el[name] = value;
        };
        /**
         * @param {?} node
         * @param {?} value
         * @return {?}
         */
        DefaultDomRenderer2.prototype.setValue = function (node, value) { node.nodeValue = value; };
        /**
         * @param {?} target
         * @param {?} event
         * @param {?} callback
         * @return {?}
         */
        DefaultDomRenderer2.prototype.listen = function (target, event, callback) {
            checkNoSyntheticProp(event, 'listener');
            if (typeof target === 'string') {
                return ( /** @type {?} */(this.eventManager.addGlobalEventListener(target, event, decoratePreventDefault(callback))));
            }
            return ( /** @type {?} */(( /** @type {?} */(this.eventManager.addEventListener(target, event, decoratePreventDefault(callback))))));
        };
        return DefaultDomRenderer2;
    }());
    var ɵ0$2$1 = /**
     * @return {?}
     */ function () { return '@'.charCodeAt(0); };
    /** @type {?} */
    var AT_CHARCODE = ((ɵ0$2$1))();
    /**
     * @param {?} name
     * @param {?} nameKind
     * @return {?}
     */
    function checkNoSyntheticProp(name, nameKind) {
        if (name.charCodeAt(0) === AT_CHARCODE) {
            throw new Error("Found the synthetic " + nameKind + " " + name + ". Please include either \"BrowserAnimationsModule\" or \"NoopAnimationsModule\" in your application.");
        }
    }
    var EmulatedEncapsulationDomRenderer2 = /** @class */ (function (_super) {
        __extends(EmulatedEncapsulationDomRenderer2, _super);
        /**
         * @param {?} eventManager
         * @param {?} sharedStylesHost
         * @param {?} component
         * @param {?} appId
         */
        function EmulatedEncapsulationDomRenderer2(eventManager, sharedStylesHost, component, appId) {
            var _this = _super.call(this, eventManager) || this;
            _this.component = component;
            /** @type {?} */
            var styles = flattenStyles(appId + '-' + component.id, component.styles, []);
            sharedStylesHost.addStyles(styles);
            _this.contentAttr = shimContentAttribute(appId + '-' + component.id);
            _this.hostAttr = shimHostAttribute(appId + '-' + component.id);
            return _this;
        }
        /**
         * @param {?} element
         * @return {?}
         */
        EmulatedEncapsulationDomRenderer2.prototype.applyToHost = function (element) { _super.prototype.setAttribute.call(this, element, this.hostAttr, ''); };
        /**
         * @param {?} parent
         * @param {?} name
         * @return {?}
         */
        EmulatedEncapsulationDomRenderer2.prototype.createElement = function (parent, name) {
            /** @type {?} */
            var el = _super.prototype.createElement.call(this, parent, name);
            _super.prototype.setAttribute.call(this, el, this.contentAttr, '');
            return el;
        };
        return EmulatedEncapsulationDomRenderer2;
    }(DefaultDomRenderer2));
    var ShadowDomRenderer = /** @class */ (function (_super) {
        __extends(ShadowDomRenderer, _super);
        /**
         * @param {?} eventManager
         * @param {?} sharedStylesHost
         * @param {?} hostEl
         * @param {?} component
         */
        function ShadowDomRenderer(eventManager, sharedStylesHost, hostEl, component) {
            var _this = _super.call(this, eventManager) || this;
            _this.sharedStylesHost = sharedStylesHost;
            _this.hostEl = hostEl;
            _this.component = component;
            if (component.encapsulation === ViewEncapsulation.ShadowDom) {
                _this.shadowRoot = (( /** @type {?} */(hostEl))).attachShadow({ mode: 'open' });
            }
            else {
                _this.shadowRoot = (( /** @type {?} */(hostEl))).createShadowRoot();
            }
            _this.sharedStylesHost.addHost(_this.shadowRoot);
            /** @type {?} */
            var styles = flattenStyles(component.id, component.styles, []);
            for (var i_125 = 0; i_125 < styles.length; i_125++) {
                /** @type {?} */
                var styleEl = document.createElement('style');
                styleEl.textContent = styles[i_125];
                _this.shadowRoot.appendChild(styleEl);
            }
            return _this;
        }
        /**
         * @private
         * @param {?} node
         * @return {?}
         */
        ShadowDomRenderer.prototype.nodeOrShadowRoot = function (node) { return node === this.hostEl ? this.shadowRoot : node; };
        /**
         * @return {?}
         */
        ShadowDomRenderer.prototype.destroy = function () { this.sharedStylesHost.removeHost(this.shadowRoot); };
        /**
         * @param {?} parent
         * @param {?} newChild
         * @return {?}
         */
        ShadowDomRenderer.prototype.appendChild = function (parent, newChild) {
            return _super.prototype.appendChild.call(this, this.nodeOrShadowRoot(parent), newChild);
        };
        /**
         * @param {?} parent
         * @param {?} newChild
         * @param {?} refChild
         * @return {?}
         */
        ShadowDomRenderer.prototype.insertBefore = function (parent, newChild, refChild) {
            return _super.prototype.insertBefore.call(this, this.nodeOrShadowRoot(parent), newChild, refChild);
        };
        /**
         * @param {?} parent
         * @param {?} oldChild
         * @return {?}
         */
        ShadowDomRenderer.prototype.removeChild = function (parent, oldChild) {
            return _super.prototype.removeChild.call(this, this.nodeOrShadowRoot(parent), oldChild);
        };
        /**
         * @param {?} node
         * @return {?}
         */
        ShadowDomRenderer.prototype.parentNode = function (node) {
            return this.nodeOrShadowRoot(_super.prototype.parentNode.call(this, this.nodeOrShadowRoot(node)));
        };
        return ShadowDomRenderer;
    }(DefaultDomRenderer2));
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ɵ0$3$1 = /**
     * @return {?}
     */ function () { return (typeof Zone !== 'undefined') && (( /** @type {?} */(Zone)))['__symbol__'] ||
        ( /**
         * @param {?} v
         * @return {?}
         */function (v) { return '__zone_symbol__' + v; }); };
    /**
     * Detect if Zone is present. If it is then use simple zone aware 'addEventListener'
     * since Angular can do much more
     * efficient bookkeeping than Zone can, because we have additional information. This speeds up
     * addEventListener by 3x.
     * @type {?}
     */
    var __symbol__ = ((ɵ0$3$1))();
    /** @type {?} */
    var ADD_EVENT_LISTENER = __symbol__('addEventListener');
    /** @type {?} */
    var REMOVE_EVENT_LISTENER = __symbol__('removeEventListener');
    /** @type {?} */
    var symbolNames = {};
    /** @type {?} */
    var FALSE = 'FALSE';
    /** @type {?} */
    var ANGULAR = 'ANGULAR';
    /** @type {?} */
    var NATIVE_ADD_LISTENER = 'addEventListener';
    /** @type {?} */
    var NATIVE_REMOVE_LISTENER = 'removeEventListener';
    // use the same symbol string which is used in zone.js
    /** @type {?} */
    var stopSymbol = '__zone_symbol__propagationStopped';
    /** @type {?} */
    var stopMethodSymbol = '__zone_symbol__stopImmediatePropagation';
    var ɵ1$2 = /**
     * @return {?}
     */ function () {
        /** @type {?} */
        var blackListedEvents = (typeof Zone !== 'undefined') && (( /** @type {?} */(Zone)))[__symbol__('BLACK_LISTED_EVENTS')];
        if (blackListedEvents) {
            /** @type {?} */
            var res_1 = {};
            blackListedEvents.forEach(( /**
             * @param {?} eventName
             * @return {?}
             */function (/**
             * @param {?} eventName
             * @return {?}
             */ eventName) { res_1[eventName] = eventName; }));
            return res_1;
        }
        return undefined;
    };
    /** @type {?} */
    var blackListedMap = ((ɵ1$2))();
    /** @type {?} */
    var isBlackListedEvent = ( /**
     * @param {?} eventName
     * @return {?}
     */function (eventName) {
        if (!blackListedMap) {
            return false;
        }
        return blackListedMap.hasOwnProperty(eventName);
    });
    // a global listener to handle all dom event,
    // so we do not need to create a closure every time
    /** @type {?} */
    var globalListener = ( /**
     * @this {?}
     * @param {?} event
     * @return {?}
     */function (event) {
        /** @type {?} */
        var symbolName = symbolNames[event.type];
        if (!symbolName) {
            return;
        }
        /** @type {?} */
        var taskDatas = this[symbolName];
        if (!taskDatas) {
            return;
        }
        /** @type {?} */
        var args = [event];
        if (taskDatas.length === 1) {
            // if taskDatas only have one element, just invoke it
            /** @type {?} */
            var taskData = taskDatas[0];
            if (taskData.zone !== Zone.current) {
                // only use Zone.run when Zone.current not equals to stored zone
                return taskData.zone.run(taskData.handler, this, args);
            }
            else {
                return taskData.handler.apply(this, args);
            }
        }
        else {
            // copy tasks as a snapshot to avoid event handlers remove
            // itself or others
            /** @type {?} */
            var copiedTasks = taskDatas.slice();
            for (var i_126 = 0; i_126 < copiedTasks.length; i_126++) {
                // if other listener call event.stopImmediatePropagation
                // just break
                if ((( /** @type {?} */(event)))[stopSymbol] === true) {
                    break;
                }
                /** @type {?} */
                var taskData = copiedTasks[i_126];
                if (taskData.zone !== Zone.current) {
                    // only use Zone.run when Zone.current not equals to stored zone
                    taskData.zone.run(taskData.handler, this, args);
                }
                else {
                    taskData.handler.apply(this, args);
                }
            }
        }
    });
    var DomEventsPlugin = /** @class */ (function (_super) {
        __extends(DomEventsPlugin, _super);
        /**
         * @param {?} doc
         * @param {?} ngZone
         * @param {?} platformId
         */
        function DomEventsPlugin(doc, ngZone, platformId) {
            var _this = _super.call(this, doc) || this;
            _this.ngZone = ngZone;
            if (!platformId || !isPlatformServer(platformId)) {
                _this.patchEvent();
            }
            return _this;
        }
        /**
         * @private
         * @return {?}
         */
        DomEventsPlugin.prototype.patchEvent = function () {
            if (typeof Event === 'undefined' || !Event || !Event.prototype) {
                return;
            }
            if ((( /** @type {?} */(Event.prototype)))[stopMethodSymbol]) {
                // already patched by zone.js
                return;
            }
            /** @type {?} */
            var delegate = (( /** @type {?} */(Event.prototype)))[stopMethodSymbol] =
                Event.prototype.stopImmediatePropagation;
            Event.prototype.stopImmediatePropagation = ( /**
             * @this {?}
             * @return {?}
             */function () {
                if (this) {
                    this[stopSymbol] = true;
                }
                // We should call native delegate in case in some environment part of
                // the application will not use the patched Event. Also we cast the
                // "arguments" to any since "stopImmediatePropagation" technically does not
                // accept any arguments, but we don't know what developers pass through the
                // function and we want to not break these calls.
                delegate && delegate.apply(this, ( /** @type {?} */(arguments)));
            });
        };
        // This plugin should come last in the list of plugins, because it accepts all
        // events.
        /**
         * @param {?} eventName
         * @return {?}
         */
        DomEventsPlugin.prototype.supports = function (eventName) { return true; };
        /**
         * @param {?} element
         * @param {?} eventName
         * @param {?} handler
         * @return {?}
         */
        DomEventsPlugin.prototype.addEventListener = function (element, eventName, handler) {
            var _this = this;
            /** @type {?} */
            var zoneJsLoaded = element[ADD_EVENT_LISTENER];
            /** @type {?} */
            var callback = ( /** @type {?} */(handler));
            // if zonejs is loaded and current zone is not ngZone
            // we keep Zone.current on target for later restoration.
            if (zoneJsLoaded && (!NgZone.isInAngularZone() || isBlackListedEvent(eventName))) {
                /** @type {?} */
                var symbolName = symbolNames[eventName];
                if (!symbolName) {
                    symbolName = symbolNames[eventName] = __symbol__(ANGULAR + eventName + FALSE);
                }
                /** @type {?} */
                var taskDatas = (( /** @type {?} */(element)))[symbolName];
                /** @type {?} */
                var globalListenerRegistered = taskDatas && taskDatas.length > 0;
                if (!taskDatas) {
                    taskDatas = (( /** @type {?} */(element)))[symbolName] = [];
                }
                /** @type {?} */
                var zone = isBlackListedEvent(eventName) ? Zone.root : Zone.current;
                if (taskDatas.length === 0) {
                    taskDatas.push({ zone: zone, handler: callback });
                }
                else {
                    /** @type {?} */
                    var callbackRegistered = false;
                    for (var i_127 = 0; i_127 < taskDatas.length; i_127++) {
                        if (taskDatas[i_127].handler === callback) {
                            callbackRegistered = true;
                            break;
                        }
                    }
                    if (!callbackRegistered) {
                        taskDatas.push({ zone: zone, handler: callback });
                    }
                }
                if (!globalListenerRegistered) {
                    element[ADD_EVENT_LISTENER](eventName, globalListener, false);
                }
            }
            else {
                element[NATIVE_ADD_LISTENER](eventName, callback, false);
            }
            return ( /**
             * @return {?}
             */function () { return _this.removeEventListener(element, eventName, callback); });
        };
        /**
         * @param {?} target
         * @param {?} eventName
         * @param {?} callback
         * @return {?}
         */
        DomEventsPlugin.prototype.removeEventListener = function (target, eventName, callback) {
            /** @type {?} */
            var underlyingRemove = target[REMOVE_EVENT_LISTENER];
            // zone.js not loaded, use native removeEventListener
            if (!underlyingRemove) {
                return target[NATIVE_REMOVE_LISTENER].apply(target, [eventName, callback, false]);
            }
            /** @type {?} */
            var symbolName = symbolNames[eventName];
            /** @type {?} */
            var taskDatas = symbolName && target[symbolName];
            if (!taskDatas) {
                // addEventListener not using patched version
                // just call native removeEventListener
                return target[NATIVE_REMOVE_LISTENER].apply(target, [eventName, callback, false]);
            }
            // fix issue 20532, should be able to remove
            // listener which was added inside of ngZone
            /** @type {?} */
            var found = false;
            for (var i_128 = 0; i_128 < taskDatas.length; i_128++) {
                // remove listener from taskDatas if the callback equals
                if (taskDatas[i_128].handler === callback) {
                    found = true;
                    taskDatas.splice(i_128, 1);
                    break;
                }
            }
            if (found) {
                if (taskDatas.length === 0) {
                    // all listeners are removed, we can remove the globalListener from target
                    underlyingRemove.apply(target, [eventName, globalListener, false]);
                }
            }
            else {
                // not found in taskDatas, the callback may be added inside of ngZone
                // use native remove listener to remove the callback
                target[NATIVE_REMOVE_LISTENER].apply(target, [eventName, callback, false]);
            }
        };
        return DomEventsPlugin;
    }(EventManagerPlugin));
    DomEventsPlugin.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    DomEventsPlugin.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] },
        { type: NgZone },
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [PLATFORM_ID,] }] }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Supported HammerJS recognizer event names.
     * @type {?}
     */
    var EVENT_NAMES = {
        // pan
        'pan': true,
        'panstart': true,
        'panmove': true,
        'panend': true,
        'pancancel': true,
        'panleft': true,
        'panright': true,
        'panup': true,
        'pandown': true,
        // pinch
        'pinch': true,
        'pinchstart': true,
        'pinchmove': true,
        'pinchend': true,
        'pinchcancel': true,
        'pinchin': true,
        'pinchout': true,
        // press
        'press': true,
        'pressup': true,
        // rotate
        'rotate': true,
        'rotatestart': true,
        'rotatemove': true,
        'rotateend': true,
        'rotatecancel': true,
        // swipe
        'swipe': true,
        'swipeleft': true,
        'swiperight': true,
        'swipeup': true,
        'swipedown': true,
        // tap
        'tap': true,
    };
    /**
     * DI token for providing [HammerJS](http://hammerjs.github.io/) support to Angular.
     * @see `HammerGestureConfig`
     *
     * \@publicApi
     * @type {?}
     */
    var HAMMER_GESTURE_CONFIG = new InjectionToken('HammerGestureConfig');
    /**
     * Injection token used to provide a {\@link HammerLoader} to Angular.
     *
     * \@publicApi
     * @type {?}
     */
    var HAMMER_LOADER = new InjectionToken('HammerLoader');
    /**
     * An injectable [HammerJS Manager](http://hammerjs.github.io/api/#hammer.manager)
     * for gesture recognition. Configures specific event recognition.
     * \@publicApi
     */
    var HammerGestureConfig = /** @class */ (function () {
        function HammerGestureConfig() {
            /**
             * A set of supported event names for gestures to be used in Angular.
             * Angular supports all built-in recognizers, as listed in
             * [HammerJS documentation](http://hammerjs.github.io/).
             */
            this.events = [];
            /**
             * Maps gesture event names to a set of configuration options
             * that specify overrides to the default values for specific properties.
             *
             * The key is a supported event name to be configured,
             * and the options object contains a set of properties, with override values
             * to be applied to the named recognizer event.
             * For example, to disable recognition of the rotate event, specify
             *  `{"rotate": {"enable": false}}`.
             *
             * Properties that are not present take the HammerJS default values.
             * For information about which properties are supported for which events,
             * and their allowed and default values, see
             * [HammerJS documentation](http://hammerjs.github.io/).
             *
             */
            this.overrides = {};
        }
        /**
         * Creates a [HammerJS Manager](http://hammerjs.github.io/api/#hammer.manager)
         * and attaches it to a given HTML element.
         * @param {?} element The element that will recognize gestures.
         * @return {?} A HammerJS event-manager object.
         */
        HammerGestureConfig.prototype.buildHammer = function (element) {
            /** @type {?} */
            var mc = new ( /** @type {?} */(Hammer))(element, this.options);
            mc.get('pinch').set({ enable: true });
            mc.get('rotate').set({ enable: true });
            for (var eventName in this.overrides) {
                mc.get(eventName).set(this.overrides[eventName]);
            }
            return mc;
        };
        return HammerGestureConfig;
    }());
    HammerGestureConfig.decorators = [
        { type: Injectable }
    ];
    var HammerGesturesPlugin = /** @class */ (function (_super) {
        __extends(HammerGesturesPlugin, _super);
        /**
         * @param {?} doc
         * @param {?} _config
         * @param {?} console
         * @param {?=} loader
         */
        function HammerGesturesPlugin(doc, _config, console, loader) {
            var _this = _super.call(this, doc) || this;
            _this._config = _config;
            _this.console = console;
            _this.loader = loader;
            return _this;
        }
        /**
         * @param {?} eventName
         * @return {?}
         */
        HammerGesturesPlugin.prototype.supports = function (eventName) {
            if (!EVENT_NAMES.hasOwnProperty(eventName.toLowerCase()) && !this.isCustomEvent(eventName)) {
                return false;
            }
            if (!(( /** @type {?} */(window))).Hammer && !this.loader) {
                this.console.warn("The \"" + eventName + "\" event cannot be bound because Hammer.JS is not " +
                    "loaded and no custom loader has been specified.");
                return false;
            }
            return true;
        };
        /**
         * @param {?} element
         * @param {?} eventName
         * @param {?} handler
         * @return {?}
         */
        HammerGesturesPlugin.prototype.addEventListener = function (element, eventName, handler) {
            var _this = this;
            /** @type {?} */
            var zone = this.manager.getZone();
            eventName = eventName.toLowerCase();
            // If Hammer is not present but a loader is specified, we defer adding the event listener
            // until Hammer is loaded.
            if (!(( /** @type {?} */(window))).Hammer && this.loader) {
                // This `addEventListener` method returns a function to remove the added listener.
                // Until Hammer is loaded, the returned function needs to *cancel* the registration rather
                // than remove anything.
                /** @type {?} */
                var cancelRegistration_1 = false;
                /** @type {?} */
                var deregister_1 = ( /**
                 * @return {?}
                 */function () { cancelRegistration_1 = true; });
                this.loader()
                    .then(( /**
             * @return {?}
             */function () {
                    // If Hammer isn't actually loaded when the custom loader resolves, give up.
                    if (!(( /** @type {?} */(window))).Hammer) {
                        _this.console.warn("The custom HAMMER_LOADER completed, but Hammer.JS is not present.");
                        deregister_1 = ( /**
                         * @return {?}
                         */function () { });
                        return;
                    }
                    if (!cancelRegistration_1) {
                        // Now that Hammer is loaded and the listener is being loaded for real,
                        // the deregistration function changes from canceling registration to removal.
                        deregister_1 = _this.addEventListener(element, eventName, handler);
                    }
                }))
                    .catch(( /**
             * @return {?}
             */function () {
                    _this.console.warn("The \"" + eventName + "\" event cannot be bound because the custom " +
                        "Hammer.JS loader failed.");
                    deregister_1 = ( /**
                     * @return {?}
                     */function () { });
                }));
                // Return a function that *executes* `deregister` (and not `deregister` itself) so that we
                // can change the behavior of `deregister` once the listener is added. Using a closure in
                // this way allows us to avoid any additional data structures to track listener removal.
                return ( /**
                 * @return {?}
                 */function () { deregister_1(); });
            }
            return zone.runOutsideAngular(( /**
             * @return {?}
             */function () {
                // Creating the manager bind events, must be done outside of angular
                /** @type {?} */
                var mc = _this._config.buildHammer(element);
                /** @type {?} */
                var callback = ( /**
                 * @param {?} eventObj
                 * @return {?}
                 */function (eventObj) {
                    zone.runGuarded(( /**
                     * @return {?}
                     */function () { handler(eventObj); }));
                });
                mc.on(eventName, callback);
                return ( /**
                 * @return {?}
                 */function () {
                    mc.off(eventName, callback);
                    // destroy mc to prevent memory leak
                    if (typeof mc.destroy === 'function') {
                        mc.destroy();
                    }
                });
            }));
        };
        /**
         * @param {?} eventName
         * @return {?}
         */
        HammerGesturesPlugin.prototype.isCustomEvent = function (eventName) { return this._config.events.indexOf(eventName) > -1; };
        return HammerGesturesPlugin;
    }(EventManagerPlugin));
    HammerGesturesPlugin.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    HammerGesturesPlugin.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] },
        { type: HammerGestureConfig, decorators: [{ type: Inject, args: [HAMMER_GESTURE_CONFIG,] }] },
        { type: Console },
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [HAMMER_LOADER,] }] }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Defines supported modifiers for key events.
     * @type {?}
     */
    var MODIFIER_KEYS = ['alt', 'control', 'meta', 'shift'];
    var ɵ0$4$1 = /**
     * @param {?} event
     * @return {?}
     */ function (event) { return event.altKey; }, ɵ1$1$2 = /**
     * @param {?} event
     * @return {?}
     */ function (event) { return event.ctrlKey; }, ɵ2$1$2 = /**
     * @param {?} event
     * @return {?}
     */ function (event) { return event.metaKey; }, ɵ3$1$1 = /**
     * @param {?} event
     * @return {?}
     */ function (event) { return event.shiftKey; };
    /**
     * Retrieves modifiers from key-event objects.
     * @type {?}
     */
    var MODIFIER_KEY_GETTERS = {
        'alt': (ɵ0$4$1),
        'control': (ɵ1$1$2),
        'meta': (ɵ2$1$2),
        'shift': (ɵ3$1$1)
    };
    /**
     * \@publicApi
     * A browser plug-in that provides support for handling of key events in Angular.
     */
    var KeyEventsPlugin = /** @class */ (function (_super) {
        __extends(KeyEventsPlugin, _super);
        /**
         * Initializes an instance of the browser plug-in.
         * @param {?} doc The document in which key events will be detected.
         */
        function KeyEventsPlugin(doc) {
            return _super.call(this, doc) || this;
        }
        /**
         * Reports whether a named key event is supported.
         * @param {?} eventName The event name to query.
         * @return {?} True if the named key event is supported.
         */
        KeyEventsPlugin.prototype.supports = function (eventName) { return KeyEventsPlugin.parseEventName(eventName) != null; };
        /**
         * Registers a handler for a specific element and key event.
         * @param {?} element The HTML element to receive event notifications.
         * @param {?} eventName The name of the key event to listen for.
         * @param {?} handler A function to call when the notification occurs. Receives the
         * event object as an argument.
         * @return {?} The key event that was registered.
         */
        KeyEventsPlugin.prototype.addEventListener = function (element, eventName, handler) {
            /** @type {?} */
            var parsedEvent = ( /** @type {?} */(KeyEventsPlugin.parseEventName(eventName)));
            /** @type {?} */
            var outsideHandler = KeyEventsPlugin.eventCallback(parsedEvent['fullKey'], handler, this.manager.getZone());
            return this.manager.getZone().runOutsideAngular(( /**
             * @return {?}
             */function () {
                return getDOM().onAndCancel(element, parsedEvent['domEventName'], outsideHandler);
            }));
        };
        /**
         * @param {?} eventName
         * @return {?}
         */
        KeyEventsPlugin.parseEventName = function (eventName) {
            /** @type {?} */
            var parts = eventName.toLowerCase().split('.');
            /** @type {?} */
            var domEventName = parts.shift();
            if ((parts.length === 0) || !(domEventName === 'keydown' || domEventName === 'keyup')) {
                return null;
            }
            /** @type {?} */
            var key = KeyEventsPlugin._normalizeKey(( /** @type {?} */(parts.pop())));
            /** @type {?} */
            var fullKey = '';
            MODIFIER_KEYS.forEach(( /**
             * @param {?} modifierName
             * @return {?}
             */function (/**
             * @param {?} modifierName
             * @return {?}
             */ modifierName) {
                /** @type {?} */
                var index = parts.indexOf(modifierName);
                if (index > -1) {
                    parts.splice(index, 1);
                    fullKey += modifierName + '.';
                }
            }));
            fullKey += key;
            if (parts.length != 0 || key.length === 0) {
                // returning null instead of throwing to let another plugin process the event
                return null;
            }
            /** @type {?} */
            var result = {};
            result['domEventName'] = domEventName;
            result['fullKey'] = fullKey;
            return result;
        };
        /**
         * @param {?} event
         * @return {?}
         */
        KeyEventsPlugin.getEventFullKey = function (event) {
            /** @type {?} */
            var fullKey = '';
            /** @type {?} */
            var key = getDOM().getEventKey(event);
            key = key.toLowerCase();
            if (key === ' ') {
                key = 'space'; // for readability
            }
            else if (key === '.') {
                key = 'dot'; // because '.' is used as a separator in event names
            }
            MODIFIER_KEYS.forEach(( /**
             * @param {?} modifierName
             * @return {?}
             */function (/**
             * @param {?} modifierName
             * @return {?}
             */ modifierName) {
                if (modifierName != key) {
                    /** @type {?} */
                    var modifierGetter = MODIFIER_KEY_GETTERS[modifierName];
                    if (modifierGetter(event)) {
                        fullKey += modifierName + '.';
                    }
                }
            }));
            fullKey += key;
            return fullKey;
        };
        /**
         * Configures a handler callback for a key event.
         * @param {?} fullKey The event name that combines all simultaneous keystrokes.
         * @param {?} handler The function that responds to the key event.
         * @param {?} zone The zone in which the event occurred.
         * @return {?} A callback function.
         */
        KeyEventsPlugin.eventCallback = function (fullKey, handler, zone) {
            return ( /**
             * @param {?} event
             * @return {?}
             */function (event /** TODO #9100 */) {
                if (KeyEventsPlugin.getEventFullKey(event) === fullKey) {
                    zone.runGuarded(( /**
                     * @return {?}
                     */function () { return handler(event); }));
                }
            });
        };
        /**
         * \@internal
         * @param {?} keyName
         * @return {?}
         */
        KeyEventsPlugin._normalizeKey = function (keyName) {
            // TODO: switch to a Map if the mapping grows too much
            switch (keyName) {
                case 'esc':
                    return 'escape';
                default:
                    return keyName;
            }
        };
        return KeyEventsPlugin;
    }(EventManagerPlugin));
    KeyEventsPlugin.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    KeyEventsPlugin.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
    ]; };
    /**
     * DomSanitizer helps preventing Cross Site Scripting Security bugs (XSS) by sanitizing
     * values to be safe to use in the different DOM contexts.
     *
     * For example, when binding a URL in an `<a [href]="someValue">` hyperlink, `someValue` will be
     * sanitized so that an attacker cannot inject e.g. a `javascript:` URL that would execute code on
     * the website.
     *
     * In specific situations, it might be necessary to disable sanitization, for example if the
     * application genuinely needs to produce a `javascript:` style link with a dynamic value in it.
     * Users can bypass security by constructing a value with one of the `bypassSecurityTrust...`
     * methods, and then binding to that value from the template.
     *
     * These situations should be very rare, and extraordinary care must be taken to avoid creating a
     * Cross Site Scripting (XSS) security bug!
     *
     * When using `bypassSecurityTrust...`, make sure to call the method as early as possible and as
     * close as possible to the source of the value, to make it easy to verify no security bug is
     * created by its use.
     *
     * It is not required (and not recommended) to bypass security if the value is safe, e.g. a URL that
     * does not start with a suspicious protocol, or an HTML snippet that does not contain dangerous
     * code. The sanitizer leaves safe values intact.
     *
     * \@security Calling any of the `bypassSecurityTrust...` APIs disables Angular's built-in
     * sanitization for the value passed in. Carefully check and audit all values and code paths going
     * into this call. Make sure any user data is appropriately escaped for this security context.
     * For more detail, see the [Security Guide](http://g.co/ng/security).
     *
     * \@publicApi
     * @abstract
     */
    var DomSanitizer = /** @class */ (function () {
        function DomSanitizer() {
        }
        return DomSanitizer;
    }());
    var DomSanitizerImpl = /** @class */ (function (_super) {
        __extends(DomSanitizerImpl, _super);
        /**
         * @param {?} _doc
         */
        function DomSanitizerImpl(_doc) {
            var _this = _super.call(this) || this;
            _this._doc = _doc;
            return _this;
        }
        /**
         * @param {?} ctx
         * @param {?} value
         * @return {?}
         */
        DomSanitizerImpl.prototype.sanitize = function (ctx, value) {
            if (value == null)
                return null;
            switch (ctx) {
                case SecurityContext.NONE:
                    return ( /** @type {?} */(value));
                case SecurityContext.HTML:
                    if (value instanceof SafeHtmlImpl)
                        return value.changingThisBreaksApplicationSecurity;
                    this.checkNotSafeValue(value, 'HTML');
                    return _sanitizeHtml(this._doc, String(value));
                case SecurityContext.STYLE:
                    if (value instanceof SafeStyleImpl)
                        return value.changingThisBreaksApplicationSecurity;
                    this.checkNotSafeValue(value, 'Style');
                    return _sanitizeStyle(( /** @type {?} */(value)));
                case SecurityContext.SCRIPT:
                    if (value instanceof SafeScriptImpl)
                        return value.changingThisBreaksApplicationSecurity;
                    this.checkNotSafeValue(value, 'Script');
                    throw new Error('unsafe value used in a script context');
                case SecurityContext.URL:
                    if (value instanceof SafeResourceUrlImpl || value instanceof SafeUrlImpl) {
                        // Allow resource URLs in URL contexts, they are strictly more trusted.
                        return value.changingThisBreaksApplicationSecurity;
                    }
                    this.checkNotSafeValue(value, 'URL');
                    return _sanitizeUrl(String(value));
                case SecurityContext.RESOURCE_URL:
                    if (value instanceof SafeResourceUrlImpl) {
                        return value.changingThisBreaksApplicationSecurity;
                    }
                    this.checkNotSafeValue(value, 'ResourceURL');
                    throw new Error('unsafe value used in a resource URL context (see http://g.co/ng/security#xss)');
                default:
                    throw new Error("Unexpected SecurityContext " + ctx + " (see http://g.co/ng/security#xss)");
            }
        };
        /**
         * @private
         * @param {?} value
         * @param {?} expectedType
         * @return {?}
         */
        DomSanitizerImpl.prototype.checkNotSafeValue = function (value, expectedType) {
            if (value instanceof SafeValueImpl) {
                throw new Error("Required a safe " + expectedType + ", got a " + value.getTypeName() + " " +
                    "(see http://g.co/ng/security#xss)");
            }
        };
        /**
         * @param {?} value
         * @return {?}
         */
        DomSanitizerImpl.prototype.bypassSecurityTrustHtml = function (value) { return new SafeHtmlImpl(value); };
        /**
         * @param {?} value
         * @return {?}
         */
        DomSanitizerImpl.prototype.bypassSecurityTrustStyle = function (value) { return new SafeStyleImpl(value); };
        /**
         * @param {?} value
         * @return {?}
         */
        DomSanitizerImpl.prototype.bypassSecurityTrustScript = function (value) { return new SafeScriptImpl(value); };
        /**
         * @param {?} value
         * @return {?}
         */
        DomSanitizerImpl.prototype.bypassSecurityTrustUrl = function (value) { return new SafeUrlImpl(value); };
        /**
         * @param {?} value
         * @return {?}
         */
        DomSanitizerImpl.prototype.bypassSecurityTrustResourceUrl = function (value) {
            return new SafeResourceUrlImpl(value);
        };
        return DomSanitizerImpl;
    }(DomSanitizer));
    DomSanitizerImpl.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    DomSanitizerImpl.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
    ]; };
    /**
     * @abstract
     */
    var SafeValueImpl = /** @class */ (function () {
        /**
         * @param {?} changingThisBreaksApplicationSecurity
         */
        function SafeValueImpl(changingThisBreaksApplicationSecurity) {
            this.changingThisBreaksApplicationSecurity = changingThisBreaksApplicationSecurity;
            // empty
        }
        /**
         * @return {?}
         */
        SafeValueImpl.prototype.toString = function () {
            return "SafeValue must use [property]=binding: " + this.changingThisBreaksApplicationSecurity +
                " (see http://g.co/ng/security#xss)";
        };
        return SafeValueImpl;
    }());
    var SafeHtmlImpl = /** @class */ (function (_super) {
        __extends(SafeHtmlImpl, _super);
        function SafeHtmlImpl() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @return {?}
         */
        SafeHtmlImpl.prototype.getTypeName = function () { return 'HTML'; };
        return SafeHtmlImpl;
    }(SafeValueImpl));
    var SafeStyleImpl = /** @class */ (function (_super) {
        __extends(SafeStyleImpl, _super);
        function SafeStyleImpl() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @return {?}
         */
        SafeStyleImpl.prototype.getTypeName = function () { return 'Style'; };
        return SafeStyleImpl;
    }(SafeValueImpl));
    var SafeScriptImpl = /** @class */ (function (_super) {
        __extends(SafeScriptImpl, _super);
        function SafeScriptImpl() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @return {?}
         */
        SafeScriptImpl.prototype.getTypeName = function () { return 'Script'; };
        return SafeScriptImpl;
    }(SafeValueImpl));
    var SafeUrlImpl = /** @class */ (function (_super) {
        __extends(SafeUrlImpl, _super);
        function SafeUrlImpl() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @return {?}
         */
        SafeUrlImpl.prototype.getTypeName = function () { return 'URL'; };
        return SafeUrlImpl;
    }(SafeValueImpl));
    var SafeResourceUrlImpl = /** @class */ (function (_super) {
        __extends(SafeResourceUrlImpl, _super);
        function SafeResourceUrlImpl() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @return {?}
         */
        SafeResourceUrlImpl.prototype.getTypeName = function () { return 'ResourceURL'; };
        return SafeResourceUrlImpl;
    }(SafeValueImpl));
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ɵ0$5$1 = PLATFORM_BROWSER_ID;
    /** @type {?} */
    var INTERNAL_BROWSER_PLATFORM_PROVIDERS = [
        { provide: PLATFORM_ID, useValue: ɵ0$5$1 },
        { provide: PLATFORM_INITIALIZER, useValue: initDomAdapter, multi: true },
        { provide: PlatformLocation, useClass: BrowserPlatformLocation, deps: [DOCUMENT] },
        { provide: DOCUMENT, useFactory: _document, deps: [] },
    ];
    /**
     * \@security Replacing built-in sanitization providers exposes the application to XSS risks.
     * Attacker-controlled data introduced by an unsanitized provider could expose your
     * application to XSS risks. For more detail, see the [Security Guide](http://g.co/ng/security).
     * \@publicApi
     * @type {?}
     */
    var BROWSER_SANITIZATION_PROVIDERS = [
        { provide: Sanitizer, useExisting: DomSanitizer },
        { provide: DomSanitizer, useClass: DomSanitizerImpl, deps: [DOCUMENT] },
    ];
    /**
     * \@publicApi
     * @type {?}
     */
    var platformBrowser = createPlatformFactory(platformCore, 'browser', INTERNAL_BROWSER_PLATFORM_PROVIDERS);
    /**
     * @return {?}
     */
    function initDomAdapter() {
        BrowserDomAdapter.makeCurrent();
        BrowserGetTestability.init();
    }
    /**
     * @return {?}
     */
    function errorHandler() {
        return new ErrorHandler();
    }
    /**
     * @return {?}
     */
    function _document() {
        return document;
    }
    /** @type {?} */
    var BROWSER_MODULE_PROVIDERS = [
        BROWSER_SANITIZATION_PROVIDERS,
        { provide: APP_ROOT, useValue: true },
        { provide: ErrorHandler, useFactory: errorHandler, deps: [] },
        {
            provide: EVENT_MANAGER_PLUGINS,
            useClass: DomEventsPlugin,
            multi: true,
            deps: [DOCUMENT, NgZone, PLATFORM_ID]
        },
        { provide: EVENT_MANAGER_PLUGINS, useClass: KeyEventsPlugin, multi: true, deps: [DOCUMENT] },
        {
            provide: EVENT_MANAGER_PLUGINS,
            useClass: HammerGesturesPlugin,
            multi: true,
            deps: [DOCUMENT, HAMMER_GESTURE_CONFIG, Console, [new Optional(), HAMMER_LOADER]]
        },
        { provide: HAMMER_GESTURE_CONFIG, useClass: HammerGestureConfig, deps: [] },
        {
            provide: DomRendererFactory2,
            useClass: DomRendererFactory2,
            deps: [EventManager, DomSharedStylesHost, APP_ID]
        },
        { provide: RendererFactory2, useExisting: DomRendererFactory2 },
        { provide: SharedStylesHost, useExisting: DomSharedStylesHost },
        { provide: DomSharedStylesHost, useClass: DomSharedStylesHost, deps: [DOCUMENT] },
        { provide: Testability, useClass: Testability, deps: [NgZone] },
        { provide: EventManager, useClass: EventManager, deps: [EVENT_MANAGER_PLUGINS, NgZone] },
        ELEMENT_PROBE_PROVIDERS,
    ];
    /**
     * Exports required infrastructure for all Angular apps.
     * Included by default in all Angular apps created with the CLI
     * `new` command.
     * Re-exports `CommonModule` and `ApplicationModule`, making their
     * exports and providers available to all apps.
     *
     * \@publicApi
     */
    var BrowserModule = /** @class */ (function () {
        /**
         * @param {?} parentModule
         */
        function BrowserModule(parentModule) {
            if (parentModule) {
                throw new Error("BrowserModule has already been loaded. If you need access to common directives such as NgIf and NgFor from a lazy loaded module, import CommonModule instead.");
            }
        }
        /**
         * Configures a browser-based app to transition from a server-rendered app, if
         * one is present on the page.
         *
         * @param {?} params An object containing an identifier for the app to transition.
         * The ID must match between the client and server versions of the app.
         * @return {?} The reconfigured `BrowserModule` to import into the app's root `AppModule`.
         */
        BrowserModule.withServerTransition = function (params) {
            return {
                ngModule: BrowserModule,
                providers: [
                    { provide: APP_ID, useValue: params.appId },
                    { provide: TRANSITION_ID, useExisting: APP_ID },
                    SERVER_TRANSITION_PROVIDERS,
                ],
            };
        };
        return BrowserModule;
    }());
    BrowserModule.decorators = [
        { type: NgModule, args: [{ providers: BROWSER_MODULE_PROVIDERS, exports: [CommonModule, ApplicationModule] },] }
    ];
    /** @nocollapse */
    BrowserModule.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Optional }, { type: SkipSelf }, { type: Inject, args: [BrowserModule,] }] }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Factory to create Meta service.
     * @return {?}
     */
    function createMeta() {
        return new Meta(ɵɵinject(DOCUMENT));
    }
    /**
     * A service that can be used to get and add meta tags.
     *
     * \@publicApi
     */
    var Meta = /** @class */ (function () {
        /**
         * @param {?} _doc
         */
        function Meta(_doc) {
            this._doc = _doc;
            this._dom = getDOM();
        }
        /**
         * @param {?} tag
         * @param {?=} forceCreation
         * @return {?}
         */
        Meta.prototype.addTag = function (tag, forceCreation) {
            if (forceCreation === void 0) { forceCreation = false; }
            if (!tag)
                return null;
            return this._getOrCreateElement(tag, forceCreation);
        };
        /**
         * @param {?} tags
         * @param {?=} forceCreation
         * @return {?}
         */
        Meta.prototype.addTags = function (tags, forceCreation) {
            var _this = this;
            if (forceCreation === void 0) { forceCreation = false; }
            if (!tags)
                return [];
            return tags.reduce(( /**
             * @param {?} result
             * @param {?} tag
             * @return {?}
             */function (result, tag) {
                if (tag) {
                    result.push(_this._getOrCreateElement(tag, forceCreation));
                }
                return result;
            }), []);
        };
        /**
         * @param {?} attrSelector
         * @return {?}
         */
        Meta.prototype.getTag = function (attrSelector) {
            if (!attrSelector)
                return null;
            return this._dom.querySelector(this._doc, "meta[" + attrSelector + "]") || null;
        };
        /**
         * @param {?} attrSelector
         * @return {?}
         */
        Meta.prototype.getTags = function (attrSelector) {
            if (!attrSelector)
                return [];
            /** @type {?} */
            var list /*NodeList*/ = this._dom.querySelectorAll(this._doc, "meta[" + attrSelector + "]");
            return list ? [].slice.call(list) : [];
        };
        /**
         * @param {?} tag
         * @param {?=} selector
         * @return {?}
         */
        Meta.prototype.updateTag = function (tag, selector) {
            if (!tag)
                return null;
            selector = selector || this._parseSelector(tag);
            /** @type {?} */
            var meta = ( /** @type {?} */(this.getTag(selector)));
            if (meta) {
                return this._setMetaElementAttributes(tag, meta);
            }
            return this._getOrCreateElement(tag, true);
        };
        /**
         * @param {?} attrSelector
         * @return {?}
         */
        Meta.prototype.removeTag = function (attrSelector) { this.removeTagElement(( /** @type {?} */(this.getTag(attrSelector)))); };
        /**
         * @param {?} meta
         * @return {?}
         */
        Meta.prototype.removeTagElement = function (meta) {
            if (meta) {
                this._dom.remove(meta);
            }
        };
        /**
         * @private
         * @param {?} meta
         * @param {?=} forceCreation
         * @return {?}
         */
        Meta.prototype._getOrCreateElement = function (meta, forceCreation) {
            if (forceCreation === void 0) { forceCreation = false; }
            if (!forceCreation) {
                /** @type {?} */
                var selector = this._parseSelector(meta);
                /** @type {?} */
                var elem = ( /** @type {?} */(this.getTag(selector)));
                // It's allowed to have multiple elements with the same name so it's not enough to
                // just check that element with the same name already present on the page. We also need to
                // check if element has tag attributes
                if (elem && this._containsAttributes(meta, elem))
                    return elem;
            }
            /** @type {?} */
            var element = ( /** @type {?} */(this._dom.createElement('meta')));
            this._setMetaElementAttributes(meta, element);
            /** @type {?} */
            var head = this._dom.getElementsByTagName(this._doc, 'head')[0];
            this._dom.appendChild(head, element);
            return element;
        };
        /**
         * @private
         * @param {?} tag
         * @param {?} el
         * @return {?}
         */
        Meta.prototype._setMetaElementAttributes = function (tag, el) {
            var _this = this;
            Object.keys(tag).forEach(( /**
             * @param {?} prop
             * @return {?}
             */function (prop) { return _this._dom.setAttribute(el, prop, tag[prop]); }));
            return el;
        };
        /**
         * @private
         * @param {?} tag
         * @return {?}
         */
        Meta.prototype._parseSelector = function (tag) {
            /** @type {?} */
            var attr = tag.name ? 'name' : 'property';
            return attr + "=\"" + tag[attr] + "\"";
        };
        /**
         * @private
         * @param {?} tag
         * @param {?} elem
         * @return {?}
         */
        Meta.prototype._containsAttributes = function (tag, elem) {
            var _this = this;
            return Object.keys(tag).every(( /**
             * @param {?} key
             * @return {?}
             */function (key) { return _this._dom.getAttribute(elem, key) === tag[key]; }));
        };
        return Meta;
    }());
    Meta.decorators = [
        { type: Injectable, args: [{ providedIn: 'root', useFactory: createMeta, deps: [] },] }
    ];
    /** @nocollapse */
    Meta.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
    ]; };
    /** @nocollapse */ Meta.ngInjectableDef = ɵɵdefineInjectable({ factory: createMeta, token: Meta, providedIn: "root" });
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Factory to create Title service.
     * @return {?}
     */
    function createTitle() {
        return new Title(ɵɵinject(DOCUMENT));
    }
    /**
     * A service that can be used to get and set the title of a current HTML document.
     *
     * Since an Angular application can't be bootstrapped on the entire HTML document (`<html>` tag)
     * it is not possible to bind to the `text` property of the `HTMLTitleElement` elements
     * (representing the `<title>` tag). Instead, this service can be used to set and get the current
     * title value.
     *
     * \@publicApi
     */
    var Title = /** @class */ (function () {
        /**
         * @param {?} _doc
         */
        function Title(_doc) {
            this._doc = _doc;
        }
        /**
         * Get the title of the current HTML document.
         * @return {?}
         */
        Title.prototype.getTitle = function () { return getDOM().getTitle(this._doc); };
        /**
         * Set the title of the current HTML document.
         * @param {?} newTitle
         * @return {?}
         */
        Title.prototype.setTitle = function (newTitle) { getDOM().setTitle(this._doc, newTitle); };
        return Title;
    }());
    Title.decorators = [
        { type: Injectable, args: [{ providedIn: 'root', useFactory: createTitle, deps: [] },] }
    ];
    /** @nocollapse */
    Title.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
    ]; };
    /** @nocollapse */ Title.ngInjectableDef = ɵɵdefineInjectable({ factory: createTitle, token: Title, providedIn: "root" });
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@publicApi
     * @type {?}
     */
    var VERSION$2 = new Version('8.2.14');
    /**
     * @license Angular v8.2.14
     * (c) 2010-2019 Google LLC. https://angular.io/
     * License: MIT
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * Transforms an `HttpRequest` into a stream of `HttpEvent`s, one of which will likely be a
     * `HttpResponse`.
     *
     * `HttpHandler` is injectable. When injected, the handler instance dispatches requests to the
     * first interceptor in the chain, which dispatches to the second, etc, eventually reaching the
     * `HttpBackend`.
     *
     * In an `HttpInterceptor`, the `HttpHandler` parameter is the next interceptor in the chain.
     *
     * \@publicApi
     * @abstract
     */
    var HttpHandler = /** @class */ (function () {
        function HttpHandler() {
        }
        return HttpHandler;
    }());
    /**
     * A final `HttpHandler` which will dispatch the request via browser HTTP APIs to a backend.
     *
     * Interceptors sit between the `HttpClient` interface and the `HttpBackend`.
     *
     * When injected, `HttpBackend` dispatches requests directly to the backend, without going
     * through the interceptor chain.
     *
     * \@publicApi
     * @abstract
     */
    var HttpBackend = /** @class */ (function () {
        function HttpBackend() {
        }
        return HttpBackend;
    }());
    /**
     * Represents the header configuration options for an HTTP request.
     * Instances are immutable. Modifying methods return a cloned
     * instance with the change. The original object is never changed.
     *
     * \@publicApi
     */
    var HttpHeaders = /** @class */ (function () {
        /**
         * Constructs a new HTTP header object with the given values.
         * @param {?=} headers
         */
        function HttpHeaders(headers) {
            var _this = this;
            /**
             * Internal map of lowercased header names to the normalized
             * form of the name (the form seen first).
             */
            this.normalizedNames = new Map();
            /**
             * Queued updates to be materialized the next initialization.
             */
            this.lazyUpdate = null;
            if (!headers) {
                this.headers = new Map();
            }
            else if (typeof headers === 'string') {
                this.lazyInit = ( /**
                 * @return {?}
                 */function () {
                    _this.headers = new Map();
                    headers.split('\n').forEach(( /**
                     * @param {?} line
                     * @return {?}
                     */function (/**
                     * @param {?} line
                     * @return {?}
                     */ line) {
                        /** @type {?} */
                        var index = line.indexOf(':');
                        if (index > 0) {
                            /** @type {?} */
                            var name_3 = line.slice(0, index);
                            /** @type {?} */
                            var key = name_3.toLowerCase();
                            /** @type {?} */
                            var value = line.slice(index + 1).trim();
                            _this.maybeSetNormalizedName(name_3, key);
                            if (_this.headers.has(key)) {
                                ( /** @type {?} */(_this.headers.get(key))).push(value);
                            }
                            else {
                                _this.headers.set(key, [value]);
                            }
                        }
                    }));
                });
            }
            else {
                this.lazyInit = ( /**
                 * @return {?}
                 */function () {
                    _this.headers = new Map();
                    Object.keys(headers).forEach(( /**
                     * @param {?} name
                     * @return {?}
                     */function (/**
                     * @param {?} name
                     * @return {?}
                     */ name) {
                        /** @type {?} */
                        var values = headers[name];
                        /** @type {?} */
                        var key = name.toLowerCase();
                        if (typeof values === 'string') {
                            values = [values];
                        }
                        if (values.length > 0) {
                            _this.headers.set(key, values);
                            _this.maybeSetNormalizedName(name, key);
                        }
                    }));
                });
            }
        }
        /**
         * Checks for existence of a given header.
         *
         * @param {?} name The header name to check for existence.
         *
         * @return {?} True if the header exists, false otherwise.
         */
        HttpHeaders.prototype.has = function (name) {
            this.init();
            return this.headers.has(name.toLowerCase());
        };
        /**
         * Retrieves the first value of a given header.
         *
         * @param {?} name The header name.
         *
         * @return {?} The value string if the header exists, null otherwise
         */
        HttpHeaders.prototype.get = function (name) {
            this.init();
            /** @type {?} */
            var values = this.headers.get(name.toLowerCase());
            return values && values.length > 0 ? values[0] : null;
        };
        /**
         * Retrieves the names of the headers.
         *
         * @return {?} A list of header names.
         */
        HttpHeaders.prototype.keys = function () {
            this.init();
            return Array.from(this.normalizedNames.values());
        };
        /**
         * Retrieves a list of values for a given header.
         *
         * @param {?} name The header name from which to retrieve values.
         *
         * @return {?} A string of values if the header exists, null otherwise.
         */
        HttpHeaders.prototype.getAll = function (name) {
            this.init();
            return this.headers.get(name.toLowerCase()) || null;
        };
        /**
         * Appends a new value to the existing set of values for a header
         * and returns them in a clone of the original instance.
         *
         * @param {?} name The header name for which to append the value or values.
         * @param {?} value The new value or array of values.
         *
         * @return {?} A clone of the HTTP headers object with the value appended to the given header.
         */
        HttpHeaders.prototype.append = function (name, value) {
            return this.clone({ name: name, value: value, op: 'a' });
        };
        /**
         * Sets or modifies a value for a given header in a clone of the original instance.
         * If the header already exists, its value is replaced with the given value
         * in the returned object.
         *
         * @param {?} name The header name.
         * @param {?} value The value or values to set or overide for the given header.
         *
         * @return {?} A clone of the HTTP headers object with the newly set header value.
         */
        HttpHeaders.prototype.set = function (name, value) {
            return this.clone({ name: name, value: value, op: 's' });
        };
        /**
         * Deletes values for a given header in a clone of the original instance.
         *
         * @param {?} name The header name.
         * @param {?=} value The value or values to delete for the given header.
         *
         * @return {?} A clone of the HTTP headers object with the given value deleted.
         */
        HttpHeaders.prototype.delete = function (name, value) {
            return this.clone({ name: name, value: value, op: 'd' });
        };
        /**
         * @private
         * @param {?} name
         * @param {?} lcName
         * @return {?}
         */
        HttpHeaders.prototype.maybeSetNormalizedName = function (name, lcName) {
            if (!this.normalizedNames.has(lcName)) {
                this.normalizedNames.set(lcName, name);
            }
        };
        /**
         * @private
         * @return {?}
         */
        HttpHeaders.prototype.init = function () {
            var _this = this;
            if (!!this.lazyInit) {
                if (this.lazyInit instanceof HttpHeaders) {
                    this.copyFrom(this.lazyInit);
                }
                else {
                    this.lazyInit();
                }
                this.lazyInit = null;
                if (!!this.lazyUpdate) {
                    this.lazyUpdate.forEach(( /**
                     * @param {?} update
                     * @return {?}
                     */function (/**
                     * @param {?} update
                     * @return {?}
                     */ update) { return _this.applyUpdate(update); }));
                    this.lazyUpdate = null;
                }
            }
        };
        /**
         * @private
         * @param {?} other
         * @return {?}
         */
        HttpHeaders.prototype.copyFrom = function (other) {
            var _this = this;
            other.init();
            Array.from(other.headers.keys()).forEach(( /**
             * @param {?} key
             * @return {?}
             */function (/**
             * @param {?} key
             * @return {?}
             */ key) {
                _this.headers.set(key, ( /** @type {?} */(other.headers.get(key))));
                _this.normalizedNames.set(key, ( /** @type {?} */(other.normalizedNames.get(key))));
            }));
        };
        /**
         * @private
         * @param {?} update
         * @return {?}
         */
        HttpHeaders.prototype.clone = function (update) {
            /** @type {?} */
            var clone = new HttpHeaders();
            clone.lazyInit =
                (!!this.lazyInit && this.lazyInit instanceof HttpHeaders) ? this.lazyInit : this;
            clone.lazyUpdate = (this.lazyUpdate || []).concat([update]);
            return clone;
        };
        /**
         * @private
         * @param {?} update
         * @return {?}
         */
        HttpHeaders.prototype.applyUpdate = function (update) {
            /** @type {?} */
            var key = update.name.toLowerCase();
            switch (update.op) {
                case 'a':
                case 's':
                    /** @type {?} */
                    var value = ( /** @type {?} */(update.value));
                    if (typeof value === 'string') {
                        value = [value];
                    }
                    if (value.length === 0) {
                        return;
                    }
                    this.maybeSetNormalizedName(update.name, key);
                    /** @type {?} */
                    var base = (update.op === 'a' ? this.headers.get(key) : undefined) || [];
                    base.push.apply(base, __spread(value));
                    this.headers.set(key, base);
                    break;
                case 'd':
                    /** @type {?} */
                    var toDelete_1 = ( /** @type {?} */(update.value));
                    if (!toDelete_1) {
                        this.headers.delete(key);
                        this.normalizedNames.delete(key);
                    }
                    else {
                        /** @type {?} */
                        var existing = this.headers.get(key);
                        if (!existing) {
                            return;
                        }
                        existing = existing.filter(( /**
                         * @param {?} value
                         * @return {?}
                         */function (/**
                         * @param {?} value
                         * @return {?}
                         */ value) { return toDelete_1.indexOf(value) === -1; }));
                        if (existing.length === 0) {
                            this.headers.delete(key);
                            this.normalizedNames.delete(key);
                        }
                        else {
                            this.headers.set(key, existing);
                        }
                    }
                    break;
            }
        };
        /**
         * \@internal
         * @param {?} fn
         * @return {?}
         */
        HttpHeaders.prototype.forEach = function (fn) {
            var _this = this;
            this.init();
            Array.from(this.normalizedNames.keys())
                .forEach(( /**
         * @param {?} key
         * @return {?}
         */function (/**
         * @param {?} key
         * @return {?}
         */ key) { return fn(( /** @type {?} */(_this.normalizedNames.get(key))), ( /** @type {?} */(_this.headers.get(key)))); }));
        };
        return HttpHeaders;
    }());
    /**
     * Provides encoding and decoding of URL parameter and query-string values.
     *
     * Serializes and parses URL parameter keys and values to encode and decode them.
     * If you pass URL query parameters without encoding,
     * the query parameters can be misinterpreted at the receiving end.
     *
     *
     * \@publicApi
     */
    var HttpUrlEncodingCodec = /** @class */ (function () {
        function HttpUrlEncodingCodec() {
        }
        /**
         * Encodes a key name for a URL parameter or query-string.
         * @param {?} key The key name.
         * @return {?} The encoded key name.
         */
        HttpUrlEncodingCodec.prototype.encodeKey = function (key) { return standardEncoding(key); };
        /**
         * Encodes the value of a URL parameter or query-string.
         * @param {?} value The value.
         * @return {?} The encoded value.
         */
        HttpUrlEncodingCodec.prototype.encodeValue = function (value) { return standardEncoding(value); };
        /**
         * Decodes an encoded URL parameter or query-string key.
         * @param {?} key The encoded key name.
         * @return {?} The decoded key name.
         */
        HttpUrlEncodingCodec.prototype.decodeKey = function (key) { return decodeURIComponent(key); };
        /**
         * Decodes an encoded URL parameter or query-string value.
         * @param {?} value The encoded value.
         * @return {?} The decoded value.
         */
        HttpUrlEncodingCodec.prototype.decodeValue = function (value) { return decodeURIComponent(value); };
        return HttpUrlEncodingCodec;
    }());
    /**
     * @param {?} rawParams
     * @param {?} codec
     * @return {?}
     */
    function paramParser(rawParams, codec) {
        /** @type {?} */
        var map = new Map();
        if (rawParams.length > 0) {
            /** @type {?} */
            var params = rawParams.split('&');
            params.forEach(( /**
             * @param {?} param
             * @return {?}
             */function (param) {
                /** @type {?} */
                var eqIdx = param.indexOf('=');
                var _b = __read(eqIdx == -1 ?
                    [codec.decodeKey(param), ''] :
                    [codec.decodeKey(param.slice(0, eqIdx)), codec.decodeValue(param.slice(eqIdx + 1))], 2), key = _b[0], val = _b[1];
                /** @type {?} */
                var list = map.get(key) || [];
                list.push(val);
                map.set(key, list);
            }));
        }
        return map;
    }
    /**
     * @param {?} v
     * @return {?}
     */
    function standardEncoding(v) {
        return encodeURIComponent(v)
            .replace(/%40/gi, '@')
            .replace(/%3A/gi, ':')
            .replace(/%24/gi, '$')
            .replace(/%2C/gi, ',')
            .replace(/%3B/gi, ';')
            .replace(/%2B/gi, '+')
            .replace(/%3D/gi, '=')
            .replace(/%3F/gi, '?')
            .replace(/%2F/gi, '/');
    }
    /**
     * An HTTP request/response body that represents serialized parameters,
     * per the MIME type `application/x-www-form-urlencoded`.
     *
     * This class is immutable; all mutation operations return a new instance.
     *
     * \@publicApi
     */
    var HttpParams = /** @class */ (function () {
        /**
         * @param {?=} options
         */
        function HttpParams(options) {
            if (options === void 0) { options = ( /** @type {?} */({})); }
            var _this = this;
            this.updates = null;
            this.cloneFrom = null;
            this.encoder = options.encoder || new HttpUrlEncodingCodec();
            if (!!options.fromString) {
                if (!!options.fromObject) {
                    throw new Error("Cannot specify both fromString and fromObject.");
                }
                this.map = paramParser(options.fromString, this.encoder);
            }
            else if (!!options.fromObject) {
                this.map = new Map();
                Object.keys(options.fromObject).forEach(( /**
                 * @param {?} key
                 * @return {?}
                 */function (/**
                 * @param {?} key
                 * @return {?}
                 */ key) {
                    /** @type {?} */
                    var value = (( /** @type {?} */(options.fromObject)))[key];
                    ( /** @type {?} */(_this.map)).set(key, Array.isArray(value) ? value : [value]);
                }));
            }
            else {
                this.map = null;
            }
        }
        /**
         * Reports whether the body includes one or more values for a given parameter.
         * @param {?} param The parameter name.
         * @return {?} True if the parameter has one or more values,
         * false if it has no value or is not present.
         */
        HttpParams.prototype.has = function (param) {
            this.init();
            return ( /** @type {?} */(this.map)).has(param);
        };
        /**
         * Retrieves the first value for a parameter.
         * @param {?} param The parameter name.
         * @return {?} The first value of the given parameter,
         * or `null` if the parameter is not present.
         */
        HttpParams.prototype.get = function (param) {
            this.init();
            /** @type {?} */
            var res = ( /** @type {?} */(this.map)).get(param);
            return !!res ? res[0] : null;
        };
        /**
         * Retrieves all values for a  parameter.
         * @param {?} param The parameter name.
         * @return {?} All values in a string array,
         * or `null` if the parameter not present.
         */
        HttpParams.prototype.getAll = function (param) {
            this.init();
            return ( /** @type {?} */(this.map)).get(param) || null;
        };
        /**
         * Retrieves all the parameters for this body.
         * @return {?} The parameter names in a string array.
         */
        HttpParams.prototype.keys = function () {
            this.init();
            return Array.from(( /** @type {?} */(this.map)).keys());
        };
        /**
         * Appends a new value to existing values for a parameter.
         * @param {?} param The parameter name.
         * @param {?} value The new value to add.
         * @return {?} A new body with the appended value.
         */
        HttpParams.prototype.append = function (param, value) { return this.clone({ param: param, value: value, op: 'a' }); };
        /**
         * Replaces the value for a parameter.
         * @param {?} param The parameter name.
         * @param {?} value The new value.
         * @return {?} A new body with the new value.
         */
        HttpParams.prototype.set = function (param, value) { return this.clone({ param: param, value: value, op: 's' }); };
        /**
         * Removes a given value or all values from a parameter.
         * @param {?} param The parameter name.
         * @param {?=} value The value to remove, if provided.
         * @return {?} A new body with the given value removed, or with all values
         * removed if no value is specified.
         */
        HttpParams.prototype.delete = function (param, value) { return this.clone({ param: param, value: value, op: 'd' }); };
        /**
         * Serializes the body to an encoded string, where key-value pairs (separated by `=`) are
         * separated by `&`s.
         * @return {?}
         */
        HttpParams.prototype.toString = function () {
            var _this = this;
            this.init();
            return this.keys()
                .map(( /**
         * @param {?} key
         * @return {?}
         */function (/**
         * @param {?} key
         * @return {?}
         */ key) {
                /** @type {?} */
                var eKey = _this.encoder.encodeKey(key);
                return ( /** @type {?} */(( /** @type {?} */(_this.map)).get(key))).map(( /**
                 * @param {?} value
                 * @return {?}
                 */function (/**
                 * @param {?} value
                 * @return {?}
                 */ value) { return eKey + '=' + _this.encoder.encodeValue(value); }))
                    .join('&');
            }))
                .join('&');
        };
        /**
         * @private
         * @param {?} update
         * @return {?}
         */
        HttpParams.prototype.clone = function (update) {
            /** @type {?} */
            var clone = new HttpParams(( /** @type {?} */({ encoder: this.encoder })));
            clone.cloneFrom = this.cloneFrom || this;
            clone.updates = (this.updates || []).concat([update]);
            return clone;
        };
        /**
         * @private
         * @return {?}
         */
        HttpParams.prototype.init = function () {
            var _this = this;
            if (this.map === null) {
                this.map = new Map();
            }
            if (this.cloneFrom !== null) {
                this.cloneFrom.init();
                this.cloneFrom.keys().forEach(( /**
                 * @param {?} key
                 * @return {?}
                 */function (/**
                 * @param {?} key
                 * @return {?}
                 */ key) { return ( /** @type {?} */(_this.map)).set(key, ( /** @type {?} */(( /** @type {?} */(( /** @type {?} */(_this.cloneFrom)).map)).get(key)))); }));
                ( /** @type {?} */(this.updates)).forEach(( /**
                 * @param {?} update
                 * @return {?}
                 */function (/**
                 * @param {?} update
                 * @return {?}
                 */ update) {
                    switch (update.op) {
                        case 'a':
                        case 's':
                            /** @type {?} */
                            var base = (update.op === 'a' ? ( /** @type {?} */(_this.map)).get(update.param) : undefined) || [];
                            base.push(( /** @type {?} */(update.value)));
                            ( /** @type {?} */(_this.map)).set(update.param, base);
                            break;
                        case 'd':
                            if (update.value !== undefined) {
                                /** @type {?} */
                                var base_1 = ( /** @type {?} */(_this.map)).get(update.param) || [];
                                /** @type {?} */
                                var idx = base_1.indexOf(update.value);
                                if (idx !== -1) {
                                    base_1.splice(idx, 1);
                                }
                                if (base_1.length > 0) {
                                    ( /** @type {?} */(_this.map)).set(update.param, base_1);
                                }
                                else {
                                    ( /** @type {?} */(_this.map)).delete(update.param);
                                }
                            }
                            else {
                                ( /** @type {?} */(_this.map)).delete(update.param);
                                break;
                            }
                    }
                }));
                this.cloneFrom = this.updates = null;
            }
        };
        return HttpParams;
    }());
    /**
     * Determine whether the given HTTP method may include a body.
     * @param {?} method
     * @return {?}
     */
    function mightHaveBody(method) {
        switch (method) {
            case 'DELETE':
            case 'GET':
            case 'HEAD':
            case 'OPTIONS':
            case 'JSONP':
                return false;
            default:
                return true;
        }
    }
    /**
     * Safely assert whether the given value is an ArrayBuffer.
     *
     * In some execution environments ArrayBuffer is not defined.
     * @param {?} value
     * @return {?}
     */
    function isArrayBuffer(value) {
        return typeof ArrayBuffer !== 'undefined' && value instanceof ArrayBuffer;
    }
    /**
     * Safely assert whether the given value is a Blob.
     *
     * In some execution environments Blob is not defined.
     * @param {?} value
     * @return {?}
     */
    function isBlob(value) {
        return typeof Blob !== 'undefined' && value instanceof Blob;
    }
    /**
     * Safely assert whether the given value is a FormData instance.
     *
     * In some execution environments FormData is not defined.
     * @param {?} value
     * @return {?}
     */
    function isFormData(value) {
        return typeof FormData !== 'undefined' && value instanceof FormData;
    }
    /**
     * An outgoing HTTP request with an optional typed body.
     *
     * `HttpRequest` represents an outgoing request, including URL, method,
     * headers, body, and other request configuration options. Instances should be
     * assumed to be immutable. To modify a `HttpRequest`, the `clone`
     * method should be used.
     *
     * \@publicApi
     * @template T
     */
    var HttpRequest = /** @class */ (function () {
        /**
         * @param {?} method
         * @param {?} url
         * @param {?=} third
         * @param {?=} fourth
         */
        function HttpRequest(method, url, third, fourth) {
            this.url = url;
            /**
             * The request body, or `null` if one isn't set.
             *
             * Bodies are not enforced to be immutable, as they can include a reference to any
             * user-defined data type. However, interceptors should take care to preserve
             * idempotence by treating them as such.
             */
            this.body = null;
            /**
             * Whether this request should be made in a way that exposes progress events.
             *
             * Progress events are expensive (change detection runs on each event) and so
             * they should only be requested if the consumer intends to monitor them.
             */
            this.reportProgress = false;
            /**
             * Whether this request should be sent with outgoing credentials (cookies).
             */
            this.withCredentials = false;
            /**
             * The expected response type of the server.
             *
             * This is used to parse the response appropriately before returning it to
             * the requestee.
             */
            this.responseType = 'json';
            this.method = method.toUpperCase();
            // Next, need to figure out which argument holds the HttpRequestInit
            // options, if any.
            /** @type {?} */
            var options;
            // Check whether a body argument is expected. The only valid way to omit
            // the body argument is to use a known no-body method like GET.
            if (mightHaveBody(this.method) || !!fourth) {
                // Body is the third argument, options are the fourth.
                this.body = (third !== undefined) ? ( /** @type {?} */(third)) : null;
                options = fourth;
            }
            else {
                // No body required, options are the third argument. The body stays null.
                options = ( /** @type {?} */(third));
            }
            // If options have been passed, interpret them.
            if (options) {
                // Normalize reportProgress and withCredentials.
                this.reportProgress = !!options.reportProgress;
                this.withCredentials = !!options.withCredentials;
                // Override default response type of 'json' if one is provided.
                if (!!options.responseType) {
                    this.responseType = options.responseType;
                }
                // Override headers if they're provided.
                if (!!options.headers) {
                    this.headers = options.headers;
                }
                if (!!options.params) {
                    this.params = options.params;
                }
            }
            // If no headers have been passed in, construct a new HttpHeaders instance.
            if (!this.headers) {
                this.headers = new HttpHeaders();
            }
            // If no parameters have been passed in, construct a new HttpUrlEncodedParams instance.
            if (!this.params) {
                this.params = new HttpParams();
                this.urlWithParams = url;
            }
            else {
                // Encode the parameters to a string in preparation for inclusion in the URL.
                /** @type {?} */
                var params = this.params.toString();
                if (params.length === 0) {
                    // No parameters, the visible URL is just the URL given at creation time.
                    this.urlWithParams = url;
                }
                else {
                    // Does the URL already have query parameters? Look for '?'.
                    /** @type {?} */
                    var qIdx = url.indexOf('?');
                    // There are 3 cases to handle:
                    // 1) No existing parameters -> append '?' followed by params.
                    // 2) '?' exists and is followed by existing query string ->
                    //    append '&' followed by params.
                    // 3) '?' exists at the end of the url -> append params directly.
                    // This basically amounts to determining the character, if any, with
                    // which to join the URL and parameters.
                    /** @type {?} */
                    var sep = qIdx === -1 ? '?' : (qIdx < url.length - 1 ? '&' : '');
                    this.urlWithParams = url + sep + params;
                }
            }
        }
        /**
         * Transform the free-form body into a serialized format suitable for
         * transmission to the server.
         * @return {?}
         */
        HttpRequest.prototype.serializeBody = function () {
            // If no body is present, no need to serialize it.
            if (this.body === null) {
                return null;
            }
            // Check whether the body is already in a serialized form. If so,
            // it can just be returned directly.
            if (isArrayBuffer(this.body) || isBlob(this.body) || isFormData(this.body) ||
                typeof this.body === 'string') {
                return this.body;
            }
            // Check whether the body is an instance of HttpUrlEncodedParams.
            if (this.body instanceof HttpParams) {
                return this.body.toString();
            }
            // Check whether the body is an object or array, and serialize with JSON if so.
            if (typeof this.body === 'object' || typeof this.body === 'boolean' ||
                Array.isArray(this.body)) {
                return JSON.stringify(this.body);
            }
            // Fall back on toString() for everything else.
            return (( /** @type {?} */(this.body))).toString();
        };
        /**
         * Examine the body and attempt to infer an appropriate MIME type
         * for it.
         *
         * If no such type can be inferred, this method will return `null`.
         * @return {?}
         */
        HttpRequest.prototype.detectContentTypeHeader = function () {
            // An empty body has no content type.
            if (this.body === null) {
                return null;
            }
            // FormData bodies rely on the browser's content type assignment.
            if (isFormData(this.body)) {
                return null;
            }
            // Blobs usually have their own content type. If it doesn't, then
            // no type can be inferred.
            if (isBlob(this.body)) {
                return this.body.type || null;
            }
            // Array buffers have unknown contents and thus no type can be inferred.
            if (isArrayBuffer(this.body)) {
                return null;
            }
            // Technically, strings could be a form of JSON data, but it's safe enough
            // to assume they're plain strings.
            if (typeof this.body === 'string') {
                return 'text/plain';
            }
            // `HttpUrlEncodedParams` has its own content-type.
            if (this.body instanceof HttpParams) {
                return 'application/x-www-form-urlencoded;charset=UTF-8';
            }
            // Arrays, objects, and numbers will be encoded as JSON.
            if (typeof this.body === 'object' || typeof this.body === 'number' ||
                Array.isArray(this.body)) {
                return 'application/json';
            }
            // No type could be inferred.
            return null;
        };
        /**
         * @param {?=} update
         * @return {?}
         */
        HttpRequest.prototype.clone = function (update) {
            if (update === void 0) { update = {}; }
            // For method, url, and responseType, take the current value unless
            // it is overridden in the update hash.
            /** @type {?} */
            var method = update.method || this.method;
            /** @type {?} */
            var url = update.url || this.url;
            /** @type {?} */
            var responseType = update.responseType || this.responseType;
            // The body is somewhat special - a `null` value in update.body means
            // whatever current body is present is being overridden with an empty
            // body, whereas an `undefined` value in update.body implies no
            // override.
            /** @type {?} */
            var body = (update.body !== undefined) ? update.body : this.body;
            // Carefully handle the boolean options to differentiate between
            // `false` and `undefined` in the update args.
            /** @type {?} */
            var withCredentials = (update.withCredentials !== undefined) ? update.withCredentials : this.withCredentials;
            /** @type {?} */
            var reportProgress = (update.reportProgress !== undefined) ? update.reportProgress : this.reportProgress;
            // Headers and params may be appended to if `setHeaders` or
            // `setParams` are used.
            /** @type {?} */
            var headers = update.headers || this.headers;
            /** @type {?} */
            var params = update.params || this.params;
            // Check whether the caller has asked to add headers.
            if (update.setHeaders !== undefined) {
                // Set every requested header.
                headers =
                    Object.keys(update.setHeaders)
                        .reduce(( /**
                 * @param {?} headers
                 * @param {?} name
                 * @return {?}
                 */function (headers, name) { return headers.set(name, ( /** @type {?} */(update.setHeaders))[name]); }), headers);
            }
            // Check whether the caller has asked to set params.
            if (update.setParams) {
                // Set every requested param.
                params = Object.keys(update.setParams)
                    .reduce(( /**
             * @param {?} params
             * @param {?} param
             * @return {?}
             */function (params, param) { return params.set(param, ( /** @type {?} */(update.setParams))[param]); }), params);
            }
            // Finally, construct the new HttpRequest using the pieces from above.
            return new HttpRequest(method, url, body, {
                params: params, headers: headers, reportProgress: reportProgress, responseType: responseType, withCredentials: withCredentials,
            });
        };
        return HttpRequest;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var HttpEventType = {
        /**
         * The request was sent out over the wire.
         */
        Sent: 0,
        /**
         * An upload progress event was received.
         */
        UploadProgress: 1,
        /**
         * The response status code and headers were received.
         */
        ResponseHeader: 2,
        /**
         * A download progress event was received.
         */
        DownloadProgress: 3,
        /**
         * The full response including the body was received.
         */
        Response: 4,
        /**
         * A custom event from an interceptor or a backend.
         */
        User: 5,
    };
    HttpEventType[HttpEventType.Sent] = 'Sent';
    HttpEventType[HttpEventType.UploadProgress] = 'UploadProgress';
    HttpEventType[HttpEventType.ResponseHeader] = 'ResponseHeader';
    HttpEventType[HttpEventType.DownloadProgress] = 'DownloadProgress';
    HttpEventType[HttpEventType.Response] = 'Response';
    HttpEventType[HttpEventType.User] = 'User';
    /**
     * Base class for both `HttpResponse` and `HttpHeaderResponse`.
     *
     * \@publicApi
     * @abstract
     */
    var HttpResponseBase = /** @class */ (function () {
        /**
         * Super-constructor for all responses.
         *
         * The single parameter accepted is an initialization hash. Any properties
         * of the response passed there will override the default values.
         * @param {?} init
         * @param {?=} defaultStatus
         * @param {?=} defaultStatusText
         */
        function HttpResponseBase(init, defaultStatus, defaultStatusText) {
            if (defaultStatus === void 0) { defaultStatus = 200; }
            if (defaultStatusText === void 0) { defaultStatusText = 'OK'; }
            // If the hash has values passed, use them to initialize the response.
            // Otherwise use the default values.
            this.headers = init.headers || new HttpHeaders();
            this.status = init.status !== undefined ? init.status : defaultStatus;
            this.statusText = init.statusText || defaultStatusText;
            this.url = init.url || null;
            // Cache the ok value to avoid defining a getter.
            this.ok = this.status >= 200 && this.status < 300;
        }
        return HttpResponseBase;
    }());
    /**
     * A partial HTTP response which only includes the status and header data,
     * but no response body.
     *
     * `HttpHeaderResponse` is a `HttpEvent` available on the response
     * event stream, only when progress events are requested.
     *
     * \@publicApi
     */
    var HttpHeaderResponse = /** @class */ (function (_super) {
        __extends(HttpHeaderResponse, _super);
        /**
         * Create a new `HttpHeaderResponse` with the given parameters.
         * @param {?=} init
         */
        function HttpHeaderResponse(init) {
            if (init === void 0) { init = {}; }
            var _this = _super.call(this, init) || this;
            _this.type = HttpEventType.ResponseHeader;
            return _this;
        }
        /**
         * Copy this `HttpHeaderResponse`, overriding its contents with the
         * given parameter hash.
         * @param {?=} update
         * @return {?}
         */
        HttpHeaderResponse.prototype.clone = function (update) {
            if (update === void 0) { update = {}; }
            // Perform a straightforward initialization of the new HttpHeaderResponse,
            // overriding the current parameters with new ones if given.
            return new HttpHeaderResponse({
                headers: update.headers || this.headers,
                status: update.status !== undefined ? update.status : this.status,
                statusText: update.statusText || this.statusText,
                url: update.url || this.url || undefined,
            });
        };
        return HttpHeaderResponse;
    }(HttpResponseBase));
    /**
     * A full HTTP response, including a typed response body (which may be `null`
     * if one was not returned).
     *
     * `HttpResponse` is a `HttpEvent` available on the response event
     * stream.
     *
     * \@publicApi
     * @template T
     */
    var HttpResponse = /** @class */ (function (_super) {
        __extends(HttpResponse, _super);
        /**
         * Construct a new `HttpResponse`.
         * @param {?=} init
         */
        function HttpResponse(init) {
            if (init === void 0) { init = {}; }
            var _this = _super.call(this, init) || this;
            _this.type = HttpEventType.Response;
            _this.body = init.body !== undefined ? init.body : null;
            return _this;
        }
        /**
         * @param {?=} update
         * @return {?}
         */
        HttpResponse.prototype.clone = function (update) {
            if (update === void 0) { update = {}; }
            return new HttpResponse({
                body: (update.body !== undefined) ? update.body : this.body,
                headers: update.headers || this.headers,
                status: (update.status !== undefined) ? update.status : this.status,
                statusText: update.statusText || this.statusText,
                url: update.url || this.url || undefined,
            });
        };
        return HttpResponse;
    }(HttpResponseBase));
    /**
     * A response that represents an error or failure, either from a
     * non-successful HTTP status, an error while executing the request,
     * or some other failure which occurred during the parsing of the response.
     *
     * Any error returned on the `Observable` response stream will be
     * wrapped in an `HttpErrorResponse` to provide additional context about
     * the state of the HTTP layer when the error occurred. The error property
     * will contain either a wrapped Error object or the error response returned
     * from the server.
     *
     * \@publicApi
     */
    var HttpErrorResponse = /** @class */ (function (_super) {
        __extends(HttpErrorResponse, _super);
        /**
         * @param {?} init
         */
        function HttpErrorResponse(init) {
            var _this = 
            // Initialize with a default status of 0 / Unknown Error.
            _super.call(this, init, 0, 'Unknown Error') || this;
            _this.name = 'HttpErrorResponse';
            /**
             * Errors are never okay, even when the status code is in the 2xx success range.
             */
            _this.ok = false;
            // If the response was successful, then this was a parse error. Otherwise, it was
            // a protocol-level failure of some sort. Either the request failed in transit
            // or the server returned an unsuccessful status code.
            if (_this.status >= 200 && _this.status < 300) {
                _this.message = "Http failure during parsing for " + (init.url || '(unknown url)');
            }
            else {
                _this.message =
                    "Http failure response for " + (init.url || '(unknown url)') + ": " + init.status + " " + init.statusText;
            }
            _this.error = init.error || null;
            return _this;
        }
        return HttpErrorResponse;
    }(HttpResponseBase));
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Constructs an instance of `HttpRequestOptions<T>` from a source `HttpMethodOptions` and
     * the given `body`. This function clones the object and adds the body.
     *
     * Note that the `responseType` *options* value is a String that identifies the
     * single data type of the response.
     * A single overload version of the method handles each response type.
     * The value of `responseType` cannot be a union, as the combined signature could imply.
     *
     * @template T
     * @param {?} options
     * @param {?} body
     * @return {?}
     */
    function addBody(options, body) {
        return {
            body: body,
            headers: options.headers,
            observe: options.observe,
            params: options.params,
            reportProgress: options.reportProgress,
            responseType: options.responseType,
            withCredentials: options.withCredentials,
        };
    }
    /**
     * Performs HTTP requests.
     * This service is available as an injectable class, with methods to perform HTTP requests.
     * Each request method has multiple signatures, and the return type varies based on
     * the signature that is called (mainly the values of `observe` and `responseType`).
     *
     * Note that the `responseType` *options* value is a String that identifies the
     * single data type of the response.
     * A single overload version of the method handles each response type.
     * The value of `responseType` cannot be a union, as the combined signature could imply.
     *
     * \@usageNotes
     * Sample HTTP requests for the [Tour of Heroes](/tutorial/toh-pt0) application.
     *
     * ### HTTP Request Example
     *
     * ```
     *  // GET heroes whose name contains search term
     * searchHeroes(term: string): observable<Hero[]>{
     *
     *  const params = new HttpParams({fromString: 'name=term'});
     *    return this.httpClient.request('GET', this.heroesUrl, {responseType:'json', params});
     * }
     * ```
     * ### JSONP Example
     * ```
     * requestJsonp(url, callback = 'callback') {
     *  return this.httpClient.jsonp(this.heroesURL, callback);
     * }
     * ```
     *
     * ### PATCH Example
     * ```
     * // PATCH one of the heroes' name
     * patchHero (id: number, heroName: string): Observable<{}> {
     * const url = `${this.heroesUrl}/${id}`;   // PATCH api/heroes/42
     *  return this.httpClient.patch(url, {name: heroName}, httpOptions)
     *    .pipe(catchError(this.handleError('patchHero')));
     * }
     * ```
     *
     * @see [HTTP Guide](guide/http)
     *
     * \@publicApi
     */
    var HttpClient = /** @class */ (function () {
        /**
         * @param {?} handler
         */
        function HttpClient(handler) {
            this.handler = handler;
        }
        /**
         * Constructs an observable for a generic HTTP request that, when subscribed,
         * fires the request through the chain of registered interceptors and on to the
         * server.
         *
         * You can pass an `HttpRequest` directly as the only parameter. In this case,
         * the call returns an observable of the raw `HttpEvent` stream.
         *
         * Alternatively you can pass an HTTP method as the first parameter,
         * a URL string as the second, and an options hash containing the request body as the third.
         * See `addBody()`. In this case, the specified `responseType` and `observe` options determine the
         * type of returned observable.
         *   * The `responseType` value determines how a successful response body is parsed.
         *   * If `responseType` is the default `json`, you can pass a type interface for the resulting
         * object as a type parameter to the call.
         *
         * The `observe` value determines the return type, according to what you are interested in
         * observing.
         *   * An `observe` value of events returns an observable of the raw `HttpEvent` stream, including
         * progress events by default.
         *   * An `observe` value of response returns an observable of `HttpResponse<T>`,
         * where the `T` parameter depends on the `responseType` and any optionally provided type
         * parameter.
         *   * An `observe` value of body returns an observable of `<T>` with the same `T` body type.
         *
         * @param {?} first
         * @param {?=} url
         * @param {?=} options
         * @return {?}
         */
        HttpClient.prototype.request = function (first, url, options) {
            var _this = this;
            if (options === void 0) { options = {}; }
            /** @type {?} */
            var req;
            // First, check whether the primary argument is an instance of `HttpRequest`.
            if (first instanceof HttpRequest) {
                // It is. The other arguments must be undefined (per the signatures) and can be
                // ignored.
                req = ( /** @type {?} */(first));
            }
            else {
                // It's a string, so it represents a URL. Construct a request based on it,
                // and incorporate the remaining arguments (assuming `GET` unless a method is
                // provided.
                // Figure out the headers.
                /** @type {?} */
                var headers = undefined;
                if (options.headers instanceof HttpHeaders) {
                    headers = options.headers;
                }
                else {
                    headers = new HttpHeaders(options.headers);
                }
                // Sort out parameters.
                /** @type {?} */
                var params = undefined;
                if (!!options.params) {
                    if (options.params instanceof HttpParams) {
                        params = options.params;
                    }
                    else {
                        params = new HttpParams(( /** @type {?} */({ fromObject: options.params })));
                    }
                }
                // Construct the request.
                req = new HttpRequest(first, ( /** @type {?} */(url)), (options.body !== undefined ? options.body : null), {
                    headers: headers,
                    params: params,
                    reportProgress: options.reportProgress,
                    // By default, JSON is assumed to be returned for all calls.
                    responseType: options.responseType || 'json',
                    withCredentials: options.withCredentials,
                });
            }
            // Start with an Observable.of() the initial request, and run the handler (which
            // includes all interceptors) inside a concatMap(). This way, the handler runs
            // inside an Observable chain, which causes interceptors to be re-run on every
            // subscription (this also makes retries re-run the handler, including interceptors).
            /** @type {?} */
            var events$ = of(req).pipe(concatMap(( /**
             * @param {?} req
             * @return {?}
             */function (req) { return _this.handler.handle(req); })));
            // If coming via the API signature which accepts a previously constructed HttpRequest,
            // the only option is to get the event stream. Otherwise, return the event stream if
            // that is what was requested.
            if (first instanceof HttpRequest || options.observe === 'events') {
                return events$;
            }
            // The requested stream contains either the full response or the body. In either
            // case, the first step is to filter the event stream to extract a stream of
            // responses(s).
            /** @type {?} */
            var res$ = ( /** @type {?} */(events$.pipe(filter(( /**
             * @param {?} event
             * @return {?}
             */function (event) { return event instanceof HttpResponse; })))));
            // Decide which stream to return.
            switch (options.observe || 'body') {
                case 'body':
                    // The requested stream is the body. Map the response stream to the response
                    // body. This could be done more simply, but a misbehaving interceptor might
                    // transform the response body into a different format and ignore the requested
                    // responseType. Guard against this by validating that the response is of the
                    // requested type.
                    switch (req.responseType) {
                        case 'arraybuffer':
                            return res$.pipe(map(( /**
                             * @param {?} res
                             * @return {?}
                             */function (res) {
                                // Validate that the body is an ArrayBuffer.
                                if (res.body !== null && !(res.body instanceof ArrayBuffer)) {
                                    throw new Error('Response is not an ArrayBuffer.');
                                }
                                return res.body;
                            })));
                        case 'blob':
                            return res$.pipe(map(( /**
                             * @param {?} res
                             * @return {?}
                             */function (res) {
                                // Validate that the body is a Blob.
                                if (res.body !== null && !(res.body instanceof Blob)) {
                                    throw new Error('Response is not a Blob.');
                                }
                                return res.body;
                            })));
                        case 'text':
                            return res$.pipe(map(( /**
                             * @param {?} res
                             * @return {?}
                             */function (res) {
                                // Validate that the body is a string.
                                if (res.body !== null && typeof res.body !== 'string') {
                                    throw new Error('Response is not a string.');
                                }
                                return res.body;
                            })));
                        case 'json':
                        default:
                            // No validation needed for JSON responses, as they can be of any type.
                            return res$.pipe(map(( /**
                             * @param {?} res
                             * @return {?}
                             */function (res) { return res.body; })));
                    }
                case 'response':
                    // The response stream was requested directly, so return it.
                    return res$;
                default:
                    // Guard against new future observe types being added.
                    throw new Error("Unreachable: unhandled observe type " + options.observe + "}");
            }
        };
        /**
         * Constructs an observable that, when subscribed, causes the configured
         * `DELETE` request to execute on the server. See the individual overloads for
         * details on the return type.
         *
         * @param {?} url     The endpoint URL.
         * @param {?=} options The HTTP options to send with the request.
         *
         * @return {?}
         */
        HttpClient.prototype.delete = function (url, options) {
            if (options === void 0) { options = {}; }
            return this.request('DELETE', url, ( /** @type {?} */(options)));
        };
        /**
         * Constructs an observable that, when subscribed, causes the configured
         * `GET` request to execute on the server. See the individual overloads for
         * details on the return type.
         * @param {?} url
         * @param {?=} options
         * @return {?}
         */
        HttpClient.prototype.get = function (url, options) {
            if (options === void 0) { options = {}; }
            return this.request('GET', url, ( /** @type {?} */(options)));
        };
        /**
         * Constructs an observable that, when subscribed, causes the configured
         * `HEAD` request to execute on the server. The `HEAD` method returns
         * meta information about the resource without transferring the
         * resource itself. See the individual overloads for
         * details on the return type.
         * @param {?} url
         * @param {?=} options
         * @return {?}
         */
        HttpClient.prototype.head = function (url, options) {
            if (options === void 0) { options = {}; }
            return this.request('HEAD', url, ( /** @type {?} */(options)));
        };
        /**
         * Constructs an `Observable` that, when subscribed, causes a request with the special method
         * `JSONP` to be dispatched via the interceptor pipeline.
         * The [JSONP pattern](https://en.wikipedia.org/wiki/JSONP) works around limitations of certain
         * API endpoints that don't support newer,
         * and preferable [CORS](https://developer.mozilla.org/en-US/docs/Web/HTTP/CORS) protocol.
         * JSONP treats the endpoint API as a JavaScript file and tricks the browser to process the
         * requests even if the API endpoint is not located on the same domain (origin) as the client-side
         * application making the request.
         * The endpoint API must support JSONP callback for JSONP requests to work.
         * The resource API returns the JSON response wrapped in a callback function.
         * You can pass the callback function name as one of the query parameters.
         * Note that JSONP requests can only be used with `GET` requests.
         *
         * @template T
         * @param {?} url The resource URL.
         * @param {?} callbackParam The callback function name.
         *
         * @return {?}
         */
        HttpClient.prototype.jsonp = function (url, callbackParam) {
            return this.request('JSONP', url, {
                params: new HttpParams().append(callbackParam, 'JSONP_CALLBACK'),
                observe: 'body',
                responseType: 'json',
            });
        };
        /**
         * Constructs an `Observable` that, when subscribed, causes the configured
         * `OPTIONS` request to execute on the server. This method allows the client
         * to determine the supported HTTP methods and other capabilites of an endpoint,
         * without implying a resource action. See the individual overloads for
         * details on the return type.
         * @param {?} url
         * @param {?=} options
         * @return {?}
         */
        HttpClient.prototype.options = function (url, options) {
            if (options === void 0) { options = {}; }
            return this.request('OPTIONS', url, ( /** @type {?} */(options)));
        };
        /**
         * Constructs an observable that, when subscribed, causes the configured
         * `PATCH` request to execute on the server. See the individual overloads for
         * details on the return type.
         * @param {?} url
         * @param {?} body
         * @param {?=} options
         * @return {?}
         */
        HttpClient.prototype.patch = function (url, body, options) {
            if (options === void 0) { options = {}; }
            return this.request('PATCH', url, addBody(options, body));
        };
        /**
         * Constructs an observable that, when subscribed, causes the configured
         * `POST` request to execute on the server. The server responds with the location of
         * the replaced resource. See the individual overloads for
         * details on the return type.
         * @param {?} url
         * @param {?} body
         * @param {?=} options
         * @return {?}
         */
        HttpClient.prototype.post = function (url, body, options) {
            if (options === void 0) { options = {}; }
            return this.request('POST', url, addBody(options, body));
        };
        /**
         * Constructs an observable that, when subscribed, causes the configured
         * `PUT` request to execute on the server. The `PUT` method replaces an existing resource
         * with a new set of values.
         * See the individual overloads for details on the return type.
         * @param {?} url
         * @param {?} body
         * @param {?=} options
         * @return {?}
         */
        HttpClient.prototype.put = function (url, body, options) {
            if (options === void 0) { options = {}; }
            return this.request('PUT', url, addBody(options, body));
        };
        return HttpClient;
    }());
    HttpClient.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    HttpClient.ctorParameters = function () { return [
        { type: HttpHandler }
    ]; };
    /**
     * `HttpHandler` which applies an `HttpInterceptor` to an `HttpRequest`.
     *
     *
     */
    var HttpInterceptorHandler = /** @class */ (function () {
        /**
         * @param {?} next
         * @param {?} interceptor
         */
        function HttpInterceptorHandler(next, interceptor) {
            this.next = next;
            this.interceptor = interceptor;
        }
        /**
         * @param {?} req
         * @return {?}
         */
        HttpInterceptorHandler.prototype.handle = function (req) {
            return this.interceptor.intercept(req, this.next);
        };
        return HttpInterceptorHandler;
    }());
    /**
     * A multi-provider token that represents the array of registered
     * `HttpInterceptor` objects.
     *
     * \@publicApi
     * @type {?}
     */
    var HTTP_INTERCEPTORS = new InjectionToken('HTTP_INTERCEPTORS');
    var NoopInterceptor = /** @class */ (function () {
        function NoopInterceptor() {
        }
        /**
         * @param {?} req
         * @param {?} next
         * @return {?}
         */
        NoopInterceptor.prototype.intercept = function (req, next) {
            return next.handle(req);
        };
        return NoopInterceptor;
    }());
    NoopInterceptor.decorators = [
        { type: Injectable }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var XSSI_PREFIX = /^\)\]\}',?\n/;
    /**
     * Determine an appropriate URL for the response, by checking either
     * XMLHttpRequest.responseURL or the X-Request-URL header.
     * @param {?} xhr
     * @return {?}
     */
    function getResponseUrl(xhr) {
        if ('responseURL' in xhr && xhr.responseURL) {
            return xhr.responseURL;
        }
        if (/^X-Request-URL:/m.test(xhr.getAllResponseHeaders())) {
            return xhr.getResponseHeader('X-Request-URL');
        }
        return null;
    }
    /**
     * A wrapper around the `XMLHttpRequest` constructor.
     *
     * \@publicApi
     * @abstract
     */
    var XhrFactory = /** @class */ (function () {
        function XhrFactory() {
        }
        return XhrFactory;
    }());
    /**
     * A factory for `HttpXhrBackend` that uses the `XMLHttpRequest` browser API.
     *
     */
    var BrowserXhr = /** @class */ (function () {
        function BrowserXhr() {
        }
        /**
         * @return {?}
         */
        BrowserXhr.prototype.build = function () { return ( /** @type {?} */((new XMLHttpRequest()))); };
        return BrowserXhr;
    }());
    BrowserXhr.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    BrowserXhr.ctorParameters = function () { return []; };
    /**
     * Uses `XMLHttpRequest` to send requests to a backend server.
     * @see `HttpHandler`
     * @see `JsonpClientBackend`
     *
     * \@publicApi
     */
    var HttpXhrBackend = /** @class */ (function () {
        /**
         * @param {?} xhrFactory
         */
        function HttpXhrBackend(xhrFactory) {
            this.xhrFactory = xhrFactory;
        }
        /**
         * Processes a request and returns a stream of response events.
         * @param {?} req The request object.
         * @return {?} An observable of the response events.
         */
        HttpXhrBackend.prototype.handle = function (req) {
            var _this = this;
            // Quick check to give a better error message when a user attempts to use
            // HttpClient.jsonp() without installing the JsonpClientModule
            if (req.method === 'JSONP') {
                throw new Error("Attempted to construct Jsonp request without JsonpClientModule installed.");
            }
            // Everything happens on Observable subscription.
            return new Observable(( /**
             * @param {?} observer
             * @return {?}
             */function (observer) {
                // Start by setting up the XHR object with request method, URL, and withCredentials flag.
                /** @type {?} */
                var xhr = _this.xhrFactory.build();
                xhr.open(req.method, req.urlWithParams);
                if (!!req.withCredentials) {
                    xhr.withCredentials = true;
                }
                // Add all the requested headers.
                req.headers.forEach(( /**
                 * @param {?} name
                 * @param {?} values
                 * @return {?}
                 */function (name, values) { return xhr.setRequestHeader(name, values.join(',')); }));
                // Add an Accept header if one isn't present already.
                if (!req.headers.has('Accept')) {
                    xhr.setRequestHeader('Accept', 'application/json, text/plain, */*');
                }
                // Auto-detect the Content-Type header if one isn't present already.
                if (!req.headers.has('Content-Type')) {
                    /** @type {?} */
                    var detectedType = req.detectContentTypeHeader();
                    // Sometimes Content-Type detection fails.
                    if (detectedType !== null) {
                        xhr.setRequestHeader('Content-Type', detectedType);
                    }
                }
                // Set the responseType if one was requested.
                if (req.responseType) {
                    /** @type {?} */
                    var responseType = req.responseType.toLowerCase();
                    // JSON responses need to be processed as text. This is because if the server
                    // returns an XSSI-prefixed JSON response, the browser will fail to parse it,
                    // xhr.response will be null, and xhr.responseText cannot be accessed to
                    // retrieve the prefixed JSON data in order to strip the prefix. Thus, all JSON
                    // is parsed by first requesting text and then applying JSON.parse.
                    xhr.responseType = ( /** @type {?} */(((responseType !== 'json') ? responseType : 'text')));
                }
                // Serialize the request body if one is present. If not, this will be set to null.
                /** @type {?} */
                var reqBody = req.serializeBody();
                // If progress events are enabled, response headers will be delivered
                // in two events - the HttpHeaderResponse event and the full HttpResponse
                // event. However, since response headers don't change in between these
                // two events, it doesn't make sense to parse them twice. So headerResponse
                // caches the data extracted from the response whenever it's first parsed,
                // to ensure parsing isn't duplicated.
                /** @type {?} */
                var headerResponse = null;
                // partialFromXhr extracts the HttpHeaderResponse from the current XMLHttpRequest
                // state, and memoizes it into headerResponse.
                /** @type {?} */
                var partialFromXhr = ( /**
                 * @return {?}
                 */function () {
                    if (headerResponse !== null) {
                        return headerResponse;
                    }
                    // Read status and normalize an IE9 bug (http://bugs.jquery.com/ticket/1450).
                    /** @type {?} */
                    var status = xhr.status === 1223 ? 204 : xhr.status;
                    /** @type {?} */
                    var statusText = xhr.statusText || 'OK';
                    // Parse headers from XMLHttpRequest - this step is lazy.
                    /** @type {?} */
                    var headers = new HttpHeaders(xhr.getAllResponseHeaders());
                    // Read the response URL from the XMLHttpResponse instance and fall back on the
                    // request URL.
                    /** @type {?} */
                    var url = getResponseUrl(xhr) || req.url;
                    // Construct the HttpHeaderResponse and memoize it.
                    headerResponse = new HttpHeaderResponse({ headers: headers, status: status, statusText: statusText, url: url });
                    return headerResponse;
                });
                // Next, a few closures are defined for the various events which XMLHttpRequest can
                // emit. This allows them to be unregistered as event listeners later.
                // First up is the load event, which represents a response being fully available.
                /** @type {?} */
                var onLoad = ( /**
                 * @return {?}
                 */function () {
                    // Read response state from the memoized partial data.
                    var _b = partialFromXhr(), headers = _b.headers, status = _b.status, statusText = _b.statusText, url = _b.url;
                    // The body will be read out if present.
                    /** @type {?} */
                    var body = null;
                    if (status !== 204) {
                        // Use XMLHttpRequest.response if set, responseText otherwise.
                        body = (typeof xhr.response === 'undefined') ? xhr.responseText : xhr.response;
                    }
                    // Normalize another potential bug (this one comes from CORS).
                    if (status === 0) {
                        status = !!body ? 200 : 0;
                    }
                    // ok determines whether the response will be transmitted on the event or
                    // error channel. Unsuccessful status codes (not 2xx) will always be errors,
                    // but a successful status code can still result in an error if the user
                    // asked for JSON data and the body cannot be parsed as such.
                    /** @type {?} */
                    var ok = status >= 200 && status < 300;
                    // Check whether the body needs to be parsed as JSON (in many cases the browser
                    // will have done that already).
                    if (req.responseType === 'json' && typeof body === 'string') {
                        // Save the original body, before attempting XSSI prefix stripping.
                        /** @type {?} */
                        var originalBody = body;
                        body = body.replace(XSSI_PREFIX, '');
                        try {
                            // Attempt the parse. If it fails, a parse error should be delivered to the user.
                            body = body !== '' ? JSON.parse(body) : null;
                        }
                        catch (error) {
                            // Since the JSON.parse failed, it's reasonable to assume this might not have been a
                            // JSON response. Restore the original body (including any XSSI prefix) to deliver
                            // a better error response.
                            body = originalBody;
                            // If this was an error request to begin with, leave it as a string, it probably
                            // just isn't JSON. Otherwise, deliver the parsing error to the user.
                            if (ok) {
                                // Even though the response status was 2xx, this is still an error.
                                ok = false;
                                // The parse error contains the text of the body that failed to parse.
                                body = ( /** @type {?} */({ error: error, text: body }));
                            }
                        }
                    }
                    if (ok) {
                        // A successful response is delivered on the event stream.
                        observer.next(new HttpResponse({
                            body: body,
                            headers: headers,
                            status: status,
                            statusText: statusText,
                            url: url || undefined,
                        }));
                        // The full body has been received and delivered, no further events
                        // are possible. This request is complete.
                        observer.complete();
                    }
                    else {
                        // An unsuccessful request is delivered on the error channel.
                        observer.error(new HttpErrorResponse({
                            // The error in this case is the response body (error from the server).
                            error: body,
                            headers: headers,
                            status: status,
                            statusText: statusText,
                            url: url || undefined,
                        }));
                    }
                });
                // The onError callback is called when something goes wrong at the network level.
                // Connection timeout, DNS error, offline, etc. These are actual errors, and are
                // transmitted on the error channel.
                /** @type {?} */
                var onError = ( /**
                 * @param {?} error
                 * @return {?}
                 */function (error) {
                    var url = partialFromXhr().url;
                    /** @type {?} */
                    var res = new HttpErrorResponse({
                        error: error,
                        status: xhr.status || 0,
                        statusText: xhr.statusText || 'Unknown Error',
                        url: url || undefined,
                    });
                    observer.error(res);
                });
                // The sentHeaders flag tracks whether the HttpResponseHeaders event
                // has been sent on the stream. This is necessary to track if progress
                // is enabled since the event will be sent on only the first download
                // progerss event.
                /** @type {?} */
                var sentHeaders = false;
                // The download progress event handler, which is only registered if
                // progress events are enabled.
                /** @type {?} */
                var onDownProgress = ( /**
                 * @param {?} event
                 * @return {?}
                 */function (event) {
                    // Send the HttpResponseHeaders event if it hasn't been sent already.
                    if (!sentHeaders) {
                        observer.next(partialFromXhr());
                        sentHeaders = true;
                    }
                    // Start building the download progress event to deliver on the response
                    // event stream.
                    /** @type {?} */
                    var progressEvent = {
                        type: HttpEventType.DownloadProgress,
                        loaded: event.loaded,
                    };
                    // Set the total number of bytes in the event if it's available.
                    if (event.lengthComputable) {
                        progressEvent.total = event.total;
                    }
                    // If the request was for text content and a partial response is
                    // available on XMLHttpRequest, include it in the progress event
                    // to allow for streaming reads.
                    if (req.responseType === 'text' && !!xhr.responseText) {
                        progressEvent.partialText = xhr.responseText;
                    }
                    // Finally, fire the event.
                    observer.next(progressEvent);
                });
                // The upload progress event handler, which is only registered if
                // progress events are enabled.
                /** @type {?} */
                var onUpProgress = ( /**
                 * @param {?} event
                 * @return {?}
                 */function (event) {
                    // Upload progress events are simpler. Begin building the progress
                    // event.
                    /** @type {?} */
                    var progress = {
                        type: HttpEventType.UploadProgress,
                        loaded: event.loaded,
                    };
                    // If the total number of bytes being uploaded is available, include
                    // it.
                    if (event.lengthComputable) {
                        progress.total = event.total;
                    }
                    // Send the event.
                    observer.next(progress);
                });
                // By default, register for load and error events.
                xhr.addEventListener('load', onLoad);
                xhr.addEventListener('error', onError);
                // Progress events are only enabled if requested.
                if (req.reportProgress) {
                    // Download progress is always enabled if requested.
                    xhr.addEventListener('progress', onDownProgress);
                    // Upload progress depends on whether there is a body to upload.
                    if (reqBody !== null && xhr.upload) {
                        xhr.upload.addEventListener('progress', onUpProgress);
                    }
                }
                // Fire the request, and notify the event stream that it was fired.
                xhr.send(( /** @type {?} */(reqBody)));
                observer.next({ type: HttpEventType.Sent });
                // This is the return from the Observable function, which is the
                // request cancellation handler.
                return ( /**
                 * @return {?}
                 */function () {
                    // On a cancellation, remove all registered event listeners.
                    xhr.removeEventListener('error', onError);
                    xhr.removeEventListener('load', onLoad);
                    if (req.reportProgress) {
                        xhr.removeEventListener('progress', onDownProgress);
                        if (reqBody !== null && xhr.upload) {
                            xhr.upload.removeEventListener('progress', onUpProgress);
                        }
                    }
                    // Finally, abort the in-flight request.
                    xhr.abort();
                });
            }));
        };
        return HttpXhrBackend;
    }());
    HttpXhrBackend.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    HttpXhrBackend.ctorParameters = function () { return [
        { type: XhrFactory }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var XSRF_COOKIE_NAME = new InjectionToken('XSRF_COOKIE_NAME');
    /** @type {?} */
    var XSRF_HEADER_NAME = new InjectionToken('XSRF_HEADER_NAME');
    /**
     * Retrieves the current XSRF token to use with the next outgoing request.
     *
     * \@publicApi
     * @abstract
     */
    var HttpXsrfTokenExtractor = /** @class */ (function () {
        function HttpXsrfTokenExtractor() {
        }
        return HttpXsrfTokenExtractor;
    }());
    /**
     * `HttpXsrfTokenExtractor` which retrieves the token from a cookie.
     */
    var HttpXsrfCookieExtractor = /** @class */ (function () {
        /**
         * @param {?} doc
         * @param {?} platform
         * @param {?} cookieName
         */
        function HttpXsrfCookieExtractor(doc, platform, cookieName) {
            this.doc = doc;
            this.platform = platform;
            this.cookieName = cookieName;
            this.lastCookieString = '';
            this.lastToken = null;
            /**
             * \@internal for testing
             */
            this.parseCount = 0;
        }
        /**
         * @return {?}
         */
        HttpXsrfCookieExtractor.prototype.getToken = function () {
            if (this.platform === 'server') {
                return null;
            }
            /** @type {?} */
            var cookieString = this.doc.cookie || '';
            if (cookieString !== this.lastCookieString) {
                this.parseCount++;
                this.lastToken = parseCookieValue(cookieString, this.cookieName);
                this.lastCookieString = cookieString;
            }
            return this.lastToken;
        };
        return HttpXsrfCookieExtractor;
    }());
    HttpXsrfCookieExtractor.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    HttpXsrfCookieExtractor.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] },
        { type: String, decorators: [{ type: Inject, args: [PLATFORM_ID,] }] },
        { type: String, decorators: [{ type: Inject, args: [XSRF_COOKIE_NAME,] }] }
    ]; };
    /**
     * `HttpInterceptor` which adds an XSRF token to eligible outgoing requests.
     */
    var HttpXsrfInterceptor = /** @class */ (function () {
        /**
         * @param {?} tokenService
         * @param {?} headerName
         */
        function HttpXsrfInterceptor(tokenService, headerName) {
            this.tokenService = tokenService;
            this.headerName = headerName;
        }
        /**
         * @param {?} req
         * @param {?} next
         * @return {?}
         */
        HttpXsrfInterceptor.prototype.intercept = function (req, next) {
            /** @type {?} */
            var lcUrl = req.url.toLowerCase();
            // Skip both non-mutating requests and absolute URLs.
            // Non-mutating requests don't require a token, and absolute URLs require special handling
            // anyway as the cookie set
            // on our origin is not the same as the token expected by another origin.
            if (req.method === 'GET' || req.method === 'HEAD' || lcUrl.startsWith('http://') ||
                lcUrl.startsWith('https://')) {
                return next.handle(req);
            }
            /** @type {?} */
            var token = this.tokenService.getToken();
            // Be careful not to overwrite an existing header of the same name.
            if (token !== null && !req.headers.has(this.headerName)) {
                req = req.clone({ headers: req.headers.set(this.headerName, token) });
            }
            return next.handle(req);
        };
        return HttpXsrfInterceptor;
    }());
    HttpXsrfInterceptor.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    HttpXsrfInterceptor.ctorParameters = function () { return [
        { type: HttpXsrfTokenExtractor },
        { type: String, decorators: [{ type: Inject, args: [XSRF_HEADER_NAME,] }] }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * An injectable `HttpHandler` that applies multiple interceptors
     * to a request before passing it to the given `HttpBackend`.
     *
     * The interceptors are loaded lazily from the injector, to allow
     * interceptors to themselves inject classes depending indirectly
     * on `HttpInterceptingHandler` itself.
     * @see `HttpInterceptor`
     */
    var HttpInterceptingHandler = /** @class */ (function () {
        /**
         * @param {?} backend
         * @param {?} injector
         */
        function HttpInterceptingHandler(backend, injector) {
            this.backend = backend;
            this.injector = injector;
            this.chain = null;
        }
        /**
         * @param {?} req
         * @return {?}
         */
        HttpInterceptingHandler.prototype.handle = function (req) {
            if (this.chain === null) {
                /** @type {?} */
                var interceptors = this.injector.get(HTTP_INTERCEPTORS, []);
                this.chain = interceptors.reduceRight(( /**
                 * @param {?} next
                 * @param {?} interceptor
                 * @return {?}
                 */function (next, interceptor) { return new HttpInterceptorHandler(next, interceptor); }), this.backend);
            }
            return this.chain.handle(req);
        };
        return HttpInterceptingHandler;
    }());
    HttpInterceptingHandler.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    HttpInterceptingHandler.ctorParameters = function () { return [
        { type: HttpBackend },
        { type: Injector }
    ]; };
    /**
     * Configures XSRF protection support for outgoing requests.
     *
     * For a server that supports a cookie-based XSRF protection system,
     * use directly to configure XSRF protection with the correct
     * cookie and header names.
     *
     * If no names are supplied, the default cookie name is `XSRF-TOKEN`
     * and the default header name is `X-XSRF-TOKEN`.
     *
     * \@publicApi
     */
    var HttpClientXsrfModule = /** @class */ (function () {
        function HttpClientXsrfModule() {
        }
        /**
         * Disable the default XSRF protection.
         * @return {?}
         */
        HttpClientXsrfModule.disable = function () {
            return {
                ngModule: HttpClientXsrfModule,
                providers: [
                    { provide: HttpXsrfInterceptor, useClass: NoopInterceptor },
                ],
            };
        };
        /**
         * Configure XSRF protection.
         * @param {?=} options An object that can specify either or both
         * cookie name or header name.
         * - Cookie name default is `XSRF-TOKEN`.
         * - Header name default is `X-XSRF-TOKEN`.
         *
         * @return {?}
         */
        HttpClientXsrfModule.withOptions = function (options) {
            if (options === void 0) { options = {}; }
            return {
                ngModule: HttpClientXsrfModule,
                providers: [
                    options.cookieName ? { provide: XSRF_COOKIE_NAME, useValue: options.cookieName } : [],
                    options.headerName ? { provide: XSRF_HEADER_NAME, useValue: options.headerName } : [],
                ],
            };
        };
        return HttpClientXsrfModule;
    }());
    HttpClientXsrfModule.decorators = [
        { type: NgModule, args: [{
                    providers: [
                        HttpXsrfInterceptor,
                        { provide: HTTP_INTERCEPTORS, useExisting: HttpXsrfInterceptor, multi: true },
                        { provide: HttpXsrfTokenExtractor, useClass: HttpXsrfCookieExtractor },
                        { provide: XSRF_COOKIE_NAME, useValue: 'XSRF-TOKEN' },
                        { provide: XSRF_HEADER_NAME, useValue: 'X-XSRF-TOKEN' },
                    ],
                },] }
    ];
    /**
     * Configures the [dependency injector](guide/glossary#injector) for `HttpClient`
     * with supporting services for XSRF. Automatically imported by `HttpClientModule`.
     *
     * You can add interceptors to the chain behind `HttpClient` by binding them to the
     * multiprovider for built-in [DI token](guide/glossary#di-token) `HTTP_INTERCEPTORS`.
     *
     * \@publicApi
     */
    var HttpClientModule = /** @class */ (function () {
        function HttpClientModule() {
        }
        return HttpClientModule;
    }());
    HttpClientModule.decorators = [
        { type: NgModule, args: [{
                    /**
                     * Optional configuration for XSRF protection.
                     */
                    imports: [
                        HttpClientXsrfModule.withOptions({
                            cookieName: 'XSRF-TOKEN',
                            headerName: 'X-XSRF-TOKEN',
                        }),
                    ],
                    /**
                     * Configures the [dependency injector](guide/glossary#injector) where it is imported
                     * with supporting services for HTTP communications.
                     */
                    providers: [
                        HttpClient,
                        { provide: HttpHandler, useClass: HttpInterceptingHandler },
                        HttpXhrBackend,
                        { provide: HttpBackend, useExisting: HttpXhrBackend },
                        BrowserXhr,
                        { provide: XhrFactory, useExisting: BrowserXhr },
                    ],
                },] }
    ];
    /**
     * @license Angular v8.2.14
     * (c) 2010-2019 Google LLC. https://angular.io/
     * License: MIT
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * An injectable service that produces an animation sequence programmatically within an
     * Angular component or directive.
     * Provided by the `BrowserAnimationsModule` or `NoopAnimationsModule`.
     *
     * \@usageNotes
     *
     * To use this service, add it to your component or directive as a dependency.
     * The service is instantiated along with your component.
     *
     * Apps do not typically need to create their own animation players, but if you
     * do need to, follow these steps:
     *
     * 1. Use the `build()` method to create a programmatic animation using the
     * `animate()` function. The method returns an `AnimationFactory` instance.
     *
     * 2. Use the factory object to create an `AnimationPlayer` and attach it to a DOM element.
     *
     * 3. Use the player object to control the animation programmatically.
     *
     * For example:
     *
     * ```ts
     * // import the service from BrowserAnimationsModule
     * import {AnimationBuilder} from '\@angular/animations';
     * // require the service as a dependency
     * class MyCmp {
     *   constructor(private _builder: AnimationBuilder) {}
     *
     *   makeAnimation(element: any) {
     *     // first define a reusable animation
     *     const myAnimation = this._builder.build([
     *       style({ width: 0 }),
     *       animate(1000, style({ width: '100px' }))
     *     ]);
     *
     *     // use the returned factory object to create a player
     *     const player = myAnimation.create(element);
     *
     *     player.play();
     *   }
     * }
     * ```
     *
     * \@publicApi
     * @abstract
     */
    var AnimationBuilder = /** @class */ (function () {
        function AnimationBuilder() {
        }
        return AnimationBuilder;
    }());
    /**
     * A factory object returned from the `AnimationBuilder`.`build()` method.
     *
     * \@publicApi
     * @abstract
     */
    var AnimationFactory = /** @class */ (function () {
        function AnimationFactory() {
        }
        return AnimationFactory;
    }());
    /**
     * Specifies automatic styling.
     *
     * \@publicApi
     * @type {?}
     */
    var AUTO_STYLE = '*';
    /**
     * Creates a named animation trigger, containing a  list of `state()`
     * and `transition()` entries to be evaluated when the expression
     * bound to the trigger changes.
     *
     * \@usageNotes
     * Define an animation trigger in the `animations` section of `\@Component` metadata.
     * In the template, reference the trigger by name and bind it to a trigger expression that
     * evaluates to a defined animation state, using the following format:
     *
     * `[\@triggerName]="expression"`
     *
     * Animation trigger bindings convert all values to strings, and then match the
     * previous and current values against any linked transitions.
     * Booleans can be specified as `1` or `true` and `0` or `false`.
     *
     * ### Usage Example
     *
     * The following example creates an animation trigger reference based on the provided
     * name value.
     * The provided animation value is expected to be an array consisting of state and
     * transition declarations.
     *
     * ```typescript
     * \@Component({
     *   selector: "my-component",
     *   templateUrl: "my-component-tpl.html",
     *   animations: [
     *     trigger("myAnimationTrigger", [
     *       state(...),
     *       state(...),
     *       transition(...),
     *       transition(...)
     *     ])
     *   ]
     * })
     * class MyComponent {
     *   myStatusExp = "something";
     * }
     * ```
     *
     * The template associated with this component makes use of the defined trigger
     * by binding to an element within its template code.
     *
     * ```html
     * <!-- somewhere inside of my-component-tpl.html -->
     * <div [\@myAnimationTrigger]="myStatusExp">...</div>
     * ```
     *
     * ### Using an inline function
     * The `transition` animation method also supports reading an inline function which can decide
     * if its associated animation should be run.
     *
     * ```typescript
     * // this method is run each time the `myAnimationTrigger` trigger value changes.
     * function myInlineMatcherFn(fromState: string, toState: string, element: any, params: {[key:
     * string]: any}): boolean {
     *   // notice that `element` and `params` are also available here
     *   return toState == 'yes-please-animate';
     * }
     *  /
     *   selector: 'my-component',
     *   templateUrl: 'my-component-tpl.html',
     *   animations: [
     *     trigger('myAnimationTrigger', [
     *       transition(myInlineMatcherFn, [
     *         // the animation sequence code
     *       ]),
     *     ])
     *   ]
     * })
     * class MyComponent {
     *   myStatusExp = "yes-please-animate";
     * }
     * ```
     *
     * ### Disabling Animations
     * When true, the special animation control binding `\@.disabled` binding prevents
     * all animations from rendering.
     * Place the  `\@.disabled` binding on an element to disable
     * animations on the element itself, as well as any inner animation triggers
     * within the element.
     *
     * The following example shows how to use this feature:
     *
     * ```typescript /
     *   selector: 'my-component',
     *   template: `
     *     <div [\@.disabled]="isDisabled">
     *       <div [\@childAnimation]="exp"></div>
     *     </div>
     *   `,
     *   animations: [
     *     trigger("childAnimation", [
     *       // ...
     *     ])
     *   ]
     * })
     * class MyComponent {
     *   isDisabled = true;
     *   exp = '...';
     * }
     * ```
     *
     * When `\@.disabled` is true, it prevents the `\@childAnimation` trigger from animating,
     * along with any inner animations.
     *
     * ### Disable animations application-wide
     * When an area of the template is set to have animations disabled,
     * **all** inner components have their animations disabled as well.
     * This means that you can disable all animations for an app
     * by placing a host binding set on `\@.disabled` on the topmost Angular component.
     *
     * ```typescript
     * import {Component, HostBinding} from '\@angular/core';
     *  /
     *   selector: 'app-component',
     *   templateUrl: 'app.component.html',
     * })
     * class AppComponent {
     * \@HostBinding('@.disabled')
     *   public animationsDisabled = true;
     * }
     * ```
     *
     * ### Overriding disablement of inner animations
     * Despite inner animations being disabled, a parent animation can `query()`
     * for inner elements located in disabled areas of the template and still animate
     * them if needed. This is also the case for when a sub animation is
     * queried by a parent and then later animated using `animateChild()`.
     *
     * ### Detecting when an animation is disabled
     * If a region of the DOM (or the entire application) has its animations disabled, the animation
     * trigger callbacks still fire, but for zero seconds. When the callback fires, it provides
     * an instance of an `AnimationEvent`. If animations are disabled,
     * the `.disabled` flag on the event is true.
     *
     * \@publicApi
     * @param {?} name An identifying string.
     * @param {?} definitions  An animation definition object, containing an array of `state()`
     * and `transition()` declarations.
     *
     * @return {?} An object that encapsulates the trigger data.
     *
     */
    function trigger(name, definitions) {
        return { type: 7 /* Trigger */, name: name, definitions: definitions, options: {} };
    }
    /**
     * Defines an animation step that combines styling information with timing information.
     *
     * \@usageNotes
     * Call within an animation `sequence()`, `{\@link animations/group group()}`, or
     * `transition()` call to specify an animation step
     * that applies given style data to the parent animation for a given amount of time.
     *
     * ### Syntax Examples
     * **Timing examples**
     *
     * The following examples show various `timings` specifications.
     * - `animate(500)` : Duration is 500 milliseconds.
     * - `animate("1s")` : Duration is 1000 milliseconds.
     * - `animate("100ms 0.5s")` : Duration is 100 milliseconds, delay is 500 milliseconds.
     * - `animate("5s ease-in")` : Duration is 5000 milliseconds, easing in.
     * - `animate("5s 10ms cubic-bezier(.17,.67,.88,.1)")` : Duration is 5000 milliseconds, delay is 10
     * milliseconds, easing according to a bezier curve.
     *
     * **Style examples**
     *
     * The following example calls `style()` to set a single CSS style.
     * ```typescript
     * animate(500, style({ background: "red" }))
     * ```
     * The following example calls `keyframes()` to set a CSS style
     * to different values for successive keyframes.
     * ```typescript
     * animate(500, keyframes(
     *  [
     *   style({ background: "blue" })),
     *   style({ background: "red" }))
     *  ])
     * ```
     *
     * \@publicApi
     * @param {?} timings Sets `AnimateTimings` for the parent animation.
     * A string in the format "duration [delay] [easing]".
     *  - Duration and delay are expressed as a number and optional time unit,
     * such as "1s" or "10ms" for one second and 10 milliseconds, respectively.
     * The default unit is milliseconds.
     *  - The easing value controls how the animation accelerates and decelerates
     * during its runtime. Value is one of  `ease`, `ease-in`, `ease-out`,
     * `ease-in-out`, or a `cubic-bezier()` function call.
     * If not supplied, no easing is applied.
     *
     * For example, the string "1s 100ms ease-out" specifies a duration of
     * 1000 milliseconds, and delay of 100 ms, and the "ease-out" easing style,
     * which decelerates near the end of the duration.
     * @param {?=} styles Sets AnimationStyles for the parent animation.
     * A function call to either `style()` or `keyframes()`
     * that returns a collection of CSS style entries to be applied to the parent animation.
     * When null, uses the styles from the destination state.
     * This is useful when describing an animation step that will complete an animation;
     * see "Animating to the final state" in `transitions()`.
     * @return {?} An object that encapsulates the animation step.
     *
     */
    function animate(timings, styles) {
        if (styles === void 0) { styles = null; }
        return { type: 4 /* Animate */, styles: styles, timings: timings };
    }
    /**
     * \@description Defines a list of animation steps to be run in parallel.
     *
     * \@usageNotes
     * Grouped animations are useful when a series of styles must be
     * animated at different starting times and closed off at different ending times.
     *
     * When called within a `sequence()` or a
     * `transition()` call, does not continue to the next
     * instruction until all of the inner animation steps have completed.
     *
     * \@publicApi
     * @param {?} steps An array of animation step objects.
     * - When steps are defined by `style()` or `animate()`
     * function calls, each call within the group is executed instantly.
     * - To specify offset styles to be applied at a later time, define steps with
     * `keyframes()`, or use `animate()` calls with a delay value.
     * For example:
     *
     * ```typescript
     * group([
     *   animate("1s", style({ background: "black" })),
     *   animate("2s", style({ color: "white" }))
     * ])
     * ```
     *
     * @param {?=} options An options object containing a delay and
     * developer-defined parameters that provide styling defaults and
     * can be overridden on invocation.
     *
     * @return {?} An object that encapsulates the group data.
     *
     */
    function group(steps, options) {
        if (options === void 0) { options = null; }
        return { type: 3 /* Group */, steps: steps, options: options };
    }
    /**
     * Defines a list of animation steps to be run sequentially, one by one.
     *
     * \@usageNotes
     * When you pass an array of steps to a
     * `transition()` call, the steps run sequentially by default.
     * Compare this to the `{\@link animations/group group()}` call, which runs animation steps in parallel.
     *
     * When a sequence is used within a `{\@link animations/group group()}` or a `transition()` call,
     * execution continues to the next instruction only after each of the inner animation
     * steps have completed.
     *
     * \@publicApi
     *
     * @param {?} steps An array of animation step objects.
     * - Steps defined by `style()` calls apply the styling data immediately.
     * - Steps defined by `animate()` calls apply the styling data over time
     *   as specified by the timing data.
     *
     * ```typescript
     * sequence([
     *   style({ opacity: 0 }),
     *   animate("1s", style({ opacity: 1 }))
     * ])
     * ```
     *
     * @param {?=} options An options object containing a delay and
     * developer-defined parameters that provide styling defaults and
     * can be overridden on invocation.
     *
     * @return {?} An object that encapsulates the sequence data.
     *
     */
    function sequence(steps, options) {
        if (options === void 0) { options = null; }
        return { type: 2 /* Sequence */, steps: steps, options: options };
    }
    /**
     * Declares a key/value object containing CSS properties/styles that
     * can then be used for an animation `state`, within an animation `sequence`,
     * or as styling data for calls to `animate()` and `keyframes()`.
     *
     * \@usageNotes
     * The following examples create animation styles that collect a set of
     * CSS property values:
     *
     * ```typescript
     * // string values for CSS properties
     * style({ background: "red", color: "blue" })
     *
     * // numerical pixel values
     * style({ width: 100, height: 0 })
     * ```
     *
     * The following example uses auto-styling to allow a component to animate from
     * a height of 0 up to the height of the parent element:
     *
     * ```
     * style({ height: 0 }),
     * animate("1s", style({ height: "*" }))
     * ```
     *
     * \@publicApi
     *
     * @param {?} tokens A set of CSS styles or HTML styles associated with an animation state.
     * The value can be any of the following:
     * - A key-value style pair associating a CSS property with a value.
     * - An array of key-value style pairs.
     * - An asterisk (*), to use auto-styling, where styles are derived from the element
     * being animated and applied to the animation when it starts.
     *
     * Auto-styling can be used to define a state that depends on layout or other
     * environmental factors.
     *
     * @return {?} An object that encapsulates the style data.
     *
     */
    function style(tokens) {
        return { type: 6 /* Style */, styles: tokens, offset: null };
    }
    /**
     * Declares an animation state within a trigger attached to an element.
     *
     * \@usageNotes
     * Use the `trigger()` function to register states to an animation trigger.
     * Use the `transition()` function to animate between states.
     * When a state is active within a component, its associated styles persist on the element,
     * even when the animation ends.
     *
     * \@publicApi
     *
     * @param {?} name One or more names for the defined state in a comma-separated string.
     * The following reserved state names can be supplied to define a style for specific use
     * cases:
     *
     * - `void` You can associate styles with this name to be used when
     * the element is detached from the application. For example, when an `ngIf` evaluates
     * to false, the state of the associated element is void.
     *  - `*` (asterisk) Indicates the default state. You can associate styles with this name
     * to be used as the fallback when the state that is being animated is not declared
     * within the trigger.
     *
     * @param {?} styles A set of CSS styles associated with this state, created using the
     * `style()` function.
     * This set of styles persists on the element once the state has been reached.
     * @param {?=} options Parameters that can be passed to the state when it is invoked.
     * 0 or more key-value pairs.
     * @return {?} An object that encapsulates the new state data.
     *
     */
    function state(name, styles, options) {
        return { type: 0 /* State */, name: name, styles: styles, options: options };
    }
    /**
     * Defines a set of animation styles, associating each style with an optional `offset` value.
     *
     * \@usageNotes
     * Use with the `animate()` call. Instead of applying animations
     * from the current state
     * to the destination state, keyframes describe how each style entry is applied and at what point
     * within the animation arc.
     * Compare [CSS Keyframe Animations](https://www.w3schools.com/css/css3_animations.asp).
     *
     * ### Usage
     *
     * In the following example, the offset values describe
     * when each `backgroundColor` value is applied. The color is red at the start, and changes to
     * blue when 20% of the total time has elapsed.
     *
     * ```typescript
     * // the provided offset values
     * animate("5s", keyframes([
     *   style({ backgroundColor: "red", offset: 0 }),
     *   style({ backgroundColor: "blue", offset: 0.2 }),
     *   style({ backgroundColor: "orange", offset: 0.3 }),
     *   style({ backgroundColor: "black", offset: 1 })
     * ]))
     * ```
     *
     * If there are no `offset` values specified in the style entries, the offsets
     * are calculated automatically.
     *
     * ```typescript
     * animate("5s", keyframes([
     *   style({ backgroundColor: "red" }) // offset = 0
     *   style({ backgroundColor: "blue" }) // offset = 0.33
     *   style({ backgroundColor: "orange" }) // offset = 0.66
     *   style({ backgroundColor: "black" }) // offset = 1
     * ]))
     * ```
     * \@publicApi
     * @param {?} steps A set of animation styles with optional offset data.
     * The optional `offset` value for a style specifies a percentage of the total animation
     * time at which that style is applied.
     * @return {?} An object that encapsulates the keyframes data.
     *
     */
    function keyframes(steps) {
        return { type: 5 /* Keyframes */, steps: steps };
    }
    /**
     * Declares an animation transition as a sequence of animation steps to run when a given
     * condition is satisfied. The condition is a Boolean expression or function that compares
     * the previous and current animation states, and returns true if this transition should occur.
     * When the state criteria of a defined transition are met, the associated animation is
     * triggered.
     *
     * \@usageNotes
     * The template associated with a component binds an animation trigger to an element.
     *
     * ```HTML
     * <!-- somewhere inside of my-component-tpl.html -->
     * <div [\@myAnimationTrigger]="myStatusExp">...</div>
     * ```
     *
     * All transitions are defined within an animation trigger,
     * along with named states that the transitions change to and from.
     *
     * ```typescript
     * trigger("myAnimationTrigger", [
     *  // define states
     *  state("on", style({ background: "green" })),
     *  state("off", style({ background: "grey" })),
     *  ...]
     * ```
     *
     * Note that when you call the `sequence()` function within a `{\@link animations/group group()}`
     * or a `transition()` call, execution does not continue to the next instruction
     * until each of the inner animation steps have completed.
     *
     * ### Syntax examples
     *
     * The following examples define transitions between the two defined states (and default states),
     * using various options:
     *
     * ```typescript
     * // Transition occurs when the state value
     * // bound to "myAnimationTrigger" changes from "on" to "off"
     * transition("on => off", animate(500))
     * // Run the same animation for both directions
     * transition("on <=> off", animate(500))
     * // Define multiple state-change pairs separated by commas
     * transition("on => off, off => void", animate(500))
     * ```
     *
     * ### Special values for state-change expressions
     *
     * - Catch-all state change for when an element is inserted into the page and the
     * destination state is unknown:
     *
     * ```typescript
     * transition("void => *", [
     *  style({ opacity: 0 }),
     *  animate(500)
     *  ])
     * ```
     *
     * - Capture a state change between any states:
     *
     *  `transition("* => *", animate("1s 0s"))`
     *
     * - Entry and exit transitions:
     *
     * ```typescript
     * transition(":enter", [
     *   style({ opacity: 0 }),
     *   animate(500, style({ opacity: 1 }))
     *   ]),
     * transition(":leave", [
     *   animate(500, style({ opacity: 0 }))
     *   ])
     * ```
     *
     * - Use `:increment` and `:decrement` to initiate transitions:
     *
     * ```typescript
     * transition(":increment", group([
     *  query(':enter', [
     *     style({ left: '100%' }),
     *     animate('0.5s ease-out', style('*'))
     *   ]),
     *  query(':leave', [
     *     animate('0.5s ease-out', style({ left: '-100%' }))
     *  ])
     * ]))
     *
     * transition(":decrement", group([
     *  query(':enter', [
     *     style({ left: '100%' }),
     *     animate('0.5s ease-out', style('*'))
     *   ]),
     *  query(':leave', [
     *     animate('0.5s ease-out', style({ left: '-100%' }))
     *  ])
     * ]))
     * ```
     *
     * ### State-change functions
     *
     * Here is an example of a `fromState` specified as a state-change function that invokes an
     * animation when true:
     *
     * ```typescript
     * transition((fromState, toState) =>
     *  {
     *   return fromState == "off" && toState == "on";
     *  },
     *  animate("1s 0s"))
     * ```
     *
     * ### Animating to the final state
     *
     * If the final step in a transition is a call to `animate()` that uses a timing value
     * with no style data, that step is automatically considered the final animation arc,
     * for the element to reach the final state. Angular automatically adds or removes
     * CSS styles to ensure that the element is in the correct final state.
     *
     * The following example defines a transition that starts by hiding the element,
     * then makes sure that it animates properly to whatever state is currently active for trigger:
     *
     * ```typescript
     * transition("void => *", [
     *   style({ opacity: 0 }),
     *   animate(500)
     *  ])
     * ```
     * ### Boolean value matching
     * If a trigger binding value is a Boolean, it can be matched using a transition expression
     * that compares true and false or 1 and 0. For example:
     *
     * ```
     * // in the template
     * <div [\@openClose]="open ? true : false">...</div>
     * // in the component metadata
     * trigger('openClose', [
     *   state('true', style({ height: '*' })),
     *   state('false', style({ height: '0px' })),
     *   transition('false <=> true', animate(500))
     * ])
     * ```
     *
     * \@publicApi
     *
     * @param {?} stateChangeExpr A Boolean expression or function that compares the previous and current
     * animation states, and returns true if this transition should occur. Note that  "true" and "false"
     * match 1 and 0, respectively. An expression is evaluated each time a state change occurs in the
     * animation trigger element.
     * The animation steps run when the expression evaluates to true.
     *
     * - A state-change string takes the form "state1 => state2", where each side is a defined animation
     * state, or an asterix (*) to refer to a dynamic start or end state.
     *   - The expression string can contain multiple comma-separated statements;
     * for example "state1 => state2, state3 => state4".
     *   - Special values `:enter` and `:leave` initiate a transition on the entry and exit states,
     * equivalent to  "void => *"  and "* => void".
     *   - Special values `:increment` and `:decrement` initiate a transition when a numeric value has
     * increased or decreased in value.
     * - A function is executed each time a state change occurs in the animation trigger element.
     * The animation steps run when the function returns true.
     *
     * @param {?} steps One or more animation objects, as returned by the `animate()` or
     * `sequence()` function, that form a transformation from one state to another.
     * A sequence is used by default when you pass an array.
     * @param {?=} options An options object that can contain a delay value for the start of the animation,
     * and additional developer-defined parameters. Provided values for additional parameters are used
     * as defaults, and override values can be passed to the caller on invocation.
     * @return {?} An object that encapsulates the transition data.
     *
     */
    function transition(stateChangeExpr, steps, options) {
        if (options === void 0) { options = null; }
        return { type: 1 /* Transition */, expr: stateChangeExpr, animation: steps, options: options };
    }
    /**
     * Executes a queried inner animation element within an animation sequence.
     *
     * \@usageNotes
     * Each time an animation is triggered in Angular, the parent animation
     * has priority and any child animations are blocked. In order
     * for a child animation to run, the parent animation must query each of the elements
     * containing child animations, and run them using this function.
     *
     * Note that this feature is designed to be used with `query()` and it will only work
     * with animations that are assigned using the Angular animation library. CSS keyframes
     * and transitions are not handled by this API.
     *
     * \@publicApi
     * @param {?=} options An options object that can contain a delay value for the start of the
     * animation, and additional override values for developer-defined parameters.
     * @return {?} An object that encapsulates the child animation data.
     *
     */
    function animateChild(options) {
        if (options === void 0) { options = null; }
        return { type: 9 /* AnimateChild */, options: options };
    }
    /**
     * Finds one or more inner elements within the current element that is
     * being animated within a sequence. Use with `animate()`.
     *
     * \@usageNotes
     * Tokens can be merged into a combined query selector string. For example:
     *
     * ```typescript
     *  query(':self, .record:enter, .record:leave, \@subTrigger', [...])
     * ```
     *
     * The `query()` function collects multiple elements and works internally by using
     * `element.querySelectorAll`. Use the `limit` field of an options object to limit
     * the total number of items to be collected. For example:
     *
     * ```js
     * query('div', [
     *   animate(...),
     *   animate(...)
     * ], { limit: 1 })
     * ```
     *
     * By default, throws an error when zero items are found. Set the
     * `optional` flag to ignore this error. For example:
     *
     * ```js
     * query('.some-element-that-may-not-be-there', [
     *   animate(...),
     *   animate(...)
     * ], { optional: true })
     * ```
     *
     * ### Usage Example
     *
     * The following example queries for inner elements and animates them
     * individually using `animate()`.
     *
     * ```typescript
     * \@Component({
     *   selector: 'inner',
     *   template: `
     *     <div [\@queryAnimation]="exp">
     *       <h1>Title</h1>
     *       <div class="content">
     *         Blah blah blah
     *       </div>
     *     </div>
     *   `,
     *   animations: [
     *    trigger('queryAnimation', [
     *      transition('* => goAnimate', [
     *        // hide the inner elements
     *        query('h1', style({ opacity: 0 })),
     *        query('.content', style({ opacity: 0 })),
     *
     *        // animate the inner elements in, one by one
     *        query('h1', animate(1000, style({ opacity: 1 }))),
     *        query('.content', animate(1000, style({ opacity: 1 }))),
     *      ])
     *    ])
     *  ]
     * })
     * class Cmp {
     *   exp = '';
     *
     *   goAnimate() {
     *     this.exp = 'goAnimate';
     *   }
     * }
     * ```
     *
     * \@publicApi
     * @param {?} selector The element to query, or a set of elements that contain Angular-specific
     * characteristics, specified with one or more of the following tokens.
     *  - `query(":enter")` or `query(":leave")` : Query for newly inserted/removed elements.
     *  - `query(":animating")` : Query all currently animating elements.
     *  - `query("\@triggerName")` : Query elements that contain an animation trigger.
     *  - `query("\@*")` : Query all elements that contain an animation triggers.
     *  - `query(":self")` : Include the current element into the animation sequence.
     *
     * @param {?} animation One or more animation steps to apply to the queried element or elements.
     * An array is treated as an animation sequence.
     * @param {?=} options An options object. Use the 'limit' field to limit the total number of
     * items to collect.
     * @return {?} An object that encapsulates the query data.
     *
     */
    function query(selector, animation, options) {
        if (options === void 0) { options = null; }
        return { type: 11 /* Query */, selector: selector, animation: animation, options: options };
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     * @param {?} cb
     * @return {?}
     */
    function scheduleMicroTask$1(cb) {
        Promise.resolve(null).then(cb);
    }
    /**
     * An empty programmatic controller for reusable animations.
     * Used internally when animations are disabled, to avoid
     * checking for the null case when an animation player is expected.
     *
     * @see `animate()`
     * @see `AnimationPlayer`
     * @see `GroupPlayer`
     *
     * \@publicApi
     */
    var NoopAnimationPlayer = /** @class */ (function () {
        /**
         * @param {?=} duration
         * @param {?=} delay
         */
        function NoopAnimationPlayer(duration, delay) {
            if (duration === void 0) { duration = 0; }
            if (delay === void 0) { delay = 0; }
            this._onDoneFns = [];
            this._onStartFns = [];
            this._onDestroyFns = [];
            this._started = false;
            this._destroyed = false;
            this._finished = false;
            this.parentPlayer = null;
            this.totalTime = duration + delay;
        }
        /**
         * @private
         * @return {?}
         */
        NoopAnimationPlayer.prototype._onFinish = function () {
            if (!this._finished) {
                this._finished = true;
                this._onDoneFns.forEach(( /**
                 * @param {?} fn
                 * @return {?}
                 */function (/**
                 * @param {?} fn
                 * @return {?}
                 */ fn) { return fn(); }));
                this._onDoneFns = [];
            }
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        NoopAnimationPlayer.prototype.onStart = function (fn) { this._onStartFns.push(fn); };
        /**
         * @param {?} fn
         * @return {?}
         */
        NoopAnimationPlayer.prototype.onDone = function (fn) { this._onDoneFns.push(fn); };
        /**
         * @param {?} fn
         * @return {?}
         */
        NoopAnimationPlayer.prototype.onDestroy = function (fn) { this._onDestroyFns.push(fn); };
        /**
         * @return {?}
         */
        NoopAnimationPlayer.prototype.hasStarted = function () { return this._started; };
        /**
         * @return {?}
         */
        NoopAnimationPlayer.prototype.init = function () { };
        /**
         * @return {?}
         */
        NoopAnimationPlayer.prototype.play = function () {
            if (!this.hasStarted()) {
                this._onStart();
                this.triggerMicrotask();
            }
            this._started = true;
        };
        /**
         * \@internal
         * @return {?}
         */
        NoopAnimationPlayer.prototype.triggerMicrotask = function () {
            var _this = this;
            scheduleMicroTask$1(( /**
             * @return {?}
             */function () { return _this._onFinish(); }));
        };
        /**
         * @private
         * @return {?}
         */
        NoopAnimationPlayer.prototype._onStart = function () {
            this._onStartFns.forEach(( /**
             * @param {?} fn
             * @return {?}
             */function (/**
             * @param {?} fn
             * @return {?}
             */ fn) { return fn(); }));
            this._onStartFns = [];
        };
        /**
         * @return {?}
         */
        NoopAnimationPlayer.prototype.pause = function () { };
        /**
         * @return {?}
         */
        NoopAnimationPlayer.prototype.restart = function () { };
        /**
         * @return {?}
         */
        NoopAnimationPlayer.prototype.finish = function () { this._onFinish(); };
        /**
         * @return {?}
         */
        NoopAnimationPlayer.prototype.destroy = function () {
            if (!this._destroyed) {
                this._destroyed = true;
                if (!this.hasStarted()) {
                    this._onStart();
                }
                this.finish();
                this._onDestroyFns.forEach(( /**
                 * @param {?} fn
                 * @return {?}
                 */function (/**
                 * @param {?} fn
                 * @return {?}
                 */ fn) { return fn(); }));
                this._onDestroyFns = [];
            }
        };
        /**
         * @return {?}
         */
        NoopAnimationPlayer.prototype.reset = function () { };
        /**
         * @param {?} position
         * @return {?}
         */
        NoopAnimationPlayer.prototype.setPosition = function (position) { };
        /**
         * @return {?}
         */
        NoopAnimationPlayer.prototype.getPosition = function () { return 0; };
        /**
         * \@internal
         * @param {?} phaseName
         * @return {?}
         */
        NoopAnimationPlayer.prototype.triggerCallback = function (phaseName) {
            /** @type {?} */
            var methods = phaseName == 'start' ? this._onStartFns : this._onDoneFns;
            methods.forEach(( /**
             * @param {?} fn
             * @return {?}
             */function (/**
             * @param {?} fn
             * @return {?}
             */ fn) { return fn(); }));
            methods.length = 0;
        };
        return NoopAnimationPlayer;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A programmatic controller for a group of reusable animations.
     * Used internally to control animations.
     *
     * @see `AnimationPlayer`
     * @see `{\@link animations/group group()}`
     *
     */
    var AnimationGroupPlayer = /** @class */ (function () {
        /**
         * @param {?} _players
         */
        function AnimationGroupPlayer(_players) {
            var _this = this;
            this._onDoneFns = [];
            this._onStartFns = [];
            this._finished = false;
            this._started = false;
            this._destroyed = false;
            this._onDestroyFns = [];
            this.parentPlayer = null;
            this.totalTime = 0;
            this.players = _players;
            /** @type {?} */
            var doneCount = 0;
            /** @type {?} */
            var destroyCount = 0;
            /** @type {?} */
            var startCount = 0;
            /** @type {?} */
            var total = this.players.length;
            if (total == 0) {
                scheduleMicroTask$1(( /**
                 * @return {?}
                 */function () { return _this._onFinish(); }));
            }
            else {
                this.players.forEach(( /**
                 * @param {?} player
                 * @return {?}
                 */function (/**
                 * @param {?} player
                 * @return {?}
                 */ player) {
                    player.onDone(( /**
                     * @return {?}
                     */function () {
                        if (++doneCount == total) {
                            _this._onFinish();
                        }
                    }));
                    player.onDestroy(( /**
                     * @return {?}
                     */function () {
                        if (++destroyCount == total) {
                            _this._onDestroy();
                        }
                    }));
                    player.onStart(( /**
                     * @return {?}
                     */function () {
                        if (++startCount == total) {
                            _this._onStart();
                        }
                    }));
                }));
            }
            this.totalTime = this.players.reduce(( /**
             * @param {?} time
             * @param {?} player
             * @return {?}
             */function (time, player) { return Math.max(time, player.totalTime); }), 0);
        }
        /**
         * @private
         * @return {?}
         */
        AnimationGroupPlayer.prototype._onFinish = function () {
            if (!this._finished) {
                this._finished = true;
                this._onDoneFns.forEach(( /**
                 * @param {?} fn
                 * @return {?}
                 */function (/**
                 * @param {?} fn
                 * @return {?}
                 */ fn) { return fn(); }));
                this._onDoneFns = [];
            }
        };
        /**
         * @return {?}
         */
        AnimationGroupPlayer.prototype.init = function () {
            this.players.forEach(( /**
             * @param {?} player
             * @return {?}
             */function (/**
             * @param {?} player
             * @return {?}
             */ player) { return player.init(); }));
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        AnimationGroupPlayer.prototype.onStart = function (fn) { this._onStartFns.push(fn); };
        /**
         * @private
         * @return {?}
         */
        AnimationGroupPlayer.prototype._onStart = function () {
            if (!this.hasStarted()) {
                this._started = true;
                this._onStartFns.forEach(( /**
                 * @param {?} fn
                 * @return {?}
                 */function (/**
                 * @param {?} fn
                 * @return {?}
                 */ fn) { return fn(); }));
                this._onStartFns = [];
            }
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        AnimationGroupPlayer.prototype.onDone = function (fn) { this._onDoneFns.push(fn); };
        /**
         * @param {?} fn
         * @return {?}
         */
        AnimationGroupPlayer.prototype.onDestroy = function (fn) { this._onDestroyFns.push(fn); };
        /**
         * @return {?}
         */
        AnimationGroupPlayer.prototype.hasStarted = function () { return this._started; };
        /**
         * @return {?}
         */
        AnimationGroupPlayer.prototype.play = function () {
            if (!this.parentPlayer) {
                this.init();
            }
            this._onStart();
            this.players.forEach(( /**
             * @param {?} player
             * @return {?}
             */function (/**
             * @param {?} player
             * @return {?}
             */ player) { return player.play(); }));
        };
        /**
         * @return {?}
         */
        AnimationGroupPlayer.prototype.pause = function () {
            this.players.forEach(( /**
             * @param {?} player
             * @return {?}
             */function (/**
             * @param {?} player
             * @return {?}
             */ player) { return player.pause(); }));
        };
        /**
         * @return {?}
         */
        AnimationGroupPlayer.prototype.restart = function () {
            this.players.forEach(( /**
             * @param {?} player
             * @return {?}
             */function (/**
             * @param {?} player
             * @return {?}
             */ player) { return player.restart(); }));
        };
        /**
         * @return {?}
         */
        AnimationGroupPlayer.prototype.finish = function () {
            this._onFinish();
            this.players.forEach(( /**
             * @param {?} player
             * @return {?}
             */function (/**
             * @param {?} player
             * @return {?}
             */ player) { return player.finish(); }));
        };
        /**
         * @return {?}
         */
        AnimationGroupPlayer.prototype.destroy = function () { this._onDestroy(); };
        /**
         * @private
         * @return {?}
         */
        AnimationGroupPlayer.prototype._onDestroy = function () {
            if (!this._destroyed) {
                this._destroyed = true;
                this._onFinish();
                this.players.forEach(( /**
                 * @param {?} player
                 * @return {?}
                 */function (/**
                 * @param {?} player
                 * @return {?}
                 */ player) { return player.destroy(); }));
                this._onDestroyFns.forEach(( /**
                 * @param {?} fn
                 * @return {?}
                 */function (/**
                 * @param {?} fn
                 * @return {?}
                 */ fn) { return fn(); }));
                this._onDestroyFns = [];
            }
        };
        /**
         * @return {?}
         */
        AnimationGroupPlayer.prototype.reset = function () {
            this.players.forEach(( /**
             * @param {?} player
             * @return {?}
             */function (/**
             * @param {?} player
             * @return {?}
             */ player) { return player.reset(); }));
            this._destroyed = false;
            this._finished = false;
            this._started = false;
        };
        /**
         * @param {?} p
         * @return {?}
         */
        AnimationGroupPlayer.prototype.setPosition = function (p) {
            /** @type {?} */
            var timeAtPosition = p * this.totalTime;
            this.players.forEach(( /**
             * @param {?} player
             * @return {?}
             */function (/**
             * @param {?} player
             * @return {?}
             */ player) {
                /** @type {?} */
                var position = player.totalTime ? Math.min(1, timeAtPosition / player.totalTime) : 1;
                player.setPosition(position);
            }));
        };
        /**
         * @return {?}
         */
        AnimationGroupPlayer.prototype.getPosition = function () {
            /** @type {?} */
            var min = 0;
            this.players.forEach(( /**
             * @param {?} player
             * @return {?}
             */function (/**
             * @param {?} player
             * @return {?}
             */ player) {
                /** @type {?} */
                var p = player.getPosition();
                min = Math.min(p, min);
            }));
            return min;
        };
        /**
         * @return {?}
         */
        AnimationGroupPlayer.prototype.beforeDestroy = function () {
            this.players.forEach(( /**
             * @param {?} player
             * @return {?}
             */function (/**
             * @param {?} player
             * @return {?}
             */ player) {
                if (player.beforeDestroy) {
                    player.beforeDestroy();
                }
            }));
        };
        /**
         * \@internal
         * @param {?} phaseName
         * @return {?}
         */
        AnimationGroupPlayer.prototype.triggerCallback = function (phaseName) {
            /** @type {?} */
            var methods = phaseName == 'start' ? this._onStartFns : this._onDoneFns;
            methods.forEach(( /**
             * @param {?} fn
             * @return {?}
             */function (/**
             * @param {?} fn
             * @return {?}
             */ fn) { return fn(); }));
            methods.length = 0;
        };
        return AnimationGroupPlayer;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var ɵPRE_STYLE = '!';
    /**
     * @license Angular v8.2.14
     * (c) 2010-2019 Google LLC. https://angular.io/
     * License: MIT
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @return {?}
     */
    function isBrowser() {
        return (typeof window !== 'undefined' && typeof window.document !== 'undefined');
    }
    /**
     * @return {?}
     */
    function isNode() {
        return (typeof process !== 'undefined');
    }
    /**
     * @param {?} players
     * @return {?}
     */
    function optimizeGroupPlayer(players) {
        switch (players.length) {
            case 0:
                return new NoopAnimationPlayer();
            case 1:
                return players[0];
            default:
                return new AnimationGroupPlayer(players);
        }
    }
    /**
     * @param {?} driver
     * @param {?} normalizer
     * @param {?} element
     * @param {?} keyframes
     * @param {?=} preStyles
     * @param {?=} postStyles
     * @return {?}
     */
    function normalizeKeyframes(driver, normalizer, element, keyframes, preStyles, postStyles) {
        if (preStyles === void 0) { preStyles = {}; }
        if (postStyles === void 0) { postStyles = {}; }
        /** @type {?} */
        var errors = [];
        /** @type {?} */
        var normalizedKeyframes = [];
        /** @type {?} */
        var previousOffset = -1;
        /** @type {?} */
        var previousKeyframe = null;
        keyframes.forEach(( /**
         * @param {?} kf
         * @return {?}
         */function (/**
         * @param {?} kf
         * @return {?}
         */ kf) {
            /** @type {?} */
            var offset = ( /** @type {?} */(kf['offset']));
            /** @type {?} */
            var isSameOffset = offset == previousOffset;
            /** @type {?} */
            var normalizedKeyframe = (isSameOffset && previousKeyframe) || {};
            Object.keys(kf).forEach(( /**
             * @param {?} prop
             * @return {?}
             */function (/**
             * @param {?} prop
             * @return {?}
             */ prop) {
                /** @type {?} */
                var normalizedProp = prop;
                /** @type {?} */
                var normalizedValue = kf[prop];
                if (prop !== 'offset') {
                    normalizedProp = normalizer.normalizePropertyName(normalizedProp, errors);
                    switch (normalizedValue) {
                        case ɵPRE_STYLE:
                            normalizedValue = preStyles[prop];
                            break;
                        case AUTO_STYLE:
                            normalizedValue = postStyles[prop];
                            break;
                        default:
                            normalizedValue =
                                normalizer.normalizeStyleValue(prop, normalizedProp, normalizedValue, errors);
                            break;
                    }
                }
                normalizedKeyframe[normalizedProp] = normalizedValue;
            }));
            if (!isSameOffset) {
                normalizedKeyframes.push(normalizedKeyframe);
            }
            previousKeyframe = normalizedKeyframe;
            previousOffset = offset;
        }));
        if (errors.length) {
            /** @type {?} */
            var LINE_START = '\n - ';
            throw new Error("Unable to animate due to the following errors:" + LINE_START + errors.join(LINE_START));
        }
        return normalizedKeyframes;
    }
    /**
     * @param {?} player
     * @param {?} eventName
     * @param {?} event
     * @param {?} callback
     * @return {?}
     */
    function listenOnPlayer(player, eventName, event, callback) {
        switch (eventName) {
            case 'start':
                player.onStart(( /**
                 * @return {?}
                 */function () { return callback(event && copyAnimationEvent(event, 'start', player)); }));
                break;
            case 'done':
                player.onDone(( /**
                 * @return {?}
                 */function () { return callback(event && copyAnimationEvent(event, 'done', player)); }));
                break;
            case 'destroy':
                player.onDestroy(( /**
                 * @return {?}
                 */function () { return callback(event && copyAnimationEvent(event, 'destroy', player)); }));
                break;
        }
    }
    /**
     * @param {?} e
     * @param {?} phaseName
     * @param {?} player
     * @return {?}
     */
    function copyAnimationEvent(e, phaseName, player) {
        /** @type {?} */
        var totalTime = player.totalTime;
        /** @type {?} */
        var disabled = (( /** @type {?} */(player))).disabled ? true : false;
        /** @type {?} */
        var event = makeAnimationEvent(e.element, e.triggerName, e.fromState, e.toState, phaseName || e.phaseName, totalTime == undefined ? e.totalTime : totalTime, disabled);
        /** @type {?} */
        var data = (( /** @type {?} */(e)))['_data'];
        if (data != null) {
            (( /** @type {?} */(event)))['_data'] = data;
        }
        return event;
    }
    /**
     * @param {?} element
     * @param {?} triggerName
     * @param {?} fromState
     * @param {?} toState
     * @param {?=} phaseName
     * @param {?=} totalTime
     * @param {?=} disabled
     * @return {?}
     */
    function makeAnimationEvent(element, triggerName, fromState, toState, phaseName, totalTime, disabled) {
        if (phaseName === void 0) { phaseName = ''; }
        if (totalTime === void 0) { totalTime = 0; }
        return { element: element, triggerName: triggerName, fromState: fromState, toState: toState, phaseName: phaseName, totalTime: totalTime, disabled: !!disabled };
    }
    /**
     * @param {?} map
     * @param {?} key
     * @param {?} defaultValue
     * @return {?}
     */
    function getOrSetAsInMap(map, key, defaultValue) {
        /** @type {?} */
        var value;
        if (map instanceof Map) {
            value = map.get(key);
            if (!value) {
                map.set(key, value = defaultValue);
            }
        }
        else {
            value = map[key];
            if (!value) {
                value = map[key] = defaultValue;
            }
        }
        return value;
    }
    /**
     * @param {?} command
     * @return {?}
     */
    function parseTimelineCommand(command) {
        /** @type {?} */
        var separatorPos = command.indexOf(':');
        /** @type {?} */
        var id = command.substring(1, separatorPos);
        /** @type {?} */
        var action = command.substr(separatorPos + 1);
        return [id, action];
    }
    /** @type {?} */
    var _contains = ( /**
     * @param {?} elm1
     * @param {?} elm2
     * @return {?}
     */function (elm1, elm2) { return false; });
    /** @type {?} */
    var _matches = ( /**
     * @param {?} element
     * @param {?} selector
     * @return {?}
     */function (element, selector) { return false; });
    /** @type {?} */
    var _query = ( /**
     * @param {?} element
     * @param {?} selector
     * @param {?} multi
     * @return {?}
     */function (element, selector, multi) {
        return [];
    });
    // Define utility methods for browsers and platform-server(domino) where Element
    // and utility methods exist.
    /** @type {?} */
    var _isNode = isNode();
    if (_isNode || typeof Element !== 'undefined') {
        // this is well supported in all browsers
        _contains = ( /**
         * @param {?} elm1
         * @param {?} elm2
         * @return {?}
         */function (elm1, elm2) { return ( /** @type {?} */(elm1.contains(elm2))); });
        _matches = (( /**
         * @return {?}
         */function () {
            if (_isNode || Element.prototype.matches) {
                return ( /**
                 * @param {?} element
                 * @param {?} selector
                 * @return {?}
                 */function (element, selector) { return element.matches(selector); });
            }
            else {
                /** @type {?} */
                var proto = ( /** @type {?} */(Element.prototype));
                /** @type {?} */
                var fn_1 = proto.matchesSelector || proto.mozMatchesSelector || proto.msMatchesSelector ||
                    proto.oMatchesSelector || proto.webkitMatchesSelector;
                if (fn_1) {
                    return ( /**
                     * @param {?} element
                     * @param {?} selector
                     * @return {?}
                     */function (element, selector) { return fn_1.apply(element, [selector]); });
                }
                else {
                    return _matches;
                }
            }
        }))();
        _query = ( /**
         * @param {?} element
         * @param {?} selector
         * @param {?} multi
         * @return {?}
         */function (element, selector, multi) {
            /** @type {?} */
            var results = [];
            if (multi) {
                results.push.apply(results, __spread(element.querySelectorAll(selector)));
            }
            else {
                /** @type {?} */
                var elm = element.querySelector(selector);
                if (elm) {
                    results.push(elm);
                }
            }
            return results;
        });
    }
    /**
     * @param {?} prop
     * @return {?}
     */
    function containsVendorPrefix(prop) {
        // Webkit is the only real popular vendor prefix nowadays
        // cc: http://shouldiprefix.com/
        return prop.substring(1, 6) == 'ebkit'; // webkit or Webkit
    }
    /** @type {?} */
    var _CACHED_BODY = null;
    /** @type {?} */
    var _IS_WEBKIT = false;
    /**
     * @param {?} prop
     * @return {?}
     */
    function validateStyleProperty(prop) {
        if (!_CACHED_BODY) {
            _CACHED_BODY = getBodyNode() || {};
            _IS_WEBKIT = ( /** @type {?} */(_CACHED_BODY)).style ? ('WebkitAppearance' in ( /** @type {?} */(_CACHED_BODY)).style) : false;
        }
        /** @type {?} */
        var result = true;
        if (( /** @type {?} */(_CACHED_BODY)).style && !containsVendorPrefix(prop)) {
            result = prop in ( /** @type {?} */(_CACHED_BODY)).style;
            if (!result && _IS_WEBKIT) {
                /** @type {?} */
                var camelProp = 'Webkit' + prop.charAt(0).toUpperCase() + prop.substr(1);
                result = camelProp in ( /** @type {?} */(_CACHED_BODY)).style;
            }
        }
        return result;
    }
    /**
     * @return {?}
     */
    function getBodyNode() {
        if (typeof document != 'undefined') {
            return document.body;
        }
        return null;
    }
    /** @type {?} */
    var matchesElement = _matches;
    /** @type {?} */
    var containsElement = _contains;
    /** @type {?} */
    var invokeQuery = _query;
    /**
     * @param {?} object
     * @return {?}
     */
    function hypenatePropsObject(object) {
        /** @type {?} */
        var newObj = {};
        Object.keys(object).forEach(( /**
         * @param {?} prop
         * @return {?}
         */function (/**
         * @param {?} prop
         * @return {?}
         */ prop) {
            /** @type {?} */
            var newProp = prop.replace(/([a-z])([A-Z])/g, '$1-$2');
            newObj[newProp] = object[prop];
        }));
        return newObj;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@publicApi
     */
    var NoopAnimationDriver = /** @class */ (function () {
        function NoopAnimationDriver() {
        }
        /**
         * @param {?} prop
         * @return {?}
         */
        NoopAnimationDriver.prototype.validateStyleProperty = function (prop) { return validateStyleProperty(prop); };
        /**
         * @param {?} element
         * @param {?} selector
         * @return {?}
         */
        NoopAnimationDriver.prototype.matchesElement = function (element, selector) {
            return matchesElement(element, selector);
        };
        /**
         * @param {?} elm1
         * @param {?} elm2
         * @return {?}
         */
        NoopAnimationDriver.prototype.containsElement = function (elm1, elm2) { return containsElement(elm1, elm2); };
        /**
         * @param {?} element
         * @param {?} selector
         * @param {?} multi
         * @return {?}
         */
        NoopAnimationDriver.prototype.query = function (element, selector, multi) {
            return invokeQuery(element, selector, multi);
        };
        /**
         * @param {?} element
         * @param {?} prop
         * @param {?=} defaultValue
         * @return {?}
         */
        NoopAnimationDriver.prototype.computeStyle = function (element, prop, defaultValue) {
            return defaultValue || '';
        };
        /**
         * @param {?} element
         * @param {?} keyframes
         * @param {?} duration
         * @param {?} delay
         * @param {?} easing
         * @param {?=} previousPlayers
         * @param {?=} scrubberAccessRequested
         * @return {?}
         */
        NoopAnimationDriver.prototype.animate = function (element, keyframes, duration, delay, easing, previousPlayers, scrubberAccessRequested) {
            if (previousPlayers === void 0) { previousPlayers = []; }
            return new NoopAnimationPlayer(duration, delay);
        };
        return NoopAnimationDriver;
    }());
    NoopAnimationDriver.decorators = [
        { type: Injectable }
    ];
    /**
     * \@publicApi
     * @abstract
     */
    var AnimationDriver = /** @class */ (function () {
        function AnimationDriver() {
        }
        return AnimationDriver;
    }());
    AnimationDriver.NOOP = new NoopAnimationDriver();
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var ONE_SECOND = 1000;
    /** @type {?} */
    var SUBSTITUTION_EXPR_START = '{{';
    /** @type {?} */
    var SUBSTITUTION_EXPR_END = '}}';
    /** @type {?} */
    var ENTER_CLASSNAME = 'ng-enter';
    /** @type {?} */
    var LEAVE_CLASSNAME = 'ng-leave';
    /** @type {?} */
    var NG_TRIGGER_CLASSNAME = 'ng-trigger';
    /** @type {?} */
    var NG_TRIGGER_SELECTOR = '.ng-trigger';
    /** @type {?} */
    var NG_ANIMATING_CLASSNAME = 'ng-animating';
    /** @type {?} */
    var NG_ANIMATING_SELECTOR = '.ng-animating';
    /**
     * @param {?} value
     * @return {?}
     */
    function resolveTimingValue(value) {
        if (typeof value == 'number')
            return value;
        /** @type {?} */
        var matches = (( /** @type {?} */(value))).match(/^(-?[\.\d]+)(m?s)/);
        if (!matches || matches.length < 2)
            return 0;
        return _convertTimeValueToMS(parseFloat(matches[1]), matches[2]);
    }
    /**
     * @param {?} value
     * @param {?} unit
     * @return {?}
     */
    function _convertTimeValueToMS(value, unit) {
        switch (unit) {
            case 's':
                return value * ONE_SECOND;
            default: // ms or something else
                return value;
        }
    }
    /**
     * @param {?} timings
     * @param {?} errors
     * @param {?=} allowNegativeValues
     * @return {?}
     */
    function resolveTiming(timings, errors, allowNegativeValues) {
        return timings.hasOwnProperty('duration') ?
            ( /** @type {?} */(timings)) :
            parseTimeExpression(( /** @type {?} */(timings)), errors, allowNegativeValues);
    }
    /**
     * @param {?} exp
     * @param {?} errors
     * @param {?=} allowNegativeValues
     * @return {?}
     */
    function parseTimeExpression(exp, errors, allowNegativeValues) {
        /** @type {?} */
        var regex = /^(-?[\.\d]+)(m?s)(?:\s+(-?[\.\d]+)(m?s))?(?:\s+([-a-z]+(?:\(.+?\))?))?$/i;
        /** @type {?} */
        var duration;
        /** @type {?} */
        var delay = 0;
        /** @type {?} */
        var easing = '';
        if (typeof exp === 'string') {
            /** @type {?} */
            var matches = exp.match(regex);
            if (matches === null) {
                errors.push("The provided timing value \"" + exp + "\" is invalid.");
                return { duration: 0, delay: 0, easing: '' };
            }
            duration = _convertTimeValueToMS(parseFloat(matches[1]), matches[2]);
            /** @type {?} */
            var delayMatch = matches[3];
            if (delayMatch != null) {
                delay = _convertTimeValueToMS(parseFloat(delayMatch), matches[4]);
            }
            /** @type {?} */
            var easingVal = matches[5];
            if (easingVal) {
                easing = easingVal;
            }
        }
        else {
            duration = ( /** @type {?} */(exp));
        }
        if (!allowNegativeValues) {
            /** @type {?} */
            var containsErrors = false;
            /** @type {?} */
            var startIndex = errors.length;
            if (duration < 0) {
                errors.push("Duration values below 0 are not allowed for this animation step.");
                containsErrors = true;
            }
            if (delay < 0) {
                errors.push("Delay values below 0 are not allowed for this animation step.");
                containsErrors = true;
            }
            if (containsErrors) {
                errors.splice(startIndex, 0, "The provided timing value \"" + exp + "\" is invalid.");
            }
        }
        return { duration: duration, delay: delay, easing: easing };
    }
    /**
     * @param {?} obj
     * @param {?=} destination
     * @return {?}
     */
    function copyObj(obj, destination) {
        if (destination === void 0) { destination = {}; }
        Object.keys(obj).forEach(( /**
         * @param {?} prop
         * @return {?}
         */function (/**
         * @param {?} prop
         * @return {?}
         */ prop) { destination[prop] = obj[prop]; }));
        return destination;
    }
    /**
     * @param {?} styles
     * @param {?} readPrototype
     * @param {?=} destination
     * @return {?}
     */
    function copyStyles(styles, readPrototype, destination) {
        if (destination === void 0) { destination = {}; }
        if (readPrototype) {
            // we make use of a for-in loop so that the
            // prototypically inherited properties are
            // revealed from the backFill map
            for (var prop in styles) {
                destination[prop] = styles[prop];
            }
        }
        else {
            copyObj(styles, destination);
        }
        return destination;
    }
    /**
     * @param {?} element
     * @param {?} key
     * @param {?} value
     * @return {?}
     */
    function getStyleAttributeString(element, key, value) {
        // Return the key-value pair string to be added to the style attribute for the
        // given CSS style key.
        if (value) {
            return key + ':' + value + ';';
        }
        else {
            return '';
        }
    }
    /**
     * @param {?} element
     * @return {?}
     */
    function writeStyleAttribute(element) {
        // Read the style property of the element and manually reflect it to the
        // style attribute. This is needed because Domino on platform-server doesn't
        // understand the full set of allowed CSS properties and doesn't reflect some
        // of them automatically.
        /** @type {?} */
        var styleAttrValue = '';
        for (var i_129 = 0; i_129 < element.style.length; i_129++) {
            /** @type {?} */
            var key = element.style.item(i_129);
            styleAttrValue += getStyleAttributeString(element, key, element.style.getPropertyValue(key));
        }
        for (var key in element.style) {
            // Skip internal Domino properties that don't need to be reflected.
            if (!element.style.hasOwnProperty(key) || key.startsWith('_')) {
                continue;
            }
            /** @type {?} */
            var dashKey = camelCaseToDashCase$1(key);
            styleAttrValue += getStyleAttributeString(element, dashKey, element.style[key]);
        }
        element.setAttribute('style', styleAttrValue);
    }
    /**
     * @param {?} element
     * @param {?} styles
     * @param {?=} formerStyles
     * @return {?}
     */
    function setStyles(element, styles, formerStyles) {
        if (element['style']) {
            Object.keys(styles).forEach(( /**
             * @param {?} prop
             * @return {?}
             */function (/**
             * @param {?} prop
             * @return {?}
             */ prop) {
                /** @type {?} */
                var camelProp = dashCaseToCamelCase(prop);
                if (formerStyles && !formerStyles.hasOwnProperty(prop)) {
                    formerStyles[prop] = element.style[camelProp];
                }
                element.style[camelProp] = styles[prop];
            }));
            // On the server set the 'style' attribute since it's not automatically reflected.
            if (isNode()) {
                writeStyleAttribute(element);
            }
        }
    }
    /**
     * @param {?} element
     * @param {?} styles
     * @return {?}
     */
    function eraseStyles(element, styles) {
        if (element['style']) {
            Object.keys(styles).forEach(( /**
             * @param {?} prop
             * @return {?}
             */function (/**
             * @param {?} prop
             * @return {?}
             */ prop) {
                /** @type {?} */
                var camelProp = dashCaseToCamelCase(prop);
                element.style[camelProp] = '';
            }));
            // On the server set the 'style' attribute since it's not automatically reflected.
            if (isNode()) {
                writeStyleAttribute(element);
            }
        }
    }
    /**
     * @param {?} steps
     * @return {?}
     */
    function normalizeAnimationEntry(steps) {
        if (Array.isArray(steps)) {
            if (steps.length == 1)
                return steps[0];
            return sequence(steps);
        }
        return ( /** @type {?} */(steps));
    }
    /**
     * @param {?} value
     * @param {?} options
     * @param {?} errors
     * @return {?}
     */
    function validateStyleParams(value, options, errors) {
        /** @type {?} */
        var params = options.params || {};
        /** @type {?} */
        var matches = extractStyleParams(value);
        if (matches.length) {
            matches.forEach(( /**
             * @param {?} varName
             * @return {?}
             */function (/**
             * @param {?} varName
             * @return {?}
             */ varName) {
                if (!params.hasOwnProperty(varName)) {
                    errors.push("Unable to resolve the local animation param " + varName + " in the given list of values");
                }
            }));
        }
    }
    /** @type {?} */
    var PARAM_REGEX = new RegExp(SUBSTITUTION_EXPR_START + "\\s*(.+?)\\s*" + SUBSTITUTION_EXPR_END, 'g');
    /**
     * @param {?} value
     * @return {?}
     */
    function extractStyleParams(value) {
        /** @type {?} */
        var params = [];
        if (typeof value === 'string') {
            /** @type {?} */
            var val = value.toString();
            /** @type {?} */
            var match_3;
            while (match_3 = PARAM_REGEX.exec(val)) {
                params.push(( /** @type {?} */(match_3[1])));
            }
            PARAM_REGEX.lastIndex = 0;
        }
        return params;
    }
    /**
     * @param {?} value
     * @param {?} params
     * @param {?} errors
     * @return {?}
     */
    function interpolateParams(value, params, errors) {
        /** @type {?} */
        var original = value.toString();
        /** @type {?} */
        var str = original.replace(PARAM_REGEX, ( /**
         * @param {?} _
         * @param {?} varName
         * @return {?}
         */function (_, varName) {
            /** @type {?} */
            var localVal = params[varName];
            // this means that the value was never overridden by the data passed in by the user
            if (!params.hasOwnProperty(varName)) {
                errors.push("Please provide a value for the animation param " + varName);
                localVal = '';
            }
            return localVal.toString();
        }));
        // we do this to assert that numeric values stay as they are
        return str == original ? value : str;
    }
    /**
     * @param {?} iterator
     * @return {?}
     */
    function iteratorToArray(iterator) {
        /** @type {?} */
        var arr = [];
        /** @type {?} */
        var item = iterator.next();
        while (!item.done) {
            arr.push(item.value);
            item = iterator.next();
        }
        return arr;
    }
    /** @type {?} */
    var DASH_CASE_REGEXP = /-+([a-z0-9])/g;
    /**
     * @param {?} input
     * @return {?}
     */
    function dashCaseToCamelCase(input) {
        return input.replace(DASH_CASE_REGEXP, ( /**
         * @param {...?} m
         * @return {?}
         */function () {
            var m = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                m[_i] = arguments[_i];
            }
            return m[1].toUpperCase();
        }));
    }
    /**
     * @param {?} input
     * @return {?}
     */
    function camelCaseToDashCase$1(input) {
        return input.replace(/([a-z])([A-Z])/g, '$1-$2').toLowerCase();
    }
    /**
     * @param {?} duration
     * @param {?} delay
     * @return {?}
     */
    function allowPreviousPlayerStylesMerge(duration, delay) {
        return duration === 0 || delay === 0;
    }
    /**
     * @param {?} element
     * @param {?} keyframes
     * @param {?} previousStyles
     * @return {?}
     */
    function balancePreviousStylesIntoKeyframes(element, keyframes, previousStyles) {
        /** @type {?} */
        var previousStyleProps = Object.keys(previousStyles);
        if (previousStyleProps.length && keyframes.length) {
            /** @type {?} */
            var startingKeyframe_1 = keyframes[0];
            /** @type {?} */
            var missingStyleProps_1 = [];
            previousStyleProps.forEach(( /**
             * @param {?} prop
             * @return {?}
             */function (/**
             * @param {?} prop
             * @return {?}
             */ prop) {
                if (!startingKeyframe_1.hasOwnProperty(prop)) {
                    missingStyleProps_1.push(prop);
                }
                startingKeyframe_1[prop] = previousStyles[prop];
            }));
            if (missingStyleProps_1.length) {
                var _loop_2 = function () {
                    /** @type {?} */
                    var kf = keyframes[i];
                    missingStyleProps_1.forEach(( /**
                     * @param {?} prop
                     * @return {?}
                     */function (prop) { kf[prop] = computeStyle(element, prop); }));
                };
                // tslint:disable-next-line
                for (var i = 1; i < keyframes.length; i++) {
                    _loop_2();
                }
            }
        }
        return keyframes;
    }
    /**
     * @param {?} visitor
     * @param {?} node
     * @param {?} context
     * @return {?}
     */
    function visitDslNode(visitor, node, context) {
        switch (node.type) {
            case 7 /* Trigger */:
                return visitor.visitTrigger(node, context);
            case 0 /* State */:
                return visitor.visitState(node, context);
            case 1 /* Transition */:
                return visitor.visitTransition(node, context);
            case 2 /* Sequence */:
                return visitor.visitSequence(node, context);
            case 3 /* Group */:
                return visitor.visitGroup(node, context);
            case 4 /* Animate */:
                return visitor.visitAnimate(node, context);
            case 5 /* Keyframes */:
                return visitor.visitKeyframes(node, context);
            case 6 /* Style */:
                return visitor.visitStyle(node, context);
            case 8 /* Reference */:
                return visitor.visitReference(node, context);
            case 9 /* AnimateChild */:
                return visitor.visitAnimateChild(node, context);
            case 10 /* AnimateRef */:
                return visitor.visitAnimateRef(node, context);
            case 11 /* Query */:
                return visitor.visitQuery(node, context);
            case 12 /* Stagger */:
                return visitor.visitStagger(node, context);
            default:
                throw new Error("Unable to resolve animation metadata node #" + node.type);
        }
    }
    /**
     * @param {?} element
     * @param {?} prop
     * @return {?}
     */
    function computeStyle(element, prop) {
        return (( /** @type {?} */(window.getComputedStyle(element))))[prop];
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     * @type {?}
     */
    var ANY_STATE = '*';
    /**
     * @param {?} transitionValue
     * @param {?} errors
     * @return {?}
     */
    function parseTransitionExpr(transitionValue, errors) {
        /** @type {?} */
        var expressions = [];
        if (typeof transitionValue == 'string') {
            (( /** @type {?} */(transitionValue)))
                .split(/\s*,\s*/)
                .forEach(( /**
         * @param {?} str
         * @return {?}
         */function (/**
         * @param {?} str
         * @return {?}
         */ str) { return parseInnerTransitionStr(str, expressions, errors); }));
        }
        else {
            expressions.push(( /** @type {?} */(transitionValue)));
        }
        return expressions;
    }
    /**
     * @param {?} eventStr
     * @param {?} expressions
     * @param {?} errors
     * @return {?}
     */
    function parseInnerTransitionStr(eventStr, expressions, errors) {
        if (eventStr[0] == ':') {
            /** @type {?} */
            var result = parseAnimationAlias(eventStr, errors);
            if (typeof result == 'function') {
                expressions.push(result);
                return;
            }
            eventStr = ( /** @type {?} */(result));
        }
        /** @type {?} */
        var match = eventStr.match(/^(\*|[-\w]+)\s*(<?[=-]>)\s*(\*|[-\w]+)$/);
        if (match == null || match.length < 4) {
            errors.push("The provided transition expression \"" + eventStr + "\" is not supported");
            return expressions;
        }
        /** @type {?} */
        var fromState = match[1];
        /** @type {?} */
        var separator = match[2];
        /** @type {?} */
        var toState = match[3];
        expressions.push(makeLambdaFromStates(fromState, toState));
        /** @type {?} */
        var isFullAnyStateExpr = fromState == ANY_STATE && toState == ANY_STATE;
        if (separator[0] == '<' && !isFullAnyStateExpr) {
            expressions.push(makeLambdaFromStates(toState, fromState));
        }
    }
    /**
     * @param {?} alias
     * @param {?} errors
     * @return {?}
     */
    function parseAnimationAlias(alias, errors) {
        switch (alias) {
            case ':enter':
                return 'void => *';
            case ':leave':
                return '* => void';
            case ':increment':
                return ( /**
                 * @param {?} fromState
                 * @param {?} toState
                 * @return {?}
                 */function (fromState, toState) { return parseFloat(toState) > parseFloat(fromState); });
            case ':decrement':
                return ( /**
                 * @param {?} fromState
                 * @param {?} toState
                 * @return {?}
                 */function (fromState, toState) { return parseFloat(toState) < parseFloat(fromState); });
            default:
                errors.push("The transition alias value \"" + alias + "\" is not supported");
                return '* => *';
        }
    }
    // DO NOT REFACTOR ... keep the follow set instantiations
    // with the values intact (closure compiler for some reason
    // removes follow-up lines that add the values outside of
    // the constructor...
    /** @type {?} */
    var TRUE_BOOLEAN_VALUES = new Set(['true', '1']);
    /** @type {?} */
    var FALSE_BOOLEAN_VALUES = new Set(['false', '0']);
    /**
     * @param {?} lhs
     * @param {?} rhs
     * @return {?}
     */
    function makeLambdaFromStates(lhs, rhs) {
        /** @type {?} */
        var LHS_MATCH_BOOLEAN = TRUE_BOOLEAN_VALUES.has(lhs) || FALSE_BOOLEAN_VALUES.has(lhs);
        /** @type {?} */
        var RHS_MATCH_BOOLEAN = TRUE_BOOLEAN_VALUES.has(rhs) || FALSE_BOOLEAN_VALUES.has(rhs);
        return ( /**
         * @param {?} fromState
         * @param {?} toState
         * @return {?}
         */function (fromState, toState) {
            /** @type {?} */
            var lhsMatch = lhs == ANY_STATE || lhs == fromState;
            /** @type {?} */
            var rhsMatch = rhs == ANY_STATE || rhs == toState;
            if (!lhsMatch && LHS_MATCH_BOOLEAN && typeof fromState === 'boolean') {
                lhsMatch = fromState ? TRUE_BOOLEAN_VALUES.has(lhs) : FALSE_BOOLEAN_VALUES.has(lhs);
            }
            if (!rhsMatch && RHS_MATCH_BOOLEAN && typeof toState === 'boolean') {
                rhsMatch = toState ? TRUE_BOOLEAN_VALUES.has(rhs) : FALSE_BOOLEAN_VALUES.has(rhs);
            }
            return lhsMatch && rhsMatch;
        });
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var SELF_TOKEN = ':self';
    /** @type {?} */
    var SELF_TOKEN_REGEX = new RegExp("s*" + SELF_TOKEN + "s*,?", 'g');
    /*
     * [Validation]
     * The visitor code below will traverse the animation AST generated by the animation verb functions
     * (the output is a tree of objects) and attempt to perform a series of validations on the data. The
     * following corner-cases will be validated:
     *
     * 1. Overlap of animations
     * Given that a CSS property cannot be animated in more than one place at the same time, it's
     * important that this behavior is detected and validated. The way in which this occurs is that
     * each time a style property is examined, a string-map containing the property will be updated with
     * the start and end times for when the property is used within an animation step.
     *
     * If there are two or more parallel animations that are currently running (these are invoked by the
     * group()) on the same element then the validator will throw an error. Since the start/end timing
     * values are collected for each property then if the current animation step is animating the same
     * property and its timing values fall anywhere into the window of time that the property is
     * currently being animated within then this is what causes an error.
     *
     * 2. Timing values
     * The validator will validate to see if a timing value of `duration delay easing` or
     * `durationNumber` is valid or not.
     *
     * (note that upon validation the code below will replace the timing data with an object containing
     * {duration,delay,easing}.
     *
     * 3. Offset Validation
     * Each of the style() calls are allowed to have an offset value when placed inside of keyframes().
     * Offsets within keyframes() are considered valid when:
     *
     *   - No offsets are used at all
     *   - Each style() entry contains an offset value
     *   - Each offset is between 0 and 1
     *   - Each offset is greater to or equal than the previous one
     *
     * Otherwise an error will be thrown.
     */
    /**
     * @param {?} driver
     * @param {?} metadata
     * @param {?} errors
     * @return {?}
     */
    function buildAnimationAst(driver, metadata, errors) {
        return new AnimationAstBuilderVisitor(driver).build(metadata, errors);
    }
    /** @type {?} */
    var ROOT_SELECTOR = '';
    var AnimationAstBuilderVisitor = /** @class */ (function () {
        /**
         * @param {?} _driver
         */
        function AnimationAstBuilderVisitor(_driver) {
            this._driver = _driver;
        }
        /**
         * @param {?} metadata
         * @param {?} errors
         * @return {?}
         */
        AnimationAstBuilderVisitor.prototype.build = function (metadata, errors) {
            /** @type {?} */
            var context = new AnimationAstBuilderContext(errors);
            this._resetContextStyleTimingState(context);
            return ( /** @type {?} */(visitDslNode(this, normalizeAnimationEntry(metadata), context)));
        };
        /**
         * @private
         * @param {?} context
         * @return {?}
         */
        AnimationAstBuilderVisitor.prototype._resetContextStyleTimingState = function (context) {
            context.currentQuerySelector = ROOT_SELECTOR;
            context.collectedStyles = {};
            context.collectedStyles[ROOT_SELECTOR] = {};
            context.currentTime = 0;
        };
        /**
         * @param {?} metadata
         * @param {?} context
         * @return {?}
         */
        AnimationAstBuilderVisitor.prototype.visitTrigger = function (metadata, context) {
            var _this = this;
            /** @type {?} */
            var queryCount = context.queryCount = 0;
            /** @type {?} */
            var depCount = context.depCount = 0;
            /** @type {?} */
            var states = [];
            /** @type {?} */
            var transitions = [];
            if (metadata.name.charAt(0) == '@') {
                context.errors.push('animation triggers cannot be prefixed with an `@` sign (e.g. trigger(\'@foo\', [...]))');
            }
            metadata.definitions.forEach(( /**
             * @param {?} def
             * @return {?}
             */function (/**
             * @param {?} def
             * @return {?}
             */ def) {
                _this._resetContextStyleTimingState(context);
                if (def.type == 0 /* State */) {
                    /** @type {?} */
                    var stateDef_1 = ( /** @type {?} */(def));
                    /** @type {?} */
                    var name_4 = stateDef_1.name;
                    name_4.toString().split(/\s*,\s*/).forEach(( /**
                     * @param {?} n
                     * @return {?}
                     */function (/**
                     * @param {?} n
                     * @return {?}
                     */ n) {
                        stateDef_1.name = n;
                        states.push(_this.visitState(stateDef_1, context));
                    }));
                    stateDef_1.name = name_4;
                }
                else if (def.type == 1 /* Transition */) {
                    /** @type {?} */
                    var transition_1 = _this.visitTransition(( /** @type {?} */(def)), context);
                    queryCount += transition_1.queryCount;
                    depCount += transition_1.depCount;
                    transitions.push(transition_1);
                }
                else {
                    context.errors.push('only state() and transition() definitions can sit inside of a trigger()');
                }
            }));
            return {
                type: 7 /* Trigger */,
                name: metadata.name, states: states, transitions: transitions, queryCount: queryCount, depCount: depCount,
                options: null
            };
        };
        /**
         * @param {?} metadata
         * @param {?} context
         * @return {?}
         */
        AnimationAstBuilderVisitor.prototype.visitState = function (metadata, context) {
            /** @type {?} */
            var styleAst = this.visitStyle(metadata.styles, context);
            /** @type {?} */
            var astParams = (metadata.options && metadata.options.params) || null;
            if (styleAst.containsDynamicStyles) {
                /** @type {?} */
                var missingSubs_1 = new Set();
                /** @type {?} */
                var params_2 = astParams || {};
                styleAst.styles.forEach(( /**
                 * @param {?} value
                 * @return {?}
                 */function (/**
                 * @param {?} value
                 * @return {?}
                 */ value) {
                    if (isObject$1(value)) {
                        /** @type {?} */
                        var stylesObj_1 = ( /** @type {?} */(value));
                        Object.keys(stylesObj_1).forEach(( /**
                         * @param {?} prop
                         * @return {?}
                         */function (/**
                         * @param {?} prop
                         * @return {?}
                         */ prop) {
                            extractStyleParams(stylesObj_1[prop]).forEach(( /**
                             * @param {?} sub
                             * @return {?}
                             */function (/**
                             * @param {?} sub
                             * @return {?}
                             */ sub) {
                                if (!params_2.hasOwnProperty(sub)) {
                                    missingSubs_1.add(sub);
                                }
                            }));
                        }));
                    }
                }));
                if (missingSubs_1.size) {
                    /** @type {?} */
                    var missingSubsArr = iteratorToArray(missingSubs_1.values());
                    context.errors.push("state(\"" + metadata.name + "\", ...) must define default values for all the following style substitutions: " + missingSubsArr.join(', '));
                }
            }
            return {
                type: 0 /* State */,
                name: metadata.name,
                style: styleAst,
                options: astParams ? { params: astParams } : null
            };
        };
        /**
         * @param {?} metadata
         * @param {?} context
         * @return {?}
         */
        AnimationAstBuilderVisitor.prototype.visitTransition = function (metadata, context) {
            context.queryCount = 0;
            context.depCount = 0;
            /** @type {?} */
            var animation = visitDslNode(this, normalizeAnimationEntry(metadata.animation), context);
            /** @type {?} */
            var matchers = parseTransitionExpr(metadata.expr, context.errors);
            return {
                type: 1 /* Transition */,
                matchers: matchers,
                animation: animation,
                queryCount: context.queryCount,
                depCount: context.depCount,
                options: normalizeAnimationOptions(metadata.options)
            };
        };
        /**
         * @param {?} metadata
         * @param {?} context
         * @return {?}
         */
        AnimationAstBuilderVisitor.prototype.visitSequence = function (metadata, context) {
            var _this = this;
            return {
                type: 2 /* Sequence */,
                steps: metadata.steps.map(( /**
                 * @param {?} s
                 * @return {?}
                 */function (/**
                 * @param {?} s
                 * @return {?}
                 */ s) { return visitDslNode(_this, s, context); })),
                options: normalizeAnimationOptions(metadata.options)
            };
        };
        /**
         * @param {?} metadata
         * @param {?} context
         * @return {?}
         */
        AnimationAstBuilderVisitor.prototype.visitGroup = function (metadata, context) {
            var _this = this;
            /** @type {?} */
            var currentTime = context.currentTime;
            /** @type {?} */
            var furthestTime = 0;
            /** @type {?} */
            var steps = metadata.steps.map(( /**
             * @param {?} step
             * @return {?}
             */function (/**
             * @param {?} step
             * @return {?}
             */ step) {
                context.currentTime = currentTime;
                /** @type {?} */
                var innerAst = visitDslNode(_this, step, context);
                furthestTime = Math.max(furthestTime, context.currentTime);
                return innerAst;
            }));
            context.currentTime = furthestTime;
            return {
                type: 3 /* Group */,
                steps: steps,
                options: normalizeAnimationOptions(metadata.options)
            };
        };
        /**
         * @param {?} metadata
         * @param {?} context
         * @return {?}
         */
        AnimationAstBuilderVisitor.prototype.visitAnimate = function (metadata, context) {
            /** @type {?} */
            var timingAst = constructTimingAst(metadata.timings, context.errors);
            context.currentAnimateTimings = timingAst;
            /** @type {?} */
            var styleAst;
            /** @type {?} */
            var styleMetadata = metadata.styles ? metadata.styles : style({});
            if (styleMetadata.type == 5 /* Keyframes */) {
                styleAst = this.visitKeyframes(( /** @type {?} */(styleMetadata)), context);
            }
            else {
                /** @type {?} */
                var styleMetadata_1 = ( /** @type {?} */(metadata.styles));
                /** @type {?} */
                var isEmpty_1 = false;
                if (!styleMetadata_1) {
                    isEmpty_1 = true;
                    /** @type {?} */
                    var newStyleData = {};
                    if (timingAst.easing) {
                        newStyleData['easing'] = timingAst.easing;
                    }
                    styleMetadata_1 = style(newStyleData);
                }
                context.currentTime += timingAst.duration + timingAst.delay;
                /** @type {?} */
                var _styleAst = this.visitStyle(styleMetadata_1, context);
                _styleAst.isEmptyStep = isEmpty_1;
                styleAst = _styleAst;
            }
            context.currentAnimateTimings = null;
            return {
                type: 4 /* Animate */,
                timings: timingAst,
                style: styleAst,
                options: null
            };
        };
        /**
         * @param {?} metadata
         * @param {?} context
         * @return {?}
         */
        AnimationAstBuilderVisitor.prototype.visitStyle = function (metadata, context) {
            /** @type {?} */
            var ast = this._makeStyleAst(metadata, context);
            this._validateStyleAst(ast, context);
            return ast;
        };
        /**
         * @private
         * @param {?} metadata
         * @param {?} context
         * @return {?}
         */
        AnimationAstBuilderVisitor.prototype._makeStyleAst = function (metadata, context) {
            /** @type {?} */
            var styles = [];
            if (Array.isArray(metadata.styles)) {
                (( /** @type {?} */(metadata.styles))).forEach(( /**
                 * @param {?} styleTuple
                 * @return {?}
                 */function (/**
                 * @param {?} styleTuple
                 * @return {?}
                 */ styleTuple) {
                    if (typeof styleTuple == 'string') {
                        if (styleTuple == AUTO_STYLE) {
                            styles.push(( /** @type {?} */(styleTuple)));
                        }
                        else {
                            context.errors.push("The provided style string value " + styleTuple + " is not allowed.");
                        }
                    }
                    else {
                        styles.push(( /** @type {?} */(styleTuple)));
                    }
                }));
            }
            else {
                styles.push(metadata.styles);
            }
            /** @type {?} */
            var containsDynamicStyles = false;
            /** @type {?} */
            var collectedEasing = null;
            styles.forEach(( /**
             * @param {?} styleData
             * @return {?}
             */function (/**
             * @param {?} styleData
             * @return {?}
             */ styleData) {
                if (isObject$1(styleData)) {
                    /** @type {?} */
                    var styleMap = ( /** @type {?} */(styleData));
                    /** @type {?} */
                    var easing = styleMap['easing'];
                    if (easing) {
                        collectedEasing = ( /** @type {?} */(easing));
                        delete styleMap['easing'];
                    }
                    if (!containsDynamicStyles) {
                        for (var prop in styleMap) {
                            /** @type {?} */
                            var value = styleMap[prop];
                            if (value.toString().indexOf(SUBSTITUTION_EXPR_START) >= 0) {
                                containsDynamicStyles = true;
                                break;
                            }
                        }
                    }
                }
            }));
            return {
                type: 6 /* Style */,
                styles: styles,
                easing: collectedEasing,
                offset: metadata.offset, containsDynamicStyles: containsDynamicStyles,
                options: null
            };
        };
        /**
         * @private
         * @param {?} ast
         * @param {?} context
         * @return {?}
         */
        AnimationAstBuilderVisitor.prototype._validateStyleAst = function (ast, context) {
            var _this = this;
            /** @type {?} */
            var timings = context.currentAnimateTimings;
            /** @type {?} */
            var endTime = context.currentTime;
            /** @type {?} */
            var startTime = context.currentTime;
            if (timings && startTime > 0) {
                startTime -= timings.duration + timings.delay;
            }
            ast.styles.forEach(( /**
             * @param {?} tuple
             * @return {?}
             */function (/**
             * @param {?} tuple
             * @return {?}
             */ tuple) {
                if (typeof tuple == 'string')
                    return;
                Object.keys(tuple).forEach(( /**
                 * @param {?} prop
                 * @return {?}
                 */function (/**
                 * @param {?} prop
                 * @return {?}
                 */ prop) {
                    if (!_this._driver.validateStyleProperty(prop)) {
                        context.errors.push("The provided animation property \"" + prop + "\" is not a supported CSS property for animations");
                        return;
                    }
                    /** @type {?} */
                    var collectedStyles = context.collectedStyles[( /** @type {?} */(context.currentQuerySelector))];
                    /** @type {?} */
                    var collectedEntry = collectedStyles[prop];
                    /** @type {?} */
                    var updateCollectedStyle = true;
                    if (collectedEntry) {
                        if (startTime != endTime && startTime >= collectedEntry.startTime &&
                            endTime <= collectedEntry.endTime) {
                            context.errors.push("The CSS property \"" + prop + "\" that exists between the times of \"" + collectedEntry.startTime + "ms\" and \"" + collectedEntry.endTime + "ms\" is also being animated in a parallel animation between the times of \"" + startTime + "ms\" and \"" + endTime + "ms\"");
                            updateCollectedStyle = false;
                        }
                        // we always choose the smaller start time value since we
                        // want to have a record of the entire animation window where
                        // the style property is being animated in between
                        startTime = collectedEntry.startTime;
                    }
                    if (updateCollectedStyle) {
                        collectedStyles[prop] = { startTime: startTime, endTime: endTime };
                    }
                    if (context.options) {
                        validateStyleParams(tuple[prop], context.options, context.errors);
                    }
                }));
            }));
        };
        /**
         * @param {?} metadata
         * @param {?} context
         * @return {?}
         */
        AnimationAstBuilderVisitor.prototype.visitKeyframes = function (metadata, context) {
            var _this = this;
            /** @type {?} */
            var ast = { type: 5 /* Keyframes */, styles: [], options: null };
            if (!context.currentAnimateTimings) {
                context.errors.push("keyframes() must be placed inside of a call to animate()");
                return ast;
            }
            /** @type {?} */
            var MAX_KEYFRAME_OFFSET = 1;
            /** @type {?} */
            var totalKeyframesWithOffsets = 0;
            /** @type {?} */
            var offsets = [];
            /** @type {?} */
            var offsetsOutOfOrder = false;
            /** @type {?} */
            var keyframesOutOfRange = false;
            /** @type {?} */
            var previousOffset = 0;
            /** @type {?} */
            var keyframes = metadata.steps.map(( /**
             * @param {?} styles
             * @return {?}
             */function (/**
             * @param {?} styles
             * @return {?}
             */ styles) {
                /** @type {?} */
                var style = _this._makeStyleAst(styles, context);
                /** @type {?} */
                var offsetVal = style.offset != null ? style.offset : consumeOffset(style.styles);
                /** @type {?} */
                var offset = 0;
                if (offsetVal != null) {
                    totalKeyframesWithOffsets++;
                    offset = style.offset = offsetVal;
                }
                keyframesOutOfRange = keyframesOutOfRange || offset < 0 || offset > 1;
                offsetsOutOfOrder = offsetsOutOfOrder || offset < previousOffset;
                previousOffset = offset;
                offsets.push(offset);
                return style;
            }));
            if (keyframesOutOfRange) {
                context.errors.push("Please ensure that all keyframe offsets are between 0 and 1");
            }
            if (offsetsOutOfOrder) {
                context.errors.push("Please ensure that all keyframe offsets are in order");
            }
            /** @type {?} */
            var length = metadata.steps.length;
            /** @type {?} */
            var generatedOffset = 0;
            if (totalKeyframesWithOffsets > 0 && totalKeyframesWithOffsets < length) {
                context.errors.push("Not all style() steps within the declared keyframes() contain offsets");
            }
            else if (totalKeyframesWithOffsets == 0) {
                generatedOffset = MAX_KEYFRAME_OFFSET / (length - 1);
            }
            /** @type {?} */
            var limit = length - 1;
            /** @type {?} */
            var currentTime = context.currentTime;
            /** @type {?} */
            var currentAnimateTimings = ( /** @type {?} */(context.currentAnimateTimings));
            /** @type {?} */
            var animateDuration = currentAnimateTimings.duration;
            keyframes.forEach(( /**
             * @param {?} kf
             * @param {?} i
             * @return {?}
             */function (kf, i) {
                /** @type {?} */
                var offset = generatedOffset > 0 ? (i == limit ? 1 : (generatedOffset * i)) : offsets[i];
                /** @type {?} */
                var durationUpToThisFrame = offset * animateDuration;
                context.currentTime = currentTime + currentAnimateTimings.delay + durationUpToThisFrame;
                currentAnimateTimings.duration = durationUpToThisFrame;
                _this._validateStyleAst(kf, context);
                kf.offset = offset;
                ast.styles.push(kf);
            }));
            return ast;
        };
        /**
         * @param {?} metadata
         * @param {?} context
         * @return {?}
         */
        AnimationAstBuilderVisitor.prototype.visitReference = function (metadata, context) {
            return {
                type: 8 /* Reference */,
                animation: visitDslNode(this, normalizeAnimationEntry(metadata.animation), context),
                options: normalizeAnimationOptions(metadata.options)
            };
        };
        /**
         * @param {?} metadata
         * @param {?} context
         * @return {?}
         */
        AnimationAstBuilderVisitor.prototype.visitAnimateChild = function (metadata, context) {
            context.depCount++;
            return {
                type: 9 /* AnimateChild */,
                options: normalizeAnimationOptions(metadata.options)
            };
        };
        /**
         * @param {?} metadata
         * @param {?} context
         * @return {?}
         */
        AnimationAstBuilderVisitor.prototype.visitAnimateRef = function (metadata, context) {
            return {
                type: 10 /* AnimateRef */,
                animation: this.visitReference(metadata.animation, context),
                options: normalizeAnimationOptions(metadata.options)
            };
        };
        /**
         * @param {?} metadata
         * @param {?} context
         * @return {?}
         */
        AnimationAstBuilderVisitor.prototype.visitQuery = function (metadata, context) {
            /** @type {?} */
            var parentSelector = ( /** @type {?} */(context.currentQuerySelector));
            /** @type {?} */
            var options = ( /** @type {?} */((metadata.options || {})));
            context.queryCount++;
            context.currentQuery = metadata;
            var _b = __read(normalizeSelector(metadata.selector), 2), selector = _b[0], includeSelf = _b[1];
            context.currentQuerySelector =
                parentSelector.length ? (parentSelector + ' ' + selector) : selector;
            getOrSetAsInMap(context.collectedStyles, context.currentQuerySelector, {});
            /** @type {?} */
            var animation = visitDslNode(this, normalizeAnimationEntry(metadata.animation), context);
            context.currentQuery = null;
            context.currentQuerySelector = parentSelector;
            return {
                type: 11 /* Query */,
                selector: selector,
                limit: options.limit || 0,
                optional: !!options.optional, includeSelf: includeSelf, animation: animation,
                originalSelector: metadata.selector,
                options: normalizeAnimationOptions(metadata.options)
            };
        };
        /**
         * @param {?} metadata
         * @param {?} context
         * @return {?}
         */
        AnimationAstBuilderVisitor.prototype.visitStagger = function (metadata, context) {
            if (!context.currentQuery) {
                context.errors.push("stagger() can only be used inside of query()");
            }
            /** @type {?} */
            var timings = metadata.timings === 'full' ?
                { duration: 0, delay: 0, easing: 'full' } :
                resolveTiming(metadata.timings, context.errors, true);
            return {
                type: 12 /* Stagger */,
                animation: visitDslNode(this, normalizeAnimationEntry(metadata.animation), context), timings: timings,
                options: null
            };
        };
        return AnimationAstBuilderVisitor;
    }());
    /**
     * @param {?} selector
     * @return {?}
     */
    function normalizeSelector(selector) {
        /** @type {?} */
        var hasAmpersand = selector.split(/\s*,\s*/).find(( /**
         * @param {?} token
         * @return {?}
         */function (/**
         * @param {?} token
         * @return {?}
         */ token) { return token == SELF_TOKEN; })) ? true : false;
        if (hasAmpersand) {
            selector = selector.replace(SELF_TOKEN_REGEX, '');
        }
        // the :enter and :leave selectors are filled in at runtime during timeline building
        selector = selector.replace(/@\*/g, NG_TRIGGER_SELECTOR)
            .replace(/@\w+/g, ( /**
     * @param {?} match
     * @return {?}
     */function (/**
     * @param {?} match
     * @return {?}
     */ match) { return NG_TRIGGER_SELECTOR + '-' + match.substr(1); }))
            .replace(/:animating/g, NG_ANIMATING_SELECTOR);
        return [selector, hasAmpersand];
    }
    /**
     * @param {?} obj
     * @return {?}
     */
    function normalizeParams(obj) {
        return obj ? copyObj(obj) : null;
    }
    var AnimationAstBuilderContext = /** @class */ (function () {
        /**
         * @param {?} errors
         */
        function AnimationAstBuilderContext(errors) {
            this.errors = errors;
            this.queryCount = 0;
            this.depCount = 0;
            this.currentTransition = null;
            this.currentQuery = null;
            this.currentQuerySelector = null;
            this.currentAnimateTimings = null;
            this.currentTime = 0;
            this.collectedStyles = {};
            this.options = null;
        }
        return AnimationAstBuilderContext;
    }());
    /**
     * @param {?} styles
     * @return {?}
     */
    function consumeOffset(styles) {
        if (typeof styles == 'string')
            return null;
        /** @type {?} */
        var offset = null;
        if (Array.isArray(styles)) {
            styles.forEach(( /**
             * @param {?} styleTuple
             * @return {?}
             */function (/**
             * @param {?} styleTuple
             * @return {?}
             */ styleTuple) {
                if (isObject$1(styleTuple) && styleTuple.hasOwnProperty('offset')) {
                    /** @type {?} */
                    var obj = ( /** @type {?} */(styleTuple));
                    offset = parseFloat(( /** @type {?} */(obj['offset'])));
                    delete obj['offset'];
                }
            }));
        }
        else if (isObject$1(styles) && styles.hasOwnProperty('offset')) {
            /** @type {?} */
            var obj = ( /** @type {?} */(styles));
            offset = parseFloat(( /** @type {?} */(obj['offset'])));
            delete obj['offset'];
        }
        return offset;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    function isObject$1(value) {
        return !Array.isArray(value) && typeof value == 'object';
    }
    /**
     * @param {?} value
     * @param {?} errors
     * @return {?}
     */
    function constructTimingAst(value, errors) {
        /** @type {?} */
        var timings = null;
        if (value.hasOwnProperty('duration')) {
            timings = ( /** @type {?} */(value));
        }
        else if (typeof value == 'number') {
            /** @type {?} */
            var duration = resolveTiming(( /** @type {?} */(value)), errors).duration;
            return makeTimingAst(( /** @type {?} */(duration)), 0, '');
        }
        /** @type {?} */
        var strValue = ( /** @type {?} */(value));
        /** @type {?} */
        var isDynamic = strValue.split(/\s+/).some(( /**
         * @param {?} v
         * @return {?}
         */function (/**
         * @param {?} v
         * @return {?}
         */ v) { return v.charAt(0) == '{' && v.charAt(1) == '{'; }));
        if (isDynamic) {
            /** @type {?} */
            var ast = ( /** @type {?} */(makeTimingAst(0, 0, '')));
            ast.dynamic = true;
            ast.strValue = strValue;
            return ( /** @type {?} */(ast));
        }
        timings = timings || resolveTiming(strValue, errors);
        return makeTimingAst(timings.duration, timings.delay, timings.easing);
    }
    /**
     * @param {?} options
     * @return {?}
     */
    function normalizeAnimationOptions(options) {
        if (options) {
            options = copyObj(options);
            if (options['params']) {
                options['params'] = ( /** @type {?} */(normalizeParams(options['params'])));
            }
        }
        else {
            options = {};
        }
        return options;
    }
    /**
     * @param {?} duration
     * @param {?} delay
     * @param {?} easing
     * @return {?}
     */
    function makeTimingAst(duration, delay, easing) {
        return { duration: duration, delay: delay, easing: easing };
    }
    /**
     * @param {?} element
     * @param {?} keyframes
     * @param {?} preStyleProps
     * @param {?} postStyleProps
     * @param {?} duration
     * @param {?} delay
     * @param {?=} easing
     * @param {?=} subTimeline
     * @return {?}
     */
    function createTimelineInstruction(element, keyframes, preStyleProps, postStyleProps, duration, delay, easing, subTimeline) {
        if (easing === void 0) { easing = null; }
        if (subTimeline === void 0) { subTimeline = false; }
        return {
            type: 1 /* TimelineAnimation */,
            element: element,
            keyframes: keyframes,
            preStyleProps: preStyleProps,
            postStyleProps: postStyleProps,
            duration: duration,
            delay: delay,
            totalTime: duration + delay, easing: easing, subTimeline: subTimeline
        };
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ElementInstructionMap = /** @class */ (function () {
        function ElementInstructionMap() {
            this._map = new Map();
        }
        /**
         * @param {?} element
         * @return {?}
         */
        ElementInstructionMap.prototype.consume = function (element) {
            /** @type {?} */
            var instructions = this._map.get(element);
            if (instructions) {
                this._map.delete(element);
            }
            else {
                instructions = [];
            }
            return instructions;
        };
        /**
         * @param {?} element
         * @param {?} instructions
         * @return {?}
         */
        ElementInstructionMap.prototype.append = function (element, instructions) {
            /** @type {?} */
            var existingInstructions = this._map.get(element);
            if (!existingInstructions) {
                this._map.set(element, existingInstructions = []);
            }
            existingInstructions.push.apply(existingInstructions, __spread(instructions));
        };
        /**
         * @param {?} element
         * @return {?}
         */
        ElementInstructionMap.prototype.has = function (element) { return this._map.has(element); };
        /**
         * @return {?}
         */
        ElementInstructionMap.prototype.clear = function () { this._map.clear(); };
        return ElementInstructionMap;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var ONE_FRAME_IN_MILLISECONDS = 1;
    /** @type {?} */
    var ENTER_TOKEN = ':enter';
    /** @type {?} */
    var ENTER_TOKEN_REGEX = new RegExp(ENTER_TOKEN, 'g');
    /** @type {?} */
    var LEAVE_TOKEN = ':leave';
    /** @type {?} */
    var LEAVE_TOKEN_REGEX = new RegExp(LEAVE_TOKEN, 'g');
    /*
     * The code within this file aims to generate web-animations-compatible keyframes from Angular's
     * animation DSL code.
     *
     * The code below will be converted from:
     *
     * ```
     * sequence([
     *   style({ opacity: 0 }),
     *   animate(1000, style({ opacity: 0 }))
     * ])
     * ```
     *
     * To:
     * ```
     * keyframes = [{ opacity: 0, offset: 0 }, { opacity: 1, offset: 1 }]
     * duration = 1000
     * delay = 0
     * easing = ''
     * ```
     *
     * For this operation to cover the combination of animation verbs (style, animate, group, etc...) a
     * combination of prototypical inheritance, AST traversal and merge-sort-like algorithms are used.
     *
     * [AST Traversal]
     * Each of the animation verbs, when executed, will return an string-map object representing what
     * type of action it is (style, animate, group, etc...) and the data associated with it. This means
     * that when functional composition mix of these functions is evaluated (like in the example above)
     * then it will end up producing a tree of objects representing the animation itself.
     *
     * When this animation object tree is processed by the visitor code below it will visit each of the
     * verb statements within the visitor. And during each visit it will build the context of the
     * animation keyframes by interacting with the `TimelineBuilder`.
     *
     * [TimelineBuilder]
     * This class is responsible for tracking the styles and building a series of keyframe objects for a
     * timeline between a start and end time. The builder starts off with an initial timeline and each
     * time the AST comes across a `group()`, `keyframes()` or a combination of the two wihtin a
     * `sequence()` then it will generate a sub timeline for each step as well as a new one after
     * they are complete.
     *
     * As the AST is traversed, the timing state on each of the timelines will be incremented. If a sub
     * timeline was created (based on one of the cases above) then the parent timeline will attempt to
     * merge the styles used within the sub timelines into itself (only with group() this will happen).
     * This happens with a merge operation (much like how the merge works in mergesort) and it will only
     * copy the most recently used styles from the sub timelines into the parent timeline. This ensures
     * that if the styles are used later on in another phase of the animation then they will be the most
     * up-to-date values.
     *
     * [How Missing Styles Are Updated]
     * Each timeline has a `backFill` property which is responsible for filling in new styles into
     * already processed keyframes if a new style shows up later within the animation sequence.
     *
     * ```
     * sequence([
     *   style({ width: 0 }),
     *   animate(1000, style({ width: 100 })),
     *   animate(1000, style({ width: 200 })),
     *   animate(1000, style({ width: 300 }))
     *   animate(1000, style({ width: 400, height: 400 })) // notice how `height` doesn't exist anywhere
     * else
     * ])
     * ```
     *
     * What is happening here is that the `height` value is added later in the sequence, but is missing
     * from all previous animation steps. Therefore when a keyframe is created it would also be missing
     * from all previous keyframes up until where it is first used. For the timeline keyframe generation
     * to properly fill in the style it will place the previous value (the value from the parent
     * timeline) or a default value of `*` into the backFill object. Given that each of the keyframe
     * styles are objects that prototypically inhert from the backFill object, this means that if a
     * value is added into the backFill then it will automatically propagate any missing values to all
     * keyframes. Therefore the missing `height` value will be properly filled into the already
     * processed keyframes.
     *
     * When a sub-timeline is created it will have its own backFill property. This is done so that
     * styles present within the sub-timeline do not accidentally seep into the previous/future timeline
     * keyframes
     *
     * (For prototypically-inherited contents to be detected a `for(i in obj)` loop must be used.)
     *
     * [Validation]
     * The code in this file is not responsible for validation. That functionality happens with within
     * the `AnimationValidatorVisitor` code.
     */
    /**
     * @param {?} driver
     * @param {?} rootElement
     * @param {?} ast
     * @param {?} enterClassName
     * @param {?} leaveClassName
     * @param {?=} startingStyles
     * @param {?=} finalStyles
     * @param {?=} options
     * @param {?=} subInstructions
     * @param {?=} errors
     * @return {?}
     */
    function buildAnimationTimelines(driver, rootElement, ast, enterClassName, leaveClassName, startingStyles, finalStyles, options, subInstructions, errors) {
        if (startingStyles === void 0) { startingStyles = {}; }
        if (finalStyles === void 0) { finalStyles = {}; }
        if (errors === void 0) { errors = []; }
        return new AnimationTimelineBuilderVisitor().buildKeyframes(driver, rootElement, ast, enterClassName, leaveClassName, startingStyles, finalStyles, options, subInstructions, errors);
    }
    var AnimationTimelineBuilderVisitor = /** @class */ (function () {
        function AnimationTimelineBuilderVisitor() {
        }
        /**
         * @param {?} driver
         * @param {?} rootElement
         * @param {?} ast
         * @param {?} enterClassName
         * @param {?} leaveClassName
         * @param {?} startingStyles
         * @param {?} finalStyles
         * @param {?} options
         * @param {?=} subInstructions
         * @param {?=} errors
         * @return {?}
         */
        AnimationTimelineBuilderVisitor.prototype.buildKeyframes = function (driver, rootElement, ast, enterClassName, leaveClassName, startingStyles, finalStyles, options, subInstructions, errors) {
            if (errors === void 0) { errors = []; }
            subInstructions = subInstructions || new ElementInstructionMap();
            /** @type {?} */
            var context = new AnimationTimelineContext(driver, rootElement, subInstructions, enterClassName, leaveClassName, errors, []);
            context.options = options;
            context.currentTimeline.setStyles([startingStyles], null, context.errors, options);
            visitDslNode(this, ast, context);
            // this checks to see if an actual animation happened
            /** @type {?} */
            var timelines = context.timelines.filter(( /**
             * @param {?} timeline
             * @return {?}
             */function (/**
             * @param {?} timeline
             * @return {?}
             */ timeline) { return timeline.containsAnimation(); }));
            if (timelines.length && Object.keys(finalStyles).length) {
                /** @type {?} */
                var tl = timelines[timelines.length - 1];
                if (!tl.allowOnlyTimelineStyles()) {
                    tl.setStyles([finalStyles], null, context.errors, options);
                }
            }
            return timelines.length ? timelines.map(( /**
             * @param {?} timeline
             * @return {?}
             */function (/**
             * @param {?} timeline
             * @return {?}
             */ timeline) { return timeline.buildKeyframes(); })) :
                [createTimelineInstruction(rootElement, [], [], [], 0, 0, '', false)];
        };
        /**
         * @param {?} ast
         * @param {?} context
         * @return {?}
         */
        AnimationTimelineBuilderVisitor.prototype.visitTrigger = function (ast, context) {
            // these values are not visited in this AST
        };
        /**
         * @param {?} ast
         * @param {?} context
         * @return {?}
         */
        AnimationTimelineBuilderVisitor.prototype.visitState = function (ast, context) {
            // these values are not visited in this AST
        };
        /**
         * @param {?} ast
         * @param {?} context
         * @return {?}
         */
        AnimationTimelineBuilderVisitor.prototype.visitTransition = function (ast, context) {
            // these values are not visited in this AST
        };
        /**
         * @param {?} ast
         * @param {?} context
         * @return {?}
         */
        AnimationTimelineBuilderVisitor.prototype.visitAnimateChild = function (ast, context) {
            /** @type {?} */
            var elementInstructions = context.subInstructions.consume(context.element);
            if (elementInstructions) {
                /** @type {?} */
                var innerContext = context.createSubContext(ast.options);
                /** @type {?} */
                var startTime = context.currentTimeline.currentTime;
                /** @type {?} */
                var endTime = this._visitSubInstructions(elementInstructions, innerContext, ( /** @type {?} */(innerContext.options)));
                if (startTime != endTime) {
                    // we do this on the upper context because we created a sub context for
                    // the sub child animations
                    context.transformIntoNewTimeline(endTime);
                }
            }
            context.previousNode = ast;
        };
        /**
         * @param {?} ast
         * @param {?} context
         * @return {?}
         */
        AnimationTimelineBuilderVisitor.prototype.visitAnimateRef = function (ast, context) {
            /** @type {?} */
            var innerContext = context.createSubContext(ast.options);
            innerContext.transformIntoNewTimeline();
            this.visitReference(ast.animation, innerContext);
            context.transformIntoNewTimeline(innerContext.currentTimeline.currentTime);
            context.previousNode = ast;
        };
        /**
         * @private
         * @param {?} instructions
         * @param {?} context
         * @param {?} options
         * @return {?}
         */
        AnimationTimelineBuilderVisitor.prototype._visitSubInstructions = function (instructions, context, options) {
            /** @type {?} */
            var startTime = context.currentTimeline.currentTime;
            /** @type {?} */
            var furthestTime = startTime;
            // this is a special-case for when a user wants to skip a sub
            // animation from being fired entirely.
            /** @type {?} */
            var duration = options.duration != null ? resolveTimingValue(options.duration) : null;
            /** @type {?} */
            var delay = options.delay != null ? resolveTimingValue(options.delay) : null;
            if (duration !== 0) {
                instructions.forEach(( /**
                 * @param {?} instruction
                 * @return {?}
                 */function (/**
                 * @param {?} instruction
                 * @return {?}
                 */ instruction) {
                    /** @type {?} */
                    var instructionTimings = context.appendInstructionToTimeline(instruction, duration, delay);
                    furthestTime =
                        Math.max(furthestTime, instructionTimings.duration + instructionTimings.delay);
                }));
            }
            return furthestTime;
        };
        /**
         * @param {?} ast
         * @param {?} context
         * @return {?}
         */
        AnimationTimelineBuilderVisitor.prototype.visitReference = function (ast, context) {
            context.updateOptions(ast.options, true);
            visitDslNode(this, ast.animation, context);
            context.previousNode = ast;
        };
        /**
         * @param {?} ast
         * @param {?} context
         * @return {?}
         */
        AnimationTimelineBuilderVisitor.prototype.visitSequence = function (ast, context) {
            var _this = this;
            /** @type {?} */
            var subContextCount = context.subContextCount;
            /** @type {?} */
            var ctx = context;
            /** @type {?} */
            var options = ast.options;
            if (options && (options.params || options.delay)) {
                ctx = context.createSubContext(options);
                ctx.transformIntoNewTimeline();
                if (options.delay != null) {
                    if (ctx.previousNode.type == 6 /* Style */) {
                        ctx.currentTimeline.snapshotCurrentStyles();
                        ctx.previousNode = DEFAULT_NOOP_PREVIOUS_NODE;
                    }
                    /** @type {?} */
                    var delay_2 = resolveTimingValue(options.delay);
                    ctx.delayNextStep(delay_2);
                }
            }
            if (ast.steps.length) {
                ast.steps.forEach(( /**
                 * @param {?} s
                 * @return {?}
                 */function (/**
                 * @param {?} s
                 * @return {?}
                 */ s) { return visitDslNode(_this, s, ctx); }));
                // this is here just incase the inner steps only contain or end with a style() call
                ctx.currentTimeline.applyStylesToKeyframe();
                // this means that some animation function within the sequence
                // ended up creating a sub timeline (which means the current
                // timeline cannot overlap with the contents of the sequence)
                if (ctx.subContextCount > subContextCount) {
                    ctx.transformIntoNewTimeline();
                }
            }
            context.previousNode = ast;
        };
        /**
         * @param {?} ast
         * @param {?} context
         * @return {?}
         */
        AnimationTimelineBuilderVisitor.prototype.visitGroup = function (ast, context) {
            var _this = this;
            /** @type {?} */
            var innerTimelines = [];
            /** @type {?} */
            var furthestTime = context.currentTimeline.currentTime;
            /** @type {?} */
            var delay = ast.options && ast.options.delay ? resolveTimingValue(ast.options.delay) : 0;
            ast.steps.forEach(( /**
             * @param {?} s
             * @return {?}
             */function (/**
             * @param {?} s
             * @return {?}
             */ s) {
                /** @type {?} */
                var innerContext = context.createSubContext(ast.options);
                if (delay) {
                    innerContext.delayNextStep(delay);
                }
                visitDslNode(_this, s, innerContext);
                furthestTime = Math.max(furthestTime, innerContext.currentTimeline.currentTime);
                innerTimelines.push(innerContext.currentTimeline);
            }));
            // this operation is run after the AST loop because otherwise
            // if the parent timeline's collected styles were updated then
            // it would pass in invalid data into the new-to-be forked items
            innerTimelines.forEach(( /**
             * @param {?} timeline
             * @return {?}
             */function (/**
             * @param {?} timeline
             * @return {?}
             */ timeline) { return context.currentTimeline.mergeTimelineCollectedStyles(timeline); }));
            context.transformIntoNewTimeline(furthestTime);
            context.previousNode = ast;
        };
        /**
         * @private
         * @param {?} ast
         * @param {?} context
         * @return {?}
         */
        AnimationTimelineBuilderVisitor.prototype._visitTiming = function (ast, context) {
            if ((( /** @type {?} */(ast))).dynamic) {
                /** @type {?} */
                var strValue = (( /** @type {?} */(ast))).strValue;
                /** @type {?} */
                var timingValue = context.params ? interpolateParams(strValue, context.params, context.errors) : strValue;
                return resolveTiming(timingValue, context.errors);
            }
            else {
                return { duration: ast.duration, delay: ast.delay, easing: ast.easing };
            }
        };
        /**
         * @param {?} ast
         * @param {?} context
         * @return {?}
         */
        AnimationTimelineBuilderVisitor.prototype.visitAnimate = function (ast, context) {
            /** @type {?} */
            var timings = context.currentAnimateTimings = this._visitTiming(ast.timings, context);
            /** @type {?} */
            var timeline = context.currentTimeline;
            if (timings.delay) {
                context.incrementTime(timings.delay);
                timeline.snapshotCurrentStyles();
            }
            /** @type {?} */
            var style = ast.style;
            if (style.type == 5 /* Keyframes */) {
                this.visitKeyframes(style, context);
            }
            else {
                context.incrementTime(timings.duration);
                this.visitStyle(( /** @type {?} */(style)), context);
                timeline.applyStylesToKeyframe();
            }
            context.currentAnimateTimings = null;
            context.previousNode = ast;
        };
        /**
         * @param {?} ast
         * @param {?} context
         * @return {?}
         */
        AnimationTimelineBuilderVisitor.prototype.visitStyle = function (ast, context) {
            /** @type {?} */
            var timeline = context.currentTimeline;
            /** @type {?} */
            var timings = ( /** @type {?} */(context.currentAnimateTimings));
            // this is a special case for when a style() call
            // directly follows  an animate() call (but not inside of an animate() call)
            if (!timings && timeline.getCurrentStyleProperties().length) {
                timeline.forwardFrame();
            }
            /** @type {?} */
            var easing = (timings && timings.easing) || ast.easing;
            if (ast.isEmptyStep) {
                timeline.applyEmptyStep(easing);
            }
            else {
                timeline.setStyles(ast.styles, easing, context.errors, context.options);
            }
            context.previousNode = ast;
        };
        /**
         * @param {?} ast
         * @param {?} context
         * @return {?}
         */
        AnimationTimelineBuilderVisitor.prototype.visitKeyframes = function (ast, context) {
            /** @type {?} */
            var currentAnimateTimings = ( /** @type {?} */(context.currentAnimateTimings));
            /** @type {?} */
            var startTime = (( /** @type {?} */(context.currentTimeline))).duration;
            /** @type {?} */
            var duration = currentAnimateTimings.duration;
            /** @type {?} */
            var innerContext = context.createSubContext();
            /** @type {?} */
            var innerTimeline = innerContext.currentTimeline;
            innerTimeline.easing = currentAnimateTimings.easing;
            ast.styles.forEach(( /**
             * @param {?} step
             * @return {?}
             */function (/**
             * @param {?} step
             * @return {?}
             */ step) {
                /** @type {?} */
                var offset = step.offset || 0;
                innerTimeline.forwardTime(offset * duration);
                innerTimeline.setStyles(step.styles, step.easing, context.errors, context.options);
                innerTimeline.applyStylesToKeyframe();
            }));
            // this will ensure that the parent timeline gets all the styles from
            // the child even if the new timeline below is not used
            context.currentTimeline.mergeTimelineCollectedStyles(innerTimeline);
            // we do this because the window between this timeline and the sub timeline
            // should ensure that the styles within are exactly the same as they were before
            context.transformIntoNewTimeline(startTime + duration);
            context.previousNode = ast;
        };
        /**
         * @param {?} ast
         * @param {?} context
         * @return {?}
         */
        AnimationTimelineBuilderVisitor.prototype.visitQuery = function (ast, context) {
            var _this = this;
            // in the event that the first step before this is a style step we need
            // to ensure the styles are applied before the children are animated
            /** @type {?} */
            var startTime = context.currentTimeline.currentTime;
            /** @type {?} */
            var options = ( /** @type {?} */((ast.options || {})));
            /** @type {?} */
            var delay = options.delay ? resolveTimingValue(options.delay) : 0;
            if (delay && (context.previousNode.type === 6 /* Style */ ||
                (startTime == 0 && context.currentTimeline.getCurrentStyleProperties().length))) {
                context.currentTimeline.snapshotCurrentStyles();
                context.previousNode = DEFAULT_NOOP_PREVIOUS_NODE;
            }
            /** @type {?} */
            var furthestTime = startTime;
            /** @type {?} */
            var elms = context.invokeQuery(ast.selector, ast.originalSelector, ast.limit, ast.includeSelf, options.optional ? true : false, context.errors);
            context.currentQueryTotal = elms.length;
            /** @type {?} */
            var sameElementTimeline = null;
            elms.forEach(( /**
             * @param {?} element
             * @param {?} i
             * @return {?}
             */function (element, i) {
                context.currentQueryIndex = i;
                /** @type {?} */
                var innerContext = context.createSubContext(ast.options, element);
                if (delay) {
                    innerContext.delayNextStep(delay);
                }
                if (element === context.element) {
                    sameElementTimeline = innerContext.currentTimeline;
                }
                visitDslNode(_this, ast.animation, innerContext);
                // this is here just incase the inner steps only contain or end
                // with a style() call (which is here to signal that this is a preparatory
                // call to style an element before it is animated again)
                innerContext.currentTimeline.applyStylesToKeyframe();
                /** @type {?} */
                var endTime = innerContext.currentTimeline.currentTime;
                furthestTime = Math.max(furthestTime, endTime);
            }));
            context.currentQueryIndex = 0;
            context.currentQueryTotal = 0;
            context.transformIntoNewTimeline(furthestTime);
            if (sameElementTimeline) {
                context.currentTimeline.mergeTimelineCollectedStyles(sameElementTimeline);
                context.currentTimeline.snapshotCurrentStyles();
            }
            context.previousNode = ast;
        };
        /**
         * @param {?} ast
         * @param {?} context
         * @return {?}
         */
        AnimationTimelineBuilderVisitor.prototype.visitStagger = function (ast, context) {
            /** @type {?} */
            var parentContext = ( /** @type {?} */(context.parentContext));
            /** @type {?} */
            var tl = context.currentTimeline;
            /** @type {?} */
            var timings = ast.timings;
            /** @type {?} */
            var duration = Math.abs(timings.duration);
            /** @type {?} */
            var maxTime = duration * (context.currentQueryTotal - 1);
            /** @type {?} */
            var delay = duration * context.currentQueryIndex;
            /** @type {?} */
            var staggerTransformer = timings.duration < 0 ? 'reverse' : timings.easing;
            switch (staggerTransformer) {
                case 'reverse':
                    delay = maxTime - delay;
                    break;
                case 'full':
                    delay = parentContext.currentStaggerTime;
                    break;
            }
            /** @type {?} */
            var timeline = context.currentTimeline;
            if (delay) {
                timeline.delayNextStep(delay);
            }
            /** @type {?} */
            var startingTime = timeline.currentTime;
            visitDslNode(this, ast.animation, context);
            context.previousNode = ast;
            // time = duration + delay
            // the reason why this computation is so complex is because
            // the inner timeline may either have a delay value or a stretched
            // keyframe depending on if a subtimeline is not used or is used.
            parentContext.currentStaggerTime =
                (tl.currentTime - startingTime) + (tl.startTime - parentContext.currentTimeline.startTime);
        };
        return AnimationTimelineBuilderVisitor;
    }());
    /** @type {?} */
    var DEFAULT_NOOP_PREVIOUS_NODE = ( /** @type {?} */({}));
    var AnimationTimelineContext = /** @class */ (function () {
        /**
         * @param {?} _driver
         * @param {?} element
         * @param {?} subInstructions
         * @param {?} _enterClassName
         * @param {?} _leaveClassName
         * @param {?} errors
         * @param {?} timelines
         * @param {?=} initialTimeline
         */
        function AnimationTimelineContext(_driver, element, subInstructions, _enterClassName, _leaveClassName, errors, timelines, initialTimeline) {
            this._driver = _driver;
            this.element = element;
            this.subInstructions = subInstructions;
            this._enterClassName = _enterClassName;
            this._leaveClassName = _leaveClassName;
            this.errors = errors;
            this.timelines = timelines;
            this.parentContext = null;
            this.currentAnimateTimings = null;
            this.previousNode = DEFAULT_NOOP_PREVIOUS_NODE;
            this.subContextCount = 0;
            this.options = {};
            this.currentQueryIndex = 0;
            this.currentQueryTotal = 0;
            this.currentStaggerTime = 0;
            this.currentTimeline = initialTimeline || new TimelineBuilder(this._driver, element, 0);
            timelines.push(this.currentTimeline);
        }
        Object.defineProperty(AnimationTimelineContext.prototype, "params", {
            /**
             * @return {?}
             */
            get: function () { return this.options.params; },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} options
         * @param {?=} skipIfExists
         * @return {?}
         */
        AnimationTimelineContext.prototype.updateOptions = function (options, skipIfExists) {
            var _this = this;
            if (!options)
                return;
            /** @type {?} */
            var newOptions = ( /** @type {?} */(options));
            /** @type {?} */
            var optionsToUpdate = this.options;
            // NOTE: this will get patched up when other animation methods support duration overrides
            if (newOptions.duration != null) {
                (( /** @type {?} */(optionsToUpdate))).duration = resolveTimingValue(newOptions.duration);
            }
            if (newOptions.delay != null) {
                optionsToUpdate.delay = resolveTimingValue(newOptions.delay);
            }
            /** @type {?} */
            var newParams = newOptions.params;
            if (newParams) {
                /** @type {?} */
                var paramsToUpdate_1 = ( /** @type {?} */(optionsToUpdate.params));
                if (!paramsToUpdate_1) {
                    paramsToUpdate_1 = this.options.params = {};
                }
                Object.keys(newParams).forEach(( /**
                 * @param {?} name
                 * @return {?}
                 */function (/**
                 * @param {?} name
                 * @return {?}
                 */ name) {
                    if (!skipIfExists || !paramsToUpdate_1.hasOwnProperty(name)) {
                        paramsToUpdate_1[name] = interpolateParams(newParams[name], paramsToUpdate_1, _this.errors);
                    }
                }));
            }
        };
        /**
         * @private
         * @return {?}
         */
        AnimationTimelineContext.prototype._copyOptions = function () {
            /** @type {?} */
            var options = {};
            if (this.options) {
                /** @type {?} */
                var oldParams_1 = this.options.params;
                if (oldParams_1) {
                    /** @type {?} */
                    var params_3 = options['params'] = {};
                    Object.keys(oldParams_1).forEach(( /**
                     * @param {?} name
                     * @return {?}
                     */function (/**
                     * @param {?} name
                     * @return {?}
                     */ name) { params_3[name] = oldParams_1[name]; }));
                }
            }
            return options;
        };
        /**
         * @param {?=} options
         * @param {?=} element
         * @param {?=} newTime
         * @return {?}
         */
        AnimationTimelineContext.prototype.createSubContext = function (options, element, newTime) {
            if (options === void 0) { options = null; }
            /** @type {?} */
            var target = element || this.element;
            /** @type {?} */
            var context = new AnimationTimelineContext(this._driver, target, this.subInstructions, this._enterClassName, this._leaveClassName, this.errors, this.timelines, this.currentTimeline.fork(target, newTime || 0));
            context.previousNode = this.previousNode;
            context.currentAnimateTimings = this.currentAnimateTimings;
            context.options = this._copyOptions();
            context.updateOptions(options);
            context.currentQueryIndex = this.currentQueryIndex;
            context.currentQueryTotal = this.currentQueryTotal;
            context.parentContext = this;
            this.subContextCount++;
            return context;
        };
        /**
         * @param {?=} newTime
         * @return {?}
         */
        AnimationTimelineContext.prototype.transformIntoNewTimeline = function (newTime) {
            this.previousNode = DEFAULT_NOOP_PREVIOUS_NODE;
            this.currentTimeline = this.currentTimeline.fork(this.element, newTime);
            this.timelines.push(this.currentTimeline);
            return this.currentTimeline;
        };
        /**
         * @param {?} instruction
         * @param {?} duration
         * @param {?} delay
         * @return {?}
         */
        AnimationTimelineContext.prototype.appendInstructionToTimeline = function (instruction, duration, delay) {
            /** @type {?} */
            var updatedTimings = {
                duration: duration != null ? duration : instruction.duration,
                delay: this.currentTimeline.currentTime + (delay != null ? delay : 0) + instruction.delay,
                easing: ''
            };
            /** @type {?} */
            var builder = new SubTimelineBuilder(this._driver, instruction.element, instruction.keyframes, instruction.preStyleProps, instruction.postStyleProps, updatedTimings, instruction.stretchStartingKeyframe);
            this.timelines.push(builder);
            return updatedTimings;
        };
        /**
         * @param {?} time
         * @return {?}
         */
        AnimationTimelineContext.prototype.incrementTime = function (time) {
            this.currentTimeline.forwardTime(this.currentTimeline.duration + time);
        };
        /**
         * @param {?} delay
         * @return {?}
         */
        AnimationTimelineContext.prototype.delayNextStep = function (delay) {
            // negative delays are not yet supported
            if (delay > 0) {
                this.currentTimeline.delayNextStep(delay);
            }
        };
        /**
         * @param {?} selector
         * @param {?} originalSelector
         * @param {?} limit
         * @param {?} includeSelf
         * @param {?} optional
         * @param {?} errors
         * @return {?}
         */
        AnimationTimelineContext.prototype.invokeQuery = function (selector, originalSelector, limit, includeSelf, optional, errors) {
            /** @type {?} */
            var results = [];
            if (includeSelf) {
                results.push(this.element);
            }
            if (selector.length > 0) { // if :self is only used then the selector is empty
                selector = selector.replace(ENTER_TOKEN_REGEX, '.' + this._enterClassName);
                selector = selector.replace(LEAVE_TOKEN_REGEX, '.' + this._leaveClassName);
                /** @type {?} */
                var multi = limit != 1;
                /** @type {?} */
                var elements = this._driver.query(this.element, selector, multi);
                if (limit !== 0) {
                    elements = limit < 0 ? elements.slice(elements.length + limit, elements.length) :
                        elements.slice(0, limit);
                }
                results.push.apply(results, __spread(elements));
            }
            if (!optional && results.length == 0) {
                errors.push("`query(\"" + originalSelector + "\")` returned zero elements. (Use `query(\"" + originalSelector + "\", { optional: true })` if you wish to allow this.)");
            }
            return results;
        };
        return AnimationTimelineContext;
    }());
    var TimelineBuilder = /** @class */ (function () {
        /**
         * @param {?} _driver
         * @param {?} element
         * @param {?} startTime
         * @param {?=} _elementTimelineStylesLookup
         */
        function TimelineBuilder(_driver, element, startTime, _elementTimelineStylesLookup) {
            this._driver = _driver;
            this.element = element;
            this.startTime = startTime;
            this._elementTimelineStylesLookup = _elementTimelineStylesLookup;
            this.duration = 0;
            this._previousKeyframe = {};
            this._currentKeyframe = {};
            this._keyframes = new Map();
            this._styleSummary = {};
            this._pendingStyles = {};
            this._backFill = {};
            this._currentEmptyStepKeyframe = null;
            if (!this._elementTimelineStylesLookup) {
                this._elementTimelineStylesLookup = new Map();
            }
            this._localTimelineStyles = Object.create(this._backFill, {});
            this._globalTimelineStyles = ( /** @type {?} */(this._elementTimelineStylesLookup.get(element)));
            if (!this._globalTimelineStyles) {
                this._globalTimelineStyles = this._localTimelineStyles;
                this._elementTimelineStylesLookup.set(element, this._localTimelineStyles);
            }
            this._loadKeyframe();
        }
        /**
         * @return {?}
         */
        TimelineBuilder.prototype.containsAnimation = function () {
            switch (this._keyframes.size) {
                case 0:
                    return false;
                case 1:
                    return this.getCurrentStyleProperties().length > 0;
                default:
                    return true;
            }
        };
        /**
         * @return {?}
         */
        TimelineBuilder.prototype.getCurrentStyleProperties = function () { return Object.keys(this._currentKeyframe); };
        Object.defineProperty(TimelineBuilder.prototype, "currentTime", {
            /**
             * @return {?}
             */
            get: function () { return this.startTime + this.duration; },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} delay
         * @return {?}
         */
        TimelineBuilder.prototype.delayNextStep = function (delay) {
            // in the event that a style() step is placed right before a stagger()
            // and that style() step is the very first style() value in the animation
            // then we need to make a copy of the keyframe [0, copy, 1] so that the delay
            // properly applies the style() values to work with the stagger...
            /** @type {?} */
            var hasPreStyleStep = this._keyframes.size == 1 && Object.keys(this._pendingStyles).length;
            if (this.duration || hasPreStyleStep) {
                this.forwardTime(this.currentTime + delay);
                if (hasPreStyleStep) {
                    this.snapshotCurrentStyles();
                }
            }
            else {
                this.startTime += delay;
            }
        };
        /**
         * @param {?} element
         * @param {?=} currentTime
         * @return {?}
         */
        TimelineBuilder.prototype.fork = function (element, currentTime) {
            this.applyStylesToKeyframe();
            return new TimelineBuilder(this._driver, element, currentTime || this.currentTime, this._elementTimelineStylesLookup);
        };
        /**
         * @private
         * @return {?}
         */
        TimelineBuilder.prototype._loadKeyframe = function () {
            if (this._currentKeyframe) {
                this._previousKeyframe = this._currentKeyframe;
            }
            this._currentKeyframe = ( /** @type {?} */(this._keyframes.get(this.duration)));
            if (!this._currentKeyframe) {
                this._currentKeyframe = Object.create(this._backFill, {});
                this._keyframes.set(this.duration, this._currentKeyframe);
            }
        };
        /**
         * @return {?}
         */
        TimelineBuilder.prototype.forwardFrame = function () {
            this.duration += ONE_FRAME_IN_MILLISECONDS;
            this._loadKeyframe();
        };
        /**
         * @param {?} time
         * @return {?}
         */
        TimelineBuilder.prototype.forwardTime = function (time) {
            this.applyStylesToKeyframe();
            this.duration = time;
            this._loadKeyframe();
        };
        /**
         * @private
         * @param {?} prop
         * @param {?} value
         * @return {?}
         */
        TimelineBuilder.prototype._updateStyle = function (prop, value) {
            this._localTimelineStyles[prop] = value;
            this._globalTimelineStyles[prop] = value;
            this._styleSummary[prop] = { time: this.currentTime, value: value };
        };
        /**
         * @return {?}
         */
        TimelineBuilder.prototype.allowOnlyTimelineStyles = function () { return this._currentEmptyStepKeyframe !== this._currentKeyframe; };
        /**
         * @param {?} easing
         * @return {?}
         */
        TimelineBuilder.prototype.applyEmptyStep = function (easing) {
            var _this = this;
            if (easing) {
                this._previousKeyframe['easing'] = easing;
            }
            // special case for animate(duration):
            // all missing styles are filled with a `*` value then
            // if any destination styles are filled in later on the same
            // keyframe then they will override the overridden styles
            // We use `_globalTimelineStyles` here because there may be
            // styles in previous keyframes that are not present in this timeline
            Object.keys(this._globalTimelineStyles).forEach(( /**
             * @param {?} prop
             * @return {?}
             */function (/**
             * @param {?} prop
             * @return {?}
             */ prop) {
                _this._backFill[prop] = _this._globalTimelineStyles[prop] || AUTO_STYLE;
                _this._currentKeyframe[prop] = AUTO_STYLE;
            }));
            this._currentEmptyStepKeyframe = this._currentKeyframe;
        };
        /**
         * @param {?} input
         * @param {?} easing
         * @param {?} errors
         * @param {?=} options
         * @return {?}
         */
        TimelineBuilder.prototype.setStyles = function (input, easing, errors, options) {
            var _this = this;
            if (easing) {
                this._previousKeyframe['easing'] = easing;
            }
            /** @type {?} */
            var params = (options && options.params) || {};
            /** @type {?} */
            var styles = flattenStyles$1(input, this._globalTimelineStyles);
            Object.keys(styles).forEach(( /**
             * @param {?} prop
             * @return {?}
             */function (/**
             * @param {?} prop
             * @return {?}
             */ prop) {
                /** @type {?} */
                var val = interpolateParams(styles[prop], params, errors);
                _this._pendingStyles[prop] = val;
                if (!_this._localTimelineStyles.hasOwnProperty(prop)) {
                    _this._backFill[prop] = _this._globalTimelineStyles.hasOwnProperty(prop) ?
                        _this._globalTimelineStyles[prop] :
                        AUTO_STYLE;
                }
                _this._updateStyle(prop, val);
            }));
        };
        /**
         * @return {?}
         */
        TimelineBuilder.prototype.applyStylesToKeyframe = function () {
            var _this = this;
            /** @type {?} */
            var styles = this._pendingStyles;
            /** @type {?} */
            var props = Object.keys(styles);
            if (props.length == 0)
                return;
            this._pendingStyles = {};
            props.forEach(( /**
             * @param {?} prop
             * @return {?}
             */function (/**
             * @param {?} prop
             * @return {?}
             */ prop) {
                /** @type {?} */
                var val = styles[prop];
                _this._currentKeyframe[prop] = val;
            }));
            Object.keys(this._localTimelineStyles).forEach(( /**
             * @param {?} prop
             * @return {?}
             */function (/**
             * @param {?} prop
             * @return {?}
             */ prop) {
                if (!_this._currentKeyframe.hasOwnProperty(prop)) {
                    _this._currentKeyframe[prop] = _this._localTimelineStyles[prop];
                }
            }));
        };
        /**
         * @return {?}
         */
        TimelineBuilder.prototype.snapshotCurrentStyles = function () {
            var _this = this;
            Object.keys(this._localTimelineStyles).forEach(( /**
             * @param {?} prop
             * @return {?}
             */function (/**
             * @param {?} prop
             * @return {?}
             */ prop) {
                /** @type {?} */
                var val = _this._localTimelineStyles[prop];
                _this._pendingStyles[prop] = val;
                _this._updateStyle(prop, val);
            }));
        };
        /**
         * @return {?}
         */
        TimelineBuilder.prototype.getFinalKeyframe = function () { return this._keyframes.get(this.duration); };
        Object.defineProperty(TimelineBuilder.prototype, "properties", {
            /**
             * @return {?}
             */
            get: function () {
                /** @type {?} */
                var properties = [];
                for (var prop in this._currentKeyframe) {
                    properties.push(prop);
                }
                return properties;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} timeline
         * @return {?}
         */
        TimelineBuilder.prototype.mergeTimelineCollectedStyles = function (timeline) {
            var _this = this;
            Object.keys(timeline._styleSummary).forEach(( /**
             * @param {?} prop
             * @return {?}
             */function (/**
             * @param {?} prop
             * @return {?}
             */ prop) {
                /** @type {?} */
                var details0 = _this._styleSummary[prop];
                /** @type {?} */
                var details1 = timeline._styleSummary[prop];
                if (!details0 || details1.time > details0.time) {
                    _this._updateStyle(prop, details1.value);
                }
            }));
        };
        /**
         * @return {?}
         */
        TimelineBuilder.prototype.buildKeyframes = function () {
            var _this = this;
            this.applyStylesToKeyframe();
            /** @type {?} */
            var preStyleProps = new Set();
            /** @type {?} */
            var postStyleProps = new Set();
            /** @type {?} */
            var isEmpty = this._keyframes.size === 1 && this.duration === 0;
            /** @type {?} */
            var finalKeyframes = [];
            this._keyframes.forEach(( /**
             * @param {?} keyframe
             * @param {?} time
             * @return {?}
             */function (keyframe, time) {
                /** @type {?} */
                var finalKeyframe = copyStyles(keyframe, true);
                Object.keys(finalKeyframe).forEach(( /**
                 * @param {?} prop
                 * @return {?}
                 */function (/**
                 * @param {?} prop
                 * @return {?}
                 */ prop) {
                    /** @type {?} */
                    var value = finalKeyframe[prop];
                    if (value == ɵPRE_STYLE) {
                        preStyleProps.add(prop);
                    }
                    else if (value == AUTO_STYLE) {
                        postStyleProps.add(prop);
                    }
                }));
                if (!isEmpty) {
                    finalKeyframe['offset'] = time / _this.duration;
                }
                finalKeyframes.push(finalKeyframe);
            }));
            /** @type {?} */
            var preProps = preStyleProps.size ? iteratorToArray(preStyleProps.values()) : [];
            /** @type {?} */
            var postProps = postStyleProps.size ? iteratorToArray(postStyleProps.values()) : [];
            // special case for a 0-second animation (which is designed just to place styles onscreen)
            if (isEmpty) {
                /** @type {?} */
                var kf0 = finalKeyframes[0];
                /** @type {?} */
                var kf1 = copyObj(kf0);
                kf0['offset'] = 0;
                kf1['offset'] = 1;
                finalKeyframes = [kf0, kf1];
            }
            return createTimelineInstruction(this.element, finalKeyframes, preProps, postProps, this.duration, this.startTime, this.easing, false);
        };
        return TimelineBuilder;
    }());
    var SubTimelineBuilder = /** @class */ (function (_super) {
        __extends(SubTimelineBuilder, _super);
        /**
         * @param {?} driver
         * @param {?} element
         * @param {?} keyframes
         * @param {?} preStyleProps
         * @param {?} postStyleProps
         * @param {?} timings
         * @param {?=} _stretchStartingKeyframe
         */
        function SubTimelineBuilder(driver, element, keyframes, preStyleProps, postStyleProps, timings, _stretchStartingKeyframe) {
            if (_stretchStartingKeyframe === void 0) { _stretchStartingKeyframe = false; }
            var _this = _super.call(this, driver, element, timings.delay) || this;
            _this.element = element;
            _this.keyframes = keyframes;
            _this.preStyleProps = preStyleProps;
            _this.postStyleProps = postStyleProps;
            _this._stretchStartingKeyframe = _stretchStartingKeyframe;
            _this.timings = { duration: timings.duration, delay: timings.delay, easing: timings.easing };
            return _this;
        }
        /**
         * @return {?}
         */
        SubTimelineBuilder.prototype.containsAnimation = function () { return this.keyframes.length > 1; };
        /**
         * @return {?}
         */
        SubTimelineBuilder.prototype.buildKeyframes = function () {
            /** @type {?} */
            var keyframes = this.keyframes;
            var _b = this.timings, delay = _b.delay, duration = _b.duration, easing = _b.easing;
            if (this._stretchStartingKeyframe && delay) {
                /** @type {?} */
                var newKeyframes = [];
                /** @type {?} */
                var totalTime = duration + delay;
                /** @type {?} */
                var startingGap = delay / totalTime;
                // the original starting keyframe now starts once the delay is done
                /** @type {?} */
                var newFirstKeyframe = copyStyles(keyframes[0], false);
                newFirstKeyframe['offset'] = 0;
                newKeyframes.push(newFirstKeyframe);
                /** @type {?} */
                var oldFirstKeyframe = copyStyles(keyframes[0], false);
                oldFirstKeyframe['offset'] = roundOffset(startingGap);
                newKeyframes.push(oldFirstKeyframe);
                /*
                        When the keyframe is stretched then it means that the delay before the animation
                        starts is gone. Instead the first keyframe is placed at the start of the animation
                        and it is then copied to where it starts when the original delay is over. This basically
                        means nothing animates during that delay, but the styles are still renderered. For this
                        to work the original offset values that exist in the original keyframes must be "warped"
                        so that they can take the new keyframe + delay into account.
                
                        delay=1000, duration=1000, keyframes = 0 .5 1
                
                        turns into
                
                        delay=0, duration=2000, keyframes = 0 .33 .66 1
                       */
                // offsets between 1 ... n -1 are all warped by the keyframe stretch
                /** @type {?} */
                var limit = keyframes.length - 1;
                for (var i_130 = 1; i_130 <= limit; i_130++) {
                    /** @type {?} */
                    var kf = copyStyles(keyframes[i_130], false);
                    /** @type {?} */
                    var oldOffset = ( /** @type {?} */(kf['offset']));
                    /** @type {?} */
                    var timeAtKeyframe = delay + oldOffset * duration;
                    kf['offset'] = roundOffset(timeAtKeyframe / totalTime);
                    newKeyframes.push(kf);
                }
                // the new starting keyframe should be added at the start
                duration = totalTime;
                delay = 0;
                easing = '';
                keyframes = newKeyframes;
            }
            return createTimelineInstruction(this.element, keyframes, this.preStyleProps, this.postStyleProps, duration, delay, easing, true);
        };
        return SubTimelineBuilder;
    }(TimelineBuilder));
    /**
     * @param {?} offset
     * @param {?=} decimalPoints
     * @return {?}
     */
    function roundOffset(offset, decimalPoints) {
        if (decimalPoints === void 0) { decimalPoints = 3; }
        /** @type {?} */
        var mult = Math.pow(10, decimalPoints - 1);
        return Math.round(offset * mult) / mult;
    }
    /**
     * @param {?} input
     * @param {?} allStyles
     * @return {?}
     */
    function flattenStyles$1(input, allStyles) {
        /** @type {?} */
        var styles = {};
        /** @type {?} */
        var allProperties;
        input.forEach(( /**
         * @param {?} token
         * @return {?}
         */function (/**
         * @param {?} token
         * @return {?}
         */ token) {
            if (token === '*') {
                allProperties = allProperties || Object.keys(allStyles);
                allProperties.forEach(( /**
                 * @param {?} prop
                 * @return {?}
                 */function (/**
                 * @param {?} prop
                 * @return {?}
                 */ prop) { styles[prop] = AUTO_STYLE; }));
            }
            else {
                copyStyles(( /** @type {?} */(token)), false, styles);
            }
        }));
        return styles;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * \@publicApi
     * @abstract
     */
    var AnimationStyleNormalizer = /** @class */ (function () {
        function AnimationStyleNormalizer() {
        }
        return AnimationStyleNormalizer;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var WebAnimationsStyleNormalizer = /** @class */ (function (_super) {
        __extends(WebAnimationsStyleNormalizer, _super);
        function WebAnimationsStyleNormalizer() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @param {?} propertyName
         * @param {?} errors
         * @return {?}
         */
        WebAnimationsStyleNormalizer.prototype.normalizePropertyName = function (propertyName, errors) {
            return dashCaseToCamelCase(propertyName);
        };
        /**
         * @param {?} userProvidedProperty
         * @param {?} normalizedProperty
         * @param {?} value
         * @param {?} errors
         * @return {?}
         */
        WebAnimationsStyleNormalizer.prototype.normalizeStyleValue = function (userProvidedProperty, normalizedProperty, value, errors) {
            /** @type {?} */
            var unit = '';
            /** @type {?} */
            var strVal = value.toString().trim();
            if (DIMENSIONAL_PROP_MAP[normalizedProperty] && value !== 0 && value !== '0') {
                if (typeof value === 'number') {
                    unit = 'px';
                }
                else {
                    /** @type {?} */
                    var valAndSuffixMatch = value.match(/^[+-]?[\d\.]+([a-z]*)$/);
                    if (valAndSuffixMatch && valAndSuffixMatch[1].length == 0) {
                        errors.push("Please provide a CSS unit value for " + userProvidedProperty + ":" + value);
                    }
                }
            }
            return strVal + unit;
        };
        return WebAnimationsStyleNormalizer;
    }(AnimationStyleNormalizer));
    var ɵ0$1$3 = /**
     * @return {?}
     */ function () { return makeBooleanMap('width,height,minWidth,minHeight,maxWidth,maxHeight,left,top,bottom,right,fontSize,outlineWidth,outlineOffset,paddingTop,paddingLeft,paddingBottom,paddingRight,marginTop,marginLeft,marginBottom,marginRight,borderRadius,borderWidth,borderTopWidth,borderLeftWidth,borderRightWidth,borderBottomWidth,textIndent,perspective'
        .split(',')); };
    /** @type {?} */
    var DIMENSIONAL_PROP_MAP = ((ɵ0$1$3))();
    /**
     * @param {?} keys
     * @return {?}
     */
    function makeBooleanMap(keys) {
        /** @type {?} */
        var map = {};
        keys.forEach(( /**
         * @param {?} key
         * @return {?}
         */function (/**
         * @param {?} key
         * @return {?}
         */ key) { return map[key] = true; }));
        return map;
    }
    /**
     * @param {?} element
     * @param {?} triggerName
     * @param {?} fromState
     * @param {?} toState
     * @param {?} isRemovalTransition
     * @param {?} fromStyles
     * @param {?} toStyles
     * @param {?} timelines
     * @param {?} queriedElements
     * @param {?} preStyleProps
     * @param {?} postStyleProps
     * @param {?} totalTime
     * @param {?=} errors
     * @return {?}
     */
    function createTransitionInstruction(element, triggerName, fromState, toState, isRemovalTransition, fromStyles, toStyles, timelines, queriedElements, preStyleProps, postStyleProps, totalTime, errors) {
        return {
            type: 0 /* TransitionAnimation */,
            element: element,
            triggerName: triggerName,
            isRemovalTransition: isRemovalTransition,
            fromState: fromState,
            fromStyles: fromStyles,
            toState: toState,
            toStyles: toStyles,
            timelines: timelines,
            queriedElements: queriedElements,
            preStyleProps: preStyleProps,
            postStyleProps: postStyleProps,
            totalTime: totalTime,
            errors: errors
        };
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var EMPTY_OBJECT = {};
    var AnimationTransitionFactory = /** @class */ (function () {
        /**
         * @param {?} _triggerName
         * @param {?} ast
         * @param {?} _stateStyles
         */
        function AnimationTransitionFactory(_triggerName, ast, _stateStyles) {
            this._triggerName = _triggerName;
            this.ast = ast;
            this._stateStyles = _stateStyles;
        }
        /**
         * @param {?} currentState
         * @param {?} nextState
         * @param {?} element
         * @param {?} params
         * @return {?}
         */
        AnimationTransitionFactory.prototype.match = function (currentState, nextState, element, params) {
            return oneOrMoreTransitionsMatch(this.ast.matchers, currentState, nextState, element, params);
        };
        /**
         * @param {?} stateName
         * @param {?} params
         * @param {?} errors
         * @return {?}
         */
        AnimationTransitionFactory.prototype.buildStyles = function (stateName, params, errors) {
            /** @type {?} */
            var backupStateStyler = this._stateStyles['*'];
            /** @type {?} */
            var stateStyler = this._stateStyles[stateName];
            /** @type {?} */
            var backupStyles = backupStateStyler ? backupStateStyler.buildStyles(params, errors) : {};
            return stateStyler ? stateStyler.buildStyles(params, errors) : backupStyles;
        };
        /**
         * @param {?} driver
         * @param {?} element
         * @param {?} currentState
         * @param {?} nextState
         * @param {?} enterClassName
         * @param {?} leaveClassName
         * @param {?=} currentOptions
         * @param {?=} nextOptions
         * @param {?=} subInstructions
         * @param {?=} skipAstBuild
         * @return {?}
         */
        AnimationTransitionFactory.prototype.build = function (driver, element, currentState, nextState, enterClassName, leaveClassName, currentOptions, nextOptions, subInstructions, skipAstBuild) {
            /** @type {?} */
            var errors = [];
            /** @type {?} */
            var transitionAnimationParams = this.ast.options && this.ast.options.params || EMPTY_OBJECT;
            /** @type {?} */
            var currentAnimationParams = currentOptions && currentOptions.params || EMPTY_OBJECT;
            /** @type {?} */
            var currentStateStyles = this.buildStyles(currentState, currentAnimationParams, errors);
            /** @type {?} */
            var nextAnimationParams = nextOptions && nextOptions.params || EMPTY_OBJECT;
            /** @type {?} */
            var nextStateStyles = this.buildStyles(nextState, nextAnimationParams, errors);
            /** @type {?} */
            var queriedElements = new Set();
            /** @type {?} */
            var preStyleMap = new Map();
            /** @type {?} */
            var postStyleMap = new Map();
            /** @type {?} */
            var isRemoval = nextState === 'void';
            /** @type {?} */
            var animationOptions = { params: Object.assign({}, transitionAnimationParams, nextAnimationParams) };
            /** @type {?} */
            var timelines = skipAstBuild ? [] : buildAnimationTimelines(driver, element, this.ast.animation, enterClassName, leaveClassName, currentStateStyles, nextStateStyles, animationOptions, subInstructions, errors);
            /** @type {?} */
            var totalTime = 0;
            timelines.forEach(( /**
             * @param {?} tl
             * @return {?}
             */function (/**
             * @param {?} tl
             * @return {?}
             */ tl) { totalTime = Math.max(tl.duration + tl.delay, totalTime); }));
            if (errors.length) {
                return createTransitionInstruction(element, this._triggerName, currentState, nextState, isRemoval, currentStateStyles, nextStateStyles, [], [], preStyleMap, postStyleMap, totalTime, errors);
            }
            timelines.forEach(( /**
             * @param {?} tl
             * @return {?}
             */function (/**
             * @param {?} tl
             * @return {?}
             */ tl) {
                /** @type {?} */
                var elm = tl.element;
                /** @type {?} */
                var preProps = getOrSetAsInMap(preStyleMap, elm, {});
                tl.preStyleProps.forEach(( /**
                 * @param {?} prop
                 * @return {?}
                 */function (/**
                 * @param {?} prop
                 * @return {?}
                 */ prop) { return preProps[prop] = true; }));
                /** @type {?} */
                var postProps = getOrSetAsInMap(postStyleMap, elm, {});
                tl.postStyleProps.forEach(( /**
                 * @param {?} prop
                 * @return {?}
                 */function (/**
                 * @param {?} prop
                 * @return {?}
                 */ prop) { return postProps[prop] = true; }));
                if (elm !== element) {
                    queriedElements.add(elm);
                }
            }));
            /** @type {?} */
            var queriedElementsList = iteratorToArray(queriedElements.values());
            return createTransitionInstruction(element, this._triggerName, currentState, nextState, isRemoval, currentStateStyles, nextStateStyles, timelines, queriedElementsList, preStyleMap, postStyleMap, totalTime);
        };
        return AnimationTransitionFactory;
    }());
    /**
     * @param {?} matchFns
     * @param {?} currentState
     * @param {?} nextState
     * @param {?} element
     * @param {?} params
     * @return {?}
     */
    function oneOrMoreTransitionsMatch(matchFns, currentState, nextState, element, params) {
        return matchFns.some(( /**
         * @param {?} fn
         * @return {?}
         */function (/**
         * @param {?} fn
         * @return {?}
         */ fn) { return fn(currentState, nextState, element, params); }));
    }
    var AnimationStateStyles = /** @class */ (function () {
        /**
         * @param {?} styles
         * @param {?} defaultParams
         */
        function AnimationStateStyles(styles, defaultParams) {
            this.styles = styles;
            this.defaultParams = defaultParams;
        }
        /**
         * @param {?} params
         * @param {?} errors
         * @return {?}
         */
        AnimationStateStyles.prototype.buildStyles = function (params, errors) {
            /** @type {?} */
            var finalStyles = {};
            /** @type {?} */
            var combinedParams = copyObj(this.defaultParams);
            Object.keys(params).forEach(( /**
             * @param {?} key
             * @return {?}
             */function (/**
             * @param {?} key
             * @return {?}
             */ key) {
                /** @type {?} */
                var value = params[key];
                if (value != null) {
                    combinedParams[key] = value;
                }
            }));
            this.styles.styles.forEach(( /**
             * @param {?} value
             * @return {?}
             */function (/**
             * @param {?} value
             * @return {?}
             */ value) {
                if (typeof value !== 'string') {
                    /** @type {?} */
                    var styleObj_1 = ( /** @type {?} */(value));
                    Object.keys(styleObj_1).forEach(( /**
                     * @param {?} prop
                     * @return {?}
                     */function (/**
                     * @param {?} prop
                     * @return {?}
                     */ prop) {
                        /** @type {?} */
                        var val = styleObj_1[prop];
                        if (val.length > 1) {
                            val = interpolateParams(val, combinedParams, errors);
                        }
                        finalStyles[prop] = val;
                    }));
                }
            }));
            return finalStyles;
        };
        return AnimationStateStyles;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@publicApi
     * @param {?} name
     * @param {?} ast
     * @return {?}
     */
    function buildTrigger(name, ast) {
        return new AnimationTrigger(name, ast);
    }
    /**
     * \@publicApi
     */
    var AnimationTrigger = /** @class */ (function () {
        /**
         * @param {?} name
         * @param {?} ast
         */
        function AnimationTrigger(name, ast) {
            var _this = this;
            this.name = name;
            this.ast = ast;
            this.transitionFactories = [];
            this.states = {};
            ast.states.forEach(( /**
             * @param {?} ast
             * @return {?}
             */function (/**
             * @param {?} ast
             * @return {?}
             */ ast) {
                /** @type {?} */
                var defaultParams = (ast.options && ast.options.params) || {};
                _this.states[ast.name] = new AnimationStateStyles(ast.style, defaultParams);
            }));
            balanceProperties(this.states, 'true', '1');
            balanceProperties(this.states, 'false', '0');
            ast.transitions.forEach(( /**
             * @param {?} ast
             * @return {?}
             */function (/**
             * @param {?} ast
             * @return {?}
             */ ast) {
                _this.transitionFactories.push(new AnimationTransitionFactory(name, ast, _this.states));
            }));
            this.fallbackTransition = createFallbackTransition(name, this.states);
        }
        Object.defineProperty(AnimationTrigger.prototype, "containsQueries", {
            /**
             * @return {?}
             */
            get: function () { return this.ast.queryCount > 0; },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} currentState
         * @param {?} nextState
         * @param {?} element
         * @param {?} params
         * @return {?}
         */
        AnimationTrigger.prototype.matchTransition = function (currentState, nextState, element, params) {
            /** @type {?} */
            var entry = this.transitionFactories.find(( /**
             * @param {?} f
             * @return {?}
             */function (/**
             * @param {?} f
             * @return {?}
             */ f) { return f.match(currentState, nextState, element, params); }));
            return entry || null;
        };
        /**
         * @param {?} currentState
         * @param {?} params
         * @param {?} errors
         * @return {?}
         */
        AnimationTrigger.prototype.matchStyles = function (currentState, params, errors) {
            return this.fallbackTransition.buildStyles(currentState, params, errors);
        };
        return AnimationTrigger;
    }());
    /**
     * @param {?} triggerName
     * @param {?} states
     * @return {?}
     */
    function createFallbackTransition(triggerName, states) {
        /** @type {?} */
        var matchers = [( /**
                 * @param {?} fromState
                 * @param {?} toState
                 * @return {?}
                 */function (fromState, toState) { return true; })];
        /** @type {?} */
        var animation = { type: 2 /* Sequence */, steps: [], options: null };
        /** @type {?} */
        var transition = {
            type: 1 /* Transition */,
            animation: animation,
            matchers: matchers,
            options: null,
            queryCount: 0,
            depCount: 0
        };
        return new AnimationTransitionFactory(triggerName, transition, states);
    }
    /**
     * @param {?} obj
     * @param {?} key1
     * @param {?} key2
     * @return {?}
     */
    function balanceProperties(obj, key1, key2) {
        if (obj.hasOwnProperty(key1)) {
            if (!obj.hasOwnProperty(key2)) {
                obj[key2] = obj[key1];
            }
        }
        else if (obj.hasOwnProperty(key2)) {
            obj[key1] = obj[key2];
        }
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var EMPTY_INSTRUCTION_MAP = new ElementInstructionMap();
    var TimelineAnimationEngine = /** @class */ (function () {
        /**
         * @param {?} bodyNode
         * @param {?} _driver
         * @param {?} _normalizer
         */
        function TimelineAnimationEngine(bodyNode, _driver, _normalizer) {
            this.bodyNode = bodyNode;
            this._driver = _driver;
            this._normalizer = _normalizer;
            this._animations = {};
            this._playersById = {};
            this.players = [];
        }
        /**
         * @param {?} id
         * @param {?} metadata
         * @return {?}
         */
        TimelineAnimationEngine.prototype.register = function (id, metadata) {
            /** @type {?} */
            var errors = [];
            /** @type {?} */
            var ast = buildAnimationAst(this._driver, metadata, errors);
            if (errors.length) {
                throw new Error("Unable to build the animation due to the following errors: " + errors.join("\n"));
            }
            else {
                this._animations[id] = ast;
            }
        };
        /**
         * @private
         * @param {?} i
         * @param {?} preStyles
         * @param {?=} postStyles
         * @return {?}
         */
        TimelineAnimationEngine.prototype._buildPlayer = function (i, preStyles, postStyles) {
            /** @type {?} */
            var element = i.element;
            /** @type {?} */
            var keyframes = normalizeKeyframes(this._driver, this._normalizer, element, i.keyframes, preStyles, postStyles);
            return this._driver.animate(element, keyframes, i.duration, i.delay, i.easing, [], true);
        };
        /**
         * @param {?} id
         * @param {?} element
         * @param {?=} options
         * @return {?}
         */
        TimelineAnimationEngine.prototype.create = function (id, element, options) {
            var _this = this;
            if (options === void 0) { options = {}; }
            /** @type {?} */
            var errors = [];
            /** @type {?} */
            var ast = this._animations[id];
            /** @type {?} */
            var instructions;
            /** @type {?} */
            var autoStylesMap = new Map();
            if (ast) {
                instructions = buildAnimationTimelines(this._driver, element, ast, ENTER_CLASSNAME, LEAVE_CLASSNAME, {}, {}, options, EMPTY_INSTRUCTION_MAP, errors);
                instructions.forEach(( /**
                 * @param {?} inst
                 * @return {?}
                 */function (/**
                 * @param {?} inst
                 * @return {?}
                 */ inst) {
                    /** @type {?} */
                    var styles = getOrSetAsInMap(autoStylesMap, inst.element, {});
                    inst.postStyleProps.forEach(( /**
                     * @param {?} prop
                     * @return {?}
                     */function (/**
                     * @param {?} prop
                     * @return {?}
                     */ prop) { return styles[prop] = null; }));
                }));
            }
            else {
                errors.push('The requested animation doesn\'t exist or has already been destroyed');
                instructions = [];
            }
            if (errors.length) {
                throw new Error("Unable to create the animation due to the following errors: " + errors.join("\n"));
            }
            autoStylesMap.forEach(( /**
             * @param {?} styles
             * @param {?} element
             * @return {?}
             */function (styles, element) {
                Object.keys(styles).forEach(( /**
                 * @param {?} prop
                 * @return {?}
                 */function (/**
                 * @param {?} prop
                 * @return {?}
                 */ prop) { styles[prop] = _this._driver.computeStyle(element, prop, AUTO_STYLE); }));
            }));
            /** @type {?} */
            var players = instructions.map(( /**
             * @param {?} i
             * @return {?}
             */function (/**
             * @param {?} i
             * @return {?}
             */ i) {
                /** @type {?} */
                var styles = autoStylesMap.get(i.element);
                return _this._buildPlayer(i, {}, styles);
            }));
            /** @type {?} */
            var player = optimizeGroupPlayer(players);
            this._playersById[id] = player;
            player.onDestroy(( /**
             * @return {?}
             */function () { return _this.destroy(id); }));
            this.players.push(player);
            return player;
        };
        /**
         * @param {?} id
         * @return {?}
         */
        TimelineAnimationEngine.prototype.destroy = function (id) {
            /** @type {?} */
            var player = this._getPlayer(id);
            player.destroy();
            delete this._playersById[id];
            /** @type {?} */
            var index = this.players.indexOf(player);
            if (index >= 0) {
                this.players.splice(index, 1);
            }
        };
        /**
         * @private
         * @param {?} id
         * @return {?}
         */
        TimelineAnimationEngine.prototype._getPlayer = function (id) {
            /** @type {?} */
            var player = this._playersById[id];
            if (!player) {
                throw new Error("Unable to find the timeline player referenced by " + id);
            }
            return player;
        };
        /**
         * @param {?} id
         * @param {?} element
         * @param {?} eventName
         * @param {?} callback
         * @return {?}
         */
        TimelineAnimationEngine.prototype.listen = function (id, element, eventName, callback) {
            // triggerName, fromState, toState are all ignored for timeline animations
            /** @type {?} */
            var baseEvent = makeAnimationEvent(element, '', '', '');
            listenOnPlayer(this._getPlayer(id), eventName, baseEvent, callback);
            return ( /**
             * @return {?}
             */function () { });
        };
        /**
         * @param {?} id
         * @param {?} element
         * @param {?} command
         * @param {?} args
         * @return {?}
         */
        TimelineAnimationEngine.prototype.command = function (id, element, command, args) {
            if (command == 'register') {
                this.register(id, ( /** @type {?} */(args[0])));
                return;
            }
            if (command == 'create') {
                /** @type {?} */
                var options = ( /** @type {?} */((args[0] || {})));
                this.create(id, element, options);
                return;
            }
            /** @type {?} */
            var player = this._getPlayer(id);
            switch (command) {
                case 'play':
                    player.play();
                    break;
                case 'pause':
                    player.pause();
                    break;
                case 'reset':
                    player.reset();
                    break;
                case 'restart':
                    player.restart();
                    break;
                case 'finish':
                    player.finish();
                    break;
                case 'init':
                    player.init();
                    break;
                case 'setPosition':
                    player.setPosition(parseFloat(( /** @type {?} */(args[0]))));
                    break;
                case 'destroy':
                    this.destroy(id);
                    break;
            }
        };
        return TimelineAnimationEngine;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var QUEUED_CLASSNAME = 'ng-animate-queued';
    /** @type {?} */
    var QUEUED_SELECTOR = '.ng-animate-queued';
    /** @type {?} */
    var DISABLED_CLASSNAME = 'ng-animate-disabled';
    /** @type {?} */
    var DISABLED_SELECTOR = '.ng-animate-disabled';
    /** @type {?} */
    var STAR_CLASSNAME = 'ng-star-inserted';
    /** @type {?} */
    var STAR_SELECTOR = '.ng-star-inserted';
    /** @type {?} */
    var EMPTY_PLAYER_ARRAY = [];
    /** @type {?} */
    var NULL_REMOVAL_STATE = {
        namespaceId: '',
        setForRemoval: false,
        setForMove: false,
        hasAnimation: false,
        removedBeforeQueried: false
    };
    /** @type {?} */
    var NULL_REMOVED_QUERIED_STATE = {
        namespaceId: '',
        setForMove: false,
        setForRemoval: false,
        hasAnimation: false,
        removedBeforeQueried: true
    };
    /** @type {?} */
    var REMOVAL_FLAG = '__ng_removed';
    var StateValue = /** @class */ (function () {
        /**
         * @param {?} input
         * @param {?=} namespaceId
         */
        function StateValue(input, namespaceId) {
            if (namespaceId === void 0) { namespaceId = ''; }
            this.namespaceId = namespaceId;
            /** @type {?} */
            var isObj = input && input.hasOwnProperty('value');
            /** @type {?} */
            var value = isObj ? input['value'] : input;
            this.value = normalizeTriggerValue(value);
            if (isObj) {
                /** @type {?} */
                var options = copyObj(( /** @type {?} */(input)));
                delete options['value'];
                this.options = ( /** @type {?} */(options));
            }
            else {
                this.options = {};
            }
            if (!this.options.params) {
                this.options.params = {};
            }
        }
        Object.defineProperty(StateValue.prototype, "params", {
            /**
             * @return {?}
             */
            get: function () { return ( /** @type {?} */(this.options.params)); },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} options
         * @return {?}
         */
        StateValue.prototype.absorbOptions = function (options) {
            /** @type {?} */
            var newParams = options.params;
            if (newParams) {
                /** @type {?} */
                var oldParams_2 = ( /** @type {?} */(this.options.params));
                Object.keys(newParams).forEach(( /**
                 * @param {?} prop
                 * @return {?}
                 */function (/**
                 * @param {?} prop
                 * @return {?}
                 */ prop) {
                    if (oldParams_2[prop] == null) {
                        oldParams_2[prop] = newParams[prop];
                    }
                }));
            }
        };
        return StateValue;
    }());
    /** @type {?} */
    var VOID_VALUE = 'void';
    /** @type {?} */
    var DEFAULT_STATE_VALUE = new StateValue(VOID_VALUE);
    var AnimationTransitionNamespace = /** @class */ (function () {
        /**
         * @param {?} id
         * @param {?} hostElement
         * @param {?} _engine
         */
        function AnimationTransitionNamespace(id, hostElement, _engine) {
            this.id = id;
            this.hostElement = hostElement;
            this._engine = _engine;
            this.players = [];
            this._triggers = {};
            this._queue = [];
            this._elementListeners = new Map();
            this._hostClassName = 'ng-tns-' + id;
            addClass(hostElement, this._hostClassName);
        }
        /**
         * @param {?} element
         * @param {?} name
         * @param {?} phase
         * @param {?} callback
         * @return {?}
         */
        AnimationTransitionNamespace.prototype.listen = function (element, name, phase, callback) {
            var _this = this;
            if (!this._triggers.hasOwnProperty(name)) {
                throw new Error("Unable to listen on the animation trigger event \"" + phase + "\" because the animation trigger \"" + name + "\" doesn't exist!");
            }
            if (phase == null || phase.length == 0) {
                throw new Error("Unable to listen on the animation trigger \"" + name + "\" because the provided event is undefined!");
            }
            if (!isTriggerEventValid(phase)) {
                throw new Error("The provided animation trigger event \"" + phase + "\" for the animation trigger \"" + name + "\" is not supported!");
            }
            /** @type {?} */
            var listeners = getOrSetAsInMap(this._elementListeners, element, []);
            /** @type {?} */
            var data = { name: name, phase: phase, callback: callback };
            listeners.push(data);
            /** @type {?} */
            var triggersWithStates = getOrSetAsInMap(this._engine.statesByElement, element, {});
            if (!triggersWithStates.hasOwnProperty(name)) {
                addClass(element, NG_TRIGGER_CLASSNAME);
                addClass(element, NG_TRIGGER_CLASSNAME + '-' + name);
                triggersWithStates[name] = DEFAULT_STATE_VALUE;
            }
            return ( /**
             * @return {?}
             */function () {
                // the event listener is removed AFTER the flush has occurred such
                // that leave animations callbacks can fire (otherwise if the node
                // is removed in between then the listeners would be deregistered)
                _this._engine.afterFlush(( /**
                 * @return {?}
                 */function () {
                    /** @type {?} */
                    var index = listeners.indexOf(data);
                    if (index >= 0) {
                        listeners.splice(index, 1);
                    }
                    if (!_this._triggers[name]) {
                        delete triggersWithStates[name];
                    }
                }));
            });
        };
        /**
         * @param {?} name
         * @param {?} ast
         * @return {?}
         */
        AnimationTransitionNamespace.prototype.register = function (name, ast) {
            if (this._triggers[name]) {
                // throw
                return false;
            }
            else {
                this._triggers[name] = ast;
                return true;
            }
        };
        /**
         * @private
         * @param {?} name
         * @return {?}
         */
        AnimationTransitionNamespace.prototype._getTrigger = function (name) {
            /** @type {?} */
            var trigger = this._triggers[name];
            if (!trigger) {
                throw new Error("The provided animation trigger \"" + name + "\" has not been registered!");
            }
            return trigger;
        };
        /**
         * @param {?} element
         * @param {?} triggerName
         * @param {?} value
         * @param {?=} defaultToFallback
         * @return {?}
         */
        AnimationTransitionNamespace.prototype.trigger = function (element, triggerName, value, defaultToFallback) {
            var _this = this;
            if (defaultToFallback === void 0) { defaultToFallback = true; }
            /** @type {?} */
            var trigger = this._getTrigger(triggerName);
            /** @type {?} */
            var player = new TransitionAnimationPlayer(this.id, triggerName, element);
            /** @type {?} */
            var triggersWithStates = this._engine.statesByElement.get(element);
            if (!triggersWithStates) {
                addClass(element, NG_TRIGGER_CLASSNAME);
                addClass(element, NG_TRIGGER_CLASSNAME + '-' + triggerName);
                this._engine.statesByElement.set(element, triggersWithStates = {});
            }
            /** @type {?} */
            var fromState = triggersWithStates[triggerName];
            /** @type {?} */
            var toState = new StateValue(value, this.id);
            /** @type {?} */
            var isObj = value && value.hasOwnProperty('value');
            if (!isObj && fromState) {
                toState.absorbOptions(fromState.options);
            }
            triggersWithStates[triggerName] = toState;
            if (!fromState) {
                fromState = DEFAULT_STATE_VALUE;
            }
            /** @type {?} */
            var isRemoval = toState.value === VOID_VALUE;
            // normally this isn't reached by here, however, if an object expression
            // is passed in then it may be a new object each time. Comparing the value
            // is important since that will stay the same despite there being a new object.
            // The removal arc here is special cased because the same element is triggered
            // twice in the event that it contains animations on the outer/inner portions
            // of the host container
            if (!isRemoval && fromState.value === toState.value) {
                // this means that despite the value not changing, some inner params
                // have changed which means that the animation final styles need to be applied
                if (!objEquals(fromState.params, toState.params)) {
                    /** @type {?} */
                    var errors = [];
                    /** @type {?} */
                    var fromStyles_1 = trigger.matchStyles(fromState.value, fromState.params, errors);
                    /** @type {?} */
                    var toStyles_1 = trigger.matchStyles(toState.value, toState.params, errors);
                    if (errors.length) {
                        this._engine.reportError(errors);
                    }
                    else {
                        this._engine.afterFlush(( /**
                         * @return {?}
                         */function () {
                            eraseStyles(element, fromStyles_1);
                            setStyles(element, toStyles_1);
                        }));
                    }
                }
                return;
            }
            /** @type {?} */
            var playersOnElement = getOrSetAsInMap(this._engine.playersByElement, element, []);
            playersOnElement.forEach(( /**
             * @param {?} player
             * @return {?}
             */function (/**
             * @param {?} player
             * @return {?}
             */ player) {
                // only remove the player if it is queued on the EXACT same trigger/namespace
                // we only also deal with queued players here because if the animation has
                // started then we want to keep the player alive until the flush happens
                // (which is where the previousPlayers are passed into the new palyer)
                if (player.namespaceId == _this.id && player.triggerName == triggerName && player.queued) {
                    player.destroy();
                }
            }));
            /** @type {?} */
            var transition = trigger.matchTransition(fromState.value, toState.value, element, toState.params);
            /** @type {?} */
            var isFallbackTransition = false;
            if (!transition) {
                if (!defaultToFallback)
                    return;
                transition = trigger.fallbackTransition;
                isFallbackTransition = true;
            }
            this._engine.totalQueuedPlayers++;
            this._queue.push({ element: element, triggerName: triggerName, transition: transition, fromState: fromState, toState: toState, player: player, isFallbackTransition: isFallbackTransition });
            if (!isFallbackTransition) {
                addClass(element, QUEUED_CLASSNAME);
                player.onStart(( /**
                 * @return {?}
                 */function () { removeClass(element, QUEUED_CLASSNAME); }));
            }
            player.onDone(( /**
             * @return {?}
             */function () {
                /** @type {?} */
                var index = _this.players.indexOf(player);
                if (index >= 0) {
                    _this.players.splice(index, 1);
                }
                /** @type {?} */
                var players = _this._engine.playersByElement.get(element);
                if (players) {
                    /** @type {?} */
                    var index_2 = players.indexOf(player);
                    if (index_2 >= 0) {
                        players.splice(index_2, 1);
                    }
                }
            }));
            this.players.push(player);
            playersOnElement.push(player);
            return player;
        };
        /**
         * @param {?} name
         * @return {?}
         */
        AnimationTransitionNamespace.prototype.deregister = function (name) {
            var _this = this;
            delete this._triggers[name];
            this._engine.statesByElement.forEach(( /**
             * @param {?} stateMap
             * @param {?} element
             * @return {?}
             */function (stateMap, element) { delete stateMap[name]; }));
            this._elementListeners.forEach(( /**
             * @param {?} listeners
             * @param {?} element
             * @return {?}
             */function (listeners, element) {
                _this._elementListeners.set(element, listeners.filter(( /**
                 * @param {?} entry
                 * @return {?}
                 */function (/**
                 * @param {?} entry
                 * @return {?}
                 */ entry) { return entry.name != name; })));
            }));
        };
        /**
         * @param {?} element
         * @return {?}
         */
        AnimationTransitionNamespace.prototype.clearElementCache = function (element) {
            this._engine.statesByElement.delete(element);
            this._elementListeners.delete(element);
            /** @type {?} */
            var elementPlayers = this._engine.playersByElement.get(element);
            if (elementPlayers) {
                elementPlayers.forEach(( /**
                 * @param {?} player
                 * @return {?}
                 */function (/**
                 * @param {?} player
                 * @return {?}
                 */ player) { return player.destroy(); }));
                this._engine.playersByElement.delete(element);
            }
        };
        /**
         * @private
         * @param {?} rootElement
         * @param {?} context
         * @param {?=} animate
         * @return {?}
         */
        AnimationTransitionNamespace.prototype._signalRemovalForInnerTriggers = function (rootElement, context, animate) {
            var _this = this;
            if (animate === void 0) { animate = false; }
            // emulate a leave animation for all inner nodes within this node.
            // If there are no animations found for any of the nodes then clear the cache
            // for the element.
            this._engine.driver.query(rootElement, NG_TRIGGER_SELECTOR, true).forEach(( /**
             * @param {?} elm
             * @return {?}
             */function (/**
             * @param {?} elm
             * @return {?}
             */ elm) {
                // this means that an inner remove() operation has already kicked off
                // the animation on this element...
                if (elm[REMOVAL_FLAG])
                    return;
                /** @type {?} */
                var namespaces = _this._engine.fetchNamespacesByElement(elm);
                if (namespaces.size) {
                    namespaces.forEach(( /**
                     * @param {?} ns
                     * @return {?}
                     */function (/**
                     * @param {?} ns
                     * @return {?}
                     */ ns) { return ns.triggerLeaveAnimation(elm, context, false, true); }));
                }
                else {
                    _this.clearElementCache(elm);
                }
            }));
        };
        /**
         * @param {?} element
         * @param {?} context
         * @param {?=} destroyAfterComplete
         * @param {?=} defaultToFallback
         * @return {?}
         */
        AnimationTransitionNamespace.prototype.triggerLeaveAnimation = function (element, context, destroyAfterComplete, defaultToFallback) {
            var _this = this;
            /** @type {?} */
            var triggerStates = this._engine.statesByElement.get(element);
            if (triggerStates) {
                /** @type {?} */
                var players_1 = [];
                Object.keys(triggerStates).forEach(( /**
                 * @param {?} triggerName
                 * @return {?}
                 */function (/**
                 * @param {?} triggerName
                 * @return {?}
                 */ triggerName) {
                    // this check is here in the event that an element is removed
                    // twice (both on the host level and the component level)
                    if (_this._triggers[triggerName]) {
                        /** @type {?} */
                        var player = _this.trigger(element, triggerName, VOID_VALUE, defaultToFallback);
                        if (player) {
                            players_1.push(player);
                        }
                    }
                }));
                if (players_1.length) {
                    this._engine.markElementAsRemoved(this.id, element, true, context);
                    if (destroyAfterComplete) {
                        optimizeGroupPlayer(players_1).onDone(( /**
                         * @return {?}
                         */function () { return _this._engine.processLeaveNode(element); }));
                    }
                    return true;
                }
            }
            return false;
        };
        /**
         * @param {?} element
         * @return {?}
         */
        AnimationTransitionNamespace.prototype.prepareLeaveAnimationListeners = function (element) {
            var _this = this;
            /** @type {?} */
            var listeners = this._elementListeners.get(element);
            if (listeners) {
                /** @type {?} */
                var visitedTriggers_1 = new Set();
                listeners.forEach(( /**
                 * @param {?} listener
                 * @return {?}
                 */function (/**
                 * @param {?} listener
                 * @return {?}
                 */ listener) {
                    /** @type {?} */
                    var triggerName = listener.name;
                    if (visitedTriggers_1.has(triggerName))
                        return;
                    visitedTriggers_1.add(triggerName);
                    /** @type {?} */
                    var trigger = _this._triggers[triggerName];
                    /** @type {?} */
                    var transition = trigger.fallbackTransition;
                    /** @type {?} */
                    var elementStates = ( /** @type {?} */(_this._engine.statesByElement.get(element)));
                    /** @type {?} */
                    var fromState = elementStates[triggerName] || DEFAULT_STATE_VALUE;
                    /** @type {?} */
                    var toState = new StateValue(VOID_VALUE);
                    /** @type {?} */
                    var player = new TransitionAnimationPlayer(_this.id, triggerName, element);
                    _this._engine.totalQueuedPlayers++;
                    _this._queue.push({
                        element: element,
                        triggerName: triggerName,
                        transition: transition,
                        fromState: fromState,
                        toState: toState,
                        player: player,
                        isFallbackTransition: true
                    });
                }));
            }
        };
        /**
         * @param {?} element
         * @param {?} context
         * @return {?}
         */
        AnimationTransitionNamespace.prototype.removeNode = function (element, context) {
            var _this = this;
            /** @type {?} */
            var engine = this._engine;
            if (element.childElementCount) {
                this._signalRemovalForInnerTriggers(element, context, true);
            }
            // this means that a * => VOID animation was detected and kicked off
            if (this.triggerLeaveAnimation(element, context, true))
                return;
            // find the player that is animating and make sure that the
            // removal is delayed until that player has completed
            /** @type {?} */
            var containsPotentialParentTransition = false;
            if (engine.totalAnimations) {
                /** @type {?} */
                var currentPlayers = engine.players.length ? engine.playersByQueriedElement.get(element) : [];
                // when this `if statement` does not continue forward it means that
                // a previous animation query has selected the current element and
                // is animating it. In this situation want to continue forwards and
                // allow the element to be queued up for animation later.
                if (currentPlayers && currentPlayers.length) {
                    containsPotentialParentTransition = true;
                }
                else {
                    /** @type {?} */
                    var parent_5 = element;
                    while (parent_5 = parent_5.parentNode) {
                        /** @type {?} */
                        var triggers = engine.statesByElement.get(parent_5);
                        if (triggers) {
                            containsPotentialParentTransition = true;
                            break;
                        }
                    }
                }
            }
            // at this stage we know that the element will either get removed
            // during flush or will be picked up by a parent query. Either way
            // we need to fire the listeners for this element when it DOES get
            // removed (once the query parent animation is done or after flush)
            this.prepareLeaveAnimationListeners(element);
            // whether or not a parent has an animation we need to delay the deferral of the leave
            // operation until we have more information (which we do after flush() has been called)
            if (containsPotentialParentTransition) {
                engine.markElementAsRemoved(this.id, element, false, context);
            }
            else {
                // we do this after the flush has occurred such
                // that the callbacks can be fired
                engine.afterFlush(( /**
                 * @return {?}
                 */function () { return _this.clearElementCache(element); }));
                engine.destroyInnerAnimations(element);
                engine._onRemovalComplete(element, context);
            }
        };
        /**
         * @param {?} element
         * @param {?} parent
         * @return {?}
         */
        AnimationTransitionNamespace.prototype.insertNode = function (element, parent) { addClass(element, this._hostClassName); };
        /**
         * @param {?} microtaskId
         * @return {?}
         */
        AnimationTransitionNamespace.prototype.drainQueuedTransitions = function (microtaskId) {
            var _this = this;
            /** @type {?} */
            var instructions = [];
            this._queue.forEach(( /**
             * @param {?} entry
             * @return {?}
             */function (/**
             * @param {?} entry
             * @return {?}
             */ entry) {
                /** @type {?} */
                var player = entry.player;
                if (player.destroyed)
                    return;
                /** @type {?} */
                var element = entry.element;
                /** @type {?} */
                var listeners = _this._elementListeners.get(element);
                if (listeners) {
                    listeners.forEach(( /**
                     * @param {?} listener
                     * @return {?}
                     */function (listener) {
                        if (listener.name == entry.triggerName) {
                            /** @type {?} */
                            var baseEvent = makeAnimationEvent(element, entry.triggerName, entry.fromState.value, entry.toState.value);
                            (( /** @type {?} */(baseEvent)))['_data'] = microtaskId;
                            listenOnPlayer(entry.player, listener.phase, baseEvent, listener.callback);
                        }
                    }));
                }
                if (player.markedForDestroy) {
                    _this._engine.afterFlush(( /**
                     * @return {?}
                     */function () {
                        // now we can destroy the element properly since the event listeners have
                        // been bound to the player
                        player.destroy();
                    }));
                }
                else {
                    instructions.push(entry);
                }
            }));
            this._queue = [];
            return instructions.sort(( /**
             * @param {?} a
             * @param {?} b
             * @return {?}
             */function (a, b) {
                // if depCount == 0 them move to front
                // otherwise if a contains b then move back
                /** @type {?} */
                var d0 = a.transition.ast.depCount;
                /** @type {?} */
                var d1 = b.transition.ast.depCount;
                if (d0 == 0 || d1 == 0) {
                    return d0 - d1;
                }
                return _this._engine.driver.containsElement(a.element, b.element) ? 1 : -1;
            }));
        };
        /**
         * @param {?} context
         * @return {?}
         */
        AnimationTransitionNamespace.prototype.destroy = function (context) {
            this.players.forEach(( /**
             * @param {?} p
             * @return {?}
             */function (/**
             * @param {?} p
             * @return {?}
             */ p) { return p.destroy(); }));
            this._signalRemovalForInnerTriggers(this.hostElement, context);
        };
        /**
         * @param {?} element
         * @return {?}
         */
        AnimationTransitionNamespace.prototype.elementContainsData = function (element) {
            /** @type {?} */
            var containsData = false;
            if (this._elementListeners.has(element))
                containsData = true;
            containsData =
                (this._queue.find(( /**
                 * @param {?} entry
                 * @return {?}
                 */function (/**
                 * @param {?} entry
                 * @return {?}
                 */ entry) { return entry.element === element; })) ? true : false) || containsData;
            return containsData;
        };
        return AnimationTransitionNamespace;
    }());
    var TransitionAnimationEngine = /** @class */ (function () {
        /**
         * @param {?} bodyNode
         * @param {?} driver
         * @param {?} _normalizer
         */
        function TransitionAnimationEngine(bodyNode, driver, _normalizer) {
            this.bodyNode = bodyNode;
            this.driver = driver;
            this._normalizer = _normalizer;
            this.players = [];
            this.newHostElements = new Map();
            this.playersByElement = new Map();
            this.playersByQueriedElement = new Map();
            this.statesByElement = new Map();
            this.disabledNodes = new Set();
            this.totalAnimations = 0;
            this.totalQueuedPlayers = 0;
            this._namespaceLookup = {};
            this._namespaceList = [];
            this._flushFns = [];
            this._whenQuietFns = [];
            this.namespacesByHostElement = new Map();
            this.collectedEnterElements = [];
            this.collectedLeaveElements = [];
            // this method is designed to be overridden by the code that uses this engine
            this.onRemovalComplete = ( /**
             * @param {?} element
             * @param {?} context
             * @return {?}
             */function (element, context) { });
        }
        /**
         * \@internal
         * @param {?} element
         * @param {?} context
         * @return {?}
         */
        TransitionAnimationEngine.prototype._onRemovalComplete = function (element, context) { this.onRemovalComplete(element, context); };
        Object.defineProperty(TransitionAnimationEngine.prototype, "queuedPlayers", {
            /**
             * @return {?}
             */
            get: function () {
                /** @type {?} */
                var players = [];
                this._namespaceList.forEach(( /**
                 * @param {?} ns
                 * @return {?}
                 */function (/**
                 * @param {?} ns
                 * @return {?}
                 */ ns) {
                    ns.players.forEach(( /**
                     * @param {?} player
                     * @return {?}
                     */function (/**
                     * @param {?} player
                     * @return {?}
                     */ player) {
                        if (player.queued) {
                            players.push(player);
                        }
                    }));
                }));
                return players;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} namespaceId
         * @param {?} hostElement
         * @return {?}
         */
        TransitionAnimationEngine.prototype.createNamespace = function (namespaceId, hostElement) {
            /** @type {?} */
            var ns = new AnimationTransitionNamespace(namespaceId, hostElement, this);
            if (hostElement.parentNode) {
                this._balanceNamespaceList(ns, hostElement);
            }
            else {
                // defer this later until flush during when the host element has
                // been inserted so that we know exactly where to place it in
                // the namespace list
                this.newHostElements.set(hostElement, ns);
                // given that this host element is apart of the animation code, it
                // may or may not be inserted by a parent node that is an of an
                // animation renderer type. If this happens then we can still have
                // access to this item when we query for :enter nodes. If the parent
                // is a renderer then the set data-structure will normalize the entry
                this.collectEnterElement(hostElement);
            }
            return this._namespaceLookup[namespaceId] = ns;
        };
        /**
         * @private
         * @param {?} ns
         * @param {?} hostElement
         * @return {?}
         */
        TransitionAnimationEngine.prototype._balanceNamespaceList = function (ns, hostElement) {
            /** @type {?} */
            var limit = this._namespaceList.length - 1;
            if (limit >= 0) {
                /** @type {?} */
                var found = false;
                for (var i_131 = limit; i_131 >= 0; i_131--) {
                    /** @type {?} */
                    var nextNamespace = this._namespaceList[i_131];
                    if (this.driver.containsElement(nextNamespace.hostElement, hostElement)) {
                        this._namespaceList.splice(i_131 + 1, 0, ns);
                        found = true;
                        break;
                    }
                }
                if (!found) {
                    this._namespaceList.splice(0, 0, ns);
                }
            }
            else {
                this._namespaceList.push(ns);
            }
            this.namespacesByHostElement.set(hostElement, ns);
            return ns;
        };
        /**
         * @param {?} namespaceId
         * @param {?} hostElement
         * @return {?}
         */
        TransitionAnimationEngine.prototype.register = function (namespaceId, hostElement) {
            /** @type {?} */
            var ns = this._namespaceLookup[namespaceId];
            if (!ns) {
                ns = this.createNamespace(namespaceId, hostElement);
            }
            return ns;
        };
        /**
         * @param {?} namespaceId
         * @param {?} name
         * @param {?} trigger
         * @return {?}
         */
        TransitionAnimationEngine.prototype.registerTrigger = function (namespaceId, name, trigger) {
            /** @type {?} */
            var ns = this._namespaceLookup[namespaceId];
            if (ns && ns.register(name, trigger)) {
                this.totalAnimations++;
            }
        };
        /**
         * @param {?} namespaceId
         * @param {?} context
         * @return {?}
         */
        TransitionAnimationEngine.prototype.destroy = function (namespaceId, context) {
            var _this = this;
            if (!namespaceId)
                return;
            /** @type {?} */
            var ns = this._fetchNamespace(namespaceId);
            this.afterFlush(( /**
             * @return {?}
             */function () {
                _this.namespacesByHostElement.delete(ns.hostElement);
                delete _this._namespaceLookup[namespaceId];
                /** @type {?} */
                var index = _this._namespaceList.indexOf(ns);
                if (index >= 0) {
                    _this._namespaceList.splice(index, 1);
                }
            }));
            this.afterFlushAnimationsDone(( /**
             * @return {?}
             */function () { return ns.destroy(context); }));
        };
        /**
         * @private
         * @param {?} id
         * @return {?}
         */
        TransitionAnimationEngine.prototype._fetchNamespace = function (id) { return this._namespaceLookup[id]; };
        /**
         * @param {?} element
         * @return {?}
         */
        TransitionAnimationEngine.prototype.fetchNamespacesByElement = function (element) {
            // normally there should only be one namespace per element, however
            // if @triggers are placed on both the component element and then
            // its host element (within the component code) then there will be
            // two namespaces returned. We use a set here to simply the dedupe
            // of namespaces incase there are multiple triggers both the elm and host
            /** @type {?} */
            var namespaces = new Set();
            /** @type {?} */
            var elementStates = this.statesByElement.get(element);
            if (elementStates) {
                /** @type {?} */
                var keys = Object.keys(elementStates);
                for (var i_132 = 0; i_132 < keys.length; i_132++) {
                    /** @type {?} */
                    var nsId = elementStates[keys[i_132]].namespaceId;
                    if (nsId) {
                        /** @type {?} */
                        var ns = this._fetchNamespace(nsId);
                        if (ns) {
                            namespaces.add(ns);
                        }
                    }
                }
            }
            return namespaces;
        };
        /**
         * @param {?} namespaceId
         * @param {?} element
         * @param {?} name
         * @param {?} value
         * @return {?}
         */
        TransitionAnimationEngine.prototype.trigger = function (namespaceId, element, name, value) {
            if (isElementNode(element)) {
                /** @type {?} */
                var ns = this._fetchNamespace(namespaceId);
                if (ns) {
                    ns.trigger(element, name, value);
                    return true;
                }
            }
            return false;
        };
        /**
         * @param {?} namespaceId
         * @param {?} element
         * @param {?} parent
         * @param {?} insertBefore
         * @return {?}
         */
        TransitionAnimationEngine.prototype.insertNode = function (namespaceId, element, parent, insertBefore) {
            if (!isElementNode(element))
                return;
            // special case for when an element is removed and reinserted (move operation)
            // when this occurs we do not want to use the element for deletion later
            /** @type {?} */
            var details = ( /** @type {?} */(element[REMOVAL_FLAG]));
            if (details && details.setForRemoval) {
                details.setForRemoval = false;
                details.setForMove = true;
                /** @type {?} */
                var index = this.collectedLeaveElements.indexOf(element);
                if (index >= 0) {
                    this.collectedLeaveElements.splice(index, 1);
                }
            }
            // in the event that the namespaceId is blank then the caller
            // code does not contain any animation code in it, but it is
            // just being called so that the node is marked as being inserted
            if (namespaceId) {
                /** @type {?} */
                var ns = this._fetchNamespace(namespaceId);
                // This if-statement is a workaround for router issue #21947.
                // The router sometimes hits a race condition where while a route
                // is being instantiated a new navigation arrives, triggering leave
                // animation of DOM that has not been fully initialized, until this
                // is resolved, we need to handle the scenario when DOM is not in a
                // consistent state during the animation.
                if (ns) {
                    ns.insertNode(element, parent);
                }
            }
            // only *directives and host elements are inserted before
            if (insertBefore) {
                this.collectEnterElement(element);
            }
        };
        /**
         * @param {?} element
         * @return {?}
         */
        TransitionAnimationEngine.prototype.collectEnterElement = function (element) { this.collectedEnterElements.push(element); };
        /**
         * @param {?} element
         * @param {?} value
         * @return {?}
         */
        TransitionAnimationEngine.prototype.markElementAsDisabled = function (element, value) {
            if (value) {
                if (!this.disabledNodes.has(element)) {
                    this.disabledNodes.add(element);
                    addClass(element, DISABLED_CLASSNAME);
                }
            }
            else if (this.disabledNodes.has(element)) {
                this.disabledNodes.delete(element);
                removeClass(element, DISABLED_CLASSNAME);
            }
        };
        /**
         * @param {?} namespaceId
         * @param {?} element
         * @param {?} isHostElement
         * @param {?} context
         * @return {?}
         */
        TransitionAnimationEngine.prototype.removeNode = function (namespaceId, element, isHostElement, context) {
            if (isElementNode(element)) {
                /** @type {?} */
                var ns = namespaceId ? this._fetchNamespace(namespaceId) : null;
                if (ns) {
                    ns.removeNode(element, context);
                }
                else {
                    this.markElementAsRemoved(namespaceId, element, false, context);
                }
                if (isHostElement) {
                    /** @type {?} */
                    var hostNS = this.namespacesByHostElement.get(element);
                    if (hostNS && hostNS.id !== namespaceId) {
                        hostNS.removeNode(element, context);
                    }
                }
            }
            else {
                this._onRemovalComplete(element, context);
            }
        };
        /**
         * @param {?} namespaceId
         * @param {?} element
         * @param {?=} hasAnimation
         * @param {?=} context
         * @return {?}
         */
        TransitionAnimationEngine.prototype.markElementAsRemoved = function (namespaceId, element, hasAnimation, context) {
            this.collectedLeaveElements.push(element);
            element[REMOVAL_FLAG] = {
                namespaceId: namespaceId,
                setForRemoval: context, hasAnimation: hasAnimation,
                removedBeforeQueried: false
            };
        };
        /**
         * @param {?} namespaceId
         * @param {?} element
         * @param {?} name
         * @param {?} phase
         * @param {?} callback
         * @return {?}
         */
        TransitionAnimationEngine.prototype.listen = function (namespaceId, element, name, phase, callback) {
            if (isElementNode(element)) {
                return this._fetchNamespace(namespaceId).listen(element, name, phase, callback);
            }
            return ( /**
             * @return {?}
             */function () { });
        };
        /**
         * @private
         * @param {?} entry
         * @param {?} subTimelines
         * @param {?} enterClassName
         * @param {?} leaveClassName
         * @param {?=} skipBuildAst
         * @return {?}
         */
        TransitionAnimationEngine.prototype._buildInstruction = function (entry, subTimelines, enterClassName, leaveClassName, skipBuildAst) {
            return entry.transition.build(this.driver, entry.element, entry.fromState.value, entry.toState.value, enterClassName, leaveClassName, entry.fromState.options, entry.toState.options, subTimelines, skipBuildAst);
        };
        /**
         * @param {?} containerElement
         * @return {?}
         */
        TransitionAnimationEngine.prototype.destroyInnerAnimations = function (containerElement) {
            var _this = this;
            /** @type {?} */
            var elements = this.driver.query(containerElement, NG_TRIGGER_SELECTOR, true);
            elements.forEach(( /**
             * @param {?} element
             * @return {?}
             */function (/**
             * @param {?} element
             * @return {?}
             */ element) { return _this.destroyActiveAnimationsForElement(element); }));
            if (this.playersByQueriedElement.size == 0)
                return;
            elements = this.driver.query(containerElement, NG_ANIMATING_SELECTOR, true);
            elements.forEach(( /**
             * @param {?} element
             * @return {?}
             */function (/**
             * @param {?} element
             * @return {?}
             */ element) { return _this.finishActiveQueriedAnimationOnElement(element); }));
        };
        /**
         * @param {?} element
         * @return {?}
         */
        TransitionAnimationEngine.prototype.destroyActiveAnimationsForElement = function (element) {
            /** @type {?} */
            var players = this.playersByElement.get(element);
            if (players) {
                players.forEach(( /**
                 * @param {?} player
                 * @return {?}
                 */function (/**
                 * @param {?} player
                 * @return {?}
                 */ player) {
                    // special case for when an element is set for destruction, but hasn't started.
                    // in this situation we want to delay the destruction until the flush occurs
                    // so that any event listeners attached to the player are triggered.
                    if (player.queued) {
                        player.markedForDestroy = true;
                    }
                    else {
                        player.destroy();
                    }
                }));
            }
        };
        /**
         * @param {?} element
         * @return {?}
         */
        TransitionAnimationEngine.prototype.finishActiveQueriedAnimationOnElement = function (element) {
            /** @type {?} */
            var players = this.playersByQueriedElement.get(element);
            if (players) {
                players.forEach(( /**
                 * @param {?} player
                 * @return {?}
                 */function (/**
                 * @param {?} player
                 * @return {?}
                 */ player) { return player.finish(); }));
            }
        };
        /**
         * @return {?}
         */
        TransitionAnimationEngine.prototype.whenRenderingDone = function () {
            var _this = this;
            return new Promise(( /**
             * @param {?} resolve
             * @return {?}
             */function (/**
             * @param {?} resolve
             * @return {?}
             */ resolve) {
                if (_this.players.length) {
                    return optimizeGroupPlayer(_this.players).onDone(( /**
                     * @return {?}
                     */function () { return resolve(); }));
                }
                else {
                    resolve();
                }
            }));
        };
        /**
         * @param {?} element
         * @return {?}
         */
        TransitionAnimationEngine.prototype.processLeaveNode = function (element) {
            var _this = this;
            /** @type {?} */
            var details = ( /** @type {?} */(element[REMOVAL_FLAG]));
            if (details && details.setForRemoval) {
                // this will prevent it from removing it twice
                element[REMOVAL_FLAG] = NULL_REMOVAL_STATE;
                if (details.namespaceId) {
                    this.destroyInnerAnimations(element);
                    /** @type {?} */
                    var ns = this._fetchNamespace(details.namespaceId);
                    if (ns) {
                        ns.clearElementCache(element);
                    }
                }
                this._onRemovalComplete(element, details.setForRemoval);
            }
            if (this.driver.matchesElement(element, DISABLED_SELECTOR)) {
                this.markElementAsDisabled(element, false);
            }
            this.driver.query(element, DISABLED_SELECTOR, true).forEach(( /**
             * @param {?} node
             * @return {?}
             */function (/**
             * @param {?} node
             * @return {?}
             */ node) {
                _this.markElementAsDisabled(node, false);
            }));
        };
        /**
         * @param {?=} microtaskId
         * @return {?}
         */
        TransitionAnimationEngine.prototype.flush = function (microtaskId) {
            var _this = this;
            if (microtaskId === void 0) { microtaskId = -1; }
            /** @type {?} */
            var players = [];
            if (this.newHostElements.size) {
                this.newHostElements.forEach(( /**
                 * @param {?} ns
                 * @param {?} element
                 * @return {?}
                 */function (ns, element) { return _this._balanceNamespaceList(ns, element); }));
                this.newHostElements.clear();
            }
            if (this.totalAnimations && this.collectedEnterElements.length) {
                for (var i_133 = 0; i_133 < this.collectedEnterElements.length; i_133++) {
                    /** @type {?} */
                    var elm = this.collectedEnterElements[i_133];
                    addClass(elm, STAR_CLASSNAME);
                }
            }
            if (this._namespaceList.length &&
                (this.totalQueuedPlayers || this.collectedLeaveElements.length)) {
                /** @type {?} */
                var cleanupFns = [];
                try {
                    players = this._flushAnimations(cleanupFns, microtaskId);
                }
                finally {
                    for (var i_134 = 0; i_134 < cleanupFns.length; i_134++) {
                        cleanupFns[i_134]();
                    }
                }
            }
            else {
                for (var i_135 = 0; i_135 < this.collectedLeaveElements.length; i_135++) {
                    /** @type {?} */
                    var element = this.collectedLeaveElements[i_135];
                    this.processLeaveNode(element);
                }
            }
            this.totalQueuedPlayers = 0;
            this.collectedEnterElements.length = 0;
            this.collectedLeaveElements.length = 0;
            this._flushFns.forEach(( /**
             * @param {?} fn
             * @return {?}
             */function (/**
             * @param {?} fn
             * @return {?}
             */ fn) { return fn(); }));
            this._flushFns = [];
            if (this._whenQuietFns.length) {
                // we move these over to a variable so that
                // if any new callbacks are registered in another
                // flush they do not populate the existing set
                /** @type {?} */
                var quietFns_1 = this._whenQuietFns;
                this._whenQuietFns = [];
                if (players.length) {
                    optimizeGroupPlayer(players).onDone(( /**
                     * @return {?}
                     */function () {
                        quietFns_1.forEach(( /**
                         * @param {?} fn
                         * @return {?}
                         */function (/**
                         * @param {?} fn
                         * @return {?}
                         */ fn) { return fn(); }));
                    }));
                }
                else {
                    quietFns_1.forEach(( /**
                     * @param {?} fn
                     * @return {?}
                     */function (/**
                     * @param {?} fn
                     * @return {?}
                     */ fn) { return fn(); }));
                }
            }
        };
        /**
         * @param {?} errors
         * @return {?}
         */
        TransitionAnimationEngine.prototype.reportError = function (errors) {
            throw new Error("Unable to process animations due to the following failed trigger transitions\n " + errors.join('\n'));
        };
        /**
         * @private
         * @param {?} cleanupFns
         * @param {?} microtaskId
         * @return {?}
         */
        TransitionAnimationEngine.prototype._flushAnimations = function (cleanupFns, microtaskId) {
            var _this = this;
            /** @type {?} */
            var subTimelines = new ElementInstructionMap();
            /** @type {?} */
            var skippedPlayers = [];
            /** @type {?} */
            var skippedPlayersMap = new Map();
            /** @type {?} */
            var queuedInstructions = [];
            /** @type {?} */
            var queriedElements = new Map();
            /** @type {?} */
            var allPreStyleElements = new Map();
            /** @type {?} */
            var allPostStyleElements = new Map();
            /** @type {?} */
            var disabledElementsSet = new Set();
            this.disabledNodes.forEach(( /**
             * @param {?} node
             * @return {?}
             */function (/**
             * @param {?} node
             * @return {?}
             */ node) {
                disabledElementsSet.add(node);
                /** @type {?} */
                var nodesThatAreDisabled = _this.driver.query(node, QUEUED_SELECTOR, true);
                for (var i_136 = 0; i_136 < nodesThatAreDisabled.length; i_136++) {
                    disabledElementsSet.add(nodesThatAreDisabled[i_136]);
                }
            }));
            /** @type {?} */
            var bodyNode = this.bodyNode;
            /** @type {?} */
            var allTriggerElements = Array.from(this.statesByElement.keys());
            /** @type {?} */
            var enterNodeMap = buildRootMap(allTriggerElements, this.collectedEnterElements);
            // this must occur before the instructions are built below such that
            // the :enter queries match the elements (since the timeline queries
            // are fired during instruction building).
            /** @type {?} */
            var enterNodeMapIds = new Map();
            /** @type {?} */
            var i = 0;
            enterNodeMap.forEach(( /**
             * @param {?} nodes
             * @param {?} root
             * @return {?}
             */function (nodes, root) {
                /** @type {?} */
                var className = ENTER_CLASSNAME + i++;
                enterNodeMapIds.set(root, className);
                nodes.forEach(( /**
                 * @param {?} node
                 * @return {?}
                 */function (/**
                 * @param {?} node
                 * @return {?}
                 */ node) { return addClass(node, className); }));
            }));
            /** @type {?} */
            var allLeaveNodes = [];
            /** @type {?} */
            var mergedLeaveNodes = new Set();
            /** @type {?} */
            var leaveNodesWithoutAnimations = new Set();
            for (var i_137 = 0; i_137 < this.collectedLeaveElements.length; i_137++) {
                /** @type {?} */
                var element = this.collectedLeaveElements[i_137];
                /** @type {?} */
                var details = ( /** @type {?} */(element[REMOVAL_FLAG]));
                if (details && details.setForRemoval) {
                    allLeaveNodes.push(element);
                    mergedLeaveNodes.add(element);
                    if (details.hasAnimation) {
                        this.driver.query(element, STAR_SELECTOR, true).forEach(( /**
                         * @param {?} elm
                         * @return {?}
                         */function (/**
                         * @param {?} elm
                         * @return {?}
                         */ elm) { return mergedLeaveNodes.add(elm); }));
                    }
                    else {
                        leaveNodesWithoutAnimations.add(element);
                    }
                }
            }
            /** @type {?} */
            var leaveNodeMapIds = new Map();
            /** @type {?} */
            var leaveNodeMap = buildRootMap(allTriggerElements, Array.from(mergedLeaveNodes));
            leaveNodeMap.forEach(( /**
             * @param {?} nodes
             * @param {?} root
             * @return {?}
             */function (nodes, root) {
                /** @type {?} */
                var className = LEAVE_CLASSNAME + i++;
                leaveNodeMapIds.set(root, className);
                nodes.forEach(( /**
                 * @param {?} node
                 * @return {?}
                 */function (/**
                 * @param {?} node
                 * @return {?}
                 */ node) { return addClass(node, className); }));
            }));
            cleanupFns.push(( /**
             * @return {?}
             */function () {
                enterNodeMap.forEach(( /**
                 * @param {?} nodes
                 * @param {?} root
                 * @return {?}
                 */function (nodes, root) {
                    /** @type {?} */
                    var className = ( /** @type {?} */(enterNodeMapIds.get(root)));
                    nodes.forEach(( /**
                     * @param {?} node
                     * @return {?}
                     */function (/**
                     * @param {?} node
                     * @return {?}
                     */ node) { return removeClass(node, className); }));
                }));
                leaveNodeMap.forEach(( /**
                 * @param {?} nodes
                 * @param {?} root
                 * @return {?}
                 */function (nodes, root) {
                    /** @type {?} */
                    var className = ( /** @type {?} */(leaveNodeMapIds.get(root)));
                    nodes.forEach(( /**
                     * @param {?} node
                     * @return {?}
                     */function (/**
                     * @param {?} node
                     * @return {?}
                     */ node) { return removeClass(node, className); }));
                }));
                allLeaveNodes.forEach(( /**
                 * @param {?} element
                 * @return {?}
                 */function (/**
                 * @param {?} element
                 * @return {?}
                 */ element) { _this.processLeaveNode(element); }));
            }));
            /** @type {?} */
            var allPlayers = [];
            /** @type {?} */
            var erroneousTransitions = [];
            for (var i_138 = this._namespaceList.length - 1; i_138 >= 0; i_138--) {
                /** @type {?} */
                var ns = this._namespaceList[i_138];
                ns.drainQueuedTransitions(microtaskId).forEach(( /**
                 * @param {?} entry
                 * @return {?}
                 */function (/**
                 * @param {?} entry
                 * @return {?}
                 */ entry) {
                    /** @type {?} */
                    var player = entry.player;
                    /** @type {?} */
                    var element = entry.element;
                    allPlayers.push(player);
                    if (_this.collectedEnterElements.length) {
                        /** @type {?} */
                        var details = ( /** @type {?} */(element[REMOVAL_FLAG]));
                        // move animations are currently not supported...
                        if (details && details.setForMove) {
                            player.destroy();
                            return;
                        }
                    }
                    /** @type {?} */
                    var nodeIsOrphaned = !bodyNode || !_this.driver.containsElement(bodyNode, element);
                    /** @type {?} */
                    var leaveClassName = ( /** @type {?} */(leaveNodeMapIds.get(element)));
                    /** @type {?} */
                    var enterClassName = ( /** @type {?} */(enterNodeMapIds.get(element)));
                    /** @type {?} */
                    var instruction = ( /** @type {?} */(_this._buildInstruction(entry, subTimelines, enterClassName, leaveClassName, nodeIsOrphaned)));
                    if (instruction.errors && instruction.errors.length) {
                        erroneousTransitions.push(instruction);
                        return;
                    }
                    // even though the element may not be apart of the DOM, it may
                    // still be added at a later point (due to the mechanics of content
                    // projection and/or dynamic component insertion) therefore it's
                    // important we still style the element.
                    if (nodeIsOrphaned) {
                        player.onStart(( /**
                         * @return {?}
                         */function () { return eraseStyles(element, instruction.fromStyles); }));
                        player.onDestroy(( /**
                         * @return {?}
                         */function () { return setStyles(element, instruction.toStyles); }));
                        skippedPlayers.push(player);
                        return;
                    }
                    // if a unmatched transition is queued to go then it SHOULD NOT render
                    // an animation and cancel the previously running animations.
                    if (entry.isFallbackTransition) {
                        player.onStart(( /**
                         * @return {?}
                         */function () { return eraseStyles(element, instruction.fromStyles); }));
                        player.onDestroy(( /**
                         * @return {?}
                         */function () { return setStyles(element, instruction.toStyles); }));
                        skippedPlayers.push(player);
                        return;
                    }
                    // this means that if a parent animation uses this animation as a sub trigger
                    // then it will instruct the timeline builder to not add a player delay, but
                    // instead stretch the first keyframe gap up until the animation starts. The
                    // reason this is important is to prevent extra initialization styles from being
                    // required by the user in the animation.
                    instruction.timelines.forEach(( /**
                     * @param {?} tl
                     * @return {?}
                     */function (/**
                     * @param {?} tl
                     * @return {?}
                     */ tl) { return tl.stretchStartingKeyframe = true; }));
                    subTimelines.append(element, instruction.timelines);
                    /** @type {?} */
                    var tuple = { instruction: instruction, player: player, element: element };
                    queuedInstructions.push(tuple);
                    instruction.queriedElements.forEach(( /**
                     * @param {?} element
                     * @return {?}
                     */function (/**
                     * @param {?} element
                     * @return {?}
                     */ element) { return getOrSetAsInMap(queriedElements, element, []).push(player); }));
                    instruction.preStyleProps.forEach(( /**
                     * @param {?} stringMap
                     * @param {?} element
                     * @return {?}
                     */function (stringMap, element) {
                        /** @type {?} */
                        var props = Object.keys(stringMap);
                        if (props.length) {
                            /** @type {?} */
                            var setVal_1 = ( /** @type {?} */(allPreStyleElements.get(element)));
                            if (!setVal_1) {
                                allPreStyleElements.set(element, setVal_1 = new Set());
                            }
                            props.forEach(( /**
                             * @param {?} prop
                             * @return {?}
                             */function (/**
                             * @param {?} prop
                             * @return {?}
                             */ prop) { return setVal_1.add(prop); }));
                        }
                    }));
                    instruction.postStyleProps.forEach(( /**
                     * @param {?} stringMap
                     * @param {?} element
                     * @return {?}
                     */function (stringMap, element) {
                        /** @type {?} */
                        var props = Object.keys(stringMap);
                        /** @type {?} */
                        var setVal = ( /** @type {?} */(allPostStyleElements.get(element)));
                        if (!setVal) {
                            allPostStyleElements.set(element, setVal = new Set());
                        }
                        props.forEach(( /**
                         * @param {?} prop
                         * @return {?}
                         */function (/**
                         * @param {?} prop
                         * @return {?}
                         */ prop) { return setVal.add(prop); }));
                    }));
                }));
            }
            if (erroneousTransitions.length) {
                /** @type {?} */
                var errors_1 = [];
                erroneousTransitions.forEach(( /**
                 * @param {?} instruction
                 * @return {?}
                 */function (/**
                 * @param {?} instruction
                 * @return {?}
                 */ instruction) {
                    errors_1.push("@" + instruction.triggerName + " has failed due to:\n");
                    ( /** @type {?} */(instruction.errors)).forEach(( /**
                     * @param {?} error
                     * @return {?}
                     */function (/**
                     * @param {?} error
                     * @return {?}
                     */ error) { return errors_1.push("- " + error + "\n"); }));
                }));
                allPlayers.forEach(( /**
                 * @param {?} player
                 * @return {?}
                 */function (/**
                 * @param {?} player
                 * @return {?}
                 */ player) { return player.destroy(); }));
                this.reportError(errors_1);
            }
            /** @type {?} */
            var allPreviousPlayersMap = new Map();
            // this map works to tell which element in the DOM tree is contained by
            // which animation. Further down below this map will get populated once
            // the players are built and in doing so it can efficiently figure out
            // if a sub player is skipped due to a parent player having priority.
            /** @type {?} */
            var animationElementMap = new Map();
            queuedInstructions.forEach(( /**
             * @param {?} entry
             * @return {?}
             */function (/**
             * @param {?} entry
             * @return {?}
             */ entry) {
                /** @type {?} */
                var element = entry.element;
                if (subTimelines.has(element)) {
                    animationElementMap.set(element, element);
                    _this._beforeAnimationBuild(entry.player.namespaceId, entry.instruction, allPreviousPlayersMap);
                }
            }));
            skippedPlayers.forEach(( /**
             * @param {?} player
             * @return {?}
             */function (/**
             * @param {?} player
             * @return {?}
             */ player) {
                /** @type {?} */
                var element = player.element;
                /** @type {?} */
                var previousPlayers = _this._getPreviousPlayers(element, false, player.namespaceId, player.triggerName, null);
                previousPlayers.forEach(( /**
                 * @param {?} prevPlayer
                 * @return {?}
                 */function (/**
                 * @param {?} prevPlayer
                 * @return {?}
                 */ prevPlayer) {
                    getOrSetAsInMap(allPreviousPlayersMap, element, []).push(prevPlayer);
                    prevPlayer.destroy();
                }));
            }));
            // this is a special case for nodes that will be removed (either by)
            // having their own leave animations or by being queried in a container
            // that will be removed once a parent animation is complete. The idea
            // here is that * styles must be identical to ! styles because of
            // backwards compatibility (* is also filled in by default in many places).
            // Otherwise * styles will return an empty value or auto since the element
            // that is being getComputedStyle'd will not be visible (since * = destination)
            /** @type {?} */
            var replaceNodes = allLeaveNodes.filter(( /**
             * @param {?} node
             * @return {?}
             */function (/**
             * @param {?} node
             * @return {?}
             */ node) {
                return replacePostStylesAsPre(node, allPreStyleElements, allPostStyleElements);
            }));
            // POST STAGE: fill the * styles
            /** @type {?} */
            var postStylesMap = new Map();
            /** @type {?} */
            var allLeaveQueriedNodes = cloakAndComputeStyles(postStylesMap, this.driver, leaveNodesWithoutAnimations, allPostStyleElements, AUTO_STYLE);
            allLeaveQueriedNodes.forEach(( /**
             * @param {?} node
             * @return {?}
             */function (/**
             * @param {?} node
             * @return {?}
             */ node) {
                if (replacePostStylesAsPre(node, allPreStyleElements, allPostStyleElements)) {
                    replaceNodes.push(node);
                }
            }));
            // PRE STAGE: fill the ! styles
            /** @type {?} */
            var preStylesMap = new Map();
            enterNodeMap.forEach(( /**
             * @param {?} nodes
             * @param {?} root
             * @return {?}
             */function (nodes, root) {
                cloakAndComputeStyles(preStylesMap, _this.driver, new Set(nodes), allPreStyleElements, ɵPRE_STYLE);
            }));
            replaceNodes.forEach(( /**
             * @param {?} node
             * @return {?}
             */function (/**
             * @param {?} node
             * @return {?}
             */ node) {
                /** @type {?} */
                var post = postStylesMap.get(node);
                /** @type {?} */
                var pre = preStylesMap.get(node);
                postStylesMap.set(node, ( /** @type {?} */(Object.assign({}, post, pre))));
            }));
            /** @type {?} */
            var rootPlayers = [];
            /** @type {?} */
            var subPlayers = [];
            /** @type {?} */
            var NO_PARENT_ANIMATION_ELEMENT_DETECTED = {};
            queuedInstructions.forEach(( /**
             * @param {?} entry
             * @return {?}
             */function (/**
             * @param {?} entry
             * @return {?}
             */ entry) {
                var element = entry.element, player = entry.player, instruction = entry.instruction;
                // this means that it was never consumed by a parent animation which
                // means that it is independent and therefore should be set for animation
                if (subTimelines.has(element)) {
                    if (disabledElementsSet.has(element)) {
                        player.onDestroy(( /**
                         * @return {?}
                         */function () { return setStyles(element, instruction.toStyles); }));
                        player.disabled = true;
                        player.overrideTotalTime(instruction.totalTime);
                        skippedPlayers.push(player);
                        return;
                    }
                    // this will flow up the DOM and query the map to figure out
                    // if a parent animation has priority over it. In the situation
                    // that a parent is detected then it will cancel the loop. If
                    // nothing is detected, or it takes a few hops to find a parent,
                    // then it will fill in the missing nodes and signal them as having
                    // a detected parent (or a NO_PARENT value via a special constant).
                    /** @type {?} */
                    var parentWithAnimation_1 = NO_PARENT_ANIMATION_ELEMENT_DETECTED;
                    if (animationElementMap.size > 1) {
                        /** @type {?} */
                        var elm = element;
                        /** @type {?} */
                        var parentsToAdd = [];
                        while (elm = elm.parentNode) {
                            /** @type {?} */
                            var detectedParent = animationElementMap.get(elm);
                            if (detectedParent) {
                                parentWithAnimation_1 = detectedParent;
                                break;
                            }
                            parentsToAdd.push(elm);
                        }
                        parentsToAdd.forEach(( /**
                         * @param {?} parent
                         * @return {?}
                         */function (/**
                         * @param {?} parent
                         * @return {?}
                         */ parent) { return animationElementMap.set(parent, parentWithAnimation_1); }));
                    }
                    /** @type {?} */
                    var innerPlayer = _this._buildAnimation(player.namespaceId, instruction, allPreviousPlayersMap, skippedPlayersMap, preStylesMap, postStylesMap);
                    player.setRealPlayer(innerPlayer);
                    if (parentWithAnimation_1 === NO_PARENT_ANIMATION_ELEMENT_DETECTED) {
                        rootPlayers.push(player);
                    }
                    else {
                        /** @type {?} */
                        var parentPlayers = _this.playersByElement.get(parentWithAnimation_1);
                        if (parentPlayers && parentPlayers.length) {
                            player.parentPlayer = optimizeGroupPlayer(parentPlayers);
                        }
                        skippedPlayers.push(player);
                    }
                }
                else {
                    eraseStyles(element, instruction.fromStyles);
                    player.onDestroy(( /**
                     * @return {?}
                     */function () { return setStyles(element, instruction.toStyles); }));
                    // there still might be a ancestor player animating this
                    // element therefore we will still add it as a sub player
                    // even if its animation may be disabled
                    subPlayers.push(player);
                    if (disabledElementsSet.has(element)) {
                        skippedPlayers.push(player);
                    }
                }
            }));
            // find all of the sub players' corresponding inner animation player
            subPlayers.forEach(( /**
             * @param {?} player
             * @return {?}
             */function (/**
             * @param {?} player
             * @return {?}
             */ player) {
                // even if any players are not found for a sub animation then it
                // will still complete itself after the next tick since it's Noop
                /** @type {?} */
                var playersForElement = skippedPlayersMap.get(player.element);
                if (playersForElement && playersForElement.length) {
                    /** @type {?} */
                    var innerPlayer = optimizeGroupPlayer(playersForElement);
                    player.setRealPlayer(innerPlayer);
                }
            }));
            // the reason why we don't actually play the animation is
            // because all that a skipped player is designed to do is to
            // fire the start/done transition callback events
            skippedPlayers.forEach(( /**
             * @param {?} player
             * @return {?}
             */function (/**
             * @param {?} player
             * @return {?}
             */ player) {
                if (player.parentPlayer) {
                    player.syncPlayerEvents(player.parentPlayer);
                }
                else {
                    player.destroy();
                }
            }));
            // run through all of the queued removals and see if they
            // were picked up by a query. If not then perform the removal
            // operation right away unless a parent animation is ongoing.
            for (var i_139 = 0; i_139 < allLeaveNodes.length; i_139++) {
                /** @type {?} */
                var element = allLeaveNodes[i_139];
                /** @type {?} */
                var details = ( /** @type {?} */(element[REMOVAL_FLAG]));
                removeClass(element, LEAVE_CLASSNAME);
                // this means the element has a removal animation that is being
                // taken care of and therefore the inner elements will hang around
                // until that animation is over (or the parent queried animation)
                if (details && details.hasAnimation)
                    continue;
                /** @type {?} */
                var players = [];
                // if this element is queried or if it contains queried children
                // then we want for the element not to be removed from the page
                // until the queried animations have finished
                if (queriedElements.size) {
                    /** @type {?} */
                    var queriedPlayerResults = queriedElements.get(element);
                    if (queriedPlayerResults && queriedPlayerResults.length) {
                        players.push.apply(players, __spread(queriedPlayerResults));
                    }
                    /** @type {?} */
                    var queriedInnerElements = this.driver.query(element, NG_ANIMATING_SELECTOR, true);
                    for (var j_9 = 0; j_9 < queriedInnerElements.length; j_9++) {
                        /** @type {?} */
                        var queriedPlayers = queriedElements.get(queriedInnerElements[j_9]);
                        if (queriedPlayers && queriedPlayers.length) {
                            players.push.apply(players, __spread(queriedPlayers));
                        }
                    }
                }
                /** @type {?} */
                var activePlayers = players.filter(( /**
                 * @param {?} p
                 * @return {?}
                 */function (/**
                 * @param {?} p
                 * @return {?}
                 */ p) { return !p.destroyed; }));
                if (activePlayers.length) {
                    removeNodesAfterAnimationDone(this, element, activePlayers);
                }
                else {
                    this.processLeaveNode(element);
                }
            }
            // this is required so the cleanup method doesn't remove them
            allLeaveNodes.length = 0;
            rootPlayers.forEach(( /**
             * @param {?} player
             * @return {?}
             */function (/**
             * @param {?} player
             * @return {?}
             */ player) {
                _this.players.push(player);
                player.onDone(( /**
                 * @return {?}
                 */function () {
                    player.destroy();
                    /** @type {?} */
                    var index = _this.players.indexOf(player);
                    _this.players.splice(index, 1);
                }));
                player.play();
            }));
            return rootPlayers;
        };
        /**
         * @param {?} namespaceId
         * @param {?} element
         * @return {?}
         */
        TransitionAnimationEngine.prototype.elementContainsData = function (namespaceId, element) {
            /** @type {?} */
            var containsData = false;
            /** @type {?} */
            var details = ( /** @type {?} */(element[REMOVAL_FLAG]));
            if (details && details.setForRemoval)
                containsData = true;
            if (this.playersByElement.has(element))
                containsData = true;
            if (this.playersByQueriedElement.has(element))
                containsData = true;
            if (this.statesByElement.has(element))
                containsData = true;
            return this._fetchNamespace(namespaceId).elementContainsData(element) || containsData;
        };
        /**
         * @param {?} callback
         * @return {?}
         */
        TransitionAnimationEngine.prototype.afterFlush = function (callback) { this._flushFns.push(callback); };
        /**
         * @param {?} callback
         * @return {?}
         */
        TransitionAnimationEngine.prototype.afterFlushAnimationsDone = function (callback) { this._whenQuietFns.push(callback); };
        /**
         * @private
         * @param {?} element
         * @param {?} isQueriedElement
         * @param {?=} namespaceId
         * @param {?=} triggerName
         * @param {?=} toStateValue
         * @return {?}
         */
        TransitionAnimationEngine.prototype._getPreviousPlayers = function (element, isQueriedElement, namespaceId, triggerName, toStateValue) {
            /** @type {?} */
            var players = [];
            if (isQueriedElement) {
                /** @type {?} */
                var queriedElementPlayers = this.playersByQueriedElement.get(element);
                if (queriedElementPlayers) {
                    players = queriedElementPlayers;
                }
            }
            else {
                /** @type {?} */
                var elementPlayers = this.playersByElement.get(element);
                if (elementPlayers) {
                    /** @type {?} */
                    var isRemovalAnimation_1 = !toStateValue || toStateValue == VOID_VALUE;
                    elementPlayers.forEach(( /**
                     * @param {?} player
                     * @return {?}
                     */function (/**
                     * @param {?} player
                     * @return {?}
                     */ player) {
                        if (player.queued)
                            return;
                        if (!isRemovalAnimation_1 && player.triggerName != triggerName)
                            return;
                        players.push(player);
                    }));
                }
            }
            if (namespaceId || triggerName) {
                players = players.filter(( /**
                 * @param {?} player
                 * @return {?}
                 */function (/**
                 * @param {?} player
                 * @return {?}
                 */ player) {
                    if (namespaceId && namespaceId != player.namespaceId)
                        return false;
                    if (triggerName && triggerName != player.triggerName)
                        return false;
                    return true;
                }));
            }
            return players;
        };
        /**
         * @private
         * @param {?} namespaceId
         * @param {?} instruction
         * @param {?} allPreviousPlayersMap
         * @return {?}
         */
        TransitionAnimationEngine.prototype._beforeAnimationBuild = function (namespaceId, instruction, allPreviousPlayersMap) {
            var e_8, _b;
            /** @type {?} */
            var triggerName = instruction.triggerName;
            /** @type {?} */
            var rootElement = instruction.element;
            // when a removal animation occurs, ALL previous players are collected
            // and destroyed (even if they are outside of the current namespace)
            /** @type {?} */
            var targetNameSpaceId = instruction.isRemovalTransition ? undefined : namespaceId;
            /** @type {?} */
            var targetTriggerName = instruction.isRemovalTransition ? undefined : triggerName;
            var _loop_3 = function (timelineInstruction) {
                /** @type {?} */
                var element = timelineInstruction.element;
                /** @type {?} */
                var isQueriedElement = element !== rootElement;
                /** @type {?} */
                var players = getOrSetAsInMap(allPreviousPlayersMap, element, []);
                /** @type {?} */
                var previousPlayers = this_1._getPreviousPlayers(element, isQueriedElement, targetNameSpaceId, targetTriggerName, instruction.toState);
                previousPlayers.forEach(( /**
                 * @param {?} player
                 * @return {?}
                 */function (/**
                 * @param {?} player
                 * @return {?}
                 */ player) {
                    /** @type {?} */
                    var realPlayer = ( /** @type {?} */(player.getRealPlayer()));
                    if (realPlayer.beforeDestroy) {
                        realPlayer.beforeDestroy();
                    }
                    player.destroy();
                    players.push(player);
                }));
            };
            var this_1 = this;
            try {
                for (var _c = __values(instruction.timelines), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var timelineInstruction = _d.value;
                    _loop_3(timelineInstruction);
                }
            }
            catch (e_8_1) { e_8 = { error: e_8_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
                }
                finally { if (e_8) throw e_8.error; }
            }
            // this needs to be done so that the PRE/POST styles can be
            // computed properly without interfering with the previous animation
            eraseStyles(rootElement, instruction.fromStyles);
        };
        /**
         * @private
         * @param {?} namespaceId
         * @param {?} instruction
         * @param {?} allPreviousPlayersMap
         * @param {?} skippedPlayersMap
         * @param {?} preStylesMap
         * @param {?} postStylesMap
         * @return {?}
         */
        TransitionAnimationEngine.prototype._buildAnimation = function (namespaceId, instruction, allPreviousPlayersMap, skippedPlayersMap, preStylesMap, postStylesMap) {
            var _this = this;
            /** @type {?} */
            var triggerName = instruction.triggerName;
            /** @type {?} */
            var rootElement = instruction.element;
            // we first run this so that the previous animation player
            // data can be passed into the successive animation players
            /** @type {?} */
            var allQueriedPlayers = [];
            /** @type {?} */
            var allConsumedElements = new Set();
            /** @type {?} */
            var allSubElements = new Set();
            /** @type {?} */
            var allNewPlayers = instruction.timelines.map(( /**
             * @param {?} timelineInstruction
             * @return {?}
             */function (/**
             * @param {?} timelineInstruction
             * @return {?}
             */ timelineInstruction) {
                /** @type {?} */
                var element = timelineInstruction.element;
                allConsumedElements.add(element);
                // FIXME (matsko): make sure to-be-removed animations are removed properly
                /** @type {?} */
                var details = element[REMOVAL_FLAG];
                if (details && details.removedBeforeQueried)
                    return new NoopAnimationPlayer(timelineInstruction.duration, timelineInstruction.delay);
                /** @type {?} */
                var isQueriedElement = element !== rootElement;
                /** @type {?} */
                var previousPlayers = flattenGroupPlayers((allPreviousPlayersMap.get(element) || EMPTY_PLAYER_ARRAY)
                    .map(( /**
             * @param {?} p
             * @return {?}
             */function (/**
             * @param {?} p
             * @return {?}
             */ p) { return p.getRealPlayer(); })))
                    .filter(( /**
             * @param {?} p
             * @return {?}
             */function (/**
             * @param {?} p
             * @return {?}
             */ p) {
                    // the `element` is not apart of the AnimationPlayer definition, but
                    // Mock/WebAnimations
                    // use the element within their implementation. This will be added in Angular5 to
                    // AnimationPlayer
                    /** @type {?} */
                    var pp = ( /** @type {?} */(p));
                    return pp.element ? pp.element === element : false;
                }));
                /** @type {?} */
                var preStyles = preStylesMap.get(element);
                /** @type {?} */
                var postStyles = postStylesMap.get(element);
                /** @type {?} */
                var keyframes = normalizeKeyframes(_this.driver, _this._normalizer, element, timelineInstruction.keyframes, preStyles, postStyles);
                /** @type {?} */
                var player = _this._buildPlayer(timelineInstruction, keyframes, previousPlayers);
                // this means that this particular player belongs to a sub trigger. It is
                // important that we match this player up with the corresponding (@trigger.listener)
                if (timelineInstruction.subTimeline && skippedPlayersMap) {
                    allSubElements.add(element);
                }
                if (isQueriedElement) {
                    /** @type {?} */
                    var wrappedPlayer = new TransitionAnimationPlayer(namespaceId, triggerName, element);
                    wrappedPlayer.setRealPlayer(player);
                    allQueriedPlayers.push(wrappedPlayer);
                }
                return player;
            }));
            allQueriedPlayers.forEach(( /**
             * @param {?} player
             * @return {?}
             */function (/**
             * @param {?} player
             * @return {?}
             */ player) {
                getOrSetAsInMap(_this.playersByQueriedElement, player.element, []).push(player);
                player.onDone(( /**
                 * @return {?}
                 */function () { return deleteOrUnsetInMap(_this.playersByQueriedElement, player.element, player); }));
            }));
            allConsumedElements.forEach(( /**
             * @param {?} element
             * @return {?}
             */function (/**
             * @param {?} element
             * @return {?}
             */ element) { return addClass(element, NG_ANIMATING_CLASSNAME); }));
            /** @type {?} */
            var player = optimizeGroupPlayer(allNewPlayers);
            player.onDestroy(( /**
             * @return {?}
             */function () {
                allConsumedElements.forEach(( /**
                 * @param {?} element
                 * @return {?}
                 */function (/**
                 * @param {?} element
                 * @return {?}
                 */ element) { return removeClass(element, NG_ANIMATING_CLASSNAME); }));
                setStyles(rootElement, instruction.toStyles);
            }));
            // this basically makes all of the callbacks for sub element animations
            // be dependent on the upper players for when they finish
            allSubElements.forEach(( /**
             * @param {?} element
             * @return {?}
             */function (/**
             * @param {?} element
             * @return {?}
             */ element) { getOrSetAsInMap(skippedPlayersMap, element, []).push(player); }));
            return player;
        };
        /**
         * @private
         * @param {?} instruction
         * @param {?} keyframes
         * @param {?} previousPlayers
         * @return {?}
         */
        TransitionAnimationEngine.prototype._buildPlayer = function (instruction, keyframes, previousPlayers) {
            if (keyframes.length > 0) {
                return this.driver.animate(instruction.element, keyframes, instruction.duration, instruction.delay, instruction.easing, previousPlayers);
            }
            // special case for when an empty transition|definition is provided
            // ... there is no point in rendering an empty animation
            return new NoopAnimationPlayer(instruction.duration, instruction.delay);
        };
        return TransitionAnimationEngine;
    }());
    var TransitionAnimationPlayer = /** @class */ (function () {
        /**
         * @param {?} namespaceId
         * @param {?} triggerName
         * @param {?} element
         */
        function TransitionAnimationPlayer(namespaceId, triggerName, element) {
            this.namespaceId = namespaceId;
            this.triggerName = triggerName;
            this.element = element;
            this._player = new NoopAnimationPlayer();
            this._containsRealPlayer = false;
            this._queuedCallbacks = {};
            this.destroyed = false;
            this.markedForDestroy = false;
            this.disabled = false;
            this.queued = true;
            this.totalTime = 0;
        }
        /**
         * @param {?} player
         * @return {?}
         */
        TransitionAnimationPlayer.prototype.setRealPlayer = function (player) {
            var _this = this;
            if (this._containsRealPlayer)
                return;
            this._player = player;
            Object.keys(this._queuedCallbacks).forEach(( /**
             * @param {?} phase
             * @return {?}
             */function (/**
             * @param {?} phase
             * @return {?}
             */ phase) {
                _this._queuedCallbacks[phase].forEach(( /**
                 * @param {?} callback
                 * @return {?}
                 */function (/**
                 * @param {?} callback
                 * @return {?}
                 */ callback) { return listenOnPlayer(player, phase, undefined, callback); }));
            }));
            this._queuedCallbacks = {};
            this._containsRealPlayer = true;
            this.overrideTotalTime(player.totalTime);
            (( /** @type {?} */(this))).queued = false;
        };
        /**
         * @return {?}
         */
        TransitionAnimationPlayer.prototype.getRealPlayer = function () { return this._player; };
        /**
         * @param {?} totalTime
         * @return {?}
         */
        TransitionAnimationPlayer.prototype.overrideTotalTime = function (totalTime) { (( /** @type {?} */(this))).totalTime = totalTime; };
        /**
         * @param {?} player
         * @return {?}
         */
        TransitionAnimationPlayer.prototype.syncPlayerEvents = function (player) {
            var _this = this;
            /** @type {?} */
            var p = ( /** @type {?} */(this._player));
            if (p.triggerCallback) {
                player.onStart(( /**
                 * @return {?}
                 */function () { return ( /** @type {?} */(p.triggerCallback))('start'); }));
            }
            player.onDone(( /**
             * @return {?}
             */function () { return _this.finish(); }));
            player.onDestroy(( /**
             * @return {?}
             */function () { return _this.destroy(); }));
        };
        /**
         * @private
         * @param {?} name
         * @param {?} callback
         * @return {?}
         */
        TransitionAnimationPlayer.prototype._queueEvent = function (name, callback) {
            getOrSetAsInMap(this._queuedCallbacks, name, []).push(callback);
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        TransitionAnimationPlayer.prototype.onDone = function (fn) {
            if (this.queued) {
                this._queueEvent('done', fn);
            }
            this._player.onDone(fn);
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        TransitionAnimationPlayer.prototype.onStart = function (fn) {
            if (this.queued) {
                this._queueEvent('start', fn);
            }
            this._player.onStart(fn);
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        TransitionAnimationPlayer.prototype.onDestroy = function (fn) {
            if (this.queued) {
                this._queueEvent('destroy', fn);
            }
            this._player.onDestroy(fn);
        };
        /**
         * @return {?}
         */
        TransitionAnimationPlayer.prototype.init = function () { this._player.init(); };
        /**
         * @return {?}
         */
        TransitionAnimationPlayer.prototype.hasStarted = function () { return this.queued ? false : this._player.hasStarted(); };
        /**
         * @return {?}
         */
        TransitionAnimationPlayer.prototype.play = function () { !this.queued && this._player.play(); };
        /**
         * @return {?}
         */
        TransitionAnimationPlayer.prototype.pause = function () { !this.queued && this._player.pause(); };
        /**
         * @return {?}
         */
        TransitionAnimationPlayer.prototype.restart = function () { !this.queued && this._player.restart(); };
        /**
         * @return {?}
         */
        TransitionAnimationPlayer.prototype.finish = function () { this._player.finish(); };
        /**
         * @return {?}
         */
        TransitionAnimationPlayer.prototype.destroy = function () {
            (( /** @type {?} */(this))).destroyed = true;
            this._player.destroy();
        };
        /**
         * @return {?}
         */
        TransitionAnimationPlayer.prototype.reset = function () { !this.queued && this._player.reset(); };
        /**
         * @param {?} p
         * @return {?}
         */
        TransitionAnimationPlayer.prototype.setPosition = function (p) {
            if (!this.queued) {
                this._player.setPosition(p);
            }
        };
        /**
         * @return {?}
         */
        TransitionAnimationPlayer.prototype.getPosition = function () { return this.queued ? 0 : this._player.getPosition(); };
        /**
         * \@internal
         * @param {?} phaseName
         * @return {?}
         */
        TransitionAnimationPlayer.prototype.triggerCallback = function (phaseName) {
            /** @type {?} */
            var p = ( /** @type {?} */(this._player));
            if (p.triggerCallback) {
                p.triggerCallback(phaseName);
            }
        };
        return TransitionAnimationPlayer;
    }());
    /**
     * @param {?} map
     * @param {?} key
     * @param {?} value
     * @return {?}
     */
    function deleteOrUnsetInMap(map, key, value) {
        /** @type {?} */
        var currentValues;
        if (map instanceof Map) {
            currentValues = map.get(key);
            if (currentValues) {
                if (currentValues.length) {
                    /** @type {?} */
                    var index = currentValues.indexOf(value);
                    currentValues.splice(index, 1);
                }
                if (currentValues.length == 0) {
                    map.delete(key);
                }
            }
        }
        else {
            currentValues = map[key];
            if (currentValues) {
                if (currentValues.length) {
                    /** @type {?} */
                    var index = currentValues.indexOf(value);
                    currentValues.splice(index, 1);
                }
                if (currentValues.length == 0) {
                    delete map[key];
                }
            }
        }
        return currentValues;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    function normalizeTriggerValue(value) {
        // we use `!= null` here because it's the most simple
        // way to test against a "falsy" value without mixing
        // in empty strings or a zero value. DO NOT OPTIMIZE.
        return value != null ? value : null;
    }
    /**
     * @param {?} node
     * @return {?}
     */
    function isElementNode(node) {
        return node && node['nodeType'] === 1;
    }
    /**
     * @param {?} eventName
     * @return {?}
     */
    function isTriggerEventValid(eventName) {
        return eventName == 'start' || eventName == 'done';
    }
    /**
     * @param {?} element
     * @param {?=} value
     * @return {?}
     */
    function cloakElement(element, value) {
        /** @type {?} */
        var oldValue = element.style.display;
        element.style.display = value != null ? value : 'none';
        return oldValue;
    }
    /**
     * @param {?} valuesMap
     * @param {?} driver
     * @param {?} elements
     * @param {?} elementPropsMap
     * @param {?} defaultStyle
     * @return {?}
     */
    function cloakAndComputeStyles(valuesMap, driver, elements, elementPropsMap, defaultStyle) {
        /** @type {?} */
        var cloakVals = [];
        elements.forEach(( /**
         * @param {?} element
         * @return {?}
         */function (/**
         * @param {?} element
         * @return {?}
         */ element) { return cloakVals.push(cloakElement(element)); }));
        /** @type {?} */
        var failedElements = [];
        elementPropsMap.forEach(( /**
         * @param {?} props
         * @param {?} element
         * @return {?}
         */function (props, element) {
            /** @type {?} */
            var styles = {};
            props.forEach(( /**
             * @param {?} prop
             * @return {?}
             */function (/**
             * @param {?} prop
             * @return {?}
             */ prop) {
                /** @type {?} */
                var value = styles[prop] = driver.computeStyle(element, prop, defaultStyle);
                // there is no easy way to detect this because a sub element could be removed
                // by a parent animation element being detached.
                if (!value || value.length == 0) {
                    element[REMOVAL_FLAG] = NULL_REMOVED_QUERIED_STATE;
                    failedElements.push(element);
                }
            }));
            valuesMap.set(element, styles);
        }));
        // we use a index variable here since Set.forEach(a, i) does not return
        // an index value for the closure (but instead just the value)
        /** @type {?} */
        var i = 0;
        elements.forEach(( /**
         * @param {?} element
         * @return {?}
         */function (/**
         * @param {?} element
         * @return {?}
         */ element) { return cloakElement(element, cloakVals[i++]); }));
        return failedElements;
    }
    /*
    Since the Angular renderer code will return a collection of inserted
    nodes in all areas of a DOM tree, it's up to this algorithm to figure
    out which nodes are roots for each animation @trigger.

    By placing each inserted node into a Set and traversing upwards, it
    is possible to find the @trigger elements and well any direct *star
    insertion nodes, if a @trigger root is found then the enter element
    is placed into the Map[@trigger] spot.
     */
    /**
     * @param {?} roots
     * @param {?} nodes
     * @return {?}
     */
    function buildRootMap(roots, nodes) {
        /** @type {?} */
        var rootMap = new Map();
        roots.forEach(( /**
         * @param {?} root
         * @return {?}
         */function (/**
         * @param {?} root
         * @return {?}
         */ root) { return rootMap.set(root, []); }));
        if (nodes.length == 0)
            return rootMap;
        /** @type {?} */
        var NULL_NODE = 1;
        /** @type {?} */
        var nodeSet = new Set(nodes);
        /** @type {?} */
        var localRootMap = new Map();
        /**
         * @param {?} node
         * @return {?}
         */
        function getRoot(node) {
            if (!node)
                return NULL_NODE;
            /** @type {?} */
            var root = localRootMap.get(node);
            if (root)
                return root;
            /** @type {?} */
            var parent = node.parentNode;
            if (rootMap.has(parent)) { // ngIf inside @trigger
                root = parent;
            }
            else if (nodeSet.has(parent)) { // ngIf inside ngIf
                root = NULL_NODE;
            }
            else { // recurse upwards
                root = getRoot(parent);
            }
            localRootMap.set(node, root);
            return root;
        }
        nodes.forEach(( /**
         * @param {?} node
         * @return {?}
         */function (/**
         * @param {?} node
         * @return {?}
         */ node) {
            /** @type {?} */
            var root = getRoot(node);
            if (root !== NULL_NODE) {
                ( /** @type {?} */(rootMap.get(root))).push(node);
            }
        }));
        return rootMap;
    }
    /** @type {?} */
    var CLASSES_CACHE_KEY = '$$classes';
    /**
     * @param {?} element
     * @param {?} className
     * @return {?}
     */
    function addClass(element, className) {
        if (element.classList) {
            element.classList.add(className);
        }
        else {
            /** @type {?} */
            var classes = element[CLASSES_CACHE_KEY];
            if (!classes) {
                classes = element[CLASSES_CACHE_KEY] = {};
            }
            classes[className] = true;
        }
    }
    /**
     * @param {?} element
     * @param {?} className
     * @return {?}
     */
    function removeClass(element, className) {
        if (element.classList) {
            element.classList.remove(className);
        }
        else {
            /** @type {?} */
            var classes = element[CLASSES_CACHE_KEY];
            if (classes) {
                delete classes[className];
            }
        }
    }
    /**
     * @param {?} engine
     * @param {?} element
     * @param {?} players
     * @return {?}
     */
    function removeNodesAfterAnimationDone(engine, element, players) {
        optimizeGroupPlayer(players).onDone(( /**
         * @return {?}
         */function () { return engine.processLeaveNode(element); }));
    }
    /**
     * @param {?} players
     * @return {?}
     */
    function flattenGroupPlayers(players) {
        /** @type {?} */
        var finalPlayers = [];
        _flattenGroupPlayersRecur(players, finalPlayers);
        return finalPlayers;
    }
    /**
     * @param {?} players
     * @param {?} finalPlayers
     * @return {?}
     */
    function _flattenGroupPlayersRecur(players, finalPlayers) {
        for (var i_140 = 0; i_140 < players.length; i_140++) {
            /** @type {?} */
            var player = players[i_140];
            if (player instanceof AnimationGroupPlayer) {
                _flattenGroupPlayersRecur(player.players, finalPlayers);
            }
            else {
                finalPlayers.push(( /** @type {?} */(player)));
            }
        }
    }
    /**
     * @param {?} a
     * @param {?} b
     * @return {?}
     */
    function objEquals(a, b) {
        /** @type {?} */
        var k1 = Object.keys(a);
        /** @type {?} */
        var k2 = Object.keys(b);
        if (k1.length != k2.length)
            return false;
        for (var i_141 = 0; i_141 < k1.length; i_141++) {
            /** @type {?} */
            var prop = k1[i_141];
            if (!b.hasOwnProperty(prop) || a[prop] !== b[prop])
                return false;
        }
        return true;
    }
    /**
     * @param {?} element
     * @param {?} allPreStyleElements
     * @param {?} allPostStyleElements
     * @return {?}
     */
    function replacePostStylesAsPre(element, allPreStyleElements, allPostStyleElements) {
        /** @type {?} */
        var postEntry = allPostStyleElements.get(element);
        if (!postEntry)
            return false;
        /** @type {?} */
        var preEntry = allPreStyleElements.get(element);
        if (preEntry) {
            postEntry.forEach(( /**
             * @param {?} data
             * @return {?}
             */function (/**
             * @param {?} data
             * @return {?}
             */ data) { return ( /** @type {?} */(preEntry)).add(data); }));
        }
        else {
            allPreStyleElements.set(element, postEntry);
        }
        allPostStyleElements.delete(element);
        return true;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AnimationEngine = /** @class */ (function () {
        /**
         * @param {?} bodyNode
         * @param {?} _driver
         * @param {?} normalizer
         */
        function AnimationEngine(bodyNode, _driver, normalizer) {
            var _this = this;
            this.bodyNode = bodyNode;
            this._driver = _driver;
            this._triggerCache = {};
            // this method is designed to be overridden by the code that uses this engine
            this.onRemovalComplete = ( /**
             * @param {?} element
             * @param {?} context
             * @return {?}
             */function (element, context) { });
            this._transitionEngine = new TransitionAnimationEngine(bodyNode, _driver, normalizer);
            this._timelineEngine = new TimelineAnimationEngine(bodyNode, _driver, normalizer);
            this._transitionEngine.onRemovalComplete = ( /**
             * @param {?} element
             * @param {?} context
             * @return {?}
             */function (element, context) { return _this.onRemovalComplete(element, context); });
        }
        /**
         * @param {?} componentId
         * @param {?} namespaceId
         * @param {?} hostElement
         * @param {?} name
         * @param {?} metadata
         * @return {?}
         */
        AnimationEngine.prototype.registerTrigger = function (componentId, namespaceId, hostElement, name, metadata) {
            /** @type {?} */
            var cacheKey = componentId + '-' + name;
            /** @type {?} */
            var trigger = this._triggerCache[cacheKey];
            if (!trigger) {
                /** @type {?} */
                var errors = [];
                /** @type {?} */
                var ast = ( /** @type {?} */(buildAnimationAst(this._driver, ( /** @type {?} */(metadata)), errors)));
                if (errors.length) {
                    throw new Error("The animation trigger \"" + name + "\" has failed to build due to the following errors:\n - " + errors.join("\n - "));
                }
                trigger = buildTrigger(name, ast);
                this._triggerCache[cacheKey] = trigger;
            }
            this._transitionEngine.registerTrigger(namespaceId, name, trigger);
        };
        /**
         * @param {?} namespaceId
         * @param {?} hostElement
         * @return {?}
         */
        AnimationEngine.prototype.register = function (namespaceId, hostElement) {
            this._transitionEngine.register(namespaceId, hostElement);
        };
        /**
         * @param {?} namespaceId
         * @param {?} context
         * @return {?}
         */
        AnimationEngine.prototype.destroy = function (namespaceId, context) {
            this._transitionEngine.destroy(namespaceId, context);
        };
        /**
         * @param {?} namespaceId
         * @param {?} element
         * @param {?} parent
         * @param {?} insertBefore
         * @return {?}
         */
        AnimationEngine.prototype.onInsert = function (namespaceId, element, parent, insertBefore) {
            this._transitionEngine.insertNode(namespaceId, element, parent, insertBefore);
        };
        /**
         * @param {?} namespaceId
         * @param {?} element
         * @param {?} context
         * @param {?=} isHostElement
         * @return {?}
         */
        AnimationEngine.prototype.onRemove = function (namespaceId, element, context, isHostElement) {
            this._transitionEngine.removeNode(namespaceId, element, isHostElement || false, context);
        };
        /**
         * @param {?} element
         * @param {?} disable
         * @return {?}
         */
        AnimationEngine.prototype.disableAnimations = function (element, disable) {
            this._transitionEngine.markElementAsDisabled(element, disable);
        };
        /**
         * @param {?} namespaceId
         * @param {?} element
         * @param {?} property
         * @param {?} value
         * @return {?}
         */
        AnimationEngine.prototype.process = function (namespaceId, element, property, value) {
            if (property.charAt(0) == '@') {
                var _b = __read(parseTimelineCommand(property), 2), id = _b[0], action = _b[1];
                /** @type {?} */
                var args = ( /** @type {?} */(value));
                this._timelineEngine.command(id, element, action, args);
            }
            else {
                this._transitionEngine.trigger(namespaceId, element, property, value);
            }
        };
        /**
         * @param {?} namespaceId
         * @param {?} element
         * @param {?} eventName
         * @param {?} eventPhase
         * @param {?} callback
         * @return {?}
         */
        AnimationEngine.prototype.listen = function (namespaceId, element, eventName, eventPhase, callback) {
            // @@listen
            if (eventName.charAt(0) == '@') {
                var _b = __read(parseTimelineCommand(eventName), 2), id = _b[0], action = _b[1];
                return this._timelineEngine.listen(id, element, action, callback);
            }
            return this._transitionEngine.listen(namespaceId, element, eventName, eventPhase, callback);
        };
        /**
         * @param {?=} microtaskId
         * @return {?}
         */
        AnimationEngine.prototype.flush = function (microtaskId) {
            if (microtaskId === void 0) { microtaskId = -1; }
            this._transitionEngine.flush(microtaskId);
        };
        Object.defineProperty(AnimationEngine.prototype, "players", {
            /**
             * @return {?}
             */
            get: function () {
                return (( /** @type {?} */(this._transitionEngine.players)))
                    .concat(( /** @type {?} */(this._timelineEngine.players)));
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        AnimationEngine.prototype.whenRenderingDone = function () { return this._transitionEngine.whenRenderingDone(); };
        return AnimationEngine;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Returns an instance of `SpecialCasedStyles` if and when any special (non animateable) styles are
     * detected.
     *
     * In CSS there exist properties that cannot be animated within a keyframe animation
     * (whether it be via CSS keyframes or web-animations) and the animation implementation
     * will ignore them. This function is designed to detect those special cased styles and
     * return a container that will be executed at the start and end of the animation.
     *
     * @param {?} element
     * @param {?} styles
     * @return {?} an instance of `SpecialCasedStyles` if any special styles are detected otherwise `null`
     */
    function packageNonAnimatableStyles(element, styles) {
        /** @type {?} */
        var startStyles = null;
        /** @type {?} */
        var endStyles = null;
        if (Array.isArray(styles) && styles.length) {
            startStyles = filterNonAnimatableStyles(styles[0]);
            if (styles.length > 1) {
                endStyles = filterNonAnimatableStyles(styles[styles.length - 1]);
            }
        }
        else if (styles) {
            startStyles = filterNonAnimatableStyles(styles);
        }
        return (startStyles || endStyles) ? new SpecialCasedStyles(element, startStyles, endStyles) :
            null;
    }
    /**
     * Designed to be executed during a keyframe-based animation to apply any special-cased styles.
     *
     * When started (when the `start()` method is run) then the provided `startStyles`
     * will be applied. When finished (when the `finish()` method is called) the
     * `endStyles` will be applied as well any any starting styles. Finally when
     * `destroy()` is called then all styles will be removed.
     */
    var SpecialCasedStyles = /** @class */ (function () {
        /**
         * @param {?} _element
         * @param {?} _startStyles
         * @param {?} _endStyles
         */
        function SpecialCasedStyles(_element, _startStyles, _endStyles) {
            this._element = _element;
            this._startStyles = _startStyles;
            this._endStyles = _endStyles;
            this._state = 0 /* Pending */;
            /** @type {?} */
            var initialStyles = SpecialCasedStyles.initialStylesByElement.get(_element);
            if (!initialStyles) {
                SpecialCasedStyles.initialStylesByElement.set(_element, initialStyles = {});
            }
            this._initialStyles = initialStyles;
        }
        /**
         * @return {?}
         */
        SpecialCasedStyles.prototype.start = function () {
            if (this._state < 1 /* Started */) {
                if (this._startStyles) {
                    setStyles(this._element, this._startStyles, this._initialStyles);
                }
                this._state = 1 /* Started */;
            }
        };
        /**
         * @return {?}
         */
        SpecialCasedStyles.prototype.finish = function () {
            this.start();
            if (this._state < 2 /* Finished */) {
                setStyles(this._element, this._initialStyles);
                if (this._endStyles) {
                    setStyles(this._element, this._endStyles);
                    this._endStyles = null;
                }
                this._state = 1 /* Started */;
            }
        };
        /**
         * @return {?}
         */
        SpecialCasedStyles.prototype.destroy = function () {
            this.finish();
            if (this._state < 3 /* Destroyed */) {
                SpecialCasedStyles.initialStylesByElement.delete(this._element);
                if (this._startStyles) {
                    eraseStyles(this._element, this._startStyles);
                    this._endStyles = null;
                }
                if (this._endStyles) {
                    eraseStyles(this._element, this._endStyles);
                    this._endStyles = null;
                }
                setStyles(this._element, this._initialStyles);
                this._state = 3 /* Destroyed */;
            }
        };
        return SpecialCasedStyles;
    }());
    SpecialCasedStyles.initialStylesByElement = new WeakMap();
    /**
     * @param {?} styles
     * @return {?}
     */
    function filterNonAnimatableStyles(styles) {
        /** @type {?} */
        var result = null;
        /** @type {?} */
        var props = Object.keys(styles);
        for (var i_142 = 0; i_142 < props.length; i_142++) {
            /** @type {?} */
            var prop = props[i_142];
            if (isNonAnimatableStyle(prop)) {
                result = result || {};
                result[prop] = styles[prop];
            }
        }
        return result;
    }
    /**
     * @param {?} prop
     * @return {?}
     */
    function isNonAnimatableStyle(prop) {
        return prop === 'display' || prop === 'position';
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     * @type {?}
     */
    var ELAPSED_TIME_MAX_DECIMAL_PLACES = 3;
    /** @type {?} */
    var ANIMATION_PROP = 'animation';
    /** @type {?} */
    var ANIMATIONEND_EVENT = 'animationend';
    /** @type {?} */
    var ONE_SECOND$1 = 1000;
    var ElementAnimationStyleHandler = /** @class */ (function () {
        /**
         * @param {?} _element
         * @param {?} _name
         * @param {?} _duration
         * @param {?} _delay
         * @param {?} _easing
         * @param {?} _fillMode
         * @param {?} _onDoneFn
         */
        function ElementAnimationStyleHandler(_element, _name, _duration, _delay, _easing, _fillMode, _onDoneFn) {
            var _this = this;
            this._element = _element;
            this._name = _name;
            this._duration = _duration;
            this._delay = _delay;
            this._easing = _easing;
            this._fillMode = _fillMode;
            this._onDoneFn = _onDoneFn;
            this._finished = false;
            this._destroyed = false;
            this._startTime = 0;
            this._position = 0;
            this._eventFn = ( /**
             * @param {?} e
             * @return {?}
             */function (e) { return _this._handleCallback(e); });
        }
        /**
         * @return {?}
         */
        ElementAnimationStyleHandler.prototype.apply = function () {
            applyKeyframeAnimation(this._element, this._duration + "ms " + this._easing + " " + this._delay + "ms 1 normal " + this._fillMode + " " + this._name);
            addRemoveAnimationEvent(this._element, this._eventFn, false);
            this._startTime = Date.now();
        };
        /**
         * @return {?}
         */
        ElementAnimationStyleHandler.prototype.pause = function () { playPauseAnimation(this._element, this._name, 'paused'); };
        /**
         * @return {?}
         */
        ElementAnimationStyleHandler.prototype.resume = function () { playPauseAnimation(this._element, this._name, 'running'); };
        /**
         * @param {?} position
         * @return {?}
         */
        ElementAnimationStyleHandler.prototype.setPosition = function (position) {
            /** @type {?} */
            var index = findIndexForAnimation(this._element, this._name);
            this._position = position * this._duration;
            setAnimationStyle(this._element, 'Delay', "-" + this._position + "ms", index);
        };
        /**
         * @return {?}
         */
        ElementAnimationStyleHandler.prototype.getPosition = function () { return this._position; };
        /**
         * @private
         * @param {?} event
         * @return {?}
         */
        ElementAnimationStyleHandler.prototype._handleCallback = function (event) {
            /** @type {?} */
            var timestamp = event._ngTestManualTimestamp || Date.now();
            /** @type {?} */
            var elapsedTime = parseFloat(event.elapsedTime.toFixed(ELAPSED_TIME_MAX_DECIMAL_PLACES)) * ONE_SECOND$1;
            if (event.animationName == this._name &&
                Math.max(timestamp - this._startTime, 0) >= this._delay && elapsedTime >= this._duration) {
                this.finish();
            }
        };
        /**
         * @return {?}
         */
        ElementAnimationStyleHandler.prototype.finish = function () {
            if (this._finished)
                return;
            this._finished = true;
            this._onDoneFn();
            addRemoveAnimationEvent(this._element, this._eventFn, true);
        };
        /**
         * @return {?}
         */
        ElementAnimationStyleHandler.prototype.destroy = function () {
            if (this._destroyed)
                return;
            this._destroyed = true;
            this.finish();
            removeKeyframeAnimation(this._element, this._name);
        };
        return ElementAnimationStyleHandler;
    }());
    /**
     * @param {?} element
     * @param {?} name
     * @param {?} status
     * @return {?}
     */
    function playPauseAnimation(element, name, status) {
        /** @type {?} */
        var index = findIndexForAnimation(element, name);
        setAnimationStyle(element, 'PlayState', status, index);
    }
    /**
     * @param {?} element
     * @param {?} value
     * @return {?}
     */
    function applyKeyframeAnimation(element, value) {
        /** @type {?} */
        var anim = getAnimationStyle(element, '').trim();
        /** @type {?} */
        var index = 0;
        if (anim.length) {
            index = countChars(anim, ',') + 1;
            value = anim + ", " + value;
        }
        setAnimationStyle(element, '', value);
        return index;
    }
    /**
     * @param {?} element
     * @param {?} name
     * @return {?}
     */
    function removeKeyframeAnimation(element, name) {
        /** @type {?} */
        var anim = getAnimationStyle(element, '');
        /** @type {?} */
        var tokens = anim.split(',');
        /** @type {?} */
        var index = findMatchingTokenIndex(tokens, name);
        if (index >= 0) {
            tokens.splice(index, 1);
            /** @type {?} */
            var newValue = tokens.join(',');
            setAnimationStyle(element, '', newValue);
        }
    }
    /**
     * @param {?} element
     * @param {?} value
     * @return {?}
     */
    function findIndexForAnimation(element, value) {
        /** @type {?} */
        var anim = getAnimationStyle(element, '');
        if (anim.indexOf(',') > 0) {
            /** @type {?} */
            var tokens = anim.split(',');
            return findMatchingTokenIndex(tokens, value);
        }
        return findMatchingTokenIndex([anim], value);
    }
    /**
     * @param {?} tokens
     * @param {?} searchToken
     * @return {?}
     */
    function findMatchingTokenIndex(tokens, searchToken) {
        for (var i_143 = 0; i_143 < tokens.length; i_143++) {
            if (tokens[i_143].indexOf(searchToken) >= 0) {
                return i_143;
            }
        }
        return -1;
    }
    /**
     * @param {?} element
     * @param {?} fn
     * @param {?} doRemove
     * @return {?}
     */
    function addRemoveAnimationEvent(element, fn, doRemove) {
        doRemove ? element.removeEventListener(ANIMATIONEND_EVENT, fn) :
            element.addEventListener(ANIMATIONEND_EVENT, fn);
    }
    /**
     * @param {?} element
     * @param {?} name
     * @param {?} value
     * @param {?=} index
     * @return {?}
     */
    function setAnimationStyle(element, name, value, index) {
        /** @type {?} */
        var prop = ANIMATION_PROP + name;
        if (index != null) {
            /** @type {?} */
            var oldValue = element.style[prop];
            if (oldValue.length) {
                /** @type {?} */
                var tokens = oldValue.split(',');
                tokens[index] = value;
                value = tokens.join(',');
            }
        }
        element.style[prop] = value;
    }
    /**
     * @param {?} element
     * @param {?} name
     * @return {?}
     */
    function getAnimationStyle(element, name) {
        return element.style[ANIMATION_PROP + name];
    }
    /**
     * @param {?} value
     * @param {?} char
     * @return {?}
     */
    function countChars(value, char) {
        /** @type {?} */
        var count = 0;
        for (var i_144 = 0; i_144 < value.length; i_144++) {
            /** @type {?} */
            var c_2 = value.charAt(i_144);
            if (c_2 === char)
                count++;
        }
        return count;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var DEFAULT_FILL_MODE = 'forwards';
    /** @type {?} */
    var DEFAULT_EASING = 'linear';
    var CssKeyframesPlayer = /** @class */ (function () {
        /**
         * @param {?} element
         * @param {?} keyframes
         * @param {?} animationName
         * @param {?} _duration
         * @param {?} _delay
         * @param {?} easing
         * @param {?} _finalStyles
         * @param {?=} _specialStyles
         */
        function CssKeyframesPlayer(element, keyframes, animationName, _duration, _delay, easing, _finalStyles, _specialStyles) {
            this.element = element;
            this.keyframes = keyframes;
            this.animationName = animationName;
            this._duration = _duration;
            this._delay = _delay;
            this._finalStyles = _finalStyles;
            this._specialStyles = _specialStyles;
            this._onDoneFns = [];
            this._onStartFns = [];
            this._onDestroyFns = [];
            this._started = false;
            this.currentSnapshot = {};
            this._state = 0;
            this.easing = easing || DEFAULT_EASING;
            this.totalTime = _duration + _delay;
            this._buildStyler();
        }
        /**
         * @param {?} fn
         * @return {?}
         */
        CssKeyframesPlayer.prototype.onStart = function (fn) { this._onStartFns.push(fn); };
        /**
         * @param {?} fn
         * @return {?}
         */
        CssKeyframesPlayer.prototype.onDone = function (fn) { this._onDoneFns.push(fn); };
        /**
         * @param {?} fn
         * @return {?}
         */
        CssKeyframesPlayer.prototype.onDestroy = function (fn) { this._onDestroyFns.push(fn); };
        /**
         * @return {?}
         */
        CssKeyframesPlayer.prototype.destroy = function () {
            this.init();
            if (this._state >= 4 /* DESTROYED */)
                return;
            this._state = 4 /* DESTROYED */;
            this._styler.destroy();
            this._flushStartFns();
            this._flushDoneFns();
            if (this._specialStyles) {
                this._specialStyles.destroy();
            }
            this._onDestroyFns.forEach(( /**
             * @param {?} fn
             * @return {?}
             */function (/**
             * @param {?} fn
             * @return {?}
             */ fn) { return fn(); }));
            this._onDestroyFns = [];
        };
        /**
         * @private
         * @return {?}
         */
        CssKeyframesPlayer.prototype._flushDoneFns = function () {
            this._onDoneFns.forEach(( /**
             * @param {?} fn
             * @return {?}
             */function (/**
             * @param {?} fn
             * @return {?}
             */ fn) { return fn(); }));
            this._onDoneFns = [];
        };
        /**
         * @private
         * @return {?}
         */
        CssKeyframesPlayer.prototype._flushStartFns = function () {
            this._onStartFns.forEach(( /**
             * @param {?} fn
             * @return {?}
             */function (/**
             * @param {?} fn
             * @return {?}
             */ fn) { return fn(); }));
            this._onStartFns = [];
        };
        /**
         * @return {?}
         */
        CssKeyframesPlayer.prototype.finish = function () {
            this.init();
            if (this._state >= 3 /* FINISHED */)
                return;
            this._state = 3 /* FINISHED */;
            this._styler.finish();
            this._flushStartFns();
            if (this._specialStyles) {
                this._specialStyles.finish();
            }
            this._flushDoneFns();
        };
        /**
         * @param {?} value
         * @return {?}
         */
        CssKeyframesPlayer.prototype.setPosition = function (value) { this._styler.setPosition(value); };
        /**
         * @return {?}
         */
        CssKeyframesPlayer.prototype.getPosition = function () { return this._styler.getPosition(); };
        /**
         * @return {?}
         */
        CssKeyframesPlayer.prototype.hasStarted = function () { return this._state >= 2 /* STARTED */; };
        /**
         * @return {?}
         */
        CssKeyframesPlayer.prototype.init = function () {
            if (this._state >= 1 /* INITIALIZED */)
                return;
            this._state = 1 /* INITIALIZED */;
            /** @type {?} */
            var elm = this.element;
            this._styler.apply();
            if (this._delay) {
                this._styler.pause();
            }
        };
        /**
         * @return {?}
         */
        CssKeyframesPlayer.prototype.play = function () {
            this.init();
            if (!this.hasStarted()) {
                this._flushStartFns();
                this._state = 2 /* STARTED */;
                if (this._specialStyles) {
                    this._specialStyles.start();
                }
            }
            this._styler.resume();
        };
        /**
         * @return {?}
         */
        CssKeyframesPlayer.prototype.pause = function () {
            this.init();
            this._styler.pause();
        };
        /**
         * @return {?}
         */
        CssKeyframesPlayer.prototype.restart = function () {
            this.reset();
            this.play();
        };
        /**
         * @return {?}
         */
        CssKeyframesPlayer.prototype.reset = function () {
            this._styler.destroy();
            this._buildStyler();
            this._styler.apply();
        };
        /**
         * @private
         * @return {?}
         */
        CssKeyframesPlayer.prototype._buildStyler = function () {
            var _this = this;
            this._styler = new ElementAnimationStyleHandler(this.element, this.animationName, this._duration, this._delay, this.easing, DEFAULT_FILL_MODE, ( /**
             * @return {?}
             */function () { return _this.finish(); }));
        };
        /**
         * \@internal
         * @param {?} phaseName
         * @return {?}
         */
        CssKeyframesPlayer.prototype.triggerCallback = function (phaseName) {
            /** @type {?} */
            var methods = phaseName == 'start' ? this._onStartFns : this._onDoneFns;
            methods.forEach(( /**
             * @param {?} fn
             * @return {?}
             */function (/**
             * @param {?} fn
             * @return {?}
             */ fn) { return fn(); }));
            methods.length = 0;
        };
        /**
         * @return {?}
         */
        CssKeyframesPlayer.prototype.beforeDestroy = function () {
            var _this = this;
            this.init();
            /** @type {?} */
            var styles = {};
            if (this.hasStarted()) {
                /** @type {?} */
                var finished_1 = this._state >= 3 /* FINISHED */;
                Object.keys(this._finalStyles).forEach(( /**
                 * @param {?} prop
                 * @return {?}
                 */function (/**
                 * @param {?} prop
                 * @return {?}
                 */ prop) {
                    if (prop != 'offset') {
                        styles[prop] = finished_1 ? _this._finalStyles[prop] : computeStyle(_this.element, prop);
                    }
                }));
            }
            this.currentSnapshot = styles;
        };
        return CssKeyframesPlayer;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DirectStylePlayer = /** @class */ (function (_super) {
        __extends(DirectStylePlayer, _super);
        /**
         * @param {?} element
         * @param {?} styles
         */
        function DirectStylePlayer(element, styles) {
            var _this = _super.call(this) || this;
            _this.element = element;
            _this._startingStyles = {};
            _this.__initialized = false;
            _this._styles = hypenatePropsObject(styles);
            return _this;
        }
        /**
         * @return {?}
         */
        DirectStylePlayer.prototype.init = function () {
            var _this = this;
            if (this.__initialized || !this._startingStyles)
                return;
            this.__initialized = true;
            Object.keys(this._styles).forEach(( /**
             * @param {?} prop
             * @return {?}
             */function (/**
             * @param {?} prop
             * @return {?}
             */ prop) {
                ( /** @type {?} */(_this._startingStyles))[prop] = _this.element.style[prop];
            }));
            _super.prototype.init.call(this);
        };
        /**
         * @return {?}
         */
        DirectStylePlayer.prototype.play = function () {
            var _this = this;
            if (!this._startingStyles)
                return;
            this.init();
            Object.keys(this._styles)
                .forEach(( /**
         * @param {?} prop
         * @return {?}
         */function (/**
         * @param {?} prop
         * @return {?}
         */ prop) { return _this.element.style.setProperty(prop, _this._styles[prop]); }));
            _super.prototype.play.call(this);
        };
        /**
         * @return {?}
         */
        DirectStylePlayer.prototype.destroy = function () {
            var _this = this;
            if (!this._startingStyles)
                return;
            Object.keys(this._startingStyles).forEach(( /**
             * @param {?} prop
             * @return {?}
             */function (/**
             * @param {?} prop
             * @return {?}
             */ prop) {
                /** @type {?} */
                var value = ( /** @type {?} */(_this._startingStyles))[prop];
                if (value) {
                    _this.element.style.setProperty(prop, value);
                }
                else {
                    _this.element.style.removeProperty(prop);
                }
            }));
            this._startingStyles = null;
            _super.prototype.destroy.call(this);
        };
        return DirectStylePlayer;
    }(NoopAnimationPlayer));
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var KEYFRAMES_NAME_PREFIX = 'gen_css_kf_';
    /** @type {?} */
    var TAB_SPACE = ' ';
    var CssKeyframesDriver = /** @class */ (function () {
        function CssKeyframesDriver() {
            this._count = 0;
            this._head = document.querySelector('head');
            this._warningIssued = false;
        }
        /**
         * @param {?} prop
         * @return {?}
         */
        CssKeyframesDriver.prototype.validateStyleProperty = function (prop) { return validateStyleProperty(prop); };
        /**
         * @param {?} element
         * @param {?} selector
         * @return {?}
         */
        CssKeyframesDriver.prototype.matchesElement = function (element, selector) {
            return matchesElement(element, selector);
        };
        /**
         * @param {?} elm1
         * @param {?} elm2
         * @return {?}
         */
        CssKeyframesDriver.prototype.containsElement = function (elm1, elm2) { return containsElement(elm1, elm2); };
        /**
         * @param {?} element
         * @param {?} selector
         * @param {?} multi
         * @return {?}
         */
        CssKeyframesDriver.prototype.query = function (element, selector, multi) {
            return invokeQuery(element, selector, multi);
        };
        /**
         * @param {?} element
         * @param {?} prop
         * @param {?=} defaultValue
         * @return {?}
         */
        CssKeyframesDriver.prototype.computeStyle = function (element, prop, defaultValue) {
            return ( /** @type {?} */((( /** @type {?} */(window.getComputedStyle(element))))[prop]));
        };
        /**
         * @param {?} element
         * @param {?} name
         * @param {?} keyframes
         * @return {?}
         */
        CssKeyframesDriver.prototype.buildKeyframeElement = function (element, name, keyframes) {
            keyframes = keyframes.map(( /**
             * @param {?} kf
             * @return {?}
             */function (/**
             * @param {?} kf
             * @return {?}
             */ kf) { return hypenatePropsObject(kf); }));
            /** @type {?} */
            var keyframeStr = "@keyframes " + name + " {\n";
            /** @type {?} */
            var tab = '';
            keyframes.forEach(( /**
             * @param {?} kf
             * @return {?}
             */function (/**
             * @param {?} kf
             * @return {?}
             */ kf) {
                tab = TAB_SPACE;
                /** @type {?} */
                var offset = parseFloat(kf['offset']);
                keyframeStr += "" + tab + offset * 100 + "% {\n";
                tab += TAB_SPACE;
                Object.keys(kf).forEach(( /**
                 * @param {?} prop
                 * @return {?}
                 */function (/**
                 * @param {?} prop
                 * @return {?}
                 */ prop) {
                    /** @type {?} */
                    var value = kf[prop];
                    switch (prop) {
                        case 'offset':
                            return;
                        case 'easing':
                            if (value) {
                                keyframeStr += tab + "animation-timing-function: " + value + ";\n";
                            }
                            return;
                        default:
                            keyframeStr += "" + tab + prop + ": " + value + ";\n";
                            return;
                    }
                }));
                keyframeStr += tab + "}\n";
            }));
            keyframeStr += "}\n";
            /** @type {?} */
            var kfElm = document.createElement('style');
            kfElm.innerHTML = keyframeStr;
            return kfElm;
        };
        /**
         * @param {?} element
         * @param {?} keyframes
         * @param {?} duration
         * @param {?} delay
         * @param {?} easing
         * @param {?=} previousPlayers
         * @param {?=} scrubberAccessRequested
         * @return {?}
         */
        CssKeyframesDriver.prototype.animate = function (element, keyframes, duration, delay, easing, previousPlayers, scrubberAccessRequested) {
            if (previousPlayers === void 0) { previousPlayers = []; }
            if (scrubberAccessRequested) {
                this._notifyFaultyScrubber();
            }
            /** @type {?} */
            var previousCssKeyframePlayers = ( /** @type {?} */(previousPlayers.filter(( /**
             * @param {?} player
             * @return {?}
             */function (/**
             * @param {?} player
             * @return {?}
             */ player) { return player instanceof CssKeyframesPlayer; }))));
            /** @type {?} */
            var previousStyles = {};
            if (allowPreviousPlayerStylesMerge(duration, delay)) {
                previousCssKeyframePlayers.forEach(( /**
                 * @param {?} player
                 * @return {?}
                 */function (/**
                 * @param {?} player
                 * @return {?}
                 */ player) {
                    /** @type {?} */
                    var styles = player.currentSnapshot;
                    Object.keys(styles).forEach(( /**
                     * @param {?} prop
                     * @return {?}
                     */function (/**
                     * @param {?} prop
                     * @return {?}
                     */ prop) { return previousStyles[prop] = styles[prop]; }));
                }));
            }
            keyframes = balancePreviousStylesIntoKeyframes(element, keyframes, previousStyles);
            /** @type {?} */
            var finalStyles = flattenKeyframesIntoStyles(keyframes);
            // if there is no animation then there is no point in applying
            // styles and waiting for an event to get fired. This causes lag.
            // It's better to just directly apply the styles to the element
            // via the direct styling animation player.
            if (duration == 0) {
                return new DirectStylePlayer(element, finalStyles);
            }
            /** @type {?} */
            var animationName = "" + KEYFRAMES_NAME_PREFIX + this._count++;
            /** @type {?} */
            var kfElm = this.buildKeyframeElement(element, animationName, keyframes);
            ( /** @type {?} */(document.querySelector('head'))).appendChild(kfElm);
            /** @type {?} */
            var specialStyles = packageNonAnimatableStyles(element, keyframes);
            /** @type {?} */
            var player = new CssKeyframesPlayer(element, keyframes, animationName, duration, delay, easing, finalStyles, specialStyles);
            player.onDestroy(( /**
             * @return {?}
             */function () { return removeElement(kfElm); }));
            return player;
        };
        /**
         * @private
         * @return {?}
         */
        CssKeyframesDriver.prototype._notifyFaultyScrubber = function () {
            if (!this._warningIssued) {
                console.warn('@angular/animations: please load the web-animations.js polyfill to allow programmatic access...\n', '  visit http://bit.ly/IWukam to learn more about using the web-animation-js polyfill.');
                this._warningIssued = true;
            }
        };
        return CssKeyframesDriver;
    }());
    /**
     * @param {?} keyframes
     * @return {?}
     */
    function flattenKeyframesIntoStyles(keyframes) {
        /** @type {?} */
        var flatKeyframes = {};
        if (keyframes) {
            /** @type {?} */
            var kfs = Array.isArray(keyframes) ? keyframes : [keyframes];
            kfs.forEach(( /**
             * @param {?} kf
             * @return {?}
             */function (/**
             * @param {?} kf
             * @return {?}
             */ kf) {
                Object.keys(kf).forEach(( /**
                 * @param {?} prop
                 * @return {?}
                 */function (/**
                 * @param {?} prop
                 * @return {?}
                 */ prop) {
                    if (prop == 'offset' || prop == 'easing')
                        return;
                    flatKeyframes[prop] = kf[prop];
                }));
            }));
        }
        return flatKeyframes;
    }
    /**
     * @param {?} node
     * @return {?}
     */
    function removeElement(node) {
        node.parentNode.removeChild(node);
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var WebAnimationsPlayer = /** @class */ (function () {
        /**
         * @param {?} element
         * @param {?} keyframes
         * @param {?} options
         * @param {?=} _specialStyles
         */
        function WebAnimationsPlayer(element, keyframes, options, _specialStyles) {
            this.element = element;
            this.keyframes = keyframes;
            this.options = options;
            this._specialStyles = _specialStyles;
            this._onDoneFns = [];
            this._onStartFns = [];
            this._onDestroyFns = [];
            this._initialized = false;
            this._finished = false;
            this._started = false;
            this._destroyed = false;
            this.time = 0;
            this.parentPlayer = null;
            this.currentSnapshot = {};
            this._duration = ( /** @type {?} */(options['duration']));
            this._delay = ( /** @type {?} */(options['delay'])) || 0;
            this.time = this._duration + this._delay;
        }
        /**
         * @private
         * @return {?}
         */
        WebAnimationsPlayer.prototype._onFinish = function () {
            if (!this._finished) {
                this._finished = true;
                this._onDoneFns.forEach(( /**
                 * @param {?} fn
                 * @return {?}
                 */function (/**
                 * @param {?} fn
                 * @return {?}
                 */ fn) { return fn(); }));
                this._onDoneFns = [];
            }
        };
        /**
         * @return {?}
         */
        WebAnimationsPlayer.prototype.init = function () {
            this._buildPlayer();
            this._preparePlayerBeforeStart();
        };
        /**
         * @private
         * @return {?}
         */
        WebAnimationsPlayer.prototype._buildPlayer = function () {
            var _this = this;
            if (this._initialized)
                return;
            this._initialized = true;
            /** @type {?} */
            var keyframes = this.keyframes;
            (( /** @type {?} */(this))).domPlayer =
                this._triggerWebAnimation(this.element, keyframes, this.options);
            this._finalKeyframe = keyframes.length ? keyframes[keyframes.length - 1] : {};
            this.domPlayer.addEventListener('finish', ( /**
             * @return {?}
             */function () { return _this._onFinish(); }));
        };
        /**
         * @private
         * @return {?}
         */
        WebAnimationsPlayer.prototype._preparePlayerBeforeStart = function () {
            // this is required so that the player doesn't start to animate right away
            if (this._delay) {
                this._resetDomPlayerState();
            }
            else {
                this.domPlayer.pause();
            }
        };
        /**
         * \@internal
         * @param {?} element
         * @param {?} keyframes
         * @param {?} options
         * @return {?}
         */
        WebAnimationsPlayer.prototype._triggerWebAnimation = function (element, keyframes, options) {
            // jscompiler doesn't seem to know animate is a native property because it's not fully
            // supported yet across common browsers (we polyfill it for Edge/Safari) [CL #143630929]
            return ( /** @type {?} */(element['animate'](keyframes, options)));
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        WebAnimationsPlayer.prototype.onStart = function (fn) { this._onStartFns.push(fn); };
        /**
         * @param {?} fn
         * @return {?}
         */
        WebAnimationsPlayer.prototype.onDone = function (fn) { this._onDoneFns.push(fn); };
        /**
         * @param {?} fn
         * @return {?}
         */
        WebAnimationsPlayer.prototype.onDestroy = function (fn) { this._onDestroyFns.push(fn); };
        /**
         * @return {?}
         */
        WebAnimationsPlayer.prototype.play = function () {
            this._buildPlayer();
            if (!this.hasStarted()) {
                this._onStartFns.forEach(( /**
                 * @param {?} fn
                 * @return {?}
                 */function (/**
                 * @param {?} fn
                 * @return {?}
                 */ fn) { return fn(); }));
                this._onStartFns = [];
                this._started = true;
                if (this._specialStyles) {
                    this._specialStyles.start();
                }
            }
            this.domPlayer.play();
        };
        /**
         * @return {?}
         */
        WebAnimationsPlayer.prototype.pause = function () {
            this.init();
            this.domPlayer.pause();
        };
        /**
         * @return {?}
         */
        WebAnimationsPlayer.prototype.finish = function () {
            this.init();
            if (this._specialStyles) {
                this._specialStyles.finish();
            }
            this._onFinish();
            this.domPlayer.finish();
        };
        /**
         * @return {?}
         */
        WebAnimationsPlayer.prototype.reset = function () {
            this._resetDomPlayerState();
            this._destroyed = false;
            this._finished = false;
            this._started = false;
        };
        /**
         * @private
         * @return {?}
         */
        WebAnimationsPlayer.prototype._resetDomPlayerState = function () {
            if (this.domPlayer) {
                this.domPlayer.cancel();
            }
        };
        /**
         * @return {?}
         */
        WebAnimationsPlayer.prototype.restart = function () {
            this.reset();
            this.play();
        };
        /**
         * @return {?}
         */
        WebAnimationsPlayer.prototype.hasStarted = function () { return this._started; };
        /**
         * @return {?}
         */
        WebAnimationsPlayer.prototype.destroy = function () {
            if (!this._destroyed) {
                this._destroyed = true;
                this._resetDomPlayerState();
                this._onFinish();
                if (this._specialStyles) {
                    this._specialStyles.destroy();
                }
                this._onDestroyFns.forEach(( /**
                 * @param {?} fn
                 * @return {?}
                 */function (/**
                 * @param {?} fn
                 * @return {?}
                 */ fn) { return fn(); }));
                this._onDestroyFns = [];
            }
        };
        /**
         * @param {?} p
         * @return {?}
         */
        WebAnimationsPlayer.prototype.setPosition = function (p) { this.domPlayer.currentTime = p * this.time; };
        /**
         * @return {?}
         */
        WebAnimationsPlayer.prototype.getPosition = function () { return this.domPlayer.currentTime / this.time; };
        Object.defineProperty(WebAnimationsPlayer.prototype, "totalTime", {
            /**
             * @return {?}
             */
            get: function () { return this._delay + this._duration; },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        WebAnimationsPlayer.prototype.beforeDestroy = function () {
            var _this = this;
            /** @type {?} */
            var styles = {};
            if (this.hasStarted()) {
                Object.keys(this._finalKeyframe).forEach(( /**
                 * @param {?} prop
                 * @return {?}
                 */function (/**
                 * @param {?} prop
                 * @return {?}
                 */ prop) {
                    if (prop != 'offset') {
                        styles[prop] =
                            _this._finished ? _this._finalKeyframe[prop] : computeStyle(_this.element, prop);
                    }
                }));
            }
            this.currentSnapshot = styles;
        };
        /**
         * \@internal
         * @param {?} phaseName
         * @return {?}
         */
        WebAnimationsPlayer.prototype.triggerCallback = function (phaseName) {
            /** @type {?} */
            var methods = phaseName == 'start' ? this._onStartFns : this._onDoneFns;
            methods.forEach(( /**
             * @param {?} fn
             * @return {?}
             */function (/**
             * @param {?} fn
             * @return {?}
             */ fn) { return fn(); }));
            methods.length = 0;
        };
        return WebAnimationsPlayer;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var WebAnimationsDriver = /** @class */ (function () {
        function WebAnimationsDriver() {
            this._isNativeImpl = /\{\s*\[native\s+code\]\s*\}/.test(getElementAnimateFn().toString());
            this._cssKeyframesDriver = new CssKeyframesDriver();
        }
        /**
         * @param {?} prop
         * @return {?}
         */
        WebAnimationsDriver.prototype.validateStyleProperty = function (prop) { return validateStyleProperty(prop); };
        /**
         * @param {?} element
         * @param {?} selector
         * @return {?}
         */
        WebAnimationsDriver.prototype.matchesElement = function (element, selector) {
            return matchesElement(element, selector);
        };
        /**
         * @param {?} elm1
         * @param {?} elm2
         * @return {?}
         */
        WebAnimationsDriver.prototype.containsElement = function (elm1, elm2) { return containsElement(elm1, elm2); };
        /**
         * @param {?} element
         * @param {?} selector
         * @param {?} multi
         * @return {?}
         */
        WebAnimationsDriver.prototype.query = function (element, selector, multi) {
            return invokeQuery(element, selector, multi);
        };
        /**
         * @param {?} element
         * @param {?} prop
         * @param {?=} defaultValue
         * @return {?}
         */
        WebAnimationsDriver.prototype.computeStyle = function (element, prop, defaultValue) {
            return ( /** @type {?} */((( /** @type {?} */(window.getComputedStyle(element))))[prop]));
        };
        /**
         * @param {?} supported
         * @return {?}
         */
        WebAnimationsDriver.prototype.overrideWebAnimationsSupport = function (supported) { this._isNativeImpl = supported; };
        /**
         * @param {?} element
         * @param {?} keyframes
         * @param {?} duration
         * @param {?} delay
         * @param {?} easing
         * @param {?=} previousPlayers
         * @param {?=} scrubberAccessRequested
         * @return {?}
         */
        WebAnimationsDriver.prototype.animate = function (element, keyframes, duration, delay, easing, previousPlayers, scrubberAccessRequested) {
            if (previousPlayers === void 0) { previousPlayers = []; }
            /** @type {?} */
            var useKeyframes = !scrubberAccessRequested && !this._isNativeImpl;
            if (useKeyframes) {
                return this._cssKeyframesDriver.animate(element, keyframes, duration, delay, easing, previousPlayers);
            }
            /** @type {?} */
            var fill = delay == 0 ? 'both' : 'forwards';
            /** @type {?} */
            var playerOptions = { duration: duration, delay: delay, fill: fill };
            // we check for this to avoid having a null|undefined value be present
            // for the easing (which results in an error for certain browsers #9752)
            if (easing) {
                playerOptions['easing'] = easing;
            }
            /** @type {?} */
            var previousStyles = {};
            /** @type {?} */
            var previousWebAnimationPlayers = ( /** @type {?} */(previousPlayers.filter(( /**
             * @param {?} player
             * @return {?}
             */function (/**
             * @param {?} player
             * @return {?}
             */ player) { return player instanceof WebAnimationsPlayer; }))));
            if (allowPreviousPlayerStylesMerge(duration, delay)) {
                previousWebAnimationPlayers.forEach(( /**
                 * @param {?} player
                 * @return {?}
                 */function (/**
                 * @param {?} player
                 * @return {?}
                 */ player) {
                    /** @type {?} */
                    var styles = player.currentSnapshot;
                    Object.keys(styles).forEach(( /**
                     * @param {?} prop
                     * @return {?}
                     */function (/**
                     * @param {?} prop
                     * @return {?}
                     */ prop) { return previousStyles[prop] = styles[prop]; }));
                }));
            }
            keyframes = keyframes.map(( /**
             * @param {?} styles
             * @return {?}
             */function (/**
             * @param {?} styles
             * @return {?}
             */ styles) { return copyStyles(styles, false); }));
            keyframes = balancePreviousStylesIntoKeyframes(element, keyframes, previousStyles);
            /** @type {?} */
            var specialStyles = packageNonAnimatableStyles(element, keyframes);
            return new WebAnimationsPlayer(element, keyframes, playerOptions, specialStyles);
        };
        return WebAnimationsDriver;
    }());
    /**
     * @return {?}
     */
    function supportsWebAnimations() {
        return typeof getElementAnimateFn() === 'function';
    }
    /**
     * @return {?}
     */
    function getElementAnimateFn() {
        return (isBrowser() && (( /** @type {?} */(Element))).prototype['animate']) || {};
    }
    /**
     * @license Angular v8.2.14
     * (c) 2010-2019 Google LLC. https://angular.io/
     * License: MIT
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BrowserAnimationBuilder = /** @class */ (function (_super) {
        __extends(BrowserAnimationBuilder, _super);
        /**
         * @param {?} rootRenderer
         * @param {?} doc
         */
        function BrowserAnimationBuilder(rootRenderer, doc) {
            var _this = _super.call(this) || this;
            _this._nextAnimationId = 0;
            /** @type {?} */
            var typeData = ( /** @type {?} */({
                id: '0',
                encapsulation: ViewEncapsulation.None,
                styles: [],
                data: { animation: [] }
            }));
            _this._renderer = ( /** @type {?} */(rootRenderer.createRenderer(doc.body, typeData)));
            return _this;
        }
        /**
         * @param {?} animation
         * @return {?}
         */
        BrowserAnimationBuilder.prototype.build = function (animation) {
            /** @type {?} */
            var id = this._nextAnimationId.toString();
            this._nextAnimationId++;
            /** @type {?} */
            var entry = Array.isArray(animation) ? sequence(animation) : animation;
            issueAnimationCommand(this._renderer, null, id, 'register', [entry]);
            return new BrowserAnimationFactory(id, this._renderer);
        };
        return BrowserAnimationBuilder;
    }(AnimationBuilder));
    BrowserAnimationBuilder.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    BrowserAnimationBuilder.ctorParameters = function () { return [
        { type: RendererFactory2 },
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
    ]; };
    var BrowserAnimationFactory = /** @class */ (function (_super) {
        __extends(BrowserAnimationFactory, _super);
        /**
         * @param {?} _id
         * @param {?} _renderer
         */
        function BrowserAnimationFactory(_id, _renderer) {
            var _this = _super.call(this) || this;
            _this._id = _id;
            _this._renderer = _renderer;
            return _this;
        }
        /**
         * @param {?} element
         * @param {?=} options
         * @return {?}
         */
        BrowserAnimationFactory.prototype.create = function (element, options) {
            return new RendererAnimationPlayer(this._id, element, options || {}, this._renderer);
        };
        return BrowserAnimationFactory;
    }(AnimationFactory));
    var RendererAnimationPlayer = /** @class */ (function () {
        /**
         * @param {?} id
         * @param {?} element
         * @param {?} options
         * @param {?} _renderer
         */
        function RendererAnimationPlayer(id, element, options, _renderer) {
            this.id = id;
            this.element = element;
            this._renderer = _renderer;
            this.parentPlayer = null;
            this._started = false;
            this.totalTime = 0;
            this._command('create', options);
        }
        /**
         * @private
         * @param {?} eventName
         * @param {?} callback
         * @return {?}
         */
        RendererAnimationPlayer.prototype._listen = function (eventName, callback) {
            return this._renderer.listen(this.element, "@@" + this.id + ":" + eventName, callback);
        };
        /**
         * @private
         * @param {?} command
         * @param {...?} args
         * @return {?}
         */
        RendererAnimationPlayer.prototype._command = function (command) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            return issueAnimationCommand(this._renderer, this.element, this.id, command, args);
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        RendererAnimationPlayer.prototype.onDone = function (fn) { this._listen('done', fn); };
        /**
         * @param {?} fn
         * @return {?}
         */
        RendererAnimationPlayer.prototype.onStart = function (fn) { this._listen('start', fn); };
        /**
         * @param {?} fn
         * @return {?}
         */
        RendererAnimationPlayer.prototype.onDestroy = function (fn) { this._listen('destroy', fn); };
        /**
         * @return {?}
         */
        RendererAnimationPlayer.prototype.init = function () { this._command('init'); };
        /**
         * @return {?}
         */
        RendererAnimationPlayer.prototype.hasStarted = function () { return this._started; };
        /**
         * @return {?}
         */
        RendererAnimationPlayer.prototype.play = function () {
            this._command('play');
            this._started = true;
        };
        /**
         * @return {?}
         */
        RendererAnimationPlayer.prototype.pause = function () { this._command('pause'); };
        /**
         * @return {?}
         */
        RendererAnimationPlayer.prototype.restart = function () { this._command('restart'); };
        /**
         * @return {?}
         */
        RendererAnimationPlayer.prototype.finish = function () { this._command('finish'); };
        /**
         * @return {?}
         */
        RendererAnimationPlayer.prototype.destroy = function () { this._command('destroy'); };
        /**
         * @return {?}
         */
        RendererAnimationPlayer.prototype.reset = function () { this._command('reset'); };
        /**
         * @param {?} p
         * @return {?}
         */
        RendererAnimationPlayer.prototype.setPosition = function (p) { this._command('setPosition', p); };
        /**
         * @return {?}
         */
        RendererAnimationPlayer.prototype.getPosition = function () { return 0; };
        return RendererAnimationPlayer;
    }());
    /**
     * @param {?} renderer
     * @param {?} element
     * @param {?} id
     * @param {?} command
     * @param {?} args
     * @return {?}
     */
    function issueAnimationCommand(renderer, element, id, command, args) {
        return renderer.setProperty(element, "@@" + id + ":" + command, args);
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var ANIMATION_PREFIX = '@';
    /** @type {?} */
    var DISABLE_ANIMATIONS_FLAG = '@.disabled';
    var AnimationRendererFactory = /** @class */ (function () {
        /**
         * @param {?} delegate
         * @param {?} engine
         * @param {?} _zone
         */
        function AnimationRendererFactory(delegate, engine, _zone) {
            this.delegate = delegate;
            this.engine = engine;
            this._zone = _zone;
            this._currentId = 0;
            this._microtaskId = 1;
            this._animationCallbacksBuffer = [];
            this._rendererCache = new Map();
            this._cdRecurDepth = 0;
            this.promise = Promise.resolve(0);
            engine.onRemovalComplete = ( /**
             * @param {?} element
             * @param {?} delegate
             * @return {?}
             */function (element, delegate) {
                // Note: if an component element has a leave animation, and the component
                // a host leave animation, the view engine will call `removeChild` for the parent
                // component renderer as well as for the child component renderer.
                // Therefore, we need to check if we already removed the element.
                if (delegate && delegate.parentNode(element)) {
                    delegate.removeChild(element.parentNode, element);
                }
            });
        }
        /**
         * @param {?} hostElement
         * @param {?} type
         * @return {?}
         */
        AnimationRendererFactory.prototype.createRenderer = function (hostElement, type) {
            var _this = this;
            /** @type {?} */
            var EMPTY_NAMESPACE_ID = '';
            // cache the delegates to find out which cached delegate can
            // be used by which cached renderer
            /** @type {?} */
            var delegate = this.delegate.createRenderer(hostElement, type);
            if (!hostElement || !type || !type.data || !type.data['animation']) {
                /** @type {?} */
                var renderer = this._rendererCache.get(delegate);
                if (!renderer) {
                    renderer = new BaseAnimationRenderer(EMPTY_NAMESPACE_ID, delegate, this.engine);
                    // only cache this result when the base renderer is used
                    this._rendererCache.set(delegate, renderer);
                }
                return renderer;
            }
            /** @type {?} */
            var componentId = type.id;
            /** @type {?} */
            var namespaceId = type.id + '-' + this._currentId;
            this._currentId++;
            this.engine.register(namespaceId, hostElement);
            /** @type {?} */
            var animationTriggers = ( /** @type {?} */(type.data['animation']));
            animationTriggers.forEach(( /**
             * @param {?} trigger
             * @return {?}
             */function (/**
             * @param {?} trigger
             * @return {?}
             */ trigger) { return _this.engine.registerTrigger(componentId, namespaceId, hostElement, trigger.name, trigger); }));
            return new AnimationRenderer(this, namespaceId, delegate, this.engine);
        };
        /**
         * @return {?}
         */
        AnimationRendererFactory.prototype.begin = function () {
            this._cdRecurDepth++;
            if (this.delegate.begin) {
                this.delegate.begin();
            }
        };
        /**
         * @private
         * @return {?}
         */
        AnimationRendererFactory.prototype._scheduleCountTask = function () {
            var _this = this;
            // always use promise to schedule microtask instead of use Zone
            this.promise.then(( /**
             * @return {?}
             */function () { _this._microtaskId++; }));
        };
        /**
         * \@internal
         * @param {?} count
         * @param {?} fn
         * @param {?} data
         * @return {?}
         */
        AnimationRendererFactory.prototype.scheduleListenerCallback = function (count, fn, data) {
            var _this = this;
            if (count >= 0 && count < this._microtaskId) {
                this._zone.run(( /**
                 * @return {?}
                 */function () { return fn(data); }));
                return;
            }
            if (this._animationCallbacksBuffer.length == 0) {
                Promise.resolve(null).then(( /**
                 * @return {?}
                 */function () {
                    _this._zone.run(( /**
                     * @return {?}
                     */function () {
                        _this._animationCallbacksBuffer.forEach(( /**
                         * @param {?} tuple
                         * @return {?}
                         */function (/**
                         * @param {?} tuple
                         * @return {?}
                         */ tuple) {
                            var _b = __read(tuple, 2), fn = _b[0], data = _b[1];
                            fn(data);
                        }));
                        _this._animationCallbacksBuffer = [];
                    }));
                }));
            }
            this._animationCallbacksBuffer.push([fn, data]);
        };
        /**
         * @return {?}
         */
        AnimationRendererFactory.prototype.end = function () {
            var _this = this;
            this._cdRecurDepth--;
            // this is to prevent animations from running twice when an inner
            // component does CD when a parent component instead has inserted it
            if (this._cdRecurDepth == 0) {
                this._zone.runOutsideAngular(( /**
                 * @return {?}
                 */function () {
                    _this._scheduleCountTask();
                    _this.engine.flush(_this._microtaskId);
                }));
            }
            if (this.delegate.end) {
                this.delegate.end();
            }
        };
        /**
         * @return {?}
         */
        AnimationRendererFactory.prototype.whenRenderingDone = function () { return this.engine.whenRenderingDone(); };
        return AnimationRendererFactory;
    }());
    AnimationRendererFactory.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    AnimationRendererFactory.ctorParameters = function () { return [
        { type: RendererFactory2 },
        { type: AnimationEngine },
        { type: NgZone }
    ]; };
    var BaseAnimationRenderer = /** @class */ (function () {
        /**
         * @param {?} namespaceId
         * @param {?} delegate
         * @param {?} engine
         */
        function BaseAnimationRenderer(namespaceId, delegate, engine) {
            this.namespaceId = namespaceId;
            this.delegate = delegate;
            this.engine = engine;
            this.destroyNode = this.delegate.destroyNode ? ( /**
             * @param {?} n
             * @return {?}
             */function (n) { return ( /** @type {?} */(delegate.destroyNode))(n); }) : null;
        }
        Object.defineProperty(BaseAnimationRenderer.prototype, "data", {
            /**
             * @return {?}
             */
            get: function () { return this.delegate.data; },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        BaseAnimationRenderer.prototype.destroy = function () {
            this.engine.destroy(this.namespaceId, this.delegate);
            this.delegate.destroy();
        };
        /**
         * @param {?} name
         * @param {?=} namespace
         * @return {?}
         */
        BaseAnimationRenderer.prototype.createElement = function (name, namespace) {
            return this.delegate.createElement(name, namespace);
        };
        /**
         * @param {?} value
         * @return {?}
         */
        BaseAnimationRenderer.prototype.createComment = function (value) { return this.delegate.createComment(value); };
        /**
         * @param {?} value
         * @return {?}
         */
        BaseAnimationRenderer.prototype.createText = function (value) { return this.delegate.createText(value); };
        /**
         * @param {?} parent
         * @param {?} newChild
         * @return {?}
         */
        BaseAnimationRenderer.prototype.appendChild = function (parent, newChild) {
            this.delegate.appendChild(parent, newChild);
            this.engine.onInsert(this.namespaceId, newChild, parent, false);
        };
        /**
         * @param {?} parent
         * @param {?} newChild
         * @param {?} refChild
         * @return {?}
         */
        BaseAnimationRenderer.prototype.insertBefore = function (parent, newChild, refChild) {
            this.delegate.insertBefore(parent, newChild, refChild);
            this.engine.onInsert(this.namespaceId, newChild, parent, true);
        };
        /**
         * @param {?} parent
         * @param {?} oldChild
         * @param {?} isHostElement
         * @return {?}
         */
        BaseAnimationRenderer.prototype.removeChild = function (parent, oldChild, isHostElement) {
            this.engine.onRemove(this.namespaceId, oldChild, this.delegate, isHostElement);
        };
        /**
         * @param {?} selectorOrNode
         * @param {?=} preserveContent
         * @return {?}
         */
        BaseAnimationRenderer.prototype.selectRootElement = function (selectorOrNode, preserveContent) {
            return this.delegate.selectRootElement(selectorOrNode, preserveContent);
        };
        /**
         * @param {?} node
         * @return {?}
         */
        BaseAnimationRenderer.prototype.parentNode = function (node) { return this.delegate.parentNode(node); };
        /**
         * @param {?} node
         * @return {?}
         */
        BaseAnimationRenderer.prototype.nextSibling = function (node) { return this.delegate.nextSibling(node); };
        /**
         * @param {?} el
         * @param {?} name
         * @param {?} value
         * @param {?=} namespace
         * @return {?}
         */
        BaseAnimationRenderer.prototype.setAttribute = function (el, name, value, namespace) {
            this.delegate.setAttribute(el, name, value, namespace);
        };
        /**
         * @param {?} el
         * @param {?} name
         * @param {?=} namespace
         * @return {?}
         */
        BaseAnimationRenderer.prototype.removeAttribute = function (el, name, namespace) {
            this.delegate.removeAttribute(el, name, namespace);
        };
        /**
         * @param {?} el
         * @param {?} name
         * @return {?}
         */
        BaseAnimationRenderer.prototype.addClass = function (el, name) { this.delegate.addClass(el, name); };
        /**
         * @param {?} el
         * @param {?} name
         * @return {?}
         */
        BaseAnimationRenderer.prototype.removeClass = function (el, name) { this.delegate.removeClass(el, name); };
        /**
         * @param {?} el
         * @param {?} style
         * @param {?} value
         * @param {?=} flags
         * @return {?}
         */
        BaseAnimationRenderer.prototype.setStyle = function (el, style, value, flags) {
            this.delegate.setStyle(el, style, value, flags);
        };
        /**
         * @param {?} el
         * @param {?} style
         * @param {?=} flags
         * @return {?}
         */
        BaseAnimationRenderer.prototype.removeStyle = function (el, style, flags) {
            this.delegate.removeStyle(el, style, flags);
        };
        /**
         * @param {?} el
         * @param {?} name
         * @param {?} value
         * @return {?}
         */
        BaseAnimationRenderer.prototype.setProperty = function (el, name, value) {
            if (name.charAt(0) == ANIMATION_PREFIX && name == DISABLE_ANIMATIONS_FLAG) {
                this.disableAnimations(el, !!value);
            }
            else {
                this.delegate.setProperty(el, name, value);
            }
        };
        /**
         * @param {?} node
         * @param {?} value
         * @return {?}
         */
        BaseAnimationRenderer.prototype.setValue = function (node, value) { this.delegate.setValue(node, value); };
        /**
         * @param {?} target
         * @param {?} eventName
         * @param {?} callback
         * @return {?}
         */
        BaseAnimationRenderer.prototype.listen = function (target, eventName, callback) {
            return this.delegate.listen(target, eventName, callback);
        };
        /**
         * @protected
         * @param {?} element
         * @param {?} value
         * @return {?}
         */
        BaseAnimationRenderer.prototype.disableAnimations = function (element, value) {
            this.engine.disableAnimations(element, value);
        };
        return BaseAnimationRenderer;
    }());
    var AnimationRenderer = /** @class */ (function (_super) {
        __extends(AnimationRenderer, _super);
        /**
         * @param {?} factory
         * @param {?} namespaceId
         * @param {?} delegate
         * @param {?} engine
         */
        function AnimationRenderer(factory, namespaceId, delegate, engine) {
            var _this = _super.call(this, namespaceId, delegate, engine) || this;
            _this.factory = factory;
            _this.namespaceId = namespaceId;
            return _this;
        }
        /**
         * @param {?} el
         * @param {?} name
         * @param {?} value
         * @return {?}
         */
        AnimationRenderer.prototype.setProperty = function (el, name, value) {
            if (name.charAt(0) == ANIMATION_PREFIX) {
                if (name.charAt(1) == '.' && name == DISABLE_ANIMATIONS_FLAG) {
                    value = value === undefined ? true : !!value;
                    this.disableAnimations(el, ( /** @type {?} */(value)));
                }
                else {
                    this.engine.process(this.namespaceId, el, name.substr(1), value);
                }
            }
            else {
                this.delegate.setProperty(el, name, value);
            }
        };
        /**
         * @param {?} target
         * @param {?} eventName
         * @param {?} callback
         * @return {?}
         */
        AnimationRenderer.prototype.listen = function (target, eventName, callback) {
            var _this = this;
            var _b;
            if (eventName.charAt(0) == ANIMATION_PREFIX) {
                /** @type {?} */
                var element = resolveElementFromTarget(target);
                /** @type {?} */
                var name_5 = eventName.substr(1);
                /** @type {?} */
                var phase = '';
                // @listener.phase is for trigger animation callbacks
                // @@listener is for animation builder callbacks
                if (name_5.charAt(0) != ANIMATION_PREFIX) {
                    _b = __read(parseTriggerCallbackName(name_5), 2), name_5 = _b[0], phase = _b[1];
                }
                return this.engine.listen(this.namespaceId, element, name_5, phase, ( /**
                 * @param {?} event
                 * @return {?}
                 */function (/**
                 * @param {?} event
                 * @return {?}
                 */ event) {
                    /** @type {?} */
                    var countId = (( /** @type {?} */(event)))['_data'] || -1;
                    _this.factory.scheduleListenerCallback(countId, callback, event);
                }));
            }
            return this.delegate.listen(target, eventName, callback);
        };
        return AnimationRenderer;
    }(BaseAnimationRenderer));
    /**
     * @param {?} target
     * @return {?}
     */
    function resolveElementFromTarget(target) {
        switch (target) {
            case 'body':
                return document.body;
            case 'document':
                return document;
            case 'window':
                return window;
            default:
                return target;
        }
    }
    /**
     * @param {?} triggerName
     * @return {?}
     */
    function parseTriggerCallbackName(triggerName) {
        /** @type {?} */
        var dotIndex = triggerName.indexOf('.');
        /** @type {?} */
        var trigger = triggerName.substring(0, dotIndex);
        /** @type {?} */
        var phase = triggerName.substr(dotIndex + 1);
        return [trigger, phase];
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var InjectableAnimationEngine = /** @class */ (function (_super) {
        __extends(InjectableAnimationEngine, _super);
        /**
         * @param {?} doc
         * @param {?} driver
         * @param {?} normalizer
         */
        function InjectableAnimationEngine(doc, driver, normalizer) {
            return _super.call(this, doc.body, driver, normalizer) || this;
        }
        return InjectableAnimationEngine;
    }(AnimationEngine));
    InjectableAnimationEngine.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    InjectableAnimationEngine.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] },
        { type: AnimationDriver },
        { type: AnimationStyleNormalizer }
    ]; };
    /**
     * @return {?}
     */
    function instantiateSupportedAnimationDriver() {
        return supportsWebAnimations() ? new WebAnimationsDriver() : new CssKeyframesDriver();
    }
    /**
     * @return {?}
     */
    function instantiateDefaultStyleNormalizer() {
        return new WebAnimationsStyleNormalizer();
    }
    /**
     * @param {?} renderer
     * @param {?} engine
     * @param {?} zone
     * @return {?}
     */
    function instantiateRendererFactory(renderer, engine, zone) {
        return new AnimationRendererFactory(renderer, engine, zone);
    }
    /**
     * \@publicApi
     * @type {?}
     */
    var ANIMATION_MODULE_TYPE = new InjectionToken('AnimationModuleType');
    /** @type {?} */
    var SHARED_ANIMATION_PROVIDERS = [
        { provide: AnimationBuilder, useClass: BrowserAnimationBuilder },
        { provide: AnimationStyleNormalizer, useFactory: instantiateDefaultStyleNormalizer },
        { provide: AnimationEngine, useClass: InjectableAnimationEngine }, {
            provide: RendererFactory2,
            useFactory: instantiateRendererFactory,
            deps: [DomRendererFactory2, AnimationEngine, NgZone]
        }
    ];
    /**
     * Separate providers from the actual module so that we can do a local modification in Google3 to
     * include them in the BrowserModule.
     * @type {?}
     */
    var BROWSER_ANIMATIONS_PROVIDERS = __spread([
        { provide: AnimationDriver, useFactory: instantiateSupportedAnimationDriver },
        { provide: ANIMATION_MODULE_TYPE, useValue: 'BrowserAnimations' }
    ], SHARED_ANIMATION_PROVIDERS);
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Exports `BrowserModule` with additional [dependency-injection providers](guide/glossary#provider)
     * for use with animations. See [Animations](guide/animations).
     * \@publicApi
     */
    var BrowserAnimationsModule = /** @class */ (function () {
        function BrowserAnimationsModule() {
        }
        return BrowserAnimationsModule;
    }());
    BrowserAnimationsModule.decorators = [
        { type: NgModule, args: [{
                    exports: [BrowserModule],
                    providers: BROWSER_ANIMATIONS_PROVIDERS,
                },] }
    ];
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Injection token used to inject the document into Directionality.
     * This is used so that the value can be faked in tests.
     *
     * We can't use the real document in tests because changing the real `dir` causes geometry-based
     * tests in Safari to fail.
     *
     * We also can't re-provide the DOCUMENT token from platform-brower because the unit tests
     * themselves use things like `querySelector` in test code.
     *
     * This token is defined in a separate file from Directionality as a workaround for
     * https://github.com/angular/angular/issues/22559
     *
     * \@docs-private
     * @type {?}
     */
    var DIR_DOCUMENT = new InjectionToken('cdk-dir-doc', {
        providedIn: 'root',
        factory: DIR_DOCUMENT_FACTORY,
    });
    /**
     * \@docs-private
     * @return {?}
     */
    function DIR_DOCUMENT_FACTORY() {
        return inject(DOCUMENT);
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The directionality (LTR / RTL) context for the application (or a subtree of it).
     * Exposes the current direction and a stream of direction changes.
     */
    var Directionality = /** @class */ (function () {
        /**
         * @param {?=} _document
         */
        function Directionality(_document) {
            /**
             * The current 'ltr' or 'rtl' value.
             */
            this.value = 'ltr';
            /**
             * Stream that emits whenever the 'ltr' / 'rtl' state changes.
             */
            this.change = new EventEmitter();
            if (_document) {
                // TODO: handle 'auto' value -
                // We still need to account for dir="auto".
                // It looks like HTMLElemenet.dir is also "auto" when that's set to the attribute,
                // but getComputedStyle return either "ltr" or "rtl". avoiding getComputedStyle for now
                /** @type {?} */
                var bodyDir = _document.body ? _document.body.dir : null;
                /** @type {?} */
                var htmlDir = _document.documentElement ? _document.documentElement.dir : null;
                /** @type {?} */
                var value = bodyDir || htmlDir;
                this.value = (value === 'ltr' || value === 'rtl') ? value : 'ltr';
            }
        }
        /**
         * @return {?}
         */
        Directionality.prototype.ngOnDestroy = function () {
            this.change.complete();
        };
        return Directionality;
    }());
    Directionality.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] },
    ];
    /** @nocollapse */
    Directionality.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [DIR_DOCUMENT,] }] }
    ]; };
    /** @nocollapse */ Directionality.ngInjectableDef = ɵɵdefineInjectable({ factory: function Directionality_Factory() { return new Directionality(ɵɵinject(DIR_DOCUMENT, 8)); }, token: Directionality, providedIn: "root" });
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Directive to listen for changes of direction of part of the DOM.
     *
     * Provides itself as Directionality such that descendant directives only need to ever inject
     * Directionality to get the closest direction.
     */
    var Dir = /** @class */ (function () {
        function Dir() {
            /**
             * Normalized direction that accounts for invalid/unsupported values.
             */
            this._dir = 'ltr';
            /**
             * Whether the `value` has been set to its initial value.
             */
            this._isInitialized = false;
            /**
             * Event emitted when the direction changes.
             */
            this.change = new EventEmitter();
        }
        Object.defineProperty(Dir.prototype, "dir", {
            /**
             * \@docs-private
             * @return {?}
             */
            get: function () { return this._dir; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                /** @type {?} */
                var old = this._dir;
                /** @type {?} */
                var normalizedValue = value ? value.toLowerCase() : value;
                this._rawDir = value;
                this._dir = (normalizedValue === 'ltr' || normalizedValue === 'rtl') ? normalizedValue : 'ltr';
                if (old !== this._dir && this._isInitialized) {
                    this.change.emit(this._dir);
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Dir.prototype, "value", {
            /**
             * Current layout direction of the element.
             * @return {?}
             */
            get: function () { return this.dir; },
            enumerable: true,
            configurable: true
        });
        /**
         * Initialize once default value has been set.
         * @return {?}
         */
        Dir.prototype.ngAfterContentInit = function () {
            this._isInitialized = true;
        };
        /**
         * @return {?}
         */
        Dir.prototype.ngOnDestroy = function () {
            this.change.complete();
        };
        return Dir;
    }());
    Dir.decorators = [
        { type: Directive, args: [{
                    selector: '[dir]',
                    providers: [{ provide: Directionality, useExisting: Dir }],
                    host: { '[attr.dir]': '_rawDir' },
                    exportAs: 'dir',
                },] },
    ];
    Dir.propDecorators = {
        change: [{ type: Output, args: ['dirChange',] }],
        dir: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BidiModule = /** @class */ (function () {
        function BidiModule() {
        }
        return BidiModule;
    }());
    BidiModule.decorators = [
        { type: NgModule, args: [{
                    exports: [Dir],
                    declarations: [Dir],
                },] },
    ];
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Current version of the Angular Component Development Kit.
     * @type {?}
     */
    var VERSION$3 = new Version('8.2.3');
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Coerces a data-bound value (typically a string) to a boolean.
     * @param {?} value
     * @return {?}
     */
    function coerceBooleanProperty(value) {
        return value != null && "" + value !== 'false';
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} value
     * @param {?=} fallbackValue
     * @return {?}
     */
    function coerceNumberProperty(value, fallbackValue) {
        if (fallbackValue === void 0) { fallbackValue = 0; }
        return _isNumberValue(value) ? Number(value) : fallbackValue;
    }
    /**
     * Whether the provided value is considered a number.
     * \@docs-private
     * @param {?} value
     * @return {?}
     */
    function _isNumberValue(value) {
        // parseFloat(value) handles most of the cases we're interested in (it treats null, empty string,
        // and other non-number values as NaN, where Number just uses 0) but it considers the string
        // '123hello' to be a valid number. Therefore we also check if Number(value) is NaN.
        return !isNaN(parseFloat(( /** @type {?} */(value)))) && !isNaN(Number(value));
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Wraps the provided value in an array, unless the provided value is an array.
     * @template T
     * @param {?} value
     * @return {?}
     */
    function coerceArray(value) {
        return Array.isArray(value) ? value : [value];
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Coerces a value to a CSS pixel value.
     * @param {?} value
     * @return {?}
     */
    function coerceCssPixelValue(value) {
        if (value == null) {
            return '';
        }
        return typeof value === 'string' ? value : value + "px";
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Coerces an ElementRef or an Element into an element.
     * Useful for APIs that can accept either a ref or the native element itself.
     * @template T
     * @param {?} elementOrRef
     * @return {?}
     */
    function coerceElement(elementOrRef) {
        return elementOrRef instanceof ElementRef ? elementOrRef.nativeElement : elementOrRef;
    }
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // Whether the current platform supports the V8 Break Iterator. The V8 check
    // is necessary to detect all Blink based browsers.
    /** @type {?} */
    var hasV8BreakIterator;
    // We need a try/catch around the reference to `Intl`, because accessing it in some cases can
    // cause IE to throw. These cases are tied to particular versions of Windows and can happen if
    // the consumer is providing a polyfilled `Map`. See:
    // https://github.com/Microsoft/ChakraCore/issues/3189
    // https://github.com/angular/components/issues/15687
    try {
        hasV8BreakIterator = (typeof Intl !== 'undefined' && (( /** @type {?} */(Intl))).v8BreakIterator);
    }
    catch (_a) {
        hasV8BreakIterator = false;
    }
    /**
     * Service to detect the current platform by comparing the userAgent strings and
     * checking browser-specific global properties.
     */
    var Platform = /** @class */ (function () {
        /**
         * \@breaking-change 8.0.0 remove optional decorator
         * @param {?=} _platformId
         */
        function Platform(_platformId) {
            this._platformId = _platformId;
            /**
             * Whether the Angular application is being rendered in the browser.
             * We want to use the Angular platform check because if the Document is shimmed
             * without the navigator, the following checks will fail. This is preferred because
             * sometimes the Document may be shimmed without the user's knowledge or intention
             */
            this.isBrowser = this._platformId ?
                isPlatformBrowser(this._platformId) : typeof document === 'object' && !!document;
            /**
             * Whether the current browser is Microsoft Edge.
             */
            this.EDGE = this.isBrowser && /(edge)/i.test(navigator.userAgent);
            /**
             * Whether the current rendering engine is Microsoft Trident.
             */
            this.TRIDENT = this.isBrowser && /(msie|trident)/i.test(navigator.userAgent);
            /**
             * Whether the current rendering engine is Blink.
             */
            // EdgeHTML and Trident mock Blink specific things and need to be excluded from this check.
            this.BLINK = this.isBrowser && (!!((( /** @type {?} */(window))).chrome || hasV8BreakIterator) &&
                typeof CSS !== 'undefined' && !this.EDGE && !this.TRIDENT);
            /**
             * Whether the current rendering engine is WebKit.
             */
            // Webkit is part of the userAgent in EdgeHTML, Blink and Trident. Therefore we need to
            // ensure that Webkit runs standalone and is not used as another engine's base.
            this.WEBKIT = this.isBrowser &&
                /AppleWebKit/i.test(navigator.userAgent) && !this.BLINK && !this.EDGE && !this.TRIDENT;
            /**
             * Whether the current platform is Apple iOS.
             */
            this.IOS = this.isBrowser && /iPad|iPhone|iPod/.test(navigator.userAgent) &&
                !('MSStream' in window);
            /**
             * Whether the current browser is Firefox.
             */
            // It's difficult to detect the plain Gecko engine, because most of the browsers identify
            // them self as Gecko-like browsers and modify the userAgent's according to that.
            // Since we only cover one explicit Firefox case, we can simply check for Firefox
            // instead of having an unstable check for Gecko.
            this.FIREFOX = this.isBrowser && /(firefox|minefield)/i.test(navigator.userAgent);
            /**
             * Whether the current platform is Android.
             */
            // Trident on mobile adds the android platform to the userAgent to trick detections.
            this.ANDROID = this.isBrowser && /android/i.test(navigator.userAgent) && !this.TRIDENT;
            /**
             * Whether the current browser is Safari.
             */
            // Safari browsers will include the Safari keyword in their userAgent. Some browsers may fake
            // this and just place the Safari keyword in the userAgent. To be more safe about Safari every
            // Safari browser should also use Webkit as its layout engine.
            this.SAFARI = this.isBrowser && /safari/i.test(navigator.userAgent) && this.WEBKIT;
        }
        return Platform;
    }());
    Platform.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] },
    ];
    /** @nocollapse */
    Platform.ctorParameters = function () { return [
        { type: Object, decorators: [{ type: Optional }, { type: Inject, args: [PLATFORM_ID,] }] }
    ]; };
    /** @nocollapse */ Platform.ngInjectableDef = ɵɵdefineInjectable({ factory: function Platform_Factory() { return new Platform(ɵɵinject(PLATFORM_ID, 8)); }, token: Platform, providedIn: "root" });
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PlatformModule = /** @class */ (function () {
        function PlatformModule() {
        }
        return PlatformModule;
    }());
    PlatformModule.decorators = [
        { type: NgModule, args: [{},] },
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Cached result Set of input types support by the current browser.
     * @type {?}
     */
    var supportedInputTypes;
    /**
     * Types of `<input>` that *might* be supported.
     * @type {?}
     */
    var candidateInputTypes = [
        // `color` must come first. Chrome 56 shows a warning if we change the type to `color` after
        // first changing it to something else:
        // The specified value "" does not conform to the required format.
        // The format is "#rrggbb" where rr, gg, bb are two-digit hexadecimal numbers.
        'color',
        'button',
        'checkbox',
        'date',
        'datetime-local',
        'email',
        'file',
        'hidden',
        'image',
        'month',
        'number',
        'password',
        'radio',
        'range',
        'reset',
        'search',
        'submit',
        'tel',
        'text',
        'time',
        'url',
        'week',
    ];
    /**
     * @return {?} The input types supported by this browser.
     */
    function getSupportedInputTypes() {
        // Result is cached.
        if (supportedInputTypes) {
            return supportedInputTypes;
        }
        // We can't check if an input type is not supported until we're on the browser, so say that
        // everything is supported when not on the browser. We don't use `Platform` here since it's
        // just a helper function and can't inject it.
        if (typeof document !== 'object' || !document) {
            supportedInputTypes = new Set(candidateInputTypes);
            return supportedInputTypes;
        }
        /** @type {?} */
        var featureTestInput = document.createElement('input');
        supportedInputTypes = new Set(candidateInputTypes.filter(( /**
         * @param {?} value
         * @return {?}
         */function (/**
         * @param {?} value
         * @return {?}
         */ value) {
            featureTestInput.setAttribute('type', value);
            return featureTestInput.type === value;
        })));
        return supportedInputTypes;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Cached result of whether the user's browser supports passive event listeners.
     * @type {?}
     */
    var supportsPassiveEvents;
    /**
     * Checks whether the user's browser supports passive event listeners.
     * See: https://github.com/WICG/EventListenerOptions/blob/gh-pages/explainer.md
     * @return {?}
     */
    function supportsPassiveEventListeners() {
        if (supportsPassiveEvents == null && typeof window !== 'undefined') {
            try {
                window.addEventListener('test', ( /** @type {?} */(null)), Object.defineProperty({}, 'passive', {
                    get: ( /**
                     * @return {?}
                     */function () { return supportsPassiveEvents = true; })
                }));
            }
            finally {
                supportsPassiveEvents = supportsPassiveEvents || false;
            }
        }
        return supportsPassiveEvents;
    }
    /**
     * Normalizes an `AddEventListener` object to something that can be passed
     * to `addEventListener` on any browser, no matter whether it supports the
     * `options` parameter.
     * @param {?} options Object to be normalized.
     * @return {?}
     */
    function normalizePassiveListenerOptions(options) {
        return supportsPassiveEventListeners() ? options : !!options.capture;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var RtlScrollAxisType = {
        /**
         * scrollLeft is 0 when scrolled all the way left and (scrollWidth - clientWidth) when scrolled
         * all the way right.
         */
        NORMAL: 0,
        /**
         * scrollLeft is -(scrollWidth - clientWidth) when scrolled all the way left and 0 when scrolled
         * all the way right.
         */
        NEGATED: 1,
        /**
         * scrollLeft is (scrollWidth - clientWidth) when scrolled all the way left and 0 when scrolled
         * all the way right.
         */
        INVERTED: 2,
    };
    RtlScrollAxisType[RtlScrollAxisType.NORMAL] = 'NORMAL';
    RtlScrollAxisType[RtlScrollAxisType.NEGATED] = 'NEGATED';
    RtlScrollAxisType[RtlScrollAxisType.INVERTED] = 'INVERTED';
    /**
     * Cached result of the way the browser handles the horizontal scroll axis in RTL mode.
     * @type {?}
     */
    var rtlScrollAxisType;
    /**
     * Check whether the browser supports scroll behaviors.
     * @return {?}
     */
    function supportsScrollBehavior() {
        return !!(typeof document == 'object' && 'scrollBehavior' in ( /** @type {?} */(document.documentElement)).style);
    }
    /**
     * Checks the type of RTL scroll axis used by this browser. As of time of writing, Chrome is NORMAL,
     * Firefox & Safari are NEGATED, and IE & Edge are INVERTED.
     * @return {?}
     */
    function getRtlScrollAxisType() {
        // We can't check unless we're on the browser. Just assume 'normal' if we're not.
        if (typeof document !== 'object' || !document) {
            return RtlScrollAxisType.NORMAL;
        }
        if (!rtlScrollAxisType) {
            // Create a 1px wide scrolling container and a 2px wide content element.
            /** @type {?} */
            var scrollContainer = document.createElement('div');
            /** @type {?} */
            var containerStyle = scrollContainer.style;
            scrollContainer.dir = 'rtl';
            containerStyle.height = '1px';
            containerStyle.width = '1px';
            containerStyle.overflow = 'auto';
            containerStyle.visibility = 'hidden';
            containerStyle.pointerEvents = 'none';
            containerStyle.position = 'absolute';
            /** @type {?} */
            var content = document.createElement('div');
            /** @type {?} */
            var contentStyle = content.style;
            contentStyle.width = '2px';
            contentStyle.height = '1px';
            scrollContainer.appendChild(content);
            document.body.appendChild(scrollContainer);
            rtlScrollAxisType = RtlScrollAxisType.NORMAL;
            // The viewport starts scrolled all the way to the right in RTL mode. If we are in a NORMAL
            // browser this would mean that the scrollLeft should be 1. If it's zero instead we know we're
            // dealing with one of the other two types of browsers.
            if (scrollContainer.scrollLeft === 0) {
                // In a NEGATED browser the scrollLeft is always somewhere in [-maxScrollAmount, 0]. For an
                // INVERTED browser it is always somewhere in [0, maxScrollAmount]. We can determine which by
                // setting to the scrollLeft to 1. This is past the max for a NEGATED browser, so it will
                // return 0 when we read it again.
                scrollContainer.scrollLeft = 1;
                rtlScrollAxisType =
                    scrollContainer.scrollLeft === 0 ? RtlScrollAxisType.NEGATED : RtlScrollAxisType.INVERTED;
            }
            ( /** @type {?} */(scrollContainer.parentNode)).removeChild(scrollContainer);
        }
        return rtlScrollAxisType;
    }
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /** @type {?} */
    var TAB = 9;
    /** @type {?} */
    var ENTER = 13;
    /** @type {?} */
    var ESCAPE = 27;
    /** @type {?} */
    var SPACE = 32;
    /** @type {?} */
    var PAGE_UP = 33;
    /** @type {?} */
    var PAGE_DOWN = 34;
    /** @type {?} */
    var END = 35;
    /** @type {?} */
    var HOME = 36;
    /** @type {?} */
    var LEFT_ARROW = 37;
    /** @type {?} */
    var UP_ARROW = 38;
    /** @type {?} */
    var RIGHT_ARROW = 39;
    /** @type {?} */
    var DOWN_ARROW = 40;
    /** @type {?} */
    var ZERO = 48;
    /** @type {?} */
    var NINE = 57;
    /** @type {?} */
    var A = 65;
    /** @type {?} */
    var Z = 90;
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Checks whether a modifier key is pressed.
     * @param {?} event Event to be checked.
     * @param {...?} modifiers
     * @return {?}
     */
    function hasModifierKey(event) {
        var modifiers = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            modifiers[_i - 1] = arguments[_i];
        }
        if (modifiers.length) {
            return modifiers.some(( /**
             * @param {?} modifier
             * @return {?}
             */function (/**
             * @param {?} modifier
             * @return {?}
             */ modifier) { return event[modifier]; }));
        }
        return event.altKey || event.shiftKey || event.ctrlKey || event.metaKey;
    }
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Factory that creates a new MutationObserver and allows us to stub it out in unit tests.
     * \@docs-private
     */
    var MutationObserverFactory = /** @class */ (function () {
        function MutationObserverFactory() {
        }
        /**
         * @param {?} callback
         * @return {?}
         */
        MutationObserverFactory.prototype.create = function (callback) {
            return typeof MutationObserver === 'undefined' ? null : new MutationObserver(callback);
        };
        return MutationObserverFactory;
    }());
    MutationObserverFactory.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] },
    ];
    /** @nocollapse */ MutationObserverFactory.ngInjectableDef = ɵɵdefineInjectable({ factory: function MutationObserverFactory_Factory() { return new MutationObserverFactory(); }, token: MutationObserverFactory, providedIn: "root" });
    /**
     * An injectable service that allows watching elements for changes to their content.
     */
    var ContentObserver = /** @class */ (function () {
        /**
         * @param {?} _mutationObserverFactory
         */
        function ContentObserver(_mutationObserverFactory) {
            this._mutationObserverFactory = _mutationObserverFactory;
            /**
             * Keeps track of the existing MutationObservers so they can be reused.
             */
            this._observedElements = new Map();
        }
        /**
         * @return {?}
         */
        ContentObserver.prototype.ngOnDestroy = function () {
            var _this = this;
            this._observedElements.forEach(( /**
             * @param {?} _
             * @param {?} element
             * @return {?}
             */function (_, element) { return _this._cleanupObserver(element); }));
        };
        /**
         * @param {?} elementOrRef
         * @return {?}
         */
        ContentObserver.prototype.observe = function (elementOrRef) {
            var _this = this;
            /** @type {?} */
            var element = coerceElement(elementOrRef);
            return new Observable(( /**
             * @param {?} observer
             * @return {?}
             */function (observer) {
                /** @type {?} */
                var stream = _this._observeElement(element);
                /** @type {?} */
                var subscription = stream.subscribe(observer);
                return ( /**
                 * @return {?}
                 */function () {
                    subscription.unsubscribe();
                    _this._unobserveElement(element);
                });
            }));
        };
        /**
         * Observes the given element by using the existing MutationObserver if available, or creating a
         * new one if not.
         * @private
         * @param {?} element
         * @return {?}
         */
        ContentObserver.prototype._observeElement = function (element) {
            if (!this._observedElements.has(element)) {
                /** @type {?} */
                var stream_1 = new Subject();
                /** @type {?} */
                var observer = this._mutationObserverFactory.create(( /**
                 * @param {?} mutations
                 * @return {?}
                 */function (/**
                 * @param {?} mutations
                 * @return {?}
                 */ mutations) { return stream_1.next(mutations); }));
                if (observer) {
                    observer.observe(element, {
                        characterData: true,
                        childList: true,
                        subtree: true
                    });
                }
                this._observedElements.set(element, { observer: observer, stream: stream_1, count: 1 });
            }
            else {
                ( /** @type {?} */(this._observedElements.get(element))).count++;
            }
            return ( /** @type {?} */(this._observedElements.get(element))).stream;
        };
        /**
         * Un-observes the given element and cleans up the underlying MutationObserver if nobody else is
         * observing this element.
         * @private
         * @param {?} element
         * @return {?}
         */
        ContentObserver.prototype._unobserveElement = function (element) {
            if (this._observedElements.has(element)) {
                ( /** @type {?} */(this._observedElements.get(element))).count--;
                if (!( /** @type {?} */(this._observedElements.get(element))).count) {
                    this._cleanupObserver(element);
                }
            }
        };
        /**
         * Clean up the underlying MutationObserver for the specified element.
         * @private
         * @param {?} element
         * @return {?}
         */
        ContentObserver.prototype._cleanupObserver = function (element) {
            if (this._observedElements.has(element)) {
                var _b = ( /** @type {?} */(this._observedElements.get(element))), observer = _b.observer, stream = _b.stream;
                if (observer) {
                    observer.disconnect();
                }
                stream.complete();
                this._observedElements.delete(element);
            }
        };
        return ContentObserver;
    }());
    ContentObserver.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] },
    ];
    /** @nocollapse */
    ContentObserver.ctorParameters = function () { return [
        { type: MutationObserverFactory }
    ]; };
    /** @nocollapse */ ContentObserver.ngInjectableDef = ɵɵdefineInjectable({ factory: function ContentObserver_Factory() { return new ContentObserver(ɵɵinject(MutationObserverFactory)); }, token: ContentObserver, providedIn: "root" });
    /**
     * Directive that triggers a callback whenever the content of
     * its associated element has changed.
     */
    var CdkObserveContent = /** @class */ (function () {
        /**
         * @param {?} _contentObserver
         * @param {?} _elementRef
         * @param {?} _ngZone
         */
        function CdkObserveContent(_contentObserver, _elementRef, _ngZone) {
            this._contentObserver = _contentObserver;
            this._elementRef = _elementRef;
            this._ngZone = _ngZone;
            /**
             * Event emitted for each change in the element's content.
             */
            this.event = new EventEmitter();
            this._disabled = false;
            this._currentSubscription = null;
        }
        Object.defineProperty(CdkObserveContent.prototype, "disabled", {
            /**
             * Whether observing content is disabled. This option can be used
             * to disconnect the underlying MutationObserver until it is needed.
             * @return {?}
             */
            get: function () { return this._disabled; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._disabled = coerceBooleanProperty(value);
                this._disabled ? this._unsubscribe() : this._subscribe();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CdkObserveContent.prototype, "debounce", {
            /**
             * Debounce interval for emitting the changes.
             * @return {?}
             */
            get: function () { return this._debounce; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._debounce = coerceNumberProperty(value);
                this._subscribe();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        CdkObserveContent.prototype.ngAfterContentInit = function () {
            if (!this._currentSubscription && !this.disabled) {
                this._subscribe();
            }
        };
        /**
         * @return {?}
         */
        CdkObserveContent.prototype.ngOnDestroy = function () {
            this._unsubscribe();
        };
        /**
         * @private
         * @return {?}
         */
        CdkObserveContent.prototype._subscribe = function () {
            var _this = this;
            this._unsubscribe();
            /** @type {?} */
            var stream = this._contentObserver.observe(this._elementRef);
            // TODO(mmalerba): We shouldn't be emitting on this @Output() outside the zone.
            // Consider brining it back inside the zone next time we're making breaking changes.
            // Bringing it back inside can cause things like infinite change detection loops and changed
            // after checked errors if people's code isn't handling it properly.
            this._ngZone.runOutsideAngular(( /**
             * @return {?}
             */function () {
                _this._currentSubscription =
                    (_this.debounce ? stream.pipe(debounceTime(_this.debounce)) : stream).subscribe(_this.event);
            }));
        };
        /**
         * @private
         * @return {?}
         */
        CdkObserveContent.prototype._unsubscribe = function () {
            if (this._currentSubscription) {
                this._currentSubscription.unsubscribe();
            }
        };
        return CdkObserveContent;
    }());
    CdkObserveContent.decorators = [
        { type: Directive, args: [{
                    selector: '[cdkObserveContent]',
                    exportAs: 'cdkObserveContent',
                },] },
    ];
    /** @nocollapse */
    CdkObserveContent.ctorParameters = function () { return [
        { type: ContentObserver },
        { type: ElementRef },
        { type: NgZone }
    ]; };
    CdkObserveContent.propDecorators = {
        event: [{ type: Output, args: ['cdkObserveContent',] }],
        disabled: [{ type: Input, args: ['cdkObserveContentDisabled',] }],
        debounce: [{ type: Input }]
    };
    var ObserversModule = /** @class */ (function () {
        function ObserversModule() {
        }
        return ObserversModule;
    }());
    ObserversModule.decorators = [
        { type: NgModule, args: [{
                    exports: [CdkObserveContent],
                    declarations: [CdkObserveContent],
                    providers: [MutationObserverFactory]
                },] },
    ];
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * IDs are deliminated by an empty space, as per the spec.
     * @type {?}
     */
    var ID_DELIMINATOR = ' ';
    /**
     * Adds the given ID to the specified ARIA attribute on an element.
     * Used for attributes such as aria-labelledby, aria-owns, etc.
     * @param {?} el
     * @param {?} attr
     * @param {?} id
     * @return {?}
     */
    function addAriaReferencedId(el, attr, id) {
        /** @type {?} */
        var ids = getAriaReferenceIds(el, attr);
        if (ids.some(( /**
         * @param {?} existingId
         * @return {?}
         */function (/**
         * @param {?} existingId
         * @return {?}
         */ existingId) { return existingId.trim() == id.trim(); }))) {
            return;
        }
        ids.push(id.trim());
        el.setAttribute(attr, ids.join(ID_DELIMINATOR));
    }
    /**
     * Removes the given ID from the specified ARIA attribute on an element.
     * Used for attributes such as aria-labelledby, aria-owns, etc.
     * @param {?} el
     * @param {?} attr
     * @param {?} id
     * @return {?}
     */
    function removeAriaReferencedId(el, attr, id) {
        /** @type {?} */
        var ids = getAriaReferenceIds(el, attr);
        /** @type {?} */
        var filteredIds = ids.filter(( /**
         * @param {?} val
         * @return {?}
         */function (/**
         * @param {?} val
         * @return {?}
         */ val) { return val != id.trim(); }));
        if (filteredIds.length) {
            el.setAttribute(attr, filteredIds.join(ID_DELIMINATOR));
        }
        else {
            el.removeAttribute(attr);
        }
    }
    /**
     * Gets the list of IDs referenced by the given ARIA attribute on an element.
     * Used for attributes such as aria-labelledby, aria-owns, etc.
     * @param {?} el
     * @param {?} attr
     * @return {?}
     */
    function getAriaReferenceIds(el, attr) {
        // Get string array of all individual ids (whitespace deliminated) in the attribute value
        return (el.getAttribute(attr) || '').match(/\S+/g) || [];
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * ID used for the body container where all messages are appended.
     * @type {?}
     */
    var MESSAGES_CONTAINER_ID = 'cdk-describedby-message-container';
    /**
     * ID prefix used for each created message element.
     * @type {?}
     */
    var CDK_DESCRIBEDBY_ID_PREFIX = 'cdk-describedby-message';
    /**
     * Attribute given to each host element that is described by a message element.
     * @type {?}
     */
    var CDK_DESCRIBEDBY_HOST_ATTRIBUTE = 'cdk-describedby-host';
    /**
     * Global incremental identifier for each registered message element.
     * @type {?}
     */
    var nextId = 0;
    /**
     * Global map of all registered message elements that have been placed into the document.
     * @type {?}
     */
    var messageRegistry = new Map();
    /**
     * Container for all registered messages.
     * @type {?}
     */
    var messagesContainer = null;
    /**
     * Utility that creates visually hidden elements with a message content. Useful for elements that
     * want to use aria-describedby to further describe themselves without adding additional visual
     * content.
     */
    var AriaDescriber = /** @class */ (function () {
        /**
         * @param {?} _document
         */
        function AriaDescriber(_document) {
            this._document = _document;
        }
        /**
         * Adds to the host element an aria-describedby reference to a hidden element that contains
         * the message. If the same message has already been registered, then it will reuse the created
         * message element.
         * @param {?} hostElement
         * @param {?} message
         * @return {?}
         */
        AriaDescriber.prototype.describe = function (hostElement, message) {
            if (!this._canBeDescribed(hostElement, message)) {
                return;
            }
            if (typeof message !== 'string') {
                // We need to ensure that the element has an ID.
                this._setMessageId(message);
                messageRegistry.set(message, { messageElement: message, referenceCount: 0 });
            }
            else if (!messageRegistry.has(message)) {
                this._createMessageElement(message);
            }
            if (!this._isElementDescribedByMessage(hostElement, message)) {
                this._addMessageReference(hostElement, message);
            }
        };
        /**
         * Removes the host element's aria-describedby reference to the message element.
         * @param {?} hostElement
         * @param {?} message
         * @return {?}
         */
        AriaDescriber.prototype.removeDescription = function (hostElement, message) {
            if (!this._isElementNode(hostElement)) {
                return;
            }
            if (this._isElementDescribedByMessage(hostElement, message)) {
                this._removeMessageReference(hostElement, message);
            }
            // If the message is a string, it means that it's one that we created for the
            // consumer so we can remove it safely, otherwise we should leave it in place.
            if (typeof message === 'string') {
                /** @type {?} */
                var registeredMessage = messageRegistry.get(message);
                if (registeredMessage && registeredMessage.referenceCount === 0) {
                    this._deleteMessageElement(message);
                }
            }
            if (messagesContainer && messagesContainer.childNodes.length === 0) {
                this._deleteMessagesContainer();
            }
        };
        /**
         * Unregisters all created message elements and removes the message container.
         * @return {?}
         */
        AriaDescriber.prototype.ngOnDestroy = function () {
            /** @type {?} */
            var describedElements = this._document.querySelectorAll("[" + CDK_DESCRIBEDBY_HOST_ATTRIBUTE + "]");
            for (var i_145 = 0; i_145 < describedElements.length; i_145++) {
                this._removeCdkDescribedByReferenceIds(describedElements[i_145]);
                describedElements[i_145].removeAttribute(CDK_DESCRIBEDBY_HOST_ATTRIBUTE);
            }
            if (messagesContainer) {
                this._deleteMessagesContainer();
            }
            messageRegistry.clear();
        };
        /**
         * Creates a new element in the visually hidden message container element with the message
         * as its content and adds it to the message registry.
         * @private
         * @param {?} message
         * @return {?}
         */
        AriaDescriber.prototype._createMessageElement = function (message) {
            /** @type {?} */
            var messageElement = this._document.createElement('div');
            this._setMessageId(messageElement);
            messageElement.textContent = message;
            this._createMessagesContainer();
            ( /** @type {?} */(messagesContainer)).appendChild(messageElement);
            messageRegistry.set(message, { messageElement: messageElement, referenceCount: 0 });
        };
        /**
         * Assigns a unique ID to an element, if it doesn't have one already.
         * @private
         * @param {?} element
         * @return {?}
         */
        AriaDescriber.prototype._setMessageId = function (element) {
            if (!element.id) {
                element.id = CDK_DESCRIBEDBY_ID_PREFIX + "-" + nextId++;
            }
        };
        /**
         * Deletes the message element from the global messages container.
         * @private
         * @param {?} message
         * @return {?}
         */
        AriaDescriber.prototype._deleteMessageElement = function (message) {
            /** @type {?} */
            var registeredMessage = messageRegistry.get(message);
            /** @type {?} */
            var messageElement = registeredMessage && registeredMessage.messageElement;
            if (messagesContainer && messageElement) {
                messagesContainer.removeChild(messageElement);
            }
            messageRegistry.delete(message);
        };
        /**
         * Creates the global container for all aria-describedby messages.
         * @private
         * @return {?}
         */
        AriaDescriber.prototype._createMessagesContainer = function () {
            if (!messagesContainer) {
                /** @type {?} */
                var preExistingContainer = this._document.getElementById(MESSAGES_CONTAINER_ID);
                // When going from the server to the client, we may end up in a situation where there's
                // already a container on the page, but we don't have a reference to it. Clear the
                // old container so we don't get duplicates. Doing this, instead of emptying the previous
                // container, should be slightly faster.
                if (preExistingContainer) {
                    ( /** @type {?} */(preExistingContainer.parentNode)).removeChild(preExistingContainer);
                }
                messagesContainer = this._document.createElement('div');
                messagesContainer.id = MESSAGES_CONTAINER_ID;
                messagesContainer.setAttribute('aria-hidden', 'true');
                messagesContainer.style.display = 'none';
                this._document.body.appendChild(messagesContainer);
            }
        };
        /**
         * Deletes the global messages container.
         * @private
         * @return {?}
         */
        AriaDescriber.prototype._deleteMessagesContainer = function () {
            if (messagesContainer && messagesContainer.parentNode) {
                messagesContainer.parentNode.removeChild(messagesContainer);
                messagesContainer = null;
            }
        };
        /**
         * Removes all cdk-describedby messages that are hosted through the element.
         * @private
         * @param {?} element
         * @return {?}
         */
        AriaDescriber.prototype._removeCdkDescribedByReferenceIds = function (element) {
            // Remove all aria-describedby reference IDs that are prefixed by CDK_DESCRIBEDBY_ID_PREFIX
            /** @type {?} */
            var originalReferenceIds = getAriaReferenceIds(element, 'aria-describedby')
                .filter(( /**
         * @param {?} id
         * @return {?}
         */function (/**
         * @param {?} id
         * @return {?}
         */ id) { return id.indexOf(CDK_DESCRIBEDBY_ID_PREFIX) != 0; }));
            element.setAttribute('aria-describedby', originalReferenceIds.join(' '));
        };
        /**
         * Adds a message reference to the element using aria-describedby and increments the registered
         * message's reference count.
         * @private
         * @param {?} element
         * @param {?} message
         * @return {?}
         */
        AriaDescriber.prototype._addMessageReference = function (element, message) {
            /** @type {?} */
            var registeredMessage = ( /** @type {?} */(messageRegistry.get(message)));
            // Add the aria-describedby reference and set the
            // describedby_host attribute to mark the element.
            addAriaReferencedId(element, 'aria-describedby', registeredMessage.messageElement.id);
            element.setAttribute(CDK_DESCRIBEDBY_HOST_ATTRIBUTE, '');
            registeredMessage.referenceCount++;
        };
        /**
         * Removes a message reference from the element using aria-describedby
         * and decrements the registered message's reference count.
         * @private
         * @param {?} element
         * @param {?} message
         * @return {?}
         */
        AriaDescriber.prototype._removeMessageReference = function (element, message) {
            /** @type {?} */
            var registeredMessage = ( /** @type {?} */(messageRegistry.get(message)));
            registeredMessage.referenceCount--;
            removeAriaReferencedId(element, 'aria-describedby', registeredMessage.messageElement.id);
            element.removeAttribute(CDK_DESCRIBEDBY_HOST_ATTRIBUTE);
        };
        /**
         * Returns true if the element has been described by the provided message ID.
         * @private
         * @param {?} element
         * @param {?} message
         * @return {?}
         */
        AriaDescriber.prototype._isElementDescribedByMessage = function (element, message) {
            /** @type {?} */
            var referenceIds = getAriaReferenceIds(element, 'aria-describedby');
            /** @type {?} */
            var registeredMessage = messageRegistry.get(message);
            /** @type {?} */
            var messageId = registeredMessage && registeredMessage.messageElement.id;
            return !!messageId && referenceIds.indexOf(messageId) != -1;
        };
        /**
         * Determines whether a message can be described on a particular element.
         * @private
         * @param {?} element
         * @param {?} message
         * @return {?}
         */
        AriaDescriber.prototype._canBeDescribed = function (element, message) {
            if (!this._isElementNode(element)) {
                return false;
            }
            if (message && typeof message === 'object') {
                // We'd have to make some assumptions about the description element's text, if the consumer
                // passed in an element. Assume that if an element is passed in, the consumer has verified
                // that it can be used as a description.
                return true;
            }
            /** @type {?} */
            var trimmedMessage = message == null ? '' : ("" + message).trim();
            /** @type {?} */
            var ariaLabel = element.getAttribute('aria-label');
            // We shouldn't set descriptions if they're exactly the same as the `aria-label` of the
            // element, because screen readers will end up reading out the same text twice in a row.
            return trimmedMessage ? (!ariaLabel || ariaLabel.trim() !== trimmedMessage) : false;
        };
        /**
         * Checks whether a node is an Element node.
         * @private
         * @param {?} element
         * @return {?}
         */
        AriaDescriber.prototype._isElementNode = function (element) {
            return element.nodeType === this._document.ELEMENT_NODE;
        };
        return AriaDescriber;
    }());
    AriaDescriber.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] },
    ];
    /** @nocollapse */
    AriaDescriber.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
    ]; };
    /** @nocollapse */ AriaDescriber.ngInjectableDef = ɵɵdefineInjectable({ factory: function AriaDescriber_Factory() { return new AriaDescriber(ɵɵinject(DOCUMENT)); }, token: AriaDescriber, providedIn: "root" });
    /**
     * \@docs-private \@deprecated \@breaking-change 8.0.0
     * @param {?} parentDispatcher
     * @param {?} _document
     * @return {?}
     */
    function ARIA_DESCRIBER_PROVIDER_FACTORY(parentDispatcher, _document) {
        return parentDispatcher || new AriaDescriber(_document);
    }
    /**
     * \@docs-private \@deprecated \@breaking-change 8.0.0
     * @type {?}
     */
    var ARIA_DESCRIBER_PROVIDER = {
        // If there is already an AriaDescriber available, use that. Otherwise, provide a new one.
        provide: AriaDescriber,
        deps: [
            [new Optional(), new SkipSelf(), AriaDescriber],
            ( /** @type {?} */(DOCUMENT))
        ],
        useFactory: ARIA_DESCRIBER_PROVIDER_FACTORY
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * This class manages keyboard events for selectable lists. If you pass it a query list
     * of items, it will set the active item correctly when arrow events occur.
     * @template T
     */
    var ListKeyManager = /** @class */ (function () {
        /**
         * @param {?} _items
         */
        function ListKeyManager(_items) {
            var _this = this;
            this._items = _items;
            this._activeItemIndex = -1;
            this._activeItem = null;
            this._wrap = false;
            this._letterKeyStream = new Subject();
            this._typeaheadSubscription = Subscription.EMPTY;
            this._vertical = true;
            this._allowedModifierKeys = [];
            /**
             * Predicate function that can be used to check whether an item should be skipped
             * by the key manager. By default, disabled items are skipped.
             */
            this._skipPredicateFn = ( /**
             * @param {?} item
             * @return {?}
             */function (item) { return item.disabled; });
            // Buffer for the letters that the user has pressed when the typeahead option is turned on.
            this._pressedLetters = [];
            /**
             * Stream that emits any time the TAB key is pressed, so components can react
             * when focus is shifted off of the list.
             */
            this.tabOut = new Subject();
            /**
             * Stream that emits whenever the active item of the list manager changes.
             */
            this.change = new Subject();
            // We allow for the items to be an array because, in some cases, the consumer may
            // not have access to a QueryList of the items they want to manage (e.g. when the
            // items aren't being collected via `ViewChildren` or `ContentChildren`).
            if (_items instanceof QueryList) {
                _items.changes.subscribe(( /**
                 * @param {?} newItems
                 * @return {?}
                 */function (newItems) {
                    if (_this._activeItem) {
                        /** @type {?} */
                        var itemArray = newItems.toArray();
                        /** @type {?} */
                        var newIndex = itemArray.indexOf(_this._activeItem);
                        if (newIndex > -1 && newIndex !== _this._activeItemIndex) {
                            _this._activeItemIndex = newIndex;
                        }
                    }
                }));
            }
        }
        /**
         * Sets the predicate function that determines which items should be skipped by the
         * list key manager.
         * @template THIS
         * @this {THIS}
         * @param {?} predicate Function that determines whether the given item should be skipped.
         * @return {THIS}
         */
        ListKeyManager.prototype.skipPredicate = function (predicate) {
            ( /** @type {?} */(this))._skipPredicateFn = predicate;
            return ( /** @type {?} */(this));
        };
        /**
         * Configures wrapping mode, which determines whether the active item will wrap to
         * the other end of list when there are no more items in the given direction.
         * @template THIS
         * @this {THIS}
         * @param {?=} shouldWrap Whether the list should wrap when reaching the end.
         * @return {THIS}
         */
        ListKeyManager.prototype.withWrap = function (shouldWrap) {
            if (shouldWrap === void 0) { shouldWrap = true; }
            ( /** @type {?} */(this))._wrap = shouldWrap;
            return ( /** @type {?} */(this));
        };
        /**
         * Configures whether the key manager should be able to move the selection vertically.
         * @template THIS
         * @this {THIS}
         * @param {?=} enabled Whether vertical selection should be enabled.
         * @return {THIS}
         */
        ListKeyManager.prototype.withVerticalOrientation = function (enabled) {
            if (enabled === void 0) { enabled = true; }
            ( /** @type {?} */(this))._vertical = enabled;
            return ( /** @type {?} */(this));
        };
        /**
         * Configures the key manager to move the selection horizontally.
         * Passing in `null` will disable horizontal movement.
         * @template THIS
         * @this {THIS}
         * @param {?} direction Direction in which the selection can be moved.
         * @return {THIS}
         */
        ListKeyManager.prototype.withHorizontalOrientation = function (direction) {
            ( /** @type {?} */(this))._horizontal = direction;
            return ( /** @type {?} */(this));
        };
        /**
         * Modifier keys which are allowed to be held down and whose default actions will be prevented
         * as the user is pressing the arrow keys. Defaults to not allowing any modifier keys.
         * @template THIS
         * @this {THIS}
         * @param {?} keys
         * @return {THIS}
         */
        ListKeyManager.prototype.withAllowedModifierKeys = function (keys) {
            ( /** @type {?} */(this))._allowedModifierKeys = keys;
            return ( /** @type {?} */(this));
        };
        /**
         * Turns on typeahead mode which allows users to set the active item by typing.
         * @template THIS
         * @this {THIS}
         * @param {?=} debounceInterval Time to wait after the last keystroke before setting the active item.
         * @return {THIS}
         */
        ListKeyManager.prototype.withTypeAhead = function (debounceInterval) {
            var _this = this;
            if (debounceInterval === void 0) { debounceInterval = 200; }
            if (( /** @type {?} */(this))._items.length && ( /** @type {?} */(this))._items.some(( /**
             * @param {?} item
             * @return {?}
             */function (/**
             * @param {?} item
             * @return {?}
             */ item) { return typeof item.getLabel !== 'function'; }))) {
                throw Error('ListKeyManager items in typeahead mode must implement the `getLabel` method.');
            }
            ( /** @type {?} */(this))._typeaheadSubscription.unsubscribe();
            // Debounce the presses of non-navigational keys, collect the ones that correspond to letters
            // and convert those letters back into a string. Afterwards find the first item that starts
            // with that string and select it.
            ( /** @type {?} */(this))._typeaheadSubscription = ( /** @type {?} */(this))._letterKeyStream.pipe(tap(( /**
             * @param {?} keyCode
             * @return {?}
             */function (/**
             * @param {?} keyCode
             * @return {?}
             */ keyCode) { return ( /** @type {?} */(_this))._pressedLetters.push(keyCode); })), debounceTime(debounceInterval), filter(( /**
             * @return {?}
             */function () { return ( /** @type {?} */(_this))._pressedLetters.length > 0; })), map(( /**
             * @return {?}
             */function () { return ( /** @type {?} */(_this))._pressedLetters.join(''); }))).subscribe(( /**
             * @param {?} inputString
             * @return {?}
             */function (/**
             * @param {?} inputString
             * @return {?}
             */ inputString) {
                /** @type {?} */
                var items = ( /** @type {?} */(_this))._getItemsArray();
                // Start at 1 because we want to start searching at the item immediately
                // following the current active item.
                for (var i_146 = 1; i_146 < items.length + 1; i_146++) {
                    /** @type {?} */
                    var index = (( /** @type {?} */(_this))._activeItemIndex + i_146) % items.length;
                    /** @type {?} */
                    var item = items[index];
                    if (!( /** @type {?} */(_this))._skipPredicateFn(item) &&
                        ( /** @type {?} */(item.getLabel))().toUpperCase().trim().indexOf(inputString) === 0) {
                        ( /** @type {?} */(_this)).setActiveItem(index);
                        break;
                    }
                }
                ( /** @type {?} */(_this))._pressedLetters = [];
            }));
            return ( /** @type {?} */(this));
        };
        /**
         * @param {?} item
         * @return {?}
         */
        ListKeyManager.prototype.setActiveItem = function (item) {
            /** @type {?} */
            var previousIndex = this._activeItemIndex;
            this.updateActiveItem(item);
            if (this._activeItemIndex !== previousIndex) {
                this.change.next(this._activeItemIndex);
            }
        };
        /**
         * Sets the active item depending on the key event passed in.
         * @param {?} event Keyboard event to be used for determining which element should be active.
         * @return {?}
         */
        ListKeyManager.prototype.onKeydown = function (event) {
            var _this = this;
            /** @type {?} */
            var keyCode = event.keyCode;
            /** @type {?} */
            var modifiers = ['altKey', 'ctrlKey', 'metaKey', 'shiftKey'];
            /** @type {?} */
            var isModifierAllowed = modifiers.every(( /**
             * @param {?} modifier
             * @return {?}
             */function (/**
             * @param {?} modifier
             * @return {?}
             */ modifier) {
                return !event[modifier] || _this._allowedModifierKeys.indexOf(modifier) > -1;
            }));
            switch (keyCode) {
                case TAB:
                    this.tabOut.next();
                    return;
                case DOWN_ARROW:
                    if (this._vertical && isModifierAllowed) {
                        this.setNextItemActive();
                        break;
                    }
                    else {
                        return;
                    }
                case UP_ARROW:
                    if (this._vertical && isModifierAllowed) {
                        this.setPreviousItemActive();
                        break;
                    }
                    else {
                        return;
                    }
                case RIGHT_ARROW:
                    if (this._horizontal && isModifierAllowed) {
                        this._horizontal === 'rtl' ? this.setPreviousItemActive() : this.setNextItemActive();
                        break;
                    }
                    else {
                        return;
                    }
                case LEFT_ARROW:
                    if (this._horizontal && isModifierAllowed) {
                        this._horizontal === 'rtl' ? this.setNextItemActive() : this.setPreviousItemActive();
                        break;
                    }
                    else {
                        return;
                    }
                default:
                    if (isModifierAllowed || hasModifierKey(event, 'shiftKey')) {
                        // Attempt to use the `event.key` which also maps it to the user's keyboard language,
                        // otherwise fall back to resolving alphanumeric characters via the keyCode.
                        if (event.key && event.key.length === 1) {
                            this._letterKeyStream.next(event.key.toLocaleUpperCase());
                        }
                        else if ((keyCode >= A && keyCode <= Z) || (keyCode >= ZERO && keyCode <= NINE)) {
                            this._letterKeyStream.next(String.fromCharCode(keyCode));
                        }
                    }
                    // Note that we return here, in order to avoid preventing
                    // the default action of non-navigational keys.
                    return;
            }
            this._pressedLetters = [];
            event.preventDefault();
        };
        Object.defineProperty(ListKeyManager.prototype, "activeItemIndex", {
            /**
             * Index of the currently active item.
             * @return {?}
             */
            get: function () {
                return this._activeItemIndex;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ListKeyManager.prototype, "activeItem", {
            /**
             * The active item.
             * @return {?}
             */
            get: function () {
                return this._activeItem;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Sets the active item to the first enabled item in the list.
         * @return {?}
         */
        ListKeyManager.prototype.setFirstItemActive = function () {
            this._setActiveItemByIndex(0, 1);
        };
        /**
         * Sets the active item to the last enabled item in the list.
         * @return {?}
         */
        ListKeyManager.prototype.setLastItemActive = function () {
            this._setActiveItemByIndex(this._items.length - 1, -1);
        };
        /**
         * Sets the active item to the next enabled item in the list.
         * @return {?}
         */
        ListKeyManager.prototype.setNextItemActive = function () {
            this._activeItemIndex < 0 ? this.setFirstItemActive() : this._setActiveItemByDelta(1);
        };
        /**
         * Sets the active item to a previous enabled item in the list.
         * @return {?}
         */
        ListKeyManager.prototype.setPreviousItemActive = function () {
            this._activeItemIndex < 0 && this._wrap ? this.setLastItemActive()
                : this._setActiveItemByDelta(-1);
        };
        /**
         * @param {?} item
         * @return {?}
         */
        ListKeyManager.prototype.updateActiveItem = function (item) {
            /** @type {?} */
            var itemArray = this._getItemsArray();
            /** @type {?} */
            var index = typeof item === 'number' ? item : itemArray.indexOf(item);
            /** @type {?} */
            var activeItem = itemArray[index];
            // Explicitly check for `null` and `undefined` because other falsy values are valid.
            this._activeItem = activeItem == null ? null : activeItem;
            this._activeItemIndex = index;
        };
        /**
         * Allows setting of the activeItemIndex without any other effects.
         * @deprecated Use `updateActiveItem` instead.
         * \@breaking-change 8.0.0
         * @param {?} index The new activeItemIndex.
         * @return {?}
         */
        ListKeyManager.prototype.updateActiveItemIndex = function (index) {
            this.updateActiveItem(index);
        };
        /**
         * This method sets the active item, given a list of items and the delta between the
         * currently active item and the new active item. It will calculate differently
         * depending on whether wrap mode is turned on.
         * @private
         * @param {?} delta
         * @return {?}
         */
        ListKeyManager.prototype._setActiveItemByDelta = function (delta) {
            this._wrap ? this._setActiveInWrapMode(delta) : this._setActiveInDefaultMode(delta);
        };
        /**
         * Sets the active item properly given "wrap" mode. In other words, it will continue to move
         * down the list until it finds an item that is not disabled, and it will wrap if it
         * encounters either end of the list.
         * @private
         * @param {?} delta
         * @return {?}
         */
        ListKeyManager.prototype._setActiveInWrapMode = function (delta) {
            /** @type {?} */
            var items = this._getItemsArray();
            for (var i_147 = 1; i_147 <= items.length; i_147++) {
                /** @type {?} */
                var index = (this._activeItemIndex + (delta * i_147) + items.length) % items.length;
                /** @type {?} */
                var item = items[index];
                if (!this._skipPredicateFn(item)) {
                    this.setActiveItem(index);
                    return;
                }
            }
        };
        /**
         * Sets the active item properly given the default mode. In other words, it will
         * continue to move down the list until it finds an item that is not disabled. If
         * it encounters either end of the list, it will stop and not wrap.
         * @private
         * @param {?} delta
         * @return {?}
         */
        ListKeyManager.prototype._setActiveInDefaultMode = function (delta) {
            this._setActiveItemByIndex(this._activeItemIndex + delta, delta);
        };
        /**
         * Sets the active item to the first enabled item starting at the index specified. If the
         * item is disabled, it will move in the fallbackDelta direction until it either
         * finds an enabled item or encounters the end of the list.
         * @private
         * @param {?} index
         * @param {?} fallbackDelta
         * @return {?}
         */
        ListKeyManager.prototype._setActiveItemByIndex = function (index, fallbackDelta) {
            /** @type {?} */
            var items = this._getItemsArray();
            if (!items[index]) {
                return;
            }
            while (this._skipPredicateFn(items[index])) {
                index += fallbackDelta;
                if (!items[index]) {
                    return;
                }
            }
            this.setActiveItem(index);
        };
        /**
         * Returns the items as an array.
         * @private
         * @return {?}
         */
        ListKeyManager.prototype._getItemsArray = function () {
            return this._items instanceof QueryList ? this._items.toArray() : this._items;
        };
        return ListKeyManager;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var ActiveDescendantKeyManager = /** @class */ (function (_super) {
        __extends(ActiveDescendantKeyManager, _super);
        function ActiveDescendantKeyManager() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @param {?} index
         * @return {?}
         */
        ActiveDescendantKeyManager.prototype.setActiveItem = function (index) {
            if (this.activeItem) {
                this.activeItem.setInactiveStyles();
            }
            _super.prototype.setActiveItem.call(this, index);
            if (this.activeItem) {
                this.activeItem.setActiveStyles();
            }
        };
        return ActiveDescendantKeyManager;
    }(ListKeyManager));
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var FocusKeyManager = /** @class */ (function (_super) {
        __extends(FocusKeyManager, _super);
        function FocusKeyManager() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this._origin = 'program';
            return _this;
        }
        /**
         * Sets the focus origin that will be passed in to the items for any subsequent `focus` calls.
         * @template THIS
         * @this {THIS}
         * @param {?} origin Focus origin to be used when focusing items.
         * @return {THIS}
         */
        FocusKeyManager.prototype.setFocusOrigin = function (origin) {
            ( /** @type {?} */(this))._origin = origin;
            return ( /** @type {?} */(this));
        };
        /**
         * @param {?} item
         * @return {?}
         */
        FocusKeyManager.prototype.setActiveItem = function (item) {
            _super.prototype.setActiveItem.call(this, item);
            if (this.activeItem) {
                this.activeItem.focus(this._origin);
            }
        };
        return FocusKeyManager;
    }(ListKeyManager));
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // The InteractivityChecker leans heavily on the ally.js accessibility utilities.
    // Methods like `isTabbable` are only covering specific edge-cases for the browsers which are
    // supported.
    /**
     * Utility for checking the interactivity of an element, such as whether is is focusable or
     * tabbable.
     */
    var InteractivityChecker = /** @class */ (function () {
        /**
         * @param {?} _platform
         */
        function InteractivityChecker(_platform) {
            this._platform = _platform;
        }
        /**
         * Gets whether an element is disabled.
         *
         * @param {?} element Element to be checked.
         * @return {?} Whether the element is disabled.
         */
        InteractivityChecker.prototype.isDisabled = function (element) {
            // This does not capture some cases, such as a non-form control with a disabled attribute or
            // a form control inside of a disabled form, but should capture the most common cases.
            return element.hasAttribute('disabled');
        };
        /**
         * Gets whether an element is visible for the purposes of interactivity.
         *
         * This will capture states like `display: none` and `visibility: hidden`, but not things like
         * being clipped by an `overflow: hidden` parent or being outside the viewport.
         *
         * @param {?} element
         * @return {?} Whether the element is visible.
         */
        InteractivityChecker.prototype.isVisible = function (element) {
            return hasGeometry(element) && getComputedStyle(element).visibility === 'visible';
        };
        /**
         * Gets whether an element can be reached via Tab key.
         * Assumes that the element has already been checked with isFocusable.
         *
         * @param {?} element Element to be checked.
         * @return {?} Whether the element is tabbable.
         */
        InteractivityChecker.prototype.isTabbable = function (element) {
            // Nothing is tabbable on the server 😎
            if (!this._platform.isBrowser) {
                return false;
            }
            /** @type {?} */
            var frameElement = getFrameElement(getWindow(element));
            if (frameElement) {
                /** @type {?} */
                var frameType = frameElement && frameElement.nodeName.toLowerCase();
                // Frame elements inherit their tabindex onto all child elements.
                if (getTabIndexValue(frameElement) === -1) {
                    return false;
                }
                // Webkit and Blink consider anything inside of an <object> element as non-tabbable.
                if ((this._platform.BLINK || this._platform.WEBKIT) && frameType === 'object') {
                    return false;
                }
                // Webkit and Blink disable tabbing to an element inside of an invisible frame.
                if ((this._platform.BLINK || this._platform.WEBKIT) && !this.isVisible(frameElement)) {
                    return false;
                }
            }
            /** @type {?} */
            var nodeName = element.nodeName.toLowerCase();
            /** @type {?} */
            var tabIndexValue = getTabIndexValue(element);
            if (element.hasAttribute('contenteditable')) {
                return tabIndexValue !== -1;
            }
            if (nodeName === 'iframe') {
                // The frames may be tabbable depending on content, but it's not possibly to reliably
                // investigate the content of the frames.
                return false;
            }
            if (nodeName === 'audio') {
                if (!element.hasAttribute('controls')) {
                    // By default an <audio> element without the controls enabled is not tabbable.
                    return false;
                }
                else if (this._platform.BLINK) {
                    // In Blink <audio controls> elements are always tabbable.
                    return true;
                }
            }
            if (nodeName === 'video') {
                if (!element.hasAttribute('controls') && this._platform.TRIDENT) {
                    // In Trident a <video> element without the controls enabled is not tabbable.
                    return false;
                }
                else if (this._platform.BLINK || this._platform.FIREFOX) {
                    // In Chrome and Firefox <video controls> elements are always tabbable.
                    return true;
                }
            }
            if (nodeName === 'object' && (this._platform.BLINK || this._platform.WEBKIT)) {
                // In all Blink and WebKit based browsers <object> elements are never tabbable.
                return false;
            }
            // In iOS the browser only considers some specific elements as tabbable.
            if (this._platform.WEBKIT && this._platform.IOS && !isPotentiallyTabbableIOS(element)) {
                return false;
            }
            return element.tabIndex >= 0;
        };
        /**
         * Gets whether an element can be focused by the user.
         *
         * @param {?} element Element to be checked.
         * @return {?} Whether the element is focusable.
         */
        InteractivityChecker.prototype.isFocusable = function (element) {
            // Perform checks in order of left to most expensive.
            // Again, naive approach that does not capture many edge cases and browser quirks.
            return isPotentiallyFocusable(element) && !this.isDisabled(element) && this.isVisible(element);
        };
        return InteractivityChecker;
    }());
    InteractivityChecker.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] },
    ];
    /** @nocollapse */
    InteractivityChecker.ctorParameters = function () { return [
        { type: Platform }
    ]; };
    /** @nocollapse */ InteractivityChecker.ngInjectableDef = ɵɵdefineInjectable({ factory: function InteractivityChecker_Factory() { return new InteractivityChecker(ɵɵinject(Platform)); }, token: InteractivityChecker, providedIn: "root" });
    /**
     * Returns the frame element from a window object. Since browsers like MS Edge throw errors if
     * the frameElement property is being accessed from a different host address, this property
     * should be accessed carefully.
     * @param {?} window
     * @return {?}
     */
    function getFrameElement(window) {
        try {
            return ( /** @type {?} */(window.frameElement));
        }
        catch (_a) {
            return null;
        }
    }
    /**
     * Checks whether the specified element has any geometry / rectangles.
     * @param {?} element
     * @return {?}
     */
    function hasGeometry(element) {
        // Use logic from jQuery to check for an invisible element.
        // See https://github.com/jquery/jquery/blob/master/src/css/hiddenVisibleSelectors.js#L12
        return !!(element.offsetWidth || element.offsetHeight ||
            (typeof element.getClientRects === 'function' && element.getClientRects().length));
    }
    /**
     * Gets whether an element's
     * @param {?} element
     * @return {?}
     */
    function isNativeFormElement(element) {
        /** @type {?} */
        var nodeName = element.nodeName.toLowerCase();
        return nodeName === 'input' ||
            nodeName === 'select' ||
            nodeName === 'button' ||
            nodeName === 'textarea';
    }
    /**
     * Gets whether an element is an `<input type="hidden">`.
     * @param {?} element
     * @return {?}
     */
    function isHiddenInput(element) {
        return isInputElement(element) && element.type == 'hidden';
    }
    /**
     * Gets whether an element is an anchor that has an href attribute.
     * @param {?} element
     * @return {?}
     */
    function isAnchorWithHref(element) {
        return isAnchorElement(element) && element.hasAttribute('href');
    }
    /**
     * Gets whether an element is an input element.
     * @param {?} element
     * @return {?}
     */
    function isInputElement(element) {
        return element.nodeName.toLowerCase() == 'input';
    }
    /**
     * Gets whether an element is an anchor element.
     * @param {?} element
     * @return {?}
     */
    function isAnchorElement(element) {
        return element.nodeName.toLowerCase() == 'a';
    }
    /**
     * Gets whether an element has a valid tabindex.
     * @param {?} element
     * @return {?}
     */
    function hasValidTabIndex(element) {
        if (!element.hasAttribute('tabindex') || element.tabIndex === undefined) {
            return false;
        }
        /** @type {?} */
        var tabIndex = element.getAttribute('tabindex');
        // IE11 parses tabindex="" as the value "-32768"
        if (tabIndex == '-32768') {
            return false;
        }
        return !!(tabIndex && !isNaN(parseInt(tabIndex, 10)));
    }
    /**
     * Returns the parsed tabindex from the element attributes instead of returning the
     * evaluated tabindex from the browsers defaults.
     * @param {?} element
     * @return {?}
     */
    function getTabIndexValue(element) {
        if (!hasValidTabIndex(element)) {
            return null;
        }
        // See browser issue in Gecko https://bugzilla.mozilla.org/show_bug.cgi?id=1128054
        /** @type {?} */
        var tabIndex = parseInt(element.getAttribute('tabindex') || '', 10);
        return isNaN(tabIndex) ? -1 : tabIndex;
    }
    /**
     * Checks whether the specified element is potentially tabbable on iOS
     * @param {?} element
     * @return {?}
     */
    function isPotentiallyTabbableIOS(element) {
        /** @type {?} */
        var nodeName = element.nodeName.toLowerCase();
        /** @type {?} */
        var inputType = nodeName === 'input' && (( /** @type {?} */(element))).type;
        return inputType === 'text'
            || inputType === 'password'
            || nodeName === 'select'
            || nodeName === 'textarea';
    }
    /**
     * Gets whether an element is potentially focusable without taking current visible/disabled state
     * into account.
     * @param {?} element
     * @return {?}
     */
    function isPotentiallyFocusable(element) {
        // Inputs are potentially focusable *unless* they're type="hidden".
        if (isHiddenInput(element)) {
            return false;
        }
        return isNativeFormElement(element) ||
            isAnchorWithHref(element) ||
            element.hasAttribute('contenteditable') ||
            hasValidTabIndex(element);
    }
    /**
     * Gets the parent window of a DOM node with regards of being inside of an iframe.
     * @param {?} node
     * @return {?}
     */
    function getWindow(node) {
        // ownerDocument is null if `node` itself *is* a document.
        return node.ownerDocument && node.ownerDocument.defaultView || window;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Class that allows for trapping focus within a DOM element.
     *
     * This class currently uses a relatively simple approach to focus trapping.
     * It assumes that the tab order is the same as DOM order, which is not necessarily true.
     * Things like `tabIndex > 0`, flex `order`, and shadow roots can cause to two to misalign.
     */
    var FocusTrap = /** @class */ (function () {
        /**
         * @param {?} _element
         * @param {?} _checker
         * @param {?} _ngZone
         * @param {?} _document
         * @param {?=} deferAnchors
         */
        function FocusTrap(_element, _checker, _ngZone, _document, deferAnchors) {
            if (deferAnchors === void 0) { deferAnchors = false; }
            var _this = this;
            this._element = _element;
            this._checker = _checker;
            this._ngZone = _ngZone;
            this._document = _document;
            this._hasAttached = false;
            // Event listeners for the anchors. Need to be regular functions so that we can unbind them later.
            this.startAnchorListener = ( /**
             * @return {?}
             */function () { return _this.focusLastTabbableElement(); });
            this.endAnchorListener = ( /**
             * @return {?}
             */function () { return _this.focusFirstTabbableElement(); });
            this._enabled = true;
            if (!deferAnchors) {
                this.attachAnchors();
            }
        }
        Object.defineProperty(FocusTrap.prototype, "enabled", {
            /**
             * Whether the focus trap is active.
             * @return {?}
             */
            get: function () { return this._enabled; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._enabled = value;
                if (this._startAnchor && this._endAnchor) {
                    this._toggleAnchorTabIndex(value, this._startAnchor);
                    this._toggleAnchorTabIndex(value, this._endAnchor);
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Destroys the focus trap by cleaning up the anchors.
         * @return {?}
         */
        FocusTrap.prototype.destroy = function () {
            /** @type {?} */
            var startAnchor = this._startAnchor;
            /** @type {?} */
            var endAnchor = this._endAnchor;
            if (startAnchor) {
                startAnchor.removeEventListener('focus', this.startAnchorListener);
                if (startAnchor.parentNode) {
                    startAnchor.parentNode.removeChild(startAnchor);
                }
            }
            if (endAnchor) {
                endAnchor.removeEventListener('focus', this.endAnchorListener);
                if (endAnchor.parentNode) {
                    endAnchor.parentNode.removeChild(endAnchor);
                }
            }
            this._startAnchor = this._endAnchor = null;
        };
        /**
         * Inserts the anchors into the DOM. This is usually done automatically
         * in the constructor, but can be deferred for cases like directives with `*ngIf`.
         * @return {?} Whether the focus trap managed to attach successfuly. This may not be the case
         * if the target element isn't currently in the DOM.
         */
        FocusTrap.prototype.attachAnchors = function () {
            var _this = this;
            // If we're not on the browser, there can be no focus to trap.
            if (this._hasAttached) {
                return true;
            }
            this._ngZone.runOutsideAngular(( /**
             * @return {?}
             */function () {
                if (!_this._startAnchor) {
                    _this._startAnchor = _this._createAnchor();
                    ( /** @type {?} */(_this._startAnchor)).addEventListener('focus', _this.startAnchorListener);
                }
                if (!_this._endAnchor) {
                    _this._endAnchor = _this._createAnchor();
                    ( /** @type {?} */(_this._endAnchor)).addEventListener('focus', _this.endAnchorListener);
                }
            }));
            if (this._element.parentNode) {
                this._element.parentNode.insertBefore(( /** @type {?} */(this._startAnchor)), this._element);
                this._element.parentNode.insertBefore(( /** @type {?} */(this._endAnchor)), this._element.nextSibling);
                this._hasAttached = true;
            }
            return this._hasAttached;
        };
        /**
         * Waits for the zone to stabilize, then either focuses the first element that the
         * user specified, or the first tabbable element.
         * @return {?} Returns a promise that resolves with a boolean, depending
         * on whether focus was moved successfuly.
         */
        FocusTrap.prototype.focusInitialElementWhenReady = function () {
            var _this = this;
            return new Promise(( /**
             * @param {?} resolve
             * @return {?}
             */function (/**
             * @param {?} resolve
             * @return {?}
             */ resolve) {
                _this._executeOnStable(( /**
                 * @return {?}
                 */function () { return resolve(_this.focusInitialElement()); }));
            }));
        };
        /**
         * Waits for the zone to stabilize, then focuses
         * the first tabbable element within the focus trap region.
         * @return {?} Returns a promise that resolves with a boolean, depending
         * on whether focus was moved successfuly.
         */
        FocusTrap.prototype.focusFirstTabbableElementWhenReady = function () {
            var _this = this;
            return new Promise(( /**
             * @param {?} resolve
             * @return {?}
             */function (/**
             * @param {?} resolve
             * @return {?}
             */ resolve) {
                _this._executeOnStable(( /**
                 * @return {?}
                 */function () { return resolve(_this.focusFirstTabbableElement()); }));
            }));
        };
        /**
         * Waits for the zone to stabilize, then focuses
         * the last tabbable element within the focus trap region.
         * @return {?} Returns a promise that resolves with a boolean, depending
         * on whether focus was moved successfuly.
         */
        FocusTrap.prototype.focusLastTabbableElementWhenReady = function () {
            var _this = this;
            return new Promise(( /**
             * @param {?} resolve
             * @return {?}
             */function (/**
             * @param {?} resolve
             * @return {?}
             */ resolve) {
                _this._executeOnStable(( /**
                 * @return {?}
                 */function () { return resolve(_this.focusLastTabbableElement()); }));
            }));
        };
        /**
         * Get the specified boundary element of the trapped region.
         * @private
         * @param {?} bound The boundary to get (start or end of trapped region).
         * @return {?} The boundary element.
         */
        FocusTrap.prototype._getRegionBoundary = function (bound) {
            // Contains the deprecated version of selector, for temporary backwards comparability.
            /** @type {?} */
            var markers = ( /** @type {?} */(this._element.querySelectorAll("[cdk-focus-region-" + bound + "], " +
                ("[cdkFocusRegion" + bound + "], ") +
                ("[cdk-focus-" + bound + "]"))));
            for (var i_148 = 0; i_148 < markers.length; i_148++) {
                // @breaking-change 8.0.0
                if (markers[i_148].hasAttribute("cdk-focus-" + bound)) {
                    console.warn("Found use of deprecated attribute 'cdk-focus-" + bound + "', " +
                        ("use 'cdkFocusRegion" + bound + "' instead. The deprecated ") +
                        "attribute will be removed in 8.0.0.", markers[i_148]);
                }
                else if (markers[i_148].hasAttribute("cdk-focus-region-" + bound)) {
                    console.warn("Found use of deprecated attribute 'cdk-focus-region-" + bound + "', " +
                        ("use 'cdkFocusRegion" + bound + "' instead. The deprecated attribute ") +
                        "will be removed in 8.0.0.", markers[i_148]);
                }
            }
            if (bound == 'start') {
                return markers.length ? markers[0] : this._getFirstTabbableElement(this._element);
            }
            return markers.length ?
                markers[markers.length - 1] : this._getLastTabbableElement(this._element);
        };
        /**
         * Focuses the element that should be focused when the focus trap is initialized.
         * @return {?} Whether focus was moved successfuly.
         */
        FocusTrap.prototype.focusInitialElement = function () {
            // Contains the deprecated version of selector, for temporary backwards comparability.
            /** @type {?} */
            var redirectToElement = ( /** @type {?} */(this._element.querySelector("[cdk-focus-initial], " +
                "[cdkFocusInitial]")));
            if (redirectToElement) {
                // @breaking-change 8.0.0
                if (redirectToElement.hasAttribute("cdk-focus-initial")) {
                    console.warn("Found use of deprecated attribute 'cdk-focus-initial', " +
                        "use 'cdkFocusInitial' instead. The deprecated attribute " +
                        "will be removed in 8.0.0", redirectToElement);
                }
                // Warn the consumer if the element they've pointed to
                // isn't focusable, when not in production mode.
                if (isDevMode() && !this._checker.isFocusable(redirectToElement)) {
                    console.warn("Element matching '[cdkFocusInitial]' is not focusable.", redirectToElement);
                }
                redirectToElement.focus();
                return true;
            }
            return this.focusFirstTabbableElement();
        };
        /**
         * Focuses the first tabbable element within the focus trap region.
         * @return {?} Whether focus was moved successfuly.
         */
        FocusTrap.prototype.focusFirstTabbableElement = function () {
            /** @type {?} */
            var redirectToElement = this._getRegionBoundary('start');
            if (redirectToElement) {
                redirectToElement.focus();
            }
            return !!redirectToElement;
        };
        /**
         * Focuses the last tabbable element within the focus trap region.
         * @return {?} Whether focus was moved successfuly.
         */
        FocusTrap.prototype.focusLastTabbableElement = function () {
            /** @type {?} */
            var redirectToElement = this._getRegionBoundary('end');
            if (redirectToElement) {
                redirectToElement.focus();
            }
            return !!redirectToElement;
        };
        /**
         * Checks whether the focus trap has successfuly been attached.
         * @return {?}
         */
        FocusTrap.prototype.hasAttached = function () {
            return this._hasAttached;
        };
        /**
         * Get the first tabbable element from a DOM subtree (inclusive).
         * @private
         * @param {?} root
         * @return {?}
         */
        FocusTrap.prototype._getFirstTabbableElement = function (root) {
            if (this._checker.isFocusable(root) && this._checker.isTabbable(root)) {
                return root;
            }
            // Iterate in DOM order. Note that IE doesn't have `children` for SVG so we fall
            // back to `childNodes` which includes text nodes, comments etc.
            /** @type {?} */
            var children = root.children || root.childNodes;
            for (var i_149 = 0; i_149 < children.length; i_149++) {
                /** @type {?} */
                var tabbableChild = children[i_149].nodeType === this._document.ELEMENT_NODE ?
                    this._getFirstTabbableElement(( /** @type {?} */(children[i_149]))) :
                    null;
                if (tabbableChild) {
                    return tabbableChild;
                }
            }
            return null;
        };
        /**
         * Get the last tabbable element from a DOM subtree (inclusive).
         * @private
         * @param {?} root
         * @return {?}
         */
        FocusTrap.prototype._getLastTabbableElement = function (root) {
            if (this._checker.isFocusable(root) && this._checker.isTabbable(root)) {
                return root;
            }
            // Iterate in reverse DOM order.
            /** @type {?} */
            var children = root.children || root.childNodes;
            for (var i_150 = children.length - 1; i_150 >= 0; i_150--) {
                /** @type {?} */
                var tabbableChild = children[i_150].nodeType === this._document.ELEMENT_NODE ?
                    this._getLastTabbableElement(( /** @type {?} */(children[i_150]))) :
                    null;
                if (tabbableChild) {
                    return tabbableChild;
                }
            }
            return null;
        };
        /**
         * Creates an anchor element.
         * @private
         * @return {?}
         */
        FocusTrap.prototype._createAnchor = function () {
            /** @type {?} */
            var anchor = this._document.createElement('div');
            this._toggleAnchorTabIndex(this._enabled, anchor);
            anchor.classList.add('cdk-visually-hidden');
            anchor.classList.add('cdk-focus-trap-anchor');
            anchor.setAttribute('aria-hidden', 'true');
            return anchor;
        };
        /**
         * Toggles the `tabindex` of an anchor, based on the enabled state of the focus trap.
         * @private
         * @param {?} isEnabled Whether the focus trap is enabled.
         * @param {?} anchor Anchor on which to toggle the tabindex.
         * @return {?}
         */
        FocusTrap.prototype._toggleAnchorTabIndex = function (isEnabled, anchor) {
            // Remove the tabindex completely, rather than setting it to -1, because if the
            // element has a tabindex, the user might still hit it when navigating with the arrow keys.
            isEnabled ? anchor.setAttribute('tabindex', '0') : anchor.removeAttribute('tabindex');
        };
        /**
         * Executes a function when the zone is stable.
         * @private
         * @param {?} fn
         * @return {?}
         */
        FocusTrap.prototype._executeOnStable = function (fn) {
            if (this._ngZone.isStable) {
                fn();
            }
            else {
                this._ngZone.onStable.asObservable().pipe(take(1)).subscribe(fn);
            }
        };
        return FocusTrap;
    }());
    /**
     * Factory that allows easy instantiation of focus traps.
     */
    var FocusTrapFactory = /** @class */ (function () {
        /**
         * @param {?} _checker
         * @param {?} _ngZone
         * @param {?} _document
         */
        function FocusTrapFactory(_checker, _ngZone, _document) {
            this._checker = _checker;
            this._ngZone = _ngZone;
            this._document = _document;
        }
        /**
         * Creates a focus-trapped region around the given element.
         * @param {?} element The element around which focus will be trapped.
         * @param {?=} deferCaptureElements Defers the creation of focus-capturing elements to be done
         *     manually by the user.
         * @return {?} The created focus trap instance.
         */
        FocusTrapFactory.prototype.create = function (element, deferCaptureElements) {
            if (deferCaptureElements === void 0) { deferCaptureElements = false; }
            return new FocusTrap(element, this._checker, this._ngZone, this._document, deferCaptureElements);
        };
        return FocusTrapFactory;
    }());
    FocusTrapFactory.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] },
    ];
    /** @nocollapse */
    FocusTrapFactory.ctorParameters = function () { return [
        { type: InteractivityChecker },
        { type: NgZone },
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
    ]; };
    /** @nocollapse */ FocusTrapFactory.ngInjectableDef = ɵɵdefineInjectable({ factory: function FocusTrapFactory_Factory() { return new FocusTrapFactory(ɵɵinject(InteractivityChecker), ɵɵinject(NgZone), ɵɵinject(DOCUMENT)); }, token: FocusTrapFactory, providedIn: "root" });
    /**
     * Directive for trapping focus within a region.
     */
    var CdkTrapFocus = /** @class */ (function () {
        /**
         * @param {?} _elementRef
         * @param {?} _focusTrapFactory
         * @param {?} _document
         */
        function CdkTrapFocus(_elementRef, _focusTrapFactory, _document) {
            this._elementRef = _elementRef;
            this._focusTrapFactory = _focusTrapFactory;
            /**
             * Previously focused element to restore focus to upon destroy when using autoCapture.
             */
            this._previouslyFocusedElement = null;
            this._document = _document;
            this.focusTrap = this._focusTrapFactory.create(this._elementRef.nativeElement, true);
        }
        Object.defineProperty(CdkTrapFocus.prototype, "enabled", {
            /**
             * Whether the focus trap is active.
             * @return {?}
             */
            get: function () { return this.focusTrap.enabled; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this.focusTrap.enabled = coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CdkTrapFocus.prototype, "autoCapture", {
            /**
             * Whether the directive should automatially move focus into the trapped region upon
             * initialization and return focus to the previous activeElement upon destruction.
             * @return {?}
             */
            get: function () { return this._autoCapture; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this._autoCapture = coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        CdkTrapFocus.prototype.ngOnDestroy = function () {
            this.focusTrap.destroy();
            // If we stored a previously focused element when using autoCapture, return focus to that
            // element now that the trapped region is being destroyed.
            if (this._previouslyFocusedElement) {
                this._previouslyFocusedElement.focus();
                this._previouslyFocusedElement = null;
            }
        };
        /**
         * @return {?}
         */
        CdkTrapFocus.prototype.ngAfterContentInit = function () {
            this.focusTrap.attachAnchors();
            if (this.autoCapture) {
                this._previouslyFocusedElement = ( /** @type {?} */(this._document.activeElement));
                this.focusTrap.focusInitialElementWhenReady();
            }
        };
        /**
         * @return {?}
         */
        CdkTrapFocus.prototype.ngDoCheck = function () {
            if (!this.focusTrap.hasAttached()) {
                this.focusTrap.attachAnchors();
            }
        };
        return CdkTrapFocus;
    }());
    CdkTrapFocus.decorators = [
        { type: Directive, args: [{
                    selector: '[cdkTrapFocus]',
                    exportAs: 'cdkTrapFocus',
                },] },
    ];
    /** @nocollapse */
    CdkTrapFocus.ctorParameters = function () { return [
        { type: ElementRef },
        { type: FocusTrapFactory },
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
    ]; };
    CdkTrapFocus.propDecorators = {
        enabled: [{ type: Input, args: ['cdkTrapFocus',] }],
        autoCapture: [{ type: Input, args: ['cdkTrapFocusAutoCapture',] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var LIVE_ANNOUNCER_ELEMENT_TOKEN = new InjectionToken('liveAnnouncerElement', {
        providedIn: 'root',
        factory: LIVE_ANNOUNCER_ELEMENT_TOKEN_FACTORY,
    });
    /**
     * \@docs-private
     * @return {?}
     */
    function LIVE_ANNOUNCER_ELEMENT_TOKEN_FACTORY() {
        return null;
    }
    /**
     * Injection token that can be used to configure the default options for the LiveAnnouncer.
     * @type {?}
     */
    var LIVE_ANNOUNCER_DEFAULT_OPTIONS = new InjectionToken('LIVE_ANNOUNCER_DEFAULT_OPTIONS');
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var LiveAnnouncer = /** @class */ (function () {
        /**
         * @param {?} elementToken
         * @param {?} _ngZone
         * @param {?} _document
         * @param {?=} _defaultOptions
         */
        function LiveAnnouncer(elementToken, _ngZone, _document, _defaultOptions) {
            this._ngZone = _ngZone;
            this._defaultOptions = _defaultOptions;
            // We inject the live element and document as `any` because the constructor signature cannot
            // reference browser globals (HTMLElement, Document) on non-browser environments, since having
            // a class decorator causes TypeScript to preserve the constructor signature types.
            this._document = _document;
            this._liveElement = elementToken || this._createLiveElement();
        }
        /**
         * @param {?} message
         * @param {...?} args
         * @return {?}
         */
        LiveAnnouncer.prototype.announce = function (message) {
            var _this = this;
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            var _b;
            /** @type {?} */
            var defaultOptions = this._defaultOptions;
            /** @type {?} */
            var politeness;
            /** @type {?} */
            var duration;
            if (args.length === 1 && typeof args[0] === 'number') {
                duration = args[0];
            }
            else {
                _b = __read(args, 2), politeness = _b[0], duration = _b[1];
            }
            this.clear();
            clearTimeout(this._previousTimeout);
            if (!politeness) {
                politeness =
                    (defaultOptions && defaultOptions.politeness) ? defaultOptions.politeness : 'polite';
            }
            if (duration == null && defaultOptions) {
                duration = defaultOptions.duration;
            }
            // TODO: ensure changing the politeness works on all environments we support.
            this._liveElement.setAttribute('aria-live', politeness);
            // This 100ms timeout is necessary for some browser + screen-reader combinations:
            // - Both JAWS and NVDA over IE11 will not announce anything without a non-zero timeout.
            // - With Chrome and IE11 with NVDA or JAWS, a repeated (identical) message won't be read a
            //   second time without clearing and then using a non-zero delay.
            // (using JAWS 17 at time of this writing).
            return this._ngZone.runOutsideAngular(( /**
             * @return {?}
             */function () {
                return new Promise(( /**
                 * @param {?} resolve
                 * @return {?}
                 */function (/**
                 * @param {?} resolve
                 * @return {?}
                 */ resolve) {
                    clearTimeout(_this._previousTimeout);
                    _this._previousTimeout = setTimeout(( /**
                     * @return {?}
                     */function () {
                        _this._liveElement.textContent = message;
                        resolve();
                        if (typeof duration === 'number') {
                            _this._previousTimeout = setTimeout(( /**
                             * @return {?}
                             */function () { return _this.clear(); }), duration);
                        }
                    }), 100);
                }));
            }));
        };
        /**
         * Clears the current text from the announcer element. Can be used to prevent
         * screen readers from reading the text out again while the user is going
         * through the page landmarks.
         * @return {?}
         */
        LiveAnnouncer.prototype.clear = function () {
            if (this._liveElement) {
                this._liveElement.textContent = '';
            }
        };
        /**
         * @return {?}
         */
        LiveAnnouncer.prototype.ngOnDestroy = function () {
            clearTimeout(this._previousTimeout);
            if (this._liveElement && this._liveElement.parentNode) {
                this._liveElement.parentNode.removeChild(this._liveElement);
                this._liveElement = ( /** @type {?} */(null));
            }
        };
        /**
         * @private
         * @return {?}
         */
        LiveAnnouncer.prototype._createLiveElement = function () {
            /** @type {?} */
            var elementClass = 'cdk-live-announcer-element';
            /** @type {?} */
            var previousElements = this._document.getElementsByClassName(elementClass);
            /** @type {?} */
            var liveEl = this._document.createElement('div');
            // Remove any old containers. This can happen when coming in from a server-side-rendered page.
            for (var i_151 = 0; i_151 < previousElements.length; i_151++) {
                ( /** @type {?} */(previousElements[i_151].parentNode)).removeChild(previousElements[i_151]);
            }
            liveEl.classList.add(elementClass);
            liveEl.classList.add('cdk-visually-hidden');
            liveEl.setAttribute('aria-atomic', 'true');
            liveEl.setAttribute('aria-live', 'polite');
            this._document.body.appendChild(liveEl);
            return liveEl;
        };
        return LiveAnnouncer;
    }());
    LiveAnnouncer.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] },
    ];
    /** @nocollapse */
    LiveAnnouncer.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [LIVE_ANNOUNCER_ELEMENT_TOKEN,] }] },
        { type: NgZone },
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] },
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [LIVE_ANNOUNCER_DEFAULT_OPTIONS,] }] }
    ]; };
    /** @nocollapse */ LiveAnnouncer.ngInjectableDef = ɵɵdefineInjectable({ factory: function LiveAnnouncer_Factory() { return new LiveAnnouncer(ɵɵinject(LIVE_ANNOUNCER_ELEMENT_TOKEN, 8), ɵɵinject(NgZone), ɵɵinject(DOCUMENT), ɵɵinject(LIVE_ANNOUNCER_DEFAULT_OPTIONS, 8)); }, token: LiveAnnouncer, providedIn: "root" });
    /**
     * A directive that works similarly to aria-live, but uses the LiveAnnouncer to ensure compatibility
     * with a wider range of browsers and screen readers.
     */
    var CdkAriaLive = /** @class */ (function () {
        /**
         * @param {?} _elementRef
         * @param {?} _liveAnnouncer
         * @param {?} _contentObserver
         * @param {?} _ngZone
         */
        function CdkAriaLive(_elementRef, _liveAnnouncer, _contentObserver, _ngZone) {
            this._elementRef = _elementRef;
            this._liveAnnouncer = _liveAnnouncer;
            this._contentObserver = _contentObserver;
            this._ngZone = _ngZone;
            this._politeness = 'off';
        }
        Object.defineProperty(CdkAriaLive.prototype, "politeness", {
            /**
             * The aria-live politeness level to use when announcing messages.
             * @return {?}
             */
            get: function () { return this._politeness; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                var _this = this;
                this._politeness = value === 'polite' || value === 'assertive' ? value : 'off';
                if (this._politeness === 'off') {
                    if (this._subscription) {
                        this._subscription.unsubscribe();
                        this._subscription = null;
                    }
                }
                else if (!this._subscription) {
                    this._subscription = this._ngZone.runOutsideAngular(( /**
                     * @return {?}
                     */function () {
                        return _this._contentObserver
                            .observe(_this._elementRef)
                            .subscribe(( /**
                     * @return {?}
                     */function () {
                            // Note that we use textContent here, rather than innerText, in order to avoid a reflow.
                            /** @type {?} */
                            var elementText = _this._elementRef.nativeElement.textContent;
                            // The `MutationObserver` fires also for attribute
                            // changes which we don't want to announce.
                            if (elementText !== _this._previousAnnouncedText) {
                                _this._liveAnnouncer.announce(elementText, _this._politeness);
                                _this._previousAnnouncedText = elementText;
                            }
                        }));
                    }));
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        CdkAriaLive.prototype.ngOnDestroy = function () {
            if (this._subscription) {
                this._subscription.unsubscribe();
            }
        };
        return CdkAriaLive;
    }());
    CdkAriaLive.decorators = [
        { type: Directive, args: [{
                    selector: '[cdkAriaLive]',
                    exportAs: 'cdkAriaLive',
                },] },
    ];
    /** @nocollapse */
    CdkAriaLive.ctorParameters = function () { return [
        { type: ElementRef },
        { type: LiveAnnouncer },
        { type: ContentObserver },
        { type: NgZone }
    ]; };
    CdkAriaLive.propDecorators = {
        politeness: [{ type: Input, args: ['cdkAriaLive',] }]
    };
    /**
     * \@docs-private \@deprecated \@breaking-change 8.0.0
     * @param {?} parentAnnouncer
     * @param {?} liveElement
     * @param {?} _document
     * @param {?} ngZone
     * @return {?}
     */
    function LIVE_ANNOUNCER_PROVIDER_FACTORY(parentAnnouncer, liveElement, _document, ngZone) {
        return parentAnnouncer || new LiveAnnouncer(liveElement, ngZone, _document);
    }
    /**
     * \@docs-private \@deprecated \@breaking-change 8.0.0
     * @type {?}
     */
    var LIVE_ANNOUNCER_PROVIDER = {
        // If there is already a LiveAnnouncer available, use that. Otherwise, provide a new one.
        provide: LiveAnnouncer,
        deps: [
            [new Optional(), new SkipSelf(), LiveAnnouncer],
            [new Optional(), new Inject(LIVE_ANNOUNCER_ELEMENT_TOKEN)],
            DOCUMENT,
            NgZone,
        ],
        useFactory: LIVE_ANNOUNCER_PROVIDER_FACTORY
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // This is the value used by AngularJS Material. Through trial and error (on iPhone 6S) they found
    // that a value of around 650ms seems appropriate.
    /** @type {?} */
    var TOUCH_BUFFER_MS = 650;
    /**
     * Event listener options that enable capturing and also
     * mark the listener as passive if the browser supports it.
     * @type {?}
     */
    var captureEventListenerOptions = normalizePassiveListenerOptions({
        passive: true,
        capture: true
    });
    /**
     * Monitors mouse and keyboard events to determine the cause of focus events.
     */
    var FocusMonitor = /** @class */ (function () {
        /**
         * @param {?} _ngZone
         * @param {?} _platform
         */
        function FocusMonitor(_ngZone, _platform) {
            var _this = this;
            this._ngZone = _ngZone;
            this._platform = _platform;
            /**
             * The focus origin that the next focus event is a result of.
             */
            this._origin = null;
            /**
             * Whether the window has just been focused.
             */
            this._windowFocused = false;
            /**
             * Map of elements being monitored to their info.
             */
            this._elementInfo = new Map();
            /**
             * The number of elements currently being monitored.
             */
            this._monitoredElementCount = 0;
            /**
             * Event listener for `keydown` events on the document.
             * Needs to be an arrow function in order to preserve the context when it gets bound.
             */
            this._documentKeydownListener = ( /**
             * @return {?}
             */function () {
                // On keydown record the origin and clear any touch event that may be in progress.
                _this._lastTouchTarget = null;
                _this._setOriginForCurrentEventQueue('keyboard');
            });
            /**
             * Event listener for `mousedown` events on the document.
             * Needs to be an arrow function in order to preserve the context when it gets bound.
             */
            this._documentMousedownListener = ( /**
             * @return {?}
             */function () {
                // On mousedown record the origin only if there is not touch
                // target, since a mousedown can happen as a result of a touch event.
                if (!_this._lastTouchTarget) {
                    _this._setOriginForCurrentEventQueue('mouse');
                }
            });
            /**
             * Event listener for `touchstart` events on the document.
             * Needs to be an arrow function in order to preserve the context when it gets bound.
             */
            this._documentTouchstartListener = ( /**
             * @param {?} event
             * @return {?}
             */function (event) {
                // When the touchstart event fires the focus event is not yet in the event queue. This means
                // we can't rely on the trick used above (setting timeout of 1ms). Instead we wait 650ms to
                // see if a focus happens.
                if (_this._touchTimeoutId != null) {
                    clearTimeout(_this._touchTimeoutId);
                }
                // Since this listener is bound on the `document` level, any events coming from the shadow DOM
                // will have their `target` set to the shadow root. If available, use `composedPath` to
                // figure out the event target.
                _this._lastTouchTarget = event.composedPath ? event.composedPath()[0] : event.target;
                _this._touchTimeoutId = setTimeout(( /**
                 * @return {?}
                 */function () { return _this._lastTouchTarget = null; }), TOUCH_BUFFER_MS);
            });
            /**
             * Event listener for `focus` events on the window.
             * Needs to be an arrow function in order to preserve the context when it gets bound.
             */
            this._windowFocusListener = ( /**
             * @return {?}
             */function () {
                // Make a note of when the window regains focus, so we can
                // restore the origin info for the focused element.
                _this._windowFocused = true;
                _this._windowFocusTimeoutId = setTimeout(( /**
                 * @return {?}
                 */function () { return _this._windowFocused = false; }));
            });
        }
        /**
         * @param {?} element
         * @param {?=} checkChildren
         * @return {?}
         */
        FocusMonitor.prototype.monitor = function (element, checkChildren) {
            var _this = this;
            if (checkChildren === void 0) { checkChildren = false; }
            // Do nothing if we're not on the browser platform.
            if (!this._platform.isBrowser) {
                return of(null);
            }
            /** @type {?} */
            var nativeElement = coerceElement(element);
            // Check if we're already monitoring this element.
            if (this._elementInfo.has(nativeElement)) {
                /** @type {?} */
                var cachedInfo = this._elementInfo.get(nativeElement);
                ( /** @type {?} */(cachedInfo)).checkChildren = checkChildren;
                return ( /** @type {?} */(cachedInfo)).subject.asObservable();
            }
            // Create monitored element info.
            /** @type {?} */
            var info = {
                unlisten: ( /**
                 * @return {?}
                 */function () { }),
                checkChildren: checkChildren,
                subject: new Subject()
            };
            this._elementInfo.set(nativeElement, info);
            this._incrementMonitoredElementCount();
            // Start listening. We need to listen in capture phase since focus events don't bubble.
            /** @type {?} */
            var focusListener = ( /**
             * @param {?} event
             * @return {?}
             */function (event) { return _this._onFocus(event, nativeElement); });
            /** @type {?} */
            var blurListener = ( /**
             * @param {?} event
             * @return {?}
             */function (event) { return _this._onBlur(event, nativeElement); });
            this._ngZone.runOutsideAngular(( /**
             * @return {?}
             */function () {
                nativeElement.addEventListener('focus', focusListener, true);
                nativeElement.addEventListener('blur', blurListener, true);
            }));
            // Create an unlisten function for later.
            info.unlisten = ( /**
             * @return {?}
             */function () {
                nativeElement.removeEventListener('focus', focusListener, true);
                nativeElement.removeEventListener('blur', blurListener, true);
            });
            return info.subject.asObservable();
        };
        /**
         * @param {?} element
         * @return {?}
         */
        FocusMonitor.prototype.stopMonitoring = function (element) {
            /** @type {?} */
            var nativeElement = coerceElement(element);
            /** @type {?} */
            var elementInfo = this._elementInfo.get(nativeElement);
            if (elementInfo) {
                elementInfo.unlisten();
                elementInfo.subject.complete();
                this._setClasses(nativeElement);
                this._elementInfo.delete(nativeElement);
                this._decrementMonitoredElementCount();
            }
        };
        /**
         * @param {?} element
         * @param {?} origin
         * @param {?=} options
         * @return {?}
         */
        FocusMonitor.prototype.focusVia = function (element, origin, options) {
            /** @type {?} */
            var nativeElement = coerceElement(element);
            this._setOriginForCurrentEventQueue(origin);
            // `focus` isn't available on the server
            if (typeof nativeElement.focus === 'function') {
                // Cast the element to `any`, because the TS typings don't have the `options` parameter yet.
                (( /** @type {?} */(nativeElement))).focus(options);
            }
        };
        /**
         * @return {?}
         */
        FocusMonitor.prototype.ngOnDestroy = function () {
            var _this = this;
            this._elementInfo.forEach(( /**
             * @param {?} _info
             * @param {?} element
             * @return {?}
             */function (_info, element) { return _this.stopMonitoring(element); }));
        };
        /**
         * @private
         * @param {?} element
         * @param {?} className
         * @param {?} shouldSet
         * @return {?}
         */
        FocusMonitor.prototype._toggleClass = function (element, className, shouldSet) {
            if (shouldSet) {
                element.classList.add(className);
            }
            else {
                element.classList.remove(className);
            }
        };
        /**
         * Sets the focus classes on the element based on the given focus origin.
         * @private
         * @param {?} element The element to update the classes on.
         * @param {?=} origin The focus origin.
         * @return {?}
         */
        FocusMonitor.prototype._setClasses = function (element, origin) {
            /** @type {?} */
            var elementInfo = this._elementInfo.get(element);
            if (elementInfo) {
                this._toggleClass(element, 'cdk-focused', !!origin);
                this._toggleClass(element, 'cdk-touch-focused', origin === 'touch');
                this._toggleClass(element, 'cdk-keyboard-focused', origin === 'keyboard');
                this._toggleClass(element, 'cdk-mouse-focused', origin === 'mouse');
                this._toggleClass(element, 'cdk-program-focused', origin === 'program');
            }
        };
        /**
         * Sets the origin and schedules an async function to clear it at the end of the event queue.
         * @private
         * @param {?} origin The origin to set.
         * @return {?}
         */
        FocusMonitor.prototype._setOriginForCurrentEventQueue = function (origin) {
            var _this = this;
            this._ngZone.runOutsideAngular(( /**
             * @return {?}
             */function () {
                _this._origin = origin;
                // Sometimes the focus origin won't be valid in Firefox because Firefox seems to focus *one*
                // tick after the interaction event fired. To ensure the focus origin is always correct,
                // the focus origin will be determined at the beginning of the next tick.
                _this._originTimeoutId = setTimeout(( /**
                 * @return {?}
                 */function () { return _this._origin = null; }), 1);
            }));
        };
        /**
         * Checks whether the given focus event was caused by a touchstart event.
         * @private
         * @param {?} event The focus event to check.
         * @return {?} Whether the event was caused by a touch.
         */
        FocusMonitor.prototype._wasCausedByTouch = function (event) {
            // Note(mmalerba): This implementation is not quite perfect, there is a small edge case.
            // Consider the following dom structure:
            //
            // <div #parent tabindex="0" cdkFocusClasses>
            //   <div #child (click)="#parent.focus()"></div>
            // </div>
            //
            // If the user touches the #child element and the #parent is programmatically focused as a
            // result, this code will still consider it to have been caused by the touch event and will
            // apply the cdk-touch-focused class rather than the cdk-program-focused class. This is a
            // relatively small edge-case that can be worked around by using
            // focusVia(parentEl, 'program') to focus the parent element.
            //
            // If we decide that we absolutely must handle this case correctly, we can do so by listening
            // for the first focus event after the touchstart, and then the first blur event after that
            // focus event. When that blur event fires we know that whatever follows is not a result of the
            // touchstart.
            /** @type {?} */
            var focusTarget = event.target;
            return this._lastTouchTarget instanceof Node && focusTarget instanceof Node &&
                (focusTarget === this._lastTouchTarget || focusTarget.contains(this._lastTouchTarget));
        };
        /**
         * Handles focus events on a registered element.
         * @private
         * @param {?} event The focus event.
         * @param {?} element The monitored element.
         * @return {?}
         */
        FocusMonitor.prototype._onFocus = function (event, element) {
            // NOTE(mmalerba): We currently set the classes based on the focus origin of the most recent
            // focus event affecting the monitored element. If we want to use the origin of the first event
            // instead we should check for the cdk-focused class here and return if the element already has
            // it. (This only matters for elements that have includesChildren = true).
            // NOTE(mmalerba): We currently set the classes based on the focus origin of the most recent
            // focus event affecting the monitored element. If we want to use the origin of the first event
            // instead we should check for the cdk-focused class here and return if the element already has
            // it. (This only matters for elements that have includesChildren = true).
            // If we are not counting child-element-focus as focused, make sure that the event target is the
            // monitored element itself.
            /** @type {?} */
            var elementInfo = this._elementInfo.get(element);
            if (!elementInfo || (!elementInfo.checkChildren && element !== event.target)) {
                return;
            }
            // If we couldn't detect a cause for the focus event, it's due to one of three reasons:
            // 1) The window has just regained focus, in which case we want to restore the focused state of
            //    the element from before the window blurred.
            // 2) It was caused by a touch event, in which case we mark the origin as 'touch'.
            // 3) The element was programmatically focused, in which case we should mark the origin as
            //    'program'.
            /** @type {?} */
            var origin = this._origin;
            if (!origin) {
                if (this._windowFocused && this._lastFocusOrigin) {
                    origin = this._lastFocusOrigin;
                }
                else if (this._wasCausedByTouch(event)) {
                    origin = 'touch';
                }
                else {
                    origin = 'program';
                }
            }
            this._setClasses(element, origin);
            this._emitOrigin(elementInfo.subject, origin);
            this._lastFocusOrigin = origin;
        };
        /**
         * Handles blur events on a registered element.
         * @param {?} event The blur event.
         * @param {?} element The monitored element.
         * @return {?}
         */
        FocusMonitor.prototype._onBlur = function (event, element) {
            // If we are counting child-element-focus as focused, make sure that we aren't just blurring in
            // order to focus another child of the monitored element.
            /** @type {?} */
            var elementInfo = this._elementInfo.get(element);
            if (!elementInfo || (elementInfo.checkChildren && event.relatedTarget instanceof Node &&
                element.contains(event.relatedTarget))) {
                return;
            }
            this._setClasses(element);
            this._emitOrigin(elementInfo.subject, null);
        };
        /**
         * @private
         * @param {?} subject
         * @param {?} origin
         * @return {?}
         */
        FocusMonitor.prototype._emitOrigin = function (subject, origin) {
            this._ngZone.run(( /**
             * @return {?}
             */function () { return subject.next(origin); }));
        };
        /**
         * @private
         * @return {?}
         */
        FocusMonitor.prototype._incrementMonitoredElementCount = function () {
            var _this = this;
            // Register global listeners when first element is monitored.
            if (++this._monitoredElementCount == 1 && this._platform.isBrowser) {
                // Note: we listen to events in the capture phase so we
                // can detect them even if the user stops propagation.
                this._ngZone.runOutsideAngular(( /**
                 * @return {?}
                 */function () {
                    document.addEventListener('keydown', _this._documentKeydownListener, captureEventListenerOptions);
                    document.addEventListener('mousedown', _this._documentMousedownListener, captureEventListenerOptions);
                    document.addEventListener('touchstart', _this._documentTouchstartListener, captureEventListenerOptions);
                    window.addEventListener('focus', _this._windowFocusListener);
                }));
            }
        };
        /**
         * @private
         * @return {?}
         */
        FocusMonitor.prototype._decrementMonitoredElementCount = function () {
            // Unregister global listeners when last element is unmonitored.
            if (!--this._monitoredElementCount) {
                document.removeEventListener('keydown', this._documentKeydownListener, captureEventListenerOptions);
                document.removeEventListener('mousedown', this._documentMousedownListener, captureEventListenerOptions);
                document.removeEventListener('touchstart', this._documentTouchstartListener, captureEventListenerOptions);
                window.removeEventListener('focus', this._windowFocusListener);
                // Clear timeouts for all potentially pending timeouts to prevent the leaks.
                clearTimeout(this._windowFocusTimeoutId);
                clearTimeout(this._touchTimeoutId);
                clearTimeout(this._originTimeoutId);
            }
        };
        return FocusMonitor;
    }());
    FocusMonitor.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] },
    ];
    /** @nocollapse */
    FocusMonitor.ctorParameters = function () { return [
        { type: NgZone },
        { type: Platform }
    ]; };
    /** @nocollapse */ FocusMonitor.ngInjectableDef = ɵɵdefineInjectable({ factory: function FocusMonitor_Factory() { return new FocusMonitor(ɵɵinject(NgZone), ɵɵinject(Platform)); }, token: FocusMonitor, providedIn: "root" });
    /**
     * Directive that determines how a particular element was focused (via keyboard, mouse, touch, or
     * programmatically) and adds corresponding classes to the element.
     *
     * There are two variants of this directive:
     * 1) cdkMonitorElementFocus: does not consider an element to be focused if one of its children is
     *    focused.
     * 2) cdkMonitorSubtreeFocus: considers an element focused if it or any of its children are focused.
     */
    var CdkMonitorFocus = /** @class */ (function () {
        /**
         * @param {?} _elementRef
         * @param {?} _focusMonitor
         */
        function CdkMonitorFocus(_elementRef, _focusMonitor) {
            var _this = this;
            this._elementRef = _elementRef;
            this._focusMonitor = _focusMonitor;
            this.cdkFocusChange = new EventEmitter();
            this._monitorSubscription = this._focusMonitor.monitor(this._elementRef, this._elementRef.nativeElement.hasAttribute('cdkMonitorSubtreeFocus'))
                .subscribe(( /**
         * @param {?} origin
         * @return {?}
         */function (/**
         * @param {?} origin
         * @return {?}
         */ origin) { return _this.cdkFocusChange.emit(origin); }));
        }
        /**
         * @return {?}
         */
        CdkMonitorFocus.prototype.ngOnDestroy = function () {
            this._focusMonitor.stopMonitoring(this._elementRef);
            this._monitorSubscription.unsubscribe();
        };
        return CdkMonitorFocus;
    }());
    CdkMonitorFocus.decorators = [
        { type: Directive, args: [{
                    selector: '[cdkMonitorElementFocus], [cdkMonitorSubtreeFocus]',
                },] },
    ];
    /** @nocollapse */
    CdkMonitorFocus.ctorParameters = function () { return [
        { type: ElementRef },
        { type: FocusMonitor }
    ]; };
    CdkMonitorFocus.propDecorators = {
        cdkFocusChange: [{ type: Output }]
    };
    /**
     * \@docs-private \@deprecated \@breaking-change 8.0.0
     * @param {?} parentDispatcher
     * @param {?} ngZone
     * @param {?} platform
     * @return {?}
     */
    function FOCUS_MONITOR_PROVIDER_FACTORY(parentDispatcher, ngZone, platform) {
        return parentDispatcher || new FocusMonitor(ngZone, platform);
    }
    /**
     * \@docs-private \@deprecated \@breaking-change 8.0.0
     * @type {?}
     */
    var FOCUS_MONITOR_PROVIDER = {
        // If there is already a FocusMonitor available, use that. Otherwise, provide a new one.
        provide: FocusMonitor,
        deps: [[new Optional(), new SkipSelf(), FocusMonitor], NgZone, Platform],
        useFactory: FOCUS_MONITOR_PROVIDER_FACTORY
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Screenreaders will often fire fake mousedown events when a focusable element
     * is activated using the keyboard. We can typically distinguish between these faked
     * mousedown events and real mousedown events using the "buttons" property. While
     * real mousedowns will indicate the mouse button that was pressed (e.g. "1" for
     * the left mouse button), faked mousedowns will usually set the property value to 0.
     * @param {?} event
     * @return {?}
     */
    function isFakeMousedownFromScreenReader(event) {
        return event.buttons === 0;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var A11yModule = /** @class */ (function () {
        function A11yModule() {
        }
        return A11yModule;
    }());
    A11yModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule, PlatformModule, ObserversModule],
                    declarations: [CdkAriaLive, CdkTrapFocus, CdkMonitorFocus],
                    exports: [CdkAriaLive, CdkTrapFocus, CdkMonitorFocus],
                },] },
    ];
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Current version of Angular Material.
     * @type {?}
     */
    var VERSION$1$1 = new Version('8.2.3');
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // Private version constant to circumvent test/build issues,
    // i.e. avoid core to depend on the @angular/material primary entry-point
    // Can be removed once the Material primary entry-point no longer
    // re-exports all secondary entry-points
    /** @type {?} */
    var VERSION$2$1 = new Version('8.2.3');
    /**
     * \@docs-private
     * @return {?}
     */
    function MATERIAL_SANITY_CHECKS_FACTORY() {
        return true;
    }
    /**
     * Injection token that configures whether the Material sanity checks are enabled.
     * @type {?}
     */
    var MATERIAL_SANITY_CHECKS = new InjectionToken('mat-sanity-checks', {
        providedIn: 'root',
        factory: MATERIAL_SANITY_CHECKS_FACTORY,
    });
    /**
     * Module that captures anything that should be loaded and/or run for *all* Angular Material
     * components. This includes Bidi, etc.
     *
     * This module should be imported to each top-level component module (e.g., MatTabsModule).
     */
    var MatCommonModule = /** @class */ (function () {
        /**
         * @param {?} _sanityChecksEnabled
         * @param {?=} _hammerLoader
         */
        function MatCommonModule(_sanityChecksEnabled, _hammerLoader) {
            this._sanityChecksEnabled = _sanityChecksEnabled;
            this._hammerLoader = _hammerLoader;
            /**
             * Whether we've done the global sanity checks (e.g. a theme is loaded, there is a doctype).
             */
            this._hasDoneGlobalChecks = false;
            /**
             * Whether we've already checked for HammerJs availability.
             */
            this._hasCheckedHammer = false;
            /**
             * Reference to the global `document` object.
             */
            this._document = typeof document === 'object' && document ? document : null;
            /**
             * Reference to the global 'window' object.
             */
            this._window = typeof window === 'object' && window ? window : null;
            if (this._areChecksEnabled() && !this._hasDoneGlobalChecks) {
                this._checkDoctypeIsDefined();
                this._checkThemeIsPresent();
                this._checkCdkVersionMatch();
                this._hasDoneGlobalChecks = true;
            }
        }
        /**
         * Whether any sanity checks are enabled
         * @private
         * @return {?}
         */
        MatCommonModule.prototype._areChecksEnabled = function () {
            return this._sanityChecksEnabled && isDevMode() && !this._isTestEnv();
        };
        /**
         * Whether the code is running in tests.
         * @private
         * @return {?}
         */
        MatCommonModule.prototype._isTestEnv = function () {
            /** @type {?} */
            var window = ( /** @type {?} */(this._window));
            return window && (window.__karma__ || window.jasmine);
        };
        /**
         * @private
         * @return {?}
         */
        MatCommonModule.prototype._checkDoctypeIsDefined = function () {
            if (this._document && !this._document.doctype) {
                console.warn('Current document does not have a doctype. This may cause ' +
                    'some Angular Material components not to behave as expected.');
            }
        };
        /**
         * @private
         * @return {?}
         */
        MatCommonModule.prototype._checkThemeIsPresent = function () {
            // We need to assert that the `body` is defined, because these checks run very early
            // and the `body` won't be defined if the consumer put their scripts in the `head`.
            if (!this._document || !this._document.body || typeof getComputedStyle !== 'function') {
                return;
            }
            /** @type {?} */
            var testElement = this._document.createElement('div');
            testElement.classList.add('mat-theme-loaded-marker');
            this._document.body.appendChild(testElement);
            /** @type {?} */
            var computedStyle = getComputedStyle(testElement);
            // In some situations the computed style of the test element can be null. For example in
            // Firefox, the computed style is null if an application is running inside of a hidden iframe.
            // See: https://bugzilla.mozilla.org/show_bug.cgi?id=548397
            if (computedStyle && computedStyle.display !== 'none') {
                console.warn('Could not find Angular Material core theme. Most Material ' +
                    'components may not work as expected. For more info refer ' +
                    'to the theming guide: https://material.angular.io/guide/theming');
            }
            this._document.body.removeChild(testElement);
        };
        /**
         * Checks whether the material version matches the cdk version
         * @private
         * @return {?}
         */
        MatCommonModule.prototype._checkCdkVersionMatch = function () {
            if (VERSION$2$1.full !== VERSION$3.full) {
                console.warn('The Angular Material version (' + VERSION$2$1.full + ') does not match ' +
                    'the Angular CDK version (' + VERSION$3.full + ').\n' +
                    'Please ensure the versions of these two packages exactly match.');
            }
        };
        /**
         * Checks whether HammerJS is available.
         * @return {?}
         */
        MatCommonModule.prototype._checkHammerIsAvailable = function () {
            if (this._hasCheckedHammer || !this._window) {
                return;
            }
            if (this._areChecksEnabled() && !(( /** @type {?} */(this._window)))['Hammer'] && !this._hammerLoader) {
                console.warn('Could not find HammerJS. Certain Angular Material components may not work correctly.');
            }
            this._hasCheckedHammer = true;
        };
        return MatCommonModule;
    }());
    MatCommonModule.decorators = [
        { type: NgModule, args: [{
                    imports: [BidiModule],
                    exports: [BidiModule],
                },] },
    ];
    /** @nocollapse */
    MatCommonModule.ctorParameters = function () { return [
        { type: Boolean, decorators: [{ type: Optional }, { type: Inject, args: [MATERIAL_SANITY_CHECKS,] }] },
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [HAMMER_LOADER,] }] }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Mixin to augment a directive with a `disabled` property.
     * @template T
     * @param {?} base
     * @return {?}
     */
    function mixinDisabled(base) {
        return /** @class */ (function (_super) {
            __extends(class_1, _super);
            /**
             * @param {...?} args
             */
            function class_1() {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                var _this = _super.apply(this, __spread(args)) || this;
                _this._disabled = false;
                return _this;
            }
            Object.defineProperty(class_1.prototype, "disabled", {
                /**
                 * @return {?}
                 */
                get: function () { return this._disabled; },
                /**
                 * @param {?} value
                 * @return {?}
                 */
                set: function (value) { this._disabled = coerceBooleanProperty(value); },
                enumerable: true,
                configurable: true
            });
            return class_1;
        }(base));
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Mixin to augment a directive with a `color` property.
     * @template T
     * @param {?} base
     * @param {?=} defaultColor
     * @return {?}
     */
    function mixinColor(base, defaultColor) {
        return /** @class */ (function (_super) {
            __extends(class_2, _super);
            /**
             * @param {...?} args
             */
            function class_2() {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                var _this = _super.apply(this, __spread(args)) || this;
                // Set the default color that can be specified from the mixin.
                _this.color = defaultColor;
                return _this;
            }
            Object.defineProperty(class_2.prototype, "color", {
                /**
                 * @return {?}
                 */
                get: function () { return this._color; },
                /**
                 * @param {?} value
                 * @return {?}
                 */
                set: function (value) {
                    /** @type {?} */
                    var colorPalette = value || defaultColor;
                    if (colorPalette !== this._color) {
                        if (this._color) {
                            this._elementRef.nativeElement.classList.remove("mat-" + this._color);
                        }
                        if (colorPalette) {
                            this._elementRef.nativeElement.classList.add("mat-" + colorPalette);
                        }
                        this._color = colorPalette;
                    }
                },
                enumerable: true,
                configurable: true
            });
            return class_2;
        }(base));
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Mixin to augment a directive with a `disableRipple` property.
     * @template T
     * @param {?} base
     * @return {?}
     */
    function mixinDisableRipple(base) {
        return /** @class */ (function (_super) {
            __extends(class_3, _super);
            /**
             * @param {...?} args
             */
            function class_3() {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                var _this = _super.apply(this, __spread(args)) || this;
                _this._disableRipple = false;
                return _this;
            }
            Object.defineProperty(class_3.prototype, "disableRipple", {
                /**
                 * Whether the ripple effect is disabled or not.
                 * @return {?}
                 */
                get: function () { return this._disableRipple; },
                /**
                 * @param {?} value
                 * @return {?}
                 */
                set: function (value) { this._disableRipple = coerceBooleanProperty(value); },
                enumerable: true,
                configurable: true
            });
            return class_3;
        }(base));
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Mixin to augment a directive with a `tabIndex` property.
     * @template T
     * @param {?} base
     * @param {?=} defaultTabIndex
     * @return {?}
     */
    function mixinTabIndex(base, defaultTabIndex) {
        if (defaultTabIndex === void 0) { defaultTabIndex = 0; }
        return /** @class */ (function (_super) {
            __extends(class_4, _super);
            /**
             * @param {...?} args
             */
            function class_4() {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                var _this = _super.apply(this, __spread(args)) || this;
                _this._tabIndex = defaultTabIndex;
                return _this;
            }
            Object.defineProperty(class_4.prototype, "tabIndex", {
                /**
                 * @return {?}
                 */
                get: function () { return this.disabled ? -1 : this._tabIndex; },
                /**
                 * @param {?} value
                 * @return {?}
                 */
                set: function (value) {
                    // If the specified tabIndex value is null or undefined, fall back to the default value.
                    this._tabIndex = value != null ? value : defaultTabIndex;
                },
                enumerable: true,
                configurable: true
            });
            return class_4;
        }(base));
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Mixin to augment a directive with updateErrorState method.
     * For component with `errorState` and need to update `errorState`.
     * @template T
     * @param {?} base
     * @return {?}
     */
    function mixinErrorState(base) {
        return /** @class */ (function (_super) {
            __extends(class_5, _super);
            /**
             * @param {...?} args
             */
            function class_5() {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                var _this = _super.apply(this, __spread(args)) || this;
                /**
                 * Whether the component is in an error state.
                 */
                _this.errorState = false;
                /**
                 * Stream that emits whenever the state of the input changes such that the wrapping
                 * `MatFormField` needs to run change detection.
                 */
                _this.stateChanges = new Subject();
                return _this;
            }
            /**
             * @return {?}
             */
            class_5.prototype.updateErrorState = function () {
                /** @type {?} */
                var oldState = this.errorState;
                /** @type {?} */
                var parent = this._parentFormGroup || this._parentForm;
                /** @type {?} */
                var matcher = this.errorStateMatcher || this._defaultErrorStateMatcher;
                /** @type {?} */
                var control = this.ngControl ? ( /** @type {?} */(this.ngControl.control)) : null;
                /** @type {?} */
                var newState = matcher.isErrorState(control, parent);
                if (newState !== oldState) {
                    this.errorState = newState;
                    this.stateChanges.next();
                }
            };
            return class_5;
        }(base));
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * InjectionToken for datepicker that can be used to override default locale code.
     * @type {?}
     */
    var MAT_DATE_LOCALE = new InjectionToken('MAT_DATE_LOCALE', {
        providedIn: 'root',
        factory: MAT_DATE_LOCALE_FACTORY,
    });
    /**
     * \@docs-private
     * @return {?}
     */
    function MAT_DATE_LOCALE_FACTORY() {
        return inject(LOCALE_ID$1);
    }
    /**
     * Adapts type `D` to be usable as a date by cdk-based components that work with dates.
     * @abstract
     * @template D
     */
    var DateAdapter = /** @class */ (function () {
        function DateAdapter() {
            this._localeChanges = new Subject();
        }
        Object.defineProperty(DateAdapter.prototype, "localeChanges", {
            /**
             * A stream that emits when the locale changes.
             * @return {?}
             */
            get: function () { return this._localeChanges; },
            enumerable: true,
            configurable: true
        });
        /**
         * Attempts to deserialize a value to a valid date object. This is different from parsing in that
         * deserialize should only accept non-ambiguous, locale-independent formats (e.g. a ISO 8601
         * string). The default implementation does not allow any deserialization, it simply checks that
         * the given value is already a valid date object or null. The `<mat-datepicker>` will call this
         * method on all of its `\@Input()` properties that accept dates. It is therefore possible to
         * support passing values from your backend directly to these properties by overriding this method
         * to also deserialize the format used by your backend.
         * @param {?} value The value to be deserialized into a date object.
         * @return {?} The deserialized date object, either a valid date, null if the value can be
         *     deserialized into a null date (e.g. the empty string), or an invalid date.
         */
        DateAdapter.prototype.deserialize = function (value) {
            if (value == null || this.isDateInstance(value) && this.isValid(value)) {
                return value;
            }
            return this.invalid();
        };
        /**
         * Sets the locale used for all dates.
         * @param {?} locale The new locale.
         * @return {?}
         */
        DateAdapter.prototype.setLocale = function (locale) {
            this.locale = locale;
            this._localeChanges.next();
        };
        /**
         * Compares two dates.
         * @param {?} first The first date to compare.
         * @param {?} second The second date to compare.
         * @return {?} 0 if the dates are equal, a number less than 0 if the first date is earlier,
         *     a number greater than 0 if the first date is later.
         */
        DateAdapter.prototype.compareDate = function (first, second) {
            return this.getYear(first) - this.getYear(second) ||
                this.getMonth(first) - this.getMonth(second) ||
                this.getDate(first) - this.getDate(second);
        };
        /**
         * Checks if two dates are equal.
         * @param {?} first The first date to check.
         * @param {?} second The second date to check.
         * @return {?} Whether the two dates are equal.
         *     Null dates are considered equal to other null dates.
         */
        DateAdapter.prototype.sameDate = function (first, second) {
            if (first && second) {
                /** @type {?} */
                var firstValid = this.isValid(first);
                /** @type {?} */
                var secondValid = this.isValid(second);
                if (firstValid && secondValid) {
                    return !this.compareDate(first, second);
                }
                return firstValid == secondValid;
            }
            return first == second;
        };
        /**
         * Clamp the given date between min and max dates.
         * @param {?} date The date to clamp.
         * @param {?=} min The minimum value to allow. If null or omitted no min is enforced.
         * @param {?=} max The maximum value to allow. If null or omitted no max is enforced.
         * @return {?} `min` if `date` is less than `min`, `max` if date is greater than `max`,
         *     otherwise `date`.
         */
        DateAdapter.prototype.clampDate = function (date, min, max) {
            if (min && this.compareDate(date, min) < 0) {
                return min;
            }
            if (max && this.compareDate(date, max) > 0) {
                return max;
            }
            return date;
        };
        return DateAdapter;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var MAT_DATE_FORMATS = new InjectionToken('mat-date-formats');
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // TODO(mmalerba): Remove when we no longer support safari 9.
    /**
     * Whether the browser supports the Intl API.
     * @type {?}
     */
    var SUPPORTS_INTL_API;
    // We need a try/catch around the reference to `Intl`, because accessing it in some cases can
    // cause IE to throw. These cases are tied to particular versions of Windows and can happen if
    // the consumer is providing a polyfilled `Map`. See:
    // https://github.com/Microsoft/ChakraCore/issues/3189
    // https://github.com/angular/components/issues/15687
    try {
        SUPPORTS_INTL_API = typeof Intl != 'undefined';
    }
    catch (_a) {
        SUPPORTS_INTL_API = false;
    }
    /**
     * The default month names to use if Intl API is not available.
     * @type {?}
     */
    var DEFAULT_MONTH_NAMES = {
        'long': [
            'January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September',
            'October', 'November', 'December'
        ],
        'short': ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'],
        'narrow': ['J', 'F', 'M', 'A', 'M', 'J', 'J', 'A', 'S', 'O', 'N', 'D']
    };
    var ɵ0$a = /**
     * @param {?} i
     * @return {?}
     */ function (/**
     * @param {?} i
     * @return {?}
     */ i) { return String(i + 1); };
    /**
     * The default date names to use if Intl API is not available.
     * @type {?}
     */
    var DEFAULT_DATE_NAMES = range(31, (ɵ0$a));
    /**
     * The default day of the week names to use if Intl API is not available.
     * @type {?}
     */
    var DEFAULT_DAY_OF_WEEK_NAMES = {
        'long': ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'],
        'short': ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'],
        'narrow': ['S', 'M', 'T', 'W', 'T', 'F', 'S']
    };
    /**
     * Matches strings that have the form of a valid RFC 3339 string
     * (https://tools.ietf.org/html/rfc3339). Note that the string may not actually be a valid date
     * because the regex will match strings an with out of bounds month, date, etc.
     * @type {?}
     */
    var ISO_8601_REGEX = /^\d{4}-\d{2}-\d{2}(?:T\d{2}:\d{2}:\d{2}(?:\.\d+)?(?:Z|(?:(?:\+|-)\d{2}:\d{2}))?)?$/;
    /**
     * Creates an array and fills it with values.
     * @template T
     * @param {?} length
     * @param {?} valueFunction
     * @return {?}
     */
    function range(length, valueFunction) {
        /** @type {?} */
        var valuesArray = Array(length);
        for (var i_152 = 0; i_152 < length; i_152++) {
            valuesArray[i_152] = valueFunction(i_152);
        }
        return valuesArray;
    }
    /**
     * Adapts the native JS Date for use with cdk-based components that work with dates.
     */
    var NativeDateAdapter = /** @class */ (function (_super) {
        __extends(NativeDateAdapter, _super);
        /**
         * @param {?} matDateLocale
         * @param {?} platform
         */
        function NativeDateAdapter(matDateLocale, platform) {
            var _this = _super.call(this) || this;
            /**
             * Whether to use `timeZone: 'utc'` with `Intl.DateTimeFormat` when formatting dates.
             * Without this `Intl.DateTimeFormat` sometimes chooses the wrong timeZone, which can throw off
             * the result. (e.g. in the en-US locale `new Date(1800, 7, 14).toLocaleDateString()`
             * will produce `'8/13/1800'`.
             *
             * TODO(mmalerba): drop this variable. It's not being used in the code right now. We're now
             * getting the string representation of a Date object from its utc representation. We're keeping
             * it here for sometime, just for precaution, in case we decide to revert some of these changes
             * though.
             */
            _this.useUtcForDisplay = true;
            _super.prototype.setLocale.call(_this, matDateLocale);
            // IE does its own time zone correction, so we disable this on IE.
            _this.useUtcForDisplay = !platform.TRIDENT;
            _this._clampDate = platform.TRIDENT || platform.EDGE;
            return _this;
        }
        /**
         * @param {?} date
         * @return {?}
         */
        NativeDateAdapter.prototype.getYear = function (date) {
            return date.getFullYear();
        };
        /**
         * @param {?} date
         * @return {?}
         */
        NativeDateAdapter.prototype.getMonth = function (date) {
            return date.getMonth();
        };
        /**
         * @param {?} date
         * @return {?}
         */
        NativeDateAdapter.prototype.getDate = function (date) {
            return date.getDate();
        };
        /**
         * @param {?} date
         * @return {?}
         */
        NativeDateAdapter.prototype.getDayOfWeek = function (date) {
            return date.getDay();
        };
        /**
         * @param {?} style
         * @return {?}
         */
        NativeDateAdapter.prototype.getMonthNames = function (style) {
            var _this = this;
            if (SUPPORTS_INTL_API) {
                /** @type {?} */
                var dtf_1 = new Intl.DateTimeFormat(this.locale, { month: style, timeZone: 'utc' });
                return range(12, ( /**
                 * @param {?} i
                 * @return {?}
                 */function (/**
                 * @param {?} i
                 * @return {?}
                 */ i) { return _this._stripDirectionalityCharacters(_this._format(dtf_1, new Date(2017, i, 1))); }));
            }
            return DEFAULT_MONTH_NAMES[style];
        };
        /**
         * @return {?}
         */
        NativeDateAdapter.prototype.getDateNames = function () {
            var _this = this;
            if (SUPPORTS_INTL_API) {
                /** @type {?} */
                var dtf_2 = new Intl.DateTimeFormat(this.locale, { day: 'numeric', timeZone: 'utc' });
                return range(31, ( /**
                 * @param {?} i
                 * @return {?}
                 */function (/**
                 * @param {?} i
                 * @return {?}
                 */ i) { return _this._stripDirectionalityCharacters(_this._format(dtf_2, new Date(2017, 0, i + 1))); }));
            }
            return DEFAULT_DATE_NAMES;
        };
        /**
         * @param {?} style
         * @return {?}
         */
        NativeDateAdapter.prototype.getDayOfWeekNames = function (style) {
            var _this = this;
            if (SUPPORTS_INTL_API) {
                /** @type {?} */
                var dtf_3 = new Intl.DateTimeFormat(this.locale, { weekday: style, timeZone: 'utc' });
                return range(7, ( /**
                 * @param {?} i
                 * @return {?}
                 */function (/**
                 * @param {?} i
                 * @return {?}
                 */ i) { return _this._stripDirectionalityCharacters(_this._format(dtf_3, new Date(2017, 0, i + 1))); }));
            }
            return DEFAULT_DAY_OF_WEEK_NAMES[style];
        };
        /**
         * @param {?} date
         * @return {?}
         */
        NativeDateAdapter.prototype.getYearName = function (date) {
            if (SUPPORTS_INTL_API) {
                /** @type {?} */
                var dtf = new Intl.DateTimeFormat(this.locale, { year: 'numeric', timeZone: 'utc' });
                return this._stripDirectionalityCharacters(this._format(dtf, date));
            }
            return String(this.getYear(date));
        };
        /**
         * @return {?}
         */
        NativeDateAdapter.prototype.getFirstDayOfWeek = function () {
            // We can't tell using native JS Date what the first day of the week is, we default to Sunday.
            return 0;
        };
        /**
         * @param {?} date
         * @return {?}
         */
        NativeDateAdapter.prototype.getNumDaysInMonth = function (date) {
            return this.getDate(this._createDateWithOverflow(this.getYear(date), this.getMonth(date) + 1, 0));
        };
        /**
         * @param {?} date
         * @return {?}
         */
        NativeDateAdapter.prototype.clone = function (date) {
            return new Date(date.getTime());
        };
        /**
         * @param {?} year
         * @param {?} month
         * @param {?} date
         * @return {?}
         */
        NativeDateAdapter.prototype.createDate = function (year, month, date) {
            // Check for invalid month and date (except upper bound on date which we have to check after
            // creating the Date).
            if (month < 0 || month > 11) {
                throw Error("Invalid month index \"" + month + "\". Month index has to be between 0 and 11.");
            }
            if (date < 1) {
                throw Error("Invalid date \"" + date + "\". Date has to be greater than 0.");
            }
            /** @type {?} */
            var result = this._createDateWithOverflow(year, month, date);
            // Check that the date wasn't above the upper bound for the month, causing the month to overflow
            if (result.getMonth() != month) {
                throw Error("Invalid date \"" + date + "\" for month with index \"" + month + "\".");
            }
            return result;
        };
        /**
         * @return {?}
         */
        NativeDateAdapter.prototype.today = function () {
            return new Date();
        };
        /**
         * @param {?} value
         * @return {?}
         */
        NativeDateAdapter.prototype.parse = function (value) {
            // We have no way using the native JS Date to set the parse format or locale, so we ignore these
            // parameters.
            if (typeof value == 'number') {
                return new Date(value);
            }
            return value ? new Date(Date.parse(value)) : null;
        };
        /**
         * @param {?} date
         * @param {?} displayFormat
         * @return {?}
         */
        NativeDateAdapter.prototype.format = function (date, displayFormat) {
            if (!this.isValid(date)) {
                throw Error('NativeDateAdapter: Cannot format invalid date.');
            }
            if (SUPPORTS_INTL_API) {
                // On IE and Edge the i18n API will throw a hard error that can crash the entire app
                // if we attempt to format a date whose year is less than 1 or greater than 9999.
                if (this._clampDate && (date.getFullYear() < 1 || date.getFullYear() > 9999)) {
                    date = this.clone(date);
                    date.setFullYear(Math.max(1, Math.min(9999, date.getFullYear())));
                }
                displayFormat = Object.assign({}, displayFormat, { timeZone: 'utc' });
                /** @type {?} */
                var dtf = new Intl.DateTimeFormat(this.locale, displayFormat);
                return this._stripDirectionalityCharacters(this._format(dtf, date));
            }
            return this._stripDirectionalityCharacters(date.toDateString());
        };
        /**
         * @param {?} date
         * @param {?} years
         * @return {?}
         */
        NativeDateAdapter.prototype.addCalendarYears = function (date, years) {
            return this.addCalendarMonths(date, years * 12);
        };
        /**
         * @param {?} date
         * @param {?} months
         * @return {?}
         */
        NativeDateAdapter.prototype.addCalendarMonths = function (date, months) {
            /** @type {?} */
            var newDate = this._createDateWithOverflow(this.getYear(date), this.getMonth(date) + months, this.getDate(date));
            // It's possible to wind up in the wrong month if the original month has more days than the new
            // month. In this case we want to go to the last day of the desired month.
            // Note: the additional + 12 % 12 ensures we end up with a positive number, since JS % doesn't
            // guarantee this.
            if (this.getMonth(newDate) != ((this.getMonth(date) + months) % 12 + 12) % 12) {
                newDate = this._createDateWithOverflow(this.getYear(newDate), this.getMonth(newDate), 0);
            }
            return newDate;
        };
        /**
         * @param {?} date
         * @param {?} days
         * @return {?}
         */
        NativeDateAdapter.prototype.addCalendarDays = function (date, days) {
            return this._createDateWithOverflow(this.getYear(date), this.getMonth(date), this.getDate(date) + days);
        };
        /**
         * @param {?} date
         * @return {?}
         */
        NativeDateAdapter.prototype.toIso8601 = function (date) {
            return [
                date.getUTCFullYear(),
                this._2digit(date.getUTCMonth() + 1),
                this._2digit(date.getUTCDate())
            ].join('-');
        };
        /**
         * Returns the given value if given a valid Date or null. Deserializes valid ISO 8601 strings
         * (https://www.ietf.org/rfc/rfc3339.txt) into valid Dates and empty string into null. Returns an
         * invalid date for all other values.
         * @param {?} value
         * @return {?}
         */
        NativeDateAdapter.prototype.deserialize = function (value) {
            if (typeof value === 'string') {
                if (!value) {
                    return null;
                }
                // The `Date` constructor accepts formats other than ISO 8601, so we need to make sure the
                // string is the right format first.
                if (ISO_8601_REGEX.test(value)) {
                    /** @type {?} */
                    var date = new Date(value);
                    if (this.isValid(date)) {
                        return date;
                    }
                }
            }
            return _super.prototype.deserialize.call(this, value);
        };
        /**
         * @param {?} obj
         * @return {?}
         */
        NativeDateAdapter.prototype.isDateInstance = function (obj) {
            return obj instanceof Date;
        };
        /**
         * @param {?} date
         * @return {?}
         */
        NativeDateAdapter.prototype.isValid = function (date) {
            return !isNaN(date.getTime());
        };
        /**
         * @return {?}
         */
        NativeDateAdapter.prototype.invalid = function () {
            return new Date(NaN);
        };
        /**
         * Creates a date but allows the month and date to overflow.
         * @private
         * @param {?} year
         * @param {?} month
         * @param {?} date
         * @return {?}
         */
        NativeDateAdapter.prototype._createDateWithOverflow = function (year, month, date) {
            /** @type {?} */
            var result = new Date(year, month, date);
            // We need to correct for the fact that JS native Date treats years in range [0, 99] as
            // abbreviations for 19xx.
            if (year >= 0 && year < 100) {
                result.setFullYear(this.getYear(result) - 1900);
            }
            return result;
        };
        /**
         * Pads a number to make it two digits.
         * @private
         * @param {?} n The number to pad.
         * @return {?} The padded number.
         */
        NativeDateAdapter.prototype._2digit = function (n) {
            return ('00' + n).slice(-2);
        };
        /**
         * Strip out unicode LTR and RTL characters. Edge and IE insert these into formatted dates while
         * other browsers do not. We remove them to make output consistent and because they interfere with
         * date parsing.
         * @private
         * @param {?} str The string to strip direction characters from.
         * @return {?} The stripped string.
         */
        NativeDateAdapter.prototype._stripDirectionalityCharacters = function (str) {
            return str.replace(/[\u200e\u200f]/g, '');
        };
        /**
         * When converting Date object to string, javascript built-in functions may return wrong
         * results because it applies its internal DST rules. The DST rules around the world change
         * very frequently, and the current valid rule is not always valid in previous years though.
         * We work around this problem building a new Date object which has its internal UTC
         * representation with the local date and time.
         * @private
         * @param {?} dtf Intl.DateTimeFormat object, containg the desired string format. It must have
         *    timeZone set to 'utc' to work fine.
         * @param {?} date Date from which we want to get the string representation according to dtf
         * @return {?} A Date object with its UTC representation based on the passed in date info
         */
        NativeDateAdapter.prototype._format = function (dtf, date) {
            /** @type {?} */
            var d = new Date(Date.UTC(date.getFullYear(), date.getMonth(), date.getDate(), date.getHours(), date.getMinutes(), date.getSeconds(), date.getMilliseconds()));
            return dtf.format(d);
        };
        return NativeDateAdapter;
    }(DateAdapter));
    NativeDateAdapter.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    NativeDateAdapter.ctorParameters = function () { return [
        { type: String, decorators: [{ type: Optional }, { type: Inject, args: [MAT_DATE_LOCALE,] }] },
        { type: Platform }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var MAT_NATIVE_DATE_FORMATS = {
        parse: {
            dateInput: null,
        },
        display: {
            dateInput: { year: 'numeric', month: 'numeric', day: 'numeric' },
            monthYearLabel: { year: 'numeric', month: 'short' },
            dateA11yLabel: { year: 'numeric', month: 'long', day: 'numeric' },
            monthYearA11yLabel: { year: 'numeric', month: 'long' },
        }
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NativeDateModule = /** @class */ (function () {
        function NativeDateModule() {
        }
        return NativeDateModule;
    }());
    NativeDateModule.decorators = [
        { type: NgModule, args: [{
                    imports: [PlatformModule],
                    providers: [
                        { provide: DateAdapter, useClass: NativeDateAdapter },
                    ],
                },] },
    ];
    var ɵ0$1$4 = MAT_NATIVE_DATE_FORMATS;
    var MatNativeDateModule = /** @class */ (function () {
        function MatNativeDateModule() {
        }
        return MatNativeDateModule;
    }());
    MatNativeDateModule.decorators = [
        { type: NgModule, args: [{
                    imports: [NativeDateModule],
                    providers: [{ provide: MAT_DATE_FORMATS, useValue: ɵ0$1$4 }],
                },] },
    ];
    /**
     * Provider that defines how form controls behave with regards to displaying error messages.
     */
    var ErrorStateMatcher = /** @class */ (function () {
        function ErrorStateMatcher() {
        }
        /**
         * @param {?} control
         * @param {?} form
         * @return {?}
         */
        ErrorStateMatcher.prototype.isErrorState = function (control, form) {
            return !!(control && control.invalid && (control.touched || (form && form.submitted)));
        };
        return ErrorStateMatcher;
    }());
    ErrorStateMatcher.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] },
    ];
    /** @nocollapse */ ErrorStateMatcher.ngInjectableDef = ɵɵdefineInjectable({ factory: function ErrorStateMatcher_Factory() { return new ErrorStateMatcher(); }, token: ErrorStateMatcher, providedIn: "root" });
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Injection token that can be used to provide options to the Hammerjs instance.
     * More info at http://hammerjs.github.io/api/.
     * @type {?}
     */
    var MAT_HAMMER_OPTIONS = new InjectionToken('MAT_HAMMER_OPTIONS');
    /** @type {?} */
    var ANGULAR_MATERIAL_SUPPORTED_HAMMER_GESTURES = [
        'longpress',
        'slide',
        'slidestart',
        'slideend',
        'slideright',
        'slideleft'
    ];
    var ɵ0$2$2 = /**
     * @return {?}
     */ function () { }, ɵ1$6 = /**
     * @return {?}
     */ function () { };
    /**
     * Fake HammerInstance that is used when a Hammer instance is requested when HammerJS has not
     * been loaded on the page.
     * @type {?}
     */
    var noopHammerInstance = {
        on: (ɵ0$2$2),
        off: (ɵ1$6),
    };
    /**
     * Adjusts configuration of our gesture library, Hammer.
     */
    var GestureConfig = /** @class */ (function (_super) {
        __extends(GestureConfig, _super);
        /**
         * @param {?=} _hammerOptions
         * @param {?=} commonModule
         */
        function GestureConfig(_hammerOptions, commonModule) {
            var _this = _super.call(this) || this;
            _this._hammerOptions = _hammerOptions;
            /**
             * List of new event names to add to the gesture support list
             */
            _this.events = ANGULAR_MATERIAL_SUPPORTED_HAMMER_GESTURES;
            if (commonModule) {
                commonModule._checkHammerIsAvailable();
            }
            return _this;
        }
        /**
         * Builds Hammer instance manually to add custom recognizers that match the Material Design spec.
         *
         * Our gesture names come from the Material Design gestures spec:
         * https://material.io/design/#gestures-touch-mechanics
         *
         * More information on default recognizers can be found in Hammer docs:
         * http://hammerjs.github.io/recognizer-pan/
         * http://hammerjs.github.io/recognizer-press/
         *
         * @param {?} element Element to which to assign the new HammerJS gestures.
         * @return {?} Newly-created HammerJS instance.
         */
        GestureConfig.prototype.buildHammer = function (element) {
            /** @type {?} */
            var hammer = typeof window !== 'undefined' ? (( /** @type {?} */(window))).Hammer : null;
            if (!hammer) {
                // If HammerJS is not loaded here, return the noop HammerInstance. This is necessary to
                // ensure that omitting HammerJS completely will not cause any errors while *also* supporting
                // the lazy-loading of HammerJS via the HAMMER_LOADER token introduced in Angular 6.1.
                // Because we can't depend on HAMMER_LOADER's existance until 7.0, we have to always set
                // `this.events` to the set we support, instead of conditionally setting it to `[]` if
                // `HAMMER_LOADER` is present (and then throwing an Error here if `window.Hammer` is
                // undefined).
                // @breaking-change 8.0.0
                return noopHammerInstance;
            }
            /** @type {?} */
            var mc = new hammer(element, this._hammerOptions || undefined);
            // Default Hammer Recognizers.
            /** @type {?} */
            var pan = new hammer.Pan();
            /** @type {?} */
            var swipe = new hammer.Swipe();
            /** @type {?} */
            var press = new hammer.Press();
            // Notice that a HammerJS recognizer can only depend on one other recognizer once.
            // Otherwise the previous `recognizeWith` will be dropped.
            // TODO: Confirm threshold numbers with Material Design UX Team
            /** @type {?} */
            var slide = this._createRecognizer(pan, { event: 'slide', threshold: 0 }, swipe);
            /** @type {?} */
            var longpress = this._createRecognizer(press, { event: 'longpress', time: 500 });
            // Overwrite the default `pan` event to use the swipe event.
            pan.recognizeWith(swipe);
            // Since the slide event threshold is set to zero, the slide recognizer can fire and
            // accidentally reset the longpress recognizer. In order to make sure that the two
            // recognizers can run simultaneously but don't affect each other, we allow the slide
            // recognizer to recognize while a longpress is being processed.
            // See: https://github.com/hammerjs/hammer.js/blob/master/src/manager.js#L123-L124
            longpress.recognizeWith(slide);
            // Add customized gestures to Hammer manager
            mc.add([swipe, press, pan, slide, longpress]);
            return ( /** @type {?} */(mc));
        };
        /**
         * Creates a new recognizer, without affecting the default recognizers of HammerJS
         * @private
         * @param {?} base
         * @param {?} options
         * @param {...?} inheritances
         * @return {?}
         */
        GestureConfig.prototype._createRecognizer = function (base, options) {
            var inheritances = [];
            for (var _i = 2; _i < arguments.length; _i++) {
                inheritances[_i - 2] = arguments[_i];
            }
            /** @type {?} */
            var recognizer = new (( /** @type {?} */(base.constructor)))(options);
            inheritances.push(base);
            inheritances.forEach(( /**
             * @param {?} item
             * @return {?}
             */function (/**
             * @param {?} item
             * @return {?}
             */ item) { return recognizer.recognizeWith(item); }));
            return recognizer;
        };
        return GestureConfig;
    }(HammerGestureConfig));
    GestureConfig.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    GestureConfig.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [MAT_HAMMER_OPTIONS,] }] },
        { type: MatCommonModule, decorators: [{ type: Optional }] }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Shared directive to count lines inside a text area, such as a list item.
     * Line elements can be extracted with a \@ContentChildren(MatLine) query, then
     * counted by checking the query list's length.
     */
    var MatLine = /** @class */ (function () {
        function MatLine() {
        }
        return MatLine;
    }());
    MatLine.decorators = [
        { type: Directive, args: [{
                    selector: '[mat-line], [matLine]',
                    host: { 'class': 'mat-line' }
                },] },
    ];
    var MatLineModule = /** @class */ (function () {
        function MatLineModule() {
        }
        return MatLineModule;
    }());
    MatLineModule.decorators = [
        { type: NgModule, args: [{
                    imports: [MatCommonModule],
                    exports: [MatLine, MatCommonModule],
                    declarations: [MatLine],
                },] },
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var RippleState = {
        FADING_IN: 0, VISIBLE: 1, FADING_OUT: 2, HIDDEN: 3,
    };
    RippleState[RippleState.FADING_IN] = 'FADING_IN';
    RippleState[RippleState.VISIBLE] = 'VISIBLE';
    RippleState[RippleState.FADING_OUT] = 'FADING_OUT';
    RippleState[RippleState.HIDDEN] = 'HIDDEN';
    /**
     * Reference to a previously launched ripple element.
     */
    var RippleRef = /** @class */ (function () {
        /**
         * @param {?} _renderer
         * @param {?} element
         * @param {?} config
         */
        function RippleRef(_renderer, element, config) {
            this._renderer = _renderer;
            this.element = element;
            this.config = config;
            /**
             * Current state of the ripple.
             */
            this.state = RippleState.HIDDEN;
        }
        /**
         * Fades out the ripple element.
         * @return {?}
         */
        RippleRef.prototype.fadeOut = function () {
            this._renderer.fadeOutRipple(this);
        };
        return RippleRef;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Default ripple animation configuration for ripples without an explicit
     * animation config specified.
     * @type {?}
     */
    var defaultRippleAnimationConfig = {
        enterDuration: 450,
        exitDuration: 400
    };
    /**
     * Timeout for ignoring mouse events. Mouse events will be temporary ignored after touch
     * events to avoid synthetic mouse events.
     * @type {?}
     */
    var ignoreMouseEventsTimeout = 800;
    /**
     * Options that apply to all the event listeners that are bound by the ripple renderer.
     * @type {?}
     */
    var passiveEventOptions = normalizePassiveListenerOptions({ passive: true });
    /**
     * Helper service that performs DOM manipulations. Not intended to be used outside this module.
     * The constructor takes a reference to the ripple directive's host element and a map of DOM
     * event handlers to be installed on the element that triggers ripple animations.
     * This will eventually become a custom renderer once Angular support exists.
     * \@docs-private
     */
    var RippleRenderer = /** @class */ (function () {
        /**
         * @param {?} _target
         * @param {?} _ngZone
         * @param {?} elementOrElementRef
         * @param {?} platform
         */
        function RippleRenderer(_target, _ngZone, elementOrElementRef, platform) {
            var _this = this;
            this._target = _target;
            this._ngZone = _ngZone;
            /**
             * Whether the pointer is currently down or not.
             */
            this._isPointerDown = false;
            /**
             * Events to be registered on the trigger element.
             */
            this._triggerEvents = new Map();
            /**
             * Set of currently active ripple references.
             */
            this._activeRipples = new Set();
            /**
             * Function being called whenever the trigger is being pressed using mouse.
             */
            this._onMousedown = ( /**
             * @param {?} event
             * @return {?}
             */function (event) {
                // Screen readers will fire fake mouse events for space/enter. Skip launching a
                // ripple in this case for consistency with the non-screen-reader experience.
                /** @type {?} */
                var isFakeMousedown = isFakeMousedownFromScreenReader(event);
                /** @type {?} */
                var isSyntheticEvent = _this._lastTouchStartEvent &&
                    Date.now() < _this._lastTouchStartEvent + ignoreMouseEventsTimeout;
                if (!_this._target.rippleDisabled && !isFakeMousedown && !isSyntheticEvent) {
                    _this._isPointerDown = true;
                    _this.fadeInRipple(event.clientX, event.clientY, _this._target.rippleConfig);
                }
            });
            /**
             * Function being called whenever the trigger is being pressed using touch.
             */
            this._onTouchStart = ( /**
             * @param {?} event
             * @return {?}
             */function (event) {
                if (!_this._target.rippleDisabled) {
                    // Some browsers fire mouse events after a `touchstart` event. Those synthetic mouse
                    // events will launch a second ripple if we don't ignore mouse events for a specific
                    // time after a touchstart event.
                    _this._lastTouchStartEvent = Date.now();
                    _this._isPointerDown = true;
                    // Use `changedTouches` so we skip any touches where the user put
                    // their finger down, but used another finger to tap the element again.
                    /** @type {?} */
                    var touches = event.changedTouches;
                    for (var i_153 = 0; i_153 < touches.length; i_153++) {
                        _this.fadeInRipple(touches[i_153].clientX, touches[i_153].clientY, _this._target.rippleConfig);
                    }
                }
            });
            /**
             * Function being called whenever the trigger is being released.
             */
            this._onPointerUp = ( /**
             * @return {?}
             */function () {
                if (!_this._isPointerDown) {
                    return;
                }
                _this._isPointerDown = false;
                // Fade-out all ripples that are visible and not persistent.
                _this._activeRipples.forEach(( /**
                 * @param {?} ripple
                 * @return {?}
                 */function (/**
                 * @param {?} ripple
                 * @return {?}
                 */ ripple) {
                    // By default, only ripples that are completely visible will fade out on pointer release.
                    // If the `terminateOnPointerUp` option is set, ripples that still fade in will also fade out.
                    /** @type {?} */
                    var isVisible = ripple.state === RippleState.VISIBLE ||
                        ripple.config.terminateOnPointerUp && ripple.state === RippleState.FADING_IN;
                    if (!ripple.config.persistent && isVisible) {
                        ripple.fadeOut();
                    }
                }));
            });
            // Only do anything if we're on the browser.
            if (platform.isBrowser) {
                this._containerElement = coerceElement(elementOrElementRef);
                // Specify events which need to be registered on the trigger.
                this._triggerEvents
                    .set('mousedown', this._onMousedown)
                    .set('mouseup', this._onPointerUp)
                    .set('mouseleave', this._onPointerUp)
                    .set('touchstart', this._onTouchStart)
                    .set('touchend', this._onPointerUp)
                    .set('touchcancel', this._onPointerUp);
            }
        }
        /**
         * Fades in a ripple at the given coordinates.
         * @param {?} x Coordinate within the element, along the X axis at which to start the ripple.
         * @param {?} y Coordinate within the element, along the Y axis at which to start the ripple.
         * @param {?=} config Extra ripple options.
         * @return {?}
         */
        RippleRenderer.prototype.fadeInRipple = function (x, y, config) {
            var _this = this;
            if (config === void 0) { config = {}; }
            /** @type {?} */
            var containerRect = this._containerRect =
                this._containerRect || this._containerElement.getBoundingClientRect();
            /** @type {?} */
            var animationConfig = Object.assign({}, defaultRippleAnimationConfig, config.animation);
            if (config.centered) {
                x = containerRect.left + containerRect.width / 2;
                y = containerRect.top + containerRect.height / 2;
            }
            /** @type {?} */
            var radius = config.radius || distanceToFurthestCorner(x, y, containerRect);
            /** @type {?} */
            var offsetX = x - containerRect.left;
            /** @type {?} */
            var offsetY = y - containerRect.top;
            /** @type {?} */
            var duration = animationConfig.enterDuration;
            /** @type {?} */
            var ripple = document.createElement('div');
            ripple.classList.add('mat-ripple-element');
            ripple.style.left = offsetX - radius + "px";
            ripple.style.top = offsetY - radius + "px";
            ripple.style.height = radius * 2 + "px";
            ripple.style.width = radius * 2 + "px";
            // If the color is not set, the default CSS color will be used.
            ripple.style.backgroundColor = config.color || null;
            ripple.style.transitionDuration = duration + "ms";
            this._containerElement.appendChild(ripple);
            // By default the browser does not recalculate the styles of dynamically created
            // ripple elements. This is critical because then the `scale` would not animate properly.
            enforceStyleRecalculation(ripple);
            ripple.style.transform = 'scale(1)';
            // Exposed reference to the ripple that will be returned.
            /** @type {?} */
            var rippleRef = new RippleRef(this, ripple, config);
            rippleRef.state = RippleState.FADING_IN;
            // Add the ripple reference to the list of all active ripples.
            this._activeRipples.add(rippleRef);
            if (!config.persistent) {
                this._mostRecentTransientRipple = rippleRef;
            }
            // Wait for the ripple element to be completely faded in.
            // Once it's faded in, the ripple can be hidden immediately if the mouse is released.
            this._runTimeoutOutsideZone(( /**
             * @return {?}
             */function () {
                /** @type {?} */
                var isMostRecentTransientRipple = rippleRef === _this._mostRecentTransientRipple;
                rippleRef.state = RippleState.VISIBLE;
                // When the timer runs out while the user has kept their pointer down, we want to
                // keep only the persistent ripples and the latest transient ripple. We do this,
                // because we don't want stacked transient ripples to appear after their enter
                // animation has finished.
                if (!config.persistent && (!isMostRecentTransientRipple || !_this._isPointerDown)) {
                    rippleRef.fadeOut();
                }
            }), duration);
            return rippleRef;
        };
        /**
         * Fades out a ripple reference.
         * @param {?} rippleRef
         * @return {?}
         */
        RippleRenderer.prototype.fadeOutRipple = function (rippleRef) {
            /** @type {?} */
            var wasActive = this._activeRipples.delete(rippleRef);
            if (rippleRef === this._mostRecentTransientRipple) {
                this._mostRecentTransientRipple = null;
            }
            // Clear out the cached bounding rect if we have no more ripples.
            if (!this._activeRipples.size) {
                this._containerRect = null;
            }
            // For ripples that are not active anymore, don't re-run the fade-out animation.
            if (!wasActive) {
                return;
            }
            /** @type {?} */
            var rippleEl = rippleRef.element;
            /** @type {?} */
            var animationConfig = Object.assign({}, defaultRippleAnimationConfig, rippleRef.config.animation);
            rippleEl.style.transitionDuration = animationConfig.exitDuration + "ms";
            rippleEl.style.opacity = '0';
            rippleRef.state = RippleState.FADING_OUT;
            // Once the ripple faded out, the ripple can be safely removed from the DOM.
            this._runTimeoutOutsideZone(( /**
             * @return {?}
             */function () {
                rippleRef.state = RippleState.HIDDEN;
                ( /** @type {?} */(rippleEl.parentNode)).removeChild(rippleEl);
            }), animationConfig.exitDuration);
        };
        /**
         * Fades out all currently active ripples.
         * @return {?}
         */
        RippleRenderer.prototype.fadeOutAll = function () {
            this._activeRipples.forEach(( /**
             * @param {?} ripple
             * @return {?}
             */function (/**
             * @param {?} ripple
             * @return {?}
             */ ripple) { return ripple.fadeOut(); }));
        };
        /**
         * Sets up the trigger event listeners
         * @param {?} elementOrElementRef
         * @return {?}
         */
        RippleRenderer.prototype.setupTriggerEvents = function (elementOrElementRef) {
            var _this = this;
            /** @type {?} */
            var element = coerceElement(elementOrElementRef);
            if (!element || element === this._triggerElement) {
                return;
            }
            // Remove all previously registered event listeners from the trigger element.
            this._removeTriggerEvents();
            this._ngZone.runOutsideAngular(( /**
             * @return {?}
             */function () {
                _this._triggerEvents.forEach(( /**
                 * @param {?} fn
                 * @param {?} type
                 * @return {?}
                 */function (fn, type) {
                    element.addEventListener(type, fn, passiveEventOptions);
                }));
            }));
            this._triggerElement = element;
        };
        /**
         * Runs a timeout outside of the Angular zone to avoid triggering the change detection.
         * @private
         * @param {?} fn
         * @param {?=} delay
         * @return {?}
         */
        RippleRenderer.prototype._runTimeoutOutsideZone = function (fn, delay) {
            if (delay === void 0) { delay = 0; }
            this._ngZone.runOutsideAngular(( /**
             * @return {?}
             */function () { return setTimeout(fn, delay); }));
        };
        /**
         * Removes previously registered event listeners from the trigger element.
         * @return {?}
         */
        RippleRenderer.prototype._removeTriggerEvents = function () {
            var _this = this;
            if (this._triggerElement) {
                this._triggerEvents.forEach(( /**
                 * @param {?} fn
                 * @param {?} type
                 * @return {?}
                 */function (fn, type) {
                    ( /** @type {?} */(_this._triggerElement)).removeEventListener(type, fn, passiveEventOptions);
                }));
            }
        };
        return RippleRenderer;
    }());
    /**
     * Enforces a style recalculation of a DOM element by computing its styles.
     * @param {?} element
     * @return {?}
     */
    function enforceStyleRecalculation(element) {
        // Enforce a style recalculation by calling `getComputedStyle` and accessing any property.
        // Calling `getPropertyValue` is important to let optimizers know that this is not a noop.
        // See: https://gist.github.com/paulirish/5d52fb081b3570c81e3a
        window.getComputedStyle(element).getPropertyValue('opacity');
    }
    /**
     * Returns the distance from the point (x, y) to the furthest corner of a rectangle.
     * @param {?} x
     * @param {?} y
     * @param {?} rect
     * @return {?}
     */
    function distanceToFurthestCorner(x, y, rect) {
        /** @type {?} */
        var distX = Math.max(Math.abs(x - rect.left), Math.abs(x - rect.right));
        /** @type {?} */
        var distY = Math.max(Math.abs(y - rect.top), Math.abs(y - rect.bottom));
        return Math.sqrt(distX * distX + distY * distY);
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Injection token that can be used to specify the global ripple options.
     * @type {?}
     */
    var MAT_RIPPLE_GLOBAL_OPTIONS = new InjectionToken('mat-ripple-global-options');
    var MatRipple = /** @class */ (function () {
        /**
         * @param {?} _elementRef
         * @param {?} ngZone
         * @param {?} platform
         * @param {?=} globalOptions
         * @param {?=} animationMode
         */
        function MatRipple(_elementRef, ngZone, platform, globalOptions, animationMode) {
            this._elementRef = _elementRef;
            /**
             * If set, the radius in pixels of foreground ripples when fully expanded. If unset, the radius
             * will be the distance from the center of the ripple to the furthest corner of the host element's
             * bounding rectangle.
             */
            this.radius = 0;
            this._disabled = false;
            /**
             * Whether ripple directive is initialized and the input bindings are set.
             */
            this._isInitialized = false;
            this._globalOptions = globalOptions || {};
            this._rippleRenderer = new RippleRenderer(this, ngZone, _elementRef, platform);
            if (animationMode === 'NoopAnimations') {
                this._globalOptions.animation = { enterDuration: 0, exitDuration: 0 };
            }
        }
        Object.defineProperty(MatRipple.prototype, "disabled", {
            /**
             * Whether click events will not trigger the ripple. Ripples can be still launched manually
             * by using the `launch()` method.
             * @return {?}
             */
            get: function () { return this._disabled; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._disabled = value;
                this._setupTriggerEventsIfEnabled();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatRipple.prototype, "trigger", {
            /**
             * The element that triggers the ripple when click events are received.
             * Defaults to the directive's host element.
             * @return {?}
             */
            get: function () { return this._trigger || this._elementRef.nativeElement; },
            /**
             * @param {?} trigger
             * @return {?}
             */
            set: function (trigger) {
                this._trigger = trigger;
                this._setupTriggerEventsIfEnabled();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        MatRipple.prototype.ngOnInit = function () {
            this._isInitialized = true;
            this._setupTriggerEventsIfEnabled();
        };
        /**
         * @return {?}
         */
        MatRipple.prototype.ngOnDestroy = function () {
            this._rippleRenderer._removeTriggerEvents();
        };
        /**
         * Fades out all currently showing ripple elements.
         * @return {?}
         */
        MatRipple.prototype.fadeOutAll = function () {
            this._rippleRenderer.fadeOutAll();
        };
        Object.defineProperty(MatRipple.prototype, "rippleConfig", {
            /**
             * Ripple configuration from the directive's input values.
             * \@docs-private Implemented as part of RippleTarget
             * @return {?}
             */
            get: function () {
                return {
                    centered: this.centered,
                    radius: this.radius,
                    color: this.color,
                    animation: Object.assign({}, this._globalOptions.animation, this.animation),
                    terminateOnPointerUp: this._globalOptions.terminateOnPointerUp,
                };
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatRipple.prototype, "rippleDisabled", {
            /**
             * Whether ripples on pointer-down are disabled or not.
             * \@docs-private Implemented as part of RippleTarget
             * @return {?}
             */
            get: function () {
                return this.disabled || !!this._globalOptions.disabled;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Sets up the trigger event listeners if ripples are enabled.
         * @private
         * @return {?}
         */
        MatRipple.prototype._setupTriggerEventsIfEnabled = function () {
            if (!this.disabled && this._isInitialized) {
                this._rippleRenderer.setupTriggerEvents(this.trigger);
            }
        };
        /**
         * Launches a manual ripple at the specified coordinated or just by the ripple config.
         * @param {?} configOrX
         * @param {?=} y
         * @param {?=} config
         * @return {?}
         */
        MatRipple.prototype.launch = function (configOrX, y, config) {
            if (y === void 0) { y = 0; }
            if (typeof configOrX === 'number') {
                return this._rippleRenderer.fadeInRipple(configOrX, y, Object.assign({}, this.rippleConfig, config));
            }
            else {
                return this._rippleRenderer.fadeInRipple(0, 0, Object.assign({}, this.rippleConfig, configOrX));
            }
        };
        return MatRipple;
    }());
    MatRipple.decorators = [
        { type: Directive, args: [{
                    selector: '[mat-ripple], [matRipple]',
                    exportAs: 'matRipple',
                    host: {
                        'class': 'mat-ripple',
                        '[class.mat-ripple-unbounded]': 'unbounded'
                    }
                },] },
    ];
    /** @nocollapse */
    MatRipple.ctorParameters = function () { return [
        { type: ElementRef },
        { type: NgZone },
        { type: Platform },
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [MAT_RIPPLE_GLOBAL_OPTIONS,] }] },
        { type: String, decorators: [{ type: Optional }, { type: Inject, args: [ANIMATION_MODULE_TYPE,] }] }
    ]; };
    MatRipple.propDecorators = {
        color: [{ type: Input, args: ['matRippleColor',] }],
        unbounded: [{ type: Input, args: ['matRippleUnbounded',] }],
        centered: [{ type: Input, args: ['matRippleCentered',] }],
        radius: [{ type: Input, args: ['matRippleRadius',] }],
        animation: [{ type: Input, args: ['matRippleAnimation',] }],
        disabled: [{ type: Input, args: ['matRippleDisabled',] }],
        trigger: [{ type: Input, args: ['matRippleTrigger',] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatRippleModule = /** @class */ (function () {
        function MatRippleModule() {
        }
        return MatRippleModule;
    }());
    MatRippleModule.decorators = [
        { type: NgModule, args: [{
                    imports: [MatCommonModule, PlatformModule],
                    exports: [MatRipple, MatCommonModule],
                    declarations: [MatRipple],
                },] },
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Component that shows a simplified checkbox without including any kind of "real" checkbox.
     * Meant to be used when the checkbox is purely decorative and a large number of them will be
     * included, such as for the options in a multi-select. Uses no SVGs or complex animations.
     * Note that theming is meant to be handled by the parent element, e.g.
     * `mat-primary .mat-pseudo-checkbox`.
     *
     * Note that this component will be completely invisible to screen-reader users. This is *not*
     * interchangeable with `<mat-checkbox>` and should *not* be used if the user would directly
     * interact with the checkbox. The pseudo-checkbox should only be used as an implementation detail
     * of more complex components that appropriately handle selected / checked state.
     * \@docs-private
     */
    var MatPseudoCheckbox = /** @class */ (function () {
        /**
         * @param {?=} _animationMode
         */
        function MatPseudoCheckbox(_animationMode) {
            this._animationMode = _animationMode;
            /**
             * Display state of the checkbox.
             */
            this.state = 'unchecked';
            /**
             * Whether the checkbox is disabled.
             */
            this.disabled = false;
        }
        return MatPseudoCheckbox;
    }());
    MatPseudoCheckbox.decorators = [
        { type: Component, args: [{ encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    selector: 'mat-pseudo-checkbox',
                    styles: [".mat-pseudo-checkbox{width:16px;height:16px;border:2px solid;border-radius:2px;cursor:pointer;display:inline-block;vertical-align:middle;box-sizing:border-box;position:relative;flex-shrink:0;transition:border-color 90ms cubic-bezier(0,0,.2,.1),background-color 90ms cubic-bezier(0,0,.2,.1)}.mat-pseudo-checkbox::after{position:absolute;opacity:0;content:'';border-bottom:2px solid currentColor;transition:opacity 90ms cubic-bezier(0,0,.2,.1)}.mat-pseudo-checkbox.mat-pseudo-checkbox-checked,.mat-pseudo-checkbox.mat-pseudo-checkbox-indeterminate{border-color:transparent}._mat-animation-noopable.mat-pseudo-checkbox{transition:none;animation:none}._mat-animation-noopable.mat-pseudo-checkbox::after{transition:none}.mat-pseudo-checkbox-disabled{cursor:default}.mat-pseudo-checkbox-indeterminate::after{top:5px;left:1px;width:10px;opacity:1;border-radius:2px}.mat-pseudo-checkbox-checked::after{top:2.4px;left:1px;width:8px;height:3px;border-left:2px solid currentColor;transform:rotate(-45deg);opacity:1;box-sizing:content-box}"],
                    template: '',
                    host: {
                        'class': 'mat-pseudo-checkbox',
                        '[class.mat-pseudo-checkbox-indeterminate]': 'state === "indeterminate"',
                        '[class.mat-pseudo-checkbox-checked]': 'state === "checked"',
                        '[class.mat-pseudo-checkbox-disabled]': 'disabled',
                        '[class._mat-animation-noopable]': '_animationMode === "NoopAnimations"',
                    },
                },] },
    ];
    /** @nocollapse */
    MatPseudoCheckbox.ctorParameters = function () { return [
        { type: String, decorators: [{ type: Optional }, { type: Inject, args: [ANIMATION_MODULE_TYPE,] }] }
    ]; };
    MatPseudoCheckbox.propDecorators = {
        state: [{ type: Input }],
        disabled: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatPseudoCheckboxModule = /** @class */ (function () {
        function MatPseudoCheckboxModule() {
        }
        return MatPseudoCheckboxModule;
    }());
    MatPseudoCheckboxModule.decorators = [
        { type: NgModule, args: [{
                    exports: [MatPseudoCheckbox],
                    declarations: [MatPseudoCheckbox]
                },] },
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // Boilerplate for applying mixins to MatOptgroup.
    /**
     * \@docs-private
     */
    var MatOptgroupBase = /** @class */ (function () {
        function MatOptgroupBase() {
        }
        return MatOptgroupBase;
    }());
    /** @type {?} */
    var _MatOptgroupMixinBase = mixinDisabled(MatOptgroupBase);
    // Counter for unique group ids.
    /** @type {?} */
    var _uniqueOptgroupIdCounter = 0;
    /**
     * Component that is used to group instances of `mat-option`.
     */
    var MatOptgroup = /** @class */ (function (_super) {
        __extends(MatOptgroup, _super);
        function MatOptgroup() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            /**
             * Unique id for the underlying label.
             */
            _this._labelId = "mat-optgroup-label-" + _uniqueOptgroupIdCounter++;
            return _this;
        }
        return MatOptgroup;
    }(_MatOptgroupMixinBase));
    MatOptgroup.decorators = [
        { type: Component, args: [{ selector: 'mat-optgroup',
                    exportAs: 'matOptgroup',
                    template: "<label class=\"mat-optgroup-label\" [id]=\"_labelId\">{{ label }}<ng-content></ng-content></label><ng-content select=\"mat-option, ng-container\"></ng-content>",
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    inputs: ['disabled'],
                    styles: [".mat-optgroup-label{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;display:block;line-height:48px;height:48px;padding:0 16px;text-align:left;text-decoration:none;max-width:100%;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:default}.mat-optgroup-label[disabled]{cursor:default}[dir=rtl] .mat-optgroup-label{text-align:right}.mat-optgroup-label .mat-icon{margin-right:16px;vertical-align:middle}.mat-optgroup-label .mat-icon svg{vertical-align:top}[dir=rtl] .mat-optgroup-label .mat-icon{margin-left:16px;margin-right:0}"],
                    host: {
                        'class': 'mat-optgroup',
                        'role': 'group',
                        '[class.mat-optgroup-disabled]': 'disabled',
                        '[attr.aria-disabled]': 'disabled.toString()',
                        '[attr.aria-labelledby]': '_labelId',
                    }
                },] },
    ];
    MatOptgroup.propDecorators = {
        label: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Option IDs need to be unique across components, so this counter exists outside of
     * the component definition.
     * @type {?}
     */
    var _uniqueIdCounter = 0;
    /**
     * Event object emitted by MatOption when selected or deselected.
     */
    var MatOptionSelectionChange = /** @class */ (function () {
        /**
         * @param {?} source
         * @param {?=} isUserInput
         */
        function MatOptionSelectionChange(source, isUserInput) {
            if (isUserInput === void 0) { isUserInput = false; }
            this.source = source;
            this.isUserInput = isUserInput;
        }
        return MatOptionSelectionChange;
    }());
    /**
     * Injection token used to provide the parent component to options.
     * @type {?}
     */
    var MAT_OPTION_PARENT_COMPONENT = new InjectionToken('MAT_OPTION_PARENT_COMPONENT');
    /**
     * Single option inside of a `<mat-select>` element.
     */
    var MatOption = /** @class */ (function () {
        /**
         * @param {?} _element
         * @param {?} _changeDetectorRef
         * @param {?} _parent
         * @param {?} group
         */
        function MatOption(_element, _changeDetectorRef, _parent, group) {
            this._element = _element;
            this._changeDetectorRef = _changeDetectorRef;
            this._parent = _parent;
            this.group = group;
            this._selected = false;
            this._active = false;
            this._disabled = false;
            this._mostRecentViewValue = '';
            /**
             * The unique ID of the option.
             */
            this.id = "mat-option-" + _uniqueIdCounter++;
            /**
             * Event emitted when the option is selected or deselected.
             */
            // tslint:disable-next-line:no-output-on-prefix
            this.onSelectionChange = new EventEmitter();
            /**
             * Emits when the state of the option changes and any parents have to be notified.
             */
            this._stateChanges = new Subject();
        }
        Object.defineProperty(MatOption.prototype, "multiple", {
            /**
             * Whether the wrapping component is in multiple selection mode.
             * @return {?}
             */
            get: function () { return this._parent && this._parent.multiple; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatOption.prototype, "selected", {
            /**
             * Whether or not the option is currently selected.
             * @return {?}
             */
            get: function () { return this._selected; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatOption.prototype, "disabled", {
            /**
             * Whether the option is disabled.
             * @return {?}
             */
            get: function () { return (this.group && this.group.disabled) || this._disabled; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this._disabled = coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatOption.prototype, "disableRipple", {
            /**
             * Whether ripples for the option are disabled.
             * @return {?}
             */
            get: function () { return this._parent && this._parent.disableRipple; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatOption.prototype, "active", {
            /**
             * Whether or not the option is currently active and ready to be selected.
             * An active option displays styles as if it is focused, but the
             * focus is actually retained somewhere else. This comes in handy
             * for components like autocomplete where focus must remain on the input.
             * @return {?}
             */
            get: function () {
                return this._active;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatOption.prototype, "viewValue", {
            /**
             * The displayed value of the option. It is necessary to show the selected option in the
             * select's trigger.
             * @return {?}
             */
            get: function () {
                // TODO(kara): Add input property alternative for node envs.
                return (this._getHostElement().textContent || '').trim();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Selects the option.
         * @return {?}
         */
        MatOption.prototype.select = function () {
            if (!this._selected) {
                this._selected = true;
                this._changeDetectorRef.markForCheck();
                this._emitSelectionChangeEvent();
            }
        };
        /**
         * Deselects the option.
         * @return {?}
         */
        MatOption.prototype.deselect = function () {
            if (this._selected) {
                this._selected = false;
                this._changeDetectorRef.markForCheck();
                this._emitSelectionChangeEvent();
            }
        };
        /**
         * Sets focus onto this option.
         * @param {?=} _origin
         * @param {?=} options
         * @return {?}
         */
        MatOption.prototype.focus = function (_origin, options) {
            // Note that we aren't using `_origin`, but we need to keep it because some internal consumers
            // use `MatOption` in a `FocusKeyManager` and we need it to match `FocusableOption`.
            /** @type {?} */
            var element = this._getHostElement();
            if (typeof element.focus === 'function') {
                element.focus(options);
            }
        };
        /**
         * This method sets display styles on the option to make it appear
         * active. This is used by the ActiveDescendantKeyManager so key
         * events will display the proper options as active on arrow key events.
         * @return {?}
         */
        MatOption.prototype.setActiveStyles = function () {
            if (!this._active) {
                this._active = true;
                this._changeDetectorRef.markForCheck();
            }
        };
        /**
         * This method removes display styles on the option that made it appear
         * active. This is used by the ActiveDescendantKeyManager so key
         * events will display the proper options as active on arrow key events.
         * @return {?}
         */
        MatOption.prototype.setInactiveStyles = function () {
            if (this._active) {
                this._active = false;
                this._changeDetectorRef.markForCheck();
            }
        };
        /**
         * Gets the label to be used when determining whether the option should be focused.
         * @return {?}
         */
        MatOption.prototype.getLabel = function () {
            return this.viewValue;
        };
        /**
         * Ensures the option is selected when activated from the keyboard.
         * @param {?} event
         * @return {?}
         */
        MatOption.prototype._handleKeydown = function (event) {
            if ((event.keyCode === ENTER || event.keyCode === SPACE) && !hasModifierKey(event)) {
                this._selectViaInteraction();
                // Prevent the page from scrolling down and form submits.
                event.preventDefault();
            }
        };
        /**
         * `Selects the option while indicating the selection came from the user. Used to
         * determine if the select's view -> model callback should be invoked.`
         * @return {?}
         */
        MatOption.prototype._selectViaInteraction = function () {
            if (!this.disabled) {
                this._selected = this.multiple ? !this._selected : true;
                this._changeDetectorRef.markForCheck();
                this._emitSelectionChangeEvent(true);
            }
        };
        /**
         * Gets the `aria-selected` value for the option. We explicitly omit the `aria-selected`
         * attribute from single-selection, unselected options. Including the `aria-selected="false"`
         * attributes adds a significant amount of noise to screen-reader users without providing useful
         * information.
         * @return {?}
         */
        MatOption.prototype._getAriaSelected = function () {
            return this.selected || (this.multiple ? false : null);
        };
        /**
         * Returns the correct tabindex for the option depending on disabled state.
         * @return {?}
         */
        MatOption.prototype._getTabIndex = function () {
            return this.disabled ? '-1' : '0';
        };
        /**
         * Gets the host DOM element.
         * @return {?}
         */
        MatOption.prototype._getHostElement = function () {
            return this._element.nativeElement;
        };
        /**
         * @return {?}
         */
        MatOption.prototype.ngAfterViewChecked = function () {
            // Since parent components could be using the option's label to display the selected values
            // (e.g. `mat-select`) and they don't have a way of knowing if the option's label has changed
            // we have to check for changes in the DOM ourselves and dispatch an event. These checks are
            // relatively cheap, however we still limit them only to selected options in order to avoid
            // hitting the DOM too often.
            if (this._selected) {
                /** @type {?} */
                var viewValue = this.viewValue;
                if (viewValue !== this._mostRecentViewValue) {
                    this._mostRecentViewValue = viewValue;
                    this._stateChanges.next();
                }
            }
        };
        /**
         * @return {?}
         */
        MatOption.prototype.ngOnDestroy = function () {
            this._stateChanges.complete();
        };
        /**
         * Emits the selection change event.
         * @private
         * @param {?=} isUserInput
         * @return {?}
         */
        MatOption.prototype._emitSelectionChangeEvent = function (isUserInput) {
            if (isUserInput === void 0) { isUserInput = false; }
            this.onSelectionChange.emit(new MatOptionSelectionChange(this, isUserInput));
        };
        return MatOption;
    }());
    MatOption.decorators = [
        { type: Component, args: [{ selector: 'mat-option',
                    exportAs: 'matOption',
                    host: {
                        'role': 'option',
                        '[attr.tabindex]': '_getTabIndex()',
                        '[class.mat-selected]': 'selected',
                        '[class.mat-option-multiple]': 'multiple',
                        '[class.mat-active]': 'active',
                        '[id]': 'id',
                        '[attr.aria-selected]': '_getAriaSelected()',
                        '[attr.aria-disabled]': 'disabled.toString()',
                        '[class.mat-option-disabled]': 'disabled',
                        '(click)': '_selectViaInteraction()',
                        '(keydown)': '_handleKeydown($event)',
                        'class': 'mat-option',
                    },
                    styles: [".mat-option{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;display:block;line-height:48px;height:48px;padding:0 16px;text-align:left;text-decoration:none;max-width:100%;position:relative;cursor:pointer;outline:0;display:flex;flex-direction:row;max-width:100%;box-sizing:border-box;align-items:center;-webkit-tap-highlight-color:transparent}.mat-option[disabled]{cursor:default}[dir=rtl] .mat-option{text-align:right}.mat-option .mat-icon{margin-right:16px;vertical-align:middle}.mat-option .mat-icon svg{vertical-align:top}[dir=rtl] .mat-option .mat-icon{margin-left:16px;margin-right:0}.mat-option[aria-disabled=true]{-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:default}.mat-optgroup .mat-option:not(.mat-option-multiple){padding-left:32px}[dir=rtl] .mat-optgroup .mat-option:not(.mat-option-multiple){padding-left:16px;padding-right:32px}@media (-ms-high-contrast:active){.mat-option{margin:0 1px}.mat-option.mat-active{border:solid 1px currentColor;margin:0}}.mat-option-text{display:inline-block;flex-grow:1;overflow:hidden;text-overflow:ellipsis}.mat-option .mat-option-ripple{top:0;left:0;right:0;bottom:0;position:absolute;pointer-events:none}@media (-ms-high-contrast:active){.mat-option .mat-option-ripple{opacity:.5}}.mat-option-pseudo-checkbox{margin-right:8px}[dir=rtl] .mat-option-pseudo-checkbox{margin-left:8px;margin-right:0}"],
                    template: "<mat-pseudo-checkbox *ngIf=\"multiple\" class=\"mat-option-pseudo-checkbox\" [state]=\"selected ? 'checked' : ''\" [disabled]=\"disabled\"></mat-pseudo-checkbox><span class=\"mat-option-text\"><ng-content></ng-content></span><div class=\"mat-option-ripple\" mat-ripple [matRippleTrigger]=\"_getHostElement()\" [matRippleDisabled]=\"disabled || disableRipple\"></div>",
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                },] },
    ];
    /** @nocollapse */
    MatOption.ctorParameters = function () { return [
        { type: ElementRef },
        { type: ChangeDetectorRef },
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [MAT_OPTION_PARENT_COMPONENT,] }] },
        { type: MatOptgroup, decorators: [{ type: Optional }] }
    ]; };
    MatOption.propDecorators = {
        value: [{ type: Input }],
        id: [{ type: Input }],
        disabled: [{ type: Input }],
        onSelectionChange: [{ type: Output }]
    };
    /**
     * Counts the amount of option group labels that precede the specified option.
     * \@docs-private
     * @param {?} optionIndex Index of the option at which to start counting.
     * @param {?} options Flat list of all of the options.
     * @param {?} optionGroups Flat list of all of the option groups.
     * @return {?}
     */
    function _countGroupLabelsBeforeOption(optionIndex, options, optionGroups) {
        if (optionGroups.length) {
            /** @type {?} */
            var optionsArray = options.toArray();
            /** @type {?} */
            var groups = optionGroups.toArray();
            /** @type {?} */
            var groupCounter = 0;
            for (var i_154 = 0; i_154 < optionIndex + 1; i_154++) {
                if (optionsArray[i_154].group && optionsArray[i_154].group === groups[groupCounter]) {
                    groupCounter++;
                }
            }
            return groupCounter;
        }
        return 0;
    }
    /**
     * Determines the position to which to scroll a panel in order for an option to be into view.
     * \@docs-private
     * @param {?} optionIndex Index of the option to be scrolled into the view.
     * @param {?} optionHeight Height of the options.
     * @param {?} currentScrollPosition Current scroll position of the panel.
     * @param {?} panelHeight Height of the panel.
     * @return {?}
     */
    function _getOptionScrollPosition(optionIndex, optionHeight, currentScrollPosition, panelHeight) {
        /** @type {?} */
        var optionOffset = optionIndex * optionHeight;
        if (optionOffset < currentScrollPosition) {
            return optionOffset;
        }
        if (optionOffset + optionHeight > currentScrollPosition + panelHeight) {
            return Math.max(0, optionOffset - panelHeight + optionHeight);
        }
        return currentScrollPosition;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatOptionModule = /** @class */ (function () {
        function MatOptionModule() {
        }
        return MatOptionModule;
    }());
    MatOptionModule.decorators = [
        { type: NgModule, args: [{
                    imports: [MatRippleModule, CommonModule, MatPseudoCheckboxModule],
                    exports: [MatOption, MatOptgroup],
                    declarations: [MatOption, MatOptgroup]
                },] },
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * InjectionToken that can be used to specify the global label options.
     * @type {?}
     */
    var MAT_LABEL_GLOBAL_OPTIONS = new InjectionToken('mat-label-global-options');
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // Boilerplate for applying mixins to MatProgressBar.
    /**
     * \@docs-private
     */
    var MatProgressBarBase = /** @class */ (function () {
        /**
         * @param {?} _elementRef
         */
        function MatProgressBarBase(_elementRef) {
            this._elementRef = _elementRef;
        }
        return MatProgressBarBase;
    }());
    /** @type {?} */
    var _MatProgressBarMixinBase = mixinColor(MatProgressBarBase, 'primary');
    /**
     * Injection token used to provide the current location to `MatProgressBar`.
     * Used to handle server-side rendering and to stub out during unit tests.
     * \@docs-private
     * @type {?}
     */
    var MAT_PROGRESS_BAR_LOCATION = new InjectionToken('mat-progress-bar-location', { providedIn: 'root', factory: MAT_PROGRESS_BAR_LOCATION_FACTORY });
    /**
     * \@docs-private
     * @return {?}
     */
    function MAT_PROGRESS_BAR_LOCATION_FACTORY() {
        /** @type {?} */
        var _document = inject(DOCUMENT);
        /** @type {?} */
        var _location = _document ? _document.location : null;
        return {
            // Note that this needs to be a function, rather than a property, because Angular
            // will only resolve it once, but we want the current path on each call.
            getPathname: ( /**
             * @return {?}
             */function () { return _location ? (_location.pathname + _location.search) : ''; })
        };
    }
    /**
     * Counter used to generate unique IDs for progress bars.
     * @type {?}
     */
    var progressbarId = 0;
    /**
     * `<mat-progress-bar>` component.
     */
    var MatProgressBar = /** @class */ (function (_super) {
        __extends(MatProgressBar, _super);
        /**
         * @param {?} _elementRef
         * @param {?} _ngZone
         * @param {?=} _animationMode
         * @param {?=} location
         */
        function MatProgressBar(_elementRef, _ngZone, _animationMode, 
        /**
         * @deprecated `location` parameter to be made required.
         * @breaking-change 8.0.0
         */
        location) {
            var _this = _super.call(this, _elementRef) || this;
            _this._elementRef = _elementRef;
            _this._ngZone = _ngZone;
            _this._animationMode = _animationMode;
            /**
             * Flag that indicates whether NoopAnimations mode is set to true.
             */
            _this._isNoopAnimation = false;
            _this._value = 0;
            _this._bufferValue = 0;
            /**
             * Event emitted when animation of the primary progress bar completes. This event will not
             * be emitted when animations are disabled, nor will it be emitted for modes with continuous
             * animations (indeterminate and query).
             */
            _this.animationEnd = new EventEmitter();
            /**
             * Reference to animation end subscription to be unsubscribed on destroy.
             */
            _this._animationEndSubscription = Subscription.EMPTY;
            /**
             * Mode of the progress bar.
             *
             * Input must be one of these values: determinate, indeterminate, buffer, query, defaults to
             * 'determinate'.
             * Mirrored to mode attribute.
             */
            _this.mode = 'determinate';
            /**
             * ID of the progress bar.
             */
            _this.progressbarId = "mat-progress-bar-" + progressbarId++;
            // We need to prefix the SVG reference with the current path, otherwise they won't work
            // in Safari if the page has a `<base>` tag. Note that we need quotes inside the `url()`,
            // because named route URLs can contain parentheses (see #12338). Also we don't use since
            // we can't tell the difference between whether
            // the consumer is using the hash location strategy or not, because `Location` normalizes
            // both `/#/foo/bar` and `/foo/bar` to the same thing.
            /** @type {?} */
            var path = location ? location.getPathname().split('#')[0] : '';
            _this._rectangleFillValue = "url('" + path + "#" + _this.progressbarId + "')";
            _this._isNoopAnimation = _animationMode === 'NoopAnimations';
            return _this;
        }
        Object.defineProperty(MatProgressBar.prototype, "value", {
            /**
             * Value of the progress bar. Defaults to zero. Mirrored to aria-valuenow.
             * @return {?}
             */
            get: function () { return this._value; },
            /**
             * @param {?} v
             * @return {?}
             */
            set: function (v) {
                this._value = clamp(v || 0);
                // When noop animation is set to true, trigger animationEnd directly.
                if (this._isNoopAnimation) {
                    this._emitAnimationEnd();
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatProgressBar.prototype, "bufferValue", {
            /**
             * Buffer value of the progress bar. Defaults to zero.
             * @return {?}
             */
            get: function () { return this._bufferValue; },
            /**
             * @param {?} v
             * @return {?}
             */
            set: function (v) { this._bufferValue = clamp(v || 0); },
            enumerable: true,
            configurable: true
        });
        /**
         * Gets the current transform value for the progress bar's primary indicator.
         * @return {?}
         */
        MatProgressBar.prototype._primaryTransform = function () {
            /** @type {?} */
            var scale = this.value / 100;
            return { transform: "scaleX(" + scale + ")" };
        };
        /**
         * Gets the current transform value for the progress bar's buffer indicator. Only used if the
         * progress mode is set to buffer, otherwise returns an undefined, causing no transformation.
         * @return {?}
         */
        MatProgressBar.prototype._bufferTransform = function () {
            if (this.mode === 'buffer') {
                /** @type {?} */
                var scale = this.bufferValue / 100;
                return { transform: "scaleX(" + scale + ")" };
            }
            return undefined;
        };
        /**
         * @return {?}
         */
        MatProgressBar.prototype.ngAfterViewInit = function () {
            var _this = this;
            if (!this._isNoopAnimation) {
                // Run outside angular so change detection didn't get triggered on every transition end
                // instead only on the animation that we care about (primary value bar's transitionend)
                this._ngZone.runOutsideAngular((( /**
                 * @return {?}
                 */function () {
                    /** @type {?} */
                    var element = _this._primaryValueBar.nativeElement;
                    _this._animationEndSubscription =
                        (( /** @type {?} */(fromEvent(element, 'transitionend'))))
                            .pipe(filter((( /**
                     * @param {?} e
                     * @return {?}
                     */function (e) { return e.target === element; }))))
                            .subscribe(( /**
                     * @return {?}
                     */function () { return _this._ngZone.run(( /**
                         * @return {?}
                         */function () { return _this._emitAnimationEnd(); })); }));
                })));
            }
        };
        /**
         * @return {?}
         */
        MatProgressBar.prototype.ngOnDestroy = function () {
            this._animationEndSubscription.unsubscribe();
        };
        /**
         * Emit an animationEnd event if in determinate or buffer mode.
         * @private
         * @return {?}
         */
        MatProgressBar.prototype._emitAnimationEnd = function () {
            if (this.mode === 'determinate' || this.mode === 'buffer') {
                this.animationEnd.next({ value: this.value });
            }
        };
        return MatProgressBar;
    }(_MatProgressBarMixinBase));
    MatProgressBar.decorators = [
        { type: Component, args: [{ selector: 'mat-progress-bar',
                    exportAs: 'matProgressBar',
                    host: {
                        'role': 'progressbar',
                        'aria-valuemin': '0',
                        'aria-valuemax': '100',
                        '[attr.aria-valuenow]': '(mode === "indeterminate" || mode === "query") ? null : value',
                        '[attr.mode]': 'mode',
                        'class': 'mat-progress-bar',
                        '[class._mat-animation-noopable]': '_isNoopAnimation',
                    },
                    inputs: ['color'],
                    template: "<svg width=\"100%\" height=\"4\" focusable=\"false\" class=\"mat-progress-bar-background mat-progress-bar-element\"><defs><pattern [id]=\"progressbarId\" x=\"4\" y=\"0\" width=\"8\" height=\"4\" patternUnits=\"userSpaceOnUse\"><circle cx=\"2\" cy=\"2\" r=\"2\"/></pattern></defs><rect [attr.fill]=\"_rectangleFillValue\" width=\"100%\" height=\"100%\"/></svg><div class=\"mat-progress-bar-buffer mat-progress-bar-element\" [ngStyle]=\"_bufferTransform()\"></div><div class=\"mat-progress-bar-primary mat-progress-bar-fill mat-progress-bar-element\" [ngStyle]=\"_primaryTransform()\" #primaryValueBar></div><div class=\"mat-progress-bar-secondary mat-progress-bar-fill mat-progress-bar-element\"></div>",
                    styles: [".mat-progress-bar{display:block;height:4px;overflow:hidden;position:relative;transition:opacity 250ms linear;width:100%}._mat-animation-noopable.mat-progress-bar{transition:none;animation:none}.mat-progress-bar .mat-progress-bar-element,.mat-progress-bar .mat-progress-bar-fill::after{height:100%;position:absolute;width:100%}.mat-progress-bar .mat-progress-bar-background{width:calc(100% + 10px)}@media (-ms-high-contrast:active){.mat-progress-bar .mat-progress-bar-background{display:none}}.mat-progress-bar .mat-progress-bar-buffer{transform-origin:top left;transition:transform 250ms ease}@media (-ms-high-contrast:active){.mat-progress-bar .mat-progress-bar-buffer{border-top:solid 5px;opacity:.5}}.mat-progress-bar .mat-progress-bar-secondary{display:none}.mat-progress-bar .mat-progress-bar-fill{animation:none;transform-origin:top left;transition:transform 250ms ease}@media (-ms-high-contrast:active){.mat-progress-bar .mat-progress-bar-fill{border-top:solid 4px}}.mat-progress-bar .mat-progress-bar-fill::after{animation:none;content:'';display:inline-block;left:0}.mat-progress-bar[dir=rtl],[dir=rtl] .mat-progress-bar{transform:rotateY(180deg)}.mat-progress-bar[mode=query]{transform:rotateZ(180deg)}.mat-progress-bar[mode=query][dir=rtl],[dir=rtl] .mat-progress-bar[mode=query]{transform:rotateZ(180deg) rotateY(180deg)}.mat-progress-bar[mode=indeterminate] .mat-progress-bar-fill,.mat-progress-bar[mode=query] .mat-progress-bar-fill{transition:none}.mat-progress-bar[mode=indeterminate] .mat-progress-bar-primary,.mat-progress-bar[mode=query] .mat-progress-bar-primary{-webkit-backface-visibility:hidden;backface-visibility:hidden;animation:mat-progress-bar-primary-indeterminate-translate 2s infinite linear;left:-145.166611%}.mat-progress-bar[mode=indeterminate] .mat-progress-bar-primary.mat-progress-bar-fill::after,.mat-progress-bar[mode=query] .mat-progress-bar-primary.mat-progress-bar-fill::after{-webkit-backface-visibility:hidden;backface-visibility:hidden;animation:mat-progress-bar-primary-indeterminate-scale 2s infinite linear}.mat-progress-bar[mode=indeterminate] .mat-progress-bar-secondary,.mat-progress-bar[mode=query] .mat-progress-bar-secondary{-webkit-backface-visibility:hidden;backface-visibility:hidden;animation:mat-progress-bar-secondary-indeterminate-translate 2s infinite linear;left:-54.888891%;display:block}.mat-progress-bar[mode=indeterminate] .mat-progress-bar-secondary.mat-progress-bar-fill::after,.mat-progress-bar[mode=query] .mat-progress-bar-secondary.mat-progress-bar-fill::after{-webkit-backface-visibility:hidden;backface-visibility:hidden;animation:mat-progress-bar-secondary-indeterminate-scale 2s infinite linear}.mat-progress-bar[mode=buffer] .mat-progress-bar-background{-webkit-backface-visibility:hidden;backface-visibility:hidden;animation:mat-progress-bar-background-scroll 250ms infinite linear;display:block}.mat-progress-bar._mat-animation-noopable .mat-progress-bar-background,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-buffer,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-fill,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-fill::after,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-primary,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-primary.mat-progress-bar-fill::after,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-secondary,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-secondary.mat-progress-bar-fill::after{animation:none;transition:none}@keyframes mat-progress-bar-primary-indeterminate-translate{0%{transform:translateX(0)}20%{animation-timing-function:cubic-bezier(.5,0,.70173,.49582);transform:translateX(0)}59.15%{animation-timing-function:cubic-bezier(.30244,.38135,.55,.95635);transform:translateX(83.67142%)}100%{transform:translateX(200.61106%)}}@keyframes mat-progress-bar-primary-indeterminate-scale{0%{transform:scaleX(.08)}36.65%{animation-timing-function:cubic-bezier(.33473,.12482,.78584,1);transform:scaleX(.08)}69.15%{animation-timing-function:cubic-bezier(.06,.11,.6,1);transform:scaleX(.66148)}100%{transform:scaleX(.08)}}@keyframes mat-progress-bar-secondary-indeterminate-translate{0%{animation-timing-function:cubic-bezier(.15,0,.51506,.40969);transform:translateX(0)}25%{animation-timing-function:cubic-bezier(.31033,.28406,.8,.73371);transform:translateX(37.65191%)}48.35%{animation-timing-function:cubic-bezier(.4,.62704,.6,.90203);transform:translateX(84.38617%)}100%{transform:translateX(160.27778%)}}@keyframes mat-progress-bar-secondary-indeterminate-scale{0%{animation-timing-function:cubic-bezier(.15,0,.51506,.40969);transform:scaleX(.08)}19.15%{animation-timing-function:cubic-bezier(.31033,.28406,.8,.73371);transform:scaleX(.4571)}44.15%{animation-timing-function:cubic-bezier(.4,.62704,.6,.90203);transform:scaleX(.72796)}100%{transform:scaleX(.08)}}@keyframes mat-progress-bar-background-scroll{to{transform:translateX(-8px)}}"],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                },] },
    ];
    /** @nocollapse */
    MatProgressBar.ctorParameters = function () { return [
        { type: ElementRef },
        { type: NgZone },
        { type: String, decorators: [{ type: Optional }, { type: Inject, args: [ANIMATION_MODULE_TYPE,] }] },
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [MAT_PROGRESS_BAR_LOCATION,] }] }
    ]; };
    MatProgressBar.propDecorators = {
        value: [{ type: Input }],
        bufferValue: [{ type: Input }],
        _primaryValueBar: [{ type: ViewChild, args: ['primaryValueBar', { static: false },] }],
        animationEnd: [{ type: Output }],
        mode: [{ type: Input }]
    };
    /**
     * Clamps a value to be between two numbers, by default 0 and 100.
     * @param {?} v
     * @param {?=} min
     * @param {?=} max
     * @return {?}
     */
    function clamp(v, min, max) {
        if (min === void 0) { min = 0; }
        if (max === void 0) { max = 100; }
        return Math.max(min, Math.min(max, v));
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatProgressBarModule = /** @class */ (function () {
        function MatProgressBarModule() {
        }
        return MatProgressBarModule;
    }());
    MatProgressBarModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule, MatCommonModule],
                    exports: [MatProgressBar, MatCommonModule],
                    declarations: [MatProgressBar],
                },] },
    ];
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Default color palette for round buttons (mat-fab and mat-mini-fab)
     * @type {?}
     */
    var DEFAULT_ROUND_BUTTON_COLOR = 'accent';
    /**
     * List of classes to add to MatButton instances based on host attributes to
     * style as different variants.
     * @type {?}
     */
    var BUTTON_HOST_ATTRIBUTES = [
        'mat-button',
        'mat-flat-button',
        'mat-icon-button',
        'mat-raised-button',
        'mat-stroked-button',
        'mat-mini-fab',
        'mat-fab',
    ];
    // Boilerplate for applying mixins to MatButton.
    /**
     * \@docs-private
     */
    var MatButtonBase = /** @class */ (function () {
        /**
         * @param {?} _elementRef
         */
        function MatButtonBase(_elementRef) {
            this._elementRef = _elementRef;
        }
        return MatButtonBase;
    }());
    /** @type {?} */
    var _MatButtonMixinBase = mixinColor(mixinDisabled(mixinDisableRipple(MatButtonBase)));
    /**
     * Material design button.
     */
    var MatButton = /** @class */ (function (_super) {
        __extends(MatButton, _super);
        /**
         * @param {?} elementRef
         * @param {?} _focusMonitor
         * @param {?} _animationMode
         */
        function MatButton(elementRef, _focusMonitor, _animationMode) {
            var e_9, _b;
            var _this = _super.call(this, elementRef) || this;
            _this._focusMonitor = _focusMonitor;
            _this._animationMode = _animationMode;
            /**
             * Whether the button is round.
             */
            _this.isRoundButton = _this._hasHostAttributes('mat-fab', 'mat-mini-fab');
            /**
             * Whether the button is icon button.
             */
            _this.isIconButton = _this._hasHostAttributes('mat-icon-button');
            try {
                // For each of the variant selectors that is present in the button's host
                // attributes, add the correct corresponding class.
                for (var BUTTON_HOST_ATTRIBUTES_1 = __values(BUTTON_HOST_ATTRIBUTES), BUTTON_HOST_ATTRIBUTES_1_1 = BUTTON_HOST_ATTRIBUTES_1.next(); !BUTTON_HOST_ATTRIBUTES_1_1.done; BUTTON_HOST_ATTRIBUTES_1_1 = BUTTON_HOST_ATTRIBUTES_1.next()) {
                    var attr = BUTTON_HOST_ATTRIBUTES_1_1.value;
                    if (_this._hasHostAttributes(attr)) {
                        (( /** @type {?} */(_this._getHostElement()))).classList.add(attr);
                    }
                }
            }
            catch (e_9_1) { e_9 = { error: e_9_1 }; }
            finally {
                try {
                    if (BUTTON_HOST_ATTRIBUTES_1_1 && !BUTTON_HOST_ATTRIBUTES_1_1.done && (_b = BUTTON_HOST_ATTRIBUTES_1.return)) _b.call(BUTTON_HOST_ATTRIBUTES_1);
                }
                finally { if (e_9) throw e_9.error; }
            }
            // Add a class that applies to all buttons. This makes it easier to target if somebody
            // wants to target all Material buttons. We do it here rather than `host` to ensure that
            // the class is applied to derived classes.
            elementRef.nativeElement.classList.add('mat-button-base');
            _this._focusMonitor.monitor(_this._elementRef, true);
            if (_this.isRoundButton) {
                _this.color = DEFAULT_ROUND_BUTTON_COLOR;
            }
            return _this;
        }
        /**
         * @return {?}
         */
        MatButton.prototype.ngOnDestroy = function () {
            this._focusMonitor.stopMonitoring(this._elementRef);
        };
        /**
         * Focuses the button.
         * @param {?=} origin
         * @param {?=} options
         * @return {?}
         */
        MatButton.prototype.focus = function (origin, options) {
            if (origin === void 0) { origin = 'program'; }
            this._focusMonitor.focusVia(this._getHostElement(), origin, options);
        };
        /**
         * @return {?}
         */
        MatButton.prototype._getHostElement = function () {
            return this._elementRef.nativeElement;
        };
        /**
         * @return {?}
         */
        MatButton.prototype._isRippleDisabled = function () {
            return this.disableRipple || this.disabled;
        };
        /**
         * Gets whether the button has one of the given attributes.
         * @param {...?} attributes
         * @return {?}
         */
        MatButton.prototype._hasHostAttributes = function () {
            var _this = this;
            var attributes = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                attributes[_i] = arguments[_i];
            }
            return attributes.some(( /**
             * @param {?} attribute
             * @return {?}
             */function (/**
             * @param {?} attribute
             * @return {?}
             */ attribute) { return _this._getHostElement().hasAttribute(attribute); }));
        };
        return MatButton;
    }(_MatButtonMixinBase));
    MatButton.decorators = [
        { type: Component, args: [{ selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],\n             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],\n             button[mat-flat-button]",
                    exportAs: 'matButton',
                    host: {
                        '[attr.disabled]': 'disabled || null',
                        '[class._mat-animation-noopable]': '_animationMode === "NoopAnimations"',
                    },
                    template: "<span class=\"mat-button-wrapper\"><ng-content></ng-content></span><div matRipple class=\"mat-button-ripple\" [class.mat-button-ripple-round]=\"isRoundButton || isIconButton\" [matRippleDisabled]=\"_isRippleDisabled()\" [matRippleCentered]=\"isIconButton\" [matRippleTrigger]=\"_getHostElement()\"></div><div class=\"mat-button-focus-overlay\"></div>",
                    styles: [".mat-button .mat-button-focus-overlay,.mat-icon-button .mat-button-focus-overlay{opacity:0}.mat-button:hover .mat-button-focus-overlay,.mat-stroked-button:hover .mat-button-focus-overlay{opacity:.04}@media (hover:none){.mat-button:hover .mat-button-focus-overlay,.mat-stroked-button:hover .mat-button-focus-overlay{opacity:0}}.mat-button,.mat-flat-button,.mat-icon-button,.mat-stroked-button{box-sizing:border-box;position:relative;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:pointer;outline:0;border:none;-webkit-tap-highlight-color:transparent;display:inline-block;white-space:nowrap;text-decoration:none;vertical-align:baseline;text-align:center;margin:0;min-width:64px;line-height:36px;padding:0 16px;border-radius:4px;overflow:visible}.mat-button::-moz-focus-inner,.mat-flat-button::-moz-focus-inner,.mat-icon-button::-moz-focus-inner,.mat-stroked-button::-moz-focus-inner{border:0}.mat-button[disabled],.mat-flat-button[disabled],.mat-icon-button[disabled],.mat-stroked-button[disabled]{cursor:default}.mat-button.cdk-keyboard-focused .mat-button-focus-overlay,.mat-button.cdk-program-focused .mat-button-focus-overlay,.mat-flat-button.cdk-keyboard-focused .mat-button-focus-overlay,.mat-flat-button.cdk-program-focused .mat-button-focus-overlay,.mat-icon-button.cdk-keyboard-focused .mat-button-focus-overlay,.mat-icon-button.cdk-program-focused .mat-button-focus-overlay,.mat-stroked-button.cdk-keyboard-focused .mat-button-focus-overlay,.mat-stroked-button.cdk-program-focused .mat-button-focus-overlay{opacity:.12}.mat-button::-moz-focus-inner,.mat-flat-button::-moz-focus-inner,.mat-icon-button::-moz-focus-inner,.mat-stroked-button::-moz-focus-inner{border:0}.mat-raised-button{box-sizing:border-box;position:relative;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:pointer;outline:0;border:none;-webkit-tap-highlight-color:transparent;display:inline-block;white-space:nowrap;text-decoration:none;vertical-align:baseline;text-align:center;margin:0;min-width:64px;line-height:36px;padding:0 16px;border-radius:4px;overflow:visible;transform:translate3d(0,0,0);transition:background .4s cubic-bezier(.25,.8,.25,1),box-shadow 280ms cubic-bezier(.4,0,.2,1)}.mat-raised-button::-moz-focus-inner{border:0}.mat-raised-button[disabled]{cursor:default}.mat-raised-button.cdk-keyboard-focused .mat-button-focus-overlay,.mat-raised-button.cdk-program-focused .mat-button-focus-overlay{opacity:.12}.mat-raised-button::-moz-focus-inner{border:0}._mat-animation-noopable.mat-raised-button{transition:none;animation:none}.mat-stroked-button{border:1px solid currentColor;padding:0 15px;line-height:34px}.mat-stroked-button .mat-button-focus-overlay,.mat-stroked-button .mat-button-ripple.mat-ripple{top:-1px;left:-1px;right:-1px;bottom:-1px}.mat-fab{box-sizing:border-box;position:relative;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:pointer;outline:0;border:none;-webkit-tap-highlight-color:transparent;display:inline-block;white-space:nowrap;text-decoration:none;vertical-align:baseline;text-align:center;margin:0;min-width:64px;line-height:36px;padding:0 16px;border-radius:4px;overflow:visible;transform:translate3d(0,0,0);transition:background .4s cubic-bezier(.25,.8,.25,1),box-shadow 280ms cubic-bezier(.4,0,.2,1);min-width:0;border-radius:50%;width:56px;height:56px;padding:0;flex-shrink:0}.mat-fab::-moz-focus-inner{border:0}.mat-fab[disabled]{cursor:default}.mat-fab.cdk-keyboard-focused .mat-button-focus-overlay,.mat-fab.cdk-program-focused .mat-button-focus-overlay{opacity:.12}.mat-fab::-moz-focus-inner{border:0}._mat-animation-noopable.mat-fab{transition:none;animation:none}.mat-fab .mat-button-wrapper{padding:16px 0;display:inline-block;line-height:24px}.mat-mini-fab{box-sizing:border-box;position:relative;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:pointer;outline:0;border:none;-webkit-tap-highlight-color:transparent;display:inline-block;white-space:nowrap;text-decoration:none;vertical-align:baseline;text-align:center;margin:0;min-width:64px;line-height:36px;padding:0 16px;border-radius:4px;overflow:visible;transform:translate3d(0,0,0);transition:background .4s cubic-bezier(.25,.8,.25,1),box-shadow 280ms cubic-bezier(.4,0,.2,1);min-width:0;border-radius:50%;width:40px;height:40px;padding:0;flex-shrink:0}.mat-mini-fab::-moz-focus-inner{border:0}.mat-mini-fab[disabled]{cursor:default}.mat-mini-fab.cdk-keyboard-focused .mat-button-focus-overlay,.mat-mini-fab.cdk-program-focused .mat-button-focus-overlay{opacity:.12}.mat-mini-fab::-moz-focus-inner{border:0}._mat-animation-noopable.mat-mini-fab{transition:none;animation:none}.mat-mini-fab .mat-button-wrapper{padding:8px 0;display:inline-block;line-height:24px}.mat-icon-button{padding:0;min-width:0;width:40px;height:40px;flex-shrink:0;line-height:40px;border-radius:50%}.mat-icon-button .mat-icon,.mat-icon-button i{line-height:24px}.mat-button-focus-overlay,.mat-button-ripple.mat-ripple{top:0;left:0;right:0;bottom:0;position:absolute;pointer-events:none;border-radius:inherit}.mat-button-ripple.mat-ripple:not(:empty){transform:translateZ(0)}.mat-button-focus-overlay{opacity:0;transition:opacity .2s cubic-bezier(.35,0,.25,1),background-color .2s cubic-bezier(.35,0,.25,1)}._mat-animation-noopable .mat-button-focus-overlay{transition:none}@media (-ms-high-contrast:active){.mat-button-focus-overlay{background-color:#fff}}@media (-ms-high-contrast:black-on-white){.mat-button-focus-overlay{background-color:#000}}.mat-button-ripple-round{border-radius:50%;z-index:1}.mat-button .mat-button-wrapper>*,.mat-fab .mat-button-wrapper>*,.mat-flat-button .mat-button-wrapper>*,.mat-icon-button .mat-button-wrapper>*,.mat-mini-fab .mat-button-wrapper>*,.mat-raised-button .mat-button-wrapper>*,.mat-stroked-button .mat-button-wrapper>*{vertical-align:middle}.mat-form-field:not(.mat-form-field-appearance-legacy) .mat-form-field-prefix .mat-icon-button,.mat-form-field:not(.mat-form-field-appearance-legacy) .mat-form-field-suffix .mat-icon-button{display:block;font-size:inherit;width:2.5em;height:2.5em}@media (-ms-high-contrast:active){.mat-button,.mat-fab,.mat-flat-button,.mat-icon-button,.mat-mini-fab,.mat-raised-button{outline:solid 1px}}"],
                    inputs: ['disabled', 'disableRipple', 'color'],
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                },] },
    ];
    /** @nocollapse */
    MatButton.ctorParameters = function () { return [
        { type: ElementRef },
        { type: FocusMonitor },
        { type: String, decorators: [{ type: Optional }, { type: Inject, args: [ANIMATION_MODULE_TYPE,] }] }
    ]; };
    MatButton.propDecorators = {
        ripple: [{ type: ViewChild, args: [MatRipple, { static: false },] }]
    };
    /**
     * Material design anchor button.
     */
    var MatAnchor = /** @class */ (function (_super) {
        __extends(MatAnchor, _super);
        /**
         * @param {?} focusMonitor
         * @param {?} elementRef
         * @param {?} animationMode
         */
        function MatAnchor(focusMonitor, elementRef, animationMode) {
            return _super.call(this, elementRef, focusMonitor, animationMode) || this;
        }
        /**
         * @param {?} event
         * @return {?}
         */
        MatAnchor.prototype._haltDisabledEvents = function (event) {
            // A disabled button shouldn't apply any actions
            if (this.disabled) {
                event.preventDefault();
                event.stopImmediatePropagation();
            }
        };
        return MatAnchor;
    }(MatButton));
    MatAnchor.decorators = [
        { type: Component, args: [{ selector: "a[mat-button], a[mat-raised-button], a[mat-icon-button], a[mat-fab],\n             a[mat-mini-fab], a[mat-stroked-button], a[mat-flat-button]",
                    exportAs: 'matButton, matAnchor',
                    host: {
                        // Note that we ignore the user-specified tabindex when it's disabled for
                        // consistency with the `mat-button` applied on native buttons where even
                        // though they have an index, they're not tabbable.
                        '[attr.tabindex]': 'disabled ? -1 : (tabIndex || 0)',
                        '[attr.disabled]': 'disabled || null',
                        '[attr.aria-disabled]': 'disabled.toString()',
                        '(click)': '_haltDisabledEvents($event)',
                        '[class._mat-animation-noopable]': '_animationMode === "NoopAnimations"',
                    },
                    inputs: ['disabled', 'disableRipple', 'color'],
                    template: "<span class=\"mat-button-wrapper\"><ng-content></ng-content></span><div matRipple class=\"mat-button-ripple\" [class.mat-button-ripple-round]=\"isRoundButton || isIconButton\" [matRippleDisabled]=\"_isRippleDisabled()\" [matRippleCentered]=\"isIconButton\" [matRippleTrigger]=\"_getHostElement()\"></div><div class=\"mat-button-focus-overlay\"></div>",
                    styles: [".mat-button .mat-button-focus-overlay,.mat-icon-button .mat-button-focus-overlay{opacity:0}.mat-button:hover .mat-button-focus-overlay,.mat-stroked-button:hover .mat-button-focus-overlay{opacity:.04}@media (hover:none){.mat-button:hover .mat-button-focus-overlay,.mat-stroked-button:hover .mat-button-focus-overlay{opacity:0}}.mat-button,.mat-flat-button,.mat-icon-button,.mat-stroked-button{box-sizing:border-box;position:relative;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:pointer;outline:0;border:none;-webkit-tap-highlight-color:transparent;display:inline-block;white-space:nowrap;text-decoration:none;vertical-align:baseline;text-align:center;margin:0;min-width:64px;line-height:36px;padding:0 16px;border-radius:4px;overflow:visible}.mat-button::-moz-focus-inner,.mat-flat-button::-moz-focus-inner,.mat-icon-button::-moz-focus-inner,.mat-stroked-button::-moz-focus-inner{border:0}.mat-button[disabled],.mat-flat-button[disabled],.mat-icon-button[disabled],.mat-stroked-button[disabled]{cursor:default}.mat-button.cdk-keyboard-focused .mat-button-focus-overlay,.mat-button.cdk-program-focused .mat-button-focus-overlay,.mat-flat-button.cdk-keyboard-focused .mat-button-focus-overlay,.mat-flat-button.cdk-program-focused .mat-button-focus-overlay,.mat-icon-button.cdk-keyboard-focused .mat-button-focus-overlay,.mat-icon-button.cdk-program-focused .mat-button-focus-overlay,.mat-stroked-button.cdk-keyboard-focused .mat-button-focus-overlay,.mat-stroked-button.cdk-program-focused .mat-button-focus-overlay{opacity:.12}.mat-button::-moz-focus-inner,.mat-flat-button::-moz-focus-inner,.mat-icon-button::-moz-focus-inner,.mat-stroked-button::-moz-focus-inner{border:0}.mat-raised-button{box-sizing:border-box;position:relative;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:pointer;outline:0;border:none;-webkit-tap-highlight-color:transparent;display:inline-block;white-space:nowrap;text-decoration:none;vertical-align:baseline;text-align:center;margin:0;min-width:64px;line-height:36px;padding:0 16px;border-radius:4px;overflow:visible;transform:translate3d(0,0,0);transition:background .4s cubic-bezier(.25,.8,.25,1),box-shadow 280ms cubic-bezier(.4,0,.2,1)}.mat-raised-button::-moz-focus-inner{border:0}.mat-raised-button[disabled]{cursor:default}.mat-raised-button.cdk-keyboard-focused .mat-button-focus-overlay,.mat-raised-button.cdk-program-focused .mat-button-focus-overlay{opacity:.12}.mat-raised-button::-moz-focus-inner{border:0}._mat-animation-noopable.mat-raised-button{transition:none;animation:none}.mat-stroked-button{border:1px solid currentColor;padding:0 15px;line-height:34px}.mat-stroked-button .mat-button-focus-overlay,.mat-stroked-button .mat-button-ripple.mat-ripple{top:-1px;left:-1px;right:-1px;bottom:-1px}.mat-fab{box-sizing:border-box;position:relative;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:pointer;outline:0;border:none;-webkit-tap-highlight-color:transparent;display:inline-block;white-space:nowrap;text-decoration:none;vertical-align:baseline;text-align:center;margin:0;min-width:64px;line-height:36px;padding:0 16px;border-radius:4px;overflow:visible;transform:translate3d(0,0,0);transition:background .4s cubic-bezier(.25,.8,.25,1),box-shadow 280ms cubic-bezier(.4,0,.2,1);min-width:0;border-radius:50%;width:56px;height:56px;padding:0;flex-shrink:0}.mat-fab::-moz-focus-inner{border:0}.mat-fab[disabled]{cursor:default}.mat-fab.cdk-keyboard-focused .mat-button-focus-overlay,.mat-fab.cdk-program-focused .mat-button-focus-overlay{opacity:.12}.mat-fab::-moz-focus-inner{border:0}._mat-animation-noopable.mat-fab{transition:none;animation:none}.mat-fab .mat-button-wrapper{padding:16px 0;display:inline-block;line-height:24px}.mat-mini-fab{box-sizing:border-box;position:relative;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:pointer;outline:0;border:none;-webkit-tap-highlight-color:transparent;display:inline-block;white-space:nowrap;text-decoration:none;vertical-align:baseline;text-align:center;margin:0;min-width:64px;line-height:36px;padding:0 16px;border-radius:4px;overflow:visible;transform:translate3d(0,0,0);transition:background .4s cubic-bezier(.25,.8,.25,1),box-shadow 280ms cubic-bezier(.4,0,.2,1);min-width:0;border-radius:50%;width:40px;height:40px;padding:0;flex-shrink:0}.mat-mini-fab::-moz-focus-inner{border:0}.mat-mini-fab[disabled]{cursor:default}.mat-mini-fab.cdk-keyboard-focused .mat-button-focus-overlay,.mat-mini-fab.cdk-program-focused .mat-button-focus-overlay{opacity:.12}.mat-mini-fab::-moz-focus-inner{border:0}._mat-animation-noopable.mat-mini-fab{transition:none;animation:none}.mat-mini-fab .mat-button-wrapper{padding:8px 0;display:inline-block;line-height:24px}.mat-icon-button{padding:0;min-width:0;width:40px;height:40px;flex-shrink:0;line-height:40px;border-radius:50%}.mat-icon-button .mat-icon,.mat-icon-button i{line-height:24px}.mat-button-focus-overlay,.mat-button-ripple.mat-ripple{top:0;left:0;right:0;bottom:0;position:absolute;pointer-events:none;border-radius:inherit}.mat-button-ripple.mat-ripple:not(:empty){transform:translateZ(0)}.mat-button-focus-overlay{opacity:0;transition:opacity .2s cubic-bezier(.35,0,.25,1),background-color .2s cubic-bezier(.35,0,.25,1)}._mat-animation-noopable .mat-button-focus-overlay{transition:none}@media (-ms-high-contrast:active){.mat-button-focus-overlay{background-color:#fff}}@media (-ms-high-contrast:black-on-white){.mat-button-focus-overlay{background-color:#000}}.mat-button-ripple-round{border-radius:50%;z-index:1}.mat-button .mat-button-wrapper>*,.mat-fab .mat-button-wrapper>*,.mat-flat-button .mat-button-wrapper>*,.mat-icon-button .mat-button-wrapper>*,.mat-mini-fab .mat-button-wrapper>*,.mat-raised-button .mat-button-wrapper>*,.mat-stroked-button .mat-button-wrapper>*{vertical-align:middle}.mat-form-field:not(.mat-form-field-appearance-legacy) .mat-form-field-prefix .mat-icon-button,.mat-form-field:not(.mat-form-field-appearance-legacy) .mat-form-field-suffix .mat-icon-button{display:block;font-size:inherit;width:2.5em;height:2.5em}@media (-ms-high-contrast:active){.mat-button,.mat-fab,.mat-flat-button,.mat-icon-button,.mat-mini-fab,.mat-raised-button{outline:solid 1px}}"],
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                },] },
    ];
    /** @nocollapse */
    MatAnchor.ctorParameters = function () { return [
        { type: FocusMonitor },
        { type: ElementRef },
        { type: String, decorators: [{ type: Optional }, { type: Inject, args: [ANIMATION_MODULE_TYPE,] }] }
    ]; };
    MatAnchor.propDecorators = {
        tabIndex: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatButtonModule = /** @class */ (function () {
        function MatButtonModule() {
        }
        return MatButtonModule;
    }());
    MatButtonModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        MatRippleModule,
                        MatCommonModule,
                    ],
                    exports: [
                        MatButton,
                        MatAnchor,
                        MatCommonModule,
                    ],
                    declarations: [
                        MatButton,
                        MatAnchor,
                    ],
                },] },
    ];
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Throws an exception when attempting to attach a null portal to a host.
     * \@docs-private
     * @return {?}
     */
    function throwNullPortalError() {
        throw Error('Must provide a portal to attach');
    }
    /**
     * Throws an exception when attempting to attach a portal to a host that is already attached.
     * \@docs-private
     * @return {?}
     */
    function throwPortalAlreadyAttachedError() {
        throw Error('Host already has a portal attached');
    }
    /**
     * Throws an exception when attempting to attach a portal to an already-disposed host.
     * \@docs-private
     * @return {?}
     */
    function throwPortalOutletAlreadyDisposedError() {
        throw Error('This PortalOutlet has already been disposed');
    }
    /**
     * Throws an exception when attempting to attach an unknown portal type.
     * \@docs-private
     * @return {?}
     */
    function throwUnknownPortalTypeError() {
        throw Error('Attempting to attach an unknown Portal type. BasePortalOutlet accepts either ' +
            'a ComponentPortal or a TemplatePortal.');
    }
    /**
     * Throws an exception when attempting to attach a portal to a null host.
     * \@docs-private
     * @return {?}
     */
    function throwNullPortalOutletError() {
        throw Error('Attempting to attach a portal to a null PortalOutlet');
    }
    /**
     * Throws an exception when attempting to detach a portal that is not attached.
     * \@docs-private
     * @return {?}
     */
    function throwNoPortalAttachedError() {
        throw Error('Attempting to detach a portal that is not attached to a host');
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A `Portal` is something that you want to render somewhere else.
     * It can be attach to / detached from a `PortalOutlet`.
     * @abstract
     * @template T
     */
    var Portal = /** @class */ (function () {
        function Portal() {
        }
        /**
         * Attach this portal to a host.
         * @param {?} host
         * @return {?}
         */
        Portal.prototype.attach = function (host) {
            if (host == null) {
                throwNullPortalOutletError();
            }
            if (host.hasAttached()) {
                throwPortalAlreadyAttachedError();
            }
            this._attachedHost = host;
            return ( /** @type {?} */(host.attach(this)));
        };
        /**
         * Detach this portal from its host
         * @return {?}
         */
        Portal.prototype.detach = function () {
            /** @type {?} */
            var host = this._attachedHost;
            if (host == null) {
                throwNoPortalAttachedError();
            }
            else {
                this._attachedHost = null;
                host.detach();
            }
        };
        Object.defineProperty(Portal.prototype, "isAttached", {
            /**
             * Whether this portal is attached to a host.
             * @return {?}
             */
            get: function () {
                return this._attachedHost != null;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Sets the PortalOutlet reference without performing `attach()`. This is used directly by
         * the PortalOutlet when it is performing an `attach()` or `detach()`.
         * @param {?} host
         * @return {?}
         */
        Portal.prototype.setAttachedHost = function (host) {
            this._attachedHost = host;
        };
        return Portal;
    }());
    /**
     * A `ComponentPortal` is a portal that instantiates some Component upon attachment.
     * @template T
     */
    var ComponentPortal = /** @class */ (function (_super) {
        __extends(ComponentPortal, _super);
        /**
         * @param {?} component
         * @param {?=} viewContainerRef
         * @param {?=} injector
         * @param {?=} componentFactoryResolver
         */
        function ComponentPortal(component, viewContainerRef, injector, componentFactoryResolver) {
            var _this = _super.call(this) || this;
            _this.component = component;
            _this.viewContainerRef = viewContainerRef;
            _this.injector = injector;
            _this.componentFactoryResolver = componentFactoryResolver;
            return _this;
        }
        return ComponentPortal;
    }(Portal));
    /**
     * A `TemplatePortal` is a portal that represents some embedded template (TemplateRef).
     * @template C
     */
    var TemplatePortal = /** @class */ (function (_super) {
        __extends(TemplatePortal, _super);
        /**
         * @param {?} template
         * @param {?} viewContainerRef
         * @param {?=} context
         */
        function TemplatePortal(template, viewContainerRef, context) {
            var _this = _super.call(this) || this;
            _this.templateRef = template;
            _this.viewContainerRef = viewContainerRef;
            _this.context = context;
            return _this;
        }
        Object.defineProperty(TemplatePortal.prototype, "origin", {
            /**
             * @return {?}
             */
            get: function () {
                return this.templateRef.elementRef;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Attach the portal to the provided `PortalOutlet`.
         * When a context is provided it will override the `context` property of the `TemplatePortal`
         * instance.
         * @param {?} host
         * @param {?=} context
         * @return {?}
         */
        TemplatePortal.prototype.attach = function (host, context) {
            if (context === void 0) { context = this.context; }
            this.context = context;
            return _super.prototype.attach.call(this, host);
        };
        /**
         * @return {?}
         */
        TemplatePortal.prototype.detach = function () {
            this.context = undefined;
            return _super.prototype.detach.call(this);
        };
        return TemplatePortal;
    }(Portal));
    /**
     * Partial implementation of PortalOutlet that handles attaching
     * ComponentPortal and TemplatePortal.
     * @abstract
     */
    var BasePortalOutlet = /** @class */ (function () {
        function BasePortalOutlet() {
            /**
             * Whether this host has already been permanently disposed.
             */
            this._isDisposed = false;
        }
        /**
         * Whether this host has an attached portal.
         * @return {?}
         */
        BasePortalOutlet.prototype.hasAttached = function () {
            return !!this._attachedPortal;
        };
        /**
         * Attaches a portal.
         * @param {?} portal
         * @return {?}
         */
        BasePortalOutlet.prototype.attach = function (portal) {
            if (!portal) {
                throwNullPortalError();
            }
            if (this.hasAttached()) {
                throwPortalAlreadyAttachedError();
            }
            if (this._isDisposed) {
                throwPortalOutletAlreadyDisposedError();
            }
            if (portal instanceof ComponentPortal) {
                this._attachedPortal = portal;
                return this.attachComponentPortal(portal);
            }
            else if (portal instanceof TemplatePortal) {
                this._attachedPortal = portal;
                return this.attachTemplatePortal(portal);
            }
            throwUnknownPortalTypeError();
        };
        /**
         * Detaches a previously attached portal.
         * @return {?}
         */
        BasePortalOutlet.prototype.detach = function () {
            if (this._attachedPortal) {
                this._attachedPortal.setAttachedHost(null);
                this._attachedPortal = null;
            }
            this._invokeDisposeFn();
        };
        /**
         * Permanently dispose of this portal host.
         * @return {?}
         */
        BasePortalOutlet.prototype.dispose = function () {
            if (this.hasAttached()) {
                this.detach();
            }
            this._invokeDisposeFn();
            this._isDisposed = true;
        };
        /**
         * \@docs-private
         * @param {?} fn
         * @return {?}
         */
        BasePortalOutlet.prototype.setDisposeFn = function (fn) {
            this._disposeFn = fn;
        };
        /**
         * @private
         * @return {?}
         */
        BasePortalOutlet.prototype._invokeDisposeFn = function () {
            if (this._disposeFn) {
                this._disposeFn();
                this._disposeFn = null;
            }
        };
        return BasePortalOutlet;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A PortalOutlet for attaching portals to an arbitrary DOM element outside of the Angular
     * application context.
     */
    var DomPortalOutlet = /** @class */ (function (_super) {
        __extends(DomPortalOutlet, _super);
        /**
         * @param {?} outletElement
         * @param {?} _componentFactoryResolver
         * @param {?} _appRef
         * @param {?} _defaultInjector
         */
        function DomPortalOutlet(outletElement, _componentFactoryResolver, _appRef, _defaultInjector) {
            var _this = _super.call(this) || this;
            _this.outletElement = outletElement;
            _this._componentFactoryResolver = _componentFactoryResolver;
            _this._appRef = _appRef;
            _this._defaultInjector = _defaultInjector;
            return _this;
        }
        /**
         * Attach the given ComponentPortal to DOM element using the ComponentFactoryResolver.
         * @template T
         * @param {?} portal Portal to be attached
         * @return {?} Reference to the created component.
         */
        DomPortalOutlet.prototype.attachComponentPortal = function (portal) {
            var _this = this;
            /** @type {?} */
            var resolver = portal.componentFactoryResolver || this._componentFactoryResolver;
            /** @type {?} */
            var componentFactory = resolver.resolveComponentFactory(portal.component);
            /** @type {?} */
            var componentRef;
            // If the portal specifies a ViewContainerRef, we will use that as the attachment point
            // for the component (in terms of Angular's component tree, not rendering).
            // When the ViewContainerRef is missing, we use the factory to create the component directly
            // and then manually attach the view to the application.
            if (portal.viewContainerRef) {
                componentRef = portal.viewContainerRef.createComponent(componentFactory, portal.viewContainerRef.length, portal.injector || portal.viewContainerRef.injector);
                this.setDisposeFn(( /**
                 * @return {?}
                 */function () { return componentRef.destroy(); }));
            }
            else {
                componentRef = componentFactory.create(portal.injector || this._defaultInjector);
                this._appRef.attachView(componentRef.hostView);
                this.setDisposeFn(( /**
                 * @return {?}
                 */function () {
                    _this._appRef.detachView(componentRef.hostView);
                    componentRef.destroy();
                }));
            }
            // At this point the component has been instantiated, so we move it to the location in the DOM
            // where we want it to be rendered.
            this.outletElement.appendChild(this._getComponentRootNode(componentRef));
            return componentRef;
        };
        /**
         * Attaches a template portal to the DOM as an embedded view.
         * @template C
         * @param {?} portal Portal to be attached.
         * @return {?} Reference to the created embedded view.
         */
        DomPortalOutlet.prototype.attachTemplatePortal = function (portal) {
            var _this = this;
            /** @type {?} */
            var viewContainer = portal.viewContainerRef;
            /** @type {?} */
            var viewRef = viewContainer.createEmbeddedView(portal.templateRef, portal.context);
            viewRef.detectChanges();
            // The method `createEmbeddedView` will add the view as a child of the viewContainer.
            // But for the DomPortalOutlet the view can be added everywhere in the DOM
            // (e.g Overlay Container) To move the view to the specified host element. We just
            // re-append the existing root nodes.
            viewRef.rootNodes.forEach(( /**
             * @param {?} rootNode
             * @return {?}
             */function (/**
             * @param {?} rootNode
             * @return {?}
             */ rootNode) { return _this.outletElement.appendChild(rootNode); }));
            this.setDisposeFn((( /**
             * @return {?}
             */function () {
                /** @type {?} */
                var index = viewContainer.indexOf(viewRef);
                if (index !== -1) {
                    viewContainer.remove(index);
                }
            })));
            // TODO(jelbourn): Return locals from view.
            return viewRef;
        };
        /**
         * Clears out a portal from the DOM.
         * @return {?}
         */
        DomPortalOutlet.prototype.dispose = function () {
            _super.prototype.dispose.call(this);
            if (this.outletElement.parentNode != null) {
                this.outletElement.parentNode.removeChild(this.outletElement);
            }
        };
        /**
         * Gets the root HTMLElement for an instantiated component.
         * @private
         * @param {?} componentRef
         * @return {?}
         */
        DomPortalOutlet.prototype._getComponentRootNode = function (componentRef) {
            return ( /** @type {?} */((( /** @type {?} */(componentRef.hostView))).rootNodes[0]));
        };
        return DomPortalOutlet;
    }(BasePortalOutlet));
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Directive version of a `TemplatePortal`. Because the directive *is* a TemplatePortal,
     * the directive instance itself can be attached to a host, enabling declarative use of portals.
     */
    var CdkPortal = /** @class */ (function (_super) {
        __extends(CdkPortal, _super);
        /**
         * @param {?} templateRef
         * @param {?} viewContainerRef
         */
        function CdkPortal(templateRef, viewContainerRef) {
            return _super.call(this, templateRef, viewContainerRef) || this;
        }
        return CdkPortal;
    }(TemplatePortal));
    CdkPortal.decorators = [
        { type: Directive, args: [{
                    selector: '[cdkPortal]',
                    exportAs: 'cdkPortal',
                },] },
    ];
    /** @nocollapse */
    CdkPortal.ctorParameters = function () { return [
        { type: TemplateRef },
        { type: ViewContainerRef }
    ]; };
    /**
     * @deprecated Use `CdkPortal` instead.
     * \@breaking-change 9.0.0
     */
    var TemplatePortalDirective = /** @class */ (function (_super) {
        __extends(TemplatePortalDirective, _super);
        function TemplatePortalDirective() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return TemplatePortalDirective;
    }(CdkPortal));
    TemplatePortalDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[cdk-portal], [portal]',
                    exportAs: 'cdkPortal',
                    providers: [{
                            provide: CdkPortal,
                            useExisting: TemplatePortalDirective
                        }]
                },] },
    ];
    /**
     * Directive version of a PortalOutlet. Because the directive *is* a PortalOutlet, portals can be
     * directly attached to it, enabling declarative use.
     *
     * Usage:
     * `<ng-template [cdkPortalOutlet]="greeting"></ng-template>`
     */
    var CdkPortalOutlet = /** @class */ (function (_super) {
        __extends(CdkPortalOutlet, _super);
        /**
         * @param {?} _componentFactoryResolver
         * @param {?} _viewContainerRef
         */
        function CdkPortalOutlet(_componentFactoryResolver, _viewContainerRef) {
            var _this = _super.call(this) || this;
            _this._componentFactoryResolver = _componentFactoryResolver;
            _this._viewContainerRef = _viewContainerRef;
            /**
             * Whether the portal component is initialized.
             */
            _this._isInitialized = false;
            /**
             * Emits when a portal is attached to the outlet.
             */
            _this.attached = new EventEmitter();
            return _this;
        }
        Object.defineProperty(CdkPortalOutlet.prototype, "portal", {
            /**
             * Portal associated with the Portal outlet.
             * @return {?}
             */
            get: function () {
                return this._attachedPortal;
            },
            /**
             * @param {?} portal
             * @return {?}
             */
            set: function (portal) {
                // Ignore the cases where the `portal` is set to a falsy value before the lifecycle hooks have
                // run. This handles the cases where the user might do something like `<div cdkPortalOutlet>`
                // and attach a portal programmatically in the parent component. When Angular does the first CD
                // round, it will fire the setter with empty string, causing the user's content to be cleared.
                if (this.hasAttached() && !portal && !this._isInitialized) {
                    return;
                }
                if (this.hasAttached()) {
                    _super.prototype.detach.call(this);
                }
                if (portal) {
                    _super.prototype.attach.call(this, portal);
                }
                this._attachedPortal = portal;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CdkPortalOutlet.prototype, "attachedRef", {
            /**
             * Component or view reference that is attached to the portal.
             * @return {?}
             */
            get: function () {
                return this._attachedRef;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        CdkPortalOutlet.prototype.ngOnInit = function () {
            this._isInitialized = true;
        };
        /**
         * @return {?}
         */
        CdkPortalOutlet.prototype.ngOnDestroy = function () {
            _super.prototype.dispose.call(this);
            this._attachedPortal = null;
            this._attachedRef = null;
        };
        /**
         * Attach the given ComponentPortal to this PortalOutlet using the ComponentFactoryResolver.
         *
         * @template T
         * @param {?} portal Portal to be attached to the portal outlet.
         * @return {?} Reference to the created component.
         */
        CdkPortalOutlet.prototype.attachComponentPortal = function (portal) {
            portal.setAttachedHost(this);
            // If the portal specifies an origin, use that as the logical location of the component
            // in the application tree. Otherwise use the location of this PortalOutlet.
            /** @type {?} */
            var viewContainerRef = portal.viewContainerRef != null ?
                portal.viewContainerRef :
                this._viewContainerRef;
            /** @type {?} */
            var resolver = portal.componentFactoryResolver || this._componentFactoryResolver;
            /** @type {?} */
            var componentFactory = resolver.resolveComponentFactory(portal.component);
            /** @type {?} */
            var ref = viewContainerRef.createComponent(componentFactory, viewContainerRef.length, portal.injector || viewContainerRef.injector);
            _super.prototype.setDisposeFn.call(this, ( /**
             * @return {?}
             */function () { return ref.destroy(); }));
            this._attachedPortal = portal;
            this._attachedRef = ref;
            this.attached.emit(ref);
            return ref;
        };
        /**
         * Attach the given TemplatePortal to this PortlHost as an embedded View.
         * @template C
         * @param {?} portal Portal to be attached.
         * @return {?} Reference to the created embedded view.
         */
        CdkPortalOutlet.prototype.attachTemplatePortal = function (portal) {
            var _this = this;
            portal.setAttachedHost(this);
            /** @type {?} */
            var viewRef = this._viewContainerRef.createEmbeddedView(portal.templateRef, portal.context);
            _super.prototype.setDisposeFn.call(this, ( /**
             * @return {?}
             */function () { return _this._viewContainerRef.clear(); }));
            this._attachedPortal = portal;
            this._attachedRef = viewRef;
            this.attached.emit(viewRef);
            return viewRef;
        };
        return CdkPortalOutlet;
    }(BasePortalOutlet));
    CdkPortalOutlet.decorators = [
        { type: Directive, args: [{
                    selector: '[cdkPortalOutlet]',
                    exportAs: 'cdkPortalOutlet',
                    inputs: ['portal: cdkPortalOutlet']
                },] },
    ];
    /** @nocollapse */
    CdkPortalOutlet.ctorParameters = function () { return [
        { type: ComponentFactoryResolver },
        { type: ViewContainerRef }
    ]; };
    CdkPortalOutlet.propDecorators = {
        attached: [{ type: Output }]
    };
    /**
     * @deprecated Use `CdkPortalOutlet` instead.
     * \@breaking-change 9.0.0
     */
    var PortalHostDirective = /** @class */ (function (_super) {
        __extends(PortalHostDirective, _super);
        function PortalHostDirective() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return PortalHostDirective;
    }(CdkPortalOutlet));
    PortalHostDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[cdkPortalHost], [portalHost]',
                    exportAs: 'cdkPortalHost',
                    inputs: ['portal: cdkPortalHost'],
                    providers: [{
                            provide: CdkPortalOutlet,
                            useExisting: PortalHostDirective
                        }]
                },] },
    ];
    var PortalModule = /** @class */ (function () {
        function PortalModule() {
        }
        return PortalModule;
    }());
    PortalModule.decorators = [
        { type: NgModule, args: [{
                    exports: [CdkPortal, CdkPortalOutlet, TemplatePortalDirective, PortalHostDirective],
                    declarations: [CdkPortal, CdkPortalOutlet, TemplatePortalDirective, PortalHostDirective],
                },] },
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Custom injector to be used when providing custom
     * injection tokens to components inside a portal.
     * \@docs-private
     */
    var PortalInjector = /** @class */ (function () {
        /**
         * @param {?} _parentInjector
         * @param {?} _customTokens
         */
        function PortalInjector(_parentInjector, _customTokens) {
            this._parentInjector = _parentInjector;
            this._customTokens = _customTokens;
        }
        /**
         * @param {?} token
         * @param {?=} notFoundValue
         * @return {?}
         */
        PortalInjector.prototype.get = function (token, notFoundValue) {
            /** @type {?} */
            var value = this._customTokens.get(token);
            if (typeof value !== 'undefined') {
                return value;
            }
            return this._parentInjector.get(token, notFoundValue);
        };
        return PortalInjector;
    }());
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     * @template T
     */
    var DataSource = /** @class */ (function () {
        function DataSource() {
        }
        return DataSource;
    }());
    /**
     * Checks whether an object is a data source.
     * @param {?} value
     * @return {?}
     */
    function isDataSource(value) {
        // Check if the value is a DataSource by observing if it has a connect function. Cannot
        // be checked as an `instanceof DataSource` since people could create their own sources
        // that match the interface, but don't extend DataSource.
        return value && typeof value.connect === 'function';
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * DataSource wrapper for a native array.
     * @template T
     */
    var ArrayDataSource = /** @class */ (function (_super) {
        __extends(ArrayDataSource, _super);
        /**
         * @param {?} _data
         */
        function ArrayDataSource(_data) {
            var _this = _super.call(this) || this;
            _this._data = _data;
            return _this;
        }
        /**
         * @return {?}
         */
        ArrayDataSource.prototype.connect = function () {
            return this._data instanceof Observable ? this._data : of(this._data);
        };
        /**
         * @return {?}
         */
        ArrayDataSource.prototype.disconnect = function () { };
        return ArrayDataSource;
    }(DataSource));
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Class to be used to power selecting one or more options from a list.
     * @template T
     */
    var SelectionModel = /** @class */ (function () {
        /**
         * @param {?=} _multiple
         * @param {?=} initiallySelectedValues
         * @param {?=} _emitChanges
         */
        function SelectionModel(_multiple, initiallySelectedValues, _emitChanges) {
            if (_multiple === void 0) { _multiple = false; }
            if (_emitChanges === void 0) { _emitChanges = true; }
            var _this = this;
            this._multiple = _multiple;
            this._emitChanges = _emitChanges;
            /**
             * Currently-selected values.
             */
            this._selection = new Set();
            /**
             * Keeps track of the deselected options that haven't been emitted by the change event.
             */
            this._deselectedToEmit = [];
            /**
             * Keeps track of the selected options that haven't been emitted by the change event.
             */
            this._selectedToEmit = [];
            /**
             * Event emitted when the value has changed.
             */
            this.changed = new Subject();
            /**
             * Event emitted when the value has changed.
             * @deprecated Use `changed` instead.
             * \@breaking-change 8.0.0 To be changed to `changed`
             */
            this.onChange = this.changed;
            if (initiallySelectedValues && initiallySelectedValues.length) {
                if (_multiple) {
                    initiallySelectedValues.forEach(( /**
                     * @param {?} value
                     * @return {?}
                     */function (/**
                     * @param {?} value
                     * @return {?}
                     */ value) { return _this._markSelected(value); }));
                }
                else {
                    this._markSelected(initiallySelectedValues[0]);
                }
                // Clear the array in order to avoid firing the change event for preselected values.
                this._selectedToEmit.length = 0;
            }
        }
        Object.defineProperty(SelectionModel.prototype, "selected", {
            /**
             * Selected values.
             * @return {?}
             */
            get: function () {
                if (!this._selected) {
                    this._selected = Array.from(this._selection.values());
                }
                return this._selected;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Selects a value or an array of values.
         * @param {...?} values
         * @return {?}
         */
        SelectionModel.prototype.select = function () {
            var _this = this;
            var values = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                values[_i] = arguments[_i];
            }
            this._verifyValueAssignment(values);
            values.forEach(( /**
             * @param {?} value
             * @return {?}
             */function (/**
             * @param {?} value
             * @return {?}
             */ value) { return _this._markSelected(value); }));
            this._emitChangeEvent();
        };
        /**
         * Deselects a value or an array of values.
         * @param {...?} values
         * @return {?}
         */
        SelectionModel.prototype.deselect = function () {
            var _this = this;
            var values = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                values[_i] = arguments[_i];
            }
            this._verifyValueAssignment(values);
            values.forEach(( /**
             * @param {?} value
             * @return {?}
             */function (/**
             * @param {?} value
             * @return {?}
             */ value) { return _this._unmarkSelected(value); }));
            this._emitChangeEvent();
        };
        /**
         * Toggles a value between selected and deselected.
         * @param {?} value
         * @return {?}
         */
        SelectionModel.prototype.toggle = function (value) {
            this.isSelected(value) ? this.deselect(value) : this.select(value);
        };
        /**
         * Clears all of the selected values.
         * @return {?}
         */
        SelectionModel.prototype.clear = function () {
            this._unmarkAll();
            this._emitChangeEvent();
        };
        /**
         * Determines whether a value is selected.
         * @param {?} value
         * @return {?}
         */
        SelectionModel.prototype.isSelected = function (value) {
            return this._selection.has(value);
        };
        /**
         * Determines whether the model does not have a value.
         * @return {?}
         */
        SelectionModel.prototype.isEmpty = function () {
            return this._selection.size === 0;
        };
        /**
         * Determines whether the model has a value.
         * @return {?}
         */
        SelectionModel.prototype.hasValue = function () {
            return !this.isEmpty();
        };
        /**
         * Sorts the selected values based on a predicate function.
         * @param {?=} predicate
         * @return {?}
         */
        SelectionModel.prototype.sort = function (predicate) {
            if (this._multiple && this.selected) {
                ( /** @type {?} */(this._selected)).sort(predicate);
            }
        };
        /**
         * Gets whether multiple values can be selected.
         * @return {?}
         */
        SelectionModel.prototype.isMultipleSelection = function () {
            return this._multiple;
        };
        /**
         * Emits a change event and clears the records of selected and deselected values.
         * @private
         * @return {?}
         */
        SelectionModel.prototype._emitChangeEvent = function () {
            // Clear the selected values so they can be re-cached.
            this._selected = null;
            if (this._selectedToEmit.length || this._deselectedToEmit.length) {
                this.changed.next({
                    source: this,
                    added: this._selectedToEmit,
                    removed: this._deselectedToEmit
                });
                this._deselectedToEmit = [];
                this._selectedToEmit = [];
            }
        };
        /**
         * Selects a value.
         * @private
         * @param {?} value
         * @return {?}
         */
        SelectionModel.prototype._markSelected = function (value) {
            if (!this.isSelected(value)) {
                if (!this._multiple) {
                    this._unmarkAll();
                }
                this._selection.add(value);
                if (this._emitChanges) {
                    this._selectedToEmit.push(value);
                }
            }
        };
        /**
         * Deselects a value.
         * @private
         * @param {?} value
         * @return {?}
         */
        SelectionModel.prototype._unmarkSelected = function (value) {
            if (this.isSelected(value)) {
                this._selection.delete(value);
                if (this._emitChanges) {
                    this._deselectedToEmit.push(value);
                }
            }
        };
        /**
         * Clears out the selected values.
         * @private
         * @return {?}
         */
        SelectionModel.prototype._unmarkAll = function () {
            var _this = this;
            if (!this.isEmpty()) {
                this._selection.forEach(( /**
                 * @param {?} value
                 * @return {?}
                 */function (/**
                 * @param {?} value
                 * @return {?}
                 */ value) { return _this._unmarkSelected(value); }));
            }
        };
        /**
         * Verifies the value assignment and throws an error if the specified value array is
         * including multiple values while the selection model is not supporting multiple values.
         * @private
         * @param {?} values
         * @return {?}
         */
        SelectionModel.prototype._verifyValueAssignment = function (values) {
            if (values.length > 1 && !this._multiple) {
                throw getMultipleValuesInSingleSelectionError();
            }
        };
        return SelectionModel;
    }());
    /**
     * Returns an error that reports that multiple values are passed into a selection model
     * with a single value.
     * \@docs-private
     * @return {?}
     */
    function getMultipleValuesInSingleSelectionError() {
        return Error('Cannot pass multiple values into SelectionModel with single-value mode.');
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Class to coordinate unique selection based on name.
     * Intended to be consumed as an Angular service.
     * This service is needed because native radio change events are only fired on the item currently
     * being selected, and we still need to uncheck the previous selection.
     *
     * This service does not *store* any IDs and names because they may change at any time, so it is
     * less error-prone if they are simply passed through when the events occur.
     */
    var UniqueSelectionDispatcher = /** @class */ (function () {
        function UniqueSelectionDispatcher() {
            this._listeners = [];
        }
        /**
         * Notify other items that selection for the given name has been set.
         * @param {?} id ID of the item.
         * @param {?} name Name of the item.
         * @return {?}
         */
        UniqueSelectionDispatcher.prototype.notify = function (id, name) {
            var e_10, _b;
            try {
                for (var _c = __values(this._listeners), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var listener = _d.value;
                    listener(id, name);
                }
            }
            catch (e_10_1) { e_10 = { error: e_10_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
                }
                finally { if (e_10) throw e_10.error; }
            }
        };
        /**
         * Listen for future changes to item selection.
         * @param {?} listener
         * @return {?} Function used to deregister listener
         */
        UniqueSelectionDispatcher.prototype.listen = function (listener) {
            var _this = this;
            this._listeners.push(listener);
            return ( /**
             * @return {?}
             */function () {
                _this._listeners = _this._listeners.filter(( /**
                 * @param {?} registered
                 * @return {?}
                 */function (registered) {
                    return listener !== registered;
                }));
            });
        };
        /**
         * @return {?}
         */
        UniqueSelectionDispatcher.prototype.ngOnDestroy = function () {
            this._listeners = [];
        };
        return UniqueSelectionDispatcher;
    }());
    UniqueSelectionDispatcher.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] },
    ];
    /** @nocollapse */ UniqueSelectionDispatcher.ngInjectableDef = ɵɵdefineInjectable({ factory: function UniqueSelectionDispatcher_Factory() { return new UniqueSelectionDispatcher(); }, token: UniqueSelectionDispatcher, providedIn: "root" });
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The injection token used to specify the virtual scrolling strategy.
     * @type {?}
     */
    var VIRTUAL_SCROLL_STRATEGY = new InjectionToken('VIRTUAL_SCROLL_STRATEGY');
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Virtual scrolling strategy for lists with items of known fixed size.
     */
    var FixedSizeVirtualScrollStrategy = /** @class */ (function () {
        /**
         * @param {?} itemSize The size of the items in the virtually scrolling list.
         * @param {?} minBufferPx The minimum amount of buffer (in pixels) before needing to render more
         * @param {?} maxBufferPx The amount of buffer (in pixels) to render when rendering more.
         */
        function FixedSizeVirtualScrollStrategy(itemSize, minBufferPx, maxBufferPx) {
            this._scrolledIndexChange = new Subject();
            /**
             * \@docs-private Implemented as part of VirtualScrollStrategy.
             */
            this.scrolledIndexChange = this._scrolledIndexChange.pipe(distinctUntilChanged());
            /**
             * The attached viewport.
             */
            this._viewport = null;
            this._itemSize = itemSize;
            this._minBufferPx = minBufferPx;
            this._maxBufferPx = maxBufferPx;
        }
        /**
         * Attaches this scroll strategy to a viewport.
         * @param {?} viewport The viewport to attach this strategy to.
         * @return {?}
         */
        FixedSizeVirtualScrollStrategy.prototype.attach = function (viewport) {
            this._viewport = viewport;
            this._updateTotalContentSize();
            this._updateRenderedRange();
        };
        /**
         * Detaches this scroll strategy from the currently attached viewport.
         * @return {?}
         */
        FixedSizeVirtualScrollStrategy.prototype.detach = function () {
            this._scrolledIndexChange.complete();
            this._viewport = null;
        };
        /**
         * Update the item size and buffer size.
         * @param {?} itemSize The size of the items in the virtually scrolling list.
         * @param {?} minBufferPx The minimum amount of buffer (in pixels) before needing to render more
         * @param {?} maxBufferPx The amount of buffer (in pixels) to render when rendering more.
         * @return {?}
         */
        FixedSizeVirtualScrollStrategy.prototype.updateItemAndBufferSize = function (itemSize, minBufferPx, maxBufferPx) {
            if (maxBufferPx < minBufferPx) {
                throw Error('CDK virtual scroll: maxBufferPx must be greater than or equal to minBufferPx');
            }
            this._itemSize = itemSize;
            this._minBufferPx = minBufferPx;
            this._maxBufferPx = maxBufferPx;
            this._updateTotalContentSize();
            this._updateRenderedRange();
        };
        /**
         * \@docs-private Implemented as part of VirtualScrollStrategy.
         * @return {?}
         */
        FixedSizeVirtualScrollStrategy.prototype.onContentScrolled = function () {
            this._updateRenderedRange();
        };
        /**
         * \@docs-private Implemented as part of VirtualScrollStrategy.
         * @return {?}
         */
        FixedSizeVirtualScrollStrategy.prototype.onDataLengthChanged = function () {
            this._updateTotalContentSize();
            this._updateRenderedRange();
        };
        /**
         * \@docs-private Implemented as part of VirtualScrollStrategy.
         * @return {?}
         */
        FixedSizeVirtualScrollStrategy.prototype.onContentRendered = function () { };
        /**
         * \@docs-private Implemented as part of VirtualScrollStrategy.
         * @return {?}
         */
        FixedSizeVirtualScrollStrategy.prototype.onRenderedOffsetChanged = function () { };
        /**
         * Scroll to the offset for the given index.
         * @param {?} index The index of the element to scroll to.
         * @param {?} behavior The ScrollBehavior to use when scrolling.
         * @return {?}
         */
        FixedSizeVirtualScrollStrategy.prototype.scrollToIndex = function (index, behavior) {
            if (this._viewport) {
                this._viewport.scrollToOffset(index * this._itemSize, behavior);
            }
        };
        /**
         * Update the viewport's total content size.
         * @private
         * @return {?}
         */
        FixedSizeVirtualScrollStrategy.prototype._updateTotalContentSize = function () {
            if (!this._viewport) {
                return;
            }
            this._viewport.setTotalContentSize(this._viewport.getDataLength() * this._itemSize);
        };
        /**
         * Update the viewport's rendered range.
         * @private
         * @return {?}
         */
        FixedSizeVirtualScrollStrategy.prototype._updateRenderedRange = function () {
            if (!this._viewport) {
                return;
            }
            /** @type {?} */
            var scrollOffset = this._viewport.measureScrollOffset();
            /** @type {?} */
            var firstVisibleIndex = scrollOffset / this._itemSize;
            /** @type {?} */
            var renderedRange = this._viewport.getRenderedRange();
            /** @type {?} */
            var newRange = { start: renderedRange.start, end: renderedRange.end };
            /** @type {?} */
            var viewportSize = this._viewport.getViewportSize();
            /** @type {?} */
            var dataLength = this._viewport.getDataLength();
            /** @type {?} */
            var startBuffer = scrollOffset - newRange.start * this._itemSize;
            if (startBuffer < this._minBufferPx && newRange.start != 0) {
                /** @type {?} */
                var expandStart = Math.ceil((this._maxBufferPx - startBuffer) / this._itemSize);
                newRange.start = Math.max(0, newRange.start - expandStart);
                newRange.end = Math.min(dataLength, Math.ceil(firstVisibleIndex + (viewportSize + this._minBufferPx) / this._itemSize));
            }
            else {
                /** @type {?} */
                var endBuffer = newRange.end * this._itemSize - (scrollOffset + viewportSize);
                if (endBuffer < this._minBufferPx && newRange.end != dataLength) {
                    /** @type {?} */
                    var expandEnd = Math.ceil((this._maxBufferPx - endBuffer) / this._itemSize);
                    if (expandEnd > 0) {
                        newRange.end = Math.min(dataLength, newRange.end + expandEnd);
                        newRange.start = Math.max(0, Math.floor(firstVisibleIndex - this._minBufferPx / this._itemSize));
                    }
                }
            }
            this._viewport.setRenderedRange(newRange);
            this._viewport.setRenderedContentOffset(this._itemSize * newRange.start);
            this._scrolledIndexChange.next(Math.floor(firstVisibleIndex));
        };
        return FixedSizeVirtualScrollStrategy;
    }());
    /**
     * Provider factory for `FixedSizeVirtualScrollStrategy` that simply extracts the already created
     * `FixedSizeVirtualScrollStrategy` from the given directive.
     * @param {?} fixedSizeDir The instance of `CdkFixedSizeVirtualScroll` to extract the
     *     `FixedSizeVirtualScrollStrategy` from.
     * @return {?}
     */
    function _fixedSizeVirtualScrollStrategyFactory(fixedSizeDir) {
        return fixedSizeDir._scrollStrategy;
    }
    /**
     * A virtual scroll strategy that supports fixed-size items.
     */
    var CdkFixedSizeVirtualScroll = /** @class */ (function () {
        function CdkFixedSizeVirtualScroll() {
            this._itemSize = 20;
            this._minBufferPx = 100;
            this._maxBufferPx = 200;
            /**
             * The scroll strategy used by this directive.
             */
            this._scrollStrategy = new FixedSizeVirtualScrollStrategy(this.itemSize, this.minBufferPx, this.maxBufferPx);
        }
        Object.defineProperty(CdkFixedSizeVirtualScroll.prototype, "itemSize", {
            /**
             * The size of the items in the list (in pixels).
             * @return {?}
             */
            get: function () { return this._itemSize; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this._itemSize = coerceNumberProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CdkFixedSizeVirtualScroll.prototype, "minBufferPx", {
            /**
             * The minimum amount of buffer rendered beyond the viewport (in pixels).
             * If the amount of buffer dips below this number, more items will be rendered. Defaults to 100px.
             * @return {?}
             */
            get: function () { return this._minBufferPx; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this._minBufferPx = coerceNumberProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CdkFixedSizeVirtualScroll.prototype, "maxBufferPx", {
            /**
             * The number of pixels worth of buffer to render for when rendering new items. Defaults to 200px.
             * @return {?}
             */
            get: function () { return this._maxBufferPx; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this._maxBufferPx = coerceNumberProperty(value); },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        CdkFixedSizeVirtualScroll.prototype.ngOnChanges = function () {
            this._scrollStrategy.updateItemAndBufferSize(this.itemSize, this.minBufferPx, this.maxBufferPx);
        };
        return CdkFixedSizeVirtualScroll;
    }());
    CdkFixedSizeVirtualScroll.decorators = [
        { type: Directive, args: [{
                    selector: 'cdk-virtual-scroll-viewport[itemSize]',
                    providers: [{
                            provide: VIRTUAL_SCROLL_STRATEGY,
                            useFactory: _fixedSizeVirtualScrollStrategyFactory,
                            deps: [forwardRef(( /**
                                     * @return {?}
                                     */function () { return CdkFixedSizeVirtualScroll; }))],
                        }],
                },] },
    ];
    CdkFixedSizeVirtualScroll.propDecorators = {
        itemSize: [{ type: Input }],
        minBufferPx: [{ type: Input }],
        maxBufferPx: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Time in ms to throttle the scrolling events by default.
     * @type {?}
     */
    var DEFAULT_SCROLL_TIME = 20;
    /**
     * Service contained all registered Scrollable references and emits an event when any one of the
     * Scrollable references emit a scrolled event.
     */
    var ScrollDispatcher = /** @class */ (function () {
        /**
         * @param {?} _ngZone
         * @param {?} _platform
         */
        function ScrollDispatcher(_ngZone, _platform) {
            this._ngZone = _ngZone;
            this._platform = _platform;
            /**
             * Subject for notifying that a registered scrollable reference element has been scrolled.
             */
            this._scrolled = new Subject();
            /**
             * Keeps track of the global `scroll` and `resize` subscriptions.
             */
            this._globalSubscription = null;
            /**
             * Keeps track of the amount of subscriptions to `scrolled`. Used for cleaning up afterwards.
             */
            this._scrolledCount = 0;
            /**
             * Map of all the scrollable references that are registered with the service and their
             * scroll event subscriptions.
             */
            this.scrollContainers = new Map();
        }
        /**
         * Registers a scrollable instance with the service and listens for its scrolled events. When the
         * scrollable is scrolled, the service emits the event to its scrolled observable.
         * @param {?} scrollable Scrollable instance to be registered.
         * @return {?}
         */
        ScrollDispatcher.prototype.register = function (scrollable) {
            var _this = this;
            if (!this.scrollContainers.has(scrollable)) {
                this.scrollContainers.set(scrollable, scrollable.elementScrolled()
                    .subscribe(( /**
             * @return {?}
             */function () { return _this._scrolled.next(scrollable); })));
            }
        };
        /**
         * Deregisters a Scrollable reference and unsubscribes from its scroll event observable.
         * @param {?} scrollable Scrollable instance to be deregistered.
         * @return {?}
         */
        ScrollDispatcher.prototype.deregister = function (scrollable) {
            /** @type {?} */
            var scrollableReference = this.scrollContainers.get(scrollable);
            if (scrollableReference) {
                scrollableReference.unsubscribe();
                this.scrollContainers.delete(scrollable);
            }
        };
        /**
         * Returns an observable that emits an event whenever any of the registered Scrollable
         * references (or window, document, or body) fire a scrolled event. Can provide a time in ms
         * to override the default "throttle" time.
         *
         * **Note:** in order to avoid hitting change detection for every scroll event,
         * all of the events emitted from this stream will be run outside the Angular zone.
         * If you need to update any data bindings as a result of a scroll event, you have
         * to run the callback using `NgZone.run`.
         * @param {?=} auditTimeInMs
         * @return {?}
         */
        ScrollDispatcher.prototype.scrolled = function (auditTimeInMs) {
            var _this = this;
            if (auditTimeInMs === void 0) { auditTimeInMs = DEFAULT_SCROLL_TIME; }
            if (!this._platform.isBrowser) {
                return of();
            }
            return new Observable(( /**
             * @param {?} observer
             * @return {?}
             */function (observer) {
                if (!_this._globalSubscription) {
                    _this._addGlobalListener();
                }
                // In the case of a 0ms delay, use an observable without auditTime
                // since it does add a perceptible delay in processing overhead.
                /** @type {?} */
                var subscription = auditTimeInMs > 0 ?
                    _this._scrolled.pipe(auditTime(auditTimeInMs)).subscribe(observer) :
                    _this._scrolled.subscribe(observer);
                _this._scrolledCount++;
                return ( /**
                 * @return {?}
                 */function () {
                    subscription.unsubscribe();
                    _this._scrolledCount--;
                    if (!_this._scrolledCount) {
                        _this._removeGlobalListener();
                    }
                });
            }));
        };
        /**
         * @return {?}
         */
        ScrollDispatcher.prototype.ngOnDestroy = function () {
            var _this = this;
            this._removeGlobalListener();
            this.scrollContainers.forEach(( /**
             * @param {?} _
             * @param {?} container
             * @return {?}
             */function (_, container) { return _this.deregister(container); }));
            this._scrolled.complete();
        };
        /**
         * Returns an observable that emits whenever any of the
         * scrollable ancestors of an element are scrolled.
         * @param {?} elementRef Element whose ancestors to listen for.
         * @param {?=} auditTimeInMs Time to throttle the scroll events.
         * @return {?}
         */
        ScrollDispatcher.prototype.ancestorScrolled = function (elementRef, auditTimeInMs) {
            /** @type {?} */
            var ancestors = this.getAncestorScrollContainers(elementRef);
            return this.scrolled(auditTimeInMs).pipe(filter(( /**
             * @param {?} target
             * @return {?}
             */function (/**
             * @param {?} target
             * @return {?}
             */ target) {
                return !target || ancestors.indexOf(target) > -1;
            })));
        };
        /**
         * Returns all registered Scrollables that contain the provided element.
         * @param {?} elementRef
         * @return {?}
         */
        ScrollDispatcher.prototype.getAncestorScrollContainers = function (elementRef) {
            var _this = this;
            /** @type {?} */
            var scrollingContainers = [];
            this.scrollContainers.forEach(( /**
             * @param {?} _subscription
             * @param {?} scrollable
             * @return {?}
             */function (_subscription, scrollable) {
                if (_this._scrollableContainsElement(scrollable, elementRef)) {
                    scrollingContainers.push(scrollable);
                }
            }));
            return scrollingContainers;
        };
        /**
         * Returns true if the element is contained within the provided Scrollable.
         * @private
         * @param {?} scrollable
         * @param {?} elementRef
         * @return {?}
         */
        ScrollDispatcher.prototype._scrollableContainsElement = function (scrollable, elementRef) {
            /** @type {?} */
            var element = elementRef.nativeElement;
            /** @type {?} */
            var scrollableElement = scrollable.getElementRef().nativeElement;
            // Traverse through the element parents until we reach null, checking if any of the elements
            // are the scrollable's element.
            do {
                if (element == scrollableElement) {
                    return true;
                }
            } while (element = ( /** @type {?} */(element)).parentElement);
            return false;
        };
        /**
         * Sets up the global scroll listeners.
         * @private
         * @return {?}
         */
        ScrollDispatcher.prototype._addGlobalListener = function () {
            var _this = this;
            this._globalSubscription = this._ngZone.runOutsideAngular(( /**
             * @return {?}
             */function () {
                return fromEvent(window.document, 'scroll').subscribe(( /**
                 * @return {?}
                 */function () { return _this._scrolled.next(); }));
            }));
        };
        /**
         * Cleans up the global scroll listener.
         * @private
         * @return {?}
         */
        ScrollDispatcher.prototype._removeGlobalListener = function () {
            if (this._globalSubscription) {
                this._globalSubscription.unsubscribe();
                this._globalSubscription = null;
            }
        };
        return ScrollDispatcher;
    }());
    ScrollDispatcher.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] },
    ];
    /** @nocollapse */
    ScrollDispatcher.ctorParameters = function () { return [
        { type: NgZone },
        { type: Platform }
    ]; };
    /** @nocollapse */ ScrollDispatcher.ngInjectableDef = ɵɵdefineInjectable({ factory: function ScrollDispatcher_Factory() { return new ScrollDispatcher(ɵɵinject(NgZone), ɵɵinject(Platform)); }, token: ScrollDispatcher, providedIn: "root" });
    /**
     * \@docs-private \@deprecated \@breaking-change 8.0.0
     * @param {?} parentDispatcher
     * @param {?} ngZone
     * @param {?} platform
     * @return {?}
     */
    function SCROLL_DISPATCHER_PROVIDER_FACTORY(parentDispatcher, ngZone, platform) {
        return parentDispatcher || new ScrollDispatcher(ngZone, platform);
    }
    /**
     * \@docs-private \@deprecated \@breaking-change 8.0.0
     * @type {?}
     */
    var SCROLL_DISPATCHER_PROVIDER = {
        // If there is already a ScrollDispatcher available, use that. Otherwise, provide a new one.
        provide: ScrollDispatcher,
        deps: [[new Optional(), new SkipSelf(), ScrollDispatcher], NgZone, Platform],
        useFactory: SCROLL_DISPATCHER_PROVIDER_FACTORY
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Sends an event when the directive's element is scrolled. Registers itself with the
     * ScrollDispatcher service to include itself as part of its collection of scrolling events that it
     * can be listened to through the service.
     */
    var CdkScrollable = /** @class */ (function () {
        /**
         * @param {?} elementRef
         * @param {?} scrollDispatcher
         * @param {?} ngZone
         * @param {?=} dir
         */
        function CdkScrollable(elementRef, scrollDispatcher, ngZone, dir) {
            var _this = this;
            this.elementRef = elementRef;
            this.scrollDispatcher = scrollDispatcher;
            this.ngZone = ngZone;
            this.dir = dir;
            this._destroyed = new Subject();
            this._elementScrolled = new Observable(( /**
             * @param {?} observer
             * @return {?}
             */function (observer) { return _this.ngZone.runOutsideAngular(( /**
             * @return {?}
             */function () { return fromEvent(_this.elementRef.nativeElement, 'scroll').pipe(takeUntil(_this._destroyed))
                .subscribe(observer); })); }));
        }
        /**
         * @return {?}
         */
        CdkScrollable.prototype.ngOnInit = function () {
            this.scrollDispatcher.register(this);
        };
        /**
         * @return {?}
         */
        CdkScrollable.prototype.ngOnDestroy = function () {
            this.scrollDispatcher.deregister(this);
            this._destroyed.next();
            this._destroyed.complete();
        };
        /**
         * Returns observable that emits when a scroll event is fired on the host element.
         * @return {?}
         */
        CdkScrollable.prototype.elementScrolled = function () {
            return this._elementScrolled;
        };
        /**
         * Gets the ElementRef for the viewport.
         * @return {?}
         */
        CdkScrollable.prototype.getElementRef = function () {
            return this.elementRef;
        };
        /**
         * Scrolls to the specified offsets. This is a normalized version of the browser's native scrollTo
         * method, since browsers are not consistent about what scrollLeft means in RTL. For this method
         * left and right always refer to the left and right side of the scrolling container irrespective
         * of the layout direction. start and end refer to left and right in an LTR context and vice-versa
         * in an RTL context.
         * @param {?} options specified the offsets to scroll to.
         * @return {?}
         */
        CdkScrollable.prototype.scrollTo = function (options) {
            /** @type {?} */
            var el = this.elementRef.nativeElement;
            /** @type {?} */
            var isRtl = this.dir && this.dir.value == 'rtl';
            // Rewrite start & end offsets as right or left offsets.
            options.left = options.left == null ? (isRtl ? options.end : options.start) : options.left;
            options.right = options.right == null ? (isRtl ? options.start : options.end) : options.right;
            // Rewrite the bottom offset as a top offset.
            if (options.bottom != null) {
                (( /** @type {?} */(options))).top =
                    el.scrollHeight - el.clientHeight - options.bottom;
            }
            // Rewrite the right offset as a left offset.
            if (isRtl && getRtlScrollAxisType() != RtlScrollAxisType.NORMAL) {
                if (options.left != null) {
                    (( /** @type {?} */(options))).right =
                        el.scrollWidth - el.clientWidth - options.left;
                }
                if (getRtlScrollAxisType() == RtlScrollAxisType.INVERTED) {
                    options.left = options.right;
                }
                else if (getRtlScrollAxisType() == RtlScrollAxisType.NEGATED) {
                    options.left = options.right ? -options.right : options.right;
                }
            }
            else {
                if (options.right != null) {
                    (( /** @type {?} */(options))).left =
                        el.scrollWidth - el.clientWidth - options.right;
                }
            }
            this._applyScrollToOptions(options);
        };
        /**
         * @private
         * @param {?} options
         * @return {?}
         */
        CdkScrollable.prototype._applyScrollToOptions = function (options) {
            /** @type {?} */
            var el = this.elementRef.nativeElement;
            if (supportsScrollBehavior()) {
                el.scrollTo(options);
            }
            else {
                if (options.top != null) {
                    el.scrollTop = options.top;
                }
                if (options.left != null) {
                    el.scrollLeft = options.left;
                }
            }
        };
        /**
         * Measures the scroll offset relative to the specified edge of the viewport. This method can be
         * used instead of directly checking scrollLeft or scrollTop, since browsers are not consistent
         * about what scrollLeft means in RTL. The values returned by this method are normalized such that
         * left and right always refer to the left and right side of the scrolling container irrespective
         * of the layout direction. start and end refer to left and right in an LTR context and vice-versa
         * in an RTL context.
         * @param {?} from The edge to measure from.
         * @return {?}
         */
        CdkScrollable.prototype.measureScrollOffset = function (from) {
            /** @type {?} */
            var LEFT = 'left';
            /** @type {?} */
            var RIGHT = 'right';
            /** @type {?} */
            var el = this.elementRef.nativeElement;
            if (from == 'top') {
                return el.scrollTop;
            }
            if (from == 'bottom') {
                return el.scrollHeight - el.clientHeight - el.scrollTop;
            }
            // Rewrite start & end as left or right offsets.
            /** @type {?} */
            var isRtl = this.dir && this.dir.value == 'rtl';
            if (from == 'start') {
                from = isRtl ? RIGHT : LEFT;
            }
            else if (from == 'end') {
                from = isRtl ? LEFT : RIGHT;
            }
            if (isRtl && getRtlScrollAxisType() == RtlScrollAxisType.INVERTED) {
                // For INVERTED, scrollLeft is (scrollWidth - clientWidth) when scrolled all the way left and
                // 0 when scrolled all the way right.
                if (from == LEFT) {
                    return el.scrollWidth - el.clientWidth - el.scrollLeft;
                }
                else {
                    return el.scrollLeft;
                }
            }
            else if (isRtl && getRtlScrollAxisType() == RtlScrollAxisType.NEGATED) {
                // For NEGATED, scrollLeft is -(scrollWidth - clientWidth) when scrolled all the way left and
                // 0 when scrolled all the way right.
                if (from == LEFT) {
                    return el.scrollLeft + el.scrollWidth - el.clientWidth;
                }
                else {
                    return -el.scrollLeft;
                }
            }
            else {
                // For NORMAL, as well as non-RTL contexts, scrollLeft is 0 when scrolled all the way left and
                // (scrollWidth - clientWidth) when scrolled all the way right.
                if (from == LEFT) {
                    return el.scrollLeft;
                }
                else {
                    return el.scrollWidth - el.clientWidth - el.scrollLeft;
                }
            }
        };
        return CdkScrollable;
    }());
    CdkScrollable.decorators = [
        { type: Directive, args: [{
                    selector: '[cdk-scrollable], [cdkScrollable]'
                },] },
    ];
    /** @nocollapse */
    CdkScrollable.ctorParameters = function () { return [
        { type: ElementRef },
        { type: ScrollDispatcher },
        { type: NgZone },
        { type: Directionality, decorators: [{ type: Optional }] }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Checks if the given ranges are equal.
     * @param {?} r1
     * @param {?} r2
     * @return {?}
     */
    function rangesEqual(r1, r2) {
        return r1.start == r2.start && r1.end == r2.end;
    }
    /**
     * Scheduler to be used for scroll events. Needs to fall back to
     * something that doesn't rely on requestAnimationFrame on environments
     * that don't support it (e.g. server-side rendering).
     * @type {?}
     */
    var SCROLL_SCHEDULER = typeof requestAnimationFrame !== 'undefined' ? animationFrame : asap;
    /**
     * A viewport that virtualizes its scrolling with the help of `CdkVirtualForOf`.
     */
    var CdkVirtualScrollViewport = /** @class */ (function (_super) {
        __extends(CdkVirtualScrollViewport, _super);
        /**
         * @param {?} elementRef
         * @param {?} _changeDetectorRef
         * @param {?} ngZone
         * @param {?} _scrollStrategy
         * @param {?} dir
         * @param {?} scrollDispatcher
         */
        function CdkVirtualScrollViewport(elementRef, _changeDetectorRef, ngZone, _scrollStrategy, dir, scrollDispatcher) {
            var _this = _super.call(this, elementRef, scrollDispatcher, ngZone, dir) || this;
            _this.elementRef = elementRef;
            _this._changeDetectorRef = _changeDetectorRef;
            _this._scrollStrategy = _scrollStrategy;
            /**
             * Emits when the viewport is detached from a CdkVirtualForOf.
             */
            _this._detachedSubject = new Subject();
            /**
             * Emits when the rendered range changes.
             */
            _this._renderedRangeSubject = new Subject();
            _this._orientation = 'vertical';
            // Note: we don't use the typical EventEmitter here because we need to subscribe to the scroll
            // strategy lazily (i.e. only if the user is actually listening to the events). We do this because
            // depending on how the strategy calculates the scrolled index, it may come at a cost to
            // performance.
            /**
             * Emits when the index of the first element visible in the viewport changes.
             */
            _this.scrolledIndexChange = new Observable(( /**
             * @param {?} observer
             * @return {?}
             */function (observer) { return _this._scrollStrategy.scrolledIndexChange.subscribe(( /**
             * @param {?} index
             * @return {?}
             */function (/**
             * @param {?} index
             * @return {?}
             */ index) { return Promise.resolve().then(( /**
             * @return {?}
             */function () { return _this.ngZone.run(( /**
             * @return {?}
             */function () { return observer.next(index); })); })); })); }));
            /**
             * A stream that emits whenever the rendered range changes.
             */
            _this.renderedRangeStream = _this._renderedRangeSubject.asObservable();
            /**
             * The total size of all content (in pixels), including content that is not currently rendered.
             */
            _this._totalContentSize = 0;
            /**
             * A string representing the `style.width` property value to be used for the spacer element.
             */
            _this._totalContentWidth = '';
            /**
             * A string representing the `style.height` property value to be used for the spacer element.
             */
            _this._totalContentHeight = '';
            /**
             * The currently rendered range of indices.
             */
            _this._renderedRange = { start: 0, end: 0 };
            /**
             * The length of the data bound to this viewport (in number of items).
             */
            _this._dataLength = 0;
            /**
             * The size of the viewport (in pixels).
             */
            _this._viewportSize = 0;
            /**
             * The last rendered content offset that was set.
             */
            _this._renderedContentOffset = 0;
            /**
             * Whether the last rendered content offset was to the end of the content (and therefore needs to
             * be rewritten as an offset to the start of the content).
             */
            _this._renderedContentOffsetNeedsRewrite = false;
            /**
             * Whether there is a pending change detection cycle.
             */
            _this._isChangeDetectionPending = false;
            /**
             * A list of functions to run after the next change detection cycle.
             */
            _this._runAfterChangeDetection = [];
            if (!_scrollStrategy) {
                throw Error('Error: cdk-virtual-scroll-viewport requires the "itemSize" property to be set.');
            }
            return _this;
        }
        Object.defineProperty(CdkVirtualScrollViewport.prototype, "orientation", {
            /**
             * The direction the viewport scrolls.
             * @return {?}
             */
            get: function () {
                return this._orientation;
            },
            /**
             * @param {?} orientation
             * @return {?}
             */
            set: function (orientation) {
                if (this._orientation !== orientation) {
                    this._orientation = orientation;
                    this._calculateSpacerSize();
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        CdkVirtualScrollViewport.prototype.ngOnInit = function () {
            var _this = this;
            _super.prototype.ngOnInit.call(this);
            // It's still too early to measure the viewport at this point. Deferring with a promise allows
            // the Viewport to be rendered with the correct size before we measure. We run this outside the
            // zone to avoid causing more change detection cycles. We handle the change detection loop
            // ourselves instead.
            this.ngZone.runOutsideAngular(( /**
             * @return {?}
             */function () { return Promise.resolve().then(( /**
             * @return {?}
             */function () {
                _this._measureViewportSize();
                _this._scrollStrategy.attach(_this);
                _this.elementScrolled()
                    .pipe(
                // Start off with a fake scroll event so we properly detect our initial position.
                startWith(( /** @type {?} */(null))), 
                // Collect multiple events into one until the next animation frame. This way if
                // there are multiple scroll events in the same frame we only need to recheck
                // our layout once.
                auditTime(0, SCROLL_SCHEDULER))
                    .subscribe(( /**
             * @return {?}
             */function () { return _this._scrollStrategy.onContentScrolled(); }));
                _this._markChangeDetectionNeeded();
            })); }));
        };
        /**
         * @return {?}
         */
        CdkVirtualScrollViewport.prototype.ngOnDestroy = function () {
            this.detach();
            this._scrollStrategy.detach();
            // Complete all subjects
            this._renderedRangeSubject.complete();
            this._detachedSubject.complete();
            _super.prototype.ngOnDestroy.call(this);
        };
        /**
         * Attaches a `CdkVirtualForOf` to this viewport.
         * @param {?} forOf
         * @return {?}
         */
        CdkVirtualScrollViewport.prototype.attach = function (forOf) {
            var _this = this;
            if (this._forOf) {
                throw Error('CdkVirtualScrollViewport is already attached.');
            }
            // Subscribe to the data stream of the CdkVirtualForOf to keep track of when the data length
            // changes. Run outside the zone to avoid triggering change detection, since we're managing the
            // change detection loop ourselves.
            this.ngZone.runOutsideAngular(( /**
             * @return {?}
             */function () {
                _this._forOf = forOf;
                _this._forOf.dataStream.pipe(takeUntil(_this._detachedSubject)).subscribe(( /**
                 * @param {?} data
                 * @return {?}
                 */function (/**
                 * @param {?} data
                 * @return {?}
                 */ data) {
                    /** @type {?} */
                    var newLength = data.length;
                    if (newLength !== _this._dataLength) {
                        _this._dataLength = newLength;
                        _this._scrollStrategy.onDataLengthChanged();
                    }
                    _this._doChangeDetection();
                }));
            }));
        };
        /**
         * Detaches the current `CdkVirtualForOf`.
         * @return {?}
         */
        CdkVirtualScrollViewport.prototype.detach = function () {
            this._forOf = null;
            this._detachedSubject.next();
        };
        /**
         * Gets the length of the data bound to this viewport (in number of items).
         * @return {?}
         */
        CdkVirtualScrollViewport.prototype.getDataLength = function () {
            return this._dataLength;
        };
        /**
         * Gets the size of the viewport (in pixels).
         * @return {?}
         */
        CdkVirtualScrollViewport.prototype.getViewportSize = function () {
            return this._viewportSize;
        };
        // TODO(mmalerba): This is technically out of sync with what's really rendered until a render
        // cycle happens. I'm being careful to only call it after the render cycle is complete and before
        // setting it to something else, but its error prone and should probably be split into
        // `pendingRange` and `renderedRange`, the latter reflecting whats actually in the DOM.
        /**
         * Get the current rendered range of items.
         * @return {?}
         */
        CdkVirtualScrollViewport.prototype.getRenderedRange = function () {
            return this._renderedRange;
        };
        /**
         * Sets the total size of all content (in pixels), including content that is not currently
         * rendered.
         * @param {?} size
         * @return {?}
         */
        CdkVirtualScrollViewport.prototype.setTotalContentSize = function (size) {
            if (this._totalContentSize !== size) {
                this._totalContentSize = size;
                this._calculateSpacerSize();
                this._markChangeDetectionNeeded();
            }
        };
        /**
         * Sets the currently rendered range of indices.
         * @param {?} range
         * @return {?}
         */
        CdkVirtualScrollViewport.prototype.setRenderedRange = function (range) {
            var _this = this;
            if (!rangesEqual(this._renderedRange, range)) {
                this._renderedRangeSubject.next(this._renderedRange = range);
                this._markChangeDetectionNeeded(( /**
                 * @return {?}
                 */function () { return _this._scrollStrategy.onContentRendered(); }));
            }
        };
        /**
         * Gets the offset from the start of the viewport to the start of the rendered data (in pixels).
         * @return {?}
         */
        CdkVirtualScrollViewport.prototype.getOffsetToRenderedContentStart = function () {
            return this._renderedContentOffsetNeedsRewrite ? null : this._renderedContentOffset;
        };
        /**
         * Sets the offset from the start of the viewport to either the start or end of the rendered data
         * (in pixels).
         * @param {?} offset
         * @param {?=} to
         * @return {?}
         */
        CdkVirtualScrollViewport.prototype.setRenderedContentOffset = function (offset, to) {
            var _this = this;
            if (to === void 0) { to = 'to-start'; }
            // For a horizontal viewport in a right-to-left language we need to translate along the x-axis
            // in the negative direction.
            /** @type {?} */
            var isRtl = this.dir && this.dir.value == 'rtl';
            /** @type {?} */
            var isHorizontal = this.orientation == 'horizontal';
            /** @type {?} */
            var axis = isHorizontal ? 'X' : 'Y';
            /** @type {?} */
            var axisDirection = isHorizontal && isRtl ? -1 : 1;
            /** @type {?} */
            var transform = "translate" + axis + "(" + Number(axisDirection * offset) + "px)";
            this._renderedContentOffset = offset;
            if (to === 'to-end') {
                transform += " translate" + axis + "(-100%)";
                // The viewport should rewrite this as a `to-start` offset on the next render cycle. Otherwise
                // elements will appear to expand in the wrong direction (e.g. `mat-expansion-panel` would
                // expand upward).
                this._renderedContentOffsetNeedsRewrite = true;
            }
            if (this._renderedContentTransform != transform) {
                // We know this value is safe because we parse `offset` with `Number()` before passing it
                // into the string.
                this._renderedContentTransform = transform;
                this._markChangeDetectionNeeded(( /**
                 * @return {?}
                 */function () {
                    if (_this._renderedContentOffsetNeedsRewrite) {
                        _this._renderedContentOffset -= _this.measureRenderedContentSize();
                        _this._renderedContentOffsetNeedsRewrite = false;
                        _this.setRenderedContentOffset(_this._renderedContentOffset);
                    }
                    else {
                        _this._scrollStrategy.onRenderedOffsetChanged();
                    }
                }));
            }
        };
        /**
         * Scrolls to the given offset from the start of the viewport. Please note that this is not always
         * the same as setting `scrollTop` or `scrollLeft`. In a horizontal viewport with right-to-left
         * direction, this would be the equivalent of setting a fictional `scrollRight` property.
         * @param {?} offset The offset to scroll to.
         * @param {?=} behavior The ScrollBehavior to use when scrolling. Default is behavior is `auto`.
         * @return {?}
         */
        CdkVirtualScrollViewport.prototype.scrollToOffset = function (offset, behavior) {
            if (behavior === void 0) { behavior = 'auto'; }
            /** @type {?} */
            var options = { behavior: behavior };
            if (this.orientation === 'horizontal') {
                options.start = offset;
            }
            else {
                options.top = offset;
            }
            this.scrollTo(options);
        };
        /**
         * Scrolls to the offset for the given index.
         * @param {?} index The index of the element to scroll to.
         * @param {?=} behavior The ScrollBehavior to use when scrolling. Default is behavior is `auto`.
         * @return {?}
         */
        CdkVirtualScrollViewport.prototype.scrollToIndex = function (index, behavior) {
            if (behavior === void 0) { behavior = 'auto'; }
            this._scrollStrategy.scrollToIndex(index, behavior);
        };
        /**
         * Gets the current scroll offset from the start of the viewport (in pixels).
         * @param {?=} from The edge to measure the offset from. Defaults to 'top' in vertical mode and 'start'
         *     in horizontal mode.
         * @return {?}
         */
        CdkVirtualScrollViewport.prototype.measureScrollOffset = function (from) {
            return _super.prototype.measureScrollOffset.call(this, from ? from : this.orientation === 'horizontal' ? 'start' : 'top');
        };
        /**
         * Measure the combined size of all of the rendered items.
         * @return {?}
         */
        CdkVirtualScrollViewport.prototype.measureRenderedContentSize = function () {
            /** @type {?} */
            var contentEl = this._contentWrapper.nativeElement;
            return this.orientation === 'horizontal' ? contentEl.offsetWidth : contentEl.offsetHeight;
        };
        /**
         * Measure the total combined size of the given range. Throws if the range includes items that are
         * not rendered.
         * @param {?} range
         * @return {?}
         */
        CdkVirtualScrollViewport.prototype.measureRangeSize = function (range) {
            if (!this._forOf) {
                return 0;
            }
            return this._forOf.measureRangeSize(range, this.orientation);
        };
        /**
         * Update the viewport dimensions and re-render.
         * @return {?}
         */
        CdkVirtualScrollViewport.prototype.checkViewportSize = function () {
            // TODO: Cleanup later when add logic for handling content resize
            this._measureViewportSize();
            this._scrollStrategy.onDataLengthChanged();
        };
        /**
         * Measure the viewport size.
         * @private
         * @return {?}
         */
        CdkVirtualScrollViewport.prototype._measureViewportSize = function () {
            /** @type {?} */
            var viewportEl = this.elementRef.nativeElement;
            this._viewportSize = this.orientation === 'horizontal' ?
                viewportEl.clientWidth : viewportEl.clientHeight;
        };
        /**
         * Queue up change detection to run.
         * @private
         * @param {?=} runAfter
         * @return {?}
         */
        CdkVirtualScrollViewport.prototype._markChangeDetectionNeeded = function (runAfter) {
            var _this = this;
            if (runAfter) {
                this._runAfterChangeDetection.push(runAfter);
            }
            // Use a Promise to batch together calls to `_doChangeDetection`. This way if we set a bunch of
            // properties sequentially we only have to run `_doChangeDetection` once at the end.
            if (!this._isChangeDetectionPending) {
                this._isChangeDetectionPending = true;
                this.ngZone.runOutsideAngular(( /**
                 * @return {?}
                 */function () { return Promise.resolve().then(( /**
                 * @return {?}
                 */function () {
                    _this._doChangeDetection();
                })); }));
            }
        };
        /**
         * Run change detection.
         * @private
         * @return {?}
         */
        CdkVirtualScrollViewport.prototype._doChangeDetection = function () {
            var _this = this;
            var e_11, _b;
            this._isChangeDetectionPending = false;
            // Apply changes to Angular bindings. Note: We must call `markForCheck` to run change detection
            // from the root, since the repeated items are content projected in. Calling `detectChanges`
            // instead does not properly check the projected content.
            this.ngZone.run(( /**
             * @return {?}
             */function () { return _this._changeDetectorRef.markForCheck(); }));
            // Apply the content transform. The transform can't be set via an Angular binding because
            // bypassSecurityTrustStyle is banned in Google. However the value is safe, it's composed of
            // string literals, a variable that can only be 'X' or 'Y', and user input that is run through
            // the `Number` function first to coerce it to a numeric value.
            this._contentWrapper.nativeElement.style.transform = this._renderedContentTransform;
            /** @type {?} */
            var runAfterChangeDetection = this._runAfterChangeDetection;
            this._runAfterChangeDetection = [];
            try {
                for (var runAfterChangeDetection_1 = __values(runAfterChangeDetection), runAfterChangeDetection_1_1 = runAfterChangeDetection_1.next(); !runAfterChangeDetection_1_1.done; runAfterChangeDetection_1_1 = runAfterChangeDetection_1.next()) {
                    var fn = runAfterChangeDetection_1_1.value;
                    fn();
                }
            }
            catch (e_11_1) { e_11 = { error: e_11_1 }; }
            finally {
                try {
                    if (runAfterChangeDetection_1_1 && !runAfterChangeDetection_1_1.done && (_b = runAfterChangeDetection_1.return)) _b.call(runAfterChangeDetection_1);
                }
                finally { if (e_11) throw e_11.error; }
            }
        };
        /**
         * Calculates the `style.width` and `style.height` for the spacer element.
         * @private
         * @return {?}
         */
        CdkVirtualScrollViewport.prototype._calculateSpacerSize = function () {
            this._totalContentHeight =
                this.orientation === 'horizontal' ? '' : this._totalContentSize + "px";
            this._totalContentWidth =
                this.orientation === 'horizontal' ? this._totalContentSize + "px" : '';
        };
        return CdkVirtualScrollViewport;
    }(CdkScrollable));
    CdkVirtualScrollViewport.decorators = [
        { type: Component, args: [{ selector: 'cdk-virtual-scroll-viewport',
                    template: "<div #contentWrapper class=\"cdk-virtual-scroll-content-wrapper\"><ng-content></ng-content></div><div class=\"cdk-virtual-scroll-spacer\" [style.width]=\"_totalContentWidth\" [style.height]=\"_totalContentHeight\"></div>",
                    styles: ["cdk-virtual-scroll-viewport{display:block;position:relative;overflow:auto;contain:strict;transform:translateZ(0);will-change:scroll-position;-webkit-overflow-scrolling:touch}.cdk-virtual-scroll-content-wrapper{position:absolute;top:0;left:0;contain:content}[dir=rtl] .cdk-virtual-scroll-content-wrapper{right:0;left:auto}.cdk-virtual-scroll-orientation-horizontal .cdk-virtual-scroll-content-wrapper{min-height:100%}.cdk-virtual-scroll-orientation-horizontal .cdk-virtual-scroll-content-wrapper>dl:not([cdkVirtualFor]),.cdk-virtual-scroll-orientation-horizontal .cdk-virtual-scroll-content-wrapper>ol:not([cdkVirtualFor]),.cdk-virtual-scroll-orientation-horizontal .cdk-virtual-scroll-content-wrapper>table:not([cdkVirtualFor]),.cdk-virtual-scroll-orientation-horizontal .cdk-virtual-scroll-content-wrapper>ul:not([cdkVirtualFor]){padding-left:0;padding-right:0;margin-left:0;margin-right:0;border-left-width:0;border-right-width:0;outline:0}.cdk-virtual-scroll-orientation-vertical .cdk-virtual-scroll-content-wrapper{min-width:100%}.cdk-virtual-scroll-orientation-vertical .cdk-virtual-scroll-content-wrapper>dl:not([cdkVirtualFor]),.cdk-virtual-scroll-orientation-vertical .cdk-virtual-scroll-content-wrapper>ol:not([cdkVirtualFor]),.cdk-virtual-scroll-orientation-vertical .cdk-virtual-scroll-content-wrapper>table:not([cdkVirtualFor]),.cdk-virtual-scroll-orientation-vertical .cdk-virtual-scroll-content-wrapper>ul:not([cdkVirtualFor]){padding-top:0;padding-bottom:0;margin-top:0;margin-bottom:0;border-top-width:0;border-bottom-width:0;outline:0}.cdk-virtual-scroll-spacer{position:absolute;top:0;left:0;height:1px;width:1px;transform-origin:0 0}[dir=rtl] .cdk-virtual-scroll-spacer{right:0;left:auto;transform-origin:100% 0}"],
                    host: {
                        'class': 'cdk-virtual-scroll-viewport',
                        '[class.cdk-virtual-scroll-orientation-horizontal]': 'orientation === "horizontal"',
                        '[class.cdk-virtual-scroll-orientation-vertical]': 'orientation !== "horizontal"',
                    },
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{
                            provide: CdkScrollable,
                            useExisting: CdkVirtualScrollViewport,
                        }]
                },] },
    ];
    /** @nocollapse */
    CdkVirtualScrollViewport.ctorParameters = function () { return [
        { type: ElementRef },
        { type: ChangeDetectorRef },
        { type: NgZone },
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [VIRTUAL_SCROLL_STRATEGY,] }] },
        { type: Directionality, decorators: [{ type: Optional }] },
        { type: ScrollDispatcher }
    ]; };
    CdkVirtualScrollViewport.propDecorators = {
        orientation: [{ type: Input }],
        scrolledIndexChange: [{ type: Output }],
        _contentWrapper: [{ type: ViewChild, args: ['contentWrapper', { static: true },] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Helper to extract size from a DOM Node.
     * @param {?} orientation
     * @param {?} node
     * @return {?}
     */
    function getSize(orientation, node) {
        /** @type {?} */
        var el = ( /** @type {?} */(node));
        if (!el.getBoundingClientRect) {
            return 0;
        }
        /** @type {?} */
        var rect = el.getBoundingClientRect();
        return orientation == 'horizontal' ? rect.width : rect.height;
    }
    /**
     * A directive similar to `ngForOf` to be used for rendering data inside a virtual scrolling
     * container.
     * @template T
     */
    var CdkVirtualForOf = /** @class */ (function () {
        /**
         * @param {?} _viewContainerRef
         * @param {?} _template
         * @param {?} _differs
         * @param {?} _viewport
         * @param {?} ngZone
         */
        function CdkVirtualForOf(_viewContainerRef, _template, _differs, _viewport, ngZone) {
            var _this = this;
            this._viewContainerRef = _viewContainerRef;
            this._template = _template;
            this._differs = _differs;
            this._viewport = _viewport;
            /**
             * Emits when the rendered view of the data changes.
             */
            this.viewChange = new Subject();
            /**
             * Subject that emits when a new DataSource instance is given.
             */
            this._dataSourceChanges = new Subject();
            /**
             * The size of the cache used to store templates that are not being used for re-use later.
             * Setting the cache size to `0` will disable caching. Defaults to 20 templates.
             */
            this.cdkVirtualForTemplateCacheSize = 20;
            /**
             * Emits whenever the data in the current DataSource changes.
             */
            this.dataStream = this._dataSourceChanges
                .pipe(
            // Start off with null `DataSource`.
            startWith(( /** @type {?} */(null))), 
            // Bundle up the previous and current data sources so we can work with both.
            pairwise(), 
            // Use `_changeDataSource` to disconnect from the previous data source and connect to the
            // new one, passing back a stream of data changes which we run through `switchMap` to give
            // us a data stream that emits the latest data from whatever the current `DataSource` is.
            switchMap(( /**
             * @param {?} __0
             * @return {?}
             */function (_b) {
                var _c = __read(_b, 2), prev = _c[0], cur = _c[1];
                return _this._changeDataSource(prev, cur);
            })), 
            // Replay the last emitted data when someone subscribes.
            shareReplay(1));
            /**
             * The differ used to calculate changes to the data.
             */
            this._differ = null;
            /**
             * The template cache used to hold on ot template instancess that have been stamped out, but don't
             * currently need to be rendered. These instances will be reused in the future rather than
             * stamping out brand new ones.
             */
            this._templateCache = [];
            /**
             * Whether the rendered data should be updated during the next ngDoCheck cycle.
             */
            this._needsUpdate = false;
            this._destroyed = new Subject();
            this.dataStream.subscribe(( /**
             * @param {?} data
             * @return {?}
             */function (/**
             * @param {?} data
             * @return {?}
             */ data) {
                _this._data = data;
                _this._onRenderedDataChange();
            }));
            this._viewport.renderedRangeStream.pipe(takeUntil(this._destroyed)).subscribe(( /**
             * @param {?} range
             * @return {?}
             */function (/**
             * @param {?} range
             * @return {?}
             */ range) {
                _this._renderedRange = range;
                ngZone.run(( /**
                 * @return {?}
                 */function () { return _this.viewChange.next(_this._renderedRange); }));
                _this._onRenderedDataChange();
            }));
            this._viewport.attach(this);
        }
        Object.defineProperty(CdkVirtualForOf.prototype, "cdkVirtualForOf", {
            /**
             * The DataSource to display.
             * @return {?}
             */
            get: function () {
                return this._cdkVirtualForOf;
            },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._cdkVirtualForOf = value;
                /** @type {?} */
                var ds = isDataSource(value) ? value :
                    // Slice the value if its an NgIterable to ensure we're working with an array.
                    new ArrayDataSource(value instanceof Observable ? value : Array.prototype.slice.call(value || []));
                this._dataSourceChanges.next(ds);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CdkVirtualForOf.prototype, "cdkVirtualForTrackBy", {
            /**
             * The `TrackByFunction` to use for tracking changes. The `TrackByFunction` takes the index and
             * the item and produces a value to be used as the item's identity when tracking changes.
             * @return {?}
             */
            get: function () {
                return this._cdkVirtualForTrackBy;
            },
            /**
             * @param {?} fn
             * @return {?}
             */
            set: function (fn) {
                var _this = this;
                this._needsUpdate = true;
                this._cdkVirtualForTrackBy = fn ?
                    ( /**
                     * @param {?} index
                     * @param {?} item
                     * @return {?}
                     */function (index, item) { return fn(index + (_this._renderedRange ? _this._renderedRange.start : 0), item); }) :
                    undefined;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CdkVirtualForOf.prototype, "cdkVirtualForTemplate", {
            /**
             * The template used to stamp out new elements.
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                if (value) {
                    this._needsUpdate = true;
                    this._template = value;
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Measures the combined size (width for horizontal orientation, height for vertical) of all items
         * in the specified range. Throws an error if the range includes items that are not currently
         * rendered.
         * @param {?} range
         * @param {?} orientation
         * @return {?}
         */
        CdkVirtualForOf.prototype.measureRangeSize = function (range, orientation) {
            if (range.start >= range.end) {
                return 0;
            }
            if (range.start < this._renderedRange.start || range.end > this._renderedRange.end) {
                throw Error("Error: attempted to measure an item that isn't rendered.");
            }
            // The index into the list of rendered views for the first item in the range.
            /** @type {?} */
            var renderedStartIndex = range.start - this._renderedRange.start;
            // The length of the range we're measuring.
            /** @type {?} */
            var rangeLen = range.end - range.start;
            // Loop over all root nodes for all items in the range and sum up their size.
            /** @type {?} */
            var totalSize = 0;
            /** @type {?} */
            var i = rangeLen;
            while (i--) {
                /** @type {?} */
                var view = ( /** @type {?} */(this._viewContainerRef.get(i + renderedStartIndex)));
                /** @type {?} */
                var j_10 = view ? view.rootNodes.length : 0;
                while (j_10--) {
                    totalSize += getSize(orientation, ( /** @type {?} */(view)).rootNodes[j_10]);
                }
            }
            return totalSize;
        };
        /**
         * @return {?}
         */
        CdkVirtualForOf.prototype.ngDoCheck = function () {
            if (this._differ && this._needsUpdate) {
                // TODO(mmalerba): We should differentiate needs update due to scrolling and a new portion of
                // this list being rendered (can use simpler algorithm) vs needs update due to data actually
                // changing (need to do this diff).
                /** @type {?} */
                var changes = this._differ.diff(this._renderedItems);
                if (!changes) {
                    this._updateContext();
                }
                else {
                    this._applyChanges(changes);
                }
                this._needsUpdate = false;
            }
        };
        /**
         * @return {?}
         */
        CdkVirtualForOf.prototype.ngOnDestroy = function () {
            var e_12, _b;
            this._viewport.detach();
            this._dataSourceChanges.next();
            this._dataSourceChanges.complete();
            this.viewChange.complete();
            this._destroyed.next();
            this._destroyed.complete();
            try {
                for (var _c = __values(this._templateCache), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var view = _d.value;
                    view.destroy();
                }
            }
            catch (e_12_1) { e_12 = { error: e_12_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
                }
                finally { if (e_12) throw e_12.error; }
            }
        };
        /**
         * React to scroll state changes in the viewport.
         * @private
         * @return {?}
         */
        CdkVirtualForOf.prototype._onRenderedDataChange = function () {
            if (!this._renderedRange) {
                return;
            }
            this._renderedItems = this._data.slice(this._renderedRange.start, this._renderedRange.end);
            if (!this._differ) {
                this._differ = this._differs.find(this._renderedItems).create(this.cdkVirtualForTrackBy);
            }
            this._needsUpdate = true;
        };
        /**
         * Swap out one `DataSource` for another.
         * @private
         * @param {?} oldDs
         * @param {?} newDs
         * @return {?}
         */
        CdkVirtualForOf.prototype._changeDataSource = function (oldDs, newDs) {
            if (oldDs) {
                oldDs.disconnect(this);
            }
            this._needsUpdate = true;
            return newDs ? newDs.connect(this) : of();
        };
        /**
         * Update the `CdkVirtualForOfContext` for all views.
         * @private
         * @return {?}
         */
        CdkVirtualForOf.prototype._updateContext = function () {
            /** @type {?} */
            var count = this._data.length;
            /** @type {?} */
            var i = this._viewContainerRef.length;
            while (i--) {
                /** @type {?} */
                var view = ( /** @type {?} */(this._viewContainerRef.get(i)));
                view.context.index = this._renderedRange.start + i;
                view.context.count = count;
                this._updateComputedContextProperties(view.context);
                view.detectChanges();
            }
        };
        /**
         * Apply changes to the DOM.
         * @private
         * @param {?} changes
         * @return {?}
         */
        CdkVirtualForOf.prototype._applyChanges = function (changes) {
            var _this = this;
            // Rearrange the views to put them in the right location.
            changes.forEachOperation(( /**
             * @param {?} record
             * @param {?} adjustedPreviousIndex
             * @param {?} currentIndex
             * @return {?}
             */function (record, adjustedPreviousIndex, currentIndex) {
                if (record.previousIndex == null) { // Item added.
                    // Item added.
                    /** @type {?} */
                    var view = _this._insertViewForNewItem(( /** @type {?} */(currentIndex)));
                    view.context.$implicit = record.item;
                }
                else if (currentIndex == null) { // Item removed.
                    _this._cacheView(_this._detachView(( /** @type {?} */(adjustedPreviousIndex))));
                }
                else { // Item moved.
                    // Item moved.
                    /** @type {?} */
                    var view = ( /** @type {?} */(_this._viewContainerRef.get(( /** @type {?} */(adjustedPreviousIndex)))));
                    _this._viewContainerRef.move(view, currentIndex);
                    view.context.$implicit = record.item;
                }
            }));
            // Update $implicit for any items that had an identity change.
            changes.forEachIdentityChange(( /**
             * @param {?} record
             * @return {?}
             */function (record) {
                /** @type {?} */
                var view = ( /** @type {?} */(_this._viewContainerRef.get(( /** @type {?} */(record.currentIndex)))));
                view.context.$implicit = record.item;
            }));
            // Update the context variables on all items.
            /** @type {?} */
            var count = this._data.length;
            /** @type {?} */
            var i = this._viewContainerRef.length;
            while (i--) {
                /** @type {?} */
                var view = ( /** @type {?} */(this._viewContainerRef.get(i)));
                view.context.index = this._renderedRange.start + i;
                view.context.count = count;
                this._updateComputedContextProperties(view.context);
            }
        };
        /**
         * Cache the given detached view.
         * @private
         * @param {?} view
         * @return {?}
         */
        CdkVirtualForOf.prototype._cacheView = function (view) {
            if (this._templateCache.length < this.cdkVirtualForTemplateCacheSize) {
                this._templateCache.push(view);
            }
            else {
                /** @type {?} */
                var index = this._viewContainerRef.indexOf(view);
                // It's very unlikely that the index will ever be -1, but just in case,
                // destroy the view on its own, otherwise destroy it through the
                // container to ensure that all the references are removed.
                if (index === -1) {
                    view.destroy();
                }
                else {
                    this._viewContainerRef.remove(index);
                }
            }
        };
        /**
         * Inserts a view for a new item, either from the cache or by creating a new one.
         * @private
         * @param {?} index
         * @return {?}
         */
        CdkVirtualForOf.prototype._insertViewForNewItem = function (index) {
            return this._insertViewFromCache(index) || this._createEmbeddedViewAt(index);
        };
        /**
         * Update the computed properties on the `CdkVirtualForOfContext`.
         * @private
         * @param {?} context
         * @return {?}
         */
        CdkVirtualForOf.prototype._updateComputedContextProperties = function (context) {
            context.first = context.index === 0;
            context.last = context.index === context.count - 1;
            context.even = context.index % 2 === 0;
            context.odd = !context.even;
        };
        /**
         * Creates a new embedded view and moves it to the given index
         * @private
         * @param {?} index
         * @return {?}
         */
        CdkVirtualForOf.prototype._createEmbeddedViewAt = function (index) {
            // Note that it's important that we insert the item directly at the proper index,
            // rather than inserting it and the moving it in place, because if there's a directive
            // on the same node that injects the `ViewContainerRef`, Angular will insert another
            // comment node which can throw off the move when it's being repeated for all items.
            return this._viewContainerRef.createEmbeddedView(this._template, {
                $implicit: ( /** @type {?} */(null)),
                cdkVirtualForOf: this._cdkVirtualForOf,
                index: -1,
                count: -1,
                first: false,
                last: false,
                odd: false,
                even: false
            }, index);
        };
        /**
         * Inserts a recycled view from the cache at the given index.
         * @private
         * @param {?} index
         * @return {?}
         */
        CdkVirtualForOf.prototype._insertViewFromCache = function (index) {
            /** @type {?} */
            var cachedView = this._templateCache.pop();
            if (cachedView) {
                this._viewContainerRef.insert(cachedView, index);
            }
            return cachedView || null;
        };
        /**
         * Detaches the embedded view at the given index.
         * @private
         * @param {?} index
         * @return {?}
         */
        CdkVirtualForOf.prototype._detachView = function (index) {
            return ( /** @type {?} */(this._viewContainerRef.detach(index)));
        };
        return CdkVirtualForOf;
    }());
    CdkVirtualForOf.decorators = [
        { type: Directive, args: [{
                    selector: '[cdkVirtualFor][cdkVirtualForOf]',
                },] },
    ];
    /** @nocollapse */
    CdkVirtualForOf.ctorParameters = function () { return [
        { type: ViewContainerRef },
        { type: TemplateRef },
        { type: IterableDiffers },
        { type: CdkVirtualScrollViewport, decorators: [{ type: SkipSelf }] },
        { type: NgZone }
    ]; };
    CdkVirtualForOf.propDecorators = {
        cdkVirtualForOf: [{ type: Input }],
        cdkVirtualForTrackBy: [{ type: Input }],
        cdkVirtualForTemplate: [{ type: Input }],
        cdkVirtualForTemplateCacheSize: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ScrollingModule = /** @class */ (function () {
        function ScrollingModule() {
        }
        return ScrollingModule;
    }());
    ScrollingModule.decorators = [
        { type: NgModule, args: [{
                    imports: [BidiModule, PlatformModule],
                    exports: [
                        BidiModule,
                        CdkFixedSizeVirtualScroll,
                        CdkScrollable,
                        CdkVirtualForOf,
                        CdkVirtualScrollViewport,
                    ],
                    declarations: [
                        CdkFixedSizeVirtualScroll,
                        CdkScrollable,
                        CdkVirtualForOf,
                        CdkVirtualScrollViewport,
                    ],
                },] },
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Time in ms to throttle the resize events by default.
     * @type {?}
     */
    var DEFAULT_RESIZE_TIME = 20;
    /**
     * Simple utility for getting the bounds of the browser viewport.
     * \@docs-private
     */
    var ViewportRuler = /** @class */ (function () {
        /**
         * @param {?} _platform
         * @param {?} ngZone
         */
        function ViewportRuler(_platform, ngZone) {
            var _this = this;
            this._platform = _platform;
            ngZone.runOutsideAngular(( /**
             * @return {?}
             */function () {
                _this._change = _platform.isBrowser ?
                    merge(fromEvent(window, 'resize'), fromEvent(window, 'orientationchange')) :
                    of();
                // Note that we need to do the subscription inside `runOutsideAngular`
                // since subscribing is what causes the event listener to be added.
                _this._invalidateCache = _this.change().subscribe(( /**
                 * @return {?}
                 */function () { return _this._updateViewportSize(); }));
            }));
        }
        /**
         * @return {?}
         */
        ViewportRuler.prototype.ngOnDestroy = function () {
            this._invalidateCache.unsubscribe();
        };
        /**
         * Returns the viewport's width and height.
         * @return {?}
         */
        ViewportRuler.prototype.getViewportSize = function () {
            if (!this._viewportSize) {
                this._updateViewportSize();
            }
            /** @type {?} */
            var output = { width: this._viewportSize.width, height: this._viewportSize.height };
            // If we're not on a browser, don't cache the size since it'll be mocked out anyway.
            if (!this._platform.isBrowser) {
                this._viewportSize = ( /** @type {?} */(null));
            }
            return output;
        };
        /**
         * Gets a ClientRect for the viewport's bounds.
         * @return {?}
         */
        ViewportRuler.prototype.getViewportRect = function () {
            // Use the document element's bounding rect rather than the window scroll properties
            // (e.g. pageYOffset, scrollY) due to in issue in Chrome and IE where window scroll
            // properties and client coordinates (boundingClientRect, clientX/Y, etc.) are in different
            // conceptual viewports. Under most circumstances these viewports are equivalent, but they
            // can disagree when the page is pinch-zoomed (on devices that support touch).
            // See https://bugs.chromium.org/p/chromium/issues/detail?id=489206#c4
            // We use the documentElement instead of the body because, by default (without a css reset)
            // browsers typically give the document body an 8px margin, which is not included in
            // getBoundingClientRect().
            /** @type {?} */
            var scrollPosition = this.getViewportScrollPosition();
            var _b = this.getViewportSize(), width = _b.width, height = _b.height;
            return {
                top: scrollPosition.top,
                left: scrollPosition.left,
                bottom: scrollPosition.top + height,
                right: scrollPosition.left + width,
                height: height,
                width: width,
            };
        };
        /**
         * Gets the (top, left) scroll position of the viewport.
         * @return {?}
         */
        ViewportRuler.prototype.getViewportScrollPosition = function () {
            // While we can get a reference to the fake document
            // during SSR, it doesn't have getBoundingClientRect.
            if (!this._platform.isBrowser) {
                return { top: 0, left: 0 };
            }
            // The top-left-corner of the viewport is determined by the scroll position of the document
            // body, normally just (scrollLeft, scrollTop). However, Chrome and Firefox disagree about
            // whether `document.body` or `document.documentElement` is the scrolled element, so reading
            // `scrollTop` and `scrollLeft` is inconsistent. However, using the bounding rect of
            // `document.documentElement` works consistently, where the `top` and `left` values will
            // equal negative the scroll position.
            /** @type {?} */
            var documentElement = ( /** @type {?} */(document.documentElement));
            /** @type {?} */
            var documentRect = documentElement.getBoundingClientRect();
            /** @type {?} */
            var top = -documentRect.top || document.body.scrollTop || window.scrollY ||
                documentElement.scrollTop || 0;
            /** @type {?} */
            var left = -documentRect.left || document.body.scrollLeft || window.scrollX ||
                documentElement.scrollLeft || 0;
            return { top: top, left: left };
        };
        /**
         * Returns a stream that emits whenever the size of the viewport changes.
         * @param {?=} throttleTime Time in milliseconds to throttle the stream.
         * @return {?}
         */
        ViewportRuler.prototype.change = function (throttleTime) {
            if (throttleTime === void 0) { throttleTime = DEFAULT_RESIZE_TIME; }
            return throttleTime > 0 ? this._change.pipe(auditTime(throttleTime)) : this._change;
        };
        /**
         * Updates the cached viewport size.
         * @private
         * @return {?}
         */
        ViewportRuler.prototype._updateViewportSize = function () {
            this._viewportSize = this._platform.isBrowser ?
                { width: window.innerWidth, height: window.innerHeight } :
                { width: 0, height: 0 };
        };
        return ViewportRuler;
    }());
    ViewportRuler.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] },
    ];
    /** @nocollapse */
    ViewportRuler.ctorParameters = function () { return [
        { type: Platform },
        { type: NgZone }
    ]; };
    /** @nocollapse */ ViewportRuler.ngInjectableDef = ɵɵdefineInjectable({ factory: function ViewportRuler_Factory() { return new ViewportRuler(ɵɵinject(Platform), ɵɵinject(NgZone)); }, token: ViewportRuler, providedIn: "root" });
    /**
     * \@docs-private \@deprecated \@breaking-change 8.0.0
     * @param {?} parentRuler
     * @param {?} platform
     * @param {?} ngZone
     * @return {?}
     */
    function VIEWPORT_RULER_PROVIDER_FACTORY(parentRuler, platform, ngZone) {
        return parentRuler || new ViewportRuler(platform, ngZone);
    }
    /**
     * \@docs-private \@deprecated \@breaking-change 8.0.0
     * @type {?}
     */
    var VIEWPORT_RULER_PROVIDER = {
        // If there is already a ViewportRuler available, use that. Otherwise, provide a new one.
        provide: ViewportRuler,
        deps: [[new Optional(), new SkipSelf(), ViewportRuler], Platform, NgZone],
        useFactory: VIEWPORT_RULER_PROVIDER_FACTORY
    };
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Strategy that will prevent the user from scrolling while the overlay is visible.
     */
    var BlockScrollStrategy = /** @class */ (function () {
        /**
         * @param {?} _viewportRuler
         * @param {?} document
         */
        function BlockScrollStrategy(_viewportRuler, document) {
            this._viewportRuler = _viewportRuler;
            this._previousHTMLStyles = { top: '', left: '' };
            this._isEnabled = false;
            this._document = document;
        }
        /**
         * Attaches this scroll strategy to an overlay.
         * @return {?}
         */
        BlockScrollStrategy.prototype.attach = function () { };
        /**
         * Blocks page-level scroll while the attached overlay is open.
         * @return {?}
         */
        BlockScrollStrategy.prototype.enable = function () {
            if (this._canBeEnabled()) {
                /** @type {?} */
                var root = ( /** @type {?} */(this._document.documentElement));
                this._previousScrollPosition = this._viewportRuler.getViewportScrollPosition();
                // Cache the previous inline styles in case the user had set them.
                this._previousHTMLStyles.left = root.style.left || '';
                this._previousHTMLStyles.top = root.style.top || '';
                // Note: we're using the `html` node, instead of the `body`, because the `body` may
                // have the user agent margin, whereas the `html` is guaranteed not to have one.
                root.style.left = coerceCssPixelValue(-this._previousScrollPosition.left);
                root.style.top = coerceCssPixelValue(-this._previousScrollPosition.top);
                root.classList.add('cdk-global-scrollblock');
                this._isEnabled = true;
            }
        };
        /**
         * Unblocks page-level scroll while the attached overlay is open.
         * @return {?}
         */
        BlockScrollStrategy.prototype.disable = function () {
            if (this._isEnabled) {
                /** @type {?} */
                var html = ( /** @type {?} */(this._document.documentElement));
                /** @type {?} */
                var body = ( /** @type {?} */(this._document.body));
                /** @type {?} */
                var htmlStyle = ( /** @type {?} */(html.style));
                /** @type {?} */
                var bodyStyle = ( /** @type {?} */(body.style));
                /** @type {?} */
                var previousHtmlScrollBehavior = htmlStyle.scrollBehavior || '';
                /** @type {?} */
                var previousBodyScrollBehavior = bodyStyle.scrollBehavior || '';
                this._isEnabled = false;
                htmlStyle.left = this._previousHTMLStyles.left;
                htmlStyle.top = this._previousHTMLStyles.top;
                html.classList.remove('cdk-global-scrollblock');
                // Disable user-defined smooth scrolling temporarily while we restore the scroll position.
                // See https://developer.mozilla.org/en-US/docs/Web/CSS/scroll-behavior
                htmlStyle.scrollBehavior = bodyStyle.scrollBehavior = 'auto';
                window.scroll(this._previousScrollPosition.left, this._previousScrollPosition.top);
                htmlStyle.scrollBehavior = previousHtmlScrollBehavior;
                bodyStyle.scrollBehavior = previousBodyScrollBehavior;
            }
        };
        /**
         * @private
         * @return {?}
         */
        BlockScrollStrategy.prototype._canBeEnabled = function () {
            // Since the scroll strategies can't be singletons, we have to use a global CSS class
            // (`cdk-global-scrollblock`) to make sure that we don't try to disable global
            // scrolling multiple times.
            /** @type {?} */
            var html = ( /** @type {?} */(this._document.documentElement));
            if (html.classList.contains('cdk-global-scrollblock') || this._isEnabled) {
                return false;
            }
            /** @type {?} */
            var body = this._document.body;
            /** @type {?} */
            var viewport = this._viewportRuler.getViewportSize();
            return body.scrollHeight > viewport.height || body.scrollWidth > viewport.width;
        };
        return BlockScrollStrategy;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Returns an error to be thrown when attempting to attach an already-attached scroll strategy.
     * @return {?}
     */
    function getMatScrollStrategyAlreadyAttachedError() {
        return Error("Scroll strategy has already been attached.");
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Strategy that will close the overlay as soon as the user starts scrolling.
     */
    var CloseScrollStrategy = /** @class */ (function () {
        /**
         * @param {?} _scrollDispatcher
         * @param {?} _ngZone
         * @param {?} _viewportRuler
         * @param {?=} _config
         */
        function CloseScrollStrategy(_scrollDispatcher, _ngZone, _viewportRuler, _config) {
            var _this = this;
            this._scrollDispatcher = _scrollDispatcher;
            this._ngZone = _ngZone;
            this._viewportRuler = _viewportRuler;
            this._config = _config;
            this._scrollSubscription = null;
            /**
             * Detaches the overlay ref and disables the scroll strategy.
             */
            this._detach = ( /**
             * @return {?}
             */function () {
                _this.disable();
                if (_this._overlayRef.hasAttached()) {
                    _this._ngZone.run(( /**
                     * @return {?}
                     */function () { return _this._overlayRef.detach(); }));
                }
            });
        }
        /**
         * Attaches this scroll strategy to an overlay.
         * @param {?} overlayRef
         * @return {?}
         */
        CloseScrollStrategy.prototype.attach = function (overlayRef) {
            if (this._overlayRef) {
                throw getMatScrollStrategyAlreadyAttachedError();
            }
            this._overlayRef = overlayRef;
        };
        /**
         * Enables the closing of the attached overlay on scroll.
         * @return {?}
         */
        CloseScrollStrategy.prototype.enable = function () {
            var _this = this;
            if (this._scrollSubscription) {
                return;
            }
            /** @type {?} */
            var stream = this._scrollDispatcher.scrolled(0);
            if (this._config && this._config.threshold && this._config.threshold > 1) {
                this._initialScrollPosition = this._viewportRuler.getViewportScrollPosition().top;
                this._scrollSubscription = stream.subscribe(( /**
                 * @return {?}
                 */function () {
                    /** @type {?} */
                    var scrollPosition = _this._viewportRuler.getViewportScrollPosition().top;
                    if (Math.abs(scrollPosition - _this._initialScrollPosition) > ( /** @type {?} */(( /** @type {?} */(_this._config)).threshold))) {
                        _this._detach();
                    }
                    else {
                        _this._overlayRef.updatePosition();
                    }
                }));
            }
            else {
                this._scrollSubscription = stream.subscribe(this._detach);
            }
        };
        /**
         * Disables the closing the attached overlay on scroll.
         * @return {?}
         */
        CloseScrollStrategy.prototype.disable = function () {
            if (this._scrollSubscription) {
                this._scrollSubscription.unsubscribe();
                this._scrollSubscription = null;
            }
        };
        /**
         * @return {?}
         */
        CloseScrollStrategy.prototype.detach = function () {
            this.disable();
            this._overlayRef = ( /** @type {?} */(null));
        };
        return CloseScrollStrategy;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Scroll strategy that doesn't do anything.
     */
    var NoopScrollStrategy = /** @class */ (function () {
        function NoopScrollStrategy() {
        }
        /**
         * Does nothing, as this scroll strategy is a no-op.
         * @return {?}
         */
        NoopScrollStrategy.prototype.enable = function () { };
        /**
         * Does nothing, as this scroll strategy is a no-op.
         * @return {?}
         */
        NoopScrollStrategy.prototype.disable = function () { };
        /**
         * Does nothing, as this scroll strategy is a no-op.
         * @return {?}
         */
        NoopScrollStrategy.prototype.attach = function () { };
        return NoopScrollStrategy;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // TODO(jelbourn): move this to live with the rest of the scrolling code
    // TODO(jelbourn): someday replace this with IntersectionObservers
    /**
     * Gets whether an element is scrolled outside of view by any of its parent scrolling containers.
     * \@docs-private
     * @param {?} element Dimensions of the element (from getBoundingClientRect)
     * @param {?} scrollContainers Dimensions of element's scrolling containers (from getBoundingClientRect)
     * @return {?} Whether the element is scrolled out of view
     */
    function isElementScrolledOutsideView(element, scrollContainers) {
        return scrollContainers.some(( /**
         * @param {?} containerBounds
         * @return {?}
         */function (/**
         * @param {?} containerBounds
         * @return {?}
         */ containerBounds) {
            /** @type {?} */
            var outsideAbove = element.bottom < containerBounds.top;
            /** @type {?} */
            var outsideBelow = element.top > containerBounds.bottom;
            /** @type {?} */
            var outsideLeft = element.right < containerBounds.left;
            /** @type {?} */
            var outsideRight = element.left > containerBounds.right;
            return outsideAbove || outsideBelow || outsideLeft || outsideRight;
        }));
    }
    /**
     * Gets whether an element is clipped by any of its scrolling containers.
     * \@docs-private
     * @param {?} element Dimensions of the element (from getBoundingClientRect)
     * @param {?} scrollContainers Dimensions of element's scrolling containers (from getBoundingClientRect)
     * @return {?} Whether the element is clipped
     */
    function isElementClippedByScrolling(element, scrollContainers) {
        return scrollContainers.some(( /**
         * @param {?} scrollContainerRect
         * @return {?}
         */function (/**
         * @param {?} scrollContainerRect
         * @return {?}
         */ scrollContainerRect) {
            /** @type {?} */
            var clippedAbove = element.top < scrollContainerRect.top;
            /** @type {?} */
            var clippedBelow = element.bottom > scrollContainerRect.bottom;
            /** @type {?} */
            var clippedLeft = element.left < scrollContainerRect.left;
            /** @type {?} */
            var clippedRight = element.right > scrollContainerRect.right;
            return clippedAbove || clippedBelow || clippedLeft || clippedRight;
        }));
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Strategy that will update the element position as the user is scrolling.
     */
    var RepositionScrollStrategy = /** @class */ (function () {
        /**
         * @param {?} _scrollDispatcher
         * @param {?} _viewportRuler
         * @param {?} _ngZone
         * @param {?=} _config
         */
        function RepositionScrollStrategy(_scrollDispatcher, _viewportRuler, _ngZone, _config) {
            this._scrollDispatcher = _scrollDispatcher;
            this._viewportRuler = _viewportRuler;
            this._ngZone = _ngZone;
            this._config = _config;
            this._scrollSubscription = null;
        }
        /**
         * Attaches this scroll strategy to an overlay.
         * @param {?} overlayRef
         * @return {?}
         */
        RepositionScrollStrategy.prototype.attach = function (overlayRef) {
            if (this._overlayRef) {
                throw getMatScrollStrategyAlreadyAttachedError();
            }
            this._overlayRef = overlayRef;
        };
        /**
         * Enables repositioning of the attached overlay on scroll.
         * @return {?}
         */
        RepositionScrollStrategy.prototype.enable = function () {
            var _this = this;
            if (!this._scrollSubscription) {
                /** @type {?} */
                var throttle = this._config ? this._config.scrollThrottle : 0;
                this._scrollSubscription = this._scrollDispatcher.scrolled(throttle).subscribe(( /**
                 * @return {?}
                 */function () {
                    _this._overlayRef.updatePosition();
                    // TODO(crisbeto): make `close` on by default once all components can handle it.
                    if (_this._config && _this._config.autoClose) {
                        /** @type {?} */
                        var overlayRect = _this._overlayRef.overlayElement.getBoundingClientRect();
                        var _b = _this._viewportRuler.getViewportSize(), width = _b.width, height = _b.height;
                        // TODO(crisbeto): include all ancestor scroll containers here once
                        // we have a way of exposing the trigger element to the scroll strategy.
                        /** @type {?} */
                        var parentRects = [{ width: width, height: height, bottom: height, right: width, top: 0, left: 0 }];
                        if (isElementScrolledOutsideView(overlayRect, parentRects)) {
                            _this.disable();
                            _this._ngZone.run(( /**
                             * @return {?}
                             */function () { return _this._overlayRef.detach(); }));
                        }
                    }
                }));
            }
        };
        /**
         * Disables repositioning of the attached overlay on scroll.
         * @return {?}
         */
        RepositionScrollStrategy.prototype.disable = function () {
            if (this._scrollSubscription) {
                this._scrollSubscription.unsubscribe();
                this._scrollSubscription = null;
            }
        };
        /**
         * @return {?}
         */
        RepositionScrollStrategy.prototype.detach = function () {
            this.disable();
            this._overlayRef = ( /** @type {?} */(null));
        };
        return RepositionScrollStrategy;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Options for how an overlay will handle scrolling.
     *
     * Users can provide a custom value for `ScrollStrategyOptions` to replace the default
     * behaviors. This class primarily acts as a factory for ScrollStrategy instances.
     */
    var ScrollStrategyOptions = /** @class */ (function () {
        /**
         * @param {?} _scrollDispatcher
         * @param {?} _viewportRuler
         * @param {?} _ngZone
         * @param {?} document
         */
        function ScrollStrategyOptions(_scrollDispatcher, _viewportRuler, _ngZone, document) {
            var _this = this;
            this._scrollDispatcher = _scrollDispatcher;
            this._viewportRuler = _viewportRuler;
            this._ngZone = _ngZone;
            /**
             * Do nothing on scroll.
             */
            this.noop = ( /**
             * @return {?}
             */function () { return new NoopScrollStrategy(); });
            /**
             * Close the overlay as soon as the user scrolls.
             * @param config Configuration to be used inside the scroll strategy.
             */
            this.close = ( /**
             * @param {?=} config
             * @return {?}
             */function (config) { return new CloseScrollStrategy(_this._scrollDispatcher, _this._ngZone, _this._viewportRuler, config); });
            /**
             * Block scrolling.
             */
            this.block = ( /**
             * @return {?}
             */function () { return new BlockScrollStrategy(_this._viewportRuler, _this._document); });
            /**
             * Update the overlay's position on scroll.
             * @param config Configuration to be used inside the scroll strategy.
             * Allows debouncing the reposition calls.
             */
            this.reposition = ( /**
             * @param {?=} config
             * @return {?}
             */function (config) { return new RepositionScrollStrategy(_this._scrollDispatcher, _this._viewportRuler, _this._ngZone, config); });
            this._document = document;
        }
        return ScrollStrategyOptions;
    }());
    ScrollStrategyOptions.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] },
    ];
    /** @nocollapse */
    ScrollStrategyOptions.ctorParameters = function () { return [
        { type: ScrollDispatcher },
        { type: ViewportRuler },
        { type: NgZone },
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
    ]; };
    /** @nocollapse */ ScrollStrategyOptions.ngInjectableDef = ɵɵdefineInjectable({ factory: function ScrollStrategyOptions_Factory() { return new ScrollStrategyOptions(ɵɵinject(ScrollDispatcher), ɵɵinject(ViewportRuler), ɵɵinject(NgZone), ɵɵinject(DOCUMENT)); }, token: ScrollStrategyOptions, providedIn: "root" });
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Initial configuration used when creating an overlay.
     */
    var OverlayConfig = /** @class */ (function () {
        /**
         * @param {?=} config
         */
        function OverlayConfig(config) {
            var e_13, _b;
            /**
             * Strategy to be used when handling scroll events while the overlay is open.
             */
            this.scrollStrategy = new NoopScrollStrategy();
            /**
             * Custom class to add to the overlay pane.
             */
            this.panelClass = '';
            /**
             * Whether the overlay has a backdrop.
             */
            this.hasBackdrop = false;
            /**
             * Custom class to add to the backdrop
             */
            this.backdropClass = 'cdk-overlay-dark-backdrop';
            /**
             * Whether the overlay should be disposed of when the user goes backwards/forwards in history.
             * Note that this usually doesn't include clicking on links (unless the user is using
             * the `HashLocationStrategy`).
             */
            this.disposeOnNavigation = false;
            if (config) {
                /** @type {?} */
                var configKeys = ( /** @type {?} */(Object.keys(config)));
                try {
                    for (var configKeys_1 = __values(configKeys), configKeys_1_1 = configKeys_1.next(); !configKeys_1_1.done; configKeys_1_1 = configKeys_1.next()) {
                        var key = configKeys_1_1.value;
                        if (config[key] !== undefined) {
                            // TypeScript, as of version 3.5, sees the left-hand-side of this expression
                            // as "I don't know *which* key this is, so the only valid value is the intersection
                            // of all the posible values." In this case, that happens to be `undefined`. TypeScript
                            // is not smart enough to see that the right-hand-side is actually an access of the same
                            // exact type with the same exact key, meaning that the value type must be identical.
                            // So we use `any` to work around this.
                            this[key] = ( /** @type {?} */(config[key]));
                        }
                    }
                }
                catch (e_13_1) { e_13 = { error: e_13_1 }; }
                finally {
                    try {
                        if (configKeys_1_1 && !configKeys_1_1.done && (_b = configKeys_1.return)) _b.call(configKeys_1);
                    }
                    finally { if (e_13) throw e_13.error; }
                }
            }
        }
        return OverlayConfig;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The points of the origin element and the overlay element to connect.
     */
    var ConnectionPositionPair = /** @class */ (function () {
        /**
         * @param {?} origin
         * @param {?} overlay
         * @param {?=} offsetX
         * @param {?=} offsetY
         * @param {?=} panelClass
         */
        function ConnectionPositionPair(origin, overlay, offsetX, offsetY, panelClass) {
            this.offsetX = offsetX;
            this.offsetY = offsetY;
            this.panelClass = panelClass;
            this.originX = origin.originX;
            this.originY = origin.originY;
            this.overlayX = overlay.overlayX;
            this.overlayY = overlay.overlayY;
        }
        return ConnectionPositionPair;
    }());
    /**
     * Set of properties regarding the position of the origin and overlay relative to the viewport
     * with respect to the containing Scrollable elements.
     *
     * The overlay and origin are clipped if any part of their bounding client rectangle exceeds the
     * bounds of any one of the strategy's Scrollable's bounding client rectangle.
     *
     * The overlay and origin are outside view if there is no overlap between their bounding client
     * rectangle and any one of the strategy's Scrollable's bounding client rectangle.
     *
     *       -----------                    -----------
     *       | outside |                    | clipped |
     *       |  view   |              --------------------------
     *       |         |              |     |         |        |
     *       ----------               |     -----------        |
     *  --------------------------    |                        |
     *  |                        |    |      Scrollable        |
     *  |                        |    |                        |
     *  |                        |     --------------------------
     *  |      Scrollable        |
     *  |                        |
     *  --------------------------
     *
     * \@docs-private
     */
    var ScrollingVisibility = /** @class */ (function () {
        function ScrollingVisibility() {
        }
        return ScrollingVisibility;
    }());
    /**
     * The change event emitted by the strategy when a fallback position is used.
     */
    var ConnectedOverlayPositionChange = /** @class */ (function () {
        /**
         * @param {?} connectionPair
         * @param {?} scrollableViewProperties
         */
        function ConnectedOverlayPositionChange(connectionPair, scrollableViewProperties) {
            this.connectionPair = connectionPair;
            this.scrollableViewProperties = scrollableViewProperties;
        }
        return ConnectedOverlayPositionChange;
    }());
    /** @nocollapse */
    ConnectedOverlayPositionChange.ctorParameters = function () { return [
        { type: ConnectionPositionPair },
        { type: ScrollingVisibility, decorators: [{ type: Optional }] }
    ]; };
    /**
     * Validates whether a vertical position property matches the expected values.
     * \@docs-private
     * @param {?} property Name of the property being validated.
     * @param {?} value Value of the property being validated.
     * @return {?}
     */
    function validateVerticalPosition(property, value) {
        if (value !== 'top' && value !== 'bottom' && value !== 'center') {
            throw Error("ConnectedPosition: Invalid " + property + " \"" + value + "\". " +
                "Expected \"top\", \"bottom\" or \"center\".");
        }
    }
    /**
     * Validates whether a horizontal position property matches the expected values.
     * \@docs-private
     * @param {?} property Name of the property being validated.
     * @param {?} value Value of the property being validated.
     * @return {?}
     */
    function validateHorizontalPosition(property, value) {
        if (value !== 'start' && value !== 'end' && value !== 'center') {
            throw Error("ConnectedPosition: Invalid " + property + " \"" + value + "\". " +
                "Expected \"start\", \"end\" or \"center\".");
        }
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Service for dispatching keyboard events that land on the body to appropriate overlay ref,
     * if any. It maintains a list of attached overlays to determine best suited overlay based
     * on event target and order of overlay opens.
     */
    var OverlayKeyboardDispatcher = /** @class */ (function () {
        /**
         * @param {?} document
         */
        function OverlayKeyboardDispatcher(document) {
            var _this = this;
            /**
             * Currently attached overlays in the order they were attached.
             */
            this._attachedOverlays = [];
            /**
             * Keyboard event listener that will be attached to the body.
             */
            this._keydownListener = ( /**
             * @param {?} event
             * @return {?}
             */function (event) {
                /** @type {?} */
                var overlays = _this._attachedOverlays;
                for (var i_155 = overlays.length - 1; i_155 > -1; i_155--) {
                    // Dispatch the keydown event to the top overlay which has subscribers to its keydown events.
                    // We want to target the most recent overlay, rather than trying to match where the event came
                    // from, because some components might open an overlay, but keep focus on a trigger element
                    // (e.g. for select and autocomplete). We skip overlays without keydown event subscriptions,
                    // because we don't want overlays that don't handle keyboard events to block the ones below
                    // them that do.
                    if (overlays[i_155]._keydownEventSubscriptions > 0) {
                        overlays[i_155]._keydownEvents.next(event);
                        break;
                    }
                }
            });
            this._document = document;
        }
        /**
         * @return {?}
         */
        OverlayKeyboardDispatcher.prototype.ngOnDestroy = function () {
            this._detach();
        };
        /**
         * Add a new overlay to the list of attached overlay refs.
         * @param {?} overlayRef
         * @return {?}
         */
        OverlayKeyboardDispatcher.prototype.add = function (overlayRef) {
            // Ensure that we don't get the same overlay multiple times.
            this.remove(overlayRef);
            // Lazily start dispatcher once first overlay is added
            if (!this._isAttached) {
                this._document.body.addEventListener('keydown', this._keydownListener);
                this._isAttached = true;
            }
            this._attachedOverlays.push(overlayRef);
        };
        /**
         * Remove an overlay from the list of attached overlay refs.
         * @param {?} overlayRef
         * @return {?}
         */
        OverlayKeyboardDispatcher.prototype.remove = function (overlayRef) {
            /** @type {?} */
            var index = this._attachedOverlays.indexOf(overlayRef);
            if (index > -1) {
                this._attachedOverlays.splice(index, 1);
            }
            // Remove the global listener once there are no more overlays.
            if (this._attachedOverlays.length === 0) {
                this._detach();
            }
        };
        /**
         * Detaches the global keyboard event listener.
         * @private
         * @return {?}
         */
        OverlayKeyboardDispatcher.prototype._detach = function () {
            if (this._isAttached) {
                this._document.body.removeEventListener('keydown', this._keydownListener);
                this._isAttached = false;
            }
        };
        return OverlayKeyboardDispatcher;
    }());
    OverlayKeyboardDispatcher.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] },
    ];
    /** @nocollapse */
    OverlayKeyboardDispatcher.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
    ]; };
    /** @nocollapse */ OverlayKeyboardDispatcher.ngInjectableDef = ɵɵdefineInjectable({ factory: function OverlayKeyboardDispatcher_Factory() { return new OverlayKeyboardDispatcher(ɵɵinject(DOCUMENT)); }, token: OverlayKeyboardDispatcher, providedIn: "root" });
    /**
     * \@docs-private \@deprecated \@breaking-change 8.0.0
     * @param {?} dispatcher
     * @param {?} _document
     * @return {?}
     */
    function OVERLAY_KEYBOARD_DISPATCHER_PROVIDER_FACTORY(dispatcher, _document) {
        return dispatcher || new OverlayKeyboardDispatcher(_document);
    }
    /**
     * \@docs-private \@deprecated \@breaking-change 8.0.0
     * @type {?}
     */
    var OVERLAY_KEYBOARD_DISPATCHER_PROVIDER = {
        // If there is already an OverlayKeyboardDispatcher available, use that.
        // Otherwise, provide a new one.
        provide: OverlayKeyboardDispatcher,
        deps: [
            [new Optional(), new SkipSelf(), OverlayKeyboardDispatcher],
            ( /** @type {?} */(
            // Coerce to `InjectionToken` so that the `deps` match the "shape"
            // of the type expected by Angular
            DOCUMENT))
        ],
        useFactory: OVERLAY_KEYBOARD_DISPATCHER_PROVIDER_FACTORY
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Container inside which all overlays will render.
     */
    var OverlayContainer = /** @class */ (function () {
        /**
         * @param {?} document
         */
        function OverlayContainer(document) {
            this._document = document;
        }
        /**
         * @return {?}
         */
        OverlayContainer.prototype.ngOnDestroy = function () {
            if (this._containerElement && this._containerElement.parentNode) {
                this._containerElement.parentNode.removeChild(this._containerElement);
            }
        };
        /**
         * This method returns the overlay container element. It will lazily
         * create the element the first time  it is called to facilitate using
         * the container in non-browser environments.
         * @return {?} the container element
         */
        OverlayContainer.prototype.getContainerElement = function () {
            if (!this._containerElement) {
                this._createContainer();
            }
            return this._containerElement;
        };
        /**
         * Create the overlay container element, which is simply a div
         * with the 'cdk-overlay-container' class on the document body.
         * @protected
         * @return {?}
         */
        OverlayContainer.prototype._createContainer = function () {
            /** @type {?} */
            var containerClass = 'cdk-overlay-container';
            /** @type {?} */
            var previousContainers = this._document.getElementsByClassName(containerClass);
            // Remove any old containers. This can happen when transitioning from the server to the client.
            for (var i_156 = 0; i_156 < previousContainers.length; i_156++) {
                ( /** @type {?} */(previousContainers[i_156].parentNode)).removeChild(previousContainers[i_156]);
            }
            /** @type {?} */
            var container = this._document.createElement('div');
            container.classList.add(containerClass);
            this._document.body.appendChild(container);
            this._containerElement = container;
        };
        return OverlayContainer;
    }());
    OverlayContainer.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] },
    ];
    /** @nocollapse */
    OverlayContainer.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
    ]; };
    /** @nocollapse */ OverlayContainer.ngInjectableDef = ɵɵdefineInjectable({ factory: function OverlayContainer_Factory() { return new OverlayContainer(ɵɵinject(DOCUMENT)); }, token: OverlayContainer, providedIn: "root" });
    /**
     * \@docs-private \@deprecated \@breaking-change 8.0.0
     * @param {?} parentContainer
     * @param {?} _document
     * @return {?}
     */
    function OVERLAY_CONTAINER_PROVIDER_FACTORY(parentContainer, _document) {
        return parentContainer || new OverlayContainer(_document);
    }
    /**
     * \@docs-private \@deprecated \@breaking-change 8.0.0
     * @type {?}
     */
    var OVERLAY_CONTAINER_PROVIDER = {
        // If there is already an OverlayContainer available, use that. Otherwise, provide a new one.
        provide: OverlayContainer,
        deps: [
            [new Optional(), new SkipSelf(), OverlayContainer],
            ( /** @type {?} */(DOCUMENT))
        ],
        useFactory: OVERLAY_CONTAINER_PROVIDER_FACTORY
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Reference to an overlay that has been created with the Overlay service.
     * Used to manipulate or dispose of said overlay.
     */
    var OverlayRef = /** @class */ (function () {
        /**
         * @param {?} _portalOutlet
         * @param {?} _host
         * @param {?} _pane
         * @param {?} _config
         * @param {?} _ngZone
         * @param {?} _keyboardDispatcher
         * @param {?} _document
         * @param {?=} _location
         */
        function OverlayRef(_portalOutlet, _host, _pane, _config, _ngZone, _keyboardDispatcher, _document, _location) {
            var _this = this;
            this._portalOutlet = _portalOutlet;
            this._host = _host;
            this._pane = _pane;
            this._config = _config;
            this._ngZone = _ngZone;
            this._keyboardDispatcher = _keyboardDispatcher;
            this._document = _document;
            this._location = _location;
            this._backdropElement = null;
            this._backdropClick = new Subject();
            this._attachments = new Subject();
            this._detachments = new Subject();
            this._locationChanges = Subscription.EMPTY;
            this._backdropClickHandler = ( /**
             * @param {?} event
             * @return {?}
             */function (event) { return _this._backdropClick.next(event); });
            this._keydownEventsObservable = new Observable(( /**
             * @param {?} observer
             * @return {?}
             */function (observer) {
                /** @type {?} */
                var subscription = _this._keydownEvents.subscribe(observer);
                _this._keydownEventSubscriptions++;
                return ( /**
                 * @return {?}
                 */function () {
                    subscription.unsubscribe();
                    _this._keydownEventSubscriptions--;
                });
            }));
            /**
             * Stream of keydown events dispatched to this overlay.
             */
            this._keydownEvents = new Subject();
            /**
             * Amount of subscriptions to the keydown events.
             */
            this._keydownEventSubscriptions = 0;
            if (_config.scrollStrategy) {
                this._scrollStrategy = _config.scrollStrategy;
                this._scrollStrategy.attach(this);
            }
            this._positionStrategy = _config.positionStrategy;
        }
        Object.defineProperty(OverlayRef.prototype, "overlayElement", {
            /**
             * The overlay's HTML element
             * @return {?}
             */
            get: function () {
                return this._pane;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(OverlayRef.prototype, "backdropElement", {
            /**
             * The overlay's backdrop HTML element.
             * @return {?}
             */
            get: function () {
                return this._backdropElement;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(OverlayRef.prototype, "hostElement", {
            /**
             * Wrapper around the panel element. Can be used for advanced
             * positioning where a wrapper with specific styling is
             * required around the overlay pane.
             * @return {?}
             */
            get: function () {
                return this._host;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Attaches content, given via a Portal, to the overlay.
         * If the overlay is configured to have a backdrop, it will be created.
         *
         * @param {?} portal Portal instance to which to attach the overlay.
         * @return {?} The portal attachment result.
         */
        OverlayRef.prototype.attach = function (portal) {
            var _this = this;
            /** @type {?} */
            var attachResult = this._portalOutlet.attach(portal);
            if (this._positionStrategy) {
                this._positionStrategy.attach(this);
            }
            // Update the pane element with the given configuration.
            if (!this._host.parentElement && this._previousHostParent) {
                this._previousHostParent.appendChild(this._host);
            }
            this._updateStackingOrder();
            this._updateElementSize();
            this._updateElementDirection();
            if (this._scrollStrategy) {
                this._scrollStrategy.enable();
            }
            // Update the position once the zone is stable so that the overlay will be fully rendered
            // before attempting to position it, as the position may depend on the size of the rendered
            // content.
            this._ngZone.onStable
                .asObservable()
                .pipe(take(1))
                .subscribe(( /**
         * @return {?}
         */function () {
                // The overlay could've been detached before the zone has stabilized.
                if (_this.hasAttached()) {
                    _this.updatePosition();
                }
            }));
            // Enable pointer events for the overlay pane element.
            this._togglePointerEvents(true);
            if (this._config.hasBackdrop) {
                this._attachBackdrop();
            }
            if (this._config.panelClass) {
                this._toggleClasses(this._pane, this._config.panelClass, true);
            }
            // Only emit the `attachments` event once all other setup is done.
            this._attachments.next();
            // Track this overlay by the keyboard dispatcher
            this._keyboardDispatcher.add(this);
            // @breaking-change 8.0.0 remove the null check for `_location`
            // once the constructor parameter is made required.
            if (this._config.disposeOnNavigation && this._location) {
                this._locationChanges = this._location.subscribe(( /**
                 * @return {?}
                 */function () { return _this.dispose(); }));
            }
            return attachResult;
        };
        /**
         * Detaches an overlay from a portal.
         * @return {?} The portal detachment result.
         */
        OverlayRef.prototype.detach = function () {
            if (!this.hasAttached()) {
                return;
            }
            this.detachBackdrop();
            // When the overlay is detached, the pane element should disable pointer events.
            // This is necessary because otherwise the pane element will cover the page and disable
            // pointer events therefore. Depends on the position strategy and the applied pane boundaries.
            this._togglePointerEvents(false);
            if (this._positionStrategy && this._positionStrategy.detach) {
                this._positionStrategy.detach();
            }
            if (this._scrollStrategy) {
                this._scrollStrategy.disable();
            }
            /** @type {?} */
            var detachmentResult = this._portalOutlet.detach();
            // Only emit after everything is detached.
            this._detachments.next();
            // Remove this overlay from keyboard dispatcher tracking.
            this._keyboardDispatcher.remove(this);
            // Keeping the host element in DOM the can cause scroll jank, because it still gets
            // rendered, even though it's transparent and unclickable which is why we remove it.
            this._detachContentWhenStable();
            // Stop listening for location changes.
            this._locationChanges.unsubscribe();
            return detachmentResult;
        };
        /**
         * Cleans up the overlay from the DOM.
         * @return {?}
         */
        OverlayRef.prototype.dispose = function () {
            /** @type {?} */
            var isAttached = this.hasAttached();
            if (this._positionStrategy) {
                this._positionStrategy.dispose();
            }
            this._disposeScrollStrategy();
            this.detachBackdrop();
            this._locationChanges.unsubscribe();
            this._keyboardDispatcher.remove(this);
            this._portalOutlet.dispose();
            this._attachments.complete();
            this._backdropClick.complete();
            this._keydownEvents.complete();
            if (this._host && this._host.parentNode) {
                this._host.parentNode.removeChild(this._host);
                this._host = ( /** @type {?} */(null));
            }
            this._previousHostParent = this._pane = ( /** @type {?} */(null));
            if (isAttached) {
                this._detachments.next();
            }
            this._detachments.complete();
        };
        /**
         * Whether the overlay has attached content.
         * @return {?}
         */
        OverlayRef.prototype.hasAttached = function () {
            return this._portalOutlet.hasAttached();
        };
        /**
         * Gets an observable that emits when the backdrop has been clicked.
         * @return {?}
         */
        OverlayRef.prototype.backdropClick = function () {
            return this._backdropClick.asObservable();
        };
        /**
         * Gets an observable that emits when the overlay has been attached.
         * @return {?}
         */
        OverlayRef.prototype.attachments = function () {
            return this._attachments.asObservable();
        };
        /**
         * Gets an observable that emits when the overlay has been detached.
         * @return {?}
         */
        OverlayRef.prototype.detachments = function () {
            return this._detachments.asObservable();
        };
        /**
         * Gets an observable of keydown events targeted to this overlay.
         * @return {?}
         */
        OverlayRef.prototype.keydownEvents = function () {
            return this._keydownEventsObservable;
        };
        /**
         * Gets the current overlay configuration, which is immutable.
         * @return {?}
         */
        OverlayRef.prototype.getConfig = function () {
            return this._config;
        };
        /**
         * Updates the position of the overlay based on the position strategy.
         * @return {?}
         */
        OverlayRef.prototype.updatePosition = function () {
            if (this._positionStrategy) {
                this._positionStrategy.apply();
            }
        };
        /**
         * Switches to a new position strategy and updates the overlay position.
         * @param {?} strategy
         * @return {?}
         */
        OverlayRef.prototype.updatePositionStrategy = function (strategy) {
            if (strategy === this._positionStrategy) {
                return;
            }
            if (this._positionStrategy) {
                this._positionStrategy.dispose();
            }
            this._positionStrategy = strategy;
            if (this.hasAttached()) {
                strategy.attach(this);
                this.updatePosition();
            }
        };
        /**
         * Update the size properties of the overlay.
         * @param {?} sizeConfig
         * @return {?}
         */
        OverlayRef.prototype.updateSize = function (sizeConfig) {
            this._config = Object.assign({}, this._config, sizeConfig);
            this._updateElementSize();
        };
        /**
         * Sets the LTR/RTL direction for the overlay.
         * @param {?} dir
         * @return {?}
         */
        OverlayRef.prototype.setDirection = function (dir) {
            this._config = Object.assign({}, this._config, { direction: dir });
            this._updateElementDirection();
        };
        /**
         * Add a CSS class or an array of classes to the overlay pane.
         * @param {?} classes
         * @return {?}
         */
        OverlayRef.prototype.addPanelClass = function (classes) {
            if (this._pane) {
                this._toggleClasses(this._pane, classes, true);
            }
        };
        /**
         * Remove a CSS class or an array of classes from the overlay pane.
         * @param {?} classes
         * @return {?}
         */
        OverlayRef.prototype.removePanelClass = function (classes) {
            if (this._pane) {
                this._toggleClasses(this._pane, classes, false);
            }
        };
        /**
         * Returns the layout direction of the overlay panel.
         * @return {?}
         */
        OverlayRef.prototype.getDirection = function () {
            /** @type {?} */
            var direction = this._config.direction;
            if (!direction) {
                return 'ltr';
            }
            return typeof direction === 'string' ? direction : direction.value;
        };
        /**
         * Switches to a new scroll strategy.
         * @param {?} strategy
         * @return {?}
         */
        OverlayRef.prototype.updateScrollStrategy = function (strategy) {
            if (strategy === this._scrollStrategy) {
                return;
            }
            this._disposeScrollStrategy();
            this._scrollStrategy = strategy;
            if (this.hasAttached()) {
                strategy.attach(this);
                strategy.enable();
            }
        };
        /**
         * Updates the text direction of the overlay panel.
         * @private
         * @return {?}
         */
        OverlayRef.prototype._updateElementDirection = function () {
            this._host.setAttribute('dir', this.getDirection());
        };
        /**
         * Updates the size of the overlay element based on the overlay config.
         * @private
         * @return {?}
         */
        OverlayRef.prototype._updateElementSize = function () {
            if (!this._pane) {
                return;
            }
            /** @type {?} */
            var style = this._pane.style;
            style.width = coerceCssPixelValue(this._config.width);
            style.height = coerceCssPixelValue(this._config.height);
            style.minWidth = coerceCssPixelValue(this._config.minWidth);
            style.minHeight = coerceCssPixelValue(this._config.minHeight);
            style.maxWidth = coerceCssPixelValue(this._config.maxWidth);
            style.maxHeight = coerceCssPixelValue(this._config.maxHeight);
        };
        /**
         * Toggles the pointer events for the overlay pane element.
         * @private
         * @param {?} enablePointer
         * @return {?}
         */
        OverlayRef.prototype._togglePointerEvents = function (enablePointer) {
            this._pane.style.pointerEvents = enablePointer ? 'auto' : 'none';
        };
        /**
         * Attaches a backdrop for this overlay.
         * @private
         * @return {?}
         */
        OverlayRef.prototype._attachBackdrop = function () {
            var _this = this;
            /** @type {?} */
            var showingClass = 'cdk-overlay-backdrop-showing';
            this._backdropElement = this._document.createElement('div');
            this._backdropElement.classList.add('cdk-overlay-backdrop');
            if (this._config.backdropClass) {
                this._toggleClasses(this._backdropElement, this._config.backdropClass, true);
            }
            // Insert the backdrop before the pane in the DOM order,
            // in order to handle stacked overlays properly.
            ( /** @type {?} */(this._host.parentElement)).insertBefore(this._backdropElement, this._host);
            // Forward backdrop clicks such that the consumer of the overlay can perform whatever
            // action desired when such a click occurs (usually closing the overlay).
            this._backdropElement.addEventListener('click', this._backdropClickHandler);
            // Add class to fade-in the backdrop after one frame.
            if (typeof requestAnimationFrame !== 'undefined') {
                this._ngZone.runOutsideAngular(( /**
                 * @return {?}
                 */function () {
                    requestAnimationFrame(( /**
                     * @return {?}
                     */function () {
                        if (_this._backdropElement) {
                            _this._backdropElement.classList.add(showingClass);
                        }
                    }));
                }));
            }
            else {
                this._backdropElement.classList.add(showingClass);
            }
        };
        /**
         * Updates the stacking order of the element, moving it to the top if necessary.
         * This is required in cases where one overlay was detached, while another one,
         * that should be behind it, was destroyed. The next time both of them are opened,
         * the stacking will be wrong, because the detached element's pane will still be
         * in its original DOM position.
         * @private
         * @return {?}
         */
        OverlayRef.prototype._updateStackingOrder = function () {
            if (this._host.nextSibling) {
                ( /** @type {?} */(this._host.parentNode)).appendChild(this._host);
            }
        };
        /**
         * Detaches the backdrop (if any) associated with the overlay.
         * @return {?}
         */
        OverlayRef.prototype.detachBackdrop = function () {
            var _this = this;
            /** @type {?} */
            var backdropToDetach = this._backdropElement;
            if (!backdropToDetach) {
                return;
            }
            /** @type {?} */
            var timeoutId;
            /** @type {?} */
            var finishDetach = ( /**
             * @return {?}
             */function () {
                // It may not be attached to anything in certain cases (e.g. unit tests).
                if (backdropToDetach) {
                    backdropToDetach.removeEventListener('click', _this._backdropClickHandler);
                    backdropToDetach.removeEventListener('transitionend', finishDetach);
                    if (backdropToDetach.parentNode) {
                        backdropToDetach.parentNode.removeChild(backdropToDetach);
                    }
                }
                // It is possible that a new portal has been attached to this overlay since we started
                // removing the backdrop. If that is the case, only clear the backdrop reference if it
                // is still the same instance that we started to remove.
                if (_this._backdropElement == backdropToDetach) {
                    _this._backdropElement = null;
                }
                if (_this._config.backdropClass) {
                    _this._toggleClasses(( /** @type {?} */(backdropToDetach)), _this._config.backdropClass, false);
                }
                clearTimeout(timeoutId);
            });
            backdropToDetach.classList.remove('cdk-overlay-backdrop-showing');
            this._ngZone.runOutsideAngular(( /**
             * @return {?}
             */function () {
                ( /** @type {?} */(backdropToDetach)).addEventListener('transitionend', finishDetach);
            }));
            // If the backdrop doesn't have a transition, the `transitionend` event won't fire.
            // In this case we make it unclickable and we try to remove it after a delay.
            backdropToDetach.style.pointerEvents = 'none';
            // Run this outside the Angular zone because there's nothing that Angular cares about.
            // If it were to run inside the Angular zone, every test that used Overlay would have to be
            // either async or fakeAsync.
            timeoutId = this._ngZone.runOutsideAngular(( /**
             * @return {?}
             */function () { return setTimeout(finishDetach, 500); }));
        };
        /**
         * Toggles a single CSS class or an array of classes on an element.
         * @private
         * @param {?} element
         * @param {?} cssClasses
         * @param {?} isAdd
         * @return {?}
         */
        OverlayRef.prototype._toggleClasses = function (element, cssClasses, isAdd) {
            /** @type {?} */
            var classList = element.classList;
            coerceArray(cssClasses).forEach(( /**
             * @param {?} cssClass
             * @return {?}
             */function (/**
             * @param {?} cssClass
             * @return {?}
             */ cssClass) {
                // We can't do a spread here, because IE doesn't support setting multiple classes.
                // Also trying to add an empty string to a DOMTokenList will throw.
                if (cssClass) {
                    isAdd ? classList.add(cssClass) : classList.remove(cssClass);
                }
            }));
        };
        /**
         * Detaches the overlay content next time the zone stabilizes.
         * @private
         * @return {?}
         */
        OverlayRef.prototype._detachContentWhenStable = function () {
            var _this = this;
            // Normally we wouldn't have to explicitly run this outside the `NgZone`, however
            // if the consumer is using `zone-patch-rxjs`, the `Subscription.unsubscribe` call will
            // be patched to run inside the zone, which will throw us into an infinite loop.
            this._ngZone.runOutsideAngular(( /**
             * @return {?}
             */function () {
                // We can't remove the host here immediately, because the overlay pane's content
                // might still be animating. This stream helps us avoid interrupting the animation
                // by waiting for the pane to become empty.
                /** @type {?} */
                var subscription = _this._ngZone.onStable
                    .asObservable()
                    .pipe(takeUntil(merge(_this._attachments, _this._detachments)))
                    .subscribe(( /**
             * @return {?}
             */function () {
                    // Needs a couple of checks for the pane and host, because
                    // they may have been removed by the time the zone stabilizes.
                    if (!_this._pane || !_this._host || _this._pane.children.length === 0) {
                        if (_this._pane && _this._config.panelClass) {
                            _this._toggleClasses(_this._pane, _this._config.panelClass, false);
                        }
                        if (_this._host && _this._host.parentElement) {
                            _this._previousHostParent = _this._host.parentElement;
                            _this._previousHostParent.removeChild(_this._host);
                        }
                        subscription.unsubscribe();
                    }
                }));
            }));
        };
        /**
         * Disposes of a scroll strategy.
         * @private
         * @return {?}
         */
        OverlayRef.prototype._disposeScrollStrategy = function () {
            /** @type {?} */
            var scrollStrategy = this._scrollStrategy;
            if (scrollStrategy) {
                scrollStrategy.disable();
                if (scrollStrategy.detach) {
                    scrollStrategy.detach();
                }
            }
        };
        return OverlayRef;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // TODO: refactor clipping detection into a separate thing (part of scrolling module)
    // TODO: doesn't handle both flexible width and height when it has to scroll along both axis.
    /**
     * Class to be added to the overlay bounding box.
     * @type {?}
     */
    var boundingBoxClass = 'cdk-overlay-connected-position-bounding-box';
    /**
     * A strategy for positioning overlays. Using this strategy, an overlay is given an
     * implicit position relative some origin element. The relative position is defined in terms of
     * a point on the origin element that is connected to a point on the overlay element. For example,
     * a basic dropdown is connecting the bottom-left corner of the origin to the top-left corner
     * of the overlay.
     */
    var FlexibleConnectedPositionStrategy = /** @class */ (function () {
        /**
         * @param {?} connectedTo
         * @param {?} _viewportRuler
         * @param {?} _document
         * @param {?} _platform
         * @param {?} _overlayContainer
         */
        function FlexibleConnectedPositionStrategy(connectedTo, _viewportRuler, _document, _platform, _overlayContainer) {
            this._viewportRuler = _viewportRuler;
            this._document = _document;
            this._platform = _platform;
            this._overlayContainer = _overlayContainer;
            /**
             * Last size used for the bounding box. Used to avoid resizing the overlay after open.
             */
            this._lastBoundingBoxSize = { width: 0, height: 0 };
            /**
             * Whether the overlay was pushed in a previous positioning.
             */
            this._isPushed = false;
            /**
             * Whether the overlay can be pushed on-screen on the initial open.
             */
            this._canPush = true;
            /**
             * Whether the overlay can grow via flexible width/height after the initial open.
             */
            this._growAfterOpen = false;
            /**
             * Whether the overlay's width and height can be constrained to fit within the viewport.
             */
            this._hasFlexibleDimensions = true;
            /**
             * Whether the overlay position is locked.
             */
            this._positionLocked = false;
            /**
             * Amount of space that must be maintained between the overlay and the edge of the viewport.
             */
            this._viewportMargin = 0;
            /**
             * The Scrollable containers used to check scrollable view properties on position change.
             */
            this._scrollables = [];
            /**
             * Ordered list of preferred positions, from most to least desirable.
             */
            this._preferredPositions = [];
            /**
             * Subject that emits whenever the position changes.
             */
            this._positionChanges = new Subject();
            /**
             * Subscription to viewport size changes.
             */
            this._resizeSubscription = Subscription.EMPTY;
            /**
             * Default offset for the overlay along the x axis.
             */
            this._offsetX = 0;
            /**
             * Default offset for the overlay along the y axis.
             */
            this._offsetY = 0;
            /**
             * Keeps track of the CSS classes that the position strategy has applied on the overlay panel.
             */
            this._appliedPanelClasses = [];
            /**
             * Observable sequence of position changes.
             */
            this.positionChanges = this._positionChanges.asObservable();
            this.setOrigin(connectedTo);
        }
        Object.defineProperty(FlexibleConnectedPositionStrategy.prototype, "positions", {
            /**
             * Ordered list of preferred positions, from most to least desirable.
             * @return {?}
             */
            get: function () {
                return this._preferredPositions;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Attaches this position strategy to an overlay.
         * @param {?} overlayRef
         * @return {?}
         */
        FlexibleConnectedPositionStrategy.prototype.attach = function (overlayRef) {
            var _this = this;
            if (this._overlayRef && overlayRef !== this._overlayRef) {
                throw Error('This position strategy is already attached to an overlay');
            }
            this._validatePositions();
            overlayRef.hostElement.classList.add(boundingBoxClass);
            this._overlayRef = overlayRef;
            this._boundingBox = overlayRef.hostElement;
            this._pane = overlayRef.overlayElement;
            this._isDisposed = false;
            this._isInitialRender = true;
            this._lastPosition = null;
            this._resizeSubscription.unsubscribe();
            this._resizeSubscription = this._viewportRuler.change().subscribe(( /**
             * @return {?}
             */function () {
                // When the window is resized, we want to trigger the next reposition as if it
                // was an initial render, in order for the strategy to pick a new optimal position,
                // otherwise position locking will cause it to stay at the old one.
                _this._isInitialRender = true;
                _this.apply();
            }));
        };
        /**
         * Updates the position of the overlay element, using whichever preferred position relative
         * to the origin best fits on-screen.
         *
         * The selection of a position goes as follows:
         *  - If any positions fit completely within the viewport as-is,
         *      choose the first position that does so.
         *  - If flexible dimensions are enabled and at least one satifies the given minimum width/height,
         *      choose the position with the greatest available size modified by the positions' weight.
         *  - If pushing is enabled, take the position that went off-screen the least and push it
         *      on-screen.
         *  - If none of the previous criteria were met, use the position that goes off-screen the least.
         * \@docs-private
         * @return {?}
         */
        FlexibleConnectedPositionStrategy.prototype.apply = function () {
            var e_14, _b, e_15, _c;
            // We shouldn't do anything if the strategy was disposed or we're on the server.
            if (this._isDisposed || !this._platform.isBrowser) {
                return;
            }
            // If the position has been applied already (e.g. when the overlay was opened) and the
            // consumer opted into locking in the position, re-use the old position, in order to
            // prevent the overlay from jumping around.
            if (!this._isInitialRender && this._positionLocked && this._lastPosition) {
                this.reapplyLastPosition();
                return;
            }
            this._clearPanelClasses();
            this._resetOverlayElementStyles();
            this._resetBoundingBoxStyles();
            // We need the bounding rects for the origin and the overlay to determine how to position
            // the overlay relative to the origin.
            // We use the viewport rect to determine whether a position would go off-screen.
            this._viewportRect = this._getNarrowedViewportRect();
            this._originRect = this._getOriginRect();
            this._overlayRect = this._pane.getBoundingClientRect();
            /** @type {?} */
            var originRect = this._originRect;
            /** @type {?} */
            var overlayRect = this._overlayRect;
            /** @type {?} */
            var viewportRect = this._viewportRect;
            // Positions where the overlay will fit with flexible dimensions.
            /** @type {?} */
            var flexibleFits = [];
            // Fallback if none of the preferred positions fit within the viewport.
            /** @type {?} */
            var fallback;
            try {
                // Go through each of the preferred positions looking for a good fit.
                // If a good fit is found, it will be applied immediately.
                for (var _d = __values(this._preferredPositions), _e = _d.next(); !_e.done; _e = _d.next()) {
                    var pos = _e.value;
                    // Get the exact (x, y) coordinate for the point-of-origin on the origin element.
                    /** @type {?} */
                    var originPoint = this._getOriginPoint(originRect, pos);
                    // From that point-of-origin, get the exact (x, y) coordinate for the top-left corner of the
                    // overlay in this position. We use the top-left corner for calculations and later translate
                    // this into an appropriate (top, left, bottom, right) style.
                    /** @type {?} */
                    var overlayPoint = this._getOverlayPoint(originPoint, overlayRect, pos);
                    // Calculate how well the overlay would fit into the viewport with this point.
                    /** @type {?} */
                    var overlayFit = this._getOverlayFit(overlayPoint, overlayRect, viewportRect, pos);
                    // If the overlay, without any further work, fits into the viewport, use this position.
                    if (overlayFit.isCompletelyWithinViewport) {
                        this._isPushed = false;
                        this._applyPosition(pos, originPoint);
                        return;
                    }
                    // If the overlay has flexible dimensions, we can use this position
                    // so long as there's enough space for the minimum dimensions.
                    if (this._canFitWithFlexibleDimensions(overlayFit, overlayPoint, viewportRect)) {
                        // Save positions where the overlay will fit with flexible dimensions. We will use these
                        // if none of the positions fit *without* flexible dimensions.
                        flexibleFits.push({
                            position: pos,
                            origin: originPoint,
                            overlayRect: overlayRect,
                            boundingBoxRect: this._calculateBoundingBoxRect(originPoint, pos)
                        });
                        continue;
                    }
                    // If the current preferred position does not fit on the screen, remember the position
                    // if it has more visible area on-screen than we've seen and move onto the next preferred
                    // position.
                    if (!fallback || fallback.overlayFit.visibleArea < overlayFit.visibleArea) {
                        fallback = { overlayFit: overlayFit, overlayPoint: overlayPoint, originPoint: originPoint, position: pos, overlayRect: overlayRect };
                    }
                }
            }
            catch (e_14_1) { e_14 = { error: e_14_1 }; }
            finally {
                try {
                    if (_e && !_e.done && (_b = _d.return)) _b.call(_d);
                }
                finally { if (e_14) throw e_14.error; }
            }
            // If there are any positions where the overlay would fit with flexible dimensions, choose the
            // one that has the greatest area available modified by the position's weight
            if (flexibleFits.length) {
                /** @type {?} */
                var bestFit = null;
                /** @type {?} */
                var bestScore = -1;
                try {
                    for (var flexibleFits_1 = __values(flexibleFits), flexibleFits_1_1 = flexibleFits_1.next(); !flexibleFits_1_1.done; flexibleFits_1_1 = flexibleFits_1.next()) {
                        var fit = flexibleFits_1_1.value;
                        /** @type {?} */
                        var score = fit.boundingBoxRect.width * fit.boundingBoxRect.height * (fit.position.weight || 1);
                        if (score > bestScore) {
                            bestScore = score;
                            bestFit = fit;
                        }
                    }
                }
                catch (e_15_1) { e_15 = { error: e_15_1 }; }
                finally {
                    try {
                        if (flexibleFits_1_1 && !flexibleFits_1_1.done && (_c = flexibleFits_1.return)) _c.call(flexibleFits_1);
                    }
                    finally { if (e_15) throw e_15.error; }
                }
                this._isPushed = false;
                this._applyPosition(( /** @type {?} */(bestFit)).position, ( /** @type {?} */(bestFit)).origin);
                return;
            }
            // When none of the preferred positions fit within the viewport, take the position
            // that went off-screen the least and attempt to push it on-screen.
            if (this._canPush) {
                // TODO(jelbourn): after pushing, the opening "direction" of the overlay might not make sense.
                this._isPushed = true;
                this._applyPosition(( /** @type {?} */(fallback)).position, ( /** @type {?} */(fallback)).originPoint);
                return;
            }
            // All options for getting the overlay within the viewport have been exhausted, so go with the
            // position that went off-screen the least.
            this._applyPosition(( /** @type {?} */(fallback)).position, ( /** @type {?} */(fallback)).originPoint);
        };
        /**
         * @return {?}
         */
        FlexibleConnectedPositionStrategy.prototype.detach = function () {
            this._clearPanelClasses();
            this._lastPosition = null;
            this._previousPushAmount = null;
            this._resizeSubscription.unsubscribe();
        };
        /**
         * Cleanup after the element gets destroyed.
         * @return {?}
         */
        FlexibleConnectedPositionStrategy.prototype.dispose = function () {
            if (this._isDisposed) {
                return;
            }
            // We can't use `_resetBoundingBoxStyles` here, because it resets
            // some properties to zero, rather than removing them.
            if (this._boundingBox) {
                extendStyles(this._boundingBox.style, ( /** @type {?} */({
                    top: '',
                    left: '',
                    right: '',
                    bottom: '',
                    height: '',
                    width: '',
                    alignItems: '',
                    justifyContent: '',
                })));
            }
            if (this._pane) {
                this._resetOverlayElementStyles();
            }
            if (this._overlayRef) {
                this._overlayRef.hostElement.classList.remove(boundingBoxClass);
            }
            this.detach();
            this._positionChanges.complete();
            this._overlayRef = this._boundingBox = ( /** @type {?} */(null));
            this._isDisposed = true;
        };
        /**
         * This re-aligns the overlay element with the trigger in its last calculated position,
         * even if a position higher in the "preferred positions" list would now fit. This
         * allows one to re-align the panel without changing the orientation of the panel.
         * @return {?}
         */
        FlexibleConnectedPositionStrategy.prototype.reapplyLastPosition = function () {
            if (!this._isDisposed && (!this._platform || this._platform.isBrowser)) {
                this._originRect = this._getOriginRect();
                this._overlayRect = this._pane.getBoundingClientRect();
                this._viewportRect = this._getNarrowedViewportRect();
                /** @type {?} */
                var lastPosition = this._lastPosition || this._preferredPositions[0];
                /** @type {?} */
                var originPoint = this._getOriginPoint(this._originRect, lastPosition);
                this._applyPosition(lastPosition, originPoint);
            }
        };
        /**
         * Sets the list of Scrollable containers that host the origin element so that
         * on reposition we can evaluate if it or the overlay has been clipped or outside view. Every
         * Scrollable must be an ancestor element of the strategy's origin element.
         * @template THIS
         * @this {THIS}
         * @param {?} scrollables
         * @return {THIS}
         */
        FlexibleConnectedPositionStrategy.prototype.withScrollableContainers = function (scrollables) {
            ( /** @type {?} */(this))._scrollables = scrollables;
            return ( /** @type {?} */(this));
        };
        /**
         * Adds new preferred positions.
         * @template THIS
         * @this {THIS}
         * @param {?} positions List of positions options for this overlay.
         * @return {THIS}
         */
        FlexibleConnectedPositionStrategy.prototype.withPositions = function (positions) {
            ( /** @type {?} */(this))._preferredPositions = positions;
            // If the last calculated position object isn't part of the positions anymore, clear
            // it in order to avoid it being picked up if the consumer tries to re-apply.
            if (positions.indexOf(( /** @type {?} */(( /** @type {?} */(this))._lastPosition))) === -1) {
                ( /** @type {?} */(this))._lastPosition = null;
            }
            ( /** @type {?} */(this))._validatePositions();
            return ( /** @type {?} */(this));
        };
        /**
         * Sets a minimum distance the overlay may be positioned to the edge of the viewport.
         * @template THIS
         * @this {THIS}
         * @param {?} margin Required margin between the overlay and the viewport edge in pixels.
         * @return {THIS}
         */
        FlexibleConnectedPositionStrategy.prototype.withViewportMargin = function (margin) {
            ( /** @type {?} */(this))._viewportMargin = margin;
            return ( /** @type {?} */(this));
        };
        /**
         * Sets whether the overlay's width and height can be constrained to fit within the viewport.
         * @template THIS
         * @this {THIS}
         * @param {?=} flexibleDimensions
         * @return {THIS}
         */
        FlexibleConnectedPositionStrategy.prototype.withFlexibleDimensions = function (flexibleDimensions) {
            if (flexibleDimensions === void 0) { flexibleDimensions = true; }
            ( /** @type {?} */(this))._hasFlexibleDimensions = flexibleDimensions;
            return ( /** @type {?} */(this));
        };
        /**
         * Sets whether the overlay can grow after the initial open via flexible width/height.
         * @template THIS
         * @this {THIS}
         * @param {?=} growAfterOpen
         * @return {THIS}
         */
        FlexibleConnectedPositionStrategy.prototype.withGrowAfterOpen = function (growAfterOpen) {
            if (growAfterOpen === void 0) { growAfterOpen = true; }
            ( /** @type {?} */(this))._growAfterOpen = growAfterOpen;
            return ( /** @type {?} */(this));
        };
        /**
         * Sets whether the overlay can be pushed on-screen if none of the provided positions fit.
         * @template THIS
         * @this {THIS}
         * @param {?=} canPush
         * @return {THIS}
         */
        FlexibleConnectedPositionStrategy.prototype.withPush = function (canPush) {
            if (canPush === void 0) { canPush = true; }
            ( /** @type {?} */(this))._canPush = canPush;
            return ( /** @type {?} */(this));
        };
        /**
         * Sets whether the overlay's position should be locked in after it is positioned
         * initially. When an overlay is locked in, it won't attempt to reposition itself
         * when the position is re-applied (e.g. when the user scrolls away).
         * @template THIS
         * @this {THIS}
         * @param {?=} isLocked Whether the overlay should locked in.
         * @return {THIS}
         */
        FlexibleConnectedPositionStrategy.prototype.withLockedPosition = function (isLocked) {
            if (isLocked === void 0) { isLocked = true; }
            ( /** @type {?} */(this))._positionLocked = isLocked;
            return ( /** @type {?} */(this));
        };
        /**
         * Sets the origin, relative to which to position the overlay.
         * Using an element origin is useful for building components that need to be positioned
         * relatively to a trigger (e.g. dropdown menus or tooltips), whereas using a point can be
         * used for cases like contextual menus which open relative to the user's pointer.
         * @template THIS
         * @this {THIS}
         * @param {?} origin Reference to the new origin.
         * @return {THIS}
         */
        FlexibleConnectedPositionStrategy.prototype.setOrigin = function (origin) {
            ( /** @type {?} */(this))._origin = origin;
            return ( /** @type {?} */(this));
        };
        /**
         * Sets the default offset for the overlay's connection point on the x-axis.
         * @template THIS
         * @this {THIS}
         * @param {?} offset New offset in the X axis.
         * @return {THIS}
         */
        FlexibleConnectedPositionStrategy.prototype.withDefaultOffsetX = function (offset) {
            ( /** @type {?} */(this))._offsetX = offset;
            return ( /** @type {?} */(this));
        };
        /**
         * Sets the default offset for the overlay's connection point on the y-axis.
         * @template THIS
         * @this {THIS}
         * @param {?} offset New offset in the Y axis.
         * @return {THIS}
         */
        FlexibleConnectedPositionStrategy.prototype.withDefaultOffsetY = function (offset) {
            ( /** @type {?} */(this))._offsetY = offset;
            return ( /** @type {?} */(this));
        };
        /**
         * Configures that the position strategy should set a `transform-origin` on some elements
         * inside the overlay, depending on the current position that is being applied. This is
         * useful for the cases where the origin of an animation can change depending on the
         * alignment of the overlay.
         * @template THIS
         * @this {THIS}
         * @param {?} selector CSS selector that will be used to find the target
         *    elements onto which to set the transform origin.
         * @return {THIS}
         */
        FlexibleConnectedPositionStrategy.prototype.withTransformOriginOn = function (selector) {
            ( /** @type {?} */(this))._transformOriginSelector = selector;
            return ( /** @type {?} */(this));
        };
        /**
         * Gets the (x, y) coordinate of a connection point on the origin based on a relative position.
         * @private
         * @param {?} originRect
         * @param {?} pos
         * @return {?}
         */
        FlexibleConnectedPositionStrategy.prototype._getOriginPoint = function (originRect, pos) {
            /** @type {?} */
            var x;
            if (pos.originX == 'center') {
                // Note: when centering we should always use the `left`
                // offset, otherwise the position will be wrong in RTL.
                x = originRect.left + (originRect.width / 2);
            }
            else {
                /** @type {?} */
                var startX = this._isRtl() ? originRect.right : originRect.left;
                /** @type {?} */
                var endX = this._isRtl() ? originRect.left : originRect.right;
                x = pos.originX == 'start' ? startX : endX;
            }
            /** @type {?} */
            var y;
            if (pos.originY == 'center') {
                y = originRect.top + (originRect.height / 2);
            }
            else {
                y = pos.originY == 'top' ? originRect.top : originRect.bottom;
            }
            return { x: x, y: y };
        };
        /**
         * Gets the (x, y) coordinate of the top-left corner of the overlay given a given position and
         * origin point to which the overlay should be connected.
         * @private
         * @param {?} originPoint
         * @param {?} overlayRect
         * @param {?} pos
         * @return {?}
         */
        FlexibleConnectedPositionStrategy.prototype._getOverlayPoint = function (originPoint, overlayRect, pos) {
            // Calculate the (overlayStartX, overlayStartY), the start of the
            // potential overlay position relative to the origin point.
            /** @type {?} */
            var overlayStartX;
            if (pos.overlayX == 'center') {
                overlayStartX = -overlayRect.width / 2;
            }
            else if (pos.overlayX === 'start') {
                overlayStartX = this._isRtl() ? -overlayRect.width : 0;
            }
            else {
                overlayStartX = this._isRtl() ? 0 : -overlayRect.width;
            }
            /** @type {?} */
            var overlayStartY;
            if (pos.overlayY == 'center') {
                overlayStartY = -overlayRect.height / 2;
            }
            else {
                overlayStartY = pos.overlayY == 'top' ? 0 : -overlayRect.height;
            }
            // The (x, y) coordinates of the overlay.
            return {
                x: originPoint.x + overlayStartX,
                y: originPoint.y + overlayStartY,
            };
        };
        /**
         * Gets how well an overlay at the given point will fit within the viewport.
         * @private
         * @param {?} point
         * @param {?} overlay
         * @param {?} viewport
         * @param {?} position
         * @return {?}
         */
        FlexibleConnectedPositionStrategy.prototype._getOverlayFit = function (point, overlay, viewport, position) {
            var x = point.x, y = point.y;
            /** @type {?} */
            var offsetX = this._getOffset(position, 'x');
            /** @type {?} */
            var offsetY = this._getOffset(position, 'y');
            // Account for the offsets since they could push the overlay out of the viewport.
            if (offsetX) {
                x += offsetX;
            }
            if (offsetY) {
                y += offsetY;
            }
            // How much the overlay would overflow at this position, on each side.
            /** @type {?} */
            var leftOverflow = 0 - x;
            /** @type {?} */
            var rightOverflow = (x + overlay.width) - viewport.width;
            /** @type {?} */
            var topOverflow = 0 - y;
            /** @type {?} */
            var bottomOverflow = (y + overlay.height) - viewport.height;
            // Visible parts of the element on each axis.
            /** @type {?} */
            var visibleWidth = this._subtractOverflows(overlay.width, leftOverflow, rightOverflow);
            /** @type {?} */
            var visibleHeight = this._subtractOverflows(overlay.height, topOverflow, bottomOverflow);
            /** @type {?} */
            var visibleArea = visibleWidth * visibleHeight;
            return {
                visibleArea: visibleArea,
                isCompletelyWithinViewport: (overlay.width * overlay.height) === visibleArea,
                fitsInViewportVertically: visibleHeight === overlay.height,
                fitsInViewportHorizontally: visibleWidth == overlay.width,
            };
        };
        /**
         * Whether the overlay can fit within the viewport when it may resize either its width or height.
         * @private
         * @param {?} fit How well the overlay fits in the viewport at some position.
         * @param {?} point The (x, y) coordinates of the overlat at some position.
         * @param {?} viewport The geometry of the viewport.
         * @return {?}
         */
        FlexibleConnectedPositionStrategy.prototype._canFitWithFlexibleDimensions = function (fit, point, viewport) {
            if (this._hasFlexibleDimensions) {
                /** @type {?} */
                var availableHeight = viewport.bottom - point.y;
                /** @type {?} */
                var availableWidth = viewport.right - point.x;
                /** @type {?} */
                var minHeight = this._overlayRef.getConfig().minHeight;
                /** @type {?} */
                var minWidth = this._overlayRef.getConfig().minWidth;
                /** @type {?} */
                var verticalFit = fit.fitsInViewportVertically ||
                    (minHeight != null && minHeight <= availableHeight);
                /** @type {?} */
                var horizontalFit = fit.fitsInViewportHorizontally ||
                    (minWidth != null && minWidth <= availableWidth);
                return verticalFit && horizontalFit;
            }
            return false;
        };
        /**
         * Gets the point at which the overlay can be "pushed" on-screen. If the overlay is larger than
         * the viewport, the top-left corner will be pushed on-screen (with overflow occuring on the
         * right and bottom).
         *
         * @private
         * @param {?} start Starting point from which the overlay is pushed.
         * @param {?} overlay Dimensions of the overlay.
         * @param {?} scrollPosition Current viewport scroll position.
         * @return {?} The point at which to position the overlay after pushing. This is effectively a new
         *     originPoint.
         */
        FlexibleConnectedPositionStrategy.prototype._pushOverlayOnScreen = function (start, overlay, scrollPosition) {
            // If the position is locked and we've pushed the overlay already, reuse the previous push
            // amount, rather than pushing it again. If we were to continue pushing, the element would
            // remain in the viewport, which goes against the expectations when position locking is enabled.
            if (this._previousPushAmount && this._positionLocked) {
                return {
                    x: start.x + this._previousPushAmount.x,
                    y: start.y + this._previousPushAmount.y
                };
            }
            /** @type {?} */
            var viewport = this._viewportRect;
            // Determine how much the overlay goes outside the viewport on each
            // side, which we'll use to decide which direction to push it.
            /** @type {?} */
            var overflowRight = Math.max(start.x + overlay.width - viewport.right, 0);
            /** @type {?} */
            var overflowBottom = Math.max(start.y + overlay.height - viewport.bottom, 0);
            /** @type {?} */
            var overflowTop = Math.max(viewport.top - scrollPosition.top - start.y, 0);
            /** @type {?} */
            var overflowLeft = Math.max(viewport.left - scrollPosition.left - start.x, 0);
            // Amount by which to push the overlay in each axis such that it remains on-screen.
            /** @type {?} */
            var pushX = 0;
            /** @type {?} */
            var pushY = 0;
            // If the overlay fits completely within the bounds of the viewport, push it from whichever
            // direction is goes off-screen. Otherwise, push the top-left corner such that its in the
            // viewport and allow for the trailing end of the overlay to go out of bounds.
            if (overlay.width <= viewport.width) {
                pushX = overflowLeft || -overflowRight;
            }
            else {
                pushX = start.x < this._viewportMargin ? (viewport.left - scrollPosition.left) - start.x : 0;
            }
            if (overlay.height <= viewport.height) {
                pushY = overflowTop || -overflowBottom;
            }
            else {
                pushY = start.y < this._viewportMargin ? (viewport.top - scrollPosition.top) - start.y : 0;
            }
            this._previousPushAmount = { x: pushX, y: pushY };
            return {
                x: start.x + pushX,
                y: start.y + pushY,
            };
        };
        /**
         * Applies a computed position to the overlay and emits a position change.
         * @private
         * @param {?} position The position preference
         * @param {?} originPoint The point on the origin element where the overlay is connected.
         * @return {?}
         */
        FlexibleConnectedPositionStrategy.prototype._applyPosition = function (position, originPoint) {
            this._setTransformOrigin(position);
            this._setOverlayElementStyles(originPoint, position);
            this._setBoundingBoxStyles(originPoint, position);
            if (position.panelClass) {
                this._addPanelClasses(position.panelClass);
            }
            // Save the last connected position in case the position needs to be re-calculated.
            this._lastPosition = position;
            // Notify that the position has been changed along with its change properties.
            // We only emit if we've got any subscriptions, because the scroll visibility
            // calculcations can be somewhat expensive.
            if (this._positionChanges.observers.length) {
                /** @type {?} */
                var scrollableViewProperties = this._getScrollVisibility();
                /** @type {?} */
                var changeEvent = new ConnectedOverlayPositionChange(position, scrollableViewProperties);
                this._positionChanges.next(changeEvent);
            }
            this._isInitialRender = false;
        };
        /**
         * Sets the transform origin based on the configured selector and the passed-in position.
         * @private
         * @param {?} position
         * @return {?}
         */
        FlexibleConnectedPositionStrategy.prototype._setTransformOrigin = function (position) {
            if (!this._transformOriginSelector) {
                return;
            }
            /** @type {?} */
            var elements = ( /** @type {?} */(this._boundingBox)).querySelectorAll(this._transformOriginSelector);
            /** @type {?} */
            var xOrigin;
            /** @type {?} */
            var yOrigin = position.overlayY;
            if (position.overlayX === 'center') {
                xOrigin = 'center';
            }
            else if (this._isRtl()) {
                xOrigin = position.overlayX === 'start' ? 'right' : 'left';
            }
            else {
                xOrigin = position.overlayX === 'start' ? 'left' : 'right';
            }
            for (var i_157 = 0; i_157 < elements.length; i_157++) {
                elements[i_157].style.transformOrigin = xOrigin + " " + yOrigin;
            }
        };
        /**
         * Gets the position and size of the overlay's sizing container.
         *
         * This method does no measuring and applies no styles so that we can cheaply compute the
         * bounds for all positions and choose the best fit based on these results.
         * @private
         * @param {?} origin
         * @param {?} position
         * @return {?}
         */
        FlexibleConnectedPositionStrategy.prototype._calculateBoundingBoxRect = function (origin, position) {
            /** @type {?} */
            var viewport = this._viewportRect;
            /** @type {?} */
            var isRtl = this._isRtl();
            /** @type {?} */
            var height;
            /** @type {?} */
            var top;
            /** @type {?} */
            var bottom;
            if (position.overlayY === 'top') {
                // Overlay is opening "downward" and thus is bound by the bottom viewport edge.
                top = origin.y;
                height = viewport.height - top + this._viewportMargin;
            }
            else if (position.overlayY === 'bottom') {
                // Overlay is opening "upward" and thus is bound by the top viewport edge. We need to add
                // the viewport margin back in, because the viewport rect is narrowed down to remove the
                // margin, whereas the `origin` position is calculated based on its `ClientRect`.
                bottom = viewport.height - origin.y + this._viewportMargin * 2;
                height = viewport.height - bottom + this._viewportMargin;
            }
            else {
                // If neither top nor bottom, it means that the overlay is vertically centered on the
                // origin point. Note that we want the position relative to the viewport, rather than
                // the page, which is why we don't use something like `viewport.bottom - origin.y` and
                // `origin.y - viewport.top`.
                /** @type {?} */
                var smallestDistanceToViewportEdge = Math.min(viewport.bottom - origin.y + viewport.top, origin.y);
                /** @type {?} */
                var previousHeight = this._lastBoundingBoxSize.height;
                height = smallestDistanceToViewportEdge * 2;
                top = origin.y - smallestDistanceToViewportEdge;
                if (height > previousHeight && !this._isInitialRender && !this._growAfterOpen) {
                    top = origin.y - (previousHeight / 2);
                }
            }
            // The overlay is opening 'right-ward' (the content flows to the right).
            /** @type {?} */
            var isBoundedByRightViewportEdge = (position.overlayX === 'start' && !isRtl) ||
                (position.overlayX === 'end' && isRtl);
            // The overlay is opening 'left-ward' (the content flows to the left).
            /** @type {?} */
            var isBoundedByLeftViewportEdge = (position.overlayX === 'end' && !isRtl) ||
                (position.overlayX === 'start' && isRtl);
            /** @type {?} */
            var width;
            /** @type {?} */
            var left;
            /** @type {?} */
            var right;
            if (isBoundedByLeftViewportEdge) {
                right = viewport.width - origin.x + this._viewportMargin;
                width = origin.x - this._viewportMargin;
            }
            else if (isBoundedByRightViewportEdge) {
                left = origin.x;
                width = viewport.right - origin.x;
            }
            else {
                // If neither start nor end, it means that the overlay is horizontally centered on the
                // origin point. Note that we want the position relative to the viewport, rather than
                // the page, which is why we don't use something like `viewport.right - origin.x` and
                // `origin.x - viewport.left`.
                /** @type {?} */
                var smallestDistanceToViewportEdge = Math.min(viewport.right - origin.x + viewport.left, origin.x);
                /** @type {?} */
                var previousWidth = this._lastBoundingBoxSize.width;
                width = smallestDistanceToViewportEdge * 2;
                left = origin.x - smallestDistanceToViewportEdge;
                if (width > previousWidth && !this._isInitialRender && !this._growAfterOpen) {
                    left = origin.x - (previousWidth / 2);
                }
            }
            return { top: ( /** @type {?} */(top)), left: ( /** @type {?} */(left)), bottom: ( /** @type {?} */(bottom)), right: ( /** @type {?} */(right)), width: width, height: height };
        };
        /**
         * Sets the position and size of the overlay's sizing wrapper. The wrapper is positioned on the
         * origin's connection point and stetches to the bounds of the viewport.
         *
         * @private
         * @param {?} origin The point on the origin element where the overlay is connected.
         * @param {?} position The position preference
         * @return {?}
         */
        FlexibleConnectedPositionStrategy.prototype._setBoundingBoxStyles = function (origin, position) {
            /** @type {?} */
            var boundingBoxRect = this._calculateBoundingBoxRect(origin, position);
            // It's weird if the overlay *grows* while scrolling, so we take the last size into account
            // when applying a new size.
            if (!this._isInitialRender && !this._growAfterOpen) {
                boundingBoxRect.height = Math.min(boundingBoxRect.height, this._lastBoundingBoxSize.height);
                boundingBoxRect.width = Math.min(boundingBoxRect.width, this._lastBoundingBoxSize.width);
            }
            /** @type {?} */
            var styles = ( /** @type {?} */({}));
            if (this._hasExactPosition()) {
                styles.top = styles.left = '0';
                styles.bottom = styles.right = '';
                styles.width = styles.height = '100%';
            }
            else {
                /** @type {?} */
                var maxHeight = this._overlayRef.getConfig().maxHeight;
                /** @type {?} */
                var maxWidth = this._overlayRef.getConfig().maxWidth;
                styles.height = coerceCssPixelValue(boundingBoxRect.height);
                styles.top = coerceCssPixelValue(boundingBoxRect.top);
                styles.bottom = coerceCssPixelValue(boundingBoxRect.bottom);
                styles.width = coerceCssPixelValue(boundingBoxRect.width);
                styles.left = coerceCssPixelValue(boundingBoxRect.left);
                styles.right = coerceCssPixelValue(boundingBoxRect.right);
                // Push the pane content towards the proper direction.
                if (position.overlayX === 'center') {
                    styles.alignItems = 'center';
                }
                else {
                    styles.alignItems = position.overlayX === 'end' ? 'flex-end' : 'flex-start';
                }
                if (position.overlayY === 'center') {
                    styles.justifyContent = 'center';
                }
                else {
                    styles.justifyContent = position.overlayY === 'bottom' ? 'flex-end' : 'flex-start';
                }
                if (maxHeight) {
                    styles.maxHeight = coerceCssPixelValue(maxHeight);
                }
                if (maxWidth) {
                    styles.maxWidth = coerceCssPixelValue(maxWidth);
                }
            }
            this._lastBoundingBoxSize = boundingBoxRect;
            extendStyles(( /** @type {?} */(this._boundingBox)).style, styles);
        };
        /**
         * Resets the styles for the bounding box so that a new positioning can be computed.
         * @private
         * @return {?}
         */
        FlexibleConnectedPositionStrategy.prototype._resetBoundingBoxStyles = function () {
            extendStyles(( /** @type {?} */(this._boundingBox)).style, ( /** @type {?} */({
                top: '0',
                left: '0',
                right: '0',
                bottom: '0',
                height: '',
                width: '',
                alignItems: '',
                justifyContent: '',
            })));
        };
        /**
         * Resets the styles for the overlay pane so that a new positioning can be computed.
         * @private
         * @return {?}
         */
        FlexibleConnectedPositionStrategy.prototype._resetOverlayElementStyles = function () {
            extendStyles(this._pane.style, ( /** @type {?} */({
                top: '',
                left: '',
                bottom: '',
                right: '',
                position: '',
                transform: '',
            })));
        };
        /**
         * Sets positioning styles to the overlay element.
         * @private
         * @param {?} originPoint
         * @param {?} position
         * @return {?}
         */
        FlexibleConnectedPositionStrategy.prototype._setOverlayElementStyles = function (originPoint, position) {
            /** @type {?} */
            var styles = ( /** @type {?} */({}));
            if (this._hasExactPosition()) {
                /** @type {?} */
                var scrollPosition = this._viewportRuler.getViewportScrollPosition();
                extendStyles(styles, this._getExactOverlayY(position, originPoint, scrollPosition));
                extendStyles(styles, this._getExactOverlayX(position, originPoint, scrollPosition));
            }
            else {
                styles.position = 'static';
            }
            // Use a transform to apply the offsets. We do this because the `center` positions rely on
            // being in the normal flex flow and setting a `top` / `left` at all will completely throw
            // off the position. We also can't use margins, because they won't have an effect in some
            // cases where the element doesn't have anything to "push off of". Finally, this works
            // better both with flexible and non-flexible positioning.
            /** @type {?} */
            var transformString = '';
            /** @type {?} */
            var offsetX = this._getOffset(position, 'x');
            /** @type {?} */
            var offsetY = this._getOffset(position, 'y');
            if (offsetX) {
                transformString += "translateX(" + offsetX + "px) ";
            }
            if (offsetY) {
                transformString += "translateY(" + offsetY + "px)";
            }
            styles.transform = transformString.trim();
            // If a maxWidth or maxHeight is specified on the overlay, we remove them. We do this because
            // we need these values to both be set to "100%" for the automatic flexible sizing to work.
            // The maxHeight and maxWidth are set on the boundingBox in order to enforce the constraint.
            if (this._hasFlexibleDimensions && this._overlayRef.getConfig().maxHeight) {
                styles.maxHeight = '';
            }
            if (this._hasFlexibleDimensions && this._overlayRef.getConfig().maxWidth) {
                styles.maxWidth = '';
            }
            extendStyles(this._pane.style, styles);
        };
        /**
         * Gets the exact top/bottom for the overlay when not using flexible sizing or when pushing.
         * @private
         * @param {?} position
         * @param {?} originPoint
         * @param {?} scrollPosition
         * @return {?}
         */
        FlexibleConnectedPositionStrategy.prototype._getExactOverlayY = function (position, originPoint, scrollPosition) {
            // Reset any existing styles. This is necessary in case the
            // preferred position has changed since the last `apply`.
            /** @type {?} */
            var styles = ( /** @type {?} */({ top: null, bottom: null }));
            /** @type {?} */
            var overlayPoint = this._getOverlayPoint(originPoint, this._overlayRect, position);
            if (this._isPushed) {
                overlayPoint = this._pushOverlayOnScreen(overlayPoint, this._overlayRect, scrollPosition);
            }
            /** @type {?} */
            var virtualKeyboardOffset = this._overlayContainer.getContainerElement().getBoundingClientRect().top;
            // Normally this would be zero, however when the overlay is attached to an input (e.g. in an
            // autocomplete), mobile browsers will shift everything in order to put the input in the middle
            // of the screen and to make space for the virtual keyboard. We need to account for this offset,
            // otherwise our positioning will be thrown off.
            overlayPoint.y -= virtualKeyboardOffset;
            // We want to set either `top` or `bottom` based on whether the overlay wants to appear
            // above or below the origin and the direction in which the element will expand.
            if (position.overlayY === 'bottom') {
                // When using `bottom`, we adjust the y position such that it is the distance
                // from the bottom of the viewport rather than the top.
                /** @type {?} */
                var documentHeight = ( /** @type {?} */(this._document.documentElement)).clientHeight;
                styles.bottom = documentHeight - (overlayPoint.y + this._overlayRect.height) + "px";
            }
            else {
                styles.top = coerceCssPixelValue(overlayPoint.y);
            }
            return styles;
        };
        /**
         * Gets the exact left/right for the overlay when not using flexible sizing or when pushing.
         * @private
         * @param {?} position
         * @param {?} originPoint
         * @param {?} scrollPosition
         * @return {?}
         */
        FlexibleConnectedPositionStrategy.prototype._getExactOverlayX = function (position, originPoint, scrollPosition) {
            // Reset any existing styles. This is necessary in case the preferred position has
            // changed since the last `apply`.
            /** @type {?} */
            var styles = ( /** @type {?} */({ left: null, right: null }));
            /** @type {?} */
            var overlayPoint = this._getOverlayPoint(originPoint, this._overlayRect, position);
            if (this._isPushed) {
                overlayPoint = this._pushOverlayOnScreen(overlayPoint, this._overlayRect, scrollPosition);
            }
            // We want to set either `left` or `right` based on whether the overlay wants to appear "before"
            // or "after" the origin, which determines the direction in which the element will expand.
            // For the horizontal axis, the meaning of "before" and "after" change based on whether the
            // page is in RTL or LTR.
            /** @type {?} */
            var horizontalStyleProperty;
            if (this._isRtl()) {
                horizontalStyleProperty = position.overlayX === 'end' ? 'left' : 'right';
            }
            else {
                horizontalStyleProperty = position.overlayX === 'end' ? 'right' : 'left';
            }
            // When we're setting `right`, we adjust the x position such that it is the distance
            // from the right edge of the viewport rather than the left edge.
            if (horizontalStyleProperty === 'right') {
                /** @type {?} */
                var documentWidth = ( /** @type {?} */(this._document.documentElement)).clientWidth;
                styles.right = documentWidth - (overlayPoint.x + this._overlayRect.width) + "px";
            }
            else {
                styles.left = coerceCssPixelValue(overlayPoint.x);
            }
            return styles;
        };
        /**
         * Gets the view properties of the trigger and overlay, including whether they are clipped
         * or completely outside the view of any of the strategy's scrollables.
         * @private
         * @return {?}
         */
        FlexibleConnectedPositionStrategy.prototype._getScrollVisibility = function () {
            // Note: needs fresh rects since the position could've changed.
            /** @type {?} */
            var originBounds = this._getOriginRect();
            /** @type {?} */
            var overlayBounds = this._pane.getBoundingClientRect();
            // TODO(jelbourn): instead of needing all of the client rects for these scrolling containers
            // every time, we should be able to use the scrollTop of the containers if the size of those
            // containers hasn't changed.
            /** @type {?} */
            var scrollContainerBounds = this._scrollables.map(( /**
             * @param {?} scrollable
             * @return {?}
             */function (/**
             * @param {?} scrollable
             * @return {?}
             */ scrollable) {
                return scrollable.getElementRef().nativeElement.getBoundingClientRect();
            }));
            return {
                isOriginClipped: isElementClippedByScrolling(originBounds, scrollContainerBounds),
                isOriginOutsideView: isElementScrolledOutsideView(originBounds, scrollContainerBounds),
                isOverlayClipped: isElementClippedByScrolling(overlayBounds, scrollContainerBounds),
                isOverlayOutsideView: isElementScrolledOutsideView(overlayBounds, scrollContainerBounds),
            };
        };
        /**
         * Subtracts the amount that an element is overflowing on an axis from its length.
         * @private
         * @param {?} length
         * @param {...?} overflows
         * @return {?}
         */
        FlexibleConnectedPositionStrategy.prototype._subtractOverflows = function (length) {
            var overflows = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                overflows[_i - 1] = arguments[_i];
            }
            return overflows.reduce(( /**
             * @param {?} currentValue
             * @param {?} currentOverflow
             * @return {?}
             */function (currentValue, currentOverflow) {
                return currentValue - Math.max(currentOverflow, 0);
            }), length);
        };
        /**
         * Narrows the given viewport rect by the current _viewportMargin.
         * @private
         * @return {?}
         */
        FlexibleConnectedPositionStrategy.prototype._getNarrowedViewportRect = function () {
            // We recalculate the viewport rect here ourselves, rather than using the ViewportRuler,
            // because we want to use the `clientWidth` and `clientHeight` as the base. The difference
            // being that the client properties don't include the scrollbar, as opposed to `innerWidth`
            // and `innerHeight` that do. This is necessary, because the overlay container uses
            // 100% `width` and `height` which don't include the scrollbar either.
            /** @type {?} */
            var width = ( /** @type {?} */(this._document.documentElement)).clientWidth;
            /** @type {?} */
            var height = ( /** @type {?} */(this._document.documentElement)).clientHeight;
            /** @type {?} */
            var scrollPosition = this._viewportRuler.getViewportScrollPosition();
            return {
                top: scrollPosition.top + this._viewportMargin,
                left: scrollPosition.left + this._viewportMargin,
                right: scrollPosition.left + width - this._viewportMargin,
                bottom: scrollPosition.top + height - this._viewportMargin,
                width: width - (2 * this._viewportMargin),
                height: height - (2 * this._viewportMargin),
            };
        };
        /**
         * Whether the we're dealing with an RTL context
         * @private
         * @return {?}
         */
        FlexibleConnectedPositionStrategy.prototype._isRtl = function () {
            return this._overlayRef.getDirection() === 'rtl';
        };
        /**
         * Determines whether the overlay uses exact or flexible positioning.
         * @private
         * @return {?}
         */
        FlexibleConnectedPositionStrategy.prototype._hasExactPosition = function () {
            return !this._hasFlexibleDimensions || this._isPushed;
        };
        /**
         * Retrieves the offset of a position along the x or y axis.
         * @private
         * @param {?} position
         * @param {?} axis
         * @return {?}
         */
        FlexibleConnectedPositionStrategy.prototype._getOffset = function (position, axis) {
            if (axis === 'x') {
                // We don't do something like `position['offset' + axis]` in
                // order to avoid breking minifiers that rename properties.
                return position.offsetX == null ? this._offsetX : position.offsetX;
            }
            return position.offsetY == null ? this._offsetY : position.offsetY;
        };
        /**
         * Validates that the current position match the expected values.
         * @private
         * @return {?}
         */
        FlexibleConnectedPositionStrategy.prototype._validatePositions = function () {
            if (!this._preferredPositions.length) {
                throw Error('FlexibleConnectedPositionStrategy: At least one position is required.');
            }
            // TODO(crisbeto): remove these once Angular's template type
            // checking is advanced enough to catch these cases.
            this._preferredPositions.forEach(( /**
             * @param {?} pair
             * @return {?}
             */function (/**
             * @param {?} pair
             * @return {?}
             */ pair) {
                validateHorizontalPosition('originX', pair.originX);
                validateVerticalPosition('originY', pair.originY);
                validateHorizontalPosition('overlayX', pair.overlayX);
                validateVerticalPosition('overlayY', pair.overlayY);
            }));
        };
        /**
         * Adds a single CSS class or an array of classes on the overlay panel.
         * @private
         * @param {?} cssClasses
         * @return {?}
         */
        FlexibleConnectedPositionStrategy.prototype._addPanelClasses = function (cssClasses) {
            var _this = this;
            if (this._pane) {
                coerceArray(cssClasses).forEach(( /**
                 * @param {?} cssClass
                 * @return {?}
                 */function (/**
                 * @param {?} cssClass
                 * @return {?}
                 */ cssClass) {
                    if (cssClass !== '' && _this._appliedPanelClasses.indexOf(cssClass) === -1) {
                        _this._appliedPanelClasses.push(cssClass);
                        _this._pane.classList.add(cssClass);
                    }
                }));
            }
        };
        /**
         * Clears the classes that the position strategy has applied from the overlay panel.
         * @private
         * @return {?}
         */
        FlexibleConnectedPositionStrategy.prototype._clearPanelClasses = function () {
            var _this = this;
            if (this._pane) {
                this._appliedPanelClasses.forEach(( /**
                 * @param {?} cssClass
                 * @return {?}
                 */function (/**
                 * @param {?} cssClass
                 * @return {?}
                 */ cssClass) {
                    _this._pane.classList.remove(cssClass);
                }));
                this._appliedPanelClasses = [];
            }
        };
        /**
         * Returns the ClientRect of the current origin.
         * @private
         * @return {?}
         */
        FlexibleConnectedPositionStrategy.prototype._getOriginRect = function () {
            /** @type {?} */
            var origin = this._origin;
            if (origin instanceof ElementRef) {
                return origin.nativeElement.getBoundingClientRect();
            }
            if (origin instanceof HTMLElement) {
                return origin.getBoundingClientRect();
            }
            /** @type {?} */
            var width = origin.width || 0;
            /** @type {?} */
            var height = origin.height || 0;
            // If the origin is a point, return a client rect as if it was a 0x0 element at the point.
            return {
                top: origin.y,
                bottom: origin.y + height,
                left: origin.x,
                right: origin.x + width,
                height: height,
                width: width
            };
        };
        return FlexibleConnectedPositionStrategy;
    }());
    /**
     * Shallow-extends a stylesheet object with another stylesheet object.
     * @param {?} dest
     * @param {?} source
     * @return {?}
     */
    function extendStyles(dest, source) {
        for (var key in source) {
            if (source.hasOwnProperty(key)) {
                dest[key] = source[key];
            }
        }
        return dest;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A strategy for positioning overlays. Using this strategy, an overlay is given an
     * implicit position relative to some origin element. The relative position is defined in terms of
     * a point on the origin element that is connected to a point on the overlay element. For example,
     * a basic dropdown is connecting the bottom-left corner of the origin to the top-left corner
     * of the overlay.
     * @deprecated Use `FlexibleConnectedPositionStrategy` instead.
     * \@breaking-change 8.0.0
     */
    var ConnectedPositionStrategy = /** @class */ (function () {
        /**
         * @param {?} originPos
         * @param {?} overlayPos
         * @param {?} connectedTo
         * @param {?} viewportRuler
         * @param {?} document
         * @param {?} platform
         * @param {?} overlayContainer
         */
        function ConnectedPositionStrategy(originPos, overlayPos, connectedTo, viewportRuler, document, platform, overlayContainer) {
            /**
             * Ordered list of preferred positions, from most to least desirable.
             */
            this._preferredPositions = [];
            // Since the `ConnectedPositionStrategy` is deprecated and we don't want to maintain
            // the extra logic, we create an instance of the positioning strategy that has some
            // defaults that make it behave as the old position strategy and to which we'll
            // proxy all of the API calls.
            this._positionStrategy = new FlexibleConnectedPositionStrategy(connectedTo, viewportRuler, document, platform, overlayContainer)
                .withFlexibleDimensions(false)
                .withPush(false)
                .withViewportMargin(0);
            this.withFallbackPosition(originPos, overlayPos);
        }
        Object.defineProperty(ConnectedPositionStrategy.prototype, "_isRtl", {
            /**
             * Whether the we're dealing with an RTL context
             * @return {?}
             */
            get: function () {
                return this._overlayRef.getDirection() === 'rtl';
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ConnectedPositionStrategy.prototype, "onPositionChange", {
            /**
             * Emits an event when the connection point changes.
             * @return {?}
             */
            get: function () {
                return this._positionStrategy.positionChanges;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ConnectedPositionStrategy.prototype, "positions", {
            /**
             * Ordered list of preferred positions, from most to least desirable.
             * @return {?}
             */
            get: function () {
                return this._preferredPositions;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Attach this position strategy to an overlay.
         * @param {?} overlayRef
         * @return {?}
         */
        ConnectedPositionStrategy.prototype.attach = function (overlayRef) {
            this._overlayRef = overlayRef;
            this._positionStrategy.attach(overlayRef);
            if (this._direction) {
                overlayRef.setDirection(this._direction);
                this._direction = null;
            }
        };
        /**
         * Disposes all resources used by the position strategy.
         * @return {?}
         */
        ConnectedPositionStrategy.prototype.dispose = function () {
            this._positionStrategy.dispose();
        };
        /**
         * \@docs-private
         * @return {?}
         */
        ConnectedPositionStrategy.prototype.detach = function () {
            this._positionStrategy.detach();
        };
        /**
         * Updates the position of the overlay element, using whichever preferred position relative
         * to the origin fits on-screen.
         * \@docs-private
         * @return {?}
         */
        ConnectedPositionStrategy.prototype.apply = function () {
            this._positionStrategy.apply();
        };
        /**
         * Re-positions the overlay element with the trigger in its last calculated position,
         * even if a position higher in the "preferred positions" list would now fit. This
         * allows one to re-align the panel without changing the orientation of the panel.
         * @return {?}
         */
        ConnectedPositionStrategy.prototype.recalculateLastPosition = function () {
            this._positionStrategy.reapplyLastPosition();
        };
        /**
         * Sets the list of Scrollable containers that host the origin element so that
         * on reposition we can evaluate if it or the overlay has been clipped or outside view. Every
         * Scrollable must be an ancestor element of the strategy's origin element.
         * @param {?} scrollables
         * @return {?}
         */
        ConnectedPositionStrategy.prototype.withScrollableContainers = function (scrollables) {
            this._positionStrategy.withScrollableContainers(scrollables);
        };
        /**
         * Adds a new preferred fallback position.
         * @template THIS
         * @this {THIS}
         * @param {?} originPos
         * @param {?} overlayPos
         * @param {?=} offsetX
         * @param {?=} offsetY
         * @return {THIS}
         */
        ConnectedPositionStrategy.prototype.withFallbackPosition = function (originPos, overlayPos, offsetX, offsetY) {
            /** @type {?} */
            var position = new ConnectionPositionPair(originPos, overlayPos, offsetX, offsetY);
            ( /** @type {?} */(this))._preferredPositions.push(position);
            ( /** @type {?} */(this))._positionStrategy.withPositions(( /** @type {?} */(this))._preferredPositions);
            return ( /** @type {?} */(this));
        };
        /**
         * Sets the layout direction so the overlay's position can be adjusted to match.
         * @template THIS
         * @this {THIS}
         * @param {?} dir New layout direction.
         * @return {THIS}
         */
        ConnectedPositionStrategy.prototype.withDirection = function (dir) {
            // Since the direction might be declared before the strategy is attached,
            // we save the value in a temporary property and we'll transfer it to the
            // overlay ref on attachment.
            if (( /** @type {?} */(this))._overlayRef) {
                ( /** @type {?} */(this))._overlayRef.setDirection(dir);
            }
            else {
                ( /** @type {?} */(this))._direction = dir;
            }
            return ( /** @type {?} */(this));
        };
        /**
         * Sets an offset for the overlay's connection point on the x-axis
         * @template THIS
         * @this {THIS}
         * @param {?} offset New offset in the X axis.
         * @return {THIS}
         */
        ConnectedPositionStrategy.prototype.withOffsetX = function (offset) {
            ( /** @type {?} */(this))._positionStrategy.withDefaultOffsetX(offset);
            return ( /** @type {?} */(this));
        };
        /**
         * Sets an offset for the overlay's connection point on the y-axis
         * @template THIS
         * @this {THIS}
         * @param {?} offset New offset in the Y axis.
         * @return {THIS}
         */
        ConnectedPositionStrategy.prototype.withOffsetY = function (offset) {
            ( /** @type {?} */(this))._positionStrategy.withDefaultOffsetY(offset);
            return ( /** @type {?} */(this));
        };
        /**
         * Sets whether the overlay's position should be locked in after it is positioned
         * initially. When an overlay is locked in, it won't attempt to reposition itself
         * when the position is re-applied (e.g. when the user scrolls away).
         * @template THIS
         * @this {THIS}
         * @param {?} isLocked Whether the overlay should locked in.
         * @return {THIS}
         */
        ConnectedPositionStrategy.prototype.withLockedPosition = function (isLocked) {
            ( /** @type {?} */(this))._positionStrategy.withLockedPosition(isLocked);
            return ( /** @type {?} */(this));
        };
        /**
         * Overwrites the current set of positions with an array of new ones.
         * @template THIS
         * @this {THIS}
         * @param {?} positions Position pairs to be set on the strategy.
         * @return {THIS}
         */
        ConnectedPositionStrategy.prototype.withPositions = function (positions) {
            ( /** @type {?} */(this))._preferredPositions = positions.slice();
            ( /** @type {?} */(this))._positionStrategy.withPositions(( /** @type {?} */(this))._preferredPositions);
            return ( /** @type {?} */(this));
        };
        /**
         * Sets the origin element, relative to which to position the overlay.
         * @template THIS
         * @this {THIS}
         * @param {?} origin Reference to the new origin element.
         * @return {THIS}
         */
        ConnectedPositionStrategy.prototype.setOrigin = function (origin) {
            ( /** @type {?} */(this))._positionStrategy.setOrigin(origin);
            return ( /** @type {?} */(this));
        };
        return ConnectedPositionStrategy;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Class to be added to the overlay pane wrapper.
     * @type {?}
     */
    var wrapperClass = 'cdk-global-overlay-wrapper';
    /**
     * A strategy for positioning overlays. Using this strategy, an overlay is given an
     * explicit position relative to the browser's viewport. We use flexbox, instead of
     * transforms, in order to avoid issues with subpixel rendering which can cause the
     * element to become blurry.
     */
    var GlobalPositionStrategy = /** @class */ (function () {
        function GlobalPositionStrategy() {
            this._cssPosition = 'static';
            this._topOffset = '';
            this._bottomOffset = '';
            this._leftOffset = '';
            this._rightOffset = '';
            this._alignItems = '';
            this._justifyContent = '';
            this._width = '';
            this._height = '';
        }
        /**
         * @param {?} overlayRef
         * @return {?}
         */
        GlobalPositionStrategy.prototype.attach = function (overlayRef) {
            /** @type {?} */
            var config = overlayRef.getConfig();
            this._overlayRef = overlayRef;
            if (this._width && !config.width) {
                overlayRef.updateSize({ width: this._width });
            }
            if (this._height && !config.height) {
                overlayRef.updateSize({ height: this._height });
            }
            overlayRef.hostElement.classList.add(wrapperClass);
            this._isDisposed = false;
        };
        /**
         * Sets the top position of the overlay. Clears any previously set vertical position.
         * @template THIS
         * @this {THIS}
         * @param {?=} value New top offset.
         * @return {THIS}
         */
        GlobalPositionStrategy.prototype.top = function (value) {
            if (value === void 0) { value = ''; }
            ( /** @type {?} */(this))._bottomOffset = '';
            ( /** @type {?} */(this))._topOffset = value;
            ( /** @type {?} */(this))._alignItems = 'flex-start';
            return ( /** @type {?} */(this));
        };
        /**
         * Sets the left position of the overlay. Clears any previously set horizontal position.
         * @template THIS
         * @this {THIS}
         * @param {?=} value New left offset.
         * @return {THIS}
         */
        GlobalPositionStrategy.prototype.left = function (value) {
            if (value === void 0) { value = ''; }
            ( /** @type {?} */(this))._rightOffset = '';
            ( /** @type {?} */(this))._leftOffset = value;
            ( /** @type {?} */(this))._justifyContent = 'flex-start';
            return ( /** @type {?} */(this));
        };
        /**
         * Sets the bottom position of the overlay. Clears any previously set vertical position.
         * @template THIS
         * @this {THIS}
         * @param {?=} value New bottom offset.
         * @return {THIS}
         */
        GlobalPositionStrategy.prototype.bottom = function (value) {
            if (value === void 0) { value = ''; }
            ( /** @type {?} */(this))._topOffset = '';
            ( /** @type {?} */(this))._bottomOffset = value;
            ( /** @type {?} */(this))._alignItems = 'flex-end';
            return ( /** @type {?} */(this));
        };
        /**
         * Sets the right position of the overlay. Clears any previously set horizontal position.
         * @template THIS
         * @this {THIS}
         * @param {?=} value New right offset.
         * @return {THIS}
         */
        GlobalPositionStrategy.prototype.right = function (value) {
            if (value === void 0) { value = ''; }
            ( /** @type {?} */(this))._leftOffset = '';
            ( /** @type {?} */(this))._rightOffset = value;
            ( /** @type {?} */(this))._justifyContent = 'flex-end';
            return ( /** @type {?} */(this));
        };
        /**
         * Sets the overlay width and clears any previously set width.
         * @deprecated Pass the `width` through the `OverlayConfig`.
         * \@breaking-change 8.0.0
         * @template THIS
         * @this {THIS}
         * @param {?=} value New width for the overlay
         * @return {THIS}
         */
        GlobalPositionStrategy.prototype.width = function (value) {
            if (value === void 0) { value = ''; }
            if (( /** @type {?} */(this))._overlayRef) {
                ( /** @type {?} */(this))._overlayRef.updateSize({ width: value });
            }
            else {
                ( /** @type {?} */(this))._width = value;
            }
            return ( /** @type {?} */(this));
        };
        /**
         * Sets the overlay height and clears any previously set height.
         * @deprecated Pass the `height` through the `OverlayConfig`.
         * \@breaking-change 8.0.0
         * @template THIS
         * @this {THIS}
         * @param {?=} value New height for the overlay
         * @return {THIS}
         */
        GlobalPositionStrategy.prototype.height = function (value) {
            if (value === void 0) { value = ''; }
            if (( /** @type {?} */(this))._overlayRef) {
                ( /** @type {?} */(this))._overlayRef.updateSize({ height: value });
            }
            else {
                ( /** @type {?} */(this))._height = value;
            }
            return ( /** @type {?} */(this));
        };
        /**
         * Centers the overlay horizontally with an optional offset.
         * Clears any previously set horizontal position.
         *
         * @template THIS
         * @this {THIS}
         * @param {?=} offset Overlay offset from the horizontal center.
         * @return {THIS}
         */
        GlobalPositionStrategy.prototype.centerHorizontally = function (offset) {
            if (offset === void 0) { offset = ''; }
            ( /** @type {?} */(this)).left(offset);
            ( /** @type {?} */(this))._justifyContent = 'center';
            return ( /** @type {?} */(this));
        };
        /**
         * Centers the overlay vertically with an optional offset.
         * Clears any previously set vertical position.
         *
         * @template THIS
         * @this {THIS}
         * @param {?=} offset Overlay offset from the vertical center.
         * @return {THIS}
         */
        GlobalPositionStrategy.prototype.centerVertically = function (offset) {
            if (offset === void 0) { offset = ''; }
            ( /** @type {?} */(this)).top(offset);
            ( /** @type {?} */(this))._alignItems = 'center';
            return ( /** @type {?} */(this));
        };
        /**
         * Apply the position to the element.
         * \@docs-private
         * @return {?}
         */
        GlobalPositionStrategy.prototype.apply = function () {
            // Since the overlay ref applies the strategy asynchronously, it could
            // have been disposed before it ends up being applied. If that is the
            // case, we shouldn't do anything.
            if (!this._overlayRef || !this._overlayRef.hasAttached()) {
                return;
            }
            /** @type {?} */
            var styles = this._overlayRef.overlayElement.style;
            /** @type {?} */
            var parentStyles = this._overlayRef.hostElement.style;
            /** @type {?} */
            var config = this._overlayRef.getConfig();
            styles.position = this._cssPosition;
            styles.marginLeft = config.width === '100%' ? '0' : this._leftOffset;
            styles.marginTop = config.height === '100%' ? '0' : this._topOffset;
            styles.marginBottom = this._bottomOffset;
            styles.marginRight = this._rightOffset;
            if (config.width === '100%') {
                parentStyles.justifyContent = 'flex-start';
            }
            else if (this._justifyContent === 'center') {
                parentStyles.justifyContent = 'center';
            }
            else if (this._overlayRef.getConfig().direction === 'rtl') {
                // In RTL the browser will invert `flex-start` and `flex-end` automatically, but we
                // don't want that because our positioning is explicitly `left` and `right`, hence
                // why we do another inversion to ensure that the overlay stays in the same position.
                // TODO: reconsider this if we add `start` and `end` methods.
                if (this._justifyContent === 'flex-start') {
                    parentStyles.justifyContent = 'flex-end';
                }
                else if (this._justifyContent === 'flex-end') {
                    parentStyles.justifyContent = 'flex-start';
                }
            }
            else {
                parentStyles.justifyContent = this._justifyContent;
            }
            parentStyles.alignItems = config.height === '100%' ? 'flex-start' : this._alignItems;
        };
        /**
         * Cleans up the DOM changes from the position strategy.
         * \@docs-private
         * @return {?}
         */
        GlobalPositionStrategy.prototype.dispose = function () {
            if (this._isDisposed || !this._overlayRef) {
                return;
            }
            /** @type {?} */
            var styles = this._overlayRef.overlayElement.style;
            /** @type {?} */
            var parent = this._overlayRef.hostElement;
            /** @type {?} */
            var parentStyles = parent.style;
            parent.classList.remove(wrapperClass);
            parentStyles.justifyContent = parentStyles.alignItems = styles.marginTop =
                styles.marginBottom = styles.marginLeft = styles.marginRight = styles.position = '';
            this._overlayRef = ( /** @type {?} */(null));
            this._isDisposed = true;
        };
        return GlobalPositionStrategy;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Builder for overlay position strategy.
     */
    var OverlayPositionBuilder = /** @class */ (function () {
        /**
         * @param {?} _viewportRuler
         * @param {?} _document
         * @param {?} _platform
         * @param {?} _overlayContainer
         */
        function OverlayPositionBuilder(_viewportRuler, _document, _platform, _overlayContainer) {
            this._viewportRuler = _viewportRuler;
            this._document = _document;
            this._platform = _platform;
            this._overlayContainer = _overlayContainer;
        }
        /**
         * Creates a global position strategy.
         * @return {?}
         */
        OverlayPositionBuilder.prototype.global = function () {
            return new GlobalPositionStrategy();
        };
        /**
         * Creates a relative position strategy.
         * @deprecated Use `flexibleConnectedTo` instead.
         * \@breaking-change 8.0.0
         * @param {?} elementRef
         * @param {?} originPos
         * @param {?} overlayPos
         * @return {?}
         */
        OverlayPositionBuilder.prototype.connectedTo = function (elementRef, originPos, overlayPos) {
            return new ConnectedPositionStrategy(originPos, overlayPos, elementRef, this._viewportRuler, this._document, this._platform, this._overlayContainer);
        };
        /**
         * Creates a flexible position strategy.
         * @param {?} origin Origin relative to which to position the overlay.
         * @return {?}
         */
        OverlayPositionBuilder.prototype.flexibleConnectedTo = function (origin) {
            return new FlexibleConnectedPositionStrategy(origin, this._viewportRuler, this._document, this._platform, this._overlayContainer);
        };
        return OverlayPositionBuilder;
    }());
    OverlayPositionBuilder.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] },
    ];
    /** @nocollapse */
    OverlayPositionBuilder.ctorParameters = function () { return [
        { type: ViewportRuler },
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] },
        { type: Platform },
        { type: OverlayContainer }
    ]; };
    /** @nocollapse */ OverlayPositionBuilder.ngInjectableDef = ɵɵdefineInjectable({ factory: function OverlayPositionBuilder_Factory() { return new OverlayPositionBuilder(ɵɵinject(ViewportRuler), ɵɵinject(DOCUMENT), ɵɵinject(Platform), ɵɵinject(OverlayContainer)); }, token: OverlayPositionBuilder, providedIn: "root" });
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Next overlay unique ID.
     * @type {?}
     */
    var nextUniqueId = 0;
    // Note that Overlay is *not* scoped to the app root because the ComponentFactoryResolver
    // it needs is different based on where OverlayModule is imported.
    /**
     * Service to create Overlays. Overlays are dynamically added pieces of floating UI, meant to be
     * used as a low-level building block for other components. Dialogs, tooltips, menus,
     * selects, etc. can all be built using overlays. The service should primarily be used by authors
     * of re-usable components rather than developers building end-user applications.
     *
     * An overlay *is* a PortalOutlet, so any kind of Portal can be loaded into one.
     */
    var Overlay = /** @class */ (function () {
        /**
         * @param {?} scrollStrategies
         * @param {?} _overlayContainer
         * @param {?} _componentFactoryResolver
         * @param {?} _positionBuilder
         * @param {?} _keyboardDispatcher
         * @param {?} _injector
         * @param {?} _ngZone
         * @param {?} _document
         * @param {?} _directionality
         * @param {?=} _location
         */
        function Overlay(scrollStrategies, _overlayContainer, _componentFactoryResolver, _positionBuilder, _keyboardDispatcher, _injector, _ngZone, _document, _directionality, _location) {
            this.scrollStrategies = scrollStrategies;
            this._overlayContainer = _overlayContainer;
            this._componentFactoryResolver = _componentFactoryResolver;
            this._positionBuilder = _positionBuilder;
            this._keyboardDispatcher = _keyboardDispatcher;
            this._injector = _injector;
            this._ngZone = _ngZone;
            this._document = _document;
            this._directionality = _directionality;
            this._location = _location;
        }
        /**
         * Creates an overlay.
         * @param {?=} config Configuration applied to the overlay.
         * @return {?} Reference to the created overlay.
         */
        Overlay.prototype.create = function (config) {
            /** @type {?} */
            var host = this._createHostElement();
            /** @type {?} */
            var pane = this._createPaneElement(host);
            /** @type {?} */
            var portalOutlet = this._createPortalOutlet(pane);
            /** @type {?} */
            var overlayConfig = new OverlayConfig(config);
            overlayConfig.direction = overlayConfig.direction || this._directionality.value;
            return new OverlayRef(portalOutlet, host, pane, overlayConfig, this._ngZone, this._keyboardDispatcher, this._document, this._location);
        };
        /**
         * Gets a position builder that can be used, via fluent API,
         * to construct and configure a position strategy.
         * @return {?} An overlay position builder.
         */
        Overlay.prototype.position = function () {
            return this._positionBuilder;
        };
        /**
         * Creates the DOM element for an overlay and appends it to the overlay container.
         * @private
         * @param {?} host
         * @return {?} Newly-created pane element
         */
        Overlay.prototype._createPaneElement = function (host) {
            /** @type {?} */
            var pane = this._document.createElement('div');
            pane.id = "cdk-overlay-" + nextUniqueId++;
            pane.classList.add('cdk-overlay-pane');
            host.appendChild(pane);
            return pane;
        };
        /**
         * Creates the host element that wraps around an overlay
         * and can be used for advanced positioning.
         * @private
         * @return {?} Newly-create host element.
         */
        Overlay.prototype._createHostElement = function () {
            /** @type {?} */
            var host = this._document.createElement('div');
            this._overlayContainer.getContainerElement().appendChild(host);
            return host;
        };
        /**
         * Create a DomPortalOutlet into which the overlay content can be loaded.
         * @private
         * @param {?} pane The DOM element to turn into a portal outlet.
         * @return {?} A portal outlet for the given DOM element.
         */
        Overlay.prototype._createPortalOutlet = function (pane) {
            // We have to resolve the ApplicationRef later in order to allow people
            // to use overlay-based providers during app initialization.
            if (!this._appRef) {
                this._appRef = this._injector.get(ApplicationRef);
            }
            return new DomPortalOutlet(pane, this._componentFactoryResolver, this._appRef, this._injector);
        };
        return Overlay;
    }());
    Overlay.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    Overlay.ctorParameters = function () { return [
        { type: ScrollStrategyOptions },
        { type: OverlayContainer },
        { type: ComponentFactoryResolver },
        { type: OverlayPositionBuilder },
        { type: OverlayKeyboardDispatcher },
        { type: Injector },
        { type: NgZone },
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] },
        { type: Directionality },
        { type: Location, decorators: [{ type: Optional }] }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Default set of positions for the overlay. Follows the behavior of a dropdown.
     * @type {?}
     */
    var defaultPositionList = [
        {
            originX: 'start',
            originY: 'bottom',
            overlayX: 'start',
            overlayY: 'top'
        },
        {
            originX: 'start',
            originY: 'top',
            overlayX: 'start',
            overlayY: 'bottom'
        },
        {
            originX: 'end',
            originY: 'top',
            overlayX: 'end',
            overlayY: 'bottom'
        },
        {
            originX: 'end',
            originY: 'bottom',
            overlayX: 'end',
            overlayY: 'top'
        }
    ];
    /**
     * Injection token that determines the scroll handling while the connected overlay is open.
     * @type {?}
     */
    var CDK_CONNECTED_OVERLAY_SCROLL_STRATEGY = new InjectionToken('cdk-connected-overlay-scroll-strategy');
    /**
     * Directive applied to an element to make it usable as an origin for an Overlay using a
     * ConnectedPositionStrategy.
     */
    var CdkOverlayOrigin = /** @class */ (function () {
        /**
         * @param {?} elementRef
         */
        function CdkOverlayOrigin(elementRef) {
            this.elementRef = elementRef;
        }
        return CdkOverlayOrigin;
    }());
    CdkOverlayOrigin.decorators = [
        { type: Directive, args: [{
                    selector: '[cdk-overlay-origin], [overlay-origin], [cdkOverlayOrigin]',
                    exportAs: 'cdkOverlayOrigin',
                },] },
    ];
    /** @nocollapse */
    CdkOverlayOrigin.ctorParameters = function () { return [
        { type: ElementRef }
    ]; };
    /**
     * Directive to facilitate declarative creation of an
     * Overlay using a FlexibleConnectedPositionStrategy.
     */
    var CdkConnectedOverlay = /** @class */ (function () {
        // TODO(jelbourn): inputs for size, scroll behavior, animation, etc.
        /**
         * @param {?} _overlay
         * @param {?} templateRef
         * @param {?} viewContainerRef
         * @param {?} scrollStrategyFactory
         * @param {?} _dir
         */
        function CdkConnectedOverlay(_overlay, templateRef, viewContainerRef, scrollStrategyFactory, _dir) {
            this._overlay = _overlay;
            this._dir = _dir;
            this._hasBackdrop = false;
            this._lockPosition = false;
            this._growAfterOpen = false;
            this._flexibleDimensions = false;
            this._push = false;
            this._backdropSubscription = Subscription.EMPTY;
            /**
             * Margin between the overlay and the viewport edges.
             */
            this.viewportMargin = 0;
            /**
             * Whether the overlay is open.
             */
            this.open = false;
            /**
             * Event emitted when the backdrop is clicked.
             */
            this.backdropClick = new EventEmitter();
            /**
             * Event emitted when the position has changed.
             */
            this.positionChange = new EventEmitter();
            /**
             * Event emitted when the overlay has been attached.
             */
            this.attach = new EventEmitter();
            /**
             * Event emitted when the overlay has been detached.
             */
            this.detach = new EventEmitter();
            /**
             * Emits when there are keyboard events that are targeted at the overlay.
             */
            this.overlayKeydown = new EventEmitter();
            this._templatePortal = new TemplatePortal(templateRef, viewContainerRef);
            this._scrollStrategyFactory = scrollStrategyFactory;
            this.scrollStrategy = this._scrollStrategyFactory();
        }
        Object.defineProperty(CdkConnectedOverlay.prototype, "offsetX", {
            /**
             * The offset in pixels for the overlay connection point on the x-axis
             * @return {?}
             */
            get: function () { return this._offsetX; },
            /**
             * @param {?} offsetX
             * @return {?}
             */
            set: function (offsetX) {
                this._offsetX = offsetX;
                if (this._position) {
                    this._updatePositionStrategy(this._position);
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CdkConnectedOverlay.prototype, "offsetY", {
            /**
             * The offset in pixels for the overlay connection point on the y-axis
             * @return {?}
             */
            get: function () { return this._offsetY; },
            /**
             * @param {?} offsetY
             * @return {?}
             */
            set: function (offsetY) {
                this._offsetY = offsetY;
                if (this._position) {
                    this._updatePositionStrategy(this._position);
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CdkConnectedOverlay.prototype, "hasBackdrop", {
            /**
             * Whether or not the overlay should attach a backdrop.
             * @return {?}
             */
            get: function () { return this._hasBackdrop; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this._hasBackdrop = coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CdkConnectedOverlay.prototype, "lockPosition", {
            /**
             * Whether or not the overlay should be locked when scrolling.
             * @return {?}
             */
            get: function () { return this._lockPosition; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this._lockPosition = coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CdkConnectedOverlay.prototype, "flexibleDimensions", {
            /**
             * Whether the overlay's width and height can be constrained to fit within the viewport.
             * @return {?}
             */
            get: function () { return this._flexibleDimensions; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._flexibleDimensions = coerceBooleanProperty(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CdkConnectedOverlay.prototype, "growAfterOpen", {
            /**
             * Whether the overlay can grow after the initial open when flexible positioning is turned on.
             * @return {?}
             */
            get: function () { return this._growAfterOpen; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this._growAfterOpen = coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CdkConnectedOverlay.prototype, "push", {
            /**
             * Whether the overlay can be pushed on-screen if none of the provided positions fit.
             * @return {?}
             */
            get: function () { return this._push; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this._push = coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CdkConnectedOverlay.prototype, "overlayRef", {
            /**
             * The associated overlay reference.
             * @return {?}
             */
            get: function () {
                return this._overlayRef;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CdkConnectedOverlay.prototype, "dir", {
            /**
             * The element's layout direction.
             * @return {?}
             */
            get: function () {
                return this._dir ? this._dir.value : 'ltr';
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        CdkConnectedOverlay.prototype.ngOnDestroy = function () {
            if (this._overlayRef) {
                this._overlayRef.dispose();
            }
            this._backdropSubscription.unsubscribe();
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        CdkConnectedOverlay.prototype.ngOnChanges = function (changes) {
            if (this._position) {
                this._updatePositionStrategy(this._position);
                this._overlayRef.updateSize({
                    width: this.width,
                    minWidth: this.minWidth,
                    height: this.height,
                    minHeight: this.minHeight,
                });
                if (changes['origin'] && this.open) {
                    this._position.apply();
                }
            }
            if (changes['open']) {
                this.open ? this._attachOverlay() : this._detachOverlay();
            }
        };
        /**
         * Creates an overlay
         * @private
         * @return {?}
         */
        CdkConnectedOverlay.prototype._createOverlay = function () {
            var _this = this;
            if (!this.positions || !this.positions.length) {
                this.positions = defaultPositionList;
            }
            this._overlayRef = this._overlay.create(this._buildConfig());
            this._overlayRef.keydownEvents().subscribe(( /**
             * @param {?} event
             * @return {?}
             */function (event) {
                _this.overlayKeydown.next(event);
                if (event.keyCode === ESCAPE && !hasModifierKey(event)) {
                    event.preventDefault();
                    _this._detachOverlay();
                }
            }));
        };
        /**
         * Builds the overlay config based on the directive's inputs
         * @private
         * @return {?}
         */
        CdkConnectedOverlay.prototype._buildConfig = function () {
            /** @type {?} */
            var positionStrategy = this._position = this._createPositionStrategy();
            /** @type {?} */
            var overlayConfig = new OverlayConfig({
                direction: this._dir,
                positionStrategy: positionStrategy,
                scrollStrategy: this.scrollStrategy,
                hasBackdrop: this.hasBackdrop
            });
            if (this.width || this.width === 0) {
                overlayConfig.width = this.width;
            }
            if (this.height || this.height === 0) {
                overlayConfig.height = this.height;
            }
            if (this.minWidth || this.minWidth === 0) {
                overlayConfig.minWidth = this.minWidth;
            }
            if (this.minHeight || this.minHeight === 0) {
                overlayConfig.minHeight = this.minHeight;
            }
            if (this.backdropClass) {
                overlayConfig.backdropClass = this.backdropClass;
            }
            if (this.panelClass) {
                overlayConfig.panelClass = this.panelClass;
            }
            return overlayConfig;
        };
        /**
         * Updates the state of a position strategy, based on the values of the directive inputs.
         * @private
         * @param {?} positionStrategy
         * @return {?}
         */
        CdkConnectedOverlay.prototype._updatePositionStrategy = function (positionStrategy) {
            var _this = this;
            /** @type {?} */
            var positions = this.positions.map(( /**
             * @param {?} currentPosition
             * @return {?}
             */function (/**
             * @param {?} currentPosition
             * @return {?}
             */ currentPosition) { return ({
                originX: currentPosition.originX,
                originY: currentPosition.originY,
                overlayX: currentPosition.overlayX,
                overlayY: currentPosition.overlayY,
                offsetX: currentPosition.offsetX || _this.offsetX,
                offsetY: currentPosition.offsetY || _this.offsetY,
                panelClass: currentPosition.panelClass || undefined,
            }); }));
            return positionStrategy
                .setOrigin(this.origin.elementRef)
                .withPositions(positions)
                .withFlexibleDimensions(this.flexibleDimensions)
                .withPush(this.push)
                .withGrowAfterOpen(this.growAfterOpen)
                .withViewportMargin(this.viewportMargin)
                .withLockedPosition(this.lockPosition);
        };
        /**
         * Returns the position strategy of the overlay to be set on the overlay config
         * @private
         * @return {?}
         */
        CdkConnectedOverlay.prototype._createPositionStrategy = function () {
            var _this = this;
            /** @type {?} */
            var strategy = this._overlay.position().flexibleConnectedTo(this.origin.elementRef);
            this._updatePositionStrategy(strategy);
            strategy.positionChanges.subscribe(( /**
             * @param {?} p
             * @return {?}
             */function (/**
             * @param {?} p
             * @return {?}
             */ p) { return _this.positionChange.emit(p); }));
            return strategy;
        };
        /**
         * Attaches the overlay and subscribes to backdrop clicks if backdrop exists
         * @private
         * @return {?}
         */
        CdkConnectedOverlay.prototype._attachOverlay = function () {
            var _this = this;
            if (!this._overlayRef) {
                this._createOverlay();
            }
            else {
                // Update the overlay size, in case the directive's inputs have changed
                this._overlayRef.getConfig().hasBackdrop = this.hasBackdrop;
            }
            if (!this._overlayRef.hasAttached()) {
                this._overlayRef.attach(this._templatePortal);
                this.attach.emit();
            }
            if (this.hasBackdrop) {
                this._backdropSubscription = this._overlayRef.backdropClick().subscribe(( /**
                 * @param {?} event
                 * @return {?}
                 */function (/**
                 * @param {?} event
                 * @return {?}
                 */ event) {
                    _this.backdropClick.emit(event);
                }));
            }
            else {
                this._backdropSubscription.unsubscribe();
            }
        };
        /**
         * Detaches the overlay and unsubscribes to backdrop clicks if backdrop exists
         * @private
         * @return {?}
         */
        CdkConnectedOverlay.prototype._detachOverlay = function () {
            if (this._overlayRef) {
                this._overlayRef.detach();
                this.detach.emit();
            }
            this._backdropSubscription.unsubscribe();
        };
        return CdkConnectedOverlay;
    }());
    CdkConnectedOverlay.decorators = [
        { type: Directive, args: [{
                    selector: '[cdk-connected-overlay], [connected-overlay], [cdkConnectedOverlay]',
                    exportAs: 'cdkConnectedOverlay'
                },] },
    ];
    /** @nocollapse */
    CdkConnectedOverlay.ctorParameters = function () { return [
        { type: Overlay },
        { type: TemplateRef },
        { type: ViewContainerRef },
        { type: undefined, decorators: [{ type: Inject, args: [CDK_CONNECTED_OVERLAY_SCROLL_STRATEGY,] }] },
        { type: Directionality, decorators: [{ type: Optional }] }
    ]; };
    CdkConnectedOverlay.propDecorators = {
        origin: [{ type: Input, args: ['cdkConnectedOverlayOrigin',] }],
        positions: [{ type: Input, args: ['cdkConnectedOverlayPositions',] }],
        offsetX: [{ type: Input, args: ['cdkConnectedOverlayOffsetX',] }],
        offsetY: [{ type: Input, args: ['cdkConnectedOverlayOffsetY',] }],
        width: [{ type: Input, args: ['cdkConnectedOverlayWidth',] }],
        height: [{ type: Input, args: ['cdkConnectedOverlayHeight',] }],
        minWidth: [{ type: Input, args: ['cdkConnectedOverlayMinWidth',] }],
        minHeight: [{ type: Input, args: ['cdkConnectedOverlayMinHeight',] }],
        backdropClass: [{ type: Input, args: ['cdkConnectedOverlayBackdropClass',] }],
        panelClass: [{ type: Input, args: ['cdkConnectedOverlayPanelClass',] }],
        viewportMargin: [{ type: Input, args: ['cdkConnectedOverlayViewportMargin',] }],
        scrollStrategy: [{ type: Input, args: ['cdkConnectedOverlayScrollStrategy',] }],
        open: [{ type: Input, args: ['cdkConnectedOverlayOpen',] }],
        hasBackdrop: [{ type: Input, args: ['cdkConnectedOverlayHasBackdrop',] }],
        lockPosition: [{ type: Input, args: ['cdkConnectedOverlayLockPosition',] }],
        flexibleDimensions: [{ type: Input, args: ['cdkConnectedOverlayFlexibleDimensions',] }],
        growAfterOpen: [{ type: Input, args: ['cdkConnectedOverlayGrowAfterOpen',] }],
        push: [{ type: Input, args: ['cdkConnectedOverlayPush',] }],
        backdropClick: [{ type: Output }],
        positionChange: [{ type: Output }],
        attach: [{ type: Output }],
        detach: [{ type: Output }],
        overlayKeydown: [{ type: Output }]
    };
    /**
     * \@docs-private
     * @param {?} overlay
     * @return {?}
     */
    function CDK_CONNECTED_OVERLAY_SCROLL_STRATEGY_PROVIDER_FACTORY(overlay) {
        return ( /**
         * @return {?}
         */function () { return overlay.scrollStrategies.reposition(); });
    }
    /**
     * \@docs-private
     * @type {?}
     */
    var CDK_CONNECTED_OVERLAY_SCROLL_STRATEGY_PROVIDER = {
        provide: CDK_CONNECTED_OVERLAY_SCROLL_STRATEGY,
        deps: [Overlay],
        useFactory: CDK_CONNECTED_OVERLAY_SCROLL_STRATEGY_PROVIDER_FACTORY,
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var OverlayModule = /** @class */ (function () {
        function OverlayModule() {
        }
        return OverlayModule;
    }());
    OverlayModule.decorators = [
        { type: NgModule, args: [{
                    imports: [BidiModule, PortalModule, ScrollingModule],
                    exports: [CdkConnectedOverlay, CdkOverlayOrigin, ScrollingModule],
                    declarations: [CdkConnectedOverlay, CdkOverlayOrigin],
                    providers: [
                        Overlay,
                        CDK_CONNECTED_OVERLAY_SCROLL_STRATEGY_PROVIDER,
                    ],
                },] },
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Alternative to OverlayContainer that supports correct displaying of overlay elements in
     * Fullscreen mode
     * https://developer.mozilla.org/en-US/docs/Web/API/Element/requestFullScreen
     *
     * Should be provided in the root component.
     */
    var FullscreenOverlayContainer = /** @class */ (function (_super) {
        __extends(FullscreenOverlayContainer, _super);
        /**
         * @param {?} _document
         */
        function FullscreenOverlayContainer(_document) {
            return _super.call(this, _document) || this;
        }
        /**
         * @return {?}
         */
        FullscreenOverlayContainer.prototype.ngOnDestroy = function () {
            _super.prototype.ngOnDestroy.call(this);
            if (this._fullScreenEventName && this._fullScreenListener) {
                this._document.removeEventListener(this._fullScreenEventName, this._fullScreenListener);
            }
        };
        /**
         * @protected
         * @return {?}
         */
        FullscreenOverlayContainer.prototype._createContainer = function () {
            var _this = this;
            _super.prototype._createContainer.call(this);
            this._adjustParentForFullscreenChange();
            this._addFullscreenChangeListener(( /**
             * @return {?}
             */function () { return _this._adjustParentForFullscreenChange(); }));
        };
        /**
         * @private
         * @return {?}
         */
        FullscreenOverlayContainer.prototype._adjustParentForFullscreenChange = function () {
            if (!this._containerElement) {
                return;
            }
            /** @type {?} */
            var fullscreenElement = this.getFullscreenElement();
            /** @type {?} */
            var parent = fullscreenElement || this._document.body;
            parent.appendChild(this._containerElement);
        };
        /**
         * @private
         * @param {?} fn
         * @return {?}
         */
        FullscreenOverlayContainer.prototype._addFullscreenChangeListener = function (fn) {
            /** @type {?} */
            var eventName = this._getEventName();
            if (eventName) {
                if (this._fullScreenListener) {
                    this._document.removeEventListener(eventName, this._fullScreenListener);
                }
                this._document.addEventListener(eventName, fn);
                this._fullScreenListener = fn;
            }
        };
        /**
         * @private
         * @return {?}
         */
        FullscreenOverlayContainer.prototype._getEventName = function () {
            if (!this._fullScreenEventName) {
                /** @type {?} */
                var _document_1 = ( /** @type {?} */(this._document));
                if (_document_1.fullscreenEnabled) {
                    this._fullScreenEventName = 'fullscreenchange';
                }
                else if (_document_1.webkitFullscreenEnabled) {
                    this._fullScreenEventName = 'webkitfullscreenchange';
                }
                else if (_document_1.mozFullScreenEnabled) {
                    this._fullScreenEventName = 'mozfullscreenchange';
                }
                else if (_document_1.msFullscreenEnabled) {
                    this._fullScreenEventName = 'MSFullscreenChange';
                }
            }
            return this._fullScreenEventName;
        };
        /**
         * When the page is put into fullscreen mode, a specific element is specified.
         * Only that element and its children are visible when in fullscreen mode.
         * @return {?}
         */
        FullscreenOverlayContainer.prototype.getFullscreenElement = function () {
            /** @type {?} */
            var _document = ( /** @type {?} */(this._document));
            return _document.fullscreenElement ||
                _document.webkitFullscreenElement ||
                _document.mozFullScreenElement ||
                _document.msFullscreenElement ||
                null;
        };
        return FullscreenOverlayContainer;
    }(OverlayContainer));
    FullscreenOverlayContainer.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] },
    ];
    /** @nocollapse */
    FullscreenOverlayContainer.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
    ]; };
    /** @nocollapse */ FullscreenOverlayContainer.ngInjectableDef = ɵɵdefineInjectable({ factory: function FullscreenOverlayContainer_Factory() { return new FullscreenOverlayContainer(ɵɵinject(DOCUMENT)); }, token: FullscreenOverlayContainer, providedIn: "root" });
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Configuration for opening a modal dialog with the MatDialog service.
     * @template D
     */
    var MatDialogConfig = /** @class */ (function () {
        function MatDialogConfig() {
            /**
             * The ARIA role of the dialog element.
             */
            this.role = 'dialog';
            /**
             * Custom class for the overlay pane.
             */
            this.panelClass = '';
            /**
             * Whether the dialog has a backdrop.
             */
            this.hasBackdrop = true;
            /**
             * Custom class for the backdrop.
             */
            this.backdropClass = '';
            /**
             * Whether the user can use escape or clicking on the backdrop to close the modal.
             */
            this.disableClose = false;
            /**
             * Width of the dialog.
             */
            this.width = '';
            /**
             * Height of the dialog.
             */
            this.height = '';
            /**
             * Max-width of the dialog. If a number is provided, assumes pixel units. Defaults to 80vw.
             */
            this.maxWidth = '80vw';
            /**
             * Data being injected into the child component.
             */
            this.data = null;
            /**
             * ID of the element that describes the dialog.
             */
            this.ariaDescribedBy = null;
            /**
             * ID of the element that labels the dialog.
             */
            this.ariaLabelledBy = null;
            /**
             * Aria label to assign to the dialog element.
             */
            this.ariaLabel = null;
            /**
             * Whether the dialog should focus the first focusable element on open.
             */
            this.autoFocus = true;
            /**
             * Whether the dialog should restore focus to the
             * previously-focused element, after it's closed.
             */
            this.restoreFocus = true;
            /**
             * Whether the dialog should close when the user goes backwards/forwards in history.
             * Note that this usually doesn't include clicking on links (unless the user is using
             * the `HashLocationStrategy`).
             */
            this.closeOnNavigation = true;
            // TODO(jelbourn): add configuration for lifecycle hooks, ARIA labelling.
        }
        return MatDialogConfig;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var animationBody = [
        // Note: The `enter` animation transitions to `transform: none`, because for some reason
        // specifying the transform explicitly, causes IE both to blur the dialog content and
        // decimate the animation performance. Leaving it as `none` solves both issues.
        state('void, exit', style({ opacity: 0, transform: 'scale(0.7)' })),
        state('enter', style({ transform: 'none' })),
        transition('* => enter', animate('150ms cubic-bezier(0, 0, 0.2, 1)', style({ transform: 'none', opacity: 1 }))),
        transition('* => void, * => exit', animate('75ms cubic-bezier(0.4, 0.0, 0.2, 1)', style({ opacity: 0 }))),
    ];
    /**
     * Animations used by MatDialog.
     * \@docs-private
     * @type {?}
     */
    var matDialogAnimations = {
        /**
         * Animation that is applied on the dialog container by defalt.
         */
        dialogContainer: trigger('dialogContainer', animationBody),
        /**
         * @deprecated \@breaking-change 8.0.0 Use `matDialogAnimations.dialogContainer` instead.
         */
        slideDialog: trigger('slideDialog', animationBody)
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Throws an exception for the case when a ComponentPortal is
     * attached to a DomPortalOutlet without an origin.
     * \@docs-private
     * @return {?}
     */
    function throwMatDialogContentAlreadyAttachedError() {
        throw Error('Attempting to attach dialog content after content is already attached');
    }
    /**
     * Internal component that wraps user-provided dialog content.
     * Animation is based on https://material.io/guidelines/motion/choreography.html.
     * \@docs-private
     */
    var MatDialogContainer = /** @class */ (function (_super) {
        __extends(MatDialogContainer, _super);
        /**
         * @param {?} _elementRef
         * @param {?} _focusTrapFactory
         * @param {?} _changeDetectorRef
         * @param {?} _document
         * @param {?} _config
         */
        function MatDialogContainer(_elementRef, _focusTrapFactory, _changeDetectorRef, _document, _config) {
            var _this = _super.call(this) || this;
            _this._elementRef = _elementRef;
            _this._focusTrapFactory = _focusTrapFactory;
            _this._changeDetectorRef = _changeDetectorRef;
            _this._document = _document;
            _this._config = _config;
            /**
             * Element that was focused before the dialog was opened. Save this to restore upon close.
             */
            _this._elementFocusedBeforeDialogWasOpened = null;
            /**
             * State of the dialog animation.
             */
            _this._state = 'enter';
            /**
             * Emits when an animation state changes.
             */
            _this._animationStateChanged = new EventEmitter();
            _this._ariaLabelledBy = _config.ariaLabelledBy || null;
            return _this;
        }
        /**
         * Attach a ComponentPortal as content to this dialog container.
         * @template T
         * @param {?} portal Portal to be attached as the dialog content.
         * @return {?}
         */
        MatDialogContainer.prototype.attachComponentPortal = function (portal) {
            if (this._portalOutlet.hasAttached()) {
                throwMatDialogContentAlreadyAttachedError();
            }
            this._savePreviouslyFocusedElement();
            return this._portalOutlet.attachComponentPortal(portal);
        };
        /**
         * Attach a TemplatePortal as content to this dialog container.
         * @template C
         * @param {?} portal Portal to be attached as the dialog content.
         * @return {?}
         */
        MatDialogContainer.prototype.attachTemplatePortal = function (portal) {
            if (this._portalOutlet.hasAttached()) {
                throwMatDialogContentAlreadyAttachedError();
            }
            this._savePreviouslyFocusedElement();
            return this._portalOutlet.attachTemplatePortal(portal);
        };
        /**
         * Moves the focus inside the focus trap.
         * @private
         * @return {?}
         */
        MatDialogContainer.prototype._trapFocus = function () {
            /** @type {?} */
            var element = this._elementRef.nativeElement;
            if (!this._focusTrap) {
                this._focusTrap = this._focusTrapFactory.create(element);
            }
            // If we were to attempt to focus immediately, then the content of the dialog would not yet be
            // ready in instances where change detection has to run first. To deal with this, we simply
            // wait for the microtask queue to be empty.
            if (this._config.autoFocus) {
                this._focusTrap.focusInitialElementWhenReady();
            }
            else {
                /** @type {?} */
                var activeElement = this._document.activeElement;
                // Otherwise ensure that focus is on the dialog container. It's possible that a different
                // component tried to move focus while the open animation was running. See:
                // https://github.com/angular/components/issues/16215. Note that we only want to do this
                // if the focus isn't inside the dialog already, because it's possible that the consumer
                // turned off `autoFocus` in order to move focus themselves.
                if (activeElement !== element && !element.contains(activeElement)) {
                    element.focus();
                }
            }
        };
        /**
         * Restores focus to the element that was focused before the dialog opened.
         * @private
         * @return {?}
         */
        MatDialogContainer.prototype._restoreFocus = function () {
            /** @type {?} */
            var toFocus = this._elementFocusedBeforeDialogWasOpened;
            // We need the extra check, because IE can set the `activeElement` to null in some cases.
            if (this._config.restoreFocus && toFocus && typeof toFocus.focus === 'function') {
                toFocus.focus();
            }
            if (this._focusTrap) {
                this._focusTrap.destroy();
            }
        };
        /**
         * Saves a reference to the element that was focused before the dialog was opened.
         * @private
         * @return {?}
         */
        MatDialogContainer.prototype._savePreviouslyFocusedElement = function () {
            var _this = this;
            if (this._document) {
                this._elementFocusedBeforeDialogWasOpened = ( /** @type {?} */(this._document.activeElement));
                // Note that there is no focus method when rendering on the server.
                if (this._elementRef.nativeElement.focus) {
                    // Move focus onto the dialog immediately in order to prevent the user from accidentally
                    // opening multiple dialogs at the same time. Needs to be async, because the element
                    // may not be focusable immediately.
                    Promise.resolve().then(( /**
                     * @return {?}
                     */function () { return _this._elementRef.nativeElement.focus(); }));
                }
            }
        };
        /**
         * Callback, invoked whenever an animation on the host completes.
         * @param {?} event
         * @return {?}
         */
        MatDialogContainer.prototype._onAnimationDone = function (event) {
            if (event.toState === 'enter') {
                this._trapFocus();
            }
            else if (event.toState === 'exit') {
                this._restoreFocus();
            }
            this._animationStateChanged.emit(event);
        };
        /**
         * Callback, invoked when an animation on the host starts.
         * @param {?} event
         * @return {?}
         */
        MatDialogContainer.prototype._onAnimationStart = function (event) {
            this._animationStateChanged.emit(event);
        };
        /**
         * Starts the dialog exit animation.
         * @return {?}
         */
        MatDialogContainer.prototype._startExitAnimation = function () {
            this._state = 'exit';
            // Mark the container for check so it can react if the
            // view container is using OnPush change detection.
            this._changeDetectorRef.markForCheck();
        };
        return MatDialogContainer;
    }(BasePortalOutlet));
    MatDialogContainer.decorators = [
        { type: Component, args: [{ selector: 'mat-dialog-container',
                    template: "<ng-template cdkPortalOutlet></ng-template>",
                    styles: [".mat-dialog-container{display:block;padding:24px;border-radius:4px;box-sizing:border-box;overflow:auto;outline:0;width:100%;height:100%;min-height:inherit;max-height:inherit}@media (-ms-high-contrast:active){.mat-dialog-container{outline:solid 1px}}.mat-dialog-content{display:block;margin:0 -24px;padding:0 24px;max-height:65vh;overflow:auto;-webkit-overflow-scrolling:touch}.mat-dialog-title{margin:0 0 20px;display:block}.mat-dialog-actions{padding:8px 0;display:flex;flex-wrap:wrap;min-height:52px;align-items:center;margin-bottom:-24px}.mat-dialog-actions[align=end]{justify-content:flex-end}.mat-dialog-actions[align=center]{justify-content:center}.mat-dialog-actions .mat-button-base+.mat-button-base{margin-left:8px}[dir=rtl] .mat-dialog-actions .mat-button-base+.mat-button-base{margin-left:0;margin-right:8px}"],
                    encapsulation: ViewEncapsulation.None,
                    // Using OnPush for dialogs caused some G3 sync issues. Disabled until we can track them down.
                    // tslint:disable-next-line:validate-decorators
                    changeDetection: ChangeDetectionStrategy.Default,
                    animations: [matDialogAnimations.dialogContainer],
                    host: {
                        'class': 'mat-dialog-container',
                        'tabindex': '-1',
                        'aria-modal': 'true',
                        '[attr.id]': '_id',
                        '[attr.role]': '_config.role',
                        '[attr.aria-labelledby]': '_config.ariaLabel ? null : _ariaLabelledBy',
                        '[attr.aria-label]': '_config.ariaLabel',
                        '[attr.aria-describedby]': '_config.ariaDescribedBy || null',
                        '[@dialogContainer]': '_state',
                        '(@dialogContainer.start)': '_onAnimationStart($event)',
                        '(@dialogContainer.done)': '_onAnimationDone($event)',
                    },
                },] },
    ];
    /** @nocollapse */
    MatDialogContainer.ctorParameters = function () { return [
        { type: ElementRef },
        { type: FocusTrapFactory },
        { type: ChangeDetectorRef },
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [DOCUMENT,] }] },
        { type: MatDialogConfig }
    ]; };
    MatDialogContainer.propDecorators = {
        _portalOutlet: [{ type: ViewChild, args: [CdkPortalOutlet, { static: true },] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // TODO(jelbourn): resizing
    // Counter for unique dialog ids.
    /** @type {?} */
    var uniqueId = 0;
    /**
     * Reference to a dialog opened via the MatDialog service.
     * @template T, R
     */
    var MatDialogRef = /** @class */ (function () {
        /**
         * @param {?} _overlayRef
         * @param {?} _containerInstance
         * @param {?=} _location
         * @param {?=} id
         */
        function MatDialogRef(_overlayRef, _containerInstance, 
        // @breaking-change 8.0.0 `_location` parameter to be removed.
        _location, id) {
            if (id === void 0) { id = "mat-dialog-" + uniqueId++; }
            var _this = this;
            this._overlayRef = _overlayRef;
            this._containerInstance = _containerInstance;
            this.id = id;
            /**
             * Whether the user is allowed to close the dialog.
             */
            this.disableClose = this._containerInstance._config.disableClose;
            /**
             * Subject for notifying the user that the dialog has finished opening.
             */
            this._afterOpened = new Subject();
            /**
             * Subject for notifying the user that the dialog has finished closing.
             */
            this._afterClosed = new Subject();
            /**
             * Subject for notifying the user that the dialog has started closing.
             */
            this._beforeClosed = new Subject();
            /**
             * Current state of the dialog.
             */
            this._state = 0 /* OPEN */;
            // Pass the id along to the container.
            _containerInstance._id = id;
            // Emit when opening animation completes
            _containerInstance._animationStateChanged.pipe(filter(( /**
             * @param {?} event
             * @return {?}
             */function (/**
             * @param {?} event
             * @return {?}
             */ event) { return event.phaseName === 'done' && event.toState === 'enter'; })), take(1))
                .subscribe(( /**
         * @return {?}
         */function () {
                _this._afterOpened.next();
                _this._afterOpened.complete();
            }));
            // Dispose overlay when closing animation is complete
            _containerInstance._animationStateChanged.pipe(filter(( /**
             * @param {?} event
             * @return {?}
             */function (/**
             * @param {?} event
             * @return {?}
             */ event) { return event.phaseName === 'done' && event.toState === 'exit'; })), take(1)).subscribe(( /**
             * @return {?}
             */function () {
                clearTimeout(_this._closeFallbackTimeout);
                _this._overlayRef.dispose();
            }));
            _overlayRef.detachments().subscribe(( /**
             * @return {?}
             */function () {
                _this._beforeClosed.next(_this._result);
                _this._beforeClosed.complete();
                _this._afterClosed.next(_this._result);
                _this._afterClosed.complete();
                _this.componentInstance = ( /** @type {?} */(null));
                _this._overlayRef.dispose();
            }));
            _overlayRef.keydownEvents()
                .pipe(filter(( /**
         * @param {?} event
         * @return {?}
         */function (/**
         * @param {?} event
         * @return {?}
         */ event) {
                return event.keyCode === ESCAPE && !_this.disableClose && !hasModifierKey(event);
            })))
                .subscribe(( /**
         * @param {?} event
         * @return {?}
         */function (/**
         * @param {?} event
         * @return {?}
         */ event) {
                event.preventDefault();
                _this.close();
            }));
        }
        /**
         * Close the dialog.
         * @param {?=} dialogResult Optional result to return to the dialog opener.
         * @return {?}
         */
        MatDialogRef.prototype.close = function (dialogResult) {
            var _this = this;
            this._result = dialogResult;
            // Transition the backdrop in parallel to the dialog.
            this._containerInstance._animationStateChanged.pipe(filter(( /**
             * @param {?} event
             * @return {?}
             */function (/**
             * @param {?} event
             * @return {?}
             */ event) { return event.phaseName === 'start'; })), take(1))
                .subscribe(( /**
         * @param {?} event
         * @return {?}
         */function (/**
         * @param {?} event
         * @return {?}
         */ event) {
                _this._beforeClosed.next(dialogResult);
                _this._beforeClosed.complete();
                _this._state = 2 /* CLOSED */;
                _this._overlayRef.detachBackdrop();
                // The logic that disposes of the overlay depends on the exit animation completing, however
                // it isn't guaranteed if the parent view is destroyed while it's running. Add a fallback
                // timeout which will clean everything up if the animation hasn't fired within the specified
                // amount of time plus 100ms. We don't need to run this outside the NgZone, because for the
                // vast majority of cases the timeout will have been cleared before it has the chance to fire.
                _this._closeFallbackTimeout = setTimeout(( /**
                 * @return {?}
                 */function () {
                    _this._overlayRef.dispose();
                }), event.totalTime + 100);
            }));
            this._containerInstance._startExitAnimation();
            this._state = 1 /* CLOSING */;
        };
        /**
         * Gets an observable that is notified when the dialog is finished opening.
         * @return {?}
         */
        MatDialogRef.prototype.afterOpened = function () {
            return this._afterOpened.asObservable();
        };
        /**
         * Gets an observable that is notified when the dialog is finished closing.
         * @return {?}
         */
        MatDialogRef.prototype.afterClosed = function () {
            return this._afterClosed.asObservable();
        };
        /**
         * Gets an observable that is notified when the dialog has started closing.
         * @return {?}
         */
        MatDialogRef.prototype.beforeClosed = function () {
            return this._beforeClosed.asObservable();
        };
        /**
         * Gets an observable that emits when the overlay's backdrop has been clicked.
         * @return {?}
         */
        MatDialogRef.prototype.backdropClick = function () {
            return this._overlayRef.backdropClick();
        };
        /**
         * Gets an observable that emits when keydown events are targeted on the overlay.
         * @return {?}
         */
        MatDialogRef.prototype.keydownEvents = function () {
            return this._overlayRef.keydownEvents();
        };
        /**
         * Updates the dialog's position.
         * @template THIS
         * @this {THIS}
         * @param {?=} position New dialog position.
         * @return {THIS}
         */
        MatDialogRef.prototype.updatePosition = function (position) {
            /** @type {?} */
            var strategy = ( /** @type {?} */(this))._getPositionStrategy();
            if (position && (position.left || position.right)) {
                position.left ? strategy.left(position.left) : strategy.right(position.right);
            }
            else {
                strategy.centerHorizontally();
            }
            if (position && (position.top || position.bottom)) {
                position.top ? strategy.top(position.top) : strategy.bottom(position.bottom);
            }
            else {
                strategy.centerVertically();
            }
            ( /** @type {?} */(this))._overlayRef.updatePosition();
            return ( /** @type {?} */(this));
        };
        /**
         * Updates the dialog's width and height.
         * @template THIS
         * @this {THIS}
         * @param {?=} width New width of the dialog.
         * @param {?=} height New height of the dialog.
         * @return {THIS}
         */
        MatDialogRef.prototype.updateSize = function (width, height) {
            if (width === void 0) { width = ''; }
            if (height === void 0) { height = ''; }
            ( /** @type {?} */(this))._getPositionStrategy().width(width).height(height);
            ( /** @type {?} */(this))._overlayRef.updatePosition();
            return ( /** @type {?} */(this));
        };
        /**
         * Add a CSS class or an array of classes to the overlay pane.
         * @template THIS
         * @this {THIS}
         * @param {?} classes
         * @return {THIS}
         */
        MatDialogRef.prototype.addPanelClass = function (classes) {
            ( /** @type {?} */(this))._overlayRef.addPanelClass(classes);
            return ( /** @type {?} */(this));
        };
        /**
         * Remove a CSS class or an array of classes from the overlay pane.
         * @template THIS
         * @this {THIS}
         * @param {?} classes
         * @return {THIS}
         */
        MatDialogRef.prototype.removePanelClass = function (classes) {
            ( /** @type {?} */(this))._overlayRef.removePanelClass(classes);
            return ( /** @type {?} */(this));
        };
        /**
         * Gets an observable that is notified when the dialog is finished opening.
         * @deprecated Use `afterOpened` instead.
         * \@breaking-change 8.0.0
         * @return {?}
         */
        MatDialogRef.prototype.afterOpen = function () {
            return this.afterOpened();
        };
        /**
         * Gets an observable that is notified when the dialog has started closing.
         * @deprecated Use `beforeClosed` instead.
         * \@breaking-change 8.0.0
         * @return {?}
         */
        MatDialogRef.prototype.beforeClose = function () {
            return this.beforeClosed();
        };
        /**
         * Gets the current state of the dialog's lifecycle.
         * @return {?}
         */
        MatDialogRef.prototype.getState = function () {
            return this._state;
        };
        /**
         * Fetches the position strategy object from the overlay ref.
         * @private
         * @return {?}
         */
        MatDialogRef.prototype._getPositionStrategy = function () {
            return ( /** @type {?} */(this._overlayRef.getConfig().positionStrategy));
        };
        return MatDialogRef;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Injection token that can be used to access the data that was passed in to a dialog.
     * @type {?}
     */
    var MAT_DIALOG_DATA = new InjectionToken('MatDialogData');
    /**
     * Injection token that can be used to specify default dialog options.
     * @type {?}
     */
    var MAT_DIALOG_DEFAULT_OPTIONS = new InjectionToken('mat-dialog-default-options');
    /**
     * Injection token that determines the scroll handling while the dialog is open.
     * @type {?}
     */
    var MAT_DIALOG_SCROLL_STRATEGY = new InjectionToken('mat-dialog-scroll-strategy');
    /**
     * \@docs-private
     * @param {?} overlay
     * @return {?}
     */
    function MAT_DIALOG_SCROLL_STRATEGY_PROVIDER_FACTORY(overlay) {
        return ( /**
         * @return {?}
         */function () { return overlay.scrollStrategies.block(); });
    }
    /**
     * \@docs-private
     * @type {?}
     */
    var MAT_DIALOG_SCROLL_STRATEGY_PROVIDER = {
        provide: MAT_DIALOG_SCROLL_STRATEGY,
        deps: [Overlay],
        useFactory: MAT_DIALOG_SCROLL_STRATEGY_PROVIDER_FACTORY,
    };
    /**
     * Service to open Material Design modal dialogs.
     */
    var MatDialog = /** @class */ (function () {
        /**
         * @param {?} _overlay
         * @param {?} _injector
         * @param {?} _location
         * @param {?} _defaultOptions
         * @param {?} scrollStrategy
         * @param {?} _parentDialog
         * @param {?} _overlayContainer
         */
        function MatDialog(_overlay, _injector, _location, _defaultOptions, scrollStrategy, _parentDialog, _overlayContainer) {
            var _this = this;
            this._overlay = _overlay;
            this._injector = _injector;
            this._location = _location;
            this._defaultOptions = _defaultOptions;
            this._parentDialog = _parentDialog;
            this._overlayContainer = _overlayContainer;
            this._openDialogsAtThisLevel = [];
            this._afterAllClosedAtThisLevel = new Subject();
            this._afterOpenedAtThisLevel = new Subject();
            this._ariaHiddenElements = new Map();
            // TODO (jelbourn): tighten the typing right-hand side of this expression.
            /**
             * Stream that emits when all open dialog have finished closing.
             * Will emit on subscribe if there are no open dialogs to begin with.
             */
            this.afterAllClosed = ( /** @type {?} */(defer(( /**
             * @return {?}
             */function () { return _this.openDialogs.length ?
                _this._afterAllClosed :
                _this._afterAllClosed.pipe(startWith(undefined)); }))));
            this._scrollStrategy = scrollStrategy;
        }
        Object.defineProperty(MatDialog.prototype, "openDialogs", {
            /**
             * Keeps track of the currently-open dialogs.
             * @return {?}
             */
            get: function () {
                return this._parentDialog ? this._parentDialog.openDialogs : this._openDialogsAtThisLevel;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatDialog.prototype, "afterOpened", {
            /**
             * Stream that emits when a dialog has been opened.
             * @return {?}
             */
            get: function () {
                return this._parentDialog ? this._parentDialog.afterOpened : this._afterOpenedAtThisLevel;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatDialog.prototype, "afterOpen", {
            /**
             * Stream that emits when a dialog has been opened.
             * @deprecated Use `afterOpened` instead.
             * \@breaking-change 8.0.0
             * @return {?}
             */
            get: function () {
                return this.afterOpened;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatDialog.prototype, "_afterAllClosed", {
            /**
             * @return {?}
             */
            get: function () {
                /** @type {?} */
                var parent = this._parentDialog;
                return parent ? parent._afterAllClosed : this._afterAllClosedAtThisLevel;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Opens a modal dialog containing the given component.
         * @template T, D, R
         * @param {?} componentOrTemplateRef Type of the component to load into the dialog,
         *     or a TemplateRef to instantiate as the dialog content.
         * @param {?=} config Extra configuration options.
         * @return {?} Reference to the newly-opened dialog.
         */
        MatDialog.prototype.open = function (componentOrTemplateRef, config) {
            var _this = this;
            config = _applyConfigDefaults(config, this._defaultOptions || new MatDialogConfig());
            if (config.id && this.getDialogById(config.id)) {
                throw Error("Dialog with id \"" + config.id + "\" exists already. The dialog id must be unique.");
            }
            /** @type {?} */
            var overlayRef = this._createOverlay(config);
            /** @type {?} */
            var dialogContainer = this._attachDialogContainer(overlayRef, config);
            /** @type {?} */
            var dialogRef = this._attachDialogContent(componentOrTemplateRef, dialogContainer, overlayRef, config);
            // If this is the first dialog that we're opening, hide all the non-overlay content.
            if (!this.openDialogs.length) {
                this._hideNonDialogContentFromAssistiveTechnology();
            }
            this.openDialogs.push(dialogRef);
            dialogRef.afterClosed().subscribe(( /**
             * @return {?}
             */function () { return _this._removeOpenDialog(dialogRef); }));
            this.afterOpened.next(dialogRef);
            return dialogRef;
        };
        /**
         * Closes all of the currently-open dialogs.
         * @return {?}
         */
        MatDialog.prototype.closeAll = function () {
            this._closeDialogs(this.openDialogs);
        };
        /**
         * Finds an open dialog by its id.
         * @param {?} id ID to use when looking up the dialog.
         * @return {?}
         */
        MatDialog.prototype.getDialogById = function (id) {
            return this.openDialogs.find(( /**
             * @param {?} dialog
             * @return {?}
             */function (/**
             * @param {?} dialog
             * @return {?}
             */ dialog) { return dialog.id === id; }));
        };
        /**
         * @return {?}
         */
        MatDialog.prototype.ngOnDestroy = function () {
            // Only close the dialogs at this level on destroy
            // since the parent service may still be active.
            this._closeDialogs(this._openDialogsAtThisLevel);
            this._afterAllClosedAtThisLevel.complete();
            this._afterOpenedAtThisLevel.complete();
        };
        /**
         * Creates the overlay into which the dialog will be loaded.
         * @private
         * @param {?} config The dialog configuration.
         * @return {?} A promise resolving to the OverlayRef for the created overlay.
         */
        MatDialog.prototype._createOverlay = function (config) {
            /** @type {?} */
            var overlayConfig = this._getOverlayConfig(config);
            return this._overlay.create(overlayConfig);
        };
        /**
         * Creates an overlay config from a dialog config.
         * @private
         * @param {?} dialogConfig The dialog configuration.
         * @return {?} The overlay configuration.
         */
        MatDialog.prototype._getOverlayConfig = function (dialogConfig) {
            /** @type {?} */
            var state$$1 = new OverlayConfig({
                positionStrategy: this._overlay.position().global(),
                scrollStrategy: dialogConfig.scrollStrategy || this._scrollStrategy(),
                panelClass: dialogConfig.panelClass,
                hasBackdrop: dialogConfig.hasBackdrop,
                direction: dialogConfig.direction,
                minWidth: dialogConfig.minWidth,
                minHeight: dialogConfig.minHeight,
                maxWidth: dialogConfig.maxWidth,
                maxHeight: dialogConfig.maxHeight,
                disposeOnNavigation: dialogConfig.closeOnNavigation
            });
            if (dialogConfig.backdropClass) {
                state$$1.backdropClass = dialogConfig.backdropClass;
            }
            return state$$1;
        };
        /**
         * Attaches an MatDialogContainer to a dialog's already-created overlay.
         * @private
         * @param {?} overlay Reference to the dialog's underlying overlay.
         * @param {?} config The dialog configuration.
         * @return {?} A promise resolving to a ComponentRef for the attached container.
         */
        MatDialog.prototype._attachDialogContainer = function (overlay, config) {
            /** @type {?} */
            var userInjector = config && config.viewContainerRef && config.viewContainerRef.injector;
            /** @type {?} */
            var injector = new PortalInjector(userInjector || this._injector, new WeakMap([
                [MatDialogConfig, config]
            ]));
            /** @type {?} */
            var containerPortal = new ComponentPortal(MatDialogContainer, config.viewContainerRef, injector, config.componentFactoryResolver);
            /** @type {?} */
            var containerRef = overlay.attach(containerPortal);
            return containerRef.instance;
        };
        /**
         * Attaches the user-provided component to the already-created MatDialogContainer.
         * @private
         * @template T, R
         * @param {?} componentOrTemplateRef The type of component being loaded into the dialog,
         *     or a TemplateRef to instantiate as the content.
         * @param {?} dialogContainer Reference to the wrapping MatDialogContainer.
         * @param {?} overlayRef Reference to the overlay in which the dialog resides.
         * @param {?} config The dialog configuration.
         * @return {?} A promise resolving to the MatDialogRef that should be returned to the user.
         */
        MatDialog.prototype._attachDialogContent = function (componentOrTemplateRef, dialogContainer, overlayRef, config) {
            // Create a reference to the dialog we're creating in order to give the user a handle
            // to modify and close it.
            /** @type {?} */
            var dialogRef = new MatDialogRef(overlayRef, dialogContainer, this._location, config.id);
            // When the dialog backdrop is clicked, we want to close it.
            if (config.hasBackdrop) {
                overlayRef.backdropClick().subscribe(( /**
                 * @return {?}
                 */function () {
                    if (!dialogRef.disableClose) {
                        dialogRef.close();
                    }
                }));
            }
            if (componentOrTemplateRef instanceof TemplateRef) {
                dialogContainer.attachTemplatePortal(new TemplatePortal(componentOrTemplateRef, ( /** @type {?} */(null)), ( /** @type {?} */({ $implicit: config.data, dialogRef: dialogRef }))));
            }
            else {
                /** @type {?} */
                var injector = this._createInjector(config, dialogRef, dialogContainer);
                /** @type {?} */
                var contentRef = dialogContainer.attachComponentPortal(new ComponentPortal(componentOrTemplateRef, undefined, injector));
                dialogRef.componentInstance = contentRef.instance;
            }
            dialogRef
                .updateSize(config.width, config.height)
                .updatePosition(config.position);
            return dialogRef;
        };
        /**
         * Creates a custom injector to be used inside the dialog. This allows a component loaded inside
         * of a dialog to close itself and, optionally, to return a value.
         * @private
         * @template T
         * @param {?} config Config object that is used to construct the dialog.
         * @param {?} dialogRef Reference to the dialog.
         * @param {?} dialogContainer
         * @return {?} The custom injector that can be used inside the dialog.
         */
        MatDialog.prototype._createInjector = function (config, dialogRef, dialogContainer) {
            /** @type {?} */
            var userInjector = config && config.viewContainerRef && config.viewContainerRef.injector;
            // The MatDialogContainer is injected in the portal as the MatDialogContainer and the dialog's
            // content are created out of the same ViewContainerRef and as such, are siblings for injector
            // purposes. To allow the hierarchy that is expected, the MatDialogContainer is explicitly
            // added to the injection tokens.
            /** @type {?} */
            var injectionTokens = new WeakMap([
                [MatDialogContainer, dialogContainer],
                [MAT_DIALOG_DATA, config.data],
                [MatDialogRef, dialogRef]
            ]);
            if (config.direction &&
                (!userInjector || !userInjector.get(Directionality, null))) {
                injectionTokens.set(Directionality, {
                    value: config.direction,
                    change: of()
                });
            }
            return new PortalInjector(userInjector || this._injector, injectionTokens);
        };
        /**
         * Removes a dialog from the array of open dialogs.
         * @private
         * @param {?} dialogRef Dialog to be removed.
         * @return {?}
         */
        MatDialog.prototype._removeOpenDialog = function (dialogRef) {
            /** @type {?} */
            var index = this.openDialogs.indexOf(dialogRef);
            if (index > -1) {
                this.openDialogs.splice(index, 1);
                // If all the dialogs were closed, remove/restore the `aria-hidden`
                // to a the siblings and emit to the `afterAllClosed` stream.
                if (!this.openDialogs.length) {
                    this._ariaHiddenElements.forEach(( /**
                     * @param {?} previousValue
                     * @param {?} element
                     * @return {?}
                     */function (previousValue, element) {
                        if (previousValue) {
                            element.setAttribute('aria-hidden', previousValue);
                        }
                        else {
                            element.removeAttribute('aria-hidden');
                        }
                    }));
                    this._ariaHiddenElements.clear();
                    this._afterAllClosed.next();
                }
            }
        };
        /**
         * Hides all of the content that isn't an overlay from assistive technology.
         * @private
         * @return {?}
         */
        MatDialog.prototype._hideNonDialogContentFromAssistiveTechnology = function () {
            /** @type {?} */
            var overlayContainer = this._overlayContainer.getContainerElement();
            // Ensure that the overlay container is attached to the DOM.
            if (overlayContainer.parentElement) {
                /** @type {?} */
                var siblings = overlayContainer.parentElement.children;
                for (var i_158 = siblings.length - 1; i_158 > -1; i_158--) {
                    /** @type {?} */
                    var sibling = siblings[i_158];
                    if (sibling !== overlayContainer &&
                        sibling.nodeName !== 'SCRIPT' &&
                        sibling.nodeName !== 'STYLE' &&
                        !sibling.hasAttribute('aria-live')) {
                        this._ariaHiddenElements.set(sibling, sibling.getAttribute('aria-hidden'));
                        sibling.setAttribute('aria-hidden', 'true');
                    }
                }
            }
        };
        /**
         * Closes all of the dialogs in an array.
         * @private
         * @param {?} dialogs
         * @return {?}
         */
        MatDialog.prototype._closeDialogs = function (dialogs) {
            /** @type {?} */
            var i = dialogs.length;
            while (i--) {
                // The `_openDialogs` property isn't updated after close until the rxjs subscription
                // runs on the next microtask, in addition to modifying the array as we're going
                // through it. We loop through all of them and call close without assuming that
                // they'll be removed from the list instantaneously.
                dialogs[i].close();
            }
        };
        return MatDialog;
    }());
    MatDialog.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    MatDialog.ctorParameters = function () { return [
        { type: Overlay },
        { type: Injector },
        { type: Location, decorators: [{ type: Optional }] },
        { type: MatDialogConfig, decorators: [{ type: Optional }, { type: Inject, args: [MAT_DIALOG_DEFAULT_OPTIONS,] }] },
        { type: undefined, decorators: [{ type: Inject, args: [MAT_DIALOG_SCROLL_STRATEGY,] }] },
        { type: MatDialog, decorators: [{ type: Optional }, { type: SkipSelf }] },
        { type: OverlayContainer }
    ]; };
    /**
     * Applies default options to the dialog config.
     * @param {?=} config Config to be modified.
     * @param {?=} defaultOptions Default options provided.
     * @return {?} The new configuration object.
     */
    function _applyConfigDefaults(config, defaultOptions) {
        return Object.assign({}, defaultOptions, config);
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Counter used to generate unique IDs for dialog elements.
     * @type {?}
     */
    var dialogElementUid = 0;
    /**
     * Button that will close the current dialog.
     */
    var MatDialogClose = /** @class */ (function () {
        /**
         * @param {?} dialogRef
         * @param {?} _elementRef
         * @param {?} _dialog
         */
        function MatDialogClose(dialogRef, _elementRef, _dialog) {
            this.dialogRef = dialogRef;
            this._elementRef = _elementRef;
            this._dialog = _dialog;
            /**
             * Default to "button" to prevents accidental form submits.
             */
            this.type = 'button';
        }
        /**
         * @return {?}
         */
        MatDialogClose.prototype.ngOnInit = function () {
            if (!this.dialogRef) {
                // When this directive is included in a dialog via TemplateRef (rather than being
                // in a Component), the DialogRef isn't available via injection because embedded
                // views cannot be given a custom injector. Instead, we look up the DialogRef by
                // ID. This must occur in `onInit`, as the ID binding for the dialog container won't
                // be resolved at constructor time.
                this.dialogRef = ( /** @type {?} */(getClosestDialog(this._elementRef, this._dialog.openDialogs)));
            }
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        MatDialogClose.prototype.ngOnChanges = function (changes) {
            /** @type {?} */
            var proxiedChange = changes['_matDialogClose'] || changes['_matDialogCloseResult'];
            if (proxiedChange) {
                this.dialogResult = proxiedChange.currentValue;
            }
        };
        return MatDialogClose;
    }());
    MatDialogClose.decorators = [
        { type: Directive, args: [{
                    selector: '[mat-dialog-close], [matDialogClose]',
                    exportAs: 'matDialogClose',
                    host: {
                        '(click)': 'dialogRef.close(dialogResult)',
                        '[attr.aria-label]': 'ariaLabel || null',
                        '[attr.type]': 'type',
                    }
                },] },
    ];
    /** @nocollapse */
    MatDialogClose.ctorParameters = function () { return [
        { type: MatDialogRef, decorators: [{ type: Optional }] },
        { type: ElementRef },
        { type: MatDialog }
    ]; };
    MatDialogClose.propDecorators = {
        ariaLabel: [{ type: Input, args: ['aria-label',] }],
        type: [{ type: Input }],
        dialogResult: [{ type: Input, args: ['mat-dialog-close',] }],
        _matDialogClose: [{ type: Input, args: ['matDialogClose',] }]
    };
    /**
     * Title of a dialog element. Stays fixed to the top of the dialog when scrolling.
     */
    var MatDialogTitle = /** @class */ (function () {
        /**
         * @param {?} _dialogRef
         * @param {?} _elementRef
         * @param {?} _dialog
         */
        function MatDialogTitle(_dialogRef, _elementRef, _dialog) {
            this._dialogRef = _dialogRef;
            this._elementRef = _elementRef;
            this._dialog = _dialog;
            this.id = "mat-dialog-title-" + dialogElementUid++;
        }
        /**
         * @return {?}
         */
        MatDialogTitle.prototype.ngOnInit = function () {
            var _this = this;
            if (!this._dialogRef) {
                this._dialogRef = ( /** @type {?} */(getClosestDialog(this._elementRef, this._dialog.openDialogs)));
            }
            if (this._dialogRef) {
                Promise.resolve().then(( /**
                 * @return {?}
                 */function () {
                    /** @type {?} */
                    var container = _this._dialogRef._containerInstance;
                    if (container && !container._ariaLabelledBy) {
                        container._ariaLabelledBy = _this.id;
                    }
                }));
            }
        };
        return MatDialogTitle;
    }());
    MatDialogTitle.decorators = [
        { type: Directive, args: [{
                    selector: '[mat-dialog-title], [matDialogTitle]',
                    exportAs: 'matDialogTitle',
                    host: {
                        'class': 'mat-dialog-title',
                        '[id]': 'id',
                    },
                },] },
    ];
    /** @nocollapse */
    MatDialogTitle.ctorParameters = function () { return [
        { type: MatDialogRef, decorators: [{ type: Optional }] },
        { type: ElementRef },
        { type: MatDialog }
    ]; };
    MatDialogTitle.propDecorators = {
        id: [{ type: Input }]
    };
    /**
     * Scrollable content container of a dialog.
     */
    var MatDialogContent = /** @class */ (function () {
        function MatDialogContent() {
        }
        return MatDialogContent;
    }());
    MatDialogContent.decorators = [
        { type: Directive, args: [{
                    selector: "[mat-dialog-content], mat-dialog-content, [matDialogContent]",
                    host: { 'class': 'mat-dialog-content' }
                },] },
    ];
    /**
     * Container for the bottom action buttons in a dialog.
     * Stays fixed to the bottom when scrolling.
     */
    var MatDialogActions = /** @class */ (function () {
        function MatDialogActions() {
        }
        return MatDialogActions;
    }());
    MatDialogActions.decorators = [
        { type: Directive, args: [{
                    selector: "[mat-dialog-actions], mat-dialog-actions, [matDialogActions]",
                    host: { 'class': 'mat-dialog-actions' }
                },] },
    ];
    /**
     * Finds the closest MatDialogRef to an element by looking at the DOM.
     * @param {?} element Element relative to which to look for a dialog.
     * @param {?} openDialogs References to the currently-open dialogs.
     * @return {?}
     */
    function getClosestDialog(element, openDialogs) {
        /** @type {?} */
        var parent = element.nativeElement.parentElement;
        while (parent && !parent.classList.contains('mat-dialog-container')) {
            parent = parent.parentElement;
        }
        return parent ? openDialogs.find(( /**
         * @param {?} dialog
         * @return {?}
         */function (/**
         * @param {?} dialog
         * @return {?}
         */ dialog) { return dialog.id === ( /** @type {?} */(parent)).id; })) : null;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatDialogModule = /** @class */ (function () {
        function MatDialogModule() {
        }
        return MatDialogModule;
    }());
    MatDialogModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        OverlayModule,
                        PortalModule,
                        MatCommonModule,
                    ],
                    exports: [
                        MatDialogContainer,
                        MatDialogClose,
                        MatDialogTitle,
                        MatDialogContent,
                        MatDialogActions,
                        MatCommonModule,
                    ],
                    declarations: [
                        MatDialogContainer,
                        MatDialogClose,
                        MatDialogTitle,
                        MatDialogActions,
                        MatDialogContent,
                    ],
                    providers: [
                        MatDialog,
                        MAT_DIALOG_SCROLL_STRATEGY_PROVIDER,
                    ],
                    entryComponents: [MatDialogContainer],
                },] },
    ];
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Base reference size of the spinner.
     * \@docs-private
     * @type {?}
     */
    var BASE_SIZE = 100;
    /**
     * Base reference stroke width of the spinner.
     * \@docs-private
     * @type {?}
     */
    var BASE_STROKE_WIDTH = 10;
    // Boilerplate for applying mixins to MatProgressSpinner.
    /**
     * \@docs-private
     */
    var MatProgressSpinnerBase = /** @class */ (function () {
        /**
         * @param {?} _elementRef
         */
        function MatProgressSpinnerBase(_elementRef) {
            this._elementRef = _elementRef;
        }
        return MatProgressSpinnerBase;
    }());
    /** @type {?} */
    var _MatProgressSpinnerMixinBase = mixinColor(MatProgressSpinnerBase, 'primary');
    /**
     * Injection token to be used to override the default options for `mat-progress-spinner`.
     * @type {?}
     */
    var MAT_PROGRESS_SPINNER_DEFAULT_OPTIONS = new InjectionToken('mat-progress-spinner-default-options', {
        providedIn: 'root',
        factory: MAT_PROGRESS_SPINNER_DEFAULT_OPTIONS_FACTORY,
    });
    /**
     * \@docs-private
     * @return {?}
     */
    function MAT_PROGRESS_SPINNER_DEFAULT_OPTIONS_FACTORY() {
        return { diameter: BASE_SIZE };
    }
    // .0001 percentage difference is necessary in order to avoid unwanted animation frames
    // for example because the animation duration is 4 seconds, .1% accounts to 4ms
    // which are enough to see the flicker described in
    // https://github.com/angular/components/issues/8984
    /** @type {?} */
    var INDETERMINATE_ANIMATION_TEMPLATE = "\n @keyframes mat-progress-spinner-stroke-rotate-DIAMETER {\n    0%      { stroke-dashoffset: START_VALUE;  transform: rotate(0); }\n    12.5%   { stroke-dashoffset: END_VALUE;    transform: rotate(0); }\n    12.5001%  { stroke-dashoffset: END_VALUE;    transform: rotateX(180deg) rotate(72.5deg); }\n    25%     { stroke-dashoffset: START_VALUE;  transform: rotateX(180deg) rotate(72.5deg); }\n\n    25.0001%   { stroke-dashoffset: START_VALUE;  transform: rotate(270deg); }\n    37.5%   { stroke-dashoffset: END_VALUE;    transform: rotate(270deg); }\n    37.5001%  { stroke-dashoffset: END_VALUE;    transform: rotateX(180deg) rotate(161.5deg); }\n    50%     { stroke-dashoffset: START_VALUE;  transform: rotateX(180deg) rotate(161.5deg); }\n\n    50.0001%  { stroke-dashoffset: START_VALUE;  transform: rotate(180deg); }\n    62.5%   { stroke-dashoffset: END_VALUE;    transform: rotate(180deg); }\n    62.5001%  { stroke-dashoffset: END_VALUE;    transform: rotateX(180deg) rotate(251.5deg); }\n    75%     { stroke-dashoffset: START_VALUE;  transform: rotateX(180deg) rotate(251.5deg); }\n\n    75.0001%  { stroke-dashoffset: START_VALUE;  transform: rotate(90deg); }\n    87.5%   { stroke-dashoffset: END_VALUE;    transform: rotate(90deg); }\n    87.5001%  { stroke-dashoffset: END_VALUE;    transform: rotateX(180deg) rotate(341.5deg); }\n    100%    { stroke-dashoffset: START_VALUE;  transform: rotateX(180deg) rotate(341.5deg); }\n  }\n";
    /**
     * `<mat-progress-spinner>` component.
     */
    var MatProgressSpinner = /** @class */ (function (_super) {
        __extends(MatProgressSpinner, _super);
        /**
         * @param {?} _elementRef
         * @param {?} platform
         * @param {?} _document
         * @param {?} animationMode
         * @param {?=} defaults
         */
        function MatProgressSpinner(_elementRef, platform, _document, animationMode, defaults) {
            var _this = _super.call(this, _elementRef) || this;
            _this._elementRef = _elementRef;
            _this._document = _document;
            _this._diameter = BASE_SIZE;
            _this._value = 0;
            _this._fallbackAnimation = false;
            /**
             * Mode of the progress circle
             */
            _this.mode = 'determinate';
            /** @type {?} */
            var trackedDiameters = MatProgressSpinner._diameters;
            // The base size is already inserted via the component's structural styles. We still
            // need to track it so we don't end up adding the same styles again.
            if (!trackedDiameters.has(_document.head)) {
                trackedDiameters.set(_document.head, new Set([BASE_SIZE]));
            }
            _this._fallbackAnimation = platform.EDGE || platform.TRIDENT;
            _this._noopAnimations = animationMode === 'NoopAnimations' &&
                (!!defaults && !defaults._forceAnimations);
            if (defaults) {
                if (defaults.diameter) {
                    _this.diameter = defaults.diameter;
                }
                if (defaults.strokeWidth) {
                    _this.strokeWidth = defaults.strokeWidth;
                }
            }
            return _this;
        }
        Object.defineProperty(MatProgressSpinner.prototype, "diameter", {
            /**
             * The diameter of the progress spinner (will set width and height of svg).
             * @return {?}
             */
            get: function () { return this._diameter; },
            /**
             * @param {?} size
             * @return {?}
             */
            set: function (size) {
                this._diameter = coerceNumberProperty(size);
                // If this is set before `ngOnInit`, the style root may not have been resolved yet.
                if (!this._fallbackAnimation && this._styleRoot) {
                    this._attachStyleNode();
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatProgressSpinner.prototype, "strokeWidth", {
            /**
             * Stroke width of the progress spinner.
             * @return {?}
             */
            get: function () {
                return this._strokeWidth || this.diameter / 10;
            },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._strokeWidth = coerceNumberProperty(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatProgressSpinner.prototype, "value", {
            /**
             * Value of the progress circle.
             * @return {?}
             */
            get: function () {
                return this.mode === 'determinate' ? this._value : 0;
            },
            /**
             * @param {?} newValue
             * @return {?}
             */
            set: function (newValue) {
                this._value = Math.max(0, Math.min(100, coerceNumberProperty(newValue)));
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        MatProgressSpinner.prototype.ngOnInit = function () {
            /** @type {?} */
            var element = this._elementRef.nativeElement;
            // Note that we need to look up the root node in ngOnInit, rather than the constructor, because
            // Angular seems to create the element outside the shadow root and then moves it inside, if the
            // node is inside an `ngIf` and a ShadowDom-encapsulated component.
            this._styleRoot = _getShadowRoot(element, this._document) || this._document.head;
            this._attachStyleNode();
            // On IE and Edge, we can't animate the `stroke-dashoffset`
            // reliably so we fall back to a non-spec animation.
            /** @type {?} */
            var animationClass = "mat-progress-spinner-indeterminate" + (this._fallbackAnimation ? '-fallback' : '') + "-animation";
            element.classList.add(animationClass);
        };
        Object.defineProperty(MatProgressSpinner.prototype, "_circleRadius", {
            /**
             * The radius of the spinner, adjusted for stroke width.
             * @return {?}
             */
            get: function () {
                return (this.diameter - BASE_STROKE_WIDTH) / 2;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatProgressSpinner.prototype, "_viewBox", {
            /**
             * The view box of the spinner's svg element.
             * @return {?}
             */
            get: function () {
                /** @type {?} */
                var viewBox = this._circleRadius * 2 + this.strokeWidth;
                return "0 0 " + viewBox + " " + viewBox;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatProgressSpinner.prototype, "_strokeCircumference", {
            /**
             * The stroke circumference of the svg circle.
             * @return {?}
             */
            get: function () {
                return 2 * Math.PI * this._circleRadius;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatProgressSpinner.prototype, "_strokeDashOffset", {
            /**
             * The dash offset of the svg circle.
             * @return {?}
             */
            get: function () {
                if (this.mode === 'determinate') {
                    return this._strokeCircumference * (100 - this._value) / 100;
                }
                // In fallback mode set the circle to 80% and rotate it with CSS.
                if (this._fallbackAnimation && this.mode === 'indeterminate') {
                    return this._strokeCircumference * 0.2;
                }
                return null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatProgressSpinner.prototype, "_circleStrokeWidth", {
            /**
             * Stroke width of the circle in percent.
             * @return {?}
             */
            get: function () {
                return this.strokeWidth / this.diameter * 100;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Dynamically generates a style tag containing the correct animation for this diameter.
         * @private
         * @return {?}
         */
        MatProgressSpinner.prototype._attachStyleNode = function () {
            /** @type {?} */
            var styleRoot = this._styleRoot;
            /** @type {?} */
            var currentDiameter = this._diameter;
            /** @type {?} */
            var diameters = MatProgressSpinner._diameters;
            /** @type {?} */
            var diametersForElement = diameters.get(styleRoot);
            if (!diametersForElement || !diametersForElement.has(currentDiameter)) {
                /** @type {?} */
                var styleTag = this._document.createElement('style');
                styleTag.setAttribute('mat-spinner-animation', currentDiameter + '');
                styleTag.textContent = this._getAnimationText();
                styleRoot.appendChild(styleTag);
                if (!diametersForElement) {
                    diametersForElement = new Set();
                    diameters.set(styleRoot, diametersForElement);
                }
                diametersForElement.add(currentDiameter);
            }
        };
        /**
         * Generates animation styles adjusted for the spinner's diameter.
         * @private
         * @return {?}
         */
        MatProgressSpinner.prototype._getAnimationText = function () {
            return INDETERMINATE_ANIMATION_TEMPLATE
                // Animation should begin at 5% and end at 80%
                .replace(/START_VALUE/g, "" + 0.95 * this._strokeCircumference)
                .replace(/END_VALUE/g, "" + 0.2 * this._strokeCircumference)
                .replace(/DIAMETER/g, "" + this.diameter);
        };
        return MatProgressSpinner;
    }(_MatProgressSpinnerMixinBase));
    /**
     * Tracks diameters of existing instances to de-dupe generated styles (default d = 100).
     * We need to keep track of which elements the diameters were attached to, because for
     * elements in the Shadow DOM the style tags are attached to the shadow root, rather
     * than the document head.
     */
    MatProgressSpinner._diameters = new WeakMap();
    MatProgressSpinner.decorators = [
        { type: Component, args: [{ selector: 'mat-progress-spinner',
                    exportAs: 'matProgressSpinner',
                    host: {
                        'role': 'progressbar',
                        'class': 'mat-progress-spinner',
                        '[class._mat-animation-noopable]': "_noopAnimations",
                        '[style.width.px]': 'diameter',
                        '[style.height.px]': 'diameter',
                        '[attr.aria-valuemin]': 'mode === "determinate" ? 0 : null',
                        '[attr.aria-valuemax]': 'mode === "determinate" ? 100 : null',
                        '[attr.aria-valuenow]': 'mode === "determinate" ? value : null',
                        '[attr.mode]': 'mode',
                    },
                    inputs: ['color'],
                    template: "<svg [style.width.px]=\"diameter\" [style.height.px]=\"diameter\" [attr.viewBox]=\"_viewBox\" preserveAspectRatio=\"xMidYMid meet\" focusable=\"false\" [ngSwitch]=\"mode === 'indeterminate'\"><circle *ngSwitchCase=\"true\" cx=\"50%\" cy=\"50%\" [attr.r]=\"_circleRadius\" [style.animation-name]=\"'mat-progress-spinner-stroke-rotate-' + diameter\" [style.stroke-dashoffset.px]=\"_strokeDashOffset\" [style.stroke-dasharray.px]=\"_strokeCircumference\" [style.stroke-width.%]=\"_circleStrokeWidth\"></circle><circle *ngSwitchCase=\"false\" cx=\"50%\" cy=\"50%\" [attr.r]=\"_circleRadius\" [style.stroke-dashoffset.px]=\"_strokeDashOffset\" [style.stroke-dasharray.px]=\"_strokeCircumference\" [style.stroke-width.%]=\"_circleStrokeWidth\"></circle></svg>",
                    styles: [".mat-progress-spinner{display:block;position:relative}.mat-progress-spinner svg{position:absolute;transform:rotate(-90deg);top:0;left:0;transform-origin:center;overflow:visible}.mat-progress-spinner circle{fill:transparent;transform-origin:center;transition:stroke-dashoffset 225ms linear}._mat-animation-noopable.mat-progress-spinner circle{transition:none;animation:none}.mat-progress-spinner.mat-progress-spinner-indeterminate-animation[mode=indeterminate]{animation:mat-progress-spinner-linear-rotate 2s linear infinite}._mat-animation-noopable.mat-progress-spinner.mat-progress-spinner-indeterminate-animation[mode=indeterminate]{transition:none;animation:none}.mat-progress-spinner.mat-progress-spinner-indeterminate-animation[mode=indeterminate] circle{transition-property:stroke;animation-duration:4s;animation-timing-function:cubic-bezier(.35,0,.25,1);animation-iteration-count:infinite}._mat-animation-noopable.mat-progress-spinner.mat-progress-spinner-indeterminate-animation[mode=indeterminate] circle{transition:none;animation:none}.mat-progress-spinner.mat-progress-spinner-indeterminate-fallback-animation[mode=indeterminate]{animation:mat-progress-spinner-stroke-rotate-fallback 10s cubic-bezier(.87,.03,.33,1) infinite}._mat-animation-noopable.mat-progress-spinner.mat-progress-spinner-indeterminate-fallback-animation[mode=indeterminate]{transition:none;animation:none}.mat-progress-spinner.mat-progress-spinner-indeterminate-fallback-animation[mode=indeterminate] circle{transition-property:stroke}._mat-animation-noopable.mat-progress-spinner.mat-progress-spinner-indeterminate-fallback-animation[mode=indeterminate] circle{transition:none;animation:none}@keyframes mat-progress-spinner-linear-rotate{0%{transform:rotate(0)}100%{transform:rotate(360deg)}}@keyframes mat-progress-spinner-stroke-rotate-100{0%{stroke-dashoffset:268.60617px;transform:rotate(0)}12.5%{stroke-dashoffset:56.54867px;transform:rotate(0)}12.5001%{stroke-dashoffset:56.54867px;transform:rotateX(180deg) rotate(72.5deg)}25%{stroke-dashoffset:268.60617px;transform:rotateX(180deg) rotate(72.5deg)}25.0001%{stroke-dashoffset:268.60617px;transform:rotate(270deg)}37.5%{stroke-dashoffset:56.54867px;transform:rotate(270deg)}37.5001%{stroke-dashoffset:56.54867px;transform:rotateX(180deg) rotate(161.5deg)}50%{stroke-dashoffset:268.60617px;transform:rotateX(180deg) rotate(161.5deg)}50.0001%{stroke-dashoffset:268.60617px;transform:rotate(180deg)}62.5%{stroke-dashoffset:56.54867px;transform:rotate(180deg)}62.5001%{stroke-dashoffset:56.54867px;transform:rotateX(180deg) rotate(251.5deg)}75%{stroke-dashoffset:268.60617px;transform:rotateX(180deg) rotate(251.5deg)}75.0001%{stroke-dashoffset:268.60617px;transform:rotate(90deg)}87.5%{stroke-dashoffset:56.54867px;transform:rotate(90deg)}87.5001%{stroke-dashoffset:56.54867px;transform:rotateX(180deg) rotate(341.5deg)}100%{stroke-dashoffset:268.60617px;transform:rotateX(180deg) rotate(341.5deg)}}@keyframes mat-progress-spinner-stroke-rotate-fallback{0%{transform:rotate(0)}25%{transform:rotate(1170deg)}50%{transform:rotate(2340deg)}75%{transform:rotate(3510deg)}100%{transform:rotate(4680deg)}}"],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                },] },
    ];
    /** @nocollapse */
    MatProgressSpinner.ctorParameters = function () { return [
        { type: ElementRef },
        { type: Platform },
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [DOCUMENT,] }] },
        { type: String, decorators: [{ type: Optional }, { type: Inject, args: [ANIMATION_MODULE_TYPE,] }] },
        { type: undefined, decorators: [{ type: Inject, args: [MAT_PROGRESS_SPINNER_DEFAULT_OPTIONS,] }] }
    ]; };
    MatProgressSpinner.propDecorators = {
        diameter: [{ type: Input }],
        strokeWidth: [{ type: Input }],
        mode: [{ type: Input }],
        value: [{ type: Input }]
    };
    /**
     * `<mat-spinner>` component.
     *
     * This is a component definition to be used as a convenience reference to create an
     * indeterminate `<mat-progress-spinner>` instance.
     */
    var MatSpinner = /** @class */ (function (_super) {
        __extends(MatSpinner, _super);
        /**
         * @param {?} elementRef
         * @param {?} platform
         * @param {?} document
         * @param {?} animationMode
         * @param {?=} defaults
         */
        function MatSpinner(elementRef, platform, document, animationMode, defaults) {
            var _this = _super.call(this, elementRef, platform, document, animationMode, defaults) || this;
            _this.mode = 'indeterminate';
            return _this;
        }
        return MatSpinner;
    }(MatProgressSpinner));
    MatSpinner.decorators = [
        { type: Component, args: [{ selector: 'mat-spinner',
                    host: {
                        'role': 'progressbar',
                        'mode': 'indeterminate',
                        'class': 'mat-spinner mat-progress-spinner',
                        '[class._mat-animation-noopable]': "_noopAnimations",
                        '[style.width.px]': 'diameter',
                        '[style.height.px]': 'diameter',
                    },
                    inputs: ['color'],
                    template: "<svg [style.width.px]=\"diameter\" [style.height.px]=\"diameter\" [attr.viewBox]=\"_viewBox\" preserveAspectRatio=\"xMidYMid meet\" focusable=\"false\" [ngSwitch]=\"mode === 'indeterminate'\"><circle *ngSwitchCase=\"true\" cx=\"50%\" cy=\"50%\" [attr.r]=\"_circleRadius\" [style.animation-name]=\"'mat-progress-spinner-stroke-rotate-' + diameter\" [style.stroke-dashoffset.px]=\"_strokeDashOffset\" [style.stroke-dasharray.px]=\"_strokeCircumference\" [style.stroke-width.%]=\"_circleStrokeWidth\"></circle><circle *ngSwitchCase=\"false\" cx=\"50%\" cy=\"50%\" [attr.r]=\"_circleRadius\" [style.stroke-dashoffset.px]=\"_strokeDashOffset\" [style.stroke-dasharray.px]=\"_strokeCircumference\" [style.stroke-width.%]=\"_circleStrokeWidth\"></circle></svg>",
                    styles: [".mat-progress-spinner{display:block;position:relative}.mat-progress-spinner svg{position:absolute;transform:rotate(-90deg);top:0;left:0;transform-origin:center;overflow:visible}.mat-progress-spinner circle{fill:transparent;transform-origin:center;transition:stroke-dashoffset 225ms linear}._mat-animation-noopable.mat-progress-spinner circle{transition:none;animation:none}.mat-progress-spinner.mat-progress-spinner-indeterminate-animation[mode=indeterminate]{animation:mat-progress-spinner-linear-rotate 2s linear infinite}._mat-animation-noopable.mat-progress-spinner.mat-progress-spinner-indeterminate-animation[mode=indeterminate]{transition:none;animation:none}.mat-progress-spinner.mat-progress-spinner-indeterminate-animation[mode=indeterminate] circle{transition-property:stroke;animation-duration:4s;animation-timing-function:cubic-bezier(.35,0,.25,1);animation-iteration-count:infinite}._mat-animation-noopable.mat-progress-spinner.mat-progress-spinner-indeterminate-animation[mode=indeterminate] circle{transition:none;animation:none}.mat-progress-spinner.mat-progress-spinner-indeterminate-fallback-animation[mode=indeterminate]{animation:mat-progress-spinner-stroke-rotate-fallback 10s cubic-bezier(.87,.03,.33,1) infinite}._mat-animation-noopable.mat-progress-spinner.mat-progress-spinner-indeterminate-fallback-animation[mode=indeterminate]{transition:none;animation:none}.mat-progress-spinner.mat-progress-spinner-indeterminate-fallback-animation[mode=indeterminate] circle{transition-property:stroke}._mat-animation-noopable.mat-progress-spinner.mat-progress-spinner-indeterminate-fallback-animation[mode=indeterminate] circle{transition:none;animation:none}@keyframes mat-progress-spinner-linear-rotate{0%{transform:rotate(0)}100%{transform:rotate(360deg)}}@keyframes mat-progress-spinner-stroke-rotate-100{0%{stroke-dashoffset:268.60617px;transform:rotate(0)}12.5%{stroke-dashoffset:56.54867px;transform:rotate(0)}12.5001%{stroke-dashoffset:56.54867px;transform:rotateX(180deg) rotate(72.5deg)}25%{stroke-dashoffset:268.60617px;transform:rotateX(180deg) rotate(72.5deg)}25.0001%{stroke-dashoffset:268.60617px;transform:rotate(270deg)}37.5%{stroke-dashoffset:56.54867px;transform:rotate(270deg)}37.5001%{stroke-dashoffset:56.54867px;transform:rotateX(180deg) rotate(161.5deg)}50%{stroke-dashoffset:268.60617px;transform:rotateX(180deg) rotate(161.5deg)}50.0001%{stroke-dashoffset:268.60617px;transform:rotate(180deg)}62.5%{stroke-dashoffset:56.54867px;transform:rotate(180deg)}62.5001%{stroke-dashoffset:56.54867px;transform:rotateX(180deg) rotate(251.5deg)}75%{stroke-dashoffset:268.60617px;transform:rotateX(180deg) rotate(251.5deg)}75.0001%{stroke-dashoffset:268.60617px;transform:rotate(90deg)}87.5%{stroke-dashoffset:56.54867px;transform:rotate(90deg)}87.5001%{stroke-dashoffset:56.54867px;transform:rotateX(180deg) rotate(341.5deg)}100%{stroke-dashoffset:268.60617px;transform:rotateX(180deg) rotate(341.5deg)}}@keyframes mat-progress-spinner-stroke-rotate-fallback{0%{transform:rotate(0)}25%{transform:rotate(1170deg)}50%{transform:rotate(2340deg)}75%{transform:rotate(3510deg)}100%{transform:rotate(4680deg)}}"],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                },] },
    ];
    /** @nocollapse */
    MatSpinner.ctorParameters = function () { return [
        { type: ElementRef },
        { type: Platform },
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [DOCUMENT,] }] },
        { type: String, decorators: [{ type: Optional }, { type: Inject, args: [ANIMATION_MODULE_TYPE,] }] },
        { type: undefined, decorators: [{ type: Inject, args: [MAT_PROGRESS_SPINNER_DEFAULT_OPTIONS,] }] }
    ]; };
    /**
     * Gets the shadow root of an element, if supported and the element is inside the Shadow DOM.
     * @param {?} element
     * @param {?} _document
     * @return {?}
     */
    function _getShadowRoot(element, _document) {
        // TODO(crisbeto): see whether we should move this into the CDK
        // feature detection utilities once #15616 gets merged in.
        if (typeof window !== 'undefined') {
            /** @type {?} */
            var head = _document.head;
            // Check whether the browser supports Shadow DOM.
            if (head && ((( /** @type {?} */(head))).createShadowRoot || head.attachShadow)) {
                /** @type {?} */
                var rootNode = element.getRootNode ? element.getRootNode() : null;
                // We need to take the `ShadowRoot` off of `window`, because the built-in types are
                // incorrect. See https://github.com/Microsoft/TypeScript/issues/27929.
                if (rootNode instanceof (( /** @type {?} */(window))).ShadowRoot) {
                    return rootNode;
                }
            }
        }
        return null;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatProgressSpinnerModule = /** @class */ (function () {
        function MatProgressSpinnerModule() {
        }
        return MatProgressSpinnerModule;
    }());
    MatProgressSpinnerModule.decorators = [
        { type: NgModule, args: [{
                    imports: [MatCommonModule, CommonModule],
                    exports: [
                        MatProgressSpinner,
                        MatSpinner,
                        MatCommonModule
                    ],
                    declarations: [
                        MatProgressSpinner,
                        MatSpinner
                    ],
                },] },
    ];
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Global registry for all dynamically-created, injected media queries.
     * @type {?}
     */
    var mediaQueriesForWebkitCompatibility = new Set();
    /**
     * Style tag that holds all of the dynamically-created media queries.
     * @type {?}
     */
    var mediaQueryStyleNode;
    /**
     * A utility for calling matchMedia queries.
     */
    var MediaMatcher = /** @class */ (function () {
        /**
         * @param {?} _platform
         */
        function MediaMatcher(_platform) {
            this._platform = _platform;
            this._matchMedia = this._platform.isBrowser && window.matchMedia ?
                // matchMedia is bound to the window scope intentionally as it is an illegal invocation to
                // call it from a different scope.
                window.matchMedia.bind(window) :
                noopMatchMedia;
        }
        /**
         * Evaluates the given media query and returns the native MediaQueryList from which results
         * can be retrieved.
         * Confirms the layout engine will trigger for the selector query provided and returns the
         * MediaQueryList for the query provided.
         * @param {?} query
         * @return {?}
         */
        MediaMatcher.prototype.matchMedia = function (query) {
            if (this._platform.WEBKIT) {
                createEmptyStyleRule(query);
            }
            return this._matchMedia(query);
        };
        return MediaMatcher;
    }());
    MediaMatcher.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] },
    ];
    /** @nocollapse */
    MediaMatcher.ctorParameters = function () { return [
        { type: Platform }
    ]; };
    /** @nocollapse */ MediaMatcher.ngInjectableDef = ɵɵdefineInjectable({ factory: function MediaMatcher_Factory() { return new MediaMatcher(ɵɵinject(Platform)); }, token: MediaMatcher, providedIn: "root" });
    /**
     * For Webkit engines that only trigger the MediaQueryListListener when
     * there is at least one CSS selector for the respective media query.
     * @param {?} query
     * @return {?}
     */
    function createEmptyStyleRule(query) {
        if (mediaQueriesForWebkitCompatibility.has(query)) {
            return;
        }
        try {
            if (!mediaQueryStyleNode) {
                mediaQueryStyleNode = document.createElement('style');
                mediaQueryStyleNode.setAttribute('type', 'text/css');
                ( /** @type {?} */(document.head)).appendChild(mediaQueryStyleNode);
            }
            if (mediaQueryStyleNode.sheet) {
                (( /** @type {?} */(mediaQueryStyleNode.sheet)))
                    .insertRule("@media " + query + " {.fx-query-test{ }}", 0);
                mediaQueriesForWebkitCompatibility.add(query);
            }
        }
        catch (e) {
            console.error(e);
        }
    }
    /**
     * No-op matchMedia replacement for non-browser platforms.
     * @param {?} query
     * @return {?}
     */
    function noopMatchMedia(query) {
        // Use `as any` here to avoid adding additional necessary properties for
        // the noop matcher.
        return ( /** @type {?} */({
            matches: query === 'all' || query === '',
            media: query,
            addListener: ( /**
             * @return {?}
             */function () { }),
            removeListener: ( /**
             * @return {?}
             */function () { })
        }));
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Utility for checking the matching state of \@media queries.
     */
    var BreakpointObserver = /** @class */ (function () {
        /**
         * @param {?} _mediaMatcher
         * @param {?} _zone
         */
        function BreakpointObserver(_mediaMatcher, _zone) {
            this._mediaMatcher = _mediaMatcher;
            this._zone = _zone;
            /**
             * A map of all media queries currently being listened for.
             */
            this._queries = new Map();
            /**
             * A subject for all other observables to takeUntil based on.
             */
            this._destroySubject = new Subject();
        }
        /**
         * Completes the active subject, signalling to all other observables to complete.
         * @return {?}
         */
        BreakpointObserver.prototype.ngOnDestroy = function () {
            this._destroySubject.next();
            this._destroySubject.complete();
        };
        /**
         * Whether one or more media queries match the current viewport size.
         * @param {?} value One or more media queries to check.
         * @return {?} Whether any of the media queries match.
         */
        BreakpointObserver.prototype.isMatched = function (value) {
            var _this = this;
            /** @type {?} */
            var queries = splitQueries(coerceArray(value));
            return queries.some(( /**
             * @param {?} mediaQuery
             * @return {?}
             */function (/**
             * @param {?} mediaQuery
             * @return {?}
             */ mediaQuery) { return _this._registerQuery(mediaQuery).mql.matches; }));
        };
        /**
         * Gets an observable of results for the given queries that will emit new results for any changes
         * in matching of the given queries.
         * @param {?} value One or more media queries to check.
         * @return {?} A stream of matches for the given queries.
         */
        BreakpointObserver.prototype.observe = function (value) {
            var _this = this;
            /** @type {?} */
            var queries = splitQueries(coerceArray(value));
            /** @type {?} */
            var observables = queries.map(( /**
             * @param {?} query
             * @return {?}
             */function (/**
             * @param {?} query
             * @return {?}
             */ query) { return _this._registerQuery(query).observable; }));
            /** @type {?} */
            var stateObservable = combineLatest(observables);
            // Emit the first state immediately, and then debounce the subsequent emissions.
            stateObservable = concat(stateObservable.pipe(take(1)), stateObservable.pipe(skip(1), debounceTime(0)));
            return stateObservable.pipe(map(( /**
             * @param {?} breakpointStates
             * @return {?}
             */function (breakpointStates) {
                /** @type {?} */
                var response = {
                    matches: false,
                    breakpoints: {},
                };
                breakpointStates.forEach(( /**
                 * @param {?} state
                 * @return {?}
                 */function (state) {
                    response.matches = response.matches || state.matches;
                    response.breakpoints[state.query] = state.matches;
                }));
                return response;
            })));
        };
        /**
         * Registers a specific query to be listened for.
         * @private
         * @param {?} query
         * @return {?}
         */
        BreakpointObserver.prototype._registerQuery = function (query) {
            var _this = this;
            // Only set up a new MediaQueryList if it is not already being listened for.
            if (this._queries.has(query)) {
                return ( /** @type {?} */(this._queries.get(query)));
            }
            /** @type {?} */
            var mql = this._mediaMatcher.matchMedia(query);
            // Create callback for match changes and add it is as a listener.
            /** @type {?} */
            var queryObservable = new Observable(( /**
             * @param {?} observer
             * @return {?}
             */function (observer) {
                // Listener callback methods are wrapped to be placed back in ngZone. Callbacks must be placed
                // back into the zone because matchMedia is only included in Zone.js by loading the
                // webapis-media-query.js file alongside the zone.js file.  Additionally, some browsers do not
                // have MediaQueryList inherit from EventTarget, which causes inconsistencies in how Zone.js
                // patches it.
                /** @type {?} */
                var handler = ( /**
                 * @param {?} e
                 * @return {?}
                 */function (e) { return _this._zone.run(( /**
                 * @return {?}
                 */function () { return observer.next(e); })); });
                mql.addListener(handler);
                return ( /**
                 * @return {?}
                 */function () {
                    mql.removeListener(handler);
                });
            })).pipe(startWith(mql), map(( /**
             * @param {?} nextMql
             * @return {?}
             */function (nextMql) { return ({ query: query, matches: nextMql.matches }); })), takeUntil(this._destroySubject));
            // Add the MediaQueryList to the set of queries.
            /** @type {?} */
            var output = { observable: queryObservable, mql: mql };
            this._queries.set(query, output);
            return output;
        };
        return BreakpointObserver;
    }());
    BreakpointObserver.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] },
    ];
    /** @nocollapse */
    BreakpointObserver.ctorParameters = function () { return [
        { type: MediaMatcher },
        { type: NgZone }
    ]; };
    /** @nocollapse */ BreakpointObserver.ngInjectableDef = ɵɵdefineInjectable({ factory: function BreakpointObserver_Factory() { return new BreakpointObserver(ɵɵinject(MediaMatcher), ɵɵinject(NgZone)); }, token: BreakpointObserver, providedIn: "root" });
    /**
     * Split each query string into separate query strings if two queries are provided as comma
     * separated.
     * @param {?} queries
     * @return {?}
     */
    function splitQueries(queries) {
        return queries.map(( /**
         * @param {?} query
         * @return {?}
         */function (query) { return query.split(','); }))
            .reduce(( /**
     * @param {?} a1
     * @param {?} a2
     * @return {?}
     */function (a1, a2) { return a1.concat(a2); }))
            .map(( /**
     * @param {?} query
     * @return {?}
     */function (/**
     * @param {?} query
     * @return {?}
     */ query) { return query.trim(); }));
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // PascalCase is being used as Breakpoints is used like an enum.
    // tslint:disable-next-line:variable-name
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     * @type {?}
     */
    var Breakpoints = {
        XSmall: '(max-width: 599.99px)',
        Small: '(min-width: 600px) and (max-width: 959.99px)',
        Medium: '(min-width: 960px) and (max-width: 1279.99px)',
        Large: '(min-width: 1280px) and (max-width: 1919.99px)',
        XLarge: '(min-width: 1920px)',
        Handset: '(max-width: 599.99px) and (orientation: portrait), ' +
            '(max-width: 959.99px) and (orientation: landscape)',
        Tablet: '(min-width: 600px) and (max-width: 839.99px) and (orientation: portrait), ' +
            '(min-width: 960px) and (max-width: 1279.99px) and (orientation: landscape)',
        Web: '(min-width: 840px) and (orientation: portrait), ' +
            '(min-width: 1280px) and (orientation: landscape)',
        HandsetPortrait: '(max-width: 599.99px) and (orientation: portrait)',
        TabletPortrait: '(min-width: 600px) and (max-width: 839.99px) and (orientation: portrait)',
        WebPortrait: '(min-width: 840px) and (orientation: portrait)',
        HandsetLandscape: '(max-width: 959.99px) and (orientation: landscape)',
        TabletLandscape: '(min-width: 960px) and (max-width: 1279.99px) and (orientation: landscape)',
        WebLandscape: '(min-width: 1280px) and (orientation: landscape)',
    };
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Reference to a snack bar dispatched from the snack bar service.
     * @template T
     */
    var MatSnackBarRef = /** @class */ (function () {
        /**
         * @param {?} containerInstance
         * @param {?} _overlayRef
         */
        function MatSnackBarRef(containerInstance, _overlayRef) {
            var _this = this;
            this._overlayRef = _overlayRef;
            /**
             * Subject for notifying the user that the snack bar has been dismissed.
             */
            this._afterDismissed = new Subject();
            /**
             * Subject for notifying the user that the snack bar has opened and appeared.
             */
            this._afterOpened = new Subject();
            /**
             * Subject for notifying the user that the snack bar action was called.
             */
            this._onAction = new Subject();
            /**
             * Whether the snack bar was dismissed using the action button.
             */
            this._dismissedByAction = false;
            this.containerInstance = containerInstance;
            // Dismiss snackbar on action.
            this.onAction().subscribe(( /**
             * @return {?}
             */function () { return _this.dismiss(); }));
            containerInstance._onExit.subscribe(( /**
             * @return {?}
             */function () { return _this._finishDismiss(); }));
        }
        /**
         * Dismisses the snack bar.
         * @return {?}
         */
        MatSnackBarRef.prototype.dismiss = function () {
            if (!this._afterDismissed.closed) {
                this.containerInstance.exit();
            }
            clearTimeout(this._durationTimeoutId);
        };
        /**
         * Marks the snackbar action clicked.
         * @return {?}
         */
        MatSnackBarRef.prototype.dismissWithAction = function () {
            if (!this._onAction.closed) {
                this._dismissedByAction = true;
                this._onAction.next();
                this._onAction.complete();
            }
        };
        /**
         * Marks the snackbar action clicked.
         * @deprecated Use `dismissWithAction` instead.
         * \@breaking-change 8.0.0
         * @return {?}
         */
        MatSnackBarRef.prototype.closeWithAction = function () {
            this.dismissWithAction();
        };
        /**
         * Dismisses the snack bar after some duration
         * @param {?} duration
         * @return {?}
         */
        MatSnackBarRef.prototype._dismissAfter = function (duration) {
            var _this = this;
            this._durationTimeoutId = setTimeout(( /**
             * @return {?}
             */function () { return _this.dismiss(); }), duration);
        };
        /**
         * Marks the snackbar as opened
         * @return {?}
         */
        MatSnackBarRef.prototype._open = function () {
            if (!this._afterOpened.closed) {
                this._afterOpened.next();
                this._afterOpened.complete();
            }
        };
        /**
         * Cleans up the DOM after closing.
         * @private
         * @return {?}
         */
        MatSnackBarRef.prototype._finishDismiss = function () {
            this._overlayRef.dispose();
            if (!this._onAction.closed) {
                this._onAction.complete();
            }
            this._afterDismissed.next({ dismissedByAction: this._dismissedByAction });
            this._afterDismissed.complete();
            this._dismissedByAction = false;
        };
        /**
         * Gets an observable that is notified when the snack bar is finished closing.
         * @return {?}
         */
        MatSnackBarRef.prototype.afterDismissed = function () {
            return this._afterDismissed.asObservable();
        };
        /**
         * Gets an observable that is notified when the snack bar has opened and appeared.
         * @return {?}
         */
        MatSnackBarRef.prototype.afterOpened = function () {
            return this.containerInstance._onEnter;
        };
        /**
         * Gets an observable that is notified when the snack bar action is called.
         * @return {?}
         */
        MatSnackBarRef.prototype.onAction = function () {
            return this._onAction.asObservable();
        };
        return MatSnackBarRef;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Injection token that can be used to access the data that was passed in to a snack bar.
     * @type {?}
     */
    var MAT_SNACK_BAR_DATA = new InjectionToken('MatSnackBarData');
    /**
     * Configuration used when opening a snack-bar.
     * @template D
     */
    var MatSnackBarConfig = /** @class */ (function () {
        function MatSnackBarConfig() {
            /**
             * The politeness level for the MatAriaLiveAnnouncer announcement.
             */
            this.politeness = 'assertive';
            /**
             * Message to be announced by the LiveAnnouncer. When opening a snackbar without a custom
             * component or template, the announcement message will default to the specified message.
             */
            this.announcementMessage = '';
            /**
             * The length of time in milliseconds to wait before automatically dismissing the snack bar.
             */
            this.duration = 0;
            /**
             * Data being injected into the child component.
             */
            this.data = null;
            /**
             * The horizontal position to place the snack bar.
             */
            this.horizontalPosition = 'center';
            /**
             * The vertical position to place the snack bar.
             */
            this.verticalPosition = 'bottom';
        }
        return MatSnackBarConfig;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A component used to open as the default snack bar, matching material spec.
     * This should only be used internally by the snack bar service.
     */
    var SimpleSnackBar = /** @class */ (function () {
        /**
         * @param {?} snackBarRef
         * @param {?} data
         */
        function SimpleSnackBar(snackBarRef, data) {
            this.snackBarRef = snackBarRef;
            this.data = data;
        }
        /**
         * Performs the action on the snack bar.
         * @return {?}
         */
        SimpleSnackBar.prototype.action = function () {
            this.snackBarRef.dismissWithAction();
        };
        Object.defineProperty(SimpleSnackBar.prototype, "hasAction", {
            /**
             * If the action button should be shown.
             * @return {?}
             */
            get: function () {
                return !!this.data.action;
            },
            enumerable: true,
            configurable: true
        });
        return SimpleSnackBar;
    }());
    SimpleSnackBar.decorators = [
        { type: Component, args: [{ selector: 'simple-snack-bar',
                    template: "<span>{{data.message}}</span><div class=\"mat-simple-snackbar-action\" *ngIf=\"hasAction\"><button mat-button (click)=\"action()\">{{data.action}}</button></div>",
                    styles: [".mat-simple-snackbar{display:flex;justify-content:space-between;align-items:center;line-height:20px;opacity:1}.mat-simple-snackbar-action{flex-shrink:0;margin:-8px -8px -8px 8px}.mat-simple-snackbar-action button{max-height:36px;min-width:0}[dir=rtl] .mat-simple-snackbar-action{margin-left:-8px;margin-right:8px}"],
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    host: {
                        'class': 'mat-simple-snackbar',
                    }
                },] },
    ];
    /** @nocollapse */
    SimpleSnackBar.ctorParameters = function () { return [
        { type: MatSnackBarRef },
        { type: undefined, decorators: [{ type: Inject, args: [MAT_SNACK_BAR_DATA,] }] }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Animations used by the Material snack bar.
     * \@docs-private
     * @type {?}
     */
    var matSnackBarAnimations = {
        /**
         * Animation that shows and hides a snack bar.
         */
        snackBarState: trigger('state', [
            state('void, hidden', style({
                transform: 'scale(0.8)',
                opacity: 0,
            })),
            state('visible', style({
                transform: 'scale(1)',
                opacity: 1,
            })),
            transition('* => visible', animate('150ms cubic-bezier(0, 0, 0.2, 1)')),
            transition('* => void, * => hidden', animate('75ms cubic-bezier(0.4, 0.0, 1, 1)', style({
                opacity: 0
            }))),
        ])
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Internal component that wraps user-provided snack bar content.
     * \@docs-private
     */
    var MatSnackBarContainer = /** @class */ (function (_super) {
        __extends(MatSnackBarContainer, _super);
        /**
         * @param {?} _ngZone
         * @param {?} _elementRef
         * @param {?} _changeDetectorRef
         * @param {?} snackBarConfig
         */
        function MatSnackBarContainer(_ngZone, _elementRef, _changeDetectorRef, snackBarConfig) {
            var _this = _super.call(this) || this;
            _this._ngZone = _ngZone;
            _this._elementRef = _elementRef;
            _this._changeDetectorRef = _changeDetectorRef;
            _this.snackBarConfig = snackBarConfig;
            /**
             * Whether the component has been destroyed.
             */
            _this._destroyed = false;
            /**
             * Subject for notifying that the snack bar has exited from view.
             */
            _this._onExit = new Subject();
            /**
             * Subject for notifying that the snack bar has finished entering the view.
             */
            _this._onEnter = new Subject();
            /**
             * The state of the snack bar animations.
             */
            _this._animationState = 'void';
            // Based on the ARIA spec, `alert` and `status` roles have an
            // implicit `assertive` and `polite` politeness respectively.
            if (snackBarConfig.politeness === 'assertive' && !snackBarConfig.announcementMessage) {
                _this._role = 'alert';
            }
            else if (snackBarConfig.politeness === 'off') {
                _this._role = null;
            }
            else {
                _this._role = 'status';
            }
            return _this;
        }
        /**
         * Attach a component portal as content to this snack bar container.
         * @template T
         * @param {?} portal
         * @return {?}
         */
        MatSnackBarContainer.prototype.attachComponentPortal = function (portal) {
            this._assertNotAttached();
            this._applySnackBarClasses();
            return this._portalOutlet.attachComponentPortal(portal);
        };
        /**
         * Attach a template portal as content to this snack bar container.
         * @template C
         * @param {?} portal
         * @return {?}
         */
        MatSnackBarContainer.prototype.attachTemplatePortal = function (portal) {
            this._assertNotAttached();
            this._applySnackBarClasses();
            return this._portalOutlet.attachTemplatePortal(portal);
        };
        /**
         * Handle end of animations, updating the state of the snackbar.
         * @param {?} event
         * @return {?}
         */
        MatSnackBarContainer.prototype.onAnimationEnd = function (event) {
            var fromState = event.fromState, toState = event.toState;
            if ((toState === 'void' && fromState !== 'void') || toState === 'hidden') {
                this._completeExit();
            }
            if (toState === 'visible') {
                // Note: we shouldn't use `this` inside the zone callback,
                // because it can cause a memory leak.
                /** @type {?} */
                var onEnter_1 = this._onEnter;
                this._ngZone.run(( /**
                 * @return {?}
                 */function () {
                    onEnter_1.next();
                    onEnter_1.complete();
                }));
            }
        };
        /**
         * Begin animation of snack bar entrance into view.
         * @return {?}
         */
        MatSnackBarContainer.prototype.enter = function () {
            if (!this._destroyed) {
                this._animationState = 'visible';
                this._changeDetectorRef.detectChanges();
            }
        };
        /**
         * Begin animation of the snack bar exiting from view.
         * @return {?}
         */
        MatSnackBarContainer.prototype.exit = function () {
            // Note: this one transitions to `hidden`, rather than `void`, in order to handle the case
            // where multiple snack bars are opened in quick succession (e.g. two consecutive calls to
            // `MatSnackBar.open`).
            this._animationState = 'hidden';
            return this._onExit;
        };
        /**
         * Makes sure the exit callbacks have been invoked when the element is destroyed.
         * @return {?}
         */
        MatSnackBarContainer.prototype.ngOnDestroy = function () {
            this._destroyed = true;
            this._completeExit();
        };
        /**
         * Waits for the zone to settle before removing the element. Helps prevent
         * errors where we end up removing an element which is in the middle of an animation.
         * @private
         * @return {?}
         */
        MatSnackBarContainer.prototype._completeExit = function () {
            var _this = this;
            this._ngZone.onMicrotaskEmpty.asObservable().pipe(take(1)).subscribe(( /**
             * @return {?}
             */function () {
                _this._onExit.next();
                _this._onExit.complete();
            }));
        };
        /**
         * Applies the various positioning and user-configured CSS classes to the snack bar.
         * @private
         * @return {?}
         */
        MatSnackBarContainer.prototype._applySnackBarClasses = function () {
            /** @type {?} */
            var element = this._elementRef.nativeElement;
            /** @type {?} */
            var panelClasses = this.snackBarConfig.panelClass;
            if (panelClasses) {
                if (Array.isArray(panelClasses)) {
                    // Note that we can't use a spread here, because IE doesn't support multiple arguments.
                    panelClasses.forEach(( /**
                     * @param {?} cssClass
                     * @return {?}
                     */function (/**
                     * @param {?} cssClass
                     * @return {?}
                     */ cssClass) { return element.classList.add(cssClass); }));
                }
                else {
                    element.classList.add(panelClasses);
                }
            }
            if (this.snackBarConfig.horizontalPosition === 'center') {
                element.classList.add('mat-snack-bar-center');
            }
            if (this.snackBarConfig.verticalPosition === 'top') {
                element.classList.add('mat-snack-bar-top');
            }
        };
        /**
         * Asserts that no content is already attached to the container.
         * @private
         * @return {?}
         */
        MatSnackBarContainer.prototype._assertNotAttached = function () {
            if (this._portalOutlet.hasAttached()) {
                throw Error('Attempting to attach snack bar content after content is already attached');
            }
        };
        return MatSnackBarContainer;
    }(BasePortalOutlet));
    MatSnackBarContainer.decorators = [
        { type: Component, args: [{ selector: 'snack-bar-container',
                    template: "<ng-template cdkPortalOutlet></ng-template>",
                    styles: [".mat-snack-bar-container{border-radius:4px;box-sizing:border-box;display:block;margin:24px;max-width:33vw;min-width:344px;padding:14px 16px;min-height:48px;transform-origin:center}@media (-ms-high-contrast:active){.mat-snack-bar-container{border:solid 1px}}.mat-snack-bar-handset{width:100%}.mat-snack-bar-handset .mat-snack-bar-container{margin:8px;max-width:100%;min-width:0;width:100%}"],
                    // In Ivy embedded views will be change detected from their declaration place, rather than
                    // where they were stamped out. This means that we can't have the snack bar container be OnPush,
                    // because it might cause snack bars that were opened from a template not to be out of date.
                    // tslint:disable-next-line:validate-decorators
                    changeDetection: ChangeDetectionStrategy.Default,
                    encapsulation: ViewEncapsulation.None,
                    animations: [matSnackBarAnimations.snackBarState],
                    host: {
                        '[attr.role]': '_role',
                        'class': 'mat-snack-bar-container',
                        '[@state]': '_animationState',
                        '(@state.done)': 'onAnimationEnd($event)'
                    },
                },] },
    ];
    /** @nocollapse */
    MatSnackBarContainer.ctorParameters = function () { return [
        { type: NgZone },
        { type: ElementRef },
        { type: ChangeDetectorRef },
        { type: MatSnackBarConfig }
    ]; };
    MatSnackBarContainer.propDecorators = {
        _portalOutlet: [{ type: ViewChild, args: [CdkPortalOutlet, { static: true },] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatSnackBarModule = /** @class */ (function () {
        function MatSnackBarModule() {
        }
        return MatSnackBarModule;
    }());
    MatSnackBarModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        OverlayModule,
                        PortalModule,
                        CommonModule,
                        MatButtonModule,
                        MatCommonModule,
                    ],
                    exports: [MatSnackBarContainer, MatCommonModule],
                    declarations: [MatSnackBarContainer, SimpleSnackBar],
                    entryComponents: [MatSnackBarContainer, SimpleSnackBar],
                },] },
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Injection token that can be used to specify default snack bar.
     * @type {?}
     */
    var MAT_SNACK_BAR_DEFAULT_OPTIONS = new InjectionToken('mat-snack-bar-default-options', {
        providedIn: 'root',
        factory: MAT_SNACK_BAR_DEFAULT_OPTIONS_FACTORY,
    });
    /**
     * \@docs-private
     * @return {?}
     */
    function MAT_SNACK_BAR_DEFAULT_OPTIONS_FACTORY() {
        return new MatSnackBarConfig();
    }
    /**
     * Service to dispatch Material Design snack bar messages.
     */
    var MatSnackBar = /** @class */ (function () {
        /**
         * @param {?} _overlay
         * @param {?} _live
         * @param {?} _injector
         * @param {?} _breakpointObserver
         * @param {?} _parentSnackBar
         * @param {?} _defaultConfig
         */
        function MatSnackBar(_overlay, _live, _injector, _breakpointObserver, _parentSnackBar, _defaultConfig) {
            this._overlay = _overlay;
            this._live = _live;
            this._injector = _injector;
            this._breakpointObserver = _breakpointObserver;
            this._parentSnackBar = _parentSnackBar;
            this._defaultConfig = _defaultConfig;
            /**
             * Reference to the current snack bar in the view *at this level* (in the Angular injector tree).
             * If there is a parent snack-bar service, all operations should delegate to that parent
             * via `_openedSnackBarRef`.
             */
            this._snackBarRefAtThisLevel = null;
        }
        Object.defineProperty(MatSnackBar.prototype, "_openedSnackBarRef", {
            /**
             * Reference to the currently opened snackbar at *any* level.
             * @return {?}
             */
            get: function () {
                /** @type {?} */
                var parent = this._parentSnackBar;
                return parent ? parent._openedSnackBarRef : this._snackBarRefAtThisLevel;
            },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                if (this._parentSnackBar) {
                    this._parentSnackBar._openedSnackBarRef = value;
                }
                else {
                    this._snackBarRefAtThisLevel = value;
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Creates and dispatches a snack bar with a custom component for the content, removing any
         * currently opened snack bars.
         *
         * @template T
         * @param {?} component Component to be instantiated.
         * @param {?=} config Extra configuration for the snack bar.
         * @return {?}
         */
        MatSnackBar.prototype.openFromComponent = function (component, config) {
            return ( /** @type {?} */(this._attach(component, config)));
        };
        /**
         * Creates and dispatches a snack bar with a custom template for the content, removing any
         * currently opened snack bars.
         *
         * @param {?} template Template to be instantiated.
         * @param {?=} config Extra configuration for the snack bar.
         * @return {?}
         */
        MatSnackBar.prototype.openFromTemplate = function (template, config) {
            return this._attach(template, config);
        };
        /**
         * Opens a snackbar with a message and an optional action.
         * @param {?} message The message to show in the snackbar.
         * @param {?=} action The label for the snackbar action.
         * @param {?=} config Additional configuration options for the snackbar.
         * @return {?}
         */
        MatSnackBar.prototype.open = function (message, action, config) {
            if (action === void 0) { action = ''; }
            /** @type {?} */
            var _config = Object.assign({}, this._defaultConfig, config);
            // Since the user doesn't have access to the component, we can
            // override the data to pass in our own message and action.
            _config.data = { message: message, action: action };
            if (!_config.announcementMessage) {
                _config.announcementMessage = message;
            }
            return this.openFromComponent(SimpleSnackBar, _config);
        };
        /**
         * Dismisses the currently-visible snack bar.
         * @return {?}
         */
        MatSnackBar.prototype.dismiss = function () {
            if (this._openedSnackBarRef) {
                this._openedSnackBarRef.dismiss();
            }
        };
        /**
         * @return {?}
         */
        MatSnackBar.prototype.ngOnDestroy = function () {
            // Only dismiss the snack bar at the current level on destroy.
            if (this._snackBarRefAtThisLevel) {
                this._snackBarRefAtThisLevel.dismiss();
            }
        };
        /**
         * Attaches the snack bar container component to the overlay.
         * @private
         * @param {?} overlayRef
         * @param {?} config
         * @return {?}
         */
        MatSnackBar.prototype._attachSnackBarContainer = function (overlayRef, config) {
            /** @type {?} */
            var userInjector = config && config.viewContainerRef && config.viewContainerRef.injector;
            /** @type {?} */
            var injector = new PortalInjector(userInjector || this._injector, new WeakMap([
                [MatSnackBarConfig, config]
            ]));
            /** @type {?} */
            var containerPortal = new ComponentPortal(MatSnackBarContainer, config.viewContainerRef, injector);
            /** @type {?} */
            var containerRef = overlayRef.attach(containerPortal);
            containerRef.instance.snackBarConfig = config;
            return containerRef.instance;
        };
        /**
         * Places a new component or a template as the content of the snack bar container.
         * @private
         * @template T
         * @param {?} content
         * @param {?=} userConfig
         * @return {?}
         */
        MatSnackBar.prototype._attach = function (content, userConfig) {
            /** @type {?} */
            var config = Object.assign({}, new MatSnackBarConfig(), this._defaultConfig, userConfig);
            /** @type {?} */
            var overlayRef = this._createOverlay(config);
            /** @type {?} */
            var container = this._attachSnackBarContainer(overlayRef, config);
            /** @type {?} */
            var snackBarRef = new MatSnackBarRef(container, overlayRef);
            if (content instanceof TemplateRef) {
                /** @type {?} */
                var portal = new TemplatePortal(content, ( /** @type {?} */(null)), ( /** @type {?} */({
                    $implicit: config.data,
                    snackBarRef: snackBarRef
                })));
                snackBarRef.instance = container.attachTemplatePortal(portal);
            }
            else {
                /** @type {?} */
                var injector = this._createInjector(config, snackBarRef);
                /** @type {?} */
                var portal = new ComponentPortal(content, undefined, injector);
                /** @type {?} */
                var contentRef = container.attachComponentPortal(portal);
                // We can't pass this via the injector, because the injector is created earlier.
                snackBarRef.instance = contentRef.instance;
            }
            // Subscribe to the breakpoint observer and attach the mat-snack-bar-handset class as
            // appropriate. This class is applied to the overlay element because the overlay must expand to
            // fill the width of the screen for full width snackbars.
            this._breakpointObserver.observe(Breakpoints.HandsetPortrait).pipe(takeUntil(overlayRef.detachments())).subscribe(( /**
             * @param {?} state
             * @return {?}
             */function (/**
             * @param {?} state
             * @return {?}
             */ state$$1) {
                /** @type {?} */
                var classList = overlayRef.overlayElement.classList;
                /** @type {?} */
                var className = 'mat-snack-bar-handset';
                state$$1.matches ? classList.add(className) : classList.remove(className);
            }));
            this._animateSnackBar(snackBarRef, config);
            this._openedSnackBarRef = snackBarRef;
            return this._openedSnackBarRef;
        };
        /**
         * Animates the old snack bar out and the new one in.
         * @private
         * @param {?} snackBarRef
         * @param {?} config
         * @return {?}
         */
        MatSnackBar.prototype._animateSnackBar = function (snackBarRef, config) {
            var _this = this;
            // When the snackbar is dismissed, clear the reference to it.
            snackBarRef.afterDismissed().subscribe(( /**
             * @return {?}
             */function () {
                // Clear the snackbar ref if it hasn't already been replaced by a newer snackbar.
                if (_this._openedSnackBarRef == snackBarRef) {
                    _this._openedSnackBarRef = null;
                }
                if (config.announcementMessage) {
                    _this._live.clear();
                }
            }));
            if (this._openedSnackBarRef) {
                // If a snack bar is already in view, dismiss it and enter the
                // new snack bar after exit animation is complete.
                this._openedSnackBarRef.afterDismissed().subscribe(( /**
                 * @return {?}
                 */function () {
                    snackBarRef.containerInstance.enter();
                }));
                this._openedSnackBarRef.dismiss();
            }
            else {
                // If no snack bar is in view, enter the new snack bar.
                snackBarRef.containerInstance.enter();
            }
            // If a dismiss timeout is provided, set up dismiss based on after the snackbar is opened.
            if (config.duration && config.duration > 0) {
                snackBarRef.afterOpened().subscribe(( /**
                 * @return {?}
                 */function () { return snackBarRef._dismissAfter(( /** @type {?} */(config.duration))); }));
            }
            if (config.announcementMessage) {
                this._live.announce(config.announcementMessage, config.politeness);
            }
        };
        /**
         * Creates a new overlay and places it in the correct location.
         * @private
         * @param {?} config The user-specified snack bar config.
         * @return {?}
         */
        MatSnackBar.prototype._createOverlay = function (config) {
            /** @type {?} */
            var overlayConfig = new OverlayConfig();
            overlayConfig.direction = config.direction;
            /** @type {?} */
            var positionStrategy = this._overlay.position().global();
            // Set horizontal position.
            /** @type {?} */
            var isRtl = config.direction === 'rtl';
            /** @type {?} */
            var isLeft = (config.horizontalPosition === 'left' ||
                (config.horizontalPosition === 'start' && !isRtl) ||
                (config.horizontalPosition === 'end' && isRtl));
            /** @type {?} */
            var isRight = !isLeft && config.horizontalPosition !== 'center';
            if (isLeft) {
                positionStrategy.left('0');
            }
            else if (isRight) {
                positionStrategy.right('0');
            }
            else {
                positionStrategy.centerHorizontally();
            }
            // Set horizontal position.
            if (config.verticalPosition === 'top') {
                positionStrategy.top('0');
            }
            else {
                positionStrategy.bottom('0');
            }
            overlayConfig.positionStrategy = positionStrategy;
            return this._overlay.create(overlayConfig);
        };
        /**
         * Creates an injector to be used inside of a snack bar component.
         * @private
         * @template T
         * @param {?} config Config that was used to create the snack bar.
         * @param {?} snackBarRef Reference to the snack bar.
         * @return {?}
         */
        MatSnackBar.prototype._createInjector = function (config, snackBarRef) {
            /** @type {?} */
            var userInjector = config && config.viewContainerRef && config.viewContainerRef.injector;
            return new PortalInjector(userInjector || this._injector, new WeakMap([
                [MatSnackBarRef, snackBarRef],
                [MAT_SNACK_BAR_DATA, config.data]
            ]));
        };
        return MatSnackBar;
    }());
    MatSnackBar.decorators = [
        { type: Injectable, args: [{ providedIn: MatSnackBarModule },] },
    ];
    /** @nocollapse */
    MatSnackBar.ctorParameters = function () { return [
        { type: Overlay },
        { type: LiveAnnouncer },
        { type: Injector },
        { type: BreakpointObserver },
        { type: MatSnackBar, decorators: [{ type: Optional }, { type: SkipSelf }] },
        { type: MatSnackBarConfig, decorators: [{ type: Inject, args: [MAT_SNACK_BAR_DEFAULT_OPTIONS,] }] }
    ]; };
    /** @nocollapse */ MatSnackBar.ngInjectableDef = ɵɵdefineInjectable({ factory: function MatSnackBar_Factory() { return new MatSnackBar(ɵɵinject(Overlay), ɵɵinject(LiveAnnouncer), ɵɵinject(INJECTOR), ɵɵinject(BreakpointObserver), ɵɵinject(MatSnackBar, 12), ɵɵinject(MAT_SNACK_BAR_DEFAULT_OPTIONS)); }, token: MatSnackBar, providedIn: MatSnackBarModule });
    /**
     * @license NgRx 8.6.0
     * (c) 2015-2018 Brandon Roberts, Mike Ryan, Rob Wormald, Victor Savkin
     * License: MIT
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@description
     * Creates a configured `Creator` function that, when called, returns an object in the shape of the `Action` interface.
     *
     * Action creators reduce the explicitness of class-based action creators.
     *
     * \@usageNotes
     *
     * **Declaring an action creator**
     *
     * Without additional metadata:
     * ```ts
     * export const increment = createAction('[Counter] Increment');
     * ```
     * With additional metadata:
     * ```ts
     * export const loginSuccess = createAction(
     *   '[Auth/API] Login Success',
     *   props<{ user: User }>()
     * );
     * ```
     * With a function:
     * ```ts
     * export const loginSuccess = createAction(
     *   '[Auth/API] Login Success',
     *   (response: Response) => response.user
     * );
     * ```
     *
     * **Dispatching an action**
     *
     * Without additional metadata:
     * ```ts
     * store.dispatch(increment());
     * ```
     * With additional metadata:
     * ```ts
     * store.dispatch(loginSuccess({ user: newUser }));
     * ```
     *
     * **Referencing an action in a reducer**
     *
     * Using a switch statement:
     * ```ts
     * switch (action.type) {
     *   // ...
     *   case AuthApiActions.loginSuccess.type: {
     *     return {
     *       ...state,
     *       user: action.user
     *     };
     *   }
     * }
     * ```
     * Using a reducer creator:
     * ```ts
     * on(AuthApiActions.loginSuccess, (state, { user }) => ({ ...state, user }))
     * ```
     *
     *  **Referencing an action in an effect**
     * ```ts
     * effectName$ = createEffect(
     *   () => this.actions$.pipe(
     *     ofType(AuthApiActions.loginSuccess),
     *     // ...
     *   )
     * );
     * ```
     * @template T, C
     * @param {?} type Describes the action that will be dispatched
     * @param {?=} config Additional metadata needed for the handling of the action.  See {\@link createAction#usage-notes Usage Notes}.
     *
     * @return {?}
     */
    function createAction(type, config) {
        if (typeof config === 'function') {
            return defineType(type, ( /**
             * @param {...?} args
             * @return {?}
             */function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                return (Object.assign({}, config.apply(void 0, __spread(args)), { type: type }));
            }));
        }
        /** @type {?} */
        var as = config ? config._as : 'empty';
        switch (as) {
            case 'empty':
                return defineType(type, ( /**
                 * @return {?}
                 */function () { return ({ type: type }); }));
            case 'props':
                return defineType(type, ( /**
                 * @param {?} props
                 * @return {?}
                 */function (props) { return (Object.assign({}, props, { type: type })); }));
            default:
                throw new Error('Unexpected config.');
        }
    }
    /**
     * @template P
     * @return {?}
     */
    function props() {
        // the return type does not match TypePropertyIsNotAllowed, so double casting
        // is used.
        return ( /** @type {?} */((( /** @type {?} */({ _as: 'props', _p: ( /** @type {?} */(undefined)) })))));
    }
    /**
     * @param {?} type
     * @param {?} creator
     * @return {?}
     */
    function defineType(type, creator) {
        return Object.defineProperty(creator, 'type', {
            value: type,
            writable: false,
        });
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var INIT = ( /** @type {?} */('@ngrx/store/init'));
    var ActionsSubject = /** @class */ (function (_super) {
        __extends(ActionsSubject, _super);
        function ActionsSubject() {
            return _super.call(this, { type: INIT }) || this;
        }
        /**
         * @param {?} action
         * @return {?}
         */
        ActionsSubject.prototype.next = function (action) {
            if (typeof action === 'function') {
                throw new TypeError("\n        Dispatch expected an object, instead it received a function.\n        If you're using the createAction function, make sure to invoke the function\n        before dispatching the action. For example, someAction should be someAction().");
            }
            else if (typeof action === 'undefined') {
                throw new TypeError("Actions must be objects");
            }
            else if (typeof action.type === 'undefined') {
                throw new TypeError("Actions must have a type property");
            }
            _super.prototype.next.call(this, action);
        };
        /**
         * @return {?}
         */
        ActionsSubject.prototype.complete = function () {
            /* noop */
        };
        /**
         * @return {?}
         */
        ActionsSubject.prototype.ngOnDestroy = function () {
            _super.prototype.complete.call(this);
        };
        return ActionsSubject;
    }(BehaviorSubject));
    ActionsSubject.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    ActionsSubject.ctorParameters = function () { return []; };
    /** @type {?} */
    var ACTIONS_SUBJECT_PROVIDERS = [ActionsSubject];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var _ROOT_STORE_GUARD = new InjectionToken('@ngrx/store Internal Root Guard');
    /** @type {?} */
    var _INITIAL_STATE = new InjectionToken('@ngrx/store Internal Initial State');
    /** @type {?} */
    var INITIAL_STATE = new InjectionToken('@ngrx/store Initial State');
    /** @type {?} */
    var REDUCER_FACTORY = new InjectionToken('@ngrx/store Reducer Factory');
    /** @type {?} */
    var _REDUCER_FACTORY = new InjectionToken('@ngrx/store Internal Reducer Factory Provider');
    /** @type {?} */
    var INITIAL_REDUCERS = new InjectionToken('@ngrx/store Initial Reducers');
    /** @type {?} */
    var _INITIAL_REDUCERS = new InjectionToken('@ngrx/store Internal Initial Reducers');
    /** @type {?} */
    var STORE_FEATURES = new InjectionToken('@ngrx/store Store Features');
    /** @type {?} */
    var _STORE_REDUCERS = new InjectionToken('@ngrx/store Internal Store Reducers');
    /** @type {?} */
    var _FEATURE_REDUCERS = new InjectionToken('@ngrx/store Internal Feature Reducers');
    /** @type {?} */
    var _FEATURE_CONFIGS = new InjectionToken('@ngrx/store Internal Feature Configs');
    /** @type {?} */
    var _STORE_FEATURES = new InjectionToken('@ngrx/store Internal Store Features');
    /** @type {?} */
    var _FEATURE_REDUCERS_TOKEN = new InjectionToken('@ngrx/store Internal Feature Reducers Token');
    /** @type {?} */
    var FEATURE_REDUCERS = new InjectionToken('@ngrx/store Feature Reducers');
    /**
     * User-defined meta reducers from StoreModule.forRoot()
     * @type {?}
     */
    var USER_PROVIDED_META_REDUCERS = new InjectionToken('@ngrx/store User Provided Meta Reducers');
    /**
     * Meta reducers defined either internally by \@ngrx/store or by library authors
     * @type {?}
     */
    var META_REDUCERS = new InjectionToken('@ngrx/store Meta Reducers');
    /**
     * Concats the user provided meta reducers and the meta reducers provided on the multi
     * injection token
     * @type {?}
     */
    var _RESOLVED_META_REDUCERS = new InjectionToken('@ngrx/store Internal Resolved Meta Reducers');
    /**
     * Runtime checks defined by the user via an InjectionToken
     * Defaults to `_USER_RUNTIME_CHECKS`
     * @type {?}
     */
    var USER_RUNTIME_CHECKS = new InjectionToken('@ngrx/store User Runtime Checks Config');
    /**
     * Runtime checks defined by the user via forRoot()
     * @type {?}
     */
    var _USER_RUNTIME_CHECKS = new InjectionToken('@ngrx/store Internal User Runtime Checks Config');
    /**
     * Runtime checks currently in use
     * @type {?}
     */
    var _ACTIVE_RUNTIME_CHECKS = new InjectionToken('@ngrx/store Internal Runtime Checks');
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} reducers
     * @param {?=} initialState
     * @return {?}
     */
    function combineReducers(reducers, initialState) {
        if (initialState === void 0) { initialState = {}; }
        /** @type {?} */
        var reducerKeys = Object.keys(reducers);
        /** @type {?} */
        var finalReducers = {};
        for (var i_159 = 0; i_159 < reducerKeys.length; i_159++) {
            /** @type {?} */
            var key = reducerKeys[i_159];
            if (typeof reducers[key] === 'function') {
                finalReducers[key] = reducers[key];
            }
        }
        /** @type {?} */
        var finalReducerKeys = Object.keys(finalReducers);
        return ( /**
         * @param {?} state
         * @param {?} action
         * @return {?}
         */function combination(state, action) {
            state = state === undefined ? initialState : state;
            /** @type {?} */
            var hasChanged = false;
            /** @type {?} */
            var nextState = {};
            for (var i_160 = 0; i_160 < finalReducerKeys.length; i_160++) {
                /** @type {?} */
                var key = finalReducerKeys[i_160];
                /** @type {?} */
                var reducer_1 = finalReducers[key];
                /** @type {?} */
                var previousStateForKey = state[key];
                /** @type {?} */
                var nextStateForKey = reducer_1(previousStateForKey, action);
                nextState[key] = nextStateForKey;
                hasChanged = hasChanged || nextStateForKey !== previousStateForKey;
            }
            return hasChanged ? nextState : state;
        });
    }
    /**
     * @template T
     * @param {?} object
     * @param {?} keyToRemove
     * @return {?}
     */
    function omit(object, keyToRemove) {
        return Object.keys(object)
            .filter(( /**
     * @param {?} key
     * @return {?}
     */function (/**
     * @param {?} key
     * @return {?}
     */ key) { return key !== keyToRemove; }))
            .reduce(( /**
     * @param {?} result
     * @param {?} key
     * @return {?}
     */function (result, key) {
            var _b;
            return Object.assign(result, (_b = {}, _b[key] = object[key], _b));
        }), {});
    }
    /**
     * @param {...?} functions
     * @return {?}
     */
    function compose() {
        var functions = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            functions[_i] = arguments[_i];
        }
        return ( /**
         * @param {?} arg
         * @return {?}
         */function (arg) {
            if (functions.length === 0) {
                return arg;
            }
            /** @type {?} */
            var last = functions[functions.length - 1];
            /** @type {?} */
            var rest = functions.slice(0, -1);
            return rest.reduceRight(( /**
             * @param {?} composed
             * @param {?} fn
             * @return {?}
             */function (composed, fn) { return fn(composed); }), last(arg));
        });
    }
    /**
     * @template T, V
     * @param {?} reducerFactory
     * @param {?=} metaReducers
     * @return {?}
     */
    function createReducerFactory(reducerFactory, metaReducers) {
        if (Array.isArray(metaReducers) && metaReducers.length > 0) {
            (( /** @type {?} */(reducerFactory))) = compose.apply(null, __spread(metaReducers, [
                reducerFactory,
            ]));
        }
        return ( /**
         * @param {?} reducers
         * @param {?=} initialState
         * @return {?}
         */function (reducers, initialState) {
            /** @type {?} */
            var reducer = reducerFactory(reducers);
            return ( /**
             * @param {?} state
             * @param {?} action
             * @return {?}
             */function (state, action) {
                state = state === undefined ? (( /** @type {?} */(initialState))) : state;
                return reducer(state, action);
            });
        });
    }
    /**
     * @template T, V
     * @param {?=} metaReducers
     * @return {?}
     */
    function createFeatureReducerFactory(metaReducers) {
        /** @type {?} */
        var reducerFactory = Array.isArray(metaReducers) && metaReducers.length > 0
            ? compose.apply(void 0, __spread(metaReducers)) : ( /**
         * @param {?} r
         * @return {?}
         */function (r) { return r; });
        return ( /**
         * @param {?} reducer
         * @param {?=} initialState
         * @return {?}
         */function (reducer, initialState) {
            reducer = reducerFactory(reducer);
            return ( /**
             * @param {?} state
             * @param {?} action
             * @return {?}
             */function (state, action) {
                state = state === undefined ? initialState : state;
                return reducer(state, action);
            });
        });
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     */
    var ReducerObservable = /** @class */ (function (_super) {
        __extends(ReducerObservable, _super);
        function ReducerObservable() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return ReducerObservable;
    }(Observable));
    /**
     * @abstract
     */
    var ReducerManagerDispatcher = /** @class */ (function (_super) {
        __extends(ReducerManagerDispatcher, _super);
        function ReducerManagerDispatcher() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return ReducerManagerDispatcher;
    }(ActionsSubject));
    /** @type {?} */
    var UPDATE = ( /** @type {?} */('@ngrx/store/update-reducers'));
    var ReducerManager = /** @class */ (function (_super) {
        __extends(ReducerManager, _super);
        /**
         * @param {?} dispatcher
         * @param {?} initialState
         * @param {?} reducers
         * @param {?} reducerFactory
         */
        function ReducerManager(dispatcher, initialState, reducers, reducerFactory) {
            var _this = _super.call(this, reducerFactory(reducers, initialState)) || this;
            _this.dispatcher = dispatcher;
            _this.initialState = initialState;
            _this.reducers = reducers;
            _this.reducerFactory = reducerFactory;
            return _this;
        }
        /**
         * @param {?} feature
         * @return {?}
         */
        ReducerManager.prototype.addFeature = function (feature) {
            this.addFeatures([feature]);
        };
        /**
         * @param {?} features
         * @return {?}
         */
        ReducerManager.prototype.addFeatures = function (features) {
            /** @type {?} */
            var reducers = features.reduce(( /**
             * @param {?} reducerDict
             * @param {?} __1
             * @return {?}
             */function (reducerDict, _b) {
                var reducers = _b.reducers, reducerFactory = _b.reducerFactory, metaReducers = _b.metaReducers, initialState = _b.initialState, key = _b.key;
                /** @type {?} */
                var reducer = typeof reducers === 'function'
                    ? createFeatureReducerFactory(metaReducers)(reducers, initialState)
                    : createReducerFactory(reducerFactory, metaReducers)(reducers, initialState);
                reducerDict[key] = reducer;
                return reducerDict;
            }), ( /** @type {?} */({})));
            this.addReducers(reducers);
        };
        /**
         * @param {?} feature
         * @return {?}
         */
        ReducerManager.prototype.removeFeature = function (feature) {
            this.removeFeatures([feature]);
        };
        /**
         * @param {?} features
         * @return {?}
         */
        ReducerManager.prototype.removeFeatures = function (features) {
            this.removeReducers(features.map(( /**
             * @param {?} p
             * @return {?}
             */function (/**
             * @param {?} p
             * @return {?}
             */ p) { return p.key; })));
        };
        /**
         * @param {?} key
         * @param {?} reducer
         * @return {?}
         */
        ReducerManager.prototype.addReducer = function (key, reducer) {
            var _b;
            this.addReducers((_b = {}, _b[key] = reducer, _b));
        };
        /**
         * @param {?} reducers
         * @return {?}
         */
        ReducerManager.prototype.addReducers = function (reducers) {
            this.reducers = Object.assign({}, this.reducers, reducers);
            this.updateReducers(Object.keys(reducers));
        };
        /**
         * @param {?} featureKey
         * @return {?}
         */
        ReducerManager.prototype.removeReducer = function (featureKey) {
            this.removeReducers([featureKey]);
        };
        /**
         * @param {?} featureKeys
         * @return {?}
         */
        ReducerManager.prototype.removeReducers = function (featureKeys) {
            var _this = this;
            featureKeys.forEach(( /**
             * @param {?} key
             * @return {?}
             */function (/**
             * @param {?} key
             * @return {?}
             */ key) {
                _this.reducers = ( /** @type {?} */(omit(_this.reducers, key) /*TODO(#823)*/));
            }));
            this.updateReducers(featureKeys);
        };
        /**
         * @private
         * @param {?} featureKeys
         * @return {?}
         */
        ReducerManager.prototype.updateReducers = function (featureKeys) {
            this.next(this.reducerFactory(this.reducers, this.initialState));
            this.dispatcher.next(( /** @type {?} */({
                type: UPDATE,
                features: featureKeys,
            })));
        };
        /**
         * @return {?}
         */
        ReducerManager.prototype.ngOnDestroy = function () {
            this.complete();
        };
        return ReducerManager;
    }(BehaviorSubject));
    ReducerManager.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    ReducerManager.ctorParameters = function () { return [
        { type: ReducerManagerDispatcher },
        { type: undefined, decorators: [{ type: Inject, args: [INITIAL_STATE,] }] },
        { type: undefined, decorators: [{ type: Inject, args: [INITIAL_REDUCERS,] }] },
        { type: undefined, decorators: [{ type: Inject, args: [REDUCER_FACTORY,] }] }
    ]; };
    /** @type {?} */
    var REDUCER_MANAGER_PROVIDERS = [
        ReducerManager,
        { provide: ReducerObservable, useExisting: ReducerManager },
        { provide: ReducerManagerDispatcher, useExisting: ActionsSubject },
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ScannedActionsSubject = /** @class */ (function (_super) {
        __extends(ScannedActionsSubject, _super);
        function ScannedActionsSubject() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @return {?}
         */
        ScannedActionsSubject.prototype.ngOnDestroy = function () {
            this.complete();
        };
        return ScannedActionsSubject;
    }(Subject));
    ScannedActionsSubject.decorators = [
        { type: Injectable }
    ];
    /** @type {?} */
    var SCANNED_ACTIONS_SUBJECT_PROVIDERS = [
        ScannedActionsSubject,
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     */
    var StateObservable = /** @class */ (function (_super) {
        __extends(StateObservable, _super);
        function StateObservable() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return StateObservable;
    }(Observable));
    /**
     * @template T
     */
    var State = /** @class */ (function (_super) {
        __extends(State, _super);
        /**
         * @param {?} actions$
         * @param {?} reducer$
         * @param {?} scannedActions
         * @param {?} initialState
         */
        function State(actions$, reducer$, scannedActions, initialState) {
            var _this = _super.call(this, initialState) || this;
            /** @type {?} */
            var actionsOnQueue$ = actions$.pipe(observeOn(queue));
            /** @type {?} */
            var withLatestReducer$ = actionsOnQueue$.pipe(withLatestFrom(reducer$));
            /** @type {?} */
            var seed = { state: initialState };
            /** @type {?} */
            var stateAndAction$ = withLatestReducer$.pipe(scan(reduceState, seed));
            _this.stateSubscription = stateAndAction$.subscribe(( /**
             * @param {?} __0
             * @return {?}
             */function (_b) {
                var state = _b.state, action = _b.action;
                _this.next(state);
                scannedActions.next(action);
            }));
            return _this;
        }
        /**
         * @return {?}
         */
        State.prototype.ngOnDestroy = function () {
            this.stateSubscription.unsubscribe();
            this.complete();
        };
        return State;
    }(BehaviorSubject));
    State.INIT = INIT;
    State.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    State.ctorParameters = function () { return [
        { type: ActionsSubject },
        { type: ReducerObservable },
        { type: ScannedActionsSubject },
        { type: undefined, decorators: [{ type: Inject, args: [INITIAL_STATE,] }] }
    ]; };
    /**
     * @template T, V
     * @param {?=} stateActionPair
     * @param {?=} __1
     * @return {?}
     */
    function reduceState(stateActionPair, _b) {
        if (stateActionPair === void 0) { stateActionPair = { state: undefined }; }
        var _c = __read(_b, 2), action = _c[0], reducer = _c[1];
        var state = stateActionPair.state;
        return { state: reducer(state, action), action: action };
    }
    /** @type {?} */
    var STATE_PROVIDERS = [
        State,
        { provide: StateObservable, useExisting: State },
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var Store = /** @class */ (function (_super) {
        __extends(Store, _super);
        /**
         * @param {?} state$
         * @param {?} actionsObserver
         * @param {?} reducerManager
         */
        function Store(state$, actionsObserver, reducerManager) {
            var _this = _super.call(this) || this;
            _this.actionsObserver = actionsObserver;
            _this.reducerManager = reducerManager;
            _this.source = state$;
            return _this;
        }
        /**
         * @template Props, K
         * @param {?} pathOrMapFn
         * @param {...?} paths
         * @return {?}
         */
        Store.prototype.select = function (pathOrMapFn) {
            var paths = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                paths[_i - 1] = arguments[_i];
            }
            return (( /** @type {?} */(select))).call.apply((( /** @type {?} */(select))), __spread([null, pathOrMapFn], paths))(this);
        };
        /**
         * @template R
         * @param {?} operator
         * @return {?}
         */
        Store.prototype.lift = function (operator) {
            /** @type {?} */
            var store = new Store(this, this.actionsObserver, this.reducerManager);
            store.operator = operator;
            return store;
        };
        /**
         * @template V
         * @param {?} action
         * @return {?}
         */
        Store.prototype.dispatch = function (action) {
            this.actionsObserver.next(action);
        };
        /**
         * @param {?} action
         * @return {?}
         */
        Store.prototype.next = function (action) {
            this.actionsObserver.next(action);
        };
        /**
         * @param {?} err
         * @return {?}
         */
        Store.prototype.error = function (err) {
            this.actionsObserver.error(err);
        };
        /**
         * @return {?}
         */
        Store.prototype.complete = function () {
            this.actionsObserver.complete();
        };
        /**
         * @template State, Actions
         * @param {?} key
         * @param {?} reducer
         * @return {?}
         */
        Store.prototype.addReducer = function (key, reducer) {
            this.reducerManager.addReducer(key, reducer);
        };
        /**
         * @template Key
         * @param {?} key
         * @return {?}
         */
        Store.prototype.removeReducer = function (key) {
            this.reducerManager.removeReducer(key);
        };
        return Store;
    }(Observable));
    Store.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    Store.ctorParameters = function () { return [
        { type: StateObservable },
        { type: ActionsSubject },
        { type: ReducerManager }
    ]; };
    /** @type {?} */
    var STORE_PROVIDERS = [Store];
    /**
     * @template T, Props, K
     * @param {?} pathOrMapFn
     * @param {?=} propsOrPath
     * @param {...?} paths
     * @return {?}
     */
    function select(pathOrMapFn, propsOrPath) {
        var paths = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            paths[_i - 2] = arguments[_i];
        }
        return ( /**
         * @param {?} source$
         * @return {?}
         */function selectOperator(source$) {
            /** @type {?} */
            var mapped$;
            if (typeof pathOrMapFn === 'string') {
                /** @type {?} */
                var pathSlices = __spread([( /** @type {?} */(propsOrPath))], paths).filter(Boolean);
                mapped$ = source$.pipe(pluck.apply(void 0, __spread([pathOrMapFn], pathSlices)));
            }
            else if (typeof pathOrMapFn === 'function') {
                mapped$ = source$.pipe(map(( /**
                 * @param {?} source
                 * @return {?}
                 */function (/**
                 * @param {?} source
                 * @return {?}
                 */ source) { return pathOrMapFn(source, ( /** @type {?} */(propsOrPath))); })));
            }
            else {
                throw new TypeError("Unexpected type '" + typeof pathOrMapFn + "' in select operator," +
                    " expected 'string' or 'function'");
            }
            return mapped$.pipe(distinctUntilChanged());
        });
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} a
     * @param {?} b
     * @return {?}
     */
    function isEqualCheck(a, b) {
        return a === b;
    }
    /**
     * @param {?} args
     * @param {?} lastArguments
     * @param {?} comparator
     * @return {?}
     */
    function isArgumentsChanged(args, lastArguments, comparator) {
        for (var i_161 = 0; i_161 < args.length; i_161++) {
            if (!comparator(args[i_161], lastArguments[i_161])) {
                return true;
            }
        }
        return false;
    }
    /**
     * @param {?} projectionFn
     * @param {?=} isArgumentsEqual
     * @param {?=} isResultEqual
     * @return {?}
     */
    function defaultMemoize(projectionFn, isArgumentsEqual, isResultEqual) {
        if (isArgumentsEqual === void 0) { isArgumentsEqual = isEqualCheck; }
        if (isResultEqual === void 0) { isResultEqual = isEqualCheck; }
        /** @type {?} */
        var lastArguments = null;
        // tslint:disable-next-line:no-any anything could be the result.
        /** @type {?} */
        var lastResult = null;
        /** @type {?} */
        var overrideResult;
        /**
         * @return {?}
         */
        function reset() {
            lastArguments = null;
            lastResult = null;
        }
        /**
         * @param {?=} result
         * @return {?}
         */
        function setResult(result) {
            if (result === void 0) { result = undefined; }
            overrideResult = result;
        }
        // tslint:disable-next-line:no-any anything could be the result.
        /**
         * @return {?}
         */
        function memoized() {
            if (overrideResult !== undefined) {
                return overrideResult;
            }
            if (!lastArguments) {
                lastResult = projectionFn.apply(null, ( /** @type {?} */(arguments)));
                lastArguments = arguments;
                return lastResult;
            }
            if (!isArgumentsChanged(arguments, lastArguments, isArgumentsEqual)) {
                return lastResult;
            }
            /** @type {?} */
            var newResult = projectionFn.apply(null, ( /** @type {?} */(arguments)));
            lastArguments = arguments;
            if (isResultEqual(lastResult, newResult)) {
                return lastResult;
            }
            lastResult = newResult;
            return newResult;
        }
        return { memoized: memoized, reset: reset, setResult: setResult };
    }
    /**
     * @param {...?} input
     * @return {?}
     */
    function createSelector() {
        var input = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            input[_i] = arguments[_i];
        }
        return createSelectorFactory(defaultMemoize).apply(void 0, __spread(input));
    }
    /**
     * @param {?} state
     * @param {?} selectors
     * @param {?} props
     * @param {?} memoizedProjector
     * @return {?}
     */
    function defaultStateFn(state, selectors, props, memoizedProjector) {
        if (props === undefined) {
            /** @type {?} */
            var args_1 = (( /** @type {?} */(selectors))).map(( /**
             * @param {?} fn
             * @return {?}
             */function (/**
             * @param {?} fn
             * @return {?}
             */ fn) { return fn(state); }));
            return memoizedProjector.memoized.apply(null, args_1);
        }
        /** @type {?} */
        var args = (( /** @type {?} */(selectors))).map(( /**
         * @param {?} fn
         * @return {?}
         */function (/**
         * @param {?} fn
         * @return {?}
         */ fn) { return fn(state, props); }));
        return memoizedProjector.memoized.apply(null, __spread(args, [props]));
    }
    /**
     * @param {?} memoize
     * @param {?=} options
     * @return {?}
     */
    function createSelectorFactory(memoize, options) {
        if (options === void 0) { options = {
            stateFn: defaultStateFn,
        }; }
        return ( /**
         * @param {...?} input
         * @return {?}
         */function () {
            var input = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                input[_i] = arguments[_i];
            }
            /** @type {?} */
            var args = input;
            if (Array.isArray(args[0])) {
                var _b = __read(args), head = _b[0], tail = _b.slice(1);
                args = __spread(head, tail);
            }
            /** @type {?} */
            var selectors = args.slice(0, args.length - 1);
            /** @type {?} */
            var projector = args[args.length - 1];
            /** @type {?} */
            var memoizedSelectors = selectors.filter(( /**
             * @param {?} selector
             * @return {?}
             */function (selector) { return selector.release && typeof selector.release === 'function'; }));
            /** @type {?} */
            var memoizedProjector = memoize(( /**
             * @param {...?} selectors
             * @return {?}
             */function () {
                var selectors = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    selectors[_i] = arguments[_i];
                }
                return projector.apply(null, selectors);
            }));
            /** @type {?} */
            var memoizedState = defaultMemoize(( /**
             * @param {?} state
             * @param {?} props
             * @return {?}
             */function (state, props) {
                return options.stateFn.apply(null, [
                    state,
                    selectors,
                    props,
                    memoizedProjector,
                ]);
            }));
            /**
             * @return {?}
             */
            function release() {
                memoizedState.reset();
                memoizedProjector.reset();
                memoizedSelectors.forEach(( /**
                 * @param {?} selector
                 * @return {?}
                 */function (/**
                 * @param {?} selector
                 * @return {?}
                 */ selector) { return selector.release(); }));
            }
            return Object.assign(memoizedState.memoized, {
                release: release,
                projector: memoizedProjector.memoized,
                setResult: memoizedState.setResult,
            });
        });
    }
    /**
     * @param {?} featureName
     * @return {?}
     */
    function createFeatureSelector(featureName) {
        return createSelector(( /**
         * @param {?} state
         * @return {?}
         */function (state) {
            /** @type {?} */
            var featureState = state[featureName];
            if (isDevMode() && !(featureName in state)) {
                console.warn("@ngrx/store: The feature name \"" + featureName + "\" does " +
                    'not exist in the state, therefore createFeatureSelector ' +
                    'cannot access it.  Be sure it is imported in a loaded module ' +
                    ("using StoreModule.forRoot('" + featureName + "', ...) or ") +
                    ("StoreModule.forFeature('" + featureName + "', ...).  If the default ") +
                    'state is intended to be undefined, as is the case with router ' +
                    'state, this development-only warning message can be ignored.');
            }
            return featureState;
        }), ( /**
         * @param {?} featureState
         * @return {?}
         */function (featureState) { return featureState; }));
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} target
     * @return {?}
     */
    function isUndefined(target) {
        return target === undefined;
    }
    /**
     * @param {?} target
     * @return {?}
     */
    function isNull(target) {
        return target === null;
    }
    /**
     * @param {?} target
     * @return {?}
     */
    function isArray$1(target) {
        return Array.isArray(target);
    }
    /**
     * @param {?} target
     * @return {?}
     */
    function isString(target) {
        return typeof target === 'string';
    }
    /**
     * @param {?} target
     * @return {?}
     */
    function isBoolean(target) {
        return typeof target === 'boolean';
    }
    /**
     * @param {?} target
     * @return {?}
     */
    function isNumber(target) {
        return typeof target === 'number';
    }
    /**
     * @param {?} target
     * @return {?}
     */
    function isObjectLike(target) {
        return typeof target === 'object' && target !== null;
    }
    /**
     * @param {?} target
     * @return {?}
     */
    function isObject$2(target) {
        return isObjectLike(target) && !isArray$1(target);
    }
    /**
     * @param {?} target
     * @return {?}
     */
    function isPlainObject(target) {
        if (!isObject$2(target)) {
            return false;
        }
        /** @type {?} */
        var targetPrototype = Object.getPrototypeOf(target);
        return targetPrototype === Object.prototype || targetPrototype === null;
    }
    /**
     * @param {?} target
     * @return {?}
     */
    function isFunction$1(target) {
        return typeof target === 'function';
    }
    /**
     * @param {?} target
     * @param {?} propertyName
     * @return {?}
     */
    function hasOwnProperty(target, propertyName) {
        return Object.prototype.hasOwnProperty.call(target, propertyName);
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} reducer
     * @param {?} checks
     * @return {?}
     */
    function immutabilityCheckMetaReducer(reducer, checks) {
        return ( /**
         * @param {?} state
         * @param {?} action
         * @return {?}
         */function (state, action) {
            /** @type {?} */
            var act = checks.action ? freeze(action) : action;
            /** @type {?} */
            var nextState = reducer(state, act);
            return checks.state ? freeze(nextState) : nextState;
        });
    }
    /**
     * @param {?} target
     * @return {?}
     */
    function freeze(target) {
        Object.freeze(target);
        /** @type {?} */
        var targetIsFunction = isFunction$1(target);
        Object.getOwnPropertyNames(target).forEach(( /**
         * @param {?} prop
         * @return {?}
         */function (/**
         * @param {?} prop
         * @return {?}
         */ prop) {
            if (hasOwnProperty(target, prop) &&
                (targetIsFunction
                    ? prop !== 'caller' && prop !== 'callee' && prop !== 'arguments'
                    : true)) {
                /** @type {?} */
                var propValue = target[prop];
                if ((isObjectLike(propValue) || isFunction$1(propValue)) &&
                    !Object.isFrozen(propValue)) {
                    freeze(propValue);
                }
            }
        }));
        return target;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} reducer
     * @param {?} checks
     * @return {?}
     */
    function serializationCheckMetaReducer(reducer, checks) {
        return ( /**
         * @param {?} state
         * @param {?} action
         * @return {?}
         */function (state, action) {
            if (checks.action) {
                /** @type {?} */
                var unserializableAction = getUnserializable(action);
                throwIfUnserializable(unserializableAction, 'action');
            }
            /** @type {?} */
            var nextState = reducer(state, action);
            if (checks.state) {
                /** @type {?} */
                var unserializableState = getUnserializable(nextState);
                throwIfUnserializable(unserializableState, 'state');
            }
            return nextState;
        });
    }
    /**
     * @param {?=} target
     * @param {?=} path
     * @return {?}
     */
    function getUnserializable(target, path) {
        if (path === void 0) { path = []; }
        // Guard against undefined and null, e.g. a reducer that returns undefined
        if ((isUndefined(target) || isNull(target)) && path.length === 0) {
            return {
                path: ['root'],
                value: target,
            };
        }
        /** @type {?} */
        var keys = Object.keys(target);
        return keys.reduce(( /**
         * @param {?} result
         * @param {?} key
         * @return {?}
         */function (result, key) {
            if (result) {
                return result;
            }
            /** @type {?} */
            var value = (( /** @type {?} */(target)))[key];
            if (isUndefined(value) ||
                isNull(value) ||
                isNumber(value) ||
                isBoolean(value) ||
                isString(value) ||
                isArray$1(value)) {
                return false;
            }
            if (isPlainObject(value)) {
                return getUnserializable(value, __spread(path, [key]));
            }
            return {
                path: __spread(path, [key]),
                value: value,
            };
        }), false);
    }
    /**
     * @param {?} unserializable
     * @param {?} context
     * @return {?}
     */
    function throwIfUnserializable(unserializable, context) {
        if (unserializable === false) {
            return;
        }
        /** @type {?} */
        var unserializablePath = unserializable.path.join('.');
        /** @type {?} */
        var error = new Error("Detected unserializable " + context + " at \"" + unserializablePath + "\"");
        error.value = unserializable.value;
        error.unserializablePath = unserializablePath;
        throw error;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?=} runtimeChecks
     * @return {?}
     */
    function createActiveRuntimeChecks(runtimeChecks) {
        if (isDevMode()) {
            if (runtimeChecks === undefined) {
                console.warn('@ngrx/store: runtime checks are currently opt-in but will be the default in the next major version with the possibility to opt-out, see https://ngrx.io/guide/migration/v8 for more information.');
            }
            return Object.assign({ strictStateSerializability: false, strictActionSerializability: false, strictStateImmutability: false, strictActionImmutability: false }, runtimeChecks);
        }
        return {
            strictStateSerializability: false,
            strictActionSerializability: false,
            strictStateImmutability: false,
            strictActionImmutability: false,
        };
    }
    /**
     * @param {?} __0
     * @return {?}
     */
    function createSerializationCheckMetaReducer(_b) {
        var strictActionSerializability = _b.strictActionSerializability, strictStateSerializability = _b.strictStateSerializability;
        return ( /**
         * @param {?} reducer
         * @return {?}
         */function (/**
         * @param {?} reducer
         * @return {?}
         */ reducer) { return strictActionSerializability || strictStateSerializability
            ? serializationCheckMetaReducer(reducer, {
                action: strictActionSerializability,
                state: strictStateSerializability,
            })
            : reducer; });
    }
    /**
     * @param {?} __0
     * @return {?}
     */
    function createImmutabilityCheckMetaReducer(_b) {
        var strictActionImmutability = _b.strictActionImmutability, strictStateImmutability = _b.strictStateImmutability;
        return ( /**
         * @param {?} reducer
         * @return {?}
         */function (/**
         * @param {?} reducer
         * @return {?}
         */ reducer) { return strictActionImmutability || strictStateImmutability
            ? immutabilityCheckMetaReducer(reducer, {
                action: strictActionImmutability,
                state: strictStateImmutability,
            })
            : reducer; });
    }
    /**
     * @param {?=} runtimeChecks
     * @return {?}
     */
    function provideRuntimeChecks(runtimeChecks) {
        return [
            {
                provide: _USER_RUNTIME_CHECKS,
                useValue: runtimeChecks,
            },
            {
                provide: USER_RUNTIME_CHECKS,
                useFactory: _runtimeChecksFactory,
                deps: [_USER_RUNTIME_CHECKS],
            },
            {
                provide: _ACTIVE_RUNTIME_CHECKS,
                deps: [USER_RUNTIME_CHECKS],
                useFactory: createActiveRuntimeChecks,
            },
            {
                provide: META_REDUCERS,
                multi: true,
                deps: [_ACTIVE_RUNTIME_CHECKS],
                useFactory: createImmutabilityCheckMetaReducer,
            },
            {
                provide: META_REDUCERS,
                multi: true,
                deps: [_ACTIVE_RUNTIME_CHECKS],
                useFactory: createSerializationCheckMetaReducer,
            },
        ];
    }
    /**
     * @param {?} runtimeChecks
     * @return {?}
     */
    function _runtimeChecksFactory(runtimeChecks) {
        return runtimeChecks;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var StoreRootModule = /** @class */ (function () {
        /**
         * @param {?} actions$
         * @param {?} reducer$
         * @param {?} scannedActions$
         * @param {?} store
         * @param {?} guard
         */
        function StoreRootModule(actions$, reducer$, scannedActions$, store, guard) {
        }
        return StoreRootModule;
    }());
    StoreRootModule.decorators = [
        { type: NgModule, args: [{},] }
    ];
    /** @nocollapse */
    StoreRootModule.ctorParameters = function () { return [
        { type: ActionsSubject },
        { type: ReducerObservable },
        { type: ScannedActionsSubject },
        { type: Store },
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [_ROOT_STORE_GUARD,] }] }
    ]; };
    var StoreFeatureModule = /** @class */ (function () {
        /**
         * @param {?} features
         * @param {?} featureReducers
         * @param {?} reducerManager
         * @param {?} root
         */
        function StoreFeatureModule(features, featureReducers, reducerManager, root) {
            this.features = features;
            this.featureReducers = featureReducers;
            this.reducerManager = reducerManager;
            /** @type {?} */
            var feats = features.map(( /**
             * @param {?} feature
             * @param {?} index
             * @return {?}
             */function (feature, index) {
                /** @type {?} */
                var featureReducerCollection = featureReducers.shift();
                /** @type {?} */
                var reducers = ( /** @type {?} */(featureReducerCollection /*TODO(#823)*/))[index];
                return Object.assign({}, feature, { reducers: reducers, initialState: _initialStateFactory(feature.initialState) });
            }));
            reducerManager.addFeatures(feats);
        }
        /**
         * @return {?}
         */
        StoreFeatureModule.prototype.ngOnDestroy = function () {
            this.reducerManager.removeFeatures(this.features);
        };
        return StoreFeatureModule;
    }());
    StoreFeatureModule.decorators = [
        { type: NgModule, args: [{},] }
    ];
    /** @nocollapse */
    StoreFeatureModule.ctorParameters = function () { return [
        { type: Array, decorators: [{ type: Inject, args: [_STORE_FEATURES,] }] },
        { type: Array, decorators: [{ type: Inject, args: [FEATURE_REDUCERS,] }] },
        { type: ReducerManager },
        { type: StoreRootModule }
    ]; };
    var StoreModule = /** @class */ (function () {
        function StoreModule() {
        }
        /**
         * @param {?} reducers
         * @param {?=} config
         * @return {?}
         */
        StoreModule.forRoot = function (reducers, config) {
            if (config === void 0) { config = {}; }
            return {
                ngModule: StoreRootModule,
                providers: [
                    {
                        provide: _ROOT_STORE_GUARD,
                        useFactory: _provideForRootGuard,
                        deps: [[Store, new Optional(), new SkipSelf()]],
                    },
                    { provide: _INITIAL_STATE, useValue: config.initialState },
                    {
                        provide: INITIAL_STATE,
                        useFactory: _initialStateFactory,
                        deps: [_INITIAL_STATE],
                    },
                    { provide: _INITIAL_REDUCERS, useValue: reducers },
                    {
                        provide: _STORE_REDUCERS,
                        useExisting: reducers instanceof InjectionToken ? reducers : _INITIAL_REDUCERS,
                    },
                    {
                        provide: INITIAL_REDUCERS,
                        deps: [Injector, _INITIAL_REDUCERS, [new Inject(_STORE_REDUCERS)]],
                        useFactory: _createStoreReducers,
                    },
                    {
                        provide: USER_PROVIDED_META_REDUCERS,
                        useValue: config.metaReducers ? config.metaReducers : [],
                    },
                    {
                        provide: _RESOLVED_META_REDUCERS,
                        deps: [META_REDUCERS, USER_PROVIDED_META_REDUCERS],
                        useFactory: _concatMetaReducers,
                    },
                    {
                        provide: _REDUCER_FACTORY,
                        useValue: config.reducerFactory
                            ? config.reducerFactory
                            : combineReducers,
                    },
                    {
                        provide: REDUCER_FACTORY,
                        deps: [_REDUCER_FACTORY, _RESOLVED_META_REDUCERS],
                        useFactory: createReducerFactory,
                    },
                    ACTIONS_SUBJECT_PROVIDERS,
                    REDUCER_MANAGER_PROVIDERS,
                    SCANNED_ACTIONS_SUBJECT_PROVIDERS,
                    STATE_PROVIDERS,
                    STORE_PROVIDERS,
                    provideRuntimeChecks(config.runtimeChecks),
                ],
            };
        };
        /**
         * @param {?} featureName
         * @param {?} reducers
         * @param {?=} config
         * @return {?}
         */
        StoreModule.forFeature = function (featureName, reducers, config) {
            if (config === void 0) { config = {}; }
            return {
                ngModule: StoreFeatureModule,
                providers: [
                    {
                        provide: _FEATURE_CONFIGS,
                        multi: true,
                        useValue: config,
                    },
                    {
                        provide: STORE_FEATURES,
                        multi: true,
                        useValue: {
                            key: featureName,
                            reducerFactory: !(config instanceof InjectionToken) && config.reducerFactory
                                ? config.reducerFactory
                                : combineReducers,
                            metaReducers: !(config instanceof InjectionToken) && config.metaReducers
                                ? config.metaReducers
                                : [],
                            initialState: !(config instanceof InjectionToken) && config.initialState
                                ? config.initialState
                                : undefined,
                        },
                    },
                    {
                        provide: _STORE_FEATURES,
                        deps: [Injector, _FEATURE_CONFIGS, STORE_FEATURES],
                        useFactory: _createFeatureStore,
                    },
                    { provide: _FEATURE_REDUCERS, multi: true, useValue: reducers },
                    {
                        provide: _FEATURE_REDUCERS_TOKEN,
                        multi: true,
                        useExisting: reducers instanceof InjectionToken ? reducers : _FEATURE_REDUCERS,
                    },
                    {
                        provide: FEATURE_REDUCERS,
                        multi: true,
                        deps: [
                            Injector,
                            _FEATURE_REDUCERS,
                            [new Inject(_FEATURE_REDUCERS_TOKEN)],
                        ],
                        useFactory: _createFeatureReducers,
                    },
                ],
            };
        };
        return StoreModule;
    }());
    StoreModule.decorators = [
        { type: NgModule, args: [{},] }
    ];
    /**
     * @param {?} injector
     * @param {?} reducers
     * @return {?}
     */
    function _createStoreReducers(injector, reducers) {
        return reducers instanceof InjectionToken ? injector.get(reducers) : reducers;
    }
    /**
     * @param {?} injector
     * @param {?} configs
     * @param {?} featureStores
     * @return {?}
     */
    function _createFeatureStore(injector, configs, featureStores) {
        return featureStores.map(( /**
         * @param {?} feat
         * @param {?} index
         * @return {?}
         */function (feat, index) {
            if (configs[index] instanceof InjectionToken) {
                /** @type {?} */
                var conf = injector.get(configs[index]);
                return {
                    key: feat.key,
                    reducerFactory: conf.reducerFactory
                        ? conf.reducerFactory
                        : combineReducers,
                    metaReducers: conf.metaReducers ? conf.metaReducers : [],
                    initialState: conf.initialState,
                };
            }
            return feat;
        }));
    }
    /**
     * @param {?} injector
     * @param {?} reducerCollection
     * @return {?}
     */
    function _createFeatureReducers(injector, reducerCollection) {
        /** @type {?} */
        var reducers = reducerCollection.map(( /**
         * @param {?} reducer
         * @return {?}
         */function (/**
         * @param {?} reducer
         * @return {?}
         */ reducer) {
            return reducer instanceof InjectionToken ? injector.get(reducer) : reducer;
        }));
        return reducers;
    }
    /**
     * @param {?} initialState
     * @return {?}
     */
    function _initialStateFactory(initialState) {
        if (typeof initialState === 'function') {
            return initialState();
        }
        return initialState;
    }
    /**
     * @param {?} metaReducers
     * @param {?} userProvidedMetaReducers
     * @return {?}
     */
    function _concatMetaReducers(metaReducers, userProvidedMetaReducers) {
        return metaReducers.concat(userProvidedMetaReducers);
    }
    /**
     * @param {?} store
     * @return {?}
     */
    function _provideForRootGuard(store) {
        if (store) {
            throw new TypeError("StoreModule.forRoot() called twice. Feature modules should use StoreModule.forFeature() instead.");
        }
        return 'guarded';
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@description
     * Associates actions with a given state change function.
     * A state change function must be provided as the last parameter.
     *
     * @param {...?} args `ActionCreator`'s followed by a state change function.
     *
     * **To maintain type-safety**: pass 10 or less `ActionCreator`'s.
     * @return {?} an association of action types with a state change function.
     */
    function on() {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        /** @type {?} */
        var reducer = ( /** @type {?} */(args.pop()));
        /** @type {?} */
        var types = args.reduce(( /**
         * @param {?} result
         * @param {?} creator
         * @return {?}
         */function (result, creator) { return __spread(result, [(( /** @type {?} */(creator))).type]); }), ( /** @type {?} */([])));
        return { reducer: reducer, types: types };
    }
    /**
     * \@description
     * Creates a reducer function to handle state transitions.
     *
     * Reducer creators reduce the explicitness of reducer functions with switch statements.
     *
     * \@usageNotes
     *
     * - Must be used with `ActionCreator`'s (returned by `createAction`).  Cannot be used with class-based action creators.
     * - An action can be associated with multiple state change functions. In this case the functions will be executed in the specified order.
     * - The returned `ActionReducer` should additionally be returned from an exported `reducer` function.
     * This is because [function calls are not supported](https://angular.io/guide/aot-compiler#function-calls-are-not-supported) by the AOT compiler.
     *
     * **Declaring a reducer creator with an exported reducer function**
     *
     * ```ts
     * const featureReducer = createReducer(
     *   initialState,
     *   on(
     *     featureActions.actionOne,
     *     featureActions.actionTwo,
     *     (state, { updatedValue }) => ({ ...state, prop: updatedValue })
     *   ),
     *   on(featureActions.actionThree, () => initialState);
     * );
     *
     * export function reducer(state: State | undefined, action: Action) {
     *   return featureReducer(state, action);
     * }
     * ```
     * @template S, A
     * @param {?} initialState Provides a state value if the current state is `undefined`, as it is initially.
     * @param {...?} ons Associations between actions and state changes.
     * @return {?} A reducer function.
     *
     */
    function createReducer(initialState) {
        var ons = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            ons[_i - 1] = arguments[_i];
        }
        var e_16, _b;
        /** @type {?} */
        var map = new Map();
        var _loop_4 = function (on_1) {
            var e_17, _b;
            var _loop_5 = function (type) {
                if (map.has(type)) {
                    /** @type {?} */
                    var existingReducer_1 = ( /** @type {?} */(map.get(type)));
                    /** @type {?} */
                    var newReducer = ( /**
                     * @param {?} state
                     * @param {?} action
                     * @return {?}
                     */function (state, action) { return on_1.reducer(existingReducer_1(state, action), action); });
                    map.set(type, newReducer);
                }
                else {
                    map.set(type, on_1.reducer);
                }
            };
            try {
                for (var _c = __values(on_1.types), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var type = _d.value;
                    _loop_5(type);
                }
            }
            catch (e_17_1) { e_17 = { error: e_17_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
                }
                finally { if (e_17) throw e_17.error; }
            }
        };
        try {
            for (var ons_1 = __values(ons), ons_1_1 = ons_1.next(); !ons_1_1.done; ons_1_1 = ons_1.next()) {
                var on_1 = ons_1_1.value;
                _loop_4(on_1);
            }
        }
        catch (e_16_1) { e_16 = { error: e_16_1 }; }
        finally {
            try {
                if (ons_1_1 && !ons_1_1.done && (_b = ons_1.return)) _b.call(ons_1);
            }
            finally { if (e_16) throw e_16.error; }
        }
        return ( /**
         * @param {?=} state
         * @param {?=} action
         * @return {?}
         */function (state, action) {
            if (state === void 0) { state = initialState; }
            /** @type {?} */
            var reducer = map.get(action.type);
            return reducer ? reducer(state, action) : state;
        });
    }
    /** URL when running locally */
    var LOCAL_URL = '/';
    /** Plugin name */
    var PLUGIN_NAME = 'profile';
    /** Pefix of API */
    var API_PREFIX = '/data/plugin/';
    /** Tools API */
    var TOOLS_API = API_PREFIX + PLUGIN_NAME + '/tools';
    /** Hosts API */
    var HOSTS_API = API_PREFIX + PLUGIN_NAME + '/hosts';
    /** Data API */
    var DATA_API = API_PREFIX + PLUGIN_NAME + '/data';
    /** Capture Profile API */
    var CAPTURE_PROFILE_API = API_PREFIX + PLUGIN_NAME + '/capture_profile';
    /** Default Host */
    var DEFAULT_HOST = 'default';
    /**
     * Based on palette of Kenneth Kelly's 22 colors of maximum contrast.
     * More information at page 5 of
     * https://eleanormaclure.files.wordpress.com/2011/03/colour-coding.pdf.
     * "F2F3F4" was removed because it's contrast against white is poor.
     */
    var KELLY_COLORS = [
        '0067A5', 'E68FAC', 'E25822', '008856', 'F99379', '604E97', 'F6A600',
        'B3446C', 'DCD300', '8DB600', '654522', '222222', '882D17', 'F3C300',
        '875692', 'F38400', 'A1CAF1', 'BE0032', 'C2B280', '848482', '2B3D26',
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Mock data for tools API
     * @type {?}
     */
    var DATA_PLUGIN_PROFILE_TOOLS = {
        'foo': ['overview_page', 'trace_viewer'],
        'empty': [],
        'bar': [
            'overview_page',
            'overview_page@',
            'input_pipeline_analyzer',
            'input_pipeline_analyzer@',
            'memory_viewer',
            'memory_profile#',
            'kernel_stats',
            'op_profile',
            'pod_viewer',
            'trace_viewer',
            'trace_viewer@',
            'trace_viewer^',
            'tensorflow_stats',
            'tensorflow_stats^',
        ]
    };
    /**
     * Mock data for hosts API
     * @type {?}
     */
    var DATA_PLUGIN_PROFILE_HOSTS = ['device', 'host'];
    /**
     * Mock data for data API with oveview_page tag
     * @type {?}
     */
    var DATA_PLUGIN_PROFILE_OVERVIEW_PAGE_DATA = [
        {
            'cols': [
                { 'id': 'selfTimePercent', 'label': 'Time (%)', 'type': 'number' },
                {
                    'id': 'cumulativeTimePercent',
                    'label': 'Cumulative time (%)',
                    'type': 'number'
                },
                { 'id': 'category', 'label': 'Category', 'type': 'string' },
                { 'id': 'operation', 'label': 'Operation', 'type': 'string' },
                { 'id': 'flopRate', 'label': 'GFLOPs/Sec', 'type': 'number' },
            ],
            'rows': [
                {
                    'c': [
                        { 'v': 0.11555 },
                        { 'v': 0.11555 },
                        { 'v': 'InfeedDequeueTuple' },
                        { 'v': 'InfeedQueue/dequeue' },
                        { 'v': 0 },
                    ]
                },
                {
                    'c': [
                        { 'v': 0.03827 },
                        { 'v': 0.15383 },
                        { 'v': '' },
                        { 'v': 'all-reduce.958' },
                        { 'v': 1.39586 },
                    ]
                },
                {
                    'c': [
                        { 'v': 0.01991 },
                        { 'v': 0.17374 },
                        { 'v': 'DepthwiseConv2dNativeBackpropInput' },
                        { 'v': 'gradients/mnas_v4/DepthwiseConv2dNativeBackpropInput' },
                        { 'v': 184.05721510136567 },
                    ]
                },
                {
                    'c': [
                        { 'v': 0.01867 },
                        { 'v': 0.19242 },
                        { 'v': 'Conv2DBackpropInput' },
                        { 'v': 'gradients/mnas_v4/Conv2DBackpropInput' },
                        { 'v': 398.40904 },
                    ]
                },
                {
                    'c': [
                        { 'v': 0.01850 },
                        { 'v': 0.21092 },
                        { 'v': 'Conv2DBackpropInput' },
                        { 'v': 'gradients/mnas_v4/Conv2DBackpropInput' },
                        { 'v': 498.64649 },
                    ]
                },
                {
                    'c': [
                        { 'v': 0.01774 },
                        { 'v': 0.22866 },
                        { 'v': '' },
                        { 'v': 'reshape.1223' },
                        { 'v': 0 },
                    ]
                },
                {
                    'c': [
                        { 'v': 0.01616 },
                        { 'v': 0.24483 },
                        { 'v': 'DepthwiseConv2dNativeBackpropInput' },
                        { 'v': 'gradients/mnas_v4/DepthwiseConv2dNativeBackpropInput' },
                        { 'v': 221.49059 },
                    ]
                },
                {
                    'c': [
                        { 'v': 0.01427 },
                        { 'v': 0.25911 },
                        { 'v': 'DepthwiseConv2dNativeBackpropFilter' },
                        { 'v': 'gradients/mnas_v4/DepthwiseConv2dNativeBackpropFilter' },
                        { 'v': 256.82179 },
                    ]
                },
                {
                    'c': [
                        { 'v': 0.01411 },
                        { 'v': 0.27323 },
                        { 'v': 'Conv2D' },
                        { 'v': 'mnas_v4/feature_network/stem/conv/Conv2D_Fold' },
                        { 'v': 471.18847 },
                    ]
                },
                {
                    'c': [
                        { 'v': 0.01409 },
                        { 'v': 0.28732 },
                        { 'v': 'Conv2D' },
                        { 'v': 'mnas_v4/feature_network/stem/conv/Conv2D' },
                        { 'v': 463.72740 },
                    ]
                },
            ],
            'p': {
                'device_idle_time_percent': '1.1%',
                'flop_rate_utilization_relative_to_roofline': '54.6%',
                'host_idle_time_percent': '59.7%',
                'memory_bw_utilization_relative_to_hw_limit': '54.6%',
                'mxu_utilization_percent': '12.8%',
                'remark_color': '',
                'remark_text': '',
            },
        },
        {
            'cols': [
                { 'id': 'stepnum', 'label': 'stepnum', 'type': 'string' },
                { 'id': 'computeTimeMs', 'label': 'Compute', 'type': 'number' },
                { 'id': 'inputTimeMs', 'label': 'Input', 'type': 'number' },
                { 'id': 'idleTimeMs', 'label': 'Idle', 'type': 'number' },
                {
                    'id': 'tooltip',
                    'label': 'tooltip',
                    'type': 'string',
                    'p': { 'role': 'tooltip' }
                },
            ],
            'rows': [
                {
                    'c': [
                        { 'v': '1491' },
                        { 'v': 1.2346 },
                        { 'v': 1.3580 },
                        { 'v': 1.4938 },
                        {
                            'v': 'step 1491:\nTime waiting for input data \u003d 1.494 ms, ' +
                                'Step time \u003d 2.593 ms'
                        },
                    ]
                },
                {
                    'c': [
                        { 'v': '1492' },
                        { 'v': 6.1728 },
                        { 'v': 6.7901 },
                        { 'v': 7.4691 },
                        {
                            'v': 'step 1492:\nTime waiting for input data \u003d 7.469 ms, ' +
                                'Step time \u003d 12.963 ms'
                        },
                    ]
                },
                {
                    'c': [
                        { 'v': '1493' },
                        { 'v': 3.7037 },
                        { 'v': 4.0741 },
                        { 'v': 4.4815 },
                        {
                            'v': 'step 1493:\nTime waiting for input data \u003d 4.481 ms, ' +
                                'Step time \u003d 7.778 ms'
                        },
                    ]
                },
                {
                    'c': [
                        { 'v': '1494' },
                        { 'v': 8.6420 },
                        { 'v': 9.5062 },
                        { 'v': 10.4568 },
                        {
                            'v': 'step 1494:\nTime waiting for input data \u003d 10.457 ms, ' +
                                'Step time \u003d 18.148 ms'
                        },
                    ]
                },
                {
                    'c': [
                        { 'v': '1495' },
                        { 'v': 2.4691 },
                        { 'v': 2.7160 },
                        { 'v': 2.9877 },
                        {
                            'v': 'step 1495:\nTime waiting for input data \u003d 2.988 ms, ' +
                                'Step time \u003d 5.185 ms'
                        },
                    ]
                },
            ],
            'p': {
                'steptime_ms_average': '9.3',
                'steptime_ms_maximum': '18.1',
                'steptime_ms_minimum': '2.6',
                'steptime_ms_standard_deviation': '5.6',
                'idle_ms_average': '5.4',
                'input_ms_average': '4.9',
                'compute_ms_average': '4.4',
            },
        },
        {
            'cols': [],
            'rows': [],
            'p': {
                'device_core_count': '16 (Replica count \u003d 1, num cores per ' +
                    'replica \u003d 16)',
                'device_type': 'DragonFish',
                'host_count': '1',
            }
        },
        {
            'cols': [
                { 'id': 'tip_type', 'label': 'tip_type', 'type': 'string' },
                { 'id': 'link', 'label': 'link', 'type': 'string' },
            ],
            'rows': [
                {
                    'c': [
                        { 'v': 'host' },
                        {
                            'v': 'Contact <a href="mailto:tf-data-user@gmail.com" target=' +
                                '"_blank">tf-data-users@gmail.com</a> with your information.'
                        },
                    ]
                },
                {
                    'c': [
                        { 'v': 'host' },
                        { 'v': 'trace_viewer (Use the Trace Viewer.)' },
                    ]
                },
                {
                    'c': [
                        { 'v': 'device' },
                        {
                            'v': 'Contact <a href="mailto:tf-data-user@gmail.com" target=' +
                                '"_blank">tf-data-users@gmail.com</a> with your information.'
                        },
                    ]
                },
                {
                    'c': [
                        { 'v': 'device' },
                        { 'v': 'trace_viewer (Use the Trace Viewer.)' },
                    ]
                },
                {
                    'c': [
                        { 'v': 'doc' },
                        {
                            'v': '<a href="http://tensorflow.org" target="_blank">TensorFlow</a>'
                        },
                    ]
                },
                {
                    'c': [
                        { 'v': 'doc' },
                        {
                            'v': '<a href="http://cloud.google.com/tpu/" target="_blank">' +
                                'Cloud TPU</a>'
                        },
                    ]
                },
            ],
            'p': {
                'bottleneck': 'device',
                'statement': '(1) Your program is NOT input-bound because only 0.2% of ' +
                    'the total sep time sampled is waiting for input. Therefore, you ' +
                    'should focus on reducing the TPU time.',
            }
        },
    ];
    /**
     * Mock data for data API with input_pipeline tag
     * @type {?}
     */
    var DATA_PLUGIN_PROFILE_INPUT_PIPELINE_DATA = [
        {
            'cols': [
                { 'id': 'stepnum', 'label': 'stepnum', 'type': 'string' },
                {
                    'id': 'computeTimeMs',
                    'label': 'Compute time (in ms)',
                    'type': 'number'
                },
                { 'id': 'inputTimeMs', 'label': 'Input time (in ms)', 'type': 'number' },
                { 'id': 'idleTimeMs', 'label': 'Idle time (in ms)', 'type': 'number' },
                {
                    'id': 'tooltip',
                    'label': 'tooltip',
                    'type': 'string',
                    'p': { 'role': 'tooltip' }
                },
                {
                    'id': 'infeedPercentAverage',
                    'label': '% step time waiting for input data',
                    'type': 'number'
                },
                {
                    'id': 'infeedPercentMin',
                    'label': 'Infeed percent min',
                    'type': 'number',
                    'p': { 'role': 'interval' }
                },
                {
                    'id': 'infeedPercentMax',
                    'label': 'Infeed percent max',
                    'type': 'number',
                    'p': { 'role': 'interval' }
                },
            ],
            'rows': [
                {
                    'c': [
                        { 'v': '0' },
                        { 'v': 1.2346 },
                        { 'v': 1.3580 },
                        { 'v': 0.3580 },
                        {
                            'v': 'step 0:\nTime waiting for input data \u003d 1.358 ms, ' +
                                'Step time \u003d 1.235 ms'
                        },
                        { 'v': 1.2346 },
                        { 'v': 0.3856 },
                        { 'v': 1.3047 },
                    ]
                },
                {
                    'c': [
                        { 'v': '1' },
                        { 'v': 6.1728 },
                        { 'v': 6.7901 },
                        { 'v': 5.7901 },
                        {
                            'v': 'step 1:\nTime waiting for input data \u003d 6.790 ms, ' +
                                'Step time \u003d 6.173 ms'
                        },
                        { 'v': 6.1728 },
                        { 'v': 6.0534 },
                        { 'v': 7.2894 },
                    ]
                },
                {
                    'c': [
                        { 'v': '2' },
                        { 'v': 3.7037 },
                        { 'v': 4.0741 },
                        { 'v': 3.0741 },
                        {
                            'v': 'step 2:\nTime waiting for input data \u003d 4.074 ms, ' +
                                'Step time \u003d 3.704 ms'
                        },
                        { 'v': 3.7037 },
                        { 'v': 2.8989 },
                        { 'v': 4.2162 },
                    ]
                },
                {
                    'c': [
                        { 'v': '3' },
                        { 'v': 8.6420 },
                        { 'v': 9.5062 },
                        { 'v': 8.5062 },
                        {
                            'v': 'step 3:\nTime waiting for input data \u003d 9.506 ms, ' +
                                'Step time \u003d 8.642 ms'
                        },
                        { 'v': 8.6420 },
                        { 'v': 7.9922 },
                        { 'v': 8.7247 },
                    ]
                },
                {
                    'c': [
                        { 'v': '4' },
                        { 'v': 2.4691 },
                        { 'v': 2.7160 },
                        { 'v': 1.7160 },
                        {
                            'v': 'step 4:\nTime waiting for input data \u003d 2.716 ms, ' +
                                'Step time \u003d 2.469 ms'
                        },
                        { 'v': 2.4691 },
                        { 'v': 1.6194 },
                        { 'v': 2.9670 },
                    ]
                },
                {
                    'c': [
                        { 'v': '5' },
                        { 'v': 1.2346 },
                        { 'v': 1.3580 },
                        { 'v': 0.3580 },
                        {
                            'v': 'step 5:\nTime waiting for input data \u003d 1.358 ms, ' +
                                'Step time \u003d 1.235 ms'
                        },
                        { 'v': 1.2346 },
                        { 'v': 0.6609 },
                        { 'v': 2.3396 },
                    ]
                },
                {
                    'c': [
                        { 'v': '6' },
                        { 'v': 3.7037 },
                        { 'v': 4.0741 },
                        { 'v': 3.0741 },
                        {
                            'v': 'step 6:\nTime waiting for input data \u003d 4.074 ms, ' +
                                'Step time \u003d 3.704 ms'
                        },
                        { 'v': 3.7037 },
                        { 'v': 2.8748 },
                        { 'v': 3.9398 },
                    ]
                },
                {
                    'c': [
                        { 'v': '7' },
                        { 'v': 1.2346 },
                        { 'v': 1.3580 },
                        { 'v': 0.3580 },
                        {
                            'v': 'step 7:\nTime waiting for input data \u003d 1.358 ms, ' +
                                'Step time \u003d 1.235 ms'
                        },
                        { 'v': 2.4691 },
                        { 'v': 1.8634 },
                        { 'v': 2.9298 },
                    ]
                },
            ],
            'p': {
                'infeed_percent_average': '3.7',
                'infeed_percent_maximum': '8.6',
                'infeed_percent_minimum': '1.2',
                'infeed_percent_standard_deviation': '2.4',
                'steptime_ms_average': '3.5',
                'steptime_ms_maximum': '8.6',
                'steptime_ms_minimum': '1.2',
                'steptime_ms_standard_deviation': '2.5',
                'input_conclusion': '(1) Your program is NOT input-bound',
                'summary_nextstep': 'Look at the section 3 for the breakdown of input time on the host.',
            },
        },
        {},
        {
            'cols': [
                { 'id': 'opName', 'label': 'Input Op', 'type': 'string' },
                { 'id': 'count', 'label': 'Count', 'type': 'number' },
                { 'id': 'timeInMs', 'label': 'Total Time (in ms)', 'type': 'number' },
                {
                    'id': 'timeInPercent',
                    'label': 'Total Time (as % of total input-processing time)',
                    'type': 'number'
                },
                {
                    'id': 'selfTimeInMs',
                    'label': 'Total Self Time (in ms)',
                    'type': 'number'
                },
                {
                    'id': 'selfTimeInPercent',
                    'label': 'Total Self Time (as % of total input-processing time)',
                    'type': 'number'
                },
                { 'id': 'category', 'label': 'Category', 'type': 'string' },
            ],
            'rows': [
                {
                    'c': [
                        { 'v': 'Iterator::Model::Prefetch::MapAndBatch::Shuffle::SSTable' },
                        { 'v': 18 },
                        { 'v': 898.126 },
                        { 'v': 0.016 },
                        { 'v': 898.126 },
                        { 'v': 0.016 },
                        { 'v': 'Advanced file read' },
                    ]
                },
                {
                    'c': [
                        { 'v': 'Iterator::Model::Prefetch::MapAndBatch::ParallelInterleave' },
                        { 'v': 374 },
                        { 'v': 831.369 },
                        { 'v': 0.015 },
                        { 'v': 814.603 },
                        { 'v': 0.014 },
                        { 'v': 'Preprocessing' },
                    ]
                },
                {
                    'c': [
                        { 'v': 'Iterator::Model::Prefetch::MapAndBatch::Shuffle::SSTable[2]' },
                        { 'v': 13 },
                        { 'v': 813.236 },
                        { 'v': 0.014 },
                        { 'v': 813.236 },
                        { 'v': 0.014 },
                        { 'v': 'Advanced file read' },
                    ]
                },
                {
                    'c': [
                        { 'v': 'input_pipeline_task0/while/InfeedQueue/enqueue/6' },
                        { 'v': 4 },
                        { 'v': 307.823 },
                        { 'v': 0.005 },
                        { 'v': 307.823 },
                        { 'v': 0.005 },
                        { 'v': 'Enqueue' },
                    ]
                },
                {
                    'c': [
                        { 'v': 'Iterator::Model' },
                        { 'v': 18 },
                        { 'v': 535.884 },
                        { 'v': 0.009 },
                        { 'v': 0.234 },
                        { 'v': 4.245 },
                        { 'v': 'Preprocessing' },
                    ]
                },
            ],
            'p': {
                'advanced_file_read_us': '4307208.812',
                'demanded_file_read_us': '0.000',
                'enqueue_us': '3002954.541',
                'preprocessing_us': '180620.171',
                'unclassified_nonequeue_us': '0.000',
            },
        },
        {
            'cols': [{ 'id': 'link', 'label': 'link', 'type': 'string' }],
            'rows': [
                {
                    'c': [{
                            'v': 'Enqueuing data: you may want to combine small input data ' +
                                'chunks into fewer but larger chunks.'
                        }]
                },
                {
                    'c': [{
                            'v': 'Other data reading or processing: you may consider using the ' +
                                '\u003ca href\u003d\u0022https://www.tensorflow.org/programmers' +
                                '_guide/datasets\u0022 target\u003d\u0022_blank\u0022\u003eData' +
                                'set API\u003c/a\u003e (if you are not using it now)'
                        }]
                },
            ],
        },
    ];
    /**
     * Mock data for data API with tensorflow_stats tag
     * @type {?}
     */
    var DATA_PLUGIN_PROFILE_TENSORFLOW_STATS_DATA = [
        {
            'cols': [
                { 'id': 'rank', 'label': 'Rank', 'type': 'number' },
                { 'id': 'host_or_device', 'label': 'Host/device', 'type': 'string' },
                { 'id': 'type', 'label': 'Type', 'type': 'string' },
                { 'id': 'operation', 'label': 'Operation', 'type': 'string' },
                { 'id': 'occurrences', 'label': '#Occurrences', 'type': 'number' },
                { 'id': 'total_time', 'label': 'Total time (us)', 'type': 'number' },
                { 'id': 'avg_time', 'label': 'Avg. time (us)', 'type': 'number' },
                {
                    'id': 'total_self_time',
                    'label': 'Total self-time (us)',
                    'type': 'number'
                },
                { 'id': 'avg_self_time', 'label': 'Avg. self-time (us)', 'type': 'number' },
                {
                    'id': 'device_total_self_time_percent',
                    'label': 'Total self-time on Device (%)',
                    'type': 'number'
                },
                {
                    'id': 'device_cumulative_total_self_time_percent',
                    'label': 'Cumulative total-self time on Device (%)',
                    'type': 'number'
                },
                {
                    'id': 'host_total_self_time_percent',
                    'label': 'Total self-time on Host (%)',
                    'type': 'number'
                },
                {
                    'id': 'Host_cumulative_total_self_time_percent',
                    'label': 'Cumulative total-self time on Host (%)',
                    'type': 'number'
                },
                {
                    'id': 'measured_flop_rate',
                    'label': 'Measured GFLOPs/Sec',
                    'type': 'number'
                },
                {
                    'id': 'measured_memory_bw',
                    'label': 'Measured Memory BW (GBytes/Sec)',
                    'type': 'number'
                },
                {
                    'id': 'operational_intensity',
                    'label': 'Operational Intensity (FLOPs/Byte)',
                    'type': 'number'
                },
                { 'id': 'bound_by', 'label': 'Bound by', 'type': 'string' },
            ],
            'p': {
                'architecture_type': 'Convolutional Neural Network (CNN)',
                'device_tf_pprof_link': '',
                'host_tf_pprof_link': '',
                'task_type': 'Training',
            },
            'rows': [
                {
                    'c': [
                        { 'v': 1 }, { 'v': 'Device' }, { 'v': 'Conv2D' }, { 'v': 'Conv2D_Fold' },
                        { 'v': 50 }, { 'v': 4000000.5 }, { 'v': 80000.01 }, { 'v': 4000000.5 },
                        { 'v': 80000.01 }, { 'v': 0.4 }, { 'v': 0.4 }, { 'v': 0 }, { 'v': 0 },
                        { 'v': 5413.5 }, { 'v': 85 }, { 'v': 63.7 }, { 'v': 'Memory' }
                    ]
                },
                {
                    'c': [
                        { 'v': 2 }, { 'v': 'Device' }, { 'v': 'Conv2D' }, { 'v': 'Conv2D' },
                        { 'v': 40 }, { 'v': 1200000.5 }, { 'v': 30000.01 }, { 'v': 1200000.5 },
                        { 'v': 30000.01 }, { 'v': 0.12 }, { 'v': 0.52 }, { 'v': 0 }, { 'v': 0 },
                        { 'v': 447.2 }, { 'v': 121.5 }, { 'v': 3.7 }, { 'v': 'Memory' }
                    ]
                },
                {
                    'c': [
                        { 'v': 3 }, { 'v': 'Device' }, { 'v': 'DepthwiseConv2dNative' },
                        { 'v': 'DepthwiseConv2dNative' }, { 'v': 25 }, { 'v': 2000000.5 },
                        { 'v': 80000.02 }, { 'v': 2000000.5 }, { 'v': 80000.02 }, { 'v': 0.2 },
                        { 'v': 0.72 }, { 'v': 0 }, { 'v': 0 }, { 'v': 5383.2 }, { 'v': 62.8 },
                        { 'v': 85.8 }, { 'v': 'Memory' }
                    ]
                },
                {
                    'c': [
                        { 'v': 4 }, { 'v': 'Device' }, { 'v': 'Max' }, { 'v': 'BatchMax' }, { 'v': 10 },
                        { 'v': 1300000.5 }, { 'v': 130000.05 }, { 'v': 1300000.5 },
                        { 'v': 130000.05 }, { 'v': 0.13 }, { 'v': 0.85 }, { 'v': 0 }, { 'v': 0 },
                        { 'v': 111.6 }, { 'v': 210.5 }, { 'v': 0.5 }, { 'v': 'Memory' }
                    ]
                },
                {
                    'c': [
                        { 'v': 5 }, { 'v': 'Device' }, { 'v': 'IDLE' }, { 'v': 'IDLE' }, { 'v': 10 },
                        { 'v': 1500000.5 }, { 'v': 150000.05 }, { 'v': 1500000.5 },
                        { 'v': 150000.05 }, { 'v': 0.15 }, { 'v': 1 }, { 'v': 0 }, { 'v': 0 }, { 'v': 0 },
                        { 'v': 0 }, { 'v': 0 }, { 'v': 'Unknown' }
                    ]
                },
                {
                    'c': [
                        { 'v': 6 }, { 'v': 'Host' }, { 'v': 'IDLE' }, { 'v': 'IDLE' }, { 'v': 30 },
                        { 'v': 4500000.1 }, { 'v': 1500000 }, { 'v': 4500000.1 }, { 'v': 1500000 },
                        { 'v': 0 }, { 'v': 0 }, { 'v': 0.45 }, { 'v': 0.45 }, { 'v': 0 }, { 'v': 0 },
                        { 'v': 0 }, { 'v': 'Unknown' }
                    ]
                },
                {
                    'c': [
                        { 'v': 7 }, { 'v': 'Host' }, { 'v': 'OutfeedDequeueTuple' },
                        { 'v': 'OutfeedDequeueTuple' }, { 'v': 20 }, { 'v': 3000000.1 },
                        { 'v': 150000 }, { 'v': 3000000.1 }, { 'v': 150000 }, { 'v': 0 }, { 'v': 0 },
                        { 'v': 0.30 }, { 'v': 0.75 }, { 'v': 0 }, { 'v': 0 }, { 'v': 0 },
                        { 'v': 'Unknown' }
                    ]
                },
                {
                    'c': [
                        { 'v': 8 }, { 'v': 'Host' }, { 'v': 'OutfeedDequeueTuple' },
                        { 'v': 'OutfeedDequeueTuple_1' }, { 'v': 10 }, { 'v': 2500000.1 },
                        { 'v': 250000.01 }, { 'v': 2500000.1 }, { 'v': 250000.01 }, { 'v': 0 },
                        { 'v': 0 }, { 'v': 0.25 }, { 'v': 1 }, { 'v': 0 }, { 'v': 0 }, { 'v': 0 },
                        { 'v': 'Unknown' }
                    ]
                },
            ]
        },
        {
            'cols': [
                { 'id': 'rank', 'label': 'Rank', 'type': 'number' },
                { 'id': 'host_or_device', 'label': 'Host/device', 'type': 'string' },
                { 'id': 'type', 'label': 'Type', 'type': 'string' },
                { 'id': 'operation', 'label': 'Operation', 'type': 'string' },
                { 'id': 'occurrences', 'label': '#Occurrences', 'type': 'number' },
                { 'id': 'total_time', 'label': 'Total time (us)', 'type': 'number' },
                { 'id': 'avg_time', 'label': 'Avg. time (us)', 'type': 'number' },
                {
                    'id': 'total_self_time',
                    'label': 'Total self-time (us)',
                    'type': 'number'
                },
                { 'id': 'avg_self_time', 'label': 'Avg. self-time (us)', 'type': 'number' },
                {
                    'id': 'device_total_self_time_percent',
                    'label': 'Total self-time on Device (%)',
                    'type': 'number'
                },
                {
                    'id': 'device_cumulative_total_self_time_percent',
                    'label': 'Cumulative total-self time on Device (%)',
                    'type': 'number'
                },
                {
                    'id': 'host_total_self_time_percent',
                    'label': 'Total self-time on Host (%)',
                    'type': 'number'
                },
                {
                    'id': 'Host_cumulative_total_self_time_percent',
                    'label': 'Cumulative total-self time on Host (%)',
                    'type': 'number'
                },
                {
                    'id': 'measured_flop_rate',
                    'label': 'Measured GFLOPs/Sec',
                    'type': 'number'
                },
                {
                    'id': 'measured_memory_bw',
                    'label': 'Measured Memory BW (GBytes/Sec)',
                    'type': 'number'
                },
                {
                    'id': 'operational_intensity',
                    'label': 'Operational Intensity (FLOPs/Byte)',
                    'type': 'number'
                },
                { 'id': 'bound_by', 'label': 'Bound by', 'type': 'string' },
            ],
            'p': {
                'architecture_type': 'Convolutional Neural Network (CNN)',
                'device_tf_pprof_link': '',
                'host_tf_pprof_link': '',
                'task_type': 'Training',
            },
            'rows': [
                {
                    'c': [
                        { 'v': 1 }, { 'v': 'Device' }, { 'v': 'Conv2D' }, { 'v': 'Conv2D_Fold' },
                        { 'v': 50 }, { 'v': 4000000.5 }, { 'v': 80000.01 }, { 'v': 4000000.5 },
                        { 'v': 80000.01 }, { 'v': 0.46 }, { 'v': 0.46 }, { 'v': 0 }, { 'v': 0 },
                        { 'v': 5413.5 }, { 'v': 85 }, { 'v': 63.7 }, { 'v': 'Memory' }
                    ]
                },
                {
                    'c': [
                        { 'v': 2 }, { 'v': 'Device' }, { 'v': 'Conv2D' }, { 'v': 'Conv2D' },
                        { 'v': 40 }, { 'v': 1200000.5 }, { 'v': 30000.01 }, { 'v': 1200000.5 },
                        { 'v': 30000.01 }, { 'v': 0.14 }, { 'v': 0.6 }, { 'v': 0 }, { 'v': 0 },
                        { 'v': 447.2 }, { 'v': 121.5 }, { 'v': 3.7 }, { 'v': 'Memory' }
                    ]
                },
                {
                    'c': [
                        { 'v': 3 }, { 'v': 'Device' }, { 'v': 'DepthwiseConv2dNative' },
                        { 'v': 'DepthwiseConv2dNative' }, { 'v': 25 }, { 'v': 2000000.5 },
                        { 'v': 80000.02 }, { 'v': 2000000.5 }, { 'v': 80000.02 }, { 'v': 0.24 },
                        { 'v': 0.84 }, { 'v': 0 }, { 'v': 0 }, { 'v': 5383.2 }, { 'v': 62.8 },
                        { 'v': 85.8 }, { 'v': 'Memory' }
                    ]
                },
                {
                    'c': [
                        { 'v': 4 }, { 'v': 'Device' }, { 'v': 'Max' }, { 'v': 'BatchMax' }, { 'v': 10 },
                        { 'v': 1300000.5 }, { 'v': 130000.05 }, { 'v': 1300000.5 },
                        { 'v': 130000.05 }, { 'v': 0.16 }, { 'v': 1 }, { 'v': 0 }, { 'v': 0 },
                        { 'v': 111.6 }, { 'v': 210.5 }, { 'v': 0.5 }, { 'v': 'Memory' }
                    ]
                },
                {
                    'c': [
                        { 'v': 5 }, { 'v': 'Host' }, { 'v': 'OutfeedDequeueTuple' },
                        { 'v': 'OutfeedDequeueTuple' }, { 'v': 20 }, { 'v': 3000000.1 },
                        { 'v': 150000 }, { 'v': 3000000.1 }, { 'v': 150000 }, { 'v': 0 }, { 'v': 0 },
                        { 'v': 0.67 }, { 'v': 0.67 }, { 'v': 0 }, { 'v': 0 }, { 'v': 0 },
                        { 'v': 'Unknown' }
                    ]
                },
                {
                    'c': [
                        { 'v': 6 }, { 'v': 'Host' }, { 'v': 'OutfeedDequeueTuple' },
                        { 'v': 'OutfeedDequeueTuple_1' }, { 'v': 10 }, { 'v': 2500000.1 },
                        { 'v': 250000.01 }, { 'v': 2500000.1 }, { 'v': 250000.01 }, { 'v': 0 },
                        { 'v': 0 }, { 'v': 0.33 }, { 'v': 1 }, { 'v': 0 }, { 'v': 0 }, { 'v': 0 },
                        { 'v': 'Unknown' }
                    ]
                },
            ]
        },
    ];
    /* tslint:disable no-any */
    /**
     * Mock data for data API with memory_profile tag
     * @type {?}
     */
    var DATA_PLUGIN_PROFILE_MEMORY_PROFILE_DATA = {
        'memoryIds': ['0', '1', '2'],
        'memoryProfilePerAllocator': {
            '0': {
                'activeAllocations': [
                    { 'numOccurrences': '1', 'snapshotIndex': '-1', 'specialIndex': '0' },
                    { 'numOccurrences': '1', 'snapshotIndex': '-2', 'specialIndex': '1' },
                    { 'numOccurrences': '1', 'snapshotIndex': '2', 'specialIndex': '-1' }
                ],
                'memoryProfileSnapshots': [
                    {
                        'activityMetadata': {
                            'address': '222333',
                            'allocationBytes': '256',
                            'dataType': 'float',
                            'memoryActivity': ( /** @type {?} */('ALLOCATION')),
                            'regionType': 'output',
                            'requestedBytes': '200',
                            'stepId': '0',
                            'tensorShape': '[3, 3, 512, 512]',
                            'tfOpName': 'foo/bar'
                        },
                        'aggregationStats': {
                            'fragmentation': 0.1,
                            'freeMemoryBytes': '5000',
                            'heapAllocatedBytes': '3000',
                            'peakBytesInUse': '8500',
                            'stackReservedBytes': '2000'
                        },
                        'timeOffsetPs': '40000000'
                    },
                    {
                        'activityMetadata': {
                            'address': '222333',
                            'allocationBytes': '256',
                            'dataType': 'float',
                            'memoryActivity': ( /** @type {?} */('DEALLOCATION')),
                            'regionType': 'output',
                            'requestedBytes': '200',
                            'stepId': '0',
                            'tensorShape': '[3, 3, 512, 512]',
                            'tfOpName': 'foo/bar'
                        },
                        'aggregationStats': {
                            'fragmentation': 0.08,
                            'freeMemoryBytes': '5256',
                            'heapAllocatedBytes': '2744',
                            'peakBytesInUse': '8500',
                            'stackReservedBytes': '2000'
                        },
                        'timeOffsetPs': '50000000'
                    },
                    {
                        'activityMetadata': {
                            'address': '345678',
                            'allocationBytes': '300',
                            'dataType': 'int64',
                            'memoryActivity': 'ALLOCATION',
                            'regionType': 'temp',
                            'requestedBytes': '300',
                            'stepId': '0',
                            'tensorShape': '[]',
                            'tfOpName': 'mul_grad/Sum'
                        },
                        'aggregationStats': {
                            'fragmentation': 0.8,
                            'freeMemoryBytes': '3000',
                            'heapAllocatedBytes': '5000',
                            'peakBytesInUse': '9500',
                            'stackReservedBytes': '2000'
                        },
                        'timeOffsetPs': '70000000'
                    }
                ],
                'profileSummary': {
                    'memoryCapacity': '10000',
                    'peakBytesUsageLifetime': '9500',
                    'peakStats': {
                        'fragmentation': 0.8,
                        'freeMemoryBytes': '3000',
                        'heapAllocatedBytes': '5000',
                        'peakBytesInUse': '7000',
                        'stackReservedBytes': '2000'
                    },
                    'peakStatsTimePs': '70000000'
                },
                'specialAllocations': [
                    {
                        'address': '0',
                        'allocationBytes': '4700',
                        'dataType': 'INVALID',
                        'memoryActivity': ( /** @type {?} */('ALLOCATION')),
                        'regionType': 'persist',
                        'requestedBytes': '4700',
                        'stepId': '0',
                        'tensorShape': 'unknown',
                        'tfOpName': 'unused preallocated device memory'
                    },
                    {
                        'address': '0',
                        'allocationBytes': '2000',
                        'dataType': 'INVALID',
                        'memoryActivity': 'ALLOCATION',
                        'regionType': 'stack',
                        'requestedBytes': '2000',
                        'stepId': '0',
                        'tensorShape': 'unknown',
                        'tfOpName': 'stack'
                    }
                ]
            }
        },
        'numHosts': 1
    };
    /**
     * Mock data for data API with memory_viewer tag
     * @type {?}
     */
    var DATA_PLUGIN_PROFILE_MEMORY_VIEWER_DATA = {
        'hloModule': {
            'name': 'Good Module',
            'entryComputationName': 'comp',
            'entryComputationId': '0',
            'computations': [
                {
                    'name': 'comp',
                    'instructions': [
                        {
                            'name': 'ins-0',
                            'opcode': 'fusion',
                            'shape': {
                                'elementType': ( /** @type {?} */('F32')),
                                'layout': {
                                    'format': ( /** @type {?} */('DENSE')),
                                    'maxSparseElements': '0',
                                },
                            },
                            'id': '0',
                        },
                        {
                            'name': 'ins-1',
                            'opcode': 'fusion',
                            'shape': {
                                'elementType': ( /** @type {?} */('F32')),
                                'dimensions': ['32', '16', '16', '32'],
                                'layout': {
                                    'format': ( /** @type {?} */('DENSE')),
                                    'minorToMajor': ['3', '0', '2', '1'],
                                    'maxSparseElements': '0',
                                },
                            },
                            'metadata': {
                                'opType': 'Relu',
                                'opName': 'sequentila/conv2d/Relu',
                                'sourceLine': 0,
                            },
                            'id': '1',
                        },
                        {
                            'name': 'ins-2',
                            'opcode': 'fusion',
                            'shape': {
                                'elementType': 'F32',
                                'layout': {
                                    'format': 'DENSE',
                                    'maxSparseElements': '0',
                                },
                            },
                            'id': '2',
                        },
                        {
                            'name': 'ins-3',
                            'opcode': 'fusion',
                            'shape': {
                                'elementType': 'F32',
                                'layout': {
                                    'format': 'DENSE',
                                    'maxSparseElements': '0',
                                },
                            },
                            'id': '3',
                        },
                        {
                            'name': 'ins-4',
                            'opcode': 'fusion',
                            'shape': {
                                'elementType': 'F32',
                                'layout': {
                                    'format': 'DENSE',
                                    'maxSparseElements': '0',
                                },
                            },
                            'id': '4',
                        },
                    ],
                    'id': '0',
                },
            ],
        },
        'bufferAssignment': {
            'logicalBuffers': [
                {
                    'id': '0',
                    'size': '1048576',
                    'definedAt': {
                        'computationName': 'comp',
                        'instructionName': 'ins-0',
                    },
                },
                {
                    'id': '1',
                    'size': '2097512',
                    'definedAt': {
                        'computationName': 'comp',
                        'instructionName': 'ins-1',
                    },
                },
                {
                    'id': '2',
                    'size': '3145728',
                    'definedAt': {
                        'computationName': 'comp',
                        'instructionName': 'ins-2',
                    },
                },
                {
                    'id': '3',
                    'size': '5242880',
                    'definedAt': {
                        'computationName': 'comp',
                        'instructionName': 'ins-3',
                    },
                },
                {
                    'id': '4',
                    'size': '1048576',
                    'definedAt': {
                        'computationName': 'comp',
                        'instructionName': 'ins-4',
                    },
                },
            ],
            'bufferAllocations': [
                {
                    'index': '0',
                    'size': '10485676',
                    'isThreadLocal': true,
                    'isResuable': false,
                    'isEntryComputationParameter': false,
                    'maybeLiveOut': false,
                    'assigned': [{
                            'logicalBufferId': '0',
                            'offset': '0',
                            'size': '1048576',
                        }],
                },
                {
                    'index': '1',
                    'size': '2097512',
                    'isThreadLocal': true,
                    'isResuable': false,
                    'isEntryComputationParameter': false,
                    'maybeLiveOut': false,
                    'assigned': [{
                            'logicalBufferId': '1',
                            'offset': '0',
                            'size': '2097512',
                        }],
                },
                {
                    'index': '2',
                    'size': '3145728',
                    'isThreadLocal': true,
                    'isResuable': false,
                    'isEntryComputationParameter': false,
                    'maybeLiveOut': false,
                    'assigned': [{
                            'logicalBufferId': '2',
                            'offset': '0',
                            'size': '3145728',
                        }],
                },
                {
                    'index': '3',
                    'size': '5242880',
                    'isThreadLocal': true,
                    'isResuable': false,
                    'isEntryComputationParameter': false,
                    'maybeLiveOut': false,
                    'assigned': [{
                            'logicalBufferId': '3',
                            'offset': '0',
                            'size': '5242880',
                        }],
                },
                {
                    'index': '4',
                    'size': '10485676',
                    'isThreadLocal': true,
                    'isResuable': false,
                    'isEntryComputationParameter': false,
                    'maybeLiveOut': false,
                    'assigned': [{
                            'logicalBufferId': '4',
                            'offset': '0',
                            'size': '1048576',
                        }],
                },
            ],
            'heapSimulatorTraces': [
                {
                    'events': [
                        {
                            'kind': ( /** @type {?} */('ALLOC')),
                            'bufferId': '0',
                            'computationName': 'comp',
                            'instructionName': 'ins-0',
                        },
                        {
                            'kind': ( /** @type {?} */('ALLOC')),
                            'bufferId': '1',
                            'computationName': 'comp',
                            'instructionName': 'ins-1',
                        },
                        {
                            'kind': 'ALLOC',
                            'bufferId': '2',
                            'computationName': 'comp',
                            'instructionName': 'ins-2',
                        },
                        {
                            'kind': 'ALLOC',
                            'bufferId': '3',
                            'computationName': 'comp',
                            'instructionName': 'ins-3',
                        },
                        {
                            'kind': 'FREE',
                            'bufferId': '3',
                            'computationName': 'comp',
                            'instructionName': 'ins-3',
                        },
                        {
                            'kind': 'FREE',
                            'bufferId': '2',
                            'computationName': 'comp',
                            'instructionName': 'ins-2',
                        },
                        {
                            'kind': 'FREE',
                            'bufferId': '1',
                            'computationName': 'comp',
                            'instructionName': 'ins-1',
                        },
                        {
                            'kind': 'ALLOC',
                            'bufferId': '4',
                            'computationName': 'comp',
                            'instructionName': 'ins-4',
                        },
                        {
                            'kind': 'FREE',
                            'bufferId': '4',
                            'computationName': 'comp',
                            'instructionName': 'ins-4',
                        },
                        {
                            'kind': 'FREE',
                            'bufferId': '0',
                            'computationName': 'comp',
                            'instructionName': 'ins-0',
                        },
                    ],
                },
            ],
        },
    };
    /* tslint:enable */
    /**
     * Mock data for data API with op_profile tag
     * @type {?}
     */
    var DATA_PLUGIN_PROFILE_OP_PROFILE_DATA = {
        'byCategory': {
            'name': 'byCategory',
            'metrics': {
                'time': 1,
                'flops': 0.4,
                'memoryBandwidth': 0.05,
            },
            'children': [
                {
                    'name': 'Good ops',
                    'metrics': {
                        'time': 0.6,
                        'flops': 0.4,
                    },
                    'category': {},
                    'children': [
                        {
                            'name': '%convolution',
                            'metrics': {
                                'time': 0.2,
                                'flops': 0.18,
                            },
                            'xla': {
                                'op': 'convolution',
                                'expression': '%convolution = something',
                                'provenance': 'Convolution2D',
                                'category': 'Good ops',
                                'layout': {
                                    'dimensions': [
                                        {
                                            'size': 200,
                                            'alignment': 128,
                                            'semantics': 'feature',
                                        },
                                        {
                                            'size': 8,
                                            'alignment': 8,
                                            'semantics': 'batch',
                                        },
                                        {
                                            'size': 256,
                                            'alignment': 0,
                                            'semantics': 'spatial',
                                        },
                                    ],
                                },
                            },
                            'children': [],
                        },
                        {
                            'name': '%fusion',
                            'metrics': {
                                'time': 0.4,
                                'flops': 0.22,
                            },
                            'xla': {
                                'op': 'fusion:kOutput',
                                'expression': '%fusion = something',
                                'provenance': '',
                                'category': 'Good ops',
                            },
                            'children': [
                                {
                                    'name': '%dot.1',
                                    'xla': {
                                        'op': 'dot',
                                        'expression': '%dot.1 = something',
                                        'provenance': 'TfOpForFusedDot',
                                        'category': 'Good ops',
                                    },
                                    'children': [],
                                },
                                {
                                    'name': '%dot.2',
                                    'xla': {
                                        'op': 'dot',
                                        'expression': '%dot.2 = something',
                                        'provenance': '',
                                        'category': 'Good ops',
                                    },
                                    'children': [],
                                },
                            ],
                        },
                    ],
                },
                {
                    'name': 'Overhead',
                    'metrics': {
                        'time': 0.4,
                        'flops': 0,
                    },
                    'category': {},
                    'children': [
                        {
                            'name': '%infeed',
                            'metrics': {
                                'time': 0.4,
                                'flops': 0,
                            },
                            'xla': {
                                'op': 'infeed',
                                'expression': '%infeed = something',
                                'provenance': '',
                                'category': 'Overhead',
                            },
                            'children': [],
                        },
                    ],
                },
            ],
        },
        'byProgram': {
            'name': 'byProgram',
            'metrics': {
                'time': 1,
                'flops': 0.37,
                'memoryBandwidth': 0.057,
            },
            'children': [],
        },
    };
    /**
     * Mock data for data API with pod_viewer tag
     * @type {?}
     */
    var DATA_PLUGIN_PROFILE_POD_VIEWER_DATA = {
        'podStatsSequence': {
            'podStatsMap': [
                {
                    'allReduceOpDb': [
                        {
                            'dataSize': '30661632',
                            'durationUs': 10811.50,
                            'name': 'all-reduce',
                            'replicaGroups': [
                                { 'replicaIds': ['0'] },
                            ]
                        },
                        {
                            'dataSize': '2048',
                            'durationUs': 2521.16,
                            'name': 'all-reduce.1',
                            'replicaGroups': [
                                { 'replicaIds': ['0'] },
                            ]
                        },
                        {
                            'dataSize': '12356608',
                            'durationUs': 463.57,
                            'name': 'all-reduce.2',
                            'replicaGroups': [
                                { 'replicaIds': ['0'] },
                            ]
                        },
                    ],
                    'channelDb': [
                        {
                            'channelId': '16436',
                            'dataSize': '2764800',
                            'durationUs': 34.01,
                            'hloNames': [
                                'send.42',
                                'recv-done.52',
                            ],
                            'srcCoreIds': [0, 3],
                            'dstCoreIds': [1, 2],
                            'sendDelayUs': 0,
                        },
                        {
                            'channelId': '17643',
                            'dataSize': '20480',
                            'durationUs': 276.6,
                            'hloNames': [
                                'recv-done.100',
                                'send.83',
                            ],
                            'srcCoreIds': [3],
                            'dstCoreIds': [0],
                            'sendDelayUs': 73.25,
                        },
                    ],
                    'coreIdToReplicaIdMap': {
                        '0': 0,
                        '1': 0,
                        '2': 0,
                        '3': 0,
                    },
                    'podStatsPerCore': {
                        '0': {
                            'chipId': 1,
                            'allReduceComputeDurationUs': 3296.22,
                            'allReduceSyncDurationUs': 0.40571,
                            'highFlopsComputeUs': 207233.68,
                            'hostInfeedDurationUs': 1714.96,
                            'hostName': 'njsw1:14059',
                            'hostOutfeedDurationUs': 0,
                            'nodeId': 0,
                            'recvDurationUs': 40773.72,
                            'sendDurationUs': 18154.35,
                            'totalDurationUs': 398215.85,
                        },
                        '1': {
                            'chipId': 1,
                            'allReduceComputeDurationUs': 3296.22,
                            'allReduceSyncDurationUs': 0.40571,
                            'highFlopsComputeUs': 207201.06,
                            'hostInfeedDurationUs': 1719.77,
                            'hostName': 'njsw1:14059',
                            'hostOutfeedDurationUs': 0,
                            'nodeId': 1,
                            'recvDurationUs': 37772.05,
                            'sendDurationUs': 17354.91,
                            'totalDurationUs': 398223.51,
                        },
                        '2': {
                            'chipId': 0,
                            'allReduceComputeDurationUs': 3296.22,
                            'allReduceSyncDurationUs': 36.02,
                            'highFlopsComputeUs': 214142.01,
                            'hostInfeedDurationUs': 1725.31,
                            'hostName': 'njsw1:14059',
                            'hostOutfeedDurationUs': 0.33,
                            'nodeId': 0,
                            'recvDurationUs': 31277.58,
                            'sendDurationUs': 9243.76,
                            'totalDurationUs': 398218.81,
                        },
                        '3': {
                            'chipId': 0,
                            'allReduceComputeDurationUs': 3296.22,
                            'allReduceSyncDurationUs': 36.02,
                            'highFlopsComputeUs': 209330.51,
                            'hostInfeedDurationUs': 1720.71,
                            'hostName': 'njsw1:14059',
                            'hostOutfeedDurationUs': 0,
                            'nodeId': 1,
                            'recvDurationUs': 22356.51,
                            'sendDurationUs': 15068.79,
                            'totalDurationUs': 398221.08,
                        },
                    },
                    'stepNum': 222,
                },
            ]
        },
        'runEnvironment': {
            'topology': {
                'xDimension': '2',
                'yDimension': '1',
            },
            'tpuType': 'TPU v2',
        },
    };
    /**
     * Mock data for data API with kernel_stats tag
     * @type {?}
     */
    var DATA_PLUGIN_PROFILE_KERNEL_STATS_DATA = [
        {
            'cols': [
                { 'id': 'rank', 'label': 'Rank', 'type': 'number' },
                { 'id': 'kernel_name', 'label': 'Kernel Name', 'type': 'string' },
                {
                    'id': 'registers_per_thread',
                    'label': 'Registers per thread',
                    'type': 'number'
                },
                { 'id': 'shmem_bytes', 'label': 'Shared Mem bytes', 'type': 'number' },
                { 'id': 'block_dim', 'label': 'Block dim', 'type': 'string' },
                { 'id': 'grid_dim', 'label': 'Grid dim', 'type': 'string' },
                { 'id': 'occupancy_pct', 'label': 'Occupancy %', 'type': 'number' },
                {
                    'id': 'is_op_tensor_core_eligible',
                    'label': 'Op is TensorCore eligible',
                    'type': 'boolean'
                },
                {
                    'id': 'is_kernel_using_tensor_core',
                    'label': 'Kernel uses TensorCore',
                    'type': 'boolean'
                },
                { 'id': 'op_name', 'label': 'Op Name', 'type': 'string' },
                { 'id': 'occurrences', 'label': 'Occurrences', 'type': 'number' },
                {
                    'id': 'total_duration_us',
                    'label': 'Total Duration (us)',
                    'type': 'number'
                },
                { 'id': 'avg_duration_us', 'label': 'Avg Duration (us)', 'type': 'number' },
                { 'id': 'min_duration_us', 'label': 'Min Duration (us)', 'type': 'number' },
                { 'id': 'max_duration_us', 'label': 'Max Duration (us)', 'type': 'number' },
            ],
            'rows': [
                {
                    'c': [
                        { 'v': 1 }, { 'v': 'volta_sgemm_64x64_nn' }, { 'v': 126 }, { 'v': 8448 },
                        { 'v': '64,1,1' }, { 'v': '4,1547,1' }, { 'v': 0 }, { 'v': true },
                        { 'v': false }, { 'v': 'model_1/dense/MatMul' }, { 'v': 520 },
                        { 'v': 473852.691 }, { 'v': 911.261 }, { 'v': 904.191 }, { 'v': 922.621 }
                    ]
                },
                {
                    'c': [
                        { 'v': 2 }, { 'v': 'volta_sgemm_32x128_nn' }, { 'v': 55 }, { 'v': 16384 },
                        { 'v': '256,1,1' }, { 'v': '4,774,1' }, { 'v': 0 }, { 'v': false },
                        { 'v': false }, { 'v': 'model_1/dense_1/MatMul' }, { 'v': 520 },
                        { 'v': 265960.752 }, { 'v': 511.462 }, { 'v': 505.852 }, { 'v': 519.17 }
                    ]
                },
                {
                    'c': [
                        { 'v': 3 }, {
                            'v': 'void tensorflow::BiasNHWCKernel(int, float const*, float co' +
                                'nst*, flot*, int)'
                        },
                        { 'v': 20 }, { 'v': 0 }, { 'v': '1024,1,1' }, { 'v': '80,1,1' }, { 'v': 0 },
                        { 'v': false }, { 'v': true }, { 'v': 'model_1/dense/BiasAdd' }, { 'v': 520 },
                        { 'v': 153061.981 }, { 'v': 294.352 }, { 'v': 289.791 }, { 'v': 302.082 }
                    ]
                },
                {
                    'c': [
                        { 'v': 4 }, {
                            'v': 'void Eigen::internal::EigenMetaKernel const, Eigen::array c' +
                                'onst, Eigen::TensorMap, 16, Eigen::MakePointer> >, Eigen::Te' +
                                'nsorMap, 16, Eigen::MakePointer> const> const, Eigen::GpuDev' +
                                'ice>, int>(Eigen::TensorEvaluator const, Eigen::array const,' +
                                ' Eigen::TensorMap, 16, Eigen::MakePointer> >, Eigen::TensorM' +
                                'ap, 16, Eigen::MakePointer> const> const, Eigen::GpuDevice>,' +
                                ' int)'
                        },
                        { 'v': 16 }, { 'v': 0 }, { 'v': '1024,1,1' }, { 'v': '160,1,1' }, { 'v': 0 },
                        { 'v': true }, { 'v': true }, { 'v': 'model_1/concatenate/concat' },
                        { 'v': 1040 }, { 'v': 142534.251 }, { 'v': 137.052 }, { 'v': 134.142 },
                        { 'v': 141.313 }
                    ]
                },
                {
                    'c': [
                        { 'v': 5 }, {
                            'v': 'void Eigen::internal::EigenMetaKernel, 16, Eigen::MakePoint' +
                                'er>, Eigen::TensorCwiseBinaryOp, Eigen::TensorMap, 16, Eigen' +
                                '::MakePointer> const, Eigen::TensorCwiseBinaryNullaryOp, Eig' +
                                'en::TensorMap, 16, Eigen::MakePointer> const> const> const> ' +
                                'const, Eigen::GpuDevice>, long>(Eigne::TensorEvaluator, 16, ' +
                                'Eigen::MakePointer>, Eigen::TensorCwiseBinaryOp, Eigen::Tens' +
                                'orMap, 16, Eigen::MakePointer> const, Eigen::TensorCwiseBina' +
                                'ryNullaryOp, Eigen::TensorMap, 16, Eigen::MakePointer> const' +
                                '> const> const> const, Eigen::GpuDevice>, long)'
                        },
                        { 'v': 26 }, { 'v': 0 }, { 'v': '1024,1,1' }, { 'v': '160,1,1' }, { 'v': 0 },
                        { 'v': false }, { 'v': false }, { 'v': 'model_1/dense/Relu' }, { 'v': 520 },
                        { 'v': 132006.561 }, { 'v': 253.861 }, { 'v': 250.881 }, { 'v': 258.051 }
                    ]
                },
                {
                    'c': [
                        { 'v': 6 }, {
                            'v': 'void tensorflow::GatherOpKernel(float const*, int const*, f' +
                                'loat*, long long, long long, long long, long long)'
                        },
                        { 'v': 22 }, { 'v': 0 }, { 'v': '1024,1,1' }, { 'v': '80,1,1' }, { 'v': 0 },
                        { 'v': true }, { 'v': true },
                        { 'v': 'model_1/embedding_user/embedding_lookup' }, { 'v': 520 },
                        { 'v': 128865.962 }, { 'v': 247.821 }, { 'v': 244.742 }, { 'v': 253.95 }
                    ]
                },
                {
                    'c': [
                        { 'v': 7 }, {
                            'v': 'void tensorflow::GatherOpKernel(float const*, int const*, f' +
                                'loat*, long long, long long, long long, long long)'
                        },
                        { 'v': 22 }, { 'v': 0 }, { 'v': '1024,1,1' }, { 'v': '80,1,1' }, { 'v': 0 },
                        { 'v': true }, { 'v': true },
                        { 'v': 'model_1/embedding_item/embedding_lookup' }, { 'v': 520 },
                        { 'v': 124522.141 }, { 'v': 239.461 }, { 'v': 236.542 }, { 'v': 247.811 }
                    ]
                },
                {
                    'c': [
                        { 'v': 8 }, {
                            'v': 'void tensorflow::BiasNHWCKernel(int, float const*, float co' +
                                'nst*, float*, int)'
                        },
                        { 'v': 20 }, { 'v': 0 }, { 'v': '1024,1,1' }, { 'v': '80,1,1' }, { 'v': 0 },
                        { 'v': true }, { 'v': false }, { 'v': 'model_1/dense_1/BiasAdd' },
                        { 'v': 520 }, { 'v': 76828.481 }, { 'v': 147.751 }, { 'v': 145.411 },
                        { 'v': 155.652 }
                    ]
                },
                {
                    'c': [
                        { 'v': 9 }, { 'v': 'volta_sgemm_32x128_nn' }, { 'v': 55 }, { 'v': 16384 },
                        { 'v': '256,1,1' }, { 'v': '2,774,1' }, { 'v': 0 }, { 'v': false },
                        { 'v': false }, { 'v': 'model_1/dense_2/MatMul' }, { 'v': 519 },
                        { 'v': 76154.662 }, { 'v': 146.731 }, { 'v': 144.382 }, { 'v': 148.481 }
                    ]
                },
                {
                    'c': [
                        { 'v': 10 }, {
                            'v': 'void Eigen::internal::EigenMetaKernel const, Eigen::array c' +
                                'onst, Eigen::TensorMap, 16, Eigen::MakePointer> >, Eigen::Te' +
                                'nsorMap, 16, Eigen::MakePointer> const> const, Eigen::GpuDev' +
                                'ice>, int>(Eigen::TensorEvaluator const, Eigen::array const,' +
                                ' Eigen::TensorMap, 16, Eigen::MakePointer> >, Eigen::TensorM' +
                                'ap, 16, Eigen::MakePointer> const> const, Eigen::GpuDevice>,' +
                                ' int)'
                        },
                        { 'v': 16 }, { 'v': 0 }, { 'v': '1024,1,1' }, { 'v': '160,1,1' }, { 'v': 0 },
                        { 'v': false }, { 'v': true }, { 'v': 'model_1/concatenate_1/concat' },
                        { 'v': 1038 }, { 'v': 73137.971 }, { 'v': 70.461 }, { 'v': 68.611 },
                        { 'v': 72.702 }
                    ]
                },
                {
                    'c': [
                        { 'v': 11 }, {
                            'v': 'void Eigen::internal::EigenMetaKernel, 16, Eigen::MakePoint' +
                                'er>, Eigen::TensorCwiseBinaryOp, Eigen::TensorMap, 16, Eigen' +
                                '::MakePointer> const, Eigen::TensorCwiseBinaryNullaryOp, Eig' +
                                'en::TensorMap, 16, Eigen::MakePointer> const> const> const> ' +
                                'const, Eigen::GpuDevice>, int>(Eigne::TensorEvaluator, 16, E' +
                                'igen::MakePointer>, Eigen::TensorCwiseBinaryOp, Eigen::Tenso' +
                                'rMap, 16, Eigen::MakePointer> const, Eigen::TensorCwiseBinar' +
                                'yNullaryOp, Eigen::TensorMap, 16, Eigen::MakePointer> const>' +
                                ' const> const> const, Eigen::GpuDevice>, int)'
                        },
                        { 'v': 16 }, { 'v': 0 }, { 'v': '1024,1,1' }, { 'v': '160,1,1' }, { 'v': 0 },
                        { 'v': false }, { 'v': false },
                        { 'v': 'model_1/embedding_user_mip/strided_slice' }, { 'v': 520 },
                        { 'v': 70798.131 }, { 'v': 136.151 }, { 'v': 133.121 }, { 'v': 148.482 }
                    ]
                },
                {
                    'c': [
                        { 'v': 12 }, {
                            'v': 'void Eigen::internal::EigenMetaKernel, 16, Eigen::MakePoint' +
                                'er>, Eigen::TensorCwiseBinaryOp, Eigen::TensorMap, 16, Eigen' +
                                '::MakePointer> const, Eigen::TensorCwiseBinaryNullaryOp, Eig' +
                                'en::TensorMap, 16, Eigen::MakePointer> const> const> const> ' +
                                'const, Eigen::GpuDevice>, int>(Eigne::TensorEvaluator, 16, E' +
                                'igen::MakePointer>, Eigen::TensorCwiseBinaryOp, Eigen::Tenso' +
                                'rMap, 16, Eigen::MakePointer> const, Eigen::TensorCwiseBinar' +
                                'yNullaryOp, Eigen::TensorMap, 16, Eigen::MakePointer> const>' +
                                ' const> const> const, Eigen::GpuDevice>, int)'
                        },
                        { 'v': 16 }, { 'v': 0 }, { 'v': '1024,1,1' }, { 'v': '160,1,1' }, { 'v': 0 },
                        { 'v': false }, { 'v': false },
                        { 'v': 'model_1/embedding_item_mip/strided_slice' }, { 'v': 520 },
                        { 'v': 70783.822 }, { 'v': 136.121 }, { 'v': 133.121 }, { 'v': 149.502 }
                    ]
                },
            ],
            'p': {},
        },
    ];
    /**
     * Mock data for data API with tf_data_bottleneck_analysis tag
     * @type {?}
     */
    var DATA_PLUGIN_PROFILE_TF_DATA_BOTTLENECK_ANALYSIS_DATA = [
        {
            'cols': [
                { 'id': 'host', 'label': 'Host', 'type': 'string' },
                { 'id': 'input_pipeline', 'label': 'Input Pipeline', 'type': 'string' },
                { 'id': 'rank', 'label': 'Rank', 'type': 'number' },
                { 'id': 'name', 'label': 'Name', 'type': 'string' },
                { 'id': 'parent', 'label': 'Parent', 'type': 'string' },
                { 'id': 'type', 'label': 'Type', 'type': 'number' }
            ],
            'rows': [
                {
                    'c': [
                        { 'v': 'oild3:25577' }, { 'v': 'Host:0' }, { 'v': 0 }, {
                            'v': '8657233632614672692',
                            'f': '\u003cdiv style\u003d\u0027padding: 1px;\u0027\u003e\u003cb\u003eModel\u003c/b\u003e\u003cbr/\u003e\u003cdiv style\u003d\u0027text-align: left;\u0027\u003eStart Time: 4,666,862 us\u003cbr/\u003eTotal Duration: 992,837 us\u003cbr/\u003eSelf Duration: 2 us\u003cbr/\u003e# Calls: 1\u003c/div\u003e\u003c/div\u003e'
                        },
                        { 'v': '' }, { 'v': 1 }
                    ]
                },
                {
                    'c': [
                        { 'v': 'oild3:25577' }, { 'v': 'Host:0' }, { 'v': 0 }, {
                            'v': '1204700340925195271',
                            'f': '\u003cdiv style\u003d\u0027padding: 1px;\u0027\u003e\u003cb\u003eMap\u003c/b\u003e\u003cbr/\u003e\u003cdiv style\u003d\u0027text-align: left;\u0027\u003eStart Time: 4,666,863 us\u003cbr/\u003eTotal Duration: 992,835 us\u003cbr/\u003eSelf Duration: 723,709 us\u003cbr/\u003e# Calls: 1\u003c/div\u003e\u003c/div\u003e'
                        },
                        { 'v': '8657233632614672692' }, { 'v': 2 }
                    ]
                },
                {
                    'c': [
                        { 'v': 'oild3:25577' }, { 'v': 'Host:0' }, { 'v': 0 }, {
                            'v': '7987410324060857182',
                            'f': '\u003cdiv style\u003d\u0027padding: 1px;\u0027\u003e\u003cb\u003ePrefetch\u003c/b\u003e\u003cbr/\u003e\u003cdiv style\u003d\u0027text-align: left;\u0027\u003eStart Time: 4,666,865 us\u003cbr/\u003eTotal Duration: 269,126 us\u003cbr/\u003eSelf Duration: 269,126 us\u003cbr/\u003e# Calls: 1\u003c/div\u003e\u003c/div\u003e'
                        },
                        { 'v': '1204700340925195271' }, { 'v': 1 }
                    ]
                },
                {
                    'c': [
                        { 'v': 'oild3:25577' }, { 'v': 'Host:0' }, { 'v': 1 }, {
                            'v': '7987410324060857182',
                            'f': '\u003cdiv style\u003d\u0027padding: 1px;\u0027\u003e\u003cb\u003ePrefetch\u003c/b\u003e\u003cbr/\u003e\u003cdiv style\u003d\u0027text-align: left;\u0027\u003eStart Time: 733,397 us\u003cbr/\u003eTotal Duration: 4 us\u003cbr/\u003eSelf Duration: 4 us\u003cbr/\u003e# Calls: 1\u003c/div\u003e\u003c/div\u003e'
                        },
                        { 'v': '1204700340925195271' }, { 'v': 1 }
                    ]
                },
                {
                    'c': [
                        { 'v': 'oild3:25577' }, { 'v': 'Host:0' }, { 'v': 1 }, {
                            'v': '1204700340925195271',
                            'f': '\u003cdiv style\u003d\u0027padding: 1px;\u0027\u003e\u003cb\u003eMap\u003c/b\u003e\u003cbr/\u003e\u003cdiv style\u003d\u0027text-align: left;\u0027\u003eStart Time: 733,392 us\u003cbr/\u003eTotal Duration: 852,132 us\u003cbr/\u003eSelf Duration: 852,127 us\u003cbr/\u003e# Calls: 1\u003c/div\u003e\u003c/div\u003e'
                        },
                        { 'v': '8657233632614672692' }, { 'v': 2 }
                    ]
                },
                {
                    'c': [
                        { 'v': 'oild3:25577' }, { 'v': 'Host:0' }, { 'v': 1 }, {
                            'v': '8657233632614672692',
                            'f': '\u003cdiv style\u003d\u0027padding: 1px;\u0027\u003e\u003cb\u003eModel\u003c/b\u003e\u003cbr/\u003e\u003cdiv style\u003d\u0027text-align: left;\u0027\u003eStart Time: 733,391 us\u003cbr/\u003eTotal Duration: 852,134 us\u003cbr/\u003eSelf Duration: 2 us\u003cbr/\u003e# Calls: 1\u003c/div\u003e\u003c/div\u003e'
                        },
                        { 'v': '' }, { 'v': 1 }
                    ]
                },
                {
                    'c': [
                        { 'v': 'oild3:25577' }, { 'v': 'Host:0' }, { 'v': 2 }, {
                            'v': '1204700340925195271',
                            'f': '\u003cdiv style\u003d\u0027padding: 1px;\u0027\u003e\u003cb\u003eMap\u003c/b\u003e\u003cbr/\u003e\u003cdiv style\u003d\u0027text-align: left;\u0027\u003eStart Time: 6,940,733 us\u003cbr/\u003eTotal Duration: 833,329 us\u003cbr/\u003eSelf Duration: 833,323 us\u003cbr/\u003e# Calls: 1\u003c/div\u003e\u003c/div\u003e'
                        },
                        { 'v': '8657233632614672692' }, { 'v': 2 }
                    ]
                },
                {
                    'c': [
                        { 'v': 'oild3:25577' }, { 'v': 'Host:0' }, { 'v': 2 }, {
                            'v': '8657233632614672692',
                            'f': '\u003cdiv style\u003d\u0027padding: 1px;\u0027\u003e\u003cb\u003eModel\u003c/b\u003e\u003cbr/\u003e\u003cdiv style\u003d\u0027text-align: left;\u0027\u003eStart Time: 6,940,731 us\u003cbr/\u003eTotal Duration: 833,331 us\u003cbr/\u003eSelf Duration: 2 us\u003cbr/\u003e# Calls: 1\u003c/div\u003e\u003c/div\u003e'
                        },
                        { 'v': '' }, { 'v': 1 }
                    ]
                },
                {
                    'c': [
                        { 'v': 'oild3:25577' }, { 'v': 'Host:0' }, { 'v': 2 }, {
                            'v': '7987410324060857182',
                            'f': '\u003cdiv style\u003d\u0027padding: 1px;\u0027\u003e\u003cb\u003ePrefetch\u003c/b\u003e\u003cbr/\u003e\u003cdiv style\u003d\u0027text-align: left;\u0027\u003eStart Time: 6,940,738 us\u003cbr/\u003eTotal Duration: 5 us\u003cbr/\u003eSelf Duration: 5 us\u003cbr/\u003e# Calls: 1\u003c/div\u003e\u003c/div\u003e'
                        },
                        { 'v': '1204700340925195271' }, { 'v': 1 }
                    ]
                },
                {
                    'c': [
                        { 'v': 'oild3:25577' }, { 'v': 'Host:0' }, { 'v': 3 }, {
                            'v': '1204700340925195271',
                            'f': '\u003cdiv style\u003d\u0027padding: 1px;\u0027\u003e\u003cb\u003eMap\u003c/b\u003e\u003cbr/\u003e\u003cdiv style\u003d\u0027text-align: left;\u0027\u003eStart Time: 2,458,588 us\u003cbr/\u003eTotal Duration: 798,433 us\u003cbr/\u003eSelf Duration: 798,429 us\u003cbr/\u003e# Calls: 1\u003c/div\u003e\u003c/div\u003e'
                        },
                        { 'v': '8657233632614672692' }, { 'v': 2 }
                    ]
                },
                {
                    'c': [
                        { 'v': 'oild3:25577' }, { 'v': 'Host:0' }, { 'v': 3 }, {
                            'v': '8657233632614672692',
                            'f': '\u003cdiv style\u003d\u0027padding: 1px;\u0027\u003e\u003cb\u003eModel\u003c/b\u003e\u003cbr/\u003e\u003cdiv style\u003d\u0027text-align: left;\u0027\u003eStart Time: 2,458,587 us\u003cbr/\u003eTotal Duration: 798,437 us\u003cbr/\u003eSelf Duration: 3 us\u003cbr/\u003e# Calls: 1\u003c/div\u003e\u003c/div\u003e'
                        },
                        { 'v': '' }, { 'v': 1 }
                    ]
                },
                {
                    'c': [
                        { 'v': 'oild3:25577' }, { 'v': 'Host:0' }, { 'v': 3 }, {
                            'v': '7987410324060857182',
                            'f': '\u003cdiv style\u003d\u0027padding: 1px;\u0027\u003e\u003cb\u003ePrefetch\u003c/b\u003e\u003cbr/\u003e\u003cdiv style\u003d\u0027text-align: left;\u0027\u003eStart Time: 2,458,594 us\u003cbr/\u003eTotal Duration: 4 us\u003cbr/\u003eSelf Duration: 4 us\u003cbr/\u003e# Calls: 1\u003c/div\u003e\u003c/div\u003e'
                        },
                        { 'v': '1204700340925195271' }, { 'v': 1 }
                    ]
                },
                {
                    'c': [
                        { 'v': 'oild3:25577' }, { 'v': 'Host:0' }, { 'v': 4 }, {
                            'v': '1204700340925195271',
                            'f': '\u003cdiv style\u003d\u0027padding: 1px;\u0027\u003e\u003cb\u003eMap\u003c/b\u003e\u003cbr/\u003e\u003cdiv style\u003d\u0027text-align: left;\u0027\u003eStart Time: 9,857,056 us\u003cbr/\u003eTotal Duration: 139,103 us\u003cbr/\u003eSelf Duration: 139,099 us\u003cbr/\u003e# Calls: 1\u003c/div\u003e\u003c/div\u003e'
                        },
                        { 'v': '8657233632614672692' }, { 'v': 2 }
                    ]
                },
                {
                    'c': [
                        { 'v': 'oild3:25577' }, { 'v': 'Host:0' }, { 'v': 4 }, {
                            'v': '8657233632614672692',
                            'f': '\u003cdiv style\u003d\u0027padding: 1px;\u0027\u003e\u003cb\u003eModel\u003c/b\u003e\u003cbr/\u003e\u003cdiv style\u003d\u0027text-align: left;\u0027\u003eStart Time: 9,857,055 us\u003cbr/\u003eTotal Duration: 139,106 us\u003cbr/\u003eSelf Duration: 2 us\u003cbr/\u003e# Calls: 1\u003c/div\u003e\u003c/div\u003e'
                        },
                        { 'v': '' }, { 'v': 1 }
                    ]
                },
                {
                    'c': [
                        { 'v': 'oild3:25577' }, { 'v': 'Host:0' }, { 'v': 4 }, {
                            'v': '7987410324060857182',
                            'f': '\u003cdiv style\u003d\u0027padding: 1px;\u0027\u003e\u003cb\u003ePrefetch\u003c/b\u003e\u003cbr/\u003e\u003cdiv style\u003d\u0027text-align: left;\u0027\u003eStart Time: 9,857,061 us\u003cbr/\u003eTotal Duration: 4 us\u003cbr/\u003eSelf Duration: 4 us\u003cbr/\u003e# Calls: 1\u003c/div\u003e\u003c/div\u003e'
                        },
                        { 'v': '1204700340925195271' }, { 'v': 1 }
                    ]
                },
                {
                    'c': [
                        { 'v': 'oild3:25577' }, { 'v': 'Host:0' }, { 'v': 5 }, {
                            'v': '1204700340925195271',
                            'f': '\u003cdiv style\u003d\u0027padding: 1px;\u0027\u003e\u003cb\u003eMap\u003c/b\u003e\u003cbr/\u003e\u003cdiv style\u003d\u0027text-align: left;\u0027\u003eStart Time: 4,024,899 us\u003cbr/\u003eTotal Duration: 55,780 us\u003cbr/\u003eSelf Duration: 55,776 us\u003cbr/\u003e# Calls: 1\u003c/div\u003e\u003c/div\u003e'
                        },
                        { 'v': '8657233632614672692' }, { 'v': 2 }
                    ]
                },
                {
                    'c': [
                        { 'v': 'oild3:25577' }, { 'v': 'Host:0' }, { 'v': 5 }, {
                            'v': '7987410324060857182',
                            'f': '\u003cdiv style\u003d\u0027padding: 1px;\u0027\u003e\u003cb\u003ePrefetch\u003c/b\u003e\u003cbr/\u003e\u003cdiv style\u003d\u0027text-align: left;\u0027\u003eStart Time: 4,024,904 us\u003cbr/\u003eTotal Duration: 4 us\u003cbr/\u003eSelf Duration: 4 us\u003cbr/\u003e# Calls: 1\u003c/div\u003e\u003c/div\u003e'
                        },
                        { 'v': '1204700340925195271' }, { 'v': 1 }
                    ]
                },
                {
                    'c': [
                        { 'v': 'oild3:25577' }, { 'v': 'Host:0' }, { 'v': 5 }, {
                            'v': '8657233632614672692',
                            'f': '\u003cdiv style\u003d\u0027padding: 1px;\u0027\u003e\u003cb\u003eModel\u003c/b\u003e\u003cbr/\u003e\u003cdiv style\u003d\u0027text-align: left;\u0027\u003eStart Time: 4,024,898 us\u003cbr/\u003eTotal Duration: 55,783 us\u003cbr/\u003eSelf Duration: 2 us\u003cbr/\u003e# Calls: 1\u003c/div\u003e\u003c/div\u003e'
                        },
                        { 'v': '' }, { 'v': 1 }
                    ]
                }
            ]
        },
        {
            'cols': [
                { 'id': 'host', 'label': 'Host', 'type': 'string' },
                { 'id': 'input_pipeline', 'label': 'Input Pipeline', 'type': 'string' },
                { 'id': 'min', 'label': 'Min (us)', 'type': 'number' },
                { 'id': 'mean', 'label': 'Avg (us)', 'type': 'number' },
                { 'id': 'max', 'label': 'Max (us)', 'type': 'number' },
                { 'id': 'num_calls', 'label': '# calls', 'type': 'number' },
                { 'id': 'num_slow_calls', 'label': '# slow calls', 'type': 'number' }
            ],
            'rows': [{
                    'c': [
                        { 'v': 'oild3:25577' }, { 'v': 'Host:0' }, { 'v': 55783 }, { 'v': 611938 },
                        { 'v': 992837 }, { 'v': 6 }, { 'v': 6 }
                    ]
                }]
        },
        {
            'cols': [
                { 'id': 'host', 'label': 'Host', 'type': 'string' },
                { 'id': 'input_pipeline', 'label': 'Input Pipeline', 'type': 'string' },
                { 'id': 'max_latency', 'label': 'Max Latency (us)', 'type': 'number' },
                { 'id': 'bottleneck', 'label': 'Bottleneck', 'type': 'string' },
                { 'id': 'suggestion', 'label': 'Suggestion', 'type': 'string' }
            ],
            'rows': [{
                    'c': [
                        { 'v': 'oild3:25577' }, { 'v': 'Host:0' }, { 'v': 992837 }, {
                            'v': 'Map',
                            'f': '\u003cu\u003eIterator Type\u003c/u\u003e: \u003cb\u003eMap\u003c/b\u003e\u003cbr/\u003e\u003cu\u003eLong Name\u003c/u\u003e: Iterator::Model::Map'
                        },
                        { 'v': 'suggestion', 'f': 'mock suggestion' }
                    ]
                }],
            'p': { 'is_input_bound': 'true', 'summary_message': 'mock summary' }
        }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Delay time for milisecond for testing
     * @type {?}
     */
    var DELAY_TIME_MS = 1000;
    /**
     * The data service class that calls API and return response.
     */
    var DataService = /** @class */ (function () {
        /**
         * @param {?} httpClient
         * @param {?} platformLocation
         */
        function DataService(httpClient, platformLocation) {
            this.httpClient = httpClient;
            this.isLocalDevelopment = false;
            this.pathPrefix = '';
            this.isLocalDevelopment = platformLocation.pathname === LOCAL_URL;
            if (String(platformLocation.pathname).includes(API_PREFIX + PLUGIN_NAME)) {
                this.pathPrefix =
                    String(platformLocation.pathname).split(API_PREFIX + PLUGIN_NAME)[0];
            }
        }
        /**
         * @param {?} options
         * @return {?}
         */
        DataService.prototype.captureProfile = function (options) {
            if (this.isLocalDevelopment) {
                return of({ result: 'Done' });
            }
            /** @type {?} */
            var params = new HttpParams()
                .set('service_addr', options.serviceAddr)
                .set('is_tpu_name', options.isTpuName.toString())
                .set('duration', options.duration.toString())
                .set('num_retry', options.numRetry.toString())
                .set('worker_list', options.workerList)
                .set('host_tracer_level', options.hostTracerLevel.toString())
                .set('device_tracer_level', options.deviceTracerLevel.toString())
                .set('python_tracer_level', options.pythonTracerLevel.toString())
                .set('delay', options.delay.toString());
            return this.httpClient.get(this.pathPrefix + CAPTURE_PROFILE_API, { params: params });
        };
        /**
         * @return {?}
         */
        DataService.prototype.getTools = function () {
            if (this.isLocalDevelopment) {
                return of(DATA_PLUGIN_PROFILE_TOOLS);
            }
            return this.httpClient.get(this.pathPrefix + TOOLS_API);
        };
        /**
         * @param {?} run
         * @param {?} tag
         * @return {?}
         */
        DataService.prototype.getHosts = function (run, tag) {
            if (this.isLocalDevelopment) {
                return of(DATA_PLUGIN_PROFILE_HOSTS).pipe(delay(DELAY_TIME_MS));
            }
            /** @type {?} */
            var params = new HttpParams().set('run', run).set('tag', tag);
            return this.httpClient.get(this.pathPrefix + HOSTS_API, { params: params });
        };
        /**
         * @param {?} run
         * @param {?} tag
         * @param {?} host
         * @return {?}
         */
        DataService.prototype.getData = function (run, tag, host) {
            if (this.isLocalDevelopment) {
                if (tag.startsWith('overview_page')) {
                    return of(DATA_PLUGIN_PROFILE_OVERVIEW_PAGE_DATA)
                        .pipe(delay(DELAY_TIME_MS));
                }
                else if (tag.startsWith('input_pipeline_analyzer')) {
                    return of(DATA_PLUGIN_PROFILE_INPUT_PIPELINE_DATA)
                        .pipe(delay(DELAY_TIME_MS));
                }
                else if (tag.startsWith('tensorflow_stats')) {
                    return of(DATA_PLUGIN_PROFILE_TENSORFLOW_STATS_DATA)
                        .pipe(delay(DELAY_TIME_MS));
                }
                else if (tag.startsWith('memory_viewer')) {
                    return of(DATA_PLUGIN_PROFILE_MEMORY_VIEWER_DATA)
                        .pipe(delay(DELAY_TIME_MS));
                }
                else if (tag.startsWith('op_profile')) {
                    return of(DATA_PLUGIN_PROFILE_OP_PROFILE_DATA)
                        .pipe(delay(DELAY_TIME_MS));
                }
                else if (tag.startsWith('pod_viewer')) {
                    return of(DATA_PLUGIN_PROFILE_POD_VIEWER_DATA)
                        .pipe(delay(DELAY_TIME_MS));
                }
                else if (tag.startsWith('kernel_stats')) {
                    return of(DATA_PLUGIN_PROFILE_KERNEL_STATS_DATA)
                        .pipe(delay(DELAY_TIME_MS));
                }
                else if (tag.startsWith('memory_profile')) {
                    return of(DATA_PLUGIN_PROFILE_MEMORY_PROFILE_DATA)
                        .pipe(delay(DELAY_TIME_MS));
                }
                else if (tag.startsWith('tf_data_bottleneck_analysis')) {
                    return of(DATA_PLUGIN_PROFILE_TF_DATA_BOTTLENECK_ANALYSIS_DATA)
                        .pipe(delay(DELAY_TIME_MS));
                }
                else {
                    return of([]).pipe(delay(DELAY_TIME_MS));
                }
            }
            /** @type {?} */
            var params = new HttpParams().set('run', run).set('tag', tag).set('host', host);
            return ( /** @type {?} */(this.httpClient.get(this.pathPrefix + DATA_API, { params: params })));
        };
        /**
         * @param {?} run
         * @param {?} tag
         * @param {?} host
         * @return {?}
         */
        DataService.prototype.exportDataAsCSV = function (run, tag, host) {
            /** @type {?} */
            var params = new HttpParams()
                .set('run', run)
                .set('tag', tag)
                .set('host', host)
                .set('tqx', 'out:csv;');
            window.open(this.pathPrefix + DATA_API + '?' + params.toString(), '_blank');
        };
        return DataService;
    }());
    DataService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    DataService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: PlatformLocation }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Action to set active heap object
     * @type {?}
     */
    var setActiveHeapObjectAction = createAction('[Heap object] Set active heap object', props());
    /**
     * Action to set active op profile node
     * @type {?}
     */
    var setActiveOpProfileNodeAction = createAction('[Op Profile Node] Set active op profile node', props());
    /**
     * Action to set active info of the pod viewer
     * @type {?}
     */
    var setActivePodViewerInfoAction = createAction('[Pod Viewer Info] Set active pod viewer info', props());
    /**
     * Action to set capturing profile
     * @type {?}
     */
    var setCapturingProfileAction = createAction('[App State] Set capturing profile', props());
    /**
     * Action to set loading state
     * @type {?}
     */
    var setLoadingStateAction = createAction('[App State] Set loading state', props());
    /**
     * Action to set current tool state
     * @type {?}
     */
    var setCurrentToolStateAction = createAction('[App State] Set current tool state', props());
    /**
     * Action to set request data state
     * @type {?}
     */
    var setDataRequestStateAction = createAction('[App State] Set request data state', props());
    /**
     * Action to clear export_as_csv state
     * @type {?}
     */
    var clearExportAsCsvStateAction = createAction('[App State] Clear export_as_csv state');
    /**
     * Action to set export_as_csv state
     * @type {?}
     */
    var setExportAsCsvStateAction = createAction('[App State] Set export_as_csv state', props());
    /**
     * Action to set error message state
     * @type {?}
     */
    var setErrorMessageStateAction = createAction('[App State] Set error message state', props());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Initial state of active heap object
     * @type {?}
     */
    var INIT_ACTIVE_HEAP_OBJECT_STATE = null;
    /**
     * Initial state object
     * @type {?}
     */
    var INIT_MEMORY_VIEWER_STATE = {
        activeHeapObject: INIT_ACTIVE_HEAP_OBJECT_STATE,
    };
    /**
     * Initial state of active op profile node
     * @type {?}
     */
    var INIT_ACTIVE_OP_PROFILE_NODE_STATE = null;
    /**
     * Initial state of op profile
     * @type {?}
     */
    var INIT_OP_PROFILE_STATE = {
        activeOpProfileNode: INIT_ACTIVE_OP_PROFILE_NODE_STATE,
    };
    /**
     * Initial state of active pod viewer info
     * @type {?}
     */
    var INIT_ACTIVE_POD_VIEWER_INFO_STATE = null;
    /**
     * Initial state of pod viewer
     * @type {?}
     */
    var INIT_POD_VIEWER_STATE = {
        activePodViewerInfo: INIT_ACTIVE_POD_VIEWER_INFO_STATE,
    };
    /**
     * Initial state of capturing profile
     * @type {?}
     */
    var INIT_CAPTURING_PROFILE_STATE = false;
    /**
     * Initial state of loading
     * @type {?}
     */
    var INIT_LOADING_STATE = {
        loading: false,
        message: '',
    };
    /**
     * Initial state of current tool
     * @type {?}
     */
    var INIT_CURRENT_TOOL_STATE = '';
    /**
     * Initial state of request data
     * @type {?}
     */
    var INIT_REQUEST_DATA_STATE = {
        type: 0 /* UNKNOWN */,
        params: {},
    };
    /**
     * Initial state of export_as_csv
     * @type {?}
     */
    var INIT_EXPORT_AS_CSV_STATE = '';
    /**
     * Initial state of error message
     * @type {?}
     */
    var INIT_ERROR_MESSAGE_STATE = '';
    /**
     * Initial state object
     * @type {?}
     */
    var INIT_APP_STATE = {
        memoryViewerState: INIT_MEMORY_VIEWER_STATE,
        opProfileState: INIT_OP_PROFILE_STATE,
        podViewerState: INIT_POD_VIEWER_STATE,
        capturingProfile: INIT_CAPTURING_PROFILE_STATE,
        loadingState: INIT_LOADING_STATE,
        currentTool: INIT_CURRENT_TOOL_STATE,
        dataRequest: INIT_REQUEST_DATA_STATE,
        exportAsCsv: INIT_EXPORT_AS_CSV_STATE,
        errorMessage: INIT_ERROR_MESSAGE_STATE,
    };
    /**
     * Feature key for store
     * @type {?}
     */
    var STORE_KEY = 'root';
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var appState = createFeatureSelector(STORE_KEY);
    var ɵ0$c = /**
     * @param {?} appState
     * @return {?}
     */ function (appState) { return appState.memoryViewerState; };
    /**
     * Selector for MemoryViewerState
     * @type {?}
     */
    var getMemoryViewerState = createSelector(appState, (ɵ0$c));
    var ɵ1$7 = /**
     * @param {?} memoryViewerState
     * @return {?}
     */ function (memoryViewerState) { return memoryViewerState.activeHeapObject; };
    /**
     * Selector for ActiveHeapObjectState
     * @type {?}
     */
    var getActiveHeapObjectState = createSelector(getMemoryViewerState, (ɵ1$7));
    var ɵ2$3 = /**
     * @param {?} appState
     * @return {?}
     */ function (appState) { return appState.opProfileState; };
    /**
     * Selector for OpProfileState
     * @type {?}
     */
    var getOpProfileState = createSelector(appState, (ɵ2$3));
    var ɵ3$2 = /**
     * @param {?} opProfileState
     * @return {?}
     */ function (opProfileState) { return opProfileState.activeOpProfileNode; };
    /**
     * Selector for ActiveOpProfileNodeState
     * @type {?}
     */
    var getActiveOpProfileNodeState = createSelector(getOpProfileState, (ɵ3$2));
    var ɵ4$1 = /**
     * @param {?} appState
     * @return {?}
     */ function (appState) { return appState.podViewerState; };
    /**
     * Selector for PodViewerState
     * @type {?}
     */
    var getPodViewerState = createSelector(appState, (ɵ4$1));
    var ɵ5$1 = /**
     * @param {?} podViewerState
     * @return {?}
     */ function (podViewerState) { return podViewerState.activePodViewerInfo; };
    /**
     * Selector for ActivePodViewerInfoState
     * @type {?}
     */
    var getActivePodViewerInfoState = createSelector(getPodViewerState, (ɵ5$1));
    var ɵ6$1 = /**
     * @param {?} appState
     * @return {?}
     */ function (appState) { return appState.capturingProfile; };
    /**
     * Selector for CapturingProfileState
     * @type {?}
     */
    var getCapturingProfileState = createSelector(appState, (ɵ6$1));
    var ɵ7$1 = /**
     * @param {?} appState
     * @return {?}
     */ function (appState) { return appState.loadingState; };
    /**
     * Selector for LoadingState
     * @type {?}
     */
    var getLoadingState = createSelector(appState, (ɵ7$1));
    var ɵ8$1 = /**
     * @param {?} appState
     * @return {?}
     */ function (appState) { return appState.currentTool; };
    /**
     * Selector for CurrentTool
     * @type {?}
     */
    var getCurrentTool = createSelector(appState, (ɵ8$1));
    var ɵ9$1 = /**
     * @param {?} appState
     * @return {?}
     */ function (appState) { return appState.dataRequest; };
    /**
     * Selector for DataRequestType
     * @type {?}
     */
    var getDataRequest = createSelector(appState, (ɵ9$1));
    var ɵ10 = /**
     * @param {?} appState
     * @return {?}
     */ function (appState) { return appState.exportAsCsv; };
    /**
     * Selector for ExportAsCsv
     * @type {?}
     */
    var getExportAsCsv = createSelector(appState, (ɵ10));
    var ɵ11 = /**
     * @param {?} appState
     * @return {?}
     */ function (appState) { return appState.errorMessage; };
    /**
     * Selector for ErrorMessage
     * @type {?}
     */
    var getErrorMessage = createSelector(appState, (ɵ11));
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A capture profile dialog component.
     */
    var CaptureProfileDialog = /** @class */ (function () {
        /**
         * @param {?} dialogRef
         */
        function CaptureProfileDialog(dialogRef) {
            this.dialogRef = dialogRef;
            this.captureButtonLabel = 'Capture';
            this.closeButtonLabel = 'Close';
            this.serviceAddr = '';
            this.isTpuName = false;
            this.addressType = 'ip';
            this.duration = 1000;
            this.numRetry = 3;
            this.workerList = '';
            this.hostTracerLevel = '2';
            this.hostTracerTooltip = 'lower trace level to reduce amount of host traces ' +
                'collected, some tools will not function well when the host tracer ' +
                'level is less than info';
            this.deviceTracerLevel = '1';
            this.pythonTracerLevel = '0';
            this.delay = 0;
        }
        /**
         * @param {?} value
         * @return {?}
         */
        CaptureProfileDialog.prototype.addressTypeChanged = function (value) {
            this.isTpuName = value === 'tpu';
        };
        /**
         * @param {?} value
         * @return {?}
         */
        CaptureProfileDialog.prototype.serviceAddrChanged = function (value) {
            this.serviceAddr = value.trim();
        };
        /**
         * @return {?}
         */
        CaptureProfileDialog.prototype.captureProfile = function () {
            this.dialogRef.close({
                serviceAddr: this.serviceAddr,
                isTpuName: this.isTpuName,
                duration: this.duration,
                numRetry: this.numRetry,
                workerList: this.workerList,
                hostTracerLevel: Number(this.hostTracerLevel),
                deviceTracerLevel: Number(this.deviceTracerLevel),
                pythonTracerLevel: Number(this.pythonTracerLevel),
                delay: this.delay,
            });
        };
        /**
         * @return {?}
         */
        CaptureProfileDialog.prototype.close = function () {
            this.dialogRef.close();
        };
        return CaptureProfileDialog;
    }());
    CaptureProfileDialog.decorators = [
        { type: Component, args: [{
                    selector: 'capture-profile-dialog',
                    template: "<mat-dialog-content>\n  <div>\n    <mat-form-field>\n      <mat-label>Profile Service URL(s) or TPU name</mat-label>\n      <input\n        matInput\n        placeholder=\"localhost:6009,localhost:6010\"\n        required\n        [(ngModel)]=\"serviceAddr\"\n        (ngModelChange)=\"serviceAddrChanged($event)\"\n      />\n    </mat-form-field>\n  </div>\n\n  <div>\n    <mat-radio-group\n      aria-label=\"address type\"\n      i18n-aria-label=\"Radio buttons to select address type\"\n      [(ngModel)]=\"addressType\"\n      (ngModelChange)=\"addressTypeChanged($event)\"\n    >\n      Address Type:\n      <mat-radio-button value=\"ip\">IP Address</mat-radio-button>\n      <mat-radio-button value=\"tpu\">TPU Name</mat-radio-button>\n    </mat-radio-group>\n  </div>\n\n  <br />\n\n  <div>\n    <mat-form-field>\n      <input\n        matInput\n        type=\"number\"\n        placeholder=\"Profiling Duration (milliseconds)\"\n        [(ngModel)]=\"duration\"\n      />\n    </mat-form-field>\n  </div>\n\n  <div>\n    <mat-form-field>\n      <mat-label>Host Trace (TraceMe) Level</mat-label>\n      <mat-select\n        matTooltip=\"{{ hostTracerTooltip }}\"\n        matTooltipPosition=\"above\"\n        [(ngModel)]=\"hostTracerLevel\"\n      >\n        <mat-option value=\"0\">disable</mat-option>\n        <mat-option value=\"1\">critical</mat-option>\n        <mat-option value=\"2\">info</mat-option>\n        <mat-option value=\"3\">verbose</mat-option>\n      </mat-select>\n    </mat-form-field>\n  </div>\n\n  <div>\n    <mat-form-field>\n      <mat-label>Device Trace Level</mat-label>\n      <mat-select [(ngModel)]=\"deviceTracerLevel\">\n        <mat-option value=\"0\">disable</mat-option>\n        <mat-option value=\"1\">enable</mat-option>\n      </mat-select>\n    </mat-form-field>\n  </div>\n\n  <div>\n    <mat-form-field>\n      <mat-label>Python Trace Level</mat-label>\n      <mat-select [(ngModel)]=\"pythonTracerLevel\">\n        <mat-option value=\"0\">disable</mat-option>\n        <mat-option value=\"1\">enable</mat-option>\n      </mat-select>\n    </mat-form-field>\n  </div>\n\n  <div [hidden]=\"!isTpuName\">\n    <div>\n      <mat-form-field>\n        <mat-label>Subset of worker TPUs to profile (optional)</mat-label>\n        <input\n          matInput\n          placeholder=\"List of IPs, e.g. 10.4.1.2:8466,10.4.1.3:8466\"\n          [(ngModel)]=\"workerList\"\n        />\n      </mat-form-field>\n    </div>\n  </div>\n\n  <div>\n    <mat-expansion-panel class=\"mat-elevation-z0\">\n      <mat-expansion-panel-header>\n        <mat-panel-title>\n          Advanced options\n        </mat-panel-title>\n      </mat-expansion-panel-header>\n\n      <div>\n        <mat-form-field>\n          <input\n            matInput\n            type=\"number\"\n            placeholder=\"Automatically retry N times when no trace event is collected\"\n            [(ngModel)]=\"numRetry\"\n          />\n        </mat-form-field>\n      </div>\n\n      <div>\n        <mat-form-field>\n          <input\n            matInput\n            type=\"number\"\n            placeholder=\"Delay the start of profiling (milliseconds)\"\n            [(ngModel)]=\"delay\"\n          />\n        </mat-form-field>\n      </div>\n    </mat-expansion-panel>\n  </div>\n</mat-dialog-content>\n\n<mat-dialog-actions>\n  <button mat-raised-button [disabled]=\"!serviceAddr\" (click)=\"captureProfile()\">\n    {{ captureButtonLabel | uppercase }}\n  </button>\n  <button mat-raised-button (click)=\"close()\">\n    {{ closeButtonLabel | uppercase }}\n  </button>\n</mat-dialog-actions>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}mat-expansion-panel{width:400px}.mat-expansion-panel-header{padding:0 5px 0 0}mat-form-field{width:400px}mat-radio-button{margin-left:20px}mat-dialog-actions{justify-content:flex-end}.mat-raised-button{box-shadow:none;border:1px solid #000}\n"]
                }] }
    ];
    /** @nocollapse */
    CaptureProfileDialog.ctorParameters = function () { return [
        { type: MatDialogRef }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var DELAY_TIME_MS$1 = 1000;
    /**
     * A capture profile view component.
     */
    var CaptureProfile = /** @class */ (function () {
        /**
         * @param {?} dialog
         * @param {?} snackBar
         * @param {?} dataService
         * @param {?} store
         */
        function CaptureProfile(dialog, snackBar, dataService, store) {
            this.dialog = dialog;
            this.snackBar = snackBar;
            this.dataService = dataService;
            this.store = store;
            this.captureButtonLabel = 'Capture Profile';
            /**
             * Handles on-destroy Subject, used to unsubscribe.
             */
            this.destroyed = new ReplaySubject(1);
            this.capturingProfile = this.store.select(getCapturingProfileState);
        }
        /**
         * @private
         * @param {?} message
         * @return {?}
         */
        CaptureProfile.prototype.openSnackBar = function (message) {
            this.snackBar.open(message, 'Close now!', { duration: 5000 });
        };
        /**
         * @return {?}
         */
        CaptureProfile.prototype.openDialog = function () {
            var _this = this;
            this.dialog.open(CaptureProfileDialog)
                .afterClosed()
                .pipe(takeUntil(this.destroyed))
                .subscribe(( /**
         * @param {?} options
         * @return {?}
         */function (options) {
                if (!options) {
                    return;
                }
                _this.store.dispatch(setCapturingProfileAction({ capturingProfile: true }));
                _this.dataService.captureProfile(( /** @type {?} */(options)))
                    .pipe(takeUntil(_this.destroyed))
                    .subscribe(( /**
             * @param {?} response
             * @return {?}
             */function (response) {
                    _this.store.dispatch(setCapturingProfileAction({ capturingProfile: false }));
                    if (!response) {
                        return;
                    }
                    if (response.error) {
                        _this.openSnackBar('Failed to capture profile: ' + response.error);
                        return;
                    }
                    if (response.result) {
                        _this.openSnackBar(response.result);
                        setTimeout(( /**
                         * @return {?}
                         */function () {
                            document.dispatchEvent(new Event('plugin-reload'));
                        }), DELAY_TIME_MS$1);
                    }
                }), ( /**
                 * @param {?} error
                 * @return {?}
                 */function (/**
                 * @param {?} error
                 * @return {?}
                 */ error) {
                    _this.store.dispatch(setCapturingProfileAction({ capturingProfile: false }));
                    /** @type {?} */
                    var errorMessage = error && error.toString() ? error.toString() : '';
                    _this.openSnackBar('Failed to capture profile: ' + errorMessage);
                }));
            }));
        };
        /**
         * @return {?}
         */
        CaptureProfile.prototype.ngOnDestroy = function () {
            // Unsubscribes all pending subscriptions.
            this.destroyed.next();
            this.destroyed.complete();
        };
        return CaptureProfile;
    }());
    CaptureProfile.decorators = [
        { type: Component, args: [{
                    selector: 'capture-profile',
                    template: "<div>\n  <button\n    mat-raised-button\n    [disabled]=\"capturingProfile | async\"\n    (click)=\"openDialog()\">\n    {{captureButtonLabel | uppercase}}\n    <mat-spinner\n      diameter=\"20\"\n      [style.visibility]=\"(capturingProfile | async) ? 'visible' : 'hidden'\">\n    </mat-spinner>\n  </button>\n</div>\n\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}mat-spinner{position:absolute;top:calc(50% - 10px);left:calc(50% - 10px)}.mat-raised-button{box-shadow:none;border:1px solid #000}\n"]
                }] }
    ];
    /** @nocollapse */
    CaptureProfile.ctorParameters = function () { return [
        { type: MatDialog },
        { type: MatSnackBar },
        { type: DataService },
        { type: Store }
    ]; };
    /**
     * @license Angular v8.2.14
     * (c) 2010-2019 Google LLC. https://angular.io/
     * License: MIT
     */
    /**
     * Used to provide a `ControlValueAccessor` for form controls.
     *
     * See `DefaultValueAccessor` for how to implement one.
     *
     * \@publicApi
     * @type {?}
     */
    var NG_VALUE_ACCESSOR = new InjectionToken('NgValueAccessor');
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var CHECKBOX_VALUE_ACCESSOR = {
        provide: NG_VALUE_ACCESSOR,
        useExisting: forwardRef(( /**
         * @return {?}
         */function () { return CheckboxControlValueAccessor; })),
        multi: true,
    };
    /**
     * \@description
     * A `ControlValueAccessor` for writing a value and listening to changes on a checkbox input
     * element.
     *
     * \@usageNotes
     *
     * ### Using a checkbox with a reactive form.
     *
     * The following example shows how to use a checkbox with a reactive form.
     *
     * ```ts
     * const rememberLoginControl = new FormControl();
     * ```
     *
     * ```
     * <input type="checkbox" [formControl]="rememberLoginControl">
     * ```
     *
     * \@ngModule ReactiveFormsModule
     * \@ngModule FormsModule
     * \@publicApi
     */
    var CheckboxControlValueAccessor = /** @class */ (function () {
        /**
         * @param {?} _renderer
         * @param {?} _elementRef
         */
        function CheckboxControlValueAccessor(_renderer, _elementRef) {
            this._renderer = _renderer;
            this._elementRef = _elementRef;
            /**
             * \@description
             * The registered callback function called when a change event occurs on the input element.
             */
            this.onChange = ( /**
             * @param {?} _
             * @return {?}
             */function (_) { });
            /**
             * \@description
             * The registered callback function called when a blur event occurs on the input element.
             */
            this.onTouched = ( /**
             * @return {?}
             */function () { });
        }
        /**
         * Sets the "checked" property on the input element.
         *
         * @param {?} value The checked value
         * @return {?}
         */
        CheckboxControlValueAccessor.prototype.writeValue = function (value) {
            this._renderer.setProperty(this._elementRef.nativeElement, 'checked', value);
        };
        /**
         * \@description
         * Registers a function called when the control value changes.
         *
         * @param {?} fn The callback function
         * @return {?}
         */
        CheckboxControlValueAccessor.prototype.registerOnChange = function (fn) { this.onChange = fn; };
        /**
         * \@description
         * Registers a function called when the control is touched.
         *
         * @param {?} fn The callback function
         * @return {?}
         */
        CheckboxControlValueAccessor.prototype.registerOnTouched = function (fn) { this.onTouched = fn; };
        /**
         * Sets the "disabled" property on the input element.
         *
         * @param {?} isDisabled The disabled value
         * @return {?}
         */
        CheckboxControlValueAccessor.prototype.setDisabledState = function (isDisabled) {
            this._renderer.setProperty(this._elementRef.nativeElement, 'disabled', isDisabled);
        };
        return CheckboxControlValueAccessor;
    }());
    CheckboxControlValueAccessor.decorators = [
        { type: Directive, args: [{
                    selector: 'input[type=checkbox][formControlName],input[type=checkbox][formControl],input[type=checkbox][ngModel]',
                    host: { '(change)': 'onChange($event.target.checked)', '(blur)': 'onTouched()' },
                    providers: [CHECKBOX_VALUE_ACCESSOR]
                },] }
    ];
    /** @nocollapse */
    CheckboxControlValueAccessor.ctorParameters = function () { return [
        { type: Renderer2 },
        { type: ElementRef }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var DEFAULT_VALUE_ACCESSOR = {
        provide: NG_VALUE_ACCESSOR,
        useExisting: forwardRef(( /**
         * @return {?}
         */function () { return DefaultValueAccessor; })),
        multi: true
    };
    /**
     * We must check whether the agent is Android because composition events
     * behave differently between iOS and Android.
     * @return {?}
     */
    function _isAndroid() {
        /** @type {?} */
        var userAgent = getDOM() ? getDOM().getUserAgent() : '';
        return /android (\d+)/.test(userAgent.toLowerCase());
    }
    /**
     * \@description
     * Provide this token to control if form directives buffer IME input until
     * the "compositionend" event occurs.
     * \@publicApi
     * @type {?}
     */
    var COMPOSITION_BUFFER_MODE = new InjectionToken('CompositionEventMode');
    /**
     * \@description
     * The default `ControlValueAccessor` for writing a value and listening to changes on input
     * elements. The accessor is used by the `FormControlDirective`, `FormControlName`, and
     * `NgModel` directives.
     *
     * \@usageNotes
     *
     * ### Using the default value accessor
     *
     * The following example shows how to use an input element that activates the default value accessor
     * (in this case, a text field).
     *
     * ```ts
     * const firstNameControl = new FormControl();
     * ```
     *
     * ```
     * <input type="text" [formControl]="firstNameControl">
     * ```
     *
     * \@ngModule ReactiveFormsModule
     * \@ngModule FormsModule
     * \@publicApi
     */
    var DefaultValueAccessor = /** @class */ (function () {
        /**
         * @param {?} _renderer
         * @param {?} _elementRef
         * @param {?} _compositionMode
         */
        function DefaultValueAccessor(_renderer, _elementRef, _compositionMode) {
            this._renderer = _renderer;
            this._elementRef = _elementRef;
            this._compositionMode = _compositionMode;
            /**
             * \@description
             * The registered callback function called when an input event occurs on the input element.
             */
            this.onChange = ( /**
             * @param {?} _
             * @return {?}
             */function (_) { });
            /**
             * \@description
             * The registered callback function called when a blur event occurs on the input element.
             */
            this.onTouched = ( /**
             * @return {?}
             */function () { });
            /**
             * Whether the user is creating a composition string (IME events).
             */
            this._composing = false;
            if (this._compositionMode == null) {
                this._compositionMode = !_isAndroid();
            }
        }
        /**
         * Sets the "value" property on the input element.
         *
         * @param {?} value The checked value
         * @return {?}
         */
        DefaultValueAccessor.prototype.writeValue = function (value) {
            /** @type {?} */
            var normalizedValue = value == null ? '' : value;
            this._renderer.setProperty(this._elementRef.nativeElement, 'value', normalizedValue);
        };
        /**
         * \@description
         * Registers a function called when the control value changes.
         *
         * @param {?} fn The callback function
         * @return {?}
         */
        DefaultValueAccessor.prototype.registerOnChange = function (fn) { this.onChange = fn; };
        /**
         * \@description
         * Registers a function called when the control is touched.
         *
         * @param {?} fn The callback function
         * @return {?}
         */
        DefaultValueAccessor.prototype.registerOnTouched = function (fn) { this.onTouched = fn; };
        /**
         * Sets the "disabled" property on the input element.
         *
         * @param {?} isDisabled The disabled value
         * @return {?}
         */
        DefaultValueAccessor.prototype.setDisabledState = function (isDisabled) {
            this._renderer.setProperty(this._elementRef.nativeElement, 'disabled', isDisabled);
        };
        /**
         * \@internal
         * @param {?} value
         * @return {?}
         */
        DefaultValueAccessor.prototype._handleInput = function (value) {
            if (!this._compositionMode || (this._compositionMode && !this._composing)) {
                this.onChange(value);
            }
        };
        /**
         * \@internal
         * @return {?}
         */
        DefaultValueAccessor.prototype._compositionStart = function () { this._composing = true; };
        /**
         * \@internal
         * @param {?} value
         * @return {?}
         */
        DefaultValueAccessor.prototype._compositionEnd = function (value) {
            this._composing = false;
            this._compositionMode && this.onChange(value);
        };
        return DefaultValueAccessor;
    }());
    DefaultValueAccessor.decorators = [
        { type: Directive, args: [{
                    selector: 'input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]',
                    // TODO: vsavkin replace the above selector with the one below it once
                    // https://github.com/angular/angular/issues/3011 is implemented
                    // selector: '[ngModel],[formControl],[formControlName]',
                    host: {
                        '(input)': '$any(this)._handleInput($event.target.value)',
                        '(blur)': 'onTouched()',
                        '(compositionstart)': '$any(this)._compositionStart()',
                        '(compositionend)': '$any(this)._compositionEnd($event.target.value)'
                    },
                    providers: [DEFAULT_VALUE_ACCESSOR]
                },] }
    ];
    /** @nocollapse */
    DefaultValueAccessor.ctorParameters = function () { return [
        { type: Renderer2 },
        { type: ElementRef },
        { type: Boolean, decorators: [{ type: Optional }, { type: Inject, args: [COMPOSITION_BUFFER_MODE,] }] }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * \@description
     * Base class for control directives.
     *
     * This class is only used internally in the `ReactiveFormsModule` and the `FormsModule`.
     *
     * \@publicApi
     * @abstract
     */
    var AbstractControlDirective = /** @class */ (function () {
        function AbstractControlDirective() {
        }
        Object.defineProperty(AbstractControlDirective.prototype, "value", {
            /**
             * \@description
             * Reports the value of the control if it is present, otherwise null.
             * @return {?}
             */
            get: function () { return this.control ? this.control.value : null; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractControlDirective.prototype, "valid", {
            /**
             * \@description
             * Reports whether the control is valid. A control is considered valid if no
             * validation errors exist with the current value.
             * If the control is not present, null is returned.
             * @return {?}
             */
            get: function () { return this.control ? this.control.valid : null; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractControlDirective.prototype, "invalid", {
            /**
             * \@description
             * Reports whether the control is invalid, meaning that an error exists in the input value.
             * If the control is not present, null is returned.
             * @return {?}
             */
            get: function () { return this.control ? this.control.invalid : null; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractControlDirective.prototype, "pending", {
            /**
             * \@description
             * Reports whether a control is pending, meaning that that async validation is occurring and
             * errors are not yet available for the input value. If the control is not present, null is
             * returned.
             * @return {?}
             */
            get: function () { return this.control ? this.control.pending : null; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractControlDirective.prototype, "disabled", {
            /**
             * \@description
             * Reports whether the control is disabled, meaning that the control is disabled
             * in the UI and is exempt from validation checks and excluded from aggregate
             * values of ancestor controls. If the control is not present, null is returned.
             * @return {?}
             */
            get: function () { return this.control ? this.control.disabled : null; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractControlDirective.prototype, "enabled", {
            /**
             * \@description
             * Reports whether the control is enabled, meaning that the control is included in ancestor
             * calculations of validity or value. If the control is not present, null is returned.
             * @return {?}
             */
            get: function () { return this.control ? this.control.enabled : null; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractControlDirective.prototype, "errors", {
            /**
             * \@description
             * Reports the control's validation errors. If the control is not present, null is returned.
             * @return {?}
             */
            get: function () { return this.control ? this.control.errors : null; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractControlDirective.prototype, "pristine", {
            /**
             * \@description
             * Reports whether the control is pristine, meaning that the user has not yet changed
             * the value in the UI. If the control is not present, null is returned.
             * @return {?}
             */
            get: function () { return this.control ? this.control.pristine : null; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractControlDirective.prototype, "dirty", {
            /**
             * \@description
             * Reports whether the control is dirty, meaning that the user has changed
             * the value in the UI. If the control is not present, null is returned.
             * @return {?}
             */
            get: function () { return this.control ? this.control.dirty : null; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractControlDirective.prototype, "touched", {
            /**
             * \@description
             * Reports whether the control is touched, meaning that the user has triggered
             * a `blur` event on it. If the control is not present, null is returned.
             * @return {?}
             */
            get: function () { return this.control ? this.control.touched : null; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractControlDirective.prototype, "status", {
            /**
             * \@description
             * Reports the validation status of the control. Possible values include:
             * 'VALID', 'INVALID', 'DISABLED', and 'PENDING'.
             * If the control is not present, null is returned.
             * @return {?}
             */
            get: function () { return this.control ? this.control.status : null; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractControlDirective.prototype, "untouched", {
            /**
             * \@description
             * Reports whether the control is untouched, meaning that the user has not yet triggered
             * a `blur` event on it. If the control is not present, null is returned.
             * @return {?}
             */
            get: function () { return this.control ? this.control.untouched : null; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractControlDirective.prototype, "statusChanges", {
            /**
             * \@description
             * Returns a multicasting observable that emits a validation status whenever it is
             * calculated for the control. If the control is not present, null is returned.
             * @return {?}
             */
            get: function () {
                return this.control ? this.control.statusChanges : null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractControlDirective.prototype, "valueChanges", {
            /**
             * \@description
             * Returns a multicasting observable of value changes for the control that emits every time the
             * value of the control changes in the UI or programmatically.
             * If the control is not present, null is returned.
             * @return {?}
             */
            get: function () {
                return this.control ? this.control.valueChanges : null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractControlDirective.prototype, "path", {
            /**
             * \@description
             * Returns an array that represents the path from the top-level form to this control.
             * Each index is the string name of the control on that level.
             * @return {?}
             */
            get: function () { return null; },
            enumerable: true,
            configurable: true
        });
        /**
         * \@description
         * Resets the control with the provided value if the control is present.
         * @param {?=} value
         * @return {?}
         */
        AbstractControlDirective.prototype.reset = function (value) {
            if (value === void 0) { value = undefined; }
            if (this.control)
                this.control.reset(value);
        };
        /**
         * \@description
         * Reports whether the control with the given path has the error specified.
         *
         * \@usageNotes
         * For example, for the following `FormGroup`:
         *
         * ```
         * form = new FormGroup({
         *   address: new FormGroup({ street: new FormControl() })
         * });
         * ```
         *
         * The path to the 'street' control from the root form would be 'address' -> 'street'.
         *
         * It can be provided to this method in one of two formats:
         *
         * 1. An array of string control names, e.g. `['address', 'street']`
         * 1. A period-delimited list of control names in one string, e.g. `'address.street'`
         *
         * If no path is given, this method checks for the error on the current control.
         *
         * @param {?} errorCode The code of the error to check
         * @param {?=} path A list of control names that designates how to move from the current control
         * to the control that should be queried for errors.
         *
         * @return {?} whether the given error is present in the control at the given path.
         *
         * If the control is not present, false is returned.
         */
        AbstractControlDirective.prototype.hasError = function (errorCode, path) {
            return this.control ? this.control.hasError(errorCode, path) : false;
        };
        /**
         * \@description
         * Reports error data for the control with the given path.
         *
         * \@usageNotes
         * For example, for the following `FormGroup`:
         *
         * ```
         * form = new FormGroup({
         *   address: new FormGroup({ street: new FormControl() })
         * });
         * ```
         *
         * The path to the 'street' control from the root form would be 'address' -> 'street'.
         *
         * It can be provided to this method in one of two formats:
         *
         * 1. An array of string control names, e.g. `['address', 'street']`
         * 1. A period-delimited list of control names in one string, e.g. `'address.street'`
         *
         * @param {?} errorCode The code of the error to check
         * @param {?=} path A list of control names that designates how to move from the current control
         * to the control that should be queried for errors.
         *
         * @return {?} error data for that particular error. If the control or error is not present,
         * null is returned.
         */
        AbstractControlDirective.prototype.getError = function (errorCode, path) {
            return this.control ? this.control.getError(errorCode, path) : null;
        };
        return AbstractControlDirective;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@description
     * A base class for directives that contain multiple registered instances of `NgControl`.
     * Only used by the forms module.
     *
     * \@publicApi
     * @abstract
     */
    var ControlContainer = /** @class */ (function (_super) {
        __extends(ControlContainer, _super);
        function ControlContainer() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(ControlContainer.prototype, "formDirective", {
            /**
             * \@description
             * The top-level form directive for the control.
             * @return {?}
             */
            get: function () { return null; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ControlContainer.prototype, "path", {
            /**
             * \@description
             * The path to this group.
             * @return {?}
             */
            get: function () { return null; },
            enumerable: true,
            configurable: true
        });
        return ControlContainer;
    }(AbstractControlDirective));
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @return {?}
     */
    function unimplemented() {
        throw new Error('unimplemented');
    }
    /**
     * \@description
     * A base class that all control `FormControl`-based directives extend. It binds a `FormControl`
     * object to a DOM element.
     *
     * \@publicApi
     * @abstract
     */
    var NgControl = /** @class */ (function (_super) {
        __extends(NgControl, _super);
        function NgControl() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            /**
             * \@description
             * The parent form for the control.
             *
             * \@internal
             */
            _this._parent = null;
            /**
             * \@description
             * The name for the control
             */
            _this.name = null;
            /**
             * \@description
             * The value accessor for the control
             */
            _this.valueAccessor = null;
            /**
             * \@description
             * The uncomposed array of synchronous validators for the control
             *
             * \@internal
             */
            _this._rawValidators = [];
            /**
             * \@description
             * The uncomposed array of async validators for the control
             *
             * \@internal
             */
            _this._rawAsyncValidators = [];
            return _this;
        }
        Object.defineProperty(NgControl.prototype, "validator", {
            /**
             * \@description
             * The registered synchronous validator function for the control
             *
             * @throws An exception that this method is not implemented
             * @return {?}
             */
            get: function () { return ( /** @type {?} */(unimplemented())); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgControl.prototype, "asyncValidator", {
            /**
             * \@description
             * The registered async validator function for the control
             *
             * @throws An exception that this method is not implemented
             * @return {?}
             */
            get: function () { return ( /** @type {?} */(unimplemented())); },
            enumerable: true,
            configurable: true
        });
        return NgControl;
    }(AbstractControlDirective));
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AbstractControlStatus = /** @class */ (function () {
        /**
         * @param {?} cd
         */
        function AbstractControlStatus(cd) {
            this._cd = cd;
        }
        Object.defineProperty(AbstractControlStatus.prototype, "ngClassUntouched", {
            /**
             * @return {?}
             */
            get: function () { return this._cd.control ? this._cd.control.untouched : false; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractControlStatus.prototype, "ngClassTouched", {
            /**
             * @return {?}
             */
            get: function () { return this._cd.control ? this._cd.control.touched : false; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractControlStatus.prototype, "ngClassPristine", {
            /**
             * @return {?}
             */
            get: function () { return this._cd.control ? this._cd.control.pristine : false; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractControlStatus.prototype, "ngClassDirty", {
            /**
             * @return {?}
             */
            get: function () { return this._cd.control ? this._cd.control.dirty : false; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractControlStatus.prototype, "ngClassValid", {
            /**
             * @return {?}
             */
            get: function () { return this._cd.control ? this._cd.control.valid : false; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractControlStatus.prototype, "ngClassInvalid", {
            /**
             * @return {?}
             */
            get: function () { return this._cd.control ? this._cd.control.invalid : false; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractControlStatus.prototype, "ngClassPending", {
            /**
             * @return {?}
             */
            get: function () { return this._cd.control ? this._cd.control.pending : false; },
            enumerable: true,
            configurable: true
        });
        return AbstractControlStatus;
    }());
    /** @type {?} */
    var ngControlStatusHost = {
        '[class.ng-untouched]': 'ngClassUntouched',
        '[class.ng-touched]': 'ngClassTouched',
        '[class.ng-pristine]': 'ngClassPristine',
        '[class.ng-dirty]': 'ngClassDirty',
        '[class.ng-valid]': 'ngClassValid',
        '[class.ng-invalid]': 'ngClassInvalid',
        '[class.ng-pending]': 'ngClassPending',
    };
    /**
     * \@description
     * Directive automatically applied to Angular form controls that sets CSS classes
     * based on control status.
     *
     * \@usageNotes
     *
     * ### CSS classes applied
     *
     * The following classes are applied as the properties become true:
     *
     * * ng-valid
     * * ng-invalid
     * * ng-pending
     * * ng-pristine
     * * ng-dirty
     * * ng-untouched
     * * ng-touched
     *
     * \@ngModule ReactiveFormsModule
     * \@ngModule FormsModule
     * \@publicApi
     */
    var NgControlStatus = /** @class */ (function (_super) {
        __extends(NgControlStatus, _super);
        /**
         * @param {?} cd
         */
        function NgControlStatus(cd) {
            return _super.call(this, cd) || this;
        }
        return NgControlStatus;
    }(AbstractControlStatus));
    NgControlStatus.decorators = [
        { type: Directive, args: [{ selector: '[formControlName],[ngModel],[formControl]', host: ngControlStatusHost },] }
    ];
    /** @nocollapse */
    NgControlStatus.ctorParameters = function () { return [
        { type: NgControl, decorators: [{ type: Self }] }
    ]; };
    /**
     * \@description
     * Directive automatically applied to Angular form groups that sets CSS classes
     * based on control status (valid/invalid/dirty/etc).
     *
     * @see `NgControlStatus`
     *
     * \@ngModule ReactiveFormsModule
     * \@ngModule FormsModule
     * \@publicApi
     */
    var NgControlStatusGroup = /** @class */ (function (_super) {
        __extends(NgControlStatusGroup, _super);
        /**
         * @param {?} cd
         */
        function NgControlStatusGroup(cd) {
            return _super.call(this, cd) || this;
        }
        return NgControlStatusGroup;
    }(AbstractControlStatus));
    NgControlStatusGroup.decorators = [
        { type: Directive, args: [{
                    selector: '[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]',
                    host: ngControlStatusHost
                },] }
    ];
    /** @nocollapse */
    NgControlStatusGroup.ctorParameters = function () { return [
        { type: ControlContainer, decorators: [{ type: Self }] }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} value
     * @return {?}
     */
    function isEmptyInputValue(value) {
        // we don't check for string here so it also works with arrays
        return value == null || value.length === 0;
    }
    /**
     * \@description
     * An `InjectionToken` for registering additional synchronous validators used with `AbstractControl`s.
     *
     * @see `NG_ASYNC_VALIDATORS`
     *
     * \@usageNotes
     *
     * ### Providing a custom validator
     *
     * The following example registers a custom validator directive. Adding the validator to the
     * existing collection of validators requires the `multi: true` option.
     *
     * ```typescript
     * \@Directive({
     *   selector: '[customValidator]',
     *   providers: [{provide: NG_VALIDATORS, useExisting: CustomValidatorDirective, multi: true}]
     * })
     * class CustomValidatorDirective implements Validator {
     *   validate(control: AbstractControl): ValidationErrors | null {
     *     return { 'custom': true };
     *   }
     * }
     * ```
     *
     * \@publicApi
     * @type {?}
     */
    var NG_VALIDATORS = new InjectionToken('NgValidators');
    /**
     * \@description
     * An `InjectionToken` for registering additional asynchronous validators used with `AbstractControl`s.
     *
     * @see `NG_VALIDATORS`
     *
     * \@publicApi
     * @type {?}
     */
    var NG_ASYNC_VALIDATORS = new InjectionToken('NgAsyncValidators');
    /**
     * A regular expression that matches valid e-mail addresses.
     *
     * At a high level, this regexp matches e-mail addresses of the format `local-part\@tld`, where:
     * - `local-part` consists of one or more of the allowed characters (alphanumeric and some
     *   punctuation symbols).
     * - `local-part` cannot begin or end with a period (`.`).
     * - `local-part` cannot be longer than 64 characters.
     * - `tld` consists of one or more `labels` separated by periods (`.`). For example `localhost` or
     *   `foo.com`.
     * - A `label` consists of one or more of the allowed characters (alphanumeric, dashes (`-`) and
     *   periods (`.`)).
     * - A `label` cannot begin or end with a dash (`-`) or a period (`.`).
     * - A `label` cannot be longer than 63 characters.
     * - The whole address cannot be longer than 254 characters.
     *
     * ## Implementation background
     *
     * This regexp was ported over from AngularJS (see there for git history):
     * https://github.com/angular/angular.js/blob/c133ef836/src/ng/directive/input.js#L27
     * It is based on the
     * [WHATWG version](https://html.spec.whatwg.org/multipage/input.html#valid-e-mail-address) with
     * some enhancements to incorporate more RFC rules (such as rules related to domain names and the
     * lengths of different parts of the address). The main differences from the WHATWG version are:
     *   - Disallow `local-part` to begin or end with a period (`.`).
     *   - Disallow `local-part` length to exceed 64 characters.
     *   - Disallow total address length to exceed 254 characters.
     *
     * See [this commit](https://github.com/angular/angular.js/commit/f3f5cf72e) for more details.
     * @type {?}
     */
    var EMAIL_REGEXP = /^(?=.{1,254}$)(?=.{1,64}@)[a-zA-Z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-zA-Z0-9!#$%&'*+/=?^_`{|}~-]+)*@[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)*$/;
    /**
     * \@description
     * Provides a set of built-in validators that can be used by form controls.
     *
     * A validator is a function that processes a `FormControl` or collection of
     * controls and returns an error map or null. A null map means that validation has passed.
     *
     * @see [Form Validation](/guide/form-validation)
     *
     * \@publicApi
     */
    var Validators = /** @class */ (function () {
        function Validators() {
        }
        /**
         * \@description
         * Validator that requires the control's value to be greater than or equal to the provided number.
         * The validator exists only as a function and not as a directive.
         *
         * \@usageNotes
         *
         * ### Validate against a minimum of 3
         *
         * ```typescript
         * const control = new FormControl(2, Validators.min(3));
         *
         * console.log(control.errors); // {min: {min: 3, actual: 2}}
         * ```
         *
         * @see `updateValueAndValidity()`
         *
         * @param {?} min
         * @return {?} A validator function that returns an error map with the
         * `min` property if the validation check fails, otherwise `null`.
         *
         */
        Validators.min = function (min) {
            return ( /**
             * @param {?} control
             * @return {?}
             */function (control) {
                if (isEmptyInputValue(control.value) || isEmptyInputValue(min)) {
                    return null; // don't validate empty values to allow optional controls
                }
                /** @type {?} */
                var value = parseFloat(control.value);
                // Controls with NaN values after parsing should be treated as not having a
                // minimum, per the HTML forms spec: https://www.w3.org/TR/html5/forms.html#attr-input-min
                return !isNaN(value) && value < min ? { 'min': { 'min': min, 'actual': control.value } } : null;
            });
        };
        /**
         * \@description
         * Validator that requires the control's value to be less than or equal to the provided number.
         * The validator exists only as a function and not as a directive.
         *
         * \@usageNotes
         *
         * ### Validate against a maximum of 15
         *
         * ```typescript
         * const control = new FormControl(16, Validators.max(15));
         *
         * console.log(control.errors); // {max: {max: 15, actual: 16}}
         * ```
         *
         * @see `updateValueAndValidity()`
         *
         * @param {?} max
         * @return {?} A validator function that returns an error map with the
         * `max` property if the validation check fails, otherwise `null`.
         *
         */
        Validators.max = function (max) {
            return ( /**
             * @param {?} control
             * @return {?}
             */function (control) {
                if (isEmptyInputValue(control.value) || isEmptyInputValue(max)) {
                    return null; // don't validate empty values to allow optional controls
                }
                /** @type {?} */
                var value = parseFloat(control.value);
                // Controls with NaN values after parsing should be treated as not having a
                // maximum, per the HTML forms spec: https://www.w3.org/TR/html5/forms.html#attr-input-max
                return !isNaN(value) && value > max ? { 'max': { 'max': max, 'actual': control.value } } : null;
            });
        };
        /**
         * \@description
         * Validator that requires the control have a non-empty value.
         *
         * \@usageNotes
         *
         * ### Validate that the field is non-empty
         *
         * ```typescript
         * const control = new FormControl('', Validators.required);
         *
         * console.log(control.errors); // {required: true}
         * ```
         *
         * @see `updateValueAndValidity()`
         *
         * @param {?} control
         * @return {?} An error map with the `required` property
         * if the validation check fails, otherwise `null`.
         *
         */
        Validators.required = function (control) {
            return isEmptyInputValue(control.value) ? { 'required': true } : null;
        };
        /**
         * \@description
         * Validator that requires the control's value be true. This validator is commonly
         * used for required checkboxes.
         *
         * \@usageNotes
         *
         * ### Validate that the field value is true
         *
         * ```typescript
         * const control = new FormControl('', Validators.requiredTrue);
         *
         * console.log(control.errors); // {required: true}
         * ```
         *
         * @see `updateValueAndValidity()`
         *
         * @param {?} control
         * @return {?} An error map that contains the `required` property
         * set to `true` if the validation check fails, otherwise `null`.
         *
         */
        Validators.requiredTrue = function (control) {
            return control.value === true ? null : { 'required': true };
        };
        /**
         * \@description
         * Validator that requires the control's value pass an email validation test.
         *
         * Tests the value using a [regular expression](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Guide/Regular_Expressions)
         * pattern suitable for common usecases. The pattern is based on the definition of a valid email
         * address in the [WHATWG HTML specification](https://html.spec.whatwg.org/multipage/input.html#valid-e-mail-address)
         * with some enhancements to incorporate more RFC rules (such as rules related to domain names and
         * the lengths of different parts of the address).
         *
         * The differences from the WHATWG version include:
         * - Disallow `local-part` (the part before the `\@` symbol) to begin or end with a period (`.`).
         * - Disallow `local-part` to be longer than 64 characters.
         * - Disallow the whole address to be longer than 254 characters.
         *
         * If this pattern does not satisfy your business needs, you can use `Validators.pattern()` to
         * validate the value against a different pattern.
         *
         * \@usageNotes
         *
         * ### Validate that the field matches a valid email pattern
         *
         * ```typescript
         * const control = new FormControl('bad\@', Validators.email);
         *
         * console.log(control.errors); // {email: true}
         * ```
         *
         * @see `updateValueAndValidity()`
         *
         * @param {?} control
         * @return {?} An error map with the `email` property
         * if the validation check fails, otherwise `null`.
         *
         */
        Validators.email = function (control) {
            if (isEmptyInputValue(control.value)) {
                return null; // don't validate empty values to allow optional controls
            }
            return EMAIL_REGEXP.test(control.value) ? null : { 'email': true };
        };
        /**
         * \@description
         * Validator that requires the length of the control's value to be greater than or equal
         * to the provided minimum length. This validator is also provided by default if you use the
         * the HTML5 `minlength` attribute.
         *
         * \@usageNotes
         *
         * ### Validate that the field has a minimum of 3 characters
         *
         * ```typescript
         * const control = new FormControl('ng', Validators.minLength(3));
         *
         * console.log(control.errors); // {minlength: {requiredLength: 3, actualLength: 2}}
         * ```
         *
         * ```html
         * <input minlength="5">
         * ```
         *
         * @see `updateValueAndValidity()`
         *
         * @param {?} minLength
         * @return {?} A validator function that returns an error map with the
         * `minlength` if the validation check fails, otherwise `null`.
         *
         */
        Validators.minLength = function (minLength) {
            return ( /**
             * @param {?} control
             * @return {?}
             */function (control) {
                if (isEmptyInputValue(control.value)) {
                    return null; // don't validate empty values to allow optional controls
                }
                /** @type {?} */
                var length = control.value ? control.value.length : 0;
                return length < minLength ?
                    { 'minlength': { 'requiredLength': minLength, 'actualLength': length } } :
                    null;
            });
        };
        /**
         * \@description
         * Validator that requires the length of the control's value to be less than or equal
         * to the provided maximum length. This validator is also provided by default if you use the
         * the HTML5 `maxlength` attribute.
         *
         * \@usageNotes
         *
         * ### Validate that the field has maximum of 5 characters
         *
         * ```typescript
         * const control = new FormControl('Angular', Validators.maxLength(5));
         *
         * console.log(control.errors); // {maxlength: {requiredLength: 5, actualLength: 7}}
         * ```
         *
         * ```html
         * <input maxlength="5">
         * ```
         *
         * @see `updateValueAndValidity()`
         *
         * @param {?} maxLength
         * @return {?} A validator function that returns an error map with the
         * `maxlength` property if the validation check fails, otherwise `null`.
         *
         */
        Validators.maxLength = function (maxLength) {
            return ( /**
             * @param {?} control
             * @return {?}
             */function (control) {
                /** @type {?} */
                var length = control.value ? control.value.length : 0;
                return length > maxLength ?
                    { 'maxlength': { 'requiredLength': maxLength, 'actualLength': length } } :
                    null;
            });
        };
        /**
         * \@description
         * Validator that requires the control's value to match a regex pattern. This validator is also
         * provided by default if you use the HTML5 `pattern` attribute.
         *
         * \@usageNotes
         *
         * ### Validate that the field only contains letters or spaces
         *
         * ```typescript
         * const control = new FormControl('1', Validators.pattern('[a-zA-Z ]*'));
         *
         * console.log(control.errors); // {pattern: {requiredPattern: '^[a-zA-Z ]*$', actualValue: '1'}}
         * ```
         *
         * ```html
         * <input pattern="[a-zA-Z ]*">
         * ```
         *
         * @see `updateValueAndValidity()`
         *
         * @param {?} pattern A regular expression to be used as is to test the values, or a string.
         * If a string is passed, the `^` character is prepended and the `$` character is
         * appended to the provided string (if not already present), and the resulting regular
         * expression is used to test the values.
         *
         * @return {?} A validator function that returns an error map with the
         * `pattern` property if the validation check fails, otherwise `null`.
         *
         */
        Validators.pattern = function (pattern) {
            if (!pattern)
                return Validators.nullValidator;
            /** @type {?} */
            var regex;
            /** @type {?} */
            var regexStr;
            if (typeof pattern === 'string') {
                regexStr = '';
                if (pattern.charAt(0) !== '^')
                    regexStr += '^';
                regexStr += pattern;
                if (pattern.charAt(pattern.length - 1) !== '$')
                    regexStr += '$';
                regex = new RegExp(regexStr);
            }
            else {
                regexStr = pattern.toString();
                regex = pattern;
            }
            return ( /**
             * @param {?} control
             * @return {?}
             */function (control) {
                if (isEmptyInputValue(control.value)) {
                    return null; // don't validate empty values to allow optional controls
                }
                /** @type {?} */
                var value = control.value;
                return regex.test(value) ? null :
                    { 'pattern': { 'requiredPattern': regexStr, 'actualValue': value } };
            });
        };
        /**
         * \@description
         * Validator that performs no operation.
         *
         * @see `updateValueAndValidity()`
         *
         * @param {?} control
         * @return {?}
         */
        Validators.nullValidator = function (control) { return null; };
        /**
         * @param {?} validators
         * @return {?}
         */
        Validators.compose = function (validators) {
            if (!validators)
                return null;
            /** @type {?} */
            var presentValidators = ( /** @type {?} */(validators.filter(isPresent)));
            if (presentValidators.length == 0)
                return null;
            return ( /**
             * @param {?} control
             * @return {?}
             */function (control) {
                return _mergeErrors(_executeValidators(control, presentValidators));
            });
        };
        /**
         * \@description
         * Compose multiple async validators into a single function that returns the union
         * of the individual error objects for the provided control.
         *
         * @see `updateValueAndValidity()`
         *
         * @param {?} validators
         * @return {?} A validator function that returns an error map with the
         * merged error objects of the async validators if the validation check fails, otherwise `null`.
         *
         */
        Validators.composeAsync = function (validators) {
            if (!validators)
                return null;
            /** @type {?} */
            var presentValidators = ( /** @type {?} */(validators.filter(isPresent)));
            if (presentValidators.length == 0)
                return null;
            return ( /**
             * @param {?} control
             * @return {?}
             */function (control) {
                /** @type {?} */
                var observables = _executeAsyncValidators(control, presentValidators).map(toObservable);
                return forkJoin(observables).pipe(map(_mergeErrors));
            });
        };
        return Validators;
    }());
    /**
     * @param {?} o
     * @return {?}
     */
    function isPresent(o) {
        return o != null;
    }
    /**
     * @param {?} r
     * @return {?}
     */
    function toObservable(r) {
        /** @type {?} */
        var obs = isPromise$1(r) ? from(r) : r;
        if (!(isObservable(obs))) {
            throw new Error("Expected validator to return Promise or Observable.");
        }
        return obs;
    }
    /**
     * @param {?} control
     * @param {?} validators
     * @return {?}
     */
    function _executeValidators(control, validators) {
        return validators.map(( /**
         * @param {?} v
         * @return {?}
         */function (/**
         * @param {?} v
         * @return {?}
         */ v) { return v(control); }));
    }
    /**
     * @param {?} control
     * @param {?} validators
     * @return {?}
     */
    function _executeAsyncValidators(control, validators) {
        return validators.map(( /**
         * @param {?} v
         * @return {?}
         */function (/**
         * @param {?} v
         * @return {?}
         */ v) { return v(control); }));
    }
    /**
     * @param {?} arrayOfErrors
     * @return {?}
     */
    function _mergeErrors(arrayOfErrors) {
        /** @type {?} */
        var res = arrayOfErrors.reduce(( /**
         * @param {?} res
         * @param {?} errors
         * @return {?}
         */function (res, errors) {
            return errors != null ? Object.assign({}, ( /** @type {?} */(res)), errors) : ( /** @type {?} */(res));
        }), {});
        return Object.keys(res).length === 0 ? null : res;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @param {?} validator
     * @return {?}
     */
    function normalizeValidator(validator) {
        if ((( /** @type {?} */(validator))).validate) {
            return ( /**
             * @param {?} c
             * @return {?}
             */function (c) { return (( /** @type {?} */(validator))).validate(c); });
        }
        else {
            return ( /** @type {?} */(validator));
        }
    }
    /**
     * @param {?} validator
     * @return {?}
     */
    function normalizeAsyncValidator(validator) {
        if ((( /** @type {?} */(validator))).validate) {
            return ( /**
             * @param {?} c
             * @return {?}
             */function (c) { return (( /** @type {?} */(validator))).validate(c); });
        }
        else {
            return ( /** @type {?} */(validator));
        }
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var NUMBER_VALUE_ACCESSOR = {
        provide: NG_VALUE_ACCESSOR,
        useExisting: forwardRef(( /**
         * @return {?}
         */function () { return NumberValueAccessor; })),
        multi: true
    };
    /**
     * \@description
     * The `ControlValueAccessor` for writing a number value and listening to number input changes.
     * The value accessor is used by the `FormControlDirective`, `FormControlName`, and  `NgModel`
     * directives.
     *
     * \@usageNotes
     *
     * ### Using a number input with a reactive form.
     *
     * The following example shows how to use a number input with a reactive form.
     *
     * ```ts
     * const totalCountControl = new FormControl();
     * ```
     *
     * ```
     * <input type="number" [formControl]="totalCountControl">
     * ```
     *
     * \@ngModule ReactiveFormsModule
     * \@ngModule FormsModule
     * \@publicApi
     */
    var NumberValueAccessor = /** @class */ (function () {
        /**
         * @param {?} _renderer
         * @param {?} _elementRef
         */
        function NumberValueAccessor(_renderer, _elementRef) {
            this._renderer = _renderer;
            this._elementRef = _elementRef;
            /**
             * \@description
             * The registered callback function called when a change or input event occurs on the input
             * element.
             */
            this.onChange = ( /**
             * @param {?} _
             * @return {?}
             */function (_) { });
            /**
             * \@description
             * The registered callback function called when a blur event occurs on the input element.
             */
            this.onTouched = ( /**
             * @return {?}
             */function () { });
        }
        /**
         * Sets the "value" property on the input element.
         *
         * @param {?} value The checked value
         * @return {?}
         */
        NumberValueAccessor.prototype.writeValue = function (value) {
            // The value needs to be normalized for IE9, otherwise it is set to 'null' when null
            /** @type {?} */
            var normalizedValue = value == null ? '' : value;
            this._renderer.setProperty(this._elementRef.nativeElement, 'value', normalizedValue);
        };
        /**
         * \@description
         * Registers a function called when the control value changes.
         *
         * @param {?} fn The callback function
         * @return {?}
         */
        NumberValueAccessor.prototype.registerOnChange = function (fn) {
            this.onChange = ( /**
             * @param {?} value
             * @return {?}
             */function (value) { fn(value == '' ? null : parseFloat(value)); });
        };
        /**
         * \@description
         * Registers a function called when the control is touched.
         *
         * @param {?} fn The callback function
         * @return {?}
         */
        NumberValueAccessor.prototype.registerOnTouched = function (fn) { this.onTouched = fn; };
        /**
         * Sets the "disabled" property on the input element.
         *
         * @param {?} isDisabled The disabled value
         * @return {?}
         */
        NumberValueAccessor.prototype.setDisabledState = function (isDisabled) {
            this._renderer.setProperty(this._elementRef.nativeElement, 'disabled', isDisabled);
        };
        return NumberValueAccessor;
    }());
    NumberValueAccessor.decorators = [
        { type: Directive, args: [{
                    selector: 'input[type=number][formControlName],input[type=number][formControl],input[type=number][ngModel]',
                    host: {
                        '(change)': 'onChange($event.target.value)',
                        '(input)': 'onChange($event.target.value)',
                        '(blur)': 'onTouched()'
                    },
                    providers: [NUMBER_VALUE_ACCESSOR]
                },] }
    ];
    /** @nocollapse */
    NumberValueAccessor.ctorParameters = function () { return [
        { type: Renderer2 },
        { type: ElementRef }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var RADIO_VALUE_ACCESSOR = {
        provide: NG_VALUE_ACCESSOR,
        useExisting: forwardRef(( /**
         * @return {?}
         */function () { return RadioControlValueAccessor; })),
        multi: true
    };
    /**
     * \@description
     * Class used by Angular to track radio buttons. For internal use only.
     */
    var RadioControlRegistry = /** @class */ (function () {
        function RadioControlRegistry() {
            this._accessors = [];
        }
        /**
         * \@description
         * Adds a control to the internal registry. For internal use only.
         * @param {?} control
         * @param {?} accessor
         * @return {?}
         */
        RadioControlRegistry.prototype.add = function (control, accessor) {
            this._accessors.push([control, accessor]);
        };
        /**
         * \@description
         * Removes a control from the internal registry. For internal use only.
         * @param {?} accessor
         * @return {?}
         */
        RadioControlRegistry.prototype.remove = function (accessor) {
            for (var i_162 = this._accessors.length - 1; i_162 >= 0; --i_162) {
                if (this._accessors[i_162][1] === accessor) {
                    this._accessors.splice(i_162, 1);
                    return;
                }
            }
        };
        /**
         * \@description
         * Selects a radio button. For internal use only.
         * @param {?} accessor
         * @return {?}
         */
        RadioControlRegistry.prototype.select = function (accessor) {
            var _this = this;
            this._accessors.forEach(( /**
             * @param {?} c
             * @return {?}
             */function (c) {
                if (_this._isSameGroup(c, accessor) && c[1] !== accessor) {
                    c[1].fireUncheck(accessor.value);
                }
            }));
        };
        /**
         * @private
         * @param {?} controlPair
         * @param {?} accessor
         * @return {?}
         */
        RadioControlRegistry.prototype._isSameGroup = function (controlPair, accessor) {
            if (!controlPair[0].control)
                return false;
            return controlPair[0]._parent === accessor._control._parent &&
                controlPair[1].name === accessor.name;
        };
        return RadioControlRegistry;
    }());
    RadioControlRegistry.decorators = [
        { type: Injectable }
    ];
    /**
     * \@description
     * The `ControlValueAccessor` for writing radio control values and listening to radio control
     * changes. The value accessor is used by the `FormControlDirective`, `FormControlName`, and
     * `NgModel` directives.
     *
     * \@usageNotes
     *
     * ### Using radio buttons with reactive form directives
     *
     * The follow example shows how to use radio buttons in a reactive form. When using radio buttons in
     * a reactive form, radio buttons in the same group should have the same `formControlName`.
     * Providing a `name` attribute is optional.
     *
     * {\@example forms/ts/reactiveRadioButtons/reactive_radio_button_example.ts region='Reactive'}
     *
     * \@ngModule ReactiveFormsModule
     * \@ngModule FormsModule
     * \@publicApi
     */
    var RadioControlValueAccessor = /** @class */ (function () {
        /**
         * @param {?} _renderer
         * @param {?} _elementRef
         * @param {?} _registry
         * @param {?} _injector
         */
        function RadioControlValueAccessor(_renderer, _elementRef, _registry, _injector) {
            this._renderer = _renderer;
            this._elementRef = _elementRef;
            this._registry = _registry;
            this._injector = _injector;
            /**
             * \@description
             * The registered callback function called when a change event occurs on the input element.
             */
            this.onChange = ( /**
             * @return {?}
             */function () { });
            /**
             * \@description
             * The registered callback function called when a blur event occurs on the input element.
             */
            this.onTouched = ( /**
             * @return {?}
             */function () { });
        }
        /**
         * \@description
         * A lifecycle method called when the directive is initialized. For internal use only.
         * @return {?}
         */
        RadioControlValueAccessor.prototype.ngOnInit = function () {
            this._control = this._injector.get(NgControl);
            this._checkName();
            this._registry.add(this._control, this);
        };
        /**
         * \@description
         * Lifecycle method called before the directive's instance is destroyed. For internal use only.
         * @return {?}
         */
        RadioControlValueAccessor.prototype.ngOnDestroy = function () { this._registry.remove(this); };
        /**
         * \@description
         * Sets the "checked" property value on the radio input element.
         *
         * @param {?} value The checked value
         * @return {?}
         */
        RadioControlValueAccessor.prototype.writeValue = function (value) {
            this._state = value === this.value;
            this._renderer.setProperty(this._elementRef.nativeElement, 'checked', this._state);
        };
        /**
         * \@description
         * Registers a function called when the control value changes.
         *
         * @param {?} fn The callback function
         * @return {?}
         */
        RadioControlValueAccessor.prototype.registerOnChange = function (fn) {
            var _this = this;
            this._fn = fn;
            this.onChange = ( /**
             * @return {?}
             */function () {
                fn(_this.value);
                _this._registry.select(_this);
            });
        };
        /**
         * Sets the "value" on the radio input element and unchecks it.
         *
         * @param {?} value
         * @return {?}
         */
        RadioControlValueAccessor.prototype.fireUncheck = function (value) { this.writeValue(value); };
        /**
         * \@description
         * Registers a function called when the control is touched.
         *
         * @param {?} fn The callback function
         * @return {?}
         */
        RadioControlValueAccessor.prototype.registerOnTouched = function (fn) { this.onTouched = fn; };
        /**
         * Sets the "disabled" property on the input element.
         *
         * @param {?} isDisabled The disabled value
         * @return {?}
         */
        RadioControlValueAccessor.prototype.setDisabledState = function (isDisabled) {
            this._renderer.setProperty(this._elementRef.nativeElement, 'disabled', isDisabled);
        };
        /**
         * @private
         * @return {?}
         */
        RadioControlValueAccessor.prototype._checkName = function () {
            if (this.name && this.formControlName && this.name !== this.formControlName) {
                this._throwNameError();
            }
            if (!this.name && this.formControlName)
                this.name = this.formControlName;
        };
        /**
         * @private
         * @return {?}
         */
        RadioControlValueAccessor.prototype._throwNameError = function () {
            throw new Error("\n      If you define both a name and a formControlName attribute on your radio button, their values\n      must match. Ex: <input type=\"radio\" formControlName=\"food\" name=\"food\">\n    ");
        };
        return RadioControlValueAccessor;
    }());
    RadioControlValueAccessor.decorators = [
        { type: Directive, args: [{
                    selector: 'input[type=radio][formControlName],input[type=radio][formControl],input[type=radio][ngModel]',
                    host: { '(change)': 'onChange()', '(blur)': 'onTouched()' },
                    providers: [RADIO_VALUE_ACCESSOR]
                },] }
    ];
    /** @nocollapse */
    RadioControlValueAccessor.ctorParameters = function () { return [
        { type: Renderer2 },
        { type: ElementRef },
        { type: RadioControlRegistry },
        { type: Injector }
    ]; };
    RadioControlValueAccessor.propDecorators = {
        name: [{ type: Input }],
        formControlName: [{ type: Input }],
        value: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var RANGE_VALUE_ACCESSOR = {
        provide: NG_VALUE_ACCESSOR,
        useExisting: forwardRef(( /**
         * @return {?}
         */function () { return RangeValueAccessor; })),
        multi: true
    };
    /**
     * \@description
     * The `ControlValueAccessor` for writing a range value and listening to range input changes.
     * The value accessor is used by the `FormControlDirective`, `FormControlName`, and  `NgModel`
     * directives.
     *
     * \@usageNotes
     *
     * ### Using a range input with a reactive form
     *
     * The following example shows how to use a range input with a reactive form.
     *
     * ```ts
     * const ageControl = new FormControl();
     * ```
     *
     * ```
     * <input type="range" [formControl]="ageControl">
     * ```
     *
     * \@ngModule ReactiveFormsModule
     * \@ngModule FormsModule
     * \@publicApi
     */
    var RangeValueAccessor = /** @class */ (function () {
        /**
         * @param {?} _renderer
         * @param {?} _elementRef
         */
        function RangeValueAccessor(_renderer, _elementRef) {
            this._renderer = _renderer;
            this._elementRef = _elementRef;
            /**
             * \@description
             * The registered callback function called when a change or input event occurs on the input
             * element.
             */
            this.onChange = ( /**
             * @param {?} _
             * @return {?}
             */function (_) { });
            /**
             * \@description
             * The registered callback function called when a blur event occurs on the input element.
             */
            this.onTouched = ( /**
             * @return {?}
             */function () { });
        }
        /**
         * Sets the "value" property on the input element.
         *
         * @param {?} value The checked value
         * @return {?}
         */
        RangeValueAccessor.prototype.writeValue = function (value) {
            this._renderer.setProperty(this._elementRef.nativeElement, 'value', parseFloat(value));
        };
        /**
         * \@description
         * Registers a function called when the control value changes.
         *
         * @param {?} fn The callback function
         * @return {?}
         */
        RangeValueAccessor.prototype.registerOnChange = function (fn) {
            this.onChange = ( /**
             * @param {?} value
             * @return {?}
             */function (value) { fn(value == '' ? null : parseFloat(value)); });
        };
        /**
         * \@description
         * Registers a function called when the control is touched.
         *
         * @param {?} fn The callback function
         * @return {?}
         */
        RangeValueAccessor.prototype.registerOnTouched = function (fn) { this.onTouched = fn; };
        /**
         * Sets the "disabled" property on the range input element.
         *
         * @param {?} isDisabled The disabled value
         * @return {?}
         */
        RangeValueAccessor.prototype.setDisabledState = function (isDisabled) {
            this._renderer.setProperty(this._elementRef.nativeElement, 'disabled', isDisabled);
        };
        return RangeValueAccessor;
    }());
    RangeValueAccessor.decorators = [
        { type: Directive, args: [{
                    selector: 'input[type=range][formControlName],input[type=range][formControl],input[type=range][ngModel]',
                    host: {
                        '(change)': 'onChange($event.target.value)',
                        '(input)': 'onChange($event.target.value)',
                        '(blur)': 'onTouched()'
                    },
                    providers: [RANGE_VALUE_ACCESSOR]
                },] }
    ];
    /** @nocollapse */
    RangeValueAccessor.ctorParameters = function () { return [
        { type: Renderer2 },
        { type: ElementRef }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /** @type {?} */
    var FormErrorExamples = {
        formControlName: "\n    <div [formGroup]=\"myGroup\">\n      <input formControlName=\"firstName\">\n    </div>\n\n    In your class:\n\n    this.myGroup = new FormGroup({\n       firstName: new FormControl()\n    });",
        formGroupName: "\n    <div [formGroup]=\"myGroup\">\n       <div formGroupName=\"person\">\n          <input formControlName=\"firstName\">\n       </div>\n    </div>\n\n    In your class:\n\n    this.myGroup = new FormGroup({\n       person: new FormGroup({ firstName: new FormControl() })\n    });",
        formArrayName: "\n    <div [formGroup]=\"myGroup\">\n      <div formArrayName=\"cities\">\n        <div *ngFor=\"let city of cityArray.controls; index as i\">\n          <input [formControlName]=\"i\">\n        </div>\n      </div>\n    </div>\n\n    In your class:\n\n    this.cityArray = new FormArray([new FormControl('SF')]);\n    this.myGroup = new FormGroup({\n      cities: this.cityArray\n    });",
        ngModelGroup: "\n    <form>\n       <div ngModelGroup=\"person\">\n          <input [(ngModel)]=\"person.name\" name=\"firstName\">\n       </div>\n    </form>",
        ngModelWithFormGroup: "\n    <div [formGroup]=\"myGroup\">\n       <input formControlName=\"firstName\">\n       <input [(ngModel)]=\"showMoreControls\" [ngModelOptions]=\"{standalone: true}\">\n    </div>\n  "
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ReactiveErrors = /** @class */ (function () {
        function ReactiveErrors() {
        }
        /**
         * @return {?}
         */
        ReactiveErrors.controlParentException = function () {
            throw new Error("formControlName must be used with a parent formGroup directive.  You'll want to add a formGroup\n       directive and pass it an existing FormGroup instance (you can create one in your class).\n\n      Example:\n\n      " + FormErrorExamples.formControlName);
        };
        /**
         * @return {?}
         */
        ReactiveErrors.ngModelGroupException = function () {
            throw new Error("formControlName cannot be used with an ngModelGroup parent. It is only compatible with parents\n       that also have a \"form\" prefix: formGroupName, formArrayName, or formGroup.\n\n       Option 1:  Update the parent to be formGroupName (reactive form strategy)\n\n        " + FormErrorExamples.formGroupName + "\n\n        Option 2: Use ngModel instead of formControlName (template-driven strategy)\n\n        " + FormErrorExamples.ngModelGroup);
        };
        /**
         * @return {?}
         */
        ReactiveErrors.missingFormException = function () {
            throw new Error("formGroup expects a FormGroup instance. Please pass one in.\n\n       Example:\n\n       " + FormErrorExamples.formControlName);
        };
        /**
         * @return {?}
         */
        ReactiveErrors.groupParentException = function () {
            throw new Error("formGroupName must be used with a parent formGroup directive.  You'll want to add a formGroup\n      directive and pass it an existing FormGroup instance (you can create one in your class).\n\n      Example:\n\n      " + FormErrorExamples.formGroupName);
        };
        /**
         * @return {?}
         */
        ReactiveErrors.arrayParentException = function () {
            throw new Error("formArrayName must be used with a parent formGroup directive.  You'll want to add a formGroup\n       directive and pass it an existing FormGroup instance (you can create one in your class).\n\n        Example:\n\n        " + FormErrorExamples.formArrayName);
        };
        /**
         * @return {?}
         */
        ReactiveErrors.disabledAttrWarning = function () {
            console.warn("\n      It looks like you're using the disabled attribute with a reactive form directive. If you set disabled to true\n      when you set up this control in your component class, the disabled attribute will actually be set in the DOM for\n      you. We recommend using this approach to avoid 'changed after checked' errors.\n       \n      Example: \n      form = new FormGroup({\n        first: new FormControl({value: 'Nancy', disabled: true}, Validators.required),\n        last: new FormControl('Drew', Validators.required)\n      });\n    ");
        };
        /**
         * @param {?} directiveName
         * @return {?}
         */
        ReactiveErrors.ngModelWarning = function (directiveName) {
            console.warn("\n    It looks like you're using ngModel on the same form field as " + directiveName + ". \n    Support for using the ngModel input property and ngModelChange event with \n    reactive form directives has been deprecated in Angular v6 and will be removed \n    in Angular v7.\n    \n    For more information on this, see our API docs here:\n    https://angular.io/api/forms/" + (directiveName === 'formControl' ? 'FormControlDirective'
                : 'FormControlName') + "#use-with-ngmodel\n    ");
        };
        return ReactiveErrors;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var SELECT_VALUE_ACCESSOR = {
        provide: NG_VALUE_ACCESSOR,
        useExisting: forwardRef(( /**
         * @return {?}
         */function () { return SelectControlValueAccessor; })),
        multi: true
    };
    /**
     * @param {?} id
     * @param {?} value
     * @return {?}
     */
    function _buildValueString(id, value) {
        if (id == null)
            return "" + value;
        if (value && typeof value === 'object')
            value = 'Object';
        return (id + ": " + value).slice(0, 50);
    }
    /**
     * @param {?} valueString
     * @return {?}
     */
    function _extractId(valueString) {
        return valueString.split(':')[0];
    }
    /**
     * \@description
     * The `ControlValueAccessor` for writing select control values and listening to select control
     * changes. The value accessor is used by the `FormControlDirective`, `FormControlName`, and
     * `NgModel` directives.
     *
     * \@usageNotes
     *
     * ### Using select controls in a reactive form
     *
     * The following examples show how to use a select control in a reactive form.
     *
     * {\@example forms/ts/reactiveSelectControl/reactive_select_control_example.ts region='Component'}
     *
     * ### Using select controls in a template-driven form
     *
     * To use a select in a template-driven form, simply add an `ngModel` and a `name`
     * attribute to the main `<select>` tag.
     *
     * {\@example forms/ts/selectControl/select_control_example.ts region='Component'}
     *
     * ### Customizing option selection
     *
     * Angular uses object identity to select option. It's possible for the identities of items
     * to change while the data does not. This can happen, for example, if the items are produced
     * from an RPC to the server, and that RPC is re-run. Even if the data hasn't changed, the
     * second response will produce objects with different identities.
     *
     * To customize the default option comparison algorithm, `<select>` supports `compareWith` input.
     * `compareWith` takes a **function** which has two arguments: `option1` and `option2`.
     * If `compareWith` is given, Angular selects option by the return value of the function.
     *
     * ```ts
     * const selectedCountriesControl = new FormControl();
     * ```
     *
     * ```
     * <select [compareWith]="compareFn"  [formControl]="selectedCountriesControl">
     *     <option *ngFor="let country of countries" [ngValue]="country">
     *         {{country.name}}
     *     </option>
     * </select>
     *
     * compareFn(c1: Country, c2: Country): boolean {
     *     return c1 && c2 ? c1.id === c2.id : c1 === c2;
     * }
     * ```
     *
     * **Note:** We listen to the 'change' event because 'input' events aren't fired
     * for selects in Firefox and IE:
     * https://bugzilla.mozilla.org/show_bug.cgi?id=1024350
     * https://developer.microsoft.com/en-us/microsoft-edge/platform/issues/4660045/
     *
     * \@ngModule ReactiveFormsModule
     * \@ngModule FormsModule
     * \@publicApi
     */
    var SelectControlValueAccessor = /** @class */ (function () {
        /**
         * @param {?} _renderer
         * @param {?} _elementRef
         */
        function SelectControlValueAccessor(_renderer, _elementRef) {
            this._renderer = _renderer;
            this._elementRef = _elementRef;
            /**
             * \@internal
             */
            this._optionMap = new Map();
            /**
             * \@internal
             */
            this._idCounter = 0;
            /**
             * \@description
             * The registered callback function called when a change event occurs on the input element.
             */
            this.onChange = ( /**
             * @param {?} _
             * @return {?}
             */function (_) { });
            /**
             * \@description
             * The registered callback function called when a blur event occurs on the input element.
             */
            this.onTouched = ( /**
             * @return {?}
             */function () { });
            this._compareWith = looseIdentical;
        }
        Object.defineProperty(SelectControlValueAccessor.prototype, "compareWith", {
            /**
             * \@description
             * Tracks the option comparison algorithm for tracking identities when
             * checking for changes.
             * @param {?} fn
             * @return {?}
             */
            set: function (fn) {
                if (typeof fn !== 'function') {
                    throw new Error("compareWith must be a function, but received " + JSON.stringify(fn));
                }
                this._compareWith = fn;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Sets the "value" property on the input element. The "selectedIndex"
         * property is also set if an ID is provided on the option element.
         *
         * @param {?} value The checked value
         * @return {?}
         */
        SelectControlValueAccessor.prototype.writeValue = function (value) {
            this.value = value;
            /** @type {?} */
            var id = this._getOptionId(value);
            if (id == null) {
                this._renderer.setProperty(this._elementRef.nativeElement, 'selectedIndex', -1);
            }
            /** @type {?} */
            var valueString = _buildValueString(id, value);
            this._renderer.setProperty(this._elementRef.nativeElement, 'value', valueString);
        };
        /**
         * \@description
         * Registers a function called when the control value changes.
         *
         * @param {?} fn The callback function
         * @return {?}
         */
        SelectControlValueAccessor.prototype.registerOnChange = function (fn) {
            var _this = this;
            this.onChange = ( /**
             * @param {?} valueString
             * @return {?}
             */function (valueString) {
                _this.value = _this._getOptionValue(valueString);
                fn(_this.value);
            });
        };
        /**
         * \@description
         * Registers a function called when the control is touched.
         *
         * @param {?} fn The callback function
         * @return {?}
         */
        SelectControlValueAccessor.prototype.registerOnTouched = function (fn) { this.onTouched = fn; };
        /**
         * Sets the "disabled" property on the select input element.
         *
         * @param {?} isDisabled The disabled value
         * @return {?}
         */
        SelectControlValueAccessor.prototype.setDisabledState = function (isDisabled) {
            this._renderer.setProperty(this._elementRef.nativeElement, 'disabled', isDisabled);
        };
        /**
         * \@internal
         * @return {?}
         */
        SelectControlValueAccessor.prototype._registerOption = function () { return (this._idCounter++).toString(); };
        /**
         * \@internal
         * @param {?} value
         * @return {?}
         */
        SelectControlValueAccessor.prototype._getOptionId = function (value) {
            var e_18, _b;
            try {
                for (var _c = __values(Array.from(this._optionMap.keys())), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var id = _d.value;
                    if (this._compareWith(this._optionMap.get(id), value))
                        return id;
                }
            }
            catch (e_18_1) { e_18 = { error: e_18_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
                }
                finally { if (e_18) throw e_18.error; }
            }
            return null;
        };
        /**
         * \@internal
         * @param {?} valueString
         * @return {?}
         */
        SelectControlValueAccessor.prototype._getOptionValue = function (valueString) {
            /** @type {?} */
            var id = _extractId(valueString);
            return this._optionMap.has(id) ? this._optionMap.get(id) : valueString;
        };
        return SelectControlValueAccessor;
    }());
    SelectControlValueAccessor.decorators = [
        { type: Directive, args: [{
                    selector: 'select:not([multiple])[formControlName],select:not([multiple])[formControl],select:not([multiple])[ngModel]',
                    host: { '(change)': 'onChange($event.target.value)', '(blur)': 'onTouched()' },
                    providers: [SELECT_VALUE_ACCESSOR]
                },] }
    ];
    /** @nocollapse */
    SelectControlValueAccessor.ctorParameters = function () { return [
        { type: Renderer2 },
        { type: ElementRef }
    ]; };
    SelectControlValueAccessor.propDecorators = {
        compareWith: [{ type: Input }]
    };
    /**
     * \@description
     * Marks `<option>` as dynamic, so Angular can be notified when options change.
     *
     * @see `SelectControlValueAccessor`
     *
     * \@ngModule ReactiveFormsModule
     * \@ngModule FormsModule
     * \@publicApi
     */
    var NgSelectOption = /** @class */ (function () {
        /**
         * @param {?} _element
         * @param {?} _renderer
         * @param {?} _select
         */
        function NgSelectOption(_element, _renderer, _select) {
            this._element = _element;
            this._renderer = _renderer;
            this._select = _select;
            if (this._select)
                this.id = this._select._registerOption();
        }
        Object.defineProperty(NgSelectOption.prototype, "ngValue", {
            /**
             * \@description
             * Tracks the value bound to the option element. Unlike the value binding,
             * ngValue supports binding to objects.
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                if (this._select == null)
                    return;
                this._select._optionMap.set(this.id, value);
                this._setElementValue(_buildValueString(this.id, value));
                this._select.writeValue(this._select.value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgSelectOption.prototype, "value", {
            /**
             * \@description
             * Tracks simple string values bound to the option element.
             * For objects, use the `ngValue` input binding.
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._setElementValue(value);
                if (this._select)
                    this._select.writeValue(this._select.value);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * \@internal
         * @param {?} value
         * @return {?}
         */
        NgSelectOption.prototype._setElementValue = function (value) {
            this._renderer.setProperty(this._element.nativeElement, 'value', value);
        };
        /**
         * \@description
         * Lifecycle method called before the directive's instance is destroyed. For internal use only.
         * @return {?}
         */
        NgSelectOption.prototype.ngOnDestroy = function () {
            if (this._select) {
                this._select._optionMap.delete(this.id);
                this._select.writeValue(this._select.value);
            }
        };
        return NgSelectOption;
    }());
    NgSelectOption.decorators = [
        { type: Directive, args: [{ selector: 'option' },] }
    ];
    /** @nocollapse */
    NgSelectOption.ctorParameters = function () { return [
        { type: ElementRef },
        { type: Renderer2 },
        { type: SelectControlValueAccessor, decorators: [{ type: Optional }, { type: Host }] }
    ]; };
    NgSelectOption.propDecorators = {
        ngValue: [{ type: Input, args: ['ngValue',] }],
        value: [{ type: Input, args: ['value',] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var SELECT_MULTIPLE_VALUE_ACCESSOR = {
        provide: NG_VALUE_ACCESSOR,
        useExisting: forwardRef(( /**
         * @return {?}
         */function () { return SelectMultipleControlValueAccessor; })),
        multi: true
    };
    /**
     * @param {?} id
     * @param {?} value
     * @return {?}
     */
    function _buildValueString$1(id, value) {
        if (id == null)
            return "" + value;
        if (typeof value === 'string')
            value = "'" + value + "'";
        if (value && typeof value === 'object')
            value = 'Object';
        return (id + ": " + value).slice(0, 50);
    }
    /**
     * @param {?} valueString
     * @return {?}
     */
    function _extractId$1(valueString) {
        return valueString.split(':')[0];
    }
    /**
     * \@description
     * The `ControlValueAccessor` for writing multi-select control values and listening to multi-select control
     * changes. The value accessor is used by the `FormControlDirective`, `FormControlName`, and `NgModel`
     * directives.
     *
     * @see `SelectControlValueAccessor`
     *
     * \@usageNotes
     *
     * ### Using a multi-select control
     *
     * The follow example shows you how to use a multi-select control with a reactive form.
     *
     * ```ts
     * const countryControl = new FormControl();
     * ```
     *
     * ```
     * <select multiple name="countries" [formControl]="countryControl">
     *   <option *ngFor="let country of countries" [ngValue]="country">
     *     {{ country.name }}
     *   </option>
     * </select>
     * ```
     *
     * ### Customizing option selection
     *
     * To customize the default option comparison algorithm, `<select>` supports `compareWith` input.
     * See the `SelectControlValueAccessor` for usage.
     *
     * \@ngModule ReactiveFormsModule
     * \@ngModule FormsModule
     * \@publicApi
     */
    var SelectMultipleControlValueAccessor = /** @class */ (function () {
        /**
         * @param {?} _renderer
         * @param {?} _elementRef
         */
        function SelectMultipleControlValueAccessor(_renderer, _elementRef) {
            this._renderer = _renderer;
            this._elementRef = _elementRef;
            /**
             * \@internal
             */
            this._optionMap = new Map();
            /**
             * \@internal
             */
            this._idCounter = 0;
            /**
             * \@description
             * The registered callback function called when a change event occurs on the input element.
             */
            this.onChange = ( /**
             * @param {?} _
             * @return {?}
             */function (_) { });
            /**
             * \@description
             * The registered callback function called when a blur event occurs on the input element.
             */
            this.onTouched = ( /**
             * @return {?}
             */function () { });
            this._compareWith = looseIdentical;
        }
        Object.defineProperty(SelectMultipleControlValueAccessor.prototype, "compareWith", {
            /**
             * \@description
             * Tracks the option comparison algorithm for tracking identities when
             * checking for changes.
             * @param {?} fn
             * @return {?}
             */
            set: function (fn) {
                if (typeof fn !== 'function') {
                    throw new Error("compareWith must be a function, but received " + JSON.stringify(fn));
                }
                this._compareWith = fn;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * \@description
         * Sets the "value" property on one or of more
         * of the select's options.
         *
         * @param {?} value The value
         * @return {?}
         */
        SelectMultipleControlValueAccessor.prototype.writeValue = function (value) {
            var _this = this;
            this.value = value;
            /** @type {?} */
            var optionSelectedStateSetter;
            if (Array.isArray(value)) {
                // convert values to ids
                /** @type {?} */
                var ids_1 = value.map(( /**
                 * @param {?} v
                 * @return {?}
                 */function (v) { return _this._getOptionId(v); }));
                optionSelectedStateSetter = ( /**
                 * @param {?} opt
                 * @param {?} o
                 * @return {?}
                 */function (opt, o) { opt._setSelected(ids_1.indexOf(o.toString()) > -1); });
            }
            else {
                optionSelectedStateSetter = ( /**
                 * @param {?} opt
                 * @param {?} o
                 * @return {?}
                 */function (opt, o) { opt._setSelected(false); });
            }
            this._optionMap.forEach(optionSelectedStateSetter);
        };
        /**
         * \@description
         * Registers a function called when the control value changes
         * and writes an array of the selected options.
         *
         * @param {?} fn The callback function
         * @return {?}
         */
        SelectMultipleControlValueAccessor.prototype.registerOnChange = function (fn) {
            var _this = this;
            this.onChange = ( /**
             * @param {?} _
             * @return {?}
             */function (_) {
                /** @type {?} */
                var selected = [];
                if (_.hasOwnProperty('selectedOptions')) {
                    /** @type {?} */
                    var options = _.selectedOptions;
                    for (var i_163 = 0; i_163 < options.length; i_163++) {
                        /** @type {?} */
                        var opt = options.item(i_163);
                        /** @type {?} */
                        var val = _this._getOptionValue(opt.value);
                        selected.push(val);
                    }
                }
                // Degrade on IE
                else {
                    /** @type {?} */
                    var options = ( /** @type {?} */(_.options));
                    for (var i_164 = 0; i_164 < options.length; i_164++) {
                        /** @type {?} */
                        var opt = options.item(i_164);
                        if (opt.selected) {
                            /** @type {?} */
                            var val = _this._getOptionValue(opt.value);
                            selected.push(val);
                        }
                    }
                }
                _this.value = selected;
                fn(selected);
            });
        };
        /**
         * \@description
         * Registers a function called when the control is touched.
         *
         * @param {?} fn The callback function
         * @return {?}
         */
        SelectMultipleControlValueAccessor.prototype.registerOnTouched = function (fn) { this.onTouched = fn; };
        /**
         * Sets the "disabled" property on the select input element.
         *
         * @param {?} isDisabled The disabled value
         * @return {?}
         */
        SelectMultipleControlValueAccessor.prototype.setDisabledState = function (isDisabled) {
            this._renderer.setProperty(this._elementRef.nativeElement, 'disabled', isDisabled);
        };
        /**
         * \@internal
         * @param {?} value
         * @return {?}
         */
        SelectMultipleControlValueAccessor.prototype._registerOption = function (value) {
            /** @type {?} */
            var id = (this._idCounter++).toString();
            this._optionMap.set(id, value);
            return id;
        };
        /**
         * \@internal
         * @param {?} value
         * @return {?}
         */
        SelectMultipleControlValueAccessor.prototype._getOptionId = function (value) {
            var e_19, _b;
            try {
                for (var _c = __values(Array.from(this._optionMap.keys())), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var id = _d.value;
                    if (this._compareWith(( /** @type {?} */(this._optionMap.get(id)))._value, value))
                        return id;
                }
            }
            catch (e_19_1) { e_19 = { error: e_19_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
                }
                finally { if (e_19) throw e_19.error; }
            }
            return null;
        };
        /**
         * \@internal
         * @param {?} valueString
         * @return {?}
         */
        SelectMultipleControlValueAccessor.prototype._getOptionValue = function (valueString) {
            /** @type {?} */
            var id = _extractId$1(valueString);
            return this._optionMap.has(id) ? ( /** @type {?} */(this._optionMap.get(id)))._value : valueString;
        };
        return SelectMultipleControlValueAccessor;
    }());
    SelectMultipleControlValueAccessor.decorators = [
        { type: Directive, args: [{
                    selector: 'select[multiple][formControlName],select[multiple][formControl],select[multiple][ngModel]',
                    host: { '(change)': 'onChange($event.target)', '(blur)': 'onTouched()' },
                    providers: [SELECT_MULTIPLE_VALUE_ACCESSOR]
                },] }
    ];
    /** @nocollapse */
    SelectMultipleControlValueAccessor.ctorParameters = function () { return [
        { type: Renderer2 },
        { type: ElementRef }
    ]; };
    SelectMultipleControlValueAccessor.propDecorators = {
        compareWith: [{ type: Input }]
    };
    /**
     * \@description
     * Marks `<option>` as dynamic, so Angular can be notified when options change.
     *
     * @see `SelectMultipleControlValueAccessor`
     *
     * \@ngModule ReactiveFormsModule
     * \@ngModule FormsModule
     * \@publicApi
     */
    var ɵNgSelectMultipleOption = /** @class */ (function () {
        /**
         * @param {?} _element
         * @param {?} _renderer
         * @param {?} _select
         */
        function ɵNgSelectMultipleOption(_element, _renderer, _select) {
            this._element = _element;
            this._renderer = _renderer;
            this._select = _select;
            if (this._select) {
                this.id = this._select._registerOption(this);
            }
        }
        Object.defineProperty(ɵNgSelectMultipleOption.prototype, "ngValue", {
            /**
             * \@description
             * Tracks the value bound to the option element. Unlike the value binding,
             * ngValue supports binding to objects.
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                if (this._select == null)
                    return;
                this._value = value;
                this._setElementValue(_buildValueString$1(this.id, value));
                this._select.writeValue(this._select.value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ɵNgSelectMultipleOption.prototype, "value", {
            /**
             * \@description
             * Tracks simple string values bound to the option element.
             * For objects, use the `ngValue` input binding.
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                if (this._select) {
                    this._value = value;
                    this._setElementValue(_buildValueString$1(this.id, value));
                    this._select.writeValue(this._select.value);
                }
                else {
                    this._setElementValue(value);
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * \@internal
         * @param {?} value
         * @return {?}
         */
        ɵNgSelectMultipleOption.prototype._setElementValue = function (value) {
            this._renderer.setProperty(this._element.nativeElement, 'value', value);
        };
        /**
         * \@internal
         * @param {?} selected
         * @return {?}
         */
        ɵNgSelectMultipleOption.prototype._setSelected = function (selected) {
            this._renderer.setProperty(this._element.nativeElement, 'selected', selected);
        };
        /**
         * \@description
         * Lifecycle method called before the directive's instance is destroyed. For internal use only.
         * @return {?}
         */
        ɵNgSelectMultipleOption.prototype.ngOnDestroy = function () {
            if (this._select) {
                this._select._optionMap.delete(this.id);
                this._select.writeValue(this._select.value);
            }
        };
        return ɵNgSelectMultipleOption;
    }());
    ɵNgSelectMultipleOption.decorators = [
        { type: Directive, args: [{ selector: 'option' },] }
    ];
    /** @nocollapse */
    ɵNgSelectMultipleOption.ctorParameters = function () { return [
        { type: ElementRef },
        { type: Renderer2 },
        { type: SelectMultipleControlValueAccessor, decorators: [{ type: Optional }, { type: Host }] }
    ]; };
    ɵNgSelectMultipleOption.propDecorators = {
        ngValue: [{ type: Input, args: ['ngValue',] }],
        value: [{ type: Input, args: ['value',] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} name
     * @param {?} parent
     * @return {?}
     */
    function controlPath(name, parent) {
        return __spread(( /** @type {?} */(parent.path)), [name]);
    }
    /**
     * @param {?} control
     * @param {?} dir
     * @return {?}
     */
    function setUpControl(control, dir) {
        if (!control)
            _throwError$1(dir, 'Cannot find control with');
        if (!dir.valueAccessor)
            _throwError$1(dir, 'No value accessor for form control with');
        control.validator = Validators.compose([( /** @type {?} */(control.validator)), dir.validator]);
        control.asyncValidator = Validators.composeAsync([( /** @type {?} */(control.asyncValidator)), dir.asyncValidator]);
        ( /** @type {?} */(dir.valueAccessor)).writeValue(control.value);
        setUpViewChangePipeline(control, dir);
        setUpModelChangePipeline(control, dir);
        setUpBlurPipeline(control, dir);
        if (( /** @type {?} */(dir.valueAccessor)).setDisabledState) {
            control.registerOnDisabledChange(( /**
             * @param {?} isDisabled
             * @return {?}
             */function (isDisabled) { ( /** @type {?} */(( /** @type {?} */(dir.valueAccessor)).setDisabledState))(isDisabled); }));
        }
        // re-run validation when validator binding changes, e.g. minlength=3 -> minlength=4
        dir._rawValidators.forEach(( /**
         * @param {?} validator
         * @return {?}
         */function (validator) {
            if ((( /** @type {?} */(validator))).registerOnValidatorChange)
                ( /** @type {?} */((( /** @type {?} */(validator))).registerOnValidatorChange))(( /**
                 * @return {?}
                 */function () { return control.updateValueAndValidity(); }));
        }));
        dir._rawAsyncValidators.forEach(( /**
         * @param {?} validator
         * @return {?}
         */function (validator) {
            if ((( /** @type {?} */(validator))).registerOnValidatorChange)
                ( /** @type {?} */((( /** @type {?} */(validator))).registerOnValidatorChange))(( /**
                 * @return {?}
                 */function () { return control.updateValueAndValidity(); }));
        }));
    }
    /**
     * @param {?} control
     * @param {?} dir
     * @return {?}
     */
    function cleanUpControl(control, dir) {
        ( /** @type {?} */(dir.valueAccessor)).registerOnChange(( /**
         * @return {?}
         */function () { return _noControlError(dir); }));
        ( /** @type {?} */(dir.valueAccessor)).registerOnTouched(( /**
         * @return {?}
         */function () { return _noControlError(dir); }));
        dir._rawValidators.forEach(( /**
         * @param {?} validator
         * @return {?}
         */function (validator) {
            if (validator.registerOnValidatorChange) {
                validator.registerOnValidatorChange(null);
            }
        }));
        dir._rawAsyncValidators.forEach(( /**
         * @param {?} validator
         * @return {?}
         */function (validator) {
            if (validator.registerOnValidatorChange) {
                validator.registerOnValidatorChange(null);
            }
        }));
        if (control)
            control._clearChangeFns();
    }
    /**
     * @param {?} control
     * @param {?} dir
     * @return {?}
     */
    function setUpViewChangePipeline(control, dir) {
        ( /** @type {?} */(dir.valueAccessor)).registerOnChange(( /**
         * @param {?} newValue
         * @return {?}
         */function (newValue) {
            control._pendingValue = newValue;
            control._pendingChange = true;
            control._pendingDirty = true;
            if (control.updateOn === 'change')
                updateControl(control, dir);
        }));
    }
    /**
     * @param {?} control
     * @param {?} dir
     * @return {?}
     */
    function setUpBlurPipeline(control, dir) {
        ( /** @type {?} */(dir.valueAccessor)).registerOnTouched(( /**
         * @return {?}
         */function () {
            control._pendingTouched = true;
            if (control.updateOn === 'blur' && control._pendingChange)
                updateControl(control, dir);
            if (control.updateOn !== 'submit')
                control.markAsTouched();
        }));
    }
    /**
     * @param {?} control
     * @param {?} dir
     * @return {?}
     */
    function updateControl(control, dir) {
        if (control._pendingDirty)
            control.markAsDirty();
        control.setValue(control._pendingValue, { emitModelToViewChange: false });
        dir.viewToModelUpdate(control._pendingValue);
        control._pendingChange = false;
    }
    /**
     * @param {?} control
     * @param {?} dir
     * @return {?}
     */
    function setUpModelChangePipeline(control, dir) {
        control.registerOnChange(( /**
         * @param {?} newValue
         * @param {?} emitModelEvent
         * @return {?}
         */function (newValue, emitModelEvent) {
            // control -> view
            ( /** @type {?} */(dir.valueAccessor)).writeValue(newValue);
            // control -> ngModel
            if (emitModelEvent)
                dir.viewToModelUpdate(newValue);
        }));
    }
    /**
     * @param {?} control
     * @param {?} dir
     * @return {?}
     */
    function setUpFormContainer(control, dir) {
        if (control == null)
            _throwError$1(dir, 'Cannot find control with');
        control.validator = Validators.compose([control.validator, dir.validator]);
        control.asyncValidator = Validators.composeAsync([control.asyncValidator, dir.asyncValidator]);
    }
    /**
     * @param {?} dir
     * @return {?}
     */
    function _noControlError(dir) {
        return _throwError$1(dir, 'There is no FormControl instance attached to form control element with');
    }
    /**
     * @param {?} dir
     * @param {?} message
     * @return {?}
     */
    function _throwError$1(dir, message) {
        /** @type {?} */
        var messageEnd;
        if (( /** @type {?} */(dir.path)).length > 1) {
            messageEnd = "path: '" + ( /** @type {?} */(dir.path)).join(' -> ') + "'";
        }
        else if (( /** @type {?} */(dir.path))[0]) {
            messageEnd = "name: '" + dir.path + "'";
        }
        else {
            messageEnd = 'unspecified name attribute';
        }
        throw new Error(message + " " + messageEnd);
    }
    /**
     * @param {?} validators
     * @return {?}
     */
    function composeValidators(validators) {
        return validators != null ? Validators.compose(validators.map(normalizeValidator)) : null;
    }
    /**
     * @param {?} validators
     * @return {?}
     */
    function composeAsyncValidators(validators) {
        return validators != null ? Validators.composeAsync(validators.map(normalizeAsyncValidator)) :
            null;
    }
    /**
     * @param {?} changes
     * @param {?} viewModel
     * @return {?}
     */
    function isPropertyUpdated(changes, viewModel) {
        if (!changes.hasOwnProperty('model'))
            return false;
        /** @type {?} */
        var change = changes['model'];
        if (change.isFirstChange())
            return true;
        return !looseIdentical(viewModel, change.currentValue);
    }
    /** @type {?} */
    var BUILTIN_ACCESSORS = [
        CheckboxControlValueAccessor,
        RangeValueAccessor,
        NumberValueAccessor,
        SelectControlValueAccessor,
        SelectMultipleControlValueAccessor,
        RadioControlValueAccessor,
    ];
    /**
     * @param {?} valueAccessor
     * @return {?}
     */
    function isBuiltInAccessor(valueAccessor) {
        return BUILTIN_ACCESSORS.some(( /**
         * @param {?} a
         * @return {?}
         */function (/**
         * @param {?} a
         * @return {?}
         */ a) { return valueAccessor.constructor === a; }));
    }
    /**
     * @param {?} form
     * @param {?} directives
     * @return {?}
     */
    function syncPendingControls(form, directives) {
        form._syncPendingControls();
        directives.forEach(( /**
         * @param {?} dir
         * @return {?}
         */function (/**
         * @param {?} dir
         * @return {?}
         */ dir) {
            /** @type {?} */
            var control = ( /** @type {?} */(dir.control));
            if (control.updateOn === 'submit' && control._pendingChange) {
                dir.viewToModelUpdate(control._pendingValue);
                control._pendingChange = false;
            }
        }));
    }
    // TODO: vsavkin remove it once https://github.com/angular/angular/issues/3011 is implemented
    /**
     * @param {?} dir
     * @param {?} valueAccessors
     * @return {?}
     */
    function selectValueAccessor(dir, valueAccessors) {
        if (!valueAccessors)
            return null;
        if (!Array.isArray(valueAccessors))
            _throwError$1(dir, 'Value accessor was not provided as an array for form control with');
        /** @type {?} */
        var defaultAccessor = undefined;
        /** @type {?} */
        var builtinAccessor = undefined;
        /** @type {?} */
        var customAccessor = undefined;
        valueAccessors.forEach(( /**
         * @param {?} v
         * @return {?}
         */function (v) {
            if (v.constructor === DefaultValueAccessor) {
                defaultAccessor = v;
            }
            else if (isBuiltInAccessor(v)) {
                if (builtinAccessor)
                    _throwError$1(dir, 'More than one built-in value accessor matches form control with');
                builtinAccessor = v;
            }
            else {
                if (customAccessor)
                    _throwError$1(dir, 'More than one custom value accessor matches form control with');
                customAccessor = v;
            }
        }));
        if (customAccessor)
            return customAccessor;
        if (builtinAccessor)
            return builtinAccessor;
        if (defaultAccessor)
            return defaultAccessor;
        _throwError$1(dir, 'No valid value accessor for form control with');
        return null;
    }
    /**
     * @template T
     * @param {?} list
     * @param {?} el
     * @return {?}
     */
    function removeDir(list, el) {
        /** @type {?} */
        var index = list.indexOf(el);
        if (index > -1)
            list.splice(index, 1);
    }
    // TODO(kara): remove after deprecation period
    /**
     * @param {?} name
     * @param {?} type
     * @param {?} instance
     * @param {?} warningConfig
     * @return {?}
     */
    function _ngModelWarning(name, type, instance, warningConfig) {
        if (!isDevMode() || warningConfig === 'never')
            return;
        if (((warningConfig === null || warningConfig === 'once') && !type._ngModelWarningSentOnce) ||
            (warningConfig === 'always' && !instance._ngModelWarningSent)) {
            ReactiveErrors.ngModelWarning(name);
            type._ngModelWarningSentOnce = true;
            instance._ngModelWarningSent = true;
        }
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Reports that a FormControl is valid, meaning that no errors exist in the input value.
     *
     * @see `status`
     * @type {?}
     */
    var VALID = 'VALID';
    /**
     * Reports that a FormControl is invalid, meaning that an error exists in the input value.
     *
     * @see `status`
     * @type {?}
     */
    var INVALID = 'INVALID';
    /**
     * Reports that a FormControl is pending, meaning that that async validation is occurring and
     * errors are not yet available for the input value.
     *
     * @see `markAsPending`
     * @see `status`
     * @type {?}
     */
    var PENDING = 'PENDING';
    /**
     * Reports that a FormControl is disabled, meaning that the control is exempt from ancestor
     * calculations of validity or value.
     *
     * @see `markAsDisabled`
     * @see `status`
     * @type {?}
     */
    var DISABLED = 'DISABLED';
    /**
     * @param {?} control
     * @param {?} path
     * @param {?} delimiter
     * @return {?}
     */
    function _find(control, path, delimiter) {
        if (path == null)
            return null;
        if (!(path instanceof Array)) {
            path = (( /** @type {?} */(path))).split(delimiter);
        }
        if (path instanceof Array && (path.length === 0))
            return null;
        return (( /** @type {?} */(path))).reduce(( /**
         * @param {?} v
         * @param {?} name
         * @return {?}
         */function (v, name) {
            if (v instanceof FormGroup) {
                return v.controls.hasOwnProperty(( /** @type {?} */(name))) ? v.controls[name] : null;
            }
            if (v instanceof FormArray) {
                return v.at(( /** @type {?} */(name))) || null;
            }
            return null;
        }), control);
    }
    /**
     * @param {?=} validatorOrOpts
     * @return {?}
     */
    function coerceToValidator(validatorOrOpts) {
        /** @type {?} */
        var validator = ( /** @type {?} */((isOptionsObj(validatorOrOpts) ? (( /** @type {?} */(validatorOrOpts))).validators :
            validatorOrOpts)));
        return Array.isArray(validator) ? composeValidators(validator) : validator || null;
    }
    /**
     * @param {?=} asyncValidator
     * @param {?=} validatorOrOpts
     * @return {?}
     */
    function coerceToAsyncValidator(asyncValidator, validatorOrOpts) {
        /** @type {?} */
        var origAsyncValidator = ( /** @type {?} */((isOptionsObj(validatorOrOpts) ? (( /** @type {?} */(validatorOrOpts))).asyncValidators :
            asyncValidator)));
        return Array.isArray(origAsyncValidator) ? composeAsyncValidators(origAsyncValidator) :
            origAsyncValidator || null;
    }
    /**
     * @param {?=} validatorOrOpts
     * @return {?}
     */
    function isOptionsObj(validatorOrOpts) {
        return validatorOrOpts != null && !Array.isArray(validatorOrOpts) &&
            typeof validatorOrOpts === 'object';
    }
    /**
     * This is the base class for `FormControl`, `FormGroup`, and `FormArray`.
     *
     * It provides some of the shared behavior that all controls and groups of controls have, like
     * running validators, calculating status, and resetting state. It also defines the properties
     * that are shared between all sub-classes, like `value`, `valid`, and `dirty`. It shouldn't be
     * instantiated directly.
     *
     * @see [Forms Guide](/guide/forms)
     * @see [Reactive Forms Guide](/guide/reactive-forms)
     * @see [Dynamic Forms Guide](/guide/dynamic-form)
     *
     * \@publicApi
     * @abstract
     */
    var AbstractControl = /** @class */ (function () {
        /**
         * Initialize the AbstractControl instance.
         *
         * @param {?} validator The function that determines the synchronous validity of this control.
         * @param {?} asyncValidator The function that determines the asynchronous validity of this
         * control.
         */
        function AbstractControl(validator, asyncValidator) {
            this.validator = validator;
            this.asyncValidator = asyncValidator;
            /**
             * \@internal
             */
            this._onCollectionChange = ( /**
             * @return {?}
             */function () { });
            /**
             * A control is `pristine` if the user has not yet changed
             * the value in the UI.
             *
             * @return True if the user has not yet changed the value in the UI; compare `dirty`.
             * Programmatic changes to a control's value do not mark it dirty.
             */
            this.pristine = true;
            /**
             * True if the control is marked as `touched`.
             *
             * A control is marked `touched` once the user has triggered
             * a `blur` event on it.
             */
            this.touched = false;
            /**
             * \@internal
             */
            this._onDisabledChange = [];
        }
        Object.defineProperty(AbstractControl.prototype, "parent", {
            /**
             * The parent control.
             * @return {?}
             */
            get: function () { return this._parent; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractControl.prototype, "valid", {
            /**
             * A control is `valid` when its `status` is `VALID`.
             *
             * @see {\@link AbstractControl.status}
             *
             * @return {?} True if the control has passed all of its validation tests,
             * false otherwise.
             */
            get: function () { return this.status === VALID; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractControl.prototype, "invalid", {
            /**
             * A control is `invalid` when its `status` is `INVALID`.
             *
             * @see {\@link AbstractControl.status}
             *
             * @return {?} True if this control has failed one or more of its validation checks,
             * false otherwise.
             */
            get: function () { return this.status === INVALID; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractControl.prototype, "pending", {
            /**
             * A control is `pending` when its `status` is `PENDING`.
             *
             * @see {\@link AbstractControl.status}
             *
             * @return {?} True if this control is in the process of conducting a validation check,
             * false otherwise.
             */
            get: function () { return this.status == PENDING; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractControl.prototype, "disabled", {
            /**
             * A control is `disabled` when its `status` is `DISABLED`.
             *
             * Disabled controls are exempt from validation checks and
             * are not included in the aggregate value of their ancestor
             * controls.
             *
             * @see {\@link AbstractControl.status}
             *
             * @return {?} True if the control is disabled, false otherwise.
             */
            get: function () { return this.status === DISABLED; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractControl.prototype, "enabled", {
            /**
             * A control is `enabled` as long as its `status` is not `DISABLED`.
             *
             * @see {\@link AbstractControl.status}
             *
             * @return {?} True if the control has any status other than 'DISABLED',
             * false if the status is 'DISABLED'.
             *
             */
            get: function () { return this.status !== DISABLED; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractControl.prototype, "dirty", {
            /**
             * A control is `dirty` if the user has changed the value
             * in the UI.
             *
             * @return {?} True if the user has changed the value of this control in the UI; compare `pristine`.
             * Programmatic changes to a control's value do not mark it dirty.
             */
            get: function () { return !this.pristine; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractControl.prototype, "untouched", {
            /**
             * True if the control has not been marked as touched
             *
             * A control is `untouched` if the user has not yet triggered
             * a `blur` event on it.
             * @return {?}
             */
            get: function () { return !this.touched; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractControl.prototype, "updateOn", {
            /**
             * Reports the update strategy of the `AbstractControl` (meaning
             * the event on which the control updates itself).
             * Possible values: `'change'` | `'blur'` | `'submit'`
             * Default value: `'change'`
             * @return {?}
             */
            get: function () {
                return this._updateOn ? this._updateOn : (this.parent ? this.parent.updateOn : 'change');
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Sets the synchronous validators that are active on this control.  Calling
         * this overwrites any existing sync validators.
         *
         * When you add or remove a validator at run time, you must call
         * `updateValueAndValidity()` for the new validation to take effect.
         *
         * @param {?} newValidator
         * @return {?}
         */
        AbstractControl.prototype.setValidators = function (newValidator) {
            this.validator = coerceToValidator(newValidator);
        };
        /**
         * Sets the async validators that are active on this control. Calling this
         * overwrites any existing async validators.
         *
         * When you add or remove a validator at run time, you must call
         * `updateValueAndValidity()` for the new validation to take effect.
         *
         * @param {?} newValidator
         * @return {?}
         */
        AbstractControl.prototype.setAsyncValidators = function (newValidator) {
            this.asyncValidator = coerceToAsyncValidator(newValidator);
        };
        /**
         * Empties out the sync validator list.
         *
         * When you add or remove a validator at run time, you must call
         * `updateValueAndValidity()` for the new validation to take effect.
         *
         * @return {?}
         */
        AbstractControl.prototype.clearValidators = function () { this.validator = null; };
        /**
         * Empties out the async validator list.
         *
         * When you add or remove a validator at run time, you must call
         * `updateValueAndValidity()` for the new validation to take effect.
         *
         * @return {?}
         */
        AbstractControl.prototype.clearAsyncValidators = function () { this.asyncValidator = null; };
        /**
         * Marks the control as `touched`. A control is touched by focus and
         * blur events that do not change the value.
         *
         * @see `markAsUntouched()` / `markAsDirty()` / `markAsPristine()`
         *
         * @param {?=} opts Configuration options that determine how the control propagates changes
         * and emits events events after marking is applied.
         * * `onlySelf`: When true, mark only this control. When false or not supplied,
         * marks all direct ancestors. Default is false.
         * @return {?}
         */
        AbstractControl.prototype.markAsTouched = function (opts) {
            if (opts === void 0) { opts = {}; }
            (( /** @type {?} */(this))).touched = true;
            if (this._parent && !opts.onlySelf) {
                this._parent.markAsTouched(opts);
            }
        };
        /**
         * Marks the control and all its descendant controls as `touched`.
         * @see `markAsTouched()`
         * @return {?}
         */
        AbstractControl.prototype.markAllAsTouched = function () {
            this.markAsTouched({ onlySelf: true });
            this._forEachChild(( /**
             * @param {?} control
             * @return {?}
             */function (control) { return control.markAllAsTouched(); }));
        };
        /**
         * Marks the control as `untouched`.
         *
         * If the control has any children, also marks all children as `untouched`
         * and recalculates the `touched` status of all parent controls.
         *
         * @see `markAsTouched()` / `markAsDirty()` / `markAsPristine()`
         *
         * @param {?=} opts Configuration options that determine how the control propagates changes
         * and emits events after the marking is applied.
         * * `onlySelf`: When true, mark only this control. When false or not supplied,
         * marks all direct ancestors. Default is false.
         * @return {?}
         */
        AbstractControl.prototype.markAsUntouched = function (opts) {
            if (opts === void 0) { opts = {}; }
            (( /** @type {?} */(this))).touched = false;
            this._pendingTouched = false;
            this._forEachChild(( /**
             * @param {?} control
             * @return {?}
             */function (control) { control.markAsUntouched({ onlySelf: true }); }));
            if (this._parent && !opts.onlySelf) {
                this._parent._updateTouched(opts);
            }
        };
        /**
         * Marks the control as `dirty`. A control becomes dirty when
         * the control's value is changed through the UI; compare `markAsTouched`.
         *
         * @see `markAsTouched()` / `markAsUntouched()` / `markAsPristine()`
         *
         * @param {?=} opts Configuration options that determine how the control propagates changes
         * and emits events after marking is applied.
         * * `onlySelf`: When true, mark only this control. When false or not supplied,
         * marks all direct ancestors. Default is false.
         * @return {?}
         */
        AbstractControl.prototype.markAsDirty = function (opts) {
            if (opts === void 0) { opts = {}; }
            (( /** @type {?} */(this))).pristine = false;
            if (this._parent && !opts.onlySelf) {
                this._parent.markAsDirty(opts);
            }
        };
        /**
         * Marks the control as `pristine`.
         *
         * If the control has any children, marks all children as `pristine`,
         * and recalculates the `pristine` status of all parent
         * controls.
         *
         * @see `markAsTouched()` / `markAsUntouched()` / `markAsDirty()`
         *
         * @param {?=} opts Configuration options that determine how the control emits events after
         * marking is applied.
         * * `onlySelf`: When true, mark only this control. When false or not supplied,
         * marks all direct ancestors. Default is false..
         * @return {?}
         */
        AbstractControl.prototype.markAsPristine = function (opts) {
            if (opts === void 0) { opts = {}; }
            (( /** @type {?} */(this))).pristine = true;
            this._pendingDirty = false;
            this._forEachChild(( /**
             * @param {?} control
             * @return {?}
             */function (control) { control.markAsPristine({ onlySelf: true }); }));
            if (this._parent && !opts.onlySelf) {
                this._parent._updatePristine(opts);
            }
        };
        /**
         * Marks the control as `pending`.
         *
         * A control is pending while the control performs async validation.
         *
         * @see {\@link AbstractControl.status}
         *
         * @param {?=} opts Configuration options that determine how the control propagates changes and
         * emits events after marking is applied.
         * * `onlySelf`: When true, mark only this control. When false or not supplied,
         * marks all direct ancestors. Default is false..
         * * `emitEvent`: When true or not supplied (the default), the `statusChanges`
         * observable emits an event with the latest status the control is marked pending.
         * When false, no events are emitted.
         *
         * @return {?}
         */
        AbstractControl.prototype.markAsPending = function (opts) {
            if (opts === void 0) { opts = {}; }
            (( /** @type {?} */(this))).status = PENDING;
            if (opts.emitEvent !== false) {
                (( /** @type {?} */(this.statusChanges))).emit(this.status);
            }
            if (this._parent && !opts.onlySelf) {
                this._parent.markAsPending(opts);
            }
        };
        /**
         * Disables the control. This means the control is exempt from validation checks and
         * excluded from the aggregate value of any parent. Its status is `DISABLED`.
         *
         * If the control has children, all children are also disabled.
         *
         * @see {\@link AbstractControl.status}
         *
         * @param {?=} opts Configuration options that determine how the control propagates
         * changes and emits events after the control is disabled.
         * * `onlySelf`: When true, mark only this control. When false or not supplied,
         * marks all direct ancestors. Default is false..
         * * `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
         * `valueChanges`
         * observables emit events with the latest status and value when the control is disabled.
         * When false, no events are emitted.
         * @return {?}
         */
        AbstractControl.prototype.disable = function (opts) {
            if (opts === void 0) { opts = {}; }
            // If parent has been marked artificially dirty we don't want to re-calculate the
            // parent's dirtiness based on the children.
            /** @type {?} */
            var skipPristineCheck = this._parentMarkedDirty(opts.onlySelf);
            (( /** @type {?} */(this))).status = DISABLED;
            (( /** @type {?} */(this))).errors = null;
            this._forEachChild(( /**
             * @param {?} control
             * @return {?}
             */function (control) { control.disable(Object.assign({}, opts, { onlySelf: true })); }));
            this._updateValue();
            if (opts.emitEvent !== false) {
                (( /** @type {?} */(this.valueChanges))).emit(this.value);
                (( /** @type {?} */(this.statusChanges))).emit(this.status);
            }
            this._updateAncestors(Object.assign({}, opts, { skipPristineCheck: skipPristineCheck }));
            this._onDisabledChange.forEach(( /**
             * @param {?} changeFn
             * @return {?}
             */function (changeFn) { return changeFn(true); }));
        };
        /**
         * Enables the control. This means the control is included in validation checks and
         * the aggregate value of its parent. Its status recalculates based on its value and
         * its validators.
         *
         * By default, if the control has children, all children are enabled.
         *
         * @see {\@link AbstractControl.status}
         *
         * @param {?=} opts Configure options that control how the control propagates changes and
         * emits events when marked as untouched
         * * `onlySelf`: When true, mark only this control. When false or not supplied,
         * marks all direct ancestors. Default is false..
         * * `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
         * `valueChanges`
         * observables emit events with the latest status and value when the control is enabled.
         * When false, no events are emitted.
         * @return {?}
         */
        AbstractControl.prototype.enable = function (opts) {
            if (opts === void 0) { opts = {}; }
            // If parent has been marked artificially dirty we don't want to re-calculate the
            // parent's dirtiness based on the children.
            /** @type {?} */
            var skipPristineCheck = this._parentMarkedDirty(opts.onlySelf);
            (( /** @type {?} */(this))).status = VALID;
            this._forEachChild(( /**
             * @param {?} control
             * @return {?}
             */function (control) { control.enable(Object.assign({}, opts, { onlySelf: true })); }));
            this.updateValueAndValidity({ onlySelf: true, emitEvent: opts.emitEvent });
            this._updateAncestors(Object.assign({}, opts, { skipPristineCheck: skipPristineCheck }));
            this._onDisabledChange.forEach(( /**
             * @param {?} changeFn
             * @return {?}
             */function (changeFn) { return changeFn(false); }));
        };
        /**
         * @private
         * @param {?} opts
         * @return {?}
         */
        AbstractControl.prototype._updateAncestors = function (opts) {
            if (this._parent && !opts.onlySelf) {
                this._parent.updateValueAndValidity(opts);
                if (!opts.skipPristineCheck) {
                    this._parent._updatePristine();
                }
                this._parent._updateTouched();
            }
        };
        /**
         * @param {?} parent Sets the parent of the control
         * @return {?}
         */
        AbstractControl.prototype.setParent = function (parent) { this._parent = parent; };
        /**
         * Recalculates the value and validation status of the control.
         *
         * By default, it also updates the value and validity of its ancestors.
         *
         * @param {?=} opts Configuration options determine how the control propagates changes and emits events
         * after updates and validity checks are applied.
         * * `onlySelf`: When true, only update this control. When false or not supplied,
         * update all direct ancestors. Default is false..
         * * `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
         * `valueChanges`
         * observables emit events with the latest status and value when the control is updated.
         * When false, no events are emitted.
         * @return {?}
         */
        AbstractControl.prototype.updateValueAndValidity = function (opts) {
            if (opts === void 0) { opts = {}; }
            this._setInitialStatus();
            this._updateValue();
            if (this.enabled) {
                this._cancelExistingSubscription();
                (( /** @type {?} */(this))).errors = this._runValidator();
                (( /** @type {?} */(this))).status = this._calculateStatus();
                if (this.status === VALID || this.status === PENDING) {
                    this._runAsyncValidator(opts.emitEvent);
                }
            }
            if (opts.emitEvent !== false) {
                (( /** @type {?} */(this.valueChanges))).emit(this.value);
                (( /** @type {?} */(this.statusChanges))).emit(this.status);
            }
            if (this._parent && !opts.onlySelf) {
                this._parent.updateValueAndValidity(opts);
            }
        };
        /**
         * \@internal
         * @param {?=} opts
         * @return {?}
         */
        AbstractControl.prototype._updateTreeValidity = function (opts) {
            if (opts === void 0) { opts = { emitEvent: true }; }
            this._forEachChild(( /**
             * @param {?} ctrl
             * @return {?}
             */function (ctrl) { return ctrl._updateTreeValidity(opts); }));
            this.updateValueAndValidity({ onlySelf: true, emitEvent: opts.emitEvent });
        };
        /**
         * @private
         * @return {?}
         */
        AbstractControl.prototype._setInitialStatus = function () {
            (( /** @type {?} */(this))).status = this._allControlsDisabled() ? DISABLED : VALID;
        };
        /**
         * @private
         * @return {?}
         */
        AbstractControl.prototype._runValidator = function () {
            return this.validator ? this.validator(this) : null;
        };
        /**
         * @private
         * @param {?=} emitEvent
         * @return {?}
         */
        AbstractControl.prototype._runAsyncValidator = function (emitEvent) {
            var _this = this;
            if (this.asyncValidator) {
                (( /** @type {?} */(this))).status = PENDING;
                /** @type {?} */
                var obs = toObservable(this.asyncValidator(this));
                this._asyncValidationSubscription =
                    obs.subscribe(( /**
                     * @param {?} errors
                     * @return {?}
                     */function (errors) { return _this.setErrors(errors, { emitEvent: emitEvent }); }));
            }
        };
        /**
         * @private
         * @return {?}
         */
        AbstractControl.prototype._cancelExistingSubscription = function () {
            if (this._asyncValidationSubscription) {
                this._asyncValidationSubscription.unsubscribe();
            }
        };
        /**
         * Sets errors on a form control when running validations manually, rather than automatically.
         *
         * Calling `setErrors` also updates the validity of the parent control.
         *
         * \@usageNotes
         * ### Manually set the errors for a control
         *
         * ```
         * const login = new FormControl('someLogin');
         * login.setErrors({
         *   notUnique: true
         * });
         *
         * expect(login.valid).toEqual(false);
         * expect(login.errors).toEqual({ notUnique: true });
         *
         * login.setValue('someOtherLogin');
         *
         * expect(login.valid).toEqual(true);
         * ```
         * @param {?} errors
         * @param {?=} opts
         * @return {?}
         */
        AbstractControl.prototype.setErrors = function (errors, opts) {
            if (opts === void 0) { opts = {}; }
            (( /** @type {?} */(this))).errors = errors;
            this._updateControlsErrors(opts.emitEvent !== false);
        };
        /**
         * Retrieves a child control given the control's name or path.
         *
         * \@usageNotes
         * ### Retrieve a nested control
         *
         * For example, to get a `name` control nested within a `person` sub-group:
         *
         * * `this.form.get('person.name');`
         *
         * -OR-
         *
         * * `this.form.get(['person', 'name']);`
         * @param {?} path A dot-delimited string or array of string/number values that define the path to the
         * control.
         *
         * @return {?}
         */
        AbstractControl.prototype.get = function (path) { return _find(this, path, '.'); };
        /**
         * \@description
         * Reports error data for the control with the given path.
         *
         * \@usageNotes
         * For example, for the following `FormGroup`:
         *
         * ```
         * form = new FormGroup({
         *   address: new FormGroup({ street: new FormControl() })
         * });
         * ```
         *
         * The path to the 'street' control from the root form would be 'address' -> 'street'.
         *
         * It can be provided to this method in one of two formats:
         *
         * 1. An array of string control names, e.g. `['address', 'street']`
         * 1. A period-delimited list of control names in one string, e.g. `'address.street'`
         *
         * @param {?} errorCode The code of the error to check
         * @param {?=} path A list of control names that designates how to move from the current control
         * to the control that should be queried for errors.
         *
         * @return {?} error data for that particular error. If the control or error is not present,
         * null is returned.
         */
        AbstractControl.prototype.getError = function (errorCode, path) {
            /** @type {?} */
            var control = path ? this.get(path) : this;
            return control && control.errors ? control.errors[errorCode] : null;
        };
        /**
         * \@description
         * Reports whether the control with the given path has the error specified.
         *
         * \@usageNotes
         * For example, for the following `FormGroup`:
         *
         * ```
         * form = new FormGroup({
         *   address: new FormGroup({ street: new FormControl() })
         * });
         * ```
         *
         * The path to the 'street' control from the root form would be 'address' -> 'street'.
         *
         * It can be provided to this method in one of two formats:
         *
         * 1. An array of string control names, e.g. `['address', 'street']`
         * 1. A period-delimited list of control names in one string, e.g. `'address.street'`
         *
         * If no path is given, this method checks for the error on the current control.
         *
         * @param {?} errorCode The code of the error to check
         * @param {?=} path A list of control names that designates how to move from the current control
         * to the control that should be queried for errors.
         *
         * @return {?} whether the given error is present in the control at the given path.
         *
         * If the control is not present, false is returned.
         */
        AbstractControl.prototype.hasError = function (errorCode, path) {
            return !!this.getError(errorCode, path);
        };
        Object.defineProperty(AbstractControl.prototype, "root", {
            /**
             * Retrieves the top-level ancestor of this control.
             * @return {?}
             */
            get: function () {
                /** @type {?} */
                var x = this;
                while (x._parent) {
                    x = x._parent;
                }
                return x;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * \@internal
         * @param {?} emitEvent
         * @return {?}
         */
        AbstractControl.prototype._updateControlsErrors = function (emitEvent) {
            (( /** @type {?} */(this))).status = this._calculateStatus();
            if (emitEvent) {
                (( /** @type {?} */(this.statusChanges))).emit(this.status);
            }
            if (this._parent) {
                this._parent._updateControlsErrors(emitEvent);
            }
        };
        /**
         * \@internal
         * @return {?}
         */
        AbstractControl.prototype._initObservables = function () {
            (( /** @type {?} */(this))).valueChanges = new EventEmitter();
            (( /** @type {?} */(this))).statusChanges = new EventEmitter();
        };
        /**
         * @private
         * @return {?}
         */
        AbstractControl.prototype._calculateStatus = function () {
            if (this._allControlsDisabled())
                return DISABLED;
            if (this.errors)
                return INVALID;
            if (this._anyControlsHaveStatus(PENDING))
                return PENDING;
            if (this._anyControlsHaveStatus(INVALID))
                return INVALID;
            return VALID;
        };
        /**
         * \@internal
         * @param {?} status
         * @return {?}
         */
        AbstractControl.prototype._anyControlsHaveStatus = function (status) {
            return this._anyControls(( /**
             * @param {?} control
             * @return {?}
             */function (control) { return control.status === status; }));
        };
        /**
         * \@internal
         * @return {?}
         */
        AbstractControl.prototype._anyControlsDirty = function () {
            return this._anyControls(( /**
             * @param {?} control
             * @return {?}
             */function (control) { return control.dirty; }));
        };
        /**
         * \@internal
         * @return {?}
         */
        AbstractControl.prototype._anyControlsTouched = function () {
            return this._anyControls(( /**
             * @param {?} control
             * @return {?}
             */function (control) { return control.touched; }));
        };
        /**
         * \@internal
         * @param {?=} opts
         * @return {?}
         */
        AbstractControl.prototype._updatePristine = function (opts) {
            if (opts === void 0) { opts = {}; }
            (( /** @type {?} */(this))).pristine = !this._anyControlsDirty();
            if (this._parent && !opts.onlySelf) {
                this._parent._updatePristine(opts);
            }
        };
        /**
         * \@internal
         * @param {?=} opts
         * @return {?}
         */
        AbstractControl.prototype._updateTouched = function (opts) {
            if (opts === void 0) { opts = {}; }
            (( /** @type {?} */(this))).touched = this._anyControlsTouched();
            if (this._parent && !opts.onlySelf) {
                this._parent._updateTouched(opts);
            }
        };
        /**
         * \@internal
         * @param {?} formState
         * @return {?}
         */
        AbstractControl.prototype._isBoxedValue = function (formState) {
            return typeof formState === 'object' && formState !== null &&
                Object.keys(formState).length === 2 && 'value' in formState && 'disabled' in formState;
        };
        /**
         * \@internal
         * @param {?} fn
         * @return {?}
         */
        AbstractControl.prototype._registerOnCollectionChange = function (fn) { this._onCollectionChange = fn; };
        /**
         * \@internal
         * @param {?=} opts
         * @return {?}
         */
        AbstractControl.prototype._setUpdateStrategy = function (opts) {
            if (isOptionsObj(opts) && (( /** @type {?} */(opts))).updateOn != null) {
                this._updateOn = ( /** @type {?} */((( /** @type {?} */(opts))).updateOn));
            }
        };
        /**
         * Check to see if parent has been marked artificially dirty.
         *
         * \@internal
         * @private
         * @param {?=} onlySelf
         * @return {?}
         */
        AbstractControl.prototype._parentMarkedDirty = function (onlySelf) {
            /** @type {?} */
            var parentDirty = this._parent && this._parent.dirty;
            return !onlySelf && parentDirty && !this._parent._anyControlsDirty();
        };
        return AbstractControl;
    }());
    /**
     * Tracks the value and validation status of an individual form control.
     *
     * This is one of the three fundamental building blocks of Angular forms, along with
     * `FormGroup` and `FormArray`. It extends the `AbstractControl` class that
     * implements most of the base functionality for accessing the value, validation status,
     * user interactions and events.
     *
     * @see `AbstractControl`
     * @see [Reactive Forms Guide](guide/reactive-forms)
     * @see [Usage Notes](#usage-notes)
     *
     * \@usageNotes
     *
     * ### Initializing Form Controls
     *
     * Instantiate a `FormControl`, with an initial value.
     *
     * ```ts
     * const control = new FormControl('some value');
     * console.log(control.value);     // 'some value'
     * ```
     *
     * The following example initializes the control with a form state object. The `value`
     * and `disabled` keys are required in this case.
     *
     * ```ts
     * const control = new FormControl({ value: 'n/a', disabled: true });
     * console.log(control.value);     // 'n/a'
     * console.log(control.status);    // 'DISABLED'
     * ```
     *
     * The following example initializes the control with a sync validator.
     *
     * ```ts
     * const control = new FormControl('', Validators.required);
     * console.log(control.value);      // ''
     * console.log(control.status);     // 'INVALID'
     * ```
     *
     * The following example initializes the control using an options object.
     *
     * ```ts
     * const control = new FormControl('', {
     *    validators: Validators.required,
     *    asyncValidators: myAsyncValidator
     * });
     * ```
     *
     * ### Configure the control to update on a blur event
     *
     * Set the `updateOn` option to `'blur'` to update on the blur `event`.
     *
     * ```ts
     * const control = new FormControl('', { updateOn: 'blur' });
     * ```
     *
     * ### Configure the control to update on a submit event
     *
     * Set the `updateOn` option to `'submit'` to update on a submit `event`.
     *
     * ```ts
     * const control = new FormControl('', { updateOn: 'submit' });
     * ```
     *
     * ### Reset the control back to an initial value
     *
     * You reset to a specific form state by passing through a standalone
     * value or a form state object that contains both a value and a disabled state
     * (these are the only two properties that cannot be calculated).
     *
     * ```ts
     * const control = new FormControl('Nancy');
     *
     * console.log(control.value); // 'Nancy'
     *
     * control.reset('Drew');
     *
     * console.log(control.value); // 'Drew'
     * ```
     *
     * ### Reset the control back to an initial value and disabled
     *
     * ```
     * const control = new FormControl('Nancy');
     *
     * console.log(control.value); // 'Nancy'
     * console.log(control.status); // 'VALID'
     *
     * control.reset({ value: 'Drew', disabled: true });
     *
     * console.log(control.value); // 'Drew'
     * console.log(control.status); // 'DISABLED'
     * ```
     *
     * \@publicApi
     */
    var FormControl = /** @class */ (function (_super) {
        __extends(FormControl, _super);
        /**
         * Creates a new `FormControl` instance.
         *
         * @param {?=} formState Initializes the control with an initial value,
         * or an object that defines the initial value and disabled state.
         *
         * @param {?=} validatorOrOpts A synchronous validator function, or an array of
         * such functions, or an `AbstractControlOptions` object that contains validation functions
         * and a validation trigger.
         *
         * @param {?=} asyncValidator A single async validator or array of async validator functions
         *
         */
        function FormControl(formState, validatorOrOpts, asyncValidator) {
            if (formState === void 0) { formState = null; }
            var _this = _super.call(this, coerceToValidator(validatorOrOpts), coerceToAsyncValidator(asyncValidator, validatorOrOpts)) || this;
            /**
             * \@internal
             */
            _this._onChange = [];
            _this._applyFormState(formState);
            _this._setUpdateStrategy(validatorOrOpts);
            _this.updateValueAndValidity({ onlySelf: true, emitEvent: false });
            _this._initObservables();
            return _this;
        }
        /**
         * Sets a new value for the form control.
         *
         * @param {?} value The new value for the control.
         * @param {?=} options Configuration options that determine how the control propagates changes
         * and emits events when the value changes.
         * The configuration options are passed to the {\@link AbstractControl#updateValueAndValidity
         * updateValueAndValidity} method.
         *
         * * `onlySelf`: When true, each change only affects this control, and not its parent. Default is
         * false.
         * * `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
         * `valueChanges`
         * observables emit events with the latest status and value when the control value is updated.
         * When false, no events are emitted.
         * * `emitModelToViewChange`: When true or not supplied  (the default), each change triggers an
         * `onChange` event to
         * update the view.
         * * `emitViewToModelChange`: When true or not supplied (the default), each change triggers an
         * `ngModelChange`
         * event to update the model.
         *
         * @return {?}
         */
        FormControl.prototype.setValue = function (value, options) {
            var _this = this;
            if (options === void 0) { options = {}; }
            (( /** @type {?} */(this))).value = this._pendingValue = value;
            if (this._onChange.length && options.emitModelToViewChange !== false) {
                this._onChange.forEach(( /**
                 * @param {?} changeFn
                 * @return {?}
                 */function (changeFn) { return changeFn(_this.value, options.emitViewToModelChange !== false); }));
            }
            this.updateValueAndValidity(options);
        };
        /**
         * Patches the value of a control.
         *
         * This function is functionally the same as {\@link FormControl#setValue setValue} at this level.
         * It exists for symmetry with {\@link FormGroup#patchValue patchValue} on `FormGroups` and
         * `FormArrays`, where it does behave differently.
         *
         * @see `setValue` for options
         * @param {?} value
         * @param {?=} options
         * @return {?}
         */
        FormControl.prototype.patchValue = function (value, options) {
            if (options === void 0) { options = {}; }
            this.setValue(value, options);
        };
        /**
         * Resets the form control, marking it `pristine` and `untouched`, and setting
         * the value to null.
         *
         * @param {?=} formState Resets the control with an initial value,
         * or an object that defines the initial value and disabled state.
         *
         * @param {?=} options Configuration options that determine how the control propagates changes
         * and emits events after the value changes.
         *
         * * `onlySelf`: When true, each change only affects this control, and not its parent. Default is
         * false.
         * * `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
         * `valueChanges`
         * observables emit events with the latest status and value when the control is reset.
         * When false, no events are emitted.
         *
         * @return {?}
         */
        FormControl.prototype.reset = function (formState, options) {
            if (formState === void 0) { formState = null; }
            if (options === void 0) { options = {}; }
            this._applyFormState(formState);
            this.markAsPristine(options);
            this.markAsUntouched(options);
            this.setValue(this.value, options);
            this._pendingChange = false;
        };
        /**
         * \@internal
         * @return {?}
         */
        FormControl.prototype._updateValue = function () { };
        /**
         * \@internal
         * @param {?} condition
         * @return {?}
         */
        FormControl.prototype._anyControls = function (condition) { return false; };
        /**
         * \@internal
         * @return {?}
         */
        FormControl.prototype._allControlsDisabled = function () { return this.disabled; };
        /**
         * Register a listener for change events.
         *
         * @param {?} fn The method that is called when the value changes
         * @return {?}
         */
        FormControl.prototype.registerOnChange = function (fn) { this._onChange.push(fn); };
        /**
         * \@internal
         * @return {?}
         */
        FormControl.prototype._clearChangeFns = function () {
            this._onChange = [];
            this._onDisabledChange = [];
            this._onCollectionChange = ( /**
             * @return {?}
             */function () { });
        };
        /**
         * Register a listener for disabled events.
         *
         * @param {?} fn The method that is called when the disabled status changes.
         * @return {?}
         */
        FormControl.prototype.registerOnDisabledChange = function (fn) {
            this._onDisabledChange.push(fn);
        };
        /**
         * \@internal
         * @param {?} cb
         * @return {?}
         */
        FormControl.prototype._forEachChild = function (cb) { };
        /**
         * \@internal
         * @return {?}
         */
        FormControl.prototype._syncPendingControls = function () {
            if (this.updateOn === 'submit') {
                if (this._pendingDirty)
                    this.markAsDirty();
                if (this._pendingTouched)
                    this.markAsTouched();
                if (this._pendingChange) {
                    this.setValue(this._pendingValue, { onlySelf: true, emitModelToViewChange: false });
                    return true;
                }
            }
            return false;
        };
        /**
         * @private
         * @param {?} formState
         * @return {?}
         */
        FormControl.prototype._applyFormState = function (formState) {
            if (this._isBoxedValue(formState)) {
                (( /** @type {?} */(this))).value = this._pendingValue = formState.value;
                formState.disabled ? this.disable({ onlySelf: true, emitEvent: false }) :
                    this.enable({ onlySelf: true, emitEvent: false });
            }
            else {
                (( /** @type {?} */(this))).value = this._pendingValue = formState;
            }
        };
        return FormControl;
    }(AbstractControl));
    /**
     * Tracks the value and validity state of a group of `FormControl` instances.
     *
     * A `FormGroup` aggregates the values of each child `FormControl` into one object,
     * with each control name as the key.  It calculates its status by reducing the status values
     * of its children. For example, if one of the controls in a group is invalid, the entire
     * group becomes invalid.
     *
     * `FormGroup` is one of the three fundamental building blocks used to define forms in Angular,
     * along with `FormControl` and `FormArray`.
     *
     * When instantiating a `FormGroup`, pass in a collection of child controls as the first
     * argument. The key for each child registers the name for the control.
     *
     * \@usageNotes
     *
     * ### Create a form group with 2 controls
     *
     * ```
     * const form = new FormGroup({
     *   first: new FormControl('Nancy', Validators.minLength(2)),
     *   last: new FormControl('Drew'),
     * });
     *
     * console.log(form.value);   // {first: 'Nancy', last; 'Drew'}
     * console.log(form.status);  // 'VALID'
     * ```
     *
     * ### Create a form group with a group-level validator
     *
     * You include group-level validators as the second arg, or group-level async
     * validators as the third arg. These come in handy when you want to perform validation
     * that considers the value of more than one child control.
     *
     * ```
     * const form = new FormGroup({
     *   password: new FormControl('', Validators.minLength(2)),
     *   passwordConfirm: new FormControl('', Validators.minLength(2)),
     * }, passwordMatchValidator);
     *
     *
     * function passwordMatchValidator(g: FormGroup) {
     *    return g.get('password').value === g.get('passwordConfirm').value
     *       ? null : {'mismatch': true};
     * }
     * ```
     *
     * Like `FormControl` instances, you choose to pass in
     * validators and async validators as part of an options object.
     *
     * ```
     * const form = new FormGroup({
     *   password: new FormControl('')
     *   passwordConfirm: new FormControl('')
     * }, { validators: passwordMatchValidator, asyncValidators: otherValidator });
     * ```
     *
     * ### Set the updateOn property for all controls in a form group
     *
     * The options object is used to set a default value for each child
     * control's `updateOn` property. If you set `updateOn` to `'blur'` at the
     * group level, all child controls default to 'blur', unless the child
     * has explicitly specified a different `updateOn` value.
     *
     * ```ts
     * const c = new FormGroup({
     *   one: new FormControl()
     * }, { updateOn: 'blur' });
     * ```
     *
     * \@publicApi
     */
    var FormGroup = /** @class */ (function (_super) {
        __extends(FormGroup, _super);
        /**
         * Creates a new `FormGroup` instance.
         *
         * @param {?} controls A collection of child controls. The key for each child is the name
         * under which it is registered.
         *
         * @param {?=} validatorOrOpts A synchronous validator function, or an array of
         * such functions, or an `AbstractControlOptions` object that contains validation functions
         * and a validation trigger.
         *
         * @param {?=} asyncValidator A single async validator or array of async validator functions
         *
         */
        function FormGroup(controls, validatorOrOpts, asyncValidator) {
            var _this = _super.call(this, coerceToValidator(validatorOrOpts), coerceToAsyncValidator(asyncValidator, validatorOrOpts)) || this;
            _this.controls = controls;
            _this._initObservables();
            _this._setUpdateStrategy(validatorOrOpts);
            _this._setUpControls();
            _this.updateValueAndValidity({ onlySelf: true, emitEvent: false });
            return _this;
        }
        /**
         * Registers a control with the group's list of controls.
         *
         * This method does not update the value or validity of the control.
         * Use {\@link FormGroup#addControl addControl} instead.
         *
         * @param {?} name The control name to register in the collection
         * @param {?} control Provides the control for the given name
         * @return {?}
         */
        FormGroup.prototype.registerControl = function (name, control) {
            if (this.controls[name])
                return this.controls[name];
            this.controls[name] = control;
            control.setParent(this);
            control._registerOnCollectionChange(this._onCollectionChange);
            return control;
        };
        /**
         * Add a control to this group.
         *
         * This method also updates the value and validity of the control.
         *
         * @param {?} name The control name to add to the collection
         * @param {?} control Provides the control for the given name
         * @return {?}
         */
        FormGroup.prototype.addControl = function (name, control) {
            this.registerControl(name, control);
            this.updateValueAndValidity();
            this._onCollectionChange();
        };
        /**
         * Remove a control from this group.
         *
         * @param {?} name The control name to remove from the collection
         * @return {?}
         */
        FormGroup.prototype.removeControl = function (name) {
            if (this.controls[name])
                this.controls[name]._registerOnCollectionChange(( /**
                 * @return {?}
                 */function () { }));
            delete (this.controls[name]);
            this.updateValueAndValidity();
            this._onCollectionChange();
        };
        /**
         * Replace an existing control.
         *
         * @param {?} name The control name to replace in the collection
         * @param {?} control Provides the control for the given name
         * @return {?}
         */
        FormGroup.prototype.setControl = function (name, control) {
            if (this.controls[name])
                this.controls[name]._registerOnCollectionChange(( /**
                 * @return {?}
                 */function () { }));
            delete (this.controls[name]);
            if (control)
                this.registerControl(name, control);
            this.updateValueAndValidity();
            this._onCollectionChange();
        };
        /**
         * Check whether there is an enabled control with the given name in the group.
         *
         * Reports false for disabled controls. If you'd like to check for existence in the group
         * only, use {\@link AbstractControl#get get} instead.
         *
         * @param {?} controlName The control name to check for existence in the collection
         *
         * @return {?} false for disabled controls, true otherwise.
         */
        FormGroup.prototype.contains = function (controlName) {
            return this.controls.hasOwnProperty(controlName) && this.controls[controlName].enabled;
        };
        /**
         * Sets the value of the `FormGroup`. It accepts an object that matches
         * the structure of the group, with control names as keys.
         *
         * \@usageNotes
         * ### Set the complete value for the form group
         *
         * ```
         * const form = new FormGroup({
         *   first: new FormControl(),
         *   last: new FormControl()
         * });
         *
         * console.log(form.value);   // {first: null, last: null}
         *
         * form.setValue({first: 'Nancy', last: 'Drew'});
         * console.log(form.value);   // {first: 'Nancy', last: 'Drew'}
         * ```
         *
         * @throws When strict checks fail, such as setting the value of a control
         * that doesn't exist or if you exclude a value of a control that does exist.
         *
         * @param {?} value The new value for the control that matches the structure of the group.
         * @param {?=} options Configuration options that determine how the control propagates changes
         * and emits events after the value changes.
         * The configuration options are passed to the {\@link AbstractControl#updateValueAndValidity
         * updateValueAndValidity} method.
         *
         * * `onlySelf`: When true, each change only affects this control, and not its parent. Default is
         * false.
         * * `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
         * `valueChanges`
         * observables emit events with the latest status and value when the control value is updated.
         * When false, no events are emitted.
         * @return {?}
         */
        FormGroup.prototype.setValue = function (value, options) {
            var _this = this;
            if (options === void 0) { options = {}; }
            this._checkAllValuesPresent(value);
            Object.keys(value).forEach(( /**
             * @param {?} name
             * @return {?}
             */function (/**
             * @param {?} name
             * @return {?}
             */ name) {
                _this._throwIfControlMissing(name);
                _this.controls[name].setValue(value[name], { onlySelf: true, emitEvent: options.emitEvent });
            }));
            this.updateValueAndValidity(options);
        };
        /**
         * Patches the value of the `FormGroup`. It accepts an object with control
         * names as keys, and does its best to match the values to the correct controls
         * in the group.
         *
         * It accepts both super-sets and sub-sets of the group without throwing an error.
         *
         * \@usageNotes
         * ### Patch the value for a form group
         *
         * ```
         * const form = new FormGroup({
         *    first: new FormControl(),
         *    last: new FormControl()
         * });
         * console.log(form.value);   // {first: null, last: null}
         *
         * form.patchValue({first: 'Nancy'});
         * console.log(form.value);   // {first: 'Nancy', last: null}
         * ```
         *
         * @param {?} value The object that matches the structure of the group.
         * @param {?=} options Configuration options that determine how the control propagates changes and
         * emits events after the value is patched.
         * * `onlySelf`: When true, each change only affects this control and not its parent. Default is
         * true.
         * * `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
         * `valueChanges`
         * observables emit events with the latest status and value when the control value is updated.
         * When false, no events are emitted.
         * The configuration options are passed to the {\@link AbstractControl#updateValueAndValidity
         * updateValueAndValidity} method.
         * @return {?}
         */
        FormGroup.prototype.patchValue = function (value, options) {
            var _this = this;
            if (options === void 0) { options = {}; }
            Object.keys(value).forEach(( /**
             * @param {?} name
             * @return {?}
             */function (/**
             * @param {?} name
             * @return {?}
             */ name) {
                if (_this.controls[name]) {
                    _this.controls[name].patchValue(value[name], { onlySelf: true, emitEvent: options.emitEvent });
                }
            }));
            this.updateValueAndValidity(options);
        };
        /**
         * Resets the `FormGroup`, marks all descendants are marked `pristine` and `untouched`, and
         * the value of all descendants to null.
         *
         * You reset to a specific form state by passing in a map of states
         * that matches the structure of your form, with control names as keys. The state
         * is a standalone value or a form state object with both a value and a disabled
         * status.
         *
         * \@usageNotes
         *
         * ### Reset the form group values
         *
         * ```ts
         * const form = new FormGroup({
         *   first: new FormControl('first name'),
         *   last: new FormControl('last name')
         * });
         *
         * console.log(form.value);  // {first: 'first name', last: 'last name'}
         *
         * form.reset({ first: 'name', last: 'last name' });
         *
         * console.log(form.value);  // {first: 'name', last: 'last name'}
         * ```
         *
         * ### Reset the form group values and disabled status
         *
         * ```
         * const form = new FormGroup({
         *   first: new FormControl('first name'),
         *   last: new FormControl('last name')
         * });
         *
         * form.reset({
         *   first: {value: 'name', disabled: true},
         *   last: 'last'
         * });
         *
         * console.log(this.form.value);  // {first: 'name', last: 'last name'}
         * console.log(this.form.get('first').status);  // 'DISABLED'
         * ```
         * @param {?=} value Resets the control with an initial value,
         * or an object that defines the initial value and disabled state.
         *
         * @param {?=} options Configuration options that determine how the control propagates changes
         * and emits events when the group is reset.
         * * `onlySelf`: When true, each change only affects this control, and not its parent. Default is
         * false.
         * * `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
         * `valueChanges`
         * observables emit events with the latest status and value when the control is reset.
         * When false, no events are emitted.
         * The configuration options are passed to the {\@link AbstractControl#updateValueAndValidity
         * updateValueAndValidity} method.
         *
         * @return {?}
         */
        FormGroup.prototype.reset = function (value, options) {
            if (value === void 0) { value = {}; }
            if (options === void 0) { options = {}; }
            this._forEachChild(( /**
             * @param {?} control
             * @param {?} name
             * @return {?}
             */function (control, name) {
                control.reset(value[name], { onlySelf: true, emitEvent: options.emitEvent });
            }));
            this._updatePristine(options);
            this._updateTouched(options);
            this.updateValueAndValidity(options);
        };
        /**
         * The aggregate value of the `FormGroup`, including any disabled controls.
         *
         * Retrieves all values regardless of disabled status.
         * The `value` property is the best way to get the value of the group, because
         * it excludes disabled controls in the `FormGroup`.
         * @return {?}
         */
        FormGroup.prototype.getRawValue = function () {
            return this._reduceChildren({}, ( /**
             * @param {?} acc
             * @param {?} control
             * @param {?} name
             * @return {?}
             */function (acc, control, name) {
                acc[name] = control instanceof FormControl ? control.value : (( /** @type {?} */(control))).getRawValue();
                return acc;
            }));
        };
        /**
         * \@internal
         * @return {?}
         */
        FormGroup.prototype._syncPendingControls = function () {
            /** @type {?} */
            var subtreeUpdated = this._reduceChildren(false, ( /**
             * @param {?} updated
             * @param {?} child
             * @return {?}
             */function (updated, child) {
                return child._syncPendingControls() ? true : updated;
            }));
            if (subtreeUpdated)
                this.updateValueAndValidity({ onlySelf: true });
            return subtreeUpdated;
        };
        /**
         * \@internal
         * @param {?} name
         * @return {?}
         */
        FormGroup.prototype._throwIfControlMissing = function (name) {
            if (!Object.keys(this.controls).length) {
                throw new Error("\n        There are no form controls registered with this group yet.  If you're using ngModel,\n        you may want to check next tick (e.g. use setTimeout).\n      ");
            }
            if (!this.controls[name]) {
                throw new Error("Cannot find form control with name: " + name + ".");
            }
        };
        /**
         * \@internal
         * @param {?} cb
         * @return {?}
         */
        FormGroup.prototype._forEachChild = function (cb) {
            var _this = this;
            Object.keys(this.controls).forEach(( /**
             * @param {?} k
             * @return {?}
             */function (/**
             * @param {?} k
             * @return {?}
             */ k) { return cb(_this.controls[k], k); }));
        };
        /**
         * \@internal
         * @return {?}
         */
        FormGroup.prototype._setUpControls = function () {
            var _this = this;
            this._forEachChild(( /**
             * @param {?} control
             * @return {?}
             */function (control) {
                control.setParent(_this);
                control._registerOnCollectionChange(_this._onCollectionChange);
            }));
        };
        /**
         * \@internal
         * @return {?}
         */
        FormGroup.prototype._updateValue = function () { (( /** @type {?} */(this))).value = this._reduceValue(); };
        /**
         * \@internal
         * @param {?} condition
         * @return {?}
         */
        FormGroup.prototype._anyControls = function (condition) {
            var _this = this;
            /** @type {?} */
            var res = false;
            this._forEachChild(( /**
             * @param {?} control
             * @param {?} name
             * @return {?}
             */function (control, name) {
                res = res || (_this.contains(name) && condition(control));
            }));
            return res;
        };
        /**
         * \@internal
         * @return {?}
         */
        FormGroup.prototype._reduceValue = function () {
            var _this = this;
            return this._reduceChildren({}, ( /**
             * @param {?} acc
             * @param {?} control
             * @param {?} name
             * @return {?}
             */function (acc, control, name) {
                if (control.enabled || _this.disabled) {
                    acc[name] = control.value;
                }
                return acc;
            }));
        };
        /**
         * \@internal
         * @param {?} initValue
         * @param {?} fn
         * @return {?}
         */
        FormGroup.prototype._reduceChildren = function (initValue, fn) {
            /** @type {?} */
            var res = initValue;
            this._forEachChild(( /**
             * @param {?} control
             * @param {?} name
             * @return {?}
             */function (control, name) { res = fn(res, control, name); }));
            return res;
        };
        /**
         * \@internal
         * @return {?}
         */
        FormGroup.prototype._allControlsDisabled = function () {
            var e_20, _b;
            try {
                for (var _c = __values(Object.keys(this.controls)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var controlName = _d.value;
                    if (this.controls[controlName].enabled) {
                        return false;
                    }
                }
            }
            catch (e_20_1) { e_20 = { error: e_20_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
                }
                finally { if (e_20) throw e_20.error; }
            }
            return Object.keys(this.controls).length > 0 || this.disabled;
        };
        /**
         * \@internal
         * @param {?} value
         * @return {?}
         */
        FormGroup.prototype._checkAllValuesPresent = function (value) {
            this._forEachChild(( /**
             * @param {?} control
             * @param {?} name
             * @return {?}
             */function (control, name) {
                if (value[name] === undefined) {
                    throw new Error("Must supply a value for form control with name: '" + name + "'.");
                }
            }));
        };
        return FormGroup;
    }(AbstractControl));
    /**
     * Tracks the value and validity state of an array of `FormControl`,
     * `FormGroup` or `FormArray` instances.
     *
     * A `FormArray` aggregates the values of each child `FormControl` into an array.
     * It calculates its status by reducing the status values of its children. For example, if one of
     * the controls in a `FormArray` is invalid, the entire array becomes invalid.
     *
     * `FormArray` is one of the three fundamental building blocks used to define forms in Angular,
     * along with `FormControl` and `FormGroup`.
     *
     * \@usageNotes
     *
     * ### Create an array of form controls
     *
     * ```
     * const arr = new FormArray([
     *   new FormControl('Nancy', Validators.minLength(2)),
     *   new FormControl('Drew'),
     * ]);
     *
     * console.log(arr.value);   // ['Nancy', 'Drew']
     * console.log(arr.status);  // 'VALID'
     * ```
     *
     * ### Create a form array with array-level validators
     *
     * You include array-level validators and async validators. These come in handy
     * when you want to perform validation that considers the value of more than one child
     * control.
     *
     * The two types of validators are passed in separately as the second and third arg
     * respectively, or together as part of an options object.
     *
     * ```
     * const arr = new FormArray([
     *   new FormControl('Nancy'),
     *   new FormControl('Drew')
     * ], {validators: myValidator, asyncValidators: myAsyncValidator});
     * ```
     *
     * ### Set the updateOn property for all controls in a form array
     *
     * The options object is used to set a default value for each child
     * control's `updateOn` property. If you set `updateOn` to `'blur'` at the
     * array level, all child controls default to 'blur', unless the child
     * has explicitly specified a different `updateOn` value.
     *
     * ```ts
     * const arr = new FormArray([
     *    new FormControl()
     * ], {updateOn: 'blur'});
     * ```
     *
     * ### Adding or removing controls from a form array
     *
     * To change the controls in the array, use the `push`, `insert`, `removeAt` or `clear` methods
     * in `FormArray` itself. These methods ensure the controls are properly tracked in the
     * form's hierarchy. Do not modify the array of `AbstractControl`s used to instantiate
     * the `FormArray` directly, as that result in strange and unexpected behavior such
     * as broken change detection.
     *
     * \@publicApi
     */
    var FormArray = /** @class */ (function (_super) {
        __extends(FormArray, _super);
        /**
         * Creates a new `FormArray` instance.
         *
         * @param {?} controls An array of child controls. Each child control is given an index
         * where it is registered.
         *
         * @param {?=} validatorOrOpts A synchronous validator function, or an array of
         * such functions, or an `AbstractControlOptions` object that contains validation functions
         * and a validation trigger.
         *
         * @param {?=} asyncValidator A single async validator or array of async validator functions
         *
         */
        function FormArray(controls, validatorOrOpts, asyncValidator) {
            var _this = _super.call(this, coerceToValidator(validatorOrOpts), coerceToAsyncValidator(asyncValidator, validatorOrOpts)) || this;
            _this.controls = controls;
            _this._initObservables();
            _this._setUpdateStrategy(validatorOrOpts);
            _this._setUpControls();
            _this.updateValueAndValidity({ onlySelf: true, emitEvent: false });
            return _this;
        }
        /**
         * Get the `AbstractControl` at the given `index` in the array.
         *
         * @param {?} index Index in the array to retrieve the control
         * @return {?}
         */
        FormArray.prototype.at = function (index) { return this.controls[index]; };
        /**
         * Insert a new `AbstractControl` at the end of the array.
         *
         * @param {?} control Form control to be inserted
         * @return {?}
         */
        FormArray.prototype.push = function (control) {
            this.controls.push(control);
            this._registerControl(control);
            this.updateValueAndValidity();
            this._onCollectionChange();
        };
        /**
         * Insert a new `AbstractControl` at the given `index` in the array.
         *
         * @param {?} index Index in the array to insert the control
         * @param {?} control Form control to be inserted
         * @return {?}
         */
        FormArray.prototype.insert = function (index, control) {
            this.controls.splice(index, 0, control);
            this._registerControl(control);
            this.updateValueAndValidity();
        };
        /**
         * Remove the control at the given `index` in the array.
         *
         * @param {?} index Index in the array to remove the control
         * @return {?}
         */
        FormArray.prototype.removeAt = function (index) {
            if (this.controls[index])
                this.controls[index]._registerOnCollectionChange(( /**
                 * @return {?}
                 */function () { }));
            this.controls.splice(index, 1);
            this.updateValueAndValidity();
        };
        /**
         * Replace an existing control.
         *
         * @param {?} index Index in the array to replace the control
         * @param {?} control The `AbstractControl` control to replace the existing control
         * @return {?}
         */
        FormArray.prototype.setControl = function (index, control) {
            if (this.controls[index])
                this.controls[index]._registerOnCollectionChange(( /**
                 * @return {?}
                 */function () { }));
            this.controls.splice(index, 1);
            if (control) {
                this.controls.splice(index, 0, control);
                this._registerControl(control);
            }
            this.updateValueAndValidity();
            this._onCollectionChange();
        };
        Object.defineProperty(FormArray.prototype, "length", {
            /**
             * Length of the control array.
             * @return {?}
             */
            get: function () { return this.controls.length; },
            enumerable: true,
            configurable: true
        });
        /**
         * Sets the value of the `FormArray`. It accepts an array that matches
         * the structure of the control.
         *
         * This method performs strict checks, and throws an error if you try
         * to set the value of a control that doesn't exist or if you exclude the
         * value of a control.
         *
         * \@usageNotes
         * ### Set the values for the controls in the form array
         *
         * ```
         * const arr = new FormArray([
         *   new FormControl(),
         *   new FormControl()
         * ]);
         * console.log(arr.value);   // [null, null]
         *
         * arr.setValue(['Nancy', 'Drew']);
         * console.log(arr.value);   // ['Nancy', 'Drew']
         * ```
         *
         * @param {?} value Array of values for the controls
         * @param {?=} options Configure options that determine how the control propagates changes and
         * emits events after the value changes
         *
         * * `onlySelf`: When true, each change only affects this control, and not its parent. Default
         * is false.
         * * `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
         * `valueChanges`
         * observables emit events with the latest status and value when the control value is updated.
         * When false, no events are emitted.
         * The configuration options are passed to the {\@link AbstractControl#updateValueAndValidity
         * updateValueAndValidity} method.
         * @return {?}
         */
        FormArray.prototype.setValue = function (value, options) {
            var _this = this;
            if (options === void 0) { options = {}; }
            this._checkAllValuesPresent(value);
            value.forEach(( /**
             * @param {?} newValue
             * @param {?} index
             * @return {?}
             */function (newValue, index) {
                _this._throwIfControlMissing(index);
                _this.at(index).setValue(newValue, { onlySelf: true, emitEvent: options.emitEvent });
            }));
            this.updateValueAndValidity(options);
        };
        /**
         * Patches the value of the `FormArray`. It accepts an array that matches the
         * structure of the control, and does its best to match the values to the correct
         * controls in the group.
         *
         * It accepts both super-sets and sub-sets of the array without throwing an error.
         *
         * \@usageNotes
         * ### Patch the values for controls in a form array
         *
         * ```
         * const arr = new FormArray([
         *    new FormControl(),
         *    new FormControl()
         * ]);
         * console.log(arr.value);   // [null, null]
         *
         * arr.patchValue(['Nancy']);
         * console.log(arr.value);   // ['Nancy', null]
         * ```
         *
         * @param {?} value Array of latest values for the controls
         * @param {?=} options Configure options that determine how the control propagates changes and
         * emits events after the value changes
         *
         * * `onlySelf`: When true, each change only affects this control, and not its parent. Default
         * is false.
         * * `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
         * `valueChanges`
         * observables emit events with the latest status and value when the control value is updated.
         * When false, no events are emitted.
         * The configuration options are passed to the {\@link AbstractControl#updateValueAndValidity
         * updateValueAndValidity} method.
         * @return {?}
         */
        FormArray.prototype.patchValue = function (value, options) {
            var _this = this;
            if (options === void 0) { options = {}; }
            value.forEach(( /**
             * @param {?} newValue
             * @param {?} index
             * @return {?}
             */function (newValue, index) {
                if (_this.at(index)) {
                    _this.at(index).patchValue(newValue, { onlySelf: true, emitEvent: options.emitEvent });
                }
            }));
            this.updateValueAndValidity(options);
        };
        /**
         * Resets the `FormArray` and all descendants are marked `pristine` and `untouched`, and the
         * value of all descendants to null or null maps.
         *
         * You reset to a specific form state by passing in an array of states
         * that matches the structure of the control. The state is a standalone value
         * or a form state object with both a value and a disabled status.
         *
         * \@usageNotes
         * ### Reset the values in a form array
         *
         * ```ts
         * const arr = new FormArray([
         *    new FormControl(),
         *    new FormControl()
         * ]);
         * arr.reset(['name', 'last name']);
         *
         * console.log(this.arr.value);  // ['name', 'last name']
         * ```
         *
         * ### Reset the values in a form array and the disabled status for the first control
         *
         * ```
         * this.arr.reset([
         *   {value: 'name', disabled: true},
         *   'last'
         * ]);
         *
         * console.log(this.arr.value);  // ['name', 'last name']
         * console.log(this.arr.get(0).status);  // 'DISABLED'
         * ```
         *
         * @param {?=} value Array of values for the controls
         * @param {?=} options Configure options that determine how the control propagates changes and
         * emits events after the value changes
         *
         * * `onlySelf`: When true, each change only affects this control, and not its parent. Default
         * is false.
         * * `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
         * `valueChanges`
         * observables emit events with the latest status and value when the control is reset.
         * When false, no events are emitted.
         * The configuration options are passed to the {\@link AbstractControl#updateValueAndValidity
         * updateValueAndValidity} method.
         * @return {?}
         */
        FormArray.prototype.reset = function (value, options) {
            if (value === void 0) { value = []; }
            if (options === void 0) { options = {}; }
            this._forEachChild(( /**
             * @param {?} control
             * @param {?} index
             * @return {?}
             */function (control, index) {
                control.reset(value[index], { onlySelf: true, emitEvent: options.emitEvent });
            }));
            this._updatePristine(options);
            this._updateTouched(options);
            this.updateValueAndValidity(options);
        };
        /**
         * The aggregate value of the array, including any disabled controls.
         *
         * Reports all values regardless of disabled status.
         * For enabled controls only, the `value` property is the best way to get the value of the array.
         * @return {?}
         */
        FormArray.prototype.getRawValue = function () {
            return this.controls.map(( /**
             * @param {?} control
             * @return {?}
             */function (control) {
                return control instanceof FormControl ? control.value : (( /** @type {?} */(control))).getRawValue();
            }));
        };
        /**
         * Remove all controls in the `FormArray`.
         *
         * \@usageNotes
         * ### Remove all elements from a FormArray
         *
         * ```ts
         * const arr = new FormArray([
         *    new FormControl(),
         *    new FormControl()
         * ]);
         * console.log(arr.length);  // 2
         *
         * arr.clear();
         * console.log(arr.length);  // 0
         * ```
         *
         * It's a simpler and more efficient alternative to removing all elements one by one:
         *
         * ```ts
         * const arr = new FormArray([
         *    new FormControl(),
         *    new FormControl()
         * ]);
         *
         * while (arr.length) {
         *    arr.removeAt(0);
         * }
         * ```
         * @return {?}
         */
        FormArray.prototype.clear = function () {
            if (this.controls.length < 1)
                return;
            this._forEachChild(( /**
             * @param {?} control
             * @return {?}
             */function (control) { return control._registerOnCollectionChange(( /**
             * @return {?}
             */function () { })); }));
            this.controls.splice(0);
            this.updateValueAndValidity();
        };
        /**
         * \@internal
         * @return {?}
         */
        FormArray.prototype._syncPendingControls = function () {
            /** @type {?} */
            var subtreeUpdated = this.controls.reduce(( /**
             * @param {?} updated
             * @param {?} child
             * @return {?}
             */function (updated, child) {
                return child._syncPendingControls() ? true : updated;
            }), false);
            if (subtreeUpdated)
                this.updateValueAndValidity({ onlySelf: true });
            return subtreeUpdated;
        };
        /**
         * \@internal
         * @param {?} index
         * @return {?}
         */
        FormArray.prototype._throwIfControlMissing = function (index) {
            if (!this.controls.length) {
                throw new Error("\n        There are no form controls registered with this array yet.  If you're using ngModel,\n        you may want to check next tick (e.g. use setTimeout).\n      ");
            }
            if (!this.at(index)) {
                throw new Error("Cannot find form control at index " + index);
            }
        };
        /**
         * \@internal
         * @param {?} cb
         * @return {?}
         */
        FormArray.prototype._forEachChild = function (cb) {
            this.controls.forEach(( /**
             * @param {?} control
             * @param {?} index
             * @return {?}
             */function (control, index) { cb(control, index); }));
        };
        /**
         * \@internal
         * @return {?}
         */
        FormArray.prototype._updateValue = function () {
            var _this = this;
            (( /** @type {?} */(this))).value =
                this.controls.filter(( /**
                 * @param {?} control
                 * @return {?}
                 */function (control) { return control.enabled || _this.disabled; }))
                    .map(( /**
             * @param {?} control
             * @return {?}
             */function (control) { return control.value; }));
        };
        /**
         * \@internal
         * @param {?} condition
         * @return {?}
         */
        FormArray.prototype._anyControls = function (condition) {
            return this.controls.some(( /**
             * @param {?} control
             * @return {?}
             */function (control) { return control.enabled && condition(control); }));
        };
        /**
         * \@internal
         * @return {?}
         */
        FormArray.prototype._setUpControls = function () {
            var _this = this;
            this._forEachChild(( /**
             * @param {?} control
             * @return {?}
             */function (control) { return _this._registerControl(control); }));
        };
        /**
         * \@internal
         * @param {?} value
         * @return {?}
         */
        FormArray.prototype._checkAllValuesPresent = function (value) {
            this._forEachChild(( /**
             * @param {?} control
             * @param {?} i
             * @return {?}
             */function (control, i) {
                if (value[i] === undefined) {
                    throw new Error("Must supply a value for form control at index: " + i + ".");
                }
            }));
        };
        /**
         * \@internal
         * @return {?}
         */
        FormArray.prototype._allControlsDisabled = function () {
            var e_21, _b;
            try {
                for (var _c = __values(this.controls), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var control = _d.value;
                    if (control.enabled)
                        return false;
                }
            }
            catch (e_21_1) { e_21 = { error: e_21_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
                }
                finally { if (e_21) throw e_21.error; }
            }
            return this.controls.length > 0 || this.disabled;
        };
        /**
         * @private
         * @param {?} control
         * @return {?}
         */
        FormArray.prototype._registerControl = function (control) {
            control.setParent(this);
            control._registerOnCollectionChange(this._onCollectionChange);
        };
        return FormArray;
    }(AbstractControl));
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var formDirectiveProvider = {
        provide: ControlContainer,
        useExisting: forwardRef(( /**
         * @return {?}
         */function () { return NgForm; }))
    };
    var ɵ0$d = /**
     * @return {?}
     */ function () { return Promise.resolve(null); };
    /** @type {?} */
    var resolvedPromise = ((ɵ0$d))();
    /**
     * \@description
     * Creates a top-level `FormGroup` instance and binds it to a form
     * to track aggregate form value and validation status.
     *
     * As soon as you import the `FormsModule`, this directive becomes active by default on
     * all `<form>` tags.  You don't need to add a special selector.
     *
     * You optionally export the directive into a local template variable using `ngForm` as the key
     * (ex: `#myForm="ngForm"`). This is optional, but useful.  Many properties from the underlying
     * `FormGroup` instance are duplicated on the directive itself, so a reference to it
     * gives you access to the aggregate value and validity status of the form, as well as
     * user interaction properties like `dirty` and `touched`.
     *
     * To register child controls with the form, use `NgModel` with a `name`
     * attribute. You may use `NgModelGroup` to create sub-groups within the form.
     *
     * If necessary, listen to the directive's `ngSubmit` event to be notified when the user has
     * triggered a form submission. The `ngSubmit` event emits the original form
     * submission event.
     *
     * In template driven forms, all `<form>` tags are automatically tagged as `NgForm`.
     * To import the `FormsModule` but skip its usage in some forms,
     * for example, to use native HTML5 validation, add the `ngNoForm` and the `<form>`
     * tags won't create an `NgForm` directive. In reactive forms, using `ngNoForm` is
     * unnecessary because the `<form>` tags are inert. In that case, you would
     * refrain from using the `formGroup` directive.
     *
     * \@usageNotes
     *
     * ### Migrating from deprecated ngForm selector
     *
     * Support for using `ngForm` element selector has been deprecated in Angular v6 and will be removed
     * in Angular v9.
     *
     * This has been deprecated to keep selectors consistent with other core Angular selectors,
     * as element selectors are typically written in kebab-case.
     *
     * Now deprecated:
     * ```html
     * <ngForm #myForm="ngForm">
     * ```
     *
     * After:
     * ```html
     * <ng-form #myForm="ngForm">
     * ```
     *
     * ### Listening for form submission
     *
     * The following example shows how to capture the form values from the "ngSubmit" event.
     *
     * {\@example forms/ts/simpleForm/simple_form_example.ts region='Component'}
     *
     * ### Setting the update options
     *
     * The following example shows you how to change the "updateOn" option from its default using
     * ngFormOptions.
     *
     * ```html
     * <form [ngFormOptions]="{updateOn: 'blur'}">
     *    <input name="one" ngModel>  <!-- this ngModel will update on blur -->
     * </form>
     * ```
     *
     * \@ngModule FormsModule
     * \@publicApi
     */
    var NgForm = /** @class */ (function (_super) {
        __extends(NgForm, _super);
        /**
         * @param {?} validators
         * @param {?} asyncValidators
         */
        function NgForm(validators, asyncValidators) {
            var _this = _super.call(this) || this;
            /**
             * \@description
             * Returns whether the form submission has been triggered.
             */
            _this.submitted = false;
            _this._directives = [];
            /**
             * \@description
             * Event emitter for the "ngSubmit" event
             */
            _this.ngSubmit = new EventEmitter();
            _this.form =
                new FormGroup({}, composeValidators(validators), composeAsyncValidators(asyncValidators));
            return _this;
        }
        /**
         * \@description
         * Lifecycle method called after the view is initialized. For internal use only.
         * @return {?}
         */
        NgForm.prototype.ngAfterViewInit = function () { this._setUpdateStrategy(); };
        Object.defineProperty(NgForm.prototype, "formDirective", {
            /**
             * \@description
             * The directive instance.
             * @return {?}
             */
            get: function () { return this; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgForm.prototype, "control", {
            /**
             * \@description
             * The internal `FormGroup` instance.
             * @return {?}
             */
            get: function () { return this.form; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgForm.prototype, "path", {
            /**
             * \@description
             * Returns an array representing the path to this group. Because this directive
             * always lives at the top level of a form, it is always an empty array.
             * @return {?}
             */
            get: function () { return []; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgForm.prototype, "controls", {
            /**
             * \@description
             * Returns a map of the controls in this group.
             * @return {?}
             */
            get: function () { return this.form.controls; },
            enumerable: true,
            configurable: true
        });
        /**
         * \@description
         * Method that sets up the control directive in this group, re-calculates its value
         * and validity, and adds the instance to the internal list of directives.
         *
         * @param {?} dir The `NgModel` directive instance.
         * @return {?}
         */
        NgForm.prototype.addControl = function (dir) {
            var _this = this;
            resolvedPromise.then(( /**
             * @return {?}
             */function () {
                /** @type {?} */
                var container = _this._findContainer(dir.path);
                (( /** @type {?} */(dir))).control =
                    ( /** @type {?} */(container.registerControl(dir.name, dir.control)));
                setUpControl(dir.control, dir);
                dir.control.updateValueAndValidity({ emitEvent: false });
                _this._directives.push(dir);
            }));
        };
        /**
         * \@description
         * Retrieves the `FormControl` instance from the provided `NgModel` directive.
         *
         * @param {?} dir The `NgModel` directive instance.
         * @return {?}
         */
        NgForm.prototype.getControl = function (dir) { return ( /** @type {?} */(this.form.get(dir.path))); };
        /**
         * \@description
         * Removes the `NgModel` instance from the internal list of directives
         *
         * @param {?} dir The `NgModel` directive instance.
         * @return {?}
         */
        NgForm.prototype.removeControl = function (dir) {
            var _this = this;
            resolvedPromise.then(( /**
             * @return {?}
             */function () {
                /** @type {?} */
                var container = _this._findContainer(dir.path);
                if (container) {
                    container.removeControl(dir.name);
                }
                removeDir(_this._directives, dir);
            }));
        };
        /**
         * \@description
         * Adds a new `NgModelGroup` directive instance to the form.
         *
         * @param {?} dir The `NgModelGroup` directive instance.
         * @return {?}
         */
        NgForm.prototype.addFormGroup = function (dir) {
            var _this = this;
            resolvedPromise.then(( /**
             * @return {?}
             */function () {
                /** @type {?} */
                var container = _this._findContainer(dir.path);
                /** @type {?} */
                var group = new FormGroup({});
                setUpFormContainer(group, dir);
                container.registerControl(dir.name, group);
                group.updateValueAndValidity({ emitEvent: false });
            }));
        };
        /**
         * \@description
         * Removes the `NgModelGroup` directive instance from the form.
         *
         * @param {?} dir The `NgModelGroup` directive instance.
         * @return {?}
         */
        NgForm.prototype.removeFormGroup = function (dir) {
            var _this = this;
            resolvedPromise.then(( /**
             * @return {?}
             */function () {
                /** @type {?} */
                var container = _this._findContainer(dir.path);
                if (container) {
                    container.removeControl(dir.name);
                }
            }));
        };
        /**
         * \@description
         * Retrieves the `FormGroup` for a provided `NgModelGroup` directive instance
         *
         * @param {?} dir The `NgModelGroup` directive instance.
         * @return {?}
         */
        NgForm.prototype.getFormGroup = function (dir) { return ( /** @type {?} */(this.form.get(dir.path))); };
        /**
         * Sets the new value for the provided `NgControl` directive.
         *
         * @param {?} dir The `NgControl` directive instance.
         * @param {?} value The new value for the directive's control.
         * @return {?}
         */
        NgForm.prototype.updateModel = function (dir, value) {
            var _this = this;
            resolvedPromise.then(( /**
             * @return {?}
             */function () {
                /** @type {?} */
                var ctrl = ( /** @type {?} */(_this.form.get(( /** @type {?} */(dir.path)))));
                ctrl.setValue(value);
            }));
        };
        /**
         * \@description
         * Sets the value for this `FormGroup`.
         *
         * @param {?} value The new value
         * @return {?}
         */
        NgForm.prototype.setValue = function (value) { this.control.setValue(value); };
        /**
         * \@description
         * Method called when the "submit" event is triggered on the form.
         * Triggers the `ngSubmit` emitter to emit the "submit" event as its payload.
         *
         * @param {?} $event The "submit" event object
         * @return {?}
         */
        NgForm.prototype.onSubmit = function ($event) {
            (( /** @type {?} */(this))).submitted = true;
            syncPendingControls(this.form, this._directives);
            this.ngSubmit.emit($event);
            return false;
        };
        /**
         * \@description
         * Method called when the "reset" event is triggered on the form.
         * @return {?}
         */
        NgForm.prototype.onReset = function () { this.resetForm(); };
        /**
         * \@description
         * Resets the form to an initial value and resets its submitted status.
         *
         * @param {?=} value The new value for the form.
         * @return {?}
         */
        NgForm.prototype.resetForm = function (value) {
            if (value === void 0) { value = undefined; }
            this.form.reset(value);
            (( /** @type {?} */(this))).submitted = false;
        };
        /**
         * @private
         * @return {?}
         */
        NgForm.prototype._setUpdateStrategy = function () {
            if (this.options && this.options.updateOn != null) {
                this.form._updateOn = this.options.updateOn;
            }
        };
        /**
         * \@internal
         * @param {?} path
         * @return {?}
         */
        NgForm.prototype._findContainer = function (path) {
            path.pop();
            return path.length ? ( /** @type {?} */(this.form.get(path))) : this.form;
        };
        return NgForm;
    }(ControlContainer));
    NgForm.decorators = [
        { type: Directive, args: [{
                    selector: 'form:not([ngNoForm]):not([formGroup]),ngForm,ng-form,[ngForm]',
                    providers: [formDirectiveProvider],
                    host: { '(submit)': 'onSubmit($event)', '(reset)': 'onReset()' },
                    outputs: ['ngSubmit'],
                    exportAs: 'ngForm'
                },] }
    ];
    /** @nocollapse */
    NgForm.ctorParameters = function () { return [
        { type: Array, decorators: [{ type: Optional }, { type: Self }, { type: Inject, args: [NG_VALIDATORS,] }] },
        { type: Array, decorators: [{ type: Optional }, { type: Self }, { type: Inject, args: [NG_ASYNC_VALIDATORS,] }] }
    ]; };
    NgForm.propDecorators = {
        options: [{ type: Input, args: ['ngFormOptions',] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TemplateDrivenErrors = /** @class */ (function () {
        function TemplateDrivenErrors() {
        }
        /**
         * @return {?}
         */
        TemplateDrivenErrors.modelParentException = function () {
            throw new Error("\n      ngModel cannot be used to register form controls with a parent formGroup directive.  Try using\n      formGroup's partner directive \"formControlName\" instead.  Example:\n\n      " + FormErrorExamples.formControlName + "\n\n      Or, if you'd like to avoid registering this form control, indicate that it's standalone in ngModelOptions:\n\n      Example:\n\n      " + FormErrorExamples.ngModelWithFormGroup);
        };
        /**
         * @return {?}
         */
        TemplateDrivenErrors.formGroupNameException = function () {
            throw new Error("\n      ngModel cannot be used to register form controls with a parent formGroupName or formArrayName directive.\n\n      Option 1: Use formControlName instead of ngModel (reactive strategy):\n\n      " + FormErrorExamples.formGroupName + "\n\n      Option 2:  Update ngModel's parent be ngModelGroup (template-driven strategy):\n\n      " + FormErrorExamples.ngModelGroup);
        };
        /**
         * @return {?}
         */
        TemplateDrivenErrors.missingNameException = function () {
            throw new Error("If ngModel is used within a form tag, either the name attribute must be set or the form\n      control must be defined as 'standalone' in ngModelOptions.\n\n      Example 1: <input [(ngModel)]=\"person.firstName\" name=\"first\">\n      Example 2: <input [(ngModel)]=\"person.firstName\" [ngModelOptions]=\"{standalone: true}\">");
        };
        /**
         * @return {?}
         */
        TemplateDrivenErrors.modelGroupParentException = function () {
            throw new Error("\n      ngModelGroup cannot be used with a parent formGroup directive.\n\n      Option 1: Use formGroupName instead of ngModelGroup (reactive strategy):\n\n      " + FormErrorExamples.formGroupName + "\n\n      Option 2:  Use a regular form tag instead of the formGroup directive (template-driven strategy):\n\n      " + FormErrorExamples.ngModelGroup);
        };
        /**
         * @return {?}
         */
        TemplateDrivenErrors.ngFormWarning = function () {
            console.warn("\n    It looks like you're using 'ngForm'.\n\n    Support for using the 'ngForm' element selector has been deprecated in Angular v6 and will be removed\n    in Angular v9.\n\n    Use 'ng-form' instead.\n\n    Before:\n    <ngForm #myForm=\"ngForm\">\n\n    After:\n    <ng-form #myForm=\"ngForm\">\n    ");
        };
        return TemplateDrivenErrors;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@description
     * `InjectionToken` to provide to turn off the warning when using 'ngForm' deprecated selector.
     * @type {?}
     */
    var NG_FORM_SELECTOR_WARNING = new InjectionToken('NgFormSelectorWarning');
    /**
     * This directive is solely used to display warnings when the deprecated `ngForm` selector is used.
     *
     * @deprecated in Angular v6 and will be removed in Angular v9.
     * \@ngModule FormsModule
     * \@publicApi
     */
    var NgFormSelectorWarning = /** @class */ (function () {
        /**
         * @param {?} ngFormWarning
         */
        function NgFormSelectorWarning(ngFormWarning) {
            if (((!ngFormWarning || ngFormWarning === 'once') && !NgFormSelectorWarning._ngFormWarning) ||
                ngFormWarning === 'always') {
                TemplateDrivenErrors.ngFormWarning();
                NgFormSelectorWarning._ngFormWarning = true;
            }
        }
        return NgFormSelectorWarning;
    }());
    /**
     * Static property used to track whether the deprecation warning for this selector has been sent.
     * Used to support warning config of "once".
     *
     * \@internal
     */
    NgFormSelectorWarning._ngFormWarning = false;
    NgFormSelectorWarning.decorators = [
        { type: Directive, args: [{ selector: 'ngForm' },] }
    ];
    /** @nocollapse */
    NgFormSelectorWarning.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [NG_FORM_SELECTOR_WARNING,] }] }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@description
     * A base class for code shared between the `NgModelGroup` and `FormGroupName` directives.
     *
     * \@publicApi
     */
    var AbstractFormGroupDirective = /** @class */ (function (_super) {
        __extends(AbstractFormGroupDirective, _super);
        function AbstractFormGroupDirective() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * \@description
         * An internal callback method triggered on the instance after the inputs are set.
         * Registers the group with its parent group.
         * @return {?}
         */
        AbstractFormGroupDirective.prototype.ngOnInit = function () {
            this._checkParentType();
            ( /** @type {?} */(this.formDirective)).addFormGroup(this);
        };
        /**
         * \@description
         * An internal callback method triggered before the instance is destroyed.
         * Removes the group from its parent group.
         * @return {?}
         */
        AbstractFormGroupDirective.prototype.ngOnDestroy = function () {
            if (this.formDirective) {
                this.formDirective.removeFormGroup(this);
            }
        };
        Object.defineProperty(AbstractFormGroupDirective.prototype, "control", {
            /**
             * \@description
             * The `FormGroup` bound to this directive.
             * @return {?}
             */
            get: function () { return ( /** @type {?} */(this.formDirective)).getFormGroup(this); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractFormGroupDirective.prototype, "path", {
            /**
             * \@description
             * The path to this group from the top-level directive.
             * @return {?}
             */
            get: function () { return controlPath(this.name, this._parent); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractFormGroupDirective.prototype, "formDirective", {
            /**
             * \@description
             * The top-level directive for this group if present, otherwise null.
             * @return {?}
             */
            get: function () { return this._parent ? this._parent.formDirective : null; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractFormGroupDirective.prototype, "validator", {
            /**
             * \@description
             * The synchronous validators registered with this group.
             * @return {?}
             */
            get: function () { return composeValidators(this._validators); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractFormGroupDirective.prototype, "asyncValidator", {
            /**
             * \@description
             * The async validators registered with this group.
             * @return {?}
             */
            get: function () {
                return composeAsyncValidators(this._asyncValidators);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * \@internal
         * @return {?}
         */
        AbstractFormGroupDirective.prototype._checkParentType = function () { };
        return AbstractFormGroupDirective;
    }(ControlContainer));
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var modelGroupProvider = {
        provide: ControlContainer,
        useExisting: forwardRef(( /**
         * @return {?}
         */function () { return NgModelGroup; }))
    };
    /**
     * \@description
     * Creates and binds a `FormGroup` instance to a DOM element.
     *
     * This directive can only be used as a child of `NgForm` (within `<form>` tags).
     *
     * Use this directive to validate a sub-group of your form separately from the
     * rest of your form, or if some values in your domain model make more sense
     * to consume together in a nested object.
     *
     * Provide a name for the sub-group and it will become the key
     * for the sub-group in the form's full value. If you need direct access, export the directive into
     * a local template variable using `ngModelGroup` (ex: `#myGroup="ngModelGroup"`).
     *
     * \@usageNotes
     *
     * ### Consuming controls in a grouping
     *
     * The following example shows you how to combine controls together in a sub-group
     * of the form.
     *
     * {\@example forms/ts/ngModelGroup/ng_model_group_example.ts region='Component'}
     *
     * \@ngModule FormsModule
     * \@publicApi
     */
    var NgModelGroup = /** @class */ (function (_super) {
        __extends(NgModelGroup, _super);
        /**
         * @param {?} parent
         * @param {?} validators
         * @param {?} asyncValidators
         */
        function NgModelGroup(parent, validators, asyncValidators) {
            var _this = _super.call(this) || this;
            _this._parent = parent;
            _this._validators = validators;
            _this._asyncValidators = asyncValidators;
            return _this;
        }
        /**
         * \@internal
         * @return {?}
         */
        NgModelGroup.prototype._checkParentType = function () {
            if (!(this._parent instanceof NgModelGroup) && !(this._parent instanceof NgForm)) {
                TemplateDrivenErrors.modelGroupParentException();
            }
        };
        return NgModelGroup;
    }(AbstractFormGroupDirective));
    NgModelGroup.decorators = [
        { type: Directive, args: [{ selector: '[ngModelGroup]', providers: [modelGroupProvider], exportAs: 'ngModelGroup' },] }
    ];
    /** @nocollapse */
    NgModelGroup.ctorParameters = function () { return [
        { type: ControlContainer, decorators: [{ type: Host }, { type: SkipSelf }] },
        { type: Array, decorators: [{ type: Optional }, { type: Self }, { type: Inject, args: [NG_VALIDATORS,] }] },
        { type: Array, decorators: [{ type: Optional }, { type: Self }, { type: Inject, args: [NG_ASYNC_VALIDATORS,] }] }
    ]; };
    NgModelGroup.propDecorators = {
        name: [{ type: Input, args: ['ngModelGroup',] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var formControlBinding = {
        provide: NgControl,
        useExisting: forwardRef(( /**
         * @return {?}
         */function () { return NgModel; }))
    };
    var ɵ0$1$5 = /**
     * @return {?}
     */ function () { return Promise.resolve(null); };
    /**
     * `ngModel` forces an additional change detection run when its inputs change:
     * E.g.:
     * ```
     * <div>{{myModel.valid}}</div>
     * <input [(ngModel)]="myValue" #myModel="ngModel">
     * ```
     * I.e. `ngModel` can export itself on the element and then be used in the template.
     * Normally, this would result in expressions before the `input` that use the exported directive
     * to have and old value as they have been
     * dirty checked before. As this is a very common case for `ngModel`, we added this second change
     * detection run.
     *
     * Notes:
     * - this is just one extra run no matter how many `ngModel` have been changed.
     * - this is a general problem when using `exportAs` for directives!
     * @type {?}
     */
    var resolvedPromise$1 = ((ɵ0$1$5))();
    /**
     * \@description
     * Creates a `FormControl` instance from a domain model and binds it
     * to a form control element.
     *
     * The `FormControl` instance tracks the value, user interaction, and
     * validation status of the control and keeps the view synced with the model. If used
     * within a parent form, the directive also registers itself with the form as a child
     * control.
     *
     * This directive is used by itself or as part of a larger form. Use the
     * `ngModel` selector to activate it.
     *
     * It accepts a domain model as an optional `Input`. If you have a one-way binding
     * to `ngModel` with `[]` syntax, changing the value of the domain model in the component
     * class sets the value in the view. If you have a two-way binding with `[()]` syntax
     * (also known as 'banana-box syntax'), the value in the UI always syncs back to
     * the domain model in your class.
     *
     * To inspect the properties of the associated `FormControl` (like validity state),
     * export the directive into a local template variable using `ngModel` as the key (ex: `#myVar="ngModel"`).
     * You then access the control using the directive's `control` property,
     * but most properties used (like `valid` and `dirty`) fall through to the control anyway for direct access.
     * See a full list of properties directly available in `AbstractControlDirective`.
     *
     * @see `RadioControlValueAccessor`
     * @see `SelectControlValueAccessor`
     *
     * \@usageNotes
     *
     * ### Using ngModel on a standalone control
     *
     * The following examples show a simple standalone control using `ngModel`:
     *
     * {\@example forms/ts/simpleNgModel/simple_ng_model_example.ts region='Component'}
     *
     * When using the `ngModel` within `<form>` tags, you'll also need to supply a `name` attribute
     * so that the control can be registered with the parent form under that name.
     *
     * In the context of a parent form, it's often unnecessary to include one-way or two-way binding,
     * as the parent form syncs the value for you. You access its properties by exporting it into a
     * local template variable using `ngForm` such as (`#f="ngForm"`). Use the variable where
     * needed on form submission.
     *
     * If you do need to populate initial values into your form, using a one-way binding for
     * `ngModel` tends to be sufficient as long as you use the exported form's value rather
     * than the domain model's value on submit.
     *
     * ### Using ngModel within a form
     *
     * The following example shows controls using `ngModel` within a form:
     *
     * {\@example forms/ts/simpleForm/simple_form_example.ts region='Component'}
     *
     * ### Using a standalone ngModel within a group
     *
     * The following example shows you how to use a standalone ngModel control
     * within a form. This controls the display of the form, but doesn't contain form data.
     *
     * ```html
     * <form>
     *   <input name="login" ngModel placeholder="Login">
     *   <input type="checkbox" ngModel [ngModelOptions]="{standalone: true}"> Show more options?
     * </form>
     * <!-- form value: {login: ''} -->
     * ```
     *
     * ### Setting the ngModel name attribute through options
     *
     * The following example shows you an alternate way to set the name attribute. The name attribute is used
     * within a custom form component, and the name `\@Input` property serves a different purpose.
     *
     * ```html
     * <form>
     *   <my-person-control name="Nancy" ngModel [ngModelOptions]="{name: 'user'}">
     *   </my-person-control>
     * </form>
     * <!-- form value: {user: ''} -->
     * ```
     *
     * \@ngModule FormsModule
     * \@publicApi
     */
    var NgModel = /** @class */ (function (_super) {
        __extends(NgModel, _super);
        /**
         * @param {?} parent
         * @param {?} validators
         * @param {?} asyncValidators
         * @param {?} valueAccessors
         */
        function NgModel(parent, validators, asyncValidators, valueAccessors) {
            var _this = _super.call(this) || this;
            _this.control = new FormControl();
            /**
             * \@internal
             */
            _this._registered = false;
            /**
             * \@description
             * Event emitter for producing the `ngModelChange` event after
             * the view model updates.
             */
            _this.update = new EventEmitter();
            _this._parent = parent;
            _this._rawValidators = validators || [];
            _this._rawAsyncValidators = asyncValidators || [];
            _this.valueAccessor = selectValueAccessor(_this, valueAccessors);
            return _this;
        }
        /**
         * \@description
         * A lifecycle method called when the directive's inputs change. For internal use
         * only.
         *
         * @param {?} changes A object of key/value pairs for the set of changed inputs.
         * @return {?}
         */
        NgModel.prototype.ngOnChanges = function (changes) {
            this._checkForErrors();
            if (!this._registered)
                this._setUpControl();
            if ('isDisabled' in changes) {
                this._updateDisabled(changes);
            }
            if (isPropertyUpdated(changes, this.viewModel)) {
                this._updateValue(this.model);
                this.viewModel = this.model;
            }
        };
        /**
         * \@description
         * Lifecycle method called before the directive's instance is destroyed. For internal
         * use only.
         * @return {?}
         */
        NgModel.prototype.ngOnDestroy = function () { this.formDirective && this.formDirective.removeControl(this); };
        Object.defineProperty(NgModel.prototype, "path", {
            /**
             * \@description
             * Returns an array that represents the path from the top-level form to this control.
             * Each index is the string name of the control on that level.
             * @return {?}
             */
            get: function () {
                return this._parent ? controlPath(this.name, this._parent) : [this.name];
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgModel.prototype, "formDirective", {
            /**
             * \@description
             * The top-level directive for this control if present, otherwise null.
             * @return {?}
             */
            get: function () { return this._parent ? this._parent.formDirective : null; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgModel.prototype, "validator", {
            /**
             * \@description
             * Synchronous validator function composed of all the synchronous validators
             * registered with this directive.
             * @return {?}
             */
            get: function () { return composeValidators(this._rawValidators); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgModel.prototype, "asyncValidator", {
            /**
             * \@description
             * Async validator function composed of all the async validators registered with this
             * directive.
             * @return {?}
             */
            get: function () {
                return composeAsyncValidators(this._rawAsyncValidators);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * \@description
         * Sets the new value for the view model and emits an `ngModelChange` event.
         *
         * @param {?} newValue The new value emitted by `ngModelChange`.
         * @return {?}
         */
        NgModel.prototype.viewToModelUpdate = function (newValue) {
            this.viewModel = newValue;
            this.update.emit(newValue);
        };
        /**
         * @private
         * @return {?}
         */
        NgModel.prototype._setUpControl = function () {
            this._setUpdateStrategy();
            this._isStandalone() ? this._setUpStandalone() :
                this.formDirective.addControl(this);
            this._registered = true;
        };
        /**
         * @private
         * @return {?}
         */
        NgModel.prototype._setUpdateStrategy = function () {
            if (this.options && this.options.updateOn != null) {
                this.control._updateOn = this.options.updateOn;
            }
        };
        /**
         * @private
         * @return {?}
         */
        NgModel.prototype._isStandalone = function () {
            return !this._parent || !!(this.options && this.options.standalone);
        };
        /**
         * @private
         * @return {?}
         */
        NgModel.prototype._setUpStandalone = function () {
            setUpControl(this.control, this);
            this.control.updateValueAndValidity({ emitEvent: false });
        };
        /**
         * @private
         * @return {?}
         */
        NgModel.prototype._checkForErrors = function () {
            if (!this._isStandalone()) {
                this._checkParentType();
            }
            this._checkName();
        };
        /**
         * @private
         * @return {?}
         */
        NgModel.prototype._checkParentType = function () {
            if (!(this._parent instanceof NgModelGroup) &&
                this._parent instanceof AbstractFormGroupDirective) {
                TemplateDrivenErrors.formGroupNameException();
            }
            else if (!(this._parent instanceof NgModelGroup) && !(this._parent instanceof NgForm)) {
                TemplateDrivenErrors.modelParentException();
            }
        };
        /**
         * @private
         * @return {?}
         */
        NgModel.prototype._checkName = function () {
            if (this.options && this.options.name)
                this.name = this.options.name;
            if (!this._isStandalone() && !this.name) {
                TemplateDrivenErrors.missingNameException();
            }
        };
        /**
         * @private
         * @param {?} value
         * @return {?}
         */
        NgModel.prototype._updateValue = function (value) {
            var _this = this;
            resolvedPromise$1.then(( /**
             * @return {?}
             */function () { _this.control.setValue(value, { emitViewToModelChange: false }); }));
        };
        /**
         * @private
         * @param {?} changes
         * @return {?}
         */
        NgModel.prototype._updateDisabled = function (changes) {
            var _this = this;
            /** @type {?} */
            var disabledValue = changes['isDisabled'].currentValue;
            /** @type {?} */
            var isDisabled = disabledValue === '' || (disabledValue && disabledValue !== 'false');
            resolvedPromise$1.then(( /**
             * @return {?}
             */function () {
                if (isDisabled && !_this.control.disabled) {
                    _this.control.disable();
                }
                else if (!isDisabled && _this.control.disabled) {
                    _this.control.enable();
                }
            }));
        };
        return NgModel;
    }(NgControl));
    NgModel.decorators = [
        { type: Directive, args: [{
                    selector: '[ngModel]:not([formControlName]):not([formControl])',
                    providers: [formControlBinding],
                    exportAs: 'ngModel'
                },] }
    ];
    /** @nocollapse */
    NgModel.ctorParameters = function () { return [
        { type: ControlContainer, decorators: [{ type: Optional }, { type: Host }] },
        { type: Array, decorators: [{ type: Optional }, { type: Self }, { type: Inject, args: [NG_VALIDATORS,] }] },
        { type: Array, decorators: [{ type: Optional }, { type: Self }, { type: Inject, args: [NG_ASYNC_VALIDATORS,] }] },
        { type: Array, decorators: [{ type: Optional }, { type: Self }, { type: Inject, args: [NG_VALUE_ACCESSOR,] }] }
    ]; };
    NgModel.propDecorators = {
        name: [{ type: Input }],
        isDisabled: [{ type: Input, args: ['disabled',] }],
        model: [{ type: Input, args: ['ngModel',] }],
        options: [{ type: Input, args: ['ngModelOptions',] }],
        update: [{ type: Output, args: ['ngModelChange',] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@description
     *
     * Adds `novalidate` attribute to all forms by default.
     *
     * `novalidate` is used to disable browser's native form validation.
     *
     * If you want to use native validation with Angular forms, just add `ngNativeValidate` attribute:
     *
     * ```
     * <form ngNativeValidate></form>
     * ```
     *
     * \@publicApi
     * \@ngModule ReactiveFormsModule
     * \@ngModule FormsModule
     */
    var ɵNgNoValidate = /** @class */ (function () {
        function ɵNgNoValidate() {
        }
        return ɵNgNoValidate;
    }());
    ɵNgNoValidate.decorators = [
        { type: Directive, args: [{
                    selector: 'form:not([ngNoForm]):not([ngNativeValidate])',
                    host: { 'novalidate': '' },
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Token to provide to turn off the ngModel warning on formControl and formControlName.
     * @type {?}
     */
    var NG_MODEL_WITH_FORM_CONTROL_WARNING = new InjectionToken('NgModelWithFormControlWarning');
    /** @type {?} */
    var formControlBinding$1 = {
        provide: NgControl,
        useExisting: forwardRef(( /**
         * @return {?}
         */function () { return FormControlDirective; }))
    };
    /**
     * \@description
     * * Syncs a standalone `FormControl` instance to a form control element.
     *
     * @see [Reactive Forms Guide](guide/reactive-forms)
     * @see `FormControl`
     * @see `AbstractControl`
     *
     * \@usageNotes
     *
     * ### Registering a single form control
     *
     * The following examples shows how to register a standalone control and set its value.
     *
     * {\@example forms/ts/simpleFormControl/simple_form_control_example.ts region='Component'}
     *
     * ### Use with ngModel
     *
     * Support for using the `ngModel` input property and `ngModelChange` event with reactive
     * form directives has been deprecated in Angular v6 and will be removed in Angular v7.
     *
     * Now deprecated:
     *
     * ```html
     * <input [formControl]="control" [(ngModel)]="value">
     * ```
     *
     * ```ts
     * this.value = 'some value';
     * ```
     *
     * This has been deprecated for a few reasons. First, developers have found this pattern
     * confusing. It seems like the actual `ngModel` directive is being used, but in fact it's
     * an input/output property named `ngModel` on the reactive form directive that simply
     * approximates (some of) its behavior. Specifically, it allows getting/setting the value
     * and intercepting value events. However, some of `ngModel`'s other features - like
     * delaying updates with`ngModelOptions` or exporting the directive - simply don't work,
     * which has understandably caused some confusion.
     *
     * In addition, this pattern mixes template-driven and reactive forms strategies, which
     * we generally don't recommend because it doesn't take advantage of the full benefits of
     * either strategy. Setting the value in the template violates the template-agnostic
     * principles behind reactive forms, whereas adding a `FormControl`/`FormGroup` layer in
     * the class removes the convenience of defining forms in the template.
     *
     * To update your code before v7, you'll want to decide whether to stick with reactive form
     * directives (and get/set values using reactive forms patterns) or switch over to
     * template-driven directives.
     *
     * After (choice 1 - use reactive forms):
     *
     * ```html
     * <input [formControl]="control">
     * ```
     *
     * ```ts
     * this.control.setValue('some value');
     * ```
     *
     * After (choice 2 - use template-driven forms):
     *
     * ```html
     * <input [(ngModel)]="value">
     * ```
     *
     * ```ts
     * this.value = 'some value';
     * ```
     *
     * By default, when you use this pattern, you will see a deprecation warning once in dev
     * mode. You can choose to silence this warning by providing a config for
     * `ReactiveFormsModule` at import time:
     *
     * ```ts
     * imports: [
     *   ReactiveFormsModule.withConfig({warnOnNgModelWithFormControl: 'never'});
     * ]
     * ```
     *
     * Alternatively, you can choose to surface a separate warning for each instance of this
     * pattern with a config value of `"always"`. This may help to track down where in the code
     * the pattern is being used as the code is being updated.
     *
     * \@ngModule ReactiveFormsModule
     * \@publicApi
     */
    var FormControlDirective = /** @class */ (function (_super) {
        __extends(FormControlDirective, _super);
        /**
         * @param {?} validators
         * @param {?} asyncValidators
         * @param {?} valueAccessors
         * @param {?} _ngModelWarningConfig
         */
        function FormControlDirective(validators, asyncValidators, valueAccessors, _ngModelWarningConfig) {
            var _this = _super.call(this) || this;
            _this._ngModelWarningConfig = _ngModelWarningConfig;
            /**
             * @deprecated as of v6
             */
            _this.update = new EventEmitter();
            /**
             * \@description
             * Instance property used to track whether an ngModel warning has been sent out for this
             * particular `FormControlDirective` instance. Used to support warning config of "always".
             *
             * \@internal
             */
            _this._ngModelWarningSent = false;
            _this._rawValidators = validators || [];
            _this._rawAsyncValidators = asyncValidators || [];
            _this.valueAccessor = selectValueAccessor(_this, valueAccessors);
            return _this;
        }
        Object.defineProperty(FormControlDirective.prototype, "isDisabled", {
            /**
             * \@description
             * Triggers a warning that this input should not be used with reactive forms.
             * @param {?} isDisabled
             * @return {?}
             */
            set: function (isDisabled) { ReactiveErrors.disabledAttrWarning(); },
            enumerable: true,
            configurable: true
        });
        /**
         * \@description
         * A lifecycle method called when the directive's inputs change. For internal use
         * only.
         *
         * @param {?} changes A object of key/value pairs for the set of changed inputs.
         * @return {?}
         */
        FormControlDirective.prototype.ngOnChanges = function (changes) {
            if (this._isControlChanged(changes)) {
                setUpControl(this.form, this);
                if (this.control.disabled && ( /** @type {?} */(this.valueAccessor)).setDisabledState) {
                    ( /** @type {?} */(( /** @type {?} */(this.valueAccessor)).setDisabledState))(true);
                }
                this.form.updateValueAndValidity({ emitEvent: false });
            }
            if (isPropertyUpdated(changes, this.viewModel)) {
                _ngModelWarning('formControl', FormControlDirective, this, this._ngModelWarningConfig);
                this.form.setValue(this.model);
                this.viewModel = this.model;
            }
        };
        Object.defineProperty(FormControlDirective.prototype, "path", {
            /**
             * \@description
             * Returns an array that represents the path from the top-level form to this control.
             * Each index is the string name of the control on that level.
             * @return {?}
             */
            get: function () { return []; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FormControlDirective.prototype, "validator", {
            /**
             * \@description
             * Synchronous validator function composed of all the synchronous validators
             * registered with this directive.
             * @return {?}
             */
            get: function () { return composeValidators(this._rawValidators); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FormControlDirective.prototype, "asyncValidator", {
            /**
             * \@description
             * Async validator function composed of all the async validators registered with this
             * directive.
             * @return {?}
             */
            get: function () {
                return composeAsyncValidators(this._rawAsyncValidators);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FormControlDirective.prototype, "control", {
            /**
             * \@description
             * The `FormControl` bound to this directive.
             * @return {?}
             */
            get: function () { return this.form; },
            enumerable: true,
            configurable: true
        });
        /**
         * \@description
         * Sets the new value for the view model and emits an `ngModelChange` event.
         *
         * @param {?} newValue The new value for the view model.
         * @return {?}
         */
        FormControlDirective.prototype.viewToModelUpdate = function (newValue) {
            this.viewModel = newValue;
            this.update.emit(newValue);
        };
        /**
         * @private
         * @param {?} changes
         * @return {?}
         */
        FormControlDirective.prototype._isControlChanged = function (changes) {
            return changes.hasOwnProperty('form');
        };
        return FormControlDirective;
    }(NgControl));
    /**
     * \@description
     * Static property used to track whether any ngModel warnings have been sent across
     * all instances of FormControlDirective. Used to support warning config of "once".
     *
     * \@internal
     */
    FormControlDirective._ngModelWarningSentOnce = false;
    FormControlDirective.decorators = [
        { type: Directive, args: [{ selector: '[formControl]', providers: [formControlBinding$1], exportAs: 'ngForm' },] }
    ];
    /** @nocollapse */
    FormControlDirective.ctorParameters = function () { return [
        { type: Array, decorators: [{ type: Optional }, { type: Self }, { type: Inject, args: [NG_VALIDATORS,] }] },
        { type: Array, decorators: [{ type: Optional }, { type: Self }, { type: Inject, args: [NG_ASYNC_VALIDATORS,] }] },
        { type: Array, decorators: [{ type: Optional }, { type: Self }, { type: Inject, args: [NG_VALUE_ACCESSOR,] }] },
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [NG_MODEL_WITH_FORM_CONTROL_WARNING,] }] }
    ]; };
    FormControlDirective.propDecorators = {
        form: [{ type: Input, args: ['formControl',] }],
        isDisabled: [{ type: Input, args: ['disabled',] }],
        model: [{ type: Input, args: ['ngModel',] }],
        update: [{ type: Output, args: ['ngModelChange',] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var formDirectiveProvider$1 = {
        provide: ControlContainer,
        useExisting: forwardRef(( /**
         * @return {?}
         */function () { return FormGroupDirective; }))
    };
    /**
     * \@description
     *
     * Binds an existing `FormGroup` to a DOM element.
     *
     * This directive accepts an existing `FormGroup` instance. It will then use this
     * `FormGroup` instance to match any child `FormControl`, `FormGroup`,
     * and `FormArray` instances to child `FormControlName`, `FormGroupName`,
     * and `FormArrayName` directives.
     *
     * @see [Reactive Forms Guide](guide/reactive-forms)
     * @see `AbstractControl`
     *
     * ### Register Form Group
     *
     * The following example registers a `FormGroup` with first name and last name controls,
     * and listens for the *ngSubmit* event when the button is clicked.
     *
     * {\@example forms/ts/simpleFormGroup/simple_form_group_example.ts region='Component'}
     *
     * \@ngModule ReactiveFormsModule
     * \@publicApi
     */
    var FormGroupDirective = /** @class */ (function (_super) {
        __extends(FormGroupDirective, _super);
        /**
         * @param {?} _validators
         * @param {?} _asyncValidators
         */
        function FormGroupDirective(_validators, _asyncValidators) {
            var _this = _super.call(this) || this;
            _this._validators = _validators;
            _this._asyncValidators = _asyncValidators;
            /**
             * \@description
             * Reports whether the form submission has been triggered.
             */
            _this.submitted = false;
            /**
             * \@description
             * Tracks the list of added `FormControlName` instances
             */
            _this.directives = [];
            /**
             * \@description
             * Tracks the `FormGroup` bound to this directive.
             */
            _this.form = ( /** @type {?} */(null));
            /**
             * \@description
             * Emits an event when the form submission has been triggered.
             */
            _this.ngSubmit = new EventEmitter();
            return _this;
        }
        /**
         * \@description
         * A lifecycle method called when the directive's inputs change. For internal use only.
         *
         * @param {?} changes A object of key/value pairs for the set of changed inputs.
         * @return {?}
         */
        FormGroupDirective.prototype.ngOnChanges = function (changes) {
            this._checkFormPresent();
            if (changes.hasOwnProperty('form')) {
                this._updateValidators();
                this._updateDomValue();
                this._updateRegistrations();
            }
        };
        Object.defineProperty(FormGroupDirective.prototype, "formDirective", {
            /**
             * \@description
             * Returns this directive's instance.
             * @return {?}
             */
            get: function () { return this; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FormGroupDirective.prototype, "control", {
            /**
             * \@description
             * Returns the `FormGroup` bound to this directive.
             * @return {?}
             */
            get: function () { return this.form; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FormGroupDirective.prototype, "path", {
            /**
             * \@description
             * Returns an array representing the path to this group. Because this directive
             * always lives at the top level of a form, it always an empty array.
             * @return {?}
             */
            get: function () { return []; },
            enumerable: true,
            configurable: true
        });
        /**
         * \@description
         * Method that sets up the control directive in this group, re-calculates its value
         * and validity, and adds the instance to the internal list of directives.
         *
         * @param {?} dir The `FormControlName` directive instance.
         * @return {?}
         */
        FormGroupDirective.prototype.addControl = function (dir) {
            /** @type {?} */
            var ctrl = this.form.get(dir.path);
            setUpControl(ctrl, dir);
            ctrl.updateValueAndValidity({ emitEvent: false });
            this.directives.push(dir);
            return ctrl;
        };
        /**
         * \@description
         * Retrieves the `FormControl` instance from the provided `FormControlName` directive
         *
         * @param {?} dir The `FormControlName` directive instance.
         * @return {?}
         */
        FormGroupDirective.prototype.getControl = function (dir) { return ( /** @type {?} */(this.form.get(dir.path))); };
        /**
         * \@description
         * Removes the `FormControlName` instance from the internal list of directives
         *
         * @param {?} dir The `FormControlName` directive instance.
         * @return {?}
         */
        FormGroupDirective.prototype.removeControl = function (dir) { removeDir(this.directives, dir); };
        /**
         * Adds a new `FormGroupName` directive instance to the form.
         *
         * @param {?} dir The `FormGroupName` directive instance.
         * @return {?}
         */
        FormGroupDirective.prototype.addFormGroup = function (dir) {
            /** @type {?} */
            var ctrl = this.form.get(dir.path);
            setUpFormContainer(ctrl, dir);
            ctrl.updateValueAndValidity({ emitEvent: false });
        };
        /**
         * No-op method to remove the form group.
         *
         * @param {?} dir The `FormGroupName` directive instance.
         * @return {?}
         */
        FormGroupDirective.prototype.removeFormGroup = function (dir) { };
        /**
         * \@description
         * Retrieves the `FormGroup` for a provided `FormGroupName` directive instance
         *
         * @param {?} dir The `FormGroupName` directive instance.
         * @return {?}
         */
        FormGroupDirective.prototype.getFormGroup = function (dir) { return ( /** @type {?} */(this.form.get(dir.path))); };
        /**
         * Adds a new `FormArrayName` directive instance to the form.
         *
         * @param {?} dir The `FormArrayName` directive instance.
         * @return {?}
         */
        FormGroupDirective.prototype.addFormArray = function (dir) {
            /** @type {?} */
            var ctrl = this.form.get(dir.path);
            setUpFormContainer(ctrl, dir);
            ctrl.updateValueAndValidity({ emitEvent: false });
        };
        /**
         * No-op method to remove the form array.
         *
         * @param {?} dir The `FormArrayName` directive instance.
         * @return {?}
         */
        FormGroupDirective.prototype.removeFormArray = function (dir) { };
        /**
         * \@description
         * Retrieves the `FormArray` for a provided `FormArrayName` directive instance.
         *
         * @param {?} dir The `FormArrayName` directive instance.
         * @return {?}
         */
        FormGroupDirective.prototype.getFormArray = function (dir) { return ( /** @type {?} */(this.form.get(dir.path))); };
        /**
         * Sets the new value for the provided `FormControlName` directive.
         *
         * @param {?} dir The `FormControlName` directive instance.
         * @param {?} value The new value for the directive's control.
         * @return {?}
         */
        FormGroupDirective.prototype.updateModel = function (dir, value) {
            /** @type {?} */
            var ctrl = ( /** @type {?} */(this.form.get(dir.path)));
            ctrl.setValue(value);
        };
        /**
         * \@description
         * Method called with the "submit" event is triggered on the form.
         * Triggers the `ngSubmit` emitter to emit the "submit" event as its payload.
         *
         * @param {?} $event The "submit" event object
         * @return {?}
         */
        FormGroupDirective.prototype.onSubmit = function ($event) {
            (( /** @type {?} */(this))).submitted = true;
            syncPendingControls(this.form, this.directives);
            this.ngSubmit.emit($event);
            return false;
        };
        /**
         * \@description
         * Method called when the "reset" event is triggered on the form.
         * @return {?}
         */
        FormGroupDirective.prototype.onReset = function () { this.resetForm(); };
        /**
         * \@description
         * Resets the form to an initial value and resets its submitted status.
         *
         * @param {?=} value The new value for the form.
         * @return {?}
         */
        FormGroupDirective.prototype.resetForm = function (value) {
            if (value === void 0) { value = undefined; }
            this.form.reset(value);
            (( /** @type {?} */(this))).submitted = false;
        };
        /**
         * \@internal
         * @return {?}
         */
        FormGroupDirective.prototype._updateDomValue = function () {
            var _this = this;
            this.directives.forEach(( /**
             * @param {?} dir
             * @return {?}
             */function (/**
             * @param {?} dir
             * @return {?}
             */ dir) {
                /** @type {?} */
                var newCtrl = _this.form.get(dir.path);
                if (dir.control !== newCtrl) {
                    cleanUpControl(dir.control, dir);
                    if (newCtrl)
                        setUpControl(newCtrl, dir);
                    (( /** @type {?} */(dir))).control = newCtrl;
                }
            }));
            this.form._updateTreeValidity({ emitEvent: false });
        };
        /**
         * @private
         * @return {?}
         */
        FormGroupDirective.prototype._updateRegistrations = function () {
            var _this = this;
            this.form._registerOnCollectionChange(( /**
             * @return {?}
             */function () { return _this._updateDomValue(); }));
            if (this._oldForm)
                this._oldForm._registerOnCollectionChange(( /**
                 * @return {?}
                 */function () { }));
            this._oldForm = this.form;
        };
        /**
         * @private
         * @return {?}
         */
        FormGroupDirective.prototype._updateValidators = function () {
            /** @type {?} */
            var sync = composeValidators(this._validators);
            this.form.validator = Validators.compose([( /** @type {?} */(this.form.validator)), ( /** @type {?} */(sync))]);
            /** @type {?} */
            var async = composeAsyncValidators(this._asyncValidators);
            this.form.asyncValidator = Validators.composeAsync([( /** @type {?} */(this.form.asyncValidator)), ( /** @type {?} */(async))]);
        };
        /**
         * @private
         * @return {?}
         */
        FormGroupDirective.prototype._checkFormPresent = function () {
            if (!this.form) {
                ReactiveErrors.missingFormException();
            }
        };
        return FormGroupDirective;
    }(ControlContainer));
    FormGroupDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[formGroup]',
                    providers: [formDirectiveProvider$1],
                    host: { '(submit)': 'onSubmit($event)', '(reset)': 'onReset()' },
                    exportAs: 'ngForm'
                },] }
    ];
    /** @nocollapse */
    FormGroupDirective.ctorParameters = function () { return [
        { type: Array, decorators: [{ type: Optional }, { type: Self }, { type: Inject, args: [NG_VALIDATORS,] }] },
        { type: Array, decorators: [{ type: Optional }, { type: Self }, { type: Inject, args: [NG_ASYNC_VALIDATORS,] }] }
    ]; };
    FormGroupDirective.propDecorators = {
        form: [{ type: Input, args: ['formGroup',] }],
        ngSubmit: [{ type: Output }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var formGroupNameProvider = {
        provide: ControlContainer,
        useExisting: forwardRef(( /**
         * @return {?}
         */function () { return FormGroupName; }))
    };
    /**
     * \@description
     *
     * Syncs a nested `FormGroup` to a DOM element.
     *
     * This directive can only be used with a parent `FormGroupDirective`.
     *
     * It accepts the string name of the nested `FormGroup` to link, and
     * looks for a `FormGroup` registered with that name in the parent
     * `FormGroup` instance you passed into `FormGroupDirective`.
     *
     * Use nested form groups to validate a sub-group of a
     * form separately from the rest or to group the values of certain
     * controls into their own nested object.
     *
     * @see [Reactive Forms Guide](guide/reactive-forms)
     *
     * \@usageNotes
     *
     * ### Access the group by name
     *
     * The following example uses the {\@link AbstractControl#get get} method to access the
     * associated `FormGroup`
     *
     * ```ts
     *   this.form.get('name');
     * ```
     *
     * ### Access individual controls in the group
     *
     * The following example uses the {\@link AbstractControl#get get} method to access
     * individual controls within the group using dot syntax.
     *
     * ```ts
     *   this.form.get('name.first');
     * ```
     *
     * ### Register a nested `FormGroup`.
     *
     * The following example registers a nested *name* `FormGroup` within an existing `FormGroup`,
     * and provides methods to retrieve the nested `FormGroup` and individual controls.
     *
     * {\@example forms/ts/nestedFormGroup/nested_form_group_example.ts region='Component'}
     *
     * \@ngModule ReactiveFormsModule
     * \@publicApi
     */
    var FormGroupName = /** @class */ (function (_super) {
        __extends(FormGroupName, _super);
        /**
         * @param {?} parent
         * @param {?} validators
         * @param {?} asyncValidators
         */
        function FormGroupName(parent, validators, asyncValidators) {
            var _this = _super.call(this) || this;
            _this._parent = parent;
            _this._validators = validators;
            _this._asyncValidators = asyncValidators;
            return _this;
        }
        /**
         * \@internal
         * @return {?}
         */
        FormGroupName.prototype._checkParentType = function () {
            if (_hasInvalidParent(this._parent)) {
                ReactiveErrors.groupParentException();
            }
        };
        return FormGroupName;
    }(AbstractFormGroupDirective));
    FormGroupName.decorators = [
        { type: Directive, args: [{ selector: '[formGroupName]', providers: [formGroupNameProvider] },] }
    ];
    /** @nocollapse */
    FormGroupName.ctorParameters = function () { return [
        { type: ControlContainer, decorators: [{ type: Optional }, { type: Host }, { type: SkipSelf }] },
        { type: Array, decorators: [{ type: Optional }, { type: Self }, { type: Inject, args: [NG_VALIDATORS,] }] },
        { type: Array, decorators: [{ type: Optional }, { type: Self }, { type: Inject, args: [NG_ASYNC_VALIDATORS,] }] }
    ]; };
    FormGroupName.propDecorators = {
        name: [{ type: Input, args: ['formGroupName',] }]
    };
    /** @type {?} */
    var formArrayNameProvider = {
        provide: ControlContainer,
        useExisting: forwardRef(( /**
         * @return {?}
         */function () { return FormArrayName; }))
    };
    /**
     * \@description
     *
     * Syncs a nested `FormArray` to a DOM element.
     *
     * This directive is designed to be used with a parent `FormGroupDirective` (selector:
     * `[formGroup]`).
     *
     * It accepts the string name of the nested `FormArray` you want to link, and
     * will look for a `FormArray` registered with that name in the parent
     * `FormGroup` instance you passed into `FormGroupDirective`.
     *
     * @see [Reactive Forms Guide](guide/reactive-forms)
     * @see `AbstractControl`
     *
     * \@usageNotes
     *
     * ### Example
     *
     * {\@example forms/ts/nestedFormArray/nested_form_array_example.ts region='Component'}
     *
     * \@ngModule ReactiveFormsModule
     * \@publicApi
     */
    var FormArrayName = /** @class */ (function (_super) {
        __extends(FormArrayName, _super);
        /**
         * @param {?} parent
         * @param {?} validators
         * @param {?} asyncValidators
         */
        function FormArrayName(parent, validators, asyncValidators) {
            var _this = _super.call(this) || this;
            _this._parent = parent;
            _this._validators = validators;
            _this._asyncValidators = asyncValidators;
            return _this;
        }
        /**
         * \@description
         * A lifecycle method called when the directive's inputs are initialized. For internal use only.
         *
         * @throws If the directive does not have a valid parent.
         * @return {?}
         */
        FormArrayName.prototype.ngOnInit = function () {
            this._checkParentType();
            ( /** @type {?} */(this.formDirective)).addFormArray(this);
        };
        /**
         * \@description
         * A lifecycle method called before the directive's instance is destroyed. For internal use only.
         * @return {?}
         */
        FormArrayName.prototype.ngOnDestroy = function () {
            if (this.formDirective) {
                this.formDirective.removeFormArray(this);
            }
        };
        Object.defineProperty(FormArrayName.prototype, "control", {
            /**
             * \@description
             * The `FormArray` bound to this directive.
             * @return {?}
             */
            get: function () { return ( /** @type {?} */(this.formDirective)).getFormArray(this); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FormArrayName.prototype, "formDirective", {
            /**
             * \@description
             * The top-level directive for this group if present, otherwise null.
             * @return {?}
             */
            get: function () {
                return this._parent ? ( /** @type {?} */(this._parent.formDirective)) : null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FormArrayName.prototype, "path", {
            /**
             * \@description
             * Returns an array that represents the path from the top-level form to this control.
             * Each index is the string name of the control on that level.
             * @return {?}
             */
            get: function () { return controlPath(this.name, this._parent); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FormArrayName.prototype, "validator", {
            /**
             * \@description
             * Synchronous validator function composed of all the synchronous validators registered with this
             * directive.
             * @return {?}
             */
            get: function () { return composeValidators(this._validators); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FormArrayName.prototype, "asyncValidator", {
            /**
             * \@description
             * Async validator function composed of all the async validators registered with this directive.
             * @return {?}
             */
            get: function () {
                return composeAsyncValidators(this._asyncValidators);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @private
         * @return {?}
         */
        FormArrayName.prototype._checkParentType = function () {
            if (_hasInvalidParent(this._parent)) {
                ReactiveErrors.arrayParentException();
            }
        };
        return FormArrayName;
    }(ControlContainer));
    FormArrayName.decorators = [
        { type: Directive, args: [{ selector: '[formArrayName]', providers: [formArrayNameProvider] },] }
    ];
    /** @nocollapse */
    FormArrayName.ctorParameters = function () { return [
        { type: ControlContainer, decorators: [{ type: Optional }, { type: Host }, { type: SkipSelf }] },
        { type: Array, decorators: [{ type: Optional }, { type: Self }, { type: Inject, args: [NG_VALIDATORS,] }] },
        { type: Array, decorators: [{ type: Optional }, { type: Self }, { type: Inject, args: [NG_ASYNC_VALIDATORS,] }] }
    ]; };
    FormArrayName.propDecorators = {
        name: [{ type: Input, args: ['formArrayName',] }]
    };
    /**
     * @param {?} parent
     * @return {?}
     */
    function _hasInvalidParent(parent) {
        return !(parent instanceof FormGroupName) && !(parent instanceof FormGroupDirective) &&
            !(parent instanceof FormArrayName);
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var controlNameBinding = {
        provide: NgControl,
        useExisting: forwardRef(( /**
         * @return {?}
         */function () { return FormControlName; }))
    };
    /**
     * \@description
     * Syncs a `FormControl` in an existing `FormGroup` to a form control
     * element by name.
     *
     * @see [Reactive Forms Guide](guide/reactive-forms)
     * @see `FormControl`
     * @see `AbstractControl`
     *
     * \@usageNotes
     *
     * ### Register `FormControl` within a group
     *
     * The following example shows how to register multiple form controls within a form group
     * and set their value.
     *
     * {\@example forms/ts/simpleFormGroup/simple_form_group_example.ts region='Component'}
     *
     * To see `formControlName` examples with different form control types, see:
     *
     * * Radio buttons: `RadioControlValueAccessor`
     * * Selects: `SelectControlValueAccessor`
     *
     * ### Use with ngModel
     *
     * Support for using the `ngModel` input property and `ngModelChange` event with reactive
     * form directives has been deprecated in Angular v6 and will be removed in Angular v7.
     *
     * Now deprecated:
     *
     * ```html
     * <form [formGroup]="form">
     *   <input formControlName="first" [(ngModel)]="value">
     * </form>
     * ```
     *
     * ```ts
     * this.value = 'some value';
     * ```
     *
     * This has been deprecated for a few reasons. First, developers have found this pattern
     * confusing. It seems like the actual `ngModel` directive is being used, but in fact it's
     * an input/output property named `ngModel` on the reactive form directive that simply
     * approximates (some of) its behavior. Specifically, it allows getting/setting the value
     * and intercepting value events. However, some of `ngModel`'s other features - like
     * delaying updates with`ngModelOptions` or exporting the directive - simply don't work,
     * which has understandably caused some confusion.
     *
     * In addition, this pattern mixes template-driven and reactive forms strategies, which
     * we generally don't recommend because it doesn't take advantage of the full benefits of
     * either strategy. Setting the value in the template violates the template-agnostic
     * principles behind reactive forms, whereas adding a `FormControl`/`FormGroup` layer in
     * the class removes the convenience of defining forms in the template.
     *
     * To update your code before v7, you'll want to decide whether to stick with reactive form
     * directives (and get/set values using reactive forms patterns) or switch over to
     * template-driven directives.
     *
     * After (choice 1 - use reactive forms):
     *
     * ```html
     * <form [formGroup]="form">
     *   <input formControlName="first">
     * </form>
     * ```
     *
     * ```ts
     * this.form.get('first').setValue('some value');
     * ```
     *
     * After (choice 2 - use template-driven forms):
     *
     * ```html
     * <input [(ngModel)]="value">
     * ```
     *
     * ```ts
     * this.value = 'some value';
     * ```
     *
     * By default, when you use this pattern, you will see a deprecation warning once in dev
     * mode. You can choose to silence this warning by providing a config for
     * `ReactiveFormsModule` at import time:
     *
     * ```ts
     * imports: [
     *   ReactiveFormsModule.withConfig({warnOnNgModelWithFormControl: 'never'})
     * ]
     * ```
     *
     * Alternatively, you can choose to surface a separate warning for each instance of this
     * pattern with a config value of `"always"`. This may help to track down where in the code
     * the pattern is being used as the code is being updated.
     *
     * \@ngModule ReactiveFormsModule
     * \@publicApi
     */
    var FormControlName = /** @class */ (function (_super) {
        __extends(FormControlName, _super);
        /**
         * @param {?} parent
         * @param {?} validators
         * @param {?} asyncValidators
         * @param {?} valueAccessors
         * @param {?} _ngModelWarningConfig
         */
        function FormControlName(parent, validators, asyncValidators, valueAccessors, _ngModelWarningConfig) {
            var _this = _super.call(this) || this;
            _this._ngModelWarningConfig = _ngModelWarningConfig;
            _this._added = false;
            /**
             * @deprecated as of v6
             */
            _this.update = new EventEmitter();
            /**
             * \@description
             * Instance property used to track whether an ngModel warning has been sent out for this
             * particular FormControlName instance. Used to support warning config of "always".
             *
             * \@internal
             */
            _this._ngModelWarningSent = false;
            _this._parent = parent;
            _this._rawValidators = validators || [];
            _this._rawAsyncValidators = asyncValidators || [];
            _this.valueAccessor = selectValueAccessor(_this, valueAccessors);
            return _this;
        }
        Object.defineProperty(FormControlName.prototype, "isDisabled", {
            /**
             * \@description
             * Triggers a warning that this input should not be used with reactive forms.
             * @param {?} isDisabled
             * @return {?}
             */
            set: function (isDisabled) { ReactiveErrors.disabledAttrWarning(); },
            enumerable: true,
            configurable: true
        });
        /**
         * \@description
         * A lifecycle method called when the directive's inputs change. For internal use only.
         *
         * @param {?} changes A object of key/value pairs for the set of changed inputs.
         * @return {?}
         */
        FormControlName.prototype.ngOnChanges = function (changes) {
            if (!this._added)
                this._setUpControl();
            if (isPropertyUpdated(changes, this.viewModel)) {
                _ngModelWarning('formControlName', FormControlName, this, this._ngModelWarningConfig);
                this.viewModel = this.model;
                this.formDirective.updateModel(this, this.model);
            }
        };
        /**
         * \@description
         * Lifecycle method called before the directive's instance is destroyed. For internal use only.
         * @return {?}
         */
        FormControlName.prototype.ngOnDestroy = function () {
            if (this.formDirective) {
                this.formDirective.removeControl(this);
            }
        };
        /**
         * \@description
         * Sets the new value for the view model and emits an `ngModelChange` event.
         *
         * @param {?} newValue The new value for the view model.
         * @return {?}
         */
        FormControlName.prototype.viewToModelUpdate = function (newValue) {
            this.viewModel = newValue;
            this.update.emit(newValue);
        };
        Object.defineProperty(FormControlName.prototype, "path", {
            /**
             * \@description
             * Returns an array that represents the path from the top-level form to this control.
             * Each index is the string name of the control on that level.
             * @return {?}
             */
            get: function () { return controlPath(this.name, ( /** @type {?} */(this._parent))); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FormControlName.prototype, "formDirective", {
            /**
             * \@description
             * The top-level directive for this group if present, otherwise null.
             * @return {?}
             */
            get: function () { return this._parent ? this._parent.formDirective : null; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FormControlName.prototype, "validator", {
            /**
             * \@description
             * Synchronous validator function composed of all the synchronous validators
             * registered with this directive.
             * @return {?}
             */
            get: function () { return composeValidators(this._rawValidators); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FormControlName.prototype, "asyncValidator", {
            /**
             * \@description
             * Async validator function composed of all the async validators registered with this
             * directive.
             * @return {?}
             */
            get: function () {
                return ( /** @type {?} */(composeAsyncValidators(this._rawAsyncValidators)));
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @private
         * @return {?}
         */
        FormControlName.prototype._checkParentType = function () {
            if (!(this._parent instanceof FormGroupName) &&
                this._parent instanceof AbstractFormGroupDirective) {
                ReactiveErrors.ngModelGroupException();
            }
            else if (!(this._parent instanceof FormGroupName) && !(this._parent instanceof FormGroupDirective) &&
                !(this._parent instanceof FormArrayName)) {
                ReactiveErrors.controlParentException();
            }
        };
        /**
         * @private
         * @return {?}
         */
        FormControlName.prototype._setUpControl = function () {
            this._checkParentType();
            (( /** @type {?} */(this))).control = this.formDirective.addControl(this);
            if (this.control.disabled && ( /** @type {?} */(this.valueAccessor)).setDisabledState) {
                ( /** @type {?} */(( /** @type {?} */(this.valueAccessor)).setDisabledState))(true);
            }
            this._added = true;
        };
        return FormControlName;
    }(NgControl));
    /**
     * \@description
     * Static property used to track whether any ngModel warnings have been sent across
     * all instances of FormControlName. Used to support warning config of "once".
     *
     * \@internal
     */
    FormControlName._ngModelWarningSentOnce = false;
    FormControlName.decorators = [
        { type: Directive, args: [{ selector: '[formControlName]', providers: [controlNameBinding] },] }
    ];
    /** @nocollapse */
    FormControlName.ctorParameters = function () { return [
        { type: ControlContainer, decorators: [{ type: Optional }, { type: Host }, { type: SkipSelf }] },
        { type: Array, decorators: [{ type: Optional }, { type: Self }, { type: Inject, args: [NG_VALIDATORS,] }] },
        { type: Array, decorators: [{ type: Optional }, { type: Self }, { type: Inject, args: [NG_ASYNC_VALIDATORS,] }] },
        { type: Array, decorators: [{ type: Optional }, { type: Self }, { type: Inject, args: [NG_VALUE_ACCESSOR,] }] },
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [NG_MODEL_WITH_FORM_CONTROL_WARNING,] }] }
    ]; };
    FormControlName.propDecorators = {
        name: [{ type: Input, args: ['formControlName',] }],
        isDisabled: [{ type: Input, args: ['disabled',] }],
        model: [{ type: Input, args: ['ngModel',] }],
        update: [{ type: Output, args: ['ngModelChange',] }]
    };
    /**
     * \@description
     * Provider which adds `RequiredValidator` to the `NG_VALIDATORS` multi-provider list.
     * @type {?}
     */
    var REQUIRED_VALIDATOR = {
        provide: NG_VALIDATORS,
        useExisting: forwardRef(( /**
         * @return {?}
         */function () { return RequiredValidator; })),
        multi: true
    };
    /**
     * \@description
     * Provider which adds `CheckboxRequiredValidator` to the `NG_VALIDATORS` multi-provider list.
     * @type {?}
     */
    var CHECKBOX_REQUIRED_VALIDATOR = {
        provide: NG_VALIDATORS,
        useExisting: forwardRef(( /**
         * @return {?}
         */function () { return CheckboxRequiredValidator; })),
        multi: true
    };
    /**
     * \@description
     * A directive that adds the `required` validator to any controls marked with the
     * `required` attribute. The directive is provided with the `NG_VALIDATORS` multi-provider list.
     *
     * @see [Form Validation](guide/form-validation)
     *
     * \@usageNotes
     *
     * ### Adding a required validator using template-driven forms
     *
     * ```
     * <input name="fullName" ngModel required>
     * ```
     *
     * \@ngModule FormsModule
     * \@ngModule ReactiveFormsModule
     * \@publicApi
     */
    var RequiredValidator = /** @class */ (function () {
        function RequiredValidator() {
        }
        Object.defineProperty(RequiredValidator.prototype, "required", {
            /**
             * \@description
             * Tracks changes to the required attribute bound to this directive.
             * @return {?}
             */
            get: function () { return this._required; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._required = value != null && value !== false && "" + value !== 'false';
                if (this._onChange)
                    this._onChange();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * \@description
         * Method that validates whether the control is empty.
         * Returns the validation result if enabled, otherwise null.
         * @param {?} control
         * @return {?}
         */
        RequiredValidator.prototype.validate = function (control) {
            return this.required ? Validators.required(control) : null;
        };
        /**
         * \@description
         * Registers a callback function to call when the validator inputs change.
         *
         * @param {?} fn The callback function
         * @return {?}
         */
        RequiredValidator.prototype.registerOnValidatorChange = function (fn) { this._onChange = fn; };
        return RequiredValidator;
    }());
    RequiredValidator.decorators = [
        { type: Directive, args: [{
                    selector: ':not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]',
                    providers: [REQUIRED_VALIDATOR],
                    host: { '[attr.required]': 'required ? "" : null' }
                },] }
    ];
    RequiredValidator.propDecorators = {
        required: [{ type: Input }]
    };
    /**
     * A Directive that adds the `required` validator to checkbox controls marked with the
     * `required` attribute. The directive is provided with the `NG_VALIDATORS` multi-provider list.
     *
     * @see [Form Validation](guide/form-validation)
     *
     * \@usageNotes
     *
     * ### Adding a required checkbox validator using template-driven forms
     *
     * The following example shows how to add a checkbox required validator to an input attached to an ngModel binding.
     *
     * ```
     * <input type="checkbox" name="active" ngModel required>
     * ```
     *
     * \@publicApi
     * \@ngModule FormsModule
     * \@ngModule ReactiveFormsModule
     */
    var CheckboxRequiredValidator = /** @class */ (function (_super) {
        __extends(CheckboxRequiredValidator, _super);
        function CheckboxRequiredValidator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * \@description
         * Method that validates whether or not the checkbox has been checked.
         * Returns the validation result if enabled, otherwise null.
         * @param {?} control
         * @return {?}
         */
        CheckboxRequiredValidator.prototype.validate = function (control) {
            return this.required ? Validators.requiredTrue(control) : null;
        };
        return CheckboxRequiredValidator;
    }(RequiredValidator));
    CheckboxRequiredValidator.decorators = [
        { type: Directive, args: [{
                    selector: 'input[type=checkbox][required][formControlName],input[type=checkbox][required][formControl],input[type=checkbox][required][ngModel]',
                    providers: [CHECKBOX_REQUIRED_VALIDATOR],
                    host: { '[attr.required]': 'required ? "" : null' }
                },] }
    ];
    /**
     * \@description
     * Provider which adds `EmailValidator` to the `NG_VALIDATORS` multi-provider list.
     * @type {?}
     */
    var EMAIL_VALIDATOR = {
        provide: NG_VALIDATORS,
        useExisting: forwardRef(( /**
         * @return {?}
         */function () { return EmailValidator; })),
        multi: true
    };
    /**
     * A directive that adds the `email` validator to controls marked with the
     * `email` attribute. The directive is provided with the `NG_VALIDATORS` multi-provider list.
     *
     * @see [Form Validation](guide/form-validation)
     *
     * \@usageNotes
     *
     * ### Adding an email validator
     *
     * The following example shows how to add an email validator to an input attached to an ngModel binding.
     *
     * ```
     * <input type="email" name="email" ngModel email>
     * <input type="email" name="email" ngModel email="true">
     * <input type="email" name="email" ngModel [email]="true">
     * ```
     *
     * \@publicApi
     * \@ngModule FormsModule
     * \@ngModule ReactiveFormsModule
     */
    var EmailValidator = /** @class */ (function () {
        function EmailValidator() {
        }
        Object.defineProperty(EmailValidator.prototype, "email", {
            /**
             * \@description
             * Tracks changes to the email attribute bound to this directive.
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._enabled = value === '' || value === true || value === 'true';
                if (this._onChange)
                    this._onChange();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * \@description
         * Method that validates whether an email address is valid.
         * Returns the validation result if enabled, otherwise null.
         * @param {?} control
         * @return {?}
         */
        EmailValidator.prototype.validate = function (control) {
            return this._enabled ? Validators.email(control) : null;
        };
        /**
         * \@description
         * Registers a callback function to call when the validator inputs change.
         *
         * @param {?} fn The callback function
         * @return {?}
         */
        EmailValidator.prototype.registerOnValidatorChange = function (fn) { this._onChange = fn; };
        return EmailValidator;
    }());
    EmailValidator.decorators = [
        { type: Directive, args: [{
                    selector: '[email][formControlName],[email][formControl],[email][ngModel]',
                    providers: [EMAIL_VALIDATOR]
                },] }
    ];
    EmailValidator.propDecorators = {
        email: [{ type: Input }]
    };
    /**
     * \@description
     * Provider which adds `MinLengthValidator` to the `NG_VALIDATORS` multi-provider list.
     * @type {?}
     */
    var MIN_LENGTH_VALIDATOR = {
        provide: NG_VALIDATORS,
        useExisting: forwardRef(( /**
         * @return {?}
         */function () { return MinLengthValidator; })),
        multi: true
    };
    /**
     * A directive that adds minimum length validation to controls marked with the
     * `minlength` attribute. The directive is provided with the `NG_VALIDATORS` mult-provider list.
     *
     * @see [Form Validation](guide/form-validation)
     *
     * \@usageNotes
     *
     * ### Adding a minimum length validator
     *
     * The following example shows how to add a minimum length validator to an input attached to an
     * ngModel binding.
     *
     * ```html
     * <input name="firstName" ngModel minlength="4">
     * ```
     *
     * \@ngModule ReactiveFormsModule
     * \@ngModule FormsModule
     * \@publicApi
     */
    var MinLengthValidator = /** @class */ (function () {
        function MinLengthValidator() {
        }
        /**
         * \@description
         * A lifecycle method called when the directive's inputs change. For internal use
         * only.
         *
         * @param {?} changes A object of key/value pairs for the set of changed inputs.
         * @return {?}
         */
        MinLengthValidator.prototype.ngOnChanges = function (changes) {
            if ('minlength' in changes) {
                this._createValidator();
                if (this._onChange)
                    this._onChange();
            }
        };
        /**
         * \@description
         * Method that validates whether the value meets a minimum length
         * requirement. Returns the validation result if enabled, otherwise null.
         * @param {?} control
         * @return {?}
         */
        MinLengthValidator.prototype.validate = function (control) {
            return this.minlength == null ? null : this._validator(control);
        };
        /**
         * \@description
         * Registers a callback function to call when the validator inputs change.
         *
         * @param {?} fn The callback function
         * @return {?}
         */
        MinLengthValidator.prototype.registerOnValidatorChange = function (fn) { this._onChange = fn; };
        /**
         * @private
         * @return {?}
         */
        MinLengthValidator.prototype._createValidator = function () {
            this._validator = Validators.minLength(parseInt(this.minlength, 10));
        };
        return MinLengthValidator;
    }());
    MinLengthValidator.decorators = [
        { type: Directive, args: [{
                    selector: '[minlength][formControlName],[minlength][formControl],[minlength][ngModel]',
                    providers: [MIN_LENGTH_VALIDATOR],
                    host: { '[attr.minlength]': 'minlength ? minlength : null' }
                },] }
    ];
    MinLengthValidator.propDecorators = {
        minlength: [{ type: Input }]
    };
    /**
     * \@description
     * Provider which adds `MaxLengthValidator` to the `NG_VALIDATORS` multi-provider list.
     * @type {?}
     */
    var MAX_LENGTH_VALIDATOR = {
        provide: NG_VALIDATORS,
        useExisting: forwardRef(( /**
         * @return {?}
         */function () { return MaxLengthValidator; })),
        multi: true
    };
    /**
     * A directive that adds max length validation to controls marked with the
     * `maxlength` attribute. The directive is provided with the `NG_VALIDATORS` multi-provider list.
     *
     * @see [Form Validation](guide/form-validation)
     *
     * \@usageNotes
     *
     * ### Adding a maximum length validator
     *
     * The following example shows how to add a maximum length validator to an input attached to an
     * ngModel binding.
     *
     * ```html
     * <input name="firstName" ngModel maxlength="25">
     * ```
     *
     * \@ngModule ReactiveFormsModule
     * \@ngModule FormsModule
     * \@publicApi
     */
    var MaxLengthValidator = /** @class */ (function () {
        function MaxLengthValidator() {
        }
        /**
         * \@description
         * A lifecycle method called when the directive's inputs change. For internal use
         * only.
         *
         * @param {?} changes A object of key/value pairs for the set of changed inputs.
         * @return {?}
         */
        MaxLengthValidator.prototype.ngOnChanges = function (changes) {
            if ('maxlength' in changes) {
                this._createValidator();
                if (this._onChange)
                    this._onChange();
            }
        };
        /**
         * \@description
         * Method that validates whether the value exceeds
         * the maximum length requirement.
         * @param {?} control
         * @return {?}
         */
        MaxLengthValidator.prototype.validate = function (control) {
            return this.maxlength != null ? this._validator(control) : null;
        };
        /**
         * \@description
         * Registers a callback function to call when the validator inputs change.
         *
         * @param {?} fn The callback function
         * @return {?}
         */
        MaxLengthValidator.prototype.registerOnValidatorChange = function (fn) { this._onChange = fn; };
        /**
         * @private
         * @return {?}
         */
        MaxLengthValidator.prototype._createValidator = function () {
            this._validator = Validators.maxLength(parseInt(this.maxlength, 10));
        };
        return MaxLengthValidator;
    }());
    MaxLengthValidator.decorators = [
        { type: Directive, args: [{
                    selector: '[maxlength][formControlName],[maxlength][formControl],[maxlength][ngModel]',
                    providers: [MAX_LENGTH_VALIDATOR],
                    host: { '[attr.maxlength]': 'maxlength ? maxlength : null' }
                },] }
    ];
    MaxLengthValidator.propDecorators = {
        maxlength: [{ type: Input }]
    };
    /**
     * \@description
     * Provider which adds `PatternValidator` to the `NG_VALIDATORS` multi-provider list.
     * @type {?}
     */
    var PATTERN_VALIDATOR = {
        provide: NG_VALIDATORS,
        useExisting: forwardRef(( /**
         * @return {?}
         */function () { return PatternValidator; })),
        multi: true
    };
    /**
     * \@description
     * A directive that adds regex pattern validation to controls marked with the
     * `pattern` attribute. The regex must match the entire control value.
     * The directive is provided with the `NG_VALIDATORS` multi-provider list.
     *
     * @see [Form Validation](guide/form-validation)
     *
     * \@usageNotes
     *
     * ### Adding a pattern validator
     *
     * The following example shows how to add a pattern validator to an input attached to an
     * ngModel binding.
     *
     * ```html
     * <input name="firstName" ngModel pattern="[a-zA-Z ]*">
     * ```
     *
     * \@ngModule ReactiveFormsModule
     * \@ngModule FormsModule
     * \@publicApi
     */
    var PatternValidator = /** @class */ (function () {
        function PatternValidator() {
        }
        /**
         * \@description
         * A lifecycle method called when the directive's inputs change. For internal use
         * only.
         *
         * @param {?} changes A object of key/value pairs for the set of changed inputs.
         * @return {?}
         */
        PatternValidator.prototype.ngOnChanges = function (changes) {
            if ('pattern' in changes) {
                this._createValidator();
                if (this._onChange)
                    this._onChange();
            }
        };
        /**
         * \@description
         * Method that validates whether the value matches the
         * the pattern requirement.
         * @param {?} control
         * @return {?}
         */
        PatternValidator.prototype.validate = function (control) { return this._validator(control); };
        /**
         * \@description
         * Registers a callback function to call when the validator inputs change.
         *
         * @param {?} fn The callback function
         * @return {?}
         */
        PatternValidator.prototype.registerOnValidatorChange = function (fn) { this._onChange = fn; };
        /**
         * @private
         * @return {?}
         */
        PatternValidator.prototype._createValidator = function () { this._validator = Validators.pattern(this.pattern); };
        return PatternValidator;
    }());
    PatternValidator.decorators = [
        { type: Directive, args: [{
                    selector: '[pattern][formControlName],[pattern][formControl],[pattern][ngModel]',
                    providers: [PATTERN_VALIDATOR],
                    host: { '[attr.pattern]': 'pattern ? pattern : null' }
                },] }
    ];
    PatternValidator.propDecorators = {
        pattern: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var SHARED_FORM_DIRECTIVES = [
        ɵNgNoValidate,
        NgSelectOption,
        ɵNgSelectMultipleOption,
        DefaultValueAccessor,
        NumberValueAccessor,
        RangeValueAccessor,
        CheckboxControlValueAccessor,
        SelectControlValueAccessor,
        SelectMultipleControlValueAccessor,
        RadioControlValueAccessor,
        NgControlStatus,
        NgControlStatusGroup,
        RequiredValidator,
        MinLengthValidator,
        MaxLengthValidator,
        PatternValidator,
        CheckboxRequiredValidator,
        EmailValidator,
    ];
    /** @type {?} */
    var TEMPLATE_DRIVEN_DIRECTIVES = [NgModel, NgModelGroup, NgForm, NgFormSelectorWarning];
    /**
     * Internal module used for sharing directives between FormsModule and ReactiveFormsModule
     */
    var ɵInternalFormsSharedModule = /** @class */ (function () {
        function ɵInternalFormsSharedModule() {
        }
        return ɵInternalFormsSharedModule;
    }());
    ɵInternalFormsSharedModule.decorators = [
        { type: NgModule, args: [{
                    declarations: SHARED_FORM_DIRECTIVES,
                    exports: SHARED_FORM_DIRECTIVES,
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@publicApi
     * @type {?}
     */
    var VERSION$4 = new Version('8.2.14');
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Exports the required providers and directives for template-driven forms,
     * making them available for import by NgModules that import this module.
     *
     * @see [Forms Guide](/guide/forms)
     *
     * \@publicApi
     */
    var FormsModule = /** @class */ (function () {
        function FormsModule() {
        }
        /**
         * \@description
         * Provides options for configuring the template-driven forms module.
         *
         * @param {?} opts An object of configuration options
         * * `warnOnDeprecatedNgFormSelector` Configures when to emit a warning when the deprecated
         * `ngForm` selector is used.
         * @return {?}
         */
        FormsModule.withConfig = function (opts) {
            return {
                ngModule: FormsModule,
                providers: [{ provide: NG_FORM_SELECTOR_WARNING, useValue: opts.warnOnDeprecatedNgFormSelector }]
            };
        };
        return FormsModule;
    }());
    FormsModule.decorators = [
        { type: NgModule, args: [{
                    declarations: TEMPLATE_DRIVEN_DIRECTIVES,
                    providers: [RadioControlRegistry],
                    exports: [ɵInternalFormsSharedModule, TEMPLATE_DRIVEN_DIRECTIVES]
                },] }
    ];
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Used to generate unique ID for each accordion.
     * @type {?}
     */
    var nextId$1 = 0;
    /**
     * Directive whose purpose is to manage the expanded state of CdkAccordionItem children.
     */
    var CdkAccordion = /** @class */ (function () {
        function CdkAccordion() {
            /**
             * Emits when the state of the accordion changes
             */
            this._stateChanges = new Subject();
            /**
             * Stream that emits true/false when openAll/closeAll is triggered.
             */
            this._openCloseAllActions = new Subject();
            /**
             * A readonly id value to use for unique selection coordination.
             */
            this.id = "cdk-accordion-" + nextId$1++;
            this._multi = false;
        }
        Object.defineProperty(CdkAccordion.prototype, "multi", {
            /**
             * Whether the accordion should allow multiple expanded accordion items simultaneously.
             * @return {?}
             */
            get: function () { return this._multi; },
            /**
             * @param {?} multi
             * @return {?}
             */
            set: function (multi) { this._multi = coerceBooleanProperty(multi); },
            enumerable: true,
            configurable: true
        });
        /**
         * Opens all enabled accordion items in an accordion where multi is enabled.
         * @return {?}
         */
        CdkAccordion.prototype.openAll = function () {
            this._openCloseAll(true);
        };
        /**
         * Closes all enabled accordion items in an accordion where multi is enabled.
         * @return {?}
         */
        CdkAccordion.prototype.closeAll = function () {
            this._openCloseAll(false);
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        CdkAccordion.prototype.ngOnChanges = function (changes) {
            this._stateChanges.next(changes);
        };
        /**
         * @return {?}
         */
        CdkAccordion.prototype.ngOnDestroy = function () {
            this._stateChanges.complete();
        };
        /**
         * @private
         * @param {?} expanded
         * @return {?}
         */
        CdkAccordion.prototype._openCloseAll = function (expanded) {
            if (this.multi) {
                this._openCloseAllActions.next(expanded);
            }
        };
        return CdkAccordion;
    }());
    CdkAccordion.decorators = [
        { type: Directive, args: [{
                    selector: 'cdk-accordion, [cdkAccordion]',
                    exportAs: 'cdkAccordion',
                },] },
    ];
    CdkAccordion.propDecorators = {
        multi: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Used to generate unique ID for each accordion item.
     * @type {?}
     */
    var nextId$1$1 = 0;
    var ɵ0$e = undefined;
    /**
     * An basic directive expected to be extended and decorated as a component.  Sets up all
     * events and attributes needed to be managed by a CdkAccordion parent.
     */
    var CdkAccordionItem = /** @class */ (function () {
        /**
         * @param {?} accordion
         * @param {?} _changeDetectorRef
         * @param {?} _expansionDispatcher
         */
        function CdkAccordionItem(accordion, _changeDetectorRef, _expansionDispatcher) {
            var _this = this;
            this.accordion = accordion;
            this._changeDetectorRef = _changeDetectorRef;
            this._expansionDispatcher = _expansionDispatcher;
            /**
             * Subscription to openAll/closeAll events.
             */
            this._openCloseAllSubscription = Subscription.EMPTY;
            /**
             * Event emitted every time the AccordionItem is closed.
             */
            this.closed = new EventEmitter();
            /**
             * Event emitted every time the AccordionItem is opened.
             */
            this.opened = new EventEmitter();
            /**
             * Event emitted when the AccordionItem is destroyed.
             */
            this.destroyed = new EventEmitter();
            /**
             * Emits whenever the expanded state of the accordion changes.
             * Primarily used to facilitate two-way binding.
             * \@docs-private
             */
            this.expandedChange = new EventEmitter();
            /**
             * The unique AccordionItem id.
             */
            this.id = "cdk-accordion-child-" + nextId$1$1++;
            this._expanded = false;
            this._disabled = false;
            /**
             * Unregister function for _expansionDispatcher.
             */
            this._removeUniqueSelectionListener = ( /**
             * @return {?}
             */function () { });
            this._removeUniqueSelectionListener =
                _expansionDispatcher.listen(( /**
                 * @param {?} id
                 * @param {?} accordionId
                 * @return {?}
                 */function (id, accordionId) {
                    if (_this.accordion && !_this.accordion.multi &&
                        _this.accordion.id === accordionId && _this.id !== id) {
                        _this.expanded = false;
                    }
                }));
            // When an accordion item is hosted in an accordion, subscribe to open/close events.
            if (this.accordion) {
                this._openCloseAllSubscription = this._subscribeToOpenCloseAllActions();
            }
        }
        Object.defineProperty(CdkAccordionItem.prototype, "expanded", {
            /**
             * Whether the AccordionItem is expanded.
             * @return {?}
             */
            get: function () { return this._expanded; },
            /**
             * @param {?} expanded
             * @return {?}
             */
            set: function (expanded) {
                expanded = coerceBooleanProperty(expanded);
                // Only emit events and update the internal value if the value changes.
                if (this._expanded !== expanded) {
                    this._expanded = expanded;
                    this.expandedChange.emit(expanded);
                    if (expanded) {
                        this.opened.emit();
                        /**
                         * In the unique selection dispatcher, the id parameter is the id of the CdkAccordionItem,
                         * the name value is the id of the accordion.
                         * @type {?}
                         */
                        var accordionId = this.accordion ? this.accordion.id : this.id;
                        this._expansionDispatcher.notify(this.id, accordionId);
                    }
                    else {
                        this.closed.emit();
                    }
                    // Ensures that the animation will run when the value is set outside of an `@Input`.
                    // This includes cases like the open, close and toggle methods.
                    this._changeDetectorRef.markForCheck();
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CdkAccordionItem.prototype, "disabled", {
            /**
             * Whether the AccordionItem is disabled.
             * @return {?}
             */
            get: function () { return this._disabled; },
            /**
             * @param {?} disabled
             * @return {?}
             */
            set: function (disabled) { this._disabled = coerceBooleanProperty(disabled); },
            enumerable: true,
            configurable: true
        });
        /**
         * Emits an event for the accordion item being destroyed.
         * @return {?}
         */
        CdkAccordionItem.prototype.ngOnDestroy = function () {
            this.opened.complete();
            this.closed.complete();
            this.destroyed.emit();
            this.destroyed.complete();
            this._removeUniqueSelectionListener();
            this._openCloseAllSubscription.unsubscribe();
        };
        /**
         * Toggles the expanded state of the accordion item.
         * @return {?}
         */
        CdkAccordionItem.prototype.toggle = function () {
            if (!this.disabled) {
                this.expanded = !this.expanded;
            }
        };
        /**
         * Sets the expanded state of the accordion item to false.
         * @return {?}
         */
        CdkAccordionItem.prototype.close = function () {
            if (!this.disabled) {
                this.expanded = false;
            }
        };
        /**
         * Sets the expanded state of the accordion item to true.
         * @return {?}
         */
        CdkAccordionItem.prototype.open = function () {
            if (!this.disabled) {
                this.expanded = true;
            }
        };
        /**
         * @private
         * @return {?}
         */
        CdkAccordionItem.prototype._subscribeToOpenCloseAllActions = function () {
            var _this = this;
            return this.accordion._openCloseAllActions.subscribe(( /**
             * @param {?} expanded
             * @return {?}
             */function (/**
             * @param {?} expanded
             * @return {?}
             */ expanded) {
                // Only change expanded state if item is enabled
                if (!_this.disabled) {
                    _this.expanded = expanded;
                }
            }));
        };
        return CdkAccordionItem;
    }());
    CdkAccordionItem.decorators = [
        { type: Directive, args: [{
                    selector: 'cdk-accordion-item, [cdkAccordionItem]',
                    exportAs: 'cdkAccordionItem',
                    providers: [
                        // Provide CdkAccordion as undefined to prevent nested accordion items from registering
                        // to the same accordion.
                        { provide: CdkAccordion, useValue: ɵ0$e },
                    ],
                },] },
    ];
    /** @nocollapse */
    CdkAccordionItem.ctorParameters = function () { return [
        { type: CdkAccordion, decorators: [{ type: Optional }, { type: SkipSelf }] },
        { type: ChangeDetectorRef },
        { type: UniqueSelectionDispatcher }
    ]; };
    CdkAccordionItem.propDecorators = {
        closed: [{ type: Output }],
        opened: [{ type: Output }],
        destroyed: [{ type: Output }],
        expandedChange: [{ type: Output }],
        expanded: [{ type: Input }],
        disabled: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CdkAccordionModule = /** @class */ (function () {
        function CdkAccordionModule() {
        }
        return CdkAccordionModule;
    }());
    CdkAccordionModule.decorators = [
        { type: NgModule, args: [{
                    exports: [CdkAccordion, CdkAccordionItem],
                    declarations: [CdkAccordion, CdkAccordionItem],
                },] },
    ];
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Token used to provide a `MatAccordion` to `MatExpansionPanel`.
     * Used primarily to avoid circular imports between `MatAccordion` and `MatExpansionPanel`.
     * @type {?}
     */
    var MAT_ACCORDION = new InjectionToken('MAT_ACCORDION');
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Time and timing curve for expansion panel animations.
     * @type {?}
     */
    var EXPANSION_PANEL_ANIMATION_TIMING = '225ms cubic-bezier(0.4,0.0,0.2,1)';
    /**
     * Animations used by the Material expansion panel.
     *
     * A bug in angular animation's `state` when ViewContainers are moved using ViewContainerRef.move()
     * causes the animation state of moved components to become `void` upon exit, and not update again
     * upon reentry into the DOM.  This can lead a to situation for the expansion panel where the state
     * of the panel is `expanded` or `collapsed` but the animation state is `void`.
     *
     * To correctly handle animating to the next state, we animate between `void` and `collapsed` which
     * are defined to have the same styles. Since angular animates from the current styles to the
     * destination state's style definition, in situations where we are moving from `void`'s styles to
     * `collapsed` this acts a noop since no style values change.
     *
     * In the case where angular's animation state is out of sync with the expansion panel's state, the
     * expansion panel being `expanded` and angular animations being `void`, the animation from the
     * `expanded`'s effective styles (though in a `void` animation state) to the collapsed state will
     * occur as expected.
     *
     * Angular Bug: https://github.com/angular/angular/issues/18847
     *
     * \@docs-private
     * @type {?}
     */
    var matExpansionAnimations = {
        /**
         * Animation that rotates the indicator arrow.
         */
        indicatorRotate: trigger('indicatorRotate', [
            state('collapsed, void', style({ transform: 'rotate(0deg)' })),
            state('expanded', style({ transform: 'rotate(180deg)' })),
            transition('expanded <=> collapsed, void => collapsed', animate(EXPANSION_PANEL_ANIMATION_TIMING)),
        ]),
        /**
         * Animation that expands and collapses the panel header height.
         */
        expansionHeaderHeight: trigger('expansionHeight', [
            state('collapsed, void', style({
                height: '{{collapsedHeight}}',
            }), {
                params: { collapsedHeight: '48px' },
            }),
            state('expanded', style({
                height: '{{expandedHeight}}'
            }), {
                params: { expandedHeight: '64px' }
            }),
            transition('expanded <=> collapsed, void => collapsed', group([
                query('@indicatorRotate', animateChild(), { optional: true }),
                animate(EXPANSION_PANEL_ANIMATION_TIMING),
            ])),
        ]),
        /**
         * Animation that expands and collapses the panel content.
         */
        bodyExpansion: trigger('bodyExpansion', [
            state('collapsed, void', style({ height: '0px', visibility: 'hidden' })),
            state('expanded', style({ height: '*', visibility: 'visible' })),
            transition('expanded <=> collapsed, void => collapsed', animate(EXPANSION_PANEL_ANIMATION_TIMING)),
        ])
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Expansion panel content that will be rendered lazily
     * after the panel is opened for the first time.
     */
    var MatExpansionPanelContent = /** @class */ (function () {
        /**
         * @param {?} _template
         */
        function MatExpansionPanelContent(_template) {
            this._template = _template;
        }
        return MatExpansionPanelContent;
    }());
    MatExpansionPanelContent.decorators = [
        { type: Directive, args: [{
                    selector: 'ng-template[matExpansionPanelContent]'
                },] },
    ];
    /** @nocollapse */
    MatExpansionPanelContent.ctorParameters = function () { return [
        { type: TemplateRef }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Counter for generating unique element ids.
     * @type {?}
     */
    var uniqueId$1 = 0;
    /**
     * Injection token that can be used to configure the defalt
     * options for the expansion panel component.
     * @type {?}
     */
    var MAT_EXPANSION_PANEL_DEFAULT_OPTIONS = new InjectionToken('MAT_EXPANSION_PANEL_DEFAULT_OPTIONS');
    var ɵ0$h = undefined;
    /**
     * `<mat-expansion-panel>`
     *
     * This component can be used as a single element to show expandable content, or as one of
     * multiple children of an element with the MatAccordion directive attached.
     */
    var MatExpansionPanel = /** @class */ (function (_super) {
        __extends(MatExpansionPanel, _super);
        /**
         * @param {?} accordion
         * @param {?} _changeDetectorRef
         * @param {?} _uniqueSelectionDispatcher
         * @param {?} _viewContainerRef
         * @param {?} _document
         * @param {?} _animationMode
         * @param {?=} defaultOptions
         */
        function MatExpansionPanel(accordion, _changeDetectorRef, _uniqueSelectionDispatcher, _viewContainerRef, _document, _animationMode, defaultOptions) {
            var _this = _super.call(this, accordion, _changeDetectorRef, _uniqueSelectionDispatcher) || this;
            _this._viewContainerRef = _viewContainerRef;
            _this._animationMode = _animationMode;
            _this._hideToggle = false;
            /**
             * An event emitted after the body's expansion animation happens.
             */
            _this.afterExpand = new EventEmitter();
            /**
             * An event emitted after the body's collapse animation happens.
             */
            _this.afterCollapse = new EventEmitter();
            /**
             * Stream that emits for changes in `\@Input` properties.
             */
            _this._inputChanges = new Subject();
            /**
             * ID for the associated header element. Used for a11y labelling.
             */
            _this._headerId = "mat-expansion-panel-header-" + uniqueId$1++;
            /**
             * Stream of body animation done events.
             */
            _this._bodyAnimationDone = new Subject();
            _this.accordion = accordion;
            _this._document = _document;
            // We need a Subject with distinctUntilChanged, because the `done` event
            // fires twice on some browsers. See https://github.com/angular/angular/issues/24084
            _this._bodyAnimationDone.pipe(distinctUntilChanged(( /**
             * @param {?} x
             * @param {?} y
             * @return {?}
             */function (x, y) {
                return x.fromState === y.fromState && x.toState === y.toState;
            }))).subscribe(( /**
             * @param {?} event
             * @return {?}
             */function (/**
             * @param {?} event
             * @return {?}
             */ event) {
                if (event.fromState !== 'void') {
                    if (event.toState === 'expanded') {
                        _this.afterExpand.emit();
                    }
                    else if (event.toState === 'collapsed') {
                        _this.afterCollapse.emit();
                    }
                }
            }));
            if (defaultOptions) {
                _this.hideToggle = defaultOptions.hideToggle;
            }
            return _this;
        }
        Object.defineProperty(MatExpansionPanel.prototype, "hideToggle", {
            /**
             * Whether the toggle indicator should be hidden.
             * @return {?}
             */
            get: function () {
                return this._hideToggle || (this.accordion && this.accordion.hideToggle);
            },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._hideToggle = coerceBooleanProperty(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatExpansionPanel.prototype, "togglePosition", {
            /**
             * The position of the expansion indicator.
             * @return {?}
             */
            get: function () {
                return this._togglePosition || (this.accordion && this.accordion.togglePosition);
            },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._togglePosition = value;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Determines whether the expansion panel should have spacing between it and its siblings.
         * @return {?}
         */
        MatExpansionPanel.prototype._hasSpacing = function () {
            if (this.accordion) {
                // We don't need to subscribe to the `stateChanges` of the parent accordion because each time
                // the [displayMode] input changes, the change detection will also cover the host bindings
                // of this expansion panel.
                return (this.expanded ? this.accordion.displayMode : this._getExpandedState()) === 'default';
            }
            return false;
        };
        /**
         * Gets the expanded state string.
         * @return {?}
         */
        MatExpansionPanel.prototype._getExpandedState = function () {
            return this.expanded ? 'expanded' : 'collapsed';
        };
        /**
         * @return {?}
         */
        MatExpansionPanel.prototype.ngAfterContentInit = function () {
            var _this = this;
            if (this._lazyContent) {
                // Render the content as soon as the panel becomes open.
                this.opened.pipe(startWith(( /** @type {?} */(null))), filter(( /**
                 * @return {?}
                 */function () { return _this.expanded && !_this._portal; })), take(1)).subscribe(( /**
                 * @return {?}
                 */function () {
                    _this._portal = new TemplatePortal(_this._lazyContent._template, _this._viewContainerRef);
                }));
            }
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        MatExpansionPanel.prototype.ngOnChanges = function (changes) {
            this._inputChanges.next(changes);
        };
        /**
         * @return {?}
         */
        MatExpansionPanel.prototype.ngOnDestroy = function () {
            _super.prototype.ngOnDestroy.call(this);
            this._bodyAnimationDone.complete();
            this._inputChanges.complete();
        };
        /**
         * Checks whether the expansion panel's content contains the currently-focused element.
         * @return {?}
         */
        MatExpansionPanel.prototype._containsFocus = function () {
            if (this._body) {
                /** @type {?} */
                var focusedElement = this._document.activeElement;
                /** @type {?} */
                var bodyElement = this._body.nativeElement;
                return focusedElement === bodyElement || bodyElement.contains(focusedElement);
            }
            return false;
        };
        return MatExpansionPanel;
    }(CdkAccordionItem));
    MatExpansionPanel.decorators = [
        { type: Component, args: [{ styles: [".mat-expansion-panel{box-sizing:content-box;display:block;margin:0;border-radius:4px;overflow:hidden;transition:margin 225ms cubic-bezier(.4,0,.2,1),box-shadow 280ms cubic-bezier(.4,0,.2,1)}.mat-accordion .mat-expansion-panel:not(.mat-expanded),.mat-accordion .mat-expansion-panel:not(.mat-expansion-panel-spacing){border-radius:0}.mat-accordion .mat-expansion-panel:first-of-type{border-top-right-radius:4px;border-top-left-radius:4px}.mat-accordion .mat-expansion-panel:last-of-type{border-bottom-right-radius:4px;border-bottom-left-radius:4px}@media (-ms-high-contrast:active){.mat-expansion-panel{outline:solid 1px}}.mat-expansion-panel._mat-animation-noopable,.mat-expansion-panel.ng-animate-disabled,.ng-animate-disabled .mat-expansion-panel{transition:none}.mat-expansion-panel-content{display:flex;flex-direction:column;overflow:visible}.mat-expansion-panel-body{padding:0 24px 16px}.mat-expansion-panel-spacing{margin:16px 0}.mat-accordion>.mat-expansion-panel-spacing:first-child,.mat-accordion>:first-child:not(.mat-expansion-panel) .mat-expansion-panel-spacing{margin-top:0}.mat-accordion>.mat-expansion-panel-spacing:last-child,.mat-accordion>:last-child:not(.mat-expansion-panel) .mat-expansion-panel-spacing{margin-bottom:0}.mat-action-row{border-top-style:solid;border-top-width:1px;display:flex;flex-direction:row;justify-content:flex-end;padding:16px 8px 16px 24px}.mat-action-row button.mat-button-base{margin-left:8px}[dir=rtl] .mat-action-row button.mat-button-base{margin-left:0;margin-right:8px}"],
                    selector: 'mat-expansion-panel',
                    exportAs: 'matExpansionPanel',
                    template: "<ng-content select=\"mat-expansion-panel-header\"></ng-content><div class=\"mat-expansion-panel-content\" role=\"region\" [@bodyExpansion]=\"_getExpandedState()\" (@bodyExpansion.done)=\"_bodyAnimationDone.next($event)\" [attr.aria-labelledby]=\"_headerId\" [id]=\"id\" #body><div class=\"mat-expansion-panel-body\"><ng-content></ng-content><ng-template [cdkPortalOutlet]=\"_portal\"></ng-template></div><ng-content select=\"mat-action-row\"></ng-content></div>",
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    inputs: ['disabled', 'expanded'],
                    outputs: ['opened', 'closed', 'expandedChange'],
                    animations: [matExpansionAnimations.bodyExpansion],
                    providers: [
                        // Provide MatAccordion as undefined to prevent nested expansion panels from registering
                        // to the same accordion.
                        { provide: MAT_ACCORDION, useValue: ɵ0$h },
                    ],
                    host: {
                        'class': 'mat-expansion-panel',
                        '[class.mat-expanded]': 'expanded',
                        '[class._mat-animation-noopable]': '_animationMode === "NoopAnimations"',
                        '[class.mat-expansion-panel-spacing]': '_hasSpacing()',
                    }
                },] },
    ];
    /** @nocollapse */
    MatExpansionPanel.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Optional }, { type: SkipSelf }, { type: Inject, args: [MAT_ACCORDION,] }] },
        { type: ChangeDetectorRef },
        { type: UniqueSelectionDispatcher },
        { type: ViewContainerRef },
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] },
        { type: String, decorators: [{ type: Optional }, { type: Inject, args: [ANIMATION_MODULE_TYPE,] }] },
        { type: undefined, decorators: [{ type: Inject, args: [MAT_EXPANSION_PANEL_DEFAULT_OPTIONS,] }, { type: Optional }] }
    ]; };
    MatExpansionPanel.propDecorators = {
        hideToggle: [{ type: Input }],
        togglePosition: [{ type: Input }],
        afterExpand: [{ type: Output }],
        afterCollapse: [{ type: Output }],
        _lazyContent: [{ type: ContentChild, args: [MatExpansionPanelContent, { static: false },] }],
        _body: [{ type: ViewChild, args: ['body', { static: false },] }]
    };
    var MatExpansionPanelActionRow = /** @class */ (function () {
        function MatExpansionPanelActionRow() {
        }
        return MatExpansionPanelActionRow;
    }());
    MatExpansionPanelActionRow.decorators = [
        { type: Directive, args: [{
                    selector: 'mat-action-row',
                    host: {
                        class: 'mat-action-row'
                    }
                },] },
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * `<mat-expansion-panel-header>`
     *
     * This component corresponds to the header element of an `<mat-expansion-panel>`.
     */
    var MatExpansionPanelHeader = /** @class */ (function () {
        /**
         * @param {?} panel
         * @param {?} _element
         * @param {?} _focusMonitor
         * @param {?} _changeDetectorRef
         * @param {?=} defaultOptions
         */
        function MatExpansionPanelHeader(panel, _element, _focusMonitor, _changeDetectorRef, defaultOptions) {
            var _this = this;
            this.panel = panel;
            this._element = _element;
            this._focusMonitor = _focusMonitor;
            this._changeDetectorRef = _changeDetectorRef;
            this._parentChangeSubscription = Subscription.EMPTY;
            /**
             * Whether Angular animations in the panel header should be disabled.
             */
            this._animationsDisabled = true;
            /** @type {?} */
            var accordionHideToggleChange = panel.accordion ?
                panel.accordion._stateChanges.pipe(filter(( /**
                 * @param {?} changes
                 * @return {?}
                 */function (/**
                 * @param {?} changes
                 * @return {?}
                 */ changes) { return !!(changes['hideToggle'] || changes['togglePosition']); }))) :
                EMPTY;
            // Since the toggle state depends on an @Input on the panel, we
            // need to subscribe and trigger change detection manually.
            this._parentChangeSubscription =
                merge(panel.opened, panel.closed, accordionHideToggleChange, panel._inputChanges.pipe(filter(( /**
                 * @param {?} changes
                 * @return {?}
                 */function (/**
                 * @param {?} changes
                 * @return {?}
                 */ changes) {
                    return !!(changes['hideToggle'] ||
                        changes['disabled'] ||
                        changes['togglePosition']);
                }))))
                    .subscribe(( /**
             * @return {?}
             */function () { return _this._changeDetectorRef.markForCheck(); }));
            // Avoids focus being lost if the panel contained the focused element and was closed.
            panel.closed
                .pipe(filter(( /**
         * @return {?}
         */function () { return panel._containsFocus(); })))
                .subscribe(( /**
         * @return {?}
         */function () { return _focusMonitor.focusVia(_element, 'program'); }));
            _focusMonitor.monitor(_element).subscribe(( /**
             * @param {?} origin
             * @return {?}
             */function (/**
             * @param {?} origin
             * @return {?}
             */ origin) {
                if (origin && panel.accordion) {
                    panel.accordion._handleHeaderFocus(_this);
                }
            }));
            if (defaultOptions) {
                this.expandedHeight = defaultOptions.expandedHeight;
                this.collapsedHeight = defaultOptions.collapsedHeight;
            }
        }
        /**
         * @return {?}
         */
        MatExpansionPanelHeader.prototype._animationStarted = function () {
            // Currently the `expansionHeight` animation has a `void => collapsed` transition which is
            // there to work around a bug in Angular (see #13088), however this introduces a different
            // issue. The new transition will cause the header to animate in on init (see #16067), if the
            // consumer has set a header height that is different from the default one. We work around it
            // by disabling animations on the header and re-enabling them after the first animation has run.
            // Note that Angular dispatches animation events even if animations are disabled. Ideally this
            // wouldn't be necessary if we remove the `void => collapsed` transition, but we have to wait
            // for https://github.com/angular/angular/issues/18847 to be resolved.
            this._animationsDisabled = false;
        };
        Object.defineProperty(MatExpansionPanelHeader.prototype, "disabled", {
            /**
             * Whether the associated panel is disabled. Implemented as a part of `FocusableOption`.
             * \@docs-private
             * @return {?}
             */
            get: function () {
                return this.panel.disabled;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Toggles the expanded state of the panel.
         * @return {?}
         */
        MatExpansionPanelHeader.prototype._toggle = function () {
            this.panel.toggle();
        };
        /**
         * Gets whether the panel is expanded.
         * @return {?}
         */
        MatExpansionPanelHeader.prototype._isExpanded = function () {
            return this.panel.expanded;
        };
        /**
         * Gets the expanded state string of the panel.
         * @return {?}
         */
        MatExpansionPanelHeader.prototype._getExpandedState = function () {
            return this.panel._getExpandedState();
        };
        /**
         * Gets the panel id.
         * @return {?}
         */
        MatExpansionPanelHeader.prototype._getPanelId = function () {
            return this.panel.id;
        };
        /**
         * Gets the toggle position for the header.
         * @return {?}
         */
        MatExpansionPanelHeader.prototype._getTogglePosition = function () {
            return this.panel.togglePosition;
        };
        /**
         * Gets whether the expand indicator should be shown.
         * @return {?}
         */
        MatExpansionPanelHeader.prototype._showToggle = function () {
            return !this.panel.hideToggle && !this.panel.disabled;
        };
        /**
         * Handle keydown event calling to toggle() if appropriate.
         * @param {?} event
         * @return {?}
         */
        MatExpansionPanelHeader.prototype._keydown = function (event) {
            switch (event.keyCode) {
                // Toggle for space and enter keys.
                case SPACE:
                case ENTER:
                    if (!hasModifierKey(event)) {
                        event.preventDefault();
                        this._toggle();
                    }
                    break;
                default:
                    if (this.panel.accordion) {
                        this.panel.accordion._handleHeaderKeydown(event);
                    }
                    return;
            }
        };
        /**
         * Focuses the panel header. Implemented as a part of `FocusableOption`.
         * \@docs-private
         * @param {?=} origin Origin of the action that triggered the focus.
         * @param {?=} options
         * @return {?}
         */
        MatExpansionPanelHeader.prototype.focus = function (origin, options) {
            if (origin === void 0) { origin = 'program'; }
            this._focusMonitor.focusVia(this._element, origin, options);
        };
        /**
         * @return {?}
         */
        MatExpansionPanelHeader.prototype.ngOnDestroy = function () {
            this._parentChangeSubscription.unsubscribe();
            this._focusMonitor.stopMonitoring(this._element);
        };
        return MatExpansionPanelHeader;
    }());
    MatExpansionPanelHeader.decorators = [
        { type: Component, args: [{ selector: 'mat-expansion-panel-header',
                    styles: [".mat-expansion-panel-header{display:flex;flex-direction:row;align-items:center;padding:0 24px;border-radius:inherit}.mat-expansion-panel-header:focus,.mat-expansion-panel-header:hover{outline:0}.mat-expansion-panel-header.mat-expanded:focus,.mat-expansion-panel-header.mat-expanded:hover{background:inherit}.mat-expansion-panel-header:not([aria-disabled=true]){cursor:pointer}.mat-expansion-panel-header.mat-expansion-toggle-indicator-before{flex-direction:row-reverse}.mat-expansion-panel-header.mat-expansion-toggle-indicator-before .mat-expansion-indicator{margin:0 16px 0 0}[dir=rtl] .mat-expansion-panel-header.mat-expansion-toggle-indicator-before .mat-expansion-indicator{margin:0 0 0 16px}.mat-content{display:flex;flex:1;flex-direction:row;overflow:hidden}.mat-expansion-panel-header-description,.mat-expansion-panel-header-title{display:flex;flex-grow:1;margin-right:16px}[dir=rtl] .mat-expansion-panel-header-description,[dir=rtl] .mat-expansion-panel-header-title{margin-right:0;margin-left:16px}.mat-expansion-panel-header-description{flex-grow:2}.mat-expansion-indicator::after{border-style:solid;border-width:0 2px 2px 0;content:'';display:inline-block;padding:3px;transform:rotate(45deg);vertical-align:middle}"],
                    template: "<span class=\"mat-content\"><ng-content select=\"mat-panel-title\"></ng-content><ng-content select=\"mat-panel-description\"></ng-content><ng-content></ng-content></span><span [@indicatorRotate]=\"_getExpandedState()\" *ngIf=\"_showToggle()\" class=\"mat-expansion-indicator\"></span>",
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    animations: [
                        matExpansionAnimations.indicatorRotate,
                        matExpansionAnimations.expansionHeaderHeight
                    ],
                    host: {
                        'class': 'mat-expansion-panel-header',
                        'role': 'button',
                        '[attr.id]': 'panel._headerId',
                        '[attr.tabindex]': 'disabled ? -1 : 0',
                        '[attr.aria-controls]': '_getPanelId()',
                        '[attr.aria-expanded]': '_isExpanded()',
                        '[attr.aria-disabled]': 'panel.disabled',
                        '[class.mat-expanded]': '_isExpanded()',
                        '[class.mat-expansion-toggle-indicator-after]': "_getTogglePosition() === 'after'",
                        '[class.mat-expansion-toggle-indicator-before]': "_getTogglePosition() === 'before'",
                        '(click)': '_toggle()',
                        '(keydown)': '_keydown($event)',
                        '[@.disabled]': '_animationsDisabled',
                        '(@expansionHeight.start)': '_animationStarted()',
                        '[@expansionHeight]': "{\n        value: _getExpandedState(),\n        params: {\n          collapsedHeight: collapsedHeight,\n          expandedHeight: expandedHeight\n        }\n    }",
                    },
                },] },
    ];
    /** @nocollapse */
    MatExpansionPanelHeader.ctorParameters = function () { return [
        { type: MatExpansionPanel, decorators: [{ type: Host }] },
        { type: ElementRef },
        { type: FocusMonitor },
        { type: ChangeDetectorRef },
        { type: undefined, decorators: [{ type: Inject, args: [MAT_EXPANSION_PANEL_DEFAULT_OPTIONS,] }, { type: Optional }] }
    ]; };
    MatExpansionPanelHeader.propDecorators = {
        expandedHeight: [{ type: Input }],
        collapsedHeight: [{ type: Input }]
    };
    /**
     * `<mat-panel-description>`
     *
     * This directive is to be used inside of the MatExpansionPanelHeader component.
     */
    var MatExpansionPanelDescription = /** @class */ (function () {
        function MatExpansionPanelDescription() {
        }
        return MatExpansionPanelDescription;
    }());
    MatExpansionPanelDescription.decorators = [
        { type: Directive, args: [{
                    selector: 'mat-panel-description',
                    host: {
                        class: 'mat-expansion-panel-header-description'
                    }
                },] },
    ];
    /**
     * `<mat-panel-title>`
     *
     * This directive is to be used inside of the MatExpansionPanelHeader component.
     */
    var MatExpansionPanelTitle = /** @class */ (function () {
        function MatExpansionPanelTitle() {
        }
        return MatExpansionPanelTitle;
    }());
    MatExpansionPanelTitle.decorators = [
        { type: Directive, args: [{
                    selector: 'mat-panel-title',
                    host: {
                        class: 'mat-expansion-panel-header-title'
                    }
                },] },
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Directive for a Material Design Accordion.
     */
    var MatAccordion = /** @class */ (function (_super) {
        __extends(MatAccordion, _super);
        function MatAccordion() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this._hideToggle = false;
            /**
             * Display mode used for all expansion panels in the accordion. Currently two display
             * modes exist:
             *  default - a gutter-like spacing is placed around any expanded panel, placing the expanded
             *     panel at a different elevation from the rest of the accordion.
             *  flat - no spacing is placed around expanded panels, showing all panels at the same
             *     elevation.
             */
            _this.displayMode = 'default';
            /**
             * The position of the expansion indicator.
             */
            _this.togglePosition = 'after';
            return _this;
        }
        Object.defineProperty(MatAccordion.prototype, "hideToggle", {
            /**
             * Whether the expansion indicator should be hidden.
             * @return {?}
             */
            get: function () { return this._hideToggle; },
            /**
             * @param {?} show
             * @return {?}
             */
            set: function (show) { this._hideToggle = coerceBooleanProperty(show); },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        MatAccordion.prototype.ngAfterContentInit = function () {
            this._keyManager = new FocusKeyManager(this._headers).withWrap();
        };
        /**
         * Handles keyboard events coming in from the panel headers.
         * @param {?} event
         * @return {?}
         */
        MatAccordion.prototype._handleHeaderKeydown = function (event) {
            var keyCode = event.keyCode;
            /** @type {?} */
            var manager = this._keyManager;
            if (keyCode === HOME) {
                if (!hasModifierKey(event)) {
                    manager.setFirstItemActive();
                    event.preventDefault();
                }
            }
            else if (keyCode === END) {
                if (!hasModifierKey(event)) {
                    manager.setLastItemActive();
                    event.preventDefault();
                }
            }
            else {
                this._keyManager.onKeydown(event);
            }
        };
        /**
         * @param {?} header
         * @return {?}
         */
        MatAccordion.prototype._handleHeaderFocus = function (header) {
            this._keyManager.updateActiveItem(header);
        };
        return MatAccordion;
    }(CdkAccordion));
    MatAccordion.decorators = [
        { type: Directive, args: [{
                    selector: 'mat-accordion',
                    exportAs: 'matAccordion',
                    inputs: ['multi'],
                    providers: [{
                            provide: MAT_ACCORDION,
                            useExisting: MatAccordion
                        }],
                    host: {
                        class: 'mat-accordion'
                    }
                },] },
    ];
    MatAccordion.propDecorators = {
        _headers: [{ type: ContentChildren, args: [MatExpansionPanelHeader, { descendants: true },] }],
        hideToggle: [{ type: Input }],
        displayMode: [{ type: Input }],
        togglePosition: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatExpansionModule = /** @class */ (function () {
        function MatExpansionModule() {
        }
        return MatExpansionModule;
    }());
    MatExpansionModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule, CdkAccordionModule, PortalModule],
                    exports: [
                        MatAccordion,
                        MatExpansionPanel,
                        MatExpansionPanelActionRow,
                        MatExpansionPanelHeader,
                        MatExpansionPanelTitle,
                        MatExpansionPanelDescription,
                        MatExpansionPanelContent,
                    ],
                    declarations: [
                        MatAccordion,
                        MatExpansionPanel,
                        MatExpansionPanelActionRow,
                        MatExpansionPanelHeader,
                        MatExpansionPanelTitle,
                        MatExpansionPanelDescription,
                        MatExpansionPanelContent,
                    ],
                },] },
    ];
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var nextUniqueId$1 = 0;
    /**
     * Single error message to be shown underneath the form field.
     */
    var MatError = /** @class */ (function () {
        function MatError() {
            this.id = "mat-error-" + nextUniqueId$1++;
        }
        return MatError;
    }());
    MatError.decorators = [
        { type: Directive, args: [{
                    selector: 'mat-error',
                    host: {
                        'class': 'mat-error',
                        'role': 'alert',
                        '[attr.id]': 'id',
                    }
                },] },
    ];
    MatError.propDecorators = {
        id: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Animations used by the MatFormField.
     * \@docs-private
     * @type {?}
     */
    var matFormFieldAnimations = {
        /**
         * Animation that transitions the form field's error and hint messages.
         */
        transitionMessages: trigger('transitionMessages', [
            // TODO(mmalerba): Use angular animations for label animation as well.
            state('enter', style({ opacity: 1, transform: 'translateY(0%)' })),
            transition('void => enter', [
                style({ opacity: 0, transform: 'translateY(-100%)' }),
                animate('300ms cubic-bezier(0.55, 0, 0.55, 0.2)'),
            ]),
        ])
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * An interface which allows a control to work inside of a `MatFormField`.
     * @abstract
     * @template T
     */
    var MatFormFieldControl = /** @class */ (function () {
        function MatFormFieldControl() {
        }
        return MatFormFieldControl;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@docs-private
     * @return {?}
     */
    function getMatFormFieldPlaceholderConflictError() {
        return Error('Placeholder attribute and child element were both specified.');
    }
    /**
     * \@docs-private
     * @param {?} align
     * @return {?}
     */
    function getMatFormFieldDuplicatedHintError(align) {
        return Error("A hint was already declared for 'align=\"" + align + "\"'.");
    }
    /**
     * \@docs-private
     * @return {?}
     */
    function getMatFormFieldMissingControlError() {
        return Error('mat-form-field must contain a MatFormFieldControl.');
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var nextUniqueId$1$1 = 0;
    /**
     * Hint text to be shown underneath the form field control.
     */
    var MatHint = /** @class */ (function () {
        function MatHint() {
            /**
             * Whether to align the hint label at the start or end of the line.
             */
            this.align = 'start';
            /**
             * Unique ID for the hint. Used for the aria-describedby on the form field control.
             */
            this.id = "mat-hint-" + nextUniqueId$1$1++;
        }
        return MatHint;
    }());
    MatHint.decorators = [
        { type: Directive, args: [{
                    selector: 'mat-hint',
                    host: {
                        'class': 'mat-hint',
                        '[class.mat-right]': 'align == "end"',
                        '[attr.id]': 'id',
                        // Remove align attribute to prevent it from interfering with layout.
                        '[attr.align]': 'null',
                    }
                },] },
    ];
    MatHint.propDecorators = {
        align: [{ type: Input }],
        id: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The floating label for a `mat-form-field`.
     */
    var MatLabel = /** @class */ (function () {
        function MatLabel() {
        }
        return MatLabel;
    }());
    MatLabel.decorators = [
        { type: Directive, args: [{
                    selector: 'mat-label'
                },] },
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The placeholder text for an `MatFormField`.
     * @deprecated Use `<mat-label>` to specify the label and the `placeholder` attribute to specify the
     *     placeholder.
     * \@breaking-change 8.0.0
     */
    var MatPlaceholder = /** @class */ (function () {
        function MatPlaceholder() {
        }
        return MatPlaceholder;
    }());
    MatPlaceholder.decorators = [
        { type: Directive, args: [{
                    selector: 'mat-placeholder'
                },] },
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Prefix to be placed in front of the form field.
     */
    var MatPrefix = /** @class */ (function () {
        function MatPrefix() {
        }
        return MatPrefix;
    }());
    MatPrefix.decorators = [
        { type: Directive, args: [{
                    selector: '[matPrefix]',
                },] },
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Suffix to be placed at the end of the form field.
     */
    var MatSuffix = /** @class */ (function () {
        function MatSuffix() {
        }
        return MatSuffix;
    }());
    MatSuffix.decorators = [
        { type: Directive, args: [{
                    selector: '[matSuffix]',
                },] },
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var nextUniqueId$2 = 0;
    /** @type {?} */
    var floatingLabelScale = 0.75;
    /** @type {?} */
    var outlineGapPadding = 5;
    /**
     * Boilerplate for applying mixins to MatFormField.
     * \@docs-private
     */
    var MatFormFieldBase = /** @class */ (function () {
        /**
         * @param {?} _elementRef
         */
        function MatFormFieldBase(_elementRef) {
            this._elementRef = _elementRef;
        }
        return MatFormFieldBase;
    }());
    /**
     * Base class to which we're applying the form field mixins.
     * \@docs-private
     * @type {?}
     */
    var _MatFormFieldMixinBase = mixinColor(MatFormFieldBase, 'primary');
    /**
     * Injection token that can be used to configure the
     * default options for all form field within an app.
     * @type {?}
     */
    var MAT_FORM_FIELD_DEFAULT_OPTIONS = new InjectionToken('MAT_FORM_FIELD_DEFAULT_OPTIONS');
    /**
     * Container for form controls that applies Material Design styling and behavior.
     */
    var MatFormField = /** @class */ (function (_super) {
        __extends(MatFormField, _super);
        /**
         * @param {?} _elementRef
         * @param {?} _changeDetectorRef
         * @param {?} labelOptions
         * @param {?} _dir
         * @param {?} _defaults
         * @param {?} _platform
         * @param {?} _ngZone
         * @param {?} _animationMode
         */
        function MatFormField(_elementRef, _changeDetectorRef, labelOptions, _dir, _defaults, _platform, _ngZone, _animationMode) {
            var _this = _super.call(this, _elementRef) || this;
            _this._elementRef = _elementRef;
            _this._changeDetectorRef = _changeDetectorRef;
            _this._dir = _dir;
            _this._defaults = _defaults;
            _this._platform = _platform;
            _this._ngZone = _ngZone;
            /**
             * Whether the outline gap needs to be calculated
             * immediately on the next change detection run.
             */
            _this._outlineGapCalculationNeededImmediately = false;
            /**
             * Whether the outline gap needs to be calculated next time the zone has stabilized.
             */
            _this._outlineGapCalculationNeededOnStable = false;
            _this._destroyed = new Subject();
            /**
             * Override for the logic that disables the label animation in certain cases.
             */
            _this._showAlwaysAnimate = false;
            /**
             * State of the mat-hint and mat-error animations.
             */
            _this._subscriptAnimationState = '';
            _this._hintLabel = '';
            // Unique id for the hint label.
            _this._hintLabelId = "mat-hint-" + nextUniqueId$2++;
            // Unique id for the internal form field label.
            _this._labelId = "mat-form-field-label-" + nextUniqueId$2++;
            /* Holds the previous direction emitted by directionality service change emitter.
                 This is used in updateOutlineGap() method to update the width and position of the gap in the
                 outline. Only relevant for the outline appearance. The direction is getting updated in the
                 UI after directionality service change emission. So the outlines gaps are getting
                 updated in updateOutlineGap() method before connectionContainer child direction change
                 in UI. We may get wrong calculations. So we are storing the previous direction to get the
                 correct outline calculations*/
            _this._previousDirection = 'ltr';
            _this._labelOptions = labelOptions ? labelOptions : {};
            _this.floatLabel = _this._labelOptions.float || 'auto';
            _this._animationsEnabled = _animationMode !== 'NoopAnimations';
            // Set the default through here so we invoke the setter on the first run.
            _this.appearance = (_defaults && _defaults.appearance) ? _defaults.appearance : 'legacy';
            _this._hideRequiredMarker = (_defaults && _defaults.hideRequiredMarker != null) ?
                _defaults.hideRequiredMarker : false;
            return _this;
        }
        Object.defineProperty(MatFormField.prototype, "appearance", {
            /**
             * The form-field appearance style.
             * @return {?}
             */
            get: function () { return this._appearance; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                /** @type {?} */
                var oldValue = this._appearance;
                this._appearance = value || (this._defaults && this._defaults.appearance) || 'legacy';
                if (this._appearance === 'outline' && oldValue !== value) {
                    this._outlineGapCalculationNeededOnStable = true;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatFormField.prototype, "hideRequiredMarker", {
            /**
             * Whether the required marker should be hidden.
             * @return {?}
             */
            get: function () { return this._hideRequiredMarker; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._hideRequiredMarker = coerceBooleanProperty(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatFormField.prototype, "_shouldAlwaysFloat", {
            /**
             * Whether the floating label should always float or not.
             * @return {?}
             */
            get: function () {
                return this.floatLabel === 'always' && !this._showAlwaysAnimate;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatFormField.prototype, "_canLabelFloat", {
            /**
             * Whether the label can float or not.
             * @return {?}
             */
            get: function () { return this.floatLabel !== 'never'; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatFormField.prototype, "hintLabel", {
            /**
             * Text for the form field hint.
             * @return {?}
             */
            get: function () { return this._hintLabel; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._hintLabel = value;
                this._processHints();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatFormField.prototype, "floatLabel", {
            /**
             * Whether the label should always float, never float or float as the user types.
             *
             * Note: only the legacy appearance supports the `never` option. `never` was originally added as a
             * way to make the floating label emulate the behavior of a standard input placeholder. However
             * the form field now supports both floating labels and placeholders. Therefore in the non-legacy
             * appearances the `never` option has been disabled in favor of just using the placeholder.
             * @return {?}
             */
            get: function () {
                return this.appearance !== 'legacy' && this._floatLabel === 'never' ? 'auto' : this._floatLabel;
            },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                if (value !== this._floatLabel) {
                    this._floatLabel = value || this._labelOptions.float || 'auto';
                    this._changeDetectorRef.markForCheck();
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatFormField.prototype, "_control", {
            /**
             * @return {?}
             */
            get: function () {
                // TODO(crisbeto): we need this hacky workaround in order to support both Ivy
                // and ViewEngine. We should clean this up once Ivy is the default renderer.
                return this._explicitFormFieldControl || this._controlNonStatic || this._controlStatic;
            },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._explicitFormFieldControl = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatFormField.prototype, "_labelChild", {
            /**
             * @return {?}
             */
            get: function () {
                return this._labelChildNonStatic || this._labelChildStatic;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Gets an ElementRef for the element that a overlay attached to the form-field should be
         * positioned relative to.
         * @return {?}
         */
        MatFormField.prototype.getConnectedOverlayOrigin = function () {
            return this._connectionContainerRef || this._elementRef;
        };
        /**
         * @return {?}
         */
        MatFormField.prototype.ngAfterContentInit = function () {
            var _this = this;
            this._validateControlChild();
            /** @type {?} */
            var control = this._control;
            if (control.controlType) {
                this._elementRef.nativeElement.classList.add("mat-form-field-type-" + control.controlType);
            }
            // Subscribe to changes in the child control state in order to update the form field UI.
            control.stateChanges.pipe(startWith(( /** @type {?} */(null)))).subscribe(( /**
             * @return {?}
             */function () {
                _this._validatePlaceholders();
                _this._syncDescribedByIds();
                _this._changeDetectorRef.markForCheck();
            }));
            // Run change detection if the value changes.
            if (control.ngControl && control.ngControl.valueChanges) {
                control.ngControl.valueChanges
                    .pipe(takeUntil(this._destroyed))
                    .subscribe(( /**
             * @return {?}
             */function () { return _this._changeDetectorRef.markForCheck(); }));
            }
            // Note that we have to run outside of the `NgZone` explicitly,
            // in order to avoid throwing users into an infinite loop
            // if `zone-patch-rxjs` is included.
            this._ngZone.runOutsideAngular(( /**
             * @return {?}
             */function () {
                _this._ngZone.onStable.asObservable().pipe(takeUntil(_this._destroyed)).subscribe(( /**
                 * @return {?}
                 */function () {
                    if (_this._outlineGapCalculationNeededOnStable) {
                        _this.updateOutlineGap();
                    }
                }));
            }));
            // Run change detection and update the outline if the suffix or prefix changes.
            merge(this._prefixChildren.changes, this._suffixChildren.changes).subscribe(( /**
             * @return {?}
             */function () {
                _this._outlineGapCalculationNeededOnStable = true;
                _this._changeDetectorRef.markForCheck();
            }));
            // Re-validate when the number of hints changes.
            this._hintChildren.changes.pipe(startWith(null)).subscribe(( /**
             * @return {?}
             */function () {
                _this._processHints();
                _this._changeDetectorRef.markForCheck();
            }));
            // Update the aria-described by when the number of errors changes.
            this._errorChildren.changes.pipe(startWith(null)).subscribe(( /**
             * @return {?}
             */function () {
                _this._syncDescribedByIds();
                _this._changeDetectorRef.markForCheck();
            }));
            if (this._dir) {
                this._dir.change.pipe(takeUntil(this._destroyed)).subscribe(( /**
                 * @return {?}
                 */function () {
                    _this.updateOutlineGap();
                    _this._previousDirection = _this._dir.value;
                }));
            }
        };
        /**
         * @return {?}
         */
        MatFormField.prototype.ngAfterContentChecked = function () {
            this._validateControlChild();
            if (this._outlineGapCalculationNeededImmediately) {
                this.updateOutlineGap();
            }
        };
        /**
         * @return {?}
         */
        MatFormField.prototype.ngAfterViewInit = function () {
            // Avoid animations on load.
            this._subscriptAnimationState = 'enter';
            this._changeDetectorRef.detectChanges();
        };
        /**
         * @return {?}
         */
        MatFormField.prototype.ngOnDestroy = function () {
            this._destroyed.next();
            this._destroyed.complete();
        };
        /**
         * Determines whether a class from the NgControl should be forwarded to the host element.
         * @param {?} prop
         * @return {?}
         */
        MatFormField.prototype._shouldForward = function (prop) {
            /** @type {?} */
            var ngControl = this._control ? this._control.ngControl : null;
            return ngControl && ngControl[prop];
        };
        /**
         * @return {?}
         */
        MatFormField.prototype._hasPlaceholder = function () {
            return !!(this._control && this._control.placeholder || this._placeholderChild);
        };
        /**
         * @return {?}
         */
        MatFormField.prototype._hasLabel = function () {
            return !!this._labelChild;
        };
        /**
         * @return {?}
         */
        MatFormField.prototype._shouldLabelFloat = function () {
            return this._canLabelFloat && (this._control.shouldLabelFloat || this._shouldAlwaysFloat);
        };
        /**
         * @return {?}
         */
        MatFormField.prototype._hideControlPlaceholder = function () {
            // In the legacy appearance the placeholder is promoted to a label if no label is given.
            return this.appearance === 'legacy' && !this._hasLabel() ||
                this._hasLabel() && !this._shouldLabelFloat();
        };
        /**
         * @return {?}
         */
        MatFormField.prototype._hasFloatingLabel = function () {
            // In the legacy appearance the placeholder is promoted to a label if no label is given.
            return this._hasLabel() || this.appearance === 'legacy' && this._hasPlaceholder();
        };
        /**
         * Determines whether to display hints or errors.
         * @return {?}
         */
        MatFormField.prototype._getDisplayedMessages = function () {
            return (this._errorChildren && this._errorChildren.length > 0 &&
                this._control.errorState) ? 'error' : 'hint';
        };
        /**
         * Animates the placeholder up and locks it in position.
         * @return {?}
         */
        MatFormField.prototype._animateAndLockLabel = function () {
            var _this = this;
            if (this._hasFloatingLabel() && this._canLabelFloat) {
                // If animations are disabled, we shouldn't go in here,
                // because the `transitionend` will never fire.
                if (this._animationsEnabled) {
                    this._showAlwaysAnimate = true;
                    fromEvent(this._label.nativeElement, 'transitionend').pipe(take(1)).subscribe(( /**
                     * @return {?}
                     */function () {
                        _this._showAlwaysAnimate = false;
                    }));
                }
                this.floatLabel = 'always';
                this._changeDetectorRef.markForCheck();
            }
        };
        /**
         * Ensure that there is only one placeholder (either `placeholder` attribute on the child control
         * or child element with the `mat-placeholder` directive).
         * @private
         * @return {?}
         */
        MatFormField.prototype._validatePlaceholders = function () {
            if (this._control.placeholder && this._placeholderChild) {
                throw getMatFormFieldPlaceholderConflictError();
            }
        };
        /**
         * Does any extra processing that is required when handling the hints.
         * @private
         * @return {?}
         */
        MatFormField.prototype._processHints = function () {
            this._validateHints();
            this._syncDescribedByIds();
        };
        /**
         * Ensure that there is a maximum of one of each `<mat-hint>` alignment specified, with the
         * attribute being considered as `align="start"`.
         * @private
         * @return {?}
         */
        MatFormField.prototype._validateHints = function () {
            var _this = this;
            if (this._hintChildren) {
                /** @type {?} */
                var startHint_1;
                /** @type {?} */
                var endHint_1;
                this._hintChildren.forEach(( /**
                 * @param {?} hint
                 * @return {?}
                 */function (hint) {
                    if (hint.align === 'start') {
                        if (startHint_1 || _this.hintLabel) {
                            throw getMatFormFieldDuplicatedHintError('start');
                        }
                        startHint_1 = hint;
                    }
                    else if (hint.align === 'end') {
                        if (endHint_1) {
                            throw getMatFormFieldDuplicatedHintError('end');
                        }
                        endHint_1 = hint;
                    }
                }));
            }
        };
        /**
         * Sets the list of element IDs that describe the child control. This allows the control to update
         * its `aria-describedby` attribute accordingly.
         * @private
         * @return {?}
         */
        MatFormField.prototype._syncDescribedByIds = function () {
            if (this._control) {
                /** @type {?} */
                var ids = [];
                if (this._getDisplayedMessages() === 'hint') {
                    /** @type {?} */
                    var startHint = this._hintChildren ?
                        this._hintChildren.find(( /**
                         * @param {?} hint
                         * @return {?}
                         */function (/**
                         * @param {?} hint
                         * @return {?}
                         */ hint) { return hint.align === 'start'; })) : null;
                    /** @type {?} */
                    var endHint = this._hintChildren ?
                        this._hintChildren.find(( /**
                         * @param {?} hint
                         * @return {?}
                         */function (/**
                         * @param {?} hint
                         * @return {?}
                         */ hint) { return hint.align === 'end'; })) : null;
                    if (startHint) {
                        ids.push(startHint.id);
                    }
                    else if (this._hintLabel) {
                        ids.push(this._hintLabelId);
                    }
                    if (endHint) {
                        ids.push(endHint.id);
                    }
                }
                else if (this._errorChildren) {
                    ids = this._errorChildren.map(( /**
                     * @param {?} error
                     * @return {?}
                     */function (/**
                     * @param {?} error
                     * @return {?}
                     */ error) { return error.id; }));
                }
                this._control.setDescribedByIds(ids);
            }
        };
        /**
         * Throws an error if the form field's control is missing.
         * @protected
         * @return {?}
         */
        MatFormField.prototype._validateControlChild = function () {
            if (!this._control) {
                throw getMatFormFieldMissingControlError();
            }
        };
        /**
         * Updates the width and position of the gap in the outline. Only relevant for the outline
         * appearance.
         * @return {?}
         */
        MatFormField.prototype.updateOutlineGap = function () {
            var e_22, _b;
            /** @type {?} */
            var labelEl = this._label ? this._label.nativeElement : null;
            if (this.appearance !== 'outline' || !labelEl || !labelEl.children.length ||
                !labelEl.textContent.trim()) {
                return;
            }
            if (!this._platform.isBrowser) {
                // getBoundingClientRect isn't available on the server.
                return;
            }
            // If the element is not present in the DOM, the outline gap will need to be calculated
            // the next time it is checked and in the DOM.
            if (!( /** @type {?} */(document.documentElement)).contains(this._elementRef.nativeElement)) {
                this._outlineGapCalculationNeededImmediately = true;
                return;
            }
            /** @type {?} */
            var startWidth = 0;
            /** @type {?} */
            var gapWidth = 0;
            /** @type {?} */
            var container = this._connectionContainerRef.nativeElement;
            /** @type {?} */
            var startEls = container.querySelectorAll('.mat-form-field-outline-start');
            /** @type {?} */
            var gapEls = container.querySelectorAll('.mat-form-field-outline-gap');
            if (this._label && this._label.nativeElement.children.length) {
                /** @type {?} */
                var containerRect = container.getBoundingClientRect();
                // If the container's width and height are zero, it means that the element is
                // invisible and we can't calculate the outline gap. Mark the element as needing
                // to be checked the next time the zone stabilizes. We can't do this immediately
                // on the next change detection, because even if the element becomes visible,
                // the `ClientRect` won't be reclaculated immediately. We reset the
                // `_outlineGapCalculationNeededImmediately` flag some we don't run the checks twice.
                if (containerRect.width === 0 && containerRect.height === 0) {
                    this._outlineGapCalculationNeededOnStable = true;
                    this._outlineGapCalculationNeededImmediately = false;
                    return;
                }
                /** @type {?} */
                var containerStart = this._getStartEnd(containerRect);
                /** @type {?} */
                var labelStart = this._getStartEnd(labelEl.children[0].getBoundingClientRect());
                /** @type {?} */
                var labelWidth = 0;
                try {
                    for (var _c = __values(labelEl.children), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var child = _d.value;
                        labelWidth += child.offsetWidth;
                    }
                }
                catch (e_22_1) { e_22 = { error: e_22_1 }; }
                finally {
                    try {
                        if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
                    }
                    finally { if (e_22) throw e_22.error; }
                }
                startWidth = labelStart - containerStart - outlineGapPadding;
                gapWidth = labelWidth > 0 ? labelWidth * floatingLabelScale + outlineGapPadding * 2 : 0;
            }
            for (var i_165 = 0; i_165 < startEls.length; i_165++) {
                startEls.item(i_165).style.width = startWidth + "px";
            }
            for (var i_166 = 0; i_166 < gapEls.length; i_166++) {
                gapEls.item(i_166).style.width = gapWidth + "px";
            }
            this._outlineGapCalculationNeededOnStable =
                this._outlineGapCalculationNeededImmediately = false;
        };
        /**
         * Gets the start end of the rect considering the current directionality.
         * @private
         * @param {?} rect
         * @return {?}
         */
        MatFormField.prototype._getStartEnd = function (rect) {
            return this._previousDirection === 'rtl' ? rect.right : rect.left;
        };
        return MatFormField;
    }(_MatFormFieldMixinBase));
    MatFormField.decorators = [
        { type: Component, args: [{ selector: 'mat-form-field',
                    exportAs: 'matFormField',
                    template: "<div class=\"mat-form-field-wrapper\"><div class=\"mat-form-field-flex\" #connectionContainer (click)=\"_control.onContainerClick && _control.onContainerClick($event)\"><ng-container *ngIf=\"appearance == 'outline'\"><div class=\"mat-form-field-outline\"><div class=\"mat-form-field-outline-start\"></div><div class=\"mat-form-field-outline-gap\"></div><div class=\"mat-form-field-outline-end\"></div></div><div class=\"mat-form-field-outline mat-form-field-outline-thick\"><div class=\"mat-form-field-outline-start\"></div><div class=\"mat-form-field-outline-gap\"></div><div class=\"mat-form-field-outline-end\"></div></div></ng-container><div class=\"mat-form-field-prefix\" *ngIf=\"_prefixChildren.length\"><ng-content select=\"[matPrefix]\"></ng-content></div><div class=\"mat-form-field-infix\" #inputContainer><ng-content></ng-content><span class=\"mat-form-field-label-wrapper\"><label class=\"mat-form-field-label\" (cdkObserveContent)=\"updateOutlineGap()\" [cdkObserveContentDisabled]=\"appearance != 'outline'\" [id]=\"_labelId\" [attr.for]=\"_control.id\" [attr.aria-owns]=\"_control.id\" [class.mat-empty]=\"_control.empty && !_shouldAlwaysFloat\" [class.mat-form-field-empty]=\"_control.empty && !_shouldAlwaysFloat\" [class.mat-accent]=\"color == 'accent'\" [class.mat-warn]=\"color == 'warn'\" #label *ngIf=\"_hasFloatingLabel()\" [ngSwitch]=\"_hasLabel()\"><ng-container *ngSwitchCase=\"false\"><ng-content select=\"mat-placeholder\"></ng-content><span>{{_control.placeholder}}</span></ng-container><ng-content select=\"mat-label\" *ngSwitchCase=\"true\"></ng-content><span class=\"mat-placeholder-required mat-form-field-required-marker\" aria-hidden=\"true\" *ngIf=\"!hideRequiredMarker && _control.required && !_control.disabled\">&#32;*</span></label></span></div><div class=\"mat-form-field-suffix\" *ngIf=\"_suffixChildren.length\"><ng-content select=\"[matSuffix]\"></ng-content></div></div><div class=\"mat-form-field-underline\" #underline *ngIf=\"appearance != 'outline'\"><span class=\"mat-form-field-ripple\" [class.mat-accent]=\"color == 'accent'\" [class.mat-warn]=\"color == 'warn'\"></span></div><div class=\"mat-form-field-subscript-wrapper\" [ngSwitch]=\"_getDisplayedMessages()\"><div *ngSwitchCase=\"'error'\" [@transitionMessages]=\"_subscriptAnimationState\"><ng-content select=\"mat-error\"></ng-content></div><div class=\"mat-form-field-hint-wrapper\" *ngSwitchCase=\"'hint'\" [@transitionMessages]=\"_subscriptAnimationState\"><div *ngIf=\"hintLabel\" [id]=\"_hintLabelId\" class=\"mat-hint\">{{hintLabel}}</div><ng-content select=\"mat-hint:not([align='end'])\"></ng-content><div class=\"mat-form-field-hint-spacer\"></div><ng-content select=\"mat-hint[align='end']\"></ng-content></div></div></div>",
                    // MatInput is a directive and can't have styles, so we need to include its styles here
                    // in form-field-input.css. The MatInput styles are fairly minimal so it shouldn't be a
                    // big deal for people who aren't using MatInput.
                    styles: [".mat-form-field{display:inline-block;position:relative;text-align:left}[dir=rtl] .mat-form-field{text-align:right}.mat-form-field-wrapper{position:relative}.mat-form-field-flex{display:inline-flex;align-items:baseline;box-sizing:border-box;width:100%}.mat-form-field-prefix,.mat-form-field-suffix{white-space:nowrap;flex:none;position:relative}.mat-form-field-infix{display:block;position:relative;flex:auto;min-width:0;width:180px}@media (-ms-high-contrast:active){.mat-form-field-infix{border-image:linear-gradient(transparent,transparent)}}.mat-form-field-label-wrapper{position:absolute;left:0;box-sizing:content-box;width:100%;height:100%;overflow:hidden;pointer-events:none}[dir=rtl] .mat-form-field-label-wrapper{left:auto;right:0}.mat-form-field-label{position:absolute;left:0;font:inherit;pointer-events:none;width:100%;white-space:nowrap;text-overflow:ellipsis;overflow:hidden;transform-origin:0 0;transition:transform .4s cubic-bezier(.25,.8,.25,1),color .4s cubic-bezier(.25,.8,.25,1),width .4s cubic-bezier(.25,.8,.25,1);display:none}[dir=rtl] .mat-form-field-label{transform-origin:100% 0;left:auto;right:0}.mat-form-field-can-float.mat-form-field-should-float .mat-form-field-label,.mat-form-field-empty.mat-form-field-label{display:block}.mat-form-field-autofill-control:-webkit-autofill+.mat-form-field-label-wrapper .mat-form-field-label{display:none}.mat-form-field-can-float .mat-form-field-autofill-control:-webkit-autofill+.mat-form-field-label-wrapper .mat-form-field-label{display:block;transition:none}.mat-input-server:focus+.mat-form-field-label-wrapper .mat-form-field-label,.mat-input-server[placeholder]:not(:placeholder-shown)+.mat-form-field-label-wrapper .mat-form-field-label{display:none}.mat-form-field-can-float .mat-input-server:focus+.mat-form-field-label-wrapper .mat-form-field-label,.mat-form-field-can-float .mat-input-server[placeholder]:not(:placeholder-shown)+.mat-form-field-label-wrapper .mat-form-field-label{display:block}.mat-form-field-label:not(.mat-form-field-empty){transition:none}.mat-form-field-underline{position:absolute;width:100%;pointer-events:none;transform:scaleY(1.0001)}.mat-form-field-ripple{position:absolute;left:0;width:100%;transform-origin:50%;transform:scaleX(.5);opacity:0;transition:background-color .3s cubic-bezier(.55,0,.55,.2)}.mat-form-field.mat-focused .mat-form-field-ripple,.mat-form-field.mat-form-field-invalid .mat-form-field-ripple{opacity:1;transform:scaleX(1);transition:transform .3s cubic-bezier(.25,.8,.25,1),opacity .1s cubic-bezier(.25,.8,.25,1),background-color .3s cubic-bezier(.25,.8,.25,1)}.mat-form-field-subscript-wrapper{position:absolute;box-sizing:border-box;width:100%;overflow:hidden}.mat-form-field-label-wrapper .mat-icon,.mat-form-field-subscript-wrapper .mat-icon{width:1em;height:1em;font-size:inherit;vertical-align:baseline}.mat-form-field-hint-wrapper{display:flex}.mat-form-field-hint-spacer{flex:1 0 1em}.mat-error{display:block}.mat-form-field-control-wrapper{position:relative}.mat-form-field._mat-animation-noopable .mat-form-field-label,.mat-form-field._mat-animation-noopable .mat-form-field-ripple{transition:none} .mat-form-field-appearance-fill .mat-form-field-flex{border-radius:4px 4px 0 0;padding:.75em .75em 0 .75em}@media (-ms-high-contrast:active){.mat-form-field-appearance-fill .mat-form-field-flex{outline:solid 1px}}.mat-form-field-appearance-fill .mat-form-field-underline::before{content:'';display:block;position:absolute;bottom:0;height:1px;width:100%}.mat-form-field-appearance-fill .mat-form-field-ripple{bottom:0;height:2px}@media (-ms-high-contrast:active){.mat-form-field-appearance-fill .mat-form-field-ripple{height:0;border-top:solid 2px}}.mat-form-field-appearance-fill:not(.mat-form-field-disabled) .mat-form-field-flex:hover~.mat-form-field-underline .mat-form-field-ripple{opacity:1;transform:none;transition:opacity .6s cubic-bezier(.25,.8,.25,1)}.mat-form-field-appearance-fill._mat-animation-noopable:not(.mat-form-field-disabled) .mat-form-field-flex:hover~.mat-form-field-underline .mat-form-field-ripple{transition:none}.mat-form-field-appearance-fill .mat-form-field-subscript-wrapper{padding:0 1em} .mat-input-element{font:inherit;background:0 0;color:currentColor;border:none;outline:0;padding:0;margin:0;width:100%;max-width:100%;vertical-align:bottom;text-align:inherit}.mat-input-element:-moz-ui-invalid{box-shadow:none}.mat-input-element::-ms-clear,.mat-input-element::-ms-reveal{display:none}.mat-input-element,.mat-input-element::-webkit-search-cancel-button,.mat-input-element::-webkit-search-decoration,.mat-input-element::-webkit-search-results-button,.mat-input-element::-webkit-search-results-decoration{-webkit-appearance:none}.mat-input-element::-webkit-caps-lock-indicator,.mat-input-element::-webkit-contacts-auto-fill-button,.mat-input-element::-webkit-credentials-auto-fill-button{visibility:hidden}.mat-input-element[type=date]::after,.mat-input-element[type=datetime-local]::after,.mat-input-element[type=datetime]::after,.mat-input-element[type=month]::after,.mat-input-element[type=time]::after,.mat-input-element[type=week]::after{content:' ';white-space:pre;width:1px}.mat-input-element::-webkit-calendar-picker-indicator,.mat-input-element::-webkit-clear-button,.mat-input-element::-webkit-inner-spin-button{font-size:.75em}.mat-input-element::placeholder{-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;transition:color .4s .133s cubic-bezier(.25,.8,.25,1)}.mat-input-element::placeholder:-ms-input-placeholder{-ms-user-select:text}.mat-input-element::-moz-placeholder{-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;transition:color .4s .133s cubic-bezier(.25,.8,.25,1)}.mat-input-element::-moz-placeholder:-ms-input-placeholder{-ms-user-select:text}.mat-input-element::-webkit-input-placeholder{-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;transition:color .4s .133s cubic-bezier(.25,.8,.25,1)}.mat-input-element::-webkit-input-placeholder:-ms-input-placeholder{-ms-user-select:text}.mat-input-element:-ms-input-placeholder{-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;transition:color .4s .133s cubic-bezier(.25,.8,.25,1)}.mat-input-element:-ms-input-placeholder:-ms-input-placeholder{-ms-user-select:text}.mat-form-field-hide-placeholder .mat-input-element::placeholder{color:transparent!important;-webkit-text-fill-color:transparent;transition:none}.mat-form-field-hide-placeholder .mat-input-element::-moz-placeholder{color:transparent!important;-webkit-text-fill-color:transparent;transition:none}.mat-form-field-hide-placeholder .mat-input-element::-webkit-input-placeholder{color:transparent!important;-webkit-text-fill-color:transparent;transition:none}.mat-form-field-hide-placeholder .mat-input-element:-ms-input-placeholder{color:transparent!important;-webkit-text-fill-color:transparent;transition:none}textarea.mat-input-element{resize:vertical;overflow:auto}textarea.mat-input-element.cdk-textarea-autosize{resize:none}textarea.mat-input-element{padding:2px 0;margin:-2px 0}select.mat-input-element{-moz-appearance:none;-webkit-appearance:none;position:relative;background-color:transparent;display:inline-flex;box-sizing:border-box;padding-top:1em;top:-1em;margin-bottom:-1em}select.mat-input-element::-ms-expand{display:none}select.mat-input-element::-moz-focus-inner{border:0}select.mat-input-element:not(:disabled){cursor:pointer}select.mat-input-element::-ms-value{color:inherit;background:0 0}@media (-ms-high-contrast:active){.mat-focused select.mat-input-element::-ms-value{color:inherit}}.mat-form-field-type-mat-native-select .mat-form-field-infix::after{content:'';width:0;height:0;border-left:5px solid transparent;border-right:5px solid transparent;border-top:5px solid;position:absolute;top:50%;right:0;margin-top:-2.5px;pointer-events:none}[dir=rtl] .mat-form-field-type-mat-native-select .mat-form-field-infix::after{right:auto;left:0}.mat-form-field-type-mat-native-select .mat-input-element{padding-right:15px}[dir=rtl] .mat-form-field-type-mat-native-select .mat-input-element{padding-right:0;padding-left:15px}.mat-form-field-type-mat-native-select .mat-form-field-label-wrapper{max-width:calc(100% - 10px)}.mat-form-field-type-mat-native-select.mat-form-field-appearance-outline .mat-form-field-infix::after{margin-top:-5px}.mat-form-field-type-mat-native-select.mat-form-field-appearance-fill .mat-form-field-infix::after{margin-top:-10px} .mat-form-field-appearance-legacy .mat-form-field-label{transform:perspective(100px);-ms-transform:none}.mat-form-field-appearance-legacy .mat-form-field-prefix .mat-icon,.mat-form-field-appearance-legacy .mat-form-field-suffix .mat-icon{width:1em}.mat-form-field-appearance-legacy .mat-form-field-prefix .mat-icon-button,.mat-form-field-appearance-legacy .mat-form-field-suffix .mat-icon-button{font:inherit;vertical-align:baseline}.mat-form-field-appearance-legacy .mat-form-field-prefix .mat-icon-button .mat-icon,.mat-form-field-appearance-legacy .mat-form-field-suffix .mat-icon-button .mat-icon{font-size:inherit}.mat-form-field-appearance-legacy .mat-form-field-underline{height:1px}@media (-ms-high-contrast:active){.mat-form-field-appearance-legacy .mat-form-field-underline{height:0;border-top:solid 1px}}.mat-form-field-appearance-legacy .mat-form-field-ripple{top:0;height:2px;overflow:hidden}@media (-ms-high-contrast:active){.mat-form-field-appearance-legacy .mat-form-field-ripple{height:0;border-top:solid 2px}}.mat-form-field-appearance-legacy.mat-form-field-disabled .mat-form-field-underline{background-position:0;background-color:transparent}@media (-ms-high-contrast:active){.mat-form-field-appearance-legacy.mat-form-field-disabled .mat-form-field-underline{border-top-style:dotted;border-top-width:2px}}.mat-form-field-appearance-legacy.mat-form-field-invalid:not(.mat-focused) .mat-form-field-ripple{height:1px} .mat-form-field-appearance-outline .mat-form-field-wrapper{margin:.25em 0}.mat-form-field-appearance-outline .mat-form-field-flex{padding:0 .75em 0 .75em;margin-top:-.25em;position:relative}.mat-form-field-appearance-outline .mat-form-field-prefix,.mat-form-field-appearance-outline .mat-form-field-suffix{top:.25em}.mat-form-field-appearance-outline .mat-form-field-outline{display:flex;position:absolute;top:.25em;left:0;right:0;bottom:0;pointer-events:none}.mat-form-field-appearance-outline .mat-form-field-outline-end,.mat-form-field-appearance-outline .mat-form-field-outline-start{border:1px solid currentColor;min-width:5px}.mat-form-field-appearance-outline .mat-form-field-outline-start{border-radius:5px 0 0 5px;border-right-style:none}[dir=rtl] .mat-form-field-appearance-outline .mat-form-field-outline-start{border-right-style:solid;border-left-style:none;border-radius:0 5px 5px 0}.mat-form-field-appearance-outline .mat-form-field-outline-end{border-radius:0 5px 5px 0;border-left-style:none;flex-grow:1}[dir=rtl] .mat-form-field-appearance-outline .mat-form-field-outline-end{border-left-style:solid;border-right-style:none;border-radius:5px 0 0 5px}.mat-form-field-appearance-outline .mat-form-field-outline-gap{border-radius:.000001px;border:1px solid currentColor;border-left-style:none;border-right-style:none}.mat-form-field-appearance-outline.mat-form-field-can-float.mat-form-field-should-float .mat-form-field-outline-gap{border-top-color:transparent}.mat-form-field-appearance-outline .mat-form-field-outline-thick{opacity:0}.mat-form-field-appearance-outline .mat-form-field-outline-thick .mat-form-field-outline-end,.mat-form-field-appearance-outline .mat-form-field-outline-thick .mat-form-field-outline-gap,.mat-form-field-appearance-outline .mat-form-field-outline-thick .mat-form-field-outline-start{border-width:2px;transition:border-color .3s cubic-bezier(.25,.8,.25,1)}.mat-form-field-appearance-outline.mat-focused .mat-form-field-outline,.mat-form-field-appearance-outline.mat-form-field-invalid .mat-form-field-outline{opacity:0;transition:opacity .1s cubic-bezier(.25,.8,.25,1)}.mat-form-field-appearance-outline.mat-focused .mat-form-field-outline-thick,.mat-form-field-appearance-outline.mat-form-field-invalid .mat-form-field-outline-thick{opacity:1}.mat-form-field-appearance-outline:not(.mat-form-field-disabled) .mat-form-field-flex:hover .mat-form-field-outline{opacity:0;transition:opacity .6s cubic-bezier(.25,.8,.25,1)}.mat-form-field-appearance-outline:not(.mat-form-field-disabled) .mat-form-field-flex:hover .mat-form-field-outline-thick{opacity:1}.mat-form-field-appearance-outline .mat-form-field-subscript-wrapper{padding:0 1em}.mat-form-field-appearance-outline._mat-animation-noopable .mat-form-field-outline,.mat-form-field-appearance-outline._mat-animation-noopable .mat-form-field-outline-end,.mat-form-field-appearance-outline._mat-animation-noopable .mat-form-field-outline-gap,.mat-form-field-appearance-outline._mat-animation-noopable .mat-form-field-outline-start,.mat-form-field-appearance-outline._mat-animation-noopable:not(.mat-form-field-disabled) .mat-form-field-flex:hover~.mat-form-field-outline{transition:none} .mat-form-field-appearance-standard .mat-form-field-flex{padding-top:.75em}.mat-form-field-appearance-standard .mat-form-field-underline{height:1px}@media (-ms-high-contrast:active){.mat-form-field-appearance-standard .mat-form-field-underline{height:0;border-top:solid 1px}}.mat-form-field-appearance-standard .mat-form-field-ripple{bottom:0;height:2px}@media (-ms-high-contrast:active){.mat-form-field-appearance-standard .mat-form-field-ripple{height:0;border-top:2px}}.mat-form-field-appearance-standard.mat-form-field-disabled .mat-form-field-underline{background-position:0;background-color:transparent}@media (-ms-high-contrast:active){.mat-form-field-appearance-standard.mat-form-field-disabled .mat-form-field-underline{border-top-style:dotted;border-top-width:2px}}.mat-form-field-appearance-standard:not(.mat-form-field-disabled) .mat-form-field-flex:hover~.mat-form-field-underline .mat-form-field-ripple{opacity:1;transform:none;transition:opacity .6s cubic-bezier(.25,.8,.25,1)}.mat-form-field-appearance-standard._mat-animation-noopable:not(.mat-form-field-disabled) .mat-form-field-flex:hover~.mat-form-field-underline .mat-form-field-ripple{transition:none}"],
                    animations: [matFormFieldAnimations.transitionMessages],
                    host: {
                        'class': 'mat-form-field',
                        '[class.mat-form-field-appearance-standard]': 'appearance == "standard"',
                        '[class.mat-form-field-appearance-fill]': 'appearance == "fill"',
                        '[class.mat-form-field-appearance-outline]': 'appearance == "outline"',
                        '[class.mat-form-field-appearance-legacy]': 'appearance == "legacy"',
                        '[class.mat-form-field-invalid]': '_control.errorState',
                        '[class.mat-form-field-can-float]': '_canLabelFloat',
                        '[class.mat-form-field-should-float]': '_shouldLabelFloat()',
                        '[class.mat-form-field-has-label]': '_hasFloatingLabel()',
                        '[class.mat-form-field-hide-placeholder]': '_hideControlPlaceholder()',
                        '[class.mat-form-field-disabled]': '_control.disabled',
                        '[class.mat-form-field-autofilled]': '_control.autofilled',
                        '[class.mat-focused]': '_control.focused',
                        '[class.mat-accent]': 'color == "accent"',
                        '[class.mat-warn]': 'color == "warn"',
                        '[class.ng-untouched]': '_shouldForward("untouched")',
                        '[class.ng-touched]': '_shouldForward("touched")',
                        '[class.ng-pristine]': '_shouldForward("pristine")',
                        '[class.ng-dirty]': '_shouldForward("dirty")',
                        '[class.ng-valid]': '_shouldForward("valid")',
                        '[class.ng-invalid]': '_shouldForward("invalid")',
                        '[class.ng-pending]': '_shouldForward("pending")',
                        '[class._mat-animation-noopable]': '!_animationsEnabled',
                    },
                    inputs: ['color'],
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                },] },
    ];
    /** @nocollapse */
    MatFormField.ctorParameters = function () { return [
        { type: ElementRef },
        { type: ChangeDetectorRef },
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [MAT_LABEL_GLOBAL_OPTIONS,] }] },
        { type: Directionality, decorators: [{ type: Optional }] },
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [MAT_FORM_FIELD_DEFAULT_OPTIONS,] }] },
        { type: Platform },
        { type: NgZone },
        { type: String, decorators: [{ type: Optional }, { type: Inject, args: [ANIMATION_MODULE_TYPE,] }] }
    ]; };
    MatFormField.propDecorators = {
        appearance: [{ type: Input }],
        hideRequiredMarker: [{ type: Input }],
        hintLabel: [{ type: Input }],
        floatLabel: [{ type: Input }],
        underlineRef: [{ type: ViewChild, args: ['underline', { static: false },] }],
        _connectionContainerRef: [{ type: ViewChild, args: ['connectionContainer', { static: true },] }],
        _inputContainerRef: [{ type: ViewChild, args: ['inputContainer', { static: false },] }],
        _label: [{ type: ViewChild, args: ['label', { static: false },] }],
        _controlNonStatic: [{ type: ContentChild, args: [MatFormFieldControl, { static: false },] }],
        _controlStatic: [{ type: ContentChild, args: [MatFormFieldControl, { static: true },] }],
        _labelChildNonStatic: [{ type: ContentChild, args: [MatLabel, { static: false },] }],
        _labelChildStatic: [{ type: ContentChild, args: [MatLabel, { static: true },] }],
        _placeholderChild: [{ type: ContentChild, args: [MatPlaceholder, { static: false },] }],
        _errorChildren: [{ type: ContentChildren, args: [MatError,] }],
        _hintChildren: [{ type: ContentChildren, args: [MatHint,] }],
        _prefixChildren: [{ type: ContentChildren, args: [MatPrefix,] }],
        _suffixChildren: [{ type: ContentChildren, args: [MatSuffix,] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatFormFieldModule = /** @class */ (function () {
        function MatFormFieldModule() {
        }
        return MatFormFieldModule;
    }());
    MatFormFieldModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [
                        MatError,
                        MatFormField,
                        MatHint,
                        MatLabel,
                        MatPlaceholder,
                        MatPrefix,
                        MatSuffix,
                    ],
                    imports: [
                        CommonModule,
                        ObserversModule,
                    ],
                    exports: [
                        MatError,
                        MatFormField,
                        MatHint,
                        MatLabel,
                        MatPlaceholder,
                        MatPrefix,
                        MatSuffix,
                    ],
                },] },
    ];
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Options to pass to the animationstart listener.
     * @type {?}
     */
    var listenerOptions = normalizePassiveListenerOptions({ passive: true });
    /**
     * An injectable service that can be used to monitor the autofill state of an input.
     * Based on the following blog post:
     * https://medium.com/\@brunn/detecting-autofilled-fields-in-javascript-aed598d25da7
     */
    var AutofillMonitor = /** @class */ (function () {
        /**
         * @param {?} _platform
         * @param {?} _ngZone
         */
        function AutofillMonitor(_platform, _ngZone) {
            this._platform = _platform;
            this._ngZone = _ngZone;
            this._monitoredElements = new Map();
        }
        /**
         * @param {?} elementOrRef
         * @return {?}
         */
        AutofillMonitor.prototype.monitor = function (elementOrRef) {
            var _this = this;
            if (!this._platform.isBrowser) {
                return EMPTY;
            }
            /** @type {?} */
            var element = coerceElement(elementOrRef);
            /** @type {?} */
            var info = this._monitoredElements.get(element);
            if (info) {
                return info.subject.asObservable();
            }
            /** @type {?} */
            var result = new Subject();
            /** @type {?} */
            var cssClass = 'cdk-text-field-autofilled';
            /** @type {?} */
            var listener = ( /** @type {?} */((( /**
             * @param {?} event
             * @return {?}
             */function (event) {
                // Animation events fire on initial element render, we check for the presence of the autofill
                // CSS class to make sure this is a real change in state, not just the initial render before
                // we fire off events.
                if (event.animationName === 'cdk-text-field-autofill-start' &&
                    !element.classList.contains(cssClass)) {
                    element.classList.add(cssClass);
                    _this._ngZone.run(( /**
                     * @return {?}
                     */function () { return result.next({ target: ( /** @type {?} */(event.target)), isAutofilled: true }); }));
                }
                else if (event.animationName === 'cdk-text-field-autofill-end' &&
                    element.classList.contains(cssClass)) {
                    element.classList.remove(cssClass);
                    _this._ngZone.run(( /**
                     * @return {?}
                     */function () { return result.next({ target: ( /** @type {?} */(event.target)), isAutofilled: false }); }));
                }
            }))));
            this._ngZone.runOutsideAngular(( /**
             * @return {?}
             */function () {
                element.addEventListener('animationstart', listener, listenerOptions);
                element.classList.add('cdk-text-field-autofill-monitored');
            }));
            this._monitoredElements.set(element, {
                subject: result,
                unlisten: ( /**
                 * @return {?}
                 */function () {
                    element.removeEventListener('animationstart', listener, listenerOptions);
                })
            });
            return result.asObservable();
        };
        /**
         * @param {?} elementOrRef
         * @return {?}
         */
        AutofillMonitor.prototype.stopMonitoring = function (elementOrRef) {
            /** @type {?} */
            var element = coerceElement(elementOrRef);
            /** @type {?} */
            var info = this._monitoredElements.get(element);
            if (info) {
                info.unlisten();
                info.subject.complete();
                element.classList.remove('cdk-text-field-autofill-monitored');
                element.classList.remove('cdk-text-field-autofilled');
                this._monitoredElements.delete(element);
            }
        };
        /**
         * @return {?}
         */
        AutofillMonitor.prototype.ngOnDestroy = function () {
            var _this = this;
            this._monitoredElements.forEach(( /**
             * @param {?} _info
             * @param {?} element
             * @return {?}
             */function (_info, element) { return _this.stopMonitoring(element); }));
        };
        return AutofillMonitor;
    }());
    AutofillMonitor.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] },
    ];
    /** @nocollapse */
    AutofillMonitor.ctorParameters = function () { return [
        { type: Platform },
        { type: NgZone }
    ]; };
    /** @nocollapse */ AutofillMonitor.ngInjectableDef = ɵɵdefineInjectable({ factory: function AutofillMonitor_Factory() { return new AutofillMonitor(ɵɵinject(Platform), ɵɵinject(NgZone)); }, token: AutofillMonitor, providedIn: "root" });
    /**
     * A directive that can be used to monitor the autofill state of an input.
     */
    var CdkAutofill = /** @class */ (function () {
        /**
         * @param {?} _elementRef
         * @param {?} _autofillMonitor
         */
        function CdkAutofill(_elementRef, _autofillMonitor) {
            this._elementRef = _elementRef;
            this._autofillMonitor = _autofillMonitor;
            /**
             * Emits when the autofill state of the element changes.
             */
            this.cdkAutofill = new EventEmitter();
        }
        /**
         * @return {?}
         */
        CdkAutofill.prototype.ngOnInit = function () {
            var _this = this;
            this._autofillMonitor
                .monitor(this._elementRef)
                .subscribe(( /**
         * @param {?} event
         * @return {?}
         */function (/**
         * @param {?} event
         * @return {?}
         */ event) { return _this.cdkAutofill.emit(event); }));
        };
        /**
         * @return {?}
         */
        CdkAutofill.prototype.ngOnDestroy = function () {
            this._autofillMonitor.stopMonitoring(this._elementRef);
        };
        return CdkAutofill;
    }());
    CdkAutofill.decorators = [
        { type: Directive, args: [{
                    selector: '[cdkAutofill]',
                },] },
    ];
    /** @nocollapse */
    CdkAutofill.ctorParameters = function () { return [
        { type: ElementRef },
        { type: AutofillMonitor }
    ]; };
    CdkAutofill.propDecorators = {
        cdkAutofill: [{ type: Output }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Directive to automatically resize a textarea to fit its content.
     */
    var CdkTextareaAutosize = /** @class */ (function () {
        /**
         * @param {?} _elementRef
         * @param {?} _platform
         * @param {?} _ngZone
         */
        function CdkTextareaAutosize(_elementRef, _platform, _ngZone) {
            this._elementRef = _elementRef;
            this._platform = _platform;
            this._ngZone = _ngZone;
            this._destroyed = new Subject();
            this._enabled = true;
            /**
             * Value of minRows as of last resize. If the minRows has decreased, the
             * height of the textarea needs to be recomputed to reflect the new minimum. The maxHeight
             * does not have the same problem because it does not affect the textarea's scrollHeight.
             */
            this._previousMinRows = -1;
            this._textareaElement = ( /** @type {?} */(this._elementRef.nativeElement));
        }
        Object.defineProperty(CdkTextareaAutosize.prototype, "minRows", {
            /**
             * Minimum amount of rows in the textarea.
             * @return {?}
             */
            get: function () { return this._minRows; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._minRows = value;
                this._setMinHeight();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CdkTextareaAutosize.prototype, "maxRows", {
            /**
             * Maximum amount of rows in the textarea.
             * @return {?}
             */
            get: function () { return this._maxRows; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._maxRows = value;
                this._setMaxHeight();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CdkTextareaAutosize.prototype, "enabled", {
            /**
             * Whether autosizing is enabled or not
             * @return {?}
             */
            get: function () { return this._enabled; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                value = coerceBooleanProperty(value);
                // Only act if the actual value changed. This specifically helps to not run
                // resizeToFitContent too early (i.e. before ngAfterViewInit)
                if (this._enabled !== value) {
                    (this._enabled = value) ? this.resizeToFitContent(true) : this.reset();
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Sets the minimum height of the textarea as determined by minRows.
         * @return {?}
         */
        CdkTextareaAutosize.prototype._setMinHeight = function () {
            /** @type {?} */
            var minHeight = this.minRows && this._cachedLineHeight ?
                this.minRows * this._cachedLineHeight + "px" : null;
            if (minHeight) {
                this._textareaElement.style.minHeight = minHeight;
            }
        };
        /**
         * Sets the maximum height of the textarea as determined by maxRows.
         * @return {?}
         */
        CdkTextareaAutosize.prototype._setMaxHeight = function () {
            /** @type {?} */
            var maxHeight = this.maxRows && this._cachedLineHeight ?
                this.maxRows * this._cachedLineHeight + "px" : null;
            if (maxHeight) {
                this._textareaElement.style.maxHeight = maxHeight;
            }
        };
        /**
         * @return {?}
         */
        CdkTextareaAutosize.prototype.ngAfterViewInit = function () {
            var _this = this;
            if (this._platform.isBrowser) {
                // Remember the height which we started with in case autosizing is disabled
                this._initialHeight = this._textareaElement.style.height;
                this.resizeToFitContent();
                this._ngZone.runOutsideAngular(( /**
                 * @return {?}
                 */function () {
                    fromEvent(window, 'resize')
                        .pipe(auditTime(16), takeUntil(_this._destroyed))
                        .subscribe(( /**
                 * @return {?}
                 */function () { return _this.resizeToFitContent(true); }));
                }));
            }
        };
        /**
         * @return {?}
         */
        CdkTextareaAutosize.prototype.ngOnDestroy = function () {
            this._destroyed.next();
            this._destroyed.complete();
        };
        /**
         * Cache the height of a single-row textarea if it has not already been cached.
         *
         * We need to know how large a single "row" of a textarea is in order to apply minRows and
         * maxRows. For the initial version, we will assume that the height of a single line in the
         * textarea does not ever change.
         * @private
         * @return {?}
         */
        CdkTextareaAutosize.prototype._cacheTextareaLineHeight = function () {
            if (this._cachedLineHeight) {
                return;
            }
            // Use a clone element because we have to override some styles.
            /** @type {?} */
            var textareaClone = ( /** @type {?} */(this._textareaElement.cloneNode(false)));
            textareaClone.rows = 1;
            // Use `position: absolute` so that this doesn't cause a browser layout and use
            // `visibility: hidden` so that nothing is rendered. Clear any other styles that
            // would affect the height.
            textareaClone.style.position = 'absolute';
            textareaClone.style.visibility = 'hidden';
            textareaClone.style.border = 'none';
            textareaClone.style.padding = '0';
            textareaClone.style.height = '';
            textareaClone.style.minHeight = '';
            textareaClone.style.maxHeight = '';
            // In Firefox it happens that textarea elements are always bigger than the specified amount
            // of rows. This is because Firefox tries to add extra space for the horizontal scrollbar.
            // As a workaround that removes the extra space for the scrollbar, we can just set overflow
            // to hidden. This ensures that there is no invalid calculation of the line height.
            // See Firefox bug report: https://bugzilla.mozilla.org/show_bug.cgi?id=33654
            textareaClone.style.overflow = 'hidden';
            ( /** @type {?} */(this._textareaElement.parentNode)).appendChild(textareaClone);
            this._cachedLineHeight = textareaClone.clientHeight;
            ( /** @type {?} */(this._textareaElement.parentNode)).removeChild(textareaClone);
            // Min and max heights have to be re-calculated if the cached line height changes
            this._setMinHeight();
            this._setMaxHeight();
        };
        /**
         * @return {?}
         */
        CdkTextareaAutosize.prototype.ngDoCheck = function () {
            if (this._platform.isBrowser) {
                this.resizeToFitContent();
            }
        };
        /**
         * Resize the textarea to fit its content.
         * @param {?=} force Whether to force a height recalculation. By default the height will be
         *    recalculated only if the value changed since the last call.
         * @return {?}
         */
        CdkTextareaAutosize.prototype.resizeToFitContent = function (force) {
            var _this = this;
            if (force === void 0) { force = false; }
            // If autosizing is disabled, just skip everything else
            if (!this._enabled) {
                return;
            }
            this._cacheTextareaLineHeight();
            // If we haven't determined the line-height yet, we know we're still hidden and there's no point
            // in checking the height of the textarea.
            if (!this._cachedLineHeight) {
                return;
            }
            /** @type {?} */
            var textarea = ( /** @type {?} */(this._elementRef.nativeElement));
            /** @type {?} */
            var value = textarea.value;
            // Only resize if the value or minRows have changed since these calculations can be expensive.
            if (!force && this._minRows === this._previousMinRows && value === this._previousValue) {
                return;
            }
            /** @type {?} */
            var placeholderText = textarea.placeholder;
            // Reset the textarea height to auto in order to shrink back to its default size.
            // Also temporarily force overflow:hidden, so scroll bars do not interfere with calculations.
            // Long placeholders that are wider than the textarea width may lead to a bigger scrollHeight
            // value. To ensure that the scrollHeight is not bigger than the content, the placeholders
            // need to be removed temporarily.
            textarea.classList.add('cdk-textarea-autosize-measuring');
            textarea.placeholder = '';
            // The cdk-textarea-autosize-measuring class includes a 2px padding to workaround an issue with
            // Chrome, so we account for that extra space here by subtracting 4 (2px top + 2px bottom).
            /** @type {?} */
            var height = textarea.scrollHeight - 4;
            // Use the scrollHeight to know how large the textarea *would* be if fit its entire value.
            textarea.style.height = height + "px";
            textarea.classList.remove('cdk-textarea-autosize-measuring');
            textarea.placeholder = placeholderText;
            this._ngZone.runOutsideAngular(( /**
             * @return {?}
             */function () {
                if (typeof requestAnimationFrame !== 'undefined') {
                    requestAnimationFrame(( /**
                     * @return {?}
                     */function () { return _this._scrollToCaretPosition(textarea); }));
                }
                else {
                    setTimeout(( /**
                     * @return {?}
                     */function () { return _this._scrollToCaretPosition(textarea); }));
                }
            }));
            this._previousValue = value;
            this._previousMinRows = this._minRows;
        };
        /**
         * Resets the textarea to its original size
         * @return {?}
         */
        CdkTextareaAutosize.prototype.reset = function () {
            // Do not try to change the textarea, if the initialHeight has not been determined yet
            // This might potentially remove styles when reset() is called before ngAfterViewInit
            if (this._initialHeight === undefined) {
                return;
            }
            this._textareaElement.style.height = this._initialHeight;
        };
        /**
         * @return {?}
         */
        CdkTextareaAutosize.prototype._noopInputHandler = function () {
            // no-op handler that ensures we're running change detection on input events.
        };
        /**
         * Scrolls a textarea to the caret position. On Firefox resizing the textarea will
         * prevent it from scrolling to the caret position. We need to re-set the selection
         * in order for it to scroll to the proper position.
         * @private
         * @param {?} textarea
         * @return {?}
         */
        CdkTextareaAutosize.prototype._scrollToCaretPosition = function (textarea) {
            var selectionStart = textarea.selectionStart, selectionEnd = textarea.selectionEnd;
            // IE will throw an "Unspecified error" if we try to set the selection range after the
            // element has been removed from the DOM. Assert that the directive hasn't been destroyed
            // between the time we requested the animation frame and when it was executed.
            // Also note that we have to assert that the textarea is focused before we set the
            // selection range. Setting the selection range on a non-focused textarea will cause
            // it to receive focus on IE and Edge.
            if (!this._destroyed.isStopped && document.activeElement === textarea) {
                textarea.setSelectionRange(selectionStart, selectionEnd);
            }
        };
        return CdkTextareaAutosize;
    }());
    CdkTextareaAutosize.decorators = [
        { type: Directive, args: [{
                    selector: 'textarea[cdkTextareaAutosize]',
                    exportAs: 'cdkTextareaAutosize',
                    host: {
                        'class': 'cdk-textarea-autosize',
                        // Textarea elements that have the directive applied should have a single row by default.
                        // Browsers normally show two rows by default and therefore this limits the minRows binding.
                        'rows': '1',
                        '(input)': '_noopInputHandler()',
                    },
                },] },
    ];
    /** @nocollapse */
    CdkTextareaAutosize.ctorParameters = function () { return [
        { type: ElementRef },
        { type: Platform },
        { type: NgZone }
    ]; };
    CdkTextareaAutosize.propDecorators = {
        minRows: [{ type: Input, args: ['cdkAutosizeMinRows',] }],
        maxRows: [{ type: Input, args: ['cdkAutosizeMaxRows',] }],
        enabled: [{ type: Input, args: ['cdkTextareaAutosize',] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TextFieldModule = /** @class */ (function () {
        function TextFieldModule() {
        }
        return TextFieldModule;
    }());
    TextFieldModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [CdkAutofill, CdkTextareaAutosize],
                    imports: [PlatformModule],
                    exports: [CdkAutofill, CdkTextareaAutosize],
                },] },
    ];
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Directive to automatically resize a textarea to fit its content.
     * @deprecated Use `cdkTextareaAutosize` from `\@angular/cdk/text-field` instead.
     * \@breaking-change 8.0.0
     */
    var MatTextareaAutosize = /** @class */ (function (_super) {
        __extends(MatTextareaAutosize, _super);
        function MatTextareaAutosize() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(MatTextareaAutosize.prototype, "matAutosizeMinRows", {
            /**
             * @return {?}
             */
            get: function () { return this.minRows; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this.minRows = value; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatTextareaAutosize.prototype, "matAutosizeMaxRows", {
            /**
             * @return {?}
             */
            get: function () { return this.maxRows; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this.maxRows = value; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatTextareaAutosize.prototype, "matAutosize", {
            /**
             * @return {?}
             */
            get: function () { return this.enabled; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this.enabled = value; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatTextareaAutosize.prototype, "matTextareaAutosize", {
            /**
             * @return {?}
             */
            get: function () { return this.enabled; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this.enabled = value; },
            enumerable: true,
            configurable: true
        });
        return MatTextareaAutosize;
    }(CdkTextareaAutosize));
    MatTextareaAutosize.decorators = [
        { type: Directive, args: [{
                    selector: 'textarea[mat-autosize], textarea[matTextareaAutosize]',
                    exportAs: 'matTextareaAutosize',
                    inputs: ['cdkAutosizeMinRows', 'cdkAutosizeMaxRows'],
                    host: {
                        'class': 'cdk-textarea-autosize mat-autosize',
                        // Textarea elements that have the directive applied should have a single row by default.
                        // Browsers normally show two rows by default and therefore this limits the minRows binding.
                        'rows': '1',
                        '(input)': '_noopInputHandler()',
                    },
                },] },
    ];
    MatTextareaAutosize.propDecorators = {
        matAutosizeMinRows: [{ type: Input }],
        matAutosizeMaxRows: [{ type: Input }],
        matAutosize: [{ type: Input, args: ['mat-autosize',] }],
        matTextareaAutosize: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@docs-private
     * @param {?} type
     * @return {?}
     */
    function getMatInputUnsupportedTypeError(type) {
        return Error("Input type \"" + type + "\" isn't supported by matInput.");
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * This token is used to inject the object whose value should be set into `MatInput`. If none is
     * provided, the native `HTMLInputElement` is used. Directives like `MatDatepickerInput` can provide
     * themselves for this token, in order to make `MatInput` delegate the getting and setting of the
     * value to them.
     * @type {?}
     */
    var MAT_INPUT_VALUE_ACCESSOR = new InjectionToken('MAT_INPUT_VALUE_ACCESSOR');
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // Invalid input type. Using one of these will throw an MatInputUnsupportedTypeError.
    /** @type {?} */
    var MAT_INPUT_INVALID_TYPES = [
        'button',
        'checkbox',
        'file',
        'hidden',
        'image',
        'radio',
        'range',
        'reset',
        'submit'
    ];
    /** @type {?} */
    var nextUniqueId$3 = 0;
    // Boilerplate for applying mixins to MatInput.
    /**
     * \@docs-private
     */
    var MatInputBase = /** @class */ (function () {
        /**
         * @param {?} _defaultErrorStateMatcher
         * @param {?} _parentForm
         * @param {?} _parentFormGroup
         * @param {?} ngControl
         */
        function MatInputBase(_defaultErrorStateMatcher, _parentForm, _parentFormGroup, ngControl) {
            this._defaultErrorStateMatcher = _defaultErrorStateMatcher;
            this._parentForm = _parentForm;
            this._parentFormGroup = _parentFormGroup;
            this.ngControl = ngControl;
        }
        return MatInputBase;
    }());
    /** @type {?} */
    var _MatInputMixinBase = mixinErrorState(MatInputBase);
    /**
     * Directive that allows a native input to work inside a `MatFormField`.
     */
    var MatInput = /** @class */ (function (_super) {
        __extends(MatInput, _super);
        /**
         * @param {?} _elementRef
         * @param {?} _platform
         * @param {?} ngControl
         * @param {?} _parentForm
         * @param {?} _parentFormGroup
         * @param {?} _defaultErrorStateMatcher
         * @param {?} inputValueAccessor
         * @param {?} _autofillMonitor
         * @param {?} ngZone
         */
        function MatInput(_elementRef, _platform, ngControl, _parentForm, _parentFormGroup, _defaultErrorStateMatcher, inputValueAccessor, _autofillMonitor, ngZone) {
            var _this = _super.call(this, _defaultErrorStateMatcher, _parentForm, _parentFormGroup, ngControl) || this;
            _this._elementRef = _elementRef;
            _this._platform = _platform;
            _this.ngControl = ngControl;
            _this._autofillMonitor = _autofillMonitor;
            _this._uid = "mat-input-" + nextUniqueId$3++;
            /**
             * Whether the component is being rendered on the server.
             */
            _this._isServer = false;
            /**
             * Whether the component is a native html select.
             */
            _this._isNativeSelect = false;
            /**
             * Implemented as part of MatFormFieldControl.
             * \@docs-private
             */
            _this.focused = false;
            /**
             * Implemented as part of MatFormFieldControl.
             * \@docs-private
             */
            _this.stateChanges = new Subject();
            /**
             * Implemented as part of MatFormFieldControl.
             * \@docs-private
             */
            _this.controlType = 'mat-input';
            /**
             * Implemented as part of MatFormFieldControl.
             * \@docs-private
             */
            _this.autofilled = false;
            _this._disabled = false;
            _this._required = false;
            _this._type = 'text';
            _this._readonly = false;
            _this._neverEmptyInputTypes = [
                'date',
                'datetime',
                'datetime-local',
                'month',
                'time',
                'week'
            ].filter(( /**
             * @param {?} t
             * @return {?}
             */function (/**
             * @param {?} t
             * @return {?}
             */ t) { return getSupportedInputTypes().has(t); }));
            /** @type {?} */
            var element = _this._elementRef.nativeElement;
            // If no input value accessor was explicitly specified, use the element as the input value
            // accessor.
            _this._inputValueAccessor = inputValueAccessor || element;
            _this._previousNativeValue = _this.value;
            // Force setter to be called in case id was not specified.
            _this.id = _this.id;
            // On some versions of iOS the caret gets stuck in the wrong place when holding down the delete
            // key. In order to get around this we need to "jiggle" the caret loose. Since this bug only
            // exists on iOS, we only bother to install the listener on iOS.
            if (_platform.IOS) {
                ngZone.runOutsideAngular(( /**
                 * @return {?}
                 */function () {
                    _elementRef.nativeElement.addEventListener('keyup', ( /**
                     * @param {?} event
                     * @return {?}
                     */function (event) {
                        /** @type {?} */
                        var el = ( /** @type {?} */(event.target));
                        if (!el.value && !el.selectionStart && !el.selectionEnd) {
                            // Note: Just setting `0, 0` doesn't fix the issue. Setting
                            // `1, 1` fixes it for the first time that you type text and
                            // then hold delete. Toggling to `1, 1` and then back to
                            // `0, 0` seems to completely fix it.
                            el.setSelectionRange(1, 1);
                            el.setSelectionRange(0, 0);
                        }
                    }));
                }));
            }
            _this._isServer = !_this._platform.isBrowser;
            _this._isNativeSelect = element.nodeName.toLowerCase() === 'select';
            if (_this._isNativeSelect) {
                _this.controlType = (( /** @type {?} */(element))).multiple ? 'mat-native-select-multiple' :
                    'mat-native-select';
            }
            return _this;
        }
        Object.defineProperty(MatInput.prototype, "disabled", {
            /**
             * Implemented as part of MatFormFieldControl.
             * \@docs-private
             * @return {?}
             */
            get: function () {
                if (this.ngControl && this.ngControl.disabled !== null) {
                    return this.ngControl.disabled;
                }
                return this._disabled;
            },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._disabled = coerceBooleanProperty(value);
                // Browsers may not fire the blur event if the input is disabled too quickly.
                // Reset from here to ensure that the element doesn't become stuck.
                if (this.focused) {
                    this.focused = false;
                    this.stateChanges.next();
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatInput.prototype, "id", {
            /**
             * Implemented as part of MatFormFieldControl.
             * \@docs-private
             * @return {?}
             */
            get: function () { return this._id; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this._id = value || this._uid; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatInput.prototype, "required", {
            /**
             * Implemented as part of MatFormFieldControl.
             * \@docs-private
             * @return {?}
             */
            get: function () { return this._required; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this._required = coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatInput.prototype, "type", {
            /**
             * Input type of the element.
             * @return {?}
             */
            get: function () { return this._type; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._type = value || 'text';
                this._validateType();
                // When using Angular inputs, developers are no longer able to set the properties on the native
                // input element. To ensure that bindings for `type` work, we need to sync the setter
                // with the native property. Textarea elements don't support the type property or attribute.
                if (!this._isTextarea() && getSupportedInputTypes().has(this._type)) {
                    (( /** @type {?} */(this._elementRef.nativeElement))).type = this._type;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatInput.prototype, "value", {
            /**
             * Implemented as part of MatFormFieldControl.
             * \@docs-private
             * @return {?}
             */
            get: function () { return this._inputValueAccessor.value; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                if (value !== this.value) {
                    this._inputValueAccessor.value = value;
                    this.stateChanges.next();
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatInput.prototype, "readonly", {
            /**
             * Whether the element is readonly.
             * @return {?}
             */
            get: function () { return this._readonly; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this._readonly = coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        MatInput.prototype.ngOnInit = function () {
            var _this = this;
            if (this._platform.isBrowser) {
                this._autofillMonitor.monitor(this._elementRef.nativeElement).subscribe(( /**
                 * @param {?} event
                 * @return {?}
                 */function (/**
                 * @param {?} event
                 * @return {?}
                 */ event) {
                    _this.autofilled = event.isAutofilled;
                    _this.stateChanges.next();
                }));
            }
        };
        /**
         * @return {?}
         */
        MatInput.prototype.ngOnChanges = function () {
            this.stateChanges.next();
        };
        /**
         * @return {?}
         */
        MatInput.prototype.ngOnDestroy = function () {
            this.stateChanges.complete();
            if (this._platform.isBrowser) {
                this._autofillMonitor.stopMonitoring(this._elementRef.nativeElement);
            }
        };
        /**
         * @return {?}
         */
        MatInput.prototype.ngDoCheck = function () {
            if (this.ngControl) {
                // We need to re-evaluate this on every change detection cycle, because there are some
                // error triggers that we can't subscribe to (e.g. parent form submissions). This means
                // that whatever logic is in here has to be super lean or we risk destroying the performance.
                this.updateErrorState();
            }
            // We need to dirty-check the native element's value, because there are some cases where
            // we won't be notified when it changes (e.g. the consumer isn't using forms or they're
            // updating the value using `emitEvent: false`).
            this._dirtyCheckNativeValue();
        };
        /**
         * Focuses the input.
         * @param {?=} options
         * @return {?}
         */
        MatInput.prototype.focus = function (options) {
            this._elementRef.nativeElement.focus(options);
        };
        /**
         * Callback for the cases where the focused state of the input changes.
         * @param {?} isFocused
         * @return {?}
         */
        MatInput.prototype._focusChanged = function (isFocused) {
            if (isFocused !== this.focused && (!this.readonly || !isFocused)) {
                this.focused = isFocused;
                this.stateChanges.next();
            }
        };
        /**
         * @return {?}
         */
        MatInput.prototype._onInput = function () {
            // This is a noop function and is used to let Angular know whenever the value changes.
            // Angular will run a new change detection each time the `input` event has been dispatched.
            // It's necessary that Angular recognizes the value change, because when floatingLabel
            // is set to false and Angular forms aren't used, the placeholder won't recognize the
            // value changes and will not disappear.
            // Listening to the input event wouldn't be necessary when the input is using the
            // FormsModule or ReactiveFormsModule, because Angular forms also listens to input events.
        };
        /**
         * Does some manual dirty checking on the native input `value` property.
         * @protected
         * @return {?}
         */
        MatInput.prototype._dirtyCheckNativeValue = function () {
            /** @type {?} */
            var newValue = this._elementRef.nativeElement.value;
            if (this._previousNativeValue !== newValue) {
                this._previousNativeValue = newValue;
                this.stateChanges.next();
            }
        };
        /**
         * Make sure the input is a supported type.
         * @protected
         * @return {?}
         */
        MatInput.prototype._validateType = function () {
            if (MAT_INPUT_INVALID_TYPES.indexOf(this._type) > -1) {
                throw getMatInputUnsupportedTypeError(this._type);
            }
        };
        /**
         * Checks whether the input type is one of the types that are never empty.
         * @protected
         * @return {?}
         */
        MatInput.prototype._isNeverEmpty = function () {
            return this._neverEmptyInputTypes.indexOf(this._type) > -1;
        };
        /**
         * Checks whether the input is invalid based on the native validation.
         * @protected
         * @return {?}
         */
        MatInput.prototype._isBadInput = function () {
            // The `validity` property won't be present on platform-server.
            /** @type {?} */
            var validity = (( /** @type {?} */(this._elementRef.nativeElement))).validity;
            return validity && validity.badInput;
        };
        /**
         * Determines if the component host is a textarea.
         * @protected
         * @return {?}
         */
        MatInput.prototype._isTextarea = function () {
            return this._elementRef.nativeElement.nodeName.toLowerCase() === 'textarea';
        };
        Object.defineProperty(MatInput.prototype, "empty", {
            /**
             * Implemented as part of MatFormFieldControl.
             * \@docs-private
             * @return {?}
             */
            get: function () {
                return !this._isNeverEmpty() && !this._elementRef.nativeElement.value && !this._isBadInput() &&
                    !this.autofilled;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatInput.prototype, "shouldLabelFloat", {
            /**
             * Implemented as part of MatFormFieldControl.
             * \@docs-private
             * @return {?}
             */
            get: function () {
                if (this._isNativeSelect) {
                    // For a single-selection `<select>`, the label should float when the selected option has
                    // a non-empty display value. For a `<select multiple>`, the label *always* floats to avoid
                    // overlapping the label with the options.
                    /** @type {?} */
                    var selectElement = ( /** @type {?} */(this._elementRef.nativeElement));
                    /** @type {?} */
                    var firstOption = selectElement.options[0];
                    // On most browsers the `selectedIndex` will always be 0, however on IE and Edge it'll be
                    // -1 if the `value` is set to something, that isn't in the list of options, at a later point.
                    return this.focused || selectElement.multiple || !this.empty ||
                        !!(selectElement.selectedIndex > -1 && firstOption && firstOption.label);
                }
                else {
                    return this.focused || !this.empty;
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Implemented as part of MatFormFieldControl.
         * \@docs-private
         * @param {?} ids
         * @return {?}
         */
        MatInput.prototype.setDescribedByIds = function (ids) {
            this._ariaDescribedby = ids.join(' ');
        };
        /**
         * Implemented as part of MatFormFieldControl.
         * \@docs-private
         * @return {?}
         */
        MatInput.prototype.onContainerClick = function () {
            // Do not re-focus the input element if the element is already focused. Otherwise it can happen
            // that someone clicks on a time input and the cursor resets to the "hours" field while the
            // "minutes" field was actually clicked. See: https://github.com/angular/components/issues/12849
            if (!this.focused) {
                this.focus();
            }
        };
        return MatInput;
    }(_MatInputMixinBase));
    MatInput.decorators = [
        { type: Directive, args: [{
                    selector: "input[matInput], textarea[matInput], select[matNativeControl],\n      input[matNativeControl], textarea[matNativeControl]",
                    exportAs: 'matInput',
                    host: {
                        /**
                         * \@breaking-change 8.0.0 remove .mat-form-field-autofill-control in favor of AutofillMonitor.
                         */
                        'class': 'mat-input-element mat-form-field-autofill-control',
                        '[class.mat-input-server]': '_isServer',
                        // Native input properties that are overwritten by Angular inputs need to be synced with
                        // the native input element. Otherwise property bindings for those don't work.
                        '[attr.id]': 'id',
                        '[attr.placeholder]': 'placeholder',
                        '[disabled]': 'disabled',
                        '[required]': 'required',
                        '[attr.readonly]': 'readonly && !_isNativeSelect || null',
                        '[attr.aria-describedby]': '_ariaDescribedby || null',
                        '[attr.aria-invalid]': 'errorState',
                        '[attr.aria-required]': 'required.toString()',
                        '(blur)': '_focusChanged(false)',
                        '(focus)': '_focusChanged(true)',
                        '(input)': '_onInput()',
                    },
                    providers: [{ provide: MatFormFieldControl, useExisting: MatInput }],
                },] },
    ];
    /** @nocollapse */
    MatInput.ctorParameters = function () { return [
        { type: ElementRef },
        { type: Platform },
        { type: NgControl, decorators: [{ type: Optional }, { type: Self }] },
        { type: NgForm, decorators: [{ type: Optional }] },
        { type: FormGroupDirective, decorators: [{ type: Optional }] },
        { type: ErrorStateMatcher },
        { type: undefined, decorators: [{ type: Optional }, { type: Self }, { type: Inject, args: [MAT_INPUT_VALUE_ACCESSOR,] }] },
        { type: AutofillMonitor },
        { type: NgZone }
    ]; };
    MatInput.propDecorators = {
        disabled: [{ type: Input }],
        id: [{ type: Input }],
        placeholder: [{ type: Input }],
        required: [{ type: Input }],
        type: [{ type: Input }],
        errorStateMatcher: [{ type: Input }],
        value: [{ type: Input }],
        readonly: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatInputModule = /** @class */ (function () {
        function MatInputModule() {
        }
        return MatInputModule;
    }());
    MatInputModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [MatInput, MatTextareaAutosize],
                    imports: [
                        CommonModule,
                        TextFieldModule,
                        MatFormFieldModule,
                    ],
                    exports: [
                        TextFieldModule,
                        // We re-export the `MatFormFieldModule` since `MatInput` will almost always
                        // be used together with `MatFormField`.
                        MatFormFieldModule,
                        MatInput,
                        MatTextareaAutosize,
                    ],
                    providers: [ErrorStateMatcher],
                },] },
    ];
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var MAT_RADIO_DEFAULT_OPTIONS = new InjectionToken('mat-radio-default-options', {
        providedIn: 'root',
        factory: MAT_RADIO_DEFAULT_OPTIONS_FACTORY
    });
    /**
     * @return {?}
     */
    function MAT_RADIO_DEFAULT_OPTIONS_FACTORY() {
        return {
            color: 'accent'
        };
    }
    // Increasing integer for generating unique ids for radio components.
    /** @type {?} */
    var nextUniqueId$4 = 0;
    /**
     * Provider Expression that allows mat-radio-group to register as a ControlValueAccessor. This
     * allows it to support [(ngModel)] and ngControl.
     * \@docs-private
     * @type {?}
     */
    var MAT_RADIO_GROUP_CONTROL_VALUE_ACCESSOR = {
        provide: NG_VALUE_ACCESSOR,
        useExisting: forwardRef(( /**
         * @return {?}
         */function () { return MatRadioGroup; })),
        multi: true
    };
    /**
     * Change event object emitted by MatRadio and MatRadioGroup.
     */
    var MatRadioChange = /** @class */ (function () {
        /**
         * @param {?} source
         * @param {?} value
         */
        function MatRadioChange(source, value) {
            this.source = source;
            this.value = value;
        }
        return MatRadioChange;
    }());
    /**
     * A group of radio buttons. May contain one or more `<mat-radio-button>` elements.
     */
    var MatRadioGroup = /** @class */ (function () {
        /**
         * @param {?} _changeDetector
         */
        function MatRadioGroup(_changeDetector) {
            this._changeDetector = _changeDetector;
            /**
             * Selected value for the radio group.
             */
            this._value = null;
            /**
             * The HTML name attribute applied to radio buttons in this group.
             */
            this._name = "mat-radio-group-" + nextUniqueId$4++;
            /**
             * The currently selected radio button. Should match value.
             */
            this._selected = null;
            /**
             * Whether the `value` has been set to its initial value.
             */
            this._isInitialized = false;
            /**
             * Whether the labels should appear after or before the radio-buttons. Defaults to 'after'
             */
            this._labelPosition = 'after';
            /**
             * Whether the radio group is disabled.
             */
            this._disabled = false;
            /**
             * Whether the radio group is required.
             */
            this._required = false;
            /**
             * The method to be called in order to update ngModel
             */
            this._controlValueAccessorChangeFn = ( /**
             * @return {?}
             */function () { });
            /**
             * onTouch function registered via registerOnTouch (ControlValueAccessor).
             * \@docs-private
             */
            this.onTouched = ( /**
             * @return {?}
             */function () { });
            /**
             * Event emitted when the group value changes.
             * Change events are only emitted when the value changes due to user interaction with
             * a radio button (the same behavior as `<input type-"radio">`).
             */
            this.change = new EventEmitter();
        }
        Object.defineProperty(MatRadioGroup.prototype, "name", {
            /**
             * Name of the radio button group. All radio buttons inside this group will use this name.
             * @return {?}
             */
            get: function () { return this._name; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._name = value;
                this._updateRadioButtonNames();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatRadioGroup.prototype, "labelPosition", {
            /**
             * Whether the labels should appear after or before the radio-buttons. Defaults to 'after'
             * @return {?}
             */
            get: function () {
                return this._labelPosition;
            },
            /**
             * @param {?} v
             * @return {?}
             */
            set: function (v) {
                this._labelPosition = v === 'before' ? 'before' : 'after';
                this._markRadiosForCheck();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatRadioGroup.prototype, "value", {
            /**
             * Value for the radio-group. Should equal the value of the selected radio button if there is
             * a corresponding radio button with a matching value. If there is not such a corresponding
             * radio button, this value persists to be applied in case a new radio button is added with a
             * matching value.
             * @return {?}
             */
            get: function () { return this._value; },
            /**
             * @param {?} newValue
             * @return {?}
             */
            set: function (newValue) {
                if (this._value !== newValue) {
                    // Set this before proceeding to ensure no circular loop occurs with selection.
                    this._value = newValue;
                    this._updateSelectedRadioFromValue();
                    this._checkSelectedRadioButton();
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        MatRadioGroup.prototype._checkSelectedRadioButton = function () {
            if (this._selected && !this._selected.checked) {
                this._selected.checked = true;
            }
        };
        Object.defineProperty(MatRadioGroup.prototype, "selected", {
            /**
             * The currently selected radio button. If set to a new radio button, the radio group value
             * will be updated to match the new selected button.
             * @return {?}
             */
            get: function () { return this._selected; },
            /**
             * @param {?} selected
             * @return {?}
             */
            set: function (selected) {
                this._selected = selected;
                this.value = selected ? selected.value : null;
                this._checkSelectedRadioButton();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatRadioGroup.prototype, "disabled", {
            /**
             * Whether the radio group is disabled
             * @return {?}
             */
            get: function () { return this._disabled; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._disabled = coerceBooleanProperty(value);
                this._markRadiosForCheck();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatRadioGroup.prototype, "required", {
            /**
             * Whether the radio group is required
             * @return {?}
             */
            get: function () { return this._required; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._required = coerceBooleanProperty(value);
                this._markRadiosForCheck();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Initialize properties once content children are available.
         * This allows us to propagate relevant attributes to associated buttons.
         * @return {?}
         */
        MatRadioGroup.prototype.ngAfterContentInit = function () {
            // Mark this component as initialized in AfterContentInit because the initial value can
            // possibly be set by NgModel on MatRadioGroup, and it is possible that the OnInit of the
            // NgModel occurs *after* the OnInit of the MatRadioGroup.
            this._isInitialized = true;
        };
        /**
         * Mark this group as being "touched" (for ngModel). Meant to be called by the contained
         * radio buttons upon their blur.
         * @return {?}
         */
        MatRadioGroup.prototype._touch = function () {
            if (this.onTouched) {
                this.onTouched();
            }
        };
        /**
         * @private
         * @return {?}
         */
        MatRadioGroup.prototype._updateRadioButtonNames = function () {
            var _this = this;
            if (this._radios) {
                this._radios.forEach(( /**
                 * @param {?} radio
                 * @return {?}
                 */function (/**
                 * @param {?} radio
                 * @return {?}
                 */ radio) {
                    radio.name = _this.name;
                    radio._markForCheck();
                }));
            }
        };
        /**
         * Updates the `selected` radio button from the internal _value state.
         * @private
         * @return {?}
         */
        MatRadioGroup.prototype._updateSelectedRadioFromValue = function () {
            var _this = this;
            // If the value already matches the selected radio, do nothing.
            /** @type {?} */
            var isAlreadySelected = this._selected !== null && this._selected.value === this._value;
            if (this._radios && !isAlreadySelected) {
                this._selected = null;
                this._radios.forEach(( /**
                 * @param {?} radio
                 * @return {?}
                 */function (/**
                 * @param {?} radio
                 * @return {?}
                 */ radio) {
                    radio.checked = _this.value === radio.value;
                    if (radio.checked) {
                        _this._selected = radio;
                    }
                }));
            }
        };
        /**
         * Dispatch change event with current selection and group value.
         * @return {?}
         */
        MatRadioGroup.prototype._emitChangeEvent = function () {
            if (this._isInitialized) {
                this.change.emit(new MatRadioChange(( /** @type {?} */(this._selected)), this._value));
            }
        };
        /**
         * @return {?}
         */
        MatRadioGroup.prototype._markRadiosForCheck = function () {
            if (this._radios) {
                this._radios.forEach(( /**
                 * @param {?} radio
                 * @return {?}
                 */function (/**
                 * @param {?} radio
                 * @return {?}
                 */ radio) { return radio._markForCheck(); }));
            }
        };
        /**
         * Sets the model value. Implemented as part of ControlValueAccessor.
         * @param {?} value
         * @return {?}
         */
        MatRadioGroup.prototype.writeValue = function (value) {
            this.value = value;
            this._changeDetector.markForCheck();
        };
        /**
         * Registers a callback to be triggered when the model value changes.
         * Implemented as part of ControlValueAccessor.
         * @param {?} fn Callback to be registered.
         * @return {?}
         */
        MatRadioGroup.prototype.registerOnChange = function (fn) {
            this._controlValueAccessorChangeFn = fn;
        };
        /**
         * Registers a callback to be triggered when the control is touched.
         * Implemented as part of ControlValueAccessor.
         * @param {?} fn Callback to be registered.
         * @return {?}
         */
        MatRadioGroup.prototype.registerOnTouched = function (fn) {
            this.onTouched = fn;
        };
        /**
         * Sets the disabled state of the control. Implemented as a part of ControlValueAccessor.
         * @param {?} isDisabled Whether the control should be disabled.
         * @return {?}
         */
        MatRadioGroup.prototype.setDisabledState = function (isDisabled) {
            this.disabled = isDisabled;
            this._changeDetector.markForCheck();
        };
        return MatRadioGroup;
    }());
    MatRadioGroup.decorators = [
        { type: Directive, args: [{
                    selector: 'mat-radio-group',
                    exportAs: 'matRadioGroup',
                    providers: [MAT_RADIO_GROUP_CONTROL_VALUE_ACCESSOR],
                    host: {
                        'role': 'radiogroup',
                        'class': 'mat-radio-group',
                    },
                },] },
    ];
    /** @nocollapse */
    MatRadioGroup.ctorParameters = function () { return [
        { type: ChangeDetectorRef }
    ]; };
    MatRadioGroup.propDecorators = {
        change: [{ type: Output }],
        _radios: [{ type: ContentChildren, args: [forwardRef(( /**
                                 * @return {?}
                                 */function () { return MatRadioButton; })), { descendants: true },] }],
        color: [{ type: Input }],
        name: [{ type: Input }],
        labelPosition: [{ type: Input }],
        value: [{ type: Input }],
        selected: [{ type: Input }],
        disabled: [{ type: Input }],
        required: [{ type: Input }]
    };
    // Boilerplate for applying mixins to MatRadioButton.
    /**
     * \@docs-private
     */
    var MatRadioButtonBase = /** @class */ (function () {
        /**
         * @param {?} _elementRef
         */
        function MatRadioButtonBase(_elementRef) {
            this._elementRef = _elementRef;
        }
        return MatRadioButtonBase;
    }());
    // As per Material design specifications the selection control radio should use the accent color
    // palette by default. https://material.io/guidelines/components/selection-controls.html
    /** @type {?} */
    var _MatRadioButtonMixinBase = mixinDisableRipple(mixinTabIndex(MatRadioButtonBase));
    /**
     * A Material design radio-button. Typically placed inside of `<mat-radio-group>` elements.
     */
    var MatRadioButton = /** @class */ (function (_super) {
        __extends(MatRadioButton, _super);
        /**
         * @param {?} radioGroup
         * @param {?} elementRef
         * @param {?} _changeDetector
         * @param {?} _focusMonitor
         * @param {?} _radioDispatcher
         * @param {?=} _animationMode
         * @param {?=} _providerOverride
         */
        function MatRadioButton(radioGroup, elementRef, _changeDetector, _focusMonitor, _radioDispatcher, _animationMode, _providerOverride) {
            var _this = _super.call(this, elementRef) || this;
            _this._changeDetector = _changeDetector;
            _this._focusMonitor = _focusMonitor;
            _this._radioDispatcher = _radioDispatcher;
            _this._animationMode = _animationMode;
            _this._providerOverride = _providerOverride;
            _this._uniqueId = "mat-radio-" + ++nextUniqueId$4;
            /**
             * The unique ID for the radio button.
             */
            _this.id = _this._uniqueId;
            /**
             * Event emitted when the checked state of this radio button changes.
             * Change events are only emitted when the value changes due to user interaction with
             * the radio button (the same behavior as `<input type-"radio">`).
             */
            _this.change = new EventEmitter();
            /**
             * Whether this radio is checked.
             */
            _this._checked = false;
            /**
             * Value assigned to this radio.
             */
            _this._value = null;
            /**
             * Unregister function for _radioDispatcher
             */
            _this._removeUniqueSelectionListener = ( /**
             * @return {?}
             */function () { });
            // Assertions. Ideally these should be stripped out by the compiler.
            // TODO(jelbourn): Assert that there's no name binding AND a parent radio group.
            _this.radioGroup = radioGroup;
            _this._removeUniqueSelectionListener =
                _radioDispatcher.listen(( /**
                 * @param {?} id
                 * @param {?} name
                 * @return {?}
                 */function (id, name) {
                    if (id !== _this.id && name === _this.name) {
                        _this.checked = false;
                    }
                }));
            return _this;
        }
        Object.defineProperty(MatRadioButton.prototype, "checked", {
            /**
             * Whether this radio button is checked.
             * @return {?}
             */
            get: function () { return this._checked; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                /** @type {?} */
                var newCheckedState = coerceBooleanProperty(value);
                if (this._checked !== newCheckedState) {
                    this._checked = newCheckedState;
                    if (newCheckedState && this.radioGroup && this.radioGroup.value !== this.value) {
                        this.radioGroup.selected = this;
                    }
                    else if (!newCheckedState && this.radioGroup && this.radioGroup.value === this.value) {
                        // When unchecking the selected radio button, update the selected radio
                        // property on the group.
                        this.radioGroup.selected = null;
                    }
                    if (newCheckedState) {
                        // Notify all radio buttons with the same name to un-check.
                        this._radioDispatcher.notify(this.id, this.name);
                    }
                    this._changeDetector.markForCheck();
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatRadioButton.prototype, "value", {
            /**
             * The value of this radio button.
             * @return {?}
             */
            get: function () { return this._value; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                if (this._value !== value) {
                    this._value = value;
                    if (this.radioGroup !== null) {
                        if (!this.checked) {
                            // Update checked when the value changed to match the radio group's value
                            this.checked = this.radioGroup.value === value;
                        }
                        if (this.checked) {
                            this.radioGroup.selected = this;
                        }
                    }
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatRadioButton.prototype, "labelPosition", {
            /**
             * Whether the label should appear after or before the radio button. Defaults to 'after'
             * @return {?}
             */
            get: function () {
                return this._labelPosition || (this.radioGroup && this.radioGroup.labelPosition) || 'after';
            },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._labelPosition = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatRadioButton.prototype, "disabled", {
            /**
             * Whether the radio button is disabled.
             * @return {?}
             */
            get: function () {
                return this._disabled || (this.radioGroup !== null && this.radioGroup.disabled);
            },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                /** @type {?} */
                var newDisabledState = coerceBooleanProperty(value);
                if (this._disabled !== newDisabledState) {
                    this._disabled = newDisabledState;
                    this._changeDetector.markForCheck();
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatRadioButton.prototype, "required", {
            /**
             * Whether the radio button is required.
             * @return {?}
             */
            get: function () {
                return this._required || (this.radioGroup && this.radioGroup.required);
            },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._required = coerceBooleanProperty(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatRadioButton.prototype, "color", {
            /**
             * Theme color of the radio button.
             * @return {?}
             */
            get: function () {
                return this._color ||
                    (this.radioGroup && this.radioGroup.color) ||
                    this._providerOverride && this._providerOverride.color || 'accent';
            },
            /**
             * @param {?} newValue
             * @return {?}
             */
            set: function (newValue) { this._color = newValue; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatRadioButton.prototype, "inputId", {
            /**
             * ID of the native input element inside `<mat-radio-button>`
             * @return {?}
             */
            get: function () { return (this.id || this._uniqueId) + "-input"; },
            enumerable: true,
            configurable: true
        });
        /**
         * Focuses the radio button.
         * @param {?=} options
         * @return {?}
         */
        MatRadioButton.prototype.focus = function (options) {
            this._focusMonitor.focusVia(this._inputElement, 'keyboard', options);
        };
        /**
         * Marks the radio button as needing checking for change detection.
         * This method is exposed because the parent radio group will directly
         * update bound properties of the radio button.
         * @return {?}
         */
        MatRadioButton.prototype._markForCheck = function () {
            // When group value changes, the button will not be notified. Use `markForCheck` to explicit
            // update radio button's status
            this._changeDetector.markForCheck();
        };
        /**
         * @return {?}
         */
        MatRadioButton.prototype.ngOnInit = function () {
            if (this.radioGroup) {
                // If the radio is inside a radio group, determine if it should be checked
                this.checked = this.radioGroup.value === this._value;
                // Copy name from parent radio group
                this.name = this.radioGroup.name;
            }
        };
        /**
         * @return {?}
         */
        MatRadioButton.prototype.ngAfterViewInit = function () {
            var _this = this;
            this._focusMonitor
                .monitor(this._elementRef, true)
                .subscribe(( /**
         * @param {?} focusOrigin
         * @return {?}
         */function (/**
         * @param {?} focusOrigin
         * @return {?}
         */ focusOrigin) {
                if (!focusOrigin && _this.radioGroup) {
                    _this.radioGroup._touch();
                }
            }));
        };
        /**
         * @return {?}
         */
        MatRadioButton.prototype.ngOnDestroy = function () {
            this._focusMonitor.stopMonitoring(this._elementRef);
            this._removeUniqueSelectionListener();
        };
        /**
         * Dispatch change event with current value.
         * @private
         * @return {?}
         */
        MatRadioButton.prototype._emitChangeEvent = function () {
            this.change.emit(new MatRadioChange(this, this._value));
        };
        /**
         * @return {?}
         */
        MatRadioButton.prototype._isRippleDisabled = function () {
            return this.disableRipple || this.disabled;
        };
        /**
         * @param {?} event
         * @return {?}
         */
        MatRadioButton.prototype._onInputClick = function (event) {
            // We have to stop propagation for click events on the visual hidden input element.
            // By default, when a user clicks on a label element, a generated click event will be
            // dispatched on the associated input element. Since we are using a label element as our
            // root container, the click event on the `radio-button` will be executed twice.
            // The real click event will bubble up, and the generated click event also tries to bubble up.
            // This will lead to multiple click events.
            // Preventing bubbling for the second event will solve that issue.
            event.stopPropagation();
        };
        /**
         * Triggered when the radio button received a click or the input recognized any change.
         * Clicking on a label element, will trigger a change event on the associated input.
         * @param {?} event
         * @return {?}
         */
        MatRadioButton.prototype._onInputChange = function (event) {
            // We always have to stop propagation on the change event.
            // Otherwise the change event, from the input element, will bubble up and
            // emit its event object to the `change` output.
            event.stopPropagation();
            /** @type {?} */
            var groupValueChanged = this.radioGroup && this.value !== this.radioGroup.value;
            this.checked = true;
            this._emitChangeEvent();
            if (this.radioGroup) {
                this.radioGroup._controlValueAccessorChangeFn(this.value);
                if (groupValueChanged) {
                    this.radioGroup._emitChangeEvent();
                }
            }
        };
        return MatRadioButton;
    }(_MatRadioButtonMixinBase));
    MatRadioButton.decorators = [
        { type: Component, args: [{ selector: 'mat-radio-button',
                    template: "<label [attr.for]=\"inputId\" class=\"mat-radio-label\" #label><div class=\"mat-radio-container\"><div class=\"mat-radio-outer-circle\"></div><div class=\"mat-radio-inner-circle\"></div><div mat-ripple class=\"mat-radio-ripple\" [matRippleTrigger]=\"label\" [matRippleDisabled]=\"_isRippleDisabled()\" [matRippleCentered]=\"true\" [matRippleRadius]=\"20\" [matRippleAnimation]=\"{enterDuration: 150}\"><div class=\"mat-ripple-element mat-radio-persistent-ripple\"></div></div><input #input class=\"mat-radio-input cdk-visually-hidden\" type=\"radio\" [id]=\"inputId\" [checked]=\"checked\" [disabled]=\"disabled\" [tabIndex]=\"tabIndex\" [attr.name]=\"name\" [attr.value]=\"value\" [required]=\"required\" [attr.aria-label]=\"ariaLabel\" [attr.aria-labelledby]=\"ariaLabelledby\" [attr.aria-describedby]=\"ariaDescribedby\" (change)=\"_onInputChange($event)\" (click)=\"_onInputClick($event)\"></div><div class=\"mat-radio-label-content\" [class.mat-radio-label-before]=\"labelPosition == 'before'\"><span style=\"display:none\">&nbsp;</span><ng-content></ng-content></div></label>",
                    styles: [".mat-radio-button{display:inline-block;-webkit-tap-highlight-color:transparent;outline:0}.mat-radio-label{-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:pointer;display:inline-flex;align-items:center;white-space:nowrap;vertical-align:middle;width:100%}.mat-radio-container{box-sizing:border-box;display:inline-block;position:relative;width:20px;height:20px;flex-shrink:0}.mat-radio-outer-circle{box-sizing:border-box;height:20px;left:0;position:absolute;top:0;transition:border-color ease 280ms;width:20px;border-width:2px;border-style:solid;border-radius:50%}._mat-animation-noopable .mat-radio-outer-circle{transition:none}.mat-radio-inner-circle{border-radius:50%;box-sizing:border-box;height:20px;left:0;position:absolute;top:0;transition:transform ease 280ms,background-color ease 280ms;width:20px;transform:scale(.001)}._mat-animation-noopable .mat-radio-inner-circle{transition:none}.mat-radio-checked .mat-radio-inner-circle{transform:scale(.5)}@media (-ms-high-contrast:active){.mat-radio-checked .mat-radio-inner-circle{border:solid 10px}}.mat-radio-label-content{-webkit-user-select:auto;-moz-user-select:auto;-ms-user-select:auto;user-select:auto;display:inline-block;order:0;line-height:inherit;padding-left:8px;padding-right:0}[dir=rtl] .mat-radio-label-content{padding-right:8px;padding-left:0}.mat-radio-label-content.mat-radio-label-before{order:-1;padding-left:0;padding-right:8px}[dir=rtl] .mat-radio-label-content.mat-radio-label-before{padding-right:0;padding-left:8px}.mat-radio-disabled,.mat-radio-disabled .mat-radio-label{cursor:default}.mat-radio-button .mat-radio-ripple{position:absolute;left:calc(50% - 20px);top:calc(50% - 20px);height:40px;width:40px;z-index:1;pointer-events:none}.mat-radio-button .mat-radio-ripple .mat-ripple-element:not(.mat-radio-persistent-ripple){opacity:.16}.mat-radio-persistent-ripple{width:100%;height:100%;transform:none}.mat-radio-container:hover .mat-radio-persistent-ripple{opacity:.04}.mat-radio-button:not(.mat-radio-disabled).cdk-keyboard-focused .mat-radio-persistent-ripple,.mat-radio-button:not(.mat-radio-disabled).cdk-program-focused .mat-radio-persistent-ripple{opacity:.12}.mat-radio-disabled .mat-radio-container:hover .mat-radio-persistent-ripple,.mat-radio-persistent-ripple{opacity:0}@media (hover:none){.mat-radio-container:hover .mat-radio-persistent-ripple{display:none}}.mat-radio-input{bottom:0;left:50%}@media (-ms-high-contrast:active){.mat-radio-disabled{opacity:.5}}"],
                    inputs: ['disableRipple', 'tabIndex'],
                    encapsulation: ViewEncapsulation.None,
                    exportAs: 'matRadioButton',
                    host: {
                        'class': 'mat-radio-button',
                        '[class.mat-radio-checked]': 'checked',
                        '[class.mat-radio-disabled]': 'disabled',
                        '[class._mat-animation-noopable]': '_animationMode === "NoopAnimations"',
                        '[class.mat-primary]': 'color === "primary"',
                        '[class.mat-accent]': 'color === "accent"',
                        '[class.mat-warn]': 'color === "warn"',
                        // Needs to be -1 so the `focus` event still fires.
                        '[attr.tabindex]': '-1',
                        '[attr.id]': 'id',
                        '[attr.aria-label]': 'null',
                        '[attr.aria-labelledby]': 'null',
                        '[attr.aria-describedby]': 'null',
                        // Note: under normal conditions focus shouldn't land on this element, however it may be
                        // programmatically set, for example inside of a focus trap, in this case we want to forward
                        // the focus to the native element.
                        '(focus)': '_inputElement.nativeElement.focus()',
                    },
                    changeDetection: ChangeDetectionStrategy.OnPush,
                },] },
    ];
    /** @nocollapse */
    MatRadioButton.ctorParameters = function () { return [
        { type: MatRadioGroup, decorators: [{ type: Optional }] },
        { type: ElementRef },
        { type: ChangeDetectorRef },
        { type: FocusMonitor },
        { type: UniqueSelectionDispatcher },
        { type: String, decorators: [{ type: Optional }, { type: Inject, args: [ANIMATION_MODULE_TYPE,] }] },
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [MAT_RADIO_DEFAULT_OPTIONS,] }] }
    ]; };
    MatRadioButton.propDecorators = {
        id: [{ type: Input }],
        name: [{ type: Input }],
        ariaLabel: [{ type: Input, args: ['aria-label',] }],
        ariaLabelledby: [{ type: Input, args: ['aria-labelledby',] }],
        ariaDescribedby: [{ type: Input, args: ['aria-describedby',] }],
        checked: [{ type: Input }],
        value: [{ type: Input }],
        labelPosition: [{ type: Input }],
        disabled: [{ type: Input }],
        required: [{ type: Input }],
        color: [{ type: Input }],
        change: [{ type: Output }],
        _inputElement: [{ type: ViewChild, args: ['input', { static: false },] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatRadioModule = /** @class */ (function () {
        function MatRadioModule() {
        }
        return MatRadioModule;
    }());
    MatRadioModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule, MatRippleModule, MatCommonModule],
                    exports: [MatRadioGroup, MatRadioButton, MatCommonModule],
                    declarations: [MatRadioGroup, MatRadioButton],
                },] },
    ];
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The following are all the animations for the mat-select component, with each
     * const containing the metadata for one animation.
     *
     * The values below match the implementation of the AngularJS Material mat-select animation.
     * \@docs-private
     * @type {?}
     */
    var matSelectAnimations = {
        /**
         * This animation ensures the select's overlay panel animation (transformPanel) is called when
         * closing the select.
         * This is needed due to https://github.com/angular/angular/issues/23302
         */
        transformPanelWrap: trigger('transformPanelWrap', [
            transition('* => void', query('@transformPanel', [animateChild()], { optional: true }))
        ]),
        /**
         * This animation transforms the select's overlay panel on and off the page.
         *
         * When the panel is attached to the DOM, it expands its width by the amount of padding, scales it
         * up to 100% on the Y axis, fades in its border, and translates slightly up and to the
         * side to ensure the option text correctly overlaps the trigger text.
         *
         * When the panel is removed from the DOM, it simply fades out linearly.
         */
        transformPanel: trigger('transformPanel', [
            state('void', style({
                transform: 'scaleY(0.8)',
                minWidth: '100%',
                opacity: 0
            })),
            state('showing', style({
                opacity: 1,
                minWidth: 'calc(100% + 32px)',
                // 32px = 2 * 16px padding
                transform: 'scaleY(1)'
            })),
            state('showing-multiple', style({
                opacity: 1,
                minWidth: 'calc(100% + 64px)',
                // 64px = 48px padding on the left + 16px padding on the right
                transform: 'scaleY(1)'
            })),
            transition('void => *', animate('120ms cubic-bezier(0, 0, 0.2, 1)')),
            transition('* => void', animate('100ms 25ms linear', style({ opacity: 0 })))
        ]),
        /**
         * This animation fades in the background color and text content of the
         * select's options. It is time delayed to occur 100ms after the overlay
         * panel has transformed in.
         * @deprecated Not used anymore. To be removed.
         * \@breaking-change 8.0.0
         */
        fadeInContent: trigger('fadeInContent', [
            state('showing', style({ opacity: 1 })),
            transition('void => showing', [
                style({ opacity: 0 }),
                animate('150ms 100ms cubic-bezier(0.55, 0, 0.55, 0.2)')
            ])
        ])
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Returns an exception to be thrown when attempting to change a select's `multiple` option
     * after initialization.
     * \@docs-private
     * @return {?}
     */
    function getMatSelectDynamicMultipleError() {
        return Error('Cannot change `multiple` mode of select after initialization.');
    }
    /**
     * Returns an exception to be thrown when attempting to assign a non-array value to a select
     * in `multiple` mode. Note that `undefined` and `null` are still valid values to allow for
     * resetting the value.
     * \@docs-private
     * @return {?}
     */
    function getMatSelectNonArrayValueError() {
        return Error('Value must be an array in multiple-selection mode.');
    }
    /**
     * Returns an exception to be thrown when assigning a non-function value to the comparator
     * used to determine if a value corresponds to an option. Note that whether the function
     * actually takes two values and returns a boolean is not checked.
     * @return {?}
     */
    function getMatSelectNonFunctionValueError() {
        return Error('`compareWith` must be a function.');
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var nextUniqueId$5 = 0;
    /**
     * The max height of the select's overlay panel
     * @type {?}
     */
    var SELECT_PANEL_MAX_HEIGHT = 256;
    /**
     * The panel's padding on the x-axis
     * @type {?}
     */
    var SELECT_PANEL_PADDING_X = 16;
    /**
     * The panel's x axis padding if it is indented (e.g. there is an option group).
     * @type {?}
     */
    var SELECT_PANEL_INDENT_PADDING_X = SELECT_PANEL_PADDING_X * 2;
    /**
     * The height of the select items in `em` units.
     * @type {?}
     */
    var SELECT_ITEM_HEIGHT_EM = 3;
    // TODO(josephperrott): Revert to a constant after 2018 spec updates are fully merged.
    /**
     * Distance between the panel edge and the option text in
     * multi-selection mode.
     *
     * Calculated as:
     * (SELECT_PANEL_PADDING_X * 1.5) + 16 = 40
     * The padding is multiplied by 1.5 because the checkbox's margin is half the padding.
     * The checkbox width is 16px.
     * @type {?}
     */
    var SELECT_MULTIPLE_PANEL_PADDING_X = SELECT_PANEL_PADDING_X * 1.5 + 16;
    /**
     * The select panel will only "fit" inside the viewport if it is positioned at
     * this value or more away from the viewport boundary.
     * @type {?}
     */
    var SELECT_PANEL_VIEWPORT_PADDING = 8;
    /**
     * Injection token that determines the scroll handling while a select is open.
     * @type {?}
     */
    var MAT_SELECT_SCROLL_STRATEGY = new InjectionToken('mat-select-scroll-strategy');
    /**
     * \@docs-private
     * @param {?} overlay
     * @return {?}
     */
    function MAT_SELECT_SCROLL_STRATEGY_PROVIDER_FACTORY(overlay) {
        return ( /**
         * @return {?}
         */function () { return overlay.scrollStrategies.reposition(); });
    }
    /**
     * \@docs-private
     * @type {?}
     */
    var MAT_SELECT_SCROLL_STRATEGY_PROVIDER = {
        provide: MAT_SELECT_SCROLL_STRATEGY,
        deps: [Overlay],
        useFactory: MAT_SELECT_SCROLL_STRATEGY_PROVIDER_FACTORY,
    };
    /**
     * Change event object that is emitted when the select value has changed.
     */
    var MatSelectChange = /** @class */ (function () {
        /**
         * @param {?} source
         * @param {?} value
         */
        function MatSelectChange(source, value) {
            this.source = source;
            this.value = value;
        }
        return MatSelectChange;
    }());
    // Boilerplate for applying mixins to MatSelect.
    /**
     * \@docs-private
     */
    var MatSelectBase = /** @class */ (function () {
        /**
         * @param {?} _elementRef
         * @param {?} _defaultErrorStateMatcher
         * @param {?} _parentForm
         * @param {?} _parentFormGroup
         * @param {?} ngControl
         */
        function MatSelectBase(_elementRef, _defaultErrorStateMatcher, _parentForm, _parentFormGroup, ngControl) {
            this._elementRef = _elementRef;
            this._defaultErrorStateMatcher = _defaultErrorStateMatcher;
            this._parentForm = _parentForm;
            this._parentFormGroup = _parentFormGroup;
            this.ngControl = ngControl;
        }
        return MatSelectBase;
    }());
    /** @type {?} */
    var _MatSelectMixinBase = mixinDisableRipple(mixinTabIndex(mixinDisabled(mixinErrorState(MatSelectBase))));
    /**
     * Allows the user to customize the trigger that is displayed when the select has a value.
     */
    var MatSelectTrigger = /** @class */ (function () {
        function MatSelectTrigger() {
        }
        return MatSelectTrigger;
    }());
    MatSelectTrigger.decorators = [
        { type: Directive, args: [{
                    selector: 'mat-select-trigger'
                },] },
    ];
    var MatSelect = /** @class */ (function (_super) {
        __extends(MatSelect, _super);
        /**
         * @param {?} _viewportRuler
         * @param {?} _changeDetectorRef
         * @param {?} _ngZone
         * @param {?} _defaultErrorStateMatcher
         * @param {?} elementRef
         * @param {?} _dir
         * @param {?} _parentForm
         * @param {?} _parentFormGroup
         * @param {?} _parentFormField
         * @param {?} ngControl
         * @param {?} tabIndex
         * @param {?} scrollStrategyFactory
         * @param {?=} _liveAnnouncer
         */
        function MatSelect(_viewportRuler, _changeDetectorRef, _ngZone, _defaultErrorStateMatcher, elementRef, _dir, _parentForm, _parentFormGroup, _parentFormField, ngControl, tabIndex, scrollStrategyFactory, _liveAnnouncer) {
            var _this = _super.call(this, elementRef, _defaultErrorStateMatcher, _parentForm, _parentFormGroup, ngControl) || this;
            _this._viewportRuler = _viewportRuler;
            _this._changeDetectorRef = _changeDetectorRef;
            _this._ngZone = _ngZone;
            _this._dir = _dir;
            _this._parentFormField = _parentFormField;
            _this.ngControl = ngControl;
            _this._liveAnnouncer = _liveAnnouncer;
            /**
             * Whether or not the overlay panel is open.
             */
            _this._panelOpen = false;
            /**
             * Whether filling out the select is required in the form.
             */
            _this._required = false;
            /**
             * The scroll position of the overlay panel, calculated to center the selected option.
             */
            _this._scrollTop = 0;
            /**
             * Whether the component is in multiple selection mode.
             */
            _this._multiple = false;
            /**
             * Comparison function to specify which option is displayed. Defaults to object equality.
             */
            _this._compareWith = ( /**
             * @param {?} o1
             * @param {?} o2
             * @return {?}
             */function (o1, o2) { return o1 === o2; });
            /**
             * Unique id for this input.
             */
            _this._uid = "mat-select-" + nextUniqueId$5++;
            /**
             * Emits whenever the component is destroyed.
             */
            _this._destroy = new Subject();
            /**
             * The cached font-size of the trigger element.
             */
            _this._triggerFontSize = 0;
            /**
             * `View -> model callback called when value changes`
             */
            _this._onChange = ( /**
             * @return {?}
             */function () { });
            /**
             * `View -> model callback called when select has been touched`
             */
            _this._onTouched = ( /**
             * @return {?}
             */function () { });
            /**
             * The IDs of child options to be passed to the aria-owns attribute.
             */
            _this._optionIds = '';
            /**
             * The value of the select panel's transform-origin property.
             */
            _this._transformOrigin = 'top';
            /**
             * Emits when the panel element is finished transforming in.
             */
            _this._panelDoneAnimatingStream = new Subject();
            /**
             * The y-offset of the overlay panel in relation to the trigger's top start corner.
             * This must be adjusted to align the selected option text over the trigger text.
             * when the panel opens. Will change based on the y-position of the selected option.
             */
            _this._offsetY = 0;
            /**
             * This position config ensures that the top "start" corner of the overlay
             * is aligned with with the top "start" of the origin by default (overlapping
             * the trigger completely). If the panel cannot fit below the trigger, it
             * will fall back to a position above the trigger.
             */
            _this._positions = [
                {
                    originX: 'start',
                    originY: 'top',
                    overlayX: 'start',
                    overlayY: 'top',
                },
                {
                    originX: 'start',
                    originY: 'bottom',
                    overlayX: 'start',
                    overlayY: 'bottom',
                },
            ];
            /**
             * Whether the component is disabling centering of the active option over the trigger.
             */
            _this._disableOptionCentering = false;
            _this._focused = false;
            /**
             * A name for this control that can be used by `mat-form-field`.
             */
            _this.controlType = 'mat-select';
            /**
             * Aria label of the select. If not specified, the placeholder will be used as label.
             */
            _this.ariaLabel = '';
            /**
             * Combined stream of all of the child options' change events.
             */
            _this.optionSelectionChanges = ( /** @type {?} */(defer(( /**
             * @return {?}
             */function () {
                /** @type {?} */
                var options = _this.options;
                if (options) {
                    return options.changes.pipe(startWith(options), switchMap(( /**
                     * @return {?}
                     */function () { return merge.apply(void 0, __spread(options.map(( /**
                     * @param {?} option
                     * @return {?}
                     */function (/**
                     * @param {?} option
                     * @return {?}
                     */ option) { return option.onSelectionChange; })))); })));
                }
                return _this._ngZone.onStable
                    .asObservable()
                    .pipe(take(1), switchMap(( /**
             * @return {?}
             */function () { return _this.optionSelectionChanges; })));
            }))));
            /**
             * Event emitted when the select panel has been toggled.
             */
            _this.openedChange = new EventEmitter();
            /**
             * Event emitted when the select has been opened.
             */
            _this._openedStream = _this.openedChange.pipe(filter(( /**
             * @param {?} o
             * @return {?}
             */function (/**
             * @param {?} o
             * @return {?}
             */ o) { return o; })), map(( /**
             * @return {?}
             */function () { })));
            /**
             * Event emitted when the select has been closed.
             */
            _this._closedStream = _this.openedChange.pipe(filter(( /**
             * @param {?} o
             * @return {?}
             */function (/**
             * @param {?} o
             * @return {?}
             */ o) { return !o; })), map(( /**
             * @return {?}
             */function () { })));
            /**
             * Event emitted when the selected value has been changed by the user.
             */
            _this.selectionChange = new EventEmitter();
            /**
             * Event that emits whenever the raw value of the select changes. This is here primarily
             * to facilitate the two-way binding for the `value` input.
             * \@docs-private
             */
            _this.valueChange = new EventEmitter();
            if (_this.ngControl) {
                // Note: we provide the value accessor through here, instead of
                // the `providers` to avoid running into a circular import.
                _this.ngControl.valueAccessor = _this;
            }
            _this._scrollStrategyFactory = scrollStrategyFactory;
            _this._scrollStrategy = _this._scrollStrategyFactory();
            _this.tabIndex = parseInt(tabIndex) || 0;
            // Force setter to be called in case id was not specified.
            _this.id = _this.id;
            return _this;
        }
        Object.defineProperty(MatSelect.prototype, "focused", {
            /**
             * Whether the select is focused.
             * @return {?}
             */
            get: function () {
                return this._focused || this._panelOpen;
            },
            /**
             * @deprecated Setter to be removed as this property is intended to be readonly.
             * \@breaking-change 8.0.0
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._focused = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatSelect.prototype, "placeholder", {
            /**
             * Placeholder to be shown if no value has been selected.
             * @return {?}
             */
            get: function () { return this._placeholder; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._placeholder = value;
                this.stateChanges.next();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatSelect.prototype, "required", {
            /**
             * Whether the component is required.
             * @return {?}
             */
            get: function () { return this._required; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._required = coerceBooleanProperty(value);
                this.stateChanges.next();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatSelect.prototype, "multiple", {
            /**
             * Whether the user should be allowed to select multiple options.
             * @return {?}
             */
            get: function () { return this._multiple; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                if (this._selectionModel) {
                    throw getMatSelectDynamicMultipleError();
                }
                this._multiple = coerceBooleanProperty(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatSelect.prototype, "disableOptionCentering", {
            /**
             * Whether to center the active option over the trigger.
             * @return {?}
             */
            get: function () { return this._disableOptionCentering; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._disableOptionCentering = coerceBooleanProperty(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatSelect.prototype, "compareWith", {
            /**
             * Function to compare the option values with the selected values. The first argument
             * is a value from an option. The second is a value from the selection. A boolean
             * should be returned.
             * @return {?}
             */
            get: function () { return this._compareWith; },
            /**
             * @param {?} fn
             * @return {?}
             */
            set: function (fn) {
                if (typeof fn !== 'function') {
                    throw getMatSelectNonFunctionValueError();
                }
                this._compareWith = fn;
                if (this._selectionModel) {
                    // A different comparator means the selection could change.
                    this._initializeSelection();
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatSelect.prototype, "value", {
            /**
             * Value of the select control.
             * @return {?}
             */
            get: function () { return this._value; },
            /**
             * @param {?} newValue
             * @return {?}
             */
            set: function (newValue) {
                if (newValue !== this._value) {
                    this.writeValue(newValue);
                    this._value = newValue;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatSelect.prototype, "id", {
            /**
             * Unique id of the element.
             * @return {?}
             */
            get: function () { return this._id; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._id = value || this._uid;
                this.stateChanges.next();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        MatSelect.prototype.ngOnInit = function () {
            var _this = this;
            this._selectionModel = new SelectionModel(this.multiple);
            this.stateChanges.next();
            // We need `distinctUntilChanged` here, because some browsers will
            // fire the animation end event twice for the same animation. See:
            // https://github.com/angular/angular/issues/24084
            this._panelDoneAnimatingStream
                .pipe(distinctUntilChanged(), takeUntil(this._destroy))
                .subscribe(( /**
         * @return {?}
         */function () {
                if (_this.panelOpen) {
                    _this._scrollTop = 0;
                    _this.openedChange.emit(true);
                }
                else {
                    _this.openedChange.emit(false);
                    _this.overlayDir.offsetX = 0;
                    _this._changeDetectorRef.markForCheck();
                }
            }));
            this._viewportRuler.change()
                .pipe(takeUntil(this._destroy))
                .subscribe(( /**
         * @return {?}
         */function () {
                if (_this._panelOpen) {
                    _this._triggerRect = _this.trigger.nativeElement.getBoundingClientRect();
                    _this._changeDetectorRef.markForCheck();
                }
            }));
        };
        /**
         * @return {?}
         */
        MatSelect.prototype.ngAfterContentInit = function () {
            var _this = this;
            this._initKeyManager();
            this._selectionModel.onChange.pipe(takeUntil(this._destroy)).subscribe(( /**
             * @param {?} event
             * @return {?}
             */function (/**
             * @param {?} event
             * @return {?}
             */ event) {
                event.added.forEach(( /**
                 * @param {?} option
                 * @return {?}
                 */function (/**
                 * @param {?} option
                 * @return {?}
                 */ option) { return option.select(); }));
                event.removed.forEach(( /**
                 * @param {?} option
                 * @return {?}
                 */function (/**
                 * @param {?} option
                 * @return {?}
                 */ option) { return option.deselect(); }));
            }));
            this.options.changes.pipe(startWith(null), takeUntil(this._destroy)).subscribe(( /**
             * @return {?}
             */function () {
                _this._resetOptions();
                _this._initializeSelection();
            }));
        };
        /**
         * @return {?}
         */
        MatSelect.prototype.ngDoCheck = function () {
            if (this.ngControl) {
                this.updateErrorState();
            }
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        MatSelect.prototype.ngOnChanges = function (changes) {
            // Updating the disabled state is handled by `mixinDisabled`, but we need to additionally let
            // the parent form field know to run change detection when the disabled state changes.
            if (changes['disabled']) {
                this.stateChanges.next();
            }
            if (changes['typeaheadDebounceInterval'] && this._keyManager) {
                this._keyManager.withTypeAhead(this.typeaheadDebounceInterval);
            }
        };
        /**
         * @return {?}
         */
        MatSelect.prototype.ngOnDestroy = function () {
            this._destroy.next();
            this._destroy.complete();
            this.stateChanges.complete();
        };
        /**
         * Toggles the overlay panel open or closed.
         * @return {?}
         */
        MatSelect.prototype.toggle = function () {
            this.panelOpen ? this.close() : this.open();
        };
        /**
         * Opens the overlay panel.
         * @return {?}
         */
        MatSelect.prototype.open = function () {
            var _this = this;
            if (this.disabled || !this.options || !this.options.length || this._panelOpen) {
                return;
            }
            this._triggerRect = this.trigger.nativeElement.getBoundingClientRect();
            // Note: The computed font-size will be a string pixel value (e.g. "16px").
            // `parseInt` ignores the trailing 'px' and converts this to a number.
            this._triggerFontSize = parseInt(getComputedStyle(this.trigger.nativeElement).fontSize || '0');
            this._panelOpen = true;
            this._keyManager.withHorizontalOrientation(null);
            this._calculateOverlayPosition();
            this._highlightCorrectOption();
            this._changeDetectorRef.markForCheck();
            // Set the font size on the panel element once it exists.
            this._ngZone.onStable.asObservable().pipe(take(1)).subscribe(( /**
             * @return {?}
             */function () {
                if (_this._triggerFontSize && _this.overlayDir.overlayRef &&
                    _this.overlayDir.overlayRef.overlayElement) {
                    _this.overlayDir.overlayRef.overlayElement.style.fontSize = _this._triggerFontSize + "px";
                }
            }));
        };
        /**
         * Closes the overlay panel and focuses the host element.
         * @return {?}
         */
        MatSelect.prototype.close = function () {
            if (this._panelOpen) {
                this._panelOpen = false;
                this._keyManager.withHorizontalOrientation(this._isRtl() ? 'rtl' : 'ltr');
                this._changeDetectorRef.markForCheck();
                this._onTouched();
            }
        };
        /**
         * Sets the select's value. Part of the ControlValueAccessor interface
         * required to integrate with Angular's core forms API.
         *
         * @param {?} value New value to be written to the model.
         * @return {?}
         */
        MatSelect.prototype.writeValue = function (value) {
            if (this.options) {
                this._setSelectionByValue(value);
            }
        };
        /**
         * Saves a callback function to be invoked when the select's value
         * changes from user input. Part of the ControlValueAccessor interface
         * required to integrate with Angular's core forms API.
         *
         * @param {?} fn Callback to be triggered when the value changes.
         * @return {?}
         */
        MatSelect.prototype.registerOnChange = function (fn) {
            this._onChange = fn;
        };
        /**
         * Saves a callback function to be invoked when the select is blurred
         * by the user. Part of the ControlValueAccessor interface required
         * to integrate with Angular's core forms API.
         *
         * @param {?} fn Callback to be triggered when the component has been touched.
         * @return {?}
         */
        MatSelect.prototype.registerOnTouched = function (fn) {
            this._onTouched = fn;
        };
        /**
         * Disables the select. Part of the ControlValueAccessor interface required
         * to integrate with Angular's core forms API.
         *
         * @param {?} isDisabled Sets whether the component is disabled.
         * @return {?}
         */
        MatSelect.prototype.setDisabledState = function (isDisabled) {
            this.disabled = isDisabled;
            this._changeDetectorRef.markForCheck();
            this.stateChanges.next();
        };
        Object.defineProperty(MatSelect.prototype, "panelOpen", {
            /**
             * Whether or not the overlay panel is open.
             * @return {?}
             */
            get: function () {
                return this._panelOpen;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatSelect.prototype, "selected", {
            /**
             * The currently selected option.
             * @return {?}
             */
            get: function () {
                return this.multiple ? this._selectionModel.selected : this._selectionModel.selected[0];
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatSelect.prototype, "triggerValue", {
            /**
             * The value displayed in the trigger.
             * @return {?}
             */
            get: function () {
                if (this.empty) {
                    return '';
                }
                if (this._multiple) {
                    /** @type {?} */
                    var selectedOptions = this._selectionModel.selected.map(( /**
                     * @param {?} option
                     * @return {?}
                     */function (/**
                     * @param {?} option
                     * @return {?}
                     */ option) { return option.viewValue; }));
                    if (this._isRtl()) {
                        selectedOptions.reverse();
                    }
                    // TODO(crisbeto): delimiter should be configurable for proper localization.
                    return selectedOptions.join(', ');
                }
                return this._selectionModel.selected[0].viewValue;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Whether the element is in RTL mode.
         * @return {?}
         */
        MatSelect.prototype._isRtl = function () {
            return this._dir ? this._dir.value === 'rtl' : false;
        };
        /**
         * Handles all keydown events on the select.
         * @param {?} event
         * @return {?}
         */
        MatSelect.prototype._handleKeydown = function (event) {
            if (!this.disabled) {
                this.panelOpen ? this._handleOpenKeydown(event) : this._handleClosedKeydown(event);
            }
        };
        /**
         * Handles keyboard events while the select is closed.
         * @private
         * @param {?} event
         * @return {?}
         */
        MatSelect.prototype._handleClosedKeydown = function (event) {
            /** @type {?} */
            var keyCode = event.keyCode;
            /** @type {?} */
            var isArrowKey = keyCode === DOWN_ARROW || keyCode === UP_ARROW ||
                keyCode === LEFT_ARROW || keyCode === RIGHT_ARROW;
            /** @type {?} */
            var isOpenKey = keyCode === ENTER || keyCode === SPACE;
            /** @type {?} */
            var manager = this._keyManager;
            // Open the select on ALT + arrow key to match the native <select>
            if ((isOpenKey && !hasModifierKey(event)) || ((this.multiple || event.altKey) && isArrowKey)) {
                event.preventDefault(); // prevents the page from scrolling down when pressing space
                this.open();
            }
            else if (!this.multiple) {
                /** @type {?} */
                var previouslySelectedOption = this.selected;
                if (keyCode === HOME || keyCode === END) {
                    keyCode === HOME ? manager.setFirstItemActive() : manager.setLastItemActive();
                    event.preventDefault();
                }
                else {
                    manager.onKeydown(event);
                }
                /** @type {?} */
                var selectedOption = this.selected;
                // Since the value has changed, we need to announce it ourselves.
                // @breaking-change 8.0.0 remove null check for _liveAnnouncer.
                if (this._liveAnnouncer && selectedOption && previouslySelectedOption !== selectedOption) {
                    // We set a duration on the live announcement, because we want the live element to be
                    // cleared after a while so that users can't navigate to it using the arrow keys.
                    this._liveAnnouncer.announce((( /** @type {?} */(selectedOption))).viewValue, 10000);
                }
            }
        };
        /**
         * Handles keyboard events when the selected is open.
         * @private
         * @param {?} event
         * @return {?}
         */
        MatSelect.prototype._handleOpenKeydown = function (event) {
            /** @type {?} */
            var keyCode = event.keyCode;
            /** @type {?} */
            var isArrowKey = keyCode === DOWN_ARROW || keyCode === UP_ARROW;
            /** @type {?} */
            var manager = this._keyManager;
            if (keyCode === HOME || keyCode === END) {
                event.preventDefault();
                keyCode === HOME ? manager.setFirstItemActive() : manager.setLastItemActive();
            }
            else if (isArrowKey && event.altKey) {
                // Close the select on ALT + arrow key to match the native <select>
                event.preventDefault();
                this.close();
            }
            else if ((keyCode === ENTER || keyCode === SPACE) && manager.activeItem &&
                !hasModifierKey(event)) {
                event.preventDefault();
                manager.activeItem._selectViaInteraction();
            }
            else if (this._multiple && keyCode === A && event.ctrlKey) {
                event.preventDefault();
                /** @type {?} */
                var hasDeselectedOptions_1 = this.options.some(( /**
                 * @param {?} opt
                 * @return {?}
                 */function (/**
                 * @param {?} opt
                 * @return {?}
                 */ opt) { return !opt.disabled && !opt.selected; }));
                this.options.forEach(( /**
                 * @param {?} option
                 * @return {?}
                 */function (/**
                 * @param {?} option
                 * @return {?}
                 */ option) {
                    if (!option.disabled) {
                        hasDeselectedOptions_1 ? option.select() : option.deselect();
                    }
                }));
            }
            else {
                /** @type {?} */
                var previouslyFocusedIndex = manager.activeItemIndex;
                manager.onKeydown(event);
                if (this._multiple && isArrowKey && event.shiftKey && manager.activeItem &&
                    manager.activeItemIndex !== previouslyFocusedIndex) {
                    manager.activeItem._selectViaInteraction();
                }
            }
        };
        /**
         * @return {?}
         */
        MatSelect.prototype._onFocus = function () {
            if (!this.disabled) {
                this._focused = true;
                this.stateChanges.next();
            }
        };
        /**
         * Calls the touched callback only if the panel is closed. Otherwise, the trigger will
         * "blur" to the panel when it opens, causing a false positive.
         * @return {?}
         */
        MatSelect.prototype._onBlur = function () {
            this._focused = false;
            if (!this.disabled && !this.panelOpen) {
                this._onTouched();
                this._changeDetectorRef.markForCheck();
                this.stateChanges.next();
            }
        };
        /**
         * Callback that is invoked when the overlay panel has been attached.
         * @return {?}
         */
        MatSelect.prototype._onAttached = function () {
            var _this = this;
            this.overlayDir.positionChange.pipe(take(1)).subscribe(( /**
             * @return {?}
             */function () {
                _this._changeDetectorRef.detectChanges();
                _this._calculateOverlayOffsetX();
                _this.panel.nativeElement.scrollTop = _this._scrollTop;
            }));
        };
        /**
         * Returns the theme to be used on the panel.
         * @return {?}
         */
        MatSelect.prototype._getPanelTheme = function () {
            return this._parentFormField ? "mat-" + this._parentFormField.color : '';
        };
        Object.defineProperty(MatSelect.prototype, "empty", {
            /**
             * Whether the select has a value.
             * @return {?}
             */
            get: function () {
                return !this._selectionModel || this._selectionModel.isEmpty();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @private
         * @return {?}
         */
        MatSelect.prototype._initializeSelection = function () {
            var _this = this;
            // Defer setting the value in order to avoid the "Expression
            // has changed after it was checked" errors from Angular.
            Promise.resolve().then(( /**
             * @return {?}
             */function () {
                _this._setSelectionByValue(_this.ngControl ? _this.ngControl.value : _this._value);
                _this.stateChanges.next();
            }));
        };
        /**
         * Sets the selected option based on a value. If no option can be
         * found with the designated value, the select trigger is cleared.
         * @private
         * @param {?} value
         * @return {?}
         */
        MatSelect.prototype._setSelectionByValue = function (value) {
            var _this = this;
            if (this.multiple && value) {
                if (!Array.isArray(value)) {
                    throw getMatSelectNonArrayValueError();
                }
                this._selectionModel.clear();
                value.forEach(( /**
                 * @param {?} currentValue
                 * @return {?}
                 */function (currentValue) { return _this._selectValue(currentValue); }));
                this._sortValues();
            }
            else {
                this._selectionModel.clear();
                /** @type {?} */
                var correspondingOption = this._selectValue(value);
                // Shift focus to the active item. Note that we shouldn't do this in multiple
                // mode, because we don't know what option the user interacted with last.
                if (correspondingOption) {
                    this._keyManager.setActiveItem(correspondingOption);
                }
                else if (!this.panelOpen) {
                    // Otherwise reset the highlighted option. Note that we only want to do this while
                    // closed, because doing it while open can shift the user's focus unnecessarily.
                    this._keyManager.setActiveItem(-1);
                }
            }
            this._changeDetectorRef.markForCheck();
        };
        /**
         * Finds and selects and option based on its value.
         * @private
         * @param {?} value
         * @return {?} Option that has the corresponding value.
         */
        MatSelect.prototype._selectValue = function (value) {
            var _this = this;
            /** @type {?} */
            var correspondingOption = this.options.find(( /**
             * @param {?} option
             * @return {?}
             */function (option) {
                try {
                    // Treat null as a special reset value.
                    return option.value != null && _this._compareWith(option.value, value);
                }
                catch (error) {
                    if (isDevMode()) {
                        // Notify developers of errors in their comparator.
                        console.warn(error);
                    }
                    return false;
                }
            }));
            if (correspondingOption) {
                this._selectionModel.select(correspondingOption);
            }
            return correspondingOption;
        };
        /**
         * Sets up a key manager to listen to keyboard events on the overlay panel.
         * @private
         * @return {?}
         */
        MatSelect.prototype._initKeyManager = function () {
            var _this = this;
            this._keyManager = new ActiveDescendantKeyManager(this.options)
                .withTypeAhead(this.typeaheadDebounceInterval)
                .withVerticalOrientation()
                .withHorizontalOrientation(this._isRtl() ? 'rtl' : 'ltr')
                .withAllowedModifierKeys(['shiftKey']);
            this._keyManager.tabOut.pipe(takeUntil(this._destroy)).subscribe(( /**
             * @return {?}
             */function () {
                // Restore focus to the trigger before closing. Ensures that the focus
                // position won't be lost if the user got focus into the overlay.
                _this.focus();
                _this.close();
            }));
            this._keyManager.change.pipe(takeUntil(this._destroy)).subscribe(( /**
             * @return {?}
             */function () {
                if (_this._panelOpen && _this.panel) {
                    _this._scrollActiveOptionIntoView();
                }
                else if (!_this._panelOpen && !_this.multiple && _this._keyManager.activeItem) {
                    _this._keyManager.activeItem._selectViaInteraction();
                }
            }));
        };
        /**
         * Drops current option subscriptions and IDs and resets from scratch.
         * @private
         * @return {?}
         */
        MatSelect.prototype._resetOptions = function () {
            var _this = this;
            /** @type {?} */
            var changedOrDestroyed = merge(this.options.changes, this._destroy);
            this.optionSelectionChanges.pipe(takeUntil(changedOrDestroyed)).subscribe(( /**
             * @param {?} event
             * @return {?}
             */function (/**
             * @param {?} event
             * @return {?}
             */ event) {
                _this._onSelect(event.source, event.isUserInput);
                if (event.isUserInput && !_this.multiple && _this._panelOpen) {
                    _this.close();
                    _this.focus();
                }
            }));
            // Listen to changes in the internal state of the options and react accordingly.
            // Handles cases like the labels of the selected options changing.
            merge.apply(void 0, __spread(this.options.map(( /**
             * @param {?} option
             * @return {?}
             */function (/**
             * @param {?} option
             * @return {?}
             */ option) { return option._stateChanges; })))).pipe(takeUntil(changedOrDestroyed))
                .subscribe(( /**
         * @return {?}
         */function () {
                _this._changeDetectorRef.markForCheck();
                _this.stateChanges.next();
            }));
            this._setOptionIds();
        };
        /**
         * Invoked when an option is clicked.
         * @private
         * @param {?} option
         * @param {?} isUserInput
         * @return {?}
         */
        MatSelect.prototype._onSelect = function (option, isUserInput) {
            /** @type {?} */
            var wasSelected = this._selectionModel.isSelected(option);
            if (option.value == null && !this._multiple) {
                option.deselect();
                this._selectionModel.clear();
                this._propagateChanges(option.value);
            }
            else {
                if (wasSelected !== option.selected) {
                    option.selected ? this._selectionModel.select(option) :
                        this._selectionModel.deselect(option);
                }
                if (isUserInput) {
                    this._keyManager.setActiveItem(option);
                }
                if (this.multiple) {
                    this._sortValues();
                    if (isUserInput) {
                        // In case the user selected the option with their mouse, we
                        // want to restore focus back to the trigger, in order to
                        // prevent the select keyboard controls from clashing with
                        // the ones from `mat-option`.
                        this.focus();
                    }
                }
            }
            if (wasSelected !== this._selectionModel.isSelected(option)) {
                this._propagateChanges();
            }
            this.stateChanges.next();
        };
        /**
         * Sorts the selected values in the selected based on their order in the panel.
         * @private
         * @return {?}
         */
        MatSelect.prototype._sortValues = function () {
            var _this = this;
            if (this.multiple) {
                /** @type {?} */
                var options_1 = this.options.toArray();
                this._selectionModel.sort(( /**
                 * @param {?} a
                 * @param {?} b
                 * @return {?}
                 */function (a, b) {
                    return _this.sortComparator ? _this.sortComparator(a, b, options_1) :
                        options_1.indexOf(a) - options_1.indexOf(b);
                }));
                this.stateChanges.next();
            }
        };
        /**
         * Emits change event to set the model value.
         * @private
         * @param {?=} fallbackValue
         * @return {?}
         */
        MatSelect.prototype._propagateChanges = function (fallbackValue) {
            /** @type {?} */
            var valueToEmit = null;
            if (this.multiple) {
                valueToEmit = (( /** @type {?} */(this.selected))).map(( /**
                 * @param {?} option
                 * @return {?}
                 */function (/**
                 * @param {?} option
                 * @return {?}
                 */ option) { return option.value; }));
            }
            else {
                valueToEmit = this.selected ? (( /** @type {?} */(this.selected))).value : fallbackValue;
            }
            this._value = valueToEmit;
            this.valueChange.emit(valueToEmit);
            this._onChange(valueToEmit);
            this.selectionChange.emit(new MatSelectChange(this, valueToEmit));
            this._changeDetectorRef.markForCheck();
        };
        /**
         * Records option IDs to pass to the aria-owns property.
         * @private
         * @return {?}
         */
        MatSelect.prototype._setOptionIds = function () {
            this._optionIds = this.options.map(( /**
             * @param {?} option
             * @return {?}
             */function (/**
             * @param {?} option
             * @return {?}
             */ option) { return option.id; })).join(' ');
        };
        /**
         * Highlights the selected item. If no option is selected, it will highlight
         * the first item instead.
         * @private
         * @return {?}
         */
        MatSelect.prototype._highlightCorrectOption = function () {
            if (this._keyManager) {
                if (this.empty) {
                    this._keyManager.setFirstItemActive();
                }
                else {
                    this._keyManager.setActiveItem(this._selectionModel.selected[0]);
                }
            }
        };
        /**
         * Scrolls the active option into view.
         * @private
         * @return {?}
         */
        MatSelect.prototype._scrollActiveOptionIntoView = function () {
            /** @type {?} */
            var activeOptionIndex = this._keyManager.activeItemIndex || 0;
            /** @type {?} */
            var labelCount = _countGroupLabelsBeforeOption(activeOptionIndex, this.options, this.optionGroups);
            this.panel.nativeElement.scrollTop = _getOptionScrollPosition(activeOptionIndex + labelCount, this._getItemHeight(), this.panel.nativeElement.scrollTop, SELECT_PANEL_MAX_HEIGHT);
        };
        /**
         * Focuses the select element.
         * @param {?=} options
         * @return {?}
         */
        MatSelect.prototype.focus = function (options) {
            this._elementRef.nativeElement.focus(options);
        };
        /**
         * Gets the index of the provided option in the option list.
         * @private
         * @param {?} option
         * @return {?}
         */
        MatSelect.prototype._getOptionIndex = function (option) {
            return this.options.reduce(( /**
             * @param {?} result
             * @param {?} current
             * @param {?} index
             * @return {?}
             */function (result, current, index) {
                return result === undefined ? (option === current ? index : undefined) : result;
            }), undefined);
        };
        /**
         * Calculates the scroll position and x- and y-offsets of the overlay panel.
         * @private
         * @return {?}
         */
        MatSelect.prototype._calculateOverlayPosition = function () {
            /** @type {?} */
            var itemHeight = this._getItemHeight();
            /** @type {?} */
            var items = this._getItemCount();
            /** @type {?} */
            var panelHeight = Math.min(items * itemHeight, SELECT_PANEL_MAX_HEIGHT);
            /** @type {?} */
            var scrollContainerHeight = items * itemHeight;
            // The farthest the panel can be scrolled before it hits the bottom
            /** @type {?} */
            var maxScroll = scrollContainerHeight - panelHeight;
            // If no value is selected we open the popup to the first item.
            /** @type {?} */
            var selectedOptionOffset = this.empty ? 0 : ( /** @type {?} */(this._getOptionIndex(this._selectionModel.selected[0])));
            selectedOptionOffset += _countGroupLabelsBeforeOption(selectedOptionOffset, this.options, this.optionGroups);
            // We must maintain a scroll buffer so the selected option will be scrolled to the
            // center of the overlay panel rather than the top.
            /** @type {?} */
            var scrollBuffer = panelHeight / 2;
            this._scrollTop = this._calculateOverlayScroll(selectedOptionOffset, scrollBuffer, maxScroll);
            this._offsetY = this._calculateOverlayOffsetY(selectedOptionOffset, scrollBuffer, maxScroll);
            this._checkOverlayWithinViewport(maxScroll);
        };
        /**
         * Calculates the scroll position of the select's overlay panel.
         *
         * Attempts to center the selected option in the panel. If the option is
         * too high or too low in the panel to be scrolled to the center, it clamps the
         * scroll position to the min or max scroll positions respectively.
         * @param {?} selectedIndex
         * @param {?} scrollBuffer
         * @param {?} maxScroll
         * @return {?}
         */
        MatSelect.prototype._calculateOverlayScroll = function (selectedIndex, scrollBuffer, maxScroll) {
            /** @type {?} */
            var itemHeight = this._getItemHeight();
            /** @type {?} */
            var optionOffsetFromScrollTop = itemHeight * selectedIndex;
            /** @type {?} */
            var halfOptionHeight = itemHeight / 2;
            // Starts at the optionOffsetFromScrollTop, which scrolls the option to the top of the
            // scroll container, then subtracts the scroll buffer to scroll the option down to
            // the center of the overlay panel. Half the option height must be re-added to the
            // scrollTop so the option is centered based on its middle, not its top edge.
            /** @type {?} */
            var optimalScrollPosition = optionOffsetFromScrollTop - scrollBuffer + halfOptionHeight;
            return Math.min(Math.max(0, optimalScrollPosition), maxScroll);
        };
        /**
         * Returns the aria-label of the select component.
         * @return {?}
         */
        MatSelect.prototype._getAriaLabel = function () {
            // If an ariaLabelledby value has been set by the consumer, the select should not overwrite the
            // `aria-labelledby` value by setting the ariaLabel to the placeholder.
            return this.ariaLabelledby ? null : this.ariaLabel || this.placeholder;
        };
        /**
         * Returns the aria-labelledby of the select component.
         * @return {?}
         */
        MatSelect.prototype._getAriaLabelledby = function () {
            if (this.ariaLabelledby) {
                return this.ariaLabelledby;
            }
            // Note: we use `_getAriaLabel` here, because we want to check whether there's a
            // computed label. `this.ariaLabel` is only the user-specified label.
            if (!this._parentFormField || !this._parentFormField._hasFloatingLabel() ||
                this._getAriaLabel()) {
                return null;
            }
            return this._parentFormField._labelId || null;
        };
        /**
         * Determines the `aria-activedescendant` to be set on the host.
         * @return {?}
         */
        MatSelect.prototype._getAriaActiveDescendant = function () {
            if (this.panelOpen && this._keyManager && this._keyManager.activeItem) {
                return this._keyManager.activeItem.id;
            }
            return null;
        };
        /**
         * Sets the x-offset of the overlay panel in relation to the trigger's top start corner.
         * This must be adjusted to align the selected option text over the trigger text when
         * the panel opens. Will change based on LTR or RTL text direction. Note that the offset
         * can't be calculated until the panel has been attached, because we need to know the
         * content width in order to constrain the panel within the viewport.
         * @private
         * @return {?}
         */
        MatSelect.prototype._calculateOverlayOffsetX = function () {
            /** @type {?} */
            var overlayRect = this.overlayDir.overlayRef.overlayElement.getBoundingClientRect();
            /** @type {?} */
            var viewportSize = this._viewportRuler.getViewportSize();
            /** @type {?} */
            var isRtl = this._isRtl();
            /** @type {?} */
            var paddingWidth = this.multiple ? SELECT_MULTIPLE_PANEL_PADDING_X + SELECT_PANEL_PADDING_X :
                SELECT_PANEL_PADDING_X * 2;
            /** @type {?} */
            var offsetX;
            // Adjust the offset, depending on the option padding.
            if (this.multiple) {
                offsetX = SELECT_MULTIPLE_PANEL_PADDING_X;
            }
            else {
                /** @type {?} */
                var selected = this._selectionModel.selected[0] || this.options.first;
                offsetX = selected && selected.group ? SELECT_PANEL_INDENT_PADDING_X : SELECT_PANEL_PADDING_X;
            }
            // Invert the offset in LTR.
            if (!isRtl) {
                offsetX *= -1;
            }
            // Determine how much the select overflows on each side.
            /** @type {?} */
            var leftOverflow = 0 - (overlayRect.left + offsetX - (isRtl ? paddingWidth : 0));
            /** @type {?} */
            var rightOverflow = overlayRect.right + offsetX - viewportSize.width
                + (isRtl ? 0 : paddingWidth);
            // If the element overflows on either side, reduce the offset to allow it to fit.
            if (leftOverflow > 0) {
                offsetX += leftOverflow + SELECT_PANEL_VIEWPORT_PADDING;
            }
            else if (rightOverflow > 0) {
                offsetX -= rightOverflow + SELECT_PANEL_VIEWPORT_PADDING;
            }
            // Set the offset directly in order to avoid having to go through change detection and
            // potentially triggering "changed after it was checked" errors. Round the value to avoid
            // blurry content in some browsers.
            this.overlayDir.offsetX = Math.round(offsetX);
            this.overlayDir.overlayRef.updatePosition();
        };
        /**
         * Calculates the y-offset of the select's overlay panel in relation to the
         * top start corner of the trigger. It has to be adjusted in order for the
         * selected option to be aligned over the trigger when the panel opens.
         * @private
         * @param {?} selectedIndex
         * @param {?} scrollBuffer
         * @param {?} maxScroll
         * @return {?}
         */
        MatSelect.prototype._calculateOverlayOffsetY = function (selectedIndex, scrollBuffer, maxScroll) {
            /** @type {?} */
            var itemHeight = this._getItemHeight();
            /** @type {?} */
            var optionHeightAdjustment = (itemHeight - this._triggerRect.height) / 2;
            /** @type {?} */
            var maxOptionsDisplayed = Math.floor(SELECT_PANEL_MAX_HEIGHT / itemHeight);
            /** @type {?} */
            var optionOffsetFromPanelTop;
            // Disable offset if requested by user by returning 0 as value to offset
            if (this._disableOptionCentering) {
                return 0;
            }
            if (this._scrollTop === 0) {
                optionOffsetFromPanelTop = selectedIndex * itemHeight;
            }
            else if (this._scrollTop === maxScroll) {
                /** @type {?} */
                var firstDisplayedIndex = this._getItemCount() - maxOptionsDisplayed;
                /** @type {?} */
                var selectedDisplayIndex = selectedIndex - firstDisplayedIndex;
                // The first item is partially out of the viewport. Therefore we need to calculate what
                // portion of it is shown in the viewport and account for it in our offset.
                /** @type {?} */
                var partialItemHeight = itemHeight - (this._getItemCount() * itemHeight - SELECT_PANEL_MAX_HEIGHT) % itemHeight;
                // Because the panel height is longer than the height of the options alone,
                // there is always extra padding at the top or bottom of the panel. When
                // scrolled to the very bottom, this padding is at the top of the panel and
                // must be added to the offset.
                optionOffsetFromPanelTop = selectedDisplayIndex * itemHeight + partialItemHeight;
            }
            else {
                // If the option was scrolled to the middle of the panel using a scroll buffer,
                // its offset will be the scroll buffer minus the half height that was added to
                // center it.
                optionOffsetFromPanelTop = scrollBuffer - itemHeight / 2;
            }
            // The final offset is the option's offset from the top, adjusted for the height difference,
            // multiplied by -1 to ensure that the overlay moves in the correct direction up the page.
            // The value is rounded to prevent some browsers from blurring the content.
            return Math.round(optionOffsetFromPanelTop * -1 - optionHeightAdjustment);
        };
        /**
         * Checks that the attempted overlay position will fit within the viewport.
         * If it will not fit, tries to adjust the scroll position and the associated
         * y-offset so the panel can open fully on-screen. If it still won't fit,
         * sets the offset back to 0 to allow the fallback position to take over.
         * @private
         * @param {?} maxScroll
         * @return {?}
         */
        MatSelect.prototype._checkOverlayWithinViewport = function (maxScroll) {
            /** @type {?} */
            var itemHeight = this._getItemHeight();
            /** @type {?} */
            var viewportSize = this._viewportRuler.getViewportSize();
            /** @type {?} */
            var topSpaceAvailable = this._triggerRect.top - SELECT_PANEL_VIEWPORT_PADDING;
            /** @type {?} */
            var bottomSpaceAvailable = viewportSize.height - this._triggerRect.bottom - SELECT_PANEL_VIEWPORT_PADDING;
            /** @type {?} */
            var panelHeightTop = Math.abs(this._offsetY);
            /** @type {?} */
            var totalPanelHeight = Math.min(this._getItemCount() * itemHeight, SELECT_PANEL_MAX_HEIGHT);
            /** @type {?} */
            var panelHeightBottom = totalPanelHeight - panelHeightTop - this._triggerRect.height;
            if (panelHeightBottom > bottomSpaceAvailable) {
                this._adjustPanelUp(panelHeightBottom, bottomSpaceAvailable);
            }
            else if (panelHeightTop > topSpaceAvailable) {
                this._adjustPanelDown(panelHeightTop, topSpaceAvailable, maxScroll);
            }
            else {
                this._transformOrigin = this._getOriginBasedOnOption();
            }
        };
        /**
         * Adjusts the overlay panel up to fit in the viewport.
         * @private
         * @param {?} panelHeightBottom
         * @param {?} bottomSpaceAvailable
         * @return {?}
         */
        MatSelect.prototype._adjustPanelUp = function (panelHeightBottom, bottomSpaceAvailable) {
            // Browsers ignore fractional scroll offsets, so we need to round.
            /** @type {?} */
            var distanceBelowViewport = Math.round(panelHeightBottom - bottomSpaceAvailable);
            // Scrolls the panel up by the distance it was extending past the boundary, then
            // adjusts the offset by that amount to move the panel up into the viewport.
            this._scrollTop -= distanceBelowViewport;
            this._offsetY -= distanceBelowViewport;
            this._transformOrigin = this._getOriginBasedOnOption();
            // If the panel is scrolled to the very top, it won't be able to fit the panel
            // by scrolling, so set the offset to 0 to allow the fallback position to take
            // effect.
            if (this._scrollTop <= 0) {
                this._scrollTop = 0;
                this._offsetY = 0;
                this._transformOrigin = "50% bottom 0px";
            }
        };
        /**
         * Adjusts the overlay panel down to fit in the viewport.
         * @private
         * @param {?} panelHeightTop
         * @param {?} topSpaceAvailable
         * @param {?} maxScroll
         * @return {?}
         */
        MatSelect.prototype._adjustPanelDown = function (panelHeightTop, topSpaceAvailable, maxScroll) {
            // Browsers ignore fractional scroll offsets, so we need to round.
            /** @type {?} */
            var distanceAboveViewport = Math.round(panelHeightTop - topSpaceAvailable);
            // Scrolls the panel down by the distance it was extending past the boundary, then
            // adjusts the offset by that amount to move the panel down into the viewport.
            this._scrollTop += distanceAboveViewport;
            this._offsetY += distanceAboveViewport;
            this._transformOrigin = this._getOriginBasedOnOption();
            // If the panel is scrolled to the very bottom, it won't be able to fit the
            // panel by scrolling, so set the offset to 0 to allow the fallback position
            // to take effect.
            if (this._scrollTop >= maxScroll) {
                this._scrollTop = maxScroll;
                this._offsetY = 0;
                this._transformOrigin = "50% top 0px";
                return;
            }
        };
        /**
         * Sets the transform origin point based on the selected option.
         * @private
         * @return {?}
         */
        MatSelect.prototype._getOriginBasedOnOption = function () {
            /** @type {?} */
            var itemHeight = this._getItemHeight();
            /** @type {?} */
            var optionHeightAdjustment = (itemHeight - this._triggerRect.height) / 2;
            /** @type {?} */
            var originY = Math.abs(this._offsetY) - optionHeightAdjustment + itemHeight / 2;
            return "50% " + originY + "px 0px";
        };
        /**
         * Calculates the amount of items in the select. This includes options and group labels.
         * @private
         * @return {?}
         */
        MatSelect.prototype._getItemCount = function () {
            return this.options.length + this.optionGroups.length;
        };
        /**
         * Calculates the height of the select's options.
         * @private
         * @return {?}
         */
        MatSelect.prototype._getItemHeight = function () {
            return this._triggerFontSize * SELECT_ITEM_HEIGHT_EM;
        };
        /**
         * Implemented as part of MatFormFieldControl.
         * \@docs-private
         * @param {?} ids
         * @return {?}
         */
        MatSelect.prototype.setDescribedByIds = function (ids) {
            this._ariaDescribedby = ids.join(' ');
        };
        /**
         * Implemented as part of MatFormFieldControl.
         * \@docs-private
         * @return {?}
         */
        MatSelect.prototype.onContainerClick = function () {
            this.focus();
            this.open();
        };
        Object.defineProperty(MatSelect.prototype, "shouldLabelFloat", {
            /**
             * Implemented as part of MatFormFieldControl.
             * \@docs-private
             * @return {?}
             */
            get: function () {
                return this._panelOpen || !this.empty;
            },
            enumerable: true,
            configurable: true
        });
        return MatSelect;
    }(_MatSelectMixinBase));
    MatSelect.decorators = [
        { type: Component, args: [{ selector: 'mat-select',
                    exportAs: 'matSelect',
                    template: "<div cdk-overlay-origin class=\"mat-select-trigger\" aria-hidden=\"true\" (click)=\"toggle()\" #origin=\"cdkOverlayOrigin\" #trigger><div class=\"mat-select-value\" [ngSwitch]=\"empty\"><span class=\"mat-select-placeholder\" *ngSwitchCase=\"true\">{{placeholder || '\u00A0'}}</span> <span class=\"mat-select-value-text\" *ngSwitchCase=\"false\" [ngSwitch]=\"!!customTrigger\"><span *ngSwitchDefault>{{triggerValue || '\u00A0'}}</span><ng-content select=\"mat-select-trigger\" *ngSwitchCase=\"true\"></ng-content></span></div><div class=\"mat-select-arrow-wrapper\"><div class=\"mat-select-arrow\"></div></div></div><ng-template cdk-connected-overlay cdkConnectedOverlayLockPosition cdkConnectedOverlayHasBackdrop cdkConnectedOverlayBackdropClass=\"cdk-overlay-transparent-backdrop\" [cdkConnectedOverlayScrollStrategy]=\"_scrollStrategy\" [cdkConnectedOverlayOrigin]=\"origin\" [cdkConnectedOverlayOpen]=\"panelOpen\" [cdkConnectedOverlayPositions]=\"_positions\" [cdkConnectedOverlayMinWidth]=\"_triggerRect?.width\" [cdkConnectedOverlayOffsetY]=\"_offsetY\" (backdropClick)=\"close()\" (attach)=\"_onAttached()\" (detach)=\"close()\"><div class=\"mat-select-panel-wrap\" [@transformPanelWrap]><div #panel class=\"mat-select-panel {{ _getPanelTheme() }}\" [ngClass]=\"panelClass\" [@transformPanel]=\"multiple ? 'showing-multiple' : 'showing'\" (@transformPanel.done)=\"_panelDoneAnimatingStream.next($event.toState)\" [style.transformOrigin]=\"_transformOrigin\" [style.font-size.px]=\"_triggerFontSize\" (keydown)=\"_handleKeydown($event)\"><ng-content></ng-content></div></div></ng-template>",
                    styles: [".mat-select{display:inline-block;width:100%;outline:0}.mat-select-trigger{display:inline-table;cursor:pointer;position:relative;box-sizing:border-box}.mat-select-disabled .mat-select-trigger{-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:default}.mat-select-value{display:table-cell;max-width:0;width:100%;overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.mat-select-value-text{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}.mat-select-arrow-wrapper{display:table-cell;vertical-align:middle}.mat-form-field-appearance-fill .mat-select-arrow-wrapper{transform:translateY(-50%)}.mat-form-field-appearance-outline .mat-select-arrow-wrapper{transform:translateY(-25%)}.mat-form-field-appearance-standard.mat-form-field-has-label .mat-select:not(.mat-select-empty) .mat-select-arrow-wrapper{transform:translateY(-50%)}.mat-form-field-appearance-standard .mat-select.mat-select-empty .mat-select-arrow-wrapper{transition:transform .4s cubic-bezier(.25,.8,.25,1)}._mat-animation-noopable.mat-form-field-appearance-standard .mat-select.mat-select-empty .mat-select-arrow-wrapper{transition:none}.mat-select-arrow{width:0;height:0;border-left:5px solid transparent;border-right:5px solid transparent;border-top:5px solid;margin:0 4px}.mat-select-panel-wrap{flex-basis:100%}.mat-select-panel{min-width:112px;max-width:280px;overflow:auto;-webkit-overflow-scrolling:touch;padding-top:0;padding-bottom:0;max-height:256px;min-width:100%;border-radius:4px}@media (-ms-high-contrast:active){.mat-select-panel{outline:solid 1px}}.mat-select-panel .mat-optgroup-label,.mat-select-panel .mat-option{font-size:inherit;line-height:3em;height:3em}.mat-form-field-type-mat-select:not(.mat-form-field-disabled) .mat-form-field-flex{cursor:pointer}.mat-form-field-type-mat-select .mat-form-field-label{width:calc(100% - 18px)}.mat-select-placeholder{transition:color .4s .133s cubic-bezier(.25,.8,.25,1)}._mat-animation-noopable .mat-select-placeholder{transition:none}.mat-form-field-hide-placeholder .mat-select-placeholder{color:transparent;-webkit-text-fill-color:transparent;transition:none;display:block}"],
                    inputs: ['disabled', 'disableRipple', 'tabIndex'],
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    host: {
                        'role': 'listbox',
                        '[attr.id]': 'id',
                        '[attr.tabindex]': 'tabIndex',
                        '[attr.aria-label]': '_getAriaLabel()',
                        '[attr.aria-labelledby]': '_getAriaLabelledby()',
                        '[attr.aria-required]': 'required.toString()',
                        '[attr.aria-disabled]': 'disabled.toString()',
                        '[attr.aria-invalid]': 'errorState',
                        '[attr.aria-owns]': 'panelOpen ? _optionIds : null',
                        '[attr.aria-multiselectable]': 'multiple',
                        '[attr.aria-describedby]': '_ariaDescribedby || null',
                        '[attr.aria-activedescendant]': '_getAriaActiveDescendant()',
                        '[class.mat-select-disabled]': 'disabled',
                        '[class.mat-select-invalid]': 'errorState',
                        '[class.mat-select-required]': 'required',
                        '[class.mat-select-empty]': 'empty',
                        'class': 'mat-select',
                        '(keydown)': '_handleKeydown($event)',
                        '(focus)': '_onFocus()',
                        '(blur)': '_onBlur()',
                    },
                    animations: [
                        matSelectAnimations.transformPanelWrap,
                        matSelectAnimations.transformPanel
                    ],
                    providers: [
                        { provide: MatFormFieldControl, useExisting: MatSelect },
                        { provide: MAT_OPTION_PARENT_COMPONENT, useExisting: MatSelect }
                    ],
                },] },
    ];
    /** @nocollapse */
    MatSelect.ctorParameters = function () { return [
        { type: ViewportRuler },
        { type: ChangeDetectorRef },
        { type: NgZone },
        { type: ErrorStateMatcher },
        { type: ElementRef },
        { type: Directionality, decorators: [{ type: Optional }] },
        { type: NgForm, decorators: [{ type: Optional }] },
        { type: FormGroupDirective, decorators: [{ type: Optional }] },
        { type: MatFormField, decorators: [{ type: Optional }] },
        { type: NgControl, decorators: [{ type: Self }, { type: Optional }] },
        { type: String, decorators: [{ type: Attribute, args: ['tabindex',] }] },
        { type: undefined, decorators: [{ type: Inject, args: [MAT_SELECT_SCROLL_STRATEGY,] }] },
        { type: LiveAnnouncer }
    ]; };
    MatSelect.propDecorators = {
        trigger: [{ type: ViewChild, args: ['trigger', { static: false },] }],
        panel: [{ type: ViewChild, args: ['panel', { static: false },] }],
        overlayDir: [{ type: ViewChild, args: [CdkConnectedOverlay, { static: false },] }],
        options: [{ type: ContentChildren, args: [MatOption, { descendants: true },] }],
        optionGroups: [{ type: ContentChildren, args: [MatOptgroup,] }],
        panelClass: [{ type: Input }],
        customTrigger: [{ type: ContentChild, args: [MatSelectTrigger, { static: false },] }],
        placeholder: [{ type: Input }],
        required: [{ type: Input }],
        multiple: [{ type: Input }],
        disableOptionCentering: [{ type: Input }],
        compareWith: [{ type: Input }],
        value: [{ type: Input }],
        ariaLabel: [{ type: Input, args: ['aria-label',] }],
        ariaLabelledby: [{ type: Input, args: ['aria-labelledby',] }],
        errorStateMatcher: [{ type: Input }],
        typeaheadDebounceInterval: [{ type: Input }],
        sortComparator: [{ type: Input }],
        id: [{ type: Input }],
        openedChange: [{ type: Output }],
        _openedStream: [{ type: Output, args: ['opened',] }],
        _closedStream: [{ type: Output, args: ['closed',] }],
        selectionChange: [{ type: Output }],
        valueChange: [{ type: Output }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatSelectModule = /** @class */ (function () {
        function MatSelectModule() {
        }
        return MatSelectModule;
    }());
    MatSelectModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        OverlayModule,
                        MatOptionModule,
                        MatCommonModule,
                    ],
                    exports: [MatFormFieldModule, MatSelect, MatSelectTrigger, MatOptionModule, MatCommonModule],
                    declarations: [MatSelect, MatSelectTrigger],
                    providers: [MAT_SELECT_SCROLL_STRATEGY_PROVIDER]
                },] },
    ];
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Animations used by MatTooltip.
     * \@docs-private
     * @type {?}
     */
    var matTooltipAnimations = {
        /**
         * Animation that transitions a tooltip in and out.
         */
        tooltipState: trigger('state', [
            state('initial, void, hidden', style({ opacity: 0, transform: 'scale(0)' })),
            state('visible', style({ transform: 'scale(1)' })),
            transition('* => visible', animate('200ms cubic-bezier(0, 0, 0.2, 1)', keyframes([
                style({ opacity: 0, transform: 'scale(0)', offset: 0 }),
                style({ opacity: 0.5, transform: 'scale(0.99)', offset: 0.5 }),
                style({ opacity: 1, transform: 'scale(1)', offset: 1 })
            ]))),
            transition('* => hidden', animate('100ms cubic-bezier(0, 0, 0.2, 1)', style({ opacity: 0 }))),
        ])
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Time in ms to throttle repositioning after scroll events.
     * @type {?}
     */
    var SCROLL_THROTTLE_MS = 20;
    /**
     * CSS class that will be attached to the overlay panel.
     * @type {?}
     */
    var TOOLTIP_PANEL_CLASS = 'mat-tooltip-panel';
    /**
     * Creates an error to be thrown if the user supplied an invalid tooltip position.
     * \@docs-private
     * @param {?} position
     * @return {?}
     */
    function getMatTooltipInvalidPositionError(position) {
        return Error("Tooltip position \"" + position + "\" is invalid.");
    }
    /**
     * Injection token that determines the scroll handling while a tooltip is visible.
     * @type {?}
     */
    var MAT_TOOLTIP_SCROLL_STRATEGY = new InjectionToken('mat-tooltip-scroll-strategy');
    /**
     * \@docs-private
     * @param {?} overlay
     * @return {?}
     */
    function MAT_TOOLTIP_SCROLL_STRATEGY_FACTORY(overlay) {
        return ( /**
         * @return {?}
         */function () { return overlay.scrollStrategies.reposition({ scrollThrottle: SCROLL_THROTTLE_MS }); });
    }
    /**
     * \@docs-private
     * @type {?}
     */
    var MAT_TOOLTIP_SCROLL_STRATEGY_FACTORY_PROVIDER = {
        provide: MAT_TOOLTIP_SCROLL_STRATEGY,
        deps: [Overlay],
        useFactory: MAT_TOOLTIP_SCROLL_STRATEGY_FACTORY,
    };
    /**
     * Injection token to be used to override the default options for `matTooltip`.
     * @type {?}
     */
    var MAT_TOOLTIP_DEFAULT_OPTIONS = new InjectionToken('mat-tooltip-default-options', {
        providedIn: 'root',
        factory: MAT_TOOLTIP_DEFAULT_OPTIONS_FACTORY
    });
    /**
     * \@docs-private
     * @return {?}
     */
    function MAT_TOOLTIP_DEFAULT_OPTIONS_FACTORY() {
        return {
            showDelay: 0,
            hideDelay: 0,
            touchendHideDelay: 1500,
        };
    }
    /**
     * Directive that attaches a material design tooltip to the host element. Animates the showing and
     * hiding of a tooltip provided position (defaults to below the element).
     *
     * https://material.io/design/components/tooltips.html
     */
    var MatTooltip = /** @class */ (function () {
        /**
         * @param {?} _overlay
         * @param {?} _elementRef
         * @param {?} _scrollDispatcher
         * @param {?} _viewContainerRef
         * @param {?} _ngZone
         * @param {?} platform
         * @param {?} _ariaDescriber
         * @param {?} _focusMonitor
         * @param {?} scrollStrategy
         * @param {?} _dir
         * @param {?} _defaultOptions
         * @param {?=} hammerLoader
         */
        function MatTooltip(_overlay, _elementRef, _scrollDispatcher, _viewContainerRef, _ngZone, platform, _ariaDescriber, _focusMonitor, scrollStrategy, _dir, _defaultOptions, hammerLoader) {
            var _this = this;
            this._overlay = _overlay;
            this._elementRef = _elementRef;
            this._scrollDispatcher = _scrollDispatcher;
            this._viewContainerRef = _viewContainerRef;
            this._ngZone = _ngZone;
            this._ariaDescriber = _ariaDescriber;
            this._focusMonitor = _focusMonitor;
            this._dir = _dir;
            this._defaultOptions = _defaultOptions;
            this._position = 'below';
            this._disabled = false;
            /**
             * The default delay in ms before showing the tooltip after show is called
             */
            this.showDelay = this._defaultOptions.showDelay;
            /**
             * The default delay in ms before hiding the tooltip after hide is called
             */
            this.hideDelay = this._defaultOptions.hideDelay;
            this._message = '';
            this._manualListeners = new Map();
            /**
             * Emits when the component is destroyed.
             */
            this._destroyed = new Subject();
            this._scrollStrategy = scrollStrategy;
            /** @type {?} */
            var element = _elementRef.nativeElement;
            /** @type {?} */
            var hasGestures = typeof window === 'undefined' || (( /** @type {?} */(window))).Hammer || hammerLoader;
            // The mouse events shouldn't be bound on mobile devices, because they can prevent the
            // first tap from firing its click event or can cause the tooltip to open for clicks.
            if (!platform.IOS && !platform.ANDROID) {
                this._manualListeners
                    .set('mouseenter', ( /**
             * @return {?}
             */function () { return _this.show(); }))
                    .set('mouseleave', ( /**
             * @return {?}
             */function () { return _this.hide(); }));
            }
            else if (!hasGestures) {
                // If Hammerjs isn't loaded, fall back to showing on `touchstart`, otherwise
                // there's no way for the user to trigger the tooltip on a touch device.
                this._manualListeners.set('touchstart', ( /**
                 * @return {?}
                 */function () { return _this.show(); }));
            }
            this._manualListeners.forEach(( /**
             * @param {?} listener
             * @param {?} event
             * @return {?}
             */function (listener, event) { return element.addEventListener(event, listener); }));
            _focusMonitor.monitor(_elementRef).pipe(takeUntil(this._destroyed)).subscribe(( /**
             * @param {?} origin
             * @return {?}
             */function (/**
             * @param {?} origin
             * @return {?}
             */ origin) {
                // Note that the focus monitor runs outside the Angular zone.
                if (!origin) {
                    _ngZone.run(( /**
                     * @return {?}
                     */function () { return _this.hide(0); }));
                }
                else if (origin === 'keyboard') {
                    _ngZone.run(( /**
                     * @return {?}
                     */function () { return _this.show(); }));
                }
            }));
            if (_defaultOptions && _defaultOptions.position) {
                this.position = _defaultOptions.position;
            }
        }
        Object.defineProperty(MatTooltip.prototype, "position", {
            /**
             * Allows the user to define the position of the tooltip relative to the parent element
             * @return {?}
             */
            get: function () { return this._position; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                if (value !== this._position) {
                    this._position = value;
                    if (this._overlayRef) {
                        this._updatePosition();
                        if (this._tooltipInstance) {
                            ( /** @type {?} */(this._tooltipInstance)).show(0);
                        }
                        this._overlayRef.updatePosition();
                    }
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatTooltip.prototype, "disabled", {
            /**
             * Disables the display of the tooltip.
             * @return {?}
             */
            get: function () { return this._disabled; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._disabled = coerceBooleanProperty(value);
                // If tooltip is disabled, hide immediately.
                if (this._disabled) {
                    this.hide(0);
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatTooltip.prototype, "message", {
            /**
             * The message to be displayed in the tooltip
             * @return {?}
             */
            get: function () { return this._message; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                var _this = this;
                this._ariaDescriber.removeDescription(this._elementRef.nativeElement, this._message);
                // If the message is not a string (e.g. number), convert it to a string and trim it.
                this._message = value != null ? ("" + value).trim() : '';
                if (!this._message && this._isTooltipVisible()) {
                    this.hide(0);
                }
                else {
                    this._updateTooltipMessage();
                    this._ngZone.runOutsideAngular(( /**
                     * @return {?}
                     */function () {
                        // The `AriaDescriber` has some functionality that avoids adding a description if it's the
                        // same as the `aria-label` of an element, however we can't know whether the tooltip trigger
                        // has a data-bound `aria-label` or when it'll be set for the first time. We can avoid the
                        // issue by deferring the description by a tick so Angular has time to set the `aria-label`.
                        Promise.resolve().then(( /**
                         * @return {?}
                         */function () {
                            _this._ariaDescriber.describe(_this._elementRef.nativeElement, _this.message);
                        }));
                    }));
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatTooltip.prototype, "tooltipClass", {
            /**
             * Classes to be passed to the tooltip. Supports the same syntax as `ngClass`.
             * @return {?}
             */
            get: function () { return this._tooltipClass; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._tooltipClass = value;
                if (this._tooltipInstance) {
                    this._setTooltipClass(this._tooltipClass);
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Setup styling-specific things
         * @return {?}
         */
        MatTooltip.prototype.ngOnInit = function () {
            /** @type {?} */
            var element = this._elementRef.nativeElement;
            /** @type {?} */
            var elementStyle = ( /** @type {?} */(element.style));
            if (element.nodeName === 'INPUT' || element.nodeName === 'TEXTAREA') {
                // When we bind a gesture event on an element (in this case `longpress`), HammerJS
                // will add some inline styles by default, including `user-select: none`. This is
                // problematic on iOS and in Safari, because it will prevent users from typing in inputs.
                // Since `user-select: none` is not needed for the `longpress` event and can cause unexpected
                // behavior for text fields, we always clear the `user-select` to avoid such issues.
                elementStyle.webkitUserSelect = elementStyle.userSelect = elementStyle.msUserSelect = '';
            }
            // Hammer applies `-webkit-user-drag: none` on all elements by default,
            // which breaks the native drag&drop. If the consumer explicitly made
            // the element draggable, clear the `-webkit-user-drag`.
            if (element.draggable && elementStyle.webkitUserDrag === 'none') {
                elementStyle.webkitUserDrag = '';
            }
        };
        /**
         * Dispose the tooltip when destroyed.
         * @return {?}
         */
        MatTooltip.prototype.ngOnDestroy = function () {
            var _this = this;
            if (this._overlayRef) {
                this._overlayRef.dispose();
                this._tooltipInstance = null;
            }
            // Clean up the event listeners set in the constructor
            this._manualListeners.forEach(( /**
             * @param {?} listener
             * @param {?} event
             * @return {?}
             */function (listener, event) {
                _this._elementRef.nativeElement.removeEventListener(event, listener);
            }));
            this._manualListeners.clear();
            this._destroyed.next();
            this._destroyed.complete();
            this._ariaDescriber.removeDescription(this._elementRef.nativeElement, this.message);
            this._focusMonitor.stopMonitoring(this._elementRef);
        };
        /**
         * Shows the tooltip after the delay in ms, defaults to tooltip-delay-show or 0ms if no input
         * @param {?=} delay
         * @return {?}
         */
        MatTooltip.prototype.show = function (delay) {
            var _this = this;
            if (delay === void 0) { delay = this.showDelay; }
            if (this.disabled || !this.message || (this._isTooltipVisible() &&
                !( /** @type {?} */(this._tooltipInstance))._showTimeoutId && !( /** @type {?} */(this._tooltipInstance))._hideTimeoutId)) {
                return;
            }
            /** @type {?} */
            var overlayRef = this._createOverlay();
            this._detach();
            this._portal = this._portal || new ComponentPortal(TooltipComponent, this._viewContainerRef);
            this._tooltipInstance = overlayRef.attach(this._portal).instance;
            this._tooltipInstance.afterHidden()
                .pipe(takeUntil(this._destroyed))
                .subscribe(( /**
         * @return {?}
         */function () { return _this._detach(); }));
            this._setTooltipClass(this._tooltipClass);
            this._updateTooltipMessage();
            ( /** @type {?} */(this._tooltipInstance)).show(delay);
        };
        /**
         * Hides the tooltip after the delay in ms, defaults to tooltip-delay-hide or 0ms if no input
         * @param {?=} delay
         * @return {?}
         */
        MatTooltip.prototype.hide = function (delay) {
            if (delay === void 0) { delay = this.hideDelay; }
            if (this._tooltipInstance) {
                this._tooltipInstance.hide(delay);
            }
        };
        /**
         * Shows/hides the tooltip
         * @return {?}
         */
        MatTooltip.prototype.toggle = function () {
            this._isTooltipVisible() ? this.hide() : this.show();
        };
        /**
         * Returns true if the tooltip is currently visible to the user
         * @return {?}
         */
        MatTooltip.prototype._isTooltipVisible = function () {
            return !!this._tooltipInstance && this._tooltipInstance.isVisible();
        };
        /**
         * Handles the keydown events on the host element.
         * @param {?} e
         * @return {?}
         */
        MatTooltip.prototype._handleKeydown = function (e) {
            if (this._isTooltipVisible() && e.keyCode === ESCAPE && !hasModifierKey(e)) {
                e.preventDefault();
                e.stopPropagation();
                this.hide(0);
            }
        };
        /**
         * Handles the touchend events on the host element.
         * @return {?}
         */
        MatTooltip.prototype._handleTouchend = function () {
            this.hide(this._defaultOptions.touchendHideDelay);
        };
        /**
         * Create the overlay config and position strategy
         * @private
         * @return {?}
         */
        MatTooltip.prototype._createOverlay = function () {
            var _this = this;
            if (this._overlayRef) {
                return this._overlayRef;
            }
            /** @type {?} */
            var scrollableAncestors = this._scrollDispatcher.getAncestorScrollContainers(this._elementRef);
            // Create connected position strategy that listens for scroll events to reposition.
            /** @type {?} */
            var strategy = this._overlay.position()
                .flexibleConnectedTo(this._elementRef)
                .withTransformOriginOn('.mat-tooltip')
                .withFlexibleDimensions(false)
                .withViewportMargin(8)
                .withScrollableContainers(scrollableAncestors);
            strategy.positionChanges.pipe(takeUntil(this._destroyed)).subscribe(( /**
             * @param {?} change
             * @return {?}
             */function (/**
             * @param {?} change
             * @return {?}
             */ change) {
                if (_this._tooltipInstance) {
                    if (change.scrollableViewProperties.isOverlayClipped && _this._tooltipInstance.isVisible()) {
                        // After position changes occur and the overlay is clipped by
                        // a parent scrollable then close the tooltip.
                        _this._ngZone.run(( /**
                         * @return {?}
                         */function () { return _this.hide(0); }));
                    }
                }
            }));
            this._overlayRef = this._overlay.create({
                direction: this._dir,
                positionStrategy: strategy,
                panelClass: TOOLTIP_PANEL_CLASS,
                scrollStrategy: this._scrollStrategy()
            });
            this._updatePosition();
            this._overlayRef.detachments()
                .pipe(takeUntil(this._destroyed))
                .subscribe(( /**
         * @return {?}
         */function () { return _this._detach(); }));
            return this._overlayRef;
        };
        /**
         * Detaches the currently-attached tooltip.
         * @private
         * @return {?}
         */
        MatTooltip.prototype._detach = function () {
            if (this._overlayRef && this._overlayRef.hasAttached()) {
                this._overlayRef.detach();
            }
            this._tooltipInstance = null;
        };
        /**
         * Updates the position of the current tooltip.
         * @private
         * @return {?}
         */
        MatTooltip.prototype._updatePosition = function () {
            /** @type {?} */
            var position = ( /** @type {?} */(( /** @type {?} */(this._overlayRef)).getConfig().positionStrategy));
            /** @type {?} */
            var origin = this._getOrigin();
            /** @type {?} */
            var overlay = this._getOverlayPosition();
            position.withPositions([
                Object.assign({}, origin.main, overlay.main),
                Object.assign({}, origin.fallback, overlay.fallback)
            ]);
        };
        /**
         * Returns the origin position and a fallback position based on the user's position preference.
         * The fallback position is the inverse of the origin (e.g. `'below' -> 'above'`).
         * @return {?}
         */
        MatTooltip.prototype._getOrigin = function () {
            /** @type {?} */
            var isLtr = !this._dir || this._dir.value == 'ltr';
            /** @type {?} */
            var position = this.position;
            /** @type {?} */
            var originPosition;
            if (position == 'above' || position == 'below') {
                originPosition = { originX: 'center', originY: position == 'above' ? 'top' : 'bottom' };
            }
            else if (position == 'before' ||
                (position == 'left' && isLtr) ||
                (position == 'right' && !isLtr)) {
                originPosition = { originX: 'start', originY: 'center' };
            }
            else if (position == 'after' ||
                (position == 'right' && isLtr) ||
                (position == 'left' && !isLtr)) {
                originPosition = { originX: 'end', originY: 'center' };
            }
            else {
                throw getMatTooltipInvalidPositionError(position);
            }
            var _b = this._invertPosition(originPosition.originX, originPosition.originY), x = _b.x, y = _b.y;
            return {
                main: originPosition,
                fallback: { originX: x, originY: y }
            };
        };
        /**
         * Returns the overlay position and a fallback position based on the user's preference
         * @return {?}
         */
        MatTooltip.prototype._getOverlayPosition = function () {
            /** @type {?} */
            var isLtr = !this._dir || this._dir.value == 'ltr';
            /** @type {?} */
            var position = this.position;
            /** @type {?} */
            var overlayPosition;
            if (position == 'above') {
                overlayPosition = { overlayX: 'center', overlayY: 'bottom' };
            }
            else if (position == 'below') {
                overlayPosition = { overlayX: 'center', overlayY: 'top' };
            }
            else if (position == 'before' ||
                (position == 'left' && isLtr) ||
                (position == 'right' && !isLtr)) {
                overlayPosition = { overlayX: 'end', overlayY: 'center' };
            }
            else if (position == 'after' ||
                (position == 'right' && isLtr) ||
                (position == 'left' && !isLtr)) {
                overlayPosition = { overlayX: 'start', overlayY: 'center' };
            }
            else {
                throw getMatTooltipInvalidPositionError(position);
            }
            var _b = this._invertPosition(overlayPosition.overlayX, overlayPosition.overlayY), x = _b.x, y = _b.y;
            return {
                main: overlayPosition,
                fallback: { overlayX: x, overlayY: y }
            };
        };
        /**
         * Updates the tooltip message and repositions the overlay according to the new message length
         * @private
         * @return {?}
         */
        MatTooltip.prototype._updateTooltipMessage = function () {
            var _this = this;
            // Must wait for the message to be painted to the tooltip so that the overlay can properly
            // calculate the correct positioning based on the size of the text.
            if (this._tooltipInstance) {
                this._tooltipInstance.message = this.message;
                this._tooltipInstance._markForCheck();
                this._ngZone.onMicrotaskEmpty.asObservable().pipe(take(1), takeUntil(this._destroyed)).subscribe(( /**
                 * @return {?}
                 */function () {
                    if (_this._tooltipInstance) {
                        ( /** @type {?} */(_this._overlayRef)).updatePosition();
                    }
                }));
            }
        };
        /**
         * Updates the tooltip class
         * @private
         * @param {?} tooltipClass
         * @return {?}
         */
        MatTooltip.prototype._setTooltipClass = function (tooltipClass) {
            if (this._tooltipInstance) {
                this._tooltipInstance.tooltipClass = tooltipClass;
                this._tooltipInstance._markForCheck();
            }
        };
        /**
         * Inverts an overlay position.
         * @private
         * @param {?} x
         * @param {?} y
         * @return {?}
         */
        MatTooltip.prototype._invertPosition = function (x, y) {
            if (this.position === 'above' || this.position === 'below') {
                if (y === 'top') {
                    y = 'bottom';
                }
                else if (y === 'bottom') {
                    y = 'top';
                }
            }
            else {
                if (x === 'end') {
                    x = 'start';
                }
                else if (x === 'start') {
                    x = 'end';
                }
            }
            return { x: x, y: y };
        };
        return MatTooltip;
    }());
    MatTooltip.decorators = [
        { type: Directive, args: [{
                    selector: '[matTooltip]',
                    exportAs: 'matTooltip',
                    host: {
                        '(longpress)': 'show()',
                        '(keydown)': '_handleKeydown($event)',
                        '(touchend)': '_handleTouchend()',
                    },
                },] },
    ];
    /** @nocollapse */
    MatTooltip.ctorParameters = function () { return [
        { type: Overlay },
        { type: ElementRef },
        { type: ScrollDispatcher },
        { type: ViewContainerRef },
        { type: NgZone },
        { type: Platform },
        { type: AriaDescriber },
        { type: FocusMonitor },
        { type: undefined, decorators: [{ type: Inject, args: [MAT_TOOLTIP_SCROLL_STRATEGY,] }] },
        { type: Directionality, decorators: [{ type: Optional }] },
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [MAT_TOOLTIP_DEFAULT_OPTIONS,] }] },
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [HAMMER_LOADER,] }] }
    ]; };
    MatTooltip.propDecorators = {
        position: [{ type: Input, args: ['matTooltipPosition',] }],
        disabled: [{ type: Input, args: ['matTooltipDisabled',] }],
        showDelay: [{ type: Input, args: ['matTooltipShowDelay',] }],
        hideDelay: [{ type: Input, args: ['matTooltipHideDelay',] }],
        message: [{ type: Input, args: ['matTooltip',] }],
        tooltipClass: [{ type: Input, args: ['matTooltipClass',] }]
    };
    /**
     * Internal component that wraps the tooltip's content.
     * \@docs-private
     */
    var TooltipComponent = /** @class */ (function () {
        /**
         * @param {?} _changeDetectorRef
         * @param {?} _breakpointObserver
         */
        function TooltipComponent(_changeDetectorRef, _breakpointObserver) {
            this._changeDetectorRef = _changeDetectorRef;
            this._breakpointObserver = _breakpointObserver;
            /**
             * Property watched by the animation framework to show or hide the tooltip
             */
            this._visibility = 'initial';
            /**
             * Whether interactions on the page should close the tooltip
             */
            this._closeOnInteraction = false;
            /**
             * Subject for notifying that the tooltip has been hidden from the view
             */
            this._onHide = new Subject();
            /**
             * Stream that emits whether the user has a handset-sized display.
             */
            this._isHandset = this._breakpointObserver.observe(Breakpoints.Handset);
        }
        /**
         * Shows the tooltip with an animation originating from the provided origin
         * @param {?} delay Amount of milliseconds to the delay showing the tooltip.
         * @return {?}
         */
        TooltipComponent.prototype.show = function (delay) {
            var _this = this;
            // Cancel the delayed hide if it is scheduled
            if (this._hideTimeoutId) {
                clearTimeout(this._hideTimeoutId);
                this._hideTimeoutId = null;
            }
            // Body interactions should cancel the tooltip if there is a delay in showing.
            this._closeOnInteraction = true;
            this._showTimeoutId = setTimeout(( /**
             * @return {?}
             */function () {
                _this._visibility = 'visible';
                _this._showTimeoutId = null;
                // Mark for check so if any parent component has set the
                // ChangeDetectionStrategy to OnPush it will be checked anyways
                _this._markForCheck();
            }), delay);
        };
        /**
         * Begins the animation to hide the tooltip after the provided delay in ms.
         * @param {?} delay Amount of milliseconds to delay showing the tooltip.
         * @return {?}
         */
        TooltipComponent.prototype.hide = function (delay) {
            var _this = this;
            // Cancel the delayed show if it is scheduled
            if (this._showTimeoutId) {
                clearTimeout(this._showTimeoutId);
                this._showTimeoutId = null;
            }
            this._hideTimeoutId = setTimeout(( /**
             * @return {?}
             */function () {
                _this._visibility = 'hidden';
                _this._hideTimeoutId = null;
                // Mark for check so if any parent component has set the
                // ChangeDetectionStrategy to OnPush it will be checked anyways
                _this._markForCheck();
            }), delay);
        };
        /**
         * Returns an observable that notifies when the tooltip has been hidden from view.
         * @return {?}
         */
        TooltipComponent.prototype.afterHidden = function () {
            return this._onHide.asObservable();
        };
        /**
         * Whether the tooltip is being displayed.
         * @return {?}
         */
        TooltipComponent.prototype.isVisible = function () {
            return this._visibility === 'visible';
        };
        /**
         * @return {?}
         */
        TooltipComponent.prototype.ngOnDestroy = function () {
            this._onHide.complete();
        };
        /**
         * @return {?}
         */
        TooltipComponent.prototype._animationStart = function () {
            this._closeOnInteraction = false;
        };
        /**
         * @param {?} event
         * @return {?}
         */
        TooltipComponent.prototype._animationDone = function (event) {
            /** @type {?} */
            var toState = ( /** @type {?} */(event.toState));
            if (toState === 'hidden' && !this.isVisible()) {
                this._onHide.next();
            }
            if (toState === 'visible' || toState === 'hidden') {
                this._closeOnInteraction = true;
            }
        };
        /**
         * Interactions on the HTML body should close the tooltip immediately as defined in the
         * material design spec.
         * https://material.io/design/components/tooltips.html#behavior
         * @return {?}
         */
        TooltipComponent.prototype._handleBodyInteraction = function () {
            if (this._closeOnInteraction) {
                this.hide(0);
            }
        };
        /**
         * Marks that the tooltip needs to be checked in the next change detection run.
         * Mainly used for rendering the initial text before positioning a tooltip, which
         * can be problematic in components with OnPush change detection.
         * @return {?}
         */
        TooltipComponent.prototype._markForCheck = function () {
            this._changeDetectorRef.markForCheck();
        };
        return TooltipComponent;
    }());
    TooltipComponent.decorators = [
        { type: Component, args: [{ selector: 'mat-tooltip-component',
                    template: "<div class=\"mat-tooltip\" [ngClass]=\"tooltipClass\" [class.mat-tooltip-handset]=\"(_isHandset | async)?.matches\" [@state]=\"_visibility\" (@state.start)=\"_animationStart()\" (@state.done)=\"_animationDone($event)\">{{message}}</div>",
                    styles: [".mat-tooltip-panel{pointer-events:none!important}.mat-tooltip{color:#fff;border-radius:4px;margin:14px;max-width:250px;padding-left:8px;padding-right:8px;overflow:hidden;text-overflow:ellipsis}@media (-ms-high-contrast:active){.mat-tooltip{outline:solid 1px}}.mat-tooltip-handset{margin:24px;padding-left:16px;padding-right:16px}"],
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    animations: [matTooltipAnimations.tooltipState],
                    host: {
                        // Forces the element to have a layout in IE and Edge. This fixes issues where the element
                        // won't be rendered if the animations are disabled or there is no web animations polyfill.
                        '[style.zoom]': '_visibility === "visible" ? 1 : null',
                        '(body:click)': 'this._handleBodyInteraction()',
                        'aria-hidden': 'true',
                    }
                },] },
    ];
    /** @nocollapse */
    TooltipComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef },
        { type: BreakpointObserver }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatTooltipModule = /** @class */ (function () {
        function MatTooltipModule() {
        }
        return MatTooltipModule;
    }());
    MatTooltipModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        A11yModule,
                        CommonModule,
                        OverlayModule,
                        MatCommonModule,
                    ],
                    exports: [MatTooltip, TooltipComponent, MatCommonModule],
                    declarations: [MatTooltip, TooltipComponent],
                    entryComponents: [TooltipComponent],
                    providers: [
                        MAT_TOOLTIP_SCROLL_STRATEGY_FACTORY_PROVIDER,
                        { provide: HAMMER_GESTURE_CONFIG, useClass: GestureConfig },
                    ]
                },] },
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A capture profile dialog module.
     */
    var CaptureProfileDialogModule = /** @class */ (function () {
        function CaptureProfileDialogModule() {
        }
        return CaptureProfileDialogModule;
    }());
    CaptureProfileDialogModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [CaptureProfileDialog],
                    imports: [
                        BrowserModule,
                        CommonModule,
                        FormsModule,
                        MatButtonModule,
                        MatDialogModule,
                        MatExpansionModule,
                        MatFormFieldModule,
                        MatInputModule,
                        MatRadioModule,
                        MatSelectModule,
                        MatTooltipModule,
                    ],
                    exports: [CaptureProfileDialog]
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A capture profile view module.
     */
    var CaptureProfileModule = /** @class */ (function () {
        function CaptureProfileModule() {
        }
        return CaptureProfileModule;
    }());
    CaptureProfileModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [CaptureProfile],
                    imports: [
                        CommonModule,
                        MatButtonModule,
                        MatDialogModule,
                        MatProgressSpinnerModule,
                        CaptureProfileDialogModule,
                        MatSnackBarModule,
                    ],
                    exports: [CaptureProfile],
                    entryComponents: [CaptureProfileDialog],
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * An empty page component.
     */
    var EmptyPage = /** @class */ (function () {
        function EmptyPage() {
            this.inColab = !!(window.parent.TENSORBOARD_ENV || {}).IN_COLAB;
        }
        return EmptyPage;
    }());
    EmptyPage.decorators = [
        { type: Component, args: [{
                    selector: 'empty-page',
                    template: "<div *ngIf=\"inColab; else no_profile_data\" class=\"container\">\n  <h3>Profiling isn't supported in Colab yet.</h3>\n  <p>\n    Please see\n    <a href=\"https://github.com/tensorflow/tensorboard/issues/1913\" rel=\"noopener\" target=\"_blank\"\n      >GitHub issue #1913</a\n    >\n    for more information.\n  </p>\n</div>\n\n<ng-template #no_profile_data>\n  <div class=\"container\">\n    <h3>No profile data was found.</h3>\n    <div class=\"horizontal-center\">\n      <capture-profile></capture-profile>\n    </div>\n\n    <p>\n      If you have a model running on CPU, GPU, or Google Cloud TPU, you may be able to use the\n      above button to capture a profile.\n    </p>\n\n    <p>\n      If you're a CPU or GPU user, please use the IP address option. You may want to check out the\n      <a\n        href=\"https://colab.research.google.com/github/tensorflow/tensorboard/blob/master/docs/tensorboard_profiling_keras.ipynb\"\n        rel=\"noopener\"\n        target=\"_blank\"\n        >tutorial</a\n      >\n      on how to start a TensorFlow profiler server and profile a Keras model on a GPU.\n    </p>\n\n    <p>\n      If you're a TPU user, please use the TPU name option and you may want to check out the\n      <a href=\"https://cloud.google.com/tpu/docs/cloud-tpu-tools\" rel=\"noopener\" target=\"_blank\"\n        >tutorial</a\n      >\n      on how to interpreting the profiling results.\n    </p>\n\n    <p>\n      If you think profiling is done properly, please see the page of\n      <a href=\"https://cloud.google.com/tpu/docs/troubleshooting\" rel=\"noopener\" target=\"_blank\"\n        >Google Cloud TPU Troubleshooting and FAQ</a\n      >\n      and consider filing an issue on GitHub.\n    </p>\n  </div>\n</ng-template>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}:host{display:block}.container{max-width:540px;margin:80px auto 0 auto}\n"]
                }] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * An empty page module.
     */
    var EmptyPageModule = /** @class */ (function () {
        function EmptyPageModule() {
        }
        return EmptyPageModule;
    }());
    EmptyPageModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [EmptyPage],
                    imports: [
                        CommonModule,
                        CaptureProfileModule,
                    ],
                    exports: [EmptyPage]
                },] }
    ];
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Animations used by the Material drawers.
     * \@docs-private
     * @type {?}
     */
    var matDrawerAnimations = {
        /**
         * Animation that slides a drawer in and out.
         */
        transformDrawer: trigger('transform', [
            // We remove the `transform` here completely, rather than setting it to zero, because:
            // 1. Having a transform can cause elements with ripples or an animated
            //    transform to shift around in Chrome with an RTL layout (see #10023).
            // 2. 3d transforms causes text to appear blurry on IE and Edge.
            state('open, open-instant', style({
                'transform': 'none',
                'visibility': 'visible',
            })),
            state('void', style({
                // Avoids the shadow showing up when closed in SSR.
                'box-shadow': 'none',
                'visibility': 'hidden',
            })),
            transition('void => open-instant', animate('0ms')),
            transition('void <=> open, open-instant => void', animate('400ms cubic-bezier(0.25, 0.8, 0.25, 1)'))
        ])
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Throws an exception when two MatDrawer are matching the same position.
     * \@docs-private
     * @param {?} position
     * @return {?}
     */
    function throwMatDuplicatedDrawerError(position) {
        throw Error("A drawer was already declared for 'position=\"" + position + "\"'");
    }
    /**
     * Configures whether drawers should use auto sizing by default.
     * @type {?}
     */
    var MAT_DRAWER_DEFAULT_AUTOSIZE = new InjectionToken('MAT_DRAWER_DEFAULT_AUTOSIZE', {
        providedIn: 'root',
        factory: MAT_DRAWER_DEFAULT_AUTOSIZE_FACTORY,
    });
    /**
     * \@docs-private
     * @return {?}
     */
    function MAT_DRAWER_DEFAULT_AUTOSIZE_FACTORY() {
        return false;
    }
    var MatDrawerContent = /** @class */ (function (_super) {
        __extends(MatDrawerContent, _super);
        /**
         * @param {?} _changeDetectorRef
         * @param {?} _container
         * @param {?} elementRef
         * @param {?} scrollDispatcher
         * @param {?} ngZone
         */
        function MatDrawerContent(_changeDetectorRef, _container, elementRef, scrollDispatcher, ngZone) {
            var _this = _super.call(this, elementRef, scrollDispatcher, ngZone) || this;
            _this._changeDetectorRef = _changeDetectorRef;
            _this._container = _container;
            return _this;
        }
        /**
         * @return {?}
         */
        MatDrawerContent.prototype.ngAfterContentInit = function () {
            var _this = this;
            this._container._contentMarginChanges.subscribe(( /**
             * @return {?}
             */function () {
                _this._changeDetectorRef.markForCheck();
            }));
        };
        return MatDrawerContent;
    }(CdkScrollable));
    MatDrawerContent.decorators = [
        { type: Component, args: [{ selector: 'mat-drawer-content',
                    template: '<ng-content></ng-content>',
                    host: {
                        'class': 'mat-drawer-content',
                        '[style.margin-left.px]': '_container._contentMargins.left',
                        '[style.margin-right.px]': '_container._contentMargins.right',
                    },
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                },] },
    ];
    /** @nocollapse */
    MatDrawerContent.ctorParameters = function () { return [
        { type: ChangeDetectorRef },
        { type: MatDrawerContainer, decorators: [{ type: Inject, args: [forwardRef(( /**
                                         * @return {?}
                                         */function () { return MatDrawerContainer; })),] }] },
        { type: ElementRef },
        { type: ScrollDispatcher },
        { type: NgZone }
    ]; };
    /**
     * This component corresponds to a drawer that can be opened on the drawer container.
     */
    var MatDrawer = /** @class */ (function () {
        /**
         * @param {?} _elementRef
         * @param {?} _focusTrapFactory
         * @param {?} _focusMonitor
         * @param {?} _platform
         * @param {?} _ngZone
         * @param {?} _doc
         */
        function MatDrawer(_elementRef, _focusTrapFactory, _focusMonitor, _platform, _ngZone, _doc) {
            var _this = this;
            this._elementRef = _elementRef;
            this._focusTrapFactory = _focusTrapFactory;
            this._focusMonitor = _focusMonitor;
            this._platform = _platform;
            this._ngZone = _ngZone;
            this._doc = _doc;
            this._elementFocusedBeforeDrawerWasOpened = null;
            /**
             * Whether the drawer is initialized. Used for disabling the initial animation.
             */
            this._enableAnimations = false;
            this._position = 'start';
            this._mode = 'over';
            this._disableClose = false;
            this._autoFocus = true;
            /**
             * Emits whenever the drawer has started animating.
             */
            this._animationStarted = new Subject();
            /**
             * Emits whenever the drawer is done animating.
             */
            this._animationEnd = new Subject();
            /**
             * Current state of the sidenav animation.
             */
            // @HostBinding is used in the class as it is expected to be extended.  Since @Component decorator
            // metadata is not inherited by child classes, instead the host binding data is defined in a way
            // that can be inherited.
            // tslint:disable:no-host-decorator-in-concrete
            this._animationState = 'void';
            /**
             * Event emitted when the drawer open state is changed.
             */
            this.openedChange =
                // Note this has to be async in order to avoid some issues with two-bindings (see #8872).
                new EventEmitter(/* isAsync */ true);
            /**
             * Emits when the component is destroyed.
             */
            this._destroyed = new Subject();
            /**
             * Event emitted when the drawer's position changes.
             */
            // tslint:disable-next-line:no-output-on-prefix
            this.onPositionChanged = new EventEmitter();
            /**
             * An observable that emits when the drawer mode changes. This is used by the drawer container to
             * to know when to when the mode changes so it can adapt the margins on the content.
             */
            this._modeChanged = new Subject();
            this._opened = false;
            this.openedChange.subscribe(( /**
             * @param {?} opened
             * @return {?}
             */function (opened) {
                if (opened) {
                    if (_this._doc) {
                        _this._elementFocusedBeforeDrawerWasOpened = ( /** @type {?} */(_this._doc.activeElement));
                    }
                    if (_this._isFocusTrapEnabled && _this._focusTrap) {
                        _this._trapFocus();
                    }
                }
                else {
                    _this._restoreFocus();
                }
            }));
            /**
             * Listen to `keydown` events outside the zone so that change detection is not run every
             * time a key is pressed. Instead we re-enter the zone only if the `ESC` key is pressed
             * and we don't have close disabled.
             */
            this._ngZone.runOutsideAngular(( /**
             * @return {?}
             */function () {
                (( /** @type {?} */(fromEvent(_this._elementRef.nativeElement, 'keydown')))).pipe(filter(( /**
                 * @param {?} event
                 * @return {?}
                 */function (/**
                 * @param {?} event
                 * @return {?}
                 */ event) {
                    return event.keyCode === ESCAPE && !_this.disableClose && !hasModifierKey(event);
                })), takeUntil(_this._destroyed)).subscribe(( /**
                 * @param {?} event
                 * @return {?}
                 */function (/**
                 * @param {?} event
                 * @return {?}
                 */ event) { return _this._ngZone.run(( /**
                 * @return {?}
                 */function () {
                    _this.close();
                    event.stopPropagation();
                    event.preventDefault();
                })); }));
            }));
            // We need a Subject with distinctUntilChanged, because the `done` event
            // fires twice on some browsers. See https://github.com/angular/angular/issues/24084
            this._animationEnd.pipe(distinctUntilChanged(( /**
             * @param {?} x
             * @param {?} y
             * @return {?}
             */function (x, y) {
                return x.fromState === y.fromState && x.toState === y.toState;
            }))).subscribe(( /**
             * @param {?} event
             * @return {?}
             */function (event) {
                var fromState = event.fromState, toState = event.toState;
                if ((toState.indexOf('open') === 0 && fromState === 'void') ||
                    (toState === 'void' && fromState.indexOf('open') === 0)) {
                    _this.openedChange.emit(_this._opened);
                }
            }));
        }
        Object.defineProperty(MatDrawer.prototype, "position", {
            /**
             * The side that the drawer is attached to.
             * @return {?}
             */
            get: function () { return this._position; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                // Make sure we have a valid value.
                value = value === 'end' ? 'end' : 'start';
                if (value != this._position) {
                    this._position = value;
                    this.onPositionChanged.emit();
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatDrawer.prototype, "mode", {
            /**
             * Mode of the drawer; one of 'over', 'push' or 'side'.
             * @return {?}
             */
            get: function () { return this._mode; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._mode = value;
                this._updateFocusTrapState();
                this._modeChanged.next();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatDrawer.prototype, "disableClose", {
            /**
             * Whether the drawer can be closed with the escape key or by clicking on the backdrop.
             * @return {?}
             */
            get: function () { return this._disableClose; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this._disableClose = coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatDrawer.prototype, "autoFocus", {
            /**
             * Whether the drawer should focus the first focusable element automatically when opened.
             * @return {?}
             */
            get: function () { return this._autoFocus; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this._autoFocus = coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatDrawer.prototype, "_openedStream", {
            /**
             * Event emitted when the drawer has been opened.
             * @return {?}
             */
            get: function () {
                return this.openedChange.pipe(filter(( /**
                 * @param {?} o
                 * @return {?}
                 */function (/**
                 * @param {?} o
                 * @return {?}
                 */ o) { return o; })), map(( /**
                 * @return {?}
                 */function () { })));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatDrawer.prototype, "openedStart", {
            /**
             * Event emitted when the drawer has started opening.
             * @return {?}
             */
            get: function () {
                return this._animationStarted.pipe(filter(( /**
                 * @param {?} e
                 * @return {?}
                 */function (/**
                 * @param {?} e
                 * @return {?}
                 */ e) { return e.fromState !== e.toState && e.toState.indexOf('open') === 0; })), map(( /**
                 * @return {?}
                 */function () { })));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatDrawer.prototype, "_closedStream", {
            /**
             * Event emitted when the drawer has been closed.
             * @return {?}
             */
            get: function () {
                return this.openedChange.pipe(filter(( /**
                 * @param {?} o
                 * @return {?}
                 */function (/**
                 * @param {?} o
                 * @return {?}
                 */ o) { return !o; })), map(( /**
                 * @return {?}
                 */function () { })));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatDrawer.prototype, "closedStart", {
            /**
             * Event emitted when the drawer has started closing.
             * @return {?}
             */
            get: function () {
                return this._animationStarted.pipe(filter(( /**
                 * @param {?} e
                 * @return {?}
                 */function (/**
                 * @param {?} e
                 * @return {?}
                 */ e) { return e.fromState !== e.toState && e.toState === 'void'; })), map(( /**
                 * @return {?}
                 */function () { })));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatDrawer.prototype, "_isFocusTrapEnabled", {
            /**
             * @return {?}
             */
            get: function () {
                // The focus trap is only enabled when the drawer is open in any mode other than side.
                return this.opened && this.mode !== 'side';
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Traps focus inside the drawer.
         * @private
         * @return {?}
         */
        MatDrawer.prototype._trapFocus = function () {
            var _this = this;
            if (!this.autoFocus) {
                return;
            }
            this._focusTrap.focusInitialElementWhenReady().then(( /**
             * @param {?} hasMovedFocus
             * @return {?}
             */function (/**
             * @param {?} hasMovedFocus
             * @return {?}
             */ hasMovedFocus) {
                // If there were no focusable elements, focus the sidenav itself so the keyboard navigation
                // still works. We need to check that `focus` is a function due to Universal.
                if (!hasMovedFocus && typeof _this._elementRef.nativeElement.focus === 'function') {
                    _this._elementRef.nativeElement.focus();
                }
            }));
        };
        /**
         * If focus is currently inside the drawer, restores it to where it was before the drawer
         * opened.
         * @private
         * @return {?}
         */
        MatDrawer.prototype._restoreFocus = function () {
            if (!this.autoFocus) {
                return;
            }
            /** @type {?} */
            var activeEl = this._doc && this._doc.activeElement;
            if (activeEl && this._elementRef.nativeElement.contains(activeEl)) {
                if (this._elementFocusedBeforeDrawerWasOpened instanceof HTMLElement) {
                    this._focusMonitor.focusVia(this._elementFocusedBeforeDrawerWasOpened, this._openedVia);
                }
                else {
                    this._elementRef.nativeElement.blur();
                }
            }
            this._elementFocusedBeforeDrawerWasOpened = null;
            this._openedVia = null;
        };
        /**
         * @return {?}
         */
        MatDrawer.prototype.ngAfterContentInit = function () {
            this._focusTrap = this._focusTrapFactory.create(this._elementRef.nativeElement);
            this._updateFocusTrapState();
        };
        /**
         * @return {?}
         */
        MatDrawer.prototype.ngAfterContentChecked = function () {
            // Enable the animations after the lifecycle hooks have run, in order to avoid animating
            // drawers that are open by default. When we're on the server, we shouldn't enable the
            // animations, because we don't want the drawer to animate the first time the user sees
            // the page.
            if (this._platform.isBrowser) {
                this._enableAnimations = true;
            }
        };
        /**
         * @return {?}
         */
        MatDrawer.prototype.ngOnDestroy = function () {
            if (this._focusTrap) {
                this._focusTrap.destroy();
            }
            this._animationStarted.complete();
            this._animationEnd.complete();
            this._modeChanged.complete();
            this._destroyed.next();
            this._destroyed.complete();
        };
        Object.defineProperty(MatDrawer.prototype, "opened", {
            /**
             * Whether the drawer is opened. We overload this because we trigger an event when it
             * starts or end.
             * @return {?}
             */
            get: function () { return this._opened; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this.toggle(coerceBooleanProperty(value)); },
            enumerable: true,
            configurable: true
        });
        /**
         * Open the drawer.
         * @param {?=} openedVia Whether the drawer was opened by a key press, mouse click or programmatically.
         * Used for focus management after the sidenav is closed.
         * @return {?}
         */
        MatDrawer.prototype.open = function (openedVia) {
            return this.toggle(true, openedVia);
        };
        /**
         * Close the drawer.
         * @return {?}
         */
        MatDrawer.prototype.close = function () {
            return this.toggle(false);
        };
        /**
         * Toggle this drawer.
         * @param {?=} isOpen Whether the drawer should be open.
         * @param {?=} openedVia Whether the drawer was opened by a key press, mouse click or programmatically.
         * Used for focus management after the sidenav is closed.
         * @return {?}
         */
        MatDrawer.prototype.toggle = function (isOpen, openedVia) {
            var _this = this;
            if (isOpen === void 0) { isOpen = !this.opened; }
            if (openedVia === void 0) { openedVia = 'program'; }
            this._opened = isOpen;
            if (isOpen) {
                this._animationState = this._enableAnimations ? 'open' : 'open-instant';
                this._openedVia = openedVia;
            }
            else {
                this._animationState = 'void';
                this._restoreFocus();
            }
            this._updateFocusTrapState();
            return new Promise(( /**
             * @param {?} resolve
             * @return {?}
             */function (/**
             * @param {?} resolve
             * @return {?}
             */ resolve) {
                _this.openedChange.pipe(take(1)).subscribe(( /**
                 * @param {?} open
                 * @return {?}
                 */function (/**
                 * @param {?} open
                 * @return {?}
                 */ open) { return resolve(open ? 'open' : 'close'); }));
            }));
        };
        Object.defineProperty(MatDrawer.prototype, "_width", {
            /**
             * @return {?}
             */
            get: function () {
                return this._elementRef.nativeElement ? (this._elementRef.nativeElement.offsetWidth || 0) : 0;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Updates the enabled state of the focus trap.
         * @private
         * @return {?}
         */
        MatDrawer.prototype._updateFocusTrapState = function () {
            if (this._focusTrap) {
                this._focusTrap.enabled = this._isFocusTrapEnabled;
            }
        };
        // We have to use a `HostListener` here in order to support both Ivy and ViewEngine.
        // In Ivy the `host` bindings will be merged when this class is extended, whereas in
        // ViewEngine they're overwritten.
        // TODO(crisbeto): we move this back into `host` once Ivy is turned on by default.
        // tslint:disable-next-line:no-host-decorator-in-concrete
        /**
         * @param {?} event
         * @return {?}
         */
        MatDrawer.prototype._animationStartListener = function (event) {
            this._animationStarted.next(event);
        };
        // We have to use a `HostListener` here in order to support both Ivy and ViewEngine.
        // In Ivy the `host` bindings will be merged when this class is extended, whereas in
        // ViewEngine they're overwritten.
        // TODO(crisbeto): we move this back into `host` once Ivy is turned on by default.
        // tslint:disable-next-line:no-host-decorator-in-concrete
        /**
         * @param {?} event
         * @return {?}
         */
        MatDrawer.prototype._animationDoneListener = function (event) {
            this._animationEnd.next(event);
        };
        return MatDrawer;
    }());
    MatDrawer.decorators = [
        { type: Component, args: [{ selector: 'mat-drawer',
                    exportAs: 'matDrawer',
                    template: "<div class=\"mat-drawer-inner-container\"><ng-content></ng-content></div>",
                    animations: [matDrawerAnimations.transformDrawer],
                    host: {
                        'class': 'mat-drawer',
                        // must prevent the browser from aligning text based on value
                        '[attr.align]': 'null',
                        '[class.mat-drawer-end]': 'position === "end"',
                        '[class.mat-drawer-over]': 'mode === "over"',
                        '[class.mat-drawer-push]': 'mode === "push"',
                        '[class.mat-drawer-side]': 'mode === "side"',
                        '[class.mat-drawer-opened]': 'opened',
                        'tabIndex': '-1',
                    },
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                },] },
    ];
    /** @nocollapse */
    MatDrawer.ctorParameters = function () { return [
        { type: ElementRef },
        { type: FocusTrapFactory },
        { type: FocusMonitor },
        { type: Platform },
        { type: NgZone },
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [DOCUMENT,] }] }
    ]; };
    MatDrawer.propDecorators = {
        position: [{ type: Input }],
        mode: [{ type: Input }],
        disableClose: [{ type: Input }],
        autoFocus: [{ type: Input }],
        _animationState: [{ type: HostBinding, args: ['@transform',] }],
        openedChange: [{ type: Output }],
        _openedStream: [{ type: Output, args: ['opened',] }],
        openedStart: [{ type: Output }],
        _closedStream: [{ type: Output, args: ['closed',] }],
        closedStart: [{ type: Output }],
        onPositionChanged: [{ type: Output, args: ['positionChanged',] }],
        opened: [{ type: Input }],
        _animationStartListener: [{ type: HostListener, args: ['@transform.start', ['$event'],] }],
        _animationDoneListener: [{ type: HostListener, args: ['@transform.done', ['$event'],] }]
    };
    /**
     * `<mat-drawer-container>` component.
     *
     * This is the parent component to one or two `<mat-drawer>`s that validates the state internally
     * and coordinates the backdrop and content styling.
     */
    var MatDrawerContainer = /** @class */ (function () {
        /**
         * @param {?} _dir
         * @param {?} _element
         * @param {?} _ngZone
         * @param {?} _changeDetectorRef
         * @param {?} viewportRuler
         * @param {?=} defaultAutosize
         * @param {?=} _animationMode
         */
        function MatDrawerContainer(_dir, _element, _ngZone, _changeDetectorRef, viewportRuler, defaultAutosize, _animationMode) {
            if (defaultAutosize === void 0) { defaultAutosize = false; }
            var _this = this;
            this._dir = _dir;
            this._element = _element;
            this._ngZone = _ngZone;
            this._changeDetectorRef = _changeDetectorRef;
            this._animationMode = _animationMode;
            /**
             * Event emitted when the drawer backdrop is clicked.
             */
            this.backdropClick = new EventEmitter();
            /**
             * Emits when the component is destroyed.
             */
            this._destroyed = new Subject();
            /**
             * Emits on every ngDoCheck. Used for debouncing reflows.
             */
            this._doCheckSubject = new Subject();
            /**
             * Margins to be applied to the content. These are used to push / shrink the drawer content when a
             * drawer is open. We use margin rather than transform even for push mode because transform breaks
             * fixed position elements inside of the transformed element.
             */
            this._contentMargins = { left: null, right: null };
            this._contentMarginChanges = new Subject();
            // If a `Dir` directive exists up the tree, listen direction changes
            // and update the left/right properties to point to the proper start/end.
            if (_dir) {
                _dir.change.pipe(takeUntil(this._destroyed)).subscribe(( /**
                 * @return {?}
                 */function () {
                    _this._validateDrawers();
                    _this.updateContentMargins();
                }));
            }
            // Since the minimum width of the sidenav depends on the viewport width,
            // we need to recompute the margins if the viewport changes.
            viewportRuler.change()
                .pipe(takeUntil(this._destroyed))
                .subscribe(( /**
         * @return {?}
         */function () { return _this.updateContentMargins(); }));
            this._autosize = defaultAutosize;
        }
        Object.defineProperty(MatDrawerContainer.prototype, "start", {
            /**
             * The drawer child with the `start` position.
             * @return {?}
             */
            get: function () { return this._start; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatDrawerContainer.prototype, "end", {
            /**
             * The drawer child with the `end` position.
             * @return {?}
             */
            get: function () { return this._end; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatDrawerContainer.prototype, "autosize", {
            /**
             * Whether to automatically resize the container whenever
             * the size of any of its drawers changes.
             *
             * **Use at your own risk!** Enabling this option can cause layout thrashing by measuring
             * the drawers on every change detection cycle. Can be configured globally via the
             * `MAT_DRAWER_DEFAULT_AUTOSIZE` token.
             * @return {?}
             */
            get: function () { return this._autosize; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this._autosize = coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatDrawerContainer.prototype, "hasBackdrop", {
            /**
             * Whether the drawer container should have a backdrop while one of the sidenavs is open.
             * If explicitly set to `true`, the backdrop will be enabled for drawers in the `side`
             * mode as well.
             * @return {?}
             */
            get: function () {
                if (this._backdropOverride == null) {
                    return !this._start || this._start.mode !== 'side' || !this._end || this._end.mode !== 'side';
                }
                return this._backdropOverride;
            },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._backdropOverride = value == null ? null : coerceBooleanProperty(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatDrawerContainer.prototype, "scrollable", {
            /**
             * Reference to the CdkScrollable instance that wraps the scrollable content.
             * @return {?}
             */
            get: function () {
                return this._userContent || this._content;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        MatDrawerContainer.prototype.ngAfterContentInit = function () {
            var _this = this;
            this._drawers.changes.pipe(startWith(null)).subscribe(( /**
             * @return {?}
             */function () {
                _this._validateDrawers();
                _this._drawers.forEach(( /**
                 * @param {?} drawer
                 * @return {?}
                 */function (drawer) {
                    _this._watchDrawerToggle(drawer);
                    _this._watchDrawerPosition(drawer);
                    _this._watchDrawerMode(drawer);
                }));
                if (!_this._drawers.length ||
                    _this._isDrawerOpen(_this._start) ||
                    _this._isDrawerOpen(_this._end)) {
                    _this.updateContentMargins();
                }
                _this._changeDetectorRef.markForCheck();
            }));
            this._doCheckSubject.pipe(debounceTime(10), // Arbitrary debounce time, less than a frame at 60fps
            takeUntil(this._destroyed)).subscribe(( /**
             * @return {?}
             */function () { return _this.updateContentMargins(); }));
        };
        /**
         * @return {?}
         */
        MatDrawerContainer.prototype.ngOnDestroy = function () {
            this._contentMarginChanges.complete();
            this._doCheckSubject.complete();
            this._destroyed.next();
            this._destroyed.complete();
        };
        /**
         * Calls `open` of both start and end drawers
         * @return {?}
         */
        MatDrawerContainer.prototype.open = function () {
            this._drawers.forEach(( /**
             * @param {?} drawer
             * @return {?}
             */function (/**
             * @param {?} drawer
             * @return {?}
             */ drawer) { return drawer.open(); }));
        };
        /**
         * Calls `close` of both start and end drawers
         * @return {?}
         */
        MatDrawerContainer.prototype.close = function () {
            this._drawers.forEach(( /**
             * @param {?} drawer
             * @return {?}
             */function (/**
             * @param {?} drawer
             * @return {?}
             */ drawer) { return drawer.close(); }));
        };
        /**
         * Recalculates and updates the inline styles for the content. Note that this should be used
         * sparingly, because it causes a reflow.
         * @return {?}
         */
        MatDrawerContainer.prototype.updateContentMargins = function () {
            var _this = this;
            // 1. For drawers in `over` mode, they don't affect the content.
            // 2. For drawers in `side` mode they should shrink the content. We do this by adding to the
            //    left margin (for left drawer) or right margin (for right the drawer).
            // 3. For drawers in `push` mode the should shift the content without resizing it. We do this by
            //    adding to the left or right margin and simultaneously subtracting the same amount of
            //    margin from the other side.
            /** @type {?} */
            var left = 0;
            /** @type {?} */
            var right = 0;
            if (this._left && this._left.opened) {
                if (this._left.mode == 'side') {
                    left += this._left._width;
                }
                else if (this._left.mode == 'push') {
                    /** @type {?} */
                    var width = this._left._width;
                    left += width;
                    right -= width;
                }
            }
            if (this._right && this._right.opened) {
                if (this._right.mode == 'side') {
                    right += this._right._width;
                }
                else if (this._right.mode == 'push') {
                    /** @type {?} */
                    var width = this._right._width;
                    right += width;
                    left -= width;
                }
            }
            // If either `right` or `left` is zero, don't set a style to the element. This
            // allows users to specify a custom size via CSS class in SSR scenarios where the
            // measured widths will always be zero. Note that we reset to `null` here, rather
            // than below, in order to ensure that the types in the `if` below are consistent.
            left = left || ( /** @type {?} */(null));
            right = right || ( /** @type {?} */(null));
            if (left !== this._contentMargins.left || right !== this._contentMargins.right) {
                this._contentMargins = { left: left, right: right };
                // Pull back into the NgZone since in some cases we could be outside. We need to be careful
                // to do it only when something changed, otherwise we can end up hitting the zone too often.
                this._ngZone.run(( /**
                 * @return {?}
                 */function () { return _this._contentMarginChanges.next(_this._contentMargins); }));
            }
        };
        /**
         * @return {?}
         */
        MatDrawerContainer.prototype.ngDoCheck = function () {
            var _this = this;
            // If users opted into autosizing, do a check every change detection cycle.
            if (this._autosize && this._isPushed()) {
                // Run outside the NgZone, otherwise the debouncer will throw us into an infinite loop.
                this._ngZone.runOutsideAngular(( /**
                 * @return {?}
                 */function () { return _this._doCheckSubject.next(); }));
            }
        };
        /**
         * Subscribes to drawer events in order to set a class on the main container element when the
         * drawer is open and the backdrop is visible. This ensures any overflow on the container element
         * is properly hidden.
         * @private
         * @param {?} drawer
         * @return {?}
         */
        MatDrawerContainer.prototype._watchDrawerToggle = function (drawer) {
            var _this = this;
            drawer._animationStarted.pipe(filter(( /**
             * @param {?} event
             * @return {?}
             */function (event) { return event.fromState !== event.toState; })), takeUntil(this._drawers.changes))
                .subscribe(( /**
         * @param {?} event
         * @return {?}
         */function (event) {
                // Set the transition class on the container so that the animations occur. This should not
                // be set initially because animations should only be triggered via a change in state.
                if (event.toState !== 'open-instant' && _this._animationMode !== 'NoopAnimations') {
                    _this._element.nativeElement.classList.add('mat-drawer-transition');
                }
                _this.updateContentMargins();
                _this._changeDetectorRef.markForCheck();
            }));
            if (drawer.mode !== 'side') {
                drawer.openedChange.pipe(takeUntil(this._drawers.changes)).subscribe(( /**
                 * @return {?}
                 */function () { return _this._setContainerClass(drawer.opened); }));
            }
        };
        /**
         * Subscribes to drawer onPositionChanged event in order to
         * re-validate drawers when the position changes.
         * @private
         * @param {?} drawer
         * @return {?}
         */
        MatDrawerContainer.prototype._watchDrawerPosition = function (drawer) {
            var _this = this;
            if (!drawer) {
                return;
            }
            // NOTE: We need to wait for the microtask queue to be empty before validating,
            // since both drawers may be swapping positions at the same time.
            drawer.onPositionChanged.pipe(takeUntil(this._drawers.changes)).subscribe(( /**
             * @return {?}
             */function () {
                _this._ngZone.onMicrotaskEmpty.asObservable().pipe(take(1)).subscribe(( /**
                 * @return {?}
                 */function () {
                    _this._validateDrawers();
                }));
            }));
        };
        /**
         * Subscribes to changes in drawer mode so we can run change detection.
         * @private
         * @param {?} drawer
         * @return {?}
         */
        MatDrawerContainer.prototype._watchDrawerMode = function (drawer) {
            var _this = this;
            if (drawer) {
                drawer._modeChanged.pipe(takeUntil(merge(this._drawers.changes, this._destroyed)))
                    .subscribe(( /**
             * @return {?}
             */function () {
                    _this.updateContentMargins();
                    _this._changeDetectorRef.markForCheck();
                }));
            }
        };
        /**
         * Toggles the 'mat-drawer-opened' class on the main 'mat-drawer-container' element.
         * @private
         * @param {?} isAdd
         * @return {?}
         */
        MatDrawerContainer.prototype._setContainerClass = function (isAdd) {
            /** @type {?} */
            var classList = this._element.nativeElement.classList;
            /** @type {?} */
            var className = 'mat-drawer-container-has-open';
            if (isAdd) {
                classList.add(className);
            }
            else {
                classList.remove(className);
            }
        };
        /**
         * Validate the state of the drawer children components.
         * @private
         * @return {?}
         */
        MatDrawerContainer.prototype._validateDrawers = function () {
            var _this = this;
            this._start = this._end = null;
            // Ensure that we have at most one start and one end drawer.
            this._drawers.forEach(( /**
             * @param {?} drawer
             * @return {?}
             */function (/**
             * @param {?} drawer
             * @return {?}
             */ drawer) {
                if (drawer.position == 'end') {
                    if (_this._end != null) {
                        throwMatDuplicatedDrawerError('end');
                    }
                    _this._end = drawer;
                }
                else {
                    if (_this._start != null) {
                        throwMatDuplicatedDrawerError('start');
                    }
                    _this._start = drawer;
                }
            }));
            this._right = this._left = null;
            // Detect if we're LTR or RTL.
            if (this._dir && this._dir.value === 'rtl') {
                this._left = this._end;
                this._right = this._start;
            }
            else {
                this._left = this._start;
                this._right = this._end;
            }
        };
        /**
         * Whether the container is being pushed to the side by one of the drawers.
         * @private
         * @return {?}
         */
        MatDrawerContainer.prototype._isPushed = function () {
            return (this._isDrawerOpen(this._start) && this._start.mode != 'over') ||
                (this._isDrawerOpen(this._end) && this._end.mode != 'over');
        };
        /**
         * @return {?}
         */
        MatDrawerContainer.prototype._onBackdropClicked = function () {
            this.backdropClick.emit();
            this._closeModalDrawer();
        };
        /**
         * @return {?}
         */
        MatDrawerContainer.prototype._closeModalDrawer = function () {
            var _this = this;
            // Close all open drawers where closing is not disabled and the mode is not `side`.
            [this._start, this._end]
                .filter(( /**
         * @param {?} drawer
         * @return {?}
         */function (/**
         * @param {?} drawer
         * @return {?}
         */ drawer) { return drawer && !drawer.disableClose && _this._canHaveBackdrop(drawer); }))
                .forEach(( /**
         * @param {?} drawer
         * @return {?}
         */function (/**
         * @param {?} drawer
         * @return {?}
         */ drawer) { return ( /** @type {?} */(drawer)).close(); }));
        };
        /**
         * @return {?}
         */
        MatDrawerContainer.prototype._isShowingBackdrop = function () {
            return (this._isDrawerOpen(this._start) && this._canHaveBackdrop(this._start)) ||
                (this._isDrawerOpen(this._end) && this._canHaveBackdrop(this._end));
        };
        /**
         * @private
         * @param {?} drawer
         * @return {?}
         */
        MatDrawerContainer.prototype._canHaveBackdrop = function (drawer) {
            return drawer.mode !== 'side' || !!this._backdropOverride;
        };
        /**
         * @private
         * @param {?} drawer
         * @return {?}
         */
        MatDrawerContainer.prototype._isDrawerOpen = function (drawer) {
            return drawer != null && drawer.opened;
        };
        return MatDrawerContainer;
    }());
    MatDrawerContainer.decorators = [
        { type: Component, args: [{ selector: 'mat-drawer-container',
                    exportAs: 'matDrawerContainer',
                    template: "<div class=\"mat-drawer-backdrop\" (click)=\"_onBackdropClicked()\" *ngIf=\"hasBackdrop\" [class.mat-drawer-shown]=\"_isShowingBackdrop()\"></div><ng-content select=\"mat-drawer\"></ng-content><ng-content select=\"mat-drawer-content\"></ng-content><mat-drawer-content *ngIf=\"!_content\"><ng-content></ng-content></mat-drawer-content>",
                    styles: [".mat-drawer-container{position:relative;z-index:1;box-sizing:border-box;-webkit-overflow-scrolling:touch;display:block;overflow:hidden}.mat-drawer-container[fullscreen]{top:0;left:0;right:0;bottom:0;position:absolute}.mat-drawer-container[fullscreen].mat-drawer-container-has-open{overflow:hidden}.mat-drawer-container.mat-drawer-container-explicit-backdrop .mat-drawer-side{z-index:3}.mat-drawer-container.ng-animate-disabled .mat-drawer-backdrop,.mat-drawer-container.ng-animate-disabled .mat-drawer-content,.ng-animate-disabled .mat-drawer-container .mat-drawer-backdrop,.ng-animate-disabled .mat-drawer-container .mat-drawer-content{transition:none}.mat-drawer-backdrop{top:0;left:0;right:0;bottom:0;position:absolute;display:block;z-index:3;visibility:hidden}.mat-drawer-backdrop.mat-drawer-shown{visibility:visible}.mat-drawer-transition .mat-drawer-backdrop{transition-duration:.4s;transition-timing-function:cubic-bezier(.25,.8,.25,1);transition-property:background-color,visibility}@media (-ms-high-contrast:active){.mat-drawer-backdrop{opacity:.5}}.mat-drawer-content{position:relative;z-index:1;display:block;height:100%;overflow:auto}.mat-drawer-transition .mat-drawer-content{transition-duration:.4s;transition-timing-function:cubic-bezier(.25,.8,.25,1);transition-property:transform,margin-left,margin-right}.mat-drawer{position:relative;z-index:4;display:block;position:absolute;top:0;bottom:0;z-index:3;outline:0;box-sizing:border-box;overflow-y:auto;transform:translate3d(-100%,0,0)}@media (-ms-high-contrast:active){.mat-drawer,[dir=rtl] .mat-drawer.mat-drawer-end{border-right:solid 1px currentColor}}@media (-ms-high-contrast:active){.mat-drawer.mat-drawer-end,[dir=rtl] .mat-drawer{border-left:solid 1px currentColor;border-right:none}}.mat-drawer.mat-drawer-side{z-index:2}.mat-drawer.mat-drawer-end{right:0;transform:translate3d(100%,0,0)}[dir=rtl] .mat-drawer{transform:translate3d(100%,0,0)}[dir=rtl] .mat-drawer.mat-drawer-end{left:0;right:auto;transform:translate3d(-100%,0,0)}.mat-drawer-inner-container{width:100%;height:100%;overflow:auto;-webkit-overflow-scrolling:touch}.mat-sidenav-fixed{position:fixed}"],
                    host: {
                        'class': 'mat-drawer-container',
                        '[class.mat-drawer-container-explicit-backdrop]': '_backdropOverride',
                    },
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                },] },
    ];
    /** @nocollapse */
    MatDrawerContainer.ctorParameters = function () { return [
        { type: Directionality, decorators: [{ type: Optional }] },
        { type: ElementRef },
        { type: NgZone },
        { type: ChangeDetectorRef },
        { type: ViewportRuler },
        { type: undefined, decorators: [{ type: Inject, args: [MAT_DRAWER_DEFAULT_AUTOSIZE,] }] },
        { type: String, decorators: [{ type: Optional }, { type: Inject, args: [ANIMATION_MODULE_TYPE,] }] }
    ]; };
    MatDrawerContainer.propDecorators = {
        _drawers: [{ type: ContentChildren, args: [MatDrawer,] }],
        _content: [{ type: ContentChild, args: [MatDrawerContent, { static: false },] }],
        _userContent: [{ type: ViewChild, args: [MatDrawerContent, { static: false },] }],
        autosize: [{ type: Input }],
        hasBackdrop: [{ type: Input }],
        backdropClick: [{ type: Output }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatSidenavContent = /** @class */ (function (_super) {
        __extends(MatSidenavContent, _super);
        /**
         * @param {?} changeDetectorRef
         * @param {?} container
         * @param {?} elementRef
         * @param {?} scrollDispatcher
         * @param {?} ngZone
         */
        function MatSidenavContent(changeDetectorRef, container, elementRef, scrollDispatcher, ngZone) {
            return _super.call(this, changeDetectorRef, container, elementRef, scrollDispatcher, ngZone) || this;
        }
        return MatSidenavContent;
    }(MatDrawerContent));
    MatSidenavContent.decorators = [
        { type: Component, args: [{ selector: 'mat-sidenav-content',
                    template: '<ng-content></ng-content>',
                    host: {
                        'class': 'mat-drawer-content mat-sidenav-content',
                        '[style.margin-left.px]': '_container._contentMargins.left',
                        '[style.margin-right.px]': '_container._contentMargins.right',
                    },
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                },] },
    ];
    /** @nocollapse */
    MatSidenavContent.ctorParameters = function () { return [
        { type: ChangeDetectorRef },
        { type: MatSidenavContainer, decorators: [{ type: Inject, args: [forwardRef(( /**
                                         * @return {?}
                                         */function () { return MatSidenavContainer; })),] }] },
        { type: ElementRef },
        { type: ScrollDispatcher },
        { type: NgZone }
    ]; };
    var MatSidenav = /** @class */ (function (_super) {
        __extends(MatSidenav, _super);
        function MatSidenav() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this._fixedInViewport = false;
            _this._fixedTopGap = 0;
            _this._fixedBottomGap = 0;
            return _this;
        }
        Object.defineProperty(MatSidenav.prototype, "fixedInViewport", {
            /**
             * Whether the sidenav is fixed in the viewport.
             * @return {?}
             */
            get: function () { return this._fixedInViewport; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this._fixedInViewport = coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatSidenav.prototype, "fixedTopGap", {
            /**
             * The gap between the top of the sidenav and the top of the viewport when the sidenav is in fixed
             * mode.
             * @return {?}
             */
            get: function () { return this._fixedTopGap; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this._fixedTopGap = coerceNumberProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatSidenav.prototype, "fixedBottomGap", {
            /**
             * The gap between the bottom of the sidenav and the bottom of the viewport when the sidenav is in
             * fixed mode.
             * @return {?}
             */
            get: function () { return this._fixedBottomGap; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this._fixedBottomGap = coerceNumberProperty(value); },
            enumerable: true,
            configurable: true
        });
        return MatSidenav;
    }(MatDrawer));
    MatSidenav.decorators = [
        { type: Component, args: [{ selector: 'mat-sidenav',
                    exportAs: 'matSidenav',
                    template: "<div class=\"mat-drawer-inner-container\"><ng-content></ng-content></div>",
                    animations: [matDrawerAnimations.transformDrawer],
                    host: {
                        'class': 'mat-drawer mat-sidenav',
                        'tabIndex': '-1',
                        // must prevent the browser from aligning text based on value
                        '[attr.align]': 'null',
                        '[class.mat-drawer-end]': 'position === "end"',
                        '[class.mat-drawer-over]': 'mode === "over"',
                        '[class.mat-drawer-push]': 'mode === "push"',
                        '[class.mat-drawer-side]': 'mode === "side"',
                        '[class.mat-drawer-opened]': 'opened',
                        '[class.mat-sidenav-fixed]': 'fixedInViewport',
                        '[style.top.px]': 'fixedInViewport ? fixedTopGap : null',
                        '[style.bottom.px]': 'fixedInViewport ? fixedBottomGap : null',
                    },
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                },] },
    ];
    MatSidenav.propDecorators = {
        fixedInViewport: [{ type: Input }],
        fixedTopGap: [{ type: Input }],
        fixedBottomGap: [{ type: Input }]
    };
    var MatSidenavContainer = /** @class */ (function (_super) {
        __extends(MatSidenavContainer, _super);
        function MatSidenavContainer() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return MatSidenavContainer;
    }(MatDrawerContainer));
    MatSidenavContainer.decorators = [
        { type: Component, args: [{ selector: 'mat-sidenav-container',
                    exportAs: 'matSidenavContainer',
                    template: "<div class=\"mat-drawer-backdrop\" (click)=\"_onBackdropClicked()\" *ngIf=\"hasBackdrop\" [class.mat-drawer-shown]=\"_isShowingBackdrop()\"></div><ng-content select=\"mat-sidenav\"></ng-content><ng-content select=\"mat-sidenav-content\"></ng-content><mat-sidenav-content *ngIf=\"!_content\" cdkScrollable><ng-content></ng-content></mat-sidenav-content>",
                    styles: [".mat-drawer-container{position:relative;z-index:1;box-sizing:border-box;-webkit-overflow-scrolling:touch;display:block;overflow:hidden}.mat-drawer-container[fullscreen]{top:0;left:0;right:0;bottom:0;position:absolute}.mat-drawer-container[fullscreen].mat-drawer-container-has-open{overflow:hidden}.mat-drawer-container.mat-drawer-container-explicit-backdrop .mat-drawer-side{z-index:3}.mat-drawer-container.ng-animate-disabled .mat-drawer-backdrop,.mat-drawer-container.ng-animate-disabled .mat-drawer-content,.ng-animate-disabled .mat-drawer-container .mat-drawer-backdrop,.ng-animate-disabled .mat-drawer-container .mat-drawer-content{transition:none}.mat-drawer-backdrop{top:0;left:0;right:0;bottom:0;position:absolute;display:block;z-index:3;visibility:hidden}.mat-drawer-backdrop.mat-drawer-shown{visibility:visible}.mat-drawer-transition .mat-drawer-backdrop{transition-duration:.4s;transition-timing-function:cubic-bezier(.25,.8,.25,1);transition-property:background-color,visibility}@media (-ms-high-contrast:active){.mat-drawer-backdrop{opacity:.5}}.mat-drawer-content{position:relative;z-index:1;display:block;height:100%;overflow:auto}.mat-drawer-transition .mat-drawer-content{transition-duration:.4s;transition-timing-function:cubic-bezier(.25,.8,.25,1);transition-property:transform,margin-left,margin-right}.mat-drawer{position:relative;z-index:4;display:block;position:absolute;top:0;bottom:0;z-index:3;outline:0;box-sizing:border-box;overflow-y:auto;transform:translate3d(-100%,0,0)}@media (-ms-high-contrast:active){.mat-drawer,[dir=rtl] .mat-drawer.mat-drawer-end{border-right:solid 1px currentColor}}@media (-ms-high-contrast:active){.mat-drawer.mat-drawer-end,[dir=rtl] .mat-drawer{border-left:solid 1px currentColor;border-right:none}}.mat-drawer.mat-drawer-side{z-index:2}.mat-drawer.mat-drawer-end{right:0;transform:translate3d(100%,0,0)}[dir=rtl] .mat-drawer{transform:translate3d(100%,0,0)}[dir=rtl] .mat-drawer.mat-drawer-end{left:0;right:auto;transform:translate3d(-100%,0,0)}.mat-drawer-inner-container{width:100%;height:100%;overflow:auto;-webkit-overflow-scrolling:touch}.mat-sidenav-fixed{position:fixed}"],
                    host: {
                        'class': 'mat-drawer-container mat-sidenav-container',
                        '[class.mat-drawer-container-explicit-backdrop]': '_backdropOverride',
                    },
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                },] },
    ];
    MatSidenavContainer.propDecorators = {
        _drawers: [{ type: ContentChildren, args: [MatSidenav,] }],
        _content: [{ type: ContentChild, args: [MatSidenavContent, { static: false },] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatSidenavModule = /** @class */ (function () {
        function MatSidenavModule() {
        }
        return MatSidenavModule;
    }());
    MatSidenavModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        MatCommonModule,
                        ScrollingModule,
                        PlatformModule,
                    ],
                    exports: [
                        MatCommonModule,
                        MatDrawer,
                        MatDrawerContainer,
                        MatDrawerContent,
                        MatSidenav,
                        MatSidenavContainer,
                        MatSidenavContent,
                    ],
                    declarations: [
                        MatDrawer,
                        MatDrawerContainer,
                        MatDrawerContent,
                        MatSidenav,
                        MatSidenavContainer,
                        MatSidenavContent,
                    ],
                },] },
    ];
    /**
     * @license Angular v8.2.14
     * (c) 2010-2019 Google LLC. https://angular.io/
     * License: MIT
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * Base for events the router goes through, as opposed to events tied to a specific
     * route. Fired one time for any given navigation.
     *
     * \@usageNotes
     *
     * ```ts
     * class MyService {
     *   constructor(public router: Router, logger: Logger) {
     *     router.events.pipe(
     *       filter(e => e instanceof RouterEvent)
     *     ).subscribe(e => {
     *       logger.log(e.id, e.url);
     *     });
     *   }
     * }
     * ```
     *
     * @see `Event`
     * \@publicApi
     */
    var RouterEvent = /** @class */ (function () {
        /**
         * @param {?} id
         * @param {?} url
         */
        function RouterEvent(id, url) {
            this.id = id;
            this.url = url;
        }
        return RouterEvent;
    }());
    /**
     * An event triggered when a navigation starts.
     *
     * \@publicApi
     */
    var NavigationStart = /** @class */ (function (_super) {
        __extends(NavigationStart, _super);
        /**
         * @param {?} id
         * @param {?} url
         * @param {?=} navigationTrigger
         * @param {?=} restoredState
         */
        function NavigationStart(
        /** @docsNotRequired */
        id, 
        /** @docsNotRequired */
        url, 
        /** @docsNotRequired */
        navigationTrigger, 
        /** @docsNotRequired */
        restoredState) {
            if (navigationTrigger === void 0) { navigationTrigger = 'imperative'; }
            if (restoredState === void 0) { restoredState = null; }
            var _this = _super.call(this, id, url) || this;
            _this.navigationTrigger = navigationTrigger;
            _this.restoredState = restoredState;
            return _this;
        }
        /**
         * \@docsNotRequired
         * @return {?}
         */
        NavigationStart.prototype.toString = function () { return "NavigationStart(id: " + this.id + ", url: '" + this.url + "')"; };
        return NavigationStart;
    }(RouterEvent));
    /**
     * An event triggered when a navigation ends successfully.
     *
     * \@publicApi
     */
    var NavigationEnd = /** @class */ (function (_super) {
        __extends(NavigationEnd, _super);
        /**
         * @param {?} id
         * @param {?} url
         * @param {?} urlAfterRedirects
         */
        function NavigationEnd(
        /** @docsNotRequired */
        id, 
        /** @docsNotRequired */
        url, urlAfterRedirects) {
            var _this = _super.call(this, id, url) || this;
            _this.urlAfterRedirects = urlAfterRedirects;
            return _this;
        }
        /**
         * \@docsNotRequired
         * @return {?}
         */
        NavigationEnd.prototype.toString = function () {
            return "NavigationEnd(id: " + this.id + ", url: '" + this.url + "', urlAfterRedirects: '" + this.urlAfterRedirects + "')";
        };
        return NavigationEnd;
    }(RouterEvent));
    /**
     * An event triggered when a navigation is canceled, directly or indirectly.
     *
     * This can happen when a [route guard](guide/router#milestone-5-route-guards)
     * returns `false` or initiates a redirect by returning a `UrlTree`.
     *
     * \@publicApi
     */
    var NavigationCancel = /** @class */ (function (_super) {
        __extends(NavigationCancel, _super);
        /**
         * @param {?} id
         * @param {?} url
         * @param {?} reason
         */
        function NavigationCancel(
        /** @docsNotRequired */
        id, 
        /** @docsNotRequired */
        url, reason) {
            var _this = _super.call(this, id, url) || this;
            _this.reason = reason;
            return _this;
        }
        /**
         * \@docsNotRequired
         * @return {?}
         */
        NavigationCancel.prototype.toString = function () { return "NavigationCancel(id: " + this.id + ", url: '" + this.url + "')"; };
        return NavigationCancel;
    }(RouterEvent));
    /**
     * An event triggered when a navigation fails due to an unexpected error.
     *
     * \@publicApi
     */
    var NavigationError = /** @class */ (function (_super) {
        __extends(NavigationError, _super);
        /**
         * @param {?} id
         * @param {?} url
         * @param {?} error
         */
        function NavigationError(
        /** @docsNotRequired */
        id, 
        /** @docsNotRequired */
        url, error) {
            var _this = _super.call(this, id, url) || this;
            _this.error = error;
            return _this;
        }
        /**
         * \@docsNotRequired
         * @return {?}
         */
        NavigationError.prototype.toString = function () {
            return "NavigationError(id: " + this.id + ", url: '" + this.url + "', error: " + this.error + ")";
        };
        return NavigationError;
    }(RouterEvent));
    /**
     * An event triggered when routes are recognized.
     *
     * \@publicApi
     */
    var RoutesRecognized = /** @class */ (function (_super) {
        __extends(RoutesRecognized, _super);
        /**
         * @param {?} id
         * @param {?} url
         * @param {?} urlAfterRedirects
         * @param {?} state
         */
        function RoutesRecognized(
        /** @docsNotRequired */
        id, 
        /** @docsNotRequired */
        url, urlAfterRedirects, state) {
            var _this = _super.call(this, id, url) || this;
            _this.urlAfterRedirects = urlAfterRedirects;
            _this.state = state;
            return _this;
        }
        /**
         * \@docsNotRequired
         * @return {?}
         */
        RoutesRecognized.prototype.toString = function () {
            return "RoutesRecognized(id: " + this.id + ", url: '" + this.url + "', urlAfterRedirects: '" + this.urlAfterRedirects + "', state: " + this.state + ")";
        };
        return RoutesRecognized;
    }(RouterEvent));
    /**
     * An event triggered at the start of the Guard phase of routing.
     *
     * \@publicApi
     */
    var GuardsCheckStart = /** @class */ (function (_super) {
        __extends(GuardsCheckStart, _super);
        /**
         * @param {?} id
         * @param {?} url
         * @param {?} urlAfterRedirects
         * @param {?} state
         */
        function GuardsCheckStart(
        /** @docsNotRequired */
        id, 
        /** @docsNotRequired */
        url, urlAfterRedirects, state) {
            var _this = _super.call(this, id, url) || this;
            _this.urlAfterRedirects = urlAfterRedirects;
            _this.state = state;
            return _this;
        }
        /**
         * @return {?}
         */
        GuardsCheckStart.prototype.toString = function () {
            return "GuardsCheckStart(id: " + this.id + ", url: '" + this.url + "', urlAfterRedirects: '" + this.urlAfterRedirects + "', state: " + this.state + ")";
        };
        return GuardsCheckStart;
    }(RouterEvent));
    /**
     * An event triggered at the end of the Guard phase of routing.
     *
     * \@publicApi
     */
    var GuardsCheckEnd = /** @class */ (function (_super) {
        __extends(GuardsCheckEnd, _super);
        /**
         * @param {?} id
         * @param {?} url
         * @param {?} urlAfterRedirects
         * @param {?} state
         * @param {?} shouldActivate
         */
        function GuardsCheckEnd(
        /** @docsNotRequired */
        id, 
        /** @docsNotRequired */
        url, urlAfterRedirects, state, shouldActivate) {
            var _this = _super.call(this, id, url) || this;
            _this.urlAfterRedirects = urlAfterRedirects;
            _this.state = state;
            _this.shouldActivate = shouldActivate;
            return _this;
        }
        /**
         * @return {?}
         */
        GuardsCheckEnd.prototype.toString = function () {
            return "GuardsCheckEnd(id: " + this.id + ", url: '" + this.url + "', urlAfterRedirects: '" + this.urlAfterRedirects + "', state: " + this.state + ", shouldActivate: " + this.shouldActivate + ")";
        };
        return GuardsCheckEnd;
    }(RouterEvent));
    /**
     * An event triggered at the the start of the Resolve phase of routing.
     *
     * Runs in the "resolve" phase whether or not there is anything to resolve.
     * In future, may change to only run when there are things to be resolved.
     *
     * \@publicApi
     */
    var ResolveStart = /** @class */ (function (_super) {
        __extends(ResolveStart, _super);
        /**
         * @param {?} id
         * @param {?} url
         * @param {?} urlAfterRedirects
         * @param {?} state
         */
        function ResolveStart(
        /** @docsNotRequired */
        id, 
        /** @docsNotRequired */
        url, urlAfterRedirects, state) {
            var _this = _super.call(this, id, url) || this;
            _this.urlAfterRedirects = urlAfterRedirects;
            _this.state = state;
            return _this;
        }
        /**
         * @return {?}
         */
        ResolveStart.prototype.toString = function () {
            return "ResolveStart(id: " + this.id + ", url: '" + this.url + "', urlAfterRedirects: '" + this.urlAfterRedirects + "', state: " + this.state + ")";
        };
        return ResolveStart;
    }(RouterEvent));
    /**
     * An event triggered at the end of the Resolve phase of routing.
     * @see `ResolveStart`.
     *
     * \@publicApi
     */
    var ResolveEnd = /** @class */ (function (_super) {
        __extends(ResolveEnd, _super);
        /**
         * @param {?} id
         * @param {?} url
         * @param {?} urlAfterRedirects
         * @param {?} state
         */
        function ResolveEnd(
        /** @docsNotRequired */
        id, 
        /** @docsNotRequired */
        url, urlAfterRedirects, state) {
            var _this = _super.call(this, id, url) || this;
            _this.urlAfterRedirects = urlAfterRedirects;
            _this.state = state;
            return _this;
        }
        /**
         * @return {?}
         */
        ResolveEnd.prototype.toString = function () {
            return "ResolveEnd(id: " + this.id + ", url: '" + this.url + "', urlAfterRedirects: '" + this.urlAfterRedirects + "', state: " + this.state + ")";
        };
        return ResolveEnd;
    }(RouterEvent));
    /**
     * An event triggered before lazy loading a route configuration.
     *
     * \@publicApi
     */
    var RouteConfigLoadStart = /** @class */ (function () {
        /**
         * @param {?} route
         */
        function RouteConfigLoadStart(route) {
            this.route = route;
        }
        /**
         * @return {?}
         */
        RouteConfigLoadStart.prototype.toString = function () { return "RouteConfigLoadStart(path: " + this.route.path + ")"; };
        return RouteConfigLoadStart;
    }());
    /**
     * An event triggered when a route has been lazy loaded.
     *
     * \@publicApi
     */
    var RouteConfigLoadEnd = /** @class */ (function () {
        /**
         * @param {?} route
         */
        function RouteConfigLoadEnd(route) {
            this.route = route;
        }
        /**
         * @return {?}
         */
        RouteConfigLoadEnd.prototype.toString = function () { return "RouteConfigLoadEnd(path: " + this.route.path + ")"; };
        return RouteConfigLoadEnd;
    }());
    /**
     * An event triggered at the start of the child-activation
     * part of the Resolve phase of routing.
     * @see `ChildActivationEnd`
     * @see `ResolveStart`
     *
     * \@publicApi
     */
    var ChildActivationStart = /** @class */ (function () {
        /**
         * @param {?} snapshot
         */
        function ChildActivationStart(snapshot) {
            this.snapshot = snapshot;
        }
        /**
         * @return {?}
         */
        ChildActivationStart.prototype.toString = function () {
            /** @type {?} */
            var path = this.snapshot.routeConfig && this.snapshot.routeConfig.path || '';
            return "ChildActivationStart(path: '" + path + "')";
        };
        return ChildActivationStart;
    }());
    /**
     * An event triggered at the end of the child-activation part
     * of the Resolve phase of routing.
     * @see `ChildActivationStart`
     * @see `ResolveStart` *
     * \@publicApi
     */
    var ChildActivationEnd = /** @class */ (function () {
        /**
         * @param {?} snapshot
         */
        function ChildActivationEnd(snapshot) {
            this.snapshot = snapshot;
        }
        /**
         * @return {?}
         */
        ChildActivationEnd.prototype.toString = function () {
            /** @type {?} */
            var path = this.snapshot.routeConfig && this.snapshot.routeConfig.path || '';
            return "ChildActivationEnd(path: '" + path + "')";
        };
        return ChildActivationEnd;
    }());
    /**
     * An event triggered at the start of the activation part
     * of the Resolve phase of routing.
     * @see ActivationEnd`
     * @see `ResolveStart`
     *
     * \@publicApi
     */
    var ActivationStart = /** @class */ (function () {
        /**
         * @param {?} snapshot
         */
        function ActivationStart(snapshot) {
            this.snapshot = snapshot;
        }
        /**
         * @return {?}
         */
        ActivationStart.prototype.toString = function () {
            /** @type {?} */
            var path = this.snapshot.routeConfig && this.snapshot.routeConfig.path || '';
            return "ActivationStart(path: '" + path + "')";
        };
        return ActivationStart;
    }());
    /**
     * An event triggered at the end of the activation part
     * of the Resolve phase of routing.
     * @see `ActivationStart`
     * @see `ResolveStart`
     *
     * \@publicApi
     */
    var ActivationEnd = /** @class */ (function () {
        /**
         * @param {?} snapshot
         */
        function ActivationEnd(snapshot) {
            this.snapshot = snapshot;
        }
        /**
         * @return {?}
         */
        ActivationEnd.prototype.toString = function () {
            /** @type {?} */
            var path = this.snapshot.routeConfig && this.snapshot.routeConfig.path || '';
            return "ActivationEnd(path: '" + path + "')";
        };
        return ActivationEnd;
    }());
    /**
     * An event triggered by scrolling.
     *
     * \@publicApi
     */
    var Scroll = /** @class */ (function () {
        /**
         * @param {?} routerEvent
         * @param {?} position
         * @param {?} anchor
         */
        function Scroll(routerEvent, position, anchor) {
            this.routerEvent = routerEvent;
            this.position = position;
            this.anchor = anchor;
        }
        /**
         * @return {?}
         */
        Scroll.prototype.toString = function () {
            /** @type {?} */
            var pos = this.position ? this.position[0] + ", " + this.position[1] : null;
            return "Scroll(anchor: '" + this.anchor + "', position: '" + pos + "')";
        };
        return Scroll;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * This component is used internally within the router to be a placeholder when an empty
     * router-outlet is needed. For example, with a config such as:
     *
     * `{path: 'parent', outlet: 'nav', children: [...]}`
     *
     * In order to render, there needs to be a component on this config, which will default
     * to this `EmptyOutletComponent`.
     */
    var ɵEmptyOutletComponent = /** @class */ (function () {
        function ɵEmptyOutletComponent() {
        }
        return ɵEmptyOutletComponent;
    }());
    ɵEmptyOutletComponent.decorators = [
        { type: Component, args: [{ template: "<router-outlet></router-outlet>" }] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * The primary routing outlet.
     *
     * \@publicApi
     * @type {?}
     */
    var PRIMARY_OUTLET = 'primary';
    var ParamsAsMap = /** @class */ (function () {
        /**
         * @param {?} params
         */
        function ParamsAsMap(params) {
            this.params = params || {};
        }
        /**
         * @param {?} name
         * @return {?}
         */
        ParamsAsMap.prototype.has = function (name) { return this.params.hasOwnProperty(name); };
        /**
         * @param {?} name
         * @return {?}
         */
        ParamsAsMap.prototype.get = function (name) {
            if (this.has(name)) {
                /** @type {?} */
                var v = this.params[name];
                return Array.isArray(v) ? v[0] : v;
            }
            return null;
        };
        /**
         * @param {?} name
         * @return {?}
         */
        ParamsAsMap.prototype.getAll = function (name) {
            if (this.has(name)) {
                /** @type {?} */
                var v = this.params[name];
                return Array.isArray(v) ? v : [v];
            }
            return [];
        };
        Object.defineProperty(ParamsAsMap.prototype, "keys", {
            /**
             * @return {?}
             */
            get: function () { return Object.keys(this.params); },
            enumerable: true,
            configurable: true
        });
        return ParamsAsMap;
    }());
    /**
     * Converts a `Params` instance to a `ParamMap`.
     * \@publicApi
     * @param {?} params The instance to convert.
     * @return {?} The new map instance.
     *
     */
    function convertToParamMap(params) {
        return new ParamsAsMap(params);
    }
    /** @type {?} */
    var NAVIGATION_CANCELING_ERROR = 'ngNavigationCancelingError';
    /**
     * @param {?} message
     * @return {?}
     */
    function navigationCancelingError(message) {
        /** @type {?} */
        var error = Error('NavigationCancelingError: ' + message);
        (( /** @type {?} */(error)))[NAVIGATION_CANCELING_ERROR] = true;
        return error;
    }
    /**
     * @param {?} error
     * @return {?}
     */
    function isNavigationCancelingError(error) {
        return error && (( /** @type {?} */(error)))[NAVIGATION_CANCELING_ERROR];
    }
    // Matches the route configuration (`route`) against the actual URL (`segments`).
    /**
     * @param {?} segments
     * @param {?} segmentGroup
     * @param {?} route
     * @return {?}
     */
    function defaultUrlMatcher(segments, segmentGroup, route) {
        /** @type {?} */
        var parts = ( /** @type {?} */(route.path)).split('/');
        if (parts.length > segments.length) {
            // The actual URL is shorter than the config, no match
            return null;
        }
        if (route.pathMatch === 'full' &&
            (segmentGroup.hasChildren() || parts.length < segments.length)) {
            // The config is longer than the actual URL but we are looking for a full match, return null
            return null;
        }
        /** @type {?} */
        var posParams = {};
        // Check each config part against the actual URL
        for (var index = 0; index < parts.length; index++) {
            /** @type {?} */
            var part = parts[index];
            /** @type {?} */
            var segment = segments[index];
            /** @type {?} */
            var isParameter = part.startsWith(':');
            if (isParameter) {
                posParams[part.substring(1)] = segment;
            }
            else if (part !== segment.path) {
                // The actual URL part does not match the config, no match
                return null;
            }
        }
        return { consumed: segments.slice(0, parts.length), posParams: posParams };
    }
    var LoadedRouterConfig = /** @class */ (function () {
        /**
         * @param {?} routes
         * @param {?} module
         */
        function LoadedRouterConfig(routes, module) {
            this.routes = routes;
            this.module = module;
        }
        return LoadedRouterConfig;
    }());
    /**
     * @param {?} config
     * @param {?=} parentPath
     * @return {?}
     */
    function validateConfig(config, parentPath) {
        if (parentPath === void 0) { parentPath = ''; }
        // forEach doesn't iterate undefined values
        for (var i_167 = 0; i_167 < config.length; i_167++) {
            /** @type {?} */
            var route = config[i_167];
            /** @type {?} */
            var fullPath = getFullPath(parentPath, route);
            validateNode$1(route, fullPath);
        }
    }
    /**
     * @param {?} route
     * @param {?} fullPath
     * @return {?}
     */
    function validateNode$1(route, fullPath) {
        if (!route) {
            throw new Error("\n      Invalid configuration of route '" + fullPath + "': Encountered undefined route.\n      The reason might be an extra comma.\n\n      Example:\n      const routes: Routes = [\n        { path: '', redirectTo: '/dashboard', pathMatch: 'full' },\n        { path: 'dashboard',  component: DashboardComponent },, << two commas\n        { path: 'detail/:id', component: HeroDetailComponent }\n      ];\n    ");
        }
        if (Array.isArray(route)) {
            throw new Error("Invalid configuration of route '" + fullPath + "': Array cannot be specified");
        }
        if (!route.component && !route.children && !route.loadChildren &&
            (route.outlet && route.outlet !== PRIMARY_OUTLET)) {
            throw new Error("Invalid configuration of route '" + fullPath + "': a componentless route without children or loadChildren cannot have a named outlet set");
        }
        if (route.redirectTo && route.children) {
            throw new Error("Invalid configuration of route '" + fullPath + "': redirectTo and children cannot be used together");
        }
        if (route.redirectTo && route.loadChildren) {
            throw new Error("Invalid configuration of route '" + fullPath + "': redirectTo and loadChildren cannot be used together");
        }
        if (route.children && route.loadChildren) {
            throw new Error("Invalid configuration of route '" + fullPath + "': children and loadChildren cannot be used together");
        }
        if (route.redirectTo && route.component) {
            throw new Error("Invalid configuration of route '" + fullPath + "': redirectTo and component cannot be used together");
        }
        if (route.path && route.matcher) {
            throw new Error("Invalid configuration of route '" + fullPath + "': path and matcher cannot be used together");
        }
        if (route.redirectTo === void 0 && !route.component && !route.children && !route.loadChildren) {
            throw new Error("Invalid configuration of route '" + fullPath + "'. One of the following must be provided: component, redirectTo, children or loadChildren");
        }
        if (route.path === void 0 && route.matcher === void 0) {
            throw new Error("Invalid configuration of route '" + fullPath + "': routes must have either a path or a matcher specified");
        }
        if (typeof route.path === 'string' && route.path.charAt(0) === '/') {
            throw new Error("Invalid configuration of route '" + fullPath + "': path cannot start with a slash");
        }
        if (route.path === '' && route.redirectTo !== void 0 && route.pathMatch === void 0) {
            /** @type {?} */
            var exp = "The default value of 'pathMatch' is 'prefix', but often the intent is to use 'full'.";
            throw new Error("Invalid configuration of route '{path: \"" + fullPath + "\", redirectTo: \"" + route.redirectTo + "\"}': please provide 'pathMatch'. " + exp);
        }
        if (route.pathMatch !== void 0 && route.pathMatch !== 'full' && route.pathMatch !== 'prefix') {
            throw new Error("Invalid configuration of route '" + fullPath + "': pathMatch can only be set to 'prefix' or 'full'");
        }
        if (route.children) {
            validateConfig(route.children, fullPath);
        }
    }
    /**
     * @param {?} parentPath
     * @param {?} currentRoute
     * @return {?}
     */
    function getFullPath(parentPath, currentRoute) {
        if (!currentRoute) {
            return parentPath;
        }
        if (!parentPath && !currentRoute.path) {
            return '';
        }
        else if (parentPath && !currentRoute.path) {
            return parentPath + "/";
        }
        else if (!parentPath && currentRoute.path) {
            return currentRoute.path;
        }
        else {
            return parentPath + "/" + currentRoute.path;
        }
    }
    /**
     * Makes a copy of the config and adds any default required properties.
     * @param {?} r
     * @return {?}
     */
    function standardizeConfig(r) {
        /** @type {?} */
        var children = r.children && r.children.map(standardizeConfig);
        /** @type {?} */
        var c = children ? Object.assign({}, r, { children: children }) : Object.assign({}, r);
        if (!c.component && (children || c.loadChildren) && (c.outlet && c.outlet !== PRIMARY_OUTLET)) {
            c.component = ɵEmptyOutletComponent;
        }
        return c;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} a
     * @param {?} b
     * @return {?}
     */
    function shallowEqualArrays(a, b) {
        if (a.length !== b.length)
            return false;
        for (var i_168 = 0; i_168 < a.length; ++i_168) {
            if (!shallowEqual(a[i_168], b[i_168]))
                return false;
        }
        return true;
    }
    /**
     * @param {?} a
     * @param {?} b
     * @return {?}
     */
    function shallowEqual(a, b) {
        // Casting Object.keys return values to include `undefined` as there are some cases
        // in IE 11 where this can happen. Cannot provide a test because the behavior only
        // exists in certain circumstances in IE 11, therefore doing this cast ensures the
        // logic is correct for when this edge case is hit.
        /** @type {?} */
        var k1 = ( /** @type {?} */(Object.keys(a)));
        /** @type {?} */
        var k2 = ( /** @type {?} */(Object.keys(b)));
        if (!k1 || !k2 || k1.length != k2.length) {
            return false;
        }
        /** @type {?} */
        var key;
        for (var i_169 = 0; i_169 < k1.length; i_169++) {
            key = k1[i_169];
            if (a[key] !== b[key]) {
                return false;
            }
        }
        return true;
    }
    /**
     * Flattens single-level nested arrays.
     * @template T
     * @param {?} arr
     * @return {?}
     */
    function flatten$1(arr) {
        return Array.prototype.concat.apply([], arr);
    }
    /**
     * Return the last element of an array.
     * @template T
     * @param {?} a
     * @return {?}
     */
    function last$1(a) {
        return a.length > 0 ? a[a.length - 1] : null;
    }
    /**
     * @template K, V
     * @param {?} map
     * @param {?} callback
     * @return {?}
     */
    function forEach(map, callback) {
        for (var prop in map) {
            if (map.hasOwnProperty(prop)) {
                callback(map[prop], prop);
            }
        }
    }
    /**
     * @template A, B
     * @param {?} obj
     * @param {?} fn
     * @return {?}
     */
    function waitForMap(obj, fn) {
        if (Object.keys(obj).length === 0) {
            return of({});
        }
        /** @type {?} */
        var waitHead = [];
        /** @type {?} */
        var waitTail = [];
        /** @type {?} */
        var res = {};
        forEach(obj, ( /**
         * @param {?} a
         * @param {?} k
         * @return {?}
         */function (a, k) {
            /** @type {?} */
            var mapped = fn(k, a).pipe(map(( /**
             * @param {?} r
             * @return {?}
             */function (r) { return res[k] = r; })));
            if (k === PRIMARY_OUTLET) {
                waitHead.push(mapped);
            }
            else {
                waitTail.push(mapped);
            }
        }));
        // Closure compiler has problem with using spread operator here. So we use "Array.concat".
        // Note that we also need to cast the new promise because TypeScript cannot infer the type
        // when calling the "of" function through "Function.apply"
        return (( /** @type {?} */(of.apply(null, waitHead.concat(waitTail)))))
            .pipe(concatAll(), last(), map(( /**
     * @return {?}
     */function () { return res; })));
    }
    /**
     * @template T
     * @param {?} value
     * @return {?}
     */
    function wrapIntoObservable(value) {
        if (isObservable(value)) {
            return value;
        }
        if (isPromise$1(value)) {
            // Use `Promise.resolve()` to wrap promise-like instances.
            // Required ie when a Resolver returns a AngularJS `$q` promise to correctly trigger the
            // change detection.
            return from(Promise.resolve(value));
        }
        return of(value);
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @return {?}
     */
    function createEmptyUrlTree() {
        return new UrlTree(new UrlSegmentGroup([], {}), {}, null);
    }
    /**
     * @param {?} container
     * @param {?} containee
     * @param {?} exact
     * @return {?}
     */
    function containsTree(container, containee, exact) {
        if (exact) {
            return equalQueryParams(container.queryParams, containee.queryParams) &&
                equalSegmentGroups(container.root, containee.root);
        }
        return containsQueryParams(container.queryParams, containee.queryParams) &&
            containsSegmentGroup(container.root, containee.root);
    }
    /**
     * @param {?} container
     * @param {?} containee
     * @return {?}
     */
    function equalQueryParams(container, containee) {
        // TODO: This does not handle array params correctly.
        return shallowEqual(container, containee);
    }
    /**
     * @param {?} container
     * @param {?} containee
     * @return {?}
     */
    function equalSegmentGroups(container, containee) {
        if (!equalPath(container.segments, containee.segments))
            return false;
        if (container.numberOfChildren !== containee.numberOfChildren)
            return false;
        for (var c_3 in containee.children) {
            if (!container.children[c_3])
                return false;
            if (!equalSegmentGroups(container.children[c_3], containee.children[c_3]))
                return false;
        }
        return true;
    }
    /**
     * @param {?} container
     * @param {?} containee
     * @return {?}
     */
    function containsQueryParams(container, containee) {
        // TODO: This does not handle array params correctly.
        return Object.keys(containee).length <= Object.keys(container).length &&
            Object.keys(containee).every(( /**
             * @param {?} key
             * @return {?}
             */function (/**
             * @param {?} key
             * @return {?}
             */ key) { return containee[key] === container[key]; }));
    }
    /**
     * @param {?} container
     * @param {?} containee
     * @return {?}
     */
    function containsSegmentGroup(container, containee) {
        return containsSegmentGroupHelper(container, containee, containee.segments);
    }
    /**
     * @param {?} container
     * @param {?} containee
     * @param {?} containeePaths
     * @return {?}
     */
    function containsSegmentGroupHelper(container, containee, containeePaths) {
        if (container.segments.length > containeePaths.length) {
            /** @type {?} */
            var current = container.segments.slice(0, containeePaths.length);
            if (!equalPath(current, containeePaths))
                return false;
            if (containee.hasChildren())
                return false;
            return true;
        }
        else if (container.segments.length === containeePaths.length) {
            if (!equalPath(container.segments, containeePaths))
                return false;
            for (var c_4 in containee.children) {
                if (!container.children[c_4])
                    return false;
                if (!containsSegmentGroup(container.children[c_4], containee.children[c_4]))
                    return false;
            }
            return true;
        }
        else {
            /** @type {?} */
            var current = containeePaths.slice(0, container.segments.length);
            /** @type {?} */
            var next = containeePaths.slice(container.segments.length);
            if (!equalPath(container.segments, current))
                return false;
            if (!container.children[PRIMARY_OUTLET])
                return false;
            return containsSegmentGroupHelper(container.children[PRIMARY_OUTLET], containee, next);
        }
    }
    /**
     * \@description
     *
     * Represents the parsed URL.
     *
     * Since a router state is a tree, and the URL is nothing but a serialized state, the URL is a
     * serialized tree.
     * UrlTree is a data structure that provides a lot of affordances in dealing with URLs
     *
     * \@usageNotes
     * ### Example
     *
     * ```
     * \@Component({templateUrl:'template.html'})
     * class MyComponent {
     *   constructor(router: Router) {
     *     const tree: UrlTree =
     *       router.parseUrl('/team/33/(user/victor//support:help)?debug=true#fragment');
     *     const f = tree.fragment; // return 'fragment'
     *     const q = tree.queryParams; // returns {debug: 'true'}
     *     const g: UrlSegmentGroup = tree.root.children[PRIMARY_OUTLET];
     *     const s: UrlSegment[] = g.segments; // returns 2 segments 'team' and '33'
     *     g.children[PRIMARY_OUTLET].segments; // returns 2 segments 'user' and 'victor'
     *     g.children['support'].segments; // return 1 segment 'help'
     *   }
     * }
     * ```
     *
     * \@publicApi
     */
    var UrlTree = /** @class */ (function () {
        /**
         * \@internal
         * @param {?} root
         * @param {?} queryParams
         * @param {?} fragment
         */
        function UrlTree(root, queryParams, fragment) {
            this.root = root;
            this.queryParams = queryParams;
            this.fragment = fragment;
        }
        Object.defineProperty(UrlTree.prototype, "queryParamMap", {
            /**
             * @return {?}
             */
            get: function () {
                if (!this._queryParamMap) {
                    this._queryParamMap = convertToParamMap(this.queryParams);
                }
                return this._queryParamMap;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * \@docsNotRequired
         * @return {?}
         */
        UrlTree.prototype.toString = function () { return DEFAULT_SERIALIZER.serialize(this); };
        return UrlTree;
    }());
    /**
     * \@description
     *
     * Represents the parsed URL segment group.
     *
     * See `UrlTree` for more information.
     *
     * \@publicApi
     */
    var UrlSegmentGroup = /** @class */ (function () {
        /**
         * @param {?} segments
         * @param {?} children
         */
        function UrlSegmentGroup(segments, children) {
            var _this = this;
            this.segments = segments;
            this.children = children;
            /**
             * The parent node in the url tree
             */
            this.parent = null;
            forEach(children, ( /**
             * @template THIS
             * @this {THIS}
             * @param {?} v
             * @param {?} k
             * @return {THIS}
             */function (v, k) { return v.parent = _this; }));
        }
        /**
         * Whether the segment has child segments
         * @return {?}
         */
        UrlSegmentGroup.prototype.hasChildren = function () { return this.numberOfChildren > 0; };
        Object.defineProperty(UrlSegmentGroup.prototype, "numberOfChildren", {
            /**
             * Number of child segments
             * @return {?}
             */
            get: function () { return Object.keys(this.children).length; },
            enumerable: true,
            configurable: true
        });
        /**
         * \@docsNotRequired
         * @return {?}
         */
        UrlSegmentGroup.prototype.toString = function () { return serializePaths(this); };
        return UrlSegmentGroup;
    }());
    /**
     * \@description
     *
     * Represents a single URL segment.
     *
     * A UrlSegment is a part of a URL between the two slashes. It contains a path and the matrix
     * parameters associated with the segment.
     *
     * \@usageNotes
     *  ### Example
     *
     * ```
     * \@Component({templateUrl:'template.html'})
     * class MyComponent {
     *   constructor(router: Router) {
     *     const tree: UrlTree = router.parseUrl('/team;id=33');
     *     const g: UrlSegmentGroup = tree.root.children[PRIMARY_OUTLET];
     *     const s: UrlSegment[] = g.segments;
     *     s[0].path; // returns 'team'
     *     s[0].parameters; // returns {id: 33}
     *   }
     * }
     * ```
     *
     * \@publicApi
     */
    var UrlSegment = /** @class */ (function () {
        /**
         * @param {?} path
         * @param {?} parameters
         */
        function UrlSegment(path, parameters) {
            this.path = path;
            this.parameters = parameters;
        }
        Object.defineProperty(UrlSegment.prototype, "parameterMap", {
            /**
             * @return {?}
             */
            get: function () {
                if (!this._parameterMap) {
                    this._parameterMap = convertToParamMap(this.parameters);
                }
                return this._parameterMap;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * \@docsNotRequired
         * @return {?}
         */
        UrlSegment.prototype.toString = function () { return serializePath(this); };
        return UrlSegment;
    }());
    /**
     * @param {?} as
     * @param {?} bs
     * @return {?}
     */
    function equalSegments(as, bs) {
        return equalPath(as, bs) && as.every(( /**
         * @param {?} a
         * @param {?} i
         * @return {?}
         */function (a, i) { return shallowEqual(a.parameters, bs[i].parameters); }));
    }
    /**
     * @param {?} as
     * @param {?} bs
     * @return {?}
     */
    function equalPath(as, bs) {
        if (as.length !== bs.length)
            return false;
        return as.every(( /**
         * @param {?} a
         * @param {?} i
         * @return {?}
         */function (a, i) { return a.path === bs[i].path; }));
    }
    /**
     * @template T
     * @param {?} segment
     * @param {?} fn
     * @return {?}
     */
    function mapChildrenIntoArray(segment, fn) {
        /** @type {?} */
        var res = [];
        forEach(segment.children, ( /**
         * @param {?} child
         * @param {?} childOutlet
         * @return {?}
         */function (child, childOutlet) {
            if (childOutlet === PRIMARY_OUTLET) {
                res = res.concat(fn(child, childOutlet));
            }
        }));
        forEach(segment.children, ( /**
         * @param {?} child
         * @param {?} childOutlet
         * @return {?}
         */function (child, childOutlet) {
            if (childOutlet !== PRIMARY_OUTLET) {
                res = res.concat(fn(child, childOutlet));
            }
        }));
        return res;
    }
    /**
     * \@description
     *
     * Serializes and deserializes a URL string into a URL tree.
     *
     * The url serialization strategy is customizable. You can
     * make all URLs case insensitive by providing a custom UrlSerializer.
     *
     * See `DefaultUrlSerializer` for an example of a URL serializer.
     *
     * \@publicApi
     * @abstract
     */
    var UrlSerializer = /** @class */ (function () {
        function UrlSerializer() {
        }
        return UrlSerializer;
    }());
    /**
     * \@description
     *
     * A default implementation of the `UrlSerializer`.
     *
     * Example URLs:
     *
     * ```
     * /inbox/33(popup:compose)
     * /inbox/33;open=true/messages/44
     * ```
     *
     * DefaultUrlSerializer uses parentheses to serialize secondary segments (e.g., popup:compose), the
     * colon syntax to specify the outlet, and the ';parameter=value' syntax (e.g., open=true) to
     * specify route specific parameters.
     *
     * \@publicApi
     */
    var DefaultUrlSerializer = /** @class */ (function () {
        function DefaultUrlSerializer() {
        }
        /**
         * Parses a url into a `UrlTree`
         * @param {?} url
         * @return {?}
         */
        DefaultUrlSerializer.prototype.parse = function (url) {
            /** @type {?} */
            var p = new UrlParser(url);
            return new UrlTree(p.parseRootSegment(), p.parseQueryParams(), p.parseFragment());
        };
        /**
         * Converts a `UrlTree` into a url
         * @param {?} tree
         * @return {?}
         */
        DefaultUrlSerializer.prototype.serialize = function (tree) {
            /** @type {?} */
            var segment = "/" + serializeSegment(tree.root, true);
            /** @type {?} */
            var query = serializeQueryParams(tree.queryParams);
            /** @type {?} */
            var fragment = typeof tree.fragment === "string" ? "#" + encodeUriFragment(( /** @type {?} */(tree.fragment))) : '';
            return "" + segment + query + fragment;
        };
        return DefaultUrlSerializer;
    }());
    /** @type {?} */
    var DEFAULT_SERIALIZER = new DefaultUrlSerializer();
    /**
     * @param {?} segment
     * @return {?}
     */
    function serializePaths(segment) {
        return segment.segments.map(( /**
         * @param {?} p
         * @return {?}
         */function (/**
         * @param {?} p
         * @return {?}
         */ p) { return serializePath(p); })).join('/');
    }
    /**
     * @param {?} segment
     * @param {?} root
     * @return {?}
     */
    function serializeSegment(segment, root) {
        if (!segment.hasChildren()) {
            return serializePaths(segment);
        }
        if (root) {
            /** @type {?} */
            var primary = segment.children[PRIMARY_OUTLET] ?
                serializeSegment(segment.children[PRIMARY_OUTLET], false) :
                '';
            /** @type {?} */
            var children_1 = [];
            forEach(segment.children, ( /**
             * @param {?} v
             * @param {?} k
             * @return {?}
             */function (v, k) {
                if (k !== PRIMARY_OUTLET) {
                    children_1.push(k + ":" + serializeSegment(v, false));
                }
            }));
            return children_1.length > 0 ? primary + "(" + children_1.join('//') + ")" : primary;
        }
        else {
            /** @type {?} */
            var children = mapChildrenIntoArray(segment, ( /**
             * @param {?} v
             * @param {?} k
             * @return {?}
             */function (v, k) {
                if (k === PRIMARY_OUTLET) {
                    return [serializeSegment(segment.children[PRIMARY_OUTLET], false)];
                }
                return [k + ":" + serializeSegment(v, false)];
            }));
            return serializePaths(segment) + "/(" + children.join('//') + ")";
        }
    }
    /**
     * Encodes a URI string with the default encoding. This function will only ever be called from
     * `encodeUriQuery` or `encodeUriSegment` as it's the base set of encodings to be used. We need
     * a custom encoding because encodeURIComponent is too aggressive and encodes stuff that doesn't
     * have to be encoded per https://url.spec.whatwg.org.
     * @param {?} s
     * @return {?}
     */
    function encodeUriString(s) {
        return encodeURIComponent(s)
            .replace(/%40/g, '@')
            .replace(/%3A/gi, ':')
            .replace(/%24/g, '$')
            .replace(/%2C/gi, ',');
    }
    /**
     * This function should be used to encode both keys and values in a query string key/value. In
     * the following URL, you need to call encodeUriQuery on "k" and "v":
     *
     * http://www.site.org/html;mk=mv?k=v#f
     * @param {?} s
     * @return {?}
     */
    function encodeUriQuery(s) {
        return encodeUriString(s).replace(/%3B/gi, ';');
    }
    /**
     * This function should be used to encode a URL fragment. In the following URL, you need to call
     * encodeUriFragment on "f":
     *
     * http://www.site.org/html;mk=mv?k=v#f
     * @param {?} s
     * @return {?}
     */
    function encodeUriFragment(s) {
        return encodeURI(s);
    }
    /**
     * This function should be run on any URI segment as well as the key and value in a key/value
     * pair for matrix params. In the following URL, you need to call encodeUriSegment on "html",
     * "mk", and "mv":
     *
     * http://www.site.org/html;mk=mv?k=v#f
     * @param {?} s
     * @return {?}
     */
    function encodeUriSegment(s) {
        return encodeUriString(s).replace(/\(/g, '%28').replace(/\)/g, '%29').replace(/%26/gi, '&');
    }
    /**
     * @param {?} s
     * @return {?}
     */
    function decode(s) {
        return decodeURIComponent(s);
    }
    // Query keys/values should have the "+" replaced first, as "+" in a query string is " ".
    // decodeURIComponent function will not decode "+" as a space.
    /**
     * @param {?} s
     * @return {?}
     */
    function decodeQuery(s) {
        return decode(s.replace(/\+/g, '%20'));
    }
    /**
     * @param {?} path
     * @return {?}
     */
    function serializePath(path) {
        return "" + encodeUriSegment(path.path) + serializeMatrixParams(path.parameters);
    }
    /**
     * @param {?} params
     * @return {?}
     */
    function serializeMatrixParams(params) {
        return Object.keys(params)
            .map(( /**
     * @param {?} key
     * @return {?}
     */function (/**
     * @param {?} key
     * @return {?}
     */ key) { return ";" + encodeUriSegment(key) + "=" + encodeUriSegment(params[key]); }))
            .join('');
    }
    /**
     * @param {?} params
     * @return {?}
     */
    function serializeQueryParams(params) {
        /** @type {?} */
        var strParams = Object.keys(params).map(( /**
         * @param {?} name
         * @return {?}
         */function (name) {
            /** @type {?} */
            var value = params[name];
            return Array.isArray(value) ?
                value.map(( /**
                 * @param {?} v
                 * @return {?}
                 */function (/**
                 * @param {?} v
                 * @return {?}
                 */ v) { return encodeUriQuery(name) + "=" + encodeUriQuery(v); })).join('&') :
                encodeUriQuery(name) + "=" + encodeUriQuery(value);
        }));
        return strParams.length ? "?" + strParams.join("&") : '';
    }
    /** @type {?} */
    var SEGMENT_RE = /^[^\/()?;=#]+/;
    /**
     * @param {?} str
     * @return {?}
     */
    function matchSegments(str) {
        /** @type {?} */
        var match = str.match(SEGMENT_RE);
        return match ? match[0] : '';
    }
    /** @type {?} */
    var QUERY_PARAM_RE = /^[^=?&#]+/;
    // Return the name of the query param at the start of the string or an empty string
    /**
     * @param {?} str
     * @return {?}
     */
    function matchQueryParams(str) {
        /** @type {?} */
        var match = str.match(QUERY_PARAM_RE);
        return match ? match[0] : '';
    }
    /** @type {?} */
    var QUERY_PARAM_VALUE_RE = /^[^?&#]+/;
    // Return the value of the query param at the start of the string or an empty string
    /**
     * @param {?} str
     * @return {?}
     */
    function matchUrlQueryParamValue(str) {
        /** @type {?} */
        var match = str.match(QUERY_PARAM_VALUE_RE);
        return match ? match[0] : '';
    }
    var UrlParser = /** @class */ (function () {
        /**
         * @param {?} url
         */
        function UrlParser(url) {
            this.url = url;
            this.remaining = url;
        }
        /**
         * @return {?}
         */
        UrlParser.prototype.parseRootSegment = function () {
            this.consumeOptional('/');
            if (this.remaining === '' || this.peekStartsWith('?') || this.peekStartsWith('#')) {
                return new UrlSegmentGroup([], {});
            }
            // The root segment group never has segments
            return new UrlSegmentGroup([], this.parseChildren());
        };
        /**
         * @return {?}
         */
        UrlParser.prototype.parseQueryParams = function () {
            /** @type {?} */
            var params = {};
            if (this.consumeOptional('?')) {
                do {
                    this.parseQueryParam(params);
                } while (this.consumeOptional('&'));
            }
            return params;
        };
        /**
         * @return {?}
         */
        UrlParser.prototype.parseFragment = function () {
            return this.consumeOptional('#') ? decodeURIComponent(this.remaining) : null;
        };
        /**
         * @private
         * @return {?}
         */
        UrlParser.prototype.parseChildren = function () {
            if (this.remaining === '') {
                return {};
            }
            this.consumeOptional('/');
            /** @type {?} */
            var segments = [];
            if (!this.peekStartsWith('(')) {
                segments.push(this.parseSegment());
            }
            while (this.peekStartsWith('/') && !this.peekStartsWith('//') && !this.peekStartsWith('/(')) {
                this.capture('/');
                segments.push(this.parseSegment());
            }
            /** @type {?} */
            var children = {};
            if (this.peekStartsWith('/(')) {
                this.capture('/');
                children = this.parseParens(true);
            }
            /** @type {?} */
            var res = {};
            if (this.peekStartsWith('(')) {
                res = this.parseParens(false);
            }
            if (segments.length > 0 || Object.keys(children).length > 0) {
                res[PRIMARY_OUTLET] = new UrlSegmentGroup(segments, children);
            }
            return res;
        };
        // parse a segment with its matrix parameters
        // ie `name;k1=v1;k2`
        /**
         * @private
         * @return {?}
         */
        UrlParser.prototype.parseSegment = function () {
            /** @type {?} */
            var path = matchSegments(this.remaining);
            if (path === '' && this.peekStartsWith(';')) {
                throw new Error("Empty path url segment cannot have parameters: '" + this.remaining + "'.");
            }
            this.capture(path);
            return new UrlSegment(decode(path), this.parseMatrixParams());
        };
        /**
         * @private
         * @return {?}
         */
        UrlParser.prototype.parseMatrixParams = function () {
            /** @type {?} */
            var params = {};
            while (this.consumeOptional(';')) {
                this.parseParam(params);
            }
            return params;
        };
        /**
         * @private
         * @param {?} params
         * @return {?}
         */
        UrlParser.prototype.parseParam = function (params) {
            /** @type {?} */
            var key = matchSegments(this.remaining);
            if (!key) {
                return;
            }
            this.capture(key);
            /** @type {?} */
            var value = '';
            if (this.consumeOptional('=')) {
                /** @type {?} */
                var valueMatch = matchSegments(this.remaining);
                if (valueMatch) {
                    value = valueMatch;
                    this.capture(value);
                }
            }
            params[decode(key)] = decode(value);
        };
        // Parse a single query parameter `name[=value]`
        /**
         * @private
         * @param {?} params
         * @return {?}
         */
        UrlParser.prototype.parseQueryParam = function (params) {
            /** @type {?} */
            var key = matchQueryParams(this.remaining);
            if (!key) {
                return;
            }
            this.capture(key);
            /** @type {?} */
            var value = '';
            if (this.consumeOptional('=')) {
                /** @type {?} */
                var valueMatch = matchUrlQueryParamValue(this.remaining);
                if (valueMatch) {
                    value = valueMatch;
                    this.capture(value);
                }
            }
            /** @type {?} */
            var decodedKey = decodeQuery(key);
            /** @type {?} */
            var decodedVal = decodeQuery(value);
            if (params.hasOwnProperty(decodedKey)) {
                // Append to existing values
                /** @type {?} */
                var currentVal = params[decodedKey];
                if (!Array.isArray(currentVal)) {
                    currentVal = [currentVal];
                    params[decodedKey] = currentVal;
                }
                currentVal.push(decodedVal);
            }
            else {
                // Create a new value
                params[decodedKey] = decodedVal;
            }
        };
        // parse `(a/b//outlet_name:c/d)`
        /**
         * @private
         * @param {?} allowPrimary
         * @return {?}
         */
        UrlParser.prototype.parseParens = function (allowPrimary) {
            /** @type {?} */
            var segments = {};
            this.capture('(');
            while (!this.consumeOptional(')') && this.remaining.length > 0) {
                /** @type {?} */
                var path = matchSegments(this.remaining);
                /** @type {?} */
                var next = this.remaining[path.length];
                // if is is not one of these characters, then the segment was unescaped
                // or the group was not closed
                if (next !== '/' && next !== ')' && next !== ';') {
                    throw new Error("Cannot parse url '" + this.url + "'");
                }
                /** @type {?} */
                var outletName = ( /** @type {?} */(undefined));
                if (path.indexOf(':') > -1) {
                    outletName = path.substr(0, path.indexOf(':'));
                    this.capture(outletName);
                    this.capture(':');
                }
                else if (allowPrimary) {
                    outletName = PRIMARY_OUTLET;
                }
                /** @type {?} */
                var children = this.parseChildren();
                segments[outletName] = Object.keys(children).length === 1 ? children[PRIMARY_OUTLET] :
                    new UrlSegmentGroup([], children);
                this.consumeOptional('//');
            }
            return segments;
        };
        /**
         * @private
         * @param {?} str
         * @return {?}
         */
        UrlParser.prototype.peekStartsWith = function (str) { return this.remaining.startsWith(str); };
        // Consumes the prefix when it is present and returns whether it has been consumed
        /**
         * @private
         * @param {?} str
         * @return {?}
         */
        UrlParser.prototype.consumeOptional = function (str) {
            if (this.peekStartsWith(str)) {
                this.remaining = this.remaining.substring(str.length);
                return true;
            }
            return false;
        };
        /**
         * @private
         * @param {?} str
         * @return {?}
         */
        UrlParser.prototype.capture = function (str) {
            if (!this.consumeOptional(str)) {
                throw new Error("Expected \"" + str + "\".");
            }
        };
        return UrlParser;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @template T
     */
    var Tree = /** @class */ (function () {
        /**
         * @param {?} root
         */
        function Tree(root) {
            this._root = root;
        }
        Object.defineProperty(Tree.prototype, "root", {
            /**
             * @return {?}
             */
            get: function () { return this._root.value; },
            enumerable: true,
            configurable: true
        });
        /**
         * \@internal
         * @param {?} t
         * @return {?}
         */
        Tree.prototype.parent = function (t) {
            /** @type {?} */
            var p = this.pathFromRoot(t);
            return p.length > 1 ? p[p.length - 2] : null;
        };
        /**
         * \@internal
         * @param {?} t
         * @return {?}
         */
        Tree.prototype.children = function (t) {
            /** @type {?} */
            var n = findNode(t, this._root);
            return n ? n.children.map(( /**
             * @param {?} t
             * @return {?}
             */function (/**
             * @param {?} t
             * @return {?}
             */ t) { return t.value; })) : [];
        };
        /**
         * \@internal
         * @param {?} t
         * @return {?}
         */
        Tree.prototype.firstChild = function (t) {
            /** @type {?} */
            var n = findNode(t, this._root);
            return n && n.children.length > 0 ? n.children[0].value : null;
        };
        /**
         * \@internal
         * @param {?} t
         * @return {?}
         */
        Tree.prototype.siblings = function (t) {
            /** @type {?} */
            var p = findPath(t, this._root);
            if (p.length < 2)
                return [];
            /** @type {?} */
            var c = p[p.length - 2].children.map(( /**
             * @param {?} c
             * @return {?}
             */function (/**
             * @param {?} c
             * @return {?}
             */ c) { return c.value; }));
            return c.filter(( /**
             * @param {?} cc
             * @return {?}
             */function (/**
             * @param {?} cc
             * @return {?}
             */ cc) { return cc !== t; }));
        };
        /**
         * \@internal
         * @param {?} t
         * @return {?}
         */
        Tree.prototype.pathFromRoot = function (t) {
            return findPath(t, this._root).map(( /**
             * @param {?} s
             * @return {?}
             */function (/**
             * @param {?} s
             * @return {?}
             */ s) { return s.value; }));
        };
        return Tree;
    }());
    // DFS for the node matching the value
    /**
     * @template T
     * @param {?} value
     * @param {?} node
     * @return {?}
     */
    function findNode(value, node) {
        var e_23, _b;
        if (value === node.value)
            return node;
        try {
            for (var _c = __values(node.children), _d = _c.next(); !_d.done; _d = _c.next()) {
                var child = _d.value;
                /** @type {?} */
                var node_1 = findNode(value, child);
                if (node_1)
                    return node_1;
            }
        }
        catch (e_23_1) { e_23 = { error: e_23_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
            }
            finally { if (e_23) throw e_23.error; }
        }
        return null;
    }
    // Return the path to the node with the given value using DFS
    /**
     * @template T
     * @param {?} value
     * @param {?} node
     * @return {?}
     */
    function findPath(value, node) {
        var e_24, _b;
        if (value === node.value)
            return [node];
        try {
            for (var _c = __values(node.children), _d = _c.next(); !_d.done; _d = _c.next()) {
                var child = _d.value;
                /** @type {?} */
                var path = findPath(value, child);
                if (path.length) {
                    path.unshift(node);
                    return path;
                }
            }
        }
        catch (e_24_1) { e_24 = { error: e_24_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
            }
            finally { if (e_24) throw e_24.error; }
        }
        return [];
    }
    /**
     * @template T
     */
    var TreeNode = /** @class */ (function () {
        /**
         * @param {?} value
         * @param {?} children
         */
        function TreeNode(value, children) {
            this.value = value;
            this.children = children;
        }
        /**
         * @return {?}
         */
        TreeNode.prototype.toString = function () { return "TreeNode(" + this.value + ")"; };
        return TreeNode;
    }());
    // Return the list of T indexed by outlet name
    /**
     * @template T
     * @param {?} node
     * @return {?}
     */
    function nodeChildrenAsMap(node) {
        /** @type {?} */
        var map = {};
        if (node) {
            node.children.forEach(( /**
             * @param {?} child
             * @return {?}
             */function (/**
             * @param {?} child
             * @return {?}
             */ child) { return map[child.value.outlet] = child; }));
        }
        return map;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Represents the state of the router as a tree of activated routes.
     *
     * \@usageNotes
     *
     * Every node in the route tree is an `ActivatedRoute` instance
     * that knows about the "consumed" URL segments, the extracted parameters,
     * and the resolved data.
     * Use the `ActivatedRoute` properties to traverse the tree from any node.
     *
     * ### Example
     *
     * ```
     * \@Component({templateUrl:'template.html'})
     * class MyComponent {
     *   constructor(router: Router) {
     *     const state: RouterState = router.routerState;
     *     const root: ActivatedRoute = state.root;
     *     const child = root.firstChild;
     *     const id: Observable<string> = child.params.map(p => p.id);
     *     //...
     *   }
     * }
     * ```
     *
     * @see `ActivatedRoute`
     *
     * \@publicApi
     */
    var RouterState = /** @class */ (function (_super) {
        __extends(RouterState, _super);
        /**
         * \@internal
         * @param {?} root
         * @param {?} snapshot
         */
        function RouterState(root, snapshot) {
            var _this = _super.call(this, root) || this;
            _this.snapshot = snapshot;
            setRouterState(( /** @type {?} */(_this)), root);
            return _this;
        }
        /**
         * @return {?}
         */
        RouterState.prototype.toString = function () { return this.snapshot.toString(); };
        return RouterState;
    }(Tree));
    /**
     * @param {?} urlTree
     * @param {?} rootComponent
     * @return {?}
     */
    function createEmptyState(urlTree, rootComponent) {
        /** @type {?} */
        var snapshot = createEmptyStateSnapshot(urlTree, rootComponent);
        /** @type {?} */
        var emptyUrl = new BehaviorSubject([new UrlSegment('', {})]);
        /** @type {?} */
        var emptyParams = new BehaviorSubject({});
        /** @type {?} */
        var emptyData = new BehaviorSubject({});
        /** @type {?} */
        var emptyQueryParams = new BehaviorSubject({});
        /** @type {?} */
        var fragment = new BehaviorSubject('');
        /** @type {?} */
        var activated = new ActivatedRoute(emptyUrl, emptyParams, emptyQueryParams, fragment, emptyData, PRIMARY_OUTLET, rootComponent, snapshot.root);
        activated.snapshot = snapshot.root;
        return new RouterState(new TreeNode(activated, []), snapshot);
    }
    /**
     * @param {?} urlTree
     * @param {?} rootComponent
     * @return {?}
     */
    function createEmptyStateSnapshot(urlTree, rootComponent) {
        /** @type {?} */
        var emptyParams = {};
        /** @type {?} */
        var emptyData = {};
        /** @type {?} */
        var emptyQueryParams = {};
        /** @type {?} */
        var fragment = '';
        /** @type {?} */
        var activated = new ActivatedRouteSnapshot([], emptyParams, emptyQueryParams, fragment, emptyData, PRIMARY_OUTLET, rootComponent, null, urlTree.root, -1, {});
        return new RouterStateSnapshot('', new TreeNode(activated, []));
    }
    /**
     * Provides access to information about a route associated with a component
     * that is loaded in an outlet.
     * Use to traverse the `RouterState` tree and extract information from nodes.
     *
     * {\@example router/activated-route/module.ts region="activated-route"
     *     header="activated-route.component.ts"}
     *
     * \@publicApi
     */
    var ActivatedRoute = /** @class */ (function () {
        /**
         * \@internal
         * @param {?} url
         * @param {?} params
         * @param {?} queryParams
         * @param {?} fragment
         * @param {?} data
         * @param {?} outlet
         * @param {?} component
         * @param {?} futureSnapshot
         */
        function ActivatedRoute(url, params, queryParams, fragment, data, outlet, component, futureSnapshot) {
            this.url = url;
            this.params = params;
            this.queryParams = queryParams;
            this.fragment = fragment;
            this.data = data;
            this.outlet = outlet;
            this.component = component;
            this._futureSnapshot = futureSnapshot;
        }
        Object.defineProperty(ActivatedRoute.prototype, "routeConfig", {
            /**
             * The configuration used to match this route.
             * @return {?}
             */
            get: function () { return this._futureSnapshot.routeConfig; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ActivatedRoute.prototype, "root", {
            /**
             * The root of the router state.
             * @return {?}
             */
            get: function () { return this._routerState.root; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ActivatedRoute.prototype, "parent", {
            /**
             * The parent of this route in the router state tree.
             * @return {?}
             */
            get: function () { return this._routerState.parent(this); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ActivatedRoute.prototype, "firstChild", {
            /**
             * The first child of this route in the router state tree.
             * @return {?}
             */
            get: function () { return this._routerState.firstChild(this); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ActivatedRoute.prototype, "children", {
            /**
             * The children of this route in the router state tree.
             * @return {?}
             */
            get: function () { return this._routerState.children(this); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ActivatedRoute.prototype, "pathFromRoot", {
            /**
             * The path from the root of the router state tree to this route.
             * @return {?}
             */
            get: function () { return this._routerState.pathFromRoot(this); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ActivatedRoute.prototype, "paramMap", {
            /**
             * An Observable that contains a map of the required and optional parameters
             * specific to the route.
             * The map supports retrieving single and multiple values from the same parameter.
             * @return {?}
             */
            get: function () {
                if (!this._paramMap) {
                    this._paramMap = this.params.pipe(map(( /**
                     * @param {?} p
                     * @return {?}
                     */function (p) { return convertToParamMap(p); })));
                }
                return this._paramMap;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ActivatedRoute.prototype, "queryParamMap", {
            /**
             * An Observable that contains a map of the query parameters available to all routes.
             * The map supports retrieving single and multiple values from the query parameter.
             * @return {?}
             */
            get: function () {
                if (!this._queryParamMap) {
                    this._queryParamMap =
                        this.queryParams.pipe(map(( /**
                         * @param {?} p
                         * @return {?}
                         */function (p) { return convertToParamMap(p); })));
                }
                return this._queryParamMap;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        ActivatedRoute.prototype.toString = function () {
            return this.snapshot ? this.snapshot.toString() : "Future(" + this._futureSnapshot + ")";
        };
        return ActivatedRoute;
    }());
    /**
     * Returns the inherited params, data, and resolve for a given route.
     * By default, this only inherits values up to the nearest path-less or component-less route.
     * \@internal
     * @param {?} route
     * @param {?=} paramsInheritanceStrategy
     * @return {?}
     */
    function inheritedParamsDataResolve(route, paramsInheritanceStrategy) {
        if (paramsInheritanceStrategy === void 0) { paramsInheritanceStrategy = 'emptyOnly'; }
        /** @type {?} */
        var pathFromRoot = route.pathFromRoot;
        /** @type {?} */
        var inheritingStartingFrom = 0;
        if (paramsInheritanceStrategy !== 'always') {
            inheritingStartingFrom = pathFromRoot.length - 1;
            while (inheritingStartingFrom >= 1) {
                /** @type {?} */
                var current = pathFromRoot[inheritingStartingFrom];
                /** @type {?} */
                var parent_6 = pathFromRoot[inheritingStartingFrom - 1];
                // current route is an empty path => inherits its parent's params and data
                if (current.routeConfig && current.routeConfig.path === '') {
                    inheritingStartingFrom--;
                    // parent is componentless => current route should inherit its params and data
                }
                else if (!parent_6.component) {
                    inheritingStartingFrom--;
                }
                else {
                    break;
                }
            }
        }
        return flattenInherited(pathFromRoot.slice(inheritingStartingFrom));
    }
    /**
     * \@internal
     * @param {?} pathFromRoot
     * @return {?}
     */
    function flattenInherited(pathFromRoot) {
        return pathFromRoot.reduce(( /**
         * @param {?} res
         * @param {?} curr
         * @return {?}
         */function (res, curr) {
            /** @type {?} */
            var params = Object.assign({}, res.params, curr.params);
            /** @type {?} */
            var data = Object.assign({}, res.data, curr.data);
            /** @type {?} */
            var resolve = Object.assign({}, res.resolve, curr._resolvedData);
            return { params: params, data: data, resolve: resolve };
        }), ( /** @type {?} */({ params: {}, data: {}, resolve: {} })));
    }
    /**
     * \@description
     *
     * Contains the information about a route associated with a component loaded in an
     * outlet at a particular moment in time. ActivatedRouteSnapshot can also be used to
     * traverse the router state tree.
     *
     * ```
     * \@Component({templateUrl:'./my-component.html'})
     * class MyComponent {
     *   constructor(route: ActivatedRoute) {
     *     const id: string = route.snapshot.params.id;
     *     const url: string = route.snapshot.url.join('');
     *     const user = route.snapshot.data.user;
     *   }
     * }
     * ```
     *
     * \@publicApi
     */
    var ActivatedRouteSnapshot = /** @class */ (function () {
        /**
         * \@internal
         * @param {?} url
         * @param {?} params
         * @param {?} queryParams
         * @param {?} fragment
         * @param {?} data
         * @param {?} outlet
         * @param {?} component
         * @param {?} routeConfig
         * @param {?} urlSegment
         * @param {?} lastPathIndex
         * @param {?} resolve
         */
        function ActivatedRouteSnapshot(url, params, queryParams, fragment, data, outlet, component, routeConfig, urlSegment, lastPathIndex, resolve) {
            this.url = url;
            this.params = params;
            this.queryParams = queryParams;
            this.fragment = fragment;
            this.data = data;
            this.outlet = outlet;
            this.component = component;
            this.routeConfig = routeConfig;
            this._urlSegment = urlSegment;
            this._lastPathIndex = lastPathIndex;
            this._resolve = resolve;
        }
        Object.defineProperty(ActivatedRouteSnapshot.prototype, "root", {
            /**
             * The root of the router state
             * @return {?}
             */
            get: function () { return this._routerState.root; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ActivatedRouteSnapshot.prototype, "parent", {
            /**
             * The parent of this route in the router state tree
             * @return {?}
             */
            get: function () { return this._routerState.parent(this); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ActivatedRouteSnapshot.prototype, "firstChild", {
            /**
             * The first child of this route in the router state tree
             * @return {?}
             */
            get: function () { return this._routerState.firstChild(this); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ActivatedRouteSnapshot.prototype, "children", {
            /**
             * The children of this route in the router state tree
             * @return {?}
             */
            get: function () { return this._routerState.children(this); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ActivatedRouteSnapshot.prototype, "pathFromRoot", {
            /**
             * The path from the root of the router state tree to this route
             * @return {?}
             */
            get: function () { return this._routerState.pathFromRoot(this); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ActivatedRouteSnapshot.prototype, "paramMap", {
            /**
             * @return {?}
             */
            get: function () {
                if (!this._paramMap) {
                    this._paramMap = convertToParamMap(this.params);
                }
                return this._paramMap;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ActivatedRouteSnapshot.prototype, "queryParamMap", {
            /**
             * @return {?}
             */
            get: function () {
                if (!this._queryParamMap) {
                    this._queryParamMap = convertToParamMap(this.queryParams);
                }
                return this._queryParamMap;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        ActivatedRouteSnapshot.prototype.toString = function () {
            /** @type {?} */
            var url = this.url.map(( /**
             * @param {?} segment
             * @return {?}
             */function (/**
             * @param {?} segment
             * @return {?}
             */ segment) { return segment.toString(); })).join('/');
            /** @type {?} */
            var matched = this.routeConfig ? this.routeConfig.path : '';
            return "Route(url:'" + url + "', path:'" + matched + "')";
        };
        return ActivatedRouteSnapshot;
    }());
    /**
     * \@description
     *
     * Represents the state of the router at a moment in time.
     *
     * This is a tree of activated route snapshots. Every node in this tree knows about
     * the "consumed" URL segments, the extracted parameters, and the resolved data.
     *
     * \@usageNotes
     * ### Example
     *
     * ```
     * \@Component({templateUrl:'template.html'})
     * class MyComponent {
     *   constructor(router: Router) {
     *     const state: RouterState = router.routerState;
     *     const snapshot: RouterStateSnapshot = state.snapshot;
     *     const root: ActivatedRouteSnapshot = snapshot.root;
     *     const child = root.firstChild;
     *     const id: Observable<string> = child.params.map(p => p.id);
     *     //...
     *   }
     * }
     * ```
     *
     * \@publicApi
     */
    var RouterStateSnapshot = /** @class */ (function (_super) {
        __extends(RouterStateSnapshot, _super);
        /**
         * \@internal
         * @param {?} url
         * @param {?} root
         */
        function RouterStateSnapshot(url, root) {
            var _this = _super.call(this, root) || this;
            _this.url = url;
            setRouterState(( /** @type {?} */(_this)), root);
            return _this;
        }
        /**
         * @return {?}
         */
        RouterStateSnapshot.prototype.toString = function () { return serializeNode(this._root); };
        return RouterStateSnapshot;
    }(Tree));
    /**
     * @template U, T
     * @param {?} state
     * @param {?} node
     * @return {?}
     */
    function setRouterState(state, node) {
        node.value._routerState = state;
        node.children.forEach(( /**
         * @param {?} c
         * @return {?}
         */function (/**
         * @param {?} c
         * @return {?}
         */ c) { return setRouterState(state, c); }));
    }
    /**
     * @param {?} node
     * @return {?}
     */
    function serializeNode(node) {
        /** @type {?} */
        var c = node.children.length > 0 ? " { " + node.children.map(serializeNode).join(', ') + " } " : '';
        return "" + node.value + c;
    }
    /**
     * The expectation is that the activate route is created with the right set of parameters.
     * So we push new values into the observables only when they are not the initial values.
     * And we detect that by checking if the snapshot field is set.
     * @param {?} route
     * @return {?}
     */
    function advanceActivatedRoute(route) {
        if (route.snapshot) {
            /** @type {?} */
            var currentSnapshot = route.snapshot;
            /** @type {?} */
            var nextSnapshot = route._futureSnapshot;
            route.snapshot = nextSnapshot;
            if (!shallowEqual(currentSnapshot.queryParams, nextSnapshot.queryParams)) {
                (( /** @type {?} */(route.queryParams))).next(nextSnapshot.queryParams);
            }
            if (currentSnapshot.fragment !== nextSnapshot.fragment) {
                (( /** @type {?} */(route.fragment))).next(nextSnapshot.fragment);
            }
            if (!shallowEqual(currentSnapshot.params, nextSnapshot.params)) {
                (( /** @type {?} */(route.params))).next(nextSnapshot.params);
            }
            if (!shallowEqualArrays(currentSnapshot.url, nextSnapshot.url)) {
                (( /** @type {?} */(route.url))).next(nextSnapshot.url);
            }
            if (!shallowEqual(currentSnapshot.data, nextSnapshot.data)) {
                (( /** @type {?} */(route.data))).next(nextSnapshot.data);
            }
        }
        else {
            route.snapshot = route._futureSnapshot;
            // this is for resolved data
            (( /** @type {?} */(route.data))).next(route._futureSnapshot.data);
        }
    }
    /**
     * @param {?} a
     * @param {?} b
     * @return {?}
     */
    function equalParamsAndUrlSegments(a, b) {
        /** @type {?} */
        var equalUrlParams = shallowEqual(a.params, b.params) && equalSegments(a.url, b.url);
        /** @type {?} */
        var parentsMismatch = !a.parent !== !b.parent;
        return equalUrlParams && !parentsMismatch &&
            (!a.parent || equalParamsAndUrlSegments(a.parent, ( /** @type {?} */(b.parent))));
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} routeReuseStrategy
     * @param {?} curr
     * @param {?} prevState
     * @return {?}
     */
    function createRouterState(routeReuseStrategy, curr, prevState) {
        /** @type {?} */
        var root = createNode(routeReuseStrategy, curr._root, prevState ? prevState._root : undefined);
        return new RouterState(root, curr);
    }
    /**
     * @param {?} routeReuseStrategy
     * @param {?} curr
     * @param {?=} prevState
     * @return {?}
     */
    function createNode(routeReuseStrategy, curr, prevState) {
        // reuse an activated route that is currently displayed on the screen
        if (prevState && routeReuseStrategy.shouldReuseRoute(curr.value, prevState.value.snapshot)) {
            /** @type {?} */
            var value = prevState.value;
            value._futureSnapshot = curr.value;
            /** @type {?} */
            var children = createOrReuseChildren(routeReuseStrategy, curr, prevState);
            return new TreeNode(value, children);
            // retrieve an activated route that is used to be displayed, but is not currently displayed
        }
        else {
            /** @type {?} */
            var detachedRouteHandle = ( /** @type {?} */(routeReuseStrategy.retrieve(curr.value)));
            if (detachedRouteHandle) {
                /** @type {?} */
                var tree_1 = detachedRouteHandle.route;
                setFutureSnapshotsOfActivatedRoutes(curr, tree_1);
                return tree_1;
            }
            else {
                /** @type {?} */
                var value = createActivatedRoute(curr.value);
                /** @type {?} */
                var children = curr.children.map(( /**
                 * @param {?} c
                 * @return {?}
                 */function (/**
                 * @param {?} c
                 * @return {?}
                 */ c) { return createNode(routeReuseStrategy, c); }));
                return new TreeNode(value, children);
            }
        }
    }
    /**
     * @param {?} curr
     * @param {?} result
     * @return {?}
     */
    function setFutureSnapshotsOfActivatedRoutes(curr, result) {
        if (curr.value.routeConfig !== result.value.routeConfig) {
            throw new Error('Cannot reattach ActivatedRouteSnapshot created from a different route');
        }
        if (curr.children.length !== result.children.length) {
            throw new Error('Cannot reattach ActivatedRouteSnapshot with a different number of children');
        }
        result.value._futureSnapshot = curr.value;
        for (var i_170 = 0; i_170 < curr.children.length; ++i_170) {
            setFutureSnapshotsOfActivatedRoutes(curr.children[i_170], result.children[i_170]);
        }
    }
    /**
     * @param {?} routeReuseStrategy
     * @param {?} curr
     * @param {?} prevState
     * @return {?}
     */
    function createOrReuseChildren(routeReuseStrategy, curr, prevState) {
        return curr.children.map(( /**
         * @param {?} child
         * @return {?}
         */function (/**
         * @param {?} child
         * @return {?}
         */ child) {
            var e_25, _b;
            try {
                for (var _c = __values(prevState.children), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var p_3 = _d.value;
                    if (routeReuseStrategy.shouldReuseRoute(p_3.value.snapshot, child.value)) {
                        return createNode(routeReuseStrategy, child, p_3);
                    }
                }
            }
            catch (e_25_1) { e_25 = { error: e_25_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
                }
                finally { if (e_25) throw e_25.error; }
            }
            return createNode(routeReuseStrategy, child);
        }));
    }
    /**
     * @param {?} c
     * @return {?}
     */
    function createActivatedRoute(c) {
        return new ActivatedRoute(new BehaviorSubject(c.url), new BehaviorSubject(c.params), new BehaviorSubject(c.queryParams), new BehaviorSubject(c.fragment), new BehaviorSubject(c.data), c.outlet, c.component, c);
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} route
     * @param {?} urlTree
     * @param {?} commands
     * @param {?} queryParams
     * @param {?} fragment
     * @return {?}
     */
    function createUrlTree(route, urlTree, commands, queryParams, fragment) {
        if (commands.length === 0) {
            return tree(urlTree.root, urlTree.root, urlTree, queryParams, fragment);
        }
        /** @type {?} */
        var nav = computeNavigation(commands);
        if (nav.toRoot()) {
            return tree(urlTree.root, new UrlSegmentGroup([], {}), urlTree, queryParams, fragment);
        }
        /** @type {?} */
        var startingPosition = findStartingPosition(nav, urlTree, route);
        /** @type {?} */
        var segmentGroup = startingPosition.processChildren ?
            updateSegmentGroupChildren(startingPosition.segmentGroup, startingPosition.index, nav.commands) :
            updateSegmentGroup(startingPosition.segmentGroup, startingPosition.index, nav.commands);
        return tree(startingPosition.segmentGroup, segmentGroup, urlTree, queryParams, fragment);
    }
    /**
     * @param {?} command
     * @return {?}
     */
    function isMatrixParams(command) {
        return typeof command === 'object' && command != null && !command.outlets && !command.segmentPath;
    }
    /**
     * @param {?} oldSegmentGroup
     * @param {?} newSegmentGroup
     * @param {?} urlTree
     * @param {?} queryParams
     * @param {?} fragment
     * @return {?}
     */
    function tree(oldSegmentGroup, newSegmentGroup, urlTree, queryParams, fragment) {
        /** @type {?} */
        var qp = {};
        if (queryParams) {
            forEach(queryParams, ( /**
             * @param {?} value
             * @param {?} name
             * @return {?}
             */function (value, name) {
                qp[name] = Array.isArray(value) ? value.map(( /**
                 * @param {?} v
                 * @return {?}
                 */function (v) { return "" + v; })) : "" + value;
            }));
        }
        if (urlTree.root === oldSegmentGroup) {
            return new UrlTree(newSegmentGroup, qp, fragment);
        }
        return new UrlTree(replaceSegment(urlTree.root, oldSegmentGroup, newSegmentGroup), qp, fragment);
    }
    /**
     * @param {?} current
     * @param {?} oldSegment
     * @param {?} newSegment
     * @return {?}
     */
    function replaceSegment(current, oldSegment, newSegment) {
        /** @type {?} */
        var children = {};
        forEach(current.children, ( /**
         * @param {?} c
         * @param {?} outletName
         * @return {?}
         */function (c, outletName) {
            if (c === oldSegment) {
                children[outletName] = newSegment;
            }
            else {
                children[outletName] = replaceSegment(c, oldSegment, newSegment);
            }
        }));
        return new UrlSegmentGroup(current.segments, children);
    }
    var Navigation = /** @class */ (function () {
        /**
         * @param {?} isAbsolute
         * @param {?} numberOfDoubleDots
         * @param {?} commands
         */
        function Navigation(isAbsolute, numberOfDoubleDots, commands) {
            this.isAbsolute = isAbsolute;
            this.numberOfDoubleDots = numberOfDoubleDots;
            this.commands = commands;
            if (isAbsolute && commands.length > 0 && isMatrixParams(commands[0])) {
                throw new Error('Root segment cannot have matrix parameters');
            }
            /** @type {?} */
            var cmdWithOutlet = commands.find(( /**
             * @param {?} c
             * @return {?}
             */function (/**
             * @param {?} c
             * @return {?}
             */ c) { return typeof c === 'object' && c != null && c.outlets; }));
            if (cmdWithOutlet && cmdWithOutlet !== last$1(commands)) {
                throw new Error('{outlets:{}} has to be the last command');
            }
        }
        /**
         * @return {?}
         */
        Navigation.prototype.toRoot = function () {
            return this.isAbsolute && this.commands.length === 1 && this.commands[0] == '/';
        };
        return Navigation;
    }());
    /**
     * Transforms commands to a normalized `Navigation`
     * @param {?} commands
     * @return {?}
     */
    function computeNavigation(commands) {
        if ((typeof commands[0] === 'string') && commands.length === 1 && commands[0] === '/') {
            return new Navigation(true, 0, commands);
        }
        /** @type {?} */
        var numberOfDoubleDots = 0;
        /** @type {?} */
        var isAbsolute = false;
        /** @type {?} */
        var res = commands.reduce(( /**
         * @param {?} res
         * @param {?} cmd
         * @param {?} cmdIdx
         * @return {?}
         */function (res, cmd, cmdIdx) {
            if (typeof cmd === 'object' && cmd != null) {
                if (cmd.outlets) {
                    /** @type {?} */
                    var outlets_1 = {};
                    forEach(cmd.outlets, ( /**
                     * @param {?} commands
                     * @param {?} name
                     * @return {?}
                     */function (commands, name) {
                        outlets_1[name] = typeof commands === 'string' ? commands.split('/') : commands;
                    }));
                    return __spread(res, [{ outlets: outlets_1 }]);
                }
                if (cmd.segmentPath) {
                    return __spread(res, [cmd.segmentPath]);
                }
            }
            if (!(typeof cmd === 'string')) {
                return __spread(res, [cmd]);
            }
            if (cmdIdx === 0) {
                cmd.split('/').forEach(( /**
                 * @param {?} urlPart
                 * @param {?} partIndex
                 * @return {?}
                 */function (urlPart, partIndex) {
                    if (partIndex == 0 && urlPart === '.')
                        ;
                    else if (partIndex == 0 && urlPart === '') { //  '/a'
                        isAbsolute = true;
                    }
                    else if (urlPart === '..') { //  '../a'
                        numberOfDoubleDots++;
                    }
                    else if (urlPart != '') {
                        res.push(urlPart);
                    }
                }));
                return res;
            }
            return __spread(res, [cmd]);
        }), []);
        return new Navigation(isAbsolute, numberOfDoubleDots, res);
    }
    var Position = /** @class */ (function () {
        /**
         * @param {?} segmentGroup
         * @param {?} processChildren
         * @param {?} index
         */
        function Position(segmentGroup, processChildren, index) {
            this.segmentGroup = segmentGroup;
            this.processChildren = processChildren;
            this.index = index;
        }
        return Position;
    }());
    /**
     * @param {?} nav
     * @param {?} tree
     * @param {?} route
     * @return {?}
     */
    function findStartingPosition(nav, tree, route) {
        if (nav.isAbsolute) {
            return new Position(tree.root, true, 0);
        }
        if (route.snapshot._lastPathIndex === -1) {
            return new Position(route.snapshot._urlSegment, true, 0);
        }
        /** @type {?} */
        var modifier = isMatrixParams(nav.commands[0]) ? 0 : 1;
        /** @type {?} */
        var index = route.snapshot._lastPathIndex + modifier;
        return createPositionApplyingDoubleDots(route.snapshot._urlSegment, index, nav.numberOfDoubleDots);
    }
    /**
     * @param {?} group
     * @param {?} index
     * @param {?} numberOfDoubleDots
     * @return {?}
     */
    function createPositionApplyingDoubleDots(group, index, numberOfDoubleDots) {
        /** @type {?} */
        var g = group;
        /** @type {?} */
        var ci = index;
        /** @type {?} */
        var dd = numberOfDoubleDots;
        while (dd > ci) {
            dd -= ci;
            g = ( /** @type {?} */(g.parent));
            if (!g) {
                throw new Error('Invalid number of \'../\'');
            }
            ci = g.segments.length;
        }
        return new Position(g, false, ci - dd);
    }
    /**
     * @param {?} command
     * @return {?}
     */
    function getPath(command) {
        if (typeof command === 'object' && command != null && command.outlets) {
            return command.outlets[PRIMARY_OUTLET];
        }
        return "" + command;
    }
    /**
     * @param {?} commands
     * @return {?}
     */
    function getOutlets(commands) {
        var _b, _c;
        if (!(typeof commands[0] === 'object'))
            return _b = {}, _b[PRIMARY_OUTLET] = commands, _b;
        if (commands[0].outlets === undefined)
            return _c = {}, _c[PRIMARY_OUTLET] = commands, _c;
        return commands[0].outlets;
    }
    /**
     * @param {?} segmentGroup
     * @param {?} startIndex
     * @param {?} commands
     * @return {?}
     */
    function updateSegmentGroup(segmentGroup, startIndex, commands) {
        if (!segmentGroup) {
            segmentGroup = new UrlSegmentGroup([], {});
        }
        if (segmentGroup.segments.length === 0 && segmentGroup.hasChildren()) {
            return updateSegmentGroupChildren(segmentGroup, startIndex, commands);
        }
        /** @type {?} */
        var m = prefixedWith(segmentGroup, startIndex, commands);
        /** @type {?} */
        var slicedCommands = commands.slice(m.commandIndex);
        if (m.match && m.pathIndex < segmentGroup.segments.length) {
            /** @type {?} */
            var g_1 = new UrlSegmentGroup(segmentGroup.segments.slice(0, m.pathIndex), {});
            g_1.children[PRIMARY_OUTLET] =
                new UrlSegmentGroup(segmentGroup.segments.slice(m.pathIndex), segmentGroup.children);
            return updateSegmentGroupChildren(g_1, 0, slicedCommands);
        }
        else if (m.match && slicedCommands.length === 0) {
            return new UrlSegmentGroup(segmentGroup.segments, {});
        }
        else if (m.match && !segmentGroup.hasChildren()) {
            return createNewSegmentGroup(segmentGroup, startIndex, commands);
        }
        else if (m.match) {
            return updateSegmentGroupChildren(segmentGroup, 0, slicedCommands);
        }
        else {
            return createNewSegmentGroup(segmentGroup, startIndex, commands);
        }
    }
    /**
     * @param {?} segmentGroup
     * @param {?} startIndex
     * @param {?} commands
     * @return {?}
     */
    function updateSegmentGroupChildren(segmentGroup, startIndex, commands) {
        if (commands.length === 0) {
            return new UrlSegmentGroup(segmentGroup.segments, {});
        }
        else {
            /** @type {?} */
            var outlets_2 = getOutlets(commands);
            /** @type {?} */
            var children_2 = {};
            forEach(outlets_2, ( /**
             * @param {?} commands
             * @param {?} outlet
             * @return {?}
             */function (commands, outlet) {
                if (commands !== null) {
                    children_2[outlet] = updateSegmentGroup(segmentGroup.children[outlet], startIndex, commands);
                }
            }));
            forEach(segmentGroup.children, ( /**
             * @param {?} child
             * @param {?} childOutlet
             * @return {?}
             */function (child, childOutlet) {
                if (outlets_2[childOutlet] === undefined) {
                    children_2[childOutlet] = child;
                }
            }));
            return new UrlSegmentGroup(segmentGroup.segments, children_2);
        }
    }
    /**
     * @param {?} segmentGroup
     * @param {?} startIndex
     * @param {?} commands
     * @return {?}
     */
    function prefixedWith(segmentGroup, startIndex, commands) {
        /** @type {?} */
        var currentCommandIndex = 0;
        /** @type {?} */
        var currentPathIndex = startIndex;
        /** @type {?} */
        var noMatch = { match: false, pathIndex: 0, commandIndex: 0 };
        while (currentPathIndex < segmentGroup.segments.length) {
            if (currentCommandIndex >= commands.length)
                return noMatch;
            /** @type {?} */
            var path = segmentGroup.segments[currentPathIndex];
            /** @type {?} */
            var curr = getPath(commands[currentCommandIndex]);
            /** @type {?} */
            var next = currentCommandIndex < commands.length - 1 ? commands[currentCommandIndex + 1] : null;
            if (currentPathIndex > 0 && curr === undefined)
                break;
            if (curr && next && (typeof next === 'object') && next.outlets === undefined) {
                if (!compare(curr, next, path))
                    return noMatch;
                currentCommandIndex += 2;
            }
            else {
                if (!compare(curr, {}, path))
                    return noMatch;
                currentCommandIndex++;
            }
            currentPathIndex++;
        }
        return { match: true, pathIndex: currentPathIndex, commandIndex: currentCommandIndex };
    }
    /**
     * @param {?} segmentGroup
     * @param {?} startIndex
     * @param {?} commands
     * @return {?}
     */
    function createNewSegmentGroup(segmentGroup, startIndex, commands) {
        /** @type {?} */
        var paths = segmentGroup.segments.slice(0, startIndex);
        /** @type {?} */
        var i = 0;
        while (i < commands.length) {
            if (typeof commands[i] === 'object' && commands[i].outlets !== undefined) {
                /** @type {?} */
                var children = createNewSegmentChildren(commands[i].outlets);
                return new UrlSegmentGroup(paths, children);
            }
            // if we start with an object literal, we need to reuse the path part from the segment
            if (i === 0 && isMatrixParams(commands[0])) {
                /** @type {?} */
                var p_4 = segmentGroup.segments[startIndex];
                paths.push(new UrlSegment(p_4.path, commands[0]));
                i++;
                continue;
            }
            /** @type {?} */
            var curr = getPath(commands[i]);
            /** @type {?} */
            var next = (i < commands.length - 1) ? commands[i + 1] : null;
            if (curr && next && isMatrixParams(next)) {
                paths.push(new UrlSegment(curr, stringify$1(next)));
                i += 2;
            }
            else {
                paths.push(new UrlSegment(curr, {}));
                i++;
            }
        }
        return new UrlSegmentGroup(paths, {});
    }
    /**
     * @param {?} outlets
     * @return {?}
     */
    function createNewSegmentChildren(outlets) {
        /** @type {?} */
        var children = {};
        forEach(outlets, ( /**
         * @param {?} commands
         * @param {?} outlet
         * @return {?}
         */function (commands, outlet) {
            if (commands !== null) {
                children[outlet] = createNewSegmentGroup(new UrlSegmentGroup([], {}), 0, commands);
            }
        }));
        return children;
    }
    /**
     * @param {?} params
     * @return {?}
     */
    function stringify$1(params) {
        /** @type {?} */
        var res = {};
        forEach(params, ( /**
         * @param {?} v
         * @param {?} k
         * @return {?}
         */function (v, k) { return res[k] = "" + v; }));
        return res;
    }
    /**
     * @param {?} path
     * @param {?} params
     * @param {?} segment
     * @return {?}
     */
    function compare(path, params, segment) {
        return path == segment.path && shallowEqual(params, segment.parameters);
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var activateRoutes = ( /**
     * @param {?} rootContexts
     * @param {?} routeReuseStrategy
     * @param {?} forwardEvent
     * @return {?}
     */function (rootContexts, routeReuseStrategy, forwardEvent) { return map(( /**
     * @param {?} t
     * @return {?}
     */function (/**
     * @param {?} t
     * @return {?}
     */ t) {
        new ActivateRoutes(routeReuseStrategy, ( /** @type {?} */(t.targetRouterState)), t.currentRouterState, forwardEvent)
            .activate(rootContexts);
        return t;
    })); });
    var ActivateRoutes = /** @class */ (function () {
        /**
         * @param {?} routeReuseStrategy
         * @param {?} futureState
         * @param {?} currState
         * @param {?} forwardEvent
         */
        function ActivateRoutes(routeReuseStrategy, futureState, currState, forwardEvent) {
            this.routeReuseStrategy = routeReuseStrategy;
            this.futureState = futureState;
            this.currState = currState;
            this.forwardEvent = forwardEvent;
        }
        /**
         * @param {?} parentContexts
         * @return {?}
         */
        ActivateRoutes.prototype.activate = function (parentContexts) {
            /** @type {?} */
            var futureRoot = this.futureState._root;
            /** @type {?} */
            var currRoot = this.currState ? this.currState._root : null;
            this.deactivateChildRoutes(futureRoot, currRoot, parentContexts);
            advanceActivatedRoute(this.futureState.root);
            this.activateChildRoutes(futureRoot, currRoot, parentContexts);
        };
        // De-activate the child route that are not re-used for the future state
        /**
         * @private
         * @param {?} futureNode
         * @param {?} currNode
         * @param {?} contexts
         * @return {?}
         */
        ActivateRoutes.prototype.deactivateChildRoutes = function (futureNode, currNode, contexts) {
            var _this = this;
            /** @type {?} */
            var children = nodeChildrenAsMap(currNode);
            // Recurse on the routes active in the future state to de-activate deeper children
            futureNode.children.forEach(( /**
             * @param {?} futureChild
             * @return {?}
             */function (/**
             * @param {?} futureChild
             * @return {?}
             */ futureChild) {
                /** @type {?} */
                var childOutletName = futureChild.value.outlet;
                _this.deactivateRoutes(futureChild, children[childOutletName], contexts);
                delete children[childOutletName];
            }));
            // De-activate the routes that will not be re-used
            forEach(children, ( /**
             * @param {?} v
             * @param {?} childName
             * @return {?}
             */function (v, childName) {
                _this.deactivateRouteAndItsChildren(v, contexts);
            }));
        };
        /**
         * @private
         * @param {?} futureNode
         * @param {?} currNode
         * @param {?} parentContext
         * @return {?}
         */
        ActivateRoutes.prototype.deactivateRoutes = function (futureNode, currNode, parentContext) {
            /** @type {?} */
            var future = futureNode.value;
            /** @type {?} */
            var curr = currNode ? currNode.value : null;
            if (future === curr) {
                // Reusing the node, check to see if the children need to be de-activated
                if (future.component) {
                    // If we have a normal route, we need to go through an outlet.
                    /** @type {?} */
                    var context = parentContext.getContext(future.outlet);
                    if (context) {
                        this.deactivateChildRoutes(futureNode, currNode, context.children);
                    }
                }
                else {
                    // if we have a componentless route, we recurse but keep the same outlet map.
                    this.deactivateChildRoutes(futureNode, currNode, parentContext);
                }
            }
            else {
                if (curr) {
                    // Deactivate the current route which will not be re-used
                    this.deactivateRouteAndItsChildren(currNode, parentContext);
                }
            }
        };
        /**
         * @private
         * @param {?} route
         * @param {?} parentContexts
         * @return {?}
         */
        ActivateRoutes.prototype.deactivateRouteAndItsChildren = function (route, parentContexts) {
            if (this.routeReuseStrategy.shouldDetach(route.value.snapshot)) {
                this.detachAndStoreRouteSubtree(route, parentContexts);
            }
            else {
                this.deactivateRouteAndOutlet(route, parentContexts);
            }
        };
        /**
         * @private
         * @param {?} route
         * @param {?} parentContexts
         * @return {?}
         */
        ActivateRoutes.prototype.detachAndStoreRouteSubtree = function (route, parentContexts) {
            /** @type {?} */
            var context = parentContexts.getContext(route.value.outlet);
            if (context && context.outlet) {
                /** @type {?} */
                var componentRef = context.outlet.detach();
                /** @type {?} */
                var contexts = context.children.onOutletDeactivated();
                this.routeReuseStrategy.store(route.value.snapshot, { componentRef: componentRef, route: route, contexts: contexts });
            }
        };
        /**
         * @private
         * @param {?} route
         * @param {?} parentContexts
         * @return {?}
         */
        ActivateRoutes.prototype.deactivateRouteAndOutlet = function (route, parentContexts) {
            var _this = this;
            /** @type {?} */
            var context = parentContexts.getContext(route.value.outlet);
            if (context) {
                /** @type {?} */
                var children = nodeChildrenAsMap(route);
                /** @type {?} */
                var contexts_1 = route.value.component ? context.children : parentContexts;
                forEach(children, ( /**
                 * @param {?} v
                 * @param {?} k
                 * @return {?}
                 */function (v, k) { return _this.deactivateRouteAndItsChildren(v, contexts_1); }));
                if (context.outlet) {
                    // Destroy the component
                    context.outlet.deactivate();
                    // Destroy the contexts for all the outlets that were in the component
                    context.children.onOutletDeactivated();
                }
            }
        };
        /**
         * @private
         * @param {?} futureNode
         * @param {?} currNode
         * @param {?} contexts
         * @return {?}
         */
        ActivateRoutes.prototype.activateChildRoutes = function (futureNode, currNode, contexts) {
            var _this = this;
            /** @type {?} */
            var children = nodeChildrenAsMap(currNode);
            futureNode.children.forEach(( /**
             * @param {?} c
             * @return {?}
             */function (/**
             * @param {?} c
             * @return {?}
             */ c) {
                _this.activateRoutes(c, children[c.value.outlet], contexts);
                _this.forwardEvent(new ActivationEnd(c.value.snapshot));
            }));
            if (futureNode.children.length) {
                this.forwardEvent(new ChildActivationEnd(futureNode.value.snapshot));
            }
        };
        /**
         * @private
         * @param {?} futureNode
         * @param {?} currNode
         * @param {?} parentContexts
         * @return {?}
         */
        ActivateRoutes.prototype.activateRoutes = function (futureNode, currNode, parentContexts) {
            /** @type {?} */
            var future = futureNode.value;
            /** @type {?} */
            var curr = currNode ? currNode.value : null;
            advanceActivatedRoute(future);
            // reusing the node
            if (future === curr) {
                if (future.component) {
                    // If we have a normal route, we need to go through an outlet.
                    /** @type {?} */
                    var context = parentContexts.getOrCreateContext(future.outlet);
                    this.activateChildRoutes(futureNode, currNode, context.children);
                }
                else {
                    // if we have a componentless route, we recurse but keep the same outlet map.
                    this.activateChildRoutes(futureNode, currNode, parentContexts);
                }
            }
            else {
                if (future.component) {
                    // if we have a normal route, we need to place the component into the outlet and recurse.
                    /** @type {?} */
                    var context = parentContexts.getOrCreateContext(future.outlet);
                    if (this.routeReuseStrategy.shouldAttach(future.snapshot)) {
                        /** @type {?} */
                        var stored = (( /** @type {?} */(this.routeReuseStrategy.retrieve(future.snapshot))));
                        this.routeReuseStrategy.store(future.snapshot, null);
                        context.children.onOutletReAttached(stored.contexts);
                        context.attachRef = stored.componentRef;
                        context.route = stored.route.value;
                        if (context.outlet) {
                            // Attach right away when the outlet has already been instantiated
                            // Otherwise attach from `RouterOutlet.ngOnInit` when it is instantiated
                            context.outlet.attach(stored.componentRef, stored.route.value);
                        }
                        advanceActivatedRouteNodeAndItsChildren(stored.route);
                    }
                    else {
                        /** @type {?} */
                        var config_1 = parentLoadedConfig(future.snapshot);
                        /** @type {?} */
                        var cmpFactoryResolver = config_1 ? config_1.module.componentFactoryResolver : null;
                        context.attachRef = null;
                        context.route = future;
                        context.resolver = cmpFactoryResolver;
                        if (context.outlet) {
                            // Activate the outlet when it has already been instantiated
                            // Otherwise it will get activated from its `ngOnInit` when instantiated
                            context.outlet.activateWith(future, cmpFactoryResolver);
                        }
                        this.activateChildRoutes(futureNode, null, context.children);
                    }
                }
                else {
                    // if we have a componentless route, we recurse but keep the same outlet map.
                    this.activateChildRoutes(futureNode, null, parentContexts);
                }
            }
        };
        return ActivateRoutes;
    }());
    /**
     * @param {?} node
     * @return {?}
     */
    function advanceActivatedRouteNodeAndItsChildren(node) {
        advanceActivatedRoute(node.value);
        node.children.forEach(advanceActivatedRouteNodeAndItsChildren);
    }
    /**
     * @param {?} snapshot
     * @return {?}
     */
    function parentLoadedConfig(snapshot) {
        for (var s_2 = snapshot.parent; s_2; s_2 = s_2.parent) {
            /** @type {?} */
            var route = s_2.routeConfig;
            if (route && route._loadedConfig)
                return route._loadedConfig;
            if (route && route.component)
                return null;
        }
        return null;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Simple function check, but generic so type inference will flow. Example:
     *
     * function product(a: number, b: number) {
     *   return a * b;
     * }
     *
     * if (isFunction<product>(fn)) {
     *   return fn(1, 2);
     * } else {
     *   throw "Must provide the `product` function";
     * }
     * @template T
     * @param {?} v
     * @return {?}
     */
    function isFunction$2(v) {
        return typeof v === 'function';
    }
    /**
     * @param {?} v
     * @return {?}
     */
    function isBoolean$1(v) {
        return typeof v === 'boolean';
    }
    /**
     * @param {?} v
     * @return {?}
     */
    function isUrlTree(v) {
        return v instanceof UrlTree;
    }
    /**
     * @param {?} guard
     * @return {?}
     */
    function isCanLoad(guard) {
        return guard && isFunction$2(guard.canLoad);
    }
    /**
     * @param {?} guard
     * @return {?}
     */
    function isCanActivate(guard) {
        return guard && isFunction$2(guard.canActivate);
    }
    /**
     * @param {?} guard
     * @return {?}
     */
    function isCanActivateChild(guard) {
        return guard && isFunction$2(guard.canActivateChild);
    }
    /**
     * @template T
     * @param {?} guard
     * @return {?}
     */
    function isCanDeactivate(guard) {
        return guard && isFunction$2(guard.canDeactivate);
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NoMatch = /** @class */ (function () {
        /**
         * @param {?=} segmentGroup
         */
        function NoMatch(segmentGroup) {
            this.segmentGroup = segmentGroup || null;
        }
        return NoMatch;
    }());
    var AbsoluteRedirect = /** @class */ (function () {
        /**
         * @param {?} urlTree
         */
        function AbsoluteRedirect(urlTree) {
            this.urlTree = urlTree;
        }
        return AbsoluteRedirect;
    }());
    /**
     * @param {?} segmentGroup
     * @return {?}
     */
    function noMatch(segmentGroup) {
        return new Observable(( /**
         * @param {?} obs
         * @return {?}
         */function (obs) { return obs.error(new NoMatch(segmentGroup)); }));
    }
    /**
     * @param {?} newTree
     * @return {?}
     */
    function absoluteRedirect(newTree) {
        return new Observable(( /**
         * @param {?} obs
         * @return {?}
         */function (obs) { return obs.error(new AbsoluteRedirect(newTree)); }));
    }
    /**
     * @param {?} redirectTo
     * @return {?}
     */
    function namedOutletsRedirect(redirectTo) {
        return new Observable(( /**
         * @param {?} obs
         * @return {?}
         */function (obs) { return obs.error(new Error("Only absolute redirects can have named outlets. redirectTo: '" + redirectTo + "'")); }));
    }
    /**
     * @param {?} route
     * @return {?}
     */
    function canLoadFails(route) {
        return new Observable(( /**
         * @param {?} obs
         * @return {?}
         */function (obs) { return obs.error(navigationCancelingError("Cannot load children because the guard of the route \"path: '" + route.path + "'\" returned false")); }));
    }
    /**
     * Returns the `UrlTree` with the redirection applied.
     *
     * Lazy modules are loaded along the way.
     * @param {?} moduleInjector
     * @param {?} configLoader
     * @param {?} urlSerializer
     * @param {?} urlTree
     * @param {?} config
     * @return {?}
     */
    function applyRedirects(moduleInjector, configLoader, urlSerializer, urlTree, config) {
        return new ApplyRedirects(moduleInjector, configLoader, urlSerializer, urlTree, config).apply();
    }
    var ApplyRedirects = /** @class */ (function () {
        /**
         * @param {?} moduleInjector
         * @param {?} configLoader
         * @param {?} urlSerializer
         * @param {?} urlTree
         * @param {?} config
         */
        function ApplyRedirects(moduleInjector, configLoader, urlSerializer, urlTree, config) {
            this.configLoader = configLoader;
            this.urlSerializer = urlSerializer;
            this.urlTree = urlTree;
            this.config = config;
            this.allowRedirects = true;
            this.ngModule = moduleInjector.get(NgModuleRef);
        }
        /**
         * @return {?}
         */
        ApplyRedirects.prototype.apply = function () {
            var _this = this;
            /** @type {?} */
            var expanded$ = this.expandSegmentGroup(this.ngModule, this.config, this.urlTree.root, PRIMARY_OUTLET);
            /** @type {?} */
            var urlTrees$ = expanded$.pipe(map(( /**
             * @param {?} rootSegmentGroup
             * @return {?}
             */function (rootSegmentGroup) { return _this.createUrlTree(rootSegmentGroup, _this.urlTree.queryParams, ( /** @type {?} */(_this.urlTree.fragment))); })));
            return urlTrees$.pipe(catchError(( /**
             * @param {?} e
             * @return {?}
             */function (e) {
                if (e instanceof AbsoluteRedirect) {
                    // after an absolute redirect we do not apply any more redirects!
                    _this.allowRedirects = false;
                    // we need to run matching, so we can fetch all lazy-loaded modules
                    return _this.match(e.urlTree);
                }
                if (e instanceof NoMatch) {
                    throw _this.noMatchError(e);
                }
                throw e;
            })));
        };
        /**
         * @private
         * @param {?} tree
         * @return {?}
         */
        ApplyRedirects.prototype.match = function (tree) {
            var _this = this;
            /** @type {?} */
            var expanded$ = this.expandSegmentGroup(this.ngModule, this.config, tree.root, PRIMARY_OUTLET);
            /** @type {?} */
            var mapped$ = expanded$.pipe(map(( /**
             * @param {?} rootSegmentGroup
             * @return {?}
             */function (rootSegmentGroup) { return _this.createUrlTree(rootSegmentGroup, tree.queryParams, ( /** @type {?} */(tree.fragment))); })));
            return mapped$.pipe(catchError(( /**
             * @param {?} e
             * @return {?}
             */function (e) {
                if (e instanceof NoMatch) {
                    throw _this.noMatchError(e);
                }
                throw e;
            })));
        };
        /**
         * @private
         * @param {?} e
         * @return {?}
         */
        ApplyRedirects.prototype.noMatchError = function (e) {
            return new Error("Cannot match any routes. URL Segment: '" + e.segmentGroup + "'");
        };
        /**
         * @private
         * @param {?} rootCandidate
         * @param {?} queryParams
         * @param {?} fragment
         * @return {?}
         */
        ApplyRedirects.prototype.createUrlTree = function (rootCandidate, queryParams, fragment) {
            var _b;
            /** @type {?} */
            var root = rootCandidate.segments.length > 0 ?
                new UrlSegmentGroup([], (_b = {}, _b[PRIMARY_OUTLET] = rootCandidate, _b)) :
                rootCandidate;
            return new UrlTree(root, queryParams, fragment);
        };
        /**
         * @private
         * @param {?} ngModule
         * @param {?} routes
         * @param {?} segmentGroup
         * @param {?} outlet
         * @return {?}
         */
        ApplyRedirects.prototype.expandSegmentGroup = function (ngModule, routes, segmentGroup, outlet) {
            if (segmentGroup.segments.length === 0 && segmentGroup.hasChildren()) {
                return this.expandChildren(ngModule, routes, segmentGroup)
                    .pipe(map(( /**
             * @param {?} children
             * @return {?}
             */function (children) { return new UrlSegmentGroup([], children); })));
            }
            return this.expandSegment(ngModule, segmentGroup, routes, segmentGroup.segments, outlet, true);
        };
        // Recursively expand segment groups for all the child outlets
        /**
         * @private
         * @param {?} ngModule
         * @param {?} routes
         * @param {?} segmentGroup
         * @return {?}
         */
        ApplyRedirects.prototype.expandChildren = function (ngModule, routes, segmentGroup) {
            var _this = this;
            return waitForMap(segmentGroup.children, ( /**
             * @param {?} childOutlet
             * @param {?} child
             * @return {?}
             */function (childOutlet, child) { return _this.expandSegmentGroup(ngModule, routes, child, childOutlet); }));
        };
        /**
         * @private
         * @param {?} ngModule
         * @param {?} segmentGroup
         * @param {?} routes
         * @param {?} segments
         * @param {?} outlet
         * @param {?} allowRedirects
         * @return {?}
         */
        ApplyRedirects.prototype.expandSegment = function (ngModule, segmentGroup, routes, segments, outlet, allowRedirects) {
            var _this = this;
            return of.apply(void 0, __spread(routes)).pipe(map(( /**
             * @param {?} r
             * @return {?}
             */function (r) {
                /** @type {?} */
                var expanded$ = _this.expandSegmentAgainstRoute(ngModule, segmentGroup, routes, r, segments, outlet, allowRedirects);
                return expanded$.pipe(catchError(( /**
                 * @param {?} e
                 * @return {?}
                 */function (e) {
                    if (e instanceof NoMatch) {
                        // TODO(i): this return type doesn't match the declared Observable<UrlSegmentGroup> -
                        // talk to Jason
                        return ( /** @type {?} */(of(null)));
                    }
                    throw e;
                })));
            })), concatAll(), first(( /**
             * @param {?} s
             * @return {?}
             */function (s) { return !!s; })), catchError(( /**
             * @param {?} e
             * @param {?} _
             * @return {?}
             */function (e, _) {
                if (e instanceof EmptyError || e.name === 'EmptyError') {
                    if (_this.noLeftoversInUrl(segmentGroup, segments, outlet)) {
                        return of(new UrlSegmentGroup([], {}));
                    }
                    throw new NoMatch(segmentGroup);
                }
                throw e;
            })));
        };
        /**
         * @private
         * @param {?} segmentGroup
         * @param {?} segments
         * @param {?} outlet
         * @return {?}
         */
        ApplyRedirects.prototype.noLeftoversInUrl = function (segmentGroup, segments, outlet) {
            return segments.length === 0 && !segmentGroup.children[outlet];
        };
        /**
         * @private
         * @param {?} ngModule
         * @param {?} segmentGroup
         * @param {?} routes
         * @param {?} route
         * @param {?} paths
         * @param {?} outlet
         * @param {?} allowRedirects
         * @return {?}
         */
        ApplyRedirects.prototype.expandSegmentAgainstRoute = function (ngModule, segmentGroup, routes, route, paths, outlet, allowRedirects) {
            if (getOutlet(route) !== outlet) {
                return noMatch(segmentGroup);
            }
            if (route.redirectTo === undefined) {
                return this.matchSegmentAgainstRoute(ngModule, segmentGroup, route, paths);
            }
            if (allowRedirects && this.allowRedirects) {
                return this.expandSegmentAgainstRouteUsingRedirect(ngModule, segmentGroup, routes, route, paths, outlet);
            }
            return noMatch(segmentGroup);
        };
        /**
         * @private
         * @param {?} ngModule
         * @param {?} segmentGroup
         * @param {?} routes
         * @param {?} route
         * @param {?} segments
         * @param {?} outlet
         * @return {?}
         */
        ApplyRedirects.prototype.expandSegmentAgainstRouteUsingRedirect = function (ngModule, segmentGroup, routes, route, segments, outlet) {
            if (route.path === '**') {
                return this.expandWildCardWithParamsAgainstRouteUsingRedirect(ngModule, routes, route, outlet);
            }
            return this.expandRegularSegmentAgainstRouteUsingRedirect(ngModule, segmentGroup, routes, route, segments, outlet);
        };
        /**
         * @private
         * @param {?} ngModule
         * @param {?} routes
         * @param {?} route
         * @param {?} outlet
         * @return {?}
         */
        ApplyRedirects.prototype.expandWildCardWithParamsAgainstRouteUsingRedirect = function (ngModule, routes, route, outlet) {
            var _this = this;
            /** @type {?} */
            var newTree = this.applyRedirectCommands([], ( /** @type {?} */(route.redirectTo)), {});
            if (( /** @type {?} */(route.redirectTo)).startsWith('/')) {
                return absoluteRedirect(newTree);
            }
            return this.lineralizeSegments(route, newTree).pipe(mergeMap(( /**
             * @param {?} newSegments
             * @return {?}
             */function (newSegments) {
                /** @type {?} */
                var group = new UrlSegmentGroup(newSegments, {});
                return _this.expandSegment(ngModule, group, routes, newSegments, outlet, false);
            })));
        };
        /**
         * @private
         * @param {?} ngModule
         * @param {?} segmentGroup
         * @param {?} routes
         * @param {?} route
         * @param {?} segments
         * @param {?} outlet
         * @return {?}
         */
        ApplyRedirects.prototype.expandRegularSegmentAgainstRouteUsingRedirect = function (ngModule, segmentGroup, routes, route, segments, outlet) {
            var _this = this;
            var _b = match(segmentGroup, route, segments), matched = _b.matched, consumedSegments = _b.consumedSegments, lastChild = _b.lastChild, positionalParamSegments = _b.positionalParamSegments;
            if (!matched)
                return noMatch(segmentGroup);
            /** @type {?} */
            var newTree = this.applyRedirectCommands(consumedSegments, ( /** @type {?} */(route.redirectTo)), ( /** @type {?} */(positionalParamSegments)));
            if (( /** @type {?} */(route.redirectTo)).startsWith('/')) {
                return absoluteRedirect(newTree);
            }
            return this.lineralizeSegments(route, newTree).pipe(mergeMap(( /**
             * @param {?} newSegments
             * @return {?}
             */function (newSegments) {
                return _this.expandSegment(ngModule, segmentGroup, routes, newSegments.concat(segments.slice(lastChild)), outlet, false);
            })));
        };
        /**
         * @private
         * @param {?} ngModule
         * @param {?} rawSegmentGroup
         * @param {?} route
         * @param {?} segments
         * @return {?}
         */
        ApplyRedirects.prototype.matchSegmentAgainstRoute = function (ngModule, rawSegmentGroup, route, segments) {
            var _this = this;
            if (route.path === '**') {
                if (route.loadChildren) {
                    return this.configLoader.load(ngModule.injector, route)
                        .pipe(map(( /**
                 * @param {?} cfg
                 * @return {?}
                 */function (cfg) {
                        route._loadedConfig = cfg;
                        return new UrlSegmentGroup(segments, {});
                    })));
                }
                return of(new UrlSegmentGroup(segments, {}));
            }
            var _b = match(rawSegmentGroup, route, segments), matched = _b.matched, consumedSegments = _b.consumedSegments, lastChild = _b.lastChild;
            if (!matched)
                return noMatch(rawSegmentGroup);
            /** @type {?} */
            var rawSlicedSegments = segments.slice(lastChild);
            /** @type {?} */
            var childConfig$ = this.getChildConfig(ngModule, route, segments);
            return childConfig$.pipe(mergeMap(( /**
             * @param {?} routerConfig
             * @return {?}
             */function (routerConfig) {
                /** @type {?} */
                var childModule = routerConfig.module;
                /** @type {?} */
                var childConfig = routerConfig.routes;
                var _b = split(rawSegmentGroup, consumedSegments, rawSlicedSegments, childConfig), segmentGroup = _b.segmentGroup, slicedSegments = _b.slicedSegments;
                if (slicedSegments.length === 0 && segmentGroup.hasChildren()) {
                    /** @type {?} */
                    var expanded$_1 = _this.expandChildren(childModule, childConfig, segmentGroup);
                    return expanded$_1.pipe(map(( /**
                     * @param {?} children
                     * @return {?}
                     */function (children) { return new UrlSegmentGroup(consumedSegments, children); })));
                }
                if (childConfig.length === 0 && slicedSegments.length === 0) {
                    return of(new UrlSegmentGroup(consumedSegments, {}));
                }
                /** @type {?} */
                var expanded$ = _this.expandSegment(childModule, segmentGroup, childConfig, slicedSegments, PRIMARY_OUTLET, true);
                return expanded$.pipe(map(( /**
                 * @param {?} cs
                 * @return {?}
                 */function (cs) { return new UrlSegmentGroup(consumedSegments.concat(cs.segments), cs.children); })));
            })));
        };
        /**
         * @private
         * @param {?} ngModule
         * @param {?} route
         * @param {?} segments
         * @return {?}
         */
        ApplyRedirects.prototype.getChildConfig = function (ngModule, route, segments) {
            var _this = this;
            if (route.children) {
                // The children belong to the same module
                return of(new LoadedRouterConfig(route.children, ngModule));
            }
            if (route.loadChildren) {
                // lazy children belong to the loaded module
                if (route._loadedConfig !== undefined) {
                    return of(route._loadedConfig);
                }
                return runCanLoadGuard(ngModule.injector, route, segments)
                    .pipe(mergeMap(( /**
             * @param {?} shouldLoad
             * @return {?}
             */function (shouldLoad) {
                    if (shouldLoad) {
                        return _this.configLoader.load(ngModule.injector, route)
                            .pipe(map(( /**
                     * @param {?} cfg
                     * @return {?}
                     */function (cfg) {
                            route._loadedConfig = cfg;
                            return cfg;
                        })));
                    }
                    return canLoadFails(route);
                })));
            }
            return of(new LoadedRouterConfig([], ngModule));
        };
        /**
         * @private
         * @param {?} route
         * @param {?} urlTree
         * @return {?}
         */
        ApplyRedirects.prototype.lineralizeSegments = function (route, urlTree) {
            /** @type {?} */
            var res = [];
            /** @type {?} */
            var c = urlTree.root;
            while (true) {
                res = res.concat(c.segments);
                if (c.numberOfChildren === 0) {
                    return of(res);
                }
                if (c.numberOfChildren > 1 || !c.children[PRIMARY_OUTLET]) {
                    return namedOutletsRedirect(( /** @type {?} */(route.redirectTo)));
                }
                c = c.children[PRIMARY_OUTLET];
            }
        };
        /**
         * @private
         * @param {?} segments
         * @param {?} redirectTo
         * @param {?} posParams
         * @return {?}
         */
        ApplyRedirects.prototype.applyRedirectCommands = function (segments, redirectTo, posParams) {
            return this.applyRedirectCreatreUrlTree(redirectTo, this.urlSerializer.parse(redirectTo), segments, posParams);
        };
        /**
         * @private
         * @param {?} redirectTo
         * @param {?} urlTree
         * @param {?} segments
         * @param {?} posParams
         * @return {?}
         */
        ApplyRedirects.prototype.applyRedirectCreatreUrlTree = function (redirectTo, urlTree, segments, posParams) {
            /** @type {?} */
            var newRoot = this.createSegmentGroup(redirectTo, urlTree.root, segments, posParams);
            return new UrlTree(newRoot, this.createQueryParams(urlTree.queryParams, this.urlTree.queryParams), urlTree.fragment);
        };
        /**
         * @private
         * @param {?} redirectToParams
         * @param {?} actualParams
         * @return {?}
         */
        ApplyRedirects.prototype.createQueryParams = function (redirectToParams, actualParams) {
            /** @type {?} */
            var res = {};
            forEach(redirectToParams, ( /**
             * @param {?} v
             * @param {?} k
             * @return {?}
             */function (v, k) {
                /** @type {?} */
                var copySourceValue = typeof v === 'string' && v.startsWith(':');
                if (copySourceValue) {
                    /** @type {?} */
                    var sourceName = v.substring(1);
                    res[k] = actualParams[sourceName];
                }
                else {
                    res[k] = v;
                }
            }));
            return res;
        };
        /**
         * @private
         * @param {?} redirectTo
         * @param {?} group
         * @param {?} segments
         * @param {?} posParams
         * @return {?}
         */
        ApplyRedirects.prototype.createSegmentGroup = function (redirectTo, group, segments, posParams) {
            var _this = this;
            /** @type {?} */
            var updatedSegments = this.createSegments(redirectTo, group.segments, segments, posParams);
            /** @type {?} */
            var children = {};
            forEach(group.children, ( /**
             * @param {?} child
             * @param {?} name
             * @return {?}
             */function (child, name) {
                children[name] = _this.createSegmentGroup(redirectTo, child, segments, posParams);
            }));
            return new UrlSegmentGroup(updatedSegments, children);
        };
        /**
         * @private
         * @param {?} redirectTo
         * @param {?} redirectToSegments
         * @param {?} actualSegments
         * @param {?} posParams
         * @return {?}
         */
        ApplyRedirects.prototype.createSegments = function (redirectTo, redirectToSegments, actualSegments, posParams) {
            var _this = this;
            return redirectToSegments.map(( /**
             * @param {?} s
             * @return {?}
             */function (/**
             * @param {?} s
             * @return {?}
             */ s) { return s.path.startsWith(':') ? _this.findPosParam(redirectTo, s, posParams) :
                _this.findOrReturn(s, actualSegments); }));
        };
        /**
         * @private
         * @param {?} redirectTo
         * @param {?} redirectToUrlSegment
         * @param {?} posParams
         * @return {?}
         */
        ApplyRedirects.prototype.findPosParam = function (redirectTo, redirectToUrlSegment, posParams) {
            /** @type {?} */
            var pos = posParams[redirectToUrlSegment.path.substring(1)];
            if (!pos)
                throw new Error("Cannot redirect to '" + redirectTo + "'. Cannot find '" + redirectToUrlSegment.path + "'.");
            return pos;
        };
        /**
         * @private
         * @param {?} redirectToUrlSegment
         * @param {?} actualSegments
         * @return {?}
         */
        ApplyRedirects.prototype.findOrReturn = function (redirectToUrlSegment, actualSegments) {
            var e_26, _b;
            /** @type {?} */
            var idx = 0;
            try {
                for (var actualSegments_1 = __values(actualSegments), actualSegments_1_1 = actualSegments_1.next(); !actualSegments_1_1.done; actualSegments_1_1 = actualSegments_1.next()) {
                    var s_3 = actualSegments_1_1.value;
                    if (s_3.path === redirectToUrlSegment.path) {
                        actualSegments.splice(idx);
                        return s_3;
                    }
                    idx++;
                }
            }
            catch (e_26_1) { e_26 = { error: e_26_1 }; }
            finally {
                try {
                    if (actualSegments_1_1 && !actualSegments_1_1.done && (_b = actualSegments_1.return)) _b.call(actualSegments_1);
                }
                finally { if (e_26) throw e_26.error; }
            }
            return redirectToUrlSegment;
        };
        return ApplyRedirects;
    }());
    /**
     * @param {?} moduleInjector
     * @param {?} route
     * @param {?} segments
     * @return {?}
     */
    function runCanLoadGuard(moduleInjector, route, segments) {
        /** @type {?} */
        var canLoad = route.canLoad;
        if (!canLoad || canLoad.length === 0)
            return of(true);
        /** @type {?} */
        var obs = from(canLoad).pipe(map(( /**
         * @param {?} injectionToken
         * @return {?}
         */function (injectionToken) {
            /** @type {?} */
            var guard = moduleInjector.get(injectionToken);
            /** @type {?} */
            var guardVal;
            if (isCanLoad(guard)) {
                guardVal = guard.canLoad(route, segments);
            }
            else if (isFunction$2(guard)) {
                guardVal = guard(route, segments);
            }
            else {
                throw new Error('Invalid CanLoad guard');
            }
            return wrapIntoObservable(guardVal);
        })));
        return obs.pipe(concatAll(), every(( /**
         * @param {?} result
         * @return {?}
         */function (/**
         * @param {?} result
         * @return {?}
         */ result) { return result === true; })));
    }
    /**
     * @param {?} segmentGroup
     * @param {?} route
     * @param {?} segments
     * @return {?}
     */
    function match(segmentGroup, route, segments) {
        if (route.path === '') {
            if ((route.pathMatch === 'full') && (segmentGroup.hasChildren() || segments.length > 0)) {
                return { matched: false, consumedSegments: [], lastChild: 0, positionalParamSegments: {} };
            }
            return { matched: true, consumedSegments: [], lastChild: 0, positionalParamSegments: {} };
        }
        /** @type {?} */
        var matcher = route.matcher || defaultUrlMatcher;
        /** @type {?} */
        var res = matcher(segments, segmentGroup, route);
        if (!res) {
            return {
                matched: false,
                consumedSegments: ( /** @type {?} */([])),
                lastChild: 0,
                positionalParamSegments: {},
            };
        }
        return {
            matched: true,
            consumedSegments: ( /** @type {?} */(res.consumed)),
            lastChild: ( /** @type {?} */(res.consumed.length)),
            positionalParamSegments: ( /** @type {?} */(res.posParams)),
        };
    }
    /**
     * @param {?} segmentGroup
     * @param {?} consumedSegments
     * @param {?} slicedSegments
     * @param {?} config
     * @return {?}
     */
    function split(segmentGroup, consumedSegments, slicedSegments, config) {
        if (slicedSegments.length > 0 &&
            containsEmptyPathRedirectsWithNamedOutlets(segmentGroup, slicedSegments, config)) {
            /** @type {?} */
            var s_4 = new UrlSegmentGroup(consumedSegments, createChildrenForEmptySegments(config, new UrlSegmentGroup(slicedSegments, segmentGroup.children)));
            return { segmentGroup: mergeTrivialChildren(s_4), slicedSegments: [] };
        }
        if (slicedSegments.length === 0 &&
            containsEmptyPathRedirects(segmentGroup, slicedSegments, config)) {
            /** @type {?} */
            var s_5 = new UrlSegmentGroup(segmentGroup.segments, addEmptySegmentsToChildrenIfNeeded(segmentGroup, slicedSegments, config, segmentGroup.children));
            return { segmentGroup: mergeTrivialChildren(s_5), slicedSegments: slicedSegments };
        }
        return { segmentGroup: segmentGroup, slicedSegments: slicedSegments };
    }
    /**
     * @param {?} s
     * @return {?}
     */
    function mergeTrivialChildren(s) {
        if (s.numberOfChildren === 1 && s.children[PRIMARY_OUTLET]) {
            /** @type {?} */
            var c_5 = s.children[PRIMARY_OUTLET];
            return new UrlSegmentGroup(s.segments.concat(c_5.segments), c_5.children);
        }
        return s;
    }
    /**
     * @param {?} segmentGroup
     * @param {?} slicedSegments
     * @param {?} routes
     * @param {?} children
     * @return {?}
     */
    function addEmptySegmentsToChildrenIfNeeded(segmentGroup, slicedSegments, routes, children) {
        var e_27, _b;
        /** @type {?} */
        var res = {};
        try {
            for (var routes_1 = __values(routes), routes_1_1 = routes_1.next(); !routes_1_1.done; routes_1_1 = routes_1.next()) {
                var r = routes_1_1.value;
                if (isEmptyPathRedirect(segmentGroup, slicedSegments, r) && !children[getOutlet(r)]) {
                    res[getOutlet(r)] = new UrlSegmentGroup([], {});
                }
            }
        }
        catch (e_27_1) { e_27 = { error: e_27_1 }; }
        finally {
            try {
                if (routes_1_1 && !routes_1_1.done && (_b = routes_1.return)) _b.call(routes_1);
            }
            finally { if (e_27) throw e_27.error; }
        }
        return Object.assign({}, children, res);
    }
    /**
     * @param {?} routes
     * @param {?} primarySegmentGroup
     * @return {?}
     */
    function createChildrenForEmptySegments(routes, primarySegmentGroup) {
        var e_28, _b;
        /** @type {?} */
        var res = {};
        res[PRIMARY_OUTLET] = primarySegmentGroup;
        try {
            for (var routes_2 = __values(routes), routes_2_1 = routes_2.next(); !routes_2_1.done; routes_2_1 = routes_2.next()) {
                var r = routes_2_1.value;
                if (r.path === '' && getOutlet(r) !== PRIMARY_OUTLET) {
                    res[getOutlet(r)] = new UrlSegmentGroup([], {});
                }
            }
        }
        catch (e_28_1) { e_28 = { error: e_28_1 }; }
        finally {
            try {
                if (routes_2_1 && !routes_2_1.done && (_b = routes_2.return)) _b.call(routes_2);
            }
            finally { if (e_28) throw e_28.error; }
        }
        return res;
    }
    /**
     * @param {?} segmentGroup
     * @param {?} segments
     * @param {?} routes
     * @return {?}
     */
    function containsEmptyPathRedirectsWithNamedOutlets(segmentGroup, segments, routes) {
        return routes.some(( /**
         * @param {?} r
         * @return {?}
         */function (/**
         * @param {?} r
         * @return {?}
         */ r) { return isEmptyPathRedirect(segmentGroup, segments, r) && getOutlet(r) !== PRIMARY_OUTLET; }));
    }
    /**
     * @param {?} segmentGroup
     * @param {?} segments
     * @param {?} routes
     * @return {?}
     */
    function containsEmptyPathRedirects(segmentGroup, segments, routes) {
        return routes.some(( /**
         * @param {?} r
         * @return {?}
         */function (/**
         * @param {?} r
         * @return {?}
         */ r) { return isEmptyPathRedirect(segmentGroup, segments, r); }));
    }
    /**
     * @param {?} segmentGroup
     * @param {?} segments
     * @param {?} r
     * @return {?}
     */
    function isEmptyPathRedirect(segmentGroup, segments, r) {
        if ((segmentGroup.hasChildren() || segments.length > 0) && r.pathMatch === 'full') {
            return false;
        }
        return r.path === '' && r.redirectTo !== undefined;
    }
    /**
     * @param {?} route
     * @return {?}
     */
    function getOutlet(route) {
        return route.outlet || PRIMARY_OUTLET;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} moduleInjector
     * @param {?} configLoader
     * @param {?} urlSerializer
     * @param {?} config
     * @return {?}
     */
    function applyRedirects$1(moduleInjector, configLoader, urlSerializer, config) {
        return ( /**
         * @param {?} source
         * @return {?}
         */function (source) {
            return source.pipe(switchMap(( /**
             * @param {?} t
             * @return {?}
             */function (/**
             * @param {?} t
             * @return {?}
             */ t) { return applyRedirects(moduleInjector, configLoader, urlSerializer, t.extractedUrl, config)
                .pipe(map(( /**
         * @param {?} urlAfterRedirects
         * @return {?}
         */function (/**
         * @param {?} urlAfterRedirects
         * @return {?}
         */ urlAfterRedirects) { return (Object.assign({}, t, { urlAfterRedirects: urlAfterRedirects })); }))); })));
        });
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CanActivate = /** @class */ (function () {
        /**
         * @param {?} path
         */
        function CanActivate(path) {
            this.path = path;
            this.route = this.path[this.path.length - 1];
        }
        return CanActivate;
    }());
    var CanDeactivate = /** @class */ (function () {
        /**
         * @param {?} component
         * @param {?} route
         */
        function CanDeactivate(component, route) {
            this.component = component;
            this.route = route;
        }
        return CanDeactivate;
    }());
    /**
     * @param {?} future
     * @param {?} curr
     * @param {?} parentContexts
     * @return {?}
     */
    function getAllRouteGuards(future, curr, parentContexts) {
        /** @type {?} */
        var futureRoot = future._root;
        /** @type {?} */
        var currRoot = curr ? curr._root : null;
        return getChildRouteGuards(futureRoot, currRoot, parentContexts, [futureRoot.value]);
    }
    /**
     * @param {?} p
     * @return {?}
     */
    function getCanActivateChild(p) {
        /** @type {?} */
        var canActivateChild = p.routeConfig ? p.routeConfig.canActivateChild : null;
        if (!canActivateChild || canActivateChild.length === 0)
            return null;
        return { node: p, guards: canActivateChild };
    }
    /**
     * @param {?} token
     * @param {?} snapshot
     * @param {?} moduleInjector
     * @return {?}
     */
    function getToken(token, snapshot, moduleInjector) {
        /** @type {?} */
        var config = getClosestLoadedConfig(snapshot);
        /** @type {?} */
        var injector = config ? config.module.injector : moduleInjector;
        return injector.get(token);
    }
    /**
     * @param {?} snapshot
     * @return {?}
     */
    function getClosestLoadedConfig(snapshot) {
        if (!snapshot)
            return null;
        for (var s_6 = snapshot.parent; s_6; s_6 = s_6.parent) {
            /** @type {?} */
            var route = s_6.routeConfig;
            if (route && route._loadedConfig)
                return route._loadedConfig;
        }
        return null;
    }
    /**
     * @param {?} futureNode
     * @param {?} currNode
     * @param {?} contexts
     * @param {?} futurePath
     * @param {?=} checks
     * @return {?}
     */
    function getChildRouteGuards(futureNode, currNode, contexts, futurePath, checks) {
        if (checks === void 0) { checks = {
            canDeactivateChecks: [],
            canActivateChecks: []
        }; }
        /** @type {?} */
        var prevChildren = nodeChildrenAsMap(currNode);
        // Process the children of the future route
        futureNode.children.forEach(( /**
         * @param {?} c
         * @return {?}
         */function (/**
         * @param {?} c
         * @return {?}
         */ c) {
            getRouteGuards(c, prevChildren[c.value.outlet], contexts, futurePath.concat([c.value]), checks);
            delete prevChildren[c.value.outlet];
        }));
        // Process any children left from the current route (not active for the future route)
        forEach(prevChildren, ( /**
         * @param {?} v
         * @param {?} k
         * @return {?}
         */function (v, k) { return deactivateRouteAndItsChildren(v, ( /** @type {?} */(contexts)).getContext(k), checks); }));
        return checks;
    }
    /**
     * @param {?} futureNode
     * @param {?} currNode
     * @param {?} parentContexts
     * @param {?} futurePath
     * @param {?=} checks
     * @return {?}
     */
    function getRouteGuards(futureNode, currNode, parentContexts, futurePath, checks) {
        if (checks === void 0) { checks = {
            canDeactivateChecks: [],
            canActivateChecks: []
        }; }
        /** @type {?} */
        var future = futureNode.value;
        /** @type {?} */
        var curr = currNode ? currNode.value : null;
        /** @type {?} */
        var context = parentContexts ? parentContexts.getContext(futureNode.value.outlet) : null;
        // reusing the node
        if (curr && future.routeConfig === curr.routeConfig) {
            /** @type {?} */
            var shouldRun = shouldRunGuardsAndResolvers(curr, future, ( /** @type {?} */(future.routeConfig)).runGuardsAndResolvers);
            if (shouldRun) {
                checks.canActivateChecks.push(new CanActivate(futurePath));
            }
            else {
                // we need to set the data
                future.data = curr.data;
                future._resolvedData = curr._resolvedData;
            }
            // If we have a component, we need to go through an outlet.
            if (future.component) {
                getChildRouteGuards(futureNode, currNode, context ? context.children : null, futurePath, checks);
                // if we have a componentless route, we recurse but keep the same outlet map.
            }
            else {
                getChildRouteGuards(futureNode, currNode, parentContexts, futurePath, checks);
            }
            if (shouldRun) {
                /** @type {?} */
                var component = context && context.outlet && context.outlet.component || null;
                checks.canDeactivateChecks.push(new CanDeactivate(component, curr));
            }
        }
        else {
            if (curr) {
                deactivateRouteAndItsChildren(currNode, context, checks);
            }
            checks.canActivateChecks.push(new CanActivate(futurePath));
            // If we have a component, we need to go through an outlet.
            if (future.component) {
                getChildRouteGuards(futureNode, null, context ? context.children : null, futurePath, checks);
                // if we have a componentless route, we recurse but keep the same outlet map.
            }
            else {
                getChildRouteGuards(futureNode, null, parentContexts, futurePath, checks);
            }
        }
        return checks;
    }
    /**
     * @param {?} curr
     * @param {?} future
     * @param {?} mode
     * @return {?}
     */
    function shouldRunGuardsAndResolvers(curr, future, mode) {
        if (typeof mode === 'function') {
            return mode(curr, future);
        }
        switch (mode) {
            case 'pathParamsChange':
                return !equalPath(curr.url, future.url);
            case 'pathParamsOrQueryParamsChange':
                return !equalPath(curr.url, future.url) ||
                    !shallowEqual(curr.queryParams, future.queryParams);
            case 'always':
                return true;
            case 'paramsOrQueryParamsChange':
                return !equalParamsAndUrlSegments(curr, future) ||
                    !shallowEqual(curr.queryParams, future.queryParams);
            case 'paramsChange':
            default:
                return !equalParamsAndUrlSegments(curr, future);
        }
    }
    /**
     * @param {?} route
     * @param {?} context
     * @param {?} checks
     * @return {?}
     */
    function deactivateRouteAndItsChildren(route, context, checks) {
        /** @type {?} */
        var children = nodeChildrenAsMap(route);
        /** @type {?} */
        var r = route.value;
        forEach(children, ( /**
         * @param {?} node
         * @param {?} childName
         * @return {?}
         */function (node, childName) {
            if (!r.component) {
                deactivateRouteAndItsChildren(node, context, checks);
            }
            else if (context) {
                deactivateRouteAndItsChildren(node, context.children.getContext(childName), checks);
            }
            else {
                deactivateRouteAndItsChildren(node, null, checks);
            }
        }));
        if (!r.component) {
            checks.canDeactivateChecks.push(new CanDeactivate(null, r));
        }
        else if (context && context.outlet && context.outlet.isActivated) {
            checks.canDeactivateChecks.push(new CanDeactivate(context.outlet.component, r));
        }
        else {
            checks.canDeactivateChecks.push(new CanDeactivate(null, r));
        }
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var INITIAL_VALUE = Symbol('INITIAL_VALUE');
    /**
     * @return {?}
     */
    function prioritizedGuardValue() {
        return switchMap(( /**
         * @param {?} obs
         * @return {?}
         */function (/**
         * @param {?} obs
         * @return {?}
         */ obs) {
            return ( /** @type {?} */(combineLatest.apply(void 0, __spread(obs.map(( /**
             * @param {?} o
             * @return {?}
             */function (/**
             * @param {?} o
             * @return {?}
             */ o) { return o.pipe(take(1), startWith(( /** @type {?} */(INITIAL_VALUE)))); })))).pipe(scan(( /**
         * @param {?} acc
         * @param {?} list
         * @return {?}
         */function (acc, list) {
                /** @type {?} */
                var isPending = false;
                return list.reduce(( /**
                 * @param {?} innerAcc
                 * @param {?} val
                 * @param {?} i
                 * @return {?}
                 */function (innerAcc, val, i) {
                    if (innerAcc !== INITIAL_VALUE)
                        return innerAcc;
                    // Toggle pending flag if any values haven't been set yet
                    if (val === INITIAL_VALUE)
                        isPending = true;
                    // Any other return values are only valid if we haven't yet hit a pending call.
                    // This guarantees that in the case of a guard at the bottom of the tree that
                    // returns a redirect, we will wait for the higher priority guard at the top to
                    // finish before performing the redirect.
                    if (!isPending) {
                        // Early return when we hit a `false` value as that should always cancel
                        // navigation
                        if (val === false)
                            return val;
                        if (i === list.length - 1 || isUrlTree(val)) {
                            return val;
                        }
                    }
                    return innerAcc;
                }), acc);
            }), INITIAL_VALUE), filter(( /**
             * @param {?} item
             * @return {?}
             */function (/**
             * @param {?} item
             * @return {?}
             */ item) { return item !== INITIAL_VALUE; })), map(( /**
             * @param {?} item
             * @return {?}
             */function (/**
             * @param {?} item
             * @return {?}
             */ item) { return isUrlTree(item) ? item : item === true; })), //
            take(1))));
        }));
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} moduleInjector
     * @param {?=} forwardEvent
     * @return {?}
     */
    function checkGuards(moduleInjector, forwardEvent) {
        return ( /**
         * @param {?} source
         * @return {?}
         */function (source) {
            return source.pipe(mergeMap(( /**
             * @param {?} t
             * @return {?}
             */function (/**
             * @param {?} t
             * @return {?}
             */ t) {
                var targetSnapshot = t.targetSnapshot, currentSnapshot = t.currentSnapshot, _b = t.guards, canActivateChecks = _b.canActivateChecks, canDeactivateChecks = _b.canDeactivateChecks;
                if (canDeactivateChecks.length === 0 && canActivateChecks.length === 0) {
                    return of(Object.assign({}, t, { guardsResult: true }));
                }
                return runCanDeactivateChecks(canDeactivateChecks, ( /** @type {?} */(targetSnapshot)), currentSnapshot, moduleInjector)
                    .pipe(mergeMap(( /**
             * @param {?} canDeactivate
             * @return {?}
             */function (/**
             * @param {?} canDeactivate
             * @return {?}
             */ canDeactivate) {
                    return canDeactivate && isBoolean$1(canDeactivate) ?
                        runCanActivateChecks(( /** @type {?} */(targetSnapshot)), canActivateChecks, moduleInjector, forwardEvent) :
                        of(canDeactivate);
                })), map(( /**
                 * @param {?} guardsResult
                 * @return {?}
                 */function (/**
                 * @param {?} guardsResult
                 * @return {?}
                 */ guardsResult) { return (Object.assign({}, t, { guardsResult: guardsResult })); })));
            })));
        });
    }
    /**
     * @param {?} checks
     * @param {?} futureRSS
     * @param {?} currRSS
     * @param {?} moduleInjector
     * @return {?}
     */
    function runCanDeactivateChecks(checks, futureRSS, currRSS, moduleInjector) {
        return from(checks).pipe(mergeMap(( /**
         * @param {?} check
         * @return {?}
         */function (/**
         * @param {?} check
         * @return {?}
         */ check) { return runCanDeactivate(check.component, check.route, currRSS, futureRSS, moduleInjector); })), first(( /**
         * @param {?} result
         * @return {?}
         */function (/**
         * @param {?} result
         * @return {?}
         */ result) { return result !== true; }), ( /** @type {?} */(true))));
    }
    /**
     * @param {?} futureSnapshot
     * @param {?} checks
     * @param {?} moduleInjector
     * @param {?=} forwardEvent
     * @return {?}
     */
    function runCanActivateChecks(futureSnapshot, checks, moduleInjector, forwardEvent) {
        return from(checks).pipe(concatMap(( /**
         * @param {?} check
         * @return {?}
         */function (check) {
            return from([
                fireChildActivationStart(check.route.parent, forwardEvent),
                fireActivationStart(check.route, forwardEvent),
                runCanActivateChild(futureSnapshot, check.path, moduleInjector),
                runCanActivate(futureSnapshot, check.route, moduleInjector)
            ])
                .pipe(concatAll(), first(( /**
         * @param {?} result
         * @return {?}
         */function (/**
         * @param {?} result
         * @return {?}
         */ result) {
                return result !== true;
            }), ( /** @type {?} */(true))));
        })), first(( /**
         * @param {?} result
         * @return {?}
         */function (/**
         * @param {?} result
         * @return {?}
         */ result) { return result !== true; }), ( /** @type {?} */(true))));
    }
    /**
     * This should fire off `ActivationStart` events for each route being activated at this
     * level.
     * In other words, if you're activating `a` and `b` below, `path` will contain the
     * `ActivatedRouteSnapshot`s for both and we will fire `ActivationStart` for both. Always
     * return
     * `true` so checks continue to run.
     * @param {?} snapshot
     * @param {?=} forwardEvent
     * @return {?}
     */
    function fireActivationStart(snapshot, forwardEvent) {
        if (snapshot !== null && forwardEvent) {
            forwardEvent(new ActivationStart(snapshot));
        }
        return of(true);
    }
    /**
     * This should fire off `ChildActivationStart` events for each route being activated at this
     * level.
     * In other words, if you're activating `a` and `b` below, `path` will contain the
     * `ActivatedRouteSnapshot`s for both and we will fire `ChildActivationStart` for both. Always
     * return
     * `true` so checks continue to run.
     * @param {?} snapshot
     * @param {?=} forwardEvent
     * @return {?}
     */
    function fireChildActivationStart(snapshot, forwardEvent) {
        if (snapshot !== null && forwardEvent) {
            forwardEvent(new ChildActivationStart(snapshot));
        }
        return of(true);
    }
    /**
     * @param {?} futureRSS
     * @param {?} futureARS
     * @param {?} moduleInjector
     * @return {?}
     */
    function runCanActivate(futureRSS, futureARS, moduleInjector) {
        /** @type {?} */
        var canActivate = futureARS.routeConfig ? futureARS.routeConfig.canActivate : null;
        if (!canActivate || canActivate.length === 0)
            return of(true);
        /** @type {?} */
        var canActivateObservables = canActivate.map(( /**
         * @param {?} c
         * @return {?}
         */function (c) {
            return defer(( /**
             * @return {?}
             */function () {
                /** @type {?} */
                var guard = getToken(c, futureARS, moduleInjector);
                /** @type {?} */
                var observable;
                if (isCanActivate(guard)) {
                    observable = wrapIntoObservable(guard.canActivate(futureARS, futureRSS));
                }
                else if (isFunction$2(guard)) {
                    observable = wrapIntoObservable(guard(futureARS, futureRSS));
                }
                else {
                    throw new Error('Invalid CanActivate guard');
                }
                return observable.pipe(first());
            }));
        }));
        return of(canActivateObservables).pipe(prioritizedGuardValue());
    }
    /**
     * @param {?} futureRSS
     * @param {?} path
     * @param {?} moduleInjector
     * @return {?}
     */
    function runCanActivateChild(futureRSS, path, moduleInjector) {
        /** @type {?} */
        var futureARS = path[path.length - 1];
        /** @type {?} */
        var canActivateChildGuards = path.slice(0, path.length - 1)
            .reverse()
            .map(( /**
     * @param {?} p
     * @return {?}
     */function (/**
     * @param {?} p
     * @return {?}
     */ p) { return getCanActivateChild(p); }))
            .filter(( /**
     * @param {?} _
     * @return {?}
     */function (/**
     * @param {?} _
     * @return {?}
     */ _) { return _ !== null; }));
        /** @type {?} */
        var canActivateChildGuardsMapped = canActivateChildGuards.map(( /**
         * @param {?} d
         * @return {?}
         */function (d) {
            return defer(( /**
             * @return {?}
             */function () {
                /** @type {?} */
                var guardsMapped = d.guards.map(( /**
                 * @param {?} c
                 * @return {?}
                 */function (c) {
                    /** @type {?} */
                    var guard = getToken(c, d.node, moduleInjector);
                    /** @type {?} */
                    var observable;
                    if (isCanActivateChild(guard)) {
                        observable = wrapIntoObservable(guard.canActivateChild(futureARS, futureRSS));
                    }
                    else if (isFunction$2(guard)) {
                        observable = wrapIntoObservable(guard(futureARS, futureRSS));
                    }
                    else {
                        throw new Error('Invalid CanActivateChild guard');
                    }
                    return observable.pipe(first());
                }));
                return of(guardsMapped).pipe(prioritizedGuardValue());
            }));
        }));
        return of(canActivateChildGuardsMapped).pipe(prioritizedGuardValue());
    }
    /**
     * @param {?} component
     * @param {?} currARS
     * @param {?} currRSS
     * @param {?} futureRSS
     * @param {?} moduleInjector
     * @return {?}
     */
    function runCanDeactivate(component, currARS, currRSS, futureRSS, moduleInjector) {
        /** @type {?} */
        var canDeactivate = currARS && currARS.routeConfig ? currARS.routeConfig.canDeactivate : null;
        if (!canDeactivate || canDeactivate.length === 0)
            return of(true);
        /** @type {?} */
        var canDeactivateObservables = canDeactivate.map(( /**
         * @param {?} c
         * @return {?}
         */function (c) {
            /** @type {?} */
            var guard = getToken(c, currARS, moduleInjector);
            /** @type {?} */
            var observable;
            if (isCanDeactivate(guard)) {
                observable =
                    wrapIntoObservable(guard.canDeactivate(( /** @type {?} */(component)), currARS, currRSS, futureRSS));
            }
            else if (isFunction$2(guard)) {
                observable = wrapIntoObservable(guard(component, currARS, currRSS, futureRSS));
            }
            else {
                throw new Error('Invalid CanDeactivate guard');
            }
            return observable.pipe(first());
        }));
        return of(canDeactivateObservables).pipe(prioritizedGuardValue());
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NoMatch$1 = /** @class */ (function () {
        function NoMatch$1() {
        }
        return NoMatch$1;
    }());
    /**
     * @param {?} rootComponentType
     * @param {?} config
     * @param {?} urlTree
     * @param {?} url
     * @param {?=} paramsInheritanceStrategy
     * @param {?=} relativeLinkResolution
     * @return {?}
     */
    function recognize(rootComponentType, config, urlTree, url, paramsInheritanceStrategy, relativeLinkResolution) {
        if (paramsInheritanceStrategy === void 0) { paramsInheritanceStrategy = 'emptyOnly'; }
        if (relativeLinkResolution === void 0) { relativeLinkResolution = 'legacy'; }
        return new Recognizer(rootComponentType, config, urlTree, url, paramsInheritanceStrategy, relativeLinkResolution)
            .recognize();
    }
    var Recognizer = /** @class */ (function () {
        /**
         * @param {?} rootComponentType
         * @param {?} config
         * @param {?} urlTree
         * @param {?} url
         * @param {?} paramsInheritanceStrategy
         * @param {?} relativeLinkResolution
         */
        function Recognizer(rootComponentType, config, urlTree, url, paramsInheritanceStrategy, relativeLinkResolution) {
            this.rootComponentType = rootComponentType;
            this.config = config;
            this.urlTree = urlTree;
            this.url = url;
            this.paramsInheritanceStrategy = paramsInheritanceStrategy;
            this.relativeLinkResolution = relativeLinkResolution;
        }
        /**
         * @return {?}
         */
        Recognizer.prototype.recognize = function () {
            try {
                /** @type {?} */
                var rootSegmentGroup = split$1(this.urlTree.root, [], [], this.config, this.relativeLinkResolution).segmentGroup;
                /** @type {?} */
                var children = this.processSegmentGroup(this.config, rootSegmentGroup, PRIMARY_OUTLET);
                /** @type {?} */
                var root = new ActivatedRouteSnapshot([], Object.freeze({}), Object.freeze(Object.assign({}, this.urlTree.queryParams)), ( /** @type {?} */(this.urlTree.fragment)), {}, PRIMARY_OUTLET, this.rootComponentType, null, this.urlTree.root, -1, {});
                /** @type {?} */
                var rootNode = new TreeNode(root, children);
                /** @type {?} */
                var routeState = new RouterStateSnapshot(this.url, rootNode);
                this.inheritParamsAndData(routeState._root);
                return of(routeState);
            }
            catch (e) {
                return new Observable(( /**
                 * @param {?} obs
                 * @return {?}
                 */function (obs) { return obs.error(e); }));
            }
        };
        /**
         * @param {?} routeNode
         * @return {?}
         */
        Recognizer.prototype.inheritParamsAndData = function (routeNode) {
            var _this = this;
            /** @type {?} */
            var route = routeNode.value;
            /** @type {?} */
            var i = inheritedParamsDataResolve(route, this.paramsInheritanceStrategy);
            route.params = Object.freeze(i.params);
            route.data = Object.freeze(i.data);
            routeNode.children.forEach(( /**
             * @param {?} n
             * @return {?}
             */function (/**
             * @param {?} n
             * @return {?}
             */ n) { return _this.inheritParamsAndData(n); }));
        };
        /**
         * @param {?} config
         * @param {?} segmentGroup
         * @param {?} outlet
         * @return {?}
         */
        Recognizer.prototype.processSegmentGroup = function (config, segmentGroup, outlet) {
            if (segmentGroup.segments.length === 0 && segmentGroup.hasChildren()) {
                return this.processChildren(config, segmentGroup);
            }
            return this.processSegment(config, segmentGroup, segmentGroup.segments, outlet);
        };
        /**
         * @param {?} config
         * @param {?} segmentGroup
         * @return {?}
         */
        Recognizer.prototype.processChildren = function (config, segmentGroup) {
            var _this = this;
            /** @type {?} */
            var children = mapChildrenIntoArray(segmentGroup, ( /**
             * @param {?} child
             * @param {?} childOutlet
             * @return {?}
             */function (child, childOutlet) { return _this.processSegmentGroup(config, child, childOutlet); }));
            checkOutletNameUniqueness(children);
            sortActivatedRouteSnapshots(children);
            return children;
        };
        /**
         * @param {?} config
         * @param {?} segmentGroup
         * @param {?} segments
         * @param {?} outlet
         * @return {?}
         */
        Recognizer.prototype.processSegment = function (config, segmentGroup, segments, outlet) {
            var e_29, _b;
            try {
                for (var config_2 = __values(config), config_2_1 = config_2.next(); !config_2_1.done; config_2_1 = config_2.next()) {
                    var r = config_2_1.value;
                    try {
                        return this.processSegmentAgainstRoute(r, segmentGroup, segments, outlet);
                    }
                    catch (e) {
                        if (!(e instanceof NoMatch$1))
                            throw e;
                    }
                }
            }
            catch (e_29_1) { e_29 = { error: e_29_1 }; }
            finally {
                try {
                    if (config_2_1 && !config_2_1.done && (_b = config_2.return)) _b.call(config_2);
                }
                finally { if (e_29) throw e_29.error; }
            }
            if (this.noLeftoversInUrl(segmentGroup, segments, outlet)) {
                return [];
            }
            throw new NoMatch$1();
        };
        /**
         * @private
         * @param {?} segmentGroup
         * @param {?} segments
         * @param {?} outlet
         * @return {?}
         */
        Recognizer.prototype.noLeftoversInUrl = function (segmentGroup, segments, outlet) {
            return segments.length === 0 && !segmentGroup.children[outlet];
        };
        /**
         * @param {?} route
         * @param {?} rawSegment
         * @param {?} segments
         * @param {?} outlet
         * @return {?}
         */
        Recognizer.prototype.processSegmentAgainstRoute = function (route, rawSegment, segments, outlet) {
            if (route.redirectTo)
                throw new NoMatch$1();
            if ((route.outlet || PRIMARY_OUTLET) !== outlet)
                throw new NoMatch$1();
            /** @type {?} */
            var snapshot;
            /** @type {?} */
            var consumedSegments = [];
            /** @type {?} */
            var rawSlicedSegments = [];
            if (route.path === '**') {
                /** @type {?} */
                var params = segments.length > 0 ? ( /** @type {?} */(last$1(segments))).parameters : {};
                snapshot = new ActivatedRouteSnapshot(segments, params, Object.freeze(Object.assign({}, this.urlTree.queryParams)), ( /** @type {?} */(this.urlTree.fragment)), getData(route), outlet, ( /** @type {?} */(route.component)), route, getSourceSegmentGroup(rawSegment), getPathIndexShift(rawSegment) + segments.length, getResolve(route));
            }
            else {
                /** @type {?} */
                var result = match$1(rawSegment, route, segments);
                consumedSegments = result.consumedSegments;
                rawSlicedSegments = segments.slice(result.lastChild);
                snapshot = new ActivatedRouteSnapshot(consumedSegments, result.parameters, Object.freeze(Object.assign({}, this.urlTree.queryParams)), ( /** @type {?} */(this.urlTree.fragment)), getData(route), outlet, ( /** @type {?} */(route.component)), route, getSourceSegmentGroup(rawSegment), getPathIndexShift(rawSegment) + consumedSegments.length, getResolve(route));
            }
            /** @type {?} */
            var childConfig = getChildConfig(route);
            var _b = split$1(rawSegment, consumedSegments, rawSlicedSegments, childConfig, this.relativeLinkResolution), segmentGroup = _b.segmentGroup, slicedSegments = _b.slicedSegments;
            if (slicedSegments.length === 0 && segmentGroup.hasChildren()) {
                /** @type {?} */
                var children_3 = this.processChildren(childConfig, segmentGroup);
                return [new TreeNode(snapshot, children_3)];
            }
            if (childConfig.length === 0 && slicedSegments.length === 0) {
                return [new TreeNode(snapshot, [])];
            }
            /** @type {?} */
            var children = this.processSegment(childConfig, segmentGroup, slicedSegments, PRIMARY_OUTLET);
            return [new TreeNode(snapshot, children)];
        };
        return Recognizer;
    }());
    /**
     * @param {?} nodes
     * @return {?}
     */
    function sortActivatedRouteSnapshots(nodes) {
        nodes.sort(( /**
         * @param {?} a
         * @param {?} b
         * @return {?}
         */function (a, b) {
            if (a.value.outlet === PRIMARY_OUTLET)
                return -1;
            if (b.value.outlet === PRIMARY_OUTLET)
                return 1;
            return a.value.outlet.localeCompare(b.value.outlet);
        }));
    }
    /**
     * @param {?} route
     * @return {?}
     */
    function getChildConfig(route) {
        if (route.children) {
            return route.children;
        }
        if (route.loadChildren) {
            return ( /** @type {?} */(route._loadedConfig)).routes;
        }
        return [];
    }
    /**
     * @param {?} segmentGroup
     * @param {?} route
     * @param {?} segments
     * @return {?}
     */
    function match$1(segmentGroup, route, segments) {
        if (route.path === '') {
            if (route.pathMatch === 'full' && (segmentGroup.hasChildren() || segments.length > 0)) {
                throw new NoMatch$1();
            }
            return { consumedSegments: [], lastChild: 0, parameters: {} };
        }
        /** @type {?} */
        var matcher = route.matcher || defaultUrlMatcher;
        /** @type {?} */
        var res = matcher(segments, segmentGroup, route);
        if (!res)
            throw new NoMatch$1();
        /** @type {?} */
        var posParams = {};
        forEach(( /** @type {?} */(res.posParams)), ( /**
         * @param {?} v
         * @param {?} k
         * @return {?}
         */function (v, k) { posParams[k] = v.path; }));
        /** @type {?} */
        var parameters = res.consumed.length > 0 ? Object.assign({}, posParams, res.consumed[res.consumed.length - 1].parameters) :
            posParams;
        return { consumedSegments: res.consumed, lastChild: res.consumed.length, parameters: parameters };
    }
    /**
     * @param {?} nodes
     * @return {?}
     */
    function checkOutletNameUniqueness(nodes) {
        /** @type {?} */
        var names = {};
        nodes.forEach(( /**
         * @param {?} n
         * @return {?}
         */function (/**
         * @param {?} n
         * @return {?}
         */ n) {
            /** @type {?} */
            var routeWithSameOutletName = names[n.value.outlet];
            if (routeWithSameOutletName) {
                /** @type {?} */
                var p_5 = routeWithSameOutletName.url.map(( /**
                 * @param {?} s
                 * @return {?}
                 */function (/**
                 * @param {?} s
                 * @return {?}
                 */ s) { return s.toString(); })).join('/');
                /** @type {?} */
                var c_6 = n.value.url.map(( /**
                 * @param {?} s
                 * @return {?}
                 */function (/**
                 * @param {?} s
                 * @return {?}
                 */ s) { return s.toString(); })).join('/');
                throw new Error("Two segments cannot have the same outlet name: '" + p_5 + "' and '" + c_6 + "'.");
            }
            names[n.value.outlet] = n.value;
        }));
    }
    /**
     * @param {?} segmentGroup
     * @return {?}
     */
    function getSourceSegmentGroup(segmentGroup) {
        /** @type {?} */
        var s = segmentGroup;
        while (s._sourceSegment) {
            s = s._sourceSegment;
        }
        return s;
    }
    /**
     * @param {?} segmentGroup
     * @return {?}
     */
    function getPathIndexShift(segmentGroup) {
        /** @type {?} */
        var s = segmentGroup;
        /** @type {?} */
        var res = (s._segmentIndexShift ? s._segmentIndexShift : 0);
        while (s._sourceSegment) {
            s = s._sourceSegment;
            res += (s._segmentIndexShift ? s._segmentIndexShift : 0);
        }
        return res - 1;
    }
    /**
     * @param {?} segmentGroup
     * @param {?} consumedSegments
     * @param {?} slicedSegments
     * @param {?} config
     * @param {?} relativeLinkResolution
     * @return {?}
     */
    function split$1(segmentGroup, consumedSegments, slicedSegments, config, relativeLinkResolution) {
        if (slicedSegments.length > 0 &&
            containsEmptyPathMatchesWithNamedOutlets(segmentGroup, slicedSegments, config)) {
            /** @type {?} */
            var s_7 = new UrlSegmentGroup(consumedSegments, createChildrenForEmptyPaths(segmentGroup, consumedSegments, config, new UrlSegmentGroup(slicedSegments, segmentGroup.children)));
            s_7._sourceSegment = segmentGroup;
            s_7._segmentIndexShift = consumedSegments.length;
            return { segmentGroup: s_7, slicedSegments: [] };
        }
        if (slicedSegments.length === 0 &&
            containsEmptyPathMatches(segmentGroup, slicedSegments, config)) {
            /** @type {?} */
            var s_8 = new UrlSegmentGroup(segmentGroup.segments, addEmptyPathsToChildrenIfNeeded(segmentGroup, consumedSegments, slicedSegments, config, segmentGroup.children, relativeLinkResolution));
            s_8._sourceSegment = segmentGroup;
            s_8._segmentIndexShift = consumedSegments.length;
            return { segmentGroup: s_8, slicedSegments: slicedSegments };
        }
        /** @type {?} */
        var s = new UrlSegmentGroup(segmentGroup.segments, segmentGroup.children);
        s._sourceSegment = segmentGroup;
        s._segmentIndexShift = consumedSegments.length;
        return { segmentGroup: s, slicedSegments: slicedSegments };
    }
    /**
     * @param {?} segmentGroup
     * @param {?} consumedSegments
     * @param {?} slicedSegments
     * @param {?} routes
     * @param {?} children
     * @param {?} relativeLinkResolution
     * @return {?}
     */
    function addEmptyPathsToChildrenIfNeeded(segmentGroup, consumedSegments, slicedSegments, routes, children, relativeLinkResolution) {
        var e_30, _b;
        /** @type {?} */
        var res = {};
        try {
            for (var routes_3 = __values(routes), routes_3_1 = routes_3.next(); !routes_3_1.done; routes_3_1 = routes_3.next()) {
                var r = routes_3_1.value;
                if (emptyPathMatch(segmentGroup, slicedSegments, r) && !children[getOutlet$1(r)]) {
                    /** @type {?} */
                    var s_9 = new UrlSegmentGroup([], {});
                    s_9._sourceSegment = segmentGroup;
                    if (relativeLinkResolution === 'legacy') {
                        s_9._segmentIndexShift = segmentGroup.segments.length;
                    }
                    else {
                        s_9._segmentIndexShift = consumedSegments.length;
                    }
                    res[getOutlet$1(r)] = s_9;
                }
            }
        }
        catch (e_30_1) { e_30 = { error: e_30_1 }; }
        finally {
            try {
                if (routes_3_1 && !routes_3_1.done && (_b = routes_3.return)) _b.call(routes_3);
            }
            finally { if (e_30) throw e_30.error; }
        }
        return Object.assign({}, children, res);
    }
    /**
     * @param {?} segmentGroup
     * @param {?} consumedSegments
     * @param {?} routes
     * @param {?} primarySegment
     * @return {?}
     */
    function createChildrenForEmptyPaths(segmentGroup, consumedSegments, routes, primarySegment) {
        var e_31, _b;
        /** @type {?} */
        var res = {};
        res[PRIMARY_OUTLET] = primarySegment;
        primarySegment._sourceSegment = segmentGroup;
        primarySegment._segmentIndexShift = consumedSegments.length;
        try {
            for (var routes_4 = __values(routes), routes_4_1 = routes_4.next(); !routes_4_1.done; routes_4_1 = routes_4.next()) {
                var r = routes_4_1.value;
                if (r.path === '' && getOutlet$1(r) !== PRIMARY_OUTLET) {
                    /** @type {?} */
                    var s_10 = new UrlSegmentGroup([], {});
                    s_10._sourceSegment = segmentGroup;
                    s_10._segmentIndexShift = consumedSegments.length;
                    res[getOutlet$1(r)] = s_10;
                }
            }
        }
        catch (e_31_1) { e_31 = { error: e_31_1 }; }
        finally {
            try {
                if (routes_4_1 && !routes_4_1.done && (_b = routes_4.return)) _b.call(routes_4);
            }
            finally { if (e_31) throw e_31.error; }
        }
        return res;
    }
    /**
     * @param {?} segmentGroup
     * @param {?} slicedSegments
     * @param {?} routes
     * @return {?}
     */
    function containsEmptyPathMatchesWithNamedOutlets(segmentGroup, slicedSegments, routes) {
        return routes.some(( /**
         * @param {?} r
         * @return {?}
         */function (/**
         * @param {?} r
         * @return {?}
         */ r) { return emptyPathMatch(segmentGroup, slicedSegments, r) && getOutlet$1(r) !== PRIMARY_OUTLET; }));
    }
    /**
     * @param {?} segmentGroup
     * @param {?} slicedSegments
     * @param {?} routes
     * @return {?}
     */
    function containsEmptyPathMatches(segmentGroup, slicedSegments, routes) {
        return routes.some(( /**
         * @param {?} r
         * @return {?}
         */function (/**
         * @param {?} r
         * @return {?}
         */ r) { return emptyPathMatch(segmentGroup, slicedSegments, r); }));
    }
    /**
     * @param {?} segmentGroup
     * @param {?} slicedSegments
     * @param {?} r
     * @return {?}
     */
    function emptyPathMatch(segmentGroup, slicedSegments, r) {
        if ((segmentGroup.hasChildren() || slicedSegments.length > 0) && r.pathMatch === 'full') {
            return false;
        }
        return r.path === '' && r.redirectTo === undefined;
    }
    /**
     * @param {?} route
     * @return {?}
     */
    function getOutlet$1(route) {
        return route.outlet || PRIMARY_OUTLET;
    }
    /**
     * @param {?} route
     * @return {?}
     */
    function getData(route) {
        return route.data || {};
    }
    /**
     * @param {?} route
     * @return {?}
     */
    function getResolve(route) {
        return route.resolve || {};
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} rootComponentType
     * @param {?} config
     * @param {?} serializer
     * @param {?} paramsInheritanceStrategy
     * @param {?} relativeLinkResolution
     * @return {?}
     */
    function recognize$1(rootComponentType, config, serializer, paramsInheritanceStrategy, relativeLinkResolution) {
        return ( /**
         * @param {?} source
         * @return {?}
         */function (source) {
            return source.pipe(mergeMap(( /**
             * @param {?} t
             * @return {?}
             */function (/**
             * @param {?} t
             * @return {?}
             */ t) { return recognize(rootComponentType, config, t.urlAfterRedirects, serializer(t.urlAfterRedirects), paramsInheritanceStrategy, relativeLinkResolution)
                .pipe(map(( /**
         * @param {?} targetSnapshot
         * @return {?}
         */function (/**
         * @param {?} targetSnapshot
         * @return {?}
         */ targetSnapshot) { return (Object.assign({}, t, { targetSnapshot: targetSnapshot })); }))); })));
        });
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} paramsInheritanceStrategy
     * @param {?} moduleInjector
     * @return {?}
     */
    function resolveData(paramsInheritanceStrategy, moduleInjector) {
        return ( /**
         * @param {?} source
         * @return {?}
         */function (source) {
            return source.pipe(mergeMap(( /**
             * @param {?} t
             * @return {?}
             */function (/**
             * @param {?} t
             * @return {?}
             */ t) {
                var targetSnapshot = t.targetSnapshot, canActivateChecks = t.guards.canActivateChecks;
                if (!canActivateChecks.length) {
                    return of(t);
                }
                return from(canActivateChecks)
                    .pipe(concatMap(( /**
             * @param {?} check
             * @return {?}
             */function (/**
             * @param {?} check
             * @return {?}
             */ check) { return runResolve(check.route, ( /** @type {?} */(targetSnapshot)), paramsInheritanceStrategy, moduleInjector); })), reduce(( /**
                 * @param {?} _
                 * @param {?} __
                 * @return {?}
                 */function (_, __) { return _; })), map(( /**
                 * @param {?} _
                 * @return {?}
                 */function (/**
                 * @param {?} _
                 * @return {?}
                 */ _) { return t; })));
            })));
        });
    }
    /**
     * @param {?} futureARS
     * @param {?} futureRSS
     * @param {?} paramsInheritanceStrategy
     * @param {?} moduleInjector
     * @return {?}
     */
    function runResolve(futureARS, futureRSS, paramsInheritanceStrategy, moduleInjector) {
        /** @type {?} */
        var resolve = futureARS._resolve;
        return resolveNode(resolve, futureARS, futureRSS, moduleInjector)
            .pipe(map(( /**
     * @param {?} resolvedData
     * @return {?}
     */function (resolvedData) {
            futureARS._resolvedData = resolvedData;
            futureARS.data = Object.assign({}, futureARS.data, inheritedParamsDataResolve(futureARS, paramsInheritanceStrategy).resolve);
            return null;
        })));
    }
    /**
     * @param {?} resolve
     * @param {?} futureARS
     * @param {?} futureRSS
     * @param {?} moduleInjector
     * @return {?}
     */
    function resolveNode(resolve, futureARS, futureRSS, moduleInjector) {
        /** @type {?} */
        var keys = Object.keys(resolve);
        if (keys.length === 0) {
            return of({});
        }
        if (keys.length === 1) {
            /** @type {?} */
            var key_1 = keys[0];
            return getResolver(resolve[key_1], futureARS, futureRSS, moduleInjector)
                .pipe(map(( /**
         * @param {?} value
         * @return {?}
         */function (value) {
                var _b;
                return _b = {}, _b[key_1] = value, _b;
            })));
        }
        /** @type {?} */
        var data = {};
        /** @type {?} */
        var runningResolvers$ = from(keys).pipe(mergeMap(( /**
         * @param {?} key
         * @return {?}
         */function (key) {
            return getResolver(resolve[key], futureARS, futureRSS, moduleInjector)
                .pipe(map(( /**
         * @param {?} value
         * @return {?}
         */function (value) {
                data[key] = value;
                return value;
            })));
        })));
        return runningResolvers$.pipe(last(), map(( /**
         * @return {?}
         */function () { return data; })));
    }
    /**
     * @param {?} injectionToken
     * @param {?} futureARS
     * @param {?} futureRSS
     * @param {?} moduleInjector
     * @return {?}
     */
    function getResolver(injectionToken, futureARS, futureRSS, moduleInjector) {
        /** @type {?} */
        var resolver = getToken(injectionToken, futureARS, moduleInjector);
        return resolver.resolve ? wrapIntoObservable(resolver.resolve(futureARS, futureRSS)) :
            wrapIntoObservable(resolver(futureARS, futureRSS));
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Perform a side effect through a switchMap for every emission on the source Observable,
     * but return an Observable that is identical to the source. It's essentially the same as
     * the `tap` operator, but if the side effectful `next` function returns an ObservableInput,
     * it will wait before continuing with the original value.
     * @template T
     * @param {?} next
     * @return {?}
     */
    function switchTap(next) {
        return ( /**
         * @param {?} source
         * @return {?}
         */function (source) {
            return source.pipe(switchMap(( /**
             * @param {?} v
             * @return {?}
             */function (/**
             * @param {?} v
             * @return {?}
             */ v) {
                /** @type {?} */
                var nextResult = next(v);
                if (nextResult) {
                    return from(nextResult).pipe(map(( /**
                     * @return {?}
                     */function () { return v; })));
                }
                return from([v]);
            })));
        });
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * \@description
     *
     * Provides a way to customize when activated routes get reused.
     *
     * \@publicApi
     * @abstract
     */
    var RouteReuseStrategy = /** @class */ (function () {
        function RouteReuseStrategy() {
        }
        return RouteReuseStrategy;
    }());
    /**
     * Does not detach any subtrees. Reuses routes as long as their route config is the same.
     */
    var DefaultRouteReuseStrategy = /** @class */ (function () {
        function DefaultRouteReuseStrategy() {
        }
        /**
         * @param {?} route
         * @return {?}
         */
        DefaultRouteReuseStrategy.prototype.shouldDetach = function (route) { return false; };
        /**
         * @param {?} route
         * @param {?} detachedTree
         * @return {?}
         */
        DefaultRouteReuseStrategy.prototype.store = function (route, detachedTree) { };
        /**
         * @param {?} route
         * @return {?}
         */
        DefaultRouteReuseStrategy.prototype.shouldAttach = function (route) { return false; };
        /**
         * @param {?} route
         * @return {?}
         */
        DefaultRouteReuseStrategy.prototype.retrieve = function (route) { return null; };
        /**
         * @param {?} future
         * @param {?} curr
         * @return {?}
         */
        DefaultRouteReuseStrategy.prototype.shouldReuseRoute = function (future, curr) {
            return future.routeConfig === curr.routeConfig;
        };
        return DefaultRouteReuseStrategy;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The [DI token](guide/glossary/#di-token) for a router configuration.
     * @see `ROUTES`
     * \@publicApi
     * @type {?}
     */
    var ROUTES = new InjectionToken('ROUTES');
    var RouterConfigLoader = /** @class */ (function () {
        /**
         * @param {?} loader
         * @param {?} compiler
         * @param {?=} onLoadStartListener
         * @param {?=} onLoadEndListener
         */
        function RouterConfigLoader(loader, compiler, onLoadStartListener, onLoadEndListener) {
            this.loader = loader;
            this.compiler = compiler;
            this.onLoadStartListener = onLoadStartListener;
            this.onLoadEndListener = onLoadEndListener;
        }
        /**
         * @param {?} parentInjector
         * @param {?} route
         * @return {?}
         */
        RouterConfigLoader.prototype.load = function (parentInjector, route) {
            var _this = this;
            if (this.onLoadStartListener) {
                this.onLoadStartListener(route);
            }
            /** @type {?} */
            var moduleFactory$ = this.loadModuleFactory(( /** @type {?} */(route.loadChildren)));
            return moduleFactory$.pipe(map(( /**
             * @param {?} factory
             * @return {?}
             */function (factory) {
                if (_this.onLoadEndListener) {
                    _this.onLoadEndListener(route);
                }
                /** @type {?} */
                var module = factory.create(parentInjector);
                return new LoadedRouterConfig(flatten$1(module.injector.get(ROUTES)).map(standardizeConfig), module);
            })));
        };
        /**
         * @private
         * @param {?} loadChildren
         * @return {?}
         */
        RouterConfigLoader.prototype.loadModuleFactory = function (loadChildren) {
            var _this = this;
            if (typeof loadChildren === 'string') {
                return from(this.loader.load(loadChildren));
            }
            else {
                return wrapIntoObservable(loadChildren()).pipe(mergeMap(( /**
                 * @param {?} t
                 * @return {?}
                 */function (t) {
                    if (t instanceof NgModuleFactory) {
                        return of(t);
                    }
                    else {
                        return from(_this.compiler.compileModuleAsync(t));
                    }
                })));
            }
        };
        return RouterConfigLoader;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * \@description
     *
     * Provides a way to migrate AngularJS applications to Angular.
     *
     * \@publicApi
     * @abstract
     */
    var UrlHandlingStrategy = /** @class */ (function () {
        function UrlHandlingStrategy() {
        }
        return UrlHandlingStrategy;
    }());
    /**
     * \@publicApi
     */
    var DefaultUrlHandlingStrategy = /** @class */ (function () {
        function DefaultUrlHandlingStrategy() {
        }
        /**
         * @param {?} url
         * @return {?}
         */
        DefaultUrlHandlingStrategy.prototype.shouldProcessUrl = function (url) { return true; };
        /**
         * @param {?} url
         * @return {?}
         */
        DefaultUrlHandlingStrategy.prototype.extract = function (url) { return url; };
        /**
         * @param {?} newUrlPart
         * @param {?} wholeUrl
         * @return {?}
         */
        DefaultUrlHandlingStrategy.prototype.merge = function (newUrlPart, wholeUrl) { return newUrlPart; };
        return DefaultUrlHandlingStrategy;
    }());
    /**
     * @param {?} error
     * @return {?}
     */
    function defaultErrorHandler(error) {
        throw error;
    }
    /**
     * @param {?} error
     * @param {?} urlSerializer
     * @param {?} url
     * @return {?}
     */
    function defaultMalformedUriErrorHandler(error, urlSerializer, url) {
        return urlSerializer.parse('/');
    }
    /**
     * \@internal
     * @param {?} snapshot
     * @param {?} runExtras
     * @return {?}
     */
    function defaultRouterHook(snapshot, runExtras) {
        return ( /** @type {?} */(of(null)));
    }
    /**
     * \@description
     *
     * A service that provides navigation and URL manipulation capabilities.
     *
     * @see `Route`.
     * @see [Routing and Navigation Guide](guide/router).
     *
     * \@ngModule RouterModule
     *
     * \@publicApi
     */
    var Router = /** @class */ (function () {
        /**
         * Creates the router service.
         * @param {?} rootComponentType
         * @param {?} urlSerializer
         * @param {?} rootContexts
         * @param {?} location
         * @param {?} injector
         * @param {?} loader
         * @param {?} compiler
         * @param {?} config
         */
        // TODO: vsavkin make internal after the final is out.
        function Router(rootComponentType, urlSerializer, rootContexts, location, injector, loader, compiler, config) {
            var _this = this;
            this.rootComponentType = rootComponentType;
            this.urlSerializer = urlSerializer;
            this.rootContexts = rootContexts;
            this.location = location;
            this.config = config;
            this.lastSuccessfulNavigation = null;
            this.currentNavigation = null;
            this.navigationId = 0;
            this.isNgZoneEnabled = false;
            /**
             * An event stream for routing events in this NgModule.
             */
            this.events = new Subject();
            /**
             * A handler for navigation errors in this NgModule.
             */
            this.errorHandler = defaultErrorHandler;
            /**
             * A handler for errors thrown by `Router.parseUrl(url)`
             * when `url` contains an invalid character.
             * The most common case is a `%` sign
             * that's not encoded and is not part of a percent encoded sequence.
             */
            this.malformedUriErrorHandler = defaultMalformedUriErrorHandler;
            /**
             * True if at least one navigation event has occurred,
             * false otherwise.
             */
            this.navigated = false;
            this.lastSuccessfulId = -1;
            /**
             * Hooks that enable you to pause navigation,
             * either before or after the preactivation phase.
             * Used by `RouterModule`.
             *
             * \@internal
             */
            this.hooks = {
                beforePreactivation: defaultRouterHook,
                afterPreactivation: defaultRouterHook
            };
            /**
             * A strategy for extracting and merging URLs.
             * Used for AngularJS to Angular migrations.
             */
            this.urlHandlingStrategy = new DefaultUrlHandlingStrategy();
            /**
             * A strategy for re-using routes.
             */
            this.routeReuseStrategy = new DefaultRouteReuseStrategy();
            /**
             * How to handle a navigation request to the current URL. One of:
             * - `'ignore'` :  The router ignores the request.
             * - `'reload'` : The router reloads the URL. Use to implement a "refresh" feature.
             */
            this.onSameUrlNavigation = 'ignore';
            /**
             * How to merge parameters, data, and resolved data from parent to child
             * routes. One of:
             *
             * - `'emptyOnly'` : Inherit parent parameters, data, and resolved data
             * for path-less or component-less routes.
             * - `'always'` : Inherit parent parameters, data, and resolved data
             * for all child routes.
             */
            this.paramsInheritanceStrategy = 'emptyOnly';
            /**
             * Determines when the router updates the browser URL.
             * By default (`"deferred"`), updates the browser URL after navigation has finished.
             * Set to `'eager'` to update the browser URL at the beginning of navigation.
             * You can choose to update early so that, if navigation fails,
             * you can show an error message with the URL that failed.
             */
            this.urlUpdateStrategy = 'deferred';
            /**
             * Enables a bug fix that corrects relative link resolution in components with empty paths.
             * @see `RouterModule`
             */
            this.relativeLinkResolution = 'legacy';
            /** @type {?} */
            var onLoadStart = ( /**
             * @param {?} r
             * @return {?}
             */function (r) { return _this.triggerEvent(new RouteConfigLoadStart(r)); });
            /** @type {?} */
            var onLoadEnd = ( /**
             * @param {?} r
             * @return {?}
             */function (r) { return _this.triggerEvent(new RouteConfigLoadEnd(r)); });
            this.ngModule = injector.get(NgModuleRef);
            this.console = injector.get(Console);
            /** @type {?} */
            var ngZone = injector.get(NgZone);
            this.isNgZoneEnabled = ngZone instanceof NgZone;
            this.resetConfig(config);
            this.currentUrlTree = createEmptyUrlTree();
            this.rawUrlTree = this.currentUrlTree;
            this.browserUrlTree = this.currentUrlTree;
            this.configLoader = new RouterConfigLoader(loader, compiler, onLoadStart, onLoadEnd);
            this.routerState = createEmptyState(this.currentUrlTree, this.rootComponentType);
            this.transitions = new BehaviorSubject({
                id: 0,
                currentUrlTree: this.currentUrlTree,
                currentRawUrl: this.currentUrlTree,
                extractedUrl: this.urlHandlingStrategy.extract(this.currentUrlTree),
                urlAfterRedirects: this.urlHandlingStrategy.extract(this.currentUrlTree),
                rawUrl: this.currentUrlTree,
                extras: {},
                resolve: null,
                reject: null,
                promise: Promise.resolve(true),
                source: 'imperative',
                restoredState: null,
                currentSnapshot: this.routerState.snapshot,
                targetSnapshot: null,
                currentRouterState: this.routerState,
                targetRouterState: null,
                guards: { canActivateChecks: [], canDeactivateChecks: [] },
                guardsResult: null,
            });
            this.navigations = this.setupNavigations(this.transitions);
            this.processNavigations();
        }
        /**
         * @private
         * @param {?} transitions
         * @return {?}
         */
        Router.prototype.setupNavigations = function (transitions) {
            var _this = this;
            /** @type {?} */
            var eventsSubject = (( /** @type {?} */(this.events)));
            return ( /** @type {?} */(( /** @type {?} */(transitions.pipe(filter(( /**
             * @param {?} t
             * @return {?}
             */function (/**
             * @param {?} t
             * @return {?}
             */ t) { return t.id !== 0; })), 
            // Extract URL
            map(( /**
             * @param {?} t
             * @return {?}
             */function (/**
             * @param {?} t
             * @return {?}
             */ t) { return (( /** @type {?} */(Object.assign({}, t, { extractedUrl: _this.urlHandlingStrategy.extract(t.rawUrl) })))); })), 
            // Using switchMap so we cancel executing navigations when a new one comes in
            switchMap(( /**
             * @param {?} t
             * @return {?}
             */function (/**
             * @param {?} t
             * @return {?}
             */ t) {
                /** @type {?} */
                var completed = false;
                /** @type {?} */
                var errored = false;
                return of(t).pipe(
                // Store the Navigation object
                tap(( /**
                 * @param {?} t
                 * @return {?}
                 */function (/**
                 * @param {?} t
                 * @return {?}
                 */ t) {
                    _this.currentNavigation = {
                        id: t.id,
                        initialUrl: t.currentRawUrl,
                        extractedUrl: t.extractedUrl,
                        trigger: t.source,
                        extras: t.extras,
                        previousNavigation: _this.lastSuccessfulNavigation ? Object.assign({}, _this.lastSuccessfulNavigation, { previousNavigation: null }) :
                            null
                    };
                })), switchMap(( /**
                 * @param {?} t
                 * @return {?}
                 */function (/**
                 * @param {?} t
                 * @return {?}
                 */ t) {
                    /** @type {?} */
                    var urlTransition = !_this.navigated || t.extractedUrl.toString() !== _this.browserUrlTree.toString();
                    /** @type {?} */
                    var processCurrentUrl = (_this.onSameUrlNavigation === 'reload' ? true : urlTransition) &&
                        _this.urlHandlingStrategy.shouldProcessUrl(t.rawUrl);
                    if (processCurrentUrl) {
                        return of(t).pipe(
                        // Fire NavigationStart event
                        switchMap(( /**
                         * @param {?} t
                         * @return {?}
                         */function (/**
                         * @param {?} t
                         * @return {?}
                         */ t) {
                            /** @type {?} */
                            var transition = _this.transitions.getValue();
                            eventsSubject.next(new NavigationStart(t.id, _this.serializeUrl(t.extractedUrl), t.source, t.restoredState));
                            if (transition !== _this.transitions.getValue()) {
                                return EMPTY;
                            }
                            return [t];
                        })), 
                        // This delay is required to match old behavior that forced navigation to
                        // always be async
                        switchMap(( /**
                         * @param {?} t
                         * @return {?}
                         */function (/**
                         * @param {?} t
                         * @return {?}
                         */ t) { return Promise.resolve(t); })), 
                        // ApplyRedirects
                        applyRedirects$1(_this.ngModule.injector, _this.configLoader, _this.urlSerializer, _this.config), 
                        // Update the currentNavigation
                        tap(( /**
                         * @param {?} t
                         * @return {?}
                         */function (/**
                         * @param {?} t
                         * @return {?}
                         */ t) {
                            _this.currentNavigation = Object.assign({}, ( /** @type {?} */(_this.currentNavigation)), { finalUrl: t.urlAfterRedirects });
                        })), 
                        // Recognize
                        recognize$1(_this.rootComponentType, _this.config, ( /**
                         * @param {?} url
                         * @return {?}
                         */function (url) { return _this.serializeUrl(url); }), _this.paramsInheritanceStrategy, _this.relativeLinkResolution), 
                        // Update URL if in `eager` update mode
                        tap(( /**
                         * @param {?} t
                         * @return {?}
                         */function (/**
                         * @param {?} t
                         * @return {?}
                         */ t) {
                            if (_this.urlUpdateStrategy === 'eager') {
                                if (!t.extras.skipLocationChange) {
                                    _this.setBrowserUrl(t.urlAfterRedirects, !!t.extras.replaceUrl, t.id, t.extras.state);
                                }
                                _this.browserUrlTree = t.urlAfterRedirects;
                            }
                        })), 
                        // Fire RoutesRecognized
                        tap(( /**
                         * @param {?} t
                         * @return {?}
                         */function (/**
                         * @param {?} t
                         * @return {?}
                         */ t) {
                            /** @type {?} */
                            var routesRecognized = new RoutesRecognized(t.id, _this.serializeUrl(t.extractedUrl), _this.serializeUrl(t.urlAfterRedirects), ( /** @type {?} */(t.targetSnapshot)));
                            eventsSubject.next(routesRecognized);
                        })));
                    }
                    else {
                        /** @type {?} */
                        var processPreviousUrl = urlTransition && _this.rawUrlTree &&
                            _this.urlHandlingStrategy.shouldProcessUrl(_this.rawUrlTree);
                        /* When the current URL shouldn't be processed, but the previous one was, we
                         * handle this "error condition" by navigating to the previously successful URL,
                         * but leaving the URL intact.*/
                        if (processPreviousUrl) {
                            var id = t.id, extractedUrl = t.extractedUrl, source = t.source, restoredState = t.restoredState, extras = t.extras;
                            /** @type {?} */
                            var navStart = new NavigationStart(id, _this.serializeUrl(extractedUrl), source, restoredState);
                            eventsSubject.next(navStart);
                            /** @type {?} */
                            var targetSnapshot = createEmptyState(extractedUrl, _this.rootComponentType).snapshot;
                            return of(Object.assign({}, t, { targetSnapshot: targetSnapshot, urlAfterRedirects: extractedUrl, extras: Object.assign({}, extras, { skipLocationChange: false, replaceUrl: false }) }));
                        }
                        else {
                            /* When neither the current or previous URL can be processed, do nothing other
                             * than update router's internal reference to the current "settled" URL. This
                             * way the next navigation will be coming from the current URL in the browser.
                             */
                            _this.rawUrlTree = t.rawUrl;
                            _this.browserUrlTree = t.urlAfterRedirects;
                            t.resolve(null);
                            return EMPTY;
                        }
                    }
                })), 
                // Before Preactivation
                switchTap(( /**
                 * @param {?} t
                 * @return {?}
                 */function (/**
                 * @param {?} t
                 * @return {?}
                 */ t) {
                    var targetSnapshot = t.targetSnapshot, navigationId = t.id, appliedUrlTree = t.extractedUrl, rawUrlTree = t.rawUrl, _b = t.extras, skipLocationChange = _b.skipLocationChange, replaceUrl = _b.replaceUrl;
                    return _this.hooks.beforePreactivation(( /** @type {?} */(targetSnapshot)), {
                        navigationId: navigationId,
                        appliedUrlTree: appliedUrlTree,
                        rawUrlTree: rawUrlTree,
                        skipLocationChange: !!skipLocationChange,
                        replaceUrl: !!replaceUrl,
                    });
                })), 
                // --- GUARDS ---
                tap(( /**
                 * @param {?} t
                 * @return {?}
                 */function (/**
                 * @param {?} t
                 * @return {?}
                 */ t) {
                    /** @type {?} */
                    var guardsStart = new GuardsCheckStart(t.id, _this.serializeUrl(t.extractedUrl), _this.serializeUrl(t.urlAfterRedirects), ( /** @type {?} */(t.targetSnapshot)));
                    _this.triggerEvent(guardsStart);
                })), map(( /**
                 * @param {?} t
                 * @return {?}
                 */function (/**
                 * @param {?} t
                 * @return {?}
                 */ t) { return (Object.assign({}, t, { guards: getAllRouteGuards(( /** @type {?} */(t.targetSnapshot)), t.currentSnapshot, _this.rootContexts) })); })), checkGuards(_this.ngModule.injector, ( /**
                 * @param {?} evt
                 * @return {?}
                 */function (evt) { return _this.triggerEvent(evt); })), tap(( /**
                 * @param {?} t
                 * @return {?}
                 */function (/**
                 * @param {?} t
                 * @return {?}
                 */ t) {
                    if (isUrlTree(t.guardsResult)) {
                        /** @type {?} */
                        var error = navigationCancelingError("Redirecting to \"" + _this.serializeUrl(t.guardsResult) + "\"");
                        error.url = t.guardsResult;
                        throw error;
                    }
                })), tap(( /**
                 * @param {?} t
                 * @return {?}
                 */function (/**
                 * @param {?} t
                 * @return {?}
                 */ t) {
                    /** @type {?} */
                    var guardsEnd = new GuardsCheckEnd(t.id, _this.serializeUrl(t.extractedUrl), _this.serializeUrl(t.urlAfterRedirects), ( /** @type {?} */(t.targetSnapshot)), !!t.guardsResult);
                    _this.triggerEvent(guardsEnd);
                })), filter(( /**
                 * @param {?} t
                 * @return {?}
                 */function (/**
                 * @param {?} t
                 * @return {?}
                 */ t) {
                    if (!t.guardsResult) {
                        _this.resetUrlToCurrentUrlTree();
                        /** @type {?} */
                        var navCancel = new NavigationCancel(t.id, _this.serializeUrl(t.extractedUrl), '');
                        eventsSubject.next(navCancel);
                        t.resolve(false);
                        return false;
                    }
                    return true;
                })), 
                // --- RESOLVE ---
                switchTap(( /**
                 * @param {?} t
                 * @return {?}
                 */function (/**
                 * @param {?} t
                 * @return {?}
                 */ t) {
                    if (t.guards.canActivateChecks.length) {
                        return of(t).pipe(tap(( /**
                         * @param {?} t
                         * @return {?}
                         */function (/**
                         * @param {?} t
                         * @return {?}
                         */ t) {
                            /** @type {?} */
                            var resolveStart = new ResolveStart(t.id, _this.serializeUrl(t.extractedUrl), _this.serializeUrl(t.urlAfterRedirects), ( /** @type {?} */(t.targetSnapshot)));
                            _this.triggerEvent(resolveStart);
                        })), resolveData(_this.paramsInheritanceStrategy, _this.ngModule.injector), //
                        tap(( /**
                         * @param {?} t
                         * @return {?}
                         */function (/**
                         * @param {?} t
                         * @return {?}
                         */ t) {
                            /** @type {?} */
                            var resolveEnd = new ResolveEnd(t.id, _this.serializeUrl(t.extractedUrl), _this.serializeUrl(t.urlAfterRedirects), ( /** @type {?} */(t.targetSnapshot)));
                            _this.triggerEvent(resolveEnd);
                        })));
                    }
                    return undefined;
                })), 
                // --- AFTER PREACTIVATION ---
                switchTap(( /**
                 * @param {?} t
                 * @return {?}
                 */function (t) {
                    var targetSnapshot = t.targetSnapshot, navigationId = t.id, appliedUrlTree = t.extractedUrl, rawUrlTree = t.rawUrl, _b = t.extras, skipLocationChange = _b.skipLocationChange, replaceUrl = _b.replaceUrl;
                    return _this.hooks.afterPreactivation(( /** @type {?} */(targetSnapshot)), {
                        navigationId: navigationId,
                        appliedUrlTree: appliedUrlTree,
                        rawUrlTree: rawUrlTree,
                        skipLocationChange: !!skipLocationChange,
                        replaceUrl: !!replaceUrl,
                    });
                })), map(( /**
                 * @param {?} t
                 * @return {?}
                 */function (t) {
                    /** @type {?} */
                    var targetRouterState = createRouterState(_this.routeReuseStrategy, ( /** @type {?} */(t.targetSnapshot)), t.currentRouterState);
                    return (Object.assign({}, t, { targetRouterState: targetRouterState }));
                })), 
                /* Once here, we are about to activate syncronously. The assumption is this will
                   succeed, and user code may read from the Router service. Therefore before
                   activation, we need to update router properties storing the current URL and the
                   RouterState, as well as updated the browser URL. All this should happen *before*
                   activating. */
                tap(( /**
                 * @param {?} t
                 * @return {?}
                 */function (t) {
                    _this.currentUrlTree = t.urlAfterRedirects;
                    _this.rawUrlTree = _this.urlHandlingStrategy.merge(_this.currentUrlTree, t.rawUrl);
                    (( /** @type {?} */(_this))).routerState = ( /** @type {?} */(t.targetRouterState));
                    if (_this.urlUpdateStrategy === 'deferred') {
                        if (!t.extras.skipLocationChange) {
                            _this.setBrowserUrl(_this.rawUrlTree, !!t.extras.replaceUrl, t.id, t.extras.state);
                        }
                        _this.browserUrlTree = t.urlAfterRedirects;
                    }
                })), activateRoutes(_this.rootContexts, _this.routeReuseStrategy, ( /**
                 * @param {?} evt
                 * @return {?}
                 */function (evt) { return _this.triggerEvent(evt); })), tap({
                    next: function () { completed = true; },
                    complete: function () { completed = true; }
                }), finalize(( /**
             * @return {?}
             */function () {
                    /* When the navigation stream finishes either through error or success, we set the
                     * `completed` or `errored` flag. However, there are some situations where we could
                     * get here without either of those being set. For instance, a redirect during
                     * NavigationStart. Therefore, this is a catch-all to make sure the NavigationCancel
                     * event is fired when a navigation gets cancelled but not caught by other means. */
                    if (!completed && !errored) {
                        // Must reset to current URL tree here to ensure history.state is set. On a fresh
                        // page load, if a new navigation comes in before a successful navigation
                        // completes, there will be nothing in history.state.navigationId. This can cause
                        // sync problems with AngularJS sync code which looks for a value here in order
                        // to determine whether or not to handle a given popstate event or to leave it
                        // to the Angualr router.
                        _this.resetUrlToCurrentUrlTree();
                        /** @type {?} */
                        var navCancel = new NavigationCancel(t.id, _this.serializeUrl(t.extractedUrl), "Navigation ID " + t.id + " is not equal to the current navigation id " + _this.navigationId);
                        eventsSubject.next(navCancel);
                        t.resolve(false);
                    }
                    // currentNavigation should always be reset to null here. If navigation was
                    // successful, lastSuccessfulTransition will have already been set. Therefore we
                    // can safely set currentNavigation to null here.
                    _this.currentNavigation = null;
                })), catchError(( /**
                 * @param {?} e
                 * @return {?}
                 */function (e) {
                    errored = true;
                    /* This error type is issued during Redirect, and is handled as a cancellation
                     * rather than an error. */
                    if (isNavigationCancelingError(e)) {
                        /** @type {?} */
                        var redirecting = isUrlTree(e.url);
                        if (!redirecting) {
                            // Set property only if we're not redirecting. If we landed on a page and
                            // redirect to `/` route, the new navigation is going to see the `/` isn't
                            // a change from the default currentUrlTree and won't navigate. This is
                            // only applicable with initial navigation, so setting `navigated` only when
                            // not redirecting resolves this scenario.
                            _this.navigated = true;
                            _this.resetStateAndUrl(t.currentRouterState, t.currentUrlTree, t.rawUrl);
                        }
                        /** @type {?} */
                        var navCancel = new NavigationCancel(t.id, _this.serializeUrl(t.extractedUrl), e.message);
                        eventsSubject.next(navCancel);
                        t.resolve(false);
                        if (redirecting) {
                            _this.navigateByUrl(e.url);
                        }
                        /* All other errors should reset to the router's internal URL reference to the
                         * pre-error state. */
                    }
                    else {
                        _this.resetStateAndUrl(t.currentRouterState, t.currentUrlTree, t.rawUrl);
                        /** @type {?} */
                        var navError = new NavigationError(t.id, _this.serializeUrl(t.extractedUrl), e);
                        eventsSubject.next(navError);
                        try {
                            t.resolve(_this.errorHandler(e));
                        }
                        catch (ee) {
                            t.reject(ee);
                        }
                    }
                    return EMPTY;
                })));
                // TODO(jasonaden): remove cast once g3 is on updated TypeScript
            })))))));
        };
        /**
         * \@internal
         * TODO: this should be removed once the constructor of the router made internal
         * @param {?} rootComponentType
         * @return {?}
         */
        Router.prototype.resetRootComponentType = function (rootComponentType) {
            this.rootComponentType = rootComponentType;
            // TODO: vsavkin router 4.0 should make the root component set to null
            // this will simplify the lifecycle of the router.
            this.routerState.root.component = this.rootComponentType;
        };
        /**
         * @private
         * @return {?}
         */
        Router.prototype.getTransition = function () {
            /** @type {?} */
            var transition = this.transitions.value;
            // This value needs to be set. Other values such as extractedUrl are set on initial navigation
            // but the urlAfterRedirects may not get set if we aren't processing the new URL *and* not
            // processing the previous URL.
            transition.urlAfterRedirects = this.browserUrlTree;
            return transition;
        };
        /**
         * @private
         * @param {?} t
         * @return {?}
         */
        Router.prototype.setTransition = function (t) {
            this.transitions.next(Object.assign({}, this.getTransition(), t));
        };
        /**
         * Sets up the location change listener and performs the initial navigation.
         * @return {?}
         */
        Router.prototype.initialNavigation = function () {
            this.setUpLocationChangeListener();
            if (this.navigationId === 0) {
                this.navigateByUrl(this.location.path(true), { replaceUrl: true });
            }
        };
        /**
         * Sets up the location change listener.
         * @return {?}
         */
        Router.prototype.setUpLocationChangeListener = function () {
            var _this = this;
            // Don't need to use Zone.wrap any more, because zone.js
            // already patch onPopState, so location change callback will
            // run into ngZone
            if (!this.locationSubscription) {
                this.locationSubscription = ( /** @type {?} */(this.location.subscribe(( /**
                 * @param {?} change
                 * @return {?}
                 */function (change) {
                    /** @type {?} */
                    var rawUrlTree = _this.parseUrl(change['url']);
                    /** @type {?} */
                    var source = change['type'] === 'popstate' ? 'popstate' : 'hashchange';
                    // Navigations coming from Angular router have a navigationId state property. When this
                    // exists, restore the state.
                    /** @type {?} */
                    var state = change.state && change.state.navigationId ? change.state : null;
                    setTimeout(( /**
                     * @return {?}
                     */function () { _this.scheduleNavigation(rawUrlTree, source, state, { replaceUrl: true }); }), 0);
                }))));
            }
        };
        Object.defineProperty(Router.prototype, "url", {
            /**
             * The current URL.
             * @return {?}
             */
            get: function () { return this.serializeUrl(this.currentUrlTree); },
            enumerable: true,
            configurable: true
        });
        /**
         * The current Navigation object if one exists
         * @return {?}
         */
        Router.prototype.getCurrentNavigation = function () { return this.currentNavigation; };
        /**
         * \@internal
         * @param {?} event
         * @return {?}
         */
        Router.prototype.triggerEvent = function (event) { (( /** @type {?} */(this.events))).next(event); };
        /**
         * Resets the configuration used for navigation and generating links.
         *
         * \@usageNotes
         *
         * ```
         * router.resetConfig([
         *  { path: 'team/:id', component: TeamCmp, children: [
         *    { path: 'simple', component: SimpleCmp },
         *    { path: 'user/:name', component: UserCmp }
         *  ]}
         * ]);
         * ```
         * @param {?} config The route array for the new configuration.
         *
         * @return {?}
         */
        Router.prototype.resetConfig = function (config) {
            validateConfig(config);
            this.config = config.map(standardizeConfig);
            this.navigated = false;
            this.lastSuccessfulId = -1;
        };
        /**
         * \@docsNotRequired
         * @return {?}
         */
        Router.prototype.ngOnDestroy = function () { this.dispose(); };
        /**
         * Disposes of the router.
         * @return {?}
         */
        Router.prototype.dispose = function () {
            if (this.locationSubscription) {
                this.locationSubscription.unsubscribe();
                this.locationSubscription = ( /** @type {?} */(null));
            }
        };
        /**
         * Applies an array of commands to the current URL tree and creates a new URL tree.
         *
         * When given an activated route, applies the given commands starting from the route.
         * Otherwise, applies the given command starting from the root.
         *
         * \@usageNotes
         *
         * ```
         * // create /team/33/user/11
         * router.createUrlTree(['/team', 33, 'user', 11]);
         *
         * // create /team/33;expand=true/user/11
         * router.createUrlTree(['/team', 33, {expand: true}, 'user', 11]);
         *
         * // you can collapse static segments like this (this works only with the first passed-in value):
         * router.createUrlTree(['/team/33/user', userId]);
         *
         * // If the first segment can contain slashes, and you do not want the router to split it,
         * // you can do the following:
         * router.createUrlTree([{segmentPath: '/one/two'}]);
         *
         * // create /team/33/(user/11//right:chat)
         * router.createUrlTree(['/team', 33, {outlets: {primary: 'user/11', right: 'chat'}}]);
         *
         * // remove the right secondary node
         * router.createUrlTree(['/team', 33, {outlets: {primary: 'user/11', right: null}}]);
         *
         * // assuming the current url is `/team/33/user/11` and the route points to `user/11`
         *
         * // navigate to /team/33/user/11/details
         * router.createUrlTree(['details'], {relativeTo: route});
         *
         * // navigate to /team/33/user/22
         * router.createUrlTree(['../22'], {relativeTo: route});
         *
         * // navigate to /team/44/user/22
         * router.createUrlTree(['../../team/44/user/22'], {relativeTo: route});
         * ```
         * @param {?} commands An array of commands to apply.
         * @param {?=} navigationExtras Options that control the navigation strategy.
         * @return {?} The new URL tree.
         *
         */
        Router.prototype.createUrlTree = function (commands, navigationExtras) {
            if (navigationExtras === void 0) { navigationExtras = {}; }
            var relativeTo = navigationExtras.relativeTo, queryParams = navigationExtras.queryParams, fragment = navigationExtras.fragment, preserveQueryParams = navigationExtras.preserveQueryParams, queryParamsHandling = navigationExtras.queryParamsHandling, preserveFragment = navigationExtras.preserveFragment;
            if (isDevMode() && preserveQueryParams && ( /** @type {?} */(console)) && ( /** @type {?} */(console.warn))) {
                console.warn('preserveQueryParams is deprecated, use queryParamsHandling instead.');
            }
            /** @type {?} */
            var a = relativeTo || this.routerState.root;
            /** @type {?} */
            var f = preserveFragment ? this.currentUrlTree.fragment : fragment;
            /** @type {?} */
            var q = null;
            if (queryParamsHandling) {
                switch (queryParamsHandling) {
                    case 'merge':
                        q = Object.assign({}, this.currentUrlTree.queryParams, queryParams);
                        break;
                    case 'preserve':
                        q = this.currentUrlTree.queryParams;
                        break;
                    default:
                        q = queryParams || null;
                }
            }
            else {
                q = preserveQueryParams ? this.currentUrlTree.queryParams : queryParams || null;
            }
            if (q !== null) {
                q = this.removeEmptyProps(q);
            }
            return createUrlTree(a, this.currentUrlTree, commands, ( /** @type {?} */(q)), ( /** @type {?} */(f)));
        };
        /**
         * Navigate based on the provided URL, which must be absolute.
         *
         * \@usageNotes
         *
         * ```
         * router.navigateByUrl("/team/33/user/11");
         *
         * // Navigate without updating the URL
         * router.navigateByUrl("/team/33/user/11", { skipLocationChange: true });
         * ```
         *
         * @param {?} url An absolute URL. The function does not apply any delta to the current URL.
         * @param {?=} extras An object containing properties that modify the navigation strategy.
         * The function ignores any properties in the `NavigationExtras` that would change the
         * provided URL.
         *
         * @return {?} A Promise that resolves to 'true' when navigation succeeds,
         * to 'false' when navigation fails, or is rejected on error.
         *
         */
        Router.prototype.navigateByUrl = function (url, extras) {
            if (extras === void 0) { extras = { skipLocationChange: false }; }
            if (isDevMode() && this.isNgZoneEnabled && !NgZone.isInAngularZone()) {
                this.console.warn("Navigation triggered outside Angular zone, did you forget to call 'ngZone.run()'?");
            }
            /** @type {?} */
            var urlTree = isUrlTree(url) ? url : this.parseUrl(url);
            /** @type {?} */
            var mergedTree = this.urlHandlingStrategy.merge(urlTree, this.rawUrlTree);
            return this.scheduleNavigation(mergedTree, 'imperative', null, extras);
        };
        /**
         * Navigate based on the provided array of commands and a starting point.
         * If no starting route is provided, the navigation is absolute.
         *
         * Returns a promise that:
         * - resolves to 'true' when navigation succeeds,
         * - resolves to 'false' when navigation fails,
         * - is rejected when an error happens.
         *
         * \@usageNotes
         *
         * ```
         * router.navigate(['team', 33, 'user', 11], {relativeTo: route});
         *
         * // Navigate without updating the URL
         * router.navigate(['team', 33, 'user', 11], {relativeTo: route, skipLocationChange: true});
         * ```
         *
         * The first parameter of `navigate()` is a delta to be applied to the current URL
         * or the one provided in the `relativeTo` property of the second parameter (the
         * `NavigationExtras`).
         *
         * In order to affect this browser's `history.state` entry, the `state`
         * parameter can be passed. This must be an object because the router
         * will add the `navigationId` property to this object before creating
         * the new history item.
         * @param {?} commands
         * @param {?=} extras
         * @return {?}
         */
        Router.prototype.navigate = function (commands, extras) {
            if (extras === void 0) { extras = { skipLocationChange: false }; }
            validateCommands(commands);
            return this.navigateByUrl(this.createUrlTree(commands, extras), extras);
        };
        /**
         * Serializes a `UrlTree` into a string
         * @param {?} url
         * @return {?}
         */
        Router.prototype.serializeUrl = function (url) { return this.urlSerializer.serialize(url); };
        /**
         * Parses a string into a `UrlTree`
         * @param {?} url
         * @return {?}
         */
        Router.prototype.parseUrl = function (url) {
            /** @type {?} */
            var urlTree;
            try {
                urlTree = this.urlSerializer.parse(url);
            }
            catch (e) {
                urlTree = this.malformedUriErrorHandler(e, this.urlSerializer, url);
            }
            return urlTree;
        };
        /**
         * Returns whether the url is activated
         * @param {?} url
         * @param {?} exact
         * @return {?}
         */
        Router.prototype.isActive = function (url, exact) {
            if (isUrlTree(url)) {
                return containsTree(this.currentUrlTree, url, exact);
            }
            /** @type {?} */
            var urlTree = this.parseUrl(url);
            return containsTree(this.currentUrlTree, urlTree, exact);
        };
        /**
         * @private
         * @param {?} params
         * @return {?}
         */
        Router.prototype.removeEmptyProps = function (params) {
            return Object.keys(params).reduce(( /**
             * @param {?} result
             * @param {?} key
             * @return {?}
             */function (result, key) {
                /** @type {?} */
                var value = params[key];
                if (value !== null && value !== undefined) {
                    result[key] = value;
                }
                return result;
            }), {});
        };
        /**
         * @private
         * @return {?}
         */
        Router.prototype.processNavigations = function () {
            var _this = this;
            this.navigations.subscribe(( /**
             * @param {?} t
             * @return {?}
             */function (/**
             * @param {?} t
             * @return {?}
             */ t) {
                _this.navigated = true;
                _this.lastSuccessfulId = t.id;
                (( /** @type {?} */(_this.events)))
                    .next(new NavigationEnd(t.id, _this.serializeUrl(t.extractedUrl), _this.serializeUrl(_this.currentUrlTree)));
                _this.lastSuccessfulNavigation = _this.currentNavigation;
                _this.currentNavigation = null;
                t.resolve(true);
            }), ( /**
             * @param {?} e
             * @return {?}
             */function (/**
             * @param {?} e
             * @return {?}
             */ e) { _this.console.warn("Unhandled Navigation Error: "); }));
        };
        /**
         * @private
         * @param {?} rawUrl
         * @param {?} source
         * @param {?} restoredState
         * @param {?} extras
         * @return {?}
         */
        Router.prototype.scheduleNavigation = function (rawUrl, source, restoredState, extras) {
            /** @type {?} */
            var lastNavigation = this.getTransition();
            // If the user triggers a navigation imperatively (e.g., by using navigateByUrl),
            // and that navigation results in 'replaceState' that leads to the same URL,
            // we should skip those.
            if (lastNavigation && source !== 'imperative' && lastNavigation.source === 'imperative' &&
                lastNavigation.rawUrl.toString() === rawUrl.toString()) {
                return Promise.resolve(true); // return value is not used
            }
            // Because of a bug in IE and Edge, the location class fires two events (popstate and
            // hashchange) every single time. The second one should be ignored. Otherwise, the URL will
            // flicker. Handles the case when a popstate was emitted first.
            if (lastNavigation && source == 'hashchange' && lastNavigation.source === 'popstate' &&
                lastNavigation.rawUrl.toString() === rawUrl.toString()) {
                return Promise.resolve(true); // return value is not used
            }
            // Because of a bug in IE and Edge, the location class fires two events (popstate and
            // hashchange) every single time. The second one should be ignored. Otherwise, the URL will
            // flicker. Handles the case when a hashchange was emitted first.
            if (lastNavigation && source == 'popstate' && lastNavigation.source === 'hashchange' &&
                lastNavigation.rawUrl.toString() === rawUrl.toString()) {
                return Promise.resolve(true); // return value is not used
            }
            /** @type {?} */
            var resolve = null;
            /** @type {?} */
            var reject = null;
            /** @type {?} */
            var promise = new Promise(( /**
             * @param {?} res
             * @param {?} rej
             * @return {?}
             */function (res, rej) {
                resolve = res;
                reject = rej;
            }));
            /** @type {?} */
            var id = ++this.navigationId;
            this.setTransition({
                id: id,
                source: source,
                restoredState: restoredState,
                currentUrlTree: this.currentUrlTree,
                currentRawUrl: this.rawUrlTree, rawUrl: rawUrl, extras: extras, resolve: resolve, reject: reject, promise: promise,
                currentSnapshot: this.routerState.snapshot,
                currentRouterState: this.routerState
            });
            // Make sure that the error is propagated even though `processNavigations` catch
            // handler does not rethrow
            return promise.catch(( /**
             * @param {?} e
             * @return {?}
             */function (e) { return Promise.reject(e); }));
        };
        /**
         * @private
         * @param {?} url
         * @param {?} replaceUrl
         * @param {?} id
         * @param {?=} state
         * @return {?}
         */
        Router.prototype.setBrowserUrl = function (url, replaceUrl, id, state) {
            /** @type {?} */
            var path = this.urlSerializer.serialize(url);
            state = state || {};
            if (this.location.isCurrentPathEqualTo(path) || replaceUrl) {
                // TODO(jasonaden): Remove first `navigationId` and rely on `ng` namespace.
                this.location.replaceState(path, '', Object.assign({}, state, { navigationId: id }));
            }
            else {
                this.location.go(path, '', Object.assign({}, state, { navigationId: id }));
            }
        };
        /**
         * @private
         * @param {?} storedState
         * @param {?} storedUrl
         * @param {?} rawUrl
         * @return {?}
         */
        Router.prototype.resetStateAndUrl = function (storedState, storedUrl, rawUrl) {
            (( /** @type {?} */(this))).routerState = storedState;
            this.currentUrlTree = storedUrl;
            this.rawUrlTree = this.urlHandlingStrategy.merge(this.currentUrlTree, rawUrl);
            this.resetUrlToCurrentUrlTree();
        };
        /**
         * @private
         * @return {?}
         */
        Router.prototype.resetUrlToCurrentUrlTree = function () {
            this.location.replaceState(this.urlSerializer.serialize(this.rawUrlTree), '', { navigationId: this.lastSuccessfulId });
        };
        return Router;
    }());
    /**
     * @param {?} commands
     * @return {?}
     */
    function validateCommands(commands) {
        for (var i_171 = 0; i_171 < commands.length; i_171++) {
            /** @type {?} */
            var cmd = commands[i_171];
            if (cmd == null) {
                throw new Error("The requested path contains " + cmd + " segment at index " + i_171);
            }
        }
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@description
     *
     * Lets you link to specific routes in your app.
     *
     * Consider the following route configuration:
     * `[{ path: 'user/:name', component: UserCmp }]`.
     * When linking to this `user/:name` route, you use the `RouterLink` directive.
     *
     * If the link is static, you can use the directive as follows:
     * `<a routerLink="/user/bob">link to user component</a>`
     *
     * If you use dynamic values to generate the link, you can pass an array of path
     * segments, followed by the params for each segment.
     *
     * For instance `['/team', teamId, 'user', userName, {details: true}]`
     * means that we want to generate a link to `/team/11/user/bob;details=true`.
     *
     * Multiple static segments can be merged into one
     * (e.g., `['/team/11/user', userName, {details: true}]`).
     *
     * The first segment name can be prepended with `/`, `./`, or `../`:
     * * If the first segment begins with `/`, the router will look up the route from the root of the
     *   app.
     * * If the first segment begins with `./`, or doesn't begin with a slash, the router will
     *   instead look in the children of the current activated route.
     * * And if the first segment begins with `../`, the router will go up one level.
     *
     * You can set query params and fragment as follows:
     *
     * ```
     * <a [routerLink]="['/user/bob']" [queryParams]="{debug: true}" fragment="education">
     *   link to user component
     * </a>
     * ```
     * RouterLink will use these to generate this link: `/user/bob#education?debug=true`.
     *
     * (Deprecated in v4.0.0 use `queryParamsHandling` instead) You can also tell the
     * directive to preserve the current query params and fragment:
     *
     * ```
     * <a [routerLink]="['/user/bob']" preserveQueryParams preserveFragment>
     *   link to user component
     * </a>
     * ```
     *
     * You can tell the directive how to handle queryParams. Available options are:
     *  - `'merge'`: merge the queryParams into the current queryParams
     *  - `'preserve'`: preserve the current queryParams
     *  - default/`''`: use the queryParams only
     *
     * Same options for {\@link NavigationExtras#queryParamsHandling
     * NavigationExtras#queryParamsHandling}.
     *
     * ```
     * <a [routerLink]="['/user/bob']" [queryParams]="{debug: true}" queryParamsHandling="merge">
     *   link to user component
     * </a>
     * ```
     *
     * You can provide a `state` value to be persisted to the browser's History.state
     * property (See https://developer.mozilla.org/en-US/docs/Web/API/History#Properties). It's
     * used as follows:
     *
     * ```
     * <a [routerLink]="['/user/bob']" [state]="{tracingId: 123}">
     *   link to user component
     * </a>
     * ```
     *
     * And later the value can be read from the router through `router.getCurrentNavigation`.
     * For example, to capture the `tracingId` above during the `NavigationStart` event:
     *
     * ```
     * // Get NavigationStart events
     * router.events.pipe(filter(e => e instanceof NavigationStart)).subscribe(e => {
     *   const navigation = router.getCurrentNavigation();
     *   tracingService.trace({id: navigation.extras.state.tracingId});
     * });
     * ```
     *
     * The router link directive always treats the provided input as a delta to the current url.
     *
     * For instance, if the current url is `/user/(box//aux:team)`.
     *
     * Then the following link `<a [routerLink]="['/user/jim']">Jim</a>` will generate the link
     * `/user/(jim//aux:team)`.
     *
     * See {\@link Router#createUrlTree createUrlTree} for more information.
     *
     * \@ngModule RouterModule
     *
     * \@publicApi
     */
    var RouterLink = /** @class */ (function () {
        /**
         * @param {?} router
         * @param {?} route
         * @param {?} tabIndex
         * @param {?} renderer
         * @param {?} el
         */
        function RouterLink(router, route, tabIndex, renderer, el) {
            this.router = router;
            this.route = route;
            this.commands = [];
            if (tabIndex == null) {
                renderer.setAttribute(el.nativeElement, 'tabindex', '0');
            }
        }
        Object.defineProperty(RouterLink.prototype, "routerLink", {
            /**
             * @param {?} commands
             * @return {?}
             */
            set: function (commands) {
                if (commands != null) {
                    this.commands = Array.isArray(commands) ? commands : [commands];
                }
                else {
                    this.commands = [];
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RouterLink.prototype, "preserveQueryParams", {
            /**
             * @deprecated 4.0.0 use `queryParamsHandling` instead.
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                if (isDevMode() && ( /** @type {?} */(console)) && ( /** @type {?} */(console.warn))) {
                    console.warn('preserveQueryParams is deprecated!, use queryParamsHandling instead.');
                }
                this.preserve = value;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        RouterLink.prototype.onClick = function () {
            /** @type {?} */
            var extras = {
                skipLocationChange: attrBoolValue(this.skipLocationChange),
                replaceUrl: attrBoolValue(this.replaceUrl),
            };
            this.router.navigateByUrl(this.urlTree, extras);
            return true;
        };
        Object.defineProperty(RouterLink.prototype, "urlTree", {
            /**
             * @return {?}
             */
            get: function () {
                return this.router.createUrlTree(this.commands, {
                    relativeTo: this.route,
                    queryParams: this.queryParams,
                    fragment: this.fragment,
                    preserveQueryParams: attrBoolValue(this.preserve),
                    queryParamsHandling: this.queryParamsHandling,
                    preserveFragment: attrBoolValue(this.preserveFragment),
                });
            },
            enumerable: true,
            configurable: true
        });
        return RouterLink;
    }());
    RouterLink.decorators = [
        { type: Directive, args: [{ selector: ':not(a):not(area)[routerLink]' },] }
    ];
    /** @nocollapse */
    RouterLink.ctorParameters = function () { return [
        { type: Router },
        { type: ActivatedRoute },
        { type: String, decorators: [{ type: Attribute, args: ['tabindex',] }] },
        { type: Renderer2 },
        { type: ElementRef }
    ]; };
    RouterLink.propDecorators = {
        queryParams: [{ type: Input }],
        fragment: [{ type: Input }],
        queryParamsHandling: [{ type: Input }],
        preserveFragment: [{ type: Input }],
        skipLocationChange: [{ type: Input }],
        replaceUrl: [{ type: Input }],
        state: [{ type: Input }],
        routerLink: [{ type: Input }],
        preserveQueryParams: [{ type: Input }],
        onClick: [{ type: HostListener, args: ['click',] }]
    };
    /**
     * \@description
     *
     * Lets you link to specific routes in your app.
     *
     * See `RouterLink` for more information.
     *
     * \@ngModule RouterModule
     *
     * \@publicApi
     */
    var RouterLinkWithHref = /** @class */ (function () {
        /**
         * @param {?} router
         * @param {?} route
         * @param {?} locationStrategy
         */
        function RouterLinkWithHref(router, route, locationStrategy) {
            var _this = this;
            this.router = router;
            this.route = route;
            this.locationStrategy = locationStrategy;
            this.commands = [];
            this.subscription = router.events.subscribe(( /**
             * @param {?} s
             * @return {?}
             */function (s) {
                if (s instanceof NavigationEnd) {
                    _this.updateTargetUrlAndHref();
                }
            }));
        }
        Object.defineProperty(RouterLinkWithHref.prototype, "routerLink", {
            /**
             * @param {?} commands
             * @return {?}
             */
            set: function (commands) {
                if (commands != null) {
                    this.commands = Array.isArray(commands) ? commands : [commands];
                }
                else {
                    this.commands = [];
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RouterLinkWithHref.prototype, "preserveQueryParams", {
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                if (isDevMode() && ( /** @type {?} */(console)) && ( /** @type {?} */(console.warn))) {
                    console.warn('preserveQueryParams is deprecated, use queryParamsHandling instead.');
                }
                this.preserve = value;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} changes
         * @return {?}
         */
        RouterLinkWithHref.prototype.ngOnChanges = function (changes) { this.updateTargetUrlAndHref(); };
        /**
         * @return {?}
         */
        RouterLinkWithHref.prototype.ngOnDestroy = function () { this.subscription.unsubscribe(); };
        /**
         * @param {?} button
         * @param {?} ctrlKey
         * @param {?} metaKey
         * @param {?} shiftKey
         * @return {?}
         */
        RouterLinkWithHref.prototype.onClick = function (button, ctrlKey, metaKey, shiftKey) {
            if (button !== 0 || ctrlKey || metaKey || shiftKey) {
                return true;
            }
            if (typeof this.target === 'string' && this.target != '_self') {
                return true;
            }
            /** @type {?} */
            var extras = {
                skipLocationChange: attrBoolValue(this.skipLocationChange),
                replaceUrl: attrBoolValue(this.replaceUrl),
                state: this.state
            };
            this.router.navigateByUrl(this.urlTree, extras);
            return false;
        };
        /**
         * @private
         * @return {?}
         */
        RouterLinkWithHref.prototype.updateTargetUrlAndHref = function () {
            this.href = this.locationStrategy.prepareExternalUrl(this.router.serializeUrl(this.urlTree));
        };
        Object.defineProperty(RouterLinkWithHref.prototype, "urlTree", {
            /**
             * @return {?}
             */
            get: function () {
                return this.router.createUrlTree(this.commands, {
                    relativeTo: this.route,
                    queryParams: this.queryParams,
                    fragment: this.fragment,
                    preserveQueryParams: attrBoolValue(this.preserve),
                    queryParamsHandling: this.queryParamsHandling,
                    preserveFragment: attrBoolValue(this.preserveFragment),
                });
            },
            enumerable: true,
            configurable: true
        });
        return RouterLinkWithHref;
    }());
    RouterLinkWithHref.decorators = [
        { type: Directive, args: [{ selector: 'a[routerLink],area[routerLink]' },] }
    ];
    /** @nocollapse */
    RouterLinkWithHref.ctorParameters = function () { return [
        { type: Router },
        { type: ActivatedRoute },
        { type: LocationStrategy }
    ]; };
    RouterLinkWithHref.propDecorators = {
        target: [{ type: HostBinding, args: ['attr.target',] }, { type: Input }],
        queryParams: [{ type: Input }],
        fragment: [{ type: Input }],
        queryParamsHandling: [{ type: Input }],
        preserveFragment: [{ type: Input }],
        skipLocationChange: [{ type: Input }],
        replaceUrl: [{ type: Input }],
        state: [{ type: Input }],
        href: [{ type: HostBinding }],
        routerLink: [{ type: Input }],
        preserveQueryParams: [{ type: Input }],
        onClick: [{ type: HostListener, args: ['click', ['$event.button', '$event.ctrlKey', '$event.metaKey', '$event.shiftKey'],] }]
    };
    /**
     * @param {?} s
     * @return {?}
     */
    function attrBoolValue(s) {
        return s === '' || !!s;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     *
     * \@description
     *
     * Lets you add a CSS class to an element when the link's route becomes active.
     *
     * This directive lets you add a CSS class to an element when the link's route
     * becomes active.
     *
     * Consider the following example:
     *
     * ```
     * <a routerLink="/user/bob" routerLinkActive="active-link">Bob</a>
     * ```
     *
     * When the url is either '/user' or '/user/bob', the active-link class will
     * be added to the `a` tag. If the url changes, the class will be removed.
     *
     * You can set more than one class, as follows:
     *
     * ```
     * <a routerLink="/user/bob" routerLinkActive="class1 class2">Bob</a>
     * <a routerLink="/user/bob" [routerLinkActive]="['class1', 'class2']">Bob</a>
     * ```
     *
     * You can configure RouterLinkActive by passing `exact: true`. This will add the classes
     * only when the url matches the link exactly.
     *
     * ```
     * <a routerLink="/user/bob" routerLinkActive="active-link" [routerLinkActiveOptions]="{exact:
     * true}">Bob</a>
     * ```
     *
     * You can assign the RouterLinkActive instance to a template variable and directly check
     * the `isActive` status.
     * ```
     * <a routerLink="/user/bob" routerLinkActive #rla="routerLinkActive">
     *   Bob {{ rla.isActive ? '(already open)' : ''}}
     * </a>
     * ```
     *
     * Finally, you can apply the RouterLinkActive directive to an ancestor of a RouterLink.
     *
     * ```
     * <div routerLinkActive="active-link" [routerLinkActiveOptions]="{exact: true}">
     *   <a routerLink="/user/jim">Jim</a>
     *   <a routerLink="/user/bob">Bob</a>
     * </div>
     * ```
     *
     * This will set the active-link class on the div tag if the url is either '/user/jim' or
     * '/user/bob'.
     *
     * \@ngModule RouterModule
     *
     * \@publicApi
     */
    var RouterLinkActive = /** @class */ (function () {
        /**
         * @param {?} router
         * @param {?} element
         * @param {?} renderer
         * @param {?=} link
         * @param {?=} linkWithHref
         */
        function RouterLinkActive(router, element, renderer, link, linkWithHref) {
            var _this = this;
            this.router = router;
            this.element = element;
            this.renderer = renderer;
            this.link = link;
            this.linkWithHref = linkWithHref;
            this.classes = [];
            this.isActive = false;
            this.routerLinkActiveOptions = { exact: false };
            this.subscription = router.events.subscribe(( /**
             * @param {?} s
             * @return {?}
             */function (s) {
                if (s instanceof NavigationEnd) {
                    _this.update();
                }
            }));
        }
        /**
         * @return {?}
         */
        RouterLinkActive.prototype.ngAfterContentInit = function () {
            var _this = this;
            this.links.changes.subscribe(( /**
             * @param {?} _
             * @return {?}
             */function (/**
             * @param {?} _
             * @return {?}
             */ _) { return _this.update(); }));
            this.linksWithHrefs.changes.subscribe(( /**
             * @param {?} _
             * @return {?}
             */function (/**
             * @param {?} _
             * @return {?}
             */ _) { return _this.update(); }));
            this.update();
        };
        Object.defineProperty(RouterLinkActive.prototype, "routerLinkActive", {
            /**
             * @param {?} data
             * @return {?}
             */
            set: function (data) {
                /** @type {?} */
                var classes = Array.isArray(data) ? data : data.split(' ');
                this.classes = classes.filter(( /**
                 * @param {?} c
                 * @return {?}
                 */function (/**
                 * @param {?} c
                 * @return {?}
                 */ c) { return !!c; }));
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} changes
         * @return {?}
         */
        RouterLinkActive.prototype.ngOnChanges = function (changes) { this.update(); };
        /**
         * @return {?}
         */
        RouterLinkActive.prototype.ngOnDestroy = function () { this.subscription.unsubscribe(); };
        /**
         * @private
         * @return {?}
         */
        RouterLinkActive.prototype.update = function () {
            var _this = this;
            if (!this.links || !this.linksWithHrefs || !this.router.navigated)
                return;
            Promise.resolve().then(( /**
             * @return {?}
             */function () {
                /** @type {?} */
                var hasActiveLinks = _this.hasActiveLinks();
                if (_this.isActive !== hasActiveLinks) {
                    (( /** @type {?} */(_this))).isActive = hasActiveLinks;
                    _this.classes.forEach(( /**
                     * @param {?} c
                     * @return {?}
                     */function (c) {
                        if (hasActiveLinks) {
                            _this.renderer.addClass(_this.element.nativeElement, c);
                        }
                        else {
                            _this.renderer.removeClass(_this.element.nativeElement, c);
                        }
                    }));
                }
            }));
        };
        /**
         * @private
         * @param {?} router
         * @return {?}
         */
        RouterLinkActive.prototype.isLinkActive = function (router) {
            var _this = this;
            return ( /**
             * @param {?} link
             * @return {?}
             */function (link) { return router.isActive(link.urlTree, _this.routerLinkActiveOptions.exact); });
        };
        /**
         * @private
         * @return {?}
         */
        RouterLinkActive.prototype.hasActiveLinks = function () {
            /** @type {?} */
            var isActiveCheckFn = this.isLinkActive(this.router);
            return this.link && isActiveCheckFn(this.link) ||
                this.linkWithHref && isActiveCheckFn(this.linkWithHref) ||
                this.links.some(isActiveCheckFn) || this.linksWithHrefs.some(isActiveCheckFn);
        };
        return RouterLinkActive;
    }());
    RouterLinkActive.decorators = [
        { type: Directive, args: [{
                    selector: '[routerLinkActive]',
                    exportAs: 'routerLinkActive',
                },] }
    ];
    /** @nocollapse */
    RouterLinkActive.ctorParameters = function () { return [
        { type: Router },
        { type: ElementRef },
        { type: Renderer2 },
        { type: RouterLink, decorators: [{ type: Optional }] },
        { type: RouterLinkWithHref, decorators: [{ type: Optional }] }
    ]; };
    RouterLinkActive.propDecorators = {
        links: [{ type: ContentChildren, args: [RouterLink, { descendants: true },] }],
        linksWithHrefs: [{ type: ContentChildren, args: [RouterLinkWithHref, { descendants: true },] }],
        routerLinkActiveOptions: [{ type: Input }],
        routerLinkActive: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * Store contextual information about a `RouterOutlet`
     *
     * \@publicApi
     */
    var OutletContext = /** @class */ (function () {
        function OutletContext() {
            this.outlet = null;
            this.route = null;
            this.resolver = null;
            this.children = new ChildrenOutletContexts();
            this.attachRef = null;
        }
        return OutletContext;
    }());
    /**
     * Store contextual information about the children (= nested) `RouterOutlet`
     *
     * \@publicApi
     */
    var ChildrenOutletContexts = /** @class */ (function () {
        function ChildrenOutletContexts() {
            // contexts for child outlets, by name.
            this.contexts = new Map();
        }
        /**
         * Called when a `RouterOutlet` directive is instantiated
         * @param {?} childName
         * @param {?} outlet
         * @return {?}
         */
        ChildrenOutletContexts.prototype.onChildOutletCreated = function (childName, outlet) {
            /** @type {?} */
            var context = this.getOrCreateContext(childName);
            context.outlet = outlet;
            this.contexts.set(childName, context);
        };
        /**
         * Called when a `RouterOutlet` directive is destroyed.
         * We need to keep the context as the outlet could be destroyed inside a NgIf and might be
         * re-created later.
         * @param {?} childName
         * @return {?}
         */
        ChildrenOutletContexts.prototype.onChildOutletDestroyed = function (childName) {
            /** @type {?} */
            var context = this.getContext(childName);
            if (context) {
                context.outlet = null;
            }
        };
        /**
         * Called when the corresponding route is deactivated during navigation.
         * Because the component get destroyed, all children outlet are destroyed.
         * @return {?}
         */
        ChildrenOutletContexts.prototype.onOutletDeactivated = function () {
            /** @type {?} */
            var contexts = this.contexts;
            this.contexts = new Map();
            return contexts;
        };
        /**
         * @param {?} contexts
         * @return {?}
         */
        ChildrenOutletContexts.prototype.onOutletReAttached = function (contexts) { this.contexts = contexts; };
        /**
         * @param {?} childName
         * @return {?}
         */
        ChildrenOutletContexts.prototype.getOrCreateContext = function (childName) {
            /** @type {?} */
            var context = this.getContext(childName);
            if (!context) {
                context = new OutletContext();
                this.contexts.set(childName, context);
            }
            return context;
        };
        /**
         * @param {?} childName
         * @return {?}
         */
        ChildrenOutletContexts.prototype.getContext = function (childName) { return this.contexts.get(childName) || null; };
        return ChildrenOutletContexts;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@description
     *
     * Acts as a placeholder that Angular dynamically fills based on the current router state.
     *
     * Each outlet can have a unique name, determined by the optional `name` attribute.
     * The name cannot be set or changed dynamically. If not set, default value is "primary".
     *
     * ```
     * <router-outlet></router-outlet>
     * <router-outlet name='left'></router-outlet>
     * <router-outlet name='right'></router-outlet>
     * ```
     *
     * A router outlet emits an activate event when a new component is instantiated,
     * and a deactivate event when a component is destroyed.
     *
     * ```
     * <router-outlet
     *   (activate)='onActivate($event)'
     *   (deactivate)='onDeactivate($event)'></router-outlet>
     * ```
     * \@ngModule RouterModule
     *
     * \@publicApi
     */
    var RouterOutlet = /** @class */ (function () {
        /**
         * @param {?} parentContexts
         * @param {?} location
         * @param {?} resolver
         * @param {?} name
         * @param {?} changeDetector
         */
        function RouterOutlet(parentContexts, location, resolver, name, changeDetector) {
            this.parentContexts = parentContexts;
            this.location = location;
            this.resolver = resolver;
            this.changeDetector = changeDetector;
            this.activated = null;
            this._activatedRoute = null;
            this.activateEvents = new EventEmitter();
            this.deactivateEvents = new EventEmitter();
            this.name = name || PRIMARY_OUTLET;
            parentContexts.onChildOutletCreated(this.name, this);
        }
        /**
         * @return {?}
         */
        RouterOutlet.prototype.ngOnDestroy = function () { this.parentContexts.onChildOutletDestroyed(this.name); };
        /**
         * @return {?}
         */
        RouterOutlet.prototype.ngOnInit = function () {
            if (!this.activated) {
                // If the outlet was not instantiated at the time the route got activated we need to populate
                // the outlet when it is initialized (ie inside a NgIf)
                /** @type {?} */
                var context = this.parentContexts.getContext(this.name);
                if (context && context.route) {
                    if (context.attachRef) {
                        // `attachRef` is populated when there is an existing component to mount
                        this.attach(context.attachRef, context.route);
                    }
                    else {
                        // otherwise the component defined in the configuration is created
                        this.activateWith(context.route, context.resolver || null);
                    }
                }
            }
        };
        Object.defineProperty(RouterOutlet.prototype, "isActivated", {
            /**
             * @return {?}
             */
            get: function () { return !!this.activated; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RouterOutlet.prototype, "component", {
            /**
             * @return {?}
             */
            get: function () {
                if (!this.activated)
                    throw new Error('Outlet is not activated');
                return this.activated.instance;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RouterOutlet.prototype, "activatedRoute", {
            /**
             * @return {?}
             */
            get: function () {
                if (!this.activated)
                    throw new Error('Outlet is not activated');
                return ( /** @type {?} */(this._activatedRoute));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RouterOutlet.prototype, "activatedRouteData", {
            /**
             * @return {?}
             */
            get: function () {
                if (this._activatedRoute) {
                    return this._activatedRoute.snapshot.data;
                }
                return {};
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Called when the `RouteReuseStrategy` instructs to detach the subtree
         * @return {?}
         */
        RouterOutlet.prototype.detach = function () {
            if (!this.activated)
                throw new Error('Outlet is not activated');
            this.location.detach();
            /** @type {?} */
            var cmp = this.activated;
            this.activated = null;
            this._activatedRoute = null;
            return cmp;
        };
        /**
         * Called when the `RouteReuseStrategy` instructs to re-attach a previously detached subtree
         * @param {?} ref
         * @param {?} activatedRoute
         * @return {?}
         */
        RouterOutlet.prototype.attach = function (ref, activatedRoute) {
            this.activated = ref;
            this._activatedRoute = activatedRoute;
            this.location.insert(ref.hostView);
        };
        /**
         * @return {?}
         */
        RouterOutlet.prototype.deactivate = function () {
            if (this.activated) {
                /** @type {?} */
                var c_7 = this.component;
                this.activated.destroy();
                this.activated = null;
                this._activatedRoute = null;
                this.deactivateEvents.emit(c_7);
            }
        };
        /**
         * @param {?} activatedRoute
         * @param {?} resolver
         * @return {?}
         */
        RouterOutlet.prototype.activateWith = function (activatedRoute, resolver) {
            if (this.isActivated) {
                throw new Error('Cannot activate an already activated outlet');
            }
            this._activatedRoute = activatedRoute;
            /** @type {?} */
            var snapshot = activatedRoute._futureSnapshot;
            /** @type {?} */
            var component = ( /** @type {?} */(( /** @type {?} */(snapshot.routeConfig)).component));
            resolver = resolver || this.resolver;
            /** @type {?} */
            var factory = resolver.resolveComponentFactory(component);
            /** @type {?} */
            var childContexts = this.parentContexts.getOrCreateContext(this.name).children;
            /** @type {?} */
            var injector = new OutletInjector(activatedRoute, childContexts, this.location.injector);
            this.activated = this.location.createComponent(factory, this.location.length, injector);
            // Calling `markForCheck` to make sure we will run the change detection when the
            // `RouterOutlet` is inside a `ChangeDetectionStrategy.OnPush` component.
            this.changeDetector.markForCheck();
            this.activateEvents.emit(this.activated.instance);
        };
        return RouterOutlet;
    }());
    RouterOutlet.decorators = [
        { type: Directive, args: [{ selector: 'router-outlet', exportAs: 'outlet' },] }
    ];
    /** @nocollapse */
    RouterOutlet.ctorParameters = function () { return [
        { type: ChildrenOutletContexts },
        { type: ViewContainerRef },
        { type: ComponentFactoryResolver },
        { type: String, decorators: [{ type: Attribute, args: ['name',] }] },
        { type: ChangeDetectorRef }
    ]; };
    RouterOutlet.propDecorators = {
        activateEvents: [{ type: Output, args: ['activate',] }],
        deactivateEvents: [{ type: Output, args: ['deactivate',] }]
    };
    var OutletInjector = /** @class */ (function () {
        /**
         * @param {?} route
         * @param {?} childContexts
         * @param {?} parent
         */
        function OutletInjector(route, childContexts, parent) {
            this.route = route;
            this.childContexts = childContexts;
            this.parent = parent;
        }
        /**
         * @param {?} token
         * @param {?=} notFoundValue
         * @return {?}
         */
        OutletInjector.prototype.get = function (token, notFoundValue) {
            if (token === ActivatedRoute) {
                return this.route;
            }
            if (token === ChildrenOutletContexts) {
                return this.childContexts;
            }
            return this.parent.get(token, notFoundValue);
        };
        return OutletInjector;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@description
     *
     * Provides a preloading strategy.
     *
     * \@publicApi
     * @abstract
     */
    var PreloadingStrategy = /** @class */ (function () {
        function PreloadingStrategy() {
        }
        return PreloadingStrategy;
    }());
    /**
     * \@description
     *
     * Provides a preloading strategy that preloads all modules as quickly as possible.
     *
     * ```
     * RouteModule.forRoot(ROUTES, {preloadingStrategy: PreloadAllModules})
     * ```
     *
     * \@publicApi
     */
    var PreloadAllModules = /** @class */ (function () {
        function PreloadAllModules() {
        }
        /**
         * @param {?} route
         * @param {?} fn
         * @return {?}
         */
        PreloadAllModules.prototype.preload = function (route, fn) {
            return fn().pipe(catchError(( /**
             * @return {?}
             */function () { return of(null); })));
        };
        return PreloadAllModules;
    }());
    /**
     * \@description
     *
     * Provides a preloading strategy that does not preload any modules.
     *
     * This strategy is enabled by default.
     *
     * \@publicApi
     */
    var NoPreloading = /** @class */ (function () {
        function NoPreloading() {
        }
        /**
         * @param {?} route
         * @param {?} fn
         * @return {?}
         */
        NoPreloading.prototype.preload = function (route, fn) { return of(null); };
        return NoPreloading;
    }());
    /**
     * The preloader optimistically loads all router configurations to
     * make navigations into lazily-loaded sections of the application faster.
     *
     * The preloader runs in the background. When the router bootstraps, the preloader
     * starts listening to all navigation events. After every such event, the preloader
     * will check if any configurations can be loaded lazily.
     *
     * If a route is protected by `canLoad` guards, the preloaded will not load it.
     *
     * \@publicApi
     */
    var RouterPreloader = /** @class */ (function () {
        /**
         * @param {?} router
         * @param {?} moduleLoader
         * @param {?} compiler
         * @param {?} injector
         * @param {?} preloadingStrategy
         */
        function RouterPreloader(router, moduleLoader, compiler, injector, preloadingStrategy) {
            this.router = router;
            this.injector = injector;
            this.preloadingStrategy = preloadingStrategy;
            /** @type {?} */
            var onStartLoad = ( /**
             * @param {?} r
             * @return {?}
             */function (r) { return router.triggerEvent(new RouteConfigLoadStart(r)); });
            /** @type {?} */
            var onEndLoad = ( /**
             * @param {?} r
             * @return {?}
             */function (r) { return router.triggerEvent(new RouteConfigLoadEnd(r)); });
            this.loader = new RouterConfigLoader(moduleLoader, compiler, onStartLoad, onEndLoad);
        }
        /**
         * @return {?}
         */
        RouterPreloader.prototype.setUpPreloading = function () {
            var _this = this;
            this.subscription =
                this.router.events
                    .pipe(filter(( /**
             * @param {?} e
             * @return {?}
             */function (e) { return e instanceof NavigationEnd; })), concatMap(( /**
                 * @return {?}
                 */function () { return _this.preload(); })))
                    .subscribe(( /**
             * @return {?}
             */function () { }));
        };
        /**
         * @return {?}
         */
        RouterPreloader.prototype.preload = function () {
            /** @type {?} */
            var ngModule = this.injector.get(NgModuleRef);
            return this.processRoutes(ngModule, this.router.config);
        };
        // TODO(jasonaden): This class relies on code external to the class to call setUpPreloading. If
        // this hasn't been done, ngOnDestroy will fail as this.subscription will be undefined. This
        // should be refactored.
        /**
         * @return {?}
         */
        RouterPreloader.prototype.ngOnDestroy = function () { this.subscription.unsubscribe(); };
        /**
         * @private
         * @param {?} ngModule
         * @param {?} routes
         * @return {?}
         */
        RouterPreloader.prototype.processRoutes = function (ngModule, routes) {
            var e_32, _b;
            /** @type {?} */
            var res = [];
            try {
                for (var routes_5 = __values(routes), routes_5_1 = routes_5.next(); !routes_5_1.done; routes_5_1 = routes_5.next()) {
                    var route = routes_5_1.value;
                    // we already have the config loaded, just recurse
                    if (route.loadChildren && !route.canLoad && route._loadedConfig) {
                        /** @type {?} */
                        var childConfig = route._loadedConfig;
                        res.push(this.processRoutes(childConfig.module, childConfig.routes));
                        // no config loaded, fetch the config
                    }
                    else if (route.loadChildren && !route.canLoad) {
                        res.push(this.preloadConfig(ngModule, route));
                        // recurse into children
                    }
                    else if (route.children) {
                        res.push(this.processRoutes(ngModule, route.children));
                    }
                }
            }
            catch (e_32_1) { e_32 = { error: e_32_1 }; }
            finally {
                try {
                    if (routes_5_1 && !routes_5_1.done && (_b = routes_5.return)) _b.call(routes_5);
                }
                finally { if (e_32) throw e_32.error; }
            }
            return from(res).pipe(mergeAll(), map(( /**
             * @param {?} _
             * @return {?}
             */function (_) { return void 0; })));
        };
        /**
         * @private
         * @param {?} ngModule
         * @param {?} route
         * @return {?}
         */
        RouterPreloader.prototype.preloadConfig = function (ngModule, route) {
            var _this = this;
            return this.preloadingStrategy.preload(route, ( /**
             * @return {?}
             */function () {
                /** @type {?} */
                var loaded$ = _this.loader.load(ngModule.injector, route);
                return loaded$.pipe(mergeMap(( /**
                 * @param {?} config
                 * @return {?}
                 */function (config) {
                    route._loadedConfig = config;
                    return _this.processRoutes(config.module, config.routes);
                })));
            }));
        };
        return RouterPreloader;
    }());
    RouterPreloader.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    RouterPreloader.ctorParameters = function () { return [
        { type: Router },
        { type: NgModuleFactoryLoader },
        { type: Compiler },
        { type: Injector },
        { type: PreloadingStrategy }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var RouterScroller = /** @class */ (function () {
        /**
         * @param {?} router
         * @param {?} viewportScroller
         * @param {?=} options
         */
        function RouterScroller(router, viewportScroller, options) {
            if (options === void 0) { options = {}; }
            this.router = router;
            this.viewportScroller = viewportScroller;
            this.options = options;
            this.lastId = 0;
            this.lastSource = 'imperative';
            this.restoredId = 0;
            this.store = {};
            // Default both options to 'disabled'
            options.scrollPositionRestoration = options.scrollPositionRestoration || 'disabled';
            options.anchorScrolling = options.anchorScrolling || 'disabled';
        }
        /**
         * @return {?}
         */
        RouterScroller.prototype.init = function () {
            // we want to disable the automatic scrolling because having two places
            // responsible for scrolling results race conditions, especially given
            // that browser don't implement this behavior consistently
            if (this.options.scrollPositionRestoration !== 'disabled') {
                this.viewportScroller.setHistoryScrollRestoration('manual');
            }
            this.routerEventsSubscription = this.createScrollEvents();
            this.scrollEventsSubscription = this.consumeScrollEvents();
        };
        /**
         * @private
         * @return {?}
         */
        RouterScroller.prototype.createScrollEvents = function () {
            var _this = this;
            return this.router.events.subscribe(( /**
             * @param {?} e
             * @return {?}
             */function (/**
             * @param {?} e
             * @return {?}
             */ e) {
                if (e instanceof NavigationStart) {
                    // store the scroll position of the current stable navigations.
                    _this.store[_this.lastId] = _this.viewportScroller.getScrollPosition();
                    _this.lastSource = e.navigationTrigger;
                    _this.restoredId = e.restoredState ? e.restoredState.navigationId : 0;
                }
                else if (e instanceof NavigationEnd) {
                    _this.lastId = e.id;
                    _this.scheduleScrollEvent(e, _this.router.parseUrl(e.urlAfterRedirects).fragment);
                }
            }));
        };
        /**
         * @private
         * @return {?}
         */
        RouterScroller.prototype.consumeScrollEvents = function () {
            var _this = this;
            return this.router.events.subscribe(( /**
             * @param {?} e
             * @return {?}
             */function (/**
             * @param {?} e
             * @return {?}
             */ e) {
                if (!(e instanceof Scroll))
                    return;
                // a popstate event. The pop state event will always ignore anchor scrolling.
                if (e.position) {
                    if (_this.options.scrollPositionRestoration === 'top') {
                        _this.viewportScroller.scrollToPosition([0, 0]);
                    }
                    else if (_this.options.scrollPositionRestoration === 'enabled') {
                        _this.viewportScroller.scrollToPosition(e.position);
                    }
                    // imperative navigation "forward"
                }
                else {
                    if (e.anchor && _this.options.anchorScrolling === 'enabled') {
                        _this.viewportScroller.scrollToAnchor(e.anchor);
                    }
                    else if (_this.options.scrollPositionRestoration !== 'disabled') {
                        _this.viewportScroller.scrollToPosition([0, 0]);
                    }
                }
            }));
        };
        /**
         * @private
         * @param {?} routerEvent
         * @param {?} anchor
         * @return {?}
         */
        RouterScroller.prototype.scheduleScrollEvent = function (routerEvent, anchor) {
            this.router.triggerEvent(new Scroll(routerEvent, this.lastSource === 'popstate' ? this.store[this.restoredId] : null, anchor));
        };
        /**
         * @return {?}
         */
        RouterScroller.prototype.ngOnDestroy = function () {
            if (this.routerEventsSubscription) {
                this.routerEventsSubscription.unsubscribe();
            }
            if (this.scrollEventsSubscription) {
                this.scrollEventsSubscription.unsubscribe();
            }
        };
        return RouterScroller;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The directives defined in the `RouterModule`.
     * @type {?}
     */
    var ROUTER_DIRECTIVES = [RouterOutlet, RouterLink, RouterLinkWithHref, RouterLinkActive, ɵEmptyOutletComponent];
    /**
     * A [DI token](guide/glossary/#di-token) for the router service.
     *
     * \@publicApi
     * @type {?}
     */
    var ROUTER_CONFIGURATION = new InjectionToken('ROUTER_CONFIGURATION');
    /**
     * \@docsNotRequired
     * @type {?}
     */
    var ROUTER_FORROOT_GUARD = new InjectionToken('ROUTER_FORROOT_GUARD');
    var ɵ0$i = { enableTracing: false };
    /** @type {?} */
    var ROUTER_PROVIDERS = [
        Location,
        { provide: UrlSerializer, useClass: DefaultUrlSerializer },
        {
            provide: Router,
            useFactory: setupRouter,
            deps: [
                ApplicationRef, UrlSerializer, ChildrenOutletContexts, Location, Injector,
                NgModuleFactoryLoader, Compiler, ROUTES, ROUTER_CONFIGURATION,
                [UrlHandlingStrategy, new Optional()], [RouteReuseStrategy, new Optional()]
            ]
        },
        ChildrenOutletContexts,
        { provide: ActivatedRoute, useFactory: rootRoute, deps: [Router] },
        { provide: NgModuleFactoryLoader, useClass: SystemJsNgModuleLoader },
        RouterPreloader,
        NoPreloading,
        PreloadAllModules,
        { provide: ROUTER_CONFIGURATION, useValue: ɵ0$i },
    ];
    /**
     * @return {?}
     */
    function routerNgProbeToken() {
        return new NgProbeToken('Router', Router);
    }
    /**
     * \@usageNotes
     *
     * RouterModule can be imported multiple times: once per lazily-loaded bundle.
     * Since the router deals with a global shared resource--location, we cannot have
     * more than one router service active.
     *
     * That is why there are two ways to create the module: `RouterModule.forRoot` and
     * `RouterModule.forChild`.
     *
     * * `forRoot` creates a module that contains all the directives, the given routes, and the router
     *   service itself.
     * * `forChild` creates a module that contains all the directives and the given routes, but does not
     *   include the router service.
     *
     * When registered at the root, the module should be used as follows
     *
     * ```
     * \@NgModule({
     *   imports: [RouterModule.forRoot(ROUTES)]
     * })
     * class MyNgModule {}
     * ```
     *
     * For submodules and lazy loaded submodules the module should be used as follows:
     *
     * ```
     * \@NgModule({
     *   imports: [RouterModule.forChild(ROUTES)]
     * })
     * class MyNgModule {}
     * ```
     *
     * \@description
     *
     * Adds router directives and providers.
     *
     * Managing state transitions is one of the hardest parts of building applications. This is
     * especially true on the web, where you also need to ensure that the state is reflected in the URL.
     * In addition, we often want to split applications into multiple bundles and load them on demand.
     * Doing this transparently is not trivial.
     *
     * The Angular router service solves these problems. Using the router, you can declaratively specify
     * application states, manage state transitions while taking care of the URL, and load bundles on
     * demand.
     *
     * @see [Routing and Navigation](guide/router.html) for an
     * overview of how the router service should be used.
     *
     * \@publicApi
     */
    var RouterModule = /** @class */ (function () {
        // Note: We are injecting the Router so it gets created eagerly...
        /**
         * @param {?} guard
         * @param {?} router
         */
        function RouterModule(guard, router) {
        }
        /**
         * Creates and configures a module with all the router providers and directives.
         * Optionally sets up an application listener to perform an initial navigation.
         *
         * @param {?} routes An array of `Route` objects that define the navigation paths for the application.
         * @param {?=} config An `ExtraOptions` configuration object that controls how navigation is performed.
         * @return {?} The new router module.
         */
        RouterModule.forRoot = function (routes, config) {
            return {
                ngModule: RouterModule,
                providers: [
                    ROUTER_PROVIDERS,
                    provideRoutes(routes),
                    {
                        provide: ROUTER_FORROOT_GUARD,
                        useFactory: provideForRootGuard,
                        deps: [[Router, new Optional(), new SkipSelf()]]
                    },
                    { provide: ROUTER_CONFIGURATION, useValue: config ? config : {} },
                    {
                        provide: LocationStrategy,
                        useFactory: provideLocationStrategy,
                        deps: [
                            PlatformLocation, [new Inject(APP_BASE_HREF), new Optional()], ROUTER_CONFIGURATION
                        ]
                    },
                    {
                        provide: RouterScroller,
                        useFactory: createRouterScroller,
                        deps: [Router, ViewportScroller, ROUTER_CONFIGURATION]
                    },
                    {
                        provide: PreloadingStrategy,
                        useExisting: config && config.preloadingStrategy ? config.preloadingStrategy :
                            NoPreloading
                    },
                    { provide: NgProbeToken, multi: true, useFactory: routerNgProbeToken },
                    provideRouterInitializer(),
                ],
            };
        };
        /**
         * Creates a module with all the router directives and a provider registering routes.
         * @param {?} routes
         * @return {?}
         */
        RouterModule.forChild = function (routes) {
            return { ngModule: RouterModule, providers: [provideRoutes(routes)] };
        };
        return RouterModule;
    }());
    RouterModule.decorators = [
        { type: NgModule, args: [{
                    declarations: ROUTER_DIRECTIVES,
                    exports: ROUTER_DIRECTIVES,
                    entryComponents: [ɵEmptyOutletComponent]
                },] }
    ];
    /** @nocollapse */
    RouterModule.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [ROUTER_FORROOT_GUARD,] }] },
        { type: Router, decorators: [{ type: Optional }] }
    ]; };
    /**
     * @param {?} router
     * @param {?} viewportScroller
     * @param {?} config
     * @return {?}
     */
    function createRouterScroller(router, viewportScroller, config) {
        if (config.scrollOffset) {
            viewportScroller.setOffset(config.scrollOffset);
        }
        return new RouterScroller(router, viewportScroller, config);
    }
    /**
     * @param {?} platformLocationStrategy
     * @param {?} baseHref
     * @param {?=} options
     * @return {?}
     */
    function provideLocationStrategy(platformLocationStrategy, baseHref, options) {
        if (options === void 0) { options = {}; }
        return options.useHash ? new HashLocationStrategy(platformLocationStrategy, baseHref) :
            new PathLocationStrategy(platformLocationStrategy, baseHref);
    }
    /**
     * @param {?} router
     * @return {?}
     */
    function provideForRootGuard(router) {
        if (router) {
            throw new Error("RouterModule.forRoot() called twice. Lazy loaded modules should use RouterModule.forChild() instead.");
        }
        return 'guarded';
    }
    /**
     * Registers a [DI provider](guide/glossary#provider) for a set of routes.
     * \@usageNotes
     *
     * ```
     * \@NgModule({
     *   imports: [RouterModule.forChild(ROUTES)],
     *   providers: [provideRoutes(EXTRA_ROUTES)]
     * })
     * class MyNgModule {}
     * ```
     *
     * \@publicApi
     * @param {?} routes The route configuration to provide.
     *
     * @return {?}
     */
    function provideRoutes(routes) {
        return [
            { provide: ANALYZE_FOR_ENTRY_COMPONENTS, multi: true, useValue: routes },
            { provide: ROUTES, multi: true, useValue: routes },
        ];
    }
    /**
     * @param {?} ref
     * @param {?} urlSerializer
     * @param {?} contexts
     * @param {?} location
     * @param {?} injector
     * @param {?} loader
     * @param {?} compiler
     * @param {?} config
     * @param {?=} opts
     * @param {?=} urlHandlingStrategy
     * @param {?=} routeReuseStrategy
     * @return {?}
     */
    function setupRouter(ref, urlSerializer, contexts, location, injector, loader, compiler, config, opts, urlHandlingStrategy, routeReuseStrategy) {
        if (opts === void 0) { opts = {}; }
        /** @type {?} */
        var router = new Router(null, urlSerializer, contexts, location, injector, loader, compiler, flatten$1(config));
        if (urlHandlingStrategy) {
            router.urlHandlingStrategy = urlHandlingStrategy;
        }
        if (routeReuseStrategy) {
            router.routeReuseStrategy = routeReuseStrategy;
        }
        if (opts.errorHandler) {
            router.errorHandler = opts.errorHandler;
        }
        if (opts.malformedUriErrorHandler) {
            router.malformedUriErrorHandler = opts.malformedUriErrorHandler;
        }
        if (opts.enableTracing) {
            /** @type {?} */
            var dom_1 = getDOM();
            router.events.subscribe(( /**
             * @param {?} e
             * @return {?}
             */function (e) {
                dom_1.logGroup("Router Event: " + (( /** @type {?} */(e.constructor))).name);
                dom_1.log(e.toString());
                dom_1.log(e);
                dom_1.logGroupEnd();
            }));
        }
        if (opts.onSameUrlNavigation) {
            router.onSameUrlNavigation = opts.onSameUrlNavigation;
        }
        if (opts.paramsInheritanceStrategy) {
            router.paramsInheritanceStrategy = opts.paramsInheritanceStrategy;
        }
        if (opts.urlUpdateStrategy) {
            router.urlUpdateStrategy = opts.urlUpdateStrategy;
        }
        if (opts.relativeLinkResolution) {
            router.relativeLinkResolution = opts.relativeLinkResolution;
        }
        return router;
    }
    /**
     * @param {?} router
     * @return {?}
     */
    function rootRoute(router) {
        return router.routerState.root;
    }
    /**
     * Router initialization requires two steps:
     *
     * First, we start the navigation in a `APP_INITIALIZER` to block the bootstrap if
     * a resolver or a guard executes asynchronously.
     *
     * Next, we actually run activation in a `BOOTSTRAP_LISTENER`, using the
     * `afterPreactivation` hook provided by the router.
     * The router navigation starts, reaches the point when preactivation is done, and then
     * pauses. It waits for the hook to be resolved. We then resolve it only in a bootstrap listener.
     */
    var RouterInitializer = /** @class */ (function () {
        /**
         * @param {?} injector
         */
        function RouterInitializer(injector) {
            this.injector = injector;
            this.initNavigation = false;
            this.resultOfPreactivationDone = new Subject();
        }
        /**
         * @return {?}
         */
        RouterInitializer.prototype.appInitializer = function () {
            var _this = this;
            /** @type {?} */
            var p = this.injector.get(LOCATION_INITIALIZED, Promise.resolve(null));
            return p.then(( /**
             * @return {?}
             */function () {
                /** @type {?} */
                var resolve = ( /** @type {?} */(null));
                /** @type {?} */
                var res = new Promise(( /**
                 * @param {?} r
                 * @return {?}
                 */function (/**
                 * @param {?} r
                 * @return {?}
                 */ r) { return resolve = r; }));
                /** @type {?} */
                var router = _this.injector.get(Router);
                /** @type {?} */
                var opts = _this.injector.get(ROUTER_CONFIGURATION);
                if (_this.isLegacyDisabled(opts) || _this.isLegacyEnabled(opts)) {
                    resolve(true);
                }
                else if (opts.initialNavigation === 'disabled') {
                    router.setUpLocationChangeListener();
                    resolve(true);
                }
                else if (opts.initialNavigation === 'enabled') {
                    router.hooks.afterPreactivation = ( /**
                     * @return {?}
                     */function () {
                        // only the initial navigation should be delayed
                        if (!_this.initNavigation) {
                            _this.initNavigation = true;
                            resolve(true);
                            return _this.resultOfPreactivationDone;
                            // subsequent navigations should not be delayed
                        }
                        else {
                            return ( /** @type {?} */(of(null)));
                        }
                    });
                    router.initialNavigation();
                }
                else {
                    throw new Error("Invalid initialNavigation options: '" + opts.initialNavigation + "'");
                }
                return res;
            }));
        };
        /**
         * @param {?} bootstrappedComponentRef
         * @return {?}
         */
        RouterInitializer.prototype.bootstrapListener = function (bootstrappedComponentRef) {
            /** @type {?} */
            var opts = this.injector.get(ROUTER_CONFIGURATION);
            /** @type {?} */
            var preloader = this.injector.get(RouterPreloader);
            /** @type {?} */
            var routerScroller = this.injector.get(RouterScroller);
            /** @type {?} */
            var router = this.injector.get(Router);
            /** @type {?} */
            var ref = this.injector.get(ApplicationRef);
            if (bootstrappedComponentRef !== ref.components[0]) {
                return;
            }
            if (this.isLegacyEnabled(opts)) {
                router.initialNavigation();
            }
            else if (this.isLegacyDisabled(opts)) {
                router.setUpLocationChangeListener();
            }
            preloader.setUpPreloading();
            routerScroller.init();
            router.resetRootComponentType(ref.componentTypes[0]);
            this.resultOfPreactivationDone.next(( /** @type {?} */(null)));
            this.resultOfPreactivationDone.complete();
        };
        /**
         * @private
         * @param {?} opts
         * @return {?}
         */
        RouterInitializer.prototype.isLegacyEnabled = function (opts) {
            return opts.initialNavigation === 'legacy_enabled' || opts.initialNavigation === true ||
                opts.initialNavigation === undefined;
        };
        /**
         * @private
         * @param {?} opts
         * @return {?}
         */
        RouterInitializer.prototype.isLegacyDisabled = function (opts) {
            return opts.initialNavigation === 'legacy_disabled' || opts.initialNavigation === false;
        };
        return RouterInitializer;
    }());
    RouterInitializer.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    RouterInitializer.ctorParameters = function () { return [
        { type: Injector }
    ]; };
    /**
     * @param {?} r
     * @return {?}
     */
    function getAppInitializer(r) {
        return r.appInitializer.bind(r);
    }
    /**
     * @param {?} r
     * @return {?}
     */
    function getBootstrapListener(r) {
        return r.bootstrapListener.bind(r);
    }
    /**
     * A [DI token](guide/glossary/#di-token) for the router initializer that
     * is called after the app is bootstrapped.
     *
     * \@publicApi
     * @type {?}
     */
    var ROUTER_INITIALIZER = new InjectionToken('Router Initializer');
    /**
     * @return {?}
     */
    function provideRouterInitializer() {
        return [
            RouterInitializer,
            {
                provide: APP_INITIALIZER,
                multi: true,
                useFactory: getAppInitializer,
                deps: [RouterInitializer]
            },
            { provide: ROUTER_INITIALIZER, useFactory: getBootstrapListener, deps: [RouterInitializer] },
            { provide: APP_BOOTSTRAP_LISTENER, multi: true, useExisting: ROUTER_INITIALIZER },
        ];
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@publicApi
     * @type {?}
     */
    var VERSION$5 = new Version('8.2.14');
    var PRIMITIVE_TYPE_BYTE_SIZE = {
        'BF16': 2,
        'C64': 8,
        'F16': 2,
        'F32': 4,
        'F64': 8,
        'PRED': 1,
        'TOKEN': 0,
        'S8': 1,
        'S16': 2,
        'S32': 4,
        'S64': 8,
        'U8': 1,
        'U16': 2,
        'U32': 4,
        'U64': 8,
    };
    var SHUFFLED_MATERIAL_COLORS = [
        '#e91e63', '#2196f3', '#81c784', '#4dd0e1', '#3f51b5', '#e53935', '#ff9100',
        '#b39ddb', '#90a4ae', '#26c6da', '#ad1457', '#03a9f4', '#2196f3', '#c2185b',
        '#795548', '#f9a825', '#00bfa5', '#880e4f', '#d500f9', '#ce93d8', '#ec407a',
        '#4caf50', '#ff8f00', '#ffca28', '#ab47bc', '#00e5ff', '#ff9800', '#40c4ff',
        '#1e88e5', '#9fa8da', '#bf360c', '#00b8d4', '#f57f17', '#64b5f6', '#e040fb',
        '#ffab91', '#4caf50', '#01579b', '#66bb6a', '#ef9a9a', '#558b2f', '#fb8c00',
        '#ff4081', '#00e676', '#388e3c', '#424242', '#6d4c41', '#c62828', '#616161',
        '#00897b', '#448aff', '#0d47a1', '#607d8b', '#673ab7', '#00c853', '#2e7d32',
        '#ffa726', '#5e35b1', '#ba68c8', '#8d6e63', '#00bcd4', '#ff6f00', '#f4511e',
        '#ff1744', '#9e9e9e', '#d81b60', '#4a148c', '#26a69a', '#689f38', '#7b1fa2',
        '#b0bec5', '#304ffe', '#f48fb1', '#ffd600', '#ffb74d', '#8bc34a', '#303f9f',
        '#5d4037', '#80cbc4', '#ffcc80', '#00acc1', '#3e2723', '#ff5252', '#ff7043',
        '#e91e63', '#ea80fc', '#e65100', '#d84315', '#212121', '#ff5722', '#1976d2',
        '#2962ff', '#bdbdbd', '#3949ab', '#69f0ae', '#d50000', '#ffd740', '#c0ca33',
        '#ff6e40', '#00b0ff', '#2979ff', '#e64a19', '#7c4dff', '#607d8b', '#009688',
        '#ffb300', '#c51162', '#ffc400', '#29b6f6', '#3d5afe', '#76ff03', '#cddc39',
        '#b388ff', '#5c6bc0', '#9e9d24', '#7cb342', '#ef5350', '#fdd835', '#ef6c00',
        '#4fc3f7', '#6200ea', '#004d40', '#ff8a65', '#ffab00', '#80deea', '#0097a7',
        '#7e57c2', '#ff6d00', '#1565c0', '#455a64', '#ffc107', '#4527a0', '#ff5722',
        '#f44336', '#f57c00', '#827717', '#a5d6a7', '#82b1ff', '#9c27b0', '#ff80ab',
        '#e1bee7', '#78909c', '#311b92', '#00695c', '#4e342e', '#3f51b5', '#651fff',
        '#9e9e9e', '#81d4fa', '#f8bbd0', '#b71c1c', '#0091ea', '#673ab7', '#a1887f',
        '#4db6ac', '#ffa000', '#6a1b9a', '#43a047', '#bcaaa4', '#546e7a', '#aeea00',
        '#e57373', '#ffccbc', '#006064', '#fbc02d', '#ffeb3b', '#8bc34a', '#039be5',
        '#8e24aa', '#80d8ff', '#009688', '#9ccc65', '#512da8', '#ffc107', '#757575',
        '#0277bd', '#ff3d00', '#33691e', '#03a9f4', '#00838f', '#ff8a80', '#283593',
        '#f50057', '#1a237e', '#90caf9', '#9c27b0', '#aa00ff', '#aed581', '#afb42b',
        '#9575cd', '#d32f2f', '#64dd17', '#f44336', '#795548', '#cddc39', '#ff9e80',
        '#7986cb', '#dd2c00', '#0288d1', '#ff9800', '#263238', '#00796b', '#42a5f5',
        '#8c9eff', '#1b5e20', '#ffab40', '#536dfe', '#00bcd4', '#f06292',
    ];
    var KNOWN_TOOLS = [
        'input_pipeline_analyzer',
        'memory_profile',
        'memory_viewer',
        'op_profile',
        'pod_viewer',
        'tensorflow_stats',
        'trace_viewer',
        'tf_data_bottleneck_analysis',
    ];
    /**
     * Returns the number of bytes of the primitive type.
     */
    function byteSizeOfPrimitiveType(type) {
        if (!PRIMITIVE_TYPE_BYTE_SIZE.hasOwnProperty(type)) {
            console.error('Unhandled primitive type ' + type);
            return 0;
        }
        return PRIMITIVE_TYPE_BYTE_SIZE[type];
    }
    /**
     * Converts from number of bytes to MiB.
     */
    function bytesToMiB(numBytes) {
        return numBytes / (1024 * 1024);
    }
    /**
     * Format the number as human-readable text.
     * @param num Number to convert.
     * @param si True to use metric (SI) units, aka powers of 1000. False to use
     *           binary (IEC), aka powers of 1024.
     * @param dp Number of decimal places to display.
     * @param suffix Text to append to the string as common unit, e.g. FLOP/s.
     */
    function humanReadableText(num, _b) {
        var _c = _b === void 0 ? {} : _b, _d = _c.si, si = _d === void 0 ? false : _d, _e = _c.dp, dp = _e === void 0 ? 2 : _e, _f = _c.suffix, suffix = _f === void 0 ? 'B' : _f;
        var base = si ? 1000 : 1024;
        var units = si ? ['', 'K', 'M', 'G', 'T', 'P', 'E', 'Z', 'Y'] :
            ['', 'Ki', 'Mi', 'Gi', 'Ti', 'Pi', 'Ei', 'Zi', 'Yi'];
        var i = num === 0 ? 0 : Math.floor(Math.log(num) / Math.log(base));
        return (Number(num / Math.pow(base, i)).toFixed(dp) + ' ' + units[i] +
            suffix) ||
            '';
    }
    /**
     * Returns a color for chart item by index.
     */
    function getChartItemColorByIndex(index) {
        return SHUFFLED_MATERIAL_COLORS[index % SHUFFLED_MATERIAL_COLORS.length];
    }
    /**
     * Converts from string to number.
     */
    function toNumber(value) {
        var num = Number(value);
        return isNaN(num) ? 0 : num;
    }
    /**
     * Returns a rgba string.
     */
    function rgba(red, green, blue, alpha) {
        return 'rgba(' + Math.round(red * 255).toString() + ',' +
            Math.round(green * 255).toString() + ',' +
            Math.round(blue * 255).toString() + ',' + alpha.toString() + ')';
    }
    /**
     * Computes a flame color.
     */
    function flameColor(fraction, brightness, opacity, curve) {
        if (brightness === void 0) {
            brightness = 1;
        }
        if (opacity === void 0) {
            opacity = 1;
        }
        if (curve === void 0) {
            curve = function (x) { return 1 - Math.sqrt(1 - x); };
        }
        if (isNaN(fraction)) {
            return rgba(brightness, brightness, brightness, opacity);
        }
        fraction = curve(fraction);
        // Or everythin is depressing and red.
        return fraction < 0.5 ?
            rgba(brightness, 2 * fraction * brightness, 0, opacity) :
            rgba(2 * (1 - fraction) * brightness, brightness, 0, opacity);
    }
    /**
     * Computes a Flops color.
     */
    function flopsColor(fraction) {
        return flameColor(Math.min(fraction, 1), 0.7, 1, Math.sqrt);
    }
    /**
     * Computes a memory bandwidth color.
     */
    function bwColor(fraction) {
        return flameColor(Math.max(1 - fraction, 0), 0.7, 1, Math.sqrt);
    }
    /**
     * Computes the utilization for operations.
     */
    function flopsUtilization(node) {
        // NaN indicates undefined utilization for fused operations (we can't
        // measure performance inside a fusion). It could also indicate operations
        // with zero time, but they currently don't appear in the profile.
        if (!node || !node.metrics || !node.metrics.time)
            return NaN;
        return (node.metrics.flops || 0) / node.metrics.time;
    }
    /**
     * Computes the flops rate for operations.
     */
    function flopsRate(node) {
        // NaN indicates undefined flops for fused operations (we can't
        // measure performance inside a fusion). It could also indicate operations
        // with zero time, but they currently don't appear in the profile.
        if (!node || !node.metrics || !node.metrics.rawTime)
            return NaN;
        // The unit of rawTime is picoseconds.
        return (node.metrics.rawFlops || 0) * 1E12 / node.metrics.rawTime;
    }
    /**
     * Computes a memory bandwidth utilization.
     */
    function memoryBandwidthUtilization(node) {
        // NaN indicates undefined memory bandwidth utilization (the profile was
        // collected from older versions of profiler).
        if (!node || !node.metrics || !node.metrics.memoryBandwidth)
            return NaN;
        return node.metrics.memoryBandwidth;
    }
    /**
     * Computes the memory bandwidth for operations.
     */
    function memoryBandwidth(node) {
        // NaN indicates undefined memory utilization (the profile was collected
        // from older versions of profiler).
        if (!node || !node.metrics || !node.metrics.rawTime)
            return NaN;
        // The unit of rawTime is picoseconds.
        return (node.metrics.rawBytesAccessed || 0) * 1E12 / node.metrics.rawTime;
    }
    /**
     * Returns whether a node has flops utilization.
     */
    function hasFlopsUtilization(node) {
        return !!node && !!node.metrics && !!node.metrics.time;
    }
    /**
     * Returns whether a node has memory bandwidth utilization.
     */
    function hasMemoryBandwidthUtilization(node) {
        return !!node && !!node.metrics && !!node.metrics.memoryBandwidth;
    }
    /**
     * Computes a percent.
     */
    function percent(fraction) {
        if (isNaN(fraction))
            return '-';
        return fraction >= 1.995 ?
            '200%' :
            fraction < 0.00001 ?
                '0.00%' :
                Number((fraction * 100).toPrecision(2)).toString() + '%';
    }
    /**
     * Computes wasted time.
     */
    function timeWasted(node) {
        if (!node || !node.metrics)
            return NaN;
        return ((node.metrics.time || 0) *
            (1 - Math.max(flopsUtilization(node), memoryBandwidthUtilization(node))));
    }
    /**
     * Returns podStatsRecord stepBreakdownUs field property.
     */
    function getPodStatsRecordBreakdownProperty(podStatsRecord, key) {
        if (podStatsRecord.stepBreakdownUs) {
            return podStatsRecord.stepBreakdownUs[key] || 0;
        }
        return 0;
    }
    /**
     * Returns a string with an anchor tag.
     */
    function addAnchorTag(value) {
        if (value === void 0) { value = ''; }
        return '<a>' + value + '</a>';
    }
    /**
     * Returns a string with the known tool name changed to an anchor tag.
     */
    function convertKnownToolToAnchorTag(value) {
        if (value === void 0) { value = ''; }
        KNOWN_TOOLS.forEach(function (tool) {
            value = value.replace(new RegExp(tool, 'g'), addAnchorTag(tool));
        });
        return value;
    }
    /**
     * Parse diagnostics data table and returns Diagnostics object.
     */
    function parseDiagnosticsDataTable(diagnosticsTable) {
        var diagnostics = { info: [], warnings: [], errors: [] };
        if (!diagnosticsTable || !diagnosticsTable.rows)
            return diagnostics;
        /** Convert data table to string arrays */
        diagnosticsTable.rows.forEach(function (row) {
            if (String(row.c[0].v) === 'ERROR') {
                diagnostics.errors.push(String(row.c[1].v));
            }
            else if (String(row.c[0].v) === 'WARNING') {
                diagnostics.warnings.push(String(row.c[1].v));
            }
            else {
                diagnostics.info.push(String(row.c[1].v));
            }
        });
        return diagnostics;
    }
    /**
     * Sets the global loading state.
     */
    function setLoadingState(beingLoaded, store) {
        if (beingLoaded) {
            store.dispatch(setLoadingStateAction({
                loadingState: {
                    loading: true,
                    message: 'Loading data',
                }
            }));
        }
        else {
            store.dispatch(setLoadingStateAction({
                loadingState: {
                    loading: false,
                    message: '',
                }
            }));
        }
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var COLUMN_ID_DEVICE_ANALYSIS = 'stepnum';
    /** @type {?} */
    var COLUMN_ID_HOST_ANALYSIS = 'opName';
    /** @type {?} */
    var COLUMN_ID_RECOMMENDATION = 'link';
    /** @type {?} */
    var COLUMN_ID_DIAGNOSTICS = 'severity';
    /** @type {?} */
    var PROPERTIES_DEVICE_ANALYSIS = [
        'infeed_percent_average',
        'infeed_percent_maximum',
        'infeed_percent_minimum',
        'infeed_percent_standard_deviation',
        'steptime_ms_average',
        'steptime_ms_maximum',
        'steptime_ms_minimum',
        'steptime_ms_standard_deviation',
        'input_conclusion',
        'summary_nextstep',
    ];
    /** @type {?} */
    var PROPERTIES_HOST_ANALYSIS = [
        'advanced_file_read_us',
        'demanded_file_read_us',
        'enqueue_us',
        'preprocessing_us',
        'unclassified_nonequeue_us',
    ];
    /**
     * A common class for the input-pipeline component.
     */
    var InputPipelineCommon = /** @class */ (function () {
        function InputPipelineCommon() {
            this.deviceAnalysis = null;
            this.hostAnalysis = null;
            this.recommendation = null;
            this.hasDiviceAanlysisRows = true;
            this.diagnostics = { info: [], warnings: [], errors: [] };
        }
        /**
         * @param {?} data
         * @param {?} columnId
         * @param {?=} properties
         * @return {?}
         */
        InputPipelineCommon.prototype.findAnalysisData = function (data, columnId, properties) {
            if (properties === void 0) { properties = []; }
            if (!data) {
                return {};
            }
            for (var i_172 = 0; i_172 < data.length; i_172++) {
                /** @type {?} */
                var analysis = data[i_172];
                if (!analysis) {
                    continue;
                }
                if (analysis.cols) {
                    /** @type {?} */
                    var foundCols = analysis.cols.find(( /**
                     * @param {?} column
                     * @return {?}
                     */function (/**
                     * @param {?} column
                     * @return {?}
                     */ column) { return column.id === columnId; }));
                    if (!!foundCols) {
                        return analysis;
                    }
                }
                if (analysis['p']) {
                    /** @type {?} */
                    var foundProperties = Object.keys(analysis['p'])
                        .find(( /**
                 * @param {?} property
                 * @return {?}
                 */function (/**
                 * @param {?} property
                 * @return {?}
                 */ property) { return properties.includes(property); }));
                    if (!!foundProperties) {
                        return analysis;
                    }
                }
            }
            return {};
        };
        /**
         * @return {?}
         */
        InputPipelineCommon.prototype.updateHasDeviceAanlysisRows = function () {
            /** @type {?} */
            var analysis = this.deviceAnalysis || {};
            analysis.p = analysis.p || {};
            this.hasDiviceAanlysisRows = !!analysis.rows && analysis.rows.length > 0;
        };
        /**
         * @param {?} data
         * @return {?}
         */
        InputPipelineCommon.prototype.parseCommonInputData = function (data) {
            this.deviceAnalysis = ( /** @type {?} */(this.findAnalysisData(data, COLUMN_ID_DEVICE_ANALYSIS, PROPERTIES_DEVICE_ANALYSIS)));
            this.hostAnalysis =
                ( /** @type {?} */(this.findAnalysisData(data, COLUMN_ID_HOST_ANALYSIS, PROPERTIES_HOST_ANALYSIS)));
            this.recommendation =
                ( /** @type {?} */(this.findAnalysisData(data, COLUMN_ID_RECOMMENDATION)));
            this.diagnostics = parseDiagnosticsDataTable(this.findAnalysisData(data, COLUMN_ID_DIAGNOSTICS));
            this.updateHasDeviceAanlysisRows();
        };
        return InputPipelineCommon;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * An input pipeline component.
     */
    var InputPipeline = /** @class */ (function (_super) {
        __extends(InputPipeline, _super);
        /**
         * @param {?} route
         * @param {?} dataService
         * @param {?} store
         */
        function InputPipeline(route, dataService, store) {
            var _this = _super.call(this) || this;
            _this.dataService = dataService;
            _this.store = store;
            /**
             * Handles on-destroy Subject, used to unsubscribe.
             */
            _this.destroyed = new ReplaySubject(1);
            route.params.pipe(takeUntil(_this.destroyed)).subscribe(( /**
             * @param {?} params
             * @return {?}
             */function (params) {
                _this.update(( /** @type {?} */(params)));
            }));
            return _this;
        }
        /**
         * @param {?} event
         * @return {?}
         */
        InputPipeline.prototype.update = function (event) {
            var _this = this;
            /** @type {?} */
            var run = event.run || '';
            /** @type {?} */
            var tag = event.tag || 'input_pipeline_analyzer';
            /** @type {?} */
            var host = event.host || '';
            setLoadingState(true, this.store);
            this.dataService.getData(run, tag, host)
                .pipe(takeUntil(this.destroyed))
                .subscribe(( /**
         * @param {?} data
         * @return {?}
         */function (data) {
                setLoadingState(false, _this.store);
                data = ( /** @type {?} */((data || [])));
                _this.parseCommonInputData(data);
            }));
        };
        /**
         * @return {?}
         */
        InputPipeline.prototype.ngOnDestroy = function () {
            // Unsubscribes all pending subscriptions.
            this.destroyed.next();
            this.destroyed.complete();
        };
        return InputPipeline;
    }(InputPipelineCommon));
    InputPipeline.decorators = [
        { type: Component, args: [{
                    selector: 'input-pipeline',
                    template: "<div>\n  <diagnostics-view [diagnostics]=\"diagnostics\"></diagnostics-view>\n  <analysis-summary [deviceAnalysis]=\"deviceAnalysis\"></analysis-summary>\n  <mat-divider></mat-divider>\n  <div [className]=\"hasDiviceAanlysisRows ? 'full-height' : 'hidden-content'\">\n    <device-side-analysis-detail [deviceAnalysis]=\"deviceAnalysis\"></device-side-analysis-detail>\n    <mat-divider></mat-divider>\n  </div>\n  <host-side-analysis-detail [hostAnalysis]=\"hostAnalysis\"\n                             [recommendation]=\"recommendation\">\n  </host-side-analysis-detail>\n</div>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}:host{display:block}\n"]
                }] }
    ];
    /** @nocollapse */
    InputPipeline.ctorParameters = function () { return [
        { type: ActivatedRoute },
        { type: DataService },
        { type: Store }
    ]; };
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatDivider = /** @class */ (function () {
        function MatDivider() {
            this._vertical = false;
            this._inset = false;
        }
        Object.defineProperty(MatDivider.prototype, "vertical", {
            /**
             * Whether the divider is vertically aligned.
             * @return {?}
             */
            get: function () { return this._vertical; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this._vertical = coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatDivider.prototype, "inset", {
            /**
             * Whether the divider is an inset divider.
             * @return {?}
             */
            get: function () { return this._inset; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this._inset = coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        return MatDivider;
    }());
    MatDivider.decorators = [
        { type: Component, args: [{ selector: 'mat-divider',
                    host: {
                        'role': 'separator',
                        '[attr.aria-orientation]': 'vertical ? "vertical" : "horizontal"',
                        '[class.mat-divider-vertical]': 'vertical',
                        '[class.mat-divider-horizontal]': '!vertical',
                        '[class.mat-divider-inset]': 'inset',
                        'class': 'mat-divider'
                    },
                    template: '',
                    styles: [".mat-divider{display:block;margin:0;border-top-width:1px;border-top-style:solid}.mat-divider.mat-divider-vertical{border-top:0;border-right-width:1px;border-right-style:solid}.mat-divider.mat-divider-inset{margin-left:80px}[dir=rtl] .mat-divider.mat-divider-inset{margin-left:auto;margin-right:80px}"],
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                },] },
    ];
    MatDivider.propDecorators = {
        vertical: [{ type: Input }],
        inset: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatDividerModule = /** @class */ (function () {
        function MatDividerModule() {
        }
        return MatDividerModule;
    }());
    MatDividerModule.decorators = [
        { type: NgModule, args: [{
                    imports: [MatCommonModule, CommonModule],
                    exports: [MatDivider, MatCommonModule],
                    declarations: [MatDivider],
                },] },
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * An diagnostics view component.
     */
    var DiagnosticsView = /** @class */ (function () {
        function DiagnosticsView() {
            /**
             * Error and warning messages for diagnosing profiling issues
             */
            this.diagnostics = { info: [], warnings: [], errors: [] };
        }
        return DiagnosticsView;
    }());
    DiagnosticsView.decorators = [
        { type: Component, args: [{
                    selector: 'diagnostics-view',
                    template: "<div *ngIf=\"diagnostics.errors.length\" class=\"callout is-critical\">\n<header>Errors</header>\n  <li *ngFor=\"let error of diagnostics.errors\">\n      {{ error }}\n  </li>\n</div>\n<div *ngIf=\"diagnostics.warnings.length\" class=\"callout is-important\">\n<header>Warnings</header>\n  <li *ngFor=\"let warning of diagnostics.warnings\">\n      {{ warning }}\n  </li>\n</div>\n<div *ngIf=\"diagnostics.info.length\" class=\"callout is-helpful\">\n<header>Info</header>\n  <li *ngFor=\"let info of diagnostics.info\">\n      {{ info }}\n  </li>\n</div>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}.callout{padding:0;border-left:none !important;border-radius:4px}.callout header{color:#fff;line-height:24px;font-weight:500;padding:8px 16px;margin:0;text-transform:uppercase;border-radius:4px 4px 0 0}.callout p{padding:16px;margin:0;font-size:14px}.callout>:not(:first-child){padding:12px 24px}.callout.is-critical{border-color:#dd0031;background:rgba(221,0,49,.05)}.callout.is-critical header{background:#dd0031}.callout.is-important{border-color:#ff9800;background:rgba(255,152,0,.05)}.callout.is-important header{background:#ffa000}.callout.is-helpful{border-color:#1976d2;background:rgba(25,118,210,.05)}.callout.is-helpful header{background:#1976d2}\n"]
                }] }
    ];
    DiagnosticsView.propDecorators = {
        diagnostics: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DiagnosticsViewModule = /** @class */ (function () {
        function DiagnosticsViewModule() {
        }
        return DiagnosticsViewModule;
    }());
    DiagnosticsViewModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [DiagnosticsView],
                    imports: [CommonModule],
                    exports: [DiagnosticsView]
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A summary of input pipeline analysis component.
     */
    var AnalysisSummary = /** @class */ (function () {
        function AnalysisSummary() {
            this.inputConclusion = '';
            this.summaryNextstep = '';
            this.summaryColor = 'green';
        }
        Object.defineProperty(AnalysisSummary.prototype, "deviceAnalysis", {
            /**
             * The input pipeline device anaysis data.
             * @param {?} analysis
             * @return {?}
             */
            set: function (analysis) {
                analysis = analysis || {};
                analysis.p = analysis.p || {};
                this.inputConclusion = analysis.p.input_conclusion || '';
                this.summaryNextstep =
                    this.replaceSectionName(analysis.p.summary_nextstep || '');
                this.summaryColor = 'green';
                if (this.inputConclusion.includes('HIGHLY')) {
                    this.summaryColor = 'red';
                }
                else if (this.inputConclusion.includes('MODERATE')) {
                    this.summaryColor = 'orange';
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @private
         * @param {?} summary
         * @return {?}
         */
        AnalysisSummary.prototype.replaceSectionName = function (summary) {
            return summary.replace(/section 2/g, 'Device-side analysis details section')
                .replace(/section 3/g, 'Host-side analysis details section');
        };
        return AnalysisSummary;
    }());
    AnalysisSummary.decorators = [
        { type: Component, args: [{
                    selector: 'analysis-summary',
                    template: "<div class=\"mat-headline\">Summary of input-pipeline analysis</div>\n<div class=\"summary-conclusion description\">{{inputConclusion}}</div>\n<br>\n<div class=\"mat-title\">Recommendation for next step:</div>\n<div class=\"summary-nextstep description\" [innerHtml]=\"summaryNextstep\"></div>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}:host{display:block;padding:20px}.summary-conclusion{font-style:italic;margin-top:-16px}.summary-nextstep{margin-top:-16px}\n"]
                }] }
    ];
    AnalysisSummary.propDecorators = {
        deviceAnalysis: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AnalysisSummaryModule = /** @class */ (function () {
        function AnalysisSummaryModule() {
        }
        return AnalysisSummaryModule;
    }());
    AnalysisSummaryModule.decorators = [
        { type: NgModule, args: [{ declarations: [AnalysisSummary], imports: [], exports: [AnalysisSummary] },] }
    ];
    // Type definitions for additional types of Gviz
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A common chart component.
     */
    var Chart = /** @class */ (function () {
        /**
         * @param {?} elementRef
         */
        function Chart(elementRef) {
            this.elementRef = elementRef;
            /**
             * The event for the number of rows of processed data.
             */
            this.processedNumberOfRows = new EventEmitter();
        }
        /**
         * @return {?}
         */
        Chart.prototype.ngOnInit = function () {
            this.loadGoogleChart();
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        Chart.prototype.ngOnChanges = function (changes) {
            if (changes['dataInfo'] && this.dataInfo && this.dataInfo.dataProvider) {
                this.dataInfo.dataProvider.parseData(this.dataInfo.data);
                this.dataInfo.dataProvider.setFilters(this.dataInfo.filters || []);
            }
            this.draw();
        };
        /**
         * @return {?}
         */
        Chart.prototype.draw = function () {
            if (!this.chart) {
                return;
            }
            if (!this.dataInfo || !this.dataInfo.dataProvider) {
                this.chart.clearChart();
                return;
            }
            /** @type {?} */
            var processedData = this.getProcessedData(this.dataInfo.customChartDataProcessor);
            /** @type {?} */
            var options = this.dataInfo.dataProvider.getOptions() || this.dataInfo.options;
            if (processedData) {
                // tslint:disable-next-line:no-any
                this.chart.draw(processedData, ( /** @type {?} */(options)));
            }
            this.processedNumberOfRows.emit(processedData ? processedData.getNumberOfRows() : 0);
        };
        /**
         * @param {?} customChartDataProcessor
         * @return {?}
         */
        Chart.prototype.getProcessedData = function (customChartDataProcessor) {
            if (!this.dataInfo || !this.dataInfo.dataProvider) {
                return null;
            }
            if (customChartDataProcessor && customChartDataProcessor.process) {
                return customChartDataProcessor.process(this.dataInfo.dataProvider);
            }
            return this.dataInfo.dataProvider.process();
        };
        /**
         * @return {?}
         */
        Chart.prototype.loadGoogleChart = function () {
            var _this = this;
            if (!google || !google.charts) {
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    _this.loadGoogleChart();
                }), 100);
            }
            google.charts.safeLoad({ 'packages': ['corechart', 'table'] });
            google.charts.setOnLoadCallback(( /**
             * @return {?}
             */function () {
                _this.initChart();
                _this.initDataProvider();
                _this.draw();
            }));
        };
        /**
         * @return {?}
         */
        Chart.prototype.initChart = function () {
            switch (this.chartType) {
                case "AreaChart" /* AREA_CHART */:
                    this.chart =
                        new google.visualization.AreaChart(this.elementRef.nativeElement);
                    break;
                case "BarChart" /* BAR_CHART */:
                    this.chart =
                        new google.visualization.BarChart(this.elementRef.nativeElement);
                    break;
                case "BubbleChart" /* BUBBLE_CHART */:
                    this.chart =
                        new google.visualization.BubbleChart(this.elementRef.nativeElement);
                    break;
                case "CandlestickChart" /* CANDLESTICK_CHART */:
                    this.chart = new google.visualization.CandlestickChart(this.elementRef.nativeElement);
                    break;
                case "ColumnChart" /* COLUMN_CHART */:
                    this.chart =
                        new google.visualization.ColumnChart(this.elementRef.nativeElement);
                    break;
                case "ComboChart" /* COMBO_CHART */:
                    this.chart =
                        new google.visualization.ComboChart(this.elementRef.nativeElement);
                    break;
                case "Histogram" /* HISTOGRAM */:
                    this.chart =
                        new google.visualization.Histogram(this.elementRef.nativeElement);
                    break;
                case "LineChart" /* LINE_CHART */:
                    this.chart =
                        new google.visualization.LineChart(this.elementRef.nativeElement);
                    break;
                case "PieChart" /* PIE_CHART */:
                    this.chart =
                        new google.visualization.PieChart(this.elementRef.nativeElement);
                    break;
                case "ScatterChart" /* SCATTER_CHART */:
                    this.chart = new google.visualization.ScatterChart(this.elementRef.nativeElement);
                    break;
                case "SteppedAreaChart" /* STEPPED_AREA_CHART */:
                    this.chart = new google.visualization.SteppedAreaChart(this.elementRef.nativeElement);
                    break;
                case "Table" /* TABLE */:
                    this.chart =
                        new google.visualization.Table(this.elementRef.nativeElement);
                    break;
                default:
                    this.chart = undefined;
                    break;
            }
        };
        /**
         * @return {?}
         */
        Chart.prototype.initDataProvider = function () {
            var _this = this;
            if (!this.dataInfo || !this.dataInfo.dataProvider) {
                return;
            }
            if (this.chart) {
                this.dataInfo.dataProvider.setChart(this.chart);
            }
            this.dataInfo.dataProvider.parseData(this.dataInfo.data);
            this.dataInfo.dataProvider.setFilters(this.dataInfo.filters || []);
            this.dataInfo.dataProvider.setUpdateEventListener(( /**
             * @return {?}
             */function () {
                _this.draw();
            }));
        };
        return Chart;
    }());
    Chart.decorators = [
        { type: Component, args: [{
                    selector: 'chart',
                    template: '',
                    styles: [':host {display: block;}']
                }] }
    ];
    /** @nocollapse */
    Chart.ctorParameters = function () { return [
        { type: ElementRef }
    ]; };
    Chart.propDecorators = {
        chartType: [{ type: Input }],
        dataInfo: [{ type: Input }],
        processedNumberOfRows: [{ type: Output }]
    };
    var ChartModule = /** @class */ (function () {
        function ChartModule() {
        }
        return ChartModule;
    }());
    ChartModule.decorators = [
        { type: NgModule, args: [{ declarations: [Chart], exports: [Chart] },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A default chart data provider.
     */
    var DefaultDataProvider = /** @class */ (function () {
        function DefaultDataProvider() {
            this.update = new EventEmitter();
        }
        /**
         * @param {?} chart
         * @return {?}
         */
        DefaultDataProvider.prototype.setChart = function (chart) {
            this.chart = chart;
        };
        /**
         * @param {?} data
         * @return {?}
         */
        DefaultDataProvider.prototype.parseData = function (data) {
            if (data) {
                this.dataTable =
                    new google.visualization.DataTable(( /** @type {?} */(data)));
            }
        };
        /**
         * @param {?} sortColumns
         * @return {?}
         */
        DefaultDataProvider.prototype.setSortColumns = function (sortColumns) {
            this.sortColumns = sortColumns;
        };
        /**
         * @param {?} visibleColumns
         * @return {?}
         */
        DefaultDataProvider.prototype.setVisibleColumns = function (visibleColumns) {
            this.visibleColumns = visibleColumns;
        };
        /**
         * @param {?} filters
         * @return {?}
         */
        DefaultDataProvider.prototype.setFilters = function (filters) {
            this.filters = filters;
        };
        /**
         * @return {?}
         */
        DefaultDataProvider.prototype.process = function () {
            if (!this.dataTable) {
                return null;
            }
            if (this.sortColumns && this.sortColumns.length > 0) {
                this.dataTable.sort(this.sortColumns);
            }
            /** @type {?} */
            var dataView = new google.visualization.DataView(this.dataTable);
            if (this.visibleColumns && this.visibleColumns.length > 0) {
                dataView.setColumns(this.visibleColumns);
            }
            if (this.filters && this.filters.length > 0) {
                dataView.setRows(this.dataTable.getFilteredRows(this.filters));
            }
            return dataView;
        };
        /**
         * @return {?}
         */
        DefaultDataProvider.prototype.getChart = function () {
            return this.chart || null;
        };
        /**
         * @return {?}
         */
        DefaultDataProvider.prototype.getDataTable = function () {
            return this.dataTable ?
                (( /** @type {?} */(this.dataTable))) :
                null;
        };
        /**
         * @return {?}
         */
        DefaultDataProvider.prototype.getOptions = function () {
            return null;
        };
        /**
         * @param {?} callback
         * @return {?}
         */
        DefaultDataProvider.prototype.setUpdateEventListener = function (callback) {
            this.update.subscribe(callback);
        };
        /**
         * @return {?}
         */
        DefaultDataProvider.prototype.notifyCharts = function () {
            this.update.emit();
        };
        return DefaultDataProvider;
    }());
    /**
     * A chart data provider that accepts array data.
     */
    var ArrayDataProvider = /** @class */ (function (_super) {
        __extends(ArrayDataProvider, _super);
        function ArrayDataProvider() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @param {?} data
         * @return {?}
         */
        ArrayDataProvider.prototype.parseData = function (data) {
            if (data) {
                /* tslint:disable no-any */
                this.dataTable = google.visualization.arrayToDataTable(( /** @type {?} */(data)));
                /* tslint:enable */
            }
        };
        return ArrayDataProvider;
    }(DefaultDataProvider));
    /** A device side analysis detail data provider. */
    var DeviceSideAnalysisDetailDataProvider = /** @class */ (function (_super) {
        __extends(DeviceSideAnalysisDetailDataProvider, _super);
        function DeviceSideAnalysisDetailDataProvider() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this.columnIds = [];
            return _this;
        }
        DeviceSideAnalysisDetailDataProvider.prototype.setColumnIds = function (columnIds) {
            this.columnIds = columnIds;
        };
        DeviceSideAnalysisDetailDataProvider.prototype.parseData = function (data) {
            if (!data)
                return;
            var dataTable = new google.visualization.DataTable(data);
            var i = 0;
            while (i < dataTable.getNumberOfColumns()) {
                if (!this.columnIds.includes(dataTable.getColumnId(i))) {
                    dataTable.removeColumn(i);
                    continue;
                }
                i++;
            }
            this.dataTable = dataTable;
        };
        return DeviceSideAnalysisDetailDataProvider;
    }(DefaultDataProvider));
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var INFEED_COLUMN_IDS = [
        'stepnum',
        'infeedPercentAverage',
        'infeedPercentMin',
        'infeedPercentMax',
    ];
    /** @type {?} */
    var STEPTIME_COLUMN_IDS_FOR_TPU = [
        'stepnum',
        'computeTimeMs',
        'inputTimeMs',
        'idleTimeMs',
        'tooltip',
    ];
    /** @type {?} */
    var STEPTIME_COLUMN_IDS_FOR_GPU = [
        'stepnum',
        'deviceComputeTimeMs',
        'deviceToDeviceTimeMs',
        'deviceCollectivesTimeMs',
        'hostComputeTimeMs',
        'kernelLaunchTimeMs',
        'infeedTimeMs',
        'outfeedTimeMs',
        'compileTimeMs',
        'otherTimeMs',
        'tooltip',
    ];
    /** @type {?} */
    var COLORS_FOR_TPU = [
        'green',
        'crimson',
        'blue',
    ];
    /** @type {?} */
    var COLORS_FOR_GPU = [
        '#9CCC65',
        '#FFEB3B',
        'pink',
        '#64B5F6',
        '#FF9800',
        '#B71C1C',
        'black',
        '#00695C',
        '#5E35B1',
    ];
    /**
     * A device-side analysis detail view component.
     */
    var DeviceSideAnalysisDetail = /** @class */ (function () {
        function DeviceSideAnalysisDetail() {
            /**
             * The default column ids.
             */
            this.columnIds = STEPTIME_COLUMN_IDS_FOR_TPU;
            /**
             * The default column colors.
             */
            this.columnColors = COLORS_FOR_TPU;
            this.isTpu = true;
            this.inputPipelineDeviceAnalysis = null;
            this.infeedPercentMetrics = {};
            this.steptimeMsMetrics = {};
            this.areaChart = null;
            this.lineChart = null;
            this.dataProviderForAreaChart = new DeviceSideAnalysisDetailDataProvider();
            this.dataInfoForAreaChart = {
                data: null,
                dataProvider: this.dataProviderForAreaChart,
                options: {
                    hAxis: { title: 'Step Number' },
                    vAxis: { title: 'Milliseconds', format: '###.####ms', minValue: 0 },
                    chartArea: {
                        left: 100,
                        top: 10,
                        width: '65%',
                        height: '90%',
                    },
                    width: 820,
                    height: 300,
                    colors: COLORS_FOR_TPU,
                    backgroundColor: { fill: 'transparent' },
                    isStacked: true,
                },
            };
            this.dataProviderForLineChart = new DeviceSideAnalysisDetailDataProvider();
            this.dataInfoForLineChart = {
                data: null,
                dataProvider: this.dataProviderForLineChart,
                options: {
                    hAxis: { title: 'Step Number' },
                    vAxis: { title: '% of step time', format: '###.###\'%\'' },
                    chartArea: {
                        left: 100,
                        top: 10,
                        width: '65%',
                        height: '90%',
                    },
                    width: 820,
                    height: 300,
                    legend: 'none',
                    lineWidth: 1,
                    colors: ['none'],
                    backgroundColor: { fill: 'transparent' },
                    intervals: { style: 'boxes', color: 'red' },
                },
            };
        }
        Object.defineProperty(DeviceSideAnalysisDetail.prototype, "deviceAnalysis", {
            /**
             * The input pipeline device analysis data.
             * @param {?} analysis
             * @return {?}
             */
            set: function (analysis) {
                this.inputPipelineDeviceAnalysis = analysis;
                analysis = analysis || {};
                analysis.p = analysis.p || {};
                if (!analysis.rows || analysis.rows.length === 0) {
                    return;
                }
                this.isTpu = (analysis.p.hardware_type || 'TPU') === 'TPU';
                this.steptimeMsMetrics.average = analysis.p.steptime_ms_average || '';
                this.steptimeMsMetrics.max = analysis.p.steptime_ms_maximum || '';
                this.steptimeMsMetrics.min = analysis.p.steptime_ms_minimum || '';
                this.steptimeMsMetrics.stddev =
                    analysis.p.steptime_ms_standard_deviation || '';
                this.infeedPercentMetrics.average = analysis.p.infeed_percent_average || '';
                this.infeedPercentMetrics.max = analysis.p.infeed_percent_maximum || '';
                this.infeedPercentMetrics.min = analysis.p.infeed_percent_minimum || '';
                this.infeedPercentMetrics.stddev =
                    analysis.p.infeed_percent_standard_deviation || '';
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} changes
         * @return {?}
         */
        DeviceSideAnalysisDetail.prototype.ngOnChanges = function (changes) {
            this.dataProviderForAreaChart.setColumnIds(this.isTpu ? this.columnIds : STEPTIME_COLUMN_IDS_FOR_GPU);
            this.dataInfoForAreaChart = Object.assign({}, this.dataInfoForAreaChart, { data: this.inputPipelineDeviceAnalysis, options: Object.assign({}, this.dataInfoForAreaChart.options, { colors: this.isTpu ? this.columnColors : COLORS_FOR_GPU }) });
            this.dataProviderForLineChart.setColumnIds(INFEED_COLUMN_IDS);
            this.dataInfoForLineChart = Object.assign({}, this.dataInfoForLineChart, { data: this.inputPipelineDeviceAnalysis });
        };
        return DeviceSideAnalysisDetail;
    }());
    DeviceSideAnalysisDetail.decorators = [
        { type: Component, args: [{
                    selector: 'device-side-analysis-detail',
                    template: "<div>\n  <div class=\"mat-headline\">Device-side analysis details</div>\n\n  <div class=\"mat-headline sub-section-title\">Device step time</div>\n  <div class=\"content-container\">\n    <div class=\"mat-title\">Device step-time statistics</div>\n    <div class=\"primary-content\">\n      Average: {{steptimeMsMetrics.average}} ms (\u03C3 = {{steptimeMsMetrics.stddev}} ms)\n    </div>\n    <div class=\"primary-content\">\n      Range: {{steptimeMsMetrics.min}} - {{steptimeMsMetrics.max}} ms\n    </div>\n    <br>\n    <div class=\"mat-title\">Step Time (in milliseconds)</div>\n    <div #areaChart class=\"chart\"></div>\n    <chart class=\"chart\" chartType=\"AreaChart\" [dataInfo]=\"dataInfoForAreaChart\"></chart>\n  </div>\n\n  <br>\n\n  <div [className]=\"isTpu ? 'auto-height' : 'hidden-content'\">\n    <div class=\"mat-headline sub-section-title\">\n      Range of device time waiting for input data across cores at each step\n    </div>\n    <div class=\"content-container\">\n      <div class=\"mat-title\">% of device step time waiting for input data</div>\n      <div class=\"description\">\n        (average over the <i>maximum</i> waiting time across cores at each step)\n      </div>\n      <div class=\"primary-content\">\n        Average: {{infeedPercentMetrics.average}} % (\u03C3 = {{infeedPercentMetrics.stddev}} ms)\n      </div>\n      <div class=\"primary-content\">\n        Range: {{infeedPercentMetrics.min}} - {{infeedPercentMetrics.max}} %\n      </div>\n      <br>\n      <div class=\"mat-title\">\n        Range of device time waiting for input data across cores at each step (in % of step time)\n      </div>\n      <div #lineChart class=\"chart\"></div>\n      <chart class=\"chart\" chartType=\"LineChart\" [dataInfo]=\"dataInfoForLineChart\"></chart>\n    </div>\n  </div>\n</div>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}:host{display:block;padding:20px}.content-container{margin-left:32px;margin-top:-16px}.content-container .mat-title{margin-bottom:0}.sub-section-title{font-size:22px;margin-left:8px}.description{margin-bottom:4px}.chart{margin-left:-52px}\n"]
                }] }
    ];
    DeviceSideAnalysisDetail.propDecorators = {
        deviceAnalysis: [{ type: Input }],
        columnIds: [{ type: Input }],
        columnColors: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DeviceSideAnalysisDetailModule = /** @class */ (function () {
        function DeviceSideAnalysisDetailModule() {
        }
        return DeviceSideAnalysisDetailModule;
    }());
    DeviceSideAnalysisDetailModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [DeviceSideAnalysisDetail],
                    imports: [ChartModule],
                    exports: [DeviceSideAnalysisDetail],
                },] }
    ];
    /** The basic options of Google Charts table. */
    var TABLE_OPTIONS = {
        allowHtml: true,
        alternatingRowStyle: false,
        cssClassNames: {
            'headerCell': 'google-chart-table-header-cell',
            'tableCell': 'google-chart-table-table-cell',
        },
    };
    /** The basic options of Google Charts pie chart. */
    var PIE_CHART_OPTIONS = {
        backgroundColor: 'transparent',
        width: 400,
        height: 200,
        chartArea: {
            left: 0,
            width: '100%',
            height: '80%',
        },
        legend: { textStyle: { fontSize: 10 } },
        sliceVisibilityThreshold: 0.01,
    };
    /** The basic options of Google Charts column chart. */
    var COLUMN_CHART_OPTIONS = {
        backgroundColor: 'transparent',
        width: 550,
        height: 200,
        chartArea: {
            left: 70,
            top: 10,
            width: '80%',
            height: '80%',
        },
        legend: { position: 'none' },
        tooltip: {
            isHtml: true,
            ignoreBounds: true,
        },
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A host side analysis detail table data provider.
     */
    var HostSideAnalysisDetailTableDataProvider = /** @class */ (function (_super) {
        __extends(HostSideAnalysisDetailTableDataProvider, _super);
        function HostSideAnalysisDetailTableDataProvider() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this.hasHostOpsChanged = new EventEmitter();
            return _this;
        }
        /**
         * @param {?} data
         * @return {?}
         */
        HostSideAnalysisDetailTableDataProvider.prototype.parseData = function (data) {
            if (!data)
                return;
            /** @type {?} */
            var dataTable = new google.visualization.DataTable(data);
            if (dataTable.getNumberOfRows() < 1) {
                this.hasHostOpsChanged.emit(false);
                return;
            }
            this.hasHostOpsChanged.emit(true);
            /** @type {?} */
            var columns = {
                opName: 0,
                count: 0,
                timeInMs: 0,
                timeInPercent: 0,
                selfTimeInMs: 0,
                selfTimeInPercent: 0,
                category: 0,
            };
            for (var i_173 = 0; i_173 < dataTable.getNumberOfColumns(); i_173++) {
                switch (dataTable.getColumnId(i_173)) {
                    case 'opName':
                        columns.opName = i_173;
                        break;
                    case 'count':
                        columns.count = i_173;
                        break;
                    case 'timeInMs':
                        columns.timeInMs = i_173;
                        break;
                    case 'timeInPercent':
                        columns.timeInPercent = i_173;
                        break;
                    case 'selfTimeInMs':
                        columns.selfTimeInMs = i_173;
                        break;
                    case 'selfTimeInPercent':
                        columns.selfTimeInPercent = i_173;
                        break;
                    case 'category':
                        columns.category = i_173;
                        break;
                    default:
                        break;
                }
            }
            /** @type {?} */
            var percentFormatter = new google.visualization.NumberFormat({ pattern: '##.#%' });
            percentFormatter.format(dataTable, columns.timeInPercent);
            percentFormatter.format(dataTable, columns.selfTimeInPercent);
            /** @type {?} */
            var zeroDecimalPtFormatter = new google.visualization.NumberFormat({ 'fractionDigits': 0 });
            zeroDecimalPtFormatter.format(dataTable, columns.timeInMs);
            zeroDecimalPtFormatter.format(dataTable, columns.selfTimeInMs);
            dataTable.setProperty(0, columns.opName, 'style', 'width: 40%');
            dataTable.setProperty(0, columns.count, 'style', 'width: 15%');
            dataTable.setProperty(0, columns.timeInMs, 'style', 'width: 10%');
            dataTable.setProperty(0, columns.timeInPercent, 'style', 'width: 5%');
            dataTable.setProperty(0, columns.selfTimeInMs, 'style', 'width: 10%');
            dataTable.setProperty(0, columns.selfTimeInPercent, 'style', 'width: 5%');
            dataTable.setProperty(0, columns.category, 'style', 'width: 15%');
            this.dataTable = dataTable;
        };
        /**
         * @param {?} callback
         * @return {?}
         */
        HostSideAnalysisDetailTableDataProvider.prototype.setHasHostOpsChangedEventListener = function (callback) {
            this.hasHostOpsChanged.subscribe(callback);
        };
        return HostSideAnalysisDetailTableDataProvider;
    }(DefaultDataProvider));
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A host-side analysis detail view component.
     */
    var HostSideAnalysisDetail = /** @class */ (function () {
        function HostSideAnalysisDetail() {
            /**
             * The input pipeline host anaysis data.
             */
            this.hostAnalysis = null;
            this.hasHostOps = false;
            this.recommendations = [];
            this.dataInfoForColumnChart = {
                data: null,
                dataProvider: new ArrayDataProvider(),
                options: {
                    bar: { groupWidth: '45%' },
                    chartArea: {
                        left: 40,
                        width: '50%',
                        height: '90%',
                    },
                    width: 800,
                    height: 300,
                    colors: ['red', 'blue', 'orange', 'green', 'purple'],
                    backgroundColor: { 'fill': 'transparent' },
                    isStacked: 'percent',
                },
            };
            this.dataProviderForTable = new HostSideAnalysisDetailTableDataProvider();
            this.dataInfoForTable = {
                data: null,
                dataProvider: this.dataProviderForTable,
                options: Object.assign({}, TABLE_OPTIONS, { alternatingRowStyle: false }),
            };
        }
        Object.defineProperty(HostSideAnalysisDetail.prototype, "recommendation", {
            /**
             * The recommendation data.
             * @param {?} data
             * @return {?}
             */
            set: function (data) {
                var _this = this;
                data = data || {};
                data.rows = data.rows || [];
                data.rows.forEach(( /**
                 * @param {?} row
                 * @return {?}
                 */function (/**
                 * @param {?} row
                 * @return {?}
                 */ row) {
                    if (row.c && row.c[0] && row.c[0].v) {
                        _this.recommendations.push(String(row.c[0].v));
                    }
                }));
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        HostSideAnalysisDetail.prototype.ngOnInit = function () {
            var _this = this;
            this.dataProviderForTable.setHasHostOpsChangedEventListener(( /**
             * @param {?} hasHostOps
             * @return {?}
             */function (hasHostOps) {
                _this.hasHostOps = hasHostOps;
            }));
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        HostSideAnalysisDetail.prototype.ngOnChanges = function (changes) {
            this.parseColumnChartData(this.hostAnalysis);
            this.dataInfoForTable = Object.assign({}, this.dataInfoForTable, { data: this.hostAnalysis });
        };
        /**
         * @param {?} hostAnalysis
         * @return {?}
         */
        HostSideAnalysisDetail.prototype.parseColumnChartData = function (hostAnalysis) {
            if (!hostAnalysis) {
                this.hasHostOps = false;
                return;
            }
            this.hasHostOps = true;
            /** @type {?} */
            var kUsPerMs = 1000.0;
            /** @type {?} */
            var p = hostAnalysis.p || {};
            /** @type {?} */
            var unclassifiedNonEnqueueMs = Number(p.unclassified_nonequeue_us) / kUsPerMs;
            /** @type {?} */
            var demandedFileReadMs = Number(p.demanded_file_read_us) / kUsPerMs;
            /** @type {?} */
            var advancedFileReadMs = Number(p.advanced_file_read_us) / kUsPerMs;
            /** @type {?} */
            var preprocessingMs = Number(p.preprocessing_us) / kUsPerMs;
            /** @type {?} */
            var enqueueMs = Number(p.enqueue_us) / kUsPerMs;
            /** @type {?} */
            var data = [
                [
                    'Input time breakdown',
                    'Other data reading or processing (in ms)',
                    'Reading data from files on demand (in ms)',
                    'Reading data from files in advance [including caching, prefetching, interleaving] (in ms)',
                    'Data preprocessing (in ms)',
                    'Enqueuing data to be transferred to device (in ms)',
                ],
                [
                    '',
                    unclassifiedNonEnqueueMs,
                    demandedFileReadMs,
                    advancedFileReadMs,
                    preprocessingMs,
                    enqueueMs,
                ],
            ];
            this.dataInfoForColumnChart = Object.assign({}, this.dataInfoForColumnChart, { data: data });
        };
        return HostSideAnalysisDetail;
    }());
    HostSideAnalysisDetail.decorators = [
        { type: Component, args: [{
                    selector: 'host-side-analysis-detail',
                    template: "<div [className]=\"hasHostOps ? 'auto-height' : 'hidden-content'\">\n  <div class=\"section-container\">\n    <div class=\"mat-headline\">Host-side analysis details</div>\n    <div class=\"content-container\">\n      <div class=\"mat-title\">Breakdown of input processing time on the host</div>\n      <chart class=\"column-chart\"\n             chartType=\"ColumnChart\"\n             [dataInfo]=\"dataInfoForColumnChart\">\n      </chart>\n      <div class=\"mat-title\">What can be done to reduce above components of the host input time:</div>\n      <div class=\"recommendations\">\n        <div *ngFor=\"let recommendation of recommendations\" [innerHtml]=\"recommendation\"></div>\n      </div>\n    </div>\n  </div>\n\n  <mat-expansion-panel>\n    <mat-expansion-panel-header>\n      <mat-panel-title>Input Op statistics</mat-panel-title>\n    </mat-expansion-panel-header>\n    <chart chartType=\"Table\" [dataInfo]=\"dataInfoForTable\"></chart>\n  </mat-expansion-panel>\n  <br/>\n</div>\n\n<div *ngIf=\"!hasHostOps\" class=\"section-container\">\n  <div class=\"mat-headline\">Host-side analysis details</div>\n  <p>Host side analysis can not be done without instrumentation.</p>\n</div>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}mat-expansion-panel{box-shadow:none !important;margin:8px;margin:0}@media screen and (max-width: 1140px){mat-expansion-panel{min-width:500px}}mat-expansion-panel-header{margin:8px 8px 0 8px}mat-panel-title{background-color:#fff;border-top-left-radius:4px;border-top-right-radius:4px;color:#000;font-size:24px;font-weight:400;background-color:transparent}mat-expansion-panel-header.cdk-keyboard-focused,mat-expansion-panel:not(.mat-expanded) mat-expansion-panel-header:hover{background-color:#eee !important}.mat-expanded mat-expansion-panel-header{border-bottom-left-radius:0;border-bottom-right-radius:0}.section-container{border-bottom:1px solid #eee;padding:20px}.content-container{margin-left:32px}.column-chart,.recommendations{color:#4a4a4a;margin-top:-16px}\n"]
                }] }
    ];
    HostSideAnalysisDetail.propDecorators = {
        hostAnalysis: [{ type: Input }],
        recommendation: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var HostSideAnalysisDetailModule = /** @class */ (function () {
        function HostSideAnalysisDetailModule() {
        }
        return HostSideAnalysisDetailModule;
    }());
    HostSideAnalysisDetailModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [HostSideAnalysisDetail],
                    imports: [
                        CommonModule,
                        MatExpansionModule,
                        ChartModule,
                    ],
                    exports: [HostSideAnalysisDetail]
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var InputPipelineModule = /** @class */ (function () {
        function InputPipelineModule() {
        }
        return InputPipelineModule;
    }());
    InputPipelineModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [InputPipeline],
                    imports: [
                        AnalysisSummaryModule,
                        DeviceSideAnalysisDetailModule,
                        DiagnosticsViewModule,
                        HostSideAnalysisDetailModule,
                        MatDividerModule,
                    ],
                    exports: [InputPipeline]
                },] }
    ];
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Returns an exception to be thrown in the case when attempting to
     * load an icon with a name that cannot be found.
     * \@docs-private
     * @param {?} iconName
     * @return {?}
     */
    function getMatIconNameNotFoundError(iconName) {
        return Error("Unable to find icon with the name \"" + iconName + "\"");
    }
    /**
     * Returns an exception to be thrown when the consumer attempts to use
     * `<mat-icon>` without including \@angular/common/http.
     * \@docs-private
     * @return {?}
     */
    function getMatIconNoHttpProviderError() {
        return Error('Could not find HttpClient provider for use with Angular Material icons. ' +
            'Please include the HttpClientModule from @angular/common/http in your ' +
            'app imports.');
    }
    /**
     * Returns an exception to be thrown when a URL couldn't be sanitized.
     * \@docs-private
     * @param {?} url URL that was attempted to be sanitized.
     * @return {?}
     */
    function getMatIconFailedToSanitizeUrlError(url) {
        return Error("The URL provided to MatIconRegistry was not trusted as a resource URL " +
            ("via Angular's DomSanitizer. Attempted URL was \"" + url + "\"."));
    }
    /**
     * Returns an exception to be thrown when a HTML string couldn't be sanitized.
     * \@docs-private
     * @param {?} literal HTML that was attempted to be sanitized.
     * @return {?}
     */
    function getMatIconFailedToSanitizeLiteralError(literal) {
        return Error("The literal provided to MatIconRegistry was not trusted as safe HTML by " +
            ("Angular's DomSanitizer. Attempted literal was \"" + literal + "\"."));
    }
    /**
     * Configuration for an icon, including the URL and possibly the cached SVG element.
     * \@docs-private
     */
    var SvgIconConfig = /** @class */ (function () {
        /**
         * @param {?} data
         * @param {?=} options
         */
        function SvgIconConfig(data, options) {
            this.options = options;
            // Note that we can't use `instanceof SVGElement` here,
            // because it'll break during server-side rendering.
            if (!!(( /** @type {?} */(data))).nodeName) {
                this.svgElement = ( /** @type {?} */(data));
            }
            else {
                this.url = ( /** @type {?} */(data));
            }
        }
        return SvgIconConfig;
    }());
    /**
     * Service to register and display icons used by the `<mat-icon>` component.
     * - Registers icon URLs by namespace and name.
     * - Registers icon set URLs by namespace.
     * - Registers aliases for CSS classes, for use with icon fonts.
     * - Loads icons from URLs and extracts individual icons from icon sets.
     */
    var MatIconRegistry = /** @class */ (function () {
        /**
         * @param {?} _httpClient
         * @param {?} _sanitizer
         * @param {?} document
         * @param {?=} _errorHandler
         */
        function MatIconRegistry(_httpClient, _sanitizer, document, _errorHandler) {
            this._httpClient = _httpClient;
            this._sanitizer = _sanitizer;
            this._errorHandler = _errorHandler;
            /**
             * URLs and cached SVG elements for individual icons. Keys are of the format "[namespace]:[icon]".
             */
            this._svgIconConfigs = new Map();
            /**
             * SvgIconConfig objects and cached SVG elements for icon sets, keyed by namespace.
             * Multiple icon sets can be registered under the same namespace.
             */
            this._iconSetConfigs = new Map();
            /**
             * Cache for icons loaded by direct URLs.
             */
            this._cachedIconsByUrl = new Map();
            /**
             * In-progress icon fetches. Used to coalesce multiple requests to the same URL.
             */
            this._inProgressUrlFetches = new Map();
            /**
             * Map from font identifiers to their CSS class names. Used for icon fonts.
             */
            this._fontCssClassesByAlias = new Map();
            /**
             * The CSS class to apply when an `<mat-icon>` component has no icon name, url, or font specified.
             * The default 'material-icons' value assumes that the material icon font has been loaded as
             * described at http://google.github.io/material-design-icons/#icon-font-for-the-web
             */
            this._defaultFontSetClass = 'material-icons';
            this._document = document;
        }
        /**
         * Registers an icon by URL in the default namespace.
         * @template THIS
         * @this {THIS}
         * @param {?} iconName Name under which the icon should be registered.
         * @param {?} url
         * @param {?=} options
         * @return {THIS}
         */
        MatIconRegistry.prototype.addSvgIcon = function (iconName, url, options) {
            return ( /** @type {?} */(this)).addSvgIconInNamespace('', iconName, url, options);
        };
        /**
         * Registers an icon using an HTML string in the default namespace.
         * @template THIS
         * @this {THIS}
         * @param {?} iconName Name under which the icon should be registered.
         * @param {?} literal SVG source of the icon.
         * @param {?=} options
         * @return {THIS}
         */
        MatIconRegistry.prototype.addSvgIconLiteral = function (iconName, literal, options) {
            return ( /** @type {?} */(this)).addSvgIconLiteralInNamespace('', iconName, literal, options);
        };
        /**
         * Registers an icon by URL in the specified namespace.
         * @template THIS
         * @this {THIS}
         * @param {?} namespace Namespace in which the icon should be registered.
         * @param {?} iconName Name under which the icon should be registered.
         * @param {?} url
         * @param {?=} options
         * @return {THIS}
         */
        MatIconRegistry.prototype.addSvgIconInNamespace = function (namespace, iconName, url, options) {
            return ( /** @type {?} */(this))._addSvgIconConfig(namespace, iconName, new SvgIconConfig(url, options));
        };
        /**
         * Registers an icon using an HTML string in the specified namespace.
         * @template THIS
         * @this {THIS}
         * @param {?} namespace Namespace in which the icon should be registered.
         * @param {?} iconName Name under which the icon should be registered.
         * @param {?} literal SVG source of the icon.
         * @param {?=} options
         * @return {THIS}
         */
        MatIconRegistry.prototype.addSvgIconLiteralInNamespace = function (namespace, iconName, literal, options) {
            /** @type {?} */
            var sanitizedLiteral = ( /** @type {?} */(this))._sanitizer.sanitize(SecurityContext.HTML, literal);
            if (!sanitizedLiteral) {
                throw getMatIconFailedToSanitizeLiteralError(literal);
            }
            /** @type {?} */
            var svgElement = ( /** @type {?} */(this))._createSvgElementForSingleIcon(sanitizedLiteral, options);
            return ( /** @type {?} */(this))._addSvgIconConfig(namespace, iconName, new SvgIconConfig(svgElement, options));
        };
        /**
         * Registers an icon set by URL in the default namespace.
         * @template THIS
         * @this {THIS}
         * @param {?} url
         * @param {?=} options
         * @return {THIS}
         */
        MatIconRegistry.prototype.addSvgIconSet = function (url, options) {
            return ( /** @type {?} */(this)).addSvgIconSetInNamespace('', url, options);
        };
        /**
         * Registers an icon set using an HTML string in the default namespace.
         * @template THIS
         * @this {THIS}
         * @param {?} literal SVG source of the icon set.
         * @param {?=} options
         * @return {THIS}
         */
        MatIconRegistry.prototype.addSvgIconSetLiteral = function (literal, options) {
            return ( /** @type {?} */(this)).addSvgIconSetLiteralInNamespace('', literal, options);
        };
        /**
         * Registers an icon set by URL in the specified namespace.
         * @template THIS
         * @this {THIS}
         * @param {?} namespace Namespace in which to register the icon set.
         * @param {?} url
         * @param {?=} options
         * @return {THIS}
         */
        MatIconRegistry.prototype.addSvgIconSetInNamespace = function (namespace, url, options) {
            return ( /** @type {?} */(this))._addSvgIconSetConfig(namespace, new SvgIconConfig(url, options));
        };
        /**
         * Registers an icon set using an HTML string in the specified namespace.
         * @template THIS
         * @this {THIS}
         * @param {?} namespace Namespace in which to register the icon set.
         * @param {?} literal SVG source of the icon set.
         * @param {?=} options
         * @return {THIS}
         */
        MatIconRegistry.prototype.addSvgIconSetLiteralInNamespace = function (namespace, literal, options) {
            /** @type {?} */
            var sanitizedLiteral = ( /** @type {?} */(this))._sanitizer.sanitize(SecurityContext.HTML, literal);
            if (!sanitizedLiteral) {
                throw getMatIconFailedToSanitizeLiteralError(literal);
            }
            /** @type {?} */
            var svgElement = ( /** @type {?} */(this))._svgElementFromString(sanitizedLiteral);
            return ( /** @type {?} */(this))._addSvgIconSetConfig(namespace, new SvgIconConfig(svgElement, options));
        };
        /**
         * Defines an alias for a CSS class name to be used for icon fonts. Creating an matIcon
         * component with the alias as the fontSet input will cause the class name to be applied
         * to the `<mat-icon>` element.
         *
         * @template THIS
         * @this {THIS}
         * @param {?} alias Alias for the font.
         * @param {?=} className Class name override to be used instead of the alias.
         * @return {THIS}
         */
        MatIconRegistry.prototype.registerFontClassAlias = function (alias, className) {
            if (className === void 0) { className = alias; }
            ( /** @type {?} */(this))._fontCssClassesByAlias.set(alias, className);
            return ( /** @type {?} */(this));
        };
        /**
         * Returns the CSS class name associated with the alias by a previous call to
         * registerFontClassAlias. If no CSS class has been associated, returns the alias unmodified.
         * @param {?} alias
         * @return {?}
         */
        MatIconRegistry.prototype.classNameForFontAlias = function (alias) {
            return this._fontCssClassesByAlias.get(alias) || alias;
        };
        /**
         * Sets the CSS class name to be used for icon fonts when an `<mat-icon>` component does not
         * have a fontSet input value, and is not loading an icon by name or URL.
         *
         * @template THIS
         * @this {THIS}
         * @param {?} className
         * @return {THIS}
         */
        MatIconRegistry.prototype.setDefaultFontSetClass = function (className) {
            ( /** @type {?} */(this))._defaultFontSetClass = className;
            return ( /** @type {?} */(this));
        };
        /**
         * Returns the CSS class name to be used for icon fonts when an `<mat-icon>` component does not
         * have a fontSet input value, and is not loading an icon by name or URL.
         * @return {?}
         */
        MatIconRegistry.prototype.getDefaultFontSetClass = function () {
            return this._defaultFontSetClass;
        };
        /**
         * Returns an Observable that produces the icon (as an `<svg>` DOM element) from the given URL.
         * The response from the URL may be cached so this will not always cause an HTTP request, but
         * the produced element will always be a new copy of the originally fetched icon. (That is,
         * it will not contain any modifications made to elements previously returned).
         *
         * @param {?} safeUrl URL from which to fetch the SVG icon.
         * @return {?}
         */
        MatIconRegistry.prototype.getSvgIconFromUrl = function (safeUrl) {
            var _this = this;
            /** @type {?} */
            var url = this._sanitizer.sanitize(SecurityContext.RESOURCE_URL, safeUrl);
            if (!url) {
                throw getMatIconFailedToSanitizeUrlError(safeUrl);
            }
            /** @type {?} */
            var cachedIcon = this._cachedIconsByUrl.get(url);
            if (cachedIcon) {
                return of(cloneSvg(cachedIcon));
            }
            return this._loadSvgIconFromConfig(new SvgIconConfig(safeUrl)).pipe(tap(( /**
             * @param {?} svg
             * @return {?}
             */function (/**
             * @param {?} svg
             * @return {?}
             */ svg) { return _this._cachedIconsByUrl.set(( /** @type {?} */(url)), svg); })), map(( /**
             * @param {?} svg
             * @return {?}
             */function (/**
             * @param {?} svg
             * @return {?}
             */ svg) { return cloneSvg(svg); })));
        };
        /**
         * Returns an Observable that produces the icon (as an `<svg>` DOM element) with the given name
         * and namespace. The icon must have been previously registered with addIcon or addIconSet;
         * if not, the Observable will throw an error.
         *
         * @param {?} name Name of the icon to be retrieved.
         * @param {?=} namespace Namespace in which to look for the icon.
         * @return {?}
         */
        MatIconRegistry.prototype.getNamedSvgIcon = function (name, namespace) {
            if (namespace === void 0) { namespace = ''; }
            // Return (copy of) cached icon if possible.
            /** @type {?} */
            var key = iconKey(namespace, name);
            /** @type {?} */
            var config = this._svgIconConfigs.get(key);
            if (config) {
                return this._getSvgFromConfig(config);
            }
            // See if we have any icon sets registered for the namespace.
            /** @type {?} */
            var iconSetConfigs = this._iconSetConfigs.get(namespace);
            if (iconSetConfigs) {
                return this._getSvgFromIconSetConfigs(name, iconSetConfigs);
            }
            return throwError(getMatIconNameNotFoundError(key));
        };
        /**
         * @return {?}
         */
        MatIconRegistry.prototype.ngOnDestroy = function () {
            this._svgIconConfigs.clear();
            this._iconSetConfigs.clear();
            this._cachedIconsByUrl.clear();
        };
        /**
         * Returns the cached icon for a SvgIconConfig if available, or fetches it from its URL if not.
         * @private
         * @param {?} config
         * @return {?}
         */
        MatIconRegistry.prototype._getSvgFromConfig = function (config) {
            if (config.svgElement) {
                // We already have the SVG element for this icon, return a copy.
                return of(cloneSvg(config.svgElement));
            }
            else {
                // Fetch the icon from the config's URL, cache it, and return a copy.
                return this._loadSvgIconFromConfig(config).pipe(tap(( /**
                 * @param {?} svg
                 * @return {?}
                 */function (/**
                 * @param {?} svg
                 * @return {?}
                 */ svg) { return config.svgElement = svg; })), map(( /**
                 * @param {?} svg
                 * @return {?}
                 */function (/**
                 * @param {?} svg
                 * @return {?}
                 */ svg) { return cloneSvg(svg); })));
            }
        };
        /**
         * Attempts to find an icon with the specified name in any of the SVG icon sets.
         * First searches the available cached icons for a nested element with a matching name, and
         * if found copies the element to a new `<svg>` element. If not found, fetches all icon sets
         * that have not been cached, and searches again after all fetches are completed.
         * The returned Observable produces the SVG element if possible, and throws
         * an error if no icon with the specified name can be found.
         * @private
         * @param {?} name
         * @param {?} iconSetConfigs
         * @return {?}
         */
        MatIconRegistry.prototype._getSvgFromIconSetConfigs = function (name, iconSetConfigs) {
            var _this = this;
            // For all the icon set SVG elements we've fetched, see if any contain an icon with the
            // requested name.
            /** @type {?} */
            var namedIcon = this._extractIconWithNameFromAnySet(name, iconSetConfigs);
            if (namedIcon) {
                // We could cache namedIcon in _svgIconConfigs, but since we have to make a copy every
                // time anyway, there's probably not much advantage compared to just always extracting
                // it from the icon set.
                return of(namedIcon);
            }
            // Not found in any cached icon sets. If there are icon sets with URLs that we haven't
            // fetched, fetch them now and look for iconName in the results.
            /** @type {?} */
            var iconSetFetchRequests = iconSetConfigs
                .filter(( /**
         * @param {?} iconSetConfig
         * @return {?}
         */function (/**
         * @param {?} iconSetConfig
         * @return {?}
         */ iconSetConfig) { return !iconSetConfig.svgElement; }))
                .map(( /**
         * @param {?} iconSetConfig
         * @return {?}
         */function (/**
         * @param {?} iconSetConfig
         * @return {?}
         */ iconSetConfig) {
                return _this._loadSvgIconSetFromConfig(iconSetConfig).pipe(catchError(( /**
                 * @param {?} err
                 * @return {?}
                 */function (err) {
                    /** @type {?} */
                    var url = _this._sanitizer.sanitize(SecurityContext.RESOURCE_URL, iconSetConfig.url);
                    // Swallow errors fetching individual URLs so the
                    // combined Observable won't necessarily fail.
                    /** @type {?} */
                    var errorMessage = "Loading icon set URL: " + url + " failed: " + err.message;
                    // @breaking-change 9.0.0 _errorHandler parameter to be made required
                    if (_this._errorHandler) {
                        _this._errorHandler.handleError(new Error(errorMessage));
                    }
                    else {
                        console.error(errorMessage);
                    }
                    return of(null);
                })));
            }));
            // Fetch all the icon set URLs. When the requests complete, every IconSet should have a
            // cached SVG element (unless the request failed), and we can check again for the icon.
            return forkJoin(iconSetFetchRequests).pipe(map(( /**
             * @return {?}
             */function () {
                /** @type {?} */
                var foundIcon = _this._extractIconWithNameFromAnySet(name, iconSetConfigs);
                if (!foundIcon) {
                    throw getMatIconNameNotFoundError(name);
                }
                return foundIcon;
            })));
        };
        /**
         * Searches the cached SVG elements for the given icon sets for a nested icon element whose "id"
         * tag matches the specified name. If found, copies the nested element to a new SVG element and
         * returns it. Returns null if no matching element is found.
         * @private
         * @param {?} iconName
         * @param {?} iconSetConfigs
         * @return {?}
         */
        MatIconRegistry.prototype._extractIconWithNameFromAnySet = function (iconName, iconSetConfigs) {
            // Iterate backwards, so icon sets added later have precedence.
            for (var i_174 = iconSetConfigs.length - 1; i_174 >= 0; i_174--) {
                /** @type {?} */
                var config_3 = iconSetConfigs[i_174];
                if (config_3.svgElement) {
                    /** @type {?} */
                    var foundIcon = this._extractSvgIconFromSet(config_3.svgElement, iconName, config_3.options);
                    if (foundIcon) {
                        return foundIcon;
                    }
                }
            }
            return null;
        };
        /**
         * Loads the content of the icon URL specified in the SvgIconConfig and creates an SVG element
         * from it.
         * @private
         * @param {?} config
         * @return {?}
         */
        MatIconRegistry.prototype._loadSvgIconFromConfig = function (config) {
            var _this = this;
            return this._fetchUrl(config.url)
                .pipe(map(( /**
         * @param {?} svgText
         * @return {?}
         */function (/**
         * @param {?} svgText
         * @return {?}
         */ svgText) { return _this._createSvgElementForSingleIcon(svgText, config.options); })));
        };
        /**
         * Loads the content of the icon set URL specified in the SvgIconConfig and creates an SVG element
         * from it.
         * @private
         * @param {?} config
         * @return {?}
         */
        MatIconRegistry.prototype._loadSvgIconSetFromConfig = function (config) {
            var _this = this;
            // If the SVG for this icon set has already been parsed, do nothing.
            if (config.svgElement) {
                return of(config.svgElement);
            }
            return this._fetchUrl(config.url).pipe(map(( /**
             * @param {?} svgText
             * @return {?}
             */function (/**
             * @param {?} svgText
             * @return {?}
             */ svgText) {
                // It is possible that the icon set was parsed and cached by an earlier request, so parsing
                // only needs to occur if the cache is yet unset.
                if (!config.svgElement) {
                    config.svgElement = _this._svgElementFromString(svgText);
                }
                return config.svgElement;
            })));
        };
        /**
         * Creates a DOM element from the given SVG string, and adds default attributes.
         * @private
         * @param {?} responseText
         * @param {?=} options
         * @return {?}
         */
        MatIconRegistry.prototype._createSvgElementForSingleIcon = function (responseText, options) {
            /** @type {?} */
            var svg = this._svgElementFromString(responseText);
            this._setSvgAttributes(svg, options);
            return svg;
        };
        /**
         * Searches the cached element of the given SvgIconConfig for a nested icon element whose "id"
         * tag matches the specified name. If found, copies the nested element to a new SVG element and
         * returns it. Returns null if no matching element is found.
         * @private
         * @param {?} iconSet
         * @param {?} iconName
         * @param {?=} options
         * @return {?}
         */
        MatIconRegistry.prototype._extractSvgIconFromSet = function (iconSet, iconName, options) {
            // Use the `id="iconName"` syntax in order to escape special
            // characters in the ID (versus using the #iconName syntax).
            /** @type {?} */
            var iconSource = iconSet.querySelector("[id=\"" + iconName + "\"]");
            if (!iconSource) {
                return null;
            }
            // Clone the element and remove the ID to prevent multiple elements from being added
            // to the page with the same ID.
            /** @type {?} */
            var iconElement = ( /** @type {?} */(iconSource.cloneNode(true)));
            iconElement.removeAttribute('id');
            // If the icon node is itself an <svg> node, clone and return it directly. If not, set it as
            // the content of a new <svg> node.
            if (iconElement.nodeName.toLowerCase() === 'svg') {
                return this._setSvgAttributes(( /** @type {?} */(iconElement)), options);
            }
            // If the node is a <symbol>, it won't be rendered so we have to convert it into <svg>. Note
            // that the same could be achieved by referring to it via <use href="#id">, however the <use>
            // tag is problematic on Firefox, because it needs to include the current page path.
            if (iconElement.nodeName.toLowerCase() === 'symbol') {
                return this._setSvgAttributes(this._toSvgElement(iconElement), options);
            }
            // createElement('SVG') doesn't work as expected; the DOM ends up with
            // the correct nodes, but the SVG content doesn't render. Instead we
            // have to create an empty SVG node using innerHTML and append its content.
            // Elements created using DOMParser.parseFromString have the same problem.
            // http://stackoverflow.com/questions/23003278/svg-innerhtml-in-firefox-can-not-display
            /** @type {?} */
            var svg = this._svgElementFromString('<svg></svg>');
            // Clone the node so we don't remove it from the parent icon set element.
            svg.appendChild(iconElement);
            return this._setSvgAttributes(svg, options);
        };
        /**
         * Creates a DOM element from the given SVG string.
         * @private
         * @param {?} str
         * @return {?}
         */
        MatIconRegistry.prototype._svgElementFromString = function (str) {
            /** @type {?} */
            var div = this._document.createElement('DIV');
            div.innerHTML = str;
            /** @type {?} */
            var svg = ( /** @type {?} */(div.querySelector('svg')));
            if (!svg) {
                throw Error('<svg> tag not found');
            }
            return svg;
        };
        /**
         * Converts an element into an SVG node by cloning all of its children.
         * @private
         * @param {?} element
         * @return {?}
         */
        MatIconRegistry.prototype._toSvgElement = function (element) {
            /** @type {?} */
            var svg = this._svgElementFromString('<svg></svg>');
            /** @type {?} */
            var attributes = element.attributes;
            // Copy over all the attributes from the `symbol` to the new SVG, except the id.
            for (var i_175 = 0; i_175 < attributes.length; i_175++) {
                var _b = attributes[i_175], name_6 = _b.name, value = _b.value;
                if (name_6 !== 'id') {
                    svg.setAttribute(name_6, value);
                }
            }
            for (var i_176 = 0; i_176 < element.childNodes.length; i_176++) {
                if (element.childNodes[i_176].nodeType === this._document.ELEMENT_NODE) {
                    svg.appendChild(element.childNodes[i_176].cloneNode(true));
                }
            }
            return svg;
        };
        /**
         * Sets the default attributes for an SVG element to be used as an icon.
         * @private
         * @param {?} svg
         * @param {?=} options
         * @return {?}
         */
        MatIconRegistry.prototype._setSvgAttributes = function (svg, options) {
            svg.setAttribute('fit', '');
            svg.setAttribute('height', '100%');
            svg.setAttribute('width', '100%');
            svg.setAttribute('preserveAspectRatio', 'xMidYMid meet');
            svg.setAttribute('focusable', 'false'); // Disable IE11 default behavior to make SVGs focusable.
            if (options && options.viewBox) {
                svg.setAttribute('viewBox', options.viewBox);
            }
            return svg;
        };
        /**
         * Returns an Observable which produces the string contents of the given URL. Results may be
         * cached, so future calls with the same URL may not cause another HTTP request.
         * @private
         * @param {?} safeUrl
         * @return {?}
         */
        MatIconRegistry.prototype._fetchUrl = function (safeUrl) {
            var _this = this;
            if (!this._httpClient) {
                throw getMatIconNoHttpProviderError();
            }
            if (safeUrl == null) {
                throw Error("Cannot fetch icon from URL \"" + safeUrl + "\".");
            }
            /** @type {?} */
            var url = this._sanitizer.sanitize(SecurityContext.RESOURCE_URL, safeUrl);
            if (!url) {
                throw getMatIconFailedToSanitizeUrlError(safeUrl);
            }
            // Store in-progress fetches to avoid sending a duplicate request for a URL when there is
            // already a request in progress for that URL. It's necessary to call share() on the
            // Observable returned by http.get() so that multiple subscribers don't cause multiple XHRs.
            /** @type {?} */
            var inProgressFetch = this._inProgressUrlFetches.get(url);
            if (inProgressFetch) {
                return inProgressFetch;
            }
            // TODO(jelbourn): for some reason, the `finalize` operator "loses" the generic type on the
            // Observable. Figure out why and fix it.
            /** @type {?} */
            var req = this._httpClient.get(url, { responseType: 'text' }).pipe(finalize(( /**
             * @return {?}
             */function () { return _this._inProgressUrlFetches.delete(url); })), share());
            this._inProgressUrlFetches.set(url, req);
            return req;
        };
        /**
         * Registers an icon config by name in the specified namespace.
         * @private
         * @template THIS
         * @this {THIS}
         * @param {?} namespace Namespace in which to register the icon config.
         * @param {?} iconName Name under which to register the config.
         * @param {?} config Config to be registered.
         * @return {THIS}
         */
        MatIconRegistry.prototype._addSvgIconConfig = function (namespace, iconName, config) {
            ( /** @type {?} */(this))._svgIconConfigs.set(iconKey(namespace, iconName), config);
            return ( /** @type {?} */(this));
        };
        /**
         * Registers an icon set config in the specified namespace.
         * @private
         * @template THIS
         * @this {THIS}
         * @param {?} namespace Namespace in which to register the icon config.
         * @param {?} config Config to be registered.
         * @return {THIS}
         */
        MatIconRegistry.prototype._addSvgIconSetConfig = function (namespace, config) {
            /** @type {?} */
            var configNamespace = ( /** @type {?} */(this))._iconSetConfigs.get(namespace);
            if (configNamespace) {
                configNamespace.push(config);
            }
            else {
                ( /** @type {?} */(this))._iconSetConfigs.set(namespace, [config]);
            }
            return ( /** @type {?} */(this));
        };
        return MatIconRegistry;
    }());
    MatIconRegistry.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] },
    ];
    /** @nocollapse */
    MatIconRegistry.ctorParameters = function () { return [
        { type: HttpClient, decorators: [{ type: Optional }] },
        { type: DomSanitizer },
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [DOCUMENT,] }] },
        { type: ErrorHandler, decorators: [{ type: Optional }] }
    ]; };
    /** @nocollapse */ MatIconRegistry.ngInjectableDef = ɵɵdefineInjectable({ factory: function MatIconRegistry_Factory() { return new MatIconRegistry(ɵɵinject(HttpClient, 8), ɵɵinject(DomSanitizer), ɵɵinject(DOCUMENT, 8), ɵɵinject(ErrorHandler, 8)); }, token: MatIconRegistry, providedIn: "root" });
    /**
     * \@docs-private
     * @param {?} parentRegistry
     * @param {?} httpClient
     * @param {?} sanitizer
     * @param {?=} document
     * @param {?=} errorHandler
     * @return {?}
     */
    function ICON_REGISTRY_PROVIDER_FACTORY(parentRegistry, httpClient, sanitizer, document, errorHandler) {
        return parentRegistry || new MatIconRegistry(httpClient, sanitizer, document, errorHandler);
    }
    /**
     * \@docs-private
     * @type {?}
     */
    var ICON_REGISTRY_PROVIDER = {
        // If there is already an MatIconRegistry available, use that. Otherwise, provide a new one.
        provide: MatIconRegistry,
        deps: [
            [new Optional(), new SkipSelf(), MatIconRegistry],
            [new Optional(), HttpClient],
            DomSanitizer,
            [new Optional(), ErrorHandler],
            [new Optional(), ( /** @type {?} */(DOCUMENT))],
        ],
        useFactory: ICON_REGISTRY_PROVIDER_FACTORY,
    };
    /**
     * Clones an SVGElement while preserving type information.
     * @param {?} svg
     * @return {?}
     */
    function cloneSvg(svg) {
        return ( /** @type {?} */(svg.cloneNode(true)));
    }
    /**
     * Returns the cache key to use for an icon namespace and name.
     * @param {?} namespace
     * @param {?} name
     * @return {?}
     */
    function iconKey(namespace, name) {
        return namespace + ':' + name;
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // Boilerplate for applying mixins to MatIcon.
    /**
     * \@docs-private
     */
    var MatIconBase = /** @class */ (function () {
        /**
         * @param {?} _elementRef
         */
        function MatIconBase(_elementRef) {
            this._elementRef = _elementRef;
        }
        return MatIconBase;
    }());
    /** @type {?} */
    var _MatIconMixinBase = mixinColor(MatIconBase);
    /**
     * Injection token used to provide the current location to `MatIcon`.
     * Used to handle server-side rendering and to stub out during unit tests.
     * \@docs-private
     * @type {?}
     */
    var MAT_ICON_LOCATION = new InjectionToken('mat-icon-location', {
        providedIn: 'root',
        factory: MAT_ICON_LOCATION_FACTORY
    });
    /**
     * \@docs-private
     * @return {?}
     */
    function MAT_ICON_LOCATION_FACTORY() {
        /** @type {?} */
        var _document = inject(DOCUMENT);
        /** @type {?} */
        var _location = _document ? _document.location : null;
        return {
            // Note that this needs to be a function, rather than a property, because Angular
            // will only resolve it once, but we want the current path on each call.
            getPathname: ( /**
             * @return {?}
             */function () { return _location ? (_location.pathname + _location.search) : ''; })
        };
    }
    /**
     * SVG attributes that accept a FuncIRI (e.g. `url(<something>)`).
     * @type {?}
     */
    var funcIriAttributes = [
        'clip-path',
        'color-profile',
        'src',
        'cursor',
        'fill',
        'filter',
        'marker',
        'marker-start',
        'marker-mid',
        'marker-end',
        'mask',
        'stroke'
    ];
    var ɵ0$j = /**
     * @param {?} attr
     * @return {?}
     */ function (/**
     * @param {?} attr
     * @return {?}
     */ attr) { return "[" + attr + "]"; };
    /**
     * Selector that can be used to find all elements that are using a `FuncIRI`.
     * @type {?}
     */
    var funcIriAttributeSelector = funcIriAttributes.map((ɵ0$j)).join(', ');
    /**
     * Regex that can be used to extract the id out of a FuncIRI.
     * @type {?}
     */
    var funcIriPattern = /^url\(['"]?#(.*?)['"]?\)$/;
    /**
     * Component to display an icon. It can be used in the following ways:
     *
     * - Specify the svgIcon input to load an SVG icon from a URL previously registered with the
     *   addSvgIcon, addSvgIconInNamespace, addSvgIconSet, or addSvgIconSetInNamespace methods of
     *   MatIconRegistry. If the svgIcon value contains a colon it is assumed to be in the format
     *   "[namespace]:[name]", if not the value will be the name of an icon in the default namespace.
     *   Examples:
     *     `<mat-icon svgIcon="left-arrow"></mat-icon>
     *     <mat-icon svgIcon="animals:cat"></mat-icon>`
     *
     * - Use a font ligature as an icon by putting the ligature text in the content of the `<mat-icon>`
     *   component. By default the Material icons font is used as described at
     *   http://google.github.io/material-design-icons/#icon-font-for-the-web. You can specify an
     *   alternate font by setting the fontSet input to either the CSS class to apply to use the
     *   desired font, or to an alias previously registered with MatIconRegistry.registerFontClassAlias.
     *   Examples:
     *     `<mat-icon>home</mat-icon>
     *     <mat-icon fontSet="myfont">sun</mat-icon>`
     *
     * - Specify a font glyph to be included via CSS rules by setting the fontSet input to specify the
     *   font, and the fontIcon input to specify the icon. Typically the fontIcon will specify a
     *   CSS class which causes the glyph to be displayed via a :before selector, as in
     *   https://fortawesome.github.io/Font-Awesome/examples/
     *   Example:
     *     `<mat-icon fontSet="fa" fontIcon="alarm"></mat-icon>`
     */
    var MatIcon = /** @class */ (function (_super) {
        __extends(MatIcon, _super);
        /**
         * @param {?} elementRef
         * @param {?} _iconRegistry
         * @param {?} ariaHidden
         * @param {?=} _location
         * @param {?=} _errorHandler
         */
        function MatIcon(elementRef, _iconRegistry, ariaHidden, _location, _errorHandler) {
            var _this = _super.call(this, elementRef) || this;
            _this._iconRegistry = _iconRegistry;
            _this._location = _location;
            _this._errorHandler = _errorHandler;
            _this._inline = false;
            // If the user has not explicitly set aria-hidden, mark the icon as hidden, as this is
            // the right thing to do for the majority of icon use-cases.
            if (!ariaHidden) {
                elementRef.nativeElement.setAttribute('aria-hidden', 'true');
            }
            return _this;
        }
        Object.defineProperty(MatIcon.prototype, "inline", {
            /**
             * Whether the icon should be inlined, automatically sizing the icon to match the font size of
             * the element the icon is contained in.
             * @return {?}
             */
            get: function () {
                return this._inline;
            },
            /**
             * @param {?} inline
             * @return {?}
             */
            set: function (inline) {
                this._inline = coerceBooleanProperty(inline);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatIcon.prototype, "fontSet", {
            /**
             * Font set that the icon is a part of.
             * @return {?}
             */
            get: function () { return this._fontSet; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._fontSet = this._cleanupFontValue(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatIcon.prototype, "fontIcon", {
            /**
             * Name of an icon within a font set.
             * @return {?}
             */
            get: function () { return this._fontIcon; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._fontIcon = this._cleanupFontValue(value);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Splits an svgIcon binding value into its icon set and icon name components.
         * Returns a 2-element array of [(icon set), (icon name)].
         * The separator for the two fields is ':'. If there is no separator, an empty
         * string is returned for the icon set and the entire value is returned for
         * the icon name. If the argument is falsy, returns an array of two empty strings.
         * Throws an error if the name contains two or more ':' separators.
         * Examples:
         *   `'social:cake' -> ['social', 'cake']
         *   'penguin' -> ['', 'penguin']
         *   null -> ['', '']
         *   'a:b:c' -> (throws Error)`
         * @private
         * @param {?} iconName
         * @return {?}
         */
        MatIcon.prototype._splitIconName = function (iconName) {
            if (!iconName) {
                return ['', ''];
            }
            /** @type {?} */
            var parts = iconName.split(':');
            switch (parts.length) {
                case 1: return ['', parts[0]]; // Use default namespace.
                case 2: return ( /** @type {?} */(parts));
                default: throw Error("Invalid icon name: \"" + iconName + "\"");
            }
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        MatIcon.prototype.ngOnChanges = function (changes) {
            var _this = this;
            // Only update the inline SVG icon if the inputs changed, to avoid unnecessary DOM operations.
            /** @type {?} */
            var svgIconChanges = changes['svgIcon'];
            if (svgIconChanges) {
                if (this.svgIcon) {
                    var _b = __read(this._splitIconName(this.svgIcon), 2), namespace_1 = _b[0], iconName_1 = _b[1];
                    this._iconRegistry.getNamedSvgIcon(iconName_1, namespace_1)
                        .pipe(take(1))
                        .subscribe(( /**
                 * @param {?} svg
                 * @return {?}
                 */function (/**
                 * @param {?} svg
                 * @return {?}
                 */ svg) { return _this._setSvgElement(svg); }), ( /**
                     * @param {?} err
                     * @return {?}
                     */function (err) {
                        /** @type {?} */
                        var errorMessage = "Error retrieving icon " + namespace_1 + ":" + iconName_1 + "! " + err.message;
                        // @breaking-change 9.0.0 _errorHandler parameter to be made required.
                        if (_this._errorHandler) {
                            _this._errorHandler.handleError(new Error(errorMessage));
                        }
                        else {
                            console.error(errorMessage);
                        }
                    }));
                }
                else if (svgIconChanges.previousValue) {
                    this._clearSvgElement();
                }
            }
            if (this._usingFontIcon()) {
                this._updateFontIconClasses();
            }
        };
        /**
         * @return {?}
         */
        MatIcon.prototype.ngOnInit = function () {
            // Update font classes because ngOnChanges won't be called if none of the inputs are present,
            // e.g. <mat-icon>arrow</mat-icon> In this case we need to add a CSS class for the default font.
            if (this._usingFontIcon()) {
                this._updateFontIconClasses();
            }
        };
        /**
         * @return {?}
         */
        MatIcon.prototype.ngAfterViewChecked = function () {
            /** @type {?} */
            var cachedElements = this._elementsWithExternalReferences;
            if (cachedElements && this._location && cachedElements.size) {
                /** @type {?} */
                var newPath = this._location.getPathname();
                // We need to check whether the URL has changed on each change detection since
                // the browser doesn't have an API that will let us react on link clicks and
                // we can't depend on the Angular router. The references need to be updated,
                // because while most browsers don't care whether the URL is correct after
                // the first render, Safari will break if the user navigates to a different
                // page and the SVG isn't re-rendered.
                if (newPath !== this._previousPath) {
                    this._previousPath = newPath;
                    this._prependPathToReferences(newPath);
                }
            }
        };
        /**
         * @return {?}
         */
        MatIcon.prototype.ngOnDestroy = function () {
            if (this._elementsWithExternalReferences) {
                this._elementsWithExternalReferences.clear();
            }
        };
        /**
         * @private
         * @return {?}
         */
        MatIcon.prototype._usingFontIcon = function () {
            return !this.svgIcon;
        };
        /**
         * @private
         * @param {?} svg
         * @return {?}
         */
        MatIcon.prototype._setSvgElement = function (svg) {
            this._clearSvgElement();
            // Workaround for IE11 and Edge ignoring `style` tags inside dynamically-created SVGs.
            // See: https://developer.microsoft.com/en-us/microsoft-edge/platform/issues/10898469/
            // Do this before inserting the element into the DOM, in order to avoid a style recalculation.
            /** @type {?} */
            var styleTags = ( /** @type {?} */(svg.querySelectorAll('style')));
            for (var i_177 = 0; i_177 < styleTags.length; i_177++) {
                styleTags[i_177].textContent += ' ';
            }
            // Note: we do this fix here, rather than the icon registry, because the
            // references have to point to the URL at the time that the icon was created.
            if (this._location) {
                /** @type {?} */
                var path = this._location.getPathname();
                this._previousPath = path;
                this._cacheChildrenWithExternalReferences(svg);
                this._prependPathToReferences(path);
            }
            this._elementRef.nativeElement.appendChild(svg);
        };
        /**
         * @private
         * @return {?}
         */
        MatIcon.prototype._clearSvgElement = function () {
            /** @type {?} */
            var layoutElement = this._elementRef.nativeElement;
            /** @type {?} */
            var childCount = layoutElement.childNodes.length;
            if (this._elementsWithExternalReferences) {
                this._elementsWithExternalReferences.clear();
            }
            // Remove existing non-element child nodes and SVGs, and add the new SVG element. Note that
            // we can't use innerHTML, because IE will throw if the element has a data binding.
            while (childCount--) {
                /** @type {?} */
                var child = layoutElement.childNodes[childCount];
                // 1 corresponds to Node.ELEMENT_NODE. We remove all non-element nodes in order to get rid
                // of any loose text nodes, as well as any SVG elements in order to remove any old icons.
                if (child.nodeType !== 1 || child.nodeName.toLowerCase() === 'svg') {
                    layoutElement.removeChild(child);
                }
            }
        };
        /**
         * @private
         * @return {?}
         */
        MatIcon.prototype._updateFontIconClasses = function () {
            if (!this._usingFontIcon()) {
                return;
            }
            /** @type {?} */
            var elem = this._elementRef.nativeElement;
            /** @type {?} */
            var fontSetClass = this.fontSet ?
                this._iconRegistry.classNameForFontAlias(this.fontSet) :
                this._iconRegistry.getDefaultFontSetClass();
            if (fontSetClass != this._previousFontSetClass) {
                if (this._previousFontSetClass) {
                    elem.classList.remove(this._previousFontSetClass);
                }
                if (fontSetClass) {
                    elem.classList.add(fontSetClass);
                }
                this._previousFontSetClass = fontSetClass;
            }
            if (this.fontIcon != this._previousFontIconClass) {
                if (this._previousFontIconClass) {
                    elem.classList.remove(this._previousFontIconClass);
                }
                if (this.fontIcon) {
                    elem.classList.add(this.fontIcon);
                }
                this._previousFontIconClass = this.fontIcon;
            }
        };
        /**
         * Cleans up a value to be used as a fontIcon or fontSet.
         * Since the value ends up being assigned as a CSS class, we
         * have to trim the value and omit space-separated values.
         * @private
         * @param {?} value
         * @return {?}
         */
        MatIcon.prototype._cleanupFontValue = function (value) {
            return typeof value === 'string' ? value.trim().split(' ')[0] : value;
        };
        /**
         * Prepends the current path to all elements that have an attribute pointing to a `FuncIRI`
         * reference. This is required because WebKit browsers require references to be prefixed with
         * the current path, if the page has a `base` tag.
         * @private
         * @param {?} path
         * @return {?}
         */
        MatIcon.prototype._prependPathToReferences = function (path) {
            /** @type {?} */
            var elements = this._elementsWithExternalReferences;
            if (elements) {
                elements.forEach(( /**
                 * @param {?} attrs
                 * @param {?} element
                 * @return {?}
                 */function (attrs, element) {
                    attrs.forEach(( /**
                     * @param {?} attr
                     * @return {?}
                     */function (/**
                     * @param {?} attr
                     * @return {?}
                     */ attr) {
                        element.setAttribute(attr.name, "url('" + path + "#" + attr.value + "')");
                    }));
                }));
            }
        };
        /**
         * Caches the children of an SVG element that have `url()`
         * references that we need to prefix with the current path.
         * @private
         * @param {?} element
         * @return {?}
         */
        MatIcon.prototype._cacheChildrenWithExternalReferences = function (element) {
            /** @type {?} */
            var elementsWithFuncIri = element.querySelectorAll(funcIriAttributeSelector);
            /** @type {?} */
            var elements = this._elementsWithExternalReferences =
                this._elementsWithExternalReferences || new Map();
            var _loop_6 = function (i_178) {
                funcIriAttributes.forEach(( /**
                 * @param {?} attr
                 * @return {?}
                 */function (/**
                 * @param {?} attr
                 * @return {?}
                 */ attr) {
                    /** @type {?} */
                    var elementWithReference = elementsWithFuncIri[i_178];
                    /** @type {?} */
                    var value = elementWithReference.getAttribute(attr);
                    /** @type {?} */
                    var match = value ? value.match(funcIriPattern) : null;
                    if (match) {
                        /** @type {?} */
                        var attributes = elements.get(elementWithReference);
                        if (!attributes) {
                            attributes = [];
                            elements.set(elementWithReference, attributes);
                        }
                        ( /** @type {?} */(attributes)).push({ name: attr, value: match[1] });
                    }
                }));
            };
            for (var i_178 = 0; i_178 < elementsWithFuncIri.length; i_178++) {
                _loop_6(i_178);
            }
        };
        return MatIcon;
    }(_MatIconMixinBase));
    MatIcon.decorators = [
        { type: Component, args: [{ template: '<ng-content></ng-content>',
                    selector: 'mat-icon',
                    exportAs: 'matIcon',
                    styles: [".mat-icon{background-repeat:no-repeat;display:inline-block;fill:currentColor;height:24px;width:24px}.mat-icon.mat-icon-inline{font-size:inherit;height:inherit;line-height:inherit;width:inherit}[dir=rtl] .mat-icon-rtl-mirror{transform:scale(-1,1)}.mat-form-field:not(.mat-form-field-appearance-legacy) .mat-form-field-prefix .mat-icon,.mat-form-field:not(.mat-form-field-appearance-legacy) .mat-form-field-suffix .mat-icon{display:block}.mat-form-field:not(.mat-form-field-appearance-legacy) .mat-form-field-prefix .mat-icon-button .mat-icon,.mat-form-field:not(.mat-form-field-appearance-legacy) .mat-form-field-suffix .mat-icon-button .mat-icon{margin:auto}"],
                    inputs: ['color'],
                    host: {
                        'role': 'img',
                        'class': 'mat-icon notranslate',
                        '[class.mat-icon-inline]': 'inline',
                        '[class.mat-icon-no-color]': 'color !== "primary" && color !== "accent" && color !== "warn"',
                    },
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                },] },
    ];
    /** @nocollapse */
    MatIcon.ctorParameters = function () { return [
        { type: ElementRef },
        { type: MatIconRegistry },
        { type: String, decorators: [{ type: Attribute, args: ['aria-hidden',] }] },
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [MAT_ICON_LOCATION,] }] },
        { type: ErrorHandler, decorators: [{ type: Optional }] }
    ]; };
    MatIcon.propDecorators = {
        inline: [{ type: Input }],
        svgIcon: [{ type: Input }],
        fontSet: [{ type: Input }],
        fontIcon: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatIconModule = /** @class */ (function () {
        function MatIconModule() {
        }
        return MatIconModule;
    }());
    MatIconModule.decorators = [
        { type: NgModule, args: [{
                    imports: [MatCommonModule],
                    exports: [MatIcon, MatCommonModule],
                    declarations: [MatIcon],
                },] },
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A 'Export as CSV' button component.
     */
    var ExportAsCsv = /** @class */ (function () {
        /**
         * @param {?} store
         */
        function ExportAsCsv(store) {
            this.store = store;
            /**
             * The name of tool.
             */
            this.tool = '';
        }
        /**
         * @return {?}
         */
        ExportAsCsv.prototype.exportDataAsCSV = function () {
            this.store.dispatch(clearExportAsCsvStateAction());
            this.store.dispatch(setExportAsCsvStateAction({ exportAsCsv: this.tool }));
        };
        return ExportAsCsv;
    }());
    ExportAsCsv.decorators = [
        { type: Component, args: [{
                    selector: 'export-as-csv',
                    template: "<div class=\"save-button\" (click)=\"exportDataAsCSV()\">\n  <mat-icon>save_alt</mat-icon>\n  <div class=\"mat-title\">Export as CSV</div>\n</div>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}.save-button{padding-top:8px;text-align:center;width:130px}.save-button:hover{color:#777;cursor:pointer}\n"]
                }] }
    ];
    /** @nocollapse */
    ExportAsCsv.ctorParameters = function () { return [
        { type: Store }
    ]; };
    ExportAsCsv.propDecorators = {
        tool: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A export-to-csv button module.
     */
    var ExportAsCsvModule = /** @class */ (function () {
        function ExportAsCsvModule() {
        }
        return ExportAsCsvModule;
    }());
    ExportAsCsvModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [ExportAsCsv],
                    imports: [
                        CommonModule,
                        MatIconModule,
                    ],
                    exports: [ExportAsCsv],
                },] }
    ];
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Visually, a 30px separation between tick marks looks best. This is very subjective but it is
     * the default separation we chose.
     * @type {?}
     */
    var MIN_AUTO_TICK_SEPARATION = 30;
    /**
     * The thumb gap size for a disabled slider.
     * @type {?}
     */
    var DISABLED_THUMB_GAP = 7;
    /**
     * The thumb gap size for a non-active slider at its minimum value.
     * @type {?}
     */
    var MIN_VALUE_NONACTIVE_THUMB_GAP = 7;
    /**
     * The thumb gap size for an active slider at its minimum value.
     * @type {?}
     */
    var MIN_VALUE_ACTIVE_THUMB_GAP = 10;
    /**
     * Provider Expression that allows mat-slider to register as a ControlValueAccessor.
     * This allows it to support [(ngModel)] and [formControl].
     * \@docs-private
     * @type {?}
     */
    var MAT_SLIDER_VALUE_ACCESSOR = {
        provide: NG_VALUE_ACCESSOR,
        useExisting: forwardRef(( /**
         * @return {?}
         */function () { return MatSlider; })),
        multi: true
    };
    /**
     * A simple change event emitted by the MatSlider component.
     */
    var MatSliderChange = /** @class */ (function () {
        function MatSliderChange() {
        }
        return MatSliderChange;
    }());
    // Boilerplate for applying mixins to MatSlider.
    /**
     * \@docs-private
     */
    var MatSliderBase = /** @class */ (function () {
        /**
         * @param {?} _elementRef
         */
        function MatSliderBase(_elementRef) {
            this._elementRef = _elementRef;
        }
        return MatSliderBase;
    }());
    /** @type {?} */
    var _MatSliderMixinBase = mixinTabIndex(mixinColor(mixinDisabled(MatSliderBase), 'accent'));
    /**
     * Allows users to select from a range of values by moving the slider thumb. It is similar in
     * behavior to the native `<input type="range">` element.
     */
    var MatSlider = /** @class */ (function (_super) {
        __extends(MatSlider, _super);
        /**
         * @param {?} elementRef
         * @param {?} _focusMonitor
         * @param {?} _changeDetectorRef
         * @param {?} _dir
         * @param {?} tabIndex
         * @param {?=} _animationMode
         */
        function MatSlider(elementRef, _focusMonitor, _changeDetectorRef, _dir, tabIndex, _animationMode) {
            var _this = _super.call(this, elementRef) || this;
            _this._focusMonitor = _focusMonitor;
            _this._changeDetectorRef = _changeDetectorRef;
            _this._dir = _dir;
            _this._animationMode = _animationMode;
            _this._invert = false;
            _this._max = 100;
            _this._min = 0;
            _this._step = 1;
            _this._thumbLabel = false;
            _this._tickInterval = 0;
            _this._value = null;
            _this._vertical = false;
            /**
             * Event emitted when the slider value has changed.
             */
            _this.change = new EventEmitter();
            /**
             * Event emitted when the slider thumb moves.
             */
            _this.input = new EventEmitter();
            /**
             * Emits when the raw value of the slider changes. This is here primarily
             * to facilitate the two-way binding for the `value` input.
             * \@docs-private
             */
            _this.valueChange = new EventEmitter();
            /**
             * onTouch function registered via registerOnTouch (ControlValueAccessor).
             */
            _this.onTouched = ( /**
             * @return {?}
             */function () { });
            _this._percent = 0;
            /**
             * Whether or not the thumb is sliding.
             * Used to determine if there should be a transition for the thumb and fill track.
             */
            _this._isSliding = false;
            /**
             * Whether or not the slider is active (clicked or sliding).
             * Used to shrink and grow the thumb as according to the Material Design spec.
             */
            _this._isActive = false;
            /**
             * The size of a tick interval as a percentage of the size of the track.
             */
            _this._tickIntervalPercent = 0;
            /**
             * The dimensions of the slider.
             */
            _this._sliderDimensions = null;
            _this._controlValueAccessorChangeFn = ( /**
             * @return {?}
             */function () { });
            /**
             * Subscription to the Directionality change EventEmitter.
             */
            _this._dirChangeSubscription = Subscription.EMPTY;
            _this.tabIndex = parseInt(tabIndex) || 0;
            return _this;
        }
        Object.defineProperty(MatSlider.prototype, "invert", {
            /**
             * Whether the slider is inverted.
             * @return {?}
             */
            get: function () { return this._invert; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._invert = coerceBooleanProperty(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatSlider.prototype, "max", {
            /**
             * The maximum value that the slider can have.
             * @return {?}
             */
            get: function () { return this._max; },
            /**
             * @param {?} v
             * @return {?}
             */
            set: function (v) {
                this._max = coerceNumberProperty(v, this._max);
                this._percent = this._calculatePercentage(this._value);
                // Since this also modifies the percentage, we need to let the change detection know.
                this._changeDetectorRef.markForCheck();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatSlider.prototype, "min", {
            /**
             * The minimum value that the slider can have.
             * @return {?}
             */
            get: function () { return this._min; },
            /**
             * @param {?} v
             * @return {?}
             */
            set: function (v) {
                this._min = coerceNumberProperty(v, this._min);
                // If the value wasn't explicitly set by the user, set it to the min.
                if (this._value === null) {
                    this.value = this._min;
                }
                this._percent = this._calculatePercentage(this._value);
                // Since this also modifies the percentage, we need to let the change detection know.
                this._changeDetectorRef.markForCheck();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatSlider.prototype, "step", {
            /**
             * The values at which the thumb will snap.
             * @return {?}
             */
            get: function () { return this._step; },
            /**
             * @param {?} v
             * @return {?}
             */
            set: function (v) {
                this._step = coerceNumberProperty(v, this._step);
                if (this._step % 1 !== 0) {
                    this._roundToDecimal = ( /** @type {?} */(this._step.toString().split('.').pop())).length;
                }
                // Since this could modify the label, we need to notify the change detection.
                this._changeDetectorRef.markForCheck();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatSlider.prototype, "thumbLabel", {
            /**
             * Whether or not to show the thumb label.
             * @return {?}
             */
            get: function () { return this._thumbLabel; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this._thumbLabel = coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatSlider.prototype, "tickInterval", {
            /**
             * How often to show ticks. Relative to the step so that a tick always appears on a step.
             * Ex: Tick interval of 4 with a step of 3 will draw a tick every 4 steps (every 12 values).
             * @return {?}
             */
            get: function () { return this._tickInterval; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                if (value === 'auto') {
                    this._tickInterval = 'auto';
                }
                else if (typeof value === 'number' || typeof value === 'string') {
                    this._tickInterval = coerceNumberProperty(value, ( /** @type {?} */(this._tickInterval)));
                }
                else {
                    this._tickInterval = 0;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatSlider.prototype, "value", {
            /**
             * Value of the slider.
             * @return {?}
             */
            get: function () {
                // If the value needs to be read and it is still uninitialized, initialize it to the min.
                if (this._value === null) {
                    this.value = this._min;
                }
                return this._value;
            },
            /**
             * @param {?} v
             * @return {?}
             */
            set: function (v) {
                if (v !== this._value) {
                    /** @type {?} */
                    var value = coerceNumberProperty(v);
                    // While incrementing by a decimal we can end up with values like 33.300000000000004.
                    // Truncate it to ensure that it matches the label and to make it easier to work with.
                    if (this._roundToDecimal) {
                        value = parseFloat(value.toFixed(this._roundToDecimal));
                    }
                    this._value = value;
                    this._percent = this._calculatePercentage(this._value);
                    // Since this also modifies the percentage, we need to let the change detection know.
                    this._changeDetectorRef.markForCheck();
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatSlider.prototype, "vertical", {
            /**
             * Whether the slider is vertical.
             * @return {?}
             */
            get: function () { return this._vertical; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._vertical = coerceBooleanProperty(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatSlider.prototype, "displayValue", {
            /**
             * The value to be used for display purposes.
             * @return {?}
             */
            get: function () {
                if (this.displayWith) {
                    // Value is never null but since setters and getters cannot have
                    // different types, the value getter is also typed to return null.
                    return this.displayWith(( /** @type {?} */(this.value)));
                }
                // Note that this could be improved further by rounding something like 0.999 to 1 or
                // 0.899 to 0.9, however it is very performance sensitive, because it gets called on
                // every change detection cycle.
                if (this._roundToDecimal && this.value && this.value % 1 !== 0) {
                    return this.value.toFixed(this._roundToDecimal);
                }
                return this.value || 0;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * set focus to the host element
         * @param {?=} options
         * @return {?}
         */
        MatSlider.prototype.focus = function (options) {
            this._focusHostElement(options);
        };
        /**
         * blur the host element
         * @return {?}
         */
        MatSlider.prototype.blur = function () {
            this._blurHostElement();
        };
        Object.defineProperty(MatSlider.prototype, "percent", {
            /**
             * The percentage of the slider that coincides with the value.
             * @return {?}
             */
            get: function () { return this._clamp(this._percent); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatSlider.prototype, "_invertAxis", {
            /**
             * Whether the axis of the slider is inverted.
             * (i.e. whether moving the thumb in the positive x or y direction decreases the slider's value).
             * @return {?}
             */
            get: function () {
                // Standard non-inverted mode for a vertical slider should be dragging the thumb from bottom to
                // top. However from a y-axis standpoint this is inverted.
                return this.vertical ? !this.invert : this.invert;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatSlider.prototype, "_isMinValue", {
            /**
             * Whether the slider is at its minimum value.
             * @return {?}
             */
            get: function () {
                return this.percent === 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatSlider.prototype, "_thumbGap", {
            /**
             * The amount of space to leave between the slider thumb and the track fill & track background
             * elements.
             * @return {?}
             */
            get: function () {
                if (this.disabled) {
                    return DISABLED_THUMB_GAP;
                }
                if (this._isMinValue && !this.thumbLabel) {
                    return this._isActive ? MIN_VALUE_ACTIVE_THUMB_GAP : MIN_VALUE_NONACTIVE_THUMB_GAP;
                }
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatSlider.prototype, "_trackBackgroundStyles", {
            /**
             * CSS styles for the track background element.
             * @return {?}
             */
            get: function () {
                /** @type {?} */
                var axis = this.vertical ? 'Y' : 'X';
                /** @type {?} */
                var scale = this.vertical ? "1, " + (1 - this.percent) + ", 1" : 1 - this.percent + ", 1, 1";
                /** @type {?} */
                var sign = this._shouldInvertMouseCoords() ? '-' : '';
                return {
                    // scale3d avoids some rendering issues in Chrome. See #12071.
                    transform: "translate" + axis + "(" + sign + this._thumbGap + "px) scale3d(" + scale + ")"
                };
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatSlider.prototype, "_trackFillStyles", {
            /**
             * CSS styles for the track fill element.
             * @return {?}
             */
            get: function () {
                /** @type {?} */
                var axis = this.vertical ? 'Y' : 'X';
                /** @type {?} */
                var scale = this.vertical ? "1, " + this.percent + ", 1" : this.percent + ", 1, 1";
                /** @type {?} */
                var sign = this._shouldInvertMouseCoords() ? '' : '-';
                return {
                    // scale3d avoids some rendering issues in Chrome. See #12071.
                    transform: "translate" + axis + "(" + sign + this._thumbGap + "px) scale3d(" + scale + ")"
                };
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatSlider.prototype, "_ticksContainerStyles", {
            /**
             * CSS styles for the ticks container element.
             * @return {?}
             */
            get: function () {
                /** @type {?} */
                var axis = this.vertical ? 'Y' : 'X';
                // For a horizontal slider in RTL languages we push the ticks container off the left edge
                // instead of the right edge to avoid causing a horizontal scrollbar to appear.
                /** @type {?} */
                var sign = !this.vertical && this._getDirection() == 'rtl' ? '' : '-';
                /** @type {?} */
                var offset = this._tickIntervalPercent / 2 * 100;
                return {
                    'transform': "translate" + axis + "(" + sign + offset + "%)"
                };
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatSlider.prototype, "_ticksStyles", {
            /**
             * CSS styles for the ticks element.
             * @return {?}
             */
            get: function () {
                /** @type {?} */
                var tickSize = this._tickIntervalPercent * 100;
                /** @type {?} */
                var backgroundSize = this.vertical ? "2px " + tickSize + "%" : tickSize + "% 2px";
                /** @type {?} */
                var axis = this.vertical ? 'Y' : 'X';
                // Depending on the direction we pushed the ticks container, push the ticks the opposite
                // direction to re-center them but clip off the end edge. In RTL languages we need to flip the
                // ticks 180 degrees so we're really cutting off the end edge abd not the start.
                /** @type {?} */
                var sign = !this.vertical && this._getDirection() == 'rtl' ? '-' : '';
                /** @type {?} */
                var rotate = !this.vertical && this._getDirection() == 'rtl' ? ' rotate(180deg)' : '';
                /** @type {?} */
                var styles = {
                    'backgroundSize': backgroundSize,
                    // Without translateZ ticks sometimes jitter as the slider moves on Chrome & Firefox.
                    'transform': "translateZ(0) translate" + axis + "(" + sign + tickSize / 2 + "%)" + rotate
                };
                if (this._isMinValue && this._thumbGap) {
                    /** @type {?} */
                    var side = this.vertical ?
                        (this._invertAxis ? 'Bottom' : 'Top') :
                        (this._invertAxis ? 'Right' : 'Left');
                    styles["padding" + side] = this._thumbGap + "px";
                }
                return styles;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatSlider.prototype, "_thumbContainerStyles", {
            /**
             * @return {?}
             */
            get: function () {
                /** @type {?} */
                var axis = this.vertical ? 'Y' : 'X';
                // For a horizontal slider in RTL languages we push the thumb container off the left edge
                // instead of the right edge to avoid causing a horizontal scrollbar to appear.
                /** @type {?} */
                var invertOffset = (this._getDirection() == 'rtl' && !this.vertical) ? !this._invertAxis : this._invertAxis;
                /** @type {?} */
                var offset = (invertOffset ? this.percent : 1 - this.percent) * 100;
                return {
                    'transform': "translate" + axis + "(-" + offset + "%)"
                };
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Whether mouse events should be converted to a slider position by calculating their distance
         * from the right or bottom edge of the slider as opposed to the top or left.
         * @return {?}
         */
        MatSlider.prototype._shouldInvertMouseCoords = function () {
            return (this._getDirection() == 'rtl' && !this.vertical) ? !this._invertAxis : this._invertAxis;
        };
        /**
         * The language direction for this slider element.
         * @private
         * @return {?}
         */
        MatSlider.prototype._getDirection = function () {
            return (this._dir && this._dir.value == 'rtl') ? 'rtl' : 'ltr';
        };
        /**
         * @return {?}
         */
        MatSlider.prototype.ngOnInit = function () {
            var _this = this;
            this._focusMonitor
                .monitor(this._elementRef, true)
                .subscribe(( /**
         * @param {?} origin
         * @return {?}
         */function (origin) {
                _this._isActive = !!origin && origin !== 'keyboard';
                _this._changeDetectorRef.detectChanges();
            }));
            if (this._dir) {
                this._dirChangeSubscription = this._dir.change.subscribe(( /**
                 * @return {?}
                 */function () {
                    _this._changeDetectorRef.markForCheck();
                }));
            }
        };
        /**
         * @return {?}
         */
        MatSlider.prototype.ngOnDestroy = function () {
            this._focusMonitor.stopMonitoring(this._elementRef);
            this._dirChangeSubscription.unsubscribe();
        };
        /**
         * @return {?}
         */
        MatSlider.prototype._onMouseenter = function () {
            if (this.disabled) {
                return;
            }
            // We save the dimensions of the slider here so we can use them to update the spacing of the
            // ticks and determine where on the slider click and slide events happen.
            this._sliderDimensions = this._getSliderDimensions();
            this._updateTickIntervalPercent();
        };
        /**
         * @param {?} event
         * @return {?}
         */
        MatSlider.prototype._onMousedown = function (event) {
            // Don't do anything if the slider is disabled or the
            // user is using anything other than the main mouse button.
            if (this.disabled || event.button !== 0) {
                return;
            }
            /** @type {?} */
            var oldValue = this.value;
            this._isSliding = false;
            this._focusHostElement();
            this._updateValueFromPosition({ x: event.clientX, y: event.clientY });
            // Emit a change and input event if the value changed.
            if (oldValue != this.value) {
                this._emitInputEvent();
                this._emitChangeEvent();
            }
        };
        /**
         * @param {?} event
         * @return {?}
         */
        MatSlider.prototype._onSlide = function (event) {
            if (this.disabled) {
                return;
            }
            // The slide start event sometimes fails to fire on iOS, so if we're not already in the sliding
            // state, call the slide start handler manually.
            if (!this._isSliding) {
                this._onSlideStart(null);
            }
            // Prevent the slide from selecting anything else.
            event.preventDefault();
            /** @type {?} */
            var oldValue = this.value;
            this._updateValueFromPosition({ x: event.center.x, y: event.center.y });
            // Native range elements always emit `input` events when the value changed while sliding.
            if (oldValue != this.value) {
                this._emitInputEvent();
            }
        };
        /**
         * @param {?} event
         * @return {?}
         */
        MatSlider.prototype._onSlideStart = function (event) {
            if (this.disabled || this._isSliding) {
                return;
            }
            // Simulate mouseenter in case this is a mobile device.
            this._onMouseenter();
            this._isSliding = true;
            this._focusHostElement();
            this._valueOnSlideStart = this.value;
            if (event) {
                this._updateValueFromPosition({ x: event.center.x, y: event.center.y });
                event.preventDefault();
            }
        };
        /**
         * @return {?}
         */
        MatSlider.prototype._onSlideEnd = function () {
            this._isSliding = false;
            if (this._valueOnSlideStart != this.value && !this.disabled) {
                this._emitChangeEvent();
            }
            this._valueOnSlideStart = null;
        };
        /**
         * @return {?}
         */
        MatSlider.prototype._onFocus = function () {
            // We save the dimensions of the slider here so we can use them to update the spacing of the
            // ticks and determine where on the slider click and slide events happen.
            this._sliderDimensions = this._getSliderDimensions();
            this._updateTickIntervalPercent();
        };
        /**
         * @return {?}
         */
        MatSlider.prototype._onBlur = function () {
            this.onTouched();
        };
        /**
         * @param {?} event
         * @return {?}
         */
        MatSlider.prototype._onKeydown = function (event) {
            if (this.disabled || hasModifierKey(event)) {
                return;
            }
            /** @type {?} */
            var oldValue = this.value;
            switch (event.keyCode) {
                case PAGE_UP:
                    this._increment(10);
                    break;
                case PAGE_DOWN:
                    this._increment(-10);
                    break;
                case END:
                    this.value = this.max;
                    break;
                case HOME:
                    this.value = this.min;
                    break;
                case LEFT_ARROW:
                    // NOTE: For a sighted user it would make more sense that when they press an arrow key on an
                    // inverted slider the thumb moves in that direction. However for a blind user, nothing
                    // about the slider indicates that it is inverted. They will expect left to be decrement,
                    // regardless of how it appears on the screen. For speakers ofRTL languages, they probably
                    // expect left to mean increment. Therefore we flip the meaning of the side arrow keys for
                    // RTL. For inverted sliders we prefer a good a11y experience to having it "look right" for
                    // sighted users, therefore we do not swap the meaning.
                    this._increment(this._getDirection() == 'rtl' ? 1 : -1);
                    break;
                case UP_ARROW:
                    this._increment(1);
                    break;
                case RIGHT_ARROW:
                    // See comment on LEFT_ARROW about the conditions under which we flip the meaning.
                    this._increment(this._getDirection() == 'rtl' ? -1 : 1);
                    break;
                case DOWN_ARROW:
                    this._increment(-1);
                    break;
                default:
                    // Return if the key is not one that we explicitly handle to avoid calling preventDefault on
                    // it.
                    return;
            }
            if (oldValue != this.value) {
                this._emitInputEvent();
                this._emitChangeEvent();
            }
            this._isSliding = true;
            event.preventDefault();
        };
        /**
         * @return {?}
         */
        MatSlider.prototype._onKeyup = function () {
            this._isSliding = false;
        };
        /**
         * Increments the slider by the given number of steps (negative number decrements).
         * @private
         * @param {?} numSteps
         * @return {?}
         */
        MatSlider.prototype._increment = function (numSteps) {
            this.value = this._clamp((this.value || 0) + this.step * numSteps, this.min, this.max);
        };
        /**
         * Calculate the new value from the new physical location. The value will always be snapped.
         * @private
         * @param {?} pos
         * @return {?}
         */
        MatSlider.prototype._updateValueFromPosition = function (pos) {
            if (!this._sliderDimensions) {
                return;
            }
            /** @type {?} */
            var offset = this.vertical ? this._sliderDimensions.top : this._sliderDimensions.left;
            /** @type {?} */
            var size = this.vertical ? this._sliderDimensions.height : this._sliderDimensions.width;
            /** @type {?} */
            var posComponent = this.vertical ? pos.y : pos.x;
            // The exact value is calculated from the event and used to find the closest snap value.
            /** @type {?} */
            var percent = this._clamp((posComponent - offset) / size);
            if (this._shouldInvertMouseCoords()) {
                percent = 1 - percent;
            }
            // Since the steps may not divide cleanly into the max value, if the user
            // slid to 0 or 100 percent, we jump to the min/max value. This approach
            // is slightly more intuitive than using `Math.ceil` below, because it
            // follows the user's pointer closer.
            if (percent === 0) {
                this.value = this.min;
            }
            else if (percent === 1) {
                this.value = this.max;
            }
            else {
                /** @type {?} */
                var exactValue = this._calculateValue(percent);
                // This calculation finds the closest step by finding the closest
                // whole number divisible by the step relative to the min.
                /** @type {?} */
                var closestValue = Math.round((exactValue - this.min) / this.step) * this.step + this.min;
                // The value needs to snap to the min and max.
                this.value = this._clamp(closestValue, this.min, this.max);
            }
        };
        /**
         * Emits a change event if the current value is different from the last emitted value.
         * @private
         * @return {?}
         */
        MatSlider.prototype._emitChangeEvent = function () {
            this._controlValueAccessorChangeFn(this.value);
            this.valueChange.emit(this.value);
            this.change.emit(this._createChangeEvent());
        };
        /**
         * Emits an input event when the current value is different from the last emitted value.
         * @private
         * @return {?}
         */
        MatSlider.prototype._emitInputEvent = function () {
            this.input.emit(this._createChangeEvent());
        };
        /**
         * Updates the amount of space between ticks as a percentage of the width of the slider.
         * @private
         * @return {?}
         */
        MatSlider.prototype._updateTickIntervalPercent = function () {
            if (!this.tickInterval || !this._sliderDimensions) {
                return;
            }
            if (this.tickInterval == 'auto') {
                /** @type {?} */
                var trackSize = this.vertical ? this._sliderDimensions.height : this._sliderDimensions.width;
                /** @type {?} */
                var pixelsPerStep = trackSize * this.step / (this.max - this.min);
                /** @type {?} */
                var stepsPerTick = Math.ceil(MIN_AUTO_TICK_SEPARATION / pixelsPerStep);
                /** @type {?} */
                var pixelsPerTick = stepsPerTick * this.step;
                this._tickIntervalPercent = pixelsPerTick / trackSize;
            }
            else {
                this._tickIntervalPercent = this.tickInterval * this.step / (this.max - this.min);
            }
        };
        /**
         * Creates a slider change object from the specified value.
         * @private
         * @param {?=} value
         * @return {?}
         */
        MatSlider.prototype._createChangeEvent = function (value) {
            if (value === void 0) { value = this.value; }
            /** @type {?} */
            var event = new MatSliderChange();
            event.source = this;
            event.value = value;
            return event;
        };
        /**
         * Calculates the percentage of the slider that a value is.
         * @private
         * @param {?} value
         * @return {?}
         */
        MatSlider.prototype._calculatePercentage = function (value) {
            return ((value || 0) - this.min) / (this.max - this.min);
        };
        /**
         * Calculates the value a percentage of the slider corresponds to.
         * @private
         * @param {?} percentage
         * @return {?}
         */
        MatSlider.prototype._calculateValue = function (percentage) {
            return this.min + percentage * (this.max - this.min);
        };
        /**
         * Return a number between two numbers.
         * @private
         * @param {?} value
         * @param {?=} min
         * @param {?=} max
         * @return {?}
         */
        MatSlider.prototype._clamp = function (value, min, max) {
            if (min === void 0) { min = 0; }
            if (max === void 0) { max = 1; }
            return Math.max(min, Math.min(value, max));
        };
        /**
         * Get the bounding client rect of the slider track element.
         * The track is used rather than the native element to ignore the extra space that the thumb can
         * take up.
         * @private
         * @return {?}
         */
        MatSlider.prototype._getSliderDimensions = function () {
            return this._sliderWrapper ? this._sliderWrapper.nativeElement.getBoundingClientRect() : null;
        };
        /**
         * Focuses the native element.
         * Currently only used to allow a blur event to fire but will be used with keyboard input later.
         * @private
         * @param {?=} options
         * @return {?}
         */
        MatSlider.prototype._focusHostElement = function (options) {
            this._elementRef.nativeElement.focus(options);
        };
        /**
         * Blurs the native element.
         * @private
         * @return {?}
         */
        MatSlider.prototype._blurHostElement = function () {
            this._elementRef.nativeElement.blur();
        };
        /**
         * Sets the model value. Implemented as part of ControlValueAccessor.
         * @param {?} value
         * @return {?}
         */
        MatSlider.prototype.writeValue = function (value) {
            this.value = value;
        };
        /**
         * Registers a callback to be triggered when the value has changed.
         * Implemented as part of ControlValueAccessor.
         * @param {?} fn Callback to be registered.
         * @return {?}
         */
        MatSlider.prototype.registerOnChange = function (fn) {
            this._controlValueAccessorChangeFn = fn;
        };
        /**
         * Registers a callback to be triggered when the component is touched.
         * Implemented as part of ControlValueAccessor.
         * @param {?} fn Callback to be registered.
         * @return {?}
         */
        MatSlider.prototype.registerOnTouched = function (fn) {
            this.onTouched = fn;
        };
        /**
         * Sets whether the component should be disabled.
         * Implemented as part of ControlValueAccessor.
         * @param {?} isDisabled
         * @return {?}
         */
        MatSlider.prototype.setDisabledState = function (isDisabled) {
            this.disabled = isDisabled;
        };
        return MatSlider;
    }(_MatSliderMixinBase));
    MatSlider.decorators = [
        { type: Component, args: [{ selector: 'mat-slider',
                    exportAs: 'matSlider',
                    providers: [MAT_SLIDER_VALUE_ACCESSOR],
                    host: {
                        '(focus)': '_onFocus()',
                        '(blur)': '_onBlur()',
                        '(mousedown)': '_onMousedown($event)',
                        '(keydown)': '_onKeydown($event)',
                        '(keyup)': '_onKeyup()',
                        '(mouseenter)': '_onMouseenter()',
                        '(slide)': '_onSlide($event)',
                        '(slideend)': '_onSlideEnd()',
                        '(slidestart)': '_onSlideStart($event)',
                        // On Safari starting to slide temporarily triggers text selection mode which
                        // show the wrong cursor. We prevent it by stopping the `selectstart` event.
                        '(selectstart)': '$event.preventDefault()',
                        'class': 'mat-slider',
                        'role': 'slider',
                        '[tabIndex]': 'tabIndex',
                        '[attr.aria-disabled]': 'disabled',
                        '[attr.aria-valuemax]': 'max',
                        '[attr.aria-valuemin]': 'min',
                        '[attr.aria-valuenow]': 'value',
                        '[attr.aria-orientation]': 'vertical ? "vertical" : "horizontal"',
                        '[class.mat-slider-disabled]': 'disabled',
                        '[class.mat-slider-has-ticks]': 'tickInterval',
                        '[class.mat-slider-horizontal]': '!vertical',
                        '[class.mat-slider-axis-inverted]': '_invertAxis',
                        // Class binding which is only used by the test harness as there is no other
                        // way for the harness to detect if mouse coordinates need to be inverted.
                        '[class.mat-slider-invert-mouse-coords]': '_shouldInvertMouseCoords()',
                        '[class.mat-slider-sliding]': '_isSliding',
                        '[class.mat-slider-thumb-label-showing]': 'thumbLabel',
                        '[class.mat-slider-vertical]': 'vertical',
                        '[class.mat-slider-min-value]': '_isMinValue',
                        '[class.mat-slider-hide-last-tick]': 'disabled || _isMinValue && _thumbGap && _invertAxis',
                        '[class._mat-animation-noopable]': '_animationMode === "NoopAnimations"',
                    },
                    template: "<div class=\"mat-slider-wrapper\" #sliderWrapper><div class=\"mat-slider-track-wrapper\"><div class=\"mat-slider-track-background\" [ngStyle]=\"_trackBackgroundStyles\"></div><div class=\"mat-slider-track-fill\" [ngStyle]=\"_trackFillStyles\"></div></div><div class=\"mat-slider-ticks-container\" [ngStyle]=\"_ticksContainerStyles\"><div class=\"mat-slider-ticks\" [ngStyle]=\"_ticksStyles\"></div></div><div class=\"mat-slider-thumb-container\" [ngStyle]=\"_thumbContainerStyles\"><div class=\"mat-slider-focus-ring\"></div><div class=\"mat-slider-thumb\"></div><div class=\"mat-slider-thumb-label\"><span class=\"mat-slider-thumb-label-text\">{{displayValue}}</span></div></div></div>",
                    styles: [".mat-slider{display:inline-block;position:relative;box-sizing:border-box;padding:8px;outline:0;vertical-align:middle}.mat-slider.mat-slider-sliding:not(.mat-slider-disabled),.mat-slider:not(.mat-slider-disabled):active{cursor:-webkit-grabbing;cursor:grabbing}.mat-slider-wrapper{position:absolute}.mat-slider-track-wrapper{position:absolute;top:0;left:0;overflow:hidden}.mat-slider-track-fill{position:absolute;transform-origin:0 0;transition:transform .4s cubic-bezier(.25,.8,.25,1),background-color .4s cubic-bezier(.25,.8,.25,1)}.mat-slider-track-background{position:absolute;transform-origin:100% 100%;transition:transform .4s cubic-bezier(.25,.8,.25,1),background-color .4s cubic-bezier(.25,.8,.25,1)}.mat-slider-ticks-container{position:absolute;left:0;top:0;overflow:hidden}.mat-slider-ticks{background-repeat:repeat;background-clip:content-box;box-sizing:border-box;opacity:0;transition:opacity .4s cubic-bezier(.25,.8,.25,1)}.mat-slider-thumb-container{position:absolute;z-index:1;transition:transform .4s cubic-bezier(.25,.8,.25,1)}.mat-slider-focus-ring{position:absolute;width:30px;height:30px;border-radius:50%;transform:scale(0);opacity:0;transition:transform .4s cubic-bezier(.25,.8,.25,1),background-color .4s cubic-bezier(.25,.8,.25,1),opacity .4s cubic-bezier(.25,.8,.25,1)}.mat-slider.cdk-keyboard-focused .mat-slider-focus-ring,.mat-slider.cdk-program-focused .mat-slider-focus-ring{transform:scale(1);opacity:1}.mat-slider:not(.mat-slider-disabled):not(.mat-slider-sliding) .mat-slider-thumb,.mat-slider:not(.mat-slider-disabled):not(.mat-slider-sliding) .mat-slider-thumb-label{cursor:-webkit-grab;cursor:grab}.mat-slider-thumb{position:absolute;right:-10px;bottom:-10px;box-sizing:border-box;width:20px;height:20px;border:3px solid transparent;border-radius:50%;transform:scale(.7);transition:transform .4s cubic-bezier(.25,.8,.25,1),background-color .4s cubic-bezier(.25,.8,.25,1),border-color .4s cubic-bezier(.25,.8,.25,1)}.mat-slider-thumb-label{display:none;align-items:center;justify-content:center;position:absolute;width:28px;height:28px;border-radius:50%;transition:transform .4s cubic-bezier(.25,.8,.25,1),border-radius .4s cubic-bezier(.25,.8,.25,1),background-color .4s cubic-bezier(.25,.8,.25,1)}@media (-ms-high-contrast:active){.mat-slider-thumb-label{outline:solid 1px}}.mat-slider-thumb-label-text{z-index:1;opacity:0;transition:opacity .4s cubic-bezier(.25,.8,.25,1)}.mat-slider-sliding .mat-slider-thumb-container,.mat-slider-sliding .mat-slider-track-background,.mat-slider-sliding .mat-slider-track-fill{transition-duration:0s}.mat-slider-has-ticks .mat-slider-wrapper::after{content:'';position:absolute;border-width:0;border-style:solid;opacity:0;transition:opacity .4s cubic-bezier(.25,.8,.25,1)}.mat-slider-has-ticks.cdk-focused:not(.mat-slider-hide-last-tick) .mat-slider-wrapper::after,.mat-slider-has-ticks:hover:not(.mat-slider-hide-last-tick) .mat-slider-wrapper::after{opacity:1}.mat-slider-has-ticks.cdk-focused:not(.mat-slider-disabled) .mat-slider-ticks,.mat-slider-has-ticks:hover:not(.mat-slider-disabled) .mat-slider-ticks{opacity:1}.mat-slider-thumb-label-showing .mat-slider-focus-ring{display:none}.mat-slider-thumb-label-showing .mat-slider-thumb-label{display:flex}.mat-slider-axis-inverted .mat-slider-track-fill{transform-origin:100% 100%}.mat-slider-axis-inverted .mat-slider-track-background{transform-origin:0 0}.mat-slider:not(.mat-slider-disabled).cdk-focused.mat-slider-thumb-label-showing .mat-slider-thumb{transform:scale(0)}.mat-slider:not(.mat-slider-disabled).cdk-focused .mat-slider-thumb-label{border-radius:50% 50% 0}.mat-slider:not(.mat-slider-disabled).cdk-focused .mat-slider-thumb-label-text{opacity:1}.mat-slider:not(.mat-slider-disabled).cdk-mouse-focused .mat-slider-thumb,.mat-slider:not(.mat-slider-disabled).cdk-program-focused .mat-slider-thumb,.mat-slider:not(.mat-slider-disabled).cdk-touch-focused .mat-slider-thumb{border-width:2px;transform:scale(1)}.mat-slider-disabled .mat-slider-focus-ring{transform:scale(0);opacity:0}.mat-slider-disabled .mat-slider-thumb{border-width:4px;transform:scale(.5)}.mat-slider-disabled .mat-slider-thumb-label{display:none}.mat-slider-horizontal{height:48px;min-width:128px}.mat-slider-horizontal .mat-slider-wrapper{height:2px;top:23px;left:8px;right:8px}.mat-slider-horizontal .mat-slider-wrapper::after{height:2px;border-left-width:2px;right:0;top:0}.mat-slider-horizontal .mat-slider-track-wrapper{height:2px;width:100%}.mat-slider-horizontal .mat-slider-track-fill{height:2px;width:100%;transform:scaleX(0)}.mat-slider-horizontal .mat-slider-track-background{height:2px;width:100%;transform:scaleX(1)}.mat-slider-horizontal .mat-slider-ticks-container{height:2px;width:100%}@media (-ms-high-contrast:active){.mat-slider-horizontal .mat-slider-ticks-container{height:0;outline:solid 2px;top:1px}}.mat-slider-horizontal .mat-slider-ticks{height:2px;width:100%}.mat-slider-horizontal .mat-slider-thumb-container{width:100%;height:0;top:50%}.mat-slider-horizontal .mat-slider-focus-ring{top:-15px;right:-15px}.mat-slider-horizontal .mat-slider-thumb-label{right:-14px;top:-40px;transform:translateY(26px) scale(.01) rotate(45deg)}.mat-slider-horizontal .mat-slider-thumb-label-text{transform:rotate(-45deg)}.mat-slider-horizontal.cdk-focused .mat-slider-thumb-label{transform:rotate(45deg)}@media (-ms-high-contrast:active){.mat-slider-horizontal.cdk-focused .mat-slider-thumb-label,.mat-slider-horizontal.cdk-focused .mat-slider-thumb-label-text{transform:none}}.mat-slider-vertical{width:48px;min-height:128px}.mat-slider-vertical .mat-slider-wrapper{width:2px;top:8px;bottom:8px;left:23px}.mat-slider-vertical .mat-slider-wrapper::after{width:2px;border-top-width:2px;bottom:0;left:0}.mat-slider-vertical .mat-slider-track-wrapper{height:100%;width:2px}.mat-slider-vertical .mat-slider-track-fill{height:100%;width:2px;transform:scaleY(0)}.mat-slider-vertical .mat-slider-track-background{height:100%;width:2px;transform:scaleY(1)}.mat-slider-vertical .mat-slider-ticks-container{width:2px;height:100%}@media (-ms-high-contrast:active){.mat-slider-vertical .mat-slider-ticks-container{width:0;outline:solid 2px;left:1px}}.mat-slider-vertical .mat-slider-focus-ring{bottom:-15px;left:-15px}.mat-slider-vertical .mat-slider-ticks{width:2px;height:100%}.mat-slider-vertical .mat-slider-thumb-container{height:100%;width:0;left:50%}.mat-slider-vertical .mat-slider-thumb{-webkit-backface-visibility:hidden;backface-visibility:hidden}.mat-slider-vertical .mat-slider-thumb-label{bottom:-14px;left:-40px;transform:translateX(26px) scale(.01) rotate(-45deg)}.mat-slider-vertical .mat-slider-thumb-label-text{transform:rotate(45deg)}.mat-slider-vertical.cdk-focused .mat-slider-thumb-label{transform:rotate(-45deg)}[dir=rtl] .mat-slider-wrapper::after{left:0;right:auto}[dir=rtl] .mat-slider-horizontal .mat-slider-track-fill{transform-origin:100% 100%}[dir=rtl] .mat-slider-horizontal .mat-slider-track-background{transform-origin:0 0}[dir=rtl] .mat-slider-horizontal.mat-slider-axis-inverted .mat-slider-track-fill{transform-origin:0 0}[dir=rtl] .mat-slider-horizontal.mat-slider-axis-inverted .mat-slider-track-background{transform-origin:100% 100%}.mat-slider._mat-animation-noopable .mat-slider-focus-ring,.mat-slider._mat-animation-noopable .mat-slider-has-ticks .mat-slider-wrapper::after,.mat-slider._mat-animation-noopable .mat-slider-thumb,.mat-slider._mat-animation-noopable .mat-slider-thumb-container,.mat-slider._mat-animation-noopable .mat-slider-thumb-label,.mat-slider._mat-animation-noopable .mat-slider-thumb-label-text,.mat-slider._mat-animation-noopable .mat-slider-ticks,.mat-slider._mat-animation-noopable .mat-slider-track-background,.mat-slider._mat-animation-noopable .mat-slider-track-fill{transition:none}"],
                    inputs: ['disabled', 'color', 'tabIndex'],
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                },] },
    ];
    /** @nocollapse */
    MatSlider.ctorParameters = function () { return [
        { type: ElementRef },
        { type: FocusMonitor },
        { type: ChangeDetectorRef },
        { type: Directionality, decorators: [{ type: Optional }] },
        { type: String, decorators: [{ type: Attribute, args: ['tabindex',] }] },
        { type: String, decorators: [{ type: Optional }, { type: Inject, args: [ANIMATION_MODULE_TYPE,] }] }
    ]; };
    MatSlider.propDecorators = {
        invert: [{ type: Input }],
        max: [{ type: Input }],
        min: [{ type: Input }],
        step: [{ type: Input }],
        thumbLabel: [{ type: Input }],
        tickInterval: [{ type: Input }],
        value: [{ type: Input }],
        displayWith: [{ type: Input }],
        vertical: [{ type: Input }],
        change: [{ type: Output }],
        input: [{ type: Output }],
        valueChange: [{ type: Output }],
        _sliderWrapper: [{ type: ViewChild, args: ['sliderWrapper', { static: false },] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatSliderModule = /** @class */ (function () {
        function MatSliderModule() {
        }
        return MatSliderModule;
    }());
    MatSliderModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule, MatCommonModule],
                    exports: [MatSlider, MatCommonModule],
                    declarations: [MatSlider],
                    providers: [{ provide: HAMMER_GESTURE_CONFIG, useClass: GestureConfig }]
                },] },
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var KERNEL_NAME_COLUMN_INDEX = 0;
    /** @type {?} */
    var TOTAL_DURATION_US_COLUMN_INDEX = 1;
    /** @type {?} */
    var TOOLTIP_COLUMN_INDEX = 2;
    /**
     * A kernel stats chart view component.
     */
    var KernelStatsChart = /** @class */ (function () {
        function KernelStatsChart() {
            /**
             * The kernel stats data.
             */
            this.kernelStatsData = null;
            this.count = 0;
            this.total = 0;
        }
        /**
         * @return {?}
         */
        KernelStatsChart.prototype.ngOnInit = function () {
            this.loadGoogleChart();
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        KernelStatsChart.prototype.ngOnChanges = function (changes) {
            this.drawChart();
        };
        /**
         * @private
         * @param {?} kernelName
         * @param {?} durationUs
         * @param {?} totalDurationUs
         * @return {?}
         */
        KernelStatsChart.prototype.makeTooltip = function (kernelName, durationUs, totalDurationUs) {
            return '<div style="padding:5px;">' +
                '<b>' + kernelName + '</b><br/>' + durationUs.toFixed(2) + ' us ' +
                '(' + (durationUs / totalDurationUs * 100.0).toFixed(1) + ')%' +
                '</div>';
        };
        /**
         * @private
         * @return {?}
         */
        KernelStatsChart.prototype.getDataTable = function () {
            if (!this.kernelStatsData) {
                return null;
            }
            if (this.dataTable) {
                return this.dataTable;
            }
            /** @type {?} */
            var dataTable = new google.visualization.DataTable(this.kernelStatsData);
            /** @type {?} */
            var columns = {
                kernelName: 0,
                totalDurationUs: 0,
            };
            for (var i_179 = 0; i_179 < dataTable.getNumberOfColumns(); i_179++) {
                switch (dataTable.getColumnId(i_179)) {
                    case 'kernel_name':
                        columns.kernelName = i_179;
                        break;
                    case 'total_duration_us':
                        columns.totalDurationUs = i_179;
                        break;
                    default:
                        break;
                }
            }
            // tslint:disable-next-line:no-any
            /** @type {?} */
            var dataGroup = new (( /** @type {?} */(google.visualization)))['data']['group'](dataTable, [columns.kernelName], [
                {
                    'column': columns.totalDurationUs,
                    // tslint:disable-next-line:no-any
                    'aggregation': (( /** @type {?} */(google.visualization)))['data']['sum'],
                    'type': 'number',
                },
            ]);
            dataGroup.sort([
                {
                    column: TOTAL_DURATION_US_COLUMN_INDEX,
                    desc: true,
                },
                {
                    column: KERNEL_NAME_COLUMN_INDEX,
                    asc: true,
                },
            ]);
            dataGroup.addColumn({
                type: 'string',
                role: 'tooltip',
                p: { 'html': true },
            });
            this.total = dataGroup.getNumberOfRows();
            this.count = Math.min(this.total, 10);
            this.dataTable = new google.visualization.DataView(dataGroup).toDataTable();
            return this.dataTable;
        };
        /**
         * @return {?}
         */
        KernelStatsChart.prototype.drawChart = function () {
            if (!this.chart) {
                return;
            }
            /** @type {?} */
            var dataTable = this.getDataTable();
            if (!dataTable) {
                return;
            }
            /** @type {?} */
            var totalDurationUs = 0.0;
            for (var i_180 = 0; i_180 < this.count; i_180++) {
                totalDurationUs += dataTable.getValue(i_180, TOTAL_DURATION_US_COLUMN_INDEX);
            }
            for (var i_181 = 0; i_181 < this.count; i_181++) {
                /** @type {?} */
                var tooltip = this.makeTooltip(dataTable.getValue(i_181, KERNEL_NAME_COLUMN_INDEX), dataTable.getValue(i_181, TOTAL_DURATION_US_COLUMN_INDEX), totalDurationUs);
                dataTable.setCell(i_181, TOOLTIP_COLUMN_INDEX, tooltip);
            }
            /** @type {?} */
            var dataView = new google.visualization.DataView(dataTable);
            if (this.total > this.count) {
                dataView.hideRows(this.count, this.total - 1);
            }
            /** @type {?} */
            var options = {
                backgroundColor: 'transparent',
                width: 700,
                height: 250,
                chartArea: {
                    left: 0,
                    width: '90%',
                    height: '90%',
                },
                legend: { textStyle: { fontSize: 10 } },
                sliceVisibilityThreshold: 0.01,
                tooltip: { isHtml: true },
            };
            this.chart.draw(dataView, options);
        };
        /**
         * @return {?}
         */
        KernelStatsChart.prototype.loadGoogleChart = function () {
            var _this = this;
            if (!google || !google.charts) {
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    _this.loadGoogleChart();
                }), 100);
            }
            google.charts.load('current', { 'packages': ['corechart'] });
            google.charts.setOnLoadCallback(( /**
             * @return {?}
             */function () {
                _this.chart =
                    new google.visualization.PieChart(_this.chartRef.nativeElement);
                _this.drawChart();
            }));
        };
        /**
         * @param {?} value
         * @return {?}
         */
        KernelStatsChart.prototype.updateCount = function (value) {
            value = Number(value);
            if (value === this.count) {
                return;
            }
            this.count = value;
            this.drawChart();
        };
        return KernelStatsChart;
    }());
    KernelStatsChart.decorators = [
        { type: Component, args: [{
                    selector: 'kernel-stats-chart',
                    template: "<div>\n  <div class=\"mat-title\">Top {{count}} Kernels with highest Total Duration</div>\n  <div class=\"control\">\n      <div class=\"control-title\">\n        Show top&nbsp;\n        <mat-form-field class=\"count-input\">\n          <input\n                 matInput\n                 type=\"number\"\n                 [min]=\"1\"\n                 [max]=\"total\"\n                 [step]=\"1\"\n                 [value]=\"count\"\n                 (input)=\"updateCount($event.target.value)\" />\n        </mat-form-field>\n        &nbsp;Kernels\n      </div>\n      <div>\n        <mat-slider\n                    [min]=\"1\"\n                    [max]=\"total\"\n                    [step]=\"1\"\n                    [value]=\"count\"\n                    (change)=\"updateCount($event.value)\">\n        </mat-slider>\n      </div>\n    </div>\n  <div class=\"chart\" #chart></div>\n</div>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}:host{display:block;width:800px;height:fit-content;margin:8px 8px 8px 0}.control{width:fit-content;text-align:center}.control-title{color:#5f6368;margin:-20px 0 -24px}.count-input{width:50px}\n"]
                }] }
    ];
    KernelStatsChart.propDecorators = {
        kernelStatsData: [{ type: Input }],
        chartRef: [{ type: ViewChild, args: ['chart', { static: false },] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var KernelStatsChartModule = /** @class */ (function () {
        function KernelStatsChartModule() {
        }
        return KernelStatsChartModule;
    }());
    KernelStatsChartModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [KernelStatsChart],
                    imports: [
                        MatFormFieldModule,
                        MatInputModule,
                        MatSliderModule,
                    ],
                    exports: [KernelStatsChart]
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var DATA_TABLE_RANK_INDEX = 0;
    /** @type {?} */
    var DATA_TABLE_KERNEL_NAME_INDEX = 1;
    /** @type {?} */
    var DATA_TABLE_OP_NAME_INDEX = 8;
    /**
     * A kernel stats table view component.
     */
    var KernelStatsTable = /** @class */ (function () {
        function KernelStatsTable() {
            /**
             * The kernel stats data.
             */
            this.kernelStatsData = null;
            this.columns = {
                rank: 0,
                kernelName: 0,
                registersPerThread: 0,
                shmemBytes: 0,
                blockDim: 0,
                gridDim: 0,
                occupancyPct: 0,
                isKernelUsingTensorCore: 0,
                isOpTensorCoreEligible: 0,
                opName: 0,
                occurrences: 0,
                totalDurationUs: 0,
                avgDurationUs: 0,
                minDurationUs: 0,
                maxDurationUs: 0,
            };
            this.dataTable = null;
            this.filterKernelName = '';
            this.filterOpName = '';
            this.sortAscending = true;
            this.sortColumn = 0;
            this.table = null;
            this.loading = true;
        }
        /**
         * @return {?}
         */
        KernelStatsTable.prototype.ngOnInit = function () {
            this.loadGoogleChart();
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        KernelStatsTable.prototype.ngOnChanges = function (changes) {
            this.dataTable = null;
            this.drawTable();
        };
        /**
         * @return {?}
         */
        KernelStatsTable.prototype.createDataTable = function () {
            if (!this.table || !this.kernelStatsData || !!this.dataTable) {
                return;
            }
            this.dataTable = new google.visualization.DataTable(this.kernelStatsData);
        };
        /**
         * @return {?}
         */
        KernelStatsTable.prototype.drawTable = function () {
            if (!this.table || !this.kernelStatsData) {
                return;
            }
            /** @type {?} */
            var dataView = this.getDataView();
            if (!dataView) {
                return;
            }
            /** @type {?} */
            var options = {
                allowHtml: true,
                alternatingRowStyle: false,
                showRowNumber: false,
                width: '100%',
                cssClassNames: {
                    'headerCell': 'google-chart-table-header-cell',
                    'tableCell': 'google-chart-table-table-cell',
                },
                sort: 'event',
                sortAscending: this.sortAscending,
                sortColumn: this.sortColumn,
                page: 'enable',
                pageSize: 100,
            };
            this.table.draw(dataView, ( /** @type {?} */(options)));
        };
        /**
         * @return {?}
         */
        KernelStatsTable.prototype.enumerateColumns = function () {
            if (!this.dataTable) {
                return;
            }
            for (var i_182 = 0; i_182 < this.dataTable.getNumberOfColumns(); i_182++) {
                switch (this.dataTable.getColumnId(i_182)) {
                    case 'rank':
                        this.columns.rank = i_182;
                        break;
                    case 'kernel_name':
                        this.columns.kernelName = i_182;
                        break;
                    case 'registers_per_thread':
                        this.columns.registersPerThread = i_182;
                        break;
                    case 'shmem_bytes':
                        this.columns.shmemBytes = i_182;
                        break;
                    case 'block_dim':
                        this.columns.blockDim = i_182;
                        break;
                    case 'grid_dim':
                        this.columns.gridDim = i_182;
                        break;
                    case 'occupancy_pct':
                        this.columns.occupancyPct = i_182;
                        break;
                    case 'is_kernel_using_tensor_core':
                        this.columns.isKernelUsingTensorCore = i_182;
                        break;
                    case 'is_op_tensor_core_eligible':
                        this.columns.isOpTensorCoreEligible = i_182;
                        break;
                    case 'op_name':
                        this.columns.opName = i_182;
                        break;
                    case 'occurrences':
                        this.columns.occurrences = i_182;
                        break;
                    case 'total_duration_us':
                        this.columns.totalDurationUs = i_182;
                        break;
                    case 'avg_duration_us':
                        this.columns.avgDurationUs = i_182;
                        break;
                    case 'min_duration_us':
                        this.columns.minDurationUs = i_182;
                        break;
                    case 'max_duration_us':
                        this.columns.maxDurationUs = i_182;
                        break;
                    default:
                        break;
                }
            }
        };
        /**
         * @return {?}
         */
        KernelStatsTable.prototype.getDataView = function () {
            if (!this.dataTable) {
                this.createDataTable();
                this.enumerateColumns();
            }
            if (this.dataTable) {
                this.dataTable.setProperty(0, this.columns.kernelName, 'style', 'width: 30%');
                this.dataTable.setProperty(0, this.columns.opName, 'style', 'width: 25%');
            }
            /** @type {?} */
            var dataView = this.sortDataView();
            if (!dataView) {
                return null;
            }
            dataView.setColumns([
                this.columns.rank,
                this.columns.kernelName,
                this.columns.registersPerThread,
                this.columns.shmemBytes,
                this.columns.blockDim,
                this.columns.gridDim,
                this.columns.occupancyPct,
                this.columns.isKernelUsingTensorCore,
                this.columns.isOpTensorCoreEligible,
                this.columns.opName,
                this.columns.occurrences,
                this.columns.totalDurationUs,
                this.columns.avgDurationUs,
                this.columns.minDurationUs,
                this.columns.maxDurationUs,
            ]);
            return dataView;
        };
        /**
         * @return {?}
         */
        KernelStatsTable.prototype.getFilteredDataTable = function () {
            if (!this.dataTable) {
                return null;
            }
            /** @type {?} */
            var filters = [];
            if (this.filterKernelName.trim()) {
                /** @type {?} */
                var filter_1 = this.filterKernelName.trim().toLowerCase();
                filters.push(( /** @type {?} */({
                    'column': DATA_TABLE_KERNEL_NAME_INDEX,
                    'test': ( /**
                     * @param {?} value
                     * @return {?}
                     */function (value) { return value.toLowerCase().indexOf(filter_1) >= 0; }),
                })));
            }
            if (this.filterOpName.trim()) {
                /** @type {?} */
                var filter_2 = this.filterOpName.trim().toLowerCase();
                filters.push(( /** @type {?} */({
                    'column': DATA_TABLE_OP_NAME_INDEX,
                    'test': ( /**
                     * @param {?} value
                     * @return {?}
                     */function (value) { return value.toLowerCase().indexOf(filter_2) >= 0; }),
                })));
            }
            if (filters.length > 0) {
                /** @type {?} */
                var dataView = new google.visualization.DataView(this.dataTable);
                dataView.setRows(this.dataTable.getFilteredRows(filters));
                return dataView.toDataTable();
            }
            return this.dataTable;
        };
        /**
         * @return {?}
         */
        KernelStatsTable.prototype.loadGoogleChart = function () {
            var _this = this;
            if (!google || !google.charts) {
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    _this.loadGoogleChart();
                }), 100);
            }
            google.charts.load('current', { 'packages': ['table'] });
            google.charts.setOnLoadCallback(( /**
             * @return {?}
             */function () {
                _this.table = new google.visualization.Table(_this.tableRef.nativeElement);
                google.visualization.events.addListener(_this.table, 'sort', ( /**
                 * @param {?} event
                 * @return {?}
                 */function (event) {
                    _this.sortColumn = event.column;
                    _this.sortAscending = event.ascending;
                    _this.drawTable();
                }));
                _this.drawTable();
            }));
        };
        /**
         * @return {?}
         */
        KernelStatsTable.prototype.sortDataView = function () {
            /** @type {?} */
            var dataTable = this.getFilteredDataTable();
            if (!dataTable) {
                return null;
            }
            /** @type {?} */
            var sortedIndex = dataTable.getSortedRows({
                column: this.sortColumn,
                desc: !this.sortAscending,
            });
            if (this.sortColumn === DATA_TABLE_RANK_INDEX && !this.sortAscending) {
                /** @type {?} */
                var n_1 = sortedIndex.length;
                sortedIndex.forEach(( /**
                 * @param {?} v
                 * @return {?}
                 */function (v) {
                    dataTable.setCell(v, DATA_TABLE_RANK_INDEX, n_1--);
                }));
            }
            else {
                sortedIndex.forEach(( /**
                 * @param {?} v
                 * @param {?} idx
                 * @return {?}
                 */function (v, idx) {
                    dataTable.setCell(v, DATA_TABLE_RANK_INDEX, idx + 1);
                }));
            }
            /** @type {?} */
            var dataView = new google.visualization.DataView(dataTable);
            dataView.setRows(sortedIndex);
            return dataView;
        };
        return KernelStatsTable;
    }());
    KernelStatsTable.decorators = [
        { type: Component, args: [{
                    selector: 'kernel-stats-table',
                    template: "<div>\n  <div class=\"mat-headline\">GPU Kernels</div>\n  <mat-form-field>\n    <input\n           matInput\n           placeholder=\"Kernel Name\"\n           [value]=\"filterKernelName\"\n           (input)=\"filterKernelName = $event.target.value; drawTable();\">\n    <mat-icon matSuffix>search</mat-icon>\n  </mat-form-field>\n  <mat-form-field>\n    <input\n           matInput\n           placeholder=\"Op Name\"\n           [value]=\"filterOpName\"\n           (input)=\"filterOpName = $event.target.value; drawTable();\">\n    <mat-icon matSuffix>search</mat-icon>\n  </mat-form-field>\n</div>\n<br>\n<div>\n  <div #table class=\"table\"></div>\n</div>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}:host{display:block;padding:20px}mat-form-field{margin:0 8px}mat-icon{color:#777;vertical-align:bottom}.table{border:1px solid #eee}\n"]
                }] }
    ];
    KernelStatsTable.propDecorators = {
        kernelStatsData: [{ type: Input }],
        tableRef: [{ type: ViewChild, args: ['table', { static: false },] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var KernelStatsTableModule = /** @class */ (function () {
        function KernelStatsTableModule() {
        }
        return KernelStatsTableModule;
    }());
    KernelStatsTableModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [KernelStatsTable],
                    imports: [
                        MatFormFieldModule,
                        MatIconModule,
                        MatInputModule,
                    ],
                    exports: [KernelStatsTable]
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Initial state object
     * @type {?}
     */
    var INIT_COMMON_DATA_STORE_STATE = {
        kernelStatsData: null,
    };
    /**
     * Feature key for store
     * @type {?}
     */
    var COMMON_DATA_STORE_KEY = 'common_data_store';
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var commonDataStoreState = createFeatureSelector(COMMON_DATA_STORE_KEY);
    var ɵ0$k = /**
     * @param {?} commonDataStoreState
     * @return {?}
     */ function (commonDataStoreState) { return commonDataStoreState.kernelStatsData; };
    /**
     * Selector for kernel stats data property
     * @type {?}
     */
    var getKernelStatsDataState = createSelector(commonDataStoreState, (ɵ0$k));
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A Kernel Stats component.
     */
    var KernelStats = /** @class */ (function () {
        /**
         * @param {?} store
         */
        function KernelStats(store) {
            var _this = this;
            this.data = null;
            this.hasDataRow = false;
            store.select(getKernelStatsDataState)
                .subscribe(( /**
         * @param {?} data
         * @return {?}
         */function (data) {
                _this.update(data);
            }));
        }
        /**
         * @param {?} data
         * @return {?}
         */
        KernelStats.prototype.update = function (data) {
            this.data = data;
            this.hasDataRow = !!(data) && !!(data.rows) && data.rows.length > 0;
        };
        return KernelStats;
    }());
    KernelStats.decorators = [
        { type: Component, args: [{
                    selector: 'kernel-stats',
                    template: "<div class=\"section-container\">\n  <div class=\"row\">\n    <div>\n      <div class=\"mat-headline\">GPU Kernel Stats</div>\n    </div>\n    <div class=\"flex-space\"></div>\n    <export-as-csv tool=\"kernel_stats\"></export-as-csv>\n  </div>\n\n  <div [className]=\"hasDataRow ? 'auto-height' : 'hidden-content'\">\n    <br>\n\n    <kernel-stats-chart [kernelStatsData]=\"data\"></kernel-stats-chart>\n  </div>\n</div>\n\n<div [className]=\"hasDataRow ? 'auto-height' : 'hidden-content'\">\n  <mat-divider></mat-divider>\n\n  <kernel-stats-table [kernelStatsData]=\"data\"></kernel-stats-table>\n</div>\n\n<div class=\"section-container\" [hidden]=\"hasDataRow\">\n  There is no GPU data to display because there were no kernels in the capture duration.\n</div>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}:host{display:block}.section-container{padding:20px}.row{display:flex}.flex-space{flex:1}\n"]
                }] }
    ];
    /** @nocollapse */
    KernelStats.ctorParameters = function () { return [
        { type: Store }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A kernel stats module.
     */
    var KernelStatsModule = /** @class */ (function () {
        function KernelStatsModule() {
        }
        return KernelStatsModule;
    }());
    KernelStatsModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [KernelStats],
                    imports: [
                        MatDividerModule,
                        ExportAsCsvModule,
                        KernelStatsChartModule,
                        KernelStatsTableModule,
                    ],
                    exports: [KernelStats]
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A kernel stats adapter component.
     */
    var KernelStatsAdapter = /** @class */ (function () {
        /**
         * @param {?} route
         * @param {?} store
         */
        function KernelStatsAdapter(route, store) {
            var _this = this;
            this.store = store;
            /**
             * Handles on-destroy Subject, used to unsubscribe.
             */
            this.destroyed = new ReplaySubject(1);
            route.params.pipe(takeUntil(this.destroyed)).subscribe(( /**
             * @param {?} params
             * @return {?}
             */function (params) {
                _this.update(( /** @type {?} */(params)));
            }));
        }
        /**
         * @param {?} event
         * @return {?}
         */
        KernelStatsAdapter.prototype.update = function (event) {
            /** @type {?} */
            var params = {
                run: event.run || '',
                tag: event.tag || 'kernel_stats',
                host: event.host || '',
            };
            this.store.dispatch(setDataRequestStateAction({ dataRequest: { type: 2 /* KERNEL_STATS */, params: params } }));
        };
        /**
         * @return {?}
         */
        KernelStatsAdapter.prototype.ngOnDestroy = function () {
            // Unsubscribes all pending subscriptions.
            this.destroyed.next();
            this.destroyed.complete();
        };
        return KernelStatsAdapter;
    }());
    KernelStatsAdapter.decorators = [
        { type: Component, args: [{
                    selector: 'kernel-stats-adapter',
                    template: '<kernel-stats></kernel-stats>'
                }] }
    ];
    /** @nocollapse */
    KernelStatsAdapter.ctorParameters = function () { return [
        { type: ActivatedRoute },
        { type: Store }
    ]; };
    var KernelStatsAdapterModule = /** @class */ (function () {
        function KernelStatsAdapterModule() {
        }
        return KernelStatsAdapterModule;
    }());
    KernelStatsAdapterModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [KernelStatsAdapter],
                    imports: [KernelStatsModule],
                    exports: [KernelStatsAdapter]
                },] }
    ];
    /** Base class of Memory Profile component. */
    var MemoryProfileBase = /** @class */ (function () {
        function MemoryProfileBase() {
            this.data = null;
            this.hasMemoryData = false;
            this.memoryIds = [];
            this.selectedMemoryId = '';
        }
        MemoryProfileBase.prototype.parseData = function (data) {
            this.data = data;
            if (data && data.memoryIds && data.numHosts) {
                if (data.numHosts > 0 && data.memoryIds.length > 0) {
                    this.hasMemoryData = true;
                    this.memoryIds = data.memoryIds;
                    if (this.selectedMemoryId === '') {
                        this.selectedMemoryId = data.memoryIds[0];
                    }
                }
            }
        };
        return MemoryProfileBase;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A Memory Profile component.
     */
    var MemoryProfile = /** @class */ (function (_super) {
        __extends(MemoryProfile, _super);
        /**
         * @param {?} route
         * @param {?} dataService
         * @param {?} store
         */
        function MemoryProfile(route, dataService, store) {
            var _this = _super.call(this) || this;
            _this.dataService = dataService;
            _this.store = store;
            /**
             * Handles on-destroy Subject, used to unsubscribe.
             */
            _this.destroyed = new ReplaySubject(1);
            _this.run = '';
            _this.tag = '';
            _this.host = '';
            route.params.pipe(takeUntil(_this.destroyed)).subscribe(( /**
             * @param {?} params
             * @return {?}
             */function (params) {
                _this.update(( /** @type {?} */(params)));
            }));
            return _this;
        }
        /**
         * @param {?} event
         * @return {?}
         */
        MemoryProfile.prototype.update = function (event) {
            var _this = this;
            this.run = event.run || '';
            this.tag = event.tag || 'memory_profile';
            this.host = event.host || '';
            this.store.dispatch(setLoadingStateAction({
                loadingState: {
                    loading: true,
                    message: 'Loading data',
                }
            }));
            this.dataService.getData(this.run, this.tag, this.host)
                .pipe(takeUntil(this.destroyed))
                .subscribe(( /**
         * @param {?} data
         * @return {?}
         */function (/**
         * @param {?} data
         * @return {?}
         */ data) {
                _this.store.dispatch(setLoadingStateAction({
                    loadingState: {
                        loading: false,
                        message: '',
                    }
                }));
                _this.parseData(( /** @type {?} */(data)));
            }));
        };
        /**
         * @return {?}
         */
        MemoryProfile.prototype.ngOnDestroy = function () {
            // Unsubscribes all pending subscriptions.
            this.destroyed.next();
            this.destroyed.complete();
        };
        return MemoryProfile;
    }(MemoryProfileBase));
    MemoryProfile.decorators = [
        { type: Component, args: [{
                    selector: 'memory-profile',
                    template: "<div>\n  <div class=\"error-message\" [hidden]=\"hasMemoryData\">\n    There is no memory profile to display because there were no memory activity data in the captured\n    duration.\n  </div>\n  <div [hidden]=\"!hasMemoryData\">\n    <div class=\"container\">\n      <div class=\"left-column\">\n        <memory-profile-summary [data]=\"data\" [memoryId]=\"selectedMemoryId\">\n          <div class=\"item-container\">\n            <table>\n              <tr>\n                <td>\n                  <b>Memory ID</b>\n                  <div class=\"description\">show memory profile for selected device</div>\n                </td>\n                <td class=\"item-value\">\n                  <mat-form-field>\n                    <mat-select [(value)]=\"selectedMemoryId\">\n                      <mat-option *ngFor=\"let id of memoryIds\" [value]=\"id\">\n                        {{ id }}\n                      </mat-option>\n                    </mat-select>\n                  </mat-form-field>\n                </td>\n              </tr>\n            </table>\n          </div>\n        </memory-profile-summary>\n      </div>\n\n      <div class=\"right-column\">\n        <memory-timeline-graph\n          [memoryProfileProtoOrNull]=\"data\"\n          [memoryId]=\"selectedMemoryId\"\n        ></memory-timeline-graph>\n      </div>\n      <div class=\"full-column\">\n        <memory-breakdown-table [memoryProfileData]=\"data\" [memoryId]=\"selectedMemoryId\">\n        </memory-breakdown-table>\n      </div>\n    </div>\n  </div>\n</div>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}:host{display:block}mat-form-field{width:80px;margin-left:-10px}.error-message{color:red;font-size:.5cm;font-weight:bolder;margin-top:.5cm;margin-bottom:.5cm;text-align:center}.container{display:flex;flex-wrap:wrap;width:100%}.left-column{display:flex;flex-direction:column;width:33.333%}.right-column{display:flex;flex-direction:column;width:66.667%}.full-column{border-right:1px solid #eee;width:100%}@media screen and (max-width: 860px){:host{width:fit-content}}@media screen and (max-width: 1140px){.left-column,.right-column{width:100%}}.mat-subheading-2{padding-left:10px;margin-top:10px;margin-bottom:0}.mat-form-field{padding-left:10px}\n"]
                }] }
    ];
    /** @nocollapse */
    MemoryProfile.ctorParameters = function () { return [
        { type: ActivatedRoute },
        { type: DataService },
        { type: Store }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var DATA_TABLE_OPERATION_INDEX = 0;
    /**
     * A memory breakdown table view component.
     */
    var MemoryBreakdownTable = /** @class */ (function () {
        function MemoryBreakdownTable() {
            /**
             * The memory profile proto data.
             */
            this.memoryProfileData = null;
            /**
             * The selected memory ID to show memory profile for.
             */
            this.memoryId = '';
            this.dataTable = null;
            this.filterOperation = '';
            this.table = null;
        }
        /**
         * @return {?}
         */
        MemoryBreakdownTable.prototype.ngOnInit = function () {
            this.loadGoogleChart();
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        MemoryBreakdownTable.prototype.ngOnChanges = function (changes) {
            this.dataTable = null;
            this.drawTable();
        };
        /**
         * @return {?}
         */
        MemoryBreakdownTable.prototype.createDataTable = function () {
            if (!this.table || !this.memoryProfileData ||
                !this.memoryProfileData.memoryProfilePerAllocator || !!this.dataTable) {
                return;
            }
            this.dataTable = new google.visualization.DataTable();
            this.dataTable.addColumn('string', 'Op Name');
            this.dataTable.addColumn('number', 'Allocation Size (GiBs)');
            this.dataTable.addColumn('number', 'Requested Size (GiBs)');
            this.dataTable.addColumn('number', 'Occurrences');
            this.dataTable.addColumn('string', 'Region type');
            this.dataTable.addColumn('string', 'Data type');
            this.dataTable.addColumn('string', 'Shape');
            /** @type {?} */
            var snapshots = this.memoryProfileData.memoryProfilePerAllocator[this.memoryId]
                .memoryProfileSnapshots;
            /** @type {?} */
            var activeAllocations = this.memoryProfileData.memoryProfilePerAllocator[this.memoryId]
                .activeAllocations;
            /** @type {?} */
            var specialAllocations = this.memoryProfileData.memoryProfilePerAllocator[this.memoryId]
                .specialAllocations;
            if (!snapshots || !activeAllocations || !specialAllocations) {
                return;
            }
            for (var i_183 = 0; i_183 < activeAllocations.length; i_183++) {
                /** @type {?} */
                var index = Number(activeAllocations[i_183].snapshotIndex);
                /** @type {?} */
                var specialIndex = Number(activeAllocations[i_183].specialIndex);
                // Use snapshot index or special index, whichever is positve.
                /** @type {?} */
                var metadata = void 0;
                if (index >= 0) {
                    // It may be dropped depending on the max_num_snapshots query parameter
                    // which is set to 1000 by default.
                    if (!(index in snapshots))
                        continue;
                    metadata = snapshots[index].activityMetadata;
                }
                else {
                    metadata = specialAllocations[specialIndex];
                }
                if (!metadata) {
                    continue;
                }
                this.dataTable.addRow([
                    metadata.tfOpName,
                    this.bytesToGiBs(metadata.allocationBytes),
                    this.bytesToGiBs(metadata.requestedBytes),
                    Number(activeAllocations[i_183].numOccurrences),
                    metadata.regionType,
                    metadata.dataType,
                    metadata.tensorShape,
                ]);
            }
            /** @type {?} */
            var decimalPtFormatter = new google.visualization.NumberFormat({ fractionDigits: 3 });
            decimalPtFormatter.format(this.dataTable, 1); /* requested_size */
            decimalPtFormatter.format(this.dataTable, 2); /* allocation_size */
        };
        /**
         * @return {?}
         */
        MemoryBreakdownTable.prototype.drawTable = function () {
            if (!this.table || !this.memoryProfileData) {
                return;
            }
            /** @type {?} */
            var dataView = this.getDataView();
            if (!dataView) {
                return;
            }
            /** @type {?} */
            var options = {
                allowHtml: true,
                alternatingRowStyle: false,
                showRowNumber: false,
                width: '100%',
                height: '600px',
                cssClassNames: {
                    'headerCell': 'google-chart-table-header-cell',
                    'tableCell': 'google-chart-table-table-cell',
                },
            };
            this.table.draw(dataView, ( /** @type {?} */(options)));
        };
        /**
         * @return {?}
         */
        MemoryBreakdownTable.prototype.getDataView = function () {
            if (!this.dataTable) {
                this.createDataTable();
            }
            /** @type {?} */
            var dataTable = this.getFilteredDataTable();
            if (!dataTable) {
                return null;
            }
            /** @type {?} */
            var dataView = new google.visualization.DataView(dataTable);
            dataView.setRows(dataView.getFilteredRows([{ column: 2, minValue: 0.001 }]));
            return dataView;
        };
        /**
         * @return {?}
         */
        MemoryBreakdownTable.prototype.getFilteredDataTable = function () {
            if (!this.dataTable) {
                return null;
            }
            /* tslint:disable no-any */
            /** @type {?} */
            var filters = [];
            if (this.filterOperation.trim()) {
                /** @type {?} */
                var filter_3 = this.filterOperation.trim().toLowerCase();
                filters.push(( /** @type {?} */({
                    'column': DATA_TABLE_OPERATION_INDEX,
                    'test': ( /**
                     * @param {?} value
                     * @return {?}
                     */function (value) { return value.toLowerCase().indexOf(filter_3) >= 0; }),
                })));
            }
            /* tslint:enable */
            if (filters.length > 0) {
                /** @type {?} */
                var dataView = new google.visualization.DataView(this.dataTable);
                dataView.setRows(this.dataTable.getFilteredRows(filters));
                return dataView.toDataTable();
            }
            return this.dataTable;
        };
        /**
         * @param {?} stat
         * @return {?}
         */
        MemoryBreakdownTable.prototype.bytesToGiBs = function (stat) {
            if (!stat)
                return 0;
            return Number(stat) / Math.pow(2, 30);
        };
        /**
         * @return {?}
         */
        MemoryBreakdownTable.prototype.loadGoogleChart = function () {
            var _this = this;
            if (!google || !google.charts) {
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    _this.loadGoogleChart();
                }), 100);
            }
            // tslint:disable-next-line:no-any
            (( /** @type {?} */(google.charts)))['load']('current', { 'packages': ['table'] });
            google.charts.setOnLoadCallback(( /**
             * @return {?}
             */function () {
                _this.table = new google.visualization.Table(_this.tableRef.nativeElement);
                _this.drawTable();
            }));
        };
        return MemoryBreakdownTable;
    }());
    MemoryBreakdownTable.decorators = [
        { type: Component, args: [{
                    selector: 'memory-breakdown-table',
                    template: "<div>\n  <div class=\"mat-headline\">Memory Breakdown Table</div>\n  <mat-form-field>\n    <input\n      matInput\n      placeholder=\"Operation\"\n      [value]=\"filterOperation\"\n      (input)=\"filterOperation = $event.target.value; drawTable()\"\n    />\n    <mat-icon matSuffix>search</mat-icon>\n  </mat-form-field>\n</div>\n<div [style.display]=\"true\">\n  Note: Showing active memory allocations at peak usage within the profiling window. To avoid\n  sluggishness, only the allocations with size over 1MiB are shown in the table below.\n</div>\n<br />\n<div>\n  <div #table class=\"table\"></div>\n</div>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}:host{display:block;padding:20px}mat-form-field{margin:0 8px}mat-icon{color:#777;vertical-align:bottom}.table{margin:0 -20px}\n"]
                }] }
    ];
    MemoryBreakdownTable.propDecorators = {
        memoryProfileData: [{ type: Input }],
        memoryId: [{ type: Input }],
        tableRef: [{ type: ViewChild, args: ['table', { static: false },] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MemoryBreakdownTableModule = /** @class */ (function () {
        function MemoryBreakdownTableModule() {
        }
        return MemoryBreakdownTableModule;
    }());
    MemoryBreakdownTableModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [MemoryBreakdownTable],
                    imports: [
                        MatFormFieldModule,
                        MatIconModule,
                        MatInputModule,
                    ],
                    exports: [MemoryBreakdownTable]
                },] }
    ];
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Content of a card, needed as it's used as a selector in the API.
     * \@docs-private
     */
    var MatCardContent = /** @class */ (function () {
        function MatCardContent() {
        }
        return MatCardContent;
    }());
    MatCardContent.decorators = [
        { type: Directive, args: [{
                    selector: 'mat-card-content',
                    host: { 'class': 'mat-card-content' }
                },] },
    ];
    /**
     * Title of a card, needed as it's used as a selector in the API.
     * \@docs-private
     */
    var MatCardTitle = /** @class */ (function () {
        function MatCardTitle() {
        }
        return MatCardTitle;
    }());
    MatCardTitle.decorators = [
        { type: Directive, args: [{
                    selector: "mat-card-title, [mat-card-title], [matCardTitle]",
                    host: {
                        'class': 'mat-card-title'
                    }
                },] },
    ];
    /**
     * Sub-title of a card, needed as it's used as a selector in the API.
     * \@docs-private
     */
    var MatCardSubtitle = /** @class */ (function () {
        function MatCardSubtitle() {
        }
        return MatCardSubtitle;
    }());
    MatCardSubtitle.decorators = [
        { type: Directive, args: [{
                    selector: "mat-card-subtitle, [mat-card-subtitle], [matCardSubtitle]",
                    host: {
                        'class': 'mat-card-subtitle'
                    }
                },] },
    ];
    /**
     * Action section of a card, needed as it's used as a selector in the API.
     * \@docs-private
     */
    var MatCardActions = /** @class */ (function () {
        function MatCardActions() {
            /**
             * Position of the actions inside the card.
             */
            this.align = 'start';
        }
        return MatCardActions;
    }());
    MatCardActions.decorators = [
        { type: Directive, args: [{
                    selector: 'mat-card-actions',
                    exportAs: 'matCardActions',
                    host: {
                        'class': 'mat-card-actions',
                        '[class.mat-card-actions-align-end]': 'align === "end"',
                    }
                },] },
    ];
    MatCardActions.propDecorators = {
        align: [{ type: Input }]
    };
    /**
     * Footer of a card, needed as it's used as a selector in the API.
     * \@docs-private
     */
    var MatCardFooter = /** @class */ (function () {
        function MatCardFooter() {
        }
        return MatCardFooter;
    }());
    MatCardFooter.decorators = [
        { type: Directive, args: [{
                    selector: 'mat-card-footer',
                    host: { 'class': 'mat-card-footer' }
                },] },
    ];
    /**
     * Image used in a card, needed to add the mat- CSS styling.
     * \@docs-private
     */
    var MatCardImage = /** @class */ (function () {
        function MatCardImage() {
        }
        return MatCardImage;
    }());
    MatCardImage.decorators = [
        { type: Directive, args: [{
                    selector: '[mat-card-image], [matCardImage]',
                    host: { 'class': 'mat-card-image' }
                },] },
    ];
    /**
     * Image used in a card, needed to add the mat- CSS styling.
     * \@docs-private
     */
    var MatCardSmImage = /** @class */ (function () {
        function MatCardSmImage() {
        }
        return MatCardSmImage;
    }());
    MatCardSmImage.decorators = [
        { type: Directive, args: [{
                    selector: '[mat-card-sm-image], [matCardImageSmall]',
                    host: { 'class': 'mat-card-sm-image' }
                },] },
    ];
    /**
     * Image used in a card, needed to add the mat- CSS styling.
     * \@docs-private
     */
    var MatCardMdImage = /** @class */ (function () {
        function MatCardMdImage() {
        }
        return MatCardMdImage;
    }());
    MatCardMdImage.decorators = [
        { type: Directive, args: [{
                    selector: '[mat-card-md-image], [matCardImageMedium]',
                    host: { 'class': 'mat-card-md-image' }
                },] },
    ];
    /**
     * Image used in a card, needed to add the mat- CSS styling.
     * \@docs-private
     */
    var MatCardLgImage = /** @class */ (function () {
        function MatCardLgImage() {
        }
        return MatCardLgImage;
    }());
    MatCardLgImage.decorators = [
        { type: Directive, args: [{
                    selector: '[mat-card-lg-image], [matCardImageLarge]',
                    host: { 'class': 'mat-card-lg-image' }
                },] },
    ];
    /**
     * Large image used in a card, needed to add the mat- CSS styling.
     * \@docs-private
     */
    var MatCardXlImage = /** @class */ (function () {
        function MatCardXlImage() {
        }
        return MatCardXlImage;
    }());
    MatCardXlImage.decorators = [
        { type: Directive, args: [{
                    selector: '[mat-card-xl-image], [matCardImageXLarge]',
                    host: { 'class': 'mat-card-xl-image' }
                },] },
    ];
    /**
     * Avatar image used in a card, needed to add the mat- CSS styling.
     * \@docs-private
     */
    var MatCardAvatar = /** @class */ (function () {
        function MatCardAvatar() {
        }
        return MatCardAvatar;
    }());
    MatCardAvatar.decorators = [
        { type: Directive, args: [{
                    selector: '[mat-card-avatar], [matCardAvatar]',
                    host: { 'class': 'mat-card-avatar' }
                },] },
    ];
    /**
     * A basic content container component that adds the styles of a Material design card.
     *
     * While this component can be used alone, it also provides a number
     * of preset styles for common card sections, including:
     * - mat-card-title
     * - mat-card-subtitle
     * - mat-card-content
     * - mat-card-actions
     * - mat-card-footer
     */
    var MatCard = /** @class */ (function () {
        // @breaking-change 9.0.0 `_animationMode` parameter to be made required.
        /**
         * @param {?=} _animationMode
         */
        function MatCard(_animationMode) {
            this._animationMode = _animationMode;
        }
        return MatCard;
    }());
    MatCard.decorators = [
        { type: Component, args: [{ selector: 'mat-card',
                    exportAs: 'matCard',
                    template: "<ng-content></ng-content><ng-content select=\"mat-card-footer\"></ng-content>",
                    styles: [".mat-card{transition:box-shadow 280ms cubic-bezier(.4,0,.2,1);display:block;position:relative;padding:16px;border-radius:4px}._mat-animation-noopable.mat-card{transition:none;animation:none}.mat-card .mat-divider-horizontal{position:absolute;left:0;width:100%}[dir=rtl] .mat-card .mat-divider-horizontal{left:auto;right:0}.mat-card .mat-divider-horizontal.mat-divider-inset{position:static;margin:0}[dir=rtl] .mat-card .mat-divider-horizontal.mat-divider-inset{margin-right:0}@media (-ms-high-contrast:active){.mat-card{outline:solid 1px}}.mat-card-actions,.mat-card-content,.mat-card-subtitle{display:block;margin-bottom:16px}.mat-card-title{display:block;margin-bottom:8px}.mat-card-actions{margin-left:-8px;margin-right:-8px;padding:8px 0}.mat-card-actions-align-end{display:flex;justify-content:flex-end}.mat-card-image{width:calc(100% + 32px);margin:0 -16px 16px -16px}.mat-card-footer{display:block;margin:0 -16px -16px -16px}.mat-card-actions .mat-button,.mat-card-actions .mat-raised-button,.mat-card-actions .mat-stroked-button{margin:0 8px}.mat-card-header{display:flex;flex-direction:row}.mat-card-header .mat-card-title{margin-bottom:12px}.mat-card-header-text{margin:0 16px}.mat-card-avatar{height:40px;width:40px;border-radius:50%;flex-shrink:0;object-fit:cover}.mat-card-title-group{display:flex;justify-content:space-between}.mat-card-sm-image{width:80px;height:80px}.mat-card-md-image{width:112px;height:112px}.mat-card-lg-image{width:152px;height:152px}.mat-card-xl-image{width:240px;height:240px;margin:-8px}.mat-card-title-group>.mat-card-xl-image{margin:-8px 0 8px}@media (max-width:599px){.mat-card-title-group{margin:0}.mat-card-xl-image{margin-left:0;margin-right:0}}.mat-card-content>:first-child,.mat-card>:first-child{margin-top:0}.mat-card-content>:last-child:not(.mat-card-footer),.mat-card>:last-child:not(.mat-card-footer){margin-bottom:0}.mat-card-image:first-child{margin-top:-16px;border-top-left-radius:inherit;border-top-right-radius:inherit}.mat-card>.mat-card-actions:last-child{margin-bottom:-8px;padding-bottom:0}.mat-card-actions .mat-button:first-child,.mat-card-actions .mat-raised-button:first-child,.mat-card-actions .mat-stroked-button:first-child{margin-left:0;margin-right:0}.mat-card-subtitle:not(:first-child),.mat-card-title:not(:first-child){margin-top:-4px}.mat-card-header .mat-card-subtitle:not(:first-child){margin-top:-8px}.mat-card>.mat-card-xl-image:first-child{margin-top:-8px}.mat-card>.mat-card-xl-image:last-child{margin-bottom:-8px}"],
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    host: {
                        'class': 'mat-card',
                        '[class._mat-animation-noopable]': '_animationMode === "NoopAnimations"',
                    }
                },] },
    ];
    /** @nocollapse */
    MatCard.ctorParameters = function () { return [
        { type: String, decorators: [{ type: Optional }, { type: Inject, args: [ANIMATION_MODULE_TYPE,] }] }
    ]; };
    /**
     * Component intended to be used within the `<mat-card>` component. It adds styles for a
     * preset header section (i.e. a title, subtitle, and avatar layout).
     * \@docs-private
     */
    var MatCardHeader = /** @class */ (function () {
        function MatCardHeader() {
        }
        return MatCardHeader;
    }());
    MatCardHeader.decorators = [
        { type: Component, args: [{ selector: 'mat-card-header',
                    template: "<ng-content select=\"[mat-card-avatar], [matCardAvatar]\"></ng-content><div class=\"mat-card-header-text\"><ng-content select=\"mat-card-title, mat-card-subtitle, [mat-card-title], [mat-card-subtitle], [matCardTitle], [matCardSubtitle]\"></ng-content></div><ng-content></ng-content>",
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    host: { 'class': 'mat-card-header' }
                },] },
    ];
    /**
     * Component intended to be used within the `<mat-card>` component. It adds styles for a preset
     * layout that groups an image with a title section.
     * \@docs-private
     */
    var MatCardTitleGroup = /** @class */ (function () {
        function MatCardTitleGroup() {
        }
        return MatCardTitleGroup;
    }());
    MatCardTitleGroup.decorators = [
        { type: Component, args: [{ selector: 'mat-card-title-group',
                    template: "<div><ng-content select=\"mat-card-title, mat-card-subtitle, [mat-card-title], [mat-card-subtitle], [matCardTitle], [matCardSubtitle]\"></ng-content></div><ng-content select=\"img\"></ng-content><ng-content></ng-content>",
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    host: { 'class': 'mat-card-title-group' }
                },] },
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatCardModule = /** @class */ (function () {
        function MatCardModule() {
        }
        return MatCardModule;
    }());
    MatCardModule.decorators = [
        { type: NgModule, args: [{
                    imports: [MatCommonModule],
                    exports: [
                        MatCard,
                        MatCardHeader,
                        MatCardTitleGroup,
                        MatCardContent,
                        MatCardTitle,
                        MatCardSubtitle,
                        MatCardActions,
                        MatCardFooter,
                        MatCardSmImage,
                        MatCardMdImage,
                        MatCardLgImage,
                        MatCardImage,
                        MatCardXlImage,
                        MatCardAvatar,
                        MatCommonModule,
                    ],
                    declarations: [
                        MatCard, MatCardHeader, MatCardTitleGroup, MatCardContent, MatCardTitle, MatCardSubtitle,
                        MatCardActions, MatCardFooter, MatCardSmImage, MatCardMdImage, MatCardLgImage, MatCardImage,
                        MatCardXlImage, MatCardAvatar,
                    ],
                },] },
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A memory profile summary view component.
     */
    var MemoryProfileSummary = /** @class */ (function () {
        /**
         * @param {?} changeDetector
         */
        function MemoryProfileSummary(changeDetector) {
            this.changeDetector = changeDetector;
            /**
             * The memory profile summary data.
             */
            this.data = null;
            /**
             * The selected memory ID to show memory profile for.
             */
            this.memoryId = '';
            this.title = 'Memory Profile Summary';
            this.numAllocations = 0;
            this.numDeallocations = 0;
            this.memoryCapacity = '';
            this.peakHeapUsageLifetime = '';
            this.peakMemUsageProfile = '';
            this.timestampAtPeakMs = '';
            this.stackAtPeak = '';
            this.heapAtPeak = '';
            this.freeAtPeak = '';
            this.fragmentationAtPeakPct = '';
        }
        /**
         * @return {?}
         */
        MemoryProfileSummary.prototype.ngAfterViewInit = function () {
            this.memoryProfileSummary();
            this.changeDetector.detectChanges();
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        MemoryProfileSummary.prototype.ngOnChanges = function (changes) {
            this.memoryProfileSummary();
        };
        /**
         * @return {?}
         */
        MemoryProfileSummary.prototype.memoryProfileSummary = function () {
            if (!this.data || !this.data.memoryIds || !this.data.memoryIds.length ||
                !this.data.memoryProfilePerAllocator) {
                return;
            }
            /** @type {?} */
            var summary = this.data.memoryProfilePerAllocator[this.memoryId].profileSummary;
            /** @type {?} */
            var snapshots = this.data.memoryProfilePerAllocator[this.memoryId]
                .memoryProfileSnapshots;
            if (!summary || !snapshots) {
                return;
            }
            /** @type {?} */
            var peakStats = summary.peakStats;
            if (!peakStats) {
                return;
            }
            /** @type {?} */
            var numAllocations = 0;
            /** @type {?} */
            var numDeallocations = 0;
            for (var i_184 = 0; i_184 < snapshots.length; i_184++) {
                /** @type {?} */
                var snapshot = snapshots[i_184];
                if (!snapshot || !snapshot.activityMetadata ||
                    !snapshot.activityMetadata.memoryActivity) {
                    return;
                }
                if (snapshot.activityMetadata.memoryActivity === 'ALLOCATION') {
                    numAllocations++;
                }
                else if (snapshot.activityMetadata.memoryActivity === 'DEALLOCATION') {
                    numDeallocations++;
                }
            }
            this.numAllocations = numAllocations;
            this.numDeallocations = numDeallocations;
            this.memoryCapacity =
                humanReadableText(Number(summary.memoryCapacity) || 0);
            this.peakHeapUsageLifetime =
                humanReadableText(Number(summary.peakBytesUsageLifetime) || 0);
            this.timestampAtPeakMs =
                this.picoToMilli(summary.peakStatsTimePs).toFixed(1);
            this.peakMemUsageProfile =
                humanReadableText(Number(peakStats.peakBytesInUse) || 0);
            this.stackAtPeak =
                humanReadableText(Number(peakStats.stackReservedBytes) || 0);
            this.heapAtPeak =
                humanReadableText(Number(peakStats.heapAllocatedBytes) || 0);
            this.freeAtPeak = humanReadableText(Number(peakStats.freeMemoryBytes) || 0);
            this.fragmentationAtPeakPct =
                ((peakStats.fragmentation || 0) * 100).toFixed(2) + '%';
        };
        /**
         * @param {?} timePs
         * @return {?}
         */
        MemoryProfileSummary.prototype.picoToMilli = function (timePs) {
            if (!timePs)
                return 0;
            return Number(timePs) / Math.pow(10, 9);
        };
        return MemoryProfileSummary;
    }());
    MemoryProfileSummary.decorators = [
        { type: Component, args: [{
                    selector: 'memory-profile-summary',
                    template: "<mat-card>\n  <mat-card-title>{{ title }}</mat-card-title>\n  <mat-card-content>\n    <ng-content></ng-content>\n    <div class=\"item-container\">\n      <table>\n        <tr>\n          <td>\n            <b>#Allocation</b>\n          </td>\n          <td class=\"item-value\">\n            <div>{{ numAllocations }}</div>\n          </td>\n        </tr>\n      </table>\n    </div>\n    <div class=\"item-container\">\n      <table>\n        <tr>\n          <td>\n            <b>#Deallocation</b>\n          </td>\n          <td class=\"item-value\">\n            <div>{{ numDeallocations }}</div>\n          </td>\n        </tr>\n      </table>\n    </div>\n    <div class=\"item-container\">\n      <table>\n        <tr>\n          <td>\n            <b>Memory Capacity</b>\n          </td>\n          <td class=\"item-value\">\n            <div>{{ memoryCapacity }}</div>\n          </td>\n        </tr>\n      </table>\n    </div>\n    <div class=\"item-container\">\n      <table>\n        <tr>\n          <td>\n            <b>Peak Heap Usage</b>\n            <div class=\"description\">high water mark in lifetime</div>\n          </td>\n          <td class=\"item-value\">\n            <div>{{ peakHeapUsageLifetime }}</div>\n          </td>\n        </tr>\n      </table>\n    </div>\n    <div class=\"item-container\">\n      <table>\n        <tr>\n          <td>\n            <b>Peak Memory Usage</b>\n            <div class=\"description\">stack + heap, within profiling window</div>\n          </td>\n          <td class=\"item-value\">\n            <div>{{ peakMemUsageProfile }} </div>\n          </td>\n        </tr>\n      </table>\n    </div>\n    <ul>\n      <li class=\"primary-content\">Timestamp: {{ timestampAtPeakMs }} ms</li>\n      <li class=\"primary-content\">Stack Reservation: {{ stackAtPeak }}</li>\n      <li class=\"primary-content\">Heap Allocation: {{ heapAtPeak }} </li>\n      <li class=\"primary-content\">Free Memory: {{ freeAtPeak }} </li>\n      <li class=\"primary-content\">Fragmentation: {{ fragmentationAtPeakPct }}</li>\n    </ul>\n  </mat-card-content>\n</mat-card>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}:host{border-bottom:1px solid #eee;border-right:1px solid #eee;flex-grow:1}mat-card{box-shadow:none !important;margin:8px;height:calc(100% - 48px)}@media screen and (max-width: 1140px){mat-card{min-width:500px}}mat-card-title{background-color:#fff;border-top-left-radius:4px;border-top-right-radius:4px;color:#000;font-size:24px;font-weight:400;margin-bottom:25px}:host ::ng-deep b{font-weight:500}ul{list-style-position:outside;margin-top:-16px;padding-inline-start:20px}:host ::ng-deep .item-container{margin-bottom:16px}:host ::ng-deep .item-container>table{border-spacing:0;width:100%}:host ::ng-deep .item-container>td{padding:0}:host ::ng-deep .item-value{padding-left:0px;min-width:100px;width:20%;font-size:18px;font-weight:500}.flops-utilization-tooltip-target{color:#e8710a;border-bottom:1px dotted #e8710a}\n"]
                }] }
    ];
    /** @nocollapse */
    MemoryProfileSummary.ctorParameters = function () { return [
        { type: ChangeDetectorRef }
    ]; };
    MemoryProfileSummary.propDecorators = {
        data: [{ type: Input }],
        memoryId: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MemoryProfileSummaryModule = /** @class */ (function () {
        function MemoryProfileSummaryModule() {
        }
        return MemoryProfileSummaryModule;
    }());
    MemoryProfileSummaryModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [MemoryProfileSummary],
                    imports: [
                        CommonModule,
                        MatCardModule,
                        MatTooltipModule,
                    ],
                    exports: [MemoryProfileSummary]
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var MAX_CHART_WIDTH = 1500;
    /**
     * A Memory Timeline Graph view component.
     */
    var MemoryTimelineGraph = /** @class */ (function () {
        function MemoryTimelineGraph() {
            /**
             * The memory profile data.
             */
            this.memoryProfileProtoOrNull = null;
            /**
             * The selected memory ID to show memory profile for.
             */
            this.memoryId = '';
            this.title = 'Memory Timeline Graph';
            this.height = 465;
            this.width = 0;
            this.chart = null;
        }
        /**
         * @return {?}
         */
        MemoryTimelineGraph.prototype.ngAfterViewInit = function () {
            this.loadGoogleChart();
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        MemoryTimelineGraph.prototype.ngOnChanges = function (changes) {
            var _this = this;
            setTimeout(( /**
             * @return {?}
             */function () {
                _this.width = 0;
                _this.drawChart();
            }), 100);
        };
        /**
         * @return {?}
         */
        MemoryTimelineGraph.prototype.onResize = function () {
            this.drawChart();
        };
        /**
         * @return {?}
         */
        MemoryTimelineGraph.prototype.drawChart = function () {
            if (!this.chartRef || !this.chart || this.memoryId === '' ||
                !this.memoryProfileProtoOrNull ||
                !this.memoryProfileProtoOrNull.memoryProfilePerAllocator) {
                return;
            }
            this.width =
                Math.min(MAX_CHART_WIDTH, this.chartRef.nativeElement.offsetWidth);
            /** @type {?} */
            var snapshots = this.memoryProfileProtoOrNull.memoryProfilePerAllocator[this.memoryId]
                .memoryProfileSnapshots;
            if (!snapshots)
                return;
            snapshots.sort(( /**
             * @param {?} a
             * @param {?} b
             * @return {?}
             */function (a, b) { return Number(a.timeOffsetPs) - Number(b.timeOffsetPs); }));
            /** @type {?} */
            var dataTable = new google.visualization.DataTable();
            dataTable.addColumn('number', 'timestamp(ps)');
            dataTable.addColumn('number', 'stack');
            dataTable.addColumn('number', 'heap');
            dataTable.addColumn({ type: 'string', role: 'tooltip' });
            dataTable.addColumn('number', 'free');
            dataTable.addColumn('number', 'fragmentation');
            for (var i_185 = 0; i_185 < snapshots.length; i_185++) {
                /** @type {?} */
                var stats = snapshots[i_185].aggregationStats;
                if (!stats || !snapshots[i_185].timeOffsetPs) {
                    continue;
                }
                dataTable.addRow([
                    this.picoToMilli(snapshots[i_185].timeOffsetPs),
                    this.bytesToGiBs(stats.stackReservedBytes),
                    this.bytesToGiBs(stats.heapAllocatedBytes),
                    this.getMetadataTooltip(snapshots[i_185]),
                    this.bytesToGiBs(stats.freeMemoryBytes),
                    (stats.fragmentation || 0) * 100,
                ]);
            }
            /** @type {?} */
            var options = {
                curveType: 'none',
                chartArea: { left: 60, right: 60, width: '100%' },
                hAxis: {
                    title: 'Timestamp (ms)',
                    textStyle: { bold: true },
                },
                vAxes: {
                    0: {
                        title: 'Memory Usage (GiBs)',
                        minValue: 0,
                        textStyle: { bold: true },
                    },
                    1: {
                        title: 'Fragmentation (%)',
                        minValue: 0,
                        maxValue: 100,
                        textStyle: { bold: true },
                    },
                },
                series: {
                    0: { 'targetAxisIndex': 0 },
                    1: { 'targetAxisIndex': 0 },
                    2: { 'targetAxisIndex': 0 },
                    3: {
                        'targetAxisIndex': 1,
                        // Using string parameter to prevent renaming.
                        type: 'line',
                        lineDashStyle: [4, 4],
                    },
                },
                // tslint:disable-next-line:no-any
                legend: { position: ( /** @type {?} */('top')) },
                tooltip: {
                    trigger: 'selection',
                },
                colors: ['red', 'orange', 'green'],
                height: this.height,
                isStacked: true,
                explorer: {
                    actions: ['dragToZoom', 'rightClickToReset'],
                    maxZoomIn: .001,
                    maxZoomOut: 10,
                },
            };
            this.chart.draw(dataTable, ( /** @type {?} */(options)));
        };
        /**
         * @param {?} stat
         * @return {?}
         */
        MemoryTimelineGraph.prototype.bytesToGiBs = function (stat) {
            if (!stat)
                return 0;
            return Number(stat) / Math.pow(2, 30);
        };
        /**
         * @param {?} timePs
         * @return {?}
         */
        MemoryTimelineGraph.prototype.picoToMilli = function (timePs) {
            if (!timePs)
                return 0;
            return Number(timePs) / Math.pow(10, 9);
        };
        /**
         * @param {?} snapshot
         * @return {?}
         */
        MemoryTimelineGraph.prototype.getMetadataTooltip = function (snapshot) {
            if (!snapshot)
                return '';
            /** @type {?} */
            var timestampMs = this.picoToMilli(snapshot.timeOffsetPs);
            /** @type {?} */
            var stats = snapshot.aggregationStats;
            /** @type {?} */
            var metadata = snapshot.activityMetadata;
            if (!stats || !metadata || !metadata.requestedBytes ||
                !metadata.allocationBytes || !metadata.memoryActivity) {
                return '';
            }
            /** @type {?} */
            var requestedSizeGib = this.bytesToGiBs(metadata.requestedBytes);
            /** @type {?} */
            var allocationSizeGib = this.bytesToGiBs(metadata.allocationBytes);
            if (metadata.memoryActivity === 'DEALLOCATION') {
                requestedSizeGib = -requestedSizeGib;
                allocationSizeGib = -allocationSizeGib;
            }
            /** @type {?} */
            var memInUseGib = this.bytesToGiBs(Number(stats.stackReservedBytes) +
                Number(stats.heapAllocatedBytes))
                .toFixed(4);
            /** @type {?} */
            var metadataTooltip = 'timestamp(ms): ' + timestampMs.toFixed(1);
            metadataTooltip += '\nevent: ' + metadata.memoryActivity.toLowerCase();
            if (Number(metadata.requestedBytes) > 0) {
                metadataTooltip +=
                    '\nrequested_size(GiBs): ' + requestedSizeGib.toFixed(4);
            }
            metadataTooltip +=
                '\nallocation_size(GiBs): ' + allocationSizeGib.toFixed(4);
            if (metadata.tfOpName) {
                metadataTooltip += '\ntf_op: ' + metadata.tfOpName;
            }
            if (metadata.stepId) {
                metadataTooltip += '\nstep_id: ' + metadata.stepId;
            }
            if (metadata.regionType) {
                metadataTooltip += '\nregion_type: ' + metadata.regionType;
            }
            if (metadata.dataType && metadata.dataType !== 'INVALID') {
                metadataTooltip += '\ndata_type: ' + metadata.dataType;
            }
            if (metadata.tensorShape) {
                metadataTooltip += '\ntensor_shape: ' + metadata.tensorShape;
            }
            metadataTooltip += '\n\nmemory_in_use(GiBs): ' + memInUseGib;
            return metadataTooltip;
        };
        /**
         * @return {?}
         */
        MemoryTimelineGraph.prototype.loadGoogleChart = function () {
            var _this = this;
            if (!google || !google.charts) {
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    _this.loadGoogleChart();
                }), 100);
            }
            // tslint:disable-next-line:no-any
            (( /** @type {?} */(google.charts)))['load']('current', { 'packages': ['corechart'] });
            google.charts.setOnLoadCallback(( /**
             * @return {?}
             */function () {
                _this.chart =
                    new google.visualization.AreaChart(_this.chartRef.nativeElement);
                _this.drawChart();
            }));
        };
        return MemoryTimelineGraph;
    }());
    MemoryTimelineGraph.decorators = [
        { type: Component, args: [{
                    selector: 'memory-timeline-graph',
                    template: "<mat-card>\n  <mat-card-title>{{ title }}</mat-card-title>\n  <mat-card-content>\n    <div [style.display]=\"true\">\n      Tips: Zoom in: left click and drag; Zoom out: right click; Metadata: click on heap data point.\n    </div>\n    <div #chart class=\"chart\" [style.height]=\"height + 'px'\"></div>\n  </mat-card-content>\n</mat-card>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}:host{border-bottom:1px solid #eee;border-right:1px solid #eee;flex-grow:1}mat-card{box-shadow:none !important;margin:8px;height:calc(100% - 48px)}@media screen and (max-width: 1140px){mat-card{min-width:500px}}mat-card-title{background-color:#fff;border-top-left-radius:4px;border-top-right-radius:4px;color:#000;font-size:24px;font-weight:400}.chart{margin:0 auto;max-width:1500px}\n"]
                }] }
    ];
    MemoryTimelineGraph.propDecorators = {
        memoryProfileProtoOrNull: [{ type: Input }],
        memoryId: [{ type: Input }],
        chartRef: [{ type: ViewChild, args: ['chart', { static: false },] }],
        onResize: [{ type: HostListener, args: ['window:resize',] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MemoryTimelineGraphModule = /** @class */ (function () {
        function MemoryTimelineGraphModule() {
        }
        return MemoryTimelineGraphModule;
    }());
    MemoryTimelineGraphModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [MemoryTimelineGraph],
                    imports: [MatCardModule],
                    exports: [MemoryTimelineGraph]
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A memory profile module.
     */
    var MemoryProfileModule = /** @class */ (function () {
        function MemoryProfileModule() {
        }
        return MemoryProfileModule;
    }());
    MemoryProfileModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [MemoryProfile],
                    imports: [
                        CommonModule,
                        MatDividerModule,
                        MatIconModule,
                        MatSelectModule,
                        MatOptionModule,
                        MemoryProfileSummaryModule,
                        MemoryTimelineGraphModule,
                        MemoryBreakdownTableModule,
                    ],
                    exports: [MemoryProfile]
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A memory viewer component.
     */
    var MemoryViewer = /** @class */ (function () {
        /**
         * @param {?} route
         * @param {?} dataService
         * @param {?} store
         */
        function MemoryViewer(route, dataService, store) {
            var _this = this;
            this.dataService = dataService;
            this.store = store;
            this.hloProto = null;
            /**
             * Handles on-destroy Subject, used to unsubscribe.
             */
            this.destroyed = new ReplaySubject(1);
            route.params.pipe(takeUntil(this.destroyed)).subscribe(( /**
             * @param {?} params
             * @return {?}
             */function (params) {
                _this.update(( /** @type {?} */(params)));
            }));
        }
        /**
         * @param {?} event
         * @return {?}
         */
        MemoryViewer.prototype.update = function (event) {
            var _this = this;
            this.store.dispatch(setLoadingStateAction({
                loadingState: {
                    loading: true,
                    message: 'Loading data',
                }
            }));
            this.dataService
                .getData(event.run || '', event.tag || 'memory_viewer', event.host || '')
                .pipe(takeUntil(this.destroyed))
                .subscribe(( /**
         * @param {?} data
         * @return {?}
         */function (/**
         * @param {?} data
         * @return {?}
         */ data) {
                _this.store.dispatch(setLoadingStateAction({
                    loadingState: {
                        loading: false,
                        message: '',
                    }
                }));
                _this.hloProto = ( /** @type {?} */(data));
            }));
        };
        /**
         * @return {?}
         */
        MemoryViewer.prototype.ngOnDestroy = function () {
            // Unsubscribes all pending subscriptions.
            this.destroyed.next();
            this.destroyed.complete();
        };
        return MemoryViewer;
    }());
    MemoryViewer.decorators = [
        { type: Component, args: [{
                    selector: 'memory-viewer',
                    template: "<memory-viewer-main [hloProto]=hloProto></memory-viewer-main>\n",
                    styles: ["\n"]
                }] }
    ];
    /** @nocollapse */
    MemoryViewer.ctorParameters = function () { return [
        { type: ActivatedRoute },
        { type: DataService },
        { type: Store }
    ]; };
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Injection token that can be used to specify the checkbox click behavior.
     * @type {?}
     */
    var MAT_CHECKBOX_CLICK_ACTION = new InjectionToken('mat-checkbox-click-action');
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // Increasing integer for generating unique ids for checkbox components.
    /** @type {?} */
    var nextUniqueId$6 = 0;
    /**
     * Provider Expression that allows mat-checkbox to register as a ControlValueAccessor.
     * This allows it to support [(ngModel)].
     * \@docs-private
     * @type {?}
     */
    var MAT_CHECKBOX_CONTROL_VALUE_ACCESSOR = {
        provide: NG_VALUE_ACCESSOR,
        useExisting: forwardRef(( /**
         * @return {?}
         */function () { return MatCheckbox; })),
        multi: true
    };
    /** @enum {number} */
    var TransitionCheckState = {
        /** The initial state of the component before any user interaction. */
        Init: 0,
        /** The state representing the component when it's becoming checked. */
        Checked: 1,
        /** The state representing the component when it's becoming unchecked. */
        Unchecked: 2,
        /** The state representing the component when it's becoming indeterminate. */
        Indeterminate: 3,
    };
    TransitionCheckState[TransitionCheckState.Init] = 'Init';
    TransitionCheckState[TransitionCheckState.Checked] = 'Checked';
    TransitionCheckState[TransitionCheckState.Unchecked] = 'Unchecked';
    TransitionCheckState[TransitionCheckState.Indeterminate] = 'Indeterminate';
    /**
     * Change event object emitted by MatCheckbox.
     */
    var MatCheckboxChange = /** @class */ (function () {
        function MatCheckboxChange() {
        }
        return MatCheckboxChange;
    }());
    // Boilerplate for applying mixins to MatCheckbox.
    /**
     * \@docs-private
     */
    var MatCheckboxBase = /** @class */ (function () {
        /**
         * @param {?} _elementRef
         */
        function MatCheckboxBase(_elementRef) {
            this._elementRef = _elementRef;
        }
        return MatCheckboxBase;
    }());
    /** @type {?} */
    var _MatCheckboxMixinBase = mixinTabIndex(mixinColor(mixinDisableRipple(mixinDisabled(MatCheckboxBase)), 'accent'));
    /**
     * A material design checkbox component. Supports all of the functionality of an HTML5 checkbox,
     * and exposes a similar API. A MatCheckbox can be either checked, unchecked, indeterminate, or
     * disabled. Note that all additional accessibility attributes are taken care of by the component,
     * so there is no need to provide them yourself. However, if you want to omit a label and still
     * have the checkbox be accessible, you may supply an [aria-label] input.
     * See: https://material.io/design/components/selection-controls.html
     */
    var MatCheckbox = /** @class */ (function (_super) {
        __extends(MatCheckbox, _super);
        /**
         * @param {?} elementRef
         * @param {?} _changeDetectorRef
         * @param {?} _focusMonitor
         * @param {?} _ngZone
         * @param {?} tabIndex
         * @param {?} _clickAction
         * @param {?=} _animationMode
         */
        function MatCheckbox(elementRef, _changeDetectorRef, _focusMonitor, _ngZone, tabIndex, _clickAction, _animationMode) {
            var _this = _super.call(this, elementRef) || this;
            _this._changeDetectorRef = _changeDetectorRef;
            _this._focusMonitor = _focusMonitor;
            _this._ngZone = _ngZone;
            _this._clickAction = _clickAction;
            _this._animationMode = _animationMode;
            /**
             * Attached to the aria-label attribute of the host element. In most cases, aria-labelledby will
             * take precedence so this may be omitted.
             */
            _this.ariaLabel = '';
            /**
             * Users can specify the `aria-labelledby` attribute which will be forwarded to the input element
             */
            _this.ariaLabelledby = null;
            _this._uniqueId = "mat-checkbox-" + ++nextUniqueId$6;
            /**
             * A unique id for the checkbox input. If none is supplied, it will be auto-generated.
             */
            _this.id = _this._uniqueId;
            /**
             * Whether the label should appear after or before the checkbox. Defaults to 'after'
             */
            _this.labelPosition = 'after';
            /**
             * Name value will be applied to the input element if present
             */
            _this.name = null;
            /**
             * Event emitted when the checkbox's `checked` value changes.
             */
            _this.change = new EventEmitter();
            /**
             * Event emitted when the checkbox's `indeterminate` value changes.
             */
            _this.indeterminateChange = new EventEmitter();
            /**
             * Called when the checkbox is blurred. Needed to properly implement ControlValueAccessor.
             * \@docs-private
             */
            _this._onTouched = ( /**
             * @return {?}
             */function () { });
            _this._currentAnimationClass = '';
            _this._currentCheckState = TransitionCheckState.Init;
            _this._controlValueAccessorChangeFn = ( /**
             * @return {?}
             */function () { });
            _this._checked = false;
            _this._disabled = false;
            _this._indeterminate = false;
            _this.tabIndex = parseInt(tabIndex) || 0;
            _this._focusMonitor.monitor(elementRef, true).subscribe(( /**
             * @param {?} focusOrigin
             * @return {?}
             */function (/**
             * @param {?} focusOrigin
             * @return {?}
             */ focusOrigin) {
                if (!focusOrigin) {
                    // When a focused element becomes disabled, the browser *immediately* fires a blur event.
                    // Angular does not expect events to be raised during change detection, so any state change
                    // (such as a form control's 'ng-touched') will cause a changed-after-checked error.
                    // See https://github.com/angular/angular/issues/17793. To work around this, we defer
                    // telling the form control it has been touched until the next tick.
                    Promise.resolve().then(( /**
                     * @return {?}
                     */function () {
                        _this._onTouched();
                        _changeDetectorRef.markForCheck();
                    }));
                }
            }));
            return _this;
        }
        Object.defineProperty(MatCheckbox.prototype, "inputId", {
            /**
             * Returns the unique id for the visual hidden input.
             * @return {?}
             */
            get: function () { return (this.id || this._uniqueId) + "-input"; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatCheckbox.prototype, "required", {
            /**
             * Whether the checkbox is required.
             * @return {?}
             */
            get: function () { return this._required; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this._required = coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        // TODO: Delete next major revision.
        /**
         * @return {?}
         */
        MatCheckbox.prototype.ngAfterViewChecked = function () { };
        /**
         * @return {?}
         */
        MatCheckbox.prototype.ngOnDestroy = function () {
            this._focusMonitor.stopMonitoring(this._elementRef);
        };
        Object.defineProperty(MatCheckbox.prototype, "checked", {
            /**
             * Whether the checkbox is checked.
             * @return {?}
             */
            get: function () { return this._checked; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                if (value != this.checked) {
                    this._checked = value;
                    this._changeDetectorRef.markForCheck();
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatCheckbox.prototype, "disabled", {
            /**
             * Whether the checkbox is disabled. This fully overrides the implementation provided by
             * mixinDisabled, but the mixin is still required because mixinTabIndex requires it.
             * @return {?}
             */
            get: function () { return this._disabled; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                /** @type {?} */
                var newValue = coerceBooleanProperty(value);
                if (newValue !== this.disabled) {
                    this._disabled = newValue;
                    this._changeDetectorRef.markForCheck();
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatCheckbox.prototype, "indeterminate", {
            /**
             * Whether the checkbox is indeterminate. This is also known as "mixed" mode and can be used to
             * represent a checkbox with three states, e.g. a checkbox that represents a nested list of
             * checkable items. Note that whenever checkbox is manually clicked, indeterminate is immediately
             * set to false.
             * @return {?}
             */
            get: function () { return this._indeterminate; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                /** @type {?} */
                var changed = value != this._indeterminate;
                this._indeterminate = value;
                if (changed) {
                    if (this._indeterminate) {
                        this._transitionCheckState(TransitionCheckState.Indeterminate);
                    }
                    else {
                        this._transitionCheckState(this.checked ? TransitionCheckState.Checked : TransitionCheckState.Unchecked);
                    }
                    this.indeterminateChange.emit(this._indeterminate);
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        MatCheckbox.prototype._isRippleDisabled = function () {
            return this.disableRipple || this.disabled;
        };
        /**
         * Method being called whenever the label text changes.
         * @return {?}
         */
        MatCheckbox.prototype._onLabelTextChange = function () {
            // Since the event of the `cdkObserveContent` directive runs outside of the zone, the checkbox
            // component will be only marked for check, but no actual change detection runs automatically.
            // Instead of going back into the zone in order to trigger a change detection which causes
            // *all* components to be checked (if explicitly marked or not using OnPush), we only trigger
            // an explicit change detection for the checkbox view and its children.
            this._changeDetectorRef.detectChanges();
        };
        // Implemented as part of ControlValueAccessor.
        /**
         * @param {?} value
         * @return {?}
         */
        MatCheckbox.prototype.writeValue = function (value) {
            this.checked = !!value;
        };
        // Implemented as part of ControlValueAccessor.
        /**
         * @param {?} fn
         * @return {?}
         */
        MatCheckbox.prototype.registerOnChange = function (fn) {
            this._controlValueAccessorChangeFn = fn;
        };
        // Implemented as part of ControlValueAccessor.
        /**
         * @param {?} fn
         * @return {?}
         */
        MatCheckbox.prototype.registerOnTouched = function (fn) {
            this._onTouched = fn;
        };
        // Implemented as part of ControlValueAccessor.
        /**
         * @param {?} isDisabled
         * @return {?}
         */
        MatCheckbox.prototype.setDisabledState = function (isDisabled) {
            this.disabled = isDisabled;
        };
        /**
         * @return {?}
         */
        MatCheckbox.prototype._getAriaChecked = function () {
            return this.checked ? 'true' : (this.indeterminate ? 'mixed' : 'false');
        };
        /**
         * @private
         * @param {?} newState
         * @return {?}
         */
        MatCheckbox.prototype._transitionCheckState = function (newState) {
            /** @type {?} */
            var oldState = this._currentCheckState;
            /** @type {?} */
            var element = this._elementRef.nativeElement;
            if (oldState === newState) {
                return;
            }
            if (this._currentAnimationClass.length > 0) {
                element.classList.remove(this._currentAnimationClass);
            }
            this._currentAnimationClass = this._getAnimationClassForCheckStateTransition(oldState, newState);
            this._currentCheckState = newState;
            if (this._currentAnimationClass.length > 0) {
                element.classList.add(this._currentAnimationClass);
                // Remove the animation class to avoid animation when the checkbox is moved between containers
                /** @type {?} */
                var animationClass_1 = this._currentAnimationClass;
                this._ngZone.runOutsideAngular(( /**
                 * @return {?}
                 */function () {
                    setTimeout(( /**
                     * @return {?}
                     */function () {
                        element.classList.remove(animationClass_1);
                    }), 1000);
                }));
            }
        };
        /**
         * @private
         * @return {?}
         */
        MatCheckbox.prototype._emitChangeEvent = function () {
            /** @type {?} */
            var event = new MatCheckboxChange();
            event.source = this;
            event.checked = this.checked;
            this._controlValueAccessorChangeFn(this.checked);
            this.change.emit(event);
        };
        /**
         * Toggles the `checked` state of the checkbox.
         * @return {?}
         */
        MatCheckbox.prototype.toggle = function () {
            this.checked = !this.checked;
        };
        /**
         * Event handler for checkbox input element.
         * Toggles checked state if element is not disabled.
         * Do not toggle on (change) event since IE doesn't fire change event when
         *   indeterminate checkbox is clicked.
         * @param {?} event
         * @return {?}
         */
        MatCheckbox.prototype._onInputClick = function (event) {
            var _this = this;
            // We have to stop propagation for click events on the visual hidden input element.
            // By default, when a user clicks on a label element, a generated click event will be
            // dispatched on the associated input element. Since we are using a label element as our
            // root container, the click event on the `checkbox` will be executed twice.
            // The real click event will bubble up, and the generated click event also tries to bubble up.
            // This will lead to multiple click events.
            // Preventing bubbling for the second event will solve that issue.
            event.stopPropagation();
            // If resetIndeterminate is false, and the current state is indeterminate, do nothing on click
            if (!this.disabled && this._clickAction !== 'noop') {
                // When user manually click on the checkbox, `indeterminate` is set to false.
                if (this.indeterminate && this._clickAction !== 'check') {
                    Promise.resolve().then(( /**
                     * @return {?}
                     */function () {
                        _this._indeterminate = false;
                        _this.indeterminateChange.emit(_this._indeterminate);
                    }));
                }
                this.toggle();
                this._transitionCheckState(this._checked ? TransitionCheckState.Checked : TransitionCheckState.Unchecked);
                // Emit our custom change event if the native input emitted one.
                // It is important to only emit it, if the native input triggered one, because
                // we don't want to trigger a change event, when the `checked` variable changes for example.
                this._emitChangeEvent();
            }
            else if (!this.disabled && this._clickAction === 'noop') {
                // Reset native input when clicked with noop. The native checkbox becomes checked after
                // click, reset it to be align with `checked` value of `mat-checkbox`.
                this._inputElement.nativeElement.checked = this.checked;
                this._inputElement.nativeElement.indeterminate = this.indeterminate;
            }
        };
        /**
         * Focuses the checkbox.
         * @param {?=} origin
         * @param {?=} options
         * @return {?}
         */
        MatCheckbox.prototype.focus = function (origin, options) {
            if (origin === void 0) { origin = 'keyboard'; }
            this._focusMonitor.focusVia(this._inputElement, origin, options);
        };
        /**
         * @param {?} event
         * @return {?}
         */
        MatCheckbox.prototype._onInteractionEvent = function (event) {
            // We always have to stop propagation on the change event.
            // Otherwise the change event, from the input element, will bubble up and
            // emit its event object to the `change` output.
            event.stopPropagation();
        };
        /**
         * @private
         * @param {?} oldState
         * @param {?} newState
         * @return {?}
         */
        MatCheckbox.prototype._getAnimationClassForCheckStateTransition = function (oldState, newState) {
            // Don't transition if animations are disabled.
            if (this._animationMode === 'NoopAnimations') {
                return '';
            }
            /** @type {?} */
            var animSuffix = '';
            switch (oldState) {
                case TransitionCheckState.Init:
                    // Handle edge case where user interacts with checkbox that does not have [(ngModel)] or
                    // [checked] bound to it.
                    if (newState === TransitionCheckState.Checked) {
                        animSuffix = 'unchecked-checked';
                    }
                    else if (newState == TransitionCheckState.Indeterminate) {
                        animSuffix = 'unchecked-indeterminate';
                    }
                    else {
                        return '';
                    }
                    break;
                case TransitionCheckState.Unchecked:
                    animSuffix = newState === TransitionCheckState.Checked ?
                        'unchecked-checked' : 'unchecked-indeterminate';
                    break;
                case TransitionCheckState.Checked:
                    animSuffix = newState === TransitionCheckState.Unchecked ?
                        'checked-unchecked' : 'checked-indeterminate';
                    break;
                case TransitionCheckState.Indeterminate:
                    animSuffix = newState === TransitionCheckState.Checked ?
                        'indeterminate-checked' : 'indeterminate-unchecked';
                    break;
            }
            return "mat-checkbox-anim-" + animSuffix;
        };
        return MatCheckbox;
    }(_MatCheckboxMixinBase));
    MatCheckbox.decorators = [
        { type: Component, args: [{ selector: 'mat-checkbox',
                    template: "<label [attr.for]=\"inputId\" class=\"mat-checkbox-layout\" #label><div class=\"mat-checkbox-inner-container\" [class.mat-checkbox-inner-container-no-side-margin]=\"!checkboxLabel.textContent || !checkboxLabel.textContent.trim()\"><input #input class=\"mat-checkbox-input cdk-visually-hidden\" type=\"checkbox\" [id]=\"inputId\" [required]=\"required\" [checked]=\"checked\" [attr.value]=\"value\" [disabled]=\"disabled\" [attr.name]=\"name\" [tabIndex]=\"tabIndex\" [indeterminate]=\"indeterminate\" [attr.aria-label]=\"ariaLabel || null\" [attr.aria-labelledby]=\"ariaLabelledby\" [attr.aria-checked]=\"_getAriaChecked()\" (change)=\"_onInteractionEvent($event)\" (click)=\"_onInputClick($event)\"><div matRipple class=\"mat-checkbox-ripple\" [matRippleTrigger]=\"label\" [matRippleDisabled]=\"_isRippleDisabled()\" [matRippleRadius]=\"20\" [matRippleCentered]=\"true\" [matRippleAnimation]=\"{enterDuration: 150}\"><div class=\"mat-ripple-element mat-checkbox-persistent-ripple\"></div></div><div class=\"mat-checkbox-frame\"></div><div class=\"mat-checkbox-background\"><svg version=\"1.1\" focusable=\"false\" class=\"mat-checkbox-checkmark\" viewBox=\"0 0 24 24\" xml:space=\"preserve\"><path class=\"mat-checkbox-checkmark-path\" fill=\"none\" stroke=\"white\" d=\"M4.1,12.7 9,17.6 20.3,6.3\"/></svg><div class=\"mat-checkbox-mixedmark\"></div></div></div><span class=\"mat-checkbox-label\" #checkboxLabel (cdkObserveContent)=\"_onLabelTextChange()\"><span style=\"display:none\">&nbsp;</span><ng-content></ng-content></span></label>",
                    styles: ["@keyframes mat-checkbox-fade-in-background{0%{opacity:0}50%{opacity:1}}@keyframes mat-checkbox-fade-out-background{0%,50%{opacity:1}100%{opacity:0}}@keyframes mat-checkbox-unchecked-checked-checkmark-path{0%,50%{stroke-dashoffset:22.91026}50%{animation-timing-function:cubic-bezier(0,0,.2,.1)}100%{stroke-dashoffset:0}}@keyframes mat-checkbox-unchecked-indeterminate-mixedmark{0%,68.2%{transform:scaleX(0)}68.2%{animation-timing-function:cubic-bezier(0,0,0,1)}100%{transform:scaleX(1)}}@keyframes mat-checkbox-checked-unchecked-checkmark-path{from{animation-timing-function:cubic-bezier(.4,0,1,1);stroke-dashoffset:0}to{stroke-dashoffset:-22.91026}}@keyframes mat-checkbox-checked-indeterminate-checkmark{from{animation-timing-function:cubic-bezier(0,0,.2,.1);opacity:1;transform:rotate(0)}to{opacity:0;transform:rotate(45deg)}}@keyframes mat-checkbox-indeterminate-checked-checkmark{from{animation-timing-function:cubic-bezier(.14,0,0,1);opacity:0;transform:rotate(45deg)}to{opacity:1;transform:rotate(360deg)}}@keyframes mat-checkbox-checked-indeterminate-mixedmark{from{animation-timing-function:cubic-bezier(0,0,.2,.1);opacity:0;transform:rotate(-45deg)}to{opacity:1;transform:rotate(0)}}@keyframes mat-checkbox-indeterminate-checked-mixedmark{from{animation-timing-function:cubic-bezier(.14,0,0,1);opacity:1;transform:rotate(0)}to{opacity:0;transform:rotate(315deg)}}@keyframes mat-checkbox-indeterminate-unchecked-mixedmark{0%{animation-timing-function:linear;opacity:1;transform:scaleX(1)}100%,32.8%{opacity:0;transform:scaleX(0)}}.mat-checkbox-background,.mat-checkbox-frame{top:0;left:0;right:0;bottom:0;position:absolute;border-radius:2px;box-sizing:border-box;pointer-events:none}.mat-checkbox{transition:background .4s cubic-bezier(.25,.8,.25,1),box-shadow 280ms cubic-bezier(.4,0,.2,1);cursor:pointer;-webkit-tap-highlight-color:transparent}._mat-animation-noopable.mat-checkbox{transition:none;animation:none}.mat-checkbox .mat-ripple-element:not(.mat-checkbox-persistent-ripple){opacity:.16}.mat-checkbox-layout{-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:inherit;align-items:baseline;vertical-align:middle;display:inline-flex;white-space:nowrap}.mat-checkbox-label{-webkit-user-select:auto;-moz-user-select:auto;-ms-user-select:auto;user-select:auto}.mat-checkbox-inner-container{display:inline-block;height:16px;line-height:0;margin:auto;margin-right:8px;order:0;position:relative;vertical-align:middle;white-space:nowrap;width:16px;flex-shrink:0}[dir=rtl] .mat-checkbox-inner-container{margin-left:8px;margin-right:auto}.mat-checkbox-inner-container-no-side-margin{margin-left:0;margin-right:0}.mat-checkbox-frame{background-color:transparent;transition:border-color 90ms cubic-bezier(0,0,.2,.1);border-width:2px;border-style:solid}._mat-animation-noopable .mat-checkbox-frame{transition:none}@media (-ms-high-contrast:active){.mat-checkbox.cdk-keyboard-focused .mat-checkbox-frame{border-style:dotted}}.mat-checkbox-background{align-items:center;display:inline-flex;justify-content:center;transition:background-color 90ms cubic-bezier(0,0,.2,.1),opacity 90ms cubic-bezier(0,0,.2,.1)}._mat-animation-noopable .mat-checkbox-background{transition:none}.mat-checkbox-persistent-ripple{width:100%;height:100%;transform:none}.mat-checkbox-inner-container:hover .mat-checkbox-persistent-ripple{opacity:.04}.mat-checkbox.cdk-keyboard-focused .mat-checkbox-persistent-ripple{opacity:.12}.mat-checkbox-persistent-ripple,.mat-checkbox.mat-checkbox-disabled .mat-checkbox-inner-container:hover .mat-checkbox-persistent-ripple{opacity:0}@media (hover:none){.mat-checkbox-inner-container:hover .mat-checkbox-persistent-ripple{display:none}}.mat-checkbox-checkmark{top:0;left:0;right:0;bottom:0;position:absolute;width:100%}.mat-checkbox-checkmark-path{stroke-dashoffset:22.91026;stroke-dasharray:22.91026;stroke-width:2.13333px}.mat-checkbox-mixedmark{width:calc(100% - 6px);height:2px;opacity:0;transform:scaleX(0) rotate(0);border-radius:2px}@media (-ms-high-contrast:active){.mat-checkbox-mixedmark{height:0;border-top:solid 2px;margin-top:2px}}.mat-checkbox-label-before .mat-checkbox-inner-container{order:1;margin-left:8px;margin-right:auto}[dir=rtl] .mat-checkbox-label-before .mat-checkbox-inner-container{margin-left:auto;margin-right:8px}.mat-checkbox-checked .mat-checkbox-checkmark{opacity:1}.mat-checkbox-checked .mat-checkbox-checkmark-path{stroke-dashoffset:0}.mat-checkbox-checked .mat-checkbox-mixedmark{transform:scaleX(1) rotate(-45deg)}.mat-checkbox-indeterminate .mat-checkbox-checkmark{opacity:0;transform:rotate(45deg)}.mat-checkbox-indeterminate .mat-checkbox-checkmark-path{stroke-dashoffset:0}.mat-checkbox-indeterminate .mat-checkbox-mixedmark{opacity:1;transform:scaleX(1) rotate(0)}.mat-checkbox-unchecked .mat-checkbox-background{background-color:transparent}.mat-checkbox-disabled{cursor:default}.mat-checkbox-anim-unchecked-checked .mat-checkbox-background{animation:180ms linear 0s mat-checkbox-fade-in-background}.mat-checkbox-anim-unchecked-checked .mat-checkbox-checkmark-path{animation:180ms linear 0s mat-checkbox-unchecked-checked-checkmark-path}.mat-checkbox-anim-unchecked-indeterminate .mat-checkbox-background{animation:180ms linear 0s mat-checkbox-fade-in-background}.mat-checkbox-anim-unchecked-indeterminate .mat-checkbox-mixedmark{animation:90ms linear 0s mat-checkbox-unchecked-indeterminate-mixedmark}.mat-checkbox-anim-checked-unchecked .mat-checkbox-background{animation:180ms linear 0s mat-checkbox-fade-out-background}.mat-checkbox-anim-checked-unchecked .mat-checkbox-checkmark-path{animation:90ms linear 0s mat-checkbox-checked-unchecked-checkmark-path}.mat-checkbox-anim-checked-indeterminate .mat-checkbox-checkmark{animation:90ms linear 0s mat-checkbox-checked-indeterminate-checkmark}.mat-checkbox-anim-checked-indeterminate .mat-checkbox-mixedmark{animation:90ms linear 0s mat-checkbox-checked-indeterminate-mixedmark}.mat-checkbox-anim-indeterminate-checked .mat-checkbox-checkmark{animation:.5s linear 0s mat-checkbox-indeterminate-checked-checkmark}.mat-checkbox-anim-indeterminate-checked .mat-checkbox-mixedmark{animation:.5s linear 0s mat-checkbox-indeterminate-checked-mixedmark}.mat-checkbox-anim-indeterminate-unchecked .mat-checkbox-background{animation:180ms linear 0s mat-checkbox-fade-out-background}.mat-checkbox-anim-indeterminate-unchecked .mat-checkbox-mixedmark{animation:.3s linear 0s mat-checkbox-indeterminate-unchecked-mixedmark}.mat-checkbox-input{bottom:0;left:50%}.mat-checkbox .mat-checkbox-ripple{position:absolute;left:calc(50% - 20px);top:calc(50% - 20px);height:40px;width:40px;z-index:1;pointer-events:none}"],
                    exportAs: 'matCheckbox',
                    host: {
                        'class': 'mat-checkbox',
                        '[id]': 'id',
                        '[attr.tabindex]': 'null',
                        '[class.mat-checkbox-indeterminate]': 'indeterminate',
                        '[class.mat-checkbox-checked]': 'checked',
                        '[class.mat-checkbox-disabled]': 'disabled',
                        '[class.mat-checkbox-label-before]': 'labelPosition == "before"',
                        '[class._mat-animation-noopable]': "_animationMode === 'NoopAnimations'",
                    },
                    providers: [MAT_CHECKBOX_CONTROL_VALUE_ACCESSOR],
                    inputs: ['disableRipple', 'color', 'tabIndex'],
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    MatCheckbox.ctorParameters = function () { return [
        { type: ElementRef },
        { type: ChangeDetectorRef },
        { type: FocusMonitor },
        { type: NgZone },
        { type: String, decorators: [{ type: Attribute, args: ['tabindex',] }] },
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [MAT_CHECKBOX_CLICK_ACTION,] }] },
        { type: String, decorators: [{ type: Optional }, { type: Inject, args: [ANIMATION_MODULE_TYPE,] }] }
    ]; };
    MatCheckbox.propDecorators = {
        ariaLabel: [{ type: Input, args: ['aria-label',] }],
        ariaLabelledby: [{ type: Input, args: ['aria-labelledby',] }],
        id: [{ type: Input }],
        required: [{ type: Input }],
        labelPosition: [{ type: Input }],
        name: [{ type: Input }],
        change: [{ type: Output }],
        indeterminateChange: [{ type: Output }],
        value: [{ type: Input }],
        _inputElement: [{ type: ViewChild, args: ['input', { static: false },] }],
        ripple: [{ type: ViewChild, args: [MatRipple, { static: false },] }],
        checked: [{ type: Input }],
        disabled: [{ type: Input }],
        indeterminate: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var MAT_CHECKBOX_REQUIRED_VALIDATOR = {
        provide: NG_VALIDATORS,
        useExisting: forwardRef(( /**
         * @return {?}
         */function () { return MatCheckboxRequiredValidator; })),
        multi: true
    };
    /**
     * Validator for Material checkbox's required attribute in template-driven checkbox.
     * Current CheckboxRequiredValidator only work with `input type=checkbox` and does not
     * work with `mat-checkbox`.
     */
    var MatCheckboxRequiredValidator = /** @class */ (function (_super) {
        __extends(MatCheckboxRequiredValidator, _super);
        function MatCheckboxRequiredValidator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return MatCheckboxRequiredValidator;
    }(CheckboxRequiredValidator));
    MatCheckboxRequiredValidator.decorators = [
        { type: Directive, args: [{
                    selector: "mat-checkbox[required][formControlName],\n             mat-checkbox[required][formControl], mat-checkbox[required][ngModel]",
                    providers: [MAT_CHECKBOX_REQUIRED_VALIDATOR],
                },] },
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * This module is used by both original and MDC-based checkbox implementations.
     */
    // tslint:disable-next-line:class-name
    var _MatCheckboxRequiredValidatorModule = /** @class */ (function () {
        function _MatCheckboxRequiredValidatorModule() {
        }
        return _MatCheckboxRequiredValidatorModule;
    }());
    _MatCheckboxRequiredValidatorModule.decorators = [
        { type: NgModule, args: [{
                    exports: [MatCheckboxRequiredValidator],
                    declarations: [MatCheckboxRequiredValidator],
                },] },
    ];
    var MatCheckboxModule = /** @class */ (function () {
        function MatCheckboxModule() {
        }
        return MatCheckboxModule;
    }());
    MatCheckboxModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule, MatRippleModule, MatCommonModule, ObserversModule,
                        _MatCheckboxRequiredValidatorModule
                    ],
                    exports: [MatCheckbox, MatCommonModule, _MatCheckboxRequiredValidatorModule],
                    declarations: [MatCheckbox],
                },] },
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A max heap chart view component.
     */
    var MaxHeapChart = /** @class */ (function () {
        function MaxHeapChart() {
            /**
             * The heap object list.
             */
            this.maxHeap = [];
            /**
             * The title of view component.
             */
            this.title = '';
            /**
             * The selected item index.
             */
            this.selectedIndex = -1;
            /**
             * The event when the selection of the chart is changed.
             */
            this.selected = new EventEmitter();
            this.chart = null;
        }
        /**
         * @return {?}
         */
        MaxHeapChart.prototype.ngOnInit = function () {
            this.loadGoogleChart();
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        MaxHeapChart.prototype.ngOnChanges = function (changes) {
            if (changes['maxHeap']) {
                this.drawChart();
            }
            if (changes['selectedIndex']) {
                this.updateSelection();
            }
        };
        /**
         * @return {?}
         */
        MaxHeapChart.prototype.drawChart = function () {
            var _this = this;
            if (!this.chart || !this.maxHeap) {
                return;
            }
            /** @type {?} */
            var data = [0].concat(this.maxHeap.map(( /**
             * @param {?} heapObject
             * @return {?}
             */function (/**
             * @param {?} heapObject
             * @return {?}
             */ heapObject) {
                return heapObject ? heapObject.sizeMiB || 0 : 0;
            })));
            /** @type {?} */
            var chartItemColors = this.maxHeap.map(( /**
             * @param {?} heapObject
             * @return {?}
             */function (/**
             * @param {?} heapObject
             * @return {?}
             */ heapObject) { return getChartItemColorByIndex(heapObject.color || 0); }));
            /** @type {?} */
            var dataTable = google.visualization.arrayToDataTable([
                Array.from({ length: data.length }).fill(''),
                data,
            ]);
            /** @type {?} */
            var options = {
                bar: { groupWidth: '100%' },
                colors: chartItemColors,
                chartArea: {
                    left: 0,
                    right: 0,
                    width: '100%',
                    height: '100%',
                },
                isStacked: 'percent',
                legend: { position: 'none' },
                orientation: 'vertical',
                tooltip: { trigger: 'none' },
                hAxis: { baselineColor: 'transparent' },
                vAxis: { baselineColor: 'transparent' },
            };
            this.chart.draw(dataTable, ( /** @type {?} */(options)));
            google.visualization.events.addListener(this.chart, 'click', ( /**
             * @return {?}
             */function () {
                if (_this.chart) {
                    _this.chart.setSelection([]);
                }
            }));
            google.visualization.events.addListener(this.chart, 'onmouseout', ( /**
             * @return {?}
             */function () {
                if (_this.chart) {
                    _this.chart.setSelection([]);
                }
                _this.selected.emit(-1);
            }));
            google.visualization.events.addListener(this.chart, 'onmouseover', ( /**
             * @param {?} event
             * @return {?}
             */function (event) {
                event = event || {};
                /** @type {?} */
                var arr = [];
                arr.push(event);
                if (_this.chart) {
                    _this.chart.setSelection(arr);
                }
                _this.selected.emit((event.column || 0) - 1);
            }));
        };
        /**
         * @return {?}
         */
        MaxHeapChart.prototype.loadGoogleChart = function () {
            var _this = this;
            if (!google || !google.charts) {
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    _this.loadGoogleChart();
                }), 100);
            }
            google.charts.load('current', { 'packages': ['corechart'] });
            google.charts.setOnLoadCallback(( /**
             * @return {?}
             */function () {
                _this.chart =
                    new google.visualization.ColumnChart(_this.chartRef.nativeElement);
                _this.drawChart();
            }));
        };
        /**
         * @return {?}
         */
        MaxHeapChart.prototype.updateSelection = function () {
            if (!this.chart) {
                return;
            }
            this.chart.setSelection([{ row: 0, column: this.selectedIndex + 1 }]);
        };
        return MaxHeapChart;
    }());
    MaxHeapChart.decorators = [
        { type: Component, args: [{
                    selector: 'max-heap-chart',
                    template: "<div [className]=\"maxHeap.length ? 'auto-height' : 'hidden-content'\">\n  <div class=\"mat-headline\">{{title}} ({{maxHeap?.length}})</div>\n  <div class=\"description\">Hover over a bar for buffer details to appear on the left.</div>\n  <div class=\"chart\" #chart></div>\n</div>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}:host{display:block;margin:20px}.description{margin-top:-16px}.chart{margin-top:24px;width:1200px;height:100px}\n"]
                }] }
    ];
    MaxHeapChart.propDecorators = {
        maxHeap: [{ type: Input }],
        title: [{ type: Input }],
        selectedIndex: [{ type: Input }],
        selected: [{ type: Output }],
        chartRef: [{ type: ViewChild, args: ['chart', { static: false },] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MaxHeapChartModule = /** @class */ (function () {
        function MaxHeapChartModule() {
        }
        return MaxHeapChartModule;
    }());
    MaxHeapChartModule.decorators = [
        { type: NgModule, args: [{ declarations: [MaxHeapChart], exports: [MaxHeapChart] },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A program order chart view component.
     */
    var ProgramOrderChart = /** @class */ (function () {
        function ProgramOrderChart() {
            /**
             * The heap size list.
             */
            this.heapSizes = [];
            /**
             * The unpadded heap size list.
             */
            this.unpaddedHeapSizes = [];
            this.activeChart = null;
            this.chart = null;
            this.peakChart = null;
            this.maxSize = 0;
            this.maxOrder = 0;
        }
        /**
         * @return {?}
         */
        ProgramOrderChart.prototype.ngOnInit = function () {
            this.loadGoogleChart();
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        ProgramOrderChart.prototype.ngOnChanges = function (changes) {
            if (changes['heapSizes'] || changes['unpaddedHeapSizes']) {
                this.drawChart();
            }
            if (changes['peakInfo']) {
                this.drawPeakChart();
            }
            if (changes['activeInfo']) {
                this.drawActiveChart();
            }
        };
        /**
         * @return {?}
         */
        ProgramOrderChart.prototype.drawActiveChart = function () {
            if (!this.activeChart) {
                return;
            }
            if (!this.activeInfo) {
                this.activeChart.clearChart();
                return;
            }
            /** @type {?} */
            var dataTable = google.visualization.arrayToDataTable([
                ['X', 'Size'],
                [this.activeInfo.alloc, this.activeInfo.size],
                [this.activeInfo.free, this.activeInfo.size],
            ]);
            /** @type {?} */
            var options = {
                areaOpacity: 0.7,
                backgroundColor: 'transparent',
                chartArea: {
                    left: 50,
                    right: 50,
                    width: '90%',
                    height: '90%',
                },
                colors: [this.activeInfo.color || ''],
                focusTarget: 'none',
                hAxis: {
                    baselineColor: 'transparent',
                    gridlines: { color: 'transparent' },
                    textPosition: 'none',
                    viewWindow: {
                        min: 0,
                        max: this.maxOrder,
                    },
                },
                vAxis: {
                    baselineColor: 'transparent',
                    gridlines: { color: 'transparent' },
                    textPosition: 'none',
                    viewWindow: {
                        min: 0,
                        max: this.maxSize,
                    },
                },
                legend: { position: 'none' },
                lineWidth: 2,
            };
            this.activeChart.draw(dataTable, ( /** @type {?} */(options)));
        };
        /**
         * @return {?}
         */
        ProgramOrderChart.prototype.drawChart = function () {
            if (!this.chart || !this.heapSizes.length ||
                !this.unpaddedHeapSizes.length) {
                return;
            }
            /** @type {?} */
            var data = [];
            this.maxOrder = this.heapSizes.length - 1;
            this.maxSize = 0;
            for (var i_186 = 0; i_186 < this.heapSizes.length; i_186++) {
                this.maxSize = Math.max(this.maxSize, Math.max(this.heapSizes[i_186], this.unpaddedHeapSizes[i_186]));
                data.push([i_186, this.heapSizes[i_186], this.unpaddedHeapSizes[i_186]]);
            }
            this.maxSize = Math.round(this.maxSize * 1.1);
            /** @type {?} */
            var dataTable = new google.visualization.DataTable();
            dataTable.addColumn('number', 'X');
            dataTable.addColumn('number', 'Size');
            dataTable.addColumn('number', 'Unpadded Size');
            dataTable.addRows(data);
            /** @type {?} */
            var options = {
                backgroundColor: 'transparent',
                chartArea: {
                    left: 50,
                    right: 50,
                    width: '90%',
                    height: '90%',
                },
                focusTarget: 'none',
                hAxis: {
                    baselineColor: 'transparent',
                    viewWindow: {
                        min: 0,
                        max: this.maxOrder,
                    },
                },
                vAxis: {
                    baselineColor: 'transparent',
                    viewWindow: {
                        min: 0,
                        max: this.maxSize,
                    },
                },
                legend: { position: 'top' },
            };
            this.chart.draw(dataTable, ( /** @type {?} */(options)));
        };
        /**
         * @return {?}
         */
        ProgramOrderChart.prototype.drawPeakChart = function () {
            if (!this.peakChart || !this.peakInfo) {
                return;
            }
            /** @type {?} */
            var peakWidth = Math.max(Math.round(this.maxOrder / 50), 1);
            /** @type {?} */
            var peakAlloc = Math.max(Math.round(this.peakInfo.alloc - peakWidth / 2), 0);
            /** @type {?} */
            var peakFree = Math.min(peakAlloc + peakWidth, this.maxOrder);
            /** @type {?} */
            var dataTable = google.visualization.arrayToDataTable([
                ['X', 'Size'],
                [peakAlloc, this.peakInfo.size],
                [peakFree, this.peakInfo.size],
            ]);
            /** @type {?} */
            var options = {
                backgroundColor: 'transparent',
                chartArea: {
                    left: 50,
                    right: 50,
                    width: '90%',
                    height: '90%',
                },
                colors: ['#00ff00'],
                focusTarget: 'none',
                hAxis: {
                    baselineColor: 'transparent',
                    gridlines: { color: 'transparent' },
                    textPosition: 'none',
                    viewWindow: {
                        min: 0,
                        max: this.maxOrder,
                    },
                },
                vAxis: {
                    baselineColor: 'transparent',
                    gridlines: { color: 'transparent' },
                    textPosition: 'none',
                    viewWindow: {
                        min: 0,
                        max: this.maxSize,
                    },
                },
                legend: { position: 'none' },
                lineWidth: 0,
            };
            this.peakChart.draw(dataTable, ( /** @type {?} */(options)));
        };
        /**
         * @return {?}
         */
        ProgramOrderChart.prototype.loadGoogleChart = function () {
            var _this = this;
            if (!google || !google.charts) {
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    _this.loadGoogleChart();
                }), 100);
            }
            google.charts.load('current', { 'packages': ['corechart'] });
            google.charts.setOnLoadCallback(( /**
             * @return {?}
             */function () {
                _this.activeChart =
                    new google.visualization.AreaChart(_this.activeChartRef.nativeElement);
                _this.chart =
                    new google.visualization.LineChart(_this.chartRef.nativeElement);
                _this.peakChart =
                    new google.visualization.AreaChart(_this.peakChartRef.nativeElement);
                _this.drawChart();
                _this.drawPeakChart();
                _this.drawActiveChart();
            }));
        };
        return ProgramOrderChart;
    }());
    ProgramOrderChart.decorators = [
        { type: Component, args: [{
                    selector: 'program-order-chart',
                    template: "<div [className]=\"heapSizes.length ? 'auto-height' : 'hidden-content'\">\n  <div class=\"mat-headline\">Working Space Size (MiB) vs Program Order (HLO Sequence)</div>\n  <div class=\"chart-container\">\n    <div class=\"chart\" #peakChart></div>\n    <div class=\"chart\" #chart></div>\n    <div class=\"chart\" #activeChart></div>\n  </div>\n</div>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}:host{display:block;margin:20px}.chart-container{position:relative;width:1200px;height:380px}.chart{position:absolute;top:0;left:0;width:1200px;height:380px}\n"]
                }] }
    ];
    ProgramOrderChart.propDecorators = {
        heapSizes: [{ type: Input }],
        unpaddedHeapSizes: [{ type: Input }],
        peakInfo: [{ type: Input }],
        activeInfo: [{ type: Input }],
        activeChartRef: [{ type: ViewChild, args: ['activeChart', { static: false },] }],
        chartRef: [{ type: ViewChild, args: ['chart', { static: false },] }],
        peakChartRef: [{ type: ViewChild, args: ['peakChart', { static: false },] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ProgramOrderChartModule = /** @class */ (function () {
        function ProgramOrderChartModule() {
        }
        return ProgramOrderChartModule;
    }());
    ProgramOrderChartModule.decorators = [
        { type: NgModule, args: [{ declarations: [ProgramOrderChart], exports: [ProgramOrderChart] },] }
    ];
    /**
     * HLO assigned buffer allocation representation.
     * @final
     */
    var BufferAllocationAssigned = /** @class */ (function () {
        function BufferAllocationAssigned(assigned) {
            assigned = assigned || {};
            this.logicalBufferId = toNumber(assigned.logicalBufferId);
            this.offset = toNumber(assigned.offset);
            this.size = toNumber(assigned.size);
        }
        return BufferAllocationAssigned;
    }());
    /**
     * HLO buffer allocation representation.
     * @final
     */
    var BufferAllocation = /** @class */ (function () {
        function BufferAllocation(allocation) {
            allocation = allocation || {};
            this.index = toNumber(allocation.index);
            this.size = toNumber(allocation.size);
            this.isThreadLocal = allocation.isThreadLocal || false;
            this.assigned = this.getAllocation(allocation);
            this.groupName = this.getGroupName(allocation);
        }
        BufferAllocation.prototype.getAllocation = function (allocation) {
            return allocation.assigned ?
                allocation.assigned.map(function (assigned) { return new BufferAllocationAssigned(assigned); }) :
                [];
        };
        BufferAllocation.prototype.getGroupName = function (allocation) {
            if (allocation.isEntryComputationParameter) {
                return 'Parameter';
            }
            else if (allocation.maybeLiveOut) {
                return 'Output';
            }
            else if (allocation.isThreadLocal) {
                return 'Thread-local';
            }
            return 'Temporary';
        };
        return BufferAllocation;
    }());
    /**
     * A layout describes how the array is placed in (1D) memory space. This
     * includes the minor-to-major ordering of dimensions within a shape, as well
     * as size, alignment and semantics.
     * @final
     */
    var Layout = /** @class */ (function () {
        function Layout(layout, dimensions, elementType) {
            if (dimensions === void 0) { dimensions = []; }
            if (elementType === void 0) { elementType = ''; }
            layout = layout || {};
            this.format = layout.format || '';
            this.minorToMajor = [];
            this.dimensions = [];
            this.maxSparseElements = 0;
            if (layout.minorToMajor) {
                this.minorToMajor = layout.minorToMajor.map(function (item) { return Number(item); });
                this.dimensions =
                    this.analyzeLayout(dimensions, this.minorToMajor, elementType);
            }
        }
        Layout.prototype.analyzeLayout = function (dimensions, minorToMajor, elementType) {
            var e_33, _b;
            var result = [];
            try {
                for (var minorToMajor_1 = __values(minorToMajor), minorToMajor_1_1 = minorToMajor_1.next(); !minorToMajor_1_1.done; minorToMajor_1_1 = minorToMajor_1.next()) {
                    var index = minorToMajor_1_1.value;
                    var size = dimensions[index];
                    var alignment = 0;
                    if (result.length === 0) {
                        alignment = 128;
                    }
                    else if (result.length === 1) {
                        if (size <= 2) {
                            if (elementType === 'BF16') {
                                alignment = 4;
                            }
                            else {
                                alignment = 2;
                            }
                        }
                        else if (size <= 4) {
                            alignment = 4;
                        }
                        else {
                            alignment = 8;
                        }
                    }
                    result.push({ 'size': size, 'alignment': alignment });
                }
            }
            catch (e_33_1) { e_33 = { error: e_33_1 }; }
            finally {
                try {
                    if (minorToMajor_1_1 && !minorToMajor_1_1.done && (_b = minorToMajor_1.return)) _b.call(minorToMajor_1);
                }
                finally { if (e_33) throw e_33.error; }
            }
            return result;
        };
        /**
         * Returns a human-readable string that represents the given layout.
         * @return {string}
         */
        Layout.prototype.humanLayoutString = function () {
            if (this.format === 'SPARSE') {
                return 'sparse{' + this.maxSparseElements.toString() + '}';
            }
            else if (this.format === 'DENSE') {
                return '{' + this.minorToMajor.join() + '}';
            }
            return '';
        };
        return Layout;
    }());
    /**
     * A shape describes the number of dimensions in the array, the size of each
     * dimension, and the primitive component type. Tuples are a special case in
     * that they have rank zero and have tuple_shapes defined.
     * @final
     */
    var Shape = /** @class */ (function () {
        function Shape(shape) {
            shape = shape || {};
            this.elementType = shape.elementType || '';
            this.dimensions = [];
            this.tupleShapes = [];
            if (shape.dimensions) {
                this.dimensions = shape.dimensions.map(function (item) { return Number(item); });
            }
            if (shape.tupleShapes) {
                this.tupleShapes = shape.tupleShapes.map(function (item) { return new Shape(item); });
            }
            if (shape.layout) {
                this.layout = new Layout(shape.layout, this.dimensions, shape.elementType);
            }
        }
        /**
         * Returns a human-readable string that represents the given shape, with
         * layout. e.g. "f32[42x12] {0, 1}"
         * @return {string}
         */
        Shape.prototype.humanStringWithLayout = function () {
            if (this.elementType === 'TUPLE') {
                return "(" + this.tupleShapes.map(function (shape) { return shape.humanStringWithLayout(); })
                    .join(', ') + ")";
            }
            var result = this.elementType + '[' + this.dimensions.join() + ']';
            if (this.elementType !== 'OPAQUE' && this.elementType !== 'TOKEN' &&
                this.dimensions.length > 0 && this.layout) {
                return result + this.layout.humanLayoutString();
            }
            return result;
        };
        /**
         * Resolve the right shape from the shapeIndex.
         * @param {!Array<number>} shapeIndex
         * @return {!Shape}
         */
        Shape.prototype.resolveShapeIndex = function (shapeIndex) {
            if (shapeIndex.length === 0)
                return this;
            return shapeIndex.reduce(function (shape, item) { return shape.tupleShapes[item]; }, this);
        };
        /**
         * Returns the size of shape with out padding.
         * @return {number}
         */
        Shape.prototype.unpaddedHeapSizeBytes = function () {
            var INT64_BYTES = 8;
            if (this.elementType === 'TOKEN') {
                return 0;
            }
            if (this.elementType === 'TUPLE') {
                return INT64_BYTES * this.tupleShapes.length;
            }
            var byteSize = 0;
            if (!this.layout || this.layout.format === 'DENSE') {
                var allocatedElementCount = this.dimensions.reduce(function (count, item) { return count * item; }, 1);
                byteSize += allocatedElementCount *
                    byteSizeOfPrimitiveType(this.elementType);
            }
            else if (this.layout.format === 'SPARSE') {
                var maxElements = this.layout.maxSparseElements;
                byteSize = maxElements * byteSizeOfPrimitiveType(this.elementType);
                byteSize += maxElements * this.dimensions.length * INT64_BYTES;
            }
            return byteSize;
        };
        return Shape;
    }());
    /**
     * HLO instructions are the IR used by the high-level XLA compiler.
     * @final
     */
    var HloInstruction = /** @class */ (function () {
        function HloInstruction(instruction) {
            instruction = instruction || {};
            this.name = instruction.name || '';
            this.opcode = instruction.opcode || '';
            if (instruction.shape) {
                this.shape = new Shape(instruction.shape);
            }
            if (instruction.metadata) {
                this.tfOpName = instruction.metadata.opName || '';
            }
        }
        return HloInstruction;
    }());
    /**
     * HLO logical buffer representation.
     * @final
     */
    var LogicalBuffer = /** @class */ (function () {
        function LogicalBuffer(buffer) {
            buffer = buffer || {};
            this.id = toNumber(buffer.id || '0');
            this.size = toNumber(buffer.size || '0');
            this.color = toNumber(buffer.color || '0');
            this.computationName = '';
            this.instructionName = '';
            this.shapeIndex = [];
            if (buffer.definedAt) {
                this.initBufferLocation(buffer.definedAt);
            }
        }
        /**
         * Constructs the computation, instruction and its shape index, which
         * uniquely identifies a point where a buffer is defined.
         */
        LogicalBuffer.prototype.initBufferLocation = function (location) {
            if (!location)
                return;
            this.computationName = location.computationName || '';
            this.instructionName = location.instructionName || '';
            if (location.shapeIndex) {
                this.shapeIndex = location.shapeIndex.map(function (item) { return Number(item); });
            }
        };
        return LogicalBuffer;
    }());
    /**
     * Provides calculation of memory usage from xla buffer assignment.
     * @final
     */
    var MemoryUsage = /** @class */ (function () {
        function MemoryUsage(hloProto, memorySpaceColor, includeNotSimulated) {
            this.includeNotSimulated = includeNotSimulated;
            this.buffers = [];
            this.idToBuffer = {};
            this.idToBufferAllocation = {};
            this.nameToHlo = {};
            this.unSeenLogicalBuffers = new Set();
            this.seenBufferAllocations = new Set();
            this.nColor = 0;
            this.rest = 0;
            this.smallBufferCount = 0;
            this.peakHeapSizeBytes = 0;
            this.unpaddedPeakHeapSizeBytes = 0;
            this.peakLogicalBuffers = [];
            this.peakHeapSizePosition = 0;
            this.indefiniteMemoryUsageBytes = { padded: 0, unpadded: 0 };
            this.heapSizes = [];
            this.unpaddedHeapSizes = [];
            this.maxHeap = [];
            this.maxHeapBySize = [];
            this.maxHeapByPaddingSize = [];
            this.bySizeToMaxHeap = [];
            this.maxHeapToBySize = [];
            this.byPaddingSizeToMaxHeap = [];
            this.maxHeapToByPaddingSize = [];
            this.logicalBufferSpans = {};
            this.smallBufferSize = 16 * 1024;
            this.initHloInstructions(hloProto.hloModule);
            this.initMemoryUsage(memorySpaceColor, hloProto.bufferAssignment);
            this.initMaxHeap();
        }
        /**
         * Adds the logical buffer as an element in the maxHeap with constitutent
         * logical buffers.
         */
        MemoryUsage.prototype.addHeapObject = function (buffer, groupName) {
            if (buffer.size <= this.smallBufferSize) {
                this.rest += buffer.size;
                this.smallBufferCount++;
                return;
            }
            var shape = new Shape();
            var inst = new HloInstruction();
            if (buffer.instructionName) {
                inst = this.nameToHlo[buffer.instructionName];
                if (inst && inst.shape) {
                    shape = inst.shape.resolveShapeIndex(buffer.shapeIndex);
                }
            }
            var heapObject = this.newHeapObject(buffer, shape, inst, groupName);
            if (heapObject) {
                this.maxHeap.push(heapObject);
            }
        };
        /**
         * Calculate the indefinite memory usage from the unseen logical buffers.
         * Assume they have indefinite lifetime if they are not in thread-local buffer
         * allocations.
         * @private
         */
        MemoryUsage.prototype.findIndefiniteMemoryUsage = function (buffers, color) {
            var _this = this;
            var usageBytes = { padded: 0, unpadded: 0 };
            buffers.forEach(function (id) {
                var alloc = _this.idToBufferAllocation[id];
                if (!alloc || alloc.isThreadLocal) {
                    return;
                }
                if (!_this.idToBuffer[id] || _this.idToBuffer[id].color !== color)
                    return;
                if (!_this.seenBufferAllocations.has(alloc.index)) {
                    usageBytes.padded += alloc.size;
                    _this.seenBufferAllocations.add(alloc.index);
                    // Add all logical buffers assigned to the allocation to HeapObjects.
                    // Since we don't know the heap simulator traces of those buffers,
                    // simply estimate the total padding size with average padding.
                    var padded_1 = 0;
                    var unpadded_1 = 0;
                    alloc.assigned.forEach(function (assigned) {
                        var buffer = _this.idToBuffer[assigned.logicalBufferId];
                        var shape = null;
                        if (buffer.instructionName) {
                            var hlo = _this.nameToHlo[buffer.instructionName];
                            if (hlo && hlo.shape) {
                                shape = hlo.shape.resolveShapeIndex(buffer.shapeIndex);
                            }
                        }
                        _this.addHeapObject(buffer, alloc.groupName);
                        unpadded_1 += shape ? shape.unpaddedHeapSizeBytes() : buffer.size;
                        padded_1 += buffer.size;
                    });
                    usageBytes.unpadded += Math.floor(alloc.size * unpadded_1 / padded_1);
                }
            });
            this.indefiniteMemoryUsageBytes = usageBytes;
            return usageBytes;
        };
        /**
         * Finds the peak memory usage from the `HeapSimulatorTrace`.
         */
        MemoryUsage.prototype.findPeakMemoryUsage = function (trace, color) {
            var e_34, _b;
            var heapSizes = [];
            var unpaddedHeapSizes = [];
            var logicalBuffers = [];
            var peakLogicalBuffers = [];
            var heapSizeBytes = 0;
            var unpaddedHeapSizeBytes = 0;
            var peakHeapSizeBytes = 0;
            var unpaddedPeakHeapSizeBytes = 0;
            var peakHeapSizePosition = 0;
            if (trace) {
                var _loop_7 = function (event_1) {
                    heapSizes.push(bytesToMiB(heapSizeBytes));
                    unpaddedHeapSizes.push(bytesToMiB(unpaddedHeapSizeBytes));
                    var eventId = toNumber(event_1.bufferId);
                    var buffer = this_2.idToBuffer[eventId];
                    this_2.unSeenLogicalBuffers.delete(eventId);
                    var alloc = this_2.idToBufferAllocation[eventId];
                    if (alloc) {
                        this_2.seenBufferAllocations.add(alloc.index);
                    }
                    var shape = null;
                    if (buffer.instructionName && buffer.instructionName !== '') {
                        var hlo = this_2.nameToHlo[buffer.instructionName];
                        if (hlo && hlo.shape) {
                            shape = hlo.shape.resolveShapeIndex(buffer.shapeIndex);
                        }
                    }
                    switch (event_1.kind) {
                        // Default to 'ALLOC' when event.kind is undefined. This is because
                        // by default proto3 primitive fields with default values will be
                        // omitted in JSON output.
                        case undefined:
                        case 'ALLOC':
                        case 'SHARE_WITH':
                            logicalBuffers.push(eventId);
                            heapSizeBytes += buffer.size;
                            if (shape) {
                                unpaddedHeapSizeBytes += shape.unpaddedHeapSizeBytes();
                            }
                            this_2.logicalBufferSpans[eventId] = [heapSizes.length - 1, -1];
                            if (heapSizeBytes > peakHeapSizeBytes) {
                                peakHeapSizeBytes = heapSizeBytes;
                                unpaddedPeakHeapSizeBytes = unpaddedHeapSizeBytes;
                                peakHeapSizePosition = heapSizes.length - 1;
                                peakLogicalBuffers = logicalBuffers.slice();
                            }
                            break;
                        case 'FREE':
                            logicalBuffers = logicalBuffers.filter(function (item) {
                                return item !== eventId;
                            });
                            heapSizeBytes -= buffer.size;
                            if (shape) {
                                unpaddedHeapSizeBytes -= shape.unpaddedHeapSizeBytes();
                            }
                            if (!this_2.logicalBufferSpans[eventId]) {
                                // The logical buffer is not allocated in this module.
                                this_2.logicalBufferSpans[eventId] = [0, heapSizes.length - 1];
                                console.warn(event_1, ' is freed but has seen no allocation event.');
                            }
                            else {
                                this_2.logicalBufferSpans[eventId][1] = heapSizes.length - 1;
                            }
                            if (heapSizeBytes < 0) {
                                console.error('heap_size_bytes < 0');
                            }
                            break;
                        default:
                            console.log('ERROR: unknown heap event kind: ', event_1);
                            break;
                    }
                };
                var this_2 = this;
                try {
                    for (var _c = __values(trace.events || []), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var event_1 = _d.value;
                        _loop_7(event_1);
                    }
                }
                catch (e_34_1) { e_34 = { error: e_34_1 }; }
                finally {
                    try {
                        if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
                    }
                    finally { if (e_34) throw e_34.error; }
                }
                heapSizes.push(bytesToMiB(heapSizeBytes));
                unpaddedHeapSizes.push(bytesToMiB(unpaddedHeapSizeBytes));
            }
            this.peakLogicalBuffers = peakLogicalBuffers;
            this.peakHeapSizePosition = peakHeapSizePosition;
            if (this.includeNotSimulated) {
                var indefiniteMemoryUsageBytes = this.findIndefiniteMemoryUsage(this.unSeenLogicalBuffers, color);
                this.peakHeapSizeBytes =
                    peakHeapSizeBytes + indefiniteMemoryUsageBytes.padded;
                this.unpaddedPeakHeapSizeBytes =
                    unpaddedPeakHeapSizeBytes + indefiniteMemoryUsageBytes.unpadded;
                var addendPadded_1 = bytesToMiB(indefiniteMemoryUsageBytes.padded);
                this.heapSizes = heapSizes.map(function (item) { return item + addendPadded_1; });
                var addendUnpadded_1 = bytesToMiB(indefiniteMemoryUsageBytes.unpadded);
                this.unpaddedHeapSizes =
                    unpaddedHeapSizes.map(function (item) { return item + addendUnpadded_1; });
            }
            else {
                this.peakHeapSizeBytes = peakHeapSizeBytes;
                this.unpaddedPeakHeapSizeBytes = unpaddedPeakHeapSizeBytes;
                this.heapSizes = heapSizes;
                this.unpaddedHeapSizes = unpaddedHeapSizes;
            }
        };
        /**
         * From a list of heap simulator traces, identify the one uses 0 as memory
         * space color.
         */
        MemoryUsage.prototype.getHeapTraceByColor = function (color, traces) {
            var e_35, _b, e_36, _c;
            if (!traces) {
                return null;
            }
            try {
                for (var traces_1 = __values(traces), traces_1_1 = traces_1.next(); !traces_1_1.done; traces_1_1 = traces_1.next()) {
                    var trace_1 = traces_1_1.value;
                    try {
                        for (var _d = __values(trace_1.events || []), _e = _d.next(); !_e.done; _e = _d.next()) {
                            var event_2 = _e.value;
                            var buffer = this.idToBuffer[toNumber(event_2.bufferId || '0')];
                            if (!buffer)
                                continue;
                            if (buffer.color !== color)
                                break;
                            return trace_1;
                        }
                    }
                    catch (e_36_1) { e_36 = { error: e_36_1 }; }
                    finally {
                        try {
                            if (_e && !_e.done && (_c = _d.return)) _c.call(_d);
                        }
                        finally { if (e_36) throw e_36.error; }
                    }
                }
            }
            catch (e_35_1) { e_35 = { error: e_35_1 }; }
            finally {
                try {
                    if (traces_1_1 && !traces_1_1.done && (_b = traces_1.return)) _b.call(traces_1);
                }
                finally { if (e_35) throw e_35.error; }
            }
            return null;
        };
        /**
         * Creates a logical buffer id to buffer allocation map from
         * `bufferAllocations`.
         */
        MemoryUsage.prototype.initAllocations = function (bufferAllocations) {
            var e_37, _b, e_38, _c;
            if (!bufferAllocations) {
                return;
            }
            try {
                for (var bufferAllocations_1 = __values(bufferAllocations), bufferAllocations_1_1 = bufferAllocations_1.next(); !bufferAllocations_1_1.done; bufferAllocations_1_1 = bufferAllocations_1.next()) {
                    var bufferAllocation = bufferAllocations_1_1.value;
                    var alloc = new BufferAllocation(bufferAllocation);
                    try {
                        for (var _d = __values(bufferAllocation.assigned || []), _e = _d.next(); !_e.done; _e = _d.next()) {
                            var assigned = _e.value;
                            this.idToBufferAllocation[toNumber(assigned.logicalBufferId || '0')] = alloc;
                        }
                    }
                    catch (e_38_1) { e_38 = { error: e_38_1 }; }
                    finally {
                        try {
                            if (_e && !_e.done && (_c = _d.return)) _c.call(_d);
                        }
                        finally { if (e_38) throw e_38.error; }
                    }
                }
            }
            catch (e_37_1) { e_37 = { error: e_37_1 }; }
            finally {
                try {
                    if (bufferAllocations_1_1 && !bufferAllocations_1_1.done && (_b = bufferAllocations_1.return)) _b.call(bufferAllocations_1);
                }
                finally { if (e_37) throw e_37.error; }
            }
        };
        /**
         * Creates a sorted buffer list and an id to buffer map from
         * `logicalBuffers`.
         * @private
         */
        MemoryUsage.prototype.initBuffers = function (logicalBuffers) {
            var e_39, _b;
            if (!logicalBuffers) {
                return;
            }
            try {
                for (var logicalBuffers_1 = __values(logicalBuffers), logicalBuffers_1_1 = logicalBuffers_1.next(); !logicalBuffers_1_1.done; logicalBuffers_1_1 = logicalBuffers_1.next()) {
                    var logicalBuffer = logicalBuffers_1_1.value;
                    var buffer = new LogicalBuffer(logicalBuffer);
                    this.buffers.push(buffer);
                    this.idToBuffer[buffer.id] = buffer;
                    this.unSeenLogicalBuffers.add(buffer.id);
                }
            }
            catch (e_39_1) { e_39 = { error: e_39_1 }; }
            finally {
                try {
                    if (logicalBuffers_1_1 && !logicalBuffers_1_1.done && (_b = logicalBuffers_1.return)) _b.call(logicalBuffers_1);
                }
                finally { if (e_39) throw e_39.error; }
            }
        };
        /**
         * Constructs a mapping from name to HLO instruction.
         */
        MemoryUsage.prototype.initHloInstructions = function (hloModule) {
            var e_40, _b, e_41, _c;
            if (!hloModule) {
                console.warn('Missing hloModule, skipping unpadded allocation size analysis');
                return;
            }
            try {
                for (var _d = __values(hloModule.computations || []), _e = _d.next(); !_e.done; _e = _d.next()) {
                    var comp = _e.value;
                    try {
                        for (var _f = __values(comp.instructions || []), _g = _f.next(); !_g.done; _g = _f.next()) {
                            var inst = _g.value;
                            if (!inst.name)
                                continue;
                            this.nameToHlo[inst.name] = new HloInstruction(inst);
                        }
                    }
                    catch (e_41_1) { e_41 = { error: e_41_1 }; }
                    finally {
                        try {
                            if (_g && !_g.done && (_c = _f.return)) _c.call(_f);
                        }
                        finally { if (e_41) throw e_41.error; }
                    }
                }
            }
            catch (e_40_1) { e_40 = { error: e_40_1 }; }
            finally {
                try {
                    if (_e && !_e.done && (_b = _d.return)) _b.call(_d);
                }
                finally { if (e_40) throw e_40.error; }
            }
        };
        /**
         * Accumulate data for use in a stacked bar plot.
         * We accumulate it in "program order" -- the order in which it was placed
         * into the logical_buffers sequence above was program order, and we iterate
         * that order to create data points.
         */
        MemoryUsage.prototype.initMaxHeap = function () {
            var e_42, _b;
            try {
                for (var _c = __values(this.peakLogicalBuffers), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var id = _d.value;
                    var alloc = this.idToBufferAllocation[id];
                    var groupName = alloc ? alloc.groupName : '';
                    this.addHeapObject(this.idToBuffer[id], groupName);
                }
            }
            catch (e_42_1) { e_42 = { error: e_42_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
                }
                finally { if (e_42) throw e_42.error; }
            }
            if (this.rest !== 0) {
                var small = this.smallBufferCount + " small buffers (<" + this.smallBufferSize / 1024 + " KiB)";
                this.maxHeap.push({
                    instructionName: small,
                    sizeMiB: bytesToMiB(this.rest),
                    color: this.nColor++,
                    groupName: small,
                });
            }
            var indexedMaxHeap = this.maxHeap.map(function (e, i) {
                return { ind: i, val: e };
            });
            // Sort max heap objects by size and create index.
            indexedMaxHeap.sort(function (a, b) {
                var sizeA = a && a.val && a.val.sizeMiB ? a.val.sizeMiB : 0;
                var sizeB = b && b.val && b.val.sizeMiB ? b.val.sizeMiB : 0;
                return sizeB - sizeA;
            });
            this.maxHeapBySize = indexedMaxHeap.map(function (e) { return e.val; });
            this.bySizeToMaxHeap = indexedMaxHeap.map(function (e) { return e.ind; });
            this.maxHeapToBySize.length = this.maxHeap.length;
            for (var i_187 = 0; i_187 < this.bySizeToMaxHeap.length; i_187++) {
                this.maxHeapToBySize[this.bySizeToMaxHeap[i_187]] = i_187;
            }
            // Sort max heap objects by padding size and create index.
            indexedMaxHeap.sort(function (a, b) {
                var paddingA = a && a.val && a.val.sizeMiB && a.val.unpaddedSizeMiB ?
                    a.val.sizeMiB - a.val.unpaddedSizeMiB :
                    0;
                var paddingB = b && b.val && b.val.sizeMiB && b.val.unpaddedSizeMiB ?
                    b.val.sizeMiB - b.val.unpaddedSizeMiB :
                    0;
                return paddingB - paddingA;
            });
            this.maxHeapByPaddingSize = indexedMaxHeap.map(function (e) { return e.val; });
            this.byPaddingSizeToMaxHeap = indexedMaxHeap.map(function (e) { return e.ind; });
            this.maxHeapToByPaddingSize.length = this.maxHeap.length;
            for (var i_188 = 0; i_188 < this.byPaddingSizeToMaxHeap.length; i_188++) {
                this.maxHeapToByPaddingSize[this.byPaddingSizeToMaxHeap[i_188]] = i_188;
            }
        };
        /**
         * Initializes memory usage of the module.
         */
        MemoryUsage.prototype.initMemoryUsage = function (memorySpaceColor, bufferAssignment) {
            if (!bufferAssignment) {
                console.warn('No buffer assignment info');
                return;
            }
            this.initBuffers(bufferAssignment.logicalBuffers);
            this.initAllocations(bufferAssignment.bufferAllocations);
            var trace = this.getHeapTraceByColor(memorySpaceColor, bufferAssignment.heapSimulatorTraces);
            if (!trace) {
                console.warn('Missing hbm heap simulator trace.');
            }
            this.findPeakMemoryUsage(trace, memorySpaceColor);
        };
        /**
         * Creates a heap object that is displayed in a plot in the memory
         * visualization.
         */
        MemoryUsage.prototype.newHeapObject = function (buffer, shape, inst, groupName) {
            if (!buffer) {
                return null;
            }
            var shapeIndex = buffer.shapeIndex.length ? ' {' + buffer.shapeIndex.join() + '}' : '';
            return {
                instructionName: buffer.instructionName + shapeIndex,
                logicalBufferId: buffer.id,
                unpaddedSizeMiB: bytesToMiB(shape.unpaddedHeapSizeBytes()),
                tfOpName: inst.tfOpName,
                opcode: inst.opcode,
                sizeMiB: bytesToMiB(buffer.size),
                color: this.nColor++,
                shape: shape.humanStringWithLayout(),
                groupName: groupName,
            };
        };
        return MemoryUsage;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A memory viewer component.
     */
    var MemoryViewerMain = /** @class */ (function () {
        /**
         * @param {?} store
         */
        function MemoryViewerMain(store) {
            this.store = store;
            /**
             * XLA Hlo proto
             */
            this.hloProto = null;
            /**
             * XLA memory space color
             */
            this.memorySpaceColor = 0;
            this.moduleName = '';
            this.peakHeapSizeMiB = '';
            this.unpaddedPeakHeapSizeMiB = '';
            this.heapSizes = [];
            this.maxHeap = [];
            this.maxHeapBySize = [];
            this.maxHeapByPaddingSize = [];
            this.selectedIndex = -1;
            this.selectedIndexBySize = -1;
            this.selectedIndexByPaddingSize = -1;
            this.unpaddedHeapSizes = [];
            this.includeNotSimulated = true;
            this.hasTrace = false;
            this.diagnostics = { info: [], warnings: [], errors: [] };
        }
        /**
         * @return {?}
         */
        MemoryViewerMain.prototype.ngOnChanges = function () {
            this.update();
        };
        /**
         * @return {?}
         */
        MemoryViewerMain.prototype.ngOnDestroy = function () {
            this.dispatchActiveHeapObject();
        };
        /**
         * @private
         * @param {?=} heapObject
         * @return {?}
         */
        MemoryViewerMain.prototype.dispatchActiveHeapObject = function (heapObject) {
            if (heapObject === void 0) { heapObject = null; }
            this.store.dispatch(setActiveHeapObjectAction({ activeHeapObject: heapObject }));
            if (heapObject) {
                /** @type {?} */
                var span = this.getLogicalBufferSpan(heapObject.logicalBufferId);
                this.activeInfo = {
                    size: heapObject.sizeMiB || 0,
                    alloc: span.alloc,
                    free: span.free,
                    color: getChartItemColorByIndex(heapObject.color || 0),
                };
            }
            else {
                this.activeInfo = undefined;
                this.selectedIndex = -1;
                this.selectedIndexBySize = -1;
                this.selectedIndexByPaddingSize = -1;
            }
        };
        /**
         * @private
         * @param {?=} index
         * @return {?}
         */
        MemoryViewerMain.prototype.getLogicalBufferSpan = function (index) {
            /** @type {?} */
            var bufferSpan = { alloc: 0, free: 0 };
            if (index && this.usage && this.usage.logicalBufferSpans &&
                this.heapSizes) {
                /** @type {?} */
                var span = this.usage.logicalBufferSpans[index];
                if (span) {
                    bufferSpan.alloc = span[0];
                    bufferSpan.free = span[1] < 0 ? this.heapSizes.length - 1 : span[1];
                }
                else {
                    bufferSpan.free = this.heapSizes.length - 1;
                }
            }
            return bufferSpan;
        };
        /**
         * @param {?} selectedIndex
         * @return {?}
         */
        MemoryViewerMain.prototype.setSelectedHeapObject = function (selectedIndex) {
            if (!this.usage) {
                return;
            }
            if (selectedIndex === -1) {
                this.dispatchActiveHeapObject();
            }
            else {
                this.dispatchActiveHeapObject(this.usage.maxHeap[selectedIndex]);
                this.selectedIndexBySize = this.usage.maxHeapToBySize[selectedIndex];
                this.selectedIndexByPaddingSize =
                    this.usage.maxHeapToByPaddingSize[selectedIndex];
            }
        };
        /**
         * @param {?} selectedIndexBySize
         * @return {?}
         */
        MemoryViewerMain.prototype.setSelectedHeapObjectBySize = function (selectedIndexBySize) {
            if (!this.usage) {
                return;
            }
            if (selectedIndexBySize === -1) {
                this.dispatchActiveHeapObject();
            }
            else {
                this.dispatchActiveHeapObject(this.usage.maxHeapBySize[selectedIndexBySize]);
                this.selectedIndex = this.usage.bySizeToMaxHeap[selectedIndexBySize];
                this.selectedIndexByPaddingSize =
                    this.usage.maxHeapToByPaddingSize[this.selectedIndex];
            }
        };
        /**
         * @param {?} selectedIndexByPaddingSize
         * @return {?}
         */
        MemoryViewerMain.prototype.setSelectedHeapObjectByPaddingSize = function (selectedIndexByPaddingSize) {
            if (!this.usage) {
                return;
            }
            if (selectedIndexByPaddingSize === -1) {
                this.dispatchActiveHeapObject();
            }
            else {
                this.dispatchActiveHeapObject(this.maxHeapByPaddingSize[selectedIndexByPaddingSize]);
                this.selectedIndex =
                    this.usage.byPaddingSizeToMaxHeap[selectedIndexByPaddingSize];
                this.selectedIndexBySize = this.usage.maxHeapToBySize[this.selectedIndex];
            }
        };
        /**
         * @return {?}
         */
        MemoryViewerMain.prototype.update = function () {
            /** @type {?} */
            var data = this.hloProto;
            this.diagnostics = { errors: [], warnings: [], info: [] };
            if (!data || !data.hloModule) {
                this.diagnostics.errors.push('We failed to fetch a valid input. The input is empty or too large.');
                return;
            }
            if (!data.bufferAssignment) {
                this.diagnostics.errors.push('The HloProto does not contain a buffer assignment. ' +
                    'Therefore, we don\'t know the memory usage.');
                return;
            }
            if (!data.bufferAssignment.heapSimulatorTraces ||
                !data.bufferAssignment.heapSimulatorTraces.length) {
                this.diagnostics.warnings.push('The HloProto does not contain a heap simulator trace.');
            }
            this.moduleName = data.hloModule.name || '';
            this.usage =
                new MemoryUsage(data, this.memorySpaceColor, this.includeNotSimulated);
            this.peakHeapSizeMiB =
                bytesToMiB(this.usage.peakHeapSizeBytes).toFixed(2);
            this.unpaddedPeakHeapSizeMiB =
                bytesToMiB(this.usage.unpaddedPeakHeapSizeBytes).toFixed(2);
            this.heapSizes = this.usage.heapSizes || [];
            this.unpaddedHeapSizes = this.usage.unpaddedHeapSizes || [];
            this.peakInfo = {
                size: bytesToMiB(this.usage.peakHeapSizeBytes),
                alloc: this.usage.peakHeapSizePosition + 1,
                free: this.usage.peakHeapSizePosition + 2,
            };
            this.maxHeap = this.usage.maxHeap || [];
            this.maxHeapBySize = this.usage.maxHeapBySize || [];
            this.maxHeapByPaddingSize = this.usage.maxHeapByPaddingSize || [];
            this.hasTrace = this.maxHeap.length > 0 || this.heapSizes.length > 0 ||
                this.maxHeapBySize.length > 0;
        };
        return MemoryViewerMain;
    }());
    MemoryViewerMain.decorators = [
        { type: Component, args: [{
                    selector: 'memory-viewer-main',
                    template: "<diagnostics-view [diagnostics]=\"diagnostics\"></diagnostics-view>\n\n<div class=\"section-container\">\n  <div class=\"row\">\n    <div>\n      <div class=\"mat-headline\">Module name: {{moduleName}}</div>\n      <div class=\"sub-title\">Peak memory allocation is {{peakHeapSizeMiB}} MiB</div>\n      <div class=\"description\" [hidden]=\"!unpaddedPeakHeapSizeMiB\">\n        ({{unpaddedPeakHeapSizeMiB}} MiB without padding)\n      </div>\n      <div class=\"description\">\n        Modifying your model's architecture, batch size and data dimensions may\n        help reduce the memory footprint.\n      </div>\n    </div>\n    <div class=\"control\">\n      <mat-checkbox [(ngModel)]=\"includeNotSimulated\" (ngModelChange)=\"update()\">\n        Include not simulated\n        <mat-icon\n          class=\"tooltip-icon\"\n          matTooltip=\"Include all logical buffers that haven't appeared in HeapSimulatorTraces.\n                      We simply sum up all those buffer allocations, and report the additional\n                      unpadded heap sizes as the sum of those unsimulated buffer allocations *\n                      (total unpadded logical buffer sizes / total padded logical buffer sizes).\"\n          matTooltipPosition=\"above\">\n            info\n        </mat-icon>\n      </mat-checkbox>\n    </div>\n  </div>\n</div>\n\n<mat-divider></mat-divider>\n\n<program-order-chart\n  [heapSizes]=\"heapSizes\"\n  [unpaddedHeapSizes]=\"unpaddedHeapSizes\"\n  [peakInfo]=\"peakInfo\"\n  [activeInfo]=\"activeInfo\">\n</program-order-chart>\n\n<div [hidden]=\"!heapSizes.length\">\n  <mat-divider ></mat-divider>\n</div>\n\n<max-heap-chart\n   [maxHeap]=\"maxHeap\"\n   [title]=\"'By Program Order'\"\n   [selectedIndex]=\"selectedIndex\"\n   (selected)=\"setSelectedHeapObject($event)\">\n</max-heap-chart>\n\n<div [hidden]=\"!maxHeap.length\">\n  <mat-divider ></mat-divider>\n</div>\n\n<max-heap-chart\n  [maxHeap]=\"maxHeapBySize\"\n  [title]=\"'By Size'\"\n  [selectedIndex]=\"selectedIndexBySize\"\n  (selected)=\"setSelectedHeapObjectBySize($event)\">\n</max-heap-chart>\n\n<div [hidden]=\"!maxHeapByPaddingSize.length\">\n  <mat-divider ></mat-divider>\n</div>\n\n<max-heap-chart\n  [maxHeap]=\"maxHeapByPaddingSize\"\n  [title]=\"'By Padding Size'\"\n  [selectedIndex] = \"selectedIndexByPaddingSize\"\n  (selected)=\"setSelectedHeapObjectByPaddingSize($event)\">\n</max-heap-chart>\n\n<div class=\"section-container\" [hidden]=\"hasTrace\">\n  There is no data to display.\n</div>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}:host{display:block}.section-container{padding:20px}.sub-title{font-weight:500}.control-title{color:#5f6368;margin-bottom:5px}.row{display:flex}.flex-space{flex:1}.control{padding:20}\n"]
                }] }
    ];
    /** @nocollapse */
    MemoryViewerMain.ctorParameters = function () { return [
        { type: Store }
    ]; };
    MemoryViewerMain.propDecorators = {
        hloProto: [{ type: Input }],
        memorySpaceColor: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A memory viewer module.
     */
    var MemoryViewerMainModule = /** @class */ (function () {
        function MemoryViewerMainModule() {
        }
        return MemoryViewerMainModule;
    }());
    MemoryViewerMainModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [MemoryViewerMain],
                    imports: [
                        DiagnosticsViewModule,
                        FormsModule,
                        MatDividerModule,
                        MaxHeapChartModule,
                        MatCheckboxModule,
                        MatIconModule,
                        MatTooltipModule,
                        ProgramOrderChartModule,
                    ],
                    exports: [MemoryViewerMain]
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A memory viewer module.
     */
    var MemoryViewerModule = /** @class */ (function () {
        function MemoryViewerModule() {
        }
        return MemoryViewerModule;
    }());
    MemoryViewerModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [MemoryViewer],
                    imports: [
                        MemoryViewerMainModule,
                    ],
                    exports: [MemoryViewer]
                },] }
    ];
    /** An op profile data class. */
    var OpProfileData = /** @class */ (function () {
        function OpProfileData() {
        }
        OpProfileData.prototype.update = function (node) {
            if (node) {
                var utilization = flopsUtilization(node);
                this.flopsColor = flopsColor(utilization);
                this.flopsUtilizationPercent = percent(utilization);
                utilization = memoryBandwidthUtilization(node);
                this.bwColor = bwColor(utilization);
                this.memoryBandwidthUtilizationPercent = percent(utilization);
            }
            else {
                this.bwColor = undefined;
                this.flopsColor = undefined;
                this.memoryBandwidthUtilizationPercent = undefined;
                this.flopsUtilizationPercent = undefined;
            }
        };
        return OpProfileData;
    }());
    /** Base class of Op Profile component. */
    var OpProfileBase = /** @class */ (function () {
        function OpProfileBase() {
            this.profile = null;
            this.data = new OpProfileData();
            this.hasTwoProfiles = false;
            this.isByCategory = false;
            this.byWasted = false;
            this.showP90 = false;
            this.childrenCount = 10;
            this.deviceType = 'TPU';
        }
        OpProfileBase.prototype.hasMultipleProfiles = function () {
            return !!this.profile && !!this.profile.byCategory &&
                !!this.profile.byProgram;
        };
        OpProfileBase.prototype.updateRoot = function () {
            if (!this.profile) {
                this.rootNode = undefined;
                return;
            }
            if (!this.hasTwoProfiles) {
                this.rootNode = this.profile.byCategory || this.profile.byProgram;
            }
            else {
                this.rootNode =
                    this.isByCategory ? this.profile.byCategory : this.profile.byProgram;
            }
            this.deviceType = this.profile.deviceType || 'TPU';
        };
        OpProfileBase.prototype.parseData = function (data) {
            this.profile = data;
            this.hasTwoProfiles = this.hasMultipleProfiles();
            this.isByCategory = false;
            this.childrenCount = 10;
            this.updateRoot();
            this.data.update(this.rootNode);
        };
        OpProfileBase.prototype.updateChildrenCount = function (value) {
            var rounded = Math.round(value / 10) * 10;
            this.childrenCount = Math.max(Math.min(rounded, 100), 10);
        };
        OpProfileBase.prototype.updateToggle = function () {
            this.isByCategory = !this.isByCategory;
            this.updateRoot();
        };
        OpProfileBase.prototype.updateByWasted = function () {
            this.byWasted = !this.byWasted;
        };
        OpProfileBase.prototype.updateShowP90 = function () {
            this.showP90 = !this.showP90;
        };
        return OpProfileBase;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * An op profile component.
     */
    var OpProfile = /** @class */ (function (_super) {
        __extends(OpProfile, _super);
        /**
         * @param {?} route
         * @param {?} dataService
         * @param {?} store
         */
        function OpProfile(route, dataService, store) {
            var _this = _super.call(this) || this;
            _this.dataService = dataService;
            _this.store = store;
            /**
             * Handles on-destroy Subject, used to unsubscribe.
             */
            _this.destroyed = new ReplaySubject(1);
            route.params.pipe(takeUntil(_this.destroyed)).subscribe(( /**
             * @param {?} params
             * @return {?}
             */function (params) {
                _this.update(( /** @type {?} */(params)));
            }));
            return _this;
        }
        /**
         * @param {?} event
         * @return {?}
         */
        OpProfile.prototype.update = function (event) {
            var _this = this;
            this.store.dispatch(setLoadingStateAction({
                loadingState: {
                    loading: true,
                    message: 'Loading data',
                }
            }));
            this.dataService
                .getData(event.run || '', event.tag || 'op_profile', event.host || '')
                .pipe(takeUntil(this.destroyed))
                .subscribe(( /**
         * @param {?} data
         * @return {?}
         */function (data) {
                _this.store.dispatch(setLoadingStateAction({
                    loadingState: {
                        loading: false,
                        message: '',
                    }
                }));
                _this.parseData(( /** @type {?} */(data)));
            }));
        };
        /**
         * @return {?}
         */
        OpProfile.prototype.ngOnDestroy = function () {
            // Unsubscribes all pending subscriptions.
            this.destroyed.next();
            this.destroyed.complete();
        };
        return OpProfile;
    }(OpProfileBase));
    OpProfile.decorators = [
        { type: Component, args: [{
                    selector: 'op-profile',
                    template: "<div class=\"container\">\n  <div class=\"mat-headline\">\n    <div>\n      Overall {{deviceType}} FLOPS utilization is\n      <span [style.color]=\"data.flopsColor\">{{data.flopsUtilizationPercent}}</span>\n    </div>\n    <div>\n      Memory bandwidth utilization is\n      <span [style.color]=\"data.bwColor\">{{data.memoryBandwidthUtilizationPercent}}</span>\n    </div>\n  </div>\n  <div class=\"description\">\n    <div>\n      Modifying your model's architecture, data dimensions, and improving\n      the efficiency of CPU operations may help reach the {{deviceType}}'s FLOPS\n      potential.\n    </div>\n    <div>\n      \"Idle\" represents the portion of the total execution time on device\n      that is idle.\n    </div>\n  </div>\n  <div class=\"control-container\">\n    <div class=\"control\" [hidden]=\"!hasTwoProfiles\">\n      <div class=\"control-title\">By category</div>\n      <mat-slide-toggle [checked]=\"isByCategory\" (toggleChange)=\"updateToggle()\"></mat-slide-toggle>\n    </div>\n    <div class=\"ops-control\">\n      <div class=\"ops-control-title\">\n        Show top&nbsp;\n        <mat-form-field class=\"children-count-input\">\n          <input\n                 matInput\n                 type=\"number\"\n                 [min]=\"10\"\n                 [max]=\"100\"\n                 [step]=\"10\"\n                 [value]=\"childrenCount\"\n                 (input)=\"updateChildrenCount($event.target.value)\" />\n        </mat-form-field>\n        &nbsp;ops\n      </div>\n      <div>\n        <mat-slider\n                    [min]=\"10\"\n                    [max]=\"100\"\n                    [step]=\"10\"\n                    [value]=\"childrenCount\"\n                    (change)=\"updateChildrenCount($event.value)\">\n        </mat-slider>\n      </div>\n    </div>\n    <div class=\"control\">\n      <div class=\"control-title\">Sort by wasted time\n        <mat-icon\n                  class=\"tooltip-icon\"\n                  matTooltip=\"Wasted time is defined by RuntimeFraction *\n                              (1 - max(FlopsUtilization, MemoryBandwidthUtilization)).\"\n                  matTooltipPosition=\"above\">\n              info\n        </mat-icon>\n      </div>\n      <mat-slide-toggle [checked]=\"byWasted\" (toggleChange)=\"updateByWasted()\"></mat-slide-toggle>\n    </div>\n    <div class=\"control\">\n      <div class=\"control-title\">Top 90%</div>\n      <mat-slide-toggle [checked]=\"showP90\" (toggleChange)=\"updateShowP90()\"></mat-slide-toggle>\n    </div>\n  </div>\n</div>\n\n<op-table\n  [rootNode]=\"rootNode\"\n  [byWasted]=\"byWasted\"\n  [showP90]=\"showP90\"\n  [childrenCount]=\"childrenCount\">\n</op-table>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}.container{padding:20px}.description{margin-top:-16px;font-size:16px;font-weight:lighter;line-height:1.6}.control-container{display:flex;padding-top:32px}.control{margin-right:80px}.ops-control{margin-right:80px;text-align:left}.control-title{color:#5f6368;margin-bottom:5px}.ops-control-title{color:#5f6368;margin:-20px 0 -24px}.children-count-input{width:60px}.tooltip-icon-container{position:relative}.tooltip-icon{color:#e8710a;font-size:25px;vertical-align:bottom;cursor:pointer}\n"]
                }] }
    ];
    /** @nocollapse */
    OpProfile.ctorParameters = function () { return [
        { type: ActivatedRoute },
        { type: DataService },
        { type: Store }
    ]; };
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Injection token to be used to override the default options for `mat-slide-toggle`.
     * @type {?}
     */
    var MAT_SLIDE_TOGGLE_DEFAULT_OPTIONS = new InjectionToken('mat-slide-toggle-default-options', {
        providedIn: 'root',
        factory: ( /**
         * @return {?}
         */function () { return ({ disableToggleValue: false, disableDragValue: false }); })
    });
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // Increasing integer for generating unique ids for slide-toggle components.
    /** @type {?} */
    var nextUniqueId$7 = 0;
    /**
     * \@docs-private
     * @type {?}
     */
    var MAT_SLIDE_TOGGLE_VALUE_ACCESSOR = {
        provide: NG_VALUE_ACCESSOR,
        useExisting: forwardRef(( /**
         * @return {?}
         */function () { return MatSlideToggle; })),
        multi: true
    };
    /**
     * Change event object emitted by a MatSlideToggle.
     */
    var MatSlideToggleChange = /** @class */ (function () {
        /**
         * @param {?} source
         * @param {?} checked
         */
        function MatSlideToggleChange(source, checked) {
            this.source = source;
            this.checked = checked;
        }
        return MatSlideToggleChange;
    }());
    // Boilerplate for applying mixins to MatSlideToggle.
    /**
     * \@docs-private
     */
    var MatSlideToggleBase = /** @class */ (function () {
        /**
         * @param {?} _elementRef
         */
        function MatSlideToggleBase(_elementRef) {
            this._elementRef = _elementRef;
        }
        return MatSlideToggleBase;
    }());
    /** @type {?} */
    var _MatSlideToggleMixinBase = mixinTabIndex(mixinColor(mixinDisableRipple(mixinDisabled(MatSlideToggleBase)), 'accent'));
    /**
     * Represents a slidable "switch" toggle that can be moved between on and off.
     */
    var MatSlideToggle = /** @class */ (function (_super) {
        __extends(MatSlideToggle, _super);
        /**
         * @param {?} elementRef
         * @param {?} _focusMonitor
         * @param {?} _changeDetectorRef
         * @param {?} tabIndex
         * @param {?} _ngZone
         * @param {?} defaults
         * @param {?=} _animationMode
         * @param {?=} _dir
         */
        function MatSlideToggle(elementRef, _focusMonitor, _changeDetectorRef, tabIndex, _ngZone, defaults, _animationMode, _dir) {
            var _this = _super.call(this, elementRef) || this;
            _this._focusMonitor = _focusMonitor;
            _this._changeDetectorRef = _changeDetectorRef;
            _this._ngZone = _ngZone;
            _this.defaults = defaults;
            _this._animationMode = _animationMode;
            _this._dir = _dir;
            _this._onChange = ( /**
             * @param {?} _
             * @return {?}
             */function (_) { });
            _this._onTouched = ( /**
             * @return {?}
             */function () { });
            _this._uniqueId = "mat-slide-toggle-" + ++nextUniqueId$7;
            _this._required = false;
            _this._checked = false;
            /**
             * Whether the thumb is currently being dragged.
             */
            _this._dragging = false;
            /**
             * Name value will be applied to the input element if present.
             */
            _this.name = null;
            /**
             * A unique id for the slide-toggle input. If none is supplied, it will be auto-generated.
             */
            _this.id = _this._uniqueId;
            /**
             * Whether the label should appear after or before the slide-toggle. Defaults to 'after'.
             */
            _this.labelPosition = 'after';
            /**
             * Used to set the aria-label attribute on the underlying input element.
             */
            _this.ariaLabel = null;
            /**
             * Used to set the aria-labelledby attribute on the underlying input element.
             */
            _this.ariaLabelledby = null;
            /**
             * An event will be dispatched each time the slide-toggle changes its value.
             */
            _this.change = new EventEmitter();
            /**
             * An event will be dispatched each time the slide-toggle input is toggled.
             * This event is always emitted when the user toggles the slide toggle, but this does not mean
             * the slide toggle's value has changed. The event does not fire when the user drags to change
             * the slide toggle value.
             */
            _this.toggleChange = new EventEmitter();
            /**
             * An event will be dispatched each time the slide-toggle is dragged.
             * This event is always emitted when the user drags the slide toggle to make a change greater
             * than 50%. It does not mean the slide toggle's value is changed. The event is not emitted when
             * the user toggles the slide toggle to change its value.
             */
            _this.dragChange = new EventEmitter();
            _this.tabIndex = parseInt(tabIndex) || 0;
            return _this;
        }
        Object.defineProperty(MatSlideToggle.prototype, "required", {
            /**
             * Whether the slide-toggle is required.
             * @return {?}
             */
            get: function () { return this._required; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) { this._required = coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatSlideToggle.prototype, "checked", {
            /**
             * Whether the slide-toggle element is checked or not.
             * @return {?}
             */
            get: function () { return this._checked; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._checked = coerceBooleanProperty(value);
                this._changeDetectorRef.markForCheck();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatSlideToggle.prototype, "inputId", {
            /**
             * Returns the unique id for the visual hidden input.
             * @return {?}
             */
            get: function () { return (this.id || this._uniqueId) + "-input"; },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        MatSlideToggle.prototype.ngAfterContentInit = function () {
            var _this = this;
            this._focusMonitor
                .monitor(this._elementRef, true)
                .subscribe(( /**
         * @param {?} focusOrigin
         * @return {?}
         */function (/**
         * @param {?} focusOrigin
         * @return {?}
         */ focusOrigin) {
                if (!focusOrigin) {
                    // When a focused element becomes disabled, the browser *immediately* fires a blur event.
                    // Angular does not expect events to be raised during change detection, so any state
                    // change (such as a form control's 'ng-touched') will cause a changed-after-checked
                    // error. See https://github.com/angular/angular/issues/17793. To work around this,
                    // we defer telling the form control it has been touched until the next tick.
                    Promise.resolve().then(( /**
                     * @return {?}
                     */function () { return _this._onTouched(); }));
                }
            }));
        };
        /**
         * @return {?}
         */
        MatSlideToggle.prototype.ngOnDestroy = function () {
            this._focusMonitor.stopMonitoring(this._elementRef);
        };
        /**
         * Method being called whenever the underlying input emits a change event.
         * @param {?} event
         * @return {?}
         */
        MatSlideToggle.prototype._onChangeEvent = function (event) {
            // We always have to stop propagation on the change event.
            // Otherwise the change event, from the input element, will bubble up and
            // emit its event object to the component's `change` output.
            event.stopPropagation();
            if (!this._dragging) {
                this.toggleChange.emit();
            }
            // Releasing the pointer over the `<label>` element while dragging triggers another
            // click event on the `<label>` element. This means that the checked state of the underlying
            // input changed unintentionally and needs to be changed back. Or when the slide toggle's config
            // disabled toggle change event by setting `disableToggleValue: true`, the slide toggle's value
            // does not change, and the checked state of the underlying input needs to be changed back.
            if (this._dragging || this.defaults.disableToggleValue) {
                this._inputElement.nativeElement.checked = this.checked;
                return;
            }
            // Sync the value from the underlying input element with the component instance.
            this.checked = this._inputElement.nativeElement.checked;
            // Emit our custom change event only if the underlying input emitted one. This ensures that
            // there is no change event, when the checked state changes programmatically.
            this._emitChangeEvent();
        };
        /**
         * Method being called whenever the slide-toggle has been clicked.
         * @param {?} event
         * @return {?}
         */
        MatSlideToggle.prototype._onInputClick = function (event) {
            // We have to stop propagation for click events on the visual hidden input element.
            // By default, when a user clicks on a label element, a generated click event will be
            // dispatched on the associated input element. Since we are using a label element as our
            // root container, the click event on the `slide-toggle` will be executed twice.
            // The real click event will bubble up, and the generated click event also tries to bubble up.
            // This will lead to multiple click events.
            // Preventing bubbling for the second event will solve that issue.
            event.stopPropagation();
        };
        /**
         * Implemented as part of ControlValueAccessor.
         * @param {?} value
         * @return {?}
         */
        MatSlideToggle.prototype.writeValue = function (value) {
            this.checked = !!value;
        };
        /**
         * Implemented as part of ControlValueAccessor.
         * @param {?} fn
         * @return {?}
         */
        MatSlideToggle.prototype.registerOnChange = function (fn) {
            this._onChange = fn;
        };
        /**
         * Implemented as part of ControlValueAccessor.
         * @param {?} fn
         * @return {?}
         */
        MatSlideToggle.prototype.registerOnTouched = function (fn) {
            this._onTouched = fn;
        };
        /**
         * Implemented as a part of ControlValueAccessor.
         * @param {?} isDisabled
         * @return {?}
         */
        MatSlideToggle.prototype.setDisabledState = function (isDisabled) {
            this.disabled = isDisabled;
            this._changeDetectorRef.markForCheck();
        };
        /**
         * Focuses the slide-toggle.
         * @param {?=} options
         * @return {?}
         */
        MatSlideToggle.prototype.focus = function (options) {
            this._focusMonitor.focusVia(this._inputElement, 'keyboard', options);
        };
        /**
         * Toggles the checked state of the slide-toggle.
         * @return {?}
         */
        MatSlideToggle.prototype.toggle = function () {
            this.checked = !this.checked;
            this._onChange(this.checked);
        };
        /**
         * Emits a change event on the `change` output. Also notifies the FormControl about the change.
         * @private
         * @return {?}
         */
        MatSlideToggle.prototype._emitChangeEvent = function () {
            this._onChange(this.checked);
            this.change.emit(new MatSlideToggleChange(this, this.checked));
        };
        /**
         * Retrieves the percentage of thumb from the moved distance. Percentage as fraction of 100.
         * @private
         * @param {?} distance
         * @return {?}
         */
        MatSlideToggle.prototype._getDragPercentage = function (distance) {
            /** @type {?} */
            var percentage = (distance / this._thumbBarWidth) * 100;
            // When the toggle was initially checked, then we have to start the drag at the end.
            if (this._previousChecked) {
                percentage += 100;
            }
            return Math.max(0, Math.min(percentage, 100));
        };
        /**
         * @return {?}
         */
        MatSlideToggle.prototype._onDragStart = function () {
            if (!this.disabled && !this._dragging) {
                /** @type {?} */
                var thumbEl = this._thumbEl.nativeElement;
                this._thumbBarWidth = this._thumbBarEl.nativeElement.clientWidth - thumbEl.clientWidth;
                thumbEl.classList.add('mat-dragging');
                this._previousChecked = this.checked;
                this._dragging = true;
            }
        };
        /**
         * @param {?} event
         * @return {?}
         */
        MatSlideToggle.prototype._onDrag = function (event) {
            if (this._dragging) {
                /** @type {?} */
                var direction = this._dir && this._dir.value === 'rtl' ? -1 : 1;
                this._dragPercentage = this._getDragPercentage(event.deltaX * direction);
                // Calculate the moved distance based on the thumb bar width.
                /** @type {?} */
                var dragX = (this._dragPercentage / 100) * this._thumbBarWidth * direction;
                this._thumbEl.nativeElement.style.transform = "translate3d(" + dragX + "px, 0, 0)";
            }
        };
        /**
         * @return {?}
         */
        MatSlideToggle.prototype._onDragEnd = function () {
            var _this = this;
            if (this._dragging) {
                /** @type {?} */
                var newCheckedValue = this._dragPercentage > 50;
                if (newCheckedValue !== this.checked) {
                    this.dragChange.emit();
                    if (!this.defaults.disableDragValue) {
                        this.checked = newCheckedValue;
                        this._emitChangeEvent();
                    }
                }
                // The drag should be stopped outside of the current event handler, otherwise the
                // click event will be fired before it and will revert the drag change.
                this._ngZone.runOutsideAngular(( /**
                 * @return {?}
                 */function () { return setTimeout(( /**
                 * @return {?}
                 */function () {
                    if (_this._dragging) {
                        _this._dragging = false;
                        _this._thumbEl.nativeElement.classList.remove('mat-dragging');
                        // Reset the transform because the component will take care
                        // of the thumb position after drag.
                        _this._thumbEl.nativeElement.style.transform = '';
                    }
                })); }));
            }
        };
        /**
         * Method being called whenever the label text changes.
         * @return {?}
         */
        MatSlideToggle.prototype._onLabelTextChange = function () {
            // Since the event of the `cdkObserveContent` directive runs outside of the zone, the
            // slide-toggle component will be only marked for check, but no actual change detection runs
            // automatically. Instead of going back into the zone in order to trigger a change detection
            // which causes *all* components to be checked (if explicitly marked or not using OnPush),
            // we only trigger an explicit change detection for the slide-toggle view and its children.
            this._changeDetectorRef.detectChanges();
        };
        return MatSlideToggle;
    }(_MatSlideToggleMixinBase));
    MatSlideToggle.decorators = [
        { type: Component, args: [{ selector: 'mat-slide-toggle',
                    exportAs: 'matSlideToggle',
                    host: {
                        'class': 'mat-slide-toggle',
                        '[id]': 'id',
                        // Needs to be `-1` so it can still receive programmatic focus.
                        '[attr.tabindex]': 'disabled ? null : -1',
                        '[attr.aria-label]': 'null',
                        '[attr.aria-labelledby]': 'null',
                        '[class.mat-checked]': 'checked',
                        '[class.mat-disabled]': 'disabled',
                        '[class.mat-slide-toggle-label-before]': 'labelPosition == "before"',
                        '[class._mat-animation-noopable]': '_animationMode === "NoopAnimations"',
                        '(focus)': '_inputElement.nativeElement.focus()',
                    },
                    template: "<label [attr.for]=\"inputId\" class=\"mat-slide-toggle-label\" #label><div #toggleBar class=\"mat-slide-toggle-bar\" [class.mat-slide-toggle-bar-no-side-margin]=\"!labelContent.textContent || !labelContent.textContent.trim()\"><input #input class=\"mat-slide-toggle-input cdk-visually-hidden\" type=\"checkbox\" role=\"switch\" [id]=\"inputId\" [required]=\"required\" [tabIndex]=\"tabIndex\" [checked]=\"checked\" [disabled]=\"disabled\" [attr.name]=\"name\" [attr.aria-checked]=\"checked.toString()\" [attr.aria-label]=\"ariaLabel\" [attr.aria-labelledby]=\"ariaLabelledby\" (change)=\"_onChangeEvent($event)\" (click)=\"_onInputClick($event)\"><div class=\"mat-slide-toggle-thumb-container\" #thumbContainer (slidestart)=\"_onDragStart()\" (slide)=\"_onDrag($event)\" (slideend)=\"_onDragEnd()\"><div class=\"mat-slide-toggle-thumb\"></div><div class=\"mat-slide-toggle-ripple\" mat-ripple [matRippleTrigger]=\"label\" [matRippleDisabled]=\"disableRipple || disabled\" [matRippleCentered]=\"true\" [matRippleRadius]=\"20\" [matRippleAnimation]=\"{enterDuration: 150}\"><div class=\"mat-ripple-element mat-slide-toggle-persistent-ripple\"></div></div></div></div><span class=\"mat-slide-toggle-content\" #labelContent (cdkObserveContent)=\"_onLabelTextChange()\"><span style=\"display:none\">&nbsp;</span><ng-content></ng-content></span></label>",
                    styles: [".mat-slide-toggle{display:inline-block;height:24px;max-width:100%;line-height:24px;white-space:nowrap;outline:0;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;-webkit-tap-highlight-color:transparent}.mat-slide-toggle.mat-checked .mat-slide-toggle-thumb-container{transform:translate3d(16px,0,0)}[dir=rtl] .mat-slide-toggle.mat-checked .mat-slide-toggle-thumb-container{transform:translate3d(-16px,0,0)}.mat-slide-toggle.mat-disabled{opacity:.38}.mat-slide-toggle.mat-disabled .mat-slide-toggle-label,.mat-slide-toggle.mat-disabled .mat-slide-toggle-thumb-container{cursor:default}.mat-slide-toggle-label{display:flex;flex:1;flex-direction:row;align-items:center;height:inherit;cursor:pointer}.mat-slide-toggle-content{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}.mat-slide-toggle-label-before .mat-slide-toggle-label{order:1}.mat-slide-toggle-label-before .mat-slide-toggle-bar{order:2}.mat-slide-toggle-bar,[dir=rtl] .mat-slide-toggle-label-before .mat-slide-toggle-bar{margin-right:8px;margin-left:0}.mat-slide-toggle-label-before .mat-slide-toggle-bar,[dir=rtl] .mat-slide-toggle-bar{margin-left:8px;margin-right:0}.mat-slide-toggle-bar-no-side-margin{margin-left:0;margin-right:0}.mat-slide-toggle-thumb-container{position:absolute;z-index:1;width:20px;height:20px;top:-3px;left:0;transform:translate3d(0,0,0);transition:all 80ms linear;transition-property:transform;cursor:-webkit-grab;cursor:grab}.mat-slide-toggle-thumb-container.mat-dragging{transition-duration:0s}.mat-slide-toggle-thumb-container:active{cursor:-webkit-grabbing;cursor:grabbing}._mat-animation-noopable .mat-slide-toggle-thumb-container{transition:none}[dir=rtl] .mat-slide-toggle-thumb-container{left:auto;right:0}.mat-slide-toggle-thumb{height:20px;width:20px;border-radius:50%}.mat-slide-toggle-bar{position:relative;width:36px;height:14px;flex-shrink:0;border-radius:8px}.mat-slide-toggle-input{bottom:0;left:10px}[dir=rtl] .mat-slide-toggle-input{left:auto;right:10px}.mat-slide-toggle-bar,.mat-slide-toggle-thumb{transition:all 80ms linear;transition-property:background-color;transition-delay:50ms}._mat-animation-noopable .mat-slide-toggle-bar,._mat-animation-noopable .mat-slide-toggle-thumb{transition:none}.mat-slide-toggle .mat-slide-toggle-ripple{position:absolute;top:calc(50% - 20px);left:calc(50% - 20px);height:40px;width:40px;z-index:1;pointer-events:none}.mat-slide-toggle .mat-slide-toggle-ripple .mat-ripple-element:not(.mat-slide-toggle-persistent-ripple){opacity:.12}.mat-slide-toggle-persistent-ripple{width:100%;height:100%;transform:none}.mat-slide-toggle-bar:hover .mat-slide-toggle-persistent-ripple{opacity:.04}.mat-slide-toggle:not(.mat-disabled).cdk-keyboard-focused .mat-slide-toggle-persistent-ripple{opacity:.12}.mat-slide-toggle-persistent-ripple,.mat-slide-toggle.mat-disabled .mat-slide-toggle-bar:hover .mat-slide-toggle-persistent-ripple{opacity:0}@media (hover:none){.mat-slide-toggle-bar:hover .mat-slide-toggle-persistent-ripple{display:none}}@media (-ms-high-contrast:active){.mat-slide-toggle-thumb{background:#fff;border:1px solid #000}.mat-slide-toggle.mat-checked .mat-slide-toggle-thumb{background:#000;border:1px solid #fff}.mat-slide-toggle-bar{background:#fff}.mat-slide-toggle.cdk-keyboard-focused .mat-slide-toggle-bar{outline:1px dotted;outline-offset:5px}}@media (-ms-high-contrast:black-on-white){.mat-slide-toggle-bar{border:1px solid #000}}"],
                    providers: [MAT_SLIDE_TOGGLE_VALUE_ACCESSOR],
                    inputs: ['disabled', 'disableRipple', 'color', 'tabIndex'],
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                },] },
    ];
    /** @nocollapse */
    MatSlideToggle.ctorParameters = function () { return [
        { type: ElementRef },
        { type: FocusMonitor },
        { type: ChangeDetectorRef },
        { type: String, decorators: [{ type: Attribute, args: ['tabindex',] }] },
        { type: NgZone },
        { type: undefined, decorators: [{ type: Inject, args: [MAT_SLIDE_TOGGLE_DEFAULT_OPTIONS,] }] },
        { type: String, decorators: [{ type: Optional }, { type: Inject, args: [ANIMATION_MODULE_TYPE,] }] },
        { type: Directionality, decorators: [{ type: Optional }] }
    ]; };
    MatSlideToggle.propDecorators = {
        _thumbEl: [{ type: ViewChild, args: ['thumbContainer', { static: false },] }],
        _thumbBarEl: [{ type: ViewChild, args: ['toggleBar', { static: false },] }],
        name: [{ type: Input }],
        id: [{ type: Input }],
        labelPosition: [{ type: Input }],
        ariaLabel: [{ type: Input, args: ['aria-label',] }],
        ariaLabelledby: [{ type: Input, args: ['aria-labelledby',] }],
        required: [{ type: Input }],
        checked: [{ type: Input }],
        change: [{ type: Output }],
        toggleChange: [{ type: Output }],
        dragChange: [{ type: Output }],
        _inputElement: [{ type: ViewChild, args: ['input', { static: false },] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var MAT_SLIDE_TOGGLE_REQUIRED_VALIDATOR = {
        provide: NG_VALIDATORS,
        useExisting: forwardRef(( /**
         * @return {?}
         */function () { return MatSlideToggleRequiredValidator; })),
        multi: true
    };
    /**
     * Validator for Material slide-toggle components with the required attribute in a
     * template-driven form. The default validator for required form controls asserts
     * that the control value is not undefined but that is not appropriate for a slide-toggle
     * where the value is always defined.
     *
     * Required slide-toggle form controls are valid when checked.
     */
    var MatSlideToggleRequiredValidator = /** @class */ (function (_super) {
        __extends(MatSlideToggleRequiredValidator, _super);
        function MatSlideToggleRequiredValidator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return MatSlideToggleRequiredValidator;
    }(CheckboxRequiredValidator));
    MatSlideToggleRequiredValidator.decorators = [
        { type: Directive, args: [{
                    selector: "mat-slide-toggle[required][formControlName],\n             mat-slide-toggle[required][formControl], mat-slide-toggle[required][ngModel]",
                    providers: [MAT_SLIDE_TOGGLE_REQUIRED_VALIDATOR],
                },] },
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * This module is used by both original and MDC-based slide-toggle implementations.
     */
    // tslint:disable-next-line:class-name
    var _MatSlideToggleRequiredValidatorModule = /** @class */ (function () {
        function _MatSlideToggleRequiredValidatorModule() {
        }
        return _MatSlideToggleRequiredValidatorModule;
    }());
    _MatSlideToggleRequiredValidatorModule.decorators = [
        { type: NgModule, args: [{
                    exports: [MatSlideToggleRequiredValidator],
                    declarations: [MatSlideToggleRequiredValidator],
                },] },
    ];
    var MatSlideToggleModule = /** @class */ (function () {
        function MatSlideToggleModule() {
        }
        return MatSlideToggleModule;
    }());
    MatSlideToggleModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        _MatSlideToggleRequiredValidatorModule,
                        MatRippleModule,
                        MatCommonModule,
                        ObserversModule,
                    ],
                    exports: [
                        _MatSlideToggleRequiredValidatorModule,
                        MatSlideToggle,
                        MatCommonModule
                    ],
                    declarations: [MatSlideToggle],
                    providers: [
                        { provide: HAMMER_GESTURE_CONFIG, useClass: GestureConfig }
                    ],
                },] },
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * An op table entry view component.
     */
    var OpTableEntry = /** @class */ (function () {
        function OpTableEntry() {
            /**
             * The depth of node.
             */
            this.level = 0;
            /**
             * The property to sort by waste time.
             */
            this.byWasted = false;
            /**
             * The property to show top 90%.
             */
            this.showP90 = false;
            /**
             * The number of children nodes to be shown.
             */
            this.childrenCount = 10;
            /**
             * The event when the mouse enter or leave.
             */
            this.hover = new EventEmitter();
            /**
             * The event when the selection is changed.
             */
            this.selected = new EventEmitter();
            this.children = [];
            this.expanded = false;
            this.barWidth = '';
            this.flameColor = '';
            this.hideFlopsUtilization = false;
            this.name = '';
            this.offset = '';
            this.percent = '';
            this.provenance = '';
            this.timeWasted = '';
            this.flopsUtilization = '';
            this.numLeftOut = 0;
        }
        /**
         * @param {?} changes
         * @return {?}
         */
        OpTableEntry.prototype.ngOnChanges = function (changes) {
            if (!this.node) {
                this.children = [];
                return;
            }
            if (this.level === 0) {
                this.expanded = true;
            }
            this.children = this.getChildren();
            this.numLeftOut = this.getLeftOut();
            if (!!this.node && !!this.node.metrics && !!this.node.metrics.time) {
                this.percent = percent(this.node.metrics.time);
                this.barWidth = this.percent;
            }
            else {
                this.barWidth = '0';
                this.percent = '';
            }
            this.flameColor =
                flameColor(flopsUtilization(this.node), 0.7, 1, Math.sqrt);
            this.hideFlopsUtilization = !hasFlopsUtilization(this.node);
            this.name = (this.node && this.node.name) ? this.node.name : '';
            this.offset = this.level.toString() + 'em';
            this.provenance = (this.node && this.node.xla && this.node.xla.provenance) ?
                this.node.xla.provenance.replace(/^.*(:|\/)/, '') :
                '';
            this.timeWasted = percent(timeWasted(this.node));
            this.flopsUtilization = percent(flopsUtilization(this.node));
        };
        /**
         * @private
         * @return {?}
         */
        OpTableEntry.prototype.get90ChildrenIndex = function () {
            if (!this.showP90 || !this.node || !this.node.children ||
                this.node.children.length === 0 || !this.node.metrics ||
                !this.node.metrics.time) {
                return this.childrenCount;
            }
            /** @type {?} */
            var tot = 0;
            /** @type {?} */
            var target90 = this.node.metrics.time * 0.9;
            /** @type {?} */
            var targetCount = Math.min(this.childrenCount, this.node.children.length);
            for (var i_189 = 0; i_189 < targetCount; i_189++) {
                if (tot >= target90) {
                    return i_189;
                }
                /** @type {?} */
                var child = this.node.children[i_189];
                if (child && child.metrics && child.metrics.time) {
                    tot += child.metrics.time;
                }
            }
            return this.childrenCount;
        };
        /**
         * @private
         * @return {?}
         */
        OpTableEntry.prototype.getChildren = function () {
            if (!this.node || !this.node.children) {
                return [];
            }
            /** @type {?} */
            var children = [];
            /** @type {?} */
            var k = this.get90ChildrenIndex();
            children = this.level ? this.node.children.slice(0, k) :
                this.node.children.slice();
            if (this.byWasted) {
                children.sort(( /**
                 * @param {?} a
                 * @param {?} b
                 * @return {?}
                 */function (a, b) { return timeWasted(b) - timeWasted(a); }));
            }
            return children;
        };
        /**
         * @private
         * @return {?}
         */
        OpTableEntry.prototype.getLeftOut = function () {
            if (!this.level || !this.node || !this.node.numChildren)
                return 0;
            return this.node.numChildren -
                Math.min(this.childrenCount, this.children.length);
        };
        /**
         * @return {?}
         */
        OpTableEntry.prototype.toggleExpanded = function () {
            this.expanded = !this.expanded;
            this.selected.emit(this.node);
        };
        return OpTableEntry;
    }());
    OpTableEntry.decorators = [
        { type: Component, args: [{
                    selector: 'op-table-entry',
                    template: "<div [hidden]=\"!level\">\n  <div\n    class=\"row\"\n    (click)=\"toggleExpanded()\"\n    (mouseenter)=\"hover.emit(node)\"\n    (mouseleave)=\"hover.emit(null)\">\n    <div class=\"bar\" [style.width]=\"barWidth\"></div>\n    <div class=\"row-focus\" [hidden]=\"node !== selectedNode\"></div>\n    <span class=\"time\">{{percent}}</span>\n    <span class=\"wasted\">{{timeWasted}}</span>\n    <span class=\"name\" [style.padding-left]=\"offset\">\n      <span class=\"disclosure\">\n        <span [hidden]=\"!children.length\">\n          <span [hidden]=\"expanded\">&#x25b6;</span>\n          <span [hidden]=\"!expanded\">&#x25bc;</span>\n        </span>\n      </span>\n      {{name}}\n    </span>\n    <span class=\"provenance\">{{provenance}}&nbsp;</span>\n    <span\n      class=\"utilization\"\n      [hidden]=\"hideFlopsUtilization\">\n      {{flopsUtilization}}\n    </span>\n    <span\n      class=\"flame-color-circle\"\n      [hidden]=\"hideFlopsUtilization\"\n      [style.background-color]=\"flameColor\">\n    </span>\n  </div>\n</div>\n\n<div [hidden]=\"!expanded\">\n  <op-table-entry\n    *ngFor=\"let childNode of children\"\n    [level]=\"level + 1\"\n    [node]=\"childNode\"\n    [selectedNode]=\"selectedNode\"\n    [byWasted]=\"byWasted\"\n    [showP90]=\"showP90\"\n    [childrenCount]=\"childrenCount\"\n    (hover)=\"hover.emit($event);\"\n    (selected)=\"selected.emit($event);\">\n  </op-table-entry>\n  <div class=\"leftout\" *ngIf=\"numLeftOut > 0\">\n    <span [style.padding-left]=\"offset\">{{numLeftOut}} categories or ops have been left out.</span>\n  </div>\n</div>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}:host{color:#4a4a4a}.row{display:flex;align-self:center;position:relative;border-top:1px solid #eee;z-index:0}.row.expanded{background-color:rgba(0,0,0,.04);font-weight:bold}.row:hover{background-color:rgba(0,0,0,.05)}.row>*{padding:.5em;overflow:hidden;flex-shrink:0;box-sizing:border-box}.bar{position:absolute;top:0;left:0;bottom:0;z-index:-2;background-color:#cde;padding:0 !important}.row-focus{position:absolute;top:0;left:0;bottom:0;z-index:-1;width:8px;background-color:#e8710a;padding:0 !important}.time,.wasted,.utilization{line-height:20px;font-size:smaller;width:60px}.time{padding-left:20px !important;width:80px}.name{display:inline-block;min-width:40%}.disclosure{display:inline-block;width:1em}.provenance{flex:1 1 0 !important}.utilization{align-self:stretch;text-align:right}.flame-color-circle{margin:10px 20px 10px 10px;width:16px;height:16px;border-radius:8px}.leftout{padding-left:175px;font-style:italic}\n"]
                }] }
    ];
    OpTableEntry.propDecorators = {
        level: [{ type: Input }],
        node: [{ type: Input }],
        selectedNode: [{ type: Input }],
        byWasted: [{ type: Input }],
        showP90: [{ type: Input }],
        childrenCount: [{ type: Input }],
        hover: [{ type: Output }],
        selected: [{ type: Output }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * An op table entry view module.
     */
    var OpTableEntryModule = /** @class */ (function () {
        function OpTableEntryModule() {
        }
        return OpTableEntryModule;
    }());
    OpTableEntryModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [OpTableEntry],
                    imports: [CommonModule],
                    exports: [OpTableEntry]
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * An op table view component.
     */
    var OpTable = /** @class */ (function () {
        /**
         * @param {?} store
         */
        function OpTable(store) {
            this.store = store;
            /**
             * The property to sort by wasted time.
             */
            this.byWasted = false;
            /**
             * The property to show top 90%.
             */
            this.showP90 = false;
            /**
             * The number of children nodes to be shown.
             */
            this.childrenCount = 10;
        }
        /**
         * @param {?=} node
         * @return {?}
         */
        OpTable.prototype.updateSelected = function (node) {
            this.selectedNode = node;
        };
        /**
         * @return {?}
         */
        OpTable.prototype.ngOnDestroy = function () {
            this.store.dispatch(setActiveOpProfileNodeAction({ activeOpProfileNode: null }));
        };
        /**
         * @param {?} node
         * @return {?}
         */
        OpTable.prototype.updateActive = function (node) {
            this.store.dispatch(setActiveOpProfileNodeAction({ activeOpProfileNode: node || this.selectedNode || null }));
        };
        return OpTable;
    }());
    OpTable.decorators = [
        { type: Component, args: [{
                    selector: 'op-table',
                    template: "<div class=\"header\">\n  <span class=\"time\">Time</span>\n  <span class=\"wasted\">Wasted</span>\n  <span class=\"name\">Name</span>\n  <span class=\"provenance\">TensorFlow Op</span>\n  <span class=\"utilization\">FLOPS</span>\n  <span class=\"flame-color-circle\"></span>\n</div>\n\n<op-table-entry\n  [level]=\"0\"\n  [node]=\"rootNode\"\n  [selectedNode]=\"selectedNode\"\n  [byWasted]=\"byWasted\"\n  [showP90]=\"showP90\"\n  [childrenCount]=\"childrenCount\"\n  (hover)=\"updateActive($event)\"\n  (selected)=\"updateSelected($event)\">\n</op-table-entry>\n",
                    styles: [".header{display:flex;align-items:center;font-size:smaller;font-weight:bold;color:#666;padding-bottom:.25em;text-transform:uppercase;white-space:nowrap}.header>*{padding:.5em .5em 0;overflow:hidden;flex-shrink:0;box-sizing:border-box}.time{padding-left:20px !important;width:80px}.wasted,.utilization{width:60px}.name{display:inline-block;min-width:40%;padding-left:2em !important}.provenance{flex:1 1 0 !important}.utilization{text-align:right}.flame-color-circle{margin:0 20px 0 10px;width:16px}\n"]
                }] }
    ];
    /** @nocollapse */
    OpTable.ctorParameters = function () { return [
        { type: Store }
    ]; };
    OpTable.propDecorators = {
        rootNode: [{ type: Input }],
        byWasted: [{ type: Input }],
        showP90: [{ type: Input }],
        childrenCount: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * An op table view module.
     */
    var OpTableModule = /** @class */ (function () {
        function OpTableModule() {
        }
        return OpTableModule;
    }());
    OpTableModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [OpTable],
                    imports: [OpTableEntryModule],
                    exports: [OpTable]
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * An op profile module.
     */
    var OpProfileModule = /** @class */ (function () {
        function OpProfileModule() {
        }
        return OpProfileModule;
    }());
    OpProfileModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [OpProfile],
                    imports: [
                        MatFormFieldModule,
                        MatInputModule,
                        MatSliderModule,
                        MatSlideToggleModule,
                        OpTableModule,
                        MatIconModule,
                        MatTooltipModule,
                    ],
                    exports: [OpProfile]
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var GENERAL_ANALYSIS_INDEX = 0;
    /** @type {?} */
    var INPUT_PIPELINE_ANALYSIS_INDEX = 1;
    /** @type {?} */
    var RUN_ENVIRONMENT_INDEX = 2;
    /** @type {?} */
    var RECOMMENDATION_RESULT_INDEX = 3;
    /** @type {?} */
    var NORMALIZED_ACCELERATOR_PERFORMANCE_INDEX = 5;
    /** @type {?} */
    var DIAGNOSTICS_INDEX = 6;
    /**
     * A common class of overview page component.
     */
    var OverviewCommon = /** @class */ (function () {
        function OverviewCommon() {
            this.propertyValues = [];
            this.diagnostics = { info: [], warnings: [], errors: [] };
            this.generalAnalysis = null;
            this.inputPipelineAnalysis = null;
            this.recommendationResult = null;
            this.runEnvironment = null;
            this.normalizedAcceleratorPerformance = null;
        }
        Object.defineProperty(OverviewCommon.prototype, "averageStepTimePropertyValues", {
            /**
             * @return {?}
             */
            get: function () {
                return this.propertyValues;
            },
            /**
             * @param {?} propertyValues
             * @return {?}
             */
            set: function (propertyValues) {
                this.propertyValues = propertyValues;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} data
         * @return {?}
         */
        OverviewCommon.prototype.parseOverviewData = function (data) {
            this.generalAnalysis = data[GENERAL_ANALYSIS_INDEX];
            this.inputPipelineAnalysis = data[INPUT_PIPELINE_ANALYSIS_INDEX];
            this.runEnvironment = data[RUN_ENVIRONMENT_INDEX];
            this.recommendationResult = data[RECOMMENDATION_RESULT_INDEX];
            this.normalizedAcceleratorPerformance =
                data[NORMALIZED_ACCELERATOR_PERFORMANCE_INDEX];
            this.diagnostics = parseDiagnosticsDataTable(data[DIAGNOSTICS_INDEX]);
        };
        return OverviewCommon;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * An overview page component.
     */
    var Overview = /** @class */ (function (_super) {
        __extends(Overview, _super);
        /**
         * @param {?} route
         * @param {?} dataService
         * @param {?} store
         */
        function Overview(route, dataService, store) {
            var _this = _super.call(this) || this;
            _this.dataService = dataService;
            _this.store = store;
            /**
             * Handles on-destroy Subject, used to unsubscribe.
             */
            _this.destroyed = new ReplaySubject(1);
            route.params.pipe(takeUntil(_this.destroyed)).subscribe(( /**
             * @param {?} params
             * @return {?}
             */function (params) {
                _this.update(( /** @type {?} */(params)));
            }));
            return _this;
        }
        /**
         * @return {?}
         */
        Overview.prototype.parseAverageStepTimeDetail = function () {
            /** @type {?} */
            var p = ((this.inputPipelineAnalysis || {}).p || {});
            this.averageStepTimePropertyValues.push("Idle: " + (p.idle_ms_average || '') + " ms");
            this.averageStepTimePropertyValues.push("Input: " + (p.input_ms_average || '') + " ms");
            this.averageStepTimePropertyValues.push("Compute: " + (p.compute_ms_average || '') + " ms");
        };
        /**
         * @param {?} event
         * @return {?}
         */
        Overview.prototype.update = function (event) {
            var _this = this;
            /** @type {?} */
            var run = event.run || '';
            /** @type {?} */
            var tag = event.tag || 'overview_page';
            /** @type {?} */
            var host = event.host || '';
            this.store.dispatch(setLoadingStateAction({
                loadingState: {
                    loading: true,
                    message: 'Loading data',
                }
            }));
            this.dataService.getData(run, tag, host)
                .pipe(takeUntil(this.destroyed))
                .subscribe(( /**
         * @param {?} data
         * @return {?}
         */function (data) {
                _this.store.dispatch(setLoadingStateAction({
                    loadingState: {
                        loading: false,
                        message: '',
                    }
                }));
                /** Transfer data to Overview DataTable type */
                _this.parseOverviewData(( /** @type {?} */((data || []))));
                _this.parseAverageStepTimeDetail();
            }));
        };
        /**
         * @return {?}
         */
        Overview.prototype.ngOnDestroy = function () {
            // Unsubscribes all pending subscriptions.
            this.destroyed.next();
            this.destroyed.complete();
        };
        return Overview;
    }(OverviewCommon));
    Overview.decorators = [
        { type: Component, args: [{
                    selector: 'overview',
                    template: "<!--\n  The Overview Page is a view within the tf-profile-dashboard.\n  It is the first page that users would look at in order to understand\n  the overall performance of their TPU workloads. The page has five\n  sections of results:\n    (1) Performance summary\n    (2) Step-time graph\n    (3) Top 10 TensorFlow Operations executed on TPU\n    (4) Run environment\n    (5) Recommendation for next steps\n-->\n\n<div>\n  <diagnostics-view [diagnostics]=\"diagnostics\"></diagnostics-view>\n  <div class=\"container\">\n    <div class=\"left-column\">\n      <performance-summary\n          [generalAnalysis]=\"generalAnalysis\"\n          [inputPipelineAnalysis]=\"inputPipelineAnalysis\"\n          [propertyValues]=\"averageStepTimePropertyValues\">\n      </performance-summary>\n      <run-environment-view [runEnvironment]=\"runEnvironment\"></run-environment-view>\n    </div>\n\n    <div class=\"right-column\">\n      <step-time-graph [inputPipelineAnalysis]=\"inputPipelineAnalysis\"></step-time-graph>\n      <recommendation-result-view [recommendationResult]=\"recommendationResult\">\n      </recommendation-result-view>\n    </div>\n\n    <div class=\"full-column\">\n      <top-ops-table\n          [generalAnalysis]=\"generalAnalysis\"\n          [inputPipelineAnalysis]=\"inputPipelineAnalysis\">\n      </top-ops-table>\n    </div>\n  </div>\n</div>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}:host{display:block}.container{display:flex;flex-wrap:wrap;width:100%}.left-column{display:flex;flex-direction:column;width:33.333%}.right-column{display:flex;flex-direction:column;width:66.667%}.full-column{border-right:1px solid #eee;width:100%}@media screen and (max-width: 860px){:host{width:fit-content}}@media screen and (max-width: 1140px){.left-column,.right-column{width:100%}}\n"]
                }] }
    ];
    /** @nocollapse */
    Overview.ctorParameters = function () { return [
        { type: ActivatedRoute },
        { type: DataService },
        { type: Store }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A normalized accelerator performance view component.
     */
    var NormalizedAcceleratorPerformanceView = /** @class */ (function () {
        function NormalizedAcceleratorPerformanceView() {
            this.title = 'GCU/NAP Details';
            this.backgroundInfos = [];
            this.totalNapsInfos = [];
            this.computeCostInfos = [];
            this.computeProductivityInfos = [];
        }
        Object.defineProperty(NormalizedAcceleratorPerformanceView.prototype, "normalizedAcceleratorPerformance", {
            /**
             * The run environment data.
             * @param {?} data
             * @return {?}
             */
            set: function (data) {
                data = data || {};
                data.p = data.p || {};
                this.backgroundInfos = [];
                this.backgroundInfos.push(data.p.background_link_0 || '');
                this.backgroundInfos.push(data.p.background_link_1 || '');
                this.backgroundInfos = this.backgroundInfos.filter(( /**
                 * @param {?} info
                 * @return {?}
                 */function (/**
                 * @param {?} info
                 * @return {?}
                 */ info) { return !!info; }));
                this.totalNapsInfos = [];
                this.totalNapsInfos.push(data.p.total_naps_line_0 || '');
                this.totalNapsInfos.push(data.p.total_naps_line_1 || '');
                this.totalNapsInfos.push(data.p.total_naps_line_2 || '');
                this.totalNapsInfos = this.totalNapsInfos.filter(( /**
                 * @param {?} info
                 * @return {?}
                 */function (/**
                 * @param {?} info
                 * @return {?}
                 */ info) { return !!info; }));
                this.computeCostInfos = [];
                this.computeCostInfos.push(data.p.training_cost_line_0 || '');
                this.computeCostInfos.push(data.p.training_cost_line_1 || '');
                this.computeCostInfos = this.computeCostInfos.filter(( /**
                 * @param {?} info
                 * @return {?}
                 */function (/**
                 * @param {?} info
                 * @return {?}
                 */ info) { return !!info; }));
                this.computeProductivityInfos = [];
                this.computeProductivityInfos.push(data.p.training_productivity_line_0 || '');
                this.computeProductivityInfos.push(data.p.training_productivity_line_1 || '');
                this.computeProductivityInfos =
                    this.computeProductivityInfos.filter(( /**
                     * @param {?} info
                     * @return {?}
                     */function (/**
                     * @param {?} info
                     * @return {?}
                     */ info) { return !!info; }));
            },
            enumerable: true,
            configurable: true
        });
        return NormalizedAcceleratorPerformanceView;
    }());
    NormalizedAcceleratorPerformanceView.decorators = [
        { type: Component, args: [{
                    selector: 'normalized-accelerator-performance-view',
                    template: "<mat-expansion-panel>\n  <mat-expansion-panel-header>\n    <mat-panel-title>{{title}}</mat-panel-title>\n  </mat-expansion-panel-header>\n  <div [hidden]=\"!backgroundInfos.length\">\n    <p>\n      <b>Background</b>:\n    </p>\n    <ul>\n      <li *ngFor=\"let info of backgroundInfos\" [innerHtml]=\"info\"></li>\n    </ul>\n  </div>\n  <p [hidden]=\"!totalNapsInfos.length\">\n    <b>Total NAPs/GCUs of the accelerator system profiled</b>:<br/>\n    <span *ngFor=\"let info of totalNapsInfos\">= {{info}}<br/></span>\n  </p>\n  <p [hidden]=\"!computeCostInfos.length\">\n    <b>Compute Cost</b> (lower is better):<br/>\n    <span *ngFor=\"let info of computeCostInfos\">= {{info}}<br/></span>\n  </p>\n  <p [hidden]=\"!computeProductivityInfos.length\">\n    <b>Compute Productivity</b> (higher is better):<br/>\n    <span *ngFor=\"let info of computeProductivityInfos\">= {{info}}<br/></span>\n  </p>\n</mat-expansion-panel>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}:host:not(.dark-theme) mat-expansion-panel{box-shadow:none !important;margin:8px;margin:0}@media screen and (max-width: 1140px){:host:not(.dark-theme) mat-expansion-panel{min-width:500px}}mat-expansion-panel-header{margin:8px 8px 0}mat-panel-title{background-color:#fff;border-top-left-radius:4px;border-top-right-radius:4px;color:#000;font-size:24px;font-weight:400;background-color:transparent}mat-expansion-panel-header.cdk-keyboard-focused,mat-expansion-panel:not(.mat-expanded) mat-expansion-panel-header:hover{background-color:#eee !important}.mat-expanded mat-expansion-panel-header{border-bottom-left-radius:0;border-bottom-right-radius:0}b{font-weight:500}ul{list-style-position:outside;margin-top:-16px;padding-inline-start:20px}:host.dark-theme{border:none}:host.dark-theme mat-expansion-panel{margin:8px}@media screen and (max-width: 1140px){:host.dark-theme mat-expansion-panel{min-width:500px}}:host.dark-theme mat-panel-title{background-color:transparent;color:#fff}:host.dark-theme mat-expansion-panel-header{background-color:#3f51b5;margin:0}:host.dark-theme mat-expansion-panel-header.cdk-keyboard-focused,:host.dark-theme mat-expansion-panel:not(.mat-expanded) mat-expansion-panel-header:hover{background-color:#7885cb !important}:host.dark-theme .table{margin-top:18px}\n"]
                }] }
    ];
    NormalizedAcceleratorPerformanceView.propDecorators = {
        normalizedAcceleratorPerformance: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A normalized accelerator performance view module.
     */
    var NormalizedAcceleratorPerformanceViewModule = /** @class */ (function () {
        function NormalizedAcceleratorPerformanceViewModule() {
        }
        return NormalizedAcceleratorPerformanceViewModule;
    }());
    NormalizedAcceleratorPerformanceViewModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [NormalizedAcceleratorPerformanceView],
                    imports: [
                        CommonModule,
                        MatExpansionModule,
                    ],
                    exports: [NormalizedAcceleratorPerformanceView]
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var GENERIC_SUMMARY_INFO = [
        {
            title: 'All Others Time',
            avg: 'other_time_ms_avg',
            sdv: 'other_time_ms_sdv',
        },
        {
            title: 'Compilation Time',
            avg: 'compile_time_ms_avg',
            sdv: 'compile_time_ms_sdv',
        },
        {
            title: 'Output Time',
            avg: 'outfeed_time_ms_avg',
            sdv: 'outfeed_time_ms_sdv',
        },
        {
            title: 'Input Time',
            avg: 'infeed_time_ms_avg',
            sdv: 'infeed_time_ms_sdv',
        },
        {
            title: 'Kernel Launch Time',
            avg: 'kernel_launch_time_ms_avg',
            sdv: 'kernel_launch_time_ms_sdv',
        },
        {
            title: 'Host Compute Time',
            avg: 'host_compute_time_ms_avg',
            sdv: 'host_compute_time_ms_sdv',
        },
        {
            title: 'Device Collective Communication Time',
            avg: 'device_collectives_time_ms_avg',
            sdv: 'device_collectives_time_ms_sdv',
        },
        {
            title: 'Device to Device Time',
            avg: 'device_to_device_time_ms_avg',
            sdv: 'device_to_device_time_ms_sdv',
        },
        {
            title: 'Device Compute Time',
            avg: 'device_compute_time_ms_avg',
            sdv: 'device_compute_time_ms_sdv',
        },
    ];
    /**
     * A performance summary view component.
     */
    var PerformanceSummary = /** @class */ (function () {
        function PerformanceSummary() {
            /**
             * The summary info to be displayed first.
             */
            this.firstSummaryInfo = [];
            /**
             * The color of average step time value from parent component.
             */
            this.averageStepTimeValueColor = '';
            this.title = 'Performance Summary';
            this.isTpu = true;
            this.summaryInfoAfter = [];
            this.summaryInfoBefore = [];
            this.mxuUtilizationPercent = '';
            this.flopRateUtilizationRelativeToRoofline = '';
            this.remarkText = '';
            this.remarkColor = '';
            this.flopsUtilizationTooltipMessage = 'The first number shows the hardware utilization based on the hardware performance counter. The second one shows the performance compared to the program\'s optimal performance considering the instruction mix (i.e., the ratio of floating-point operations and memory operations).';
            this.tfOpPlacementTooltipMessage = 'It is based on the number of TF ops executed on the host and device.';
            this.opTimeInEagerModeTooltipMessage = 'Out of the total op execution time on host (device), excluding idle time, the percentage of which used eager execution.';
            this.memoryBandwidthTooltipMessage = 'Percentage of the peak device memory bandwidth that is used.';
            this.deviceDutyCycleTooltipMessage = 'Percentage of the device time that is busy.';
        }
        /**
         * @param {?} changes
         * @return {?}
         */
        PerformanceSummary.prototype.ngOnChanges = function (changes) {
            if (!this.generalAnalysis || !this.inputPipelineAnalysis) {
                return;
            }
            this.isTpu = this.getInputPipelineProp('hardware_type', 'TPU') === 'TPU';
            if (this.isTpu) {
                this.parseTpuData();
            }
            else {
                this.parseGenericData();
            }
        };
        /**
         * @param {?} id
         * @param {?=} defaultValue
         * @return {?}
         */
        PerformanceSummary.prototype.getInputPipelineProp = function (id, defaultValue) {
            if (defaultValue === void 0) { defaultValue = ''; }
            /** @type {?} */
            var props = (this.inputPipelineAnalysis || {}).p || {};
            switch (id) {
                case 'hardware_type':
                    return props.hardware_type || defaultValue;
                case 'other_time_ms_avg':
                    return props.other_time_ms_avg || defaultValue;
                case 'other_time_ms_sdv':
                    return props.other_time_ms_sdv || defaultValue;
                case 'compile_time_ms_avg':
                    return props.compile_time_ms_avg || defaultValue;
                case 'compile_time_ms_sdv':
                    return props.compile_time_ms_sdv || defaultValue;
                case 'outfeed_time_ms_avg':
                    return props.outfeed_time_ms_avg || defaultValue;
                case 'outfeed_time_ms_sdv':
                    return props.outfeed_time_ms_sdv || defaultValue;
                case 'infeed_time_ms_avg':
                    return props.infeed_time_ms_avg || defaultValue;
                case 'infeed_time_ms_sdv':
                    return props.infeed_time_ms_sdv || defaultValue;
                case 'kernel_launch_time_ms_avg':
                    return props.kernel_launch_time_ms_avg || defaultValue;
                case 'kernel_launch_time_ms_sdv':
                    return props.kernel_launch_time_ms_sdv || defaultValue;
                case 'host_compute_time_ms_avg':
                    return props.host_compute_time_ms_avg || defaultValue;
                case 'host_compute_time_ms_sdv':
                    return props.host_compute_time_ms_sdv || defaultValue;
                case 'device_collectives_time_ms_avg':
                    return props.device_collectives_time_ms_avg || defaultValue;
                case 'device_collectives_time_ms_sdv':
                    return props.device_collectives_time_ms_sdv || defaultValue;
                case 'device_to_device_time_ms_avg':
                    return props.device_to_device_time_ms_avg || defaultValue;
                case 'device_to_device_time_ms_sdv':
                    return props.device_to_device_time_ms_sdv || defaultValue;
                case 'device_compute_time_ms_avg':
                    return props.device_compute_time_ms_avg || defaultValue;
                case 'device_compute_time_ms_sdv':
                    return props.device_compute_time_ms_sdv || defaultValue;
                default:
                    break;
            }
            return defaultValue;
        };
        /**
         * @param {?} inputPipelineProps
         * @return {?}
         */
        PerformanceSummary.prototype.initializeSummary = function (inputPipelineProps) {
            this.summaryInfoBefore = __spread(this.firstSummaryInfo);
            this.summaryInfoAfter = [];
            if (this.propertyValues && this.propertyValues.length) {
                this.summaryInfoBefore.push({
                    title: 'Average Step Time',
                    descriptions: [
                        'lower is better',
                        "(\u03C3 = " + (inputPipelineProps.steptime_ms_standard_deviation || '') + " ms)",
                    ],
                    value: inputPipelineProps.steptime_ms_average + " ms",
                    valueColor: this.averageStepTimeValueColor,
                    propertyValues: __spread((this.propertyValues || [])),
                });
            }
        };
        /**
         * @return {?}
         */
        PerformanceSummary.prototype.parseTpuData = function () {
            /** @type {?} */
            var generalProps = (this.generalAnalysis || {}).p || {};
            /** @type {?} */
            var inputPipelineProps = (this.inputPipelineAnalysis || {}).p || {};
            this.mxuUtilizationPercent = generalProps.mxu_utilization_percent || '';
            this.flopRateUtilizationRelativeToRoofline =
                generalProps.flop_rate_utilization_relative_to_roofline || '';
            this.remarkText = generalProps.remark_text || '';
            this.remarkColor = generalProps.remark_color || '';
            this.initializeSummary(inputPipelineProps);
            this.summaryInfoBefore.push({
                title: 'TPU Duty Cycle',
                tooltip: this.deviceDutyCycleTooltipMessage,
                descriptions: ['higher is better'],
                value: generalProps.device_duty_cycle_percent,
            });
            this.summaryInfoAfter.push({
                title: 'Memory Bandwidth Utilization',
                tooltip: this.memoryBandwidthTooltipMessage,
                descriptions: ['higher is better'],
                value: generalProps.memory_bw_utilization_relative_to_hw_limit,
            });
            this.summaryInfoAfter.push({
                title: 'TF Op Placement',
                descriptions: ['generally desired to have more ops on device'],
                tooltip: this.tfOpPlacementTooltipMessage,
                propertyValues: [
                    "Host: " + (generalProps.host_tf_op_percent || ''),
                    "Device: " + (generalProps.device_tf_op_percent || ''),
                ],
            });
            this.summaryInfoAfter.push({
                title: 'Op Time Spent on Eager Execution',
                descriptions: ['lower is better'],
                tooltip: this.opTimeInEagerModeTooltipMessage,
                propertyValues: [
                    "Host: " + (generalProps.host_op_time_eager_percent || ''),
                    "Device: " + (generalProps.device_op_time_eager_percent || ''),
                ],
            });
        };
        /**
         * @return {?}
         */
        PerformanceSummary.prototype.parseGenericData = function () {
            var _this = this;
            /** @type {?} */
            var generalProps = (this.generalAnalysis || {}).p || {};
            /** @type {?} */
            var inputPipelineProps = (this.inputPipelineAnalysis || {}).p || {};
            this.remarkText = generalProps.remark_text || '';
            this.remarkColor = generalProps.remark_color || '';
            this.initializeSummary(inputPipelineProps);
            GENERIC_SUMMARY_INFO.forEach(( /**
             * @param {?} info
             * @return {?}
             */function (/**
             * @param {?} info
             * @return {?}
             */ info) {
                _this.summaryInfoBefore.push({
                    type: 'list',
                    title: info.title,
                    descriptions: ["(\u03C3 =  " + _this.getInputPipelineProp(info.sdv) + " ms)"],
                    value: _this.getInputPipelineProp(info.avg) + " ms",
                });
            }));
            this.summaryInfoBefore.push({
                title: 'TF Op Placement',
                descriptions: ['generally desired to have more ops on device'],
                tooltip: this.tfOpPlacementTooltipMessage,
                propertyValues: [
                    "Host: " + (generalProps.host_tf_op_percent || ''),
                    "Device: " + (generalProps.device_tf_op_percent || ''),
                ],
            });
            this.summaryInfoBefore.push({
                title: 'Op Time Spent on Eager Execution',
                descriptions: ['lower is better'],
                tooltip: this.opTimeInEagerModeTooltipMessage,
                propertyValues: [
                    "Host: " + (generalProps.host_op_time_eager_percent || ''),
                    "Device: " + (generalProps.device_op_time_eager_percent || ''),
                ],
            });
            this.summaryInfoBefore.push({
                title: 'Device Compute Precisions',
                descriptions: ['out of Total Device Time'],
                propertyValues: [
                    "16-bit: " + (generalProps.device_compute_16bit_percent || ''),
                    "32-bit: " + (generalProps.device_compute_32bit_percent || ''),
                ],
            });
        };
        return PerformanceSummary;
    }());
    PerformanceSummary.decorators = [
        { type: Component, args: [{
                    selector: 'performance-summary',
                    template: " <mat-card>\n  <mat-card-title>{{title}}</mat-card-title>\n  <mat-card-content>\n    <ng-template *ngTemplateOutlet=\"summaryInfo; context: {$implicit: summaryInfoBefore}\">\n    </ng-template>\n\n    <div [hidden]=\"!isTpu\">\n      <div class=\"item-container\">\n        <table>\n          <tr>\n            <td>\n              <b>FLOPS Utilization</b>\n              <div class=\"description\">\n                (higher is better,\n                <span\n                  class=\"flops-utilization-tooltip-target\"\n                  [matTooltip]=\"flopsUtilizationTooltipMessage\"\n                  matTooltipPosition=\"above\">\n                  why two numbers?\n                </span>\n                )\n              </div>\n            </td>\n          </tr>\n        </table>\n      </div>\n      <ul>\n        <li class=\"primary-content\">Utilization of TPU Matrix Units: {{mxuUtilizationPercent}}</li>\n        <li class=\"primary-content\">\n          Compared to Program's Optimal FLOPS: {{flopRateUtilizationRelativeToRoofline}}\n          <ng-content></ng-content>\n        </li>\n      </ul>\n    </div>\n\n    <ng-template *ngTemplateOutlet=\"summaryInfo; context: {$implicit: summaryInfoAfter}\">\n    </ng-template>\n\n    <div class=\"item-container\">\n      <b [style.color]=\"remarkColor\">{{remarkText}}</b>\n    </div>\n    <p><!-- empty paragraph for bottom margin --></p>\n  </mat-card-content>\n</mat-card>\n\n<ng-template #summaryInfo let-infoArray>\n  <div *ngFor=\"let info of infoArray\">\n    <div class=\"item-container\">\n      <table>\n        <tr>\n          <td>\n            <div *ngIf=\"info.type !== 'list'\">\n              <ng-template *ngTemplateOutlet=\"titleAndTooltip; context: {$implicit: info}\">\n              </ng-template>\n            </div>\n            <ul *ngIf=\"info.type === 'list'\">\n              <li>\n                <ng-template *ngTemplateOutlet=\"titleAndTooltip; context: {$implicit: info}\">\n                </ng-template>\n              </li>\n            </ul>\n            <div *ngFor=\"let description of info.descriptions\"\n                 [ngClass]=\"{'item-description': info.type == 'list', 'description': true}\">\n              {{description}}\n            </div>\n          </td>\n          <td *ngIf=\"info.value\" class=\"item-value\">\n            <div [style.color]=\"info.valueColor\">{{info.value}}</div>\n          </td>\n        </tr>\n      </table>\n    </div>\n    <ul *ngIf=\"info.propertyValues?.length\">\n      <li class=\"primary-content\" *ngFor=\"let value of info.propertyValues\">{{value}}</li>\n    </ul>\n  </div>\n</ng-template>\n\n<ng-template #titleAndTooltip let-info>\n    <b>{{info.title}}</b>\n    <span *ngIf=\"info.tooltip\" class=\"tooltip-icon-container\">\n      <mat-icon\n        class=\"tooltip-icon\"\n        [matTooltip]=\"info.tooltip\"\n        matTooltipPosition=\"above\">\n        info\n      </mat-icon>\n    </span>\n</ng-template>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}:host{border-bottom:1px solid #eee;border-right:1px solid #eee}:host:not(.dark-theme) mat-card{box-shadow:none !important;margin:8px}@media screen and (max-width: 1140px){:host:not(.dark-theme) mat-card{min-width:500px}}mat-card{height:calc(100% - 48px)}mat-card-title{background-color:#fff;border-top-left-radius:4px;border-top-right-radius:4px;color:#000;font-size:24px;font-weight:400}b{font-weight:500}ul{list-style-position:outside;margin-top:-16px;padding-inline-start:20px}table{width:100%}table ul{margin:0}.item-container{margin-bottom:16px}.item-container>table{border-spacing:0}.item-container>td{padding:0}.item-value{padding-left:8px;min-width:80px;width:20%;font-size:18px;font-weight:500}.item-description{margin-left:20px}.flops-utilization-tooltip-target{color:#e8710a;border-bottom:1px dotted #e8710a;cursor:pointer}.tooltip-icon-container{position:relative}.tooltip-icon{color:#e8710a;position:absolute;top:-2px;left:4px;font-size:20px;width:20px;height:20px;cursor:pointer}:host.dark-theme{flex-grow:1;border:none}:host.dark-theme mat-card{margin:8px}@media screen and (max-width: 1140px){:host.dark-theme mat-card{min-width:500px}}:host.dark-theme mat-card-title{background-color:#3f51b5;color:#fff;padding:16px;margin:-16px -16px 16px}\n"]
                }] }
    ];
    PerformanceSummary.propDecorators = {
        generalAnalysis: [{ type: Input }],
        inputPipelineAnalysis: [{ type: Input }],
        firstSummaryInfo: [{ type: Input }],
        propertyValues: [{ type: Input }],
        averageStepTimeValueColor: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PerformanceSummaryModule = /** @class */ (function () {
        function PerformanceSummaryModule() {
        }
        return PerformanceSummaryModule;
    }());
    PerformanceSummaryModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [PerformanceSummary],
                    imports: [
                        CommonModule,
                        MatCardModule,
                        MatIconModule,
                        MatTooltipModule,
                    ],
                    exports: [PerformanceSummary]
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A common class of recommendation result view component.
     */
    var RecommendationResultViewCommon = /** @class */ (function () {
        function RecommendationResultViewCommon() {
            this.title = 'Recommendation for Next Step';
            this.statements = [];
            this.tipInfoArray = [];
        }
        /**
         * @param {?} changes
         * @return {?}
         */
        RecommendationResultViewCommon.prototype.ngOnChanges = function (changes) {
            this.parseStatements();
            this.parseTips();
        };
        /**
         * @return {?}
         */
        RecommendationResultViewCommon.prototype.parseStatements = function () { };
        /**
         * @return {?}
         */
        RecommendationResultViewCommon.prototype.parseTips = function () { };
        /**
         * @param {?} event
         * @return {?}
         */
        RecommendationResultViewCommon.prototype.onTipsClick = function (event) { };
        return RecommendationResultViewCommon;
    }());
    RecommendationResultViewCommon.propDecorators = {
        recommendationResult: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var STATEMENT_INFO = [
        { id: 'outside_compilation_statement_html' },
        { id: 'eager_statement_html' },
        { id: 'tf_function_statement_html' },
        { id: 'statement' },
        { id: 'device_collectives_statement' },
        { id: 'kernel_launch_statement' },
        { id: 'all_other_statement' },
        { id: 'precision_statement' },
    ];
    /**
     * A recommendation result view component.
     */
    var RecommendationResultView = /** @class */ (function (_super) {
        __extends(RecommendationResultView, _super);
        /**
         * @param {?} store
         */
        function RecommendationResultView(store) {
            var _this = _super.call(this) || this;
            _this.store = store;
            return _this;
        }
        /**
         * @param {?} id
         * @param {?=} defaultValue
         * @return {?}
         */
        RecommendationResultView.prototype.getRecommendationResultProp = function (id, defaultValue) {
            if (defaultValue === void 0) { defaultValue = ''; }
            /** @type {?} */
            var props = (this.recommendationResult || {}).p || {};
            switch (id) {
                case 'bottleneck':
                    return props.bottleneck || defaultValue;
                case 'outside_compilation_statement_html':
                    return props.outside_compilation_statement_html || defaultValue;
                case 'eager_statement_html':
                    return props.eager_statement_html || defaultValue;
                case 'tf_function_statement_html':
                    return props.tf_function_statement_html || defaultValue;
                case 'statement':
                    return props.statement || defaultValue;
                case 'device_collectives_statement':
                    return props.device_collectives_statement || defaultValue;
                case 'kernel_launch_statement':
                    return props.kernel_launch_statement || defaultValue;
                case 'all_other_statement':
                    return props.all_other_statement || defaultValue;
                case 'precision_statement':
                    return props.precision_statement || defaultValue;
                default:
                    break;
            }
            return defaultValue;
        };
        /**
         * @return {?}
         */
        RecommendationResultView.prototype.parseStatements = function () {
            var _this = this;
            this.statements = [];
            STATEMENT_INFO.forEach(( /**
             * @param {?} info
             * @return {?}
             */function (/**
             * @param {?} info
             * @return {?}
             */ info) {
                /** @type {?} */
                var prop = _this.getRecommendationResultProp(info.id);
                if (prop) {
                    _this.statements.push({ value: prop });
                }
            }));
        };
        /**
         * @return {?}
         */
        RecommendationResultView.prototype.parseTips = function () {
            /** @type {?} */
            var data = this.recommendationResult || {};
            /** @type {?} */
            var hostTips = [];
            /** @type {?} */
            var deviceTips = [];
            /** @type {?} */
            var documentationTips = [];
            /** @type {?} */
            var faqTips = [];
            data.rows = data.rows || [];
            data.rows.forEach(( /**
             * @param {?} row
             * @return {?}
             */function (/**
             * @param {?} row
             * @return {?}
             */ row) {
                if (row.c && row.c[0] && row.c[0].v && row.c[1] && row.c[1].v) {
                    switch (row.c[0].v) {
                        case 'host':
                            hostTips.push(convertKnownToolToAnchorTag(String(row.c[1].v)));
                            break;
                        case 'device':
                            deviceTips.push(convertKnownToolToAnchorTag(String(row.c[1].v)));
                            break;
                        case 'doc':
                            documentationTips.push(String(row.c[1].v));
                            break;
                        case 'faq':
                            faqTips.push(String(row.c[1].v));
                            break;
                        default:
                            break;
                    }
                }
            }));
            /** @type {?} */
            var bottleneck = this.getRecommendationResultProp('bottleneck');
            if (bottleneck === 'device') {
                hostTips.length = 0;
            }
            else if (bottleneck === 'host') {
                deviceTips.length = 0;
            }
            /** @type {?} */
            var tipInfoArray = [
                {
                    title: 'Tool troubleshooting / FAQ',
                    tips: faqTips,
                },
                {
                    title: 'Next tools to use for reducing the input time',
                    tips: hostTips,
                    useClickCallback: true,
                },
                {
                    title: 'Next tools to use for reducing the Device time',
                    tips: deviceTips,
                    useClickCallback: true,
                },
                {
                    title: 'Other useful resources',
                    tips: documentationTips,
                },
            ];
            this.tipInfoArray = tipInfoArray.filter(( /**
             * @param {?} tipInfo
             * @return {?}
             */function (/**
             * @param {?} tipInfo
             * @return {?}
             */ tipInfo) { return tipInfo.tips.length > 0; }));
        };
        /**
         * @param {?} event
         * @return {?}
         */
        RecommendationResultView.prototype.onTipsClick = function (event) {
            if (!event || !event.target ||
                (( /** @type {?} */(event.target))).tagName !== 'A') {
                return;
            }
            /** @type {?} */
            var tool = (( /** @type {?} */(event.target))).innerText;
            if (convertKnownToolToAnchorTag(tool) === addAnchorTag(tool)) {
                this.store.dispatch(setCurrentToolStateAction({ currentTool: tool }));
            }
        };
        return RecommendationResultView;
    }(RecommendationResultViewCommon));
    RecommendationResultView.decorators = [
        { type: Component, args: [{
                    selector: 'recommendation-result-view',
                    template: "<mat-card>\n  <mat-card-title>{{title}}</mat-card-title>\n  <mat-card-content class=\"primary-content\">\n    <ul>\n      <li *ngFor=\"let statement of statements\"\n          class=\"bottleneck-statement\"\n          [style.color]=\"statement.color\"\n          [innerHtml]=\"statement.value\">\n      </li>\n    </ul>\n    <div class=\"bottleneck-tips\" *ngFor=\"let tipInfo of tipInfoArray\" [ngStyle]=\"tipInfo.style\">\n      <p>\n        <b>{{tipInfo.title}}</b>\n      </p>\n      <ul *ngIf=\"tipInfo.useClickCallback\">\n        <li *ngFor=\"let tip of tipInfo.tips\" (click)=\"onTipsClick($event)\" [innerHtml]=\"tip\"></li>\n      </ul>\n      <ul *ngIf=\"!tipInfo.useClickCallback\">\n        <li *ngFor=\"let tip of tipInfo.tips\" [innerHtml]=\"tip\"> </li>\n      </ul>\n    </div>\n  </mat-card-content>\n</mat-card>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}:host{border-bottom:1px solid #eee;border-right:1px solid #eee;flex-grow:1}:host:not(.dark-theme) mat-card{box-shadow:none !important;margin:8px}@media screen and (max-width: 1140px){:host:not(.dark-theme) mat-card{min-width:500px}}mat-card{height:calc(100% - 48px)}mat-card-title{background-color:#fff;border-top-left-radius:4px;border-top-right-radius:4px;color:#000;font-size:24px;font-weight:400}b{font-weight:500}ul{list-style-position:outside;margin-top:-16px;padding-inline-start:20px}.bottleneck-statement{margin:10px 0}.bottleneck-tips{margin:16px 0}.documentation-tips{margin:16px 0}:host.dark-theme{border:none}:host.dark-theme mat-card{margin:8px}@media screen and (max-width: 1140px){:host.dark-theme mat-card{min-width:500px}}:host.dark-theme mat-card-title{background-color:#3f51b5;color:#fff;padding:16px;margin:-16px -16px 16px}:host.dark-theme .bottleneck-statement{font-weight:bolder;font-style:italic}\n"]
                }] }
    ];
    /** @nocollapse */
    RecommendationResultView.ctorParameters = function () { return [
        { type: Store }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var RecommendationResultViewModule = /** @class */ (function () {
        function RecommendationResultViewModule() {
        }
        return RecommendationResultViewModule;
    }());
    RecommendationResultViewModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [RecommendationResultView],
                    imports: [
                        CommonModule,
                        MatCardModule,
                    ],
                    exports: [RecommendationResultView]
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A run environment view component.
     */
    var RunEnvironmentView = /** @class */ (function () {
        function RunEnvironmentView() {
            this.title = 'Run Environment';
            this.deviceCoreCount = '';
            this.deviceType = '';
            this.hostCount = '';
        }
        Object.defineProperty(RunEnvironmentView.prototype, "runEnvironment", {
            /**
             * The run environment data.
             * @param {?} data
             * @return {?}
             */
            set: function (data) {
                data = data || {};
                data.p = data.p || {};
                this.deviceCoreCount = data.p.device_core_count || '';
                this.deviceType = data.p.device_type || '';
                this.hostCount = data.p.host_count || '';
            },
            enumerable: true,
            configurable: true
        });
        return RunEnvironmentView;
    }());
    RunEnvironmentView.decorators = [
        { type: Component, args: [{
                    selector: 'run-environment-view',
                    template: "<mat-card>\n  <mat-card-title>{{title}}</mat-card-title>\n  <mat-card-content class=\"primary-content\">\n    <ng-content select=\"[profileDetail]\"></ng-content>\n    <p>\n      <span class=\"key-label\">Number of Hosts used</span>: <span>{{hostCount}}</span>\n    </p>\n    <ng-content select=\"[taskCount]\"></ng-content>\n    <p>\n      <span class=\"key-label\">Device type</span>: <span>{{deviceType}}</span>\n    </p>\n    <p>\n      <span class=\"key-label\">Number of device cores</span>: <span>{{deviceCoreCount}}</span>\n    </p>\n    <ng-content select=\"[jobInformation]\"></ng-content>\n    <p><!-- empty paragraph for bottom margin --></p>\n  </mat-card-content>\n</mat-card>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}:host{border-bottom:1px solid #eee;border-right:1px solid #eee;flex-grow:1}:host:not(.dark-theme) mat-card{box-shadow:none !important;margin:8px}@media screen and (max-width: 1140px){:host:not(.dark-theme) mat-card{min-width:500px}}mat-card{height:calc(100% - 48px)}mat-card-title{background-color:#fff;border-top-left-radius:4px;border-top-right-radius:4px;color:#000;font-size:24px;font-weight:400}b{font-weight:500}:host.dark-theme{border:none}:host.dark-theme mat-card{margin:8px}@media screen and (max-width: 1140px){:host.dark-theme mat-card{min-width:500px}}:host.dark-theme mat-card-title{background-color:#3f51b5;color:#fff;padding:16px;margin:-16px -16px 16px}:host.dark-theme .key-label{font-weight:500}\n"]
                }] }
    ];
    RunEnvironmentView.propDecorators = {
        runEnvironment: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var RunEnvironmentViewModule = /** @class */ (function () {
        function RunEnvironmentViewModule() {
        }
        return RunEnvironmentViewModule;
    }());
    RunEnvironmentViewModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [RunEnvironmentView],
                    imports: [MatCardModule],
                    exports: [RunEnvironmentView]
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var MAX_CHART_WIDTH$1 = 800;
    /** @type {?} */
    var COLUMN_IDS_FOR_TPU = [
        'stepnum',
        'computeTimeMs',
        'inputTimeMs',
        'idleTimeMs',
        'tooltip',
    ];
    /** @type {?} */
    var COLUMN_IDS_FOR_GPU = [
        'stepnum',
        'deviceComputeTimeMs',
        'deviceToDeviceTimeMs',
        'deviceCollectivesTimeMs',
        'hostComputeTimeMs',
        'kernelLaunchTimeMs',
        'infeedTimeMs',
        'outfeedTimeMs',
        'compileTimeMs',
        'otherTimeMs',
        'tooltip',
    ];
    /** @type {?} */
    var COLORS_FOR_TPU$1 = [
        'green',
        'crimson',
        'blue',
    ];
    /** @type {?} */
    var COLORS_FOR_GPU$1 = [
        '#9CCC65',
        '#FFEB3B',
        'pink',
        '#64B5F6',
        '#FF9800',
        '#B71C1C',
        'black',
        '#00695C',
        '#5E35B1',
    ];
    /**
     * A step-time graph view component.
     */
    var StepTimeGraph = /** @class */ (function () {
        function StepTimeGraph() {
            /**
             * The input pipeline analyis data.
             */
            this.inputPipelineAnalysis = null;
            /**
             * The default column ids.
             */
            this.columnIds = COLUMN_IDS_FOR_TPU;
            /**
             * The default column colors.
             */
            this.columnColors = COLORS_FOR_TPU$1;
            this.title = 'Step-time Graph';
            this.height = 300;
            this.width = 0;
            this.chart = null;
        }
        /**
         * @return {?}
         */
        StepTimeGraph.prototype.ngAfterViewInit = function () {
            this.loadGoogleChart();
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        StepTimeGraph.prototype.ngOnChanges = function (changes) {
            this.width = 0;
            this.drawChart();
        };
        /**
         * @return {?}
         */
        StepTimeGraph.prototype.onResize = function () {
            this.drawChart();
        };
        /**
         * @return {?}
         */
        StepTimeGraph.prototype.drawChart = function () {
            if (!this.chartRef) {
                return;
            }
            /** @type {?} */
            var newWidth = Math.min(MAX_CHART_WIDTH$1, this.chartRef.nativeElement.offsetWidth);
            if (!this.chart || !this.inputPipelineAnalysis || this.width === newWidth) {
                return;
            }
            this.width = newWidth;
            /** @type {?} */
            var dataTable = new google.visualization.DataTable(this.inputPipelineAnalysis);
            /** @type {?} */
            var columnsIds = this.columnIds;
            /** @type {?} */
            var colors = this.columnColors;
            this.height = 300;
            this.inputPipelineAnalysis.p = this.inputPipelineAnalysis.p || {};
            if ((this.inputPipelineAnalysis.p.hardware_type || 'TPU') !== 'TPU') {
                columnsIds = COLUMN_IDS_FOR_GPU;
                colors = COLORS_FOR_GPU$1;
                this.height = 400;
            }
            /** @type {?} */
            var i = 0;
            while (i < dataTable.getNumberOfColumns()) {
                if (!columnsIds.includes(dataTable.getColumnId(i))) {
                    dataTable.removeColumn(i);
                    continue;
                }
                i++;
            }
            /** @type {?} */
            var showTextEvery = Math.max(1, Math.floor(dataTable.getNumberOfRows() / 10));
            /** @type {?} */
            var options = {
                title: 'Step Time (in milliseconds)',
                titleTextStyle: { bold: true },
                hAxis: {
                    title: 'Step Number',
                    showTextEvery: showTextEvery,
                    textStyle: { bold: true },
                },
                vAxis: {
                    format: '###.####',
                    minValue: 0,
                    textStyle: { bold: true },
                },
                chartArea: { left: 50, width: '60%' },
                colors: colors,
                height: this.height,
                isStacked: true,
            };
            this.chart.draw(dataTable, options);
        };
        /**
         * @return {?}
         */
        StepTimeGraph.prototype.loadGoogleChart = function () {
            var _this = this;
            if (!google || !google.charts) {
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    _this.loadGoogleChart();
                }), 100);
            }
            google.charts.load('current', { 'packages': ['corechart'] });
            google.charts.setOnLoadCallback(( /**
             * @return {?}
             */function () {
                _this.chart =
                    new google.visualization.AreaChart(_this.chartRef.nativeElement);
                _this.drawChart();
            }));
        };
        return StepTimeGraph;
    }());
    StepTimeGraph.decorators = [
        { type: Component, args: [{
                    selector: 'step-time-graph',
                    template: "<mat-card>\n  <mat-card-title>{{title}}</mat-card-title>\n  <mat-card-content>\n    <div #chart class=\"chart\" [style.height]=\"height + 'px'\"></div>\n  </mat-card-content>\n</mat-card>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}:host{border-bottom:1px solid #eee;border-right:1px solid #eee}:host:not(.dark-theme) mat-card{box-shadow:none !important;margin:8px}@media screen and (max-width: 1140px){:host:not(.dark-theme) mat-card{min-width:500px}}mat-card{height:calc(100% - 48px)}mat-card-title{background-color:#fff;border-top-left-radius:4px;border-top-right-radius:4px;color:#000;font-size:24px;font-weight:400}.chart{margin:0 auto;max-width:800px}:host.dark-theme{border:none}:host.dark-theme mat-card{margin:8px}@media screen and (max-width: 1140px){:host.dark-theme mat-card{min-width:500px}}:host.dark-theme mat-card-title{background-color:#3f51b5;color:#fff;padding:16px;margin:-16px -16px 16px}\n"]
                }] }
    ];
    StepTimeGraph.propDecorators = {
        inputPipelineAnalysis: [{ type: Input }],
        columnIds: [{ type: Input }],
        columnColors: [{ type: Input }],
        chartRef: [{ type: ViewChild, args: ['chart', { static: false },] }],
        onResize: [{ type: HostListener, args: ['window:resize',] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var StepTimeGraphModule = /** @class */ (function () {
        function StepTimeGraphModule() {
        }
        return StepTimeGraphModule;
    }());
    StepTimeGraphModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [
                        StepTimeGraph
                    ],
                    imports: [
                        MatCardModule
                    ],
                    exports: [StepTimeGraph]
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var FLOP_RATE_COLUMN_INDEX = 4;
    /**
     * A top ops table view component.
     */
    var TopOpsTable = /** @class */ (function () {
        function TopOpsTable() {
            /**
             * The general anaysis data.
             */
            this.generalAnalysis = null;
            /**
             * The input pipeline analyis data.
             */
            this.inputPipelineAnalysis = null;
            /**
             * Whether the expansion panel is initially open.
             */
            this.initiallyExpanded = true;
            this.title = '';
            this.table = null;
        }
        /**
         * @return {?}
         */
        TopOpsTable.prototype.ngAfterViewInit = function () {
            this.loadGoogleChart();
        };
        /**
         * @return {?}
         */
        TopOpsTable.prototype.ngOnChanges = function () {
            this.drawTable();
        };
        /**
         * @return {?}
         */
        TopOpsTable.prototype.drawTable = function () {
            if (!this.table || !this.generalAnalysis || !this.inputPipelineAnalysis) {
                return;
            }
            /** @type {?} */
            var dataTable = new google.visualization.DataTable(this.generalAnalysis);
            if (dataTable.getNumberOfColumns() < 1 || dataTable.getNumberOfRows() < 1) {
                this.title = '';
                this.table = null;
                return;
            }
            this.inputPipelineAnalysis.p = this.inputPipelineAnalysis.p || {};
            this.title = 'Top ' + String(dataTable.getNumberOfRows()) +
                ' TensorFlow operations on ' +
                (this.inputPipelineAnalysis.p.hardware_type || 'TPU');
            /** @type {?} */
            var columns = {
                selfTimePercent: 0,
                cumulativeTimePercent: 0,
                category: 0,
                operation: 0,
                flopRate: 0,
                tcEligibility: 0,
                tcUtilization: 0,
            };
            for (var i_190 = 0; i_190 < dataTable.getNumberOfColumns(); i_190++) {
                switch (dataTable.getColumnId(i_190)) {
                    case 'selfTimePercent':
                        columns.selfTimePercent = i_190;
                        break;
                    case 'cumulativeTimePercent':
                        columns.cumulativeTimePercent = i_190;
                        break;
                    case 'category':
                        columns.category = i_190;
                        break;
                    case 'operation':
                        columns.operation = i_190;
                        break;
                    case 'flopRate':
                        columns.flopRate = i_190;
                        break;
                    case 'tcEligibility':
                        columns.tcEligibility = i_190;
                        break;
                    case 'tcUtilization':
                        columns.tcUtilization = i_190;
                        break;
                    default:
                        break;
                }
            }
            /** @type {?} */
            var percentFormatter = new google.visualization.NumberFormat({ 'pattern': '##.#%' });
            percentFormatter.format(dataTable, columns.selfTimePercent);
            percentFormatter.format(dataTable, columns.cumulativeTimePercent);
            /** @type {?} */
            var oneDecimalPtFormatter = new google.visualization.NumberFormat({ 'fractionDigits': 1 });
            oneDecimalPtFormatter.format(dataTable, columns.flopRate);
            dataTable.setProperty(0, columns.selfTimePercent, 'style', 'width: 10%');
            dataTable.setProperty(0, columns.cumulativeTimePercent, 'style', 'width: 10%');
            dataTable.setProperty(0, columns.category, 'style', 'width: 20%');
            dataTable.setProperty(0, columns.operation, 'style', 'width: 40%');
            dataTable.setProperty(0, columns.flopRate, 'style', 'display: 10%');
            dataTable.setProperty(0, columns.tcEligibility, 'style', 'display: 5%');
            dataTable.setProperty(0, columns.tcUtilization, 'style', 'display: 5%');
            /** @type {?} */
            var options = {
                alternatingRowStyle: false,
                showRowNumber: false,
                cssClassNames: {
                    'headerCell': 'google-chart-table-header-cell',
                    'tableCell': 'google-chart-table-table-cell',
                },
                width: '100%',
            };
            if ((this.inputPipelineAnalysis.p.hardware_type || 'TPU') !== 'TPU') {
                dataTable.removeColumn(FLOP_RATE_COLUMN_INDEX);
            }
            this.table.draw(dataTable, options);
        };
        /**
         * @return {?}
         */
        TopOpsTable.prototype.loadGoogleChart = function () {
            var _this = this;
            if (!google || !google.charts) {
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    _this.loadGoogleChart();
                }), 100);
            }
            google.charts.load('current', { 'packages': ['table'] });
            google.charts.setOnLoadCallback(( /**
             * @return {?}
             */function () {
                _this.table = new google.visualization.Table(_this.tableRef.nativeElement);
                _this.drawTable();
            }));
        };
        return TopOpsTable;
    }());
    TopOpsTable.decorators = [
        { type: Component, args: [{
                    selector: 'top-ops-table',
                    template: "<div [className]=\"title ? 'auto-height' : 'hidden-content'\">\n  <mat-expansion-panel [expanded]=\"initiallyExpanded\">\n    <mat-expansion-panel-header>\n      <mat-panel-title>{{title}}</mat-panel-title>\n    </mat-expansion-panel-header>\n    <div class=\"table\" #table></div>\n    <br>\n  </mat-expansion-panel>\n</div>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}:host:not(.dark-theme) mat-expansion-panel{box-shadow:none !important;margin:8px;margin:0}@media screen and (max-width: 1140px){:host:not(.dark-theme) mat-expansion-panel{min-width:500px}}mat-expansion-panel-header{margin:8px 8px 0}mat-panel-title{background-color:#fff;border-top-left-radius:4px;border-top-right-radius:4px;color:#000;font-size:24px;font-weight:400;background-color:transparent}mat-expansion-panel-header.cdk-keyboard-focused,mat-expansion-panel:not(.mat-expanded) mat-expansion-panel-header:hover{background-color:#eee !important}.mat-expanded mat-expansion-panel-header{border-bottom-left-radius:0;border-bottom-right-radius:0}:host.dark-theme{border:none}:host.dark-theme mat-expansion-panel{margin:8px}@media screen and (max-width: 1140px){:host.dark-theme mat-expansion-panel{min-width:500px}}:host.dark-theme mat-panel-title{background-color:transparent;color:#fff}:host.dark-theme mat-expansion-panel-header{background-color:#3f51b5;margin:0}:host.dark-theme mat-expansion-panel-header.cdk-keyboard-focused,:host.dark-theme mat-expansion-panel:not(.mat-expanded) mat-expansion-panel-header:hover{background-color:#7885cb !important}:host.dark-theme .table{margin-top:18px}\n"]
                }] }
    ];
    TopOpsTable.propDecorators = {
        generalAnalysis: [{ type: Input }],
        inputPipelineAnalysis: [{ type: Input }],
        initiallyExpanded: [{ type: Input }],
        tableRef: [{ type: ViewChild, args: ['table', { static: false },] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TopOpsTableModule = /** @class */ (function () {
        function TopOpsTableModule() {
        }
        return TopOpsTableModule;
    }());
    TopOpsTableModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [TopOpsTable],
                    imports: [MatExpansionModule],
                    exports: [TopOpsTable]
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * An overview page module.
     */
    var OverviewModule = /** @class */ (function () {
        function OverviewModule() {
        }
        return OverviewModule;
    }());
    OverviewModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [Overview],
                    imports: [
                        CommonModule,
                        DiagnosticsViewModule,
                        PerformanceSummaryModule,
                        RecommendationResultViewModule,
                        RunEnvironmentViewModule,
                        StepTimeGraphModule,
                        TopOpsTableModule,
                        NormalizedAcceleratorPerformanceViewModule,
                    ],
                    exports: [Overview]
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A common class of pod viewer component.
     */
    var PodViewerCommon = /** @class */ (function () {
        /**
         * @param {?} store
         */
        function PodViewerCommon(store) {
            this.store = store;
            this.data = null;
            this.minStep = 0;
            this.maxStep = 0;
            this.selectedStep = '';
            this.diagnostics = { info: [], warnings: [], errors: [] };
            this.stepBreakdownEvents = [];
            this.stepBreakdownChartDescription = '';
            this.deviceType = '';
            this.isTPU = false;
        }
        /**
         * @private
         * @return {?}
         */
        PodViewerCommon.prototype.updateSteps = function () {
            this.minStep = 0;
            this.maxStep = 0;
            if (!this.data || !this.data.podStatsSequence ||
                !this.data.podStatsSequence.podStatsMap) {
                this.updateSelectedStep(this.minStep);
                return;
            }
            /** @type {?} */
            var podStats = this.data.podStatsSequence.podStatsMap[0];
            if (!podStats) {
                this.updateSelectedStep(this.minStep);
                return;
            }
            this.minStep = podStats.stepNum || 0;
            this.maxStep = Math.max(this.minStep, this.minStep + this.data.podStatsSequence.podStatsMap.length - 1);
            this.updateSelectedStep(this.minStep);
        };
        /**
         * @param {?} step
         * @return {?}
         */
        PodViewerCommon.prototype.updateSelectedStep = function (step) {
            if (!this.data || !this.data.podStatsSequence ||
                !this.data.podStatsSequence.podStatsMap) {
                this.selectedStep = '';
                this.channelDb = undefined;
                this.podStatsPerCore = undefined;
                return;
            }
            /** @type {?} */
            var podStats = this.data.podStatsSequence.podStatsMap[step - this.minStep];
            if (!podStats) {
                this.selectedStep = '';
                this.channelDb = undefined;
                this.podStatsPerCore = undefined;
                return;
            }
            // Negative step number indicates incomplete step.
            this.selectedStep = (step >= 0) ? step.toString() : 'incomplete step';
            this.coreIdToReplicaIdMap = podStats.coreIdToReplicaIdMap || {};
            this.processAllReduceOpChart(podStats);
            this.processChannelDb(podStats);
            this.podStatsPerCore = podStats.podStatsPerCore;
            if (this.podStatsPerCore) {
                this.processStepBreakdownChart(this.podStatsPerCore);
            }
        };
        /**
         * @param {?} podStats
         * @return {?}
         */
        PodViewerCommon.prototype.processAllReduceOpChart = function (podStats) {
            this.allReduceOpDb =
                (podStats.allReduceOpDb || [])
                    .slice(0)
                    .sort(( /**
             * @param {?} a
             * @param {?} b
             * @return {?}
             */function (a, b) { return ((a.durationUs || 0) < (b.durationUs || 0)) ? 1 : -1; }));
            this.allReduceOpChartData = this.allReduceOpDb.map(( /**
             * @param {?} allReduceOpInfo
             * @return {?}
             */function (/**
             * @param {?} allReduceOpInfo
             * @return {?}
             */ allReduceOpInfo) {
                /** @type {?} */
                var name = allReduceOpInfo.name || '';
                name = name.replace(/ll-reduce.|usion.|ll-reduce|usion/, '');
                name = name.replace(/all-to-all.|all-to-all/, 'l');
                name = name.length > 1 ? name : name + '0';
                return [name, allReduceOpInfo.durationUs];
            }));
            this.allReduceOpChartData.unshift(['name', 'Duration (us)']);
        };
        /**
         * @param {?} podStats
         * @return {?}
         */
        PodViewerCommon.prototype.processChannelDb = function (podStats) {
            this.channelDb =
                (podStats.channelDb || [])
                    .sort(( /**
             * @param {?} a
             * @param {?} b
             * @return {?}
             */function (a, b) { return ((a.channelId || '0') > (b.channelId || '0')) ? 1 : -1; }));
            this.channelDbForChart =
                (podStats.channelDb || [])
                    .slice(0)
                    .sort(( /**
             * @param {?} a
             * @param {?} b
             * @return {?}
             */function (a, b) { return ((a.durationUs || 0) < (b.durationUs || 0)) ? 1 : -1; }));
            this.channelChartData = this.channelDbForChart.map(( /**
             * @param {?} channelInfo
             * @return {?}
             */function (/**
             * @param {?} channelInfo
             * @return {?}
             */ channelInfo) { return [channelInfo.channelId,
                channelInfo.durationUs,
            ]; }));
            this.channelChartData.unshift(['channelId', 'Duration (us)']);
        };
        // Convert PodStatsRecord to gviz data row.
        /**
         * @param {?} podStatsRecord
         * @return {?}
         */
        PodViewerCommon.prototype.parsePodStatsRecord = function (podStatsRecord) {
            var e_43, _b;
            /** @type {?} */
            var entry = [];
            if (this.isTPU) {
                entry.push('(' + (podStatsRecord.chipId || 0).toString() + ',' +
                    (podStatsRecord.nodeId || 0).toString() + ')');
            }
            else {
                entry.push(podStatsRecord.hostName || 'localhost');
            }
            try {
                for (var _c = __values(this.stepBreakdownEvents || []), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var event_3 = _d.value;
                    entry.push(getPodStatsRecordBreakdownProperty(podStatsRecord, event_3.id.toString()));
                }
            }
            catch (e_43_1) { e_43 = { error: e_43_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
                }
                finally { if (e_43) throw e_43.error; }
            }
            return entry;
        };
        /**
         * @param {?} podStatsPerCore
         * @return {?}
         */
        PodViewerCommon.prototype.processStepBreakdownChart = function (podStatsPerCore) {
            this.podStatsForChart = Object.values(podStatsPerCore || {})
                .map(( /**
         * @param {?} podStatsRecord
         * @return {?}
         */function (/**
         * @param {?} podStatsRecord
         * @return {?}
         */ podStatsRecord) { return podStatsRecord; }));
            if (this.isTPU) {
                this.podStatsForChart.sort(( /**
                 * @param {?} a
                 * @param {?} b
                 * @return {?}
                 */function (a, b) {
                    if (a.chipId === b.chipId) {
                        return ((a.nodeId || 0) > (b.nodeId || 0)) ? 1 : -1;
                    }
                    return ((a.chipId || 0) > (b.chipId || 0)) ? 1 : -1;
                }));
            }
            else {
                this.podStatsForChart.sort(( /**
                 * @param {?} a
                 * @param {?} b
                 * @return {?}
                 */function (a, b) {
                    return ((a.hostName || '') > (b.hostName || '')) ? 1 : -1;
                }));
            }
            this.podStatsChartData =
                this.podStatsForChart.map(this.parsePodStatsRecord, this);
            /** @type {?} */
            var metrics = this.stepBreakdownEvents.map(( /**
             * @param {?} event
             * @return {?}
             */function (/**
             * @param {?} event
             * @return {?}
             */ event) { return event.name; }));
            metrics.unshift('metrics');
            this.podStatsChartData.unshift(metrics);
        };
        /**
         * @param {?} allReduceOpIndex
         * @return {?}
         */
        PodViewerCommon.prototype.selectedAllReduceOpChart = function (allReduceOpIndex) {
            this.store.dispatch(setActivePodViewerInfoAction({
                activePodViewerInfo: this.allReduceOpDb ? this.allReduceOpDb[allReduceOpIndex] : null
            }));
        };
        /**
         * @param {?} channelDbIndex
         * @return {?}
         */
        PodViewerCommon.prototype.selectedChannelDb = function (channelDbIndex) {
            this.store.dispatch(setActivePodViewerInfoAction({
                activePodViewerInfo: this.channelDb ? this.channelDb[channelDbIndex] :
                    null
            }));
        };
        /**
         * @param {?} channelIndex
         * @return {?}
         */
        PodViewerCommon.prototype.selectedChannelChart = function (channelIndex) {
            this.store.dispatch(setActivePodViewerInfoAction({
                activePodViewerInfo: this.channelDbForChart ? this.channelDbForChart[channelIndex] : null
            }));
        };
        /**
         * @param {?} record
         * @return {?}
         */
        PodViewerCommon.prototype.convertRecordForDetailsCard = function (record) {
            var e_44, _b;
            /** @type {?} */
            var breakdown = {};
            if (!record.stepBreakdownUs)
                return record;
            if (!this.isTPU) {
                // Set an invalid chip id so that the details card only show hostname.
                record.chipId = -1;
            }
            try {
                for (var _c = __values(this.stepBreakdownEvents), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var event_4 = _d.value;
                    breakdown[event_4.name] = record.stepBreakdownUs[event_4.id] || 0;
                }
            }
            catch (e_44_1) { e_44 = { error: e_44_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
                }
                finally { if (e_44) throw e_44.error; }
            }
            return Object.assign({}, record, { stepBreakdownUs: breakdown });
        };
        /**
         * @param {?} podStatsIndex
         * @return {?}
         */
        PodViewerCommon.prototype.selectedPodStatsChart = function (podStatsIndex) {
            this.store.dispatch(setActivePodViewerInfoAction({
                activePodViewerInfo: this.podStatsForChart ?
                    this.convertRecordForDetailsCard(this.podStatsForChart[podStatsIndex]) :
                    null
            }));
        };
        /**
         * @param {?} data
         * @return {?}
         */
        PodViewerCommon.prototype.setDiagnostics = function (data) {
            if (!data || !data.diagnostics)
                return;
            this.diagnostics.info = data.diagnostics.info || [];
            this.diagnostics.warnings = data.diagnostics.warnings || [];
            this.diagnostics.errors = data.diagnostics.errors || [];
        };
        /**
         * @param {?} isTPU
         * @return {?}
         */
        PodViewerCommon.prototype.setStepBreakdownChartDescription = function (isTPU) {
            if (isTPU) {
                this.stepBreakdownChartDescription =
                    '(x-axis: global chip id, node id, y-axis: time(us))';
            }
            else {
                this.stepBreakdownChartDescription =
                    '(x-axis: hostname, y-axis: time(us))';
            }
        };
        /**
         * @param {?} data
         * @return {?}
         */
        PodViewerCommon.prototype.parseData = function (data) {
            this.data = data;
            this.deviceType = this.data ? this.data.deviceType || '' : '';
            this.isTPU = !this.deviceType.includes('GPU') && this.deviceType !== 'CPU';
            this.setDiagnostics(this.data);
            this.stepBreakdownEvents =
                this.data ? this.data.stepBreakdownEvents || [] : [];
            this.updateSteps();
            this.setStepBreakdownChartDescription(this.isTPU);
            this.topology = this.data ? this.data.topology : undefined;
        };
        return PodViewerCommon;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A pod viewer component.
     */
    var PodViewer = /** @class */ (function (_super) {
        __extends(PodViewer, _super);
        /**
         * @param {?} route
         * @param {?} dataService
         * @param {?} store
         */
        function PodViewer(route, dataService, store) {
            var _this = _super.call(this, store) || this;
            _this.dataService = dataService;
            _this.store = store;
            /**
             * Handles on-destroy Subject, used to unsubscribe.
             */
            _this.destroyed = new ReplaySubject(1);
            route.params.pipe(takeUntil(_this.destroyed)).subscribe(( /**
             * @param {?} params
             * @return {?}
             */function (params) {
                _this.update(( /** @type {?} */(params)));
            }));
            return _this;
        }
        /**
         * @param {?} event
         * @return {?}
         */
        PodViewer.prototype.update = function (event) {
            var _this = this;
            this.store.dispatch(setLoadingStateAction({
                loadingState: {
                    loading: true,
                    message: 'Loading data',
                }
            }));
            this.dataService
                .getData(event.run || '', event.tag || 'pod_viewer', event.host || '')
                .pipe(takeUntil(this.destroyed))
                .subscribe(( /**
         * @param {?} data
         * @return {?}
         */function (/**
         * @param {?} data
         * @return {?}
         */ data) {
                _this.store.dispatch(setLoadingStateAction({
                    loadingState: {
                        loading: false,
                        message: '',
                    }
                }));
                _this.parseData(( /** @type {?} */(data)));
            }));
        };
        /**
         * @return {?}
         */
        PodViewer.prototype.ngOnDestroy = function () {
            // Unsubscribes all pending subscriptions.
            this.destroyed.next();
            this.destroyed.complete();
        };
        return PodViewer;
    }(PodViewerCommon));
    PodViewer.decorators = [
        { type: Component, args: [{
                    selector: 'pod-viewer',
                    template: "<diagnostics-view [diagnostics]=\"diagnostics\"></diagnostics-view>\n<div class=\"section-container\">\n  <div class=\"mat-headline\">Pod Viewer</div>\n  <div class=\"control\">Selected step: {{selectedStep}}</div>\n  <div *ngIf=\"minStep != maxStep\">\n    <mat-slider\n                [min]=\"minStep\"\n                [max]=\"maxStep\"\n                [step]=\"1\"\n                (change)=\"updateSelectedStep($event.value)\">\n    </mat-slider>\n  </div>\n  <div *ngIf=\"topology\">\n    <topology-graph\n      [channelDb]=\"channelDb\"\n      [coreIdToReplicaIdMap]=\"coreIdToReplicaIdMap\"\n      [metricList]=\"stepBreakdownEvents\"\n      [podStatsPerCore]=\"podStatsPerCore\"\n      [topology]=\"topology\"\n      [deviceType]=\"deviceType\"\n      (selected)=\"selectedChannelDb($event)\">\n    </topology-graph>\n  </div>\n</div>\n\n<div *ngIf=\"channelDb && channelDb.length\">\n  <mat-divider></mat-divider>\n\n  <div class=\"section-container\">\n    <div class=\"chart-title\">Latency of Send and Recv channels</div>\n    <div class=\"description\">(x-axis: channel id, y-axis: time(us))</div>\n    <stack-bar-chart [data]=\"channelChartData\" (selected)=\"selectedChannelChart($event)\">\n    </stack-bar-chart>\n  </div>\n</div>\n\n<div *ngIf=\"allReduceOpDb && allReduceOpDb.length\">\n  <mat-divider></mat-divider>\n\n  <div class=\"section-container\">\n    <div class=\"chart-title\">Duration of all-reduce or all-to-all ops</div>\n    <div class=\"description\">\n      (x-axis: short names for all-reduces ops (a#) or fusion (f#) or all-to-all (l#),\n      y-axis: time(us))\n    </div>\n    <stack-bar-chart [data]=\"allReduceOpChartData\" (selected)=\"selectedAllReduceOpChart($event)\">\n    </stack-bar-chart>\n  </div>\n</div>\n\n<mat-divider></mat-divider>\n\n<div class=\"section-container\">\n  <div class=\"chart-title\">Step breakdown</div>\n  <div class=\"description\">{{stepBreakdownChartDescription}}</div>\n  <stack-bar-chart [data]=\"podStatsChartData\" (selected)=\"selectedPodStatsChart($event)\">\n  </stack-bar-chart>\n</div>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}:host{display:block}.section-container{padding:20px}mat-slider{width:200px}.chart-title{font-size:24px;padding-bottom:8px}.control{color:#5f6368}\n"]
                }] }
    ];
    /** @nocollapse */
    PodViewer.ctorParameters = function () { return [
        { type: ActivatedRoute },
        { type: DataService },
        { type: Store }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var BAR_WIDTH = 50;
    /** @type {?} */
    var DEFAULT_CHART_WIDTH = 500;
    /**
     * A stack bar chart view component.
     */
    var StackBarChart = /** @class */ (function () {
        function StackBarChart() {
            /**
             * The event when the selection of the chart is changed.
             */
            this.selected = new EventEmitter();
            this.chart = null;
            this.chartWidth = DEFAULT_CHART_WIDTH;
        }
        /**
         * @return {?}
         */
        StackBarChart.prototype.ngOnInit = function () {
            this.loadGoogleChart();
        };
        /**
         * @return {?}
         */
        StackBarChart.prototype.ngOnChanges = function () {
            this.drawChart();
        };
        /**
         * @return {?}
         */
        StackBarChart.prototype.drawChart = function () {
            if (!this.chart || !this.data) {
                return;
            }
            this.chartWidth =
                Math.max(DEFAULT_CHART_WIDTH, this.data.length * BAR_WIDTH);
            /** @type {?} */
            var dataTable = window.google.visualization.arrayToDataTable(this.data);
            /** @type {?} */
            var options = {
                backgroundColor: 'transparent',
                chartArea: {
                    left: 50,
                    right: 20,
                    top: 50,
                    bottom: 20,
                },
                focusTarget: 'category',
                isStacked: true,
                legend: {
                    position: 'top',
                    maxLines: 3,
                    textStyle: { fontSize: 12 },
                },
                hAxis: { textStyle: { fontSize: 12 } },
                vAxis: { textStyle: { fontSize: 12 } },
                orientation: 'horizontal',
                tooltip: { trigger: 'none' },
                width: this.chartWidth,
                colors: KELLY_COLORS,
            };
            this.chart.draw(dataTable, ( /** @type {?} */(options)));
        };
        /**
         * @return {?}
         */
        StackBarChart.prototype.loadGoogleChart = function () {
            var _this = this;
            if (!google || !google.charts) {
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    _this.loadGoogleChart();
                }), 100);
            }
            google.charts.load('current', { 'packages': ['corechart'] });
            google.charts.setOnLoadCallback(( /**
             * @return {?}
             */function () {
                _this.chart =
                    new google.visualization.BarChart(_this.chartRef.nativeElement);
                google.visualization.events.addListener(_this.chart, 'onmouseover', ( /**
                 * @param {?} event
                 * @return {?}
                 */function (event) {
                    event = event || {};
                    _this.selected.emit(event.row || 0);
                }));
                _this.drawChart();
            }));
        };
        return StackBarChart;
    }());
    StackBarChart.decorators = [
        { type: Component, args: [{
                    selector: 'stack-bar-chart',
                    template: "<div class=\"container\">\n  <div\n    class=\"chart\"\n    #chart\n    [style.width]=\"chartWidth + 'px'\">\n  </div>\n</div>\n",
                    styles: [":host{display:block;margin:20px 0}.container{width:100%;overflow-x:auto;overflow-y:hidden}.chart{height:300px}\n"]
                }] }
    ];
    StackBarChart.propDecorators = {
        data: [{ type: Input }],
        selected: [{ type: Output }],
        chartRef: [{ type: ViewChild, args: ['chart', { static: false },] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A stack bar chart view module.
     */
    var StackBarChartModule = /** @class */ (function () {
        function StackBarChartModule() {
        }
        return StackBarChartModule;
    }());
    StackBarChartModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [StackBarChart],
                    exports: [StackBarChart],
                },] }
    ];
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Animations used by the mat-menu component.
     * Animation duration and timing values are based on:
     * https://material.io/guidelines/components/menus.html#menus-usage
     * \@docs-private
     * @type {?}
     */
    var matMenuAnimations = {
        /**
         * This animation controls the menu panel's entry and exit from the page.
         *
         * When the menu panel is added to the DOM, it scales in and fades in its border.
         *
         * When the menu panel is removed from the DOM, it simply fades out after a brief
         * delay to display the ripple.
         */
        transformMenu: trigger('transformMenu', [
            state('void', style({
                opacity: 0,
                transform: 'scale(0.8)'
            })),
            transition('void => enter', group([
                query('.mat-menu-content, .mat-mdc-menu-content', animate('100ms linear', style({
                    opacity: 1
                }))),
                animate('120ms cubic-bezier(0, 0, 0.2, 1)', style({ transform: 'scale(1)' })),
            ])),
            transition('* => void', animate('100ms 25ms linear', style({ opacity: 0 })))
        ]),
        /**
         * This animation fades in the background color and content of the menu panel
         * after its containing element is scaled in.
         */
        fadeInItems: trigger('fadeInItems', [
            // TODO(crisbeto): this is inside the `transformMenu`
            // now. Remove next time we do breaking changes.
            state('showing', style({ opacity: 1 })),
            transition('void => *', [
                style({ opacity: 0 }),
                animate('400ms 100ms cubic-bezier(0.55, 0, 0.55, 0.2)')
            ])
        ])
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Menu content that will be rendered lazily once the menu is opened.
     */
    var MatMenuContent = /** @class */ (function () {
        /**
         * @param {?} _template
         * @param {?} _componentFactoryResolver
         * @param {?} _appRef
         * @param {?} _injector
         * @param {?} _viewContainerRef
         * @param {?} _document
         * @param {?=} _changeDetectorRef
         */
        function MatMenuContent(_template, _componentFactoryResolver, _appRef, _injector, _viewContainerRef, _document, _changeDetectorRef) {
            this._template = _template;
            this._componentFactoryResolver = _componentFactoryResolver;
            this._appRef = _appRef;
            this._injector = _injector;
            this._viewContainerRef = _viewContainerRef;
            this._document = _document;
            this._changeDetectorRef = _changeDetectorRef;
            /**
             * Emits when the menu content has been attached.
             */
            this._attached = new Subject();
        }
        /**
         * Attaches the content with a particular context.
         * \@docs-private
         * @param {?=} context
         * @return {?}
         */
        MatMenuContent.prototype.attach = function (context) {
            if (context === void 0) { context = {}; }
            if (!this._portal) {
                this._portal = new TemplatePortal(this._template, this._viewContainerRef);
            }
            this.detach();
            if (!this._outlet) {
                this._outlet = new DomPortalOutlet(this._document.createElement('div'), this._componentFactoryResolver, this._appRef, this._injector);
            }
            /** @type {?} */
            var element = this._template.elementRef.nativeElement;
            // Because we support opening the same menu from different triggers (which in turn have their
            // own `OverlayRef` panel), we have to re-insert the host element every time, otherwise we
            // risk it staying attached to a pane that's no longer in the DOM.
            ( /** @type {?} */(element.parentNode)).insertBefore(this._outlet.outletElement, element);
            // When `MatMenuContent` is used in an `OnPush` component, the insertion of the menu
            // content via `createEmbeddedView` does not cause the content to be seen as "dirty"
            // by Angular. This causes the `@ContentChildren` for menu items within the menu to
            // not be updated by Angular. By explicitly marking for check here, we tell Angular that
            // it needs to check for new menu items and update the `@ContentChild` in `MatMenu`.
            // @breaking-change 9.0.0 Make change detector ref required
            if (this._changeDetectorRef) {
                this._changeDetectorRef.markForCheck();
            }
            this._portal.attach(this._outlet, context);
            this._attached.next();
        };
        /**
         * Detaches the content.
         * \@docs-private
         * @return {?}
         */
        MatMenuContent.prototype.detach = function () {
            if (this._portal.isAttached) {
                this._portal.detach();
            }
        };
        /**
         * @return {?}
         */
        MatMenuContent.prototype.ngOnDestroy = function () {
            if (this._outlet) {
                this._outlet.dispose();
            }
        };
        return MatMenuContent;
    }());
    MatMenuContent.decorators = [
        { type: Directive, args: [{
                    selector: 'ng-template[matMenuContent]'
                },] },
    ];
    /** @nocollapse */
    MatMenuContent.ctorParameters = function () { return [
        { type: TemplateRef },
        { type: ComponentFactoryResolver },
        { type: ApplicationRef },
        { type: Injector },
        { type: ViewContainerRef },
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] },
        { type: ChangeDetectorRef }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Throws an exception for the case when menu trigger doesn't have a valid mat-menu instance
     * \@docs-private
     * @return {?}
     */
    function throwMatMenuMissingError() {
        throw Error("matMenuTriggerFor: must pass in an mat-menu instance.\n\n    Example:\n      <mat-menu #menu=\"matMenu\"></mat-menu>\n      <button [matMenuTriggerFor]=\"menu\"></button>");
    }
    /**
     * Throws an exception for the case when menu's x-position value isn't valid.
     * In other words, it doesn't match 'before' or 'after'.
     * \@docs-private
     * @return {?}
     */
    function throwMatMenuInvalidPositionX() {
        throw Error("xPosition value must be either 'before' or after'.\n      Example: <mat-menu xPosition=\"before\" #menu=\"matMenu\"></mat-menu>");
    }
    /**
     * Throws an exception for the case when menu's y-position value isn't valid.
     * In other words, it doesn't match 'above' or 'below'.
     * \@docs-private
     * @return {?}
     */
    function throwMatMenuInvalidPositionY() {
        throw Error("yPosition value must be either 'above' or below'.\n      Example: <mat-menu yPosition=\"above\" #menu=\"matMenu\"></mat-menu>");
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Injection token used to provide the parent menu to menu-specific components.
     * \@docs-private
     * @type {?}
     */
    var MAT_MENU_PANEL = new InjectionToken('MAT_MENU_PANEL');
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // Boilerplate for applying mixins to MatMenuItem.
    /**
     * \@docs-private
     */
    var MatMenuItemBase = /** @class */ (function () {
        function MatMenuItemBase() {
        }
        return MatMenuItemBase;
    }());
    /** @type {?} */
    var _MatMenuItemMixinBase = mixinDisableRipple(mixinDisabled(MatMenuItemBase));
    /**
     * This directive is intended to be used inside an mat-menu tag.
     * It exists mostly to set the role attribute.
     */
    var MatMenuItem = /** @class */ (function (_super) {
        __extends(MatMenuItem, _super);
        /**
         * @param {?} _elementRef
         * @param {?=} document
         * @param {?=} _focusMonitor
         * @param {?=} _parentMenu
         */
        function MatMenuItem(_elementRef, document, _focusMonitor, _parentMenu) {
            var _this = 
            // @breaking-change 8.0.0 make `_focusMonitor` and `document` required params.
            _super.call(this) || this;
            _this._elementRef = _elementRef;
            _this._focusMonitor = _focusMonitor;
            _this._parentMenu = _parentMenu;
            /**
             * ARIA role for the menu item.
             */
            _this.role = 'menuitem';
            /**
             * Stream that emits when the menu item is hovered.
             */
            _this._hovered = new Subject();
            /**
             * Whether the menu item is highlighted.
             */
            _this._highlighted = false;
            /**
             * Whether the menu item acts as a trigger for a sub-menu.
             */
            _this._triggersSubmenu = false;
            if (_focusMonitor) {
                // Start monitoring the element so it gets the appropriate focused classes. We want
                // to show the focus style for menu items only when the focus was not caused by a
                // mouse or touch interaction.
                _focusMonitor.monitor(_this._elementRef, false);
            }
            if (_parentMenu && _parentMenu.addItem) {
                _parentMenu.addItem(_this);
            }
            _this._document = document;
            return _this;
        }
        /**
         * Focuses the menu item.
         * @param {?=} origin
         * @param {?=} options
         * @return {?}
         */
        MatMenuItem.prototype.focus = function (origin, options) {
            if (origin === void 0) { origin = 'program'; }
            if (this._focusMonitor) {
                this._focusMonitor.focusVia(this._getHostElement(), origin, options);
            }
            else {
                this._getHostElement().focus(options);
            }
        };
        /**
         * @return {?}
         */
        MatMenuItem.prototype.ngOnDestroy = function () {
            if (this._focusMonitor) {
                this._focusMonitor.stopMonitoring(this._elementRef);
            }
            if (this._parentMenu && this._parentMenu.removeItem) {
                this._parentMenu.removeItem(this);
            }
            this._hovered.complete();
        };
        /**
         * Used to set the `tabindex`.
         * @return {?}
         */
        MatMenuItem.prototype._getTabIndex = function () {
            return this.disabled ? '-1' : '0';
        };
        /**
         * Returns the host DOM element.
         * @return {?}
         */
        MatMenuItem.prototype._getHostElement = function () {
            return this._elementRef.nativeElement;
        };
        /**
         * Prevents the default element actions if it is disabled.
         * @param {?} event
         * @return {?}
         */
        // We have to use a `HostListener` here in order to support both Ivy and ViewEngine.
        // In Ivy the `host` bindings will be merged when this class is extended, whereas in
        // ViewEngine they're overwritten.
        // TODO(crisbeto): we move this back into `host` once Ivy is turned on by default.
        // tslint:disable-next-line:no-host-decorator-in-concrete
        MatMenuItem.prototype._checkDisabled = function (event) {
            if (this.disabled) {
                event.preventDefault();
                event.stopPropagation();
            }
        };
        /**
         * Emits to the hover stream.
         * @return {?}
         */
        // We have to use a `HostListener` here in order to support both Ivy and ViewEngine.
        // In Ivy the `host` bindings will be merged when this class is extended, whereas in
        // ViewEngine they're overwritten.
        // TODO(crisbeto): we move this back into `host` once Ivy is turned on by default.
        // tslint:disable-next-line:no-host-decorator-in-concrete
        MatMenuItem.prototype._handleMouseEnter = function () {
            this._hovered.next(this);
        };
        /**
         * Gets the label to be used when determining whether the option should be focused.
         * @return {?}
         */
        MatMenuItem.prototype.getLabel = function () {
            /** @type {?} */
            var element = this._elementRef.nativeElement;
            /** @type {?} */
            var textNodeType = this._document ? this._document.TEXT_NODE : 3;
            /** @type {?} */
            var output = '';
            if (element.childNodes) {
                /** @type {?} */
                var length_1 = element.childNodes.length;
                // Go through all the top-level text nodes and extract their text.
                // We skip anything that's not a text node to prevent the text from
                // being thrown off by something like an icon.
                for (var i_191 = 0; i_191 < length_1; i_191++) {
                    if (element.childNodes[i_191].nodeType === textNodeType) {
                        output += element.childNodes[i_191].textContent;
                    }
                }
            }
            return output.trim();
        };
        return MatMenuItem;
    }(_MatMenuItemMixinBase));
    MatMenuItem.decorators = [
        { type: Component, args: [{ selector: '[mat-menu-item]',
                    exportAs: 'matMenuItem',
                    inputs: ['disabled', 'disableRipple'],
                    host: {
                        '[attr.role]': 'role',
                        'class': 'mat-menu-item',
                        '[class.mat-menu-item-highlighted]': '_highlighted',
                        '[class.mat-menu-item-submenu-trigger]': '_triggersSubmenu',
                        '[attr.tabindex]': '_getTabIndex()',
                        '[attr.aria-disabled]': 'disabled.toString()',
                        '[attr.disabled]': 'disabled || null',
                    },
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                    template: "<ng-content></ng-content><div class=\"mat-menu-ripple\" matRipple [matRippleDisabled]=\"disableRipple || disabled\" [matRippleTrigger]=\"_getHostElement()\"></div>",
                },] },
    ];
    /** @nocollapse */
    MatMenuItem.ctorParameters = function () { return [
        { type: ElementRef },
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] },
        { type: FocusMonitor },
        { type: undefined, decorators: [{ type: Inject, args: [MAT_MENU_PANEL,] }, { type: Optional }] }
    ]; };
    MatMenuItem.propDecorators = {
        role: [{ type: Input }],
        _checkDisabled: [{ type: HostListener, args: ['click', ['$event'],] }],
        _handleMouseEnter: [{ type: HostListener, args: ['mouseenter',] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Injection token to be used to override the default options for `mat-menu`.
     * @type {?}
     */
    var MAT_MENU_DEFAULT_OPTIONS = new InjectionToken('mat-menu-default-options', {
        providedIn: 'root',
        factory: MAT_MENU_DEFAULT_OPTIONS_FACTORY
    });
    /**
     * \@docs-private
     * @return {?}
     */
    function MAT_MENU_DEFAULT_OPTIONS_FACTORY() {
        return {
            overlapTrigger: false,
            xPosition: 'after',
            yPosition: 'below',
            backdropClass: 'cdk-overlay-transparent-backdrop',
        };
    }
    /**
     * Start elevation for the menu panel.
     * \@docs-private
     * @type {?}
     */
    var MAT_MENU_BASE_ELEVATION = 4;
    /**
     * Base class with all of the `MatMenu` functionality.
     */
    // tslint:disable-next-line:class-name
    var _MatMenuBase = /** @class */ (function () {
        /**
         * @param {?} _elementRef
         * @param {?} _ngZone
         * @param {?} _defaultOptions
         */
        function _MatMenuBase(_elementRef, _ngZone, _defaultOptions) {
            this._elementRef = _elementRef;
            this._ngZone = _ngZone;
            this._defaultOptions = _defaultOptions;
            this._xPosition = this._defaultOptions.xPosition;
            this._yPosition = this._defaultOptions.yPosition;
            /**
             * Only the direct descendant menu items.
             */
            this._directDescendantItems = new QueryList();
            /**
             * Subscription to tab events on the menu panel
             */
            this._tabSubscription = Subscription.EMPTY;
            /**
             * Config object to be passed into the menu's ngClass
             */
            this._classList = {};
            /**
             * Current state of the panel animation.
             */
            this._panelAnimationState = 'void';
            /**
             * Emits whenever an animation on the menu completes.
             */
            this._animationDone = new Subject();
            /**
             * Class to be added to the backdrop element.
             */
            this.backdropClass = this._defaultOptions.backdropClass;
            this._overlapTrigger = this._defaultOptions.overlapTrigger;
            this._hasBackdrop = this._defaultOptions.hasBackdrop;
            /**
             * Event emitted when the menu is closed.
             */
            this.closed = new EventEmitter();
            /**
             * Event emitted when the menu is closed.
             * @deprecated Switch to `closed` instead
             * \@breaking-change 8.0.0
             */
            this.close = this.closed;
        }
        Object.defineProperty(_MatMenuBase.prototype, "xPosition", {
            /**
             * Position of the menu in the X axis.
             * @return {?}
             */
            get: function () { return this._xPosition; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                if (value !== 'before' && value !== 'after') {
                    throwMatMenuInvalidPositionX();
                }
                this._xPosition = value;
                this.setPositionClasses();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(_MatMenuBase.prototype, "yPosition", {
            /**
             * Position of the menu in the Y axis.
             * @return {?}
             */
            get: function () { return this._yPosition; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                if (value !== 'above' && value !== 'below') {
                    throwMatMenuInvalidPositionY();
                }
                this._yPosition = value;
                this.setPositionClasses();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(_MatMenuBase.prototype, "overlapTrigger", {
            /**
             * Whether the menu should overlap its trigger.
             * @return {?}
             */
            get: function () { return this._overlapTrigger; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._overlapTrigger = coerceBooleanProperty(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(_MatMenuBase.prototype, "hasBackdrop", {
            /**
             * Whether the menu has a backdrop.
             * @return {?}
             */
            get: function () { return this._hasBackdrop; },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._hasBackdrop = coerceBooleanProperty(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(_MatMenuBase.prototype, "panelClass", {
            /**
             * This method takes classes set on the host mat-menu element and applies them on the
             * menu template that displays in the overlay container.  Otherwise, it's difficult
             * to style the containing menu from outside the component.
             * @param {?} classes list of class names
             * @return {?}
             */
            set: function (classes) {
                var _this = this;
                /** @type {?} */
                var previousPanelClass = this._previousPanelClass;
                if (previousPanelClass && previousPanelClass.length) {
                    previousPanelClass.split(' ').forEach(( /**
                     * @param {?} className
                     * @return {?}
                     */function (className) {
                        _this._classList[className] = false;
                    }));
                }
                this._previousPanelClass = classes;
                if (classes && classes.length) {
                    classes.split(' ').forEach(( /**
                     * @param {?} className
                     * @return {?}
                     */function (className) {
                        _this._classList[className] = true;
                    }));
                    this._elementRef.nativeElement.className = '';
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(_MatMenuBase.prototype, "classList", {
            /**
             * This method takes classes set on the host mat-menu element and applies them on the
             * menu template that displays in the overlay container.  Otherwise, it's difficult
             * to style the containing menu from outside the component.
             * @deprecated Use `panelClass` instead.
             * \@breaking-change 8.0.0
             * @return {?}
             */
            get: function () { return this.panelClass; },
            /**
             * @param {?} classes
             * @return {?}
             */
            set: function (classes) { this.panelClass = classes; },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        _MatMenuBase.prototype.ngOnInit = function () {
            this.setPositionClasses();
        };
        /**
         * @return {?}
         */
        _MatMenuBase.prototype.ngAfterContentInit = function () {
            var _this = this;
            this._updateDirectDescendants();
            this._keyManager = new FocusKeyManager(this._directDescendantItems).withWrap().withTypeAhead();
            this._tabSubscription = this._keyManager.tabOut.subscribe(( /**
             * @return {?}
             */function () { return _this.closed.emit('tab'); }));
        };
        /**
         * @return {?}
         */
        _MatMenuBase.prototype.ngOnDestroy = function () {
            this._directDescendantItems.destroy();
            this._tabSubscription.unsubscribe();
            this.closed.complete();
        };
        /**
         * Stream that emits whenever the hovered menu item changes.
         * @return {?}
         */
        _MatMenuBase.prototype._hovered = function () {
            // Coerce the `changes` property because Angular types it as `Observable<any>`
            /** @type {?} */
            var itemChanges = ( /** @type {?} */(this._directDescendantItems.changes));
            return itemChanges.pipe(startWith(this._directDescendantItems), switchMap(( /**
             * @param {?} items
             * @return {?}
             */function (/**
             * @param {?} items
             * @return {?}
             */ items) { return merge.apply(void 0, __spread(items.map(( /**
             * @param {?} item
             * @return {?}
             */function (item) { return item._hovered; })))); })));
        };
        /*
           * Registers a menu item with the menu.
           * @docs-private
           * @deprecated No longer being used. To be removed.
           * @breaking-change 9.0.0
           */
        /**
         * @param {?} _item
         * @return {?}
         */
        _MatMenuBase.prototype.addItem = function (_item) { };
        /**
         * Removes an item from the menu.
         * \@docs-private
         * @deprecated No longer being used. To be removed.
         * \@breaking-change 9.0.0
         * @param {?} _item
         * @return {?}
         */
        _MatMenuBase.prototype.removeItem = function (_item) { };
        /**
         * Handle a keyboard event from the menu, delegating to the appropriate action.
         * @param {?} event
         * @return {?}
         */
        _MatMenuBase.prototype._handleKeydown = function (event) {
            /** @type {?} */
            var keyCode = event.keyCode;
            /** @type {?} */
            var manager = this._keyManager;
            switch (keyCode) {
                case ESCAPE:
                    if (!hasModifierKey(event)) {
                        event.preventDefault();
                        this.closed.emit('keydown');
                    }
                    break;
                case LEFT_ARROW:
                    if (this.parentMenu && this.direction === 'ltr') {
                        this.closed.emit('keydown');
                    }
                    break;
                case RIGHT_ARROW:
                    if (this.parentMenu && this.direction === 'rtl') {
                        this.closed.emit('keydown');
                    }
                    break;
                case HOME:
                case END:
                    if (!hasModifierKey(event)) {
                        keyCode === HOME ? manager.setFirstItemActive() : manager.setLastItemActive();
                        event.preventDefault();
                    }
                    break;
                default:
                    if (keyCode === UP_ARROW || keyCode === DOWN_ARROW) {
                        manager.setFocusOrigin('keyboard');
                    }
                    manager.onKeydown(event);
            }
        };
        /**
         * Focus the first item in the menu.
         * @param {?=} origin Action from which the focus originated. Used to set the correct styling.
         * @return {?}
         */
        _MatMenuBase.prototype.focusFirstItem = function (origin) {
            if (origin === void 0) { origin = 'program'; }
            /** @type {?} */
            var manager = this._keyManager;
            // When the content is rendered lazily, it takes a bit before the items are inside the DOM.
            if (this.lazyContent) {
                this._ngZone.onStable.asObservable()
                    .pipe(take(1))
                    .subscribe(( /**
             * @return {?}
             */function () { return manager.setFocusOrigin(origin).setFirstItemActive(); }));
            }
            else {
                manager.setFocusOrigin(origin).setFirstItemActive();
            }
            // If there's no active item at this point, it means that all the items are disabled.
            // Move focus to the menu panel so keyboard events like Escape still work. Also this will
            // give _some_ feedback to screen readers.
            if (!manager.activeItem && this._directDescendantItems.length) {
                /** @type {?} */
                var element = this._directDescendantItems.first._getHostElement().parentElement;
                // Because the `mat-menu` is at the DOM insertion point, not inside the overlay, we don't
                // have a nice way of getting a hold of the menu panel. We can't use a `ViewChild` either
                // because the panel is inside an `ng-template`. We work around it by starting from one of
                // the items and walking up the DOM.
                while (element) {
                    if (element.getAttribute('role') === 'menu') {
                        element.focus();
                        break;
                    }
                    else {
                        element = element.parentElement;
                    }
                }
            }
        };
        /**
         * Resets the active item in the menu. This is used when the menu is opened, allowing
         * the user to start from the first option when pressing the down arrow.
         * @return {?}
         */
        _MatMenuBase.prototype.resetActiveItem = function () {
            this._keyManager.setActiveItem(-1);
        };
        /**
         * Sets the menu panel elevation.
         * @param {?} depth Number of parent menus that come before the menu.
         * @return {?}
         */
        _MatMenuBase.prototype.setElevation = function (depth) {
            // The elevation starts at the base and increases by one for each level.
            /** @type {?} */
            var newElevation = "mat-elevation-z" + (MAT_MENU_BASE_ELEVATION + depth);
            /** @type {?} */
            var customElevation = Object.keys(this._classList).find(( /**
             * @param {?} c
             * @return {?}
             */function (/**
             * @param {?} c
             * @return {?}
             */ c) { return c.startsWith('mat-elevation-z'); }));
            if (!customElevation || customElevation === this._previousElevation) {
                if (this._previousElevation) {
                    this._classList[this._previousElevation] = false;
                }
                this._classList[newElevation] = true;
                this._previousElevation = newElevation;
            }
        };
        /**
         * Adds classes to the menu panel based on its position. Can be used by
         * consumers to add specific styling based on the position.
         * \@docs-private
         * @param {?=} posX Position of the menu along the x axis.
         * @param {?=} posY Position of the menu along the y axis.
         * @return {?}
         */
        _MatMenuBase.prototype.setPositionClasses = function (posX, posY) {
            if (posX === void 0) { posX = this.xPosition; }
            if (posY === void 0) { posY = this.yPosition; }
            /** @type {?} */
            var classes = this._classList;
            classes['mat-menu-before'] = posX === 'before';
            classes['mat-menu-after'] = posX === 'after';
            classes['mat-menu-above'] = posY === 'above';
            classes['mat-menu-below'] = posY === 'below';
        };
        /**
         * Starts the enter animation.
         * @return {?}
         */
        _MatMenuBase.prototype._startAnimation = function () {
            // @breaking-change 8.0.0 Combine with _resetAnimation.
            this._panelAnimationState = 'enter';
        };
        /**
         * Resets the panel animation to its initial state.
         * @return {?}
         */
        _MatMenuBase.prototype._resetAnimation = function () {
            // @breaking-change 8.0.0 Combine with _startAnimation.
            this._panelAnimationState = 'void';
        };
        /**
         * Callback that is invoked when the panel animation completes.
         * @param {?} event
         * @return {?}
         */
        _MatMenuBase.prototype._onAnimationDone = function (event) {
            this._animationDone.next(event);
            this._isAnimating = false;
        };
        /**
         * @param {?} event
         * @return {?}
         */
        _MatMenuBase.prototype._onAnimationStart = function (event) {
            this._isAnimating = true;
            // Scroll the content element to the top as soon as the animation starts. This is necessary,
            // because we move focus to the first item while it's still being animated, which can throw
            // the browser off when it determines the scroll position. Alternatively we can move focus
            // when the animation is done, however moving focus asynchronously will interrupt screen
            // readers which are in the process of reading out the menu already. We take the `element`
            // from the `event` since we can't use a `ViewChild` to access the pane.
            if (event.toState === 'enter' && this._keyManager.activeItemIndex === 0) {
                event.element.scrollTop = 0;
            }
        };
        /**
         * Sets up a stream that will keep track of any newly-added menu items and will update the list
         * of direct descendants. We collect the descendants this way, because `_allItems` can include
         * items that are part of child menus, and using a custom way of registering items is unreliable
         * when it comes to maintaining the item order.
         * @private
         * @return {?}
         */
        _MatMenuBase.prototype._updateDirectDescendants = function () {
            var _this = this;
            this._allItems.changes
                .pipe(startWith(this._allItems))
                .subscribe(( /**
         * @param {?} items
         * @return {?}
         */function (items) {
                _this._directDescendantItems.reset(items.filter(( /**
                 * @param {?} item
                 * @return {?}
                 */function (/**
                 * @param {?} item
                 * @return {?}
                 */ item) { return item._parentMenu === _this; })));
                _this._directDescendantItems.notifyOnChanges();
            }));
        };
        return _MatMenuBase;
    }());
    /** @nocollapse */
    _MatMenuBase.ctorParameters = function () { return [
        { type: ElementRef },
        { type: NgZone },
        { type: undefined, decorators: [{ type: Inject, args: [MAT_MENU_DEFAULT_OPTIONS,] }] }
    ]; };
    _MatMenuBase.propDecorators = {
        _allItems: [{ type: ContentChildren, args: [MatMenuItem, { descendants: true },] }],
        backdropClass: [{ type: Input }],
        xPosition: [{ type: Input }],
        yPosition: [{ type: Input }],
        templateRef: [{ type: ViewChild, args: [TemplateRef, { static: false },] }],
        items: [{ type: ContentChildren, args: [MatMenuItem,] }],
        lazyContent: [{ type: ContentChild, args: [MatMenuContent, { static: false },] }],
        overlapTrigger: [{ type: Input }],
        hasBackdrop: [{ type: Input }],
        panelClass: [{ type: Input, args: ['class',] }],
        classList: [{ type: Input }],
        closed: [{ type: Output }],
        close: [{ type: Output }]
    };
    /**
     * \@docs-private We show the "_MatMenu" class as "MatMenu" in the docs.
     */
    var MatMenu = /** @class */ (function (_super) {
        __extends(MatMenu, _super);
        function MatMenu() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return MatMenu;
    }(_MatMenuBase));
    // Note on the weird inheritance setup: we need three classes, because the MDC-based menu has to
    // extend `MatMenu`, however keeping a reference to it will cause the inlined template and styles
    // to be retained as well. The MDC menu also has to provide itself as a `MatMenu` in order for
    // queries and DI to work correctly, while still not referencing the actual menu class.
    // Class responsibility is split up as follows:
    // * _MatMenuBase - provides all the functionality without any of the Angular metadata.
    // * MatMenu - keeps the same name symbol name as the current menu and
    // is used as a provider for DI and query purposes.
    // * _MatMenu - the actual menu component implementation with the Angular metadata that should
    // be tree shaken away for MDC.
    /**
     * \@docs-public MatMenu
     */
    // tslint:disable-next-line:class-name
    var _MatMenu = /** @class */ (function (_super) {
        __extends(_MatMenu, _super);
        /**
         * @param {?} elementRef
         * @param {?} ngZone
         * @param {?} defaultOptions
         */
        function _MatMenu(elementRef, ngZone, defaultOptions) {
            return _super.call(this, elementRef, ngZone, defaultOptions) || this;
        }
        return _MatMenu;
    }(MatMenu));
    _MatMenu.decorators = [
        { type: Component, args: [{ selector: 'mat-menu',
                    template: "<ng-template><div class=\"mat-menu-panel\" [ngClass]=\"_classList\" (keydown)=\"_handleKeydown($event)\" (click)=\"closed.emit('click')\" [@transformMenu]=\"_panelAnimationState\" (@transformMenu.start)=\"_onAnimationStart($event)\" (@transformMenu.done)=\"_onAnimationDone($event)\" tabindex=\"-1\" role=\"menu\"><div class=\"mat-menu-content\"><ng-content></ng-content></div></div></ng-template>",
                    styles: [".mat-menu-panel{min-width:112px;max-width:280px;overflow:auto;-webkit-overflow-scrolling:touch;max-height:calc(100vh - 48px);border-radius:4px;outline:0;min-height:64px}.mat-menu-panel.ng-animating{pointer-events:none}@media (-ms-high-contrast:active){.mat-menu-panel{outline:solid 1px}}.mat-menu-content:not(:empty){padding-top:8px;padding-bottom:8px}.mat-menu-item{-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:pointer;outline:0;border:none;-webkit-tap-highlight-color:transparent;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;display:block;line-height:48px;height:48px;padding:0 16px;text-align:left;text-decoration:none;max-width:100%;position:relative}.mat-menu-item::-moz-focus-inner{border:0}.mat-menu-item[disabled]{cursor:default}[dir=rtl] .mat-menu-item{text-align:right}.mat-menu-item .mat-icon{margin-right:16px;vertical-align:middle}.mat-menu-item .mat-icon svg{vertical-align:top}[dir=rtl] .mat-menu-item .mat-icon{margin-left:16px;margin-right:0}.mat-menu-item[disabled]{pointer-events:none}@media (-ms-high-contrast:active){.mat-menu-item-highlighted,.mat-menu-item.cdk-keyboard-focused,.mat-menu-item.cdk-program-focused{outline:dotted 1px}}.mat-menu-item-submenu-trigger{padding-right:32px}.mat-menu-item-submenu-trigger::after{width:0;height:0;border-style:solid;border-width:5px 0 5px 5px;border-color:transparent transparent transparent currentColor;content:'';display:inline-block;position:absolute;top:50%;right:16px;transform:translateY(-50%)}[dir=rtl] .mat-menu-item-submenu-trigger{padding-right:16px;padding-left:32px}[dir=rtl] .mat-menu-item-submenu-trigger::after{right:auto;left:16px;transform:rotateY(180deg) translateY(-50%)}button.mat-menu-item{width:100%}.mat-menu-item .mat-menu-ripple{top:0;left:0;right:0;bottom:0;position:absolute;pointer-events:none}"],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                    exportAs: 'matMenu',
                    animations: [
                        matMenuAnimations.transformMenu,
                        matMenuAnimations.fadeInItems
                    ],
                    providers: [
                        { provide: MAT_MENU_PANEL, useExisting: MatMenu },
                        { provide: MatMenu, useExisting: _MatMenu }
                    ]
                },] },
    ];
    /** @nocollapse */
    _MatMenu.ctorParameters = function () { return [
        { type: ElementRef },
        { type: NgZone },
        { type: undefined, decorators: [{ type: Inject, args: [MAT_MENU_DEFAULT_OPTIONS,] }] }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Injection token that determines the scroll handling while the menu is open.
     * @type {?}
     */
    var MAT_MENU_SCROLL_STRATEGY = new InjectionToken('mat-menu-scroll-strategy');
    /**
     * \@docs-private
     * @param {?} overlay
     * @return {?}
     */
    function MAT_MENU_SCROLL_STRATEGY_FACTORY(overlay) {
        return ( /**
         * @return {?}
         */function () { return overlay.scrollStrategies.reposition(); });
    }
    /**
     * \@docs-private
     * @type {?}
     */
    var MAT_MENU_SCROLL_STRATEGY_FACTORY_PROVIDER = {
        provide: MAT_MENU_SCROLL_STRATEGY,
        deps: [Overlay],
        useFactory: MAT_MENU_SCROLL_STRATEGY_FACTORY,
    };
    /**
     * Default top padding of the menu panel.
     * @type {?}
     */
    var MENU_PANEL_TOP_PADDING = 8;
    /**
     * Options for binding a passive event listener.
     * @type {?}
     */
    var passiveEventListenerOptions = normalizePassiveListenerOptions({ passive: true });
    // TODO(andrewseguin): Remove the kebab versions in favor of camelCased attribute selectors
    /**
     * This directive is intended to be used in conjunction with an mat-menu tag.  It is
     * responsible for toggling the display of the provided menu instance.
     */
    var MatMenuTrigger = /** @class */ (function () {
        /**
         * @param {?} _overlay
         * @param {?} _element
         * @param {?} _viewContainerRef
         * @param {?} scrollStrategy
         * @param {?} _parentMenu
         * @param {?} _menuItemInstance
         * @param {?} _dir
         * @param {?=} _focusMonitor
         */
        function MatMenuTrigger(_overlay, _element, _viewContainerRef, scrollStrategy, _parentMenu, _menuItemInstance, _dir, _focusMonitor) {
            var _this = this;
            this._overlay = _overlay;
            this._element = _element;
            this._viewContainerRef = _viewContainerRef;
            this._parentMenu = _parentMenu;
            this._menuItemInstance = _menuItemInstance;
            this._dir = _dir;
            this._focusMonitor = _focusMonitor;
            this._overlayRef = null;
            this._menuOpen = false;
            this._closingActionsSubscription = Subscription.EMPTY;
            this._hoverSubscription = Subscription.EMPTY;
            this._menuCloseSubscription = Subscription.EMPTY;
            /**
             * Handles touch start events on the trigger.
             * Needs to be an arrow function so we can easily use addEventListener and removeEventListener.
             */
            this._handleTouchStart = ( /**
             * @return {?}
             */function () { return _this._openedBy = 'touch'; });
            // Tracking input type is necessary so it's possible to only auto-focus
            // the first item of the list when the menu is opened via the keyboard
            this._openedBy = null;
            /**
             * Whether focus should be restored when the menu is closed.
             * Note that disabling this option can have accessibility implications
             * and it's up to you to manage focus, if you decide to turn it off.
             */
            this.restoreFocus = true;
            /**
             * Event emitted when the associated menu is opened.
             */
            this.menuOpened = new EventEmitter();
            /**
             * Event emitted when the associated menu is opened.
             * @deprecated Switch to `menuOpened` instead
             * \@breaking-change 8.0.0
             */
            // tslint:disable-next-line:no-output-on-prefix
            this.onMenuOpen = this.menuOpened;
            /**
             * Event emitted when the associated menu is closed.
             */
            this.menuClosed = new EventEmitter();
            /**
             * Event emitted when the associated menu is closed.
             * @deprecated Switch to `menuClosed` instead
             * \@breaking-change 8.0.0
             */
            // tslint:disable-next-line:no-output-on-prefix
            this.onMenuClose = this.menuClosed;
            _element.nativeElement.addEventListener('touchstart', this._handleTouchStart, passiveEventListenerOptions);
            if (_menuItemInstance) {
                _menuItemInstance._triggersSubmenu = this.triggersSubmenu();
            }
            this._scrollStrategy = scrollStrategy;
        }
        Object.defineProperty(MatMenuTrigger.prototype, "_deprecatedMatMenuTriggerFor", {
            /**
             * @deprecated
             * \@breaking-change 8.0.0
             * @return {?}
             */
            get: function () { return this.menu; },
            /**
             * @param {?} v
             * @return {?}
             */
            set: function (v) {
                this.menu = v;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatMenuTrigger.prototype, "menu", {
            /**
             * References the menu instance that the trigger is associated with.
             * @return {?}
             */
            get: function () { return this._menu; },
            /**
             * @param {?} menu
             * @return {?}
             */
            set: function (menu) {
                var _this = this;
                if (menu === this._menu) {
                    return;
                }
                this._menu = menu;
                this._menuCloseSubscription.unsubscribe();
                if (menu) {
                    this._menuCloseSubscription = menu.close.asObservable().subscribe(( /**
                     * @param {?} reason
                     * @return {?}
                     */function (/**
                     * @param {?} reason
                     * @return {?}
                     */ reason) {
                        _this._destroyMenu();
                        // If a click closed the menu, we should close the entire chain of nested menus.
                        if ((reason === 'click' || reason === 'tab') && _this._parentMenu) {
                            _this._parentMenu.closed.emit(reason);
                        }
                    }));
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        MatMenuTrigger.prototype.ngAfterContentInit = function () {
            this._checkMenu();
            this._handleHover();
        };
        /**
         * @return {?}
         */
        MatMenuTrigger.prototype.ngOnDestroy = function () {
            if (this._overlayRef) {
                this._overlayRef.dispose();
                this._overlayRef = null;
            }
            this._element.nativeElement.removeEventListener('touchstart', this._handleTouchStart, passiveEventListenerOptions);
            this._menuCloseSubscription.unsubscribe();
            this._closingActionsSubscription.unsubscribe();
            this._hoverSubscription.unsubscribe();
        };
        Object.defineProperty(MatMenuTrigger.prototype, "menuOpen", {
            /**
             * Whether the menu is open.
             * @return {?}
             */
            get: function () {
                return this._menuOpen;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatMenuTrigger.prototype, "dir", {
            /**
             * The text direction of the containing app.
             * @return {?}
             */
            get: function () {
                return this._dir && this._dir.value === 'rtl' ? 'rtl' : 'ltr';
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Whether the menu triggers a sub-menu or a top-level one.
         * @return {?}
         */
        MatMenuTrigger.prototype.triggersSubmenu = function () {
            return !!(this._menuItemInstance && this._parentMenu);
        };
        /**
         * Toggles the menu between the open and closed states.
         * @return {?}
         */
        MatMenuTrigger.prototype.toggleMenu = function () {
            return this._menuOpen ? this.closeMenu() : this.openMenu();
        };
        /**
         * Opens the menu.
         * @return {?}
         */
        MatMenuTrigger.prototype.openMenu = function () {
            var _this = this;
            if (this._menuOpen) {
                return;
            }
            this._checkMenu();
            /** @type {?} */
            var overlayRef = this._createOverlay();
            /** @type {?} */
            var overlayConfig = overlayRef.getConfig();
            this._setPosition(( /** @type {?} */(overlayConfig.positionStrategy)));
            overlayConfig.hasBackdrop = this.menu.hasBackdrop == null ? !this.triggersSubmenu() :
                this.menu.hasBackdrop;
            overlayRef.attach(this._getPortal());
            if (this.menu.lazyContent) {
                this.menu.lazyContent.attach(this.menuData);
            }
            this._closingActionsSubscription = this._menuClosingActions().subscribe(( /**
             * @return {?}
             */function () { return _this.closeMenu(); }));
            this._initMenu();
            if (this.menu instanceof MatMenu) {
                this.menu._startAnimation();
            }
        };
        /**
         * Closes the menu.
         * @return {?}
         */
        MatMenuTrigger.prototype.closeMenu = function () {
            this.menu.close.emit();
        };
        /**
         * Focuses the menu trigger.
         * @param {?=} origin Source of the menu trigger's focus.
         * @param {?=} options
         * @return {?}
         */
        MatMenuTrigger.prototype.focus = function (origin, options) {
            if (origin === void 0) { origin = 'program'; }
            if (this._focusMonitor) {
                this._focusMonitor.focusVia(this._element, origin, options);
            }
            else {
                this._element.nativeElement.focus(options);
            }
        };
        /**
         * Closes the menu and does the necessary cleanup.
         * @private
         * @return {?}
         */
        MatMenuTrigger.prototype._destroyMenu = function () {
            var _this = this;
            if (!this._overlayRef || !this.menuOpen) {
                return;
            }
            /** @type {?} */
            var menu = this.menu;
            this._closingActionsSubscription.unsubscribe();
            this._overlayRef.detach();
            if (menu instanceof MatMenu) {
                menu._resetAnimation();
                if (menu.lazyContent) {
                    // Wait for the exit animation to finish before detaching the content.
                    menu._animationDone
                        .pipe(filter(( /**
                 * @param {?} event
                 * @return {?}
                 */function (/**
                 * @param {?} event
                 * @return {?}
                 */ event) { return event.toState === 'void'; })), take(1), 
                    // Interrupt if the content got re-attached.
                    takeUntil(menu.lazyContent._attached))
                        .subscribe({
                        next: ( /**
                         * @return {?}
                         */function () { return ( /** @type {?} */(menu.lazyContent)).detach(); }),
                        // No matter whether the content got re-attached, reset the menu.
                        complete: ( /**
                         * @return {?}
                         */function () { return _this._setIsMenuOpen(false); })
                    });
                }
                else {
                    this._setIsMenuOpen(false);
                }
            }
            else {
                this._setIsMenuOpen(false);
                if (menu.lazyContent) {
                    menu.lazyContent.detach();
                }
            }
            this._restoreFocus();
        };
        /**
         * This method sets the menu state to open and focuses the first item if
         * the menu was opened via the keyboard.
         * @private
         * @return {?}
         */
        MatMenuTrigger.prototype._initMenu = function () {
            this.menu.parentMenu = this.triggersSubmenu() ? this._parentMenu : undefined;
            this.menu.direction = this.dir;
            this._setMenuElevation();
            this._setIsMenuOpen(true);
            this.menu.focusFirstItem(this._openedBy || 'program');
        };
        /**
         * Updates the menu elevation based on the amount of parent menus that it has.
         * @private
         * @return {?}
         */
        MatMenuTrigger.prototype._setMenuElevation = function () {
            if (this.menu.setElevation) {
                /** @type {?} */
                var depth = 0;
                /** @type {?} */
                var parentMenu = this.menu.parentMenu;
                while (parentMenu) {
                    depth++;
                    parentMenu = parentMenu.parentMenu;
                }
                this.menu.setElevation(depth);
            }
        };
        /**
         * Restores focus to the element that was focused before the menu was open.
         * @private
         * @return {?}
         */
        MatMenuTrigger.prototype._restoreFocus = function () {
            // We should reset focus if the user is navigating using a keyboard or
            // if we have a top-level trigger which might cause focus to be lost
            // when clicking on the backdrop.
            if (this.restoreFocus) {
                if (!this._openedBy) {
                    // Note that the focus style will show up both for `program` and
                    // `keyboard` so we don't have to specify which one it is.
                    this.focus();
                }
                else if (!this.triggersSubmenu()) {
                    this.focus(this._openedBy);
                }
            }
            this._openedBy = null;
        };
        // set state rather than toggle to support triggers sharing a menu
        /**
         * @private
         * @param {?} isOpen
         * @return {?}
         */
        MatMenuTrigger.prototype._setIsMenuOpen = function (isOpen) {
            this._menuOpen = isOpen;
            this._menuOpen ? this.menuOpened.emit() : this.menuClosed.emit();
            if (this.triggersSubmenu()) {
                this._menuItemInstance._highlighted = isOpen;
            }
        };
        /**
         * This method checks that a valid instance of MatMenu has been passed into
         * matMenuTriggerFor. If not, an exception is thrown.
         * @private
         * @return {?}
         */
        MatMenuTrigger.prototype._checkMenu = function () {
            if (!this.menu) {
                throwMatMenuMissingError();
            }
        };
        /**
         * This method creates the overlay from the provided menu's template and saves its
         * OverlayRef so that it can be attached to the DOM when openMenu is called.
         * @private
         * @return {?}
         */
        MatMenuTrigger.prototype._createOverlay = function () {
            if (!this._overlayRef) {
                /** @type {?} */
                var config_4 = this._getOverlayConfig();
                this._subscribeToPositions(( /** @type {?} */(config_4.positionStrategy)));
                this._overlayRef = this._overlay.create(config_4);
                // Consume the `keydownEvents` in order to prevent them from going to another overlay.
                // Ideally we'd also have our keyboard event logic in here, however doing so will
                // break anybody that may have implemented the `MatMenuPanel` themselves.
                this._overlayRef.keydownEvents().subscribe();
            }
            return this._overlayRef;
        };
        /**
         * This method builds the configuration object needed to create the overlay, the OverlayState.
         * @private
         * @return {?} OverlayConfig
         */
        MatMenuTrigger.prototype._getOverlayConfig = function () {
            return new OverlayConfig({
                positionStrategy: this._overlay.position()
                    .flexibleConnectedTo(this._element)
                    .withLockedPosition()
                    .withTransformOriginOn('.mat-menu-panel, .mat-mdc-menu-panel'),
                backdropClass: this.menu.backdropClass || 'cdk-overlay-transparent-backdrop',
                scrollStrategy: this._scrollStrategy(),
                direction: this._dir
            });
        };
        /**
         * Listens to changes in the position of the overlay and sets the correct classes
         * on the menu based on the new position. This ensures the animation origin is always
         * correct, even if a fallback position is used for the overlay.
         * @private
         * @param {?} position
         * @return {?}
         */
        MatMenuTrigger.prototype._subscribeToPositions = function (position) {
            var _this = this;
            if (this.menu.setPositionClasses) {
                position.positionChanges.subscribe(( /**
                 * @param {?} change
                 * @return {?}
                 */function (/**
                 * @param {?} change
                 * @return {?}
                 */ change) {
                    /** @type {?} */
                    var posX = change.connectionPair.overlayX === 'start' ? 'after' : 'before';
                    /** @type {?} */
                    var posY = change.connectionPair.overlayY === 'top' ? 'below' : 'above';
                    ( /** @type {?} */(_this.menu.setPositionClasses))(posX, posY);
                }));
            }
        };
        /**
         * Sets the appropriate positions on a position strategy
         * so the overlay connects with the trigger correctly.
         * @private
         * @param {?} positionStrategy Strategy whose position to update.
         * @return {?}
         */
        MatMenuTrigger.prototype._setPosition = function (positionStrategy) {
            var _b = __read(this.menu.xPosition === 'before' ? ['end', 'start'] : ['start', 'end'], 2), originX = _b[0], originFallbackX = _b[1];
            var _c = __read(this.menu.yPosition === 'above' ? ['bottom', 'top'] : ['top', 'bottom'], 2), overlayY = _c[0], overlayFallbackY = _c[1];
            var _d = __read([overlayY, overlayFallbackY], 2), originY = _d[0], originFallbackY = _d[1];
            var _e = __read([originX, originFallbackX], 2), overlayX = _e[0], overlayFallbackX = _e[1];
            /** @type {?} */
            var offsetY = 0;
            if (this.triggersSubmenu()) {
                // When the menu is a sub-menu, it should always align itself
                // to the edges of the trigger, instead of overlapping it.
                overlayFallbackX = originX = this.menu.xPosition === 'before' ? 'start' : 'end';
                originFallbackX = overlayX = originX === 'end' ? 'start' : 'end';
                offsetY = overlayY === 'bottom' ? MENU_PANEL_TOP_PADDING : -MENU_PANEL_TOP_PADDING;
            }
            else if (!this.menu.overlapTrigger) {
                originY = overlayY === 'top' ? 'bottom' : 'top';
                originFallbackY = overlayFallbackY === 'top' ? 'bottom' : 'top';
            }
            positionStrategy.withPositions([
                { originX: originX, originY: originY, overlayX: overlayX, overlayY: overlayY, offsetY: offsetY },
                { originX: originFallbackX, originY: originY, overlayX: overlayFallbackX, overlayY: overlayY, offsetY: offsetY },
                {
                    originX: originX,
                    originY: originFallbackY,
                    overlayX: overlayX,
                    overlayY: overlayFallbackY,
                    offsetY: -offsetY
                },
                {
                    originX: originFallbackX,
                    originY: originFallbackY,
                    overlayX: overlayFallbackX,
                    overlayY: overlayFallbackY,
                    offsetY: -offsetY
                }
            ]);
        };
        /**
         * Returns a stream that emits whenever an action that should close the menu occurs.
         * @private
         * @return {?}
         */
        MatMenuTrigger.prototype._menuClosingActions = function () {
            var _this = this;
            /** @type {?} */
            var backdrop = ( /** @type {?} */(this._overlayRef)).backdropClick();
            /** @type {?} */
            var detachments = ( /** @type {?} */(this._overlayRef)).detachments();
            /** @type {?} */
            var parentClose = this._parentMenu ? this._parentMenu.closed : of();
            /** @type {?} */
            var hover = this._parentMenu ? this._parentMenu._hovered().pipe(filter(( /**
             * @param {?} active
             * @return {?}
             */function (/**
             * @param {?} active
             * @return {?}
             */ active) { return active !== _this._menuItemInstance; })), filter(( /**
             * @return {?}
             */function () { return _this._menuOpen; }))) : of();
            return merge(backdrop, parentClose, hover, detachments);
        };
        /**
         * Handles mouse presses on the trigger.
         * @param {?} event
         * @return {?}
         */
        MatMenuTrigger.prototype._handleMousedown = function (event) {
            if (!isFakeMousedownFromScreenReader(event)) {
                // Since right or middle button clicks won't trigger the `click` event,
                // we shouldn't consider the menu as opened by mouse in those cases.
                this._openedBy = event.button === 0 ? 'mouse' : null;
                // Since clicking on the trigger won't close the menu if it opens a sub-menu,
                // we should prevent focus from moving onto it via click to avoid the
                // highlight from lingering on the menu item.
                if (this.triggersSubmenu()) {
                    event.preventDefault();
                }
            }
        };
        /**
         * Handles key presses on the trigger.
         * @param {?} event
         * @return {?}
         */
        MatMenuTrigger.prototype._handleKeydown = function (event) {
            /** @type {?} */
            var keyCode = event.keyCode;
            if (this.triggersSubmenu() && ((keyCode === RIGHT_ARROW && this.dir === 'ltr') ||
                (keyCode === LEFT_ARROW && this.dir === 'rtl'))) {
                this.openMenu();
            }
        };
        /**
         * Handles click events on the trigger.
         * @param {?} event
         * @return {?}
         */
        MatMenuTrigger.prototype._handleClick = function (event) {
            if (this.triggersSubmenu()) {
                // Stop event propagation to avoid closing the parent menu.
                event.stopPropagation();
                this.openMenu();
            }
            else {
                this.toggleMenu();
            }
        };
        /**
         * Handles the cases where the user hovers over the trigger.
         * @private
         * @return {?}
         */
        MatMenuTrigger.prototype._handleHover = function () {
            var _this = this;
            // Subscribe to changes in the hovered item in order to toggle the panel.
            if (!this.triggersSubmenu()) {
                return;
            }
            this._hoverSubscription = this._parentMenu._hovered()
                // Since we might have multiple competing triggers for the same menu (e.g. a sub-menu
                // with different data and triggers), we have to delay it by a tick to ensure that
                // it won't be closed immediately after it is opened.
                .pipe(filter(( /**
         * @param {?} active
         * @return {?}
         */function (/**
         * @param {?} active
         * @return {?}
         */ active) { return active === _this._menuItemInstance && !active.disabled; })), delay(0, asap))
                .subscribe(( /**
         * @return {?}
         */function () {
                _this._openedBy = 'mouse';
                // If the same menu is used between multiple triggers, it might still be animating
                // while the new trigger tries to re-open it. Wait for the animation to finish
                // before doing so. Also interrupt if the user moves to another item.
                if (_this.menu instanceof MatMenu && _this.menu._isAnimating) {
                    // We need the `delay(0)` here in order to avoid
                    // 'changed after checked' errors in some cases. See #12194.
                    _this.menu._animationDone
                        .pipe(take(1), delay(0, asap), takeUntil(_this._parentMenu._hovered()))
                        .subscribe(( /**
                 * @return {?}
                 */function () { return _this.openMenu(); }));
                }
                else {
                    _this.openMenu();
                }
            }));
        };
        /**
         * Gets the portal that should be attached to the overlay.
         * @private
         * @return {?}
         */
        MatMenuTrigger.prototype._getPortal = function () {
            // Note that we can avoid this check by keeping the portal on the menu panel.
            // While it would be cleaner, we'd have to introduce another required method on
            // `MatMenuPanel`, making it harder to consume.
            if (!this._portal || this._portal.templateRef !== this.menu.templateRef) {
                this._portal = new TemplatePortal(this.menu.templateRef, this._viewContainerRef);
            }
            return this._portal;
        };
        return MatMenuTrigger;
    }());
    MatMenuTrigger.decorators = [
        { type: Directive, args: [{
                    selector: "[mat-menu-trigger-for], [matMenuTriggerFor]",
                    host: {
                        'class': 'mat-menu-trigger',
                        'aria-haspopup': 'true',
                        '[attr.aria-expanded]': 'menuOpen || null',
                        '(mousedown)': '_handleMousedown($event)',
                        '(keydown)': '_handleKeydown($event)',
                        '(click)': '_handleClick($event)',
                    },
                    exportAs: 'matMenuTrigger'
                },] },
    ];
    /** @nocollapse */
    MatMenuTrigger.ctorParameters = function () { return [
        { type: Overlay },
        { type: ElementRef },
        { type: ViewContainerRef },
        { type: undefined, decorators: [{ type: Inject, args: [MAT_MENU_SCROLL_STRATEGY,] }] },
        { type: MatMenu, decorators: [{ type: Optional }] },
        { type: MatMenuItem, decorators: [{ type: Optional }, { type: Self }] },
        { type: Directionality, decorators: [{ type: Optional }] },
        { type: FocusMonitor }
    ]; };
    MatMenuTrigger.propDecorators = {
        _deprecatedMatMenuTriggerFor: [{ type: Input, args: ['mat-menu-trigger-for',] }],
        menu: [{ type: Input, args: ['matMenuTriggerFor',] }],
        menuData: [{ type: Input, args: ['matMenuTriggerData',] }],
        restoreFocus: [{ type: Input, args: ['matMenuTriggerRestoreFocus',] }],
        menuOpened: [{ type: Output }],
        onMenuOpen: [{ type: Output }],
        menuClosed: [{ type: Output }],
        onMenuClose: [{ type: Output }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Used by both the current `MatMenuModule` and the MDC `MatMenuModule`
     * to declare the menu-related directives.
     */
    // tslint:disable-next-line:class-name
    var _MatMenuDirectivesModule = /** @class */ (function () {
        function _MatMenuDirectivesModule() {
        }
        return _MatMenuDirectivesModule;
    }());
    _MatMenuDirectivesModule.decorators = [
        { type: NgModule, args: [{
                    exports: [MatMenuTrigger, MatMenuContent, MatCommonModule],
                    declarations: [MatMenuTrigger, MatMenuContent],
                    providers: [MAT_MENU_SCROLL_STRATEGY_FACTORY_PROVIDER]
                },] },
    ];
    var MatMenuModule = /** @class */ (function () {
        function MatMenuModule() {
        }
        return MatMenuModule;
    }());
    MatMenuModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        MatCommonModule,
                        MatRippleModule,
                        OverlayModule,
                        _MatMenuDirectivesModule,
                    ],
                    exports: [_MatMenu, MatMenuItem, _MatMenuDirectivesModule],
                    declarations: [_MatMenu, MatMenuItem],
                    providers: [MAT_MENU_SCROLL_STRATEGY_FACTORY_PROVIDER]
                },] },
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var BORDER_WIDTH = 1;
    /** @type {?} */
    var CONTAINER_MARGIN = 4;
    /** @type {?} */
    var CHIP_PADDING = 4;
    /** @type {?} */
    var HOST_MARGIN = 5;
    /** @type {?} */
    var HOST_PADDING = 5;
    /** @type {?} */
    var LABEL_HEIGHT = 14;
    /** @type {?} */
    var LABEL_PADDING = 5;
    /** @type {?} */
    var LABEL_WIDTH = 20;
    /** @type {?} */
    var NODE_HEIGHT = 30;
    /** @type {?} */
    var NODE_WIDTH = 15;
    /** @type {?} */
    var TOOLTIP_OFFSET_X = 20;
    /** @type {?} */
    var TOOLTIP_OFFSET_Y = 35;
    /** @type {?} */
    var NODE_COLORS = [
        '#ffffd9', '#edf8b1', '#c7e9b4', '#7fcdbb', '#41b6c4', '#1d91c0', '#225ea8',
        '#253494', '#081d58'
    ];
    /**
     * A topology graph view component.
     */
    var TopologyGraph = /** @class */ (function () {
        /**
         * @param {?} elRef
         * @param {?} store
         */
        function TopologyGraph(elRef, store) {
            var _this = this;
            this.elRef = elRef;
            this.store = store;
            /**
             * The metric list.
             */
            this.metricList = [];
            /**
             * The event when the selection of the channel is changed.
             */
            this.selected = new EventEmitter();
            /**
             * Handles on-destroy Subject, used to unsubscribe.
             */
            this.destroyed = new ReplaySubject(1);
            this.hosts = [];
            this.labels = [];
            this.nodes = [];
            this.colorInfos = [];
            this.channels = [];
            this.arrows = [];
            this.xDimension = 0;
            this.yDimension = 0;
            this.containerHeight = 0;
            this.containerWidth = 0;
            this.hostColumns = 0;
            this.hostRows = 0;
            this.hostHeight = 0;
            this.hostXStride = 1;
            this.hostYStride = 1;
            this.hostWidth = 0;
            this.nodesPerChip = 2;
            this.selectedMetric = 0;
            this.selectedMetricLabel = '';
            this.channelCount = 0;
            this.firstChannel = 0;
            this.lastChannel = 0;
            this.selectedChannelIndex = 0;
            this.selectedChannelId = 0;
            this.tooltipText = '';
            this.tooltipX = 0;
            this.tooltipY = 0;
            this.createColorInfos();
            this.store.select(getActivePodViewerInfoState)
                .pipe(takeUntil(this.destroyed))
                .subscribe(( /**
         * @param {?} info
         * @return {?}
         */function (info) {
                _this.updateReplicaGroupColoring(( /** @type {?} */(info)));
            }));
        }
        /**
         * @return {?}
         */
        TopologyGraph.prototype.ngOnChanges = function () {
            this.update();
        };
        /**
         * @private
         * @return {?}
         */
        TopologyGraph.prototype.createColorInfos = function () {
            /** @type {?} */
            var len = NODE_COLORS.length;
            this.colorInfos = NODE_COLORS.map(( /**
             * @param {?} color
             * @param {?} index
             * @return {?}
             */function (color, index) { return ({ color: color, label: (index / len).toFixed(1) }); }));
        };
        /**
         * @private
         * @param {?} value
         * @return {?}
         */
        TopologyGraph.prototype.getNodeColor = function (value) {
            /** @type {?} */
            var colorIndex = Math.floor((value || 0) * NODE_COLORS.length);
            colorIndex = Math.min(colorIndex, NODE_COLORS.length - 1);
            return NODE_COLORS[colorIndex];
        };
        /**
         * @private
         * @param {?} chipId
         * @param {?} nodeId
         * @return {?}
         */
        TopologyGraph.prototype.getNodePosition = function (chipId, nodeId) {
            /** @type {?} */
            var hostWidthWithPadding = HOST_PADDING + BORDER_WIDTH + this.hostWidth +
                BORDER_WIDTH + HOST_PADDING;
            /** @type {?} */
            var hostHeightWithPadding = HOST_PADDING + BORDER_WIDTH +
                this.hostHeight + BORDER_WIDTH + HOST_PADDING;
            /** @type {?} */
            var chipWidthWithPadding = CHIP_PADDING +
                (BORDER_WIDTH + NODE_WIDTH) * this.nodesPerChip + BORDER_WIDTH +
                CHIP_PADDING;
            /** @type {?} */
            var chipHeightWithPadding = CHIP_PADDING + BORDER_WIDTH + NODE_HEIGHT + BORDER_WIDTH + CHIP_PADDING;
            /** @type {?} */
            var x = CONTAINER_MARGIN + LABEL_PADDING + LABEL_WIDTH + LABEL_PADDING;
            /** @type {?} */
            var y = CONTAINER_MARGIN + LABEL_PADDING + LABEL_HEIGHT + LABEL_PADDING;
            x += hostWidthWithPadding *
                Math.floor((chipId % (this.hostColumns * this.hostXStride)) /
                    this.hostXStride);
            x += HOST_PADDING + BORDER_WIDTH + HOST_MARGIN;
            x += chipWidthWithPadding * (chipId % this.hostXStride);
            x += CHIP_PADDING + (BORDER_WIDTH + NODE_WIDTH) * nodeId;
            y += hostHeightWithPadding *
                Math.floor(Math.floor(chipId / (this.hostColumns * this.hostXStride)) /
                    this.hostYStride);
            y += HOST_PADDING + BORDER_WIDTH + HOST_MARGIN;
            y += chipHeightWithPadding *
                (Math.floor(chipId / (this.hostColumns * this.hostXStride)) %
                    this.hostYStride);
            y += CHIP_PADDING;
            return { x: x, y: y };
        };
        /**
         * @private
         * @param {?} srcX
         * @param {?} srcY
         * @param {?} dstX
         * @param {?} dstY
         * @return {?}
         */
        TopologyGraph.prototype.getNodeRotate = function (srcX, srcY, dstX, dstY) {
            /** @type {?} */
            var dx = dstX - srcX;
            /** @type {?} */
            var dy = dstY - srcY;
            return Math.atan2(dy, dx);
        };
        /**
         * @private
         * @param {?} srcX
         * @param {?} srcY
         * @param {?} dstX
         * @param {?} dstY
         * @return {?}
         */
        TopologyGraph.prototype.getNodeScale = function (srcX, srcY, dstX, dstY) {
            /** @type {?} */
            var dx = srcX - dstX;
            /** @type {?} */
            var dy = srcY - dstY;
            return Math.sqrt(dx * dx + dy * dy) / 100;
        };
        /**
         * @private
         * @return {?}
         */
        TopologyGraph.prototype.updateArrows = function () {
            this.arrows = [];
            if (!this.topology || !this.podStatsPerCore || !this.channelDb) {
                return;
            }
            /** @type {?} */
            var channelInfo = this.channelDb[this.selectedChannelIndex];
            if (!channelInfo || !channelInfo.srcCoreIds || !channelInfo.dstCoreIds) {
                return;
            }
            /** @type {?} */
            var len = Math.min(channelInfo.srcCoreIds.length, channelInfo.dstCoreIds.length);
            for (var i_192 = 0; i_192 < len; i_192++) {
                /** @type {?} */
                var srcId = channelInfo.srcCoreIds[i_192] || 0;
                /** @type {?} */
                var dstId = channelInfo.dstCoreIds[i_192] || 0;
                /** @type {?} */
                var srcNodeInfo = this.getNodePosition(Math.floor(srcId / 2), srcId & 1);
                /** @type {?} */
                var dstNodeInfo = this.getNodePosition(Math.floor(dstId / 2), dstId & 1);
                this.arrows.push({
                    x: dstNodeInfo.x + BORDER_WIDTH + (NODE_WIDTH / 2),
                    y: dstNodeInfo.y + BORDER_WIDTH + (NODE_HEIGHT / 2),
                    scale: this.getNodeScale(srcNodeInfo.x, srcNodeInfo.y, dstNodeInfo.x, dstNodeInfo.y),
                    rotate: this.getNodeRotate(srcNodeInfo.x, srcNodeInfo.y, dstNodeInfo.x, dstNodeInfo.y),
                });
            }
        };
        /**
         * @private
         * @return {?}
         */
        TopologyGraph.prototype.updateChannels = function () {
            if (!this.topology || !this.podStatsPerCore || !this.channelDb) {
                this.channelCount = 0;
                this.firstChannel = 0;
                this.lastChannel = 0;
                this.selectedChannelIndex = 0;
                this.selectedChannelId = 0;
                return;
            }
            this.channels =
                this.channelDb.map(( /**
                 * @param {?} channelInfo
                 * @return {?}
                 */function (/**
                 * @param {?} channelInfo
                 * @return {?}
                 */ channelInfo) { return Number(channelInfo.channelId || 0); }));
            this.channelCount = this.channelDb.length - 1;
            this.firstChannel = this.channels[0];
            this.lastChannel = this.channels[this.channelCount];
            this.selectedChannelIndex = 0;
            this.selectedChannelId = this.channels[0];
            this.updateArrows();
            this.selected.emit(0);
        };
        /**
         * @private
         * @return {?}
         */
        TopologyGraph.prototype.updateHosts = function () {
            this.hosts = [];
            if (!this.topology)
                return;
            /** @type {?} */
            var xOffset = CONTAINER_MARGIN + LABEL_PADDING + LABEL_WIDTH + LABEL_PADDING;
            /** @type {?} */
            var yOffset = CONTAINER_MARGIN + LABEL_PADDING + LABEL_HEIGHT + LABEL_PADDING;
            /** @type {?} */
            var hostWidthWithPadding = HOST_PADDING + BORDER_WIDTH + this.hostWidth +
                BORDER_WIDTH + HOST_PADDING;
            /** @type {?} */
            var hostHeightWithPadding = HOST_PADDING + BORDER_WIDTH +
                this.hostHeight + BORDER_WIDTH + HOST_PADDING;
            for (var i_193 = 0; i_193 < this.hostRows; i_193++) {
                for (var j_11 = 0; j_11 < this.hostColumns; j_11++) {
                    this.hosts.push({
                        x: xOffset + HOST_PADDING + (hostWidthWithPadding * j_11),
                        y: yOffset + HOST_PADDING + (hostHeightWithPadding * i_193),
                    });
                }
            }
        };
        /**
         * @private
         * @return {?}
         */
        TopologyGraph.prototype.updateLabels = function () {
            this.labels = [];
            if (!this.topology)
                return;
            /** @type {?} */
            var xOffset = CONTAINER_MARGIN + LABEL_PADDING + LABEL_WIDTH + LABEL_PADDING;
            /** @type {?} */
            var yOffset = CONTAINER_MARGIN + LABEL_PADDING + LABEL_HEIGHT / 2;
            for (var i_194 = 0; i_194 < this.xDimension; i_194++) {
                if (i_194 % this.hostXStride === 0) {
                    xOffset += HOST_PADDING + BORDER_WIDTH + HOST_MARGIN;
                }
                xOffset += CHIP_PADDING + BORDER_WIDTH + NODE_WIDTH;
                this.labels.push({
                    id: i_194.toString(),
                    x: xOffset,
                    y: yOffset,
                });
                xOffset += BORDER_WIDTH + NODE_WIDTH + BORDER_WIDTH + CHIP_PADDING;
                if (i_194 % this.hostXStride === this.hostXStride - 1) {
                    xOffset += HOST_MARGIN + BORDER_WIDTH + HOST_PADDING;
                }
            }
            xOffset = CONTAINER_MARGIN + LABEL_PADDING + LABEL_WIDTH / 2;
            yOffset = CONTAINER_MARGIN + LABEL_PADDING + LABEL_HEIGHT + LABEL_PADDING;
            for (var i_195 = 0; i_195 < this.yDimension; i_195++) {
                if (i_195 % this.hostYStride === 0) {
                    yOffset += HOST_PADDING + BORDER_WIDTH + HOST_MARGIN;
                }
                yOffset += CHIP_PADDING + BORDER_WIDTH + NODE_HEIGHT / 2;
                this.labels.push({
                    id: i_195.toString(),
                    x: xOffset,
                    y: yOffset,
                });
                yOffset += NODE_HEIGHT / 2 + BORDER_WIDTH + CHIP_PADDING;
                if (i_195 % this.hostYStride === this.hostYStride - 1) {
                    yOffset += HOST_MARGIN + BORDER_WIDTH + HOST_PADDING;
                }
            }
        };
        /**
         * @private
         * @return {?}
         */
        TopologyGraph.prototype.updateNodes = function () {
            var _this = this;
            this.nodes = [];
            if (!this.topology || !this.podStatsPerCore) {
                return;
            }
            Object.keys(this.podStatsPerCore).forEach(( /**
             * @param {?} coreId
             * @return {?}
             */function (/**
             * @param {?} coreId
             * @return {?}
             */ coreId) {
                /** @type {?} */
                var podStatsRecord = ( /** @type {?} */(_this.podStatsPerCore))[coreId];
                /** @type {?} */
                var chipId = podStatsRecord.chipId || 0;
                /** @type {?} */
                var nodeId = podStatsRecord.nodeId || 0;
                /** @type {?} */
                var nodeInfo = _this.getNodePosition(chipId, nodeId);
                nodeInfo.id = 'node-' + chipId.toString() + '-' + nodeId.toString();
                if (_this.coreIdToReplicaIdMap &&
                    _this.coreIdToReplicaIdMap[coreId] !== undefined) {
                    nodeInfo.rid = _this.coreIdToReplicaIdMap[coreId];
                }
                _this.nodes.push(nodeInfo);
            }));
        };
        /**
         * @private
         * @return {?}
         */
        TopologyGraph.prototype.updateSystemInfo = function () {
            if (!this.topology) {
                this.xDimension = 0;
                this.yDimension = 0;
                this.containerWidth = 0;
                this.containerHeight = 0;
                this.hostColumns = 0;
                this.hostRows = 0;
                this.hostWidth = 0;
                this.hostHeight = 0;
                return;
            }
            this.xDimension = this.topology.xDimension || 0;
            this.yDimension = this.topology.yDimension || 0;
            this.hostXStride = this.topology.hostXStride || 1;
            this.hostYStride = this.topology.hostYStride || 1;
            this.nodesPerChip = this.topology.numCoresPerChip || 1;
            /** @type {?} */
            var chipWidth = CHIP_PADDING +
                ((BORDER_WIDTH + NODE_WIDTH) * this.nodesPerChip) + BORDER_WIDTH +
                CHIP_PADDING;
            /** @type {?} */
            var chipHeight = CHIP_PADDING + BORDER_WIDTH + NODE_HEIGHT + BORDER_WIDTH + CHIP_PADDING;
            this.hostWidth = HOST_MARGIN + (chipWidth * this.hostXStride) + HOST_MARGIN;
            this.hostHeight =
                HOST_MARGIN + (chipHeight * this.hostYStride) + HOST_MARGIN;
            /** @type {?} */
            var hostWidthWithPadding = HOST_PADDING + BORDER_WIDTH + this.hostWidth +
                HOST_PADDING + BORDER_WIDTH;
            /** @type {?} */
            var hostHeightWithPadding = HOST_PADDING + BORDER_WIDTH +
                this.hostHeight + HOST_PADDING + BORDER_WIDTH;
            this.hostColumns = Math.floor(this.xDimension / this.hostXStride);
            if (this.xDimension % this.hostXStride !== 0) {
                this.hostColumns++;
            }
            this.containerWidth = CONTAINER_MARGIN + LABEL_PADDING + LABEL_WIDTH +
                LABEL_PADDING + (hostWidthWithPadding * this.hostColumns) +
                CONTAINER_MARGIN;
            this.hostRows = Math.floor(this.yDimension / this.hostYStride);
            if (this.yDimension % this.hostYStride !== 0) {
                this.hostRows++;
            }
            this.containerHeight = CONTAINER_MARGIN + LABEL_PADDING + LABEL_HEIGHT +
                LABEL_PADDING + (hostHeightWithPadding * this.hostRows) +
                CONTAINER_MARGIN;
        };
        /**
         * @return {?}
         */
        TopologyGraph.prototype.hideTooltip = function () {
            this.tooltipText = '';
        };
        /**
         * @param {?} key
         * @param {?} label
         * @return {?}
         */
        TopologyGraph.prototype.selectMetric = function (key, label) {
            var _this = this;
            if (!label) {
                this.selectedMetric = 0;
                this.selectedMetricLabel = 'Please select a metric';
                return;
            }
            this.selectedMetric = key;
            this.selectedMetricLabel = 'Color: ' + label;
            if (!this.podStatsPerCore) {
                return;
            }
            Object.values(this.podStatsPerCore).forEach(( /**
             * @param {?} podStatsRecord
             * @return {?}
             */function (/**
             * @param {?} podStatsRecord
             * @return {?}
             */ podStatsRecord) {
                /** @type {?} */
                var chipId = podStatsRecord.chipId || 0;
                /** @type {?} */
                var nodeId = podStatsRecord.nodeId || 0;
                /** @type {?} */
                var id = 'node-' + chipId.toString() + '-' + nodeId.toString();
                /** @type {?} */
                var nodeEl = _this.elRef.nativeElement.querySelector('#' + id);
                if (nodeEl) {
                    /** @type {?} */
                    var value = getPodStatsRecordBreakdownProperty(podStatsRecord, key.toString());
                    value = podStatsRecord.totalDurationUs ?
                        value / podStatsRecord.totalDurationUs :
                        0;
                    nodeEl.style.backgroundColor = _this.getNodeColor(value);
                }
            }));
        };
        /**
         * @param {?} id
         * @return {?}
         */
        TopologyGraph.prototype.showTooltip = function (id) {
            this.tooltipText = '';
            /** @type {?} */
            var podStatsRecord = null;
            /** @type {?} */
            var coreId = '';
            /** @type {?} */
            var found = Object.entries(this.podStatsPerCore || {}).find(( /**
             * @param {?} __0
             * @return {?}
             */function (_b) {
                var _c = __read(_b, 2), value = _c[1];
                /** @type {?} */
                var chipId = value.chipId || 0;
                /** @type {?} */
                var nodeId = value.nodeId || 0;
                return id === 'node-' + chipId.toString() + '-' + nodeId.toString();
            }));
            if (!found || found.length !== 2) {
                return;
            }
            coreId = found[0];
            podStatsRecord = found[1];
            if (!podStatsRecord) {
                return;
            }
            /** @type {?} */
            var chipId = podStatsRecord.chipId || 0;
            /** @type {?} */
            var nodeId = podStatsRecord.nodeId || 0;
            this.tooltipText += 'pos: (';
            this.tooltipText +=
                (chipId % (this.hostColumns * this.hostXStride)).toString();
            this.tooltipText += ',';
            this.tooltipText +=
                Math.floor(chipId / (this.hostColumns * this.hostXStride)).toString();
            this.tooltipText += ')\n';
            this.tooltipText += 'host: ' + (podStatsRecord.hostName || '') + '\n';
            this.tooltipText += 'chip id: ' + chipId.toString() + '\n';
            this.tooltipText += 'node id: ' + nodeId.toString() + '\n';
            if (this.coreIdToReplicaIdMap &&
                this.coreIdToReplicaIdMap[coreId] !== undefined) {
                this.tooltipText +=
                    'replica id: ' + this.coreIdToReplicaIdMap[coreId].toString() + '\n';
            }
            if (this.selectedMetric && this.selectedMetricLabel) {
                /** @type {?} */
                var value = getPodStatsRecordBreakdownProperty(podStatsRecord, this.selectedMetric.toString());
                this.tooltipText += this.selectedMetricLabel.replace('Color: ', '');
                this.tooltipText += ' spends ';
                this.tooltipText += value.toFixed(2);
                this.tooltipText += 'us in total, ';
                this.tooltipText += 'taking ';
                this.tooltipText += podStatsRecord.totalDurationUs ?
                    (100 * value / podStatsRecord.totalDurationUs).toFixed(2) :
                    '0.00';
                this.tooltipText += '% of a step.';
            }
            /** @type {?} */
            var nodeInfo = this.getNodePosition(chipId, nodeId);
            this.tooltipX = nodeInfo.x + TOOLTIP_OFFSET_X;
            this.tooltipY = nodeInfo.y + TOOLTIP_OFFSET_Y;
        };
        /**
         * @param {?} id
         * @return {?}
         */
        TopologyGraph.prototype.updateChannelId = function (id) {
            if (id < this.selectedChannelId) {
                /** @type {?} */
                var i_196 = this.selectedChannelIndex - 1;
                while (i_196 >= 0) {
                    if (this.channels[i_196] <= id) {
                        break;
                    }
                    i_196--;
                }
                this.updateChannelIndex(Math.max(0, i_196));
            }
            else if (id > this.selectedChannelId) {
                /** @type {?} */
                var i_197 = this.selectedChannelIndex + 1;
                while (i_197 <= this.channelCount) {
                    if (this.channels[i_197] >= id) {
                        break;
                    }
                    i_197++;
                }
                this.updateChannelIndex(Math.min(this.channelCount, i_197));
            }
        };
        /**
         * @param {?} index
         * @return {?}
         */
        TopologyGraph.prototype.updateChannelIndex = function (index) {
            this.selectedChannelIndex = index;
            this.selectedChannelId = this.channels[index];
            this.updateArrows();
            this.selected.emit(index || 0);
        };
        /**
         * @param {?} info
         * @return {?}
         */
        TopologyGraph.prototype.updateReplicaGroupColoring = function (info) {
            if (!info || !info.replicaGroups || !info.replicaGroups.length)
                return;
            var _loop_8 = function (i_198) {
                /** @type {?} */
                var group_1 = info.replicaGroups[i_198].replicaIds;
                if (!group_1)
                    return "continue";
                for (var j_12 = 0; j_12 < group_1.length; j_12++) {
                    /** @type {?} */
                    var groupEl = this_3.elRef.nativeElement.querySelectorAll('[rid="' + group_1[j_12] + '"]');
                    groupEl.forEach(( /**
                     * @param {?} el
                     * @return {?}
                     */function (el) {
                        el.style.backgroundColor = KELLY_COLORS[i_198 % 20];
                    }));
                }
            };
            var this_3 = this;
            // Colors the nodes within the same replica group to the same color.
            for (var i_198 = 0; i_198 < info.replicaGroups.length; i_198++) {
                _loop_8(i_198);
            }
            this.selectedMetric = 0;
        };
        /**
         * @return {?}
         */
        TopologyGraph.prototype.update = function () {
            this.updateSystemInfo();
            this.updateLabels();
            this.updateHosts();
            this.updateNodes();
            this.selectMetric(0, '');
            this.updateChannels();
        };
        /**
         * @return {?}
         */
        TopologyGraph.prototype.ngOnDestroy = function () {
            // Unsubscribes all pending subscriptions.
            this.destroyed.next();
            this.destroyed.complete();
        };
        return TopologyGraph;
    }());
    TopologyGraph.decorators = [
        { type: Component, args: [{
                    selector: 'topology-graph',
                    template: "<div>\n  <div class=\"mat-title\">\n    {{deviceType}} {{xDimension}}x{{yDimension}}\n  </div>\n  <div class=\"topology-header\">\n    <div class=\"control-row-left\">\n      <span class=\"selected-metric-label control\">{{selectedMetricLabel}}</span>\n      <button mat-icon-button [matMenuTriggerFor]=\"mecticMenu\" aria-label=\"Metric menu\">\n        <mat-icon>arrow_drop_down</mat-icon>\n      </button>\n      <mat-menu #mecticMenu=\"matMenu\">\n        <button\n          *ngFor=\"let metric of metricList\"\n          mat-menu-item\n          [ngClass]=\"{'selected-metric-item': selectedMetric === metric.id}\"\n          (click)=\"selectMetric(metric.id, metric.name)\">\n          {{metric.name}}\n        </button>\n      </mat-menu>\n    </div>\n    <div\n      class=\"control-row-left \"\n      [style.visibility]=\"channelDb && channelDb.length ? 'visible' : 'hidden'\">\n      <span class=\"control\">PLEASE SELECT A CHANNEL ID&nbsp;</span>\n      <mat-slider\n        [min]=\"0\"\n        [max]=\"channelCount\"\n        [step]=\"1\"\n        [value]=\"selectedChannelIndex\"\n        (change)=\"updateChannelIndex($event.value)\">\n      </mat-slider>\n      <mat-form-field class=\"channel-input\">\n        <input\n          matInput\n          type=\"number\"\n          [min]=\"firstChannel\"\n          [max]=\"lastChannel\"\n          [step]=\"1\"\n          [value]=\"selectedChannelId\"\n          (change)=\"updateChannelId($event.target.value)\" />\n      </mat-form-field>\n    </div>\n  </div>\n  <div\n    class=\"container\"\n    [style.width]=\"containerWidth + 'px'\"\n    [style.height]=\"containerHeight + 'px'\">\n    <div\n      *ngFor=\"let label of labels\"\n      class=\"label\"\n      [style.top]=\"label.y + 'px'\"\n      [style.left]=\"label.x + 'px'\">\n      <div class=\"title\">{{label.id}}</div>\n    </div>\n    <div\n      *ngFor=\"let host of hosts\"\n      class=\"host\"\n      [style.width]=\"hostWidth + 'px'\"\n      [style.height]=\"hostHeight + 'px'\"\n      [style.top]=\"host.y + 'px'\"\n      [style.left]=\"host.x + 'px'\">\n    </div>\n    <div\n      *ngFor=\"let node of nodes\"\n      class=\"node\"\n      [id]=\"node.id\"\n      [attr.rid]=\"node.rid\"\n      [style.top]=\"node.y + 'px'\"\n      [style.left]=\"node.x + 'px'\"\n      (mouseenter)=\"showTooltip(node.id)\"\n      (mouseleave)=\"hideTooltip()\">\n    </div>\n    <div\n      *ngFor=\"let arrow of arrows\"\n      class=\"arrow-container\"\n      [style.top]=\"arrow.y + 'px'\"\n      [style.left]=\"arrow.x + 'px'\">\n      <svg>\n        <g class=\"arrow\" [style.transform]=\"'rotate(' + arrow.rotate + 'rad)'\">\n          <polygon points=\"3,0 -6,-5 -6,5\" />\n          <polygon\n            points=\"0,-1.5 -100,-1.5, -100,1.5 0,1.5\"\n            [style.transform]=\"'scaleX(' + arrow.scale + ')'\"/>\n        </g>\n      </svg>\n    </div>\n    <div\n      class=\"node-tooltip mat-elevation-z2\"\n      [style.left]=\"tooltipX + 'px'\"\n      [style.top]=\"tooltipY + 'px'\"\n      [hidden]=\"!tooltipText\">\n      <pre>{{tooltipText}}</pre>\n    </div>\n  </div>\n\n  <div class=\"color-table\">\n    <div\n      *ngFor=\"let colorInfo of colorInfos\">\n      <div class=\"color-cell\" [style.backgroundColor]=\"colorInfo.color\"></div>\n      <div class=\"color-label\">\u2265 {{colorInfo.label}}</div>\n    </div>\n  </div>\n</div>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}:host{display:block;padding-top:20px}.topology-header{display:flex;flex-direction:row;margin-top:-32px}.control-row-left{display:flex;margin-right:32px;flex-flow:row nowrap;align-items:center;line-height:50px;text-align:bottom;justify-content:flex-start}.container{position:relative}.label{position:absolute;width:0;height:0}.label .title{position:absolute;top:-7px;left:-15px;font-size:14px;line-height:14px;width:30px;text-align:center}.host{position:absolute;border-radius:8px;border:1px solid #333;background-color:#eee}.node{position:absolute;border-radius:4px;border:1px solid #333;width:15px;height:30px;background-color:#1d91c0;transition:background-color 1s}.color-table{display:flex;flex-wrap:nowrap;padding:20px 20px 0}.color-cell{margin:0 22px;border:1px solid #333;width:15px;height:30px;border-radius:4px}.color-label{width:60px;margin:8px 0;text-align:center}.selected-metric-label{text-transform:uppercase;padding-right:8px}.selected-metric-item{font-weight:bold;background:rgba(0,0,0,.02)}.channel-input{width:70px}.arrow-container{position:absolute;pointer-events:none}.arrow-container svg{overflow:visible}.arrow{fill:red;transform-origin:0px 0px}.node-tooltip{position:absolute;background-color:#fff;padding:10px;border-radius:8px;width:200px;font-size:12px;line-height:20px;font-family:sans-serif;pointer-events:none}.node-tooltip>pre{margin:0;white-space:pre-wrap}.control{color:#5f6368}\n"]
                }] }
    ];
    /** @nocollapse */
    TopologyGraph.ctorParameters = function () { return [
        { type: ElementRef },
        { type: Store }
    ]; };
    TopologyGraph.propDecorators = {
        channelDb: [{ type: Input }],
        coreIdToReplicaIdMap: [{ type: Input }],
        metricList: [{ type: Input }],
        podStatsPerCore: [{ type: Input }],
        topology: [{ type: Input }],
        deviceType: [{ type: Input }],
        selected: [{ type: Output }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A topology graph view module.
     */
    var TopologyGraphModule = /** @class */ (function () {
        function TopologyGraphModule() {
        }
        return TopologyGraphModule;
    }());
    TopologyGraphModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [TopologyGraph],
                    imports: [
                        CommonModule,
                        MatButtonModule,
                        MatFormFieldModule,
                        MatIconModule,
                        MatInputModule,
                        MatMenuModule,
                        MatSliderModule,
                    ],
                    exports: [TopologyGraph]
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A pod viewer module.
     */
    var PodViewerModule = /** @class */ (function () {
        function PodViewerModule() {
        }
        return PodViewerModule;
    }());
    PodViewerModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [PodViewer],
                    imports: [
                        CommonModule,
                        DiagnosticsViewModule,
                        MatDividerModule,
                        MatSliderModule,
                        StackBarChartModule,
                        TopologyGraphModule,
                    ],
                    exports: [PodViewer]
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A buffer details view component.
     */
    var BufferDetails = /** @class */ (function () {
        /**
         * @param {?} store
         */
        function BufferDetails(store) {
            var _this = this;
            this.store = store;
            /**
             * Handles on-destroy Subject, used to unsubscribe.
             */
            this.destroyed = new ReplaySubject(1);
            this.heapObject = null;
            this.store.select(getActiveHeapObjectState)
                .pipe(takeUntil(this.destroyed))
                .subscribe(( /**
         * @param {?} heapObject
         * @return {?}
         */function (heapObject) {
                _this.update(heapObject);
            }));
        }
        /**
         * @param {?} heapObject
         * @return {?}
         */
        BufferDetails.prototype.update = function (heapObject) {
            this.heapObject = heapObject;
            if (!heapObject) {
                return;
            }
            /** @type {?} */
            var sizeMiB = heapObject.sizeMiB || 0;
            /** @type {?} */
            var unpaddedSizeMiB = heapObject.unpaddedSizeMiB || 0;
            this.instructionName = heapObject.instructionName;
            this.opcode = heapObject.opcode ? heapObject.opcode + ' operation' : '';
            this.size = sizeMiB.toFixed(2);
            this.shape = heapObject.shape;
            this.tfOpName = heapObject.tfOpName;
            this.groupName = heapObject.groupName;
            if (unpaddedSizeMiB) {
                this.unpaddedSize = unpaddedSizeMiB.toFixed(2);
                /** @type {?} */
                var utilization = unpaddedSizeMiB / sizeMiB;
                this.color = flameColor(utilization, 0.7);
                if (utilization < 1) {
                    this.expansion = (1 / utilization).toFixed(1);
                    this.padding = (sizeMiB - unpaddedSizeMiB).toFixed(2);
                }
                else {
                    this.expansion = '';
                    this.padding = '';
                }
            }
            else {
                this.unpaddedSize = '';
                this.padding = '';
                this.expansion = '';
                this.color = 'rgb(192,192,192)';
            }
        };
        /**
         * @return {?}
         */
        BufferDetails.prototype.ngOnDestroy = function () {
            // Unsubscribes all pending subscriptions.
            this.destroyed.next();
            this.destroyed.complete();
        };
        return BufferDetails;
    }());
    BufferDetails.decorators = [
        { type: Component, args: [{
                    selector: 'buffer-details',
                    template: "<div [hidden]=\"!heapObject\">\n  <mat-card>\n    <mat-card-content>\n      <div class=\"info-header\">\n        <div class=\"info-header-circle\" [style.background]=\"color\"></div>\n        <div class=\"info-header-content-container\">\n          <div class=\"info-header-content\">\n            <div class=\"info-header-title\">{{instructionName}}</div>\n            <div class=\"info-header-subheader\">{{opcode}}</div>\n          </div>\n        </div>\n      </div>\n      <div class=\"info-content\">\n        <div class=\"info\" [hidden]=\"!size\">\n          <div class=\"title\">Size: </div>\n          <div>{{size}} MiB</div>\n        </div>\n        <div class=\"info\" [hidden]=!unpaddedSize>\n          <div class=\"title\">Unpadded Size: </div>\n          <div>{{unpaddedSize}} MiB</div>\n        </div>\n        <div class=\"info\" [hidden]=\"!padding\">\n          <div class=\"title\">Extra memory due to padding: </div>\n          <div>{{padding}} MiB</div>\n        </div>\n        <div class=\"info\" [hidden]=\"!expansion\">\n          <div class=\"title\">Expansion: </div>\n          <div>\n            <span>{{expansion}}</span>\n            <span class=\"title\">X</span>\n          </div>\n        </div>\n        <div class=\"info\" [hidden]=\"!shape\">\n          <div class=\"title\">Shape (and minor-to-major order): </div>\n          <div>{{shape}}</div>\n        </div>\n        <div class=\"info\" [hidden]=\"!tfOpName\">\n          <div class=\"title\">Tf Op Name:: </div>\n          <div>{{tfOpName}}</div>\n        </div>\n        <div class=\"info\" [hidden]=\"!groupName\">\n          <div class=\"title\">Allocation Type: </div>\n          <div>{{groupName}}</div>\n        </div>\n      </div>\n    </mat-card-content>\n  </mat-card>\n</div>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}:host{display:block;margin-top:20px}mat-card{box-shadow:none !important;border-top:1px solid #eee;border-radius:0;padding:0}.info-header{padding:16px;display:flex}.info-header-circle{display:inline-block;width:40px;height:40px;border-radius:20px;margin:5px 10px 5px 0}.info-header-content-container{display:inline-block;width:260px;height:50px;position:relative}.info-header-content{position:absolute;top:50%;transform:translateY(-50%)}.info-header-title{font-size:20px;font-weight:500}.info-header-subheader{color:#4a4a4a;font-style:italic}.info-content{color:#4a4a4a;font-size:16px;padding:16px;word-break:break-word}.info{margin-bottom:16px}.title{font-weight:500;margin-bottom:4px}\n"]
                }] }
    ];
    /** @nocollapse */
    BufferDetails.ctorParameters = function () { return [
        { type: Store }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A buffer details view module.
     */
    var BufferDetailsModule = /** @class */ (function () {
        function BufferDetailsModule() {
        }
        return BufferDetailsModule;
    }());
    BufferDetailsModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [BufferDetails],
                    imports: [MatCardModule],
                    exports: [BufferDetails]
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * An op details view component.
     */
    var OpDetails = /** @class */ (function () {
        /**
         * @param {?} store
         */
        function OpDetails(store) {
            var _this = this;
            this.store = store;
            /**
             * Handles on-destroy Subject, used to unsubscribe.
             */
            this.destroyed = new ReplaySubject(1);
            this.color = '';
            this.name = '';
            this.subheader = '';
            this.flopsRate = '';
            this.flopsUtilization = '';
            this.flopsColor = '';
            this.memoryBandwidth = '';
            this.memoryBandwidthUtilization = '';
            this.bwColor = '';
            this.expression = '';
            this.provenance = '';
            this.fused = false;
            this.hasCategory = false;
            this.hasLayout = false;
            this.dimensions = [];
            this.store.select(getActiveOpProfileNodeState)
                .pipe(takeUntil(this.destroyed))
                .subscribe(( /**
         * @param {?} node
         * @return {?}
         */function (node) {
                _this.update(node);
            }));
        }
        /**
         * @param {?=} dimension
         * @return {?}
         */
        OpDetails.prototype.dimensionColor = function (dimension) {
            if (!dimension || !dimension.alignment) {
                return '';
            }
            /** @type {?} */
            var ratio = (dimension.size || 0) / dimension.alignment;
            // COlors should grade harshly: 50% in a dimension is already very bad.
            /** @type {?} */
            var harshCurve = ( /**
             * @param {?} x
             * @return {?}
             */function (x) { return 1 - Math.sqrt(1 - x); });
            return flameColor(ratio / Math.ceil(ratio), 1, 0.25, harshCurve);
        };
        /**
         * @param {?=} dimension
         * @return {?}
         */
        OpDetails.prototype.dimensionHint = function (dimension) {
            if (!dimension || !dimension.alignment) {
                return '';
            }
            /** @type {?} */
            var size = dimension.size || 0;
            /** @type {?} */
            var mul = Math.ceil(size / dimension.alignment);
            /** @type {?} */
            var mulSuffix = (mul === 1) ?
                '' :
                ': ' + mul.toString() + ' x ' + dimension.alignment.toString();
            if (size % dimension.alignment === 0) {
                return 'Exact fit' + mulSuffix;
            }
            return 'Pad to ' + (mul * dimension.alignment).toString() + mulSuffix;
        };
        /**
         * @private
         * @return {?}
         */
        OpDetails.prototype.getSubheader = function () {
            if (!this.node) {
                return '';
            }
            if (this.node.xla && this.node.xla.category) {
                return this.node.xla.category + ' operation';
            }
            if (this.node.category) {
                return 'Operation category';
            }
            return 'Unknown';
        };
        /**
         * @param {?} node
         * @return {?}
         */
        OpDetails.prototype.update = function (node) {
            this.node = node || undefined;
            if (!this.node) {
                return;
            }
            this.color =
                flameColor(flopsUtilization(this.node), 0.7, 1, Math.sqrt);
            this.name = this.node.name || '';
            this.subheader = this.getSubheader();
            if (hasFlopsUtilization(this.node)) {
                /** @type {?} */
                var flopsUtilization$1 = flopsUtilization(this.node);
                this.flopsUtilization = percent(flopsUtilization$1);
                this.flopsColor = flopsColor(flopsUtilization$1);
            }
            else {
                this.flopsUtilization = '';
            }
            /** @type {?} */
            var flopsRate$1 = flopsRate(this.node);
            // Flops rate shouldn't be higher than 1EFLOPS.
            if (isNaN(flopsRate$1) || flopsRate$1 > 1E18) {
                this.flopsRate = '';
            }
            else {
                this.flopsRate = humanReadableText(flopsRate$1, { si: true, dp: 2, suffix: 'FLOP/s' });
            }
            if (hasMemoryBandwidthUtilization(this.node)) {
                /** @type {?} */
                var utilization = memoryBandwidthUtilization(this.node);
                this.memoryBandwidthUtilization = percent(utilization);
                this.bwColor = bwColor(utilization);
            }
            else {
                this.memoryBandwidthUtilization = '';
            }
            /** @type {?} */
            var memoryBW = memoryBandwidth(this.node);
            // Memory bandwidth shouldn't be higher than 10TiB/s.
            if (isNaN(memoryBW) || memoryBW > 1E13) {
                this.memoryBandwidth = '';
            }
            else {
                this.memoryBandwidth =
                    humanReadableText(memoryBW, { si: true, dp: 2, suffix: 'B/s' });
            }
            if (this.node.xla && this.node.xla.expression) {
                this.expression = this.node.xla.expression;
            }
            else {
                this.expression = '';
            }
            if (this.node.xla && this.node.xla.provenance) {
                this.provenance = this.node.xla.provenance;
            }
            else {
                this.provenance = '';
            }
            this.fused = !!this.node.xla && !this.node.metrics;
            this.hasCategory = !!this.node.category;
            this.hasLayout = !!this.node.xla && !!this.node.xla.layout &&
                !!this.node.xla.layout.dimensions &&
                this.node.xla.layout.dimensions.length > 0;
            if (this.node.xla && this.node.xla.layout) {
                this.dimensions = this.node.xla.layout.dimensions || [];
            }
        };
        /**
         * @return {?}
         */
        OpDetails.prototype.ngOnDestroy = function () {
            // Unsubscribes all pending subscriptions.
            this.destroyed.next();
            this.destroyed.complete();
        };
        return OpDetails;
    }());
    OpDetails.decorators = [
        { type: Component, args: [{
                    selector: 'op-details',
                    template: "<div [hidden]=\"!node\">\n  <mat-card>\n    <mat-card-content>\n      <div class=\"info-header\">\n        <div class=\"info-header-circle\" [style.background]=\"color\"></div>\n        <div class=\"info-header-content-container\">\n          <div class=\"info-header-content\">\n            <div class=\"info-header-title\">{{name}}</div>\n            <div class=\"info-header-subheader\">{{subheader}}</div>\n          </div>\n        </div>\n      </div>\n      <div class=\"info-content\">\n        <div class=\"info\" [hidden]=\"!flopsUtilization\">\n          <div class=\"title\">FLOPS utilization:</div>\n          <div class=\"bar-container\">\n            <div\n              class=\"bar\"\n              [style.width]=\"flopsUtilization\"\n              [style.background-color]=\"flopsColor\">\n              &nbsp;{{flopsUtilization}}\n            </div>\n          </div>\n        </div>\n        <div class=\"info\" [hidden]=\"!memoryBandwidthUtilization\">\n          <div class=\"title\">Memory bandwidth utilization:</div>\n          <div class=\"bar-container\">\n            <div\n              class=\"bar\"\n              [style.width]=\"memoryBandwidthUtilization\"\n              [style.background-color]=\"bwColor\">\n              &nbsp;{{memoryBandwidthUtilization}}\n            </div>\n          </div>\n        </div>\n        <div class=\"info\" [hidden]=\"!flopsRate\">\n          <div class=\"title\">FLOP rate:</div>\n          <code class=\"expression\">{{flopsRate}}</code>\n        </div>\n        <div class=\"info\" [hidden]=\"!memoryBandwidth\">\n          <div class=\"title\">Memory bandwidth:</div>\n          <code class=\"expression\">{{memoryBandwidth}}</code>\n        </div>\n        <div class=\"info\" [hidden]=\"!expression\">\n          <div class=\"title\">XLA expression:</div>\n          <code class=\"expression\">{{expression}}</code>\n        </div>\n        <div class=\"info\" [hidden]=\"!provenance\">\n          <div class=\"title\">Long Op Name:</div>\n          <code class=\"expression\">{{provenance}}</code>\n        </div>\n        <div class=\"info\" [hidden]=\"!fused\">\n          <div class=\"unavailable\">\n            Performance information for individual fused operations is not available.\n          </div>\n        </div>\n        <div class=\"info\" [hidden]=\"!hasCategory\">\n          <div class=\"unavailable\">\n            Select items within this category for performace details.\n          </div>\n        </div>\n        <div class=\"info\" [hidden]=\"!hasLayout\">\n          <div class=\"title\">Layout:</div>\n          <div class=\"layout\" *ngFor=\"let dimension of dimensions; let i = index\">\n            <div>\n              <div class=\"size-x\">\n                <div [hidden]=\"!i\">x</div>\n              </div>\n            </div>\n            <div>\n              <span class=\"size\">{{dimension.size}}</span>\n              <span class=\"semantics\">{{dimension.semantics}}</span>\n              <span\n                    class=\"alignment\"\n                    [style.background-color]=\"dimensionColor(dimension)\">\n                {{dimensionHint(dimension)}}\n              </span>\n            </div>\n          </div>\n        </div>\n      </div>\n    </mat-card-content>\n  </mat-card>\n</div>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}:host{display:block;margin-top:20px}mat-card{box-shadow:none !important;border-top:1px solid #eee;border-radius:0;padding:0}.info-header{padding:16px;display:flex}.info-header-circle{display:inline-block;width:40px;height:40px;border-radius:20px;margin:5px 10px 5px 0}.info-header-content-container{display:inline-block;width:260px;height:50px;position:relative}.info-header-content{position:absolute;top:50%;transform:translateY(-50%)}.info-header-title{font-size:20px;font-weight:500}.info-header-subheader{color:#4a4a4a;font-style:italic}.info-content{color:#4a4a4a;font-size:16px;padding:16px}.info{margin-bottom:16px}.title{font-weight:500;margin-bottom:4px}.bar-container{background-color:#ccc;height:24px}.bar{height:24px;line-height:24px}.expression{display:block;word-wrap:break-word}.unavailable{font-style:italic;color:#666}.layout{display:table;width:100%;border-spacing:16px 5px;margin-left:-10px}.layout>*{display:table-row}.layout>*>*{display:table-cell}.size,.size-x{text-align:center;width:20%}.size-x{font-weight:bold;color:#888}.semantics{font-size:smaller;font-weight:bold;color:#48c;text-transform:uppercase;vertical-align:middle;width:30%}.alignment{position:absolute;padding:8px;margin-top:-8px;width:45%;box-sizing:border-box}\n"]
                }] }
    ];
    /** @nocollapse */
    OpDetails.ctorParameters = function () { return [
        { type: Store }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * An op details view module.
     */
    var OpDetailsModule = /** @class */ (function () {
        function OpDetailsModule() {
        }
        return OpDetailsModule;
    }());
    OpDetailsModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [OpDetails],
                    imports: [CommonModule, MatCardModule],
                    exports: [OpDetails]
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A pod viewer details view component.
     */
    var PodViewerDetails = /** @class */ (function () {
        /**
         * @param {?} store
         */
        function PodViewerDetails(store) {
            var _this = this;
            this.store = store;
            /**
             * Handles on-destroy Subject, used to unsubscribe.
             */
            this.destroyed = new ReplaySubject(1);
            this.name = '';
            this.details = [];
            this.hloNames = '';
            this.replicaGroups = '';
            this.description = '';
            this.store.select(getActivePodViewerInfoState)
                .pipe(takeUntil(this.destroyed))
                .subscribe(( /**
         * @param {?} info
         * @return {?}
         */function (info) {
                _this.update(info);
            }));
        }
        /**
         * @private
         * @param {?} info
         * @return {?}
         */
        PodViewerDetails.prototype.updateSizeAndLatency = function (info) {
            /** @type {?} */
            var dataSize = Number(info.dataSize || '0');
            /** @type {?} */
            var latency = Number(info.durationUs || '0');
            this.details.push({
                title: 'Data Transferred',
                value: bytesToMiB(dataSize).toFixed(2) + ' MiB',
            });
            this.details.push({
                title: 'Latency',
                value: latency.toFixed(2) + ' Us',
            });
            this.details.push({
                title: 'BW',
                value: (latency !== 0 ? dataSize / latency / 1073.74 : 0).toFixed(2) +
                    ' GiB/s',
            });
        };
        /**
         * @private
         * @param {?} info
         * @return {?}
         */
        PodViewerDetails.prototype.updateAllReduceOpInfo = function (info) {
            var _this = this;
            this.info = info;
            this.name = info.name || '';
            this.updateSizeAndLatency(info);
            (info.replicaGroups || []).forEach(( /**
             * @param {?} replicaGroup
             * @return {?}
             */function (/**
             * @param {?} replicaGroup
             * @return {?}
             */ replicaGroup) {
                if (replicaGroup.replicaIds && replicaGroup.replicaIds.length > 0) {
                    _this.replicaGroups += '{' + replicaGroup.replicaIds.join(',') + '} ';
                }
            }));
            this.description = info.description || '';
        };
        /**
         * @private
         * @param {?} info
         * @return {?}
         */
        PodViewerDetails.prototype.updateChannelInfo = function (info) {
            var _this = this;
            this.info = info;
            this.name = 'Channel # ' + (info.channelId || 0).toString();
            this.updateSizeAndLatency(info);
            this.details.push({
                title: 'Send Delay',
                value: bytesToMiB(Number(info.sendDelayUs || '0')).toFixed(2) + ' Us',
            });
            (info.hloNames || []).forEach(( /**
             * @param {?} hloName
             * @return {?}
             */function (/**
             * @param {?} hloName
             * @return {?}
             */ hloName) {
                if (hloName) {
                    _this.hloNames += '"' + hloName + '" ';
                }
            }));
            this.description = info.description || '';
        };
        /**
         * @private
         * @param {?} info
         * @return {?}
         */
        PodViewerDetails.prototype.updatePodStatsRecord = function (info) {
            var _this = this;
            this.info = info;
            if (info.chipId === -1) {
                this.name = 'Step breakdown of ' + (info.hostName || 'localhost');
            }
            else {
                this.name = 'Step breakdown of chip ' + (info.chipId || 0).toString();
                if (info.hostName) {
                    this.details.push({
                        title: 'Hostname',
                        value: info.hostName,
                    });
                }
            }
            /** @type {?} */
            var total = info.totalDurationUs || 0;
            if (!total || !info.stepBreakdownUs) {
                return;
            }
            Object.keys(info.stepBreakdownUs).forEach(( /**
             * @param {?} key
             * @return {?}
             */function (key) {
                /** @type {?} */
                var value = getPodStatsRecordBreakdownProperty(info, key);
                _this.details.push({
                    title: key,
                    value: value.toFixed(2) + ' Us (' + (value / total * 100).toFixed(2) +
                        '%)',
                });
            }));
        };
        /**
         * @param {?} info
         * @return {?}
         */
        PodViewerDetails.prototype.update = function (info) {
            this.details = [];
            this.hloNames = '';
            this.replicaGroups = '';
            if (!info) {
                this.info = undefined;
                return;
            }
            if (info.hasOwnProperty('channelId')) {
                this.updateChannelInfo(( /** @type {?} */(info)));
            }
            else if (info.hasOwnProperty('chipId')) {
                this.updatePodStatsRecord(( /** @type {?} */(info)));
            }
            else {
                this.updateAllReduceOpInfo(( /** @type {?} */(info)));
            }
        };
        /**
         * @return {?}
         */
        PodViewerDetails.prototype.ngOnDestroy = function () {
            // Unsubscribes all pending subscriptions.
            this.destroyed.next();
            this.destroyed.complete();
        };
        return PodViewerDetails;
    }());
    PodViewerDetails.decorators = [
        { type: Component, args: [{
                    selector: 'pod-viewer-details',
                    template: "<div [hidden]=\"!info\">\n  <mat-card>\n    <mat-card-content>\n      <div class=\"info-header\">{{name}}</div>\n      <div class=\"info-content\">\n        <div class=\"info\" *ngFor=\"let detail of details\">\n          <div class=\"title\">{{detail.title}}: </div>\n          <div>{{detail.value}}</div>\n        </div>\n        <div class=\"info scroll-x-auto\" [hidden]=\"!hloNames\">\n          <div class=\"title\">Hlo Names</div>\n          <code>{{hloNames}}</code>\n        </div>\n        <div class=\"info scroll-x-auto\" [hidden]=\"!replicaGroups\">\n          <div class=\"title\">Replica Groups</div>\n          <code>{{replicaGroups}}</code>\n        </div>\n        <div class=\"info scroll-x-auto\" [hidden]=\"!description\">\n          <div class=\"title\">Description</div>\n          <code>{{description}}</code>\n        </div>\n      </div>\n    </mat-card-content>\n  </mat-card>\n</div>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}:host{display:block;margin-top:20px}mat-card{box-shadow:none !important;border-top:1px solid #eee;border-radius:0;padding:0}.info-header{padding:16px;font-size:20px;font-weight:500}.info-content{color:#4a4a4a;padding:16px}.info{margin-bottom:16px}.title{font-weight:500;margin-bottom:4px}.scroll-x-auto{overflow-x:auto}code{font-weight:normal}\n"]
                }] }
    ];
    /** @nocollapse */
    PodViewerDetails.ctorParameters = function () { return [
        { type: Store }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A pod viewer details view module.
     */
    var PodViewerDetailsModule = /** @class */ (function () {
        function PodViewerDetailsModule() {
        }
        return PodViewerDetailsModule;
    }());
    PodViewerDetailsModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [PodViewerDetails],
                    imports: [
                        CommonModule,
                        MatCardModule,
                    ],
                    exports: [PodViewerDetails]
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A side navigation component.
     */
    var SideNav = /** @class */ (function () {
        /**
         * @param {?} dataService
         * @param {?} store
         */
        function SideNav(dataService, store) {
            var _this = this;
            this.dataService = dataService;
            this.store = store;
            /**
             * Navigation Update Event
             */
            this.update = new EventEmitter();
            /**
             * Handles on-destroy Subject, used to unsubscribe.
             */
            this.destroyed = new ReplaySubject(1);
            this.tools = [];
            this.runs = [];
            this.tags = [];
            this.hosts = [];
            this.selectedRun = '';
            this.selectedTag = '';
            this.selectedHost = '';
            store.select(getCurrentTool)
                .pipe(takeUntil(this.destroyed))
                .subscribe(( /**
         * @param {?} currentTool
         * @return {?}
         */function (currentTool) {
                _this.updateTags(currentTool);
            }));
        }
        Object.defineProperty(SideNav.prototype, "datasets", {
            /**
             * The tool datasets.
             * @param {?} tools
             * @return {?}
             */
            set: function (tools) {
                if (tools && tools.length > 0) {
                    this.tools = tools;
                    this.runs = tools.map(( /**
                     * @param {?} tool
                     * @return {?}
                     */function (/**
                     * @param {?} tool
                     * @return {?}
                     */ tool) { return tool.name; }));
                    this.selectedRun = tools[0].name;
                    this.updateTags();
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} tag
         * @return {?}
         */
        SideNav.prototype.getDisplayTagName = function (tag) {
            return (tag && tag.length &&
                (tag[tag.length - 1] === '@' || tag[tag.length - 1] === '#' ||
                    tag[tag.length - 1] === '^')) ?
                tag.slice(0, -1) :
                tag || '';
        };
        /**
         * @param {?=} targetTag
         * @return {?}
         */
        SideNav.prototype.updateTags = function (targetTag) {
            var _this = this;
            if (targetTag === void 0) { targetTag = ''; }
            this.store.dispatch(setLoadingStateAction({
                loadingState: {
                    loading: true,
                    message: 'Loading data',
                }
            }));
            /** @type {?} */
            var tool = this.tools.find(( /**
             * @param {?} tool
             * @return {?}
             */function (/**
             * @param {?} tool
             * @return {?}
             */ tool) { return tool.name === _this.selectedRun; }));
            if (tool && tool.activeTools && tool.activeTools.length > 0) {
                this.tags = tool.activeTools;
                this.selectedTag =
                    this.tags.find(( /**
                     * @param {?} tag
                     * @return {?}
                     */function (/**
                     * @param {?} tag
                     * @return {?}
                     */ tag) { return tag === targetTag || tag === targetTag + '@' ||
                        tag === targetTag + '#' || tag === targetTag + '^'; })) ||
                        this.tags[0];
                this.updateHosts();
            }
            else {
                this.tags = [];
                this.selectedTag = '';
                this.hosts = [];
                this.selectedHost = '';
                this.emitUpdateEvent();
            }
        };
        /**
         * @return {?}
         */
        SideNav.prototype.updateHosts = function () {
            var _this = this;
            this.store.dispatch(setLoadingStateAction({
                loadingState: {
                    loading: true,
                    message: 'Loading data',
                }
            }));
            /** @type {?} */
            var run = this.selectedRun;
            /** @type {?} */
            var tag = this.selectedTag;
            this.hosts = [];
            this.selectedHost = '';
            this.dataService.getHosts(run, tag)
                .pipe(takeUntil(this.destroyed))
                .subscribe(( /**
         * @param {?} response
         * @return {?}
         */function (response) {
                /** @type {?} */
                var hosts = (( /** @type {?} */(response))) || [''];
                if (hosts.length === 0) {
                    hosts.push('');
                }
                hosts = hosts.map(( /**
                 * @param {?} host
                 * @return {?}
                 */function (/**
                 * @param {?} host
                 * @return {?}
                 */ host) {
                    if (host === null) {
                        return '';
                    }
                    else if (host === '') {
                        return DEFAULT_HOST;
                    }
                    return host;
                }));
                if (run === _this.selectedRun && tag === _this.selectedTag) {
                    _this.hosts = hosts;
                    _this.selectedHost = _this.hosts[0];
                    _this.emitUpdateEvent();
                }
            }));
        };
        /**
         * @return {?}
         */
        SideNav.prototype.emitUpdateEvent = function () {
            this.store.dispatch(setLoadingStateAction({
                loadingState: {
                    loading: false,
                    message: '',
                }
            }));
            this.update.emit({
                run: this.selectedRun,
                tag: this.selectedTag,
                host: this.selectedHost === DEFAULT_HOST ? '' : this.selectedHost
            });
        };
        /**
         * @return {?}
         */
        SideNav.prototype.ngOnDestroy = function () {
            // Unsubscribes all pending subscriptions.
            this.destroyed.next();
            this.destroyed.complete();
        };
        return SideNav;
    }());
    SideNav.decorators = [
        { type: Component, args: [{
                    selector: 'sidenav',
                    template: "<div class=\"button-container horizontal-center\">\n  <capture-profile></capture-profile>\n</div>\n\n<div class=\"item-container\">\n  <div [ngClass]=\"{'mat-subheading-2': true, 'disabled': !runs.length}\">\n    Runs ({{runs.length}})\n  </div>\n\n  <mat-form-field class=\"full-width\">\n    <mat-select panelClass=\"panel-override\" [(value)]=\"selectedRun\" [disabled]=\"!runs.length\" (selectionChange)=\"updateTags()\">\n      <mat-option *ngFor=\"let run of runs\" [value]=\"run\">\n        {{run}}\n      </mat-option>\n    </mat-select>\n  </mat-form-field>\n</div>\n\n<div class=\"item-container\">\n  <div [ngClass]=\"{'mat-subheading-2': true, 'disabled': !tags.length}\">\n    Tools ({{tags.length}})\n  </div>\n\n  <mat-form-field class=\"full-width\">\n    <mat-select panelClass=\"panel-override\" [(value)]=\"selectedTag\" [disabled]=\"!tags.length\" (selectionChange)=\"updateHosts()\">\n      <mat-option *ngFor=\"let tag of tags\" [value]=\"tag\">\n        {{getDisplayTagName(tag)}}\n      </mat-option>\n    </mat-select>\n  </mat-form-field>\n</div>\n\n<div class=\"item-container\">\n  <div [ngClass]=\"{'mat-subheading-2': true, 'disabled': !hosts.length}\">\n    Hosts\n  </div>\n\n  <mat-form-field class=\"full-width\">\n    <mat-select panelClass=\"panel-override\" [(value)]=\"selectedHost\" [disabled]=\"!hosts.length\" (selectionChange)=\"emitUpdateEvent()\">\n      <mat-option *ngFor=\"let host of hosts\" [value]=\"host\">\n        {{host}}\n      </mat-option>\n    </mat-select>\n  </mat-form-field>\n</div>\n\n<div [hidden]=\"selectedTag != 'memory_viewer'\">\n  <buffer-details></buffer-details>\n</div>\n\n<div [hidden]=\"selectedTag != 'op_profile'\">\n  <op-details></op-details>\n</div>\n\n<div [hidden]=\"!selectedTag.startsWith('pod_viewer')\">\n  <pod-viewer-details></pod-viewer-details>\n</div>\n\n<br>\n\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}.button-container{padding:20px}.item-container{padding:20px 20px 0 20px}.mat-subheading-2{margin-bottom:0}\n"]
                }] }
    ];
    /** @nocollapse */
    SideNav.ctorParameters = function () { return [
        { type: DataService },
        { type: Store }
    ]; };
    SideNav.propDecorators = {
        datasets: [{ type: Input }],
        update: [{ type: Output }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A side navigation module.
     */
    var SideNavModule = /** @class */ (function () {
        function SideNavModule() {
        }
        return SideNavModule;
    }());
    SideNavModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [SideNav],
                    imports: [
                        CommonModule,
                        MatFormFieldModule,
                        MatSelectModule,
                        MatOptionModule,
                        BufferDetailsModule,
                        CaptureProfileModule,
                        OpDetailsModule,
                        PodViewerDetailsModule,
                    ],
                    exports: [SideNav]
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Action to set data property
     * @type {?}
     */
    var setDataAction = createAction('[Tensorflow Stats] Set data property', props());
    /**
     * Action to set diffData property
     * @type {?}
     */
    var setDiffDataAction = createAction('[Tensorflow Stats] Set diffData property', props());
    /**
     * Action to set hasDiff property
     * @type {?}
     */
    var setHasDiffAction = createAction('[Tensorflow Stats] Set hasData property', props());
    /**
     * Action to set showPprofLink property
     * @type {?}
     */
    var setShowPprofLinkAction = createAction('[Tensorflow Stats] Set showPprofLink property', props());
    /**
     * Action to set showFlopRateChart property
     * @type {?}
     */
    var setShowFlopRateChartAction = createAction('[Tensorflow Stats] Set showFlopRateChart property', props());
    /**
     * Action to set showModelProperties property
     * @type {?}
     */
    var setShowModelPropertiesAction = createAction('[Tensorflow Stats] Set showModelProperties property', props());
    /**
     * Action to set title property
     * @type {?}
     */
    var setTitleAction = createAction('[Tensorflow Stats] Set title property', props());
    /** A xy table data processor. */
    var XyTableDataProcessor = /** @class */ (function () {
        function XyTableDataProcessor(numberFormatOptions, filters, xColumn, yColumn) {
            this.numberFormatOptions = numberFormatOptions;
            this.filters = filters;
            this.xColumn = xColumn;
            this.yColumn = yColumn;
        }
        XyTableDataProcessor.prototype.process = function (dataProvider) {
            if (!dataProvider) {
                return null;
            }
            var dataTable = dataProvider.getDataTable();
            if (!dataTable) {
                return null;
            }
            if (this.numberFormatOptions) {
                var numberFormatter = new google.visualization.NumberFormat(this.numberFormatOptions);
                numberFormatter.format(dataTable, this.yColumn);
            }
            var dataView = new google.visualization.DataView(dataTable);
            if (this.filters && this.filters.length > 0) {
                dataView.setRows(dataView.getFilteredRows(this.filters));
            }
            dataView.setColumns([this.xColumn, this.yColumn]);
            return dataView;
        };
        return XyTableDataProcessor;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A flop rate chart view component.
     */
    var FlopRateChart = /** @class */ (function () {
        function FlopRateChart() {
            /**
             * The input data.
             */
            this.data = null;
            /**
             * Index of the Column that corresponds to the x-axis.
             */
            this.xColumn = 0;
            /**
             * Index of the Column that corresponds to the y-axis.
             */
            this.yColumn = 0;
            /**
             * The type of the OP, e.g. TensorFlow.
             */
            this.opType = '';
            this.dataInfo = {
                data: null,
                dataProvider: new DefaultDataProvider(),
            };
        }
        /**
         * @param {?} changes
         * @return {?}
         */
        FlopRateChart.prototype.ngOnChanges = function (changes) {
            this.dataInfo.customChartDataProcessor = new XyTableDataProcessor({ 'fractionDigits': 1 }, [{ column: this.yColumn, minValue: 0.0000 }], this.xColumn, this.yColumn);
            this.dataInfo.options = Object.assign({}, COLUMN_CHART_OPTIONS, { hAxis: {
                    textPosition: 'none',
                    title: this.opType + ' Op on Device (in decreasing total self-time)',
                }, vAxis: { title: 'GFLOPs/sec' } });
            this.dataInfo = Object.assign({}, this.dataInfo, { data: this.data });
        };
        return FlopRateChart;
    }());
    FlopRateChart.decorators = [
        { type: Component, args: [{
                    selector: 'flop-rate-chart',
                    template: "<div class=\"mat-title\">MEASURED GFLOPS/SEC OF {{opType}} OPERATIONS ON DEVICE</div>\n<chart class=\"chart\" chartType=\"ColumnChart\" [dataInfo]=\"dataInfo\"></chart>\n",
                    styles: [":host{display:block;width:550px;height:fit-content;margin:8px 8px 8px 0}.chart{margin-top:-16px}.mat-title{text-transform:uppercase}\n"]
                }] }
    ];
    FlopRateChart.propDecorators = {
        data: [{ type: Input }],
        xColumn: [{ type: Input }],
        yColumn: [{ type: Input }],
        opType: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FlopRateChartModule = /** @class */ (function () {
        function FlopRateChartModule() {
        }
        return FlopRateChartModule;
    }());
    FlopRateChartModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [FlopRateChart],
                    imports: [ChartModule],
                    exports: [FlopRateChart],
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A model properties view component.
     */
    var ModelProperties = /** @class */ (function () {
        function ModelProperties() {
            /**
             * The architecture of a model.
             */
            this.architecture = '';
            /**
             * The task of a model.
             */
            this.task = '';
        }
        return ModelProperties;
    }());
    ModelProperties.decorators = [
        { type: Component, args: [{
                    selector: 'model-properties',
                    template: "<div>\n  <div class=\"mat-title\">Model Properties</div>\n  <p><b>Task: </b>{{task}}</p>\n  <p><b>Architecture: </b>{{architecture}}</p>\n  <p class=\"note\">NOTE: These are heuristic-based results. Please file a bug if incorrect.</p>\n</div>\n",
                    styles: [":host{display:block;width:350px;height:fit-content;margin:8px 8px 8px 0}p{font-size:14px}b{font-weight:500}.note{font-style:italic}\n"]
                }] }
    ];
    ModelProperties.propDecorators = {
        architecture: [{ type: Input }],
        task: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ModelPropertiesModule = /** @class */ (function () {
        function ModelPropertiesModule() {
        }
        return ModelPropertiesModule;
    }());
    ModelPropertiesModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [ModelProperties],
                    imports: [],
                    exports: [ModelProperties],
                },] }
    ];
    var RANGE_MIN = 0;
    var RANGE_MAX = 999;
    var XNOR = function (a, b) {
        return (a && b) || (!a && !b);
    };
    /**
     * Return the diffed pie-chart table based on category.
     */
    function computeCategoryDiffTable(groupView, baseGroupView, chart) {
        var e_45, _b;
        if (!groupView || !baseGroupView) {
            return null;
        }
        // Obtain a superset of categories, and the map from category to self time
        // in both baseline and current profiles.
        var categorySet = new Set(); // Assume set is unordered.
        var oldMap = {};
        var newMap = {};
        for (var i_199 = 0; i_199 < groupView.getNumberOfRows(); i_199++) {
            newMap[groupView.getValue(i_199, 0)] = groupView.getValue(i_199, 1);
            categorySet.add(groupView.getValue(i_199, 0));
        }
        for (var i_200 = 0; i_200 < baseGroupView.getNumberOfRows(); i_200++) {
            oldMap[baseGroupView.getValue(i_200, 0)] = baseGroupView.getValue(i_200, 1);
            categorySet.add(baseGroupView.getValue(i_200, 0));
        }
        // Initialize the oldTable and newTable with the superset of categories.
        var oldTable = new google.visualization.DataTable();
        for (var i_201 = 0; i_201 < baseGroupView.getNumberOfColumns(); i_201++) {
            oldTable.addColumn({
                'type': baseGroupView.getColumnType(i_201),
                'label': baseGroupView.getColumnLabel(i_201),
            });
        }
        oldTable.addRows(categorySet.size);
        var rowID = 0;
        try {
            for (var _c = __values(categorySet.keys()), _d = _c.next(); !_d.done; _d = _c.next()) {
                var skey = _d.value;
                oldTable.setCell(rowID, 0, skey);
                oldTable.setCell(rowID, 1, 0.0);
                rowID++;
            }
        }
        catch (e_45_1) { e_45 = { error: e_45_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
            }
            finally { if (e_45) throw e_45.error; }
        }
        var newTable = oldTable.clone();
        // Fill in the value in oldTable and newTable respectively.
        for (var i_202 = 0; i_202 < oldTable.getNumberOfRows(); i_202++) {
            if (oldTable.getValue(i_202, 0) in oldMap) {
                oldTable.setCell(i_202, 1, oldMap[oldTable.getValue(i_202, 0)]);
            }
        }
        for (var i_203 = 0; i_203 < newTable.getNumberOfRows(); i_203++) {
            if (newTable.getValue(i_203, 0) in newMap) {
                newTable.setCell(i_203, 1, newMap[newTable.getValue(i_203, 0)]);
            }
        }
        // Return the diffed pie-chart table.
        // tslint:disable-next-line:no-any
        return chart['computeDiff'](oldTable, newTable);
    }
    /**
     * Compute the stats difference between two tables. oldTable and newTable
     * need to be DataTable class, and function also returns DataTable class.
     * Assume the type and label of columns in both tables match, while their
     * row counts can be different.
     * This function works for both main table and opType aggregation table.
     * @param oldTable Previous data table to be compared.It is used to calculate
     *        the difference from the new data table.
     * @param newTable Data table for current values.The increase or decrease is
     *        displayed based on this value.
     * @param referenceCol Column number as a reference for comparing two data
     *        tables.
     * @param comparisonCol Column number that has the actual value comparing two
     *        data tables.
     * @param addColumnType The type of an additional column at the end for sorting
     *        purpose.
     * @param addColumnLabel The label of an additional column at the end for
     *        sorting purpose.
     * @param sortColumn Columns used for sorting the created data table.
     * @param hiddenColumns Number of hidden columns in the created data table.
     * @param formatDiffInfo Define hasColor and isLargeBetter for the range of the
     *        column. If all values are true in 8 and false in all other ranges, it
     *        can be defined as follows. If rangeMin is not defined, 0 is used. If
     *        rangeMax is not defined, 999 is used.
     *        [
     *          {
     *            rangeMax: 7,
     *            hasColor: false,
     *            isLargeBetter: false,
     *          },
     *          {
     *            rangeMin: 8,
     *            rangeMax: 8,
     *            hasColor: true,
     *            isLargeBetter: true,
     *          },
     *          {
     *            rangeMin: 9,
     *            hasColor: true,
     *            isLargeBetter: false,
     *          },
     *        ]
     * @param formatValueInfo Defines multiplier, fixed, and suffix for the range of
     *        the column. For example, column 0 multiplies by 100, removes the
     *        decimal point, and adds a % sign. The remaining columns are displayed
     *        up to two decimal places. In this case, it is defined as follows. If
     *        rangeMin is not defined, 0 is used. If rangeMax is not defined, 999 is
     *        used.
     *        [
     *          {
     *            rangeMin: 0,
     *            rangeMax: 0,
     *            multiplier: 100,
     *            fixed: 0,
     *            suffix: '%',
     *          },
     *          {
     *            rangeMin: 1,
     *            multiplier: 1,
     *            fixed: 2,
     *            suffix: '',
     *          },
     *        ]
     */
    function computeDiffTable(oldTable, newTable, referenceCol, comparisonCol, addColumnType, addColumnLabel, sortColumn, hiddenColumns, formatDiffInfo, formatValueInfo) {
        var colsCount = oldTable.getNumberOfColumns();
        var diffTable = new google.visualization.DataTable();
        // The first column can be rank ('number') or opType ('string').
        diffTable.addColumn({
            'type': oldTable.getColumnType(0),
            'label': oldTable.getColumnLabel(0),
        });
        // Adds column label for diffTable. Assume old and new tables
        // have the same column types.
        for (var colIndex = 1; colIndex < colsCount; ++colIndex) {
            diffTable.addColumn({
                'type': 'string',
                'label': oldTable.getColumnLabel(colIndex),
            });
        }
        // Add additional column at the end for sorting purpose.
        diffTable.addColumn({
            'type': addColumnType,
            'label': addColumnLabel,
        });
        diffTable.addRows(oldTable.getNumberOfRows() + newTable.getNumberOfRows());
        // Merge sort and diff the oldTable and newTable based on opName.
        var numDiffRows = mergeSortTables(diffTable, oldTable, newTable, referenceCol, comparisonCol, formatDiffInfo, formatValueInfo);
        // Hide the empty rows, and the last column in diffTable.
        var diffView = new google.visualization.DataView(diffTable);
        if (numDiffRows > 0) {
            diffView.setRows(0, numDiffRows - 1);
            sortColumn.push({ column: colsCount, desc: true });
            diffView.setRows(diffView.getSortedRows(sortColumn));
        }
        hiddenColumns.push(colsCount);
        diffView.hideColumns(hiddenColumns);
        return diffView;
    }
    /**
     * The function takes in oldTable and newTable, sort them by referenceCol
     * column, and fill their difference into the generated diffTable.
     * The difference in comparisonCol column is filled in the last column
     * of diffTable, and used for sorting the diffTable afterwards,
     */
    function mergeSortTables(diffTable, oldTable, newTable, referenceCol, comparisonCol, formatDiffInfo, formatValueInfo) {
        oldTable.sort({ column: referenceCol, desc: false }); // Ascending order.
        newTable.sort({ column: referenceCol, desc: false }); // Ascending order.
        var oldSize = oldTable.getNumberOfRows();
        var newSize = newTable.getNumberOfRows();
        // colsCount is number of columns in the original tables. In diffTable
        // there is one additional column at the end which is the difference
        // in self time between two stats.  The column is used solely for
        // sorting the diffTable and gets hidden before function returns.
        var colsCount = oldTable.getNumberOfColumns();
        var largeCharInASCII = '~~~~';
        var rowIndex = 0;
        for (var oldRow = 0, newRow = 0; oldRow < oldSize || newRow < newSize; rowIndex++) {
            // Assign the largest character in ASCII table for comparison.
            var oldReferenceValue = (oldRow < oldSize) ?
                oldTable.getValue(oldRow, referenceCol) :
                largeCharInASCII;
            var newReferenceValue = (newRow < newSize) ?
                newTable.getValue(newRow, referenceCol) :
                largeCharInASCII;
            if (oldRow < oldSize && newRow < newSize &&
                oldReferenceValue === newReferenceValue) {
                // If reference value is the same, then diff the two stats.
                for (var colIndex = 0; colIndex < colsCount; colIndex++) {
                    if (colIndex !== 0 && oldTable.getColumnType(colIndex) === 'number') {
                        var baseVal = oldTable.getValue(oldRow, colIndex);
                        var diffVal = newTable.getValue(newRow, colIndex) -
                            oldTable.getValue(oldRow, colIndex);
                        diffTable.setCell(rowIndex, colIndex, formatValue(baseVal, colIndex, formatValueInfo) +
                            formatDiff(diffVal, baseVal, colIndex, formatDiffInfo));
                    }
                    else { // Use oldTable's string values, or rank.
                        diffTable.setCell(rowIndex, colIndex, oldTable.getValue(oldRow, colIndex));
                    }
                }
                var diffValue = newTable.getValue(newRow, comparisonCol) -
                    oldTable.getValue(oldRow, comparisonCol);
                diffTable.setCell(rowIndex, colsCount, diffValue);
                oldRow++, newRow++;
            }
            else if (newRow === newSize || oldReferenceValue < newReferenceValue) {
                // If only old stats, then assign the diff as negative old stats.
                for (var colIndex = 0; colIndex < colsCount; colIndex++) {
                    if (colIndex !== 0 && oldTable.getColumnType(colIndex) === 'number') {
                        var baseVal = oldTable.getValue(oldRow, colIndex);
                        var diffVal = -oldTable.getValue(oldRow, colIndex);
                        diffTable.setCell(rowIndex, colIndex, formatValue(baseVal, colIndex, formatValueInfo) +
                            formatDiff(diffVal, baseVal, colIndex, formatDiffInfo));
                    }
                    else { // Use oldTable's string values, or rank.
                        diffTable.setCell(rowIndex, colIndex, oldTable.getValue(oldRow, colIndex));
                    }
                }
                var diffValue = -oldTable.getValue(oldRow, comparisonCol);
                diffTable.setCell(rowIndex, colsCount, diffValue);
                oldRow++;
            }
            else { // if (oldRow == oldSize || oldReferenceValue > newReferenceValue)
                // If only new stats, then assign the diff as new stats.
                for (var colIndex = 0; colIndex < colsCount; colIndex++) {
                    if (colIndex !== 0 && newTable.getColumnType(colIndex) === 'number') {
                        var baseVal = 0;
                        var diffVal = newTable.getValue(newRow, colIndex);
                        diffTable.setCell(rowIndex, colIndex, formatValue(baseVal, colIndex, formatValueInfo) +
                            formatDiff(diffVal, baseVal, colIndex, formatDiffInfo));
                    }
                    else { // Use newTable's string values, or rank.
                        diffTable.setCell(rowIndex, colIndex, newTable.getValue(newRow, colIndex));
                    }
                }
                var diffValue = newTable.getValue(newRow, comparisonCol);
                diffTable.setCell(rowIndex, colsCount, diffValue);
                newRow++;
            } // End of if condition comparing opName.
        } // End of for loop over all rows.
        return rowIndex;
    }
    /**
     * Format value based on table column index.
     */
    function formatValue(val, col, formatValueInfo) {
        var e_46, _b;
        try {
            for (var formatValueInfo_1 = __values(formatValueInfo), formatValueInfo_1_1 = formatValueInfo_1.next(); !formatValueInfo_1_1.done; formatValueInfo_1_1 = formatValueInfo_1.next()) {
                var info = formatValueInfo_1_1.value;
                var rangeMin = info.hasOwnProperty('rangeMin') ? info.rangeMin || 0 : RANGE_MIN;
                var rangeMax = info.hasOwnProperty('rangeMax') ? info.rangeMax || 0 : RANGE_MAX;
                if (col >= rangeMin && col <= rangeMax) {
                    return (val * info.multiplier).toFixed(info.fixed) + info.suffix;
                }
            }
        }
        catch (e_46_1) { e_46 = { error: e_46_1 }; }
        finally {
            try {
                if (formatValueInfo_1_1 && !formatValueInfo_1_1.done && (_b = formatValueInfo_1.return)) _b.call(formatValueInfo_1);
            }
            finally { if (e_46) throw e_46.error; }
        }
        return '';
    }
    /**
     * Format diff value.
     */
    function formatDiff(diffVal, baseVal, colIndex, formatDiffInfo) {
        var e_47, _b;
        try {
            for (var formatDiffInfo_1 = __values(formatDiffInfo), formatDiffInfo_1_1 = formatDiffInfo_1.next(); !formatDiffInfo_1_1.done; formatDiffInfo_1_1 = formatDiffInfo_1.next()) {
                var info = formatDiffInfo_1_1.value;
                var rangeMin = info.hasOwnProperty('rangeMin') ? info.rangeMin || 0 : RANGE_MIN;
                var rangeMax = info.hasOwnProperty('rangeMax') ? info.rangeMax || 0 : RANGE_MAX;
                if (colIndex >= rangeMin && colIndex <= rangeMax) {
                    return formatDiffWithColor(diffVal, baseVal, info.hasColor, info.isLargeBetter);
                }
            }
        }
        catch (e_47_1) { e_47 = { error: e_47_1 }; }
        finally {
            try {
                if (formatDiffInfo_1_1 && !formatDiffInfo_1_1.done && (_b = formatDiffInfo_1.return)) _b.call(formatDiffInfo_1);
            }
            finally { if (e_47) throw e_47.error; }
        }
        return '';
    }
    /**
     * Format diff value with color.
     */
    function formatDiffWithColor(dividend, divisor, hasColor, isLargeBetter) {
        // If dividend is 0, return 0.
        if (!dividend)
            return '<font color="grey">(0)</font>';
        var color;
        if (hasColor) {
            color = XNOR(dividend > 0, isLargeBetter) ? 'green' : 'red';
        }
        else {
            color = 'black';
        }
        var str;
        if (!divisor) { // If divisor is 0, return the original dividend value.
            str = '(+' + dividend.toFixed(1) + ')';
        }
        else {
            str = dividend > 0 ? '(+' : '(';
            str += (dividend / divisor * 100).toFixed(0) + '%)';
        }
        return str.fontcolor(color);
    }
    /**
     * Create a group table with a group column and a value column.
     * @param dataTable The data table to be changed to a group.
     * @param filters Filters on the data to be displayed.
     * @param gColumn The column index to group the data.
     * @param vColumn The column index that has data value.
     */
    function computeGroupView(dataTable, filters, gColumn, vColumn) {
        var numberFormatter = new google.visualization.NumberFormat({ 'fractionDigits': 0 });
        var dataView = new google.visualization.DataView(dataTable);
        if (filters && filters.length > 0) {
            dataView.setRows(dataView.getFilteredRows(filters));
        }
        var dataGroup = google.visualization.data.group(dataView, [gColumn], [{
                'column': vColumn,
                'aggregation': google.visualization.data.sum,
                'type': 'number',
            }]);
        dataGroup.sort({ column: 1, desc: true });
        numberFormatter.format(dataGroup, 1);
        return new google.visualization.DataView(dataGroup);
    }
    var MINIMUM_ROWS = 20;
    /** A operations table data provider. */
    var OperationsTableDataProvider = /** @class */ (function (_super) {
        __extends(OperationsTableDataProvider, _super);
        function OperationsTableDataProvider() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this.hasDiff = false;
            _this.opExecutor = "" /* NONE */;
            _this.options = {
                allowHtml: true,
                alternatingRowStyle: false,
                showRowNumber: false,
                height: '600px',
                cssClassNames: {
                    'headerCell': 'google-chart-table-header-cell',
                    'tableCell': 'google-chart-table-table-cell',
                },
            };
            return _this;
        }
        OperationsTableDataProvider.prototype.setDiffData = function (diffData) {
            this.diffTable =
                diffData ? new google.visualization.DataTable(diffData) : undefined;
        };
        OperationsTableDataProvider.prototype.process = function () {
            if (!this.dataTable ||
                (this.opExecutor !== "Device" /* DEVICE */ &&
                    this.opExecutor !== "Host" /* HOST */)) {
                return null;
            }
            var dataView = null;
            if (!this.hasDiff || !this.diffTable) {
                dataView = this.makeDataView(this.dataTable, this.opExecutor);
            }
            else {
                var oldDataView = this.makeDataView(this.diffTable, this.opExecutor);
                var newDataView = this.makeDataView(this.dataTable, this.opExecutor);
                if (!oldDataView || !newDataView) {
                    return null;
                }
                var formatDiffInfo = [
                    {
                        rangeMin: 1,
                        rangeMax: 1,
                        hasColor: false,
                        isLargeBetter: false,
                    },
                    {
                        rangeMin: 0,
                        rangeMax: 0,
                        hasColor: true,
                        isLargeBetter: false,
                    },
                    {
                        rangeMin: 2,
                        hasColor: true,
                        isLargeBetter: false,
                    },
                ];
                var formatValueInfo = [
                    {
                        rangeMin: 1,
                        rangeMax: 1,
                        multiplier: 1,
                        fixed: 0,
                        suffix: '',
                    },
                    {
                        rangeMin: 2,
                        rangeMax: 2,
                        multiplier: 1,
                        fixed: 3,
                        suffix: '',
                    },
                    {
                        rangeMin: 0,
                        rangeMax: 0,
                        multiplier: 100,
                        fixed: 1,
                        suffix: '%',
                    },
                    {
                        rangeMin: 3,
                        multiplier: 100,
                        fixed: 1,
                        suffix: '%',
                    },
                ];
                dataView = computeDiffTable(
                /* oldTable= */ oldDataView.toDataTable(), 
                /* newTable= */ newDataView.toDataTable(), 
                /* referenceCol= */ 0, 
                /* comparisonCol= */ 3, 
                /* addColumnType= */ 'number', 
                /* addColumnLabel= */ 'Diff total self time', 
                /* sortColumn= */ [], 
                /* hiddenColumns= */ [], 
                /* formatDiffInfo= */ formatDiffInfo, 
                /* formatValueInfo= */ formatValueInfo);
            }
            if (!dataView) {
                return null;
            }
            this.options.height =
                dataView.getNumberOfRows() < MINIMUM_ROWS ? '' : '600px';
            return dataView;
        };
        OperationsTableDataProvider.prototype.getOptions = function () {
            return this.options;
        };
        OperationsTableDataProvider.prototype.makeDataView = function (srcTable, deviceType) {
            return deviceType === "Device" /* DEVICE */ ?
                this.makeDataViewForDevice(srcTable) :
                this.makeDataViewForHost(srcTable);
        };
        OperationsTableDataProvider.prototype.makeDataViewForDevice = function (srcTable) {
            if (!srcTable || this.opExecutor !== "Device" /* DEVICE */) {
                return null;
            }
            var dataView = new google.visualization.DataView(srcTable);
            dataView.setRows(dataView.getFilteredRows([{
                    'column': 1,
                    'value': 'Device',
                }]));
            /**
             * column 0: type
             * column 1: occurrences
             * column 2: self_time
             * column 3: self_time_on_device
             */
            dataView.setColumns([
                2,
                4,
                7,
                9,
            ]);
            /**
             * column 0: type
             * column 1: sum of occurrences
             * column 2: sum of self_time
             * column 3: sum of self_time_on_device
             */
            var dataTable = google.visualization.data.group(dataView, [0], [
                {
                    'column': 1,
                    'aggregation': google.visualization.data.sum,
                    'type': 'number',
                },
                {
                    'column': 2,
                    'aggregation': google.visualization.data.sum,
                    'type': 'number',
                },
                {
                    'column': 3,
                    'aggregation': google.visualization.data.sum,
                    'type': 'number',
                },
            ]);
            dataTable.sort({
                'column': 2,
                'desc': true,
            });
            var decimalFormatter = new google.visualization.NumberFormat({ 'fractionDigits': 0 });
            decimalFormatter.format(dataTable, 2);
            var percentFormatter = new google.visualization.NumberFormat({ pattern: '##.#%' });
            percentFormatter.format(dataTable, 3);
            dataView = new google.visualization.DataView(dataTable);
            /**
             * column 0: type
             * column 1: sum of occurrences
             * column 2: sum of self_time
             * column 3: sum of self_time_on_device
             */
            dataView.setColumns([
                0,
                1,
                2,
                3,
            ]);
            return dataView;
        };
        OperationsTableDataProvider.prototype.makeDataViewForHost = function (srcTable) {
            if (!srcTable || this.opExecutor !== "Host" /* HOST */) {
                return null;
            }
            var dataView = new google.visualization.DataView(srcTable);
            dataView.setRows(dataView.getFilteredRows([{
                    'column': 1,
                    'value': 'Host',
                }]));
            /**
             * column 0: type
             * column 1: occurrences
             * column 2: self_time
             * column 3: self_time_on_host
             */
            dataView.setColumns([2, 4, 7, 11]);
            /**
             * column 0: type
             * column 1: sum of occurrences
             * column 2: sum of self_time
             * column 3: sum of self_time_on_host
             */
            var dataTable = google.visualization.data.group(dataView, [0], [
                {
                    'column': 1,
                    'aggregation': google.visualization.data.sum,
                    'type': 'number',
                },
                {
                    'column': 2,
                    'aggregation': google.visualization.data.sum,
                    'type': 'number',
                },
                {
                    'column': 3,
                    'aggregation': google.visualization.data.sum,
                    'type': 'number',
                },
            ]);
            dataTable.sort({
                'column': 2,
                'desc': true,
            });
            var decimalFormatter = new google.visualization.NumberFormat({ 'fractionDigits': 0 });
            decimalFormatter.format(dataTable, 2);
            var percentFormatter = new google.visualization.NumberFormat({ pattern: '##.#%' });
            percentFormatter.format(dataTable, 3);
            return new google.visualization.DataView(dataTable);
        };
        return OperationsTableDataProvider;
    }(DefaultDataProvider));
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * An operations table view component.
     */
    var OperationsTable = /** @class */ (function () {
        function OperationsTable() {
            /**
             * The tensorflow stats data.
             */
            this.tensorflowStatsData = null;
            /**
             * The tensorflow stats data for diff.
             */
            this.diffData = null;
            /**
             * Whether to use diff.
             */
            this.hasDiff = false;
            /**
             * The Op executor.
             */
            this.opExecutor = "" /* NONE */;
            this.title = '';
            this.dataProvider = new OperationsTableDataProvider();
            this.dataInfo = {
                data: null,
                dataProvider: this.dataProvider,
            };
        }
        /**
         * @param {?} changes
         * @return {?}
         */
        OperationsTable.prototype.ngOnChanges = function (changes) {
            if (this.opExecutor === "Device" /* DEVICE */) {
                this.title = 'Device-side TensorFlow operations (grouped by TYPE)';
            }
            else if (this.opExecutor === "Host" /* HOST */) {
                this.title = 'Host-side TensorFlow operations (grouped by TYPE)';
            }
            else {
                this.title = '';
            }
            this.dataProvider.hasDiff = this.hasDiff;
            if (this.hasDiff && this.diffData) {
                this.dataProvider.setDiffData(this.diffData);
            }
            this.dataProvider.opExecutor = this.opExecutor;
            this.dataInfo = Object.assign({}, this.dataInfo, { data: this.tensorflowStatsData });
        };
        return OperationsTable;
    }());
    OperationsTable.decorators = [
        { type: Component, args: [{
                    selector: 'operations-table',
                    template: "<div class=\"mat-headline\">{{title}}</div>\n<chart class=\"table\" chartType=\"Table\" [dataInfo]=\"dataInfo\"></chart>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}:host{display:block;padding:20px}.table{border:1px solid #eee;width:fit-content}\n"]
                }] }
    ];
    OperationsTable.propDecorators = {
        tensorflowStatsData: [{ type: Input }],
        diffData: [{ type: Input }],
        hasDiff: [{ type: Input }],
        opExecutor: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var OperationsTableModule = /** @class */ (function () {
        function OperationsTableModule() {
        }
        return OperationsTableModule;
    }());
    OperationsTableModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [OperationsTable],
                    imports: [ChartModule],
                    exports: [OperationsTable],
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var DATA_TABLE_RANK_INDEX$1 = 1;
    /** @type {?} */
    var DATA_TABLE_DEVICE_PERCENT_INDEX = 10;
    /** @type {?} */
    var DATA_TABLE_CUMULATIVE_DEVICE_PERCENT_INDEX = 11;
    /** @type {?} */
    var DATA_TABLE_HOST_PERCENT_INDEX = 12;
    /** @type {?} */
    var DATA_TABLE_CUMULATIVE_HOST_PERCENT_INDEX = 13;
    /** @type {?} */
    var DATA_VIEW_CUMULATIVE_DEVICE_PERCENT_INDEX = 10;
    /** @type {?} */
    var DATA_VIEW_CUMULATIVE_HOST_PERCENT_INDEX = 12;
    /** @type {?} */
    var MAXIMUM_ROWS = 1000;
    /** @type {?} */
    var MINIMUM_ROWS$1 = 20;
    /**
     * A stats table data provider.
     */
    var StatsTableDataProvider = /** @class */ (function (_super) {
        __extends(StatsTableDataProvider, _super);
        function StatsTableDataProvider() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this.hasDiff = false;
            _this.sortAscending = true;
            _this.sortColumn = -1;
            _this.options = {
                allowHtml: true,
                alternatingRowStyle: false,
                showRowNumber: false,
                width: '100%',
                height: '600px',
                cssClassNames: {
                    'headerCell': 'google-chart-table-header-cell',
                    'tableCell': 'google-chart-table-table-cell',
                },
                sort: 'event',
                sortAscending: true,
                sortColumn: -1,
            };
            _this.totalOperationsChanged = new EventEmitter();
            return _this;
        }
        /**
         * @param {?} chart
         * @return {?}
         */
        StatsTableDataProvider.prototype.setChart = function (chart) {
            var _this = this;
            this.chart = chart;
            google.visualization.events.addListener(this.chart, 'sort', ( /**
             * @param {?} event
             * @return {?}
             */function (event) {
                _this.sortColumn = event.column;
                _this.sortAscending = event.ascending;
                _this.update.emit();
            }));
        };
        /**
         * @param {?} data
         * @return {?}
         */
        StatsTableDataProvider.prototype.parseData = function (data) {
            if (!data)
                return;
            /** @type {?} */
            var dataTable = new google.visualization.DataTable(data);
            if (this.hasDiff && this.diffTable) {
                this.preProcessDiffTable(dataTable, this.diffTable);
            }
            else {
                this.preProcessDataTable(dataTable);
            }
        };
        /**
         * @param {?} diffData
         * @return {?}
         */
        StatsTableDataProvider.prototype.setDiffData = function (diffData) {
            this.diffTable = diffData ?
                new google.visualization.DataTable(diffData) :
                undefined;
        };
        /**
         * @param {?} filters
         * @return {?}
         */
        StatsTableDataProvider.prototype.setFilters = function (filters) {
            this.filters = filters;
            if (this.dataTable) {
                this.update.emit();
            }
        };
        /**
         * @return {?}
         */
        StatsTableDataProvider.prototype.process = function () {
            if (!this.dataTable) {
                return null;
            }
            /** @type {?} */
            var dataTable = this.dataTable;
            /** @type {?} */
            var dataView = null;
            if (this.filters && this.filters.length > 0) {
                dataView = new google.visualization.DataView(this.dataTable);
                dataView.setRows(this.dataTable.getFilteredRows(this.filters));
                dataTable = dataView.toDataTable();
            }
            if (!this.hasDiff) {
                dataView = this.formatDataTable(dataTable);
            }
            else {
                dataView = this.formatDiffTable(dataTable);
            }
            this.options.height =
                dataView.getNumberOfRows() < MINIMUM_ROWS$1 ? '' : '600px';
            return dataView;
        };
        /**
         * @return {?}
         */
        StatsTableDataProvider.prototype.getOptions = function () {
            this.options.sortAscending = this.sortAscending;
            this.options.sortColumn = this.sortColumn;
            return this.options;
        };
        /**
         * @param {?} callback
         * @return {?}
         */
        StatsTableDataProvider.prototype.setTotalOperationsChangedEventListener = function (callback) {
            this.totalOperationsChanged.subscribe(callback);
        };
        /**
         * @param {?} dataTable
         * @return {?}
         */
        StatsTableDataProvider.prototype.preProcessDataTable = function (dataTable) {
            this.dataTable = dataTable.clone();
            this.updateTotalOperations(this.dataTable);
            /** @type {?} */
            var zeroDecimalPtFormatter = new google.visualization.NumberFormat({ 'fractionDigits': 0 });
            zeroDecimalPtFormatter.format(this.dataTable, 5); /** total_time */
            zeroDecimalPtFormatter.format(this.dataTable, 6); /** avg_time */
            zeroDecimalPtFormatter.format(this.dataTable, 7); /** total_self_time */
            zeroDecimalPtFormatter.format(this.dataTable, 8); /** avg_self_time */
            /**
             * avg_self_time
             * @type {?}
             */
            var percentFormatter = new google.visualization.NumberFormat({ pattern: '##.#%' });
            percentFormatter.format(this.dataTable, 9); /** device_total_self_time_percent */
            percentFormatter.format(this.dataTable, 11); /** host_total_self_time_percent */
            /**
             * Format tensorcore utilization column if it exists in dataTable.
             * This column does not exist in dataTable if the device is not GPU.
             */
            for (var i_204 = 0; i_204 < dataTable.getNumberOfColumns(); i_204++) {
                if (this.dataTable.getColumnId(i_204) === 'gpu_tensorcore_utilization') {
                    percentFormatter.format(this.dataTable, i_204);
                    break;
                }
            }
            this.dataTable.insertColumn(1, 'number', 'Rank');
        };
        /**
         * @param {?} dataTable
         * @param {?} diffTable
         * @return {?}
         */
        StatsTableDataProvider.prototype.preProcessDiffTable = function (dataTable, diffTable) {
            /** @type {?} */
            var sortColumn = [{ column: 1, desc: false }];
            /** @type {?} */
            var hiddenColumn = [0, 4, 5, 6, 7, 10, 12];
            /** @type {?} */
            var formatDiffInfo = [
                {
                    rangeMin: 0,
                    rangeMax: 7,
                    hasColor: false,
                    isLargeBetter: false,
                },
                {
                    rangeMin: 8,
                    rangeMax: 12,
                    hasColor: true,
                    isLargeBetter: false,
                },
                {
                    rangeMin: 13,
                    hasColor: true,
                    isLargeBetter: true,
                },
            ];
            /** @type {?} */
            var formatValueInfo = [
                {
                    rangeMin: 0,
                    rangeMax: 8,
                    multiplier: 1,
                    fixed: 0,
                    suffix: '',
                },
                {
                    rangeMin: 9,
                    rangeMax: 12,
                    multiplier: 100,
                    fixed: 1,
                    suffix: '%',
                },
                {
                    rangeMin: 13,
                    multiplier: 1,
                    fixed: 1,
                    suffix: '',
                },
            ];
            /** @type {?} */
            var dataView = computeDiffTable(
            /* oldTable= */ diffTable, 
            /* newTable= */ dataTable, 
            /* referenceCol= */ 3, 
            /* comparisonCol= */ 8, 
            /* addColumnType= */ 'number', 
            /* addColumnLabel= */ 'Diff total self time', 
            /* sortColumn= */ sortColumn, 
            /* hiddenColumns= */ hiddenColumn, 
            /* formatDiffInfo= */ formatDiffInfo, 
            /* formatValueInfo= */ formatValueInfo);
            if (!dataView) {
                return;
            }
            this.dataTable = dataView.toDataTable();
            if (!this.dataTable) {
                return;
            }
            this.updateTotalOperations(this.dataTable);
        };
        /**
         * @param {?} dataTable
         * @return {?}
         */
        StatsTableDataProvider.prototype.formatDataTable = function (dataTable) {
            var e_48, _b, e_49, _c, e_50, _d;
            /** @type {?} */
            var sortColumn = this.sortColumn + 1;
            if (this.sortColumn === 0 ||
                this.sortColumn === DATA_VIEW_CUMULATIVE_DEVICE_PERCENT_INDEX ||
                this.sortColumn === DATA_VIEW_CUMULATIVE_HOST_PERCENT_INDEX) {
                sortColumn = this.sortColumn;
            }
            /** @type {?} */
            var sortedIndex = dataTable.getSortedRows({
                column: sortColumn,
                desc: !this.sortAscending,
            });
            /** @type {?} */
            var sumOfDevice = 0;
            /** @type {?} */
            var sumOfHost = 0;
            if (sortColumn === 0 && !this.sortAscending) {
                /** @type {?} */
                var n = sortedIndex.length;
                try {
                    for (var sortedIndex_1 = __values(sortedIndex), sortedIndex_1_1 = sortedIndex_1.next(); !sortedIndex_1_1.done; sortedIndex_1_1 = sortedIndex_1.next()) {
                        var v = sortedIndex_1_1.value;
                        dataTable.setCell(v, DATA_TABLE_RANK_INDEX$1, n--);
                        sumOfDevice += dataTable.getValue(v, DATA_TABLE_DEVICE_PERCENT_INDEX);
                        dataTable.setCell(v, DATA_TABLE_CUMULATIVE_DEVICE_PERCENT_INDEX, sumOfDevice);
                        sumOfHost += dataTable.getValue(v, DATA_TABLE_HOST_PERCENT_INDEX);
                        dataTable.setCell(v, DATA_TABLE_CUMULATIVE_HOST_PERCENT_INDEX, sumOfHost);
                    }
                }
                catch (e_48_1) { e_48 = { error: e_48_1 }; }
                finally {
                    try {
                        if (sortedIndex_1_1 && !sortedIndex_1_1.done && (_b = sortedIndex_1.return)) _b.call(sortedIndex_1);
                    }
                    finally { if (e_48) throw e_48.error; }
                }
            }
            else {
                try {
                    for (var _e = __values(sortedIndex.entries()), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var _g = __read(_f.value, 2), index = _g[0], v = _g[1];
                        dataTable.setCell(v, DATA_TABLE_RANK_INDEX$1, index + 1);
                        sumOfDevice += dataTable.getValue(v, DATA_TABLE_DEVICE_PERCENT_INDEX);
                        if (sumOfDevice > 100) {
                            sumOfDevice = 100;
                        }
                        dataTable.setCell(v, DATA_TABLE_CUMULATIVE_DEVICE_PERCENT_INDEX, sumOfDevice);
                        sumOfHost += dataTable.getValue(v, DATA_TABLE_HOST_PERCENT_INDEX);
                        if (sumOfHost > 100) {
                            sumOfHost = 100;
                        }
                        dataTable.setCell(v, DATA_TABLE_CUMULATIVE_HOST_PERCENT_INDEX, sumOfHost);
                    }
                }
                catch (e_49_1) { e_49 = { error: e_49_1 }; }
                finally {
                    try {
                        if (_f && !_f.done && (_c = _e.return)) _c.call(_e);
                    }
                    finally { if (e_49) throw e_49.error; }
                }
                if (!this.sortAscending &&
                    (this.sortColumn === DATA_VIEW_CUMULATIVE_DEVICE_PERCENT_INDEX ||
                        this.sortColumn === DATA_VIEW_CUMULATIVE_HOST_PERCENT_INDEX)) {
                    /** @type {?} */
                    var sumOfPercent = this.sortColumn === DATA_VIEW_CUMULATIVE_DEVICE_PERCENT_INDEX ?
                        sumOfDevice :
                        sumOfHost;
                    /** @type {?} */
                    var index = this.sortColumn === DATA_VIEW_CUMULATIVE_DEVICE_PERCENT_INDEX ?
                        DATA_TABLE_CUMULATIVE_DEVICE_PERCENT_INDEX :
                        DATA_TABLE_CUMULATIVE_HOST_PERCENT_INDEX;
                    try {
                        for (var sortedIndex_2 = __values(sortedIndex), sortedIndex_2_1 = sortedIndex_2.next(); !sortedIndex_2_1.done; sortedIndex_2_1 = sortedIndex_2.next()) {
                            var v = sortedIndex_2_1.value;
                            dataTable.setCell(v, index, sumOfPercent);
                            sumOfPercent -= dataTable.getValue(v, index - 1);
                            if (sumOfPercent < 0) {
                                sumOfPercent = 0;
                            }
                        }
                    }
                    catch (e_50_1) { e_50 = { error: e_50_1 }; }
                    finally {
                        try {
                            if (sortedIndex_2_1 && !sortedIndex_2_1.done && (_d = sortedIndex_2.return)) _d.call(sortedIndex_2);
                        }
                        finally { if (e_50) throw e_50.error; }
                    }
                }
            }
            /** @type {?} */
            var percentFormatter = new google.visualization.NumberFormat({ pattern: '##.#%' });
            percentFormatter.format(dataTable, DATA_TABLE_CUMULATIVE_DEVICE_PERCENT_INDEX);
            percentFormatter.format(dataTable, DATA_TABLE_CUMULATIVE_HOST_PERCENT_INDEX);
            /** @type {?} */
            var dataView = new google.visualization.DataView(dataTable);
            dataView.setRows(sortedIndex);
            dataView.hideColumns([0]);
            return dataView;
        };
        /**
         * @param {?} dataTable
         * @return {?}
         */
        StatsTableDataProvider.prototype.formatDiffTable = function (dataTable) {
            /** @type {?} */
            var dataView = new google.visualization.DataView(dataTable);
            if (this.sortColumn >= 0) {
                /** @type {?} */
                var sortedIndex = dataTable.getSortedRows({
                    column: this.sortColumn,
                    desc: !this.sortAscending,
                });
                dataView.setRows(sortedIndex);
            }
            return dataView;
        };
        /**
         * @param {?} dataTable
         * @return {?}
         */
        StatsTableDataProvider.prototype.updateTotalOperations = function (dataTable) {
            /** @type {?} */
            var totalOperations = dataTable.getNumberOfRows();
            if (totalOperations > MAXIMUM_ROWS) {
                this.totalOperationsChanged.emit(String(totalOperations));
                dataTable.removeRows(MAXIMUM_ROWS, totalOperations - MAXIMUM_ROWS);
            }
            else {
                this.totalOperationsChanged.emit('');
            }
        };
        return StatsTableDataProvider;
    }(DefaultDataProvider));
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var DATA_TABLE_EXECUTOR_INDEX = 2;
    /** @type {?} */
    var DATA_TABLE_TYPE_INDEX = 3;
    /** @type {?} */
    var DATA_TABLE_OPERATION_INDEX$1 = 4;
    /**
     * A stats table view component.
     */
    var StatsTable = /** @class */ (function () {
        function StatsTable() {
            /**
             * The tensorflow stats data.
             */
            this.tensorflowStatsData = null;
            /**
             * The tensorflow stats data for diff.
             */
            this.diffData = null;
            /**
             * Whether to use diff.
             */
            this.hasDiff = false;
            this.filterExecutor = '';
            this.filterType = '';
            this.filterOperation = '';
            this.totalOperations = '';
            this.dataProvider = new StatsTableDataProvider();
            this.dataInfo = {
                data: null,
                dataProvider: this.dataProvider,
            };
        }
        /**
         * @return {?}
         */
        StatsTable.prototype.ngOnInit = function () {
            var _this = this;
            this.dataProvider.setTotalOperationsChangedEventListener(( /**
             * @param {?} totalOperations
             * @return {?}
             */function (totalOperations) {
                _this.totalOperations = totalOperations;
            }));
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        StatsTable.prototype.ngOnChanges = function (changes) {
            this.dataProvider.hasDiff = this.hasDiff;
            if (this.hasDiff && this.diffData) {
                this.dataProvider.setDiffData(this.diffData);
            }
            this.dataInfo = Object.assign({}, this.dataInfo, { data: this.tensorflowStatsData });
        };
        /**
         * @return {?}
         */
        StatsTable.prototype.updateFilters = function () {
            /** @type {?} */
            var filters = [];
            if (this.filterExecutor.trim()) {
                /** @type {?} */
                var filter_4 = this.filterExecutor.trim().toLowerCase();
                filters.push({
                    'column': DATA_TABLE_EXECUTOR_INDEX,
                    'test': ( /**
                     * @param {?} value
                     * @return {?}
                     */function (value) { return value.toLowerCase().indexOf(filter_4) >= 0; }),
                });
            }
            if (this.filterType.trim()) {
                /** @type {?} */
                var filter_5 = this.filterType.trim().toLowerCase();
                filters.push({
                    'column': DATA_TABLE_TYPE_INDEX,
                    'test': ( /**
                     * @param {?} value
                     * @return {?}
                     */function (value) { return value.toLowerCase().indexOf(filter_5) >= 0; }),
                });
            }
            if (this.filterOperation.trim()) {
                /** @type {?} */
                var filter_6 = this.filterOperation.trim().toLowerCase();
                filters.push({
                    'column': DATA_TABLE_OPERATION_INDEX$1,
                    'test': ( /**
                     * @param {?} value
                     * @return {?}
                     */function (value) { return value.toLowerCase().indexOf(filter_6) >= 0; }),
                });
            }
            this.dataProvider.setFilters(filters);
        };
        return StatsTable;
    }());
    StatsTable.decorators = [
        { type: Component, args: [{
                    selector: 'stats-table',
                    template: "<div>\n  <div class=\"mat-headline\">TensorFlow operations</div>\n  <mat-form-field>\n    <input\n           matInput\n           placeholder=\"Host/device\"\n           [value]=\"filterExecutor\"\n           (input)=\"filterExecutor = $event.target.value; updateFilters();\">\n    <mat-icon matSuffix>search</mat-icon>\n  </mat-form-field>\n  <mat-form-field>\n    <input\n           matInput\n           placeholder=\"Type\"\n           [value]=\"filterType\"\n           (input)=\"filterType = $event.target.value; updateFilters();\">\n    <mat-icon matSuffix>search</mat-icon>\n  </mat-form-field>\n  <mat-form-field>\n    <input\n           matInput\n           placeholder=\"Operation\"\n           [value]=\"filterOperation\"\n           (input)=\"filterOperation = $event.target.value; updateFilters();\">\n    <mat-icon matSuffix>search</mat-icon>\n  </mat-form-field>\n</div>\n<div *ngIf=\"totalOperations\">\n  Note: To avoid sluggishness, only the 1000 most time-consuming operations out of the total\n  {{totalOperations}} operations are shown in the table below.\n</div>\n<br *ngIf=\"totalOperations && hasDiff\">\n<div *ngIf=\"hasDiff\">\n  Note: For diff tool, the main table is pre-ordered by the Avg. self-time absolute difference in\n  descending order. Each entry is shown as baseline(difference), while difference is converted to\n  percentage w.r.t baseline if applicable.\n</div>\n<br>\n<chart class=\"table\" chartType=\"Table\" [dataInfo]=\"dataInfo\"></chart>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}:host{display:block;padding:20px}mat-form-field{margin:0 8px}mat-icon{color:#777;vertical-align:bottom}.table{border:1px solid #eee}\n"]
                }] }
    ];
    StatsTable.propDecorators = {
        tensorflowStatsData: [{ type: Input }],
        diffData: [{ type: Input }],
        hasDiff: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var StatsTableModule = /** @class */ (function () {
        function StatsTableModule() {
        }
        return StatsTableModule;
    }());
    StatsTableModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [StatsTable],
                    imports: [
                        CommonModule,
                        MatFormFieldModule,
                        MatIconModule,
                        MatInputModule,
                        ChartModule,
                    ],
                    exports: [StatsTable],
                },] }
    ];
    /** A category diff table data processor. */
    var CategoryDiffTableDataProcessor = /** @class */ (function () {
        function CategoryDiffTableDataProcessor(diffData, filters, gColumn, vColumn) {
            this.diffData = diffData;
            this.filters = filters;
            this.gColumn = gColumn;
            this.vColumn = vColumn;
        }
        CategoryDiffTableDataProcessor.prototype.process = function (dataProvider) {
            if (!dataProvider) {
                return null;
            }
            var dataTable = dataProvider.getDataTable();
            if (!dataTable) {
                return null;
            }
            var diffTable = new google.visualization.DataTable(this.diffData);
            if (!diffTable) {
                return null;
            }
            var chart = dataProvider.getChart();
            if (!chart) {
                return null;
            }
            return computeCategoryDiffTable(computeGroupView(dataTable, this.filters, this.gColumn, this.vColumn), computeGroupView(diffTable, this.filters, this.gColumn, this.vColumn), chart);
        };
        return CategoryDiffTableDataProcessor;
    }());
    /** A category table data processor. */
    var CategoryTableDataProcessor = /** @class */ (function () {
        function CategoryTableDataProcessor(filters, gColumn, vColumn) {
            this.filters = filters;
            this.gColumn = gColumn;
            this.vColumn = vColumn;
        }
        CategoryTableDataProcessor.prototype.process = function (dataProvider) {
            if (!dataProvider) {
                return null;
            }
            var dataTable = dataProvider.getDataTable();
            if (!dataTable) {
                return null;
            }
            return computeGroupView(dataTable, this.filters, this.gColumn, this.vColumn);
        };
        return CategoryTableDataProcessor;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ɵ0$l = [];
    /**
     * Initial state object
     * @type {?}
     */
    var INIT_TENSORFLOW_STATS_STATE = {
        data: ɵ0$l,
        diffData: [],
        hasDiff: false,
        showPprofLink: false,
        showFlopRateChart: false,
        showModelProperties: false,
        title: '',
    };
    /**
     * Feature key for store
     * @type {?}
     */
    var TENSORFLOW_STATS_STORE_KEY = 'tensorflow_stats';
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var tensorFlowStatsState = createFeatureSelector(TENSORFLOW_STATS_STORE_KEY);
    var ɵ0$m = /**
     * @param {?} tensorFlowStatsState
     * @return {?}
     */ function (tensorFlowStatsState) { return tensorFlowStatsState.data; };
    /**
     * Selector for data property
     * @type {?}
     */
    var getDataState = createSelector(tensorFlowStatsState, (ɵ0$m));
    var ɵ1$8 = /**
     * @param {?} tensorFlowStatsState
     * @return {?}
     */ function (tensorFlowStatsState) { return tensorFlowStatsState.diffData; };
    /**
     * Selector for diffData property
     * @type {?}
     */
    var getDiffDataState = createSelector(tensorFlowStatsState, (ɵ1$8));
    var ɵ2$4 = /**
     * @param {?} tensorFlowStatsState
     * @return {?}
     */ function (tensorFlowStatsState) { return tensorFlowStatsState.hasDiff; };
    /**
     * Selector for hasDiff property
     * @type {?}
     */
    var getHasDiffState = createSelector(tensorFlowStatsState, (ɵ2$4));
    var ɵ3$3 = /**
     * @param {?} tensorFlowStatsState
     * @return {?}
     */ function (tensorFlowStatsState) { return tensorFlowStatsState.showPprofLink; };
    /**
     * Selector for showPprofLink property
     * @type {?}
     */
    var getShowPprofLinkState = createSelector(tensorFlowStatsState, (ɵ3$3));
    var ɵ4$2 = /**
     * @param {?} tensorFlowStatsState
     * @return {?}
     */ function (tensorFlowStatsState) { return tensorFlowStatsState.showFlopRateChart; };
    /**
     * Selector for showFlopRateChart property
     * @type {?}
     */
    var getShowFlopRateChartState = createSelector(tensorFlowStatsState, (ɵ4$2));
    var ɵ5$2 = /**
     * @param {?} tensorFlowStatsState
     * @return {?}
     */ function (tensorFlowStatsState) { return tensorFlowStatsState.showModelProperties; };
    /**
     * Selector for showModelProperties property
     * @type {?}
     */
    var getShowModelPropertiesState = createSelector(tensorFlowStatsState, (ɵ5$2));
    var ɵ6$2 = /**
     * @param {?} tensorFlowStatsState
     * @return {?}
     */ function (tensorFlowStatsState) { return tensorFlowStatsState.title; };
    /**
     * Selector for title property
     * @type {?}
     */
    var getTitleState = createSelector(tensorFlowStatsState, (ɵ6$2));
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var OP_EXECUTOR_ID = 'host_or_device';
    /** @type {?} */
    var OP_TYPE_ID = 'type';
    /** @type {?} */
    var OP_NAME_ID = 'operation';
    /** @type {?} */
    var SELF_TIME_ID = 'total_self_time';
    /** @type {?} */
    var MEASURED_FLOP_RATE_ID = 'measured_flop_rate';
    /**
     * A TensorFlow Stats component.
     */
    var TensorflowStats = /** @class */ (function () {
        /**
         * @param {?} store
         */
        function TensorflowStats(store) {
            var _this = this;
            this.store = store;
            this.data = null;
            this.diffData = null;
            this.selectedData = null;
            this.selectedDiffData = null;
            this.idleMenuButtonLabel = "No" /* NO */;
            this.idleOptionItems = ["Yes" /* YES */, "No" /* NO */];
            this.opExecutorDevice = "Device" /* DEVICE */;
            this.opExecutorHost = "Host" /* HOST */;
            this.opKindName = "Name" /* NAME */;
            this.opKindType = "Type" /* TYPE */;
            this.opType = "TensorFlow" /* TENSORFLOW */;
            this.title = '';
            this.architecture = '';
            this.task = '';
            this.devicePprofLink = '';
            this.hostPprofLink = '';
            this.hasDeviceData = false;
            this.hasDiff = false;
            this.showFlopRateChart = false;
            this.flopRateChartXColumn = -1;
            this.flopRateChartYColumn = -1;
            this.showModelProperties = false;
            this.showPprofLink = false;
            this.dataProvider = new DefaultDataProvider();
            this.dataInfoDeviceByType = {
                data: null,
                dataProvider: this.dataProvider,
                options: PIE_CHART_OPTIONS,
            };
            this.dataInfoDeviceByName = {
                data: null,
                dataProvider: this.dataProvider,
                options: PIE_CHART_OPTIONS,
            };
            this.dataInfoHostByType = {
                data: null,
                dataProvider: this.dataProvider,
                options: PIE_CHART_OPTIONS,
            };
            this.dataInfoHostByName = {
                data: null,
                dataProvider: this.dataProvider,
                options: PIE_CHART_OPTIONS,
            };
            this.store.select(getTitleState).subscribe(( /**
             * @param {?} title
             * @return {?}
             */function (title) {
                _this.title = title || '';
            }));
            this.store.select(getHasDiffState).subscribe(( /**
             * @param {?} hasDiff
             * @return {?}
             */function (/**
             * @param {?} hasDiff
             * @return {?}
             */ hasDiff) {
                _this.hasDiff = Boolean(hasDiff);
            }));
            this.store.select(getShowFlopRateChartState)
                .subscribe(( /**
         * @param {?} showFlopRateChart
         * @return {?}
         */function (/**
         * @param {?} showFlopRateChart
         * @return {?}
         */ showFlopRateChart) {
                _this.showFlopRateChart = Boolean(showFlopRateChart);
            }));
            this.store.select(getShowModelPropertiesState)
                .subscribe(( /**
         * @param {?} showModelProperties
         * @return {?}
         */function (/**
         * @param {?} showModelProperties
         * @return {?}
         */ showModelProperties) {
                _this.showModelProperties = Boolean(showModelProperties);
            }));
            this.store.select(getShowPprofLinkState)
                .subscribe(( /**
         * @param {?} showPprofLink
         * @return {?}
         */function (/**
         * @param {?} showPprofLink
         * @return {?}
         */ showPprofLink) {
                _this.showPprofLink = Boolean(showPprofLink);
            }));
            this.store.select(getDiffDataState)
                .subscribe(( /**
         * @param {?} diffData
         * @return {?}
         */function (diffData) {
                _this.diffData = (diffData || []);
                _this.setIdleOption();
            }));
            this.store.select(getDataState)
                .subscribe(( /**
         * @param {?} data
         * @return {?}
         */function (data) {
                _this.data = (data || []);
                _this.setIdleOption();
            }));
        }
        /**
         * @param {?=} option
         * @return {?}
         */
        TensorflowStats.prototype.setIdleOption = function (option /* NO */) {
            if (option === void 0) { option = "No"; }
            this.idleMenuButtonLabel = option;
            if ((!this.data || this.data.length === 0) ||
                (this.hasDiff && (!this.diffData || this.diffData.length === 0))) {
                this.selectedData = null;
                this.selectedDiffData = null;
                return;
            }
            if (option === "Yes" /* YES */) {
                this.selectedData = this.data[0] || null;
                if (this.hasDiff && this.diffData) {
                    this.selectedDiffData = this.diffData[0] || null;
                }
            }
            else {
                this.selectedData = this.data[1] || null;
                if (this.hasDiff && this.diffData) {
                    this.selectedDiffData = this.diffData[1] || null;
                }
            }
            // Four charts share one DataProvider. In order to prevent DataTable from
            // being created 4 times, it calls DataProvider function directly.
            this.dataProvider.parseData(this.selectedData);
            /** @type {?} */
            var dataTable = this.dataProvider.getDataTable();
            /** @type {?} */
            var opTypeIndex = -1;
            /** @type {?} */
            var opNameIndex = -1;
            /** @type {?} */
            var selfTimeIndex = -1;
            /** @type {?} */
            var opExecutorIndex = -1;
            if (dataTable && dataTable.getColumnIndex) {
                this.flopRateChartXColumn = dataTable.getColumnIndex(OP_NAME_ID);
                this.flopRateChartYColumn =
                    dataTable.getColumnIndex(MEASURED_FLOP_RATE_ID);
                opTypeIndex = dataTable.getColumnIndex(OP_TYPE_ID);
                opNameIndex = dataTable.getColumnIndex(OP_NAME_ID);
                selfTimeIndex = dataTable.getColumnIndex(SELF_TIME_ID);
                opExecutorIndex = dataTable.getColumnIndex(OP_EXECUTOR_ID);
            }
            /** @type {?} */
            var filtersForDevice = [{ column: opExecutorIndex, value: "Device" /* DEVICE */ }];
            /** @type {?} */
            var filtersForHost = [{ column: opExecutorIndex, value: "Host" /* HOST */ }];
            this.dataInfoDeviceByType.customChartDataProcessor = this.selectedDiffData ?
                new CategoryDiffTableDataProcessor(this.selectedDiffData, filtersForDevice, opTypeIndex, selfTimeIndex) :
                new CategoryTableDataProcessor(filtersForDevice, opTypeIndex, selfTimeIndex);
            this.dataInfoDeviceByName.customChartDataProcessor =
                new CategoryTableDataProcessor(filtersForDevice, opNameIndex, selfTimeIndex);
            this.dataInfoHostByType.customChartDataProcessor = this.selectedDiffData ?
                new CategoryDiffTableDataProcessor(this.selectedDiffData, filtersForHost, opTypeIndex, selfTimeIndex) :
                new CategoryTableDataProcessor(filtersForHost, opTypeIndex, selfTimeIndex);
            this.dataInfoHostByName.customChartDataProcessor =
                new CategoryTableDataProcessor(filtersForHost, opNameIndex, selfTimeIndex);
            // Since the DataInfo has not been updated, the notifyCharts function is
            // called to redraw the graph.
            this.dataProvider.notifyCharts();
            if (this.selectedData && this.selectedData.p) {
                this.architecture = this.selectedData.p.architecture_type || '';
                this.task = this.selectedData.p.task_type || '';
                this.devicePprofLink = this.selectedData.p.device_tf_pprof_link || '';
                this.hostPprofLink = this.selectedData.p.host_tf_pprof_link || '';
            }
            this.hasDeviceData = false;
            if (this.selectedData && this.selectedData.rows) {
                this.hasDeviceData = !!this.selectedData.rows.find(( /**
                 * @param {?} row
                 * @return {?}
                 */function (/**
                 * @param {?} row
                 * @return {?}
                 */ row) {
                    return row && row.c && row.c[1] && row.c[1].v === "Device" /* DEVICE */;
                }));
            }
        };
        return TensorflowStats;
    }());
    TensorflowStats.decorators = [
        { type: Component, args: [{
                    selector: 'tensorflow-stats',
                    template: "<div class=\"section-container\">\n  <div class=\"row\">\n    <div>\n      <div class=\"mat-headline\">{{title}}</div>\n      <div class=\"header-content\">\n        <div class=\"description\">\n          (1) In the charts and table below, \"IDLE\" represents the portion of the total execution\n          time on device (or host) that is idle.\n        </div>\n        <div class=\"description\">\n          (2) In the pie charts, the \"Other\" sector represents the sum of sectors that are too small\n          to be shown individually.\n        </div>\n      </div>\n    </div>\n    <div class=\"flex-space\"></div>\n    <export-as-csv tool=\"tensorflow_stats\"></export-as-csv>\n  </div>\n\n  <br>\n\n  <div class=\"mat-title\">Include IDLE time in statistics</div>\n\n  <mat-menu #idleOptions=\"matMenu\">\n    <button mat-menu-item\n            *ngFor=\"let option of idleOptionItems\"\n            (click)=\"setIdleOption(option)\"\n            [disabled]=\"idleMenuButtonLabel == option\">\n      {{option}}\n    </button>\n  </mat-menu>\n\n  <div class=\"idle-button-container\">\n    <button mat-raised-button [matMenuTriggerFor]=\"idleOptions\">\n      {{idleMenuButtonLabel}}\n      <mat-icon>arrow_drop_down</mat-icon>\n    </button>\n  </div>\n\n  <br>\n\n  <div class=\"row\" *ngIf=\"hasDeviceData\">\n    <div class=\"pie-chart\">\n      <div class=\"mat-title\">ON DEVICE: TOTAL SELF-TIME (GROUPED BY TYPE)</div>\n      <div class=\"description\">\n        (in microseconds) of a TensorFlow operation type\n      </div>\n      <chart chartType=\"PieChart\" [dataInfo]=\"dataInfoDeviceByType\"></chart>\n    </div>\n    <div class=\"pie-chart\" *ngIf=\"!hasDiff\">\n      <div class=\"mat-title\">ON DEVICE: TOTAL SELF-TIME</div>\n      <div class=\"description\">\n        (in microseconds) of a TensorFlow operation\n      </div>\n      <chart chartType=\"PieChart\" [dataInfo]=\"dataInfoDeviceByName\"></chart>\n    </div>\n    <flop-rate-chart [data]=\"selectedData\" [xColumn]=\"flopRateChartXColumn\"\n                     [yColumn]=\"flopRateChartYColumn\" [opType]=\"opType\"\n                     *ngIf=\"showFlopRateChart && !hasDiff\">\n    </flop-rate-chart>\n  </div>\n\n  <div class=\"row\">\n    <div class=\"pie-chart\">\n      <div class=\"mat-title\">ON HOST: TOTAL SELF-TIME (GROUPED BY TYPE)</div>\n      <div class=\"description\">\n        (in microseconds) of a TensorFlow operation type\n      </div>\n      <chart chartType=\"PieChart\" [dataInfo]=\"dataInfoHostByType\"></chart>\n    </div>\n    <div class=\"pie-chart\" *ngIf=\"!hasDiff\">\n      <div class=\"mat-title\">ON HOST: TOTAL SELF-TIME</div>\n      <div class=\"description\">\n        (in microseconds) of a TensorFlow operation\n      </div>\n      <chart chartType=\"PieChart\" [dataInfo]=\"dataInfoHostByName\"></chart>\n    </div>\n    <model-properties [architecture]=\"architecture\"\n                      [task]=\"task\"\n                      *ngIf=\"showModelProperties\">\n    </model-properties>\n  </div>\n\n</div>\n\n<mat-divider></mat-divider>\n\n<stats-table [tensorflowStatsData]=\"selectedData\"\n             [diffData]=\"selectedDiffData\"\n             [hasDiff]=\"hasDiff\">\n</stats-table>\n\n<mat-divider></mat-divider>\n\n<div *ngIf=\"hasDeviceData\">\n  <div *ngIf=\"showPprofLink\">\n    <div class=\"section-container\">\n      <div class=\"mat-headline\">Pprof for Device-side TensorFlow operations</div>\n      <div [innerHtml]=\"devicePprofLink\"></div>\n    </div>\n\n    <mat-divider></mat-divider>\n  </div>\n\n  <operations-table [tensorflowStatsData]=\"selectedData\"\n                    [diffData]=\"selectedDiffData\"\n                    [hasDiff]=\"hasDiff\"\n                    [opExecutor]=\"opExecutorDevice\">\n  </operations-table>\n\n  <mat-divider></mat-divider>\n</div>\n\n<div *ngIf=\"showPprofLink\">\n  <div class=\"section-container\">\n    <div class=\"mat-headline\">Pprof for Host-side TensorFlow operations</div>\n    <div [innerHtml]=\"hostPprofLink\"></div>\n  </div>\n\n  <mat-divider></mat-divider>\n</div>\n\n<operations-table [tensorflowStatsData]=\"selectedData\"\n                  [diffData]=\"selectedDiffData\"\n                  [hasDiff]=\"hasDiff\"\n                  [opExecutor]=\"opExecutorHost\">\n</operations-table>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}:host{display:block}.section-container{padding:20px}.header-content{font-style:italic;margin-top:-16px}.row{display:flex}.flex-space{flex:1}.mat-raised-button{box-shadow:none;border:1px solid #000;border-radius:0;color:#777}.idle-button-container{margin-top:-16px}model-properties{min-width:550px}.pie-chart{width:450px;height:fit-content;margin:8px 8px 8px 0}.pie-chart .description{margin-top:-16px}\n"]
                }] }
    ];
    /** @nocollapse */
    TensorflowStats.ctorParameters = function () { return [
        { type: Store }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * An op profile module.
     */
    var TensorflowStatsModule = /** @class */ (function () {
        function TensorflowStatsModule() {
        }
        return TensorflowStatsModule;
    }());
    TensorflowStatsModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [TensorflowStats],
                    imports: [
                        CommonModule,
                        MatButtonModule,
                        MatDividerModule,
                        MatIconModule,
                        MatMenuModule,
                        ChartModule,
                        ExportAsCsvModule,
                        FlopRateChartModule,
                        ModelPropertiesModule,
                        OperationsTableModule,
                        StatsTableModule,
                    ],
                    exports: [TensorflowStats]
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * An overview adapter component.
     */
    var TensorflowStatsAdapter = /** @class */ (function () {
        /**
         * @param {?} route
         * @param {?} store
         */
        function TensorflowStatsAdapter(route, store) {
            var _this = this;
            this.store = store;
            /**
             * Handles on-destroy Subject, used to unsubscribe.
             */
            this.destroyed = new ReplaySubject(1);
            route.params.pipe(takeUntil(this.destroyed)).subscribe(( /**
             * @param {?} params
             * @return {?}
             */function (params) {
                _this.update(( /** @type {?} */(params)));
            }));
            this.store.dispatch(setTitleAction({ title: 'TensorFlow Stats' }));
        }
        /**
         * @param {?} event
         * @return {?}
         */
        TensorflowStatsAdapter.prototype.update = function (event) {
            /** @type {?} */
            var params = {
                run: event.run || '',
                tag: event.tag || 'tensorflow_stats',
                host: event.host || '',
            };
            this.store.dispatch(setDataRequestStateAction({ dataRequest: { type: 3 /* TENSORFLOW_STATS */, params: params } }));
        };
        /**
         * @return {?}
         */
        TensorflowStatsAdapter.prototype.ngOnDestroy = function () {
            // Unsubscribes all pending subscriptions.
            this.destroyed.next();
            this.destroyed.complete();
        };
        return TensorflowStatsAdapter;
    }());
    TensorflowStatsAdapter.decorators = [
        { type: Component, args: [{
                    selector: 'tensorflow-stats-adapter',
                    template: '<tensorflow-stats></tensorflow-stats>'
                }] }
    ];
    /** @nocollapse */
    TensorflowStatsAdapter.ctorParameters = function () { return [
        { type: ActivatedRoute },
        { type: Store }
    ]; };
    var TensorflowStatsAdapterModule = /** @class */ (function () {
        function TensorflowStatsAdapterModule() {
        }
        return TensorflowStatsAdapterModule;
    }());
    TensorflowStatsAdapterModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [TensorflowStatsAdapter],
                    imports: [TensorflowStatsModule],
                    exports: [TensorflowStatsAdapter]
                },] }
    ];
    /** A base class for a google-charts dashboard. */
    var Dashboard = /** @class */ (function () {
        function Dashboard() {
            // Columns from dataTable visible in dataView.
            // If empty, all columns from dataTable are shown.
            this.columns = [];
            // Filters for selecting rows from dataTable to show in dataView.
            // If empty, all rows from dataTable are shown.
            this.filters = new Map();
        }
        Dashboard.prototype.parseData = function (data) {
            if (!data)
                return;
            this.dataTable = new google.visualization.DataTable(data);
            this.updateView();
        };
        Dashboard.prototype.updateFilters = function (filter) {
            if (filter.column === -1) {
                return;
            }
            if ('value' in filter || 'minValue' in filter || 'maxValue' in filter ||
                'test' in filter) {
                this.filters.set(filter.column, filter);
            }
            else {
                this.filters.delete(filter.column);
            }
            this.updateView();
        };
        Dashboard.prototype.updateView = function () {
            if (!this.dataTable) {
                return;
            }
            var dataView = new google.visualization.DataView(this.dataTable);
            if (this.columns.length !== 0) {
                dataView.setColumns(this.columns);
            }
            if (this.filters.size !== 0) {
                dataView.setRows(this.dataTable.getFilteredRows(this.getFilters()));
            }
            this.dataView = dataView;
        };
        Dashboard.prototype.getFilters = function () {
            return Array.from(this.filters.values());
        };
        return Dashboard;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var EVENT_DATA_INDEX = 0;
    /** @type {?} */
    var SUMMARY_DATA_INDEX = 1;
    /** @type {?} */
    var BOTTLENECK_DATA_INDEX = 2;
    /** @type {?} */
    var NAME_COLUMN_INDEX = 3;
    /** @type {?} */
    var PARENT_COLUMN_INDEX = 4;
    /** @type {?} */
    var BLOCKING_COLUMN_INDEX = 5;
    /** @type {?} */
    var BLOCKING_TYPE = 1;
    /** @type {?} */
    var BOTTLENECK_TYPE = 2;
    /** @type {?} */
    var IS_INPUT_BOUND_TABLE_PROPERTY_NAME = 'is_input_bound';
    /** @type {?} */
    var SUMMARY_MESSAGE_TABLE_PROPERTY_NAME = 'summary_message';
    /** @type {?} */
    var TRUE_STR = 'true';
    /**
     * A tf data bottleneck analysis component.
     */
    var TfDataBottleneckAnalysis = /** @class */ (function (_super) {
        __extends(TfDataBottleneckAnalysis, _super);
        /**
         * @param {?} route
         * @param {?} dataService
         * @param {?} store
         */
        function TfDataBottleneckAnalysis(route, dataService, store) {
            var _this = _super.call(this) || this;
            _this.dataService = dataService;
            _this.store = store;
            /**
             * Handles on-destroy Subject, used to unsubscribe.
             */
            _this.destroyed = new ReplaySubject(1);
            _this.isInputBound = false;
            route.params.pipe(takeUntil(_this.destroyed)).subscribe(( /**
             * @param {?} params
             * @return {?}
             */function (params) {
                _this.update(( /** @type {?} */(params)));
            }));
            return _this;
        }
        /**
         * @return {?}
         */
        TfDataBottleneckAnalysis.prototype.styleOrgChart = function () {
            if (this.dataTable) {
                for (var i_205 = 0; i_205 < this.dataTable.getNumberOfRows(); ++i_205) {
                    /** @type {?} */
                    var type = this.dataTable.getValue(i_205, BLOCKING_COLUMN_INDEX);
                    switch (type) {
                        case BLOCKING_TYPE:
                            this.dataTable.setRowProperty(i_205, 'style', 'border: 4px solid black');
                            break;
                        case BOTTLENECK_TYPE:
                            this.dataTable.setRowProperty(i_205, 'style', 'border: 4px solid red');
                            break;
                        default:
                            this.dataTable.setRowProperty(i_205, 'style', 'border: 4px dashed gray');
                            break;
                    }
                }
            }
        };
        /**
         * @param {?} event
         * @return {?}
         */
        TfDataBottleneckAnalysis.prototype.update = function (event) {
            var _this = this;
            this.store.dispatch(setLoadingStateAction({
                loadingState: {
                    loading: true,
                    message: 'Loading data',
                }
            }));
            this.dataService
                .getData(event.run || '', event.tag || 'tf_data_bottleneck_analysis', event.host || '')
                .pipe(takeUntil(this.destroyed))
                .subscribe(( /**
         * @param {?} data
         * @return {?}
         */function (data) {
                _this.store.dispatch(setLoadingStateAction({
                    loadingState: {
                        loading: false,
                        message: '',
                    }
                }));
                if (data) {
                    /** @type {?} */
                    var d_2 = ( /** @type {?} */(data));
                    _this.parseData(d_2[EVENT_DATA_INDEX]);
                    _this.styleOrgChart();
                    _this.summaryDataTable =
                        new google.visualization.DataTable(d_2[SUMMARY_DATA_INDEX]);
                    _this.summaryDataView =
                        new google.visualization.DataView(_this.summaryDataTable);
                    _this.bottleneckDataTable =
                        new google.visualization.DataTable(d_2[BOTTLENECK_DATA_INDEX]);
                    _this.bottleneckDataView =
                        new google.visualization.DataView(_this.bottleneckDataTable);
                    if (_this.bottleneckDataTable.getTableProperty(IS_INPUT_BOUND_TABLE_PROPERTY_NAME) === TRUE_STR) {
                        _this.isInputBound = true;
                    }
                    _this.summaryMessage = _this.bottleneckDataTable.getTableProperty(SUMMARY_MESSAGE_TABLE_PROPERTY_NAME);
                }
            }));
        };
        /**
         * @return {?}
         */
        TfDataBottleneckAnalysis.prototype.updateView = function () {
            _super.prototype.updateView.call(this);
            if (!this.dataView) {
                return;
            }
            /** @type {?} */
            var orgChartDataView = new google.visualization.DataView(this.dataView);
            orgChartDataView.setColumns([NAME_COLUMN_INDEX, PARENT_COLUMN_INDEX]);
            this.orgChartDataView = orgChartDataView;
        };
        /**
         * @return {?}
         */
        TfDataBottleneckAnalysis.prototype.ngOnDestroy = function () {
            // Unsubscribes all pending subscriptions.
            this.destroyed.next();
            this.destroyed.complete();
        };
        return TfDataBottleneckAnalysis;
    }(Dashboard));
    TfDataBottleneckAnalysis.decorators = [
        { type: Component, args: [{
                    selector: 'tf-data-bottleneck-analysis',
                    template: "<div class=\"section-container\">\n  <div class=\"mat-h1\">Performance Analysis Summary</div>\n  <div>\n    <div class=\"mat-body\">\n      This tool is <em>experimental</em>. Please report an issue\n      <a href=\"https://github.com/tensorflow/profiler/issues\" target=\"blank\">here</a> if the\n      analysis result seems off.\n    </div>\n    <div class=\"mat-body\" [innerHTML]=\"summaryMessage\"></div>\n  </div>\n</div>\n\n<table *ngIf=\"isInputBound\" [dataView]=\"bottleneckDataView\"></table>\n\n<mat-divider></mat-divider>\n\n<div class=\"section-container\">\n  <div class=\"mat-h2\">Summary of All Input Pipelines</div>\n</div>\n\n<table [dataView]=\"summaryDataView\"></table>\n\n<mat-divider></mat-divider>\n\n<div class=\"section-container\">\n  <div class=\"mat-h2\">Input Pipeline Graph</div>\n  <div class=\"row\">\n    <div>\n      <category-filter\n        [dataTable]=\"dataTable\"\n        column=\"Host\"\n        (changed)=\"updateFilters($event)\"\n      >\n      </category-filter>\n      <category-filter\n        [dataTable]=\"dataTable\"\n        column=\"Input Pipeline\"\n        (changed)=\"updateFilters($event)\"\n      >\n      </category-filter>\n      <category-filter [dataTable]=\"dataTable\" column=\"Rank\" (changed)=\"updateFilters($event)\">\n      </category-filter>\n    </div>\n  </div>\n  <org-chart [dataView]=\"orgChartDataView\"></org-chart>\n</div>\n",
                    styles: [".section-container{padding:20px}.row{display:flex}.flex-space{flex:1}\n"]
                }] }
    ];
    /** @nocollapse */
    TfDataBottleneckAnalysis.ctorParameters = function () { return [
        { type: ActivatedRoute },
        { type: DataService },
        { type: Store }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A organization chart view component.
     */
    var OrgChart = /** @class */ (function () {
        function OrgChart() {
        }
        /**
         * @return {?}
         */
        OrgChart.prototype.ngOnInit = function () {
            this.loadGoogleChart();
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        OrgChart.prototype.ngOnChanges = function (changes) {
            this.drawChart();
        };
        /**
         * @return {?}
         */
        OrgChart.prototype.drawChart = function () {
            if (!this.chart || !this.dataView) {
                return;
            }
            /** @type {?} */
            var options = {
                allowHtml: true,
            };
            this.chart.draw(this.dataView, options);
        };
        /**
         * @return {?}
         */
        OrgChart.prototype.loadGoogleChart = function () {
            var _this = this;
            if (!google || !google.charts) {
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    _this.loadGoogleChart();
                }), 100);
            }
            google.charts.safeLoad({ 'packages': ['orgchart'] });
            google.charts.setOnLoadCallback(( /**
             * @return {?}
             */function () {
                _this.chart =
                    new google.visualization.OrgChart(_this.chartRef.nativeElement);
                _this.drawChart();
            }));
        };
        return OrgChart;
    }());
    OrgChart.decorators = [
        { type: Component, args: [{
                    selector: 'org-chart',
                    template: "<div #chart></div>\n",
                    styles: [":host{display:block;margin:0 16px}\n"]
                }] }
    ];
    OrgChart.propDecorators = {
        dataView: [{ type: Input }],
        chartRef: [{ type: ViewChild, args: ['chart', { static: false },] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * An organization chart view module.
     */
    var OrgChartModule = /** @class */ (function () {
        function OrgChartModule() {
        }
        return OrgChartModule;
    }());
    OrgChartModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [OrgChart],
                    imports: [],
                    exports: [OrgChart],
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A table view component.
     */
    var Table = /** @class */ (function () {
        function Table() {
            this.showRowNumber = false;
            this.page = 'disable';
            this.pageSize = 10;
            this.height = '150px';
        }
        /**
         * @return {?}
         */
        Table.prototype.ngOnInit = function () {
            this.loadGoogleChart();
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        Table.prototype.ngOnChanges = function (changes) {
            this.drawTable();
        };
        /**
         * @return {?}
         */
        Table.prototype.onResize = function () {
            /** @type {?} */
            var tableElement = this.tableRef.nativeElement.querySelector('table');
            if (tableElement) {
                this.height = String(Number(tableElement.clientHeight) + 20) + 'px';
            }
        };
        /**
         * @return {?}
         */
        Table.prototype.drawTable = function () {
            if (!this.table || !this.dataView) {
                return;
            }
            /** @type {?} */
            var options = {
                allowHtml: true,
                alternatingRowStyle: false,
                showRowNumber: this.showRowNumber,
                page: this.page,
                pageSize: this.pageSize,
                cssClassNames: {
                    'headerCell': 'google-chart-table-header-cell',
                    'tableCell': 'google-chart-table-table-cell',
                },
            };
            this.table.draw(this.dataView, options);
            this.onResize();
        };
        /**
         * @return {?}
         */
        Table.prototype.loadGoogleChart = function () {
            var _this = this;
            if (!google || !google.charts) {
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    _this.loadGoogleChart();
                }), 100);
            }
            google.charts.safeLoad({ 'packages': ['table'] });
            google.charts.setOnLoadCallback(( /**
             * @return {?}
             */function () {
                _this.table = new google.visualization.Table(_this.tableRef.nativeElement);
                _this.drawTable();
            }));
        };
        return Table;
    }());
    Table.decorators = [
        { type: Component, args: [{
                    selector: 'table',
                    template: "<div [style.height]=\"height\">\n  <div #table class=\"table\"></div>\n</div>\n",
                    styles: [":host{display:block;margin:0 16px}\n"]
                }] }
    ];
    Table.propDecorators = {
        dataView: [{ type: Input }],
        showRowNumber: [{ type: Input }],
        page: [{ type: Input }],
        pageSize: [{ type: Input }],
        tableRef: [{ type: ViewChild, args: ['table', { static: false },] }],
        onResize: [{ type: HostListener, args: ['window:resize',] }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A table view module.
     */
    var TableModule = /** @class */ (function () {
        function TableModule() {
        }
        return TableModule;
    }());
    TableModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [Table],
                    imports: [],
                    exports: [Table],
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A category filter component.
     * The options are all unique values in the given column of dataTable.
     * Each cell in the column contains one value or multiple values if a
     * valueSeparator is given.
     * Selects the rows that contain the value selected by the user.
     * If all is set, it is used as a value that selects all rows.
     */
    var CategoryFilter = /** @class */ (function () {
        function CategoryFilter() {
            this.column = -1;
            this.valueSeparator = '';
            this.all = '';
            this.initValue = '';
            this.columnIndex = -1;
            this.columnLabel = '';
            this.options = [];
            this.value = '';
            this.changed = new EventEmitter();
        }
        /**
         * @param {?} changes
         * @return {?}
         */
        CategoryFilter.prototype.ngOnChanges = function (changes) {
            this.processData();
        };
        /**
         * @return {?}
         */
        CategoryFilter.prototype.processData = function () {
            if (!this.dataTable || this.dataTable.getNumberOfRows() === 0) {
                return;
            }
            this.columnIndex = (( /** @type {?} */(this.dataTable)))
                .getColumnIndex(this.column);
            if (this.columnIndex !== -1) {
                this.columnLabel = this.dataTable.getColumnLabel(this.columnIndex);
                /** @type {?} */
                var values_1 = new Set();
                /** @type {?} */
                var numRows = this.dataTable.getNumberOfRows();
                for (var i_206 = 0; i_206 < numRows; ++i_206) {
                    /** @type {?} */
                    var v = this.dataTable.getValue(i_206, this.columnIndex);
                    if (v === null)
                        continue;
                    if (this.valueSeparator) {
                        (( /** @type {?} */(v))).split(this.valueSeparator).forEach(( /**
                         * @param {?} value
                         * @return {?}
                         */function (/**
                         * @param {?} value
                         * @return {?}
                         */ value) {
                            values_1.add(value);
                        }));
                    }
                    else {
                        values_1.add(v);
                    }
                }
                this.options = Array.from(values_1);
                if (this.dataTable.getColumnType(this.columnIndex) === 'number') {
                    this.options.sort(( /**
                     * @param {?} a
                     * @param {?} b
                     * @return {?}
                     */function (a, b) { return (( /** @type {?} */(a))) - (( /** @type {?} */(b))); }));
                }
                else {
                    this.options.sort();
                }
                if (this.all) {
                    this.options.unshift(this.all);
                }
                if (this.initValue) {
                    this.value = this.initValue;
                }
                else {
                    this.value = this.options[0];
                }
            }
            this.updateFilter();
        };
        /**
         * @return {?}
         */
        CategoryFilter.prototype.updateFilter = function () {
            var _this = this;
            if (!this.dataTable || this.dataTable.getNumberOfRows() === 0) {
                return;
            }
            /** @type {?} */
            var filter = { column: this.columnIndex };
            if (!this.all || this.value !== this.all) {
                if (this.valueSeparator) {
                    filter.test = ( /**
                     * @param {?} value
                     * @return {?}
                     */function (value) { return (_this.valueSeparator + value + _this.valueSeparator)
                        .toLowerCase()
                        .indexOf(_this.valueSeparator + _this.value.toString() +
                        _this.valueSeparator) !== -1; });
                }
                else {
                    filter.value = this.value;
                }
            }
            this.changed.emit(filter);
        };
        return CategoryFilter;
    }());
    CategoryFilter.decorators = [
        { type: Component, args: [{
                    selector: 'category-filter',
                    template: "<mat-form-field class=\"control\" *ngIf=\"columnLabel\">\n  <mat-label>{{columnLabel}}</mat-label>\n  <mat-select (selectionChange)=\"updateFilter()\" [(value)]=\"value\">\n    <mat-option *ngFor=\"let option of options\" [value]=\"option\">{{option}}</mat-option>\n  </mat-select>\n</mat-form-field>\n",
                    styles: [".control{width:120px;margin-right:8px}\n"]
                }] }
    ];
    CategoryFilter.propDecorators = {
        dataTable: [{ type: Input }],
        column: [{ type: Input }],
        valueSeparator: [{ type: Input }],
        all: [{ type: Input }],
        initValue: [{ type: Input }],
        changed: [{ type: Output }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A category filter module.
     */
    var CategoryFilterModule = /** @class */ (function () {
        function CategoryFilterModule() {
        }
        return CategoryFilterModule;
    }());
    CategoryFilterModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [CategoryFilter],
                    imports: [
                        CommonModule,
                        MatOptionModule,
                        MatFormFieldModule,
                        MatSelectModule,
                    ],
                    exports: [CategoryFilter],
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A tf data stats module.
     */
    var TfDataBottleneckAnalysisModule = /** @class */ (function () {
        function TfDataBottleneckAnalysisModule() {
        }
        return TfDataBottleneckAnalysisModule;
    }());
    TfDataBottleneckAnalysisModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [TfDataBottleneckAnalysis],
                    imports: [
                        CategoryFilterModule,
                        OrgChartModule,
                        TableModule,
                        MatDividerModule,
                        CommonModule,
                    ],
                    exports: [TfDataBottleneckAnalysis],
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A trace viewer component.
     */
    var TraceViewer = /** @class */ (function () {
        /**
         * @param {?} platformLocation
         * @param {?} route
         */
        function TraceViewer(platformLocation, route) {
            var _this = this;
            /**
             * Handles on-destroy Subject, used to unsubscribe.
             */
            this.destroyed = new ReplaySubject(1);
            this.url = '';
            this.pathPrefix = '';
            if (String(platformLocation.pathname).includes(API_PREFIX + PLUGIN_NAME)) {
                this.pathPrefix =
                    String(platformLocation.pathname).split(API_PREFIX + PLUGIN_NAME)[0];
            }
            route.params.pipe(takeUntil(this.destroyed)).subscribe(( /**
             * @param {?} params
             * @return {?}
             */function (params) {
                _this.update(( /** @type {?} */(params)));
            }));
        }
        /**
         * @param {?} event
         * @return {?}
         */
        TraceViewer.prototype.update = function (event) {
            /** @type {?} */
            var isStreaming = (event.tag === 'trace_viewer@');
            /** @type {?} */
            var params = new HttpParams()
                .set('run', event.run)
                .set('tag', event.tag)
                .set('host', event.host);
            /** @type {?} */
            var traceDataUrl = this.pathPrefix + DATA_API + '?' + params.toString();
            this.url = this.pathPrefix + API_PREFIX + PLUGIN_NAME +
                '/trace_viewer_index.html' +
                '?is_streaming=' + isStreaming.toString() +
                '&trace_data_url=' + encodeURIComponent(traceDataUrl);
        };
        /**
         * @return {?}
         */
        TraceViewer.prototype.ngOnDestroy = function () {
            // Unsubscribes all pending subscriptions.
            this.destroyed.next();
            this.destroyed.complete();
        };
        return TraceViewer;
    }());
    TraceViewer.decorators = [
        { type: Component, args: [{
                    selector: 'trace-viewer',
                    template: "<iframe [src]=\"url | safe\"></iframe>\n",
                    styles: ["iframe{position:absolute;width:100%;height:100%;box-sizing:border-box}\n"]
                }] }
    ];
    /** @nocollapse */
    TraceViewer.ctorParameters = function () { return [
        { type: PlatformLocation },
        { type: ActivatedRoute }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SafePipe = /** @class */ (function () {
        /**
         * @param {?} sanitizer
         */
        function SafePipe(sanitizer) {
            this.sanitizer = sanitizer;
        }
        /**
         * @param {?} url
         * @return {?}
         */
        SafePipe.prototype.transform = function (url) {
            return this.sanitizer.bypassSecurityTrustResourceUrl(url);
        };
        return SafePipe;
    }());
    SafePipe.decorators = [
        { type: Pipe, args: [{ name: 'safe' },] }
    ];
    /** @nocollapse */
    SafePipe.ctorParameters = function () { return [
        { type: DomSanitizer }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PipesModule = /** @class */ (function () {
        function PipesModule() {
        }
        return PipesModule;
    }());
    PipesModule.decorators = [
        { type: NgModule, args: [{ imports: [CommonModule], declarations: [SafePipe], exports: [SafePipe] },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A trace viewer module.
     */
    var TraceViewerModule = /** @class */ (function () {
        function TraceViewerModule() {
        }
        return TraceViewerModule;
    }());
    TraceViewerModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [TraceViewer],
                    imports: [PipesModule],
                    exports: [TraceViewer]
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A main page component.
     */
    var MainPage = /** @class */ (function () {
        /**
         * @param {?} router
         * @param {?} store
         */
        function MainPage(router, store) {
            var _this = this;
            this.router = router;
            /**
             * The tool datasets.
             */
            this.datasets = [];
            /**
             * Handles on-destroy Subject, used to unsubscribe.
             */
            this.destroyed = new ReplaySubject(1);
            this.loading = true;
            this.loadingMessage = '';
            store.select(getLoadingState)
                .pipe(takeUntil(this.destroyed))
                .subscribe(( /**
         * @param {?} loadingState
         * @return {?}
         */function (loadingState) {
                _this.loading = loadingState.loading;
                _this.loadingMessage = loadingState.message;
            }));
        }
        /**
         * @param {?} event
         * @return {?}
         */
        MainPage.prototype.updateTool = function (event) {
            this.loading = false;
            this.router.navigate([event.tag || 'empty', event]);
        };
        /**
         * @return {?}
         */
        MainPage.prototype.ngOnDestroy = function () {
            // Unsubscribes all pending subscriptions.
            this.destroyed.next();
            this.destroyed.complete();
        };
        return MainPage;
    }());
    MainPage.decorators = [
        { type: Component, args: [{
                    selector: 'main-page',
                    template: "<mat-sidenav-container fullscreen>\n  <mat-sidenav mode=\"side\" opened>\n    <sidenav [datasets]=\"datasets\" (update)=\"updateTool($event)\"></sidenav>\n  </mat-sidenav>\n  <mat-sidenav-content>\n    <div class=\"progress-container\" [hidden]=\"!loading\">\n      <div class=\"loading-message\">{{loadingMessage}}</div>\n      <mat-progress-bar color=\"primary\" mode=\"indeterminate\"></mat-progress-bar>\n    </div>\n    <div [className]=\"loading ? 'hidden-content' : 'full-height'\">\n      <router-outlet></router-outlet>\n    </div>\n  </mat-sidenav-content>\n</mat-sidenav-container>\n",
                    styles: [".horizontal-center{text-align:center}.full-width{width:100%}.full-height{height:100%}.auto-height{height:auto}.disabled{color:rgba(0,0,0,.26)}.hidden-content{height:0;overflow:hidden}.primary-content{color:#4a4a4a}.description{color:#5f6368;font-size:14px;font-style:italic}.item-container{padding:20px 20px 0}mat-sidenav-container{background-color:#fff}mat-sidenav{background:transparent;width:340px;border-right:1px solid #eee}mat-progress-bar{width:300px;margin:0 auto}.progress-container{padding:50px}.loading-message{width:fit-content;margin:0 auto}\n"]
                }] }
    ];
    /** @nocollapse */
    MainPage.ctorParameters = function () { return [
        { type: Router },
        { type: Store }
    ]; };
    MainPage.propDecorators = {
        datasets: [{ type: Input }]
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The list of all routes available in the application.
     * @type {?}
     */
    var routes = [
        { path: 'empty', component: EmptyPage },
        { path: 'overview_page', component: Overview },
        { path: 'overview_page@', component: Overview },
        { path: 'overview_page^', component: Overview },
        { path: 'input_pipeline_analyzer', component: InputPipeline },
        { path: 'input_pipeline_analyzer@', component: InputPipeline },
        { path: 'input_pipeline_analyzer^', component: InputPipeline },
        { path: 'kernel_stats', component: KernelStatsAdapter },
        { path: 'kernel_stats^', component: KernelStatsAdapter },
        { path: 'memory_profile#', component: MemoryProfile },
        { path: 'memory_profile^', component: MemoryProfile },
        { path: 'memory_viewer', component: MemoryViewer },
        { path: 'op_profile', component: OpProfile },
        { path: 'pod_viewer', component: PodViewer },
        { path: 'pod_viewer^', component: PodViewer },
        { path: 'tf_data_bottleneck_analysis^', component: TfDataBottleneckAnalysis },
        { path: 'tensorflow_stats', component: TensorflowStatsAdapter },
        { path: 'tensorflow_stats^', component: TensorflowStatsAdapter },
        { path: 'trace_viewer', component: TraceViewer },
        { path: 'trace_viewer#', component: TraceViewer },
        { path: 'trace_viewer@', component: TraceViewer },
        { path: 'trace_viewer^', component: TraceViewer },
        { path: '**', component: EmptyPage },
    ];
    /**
     * A main page module.
     */
    var MainPageModule = /** @class */ (function () {
        function MainPageModule() {
        }
        return MainPageModule;
    }());
    MainPageModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [MainPage],
                    imports: [
                        MatProgressBarModule,
                        MatSidenavModule,
                        EmptyPageModule,
                        SideNavModule,
                        TraceViewerModule,
                        OverviewModule,
                        InputPipelineModule,
                        KernelStatsAdapterModule,
                        MemoryProfileModule,
                        MemoryViewerModule,
                        OpProfileModule,
                        PodViewerModule,
                        TfDataBottleneckAnalysisModule,
                        TensorflowStatsAdapterModule,
                        RouterModule.forRoot(routes),
                    ],
                    exports: [MainPage]
                },] }
    ];
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Action to set kernel stats data property
     * @type {?}
     */
    var setKernelStatsDataAction = createAction('[Kernel Stats] Set data property', props());
    /** The data request queue class */
    var DataRequestQueue = /** @class */ (function () {
        function DataRequestQueue() {
            this.queue = [];
        }
        DataRequestQueue.prototype.getRepresentativeType = function (dataRequest) {
            if (!dataRequest) {
                return 0 /* UNKNOWN */;
            }
            if (dataRequest.type >= 1 /* DATA_REQUEST_BEGIN */ &&
                dataRequest.type <= 7 /* DIFF_DATA_REQUEST_END */) {
                return dataRequest.type;
            }
            return 0 /* UNKNOWN */;
        };
        DataRequestQueue.prototype.findIndexByType = function (dataRequest) {
            var type = this.getRepresentativeType(dataRequest);
            return this.queue.findIndex(function (dataRequestItem) { return dataRequestItem.type === type; });
        };
        DataRequestQueue.prototype.clear = function () {
            this.queue = [];
        };
        DataRequestQueue.prototype.empty = function () {
            return this.queue.length === 0;
        };
        DataRequestQueue.prototype.front = function () {
            return this.empty() ? null : this.queue[0];
        };
        DataRequestQueue.prototype.enqueue = function (dataRequest) {
            if (this.includesType(dataRequest)) {
                return;
            }
            var type = this.getRepresentativeType(dataRequest);
            if (type === 0 /* UNKNOWN */) {
                return;
            }
            this.queue.push({
                type: type,
                params: dataRequest.params,
            });
        };
        DataRequestQueue.prototype.dequeue = function (dataRequest) {
            var index = this.findIndexByType(dataRequest);
            if (index === -1) {
                return;
            }
            this.queue.splice(index, 1);
        };
        DataRequestQueue.prototype.includes = function (dataRequest) {
            var index = this.findIndexByType(dataRequest);
            if (index === -1) {
                return false;
            }
            var result = this.queue[index];
            if (!result) {
                return false;
            }
            var resultParamsEntries = Object.entries(result.params || {}).sort();
            var paramsEntries = Object.entries(dataRequest.params || {}).sort();
            return JSON.stringify(resultParamsEntries) ===
                JSON.stringify(paramsEntries);
        };
        DataRequestQueue.prototype.includesType = function (dataRequest) {
            return this.findIndexByType(dataRequest) !== -1;
        };
        return DataRequestQueue;
    }());
    /** Action to do noghint */
    var doNothingAction = createAction('Do nothing');
    /** The base class of data dispatcher. */
    var DataDispatcherBase = /** @class */ (function () {
        function DataDispatcherBase(store) {
            var _this = this;
            this.store = store;
            this.loadedQueue = new DataRequestQueue();
            this.loadingQueue = new DataRequestQueue();
            this.store.select(getDataRequest).subscribe(function (dataRequest) {
                _this.updateQueue(dataRequest);
            });
            this.store.select(getExportAsCsv).subscribe(function (tool) {
                _this.exportAsCsv(tool);
            });
        }
        DataDispatcherBase.prototype.checkAndRun = function () {
            var _this = this;
            if (this.loadingQueue.empty()) {
                this.store.dispatch(setLoadingStateAction({
                    loadingState: {
                        loading: false,
                        message: '',
                    }
                }));
            }
            else {
                setTimeout(function () {
                    _this.run();
                });
            }
        };
        DataDispatcherBase.prototype.clearData = function (dataRequest) { };
        DataDispatcherBase.prototype.exportAsCsv = function (tool) { };
        // tslint:disable-next-line:no-any
        DataDispatcherBase.prototype.getActions = function (dataRequest, data) {
            if (data === void 0) { data = null; }
            data = data || this.getDefaultData(dataRequest);
            if (dataRequest.type === 2 /* KERNEL_STATS */) {
                return setKernelStatsDataAction({ kernelStatsData: data });
            }
            else if (dataRequest.type === 3 /* TENSORFLOW_STATS */) {
                return setDataAction({ data: data });
            }
            else if (dataRequest.type === 6 /* TENSORFLOW_STATS_DIFF */) {
                return setDiffDataAction({ diffData: data });
            }
            return doNothingAction();
        };
        DataDispatcherBase.prototype.getDefaultData = function (dataRequest) {
            if (dataRequest.type === 3 /* TENSORFLOW_STATS */ ||
                dataRequest.type === 6 /* TENSORFLOW_STATS_DIFF */) {
                return [];
            }
            return {};
        };
        // tslint:disable-next-line:no-any
        DataDispatcherBase.prototype.load = function (dataRequest) {
            return of();
        };
        // tslint:disable-next-line:no-any
        DataDispatcherBase.prototype.parseData = function (dataRequest, data) { };
        DataDispatcherBase.prototype.run = function () {
            var _this = this;
            if (this.loadingQueue.empty()) {
                this.checkAndRun();
                return;
            }
            var dataRequest = this.loadingQueue.front();
            if (!dataRequest || !dataRequest.params) {
                return;
            }
            this.store.dispatch(setLoadingStateAction({
                loadingState: {
                    loading: true,
                    message: dataRequest.loadingMessage || 'Loading data',
                }
            }));
            this.load(dataRequest)
                .subscribe(function (data) {
                if (!_this.loadingQueue.includes(dataRequest)) {
                    _this.checkAndRun();
                    return;
                }
                _this.loadingQueue.dequeue(dataRequest);
                if (_this.loadedQueue.includesType(dataRequest)) {
                    _this.loadedQueue.dequeue(dataRequest);
                }
                _this.loadedQueue.enqueue(dataRequest);
                _this.parseData(dataRequest, data);
                _this.checkAndRun();
            }, function (error) {
                _this.loadingQueue.dequeue(dataRequest);
                _this.checkAndRun();
            });
        };
        DataDispatcherBase.prototype.updateQueue = function (dataRequest) {
            if (this.loadedQueue.includes(dataRequest)) {
                return;
            }
            if (this.loadedQueue.includesType(dataRequest)) {
                this.loadedQueue.dequeue(dataRequest);
                this.clearData(dataRequest);
            }
            if (this.loadingQueue.includes(dataRequest)) {
                return;
            }
            if (this.loadingQueue.includesType(dataRequest)) {
                this.loadingQueue.dequeue(dataRequest);
            }
            this.loadingQueue.enqueue(dataRequest);
            this.checkAndRun();
        };
        return DataDispatcherBase;
    }());
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The data dispatcher class.
     */
    var DataDispatcher = /** @class */ (function (_super) {
        __extends(DataDispatcher, _super);
        /**
         * @param {?} dataService
         * @param {?} store
         */
        function DataDispatcher(dataService, store) {
            var _this = _super.call(this, store) || this;
            _this.dataService = dataService;
            _this.params = {
                run: '',
                tag: '',
                host: '',
            };
            return _this;
        }
        /**
         * @param {?} dataRequest
         * @return {?}
         */
        DataDispatcher.prototype.clearData = function (dataRequest) {
            this.store.dispatch(this.getActions(dataRequest));
        };
        /**
         * @param {?} tool
         * @return {?}
         */
        DataDispatcher.prototype.exportAsCsv = function (tool) {
            if (!!tool && tool === this.params.tag) {
                this.dataService.exportDataAsCSV(this.params.run, this.params.tag, this.params.host);
            }
        };
        // tslint:disable-next-line:no-any
        /**
         * @param {?} dataRequest
         * @return {?}
         */
        DataDispatcher.prototype.load = function (dataRequest) {
            /** @type {?} */
            var run = dataRequest.params.run || '';
            /** @type {?} */
            var tag = dataRequest.params.tag || '';
            /** @type {?} */
            var host = dataRequest.params.host || '';
            if (dataRequest.type > 1 /* DATA_REQUEST_BEGIN */ &&
                dataRequest.type < 4 /* DATA_REQUEST_END */) {
                this.params.run = run;
                this.params.tag = tag;
                this.params.host = host;
            }
            return this.dataService.getData(run, tag, host);
        };
        // tslint:disable-next-line:no-any
        /**
         * @param {?} dataRequest
         * @param {?} data
         * @return {?}
         */
        DataDispatcher.prototype.parseData = function (dataRequest, data) {
            if (dataRequest.type === 2 /* KERNEL_STATS */) {
                data = (data || [{}])[0];
            }
            this.store.dispatch(this.getActions(dataRequest, data));
        };
        return DataDispatcher;
    }(DataDispatcherBase));
    DataDispatcher.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    DataDispatcher.ctorParameters = function () { return [
        { type: DataService },
        { type: Store }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ɵ0$n = /**
     * @param {?} state
     * @param {?} action
     * @return {?}
     */ function (state, action) {
        return Object.assign({}, state, { kernelStatsData: action.kernelStatsData });
    };
    /**
     * Reduce functions of common data store.
     * @type {?}
     */
    var reducer = createReducer(INIT_COMMON_DATA_STORE_STATE, on(setKernelStatsDataAction, (ɵ0$n)));
    /**
     * Common Data Store reducer
     * @param {?} state
     * @param {?} action
     * @return {?}
     */
    function commonDataStoreReducer(state, action) {
        return reducer(state, action);
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ɵ0$o = /**
     * @param {?} state
     * @param {?} action
     * @return {?}
     */ function (state, action) {
        return Object.assign({}, state, { data: action.data });
    }, ɵ1$9 = /**
     * @param {?} state
     * @param {?} action
     * @return {?}
     */ function (state, action) {
        return Object.assign({}, state, { diffData: action.diffData });
    }, ɵ2$5 = /**
     * @param {?} state
     * @param {?} action
     * @return {?}
     */ function (state, action) {
        return Object.assign({}, state, { hasDiff: action.hasDiff });
    }, ɵ3$4 = /**
     * @param {?} state
     * @param {?} action
     * @return {?}
     */ function (state, action) {
        return Object.assign({}, state, { showPprofLink: action.showPprofLink });
    }, ɵ4$3 = /**
     * @param {?} state
     * @param {?} action
     * @return {?}
     */ function (state, action) {
        return Object.assign({}, state, { showFlopRateChart: action.showFlopRateChart });
    }, ɵ5$3 = /**
     * @param {?} state
     * @param {?} action
     * @return {?}
     */ function (state, action) {
        return Object.assign({}, state, { showModelProperties: action.showModelProperties });
    }, ɵ6$3 = /**
     * @param {?} state
     * @param {?} action
     * @return {?}
     */ function (state, action) {
        return Object.assign({}, state, { title: action.title });
    };
    /**
     * Reduce functions of tensorflow stats.
     * @type {?}
     */
    var reducer$1 = createReducer(INIT_TENSORFLOW_STATS_STATE, on(setDataAction, (ɵ0$o)), on(setDiffDataAction, (ɵ1$9)), on(setHasDiffAction, (ɵ2$5)), on(setShowPprofLinkAction, (ɵ3$4)), on(setShowFlopRateChartAction, (ɵ4$3)), on(setShowModelPropertiesAction, (ɵ5$3)), on(setTitleAction, (ɵ6$3)));
    /**
     * Tensorflow Stats reducer
     * @param {?} state
     * @param {?} action
     * @return {?}
     */
    function tensorFlowStatsReducer(state, action) {
        return reducer$1(state, action);
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ɵ0$p = /**
     * @param {?} state
     * @param {?} action
     * @return {?}
     */ function (state, action) {
        return Object.assign({}, state, { memoryViewerState: Object.assign({}, state.memoryViewerState, { activeHeapObject: action.activeHeapObject }) });
    }, ɵ1$a = /**
     * @param {?} state
     * @param {?} action
     * @return {?}
     */ function (state, action) {
        return Object.assign({}, state, { opProfileState: Object.assign({}, state.opProfileState, { activeOpProfileNode: action.activeOpProfileNode }) });
    }, ɵ2$6 = /**
     * @param {?} state
     * @param {?} action
     * @return {?}
     */ function (state, action) {
        return Object.assign({}, state, { podViewerState: Object.assign({}, state.podViewerState, { activePodViewerInfo: action.activePodViewerInfo }) });
    }, ɵ3$5 = /**
     * @param {?} state
     * @param {?} action
     * @return {?}
     */ function (state, action) {
        return Object.assign({}, state, { capturingProfile: action.capturingProfile });
    }, ɵ4$4 = /**
     * @param {?} state
     * @param {?} action
     * @return {?}
     */ function (state, action) {
        return Object.assign({}, state, { loadingState: action.loadingState });
    }, ɵ5$4 = /**
     * @param {?} state
     * @param {?} action
     * @return {?}
     */ function (state, action) {
        return Object.assign({}, state, { currentTool: action.currentTool });
    }, ɵ6$4 = /**
     * @param {?} state
     * @param {?} action
     * @return {?}
     */ function (state, action) {
        return Object.assign({}, state, { dataRequest: action.dataRequest });
    }, ɵ7$2 = /**
     * @param {?} state
     * @param {?} action
     * @return {?}
     */ function (state, action) {
        return Object.assign({}, state, { exportAsCsv: '' });
    }, ɵ8$2 = /**
     * @param {?} state
     * @param {?} action
     * @return {?}
     */ function (state, action) {
        return Object.assign({}, state, { exportAsCsv: action.exportAsCsv });
    }, ɵ9$2 = /**
     * @param {?} state
     * @param {?} action
     * @return {?}
     */ function (state, action) {
        return Object.assign({}, state, { errorMessage: action.errorMessage });
    };
    /**
     * Reduce functions of app stats.
     * @type {?}
     */
    var reducer$2 = createReducer(INIT_APP_STATE, on(setActiveHeapObjectAction, (ɵ0$p)), on(setActiveOpProfileNodeAction, (ɵ1$a)), on(setActivePodViewerInfoAction, (ɵ2$6)), on(setCapturingProfileAction, (ɵ3$5)), on(setLoadingStateAction, (ɵ4$4)), on(setCurrentToolStateAction, (ɵ5$4)), on(setDataRequestStateAction, (ɵ6$4)), on(clearExportAsCsvStateAction, (ɵ7$2)), on(setExportAsCsvStateAction, (ɵ8$2)), on(setErrorMessageStateAction, (ɵ9$2)));
    /**
     * Reducer
     * @param {?} state
     * @param {?} action
     * @return {?}
     */
    function rootReducer(state, action) {
        return reducer$2(state, action);
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var RootStoreModule = /** @class */ (function () {
        function RootStoreModule() {
        }
        return RootStoreModule;
    }());
    RootStoreModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        StoreModule.forFeature(STORE_KEY, rootReducer),
                        StoreModule.forFeature(COMMON_DATA_STORE_KEY, commonDataStoreReducer),
                        StoreModule.forFeature(TENSORFLOW_STATS_STORE_KEY, tensorFlowStatsReducer),
                        StoreModule.forRoot({}),
                    ],
                },] }
    ];
    function consumeNumber(s, i) {
        var State = { NATURAL: 0, REAL: 1, EXPONENT_SIGN: 2, EXPONENT: 3 };
        var state = State.NATURAL;
        for (; i < s.length; i++) {
            if (state === State.NATURAL) {
                if (s[i] === '.') {
                    state = State.REAL;
                }
                else if (s[i] === 'e' || s[i] === 'E') {
                    state = State.EXPONENT_SIGN;
                }
                else if (!isDigit(s[i])) {
                    break;
                }
            }
            else if (state === State.REAL) {
                if (s[i] === 'e' || s[i] === 'E') {
                    state = State.EXPONENT_SIGN;
                }
                else if (!isDigit(s[i])) {
                    break;
                }
            }
            else if (state === State.EXPONENT_SIGN) {
                if (isDigit(s[i]) || s[i] === '+' || s[i] === '-') {
                    state = State.EXPONENT;
                }
                else {
                    break;
                }
            }
            else if (state === State.EXPONENT) {
                if (!isDigit(s[i])) {
                    break;
                }
            }
        }
        return i;
    }
    function isDigit(c) {
        return '0' <= c && c <= '9';
    }
    function isBreak(c) {
        return c === '/' || c === '_' || isDigit(c);
    }
    /**
     * Compares tag names asciinumerically broken into components.
     *
     * This is the comparison function used for sorting most string values in
     * TensorBoard. Unlike the standard asciibetical comparator, this function
     * knows that 'a10b' > 'a2b'. Fixed point and engineering notation are
     * supported. This function also splits the input by slash and underscore to
     * perform array comparison. Therefore it knows that 'a/a' < 'a+/a' even
     * though '+' < '/' in the ASCII table.
     */
    function compareTagNames(a, b) {
        var ai = 0;
        var bi = 0;
        while (true) {
            if (ai === a.length) {
                return bi === b.length ? 0 : -1;
            }
            if (bi === b.length) {
                return 1;
            }
            if (isDigit(a[ai]) && isDigit(b[bi])) {
                var ais = ai;
                var bis = bi;
                ai = consumeNumber(a, ai + 1);
                bi = consumeNumber(b, bi + 1);
                var an = parseFloat(a.slice(ais, ai));
                var bn = parseFloat(b.slice(bis, bi));
                if (an < bn) {
                    return -1;
                }
                if (an > bn) {
                    return 1;
                }
                continue;
            }
            if (isBreak(a[ai])) {
                if (!isBreak(b[bi])) {
                    return -1;
                }
            }
            else if (isBreak(b[bi])) {
                return 1;
            }
            else if (a[ai] < b[bi]) {
                return -1;
            }
            else if (a[ai] > b[bi]) {
                return 1;
            }
            ai++;
            bi++;
        }
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The root component.
     */
    var App = /** @class */ (function () {
        /**
         * @param {?} dataDispatcher
         * @param {?} dataService
         */
        function App(dataDispatcher, dataService) {
            var _this = this;
            this.dataDispatcher = dataDispatcher;
            this.dataService = dataService;
            this.loading = true;
            this.comparing = false;
            this.dataFound = false;
            this.datasets = [];
            document.addEventListener('tensorboard-reload', ( /**
             * @return {?}
             */function () {
                if (!_this.loading && !_this.comparing) {
                    _this.compareDatasets();
                }
            }));
        }
        /**
         * @private
         * @param {?} tools
         * @return {?}
         */
        App.prototype.processTools = function (tools) {
            /** @type {?} */
            var datasets = [];
            /** @type {?} */
            var keys = Object.keys(tools);
            /** @type {?} */
            var values = Object.values(tools);
            for (var i_207 = 0; i_207 < keys.length; i_207++) {
                datasets.push({ name: keys[i_207], activeTools: values[i_207] || [] });
            }
            datasets.sort(( /**
             * @param {?} a
             * @param {?} b
             * @return {?}
             */function (a, b) { return -compareTagNames(a.name, b.name); }));
            return datasets;
        };
        /**
         * @return {?}
         */
        App.prototype.ngOnInit = function () {
            var _this = this;
            this.dataService.getTools().subscribe(( /**
             * @param {?} tools
             * @return {?}
             */function (/**
             * @param {?} tools
             * @return {?}
             */ tools) {
                _this.datasets =
                    _this.processTools(( /** @type {?} */((tools || {}))));
                _this.dataFound = _this.datasets.length !== 0;
                _this.loading = false;
            }));
        };
        /**
         * @return {?}
         */
        App.prototype.compareDatasets = function () {
            var _this = this;
            this.comparing = true;
            this.dataService.getTools().subscribe(( /**
             * @param {?} tools
             * @return {?}
             */function (/**
             * @param {?} tools
             * @return {?}
             */ tools) {
                /** @type {?} */
                var datasets = _this.processTools(( /** @type {?} */((tools || {}))));
                if (JSON.stringify(datasets) !== JSON.stringify(_this.datasets)) {
                    document.dispatchEvent(new Event('plugin-reload'));
                }
                _this.comparing = false;
            }));
        };
        return App;
    }());
    App.decorators = [
        { type: Component, args: [{
                    selector: 'app',
                    template: "<div *ngIf=\"!loading; else progress_bar\">\n  <div *ngIf=\"dataFound; else emptypage\">\n    <main-page [datasets]=\"datasets\"></main-page>\n  </div>\n\n  <ng-template #emptypage>\n    <empty-page></empty-page>\n  </ng-template>\n</div>\n\n<ng-template #progress_bar>\n  <div class=\"progress-container\" [hidden]=\"!loading\">\n    <div class=\"loading-message\">Loading data</div>\n    <mat-progress-bar color=\"primary\" mode=\"indeterminate\"></mat-progress-bar>\n  </div>\n</ng-template>\n",
                    styles: ["mat-progress-bar{width:300px;margin:0 auto}.progress-container{padding:50px}.loading-message{width:fit-content;margin:0 auto}\n"]
                }] }
    ];
    /** @nocollapse */
    App.ctorParameters = function () { return [
        { type: DataDispatcher },
        { type: DataService }
    ]; };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The root component module.
     */
    var AppModule = /** @class */ (function () {
        function AppModule() {
        }
        return AppModule;
    }());
    AppModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [App],
                    imports: [
                        BrowserModule,
                        HttpClientModule,
                        MatProgressBarModule,
                        EmptyPageModule,
                        MainPageModule,
                        BrowserAnimationsModule,
                        PipesModule,
                        RootStoreModule,
                    ],
                    providers: [
                        DataDispatcher,
                        DataService,
                    ],
                    bootstrap: [App],
                },] }
    ];
    var MatDialogModuleNgFactory = createNgModuleFactory(MatDialogModule, [], function (_l) {
        return moduleDef([
            moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [
                [
                    8,
                    [MatDialogContainerNgFactory]
                ],
                [
                    3,
                    ComponentFactoryResolver
                ],
                NgModuleRef
            ]),
            moduleProvideDef(4608, NgLocalization, NgLocaleLocalization, [
                LOCALE_ID$1,
                [
                    2,
                    DEPRECATED_PLURAL_FN
                ]
            ]),
            moduleProvideDef(4608, Overlay, Overlay, [
                ScrollStrategyOptions,
                OverlayContainer,
                ComponentFactoryResolver,
                OverlayPositionBuilder,
                OverlayKeyboardDispatcher,
                Injector,
                NgZone,
                DOCUMENT,
                Directionality,
                [
                    2,
                    Location
                ]
            ]),
            moduleProvideDef(5120, CDK_CONNECTED_OVERLAY_SCROLL_STRATEGY, CDK_CONNECTED_OVERLAY_SCROLL_STRATEGY_PROVIDER_FACTORY, [Overlay]),
            moduleProvideDef(5120, MAT_DIALOG_SCROLL_STRATEGY, MAT_DIALOG_SCROLL_STRATEGY_PROVIDER_FACTORY, [Overlay]),
            moduleProvideDef(135680, MatDialog, MatDialog, [
                Overlay,
                Injector,
                [
                    2,
                    Location
                ],
                [
                    2,
                    MAT_DIALOG_DEFAULT_OPTIONS
                ],
                MAT_DIALOG_SCROLL_STRATEGY,
                [
                    3,
                    MatDialog
                ],
                OverlayContainer
            ]),
            moduleProvideDef(1073742336, CommonModule, CommonModule, []),
            moduleProvideDef(1073742336, BidiModule, BidiModule, []),
            moduleProvideDef(1073742336, PortalModule, PortalModule, []),
            moduleProvideDef(1073742336, PlatformModule, PlatformModule, []),
            moduleProvideDef(1073742336, ScrollingModule, ScrollingModule, []),
            moduleProvideDef(1073742336, OverlayModule, OverlayModule, []),
            moduleProvideDef(1073742336, MatCommonModule, MatCommonModule, [
                [
                    2,
                    MATERIAL_SANITY_CHECKS
                ],
                [
                    2,
                    HAMMER_LOADER
                ]
            ]),
            moduleProvideDef(1073742336, MatDialogModule, MatDialogModule, [])
        ]);
    });
    var styles_MatDialogContainer = ['.mat-dialog-container{display:block;padding:24px;border-radius:4px;box-sizing:border-box;overflow:auto;outline:0;width:100%;height:100%;min-height:inherit;max-height:inherit}@media (-ms-high-contrast:active){.mat-dialog-container{outline:solid 1px}}.mat-dialog-content{display:block;margin:0 -24px;padding:0 24px;max-height:65vh;overflow:auto;-webkit-overflow-scrolling:touch}.mat-dialog-title{margin:0 0 20px;display:block}.mat-dialog-actions{padding:8px 0;display:flex;flex-wrap:wrap;min-height:52px;align-items:center;margin-bottom:-24px}.mat-dialog-actions[align=end]{justify-content:flex-end}.mat-dialog-actions[align=center]{justify-content:center}.mat-dialog-actions .mat-button-base+.mat-button-base{margin-left:8px}[dir=rtl] .mat-dialog-actions .mat-button-base+.mat-button-base{margin-left:0;margin-right:8px}'];
    var RenderType_MatDialogContainer = createRendererType2({
        encapsulation: 2,
        styles: styles_MatDialogContainer,
        data: {
            'animation': [{
                    type: 7,
                    name: 'dialogContainer',
                    definitions: [
                        {
                            type: 0,
                            name: 'void, exit',
                            styles: {
                                type: 6,
                                styles: {
                                    opacity: 0,
                                    transform: 'scale(0.7)'
                                },
                                offset: null
                            },
                            options: undefined
                        },
                        {
                            type: 0,
                            name: 'enter',
                            styles: {
                                type: 6,
                                styles: { transform: 'none' },
                                offset: null
                            },
                            options: undefined
                        },
                        {
                            type: 1,
                            expr: '* => enter',
                            animation: {
                                type: 4,
                                styles: {
                                    type: 6,
                                    styles: {
                                        transform: 'none',
                                        opacity: 1
                                    },
                                    offset: null
                                },
                                timings: '150ms cubic-bezier(0, 0, 0.2, 1)'
                            },
                            options: null
                        },
                        {
                            type: 1,
                            expr: '* => void, * => exit',
                            animation: {
                                type: 4,
                                styles: {
                                    type: 6,
                                    styles: { opacity: 0 },
                                    offset: null
                                },
                                timings: '75ms cubic-bezier(0.4, 0.0, 0.2, 1)'
                            },
                            options: null
                        }
                    ],
                    options: {}
                }]
        }
    });
    function View_MatDialogContainer_1(_l) {
        return viewDef(0, [(_l()(), anchorDef(0, null, null, 0))], null, null);
    }
    function View_MatDialogContainer_0(_l) {
        return viewDef(0, [
            queryDef(402653184, 1, { _portalOutlet: 0 }),
            (_l()(), anchorDef(16777216, null, null, 1, null, View_MatDialogContainer_1)),
            directiveDef(2, 212992, [[
                    1,
                    4
                ]], 0, CdkPortalOutlet, [
                ComponentFactoryResolver,
                ViewContainerRef
            ], {
                portal: [
                    0,
                    'portal'
                ]
            }, null)
        ], function (_ck, _v) {
            var currVal_0 = '';
            _ck(_v, 2, 0, currVal_0);
        }, null);
    }
    function View_MatDialogContainer_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'mat-dialog-container', [
                [
                    'aria-modal',
                    'true'
                ],
                [
                    'class',
                    'mat-dialog-container'
                ],
                [
                    'tabindex',
                    '-1'
                ]
            ], [
                [
                    1,
                    'id',
                    0
                ],
                [
                    1,
                    'role',
                    0
                ],
                [
                    1,
                    'aria-labelledby',
                    0
                ],
                [
                    1,
                    'aria-label',
                    0
                ],
                [
                    1,
                    'aria-describedby',
                    0
                ],
                [
                    40,
                    '@dialogContainer',
                    0
                ]
            ], [
                [
                    'component',
                    '@dialogContainer.start'
                ],
                [
                    'component',
                    '@dialogContainer.done'
                ]
            ], function (_v, en, $event) {
                var ad = true;
                if ('component:@dialogContainer.start' === en) {
                    var pd_0 = nodeValue(_v, 1)._onAnimationStart($event) !== false;
                    ad = pd_0 && ad;
                }
                if ('component:@dialogContainer.done' === en) {
                    var pd_1 = nodeValue(_v, 1)._onAnimationDone($event) !== false;
                    ad = pd_1 && ad;
                }
                return ad;
            }, View_MatDialogContainer_0, RenderType_MatDialogContainer)),
            directiveDef(1, 49152, null, 0, MatDialogContainer, [
                ElementRef,
                FocusTrapFactory,
                ChangeDetectorRef,
                [
                    2,
                    DOCUMENT
                ],
                MatDialogConfig
            ], null, null)
        ], null, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 1)._id;
            var currVal_1 = nodeValue(_v, 1)._config.role;
            var currVal_2 = nodeValue(_v, 1)._config.ariaLabel ? null : nodeValue(_v, 1)._ariaLabelledBy;
            var currVal_3 = nodeValue(_v, 1)._config.ariaLabel;
            var currVal_4 = nodeValue(_v, 1)._config.ariaDescribedBy || null;
            var currVal_5 = nodeValue(_v, 1)._state;
            _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5);
        });
    }
    var MatDialogContainerNgFactory = createComponentFactory('mat-dialog-container', MatDialogContainer, View_MatDialogContainer_Host_0, {}, {}, []);
    var f = MatDialogContainerNgFactory;
    var MatTooltipModuleNgFactory = createNgModuleFactory(MatTooltipModule, [], function (_l) {
        return moduleDef([
            moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [
                [
                    8,
                    [TooltipComponentNgFactory]
                ],
                [
                    3,
                    ComponentFactoryResolver
                ],
                NgModuleRef
            ]),
            moduleProvideDef(4608, NgLocalization, NgLocaleLocalization, [
                LOCALE_ID$1,
                [
                    2,
                    DEPRECATED_PLURAL_FN
                ]
            ]),
            moduleProvideDef(4608, MutationObserverFactory, MutationObserverFactory, []),
            moduleProvideDef(4608, Overlay, Overlay, [
                ScrollStrategyOptions,
                OverlayContainer,
                ComponentFactoryResolver,
                OverlayPositionBuilder,
                OverlayKeyboardDispatcher,
                Injector,
                NgZone,
                DOCUMENT,
                Directionality,
                [
                    2,
                    Location
                ]
            ]),
            moduleProvideDef(5120, CDK_CONNECTED_OVERLAY_SCROLL_STRATEGY, CDK_CONNECTED_OVERLAY_SCROLL_STRATEGY_PROVIDER_FACTORY, [Overlay]),
            moduleProvideDef(5120, MAT_TOOLTIP_SCROLL_STRATEGY, MAT_TOOLTIP_SCROLL_STRATEGY_FACTORY, [Overlay]),
            moduleProvideDef(4608, HAMMER_GESTURE_CONFIG, GestureConfig, [
                [
                    2,
                    MAT_HAMMER_OPTIONS
                ],
                [
                    2,
                    MatCommonModule
                ]
            ]),
            moduleProvideDef(1073742336, CommonModule, CommonModule, []),
            moduleProvideDef(1073742336, PlatformModule, PlatformModule, []),
            moduleProvideDef(1073742336, ObserversModule, ObserversModule, []),
            moduleProvideDef(1073742336, A11yModule, A11yModule, []),
            moduleProvideDef(1073742336, BidiModule, BidiModule, []),
            moduleProvideDef(1073742336, PortalModule, PortalModule, []),
            moduleProvideDef(1073742336, ScrollingModule, ScrollingModule, []),
            moduleProvideDef(1073742336, OverlayModule, OverlayModule, []),
            moduleProvideDef(1073742336, MatCommonModule, MatCommonModule, [
                [
                    2,
                    MATERIAL_SANITY_CHECKS
                ],
                [
                    2,
                    HAMMER_LOADER
                ]
            ]),
            moduleProvideDef(1073742336, MatTooltipModule, MatTooltipModule, [])
        ]);
    });
    var styles_TooltipComponent = ['.mat-tooltip-panel{pointer-events:none!important}.mat-tooltip{color:#fff;border-radius:4px;margin:14px;max-width:250px;padding-left:8px;padding-right:8px;overflow:hidden;text-overflow:ellipsis}@media (-ms-high-contrast:active){.mat-tooltip{outline:solid 1px}}.mat-tooltip-handset{margin:24px;padding-left:16px;padding-right:16px}'];
    var RenderType_TooltipComponent = createRendererType2({
        encapsulation: 2,
        styles: styles_TooltipComponent,
        data: {
            'animation': [{
                    type: 7,
                    name: 'state',
                    definitions: [
                        {
                            type: 0,
                            name: 'initial, void, hidden',
                            styles: {
                                type: 6,
                                styles: {
                                    opacity: 0,
                                    transform: 'scale(0)'
                                },
                                offset: null
                            },
                            options: undefined
                        },
                        {
                            type: 0,
                            name: 'visible',
                            styles: {
                                type: 6,
                                styles: { transform: 'scale(1)' },
                                offset: null
                            },
                            options: undefined
                        },
                        {
                            type: 1,
                            expr: '* => visible',
                            animation: {
                                type: 4,
                                styles: {
                                    type: 5,
                                    steps: [
                                        {
                                            type: 6,
                                            styles: {
                                                opacity: 0,
                                                transform: 'scale(0)',
                                                offset: 0
                                            },
                                            offset: null
                                        },
                                        {
                                            type: 6,
                                            styles: {
                                                opacity: 0.5,
                                                transform: 'scale(0.99)',
                                                offset: 0.5
                                            },
                                            offset: null
                                        },
                                        {
                                            type: 6,
                                            styles: {
                                                opacity: 1,
                                                transform: 'scale(1)',
                                                offset: 1
                                            },
                                            offset: null
                                        }
                                    ]
                                },
                                timings: '200ms cubic-bezier(0, 0, 0.2, 1)'
                            },
                            options: null
                        },
                        {
                            type: 1,
                            expr: '* => hidden',
                            animation: {
                                type: 4,
                                styles: {
                                    type: 6,
                                    styles: { opacity: 0 },
                                    offset: null
                                },
                                timings: '100ms cubic-bezier(0, 0, 0.2, 1)'
                            },
                            options: null
                        }
                    ],
                    options: {}
                }]
        }
    });
    function View_TooltipComponent_0(_l) {
        return viewDef(2, [
            (_l()(), elementDef(0, 0, null, null, 4, 'div', [[
                    'class',
                    'mat-tooltip'
                ]], [
                [
                    2,
                    'mat-tooltip-handset',
                    null
                ],
                [
                    24,
                    '@state',
                    0
                ]
            ], [
                [
                    null,
                    '@state.start'
                ],
                [
                    null,
                    '@state.done'
                ]
            ], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if ('@state.start' === en) {
                    var pd_0 = _co._animationStart() !== false;
                    ad = pd_0 && ad;
                }
                if ('@state.done' === en) {
                    var pd_1 = _co._animationDone($event) !== false;
                    ad = pd_1 && ad;
                }
                return ad;
            }, null, null)),
            providerDef(512, null, NgClassImpl, NgClassR2Impl, [
                IterableDiffers,
                KeyValueDiffers,
                ElementRef,
                Renderer2
            ]),
            directiveDef(2, 278528, null, 0, NgClass, [NgClassImpl], {
                klass: [
                    0,
                    'klass'
                ],
                ngClass: [
                    1,
                    'ngClass'
                ]
            }, null),
            pipeDef(131072, AsyncPipe, [ChangeDetectorRef]),
            (_l()(), textDef(4, null, [
                '',
                ''
            ]))
        ], function (_ck, _v) {
            var _co = _v.component;
            var currVal_2 = 'mat-tooltip';
            var currVal_3 = _co.tooltipClass;
            _ck(_v, 2, 0, currVal_2, currVal_3);
        }, function (_ck, _v) {
            var _co = _v.component;
            var tmp_0_0 = null;
            var currVal_0 = (tmp_0_0 = unwrapValue(_v, 0, 0, nodeValue(_v, 3).transform(_co._isHandset))) == null ? null : tmp_0_0.matches;
            var currVal_1 = _co._visibility;
            _ck(_v, 0, 0, currVal_0, currVal_1);
            var currVal_4 = _co.message;
            _ck(_v, 4, 0, currVal_4);
        });
    }
    function View_TooltipComponent_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'mat-tooltip-component', [[
                    'aria-hidden',
                    'true'
                ]], [[
                    4,
                    'zoom',
                    null
                ]], [[
                    'body',
                    'click'
                ]], function (_v, en, $event) {
                var ad = true;
                if ('body:click' === en) {
                    var pd_0 = nodeValue(_v, 1)._handleBodyInteraction() !== false;
                    ad = pd_0 && ad;
                }
                return ad;
            }, View_TooltipComponent_0, RenderType_TooltipComponent)),
            directiveDef(1, 180224, null, 0, TooltipComponent, [
                ChangeDetectorRef,
                BreakpointObserver
            ], null, null)
        ], null, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 1)._visibility === 'visible' ? 1 : null;
            _ck(_v, 0, 0, currVal_0);
        });
    }
    var TooltipComponentNgFactory = createComponentFactory('mat-tooltip-component', TooltipComponent, View_TooltipComponent_Host_0, {}, {}, []);
    var f$1 = TooltipComponentNgFactory;
    var MatButtonModuleNgFactory = createNgModuleFactory(MatButtonModule, [], function (_l) {
        return moduleDef([
            moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [
                [
                    8,
                    []
                ],
                [
                    3,
                    ComponentFactoryResolver
                ],
                NgModuleRef
            ]),
            moduleProvideDef(4608, NgLocalization, NgLocaleLocalization, [
                LOCALE_ID$1,
                [
                    2,
                    DEPRECATED_PLURAL_FN
                ]
            ]),
            moduleProvideDef(1073742336, CommonModule, CommonModule, []),
            moduleProvideDef(1073742336, BidiModule, BidiModule, []),
            moduleProvideDef(1073742336, MatCommonModule, MatCommonModule, [
                [
                    2,
                    MATERIAL_SANITY_CHECKS
                ],
                [
                    2,
                    HAMMER_LOADER
                ]
            ]),
            moduleProvideDef(1073742336, PlatformModule, PlatformModule, []),
            moduleProvideDef(1073742336, MatRippleModule, MatRippleModule, []),
            moduleProvideDef(1073742336, MatButtonModule, MatButtonModule, [])
        ]);
    });
    var styles_MatButton = ['.mat-button .mat-button-focus-overlay,.mat-icon-button .mat-button-focus-overlay{opacity:0}.mat-button:hover .mat-button-focus-overlay,.mat-stroked-button:hover .mat-button-focus-overlay{opacity:.04}@media (hover:none){.mat-button:hover .mat-button-focus-overlay,.mat-stroked-button:hover .mat-button-focus-overlay{opacity:0}}.mat-button,.mat-flat-button,.mat-icon-button,.mat-stroked-button{box-sizing:border-box;position:relative;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:pointer;outline:0;border:none;-webkit-tap-highlight-color:transparent;display:inline-block;white-space:nowrap;text-decoration:none;vertical-align:baseline;text-align:center;margin:0;min-width:64px;line-height:36px;padding:0 16px;border-radius:4px;overflow:visible}.mat-button::-moz-focus-inner,.mat-flat-button::-moz-focus-inner,.mat-icon-button::-moz-focus-inner,.mat-stroked-button::-moz-focus-inner{border:0}.mat-button[disabled],.mat-flat-button[disabled],.mat-icon-button[disabled],.mat-stroked-button[disabled]{cursor:default}.mat-button.cdk-keyboard-focused .mat-button-focus-overlay,.mat-button.cdk-program-focused .mat-button-focus-overlay,.mat-flat-button.cdk-keyboard-focused .mat-button-focus-overlay,.mat-flat-button.cdk-program-focused .mat-button-focus-overlay,.mat-icon-button.cdk-keyboard-focused .mat-button-focus-overlay,.mat-icon-button.cdk-program-focused .mat-button-focus-overlay,.mat-stroked-button.cdk-keyboard-focused .mat-button-focus-overlay,.mat-stroked-button.cdk-program-focused .mat-button-focus-overlay{opacity:.12}.mat-button::-moz-focus-inner,.mat-flat-button::-moz-focus-inner,.mat-icon-button::-moz-focus-inner,.mat-stroked-button::-moz-focus-inner{border:0}.mat-raised-button{box-sizing:border-box;position:relative;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:pointer;outline:0;border:none;-webkit-tap-highlight-color:transparent;display:inline-block;white-space:nowrap;text-decoration:none;vertical-align:baseline;text-align:center;margin:0;min-width:64px;line-height:36px;padding:0 16px;border-radius:4px;overflow:visible;transform:translate3d(0,0,0);transition:background .4s cubic-bezier(.25,.8,.25,1),box-shadow 280ms cubic-bezier(.4,0,.2,1)}.mat-raised-button::-moz-focus-inner{border:0}.mat-raised-button[disabled]{cursor:default}.mat-raised-button.cdk-keyboard-focused .mat-button-focus-overlay,.mat-raised-button.cdk-program-focused .mat-button-focus-overlay{opacity:.12}.mat-raised-button::-moz-focus-inner{border:0}._mat-animation-noopable.mat-raised-button{transition:none;animation:none}.mat-stroked-button{border:1px solid currentColor;padding:0 15px;line-height:34px}.mat-stroked-button .mat-button-focus-overlay,.mat-stroked-button .mat-button-ripple.mat-ripple{top:-1px;left:-1px;right:-1px;bottom:-1px}.mat-fab{box-sizing:border-box;position:relative;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:pointer;outline:0;border:none;-webkit-tap-highlight-color:transparent;display:inline-block;white-space:nowrap;text-decoration:none;vertical-align:baseline;text-align:center;margin:0;min-width:64px;line-height:36px;padding:0 16px;border-radius:4px;overflow:visible;transform:translate3d(0,0,0);transition:background .4s cubic-bezier(.25,.8,.25,1),box-shadow 280ms cubic-bezier(.4,0,.2,1);min-width:0;border-radius:50%;width:56px;height:56px;padding:0;flex-shrink:0}.mat-fab::-moz-focus-inner{border:0}.mat-fab[disabled]{cursor:default}.mat-fab.cdk-keyboard-focused .mat-button-focus-overlay,.mat-fab.cdk-program-focused .mat-button-focus-overlay{opacity:.12}.mat-fab::-moz-focus-inner{border:0}._mat-animation-noopable.mat-fab{transition:none;animation:none}.mat-fab .mat-button-wrapper{padding:16px 0;display:inline-block;line-height:24px}.mat-mini-fab{box-sizing:border-box;position:relative;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:pointer;outline:0;border:none;-webkit-tap-highlight-color:transparent;display:inline-block;white-space:nowrap;text-decoration:none;vertical-align:baseline;text-align:center;margin:0;min-width:64px;line-height:36px;padding:0 16px;border-radius:4px;overflow:visible;transform:translate3d(0,0,0);transition:background .4s cubic-bezier(.25,.8,.25,1),box-shadow 280ms cubic-bezier(.4,0,.2,1);min-width:0;border-radius:50%;width:40px;height:40px;padding:0;flex-shrink:0}.mat-mini-fab::-moz-focus-inner{border:0}.mat-mini-fab[disabled]{cursor:default}.mat-mini-fab.cdk-keyboard-focused .mat-button-focus-overlay,.mat-mini-fab.cdk-program-focused .mat-button-focus-overlay{opacity:.12}.mat-mini-fab::-moz-focus-inner{border:0}._mat-animation-noopable.mat-mini-fab{transition:none;animation:none}.mat-mini-fab .mat-button-wrapper{padding:8px 0;display:inline-block;line-height:24px}.mat-icon-button{padding:0;min-width:0;width:40px;height:40px;flex-shrink:0;line-height:40px;border-radius:50%}.mat-icon-button .mat-icon,.mat-icon-button i{line-height:24px}.mat-button-focus-overlay,.mat-button-ripple.mat-ripple{top:0;left:0;right:0;bottom:0;position:absolute;pointer-events:none;border-radius:inherit}.mat-button-ripple.mat-ripple:not(:empty){transform:translateZ(0)}.mat-button-focus-overlay{opacity:0;transition:opacity .2s cubic-bezier(.35,0,.25,1),background-color .2s cubic-bezier(.35,0,.25,1)}._mat-animation-noopable .mat-button-focus-overlay{transition:none}@media (-ms-high-contrast:active){.mat-button-focus-overlay{background-color:#fff}}@media (-ms-high-contrast:black-on-white){.mat-button-focus-overlay{background-color:#000}}.mat-button-ripple-round{border-radius:50%;z-index:1}.mat-button .mat-button-wrapper>*,.mat-fab .mat-button-wrapper>*,.mat-flat-button .mat-button-wrapper>*,.mat-icon-button .mat-button-wrapper>*,.mat-mini-fab .mat-button-wrapper>*,.mat-raised-button .mat-button-wrapper>*,.mat-stroked-button .mat-button-wrapper>*{vertical-align:middle}.mat-form-field:not(.mat-form-field-appearance-legacy) .mat-form-field-prefix .mat-icon-button,.mat-form-field:not(.mat-form-field-appearance-legacy) .mat-form-field-suffix .mat-icon-button{display:block;font-size:inherit;width:2.5em;height:2.5em}@media (-ms-high-contrast:active){.mat-button,.mat-fab,.mat-flat-button,.mat-icon-button,.mat-mini-fab,.mat-raised-button{outline:solid 1px}}'];
    var RenderType_MatButton = createRendererType2({
        encapsulation: 2,
        styles: styles_MatButton,
        data: {}
    });
    function View_MatButton_0(_l) {
        return viewDef(2, [
            queryDef(671088640, 1, { ripple: 0 }),
            (_l()(), elementDef(1, 0, null, null, 1, 'span', [[
                    'class',
                    'mat-button-wrapper'
                ]], null, null, null, null, null)),
            ngContentDef(null, 0),
            (_l()(), elementDef(3, 0, null, null, 1, 'div', [
                [
                    'class',
                    'mat-button-ripple mat-ripple'
                ],
                [
                    'matRipple',
                    ''
                ]
            ], [
                [
                    2,
                    'mat-button-ripple-round',
                    null
                ],
                [
                    2,
                    'mat-ripple-unbounded',
                    null
                ]
            ], null, null, null, null)),
            directiveDef(4, 212992, [[
                    1,
                    4
                ]], 0, MatRipple, [
                ElementRef,
                NgZone,
                Platform,
                [
                    2,
                    MAT_RIPPLE_GLOBAL_OPTIONS
                ],
                [
                    2,
                    ANIMATION_MODULE_TYPE
                ]
            ], {
                centered: [
                    0,
                    'centered'
                ],
                disabled: [
                    1,
                    'disabled'
                ],
                trigger: [
                    2,
                    'trigger'
                ]
            }, null),
            (_l()(), elementDef(5, 0, null, null, 0, 'div', [[
                    'class',
                    'mat-button-focus-overlay'
                ]], null, null, null, null, null))
        ], function (_ck, _v) {
            var _co = _v.component;
            var currVal_2 = _co.isIconButton;
            var currVal_3 = _co._isRippleDisabled();
            var currVal_4 = _co._getHostElement();
            _ck(_v, 4, 0, currVal_2, currVal_3, currVal_4);
        }, function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co.isRoundButton || _co.isIconButton;
            var currVal_1 = nodeValue(_v, 4).unbounded;
            _ck(_v, 3, 0, currVal_0, currVal_1);
        });
    }
    function View_MatButton_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'button', [[
                    'mat-button',
                    ''
                ]], [
                [
                    1,
                    'disabled',
                    0
                ],
                [
                    2,
                    '_mat-animation-noopable',
                    null
                ]
            ], null, null, View_MatButton_0, RenderType_MatButton)),
            directiveDef(1, 180224, null, 0, MatButton, [
                ElementRef,
                FocusMonitor,
                [
                    2,
                    ANIMATION_MODULE_TYPE
                ]
            ], null, null)
        ], null, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 1).disabled || null;
            var currVal_1 = nodeValue(_v, 1)._animationMode === 'NoopAnimations';
            _ck(_v, 0, 0, currVal_0, currVal_1);
        });
    }
    var MatButtonNgFactory = createComponentFactory('button[mat-button], button[mat-raised-button], button[mat-icon-button],\n             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],\n             button[mat-flat-button]', MatButton, View_MatButton_Host_0, {
        disabled: 'disabled',
        disableRipple: 'disableRipple',
        color: 'color'
    }, {}, ['*']);
    var styles_MatAnchor = ['.mat-button .mat-button-focus-overlay,.mat-icon-button .mat-button-focus-overlay{opacity:0}.mat-button:hover .mat-button-focus-overlay,.mat-stroked-button:hover .mat-button-focus-overlay{opacity:.04}@media (hover:none){.mat-button:hover .mat-button-focus-overlay,.mat-stroked-button:hover .mat-button-focus-overlay{opacity:0}}.mat-button,.mat-flat-button,.mat-icon-button,.mat-stroked-button{box-sizing:border-box;position:relative;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:pointer;outline:0;border:none;-webkit-tap-highlight-color:transparent;display:inline-block;white-space:nowrap;text-decoration:none;vertical-align:baseline;text-align:center;margin:0;min-width:64px;line-height:36px;padding:0 16px;border-radius:4px;overflow:visible}.mat-button::-moz-focus-inner,.mat-flat-button::-moz-focus-inner,.mat-icon-button::-moz-focus-inner,.mat-stroked-button::-moz-focus-inner{border:0}.mat-button[disabled],.mat-flat-button[disabled],.mat-icon-button[disabled],.mat-stroked-button[disabled]{cursor:default}.mat-button.cdk-keyboard-focused .mat-button-focus-overlay,.mat-button.cdk-program-focused .mat-button-focus-overlay,.mat-flat-button.cdk-keyboard-focused .mat-button-focus-overlay,.mat-flat-button.cdk-program-focused .mat-button-focus-overlay,.mat-icon-button.cdk-keyboard-focused .mat-button-focus-overlay,.mat-icon-button.cdk-program-focused .mat-button-focus-overlay,.mat-stroked-button.cdk-keyboard-focused .mat-button-focus-overlay,.mat-stroked-button.cdk-program-focused .mat-button-focus-overlay{opacity:.12}.mat-button::-moz-focus-inner,.mat-flat-button::-moz-focus-inner,.mat-icon-button::-moz-focus-inner,.mat-stroked-button::-moz-focus-inner{border:0}.mat-raised-button{box-sizing:border-box;position:relative;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:pointer;outline:0;border:none;-webkit-tap-highlight-color:transparent;display:inline-block;white-space:nowrap;text-decoration:none;vertical-align:baseline;text-align:center;margin:0;min-width:64px;line-height:36px;padding:0 16px;border-radius:4px;overflow:visible;transform:translate3d(0,0,0);transition:background .4s cubic-bezier(.25,.8,.25,1),box-shadow 280ms cubic-bezier(.4,0,.2,1)}.mat-raised-button::-moz-focus-inner{border:0}.mat-raised-button[disabled]{cursor:default}.mat-raised-button.cdk-keyboard-focused .mat-button-focus-overlay,.mat-raised-button.cdk-program-focused .mat-button-focus-overlay{opacity:.12}.mat-raised-button::-moz-focus-inner{border:0}._mat-animation-noopable.mat-raised-button{transition:none;animation:none}.mat-stroked-button{border:1px solid currentColor;padding:0 15px;line-height:34px}.mat-stroked-button .mat-button-focus-overlay,.mat-stroked-button .mat-button-ripple.mat-ripple{top:-1px;left:-1px;right:-1px;bottom:-1px}.mat-fab{box-sizing:border-box;position:relative;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:pointer;outline:0;border:none;-webkit-tap-highlight-color:transparent;display:inline-block;white-space:nowrap;text-decoration:none;vertical-align:baseline;text-align:center;margin:0;min-width:64px;line-height:36px;padding:0 16px;border-radius:4px;overflow:visible;transform:translate3d(0,0,0);transition:background .4s cubic-bezier(.25,.8,.25,1),box-shadow 280ms cubic-bezier(.4,0,.2,1);min-width:0;border-radius:50%;width:56px;height:56px;padding:0;flex-shrink:0}.mat-fab::-moz-focus-inner{border:0}.mat-fab[disabled]{cursor:default}.mat-fab.cdk-keyboard-focused .mat-button-focus-overlay,.mat-fab.cdk-program-focused .mat-button-focus-overlay{opacity:.12}.mat-fab::-moz-focus-inner{border:0}._mat-animation-noopable.mat-fab{transition:none;animation:none}.mat-fab .mat-button-wrapper{padding:16px 0;display:inline-block;line-height:24px}.mat-mini-fab{box-sizing:border-box;position:relative;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:pointer;outline:0;border:none;-webkit-tap-highlight-color:transparent;display:inline-block;white-space:nowrap;text-decoration:none;vertical-align:baseline;text-align:center;margin:0;min-width:64px;line-height:36px;padding:0 16px;border-radius:4px;overflow:visible;transform:translate3d(0,0,0);transition:background .4s cubic-bezier(.25,.8,.25,1),box-shadow 280ms cubic-bezier(.4,0,.2,1);min-width:0;border-radius:50%;width:40px;height:40px;padding:0;flex-shrink:0}.mat-mini-fab::-moz-focus-inner{border:0}.mat-mini-fab[disabled]{cursor:default}.mat-mini-fab.cdk-keyboard-focused .mat-button-focus-overlay,.mat-mini-fab.cdk-program-focused .mat-button-focus-overlay{opacity:.12}.mat-mini-fab::-moz-focus-inner{border:0}._mat-animation-noopable.mat-mini-fab{transition:none;animation:none}.mat-mini-fab .mat-button-wrapper{padding:8px 0;display:inline-block;line-height:24px}.mat-icon-button{padding:0;min-width:0;width:40px;height:40px;flex-shrink:0;line-height:40px;border-radius:50%}.mat-icon-button .mat-icon,.mat-icon-button i{line-height:24px}.mat-button-focus-overlay,.mat-button-ripple.mat-ripple{top:0;left:0;right:0;bottom:0;position:absolute;pointer-events:none;border-radius:inherit}.mat-button-ripple.mat-ripple:not(:empty){transform:translateZ(0)}.mat-button-focus-overlay{opacity:0;transition:opacity .2s cubic-bezier(.35,0,.25,1),background-color .2s cubic-bezier(.35,0,.25,1)}._mat-animation-noopable .mat-button-focus-overlay{transition:none}@media (-ms-high-contrast:active){.mat-button-focus-overlay{background-color:#fff}}@media (-ms-high-contrast:black-on-white){.mat-button-focus-overlay{background-color:#000}}.mat-button-ripple-round{border-radius:50%;z-index:1}.mat-button .mat-button-wrapper>*,.mat-fab .mat-button-wrapper>*,.mat-flat-button .mat-button-wrapper>*,.mat-icon-button .mat-button-wrapper>*,.mat-mini-fab .mat-button-wrapper>*,.mat-raised-button .mat-button-wrapper>*,.mat-stroked-button .mat-button-wrapper>*{vertical-align:middle}.mat-form-field:not(.mat-form-field-appearance-legacy) .mat-form-field-prefix .mat-icon-button,.mat-form-field:not(.mat-form-field-appearance-legacy) .mat-form-field-suffix .mat-icon-button{display:block;font-size:inherit;width:2.5em;height:2.5em}@media (-ms-high-contrast:active){.mat-button,.mat-fab,.mat-flat-button,.mat-icon-button,.mat-mini-fab,.mat-raised-button{outline:solid 1px}}'];
    var RenderType_MatAnchor = createRendererType2({
        encapsulation: 2,
        styles: styles_MatAnchor,
        data: {}
    });
    function View_MatAnchor_0(_l) {
        return viewDef(2, [
            queryDef(671088640, 1, { ripple: 0 }),
            (_l()(), elementDef(1, 0, null, null, 1, 'span', [[
                    'class',
                    'mat-button-wrapper'
                ]], null, null, null, null, null)),
            ngContentDef(null, 0),
            (_l()(), elementDef(3, 0, null, null, 1, 'div', [
                [
                    'class',
                    'mat-button-ripple mat-ripple'
                ],
                [
                    'matRipple',
                    ''
                ]
            ], [
                [
                    2,
                    'mat-button-ripple-round',
                    null
                ],
                [
                    2,
                    'mat-ripple-unbounded',
                    null
                ]
            ], null, null, null, null)),
            directiveDef(4, 212992, [[
                    1,
                    4
                ]], 0, MatRipple, [
                ElementRef,
                NgZone,
                Platform,
                [
                    2,
                    MAT_RIPPLE_GLOBAL_OPTIONS
                ],
                [
                    2,
                    ANIMATION_MODULE_TYPE
                ]
            ], {
                centered: [
                    0,
                    'centered'
                ],
                disabled: [
                    1,
                    'disabled'
                ],
                trigger: [
                    2,
                    'trigger'
                ]
            }, null),
            (_l()(), elementDef(5, 0, null, null, 0, 'div', [[
                    'class',
                    'mat-button-focus-overlay'
                ]], null, null, null, null, null))
        ], function (_ck, _v) {
            var _co = _v.component;
            var currVal_2 = _co.isIconButton;
            var currVal_3 = _co._isRippleDisabled();
            var currVal_4 = _co._getHostElement();
            _ck(_v, 4, 0, currVal_2, currVal_3, currVal_4);
        }, function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co.isRoundButton || _co.isIconButton;
            var currVal_1 = nodeValue(_v, 4).unbounded;
            _ck(_v, 3, 0, currVal_0, currVal_1);
        });
    }
    function View_MatAnchor_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'a', [[
                    'mat-button',
                    ''
                ]], [
                [
                    1,
                    'tabindex',
                    0
                ],
                [
                    1,
                    'disabled',
                    0
                ],
                [
                    1,
                    'aria-disabled',
                    0
                ],
                [
                    2,
                    '_mat-animation-noopable',
                    null
                ]
            ], [[
                    null,
                    'click'
                ]], function (_v, en, $event) {
                var ad = true;
                if ('click' === en) {
                    var pd_0 = nodeValue(_v, 1)._haltDisabledEvents($event) !== false;
                    ad = pd_0 && ad;
                }
                return ad;
            }, View_MatAnchor_0, RenderType_MatAnchor)),
            directiveDef(1, 180224, null, 0, MatAnchor, [
                FocusMonitor,
                ElementRef,
                [
                    2,
                    ANIMATION_MODULE_TYPE
                ]
            ], null, null)
        ], null, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 1).disabled ? 0 - 1 : nodeValue(_v, 1).tabIndex || 0;
            var currVal_1 = nodeValue(_v, 1).disabled || null;
            var currVal_2 = nodeValue(_v, 1).disabled.toString();
            var currVal_3 = nodeValue(_v, 1)._animationMode === 'NoopAnimations';
            _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2, currVal_3);
        });
    }
    var MatAnchorNgFactory = createComponentFactory('a[mat-button], a[mat-raised-button], a[mat-icon-button], a[mat-fab],\n             a[mat-mini-fab], a[mat-stroked-button], a[mat-flat-button]', MatAnchor, View_MatAnchor_Host_0, {
        disabled: 'disabled',
        disableRipple: 'disableRipple',
        color: 'color',
        tabIndex: 'tabIndex'
    }, {}, ['*']);
    var c = RenderType_MatButton;
    var d = View_MatButton_0;
    var MatSnackBarModuleNgFactory = createNgModuleFactory(MatSnackBarModule, [], function (_l) {
        return moduleDef([
            moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [
                [
                    8,
                    [
                        MatSnackBarContainerNgFactory,
                        SimpleSnackBarNgFactory
                    ]
                ],
                [
                    3,
                    ComponentFactoryResolver
                ],
                NgModuleRef
            ]),
            moduleProvideDef(4608, Overlay, Overlay, [
                ScrollStrategyOptions,
                OverlayContainer,
                ComponentFactoryResolver,
                OverlayPositionBuilder,
                OverlayKeyboardDispatcher,
                Injector,
                NgZone,
                DOCUMENT,
                Directionality,
                [
                    2,
                    Location
                ]
            ]),
            moduleProvideDef(5120, CDK_CONNECTED_OVERLAY_SCROLL_STRATEGY, CDK_CONNECTED_OVERLAY_SCROLL_STRATEGY_PROVIDER_FACTORY, [Overlay]),
            moduleProvideDef(4608, NgLocalization, NgLocaleLocalization, [
                LOCALE_ID$1,
                [
                    2,
                    DEPRECATED_PLURAL_FN
                ]
            ]),
            moduleProvideDef(1073742336, BidiModule, BidiModule, []),
            moduleProvideDef(1073742336, PortalModule, PortalModule, []),
            moduleProvideDef(1073742336, PlatformModule, PlatformModule, []),
            moduleProvideDef(1073742336, ScrollingModule, ScrollingModule, []),
            moduleProvideDef(1073742336, OverlayModule, OverlayModule, []),
            moduleProvideDef(1073742336, CommonModule, CommonModule, []),
            moduleProvideDef(1073742336, MatCommonModule, MatCommonModule, [
                [
                    2,
                    MATERIAL_SANITY_CHECKS
                ],
                [
                    2,
                    HAMMER_LOADER
                ]
            ]),
            moduleProvideDef(1073742336, MatRippleModule, MatRippleModule, []),
            moduleProvideDef(1073742336, MatButtonModule, MatButtonModule, []),
            moduleProvideDef(1073742336, MatSnackBarModule, MatSnackBarModule, [])
        ]);
    });
    var styles_MatSnackBarContainer = ['.mat-snack-bar-container{border-radius:4px;box-sizing:border-box;display:block;margin:24px;max-width:33vw;min-width:344px;padding:14px 16px;min-height:48px;transform-origin:center}@media (-ms-high-contrast:active){.mat-snack-bar-container{border:solid 1px}}.mat-snack-bar-handset{width:100%}.mat-snack-bar-handset .mat-snack-bar-container{margin:8px;max-width:100%;min-width:0;width:100%}'];
    var RenderType_MatSnackBarContainer = createRendererType2({
        encapsulation: 2,
        styles: styles_MatSnackBarContainer,
        data: {
            'animation': [{
                    type: 7,
                    name: 'state',
                    definitions: [
                        {
                            type: 0,
                            name: 'void, hidden',
                            styles: {
                                type: 6,
                                styles: {
                                    transform: 'scale(0.8)',
                                    opacity: 0
                                },
                                offset: null
                            },
                            options: undefined
                        },
                        {
                            type: 0,
                            name: 'visible',
                            styles: {
                                type: 6,
                                styles: {
                                    transform: 'scale(1)',
                                    opacity: 1
                                },
                                offset: null
                            },
                            options: undefined
                        },
                        {
                            type: 1,
                            expr: '* => visible',
                            animation: {
                                type: 4,
                                styles: null,
                                timings: '150ms cubic-bezier(0, 0, 0.2, 1)'
                            },
                            options: null
                        },
                        {
                            type: 1,
                            expr: '* => void, * => hidden',
                            animation: {
                                type: 4,
                                styles: {
                                    type: 6,
                                    styles: { opacity: 0 },
                                    offset: null
                                },
                                timings: '75ms cubic-bezier(0.4, 0.0, 1, 1)'
                            },
                            options: null
                        }
                    ],
                    options: {}
                }]
        }
    });
    function View_MatSnackBarContainer_1(_l) {
        return viewDef(0, [(_l()(), anchorDef(0, null, null, 0))], null, null);
    }
    function View_MatSnackBarContainer_0(_l) {
        return viewDef(0, [
            queryDef(402653184, 1, { _portalOutlet: 0 }),
            (_l()(), anchorDef(16777216, null, null, 1, null, View_MatSnackBarContainer_1)),
            directiveDef(2, 212992, [[
                    1,
                    4
                ]], 0, CdkPortalOutlet, [
                ComponentFactoryResolver,
                ViewContainerRef
            ], {
                portal: [
                    0,
                    'portal'
                ]
            }, null)
        ], function (_ck, _v) {
            var currVal_0 = '';
            _ck(_v, 2, 0, currVal_0);
        }, null);
    }
    function View_MatSnackBarContainer_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'snack-bar-container', [[
                    'class',
                    'mat-snack-bar-container'
                ]], [
                [
                    1,
                    'role',
                    0
                ],
                [
                    40,
                    '@state',
                    0
                ]
            ], [[
                    'component',
                    '@state.done'
                ]], function (_v, en, $event) {
                var ad = true;
                if ('component:@state.done' === en) {
                    var pd_0 = nodeValue(_v, 1).onAnimationEnd($event) !== false;
                    ad = pd_0 && ad;
                }
                return ad;
            }, View_MatSnackBarContainer_0, RenderType_MatSnackBarContainer)),
            directiveDef(1, 180224, null, 0, MatSnackBarContainer, [
                NgZone,
                ElementRef,
                ChangeDetectorRef,
                MatSnackBarConfig
            ], null, null)
        ], null, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 1)._role;
            var currVal_1 = nodeValue(_v, 1)._animationState;
            _ck(_v, 0, 0, currVal_0, currVal_1);
        });
    }
    var MatSnackBarContainerNgFactory = createComponentFactory('snack-bar-container', MatSnackBarContainer, View_MatSnackBarContainer_Host_0, {}, {}, []);
    var styles_SimpleSnackBar = ['.mat-simple-snackbar{display:flex;justify-content:space-between;align-items:center;line-height:20px;opacity:1}.mat-simple-snackbar-action{flex-shrink:0;margin:-8px -8px -8px 8px}.mat-simple-snackbar-action button{max-height:36px;min-width:0}[dir=rtl] .mat-simple-snackbar-action{margin-left:-8px;margin-right:8px}'];
    var RenderType_SimpleSnackBar = createRendererType2({
        encapsulation: 2,
        styles: styles_SimpleSnackBar,
        data: {}
    });
    function View_SimpleSnackBar_1(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 3, 'div', [[
                    'class',
                    'mat-simple-snackbar-action'
                ]], null, null, null, null, null)),
            (_l()(), elementDef(1, 0, null, null, 2, 'button', [[
                    'mat-button',
                    ''
                ]], [
                [
                    1,
                    'disabled',
                    0
                ],
                [
                    2,
                    '_mat-animation-noopable',
                    null
                ]
            ], [[
                    null,
                    'click'
                ]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if ('click' === en) {
                    var pd_0 = _co.action() !== false;
                    ad = pd_0 && ad;
                }
                return ad;
            }, d, c)),
            directiveDef(2, 180224, null, 0, MatButton, [
                ElementRef,
                FocusMonitor,
                [
                    2,
                    ANIMATION_MODULE_TYPE
                ]
            ], null, null),
            (_l()(), textDef(3, 0, [
                '',
                ''
            ]))
        ], null, function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = nodeValue(_v, 2).disabled || null;
            var currVal_1 = nodeValue(_v, 2)._animationMode === 'NoopAnimations';
            _ck(_v, 1, 0, currVal_0, currVal_1);
            var currVal_2 = _co.data.action;
            _ck(_v, 3, 0, currVal_2);
        });
    }
    function View_SimpleSnackBar_0(_l) {
        return viewDef(2, [
            (_l()(), elementDef(0, 0, null, null, 1, 'span', [], null, null, null, null, null)),
            (_l()(), textDef(1, null, [
                '',
                ''
            ])),
            (_l()(), anchorDef(16777216, null, null, 1, null, View_SimpleSnackBar_1)),
            directiveDef(3, 16384, null, 0, NgIf, [
                ViewContainerRef,
                TemplateRef
            ], {
                ngIf: [
                    0,
                    'ngIf'
                ]
            }, null)
        ], function (_ck, _v) {
            var _co = _v.component;
            var currVal_1 = _co.hasAction;
            _ck(_v, 3, 0, currVal_1);
        }, function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co.data.message;
            _ck(_v, 1, 0, currVal_0);
        });
    }
    function View_SimpleSnackBar_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'simple-snack-bar', [[
                    'class',
                    'mat-simple-snackbar'
                ]], null, null, null, View_SimpleSnackBar_0, RenderType_SimpleSnackBar)),
            directiveDef(1, 49152, null, 0, SimpleSnackBar, [
                MatSnackBarRef,
                MAT_SNACK_BAR_DATA
            ], null, null)
        ], null, null);
    }
    var SimpleSnackBarNgFactory = createComponentFactory('simple-snack-bar', SimpleSnackBar, View_SimpleSnackBar_Host_0, {}, {}, []);
    var f$2 = MatSnackBarContainerNgFactory;
    var j = SimpleSnackBarNgFactory;
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}mat-expansion-panel[_ngcontent-%COMP%]{width:400px}.mat-expansion-panel-header[_ngcontent-%COMP%]{padding:0 5px 0 0}mat-form-field[_ngcontent-%COMP%]{width:400px}mat-radio-button[_ngcontent-%COMP%]{margin-left:20px}mat-dialog-actions[_ngcontent-%COMP%]{justify-content:flex-end}.mat-raised-button[_ngcontent-%COMP%]{box-shadow:none;border:1px solid #000}"];
    var MatFormFieldModuleNgFactory = createNgModuleFactory(MatFormFieldModule, [], function (_l) {
        return moduleDef([
            moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [
                [
                    8,
                    []
                ],
                [
                    3,
                    ComponentFactoryResolver
                ],
                NgModuleRef
            ]),
            moduleProvideDef(4608, NgLocalization, NgLocaleLocalization, [
                LOCALE_ID$1,
                [
                    2,
                    DEPRECATED_PLURAL_FN
                ]
            ]),
            moduleProvideDef(4608, MutationObserverFactory, MutationObserverFactory, []),
            moduleProvideDef(1073742336, CommonModule, CommonModule, []),
            moduleProvideDef(1073742336, ObserversModule, ObserversModule, []),
            moduleProvideDef(1073742336, MatFormFieldModule, MatFormFieldModule, [])
        ]);
    });
    var styles_MatFormField = [
        '.mat-form-field{display:inline-block;position:relative;text-align:left}[dir=rtl] .mat-form-field{text-align:right}.mat-form-field-wrapper{position:relative}.mat-form-field-flex{display:inline-flex;align-items:baseline;box-sizing:border-box;width:100%}.mat-form-field-prefix,.mat-form-field-suffix{white-space:nowrap;flex:none;position:relative}.mat-form-field-infix{display:block;position:relative;flex:auto;min-width:0;width:180px}@media (-ms-high-contrast:active){.mat-form-field-infix{border-image:linear-gradient(transparent,transparent)}}.mat-form-field-label-wrapper{position:absolute;left:0;box-sizing:content-box;width:100%;height:100%;overflow:hidden;pointer-events:none}[dir=rtl] .mat-form-field-label-wrapper{left:auto;right:0}.mat-form-field-label{position:absolute;left:0;font:inherit;pointer-events:none;width:100%;white-space:nowrap;text-overflow:ellipsis;overflow:hidden;transform-origin:0 0;transition:transform .4s cubic-bezier(.25,.8,.25,1),color .4s cubic-bezier(.25,.8,.25,1),width .4s cubic-bezier(.25,.8,.25,1);display:none}[dir=rtl] .mat-form-field-label{transform-origin:100% 0;left:auto;right:0}.mat-form-field-can-float.mat-form-field-should-float .mat-form-field-label,.mat-form-field-empty.mat-form-field-label{display:block}.mat-form-field-autofill-control:-webkit-autofill+.mat-form-field-label-wrapper .mat-form-field-label{display:none}.mat-form-field-can-float .mat-form-field-autofill-control:-webkit-autofill+.mat-form-field-label-wrapper .mat-form-field-label{display:block;transition:none}.mat-input-server:focus+.mat-form-field-label-wrapper .mat-form-field-label,.mat-input-server[placeholder]:not(:placeholder-shown)+.mat-form-field-label-wrapper .mat-form-field-label{display:none}.mat-form-field-can-float .mat-input-server:focus+.mat-form-field-label-wrapper .mat-form-field-label,.mat-form-field-can-float .mat-input-server[placeholder]:not(:placeholder-shown)+.mat-form-field-label-wrapper .mat-form-field-label{display:block}.mat-form-field-label:not(.mat-form-field-empty){transition:none}.mat-form-field-underline{position:absolute;width:100%;pointer-events:none;transform:scaleY(1.0001)}.mat-form-field-ripple{position:absolute;left:0;width:100%;transform-origin:50%;transform:scaleX(.5);opacity:0;transition:background-color .3s cubic-bezier(.55,0,.55,.2)}.mat-form-field.mat-focused .mat-form-field-ripple,.mat-form-field.mat-form-field-invalid .mat-form-field-ripple{opacity:1;transform:scaleX(1);transition:transform .3s cubic-bezier(.25,.8,.25,1),opacity .1s cubic-bezier(.25,.8,.25,1),background-color .3s cubic-bezier(.25,.8,.25,1)}.mat-form-field-subscript-wrapper{position:absolute;box-sizing:border-box;width:100%;overflow:hidden}.mat-form-field-label-wrapper .mat-icon,.mat-form-field-subscript-wrapper .mat-icon{width:1em;height:1em;font-size:inherit;vertical-align:baseline}.mat-form-field-hint-wrapper{display:flex}.mat-form-field-hint-spacer{flex:1 0 1em}.mat-error{display:block}.mat-form-field-control-wrapper{position:relative}.mat-form-field._mat-animation-noopable .mat-form-field-label,.mat-form-field._mat-animation-noopable .mat-form-field-ripple{transition:none}',
        ".mat-form-field-appearance-fill .mat-form-field-flex{border-radius:4px 4px 0 0;padding:.75em .75em 0 .75em}@media (-ms-high-contrast:active){.mat-form-field-appearance-fill .mat-form-field-flex{outline:solid 1px}}.mat-form-field-appearance-fill .mat-form-field-underline::before{content:'';display:block;position:absolute;bottom:0;height:1px;width:100%}.mat-form-field-appearance-fill .mat-form-field-ripple{bottom:0;height:2px}@media (-ms-high-contrast:active){.mat-form-field-appearance-fill .mat-form-field-ripple{height:0;border-top:solid 2px}}.mat-form-field-appearance-fill:not(.mat-form-field-disabled) .mat-form-field-flex:hover~.mat-form-field-underline .mat-form-field-ripple{opacity:1;transform:none;transition:opacity .6s cubic-bezier(.25,.8,.25,1)}.mat-form-field-appearance-fill._mat-animation-noopable:not(.mat-form-field-disabled) .mat-form-field-flex:hover~.mat-form-field-underline .mat-form-field-ripple{transition:none}.mat-form-field-appearance-fill .mat-form-field-subscript-wrapper{padding:0 1em}",
        ".mat-input-element{font:inherit;background:0 0;color:currentColor;border:none;outline:0;padding:0;margin:0;width:100%;max-width:100%;vertical-align:bottom;text-align:inherit}.mat-input-element:-moz-ui-invalid{box-shadow:none}.mat-input-element::-ms-clear,.mat-input-element::-ms-reveal{display:none}.mat-input-element,.mat-input-element::-webkit-search-cancel-button,.mat-input-element::-webkit-search-decoration,.mat-input-element::-webkit-search-results-button,.mat-input-element::-webkit-search-results-decoration{-webkit-appearance:none}.mat-input-element::-webkit-caps-lock-indicator,.mat-input-element::-webkit-contacts-auto-fill-button,.mat-input-element::-webkit-credentials-auto-fill-button{visibility:hidden}.mat-input-element[type=date]::after,.mat-input-element[type=datetime-local]::after,.mat-input-element[type=datetime]::after,.mat-input-element[type=month]::after,.mat-input-element[type=time]::after,.mat-input-element[type=week]::after{content:' ';white-space:pre;width:1px}.mat-input-element::-webkit-calendar-picker-indicator,.mat-input-element::-webkit-clear-button,.mat-input-element::-webkit-inner-spin-button{font-size:.75em}.mat-input-element::placeholder{-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;transition:color .4s .133s cubic-bezier(.25,.8,.25,1)}.mat-input-element::placeholder:-ms-input-placeholder{-ms-user-select:text}.mat-input-element::-moz-placeholder{-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;transition:color .4s .133s cubic-bezier(.25,.8,.25,1)}.mat-input-element::-moz-placeholder:-ms-input-placeholder{-ms-user-select:text}.mat-input-element::-webkit-input-placeholder{-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;transition:color .4s .133s cubic-bezier(.25,.8,.25,1)}.mat-input-element::-webkit-input-placeholder:-ms-input-placeholder{-ms-user-select:text}.mat-input-element:-ms-input-placeholder{-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;transition:color .4s .133s cubic-bezier(.25,.8,.25,1)}.mat-input-element:-ms-input-placeholder:-ms-input-placeholder{-ms-user-select:text}.mat-form-field-hide-placeholder .mat-input-element::placeholder{color:transparent!important;-webkit-text-fill-color:transparent;transition:none}.mat-form-field-hide-placeholder .mat-input-element::-moz-placeholder{color:transparent!important;-webkit-text-fill-color:transparent;transition:none}.mat-form-field-hide-placeholder .mat-input-element::-webkit-input-placeholder{color:transparent!important;-webkit-text-fill-color:transparent;transition:none}.mat-form-field-hide-placeholder .mat-input-element:-ms-input-placeholder{color:transparent!important;-webkit-text-fill-color:transparent;transition:none}textarea.mat-input-element{resize:vertical;overflow:auto}textarea.mat-input-element.cdk-textarea-autosize{resize:none}textarea.mat-input-element{padding:2px 0;margin:-2px 0}select.mat-input-element{-moz-appearance:none;-webkit-appearance:none;position:relative;background-color:transparent;display:inline-flex;box-sizing:border-box;padding-top:1em;top:-1em;margin-bottom:-1em}select.mat-input-element::-ms-expand{display:none}select.mat-input-element::-moz-focus-inner{border:0}select.mat-input-element:not(:disabled){cursor:pointer}select.mat-input-element::-ms-value{color:inherit;background:0 0}@media (-ms-high-contrast:active){.mat-focused select.mat-input-element::-ms-value{color:inherit}}.mat-form-field-type-mat-native-select .mat-form-field-infix::after{content:'';width:0;height:0;border-left:5px solid transparent;border-right:5px solid transparent;border-top:5px solid;position:absolute;top:50%;right:0;margin-top:-2.5px;pointer-events:none}[dir=rtl] .mat-form-field-type-mat-native-select .mat-form-field-infix::after{right:auto;left:0}.mat-form-field-type-mat-native-select .mat-input-element{padding-right:15px}[dir=rtl] .mat-form-field-type-mat-native-select .mat-input-element{padding-right:0;padding-left:15px}.mat-form-field-type-mat-native-select .mat-form-field-label-wrapper{max-width:calc(100% - 10px)}.mat-form-field-type-mat-native-select.mat-form-field-appearance-outline .mat-form-field-infix::after{margin-top:-5px}.mat-form-field-type-mat-native-select.mat-form-field-appearance-fill .mat-form-field-infix::after{margin-top:-10px}",
        '.mat-form-field-appearance-legacy .mat-form-field-label{transform:perspective(100px);-ms-transform:none}.mat-form-field-appearance-legacy .mat-form-field-prefix .mat-icon,.mat-form-field-appearance-legacy .mat-form-field-suffix .mat-icon{width:1em}.mat-form-field-appearance-legacy .mat-form-field-prefix .mat-icon-button,.mat-form-field-appearance-legacy .mat-form-field-suffix .mat-icon-button{font:inherit;vertical-align:baseline}.mat-form-field-appearance-legacy .mat-form-field-prefix .mat-icon-button .mat-icon,.mat-form-field-appearance-legacy .mat-form-field-suffix .mat-icon-button .mat-icon{font-size:inherit}.mat-form-field-appearance-legacy .mat-form-field-underline{height:1px}@media (-ms-high-contrast:active){.mat-form-field-appearance-legacy .mat-form-field-underline{height:0;border-top:solid 1px}}.mat-form-field-appearance-legacy .mat-form-field-ripple{top:0;height:2px;overflow:hidden}@media (-ms-high-contrast:active){.mat-form-field-appearance-legacy .mat-form-field-ripple{height:0;border-top:solid 2px}}.mat-form-field-appearance-legacy.mat-form-field-disabled .mat-form-field-underline{background-position:0;background-color:transparent}@media (-ms-high-contrast:active){.mat-form-field-appearance-legacy.mat-form-field-disabled .mat-form-field-underline{border-top-style:dotted;border-top-width:2px}}.mat-form-field-appearance-legacy.mat-form-field-invalid:not(.mat-focused) .mat-form-field-ripple{height:1px}',
        '.mat-form-field-appearance-outline .mat-form-field-wrapper{margin:.25em 0}.mat-form-field-appearance-outline .mat-form-field-flex{padding:0 .75em 0 .75em;margin-top:-.25em;position:relative}.mat-form-field-appearance-outline .mat-form-field-prefix,.mat-form-field-appearance-outline .mat-form-field-suffix{top:.25em}.mat-form-field-appearance-outline .mat-form-field-outline{display:flex;position:absolute;top:.25em;left:0;right:0;bottom:0;pointer-events:none}.mat-form-field-appearance-outline .mat-form-field-outline-end,.mat-form-field-appearance-outline .mat-form-field-outline-start{border:1px solid currentColor;min-width:5px}.mat-form-field-appearance-outline .mat-form-field-outline-start{border-radius:5px 0 0 5px;border-right-style:none}[dir=rtl] .mat-form-field-appearance-outline .mat-form-field-outline-start{border-right-style:solid;border-left-style:none;border-radius:0 5px 5px 0}.mat-form-field-appearance-outline .mat-form-field-outline-end{border-radius:0 5px 5px 0;border-left-style:none;flex-grow:1}[dir=rtl] .mat-form-field-appearance-outline .mat-form-field-outline-end{border-left-style:solid;border-right-style:none;border-radius:5px 0 0 5px}.mat-form-field-appearance-outline .mat-form-field-outline-gap{border-radius:.000001px;border:1px solid currentColor;border-left-style:none;border-right-style:none}.mat-form-field-appearance-outline.mat-form-field-can-float.mat-form-field-should-float .mat-form-field-outline-gap{border-top-color:transparent}.mat-form-field-appearance-outline .mat-form-field-outline-thick{opacity:0}.mat-form-field-appearance-outline .mat-form-field-outline-thick .mat-form-field-outline-end,.mat-form-field-appearance-outline .mat-form-field-outline-thick .mat-form-field-outline-gap,.mat-form-field-appearance-outline .mat-form-field-outline-thick .mat-form-field-outline-start{border-width:2px;transition:border-color .3s cubic-bezier(.25,.8,.25,1)}.mat-form-field-appearance-outline.mat-focused .mat-form-field-outline,.mat-form-field-appearance-outline.mat-form-field-invalid .mat-form-field-outline{opacity:0;transition:opacity .1s cubic-bezier(.25,.8,.25,1)}.mat-form-field-appearance-outline.mat-focused .mat-form-field-outline-thick,.mat-form-field-appearance-outline.mat-form-field-invalid .mat-form-field-outline-thick{opacity:1}.mat-form-field-appearance-outline:not(.mat-form-field-disabled) .mat-form-field-flex:hover .mat-form-field-outline{opacity:0;transition:opacity .6s cubic-bezier(.25,.8,.25,1)}.mat-form-field-appearance-outline:not(.mat-form-field-disabled) .mat-form-field-flex:hover .mat-form-field-outline-thick{opacity:1}.mat-form-field-appearance-outline .mat-form-field-subscript-wrapper{padding:0 1em}.mat-form-field-appearance-outline._mat-animation-noopable .mat-form-field-outline,.mat-form-field-appearance-outline._mat-animation-noopable .mat-form-field-outline-end,.mat-form-field-appearance-outline._mat-animation-noopable .mat-form-field-outline-gap,.mat-form-field-appearance-outline._mat-animation-noopable .mat-form-field-outline-start,.mat-form-field-appearance-outline._mat-animation-noopable:not(.mat-form-field-disabled) .mat-form-field-flex:hover~.mat-form-field-outline{transition:none}',
        '.mat-form-field-appearance-standard .mat-form-field-flex{padding-top:.75em}.mat-form-field-appearance-standard .mat-form-field-underline{height:1px}@media (-ms-high-contrast:active){.mat-form-field-appearance-standard .mat-form-field-underline{height:0;border-top:solid 1px}}.mat-form-field-appearance-standard .mat-form-field-ripple{bottom:0;height:2px}@media (-ms-high-contrast:active){.mat-form-field-appearance-standard .mat-form-field-ripple{height:0;border-top:2px}}.mat-form-field-appearance-standard.mat-form-field-disabled .mat-form-field-underline{background-position:0;background-color:transparent}@media (-ms-high-contrast:active){.mat-form-field-appearance-standard.mat-form-field-disabled .mat-form-field-underline{border-top-style:dotted;border-top-width:2px}}.mat-form-field-appearance-standard:not(.mat-form-field-disabled) .mat-form-field-flex:hover~.mat-form-field-underline .mat-form-field-ripple{opacity:1;transform:none;transition:opacity .6s cubic-bezier(.25,.8,.25,1)}.mat-form-field-appearance-standard._mat-animation-noopable:not(.mat-form-field-disabled) .mat-form-field-flex:hover~.mat-form-field-underline .mat-form-field-ripple{transition:none}'
    ];
    var RenderType_MatFormField = createRendererType2({
        encapsulation: 2,
        styles: styles_MatFormField,
        data: {
            'animation': [{
                    type: 7,
                    name: 'transitionMessages',
                    definitions: [
                        {
                            type: 0,
                            name: 'enter',
                            styles: {
                                type: 6,
                                styles: {
                                    opacity: 1,
                                    transform: 'translateY(0%)'
                                },
                                offset: null
                            },
                            options: undefined
                        },
                        {
                            type: 1,
                            expr: 'void => enter',
                            animation: [
                                {
                                    type: 6,
                                    styles: {
                                        opacity: 0,
                                        transform: 'translateY(-100%)'
                                    },
                                    offset: null
                                },
                                {
                                    type: 4,
                                    styles: null,
                                    timings: '300ms cubic-bezier(0.55, 0, 0.55, 0.2)'
                                }
                            ],
                            options: null
                        }
                    ],
                    options: {}
                }]
        }
    });
    function View_MatFormField_1(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 8, null, null, null, null, null, null, null)),
            (_l()(), elementDef(1, 0, null, null, 3, 'div', [[
                    'class',
                    'mat-form-field-outline'
                ]], null, null, null, null, null)),
            (_l()(), elementDef(2, 0, null, null, 0, 'div', [[
                    'class',
                    'mat-form-field-outline-start'
                ]], null, null, null, null, null)),
            (_l()(), elementDef(3, 0, null, null, 0, 'div', [[
                    'class',
                    'mat-form-field-outline-gap'
                ]], null, null, null, null, null)),
            (_l()(), elementDef(4, 0, null, null, 0, 'div', [[
                    'class',
                    'mat-form-field-outline-end'
                ]], null, null, null, null, null)),
            (_l()(), elementDef(5, 0, null, null, 3, 'div', [[
                    'class',
                    'mat-form-field-outline mat-form-field-outline-thick'
                ]], null, null, null, null, null)),
            (_l()(), elementDef(6, 0, null, null, 0, 'div', [[
                    'class',
                    'mat-form-field-outline-start'
                ]], null, null, null, null, null)),
            (_l()(), elementDef(7, 0, null, null, 0, 'div', [[
                    'class',
                    'mat-form-field-outline-gap'
                ]], null, null, null, null, null)),
            (_l()(), elementDef(8, 0, null, null, 0, 'div', [[
                    'class',
                    'mat-form-field-outline-end'
                ]], null, null, null, null, null))
        ], null, null);
    }
    function View_MatFormField_2(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'div', [[
                    'class',
                    'mat-form-field-prefix'
                ]], null, null, null, null, null)),
            ngContentDef(null, 0)
        ], null, null);
    }
    function View_MatFormField_4(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 3, null, null, null, null, null, null, null)),
            ngContentDef(null, 2),
            (_l()(), elementDef(2, 0, null, null, 1, 'span', [], null, null, null, null, null)),
            (_l()(), textDef(3, null, [
                '',
                ''
            ]))
        ], null, function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co._control.placeholder;
            _ck(_v, 3, 0, currVal_0);
        });
    }
    function View_MatFormField_5(_l) {
        return viewDef(0, [
            ngContentDef(null, 3),
            (_l()(), anchorDef(0, null, null, 0))
        ], null, null);
    }
    function View_MatFormField_6(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'span', [
                [
                    'aria-hidden',
                    'true'
                ],
                [
                    'class',
                    'mat-placeholder-required mat-form-field-required-marker'
                ]
            ], null, null, null, null, null)),
            (_l()(), textDef(-1, null, [' *']))
        ], null, null);
    }
    function View_MatFormField_3(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, [
                [
                    4,
                    0
                ],
                [
                    'label',
                    1
                ]
            ], null, 8, 'label', [[
                    'class',
                    'mat-form-field-label'
                ]], [
                [
                    8,
                    'id',
                    0
                ],
                [
                    1,
                    'for',
                    0
                ],
                [
                    1,
                    'aria-owns',
                    0
                ],
                [
                    2,
                    'mat-empty',
                    null
                ],
                [
                    2,
                    'mat-form-field-empty',
                    null
                ],
                [
                    2,
                    'mat-accent',
                    null
                ],
                [
                    2,
                    'mat-warn',
                    null
                ]
            ], [[
                    null,
                    'cdkObserveContent'
                ]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if ('cdkObserveContent' === en) {
                    var pd_0 = _co.updateOutlineGap() !== false;
                    ad = pd_0 && ad;
                }
                return ad;
            }, null, null)),
            directiveDef(1, 16384, null, 0, NgSwitch, [], {
                ngSwitch: [
                    0,
                    'ngSwitch'
                ]
            }, null),
            directiveDef(2, 1196032, null, 0, CdkObserveContent, [
                ContentObserver,
                ElementRef,
                NgZone
            ], {
                disabled: [
                    0,
                    'disabled'
                ]
            }, { event: 'cdkObserveContent' }),
            (_l()(), anchorDef(16777216, null, null, 1, null, View_MatFormField_4)),
            directiveDef(4, 278528, null, 0, NgSwitchCase, [
                ViewContainerRef,
                TemplateRef,
                NgSwitch
            ], {
                ngSwitchCase: [
                    0,
                    'ngSwitchCase'
                ]
            }, null),
            (_l()(), anchorDef(16777216, null, null, 1, null, View_MatFormField_5)),
            directiveDef(6, 278528, null, 0, NgSwitchCase, [
                ViewContainerRef,
                TemplateRef,
                NgSwitch
            ], {
                ngSwitchCase: [
                    0,
                    'ngSwitchCase'
                ]
            }, null),
            (_l()(), anchorDef(16777216, null, null, 1, null, View_MatFormField_6)),
            directiveDef(8, 16384, null, 0, NgIf, [
                ViewContainerRef,
                TemplateRef
            ], {
                ngIf: [
                    0,
                    'ngIf'
                ]
            }, null)
        ], function (_ck, _v) {
            var _co = _v.component;
            var currVal_7 = _co._hasLabel();
            _ck(_v, 1, 0, currVal_7);
            var currVal_8 = _co.appearance != 'outline';
            _ck(_v, 2, 0, currVal_8);
            var currVal_9 = false;
            _ck(_v, 4, 0, currVal_9);
            var currVal_10 = true;
            _ck(_v, 6, 0, currVal_10);
            var currVal_11 = !_co.hideRequiredMarker && _co._control.required && !_co._control.disabled;
            _ck(_v, 8, 0, currVal_11);
        }, function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co._labelId;
            var currVal_1 = _co._control.id;
            var currVal_2 = _co._control.id;
            var currVal_3 = _co._control.empty && !_co._shouldAlwaysFloat;
            var currVal_4 = _co._control.empty && !_co._shouldAlwaysFloat;
            var currVal_5 = _co.color == 'accent';
            var currVal_6 = _co.color == 'warn';
            _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5, currVal_6);
        });
    }
    function View_MatFormField_7(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'div', [[
                    'class',
                    'mat-form-field-suffix'
                ]], null, null, null, null, null)),
            ngContentDef(null, 4)
        ], null, null);
    }
    function View_MatFormField_8(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, [
                [
                    1,
                    0
                ],
                [
                    'underline',
                    1
                ]
            ], null, 1, 'div', [[
                    'class',
                    'mat-form-field-underline'
                ]], null, null, null, null, null)),
            (_l()(), elementDef(1, 0, null, null, 0, 'span', [[
                    'class',
                    'mat-form-field-ripple'
                ]], [
                [
                    2,
                    'mat-accent',
                    null
                ],
                [
                    2,
                    'mat-warn',
                    null
                ]
            ], null, null, null, null))
        ], null, function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co.color == 'accent';
            var currVal_1 = _co.color == 'warn';
            _ck(_v, 1, 0, currVal_0, currVal_1);
        });
    }
    function View_MatFormField_9(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'div', [], [[
                    24,
                    '@transitionMessages',
                    0
                ]], null, null, null, null)),
            ngContentDef(null, 5)
        ], null, function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co._subscriptAnimationState;
            _ck(_v, 0, 0, currVal_0);
        });
    }
    function View_MatFormField_11(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'div', [[
                    'class',
                    'mat-hint'
                ]], [[
                    8,
                    'id',
                    0
                ]], null, null, null, null)),
            (_l()(), textDef(1, null, [
                '',
                ''
            ]))
        ], null, function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co._hintLabelId;
            _ck(_v, 0, 0, currVal_0);
            var currVal_1 = _co.hintLabel;
            _ck(_v, 1, 0, currVal_1);
        });
    }
    function View_MatFormField_10(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 5, 'div', [[
                    'class',
                    'mat-form-field-hint-wrapper'
                ]], [[
                    24,
                    '@transitionMessages',
                    0
                ]], null, null, null, null)),
            (_l()(), anchorDef(16777216, null, null, 1, null, View_MatFormField_11)),
            directiveDef(2, 16384, null, 0, NgIf, [
                ViewContainerRef,
                TemplateRef
            ], {
                ngIf: [
                    0,
                    'ngIf'
                ]
            }, null),
            ngContentDef(null, 6),
            (_l()(), elementDef(4, 0, null, null, 0, 'div', [[
                    'class',
                    'mat-form-field-hint-spacer'
                ]], null, null, null, null, null)),
            ngContentDef(null, 7)
        ], function (_ck, _v) {
            var _co = _v.component;
            var currVal_1 = _co.hintLabel;
            _ck(_v, 2, 0, currVal_1);
        }, function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co._subscriptAnimationState;
            _ck(_v, 0, 0, currVal_0);
        });
    }
    function View_MatFormField_0(_l) {
        return viewDef(2, [
            queryDef(671088640, 1, { underlineRef: 0 }),
            queryDef(402653184, 2, { _connectionContainerRef: 0 }),
            queryDef(671088640, 3, { _inputContainerRef: 0 }),
            queryDef(671088640, 4, { _label: 0 }),
            (_l()(), elementDef(4, 0, null, null, 20, 'div', [[
                    'class',
                    'mat-form-field-wrapper'
                ]], null, null, null, null, null)),
            (_l()(), elementDef(5, 0, [
                [
                    2,
                    0
                ],
                [
                    'connectionContainer',
                    1
                ]
            ], null, 11, 'div', [[
                    'class',
                    'mat-form-field-flex'
                ]], null, [[
                    null,
                    'click'
                ]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if ('click' === en) {
                    var pd_0 = (_co._control.onContainerClick && _co._control.onContainerClick($event)) !== false;
                    ad = pd_0 && ad;
                }
                return ad;
            }, null, null)),
            (_l()(), anchorDef(16777216, null, null, 1, null, View_MatFormField_1)),
            directiveDef(7, 16384, null, 0, NgIf, [
                ViewContainerRef,
                TemplateRef
            ], {
                ngIf: [
                    0,
                    'ngIf'
                ]
            }, null),
            (_l()(), anchorDef(16777216, null, null, 1, null, View_MatFormField_2)),
            directiveDef(9, 16384, null, 0, NgIf, [
                ViewContainerRef,
                TemplateRef
            ], {
                ngIf: [
                    0,
                    'ngIf'
                ]
            }, null),
            (_l()(), elementDef(10, 0, [
                [
                    3,
                    0
                ],
                [
                    'inputContainer',
                    1
                ]
            ], null, 4, 'div', [[
                    'class',
                    'mat-form-field-infix'
                ]], null, null, null, null, null)),
            ngContentDef(null, 1),
            (_l()(), elementDef(12, 0, null, null, 2, 'span', [[
                    'class',
                    'mat-form-field-label-wrapper'
                ]], null, null, null, null, null)),
            (_l()(), anchorDef(16777216, null, null, 1, null, View_MatFormField_3)),
            directiveDef(14, 16384, null, 0, NgIf, [
                ViewContainerRef,
                TemplateRef
            ], {
                ngIf: [
                    0,
                    'ngIf'
                ]
            }, null),
            (_l()(), anchorDef(16777216, null, null, 1, null, View_MatFormField_7)),
            directiveDef(16, 16384, null, 0, NgIf, [
                ViewContainerRef,
                TemplateRef
            ], {
                ngIf: [
                    0,
                    'ngIf'
                ]
            }, null),
            (_l()(), anchorDef(16777216, null, null, 1, null, View_MatFormField_8)),
            directiveDef(18, 16384, null, 0, NgIf, [
                ViewContainerRef,
                TemplateRef
            ], {
                ngIf: [
                    0,
                    'ngIf'
                ]
            }, null),
            (_l()(), elementDef(19, 0, null, null, 5, 'div', [[
                    'class',
                    'mat-form-field-subscript-wrapper'
                ]], null, null, null, null, null)),
            directiveDef(20, 16384, null, 0, NgSwitch, [], {
                ngSwitch: [
                    0,
                    'ngSwitch'
                ]
            }, null),
            (_l()(), anchorDef(16777216, null, null, 1, null, View_MatFormField_9)),
            directiveDef(22, 278528, null, 0, NgSwitchCase, [
                ViewContainerRef,
                TemplateRef,
                NgSwitch
            ], {
                ngSwitchCase: [
                    0,
                    'ngSwitchCase'
                ]
            }, null),
            (_l()(), anchorDef(16777216, null, null, 1, null, View_MatFormField_10)),
            directiveDef(24, 278528, null, 0, NgSwitchCase, [
                ViewContainerRef,
                TemplateRef,
                NgSwitch
            ], {
                ngSwitchCase: [
                    0,
                    'ngSwitchCase'
                ]
            }, null)
        ], function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co.appearance == 'outline';
            _ck(_v, 7, 0, currVal_0);
            var currVal_1 = _co._prefixChildren.length;
            _ck(_v, 9, 0, currVal_1);
            var currVal_2 = _co._hasFloatingLabel();
            _ck(_v, 14, 0, currVal_2);
            var currVal_3 = _co._suffixChildren.length;
            _ck(_v, 16, 0, currVal_3);
            var currVal_4 = _co.appearance != 'outline';
            _ck(_v, 18, 0, currVal_4);
            var currVal_5 = _co._getDisplayedMessages();
            _ck(_v, 20, 0, currVal_5);
            var currVal_6 = 'error';
            _ck(_v, 22, 0, currVal_6);
            var currVal_7 = 'hint';
            _ck(_v, 24, 0, currVal_7);
        }, null);
    }
    function View_MatFormField_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 10, 'mat-form-field', [[
                    'class',
                    'mat-form-field'
                ]], [
                [
                    2,
                    'mat-form-field-appearance-standard',
                    null
                ],
                [
                    2,
                    'mat-form-field-appearance-fill',
                    null
                ],
                [
                    2,
                    'mat-form-field-appearance-outline',
                    null
                ],
                [
                    2,
                    'mat-form-field-appearance-legacy',
                    null
                ],
                [
                    2,
                    'mat-form-field-invalid',
                    null
                ],
                [
                    2,
                    'mat-form-field-can-float',
                    null
                ],
                [
                    2,
                    'mat-form-field-should-float',
                    null
                ],
                [
                    2,
                    'mat-form-field-has-label',
                    null
                ],
                [
                    2,
                    'mat-form-field-hide-placeholder',
                    null
                ],
                [
                    2,
                    'mat-form-field-disabled',
                    null
                ],
                [
                    2,
                    'mat-form-field-autofilled',
                    null
                ],
                [
                    2,
                    'mat-focused',
                    null
                ],
                [
                    2,
                    'mat-accent',
                    null
                ],
                [
                    2,
                    'mat-warn',
                    null
                ],
                [
                    2,
                    'ng-untouched',
                    null
                ],
                [
                    2,
                    'ng-touched',
                    null
                ],
                [
                    2,
                    'ng-pristine',
                    null
                ],
                [
                    2,
                    'ng-dirty',
                    null
                ],
                [
                    2,
                    'ng-valid',
                    null
                ],
                [
                    2,
                    'ng-invalid',
                    null
                ],
                [
                    2,
                    'ng-pending',
                    null
                ],
                [
                    2,
                    '_mat-animation-noopable',
                    null
                ]
            ], null, null, View_MatFormField_0, RenderType_MatFormField)),
            directiveDef(1, 7520256, null, 9, MatFormField, [
                ElementRef,
                ChangeDetectorRef,
                [
                    2,
                    MAT_LABEL_GLOBAL_OPTIONS
                ],
                [
                    2,
                    Directionality
                ],
                [
                    2,
                    MAT_FORM_FIELD_DEFAULT_OPTIONS
                ],
                Platform,
                NgZone,
                [
                    2,
                    ANIMATION_MODULE_TYPE
                ]
            ], null, null),
            queryDef(603979776, 1, { _controlNonStatic: 0 }),
            queryDef(335544320, 2, { _controlStatic: 0 }),
            queryDef(603979776, 3, { _labelChildNonStatic: 0 }),
            queryDef(335544320, 4, { _labelChildStatic: 0 }),
            queryDef(603979776, 5, { _placeholderChild: 0 }),
            queryDef(603979776, 6, { _errorChildren: 1 }),
            queryDef(603979776, 7, { _hintChildren: 1 }),
            queryDef(603979776, 8, { _prefixChildren: 1 }),
            queryDef(603979776, 9, { _suffixChildren: 1 })
        ], null, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 1).appearance == 'standard';
            var currVal_1 = nodeValue(_v, 1).appearance == 'fill';
            var currVal_2 = nodeValue(_v, 1).appearance == 'outline';
            var currVal_3 = nodeValue(_v, 1).appearance == 'legacy';
            var currVal_4 = nodeValue(_v, 1)._control.errorState;
            var currVal_5 = nodeValue(_v, 1)._canLabelFloat;
            var currVal_6 = nodeValue(_v, 1)._shouldLabelFloat();
            var currVal_7 = nodeValue(_v, 1)._hasFloatingLabel();
            var currVal_8 = nodeValue(_v, 1)._hideControlPlaceholder();
            var currVal_9 = nodeValue(_v, 1)._control.disabled;
            var currVal_10 = nodeValue(_v, 1)._control.autofilled;
            var currVal_11 = nodeValue(_v, 1)._control.focused;
            var currVal_12 = nodeValue(_v, 1).color == 'accent';
            var currVal_13 = nodeValue(_v, 1).color == 'warn';
            var currVal_14 = nodeValue(_v, 1)._shouldForward('untouched');
            var currVal_15 = nodeValue(_v, 1)._shouldForward('touched');
            var currVal_16 = nodeValue(_v, 1)._shouldForward('pristine');
            var currVal_17 = nodeValue(_v, 1)._shouldForward('dirty');
            var currVal_18 = nodeValue(_v, 1)._shouldForward('valid');
            var currVal_19 = nodeValue(_v, 1)._shouldForward('invalid');
            var currVal_20 = nodeValue(_v, 1)._shouldForward('pending');
            var currVal_21 = !nodeValue(_v, 1)._animationsEnabled;
            _ck(_v, 0, 1, [
                currVal_0,
                currVal_1,
                currVal_2,
                currVal_3,
                currVal_4,
                currVal_5,
                currVal_6,
                currVal_7,
                currVal_8,
                currVal_9,
                currVal_10,
                currVal_11,
                currVal_12,
                currVal_13,
                currVal_14,
                currVal_15,
                currVal_16,
                currVal_17,
                currVal_18,
                currVal_19,
                currVal_20,
                currVal_21
            ]);
        });
    }
    var MatFormFieldNgFactory = createComponentFactory('mat-form-field', MatFormField, View_MatFormField_Host_0, {
        color: 'color',
        appearance: 'appearance',
        hideRequiredMarker: 'hideRequiredMarker',
        hintLabel: 'hintLabel',
        floatLabel: 'floatLabel'
    }, {}, [
        '[matPrefix]',
        '*',
        'mat-placeholder',
        'mat-label',
        '[matSuffix]',
        'mat-error',
        "mat-hint:not([align='end'])",
        "mat-hint[align='end']"
    ]);
    var c$1 = RenderType_MatFormField;
    var d$1 = View_MatFormField_0;
    var MatRadioModuleNgFactory = createNgModuleFactory(MatRadioModule, [], function (_l) {
        return moduleDef([
            moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [
                [
                    8,
                    []
                ],
                [
                    3,
                    ComponentFactoryResolver
                ],
                NgModuleRef
            ]),
            moduleProvideDef(4608, NgLocalization, NgLocaleLocalization, [
                LOCALE_ID$1,
                [
                    2,
                    DEPRECATED_PLURAL_FN
                ]
            ]),
            moduleProvideDef(1073742336, CommonModule, CommonModule, []),
            moduleProvideDef(1073742336, BidiModule, BidiModule, []),
            moduleProvideDef(1073742336, MatCommonModule, MatCommonModule, [
                [
                    2,
                    MATERIAL_SANITY_CHECKS
                ],
                [
                    2,
                    HAMMER_LOADER
                ]
            ]),
            moduleProvideDef(1073742336, PlatformModule, PlatformModule, []),
            moduleProvideDef(1073742336, MatRippleModule, MatRippleModule, []),
            moduleProvideDef(1073742336, MatRadioModule, MatRadioModule, [])
        ]);
    });
    var styles_MatRadioButton = ['.mat-radio-button{display:inline-block;-webkit-tap-highlight-color:transparent;outline:0}.mat-radio-label{-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:pointer;display:inline-flex;align-items:center;white-space:nowrap;vertical-align:middle;width:100%}.mat-radio-container{box-sizing:border-box;display:inline-block;position:relative;width:20px;height:20px;flex-shrink:0}.mat-radio-outer-circle{box-sizing:border-box;height:20px;left:0;position:absolute;top:0;transition:border-color ease 280ms;width:20px;border-width:2px;border-style:solid;border-radius:50%}._mat-animation-noopable .mat-radio-outer-circle{transition:none}.mat-radio-inner-circle{border-radius:50%;box-sizing:border-box;height:20px;left:0;position:absolute;top:0;transition:transform ease 280ms,background-color ease 280ms;width:20px;transform:scale(.001)}._mat-animation-noopable .mat-radio-inner-circle{transition:none}.mat-radio-checked .mat-radio-inner-circle{transform:scale(.5)}@media (-ms-high-contrast:active){.mat-radio-checked .mat-radio-inner-circle{border:solid 10px}}.mat-radio-label-content{-webkit-user-select:auto;-moz-user-select:auto;-ms-user-select:auto;user-select:auto;display:inline-block;order:0;line-height:inherit;padding-left:8px;padding-right:0}[dir=rtl] .mat-radio-label-content{padding-right:8px;padding-left:0}.mat-radio-label-content.mat-radio-label-before{order:-1;padding-left:0;padding-right:8px}[dir=rtl] .mat-radio-label-content.mat-radio-label-before{padding-right:0;padding-left:8px}.mat-radio-disabled,.mat-radio-disabled .mat-radio-label{cursor:default}.mat-radio-button .mat-radio-ripple{position:absolute;left:calc(50% - 20px);top:calc(50% - 20px);height:40px;width:40px;z-index:1;pointer-events:none}.mat-radio-button .mat-radio-ripple .mat-ripple-element:not(.mat-radio-persistent-ripple){opacity:.16}.mat-radio-persistent-ripple{width:100%;height:100%;transform:none}.mat-radio-container:hover .mat-radio-persistent-ripple{opacity:.04}.mat-radio-button:not(.mat-radio-disabled).cdk-keyboard-focused .mat-radio-persistent-ripple,.mat-radio-button:not(.mat-radio-disabled).cdk-program-focused .mat-radio-persistent-ripple{opacity:.12}.mat-radio-disabled .mat-radio-container:hover .mat-radio-persistent-ripple,.mat-radio-persistent-ripple{opacity:0}@media (hover:none){.mat-radio-container:hover .mat-radio-persistent-ripple{display:none}}.mat-radio-input{bottom:0;left:50%}@media (-ms-high-contrast:active){.mat-radio-disabled{opacity:.5}}'];
    var RenderType_MatRadioButton = createRendererType2({
        encapsulation: 2,
        styles: styles_MatRadioButton,
        data: {}
    });
    function View_MatRadioButton_0(_l) {
        return viewDef(2, [
            queryDef(671088640, 1, { _inputElement: 0 }),
            (_l()(), elementDef(1, 0, [[
                    'label',
                    1
                ]], null, 12, 'label', [[
                    'class',
                    'mat-radio-label'
                ]], [[
                    1,
                    'for',
                    0
                ]], null, null, null, null)),
            (_l()(), elementDef(2, 0, null, null, 7, 'div', [[
                    'class',
                    'mat-radio-container'
                ]], null, null, null, null, null)),
            (_l()(), elementDef(3, 0, null, null, 0, 'div', [[
                    'class',
                    'mat-radio-outer-circle'
                ]], null, null, null, null, null)),
            (_l()(), elementDef(4, 0, null, null, 0, 'div', [[
                    'class',
                    'mat-radio-inner-circle'
                ]], null, null, null, null, null)),
            (_l()(), elementDef(5, 0, null, null, 3, 'div', [
                [
                    'class',
                    'mat-radio-ripple mat-ripple'
                ],
                [
                    'mat-ripple',
                    ''
                ]
            ], [[
                    2,
                    'mat-ripple-unbounded',
                    null
                ]], null, null, null, null)),
            directiveDef(6, 212992, null, 0, MatRipple, [
                ElementRef,
                NgZone,
                Platform,
                [
                    2,
                    MAT_RIPPLE_GLOBAL_OPTIONS
                ],
                [
                    2,
                    ANIMATION_MODULE_TYPE
                ]
            ], {
                centered: [
                    0,
                    'centered'
                ],
                radius: [
                    1,
                    'radius'
                ],
                animation: [
                    2,
                    'animation'
                ],
                disabled: [
                    3,
                    'disabled'
                ],
                trigger: [
                    4,
                    'trigger'
                ]
            }, null),
            pureObjectDef(7, { enterDuration: 0 }),
            (_l()(), elementDef(8, 0, null, null, 0, 'div', [[
                    'class',
                    'mat-ripple-element mat-radio-persistent-ripple'
                ]], null, null, null, null, null)),
            (_l()(), elementDef(9, 0, [
                [
                    1,
                    0
                ],
                [
                    'input',
                    1
                ]
            ], null, 0, 'input', [
                [
                    'class',
                    'mat-radio-input cdk-visually-hidden'
                ],
                [
                    'type',
                    'radio'
                ]
            ], [
                [
                    8,
                    'id',
                    0
                ],
                [
                    8,
                    'checked',
                    0
                ],
                [
                    8,
                    'disabled',
                    0
                ],
                [
                    8,
                    'tabIndex',
                    0
                ],
                [
                    1,
                    'name',
                    0
                ],
                [
                    1,
                    'value',
                    0
                ],
                [
                    8,
                    'required',
                    0
                ],
                [
                    1,
                    'aria-label',
                    0
                ],
                [
                    1,
                    'aria-labelledby',
                    0
                ],
                [
                    1,
                    'aria-describedby',
                    0
                ]
            ], [
                [
                    null,
                    'change'
                ],
                [
                    null,
                    'click'
                ]
            ], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if ('change' === en) {
                    var pd_0 = _co._onInputChange($event) !== false;
                    ad = pd_0 && ad;
                }
                if ('click' === en) {
                    var pd_1 = _co._onInputClick($event) !== false;
                    ad = pd_1 && ad;
                }
                return ad;
            }, null, null)),
            (_l()(), elementDef(10, 0, null, null, 3, 'div', [[
                    'class',
                    'mat-radio-label-content'
                ]], [[
                    2,
                    'mat-radio-label-before',
                    null
                ]], null, null, null, null)),
            (_l()(), elementDef(11, 0, null, null, 1, 'span', [[
                    'style',
                    'display:none'
                ]], null, null, null, null, null)),
            (_l()(), textDef(-1, null, ['\xA0'])),
            ngContentDef(null, 0)
        ], function (_ck, _v) {
            var _co = _v.component;
            var currVal_2 = true;
            var currVal_3 = 20;
            var currVal_4 = _ck(_v, 7, 0, 150);
            var currVal_5 = _co._isRippleDisabled();
            var currVal_6 = nodeValue(_v, 1);
            _ck(_v, 6, 0, currVal_2, currVal_3, currVal_4, currVal_5, currVal_6);
        }, function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co.inputId;
            _ck(_v, 1, 0, currVal_0);
            var currVal_1 = nodeValue(_v, 6).unbounded;
            _ck(_v, 5, 0, currVal_1);
            var currVal_7 = _co.inputId;
            var currVal_8 = _co.checked;
            var currVal_9 = _co.disabled;
            var currVal_10 = _co.tabIndex;
            var currVal_11 = _co.name;
            var currVal_12 = _co.value;
            var currVal_13 = _co.required;
            var currVal_14 = _co.ariaLabel;
            var currVal_15 = _co.ariaLabelledby;
            var currVal_16 = _co.ariaDescribedby;
            _ck(_v, 9, 0, currVal_7, currVal_8, currVal_9, currVal_10, currVal_11, currVal_12, currVal_13, currVal_14, currVal_15, currVal_16);
            var currVal_17 = _co.labelPosition == 'before';
            _ck(_v, 10, 0, currVal_17);
        });
    }
    function View_MatRadioButton_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'mat-radio-button', [[
                    'class',
                    'mat-radio-button'
                ]], [
                [
                    2,
                    'mat-radio-checked',
                    null
                ],
                [
                    2,
                    'mat-radio-disabled',
                    null
                ],
                [
                    2,
                    '_mat-animation-noopable',
                    null
                ],
                [
                    2,
                    'mat-primary',
                    null
                ],
                [
                    2,
                    'mat-accent',
                    null
                ],
                [
                    2,
                    'mat-warn',
                    null
                ],
                [
                    1,
                    'tabindex',
                    0
                ],
                [
                    1,
                    'id',
                    0
                ],
                [
                    1,
                    'aria-label',
                    0
                ],
                [
                    1,
                    'aria-labelledby',
                    0
                ],
                [
                    1,
                    'aria-describedby',
                    0
                ]
            ], [[
                    null,
                    'focus'
                ]], function (_v, en, $event) {
                var ad = true;
                if ('focus' === en) {
                    var pd_0 = nodeValue(_v, 1)._inputElement.nativeElement.focus() !== false;
                    ad = pd_0 && ad;
                }
                return ad;
            }, View_MatRadioButton_0, RenderType_MatRadioButton)),
            directiveDef(1, 4440064, null, 0, MatRadioButton, [
                [
                    2,
                    MatRadioGroup
                ],
                ElementRef,
                ChangeDetectorRef,
                FocusMonitor,
                UniqueSelectionDispatcher,
                [
                    2,
                    ANIMATION_MODULE_TYPE
                ],
                [
                    2,
                    MAT_RADIO_DEFAULT_OPTIONS
                ]
            ], null, null)
        ], function (_ck, _v) {
            _ck(_v, 1, 0);
        }, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 1).checked;
            var currVal_1 = nodeValue(_v, 1).disabled;
            var currVal_2 = nodeValue(_v, 1)._animationMode === 'NoopAnimations';
            var currVal_3 = nodeValue(_v, 1).color === 'primary';
            var currVal_4 = nodeValue(_v, 1).color === 'accent';
            var currVal_5 = nodeValue(_v, 1).color === 'warn';
            var currVal_6 = 0 - 1;
            var currVal_7 = nodeValue(_v, 1).id;
            var currVal_8 = null;
            var currVal_9 = null;
            var currVal_10 = null;
            _ck(_v, 0, 1, [
                currVal_0,
                currVal_1,
                currVal_2,
                currVal_3,
                currVal_4,
                currVal_5,
                currVal_6,
                currVal_7,
                currVal_8,
                currVal_9,
                currVal_10
            ]);
        });
    }
    var MatRadioButtonNgFactory = createComponentFactory('mat-radio-button', MatRadioButton, View_MatRadioButton_Host_0, {
        disableRipple: 'disableRipple',
        tabIndex: 'tabIndex',
        id: 'id',
        name: 'name',
        ariaLabel: 'aria-label',
        ariaLabelledby: 'aria-labelledby',
        ariaDescribedby: 'aria-describedby',
        checked: 'checked',
        value: 'value',
        labelPosition: 'labelPosition',
        disabled: 'disabled',
        required: 'required',
        color: 'color'
    }, { change: 'change' }, ['*']);
    var c$2 = RenderType_MatRadioButton;
    var d$2 = View_MatRadioButton_0;
    var MatSelectModuleNgFactory = createNgModuleFactory(MatSelectModule, [], function (_l) {
        return moduleDef([
            moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [
                [
                    8,
                    []
                ],
                [
                    3,
                    ComponentFactoryResolver
                ],
                NgModuleRef
            ]),
            moduleProvideDef(4608, NgLocalization, NgLocaleLocalization, [
                LOCALE_ID$1,
                [
                    2,
                    DEPRECATED_PLURAL_FN
                ]
            ]),
            moduleProvideDef(4608, Overlay, Overlay, [
                ScrollStrategyOptions,
                OverlayContainer,
                ComponentFactoryResolver,
                OverlayPositionBuilder,
                OverlayKeyboardDispatcher,
                Injector,
                NgZone,
                DOCUMENT,
                Directionality,
                [
                    2,
                    Location
                ]
            ]),
            moduleProvideDef(5120, CDK_CONNECTED_OVERLAY_SCROLL_STRATEGY, CDK_CONNECTED_OVERLAY_SCROLL_STRATEGY_PROVIDER_FACTORY, [Overlay]),
            moduleProvideDef(4608, MutationObserverFactory, MutationObserverFactory, []),
            moduleProvideDef(5120, MAT_SELECT_SCROLL_STRATEGY, MAT_SELECT_SCROLL_STRATEGY_PROVIDER_FACTORY, [Overlay]),
            moduleProvideDef(1073742336, CommonModule, CommonModule, []),
            moduleProvideDef(1073742336, BidiModule, BidiModule, []),
            moduleProvideDef(1073742336, PortalModule, PortalModule, []),
            moduleProvideDef(1073742336, PlatformModule, PlatformModule, []),
            moduleProvideDef(1073742336, ScrollingModule, ScrollingModule, []),
            moduleProvideDef(1073742336, OverlayModule, OverlayModule, []),
            moduleProvideDef(1073742336, MatCommonModule, MatCommonModule, [
                [
                    2,
                    MATERIAL_SANITY_CHECKS
                ],
                [
                    2,
                    HAMMER_LOADER
                ]
            ]),
            moduleProvideDef(1073742336, MatRippleModule, MatRippleModule, []),
            moduleProvideDef(1073742336, MatPseudoCheckboxModule, MatPseudoCheckboxModule, []),
            moduleProvideDef(1073742336, MatOptionModule, MatOptionModule, []),
            moduleProvideDef(1073742336, ObserversModule, ObserversModule, []),
            moduleProvideDef(1073742336, MatFormFieldModule, MatFormFieldModule, []),
            moduleProvideDef(1073742336, MatSelectModule, MatSelectModule, [])
        ]);
    });
    var styles_MatSelect = ['.mat-select{display:inline-block;width:100%;outline:0}.mat-select-trigger{display:inline-table;cursor:pointer;position:relative;box-sizing:border-box}.mat-select-disabled .mat-select-trigger{-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:default}.mat-select-value{display:table-cell;max-width:0;width:100%;overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.mat-select-value-text{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}.mat-select-arrow-wrapper{display:table-cell;vertical-align:middle}.mat-form-field-appearance-fill .mat-select-arrow-wrapper{transform:translateY(-50%)}.mat-form-field-appearance-outline .mat-select-arrow-wrapper{transform:translateY(-25%)}.mat-form-field-appearance-standard.mat-form-field-has-label .mat-select:not(.mat-select-empty) .mat-select-arrow-wrapper{transform:translateY(-50%)}.mat-form-field-appearance-standard .mat-select.mat-select-empty .mat-select-arrow-wrapper{transition:transform .4s cubic-bezier(.25,.8,.25,1)}._mat-animation-noopable.mat-form-field-appearance-standard .mat-select.mat-select-empty .mat-select-arrow-wrapper{transition:none}.mat-select-arrow{width:0;height:0;border-left:5px solid transparent;border-right:5px solid transparent;border-top:5px solid;margin:0 4px}.mat-select-panel-wrap{flex-basis:100%}.mat-select-panel{min-width:112px;max-width:280px;overflow:auto;-webkit-overflow-scrolling:touch;padding-top:0;padding-bottom:0;max-height:256px;min-width:100%;border-radius:4px}@media (-ms-high-contrast:active){.mat-select-panel{outline:solid 1px}}.mat-select-panel .mat-optgroup-label,.mat-select-panel .mat-option{font-size:inherit;line-height:3em;height:3em}.mat-form-field-type-mat-select:not(.mat-form-field-disabled) .mat-form-field-flex{cursor:pointer}.mat-form-field-type-mat-select .mat-form-field-label{width:calc(100% - 18px)}.mat-select-placeholder{transition:color .4s .133s cubic-bezier(.25,.8,.25,1)}._mat-animation-noopable .mat-select-placeholder{transition:none}.mat-form-field-hide-placeholder .mat-select-placeholder{color:transparent;-webkit-text-fill-color:transparent;transition:none;display:block}'];
    var RenderType_MatSelect = createRendererType2({
        encapsulation: 2,
        styles: styles_MatSelect,
        data: {
            'animation': [
                {
                    type: 7,
                    name: 'transformPanelWrap',
                    definitions: [{
                            type: 1,
                            expr: '* => void',
                            animation: {
                                type: 11,
                                selector: '@transformPanel',
                                animation: [{
                                        type: 9,
                                        options: null
                                    }],
                                options: { optional: true }
                            },
                            options: null
                        }],
                    options: {}
                },
                {
                    type: 7,
                    name: 'transformPanel',
                    definitions: [
                        {
                            type: 0,
                            name: 'void',
                            styles: {
                                type: 6,
                                styles: {
                                    transform: 'scaleY(0.8)',
                                    minWidth: '100%',
                                    opacity: 0
                                },
                                offset: null
                            },
                            options: undefined
                        },
                        {
                            type: 0,
                            name: 'showing',
                            styles: {
                                type: 6,
                                styles: {
                                    opacity: 1,
                                    minWidth: 'calc(100% + 32px)',
                                    transform: 'scaleY(1)'
                                },
                                offset: null
                            },
                            options: undefined
                        },
                        {
                            type: 0,
                            name: 'showing-multiple',
                            styles: {
                                type: 6,
                                styles: {
                                    opacity: 1,
                                    minWidth: 'calc(100% + 64px)',
                                    transform: 'scaleY(1)'
                                },
                                offset: null
                            },
                            options: undefined
                        },
                        {
                            type: 1,
                            expr: 'void => *',
                            animation: {
                                type: 4,
                                styles: null,
                                timings: '120ms cubic-bezier(0, 0, 0.2, 1)'
                            },
                            options: null
                        },
                        {
                            type: 1,
                            expr: '* => void',
                            animation: {
                                type: 4,
                                styles: {
                                    type: 6,
                                    styles: { opacity: 0 },
                                    offset: null
                                },
                                timings: '100ms 25ms linear'
                            },
                            options: null
                        }
                    ],
                    options: {}
                }
            ]
        }
    });
    function View_MatSelect_1(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'span', [[
                    'class',
                    'mat-select-placeholder'
                ]], null, null, null, null, null)),
            (_l()(), textDef(1, null, [
                '',
                ''
            ]))
        ], null, function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co.placeholder || '\xA0';
            _ck(_v, 1, 0, currVal_0);
        });
    }
    function View_MatSelect_3(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'span', [], null, null, null, null, null)),
            (_l()(), textDef(1, null, [
                '',
                ''
            ]))
        ], null, function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co.triggerValue || '\xA0';
            _ck(_v, 1, 0, currVal_0);
        });
    }
    function View_MatSelect_4(_l) {
        return viewDef(0, [
            ngContentDef(null, 0),
            (_l()(), anchorDef(0, null, null, 0))
        ], null, null);
    }
    function View_MatSelect_2(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 5, 'span', [[
                    'class',
                    'mat-select-value-text'
                ]], null, null, null, null, null)),
            directiveDef(1, 16384, null, 0, NgSwitch, [], {
                ngSwitch: [
                    0,
                    'ngSwitch'
                ]
            }, null),
            (_l()(), anchorDef(16777216, null, null, 1, null, View_MatSelect_3)),
            directiveDef(3, 16384, null, 0, NgSwitchDefault, [
                ViewContainerRef,
                TemplateRef,
                NgSwitch
            ], null, null),
            (_l()(), anchorDef(16777216, null, null, 1, null, View_MatSelect_4)),
            directiveDef(5, 278528, null, 0, NgSwitchCase, [
                ViewContainerRef,
                TemplateRef,
                NgSwitch
            ], {
                ngSwitchCase: [
                    0,
                    'ngSwitchCase'
                ]
            }, null)
        ], function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = !!_co.customTrigger;
            _ck(_v, 1, 0, currVal_0);
            var currVal_1 = true;
            _ck(_v, 5, 0, currVal_1);
        }, null);
    }
    function View_MatSelect_5(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 4, 'div', [[
                    'class',
                    'mat-select-panel-wrap'
                ]], [[
                    24,
                    '@transformPanelWrap',
                    0
                ]], null, null, null, null)),
            (_l()(), elementDef(1, 0, [
                [
                    2,
                    0
                ],
                [
                    'panel',
                    1
                ]
            ], null, 3, 'div', [], [
                [
                    24,
                    '@transformPanel',
                    0
                ],
                [
                    4,
                    'transformOrigin',
                    null
                ],
                [
                    4,
                    'font-size',
                    'px'
                ]
            ], [
                [
                    null,
                    '@transformPanel.done'
                ],
                [
                    null,
                    'keydown'
                ]
            ], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if ('@transformPanel.done' === en) {
                    var pd_0 = _co._panelDoneAnimatingStream.next($event.toState) !== false;
                    ad = pd_0 && ad;
                }
                if ('keydown' === en) {
                    var pd_1 = _co._handleKeydown($event) !== false;
                    ad = pd_1 && ad;
                }
                return ad;
            }, null, null)),
            providerDef(512, null, NgClassImpl, NgClassR2Impl, [
                IterableDiffers,
                KeyValueDiffers,
                ElementRef,
                Renderer2
            ]),
            directiveDef(3, 278528, null, 0, NgClass, [NgClassImpl], {
                klass: [
                    0,
                    'klass'
                ],
                ngClass: [
                    1,
                    'ngClass'
                ]
            }, null),
            ngContentDef(null, 1)
        ], function (_ck, _v) {
            var _co = _v.component;
            var currVal_4 = inlineInterpolate(1, 'mat-select-panel ', _co._getPanelTheme(), '');
            var currVal_5 = _co.panelClass;
            _ck(_v, 3, 0, currVal_4, currVal_5);
        }, function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = undefined;
            _ck(_v, 0, 0, currVal_0);
            var currVal_1 = _co.multiple ? 'showing-multiple' : 'showing';
            var currVal_2 = _co._transformOrigin;
            var currVal_3 = _co._triggerFontSize;
            _ck(_v, 1, 0, currVal_1, currVal_2, currVal_3);
        });
    }
    function View_MatSelect_0(_l) {
        return viewDef(2, [
            queryDef(671088640, 1, { trigger: 0 }),
            queryDef(671088640, 2, { panel: 0 }),
            queryDef(671088640, 3, { overlayDir: 0 }),
            (_l()(), elementDef(3, 0, [
                [
                    1,
                    0
                ],
                [
                    'trigger',
                    1
                ]
            ], null, 9, 'div', [
                [
                    'aria-hidden',
                    'true'
                ],
                [
                    'cdk-overlay-origin',
                    ''
                ],
                [
                    'class',
                    'mat-select-trigger'
                ]
            ], null, [[
                    null,
                    'click'
                ]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if ('click' === en) {
                    var pd_0 = _co.toggle() !== false;
                    ad = pd_0 && ad;
                }
                return ad;
            }, null, null)),
            directiveDef(4, 16384, [[
                    'origin',
                    4
                ]], 0, CdkOverlayOrigin, [ElementRef], null, null),
            (_l()(), elementDef(5, 0, null, null, 5, 'div', [[
                    'class',
                    'mat-select-value'
                ]], null, null, null, null, null)),
            directiveDef(6, 16384, null, 0, NgSwitch, [], {
                ngSwitch: [
                    0,
                    'ngSwitch'
                ]
            }, null),
            (_l()(), anchorDef(16777216, null, null, 1, null, View_MatSelect_1)),
            directiveDef(8, 278528, null, 0, NgSwitchCase, [
                ViewContainerRef,
                TemplateRef,
                NgSwitch
            ], {
                ngSwitchCase: [
                    0,
                    'ngSwitchCase'
                ]
            }, null),
            (_l()(), anchorDef(16777216, null, null, 1, null, View_MatSelect_2)),
            directiveDef(10, 278528, null, 0, NgSwitchCase, [
                ViewContainerRef,
                TemplateRef,
                NgSwitch
            ], {
                ngSwitchCase: [
                    0,
                    'ngSwitchCase'
                ]
            }, null),
            (_l()(), elementDef(11, 0, null, null, 1, 'div', [[
                    'class',
                    'mat-select-arrow-wrapper'
                ]], null, null, null, null, null)),
            (_l()(), elementDef(12, 0, null, null, 0, 'div', [[
                    'class',
                    'mat-select-arrow'
                ]], null, null, null, null, null)),
            (_l()(), anchorDef(16777216, null, null, 1, function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if ('backdropClick' === en) {
                    var pd_0 = _co.close() !== false;
                    ad = pd_0 && ad;
                }
                if ('attach' === en) {
                    var pd_1 = _co._onAttached() !== false;
                    ad = pd_1 && ad;
                }
                if ('detach' === en) {
                    var pd_2 = _co.close() !== false;
                    ad = pd_2 && ad;
                }
                return ad;
            }, View_MatSelect_5)),
            directiveDef(14, 671744, [[
                    3,
                    4
                ]], 0, CdkConnectedOverlay, [
                Overlay,
                TemplateRef,
                ViewContainerRef,
                CDK_CONNECTED_OVERLAY_SCROLL_STRATEGY,
                [
                    2,
                    Directionality
                ]
            ], {
                origin: [
                    0,
                    'origin'
                ],
                positions: [
                    1,
                    'positions'
                ],
                offsetY: [
                    2,
                    'offsetY'
                ],
                minWidth: [
                    3,
                    'minWidth'
                ],
                backdropClass: [
                    4,
                    'backdropClass'
                ],
                scrollStrategy: [
                    5,
                    'scrollStrategy'
                ],
                open: [
                    6,
                    'open'
                ],
                hasBackdrop: [
                    7,
                    'hasBackdrop'
                ],
                lockPosition: [
                    8,
                    'lockPosition'
                ]
            }, {
                backdropClick: 'backdropClick',
                attach: 'attach',
                detach: 'detach'
            })
        ], function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co.empty;
            _ck(_v, 6, 0, currVal_0);
            var currVal_1 = true;
            _ck(_v, 8, 0, currVal_1);
            var currVal_2 = false;
            _ck(_v, 10, 0, currVal_2);
            var currVal_3 = nodeValue(_v, 4);
            var currVal_4 = _co._positions;
            var currVal_5 = _co._offsetY;
            var currVal_6 = _co._triggerRect == null ? null : _co._triggerRect.width;
            var currVal_7 = 'cdk-overlay-transparent-backdrop';
            var currVal_8 = _co._scrollStrategy;
            var currVal_9 = _co.panelOpen;
            var currVal_10 = '';
            var currVal_11 = '';
            _ck(_v, 14, 0, currVal_3, currVal_4, currVal_5, currVal_6, currVal_7, currVal_8, currVal_9, currVal_10, currVal_11);
        }, null);
    }
    function View_MatSelect_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 6, 'mat-select', [
                [
                    'class',
                    'mat-select'
                ],
                [
                    'role',
                    'listbox'
                ]
            ], [
                [
                    1,
                    'id',
                    0
                ],
                [
                    1,
                    'tabindex',
                    0
                ],
                [
                    1,
                    'aria-label',
                    0
                ],
                [
                    1,
                    'aria-labelledby',
                    0
                ],
                [
                    1,
                    'aria-required',
                    0
                ],
                [
                    1,
                    'aria-disabled',
                    0
                ],
                [
                    1,
                    'aria-invalid',
                    0
                ],
                [
                    1,
                    'aria-owns',
                    0
                ],
                [
                    1,
                    'aria-multiselectable',
                    0
                ],
                [
                    1,
                    'aria-describedby',
                    0
                ],
                [
                    1,
                    'aria-activedescendant',
                    0
                ],
                [
                    2,
                    'mat-select-disabled',
                    null
                ],
                [
                    2,
                    'mat-select-invalid',
                    null
                ],
                [
                    2,
                    'mat-select-required',
                    null
                ],
                [
                    2,
                    'mat-select-empty',
                    null
                ]
            ], [
                [
                    null,
                    'keydown'
                ],
                [
                    null,
                    'focus'
                ],
                [
                    null,
                    'blur'
                ]
            ], function (_v, en, $event) {
                var ad = true;
                if ('keydown' === en) {
                    var pd_0 = nodeValue(_v, 3)._handleKeydown($event) !== false;
                    ad = pd_0 && ad;
                }
                if ('focus' === en) {
                    var pd_1 = nodeValue(_v, 3)._onFocus() !== false;
                    ad = pd_1 && ad;
                }
                if ('blur' === en) {
                    var pd_2 = nodeValue(_v, 3)._onBlur() !== false;
                    ad = pd_2 && ad;
                }
                return ad;
            }, View_MatSelect_0, RenderType_MatSelect)),
            providerDef(6144, null, MatFormFieldControl, null, [MatSelect]),
            providerDef(6144, null, MAT_OPTION_PARENT_COMPONENT, null, [MatSelect]),
            directiveDef(3, 2080768, null, 3, MatSelect, [
                ViewportRuler,
                ChangeDetectorRef,
                NgZone,
                ErrorStateMatcher,
                ElementRef,
                [
                    2,
                    Directionality
                ],
                [
                    2,
                    NgForm
                ],
                [
                    2,
                    FormGroupDirective
                ],
                [
                    2,
                    MatFormField
                ],
                [
                    8,
                    null
                ],
                [
                    8,
                    null
                ],
                MAT_SELECT_SCROLL_STRATEGY,
                LiveAnnouncer
            ], null, null),
            queryDef(603979776, 1, { options: 1 }),
            queryDef(603979776, 2, { optionGroups: 1 }),
            queryDef(603979776, 3, { customTrigger: 0 })
        ], function (_ck, _v) {
            _ck(_v, 3, 0);
        }, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 3).id;
            var currVal_1 = nodeValue(_v, 3).tabIndex;
            var currVal_2 = nodeValue(_v, 3)._getAriaLabel();
            var currVal_3 = nodeValue(_v, 3)._getAriaLabelledby();
            var currVal_4 = nodeValue(_v, 3).required.toString();
            var currVal_5 = nodeValue(_v, 3).disabled.toString();
            var currVal_6 = nodeValue(_v, 3).errorState;
            var currVal_7 = nodeValue(_v, 3).panelOpen ? nodeValue(_v, 3)._optionIds : null;
            var currVal_8 = nodeValue(_v, 3).multiple;
            var currVal_9 = nodeValue(_v, 3)._ariaDescribedby || null;
            var currVal_10 = nodeValue(_v, 3)._getAriaActiveDescendant();
            var currVal_11 = nodeValue(_v, 3).disabled;
            var currVal_12 = nodeValue(_v, 3).errorState;
            var currVal_13 = nodeValue(_v, 3).required;
            var currVal_14 = nodeValue(_v, 3).empty;
            _ck(_v, 0, 1, [
                currVal_0,
                currVal_1,
                currVal_2,
                currVal_3,
                currVal_4,
                currVal_5,
                currVal_6,
                currVal_7,
                currVal_8,
                currVal_9,
                currVal_10,
                currVal_11,
                currVal_12,
                currVal_13,
                currVal_14
            ]);
        });
    }
    var MatSelectNgFactory = createComponentFactory('mat-select', MatSelect, View_MatSelect_Host_0, {
        disabled: 'disabled',
        disableRipple: 'disableRipple',
        tabIndex: 'tabIndex',
        panelClass: 'panelClass',
        placeholder: 'placeholder',
        required: 'required',
        multiple: 'multiple',
        disableOptionCentering: 'disableOptionCentering',
        compareWith: 'compareWith',
        value: 'value',
        ariaLabel: 'aria-label',
        ariaLabelledby: 'aria-labelledby',
        errorStateMatcher: 'errorStateMatcher',
        typeaheadDebounceInterval: 'typeaheadDebounceInterval',
        sortComparator: 'sortComparator',
        id: 'id'
    }, {
        openedChange: 'openedChange',
        _openedStream: 'opened',
        _closedStream: 'closed',
        selectionChange: 'selectionChange',
        valueChange: 'valueChange'
    }, [
        'mat-select-trigger',
        '*'
    ]);
    var c$3 = RenderType_MatSelect;
    var d$3 = View_MatSelect_0;
    var MatCommonModuleNgFactory = createNgModuleFactory(MatCommonModule, [], function (_l) {
        return moduleDef([
            moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [
                [
                    8,
                    []
                ],
                [
                    3,
                    ComponentFactoryResolver
                ],
                NgModuleRef
            ]),
            moduleProvideDef(1073742336, BidiModule, BidiModule, []),
            moduleProvideDef(1073742336, MatCommonModule, MatCommonModule, [
                [
                    2,
                    MATERIAL_SANITY_CHECKS
                ],
                [
                    2,
                    HAMMER_LOADER
                ]
            ])
        ]);
    });
    var NativeDateModuleNgFactory = createNgModuleFactory(NativeDateModule, [], function (_l) {
        return moduleDef([
            moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [
                [
                    8,
                    []
                ],
                [
                    3,
                    ComponentFactoryResolver
                ],
                NgModuleRef
            ]),
            moduleProvideDef(4608, DateAdapter, NativeDateAdapter, [
                [
                    2,
                    MAT_DATE_LOCALE
                ],
                Platform
            ]),
            moduleProvideDef(1073742336, PlatformModule, PlatformModule, []),
            moduleProvideDef(1073742336, NativeDateModule, NativeDateModule, [])
        ]);
    });
    var MatNativeDateModuleNgFactory = createNgModuleFactory(MatNativeDateModule, [], function (_l) {
        return moduleDef([
            moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [
                [
                    8,
                    []
                ],
                [
                    3,
                    ComponentFactoryResolver
                ],
                NgModuleRef
            ]),
            moduleProvideDef(4608, DateAdapter, NativeDateAdapter, [
                [
                    2,
                    MAT_DATE_LOCALE
                ],
                Platform
            ]),
            moduleProvideDef(1073742336, PlatformModule, PlatformModule, []),
            moduleProvideDef(1073742336, NativeDateModule, NativeDateModule, []),
            moduleProvideDef(1073742336, MatNativeDateModule, MatNativeDateModule, []),
            moduleProvideDef(256, MAT_DATE_FORMATS, MAT_NATIVE_DATE_FORMATS, [])
        ]);
    });
    var MatLineModuleNgFactory = createNgModuleFactory(MatLineModule, [], function (_l) {
        return moduleDef([
            moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [
                [
                    8,
                    []
                ],
                [
                    3,
                    ComponentFactoryResolver
                ],
                NgModuleRef
            ]),
            moduleProvideDef(1073742336, BidiModule, BidiModule, []),
            moduleProvideDef(1073742336, MatCommonModule, MatCommonModule, [
                [
                    2,
                    MATERIAL_SANITY_CHECKS
                ],
                [
                    2,
                    HAMMER_LOADER
                ]
            ]),
            moduleProvideDef(1073742336, MatLineModule, MatLineModule, [])
        ]);
    });
    var MatOptionModuleNgFactory = createNgModuleFactory(MatOptionModule, [], function (_l) {
        return moduleDef([
            moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [
                [
                    8,
                    []
                ],
                [
                    3,
                    ComponentFactoryResolver
                ],
                NgModuleRef
            ]),
            moduleProvideDef(4608, NgLocalization, NgLocaleLocalization, [
                LOCALE_ID$1,
                [
                    2,
                    DEPRECATED_PLURAL_FN
                ]
            ]),
            moduleProvideDef(1073742336, BidiModule, BidiModule, []),
            moduleProvideDef(1073742336, MatCommonModule, MatCommonModule, [
                [
                    2,
                    MATERIAL_SANITY_CHECKS
                ],
                [
                    2,
                    HAMMER_LOADER
                ]
            ]),
            moduleProvideDef(1073742336, PlatformModule, PlatformModule, []),
            moduleProvideDef(1073742336, MatRippleModule, MatRippleModule, []),
            moduleProvideDef(1073742336, CommonModule, CommonModule, []),
            moduleProvideDef(1073742336, MatPseudoCheckboxModule, MatPseudoCheckboxModule, []),
            moduleProvideDef(1073742336, MatOptionModule, MatOptionModule, [])
        ]);
    });
    var MatRippleModuleNgFactory = createNgModuleFactory(MatRippleModule, [], function (_l) {
        return moduleDef([
            moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [
                [
                    8,
                    []
                ],
                [
                    3,
                    ComponentFactoryResolver
                ],
                NgModuleRef
            ]),
            moduleProvideDef(1073742336, BidiModule, BidiModule, []),
            moduleProvideDef(1073742336, MatCommonModule, MatCommonModule, [
                [
                    2,
                    MATERIAL_SANITY_CHECKS
                ],
                [
                    2,
                    HAMMER_LOADER
                ]
            ]),
            moduleProvideDef(1073742336, PlatformModule, PlatformModule, []),
            moduleProvideDef(1073742336, MatRippleModule, MatRippleModule, [])
        ]);
    });
    var MatPseudoCheckboxModuleNgFactory = createNgModuleFactory(MatPseudoCheckboxModule, [], function (_l) {
        return moduleDef([
            moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [
                [
                    8,
                    []
                ],
                [
                    3,
                    ComponentFactoryResolver
                ],
                NgModuleRef
            ]),
            moduleProvideDef(1073742336, MatPseudoCheckboxModule, MatPseudoCheckboxModule, [])
        ]);
    });
    var styles_MatOption = ['.mat-option{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;display:block;line-height:48px;height:48px;padding:0 16px;text-align:left;text-decoration:none;max-width:100%;position:relative;cursor:pointer;outline:0;display:flex;flex-direction:row;max-width:100%;box-sizing:border-box;align-items:center;-webkit-tap-highlight-color:transparent}.mat-option[disabled]{cursor:default}[dir=rtl] .mat-option{text-align:right}.mat-option .mat-icon{margin-right:16px;vertical-align:middle}.mat-option .mat-icon svg{vertical-align:top}[dir=rtl] .mat-option .mat-icon{margin-left:16px;margin-right:0}.mat-option[aria-disabled=true]{-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:default}.mat-optgroup .mat-option:not(.mat-option-multiple){padding-left:32px}[dir=rtl] .mat-optgroup .mat-option:not(.mat-option-multiple){padding-left:16px;padding-right:32px}@media (-ms-high-contrast:active){.mat-option{margin:0 1px}.mat-option.mat-active{border:solid 1px currentColor;margin:0}}.mat-option-text{display:inline-block;flex-grow:1;overflow:hidden;text-overflow:ellipsis}.mat-option .mat-option-ripple{top:0;left:0;right:0;bottom:0;position:absolute;pointer-events:none}@media (-ms-high-contrast:active){.mat-option .mat-option-ripple{opacity:.5}}.mat-option-pseudo-checkbox{margin-right:8px}[dir=rtl] .mat-option-pseudo-checkbox{margin-left:8px;margin-right:0}'];
    var RenderType_MatOption = createRendererType2({
        encapsulation: 2,
        styles: styles_MatOption,
        data: {}
    });
    function View_MatOption_1(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'mat-pseudo-checkbox', [[
                    'class',
                    'mat-option-pseudo-checkbox mat-pseudo-checkbox'
                ]], [
                [
                    2,
                    'mat-pseudo-checkbox-indeterminate',
                    null
                ],
                [
                    2,
                    'mat-pseudo-checkbox-checked',
                    null
                ],
                [
                    2,
                    'mat-pseudo-checkbox-disabled',
                    null
                ],
                [
                    2,
                    '_mat-animation-noopable',
                    null
                ]
            ], null, null, View_MatPseudoCheckbox_0, RenderType_MatPseudoCheckbox)),
            directiveDef(1, 49152, null, 0, MatPseudoCheckbox, [[
                    2,
                    ANIMATION_MODULE_TYPE
                ]], {
                state: [
                    0,
                    'state'
                ],
                disabled: [
                    1,
                    'disabled'
                ]
            }, null)
        ], function (_ck, _v) {
            var _co = _v.component;
            var currVal_4 = _co.selected ? 'checked' : '';
            var currVal_5 = _co.disabled;
            _ck(_v, 1, 0, currVal_4, currVal_5);
        }, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 1).state === 'indeterminate';
            var currVal_1 = nodeValue(_v, 1).state === 'checked';
            var currVal_2 = nodeValue(_v, 1).disabled;
            var currVal_3 = nodeValue(_v, 1)._animationMode === 'NoopAnimations';
            _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2, currVal_3);
        });
    }
    function View_MatOption_0(_l) {
        return viewDef(2, [
            (_l()(), anchorDef(16777216, null, null, 1, null, View_MatOption_1)),
            directiveDef(1, 16384, null, 0, NgIf, [
                ViewContainerRef,
                TemplateRef
            ], {
                ngIf: [
                    0,
                    'ngIf'
                ]
            }, null),
            (_l()(), elementDef(2, 0, null, null, 1, 'span', [[
                    'class',
                    'mat-option-text'
                ]], null, null, null, null, null)),
            ngContentDef(null, 0),
            (_l()(), elementDef(4, 0, null, null, 1, 'div', [
                [
                    'class',
                    'mat-option-ripple mat-ripple'
                ],
                [
                    'mat-ripple',
                    ''
                ]
            ], [[
                    2,
                    'mat-ripple-unbounded',
                    null
                ]], null, null, null, null)),
            directiveDef(5, 212992, null, 0, MatRipple, [
                ElementRef,
                NgZone,
                Platform,
                [
                    2,
                    MAT_RIPPLE_GLOBAL_OPTIONS
                ],
                [
                    2,
                    ANIMATION_MODULE_TYPE
                ]
            ], {
                disabled: [
                    0,
                    'disabled'
                ],
                trigger: [
                    1,
                    'trigger'
                ]
            }, null)
        ], function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co.multiple;
            _ck(_v, 1, 0, currVal_0);
            var currVal_2 = _co.disabled || _co.disableRipple;
            var currVal_3 = _co._getHostElement();
            _ck(_v, 5, 0, currVal_2, currVal_3);
        }, function (_ck, _v) {
            var currVal_1 = nodeValue(_v, 5).unbounded;
            _ck(_v, 4, 0, currVal_1);
        });
    }
    function View_MatOption_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'mat-option', [
                [
                    'class',
                    'mat-option'
                ],
                [
                    'role',
                    'option'
                ]
            ], [
                [
                    1,
                    'tabindex',
                    0
                ],
                [
                    2,
                    'mat-selected',
                    null
                ],
                [
                    2,
                    'mat-option-multiple',
                    null
                ],
                [
                    2,
                    'mat-active',
                    null
                ],
                [
                    8,
                    'id',
                    0
                ],
                [
                    1,
                    'aria-selected',
                    0
                ],
                [
                    1,
                    'aria-disabled',
                    0
                ],
                [
                    2,
                    'mat-option-disabled',
                    null
                ]
            ], [
                [
                    null,
                    'click'
                ],
                [
                    null,
                    'keydown'
                ]
            ], function (_v, en, $event) {
                var ad = true;
                if ('click' === en) {
                    var pd_0 = nodeValue(_v, 1)._selectViaInteraction() !== false;
                    ad = pd_0 && ad;
                }
                if ('keydown' === en) {
                    var pd_1 = nodeValue(_v, 1)._handleKeydown($event) !== false;
                    ad = pd_1 && ad;
                }
                return ad;
            }, View_MatOption_0, RenderType_MatOption)),
            directiveDef(1, 8568832, null, 0, MatOption, [
                ElementRef,
                ChangeDetectorRef,
                [
                    2,
                    MAT_OPTION_PARENT_COMPONENT
                ],
                [
                    2,
                    MatOptgroup
                ]
            ], null, null)
        ], null, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 1)._getTabIndex();
            var currVal_1 = nodeValue(_v, 1).selected;
            var currVal_2 = nodeValue(_v, 1).multiple;
            var currVal_3 = nodeValue(_v, 1).active;
            var currVal_4 = nodeValue(_v, 1).id;
            var currVal_5 = nodeValue(_v, 1)._getAriaSelected();
            var currVal_6 = nodeValue(_v, 1).disabled.toString();
            var currVal_7 = nodeValue(_v, 1).disabled;
            _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5, currVal_6, currVal_7);
        });
    }
    var MatOptionNgFactory = createComponentFactory('mat-option', MatOption, View_MatOption_Host_0, {
        value: 'value',
        id: 'id',
        disabled: 'disabled'
    }, { onSelectionChange: 'onSelectionChange' }, ['*']);
    var styles_MatOptgroup = ['.mat-optgroup-label{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;display:block;line-height:48px;height:48px;padding:0 16px;text-align:left;text-decoration:none;max-width:100%;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:default}.mat-optgroup-label[disabled]{cursor:default}[dir=rtl] .mat-optgroup-label{text-align:right}.mat-optgroup-label .mat-icon{margin-right:16px;vertical-align:middle}.mat-optgroup-label .mat-icon svg{vertical-align:top}[dir=rtl] .mat-optgroup-label .mat-icon{margin-left:16px;margin-right:0}'];
    var RenderType_MatOptgroup = createRendererType2({
        encapsulation: 2,
        styles: styles_MatOptgroup,
        data: {}
    });
    function View_MatOptgroup_0(_l) {
        return viewDef(2, [
            (_l()(), elementDef(0, 0, null, null, 2, 'label', [[
                    'class',
                    'mat-optgroup-label'
                ]], [[
                    8,
                    'id',
                    0
                ]], null, null, null, null)),
            (_l()(), textDef(1, null, [
                '',
                ''
            ])),
            ngContentDef(null, 0),
            ngContentDef(null, 1)
        ], null, function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co._labelId;
            _ck(_v, 0, 0, currVal_0);
            var currVal_1 = _co.label;
            _ck(_v, 1, 0, currVal_1);
        });
    }
    function View_MatOptgroup_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'mat-optgroup', [
                [
                    'class',
                    'mat-optgroup'
                ],
                [
                    'role',
                    'group'
                ]
            ], [
                [
                    2,
                    'mat-optgroup-disabled',
                    null
                ],
                [
                    1,
                    'aria-disabled',
                    0
                ],
                [
                    1,
                    'aria-labelledby',
                    0
                ]
            ], null, null, View_MatOptgroup_0, RenderType_MatOptgroup)),
            directiveDef(1, 49152, null, 0, MatOptgroup, [], null, null)
        ], null, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 1).disabled;
            var currVal_1 = nodeValue(_v, 1).disabled.toString();
            var currVal_2 = nodeValue(_v, 1)._labelId;
            _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2);
        });
    }
    var MatOptgroupNgFactory = createComponentFactory('mat-optgroup', MatOptgroup, View_MatOptgroup_Host_0, {
        disabled: 'disabled',
        label: 'label'
    }, {}, [
        '*',
        'mat-option, ng-container'
    ]);
    var styles_MatPseudoCheckbox = [".mat-pseudo-checkbox{width:16px;height:16px;border:2px solid;border-radius:2px;cursor:pointer;display:inline-block;vertical-align:middle;box-sizing:border-box;position:relative;flex-shrink:0;transition:border-color 90ms cubic-bezier(0,0,.2,.1),background-color 90ms cubic-bezier(0,0,.2,.1)}.mat-pseudo-checkbox::after{position:absolute;opacity:0;content:'';border-bottom:2px solid currentColor;transition:opacity 90ms cubic-bezier(0,0,.2,.1)}.mat-pseudo-checkbox.mat-pseudo-checkbox-checked,.mat-pseudo-checkbox.mat-pseudo-checkbox-indeterminate{border-color:transparent}._mat-animation-noopable.mat-pseudo-checkbox{transition:none;animation:none}._mat-animation-noopable.mat-pseudo-checkbox::after{transition:none}.mat-pseudo-checkbox-disabled{cursor:default}.mat-pseudo-checkbox-indeterminate::after{top:5px;left:1px;width:10px;opacity:1;border-radius:2px}.mat-pseudo-checkbox-checked::after{top:2.4px;left:1px;width:8px;height:3px;border-left:2px solid currentColor;transform:rotate(-45deg);opacity:1;box-sizing:content-box}"];
    var RenderType_MatPseudoCheckbox = createRendererType2({
        encapsulation: 2,
        styles: styles_MatPseudoCheckbox,
        data: {}
    });
    function View_MatPseudoCheckbox_0(_l) {
        return viewDef(2, [], null, null);
    }
    function View_MatPseudoCheckbox_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'mat-pseudo-checkbox', [[
                    'class',
                    'mat-pseudo-checkbox'
                ]], [
                [
                    2,
                    'mat-pseudo-checkbox-indeterminate',
                    null
                ],
                [
                    2,
                    'mat-pseudo-checkbox-checked',
                    null
                ],
                [
                    2,
                    'mat-pseudo-checkbox-disabled',
                    null
                ],
                [
                    2,
                    '_mat-animation-noopable',
                    null
                ]
            ], null, null, View_MatPseudoCheckbox_0, RenderType_MatPseudoCheckbox)),
            directiveDef(1, 49152, null, 0, MatPseudoCheckbox, [[
                    2,
                    ANIMATION_MODULE_TYPE
                ]], null, null)
        ], null, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 1).state === 'indeterminate';
            var currVal_1 = nodeValue(_v, 1).state === 'checked';
            var currVal_2 = nodeValue(_v, 1).disabled;
            var currVal_3 = nodeValue(_v, 1)._animationMode === 'NoopAnimations';
            _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2, currVal_3);
        });
    }
    var MatPseudoCheckboxNgFactory = createComponentFactory('mat-pseudo-checkbox', MatPseudoCheckbox, View_MatPseudoCheckbox_Host_0, {
        state: 'state',
        disabled: 'disabled'
    }, {}, []);
    var i = RenderType_MatOption;
    var j$1 = View_MatOption_0;
    var MatExpansionModuleNgFactory = createNgModuleFactory(MatExpansionModule, [], function (_l) {
        return moduleDef([
            moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [
                [
                    8,
                    []
                ],
                [
                    3,
                    ComponentFactoryResolver
                ],
                NgModuleRef
            ]),
            moduleProvideDef(4608, NgLocalization, NgLocaleLocalization, [
                LOCALE_ID$1,
                [
                    2,
                    DEPRECATED_PLURAL_FN
                ]
            ]),
            moduleProvideDef(1073742336, CommonModule, CommonModule, []),
            moduleProvideDef(1073742336, CdkAccordionModule, CdkAccordionModule, []),
            moduleProvideDef(1073742336, PortalModule, PortalModule, []),
            moduleProvideDef(1073742336, MatExpansionModule, MatExpansionModule, [])
        ]);
    });
    var styles_MatExpansionPanel = ['.mat-expansion-panel{box-sizing:content-box;display:block;margin:0;border-radius:4px;overflow:hidden;transition:margin 225ms cubic-bezier(.4,0,.2,1),box-shadow 280ms cubic-bezier(.4,0,.2,1)}.mat-accordion .mat-expansion-panel:not(.mat-expanded),.mat-accordion .mat-expansion-panel:not(.mat-expansion-panel-spacing){border-radius:0}.mat-accordion .mat-expansion-panel:first-of-type{border-top-right-radius:4px;border-top-left-radius:4px}.mat-accordion .mat-expansion-panel:last-of-type{border-bottom-right-radius:4px;border-bottom-left-radius:4px}@media (-ms-high-contrast:active){.mat-expansion-panel{outline:solid 1px}}.mat-expansion-panel._mat-animation-noopable,.mat-expansion-panel.ng-animate-disabled,.ng-animate-disabled .mat-expansion-panel{transition:none}.mat-expansion-panel-content{display:flex;flex-direction:column;overflow:visible}.mat-expansion-panel-body{padding:0 24px 16px}.mat-expansion-panel-spacing{margin:16px 0}.mat-accordion>.mat-expansion-panel-spacing:first-child,.mat-accordion>:first-child:not(.mat-expansion-panel) .mat-expansion-panel-spacing{margin-top:0}.mat-accordion>.mat-expansion-panel-spacing:last-child,.mat-accordion>:last-child:not(.mat-expansion-panel) .mat-expansion-panel-spacing{margin-bottom:0}.mat-action-row{border-top-style:solid;border-top-width:1px;display:flex;flex-direction:row;justify-content:flex-end;padding:16px 8px 16px 24px}.mat-action-row button.mat-button-base{margin-left:8px}[dir=rtl] .mat-action-row button.mat-button-base{margin-left:0;margin-right:8px}'];
    var RenderType_MatExpansionPanel = createRendererType2({
        encapsulation: 2,
        styles: styles_MatExpansionPanel,
        data: {
            'animation': [{
                    type: 7,
                    name: 'bodyExpansion',
                    definitions: [
                        {
                            type: 0,
                            name: 'collapsed, void',
                            styles: {
                                type: 6,
                                styles: {
                                    height: '0px',
                                    visibility: 'hidden'
                                },
                                offset: null
                            },
                            options: undefined
                        },
                        {
                            type: 0,
                            name: 'expanded',
                            styles: {
                                type: 6,
                                styles: {
                                    height: '*',
                                    visibility: 'visible'
                                },
                                offset: null
                            },
                            options: undefined
                        },
                        {
                            type: 1,
                            expr: 'expanded <=> collapsed, void => collapsed',
                            animation: {
                                type: 4,
                                styles: null,
                                timings: '225ms cubic-bezier(0.4,0.0,0.2,1)'
                            },
                            options: null
                        }
                    ],
                    options: {}
                }]
        }
    });
    function View_MatExpansionPanel_1(_l) {
        return viewDef(0, [(_l()(), anchorDef(0, null, null, 0))], null, null);
    }
    function View_MatExpansionPanel_0(_l) {
        return viewDef(2, [
            queryDef(671088640, 1, { _body: 0 }),
            ngContentDef(null, 0),
            (_l()(), elementDef(2, 0, [
                [
                    1,
                    0
                ],
                [
                    'body',
                    1
                ]
            ], null, 5, 'div', [
                [
                    'class',
                    'mat-expansion-panel-content'
                ],
                [
                    'role',
                    'region'
                ]
            ], [
                [
                    24,
                    '@bodyExpansion',
                    0
                ],
                [
                    1,
                    'aria-labelledby',
                    0
                ],
                [
                    8,
                    'id',
                    0
                ]
            ], [[
                    null,
                    '@bodyExpansion.done'
                ]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if ('@bodyExpansion.done' === en) {
                    var pd_0 = _co._bodyAnimationDone.next($event) !== false;
                    ad = pd_0 && ad;
                }
                return ad;
            }, null, null)),
            (_l()(), elementDef(3, 0, null, null, 3, 'div', [[
                    'class',
                    'mat-expansion-panel-body'
                ]], null, null, null, null, null)),
            ngContentDef(null, 1),
            (_l()(), anchorDef(16777216, null, null, 1, null, View_MatExpansionPanel_1)),
            directiveDef(6, 212992, null, 0, CdkPortalOutlet, [
                ComponentFactoryResolver,
                ViewContainerRef
            ], {
                portal: [
                    0,
                    'portal'
                ]
            }, null),
            ngContentDef(null, 2)
        ], function (_ck, _v) {
            var _co = _v.component;
            var currVal_3 = _co._portal;
            _ck(_v, 6, 0, currVal_3);
        }, function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co._getExpandedState();
            var currVal_1 = _co._headerId;
            var currVal_2 = _co.id;
            _ck(_v, 2, 0, currVal_0, currVal_1, currVal_2);
        });
    }
    function View_MatExpansionPanel_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 16777216, null, null, 3, 'mat-expansion-panel', [[
                    'class',
                    'mat-expansion-panel'
                ]], [
                [
                    2,
                    'mat-expanded',
                    null
                ],
                [
                    2,
                    '_mat-animation-noopable',
                    null
                ],
                [
                    2,
                    'mat-expansion-panel-spacing',
                    null
                ]
            ], null, null, View_MatExpansionPanel_0, RenderType_MatExpansionPanel)),
            directiveDef(1, 1753088, null, 1, MatExpansionPanel, [
                [
                    3,
                    MAT_ACCORDION
                ],
                ChangeDetectorRef,
                UniqueSelectionDispatcher,
                ViewContainerRef,
                DOCUMENT,
                [
                    2,
                    ANIMATION_MODULE_TYPE
                ],
                [
                    2,
                    MAT_EXPANSION_PANEL_DEFAULT_OPTIONS
                ]
            ], null, null),
            queryDef(603979776, 1, { _lazyContent: 0 }),
            providerDef(256, null, MAT_ACCORDION, undefined, [])
        ], null, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 1).expanded;
            var currVal_1 = nodeValue(_v, 1)._animationMode === 'NoopAnimations';
            var currVal_2 = nodeValue(_v, 1)._hasSpacing();
            _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2);
        });
    }
    var MatExpansionPanelNgFactory = createComponentFactory('mat-expansion-panel', MatExpansionPanel, View_MatExpansionPanel_Host_0, {
        expanded: 'expanded',
        disabled: 'disabled',
        hideToggle: 'hideToggle',
        togglePosition: 'togglePosition'
    }, {
        closed: 'closed',
        opened: 'opened',
        destroyed: 'destroyed',
        expandedChange: 'expandedChange',
        afterExpand: 'afterExpand',
        afterCollapse: 'afterCollapse'
    }, [
        'mat-expansion-panel-header',
        '*',
        'mat-action-row'
    ]);
    var styles_MatExpansionPanelHeader = [".mat-expansion-panel-header{display:flex;flex-direction:row;align-items:center;padding:0 24px;border-radius:inherit}.mat-expansion-panel-header:focus,.mat-expansion-panel-header:hover{outline:0}.mat-expansion-panel-header.mat-expanded:focus,.mat-expansion-panel-header.mat-expanded:hover{background:inherit}.mat-expansion-panel-header:not([aria-disabled=true]){cursor:pointer}.mat-expansion-panel-header.mat-expansion-toggle-indicator-before{flex-direction:row-reverse}.mat-expansion-panel-header.mat-expansion-toggle-indicator-before .mat-expansion-indicator{margin:0 16px 0 0}[dir=rtl] .mat-expansion-panel-header.mat-expansion-toggle-indicator-before .mat-expansion-indicator{margin:0 0 0 16px}.mat-content{display:flex;flex:1;flex-direction:row;overflow:hidden}.mat-expansion-panel-header-description,.mat-expansion-panel-header-title{display:flex;flex-grow:1;margin-right:16px}[dir=rtl] .mat-expansion-panel-header-description,[dir=rtl] .mat-expansion-panel-header-title{margin-right:0;margin-left:16px}.mat-expansion-panel-header-description{flex-grow:2}.mat-expansion-indicator::after{border-style:solid;border-width:0 2px 2px 0;content:'';display:inline-block;padding:3px;transform:rotate(45deg);vertical-align:middle}"];
    var RenderType_MatExpansionPanelHeader = createRendererType2({
        encapsulation: 2,
        styles: styles_MatExpansionPanelHeader,
        data: {
            'animation': [
                {
                    type: 7,
                    name: 'indicatorRotate',
                    definitions: [
                        {
                            type: 0,
                            name: 'collapsed, void',
                            styles: {
                                type: 6,
                                styles: { transform: 'rotate(0deg)' },
                                offset: null
                            },
                            options: undefined
                        },
                        {
                            type: 0,
                            name: 'expanded',
                            styles: {
                                type: 6,
                                styles: { transform: 'rotate(180deg)' },
                                offset: null
                            },
                            options: undefined
                        },
                        {
                            type: 1,
                            expr: 'expanded <=> collapsed, void => collapsed',
                            animation: {
                                type: 4,
                                styles: null,
                                timings: '225ms cubic-bezier(0.4,0.0,0.2,1)'
                            },
                            options: null
                        }
                    ],
                    options: {}
                },
                {
                    type: 7,
                    name: 'expansionHeight',
                    definitions: [
                        {
                            type: 0,
                            name: 'collapsed, void',
                            styles: {
                                type: 6,
                                styles: { height: '{{collapsedHeight}}' },
                                offset: null
                            },
                            options: { params: { collapsedHeight: '48px' } }
                        },
                        {
                            type: 0,
                            name: 'expanded',
                            styles: {
                                type: 6,
                                styles: { height: '{{expandedHeight}}' },
                                offset: null
                            },
                            options: { params: { expandedHeight: '64px' } }
                        },
                        {
                            type: 1,
                            expr: 'expanded <=> collapsed, void => collapsed',
                            animation: {
                                type: 3,
                                steps: [
                                    {
                                        type: 11,
                                        selector: '@indicatorRotate',
                                        animation: {
                                            type: 9,
                                            options: null
                                        },
                                        options: { optional: true }
                                    },
                                    {
                                        type: 4,
                                        styles: null,
                                        timings: '225ms cubic-bezier(0.4,0.0,0.2,1)'
                                    }
                                ],
                                options: null
                            },
                            options: null
                        }
                    ],
                    options: {}
                }
            ]
        }
    });
    function View_MatExpansionPanelHeader_1(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 0, 'span', [[
                    'class',
                    'mat-expansion-indicator'
                ]], [[
                    24,
                    '@indicatorRotate',
                    0
                ]], null, null, null, null))], null, function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co._getExpandedState();
            _ck(_v, 0, 0, currVal_0);
        });
    }
    function View_MatExpansionPanelHeader_0(_l) {
        return viewDef(2, [
            (_l()(), elementDef(0, 0, null, null, 3, 'span', [[
                    'class',
                    'mat-content'
                ]], null, null, null, null, null)),
            ngContentDef(null, 0),
            ngContentDef(null, 1),
            ngContentDef(null, 2),
            (_l()(), anchorDef(16777216, null, null, 1, null, View_MatExpansionPanelHeader_1)),
            directiveDef(5, 16384, null, 0, NgIf, [
                ViewContainerRef,
                TemplateRef
            ], {
                ngIf: [
                    0,
                    'ngIf'
                ]
            }, null)
        ], function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co._showToggle();
            _ck(_v, 5, 0, currVal_0);
        }, null);
    }
    function View_MatExpansionPanelHeader_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 3, 'mat-expansion-panel-header', [
                [
                    'class',
                    'mat-expansion-panel-header'
                ],
                [
                    'role',
                    'button'
                ]
            ], [
                [
                    1,
                    'id',
                    0
                ],
                [
                    1,
                    'tabindex',
                    0
                ],
                [
                    1,
                    'aria-controls',
                    0
                ],
                [
                    1,
                    'aria-expanded',
                    0
                ],
                [
                    1,
                    'aria-disabled',
                    0
                ],
                [
                    2,
                    'mat-expanded',
                    null
                ],
                [
                    2,
                    'mat-expansion-toggle-indicator-after',
                    null
                ],
                [
                    2,
                    'mat-expansion-toggle-indicator-before',
                    null
                ],
                [
                    40,
                    '@.disabled',
                    0
                ],
                [
                    40,
                    '@expansionHeight',
                    0
                ]
            ], [
                [
                    null,
                    'click'
                ],
                [
                    null,
                    'keydown'
                ],
                [
                    'component',
                    '@expansionHeight.start'
                ]
            ], function (_v, en, $event) {
                var ad = true;
                if ('click' === en) {
                    var pd_0 = nodeValue(_v, 1)._toggle() !== false;
                    ad = pd_0 && ad;
                }
                if ('keydown' === en) {
                    var pd_1 = nodeValue(_v, 1)._keydown($event) !== false;
                    ad = pd_1 && ad;
                }
                if ('component:@expansionHeight.start' === en) {
                    var pd_2 = nodeValue(_v, 1)._animationStarted() !== false;
                    ad = pd_2 && ad;
                }
                return ad;
            }, View_MatExpansionPanelHeader_0, RenderType_MatExpansionPanelHeader)),
            directiveDef(1, 180224, null, 0, MatExpansionPanelHeader, [
                MatExpansionPanel,
                ElementRef,
                FocusMonitor,
                ChangeDetectorRef,
                [
                    2,
                    MAT_EXPANSION_PANEL_DEFAULT_OPTIONS
                ]
            ], null, null),
            pureObjectDef(2, {
                collapsedHeight: 0,
                expandedHeight: 1
            }),
            pureObjectDef(3, {
                value: 0,
                params: 1
            })
        ], null, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 1).panel._headerId;
            var currVal_1 = nodeValue(_v, 1).disabled ? 0 - 1 : 0;
            var currVal_2 = nodeValue(_v, 1)._getPanelId();
            var currVal_3 = nodeValue(_v, 1)._isExpanded();
            var currVal_4 = nodeValue(_v, 1).panel.disabled;
            var currVal_5 = nodeValue(_v, 1)._isExpanded();
            var currVal_6 = nodeValue(_v, 1)._getTogglePosition() === 'after';
            var currVal_7 = nodeValue(_v, 1)._getTogglePosition() === 'before';
            var currVal_8 = nodeValue(_v, 1)._animationsDisabled;
            var currVal_9 = _ck(_v, 3, 0, nodeValue(_v, 1)._getExpandedState(), _ck(_v, 2, 0, nodeValue(_v, 1).collapsedHeight, nodeValue(_v, 1).expandedHeight));
            _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5, currVal_6, currVal_7, currVal_8, currVal_9);
        });
    }
    var MatExpansionPanelHeaderNgFactory = createComponentFactory('mat-expansion-panel-header', MatExpansionPanelHeader, View_MatExpansionPanelHeader_Host_0, {
        expandedHeight: 'expandedHeight',
        collapsedHeight: 'collapsedHeight'
    }, {}, [
        'mat-panel-title',
        'mat-panel-description',
        '*'
    ]);
    var c$4 = RenderType_MatExpansionPanel;
    var d$4 = View_MatExpansionPanel_0;
    var g = RenderType_MatExpansionPanelHeader;
    var h = View_MatExpansionPanelHeader_0;
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_CaptureProfileDialog = [styles];
    var RenderType_CaptureProfileDialog = createRendererType2({ encapsulation: 0, styles: styles_CaptureProfileDialog, data: {} });
    function View_CaptureProfileDialog_0(_l) {
        return viewDef(0, [pipeDef(0, UpperCasePipe, []), (_l()(), elementDef(1, 0, null, null, 241, "mat-dialog-content", [["class", "mat-dialog-content"]], null, null, null, null, null)), directiveDef(2, 16384, null, 0, MatDialogContent, [], null, null), (_l()(), elementDef(3, 0, null, null, 24, "div", [], null, null, null, null, null)), (_l()(), elementDef(4, 0, null, null, 23, "mat-form-field", [["class", "mat-form-field"]], [[2, "mat-form-field-appearance-standard", null], [2, "mat-form-field-appearance-fill", null], [2, "mat-form-field-appearance-outline", null], [2, "mat-form-field-appearance-legacy", null], [2, "mat-form-field-invalid", null], [2, "mat-form-field-can-float", null], [2, "mat-form-field-should-float", null], [2, "mat-form-field-has-label", null], [2, "mat-form-field-hide-placeholder", null], [2, "mat-form-field-disabled", null], [2, "mat-form-field-autofilled", null], [2, "mat-focused", null], [2, "mat-accent", null], [2, "mat-warn", null], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [2, "_mat-animation-noopable", null]], null, null, d$1, c$1)), directiveDef(5, 7520256, null, 9, MatFormField, [ElementRef, ChangeDetectorRef, [2, MAT_LABEL_GLOBAL_OPTIONS], [2, Directionality], [2, MAT_FORM_FIELD_DEFAULT_OPTIONS], Platform, NgZone, [2, ANIMATION_MODULE_TYPE]], null, null), queryDef(603979776, 1, { _controlNonStatic: 0 }), queryDef(335544320, 2, { _controlStatic: 0 }), queryDef(603979776, 3, { _labelChildNonStatic: 0 }), queryDef(335544320, 4, { _labelChildStatic: 0 }), queryDef(603979776, 5, { _placeholderChild: 0 }), queryDef(603979776, 6, { _errorChildren: 1 }), queryDef(603979776, 7, { _hintChildren: 1 }), queryDef(603979776, 8, { _prefixChildren: 1 }), queryDef(603979776, 9, { _suffixChildren: 1 }), (_l()(), elementDef(15, 0, null, 3, 2, "mat-label", [], null, null, null, null, null)), directiveDef(16, 16384, [[3, 4], [4, 4]], 0, MatLabel, [], null, null), (_l()(), textDef(-1, null, ["Profile Service URL(s) or TPU name"])), (_l()(), elementDef(18, 0, null, 1, 9, "input", [["class", "mat-input-element mat-form-field-autofill-control"], ["matInput", ""], ["placeholder", "localhost:6009,localhost:6010"], ["required", ""]], [[1, "required", 0], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [2, "mat-input-server", null], [1, "id", 0], [1, "placeholder", 0], [8, "disabled", 0], [8, "required", 0], [1, "readonly", 0], [1, "aria-describedby", 0], [1, "aria-invalid", 0], [1, "aria-required", 0]], [[null, "ngModelChange"], [null, "input"], [null, "blur"], [null, "compositionstart"], [null, "compositionend"], [null, "focus"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("input" === en)) {
                    var pd_0 = (nodeValue(_v, 19)._handleInput($event.target.value) !== false);
                    ad = (pd_0 && ad);
                }
                if (("blur" === en)) {
                    var pd_1 = (nodeValue(_v, 19).onTouched() !== false);
                    ad = (pd_1 && ad);
                }
                if (("compositionstart" === en)) {
                    var pd_2 = (nodeValue(_v, 19)._compositionStart() !== false);
                    ad = (pd_2 && ad);
                }
                if (("compositionend" === en)) {
                    var pd_3 = (nodeValue(_v, 19)._compositionEnd($event.target.value) !== false);
                    ad = (pd_3 && ad);
                }
                if (("blur" === en)) {
                    var pd_4 = (nodeValue(_v, 26)._focusChanged(false) !== false);
                    ad = (pd_4 && ad);
                }
                if (("focus" === en)) {
                    var pd_5 = (nodeValue(_v, 26)._focusChanged(true) !== false);
                    ad = (pd_5 && ad);
                }
                if (("input" === en)) {
                    var pd_6 = (nodeValue(_v, 26)._onInput() !== false);
                    ad = (pd_6 && ad);
                }
                if (("ngModelChange" === en)) {
                    var pd_7 = ((_co.serviceAddr = $event) !== false);
                    ad = (pd_7 && ad);
                }
                if (("ngModelChange" === en)) {
                    var pd_8 = (_co.serviceAddrChanged($event) !== false);
                    ad = (pd_8 && ad);
                }
                return ad;
            }, null, null)), directiveDef(19, 16384, null, 0, DefaultValueAccessor, [Renderer2, ElementRef, [2, COMPOSITION_BUFFER_MODE]], null, null), directiveDef(20, 16384, null, 0, RequiredValidator, [], { required: [0, "required"] }, null), providerDef(1024, null, NG_VALIDATORS, function (p0_0) { return [p0_0]; }, [RequiredValidator]), providerDef(1024, null, NG_VALUE_ACCESSOR, function (p0_0) { return [p0_0]; }, [DefaultValueAccessor]), directiveDef(23, 671744, null, 0, NgModel, [[8, null], [6, NG_VALIDATORS], [8, null], [6, NG_VALUE_ACCESSOR]], { model: [0, "model"] }, { update: "ngModelChange" }), providerDef(2048, null, NgControl, null, [NgModel]), directiveDef(25, 16384, null, 0, NgControlStatus, [[4, NgControl]], null, null), directiveDef(26, 999424, null, 0, MatInput, [ElementRef, Platform, [6, NgControl], [2, NgForm], [2, FormGroupDirective], ErrorStateMatcher, [8, null], AutofillMonitor, NgZone], { placeholder: [0, "placeholder"], required: [1, "required"] }, null), providerDef(2048, [[1, 4], [2, 4]], MatFormFieldControl, null, [MatInput]), (_l()(), elementDef(28, 0, null, null, 14, "div", [], null, null, null, null, null)), (_l()(), elementDef(29, 0, null, null, 13, "mat-radio-group", [["aria-label", "address type"], ["class", "mat-radio-group"], ["role", "radiogroup"]], [[2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null]], [[null, "ngModelChange"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("ngModelChange" === en)) {
                    var pd_0 = ((_co.addressType = $event) !== false);
                    ad = (pd_0 && ad);
                }
                if (("ngModelChange" === en)) {
                    var pd_1 = (_co.addressTypeChanged($event) !== false);
                    ad = (pd_1 && ad);
                }
                return ad;
            }, null, null)), directiveDef(30, 1064960, null, 1, MatRadioGroup, [ChangeDetectorRef], null, null), queryDef(603979776, 10, { _radios: 1 }), providerDef(1024, null, NG_VALUE_ACCESSOR, function (p0_0) { return [p0_0]; }, [MatRadioGroup]), directiveDef(33, 671744, null, 0, NgModel, [[8, null], [8, null], [8, null], [6, NG_VALUE_ACCESSOR]], { model: [0, "model"] }, { update: "ngModelChange" }), providerDef(2048, null, NgControl, null, [NgModel]), directiveDef(35, 16384, null, 0, NgControlStatus, [[4, NgControl]], null, null), (_l()(), textDef(-1, null, [" Address Type: "])), (_l()(), elementDef(37, 0, null, null, 2, "mat-radio-button", [["class", "mat-radio-button"], ["value", "ip"]], [[2, "mat-radio-checked", null], [2, "mat-radio-disabled", null], [2, "_mat-animation-noopable", null], [2, "mat-primary", null], [2, "mat-accent", null], [2, "mat-warn", null], [1, "tabindex", 0], [1, "id", 0], [1, "aria-label", 0], [1, "aria-labelledby", 0], [1, "aria-describedby", 0]], [[null, "focus"]], function (_v, en, $event) {
                var ad = true;
                if (("focus" === en)) {
                    var pd_0 = (nodeValue(_v, 38)._inputElement.nativeElement.focus() !== false);
                    ad = (pd_0 && ad);
                }
                return ad;
            }, d$2, c$2)), directiveDef(38, 4440064, [[10, 4]], 0, MatRadioButton, [[2, MatRadioGroup], ElementRef, ChangeDetectorRef, FocusMonitor, UniqueSelectionDispatcher, [2, ANIMATION_MODULE_TYPE], [2, MAT_RADIO_DEFAULT_OPTIONS]], { value: [0, "value"] }, null), (_l()(), textDef(-1, 0, ["IP Address"])), (_l()(), elementDef(40, 0, null, null, 2, "mat-radio-button", [["class", "mat-radio-button"], ["value", "tpu"]], [[2, "mat-radio-checked", null], [2, "mat-radio-disabled", null], [2, "_mat-animation-noopable", null], [2, "mat-primary", null], [2, "mat-accent", null], [2, "mat-warn", null], [1, "tabindex", 0], [1, "id", 0], [1, "aria-label", 0], [1, "aria-labelledby", 0], [1, "aria-describedby", 0]], [[null, "focus"]], function (_v, en, $event) {
                var ad = true;
                if (("focus" === en)) {
                    var pd_0 = (nodeValue(_v, 41)._inputElement.nativeElement.focus() !== false);
                    ad = (pd_0 && ad);
                }
                return ad;
            }, d$2, c$2)), directiveDef(41, 4440064, [[10, 4]], 0, MatRadioButton, [[2, MatRadioGroup], ElementRef, ChangeDetectorRef, FocusMonitor, UniqueSelectionDispatcher, [2, ANIMATION_MODULE_TYPE], [2, MAT_RADIO_DEFAULT_OPTIONS]], { value: [0, "value"] }, null), (_l()(), textDef(-1, 0, ["TPU Name"])), (_l()(), elementDef(43, 0, null, null, 0, "br", [], null, null, null, null, null)), (_l()(), elementDef(44, 0, null, null, 20, "div", [], null, null, null, null, null)), (_l()(), elementDef(45, 0, null, null, 19, "mat-form-field", [["class", "mat-form-field"]], [[2, "mat-form-field-appearance-standard", null], [2, "mat-form-field-appearance-fill", null], [2, "mat-form-field-appearance-outline", null], [2, "mat-form-field-appearance-legacy", null], [2, "mat-form-field-invalid", null], [2, "mat-form-field-can-float", null], [2, "mat-form-field-should-float", null], [2, "mat-form-field-has-label", null], [2, "mat-form-field-hide-placeholder", null], [2, "mat-form-field-disabled", null], [2, "mat-form-field-autofilled", null], [2, "mat-focused", null], [2, "mat-accent", null], [2, "mat-warn", null], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [2, "_mat-animation-noopable", null]], null, null, d$1, c$1)), directiveDef(46, 7520256, null, 9, MatFormField, [ElementRef, ChangeDetectorRef, [2, MAT_LABEL_GLOBAL_OPTIONS], [2, Directionality], [2, MAT_FORM_FIELD_DEFAULT_OPTIONS], Platform, NgZone, [2, ANIMATION_MODULE_TYPE]], null, null), queryDef(603979776, 11, { _controlNonStatic: 0 }), queryDef(335544320, 12, { _controlStatic: 0 }), queryDef(603979776, 13, { _labelChildNonStatic: 0 }), queryDef(335544320, 14, { _labelChildStatic: 0 }), queryDef(603979776, 15, { _placeholderChild: 0 }), queryDef(603979776, 16, { _errorChildren: 1 }), queryDef(603979776, 17, { _hintChildren: 1 }), queryDef(603979776, 18, { _prefixChildren: 1 }), queryDef(603979776, 19, { _suffixChildren: 1 }), (_l()(), elementDef(56, 0, null, 1, 8, "input", [["class", "mat-input-element mat-form-field-autofill-control"], ["matInput", ""], ["placeholder", "Profiling Duration (milliseconds)"], ["type", "number"]], [[2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [2, "mat-input-server", null], [1, "id", 0], [1, "placeholder", 0], [8, "disabled", 0], [8, "required", 0], [1, "readonly", 0], [1, "aria-describedby", 0], [1, "aria-invalid", 0], [1, "aria-required", 0]], [[null, "ngModelChange"], [null, "input"], [null, "blur"], [null, "compositionstart"], [null, "compositionend"], [null, "change"], [null, "focus"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("input" === en)) {
                    var pd_0 = (nodeValue(_v, 57)._handleInput($event.target.value) !== false);
                    ad = (pd_0 && ad);
                }
                if (("blur" === en)) {
                    var pd_1 = (nodeValue(_v, 57).onTouched() !== false);
                    ad = (pd_1 && ad);
                }
                if (("compositionstart" === en)) {
                    var pd_2 = (nodeValue(_v, 57)._compositionStart() !== false);
                    ad = (pd_2 && ad);
                }
                if (("compositionend" === en)) {
                    var pd_3 = (nodeValue(_v, 57)._compositionEnd($event.target.value) !== false);
                    ad = (pd_3 && ad);
                }
                if (("change" === en)) {
                    var pd_4 = (nodeValue(_v, 58).onChange($event.target.value) !== false);
                    ad = (pd_4 && ad);
                }
                if (("input" === en)) {
                    var pd_5 = (nodeValue(_v, 58).onChange($event.target.value) !== false);
                    ad = (pd_5 && ad);
                }
                if (("blur" === en)) {
                    var pd_6 = (nodeValue(_v, 58).onTouched() !== false);
                    ad = (pd_6 && ad);
                }
                if (("blur" === en)) {
                    var pd_7 = (nodeValue(_v, 63)._focusChanged(false) !== false);
                    ad = (pd_7 && ad);
                }
                if (("focus" === en)) {
                    var pd_8 = (nodeValue(_v, 63)._focusChanged(true) !== false);
                    ad = (pd_8 && ad);
                }
                if (("input" === en)) {
                    var pd_9 = (nodeValue(_v, 63)._onInput() !== false);
                    ad = (pd_9 && ad);
                }
                if (("ngModelChange" === en)) {
                    var pd_10 = ((_co.duration = $event) !== false);
                    ad = (pd_10 && ad);
                }
                return ad;
            }, null, null)), directiveDef(57, 16384, null, 0, DefaultValueAccessor, [Renderer2, ElementRef, [2, COMPOSITION_BUFFER_MODE]], null, null), directiveDef(58, 16384, null, 0, NumberValueAccessor, [Renderer2, ElementRef], null, null), providerDef(1024, null, NG_VALUE_ACCESSOR, function (p0_0, p1_0) { return [p0_0, p1_0]; }, [DefaultValueAccessor, NumberValueAccessor]), directiveDef(60, 671744, null, 0, NgModel, [[8, null], [8, null], [8, null], [6, NG_VALUE_ACCESSOR]], { model: [0, "model"] }, { update: "ngModelChange" }), providerDef(2048, null, NgControl, null, [NgModel]), directiveDef(62, 16384, null, 0, NgControlStatus, [[4, NgControl]], null, null), directiveDef(63, 999424, null, 0, MatInput, [ElementRef, Platform, [6, NgControl], [2, NgForm], [2, FormGroupDirective], ErrorStateMatcher, [8, null], AutofillMonitor, NgZone], { placeholder: [0, "placeholder"], type: [1, "type"] }, null), providerDef(2048, [[11, 4], [12, 4]], MatFormFieldControl, null, [MatInput]), (_l()(), elementDef(65, 0, null, null, 37, "div", [], null, null, null, null, null)), (_l()(), elementDef(66, 0, null, null, 36, "mat-form-field", [["class", "mat-form-field"]], [[2, "mat-form-field-appearance-standard", null], [2, "mat-form-field-appearance-fill", null], [2, "mat-form-field-appearance-outline", null], [2, "mat-form-field-appearance-legacy", null], [2, "mat-form-field-invalid", null], [2, "mat-form-field-can-float", null], [2, "mat-form-field-should-float", null], [2, "mat-form-field-has-label", null], [2, "mat-form-field-hide-placeholder", null], [2, "mat-form-field-disabled", null], [2, "mat-form-field-autofilled", null], [2, "mat-focused", null], [2, "mat-accent", null], [2, "mat-warn", null], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [2, "_mat-animation-noopable", null]], null, null, d$1, c$1)), directiveDef(67, 7520256, null, 9, MatFormField, [ElementRef, ChangeDetectorRef, [2, MAT_LABEL_GLOBAL_OPTIONS], [2, Directionality], [2, MAT_FORM_FIELD_DEFAULT_OPTIONS], Platform, NgZone, [2, ANIMATION_MODULE_TYPE]], null, null), queryDef(603979776, 20, { _controlNonStatic: 0 }), queryDef(335544320, 21, { _controlStatic: 0 }), queryDef(603979776, 22, { _labelChildNonStatic: 0 }), queryDef(335544320, 23, { _labelChildStatic: 0 }), queryDef(603979776, 24, { _placeholderChild: 0 }), queryDef(603979776, 25, { _errorChildren: 1 }), queryDef(603979776, 26, { _hintChildren: 1 }), queryDef(603979776, 27, { _prefixChildren: 1 }), queryDef(603979776, 28, { _suffixChildren: 1 }), (_l()(), elementDef(77, 0, null, 3, 2, "mat-label", [], null, null, null, null, null)), directiveDef(78, 16384, [[22, 4], [23, 4]], 0, MatLabel, [], null, null), (_l()(), textDef(-1, null, ["Host Trace (TraceMe) Level"])), (_l()(), elementDef(80, 16777216, null, 1, 22, "mat-select", [["class", "mat-select"], ["matTooltipPosition", "above"], ["role", "listbox"]], [[2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [1, "id", 0], [1, "tabindex", 0], [1, "aria-label", 0], [1, "aria-labelledby", 0], [1, "aria-required", 0], [1, "aria-disabled", 0], [1, "aria-invalid", 0], [1, "aria-owns", 0], [1, "aria-multiselectable", 0], [1, "aria-describedby", 0], [1, "aria-activedescendant", 0], [2, "mat-select-disabled", null], [2, "mat-select-invalid", null], [2, "mat-select-required", null], [2, "mat-select-empty", null]], [[null, "ngModelChange"], [null, "keydown"], [null, "focus"], [null, "blur"], [null, "longpress"], [null, "touchend"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("keydown" === en)) {
                    var pd_0 = (nodeValue(_v, 84)._handleKeydown($event) !== false);
                    ad = (pd_0 && ad);
                }
                if (("focus" === en)) {
                    var pd_1 = (nodeValue(_v, 84)._onFocus() !== false);
                    ad = (pd_1 && ad);
                }
                if (("blur" === en)) {
                    var pd_2 = (nodeValue(_v, 84)._onBlur() !== false);
                    ad = (pd_2 && ad);
                }
                if (("longpress" === en)) {
                    var pd_3 = (nodeValue(_v, 88).show() !== false);
                    ad = (pd_3 && ad);
                }
                if (("keydown" === en)) {
                    var pd_4 = (nodeValue(_v, 88)._handleKeydown($event) !== false);
                    ad = (pd_4 && ad);
                }
                if (("touchend" === en)) {
                    var pd_5 = (nodeValue(_v, 88)._handleTouchend() !== false);
                    ad = (pd_5 && ad);
                }
                if (("ngModelChange" === en)) {
                    var pd_6 = ((_co.hostTracerLevel = $event) !== false);
                    ad = (pd_6 && ad);
                }
                return ad;
            }, d$3, c$3)), directiveDef(81, 671744, null, 0, NgModel, [[8, null], [8, null], [8, null], [8, null]], { model: [0, "model"] }, { update: "ngModelChange" }), providerDef(2048, null, NgControl, null, [NgModel]), directiveDef(83, 16384, null, 0, NgControlStatus, [[4, NgControl]], null, null), directiveDef(84, 2080768, null, 3, MatSelect, [ViewportRuler, ChangeDetectorRef, NgZone, ErrorStateMatcher, ElementRef, [2, Directionality], [2, NgForm], [2, FormGroupDirective], [2, MatFormField], [6, NgControl], [8, null], MAT_SELECT_SCROLL_STRATEGY, LiveAnnouncer], null, null), queryDef(603979776, 29, { options: 1 }), queryDef(603979776, 30, { optionGroups: 1 }), queryDef(603979776, 31, { customTrigger: 0 }), directiveDef(88, 212992, null, 0, MatTooltip, [Overlay, ElementRef, ScrollDispatcher, ViewContainerRef, NgZone, Platform, AriaDescriber, FocusMonitor, MAT_TOOLTIP_SCROLL_STRATEGY, [2, Directionality], [2, MAT_TOOLTIP_DEFAULT_OPTIONS], [2, HAMMER_LOADER]], { position: [0, "position"], message: [1, "message"] }, null), providerDef(2048, [[20, 4], [21, 4]], MatFormFieldControl, null, [MatSelect]), providerDef(2048, null, MAT_OPTION_PARENT_COMPONENT, null, [MatSelect]), (_l()(), elementDef(91, 0, null, 1, 2, "mat-option", [["class", "mat-option"], ["role", "option"], ["value", "0"]], [[1, "tabindex", 0], [2, "mat-selected", null], [2, "mat-option-multiple", null], [2, "mat-active", null], [8, "id", 0], [1, "aria-selected", 0], [1, "aria-disabled", 0], [2, "mat-option-disabled", null]], [[null, "click"], [null, "keydown"]], function (_v, en, $event) {
                var ad = true;
                if (("click" === en)) {
                    var pd_0 = (nodeValue(_v, 92)._selectViaInteraction() !== false);
                    ad = (pd_0 && ad);
                }
                if (("keydown" === en)) {
                    var pd_1 = (nodeValue(_v, 92)._handleKeydown($event) !== false);
                    ad = (pd_1 && ad);
                }
                return ad;
            }, j$1, i)), directiveDef(92, 8568832, [[29, 4]], 0, MatOption, [ElementRef, ChangeDetectorRef, [2, MAT_OPTION_PARENT_COMPONENT], [2, MatOptgroup]], { value: [0, "value"] }, null), (_l()(), textDef(-1, 0, ["disable"])), (_l()(), elementDef(94, 0, null, 1, 2, "mat-option", [["class", "mat-option"], ["role", "option"], ["value", "1"]], [[1, "tabindex", 0], [2, "mat-selected", null], [2, "mat-option-multiple", null], [2, "mat-active", null], [8, "id", 0], [1, "aria-selected", 0], [1, "aria-disabled", 0], [2, "mat-option-disabled", null]], [[null, "click"], [null, "keydown"]], function (_v, en, $event) {
                var ad = true;
                if (("click" === en)) {
                    var pd_0 = (nodeValue(_v, 95)._selectViaInteraction() !== false);
                    ad = (pd_0 && ad);
                }
                if (("keydown" === en)) {
                    var pd_1 = (nodeValue(_v, 95)._handleKeydown($event) !== false);
                    ad = (pd_1 && ad);
                }
                return ad;
            }, j$1, i)), directiveDef(95, 8568832, [[29, 4]], 0, MatOption, [ElementRef, ChangeDetectorRef, [2, MAT_OPTION_PARENT_COMPONENT], [2, MatOptgroup]], { value: [0, "value"] }, null), (_l()(), textDef(-1, 0, ["critical"])), (_l()(), elementDef(97, 0, null, 1, 2, "mat-option", [["class", "mat-option"], ["role", "option"], ["value", "2"]], [[1, "tabindex", 0], [2, "mat-selected", null], [2, "mat-option-multiple", null], [2, "mat-active", null], [8, "id", 0], [1, "aria-selected", 0], [1, "aria-disabled", 0], [2, "mat-option-disabled", null]], [[null, "click"], [null, "keydown"]], function (_v, en, $event) {
                var ad = true;
                if (("click" === en)) {
                    var pd_0 = (nodeValue(_v, 98)._selectViaInteraction() !== false);
                    ad = (pd_0 && ad);
                }
                if (("keydown" === en)) {
                    var pd_1 = (nodeValue(_v, 98)._handleKeydown($event) !== false);
                    ad = (pd_1 && ad);
                }
                return ad;
            }, j$1, i)), directiveDef(98, 8568832, [[29, 4]], 0, MatOption, [ElementRef, ChangeDetectorRef, [2, MAT_OPTION_PARENT_COMPONENT], [2, MatOptgroup]], { value: [0, "value"] }, null), (_l()(), textDef(-1, 0, ["info"])), (_l()(), elementDef(100, 0, null, 1, 2, "mat-option", [["class", "mat-option"], ["role", "option"], ["value", "3"]], [[1, "tabindex", 0], [2, "mat-selected", null], [2, "mat-option-multiple", null], [2, "mat-active", null], [8, "id", 0], [1, "aria-selected", 0], [1, "aria-disabled", 0], [2, "mat-option-disabled", null]], [[null, "click"], [null, "keydown"]], function (_v, en, $event) {
                var ad = true;
                if (("click" === en)) {
                    var pd_0 = (nodeValue(_v, 101)._selectViaInteraction() !== false);
                    ad = (pd_0 && ad);
                }
                if (("keydown" === en)) {
                    var pd_1 = (nodeValue(_v, 101)._handleKeydown($event) !== false);
                    ad = (pd_1 && ad);
                }
                return ad;
            }, j$1, i)), directiveDef(101, 8568832, [[29, 4]], 0, MatOption, [ElementRef, ChangeDetectorRef, [2, MAT_OPTION_PARENT_COMPONENT], [2, MatOptgroup]], { value: [0, "value"] }, null), (_l()(), textDef(-1, 0, ["verbose"])), (_l()(), elementDef(103, 0, null, null, 30, "div", [], null, null, null, null, null)), (_l()(), elementDef(104, 0, null, null, 29, "mat-form-field", [["class", "mat-form-field"]], [[2, "mat-form-field-appearance-standard", null], [2, "mat-form-field-appearance-fill", null], [2, "mat-form-field-appearance-outline", null], [2, "mat-form-field-appearance-legacy", null], [2, "mat-form-field-invalid", null], [2, "mat-form-field-can-float", null], [2, "mat-form-field-should-float", null], [2, "mat-form-field-has-label", null], [2, "mat-form-field-hide-placeholder", null], [2, "mat-form-field-disabled", null], [2, "mat-form-field-autofilled", null], [2, "mat-focused", null], [2, "mat-accent", null], [2, "mat-warn", null], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [2, "_mat-animation-noopable", null]], null, null, d$1, c$1)), directiveDef(105, 7520256, null, 9, MatFormField, [ElementRef, ChangeDetectorRef, [2, MAT_LABEL_GLOBAL_OPTIONS], [2, Directionality], [2, MAT_FORM_FIELD_DEFAULT_OPTIONS], Platform, NgZone, [2, ANIMATION_MODULE_TYPE]], null, null), queryDef(603979776, 32, { _controlNonStatic: 0 }), queryDef(335544320, 33, { _controlStatic: 0 }), queryDef(603979776, 34, { _labelChildNonStatic: 0 }), queryDef(335544320, 35, { _labelChildStatic: 0 }), queryDef(603979776, 36, { _placeholderChild: 0 }), queryDef(603979776, 37, { _errorChildren: 1 }), queryDef(603979776, 38, { _hintChildren: 1 }), queryDef(603979776, 39, { _prefixChildren: 1 }), queryDef(603979776, 40, { _suffixChildren: 1 }), (_l()(), elementDef(115, 0, null, 3, 2, "mat-label", [], null, null, null, null, null)), directiveDef(116, 16384, [[34, 4], [35, 4]], 0, MatLabel, [], null, null), (_l()(), textDef(-1, null, ["Device Trace Level"])), (_l()(), elementDef(118, 0, null, 1, 15, "mat-select", [["class", "mat-select"], ["role", "listbox"]], [[2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [1, "id", 0], [1, "tabindex", 0], [1, "aria-label", 0], [1, "aria-labelledby", 0], [1, "aria-required", 0], [1, "aria-disabled", 0], [1, "aria-invalid", 0], [1, "aria-owns", 0], [1, "aria-multiselectable", 0], [1, "aria-describedby", 0], [1, "aria-activedescendant", 0], [2, "mat-select-disabled", null], [2, "mat-select-invalid", null], [2, "mat-select-required", null], [2, "mat-select-empty", null]], [[null, "ngModelChange"], [null, "keydown"], [null, "focus"], [null, "blur"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("keydown" === en)) {
                    var pd_0 = (nodeValue(_v, 122)._handleKeydown($event) !== false);
                    ad = (pd_0 && ad);
                }
                if (("focus" === en)) {
                    var pd_1 = (nodeValue(_v, 122)._onFocus() !== false);
                    ad = (pd_1 && ad);
                }
                if (("blur" === en)) {
                    var pd_2 = (nodeValue(_v, 122)._onBlur() !== false);
                    ad = (pd_2 && ad);
                }
                if (("ngModelChange" === en)) {
                    var pd_3 = ((_co.deviceTracerLevel = $event) !== false);
                    ad = (pd_3 && ad);
                }
                return ad;
            }, d$3, c$3)), directiveDef(119, 671744, null, 0, NgModel, [[8, null], [8, null], [8, null], [8, null]], { model: [0, "model"] }, { update: "ngModelChange" }), providerDef(2048, null, NgControl, null, [NgModel]), directiveDef(121, 16384, null, 0, NgControlStatus, [[4, NgControl]], null, null), directiveDef(122, 2080768, null, 3, MatSelect, [ViewportRuler, ChangeDetectorRef, NgZone, ErrorStateMatcher, ElementRef, [2, Directionality], [2, NgForm], [2, FormGroupDirective], [2, MatFormField], [6, NgControl], [8, null], MAT_SELECT_SCROLL_STRATEGY, LiveAnnouncer], null, null), queryDef(603979776, 41, { options: 1 }), queryDef(603979776, 42, { optionGroups: 1 }), queryDef(603979776, 43, { customTrigger: 0 }), providerDef(2048, [[32, 4], [33, 4]], MatFormFieldControl, null, [MatSelect]), providerDef(2048, null, MAT_OPTION_PARENT_COMPONENT, null, [MatSelect]), (_l()(), elementDef(128, 0, null, 1, 2, "mat-option", [["class", "mat-option"], ["role", "option"], ["value", "0"]], [[1, "tabindex", 0], [2, "mat-selected", null], [2, "mat-option-multiple", null], [2, "mat-active", null], [8, "id", 0], [1, "aria-selected", 0], [1, "aria-disabled", 0], [2, "mat-option-disabled", null]], [[null, "click"], [null, "keydown"]], function (_v, en, $event) {
                var ad = true;
                if (("click" === en)) {
                    var pd_0 = (nodeValue(_v, 129)._selectViaInteraction() !== false);
                    ad = (pd_0 && ad);
                }
                if (("keydown" === en)) {
                    var pd_1 = (nodeValue(_v, 129)._handleKeydown($event) !== false);
                    ad = (pd_1 && ad);
                }
                return ad;
            }, j$1, i)), directiveDef(129, 8568832, [[41, 4]], 0, MatOption, [ElementRef, ChangeDetectorRef, [2, MAT_OPTION_PARENT_COMPONENT], [2, MatOptgroup]], { value: [0, "value"] }, null), (_l()(), textDef(-1, 0, ["disable"])), (_l()(), elementDef(131, 0, null, 1, 2, "mat-option", [["class", "mat-option"], ["role", "option"], ["value", "1"]], [[1, "tabindex", 0], [2, "mat-selected", null], [2, "mat-option-multiple", null], [2, "mat-active", null], [8, "id", 0], [1, "aria-selected", 0], [1, "aria-disabled", 0], [2, "mat-option-disabled", null]], [[null, "click"], [null, "keydown"]], function (_v, en, $event) {
                var ad = true;
                if (("click" === en)) {
                    var pd_0 = (nodeValue(_v, 132)._selectViaInteraction() !== false);
                    ad = (pd_0 && ad);
                }
                if (("keydown" === en)) {
                    var pd_1 = (nodeValue(_v, 132)._handleKeydown($event) !== false);
                    ad = (pd_1 && ad);
                }
                return ad;
            }, j$1, i)), directiveDef(132, 8568832, [[41, 4]], 0, MatOption, [ElementRef, ChangeDetectorRef, [2, MAT_OPTION_PARENT_COMPONENT], [2, MatOptgroup]], { value: [0, "value"] }, null), (_l()(), textDef(-1, 0, ["enable"])), (_l()(), elementDef(134, 0, null, null, 30, "div", [], null, null, null, null, null)), (_l()(), elementDef(135, 0, null, null, 29, "mat-form-field", [["class", "mat-form-field"]], [[2, "mat-form-field-appearance-standard", null], [2, "mat-form-field-appearance-fill", null], [2, "mat-form-field-appearance-outline", null], [2, "mat-form-field-appearance-legacy", null], [2, "mat-form-field-invalid", null], [2, "mat-form-field-can-float", null], [2, "mat-form-field-should-float", null], [2, "mat-form-field-has-label", null], [2, "mat-form-field-hide-placeholder", null], [2, "mat-form-field-disabled", null], [2, "mat-form-field-autofilled", null], [2, "mat-focused", null], [2, "mat-accent", null], [2, "mat-warn", null], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [2, "_mat-animation-noopable", null]], null, null, d$1, c$1)), directiveDef(136, 7520256, null, 9, MatFormField, [ElementRef, ChangeDetectorRef, [2, MAT_LABEL_GLOBAL_OPTIONS], [2, Directionality], [2, MAT_FORM_FIELD_DEFAULT_OPTIONS], Platform, NgZone, [2, ANIMATION_MODULE_TYPE]], null, null), queryDef(603979776, 44, { _controlNonStatic: 0 }), queryDef(335544320, 45, { _controlStatic: 0 }), queryDef(603979776, 46, { _labelChildNonStatic: 0 }), queryDef(335544320, 47, { _labelChildStatic: 0 }), queryDef(603979776, 48, { _placeholderChild: 0 }), queryDef(603979776, 49, { _errorChildren: 1 }), queryDef(603979776, 50, { _hintChildren: 1 }), queryDef(603979776, 51, { _prefixChildren: 1 }), queryDef(603979776, 52, { _suffixChildren: 1 }), (_l()(), elementDef(146, 0, null, 3, 2, "mat-label", [], null, null, null, null, null)), directiveDef(147, 16384, [[46, 4], [47, 4]], 0, MatLabel, [], null, null), (_l()(), textDef(-1, null, ["Python Trace Level"])), (_l()(), elementDef(149, 0, null, 1, 15, "mat-select", [["class", "mat-select"], ["role", "listbox"]], [[2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [1, "id", 0], [1, "tabindex", 0], [1, "aria-label", 0], [1, "aria-labelledby", 0], [1, "aria-required", 0], [1, "aria-disabled", 0], [1, "aria-invalid", 0], [1, "aria-owns", 0], [1, "aria-multiselectable", 0], [1, "aria-describedby", 0], [1, "aria-activedescendant", 0], [2, "mat-select-disabled", null], [2, "mat-select-invalid", null], [2, "mat-select-required", null], [2, "mat-select-empty", null]], [[null, "ngModelChange"], [null, "keydown"], [null, "focus"], [null, "blur"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("keydown" === en)) {
                    var pd_0 = (nodeValue(_v, 153)._handleKeydown($event) !== false);
                    ad = (pd_0 && ad);
                }
                if (("focus" === en)) {
                    var pd_1 = (nodeValue(_v, 153)._onFocus() !== false);
                    ad = (pd_1 && ad);
                }
                if (("blur" === en)) {
                    var pd_2 = (nodeValue(_v, 153)._onBlur() !== false);
                    ad = (pd_2 && ad);
                }
                if (("ngModelChange" === en)) {
                    var pd_3 = ((_co.pythonTracerLevel = $event) !== false);
                    ad = (pd_3 && ad);
                }
                return ad;
            }, d$3, c$3)), directiveDef(150, 671744, null, 0, NgModel, [[8, null], [8, null], [8, null], [8, null]], { model: [0, "model"] }, { update: "ngModelChange" }), providerDef(2048, null, NgControl, null, [NgModel]), directiveDef(152, 16384, null, 0, NgControlStatus, [[4, NgControl]], null, null), directiveDef(153, 2080768, null, 3, MatSelect, [ViewportRuler, ChangeDetectorRef, NgZone, ErrorStateMatcher, ElementRef, [2, Directionality], [2, NgForm], [2, FormGroupDirective], [2, MatFormField], [6, NgControl], [8, null], MAT_SELECT_SCROLL_STRATEGY, LiveAnnouncer], null, null), queryDef(603979776, 53, { options: 1 }), queryDef(603979776, 54, { optionGroups: 1 }), queryDef(603979776, 55, { customTrigger: 0 }), providerDef(2048, [[44, 4], [45, 4]], MatFormFieldControl, null, [MatSelect]), providerDef(2048, null, MAT_OPTION_PARENT_COMPONENT, null, [MatSelect]), (_l()(), elementDef(159, 0, null, 1, 2, "mat-option", [["class", "mat-option"], ["role", "option"], ["value", "0"]], [[1, "tabindex", 0], [2, "mat-selected", null], [2, "mat-option-multiple", null], [2, "mat-active", null], [8, "id", 0], [1, "aria-selected", 0], [1, "aria-disabled", 0], [2, "mat-option-disabled", null]], [[null, "click"], [null, "keydown"]], function (_v, en, $event) {
                var ad = true;
                if (("click" === en)) {
                    var pd_0 = (nodeValue(_v, 160)._selectViaInteraction() !== false);
                    ad = (pd_0 && ad);
                }
                if (("keydown" === en)) {
                    var pd_1 = (nodeValue(_v, 160)._handleKeydown($event) !== false);
                    ad = (pd_1 && ad);
                }
                return ad;
            }, j$1, i)), directiveDef(160, 8568832, [[53, 4]], 0, MatOption, [ElementRef, ChangeDetectorRef, [2, MAT_OPTION_PARENT_COMPONENT], [2, MatOptgroup]], { value: [0, "value"] }, null), (_l()(), textDef(-1, 0, ["disable"])), (_l()(), elementDef(162, 0, null, 1, 2, "mat-option", [["class", "mat-option"], ["role", "option"], ["value", "1"]], [[1, "tabindex", 0], [2, "mat-selected", null], [2, "mat-option-multiple", null], [2, "mat-active", null], [8, "id", 0], [1, "aria-selected", 0], [1, "aria-disabled", 0], [2, "mat-option-disabled", null]], [[null, "click"], [null, "keydown"]], function (_v, en, $event) {
                var ad = true;
                if (("click" === en)) {
                    var pd_0 = (nodeValue(_v, 163)._selectViaInteraction() !== false);
                    ad = (pd_0 && ad);
                }
                if (("keydown" === en)) {
                    var pd_1 = (nodeValue(_v, 163)._handleKeydown($event) !== false);
                    ad = (pd_1 && ad);
                }
                return ad;
            }, j$1, i)), directiveDef(163, 8568832, [[53, 4]], 0, MatOption, [ElementRef, ChangeDetectorRef, [2, MAT_OPTION_PARENT_COMPONENT], [2, MatOptgroup]], { value: [0, "value"] }, null), (_l()(), textDef(-1, 0, ["enable"])), (_l()(), elementDef(165, 0, null, null, 23, "div", [], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(166, 0, null, null, 22, "div", [], null, null, null, null, null)), (_l()(), elementDef(167, 0, null, null, 21, "mat-form-field", [["class", "mat-form-field"]], [[2, "mat-form-field-appearance-standard", null], [2, "mat-form-field-appearance-fill", null], [2, "mat-form-field-appearance-outline", null], [2, "mat-form-field-appearance-legacy", null], [2, "mat-form-field-invalid", null], [2, "mat-form-field-can-float", null], [2, "mat-form-field-should-float", null], [2, "mat-form-field-has-label", null], [2, "mat-form-field-hide-placeholder", null], [2, "mat-form-field-disabled", null], [2, "mat-form-field-autofilled", null], [2, "mat-focused", null], [2, "mat-accent", null], [2, "mat-warn", null], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [2, "_mat-animation-noopable", null]], null, null, d$1, c$1)), directiveDef(168, 7520256, null, 9, MatFormField, [ElementRef, ChangeDetectorRef, [2, MAT_LABEL_GLOBAL_OPTIONS], [2, Directionality], [2, MAT_FORM_FIELD_DEFAULT_OPTIONS], Platform, NgZone, [2, ANIMATION_MODULE_TYPE]], null, null), queryDef(603979776, 56, { _controlNonStatic: 0 }), queryDef(335544320, 57, { _controlStatic: 0 }), queryDef(603979776, 58, { _labelChildNonStatic: 0 }), queryDef(335544320, 59, { _labelChildStatic: 0 }), queryDef(603979776, 60, { _placeholderChild: 0 }), queryDef(603979776, 61, { _errorChildren: 1 }), queryDef(603979776, 62, { _hintChildren: 1 }), queryDef(603979776, 63, { _prefixChildren: 1 }), queryDef(603979776, 64, { _suffixChildren: 1 }), (_l()(), elementDef(178, 0, null, 3, 2, "mat-label", [], null, null, null, null, null)), directiveDef(179, 16384, [[58, 4], [59, 4]], 0, MatLabel, [], null, null), (_l()(), textDef(-1, null, ["Subset of worker TPUs to profile (optional)"])), (_l()(), elementDef(181, 0, null, 1, 7, "input", [["class", "mat-input-element mat-form-field-autofill-control"], ["matInput", ""], ["placeholder", "List of IPs, e.g. 10.4.1.2:8466,10.4.1.3:8466"]], [[2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [2, "mat-input-server", null], [1, "id", 0], [1, "placeholder", 0], [8, "disabled", 0], [8, "required", 0], [1, "readonly", 0], [1, "aria-describedby", 0], [1, "aria-invalid", 0], [1, "aria-required", 0]], [[null, "ngModelChange"], [null, "input"], [null, "blur"], [null, "compositionstart"], [null, "compositionend"], [null, "focus"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("input" === en)) {
                    var pd_0 = (nodeValue(_v, 182)._handleInput($event.target.value) !== false);
                    ad = (pd_0 && ad);
                }
                if (("blur" === en)) {
                    var pd_1 = (nodeValue(_v, 182).onTouched() !== false);
                    ad = (pd_1 && ad);
                }
                if (("compositionstart" === en)) {
                    var pd_2 = (nodeValue(_v, 182)._compositionStart() !== false);
                    ad = (pd_2 && ad);
                }
                if (("compositionend" === en)) {
                    var pd_3 = (nodeValue(_v, 182)._compositionEnd($event.target.value) !== false);
                    ad = (pd_3 && ad);
                }
                if (("blur" === en)) {
                    var pd_4 = (nodeValue(_v, 187)._focusChanged(false) !== false);
                    ad = (pd_4 && ad);
                }
                if (("focus" === en)) {
                    var pd_5 = (nodeValue(_v, 187)._focusChanged(true) !== false);
                    ad = (pd_5 && ad);
                }
                if (("input" === en)) {
                    var pd_6 = (nodeValue(_v, 187)._onInput() !== false);
                    ad = (pd_6 && ad);
                }
                if (("ngModelChange" === en)) {
                    var pd_7 = ((_co.workerList = $event) !== false);
                    ad = (pd_7 && ad);
                }
                return ad;
            }, null, null)), directiveDef(182, 16384, null, 0, DefaultValueAccessor, [Renderer2, ElementRef, [2, COMPOSITION_BUFFER_MODE]], null, null), providerDef(1024, null, NG_VALUE_ACCESSOR, function (p0_0) { return [p0_0]; }, [DefaultValueAccessor]), directiveDef(184, 671744, null, 0, NgModel, [[8, null], [8, null], [8, null], [6, NG_VALUE_ACCESSOR]], { model: [0, "model"] }, { update: "ngModelChange" }), providerDef(2048, null, NgControl, null, [NgModel]), directiveDef(186, 16384, null, 0, NgControlStatus, [[4, NgControl]], null, null), directiveDef(187, 999424, null, 0, MatInput, [ElementRef, Platform, [6, NgControl], [2, NgForm], [2, FormGroupDirective], ErrorStateMatcher, [8, null], AutofillMonitor, NgZone], { placeholder: [0, "placeholder"] }, null), providerDef(2048, [[56, 4], [57, 4]], MatFormFieldControl, null, [MatInput]), (_l()(), elementDef(189, 0, null, null, 53, "div", [], null, null, null, null, null)), (_l()(), elementDef(190, 16777216, null, null, 52, "mat-expansion-panel", [["class", "mat-elevation-z0 mat-expansion-panel"]], [[2, "mat-expanded", null], [2, "_mat-animation-noopable", null], [2, "mat-expansion-panel-spacing", null]], null, null, d$4, c$4)), directiveDef(191, 1753088, null, 1, MatExpansionPanel, [[3, MAT_ACCORDION], ChangeDetectorRef, UniqueSelectionDispatcher, ViewContainerRef, DOCUMENT, [2, ANIMATION_MODULE_TYPE], [2, MAT_EXPANSION_PANEL_DEFAULT_OPTIONS]], null, null), queryDef(603979776, 65, { _lazyContent: 0 }), providerDef(256, null, MAT_ACCORDION, undefined, []), (_l()(), elementDef(194, 0, null, 0, 6, "mat-expansion-panel-header", [["class", "mat-expansion-panel-header"], ["role", "button"]], [[1, "id", 0], [1, "tabindex", 0], [1, "aria-controls", 0], [1, "aria-expanded", 0], [1, "aria-disabled", 0], [2, "mat-expanded", null], [2, "mat-expansion-toggle-indicator-after", null], [2, "mat-expansion-toggle-indicator-before", null], [40, "@.disabled", 0], [40, "@expansionHeight", 0]], [[null, "click"], [null, "keydown"], ["component", "@expansionHeight.start"]], function (_v, en, $event) {
                var ad = true;
                if (("click" === en)) {
                    var pd_0 = (nodeValue(_v, 195)._toggle() !== false);
                    ad = (pd_0 && ad);
                }
                if (("keydown" === en)) {
                    var pd_1 = (nodeValue(_v, 195)._keydown($event) !== false);
                    ad = (pd_1 && ad);
                }
                if (("component:@expansionHeight.start" === en)) {
                    var pd_2 = (nodeValue(_v, 195)._animationStarted() !== false);
                    ad = (pd_2 && ad);
                }
                return ad;
            }, h, g)), directiveDef(195, 180224, null, 0, MatExpansionPanelHeader, [MatExpansionPanel, ElementRef, FocusMonitor, ChangeDetectorRef, [2, MAT_EXPANSION_PANEL_DEFAULT_OPTIONS]], null, null), pureObjectDef(196, { collapsedHeight: 0, expandedHeight: 1 }), pureObjectDef(197, { value: 0, params: 1 }), (_l()(), elementDef(198, 0, null, 0, 2, "mat-panel-title", [["class", "mat-expansion-panel-header-title"]], null, null, null, null, null)), directiveDef(199, 16384, null, 0, MatExpansionPanelTitle, [], null, null), (_l()(), textDef(-1, null, [" Advanced options "])), (_l()(), elementDef(201, 0, null, 1, 20, "div", [], null, null, null, null, null)), (_l()(), elementDef(202, 0, null, null, 19, "mat-form-field", [["class", "mat-form-field"]], [[2, "mat-form-field-appearance-standard", null], [2, "mat-form-field-appearance-fill", null], [2, "mat-form-field-appearance-outline", null], [2, "mat-form-field-appearance-legacy", null], [2, "mat-form-field-invalid", null], [2, "mat-form-field-can-float", null], [2, "mat-form-field-should-float", null], [2, "mat-form-field-has-label", null], [2, "mat-form-field-hide-placeholder", null], [2, "mat-form-field-disabled", null], [2, "mat-form-field-autofilled", null], [2, "mat-focused", null], [2, "mat-accent", null], [2, "mat-warn", null], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [2, "_mat-animation-noopable", null]], null, null, d$1, c$1)), directiveDef(203, 7520256, null, 9, MatFormField, [ElementRef, ChangeDetectorRef, [2, MAT_LABEL_GLOBAL_OPTIONS], [2, Directionality], [2, MAT_FORM_FIELD_DEFAULT_OPTIONS], Platform, NgZone, [2, ANIMATION_MODULE_TYPE]], null, null), queryDef(603979776, 66, { _controlNonStatic: 0 }), queryDef(335544320, 67, { _controlStatic: 0 }), queryDef(603979776, 68, { _labelChildNonStatic: 0 }), queryDef(335544320, 69, { _labelChildStatic: 0 }), queryDef(603979776, 70, { _placeholderChild: 0 }), queryDef(603979776, 71, { _errorChildren: 1 }), queryDef(603979776, 72, { _hintChildren: 1 }), queryDef(603979776, 73, { _prefixChildren: 1 }), queryDef(603979776, 74, { _suffixChildren: 1 }), (_l()(), elementDef(213, 0, null, 1, 8, "input", [["class", "mat-input-element mat-form-field-autofill-control"], ["matInput", ""], ["placeholder", "Automatically retry N times when no trace event is collected"], ["type", "number"]], [[2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [2, "mat-input-server", null], [1, "id", 0], [1, "placeholder", 0], [8, "disabled", 0], [8, "required", 0], [1, "readonly", 0], [1, "aria-describedby", 0], [1, "aria-invalid", 0], [1, "aria-required", 0]], [[null, "ngModelChange"], [null, "input"], [null, "blur"], [null, "compositionstart"], [null, "compositionend"], [null, "change"], [null, "focus"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("input" === en)) {
                    var pd_0 = (nodeValue(_v, 214)._handleInput($event.target.value) !== false);
                    ad = (pd_0 && ad);
                }
                if (("blur" === en)) {
                    var pd_1 = (nodeValue(_v, 214).onTouched() !== false);
                    ad = (pd_1 && ad);
                }
                if (("compositionstart" === en)) {
                    var pd_2 = (nodeValue(_v, 214)._compositionStart() !== false);
                    ad = (pd_2 && ad);
                }
                if (("compositionend" === en)) {
                    var pd_3 = (nodeValue(_v, 214)._compositionEnd($event.target.value) !== false);
                    ad = (pd_3 && ad);
                }
                if (("change" === en)) {
                    var pd_4 = (nodeValue(_v, 215).onChange($event.target.value) !== false);
                    ad = (pd_4 && ad);
                }
                if (("input" === en)) {
                    var pd_5 = (nodeValue(_v, 215).onChange($event.target.value) !== false);
                    ad = (pd_5 && ad);
                }
                if (("blur" === en)) {
                    var pd_6 = (nodeValue(_v, 215).onTouched() !== false);
                    ad = (pd_6 && ad);
                }
                if (("blur" === en)) {
                    var pd_7 = (nodeValue(_v, 220)._focusChanged(false) !== false);
                    ad = (pd_7 && ad);
                }
                if (("focus" === en)) {
                    var pd_8 = (nodeValue(_v, 220)._focusChanged(true) !== false);
                    ad = (pd_8 && ad);
                }
                if (("input" === en)) {
                    var pd_9 = (nodeValue(_v, 220)._onInput() !== false);
                    ad = (pd_9 && ad);
                }
                if (("ngModelChange" === en)) {
                    var pd_10 = ((_co.numRetry = $event) !== false);
                    ad = (pd_10 && ad);
                }
                return ad;
            }, null, null)), directiveDef(214, 16384, null, 0, DefaultValueAccessor, [Renderer2, ElementRef, [2, COMPOSITION_BUFFER_MODE]], null, null), directiveDef(215, 16384, null, 0, NumberValueAccessor, [Renderer2, ElementRef], null, null), providerDef(1024, null, NG_VALUE_ACCESSOR, function (p0_0, p1_0) { return [p0_0, p1_0]; }, [DefaultValueAccessor, NumberValueAccessor]), directiveDef(217, 671744, null, 0, NgModel, [[8, null], [8, null], [8, null], [6, NG_VALUE_ACCESSOR]], { model: [0, "model"] }, { update: "ngModelChange" }), providerDef(2048, null, NgControl, null, [NgModel]), directiveDef(219, 16384, null, 0, NgControlStatus, [[4, NgControl]], null, null), directiveDef(220, 999424, null, 0, MatInput, [ElementRef, Platform, [6, NgControl], [2, NgForm], [2, FormGroupDirective], ErrorStateMatcher, [8, null], AutofillMonitor, NgZone], { placeholder: [0, "placeholder"], type: [1, "type"] }, null), providerDef(2048, [[66, 4], [67, 4]], MatFormFieldControl, null, [MatInput]), (_l()(), elementDef(222, 0, null, 1, 20, "div", [], null, null, null, null, null)), (_l()(), elementDef(223, 0, null, null, 19, "mat-form-field", [["class", "mat-form-field"]], [[2, "mat-form-field-appearance-standard", null], [2, "mat-form-field-appearance-fill", null], [2, "mat-form-field-appearance-outline", null], [2, "mat-form-field-appearance-legacy", null], [2, "mat-form-field-invalid", null], [2, "mat-form-field-can-float", null], [2, "mat-form-field-should-float", null], [2, "mat-form-field-has-label", null], [2, "mat-form-field-hide-placeholder", null], [2, "mat-form-field-disabled", null], [2, "mat-form-field-autofilled", null], [2, "mat-focused", null], [2, "mat-accent", null], [2, "mat-warn", null], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [2, "_mat-animation-noopable", null]], null, null, d$1, c$1)), directiveDef(224, 7520256, null, 9, MatFormField, [ElementRef, ChangeDetectorRef, [2, MAT_LABEL_GLOBAL_OPTIONS], [2, Directionality], [2, MAT_FORM_FIELD_DEFAULT_OPTIONS], Platform, NgZone, [2, ANIMATION_MODULE_TYPE]], null, null), queryDef(603979776, 75, { _controlNonStatic: 0 }), queryDef(335544320, 76, { _controlStatic: 0 }), queryDef(603979776, 77, { _labelChildNonStatic: 0 }), queryDef(335544320, 78, { _labelChildStatic: 0 }), queryDef(603979776, 79, { _placeholderChild: 0 }), queryDef(603979776, 80, { _errorChildren: 1 }), queryDef(603979776, 81, { _hintChildren: 1 }), queryDef(603979776, 82, { _prefixChildren: 1 }), queryDef(603979776, 83, { _suffixChildren: 1 }), (_l()(), elementDef(234, 0, null, 1, 8, "input", [["class", "mat-input-element mat-form-field-autofill-control"], ["matInput", ""], ["placeholder", "Delay the start of profiling (milliseconds)"], ["type", "number"]], [[2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [2, "mat-input-server", null], [1, "id", 0], [1, "placeholder", 0], [8, "disabled", 0], [8, "required", 0], [1, "readonly", 0], [1, "aria-describedby", 0], [1, "aria-invalid", 0], [1, "aria-required", 0]], [[null, "ngModelChange"], [null, "input"], [null, "blur"], [null, "compositionstart"], [null, "compositionend"], [null, "change"], [null, "focus"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("input" === en)) {
                    var pd_0 = (nodeValue(_v, 235)._handleInput($event.target.value) !== false);
                    ad = (pd_0 && ad);
                }
                if (("blur" === en)) {
                    var pd_1 = (nodeValue(_v, 235).onTouched() !== false);
                    ad = (pd_1 && ad);
                }
                if (("compositionstart" === en)) {
                    var pd_2 = (nodeValue(_v, 235)._compositionStart() !== false);
                    ad = (pd_2 && ad);
                }
                if (("compositionend" === en)) {
                    var pd_3 = (nodeValue(_v, 235)._compositionEnd($event.target.value) !== false);
                    ad = (pd_3 && ad);
                }
                if (("change" === en)) {
                    var pd_4 = (nodeValue(_v, 236).onChange($event.target.value) !== false);
                    ad = (pd_4 && ad);
                }
                if (("input" === en)) {
                    var pd_5 = (nodeValue(_v, 236).onChange($event.target.value) !== false);
                    ad = (pd_5 && ad);
                }
                if (("blur" === en)) {
                    var pd_6 = (nodeValue(_v, 236).onTouched() !== false);
                    ad = (pd_6 && ad);
                }
                if (("blur" === en)) {
                    var pd_7 = (nodeValue(_v, 241)._focusChanged(false) !== false);
                    ad = (pd_7 && ad);
                }
                if (("focus" === en)) {
                    var pd_8 = (nodeValue(_v, 241)._focusChanged(true) !== false);
                    ad = (pd_8 && ad);
                }
                if (("input" === en)) {
                    var pd_9 = (nodeValue(_v, 241)._onInput() !== false);
                    ad = (pd_9 && ad);
                }
                if (("ngModelChange" === en)) {
                    var pd_10 = ((_co.delay = $event) !== false);
                    ad = (pd_10 && ad);
                }
                return ad;
            }, null, null)), directiveDef(235, 16384, null, 0, DefaultValueAccessor, [Renderer2, ElementRef, [2, COMPOSITION_BUFFER_MODE]], null, null), directiveDef(236, 16384, null, 0, NumberValueAccessor, [Renderer2, ElementRef], null, null), providerDef(1024, null, NG_VALUE_ACCESSOR, function (p0_0, p1_0) { return [p0_0, p1_0]; }, [DefaultValueAccessor, NumberValueAccessor]), directiveDef(238, 671744, null, 0, NgModel, [[8, null], [8, null], [8, null], [6, NG_VALUE_ACCESSOR]], { model: [0, "model"] }, { update: "ngModelChange" }), providerDef(2048, null, NgControl, null, [NgModel]), directiveDef(240, 16384, null, 0, NgControlStatus, [[4, NgControl]], null, null), directiveDef(241, 999424, null, 0, MatInput, [ElementRef, Platform, [6, NgControl], [2, NgForm], [2, FormGroupDirective], ErrorStateMatcher, [8, null], AutofillMonitor, NgZone], { placeholder: [0, "placeholder"], type: [1, "type"] }, null), providerDef(2048, [[75, 4], [76, 4]], MatFormFieldControl, null, [MatInput]), (_l()(), elementDef(243, 0, null, null, 9, "mat-dialog-actions", [["class", "mat-dialog-actions"]], null, null, null, null, null)), directiveDef(244, 16384, null, 0, MatDialogActions, [], null, null), (_l()(), elementDef(245, 0, null, null, 3, "button", [["mat-raised-button", ""]], [[1, "disabled", 0], [2, "_mat-animation-noopable", null]], [[null, "click"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("click" === en)) {
                    var pd_0 = (_co.captureProfile() !== false);
                    ad = (pd_0 && ad);
                }
                return ad;
            }, d, c)), directiveDef(246, 180224, null, 0, MatButton, [ElementRef, FocusMonitor, [2, ANIMATION_MODULE_TYPE]], { disabled: [0, "disabled"] }, null), (_l()(), textDef(247, 0, [" ", " "])), purePipeDef(248, 1), (_l()(), elementDef(249, 0, null, null, 3, "button", [["mat-raised-button", ""]], [[1, "disabled", 0], [2, "_mat-animation-noopable", null]], [[null, "click"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("click" === en)) {
                    var pd_0 = (_co.close() !== false);
                    ad = (pd_0 && ad);
                }
                return ad;
            }, d, c)), directiveDef(250, 180224, null, 0, MatButton, [ElementRef, FocusMonitor, [2, ANIMATION_MODULE_TYPE]], null, null), (_l()(), textDef(251, 0, [" ", " "])), purePipeDef(252, 1)], function (_ck, _v) { var _co = _v.component; var currVal_39 = ""; _ck(_v, 20, 0, currVal_39); var currVal_40 = _co.serviceAddr; _ck(_v, 23, 0, currVal_40); var currVal_41 = "localhost:6009,localhost:6010"; var currVal_42 = ""; _ck(_v, 26, 0, currVal_41, currVal_42); var currVal_50 = _co.addressType; _ck(_v, 33, 0, currVal_50); var currVal_62 = "ip"; _ck(_v, 38, 0, currVal_62); var currVal_74 = "tpu"; _ck(_v, 41, 0, currVal_74); var currVal_113 = _co.duration; _ck(_v, 60, 0, currVal_113); var currVal_114 = "Profiling Duration (milliseconds)"; var currVal_115 = "number"; _ck(_v, 63, 0, currVal_114, currVal_115); var currVal_160 = _co.hostTracerLevel; _ck(_v, 81, 0, currVal_160); _ck(_v, 84, 0); var currVal_161 = "above"; var currVal_162 = inlineInterpolate(1, "", _co.hostTracerTooltip, ""); _ck(_v, 88, 0, currVal_161, currVal_162); var currVal_171 = "0"; _ck(_v, 92, 0, currVal_171); var currVal_180 = "1"; _ck(_v, 95, 0, currVal_180); var currVal_189 = "2"; _ck(_v, 98, 0, currVal_189); var currVal_198 = "3"; _ck(_v, 101, 0, currVal_198); var currVal_243 = _co.deviceTracerLevel; _ck(_v, 119, 0, currVal_243); _ck(_v, 122, 0); var currVal_252 = "0"; _ck(_v, 129, 0, currVal_252); var currVal_261 = "1"; _ck(_v, 132, 0, currVal_261); var currVal_306 = _co.pythonTracerLevel; _ck(_v, 150, 0, currVal_306); _ck(_v, 153, 0); var currVal_315 = "0"; _ck(_v, 160, 0, currVal_315); var currVal_324 = "1"; _ck(_v, 163, 0, currVal_324); var currVal_364 = _co.workerList; _ck(_v, 184, 0, currVal_364); var currVal_365 = "List of IPs, e.g. 10.4.1.2:8466,10.4.1.3:8466"; _ck(_v, 187, 0, currVal_365); var currVal_417 = _co.numRetry; _ck(_v, 217, 0, currVal_417); var currVal_418 = "Automatically retry N times when no trace event is collected"; var currVal_419 = "number"; _ck(_v, 220, 0, currVal_418, currVal_419); var currVal_458 = _co.delay; _ck(_v, 238, 0, currVal_458); var currVal_459 = "Delay the start of profiling (milliseconds)"; var currVal_460 = "number"; _ck(_v, 241, 0, currVal_459, currVal_460); var currVal_463 = !_co.serviceAddr; _ck(_v, 246, 0, currVal_463); }, function (_ck, _v) { var _co = _v.component; var currVal_0 = (nodeValue(_v, 5).appearance == "standard"); var currVal_1 = (nodeValue(_v, 5).appearance == "fill"); var currVal_2 = (nodeValue(_v, 5).appearance == "outline"); var currVal_3 = (nodeValue(_v, 5).appearance == "legacy"); var currVal_4 = nodeValue(_v, 5)._control.errorState; var currVal_5 = nodeValue(_v, 5)._canLabelFloat; var currVal_6 = nodeValue(_v, 5)._shouldLabelFloat(); var currVal_7 = nodeValue(_v, 5)._hasFloatingLabel(); var currVal_8 = nodeValue(_v, 5)._hideControlPlaceholder(); var currVal_9 = nodeValue(_v, 5)._control.disabled; var currVal_10 = nodeValue(_v, 5)._control.autofilled; var currVal_11 = nodeValue(_v, 5)._control.focused; var currVal_12 = (nodeValue(_v, 5).color == "accent"); var currVal_13 = (nodeValue(_v, 5).color == "warn"); var currVal_14 = nodeValue(_v, 5)._shouldForward("untouched"); var currVal_15 = nodeValue(_v, 5)._shouldForward("touched"); var currVal_16 = nodeValue(_v, 5)._shouldForward("pristine"); var currVal_17 = nodeValue(_v, 5)._shouldForward("dirty"); var currVal_18 = nodeValue(_v, 5)._shouldForward("valid"); var currVal_19 = nodeValue(_v, 5)._shouldForward("invalid"); var currVal_20 = nodeValue(_v, 5)._shouldForward("pending"); var currVal_21 = !nodeValue(_v, 5)._animationsEnabled; _ck(_v, 4, 1, [currVal_0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5, currVal_6, currVal_7, currVal_8, currVal_9, currVal_10, currVal_11, currVal_12, currVal_13, currVal_14, currVal_15, currVal_16, currVal_17, currVal_18, currVal_19, currVal_20, currVal_21]); var currVal_22 = (nodeValue(_v, 20).required ? "" : null); var currVal_23 = nodeValue(_v, 25).ngClassUntouched; var currVal_24 = nodeValue(_v, 25).ngClassTouched; var currVal_25 = nodeValue(_v, 25).ngClassPristine; var currVal_26 = nodeValue(_v, 25).ngClassDirty; var currVal_27 = nodeValue(_v, 25).ngClassValid; var currVal_28 = nodeValue(_v, 25).ngClassInvalid; var currVal_29 = nodeValue(_v, 25).ngClassPending; var currVal_30 = nodeValue(_v, 26)._isServer; var currVal_31 = nodeValue(_v, 26).id; var currVal_32 = nodeValue(_v, 26).placeholder; var currVal_33 = nodeValue(_v, 26).disabled; var currVal_34 = nodeValue(_v, 26).required; var currVal_35 = ((nodeValue(_v, 26).readonly && !nodeValue(_v, 26)._isNativeSelect) || null); var currVal_36 = (nodeValue(_v, 26)._ariaDescribedby || null); var currVal_37 = nodeValue(_v, 26).errorState; var currVal_38 = nodeValue(_v, 26).required.toString(); _ck(_v, 18, 1, [currVal_22, currVal_23, currVal_24, currVal_25, currVal_26, currVal_27, currVal_28, currVal_29, currVal_30, currVal_31, currVal_32, currVal_33, currVal_34, currVal_35, currVal_36, currVal_37, currVal_38]); var currVal_43 = nodeValue(_v, 35).ngClassUntouched; var currVal_44 = nodeValue(_v, 35).ngClassTouched; var currVal_45 = nodeValue(_v, 35).ngClassPristine; var currVal_46 = nodeValue(_v, 35).ngClassDirty; var currVal_47 = nodeValue(_v, 35).ngClassValid; var currVal_48 = nodeValue(_v, 35).ngClassInvalid; var currVal_49 = nodeValue(_v, 35).ngClassPending; _ck(_v, 29, 0, currVal_43, currVal_44, currVal_45, currVal_46, currVal_47, currVal_48, currVal_49); var currVal_51 = nodeValue(_v, 38).checked; var currVal_52 = nodeValue(_v, 38).disabled; var currVal_53 = (nodeValue(_v, 38)._animationMode === "NoopAnimations"); var currVal_54 = (nodeValue(_v, 38).color === "primary"); var currVal_55 = (nodeValue(_v, 38).color === "accent"); var currVal_56 = (nodeValue(_v, 38).color === "warn"); var currVal_57 = (0 - 1); var currVal_58 = nodeValue(_v, 38).id; var currVal_59 = null; var currVal_60 = null; var currVal_61 = null; _ck(_v, 37, 1, [currVal_51, currVal_52, currVal_53, currVal_54, currVal_55, currVal_56, currVal_57, currVal_58, currVal_59, currVal_60, currVal_61]); var currVal_63 = nodeValue(_v, 41).checked; var currVal_64 = nodeValue(_v, 41).disabled; var currVal_65 = (nodeValue(_v, 41)._animationMode === "NoopAnimations"); var currVal_66 = (nodeValue(_v, 41).color === "primary"); var currVal_67 = (nodeValue(_v, 41).color === "accent"); var currVal_68 = (nodeValue(_v, 41).color === "warn"); var currVal_69 = (0 - 1); var currVal_70 = nodeValue(_v, 41).id; var currVal_71 = null; var currVal_72 = null; var currVal_73 = null; _ck(_v, 40, 1, [currVal_63, currVal_64, currVal_65, currVal_66, currVal_67, currVal_68, currVal_69, currVal_70, currVal_71, currVal_72, currVal_73]); var currVal_75 = (nodeValue(_v, 46).appearance == "standard"); var currVal_76 = (nodeValue(_v, 46).appearance == "fill"); var currVal_77 = (nodeValue(_v, 46).appearance == "outline"); var currVal_78 = (nodeValue(_v, 46).appearance == "legacy"); var currVal_79 = nodeValue(_v, 46)._control.errorState; var currVal_80 = nodeValue(_v, 46)._canLabelFloat; var currVal_81 = nodeValue(_v, 46)._shouldLabelFloat(); var currVal_82 = nodeValue(_v, 46)._hasFloatingLabel(); var currVal_83 = nodeValue(_v, 46)._hideControlPlaceholder(); var currVal_84 = nodeValue(_v, 46)._control.disabled; var currVal_85 = nodeValue(_v, 46)._control.autofilled; var currVal_86 = nodeValue(_v, 46)._control.focused; var currVal_87 = (nodeValue(_v, 46).color == "accent"); var currVal_88 = (nodeValue(_v, 46).color == "warn"); var currVal_89 = nodeValue(_v, 46)._shouldForward("untouched"); var currVal_90 = nodeValue(_v, 46)._shouldForward("touched"); var currVal_91 = nodeValue(_v, 46)._shouldForward("pristine"); var currVal_92 = nodeValue(_v, 46)._shouldForward("dirty"); var currVal_93 = nodeValue(_v, 46)._shouldForward("valid"); var currVal_94 = nodeValue(_v, 46)._shouldForward("invalid"); var currVal_95 = nodeValue(_v, 46)._shouldForward("pending"); var currVal_96 = !nodeValue(_v, 46)._animationsEnabled; _ck(_v, 45, 1, [currVal_75, currVal_76, currVal_77, currVal_78, currVal_79, currVal_80, currVal_81, currVal_82, currVal_83, currVal_84, currVal_85, currVal_86, currVal_87, currVal_88, currVal_89, currVal_90, currVal_91, currVal_92, currVal_93, currVal_94, currVal_95, currVal_96]); var currVal_97 = nodeValue(_v, 62).ngClassUntouched; var currVal_98 = nodeValue(_v, 62).ngClassTouched; var currVal_99 = nodeValue(_v, 62).ngClassPristine; var currVal_100 = nodeValue(_v, 62).ngClassDirty; var currVal_101 = nodeValue(_v, 62).ngClassValid; var currVal_102 = nodeValue(_v, 62).ngClassInvalid; var currVal_103 = nodeValue(_v, 62).ngClassPending; var currVal_104 = nodeValue(_v, 63)._isServer; var currVal_105 = nodeValue(_v, 63).id; var currVal_106 = nodeValue(_v, 63).placeholder; var currVal_107 = nodeValue(_v, 63).disabled; var currVal_108 = nodeValue(_v, 63).required; var currVal_109 = ((nodeValue(_v, 63).readonly && !nodeValue(_v, 63)._isNativeSelect) || null); var currVal_110 = (nodeValue(_v, 63)._ariaDescribedby || null); var currVal_111 = nodeValue(_v, 63).errorState; var currVal_112 = nodeValue(_v, 63).required.toString(); _ck(_v, 56, 1, [currVal_97, currVal_98, currVal_99, currVal_100, currVal_101, currVal_102, currVal_103, currVal_104, currVal_105, currVal_106, currVal_107, currVal_108, currVal_109, currVal_110, currVal_111, currVal_112]); var currVal_116 = (nodeValue(_v, 67).appearance == "standard"); var currVal_117 = (nodeValue(_v, 67).appearance == "fill"); var currVal_118 = (nodeValue(_v, 67).appearance == "outline"); var currVal_119 = (nodeValue(_v, 67).appearance == "legacy"); var currVal_120 = nodeValue(_v, 67)._control.errorState; var currVal_121 = nodeValue(_v, 67)._canLabelFloat; var currVal_122 = nodeValue(_v, 67)._shouldLabelFloat(); var currVal_123 = nodeValue(_v, 67)._hasFloatingLabel(); var currVal_124 = nodeValue(_v, 67)._hideControlPlaceholder(); var currVal_125 = nodeValue(_v, 67)._control.disabled; var currVal_126 = nodeValue(_v, 67)._control.autofilled; var currVal_127 = nodeValue(_v, 67)._control.focused; var currVal_128 = (nodeValue(_v, 67).color == "accent"); var currVal_129 = (nodeValue(_v, 67).color == "warn"); var currVal_130 = nodeValue(_v, 67)._shouldForward("untouched"); var currVal_131 = nodeValue(_v, 67)._shouldForward("touched"); var currVal_132 = nodeValue(_v, 67)._shouldForward("pristine"); var currVal_133 = nodeValue(_v, 67)._shouldForward("dirty"); var currVal_134 = nodeValue(_v, 67)._shouldForward("valid"); var currVal_135 = nodeValue(_v, 67)._shouldForward("invalid"); var currVal_136 = nodeValue(_v, 67)._shouldForward("pending"); var currVal_137 = !nodeValue(_v, 67)._animationsEnabled; _ck(_v, 66, 1, [currVal_116, currVal_117, currVal_118, currVal_119, currVal_120, currVal_121, currVal_122, currVal_123, currVal_124, currVal_125, currVal_126, currVal_127, currVal_128, currVal_129, currVal_130, currVal_131, currVal_132, currVal_133, currVal_134, currVal_135, currVal_136, currVal_137]); var currVal_138 = nodeValue(_v, 83).ngClassUntouched; var currVal_139 = nodeValue(_v, 83).ngClassTouched; var currVal_140 = nodeValue(_v, 83).ngClassPristine; var currVal_141 = nodeValue(_v, 83).ngClassDirty; var currVal_142 = nodeValue(_v, 83).ngClassValid; var currVal_143 = nodeValue(_v, 83).ngClassInvalid; var currVal_144 = nodeValue(_v, 83).ngClassPending; var currVal_145 = nodeValue(_v, 84).id; var currVal_146 = nodeValue(_v, 84).tabIndex; var currVal_147 = nodeValue(_v, 84)._getAriaLabel(); var currVal_148 = nodeValue(_v, 84)._getAriaLabelledby(); var currVal_149 = nodeValue(_v, 84).required.toString(); var currVal_150 = nodeValue(_v, 84).disabled.toString(); var currVal_151 = nodeValue(_v, 84).errorState; var currVal_152 = (nodeValue(_v, 84).panelOpen ? nodeValue(_v, 84)._optionIds : null); var currVal_153 = nodeValue(_v, 84).multiple; var currVal_154 = (nodeValue(_v, 84)._ariaDescribedby || null); var currVal_155 = nodeValue(_v, 84)._getAriaActiveDescendant(); var currVal_156 = nodeValue(_v, 84).disabled; var currVal_157 = nodeValue(_v, 84).errorState; var currVal_158 = nodeValue(_v, 84).required; var currVal_159 = nodeValue(_v, 84).empty; _ck(_v, 80, 1, [currVal_138, currVal_139, currVal_140, currVal_141, currVal_142, currVal_143, currVal_144, currVal_145, currVal_146, currVal_147, currVal_148, currVal_149, currVal_150, currVal_151, currVal_152, currVal_153, currVal_154, currVal_155, currVal_156, currVal_157, currVal_158, currVal_159]); var currVal_163 = nodeValue(_v, 92)._getTabIndex(); var currVal_164 = nodeValue(_v, 92).selected; var currVal_165 = nodeValue(_v, 92).multiple; var currVal_166 = nodeValue(_v, 92).active; var currVal_167 = nodeValue(_v, 92).id; var currVal_168 = nodeValue(_v, 92)._getAriaSelected(); var currVal_169 = nodeValue(_v, 92).disabled.toString(); var currVal_170 = nodeValue(_v, 92).disabled; _ck(_v, 91, 0, currVal_163, currVal_164, currVal_165, currVal_166, currVal_167, currVal_168, currVal_169, currVal_170); var currVal_172 = nodeValue(_v, 95)._getTabIndex(); var currVal_173 = nodeValue(_v, 95).selected; var currVal_174 = nodeValue(_v, 95).multiple; var currVal_175 = nodeValue(_v, 95).active; var currVal_176 = nodeValue(_v, 95).id; var currVal_177 = nodeValue(_v, 95)._getAriaSelected(); var currVal_178 = nodeValue(_v, 95).disabled.toString(); var currVal_179 = nodeValue(_v, 95).disabled; _ck(_v, 94, 0, currVal_172, currVal_173, currVal_174, currVal_175, currVal_176, currVal_177, currVal_178, currVal_179); var currVal_181 = nodeValue(_v, 98)._getTabIndex(); var currVal_182 = nodeValue(_v, 98).selected; var currVal_183 = nodeValue(_v, 98).multiple; var currVal_184 = nodeValue(_v, 98).active; var currVal_185 = nodeValue(_v, 98).id; var currVal_186 = nodeValue(_v, 98)._getAriaSelected(); var currVal_187 = nodeValue(_v, 98).disabled.toString(); var currVal_188 = nodeValue(_v, 98).disabled; _ck(_v, 97, 0, currVal_181, currVal_182, currVal_183, currVal_184, currVal_185, currVal_186, currVal_187, currVal_188); var currVal_190 = nodeValue(_v, 101)._getTabIndex(); var currVal_191 = nodeValue(_v, 101).selected; var currVal_192 = nodeValue(_v, 101).multiple; var currVal_193 = nodeValue(_v, 101).active; var currVal_194 = nodeValue(_v, 101).id; var currVal_195 = nodeValue(_v, 101)._getAriaSelected(); var currVal_196 = nodeValue(_v, 101).disabled.toString(); var currVal_197 = nodeValue(_v, 101).disabled; _ck(_v, 100, 0, currVal_190, currVal_191, currVal_192, currVal_193, currVal_194, currVal_195, currVal_196, currVal_197); var currVal_199 = (nodeValue(_v, 105).appearance == "standard"); var currVal_200 = (nodeValue(_v, 105).appearance == "fill"); var currVal_201 = (nodeValue(_v, 105).appearance == "outline"); var currVal_202 = (nodeValue(_v, 105).appearance == "legacy"); var currVal_203 = nodeValue(_v, 105)._control.errorState; var currVal_204 = nodeValue(_v, 105)._canLabelFloat; var currVal_205 = nodeValue(_v, 105)._shouldLabelFloat(); var currVal_206 = nodeValue(_v, 105)._hasFloatingLabel(); var currVal_207 = nodeValue(_v, 105)._hideControlPlaceholder(); var currVal_208 = nodeValue(_v, 105)._control.disabled; var currVal_209 = nodeValue(_v, 105)._control.autofilled; var currVal_210 = nodeValue(_v, 105)._control.focused; var currVal_211 = (nodeValue(_v, 105).color == "accent"); var currVal_212 = (nodeValue(_v, 105).color == "warn"); var currVal_213 = nodeValue(_v, 105)._shouldForward("untouched"); var currVal_214 = nodeValue(_v, 105)._shouldForward("touched"); var currVal_215 = nodeValue(_v, 105)._shouldForward("pristine"); var currVal_216 = nodeValue(_v, 105)._shouldForward("dirty"); var currVal_217 = nodeValue(_v, 105)._shouldForward("valid"); var currVal_218 = nodeValue(_v, 105)._shouldForward("invalid"); var currVal_219 = nodeValue(_v, 105)._shouldForward("pending"); var currVal_220 = !nodeValue(_v, 105)._animationsEnabled; _ck(_v, 104, 1, [currVal_199, currVal_200, currVal_201, currVal_202, currVal_203, currVal_204, currVal_205, currVal_206, currVal_207, currVal_208, currVal_209, currVal_210, currVal_211, currVal_212, currVal_213, currVal_214, currVal_215, currVal_216, currVal_217, currVal_218, currVal_219, currVal_220]); var currVal_221 = nodeValue(_v, 121).ngClassUntouched; var currVal_222 = nodeValue(_v, 121).ngClassTouched; var currVal_223 = nodeValue(_v, 121).ngClassPristine; var currVal_224 = nodeValue(_v, 121).ngClassDirty; var currVal_225 = nodeValue(_v, 121).ngClassValid; var currVal_226 = nodeValue(_v, 121).ngClassInvalid; var currVal_227 = nodeValue(_v, 121).ngClassPending; var currVal_228 = nodeValue(_v, 122).id; var currVal_229 = nodeValue(_v, 122).tabIndex; var currVal_230 = nodeValue(_v, 122)._getAriaLabel(); var currVal_231 = nodeValue(_v, 122)._getAriaLabelledby(); var currVal_232 = nodeValue(_v, 122).required.toString(); var currVal_233 = nodeValue(_v, 122).disabled.toString(); var currVal_234 = nodeValue(_v, 122).errorState; var currVal_235 = (nodeValue(_v, 122).panelOpen ? nodeValue(_v, 122)._optionIds : null); var currVal_236 = nodeValue(_v, 122).multiple; var currVal_237 = (nodeValue(_v, 122)._ariaDescribedby || null); var currVal_238 = nodeValue(_v, 122)._getAriaActiveDescendant(); var currVal_239 = nodeValue(_v, 122).disabled; var currVal_240 = nodeValue(_v, 122).errorState; var currVal_241 = nodeValue(_v, 122).required; var currVal_242 = nodeValue(_v, 122).empty; _ck(_v, 118, 1, [currVal_221, currVal_222, currVal_223, currVal_224, currVal_225, currVal_226, currVal_227, currVal_228, currVal_229, currVal_230, currVal_231, currVal_232, currVal_233, currVal_234, currVal_235, currVal_236, currVal_237, currVal_238, currVal_239, currVal_240, currVal_241, currVal_242]); var currVal_244 = nodeValue(_v, 129)._getTabIndex(); var currVal_245 = nodeValue(_v, 129).selected; var currVal_246 = nodeValue(_v, 129).multiple; var currVal_247 = nodeValue(_v, 129).active; var currVal_248 = nodeValue(_v, 129).id; var currVal_249 = nodeValue(_v, 129)._getAriaSelected(); var currVal_250 = nodeValue(_v, 129).disabled.toString(); var currVal_251 = nodeValue(_v, 129).disabled; _ck(_v, 128, 0, currVal_244, currVal_245, currVal_246, currVal_247, currVal_248, currVal_249, currVal_250, currVal_251); var currVal_253 = nodeValue(_v, 132)._getTabIndex(); var currVal_254 = nodeValue(_v, 132).selected; var currVal_255 = nodeValue(_v, 132).multiple; var currVal_256 = nodeValue(_v, 132).active; var currVal_257 = nodeValue(_v, 132).id; var currVal_258 = nodeValue(_v, 132)._getAriaSelected(); var currVal_259 = nodeValue(_v, 132).disabled.toString(); var currVal_260 = nodeValue(_v, 132).disabled; _ck(_v, 131, 0, currVal_253, currVal_254, currVal_255, currVal_256, currVal_257, currVal_258, currVal_259, currVal_260); var currVal_262 = (nodeValue(_v, 136).appearance == "standard"); var currVal_263 = (nodeValue(_v, 136).appearance == "fill"); var currVal_264 = (nodeValue(_v, 136).appearance == "outline"); var currVal_265 = (nodeValue(_v, 136).appearance == "legacy"); var currVal_266 = nodeValue(_v, 136)._control.errorState; var currVal_267 = nodeValue(_v, 136)._canLabelFloat; var currVal_268 = nodeValue(_v, 136)._shouldLabelFloat(); var currVal_269 = nodeValue(_v, 136)._hasFloatingLabel(); var currVal_270 = nodeValue(_v, 136)._hideControlPlaceholder(); var currVal_271 = nodeValue(_v, 136)._control.disabled; var currVal_272 = nodeValue(_v, 136)._control.autofilled; var currVal_273 = nodeValue(_v, 136)._control.focused; var currVal_274 = (nodeValue(_v, 136).color == "accent"); var currVal_275 = (nodeValue(_v, 136).color == "warn"); var currVal_276 = nodeValue(_v, 136)._shouldForward("untouched"); var currVal_277 = nodeValue(_v, 136)._shouldForward("touched"); var currVal_278 = nodeValue(_v, 136)._shouldForward("pristine"); var currVal_279 = nodeValue(_v, 136)._shouldForward("dirty"); var currVal_280 = nodeValue(_v, 136)._shouldForward("valid"); var currVal_281 = nodeValue(_v, 136)._shouldForward("invalid"); var currVal_282 = nodeValue(_v, 136)._shouldForward("pending"); var currVal_283 = !nodeValue(_v, 136)._animationsEnabled; _ck(_v, 135, 1, [currVal_262, currVal_263, currVal_264, currVal_265, currVal_266, currVal_267, currVal_268, currVal_269, currVal_270, currVal_271, currVal_272, currVal_273, currVal_274, currVal_275, currVal_276, currVal_277, currVal_278, currVal_279, currVal_280, currVal_281, currVal_282, currVal_283]); var currVal_284 = nodeValue(_v, 152).ngClassUntouched; var currVal_285 = nodeValue(_v, 152).ngClassTouched; var currVal_286 = nodeValue(_v, 152).ngClassPristine; var currVal_287 = nodeValue(_v, 152).ngClassDirty; var currVal_288 = nodeValue(_v, 152).ngClassValid; var currVal_289 = nodeValue(_v, 152).ngClassInvalid; var currVal_290 = nodeValue(_v, 152).ngClassPending; var currVal_291 = nodeValue(_v, 153).id; var currVal_292 = nodeValue(_v, 153).tabIndex; var currVal_293 = nodeValue(_v, 153)._getAriaLabel(); var currVal_294 = nodeValue(_v, 153)._getAriaLabelledby(); var currVal_295 = nodeValue(_v, 153).required.toString(); var currVal_296 = nodeValue(_v, 153).disabled.toString(); var currVal_297 = nodeValue(_v, 153).errorState; var currVal_298 = (nodeValue(_v, 153).panelOpen ? nodeValue(_v, 153)._optionIds : null); var currVal_299 = nodeValue(_v, 153).multiple; var currVal_300 = (nodeValue(_v, 153)._ariaDescribedby || null); var currVal_301 = nodeValue(_v, 153)._getAriaActiveDescendant(); var currVal_302 = nodeValue(_v, 153).disabled; var currVal_303 = nodeValue(_v, 153).errorState; var currVal_304 = nodeValue(_v, 153).required; var currVal_305 = nodeValue(_v, 153).empty; _ck(_v, 149, 1, [currVal_284, currVal_285, currVal_286, currVal_287, currVal_288, currVal_289, currVal_290, currVal_291, currVal_292, currVal_293, currVal_294, currVal_295, currVal_296, currVal_297, currVal_298, currVal_299, currVal_300, currVal_301, currVal_302, currVal_303, currVal_304, currVal_305]); var currVal_307 = nodeValue(_v, 160)._getTabIndex(); var currVal_308 = nodeValue(_v, 160).selected; var currVal_309 = nodeValue(_v, 160).multiple; var currVal_310 = nodeValue(_v, 160).active; var currVal_311 = nodeValue(_v, 160).id; var currVal_312 = nodeValue(_v, 160)._getAriaSelected(); var currVal_313 = nodeValue(_v, 160).disabled.toString(); var currVal_314 = nodeValue(_v, 160).disabled; _ck(_v, 159, 0, currVal_307, currVal_308, currVal_309, currVal_310, currVal_311, currVal_312, currVal_313, currVal_314); var currVal_316 = nodeValue(_v, 163)._getTabIndex(); var currVal_317 = nodeValue(_v, 163).selected; var currVal_318 = nodeValue(_v, 163).multiple; var currVal_319 = nodeValue(_v, 163).active; var currVal_320 = nodeValue(_v, 163).id; var currVal_321 = nodeValue(_v, 163)._getAriaSelected(); var currVal_322 = nodeValue(_v, 163).disabled.toString(); var currVal_323 = nodeValue(_v, 163).disabled; _ck(_v, 162, 0, currVal_316, currVal_317, currVal_318, currVal_319, currVal_320, currVal_321, currVal_322, currVal_323); var currVal_325 = !_co.isTpuName; _ck(_v, 165, 0, currVal_325); var currVal_326 = (nodeValue(_v, 168).appearance == "standard"); var currVal_327 = (nodeValue(_v, 168).appearance == "fill"); var currVal_328 = (nodeValue(_v, 168).appearance == "outline"); var currVal_329 = (nodeValue(_v, 168).appearance == "legacy"); var currVal_330 = nodeValue(_v, 168)._control.errorState; var currVal_331 = nodeValue(_v, 168)._canLabelFloat; var currVal_332 = nodeValue(_v, 168)._shouldLabelFloat(); var currVal_333 = nodeValue(_v, 168)._hasFloatingLabel(); var currVal_334 = nodeValue(_v, 168)._hideControlPlaceholder(); var currVal_335 = nodeValue(_v, 168)._control.disabled; var currVal_336 = nodeValue(_v, 168)._control.autofilled; var currVal_337 = nodeValue(_v, 168)._control.focused; var currVal_338 = (nodeValue(_v, 168).color == "accent"); var currVal_339 = (nodeValue(_v, 168).color == "warn"); var currVal_340 = nodeValue(_v, 168)._shouldForward("untouched"); var currVal_341 = nodeValue(_v, 168)._shouldForward("touched"); var currVal_342 = nodeValue(_v, 168)._shouldForward("pristine"); var currVal_343 = nodeValue(_v, 168)._shouldForward("dirty"); var currVal_344 = nodeValue(_v, 168)._shouldForward("valid"); var currVal_345 = nodeValue(_v, 168)._shouldForward("invalid"); var currVal_346 = nodeValue(_v, 168)._shouldForward("pending"); var currVal_347 = !nodeValue(_v, 168)._animationsEnabled; _ck(_v, 167, 1, [currVal_326, currVal_327, currVal_328, currVal_329, currVal_330, currVal_331, currVal_332, currVal_333, currVal_334, currVal_335, currVal_336, currVal_337, currVal_338, currVal_339, currVal_340, currVal_341, currVal_342, currVal_343, currVal_344, currVal_345, currVal_346, currVal_347]); var currVal_348 = nodeValue(_v, 186).ngClassUntouched; var currVal_349 = nodeValue(_v, 186).ngClassTouched; var currVal_350 = nodeValue(_v, 186).ngClassPristine; var currVal_351 = nodeValue(_v, 186).ngClassDirty; var currVal_352 = nodeValue(_v, 186).ngClassValid; var currVal_353 = nodeValue(_v, 186).ngClassInvalid; var currVal_354 = nodeValue(_v, 186).ngClassPending; var currVal_355 = nodeValue(_v, 187)._isServer; var currVal_356 = nodeValue(_v, 187).id; var currVal_357 = nodeValue(_v, 187).placeholder; var currVal_358 = nodeValue(_v, 187).disabled; var currVal_359 = nodeValue(_v, 187).required; var currVal_360 = ((nodeValue(_v, 187).readonly && !nodeValue(_v, 187)._isNativeSelect) || null); var currVal_361 = (nodeValue(_v, 187)._ariaDescribedby || null); var currVal_362 = nodeValue(_v, 187).errorState; var currVal_363 = nodeValue(_v, 187).required.toString(); _ck(_v, 181, 1, [currVal_348, currVal_349, currVal_350, currVal_351, currVal_352, currVal_353, currVal_354, currVal_355, currVal_356, currVal_357, currVal_358, currVal_359, currVal_360, currVal_361, currVal_362, currVal_363]); var currVal_366 = nodeValue(_v, 191).expanded; var currVal_367 = (nodeValue(_v, 191)._animationMode === "NoopAnimations"); var currVal_368 = nodeValue(_v, 191)._hasSpacing(); _ck(_v, 190, 0, currVal_366, currVal_367, currVal_368); var currVal_369 = nodeValue(_v, 195).panel._headerId; var currVal_370 = (nodeValue(_v, 195).disabled ? (0 - 1) : 0); var currVal_371 = nodeValue(_v, 195)._getPanelId(); var currVal_372 = nodeValue(_v, 195)._isExpanded(); var currVal_373 = nodeValue(_v, 195).panel.disabled; var currVal_374 = nodeValue(_v, 195)._isExpanded(); var currVal_375 = (nodeValue(_v, 195)._getTogglePosition() === "after"); var currVal_376 = (nodeValue(_v, 195)._getTogglePosition() === "before"); var currVal_377 = nodeValue(_v, 195)._animationsDisabled; var currVal_378 = _ck(_v, 197, 0, nodeValue(_v, 195)._getExpandedState(), _ck(_v, 196, 0, nodeValue(_v, 195).collapsedHeight, nodeValue(_v, 195).expandedHeight)); _ck(_v, 194, 0, currVal_369, currVal_370, currVal_371, currVal_372, currVal_373, currVal_374, currVal_375, currVal_376, currVal_377, currVal_378); var currVal_379 = (nodeValue(_v, 203).appearance == "standard"); var currVal_380 = (nodeValue(_v, 203).appearance == "fill"); var currVal_381 = (nodeValue(_v, 203).appearance == "outline"); var currVal_382 = (nodeValue(_v, 203).appearance == "legacy"); var currVal_383 = nodeValue(_v, 203)._control.errorState; var currVal_384 = nodeValue(_v, 203)._canLabelFloat; var currVal_385 = nodeValue(_v, 203)._shouldLabelFloat(); var currVal_386 = nodeValue(_v, 203)._hasFloatingLabel(); var currVal_387 = nodeValue(_v, 203)._hideControlPlaceholder(); var currVal_388 = nodeValue(_v, 203)._control.disabled; var currVal_389 = nodeValue(_v, 203)._control.autofilled; var currVal_390 = nodeValue(_v, 203)._control.focused; var currVal_391 = (nodeValue(_v, 203).color == "accent"); var currVal_392 = (nodeValue(_v, 203).color == "warn"); var currVal_393 = nodeValue(_v, 203)._shouldForward("untouched"); var currVal_394 = nodeValue(_v, 203)._shouldForward("touched"); var currVal_395 = nodeValue(_v, 203)._shouldForward("pristine"); var currVal_396 = nodeValue(_v, 203)._shouldForward("dirty"); var currVal_397 = nodeValue(_v, 203)._shouldForward("valid"); var currVal_398 = nodeValue(_v, 203)._shouldForward("invalid"); var currVal_399 = nodeValue(_v, 203)._shouldForward("pending"); var currVal_400 = !nodeValue(_v, 203)._animationsEnabled; _ck(_v, 202, 1, [currVal_379, currVal_380, currVal_381, currVal_382, currVal_383, currVal_384, currVal_385, currVal_386, currVal_387, currVal_388, currVal_389, currVal_390, currVal_391, currVal_392, currVal_393, currVal_394, currVal_395, currVal_396, currVal_397, currVal_398, currVal_399, currVal_400]); var currVal_401 = nodeValue(_v, 219).ngClassUntouched; var currVal_402 = nodeValue(_v, 219).ngClassTouched; var currVal_403 = nodeValue(_v, 219).ngClassPristine; var currVal_404 = nodeValue(_v, 219).ngClassDirty; var currVal_405 = nodeValue(_v, 219).ngClassValid; var currVal_406 = nodeValue(_v, 219).ngClassInvalid; var currVal_407 = nodeValue(_v, 219).ngClassPending; var currVal_408 = nodeValue(_v, 220)._isServer; var currVal_409 = nodeValue(_v, 220).id; var currVal_410 = nodeValue(_v, 220).placeholder; var currVal_411 = nodeValue(_v, 220).disabled; var currVal_412 = nodeValue(_v, 220).required; var currVal_413 = ((nodeValue(_v, 220).readonly && !nodeValue(_v, 220)._isNativeSelect) || null); var currVal_414 = (nodeValue(_v, 220)._ariaDescribedby || null); var currVal_415 = nodeValue(_v, 220).errorState; var currVal_416 = nodeValue(_v, 220).required.toString(); _ck(_v, 213, 1, [currVal_401, currVal_402, currVal_403, currVal_404, currVal_405, currVal_406, currVal_407, currVal_408, currVal_409, currVal_410, currVal_411, currVal_412, currVal_413, currVal_414, currVal_415, currVal_416]); var currVal_420 = (nodeValue(_v, 224).appearance == "standard"); var currVal_421 = (nodeValue(_v, 224).appearance == "fill"); var currVal_422 = (nodeValue(_v, 224).appearance == "outline"); var currVal_423 = (nodeValue(_v, 224).appearance == "legacy"); var currVal_424 = nodeValue(_v, 224)._control.errorState; var currVal_425 = nodeValue(_v, 224)._canLabelFloat; var currVal_426 = nodeValue(_v, 224)._shouldLabelFloat(); var currVal_427 = nodeValue(_v, 224)._hasFloatingLabel(); var currVal_428 = nodeValue(_v, 224)._hideControlPlaceholder(); var currVal_429 = nodeValue(_v, 224)._control.disabled; var currVal_430 = nodeValue(_v, 224)._control.autofilled; var currVal_431 = nodeValue(_v, 224)._control.focused; var currVal_432 = (nodeValue(_v, 224).color == "accent"); var currVal_433 = (nodeValue(_v, 224).color == "warn"); var currVal_434 = nodeValue(_v, 224)._shouldForward("untouched"); var currVal_435 = nodeValue(_v, 224)._shouldForward("touched"); var currVal_436 = nodeValue(_v, 224)._shouldForward("pristine"); var currVal_437 = nodeValue(_v, 224)._shouldForward("dirty"); var currVal_438 = nodeValue(_v, 224)._shouldForward("valid"); var currVal_439 = nodeValue(_v, 224)._shouldForward("invalid"); var currVal_440 = nodeValue(_v, 224)._shouldForward("pending"); var currVal_441 = !nodeValue(_v, 224)._animationsEnabled; _ck(_v, 223, 1, [currVal_420, currVal_421, currVal_422, currVal_423, currVal_424, currVal_425, currVal_426, currVal_427, currVal_428, currVal_429, currVal_430, currVal_431, currVal_432, currVal_433, currVal_434, currVal_435, currVal_436, currVal_437, currVal_438, currVal_439, currVal_440, currVal_441]); var currVal_442 = nodeValue(_v, 240).ngClassUntouched; var currVal_443 = nodeValue(_v, 240).ngClassTouched; var currVal_444 = nodeValue(_v, 240).ngClassPristine; var currVal_445 = nodeValue(_v, 240).ngClassDirty; var currVal_446 = nodeValue(_v, 240).ngClassValid; var currVal_447 = nodeValue(_v, 240).ngClassInvalid; var currVal_448 = nodeValue(_v, 240).ngClassPending; var currVal_449 = nodeValue(_v, 241)._isServer; var currVal_450 = nodeValue(_v, 241).id; var currVal_451 = nodeValue(_v, 241).placeholder; var currVal_452 = nodeValue(_v, 241).disabled; var currVal_453 = nodeValue(_v, 241).required; var currVal_454 = ((nodeValue(_v, 241).readonly && !nodeValue(_v, 241)._isNativeSelect) || null); var currVal_455 = (nodeValue(_v, 241)._ariaDescribedby || null); var currVal_456 = nodeValue(_v, 241).errorState; var currVal_457 = nodeValue(_v, 241).required.toString(); _ck(_v, 234, 1, [currVal_442, currVal_443, currVal_444, currVal_445, currVal_446, currVal_447, currVal_448, currVal_449, currVal_450, currVal_451, currVal_452, currVal_453, currVal_454, currVal_455, currVal_456, currVal_457]); var currVal_461 = (nodeValue(_v, 246).disabled || null); var currVal_462 = (nodeValue(_v, 246)._animationMode === "NoopAnimations"); _ck(_v, 245, 0, currVal_461, currVal_462); var currVal_464 = unwrapValue(_v, 247, 0, _ck(_v, 248, 0, nodeValue(_v, 0), _co.captureButtonLabel)); _ck(_v, 247, 0, currVal_464); var currVal_465 = (nodeValue(_v, 250).disabled || null); var currVal_466 = (nodeValue(_v, 250)._animationMode === "NoopAnimations"); _ck(_v, 249, 0, currVal_465, currVal_466); var currVal_467 = unwrapValue(_v, 251, 0, _ck(_v, 252, 0, nodeValue(_v, 0), _co.closeButtonLabel)); _ck(_v, 251, 0, currVal_467); });
    }
    function View_CaptureProfileDialog_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "capture-profile-dialog", [], null, null, null, View_CaptureProfileDialog_0, RenderType_CaptureProfileDialog)), directiveDef(1, 49152, null, 0, CaptureProfileDialog, [MatDialogRef], null, null)], null, null); }
    var CaptureProfileDialogNgFactory = createComponentFactory("capture-profile-dialog", CaptureProfileDialog, View_CaptureProfileDialog_Host_0, {}, {}, []);
    var RouterModuleNgFactory = createNgModuleFactory(RouterModule, [], function (_l) {
        return moduleDef([
            moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [
                [
                    8,
                    [ɵangular_packages_router_router_lNgFactory]
                ],
                [
                    3,
                    ComponentFactoryResolver
                ],
                NgModuleRef
            ]),
            moduleProvideDef(1073742336, RouterModule, RouterModule, [
                [
                    2,
                    ROUTER_FORROOT_GUARD
                ],
                [
                    2,
                    Router
                ]
            ])
        ]);
    });
    var styles_ɵangular_packages_router_router_l = [];
    var RenderType_ɵangular_packages_router_router_l = createRendererType2({
        encapsulation: 2,
        styles: styles_ɵangular_packages_router_router_l,
        data: {}
    });
    function View_ɵangular_packages_router_router_l_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 16777216, null, null, 1, 'router-outlet', [], null, null, null, null, null)),
            directiveDef(1, 212992, null, 0, RouterOutlet, [
                ChildrenOutletContexts,
                ViewContainerRef,
                ComponentFactoryResolver,
                [
                    8,
                    null
                ],
                ChangeDetectorRef
            ], null, null)
        ], function (_ck, _v) {
            _ck(_v, 1, 0);
        }, null);
    }
    function View_ɵangular_packages_router_router_l_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'ng-component', [], null, null, null, View_ɵangular_packages_router_router_l_0, RenderType_ɵangular_packages_router_router_l)),
            directiveDef(1, 49152, null, 0, ɵEmptyOutletComponent, [], null, null)
        ], null, null);
    }
    var ɵangular_packages_router_router_lNgFactory = createComponentFactory('ng-component', ɵEmptyOutletComponent, View_ɵangular_packages_router_router_l_Host_0, {}, {}, []);
    var f$3 = ɵangular_packages_router_router_lNgFactory;
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$1 = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}[_nghost-%COMP%]{display:block}.container[_ngcontent-%COMP%]{max-width:540px;margin:80px auto 0 auto}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$2 = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}mat-spinner[_ngcontent-%COMP%]{position:absolute;top:calc(50% - 10px);left:calc(50% - 10px)}.mat-raised-button[_ngcontent-%COMP%]{box-shadow:none;border:1px solid #000}"];
    var MatProgressSpinnerModuleNgFactory = createNgModuleFactory(MatProgressSpinnerModule, [], function (_l) {
        return moduleDef([
            moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [
                [
                    8,
                    []
                ],
                [
                    3,
                    ComponentFactoryResolver
                ],
                NgModuleRef
            ]),
            moduleProvideDef(4608, NgLocalization, NgLocaleLocalization, [
                LOCALE_ID$1,
                [
                    2,
                    DEPRECATED_PLURAL_FN
                ]
            ]),
            moduleProvideDef(1073742336, BidiModule, BidiModule, []),
            moduleProvideDef(1073742336, MatCommonModule, MatCommonModule, [
                [
                    2,
                    MATERIAL_SANITY_CHECKS
                ],
                [
                    2,
                    HAMMER_LOADER
                ]
            ]),
            moduleProvideDef(1073742336, CommonModule, CommonModule, []),
            moduleProvideDef(1073742336, MatProgressSpinnerModule, MatProgressSpinnerModule, [])
        ]);
    });
    var styles_MatProgressSpinner = ['.mat-progress-spinner{display:block;position:relative}.mat-progress-spinner svg{position:absolute;transform:rotate(-90deg);top:0;left:0;transform-origin:center;overflow:visible}.mat-progress-spinner circle{fill:transparent;transform-origin:center;transition:stroke-dashoffset 225ms linear}._mat-animation-noopable.mat-progress-spinner circle{transition:none;animation:none}.mat-progress-spinner.mat-progress-spinner-indeterminate-animation[mode=indeterminate]{animation:mat-progress-spinner-linear-rotate 2s linear infinite}._mat-animation-noopable.mat-progress-spinner.mat-progress-spinner-indeterminate-animation[mode=indeterminate]{transition:none;animation:none}.mat-progress-spinner.mat-progress-spinner-indeterminate-animation[mode=indeterminate] circle{transition-property:stroke;animation-duration:4s;animation-timing-function:cubic-bezier(.35,0,.25,1);animation-iteration-count:infinite}._mat-animation-noopable.mat-progress-spinner.mat-progress-spinner-indeterminate-animation[mode=indeterminate] circle{transition:none;animation:none}.mat-progress-spinner.mat-progress-spinner-indeterminate-fallback-animation[mode=indeterminate]{animation:mat-progress-spinner-stroke-rotate-fallback 10s cubic-bezier(.87,.03,.33,1) infinite}._mat-animation-noopable.mat-progress-spinner.mat-progress-spinner-indeterminate-fallback-animation[mode=indeterminate]{transition:none;animation:none}.mat-progress-spinner.mat-progress-spinner-indeterminate-fallback-animation[mode=indeterminate] circle{transition-property:stroke}._mat-animation-noopable.mat-progress-spinner.mat-progress-spinner-indeterminate-fallback-animation[mode=indeterminate] circle{transition:none;animation:none}@keyframes mat-progress-spinner-linear-rotate{0%{transform:rotate(0)}100%{transform:rotate(360deg)}}@keyframes mat-progress-spinner-stroke-rotate-100{0%{stroke-dashoffset:268.60617px;transform:rotate(0)}12.5%{stroke-dashoffset:56.54867px;transform:rotate(0)}12.5001%{stroke-dashoffset:56.54867px;transform:rotateX(180deg) rotate(72.5deg)}25%{stroke-dashoffset:268.60617px;transform:rotateX(180deg) rotate(72.5deg)}25.0001%{stroke-dashoffset:268.60617px;transform:rotate(270deg)}37.5%{stroke-dashoffset:56.54867px;transform:rotate(270deg)}37.5001%{stroke-dashoffset:56.54867px;transform:rotateX(180deg) rotate(161.5deg)}50%{stroke-dashoffset:268.60617px;transform:rotateX(180deg) rotate(161.5deg)}50.0001%{stroke-dashoffset:268.60617px;transform:rotate(180deg)}62.5%{stroke-dashoffset:56.54867px;transform:rotate(180deg)}62.5001%{stroke-dashoffset:56.54867px;transform:rotateX(180deg) rotate(251.5deg)}75%{stroke-dashoffset:268.60617px;transform:rotateX(180deg) rotate(251.5deg)}75.0001%{stroke-dashoffset:268.60617px;transform:rotate(90deg)}87.5%{stroke-dashoffset:56.54867px;transform:rotate(90deg)}87.5001%{stroke-dashoffset:56.54867px;transform:rotateX(180deg) rotate(341.5deg)}100%{stroke-dashoffset:268.60617px;transform:rotateX(180deg) rotate(341.5deg)}}@keyframes mat-progress-spinner-stroke-rotate-fallback{0%{transform:rotate(0)}25%{transform:rotate(1170deg)}50%{transform:rotate(2340deg)}75%{transform:rotate(3510deg)}100%{transform:rotate(4680deg)}}'];
    var RenderType_MatProgressSpinner = createRendererType2({
        encapsulation: 2,
        styles: styles_MatProgressSpinner,
        data: {}
    });
    function View_MatProgressSpinner_1(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 0, ':svg:circle', [
                [
                    'cx',
                    '50%'
                ],
                [
                    'cy',
                    '50%'
                ]
            ], [
                [
                    1,
                    'r',
                    0
                ],
                [
                    4,
                    'animation-name',
                    null
                ],
                [
                    4,
                    'stroke-dashoffset',
                    'px'
                ],
                [
                    4,
                    'stroke-dasharray',
                    'px'
                ],
                [
                    4,
                    'stroke-width',
                    '%'
                ]
            ], null, null, null, null))], null, function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co._circleRadius;
            var currVal_1 = 'mat-progress-spinner-stroke-rotate-' + _co.diameter;
            var currVal_2 = _co._strokeDashOffset;
            var currVal_3 = _co._strokeCircumference;
            var currVal_4 = _co._circleStrokeWidth;
            _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2, currVal_3, currVal_4);
        });
    }
    function View_MatProgressSpinner_2(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 0, ':svg:circle', [
                [
                    'cx',
                    '50%'
                ],
                [
                    'cy',
                    '50%'
                ]
            ], [
                [
                    1,
                    'r',
                    0
                ],
                [
                    4,
                    'stroke-dashoffset',
                    'px'
                ],
                [
                    4,
                    'stroke-dasharray',
                    'px'
                ],
                [
                    4,
                    'stroke-width',
                    '%'
                ]
            ], null, null, null, null))], null, function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co._circleRadius;
            var currVal_1 = _co._strokeDashOffset;
            var currVal_2 = _co._strokeCircumference;
            var currVal_3 = _co._circleStrokeWidth;
            _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2, currVal_3);
        });
    }
    function View_MatProgressSpinner_0(_l) {
        return viewDef(2, [
            (_l()(), elementDef(0, 0, null, null, 5, ':svg:svg', [
                [
                    'focusable',
                    'false'
                ],
                [
                    'preserveAspectRatio',
                    'xMidYMid meet'
                ]
            ], [
                [
                    4,
                    'width',
                    'px'
                ],
                [
                    4,
                    'height',
                    'px'
                ],
                [
                    1,
                    'viewBox',
                    0
                ]
            ], null, null, null, null)),
            directiveDef(1, 16384, null, 0, NgSwitch, [], {
                ngSwitch: [
                    0,
                    'ngSwitch'
                ]
            }, null),
            (_l()(), anchorDef(16777216, null, null, 1, null, View_MatProgressSpinner_1)),
            directiveDef(3, 278528, null, 0, NgSwitchCase, [
                ViewContainerRef,
                TemplateRef,
                NgSwitch
            ], {
                ngSwitchCase: [
                    0,
                    'ngSwitchCase'
                ]
            }, null),
            (_l()(), anchorDef(16777216, null, null, 1, null, View_MatProgressSpinner_2)),
            directiveDef(5, 278528, null, 0, NgSwitchCase, [
                ViewContainerRef,
                TemplateRef,
                NgSwitch
            ], {
                ngSwitchCase: [
                    0,
                    'ngSwitchCase'
                ]
            }, null)
        ], function (_ck, _v) {
            var _co = _v.component;
            var currVal_3 = _co.mode === 'indeterminate';
            _ck(_v, 1, 0, currVal_3);
            var currVal_4 = true;
            _ck(_v, 3, 0, currVal_4);
            var currVal_5 = false;
            _ck(_v, 5, 0, currVal_5);
        }, function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co.diameter;
            var currVal_1 = _co.diameter;
            var currVal_2 = _co._viewBox;
            _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2);
        });
    }
    function View_MatProgressSpinner_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'mat-progress-spinner', [
                [
                    'class',
                    'mat-progress-spinner'
                ],
                [
                    'role',
                    'progressbar'
                ]
            ], [
                [
                    2,
                    '_mat-animation-noopable',
                    null
                ],
                [
                    4,
                    'width',
                    'px'
                ],
                [
                    4,
                    'height',
                    'px'
                ],
                [
                    1,
                    'aria-valuemin',
                    0
                ],
                [
                    1,
                    'aria-valuemax',
                    0
                ],
                [
                    1,
                    'aria-valuenow',
                    0
                ],
                [
                    1,
                    'mode',
                    0
                ]
            ], null, null, View_MatProgressSpinner_0, RenderType_MatProgressSpinner)),
            directiveDef(1, 114688, null, 0, MatProgressSpinner, [
                ElementRef,
                Platform,
                [
                    2,
                    DOCUMENT
                ],
                [
                    2,
                    ANIMATION_MODULE_TYPE
                ],
                MAT_PROGRESS_SPINNER_DEFAULT_OPTIONS
            ], null, null)
        ], function (_ck, _v) {
            _ck(_v, 1, 0);
        }, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 1)._noopAnimations;
            var currVal_1 = nodeValue(_v, 1).diameter;
            var currVal_2 = nodeValue(_v, 1).diameter;
            var currVal_3 = nodeValue(_v, 1).mode === 'determinate' ? 0 : null;
            var currVal_4 = nodeValue(_v, 1).mode === 'determinate' ? 100 : null;
            var currVal_5 = nodeValue(_v, 1).mode === 'determinate' ? nodeValue(_v, 1).value : null;
            var currVal_6 = nodeValue(_v, 1).mode;
            _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5, currVal_6);
        });
    }
    var MatProgressSpinnerNgFactory = createComponentFactory('mat-progress-spinner', MatProgressSpinner, View_MatProgressSpinner_Host_0, {
        color: 'color',
        diameter: 'diameter',
        strokeWidth: 'strokeWidth',
        mode: 'mode',
        value: 'value'
    }, {}, []);
    var styles_MatSpinner = ['.mat-progress-spinner{display:block;position:relative}.mat-progress-spinner svg{position:absolute;transform:rotate(-90deg);top:0;left:0;transform-origin:center;overflow:visible}.mat-progress-spinner circle{fill:transparent;transform-origin:center;transition:stroke-dashoffset 225ms linear}._mat-animation-noopable.mat-progress-spinner circle{transition:none;animation:none}.mat-progress-spinner.mat-progress-spinner-indeterminate-animation[mode=indeterminate]{animation:mat-progress-spinner-linear-rotate 2s linear infinite}._mat-animation-noopable.mat-progress-spinner.mat-progress-spinner-indeterminate-animation[mode=indeterminate]{transition:none;animation:none}.mat-progress-spinner.mat-progress-spinner-indeterminate-animation[mode=indeterminate] circle{transition-property:stroke;animation-duration:4s;animation-timing-function:cubic-bezier(.35,0,.25,1);animation-iteration-count:infinite}._mat-animation-noopable.mat-progress-spinner.mat-progress-spinner-indeterminate-animation[mode=indeterminate] circle{transition:none;animation:none}.mat-progress-spinner.mat-progress-spinner-indeterminate-fallback-animation[mode=indeterminate]{animation:mat-progress-spinner-stroke-rotate-fallback 10s cubic-bezier(.87,.03,.33,1) infinite}._mat-animation-noopable.mat-progress-spinner.mat-progress-spinner-indeterminate-fallback-animation[mode=indeterminate]{transition:none;animation:none}.mat-progress-spinner.mat-progress-spinner-indeterminate-fallback-animation[mode=indeterminate] circle{transition-property:stroke}._mat-animation-noopable.mat-progress-spinner.mat-progress-spinner-indeterminate-fallback-animation[mode=indeterminate] circle{transition:none;animation:none}@keyframes mat-progress-spinner-linear-rotate{0%{transform:rotate(0)}100%{transform:rotate(360deg)}}@keyframes mat-progress-spinner-stroke-rotate-100{0%{stroke-dashoffset:268.60617px;transform:rotate(0)}12.5%{stroke-dashoffset:56.54867px;transform:rotate(0)}12.5001%{stroke-dashoffset:56.54867px;transform:rotateX(180deg) rotate(72.5deg)}25%{stroke-dashoffset:268.60617px;transform:rotateX(180deg) rotate(72.5deg)}25.0001%{stroke-dashoffset:268.60617px;transform:rotate(270deg)}37.5%{stroke-dashoffset:56.54867px;transform:rotate(270deg)}37.5001%{stroke-dashoffset:56.54867px;transform:rotateX(180deg) rotate(161.5deg)}50%{stroke-dashoffset:268.60617px;transform:rotateX(180deg) rotate(161.5deg)}50.0001%{stroke-dashoffset:268.60617px;transform:rotate(180deg)}62.5%{stroke-dashoffset:56.54867px;transform:rotate(180deg)}62.5001%{stroke-dashoffset:56.54867px;transform:rotateX(180deg) rotate(251.5deg)}75%{stroke-dashoffset:268.60617px;transform:rotateX(180deg) rotate(251.5deg)}75.0001%{stroke-dashoffset:268.60617px;transform:rotate(90deg)}87.5%{stroke-dashoffset:56.54867px;transform:rotate(90deg)}87.5001%{stroke-dashoffset:56.54867px;transform:rotateX(180deg) rotate(341.5deg)}100%{stroke-dashoffset:268.60617px;transform:rotateX(180deg) rotate(341.5deg)}}@keyframes mat-progress-spinner-stroke-rotate-fallback{0%{transform:rotate(0)}25%{transform:rotate(1170deg)}50%{transform:rotate(2340deg)}75%{transform:rotate(3510deg)}100%{transform:rotate(4680deg)}}'];
    var RenderType_MatSpinner = createRendererType2({
        encapsulation: 2,
        styles: styles_MatSpinner,
        data: {}
    });
    function View_MatSpinner_1(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 0, ':svg:circle', [
                [
                    'cx',
                    '50%'
                ],
                [
                    'cy',
                    '50%'
                ]
            ], [
                [
                    1,
                    'r',
                    0
                ],
                [
                    4,
                    'animation-name',
                    null
                ],
                [
                    4,
                    'stroke-dashoffset',
                    'px'
                ],
                [
                    4,
                    'stroke-dasharray',
                    'px'
                ],
                [
                    4,
                    'stroke-width',
                    '%'
                ]
            ], null, null, null, null))], null, function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co._circleRadius;
            var currVal_1 = 'mat-progress-spinner-stroke-rotate-' + _co.diameter;
            var currVal_2 = _co._strokeDashOffset;
            var currVal_3 = _co._strokeCircumference;
            var currVal_4 = _co._circleStrokeWidth;
            _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2, currVal_3, currVal_4);
        });
    }
    function View_MatSpinner_2(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 0, ':svg:circle', [
                [
                    'cx',
                    '50%'
                ],
                [
                    'cy',
                    '50%'
                ]
            ], [
                [
                    1,
                    'r',
                    0
                ],
                [
                    4,
                    'stroke-dashoffset',
                    'px'
                ],
                [
                    4,
                    'stroke-dasharray',
                    'px'
                ],
                [
                    4,
                    'stroke-width',
                    '%'
                ]
            ], null, null, null, null))], null, function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co._circleRadius;
            var currVal_1 = _co._strokeDashOffset;
            var currVal_2 = _co._strokeCircumference;
            var currVal_3 = _co._circleStrokeWidth;
            _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2, currVal_3);
        });
    }
    function View_MatSpinner_0(_l) {
        return viewDef(2, [
            (_l()(), elementDef(0, 0, null, null, 5, ':svg:svg', [
                [
                    'focusable',
                    'false'
                ],
                [
                    'preserveAspectRatio',
                    'xMidYMid meet'
                ]
            ], [
                [
                    4,
                    'width',
                    'px'
                ],
                [
                    4,
                    'height',
                    'px'
                ],
                [
                    1,
                    'viewBox',
                    0
                ]
            ], null, null, null, null)),
            directiveDef(1, 16384, null, 0, NgSwitch, [], {
                ngSwitch: [
                    0,
                    'ngSwitch'
                ]
            }, null),
            (_l()(), anchorDef(16777216, null, null, 1, null, View_MatSpinner_1)),
            directiveDef(3, 278528, null, 0, NgSwitchCase, [
                ViewContainerRef,
                TemplateRef,
                NgSwitch
            ], {
                ngSwitchCase: [
                    0,
                    'ngSwitchCase'
                ]
            }, null),
            (_l()(), anchorDef(16777216, null, null, 1, null, View_MatSpinner_2)),
            directiveDef(5, 278528, null, 0, NgSwitchCase, [
                ViewContainerRef,
                TemplateRef,
                NgSwitch
            ], {
                ngSwitchCase: [
                    0,
                    'ngSwitchCase'
                ]
            }, null)
        ], function (_ck, _v) {
            var _co = _v.component;
            var currVal_3 = _co.mode === 'indeterminate';
            _ck(_v, 1, 0, currVal_3);
            var currVal_4 = true;
            _ck(_v, 3, 0, currVal_4);
            var currVal_5 = false;
            _ck(_v, 5, 0, currVal_5);
        }, function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co.diameter;
            var currVal_1 = _co.diameter;
            var currVal_2 = _co._viewBox;
            _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2);
        });
    }
    function View_MatSpinner_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'mat-spinner', [
                [
                    'class',
                    'mat-spinner mat-progress-spinner'
                ],
                [
                    'mode',
                    'indeterminate'
                ],
                [
                    'role',
                    'progressbar'
                ]
            ], [
                [
                    2,
                    '_mat-animation-noopable',
                    null
                ],
                [
                    4,
                    'width',
                    'px'
                ],
                [
                    4,
                    'height',
                    'px'
                ]
            ], null, null, View_MatSpinner_0, RenderType_MatSpinner)),
            directiveDef(1, 114688, null, 0, MatSpinner, [
                ElementRef,
                Platform,
                [
                    2,
                    DOCUMENT
                ],
                [
                    2,
                    ANIMATION_MODULE_TYPE
                ],
                MAT_PROGRESS_SPINNER_DEFAULT_OPTIONS
            ], null, null)
        ], function (_ck, _v) {
            _ck(_v, 1, 0);
        }, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 1)._noopAnimations;
            var currVal_1 = nodeValue(_v, 1).diameter;
            var currVal_2 = nodeValue(_v, 1).diameter;
            _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2);
        });
    }
    var MatSpinnerNgFactory = createComponentFactory('mat-spinner', MatSpinner, View_MatSpinner_Host_0, {
        color: 'color',
        diameter: 'diameter',
        strokeWidth: 'strokeWidth',
        mode: 'mode',
        value: 'value'
    }, {}, []);
    var g$1 = RenderType_MatSpinner;
    var h$1 = View_MatSpinner_0;
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_CaptureProfile = [styles$2];
    var RenderType_CaptureProfile = createRendererType2({ encapsulation: 0, styles: styles_CaptureProfile, data: {} });
    function View_CaptureProfile_0(_l) {
        return viewDef(0, [pipeDef(0, UpperCasePipe, []), (_l()(), elementDef(1, 0, null, null, 8, "div", [], null, null, null, null, null)), (_l()(), elementDef(2, 0, null, null, 7, "button", [["mat-raised-button", ""]], [[1, "disabled", 0], [2, "_mat-animation-noopable", null]], [[null, "click"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("click" === en)) {
                    var pd_0 = (_co.openDialog() !== false);
                    ad = (pd_0 && ad);
                }
                return ad;
            }, d, c)), directiveDef(3, 180224, null, 0, MatButton, [ElementRef, FocusMonitor, [2, ANIMATION_MODULE_TYPE]], { disabled: [0, "disabled"] }, null), pipeDef(131072, AsyncPipe, [ChangeDetectorRef]), (_l()(), textDef(5, 0, [" ", " "])), purePipeDef(6, 1), (_l()(), elementDef(7, 0, null, 0, 2, "mat-spinner", [["class", "mat-spinner mat-progress-spinner"], ["diameter", "20"], ["mode", "indeterminate"], ["role", "progressbar"]], [[4, "visibility", null], [2, "_mat-animation-noopable", null], [4, "width", "px"], [4, "height", "px"]], null, null, h$1, g$1)), directiveDef(8, 114688, null, 0, MatSpinner, [ElementRef, Platform, [2, DOCUMENT], [2, ANIMATION_MODULE_TYPE], MAT_PROGRESS_SPINNER_DEFAULT_OPTIONS], { diameter: [0, "diameter"] }, null), pipeDef(131072, AsyncPipe, [ChangeDetectorRef])], function (_ck, _v) { var _co = _v.component; var currVal_2 = unwrapValue(_v, 3, 0, nodeValue(_v, 4).transform(_co.capturingProfile)); _ck(_v, 3, 0, currVal_2); var currVal_8 = "20"; _ck(_v, 8, 0, currVal_8); }, function (_ck, _v) { var _co = _v.component; var currVal_0 = (nodeValue(_v, 3).disabled || null); var currVal_1 = (nodeValue(_v, 3)._animationMode === "NoopAnimations"); _ck(_v, 2, 0, currVal_0, currVal_1); var currVal_3 = unwrapValue(_v, 5, 0, _ck(_v, 6, 0, nodeValue(_v, 0), _co.captureButtonLabel)); _ck(_v, 5, 0, currVal_3); var currVal_4 = (unwrapValue(_v, 7, 0, nodeValue(_v, 9).transform(_co.capturingProfile)) ? "visible" : "hidden"); var currVal_5 = nodeValue(_v, 8)._noopAnimations; var currVal_6 = nodeValue(_v, 8).diameter; var currVal_7 = nodeValue(_v, 8).diameter; _ck(_v, 7, 0, currVal_4, currVal_5, currVal_6, currVal_7); });
    }
    function View_CaptureProfile_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "capture-profile", [], null, null, null, View_CaptureProfile_0, RenderType_CaptureProfile)), directiveDef(1, 180224, null, 0, CaptureProfile, [MatDialog, MatSnackBar, DataService, Store], null, null)], null, null); }
    var CaptureProfileNgFactory = createComponentFactory("capture-profile", CaptureProfile, View_CaptureProfile_Host_0, {}, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_EmptyPage = [styles$1];
    var RenderType_EmptyPage = createRendererType2({ encapsulation: 0, styles: styles_EmptyPage, data: {} });
    function View_EmptyPage_1(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 7, "div", [["class", "container"]], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 1, "h3", [], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Profiling isn't supported in Colab yet."])), (_l()(), elementDef(3, 0, null, null, 4, "p", [], null, null, null, null, null)), (_l()(), textDef(-1, null, [" Please see "])), (_l()(), elementDef(5, 0, null, null, 1, "a", [["href", "https://github.com/tensorflow/tensorboard/issues/1913"], ["rel", "noopener"], ["target", "_blank"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["GitHub issue #1913"])), (_l()(), textDef(-1, null, [" for more information. "]))], null, null); }
    function View_EmptyPage_2(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 22, "div", [["class", "container"]], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 1, "h3", [], null, null, null, null, null)), (_l()(), textDef(-1, null, ["No profile data was found."])), (_l()(), elementDef(3, 0, null, null, 2, "div", [["class", "horizontal-center"]], null, null, null, null, null)), (_l()(), elementDef(4, 0, null, null, 1, "capture-profile", [], null, null, null, View_CaptureProfile_0, RenderType_CaptureProfile)), directiveDef(5, 180224, null, 0, CaptureProfile, [MatDialog, MatSnackBar, DataService, Store], null, null), (_l()(), elementDef(6, 0, null, null, 1, "p", [], null, null, null, null, null)), (_l()(), textDef(-1, null, [" If you have a model running on CPU, GPU, or Google Cloud TPU, you may be able to use the above button to capture a profile. "])), (_l()(), elementDef(8, 0, null, null, 4, "p", [], null, null, null, null, null)), (_l()(), textDef(-1, null, [" If you're a CPU or GPU user, please use the IP address option. You may want to check out the "])), (_l()(), elementDef(10, 0, null, null, 1, "a", [["href", "https://colab.research.google.com/github/tensorflow/tensorboard/blob/master/docs/tensorboard_profiling_keras.ipynb"], ["rel", "noopener"], ["target", "_blank"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["tutorial"])), (_l()(), textDef(-1, null, [" on how to start a TensorFlow profiler server and profile a Keras model on a GPU. "])), (_l()(), elementDef(13, 0, null, null, 4, "p", [], null, null, null, null, null)), (_l()(), textDef(-1, null, [" If you're a TPU user, please use the TPU name option and you may want to check out the "])), (_l()(), elementDef(15, 0, null, null, 1, "a", [["href", "https://cloud.google.com/tpu/docs/cloud-tpu-tools"], ["rel", "noopener"], ["target", "_blank"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["tutorial"])), (_l()(), textDef(-1, null, [" on how to interpreting the profiling results. "])), (_l()(), elementDef(18, 0, null, null, 4, "p", [], null, null, null, null, null)), (_l()(), textDef(-1, null, [" If you think profiling is done properly, please see the page of "])), (_l()(), elementDef(20, 0, null, null, 1, "a", [["href", "https://cloud.google.com/tpu/docs/troubleshooting"], ["rel", "noopener"], ["target", "_blank"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Google Cloud TPU Troubleshooting and FAQ"])), (_l()(), textDef(-1, null, [" and consider filing an issue on GitHub. "]))], null, null); }
    function View_EmptyPage_0(_l) { return viewDef(0, [(_l()(), anchorDef(16777216, null, null, 1, null, View_EmptyPage_1)), directiveDef(1, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"], ngIfElse: [1, "ngIfElse"] }, null), (_l()(), anchorDef(0, [["no_profile_data", 2]], null, 0, null, View_EmptyPage_2))], function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.inColab; var currVal_1 = nodeValue(_v, 2); _ck(_v, 1, 0, currVal_0, currVal_1); }, null); }
    function View_EmptyPage_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "empty-page", [], null, null, null, View_EmptyPage_0, RenderType_EmptyPage)), directiveDef(1, 49152, null, 0, EmptyPage, [], null, null)], null, null); }
    var EmptyPageNgFactory = createComponentFactory("empty-page", EmptyPage, View_EmptyPage_Host_0, {}, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$3 = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}[_nghost-%COMP%]{display:block}.container[_ngcontent-%COMP%]{display:flex;flex-wrap:wrap;width:100%}.left-column[_ngcontent-%COMP%]{display:flex;flex-direction:column;width:33.333%}.right-column[_ngcontent-%COMP%]{display:flex;flex-direction:column;width:66.667%}.full-column[_ngcontent-%COMP%]{border-right:1px solid #eee;width:100%}@media screen and (max-width: 860px){[_nghost-%COMP%]{width:fit-content}}@media screen and (max-width: 1140px){.left-column[_ngcontent-%COMP%], .right-column[_ngcontent-%COMP%]{width:100%}}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$4 = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}.callout[_ngcontent-%COMP%]{padding:0;border-left:none !important;border-radius:4px}.callout[_ngcontent-%COMP%]   header[_ngcontent-%COMP%]{color:#fff;line-height:24px;font-weight:500;padding:8px 16px;margin:0;text-transform:uppercase;border-radius:4px 4px 0 0}.callout[_ngcontent-%COMP%]   p[_ngcontent-%COMP%]{padding:16px;margin:0;font-size:14px}.callout[_ngcontent-%COMP%] > [_ngcontent-%COMP%]:not(:first-child){padding:12px 24px}.callout.is-critical[_ngcontent-%COMP%]{border-color:#dd0031;background:rgba(221,0,49,.05)}.callout.is-critical[_ngcontent-%COMP%]   header[_ngcontent-%COMP%]{background:#dd0031}.callout.is-important[_ngcontent-%COMP%]{border-color:#ff9800;background:rgba(255,152,0,.05)}.callout.is-important[_ngcontent-%COMP%]   header[_ngcontent-%COMP%]{background:#ffa000}.callout.is-helpful[_ngcontent-%COMP%]{border-color:#1976d2;background:rgba(25,118,210,.05)}.callout.is-helpful[_ngcontent-%COMP%]   header[_ngcontent-%COMP%]{background:#1976d2}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_DiagnosticsView = [styles$4];
    var RenderType_DiagnosticsView = createRendererType2({ encapsulation: 0, styles: styles_DiagnosticsView, data: {} });
    function View_DiagnosticsView_2(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "li", [], null, null, null, null, null)), (_l()(), textDef(1, null, [" ", " "]))], null, function (_ck, _v) { var currVal_0 = _v.context.$implicit; _ck(_v, 1, 0, currVal_0); }); }
    function View_DiagnosticsView_1(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 4, "div", [["class", "callout is-critical"]], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 1, "header", [], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Errors"])), (_l()(), anchorDef(16777216, null, null, 1, null, View_DiagnosticsView_2)), directiveDef(4, 278528, null, 0, NgForOf, [ViewContainerRef, TemplateRef, IterableDiffers], { ngForOf: [0, "ngForOf"] }, null)], function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.diagnostics.errors; _ck(_v, 4, 0, currVal_0); }, null); }
    function View_DiagnosticsView_4(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "li", [], null, null, null, null, null)), (_l()(), textDef(1, null, [" ", " "]))], null, function (_ck, _v) { var currVal_0 = _v.context.$implicit; _ck(_v, 1, 0, currVal_0); }); }
    function View_DiagnosticsView_3(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 4, "div", [["class", "callout is-important"]], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 1, "header", [], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Warnings"])), (_l()(), anchorDef(16777216, null, null, 1, null, View_DiagnosticsView_4)), directiveDef(4, 278528, null, 0, NgForOf, [ViewContainerRef, TemplateRef, IterableDiffers], { ngForOf: [0, "ngForOf"] }, null)], function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.diagnostics.warnings; _ck(_v, 4, 0, currVal_0); }, null); }
    function View_DiagnosticsView_6(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "li", [], null, null, null, null, null)), (_l()(), textDef(1, null, [" ", " "]))], null, function (_ck, _v) { var currVal_0 = _v.context.$implicit; _ck(_v, 1, 0, currVal_0); }); }
    function View_DiagnosticsView_5(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 4, "div", [["class", "callout is-helpful"]], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 1, "header", [], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Info"])), (_l()(), anchorDef(16777216, null, null, 1, null, View_DiagnosticsView_6)), directiveDef(4, 278528, null, 0, NgForOf, [ViewContainerRef, TemplateRef, IterableDiffers], { ngForOf: [0, "ngForOf"] }, null)], function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.diagnostics.info; _ck(_v, 4, 0, currVal_0); }, null); }
    function View_DiagnosticsView_0(_l) { return viewDef(0, [(_l()(), anchorDef(16777216, null, null, 1, null, View_DiagnosticsView_1)), directiveDef(1, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"] }, null), (_l()(), anchorDef(16777216, null, null, 1, null, View_DiagnosticsView_3)), directiveDef(3, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"] }, null), (_l()(), anchorDef(16777216, null, null, 1, null, View_DiagnosticsView_5)), directiveDef(5, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"] }, null)], function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.diagnostics.errors.length; _ck(_v, 1, 0, currVal_0); var currVal_1 = _co.diagnostics.warnings.length; _ck(_v, 3, 0, currVal_1); var currVal_2 = _co.diagnostics.info.length; _ck(_v, 5, 0, currVal_2); }, null); }
    function View_DiagnosticsView_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "diagnostics-view", [], null, null, null, View_DiagnosticsView_0, RenderType_DiagnosticsView)), directiveDef(1, 49152, null, 0, DiagnosticsView, [], null, null)], null, null); }
    var DiagnosticsViewNgFactory = createComponentFactory("diagnostics-view", DiagnosticsView, View_DiagnosticsView_Host_0, { diagnostics: "diagnostics" }, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$5 = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}[_nghost-%COMP%]{border-bottom:1px solid #eee;border-right:1px solid #eee}[_nghost-%COMP%]:not(.dark-theme)   mat-card[_ngcontent-%COMP%]{box-shadow:none !important;margin:8px}@media screen and (max-width: 1140px){[_nghost-%COMP%]:not(.dark-theme)   mat-card[_ngcontent-%COMP%]{min-width:500px}}mat-card[_ngcontent-%COMP%]{height:calc(100% - 48px)}mat-card-title[_ngcontent-%COMP%]{background-color:#fff;border-top-left-radius:4px;border-top-right-radius:4px;color:#000;font-size:24px;font-weight:400}b[_ngcontent-%COMP%]{font-weight:500}ul[_ngcontent-%COMP%]{list-style-position:outside;margin-top:-16px;padding-inline-start:20px}table[_ngcontent-%COMP%]{width:100%}table[_ngcontent-%COMP%]   ul[_ngcontent-%COMP%]{margin:0}.item-container[_ngcontent-%COMP%]{margin-bottom:16px}.item-container[_ngcontent-%COMP%] > table[_ngcontent-%COMP%]{border-spacing:0}.item-container[_ngcontent-%COMP%] > td[_ngcontent-%COMP%]{padding:0}.item-value[_ngcontent-%COMP%]{padding-left:8px;min-width:80px;width:20%;font-size:18px;font-weight:500}.item-description[_ngcontent-%COMP%]{margin-left:20px}.flops-utilization-tooltip-target[_ngcontent-%COMP%]{color:#e8710a;border-bottom:1px dotted #e8710a;cursor:pointer}.tooltip-icon-container[_ngcontent-%COMP%]{position:relative}.tooltip-icon[_ngcontent-%COMP%]{color:#e8710a;position:absolute;top:-2px;left:4px;font-size:20px;width:20px;height:20px;cursor:pointer}.dark-theme[_nghost-%COMP%]{flex-grow:1;border:none}.dark-theme[_nghost-%COMP%]   mat-card[_ngcontent-%COMP%]{margin:8px}@media screen and (max-width: 1140px){.dark-theme[_nghost-%COMP%]   mat-card[_ngcontent-%COMP%]{min-width:500px}}.dark-theme[_nghost-%COMP%]   mat-card-title[_ngcontent-%COMP%]{background-color:#3f51b5;color:#fff;padding:16px;margin:-16px -16px 16px}"];
    var MatIconModuleNgFactory = createNgModuleFactory(MatIconModule, [], function (_l) {
        return moduleDef([
            moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [
                [
                    8,
                    []
                ],
                [
                    3,
                    ComponentFactoryResolver
                ],
                NgModuleRef
            ]),
            moduleProvideDef(1073742336, BidiModule, BidiModule, []),
            moduleProvideDef(1073742336, MatCommonModule, MatCommonModule, [
                [
                    2,
                    MATERIAL_SANITY_CHECKS
                ],
                [
                    2,
                    HAMMER_LOADER
                ]
            ]),
            moduleProvideDef(1073742336, MatIconModule, MatIconModule, [])
        ]);
    });
    var styles_MatIcon = ['.mat-icon{background-repeat:no-repeat;display:inline-block;fill:currentColor;height:24px;width:24px}.mat-icon.mat-icon-inline{font-size:inherit;height:inherit;line-height:inherit;width:inherit}[dir=rtl] .mat-icon-rtl-mirror{transform:scale(-1,1)}.mat-form-field:not(.mat-form-field-appearance-legacy) .mat-form-field-prefix .mat-icon,.mat-form-field:not(.mat-form-field-appearance-legacy) .mat-form-field-suffix .mat-icon{display:block}.mat-form-field:not(.mat-form-field-appearance-legacy) .mat-form-field-prefix .mat-icon-button .mat-icon,.mat-form-field:not(.mat-form-field-appearance-legacy) .mat-form-field-suffix .mat-icon-button .mat-icon{margin:auto}'];
    var RenderType_MatIcon = createRendererType2({
        encapsulation: 2,
        styles: styles_MatIcon,
        data: {}
    });
    function View_MatIcon_0(_l) {
        return viewDef(2, [ngContentDef(null, 0)], null, null);
    }
    function View_MatIcon_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'mat-icon', [
                [
                    'class',
                    'mat-icon notranslate'
                ],
                [
                    'role',
                    'img'
                ]
            ], [
                [
                    2,
                    'mat-icon-inline',
                    null
                ],
                [
                    2,
                    'mat-icon-no-color',
                    null
                ]
            ], null, null, View_MatIcon_0, RenderType_MatIcon)),
            directiveDef(1, 9158656, null, 0, MatIcon, [
                ElementRef,
                MatIconRegistry,
                [
                    8,
                    null
                ],
                [
                    2,
                    MAT_ICON_LOCATION
                ],
                [
                    2,
                    ErrorHandler
                ]
            ], null, null)
        ], function (_ck, _v) {
            _ck(_v, 1, 0);
        }, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 1).inline;
            var currVal_1 = nodeValue(_v, 1).color !== 'primary' && nodeValue(_v, 1).color !== 'accent' && nodeValue(_v, 1).color !== 'warn';
            _ck(_v, 0, 0, currVal_0, currVal_1);
        });
    }
    var MatIconNgFactory = createComponentFactory('mat-icon', MatIcon, View_MatIcon_Host_0, {
        color: 'color',
        inline: 'inline',
        svgIcon: 'svgIcon',
        fontSet: 'fontSet',
        fontIcon: 'fontIcon'
    }, {}, ['*']);
    var c$5 = RenderType_MatIcon;
    var d$5 = View_MatIcon_0;
    var MatCardModuleNgFactory = createNgModuleFactory(MatCardModule, [], function (_l) {
        return moduleDef([
            moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [
                [
                    8,
                    []
                ],
                [
                    3,
                    ComponentFactoryResolver
                ],
                NgModuleRef
            ]),
            moduleProvideDef(1073742336, BidiModule, BidiModule, []),
            moduleProvideDef(1073742336, MatCommonModule, MatCommonModule, [
                [
                    2,
                    MATERIAL_SANITY_CHECKS
                ],
                [
                    2,
                    HAMMER_LOADER
                ]
            ]),
            moduleProvideDef(1073742336, MatCardModule, MatCardModule, [])
        ]);
    });
    var styles_MatCard = ['.mat-card{transition:box-shadow 280ms cubic-bezier(.4,0,.2,1);display:block;position:relative;padding:16px;border-radius:4px}._mat-animation-noopable.mat-card{transition:none;animation:none}.mat-card .mat-divider-horizontal{position:absolute;left:0;width:100%}[dir=rtl] .mat-card .mat-divider-horizontal{left:auto;right:0}.mat-card .mat-divider-horizontal.mat-divider-inset{position:static;margin:0}[dir=rtl] .mat-card .mat-divider-horizontal.mat-divider-inset{margin-right:0}@media (-ms-high-contrast:active){.mat-card{outline:solid 1px}}.mat-card-actions,.mat-card-content,.mat-card-subtitle{display:block;margin-bottom:16px}.mat-card-title{display:block;margin-bottom:8px}.mat-card-actions{margin-left:-8px;margin-right:-8px;padding:8px 0}.mat-card-actions-align-end{display:flex;justify-content:flex-end}.mat-card-image{width:calc(100% + 32px);margin:0 -16px 16px -16px}.mat-card-footer{display:block;margin:0 -16px -16px -16px}.mat-card-actions .mat-button,.mat-card-actions .mat-raised-button,.mat-card-actions .mat-stroked-button{margin:0 8px}.mat-card-header{display:flex;flex-direction:row}.mat-card-header .mat-card-title{margin-bottom:12px}.mat-card-header-text{margin:0 16px}.mat-card-avatar{height:40px;width:40px;border-radius:50%;flex-shrink:0;object-fit:cover}.mat-card-title-group{display:flex;justify-content:space-between}.mat-card-sm-image{width:80px;height:80px}.mat-card-md-image{width:112px;height:112px}.mat-card-lg-image{width:152px;height:152px}.mat-card-xl-image{width:240px;height:240px;margin:-8px}.mat-card-title-group>.mat-card-xl-image{margin:-8px 0 8px}@media (max-width:599px){.mat-card-title-group{margin:0}.mat-card-xl-image{margin-left:0;margin-right:0}}.mat-card-content>:first-child,.mat-card>:first-child{margin-top:0}.mat-card-content>:last-child:not(.mat-card-footer),.mat-card>:last-child:not(.mat-card-footer){margin-bottom:0}.mat-card-image:first-child{margin-top:-16px;border-top-left-radius:inherit;border-top-right-radius:inherit}.mat-card>.mat-card-actions:last-child{margin-bottom:-8px;padding-bottom:0}.mat-card-actions .mat-button:first-child,.mat-card-actions .mat-raised-button:first-child,.mat-card-actions .mat-stroked-button:first-child{margin-left:0;margin-right:0}.mat-card-subtitle:not(:first-child),.mat-card-title:not(:first-child){margin-top:-4px}.mat-card-header .mat-card-subtitle:not(:first-child){margin-top:-8px}.mat-card>.mat-card-xl-image:first-child{margin-top:-8px}.mat-card>.mat-card-xl-image:last-child{margin-bottom:-8px}'];
    var RenderType_MatCard = createRendererType2({
        encapsulation: 2,
        styles: styles_MatCard,
        data: {}
    });
    function View_MatCard_0(_l) {
        return viewDef(2, [
            ngContentDef(null, 0),
            ngContentDef(null, 1)
        ], null, null);
    }
    function View_MatCard_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'mat-card', [[
                    'class',
                    'mat-card'
                ]], [[
                    2,
                    '_mat-animation-noopable',
                    null
                ]], null, null, View_MatCard_0, RenderType_MatCard)),
            directiveDef(1, 49152, null, 0, MatCard, [[
                    2,
                    ANIMATION_MODULE_TYPE
                ]], null, null)
        ], null, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 1)._animationMode === 'NoopAnimations';
            _ck(_v, 0, 0, currVal_0);
        });
    }
    var MatCardNgFactory = createComponentFactory('mat-card', MatCard, View_MatCard_Host_0, {}, {}, [
        '*',
        'mat-card-footer'
    ]);
    var styles_MatCardHeader = [];
    var RenderType_MatCardHeader = createRendererType2({
        encapsulation: 2,
        styles: styles_MatCardHeader,
        data: {}
    });
    function View_MatCardHeader_0(_l) {
        return viewDef(2, [
            ngContentDef(null, 0),
            (_l()(), elementDef(1, 0, null, null, 1, 'div', [[
                    'class',
                    'mat-card-header-text'
                ]], null, null, null, null, null)),
            ngContentDef(null, 1),
            ngContentDef(null, 2)
        ], null, null);
    }
    function View_MatCardHeader_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'mat-card-header', [[
                    'class',
                    'mat-card-header'
                ]], null, null, null, View_MatCardHeader_0, RenderType_MatCardHeader)),
            directiveDef(1, 49152, null, 0, MatCardHeader, [], null, null)
        ], null, null);
    }
    var MatCardHeaderNgFactory = createComponentFactory('mat-card-header', MatCardHeader, View_MatCardHeader_Host_0, {}, {}, [
        '[mat-card-avatar], [matCardAvatar]',
        'mat-card-title, mat-card-subtitle,\n      [mat-card-title], [mat-card-subtitle],\n      [matCardTitle], [matCardSubtitle]',
        '*'
    ]);
    var styles_MatCardTitleGroup = [];
    var RenderType_MatCardTitleGroup = createRendererType2({
        encapsulation: 2,
        styles: styles_MatCardTitleGroup,
        data: {}
    });
    function View_MatCardTitleGroup_0(_l) {
        return viewDef(2, [
            (_l()(), elementDef(0, 0, null, null, 1, 'div', [], null, null, null, null, null)),
            ngContentDef(null, 0),
            ngContentDef(null, 1),
            ngContentDef(null, 2)
        ], null, null);
    }
    function View_MatCardTitleGroup_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'mat-card-title-group', [[
                    'class',
                    'mat-card-title-group'
                ]], null, null, null, View_MatCardTitleGroup_0, RenderType_MatCardTitleGroup)),
            directiveDef(1, 49152, null, 0, MatCardTitleGroup, [], null, null)
        ], null, null);
    }
    var MatCardTitleGroupNgFactory = createComponentFactory('mat-card-title-group', MatCardTitleGroup, View_MatCardTitleGroup_Host_0, {}, {}, [
        'mat-card-title, mat-card-subtitle,\n      [mat-card-title], [mat-card-subtitle],\n      [matCardTitle], [matCardSubtitle]',
        'img',
        '*'
    ]);
    var c$6 = RenderType_MatCard;
    var d$6 = View_MatCard_0;
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_PerformanceSummary = [styles$5];
    var RenderType_PerformanceSummary = createRendererType2({ encapsulation: 0, styles: styles_PerformanceSummary, data: {} });
    function View_PerformanceSummary_2(_l) { return viewDef(0, [(_l()(), anchorDef(0, null, null, 0))], null, null); }
    function View_PerformanceSummary_1(_l) { return viewDef(0, [(_l()(), anchorDef(0, null, null, 0, null, View_PerformanceSummary_2))], null, null); }
    function View_PerformanceSummary_4(_l) { return viewDef(0, [(_l()(), anchorDef(0, null, null, 0))], null, null); }
    function View_PerformanceSummary_3(_l) { return viewDef(0, [(_l()(), anchorDef(0, null, null, 0, null, View_PerformanceSummary_4))], null, null); }
    function View_PerformanceSummary_9(_l) { return viewDef(0, [(_l()(), anchorDef(0, null, null, 0))], null, null); }
    function View_PerformanceSummary_8(_l) { return viewDef(0, [(_l()(), anchorDef(0, null, null, 0, null, View_PerformanceSummary_9))], null, null); }
    function View_PerformanceSummary_7(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 3, "div", [], null, null, null, null, null)), (_l()(), anchorDef(16777216, null, null, 2, null, View_PerformanceSummary_8)), directiveDef(2, 540672, null, 0, NgTemplateOutlet, [ViewContainerRef], { ngTemplateOutletContext: [0, "ngTemplateOutletContext"], ngTemplateOutlet: [1, "ngTemplateOutlet"] }, null), pureObjectDef(3, { $implicit: 0 })], function (_ck, _v) { var currVal_0 = _ck(_v, 3, 0, _v.parent.context.$implicit); var currVal_1 = nodeValue(_v.parent.parent.parent, 37); _ck(_v, 2, 0, currVal_0, currVal_1); }, null); }
    function View_PerformanceSummary_12(_l) { return viewDef(0, [(_l()(), anchorDef(0, null, null, 0))], null, null); }
    function View_PerformanceSummary_11(_l) { return viewDef(0, [(_l()(), anchorDef(0, null, null, 0, null, View_PerformanceSummary_12))], null, null); }
    function View_PerformanceSummary_10(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 4, "ul", [], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 3, "li", [], null, null, null, null, null)), (_l()(), anchorDef(16777216, null, null, 2, null, View_PerformanceSummary_11)), directiveDef(3, 540672, null, 0, NgTemplateOutlet, [ViewContainerRef], { ngTemplateOutletContext: [0, "ngTemplateOutletContext"], ngTemplateOutlet: [1, "ngTemplateOutlet"] }, null), pureObjectDef(4, { $implicit: 0 })], function (_ck, _v) { var currVal_0 = _ck(_v, 4, 0, _v.parent.context.$implicit); var currVal_1 = nodeValue(_v.parent.parent.parent, 37); _ck(_v, 3, 0, currVal_0, currVal_1); }, null); }
    function View_PerformanceSummary_13(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 4, "div", [], null, null, null, null, null)), providerDef(512, null, NgClassImpl, NgClassR2Impl, [IterableDiffers, KeyValueDiffers, ElementRef, Renderer2]), directiveDef(2, 278528, null, 0, NgClass, [NgClassImpl], { ngClass: [0, "ngClass"] }, null), pureObjectDef(3, { "item-description": 0, "description": 1 }), (_l()(), textDef(4, null, [" ", " "]))], function (_ck, _v) { var currVal_0 = _ck(_v, 3, 0, (_v.parent.context.$implicit.type == "list"), true); _ck(_v, 2, 0, currVal_0); }, function (_ck, _v) { var currVal_1 = _v.context.$implicit; _ck(_v, 4, 0, currVal_1); }); }
    function View_PerformanceSummary_14(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 2, "td", [["class", "item-value"]], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 1, "div", [], [[4, "color", null]], null, null, null, null)), (_l()(), textDef(2, null, ["", ""]))], null, function (_ck, _v) { var currVal_0 = _v.parent.context.$implicit.valueColor; _ck(_v, 1, 0, currVal_0); var currVal_1 = _v.parent.context.$implicit.value; _ck(_v, 2, 0, currVal_1); }); }
    function View_PerformanceSummary_16(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "li", [["class", "primary-content"]], null, null, null, null, null)), (_l()(), textDef(1, null, ["", ""]))], null, function (_ck, _v) { var currVal_0 = _v.context.$implicit; _ck(_v, 1, 0, currVal_0); }); }
    function View_PerformanceSummary_15(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 2, "ul", [], null, null, null, null, null)), (_l()(), anchorDef(16777216, null, null, 1, null, View_PerformanceSummary_16)), directiveDef(2, 278528, null, 0, NgForOf, [ViewContainerRef, TemplateRef, IterableDiffers], { ngForOf: [0, "ngForOf"] }, null)], function (_ck, _v) { var currVal_0 = _v.parent.context.$implicit.propertyValues; _ck(_v, 2, 0, currVal_0); }, null); }
    function View_PerformanceSummary_6(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 14, "div", [], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 11, "div", [["class", "item-container"]], null, null, null, null, null)), (_l()(), elementDef(2, 0, null, null, 10, "table", [], null, null, null, null, null)), (_l()(), elementDef(3, 0, null, null, 9, "tr", [], null, null, null, null, null)), (_l()(), elementDef(4, 0, null, null, 6, "td", [], null, null, null, null, null)), (_l()(), anchorDef(16777216, null, null, 1, null, View_PerformanceSummary_7)), directiveDef(6, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"] }, null), (_l()(), anchorDef(16777216, null, null, 1, null, View_PerformanceSummary_10)), directiveDef(8, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"] }, null), (_l()(), anchorDef(16777216, null, null, 1, null, View_PerformanceSummary_13)), directiveDef(10, 278528, null, 0, NgForOf, [ViewContainerRef, TemplateRef, IterableDiffers], { ngForOf: [0, "ngForOf"] }, null), (_l()(), anchorDef(16777216, null, null, 1, null, View_PerformanceSummary_14)), directiveDef(12, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"] }, null), (_l()(), anchorDef(16777216, null, null, 1, null, View_PerformanceSummary_15)), directiveDef(14, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"] }, null)], function (_ck, _v) { var currVal_0 = (_v.context.$implicit.type !== "list"); _ck(_v, 6, 0, currVal_0); var currVal_1 = (_v.context.$implicit.type === "list"); _ck(_v, 8, 0, currVal_1); var currVal_2 = _v.context.$implicit.descriptions; _ck(_v, 10, 0, currVal_2); var currVal_3 = _v.context.$implicit.value; _ck(_v, 12, 0, currVal_3); var currVal_4 = ((_v.context.$implicit.propertyValues == null) ? null : _v.context.$implicit.propertyValues.length); _ck(_v, 14, 0, currVal_4); }, null); }
    function View_PerformanceSummary_5(_l) { return viewDef(0, [(_l()(), anchorDef(16777216, null, null, 1, null, View_PerformanceSummary_6)), directiveDef(1, 278528, null, 0, NgForOf, [ViewContainerRef, TemplateRef, IterableDiffers], { ngForOf: [0, "ngForOf"] }, null), (_l()(), anchorDef(0, null, null, 0))], function (_ck, _v) { var currVal_0 = _v.context.$implicit; _ck(_v, 1, 0, currVal_0); }, null); }
    function View_PerformanceSummary_18(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 4, "span", [["class", "tooltip-icon-container"]], null, null, null, null, null)), (_l()(), elementDef(1, 16777216, null, null, 3, "mat-icon", [["class", "tooltip-icon mat-icon notranslate"], ["matTooltipPosition", "above"], ["role", "img"]], [[2, "mat-icon-inline", null], [2, "mat-icon-no-color", null]], [[null, "longpress"], [null, "keydown"], [null, "touchend"]], function (_v, en, $event) {
                var ad = true;
                if (("longpress" === en)) {
                    var pd_0 = (nodeValue(_v, 3).show() !== false);
                    ad = (pd_0 && ad);
                }
                if (("keydown" === en)) {
                    var pd_1 = (nodeValue(_v, 3)._handleKeydown($event) !== false);
                    ad = (pd_1 && ad);
                }
                if (("touchend" === en)) {
                    var pd_2 = (nodeValue(_v, 3)._handleTouchend() !== false);
                    ad = (pd_2 && ad);
                }
                return ad;
            }, d$5, c$5)), directiveDef(2, 9158656, null, 0, MatIcon, [ElementRef, MatIconRegistry, [8, null], [2, MAT_ICON_LOCATION], [2, ErrorHandler]], null, null), directiveDef(3, 212992, null, 0, MatTooltip, [Overlay, ElementRef, ScrollDispatcher, ViewContainerRef, NgZone, Platform, AriaDescriber, FocusMonitor, MAT_TOOLTIP_SCROLL_STRATEGY, [2, Directionality], [2, MAT_TOOLTIP_DEFAULT_OPTIONS], [2, HAMMER_LOADER]], { position: [0, "position"], message: [1, "message"] }, null), (_l()(), textDef(-1, 0, [" info "]))], function (_ck, _v) { _ck(_v, 2, 0); var currVal_2 = "above"; var currVal_3 = _v.parent.context.$implicit.tooltip; _ck(_v, 3, 0, currVal_2, currVal_3); }, function (_ck, _v) { var currVal_0 = nodeValue(_v, 2).inline; var currVal_1 = (((nodeValue(_v, 2).color !== "primary") && (nodeValue(_v, 2).color !== "accent")) && (nodeValue(_v, 2).color !== "warn")); _ck(_v, 1, 0, currVal_0, currVal_1); });
    }
    function View_PerformanceSummary_17(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "b", [], null, null, null, null, null)), (_l()(), textDef(1, null, ["", ""])), (_l()(), anchorDef(16777216, null, null, 1, null, View_PerformanceSummary_18)), directiveDef(3, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"] }, null), (_l()(), anchorDef(0, null, null, 0))], function (_ck, _v) { var currVal_1 = _v.context.$implicit.tooltip; _ck(_v, 3, 0, currVal_1); }, function (_ck, _v) { var currVal_0 = _v.context.$implicit.title; _ck(_v, 1, 0, currVal_0); }); }
    function View_PerformanceSummary_0(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 35, "mat-card", [["class", "mat-card"]], [[2, "_mat-animation-noopable", null]], null, null, d$6, c$6)), directiveDef(1, 49152, null, 0, MatCard, [[2, ANIMATION_MODULE_TYPE]], null, null), (_l()(), elementDef(2, 0, null, 0, 2, "mat-card-title", [["class", "mat-card-title"]], null, null, null, null, null)), directiveDef(3, 16384, null, 0, MatCardTitle, [], null, null), (_l()(), textDef(4, null, ["", ""])), (_l()(), elementDef(5, 0, null, 0, 30, "mat-card-content", [["class", "mat-card-content"]], null, null, null, null, null)), directiveDef(6, 16384, null, 0, MatCardContent, [], null, null), (_l()(), anchorDef(16777216, null, null, 2, null, View_PerformanceSummary_1)), directiveDef(8, 540672, null, 0, NgTemplateOutlet, [ViewContainerRef], { ngTemplateOutletContext: [0, "ngTemplateOutletContext"], ngTemplateOutlet: [1, "ngTemplateOutlet"] }, null), pureObjectDef(9, { $implicit: 0 }), (_l()(), elementDef(10, 0, null, null, 18, "div", [], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(11, 0, null, null, 11, "div", [["class", "item-container"]], null, null, null, null, null)), (_l()(), elementDef(12, 0, null, null, 10, "table", [], null, null, null, null, null)), (_l()(), elementDef(13, 0, null, null, 9, "tr", [], null, null, null, null, null)), (_l()(), elementDef(14, 0, null, null, 8, "td", [], null, null, null, null, null)), (_l()(), elementDef(15, 0, null, null, 1, "b", [], null, null, null, null, null)), (_l()(), textDef(-1, null, ["FLOPS Utilization"])), (_l()(), elementDef(17, 0, null, null, 5, "div", [["class", "description"]], null, null, null, null, null)), (_l()(), textDef(-1, null, [" (higher is better, "])), (_l()(), elementDef(19, 16777216, null, null, 2, "span", [["class", "flops-utilization-tooltip-target"], ["matTooltipPosition", "above"]], null, [[null, "longpress"], [null, "keydown"], [null, "touchend"]], function (_v, en, $event) {
                var ad = true;
                if (("longpress" === en)) {
                    var pd_0 = (nodeValue(_v, 20).show() !== false);
                    ad = (pd_0 && ad);
                }
                if (("keydown" === en)) {
                    var pd_1 = (nodeValue(_v, 20)._handleKeydown($event) !== false);
                    ad = (pd_1 && ad);
                }
                if (("touchend" === en)) {
                    var pd_2 = (nodeValue(_v, 20)._handleTouchend() !== false);
                    ad = (pd_2 && ad);
                }
                return ad;
            }, null, null)), directiveDef(20, 212992, null, 0, MatTooltip, [Overlay, ElementRef, ScrollDispatcher, ViewContainerRef, NgZone, Platform, AriaDescriber, FocusMonitor, MAT_TOOLTIP_SCROLL_STRATEGY, [2, Directionality], [2, MAT_TOOLTIP_DEFAULT_OPTIONS], [2, HAMMER_LOADER]], { position: [0, "position"], message: [1, "message"] }, null), (_l()(), textDef(-1, null, [" why two numbers? "])), (_l()(), textDef(-1, null, [" ) "])), (_l()(), elementDef(23, 0, null, null, 5, "ul", [], null, null, null, null, null)), (_l()(), elementDef(24, 0, null, null, 1, "li", [["class", "primary-content"]], null, null, null, null, null)), (_l()(), textDef(25, null, ["Utilization of TPU Matrix Units: ", ""])), (_l()(), elementDef(26, 0, null, null, 2, "li", [["class", "primary-content"]], null, null, null, null, null)), (_l()(), textDef(27, null, [" Compared to Program's Optimal FLOPS: ", " "])), ngContentDef(null, 0), (_l()(), anchorDef(16777216, null, null, 2, null, View_PerformanceSummary_3)), directiveDef(30, 540672, null, 0, NgTemplateOutlet, [ViewContainerRef], { ngTemplateOutletContext: [0, "ngTemplateOutletContext"], ngTemplateOutlet: [1, "ngTemplateOutlet"] }, null), pureObjectDef(31, { $implicit: 0 }), (_l()(), elementDef(32, 0, null, null, 2, "div", [["class", "item-container"]], null, null, null, null, null)), (_l()(), elementDef(33, 0, null, null, 1, "b", [], [[4, "color", null]], null, null, null, null)), (_l()(), textDef(34, null, ["", ""])), (_l()(), elementDef(35, 0, null, null, 0, "p", [], null, null, null, null, null)), (_l()(), anchorDef(0, [["summaryInfo", 2]], null, 0, null, View_PerformanceSummary_5)), (_l()(), anchorDef(0, [["titleAndTooltip", 2]], null, 0, null, View_PerformanceSummary_17))], function (_ck, _v) { var _co = _v.component; var currVal_2 = _ck(_v, 9, 0, _co.summaryInfoBefore); var currVal_3 = nodeValue(_v, 36); _ck(_v, 8, 0, currVal_2, currVal_3); var currVal_5 = "above"; var currVal_6 = _co.flopsUtilizationTooltipMessage; _ck(_v, 20, 0, currVal_5, currVal_6); var currVal_9 = _ck(_v, 31, 0, _co.summaryInfoAfter); var currVal_10 = nodeValue(_v, 36); _ck(_v, 30, 0, currVal_9, currVal_10); }, function (_ck, _v) { var _co = _v.component; var currVal_0 = (nodeValue(_v, 1)._animationMode === "NoopAnimations"); _ck(_v, 0, 0, currVal_0); var currVal_1 = _co.title; _ck(_v, 4, 0, currVal_1); var currVal_4 = !_co.isTpu; _ck(_v, 10, 0, currVal_4); var currVal_7 = _co.mxuUtilizationPercent; _ck(_v, 25, 0, currVal_7); var currVal_8 = _co.flopRateUtilizationRelativeToRoofline; _ck(_v, 27, 0, currVal_8); var currVal_11 = _co.remarkColor; _ck(_v, 33, 0, currVal_11); var currVal_12 = _co.remarkText; _ck(_v, 34, 0, currVal_12); });
    }
    function View_PerformanceSummary_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "performance-summary", [], null, null, null, View_PerformanceSummary_0, RenderType_PerformanceSummary)), directiveDef(1, 573440, null, 0, PerformanceSummary, [], null, null)], null, null); }
    var PerformanceSummaryNgFactory = createComponentFactory("performance-summary", PerformanceSummary, View_PerformanceSummary_Host_0, { generalAnalysis: "generalAnalysis", inputPipelineAnalysis: "inputPipelineAnalysis", firstSummaryInfo: "firstSummaryInfo", propertyValues: "propertyValues", averageStepTimeValueColor: "averageStepTimeValueColor" }, {}, ["*"]);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$6 = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}[_nghost-%COMP%]{border-bottom:1px solid #eee;border-right:1px solid #eee;flex-grow:1}[_nghost-%COMP%]:not(.dark-theme)   mat-card[_ngcontent-%COMP%]{box-shadow:none !important;margin:8px}@media screen and (max-width: 1140px){[_nghost-%COMP%]:not(.dark-theme)   mat-card[_ngcontent-%COMP%]{min-width:500px}}mat-card[_ngcontent-%COMP%]{height:calc(100% - 48px)}mat-card-title[_ngcontent-%COMP%]{background-color:#fff;border-top-left-radius:4px;border-top-right-radius:4px;color:#000;font-size:24px;font-weight:400}b[_ngcontent-%COMP%]{font-weight:500}.dark-theme[_nghost-%COMP%]{border:none}.dark-theme[_nghost-%COMP%]   mat-card[_ngcontent-%COMP%]{margin:8px}@media screen and (max-width: 1140px){.dark-theme[_nghost-%COMP%]   mat-card[_ngcontent-%COMP%]{min-width:500px}}.dark-theme[_nghost-%COMP%]   mat-card-title[_ngcontent-%COMP%]{background-color:#3f51b5;color:#fff;padding:16px;margin:-16px -16px 16px}.dark-theme[_nghost-%COMP%]   .key-label[_ngcontent-%COMP%]{font-weight:500}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_RunEnvironmentView = [styles$6];
    var RenderType_RunEnvironmentView = createRendererType2({ encapsulation: 0, styles: styles_RunEnvironmentView, data: {} });
    function View_RunEnvironmentView_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 28, "mat-card", [["class", "mat-card"]], [[2, "_mat-animation-noopable", null]], null, null, d$6, c$6)), directiveDef(1, 49152, null, 0, MatCard, [[2, ANIMATION_MODULE_TYPE]], null, null), (_l()(), elementDef(2, 0, null, 0, 2, "mat-card-title", [["class", "mat-card-title"]], null, null, null, null, null)), directiveDef(3, 16384, null, 0, MatCardTitle, [], null, null), (_l()(), textDef(4, null, ["", ""])), (_l()(), elementDef(5, 0, null, 0, 23, "mat-card-content", [["class", "primary-content mat-card-content"]], null, null, null, null, null)), directiveDef(6, 16384, null, 0, MatCardContent, [], null, null), ngContentDef(null, 0), (_l()(), elementDef(8, 0, null, null, 5, "p", [], null, null, null, null, null)), (_l()(), elementDef(9, 0, null, null, 1, "span", [["class", "key-label"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Number of Hosts used"])), (_l()(), textDef(-1, null, [": "])), (_l()(), elementDef(12, 0, null, null, 1, "span", [], null, null, null, null, null)), (_l()(), textDef(13, null, ["", ""])), ngContentDef(null, 1), (_l()(), elementDef(15, 0, null, null, 5, "p", [], null, null, null, null, null)), (_l()(), elementDef(16, 0, null, null, 1, "span", [["class", "key-label"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Device type"])), (_l()(), textDef(-1, null, [": "])), (_l()(), elementDef(19, 0, null, null, 1, "span", [], null, null, null, null, null)), (_l()(), textDef(20, null, ["", ""])), (_l()(), elementDef(21, 0, null, null, 5, "p", [], null, null, null, null, null)), (_l()(), elementDef(22, 0, null, null, 1, "span", [["class", "key-label"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Number of device cores"])), (_l()(), textDef(-1, null, [": "])), (_l()(), elementDef(25, 0, null, null, 1, "span", [], null, null, null, null, null)), (_l()(), textDef(26, null, ["", ""])), ngContentDef(null, 2), (_l()(), elementDef(28, 0, null, null, 0, "p", [], null, null, null, null, null))], null, function (_ck, _v) { var _co = _v.component; var currVal_0 = (nodeValue(_v, 1)._animationMode === "NoopAnimations"); _ck(_v, 0, 0, currVal_0); var currVal_1 = _co.title; _ck(_v, 4, 0, currVal_1); var currVal_2 = _co.hostCount; _ck(_v, 13, 0, currVal_2); var currVal_3 = _co.deviceType; _ck(_v, 20, 0, currVal_3); var currVal_4 = _co.deviceCoreCount; _ck(_v, 26, 0, currVal_4); }); }
    function View_RunEnvironmentView_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "run-environment-view", [], null, null, null, View_RunEnvironmentView_0, RenderType_RunEnvironmentView)), directiveDef(1, 49152, null, 0, RunEnvironmentView, [], null, null)], null, null); }
    var RunEnvironmentViewNgFactory = createComponentFactory("run-environment-view", RunEnvironmentView, View_RunEnvironmentView_Host_0, { runEnvironment: "runEnvironment" }, {}, ["[profileDetail]", "[taskCount]", "[jobInformation]"]);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$7 = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}[_nghost-%COMP%]{border-bottom:1px solid #eee;border-right:1px solid #eee}[_nghost-%COMP%]:not(.dark-theme)   mat-card[_ngcontent-%COMP%]{box-shadow:none !important;margin:8px}@media screen and (max-width: 1140px){[_nghost-%COMP%]:not(.dark-theme)   mat-card[_ngcontent-%COMP%]{min-width:500px}}mat-card[_ngcontent-%COMP%]{height:calc(100% - 48px)}mat-card-title[_ngcontent-%COMP%]{background-color:#fff;border-top-left-radius:4px;border-top-right-radius:4px;color:#000;font-size:24px;font-weight:400}.chart[_ngcontent-%COMP%]{margin:0 auto;max-width:800px}.dark-theme[_nghost-%COMP%]{border:none}.dark-theme[_nghost-%COMP%]   mat-card[_ngcontent-%COMP%]{margin:8px}@media screen and (max-width: 1140px){.dark-theme[_nghost-%COMP%]   mat-card[_ngcontent-%COMP%]{min-width:500px}}.dark-theme[_nghost-%COMP%]   mat-card-title[_ngcontent-%COMP%]{background-color:#3f51b5;color:#fff;padding:16px;margin:-16px -16px 16px}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_StepTimeGraph = [styles$7];
    var RenderType_StepTimeGraph = createRendererType2({ encapsulation: 0, styles: styles_StepTimeGraph, data: {} });
    function View_StepTimeGraph_0(_l) { return viewDef(0, [queryDef(671088640, 1, { chartRef: 0 }), (_l()(), elementDef(1, 0, null, null, 7, "mat-card", [["class", "mat-card"]], [[2, "_mat-animation-noopable", null]], null, null, d$6, c$6)), directiveDef(2, 49152, null, 0, MatCard, [[2, ANIMATION_MODULE_TYPE]], null, null), (_l()(), elementDef(3, 0, null, 0, 2, "mat-card-title", [["class", "mat-card-title"]], null, null, null, null, null)), directiveDef(4, 16384, null, 0, MatCardTitle, [], null, null), (_l()(), textDef(5, null, ["", ""])), (_l()(), elementDef(6, 0, null, 0, 2, "mat-card-content", [["class", "mat-card-content"]], null, null, null, null, null)), directiveDef(7, 16384, null, 0, MatCardContent, [], null, null), (_l()(), elementDef(8, 0, [[1, 0], ["chart", 1]], null, 0, "div", [["class", "chart"]], [[4, "height", null]], null, null, null, null))], null, function (_ck, _v) { var _co = _v.component; var currVal_0 = (nodeValue(_v, 2)._animationMode === "NoopAnimations"); _ck(_v, 1, 0, currVal_0); var currVal_1 = _co.title; _ck(_v, 5, 0, currVal_1); var currVal_2 = (_co.height + "px"); _ck(_v, 8, 0, currVal_2); }); }
    function View_StepTimeGraph_Host_0(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "step-time-graph", [], null, [["window", "resize"]], function (_v, en, $event) {
                var ad = true;
                if (("window:resize" === en)) {
                    var pd_0 = (nodeValue(_v, 1).onResize() !== false);
                    ad = (pd_0 && ad);
                }
                return ad;
            }, View_StepTimeGraph_0, RenderType_StepTimeGraph)), directiveDef(1, 4767744, null, 0, StepTimeGraph, [], null, null)], null, null);
    }
    var StepTimeGraphNgFactory = createComponentFactory("step-time-graph", StepTimeGraph, View_StepTimeGraph_Host_0, { inputPipelineAnalysis: "inputPipelineAnalysis", columnIds: "columnIds", columnColors: "columnColors" }, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$8 = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}[_nghost-%COMP%]{border-bottom:1px solid #eee;border-right:1px solid #eee;flex-grow:1}[_nghost-%COMP%]:not(.dark-theme)   mat-card[_ngcontent-%COMP%]{box-shadow:none !important;margin:8px}@media screen and (max-width: 1140px){[_nghost-%COMP%]:not(.dark-theme)   mat-card[_ngcontent-%COMP%]{min-width:500px}}mat-card[_ngcontent-%COMP%]{height:calc(100% - 48px)}mat-card-title[_ngcontent-%COMP%]{background-color:#fff;border-top-left-radius:4px;border-top-right-radius:4px;color:#000;font-size:24px;font-weight:400}b[_ngcontent-%COMP%]{font-weight:500}ul[_ngcontent-%COMP%]{list-style-position:outside;margin-top:-16px;padding-inline-start:20px}.bottleneck-statement[_ngcontent-%COMP%]{margin:10px 0}.bottleneck-tips[_ngcontent-%COMP%]{margin:16px 0}.documentation-tips[_ngcontent-%COMP%]{margin:16px 0}.dark-theme[_nghost-%COMP%]{border:none}.dark-theme[_nghost-%COMP%]   mat-card[_ngcontent-%COMP%]{margin:8px}@media screen and (max-width: 1140px){.dark-theme[_nghost-%COMP%]   mat-card[_ngcontent-%COMP%]{min-width:500px}}.dark-theme[_nghost-%COMP%]   mat-card-title[_ngcontent-%COMP%]{background-color:#3f51b5;color:#fff;padding:16px;margin:-16px -16px 16px}.dark-theme[_nghost-%COMP%]   .bottleneck-statement[_ngcontent-%COMP%]{font-weight:bolder;font-style:italic}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_RecommendationResultView = [styles$8];
    var RenderType_RecommendationResultView = createRendererType2({ encapsulation: 0, styles: styles_RecommendationResultView, data: {} });
    function View_RecommendationResultView_1(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 0, "li", [["class", "bottleneck-statement"]], [[4, "color", null], [8, "innerHTML", 1]], null, null, null, null))], null, function (_ck, _v) { var currVal_0 = _v.context.$implicit.color; var currVal_1 = _v.context.$implicit.value; _ck(_v, 0, 0, currVal_0, currVal_1); }); }
    function View_RecommendationResultView_4(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 0, "li", [], [[8, "innerHTML", 1]], [[null, "click"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("click" === en)) {
                    var pd_0 = (_co.onTipsClick($event) !== false);
                    ad = (pd_0 && ad);
                }
                return ad;
            }, null, null))], null, function (_ck, _v) { var currVal_0 = _v.context.$implicit; _ck(_v, 0, 0, currVal_0); });
    }
    function View_RecommendationResultView_3(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 2, "ul", [], null, null, null, null, null)), (_l()(), anchorDef(16777216, null, null, 1, null, View_RecommendationResultView_4)), directiveDef(2, 278528, null, 0, NgForOf, [ViewContainerRef, TemplateRef, IterableDiffers], { ngForOf: [0, "ngForOf"] }, null)], function (_ck, _v) { var currVal_0 = _v.parent.context.$implicit.tips; _ck(_v, 2, 0, currVal_0); }, null); }
    function View_RecommendationResultView_6(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 0, "li", [], [[8, "innerHTML", 1]], null, null, null, null))], null, function (_ck, _v) { var currVal_0 = _v.context.$implicit; _ck(_v, 0, 0, currVal_0); }); }
    function View_RecommendationResultView_5(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 2, "ul", [], null, null, null, null, null)), (_l()(), anchorDef(16777216, null, null, 1, null, View_RecommendationResultView_6)), directiveDef(2, 278528, null, 0, NgForOf, [ViewContainerRef, TemplateRef, IterableDiffers], { ngForOf: [0, "ngForOf"] }, null)], function (_ck, _v) { var currVal_0 = _v.parent.context.$implicit.tips; _ck(_v, 2, 0, currVal_0); }, null); }
    function View_RecommendationResultView_2(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 9, "div", [["class", "bottleneck-tips"]], null, null, null, null, null)), providerDef(512, null, NgStyleImpl, NgStyleR2Impl, [ElementRef, KeyValueDiffers, Renderer2]), directiveDef(2, 278528, null, 0, NgStyle, [NgStyleImpl], { ngStyle: [0, "ngStyle"] }, null), (_l()(), elementDef(3, 0, null, null, 2, "p", [], null, null, null, null, null)), (_l()(), elementDef(4, 0, null, null, 1, "b", [], null, null, null, null, null)), (_l()(), textDef(5, null, ["", ""])), (_l()(), anchorDef(16777216, null, null, 1, null, View_RecommendationResultView_3)), directiveDef(7, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"] }, null), (_l()(), anchorDef(16777216, null, null, 1, null, View_RecommendationResultView_5)), directiveDef(9, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"] }, null)], function (_ck, _v) { var currVal_0 = _v.context.$implicit.style; _ck(_v, 2, 0, currVal_0); var currVal_2 = _v.context.$implicit.useClickCallback; _ck(_v, 7, 0, currVal_2); var currVal_3 = !_v.context.$implicit.useClickCallback; _ck(_v, 9, 0, currVal_3); }, function (_ck, _v) { var currVal_1 = _v.context.$implicit.title; _ck(_v, 5, 0, currVal_1); }); }
    function View_RecommendationResultView_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 11, "mat-card", [["class", "mat-card"]], [[2, "_mat-animation-noopable", null]], null, null, d$6, c$6)), directiveDef(1, 49152, null, 0, MatCard, [[2, ANIMATION_MODULE_TYPE]], null, null), (_l()(), elementDef(2, 0, null, 0, 2, "mat-card-title", [["class", "mat-card-title"]], null, null, null, null, null)), directiveDef(3, 16384, null, 0, MatCardTitle, [], null, null), (_l()(), textDef(4, null, ["", ""])), (_l()(), elementDef(5, 0, null, 0, 6, "mat-card-content", [["class", "primary-content mat-card-content"]], null, null, null, null, null)), directiveDef(6, 16384, null, 0, MatCardContent, [], null, null), (_l()(), elementDef(7, 0, null, null, 2, "ul", [], null, null, null, null, null)), (_l()(), anchorDef(16777216, null, null, 1, null, View_RecommendationResultView_1)), directiveDef(9, 278528, null, 0, NgForOf, [ViewContainerRef, TemplateRef, IterableDiffers], { ngForOf: [0, "ngForOf"] }, null), (_l()(), anchorDef(16777216, null, null, 1, null, View_RecommendationResultView_2)), directiveDef(11, 278528, null, 0, NgForOf, [ViewContainerRef, TemplateRef, IterableDiffers], { ngForOf: [0, "ngForOf"] }, null)], function (_ck, _v) { var _co = _v.component; var currVal_2 = _co.statements; _ck(_v, 9, 0, currVal_2); var currVal_3 = _co.tipInfoArray; _ck(_v, 11, 0, currVal_3); }, function (_ck, _v) { var _co = _v.component; var currVal_0 = (nodeValue(_v, 1)._animationMode === "NoopAnimations"); _ck(_v, 0, 0, currVal_0); var currVal_1 = _co.title; _ck(_v, 4, 0, currVal_1); }); }
    function View_RecommendationResultView_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "recommendation-result-view", [], null, null, null, View_RecommendationResultView_0, RenderType_RecommendationResultView)), directiveDef(1, 573440, null, 0, RecommendationResultView, [Store], null, null)], null, null); }
    var RecommendationResultViewNgFactory = createComponentFactory("recommendation-result-view", RecommendationResultView, View_RecommendationResultView_Host_0, { recommendationResult: "recommendationResult" }, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$9 = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}[_nghost-%COMP%]:not(.dark-theme)   mat-expansion-panel[_ngcontent-%COMP%]{box-shadow:none !important;margin:8px;margin:0}@media screen and (max-width: 1140px){[_nghost-%COMP%]:not(.dark-theme)   mat-expansion-panel[_ngcontent-%COMP%]{min-width:500px}}mat-expansion-panel-header[_ngcontent-%COMP%]{margin:8px 8px 0}mat-panel-title[_ngcontent-%COMP%]{background-color:#fff;border-top-left-radius:4px;border-top-right-radius:4px;color:#000;font-size:24px;font-weight:400;background-color:transparent}mat-expansion-panel-header.cdk-keyboard-focused[_ngcontent-%COMP%], mat-expansion-panel[_ngcontent-%COMP%]:not(.mat-expanded)   mat-expansion-panel-header[_ngcontent-%COMP%]:hover{background-color:#eee !important}.mat-expanded[_ngcontent-%COMP%]   mat-expansion-panel-header[_ngcontent-%COMP%]{border-bottom-left-radius:0;border-bottom-right-radius:0}.dark-theme[_nghost-%COMP%]{border:none}.dark-theme[_nghost-%COMP%]   mat-expansion-panel[_ngcontent-%COMP%]{margin:8px}@media screen and (max-width: 1140px){.dark-theme[_nghost-%COMP%]   mat-expansion-panel[_ngcontent-%COMP%]{min-width:500px}}.dark-theme[_nghost-%COMP%]   mat-panel-title[_ngcontent-%COMP%]{background-color:transparent;color:#fff}.dark-theme[_nghost-%COMP%]   mat-expansion-panel-header[_ngcontent-%COMP%]{background-color:#3f51b5;margin:0}.dark-theme[_nghost-%COMP%]   mat-expansion-panel-header.cdk-keyboard-focused[_ngcontent-%COMP%], .dark-theme[_nghost-%COMP%]   mat-expansion-panel[_ngcontent-%COMP%]:not(.mat-expanded)   mat-expansion-panel-header[_ngcontent-%COMP%]:hover{background-color:#7885cb !important}.dark-theme[_nghost-%COMP%]   .table[_ngcontent-%COMP%]{margin-top:18px}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_TopOpsTable = [styles$9];
    var RenderType_TopOpsTable = createRendererType2({ encapsulation: 0, styles: styles_TopOpsTable, data: {} });
    function View_TopOpsTable_0(_l) {
        return viewDef(0, [queryDef(671088640, 1, { tableRef: 0 }), (_l()(), elementDef(1, 0, null, null, 13, "div", [], [[8, "className", 0]], null, null, null, null)), (_l()(), elementDef(2, 16777216, null, null, 12, "mat-expansion-panel", [["class", "mat-expansion-panel"]], [[2, "mat-expanded", null], [2, "_mat-animation-noopable", null], [2, "mat-expansion-panel-spacing", null]], null, null, d$4, c$4)), directiveDef(3, 1753088, null, 1, MatExpansionPanel, [[3, MAT_ACCORDION], ChangeDetectorRef, UniqueSelectionDispatcher, ViewContainerRef, DOCUMENT, [2, ANIMATION_MODULE_TYPE], [2, MAT_EXPANSION_PANEL_DEFAULT_OPTIONS]], { expanded: [0, "expanded"] }, null), queryDef(603979776, 2, { _lazyContent: 0 }), providerDef(256, null, MAT_ACCORDION, undefined, []), (_l()(), elementDef(6, 0, null, 0, 6, "mat-expansion-panel-header", [["class", "mat-expansion-panel-header"], ["role", "button"]], [[1, "id", 0], [1, "tabindex", 0], [1, "aria-controls", 0], [1, "aria-expanded", 0], [1, "aria-disabled", 0], [2, "mat-expanded", null], [2, "mat-expansion-toggle-indicator-after", null], [2, "mat-expansion-toggle-indicator-before", null], [40, "@.disabled", 0], [40, "@expansionHeight", 0]], [[null, "click"], [null, "keydown"], ["component", "@expansionHeight.start"]], function (_v, en, $event) {
                var ad = true;
                if (("click" === en)) {
                    var pd_0 = (nodeValue(_v, 7)._toggle() !== false);
                    ad = (pd_0 && ad);
                }
                if (("keydown" === en)) {
                    var pd_1 = (nodeValue(_v, 7)._keydown($event) !== false);
                    ad = (pd_1 && ad);
                }
                if (("component:@expansionHeight.start" === en)) {
                    var pd_2 = (nodeValue(_v, 7)._animationStarted() !== false);
                    ad = (pd_2 && ad);
                }
                return ad;
            }, h, g)), directiveDef(7, 180224, null, 0, MatExpansionPanelHeader, [MatExpansionPanel, ElementRef, FocusMonitor, ChangeDetectorRef, [2, MAT_EXPANSION_PANEL_DEFAULT_OPTIONS]], null, null), pureObjectDef(8, { collapsedHeight: 0, expandedHeight: 1 }), pureObjectDef(9, { value: 0, params: 1 }), (_l()(), elementDef(10, 0, null, 0, 2, "mat-panel-title", [["class", "mat-expansion-panel-header-title"]], null, null, null, null, null)), directiveDef(11, 16384, null, 0, MatExpansionPanelTitle, [], null, null), (_l()(), textDef(12, null, ["", ""])), (_l()(), elementDef(13, 0, [[1, 0], ["table", 1]], 1, 0, "div", [["class", "table"]], null, null, null, null, null)), (_l()(), elementDef(14, 0, null, 1, 0, "br", [], null, null, null, null, null))], function (_ck, _v) { var _co = _v.component; var currVal_4 = _co.initiallyExpanded; _ck(_v, 3, 0, currVal_4); }, function (_ck, _v) { var _co = _v.component; var currVal_0 = (_co.title ? "auto-height" : "hidden-content"); _ck(_v, 1, 0, currVal_0); var currVal_1 = nodeValue(_v, 3).expanded; var currVal_2 = (nodeValue(_v, 3)._animationMode === "NoopAnimations"); var currVal_3 = nodeValue(_v, 3)._hasSpacing(); _ck(_v, 2, 0, currVal_1, currVal_2, currVal_3); var currVal_5 = nodeValue(_v, 7).panel._headerId; var currVal_6 = (nodeValue(_v, 7).disabled ? (0 - 1) : 0); var currVal_7 = nodeValue(_v, 7)._getPanelId(); var currVal_8 = nodeValue(_v, 7)._isExpanded(); var currVal_9 = nodeValue(_v, 7).panel.disabled; var currVal_10 = nodeValue(_v, 7)._isExpanded(); var currVal_11 = (nodeValue(_v, 7)._getTogglePosition() === "after"); var currVal_12 = (nodeValue(_v, 7)._getTogglePosition() === "before"); var currVal_13 = nodeValue(_v, 7)._animationsDisabled; var currVal_14 = _ck(_v, 9, 0, nodeValue(_v, 7)._getExpandedState(), _ck(_v, 8, 0, nodeValue(_v, 7).collapsedHeight, nodeValue(_v, 7).expandedHeight)); _ck(_v, 6, 0, currVal_5, currVal_6, currVal_7, currVal_8, currVal_9, currVal_10, currVal_11, currVal_12, currVal_13, currVal_14); var currVal_15 = _co.title; _ck(_v, 12, 0, currVal_15); });
    }
    function View_TopOpsTable_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "top-ops-table", [], null, null, null, View_TopOpsTable_0, RenderType_TopOpsTable)), directiveDef(1, 4767744, null, 0, TopOpsTable, [], null, null)], null, null); }
    var TopOpsTableNgFactory = createComponentFactory("top-ops-table", TopOpsTable, View_TopOpsTable_Host_0, { generalAnalysis: "generalAnalysis", inputPipelineAnalysis: "inputPipelineAnalysis", initiallyExpanded: "initiallyExpanded" }, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_Overview = [styles$3];
    var RenderType_Overview = createRendererType2({ encapsulation: 0, styles: styles_Overview, data: {} });
    function View_Overview_0(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 16, "div", [], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 1, "diagnostics-view", [], null, null, null, View_DiagnosticsView_0, RenderType_DiagnosticsView)), directiveDef(2, 49152, null, 0, DiagnosticsView, [], { diagnostics: [0, "diagnostics"] }, null), (_l()(), elementDef(3, 0, null, null, 13, "div", [["class", "container"]], null, null, null, null, null)), (_l()(), elementDef(4, 0, null, null, 4, "div", [["class", "left-column"]], null, null, null, null, null)), (_l()(), elementDef(5, 0, null, null, 1, "performance-summary", [], null, null, null, View_PerformanceSummary_0, RenderType_PerformanceSummary)), directiveDef(6, 573440, null, 0, PerformanceSummary, [], { generalAnalysis: [0, "generalAnalysis"], inputPipelineAnalysis: [1, "inputPipelineAnalysis"], propertyValues: [2, "propertyValues"] }, null), (_l()(), elementDef(7, 0, null, null, 1, "run-environment-view", [], null, null, null, View_RunEnvironmentView_0, RenderType_RunEnvironmentView)), directiveDef(8, 49152, null, 0, RunEnvironmentView, [], { runEnvironment: [0, "runEnvironment"] }, null), (_l()(), elementDef(9, 0, null, null, 4, "div", [["class", "right-column"]], null, null, null, null, null)), (_l()(), elementDef(10, 0, null, null, 1, "step-time-graph", [], null, [["window", "resize"]], function (_v, en, $event) {
                var ad = true;
                if (("window:resize" === en)) {
                    var pd_0 = (nodeValue(_v, 11).onResize() !== false);
                    ad = (pd_0 && ad);
                }
                return ad;
            }, View_StepTimeGraph_0, RenderType_StepTimeGraph)), directiveDef(11, 4767744, null, 0, StepTimeGraph, [], { inputPipelineAnalysis: [0, "inputPipelineAnalysis"] }, null), (_l()(), elementDef(12, 0, null, null, 1, "recommendation-result-view", [], null, null, null, View_RecommendationResultView_0, RenderType_RecommendationResultView)), directiveDef(13, 573440, null, 0, RecommendationResultView, [Store], { recommendationResult: [0, "recommendationResult"] }, null), (_l()(), elementDef(14, 0, null, null, 2, "div", [["class", "full-column"]], null, null, null, null, null)), (_l()(), elementDef(15, 0, null, null, 1, "top-ops-table", [], null, null, null, View_TopOpsTable_0, RenderType_TopOpsTable)), directiveDef(16, 4767744, null, 0, TopOpsTable, [], { generalAnalysis: [0, "generalAnalysis"], inputPipelineAnalysis: [1, "inputPipelineAnalysis"] }, null)], function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.diagnostics; _ck(_v, 2, 0, currVal_0); var currVal_1 = _co.generalAnalysis; var currVal_2 = _co.inputPipelineAnalysis; var currVal_3 = _co.averageStepTimePropertyValues; _ck(_v, 6, 0, currVal_1, currVal_2, currVal_3); var currVal_4 = _co.runEnvironment; _ck(_v, 8, 0, currVal_4); var currVal_5 = _co.inputPipelineAnalysis; _ck(_v, 11, 0, currVal_5); var currVal_6 = _co.recommendationResult; _ck(_v, 13, 0, currVal_6); var currVal_7 = _co.generalAnalysis; var currVal_8 = _co.inputPipelineAnalysis; _ck(_v, 16, 0, currVal_7, currVal_8); }, null);
    }
    function View_Overview_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "overview", [], null, null, null, View_Overview_0, RenderType_Overview)), directiveDef(1, 180224, null, 0, Overview, [ActivatedRoute, DataService, Store], null, null)], null, null); }
    var OverviewNgFactory = createComponentFactory("overview", Overview, View_Overview_Host_0, {}, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$a = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}[_nghost-%COMP%]{display:block}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$b = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}[_nghost-%COMP%]{display:block;padding:20px}.summary-conclusion[_ngcontent-%COMP%]{font-style:italic;margin-top:-16px}.summary-nextstep[_ngcontent-%COMP%]{margin-top:-16px}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_AnalysisSummary = [styles$b];
    var RenderType_AnalysisSummary = createRendererType2({ encapsulation: 0, styles: styles_AnalysisSummary, data: {} });
    function View_AnalysisSummary_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "div", [["class", "mat-headline"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Summary of input-pipeline analysis"])), (_l()(), elementDef(2, 0, null, null, 1, "div", [["class", "summary-conclusion description"]], null, null, null, null, null)), (_l()(), textDef(3, null, ["", ""])), (_l()(), elementDef(4, 0, null, null, 0, "br", [], null, null, null, null, null)), (_l()(), elementDef(5, 0, null, null, 1, "div", [["class", "mat-title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Recommendation for next step:"])), (_l()(), elementDef(7, 0, null, null, 0, "div", [["class", "summary-nextstep description"]], [[8, "innerHTML", 1]], null, null, null, null))], null, function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.inputConclusion; _ck(_v, 3, 0, currVal_0); var currVal_1 = _co.summaryNextstep; _ck(_v, 7, 0, currVal_1); }); }
    function View_AnalysisSummary_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "analysis-summary", [], null, null, null, View_AnalysisSummary_0, RenderType_AnalysisSummary)), directiveDef(1, 49152, null, 0, AnalysisSummary, [], null, null)], null, null); }
    var AnalysisSummaryNgFactory = createComponentFactory("analysis-summary", AnalysisSummary, View_AnalysisSummary_Host_0, { deviceAnalysis: "deviceAnalysis" }, {}, []);
    var MatDividerModuleNgFactory = createNgModuleFactory(MatDividerModule, [], function (_l) {
        return moduleDef([
            moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [
                [
                    8,
                    []
                ],
                [
                    3,
                    ComponentFactoryResolver
                ],
                NgModuleRef
            ]),
            moduleProvideDef(4608, NgLocalization, NgLocaleLocalization, [
                LOCALE_ID$1,
                [
                    2,
                    DEPRECATED_PLURAL_FN
                ]
            ]),
            moduleProvideDef(1073742336, BidiModule, BidiModule, []),
            moduleProvideDef(1073742336, MatCommonModule, MatCommonModule, [
                [
                    2,
                    MATERIAL_SANITY_CHECKS
                ],
                [
                    2,
                    HAMMER_LOADER
                ]
            ]),
            moduleProvideDef(1073742336, CommonModule, CommonModule, []),
            moduleProvideDef(1073742336, MatDividerModule, MatDividerModule, [])
        ]);
    });
    var styles_MatDivider = ['.mat-divider{display:block;margin:0;border-top-width:1px;border-top-style:solid}.mat-divider.mat-divider-vertical{border-top:0;border-right-width:1px;border-right-style:solid}.mat-divider.mat-divider-inset{margin-left:80px}[dir=rtl] .mat-divider.mat-divider-inset{margin-left:auto;margin-right:80px}'];
    var RenderType_MatDivider = createRendererType2({
        encapsulation: 2,
        styles: styles_MatDivider,
        data: {}
    });
    function View_MatDivider_0(_l) {
        return viewDef(2, [], null, null);
    }
    function View_MatDivider_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'mat-divider', [
                [
                    'class',
                    'mat-divider'
                ],
                [
                    'role',
                    'separator'
                ]
            ], [
                [
                    1,
                    'aria-orientation',
                    0
                ],
                [
                    2,
                    'mat-divider-vertical',
                    null
                ],
                [
                    2,
                    'mat-divider-horizontal',
                    null
                ],
                [
                    2,
                    'mat-divider-inset',
                    null
                ]
            ], null, null, View_MatDivider_0, RenderType_MatDivider)),
            directiveDef(1, 49152, null, 0, MatDivider, [], null, null)
        ], null, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 1).vertical ? 'vertical' : 'horizontal';
            var currVal_1 = nodeValue(_v, 1).vertical;
            var currVal_2 = !nodeValue(_v, 1).vertical;
            var currVal_3 = nodeValue(_v, 1).inset;
            _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2, currVal_3);
        });
    }
    var MatDividerNgFactory = createComponentFactory('mat-divider', MatDivider, View_MatDivider_Host_0, {
        vertical: 'vertical',
        inset: 'inset'
    }, {}, []);
    var c$7 = RenderType_MatDivider;
    var d$7 = View_MatDivider_0;
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$c = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}[_nghost-%COMP%]{display:block;padding:20px}.content-container[_ngcontent-%COMP%]{margin-left:32px;margin-top:-16px}.content-container[_ngcontent-%COMP%]   .mat-title[_ngcontent-%COMP%]{margin-bottom:0}.sub-section-title[_ngcontent-%COMP%]{font-size:22px;margin-left:8px}.description[_ngcontent-%COMP%]{margin-bottom:4px}.chart[_ngcontent-%COMP%]{margin-left:-52px}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var ChartModuleNgFactory = createNgModuleFactory(ChartModule, [], function (_l) { return moduleDef([moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [[8, []], [3, ComponentFactoryResolver], NgModuleRef]), moduleProvideDef(1073742336, ChartModule, ChartModule, [])]); });
    var styles_Chart = ["[_nghost-%COMP%] {display: block;}"];
    var RenderType_Chart = createRendererType2({ encapsulation: 0, styles: styles_Chart, data: {} });
    function View_Chart_0(_l) { return viewDef(0, [], null, null); }
    function View_Chart_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "chart", [], null, null, null, View_Chart_0, RenderType_Chart)), directiveDef(1, 638976, null, 0, Chart, [ElementRef], null, null)], function (_ck, _v) { _ck(_v, 1, 0); }, null); }
    var ChartNgFactory = createComponentFactory("chart", Chart, View_Chart_Host_0, { chartType: "chartType", dataInfo: "dataInfo" }, { processedNumberOfRows: "processedNumberOfRows" }, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_DeviceSideAnalysisDetail = [styles$c];
    var RenderType_DeviceSideAnalysisDetail = createRendererType2({ encapsulation: 0, styles: styles_DeviceSideAnalysisDetail, data: {} });
    function View_DeviceSideAnalysisDetail_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 39, "div", [], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 1, "div", [["class", "mat-headline"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Device-side analysis details"])), (_l()(), elementDef(3, 0, null, null, 1, "div", [["class", "mat-headline sub-section-title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Device step time"])), (_l()(), elementDef(5, 0, null, null, 12, "div", [["class", "content-container"]], null, null, null, null, null)), (_l()(), elementDef(6, 0, null, null, 1, "div", [["class", "mat-title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Device step-time statistics"])), (_l()(), elementDef(8, 0, null, null, 1, "div", [["class", "primary-content"]], null, null, null, null, null)), (_l()(), textDef(9, null, [" Average: ", " ms (\u03C3 = ", " ms) "])), (_l()(), elementDef(10, 0, null, null, 1, "div", [["class", "primary-content"]], null, null, null, null, null)), (_l()(), textDef(11, null, [" Range: ", " - ", " ms "])), (_l()(), elementDef(12, 0, null, null, 0, "br", [], null, null, null, null, null)), (_l()(), elementDef(13, 0, null, null, 1, "div", [["class", "mat-title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Step Time (in milliseconds)"])), (_l()(), elementDef(15, 0, [["areaChart", 1]], null, 0, "div", [["class", "chart"]], null, null, null, null, null)), (_l()(), elementDef(16, 0, null, null, 1, "chart", [["chartType", "AreaChart"], ["class", "chart"]], null, null, null, View_Chart_0, RenderType_Chart)), directiveDef(17, 638976, null, 0, Chart, [ElementRef], { chartType: [0, "chartType"], dataInfo: [1, "dataInfo"] }, null), (_l()(), elementDef(18, 0, null, null, 0, "br", [], null, null, null, null, null)), (_l()(), elementDef(19, 0, null, null, 20, "div", [], [[8, "className", 0]], null, null, null, null)), (_l()(), elementDef(20, 0, null, null, 1, "div", [["class", "mat-headline sub-section-title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, [" Range of device time waiting for input data across cores at each step "])), (_l()(), elementDef(22, 0, null, null, 17, "div", [["class", "content-container"]], null, null, null, null, null)), (_l()(), elementDef(23, 0, null, null, 1, "div", [["class", "mat-title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["% of device step time waiting for input data"])), (_l()(), elementDef(25, 0, null, null, 4, "div", [["class", "description"]], null, null, null, null, null)), (_l()(), textDef(-1, null, [" (average over the "])), (_l()(), elementDef(27, 0, null, null, 1, "i", [], null, null, null, null, null)), (_l()(), textDef(-1, null, ["maximum"])), (_l()(), textDef(-1, null, [" waiting time across cores at each step) "])), (_l()(), elementDef(30, 0, null, null, 1, "div", [["class", "primary-content"]], null, null, null, null, null)), (_l()(), textDef(31, null, [" Average: ", " % (\u03C3 = ", " ms) "])), (_l()(), elementDef(32, 0, null, null, 1, "div", [["class", "primary-content"]], null, null, null, null, null)), (_l()(), textDef(33, null, [" Range: ", " - ", " % "])), (_l()(), elementDef(34, 0, null, null, 0, "br", [], null, null, null, null, null)), (_l()(), elementDef(35, 0, null, null, 1, "div", [["class", "mat-title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, [" Range of device time waiting for input data across cores at each step (in % of step time) "])), (_l()(), elementDef(37, 0, [["lineChart", 1]], null, 0, "div", [["class", "chart"]], null, null, null, null, null)), (_l()(), elementDef(38, 0, null, null, 1, "chart", [["chartType", "LineChart"], ["class", "chart"]], null, null, null, View_Chart_0, RenderType_Chart)), directiveDef(39, 638976, null, 0, Chart, [ElementRef], { chartType: [0, "chartType"], dataInfo: [1, "dataInfo"] }, null)], function (_ck, _v) { var _co = _v.component; var currVal_4 = "AreaChart"; var currVal_5 = _co.dataInfoForAreaChart; _ck(_v, 17, 0, currVal_4, currVal_5); var currVal_11 = "LineChart"; var currVal_12 = _co.dataInfoForLineChart; _ck(_v, 39, 0, currVal_11, currVal_12); }, function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.steptimeMsMetrics.average; var currVal_1 = _co.steptimeMsMetrics.stddev; _ck(_v, 9, 0, currVal_0, currVal_1); var currVal_2 = _co.steptimeMsMetrics.min; var currVal_3 = _co.steptimeMsMetrics.max; _ck(_v, 11, 0, currVal_2, currVal_3); var currVal_6 = (_co.isTpu ? "auto-height" : "hidden-content"); _ck(_v, 19, 0, currVal_6); var currVal_7 = _co.infeedPercentMetrics.average; var currVal_8 = _co.infeedPercentMetrics.stddev; _ck(_v, 31, 0, currVal_7, currVal_8); var currVal_9 = _co.infeedPercentMetrics.min; var currVal_10 = _co.infeedPercentMetrics.max; _ck(_v, 33, 0, currVal_9, currVal_10); }); }
    function View_DeviceSideAnalysisDetail_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "device-side-analysis-detail", [], null, null, null, View_DeviceSideAnalysisDetail_0, RenderType_DeviceSideAnalysisDetail)), directiveDef(1, 573440, null, 0, DeviceSideAnalysisDetail, [], null, null)], null, null); }
    var DeviceSideAnalysisDetailNgFactory = createComponentFactory("device-side-analysis-detail", DeviceSideAnalysisDetail, View_DeviceSideAnalysisDetail_Host_0, { deviceAnalysis: "deviceAnalysis", columnIds: "columnIds", columnColors: "columnColors" }, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$d = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}mat-expansion-panel[_ngcontent-%COMP%]{box-shadow:none !important;margin:8px;margin:0}@media screen and (max-width: 1140px){mat-expansion-panel[_ngcontent-%COMP%]{min-width:500px}}mat-expansion-panel-header[_ngcontent-%COMP%]{margin:8px 8px 0 8px}mat-panel-title[_ngcontent-%COMP%]{background-color:#fff;border-top-left-radius:4px;border-top-right-radius:4px;color:#000;font-size:24px;font-weight:400;background-color:transparent}mat-expansion-panel-header.cdk-keyboard-focused[_ngcontent-%COMP%], mat-expansion-panel[_ngcontent-%COMP%]:not(.mat-expanded)   mat-expansion-panel-header[_ngcontent-%COMP%]:hover{background-color:#eee !important}.mat-expanded[_ngcontent-%COMP%]   mat-expansion-panel-header[_ngcontent-%COMP%]{border-bottom-left-radius:0;border-bottom-right-radius:0}.section-container[_ngcontent-%COMP%]{border-bottom:1px solid #eee;padding:20px}.content-container[_ngcontent-%COMP%]{margin-left:32px}.column-chart[_ngcontent-%COMP%], .recommendations[_ngcontent-%COMP%]{color:#4a4a4a;margin-top:-16px}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_HostSideAnalysisDetail = [styles$d];
    var RenderType_HostSideAnalysisDetail = createRendererType2({ encapsulation: 0, styles: styles_HostSideAnalysisDetail, data: {} });
    function View_HostSideAnalysisDetail_1(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 0, "div", [], [[8, "innerHTML", 1]], null, null, null, null))], null, function (_ck, _v) { var currVal_0 = _v.context.$implicit; _ck(_v, 0, 0, currVal_0); }); }
    function View_HostSideAnalysisDetail_2(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 4, "div", [["class", "section-container"]], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 1, "div", [["class", "mat-headline"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Host-side analysis details"])), (_l()(), elementDef(3, 0, null, null, 1, "p", [], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Host side analysis can not be done without instrumentation."]))], null, null); }
    function View_HostSideAnalysisDetail_0(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 27, "div", [], [[8, "className", 0]], null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 12, "div", [["class", "section-container"]], null, null, null, null, null)), (_l()(), elementDef(2, 0, null, null, 1, "div", [["class", "mat-headline"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Host-side analysis details"])), (_l()(), elementDef(4, 0, null, null, 9, "div", [["class", "content-container"]], null, null, null, null, null)), (_l()(), elementDef(5, 0, null, null, 1, "div", [["class", "mat-title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Breakdown of input processing time on the host"])), (_l()(), elementDef(7, 0, null, null, 1, "chart", [["chartType", "ColumnChart"], ["class", "column-chart"]], null, null, null, View_Chart_0, RenderType_Chart)), directiveDef(8, 638976, null, 0, Chart, [ElementRef], { chartType: [0, "chartType"], dataInfo: [1, "dataInfo"] }, null), (_l()(), elementDef(9, 0, null, null, 1, "div", [["class", "mat-title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["What can be done to reduce above components of the host input time:"])), (_l()(), elementDef(11, 0, null, null, 2, "div", [["class", "recommendations"]], null, null, null, null, null)), (_l()(), anchorDef(16777216, null, null, 1, null, View_HostSideAnalysisDetail_1)), directiveDef(13, 278528, null, 0, NgForOf, [ViewContainerRef, TemplateRef, IterableDiffers], { ngForOf: [0, "ngForOf"] }, null), (_l()(), elementDef(14, 16777216, null, null, 12, "mat-expansion-panel", [["class", "mat-expansion-panel"]], [[2, "mat-expanded", null], [2, "_mat-animation-noopable", null], [2, "mat-expansion-panel-spacing", null]], null, null, d$4, c$4)), directiveDef(15, 1753088, null, 1, MatExpansionPanel, [[3, MAT_ACCORDION], ChangeDetectorRef, UniqueSelectionDispatcher, ViewContainerRef, DOCUMENT, [2, ANIMATION_MODULE_TYPE], [2, MAT_EXPANSION_PANEL_DEFAULT_OPTIONS]], null, null), queryDef(603979776, 1, { _lazyContent: 0 }), providerDef(256, null, MAT_ACCORDION, undefined, []), (_l()(), elementDef(18, 0, null, 0, 6, "mat-expansion-panel-header", [["class", "mat-expansion-panel-header"], ["role", "button"]], [[1, "id", 0], [1, "tabindex", 0], [1, "aria-controls", 0], [1, "aria-expanded", 0], [1, "aria-disabled", 0], [2, "mat-expanded", null], [2, "mat-expansion-toggle-indicator-after", null], [2, "mat-expansion-toggle-indicator-before", null], [40, "@.disabled", 0], [40, "@expansionHeight", 0]], [[null, "click"], [null, "keydown"], ["component", "@expansionHeight.start"]], function (_v, en, $event) {
                var ad = true;
                if (("click" === en)) {
                    var pd_0 = (nodeValue(_v, 19)._toggle() !== false);
                    ad = (pd_0 && ad);
                }
                if (("keydown" === en)) {
                    var pd_1 = (nodeValue(_v, 19)._keydown($event) !== false);
                    ad = (pd_1 && ad);
                }
                if (("component:@expansionHeight.start" === en)) {
                    var pd_2 = (nodeValue(_v, 19)._animationStarted() !== false);
                    ad = (pd_2 && ad);
                }
                return ad;
            }, h, g)), directiveDef(19, 180224, null, 0, MatExpansionPanelHeader, [MatExpansionPanel, ElementRef, FocusMonitor, ChangeDetectorRef, [2, MAT_EXPANSION_PANEL_DEFAULT_OPTIONS]], null, null), pureObjectDef(20, { collapsedHeight: 0, expandedHeight: 1 }), pureObjectDef(21, { value: 0, params: 1 }), (_l()(), elementDef(22, 0, null, 0, 2, "mat-panel-title", [["class", "mat-expansion-panel-header-title"]], null, null, null, null, null)), directiveDef(23, 16384, null, 0, MatExpansionPanelTitle, [], null, null), (_l()(), textDef(-1, null, ["Input Op statistics"])), (_l()(), elementDef(25, 0, null, 1, 1, "chart", [["chartType", "Table"]], null, null, null, View_Chart_0, RenderType_Chart)), directiveDef(26, 638976, null, 0, Chart, [ElementRef], { chartType: [0, "chartType"], dataInfo: [1, "dataInfo"] }, null), (_l()(), elementDef(27, 0, null, null, 0, "br", [], null, null, null, null, null)), (_l()(), anchorDef(16777216, null, null, 1, null, View_HostSideAnalysisDetail_2)), directiveDef(29, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"] }, null)], function (_ck, _v) { var _co = _v.component; var currVal_1 = "ColumnChart"; var currVal_2 = _co.dataInfoForColumnChart; _ck(_v, 8, 0, currVal_1, currVal_2); var currVal_3 = _co.recommendations; _ck(_v, 13, 0, currVal_3); var currVal_17 = "Table"; var currVal_18 = _co.dataInfoForTable; _ck(_v, 26, 0, currVal_17, currVal_18); var currVal_19 = !_co.hasHostOps; _ck(_v, 29, 0, currVal_19); }, function (_ck, _v) { var _co = _v.component; var currVal_0 = (_co.hasHostOps ? "auto-height" : "hidden-content"); _ck(_v, 0, 0, currVal_0); var currVal_4 = nodeValue(_v, 15).expanded; var currVal_5 = (nodeValue(_v, 15)._animationMode === "NoopAnimations"); var currVal_6 = nodeValue(_v, 15)._hasSpacing(); _ck(_v, 14, 0, currVal_4, currVal_5, currVal_6); var currVal_7 = nodeValue(_v, 19).panel._headerId; var currVal_8 = (nodeValue(_v, 19).disabled ? (0 - 1) : 0); var currVal_9 = nodeValue(_v, 19)._getPanelId(); var currVal_10 = nodeValue(_v, 19)._isExpanded(); var currVal_11 = nodeValue(_v, 19).panel.disabled; var currVal_12 = nodeValue(_v, 19)._isExpanded(); var currVal_13 = (nodeValue(_v, 19)._getTogglePosition() === "after"); var currVal_14 = (nodeValue(_v, 19)._getTogglePosition() === "before"); var currVal_15 = nodeValue(_v, 19)._animationsDisabled; var currVal_16 = _ck(_v, 21, 0, nodeValue(_v, 19)._getExpandedState(), _ck(_v, 20, 0, nodeValue(_v, 19).collapsedHeight, nodeValue(_v, 19).expandedHeight)); _ck(_v, 18, 0, currVal_7, currVal_8, currVal_9, currVal_10, currVal_11, currVal_12, currVal_13, currVal_14, currVal_15, currVal_16); });
    }
    function View_HostSideAnalysisDetail_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "host-side-analysis-detail", [], null, null, null, View_HostSideAnalysisDetail_0, RenderType_HostSideAnalysisDetail)), directiveDef(1, 638976, null, 0, HostSideAnalysisDetail, [], null, null)], function (_ck, _v) { _ck(_v, 1, 0); }, null); }
    var HostSideAnalysisDetailNgFactory = createComponentFactory("host-side-analysis-detail", HostSideAnalysisDetail, View_HostSideAnalysisDetail_Host_0, { hostAnalysis: "hostAnalysis", recommendation: "recommendation" }, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_InputPipeline = [styles$a];
    var RenderType_InputPipeline = createRendererType2({ encapsulation: 0, styles: styles_InputPipeline, data: {} });
    function View_InputPipeline_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 13, "div", [], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 1, "diagnostics-view", [], null, null, null, View_DiagnosticsView_0, RenderType_DiagnosticsView)), directiveDef(2, 49152, null, 0, DiagnosticsView, [], { diagnostics: [0, "diagnostics"] }, null), (_l()(), elementDef(3, 0, null, null, 1, "analysis-summary", [], null, null, null, View_AnalysisSummary_0, RenderType_AnalysisSummary)), directiveDef(4, 49152, null, 0, AnalysisSummary, [], { deviceAnalysis: [0, "deviceAnalysis"] }, null), (_l()(), elementDef(5, 0, null, null, 1, "mat-divider", [["class", "mat-divider"], ["role", "separator"]], [[1, "aria-orientation", 0], [2, "mat-divider-vertical", null], [2, "mat-divider-horizontal", null], [2, "mat-divider-inset", null]], null, null, d$7, c$7)), directiveDef(6, 49152, null, 0, MatDivider, [], null, null), (_l()(), elementDef(7, 0, null, null, 4, "div", [], [[8, "className", 0]], null, null, null, null)), (_l()(), elementDef(8, 0, null, null, 1, "device-side-analysis-detail", [], null, null, null, View_DeviceSideAnalysisDetail_0, RenderType_DeviceSideAnalysisDetail)), directiveDef(9, 573440, null, 0, DeviceSideAnalysisDetail, [], { deviceAnalysis: [0, "deviceAnalysis"] }, null), (_l()(), elementDef(10, 0, null, null, 1, "mat-divider", [["class", "mat-divider"], ["role", "separator"]], [[1, "aria-orientation", 0], [2, "mat-divider-vertical", null], [2, "mat-divider-horizontal", null], [2, "mat-divider-inset", null]], null, null, d$7, c$7)), directiveDef(11, 49152, null, 0, MatDivider, [], null, null), (_l()(), elementDef(12, 0, null, null, 1, "host-side-analysis-detail", [], null, null, null, View_HostSideAnalysisDetail_0, RenderType_HostSideAnalysisDetail)), directiveDef(13, 638976, null, 0, HostSideAnalysisDetail, [], { hostAnalysis: [0, "hostAnalysis"], recommendation: [1, "recommendation"] }, null)], function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.diagnostics; _ck(_v, 2, 0, currVal_0); var currVal_1 = _co.deviceAnalysis; _ck(_v, 4, 0, currVal_1); var currVal_7 = _co.deviceAnalysis; _ck(_v, 9, 0, currVal_7); var currVal_12 = _co.hostAnalysis; var currVal_13 = _co.recommendation; _ck(_v, 13, 0, currVal_12, currVal_13); }, function (_ck, _v) { var _co = _v.component; var currVal_2 = (nodeValue(_v, 6).vertical ? "vertical" : "horizontal"); var currVal_3 = nodeValue(_v, 6).vertical; var currVal_4 = !nodeValue(_v, 6).vertical; var currVal_5 = nodeValue(_v, 6).inset; _ck(_v, 5, 0, currVal_2, currVal_3, currVal_4, currVal_5); var currVal_6 = (_co.hasDiviceAanlysisRows ? "full-height" : "hidden-content"); _ck(_v, 7, 0, currVal_6); var currVal_8 = (nodeValue(_v, 11).vertical ? "vertical" : "horizontal"); var currVal_9 = nodeValue(_v, 11).vertical; var currVal_10 = !nodeValue(_v, 11).vertical; var currVal_11 = nodeValue(_v, 11).inset; _ck(_v, 10, 0, currVal_8, currVal_9, currVal_10, currVal_11); }); }
    function View_InputPipeline_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "input-pipeline", [], null, null, null, View_InputPipeline_0, RenderType_InputPipeline)), directiveDef(1, 180224, null, 0, InputPipeline, [ActivatedRoute, DataService, Store], null, null)], null, null); }
    var InputPipelineNgFactory = createComponentFactory("input-pipeline", InputPipeline, View_InputPipeline_Host_0, {}, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$e = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}[_nghost-%COMP%]{display:block}.section-container[_ngcontent-%COMP%]{padding:20px}.row[_ngcontent-%COMP%]{display:flex}.flex-space[_ngcontent-%COMP%]{flex:1}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$f = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}.save-button[_ngcontent-%COMP%]{padding-top:8px;text-align:center;width:130px}.save-button[_ngcontent-%COMP%]:hover{color:#777;cursor:pointer}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_ExportAsCsv = [styles$f];
    var RenderType_ExportAsCsv = createRendererType2({ encapsulation: 0, styles: styles_ExportAsCsv, data: {} });
    function View_ExportAsCsv_0(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 5, "div", [["class", "save-button"]], null, [[null, "click"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("click" === en)) {
                    var pd_0 = (_co.exportDataAsCSV() !== false);
                    ad = (pd_0 && ad);
                }
                return ad;
            }, null, null)), (_l()(), elementDef(1, 0, null, null, 2, "mat-icon", [["class", "mat-icon notranslate"], ["role", "img"]], [[2, "mat-icon-inline", null], [2, "mat-icon-no-color", null]], null, null, d$5, c$5)), directiveDef(2, 9158656, null, 0, MatIcon, [ElementRef, MatIconRegistry, [8, null], [2, MAT_ICON_LOCATION], [2, ErrorHandler]], null, null), (_l()(), textDef(-1, 0, ["save_alt"])), (_l()(), elementDef(4, 0, null, null, 1, "div", [["class", "mat-title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Export as CSV"]))], function (_ck, _v) { _ck(_v, 2, 0); }, function (_ck, _v) { var currVal_0 = nodeValue(_v, 2).inline; var currVal_1 = (((nodeValue(_v, 2).color !== "primary") && (nodeValue(_v, 2).color !== "accent")) && (nodeValue(_v, 2).color !== "warn")); _ck(_v, 1, 0, currVal_0, currVal_1); });
    }
    function View_ExportAsCsv_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "export-as-csv", [], null, null, null, View_ExportAsCsv_0, RenderType_ExportAsCsv)), directiveDef(1, 49152, null, 0, ExportAsCsv, [Store], null, null)], null, null); }
    var ExportAsCsvNgFactory = createComponentFactory("export-as-csv", ExportAsCsv, View_ExportAsCsv_Host_0, { tool: "tool" }, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$g = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}[_nghost-%COMP%]{display:block;width:800px;height:fit-content;margin:8px 8px 8px 0}.control[_ngcontent-%COMP%]{width:fit-content;text-align:center}.control-title[_ngcontent-%COMP%]{color:#5f6368;margin:-20px 0 -24px}.count-input[_ngcontent-%COMP%]{width:50px}"];
    var MatSliderModuleNgFactory = createNgModuleFactory(MatSliderModule, [], function (_l) {
        return moduleDef([
            moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [
                [
                    8,
                    []
                ],
                [
                    3,
                    ComponentFactoryResolver
                ],
                NgModuleRef
            ]),
            moduleProvideDef(4608, NgLocalization, NgLocaleLocalization, [
                LOCALE_ID$1,
                [
                    2,
                    DEPRECATED_PLURAL_FN
                ]
            ]),
            moduleProvideDef(4608, HAMMER_GESTURE_CONFIG, GestureConfig, [
                [
                    2,
                    MAT_HAMMER_OPTIONS
                ],
                [
                    2,
                    MatCommonModule
                ]
            ]),
            moduleProvideDef(1073742336, CommonModule, CommonModule, []),
            moduleProvideDef(1073742336, BidiModule, BidiModule, []),
            moduleProvideDef(1073742336, MatCommonModule, MatCommonModule, [
                [
                    2,
                    MATERIAL_SANITY_CHECKS
                ],
                [
                    2,
                    HAMMER_LOADER
                ]
            ]),
            moduleProvideDef(1073742336, MatSliderModule, MatSliderModule, [])
        ]);
    });
    var styles_MatSlider = [".mat-slider{display:inline-block;position:relative;box-sizing:border-box;padding:8px;outline:0;vertical-align:middle}.mat-slider.mat-slider-sliding:not(.mat-slider-disabled),.mat-slider:not(.mat-slider-disabled):active{cursor:-webkit-grabbing;cursor:grabbing}.mat-slider-wrapper{position:absolute}.mat-slider-track-wrapper{position:absolute;top:0;left:0;overflow:hidden}.mat-slider-track-fill{position:absolute;transform-origin:0 0;transition:transform .4s cubic-bezier(.25,.8,.25,1),background-color .4s cubic-bezier(.25,.8,.25,1)}.mat-slider-track-background{position:absolute;transform-origin:100% 100%;transition:transform .4s cubic-bezier(.25,.8,.25,1),background-color .4s cubic-bezier(.25,.8,.25,1)}.mat-slider-ticks-container{position:absolute;left:0;top:0;overflow:hidden}.mat-slider-ticks{background-repeat:repeat;background-clip:content-box;box-sizing:border-box;opacity:0;transition:opacity .4s cubic-bezier(.25,.8,.25,1)}.mat-slider-thumb-container{position:absolute;z-index:1;transition:transform .4s cubic-bezier(.25,.8,.25,1)}.mat-slider-focus-ring{position:absolute;width:30px;height:30px;border-radius:50%;transform:scale(0);opacity:0;transition:transform .4s cubic-bezier(.25,.8,.25,1),background-color .4s cubic-bezier(.25,.8,.25,1),opacity .4s cubic-bezier(.25,.8,.25,1)}.mat-slider.cdk-keyboard-focused .mat-slider-focus-ring,.mat-slider.cdk-program-focused .mat-slider-focus-ring{transform:scale(1);opacity:1}.mat-slider:not(.mat-slider-disabled):not(.mat-slider-sliding) .mat-slider-thumb,.mat-slider:not(.mat-slider-disabled):not(.mat-slider-sliding) .mat-slider-thumb-label{cursor:-webkit-grab;cursor:grab}.mat-slider-thumb{position:absolute;right:-10px;bottom:-10px;box-sizing:border-box;width:20px;height:20px;border:3px solid transparent;border-radius:50%;transform:scale(.7);transition:transform .4s cubic-bezier(.25,.8,.25,1),background-color .4s cubic-bezier(.25,.8,.25,1),border-color .4s cubic-bezier(.25,.8,.25,1)}.mat-slider-thumb-label{display:none;align-items:center;justify-content:center;position:absolute;width:28px;height:28px;border-radius:50%;transition:transform .4s cubic-bezier(.25,.8,.25,1),border-radius .4s cubic-bezier(.25,.8,.25,1),background-color .4s cubic-bezier(.25,.8,.25,1)}@media (-ms-high-contrast:active){.mat-slider-thumb-label{outline:solid 1px}}.mat-slider-thumb-label-text{z-index:1;opacity:0;transition:opacity .4s cubic-bezier(.25,.8,.25,1)}.mat-slider-sliding .mat-slider-thumb-container,.mat-slider-sliding .mat-slider-track-background,.mat-slider-sliding .mat-slider-track-fill{transition-duration:0s}.mat-slider-has-ticks .mat-slider-wrapper::after{content:'';position:absolute;border-width:0;border-style:solid;opacity:0;transition:opacity .4s cubic-bezier(.25,.8,.25,1)}.mat-slider-has-ticks.cdk-focused:not(.mat-slider-hide-last-tick) .mat-slider-wrapper::after,.mat-slider-has-ticks:hover:not(.mat-slider-hide-last-tick) .mat-slider-wrapper::after{opacity:1}.mat-slider-has-ticks.cdk-focused:not(.mat-slider-disabled) .mat-slider-ticks,.mat-slider-has-ticks:hover:not(.mat-slider-disabled) .mat-slider-ticks{opacity:1}.mat-slider-thumb-label-showing .mat-slider-focus-ring{display:none}.mat-slider-thumb-label-showing .mat-slider-thumb-label{display:flex}.mat-slider-axis-inverted .mat-slider-track-fill{transform-origin:100% 100%}.mat-slider-axis-inverted .mat-slider-track-background{transform-origin:0 0}.mat-slider:not(.mat-slider-disabled).cdk-focused.mat-slider-thumb-label-showing .mat-slider-thumb{transform:scale(0)}.mat-slider:not(.mat-slider-disabled).cdk-focused .mat-slider-thumb-label{border-radius:50% 50% 0}.mat-slider:not(.mat-slider-disabled).cdk-focused .mat-slider-thumb-label-text{opacity:1}.mat-slider:not(.mat-slider-disabled).cdk-mouse-focused .mat-slider-thumb,.mat-slider:not(.mat-slider-disabled).cdk-program-focused .mat-slider-thumb,.mat-slider:not(.mat-slider-disabled).cdk-touch-focused .mat-slider-thumb{border-width:2px;transform:scale(1)}.mat-slider-disabled .mat-slider-focus-ring{transform:scale(0);opacity:0}.mat-slider-disabled .mat-slider-thumb{border-width:4px;transform:scale(.5)}.mat-slider-disabled .mat-slider-thumb-label{display:none}.mat-slider-horizontal{height:48px;min-width:128px}.mat-slider-horizontal .mat-slider-wrapper{height:2px;top:23px;left:8px;right:8px}.mat-slider-horizontal .mat-slider-wrapper::after{height:2px;border-left-width:2px;right:0;top:0}.mat-slider-horizontal .mat-slider-track-wrapper{height:2px;width:100%}.mat-slider-horizontal .mat-slider-track-fill{height:2px;width:100%;transform:scaleX(0)}.mat-slider-horizontal .mat-slider-track-background{height:2px;width:100%;transform:scaleX(1)}.mat-slider-horizontal .mat-slider-ticks-container{height:2px;width:100%}@media (-ms-high-contrast:active){.mat-slider-horizontal .mat-slider-ticks-container{height:0;outline:solid 2px;top:1px}}.mat-slider-horizontal .mat-slider-ticks{height:2px;width:100%}.mat-slider-horizontal .mat-slider-thumb-container{width:100%;height:0;top:50%}.mat-slider-horizontal .mat-slider-focus-ring{top:-15px;right:-15px}.mat-slider-horizontal .mat-slider-thumb-label{right:-14px;top:-40px;transform:translateY(26px) scale(.01) rotate(45deg)}.mat-slider-horizontal .mat-slider-thumb-label-text{transform:rotate(-45deg)}.mat-slider-horizontal.cdk-focused .mat-slider-thumb-label{transform:rotate(45deg)}@media (-ms-high-contrast:active){.mat-slider-horizontal.cdk-focused .mat-slider-thumb-label,.mat-slider-horizontal.cdk-focused .mat-slider-thumb-label-text{transform:none}}.mat-slider-vertical{width:48px;min-height:128px}.mat-slider-vertical .mat-slider-wrapper{width:2px;top:8px;bottom:8px;left:23px}.mat-slider-vertical .mat-slider-wrapper::after{width:2px;border-top-width:2px;bottom:0;left:0}.mat-slider-vertical .mat-slider-track-wrapper{height:100%;width:2px}.mat-slider-vertical .mat-slider-track-fill{height:100%;width:2px;transform:scaleY(0)}.mat-slider-vertical .mat-slider-track-background{height:100%;width:2px;transform:scaleY(1)}.mat-slider-vertical .mat-slider-ticks-container{width:2px;height:100%}@media (-ms-high-contrast:active){.mat-slider-vertical .mat-slider-ticks-container{width:0;outline:solid 2px;left:1px}}.mat-slider-vertical .mat-slider-focus-ring{bottom:-15px;left:-15px}.mat-slider-vertical .mat-slider-ticks{width:2px;height:100%}.mat-slider-vertical .mat-slider-thumb-container{height:100%;width:0;left:50%}.mat-slider-vertical .mat-slider-thumb{-webkit-backface-visibility:hidden;backface-visibility:hidden}.mat-slider-vertical .mat-slider-thumb-label{bottom:-14px;left:-40px;transform:translateX(26px) scale(.01) rotate(-45deg)}.mat-slider-vertical .mat-slider-thumb-label-text{transform:rotate(45deg)}.mat-slider-vertical.cdk-focused .mat-slider-thumb-label{transform:rotate(-45deg)}[dir=rtl] .mat-slider-wrapper::after{left:0;right:auto}[dir=rtl] .mat-slider-horizontal .mat-slider-track-fill{transform-origin:100% 100%}[dir=rtl] .mat-slider-horizontal .mat-slider-track-background{transform-origin:0 0}[dir=rtl] .mat-slider-horizontal.mat-slider-axis-inverted .mat-slider-track-fill{transform-origin:0 0}[dir=rtl] .mat-slider-horizontal.mat-slider-axis-inverted .mat-slider-track-background{transform-origin:100% 100%}.mat-slider._mat-animation-noopable .mat-slider-focus-ring,.mat-slider._mat-animation-noopable .mat-slider-has-ticks .mat-slider-wrapper::after,.mat-slider._mat-animation-noopable .mat-slider-thumb,.mat-slider._mat-animation-noopable .mat-slider-thumb-container,.mat-slider._mat-animation-noopable .mat-slider-thumb-label,.mat-slider._mat-animation-noopable .mat-slider-thumb-label-text,.mat-slider._mat-animation-noopable .mat-slider-ticks,.mat-slider._mat-animation-noopable .mat-slider-track-background,.mat-slider._mat-animation-noopable .mat-slider-track-fill{transition:none}"];
    var RenderType_MatSlider = createRendererType2({
        encapsulation: 2,
        styles: styles_MatSlider,
        data: {}
    });
    function View_MatSlider_0(_l) {
        return viewDef(2, [
            queryDef(671088640, 1, { _sliderWrapper: 0 }),
            (_l()(), elementDef(1, 0, [
                [
                    1,
                    0
                ],
                [
                    'sliderWrapper',
                    1
                ]
            ], null, 21, 'div', [[
                    'class',
                    'mat-slider-wrapper'
                ]], null, null, null, null, null)),
            (_l()(), elementDef(2, 0, null, null, 6, 'div', [[
                    'class',
                    'mat-slider-track-wrapper'
                ]], null, null, null, null, null)),
            (_l()(), elementDef(3, 0, null, null, 2, 'div', [[
                    'class',
                    'mat-slider-track-background'
                ]], null, null, null, null, null)),
            providerDef(512, null, NgStyleImpl, NgStyleR2Impl, [
                ElementRef,
                KeyValueDiffers,
                Renderer2
            ]),
            directiveDef(5, 278528, null, 0, NgStyle, [NgStyleImpl], {
                ngStyle: [
                    0,
                    'ngStyle'
                ]
            }, null),
            (_l()(), elementDef(6, 0, null, null, 2, 'div', [[
                    'class',
                    'mat-slider-track-fill'
                ]], null, null, null, null, null)),
            providerDef(512, null, NgStyleImpl, NgStyleR2Impl, [
                ElementRef,
                KeyValueDiffers,
                Renderer2
            ]),
            directiveDef(8, 278528, null, 0, NgStyle, [NgStyleImpl], {
                ngStyle: [
                    0,
                    'ngStyle'
                ]
            }, null),
            (_l()(), elementDef(9, 0, null, null, 5, 'div', [[
                    'class',
                    'mat-slider-ticks-container'
                ]], null, null, null, null, null)),
            providerDef(512, null, NgStyleImpl, NgStyleR2Impl, [
                ElementRef,
                KeyValueDiffers,
                Renderer2
            ]),
            directiveDef(11, 278528, null, 0, NgStyle, [NgStyleImpl], {
                ngStyle: [
                    0,
                    'ngStyle'
                ]
            }, null),
            (_l()(), elementDef(12, 0, null, null, 2, 'div', [[
                    'class',
                    'mat-slider-ticks'
                ]], null, null, null, null, null)),
            providerDef(512, null, NgStyleImpl, NgStyleR2Impl, [
                ElementRef,
                KeyValueDiffers,
                Renderer2
            ]),
            directiveDef(14, 278528, null, 0, NgStyle, [NgStyleImpl], {
                ngStyle: [
                    0,
                    'ngStyle'
                ]
            }, null),
            (_l()(), elementDef(15, 0, null, null, 7, 'div', [[
                    'class',
                    'mat-slider-thumb-container'
                ]], null, null, null, null, null)),
            providerDef(512, null, NgStyleImpl, NgStyleR2Impl, [
                ElementRef,
                KeyValueDiffers,
                Renderer2
            ]),
            directiveDef(17, 278528, null, 0, NgStyle, [NgStyleImpl], {
                ngStyle: [
                    0,
                    'ngStyle'
                ]
            }, null),
            (_l()(), elementDef(18, 0, null, null, 0, 'div', [[
                    'class',
                    'mat-slider-focus-ring'
                ]], null, null, null, null, null)),
            (_l()(), elementDef(19, 0, null, null, 0, 'div', [[
                    'class',
                    'mat-slider-thumb'
                ]], null, null, null, null, null)),
            (_l()(), elementDef(20, 0, null, null, 2, 'div', [[
                    'class',
                    'mat-slider-thumb-label'
                ]], null, null, null, null, null)),
            (_l()(), elementDef(21, 0, null, null, 1, 'span', [[
                    'class',
                    'mat-slider-thumb-label-text'
                ]], null, null, null, null, null)),
            (_l()(), textDef(22, null, [
                '',
                ''
            ]))
        ], function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co._trackBackgroundStyles;
            _ck(_v, 5, 0, currVal_0);
            var currVal_1 = _co._trackFillStyles;
            _ck(_v, 8, 0, currVal_1);
            var currVal_2 = _co._ticksContainerStyles;
            _ck(_v, 11, 0, currVal_2);
            var currVal_3 = _co._ticksStyles;
            _ck(_v, 14, 0, currVal_3);
            var currVal_4 = _co._thumbContainerStyles;
            _ck(_v, 17, 0, currVal_4);
        }, function (_ck, _v) {
            var _co = _v.component;
            var currVal_5 = _co.displayValue;
            _ck(_v, 22, 0, currVal_5);
        });
    }
    function View_MatSlider_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 2, 'mat-slider', [
                [
                    'class',
                    'mat-slider'
                ],
                [
                    'role',
                    'slider'
                ]
            ], [
                [
                    8,
                    'tabIndex',
                    0
                ],
                [
                    1,
                    'aria-disabled',
                    0
                ],
                [
                    1,
                    'aria-valuemax',
                    0
                ],
                [
                    1,
                    'aria-valuemin',
                    0
                ],
                [
                    1,
                    'aria-valuenow',
                    0
                ],
                [
                    1,
                    'aria-orientation',
                    0
                ],
                [
                    2,
                    'mat-slider-disabled',
                    null
                ],
                [
                    2,
                    'mat-slider-has-ticks',
                    null
                ],
                [
                    2,
                    'mat-slider-horizontal',
                    null
                ],
                [
                    2,
                    'mat-slider-axis-inverted',
                    null
                ],
                [
                    2,
                    'mat-slider-invert-mouse-coords',
                    null
                ],
                [
                    2,
                    'mat-slider-sliding',
                    null
                ],
                [
                    2,
                    'mat-slider-thumb-label-showing',
                    null
                ],
                [
                    2,
                    'mat-slider-vertical',
                    null
                ],
                [
                    2,
                    'mat-slider-min-value',
                    null
                ],
                [
                    2,
                    'mat-slider-hide-last-tick',
                    null
                ],
                [
                    2,
                    '_mat-animation-noopable',
                    null
                ]
            ], [
                [
                    null,
                    'focus'
                ],
                [
                    null,
                    'blur'
                ],
                [
                    null,
                    'mousedown'
                ],
                [
                    null,
                    'keydown'
                ],
                [
                    null,
                    'keyup'
                ],
                [
                    null,
                    'mouseenter'
                ],
                [
                    null,
                    'slide'
                ],
                [
                    null,
                    'slideend'
                ],
                [
                    null,
                    'slidestart'
                ],
                [
                    null,
                    'selectstart'
                ]
            ], function (_v, en, $event) {
                var ad = true;
                if ('focus' === en) {
                    var pd_0 = nodeValue(_v, 2)._onFocus() !== false;
                    ad = pd_0 && ad;
                }
                if ('blur' === en) {
                    var pd_1 = nodeValue(_v, 2)._onBlur() !== false;
                    ad = pd_1 && ad;
                }
                if ('mousedown' === en) {
                    var pd_2 = nodeValue(_v, 2)._onMousedown($event) !== false;
                    ad = pd_2 && ad;
                }
                if ('keydown' === en) {
                    var pd_3 = nodeValue(_v, 2)._onKeydown($event) !== false;
                    ad = pd_3 && ad;
                }
                if ('keyup' === en) {
                    var pd_4 = nodeValue(_v, 2)._onKeyup() !== false;
                    ad = pd_4 && ad;
                }
                if ('mouseenter' === en) {
                    var pd_5 = nodeValue(_v, 2)._onMouseenter() !== false;
                    ad = pd_5 && ad;
                }
                if ('slide' === en) {
                    var pd_6 = nodeValue(_v, 2)._onSlide($event) !== false;
                    ad = pd_6 && ad;
                }
                if ('slideend' === en) {
                    var pd_7 = nodeValue(_v, 2)._onSlideEnd() !== false;
                    ad = pd_7 && ad;
                }
                if ('slidestart' === en) {
                    var pd_8 = nodeValue(_v, 2)._onSlideStart($event) !== false;
                    ad = pd_8 && ad;
                }
                if ('selectstart' === en) {
                    var pd_9 = $event.preventDefault() !== false;
                    ad = pd_9 && ad;
                }
                return ad;
            }, View_MatSlider_0, RenderType_MatSlider)),
            providerDef(5120, null, NG_VALUE_ACCESSOR, function (p0_0) {
                return [p0_0];
            }, [MatSlider]),
            directiveDef(2, 245760, null, 0, MatSlider, [
                ElementRef,
                FocusMonitor,
                ChangeDetectorRef,
                [
                    2,
                    Directionality
                ],
                [
                    8,
                    null
                ],
                [
                    2,
                    ANIMATION_MODULE_TYPE
                ]
            ], null, null)
        ], function (_ck, _v) {
            _ck(_v, 2, 0);
        }, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 2).tabIndex;
            var currVal_1 = nodeValue(_v, 2).disabled;
            var currVal_2 = nodeValue(_v, 2).max;
            var currVal_3 = nodeValue(_v, 2).min;
            var currVal_4 = nodeValue(_v, 2).value;
            var currVal_5 = nodeValue(_v, 2).vertical ? 'vertical' : 'horizontal';
            var currVal_6 = nodeValue(_v, 2).disabled;
            var currVal_7 = nodeValue(_v, 2).tickInterval;
            var currVal_8 = !nodeValue(_v, 2).vertical;
            var currVal_9 = nodeValue(_v, 2)._invertAxis;
            var currVal_10 = nodeValue(_v, 2)._shouldInvertMouseCoords();
            var currVal_11 = nodeValue(_v, 2)._isSliding;
            var currVal_12 = nodeValue(_v, 2).thumbLabel;
            var currVal_13 = nodeValue(_v, 2).vertical;
            var currVal_14 = nodeValue(_v, 2)._isMinValue;
            var currVal_15 = nodeValue(_v, 2).disabled || nodeValue(_v, 2)._isMinValue && nodeValue(_v, 2)._thumbGap && nodeValue(_v, 2)._invertAxis;
            var currVal_16 = nodeValue(_v, 2)._animationMode === 'NoopAnimations';
            _ck(_v, 0, 1, [
                currVal_0,
                currVal_1,
                currVal_2,
                currVal_3,
                currVal_4,
                currVal_5,
                currVal_6,
                currVal_7,
                currVal_8,
                currVal_9,
                currVal_10,
                currVal_11,
                currVal_12,
                currVal_13,
                currVal_14,
                currVal_15,
                currVal_16
            ]);
        });
    }
    var MatSliderNgFactory = createComponentFactory('mat-slider', MatSlider, View_MatSlider_Host_0, {
        disabled: 'disabled',
        color: 'color',
        tabIndex: 'tabIndex',
        invert: 'invert',
        max: 'max',
        min: 'min',
        step: 'step',
        thumbLabel: 'thumbLabel',
        tickInterval: 'tickInterval',
        value: 'value',
        displayWith: 'displayWith',
        vertical: 'vertical'
    }, {
        change: 'change',
        input: 'input',
        valueChange: 'valueChange'
    }, []);
    var c$8 = RenderType_MatSlider;
    var d$8 = View_MatSlider_0;
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_KernelStatsChart = [styles$g];
    var RenderType_KernelStatsChart = createRendererType2({ encapsulation: 0, styles: styles_KernelStatsChart, data: {} });
    function View_KernelStatsChart_0(_l) {
        return viewDef(0, [queryDef(671088640, 1, { chartRef: 0 }), (_l()(), elementDef(1, 0, null, null, 25, "div", [], null, null, null, null, null)), (_l()(), elementDef(2, 0, null, null, 1, "div", [["class", "mat-title"]], null, null, null, null, null)), (_l()(), textDef(3, null, ["Top ", " Kernels with highest Total Duration"])), (_l()(), elementDef(4, 0, null, null, 21, "div", [["class", "control"]], null, null, null, null, null)), (_l()(), elementDef(5, 0, null, null, 16, "div", [["class", "control-title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, [" Show top\u00A0 "])), (_l()(), elementDef(7, 0, null, null, 13, "mat-form-field", [["class", "count-input mat-form-field"]], [[2, "mat-form-field-appearance-standard", null], [2, "mat-form-field-appearance-fill", null], [2, "mat-form-field-appearance-outline", null], [2, "mat-form-field-appearance-legacy", null], [2, "mat-form-field-invalid", null], [2, "mat-form-field-can-float", null], [2, "mat-form-field-should-float", null], [2, "mat-form-field-has-label", null], [2, "mat-form-field-hide-placeholder", null], [2, "mat-form-field-disabled", null], [2, "mat-form-field-autofilled", null], [2, "mat-focused", null], [2, "mat-accent", null], [2, "mat-warn", null], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [2, "_mat-animation-noopable", null]], null, null, d$1, c$1)), directiveDef(8, 7520256, null, 9, MatFormField, [ElementRef, ChangeDetectorRef, [2, MAT_LABEL_GLOBAL_OPTIONS], [2, Directionality], [2, MAT_FORM_FIELD_DEFAULT_OPTIONS], Platform, NgZone, [2, ANIMATION_MODULE_TYPE]], null, null), queryDef(603979776, 2, { _controlNonStatic: 0 }), queryDef(335544320, 3, { _controlStatic: 0 }), queryDef(603979776, 4, { _labelChildNonStatic: 0 }), queryDef(335544320, 5, { _labelChildStatic: 0 }), queryDef(603979776, 6, { _placeholderChild: 0 }), queryDef(603979776, 7, { _errorChildren: 1 }), queryDef(603979776, 8, { _hintChildren: 1 }), queryDef(603979776, 9, { _prefixChildren: 1 }), queryDef(603979776, 10, { _suffixChildren: 1 }), (_l()(), elementDef(18, 0, null, 1, 2, "input", [["class", "mat-input-element mat-form-field-autofill-control"], ["matInput", ""], ["type", "number"]], [[8, "min", 0], [8, "max", 0], [8, "step", 0], [2, "mat-input-server", null], [1, "id", 0], [1, "placeholder", 0], [8, "disabled", 0], [8, "required", 0], [1, "readonly", 0], [1, "aria-describedby", 0], [1, "aria-invalid", 0], [1, "aria-required", 0]], [[null, "input"], [null, "blur"], [null, "focus"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("blur" === en)) {
                    var pd_0 = (nodeValue(_v, 19)._focusChanged(false) !== false);
                    ad = (pd_0 && ad);
                }
                if (("focus" === en)) {
                    var pd_1 = (nodeValue(_v, 19)._focusChanged(true) !== false);
                    ad = (pd_1 && ad);
                }
                if (("input" === en)) {
                    var pd_2 = (nodeValue(_v, 19)._onInput() !== false);
                    ad = (pd_2 && ad);
                }
                if (("input" === en)) {
                    var pd_3 = (_co.updateCount($event.target.value) !== false);
                    ad = (pd_3 && ad);
                }
                return ad;
            }, null, null)), directiveDef(19, 999424, null, 0, MatInput, [ElementRef, Platform, [8, null], [2, NgForm], [2, FormGroupDirective], ErrorStateMatcher, [8, null], AutofillMonitor, NgZone], { type: [0, "type"], value: [1, "value"] }, null), providerDef(2048, [[2, 4], [3, 4]], MatFormFieldControl, null, [MatInput]), (_l()(), textDef(-1, null, [" \u00A0Kernels "])), (_l()(), elementDef(22, 0, null, null, 3, "div", [], null, null, null, null, null)), (_l()(), elementDef(23, 0, null, null, 2, "mat-slider", [["class", "mat-slider"], ["role", "slider"]], [[8, "tabIndex", 0], [1, "aria-disabled", 0], [1, "aria-valuemax", 0], [1, "aria-valuemin", 0], [1, "aria-valuenow", 0], [1, "aria-orientation", 0], [2, "mat-slider-disabled", null], [2, "mat-slider-has-ticks", null], [2, "mat-slider-horizontal", null], [2, "mat-slider-axis-inverted", null], [2, "mat-slider-invert-mouse-coords", null], [2, "mat-slider-sliding", null], [2, "mat-slider-thumb-label-showing", null], [2, "mat-slider-vertical", null], [2, "mat-slider-min-value", null], [2, "mat-slider-hide-last-tick", null], [2, "_mat-animation-noopable", null]], [[null, "change"], [null, "focus"], [null, "blur"], [null, "mousedown"], [null, "keydown"], [null, "keyup"], [null, "mouseenter"], [null, "slide"], [null, "slideend"], [null, "slidestart"], [null, "selectstart"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("focus" === en)) {
                    var pd_0 = (nodeValue(_v, 25)._onFocus() !== false);
                    ad = (pd_0 && ad);
                }
                if (("blur" === en)) {
                    var pd_1 = (nodeValue(_v, 25)._onBlur() !== false);
                    ad = (pd_1 && ad);
                }
                if (("mousedown" === en)) {
                    var pd_2 = (nodeValue(_v, 25)._onMousedown($event) !== false);
                    ad = (pd_2 && ad);
                }
                if (("keydown" === en)) {
                    var pd_3 = (nodeValue(_v, 25)._onKeydown($event) !== false);
                    ad = (pd_3 && ad);
                }
                if (("keyup" === en)) {
                    var pd_4 = (nodeValue(_v, 25)._onKeyup() !== false);
                    ad = (pd_4 && ad);
                }
                if (("mouseenter" === en)) {
                    var pd_5 = (nodeValue(_v, 25)._onMouseenter() !== false);
                    ad = (pd_5 && ad);
                }
                if (("slide" === en)) {
                    var pd_6 = (nodeValue(_v, 25)._onSlide($event) !== false);
                    ad = (pd_6 && ad);
                }
                if (("slideend" === en)) {
                    var pd_7 = (nodeValue(_v, 25)._onSlideEnd() !== false);
                    ad = (pd_7 && ad);
                }
                if (("slidestart" === en)) {
                    var pd_8 = (nodeValue(_v, 25)._onSlideStart($event) !== false);
                    ad = (pd_8 && ad);
                }
                if (("selectstart" === en)) {
                    var pd_9 = ($event.preventDefault() !== false);
                    ad = (pd_9 && ad);
                }
                if (("change" === en)) {
                    var pd_10 = (_co.updateCount($event.value) !== false);
                    ad = (pd_10 && ad);
                }
                return ad;
            }, d$8, c$8)), providerDef(5120, null, NG_VALUE_ACCESSOR, function (p0_0) { return [p0_0]; }, [MatSlider]), directiveDef(25, 245760, null, 0, MatSlider, [ElementRef, FocusMonitor, ChangeDetectorRef, [2, Directionality], [8, null], [2, ANIMATION_MODULE_TYPE]], { max: [0, "max"], min: [1, "min"], step: [2, "step"], value: [3, "value"] }, { change: "change" }), (_l()(), elementDef(26, 0, [[1, 0], ["chart", 1]], null, 0, "div", [["class", "chart"]], null, null, null, null, null))], function (_ck, _v) { var _co = _v.component; var currVal_35 = "number"; var currVal_36 = _co.count; _ck(_v, 19, 0, currVal_35, currVal_36); var currVal_54 = _co.total; var currVal_55 = 1; var currVal_56 = 1; var currVal_57 = _co.count; _ck(_v, 25, 0, currVal_54, currVal_55, currVal_56, currVal_57); }, function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.count; _ck(_v, 3, 0, currVal_0); var currVal_1 = (nodeValue(_v, 8).appearance == "standard"); var currVal_2 = (nodeValue(_v, 8).appearance == "fill"); var currVal_3 = (nodeValue(_v, 8).appearance == "outline"); var currVal_4 = (nodeValue(_v, 8).appearance == "legacy"); var currVal_5 = nodeValue(_v, 8)._control.errorState; var currVal_6 = nodeValue(_v, 8)._canLabelFloat; var currVal_7 = nodeValue(_v, 8)._shouldLabelFloat(); var currVal_8 = nodeValue(_v, 8)._hasFloatingLabel(); var currVal_9 = nodeValue(_v, 8)._hideControlPlaceholder(); var currVal_10 = nodeValue(_v, 8)._control.disabled; var currVal_11 = nodeValue(_v, 8)._control.autofilled; var currVal_12 = nodeValue(_v, 8)._control.focused; var currVal_13 = (nodeValue(_v, 8).color == "accent"); var currVal_14 = (nodeValue(_v, 8).color == "warn"); var currVal_15 = nodeValue(_v, 8)._shouldForward("untouched"); var currVal_16 = nodeValue(_v, 8)._shouldForward("touched"); var currVal_17 = nodeValue(_v, 8)._shouldForward("pristine"); var currVal_18 = nodeValue(_v, 8)._shouldForward("dirty"); var currVal_19 = nodeValue(_v, 8)._shouldForward("valid"); var currVal_20 = nodeValue(_v, 8)._shouldForward("invalid"); var currVal_21 = nodeValue(_v, 8)._shouldForward("pending"); var currVal_22 = !nodeValue(_v, 8)._animationsEnabled; _ck(_v, 7, 1, [currVal_1, currVal_2, currVal_3, currVal_4, currVal_5, currVal_6, currVal_7, currVal_8, currVal_9, currVal_10, currVal_11, currVal_12, currVal_13, currVal_14, currVal_15, currVal_16, currVal_17, currVal_18, currVal_19, currVal_20, currVal_21, currVal_22]); var currVal_23 = 1; var currVal_24 = _co.total; var currVal_25 = 1; var currVal_26 = nodeValue(_v, 19)._isServer; var currVal_27 = nodeValue(_v, 19).id; var currVal_28 = nodeValue(_v, 19).placeholder; var currVal_29 = nodeValue(_v, 19).disabled; var currVal_30 = nodeValue(_v, 19).required; var currVal_31 = ((nodeValue(_v, 19).readonly && !nodeValue(_v, 19)._isNativeSelect) || null); var currVal_32 = (nodeValue(_v, 19)._ariaDescribedby || null); var currVal_33 = nodeValue(_v, 19).errorState; var currVal_34 = nodeValue(_v, 19).required.toString(); _ck(_v, 18, 1, [currVal_23, currVal_24, currVal_25, currVal_26, currVal_27, currVal_28, currVal_29, currVal_30, currVal_31, currVal_32, currVal_33, currVal_34]); var currVal_37 = nodeValue(_v, 25).tabIndex; var currVal_38 = nodeValue(_v, 25).disabled; var currVal_39 = nodeValue(_v, 25).max; var currVal_40 = nodeValue(_v, 25).min; var currVal_41 = nodeValue(_v, 25).value; var currVal_42 = (nodeValue(_v, 25).vertical ? "vertical" : "horizontal"); var currVal_43 = nodeValue(_v, 25).disabled; var currVal_44 = nodeValue(_v, 25).tickInterval; var currVal_45 = !nodeValue(_v, 25).vertical; var currVal_46 = nodeValue(_v, 25)._invertAxis; var currVal_47 = nodeValue(_v, 25)._shouldInvertMouseCoords(); var currVal_48 = nodeValue(_v, 25)._isSliding; var currVal_49 = nodeValue(_v, 25).thumbLabel; var currVal_50 = nodeValue(_v, 25).vertical; var currVal_51 = nodeValue(_v, 25)._isMinValue; var currVal_52 = (nodeValue(_v, 25).disabled || ((nodeValue(_v, 25)._isMinValue && nodeValue(_v, 25)._thumbGap) && nodeValue(_v, 25)._invertAxis)); var currVal_53 = (nodeValue(_v, 25)._animationMode === "NoopAnimations"); _ck(_v, 23, 1, [currVal_37, currVal_38, currVal_39, currVal_40, currVal_41, currVal_42, currVal_43, currVal_44, currVal_45, currVal_46, currVal_47, currVal_48, currVal_49, currVal_50, currVal_51, currVal_52, currVal_53]); });
    }
    function View_KernelStatsChart_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "kernel-stats-chart", [], null, null, null, View_KernelStatsChart_0, RenderType_KernelStatsChart)), directiveDef(1, 638976, null, 0, KernelStatsChart, [], null, null)], function (_ck, _v) { _ck(_v, 1, 0); }, null); }
    var KernelStatsChartNgFactory = createComponentFactory("kernel-stats-chart", KernelStatsChart, View_KernelStatsChart_Host_0, { kernelStatsData: "kernelStatsData" }, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$h = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}[_nghost-%COMP%]{display:block;padding:20px}mat-form-field[_ngcontent-%COMP%]{margin:0 8px}mat-icon[_ngcontent-%COMP%]{color:#777;vertical-align:bottom}.table[_ngcontent-%COMP%]{border:1px solid #eee}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_KernelStatsTable = [styles$h];
    var RenderType_KernelStatsTable = createRendererType2({ encapsulation: 0, styles: styles_KernelStatsTable, data: {} });
    function View_KernelStatsTable_0(_l) {
        return viewDef(0, [queryDef(671088640, 1, { tableRef: 0 }), (_l()(), elementDef(1, 0, null, null, 38, "div", [], null, null, null, null, null)), (_l()(), elementDef(2, 0, null, null, 1, "div", [["class", "mat-headline"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["GPU Kernels"])), (_l()(), elementDef(4, 0, null, null, 17, "mat-form-field", [["class", "mat-form-field"]], [[2, "mat-form-field-appearance-standard", null], [2, "mat-form-field-appearance-fill", null], [2, "mat-form-field-appearance-outline", null], [2, "mat-form-field-appearance-legacy", null], [2, "mat-form-field-invalid", null], [2, "mat-form-field-can-float", null], [2, "mat-form-field-should-float", null], [2, "mat-form-field-has-label", null], [2, "mat-form-field-hide-placeholder", null], [2, "mat-form-field-disabled", null], [2, "mat-form-field-autofilled", null], [2, "mat-focused", null], [2, "mat-accent", null], [2, "mat-warn", null], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [2, "_mat-animation-noopable", null]], null, null, d$1, c$1)), directiveDef(5, 7520256, null, 9, MatFormField, [ElementRef, ChangeDetectorRef, [2, MAT_LABEL_GLOBAL_OPTIONS], [2, Directionality], [2, MAT_FORM_FIELD_DEFAULT_OPTIONS], Platform, NgZone, [2, ANIMATION_MODULE_TYPE]], null, null), queryDef(603979776, 2, { _controlNonStatic: 0 }), queryDef(335544320, 3, { _controlStatic: 0 }), queryDef(603979776, 4, { _labelChildNonStatic: 0 }), queryDef(335544320, 5, { _labelChildStatic: 0 }), queryDef(603979776, 6, { _placeholderChild: 0 }), queryDef(603979776, 7, { _errorChildren: 1 }), queryDef(603979776, 8, { _hintChildren: 1 }), queryDef(603979776, 9, { _prefixChildren: 1 }), queryDef(603979776, 10, { _suffixChildren: 1 }), (_l()(), elementDef(15, 0, null, 1, 2, "input", [["class", "mat-input-element mat-form-field-autofill-control"], ["matInput", ""], ["placeholder", "Kernel Name"]], [[2, "mat-input-server", null], [1, "id", 0], [1, "placeholder", 0], [8, "disabled", 0], [8, "required", 0], [1, "readonly", 0], [1, "aria-describedby", 0], [1, "aria-invalid", 0], [1, "aria-required", 0]], [[null, "input"], [null, "blur"], [null, "focus"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("blur" === en)) {
                    var pd_0 = (nodeValue(_v, 16)._focusChanged(false) !== false);
                    ad = (pd_0 && ad);
                }
                if (("focus" === en)) {
                    var pd_1 = (nodeValue(_v, 16)._focusChanged(true) !== false);
                    ad = (pd_1 && ad);
                }
                if (("input" === en)) {
                    var pd_2 = (nodeValue(_v, 16)._onInput() !== false);
                    ad = (pd_2 && ad);
                }
                if (("input" === en)) {
                    _co.filterKernelName = $event.target.value;
                    var pd_3 = (_co.drawTable() !== false);
                    ad = (pd_3 && ad);
                }
                return ad;
            }, null, null)), directiveDef(16, 999424, null, 0, MatInput, [ElementRef, Platform, [8, null], [2, NgForm], [2, FormGroupDirective], ErrorStateMatcher, [8, null], AutofillMonitor, NgZone], { placeholder: [0, "placeholder"], value: [1, "value"] }, null), providerDef(2048, [[2, 4], [3, 4]], MatFormFieldControl, null, [MatInput]), (_l()(), elementDef(18, 0, null, 4, 3, "mat-icon", [["class", "mat-icon notranslate"], ["matSuffix", ""], ["role", "img"]], [[2, "mat-icon-inline", null], [2, "mat-icon-no-color", null]], null, null, d$5, c$5)), directiveDef(19, 16384, [[10, 4]], 0, MatSuffix, [], null, null), directiveDef(20, 9158656, null, 0, MatIcon, [ElementRef, MatIconRegistry, [8, null], [2, MAT_ICON_LOCATION], [2, ErrorHandler]], null, null), (_l()(), textDef(-1, 0, ["search"])), (_l()(), elementDef(22, 0, null, null, 17, "mat-form-field", [["class", "mat-form-field"]], [[2, "mat-form-field-appearance-standard", null], [2, "mat-form-field-appearance-fill", null], [2, "mat-form-field-appearance-outline", null], [2, "mat-form-field-appearance-legacy", null], [2, "mat-form-field-invalid", null], [2, "mat-form-field-can-float", null], [2, "mat-form-field-should-float", null], [2, "mat-form-field-has-label", null], [2, "mat-form-field-hide-placeholder", null], [2, "mat-form-field-disabled", null], [2, "mat-form-field-autofilled", null], [2, "mat-focused", null], [2, "mat-accent", null], [2, "mat-warn", null], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [2, "_mat-animation-noopable", null]], null, null, d$1, c$1)), directiveDef(23, 7520256, null, 9, MatFormField, [ElementRef, ChangeDetectorRef, [2, MAT_LABEL_GLOBAL_OPTIONS], [2, Directionality], [2, MAT_FORM_FIELD_DEFAULT_OPTIONS], Platform, NgZone, [2, ANIMATION_MODULE_TYPE]], null, null), queryDef(603979776, 11, { _controlNonStatic: 0 }), queryDef(335544320, 12, { _controlStatic: 0 }), queryDef(603979776, 13, { _labelChildNonStatic: 0 }), queryDef(335544320, 14, { _labelChildStatic: 0 }), queryDef(603979776, 15, { _placeholderChild: 0 }), queryDef(603979776, 16, { _errorChildren: 1 }), queryDef(603979776, 17, { _hintChildren: 1 }), queryDef(603979776, 18, { _prefixChildren: 1 }), queryDef(603979776, 19, { _suffixChildren: 1 }), (_l()(), elementDef(33, 0, null, 1, 2, "input", [["class", "mat-input-element mat-form-field-autofill-control"], ["matInput", ""], ["placeholder", "Op Name"]], [[2, "mat-input-server", null], [1, "id", 0], [1, "placeholder", 0], [8, "disabled", 0], [8, "required", 0], [1, "readonly", 0], [1, "aria-describedby", 0], [1, "aria-invalid", 0], [1, "aria-required", 0]], [[null, "input"], [null, "blur"], [null, "focus"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("blur" === en)) {
                    var pd_0 = (nodeValue(_v, 34)._focusChanged(false) !== false);
                    ad = (pd_0 && ad);
                }
                if (("focus" === en)) {
                    var pd_1 = (nodeValue(_v, 34)._focusChanged(true) !== false);
                    ad = (pd_1 && ad);
                }
                if (("input" === en)) {
                    var pd_2 = (nodeValue(_v, 34)._onInput() !== false);
                    ad = (pd_2 && ad);
                }
                if (("input" === en)) {
                    _co.filterOpName = $event.target.value;
                    var pd_3 = (_co.drawTable() !== false);
                    ad = (pd_3 && ad);
                }
                return ad;
            }, null, null)), directiveDef(34, 999424, null, 0, MatInput, [ElementRef, Platform, [8, null], [2, NgForm], [2, FormGroupDirective], ErrorStateMatcher, [8, null], AutofillMonitor, NgZone], { placeholder: [0, "placeholder"], value: [1, "value"] }, null), providerDef(2048, [[11, 4], [12, 4]], MatFormFieldControl, null, [MatInput]), (_l()(), elementDef(36, 0, null, 4, 3, "mat-icon", [["class", "mat-icon notranslate"], ["matSuffix", ""], ["role", "img"]], [[2, "mat-icon-inline", null], [2, "mat-icon-no-color", null]], null, null, d$5, c$5)), directiveDef(37, 16384, [[19, 4]], 0, MatSuffix, [], null, null), directiveDef(38, 9158656, null, 0, MatIcon, [ElementRef, MatIconRegistry, [8, null], [2, MAT_ICON_LOCATION], [2, ErrorHandler]], null, null), (_l()(), textDef(-1, 0, ["search"])), (_l()(), elementDef(40, 0, null, null, 0, "br", [], null, null, null, null, null)), (_l()(), elementDef(41, 0, null, null, 1, "div", [], null, null, null, null, null)), (_l()(), elementDef(42, 0, [[1, 0], ["table", 1]], null, 0, "div", [["class", "table"]], null, null, null, null, null))], function (_ck, _v) { var _co = _v.component; var currVal_31 = "Kernel Name"; var currVal_32 = _co.filterKernelName; _ck(_v, 16, 0, currVal_31, currVal_32); _ck(_v, 20, 0); var currVal_66 = "Op Name"; var currVal_67 = _co.filterOpName; _ck(_v, 34, 0, currVal_66, currVal_67); _ck(_v, 38, 0); }, function (_ck, _v) { var currVal_0 = (nodeValue(_v, 5).appearance == "standard"); var currVal_1 = (nodeValue(_v, 5).appearance == "fill"); var currVal_2 = (nodeValue(_v, 5).appearance == "outline"); var currVal_3 = (nodeValue(_v, 5).appearance == "legacy"); var currVal_4 = nodeValue(_v, 5)._control.errorState; var currVal_5 = nodeValue(_v, 5)._canLabelFloat; var currVal_6 = nodeValue(_v, 5)._shouldLabelFloat(); var currVal_7 = nodeValue(_v, 5)._hasFloatingLabel(); var currVal_8 = nodeValue(_v, 5)._hideControlPlaceholder(); var currVal_9 = nodeValue(_v, 5)._control.disabled; var currVal_10 = nodeValue(_v, 5)._control.autofilled; var currVal_11 = nodeValue(_v, 5)._control.focused; var currVal_12 = (nodeValue(_v, 5).color == "accent"); var currVal_13 = (nodeValue(_v, 5).color == "warn"); var currVal_14 = nodeValue(_v, 5)._shouldForward("untouched"); var currVal_15 = nodeValue(_v, 5)._shouldForward("touched"); var currVal_16 = nodeValue(_v, 5)._shouldForward("pristine"); var currVal_17 = nodeValue(_v, 5)._shouldForward("dirty"); var currVal_18 = nodeValue(_v, 5)._shouldForward("valid"); var currVal_19 = nodeValue(_v, 5)._shouldForward("invalid"); var currVal_20 = nodeValue(_v, 5)._shouldForward("pending"); var currVal_21 = !nodeValue(_v, 5)._animationsEnabled; _ck(_v, 4, 1, [currVal_0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5, currVal_6, currVal_7, currVal_8, currVal_9, currVal_10, currVal_11, currVal_12, currVal_13, currVal_14, currVal_15, currVal_16, currVal_17, currVal_18, currVal_19, currVal_20, currVal_21]); var currVal_22 = nodeValue(_v, 16)._isServer; var currVal_23 = nodeValue(_v, 16).id; var currVal_24 = nodeValue(_v, 16).placeholder; var currVal_25 = nodeValue(_v, 16).disabled; var currVal_26 = nodeValue(_v, 16).required; var currVal_27 = ((nodeValue(_v, 16).readonly && !nodeValue(_v, 16)._isNativeSelect) || null); var currVal_28 = (nodeValue(_v, 16)._ariaDescribedby || null); var currVal_29 = nodeValue(_v, 16).errorState; var currVal_30 = nodeValue(_v, 16).required.toString(); _ck(_v, 15, 0, currVal_22, currVal_23, currVal_24, currVal_25, currVal_26, currVal_27, currVal_28, currVal_29, currVal_30); var currVal_33 = nodeValue(_v, 20).inline; var currVal_34 = (((nodeValue(_v, 20).color !== "primary") && (nodeValue(_v, 20).color !== "accent")) && (nodeValue(_v, 20).color !== "warn")); _ck(_v, 18, 0, currVal_33, currVal_34); var currVal_35 = (nodeValue(_v, 23).appearance == "standard"); var currVal_36 = (nodeValue(_v, 23).appearance == "fill"); var currVal_37 = (nodeValue(_v, 23).appearance == "outline"); var currVal_38 = (nodeValue(_v, 23).appearance == "legacy"); var currVal_39 = nodeValue(_v, 23)._control.errorState; var currVal_40 = nodeValue(_v, 23)._canLabelFloat; var currVal_41 = nodeValue(_v, 23)._shouldLabelFloat(); var currVal_42 = nodeValue(_v, 23)._hasFloatingLabel(); var currVal_43 = nodeValue(_v, 23)._hideControlPlaceholder(); var currVal_44 = nodeValue(_v, 23)._control.disabled; var currVal_45 = nodeValue(_v, 23)._control.autofilled; var currVal_46 = nodeValue(_v, 23)._control.focused; var currVal_47 = (nodeValue(_v, 23).color == "accent"); var currVal_48 = (nodeValue(_v, 23).color == "warn"); var currVal_49 = nodeValue(_v, 23)._shouldForward("untouched"); var currVal_50 = nodeValue(_v, 23)._shouldForward("touched"); var currVal_51 = nodeValue(_v, 23)._shouldForward("pristine"); var currVal_52 = nodeValue(_v, 23)._shouldForward("dirty"); var currVal_53 = nodeValue(_v, 23)._shouldForward("valid"); var currVal_54 = nodeValue(_v, 23)._shouldForward("invalid"); var currVal_55 = nodeValue(_v, 23)._shouldForward("pending"); var currVal_56 = !nodeValue(_v, 23)._animationsEnabled; _ck(_v, 22, 1, [currVal_35, currVal_36, currVal_37, currVal_38, currVal_39, currVal_40, currVal_41, currVal_42, currVal_43, currVal_44, currVal_45, currVal_46, currVal_47, currVal_48, currVal_49, currVal_50, currVal_51, currVal_52, currVal_53, currVal_54, currVal_55, currVal_56]); var currVal_57 = nodeValue(_v, 34)._isServer; var currVal_58 = nodeValue(_v, 34).id; var currVal_59 = nodeValue(_v, 34).placeholder; var currVal_60 = nodeValue(_v, 34).disabled; var currVal_61 = nodeValue(_v, 34).required; var currVal_62 = ((nodeValue(_v, 34).readonly && !nodeValue(_v, 34)._isNativeSelect) || null); var currVal_63 = (nodeValue(_v, 34)._ariaDescribedby || null); var currVal_64 = nodeValue(_v, 34).errorState; var currVal_65 = nodeValue(_v, 34).required.toString(); _ck(_v, 33, 0, currVal_57, currVal_58, currVal_59, currVal_60, currVal_61, currVal_62, currVal_63, currVal_64, currVal_65); var currVal_68 = nodeValue(_v, 38).inline; var currVal_69 = (((nodeValue(_v, 38).color !== "primary") && (nodeValue(_v, 38).color !== "accent")) && (nodeValue(_v, 38).color !== "warn")); _ck(_v, 36, 0, currVal_68, currVal_69); });
    }
    function View_KernelStatsTable_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "kernel-stats-table", [], null, null, null, View_KernelStatsTable_0, RenderType_KernelStatsTable)), directiveDef(1, 638976, null, 0, KernelStatsTable, [], null, null)], function (_ck, _v) { _ck(_v, 1, 0); }, null); }
    var KernelStatsTableNgFactory = createComponentFactory("kernel-stats-table", KernelStatsTable, View_KernelStatsTable_Host_0, { kernelStatsData: "kernelStatsData" }, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_KernelStats = [styles$e];
    var RenderType_KernelStats = createRendererType2({ encapsulation: 0, styles: styles_KernelStats, data: {} });
    function View_KernelStats_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 11, "div", [["class", "section-container"]], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 6, "div", [["class", "row"]], null, null, null, null, null)), (_l()(), elementDef(2, 0, null, null, 2, "div", [], null, null, null, null, null)), (_l()(), elementDef(3, 0, null, null, 1, "div", [["class", "mat-headline"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["GPU Kernel Stats"])), (_l()(), elementDef(5, 0, null, null, 0, "div", [["class", "flex-space"]], null, null, null, null, null)), (_l()(), elementDef(6, 0, null, null, 1, "export-as-csv", [["tool", "kernel_stats"]], null, null, null, View_ExportAsCsv_0, RenderType_ExportAsCsv)), directiveDef(7, 49152, null, 0, ExportAsCsv, [Store], { tool: [0, "tool"] }, null), (_l()(), elementDef(8, 0, null, null, 3, "div", [], [[8, "className", 0]], null, null, null, null)), (_l()(), elementDef(9, 0, null, null, 0, "br", [], null, null, null, null, null)), (_l()(), elementDef(10, 0, null, null, 1, "kernel-stats-chart", [], null, null, null, View_KernelStatsChart_0, RenderType_KernelStatsChart)), directiveDef(11, 638976, null, 0, KernelStatsChart, [], { kernelStatsData: [0, "kernelStatsData"] }, null), (_l()(), elementDef(12, 0, null, null, 4, "div", [], [[8, "className", 0]], null, null, null, null)), (_l()(), elementDef(13, 0, null, null, 1, "mat-divider", [["class", "mat-divider"], ["role", "separator"]], [[1, "aria-orientation", 0], [2, "mat-divider-vertical", null], [2, "mat-divider-horizontal", null], [2, "mat-divider-inset", null]], null, null, d$7, c$7)), directiveDef(14, 49152, null, 0, MatDivider, [], null, null), (_l()(), elementDef(15, 0, null, null, 1, "kernel-stats-table", [], null, null, null, View_KernelStatsTable_0, RenderType_KernelStatsTable)), directiveDef(16, 638976, null, 0, KernelStatsTable, [], { kernelStatsData: [0, "kernelStatsData"] }, null), (_l()(), elementDef(17, 0, null, null, 1, "div", [["class", "section-container"]], [[8, "hidden", 0]], null, null, null, null)), (_l()(), textDef(-1, null, [" There is no GPU data to display because there were no kernels in the capture duration.\n"]))], function (_ck, _v) { var _co = _v.component; var currVal_0 = "kernel_stats"; _ck(_v, 7, 0, currVal_0); var currVal_2 = _co.data; _ck(_v, 11, 0, currVal_2); var currVal_8 = _co.data; _ck(_v, 16, 0, currVal_8); }, function (_ck, _v) { var _co = _v.component; var currVal_1 = (_co.hasDataRow ? "auto-height" : "hidden-content"); _ck(_v, 8, 0, currVal_1); var currVal_3 = (_co.hasDataRow ? "auto-height" : "hidden-content"); _ck(_v, 12, 0, currVal_3); var currVal_4 = (nodeValue(_v, 14).vertical ? "vertical" : "horizontal"); var currVal_5 = nodeValue(_v, 14).vertical; var currVal_6 = !nodeValue(_v, 14).vertical; var currVal_7 = nodeValue(_v, 14).inset; _ck(_v, 13, 0, currVal_4, currVal_5, currVal_6, currVal_7); var currVal_9 = _co.hasDataRow; _ck(_v, 17, 0, currVal_9); }); }
    function View_KernelStats_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "kernel-stats", [], null, null, null, View_KernelStats_0, RenderType_KernelStats)), directiveDef(1, 49152, null, 0, KernelStats, [Store], null, null)], null, null); }
    var KernelStatsNgFactory = createComponentFactory("kernel-stats", KernelStats, View_KernelStats_Host_0, {}, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var KernelStatsAdapterModuleNgFactory = createNgModuleFactory(KernelStatsAdapterModule, [], function (_l) { return moduleDef([moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [[8, []], [3, ComponentFactoryResolver], NgModuleRef]), moduleProvideDef(4608, NgLocalization, NgLocaleLocalization, [LOCALE_ID$1, [2, DEPRECATED_PLURAL_FN]]), moduleProvideDef(4608, MutationObserverFactory, MutationObserverFactory, []), moduleProvideDef(4608, ErrorStateMatcher, ErrorStateMatcher, []), moduleProvideDef(4608, HAMMER_GESTURE_CONFIG, GestureConfig, [[2, MAT_HAMMER_OPTIONS], [2, MatCommonModule]]), moduleProvideDef(1073742336, BidiModule, BidiModule, []), moduleProvideDef(1073742336, MatCommonModule, MatCommonModule, [[2, MATERIAL_SANITY_CHECKS], [2, HAMMER_LOADER]]), moduleProvideDef(1073742336, CommonModule, CommonModule, []), moduleProvideDef(1073742336, MatDividerModule, MatDividerModule, []), moduleProvideDef(1073742336, MatIconModule, MatIconModule, []), moduleProvideDef(1073742336, ExportAsCsvModule, ExportAsCsvModule, []), moduleProvideDef(1073742336, ObserversModule, ObserversModule, []), moduleProvideDef(1073742336, MatFormFieldModule, MatFormFieldModule, []), moduleProvideDef(1073742336, PlatformModule, PlatformModule, []), moduleProvideDef(1073742336, TextFieldModule, TextFieldModule, []), moduleProvideDef(1073742336, MatInputModule, MatInputModule, []), moduleProvideDef(1073742336, MatSliderModule, MatSliderModule, []), moduleProvideDef(1073742336, KernelStatsChartModule, KernelStatsChartModule, []), moduleProvideDef(1073742336, KernelStatsTableModule, KernelStatsTableModule, []), moduleProvideDef(1073742336, KernelStatsModule, KernelStatsModule, []), moduleProvideDef(1073742336, KernelStatsAdapterModule, KernelStatsAdapterModule, [])]); });
    var styles_KernelStatsAdapter = [];
    var RenderType_KernelStatsAdapter = createRendererType2({ encapsulation: 2, styles: styles_KernelStatsAdapter, data: {} });
    function View_KernelStatsAdapter_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "kernel-stats", [], null, null, null, View_KernelStats_0, RenderType_KernelStats)), directiveDef(1, 49152, null, 0, KernelStats, [Store], null, null)], null, null); }
    function View_KernelStatsAdapter_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "kernel-stats-adapter", [], null, null, null, View_KernelStatsAdapter_0, RenderType_KernelStatsAdapter)), directiveDef(1, 180224, null, 0, KernelStatsAdapter, [ActivatedRoute, Store], null, null)], null, null); }
    var KernelStatsAdapterNgFactory = createComponentFactory("kernel-stats-adapter", KernelStatsAdapter, View_KernelStatsAdapter_Host_0, {}, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$i = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}[_nghost-%COMP%]{display:block}mat-form-field[_ngcontent-%COMP%]{width:80px;margin-left:-10px}.error-message[_ngcontent-%COMP%]{color:red;font-size:.5cm;font-weight:bolder;margin-top:.5cm;margin-bottom:.5cm;text-align:center}.container[_ngcontent-%COMP%]{display:flex;flex-wrap:wrap;width:100%}.left-column[_ngcontent-%COMP%]{display:flex;flex-direction:column;width:33.333%}.right-column[_ngcontent-%COMP%]{display:flex;flex-direction:column;width:66.667%}.full-column[_ngcontent-%COMP%]{border-right:1px solid #eee;width:100%}@media screen and (max-width: 860px){[_nghost-%COMP%]{width:fit-content}}@media screen and (max-width: 1140px){.left-column[_ngcontent-%COMP%], .right-column[_ngcontent-%COMP%]{width:100%}}.mat-subheading-2[_ngcontent-%COMP%]{padding-left:10px;margin-top:10px;margin-bottom:0}.mat-form-field[_ngcontent-%COMP%]{padding-left:10px}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$j = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}[_nghost-%COMP%]{border-bottom:1px solid #eee;border-right:1px solid #eee;flex-grow:1}mat-card[_ngcontent-%COMP%]{box-shadow:none !important;margin:8px;height:calc(100% - 48px)}@media screen and (max-width: 1140px){mat-card[_ngcontent-%COMP%]{min-width:500px}}mat-card-title[_ngcontent-%COMP%]{background-color:#fff;border-top-left-radius:4px;border-top-right-radius:4px;color:#000;font-size:24px;font-weight:400;margin-bottom:25px}[_nghost-%COMP%]     b{font-weight:500}ul[_ngcontent-%COMP%]{list-style-position:outside;margin-top:-16px;padding-inline-start:20px}[_nghost-%COMP%]     .item-container{margin-bottom:16px}[_nghost-%COMP%]     .item-container>table{border-spacing:0;width:100%}[_nghost-%COMP%]     .item-container>td{padding:0}[_nghost-%COMP%]     .item-value{padding-left:0px;min-width:100px;width:20%;font-size:18px;font-weight:500}.flops-utilization-tooltip-target[_ngcontent-%COMP%]{color:#e8710a;border-bottom:1px dotted #e8710a}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_MemoryProfileSummary = [styles$j];
    var RenderType_MemoryProfileSummary = createRendererType2({ encapsulation: 0, styles: styles_MemoryProfileSummary, data: {} });
    function View_MemoryProfileSummary_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 67, "mat-card", [["class", "mat-card"]], [[2, "_mat-animation-noopable", null]], null, null, d$6, c$6)), directiveDef(1, 49152, null, 0, MatCard, [[2, ANIMATION_MODULE_TYPE]], null, null), (_l()(), elementDef(2, 0, null, 0, 2, "mat-card-title", [["class", "mat-card-title"]], null, null, null, null, null)), directiveDef(3, 16384, null, 0, MatCardTitle, [], null, null), (_l()(), textDef(4, null, ["", ""])), (_l()(), elementDef(5, 0, null, 0, 62, "mat-card-content", [["class", "mat-card-content"]], null, null, null, null, null)), directiveDef(6, 16384, null, 0, MatCardContent, [], null, null), ngContentDef(null, 0), (_l()(), elementDef(8, 0, null, null, 8, "div", [["class", "item-container"]], null, null, null, null, null)), (_l()(), elementDef(9, 0, null, null, 7, "table", [], null, null, null, null, null)), (_l()(), elementDef(10, 0, null, null, 6, "tr", [], null, null, null, null, null)), (_l()(), elementDef(11, 0, null, null, 2, "td", [], null, null, null, null, null)), (_l()(), elementDef(12, 0, null, null, 1, "b", [], null, null, null, null, null)), (_l()(), textDef(-1, null, ["#Allocation"])), (_l()(), elementDef(14, 0, null, null, 2, "td", [["class", "item-value"]], null, null, null, null, null)), (_l()(), elementDef(15, 0, null, null, 1, "div", [], null, null, null, null, null)), (_l()(), textDef(16, null, ["", ""])), (_l()(), elementDef(17, 0, null, null, 8, "div", [["class", "item-container"]], null, null, null, null, null)), (_l()(), elementDef(18, 0, null, null, 7, "table", [], null, null, null, null, null)), (_l()(), elementDef(19, 0, null, null, 6, "tr", [], null, null, null, null, null)), (_l()(), elementDef(20, 0, null, null, 2, "td", [], null, null, null, null, null)), (_l()(), elementDef(21, 0, null, null, 1, "b", [], null, null, null, null, null)), (_l()(), textDef(-1, null, ["#Deallocation"])), (_l()(), elementDef(23, 0, null, null, 2, "td", [["class", "item-value"]], null, null, null, null, null)), (_l()(), elementDef(24, 0, null, null, 1, "div", [], null, null, null, null, null)), (_l()(), textDef(25, null, ["", ""])), (_l()(), elementDef(26, 0, null, null, 8, "div", [["class", "item-container"]], null, null, null, null, null)), (_l()(), elementDef(27, 0, null, null, 7, "table", [], null, null, null, null, null)), (_l()(), elementDef(28, 0, null, null, 6, "tr", [], null, null, null, null, null)), (_l()(), elementDef(29, 0, null, null, 2, "td", [], null, null, null, null, null)), (_l()(), elementDef(30, 0, null, null, 1, "b", [], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Memory Capacity"])), (_l()(), elementDef(32, 0, null, null, 2, "td", [["class", "item-value"]], null, null, null, null, null)), (_l()(), elementDef(33, 0, null, null, 1, "div", [], null, null, null, null, null)), (_l()(), textDef(34, null, ["", ""])), (_l()(), elementDef(35, 0, null, null, 10, "div", [["class", "item-container"]], null, null, null, null, null)), (_l()(), elementDef(36, 0, null, null, 9, "table", [], null, null, null, null, null)), (_l()(), elementDef(37, 0, null, null, 8, "tr", [], null, null, null, null, null)), (_l()(), elementDef(38, 0, null, null, 4, "td", [], null, null, null, null, null)), (_l()(), elementDef(39, 0, null, null, 1, "b", [], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Peak Heap Usage"])), (_l()(), elementDef(41, 0, null, null, 1, "div", [["class", "description"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["high water mark in lifetime"])), (_l()(), elementDef(43, 0, null, null, 2, "td", [["class", "item-value"]], null, null, null, null, null)), (_l()(), elementDef(44, 0, null, null, 1, "div", [], null, null, null, null, null)), (_l()(), textDef(45, null, ["", ""])), (_l()(), elementDef(46, 0, null, null, 10, "div", [["class", "item-container"]], null, null, null, null, null)), (_l()(), elementDef(47, 0, null, null, 9, "table", [], null, null, null, null, null)), (_l()(), elementDef(48, 0, null, null, 8, "tr", [], null, null, null, null, null)), (_l()(), elementDef(49, 0, null, null, 4, "td", [], null, null, null, null, null)), (_l()(), elementDef(50, 0, null, null, 1, "b", [], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Peak Memory Usage"])), (_l()(), elementDef(52, 0, null, null, 1, "div", [["class", "description"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["stack + heap, within profiling window"])), (_l()(), elementDef(54, 0, null, null, 2, "td", [["class", "item-value"]], null, null, null, null, null)), (_l()(), elementDef(55, 0, null, null, 1, "div", [], null, null, null, null, null)), (_l()(), textDef(56, null, ["", " "])), (_l()(), elementDef(57, 0, null, null, 10, "ul", [], null, null, null, null, null)), (_l()(), elementDef(58, 0, null, null, 1, "li", [["class", "primary-content"]], null, null, null, null, null)), (_l()(), textDef(59, null, ["Timestamp: ", " ms"])), (_l()(), elementDef(60, 0, null, null, 1, "li", [["class", "primary-content"]], null, null, null, null, null)), (_l()(), textDef(61, null, ["Stack Reservation: ", ""])), (_l()(), elementDef(62, 0, null, null, 1, "li", [["class", "primary-content"]], null, null, null, null, null)), (_l()(), textDef(63, null, ["Heap Allocation: ", " "])), (_l()(), elementDef(64, 0, null, null, 1, "li", [["class", "primary-content"]], null, null, null, null, null)), (_l()(), textDef(65, null, ["Free Memory: ", " "])), (_l()(), elementDef(66, 0, null, null, 1, "li", [["class", "primary-content"]], null, null, null, null, null)), (_l()(), textDef(67, null, ["Fragmentation: ", ""]))], null, function (_ck, _v) { var _co = _v.component; var currVal_0 = (nodeValue(_v, 1)._animationMode === "NoopAnimations"); _ck(_v, 0, 0, currVal_0); var currVal_1 = _co.title; _ck(_v, 4, 0, currVal_1); var currVal_2 = _co.numAllocations; _ck(_v, 16, 0, currVal_2); var currVal_3 = _co.numDeallocations; _ck(_v, 25, 0, currVal_3); var currVal_4 = _co.memoryCapacity; _ck(_v, 34, 0, currVal_4); var currVal_5 = _co.peakHeapUsageLifetime; _ck(_v, 45, 0, currVal_5); var currVal_6 = _co.peakMemUsageProfile; _ck(_v, 56, 0, currVal_6); var currVal_7 = _co.timestampAtPeakMs; _ck(_v, 59, 0, currVal_7); var currVal_8 = _co.stackAtPeak; _ck(_v, 61, 0, currVal_8); var currVal_9 = _co.heapAtPeak; _ck(_v, 63, 0, currVal_9); var currVal_10 = _co.freeAtPeak; _ck(_v, 65, 0, currVal_10); var currVal_11 = _co.fragmentationAtPeakPct; _ck(_v, 67, 0, currVal_11); }); }
    function View_MemoryProfileSummary_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "memory-profile-summary", [], null, null, null, View_MemoryProfileSummary_0, RenderType_MemoryProfileSummary)), directiveDef(1, 4767744, null, 0, MemoryProfileSummary, [ChangeDetectorRef], null, null)], null, null); }
    var MemoryProfileSummaryNgFactory = createComponentFactory("memory-profile-summary", MemoryProfileSummary, View_MemoryProfileSummary_Host_0, { data: "data", memoryId: "memoryId" }, {}, ["*"]);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$k = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}[_nghost-%COMP%]{border-bottom:1px solid #eee;border-right:1px solid #eee;flex-grow:1}mat-card[_ngcontent-%COMP%]{box-shadow:none !important;margin:8px;height:calc(100% - 48px)}@media screen and (max-width: 1140px){mat-card[_ngcontent-%COMP%]{min-width:500px}}mat-card-title[_ngcontent-%COMP%]{background-color:#fff;border-top-left-radius:4px;border-top-right-radius:4px;color:#000;font-size:24px;font-weight:400}.chart[_ngcontent-%COMP%]{margin:0 auto;max-width:1500px}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_MemoryTimelineGraph = [styles$k];
    var RenderType_MemoryTimelineGraph = createRendererType2({ encapsulation: 0, styles: styles_MemoryTimelineGraph, data: {} });
    function View_MemoryTimelineGraph_0(_l) { return viewDef(0, [queryDef(671088640, 1, { chartRef: 0 }), (_l()(), elementDef(1, 0, null, null, 9, "mat-card", [["class", "mat-card"]], [[2, "_mat-animation-noopable", null]], null, null, d$6, c$6)), directiveDef(2, 49152, null, 0, MatCard, [[2, ANIMATION_MODULE_TYPE]], null, null), (_l()(), elementDef(3, 0, null, 0, 2, "mat-card-title", [["class", "mat-card-title"]], null, null, null, null, null)), directiveDef(4, 16384, null, 0, MatCardTitle, [], null, null), (_l()(), textDef(5, null, ["", ""])), (_l()(), elementDef(6, 0, null, 0, 4, "mat-card-content", [["class", "mat-card-content"]], null, null, null, null, null)), directiveDef(7, 16384, null, 0, MatCardContent, [], null, null), (_l()(), elementDef(8, 0, null, null, 1, "div", [], [[4, "display", null]], null, null, null, null)), (_l()(), textDef(-1, null, [" Tips: Zoom in: left click and drag; Zoom out: right click; Metadata: click on heap data point. "])), (_l()(), elementDef(10, 0, [[1, 0], ["chart", 1]], null, 0, "div", [["class", "chart"]], [[4, "height", null]], null, null, null, null))], null, function (_ck, _v) { var _co = _v.component; var currVal_0 = (nodeValue(_v, 2)._animationMode === "NoopAnimations"); _ck(_v, 1, 0, currVal_0); var currVal_1 = _co.title; _ck(_v, 5, 0, currVal_1); var currVal_2 = true; _ck(_v, 8, 0, currVal_2); var currVal_3 = (_co.height + "px"); _ck(_v, 10, 0, currVal_3); }); }
    function View_MemoryTimelineGraph_Host_0(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "memory-timeline-graph", [], null, [["window", "resize"]], function (_v, en, $event) {
                var ad = true;
                if (("window:resize" === en)) {
                    var pd_0 = (nodeValue(_v, 1).onResize() !== false);
                    ad = (pd_0 && ad);
                }
                return ad;
            }, View_MemoryTimelineGraph_0, RenderType_MemoryTimelineGraph)), directiveDef(1, 4767744, null, 0, MemoryTimelineGraph, [], null, null)], null, null);
    }
    var MemoryTimelineGraphNgFactory = createComponentFactory("memory-timeline-graph", MemoryTimelineGraph, View_MemoryTimelineGraph_Host_0, { memoryProfileProtoOrNull: "memoryProfileProtoOrNull", memoryId: "memoryId" }, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$l = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}[_nghost-%COMP%]{display:block;padding:20px}mat-form-field[_ngcontent-%COMP%]{margin:0 8px}mat-icon[_ngcontent-%COMP%]{color:#777;vertical-align:bottom}.table[_ngcontent-%COMP%]{margin:0 -20px}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_MemoryBreakdownTable = [styles$l];
    var RenderType_MemoryBreakdownTable = createRendererType2({ encapsulation: 0, styles: styles_MemoryBreakdownTable, data: {} });
    function View_MemoryBreakdownTable_0(_l) {
        return viewDef(0, [queryDef(671088640, 1, { tableRef: 0 }), (_l()(), elementDef(1, 0, null, null, 20, "div", [], null, null, null, null, null)), (_l()(), elementDef(2, 0, null, null, 1, "div", [["class", "mat-headline"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Memory Breakdown Table"])), (_l()(), elementDef(4, 0, null, null, 17, "mat-form-field", [["class", "mat-form-field"]], [[2, "mat-form-field-appearance-standard", null], [2, "mat-form-field-appearance-fill", null], [2, "mat-form-field-appearance-outline", null], [2, "mat-form-field-appearance-legacy", null], [2, "mat-form-field-invalid", null], [2, "mat-form-field-can-float", null], [2, "mat-form-field-should-float", null], [2, "mat-form-field-has-label", null], [2, "mat-form-field-hide-placeholder", null], [2, "mat-form-field-disabled", null], [2, "mat-form-field-autofilled", null], [2, "mat-focused", null], [2, "mat-accent", null], [2, "mat-warn", null], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [2, "_mat-animation-noopable", null]], null, null, d$1, c$1)), directiveDef(5, 7520256, null, 9, MatFormField, [ElementRef, ChangeDetectorRef, [2, MAT_LABEL_GLOBAL_OPTIONS], [2, Directionality], [2, MAT_FORM_FIELD_DEFAULT_OPTIONS], Platform, NgZone, [2, ANIMATION_MODULE_TYPE]], null, null), queryDef(603979776, 2, { _controlNonStatic: 0 }), queryDef(335544320, 3, { _controlStatic: 0 }), queryDef(603979776, 4, { _labelChildNonStatic: 0 }), queryDef(335544320, 5, { _labelChildStatic: 0 }), queryDef(603979776, 6, { _placeholderChild: 0 }), queryDef(603979776, 7, { _errorChildren: 1 }), queryDef(603979776, 8, { _hintChildren: 1 }), queryDef(603979776, 9, { _prefixChildren: 1 }), queryDef(603979776, 10, { _suffixChildren: 1 }), (_l()(), elementDef(15, 0, null, 1, 2, "input", [["class", "mat-input-element mat-form-field-autofill-control"], ["matInput", ""], ["placeholder", "Operation"]], [[2, "mat-input-server", null], [1, "id", 0], [1, "placeholder", 0], [8, "disabled", 0], [8, "required", 0], [1, "readonly", 0], [1, "aria-describedby", 0], [1, "aria-invalid", 0], [1, "aria-required", 0]], [[null, "input"], [null, "blur"], [null, "focus"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("blur" === en)) {
                    var pd_0 = (nodeValue(_v, 16)._focusChanged(false) !== false);
                    ad = (pd_0 && ad);
                }
                if (("focus" === en)) {
                    var pd_1 = (nodeValue(_v, 16)._focusChanged(true) !== false);
                    ad = (pd_1 && ad);
                }
                if (("input" === en)) {
                    var pd_2 = (nodeValue(_v, 16)._onInput() !== false);
                    ad = (pd_2 && ad);
                }
                if (("input" === en)) {
                    _co.filterOperation = $event.target.value;
                    var pd_3 = (_co.drawTable() !== false);
                    ad = (pd_3 && ad);
                }
                return ad;
            }, null, null)), directiveDef(16, 999424, null, 0, MatInput, [ElementRef, Platform, [8, null], [2, NgForm], [2, FormGroupDirective], ErrorStateMatcher, [8, null], AutofillMonitor, NgZone], { placeholder: [0, "placeholder"], value: [1, "value"] }, null), providerDef(2048, [[2, 4], [3, 4]], MatFormFieldControl, null, [MatInput]), (_l()(), elementDef(18, 0, null, 4, 3, "mat-icon", [["class", "mat-icon notranslate"], ["matSuffix", ""], ["role", "img"]], [[2, "mat-icon-inline", null], [2, "mat-icon-no-color", null]], null, null, d$5, c$5)), directiveDef(19, 16384, [[10, 4]], 0, MatSuffix, [], null, null), directiveDef(20, 9158656, null, 0, MatIcon, [ElementRef, MatIconRegistry, [8, null], [2, MAT_ICON_LOCATION], [2, ErrorHandler]], null, null), (_l()(), textDef(-1, 0, ["search"])), (_l()(), elementDef(22, 0, null, null, 1, "div", [], [[4, "display", null]], null, null, null, null)), (_l()(), textDef(-1, null, [" Note: Showing active memory allocations at peak usage within the profiling window. To avoid sluggishness, only the allocations with size over 1MiB are shown in the table below.\n"])), (_l()(), elementDef(24, 0, null, null, 0, "br", [], null, null, null, null, null)), (_l()(), elementDef(25, 0, null, null, 1, "div", [], null, null, null, null, null)), (_l()(), elementDef(26, 0, [[1, 0], ["table", 1]], null, 0, "div", [["class", "table"]], null, null, null, null, null))], function (_ck, _v) { var _co = _v.component; var currVal_31 = "Operation"; var currVal_32 = _co.filterOperation; _ck(_v, 16, 0, currVal_31, currVal_32); _ck(_v, 20, 0); }, function (_ck, _v) { var currVal_0 = (nodeValue(_v, 5).appearance == "standard"); var currVal_1 = (nodeValue(_v, 5).appearance == "fill"); var currVal_2 = (nodeValue(_v, 5).appearance == "outline"); var currVal_3 = (nodeValue(_v, 5).appearance == "legacy"); var currVal_4 = nodeValue(_v, 5)._control.errorState; var currVal_5 = nodeValue(_v, 5)._canLabelFloat; var currVal_6 = nodeValue(_v, 5)._shouldLabelFloat(); var currVal_7 = nodeValue(_v, 5)._hasFloatingLabel(); var currVal_8 = nodeValue(_v, 5)._hideControlPlaceholder(); var currVal_9 = nodeValue(_v, 5)._control.disabled; var currVal_10 = nodeValue(_v, 5)._control.autofilled; var currVal_11 = nodeValue(_v, 5)._control.focused; var currVal_12 = (nodeValue(_v, 5).color == "accent"); var currVal_13 = (nodeValue(_v, 5).color == "warn"); var currVal_14 = nodeValue(_v, 5)._shouldForward("untouched"); var currVal_15 = nodeValue(_v, 5)._shouldForward("touched"); var currVal_16 = nodeValue(_v, 5)._shouldForward("pristine"); var currVal_17 = nodeValue(_v, 5)._shouldForward("dirty"); var currVal_18 = nodeValue(_v, 5)._shouldForward("valid"); var currVal_19 = nodeValue(_v, 5)._shouldForward("invalid"); var currVal_20 = nodeValue(_v, 5)._shouldForward("pending"); var currVal_21 = !nodeValue(_v, 5)._animationsEnabled; _ck(_v, 4, 1, [currVal_0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5, currVal_6, currVal_7, currVal_8, currVal_9, currVal_10, currVal_11, currVal_12, currVal_13, currVal_14, currVal_15, currVal_16, currVal_17, currVal_18, currVal_19, currVal_20, currVal_21]); var currVal_22 = nodeValue(_v, 16)._isServer; var currVal_23 = nodeValue(_v, 16).id; var currVal_24 = nodeValue(_v, 16).placeholder; var currVal_25 = nodeValue(_v, 16).disabled; var currVal_26 = nodeValue(_v, 16).required; var currVal_27 = ((nodeValue(_v, 16).readonly && !nodeValue(_v, 16)._isNativeSelect) || null); var currVal_28 = (nodeValue(_v, 16)._ariaDescribedby || null); var currVal_29 = nodeValue(_v, 16).errorState; var currVal_30 = nodeValue(_v, 16).required.toString(); _ck(_v, 15, 0, currVal_22, currVal_23, currVal_24, currVal_25, currVal_26, currVal_27, currVal_28, currVal_29, currVal_30); var currVal_33 = nodeValue(_v, 20).inline; var currVal_34 = (((nodeValue(_v, 20).color !== "primary") && (nodeValue(_v, 20).color !== "accent")) && (nodeValue(_v, 20).color !== "warn")); _ck(_v, 18, 0, currVal_33, currVal_34); var currVal_35 = true; _ck(_v, 22, 0, currVal_35); });
    }
    function View_MemoryBreakdownTable_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "memory-breakdown-table", [], null, null, null, View_MemoryBreakdownTable_0, RenderType_MemoryBreakdownTable)), directiveDef(1, 638976, null, 0, MemoryBreakdownTable, [], null, null)], function (_ck, _v) { _ck(_v, 1, 0); }, null); }
    var MemoryBreakdownTableNgFactory = createComponentFactory("memory-breakdown-table", MemoryBreakdownTable, View_MemoryBreakdownTable_Host_0, { memoryProfileData: "memoryProfileData", memoryId: "memoryId" }, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_MemoryProfile = [styles$i];
    var RenderType_MemoryProfile = createRendererType2({ encapsulation: 0, styles: styles_MemoryProfile, data: {} });
    function View_MemoryProfile_1(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 2, "mat-option", [["class", "mat-option"], ["role", "option"]], [[1, "tabindex", 0], [2, "mat-selected", null], [2, "mat-option-multiple", null], [2, "mat-active", null], [8, "id", 0], [1, "aria-selected", 0], [1, "aria-disabled", 0], [2, "mat-option-disabled", null]], [[null, "click"], [null, "keydown"]], function (_v, en, $event) {
                var ad = true;
                if (("click" === en)) {
                    var pd_0 = (nodeValue(_v, 1)._selectViaInteraction() !== false);
                    ad = (pd_0 && ad);
                }
                if (("keydown" === en)) {
                    var pd_1 = (nodeValue(_v, 1)._handleKeydown($event) !== false);
                    ad = (pd_1 && ad);
                }
                return ad;
            }, j$1, i)), directiveDef(1, 8568832, [[10, 4]], 0, MatOption, [ElementRef, ChangeDetectorRef, [2, MAT_OPTION_PARENT_COMPONENT], [2, MatOptgroup]], { value: [0, "value"] }, null), (_l()(), textDef(2, 0, [" ", " "]))], function (_ck, _v) { var currVal_8 = _v.context.$implicit; _ck(_v, 1, 0, currVal_8); }, function (_ck, _v) { var currVal_0 = nodeValue(_v, 1)._getTabIndex(); var currVal_1 = nodeValue(_v, 1).selected; var currVal_2 = nodeValue(_v, 1).multiple; var currVal_3 = nodeValue(_v, 1).active; var currVal_4 = nodeValue(_v, 1).id; var currVal_5 = nodeValue(_v, 1)._getAriaSelected(); var currVal_6 = nodeValue(_v, 1).disabled.toString(); var currVal_7 = nodeValue(_v, 1).disabled; _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5, currVal_6, currVal_7); var currVal_9 = _v.context.$implicit; _ck(_v, 2, 0, currVal_9); });
    }
    function View_MemoryProfile_0(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 42, "div", [], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 1, "div", [["class", "error-message"]], [[8, "hidden", 0]], null, null, null, null)), (_l()(), textDef(-1, null, [" There is no memory profile to display because there were no memory activity data in the captured duration. "])), (_l()(), elementDef(3, 0, null, null, 39, "div", [], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(4, 0, null, null, 38, "div", [["class", "container"]], null, null, null, null, null)), (_l()(), elementDef(5, 0, null, null, 31, "div", [["class", "left-column"]], null, null, null, null, null)), (_l()(), elementDef(6, 0, null, null, 30, "memory-profile-summary", [], null, null, null, View_MemoryProfileSummary_0, RenderType_MemoryProfileSummary)), directiveDef(7, 4767744, null, 0, MemoryProfileSummary, [ChangeDetectorRef], { data: [0, "data"], memoryId: [1, "memoryId"] }, null), (_l()(), elementDef(8, 0, null, 0, 28, "div", [["class", "item-container"]], null, null, null, null, null)), (_l()(), elementDef(9, 0, null, null, 27, "table", [], null, null, null, null, null)), (_l()(), elementDef(10, 0, null, null, 26, "tr", [], null, null, null, null, null)), (_l()(), elementDef(11, 0, null, null, 4, "td", [], null, null, null, null, null)), (_l()(), elementDef(12, 0, null, null, 1, "b", [], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Memory ID"])), (_l()(), elementDef(14, 0, null, null, 1, "div", [["class", "description"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["show memory profile for selected device"])), (_l()(), elementDef(16, 0, null, null, 20, "td", [["class", "item-value"]], null, null, null, null, null)), (_l()(), elementDef(17, 0, null, null, 19, "mat-form-field", [["class", "mat-form-field"]], [[2, "mat-form-field-appearance-standard", null], [2, "mat-form-field-appearance-fill", null], [2, "mat-form-field-appearance-outline", null], [2, "mat-form-field-appearance-legacy", null], [2, "mat-form-field-invalid", null], [2, "mat-form-field-can-float", null], [2, "mat-form-field-should-float", null], [2, "mat-form-field-has-label", null], [2, "mat-form-field-hide-placeholder", null], [2, "mat-form-field-disabled", null], [2, "mat-form-field-autofilled", null], [2, "mat-focused", null], [2, "mat-accent", null], [2, "mat-warn", null], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [2, "_mat-animation-noopable", null]], null, null, d$1, c$1)), directiveDef(18, 7520256, null, 9, MatFormField, [ElementRef, ChangeDetectorRef, [2, MAT_LABEL_GLOBAL_OPTIONS], [2, Directionality], [2, MAT_FORM_FIELD_DEFAULT_OPTIONS], Platform, NgZone, [2, ANIMATION_MODULE_TYPE]], null, null), queryDef(603979776, 1, { _controlNonStatic: 0 }), queryDef(335544320, 2, { _controlStatic: 0 }), queryDef(603979776, 3, { _labelChildNonStatic: 0 }), queryDef(335544320, 4, { _labelChildStatic: 0 }), queryDef(603979776, 5, { _placeholderChild: 0 }), queryDef(603979776, 6, { _errorChildren: 1 }), queryDef(603979776, 7, { _hintChildren: 1 }), queryDef(603979776, 8, { _prefixChildren: 1 }), queryDef(603979776, 9, { _suffixChildren: 1 }), (_l()(), elementDef(28, 0, null, 1, 8, "mat-select", [["class", "mat-select"], ["role", "listbox"]], [[1, "id", 0], [1, "tabindex", 0], [1, "aria-label", 0], [1, "aria-labelledby", 0], [1, "aria-required", 0], [1, "aria-disabled", 0], [1, "aria-invalid", 0], [1, "aria-owns", 0], [1, "aria-multiselectable", 0], [1, "aria-describedby", 0], [1, "aria-activedescendant", 0], [2, "mat-select-disabled", null], [2, "mat-select-invalid", null], [2, "mat-select-required", null], [2, "mat-select-empty", null]], [[null, "valueChange"], [null, "keydown"], [null, "focus"], [null, "blur"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("keydown" === en)) {
                    var pd_0 = (nodeValue(_v, 30)._handleKeydown($event) !== false);
                    ad = (pd_0 && ad);
                }
                if (("focus" === en)) {
                    var pd_1 = (nodeValue(_v, 30)._onFocus() !== false);
                    ad = (pd_1 && ad);
                }
                if (("blur" === en)) {
                    var pd_2 = (nodeValue(_v, 30)._onBlur() !== false);
                    ad = (pd_2 && ad);
                }
                if (("valueChange" === en)) {
                    var pd_3 = ((_co.selectedMemoryId = $event) !== false);
                    ad = (pd_3 && ad);
                }
                return ad;
            }, d$3, c$3)), providerDef(6144, null, MAT_OPTION_PARENT_COMPONENT, null, [MatSelect]), directiveDef(30, 2080768, null, 3, MatSelect, [ViewportRuler, ChangeDetectorRef, NgZone, ErrorStateMatcher, ElementRef, [2, Directionality], [2, NgForm], [2, FormGroupDirective], [2, MatFormField], [8, null], [8, null], MAT_SELECT_SCROLL_STRATEGY, LiveAnnouncer], { value: [0, "value"] }, { valueChange: "valueChange" }), queryDef(603979776, 10, { options: 1 }), queryDef(603979776, 11, { optionGroups: 1 }), queryDef(603979776, 12, { customTrigger: 0 }), providerDef(2048, [[1, 4], [2, 4]], MatFormFieldControl, null, [MatSelect]), (_l()(), anchorDef(16777216, null, 1, 1, null, View_MemoryProfile_1)), directiveDef(36, 278528, null, 0, NgForOf, [ViewContainerRef, TemplateRef, IterableDiffers], { ngForOf: [0, "ngForOf"] }, null), (_l()(), elementDef(37, 0, null, null, 2, "div", [["class", "right-column"]], null, null, null, null, null)), (_l()(), elementDef(38, 0, null, null, 1, "memory-timeline-graph", [], null, [["window", "resize"]], function (_v, en, $event) {
                var ad = true;
                if (("window:resize" === en)) {
                    var pd_0 = (nodeValue(_v, 39).onResize() !== false);
                    ad = (pd_0 && ad);
                }
                return ad;
            }, View_MemoryTimelineGraph_0, RenderType_MemoryTimelineGraph)), directiveDef(39, 4767744, null, 0, MemoryTimelineGraph, [], { memoryProfileProtoOrNull: [0, "memoryProfileProtoOrNull"], memoryId: [1, "memoryId"] }, null), (_l()(), elementDef(40, 0, null, null, 2, "div", [["class", "full-column"]], null, null, null, null, null)), (_l()(), elementDef(41, 0, null, null, 1, "memory-breakdown-table", [], null, null, null, View_MemoryBreakdownTable_0, RenderType_MemoryBreakdownTable)), directiveDef(42, 638976, null, 0, MemoryBreakdownTable, [], { memoryProfileData: [0, "memoryProfileData"], memoryId: [1, "memoryId"] }, null)], function (_ck, _v) { var _co = _v.component; var currVal_2 = _co.data; var currVal_3 = _co.selectedMemoryId; _ck(_v, 7, 0, currVal_2, currVal_3); var currVal_41 = _co.selectedMemoryId; _ck(_v, 30, 0, currVal_41); var currVal_42 = _co.memoryIds; _ck(_v, 36, 0, currVal_42); var currVal_43 = _co.data; var currVal_44 = _co.selectedMemoryId; _ck(_v, 39, 0, currVal_43, currVal_44); var currVal_45 = _co.data; var currVal_46 = _co.selectedMemoryId; _ck(_v, 42, 0, currVal_45, currVal_46); }, function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.hasMemoryData; _ck(_v, 1, 0, currVal_0); var currVal_1 = !_co.hasMemoryData; _ck(_v, 3, 0, currVal_1); var currVal_4 = (nodeValue(_v, 18).appearance == "standard"); var currVal_5 = (nodeValue(_v, 18).appearance == "fill"); var currVal_6 = (nodeValue(_v, 18).appearance == "outline"); var currVal_7 = (nodeValue(_v, 18).appearance == "legacy"); var currVal_8 = nodeValue(_v, 18)._control.errorState; var currVal_9 = nodeValue(_v, 18)._canLabelFloat; var currVal_10 = nodeValue(_v, 18)._shouldLabelFloat(); var currVal_11 = nodeValue(_v, 18)._hasFloatingLabel(); var currVal_12 = nodeValue(_v, 18)._hideControlPlaceholder(); var currVal_13 = nodeValue(_v, 18)._control.disabled; var currVal_14 = nodeValue(_v, 18)._control.autofilled; var currVal_15 = nodeValue(_v, 18)._control.focused; var currVal_16 = (nodeValue(_v, 18).color == "accent"); var currVal_17 = (nodeValue(_v, 18).color == "warn"); var currVal_18 = nodeValue(_v, 18)._shouldForward("untouched"); var currVal_19 = nodeValue(_v, 18)._shouldForward("touched"); var currVal_20 = nodeValue(_v, 18)._shouldForward("pristine"); var currVal_21 = nodeValue(_v, 18)._shouldForward("dirty"); var currVal_22 = nodeValue(_v, 18)._shouldForward("valid"); var currVal_23 = nodeValue(_v, 18)._shouldForward("invalid"); var currVal_24 = nodeValue(_v, 18)._shouldForward("pending"); var currVal_25 = !nodeValue(_v, 18)._animationsEnabled; _ck(_v, 17, 1, [currVal_4, currVal_5, currVal_6, currVal_7, currVal_8, currVal_9, currVal_10, currVal_11, currVal_12, currVal_13, currVal_14, currVal_15, currVal_16, currVal_17, currVal_18, currVal_19, currVal_20, currVal_21, currVal_22, currVal_23, currVal_24, currVal_25]); var currVal_26 = nodeValue(_v, 30).id; var currVal_27 = nodeValue(_v, 30).tabIndex; var currVal_28 = nodeValue(_v, 30)._getAriaLabel(); var currVal_29 = nodeValue(_v, 30)._getAriaLabelledby(); var currVal_30 = nodeValue(_v, 30).required.toString(); var currVal_31 = nodeValue(_v, 30).disabled.toString(); var currVal_32 = nodeValue(_v, 30).errorState; var currVal_33 = (nodeValue(_v, 30).panelOpen ? nodeValue(_v, 30)._optionIds : null); var currVal_34 = nodeValue(_v, 30).multiple; var currVal_35 = (nodeValue(_v, 30)._ariaDescribedby || null); var currVal_36 = nodeValue(_v, 30)._getAriaActiveDescendant(); var currVal_37 = nodeValue(_v, 30).disabled; var currVal_38 = nodeValue(_v, 30).errorState; var currVal_39 = nodeValue(_v, 30).required; var currVal_40 = nodeValue(_v, 30).empty; _ck(_v, 28, 1, [currVal_26, currVal_27, currVal_28, currVal_29, currVal_30, currVal_31, currVal_32, currVal_33, currVal_34, currVal_35, currVal_36, currVal_37, currVal_38, currVal_39, currVal_40]); });
    }
    function View_MemoryProfile_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "memory-profile", [], null, null, null, View_MemoryProfile_0, RenderType_MemoryProfile)), directiveDef(1, 180224, null, 0, MemoryProfile, [ActivatedRoute, DataService, Store], null, null)], null, null); }
    var MemoryProfileNgFactory = createComponentFactory("memory-profile", MemoryProfile, View_MemoryProfile_Host_0, {}, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$m = [""];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$n = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}[_nghost-%COMP%]{display:block}.section-container[_ngcontent-%COMP%]{padding:20px}.sub-title[_ngcontent-%COMP%]{font-weight:500}.control-title[_ngcontent-%COMP%]{color:#5f6368;margin-bottom:5px}.row[_ngcontent-%COMP%]{display:flex}.flex-space[_ngcontent-%COMP%]{flex:1}.control[_ngcontent-%COMP%]{padding:20}"];
    var _MatCheckboxRequiredValidatorModuleNgFactory = createNgModuleFactory(_MatCheckboxRequiredValidatorModule, [], function (_l) {
        return moduleDef([
            moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [
                [
                    8,
                    []
                ],
                [
                    3,
                    ComponentFactoryResolver
                ],
                NgModuleRef
            ]),
            moduleProvideDef(1073742336, _MatCheckboxRequiredValidatorModule, _MatCheckboxRequiredValidatorModule, [])
        ]);
    });
    var MatCheckboxModuleNgFactory = createNgModuleFactory(MatCheckboxModule, [], function (_l) {
        return moduleDef([
            moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [
                [
                    8,
                    []
                ],
                [
                    3,
                    ComponentFactoryResolver
                ],
                NgModuleRef
            ]),
            moduleProvideDef(4608, NgLocalization, NgLocaleLocalization, [
                LOCALE_ID$1,
                [
                    2,
                    DEPRECATED_PLURAL_FN
                ]
            ]),
            moduleProvideDef(4608, MutationObserverFactory, MutationObserverFactory, []),
            moduleProvideDef(1073742336, CommonModule, CommonModule, []),
            moduleProvideDef(1073742336, BidiModule, BidiModule, []),
            moduleProvideDef(1073742336, MatCommonModule, MatCommonModule, [
                [
                    2,
                    MATERIAL_SANITY_CHECKS
                ],
                [
                    2,
                    HAMMER_LOADER
                ]
            ]),
            moduleProvideDef(1073742336, PlatformModule, PlatformModule, []),
            moduleProvideDef(1073742336, MatRippleModule, MatRippleModule, []),
            moduleProvideDef(1073742336, ObserversModule, ObserversModule, []),
            moduleProvideDef(1073742336, _MatCheckboxRequiredValidatorModule, _MatCheckboxRequiredValidatorModule, []),
            moduleProvideDef(1073742336, MatCheckboxModule, MatCheckboxModule, [])
        ]);
    });
    var styles_MatCheckbox = ['@keyframes mat-checkbox-fade-in-background{0%{opacity:0}50%{opacity:1}}@keyframes mat-checkbox-fade-out-background{0%,50%{opacity:1}100%{opacity:0}}@keyframes mat-checkbox-unchecked-checked-checkmark-path{0%,50%{stroke-dashoffset:22.91026}50%{animation-timing-function:cubic-bezier(0,0,.2,.1)}100%{stroke-dashoffset:0}}@keyframes mat-checkbox-unchecked-indeterminate-mixedmark{0%,68.2%{transform:scaleX(0)}68.2%{animation-timing-function:cubic-bezier(0,0,0,1)}100%{transform:scaleX(1)}}@keyframes mat-checkbox-checked-unchecked-checkmark-path{from{animation-timing-function:cubic-bezier(.4,0,1,1);stroke-dashoffset:0}to{stroke-dashoffset:-22.91026}}@keyframes mat-checkbox-checked-indeterminate-checkmark{from{animation-timing-function:cubic-bezier(0,0,.2,.1);opacity:1;transform:rotate(0)}to{opacity:0;transform:rotate(45deg)}}@keyframes mat-checkbox-indeterminate-checked-checkmark{from{animation-timing-function:cubic-bezier(.14,0,0,1);opacity:0;transform:rotate(45deg)}to{opacity:1;transform:rotate(360deg)}}@keyframes mat-checkbox-checked-indeterminate-mixedmark{from{animation-timing-function:cubic-bezier(0,0,.2,.1);opacity:0;transform:rotate(-45deg)}to{opacity:1;transform:rotate(0)}}@keyframes mat-checkbox-indeterminate-checked-mixedmark{from{animation-timing-function:cubic-bezier(.14,0,0,1);opacity:1;transform:rotate(0)}to{opacity:0;transform:rotate(315deg)}}@keyframes mat-checkbox-indeterminate-unchecked-mixedmark{0%{animation-timing-function:linear;opacity:1;transform:scaleX(1)}100%,32.8%{opacity:0;transform:scaleX(0)}}.mat-checkbox-background,.mat-checkbox-frame{top:0;left:0;right:0;bottom:0;position:absolute;border-radius:2px;box-sizing:border-box;pointer-events:none}.mat-checkbox{transition:background .4s cubic-bezier(.25,.8,.25,1),box-shadow 280ms cubic-bezier(.4,0,.2,1);cursor:pointer;-webkit-tap-highlight-color:transparent}._mat-animation-noopable.mat-checkbox{transition:none;animation:none}.mat-checkbox .mat-ripple-element:not(.mat-checkbox-persistent-ripple){opacity:.16}.mat-checkbox-layout{-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:inherit;align-items:baseline;vertical-align:middle;display:inline-flex;white-space:nowrap}.mat-checkbox-label{-webkit-user-select:auto;-moz-user-select:auto;-ms-user-select:auto;user-select:auto}.mat-checkbox-inner-container{display:inline-block;height:16px;line-height:0;margin:auto;margin-right:8px;order:0;position:relative;vertical-align:middle;white-space:nowrap;width:16px;flex-shrink:0}[dir=rtl] .mat-checkbox-inner-container{margin-left:8px;margin-right:auto}.mat-checkbox-inner-container-no-side-margin{margin-left:0;margin-right:0}.mat-checkbox-frame{background-color:transparent;transition:border-color 90ms cubic-bezier(0,0,.2,.1);border-width:2px;border-style:solid}._mat-animation-noopable .mat-checkbox-frame{transition:none}@media (-ms-high-contrast:active){.mat-checkbox.cdk-keyboard-focused .mat-checkbox-frame{border-style:dotted}}.mat-checkbox-background{align-items:center;display:inline-flex;justify-content:center;transition:background-color 90ms cubic-bezier(0,0,.2,.1),opacity 90ms cubic-bezier(0,0,.2,.1)}._mat-animation-noopable .mat-checkbox-background{transition:none}.mat-checkbox-persistent-ripple{width:100%;height:100%;transform:none}.mat-checkbox-inner-container:hover .mat-checkbox-persistent-ripple{opacity:.04}.mat-checkbox.cdk-keyboard-focused .mat-checkbox-persistent-ripple{opacity:.12}.mat-checkbox-persistent-ripple,.mat-checkbox.mat-checkbox-disabled .mat-checkbox-inner-container:hover .mat-checkbox-persistent-ripple{opacity:0}@media (hover:none){.mat-checkbox-inner-container:hover .mat-checkbox-persistent-ripple{display:none}}.mat-checkbox-checkmark{top:0;left:0;right:0;bottom:0;position:absolute;width:100%}.mat-checkbox-checkmark-path{stroke-dashoffset:22.91026;stroke-dasharray:22.91026;stroke-width:2.13333px}.mat-checkbox-mixedmark{width:calc(100% - 6px);height:2px;opacity:0;transform:scaleX(0) rotate(0);border-radius:2px}@media (-ms-high-contrast:active){.mat-checkbox-mixedmark{height:0;border-top:solid 2px;margin-top:2px}}.mat-checkbox-label-before .mat-checkbox-inner-container{order:1;margin-left:8px;margin-right:auto}[dir=rtl] .mat-checkbox-label-before .mat-checkbox-inner-container{margin-left:auto;margin-right:8px}.mat-checkbox-checked .mat-checkbox-checkmark{opacity:1}.mat-checkbox-checked .mat-checkbox-checkmark-path{stroke-dashoffset:0}.mat-checkbox-checked .mat-checkbox-mixedmark{transform:scaleX(1) rotate(-45deg)}.mat-checkbox-indeterminate .mat-checkbox-checkmark{opacity:0;transform:rotate(45deg)}.mat-checkbox-indeterminate .mat-checkbox-checkmark-path{stroke-dashoffset:0}.mat-checkbox-indeterminate .mat-checkbox-mixedmark{opacity:1;transform:scaleX(1) rotate(0)}.mat-checkbox-unchecked .mat-checkbox-background{background-color:transparent}.mat-checkbox-disabled{cursor:default}.mat-checkbox-anim-unchecked-checked .mat-checkbox-background{animation:180ms linear 0s mat-checkbox-fade-in-background}.mat-checkbox-anim-unchecked-checked .mat-checkbox-checkmark-path{animation:180ms linear 0s mat-checkbox-unchecked-checked-checkmark-path}.mat-checkbox-anim-unchecked-indeterminate .mat-checkbox-background{animation:180ms linear 0s mat-checkbox-fade-in-background}.mat-checkbox-anim-unchecked-indeterminate .mat-checkbox-mixedmark{animation:90ms linear 0s mat-checkbox-unchecked-indeterminate-mixedmark}.mat-checkbox-anim-checked-unchecked .mat-checkbox-background{animation:180ms linear 0s mat-checkbox-fade-out-background}.mat-checkbox-anim-checked-unchecked .mat-checkbox-checkmark-path{animation:90ms linear 0s mat-checkbox-checked-unchecked-checkmark-path}.mat-checkbox-anim-checked-indeterminate .mat-checkbox-checkmark{animation:90ms linear 0s mat-checkbox-checked-indeterminate-checkmark}.mat-checkbox-anim-checked-indeterminate .mat-checkbox-mixedmark{animation:90ms linear 0s mat-checkbox-checked-indeterminate-mixedmark}.mat-checkbox-anim-indeterminate-checked .mat-checkbox-checkmark{animation:.5s linear 0s mat-checkbox-indeterminate-checked-checkmark}.mat-checkbox-anim-indeterminate-checked .mat-checkbox-mixedmark{animation:.5s linear 0s mat-checkbox-indeterminate-checked-mixedmark}.mat-checkbox-anim-indeterminate-unchecked .mat-checkbox-background{animation:180ms linear 0s mat-checkbox-fade-out-background}.mat-checkbox-anim-indeterminate-unchecked .mat-checkbox-mixedmark{animation:.3s linear 0s mat-checkbox-indeterminate-unchecked-mixedmark}.mat-checkbox-input{bottom:0;left:50%}.mat-checkbox .mat-checkbox-ripple{position:absolute;left:calc(50% - 20px);top:calc(50% - 20px);height:40px;width:40px;z-index:1;pointer-events:none}'];
    var RenderType_MatCheckbox = createRendererType2({
        encapsulation: 2,
        styles: styles_MatCheckbox,
        data: {}
    });
    function View_MatCheckbox_0(_l) {
        return viewDef(2, [
            queryDef(671088640, 1, { _inputElement: 0 }),
            queryDef(671088640, 2, { ripple: 0 }),
            (_l()(), elementDef(2, 0, [[
                    'label',
                    1
                ]], null, 16, 'label', [[
                    'class',
                    'mat-checkbox-layout'
                ]], [[
                    1,
                    'for',
                    0
                ]], null, null, null, null)),
            (_l()(), elementDef(3, 0, null, null, 10, 'div', [[
                    'class',
                    'mat-checkbox-inner-container'
                ]], [[
                    2,
                    'mat-checkbox-inner-container-no-side-margin',
                    null
                ]], null, null, null, null)),
            (_l()(), elementDef(4, 0, [
                [
                    1,
                    0
                ],
                [
                    'input',
                    1
                ]
            ], null, 0, 'input', [
                [
                    'class',
                    'mat-checkbox-input cdk-visually-hidden'
                ],
                [
                    'type',
                    'checkbox'
                ]
            ], [
                [
                    8,
                    'id',
                    0
                ],
                [
                    8,
                    'required',
                    0
                ],
                [
                    8,
                    'checked',
                    0
                ],
                [
                    1,
                    'value',
                    0
                ],
                [
                    8,
                    'disabled',
                    0
                ],
                [
                    1,
                    'name',
                    0
                ],
                [
                    8,
                    'tabIndex',
                    0
                ],
                [
                    8,
                    'indeterminate',
                    0
                ],
                [
                    1,
                    'aria-label',
                    0
                ],
                [
                    1,
                    'aria-labelledby',
                    0
                ],
                [
                    1,
                    'aria-checked',
                    0
                ]
            ], [
                [
                    null,
                    'change'
                ],
                [
                    null,
                    'click'
                ]
            ], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if ('change' === en) {
                    var pd_0 = _co._onInteractionEvent($event) !== false;
                    ad = pd_0 && ad;
                }
                if ('click' === en) {
                    var pd_1 = _co._onInputClick($event) !== false;
                    ad = pd_1 && ad;
                }
                return ad;
            }, null, null)),
            (_l()(), elementDef(5, 0, null, null, 3, 'div', [
                [
                    'class',
                    'mat-checkbox-ripple mat-ripple'
                ],
                [
                    'matRipple',
                    ''
                ]
            ], [[
                    2,
                    'mat-ripple-unbounded',
                    null
                ]], null, null, null, null)),
            directiveDef(6, 212992, [[
                    2,
                    4
                ]], 0, MatRipple, [
                ElementRef,
                NgZone,
                Platform,
                [
                    2,
                    MAT_RIPPLE_GLOBAL_OPTIONS
                ],
                [
                    2,
                    ANIMATION_MODULE_TYPE
                ]
            ], {
                centered: [
                    0,
                    'centered'
                ],
                radius: [
                    1,
                    'radius'
                ],
                animation: [
                    2,
                    'animation'
                ],
                disabled: [
                    3,
                    'disabled'
                ],
                trigger: [
                    4,
                    'trigger'
                ]
            }, null),
            pureObjectDef(7, { enterDuration: 0 }),
            (_l()(), elementDef(8, 0, null, null, 0, 'div', [[
                    'class',
                    'mat-ripple-element mat-checkbox-persistent-ripple'
                ]], null, null, null, null, null)),
            (_l()(), elementDef(9, 0, null, null, 0, 'div', [[
                    'class',
                    'mat-checkbox-frame'
                ]], null, null, null, null, null)),
            (_l()(), elementDef(10, 0, null, null, 3, 'div', [[
                    'class',
                    'mat-checkbox-background'
                ]], null, null, null, null, null)),
            (_l()(), elementDef(11, 0, null, null, 1, ':svg:svg', [
                [
                    ':xml:space',
                    'preserve'
                ],
                [
                    'class',
                    'mat-checkbox-checkmark'
                ],
                [
                    'focusable',
                    'false'
                ],
                [
                    'version',
                    '1.1'
                ],
                [
                    'viewBox',
                    '0 0 24 24'
                ]
            ], null, null, null, null, null)),
            (_l()(), elementDef(12, 0, null, null, 0, ':svg:path', [
                [
                    'class',
                    'mat-checkbox-checkmark-path'
                ],
                [
                    'd',
                    'M4.1,12.7 9,17.6 20.3,6.3'
                ],
                [
                    'fill',
                    'none'
                ],
                [
                    'stroke',
                    'white'
                ]
            ], null, null, null, null, null)),
            (_l()(), elementDef(13, 0, null, null, 0, 'div', [[
                    'class',
                    'mat-checkbox-mixedmark'
                ]], null, null, null, null, null)),
            (_l()(), elementDef(14, 0, [[
                    'checkboxLabel',
                    1
                ]], null, 4, 'span', [[
                    'class',
                    'mat-checkbox-label'
                ]], null, [[
                    null,
                    'cdkObserveContent'
                ]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if ('cdkObserveContent' === en) {
                    var pd_0 = _co._onLabelTextChange() !== false;
                    ad = pd_0 && ad;
                }
                return ad;
            }, null, null)),
            directiveDef(15, 1196032, null, 0, CdkObserveContent, [
                ContentObserver,
                ElementRef,
                NgZone
            ], null, { event: 'cdkObserveContent' }),
            (_l()(), elementDef(16, 0, null, null, 1, 'span', [[
                    'style',
                    'display:none'
                ]], null, null, null, null, null)),
            (_l()(), textDef(-1, null, ['\xA0'])),
            ngContentDef(null, 0)
        ], function (_ck, _v) {
            var _co = _v.component;
            var currVal_14 = true;
            var currVal_15 = 20;
            var currVal_16 = _ck(_v, 7, 0, 150);
            var currVal_17 = _co._isRippleDisabled();
            var currVal_18 = nodeValue(_v, 2);
            _ck(_v, 6, 0, currVal_14, currVal_15, currVal_16, currVal_17, currVal_18);
        }, function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co.inputId;
            _ck(_v, 2, 0, currVal_0);
            var currVal_1 = !nodeValue(_v, 14).textContent || !nodeValue(_v, 14).textContent.trim();
            _ck(_v, 3, 0, currVal_1);
            var currVal_2 = _co.inputId;
            var currVal_3 = _co.required;
            var currVal_4 = _co.checked;
            var currVal_5 = _co.value;
            var currVal_6 = _co.disabled;
            var currVal_7 = _co.name;
            var currVal_8 = _co.tabIndex;
            var currVal_9 = _co.indeterminate;
            var currVal_10 = _co.ariaLabel || null;
            var currVal_11 = _co.ariaLabelledby;
            var currVal_12 = _co._getAriaChecked();
            _ck(_v, 4, 1, [
                currVal_2,
                currVal_3,
                currVal_4,
                currVal_5,
                currVal_6,
                currVal_7,
                currVal_8,
                currVal_9,
                currVal_10,
                currVal_11,
                currVal_12
            ]);
            var currVal_13 = nodeValue(_v, 6).unbounded;
            _ck(_v, 5, 0, currVal_13);
        });
    }
    function View_MatCheckbox_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 2, 'mat-checkbox', [[
                    'class',
                    'mat-checkbox'
                ]], [
                [
                    8,
                    'id',
                    0
                ],
                [
                    1,
                    'tabindex',
                    0
                ],
                [
                    2,
                    'mat-checkbox-indeterminate',
                    null
                ],
                [
                    2,
                    'mat-checkbox-checked',
                    null
                ],
                [
                    2,
                    'mat-checkbox-disabled',
                    null
                ],
                [
                    2,
                    'mat-checkbox-label-before',
                    null
                ],
                [
                    2,
                    '_mat-animation-noopable',
                    null
                ]
            ], null, null, View_MatCheckbox_0, RenderType_MatCheckbox)),
            providerDef(5120, null, NG_VALUE_ACCESSOR, function (p0_0) {
                return [p0_0];
            }, [MatCheckbox]),
            directiveDef(2, 8568832, null, 0, MatCheckbox, [
                ElementRef,
                ChangeDetectorRef,
                FocusMonitor,
                NgZone,
                [
                    8,
                    null
                ],
                [
                    2,
                    MAT_CHECKBOX_CLICK_ACTION
                ],
                [
                    2,
                    ANIMATION_MODULE_TYPE
                ]
            ], null, null)
        ], null, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 2).id;
            var currVal_1 = null;
            var currVal_2 = nodeValue(_v, 2).indeterminate;
            var currVal_3 = nodeValue(_v, 2).checked;
            var currVal_4 = nodeValue(_v, 2).disabled;
            var currVal_5 = nodeValue(_v, 2).labelPosition == 'before';
            var currVal_6 = nodeValue(_v, 2)._animationMode === 'NoopAnimations';
            _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5, currVal_6);
        });
    }
    var MatCheckboxNgFactory = createComponentFactory('mat-checkbox', MatCheckbox, View_MatCheckbox_Host_0, {
        disableRipple: 'disableRipple',
        color: 'color',
        tabIndex: 'tabIndex',
        ariaLabel: 'aria-label',
        ariaLabelledby: 'aria-labelledby',
        id: 'id',
        required: 'required',
        labelPosition: 'labelPosition',
        name: 'name',
        value: 'value',
        checked: 'checked',
        disabled: 'disabled',
        indeterminate: 'indeterminate'
    }, {
        change: 'change',
        indeterminateChange: 'indeterminateChange'
    }, ['*']);
    var d$9 = RenderType_MatCheckbox;
    var e = View_MatCheckbox_0;
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$o = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}[_nghost-%COMP%]{display:block;margin:20px}.chart-container[_ngcontent-%COMP%]{position:relative;width:1200px;height:380px}.chart[_ngcontent-%COMP%]{position:absolute;top:0;left:0;width:1200px;height:380px}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_ProgramOrderChart = [styles$o];
    var RenderType_ProgramOrderChart = createRendererType2({ encapsulation: 0, styles: styles_ProgramOrderChart, data: {} });
    function View_ProgramOrderChart_0(_l) { return viewDef(0, [queryDef(671088640, 1, { activeChartRef: 0 }), queryDef(671088640, 2, { chartRef: 0 }), queryDef(671088640, 3, { peakChartRef: 0 }), (_l()(), elementDef(3, 0, null, null, 6, "div", [], [[8, "className", 0]], null, null, null, null)), (_l()(), elementDef(4, 0, null, null, 1, "div", [["class", "mat-headline"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Working Space Size (MiB) vs Program Order (HLO Sequence)"])), (_l()(), elementDef(6, 0, null, null, 3, "div", [["class", "chart-container"]], null, null, null, null, null)), (_l()(), elementDef(7, 0, [[3, 0], ["peakChart", 1]], null, 0, "div", [["class", "chart"]], null, null, null, null, null)), (_l()(), elementDef(8, 0, [[2, 0], ["chart", 1]], null, 0, "div", [["class", "chart"]], null, null, null, null, null)), (_l()(), elementDef(9, 0, [[1, 0], ["activeChart", 1]], null, 0, "div", [["class", "chart"]], null, null, null, null, null))], null, function (_ck, _v) { var _co = _v.component; var currVal_0 = (_co.heapSizes.length ? "auto-height" : "hidden-content"); _ck(_v, 3, 0, currVal_0); }); }
    function View_ProgramOrderChart_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "program-order-chart", [], null, null, null, View_ProgramOrderChart_0, RenderType_ProgramOrderChart)), directiveDef(1, 638976, null, 0, ProgramOrderChart, [], null, null)], function (_ck, _v) { _ck(_v, 1, 0); }, null); }
    var ProgramOrderChartNgFactory = createComponentFactory("program-order-chart", ProgramOrderChart, View_ProgramOrderChart_Host_0, { heapSizes: "heapSizes", unpaddedHeapSizes: "unpaddedHeapSizes", peakInfo: "peakInfo", activeInfo: "activeInfo" }, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$p = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}[_nghost-%COMP%]{display:block;margin:20px}.description[_ngcontent-%COMP%]{margin-top:-16px}.chart[_ngcontent-%COMP%]{margin-top:24px;width:1200px;height:100px}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_MaxHeapChart = [styles$p];
    var RenderType_MaxHeapChart = createRendererType2({ encapsulation: 0, styles: styles_MaxHeapChart, data: {} });
    function View_MaxHeapChart_0(_l) { return viewDef(0, [queryDef(671088640, 1, { chartRef: 0 }), (_l()(), elementDef(1, 0, null, null, 5, "div", [], [[8, "className", 0]], null, null, null, null)), (_l()(), elementDef(2, 0, null, null, 1, "div", [["class", "mat-headline"]], null, null, null, null, null)), (_l()(), textDef(3, null, ["", " (", ")"])), (_l()(), elementDef(4, 0, null, null, 1, "div", [["class", "description"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Hover over a bar for buffer details to appear on the left."])), (_l()(), elementDef(6, 0, [[1, 0], ["chart", 1]], null, 0, "div", [["class", "chart"]], null, null, null, null, null))], null, function (_ck, _v) { var _co = _v.component; var currVal_0 = (_co.maxHeap.length ? "auto-height" : "hidden-content"); _ck(_v, 1, 0, currVal_0); var currVal_1 = _co.title; var currVal_2 = ((_co.maxHeap == null) ? null : _co.maxHeap.length); _ck(_v, 3, 0, currVal_1, currVal_2); }); }
    function View_MaxHeapChart_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "max-heap-chart", [], null, null, null, View_MaxHeapChart_0, RenderType_MaxHeapChart)), directiveDef(1, 638976, null, 0, MaxHeapChart, [], null, null)], function (_ck, _v) { _ck(_v, 1, 0); }, null); }
    var MaxHeapChartNgFactory = createComponentFactory("max-heap-chart", MaxHeapChart, View_MaxHeapChart_Host_0, { maxHeap: "maxHeap", title: "title", selectedIndex: "selectedIndex" }, { selected: "selected" }, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_MemoryViewerMain = [styles$n];
    var RenderType_MemoryViewerMain = createRendererType2({ encapsulation: 0, styles: styles_MemoryViewerMain, data: {} });
    function View_MemoryViewerMain_0(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "diagnostics-view", [], null, null, null, View_DiagnosticsView_0, RenderType_DiagnosticsView)), directiveDef(1, 49152, null, 0, DiagnosticsView, [], { diagnostics: [0, "diagnostics"] }, null), (_l()(), elementDef(2, 0, null, null, 22, "div", [["class", "section-container"]], null, null, null, null, null)), (_l()(), elementDef(3, 0, null, null, 21, "div", [["class", "row"]], null, null, null, null, null)), (_l()(), elementDef(4, 0, null, null, 8, "div", [], null, null, null, null, null)), (_l()(), elementDef(5, 0, null, null, 1, "div", [["class", "mat-headline"]], null, null, null, null, null)), (_l()(), textDef(6, null, ["Module name: ", ""])), (_l()(), elementDef(7, 0, null, null, 1, "div", [["class", "sub-title"]], null, null, null, null, null)), (_l()(), textDef(8, null, ["Peak memory allocation is ", " MiB"])), (_l()(), elementDef(9, 0, null, null, 1, "div", [["class", "description"]], [[8, "hidden", 0]], null, null, null, null)), (_l()(), textDef(10, null, [" (", " MiB without padding) "])), (_l()(), elementDef(11, 0, null, null, 1, "div", [["class", "description"]], null, null, null, null, null)), (_l()(), textDef(-1, null, [" Modifying your model's architecture, batch size and data dimensions may help reduce the memory footprint. "])), (_l()(), elementDef(13, 0, null, null, 11, "div", [["class", "control"]], null, null, null, null, null)), (_l()(), elementDef(14, 0, null, null, 10, "mat-checkbox", [["class", "mat-checkbox"]], [[8, "id", 0], [1, "tabindex", 0], [2, "mat-checkbox-indeterminate", null], [2, "mat-checkbox-checked", null], [2, "mat-checkbox-disabled", null], [2, "mat-checkbox-label-before", null], [2, "_mat-animation-noopable", null], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null]], [[null, "ngModelChange"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("ngModelChange" === en)) {
                    var pd_0 = ((_co.includeNotSimulated = $event) !== false);
                    ad = (pd_0 && ad);
                }
                if (("ngModelChange" === en)) {
                    var pd_1 = (_co.update() !== false);
                    ad = (pd_1 && ad);
                }
                return ad;
            }, e, d$9)), directiveDef(15, 8568832, null, 0, MatCheckbox, [ElementRef, ChangeDetectorRef, FocusMonitor, NgZone, [8, null], [2, MAT_CHECKBOX_CLICK_ACTION], [2, ANIMATION_MODULE_TYPE]], null, null), providerDef(1024, null, NG_VALUE_ACCESSOR, function (p0_0) { return [p0_0]; }, [MatCheckbox]), directiveDef(17, 671744, null, 0, NgModel, [[8, null], [8, null], [8, null], [6, NG_VALUE_ACCESSOR]], { model: [0, "model"] }, { update: "ngModelChange" }), providerDef(2048, null, NgControl, null, [NgModel]), directiveDef(19, 16384, null, 0, NgControlStatus, [[4, NgControl]], null, null), (_l()(), textDef(-1, 0, [" Include not simulated "])), (_l()(), elementDef(21, 16777216, null, 0, 3, "mat-icon", [["class", "tooltip-icon mat-icon notranslate"], ["matTooltip", "Include all logical buffers that haven't appeared in HeapSimulatorTraces.\n                      We simply sum up all those buffer allocations, and report the additional\n                      unpadded heap sizes as the sum of those unsimulated buffer allocations *\n                      (total unpadded logical buffer sizes / total padded logical buffer sizes)."], ["matTooltipPosition", "above"], ["role", "img"]], [[2, "mat-icon-inline", null], [2, "mat-icon-no-color", null]], [[null, "longpress"], [null, "keydown"], [null, "touchend"]], function (_v, en, $event) {
                var ad = true;
                if (("longpress" === en)) {
                    var pd_0 = (nodeValue(_v, 23).show() !== false);
                    ad = (pd_0 && ad);
                }
                if (("keydown" === en)) {
                    var pd_1 = (nodeValue(_v, 23)._handleKeydown($event) !== false);
                    ad = (pd_1 && ad);
                }
                if (("touchend" === en)) {
                    var pd_2 = (nodeValue(_v, 23)._handleTouchend() !== false);
                    ad = (pd_2 && ad);
                }
                return ad;
            }, d$5, c$5)), directiveDef(22, 9158656, null, 0, MatIcon, [ElementRef, MatIconRegistry, [8, null], [2, MAT_ICON_LOCATION], [2, ErrorHandler]], null, null), directiveDef(23, 212992, null, 0, MatTooltip, [Overlay, ElementRef, ScrollDispatcher, ViewContainerRef, NgZone, Platform, AriaDescriber, FocusMonitor, MAT_TOOLTIP_SCROLL_STRATEGY, [2, Directionality], [2, MAT_TOOLTIP_DEFAULT_OPTIONS], [2, HAMMER_LOADER]], { position: [0, "position"], message: [1, "message"] }, null), (_l()(), textDef(-1, 0, [" info "])), (_l()(), elementDef(25, 0, null, null, 1, "mat-divider", [["class", "mat-divider"], ["role", "separator"]], [[1, "aria-orientation", 0], [2, "mat-divider-vertical", null], [2, "mat-divider-horizontal", null], [2, "mat-divider-inset", null]], null, null, d$7, c$7)), directiveDef(26, 49152, null, 0, MatDivider, [], null, null), (_l()(), elementDef(27, 0, null, null, 1, "program-order-chart", [], null, null, null, View_ProgramOrderChart_0, RenderType_ProgramOrderChart)), directiveDef(28, 638976, null, 0, ProgramOrderChart, [], { heapSizes: [0, "heapSizes"], unpaddedHeapSizes: [1, "unpaddedHeapSizes"], peakInfo: [2, "peakInfo"], activeInfo: [3, "activeInfo"] }, null), (_l()(), elementDef(29, 0, null, null, 2, "div", [], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(30, 0, null, null, 1, "mat-divider", [["class", "mat-divider"], ["role", "separator"]], [[1, "aria-orientation", 0], [2, "mat-divider-vertical", null], [2, "mat-divider-horizontal", null], [2, "mat-divider-inset", null]], null, null, d$7, c$7)), directiveDef(31, 49152, null, 0, MatDivider, [], null, null), (_l()(), elementDef(32, 0, null, null, 1, "max-heap-chart", [], null, [[null, "selected"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("selected" === en)) {
                    var pd_0 = (_co.setSelectedHeapObject($event) !== false);
                    ad = (pd_0 && ad);
                }
                return ad;
            }, View_MaxHeapChart_0, RenderType_MaxHeapChart)), directiveDef(33, 638976, null, 0, MaxHeapChart, [], { maxHeap: [0, "maxHeap"], title: [1, "title"], selectedIndex: [2, "selectedIndex"] }, { selected: "selected" }), (_l()(), elementDef(34, 0, null, null, 2, "div", [], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(35, 0, null, null, 1, "mat-divider", [["class", "mat-divider"], ["role", "separator"]], [[1, "aria-orientation", 0], [2, "mat-divider-vertical", null], [2, "mat-divider-horizontal", null], [2, "mat-divider-inset", null]], null, null, d$7, c$7)), directiveDef(36, 49152, null, 0, MatDivider, [], null, null), (_l()(), elementDef(37, 0, null, null, 1, "max-heap-chart", [], null, [[null, "selected"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("selected" === en)) {
                    var pd_0 = (_co.setSelectedHeapObjectBySize($event) !== false);
                    ad = (pd_0 && ad);
                }
                return ad;
            }, View_MaxHeapChart_0, RenderType_MaxHeapChart)), directiveDef(38, 638976, null, 0, MaxHeapChart, [], { maxHeap: [0, "maxHeap"], title: [1, "title"], selectedIndex: [2, "selectedIndex"] }, { selected: "selected" }), (_l()(), elementDef(39, 0, null, null, 2, "div", [], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(40, 0, null, null, 1, "mat-divider", [["class", "mat-divider"], ["role", "separator"]], [[1, "aria-orientation", 0], [2, "mat-divider-vertical", null], [2, "mat-divider-horizontal", null], [2, "mat-divider-inset", null]], null, null, d$7, c$7)), directiveDef(41, 49152, null, 0, MatDivider, [], null, null), (_l()(), elementDef(42, 0, null, null, 1, "max-heap-chart", [], null, [[null, "selected"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("selected" === en)) {
                    var pd_0 = (_co.setSelectedHeapObjectByPaddingSize($event) !== false);
                    ad = (pd_0 && ad);
                }
                return ad;
            }, View_MaxHeapChart_0, RenderType_MaxHeapChart)), directiveDef(43, 638976, null, 0, MaxHeapChart, [], { maxHeap: [0, "maxHeap"], title: [1, "title"], selectedIndex: [2, "selectedIndex"] }, { selected: "selected" }), (_l()(), elementDef(44, 0, null, null, 1, "div", [["class", "section-container"]], [[8, "hidden", 0]], null, null, null, null)), (_l()(), textDef(-1, null, [" There is no data to display.\n"]))], function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.diagnostics; _ck(_v, 1, 0, currVal_0); var currVal_19 = _co.includeNotSimulated; _ck(_v, 17, 0, currVal_19); _ck(_v, 22, 0); var currVal_22 = "above"; var currVal_23 = "Include all logical buffers that haven't appeared in HeapSimulatorTraces.\n                      We simply sum up all those buffer allocations, and report the additional\n                      unpadded heap sizes as the sum of those unsimulated buffer allocations *\n                      (total unpadded logical buffer sizes / total padded logical buffer sizes)."; _ck(_v, 23, 0, currVal_22, currVal_23); var currVal_28 = _co.heapSizes; var currVal_29 = _co.unpaddedHeapSizes; var currVal_30 = _co.peakInfo; var currVal_31 = _co.activeInfo; _ck(_v, 28, 0, currVal_28, currVal_29, currVal_30, currVal_31); var currVal_37 = _co.maxHeap; var currVal_38 = "By Program Order"; var currVal_39 = _co.selectedIndex; _ck(_v, 33, 0, currVal_37, currVal_38, currVal_39); var currVal_45 = _co.maxHeapBySize; var currVal_46 = "By Size"; var currVal_47 = _co.selectedIndexBySize; _ck(_v, 38, 0, currVal_45, currVal_46, currVal_47); var currVal_53 = _co.maxHeapByPaddingSize; var currVal_54 = "By Padding Size"; var currVal_55 = _co.selectedIndexByPaddingSize; _ck(_v, 43, 0, currVal_53, currVal_54, currVal_55); }, function (_ck, _v) { var _co = _v.component; var currVal_1 = _co.moduleName; _ck(_v, 6, 0, currVal_1); var currVal_2 = _co.peakHeapSizeMiB; _ck(_v, 8, 0, currVal_2); var currVal_3 = !_co.unpaddedPeakHeapSizeMiB; _ck(_v, 9, 0, currVal_3); var currVal_4 = _co.unpaddedPeakHeapSizeMiB; _ck(_v, 10, 0, currVal_4); var currVal_5 = nodeValue(_v, 15).id; var currVal_6 = null; var currVal_7 = nodeValue(_v, 15).indeterminate; var currVal_8 = nodeValue(_v, 15).checked; var currVal_9 = nodeValue(_v, 15).disabled; var currVal_10 = (nodeValue(_v, 15).labelPosition == "before"); var currVal_11 = (nodeValue(_v, 15)._animationMode === "NoopAnimations"); var currVal_12 = nodeValue(_v, 19).ngClassUntouched; var currVal_13 = nodeValue(_v, 19).ngClassTouched; var currVal_14 = nodeValue(_v, 19).ngClassPristine; var currVal_15 = nodeValue(_v, 19).ngClassDirty; var currVal_16 = nodeValue(_v, 19).ngClassValid; var currVal_17 = nodeValue(_v, 19).ngClassInvalid; var currVal_18 = nodeValue(_v, 19).ngClassPending; _ck(_v, 14, 1, [currVal_5, currVal_6, currVal_7, currVal_8, currVal_9, currVal_10, currVal_11, currVal_12, currVal_13, currVal_14, currVal_15, currVal_16, currVal_17, currVal_18]); var currVal_20 = nodeValue(_v, 22).inline; var currVal_21 = (((nodeValue(_v, 22).color !== "primary") && (nodeValue(_v, 22).color !== "accent")) && (nodeValue(_v, 22).color !== "warn")); _ck(_v, 21, 0, currVal_20, currVal_21); var currVal_24 = (nodeValue(_v, 26).vertical ? "vertical" : "horizontal"); var currVal_25 = nodeValue(_v, 26).vertical; var currVal_26 = !nodeValue(_v, 26).vertical; var currVal_27 = nodeValue(_v, 26).inset; _ck(_v, 25, 0, currVal_24, currVal_25, currVal_26, currVal_27); var currVal_32 = !_co.heapSizes.length; _ck(_v, 29, 0, currVal_32); var currVal_33 = (nodeValue(_v, 31).vertical ? "vertical" : "horizontal"); var currVal_34 = nodeValue(_v, 31).vertical; var currVal_35 = !nodeValue(_v, 31).vertical; var currVal_36 = nodeValue(_v, 31).inset; _ck(_v, 30, 0, currVal_33, currVal_34, currVal_35, currVal_36); var currVal_40 = !_co.maxHeap.length; _ck(_v, 34, 0, currVal_40); var currVal_41 = (nodeValue(_v, 36).vertical ? "vertical" : "horizontal"); var currVal_42 = nodeValue(_v, 36).vertical; var currVal_43 = !nodeValue(_v, 36).vertical; var currVal_44 = nodeValue(_v, 36).inset; _ck(_v, 35, 0, currVal_41, currVal_42, currVal_43, currVal_44); var currVal_48 = !_co.maxHeapByPaddingSize.length; _ck(_v, 39, 0, currVal_48); var currVal_49 = (nodeValue(_v, 41).vertical ? "vertical" : "horizontal"); var currVal_50 = nodeValue(_v, 41).vertical; var currVal_51 = !nodeValue(_v, 41).vertical; var currVal_52 = nodeValue(_v, 41).inset; _ck(_v, 40, 0, currVal_49, currVal_50, currVal_51, currVal_52); var currVal_56 = _co.hasTrace; _ck(_v, 44, 0, currVal_56); });
    }
    function View_MemoryViewerMain_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "memory-viewer-main", [], null, null, null, View_MemoryViewerMain_0, RenderType_MemoryViewerMain)), directiveDef(1, 704512, null, 0, MemoryViewerMain, [Store], null, null)], null, null); }
    var MemoryViewerMainNgFactory = createComponentFactory("memory-viewer-main", MemoryViewerMain, View_MemoryViewerMain_Host_0, { hloProto: "hloProto", memorySpaceColor: "memorySpaceColor" }, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_MemoryViewer = [styles$m];
    var RenderType_MemoryViewer = createRendererType2({ encapsulation: 0, styles: styles_MemoryViewer, data: {} });
    function View_MemoryViewer_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "memory-viewer-main", [], null, null, null, View_MemoryViewerMain_0, RenderType_MemoryViewerMain)), directiveDef(1, 704512, null, 0, MemoryViewerMain, [Store], { hloProto: [0, "hloProto"] }, null)], function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.hloProto; _ck(_v, 1, 0, currVal_0); }, null); }
    function View_MemoryViewer_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "memory-viewer", [], null, null, null, View_MemoryViewer_0, RenderType_MemoryViewer)), directiveDef(1, 180224, null, 0, MemoryViewer, [ActivatedRoute, DataService, Store], null, null)], null, null); }
    var MemoryViewerNgFactory = createComponentFactory("memory-viewer", MemoryViewer, View_MemoryViewer_Host_0, {}, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$q = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}.container[_ngcontent-%COMP%]{padding:20px}.description[_ngcontent-%COMP%]{margin-top:-16px;font-size:16px;font-weight:lighter;line-height:1.6}.control-container[_ngcontent-%COMP%]{display:flex;padding-top:32px}.control[_ngcontent-%COMP%]{margin-right:80px}.ops-control[_ngcontent-%COMP%]{margin-right:80px;text-align:left}.control-title[_ngcontent-%COMP%]{color:#5f6368;margin-bottom:5px}.ops-control-title[_ngcontent-%COMP%]{color:#5f6368;margin:-20px 0 -24px}.children-count-input[_ngcontent-%COMP%]{width:60px}.tooltip-icon-container[_ngcontent-%COMP%]{position:relative}.tooltip-icon[_ngcontent-%COMP%]{color:#e8710a;font-size:25px;vertical-align:bottom;cursor:pointer}"];
    var _MatSlideToggleRequiredValidatorModuleNgFactory = createNgModuleFactory(_MatSlideToggleRequiredValidatorModule, [], function (_l) {
        return moduleDef([
            moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [
                [
                    8,
                    []
                ],
                [
                    3,
                    ComponentFactoryResolver
                ],
                NgModuleRef
            ]),
            moduleProvideDef(1073742336, _MatSlideToggleRequiredValidatorModule, _MatSlideToggleRequiredValidatorModule, [])
        ]);
    });
    var MatSlideToggleModuleNgFactory = createNgModuleFactory(MatSlideToggleModule, [], function (_l) {
        return moduleDef([
            moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [
                [
                    8,
                    []
                ],
                [
                    3,
                    ComponentFactoryResolver
                ],
                NgModuleRef
            ]),
            moduleProvideDef(4608, MutationObserverFactory, MutationObserverFactory, []),
            moduleProvideDef(4608, HAMMER_GESTURE_CONFIG, GestureConfig, [
                [
                    2,
                    MAT_HAMMER_OPTIONS
                ],
                [
                    2,
                    MatCommonModule
                ]
            ]),
            moduleProvideDef(1073742336, _MatSlideToggleRequiredValidatorModule, _MatSlideToggleRequiredValidatorModule, []),
            moduleProvideDef(1073742336, BidiModule, BidiModule, []),
            moduleProvideDef(1073742336, MatCommonModule, MatCommonModule, [
                [
                    2,
                    MATERIAL_SANITY_CHECKS
                ],
                [
                    2,
                    HAMMER_LOADER
                ]
            ]),
            moduleProvideDef(1073742336, PlatformModule, PlatformModule, []),
            moduleProvideDef(1073742336, MatRippleModule, MatRippleModule, []),
            moduleProvideDef(1073742336, ObserversModule, ObserversModule, []),
            moduleProvideDef(1073742336, MatSlideToggleModule, MatSlideToggleModule, [])
        ]);
    });
    var styles_MatSlideToggle = ['.mat-slide-toggle{display:inline-block;height:24px;max-width:100%;line-height:24px;white-space:nowrap;outline:0;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;-webkit-tap-highlight-color:transparent}.mat-slide-toggle.mat-checked .mat-slide-toggle-thumb-container{transform:translate3d(16px,0,0)}[dir=rtl] .mat-slide-toggle.mat-checked .mat-slide-toggle-thumb-container{transform:translate3d(-16px,0,0)}.mat-slide-toggle.mat-disabled{opacity:.38}.mat-slide-toggle.mat-disabled .mat-slide-toggle-label,.mat-slide-toggle.mat-disabled .mat-slide-toggle-thumb-container{cursor:default}.mat-slide-toggle-label{display:flex;flex:1;flex-direction:row;align-items:center;height:inherit;cursor:pointer}.mat-slide-toggle-content{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}.mat-slide-toggle-label-before .mat-slide-toggle-label{order:1}.mat-slide-toggle-label-before .mat-slide-toggle-bar{order:2}.mat-slide-toggle-bar,[dir=rtl] .mat-slide-toggle-label-before .mat-slide-toggle-bar{margin-right:8px;margin-left:0}.mat-slide-toggle-label-before .mat-slide-toggle-bar,[dir=rtl] .mat-slide-toggle-bar{margin-left:8px;margin-right:0}.mat-slide-toggle-bar-no-side-margin{margin-left:0;margin-right:0}.mat-slide-toggle-thumb-container{position:absolute;z-index:1;width:20px;height:20px;top:-3px;left:0;transform:translate3d(0,0,0);transition:all 80ms linear;transition-property:transform;cursor:-webkit-grab;cursor:grab}.mat-slide-toggle-thumb-container.mat-dragging{transition-duration:0s}.mat-slide-toggle-thumb-container:active{cursor:-webkit-grabbing;cursor:grabbing}._mat-animation-noopable .mat-slide-toggle-thumb-container{transition:none}[dir=rtl] .mat-slide-toggle-thumb-container{left:auto;right:0}.mat-slide-toggle-thumb{height:20px;width:20px;border-radius:50%}.mat-slide-toggle-bar{position:relative;width:36px;height:14px;flex-shrink:0;border-radius:8px}.mat-slide-toggle-input{bottom:0;left:10px}[dir=rtl] .mat-slide-toggle-input{left:auto;right:10px}.mat-slide-toggle-bar,.mat-slide-toggle-thumb{transition:all 80ms linear;transition-property:background-color;transition-delay:50ms}._mat-animation-noopable .mat-slide-toggle-bar,._mat-animation-noopable .mat-slide-toggle-thumb{transition:none}.mat-slide-toggle .mat-slide-toggle-ripple{position:absolute;top:calc(50% - 20px);left:calc(50% - 20px);height:40px;width:40px;z-index:1;pointer-events:none}.mat-slide-toggle .mat-slide-toggle-ripple .mat-ripple-element:not(.mat-slide-toggle-persistent-ripple){opacity:.12}.mat-slide-toggle-persistent-ripple{width:100%;height:100%;transform:none}.mat-slide-toggle-bar:hover .mat-slide-toggle-persistent-ripple{opacity:.04}.mat-slide-toggle:not(.mat-disabled).cdk-keyboard-focused .mat-slide-toggle-persistent-ripple{opacity:.12}.mat-slide-toggle-persistent-ripple,.mat-slide-toggle.mat-disabled .mat-slide-toggle-bar:hover .mat-slide-toggle-persistent-ripple{opacity:0}@media (hover:none){.mat-slide-toggle-bar:hover .mat-slide-toggle-persistent-ripple{display:none}}@media (-ms-high-contrast:active){.mat-slide-toggle-thumb{background:#fff;border:1px solid #000}.mat-slide-toggle.mat-checked .mat-slide-toggle-thumb{background:#000;border:1px solid #fff}.mat-slide-toggle-bar{background:#fff}.mat-slide-toggle.cdk-keyboard-focused .mat-slide-toggle-bar{outline:1px dotted;outline-offset:5px}}@media (-ms-high-contrast:black-on-white){.mat-slide-toggle-bar{border:1px solid #000}}'];
    var RenderType_MatSlideToggle = createRendererType2({
        encapsulation: 2,
        styles: styles_MatSlideToggle,
        data: {}
    });
    function View_MatSlideToggle_0(_l) {
        return viewDef(2, [
            queryDef(671088640, 1, { _thumbEl: 0 }),
            queryDef(671088640, 2, { _thumbBarEl: 0 }),
            queryDef(671088640, 3, { _inputElement: 0 }),
            (_l()(), elementDef(3, 0, [[
                    'label',
                    1
                ]], null, 13, 'label', [[
                    'class',
                    'mat-slide-toggle-label'
                ]], [[
                    1,
                    'for',
                    0
                ]], null, null, null, null)),
            (_l()(), elementDef(4, 0, [
                [
                    2,
                    0
                ],
                [
                    'toggleBar',
                    1
                ]
            ], null, 7, 'div', [[
                    'class',
                    'mat-slide-toggle-bar'
                ]], [[
                    2,
                    'mat-slide-toggle-bar-no-side-margin',
                    null
                ]], null, null, null, null)),
            (_l()(), elementDef(5, 0, [
                [
                    3,
                    0
                ],
                [
                    'input',
                    1
                ]
            ], null, 0, 'input', [
                [
                    'class',
                    'mat-slide-toggle-input cdk-visually-hidden'
                ],
                [
                    'role',
                    'switch'
                ],
                [
                    'type',
                    'checkbox'
                ]
            ], [
                [
                    8,
                    'id',
                    0
                ],
                [
                    8,
                    'required',
                    0
                ],
                [
                    8,
                    'tabIndex',
                    0
                ],
                [
                    8,
                    'checked',
                    0
                ],
                [
                    8,
                    'disabled',
                    0
                ],
                [
                    1,
                    'name',
                    0
                ],
                [
                    1,
                    'aria-checked',
                    0
                ],
                [
                    1,
                    'aria-label',
                    0
                ],
                [
                    1,
                    'aria-labelledby',
                    0
                ]
            ], [
                [
                    null,
                    'change'
                ],
                [
                    null,
                    'click'
                ]
            ], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if ('change' === en) {
                    var pd_0 = _co._onChangeEvent($event) !== false;
                    ad = pd_0 && ad;
                }
                if ('click' === en) {
                    var pd_1 = _co._onInputClick($event) !== false;
                    ad = pd_1 && ad;
                }
                return ad;
            }, null, null)),
            (_l()(), elementDef(6, 0, [
                [
                    1,
                    0
                ],
                [
                    'thumbContainer',
                    1
                ]
            ], null, 5, 'div', [[
                    'class',
                    'mat-slide-toggle-thumb-container'
                ]], null, [
                [
                    null,
                    'slidestart'
                ],
                [
                    null,
                    'slide'
                ],
                [
                    null,
                    'slideend'
                ]
            ], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if ('slidestart' === en) {
                    var pd_0 = _co._onDragStart() !== false;
                    ad = pd_0 && ad;
                }
                if ('slide' === en) {
                    var pd_1 = _co._onDrag($event) !== false;
                    ad = pd_1 && ad;
                }
                if ('slideend' === en) {
                    var pd_2 = _co._onDragEnd() !== false;
                    ad = pd_2 && ad;
                }
                return ad;
            }, null, null)),
            (_l()(), elementDef(7, 0, null, null, 0, 'div', [[
                    'class',
                    'mat-slide-toggle-thumb'
                ]], null, null, null, null, null)),
            (_l()(), elementDef(8, 0, null, null, 3, 'div', [
                [
                    'class',
                    'mat-slide-toggle-ripple mat-ripple'
                ],
                [
                    'mat-ripple',
                    ''
                ]
            ], [[
                    2,
                    'mat-ripple-unbounded',
                    null
                ]], null, null, null, null)),
            directiveDef(9, 212992, null, 0, MatRipple, [
                ElementRef,
                NgZone,
                Platform,
                [
                    2,
                    MAT_RIPPLE_GLOBAL_OPTIONS
                ],
                [
                    2,
                    ANIMATION_MODULE_TYPE
                ]
            ], {
                centered: [
                    0,
                    'centered'
                ],
                radius: [
                    1,
                    'radius'
                ],
                animation: [
                    2,
                    'animation'
                ],
                disabled: [
                    3,
                    'disabled'
                ],
                trigger: [
                    4,
                    'trigger'
                ]
            }, null),
            pureObjectDef(10, { enterDuration: 0 }),
            (_l()(), elementDef(11, 0, null, null, 0, 'div', [[
                    'class',
                    'mat-ripple-element mat-slide-toggle-persistent-ripple'
                ]], null, null, null, null, null)),
            (_l()(), elementDef(12, 0, [[
                    'labelContent',
                    1
                ]], null, 4, 'span', [[
                    'class',
                    'mat-slide-toggle-content'
                ]], null, [[
                    null,
                    'cdkObserveContent'
                ]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if ('cdkObserveContent' === en) {
                    var pd_0 = _co._onLabelTextChange() !== false;
                    ad = pd_0 && ad;
                }
                return ad;
            }, null, null)),
            directiveDef(13, 1196032, null, 0, CdkObserveContent, [
                ContentObserver,
                ElementRef,
                NgZone
            ], null, { event: 'cdkObserveContent' }),
            (_l()(), elementDef(14, 0, null, null, 1, 'span', [[
                    'style',
                    'display:none'
                ]], null, null, null, null, null)),
            (_l()(), textDef(-1, null, ['\xA0'])),
            ngContentDef(null, 0)
        ], function (_ck, _v) {
            var _co = _v.component;
            var currVal_12 = true;
            var currVal_13 = 20;
            var currVal_14 = _ck(_v, 10, 0, 150);
            var currVal_15 = _co.disableRipple || _co.disabled;
            var currVal_16 = nodeValue(_v, 3);
            _ck(_v, 9, 0, currVal_12, currVal_13, currVal_14, currVal_15, currVal_16);
        }, function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co.inputId;
            _ck(_v, 3, 0, currVal_0);
            var currVal_1 = !nodeValue(_v, 12).textContent || !nodeValue(_v, 12).textContent.trim();
            _ck(_v, 4, 0, currVal_1);
            var currVal_2 = _co.inputId;
            var currVal_3 = _co.required;
            var currVal_4 = _co.tabIndex;
            var currVal_5 = _co.checked;
            var currVal_6 = _co.disabled;
            var currVal_7 = _co.name;
            var currVal_8 = _co.checked.toString();
            var currVal_9 = _co.ariaLabel;
            var currVal_10 = _co.ariaLabelledby;
            _ck(_v, 5, 0, currVal_2, currVal_3, currVal_4, currVal_5, currVal_6, currVal_7, currVal_8, currVal_9, currVal_10);
            var currVal_11 = nodeValue(_v, 9).unbounded;
            _ck(_v, 8, 0, currVal_11);
        });
    }
    function View_MatSlideToggle_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 2, 'mat-slide-toggle', [[
                    'class',
                    'mat-slide-toggle'
                ]], [
                [
                    8,
                    'id',
                    0
                ],
                [
                    1,
                    'tabindex',
                    0
                ],
                [
                    1,
                    'aria-label',
                    0
                ],
                [
                    1,
                    'aria-labelledby',
                    0
                ],
                [
                    2,
                    'mat-checked',
                    null
                ],
                [
                    2,
                    'mat-disabled',
                    null
                ],
                [
                    2,
                    'mat-slide-toggle-label-before',
                    null
                ],
                [
                    2,
                    '_mat-animation-noopable',
                    null
                ]
            ], [[
                    null,
                    'focus'
                ]], function (_v, en, $event) {
                var ad = true;
                if ('focus' === en) {
                    var pd_0 = nodeValue(_v, 2)._inputElement.nativeElement.focus() !== false;
                    ad = pd_0 && ad;
                }
                return ad;
            }, View_MatSlideToggle_0, RenderType_MatSlideToggle)),
            providerDef(5120, null, NG_VALUE_ACCESSOR, function (p0_0) {
                return [p0_0];
            }, [MatSlideToggle]),
            directiveDef(2, 1228800, null, 0, MatSlideToggle, [
                ElementRef,
                FocusMonitor,
                ChangeDetectorRef,
                [
                    8,
                    null
                ],
                NgZone,
                MAT_SLIDE_TOGGLE_DEFAULT_OPTIONS,
                [
                    2,
                    ANIMATION_MODULE_TYPE
                ],
                [
                    2,
                    Directionality
                ]
            ], null, null)
        ], null, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 2).id;
            var currVal_1 = nodeValue(_v, 2).disabled ? null : 0 - 1;
            var currVal_2 = null;
            var currVal_3 = null;
            var currVal_4 = nodeValue(_v, 2).checked;
            var currVal_5 = nodeValue(_v, 2).disabled;
            var currVal_6 = nodeValue(_v, 2).labelPosition == 'before';
            var currVal_7 = nodeValue(_v, 2)._animationMode === 'NoopAnimations';
            _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5, currVal_6, currVal_7);
        });
    }
    var MatSlideToggleNgFactory = createComponentFactory('mat-slide-toggle', MatSlideToggle, View_MatSlideToggle_Host_0, {
        disabled: 'disabled',
        disableRipple: 'disableRipple',
        color: 'color',
        tabIndex: 'tabIndex',
        name: 'name',
        id: 'id',
        labelPosition: 'labelPosition',
        ariaLabel: 'aria-label',
        ariaLabelledby: 'aria-labelledby',
        required: 'required',
        checked: 'checked'
    }, {
        change: 'change',
        toggleChange: 'toggleChange',
        dragChange: 'dragChange'
    }, ['*']);
    var d$a = RenderType_MatSlideToggle;
    var e$1 = View_MatSlideToggle_0;
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$r = [".header[_ngcontent-%COMP%]{display:flex;align-items:center;font-size:smaller;font-weight:bold;color:#666;padding-bottom:.25em;text-transform:uppercase;white-space:nowrap}.header[_ngcontent-%COMP%] > *[_ngcontent-%COMP%]{padding:.5em .5em 0;overflow:hidden;flex-shrink:0;box-sizing:border-box}.time[_ngcontent-%COMP%]{padding-left:20px !important;width:80px}.wasted[_ngcontent-%COMP%], .utilization[_ngcontent-%COMP%]{width:60px}.name[_ngcontent-%COMP%]{display:inline-block;min-width:40%;padding-left:2em !important}.provenance[_ngcontent-%COMP%]{flex:1 1 0 !important}.utilization[_ngcontent-%COMP%]{text-align:right}.flame-color-circle[_ngcontent-%COMP%]{margin:0 20px 0 10px;width:16px}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$s = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}[_nghost-%COMP%]{color:#4a4a4a}.row[_ngcontent-%COMP%]{display:flex;align-self:center;position:relative;border-top:1px solid #eee;z-index:0}.row.expanded[_ngcontent-%COMP%]{background-color:rgba(0,0,0,.04);font-weight:bold}.row[_ngcontent-%COMP%]:hover{background-color:rgba(0,0,0,.05)}.row[_ngcontent-%COMP%] > *[_ngcontent-%COMP%]{padding:.5em;overflow:hidden;flex-shrink:0;box-sizing:border-box}.bar[_ngcontent-%COMP%]{position:absolute;top:0;left:0;bottom:0;z-index:-2;background-color:#cde;padding:0 !important}.row-focus[_ngcontent-%COMP%]{position:absolute;top:0;left:0;bottom:0;z-index:-1;width:8px;background-color:#e8710a;padding:0 !important}.time[_ngcontent-%COMP%], .wasted[_ngcontent-%COMP%], .utilization[_ngcontent-%COMP%]{line-height:20px;font-size:smaller;width:60px}.time[_ngcontent-%COMP%]{padding-left:20px !important;width:80px}.name[_ngcontent-%COMP%]{display:inline-block;min-width:40%}.disclosure[_ngcontent-%COMP%]{display:inline-block;width:1em}.provenance[_ngcontent-%COMP%]{flex:1 1 0 !important}.utilization[_ngcontent-%COMP%]{align-self:stretch;text-align:right}.flame-color-circle[_ngcontent-%COMP%]{margin:10px 20px 10px 10px;width:16px;height:16px;border-radius:8px}.leftout[_ngcontent-%COMP%]{padding-left:175px;font-style:italic}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_OpTableEntry = [styles$s];
    var RenderType_OpTableEntry = createRendererType2({ encapsulation: 0, styles: styles_OpTableEntry, data: {} });
    function View_OpTableEntry_1(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "op-table-entry", [], null, [[null, "hover"], [null, "selected"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("hover" === en)) {
                    var pd_0 = (_co.hover.emit($event) !== false);
                    ad = (pd_0 && ad);
                }
                if (("selected" === en)) {
                    var pd_1 = (_co.selected.emit($event) !== false);
                    ad = (pd_1 && ad);
                }
                return ad;
            }, View_OpTableEntry_0, RenderType_OpTableEntry)), directiveDef(1, 573440, null, 0, OpTableEntry, [], { level: [0, "level"], node: [1, "node"], selectedNode: [2, "selectedNode"], byWasted: [3, "byWasted"], showP90: [4, "showP90"], childrenCount: [5, "childrenCount"] }, { hover: "hover", selected: "selected" })], function (_ck, _v) { var _co = _v.component; var currVal_0 = (_co.level + 1); var currVal_1 = _v.context.$implicit; var currVal_2 = _co.selectedNode; var currVal_3 = _co.byWasted; var currVal_4 = _co.showP90; var currVal_5 = _co.childrenCount; _ck(_v, 1, 0, currVal_0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5); }, null);
    }
    function View_OpTableEntry_2(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 2, "div", [["class", "leftout"]], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 1, "span", [], [[4, "padding-left", null]], null, null, null, null)), (_l()(), textDef(2, null, ["", " categories or ops have been left out."]))], null, function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.offset; _ck(_v, 1, 0, currVal_0); var currVal_1 = _co.numLeftOut; _ck(_v, 2, 0, currVal_1); }); }
    function View_OpTableEntry_0(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 20, "div", [], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 19, "div", [["class", "row"]], null, [[null, "click"], [null, "mouseenter"], [null, "mouseleave"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("click" === en)) {
                    var pd_0 = (_co.toggleExpanded() !== false);
                    ad = (pd_0 && ad);
                }
                if (("mouseenter" === en)) {
                    var pd_1 = (_co.hover.emit(_co.node) !== false);
                    ad = (pd_1 && ad);
                }
                if (("mouseleave" === en)) {
                    var pd_2 = (_co.hover.emit(null) !== false);
                    ad = (pd_2 && ad);
                }
                return ad;
            }, null, null)), (_l()(), elementDef(2, 0, null, null, 0, "div", [["class", "bar"]], [[4, "width", null]], null, null, null, null)), (_l()(), elementDef(3, 0, null, null, 0, "div", [["class", "row-focus"]], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(4, 0, null, null, 1, "span", [["class", "time"]], null, null, null, null, null)), (_l()(), textDef(5, null, ["", ""])), (_l()(), elementDef(6, 0, null, null, 1, "span", [["class", "wasted"]], null, null, null, null, null)), (_l()(), textDef(7, null, ["", ""])), (_l()(), elementDef(8, 0, null, null, 7, "span", [["class", "name"]], [[4, "padding-left", null]], null, null, null, null)), (_l()(), elementDef(9, 0, null, null, 5, "span", [["class", "disclosure"]], null, null, null, null, null)), (_l()(), elementDef(10, 0, null, null, 4, "span", [], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(11, 0, null, null, 1, "span", [], [[8, "hidden", 0]], null, null, null, null)), (_l()(), textDef(-1, null, ["\u25B6"])), (_l()(), elementDef(13, 0, null, null, 1, "span", [], [[8, "hidden", 0]], null, null, null, null)), (_l()(), textDef(-1, null, ["\u25BC"])), (_l()(), textDef(15, null, [" ", " "])), (_l()(), elementDef(16, 0, null, null, 1, "span", [["class", "provenance"]], null, null, null, null, null)), (_l()(), textDef(17, null, ["", "\u00A0"])), (_l()(), elementDef(18, 0, null, null, 1, "span", [["class", "utilization"]], [[8, "hidden", 0]], null, null, null, null)), (_l()(), textDef(19, null, [" ", " "])), (_l()(), elementDef(20, 0, null, null, 0, "span", [["class", "flame-color-circle"]], [[8, "hidden", 0], [4, "background-color", null]], null, null, null, null)), (_l()(), elementDef(21, 0, null, null, 4, "div", [], [[8, "hidden", 0]], null, null, null, null)), (_l()(), anchorDef(16777216, null, null, 1, null, View_OpTableEntry_1)), directiveDef(23, 278528, null, 0, NgForOf, [ViewContainerRef, TemplateRef, IterableDiffers], { ngForOf: [0, "ngForOf"] }, null), (_l()(), anchorDef(16777216, null, null, 1, null, View_OpTableEntry_2)), directiveDef(25, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"] }, null)], function (_ck, _v) { var _co = _v.component; var currVal_16 = _co.children; _ck(_v, 23, 0, currVal_16); var currVal_17 = (_co.numLeftOut > 0); _ck(_v, 25, 0, currVal_17); }, function (_ck, _v) { var _co = _v.component; var currVal_0 = !_co.level; _ck(_v, 0, 0, currVal_0); var currVal_1 = _co.barWidth; _ck(_v, 2, 0, currVal_1); var currVal_2 = (_co.node !== _co.selectedNode); _ck(_v, 3, 0, currVal_2); var currVal_3 = _co.percent; _ck(_v, 5, 0, currVal_3); var currVal_4 = _co.timeWasted; _ck(_v, 7, 0, currVal_4); var currVal_5 = _co.offset; _ck(_v, 8, 0, currVal_5); var currVal_6 = !_co.children.length; _ck(_v, 10, 0, currVal_6); var currVal_7 = _co.expanded; _ck(_v, 11, 0, currVal_7); var currVal_8 = !_co.expanded; _ck(_v, 13, 0, currVal_8); var currVal_9 = _co.name; _ck(_v, 15, 0, currVal_9); var currVal_10 = _co.provenance; _ck(_v, 17, 0, currVal_10); var currVal_11 = _co.hideFlopsUtilization; _ck(_v, 18, 0, currVal_11); var currVal_12 = _co.flopsUtilization; _ck(_v, 19, 0, currVal_12); var currVal_13 = _co.hideFlopsUtilization; var currVal_14 = _co.flameColor; _ck(_v, 20, 0, currVal_13, currVal_14); var currVal_15 = !_co.expanded; _ck(_v, 21, 0, currVal_15); });
    }
    function View_OpTableEntry_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "op-table-entry", [], null, null, null, View_OpTableEntry_0, RenderType_OpTableEntry)), directiveDef(1, 573440, null, 0, OpTableEntry, [], null, null)], null, null); }
    var OpTableEntryNgFactory = createComponentFactory("op-table-entry", OpTableEntry, View_OpTableEntry_Host_0, { level: "level", node: "node", selectedNode: "selectedNode", byWasted: "byWasted", showP90: "showP90", childrenCount: "childrenCount" }, { hover: "hover", selected: "selected" }, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_OpTable = [styles$r];
    var RenderType_OpTable = createRendererType2({ encapsulation: 0, styles: styles_OpTable, data: {} });
    function View_OpTable_0(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 11, "div", [["class", "header"]], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 1, "span", [["class", "time"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Time"])), (_l()(), elementDef(3, 0, null, null, 1, "span", [["class", "wasted"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Wasted"])), (_l()(), elementDef(5, 0, null, null, 1, "span", [["class", "name"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Name"])), (_l()(), elementDef(7, 0, null, null, 1, "span", [["class", "provenance"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["TensorFlow Op"])), (_l()(), elementDef(9, 0, null, null, 1, "span", [["class", "utilization"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["FLOPS"])), (_l()(), elementDef(11, 0, null, null, 0, "span", [["class", "flame-color-circle"]], null, null, null, null, null)), (_l()(), elementDef(12, 0, null, null, 1, "op-table-entry", [], null, [[null, "hover"], [null, "selected"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("hover" === en)) {
                    var pd_0 = (_co.updateActive($event) !== false);
                    ad = (pd_0 && ad);
                }
                if (("selected" === en)) {
                    var pd_1 = (_co.updateSelected($event) !== false);
                    ad = (pd_1 && ad);
                }
                return ad;
            }, View_OpTableEntry_0, RenderType_OpTableEntry)), directiveDef(13, 573440, null, 0, OpTableEntry, [], { level: [0, "level"], node: [1, "node"], selectedNode: [2, "selectedNode"], byWasted: [3, "byWasted"], showP90: [4, "showP90"], childrenCount: [5, "childrenCount"] }, { hover: "hover", selected: "selected" })], function (_ck, _v) { var _co = _v.component; var currVal_0 = 0; var currVal_1 = _co.rootNode; var currVal_2 = _co.selectedNode; var currVal_3 = _co.byWasted; var currVal_4 = _co.showP90; var currVal_5 = _co.childrenCount; _ck(_v, 13, 0, currVal_0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5); }, null);
    }
    function View_OpTable_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "op-table", [], null, null, null, View_OpTable_0, RenderType_OpTable)), directiveDef(1, 180224, null, 0, OpTable, [Store], null, null)], null, null); }
    var OpTableNgFactory = createComponentFactory("op-table", OpTable, View_OpTable_Host_0, { rootNode: "rootNode", byWasted: "byWasted", showP90: "showP90", childrenCount: "childrenCount" }, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_OpProfile = [styles$q];
    var RenderType_OpProfile = createRendererType2({ encapsulation: 0, styles: styles_OpProfile, data: {} });
    function View_OpProfile_0(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 59, "div", [["class", "container"]], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 8, "div", [["class", "mat-headline"]], null, null, null, null, null)), (_l()(), elementDef(2, 0, null, null, 3, "div", [], null, null, null, null, null)), (_l()(), textDef(3, null, [" Overall ", " FLOPS utilization is "])), (_l()(), elementDef(4, 0, null, null, 1, "span", [], [[4, "color", null]], null, null, null, null)), (_l()(), textDef(5, null, ["", ""])), (_l()(), elementDef(6, 0, null, null, 3, "div", [], null, null, null, null, null)), (_l()(), textDef(-1, null, [" Memory bandwidth utilization is "])), (_l()(), elementDef(8, 0, null, null, 1, "span", [], [[4, "color", null]], null, null, null, null)), (_l()(), textDef(9, null, ["", ""])), (_l()(), elementDef(10, 0, null, null, 4, "div", [["class", "description"]], null, null, null, null, null)), (_l()(), elementDef(11, 0, null, null, 1, "div", [], null, null, null, null, null)), (_l()(), textDef(12, null, [" Modifying your model's architecture, data dimensions, and improving the efficiency of CPU operations may help reach the ", "'s FLOPS potential. "])), (_l()(), elementDef(13, 0, null, null, 1, "div", [], null, null, null, null, null)), (_l()(), textDef(-1, null, [" \"Idle\" represents the portion of the total execution time on device that is idle. "])), (_l()(), elementDef(15, 0, null, null, 44, "div", [["class", "control-container"]], null, null, null, null, null)), (_l()(), elementDef(16, 0, null, null, 5, "div", [["class", "control"]], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(17, 0, null, null, 1, "div", [["class", "control-title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["By category"])), (_l()(), elementDef(19, 0, null, null, 2, "mat-slide-toggle", [["class", "mat-slide-toggle"]], [[8, "id", 0], [1, "tabindex", 0], [1, "aria-label", 0], [1, "aria-labelledby", 0], [2, "mat-checked", null], [2, "mat-disabled", null], [2, "mat-slide-toggle-label-before", null], [2, "_mat-animation-noopable", null]], [[null, "toggleChange"], [null, "focus"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("focus" === en)) {
                    var pd_0 = (nodeValue(_v, 21)._inputElement.nativeElement.focus() !== false);
                    ad = (pd_0 && ad);
                }
                if (("toggleChange" === en)) {
                    var pd_1 = (_co.updateToggle() !== false);
                    ad = (pd_1 && ad);
                }
                return ad;
            }, e$1, d$a)), providerDef(5120, null, NG_VALUE_ACCESSOR, function (p0_0) { return [p0_0]; }, [MatSlideToggle]), directiveDef(21, 1228800, null, 0, MatSlideToggle, [ElementRef, FocusMonitor, ChangeDetectorRef, [8, null], NgZone, MAT_SLIDE_TOGGLE_DEFAULT_OPTIONS, [2, ANIMATION_MODULE_TYPE], [2, Directionality]], { checked: [0, "checked"] }, { toggleChange: "toggleChange" }), (_l()(), elementDef(22, 0, null, null, 21, "div", [["class", "ops-control"]], null, null, null, null, null)), (_l()(), elementDef(23, 0, null, null, 16, "div", [["class", "ops-control-title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, [" Show top\u00A0 "])), (_l()(), elementDef(25, 0, null, null, 13, "mat-form-field", [["class", "children-count-input mat-form-field"]], [[2, "mat-form-field-appearance-standard", null], [2, "mat-form-field-appearance-fill", null], [2, "mat-form-field-appearance-outline", null], [2, "mat-form-field-appearance-legacy", null], [2, "mat-form-field-invalid", null], [2, "mat-form-field-can-float", null], [2, "mat-form-field-should-float", null], [2, "mat-form-field-has-label", null], [2, "mat-form-field-hide-placeholder", null], [2, "mat-form-field-disabled", null], [2, "mat-form-field-autofilled", null], [2, "mat-focused", null], [2, "mat-accent", null], [2, "mat-warn", null], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [2, "_mat-animation-noopable", null]], null, null, d$1, c$1)), directiveDef(26, 7520256, null, 9, MatFormField, [ElementRef, ChangeDetectorRef, [2, MAT_LABEL_GLOBAL_OPTIONS], [2, Directionality], [2, MAT_FORM_FIELD_DEFAULT_OPTIONS], Platform, NgZone, [2, ANIMATION_MODULE_TYPE]], null, null), queryDef(603979776, 1, { _controlNonStatic: 0 }), queryDef(335544320, 2, { _controlStatic: 0 }), queryDef(603979776, 3, { _labelChildNonStatic: 0 }), queryDef(335544320, 4, { _labelChildStatic: 0 }), queryDef(603979776, 5, { _placeholderChild: 0 }), queryDef(603979776, 6, { _errorChildren: 1 }), queryDef(603979776, 7, { _hintChildren: 1 }), queryDef(603979776, 8, { _prefixChildren: 1 }), queryDef(603979776, 9, { _suffixChildren: 1 }), (_l()(), elementDef(36, 0, null, 1, 2, "input", [["class", "mat-input-element mat-form-field-autofill-control"], ["matInput", ""], ["type", "number"]], [[8, "min", 0], [8, "max", 0], [8, "step", 0], [2, "mat-input-server", null], [1, "id", 0], [1, "placeholder", 0], [8, "disabled", 0], [8, "required", 0], [1, "readonly", 0], [1, "aria-describedby", 0], [1, "aria-invalid", 0], [1, "aria-required", 0]], [[null, "input"], [null, "blur"], [null, "focus"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("blur" === en)) {
                    var pd_0 = (nodeValue(_v, 37)._focusChanged(false) !== false);
                    ad = (pd_0 && ad);
                }
                if (("focus" === en)) {
                    var pd_1 = (nodeValue(_v, 37)._focusChanged(true) !== false);
                    ad = (pd_1 && ad);
                }
                if (("input" === en)) {
                    var pd_2 = (nodeValue(_v, 37)._onInput() !== false);
                    ad = (pd_2 && ad);
                }
                if (("input" === en)) {
                    var pd_3 = (_co.updateChildrenCount($event.target.value) !== false);
                    ad = (pd_3 && ad);
                }
                return ad;
            }, null, null)), directiveDef(37, 999424, null, 0, MatInput, [ElementRef, Platform, [8, null], [2, NgForm], [2, FormGroupDirective], ErrorStateMatcher, [8, null], AutofillMonitor, NgZone], { type: [0, "type"], value: [1, "value"] }, null), providerDef(2048, [[1, 4], [2, 4]], MatFormFieldControl, null, [MatInput]), (_l()(), textDef(-1, null, [" \u00A0ops "])), (_l()(), elementDef(40, 0, null, null, 3, "div", [], null, null, null, null, null)), (_l()(), elementDef(41, 0, null, null, 2, "mat-slider", [["class", "mat-slider"], ["role", "slider"]], [[8, "tabIndex", 0], [1, "aria-disabled", 0], [1, "aria-valuemax", 0], [1, "aria-valuemin", 0], [1, "aria-valuenow", 0], [1, "aria-orientation", 0], [2, "mat-slider-disabled", null], [2, "mat-slider-has-ticks", null], [2, "mat-slider-horizontal", null], [2, "mat-slider-axis-inverted", null], [2, "mat-slider-invert-mouse-coords", null], [2, "mat-slider-sliding", null], [2, "mat-slider-thumb-label-showing", null], [2, "mat-slider-vertical", null], [2, "mat-slider-min-value", null], [2, "mat-slider-hide-last-tick", null], [2, "_mat-animation-noopable", null]], [[null, "change"], [null, "focus"], [null, "blur"], [null, "mousedown"], [null, "keydown"], [null, "keyup"], [null, "mouseenter"], [null, "slide"], [null, "slideend"], [null, "slidestart"], [null, "selectstart"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("focus" === en)) {
                    var pd_0 = (nodeValue(_v, 43)._onFocus() !== false);
                    ad = (pd_0 && ad);
                }
                if (("blur" === en)) {
                    var pd_1 = (nodeValue(_v, 43)._onBlur() !== false);
                    ad = (pd_1 && ad);
                }
                if (("mousedown" === en)) {
                    var pd_2 = (nodeValue(_v, 43)._onMousedown($event) !== false);
                    ad = (pd_2 && ad);
                }
                if (("keydown" === en)) {
                    var pd_3 = (nodeValue(_v, 43)._onKeydown($event) !== false);
                    ad = (pd_3 && ad);
                }
                if (("keyup" === en)) {
                    var pd_4 = (nodeValue(_v, 43)._onKeyup() !== false);
                    ad = (pd_4 && ad);
                }
                if (("mouseenter" === en)) {
                    var pd_5 = (nodeValue(_v, 43)._onMouseenter() !== false);
                    ad = (pd_5 && ad);
                }
                if (("slide" === en)) {
                    var pd_6 = (nodeValue(_v, 43)._onSlide($event) !== false);
                    ad = (pd_6 && ad);
                }
                if (("slideend" === en)) {
                    var pd_7 = (nodeValue(_v, 43)._onSlideEnd() !== false);
                    ad = (pd_7 && ad);
                }
                if (("slidestart" === en)) {
                    var pd_8 = (nodeValue(_v, 43)._onSlideStart($event) !== false);
                    ad = (pd_8 && ad);
                }
                if (("selectstart" === en)) {
                    var pd_9 = ($event.preventDefault() !== false);
                    ad = (pd_9 && ad);
                }
                if (("change" === en)) {
                    var pd_10 = (_co.updateChildrenCount($event.value) !== false);
                    ad = (pd_10 && ad);
                }
                return ad;
            }, d$8, c$8)), providerDef(5120, null, NG_VALUE_ACCESSOR, function (p0_0) { return [p0_0]; }, [MatSlider]), directiveDef(43, 245760, null, 0, MatSlider, [ElementRef, FocusMonitor, ChangeDetectorRef, [2, Directionality], [8, null], [2, ANIMATION_MODULE_TYPE]], { max: [0, "max"], min: [1, "min"], step: [2, "step"], value: [3, "value"] }, { change: "change" }), (_l()(), elementDef(44, 0, null, null, 9, "div", [["class", "control"]], null, null, null, null, null)), (_l()(), elementDef(45, 0, null, null, 5, "div", [["class", "control-title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Sort by wasted time "])), (_l()(), elementDef(47, 16777216, null, null, 3, "mat-icon", [["class", "tooltip-icon mat-icon notranslate"], ["matTooltip", "Wasted time is defined by RuntimeFraction *\n                              (1 - max(FlopsUtilization, MemoryBandwidthUtilization))."], ["matTooltipPosition", "above"], ["role", "img"]], [[2, "mat-icon-inline", null], [2, "mat-icon-no-color", null]], [[null, "longpress"], [null, "keydown"], [null, "touchend"]], function (_v, en, $event) {
                var ad = true;
                if (("longpress" === en)) {
                    var pd_0 = (nodeValue(_v, 49).show() !== false);
                    ad = (pd_0 && ad);
                }
                if (("keydown" === en)) {
                    var pd_1 = (nodeValue(_v, 49)._handleKeydown($event) !== false);
                    ad = (pd_1 && ad);
                }
                if (("touchend" === en)) {
                    var pd_2 = (nodeValue(_v, 49)._handleTouchend() !== false);
                    ad = (pd_2 && ad);
                }
                return ad;
            }, d$5, c$5)), directiveDef(48, 9158656, null, 0, MatIcon, [ElementRef, MatIconRegistry, [8, null], [2, MAT_ICON_LOCATION], [2, ErrorHandler]], null, null), directiveDef(49, 212992, null, 0, MatTooltip, [Overlay, ElementRef, ScrollDispatcher, ViewContainerRef, NgZone, Platform, AriaDescriber, FocusMonitor, MAT_TOOLTIP_SCROLL_STRATEGY, [2, Directionality], [2, MAT_TOOLTIP_DEFAULT_OPTIONS], [2, HAMMER_LOADER]], { position: [0, "position"], message: [1, "message"] }, null), (_l()(), textDef(-1, 0, [" info "])), (_l()(), elementDef(51, 0, null, null, 2, "mat-slide-toggle", [["class", "mat-slide-toggle"]], [[8, "id", 0], [1, "tabindex", 0], [1, "aria-label", 0], [1, "aria-labelledby", 0], [2, "mat-checked", null], [2, "mat-disabled", null], [2, "mat-slide-toggle-label-before", null], [2, "_mat-animation-noopable", null]], [[null, "toggleChange"], [null, "focus"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("focus" === en)) {
                    var pd_0 = (nodeValue(_v, 53)._inputElement.nativeElement.focus() !== false);
                    ad = (pd_0 && ad);
                }
                if (("toggleChange" === en)) {
                    var pd_1 = (_co.updateByWasted() !== false);
                    ad = (pd_1 && ad);
                }
                return ad;
            }, e$1, d$a)), providerDef(5120, null, NG_VALUE_ACCESSOR, function (p0_0) { return [p0_0]; }, [MatSlideToggle]), directiveDef(53, 1228800, null, 0, MatSlideToggle, [ElementRef, FocusMonitor, ChangeDetectorRef, [8, null], NgZone, MAT_SLIDE_TOGGLE_DEFAULT_OPTIONS, [2, ANIMATION_MODULE_TYPE], [2, Directionality]], { checked: [0, "checked"] }, { toggleChange: "toggleChange" }), (_l()(), elementDef(54, 0, null, null, 5, "div", [["class", "control"]], null, null, null, null, null)), (_l()(), elementDef(55, 0, null, null, 1, "div", [["class", "control-title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Top 90%"])), (_l()(), elementDef(57, 0, null, null, 2, "mat-slide-toggle", [["class", "mat-slide-toggle"]], [[8, "id", 0], [1, "tabindex", 0], [1, "aria-label", 0], [1, "aria-labelledby", 0], [2, "mat-checked", null], [2, "mat-disabled", null], [2, "mat-slide-toggle-label-before", null], [2, "_mat-animation-noopable", null]], [[null, "toggleChange"], [null, "focus"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("focus" === en)) {
                    var pd_0 = (nodeValue(_v, 59)._inputElement.nativeElement.focus() !== false);
                    ad = (pd_0 && ad);
                }
                if (("toggleChange" === en)) {
                    var pd_1 = (_co.updateShowP90() !== false);
                    ad = (pd_1 && ad);
                }
                return ad;
            }, e$1, d$a)), providerDef(5120, null, NG_VALUE_ACCESSOR, function (p0_0) { return [p0_0]; }, [MatSlideToggle]), directiveDef(59, 1228800, null, 0, MatSlideToggle, [ElementRef, FocusMonitor, ChangeDetectorRef, [8, null], NgZone, MAT_SLIDE_TOGGLE_DEFAULT_OPTIONS, [2, ANIMATION_MODULE_TYPE], [2, Directionality]], { checked: [0, "checked"] }, { toggleChange: "toggleChange" }), (_l()(), elementDef(60, 0, null, null, 1, "op-table", [], null, null, null, View_OpTable_0, RenderType_OpTable)), directiveDef(61, 180224, null, 0, OpTable, [Store], { rootNode: [0, "rootNode"], byWasted: [1, "byWasted"], showP90: [2, "showP90"], childrenCount: [3, "childrenCount"] }, null)], function (_ck, _v) { var _co = _v.component; var currVal_15 = _co.isByCategory; _ck(_v, 21, 0, currVal_15); var currVal_50 = "number"; var currVal_51 = _co.childrenCount; _ck(_v, 37, 0, currVal_50, currVal_51); var currVal_69 = 100; var currVal_70 = 10; var currVal_71 = 10; var currVal_72 = _co.childrenCount; _ck(_v, 43, 0, currVal_69, currVal_70, currVal_71, currVal_72); _ck(_v, 48, 0); var currVal_75 = "above"; var currVal_76 = "Wasted time is defined by RuntimeFraction *\n                              (1 - max(FlopsUtilization, MemoryBandwidthUtilization))."; _ck(_v, 49, 0, currVal_75, currVal_76); var currVal_85 = _co.byWasted; _ck(_v, 53, 0, currVal_85); var currVal_94 = _co.showP90; _ck(_v, 59, 0, currVal_94); var currVal_95 = _co.rootNode; var currVal_96 = _co.byWasted; var currVal_97 = _co.showP90; var currVal_98 = _co.childrenCount; _ck(_v, 61, 0, currVal_95, currVal_96, currVal_97, currVal_98); }, function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.deviceType; _ck(_v, 3, 0, currVal_0); var currVal_1 = _co.data.flopsColor; _ck(_v, 4, 0, currVal_1); var currVal_2 = _co.data.flopsUtilizationPercent; _ck(_v, 5, 0, currVal_2); var currVal_3 = _co.data.bwColor; _ck(_v, 8, 0, currVal_3); var currVal_4 = _co.data.memoryBandwidthUtilizationPercent; _ck(_v, 9, 0, currVal_4); var currVal_5 = _co.deviceType; _ck(_v, 12, 0, currVal_5); var currVal_6 = !_co.hasTwoProfiles; _ck(_v, 16, 0, currVal_6); var currVal_7 = nodeValue(_v, 21).id; var currVal_8 = (nodeValue(_v, 21).disabled ? null : (0 - 1)); var currVal_9 = null; var currVal_10 = null; var currVal_11 = nodeValue(_v, 21).checked; var currVal_12 = nodeValue(_v, 21).disabled; var currVal_13 = (nodeValue(_v, 21).labelPosition == "before"); var currVal_14 = (nodeValue(_v, 21)._animationMode === "NoopAnimations"); _ck(_v, 19, 0, currVal_7, currVal_8, currVal_9, currVal_10, currVal_11, currVal_12, currVal_13, currVal_14); var currVal_16 = (nodeValue(_v, 26).appearance == "standard"); var currVal_17 = (nodeValue(_v, 26).appearance == "fill"); var currVal_18 = (nodeValue(_v, 26).appearance == "outline"); var currVal_19 = (nodeValue(_v, 26).appearance == "legacy"); var currVal_20 = nodeValue(_v, 26)._control.errorState; var currVal_21 = nodeValue(_v, 26)._canLabelFloat; var currVal_22 = nodeValue(_v, 26)._shouldLabelFloat(); var currVal_23 = nodeValue(_v, 26)._hasFloatingLabel(); var currVal_24 = nodeValue(_v, 26)._hideControlPlaceholder(); var currVal_25 = nodeValue(_v, 26)._control.disabled; var currVal_26 = nodeValue(_v, 26)._control.autofilled; var currVal_27 = nodeValue(_v, 26)._control.focused; var currVal_28 = (nodeValue(_v, 26).color == "accent"); var currVal_29 = (nodeValue(_v, 26).color == "warn"); var currVal_30 = nodeValue(_v, 26)._shouldForward("untouched"); var currVal_31 = nodeValue(_v, 26)._shouldForward("touched"); var currVal_32 = nodeValue(_v, 26)._shouldForward("pristine"); var currVal_33 = nodeValue(_v, 26)._shouldForward("dirty"); var currVal_34 = nodeValue(_v, 26)._shouldForward("valid"); var currVal_35 = nodeValue(_v, 26)._shouldForward("invalid"); var currVal_36 = nodeValue(_v, 26)._shouldForward("pending"); var currVal_37 = !nodeValue(_v, 26)._animationsEnabled; _ck(_v, 25, 1, [currVal_16, currVal_17, currVal_18, currVal_19, currVal_20, currVal_21, currVal_22, currVal_23, currVal_24, currVal_25, currVal_26, currVal_27, currVal_28, currVal_29, currVal_30, currVal_31, currVal_32, currVal_33, currVal_34, currVal_35, currVal_36, currVal_37]); var currVal_38 = 10; var currVal_39 = 100; var currVal_40 = 10; var currVal_41 = nodeValue(_v, 37)._isServer; var currVal_42 = nodeValue(_v, 37).id; var currVal_43 = nodeValue(_v, 37).placeholder; var currVal_44 = nodeValue(_v, 37).disabled; var currVal_45 = nodeValue(_v, 37).required; var currVal_46 = ((nodeValue(_v, 37).readonly && !nodeValue(_v, 37)._isNativeSelect) || null); var currVal_47 = (nodeValue(_v, 37)._ariaDescribedby || null); var currVal_48 = nodeValue(_v, 37).errorState; var currVal_49 = nodeValue(_v, 37).required.toString(); _ck(_v, 36, 1, [currVal_38, currVal_39, currVal_40, currVal_41, currVal_42, currVal_43, currVal_44, currVal_45, currVal_46, currVal_47, currVal_48, currVal_49]); var currVal_52 = nodeValue(_v, 43).tabIndex; var currVal_53 = nodeValue(_v, 43).disabled; var currVal_54 = nodeValue(_v, 43).max; var currVal_55 = nodeValue(_v, 43).min; var currVal_56 = nodeValue(_v, 43).value; var currVal_57 = (nodeValue(_v, 43).vertical ? "vertical" : "horizontal"); var currVal_58 = nodeValue(_v, 43).disabled; var currVal_59 = nodeValue(_v, 43).tickInterval; var currVal_60 = !nodeValue(_v, 43).vertical; var currVal_61 = nodeValue(_v, 43)._invertAxis; var currVal_62 = nodeValue(_v, 43)._shouldInvertMouseCoords(); var currVal_63 = nodeValue(_v, 43)._isSliding; var currVal_64 = nodeValue(_v, 43).thumbLabel; var currVal_65 = nodeValue(_v, 43).vertical; var currVal_66 = nodeValue(_v, 43)._isMinValue; var currVal_67 = (nodeValue(_v, 43).disabled || ((nodeValue(_v, 43)._isMinValue && nodeValue(_v, 43)._thumbGap) && nodeValue(_v, 43)._invertAxis)); var currVal_68 = (nodeValue(_v, 43)._animationMode === "NoopAnimations"); _ck(_v, 41, 1, [currVal_52, currVal_53, currVal_54, currVal_55, currVal_56, currVal_57, currVal_58, currVal_59, currVal_60, currVal_61, currVal_62, currVal_63, currVal_64, currVal_65, currVal_66, currVal_67, currVal_68]); var currVal_73 = nodeValue(_v, 48).inline; var currVal_74 = (((nodeValue(_v, 48).color !== "primary") && (nodeValue(_v, 48).color !== "accent")) && (nodeValue(_v, 48).color !== "warn")); _ck(_v, 47, 0, currVal_73, currVal_74); var currVal_77 = nodeValue(_v, 53).id; var currVal_78 = (nodeValue(_v, 53).disabled ? null : (0 - 1)); var currVal_79 = null; var currVal_80 = null; var currVal_81 = nodeValue(_v, 53).checked; var currVal_82 = nodeValue(_v, 53).disabled; var currVal_83 = (nodeValue(_v, 53).labelPosition == "before"); var currVal_84 = (nodeValue(_v, 53)._animationMode === "NoopAnimations"); _ck(_v, 51, 0, currVal_77, currVal_78, currVal_79, currVal_80, currVal_81, currVal_82, currVal_83, currVal_84); var currVal_86 = nodeValue(_v, 59).id; var currVal_87 = (nodeValue(_v, 59).disabled ? null : (0 - 1)); var currVal_88 = null; var currVal_89 = null; var currVal_90 = nodeValue(_v, 59).checked; var currVal_91 = nodeValue(_v, 59).disabled; var currVal_92 = (nodeValue(_v, 59).labelPosition == "before"); var currVal_93 = (nodeValue(_v, 59)._animationMode === "NoopAnimations"); _ck(_v, 57, 0, currVal_86, currVal_87, currVal_88, currVal_89, currVal_90, currVal_91, currVal_92, currVal_93); });
    }
    function View_OpProfile_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "op-profile", [], null, null, null, View_OpProfile_0, RenderType_OpProfile)), directiveDef(1, 180224, null, 0, OpProfile, [ActivatedRoute, DataService, Store], null, null)], null, null); }
    var OpProfileNgFactory = createComponentFactory("op-profile", OpProfile, View_OpProfile_Host_0, {}, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$t = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}[_nghost-%COMP%]{display:block}.section-container[_ngcontent-%COMP%]{padding:20px}mat-slider[_ngcontent-%COMP%]{width:200px}.chart-title[_ngcontent-%COMP%]{font-size:24px;padding-bottom:8px}.control[_ngcontent-%COMP%]{color:#5f6368}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$u = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}[_nghost-%COMP%]{display:block;padding-top:20px}.topology-header[_ngcontent-%COMP%]{display:flex;flex-direction:row;margin-top:-32px}.control-row-left[_ngcontent-%COMP%]{display:flex;margin-right:32px;flex-flow:row nowrap;align-items:center;line-height:50px;text-align:bottom;justify-content:flex-start}.container[_ngcontent-%COMP%]{position:relative}.label[_ngcontent-%COMP%]{position:absolute;width:0;height:0}.label[_ngcontent-%COMP%]   .title[_ngcontent-%COMP%]{position:absolute;top:-7px;left:-15px;font-size:14px;line-height:14px;width:30px;text-align:center}.host[_ngcontent-%COMP%]{position:absolute;border-radius:8px;border:1px solid #333;background-color:#eee}.node[_ngcontent-%COMP%]{position:absolute;border-radius:4px;border:1px solid #333;width:15px;height:30px;background-color:#1d91c0;transition:background-color 1s}.color-table[_ngcontent-%COMP%]{display:flex;flex-wrap:nowrap;padding:20px 20px 0}.color-cell[_ngcontent-%COMP%]{margin:0 22px;border:1px solid #333;width:15px;height:30px;border-radius:4px}.color-label[_ngcontent-%COMP%]{width:60px;margin:8px 0;text-align:center}.selected-metric-label[_ngcontent-%COMP%]{text-transform:uppercase;padding-right:8px}.selected-metric-item[_ngcontent-%COMP%]{font-weight:bold;background:rgba(0,0,0,.02)}.channel-input[_ngcontent-%COMP%]{width:70px}.arrow-container[_ngcontent-%COMP%]{position:absolute;pointer-events:none}.arrow-container[_ngcontent-%COMP%]   svg[_ngcontent-%COMP%]{overflow:visible}.arrow[_ngcontent-%COMP%]{fill:red;transform-origin:0px 0px}.node-tooltip[_ngcontent-%COMP%]{position:absolute;background-color:#fff;padding:10px;border-radius:8px;width:200px;font-size:12px;line-height:20px;font-family:sans-serif;pointer-events:none}.node-tooltip[_ngcontent-%COMP%] > pre[_ngcontent-%COMP%]{margin:0;white-space:pre-wrap}.control[_ngcontent-%COMP%]{color:#5f6368}"];
    var _MatMenuDirectivesModuleNgFactory = createNgModuleFactory(_MatMenuDirectivesModule, [], function (_l) {
        return moduleDef([
            moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [
                [
                    8,
                    []
                ],
                [
                    3,
                    ComponentFactoryResolver
                ],
                NgModuleRef
            ]),
            moduleProvideDef(5120, MAT_MENU_SCROLL_STRATEGY, MAT_MENU_SCROLL_STRATEGY_FACTORY, [Overlay]),
            moduleProvideDef(1073742336, BidiModule, BidiModule, []),
            moduleProvideDef(1073742336, MatCommonModule, MatCommonModule, [
                [
                    2,
                    MATERIAL_SANITY_CHECKS
                ],
                [
                    2,
                    HAMMER_LOADER
                ]
            ]),
            moduleProvideDef(1073742336, _MatMenuDirectivesModule, _MatMenuDirectivesModule, [])
        ]);
    });
    var MatMenuModuleNgFactory = createNgModuleFactory(MatMenuModule, [], function (_l) {
        return moduleDef([
            moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [
                [
                    8,
                    []
                ],
                [
                    3,
                    ComponentFactoryResolver
                ],
                NgModuleRef
            ]),
            moduleProvideDef(4608, NgLocalization, NgLocaleLocalization, [
                LOCALE_ID$1,
                [
                    2,
                    DEPRECATED_PLURAL_FN
                ]
            ]),
            moduleProvideDef(4608, Overlay, Overlay, [
                ScrollStrategyOptions,
                OverlayContainer,
                ComponentFactoryResolver,
                OverlayPositionBuilder,
                OverlayKeyboardDispatcher,
                Injector,
                NgZone,
                DOCUMENT,
                Directionality,
                [
                    2,
                    Location
                ]
            ]),
            moduleProvideDef(5120, CDK_CONNECTED_OVERLAY_SCROLL_STRATEGY, CDK_CONNECTED_OVERLAY_SCROLL_STRATEGY_PROVIDER_FACTORY, [Overlay]),
            moduleProvideDef(5120, MAT_MENU_SCROLL_STRATEGY, MAT_MENU_SCROLL_STRATEGY_FACTORY, [Overlay]),
            moduleProvideDef(1073742336, CommonModule, CommonModule, []),
            moduleProvideDef(1073742336, BidiModule, BidiModule, []),
            moduleProvideDef(1073742336, MatCommonModule, MatCommonModule, [
                [
                    2,
                    MATERIAL_SANITY_CHECKS
                ],
                [
                    2,
                    HAMMER_LOADER
                ]
            ]),
            moduleProvideDef(1073742336, PlatformModule, PlatformModule, []),
            moduleProvideDef(1073742336, MatRippleModule, MatRippleModule, []),
            moduleProvideDef(1073742336, PortalModule, PortalModule, []),
            moduleProvideDef(1073742336, ScrollingModule, ScrollingModule, []),
            moduleProvideDef(1073742336, OverlayModule, OverlayModule, []),
            moduleProvideDef(1073742336, _MatMenuDirectivesModule, _MatMenuDirectivesModule, []),
            moduleProvideDef(1073742336, MatMenuModule, MatMenuModule, [])
        ]);
    });
    var styles__MatMenu = [".mat-menu-panel{min-width:112px;max-width:280px;overflow:auto;-webkit-overflow-scrolling:touch;max-height:calc(100vh - 48px);border-radius:4px;outline:0;min-height:64px}.mat-menu-panel.ng-animating{pointer-events:none}@media (-ms-high-contrast:active){.mat-menu-panel{outline:solid 1px}}.mat-menu-content:not(:empty){padding-top:8px;padding-bottom:8px}.mat-menu-item{-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:pointer;outline:0;border:none;-webkit-tap-highlight-color:transparent;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;display:block;line-height:48px;height:48px;padding:0 16px;text-align:left;text-decoration:none;max-width:100%;position:relative}.mat-menu-item::-moz-focus-inner{border:0}.mat-menu-item[disabled]{cursor:default}[dir=rtl] .mat-menu-item{text-align:right}.mat-menu-item .mat-icon{margin-right:16px;vertical-align:middle}.mat-menu-item .mat-icon svg{vertical-align:top}[dir=rtl] .mat-menu-item .mat-icon{margin-left:16px;margin-right:0}.mat-menu-item[disabled]{pointer-events:none}@media (-ms-high-contrast:active){.mat-menu-item-highlighted,.mat-menu-item.cdk-keyboard-focused,.mat-menu-item.cdk-program-focused{outline:dotted 1px}}.mat-menu-item-submenu-trigger{padding-right:32px}.mat-menu-item-submenu-trigger::after{width:0;height:0;border-style:solid;border-width:5px 0 5px 5px;border-color:transparent transparent transparent currentColor;content:'';display:inline-block;position:absolute;top:50%;right:16px;transform:translateY(-50%)}[dir=rtl] .mat-menu-item-submenu-trigger{padding-right:16px;padding-left:32px}[dir=rtl] .mat-menu-item-submenu-trigger::after{right:auto;left:16px;transform:rotateY(180deg) translateY(-50%)}button.mat-menu-item{width:100%}.mat-menu-item .mat-menu-ripple{top:0;left:0;right:0;bottom:0;position:absolute;pointer-events:none}"];
    var RenderType__MatMenu = createRendererType2({
        encapsulation: 2,
        styles: styles__MatMenu,
        data: {
            'animation': [
                {
                    type: 7,
                    name: 'transformMenu',
                    definitions: [
                        {
                            type: 0,
                            name: 'void',
                            styles: {
                                type: 6,
                                styles: {
                                    opacity: 0,
                                    transform: 'scale(0.8)'
                                },
                                offset: null
                            },
                            options: undefined
                        },
                        {
                            type: 1,
                            expr: 'void => enter',
                            animation: {
                                type: 3,
                                steps: [
                                    {
                                        type: 11,
                                        selector: '.mat-menu-content, .mat-mdc-menu-content',
                                        animation: {
                                            type: 4,
                                            styles: {
                                                type: 6,
                                                styles: { opacity: 1 },
                                                offset: null
                                            },
                                            timings: '100ms linear'
                                        },
                                        options: null
                                    },
                                    {
                                        type: 4,
                                        styles: {
                                            type: 6,
                                            styles: { transform: 'scale(1)' },
                                            offset: null
                                        },
                                        timings: '120ms cubic-bezier(0, 0, 0.2, 1)'
                                    }
                                ],
                                options: null
                            },
                            options: null
                        },
                        {
                            type: 1,
                            expr: '* => void',
                            animation: {
                                type: 4,
                                styles: {
                                    type: 6,
                                    styles: { opacity: 0 },
                                    offset: null
                                },
                                timings: '100ms 25ms linear'
                            },
                            options: null
                        }
                    ],
                    options: {}
                },
                {
                    type: 7,
                    name: 'fadeInItems',
                    definitions: [
                        {
                            type: 0,
                            name: 'showing',
                            styles: {
                                type: 6,
                                styles: { opacity: 1 },
                                offset: null
                            },
                            options: undefined
                        },
                        {
                            type: 1,
                            expr: 'void => *',
                            animation: [
                                {
                                    type: 6,
                                    styles: { opacity: 0 },
                                    offset: null
                                },
                                {
                                    type: 4,
                                    styles: null,
                                    timings: '400ms 100ms cubic-bezier(0.55, 0, 0.55, 0.2)'
                                }
                            ],
                            options: null
                        }
                    ],
                    options: {}
                }
            ]
        }
    });
    function View__MatMenu_1(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 4, 'div', [
                [
                    'class',
                    'mat-menu-panel'
                ],
                [
                    'role',
                    'menu'
                ],
                [
                    'tabindex',
                    '-1'
                ]
            ], [[
                    24,
                    '@transformMenu',
                    0
                ]], [
                [
                    null,
                    'keydown'
                ],
                [
                    null,
                    'click'
                ],
                [
                    null,
                    '@transformMenu.start'
                ],
                [
                    null,
                    '@transformMenu.done'
                ]
            ], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if ('keydown' === en) {
                    var pd_0 = _co._handleKeydown($event) !== false;
                    ad = pd_0 && ad;
                }
                if ('click' === en) {
                    var pd_1 = _co.closed.emit('click') !== false;
                    ad = pd_1 && ad;
                }
                if ('@transformMenu.start' === en) {
                    var pd_2 = _co._onAnimationStart($event) !== false;
                    ad = pd_2 && ad;
                }
                if ('@transformMenu.done' === en) {
                    var pd_3 = _co._onAnimationDone($event) !== false;
                    ad = pd_3 && ad;
                }
                return ad;
            }, null, null)),
            providerDef(512, null, NgClassImpl, NgClassR2Impl, [
                IterableDiffers,
                KeyValueDiffers,
                ElementRef,
                Renderer2
            ]),
            directiveDef(2, 278528, null, 0, NgClass, [NgClassImpl], {
                klass: [
                    0,
                    'klass'
                ],
                ngClass: [
                    1,
                    'ngClass'
                ]
            }, null),
            (_l()(), elementDef(3, 0, null, null, 1, 'div', [[
                    'class',
                    'mat-menu-content'
                ]], null, null, null, null, null)),
            ngContentDef(null, 0)
        ], function (_ck, _v) {
            var _co = _v.component;
            var currVal_1 = 'mat-menu-panel';
            var currVal_2 = _co._classList;
            _ck(_v, 2, 0, currVal_1, currVal_2);
        }, function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co._panelAnimationState;
            _ck(_v, 0, 0, currVal_0);
        });
    }
    function View__MatMenu_0(_l) {
        return viewDef(2, [
            queryDef(671088640, 1, { templateRef: 0 }),
            (_l()(), anchorDef(0, [[
                    1,
                    2
                ]], null, 0, null, View__MatMenu_1))
        ], null, null);
    }
    function View__MatMenu_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 6, 'mat-menu', [], null, null, null, View__MatMenu_0, RenderType__MatMenu)),
            providerDef(6144, null, MatMenu, null, [_MatMenu]),
            providerDef(6144, null, MAT_MENU_PANEL, null, [MatMenu]),
            directiveDef(3, 1294336, null, 3, _MatMenu, [
                ElementRef,
                NgZone,
                MAT_MENU_DEFAULT_OPTIONS
            ], null, null),
            queryDef(603979776, 1, { _allItems: 1 }),
            queryDef(603979776, 2, { items: 1 }),
            queryDef(603979776, 3, { lazyContent: 0 })
        ], function (_ck, _v) {
            _ck(_v, 3, 0);
        }, null);
    }
    var _MatMenuNgFactory = createComponentFactory('mat-menu', _MatMenu, View__MatMenu_Host_0, {
        backdropClass: 'backdropClass',
        xPosition: 'xPosition',
        yPosition: 'yPosition',
        overlapTrigger: 'overlapTrigger',
        hasBackdrop: 'hasBackdrop',
        panelClass: 'class',
        classList: 'classList'
    }, {
        closed: 'closed',
        close: 'close'
    }, ['*']);
    var styles_MatMenuItem = [];
    var RenderType_MatMenuItem = createRendererType2({
        encapsulation: 2,
        styles: styles_MatMenuItem,
        data: {}
    });
    function View_MatMenuItem_0(_l) {
        return viewDef(2, [
            ngContentDef(null, 0),
            (_l()(), elementDef(1, 0, null, null, 1, 'div', [
                [
                    'class',
                    'mat-menu-ripple mat-ripple'
                ],
                [
                    'matRipple',
                    ''
                ]
            ], [[
                    2,
                    'mat-ripple-unbounded',
                    null
                ]], null, null, null, null)),
            directiveDef(2, 212992, null, 0, MatRipple, [
                ElementRef,
                NgZone,
                Platform,
                [
                    2,
                    MAT_RIPPLE_GLOBAL_OPTIONS
                ],
                [
                    2,
                    ANIMATION_MODULE_TYPE
                ]
            ], {
                disabled: [
                    0,
                    'disabled'
                ],
                trigger: [
                    1,
                    'trigger'
                ]
            }, null)
        ], function (_ck, _v) {
            var _co = _v.component;
            var currVal_1 = _co.disableRipple || _co.disabled;
            var currVal_2 = _co._getHostElement();
            _ck(_v, 2, 0, currVal_1, currVal_2);
        }, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 2).unbounded;
            _ck(_v, 1, 0, currVal_0);
        });
    }
    function View_MatMenuItem_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'div', [
                [
                    'class',
                    'mat-menu-item'
                ],
                [
                    'mat-menu-item',
                    ''
                ]
            ], [
                [
                    1,
                    'role',
                    0
                ],
                [
                    2,
                    'mat-menu-item-highlighted',
                    null
                ],
                [
                    2,
                    'mat-menu-item-submenu-trigger',
                    null
                ],
                [
                    1,
                    'tabindex',
                    0
                ],
                [
                    1,
                    'aria-disabled',
                    0
                ],
                [
                    1,
                    'disabled',
                    0
                ]
            ], [
                [
                    null,
                    'click'
                ],
                [
                    null,
                    'mouseenter'
                ]
            ], function (_v, en, $event) {
                var ad = true;
                if ('click' === en) {
                    var pd_0 = nodeValue(_v, 1)._checkDisabled($event) !== false;
                    ad = pd_0 && ad;
                }
                if ('mouseenter' === en) {
                    var pd_1 = nodeValue(_v, 1)._handleMouseEnter() !== false;
                    ad = pd_1 && ad;
                }
                return ad;
            }, View_MatMenuItem_0, RenderType_MatMenuItem)),
            directiveDef(1, 180224, null, 0, MatMenuItem, [
                ElementRef,
                DOCUMENT,
                FocusMonitor,
                [
                    2,
                    MAT_MENU_PANEL
                ]
            ], null, null)
        ], null, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 1).role;
            var currVal_1 = nodeValue(_v, 1)._highlighted;
            var currVal_2 = nodeValue(_v, 1)._triggersSubmenu;
            var currVal_3 = nodeValue(_v, 1)._getTabIndex();
            var currVal_4 = nodeValue(_v, 1).disabled.toString();
            var currVal_5 = nodeValue(_v, 1).disabled || null;
            _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5);
        });
    }
    var MatMenuItemNgFactory = createComponentFactory('[mat-menu-item]', MatMenuItem, View_MatMenuItem_Host_0, {
        disabled: 'disabled',
        disableRipple: 'disableRipple',
        role: 'role'
    }, {}, ['*']);
    var d$b = RenderType__MatMenu;
    var e$2 = View__MatMenu_0;
    var h$2 = RenderType_MatMenuItem;
    var i$1 = View_MatMenuItem_0;
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_TopologyGraph = [styles$u];
    var RenderType_TopologyGraph = createRendererType2({ encapsulation: 0, styles: styles_TopologyGraph, data: {} });
    function View_TopologyGraph_1(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 5, "button", [["class", "mat-menu-item"], ["mat-menu-item", ""]], [[1, "role", 0], [2, "mat-menu-item-highlighted", null], [2, "mat-menu-item-submenu-trigger", null], [1, "tabindex", 0], [1, "aria-disabled", 0], [1, "disabled", 0]], [[null, "click"], [null, "mouseenter"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("click" === en)) {
                    var pd_0 = (nodeValue(_v, 4)._checkDisabled($event) !== false);
                    ad = (pd_0 && ad);
                }
                if (("mouseenter" === en)) {
                    var pd_1 = (nodeValue(_v, 4)._handleMouseEnter() !== false);
                    ad = (pd_1 && ad);
                }
                if (("click" === en)) {
                    var pd_2 = (_co.selectMetric(_v.context.$implicit.id, _v.context.$implicit.name) !== false);
                    ad = (pd_2 && ad);
                }
                return ad;
            }, i$1, h$2)), providerDef(512, null, NgClassImpl, NgClassR2Impl, [IterableDiffers, KeyValueDiffers, ElementRef, Renderer2]), directiveDef(2, 278528, null, 0, NgClass, [NgClassImpl], { ngClass: [0, "ngClass"] }, null), pureObjectDef(3, { "selected-metric-item": 0 }), directiveDef(4, 180224, [[1, 4], [2, 4]], 0, MatMenuItem, [ElementRef, DOCUMENT, FocusMonitor, [2, MAT_MENU_PANEL]], null, null), (_l()(), textDef(5, 0, [" ", " "]))], function (_ck, _v) { var _co = _v.component; var currVal_6 = _ck(_v, 3, 0, (_co.selectedMetric === _v.context.$implicit.id)); _ck(_v, 2, 0, currVal_6); }, function (_ck, _v) { var currVal_0 = nodeValue(_v, 4).role; var currVal_1 = nodeValue(_v, 4)._highlighted; var currVal_2 = nodeValue(_v, 4)._triggersSubmenu; var currVal_3 = nodeValue(_v, 4)._getTabIndex(); var currVal_4 = nodeValue(_v, 4).disabled.toString(); var currVal_5 = (nodeValue(_v, 4).disabled || null); _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5); var currVal_7 = _v.context.$implicit.name; _ck(_v, 5, 0, currVal_7); });
    }
    function View_TopologyGraph_2(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 2, "div", [["class", "label"]], [[4, "top", null], [4, "left", null]], null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 1, "div", [["class", "title"]], null, null, null, null, null)), (_l()(), textDef(2, null, ["", ""]))], null, function (_ck, _v) { var currVal_0 = (_v.context.$implicit.y + "px"); var currVal_1 = (_v.context.$implicit.x + "px"); _ck(_v, 0, 0, currVal_0, currVal_1); var currVal_2 = _v.context.$implicit.id; _ck(_v, 2, 0, currVal_2); }); }
    function View_TopologyGraph_3(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 0, "div", [["class", "host"]], [[4, "width", null], [4, "height", null], [4, "top", null], [4, "left", null]], null, null, null, null))], null, function (_ck, _v) { var _co = _v.component; var currVal_0 = (_co.hostWidth + "px"); var currVal_1 = (_co.hostHeight + "px"); var currVal_2 = (_v.context.$implicit.y + "px"); var currVal_3 = (_v.context.$implicit.x + "px"); _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2, currVal_3); }); }
    function View_TopologyGraph_4(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 0, "div", [["class", "node"]], [[8, "id", 0], [1, "rid", 0], [4, "top", null], [4, "left", null]], [[null, "mouseenter"], [null, "mouseleave"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("mouseenter" === en)) {
                    var pd_0 = (_co.showTooltip(_v.context.$implicit.id) !== false);
                    ad = (pd_0 && ad);
                }
                if (("mouseleave" === en)) {
                    var pd_1 = (_co.hideTooltip() !== false);
                    ad = (pd_1 && ad);
                }
                return ad;
            }, null, null))], null, function (_ck, _v) { var currVal_0 = _v.context.$implicit.id; var currVal_1 = _v.context.$implicit.rid; var currVal_2 = (_v.context.$implicit.y + "px"); var currVal_3 = (_v.context.$implicit.x + "px"); _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2, currVal_3); });
    }
    function View_TopologyGraph_5(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 4, "div", [["class", "arrow-container"]], [[4, "top", null], [4, "left", null]], null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 3, ":svg:svg", [], null, null, null, null, null)), (_l()(), elementDef(2, 0, null, null, 2, ":svg:g", [["class", "arrow"]], [[4, "transform", null]], null, null, null, null)), (_l()(), elementDef(3, 0, null, null, 0, ":svg:polygon", [["points", "3,0 -6,-5 -6,5"]], null, null, null, null, null)), (_l()(), elementDef(4, 0, null, null, 0, ":svg:polygon", [["points", "0,-1.5 -100,-1.5, -100,1.5 0,1.5"]], [[4, "transform", null]], null, null, null, null))], null, function (_ck, _v) { var currVal_0 = (_v.context.$implicit.y + "px"); var currVal_1 = (_v.context.$implicit.x + "px"); _ck(_v, 0, 0, currVal_0, currVal_1); var currVal_2 = (("rotate(" + _v.context.$implicit.rotate) + "rad)"); _ck(_v, 2, 0, currVal_2); var currVal_3 = (("scaleX(" + _v.context.$implicit.scale) + ")"); _ck(_v, 4, 0, currVal_3); }); }
    function View_TopologyGraph_6(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 3, "div", [], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 0, "div", [["class", "color-cell"]], [[4, "backgroundColor", null]], null, null, null, null)), (_l()(), elementDef(2, 0, null, null, 1, "div", [["class", "color-label"]], null, null, null, null, null)), (_l()(), textDef(3, null, ["\u2265 ", ""]))], null, function (_ck, _v) { var currVal_0 = _v.context.$implicit.color; _ck(_v, 1, 0, currVal_0); var currVal_1 = _v.context.$implicit.label; _ck(_v, 3, 0, currVal_1); }); }
    function View_TopologyGraph_0(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 56, "div", [], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 1, "div", [["class", "mat-title"]], null, null, null, null, null)), (_l()(), textDef(2, null, [" ", " ", "x", " "])), (_l()(), elementDef(3, 0, null, null, 38, "div", [["class", "topology-header"]], null, null, null, null, null)), (_l()(), elementDef(4, 0, null, null, 17, "div", [["class", "control-row-left"]], null, null, null, null, null)), (_l()(), elementDef(5, 0, null, null, 1, "span", [["class", "selected-metric-label control"]], null, null, null, null, null)), (_l()(), textDef(6, null, ["", ""])), (_l()(), elementDef(7, 16777216, null, null, 5, "button", [["aria-haspopup", "true"], ["aria-label", "Metric menu"], ["class", "mat-menu-trigger"], ["mat-icon-button", ""]], [[1, "disabled", 0], [2, "_mat-animation-noopable", null], [1, "aria-expanded", 0]], [[null, "mousedown"], [null, "keydown"], [null, "click"]], function (_v, en, $event) {
                var ad = true;
                if (("mousedown" === en)) {
                    var pd_0 = (nodeValue(_v, 9)._handleMousedown($event) !== false);
                    ad = (pd_0 && ad);
                }
                if (("keydown" === en)) {
                    var pd_1 = (nodeValue(_v, 9)._handleKeydown($event) !== false);
                    ad = (pd_1 && ad);
                }
                if (("click" === en)) {
                    var pd_2 = (nodeValue(_v, 9)._handleClick($event) !== false);
                    ad = (pd_2 && ad);
                }
                return ad;
            }, d, c)), directiveDef(8, 180224, null, 0, MatButton, [ElementRef, FocusMonitor, [2, ANIMATION_MODULE_TYPE]], null, null), directiveDef(9, 1196032, null, 0, MatMenuTrigger, [Overlay, ElementRef, ViewContainerRef, MAT_MENU_SCROLL_STRATEGY, [2, MatMenu], [8, null], [2, Directionality], FocusMonitor], { menu: [0, "menu"] }, null), (_l()(), elementDef(10, 0, null, 0, 2, "mat-icon", [["class", "mat-icon notranslate"], ["role", "img"]], [[2, "mat-icon-inline", null], [2, "mat-icon-no-color", null]], null, null, d$5, c$5)), directiveDef(11, 9158656, null, 0, MatIcon, [ElementRef, MatIconRegistry, [8, null], [2, MAT_ICON_LOCATION], [2, ErrorHandler]], null, null), (_l()(), textDef(-1, 0, ["arrow_drop_down"])), (_l()(), elementDef(13, 0, null, null, 8, "mat-menu", [], null, null, null, e$2, d$b)), providerDef(6144, null, MatMenu, null, [_MatMenu]), providerDef(6144, null, MAT_MENU_PANEL, null, [MatMenu]), directiveDef(16, 1294336, [["mecticMenu", 4]], 3, _MatMenu, [ElementRef, NgZone, MAT_MENU_DEFAULT_OPTIONS], null, null), queryDef(603979776, 1, { _allItems: 1 }), queryDef(603979776, 2, { items: 1 }), queryDef(603979776, 3, { lazyContent: 0 }), (_l()(), anchorDef(16777216, null, 0, 1, null, View_TopologyGraph_1)), directiveDef(21, 278528, null, 0, NgForOf, [ViewContainerRef, TemplateRef, IterableDiffers], { ngForOf: [0, "ngForOf"] }, null), (_l()(), elementDef(22, 0, null, null, 19, "div", [["class", "control-row-left "]], [[4, "visibility", null]], null, null, null, null)), (_l()(), elementDef(23, 0, null, null, 1, "span", [["class", "control"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["PLEASE SELECT A CHANNEL ID\u00A0"])), (_l()(), elementDef(25, 0, null, null, 2, "mat-slider", [["class", "mat-slider"], ["role", "slider"]], [[8, "tabIndex", 0], [1, "aria-disabled", 0], [1, "aria-valuemax", 0], [1, "aria-valuemin", 0], [1, "aria-valuenow", 0], [1, "aria-orientation", 0], [2, "mat-slider-disabled", null], [2, "mat-slider-has-ticks", null], [2, "mat-slider-horizontal", null], [2, "mat-slider-axis-inverted", null], [2, "mat-slider-invert-mouse-coords", null], [2, "mat-slider-sliding", null], [2, "mat-slider-thumb-label-showing", null], [2, "mat-slider-vertical", null], [2, "mat-slider-min-value", null], [2, "mat-slider-hide-last-tick", null], [2, "_mat-animation-noopable", null]], [[null, "change"], [null, "focus"], [null, "blur"], [null, "mousedown"], [null, "keydown"], [null, "keyup"], [null, "mouseenter"], [null, "slide"], [null, "slideend"], [null, "slidestart"], [null, "selectstart"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("focus" === en)) {
                    var pd_0 = (nodeValue(_v, 27)._onFocus() !== false);
                    ad = (pd_0 && ad);
                }
                if (("blur" === en)) {
                    var pd_1 = (nodeValue(_v, 27)._onBlur() !== false);
                    ad = (pd_1 && ad);
                }
                if (("mousedown" === en)) {
                    var pd_2 = (nodeValue(_v, 27)._onMousedown($event) !== false);
                    ad = (pd_2 && ad);
                }
                if (("keydown" === en)) {
                    var pd_3 = (nodeValue(_v, 27)._onKeydown($event) !== false);
                    ad = (pd_3 && ad);
                }
                if (("keyup" === en)) {
                    var pd_4 = (nodeValue(_v, 27)._onKeyup() !== false);
                    ad = (pd_4 && ad);
                }
                if (("mouseenter" === en)) {
                    var pd_5 = (nodeValue(_v, 27)._onMouseenter() !== false);
                    ad = (pd_5 && ad);
                }
                if (("slide" === en)) {
                    var pd_6 = (nodeValue(_v, 27)._onSlide($event) !== false);
                    ad = (pd_6 && ad);
                }
                if (("slideend" === en)) {
                    var pd_7 = (nodeValue(_v, 27)._onSlideEnd() !== false);
                    ad = (pd_7 && ad);
                }
                if (("slidestart" === en)) {
                    var pd_8 = (nodeValue(_v, 27)._onSlideStart($event) !== false);
                    ad = (pd_8 && ad);
                }
                if (("selectstart" === en)) {
                    var pd_9 = ($event.preventDefault() !== false);
                    ad = (pd_9 && ad);
                }
                if (("change" === en)) {
                    var pd_10 = (_co.updateChannelIndex($event.value) !== false);
                    ad = (pd_10 && ad);
                }
                return ad;
            }, d$8, c$8)), providerDef(5120, null, NG_VALUE_ACCESSOR, function (p0_0) { return [p0_0]; }, [MatSlider]), directiveDef(27, 245760, null, 0, MatSlider, [ElementRef, FocusMonitor, ChangeDetectorRef, [2, Directionality], [8, null], [2, ANIMATION_MODULE_TYPE]], { max: [0, "max"], min: [1, "min"], step: [2, "step"], value: [3, "value"] }, { change: "change" }), (_l()(), elementDef(28, 0, null, null, 13, "mat-form-field", [["class", "channel-input mat-form-field"]], [[2, "mat-form-field-appearance-standard", null], [2, "mat-form-field-appearance-fill", null], [2, "mat-form-field-appearance-outline", null], [2, "mat-form-field-appearance-legacy", null], [2, "mat-form-field-invalid", null], [2, "mat-form-field-can-float", null], [2, "mat-form-field-should-float", null], [2, "mat-form-field-has-label", null], [2, "mat-form-field-hide-placeholder", null], [2, "mat-form-field-disabled", null], [2, "mat-form-field-autofilled", null], [2, "mat-focused", null], [2, "mat-accent", null], [2, "mat-warn", null], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [2, "_mat-animation-noopable", null]], null, null, d$1, c$1)), directiveDef(29, 7520256, null, 9, MatFormField, [ElementRef, ChangeDetectorRef, [2, MAT_LABEL_GLOBAL_OPTIONS], [2, Directionality], [2, MAT_FORM_FIELD_DEFAULT_OPTIONS], Platform, NgZone, [2, ANIMATION_MODULE_TYPE]], null, null), queryDef(603979776, 4, { _controlNonStatic: 0 }), queryDef(335544320, 5, { _controlStatic: 0 }), queryDef(603979776, 6, { _labelChildNonStatic: 0 }), queryDef(335544320, 7, { _labelChildStatic: 0 }), queryDef(603979776, 8, { _placeholderChild: 0 }), queryDef(603979776, 9, { _errorChildren: 1 }), queryDef(603979776, 10, { _hintChildren: 1 }), queryDef(603979776, 11, { _prefixChildren: 1 }), queryDef(603979776, 12, { _suffixChildren: 1 }), (_l()(), elementDef(39, 0, null, 1, 2, "input", [["class", "mat-input-element mat-form-field-autofill-control"], ["matInput", ""], ["type", "number"]], [[8, "min", 0], [8, "max", 0], [8, "step", 0], [2, "mat-input-server", null], [1, "id", 0], [1, "placeholder", 0], [8, "disabled", 0], [8, "required", 0], [1, "readonly", 0], [1, "aria-describedby", 0], [1, "aria-invalid", 0], [1, "aria-required", 0]], [[null, "change"], [null, "blur"], [null, "focus"], [null, "input"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("blur" === en)) {
                    var pd_0 = (nodeValue(_v, 40)._focusChanged(false) !== false);
                    ad = (pd_0 && ad);
                }
                if (("focus" === en)) {
                    var pd_1 = (nodeValue(_v, 40)._focusChanged(true) !== false);
                    ad = (pd_1 && ad);
                }
                if (("input" === en)) {
                    var pd_2 = (nodeValue(_v, 40)._onInput() !== false);
                    ad = (pd_2 && ad);
                }
                if (("change" === en)) {
                    var pd_3 = (_co.updateChannelId($event.target.value) !== false);
                    ad = (pd_3 && ad);
                }
                return ad;
            }, null, null)), directiveDef(40, 999424, null, 0, MatInput, [ElementRef, Platform, [8, null], [2, NgForm], [2, FormGroupDirective], ErrorStateMatcher, [8, null], AutofillMonitor, NgZone], { type: [0, "type"], value: [1, "value"] }, null), providerDef(2048, [[4, 4], [5, 4]], MatFormFieldControl, null, [MatInput]), (_l()(), elementDef(42, 0, null, null, 11, "div", [["class", "container"]], [[4, "width", null], [4, "height", null]], null, null, null, null)), (_l()(), anchorDef(16777216, null, null, 1, null, View_TopologyGraph_2)), directiveDef(44, 278528, null, 0, NgForOf, [ViewContainerRef, TemplateRef, IterableDiffers], { ngForOf: [0, "ngForOf"] }, null), (_l()(), anchorDef(16777216, null, null, 1, null, View_TopologyGraph_3)), directiveDef(46, 278528, null, 0, NgForOf, [ViewContainerRef, TemplateRef, IterableDiffers], { ngForOf: [0, "ngForOf"] }, null), (_l()(), anchorDef(16777216, null, null, 1, null, View_TopologyGraph_4)), directiveDef(48, 278528, null, 0, NgForOf, [ViewContainerRef, TemplateRef, IterableDiffers], { ngForOf: [0, "ngForOf"] }, null), (_l()(), anchorDef(16777216, null, null, 1, null, View_TopologyGraph_5)), directiveDef(50, 278528, null, 0, NgForOf, [ViewContainerRef, TemplateRef, IterableDiffers], { ngForOf: [0, "ngForOf"] }, null), (_l()(), elementDef(51, 0, null, null, 2, "div", [["class", "node-tooltip mat-elevation-z2"]], [[4, "left", null], [4, "top", null], [8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(52, 0, null, null, 1, "pre", [], null, null, null, null, null)), (_l()(), textDef(53, null, ["", ""])), (_l()(), elementDef(54, 0, null, null, 2, "div", [["class", "color-table"]], null, null, null, null, null)), (_l()(), anchorDef(16777216, null, null, 1, null, View_TopologyGraph_6)), directiveDef(56, 278528, null, 0, NgForOf, [ViewContainerRef, TemplateRef, IterableDiffers], { ngForOf: [0, "ngForOf"] }, null)], function (_ck, _v) { var _co = _v.component; var currVal_7 = nodeValue(_v, 16); _ck(_v, 9, 0, currVal_7); _ck(_v, 11, 0); _ck(_v, 16, 0); var currVal_10 = _co.metricList; _ck(_v, 21, 0, currVal_10); var currVal_29 = _co.channelCount; var currVal_30 = 0; var currVal_31 = 1; var currVal_32 = _co.selectedChannelIndex; _ck(_v, 27, 0, currVal_29, currVal_30, currVal_31, currVal_32); var currVal_67 = "number"; var currVal_68 = _co.selectedChannelId; _ck(_v, 40, 0, currVal_67, currVal_68); var currVal_71 = _co.labels; _ck(_v, 44, 0, currVal_71); var currVal_72 = _co.hosts; _ck(_v, 46, 0, currVal_72); var currVal_73 = _co.nodes; _ck(_v, 48, 0, currVal_73); var currVal_74 = _co.arrows; _ck(_v, 50, 0, currVal_74); var currVal_79 = _co.colorInfos; _ck(_v, 56, 0, currVal_79); }, function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.deviceType; var currVal_1 = _co.xDimension; var currVal_2 = _co.yDimension; _ck(_v, 2, 0, currVal_0, currVal_1, currVal_2); var currVal_3 = _co.selectedMetricLabel; _ck(_v, 6, 0, currVal_3); var currVal_4 = (nodeValue(_v, 8).disabled || null); var currVal_5 = (nodeValue(_v, 8)._animationMode === "NoopAnimations"); var currVal_6 = (nodeValue(_v, 9).menuOpen || null); _ck(_v, 7, 0, currVal_4, currVal_5, currVal_6); var currVal_8 = nodeValue(_v, 11).inline; var currVal_9 = (((nodeValue(_v, 11).color !== "primary") && (nodeValue(_v, 11).color !== "accent")) && (nodeValue(_v, 11).color !== "warn")); _ck(_v, 10, 0, currVal_8, currVal_9); var currVal_11 = ((_co.channelDb && _co.channelDb.length) ? "visible" : "hidden"); _ck(_v, 22, 0, currVal_11); var currVal_12 = nodeValue(_v, 27).tabIndex; var currVal_13 = nodeValue(_v, 27).disabled; var currVal_14 = nodeValue(_v, 27).max; var currVal_15 = nodeValue(_v, 27).min; var currVal_16 = nodeValue(_v, 27).value; var currVal_17 = (nodeValue(_v, 27).vertical ? "vertical" : "horizontal"); var currVal_18 = nodeValue(_v, 27).disabled; var currVal_19 = nodeValue(_v, 27).tickInterval; var currVal_20 = !nodeValue(_v, 27).vertical; var currVal_21 = nodeValue(_v, 27)._invertAxis; var currVal_22 = nodeValue(_v, 27)._shouldInvertMouseCoords(); var currVal_23 = nodeValue(_v, 27)._isSliding; var currVal_24 = nodeValue(_v, 27).thumbLabel; var currVal_25 = nodeValue(_v, 27).vertical; var currVal_26 = nodeValue(_v, 27)._isMinValue; var currVal_27 = (nodeValue(_v, 27).disabled || ((nodeValue(_v, 27)._isMinValue && nodeValue(_v, 27)._thumbGap) && nodeValue(_v, 27)._invertAxis)); var currVal_28 = (nodeValue(_v, 27)._animationMode === "NoopAnimations"); _ck(_v, 25, 1, [currVal_12, currVal_13, currVal_14, currVal_15, currVal_16, currVal_17, currVal_18, currVal_19, currVal_20, currVal_21, currVal_22, currVal_23, currVal_24, currVal_25, currVal_26, currVal_27, currVal_28]); var currVal_33 = (nodeValue(_v, 29).appearance == "standard"); var currVal_34 = (nodeValue(_v, 29).appearance == "fill"); var currVal_35 = (nodeValue(_v, 29).appearance == "outline"); var currVal_36 = (nodeValue(_v, 29).appearance == "legacy"); var currVal_37 = nodeValue(_v, 29)._control.errorState; var currVal_38 = nodeValue(_v, 29)._canLabelFloat; var currVal_39 = nodeValue(_v, 29)._shouldLabelFloat(); var currVal_40 = nodeValue(_v, 29)._hasFloatingLabel(); var currVal_41 = nodeValue(_v, 29)._hideControlPlaceholder(); var currVal_42 = nodeValue(_v, 29)._control.disabled; var currVal_43 = nodeValue(_v, 29)._control.autofilled; var currVal_44 = nodeValue(_v, 29)._control.focused; var currVal_45 = (nodeValue(_v, 29).color == "accent"); var currVal_46 = (nodeValue(_v, 29).color == "warn"); var currVal_47 = nodeValue(_v, 29)._shouldForward("untouched"); var currVal_48 = nodeValue(_v, 29)._shouldForward("touched"); var currVal_49 = nodeValue(_v, 29)._shouldForward("pristine"); var currVal_50 = nodeValue(_v, 29)._shouldForward("dirty"); var currVal_51 = nodeValue(_v, 29)._shouldForward("valid"); var currVal_52 = nodeValue(_v, 29)._shouldForward("invalid"); var currVal_53 = nodeValue(_v, 29)._shouldForward("pending"); var currVal_54 = !nodeValue(_v, 29)._animationsEnabled; _ck(_v, 28, 1, [currVal_33, currVal_34, currVal_35, currVal_36, currVal_37, currVal_38, currVal_39, currVal_40, currVal_41, currVal_42, currVal_43, currVal_44, currVal_45, currVal_46, currVal_47, currVal_48, currVal_49, currVal_50, currVal_51, currVal_52, currVal_53, currVal_54]); var currVal_55 = _co.firstChannel; var currVal_56 = _co.lastChannel; var currVal_57 = 1; var currVal_58 = nodeValue(_v, 40)._isServer; var currVal_59 = nodeValue(_v, 40).id; var currVal_60 = nodeValue(_v, 40).placeholder; var currVal_61 = nodeValue(_v, 40).disabled; var currVal_62 = nodeValue(_v, 40).required; var currVal_63 = ((nodeValue(_v, 40).readonly && !nodeValue(_v, 40)._isNativeSelect) || null); var currVal_64 = (nodeValue(_v, 40)._ariaDescribedby || null); var currVal_65 = nodeValue(_v, 40).errorState; var currVal_66 = nodeValue(_v, 40).required.toString(); _ck(_v, 39, 1, [currVal_55, currVal_56, currVal_57, currVal_58, currVal_59, currVal_60, currVal_61, currVal_62, currVal_63, currVal_64, currVal_65, currVal_66]); var currVal_69 = (_co.containerWidth + "px"); var currVal_70 = (_co.containerHeight + "px"); _ck(_v, 42, 0, currVal_69, currVal_70); var currVal_75 = (_co.tooltipX + "px"); var currVal_76 = (_co.tooltipY + "px"); var currVal_77 = !_co.tooltipText; _ck(_v, 51, 0, currVal_75, currVal_76, currVal_77); var currVal_78 = _co.tooltipText; _ck(_v, 53, 0, currVal_78); });
    }
    function View_TopologyGraph_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "topology-graph", [], null, null, null, View_TopologyGraph_0, RenderType_TopologyGraph)), directiveDef(1, 704512, null, 0, TopologyGraph, [ElementRef, Store], null, null)], null, null); }
    var TopologyGraphNgFactory = createComponentFactory("topology-graph", TopologyGraph, View_TopologyGraph_Host_0, { channelDb: "channelDb", coreIdToReplicaIdMap: "coreIdToReplicaIdMap", metricList: "metricList", podStatsPerCore: "podStatsPerCore", topology: "topology", deviceType: "deviceType" }, { selected: "selected" }, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$v = ["[_nghost-%COMP%]{display:block;margin:20px 0}.container[_ngcontent-%COMP%]{width:100%;overflow-x:auto;overflow-y:hidden}.chart[_ngcontent-%COMP%]{height:300px}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_StackBarChart = [styles$v];
    var RenderType_StackBarChart = createRendererType2({ encapsulation: 0, styles: styles_StackBarChart, data: {} });
    function View_StackBarChart_0(_l) { return viewDef(0, [queryDef(671088640, 1, { chartRef: 0 }), (_l()(), elementDef(1, 0, null, null, 1, "div", [["class", "container"]], null, null, null, null, null)), (_l()(), elementDef(2, 0, [[1, 0], ["chart", 1]], null, 0, "div", [["class", "chart"]], [[4, "width", null]], null, null, null, null))], null, function (_ck, _v) { var _co = _v.component; var currVal_0 = (_co.chartWidth + "px"); _ck(_v, 2, 0, currVal_0); }); }
    function View_StackBarChart_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "stack-bar-chart", [], null, null, null, View_StackBarChart_0, RenderType_StackBarChart)), directiveDef(1, 638976, null, 0, StackBarChart, [], null, null)], function (_ck, _v) { _ck(_v, 1, 0); }, null); }
    var StackBarChartNgFactory = createComponentFactory("stack-bar-chart", StackBarChart, View_StackBarChart_Host_0, { data: "data" }, { selected: "selected" }, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_PodViewer = [styles$t];
    var RenderType_PodViewer = createRendererType2({ encapsulation: 0, styles: styles_PodViewer, data: {} });
    function View_PodViewer_1(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 3, "div", [], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 2, "mat-slider", [["class", "mat-slider"], ["role", "slider"]], [[8, "tabIndex", 0], [1, "aria-disabled", 0], [1, "aria-valuemax", 0], [1, "aria-valuemin", 0], [1, "aria-valuenow", 0], [1, "aria-orientation", 0], [2, "mat-slider-disabled", null], [2, "mat-slider-has-ticks", null], [2, "mat-slider-horizontal", null], [2, "mat-slider-axis-inverted", null], [2, "mat-slider-invert-mouse-coords", null], [2, "mat-slider-sliding", null], [2, "mat-slider-thumb-label-showing", null], [2, "mat-slider-vertical", null], [2, "mat-slider-min-value", null], [2, "mat-slider-hide-last-tick", null], [2, "_mat-animation-noopable", null]], [[null, "change"], [null, "focus"], [null, "blur"], [null, "mousedown"], [null, "keydown"], [null, "keyup"], [null, "mouseenter"], [null, "slide"], [null, "slideend"], [null, "slidestart"], [null, "selectstart"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("focus" === en)) {
                    var pd_0 = (nodeValue(_v, 3)._onFocus() !== false);
                    ad = (pd_0 && ad);
                }
                if (("blur" === en)) {
                    var pd_1 = (nodeValue(_v, 3)._onBlur() !== false);
                    ad = (pd_1 && ad);
                }
                if (("mousedown" === en)) {
                    var pd_2 = (nodeValue(_v, 3)._onMousedown($event) !== false);
                    ad = (pd_2 && ad);
                }
                if (("keydown" === en)) {
                    var pd_3 = (nodeValue(_v, 3)._onKeydown($event) !== false);
                    ad = (pd_3 && ad);
                }
                if (("keyup" === en)) {
                    var pd_4 = (nodeValue(_v, 3)._onKeyup() !== false);
                    ad = (pd_4 && ad);
                }
                if (("mouseenter" === en)) {
                    var pd_5 = (nodeValue(_v, 3)._onMouseenter() !== false);
                    ad = (pd_5 && ad);
                }
                if (("slide" === en)) {
                    var pd_6 = (nodeValue(_v, 3)._onSlide($event) !== false);
                    ad = (pd_6 && ad);
                }
                if (("slideend" === en)) {
                    var pd_7 = (nodeValue(_v, 3)._onSlideEnd() !== false);
                    ad = (pd_7 && ad);
                }
                if (("slidestart" === en)) {
                    var pd_8 = (nodeValue(_v, 3)._onSlideStart($event) !== false);
                    ad = (pd_8 && ad);
                }
                if (("selectstart" === en)) {
                    var pd_9 = ($event.preventDefault() !== false);
                    ad = (pd_9 && ad);
                }
                if (("change" === en)) {
                    var pd_10 = (_co.updateSelectedStep($event.value) !== false);
                    ad = (pd_10 && ad);
                }
                return ad;
            }, d$8, c$8)), providerDef(5120, null, NG_VALUE_ACCESSOR, function (p0_0) { return [p0_0]; }, [MatSlider]), directiveDef(3, 245760, null, 0, MatSlider, [ElementRef, FocusMonitor, ChangeDetectorRef, [2, Directionality], [8, null], [2, ANIMATION_MODULE_TYPE]], { max: [0, "max"], min: [1, "min"], step: [2, "step"] }, { change: "change" })], function (_ck, _v) { var _co = _v.component; var currVal_17 = _co.maxStep; var currVal_18 = _co.minStep; var currVal_19 = 1; _ck(_v, 3, 0, currVal_17, currVal_18, currVal_19); }, function (_ck, _v) { var currVal_0 = nodeValue(_v, 3).tabIndex; var currVal_1 = nodeValue(_v, 3).disabled; var currVal_2 = nodeValue(_v, 3).max; var currVal_3 = nodeValue(_v, 3).min; var currVal_4 = nodeValue(_v, 3).value; var currVal_5 = (nodeValue(_v, 3).vertical ? "vertical" : "horizontal"); var currVal_6 = nodeValue(_v, 3).disabled; var currVal_7 = nodeValue(_v, 3).tickInterval; var currVal_8 = !nodeValue(_v, 3).vertical; var currVal_9 = nodeValue(_v, 3)._invertAxis; var currVal_10 = nodeValue(_v, 3)._shouldInvertMouseCoords(); var currVal_11 = nodeValue(_v, 3)._isSliding; var currVal_12 = nodeValue(_v, 3).thumbLabel; var currVal_13 = nodeValue(_v, 3).vertical; var currVal_14 = nodeValue(_v, 3)._isMinValue; var currVal_15 = (nodeValue(_v, 3).disabled || ((nodeValue(_v, 3)._isMinValue && nodeValue(_v, 3)._thumbGap) && nodeValue(_v, 3)._invertAxis)); var currVal_16 = (nodeValue(_v, 3)._animationMode === "NoopAnimations"); _ck(_v, 1, 1, [currVal_0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5, currVal_6, currVal_7, currVal_8, currVal_9, currVal_10, currVal_11, currVal_12, currVal_13, currVal_14, currVal_15, currVal_16]); });
    }
    function View_PodViewer_2(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 2, "div", [], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 1, "topology-graph", [], null, [[null, "selected"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("selected" === en)) {
                    var pd_0 = (_co.selectedChannelDb($event) !== false);
                    ad = (pd_0 && ad);
                }
                return ad;
            }, View_TopologyGraph_0, RenderType_TopologyGraph)), directiveDef(2, 704512, null, 0, TopologyGraph, [ElementRef, Store], { channelDb: [0, "channelDb"], coreIdToReplicaIdMap: [1, "coreIdToReplicaIdMap"], metricList: [2, "metricList"], podStatsPerCore: [3, "podStatsPerCore"], topology: [4, "topology"], deviceType: [5, "deviceType"] }, { selected: "selected" })], function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.channelDb; var currVal_1 = _co.coreIdToReplicaIdMap; var currVal_2 = _co.stepBreakdownEvents; var currVal_3 = _co.podStatsPerCore; var currVal_4 = _co.topology; var currVal_5 = _co.deviceType; _ck(_v, 2, 0, currVal_0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5); }, null);
    }
    function View_PodViewer_3(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 9, "div", [], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 1, "mat-divider", [["class", "mat-divider"], ["role", "separator"]], [[1, "aria-orientation", 0], [2, "mat-divider-vertical", null], [2, "mat-divider-horizontal", null], [2, "mat-divider-inset", null]], null, null, d$7, c$7)), directiveDef(2, 49152, null, 0, MatDivider, [], null, null), (_l()(), elementDef(3, 0, null, null, 6, "div", [["class", "section-container"]], null, null, null, null, null)), (_l()(), elementDef(4, 0, null, null, 1, "div", [["class", "chart-title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Latency of Send and Recv channels"])), (_l()(), elementDef(6, 0, null, null, 1, "div", [["class", "description"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["(x-axis: channel id, y-axis: time(us))"])), (_l()(), elementDef(8, 0, null, null, 1, "stack-bar-chart", [], null, [[null, "selected"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("selected" === en)) {
                    var pd_0 = (_co.selectedChannelChart($event) !== false);
                    ad = (pd_0 && ad);
                }
                return ad;
            }, View_StackBarChart_0, RenderType_StackBarChart)), directiveDef(9, 638976, null, 0, StackBarChart, [], { data: [0, "data"] }, { selected: "selected" })], function (_ck, _v) { var _co = _v.component; var currVal_4 = _co.channelChartData; _ck(_v, 9, 0, currVal_4); }, function (_ck, _v) { var currVal_0 = (nodeValue(_v, 2).vertical ? "vertical" : "horizontal"); var currVal_1 = nodeValue(_v, 2).vertical; var currVal_2 = !nodeValue(_v, 2).vertical; var currVal_3 = nodeValue(_v, 2).inset; _ck(_v, 1, 0, currVal_0, currVal_1, currVal_2, currVal_3); });
    }
    function View_PodViewer_4(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 9, "div", [], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 1, "mat-divider", [["class", "mat-divider"], ["role", "separator"]], [[1, "aria-orientation", 0], [2, "mat-divider-vertical", null], [2, "mat-divider-horizontal", null], [2, "mat-divider-inset", null]], null, null, d$7, c$7)), directiveDef(2, 49152, null, 0, MatDivider, [], null, null), (_l()(), elementDef(3, 0, null, null, 6, "div", [["class", "section-container"]], null, null, null, null, null)), (_l()(), elementDef(4, 0, null, null, 1, "div", [["class", "chart-title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Duration of all-reduce or all-to-all ops"])), (_l()(), elementDef(6, 0, null, null, 1, "div", [["class", "description"]], null, null, null, null, null)), (_l()(), textDef(-1, null, [" (x-axis: short names for all-reduces ops (a#) or fusion (f#) or all-to-all (l#), y-axis: time(us)) "])), (_l()(), elementDef(8, 0, null, null, 1, "stack-bar-chart", [], null, [[null, "selected"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("selected" === en)) {
                    var pd_0 = (_co.selectedAllReduceOpChart($event) !== false);
                    ad = (pd_0 && ad);
                }
                return ad;
            }, View_StackBarChart_0, RenderType_StackBarChart)), directiveDef(9, 638976, null, 0, StackBarChart, [], { data: [0, "data"] }, { selected: "selected" })], function (_ck, _v) { var _co = _v.component; var currVal_4 = _co.allReduceOpChartData; _ck(_v, 9, 0, currVal_4); }, function (_ck, _v) { var currVal_0 = (nodeValue(_v, 2).vertical ? "vertical" : "horizontal"); var currVal_1 = nodeValue(_v, 2).vertical; var currVal_2 = !nodeValue(_v, 2).vertical; var currVal_3 = nodeValue(_v, 2).inset; _ck(_v, 1, 0, currVal_0, currVal_1, currVal_2, currVal_3); });
    }
    function View_PodViewer_0(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "diagnostics-view", [], null, null, null, View_DiagnosticsView_0, RenderType_DiagnosticsView)), directiveDef(1, 49152, null, 0, DiagnosticsView, [], { diagnostics: [0, "diagnostics"] }, null), (_l()(), elementDef(2, 0, null, null, 8, "div", [["class", "section-container"]], null, null, null, null, null)), (_l()(), elementDef(3, 0, null, null, 1, "div", [["class", "mat-headline"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Pod Viewer"])), (_l()(), elementDef(5, 0, null, null, 1, "div", [["class", "control"]], null, null, null, null, null)), (_l()(), textDef(6, null, ["Selected step: ", ""])), (_l()(), anchorDef(16777216, null, null, 1, null, View_PodViewer_1)), directiveDef(8, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"] }, null), (_l()(), anchorDef(16777216, null, null, 1, null, View_PodViewer_2)), directiveDef(10, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"] }, null), (_l()(), anchorDef(16777216, null, null, 1, null, View_PodViewer_3)), directiveDef(12, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"] }, null), (_l()(), anchorDef(16777216, null, null, 1, null, View_PodViewer_4)), directiveDef(14, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"] }, null), (_l()(), elementDef(15, 0, null, null, 1, "mat-divider", [["class", "mat-divider"], ["role", "separator"]], [[1, "aria-orientation", 0], [2, "mat-divider-vertical", null], [2, "mat-divider-horizontal", null], [2, "mat-divider-inset", null]], null, null, d$7, c$7)), directiveDef(16, 49152, null, 0, MatDivider, [], null, null), (_l()(), elementDef(17, 0, null, null, 6, "div", [["class", "section-container"]], null, null, null, null, null)), (_l()(), elementDef(18, 0, null, null, 1, "div", [["class", "chart-title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Step breakdown"])), (_l()(), elementDef(20, 0, null, null, 1, "div", [["class", "description"]], null, null, null, null, null)), (_l()(), textDef(21, null, ["", ""])), (_l()(), elementDef(22, 0, null, null, 1, "stack-bar-chart", [], null, [[null, "selected"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("selected" === en)) {
                    var pd_0 = (_co.selectedPodStatsChart($event) !== false);
                    ad = (pd_0 && ad);
                }
                return ad;
            }, View_StackBarChart_0, RenderType_StackBarChart)), directiveDef(23, 638976, null, 0, StackBarChart, [], { data: [0, "data"] }, { selected: "selected" })], function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.diagnostics; _ck(_v, 1, 0, currVal_0); var currVal_2 = (_co.minStep != _co.maxStep); _ck(_v, 8, 0, currVal_2); var currVal_3 = _co.topology; _ck(_v, 10, 0, currVal_3); var currVal_4 = (_co.channelDb && _co.channelDb.length); _ck(_v, 12, 0, currVal_4); var currVal_5 = (_co.allReduceOpDb && _co.allReduceOpDb.length); _ck(_v, 14, 0, currVal_5); var currVal_11 = _co.podStatsChartData; _ck(_v, 23, 0, currVal_11); }, function (_ck, _v) { var _co = _v.component; var currVal_1 = _co.selectedStep; _ck(_v, 6, 0, currVal_1); var currVal_6 = (nodeValue(_v, 16).vertical ? "vertical" : "horizontal"); var currVal_7 = nodeValue(_v, 16).vertical; var currVal_8 = !nodeValue(_v, 16).vertical; var currVal_9 = nodeValue(_v, 16).inset; _ck(_v, 15, 0, currVal_6, currVal_7, currVal_8, currVal_9); var currVal_10 = _co.stepBreakdownChartDescription; _ck(_v, 21, 0, currVal_10); });
    }
    function View_PodViewer_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "pod-viewer", [], null, null, null, View_PodViewer_0, RenderType_PodViewer)), directiveDef(1, 180224, null, 0, PodViewer, [ActivatedRoute, DataService, Store], null, null)], null, null); }
    var PodViewerNgFactory = createComponentFactory("pod-viewer", PodViewer, View_PodViewer_Host_0, {}, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$w = [".section-container[_ngcontent-%COMP%]{padding:20px}.row[_ngcontent-%COMP%]{display:flex}.flex-space[_ngcontent-%COMP%]{flex:1}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$x = ["[_nghost-%COMP%]{display:block;margin:0 16px}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_Table = [styles$x];
    var RenderType_Table = createRendererType2({ encapsulation: 0, styles: styles_Table, data: {} });
    function View_Table_0(_l) { return viewDef(0, [queryDef(671088640, 1, { tableRef: 0 }), (_l()(), elementDef(1, 0, null, null, 1, "div", [], [[4, "height", null]], null, null, null, null)), (_l()(), elementDef(2, 0, [[1, 0], ["table", 1]], null, 0, "div", [["class", "table"]], null, null, null, null, null))], null, function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.height; _ck(_v, 1, 0, currVal_0); }); }
    function View_Table_Host_0(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "table", [], null, [["window", "resize"]], function (_v, en, $event) {
                var ad = true;
                if (("window:resize" === en)) {
                    var pd_0 = (nodeValue(_v, 1).onResize() !== false);
                    ad = (pd_0 && ad);
                }
                return ad;
            }, View_Table_0, RenderType_Table)), directiveDef(1, 638976, null, 0, Table, [], null, null)], function (_ck, _v) { _ck(_v, 1, 0); }, null);
    }
    var TableNgFactory = createComponentFactory("table", Table, View_Table_Host_0, { dataView: "dataView", showRowNumber: "showRowNumber", page: "page", pageSize: "pageSize" }, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$y = [".control[_ngcontent-%COMP%]{width:120px;margin-right:8px}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_CategoryFilter = [styles$y];
    var RenderType_CategoryFilter = createRendererType2({ encapsulation: 0, styles: styles_CategoryFilter, data: {} });
    function View_CategoryFilter_2(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 2, "mat-option", [["class", "mat-option"], ["role", "option"]], [[1, "tabindex", 0], [2, "mat-selected", null], [2, "mat-option-multiple", null], [2, "mat-active", null], [8, "id", 0], [1, "aria-selected", 0], [1, "aria-disabled", 0], [2, "mat-option-disabled", null]], [[null, "click"], [null, "keydown"]], function (_v, en, $event) {
                var ad = true;
                if (("click" === en)) {
                    var pd_0 = (nodeValue(_v, 1)._selectViaInteraction() !== false);
                    ad = (pd_0 && ad);
                }
                if (("keydown" === en)) {
                    var pd_1 = (nodeValue(_v, 1)._handleKeydown($event) !== false);
                    ad = (pd_1 && ad);
                }
                return ad;
            }, j$1, i)), directiveDef(1, 8568832, [[10, 4]], 0, MatOption, [ElementRef, ChangeDetectorRef, [2, MAT_OPTION_PARENT_COMPONENT], [2, MatOptgroup]], { value: [0, "value"] }, null), (_l()(), textDef(2, 0, ["", ""]))], function (_ck, _v) { var currVal_8 = _v.context.$implicit; _ck(_v, 1, 0, currVal_8); }, function (_ck, _v) { var currVal_0 = nodeValue(_v, 1)._getTabIndex(); var currVal_1 = nodeValue(_v, 1).selected; var currVal_2 = nodeValue(_v, 1).multiple; var currVal_3 = nodeValue(_v, 1).active; var currVal_4 = nodeValue(_v, 1).id; var currVal_5 = nodeValue(_v, 1)._getAriaSelected(); var currVal_6 = nodeValue(_v, 1).disabled.toString(); var currVal_7 = nodeValue(_v, 1).disabled; _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5, currVal_6, currVal_7); var currVal_9 = _v.context.$implicit; _ck(_v, 2, 0, currVal_9); });
    }
    function View_CategoryFilter_1(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 22, "mat-form-field", [["class", "control mat-form-field"]], [[2, "mat-form-field-appearance-standard", null], [2, "mat-form-field-appearance-fill", null], [2, "mat-form-field-appearance-outline", null], [2, "mat-form-field-appearance-legacy", null], [2, "mat-form-field-invalid", null], [2, "mat-form-field-can-float", null], [2, "mat-form-field-should-float", null], [2, "mat-form-field-has-label", null], [2, "mat-form-field-hide-placeholder", null], [2, "mat-form-field-disabled", null], [2, "mat-form-field-autofilled", null], [2, "mat-focused", null], [2, "mat-accent", null], [2, "mat-warn", null], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [2, "_mat-animation-noopable", null]], null, null, d$1, c$1)), directiveDef(1, 7520256, null, 9, MatFormField, [ElementRef, ChangeDetectorRef, [2, MAT_LABEL_GLOBAL_OPTIONS], [2, Directionality], [2, MAT_FORM_FIELD_DEFAULT_OPTIONS], Platform, NgZone, [2, ANIMATION_MODULE_TYPE]], null, null), queryDef(603979776, 1, { _controlNonStatic: 0 }), queryDef(335544320, 2, { _controlStatic: 0 }), queryDef(603979776, 3, { _labelChildNonStatic: 0 }), queryDef(335544320, 4, { _labelChildStatic: 0 }), queryDef(603979776, 5, { _placeholderChild: 0 }), queryDef(603979776, 6, { _errorChildren: 1 }), queryDef(603979776, 7, { _hintChildren: 1 }), queryDef(603979776, 8, { _prefixChildren: 1 }), queryDef(603979776, 9, { _suffixChildren: 1 }), (_l()(), elementDef(11, 0, null, 3, 2, "mat-label", [], null, null, null, null, null)), directiveDef(12, 16384, [[3, 4], [4, 4]], 0, MatLabel, [], null, null), (_l()(), textDef(13, null, ["", ""])), (_l()(), elementDef(14, 0, null, 1, 8, "mat-select", [["class", "mat-select"], ["role", "listbox"]], [[1, "id", 0], [1, "tabindex", 0], [1, "aria-label", 0], [1, "aria-labelledby", 0], [1, "aria-required", 0], [1, "aria-disabled", 0], [1, "aria-invalid", 0], [1, "aria-owns", 0], [1, "aria-multiselectable", 0], [1, "aria-describedby", 0], [1, "aria-activedescendant", 0], [2, "mat-select-disabled", null], [2, "mat-select-invalid", null], [2, "mat-select-required", null], [2, "mat-select-empty", null]], [[null, "selectionChange"], [null, "valueChange"], [null, "keydown"], [null, "focus"], [null, "blur"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("keydown" === en)) {
                    var pd_0 = (nodeValue(_v, 16)._handleKeydown($event) !== false);
                    ad = (pd_0 && ad);
                }
                if (("focus" === en)) {
                    var pd_1 = (nodeValue(_v, 16)._onFocus() !== false);
                    ad = (pd_1 && ad);
                }
                if (("blur" === en)) {
                    var pd_2 = (nodeValue(_v, 16)._onBlur() !== false);
                    ad = (pd_2 && ad);
                }
                if (("selectionChange" === en)) {
                    var pd_3 = (_co.updateFilter() !== false);
                    ad = (pd_3 && ad);
                }
                if (("valueChange" === en)) {
                    var pd_4 = ((_co.value = $event) !== false);
                    ad = (pd_4 && ad);
                }
                return ad;
            }, d$3, c$3)), providerDef(6144, null, MAT_OPTION_PARENT_COMPONENT, null, [MatSelect]), directiveDef(16, 2080768, null, 3, MatSelect, [ViewportRuler, ChangeDetectorRef, NgZone, ErrorStateMatcher, ElementRef, [2, Directionality], [2, NgForm], [2, FormGroupDirective], [2, MatFormField], [8, null], [8, null], MAT_SELECT_SCROLL_STRATEGY, LiveAnnouncer], { value: [0, "value"] }, { selectionChange: "selectionChange", valueChange: "valueChange" }), queryDef(603979776, 10, { options: 1 }), queryDef(603979776, 11, { optionGroups: 1 }), queryDef(603979776, 12, { customTrigger: 0 }), providerDef(2048, [[1, 4], [2, 4]], MatFormFieldControl, null, [MatSelect]), (_l()(), anchorDef(16777216, null, 1, 1, null, View_CategoryFilter_2)), directiveDef(22, 278528, null, 0, NgForOf, [ViewContainerRef, TemplateRef, IterableDiffers], { ngForOf: [0, "ngForOf"] }, null)], function (_ck, _v) { var _co = _v.component; var currVal_38 = _co.value; _ck(_v, 16, 0, currVal_38); var currVal_39 = _co.options; _ck(_v, 22, 0, currVal_39); }, function (_ck, _v) { var _co = _v.component; var currVal_0 = (nodeValue(_v, 1).appearance == "standard"); var currVal_1 = (nodeValue(_v, 1).appearance == "fill"); var currVal_2 = (nodeValue(_v, 1).appearance == "outline"); var currVal_3 = (nodeValue(_v, 1).appearance == "legacy"); var currVal_4 = nodeValue(_v, 1)._control.errorState; var currVal_5 = nodeValue(_v, 1)._canLabelFloat; var currVal_6 = nodeValue(_v, 1)._shouldLabelFloat(); var currVal_7 = nodeValue(_v, 1)._hasFloatingLabel(); var currVal_8 = nodeValue(_v, 1)._hideControlPlaceholder(); var currVal_9 = nodeValue(_v, 1)._control.disabled; var currVal_10 = nodeValue(_v, 1)._control.autofilled; var currVal_11 = nodeValue(_v, 1)._control.focused; var currVal_12 = (nodeValue(_v, 1).color == "accent"); var currVal_13 = (nodeValue(_v, 1).color == "warn"); var currVal_14 = nodeValue(_v, 1)._shouldForward("untouched"); var currVal_15 = nodeValue(_v, 1)._shouldForward("touched"); var currVal_16 = nodeValue(_v, 1)._shouldForward("pristine"); var currVal_17 = nodeValue(_v, 1)._shouldForward("dirty"); var currVal_18 = nodeValue(_v, 1)._shouldForward("valid"); var currVal_19 = nodeValue(_v, 1)._shouldForward("invalid"); var currVal_20 = nodeValue(_v, 1)._shouldForward("pending"); var currVal_21 = !nodeValue(_v, 1)._animationsEnabled; _ck(_v, 0, 1, [currVal_0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5, currVal_6, currVal_7, currVal_8, currVal_9, currVal_10, currVal_11, currVal_12, currVal_13, currVal_14, currVal_15, currVal_16, currVal_17, currVal_18, currVal_19, currVal_20, currVal_21]); var currVal_22 = _co.columnLabel; _ck(_v, 13, 0, currVal_22); var currVal_23 = nodeValue(_v, 16).id; var currVal_24 = nodeValue(_v, 16).tabIndex; var currVal_25 = nodeValue(_v, 16)._getAriaLabel(); var currVal_26 = nodeValue(_v, 16)._getAriaLabelledby(); var currVal_27 = nodeValue(_v, 16).required.toString(); var currVal_28 = nodeValue(_v, 16).disabled.toString(); var currVal_29 = nodeValue(_v, 16).errorState; var currVal_30 = (nodeValue(_v, 16).panelOpen ? nodeValue(_v, 16)._optionIds : null); var currVal_31 = nodeValue(_v, 16).multiple; var currVal_32 = (nodeValue(_v, 16)._ariaDescribedby || null); var currVal_33 = nodeValue(_v, 16)._getAriaActiveDescendant(); var currVal_34 = nodeValue(_v, 16).disabled; var currVal_35 = nodeValue(_v, 16).errorState; var currVal_36 = nodeValue(_v, 16).required; var currVal_37 = nodeValue(_v, 16).empty; _ck(_v, 14, 1, [currVal_23, currVal_24, currVal_25, currVal_26, currVal_27, currVal_28, currVal_29, currVal_30, currVal_31, currVal_32, currVal_33, currVal_34, currVal_35, currVal_36, currVal_37]); });
    }
    function View_CategoryFilter_0(_l) { return viewDef(0, [(_l()(), anchorDef(16777216, null, null, 1, null, View_CategoryFilter_1)), directiveDef(1, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"] }, null)], function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.columnLabel; _ck(_v, 1, 0, currVal_0); }, null); }
    function View_CategoryFilter_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "category-filter", [], null, null, null, View_CategoryFilter_0, RenderType_CategoryFilter)), directiveDef(1, 573440, null, 0, CategoryFilter, [], null, null)], null, null); }
    var CategoryFilterNgFactory = createComponentFactory("category-filter", CategoryFilter, View_CategoryFilter_Host_0, { dataTable: "dataTable", column: "column", valueSeparator: "valueSeparator", all: "all", initValue: "initValue" }, { changed: "changed" }, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$z = ["[_nghost-%COMP%]{display:block;margin:0 16px}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_OrgChart = [styles$z];
    var RenderType_OrgChart = createRendererType2({ encapsulation: 0, styles: styles_OrgChart, data: {} });
    function View_OrgChart_0(_l) { return viewDef(0, [queryDef(671088640, 1, { chartRef: 0 }), (_l()(), elementDef(1, 0, [[1, 0], ["chart", 1]], null, 0, "div", [], null, null, null, null, null))], null, null); }
    function View_OrgChart_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "org-chart", [], null, null, null, View_OrgChart_0, RenderType_OrgChart)), directiveDef(1, 638976, null, 0, OrgChart, [], null, null)], function (_ck, _v) { _ck(_v, 1, 0); }, null); }
    var OrgChartNgFactory = createComponentFactory("org-chart", OrgChart, View_OrgChart_Host_0, { dataView: "dataView" }, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_TfDataBottleneckAnalysis = [styles$w];
    var RenderType_TfDataBottleneckAnalysis = createRendererType2({ encapsulation: 0, styles: styles_TfDataBottleneckAnalysis, data: {} });
    function View_TfDataBottleneckAnalysis_1(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "table", [], null, [["window", "resize"]], function (_v, en, $event) {
                var ad = true;
                if (("window:resize" === en)) {
                    var pd_0 = (nodeValue(_v, 1).onResize() !== false);
                    ad = (pd_0 && ad);
                }
                return ad;
            }, View_Table_0, RenderType_Table)), directiveDef(1, 638976, null, 0, Table, [], { dataView: [0, "dataView"] }, null)], function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.bottleneckDataView; _ck(_v, 1, 0, currVal_0); }, null);
    }
    function View_TfDataBottleneckAnalysis_0(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 12, "div", [["class", "section-container"]], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 1, "div", [["class", "mat-h1"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Performance Analysis Summary"])), (_l()(), elementDef(3, 0, null, null, 9, "div", [], null, null, null, null, null)), (_l()(), elementDef(4, 0, null, null, 7, "div", [["class", "mat-body"]], null, null, null, null, null)), (_l()(), textDef(-1, null, [" This tool is "])), (_l()(), elementDef(6, 0, null, null, 1, "em", [], null, null, null, null, null)), (_l()(), textDef(-1, null, ["experimental"])), (_l()(), textDef(-1, null, [". Please report an issue "])), (_l()(), elementDef(9, 0, null, null, 1, "a", [["href", "https://github.com/tensorflow/profiler/issues"], ["target", "blank"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["here"])), (_l()(), textDef(-1, null, [" if the analysis result seems off. "])), (_l()(), elementDef(12, 0, null, null, 0, "div", [["class", "mat-body"]], [[8, "innerHTML", 1]], null, null, null, null)), (_l()(), anchorDef(16777216, null, null, 1, null, View_TfDataBottleneckAnalysis_1)), directiveDef(14, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"] }, null), (_l()(), elementDef(15, 0, null, null, 1, "mat-divider", [["class", "mat-divider"], ["role", "separator"]], [[1, "aria-orientation", 0], [2, "mat-divider-vertical", null], [2, "mat-divider-horizontal", null], [2, "mat-divider-inset", null]], null, null, d$7, c$7)), directiveDef(16, 49152, null, 0, MatDivider, [], null, null), (_l()(), elementDef(17, 0, null, null, 2, "div", [["class", "section-container"]], null, null, null, null, null)), (_l()(), elementDef(18, 0, null, null, 1, "div", [["class", "mat-h2"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Summary of All Input Pipelines"])), (_l()(), elementDef(20, 0, null, null, 1, "table", [], null, [["window", "resize"]], function (_v, en, $event) {
                var ad = true;
                if (("window:resize" === en)) {
                    var pd_0 = (nodeValue(_v, 21).onResize() !== false);
                    ad = (pd_0 && ad);
                }
                return ad;
            }, View_Table_0, RenderType_Table)), directiveDef(21, 638976, null, 0, Table, [], { dataView: [0, "dataView"] }, null), (_l()(), elementDef(22, 0, null, null, 1, "mat-divider", [["class", "mat-divider"], ["role", "separator"]], [[1, "aria-orientation", 0], [2, "mat-divider-vertical", null], [2, "mat-divider-horizontal", null], [2, "mat-divider-inset", null]], null, null, d$7, c$7)), directiveDef(23, 49152, null, 0, MatDivider, [], null, null), (_l()(), elementDef(24, 0, null, null, 12, "div", [["class", "section-container"]], null, null, null, null, null)), (_l()(), elementDef(25, 0, null, null, 1, "div", [["class", "mat-h2"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Input Pipeline Graph"])), (_l()(), elementDef(27, 0, null, null, 7, "div", [["class", "row"]], null, null, null, null, null)), (_l()(), elementDef(28, 0, null, null, 6, "div", [], null, null, null, null, null)), (_l()(), elementDef(29, 0, null, null, 1, "category-filter", [["column", "Host"]], null, [[null, "changed"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("changed" === en)) {
                    var pd_0 = (_co.updateFilters($event) !== false);
                    ad = (pd_0 && ad);
                }
                return ad;
            }, View_CategoryFilter_0, RenderType_CategoryFilter)), directiveDef(30, 573440, null, 0, CategoryFilter, [], { dataTable: [0, "dataTable"], column: [1, "column"] }, { changed: "changed" }), (_l()(), elementDef(31, 0, null, null, 1, "category-filter", [["column", "Input Pipeline"]], null, [[null, "changed"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("changed" === en)) {
                    var pd_0 = (_co.updateFilters($event) !== false);
                    ad = (pd_0 && ad);
                }
                return ad;
            }, View_CategoryFilter_0, RenderType_CategoryFilter)), directiveDef(32, 573440, null, 0, CategoryFilter, [], { dataTable: [0, "dataTable"], column: [1, "column"] }, { changed: "changed" }), (_l()(), elementDef(33, 0, null, null, 1, "category-filter", [["column", "Rank"]], null, [[null, "changed"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("changed" === en)) {
                    var pd_0 = (_co.updateFilters($event) !== false);
                    ad = (pd_0 && ad);
                }
                return ad;
            }, View_CategoryFilter_0, RenderType_CategoryFilter)), directiveDef(34, 573440, null, 0, CategoryFilter, [], { dataTable: [0, "dataTable"], column: [1, "column"] }, { changed: "changed" }), (_l()(), elementDef(35, 0, null, null, 1, "org-chart", [], null, null, null, View_OrgChart_0, RenderType_OrgChart)), directiveDef(36, 638976, null, 0, OrgChart, [], { dataView: [0, "dataView"] }, null)], function (_ck, _v) { var _co = _v.component; var currVal_1 = _co.isInputBound; _ck(_v, 14, 0, currVal_1); var currVal_6 = _co.summaryDataView; _ck(_v, 21, 0, currVal_6); var currVal_11 = _co.dataTable; var currVal_12 = "Host"; _ck(_v, 30, 0, currVal_11, currVal_12); var currVal_13 = _co.dataTable; var currVal_14 = "Input Pipeline"; _ck(_v, 32, 0, currVal_13, currVal_14); var currVal_15 = _co.dataTable; var currVal_16 = "Rank"; _ck(_v, 34, 0, currVal_15, currVal_16); var currVal_17 = _co.orgChartDataView; _ck(_v, 36, 0, currVal_17); }, function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.summaryMessage; _ck(_v, 12, 0, currVal_0); var currVal_2 = (nodeValue(_v, 16).vertical ? "vertical" : "horizontal"); var currVal_3 = nodeValue(_v, 16).vertical; var currVal_4 = !nodeValue(_v, 16).vertical; var currVal_5 = nodeValue(_v, 16).inset; _ck(_v, 15, 0, currVal_2, currVal_3, currVal_4, currVal_5); var currVal_7 = (nodeValue(_v, 23).vertical ? "vertical" : "horizontal"); var currVal_8 = nodeValue(_v, 23).vertical; var currVal_9 = !nodeValue(_v, 23).vertical; var currVal_10 = nodeValue(_v, 23).inset; _ck(_v, 22, 0, currVal_7, currVal_8, currVal_9, currVal_10); });
    }
    function View_TfDataBottleneckAnalysis_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "tf-data-bottleneck-analysis", [], null, null, null, View_TfDataBottleneckAnalysis_0, RenderType_TfDataBottleneckAnalysis)), directiveDef(1, 180224, null, 0, TfDataBottleneckAnalysis, [ActivatedRoute, DataService, Store], null, null)], null, null); }
    var TfDataBottleneckAnalysisNgFactory = createComponentFactory("tf-data-bottleneck-analysis", TfDataBottleneckAnalysis, View_TfDataBottleneckAnalysis_Host_0, {}, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$A = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}[_nghost-%COMP%]{display:block}.section-container[_ngcontent-%COMP%]{padding:20px}.header-content[_ngcontent-%COMP%]{font-style:italic;margin-top:-16px}.row[_ngcontent-%COMP%]{display:flex}.flex-space[_ngcontent-%COMP%]{flex:1}.mat-raised-button[_ngcontent-%COMP%]{box-shadow:none;border:1px solid #000;border-radius:0;color:#777}.idle-button-container[_ngcontent-%COMP%]{margin-top:-16px}model-properties[_ngcontent-%COMP%]{min-width:550px}.pie-chart[_ngcontent-%COMP%]{width:450px;height:fit-content;margin:8px 8px 8px 0}.pie-chart[_ngcontent-%COMP%]   .description[_ngcontent-%COMP%]{margin-top:-16px}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$B = ["[_nghost-%COMP%]{display:block;width:550px;height:fit-content;margin:8px 8px 8px 0}.chart[_ngcontent-%COMP%]{margin-top:-16px}.mat-title[_ngcontent-%COMP%]{text-transform:uppercase}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_FlopRateChart = [styles$B];
    var RenderType_FlopRateChart = createRendererType2({ encapsulation: 0, styles: styles_FlopRateChart, data: {} });
    function View_FlopRateChart_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "div", [["class", "mat-title"]], null, null, null, null, null)), (_l()(), textDef(1, null, ["MEASURED GFLOPS/SEC OF ", " OPERATIONS ON DEVICE"])), (_l()(), elementDef(2, 0, null, null, 1, "chart", [["chartType", "ColumnChart"], ["class", "chart"]], null, null, null, View_Chart_0, RenderType_Chart)), directiveDef(3, 638976, null, 0, Chart, [ElementRef], { chartType: [0, "chartType"], dataInfo: [1, "dataInfo"] }, null)], function (_ck, _v) { var _co = _v.component; var currVal_1 = "ColumnChart"; var currVal_2 = _co.dataInfo; _ck(_v, 3, 0, currVal_1, currVal_2); }, function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.opType; _ck(_v, 1, 0, currVal_0); }); }
    function View_FlopRateChart_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "flop-rate-chart", [], null, null, null, View_FlopRateChart_0, RenderType_FlopRateChart)), directiveDef(1, 573440, null, 0, FlopRateChart, [], null, null)], null, null); }
    var FlopRateChartNgFactory = createComponentFactory("flop-rate-chart", FlopRateChart, View_FlopRateChart_Host_0, { data: "data", xColumn: "xColumn", yColumn: "yColumn", opType: "opType" }, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$C = ["[_nghost-%COMP%]{display:block;width:350px;height:fit-content;margin:8px 8px 8px 0}p[_ngcontent-%COMP%]{font-size:14px}b[_ngcontent-%COMP%]{font-weight:500}.note[_ngcontent-%COMP%]{font-style:italic}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_ModelProperties = [styles$C];
    var RenderType_ModelProperties = createRendererType2({ encapsulation: 0, styles: styles_ModelProperties, data: {} });
    function View_ModelProperties_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 12, "div", [], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 1, "div", [["class", "mat-title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Model Properties"])), (_l()(), elementDef(3, 0, null, null, 3, "p", [], null, null, null, null, null)), (_l()(), elementDef(4, 0, null, null, 1, "b", [], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Task: "])), (_l()(), textDef(6, null, ["", ""])), (_l()(), elementDef(7, 0, null, null, 3, "p", [], null, null, null, null, null)), (_l()(), elementDef(8, 0, null, null, 1, "b", [], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Architecture: "])), (_l()(), textDef(10, null, ["", ""])), (_l()(), elementDef(11, 0, null, null, 1, "p", [["class", "note"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["NOTE: These are heuristic-based results. Please file a bug if incorrect."]))], null, function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.task; _ck(_v, 6, 0, currVal_0); var currVal_1 = _co.architecture; _ck(_v, 10, 0, currVal_1); }); }
    function View_ModelProperties_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "model-properties", [], null, null, null, View_ModelProperties_0, RenderType_ModelProperties)), directiveDef(1, 49152, null, 0, ModelProperties, [], null, null)], null, null); }
    var ModelPropertiesNgFactory = createComponentFactory("model-properties", ModelProperties, View_ModelProperties_Host_0, { architecture: "architecture", task: "task" }, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$D = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}[_nghost-%COMP%]{display:block;padding:20px}.table[_ngcontent-%COMP%]{border:1px solid #eee;width:fit-content}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_OperationsTable = [styles$D];
    var RenderType_OperationsTable = createRendererType2({ encapsulation: 0, styles: styles_OperationsTable, data: {} });
    function View_OperationsTable_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "div", [["class", "mat-headline"]], null, null, null, null, null)), (_l()(), textDef(1, null, ["", ""])), (_l()(), elementDef(2, 0, null, null, 1, "chart", [["chartType", "Table"], ["class", "table"]], null, null, null, View_Chart_0, RenderType_Chart)), directiveDef(3, 638976, null, 0, Chart, [ElementRef], { chartType: [0, "chartType"], dataInfo: [1, "dataInfo"] }, null)], function (_ck, _v) { var _co = _v.component; var currVal_1 = "Table"; var currVal_2 = _co.dataInfo; _ck(_v, 3, 0, currVal_1, currVal_2); }, function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.title; _ck(_v, 1, 0, currVal_0); }); }
    function View_OperationsTable_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "operations-table", [], null, null, null, View_OperationsTable_0, RenderType_OperationsTable)), directiveDef(1, 573440, null, 0, OperationsTable, [], null, null)], null, null); }
    var OperationsTableNgFactory = createComponentFactory("operations-table", OperationsTable, View_OperationsTable_Host_0, { tensorflowStatsData: "tensorflowStatsData", diffData: "diffData", hasDiff: "hasDiff", opExecutor: "opExecutor" }, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$E = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}[_nghost-%COMP%]{display:block;padding:20px}mat-form-field[_ngcontent-%COMP%]{margin:0 8px}mat-icon[_ngcontent-%COMP%]{color:#777;vertical-align:bottom}.table[_ngcontent-%COMP%]{border:1px solid #eee}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_StatsTable = [styles$E];
    var RenderType_StatsTable = createRendererType2({ encapsulation: 0, styles: styles_StatsTable, data: {} });
    function View_StatsTable_1(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "div", [], null, null, null, null, null)), (_l()(), textDef(1, null, [" Note: To avoid sluggishness, only the 1000 most time-consuming operations out of the total ", " operations are shown in the table below.\n"]))], null, function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.totalOperations; _ck(_v, 1, 0, currVal_0); }); }
    function View_StatsTable_2(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 0, "br", [], null, null, null, null, null))], null, null); }
    function View_StatsTable_3(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "div", [], null, null, null, null, null)), (_l()(), textDef(-1, null, [" Note: For diff tool, the main table is pre-ordered by the Avg. self-time absolute difference in descending order. Each entry is shown as baseline(difference), while difference is converted to percentage w.r.t baseline if applicable.\n"]))], null, null); }
    function View_StatsTable_0(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 56, "div", [], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 1, "div", [["class", "mat-headline"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["TensorFlow operations"])), (_l()(), elementDef(3, 0, null, null, 17, "mat-form-field", [["class", "mat-form-field"]], [[2, "mat-form-field-appearance-standard", null], [2, "mat-form-field-appearance-fill", null], [2, "mat-form-field-appearance-outline", null], [2, "mat-form-field-appearance-legacy", null], [2, "mat-form-field-invalid", null], [2, "mat-form-field-can-float", null], [2, "mat-form-field-should-float", null], [2, "mat-form-field-has-label", null], [2, "mat-form-field-hide-placeholder", null], [2, "mat-form-field-disabled", null], [2, "mat-form-field-autofilled", null], [2, "mat-focused", null], [2, "mat-accent", null], [2, "mat-warn", null], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [2, "_mat-animation-noopable", null]], null, null, d$1, c$1)), directiveDef(4, 7520256, null, 9, MatFormField, [ElementRef, ChangeDetectorRef, [2, MAT_LABEL_GLOBAL_OPTIONS], [2, Directionality], [2, MAT_FORM_FIELD_DEFAULT_OPTIONS], Platform, NgZone, [2, ANIMATION_MODULE_TYPE]], null, null), queryDef(603979776, 1, { _controlNonStatic: 0 }), queryDef(335544320, 2, { _controlStatic: 0 }), queryDef(603979776, 3, { _labelChildNonStatic: 0 }), queryDef(335544320, 4, { _labelChildStatic: 0 }), queryDef(603979776, 5, { _placeholderChild: 0 }), queryDef(603979776, 6, { _errorChildren: 1 }), queryDef(603979776, 7, { _hintChildren: 1 }), queryDef(603979776, 8, { _prefixChildren: 1 }), queryDef(603979776, 9, { _suffixChildren: 1 }), (_l()(), elementDef(14, 0, null, 1, 2, "input", [["class", "mat-input-element mat-form-field-autofill-control"], ["matInput", ""], ["placeholder", "Host/device"]], [[2, "mat-input-server", null], [1, "id", 0], [1, "placeholder", 0], [8, "disabled", 0], [8, "required", 0], [1, "readonly", 0], [1, "aria-describedby", 0], [1, "aria-invalid", 0], [1, "aria-required", 0]], [[null, "input"], [null, "blur"], [null, "focus"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("blur" === en)) {
                    var pd_0 = (nodeValue(_v, 15)._focusChanged(false) !== false);
                    ad = (pd_0 && ad);
                }
                if (("focus" === en)) {
                    var pd_1 = (nodeValue(_v, 15)._focusChanged(true) !== false);
                    ad = (pd_1 && ad);
                }
                if (("input" === en)) {
                    var pd_2 = (nodeValue(_v, 15)._onInput() !== false);
                    ad = (pd_2 && ad);
                }
                if (("input" === en)) {
                    _co.filterExecutor = $event.target.value;
                    var pd_3 = (_co.updateFilters() !== false);
                    ad = (pd_3 && ad);
                }
                return ad;
            }, null, null)), directiveDef(15, 999424, null, 0, MatInput, [ElementRef, Platform, [8, null], [2, NgForm], [2, FormGroupDirective], ErrorStateMatcher, [8, null], AutofillMonitor, NgZone], { placeholder: [0, "placeholder"], value: [1, "value"] }, null), providerDef(2048, [[1, 4], [2, 4]], MatFormFieldControl, null, [MatInput]), (_l()(), elementDef(17, 0, null, 4, 3, "mat-icon", [["class", "mat-icon notranslate"], ["matSuffix", ""], ["role", "img"]], [[2, "mat-icon-inline", null], [2, "mat-icon-no-color", null]], null, null, d$5, c$5)), directiveDef(18, 16384, [[9, 4]], 0, MatSuffix, [], null, null), directiveDef(19, 9158656, null, 0, MatIcon, [ElementRef, MatIconRegistry, [8, null], [2, MAT_ICON_LOCATION], [2, ErrorHandler]], null, null), (_l()(), textDef(-1, 0, ["search"])), (_l()(), elementDef(21, 0, null, null, 17, "mat-form-field", [["class", "mat-form-field"]], [[2, "mat-form-field-appearance-standard", null], [2, "mat-form-field-appearance-fill", null], [2, "mat-form-field-appearance-outline", null], [2, "mat-form-field-appearance-legacy", null], [2, "mat-form-field-invalid", null], [2, "mat-form-field-can-float", null], [2, "mat-form-field-should-float", null], [2, "mat-form-field-has-label", null], [2, "mat-form-field-hide-placeholder", null], [2, "mat-form-field-disabled", null], [2, "mat-form-field-autofilled", null], [2, "mat-focused", null], [2, "mat-accent", null], [2, "mat-warn", null], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [2, "_mat-animation-noopable", null]], null, null, d$1, c$1)), directiveDef(22, 7520256, null, 9, MatFormField, [ElementRef, ChangeDetectorRef, [2, MAT_LABEL_GLOBAL_OPTIONS], [2, Directionality], [2, MAT_FORM_FIELD_DEFAULT_OPTIONS], Platform, NgZone, [2, ANIMATION_MODULE_TYPE]], null, null), queryDef(603979776, 10, { _controlNonStatic: 0 }), queryDef(335544320, 11, { _controlStatic: 0 }), queryDef(603979776, 12, { _labelChildNonStatic: 0 }), queryDef(335544320, 13, { _labelChildStatic: 0 }), queryDef(603979776, 14, { _placeholderChild: 0 }), queryDef(603979776, 15, { _errorChildren: 1 }), queryDef(603979776, 16, { _hintChildren: 1 }), queryDef(603979776, 17, { _prefixChildren: 1 }), queryDef(603979776, 18, { _suffixChildren: 1 }), (_l()(), elementDef(32, 0, null, 1, 2, "input", [["class", "mat-input-element mat-form-field-autofill-control"], ["matInput", ""], ["placeholder", "Type"]], [[2, "mat-input-server", null], [1, "id", 0], [1, "placeholder", 0], [8, "disabled", 0], [8, "required", 0], [1, "readonly", 0], [1, "aria-describedby", 0], [1, "aria-invalid", 0], [1, "aria-required", 0]], [[null, "input"], [null, "blur"], [null, "focus"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("blur" === en)) {
                    var pd_0 = (nodeValue(_v, 33)._focusChanged(false) !== false);
                    ad = (pd_0 && ad);
                }
                if (("focus" === en)) {
                    var pd_1 = (nodeValue(_v, 33)._focusChanged(true) !== false);
                    ad = (pd_1 && ad);
                }
                if (("input" === en)) {
                    var pd_2 = (nodeValue(_v, 33)._onInput() !== false);
                    ad = (pd_2 && ad);
                }
                if (("input" === en)) {
                    _co.filterType = $event.target.value;
                    var pd_3 = (_co.updateFilters() !== false);
                    ad = (pd_3 && ad);
                }
                return ad;
            }, null, null)), directiveDef(33, 999424, null, 0, MatInput, [ElementRef, Platform, [8, null], [2, NgForm], [2, FormGroupDirective], ErrorStateMatcher, [8, null], AutofillMonitor, NgZone], { placeholder: [0, "placeholder"], value: [1, "value"] }, null), providerDef(2048, [[10, 4], [11, 4]], MatFormFieldControl, null, [MatInput]), (_l()(), elementDef(35, 0, null, 4, 3, "mat-icon", [["class", "mat-icon notranslate"], ["matSuffix", ""], ["role", "img"]], [[2, "mat-icon-inline", null], [2, "mat-icon-no-color", null]], null, null, d$5, c$5)), directiveDef(36, 16384, [[18, 4]], 0, MatSuffix, [], null, null), directiveDef(37, 9158656, null, 0, MatIcon, [ElementRef, MatIconRegistry, [8, null], [2, MAT_ICON_LOCATION], [2, ErrorHandler]], null, null), (_l()(), textDef(-1, 0, ["search"])), (_l()(), elementDef(39, 0, null, null, 17, "mat-form-field", [["class", "mat-form-field"]], [[2, "mat-form-field-appearance-standard", null], [2, "mat-form-field-appearance-fill", null], [2, "mat-form-field-appearance-outline", null], [2, "mat-form-field-appearance-legacy", null], [2, "mat-form-field-invalid", null], [2, "mat-form-field-can-float", null], [2, "mat-form-field-should-float", null], [2, "mat-form-field-has-label", null], [2, "mat-form-field-hide-placeholder", null], [2, "mat-form-field-disabled", null], [2, "mat-form-field-autofilled", null], [2, "mat-focused", null], [2, "mat-accent", null], [2, "mat-warn", null], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [2, "_mat-animation-noopable", null]], null, null, d$1, c$1)), directiveDef(40, 7520256, null, 9, MatFormField, [ElementRef, ChangeDetectorRef, [2, MAT_LABEL_GLOBAL_OPTIONS], [2, Directionality], [2, MAT_FORM_FIELD_DEFAULT_OPTIONS], Platform, NgZone, [2, ANIMATION_MODULE_TYPE]], null, null), queryDef(603979776, 19, { _controlNonStatic: 0 }), queryDef(335544320, 20, { _controlStatic: 0 }), queryDef(603979776, 21, { _labelChildNonStatic: 0 }), queryDef(335544320, 22, { _labelChildStatic: 0 }), queryDef(603979776, 23, { _placeholderChild: 0 }), queryDef(603979776, 24, { _errorChildren: 1 }), queryDef(603979776, 25, { _hintChildren: 1 }), queryDef(603979776, 26, { _prefixChildren: 1 }), queryDef(603979776, 27, { _suffixChildren: 1 }), (_l()(), elementDef(50, 0, null, 1, 2, "input", [["class", "mat-input-element mat-form-field-autofill-control"], ["matInput", ""], ["placeholder", "Operation"]], [[2, "mat-input-server", null], [1, "id", 0], [1, "placeholder", 0], [8, "disabled", 0], [8, "required", 0], [1, "readonly", 0], [1, "aria-describedby", 0], [1, "aria-invalid", 0], [1, "aria-required", 0]], [[null, "input"], [null, "blur"], [null, "focus"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("blur" === en)) {
                    var pd_0 = (nodeValue(_v, 51)._focusChanged(false) !== false);
                    ad = (pd_0 && ad);
                }
                if (("focus" === en)) {
                    var pd_1 = (nodeValue(_v, 51)._focusChanged(true) !== false);
                    ad = (pd_1 && ad);
                }
                if (("input" === en)) {
                    var pd_2 = (nodeValue(_v, 51)._onInput() !== false);
                    ad = (pd_2 && ad);
                }
                if (("input" === en)) {
                    _co.filterOperation = $event.target.value;
                    var pd_3 = (_co.updateFilters() !== false);
                    ad = (pd_3 && ad);
                }
                return ad;
            }, null, null)), directiveDef(51, 999424, null, 0, MatInput, [ElementRef, Platform, [8, null], [2, NgForm], [2, FormGroupDirective], ErrorStateMatcher, [8, null], AutofillMonitor, NgZone], { placeholder: [0, "placeholder"], value: [1, "value"] }, null), providerDef(2048, [[19, 4], [20, 4]], MatFormFieldControl, null, [MatInput]), (_l()(), elementDef(53, 0, null, 4, 3, "mat-icon", [["class", "mat-icon notranslate"], ["matSuffix", ""], ["role", "img"]], [[2, "mat-icon-inline", null], [2, "mat-icon-no-color", null]], null, null, d$5, c$5)), directiveDef(54, 16384, [[27, 4]], 0, MatSuffix, [], null, null), directiveDef(55, 9158656, null, 0, MatIcon, [ElementRef, MatIconRegistry, [8, null], [2, MAT_ICON_LOCATION], [2, ErrorHandler]], null, null), (_l()(), textDef(-1, 0, ["search"])), (_l()(), anchorDef(16777216, null, null, 1, null, View_StatsTable_1)), directiveDef(58, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"] }, null), (_l()(), anchorDef(16777216, null, null, 1, null, View_StatsTable_2)), directiveDef(60, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"] }, null), (_l()(), anchorDef(16777216, null, null, 1, null, View_StatsTable_3)), directiveDef(62, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"] }, null), (_l()(), elementDef(63, 0, null, null, 0, "br", [], null, null, null, null, null)), (_l()(), elementDef(64, 0, null, null, 1, "chart", [["chartType", "Table"], ["class", "table"]], null, null, null, View_Chart_0, RenderType_Chart)), directiveDef(65, 638976, null, 0, Chart, [ElementRef], { chartType: [0, "chartType"], dataInfo: [1, "dataInfo"] }, null)], function (_ck, _v) { var _co = _v.component; var currVal_31 = "Host/device"; var currVal_32 = _co.filterExecutor; _ck(_v, 15, 0, currVal_31, currVal_32); _ck(_v, 19, 0); var currVal_66 = "Type"; var currVal_67 = _co.filterType; _ck(_v, 33, 0, currVal_66, currVal_67); _ck(_v, 37, 0); var currVal_101 = "Operation"; var currVal_102 = _co.filterOperation; _ck(_v, 51, 0, currVal_101, currVal_102); _ck(_v, 55, 0); var currVal_105 = _co.totalOperations; _ck(_v, 58, 0, currVal_105); var currVal_106 = (_co.totalOperations && _co.hasDiff); _ck(_v, 60, 0, currVal_106); var currVal_107 = _co.hasDiff; _ck(_v, 62, 0, currVal_107); var currVal_108 = "Table"; var currVal_109 = _co.dataInfo; _ck(_v, 65, 0, currVal_108, currVal_109); }, function (_ck, _v) { var currVal_0 = (nodeValue(_v, 4).appearance == "standard"); var currVal_1 = (nodeValue(_v, 4).appearance == "fill"); var currVal_2 = (nodeValue(_v, 4).appearance == "outline"); var currVal_3 = (nodeValue(_v, 4).appearance == "legacy"); var currVal_4 = nodeValue(_v, 4)._control.errorState; var currVal_5 = nodeValue(_v, 4)._canLabelFloat; var currVal_6 = nodeValue(_v, 4)._shouldLabelFloat(); var currVal_7 = nodeValue(_v, 4)._hasFloatingLabel(); var currVal_8 = nodeValue(_v, 4)._hideControlPlaceholder(); var currVal_9 = nodeValue(_v, 4)._control.disabled; var currVal_10 = nodeValue(_v, 4)._control.autofilled; var currVal_11 = nodeValue(_v, 4)._control.focused; var currVal_12 = (nodeValue(_v, 4).color == "accent"); var currVal_13 = (nodeValue(_v, 4).color == "warn"); var currVal_14 = nodeValue(_v, 4)._shouldForward("untouched"); var currVal_15 = nodeValue(_v, 4)._shouldForward("touched"); var currVal_16 = nodeValue(_v, 4)._shouldForward("pristine"); var currVal_17 = nodeValue(_v, 4)._shouldForward("dirty"); var currVal_18 = nodeValue(_v, 4)._shouldForward("valid"); var currVal_19 = nodeValue(_v, 4)._shouldForward("invalid"); var currVal_20 = nodeValue(_v, 4)._shouldForward("pending"); var currVal_21 = !nodeValue(_v, 4)._animationsEnabled; _ck(_v, 3, 1, [currVal_0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5, currVal_6, currVal_7, currVal_8, currVal_9, currVal_10, currVal_11, currVal_12, currVal_13, currVal_14, currVal_15, currVal_16, currVal_17, currVal_18, currVal_19, currVal_20, currVal_21]); var currVal_22 = nodeValue(_v, 15)._isServer; var currVal_23 = nodeValue(_v, 15).id; var currVal_24 = nodeValue(_v, 15).placeholder; var currVal_25 = nodeValue(_v, 15).disabled; var currVal_26 = nodeValue(_v, 15).required; var currVal_27 = ((nodeValue(_v, 15).readonly && !nodeValue(_v, 15)._isNativeSelect) || null); var currVal_28 = (nodeValue(_v, 15)._ariaDescribedby || null); var currVal_29 = nodeValue(_v, 15).errorState; var currVal_30 = nodeValue(_v, 15).required.toString(); _ck(_v, 14, 0, currVal_22, currVal_23, currVal_24, currVal_25, currVal_26, currVal_27, currVal_28, currVal_29, currVal_30); var currVal_33 = nodeValue(_v, 19).inline; var currVal_34 = (((nodeValue(_v, 19).color !== "primary") && (nodeValue(_v, 19).color !== "accent")) && (nodeValue(_v, 19).color !== "warn")); _ck(_v, 17, 0, currVal_33, currVal_34); var currVal_35 = (nodeValue(_v, 22).appearance == "standard"); var currVal_36 = (nodeValue(_v, 22).appearance == "fill"); var currVal_37 = (nodeValue(_v, 22).appearance == "outline"); var currVal_38 = (nodeValue(_v, 22).appearance == "legacy"); var currVal_39 = nodeValue(_v, 22)._control.errorState; var currVal_40 = nodeValue(_v, 22)._canLabelFloat; var currVal_41 = nodeValue(_v, 22)._shouldLabelFloat(); var currVal_42 = nodeValue(_v, 22)._hasFloatingLabel(); var currVal_43 = nodeValue(_v, 22)._hideControlPlaceholder(); var currVal_44 = nodeValue(_v, 22)._control.disabled; var currVal_45 = nodeValue(_v, 22)._control.autofilled; var currVal_46 = nodeValue(_v, 22)._control.focused; var currVal_47 = (nodeValue(_v, 22).color == "accent"); var currVal_48 = (nodeValue(_v, 22).color == "warn"); var currVal_49 = nodeValue(_v, 22)._shouldForward("untouched"); var currVal_50 = nodeValue(_v, 22)._shouldForward("touched"); var currVal_51 = nodeValue(_v, 22)._shouldForward("pristine"); var currVal_52 = nodeValue(_v, 22)._shouldForward("dirty"); var currVal_53 = nodeValue(_v, 22)._shouldForward("valid"); var currVal_54 = nodeValue(_v, 22)._shouldForward("invalid"); var currVal_55 = nodeValue(_v, 22)._shouldForward("pending"); var currVal_56 = !nodeValue(_v, 22)._animationsEnabled; _ck(_v, 21, 1, [currVal_35, currVal_36, currVal_37, currVal_38, currVal_39, currVal_40, currVal_41, currVal_42, currVal_43, currVal_44, currVal_45, currVal_46, currVal_47, currVal_48, currVal_49, currVal_50, currVal_51, currVal_52, currVal_53, currVal_54, currVal_55, currVal_56]); var currVal_57 = nodeValue(_v, 33)._isServer; var currVal_58 = nodeValue(_v, 33).id; var currVal_59 = nodeValue(_v, 33).placeholder; var currVal_60 = nodeValue(_v, 33).disabled; var currVal_61 = nodeValue(_v, 33).required; var currVal_62 = ((nodeValue(_v, 33).readonly && !nodeValue(_v, 33)._isNativeSelect) || null); var currVal_63 = (nodeValue(_v, 33)._ariaDescribedby || null); var currVal_64 = nodeValue(_v, 33).errorState; var currVal_65 = nodeValue(_v, 33).required.toString(); _ck(_v, 32, 0, currVal_57, currVal_58, currVal_59, currVal_60, currVal_61, currVal_62, currVal_63, currVal_64, currVal_65); var currVal_68 = nodeValue(_v, 37).inline; var currVal_69 = (((nodeValue(_v, 37).color !== "primary") && (nodeValue(_v, 37).color !== "accent")) && (nodeValue(_v, 37).color !== "warn")); _ck(_v, 35, 0, currVal_68, currVal_69); var currVal_70 = (nodeValue(_v, 40).appearance == "standard"); var currVal_71 = (nodeValue(_v, 40).appearance == "fill"); var currVal_72 = (nodeValue(_v, 40).appearance == "outline"); var currVal_73 = (nodeValue(_v, 40).appearance == "legacy"); var currVal_74 = nodeValue(_v, 40)._control.errorState; var currVal_75 = nodeValue(_v, 40)._canLabelFloat; var currVal_76 = nodeValue(_v, 40)._shouldLabelFloat(); var currVal_77 = nodeValue(_v, 40)._hasFloatingLabel(); var currVal_78 = nodeValue(_v, 40)._hideControlPlaceholder(); var currVal_79 = nodeValue(_v, 40)._control.disabled; var currVal_80 = nodeValue(_v, 40)._control.autofilled; var currVal_81 = nodeValue(_v, 40)._control.focused; var currVal_82 = (nodeValue(_v, 40).color == "accent"); var currVal_83 = (nodeValue(_v, 40).color == "warn"); var currVal_84 = nodeValue(_v, 40)._shouldForward("untouched"); var currVal_85 = nodeValue(_v, 40)._shouldForward("touched"); var currVal_86 = nodeValue(_v, 40)._shouldForward("pristine"); var currVal_87 = nodeValue(_v, 40)._shouldForward("dirty"); var currVal_88 = nodeValue(_v, 40)._shouldForward("valid"); var currVal_89 = nodeValue(_v, 40)._shouldForward("invalid"); var currVal_90 = nodeValue(_v, 40)._shouldForward("pending"); var currVal_91 = !nodeValue(_v, 40)._animationsEnabled; _ck(_v, 39, 1, [currVal_70, currVal_71, currVal_72, currVal_73, currVal_74, currVal_75, currVal_76, currVal_77, currVal_78, currVal_79, currVal_80, currVal_81, currVal_82, currVal_83, currVal_84, currVal_85, currVal_86, currVal_87, currVal_88, currVal_89, currVal_90, currVal_91]); var currVal_92 = nodeValue(_v, 51)._isServer; var currVal_93 = nodeValue(_v, 51).id; var currVal_94 = nodeValue(_v, 51).placeholder; var currVal_95 = nodeValue(_v, 51).disabled; var currVal_96 = nodeValue(_v, 51).required; var currVal_97 = ((nodeValue(_v, 51).readonly && !nodeValue(_v, 51)._isNativeSelect) || null); var currVal_98 = (nodeValue(_v, 51)._ariaDescribedby || null); var currVal_99 = nodeValue(_v, 51).errorState; var currVal_100 = nodeValue(_v, 51).required.toString(); _ck(_v, 50, 0, currVal_92, currVal_93, currVal_94, currVal_95, currVal_96, currVal_97, currVal_98, currVal_99, currVal_100); var currVal_103 = nodeValue(_v, 55).inline; var currVal_104 = (((nodeValue(_v, 55).color !== "primary") && (nodeValue(_v, 55).color !== "accent")) && (nodeValue(_v, 55).color !== "warn")); _ck(_v, 53, 0, currVal_103, currVal_104); });
    }
    function View_StatsTable_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "stats-table", [], null, null, null, View_StatsTable_0, RenderType_StatsTable)), directiveDef(1, 638976, null, 0, StatsTable, [], null, null)], function (_ck, _v) { _ck(_v, 1, 0); }, null); }
    var StatsTableNgFactory = createComponentFactory("stats-table", StatsTable, View_StatsTable_Host_0, { tensorflowStatsData: "tensorflowStatsData", diffData: "diffData", hasDiff: "hasDiff" }, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_TensorflowStats = [styles$A];
    var RenderType_TensorflowStats = createRendererType2({ encapsulation: 0, styles: styles_TensorflowStats, data: {} });
    function View_TensorflowStats_1(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 2, "button", [["class", "mat-menu-item"], ["mat-menu-item", ""]], [[1, "role", 0], [2, "mat-menu-item-highlighted", null], [2, "mat-menu-item-submenu-trigger", null], [1, "tabindex", 0], [1, "aria-disabled", 0], [1, "disabled", 0]], [[null, "click"], [null, "mouseenter"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("click" === en)) {
                    var pd_0 = (nodeValue(_v, 1)._checkDisabled($event) !== false);
                    ad = (pd_0 && ad);
                }
                if (("mouseenter" === en)) {
                    var pd_1 = (nodeValue(_v, 1)._handleMouseEnter() !== false);
                    ad = (pd_1 && ad);
                }
                if (("click" === en)) {
                    var pd_2 = (_co.setIdleOption(_v.context.$implicit) !== false);
                    ad = (pd_2 && ad);
                }
                return ad;
            }, i$1, h$2)), directiveDef(1, 180224, [[1, 4], [2, 4]], 0, MatMenuItem, [ElementRef, DOCUMENT, FocusMonitor, [2, MAT_MENU_PANEL]], { disabled: [0, "disabled"] }, null), (_l()(), textDef(2, 0, [" ", " "]))], function (_ck, _v) { var _co = _v.component; var currVal_6 = (_co.idleMenuButtonLabel == _v.context.$implicit); _ck(_v, 1, 0, currVal_6); }, function (_ck, _v) { var currVal_0 = nodeValue(_v, 1).role; var currVal_1 = nodeValue(_v, 1)._highlighted; var currVal_2 = nodeValue(_v, 1)._triggersSubmenu; var currVal_3 = nodeValue(_v, 1)._getTabIndex(); var currVal_4 = nodeValue(_v, 1).disabled.toString(); var currVal_5 = (nodeValue(_v, 1).disabled || null); _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5); var currVal_7 = _v.context.$implicit; _ck(_v, 2, 0, currVal_7); });
    }
    function View_TensorflowStats_3(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 6, "div", [["class", "pie-chart"]], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 1, "div", [["class", "mat-title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["ON DEVICE: TOTAL SELF-TIME"])), (_l()(), elementDef(3, 0, null, null, 1, "div", [["class", "description"]], null, null, null, null, null)), (_l()(), textDef(-1, null, [" (in microseconds) of a TensorFlow operation "])), (_l()(), elementDef(5, 0, null, null, 1, "chart", [["chartType", "PieChart"]], null, null, null, View_Chart_0, RenderType_Chart)), directiveDef(6, 638976, null, 0, Chart, [ElementRef], { chartType: [0, "chartType"], dataInfo: [1, "dataInfo"] }, null)], function (_ck, _v) { var _co = _v.component; var currVal_0 = "PieChart"; var currVal_1 = _co.dataInfoDeviceByName; _ck(_v, 6, 0, currVal_0, currVal_1); }, null); }
    function View_TensorflowStats_4(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "flop-rate-chart", [], null, null, null, View_FlopRateChart_0, RenderType_FlopRateChart)), directiveDef(1, 573440, null, 0, FlopRateChart, [], { data: [0, "data"], xColumn: [1, "xColumn"], yColumn: [2, "yColumn"], opType: [3, "opType"] }, null)], function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.selectedData; var currVal_1 = _co.flopRateChartXColumn; var currVal_2 = _co.flopRateChartYColumn; var currVal_3 = _co.opType; _ck(_v, 1, 0, currVal_0, currVal_1, currVal_2, currVal_3); }, null); }
    function View_TensorflowStats_2(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 11, "div", [["class", "row"]], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 6, "div", [["class", "pie-chart"]], null, null, null, null, null)), (_l()(), elementDef(2, 0, null, null, 1, "div", [["class", "mat-title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["ON DEVICE: TOTAL SELF-TIME (GROUPED BY TYPE)"])), (_l()(), elementDef(4, 0, null, null, 1, "div", [["class", "description"]], null, null, null, null, null)), (_l()(), textDef(-1, null, [" (in microseconds) of a TensorFlow operation type "])), (_l()(), elementDef(6, 0, null, null, 1, "chart", [["chartType", "PieChart"]], null, null, null, View_Chart_0, RenderType_Chart)), directiveDef(7, 638976, null, 0, Chart, [ElementRef], { chartType: [0, "chartType"], dataInfo: [1, "dataInfo"] }, null), (_l()(), anchorDef(16777216, null, null, 1, null, View_TensorflowStats_3)), directiveDef(9, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"] }, null), (_l()(), anchorDef(16777216, null, null, 1, null, View_TensorflowStats_4)), directiveDef(11, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"] }, null)], function (_ck, _v) { var _co = _v.component; var currVal_0 = "PieChart"; var currVal_1 = _co.dataInfoDeviceByType; _ck(_v, 7, 0, currVal_0, currVal_1); var currVal_2 = !_co.hasDiff; _ck(_v, 9, 0, currVal_2); var currVal_3 = (_co.showFlopRateChart && !_co.hasDiff); _ck(_v, 11, 0, currVal_3); }, null); }
    function View_TensorflowStats_5(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 6, "div", [["class", "pie-chart"]], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 1, "div", [["class", "mat-title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["ON HOST: TOTAL SELF-TIME"])), (_l()(), elementDef(3, 0, null, null, 1, "div", [["class", "description"]], null, null, null, null, null)), (_l()(), textDef(-1, null, [" (in microseconds) of a TensorFlow operation "])), (_l()(), elementDef(5, 0, null, null, 1, "chart", [["chartType", "PieChart"]], null, null, null, View_Chart_0, RenderType_Chart)), directiveDef(6, 638976, null, 0, Chart, [ElementRef], { chartType: [0, "chartType"], dataInfo: [1, "dataInfo"] }, null)], function (_ck, _v) { var _co = _v.component; var currVal_0 = "PieChart"; var currVal_1 = _co.dataInfoHostByName; _ck(_v, 6, 0, currVal_0, currVal_1); }, null); }
    function View_TensorflowStats_6(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "model-properties", [], null, null, null, View_ModelProperties_0, RenderType_ModelProperties)), directiveDef(1, 49152, null, 0, ModelProperties, [], { architecture: [0, "architecture"], task: [1, "task"] }, null)], function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.architecture; var currVal_1 = _co.task; _ck(_v, 1, 0, currVal_0, currVal_1); }, null); }
    function View_TensorflowStats_8(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 6, "div", [], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 3, "div", [["class", "section-container"]], null, null, null, null, null)), (_l()(), elementDef(2, 0, null, null, 1, "div", [["class", "mat-headline"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Pprof for Device-side TensorFlow operations"])), (_l()(), elementDef(4, 0, null, null, 0, "div", [], [[8, "innerHTML", 1]], null, null, null, null)), (_l()(), elementDef(5, 0, null, null, 1, "mat-divider", [["class", "mat-divider"], ["role", "separator"]], [[1, "aria-orientation", 0], [2, "mat-divider-vertical", null], [2, "mat-divider-horizontal", null], [2, "mat-divider-inset", null]], null, null, d$7, c$7)), directiveDef(6, 49152, null, 0, MatDivider, [], null, null)], null, function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.devicePprofLink; _ck(_v, 4, 0, currVal_0); var currVal_1 = (nodeValue(_v, 6).vertical ? "vertical" : "horizontal"); var currVal_2 = nodeValue(_v, 6).vertical; var currVal_3 = !nodeValue(_v, 6).vertical; var currVal_4 = nodeValue(_v, 6).inset; _ck(_v, 5, 0, currVal_1, currVal_2, currVal_3, currVal_4); }); }
    function View_TensorflowStats_7(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 6, "div", [], null, null, null, null, null)), (_l()(), anchorDef(16777216, null, null, 1, null, View_TensorflowStats_8)), directiveDef(2, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"] }, null), (_l()(), elementDef(3, 0, null, null, 1, "operations-table", [], null, null, null, View_OperationsTable_0, RenderType_OperationsTable)), directiveDef(4, 573440, null, 0, OperationsTable, [], { tensorflowStatsData: [0, "tensorflowStatsData"], diffData: [1, "diffData"], hasDiff: [2, "hasDiff"], opExecutor: [3, "opExecutor"] }, null), (_l()(), elementDef(5, 0, null, null, 1, "mat-divider", [["class", "mat-divider"], ["role", "separator"]], [[1, "aria-orientation", 0], [2, "mat-divider-vertical", null], [2, "mat-divider-horizontal", null], [2, "mat-divider-inset", null]], null, null, d$7, c$7)), directiveDef(6, 49152, null, 0, MatDivider, [], null, null)], function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.showPprofLink; _ck(_v, 2, 0, currVal_0); var currVal_1 = _co.selectedData; var currVal_2 = _co.selectedDiffData; var currVal_3 = _co.hasDiff; var currVal_4 = _co.opExecutorDevice; _ck(_v, 4, 0, currVal_1, currVal_2, currVal_3, currVal_4); }, function (_ck, _v) { var currVal_5 = (nodeValue(_v, 6).vertical ? "vertical" : "horizontal"); var currVal_6 = nodeValue(_v, 6).vertical; var currVal_7 = !nodeValue(_v, 6).vertical; var currVal_8 = nodeValue(_v, 6).inset; _ck(_v, 5, 0, currVal_5, currVal_6, currVal_7, currVal_8); }); }
    function View_TensorflowStats_9(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 6, "div", [], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 3, "div", [["class", "section-container"]], null, null, null, null, null)), (_l()(), elementDef(2, 0, null, null, 1, "div", [["class", "mat-headline"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Pprof for Host-side TensorFlow operations"])), (_l()(), elementDef(4, 0, null, null, 0, "div", [], [[8, "innerHTML", 1]], null, null, null, null)), (_l()(), elementDef(5, 0, null, null, 1, "mat-divider", [["class", "mat-divider"], ["role", "separator"]], [[1, "aria-orientation", 0], [2, "mat-divider-vertical", null], [2, "mat-divider-horizontal", null], [2, "mat-divider-inset", null]], null, null, d$7, c$7)), directiveDef(6, 49152, null, 0, MatDivider, [], null, null)], null, function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.hostPprofLink; _ck(_v, 4, 0, currVal_0); var currVal_1 = (nodeValue(_v, 6).vertical ? "vertical" : "horizontal"); var currVal_2 = nodeValue(_v, 6).vertical; var currVal_3 = !nodeValue(_v, 6).vertical; var currVal_4 = nodeValue(_v, 6).inset; _ck(_v, 5, 0, currVal_1, currVal_2, currVal_3, currVal_4); }); }
    function View_TensorflowStats_0(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 47, "div", [["class", "section-container"]], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 11, "div", [["class", "row"]], null, null, null, null, null)), (_l()(), elementDef(2, 0, null, null, 7, "div", [], null, null, null, null, null)), (_l()(), elementDef(3, 0, null, null, 1, "div", [["class", "mat-headline"]], null, null, null, null, null)), (_l()(), textDef(4, null, ["", ""])), (_l()(), elementDef(5, 0, null, null, 4, "div", [["class", "header-content"]], null, null, null, null, null)), (_l()(), elementDef(6, 0, null, null, 1, "div", [["class", "description"]], null, null, null, null, null)), (_l()(), textDef(-1, null, [" (1) In the charts and table below, \"IDLE\" represents the portion of the total execution time on device (or host) that is idle. "])), (_l()(), elementDef(8, 0, null, null, 1, "div", [["class", "description"]], null, null, null, null, null)), (_l()(), textDef(-1, null, [" (2) In the pie charts, the \"Other\" sector represents the sum of sectors that are too small to be shown individually. "])), (_l()(), elementDef(10, 0, null, null, 0, "div", [["class", "flex-space"]], null, null, null, null, null)), (_l()(), elementDef(11, 0, null, null, 1, "export-as-csv", [["tool", "tensorflow_stats"]], null, null, null, View_ExportAsCsv_0, RenderType_ExportAsCsv)), directiveDef(12, 49152, null, 0, ExportAsCsv, [Store], { tool: [0, "tool"] }, null), (_l()(), elementDef(13, 0, null, null, 0, "br", [], null, null, null, null, null)), (_l()(), elementDef(14, 0, null, null, 1, "div", [["class", "mat-title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Include IDLE time in statistics"])), (_l()(), elementDef(16, 0, null, null, 8, "mat-menu", [], null, null, null, e$2, d$b)), providerDef(6144, null, MatMenu, null, [_MatMenu]), providerDef(6144, null, MAT_MENU_PANEL, null, [MatMenu]), directiveDef(19, 1294336, [["idleOptions", 4]], 3, _MatMenu, [ElementRef, NgZone, MAT_MENU_DEFAULT_OPTIONS], null, null), queryDef(603979776, 1, { _allItems: 1 }), queryDef(603979776, 2, { items: 1 }), queryDef(603979776, 3, { lazyContent: 0 }), (_l()(), anchorDef(16777216, null, 0, 1, null, View_TensorflowStats_1)), directiveDef(24, 278528, null, 0, NgForOf, [ViewContainerRef, TemplateRef, IterableDiffers], { ngForOf: [0, "ngForOf"] }, null), (_l()(), elementDef(25, 0, null, null, 7, "div", [["class", "idle-button-container"]], null, null, null, null, null)), (_l()(), elementDef(26, 16777216, null, null, 6, "button", [["aria-haspopup", "true"], ["class", "mat-menu-trigger"], ["mat-raised-button", ""]], [[1, "disabled", 0], [2, "_mat-animation-noopable", null], [1, "aria-expanded", 0]], [[null, "mousedown"], [null, "keydown"], [null, "click"]], function (_v, en, $event) {
                var ad = true;
                if (("mousedown" === en)) {
                    var pd_0 = (nodeValue(_v, 28)._handleMousedown($event) !== false);
                    ad = (pd_0 && ad);
                }
                if (("keydown" === en)) {
                    var pd_1 = (nodeValue(_v, 28)._handleKeydown($event) !== false);
                    ad = (pd_1 && ad);
                }
                if (("click" === en)) {
                    var pd_2 = (nodeValue(_v, 28)._handleClick($event) !== false);
                    ad = (pd_2 && ad);
                }
                return ad;
            }, d, c)), directiveDef(27, 180224, null, 0, MatButton, [ElementRef, FocusMonitor, [2, ANIMATION_MODULE_TYPE]], null, null), directiveDef(28, 1196032, null, 0, MatMenuTrigger, [Overlay, ElementRef, ViewContainerRef, MAT_MENU_SCROLL_STRATEGY, [2, MatMenu], [8, null], [2, Directionality], FocusMonitor], { menu: [0, "menu"] }, null), (_l()(), textDef(29, 0, [" ", " "])), (_l()(), elementDef(30, 0, null, 0, 2, "mat-icon", [["class", "mat-icon notranslate"], ["role", "img"]], [[2, "mat-icon-inline", null], [2, "mat-icon-no-color", null]], null, null, d$5, c$5)), directiveDef(31, 9158656, null, 0, MatIcon, [ElementRef, MatIconRegistry, [8, null], [2, MAT_ICON_LOCATION], [2, ErrorHandler]], null, null), (_l()(), textDef(-1, 0, ["arrow_drop_down"])), (_l()(), elementDef(33, 0, null, null, 0, "br", [], null, null, null, null, null)), (_l()(), anchorDef(16777216, null, null, 1, null, View_TensorflowStats_2)), directiveDef(35, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"] }, null), (_l()(), elementDef(36, 0, null, null, 11, "div", [["class", "row"]], null, null, null, null, null)), (_l()(), elementDef(37, 0, null, null, 6, "div", [["class", "pie-chart"]], null, null, null, null, null)), (_l()(), elementDef(38, 0, null, null, 1, "div", [["class", "mat-title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["ON HOST: TOTAL SELF-TIME (GROUPED BY TYPE)"])), (_l()(), elementDef(40, 0, null, null, 1, "div", [["class", "description"]], null, null, null, null, null)), (_l()(), textDef(-1, null, [" (in microseconds) of a TensorFlow operation type "])), (_l()(), elementDef(42, 0, null, null, 1, "chart", [["chartType", "PieChart"]], null, null, null, View_Chart_0, RenderType_Chart)), directiveDef(43, 638976, null, 0, Chart, [ElementRef], { chartType: [0, "chartType"], dataInfo: [1, "dataInfo"] }, null), (_l()(), anchorDef(16777216, null, null, 1, null, View_TensorflowStats_5)), directiveDef(45, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"] }, null), (_l()(), anchorDef(16777216, null, null, 1, null, View_TensorflowStats_6)), directiveDef(47, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"] }, null), (_l()(), elementDef(48, 0, null, null, 1, "mat-divider", [["class", "mat-divider"], ["role", "separator"]], [[1, "aria-orientation", 0], [2, "mat-divider-vertical", null], [2, "mat-divider-horizontal", null], [2, "mat-divider-inset", null]], null, null, d$7, c$7)), directiveDef(49, 49152, null, 0, MatDivider, [], null, null), (_l()(), elementDef(50, 0, null, null, 1, "stats-table", [], null, null, null, View_StatsTable_0, RenderType_StatsTable)), directiveDef(51, 638976, null, 0, StatsTable, [], { tensorflowStatsData: [0, "tensorflowStatsData"], diffData: [1, "diffData"], hasDiff: [2, "hasDiff"] }, null), (_l()(), elementDef(52, 0, null, null, 1, "mat-divider", [["class", "mat-divider"], ["role", "separator"]], [[1, "aria-orientation", 0], [2, "mat-divider-vertical", null], [2, "mat-divider-horizontal", null], [2, "mat-divider-inset", null]], null, null, d$7, c$7)), directiveDef(53, 49152, null, 0, MatDivider, [], null, null), (_l()(), anchorDef(16777216, null, null, 1, null, View_TensorflowStats_7)), directiveDef(55, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"] }, null), (_l()(), anchorDef(16777216, null, null, 1, null, View_TensorflowStats_9)), directiveDef(57, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"] }, null), (_l()(), elementDef(58, 0, null, null, 1, "operations-table", [], null, null, null, View_OperationsTable_0, RenderType_OperationsTable)), directiveDef(59, 573440, null, 0, OperationsTable, [], { tensorflowStatsData: [0, "tensorflowStatsData"], diffData: [1, "diffData"], hasDiff: [2, "hasDiff"], opExecutor: [3, "opExecutor"] }, null)], function (_ck, _v) { var _co = _v.component; var currVal_1 = "tensorflow_stats"; _ck(_v, 12, 0, currVal_1); _ck(_v, 19, 0); var currVal_2 = _co.idleOptionItems; _ck(_v, 24, 0, currVal_2); var currVal_6 = nodeValue(_v, 19); _ck(_v, 28, 0, currVal_6); _ck(_v, 31, 0); var currVal_10 = _co.hasDeviceData; _ck(_v, 35, 0, currVal_10); var currVal_11 = "PieChart"; var currVal_12 = _co.dataInfoHostByType; _ck(_v, 43, 0, currVal_11, currVal_12); var currVal_13 = !_co.hasDiff; _ck(_v, 45, 0, currVal_13); var currVal_14 = _co.showModelProperties; _ck(_v, 47, 0, currVal_14); var currVal_19 = _co.selectedData; var currVal_20 = _co.selectedDiffData; var currVal_21 = _co.hasDiff; _ck(_v, 51, 0, currVal_19, currVal_20, currVal_21); var currVal_26 = _co.hasDeviceData; _ck(_v, 55, 0, currVal_26); var currVal_27 = _co.showPprofLink; _ck(_v, 57, 0, currVal_27); var currVal_28 = _co.selectedData; var currVal_29 = _co.selectedDiffData; var currVal_30 = _co.hasDiff; var currVal_31 = _co.opExecutorHost; _ck(_v, 59, 0, currVal_28, currVal_29, currVal_30, currVal_31); }, function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.title; _ck(_v, 4, 0, currVal_0); var currVal_3 = (nodeValue(_v, 27).disabled || null); var currVal_4 = (nodeValue(_v, 27)._animationMode === "NoopAnimations"); var currVal_5 = (nodeValue(_v, 28).menuOpen || null); _ck(_v, 26, 0, currVal_3, currVal_4, currVal_5); var currVal_7 = _co.idleMenuButtonLabel; _ck(_v, 29, 0, currVal_7); var currVal_8 = nodeValue(_v, 31).inline; var currVal_9 = (((nodeValue(_v, 31).color !== "primary") && (nodeValue(_v, 31).color !== "accent")) && (nodeValue(_v, 31).color !== "warn")); _ck(_v, 30, 0, currVal_8, currVal_9); var currVal_15 = (nodeValue(_v, 49).vertical ? "vertical" : "horizontal"); var currVal_16 = nodeValue(_v, 49).vertical; var currVal_17 = !nodeValue(_v, 49).vertical; var currVal_18 = nodeValue(_v, 49).inset; _ck(_v, 48, 0, currVal_15, currVal_16, currVal_17, currVal_18); var currVal_22 = (nodeValue(_v, 53).vertical ? "vertical" : "horizontal"); var currVal_23 = nodeValue(_v, 53).vertical; var currVal_24 = !nodeValue(_v, 53).vertical; var currVal_25 = nodeValue(_v, 53).inset; _ck(_v, 52, 0, currVal_22, currVal_23, currVal_24, currVal_25); });
    }
    function View_TensorflowStats_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "tensorflow-stats", [], null, null, null, View_TensorflowStats_0, RenderType_TensorflowStats)), directiveDef(1, 49152, null, 0, TensorflowStats, [Store], null, null)], null, null); }
    var TensorflowStatsNgFactory = createComponentFactory("tensorflow-stats", TensorflowStats, View_TensorflowStats_Host_0, {}, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var TensorflowStatsAdapterModuleNgFactory = createNgModuleFactory(TensorflowStatsAdapterModule, [], function (_l) { return moduleDef([moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [[8, []], [3, ComponentFactoryResolver], NgModuleRef]), moduleProvideDef(4608, NgLocalization, NgLocaleLocalization, [LOCALE_ID$1, [2, DEPRECATED_PLURAL_FN]]), moduleProvideDef(4608, Overlay, Overlay, [ScrollStrategyOptions, OverlayContainer, ComponentFactoryResolver, OverlayPositionBuilder, OverlayKeyboardDispatcher, Injector, NgZone, DOCUMENT, Directionality, [2, Location]]), moduleProvideDef(5120, CDK_CONNECTED_OVERLAY_SCROLL_STRATEGY, CDK_CONNECTED_OVERLAY_SCROLL_STRATEGY_PROVIDER_FACTORY, [Overlay]), moduleProvideDef(5120, MAT_MENU_SCROLL_STRATEGY, MAT_MENU_SCROLL_STRATEGY_FACTORY, [Overlay]), moduleProvideDef(4608, MutationObserverFactory, MutationObserverFactory, []), moduleProvideDef(4608, ErrorStateMatcher, ErrorStateMatcher, []), moduleProvideDef(1073742336, CommonModule, CommonModule, []), moduleProvideDef(1073742336, BidiModule, BidiModule, []), moduleProvideDef(1073742336, MatCommonModule, MatCommonModule, [[2, MATERIAL_SANITY_CHECKS], [2, HAMMER_LOADER]]), moduleProvideDef(1073742336, PlatformModule, PlatformModule, []), moduleProvideDef(1073742336, MatRippleModule, MatRippleModule, []), moduleProvideDef(1073742336, MatButtonModule, MatButtonModule, []), moduleProvideDef(1073742336, MatDividerModule, MatDividerModule, []), moduleProvideDef(1073742336, MatIconModule, MatIconModule, []), moduleProvideDef(1073742336, PortalModule, PortalModule, []), moduleProvideDef(1073742336, ScrollingModule, ScrollingModule, []), moduleProvideDef(1073742336, OverlayModule, OverlayModule, []), moduleProvideDef(1073742336, _MatMenuDirectivesModule, _MatMenuDirectivesModule, []), moduleProvideDef(1073742336, MatMenuModule, MatMenuModule, []), moduleProvideDef(1073742336, ChartModule, ChartModule, []), moduleProvideDef(1073742336, ExportAsCsvModule, ExportAsCsvModule, []), moduleProvideDef(1073742336, FlopRateChartModule, FlopRateChartModule, []), moduleProvideDef(1073742336, ModelPropertiesModule, ModelPropertiesModule, []), moduleProvideDef(1073742336, OperationsTableModule, OperationsTableModule, []), moduleProvideDef(1073742336, ObserversModule, ObserversModule, []), moduleProvideDef(1073742336, MatFormFieldModule, MatFormFieldModule, []), moduleProvideDef(1073742336, TextFieldModule, TextFieldModule, []), moduleProvideDef(1073742336, MatInputModule, MatInputModule, []), moduleProvideDef(1073742336, StatsTableModule, StatsTableModule, []), moduleProvideDef(1073742336, TensorflowStatsModule, TensorflowStatsModule, []), moduleProvideDef(1073742336, TensorflowStatsAdapterModule, TensorflowStatsAdapterModule, [])]); });
    var styles_TensorflowStatsAdapter = [];
    var RenderType_TensorflowStatsAdapter = createRendererType2({ encapsulation: 2, styles: styles_TensorflowStatsAdapter, data: {} });
    function View_TensorflowStatsAdapter_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "tensorflow-stats", [], null, null, null, View_TensorflowStats_0, RenderType_TensorflowStats)), directiveDef(1, 49152, null, 0, TensorflowStats, [Store], null, null)], null, null); }
    function View_TensorflowStatsAdapter_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "tensorflow-stats-adapter", [], null, null, null, View_TensorflowStatsAdapter_0, RenderType_TensorflowStatsAdapter)), directiveDef(1, 180224, null, 0, TensorflowStatsAdapter, [ActivatedRoute, Store], null, null)], null, null); }
    var TensorflowStatsAdapterNgFactory = createComponentFactory("tensorflow-stats-adapter", TensorflowStatsAdapter, View_TensorflowStatsAdapter_Host_0, {}, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$F = ["iframe[_ngcontent-%COMP%]{position:absolute;width:100%;height:100%;box-sizing:border-box}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_TraceViewer = [styles$F];
    var RenderType_TraceViewer = createRendererType2({ encapsulation: 0, styles: styles_TraceViewer, data: {} });
    function View_TraceViewer_0(_l) { return viewDef(0, [pipeDef(0, SafePipe, [DomSanitizer]), (_l()(), elementDef(1, 0, null, null, 1, "iframe", [], [[8, "src", 5]], null, null, null, null)), purePipeDef(2, 1)], null, function (_ck, _v) { var _co = _v.component; var currVal_0 = unwrapValue(_v, 1, 0, _ck(_v, 2, 0, nodeValue(_v, 0), _co.url)); _ck(_v, 1, 0, currVal_0); }); }
    function View_TraceViewer_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "trace-viewer", [], null, null, null, View_TraceViewer_0, RenderType_TraceViewer)), directiveDef(1, 180224, null, 0, TraceViewer, [PlatformLocation, ActivatedRoute], null, null)], null, null); }
    var TraceViewerNgFactory = createComponentFactory("trace-viewer", TraceViewer, View_TraceViewer_Host_0, {}, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$G = ["mat-progress-bar[_ngcontent-%COMP%]{width:300px;margin:0 auto}.progress-container[_ngcontent-%COMP%]{padding:50px}.loading-message[_ngcontent-%COMP%]{width:fit-content;margin:0 auto}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$H = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}mat-sidenav-container[_ngcontent-%COMP%]{background-color:#fff}mat-sidenav[_ngcontent-%COMP%]{background:transparent;width:340px;border-right:1px solid #eee}mat-progress-bar[_ngcontent-%COMP%]{width:300px;margin:0 auto}.progress-container[_ngcontent-%COMP%]{padding:50px}.loading-message[_ngcontent-%COMP%]{width:fit-content;margin:0 auto}"];
    var MatSidenavModuleNgFactory = createNgModuleFactory(MatSidenavModule, [], function (_l) {
        return moduleDef([
            moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [
                [
                    8,
                    []
                ],
                [
                    3,
                    ComponentFactoryResolver
                ],
                NgModuleRef
            ]),
            moduleProvideDef(4608, NgLocalization, NgLocaleLocalization, [
                LOCALE_ID$1,
                [
                    2,
                    DEPRECATED_PLURAL_FN
                ]
            ]),
            moduleProvideDef(1073742336, CommonModule, CommonModule, []),
            moduleProvideDef(1073742336, BidiModule, BidiModule, []),
            moduleProvideDef(1073742336, MatCommonModule, MatCommonModule, [
                [
                    2,
                    MATERIAL_SANITY_CHECKS
                ],
                [
                    2,
                    HAMMER_LOADER
                ]
            ]),
            moduleProvideDef(1073742336, PlatformModule, PlatformModule, []),
            moduleProvideDef(1073742336, ScrollingModule, ScrollingModule, []),
            moduleProvideDef(1073742336, MatSidenavModule, MatSidenavModule, [])
        ]);
    });
    var styles_MatDrawerContent = [];
    var RenderType_MatDrawerContent = createRendererType2({
        encapsulation: 2,
        styles: styles_MatDrawerContent,
        data: {}
    });
    function View_MatDrawerContent_0(_l) {
        return viewDef(2, [ngContentDef(null, 0)], null, null);
    }
    function View_MatDrawerContent_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'mat-drawer-content', [[
                    'class',
                    'mat-drawer-content'
                ]], [
                [
                    4,
                    'margin-left',
                    'px'
                ],
                [
                    4,
                    'margin-right',
                    'px'
                ]
            ], null, null, View_MatDrawerContent_0, RenderType_MatDrawerContent)),
            directiveDef(1, 1294336, null, 0, MatDrawerContent, [
                ChangeDetectorRef,
                MatDrawerContainer,
                ElementRef,
                ScrollDispatcher,
                NgZone
            ], null, null)
        ], function (_ck, _v) {
            _ck(_v, 1, 0);
        }, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 1)._container._contentMargins.left;
            var currVal_1 = nodeValue(_v, 1)._container._contentMargins.right;
            _ck(_v, 0, 0, currVal_0, currVal_1);
        });
    }
    var MatDrawerContentNgFactory = createComponentFactory('mat-drawer-content', MatDrawerContent, View_MatDrawerContent_Host_0, {}, {}, ['*']);
    var styles_MatDrawer = [];
    var RenderType_MatDrawer = createRendererType2({
        encapsulation: 2,
        styles: styles_MatDrawer,
        data: {
            'animation': [{
                    type: 7,
                    name: 'transform',
                    definitions: [
                        {
                            type: 0,
                            name: 'open, open-instant',
                            styles: {
                                type: 6,
                                styles: {
                                    transform: 'none',
                                    visibility: 'visible'
                                },
                                offset: null
                            },
                            options: undefined
                        },
                        {
                            type: 0,
                            name: 'void',
                            styles: {
                                type: 6,
                                styles: {
                                    'box-shadow': 'none',
                                    visibility: 'hidden'
                                },
                                offset: null
                            },
                            options: undefined
                        },
                        {
                            type: 1,
                            expr: 'void => open-instant',
                            animation: {
                                type: 4,
                                styles: null,
                                timings: '0ms'
                            },
                            options: null
                        },
                        {
                            type: 1,
                            expr: 'void <=> open, open-instant => void',
                            animation: {
                                type: 4,
                                styles: null,
                                timings: '400ms cubic-bezier(0.25, 0.8, 0.25, 1)'
                            },
                            options: null
                        }
                    ],
                    options: {}
                }]
        }
    });
    function View_MatDrawer_0(_l) {
        return viewDef(2, [
            (_l()(), elementDef(0, 0, null, null, 1, 'div', [[
                    'class',
                    'mat-drawer-inner-container'
                ]], null, null, null, null, null)),
            ngContentDef(null, 0)
        ], null, null);
    }
    function View_MatDrawer_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'mat-drawer', [
                [
                    'class',
                    'mat-drawer'
                ],
                [
                    'tabIndex',
                    '-1'
                ]
            ], [
                [
                    1,
                    'align',
                    0
                ],
                [
                    2,
                    'mat-drawer-end',
                    null
                ],
                [
                    2,
                    'mat-drawer-over',
                    null
                ],
                [
                    2,
                    'mat-drawer-push',
                    null
                ],
                [
                    2,
                    'mat-drawer-side',
                    null
                ],
                [
                    2,
                    'mat-drawer-opened',
                    null
                ],
                [
                    40,
                    '@transform',
                    0
                ]
            ], [
                [
                    'component',
                    '@transform.start'
                ],
                [
                    'component',
                    '@transform.done'
                ]
            ], function (_v, en, $event) {
                var ad = true;
                if ('component:@transform.start' === en) {
                    var pd_0 = nodeValue(_v, 1)._animationStartListener($event) !== false;
                    ad = pd_0 && ad;
                }
                if ('component:@transform.done' === en) {
                    var pd_1 = nodeValue(_v, 1)._animationDoneListener($event) !== false;
                    ad = pd_1 && ad;
                }
                return ad;
            }, View_MatDrawer_0, RenderType_MatDrawer)),
            directiveDef(1, 3325952, null, 0, MatDrawer, [
                ElementRef,
                FocusTrapFactory,
                FocusMonitor,
                Platform,
                NgZone,
                [
                    2,
                    DOCUMENT
                ]
            ], null, null)
        ], null, function (_ck, _v) {
            var currVal_0 = null;
            var currVal_1 = nodeValue(_v, 1).position === 'end';
            var currVal_2 = nodeValue(_v, 1).mode === 'over';
            var currVal_3 = nodeValue(_v, 1).mode === 'push';
            var currVal_4 = nodeValue(_v, 1).mode === 'side';
            var currVal_5 = nodeValue(_v, 1).opened;
            var currVal_6 = nodeValue(_v, 1)._animationState;
            _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5, currVal_6);
        });
    }
    var MatDrawerNgFactory = createComponentFactory('mat-drawer', MatDrawer, View_MatDrawer_Host_0, {
        position: 'position',
        mode: 'mode',
        disableClose: 'disableClose',
        autoFocus: 'autoFocus',
        opened: 'opened'
    }, {
        openedChange: 'openedChange',
        _openedStream: 'opened',
        openedStart: 'openedStart',
        _closedStream: 'closed',
        closedStart: 'closedStart',
        onPositionChanged: 'positionChanged'
    }, ['*']);
    var styles_MatDrawerContainer = ['.mat-drawer-container{position:relative;z-index:1;box-sizing:border-box;-webkit-overflow-scrolling:touch;display:block;overflow:hidden}.mat-drawer-container[fullscreen]{top:0;left:0;right:0;bottom:0;position:absolute}.mat-drawer-container[fullscreen].mat-drawer-container-has-open{overflow:hidden}.mat-drawer-container.mat-drawer-container-explicit-backdrop .mat-drawer-side{z-index:3}.mat-drawer-container.ng-animate-disabled .mat-drawer-backdrop,.mat-drawer-container.ng-animate-disabled .mat-drawer-content,.ng-animate-disabled .mat-drawer-container .mat-drawer-backdrop,.ng-animate-disabled .mat-drawer-container .mat-drawer-content{transition:none}.mat-drawer-backdrop{top:0;left:0;right:0;bottom:0;position:absolute;display:block;z-index:3;visibility:hidden}.mat-drawer-backdrop.mat-drawer-shown{visibility:visible}.mat-drawer-transition .mat-drawer-backdrop{transition-duration:.4s;transition-timing-function:cubic-bezier(.25,.8,.25,1);transition-property:background-color,visibility}@media (-ms-high-contrast:active){.mat-drawer-backdrop{opacity:.5}}.mat-drawer-content{position:relative;z-index:1;display:block;height:100%;overflow:auto}.mat-drawer-transition .mat-drawer-content{transition-duration:.4s;transition-timing-function:cubic-bezier(.25,.8,.25,1);transition-property:transform,margin-left,margin-right}.mat-drawer{position:relative;z-index:4;display:block;position:absolute;top:0;bottom:0;z-index:3;outline:0;box-sizing:border-box;overflow-y:auto;transform:translate3d(-100%,0,0)}@media (-ms-high-contrast:active){.mat-drawer,[dir=rtl] .mat-drawer.mat-drawer-end{border-right:solid 1px currentColor}}@media (-ms-high-contrast:active){.mat-drawer.mat-drawer-end,[dir=rtl] .mat-drawer{border-left:solid 1px currentColor;border-right:none}}.mat-drawer.mat-drawer-side{z-index:2}.mat-drawer.mat-drawer-end{right:0;transform:translate3d(100%,0,0)}[dir=rtl] .mat-drawer{transform:translate3d(100%,0,0)}[dir=rtl] .mat-drawer.mat-drawer-end{left:0;right:auto;transform:translate3d(-100%,0,0)}.mat-drawer-inner-container{width:100%;height:100%;overflow:auto;-webkit-overflow-scrolling:touch}.mat-sidenav-fixed{position:fixed}'];
    var RenderType_MatDrawerContainer = createRendererType2({
        encapsulation: 2,
        styles: styles_MatDrawerContainer,
        data: {}
    });
    function View_MatDrawerContainer_1(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 0, 'div', [[
                    'class',
                    'mat-drawer-backdrop'
                ]], [[
                    2,
                    'mat-drawer-shown',
                    null
                ]], [[
                    null,
                    'click'
                ]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if ('click' === en) {
                    var pd_0 = _co._onBackdropClicked() !== false;
                    ad = pd_0 && ad;
                }
                return ad;
            }, null, null))], null, function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co._isShowingBackdrop();
            _ck(_v, 0, 0, currVal_0);
        });
    }
    function View_MatDrawerContainer_2(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 2, 'mat-drawer-content', [[
                    'class',
                    'mat-drawer-content'
                ]], [
                [
                    4,
                    'margin-left',
                    'px'
                ],
                [
                    4,
                    'margin-right',
                    'px'
                ]
            ], null, null, View_MatDrawerContent_0, RenderType_MatDrawerContent)),
            directiveDef(1, 1294336, [[
                    1,
                    4
                ]], 0, MatDrawerContent, [
                ChangeDetectorRef,
                MatDrawerContainer,
                ElementRef,
                ScrollDispatcher,
                NgZone
            ], null, null),
            ngContentDef(0, 2)
        ], function (_ck, _v) {
            _ck(_v, 1, 0);
        }, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 1)._container._contentMargins.left;
            var currVal_1 = nodeValue(_v, 1)._container._contentMargins.right;
            _ck(_v, 0, 0, currVal_0, currVal_1);
        });
    }
    function View_MatDrawerContainer_0(_l) {
        return viewDef(2, [
            queryDef(671088640, 1, { _userContent: 0 }),
            (_l()(), anchorDef(16777216, null, null, 1, null, View_MatDrawerContainer_1)),
            directiveDef(2, 16384, null, 0, NgIf, [
                ViewContainerRef,
                TemplateRef
            ], {
                ngIf: [
                    0,
                    'ngIf'
                ]
            }, null),
            ngContentDef(null, 0),
            ngContentDef(null, 1),
            (_l()(), anchorDef(16777216, null, null, 1, null, View_MatDrawerContainer_2)),
            directiveDef(6, 16384, null, 0, NgIf, [
                ViewContainerRef,
                TemplateRef
            ], {
                ngIf: [
                    0,
                    'ngIf'
                ]
            }, null)
        ], function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co.hasBackdrop;
            _ck(_v, 2, 0, currVal_0);
            var currVal_1 = !_co._content;
            _ck(_v, 6, 0, currVal_1);
        }, null);
    }
    function View_MatDrawerContainer_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 3, 'mat-drawer-container', [[
                    'class',
                    'mat-drawer-container'
                ]], [[
                    2,
                    'mat-drawer-container-explicit-backdrop',
                    null
                ]], null, null, View_MatDrawerContainer_0, RenderType_MatDrawerContainer)),
            directiveDef(1, 1490944, null, 2, MatDrawerContainer, [
                [
                    2,
                    Directionality
                ],
                ElementRef,
                NgZone,
                ChangeDetectorRef,
                ViewportRuler,
                MAT_DRAWER_DEFAULT_AUTOSIZE,
                [
                    2,
                    ANIMATION_MODULE_TYPE
                ]
            ], null, null),
            queryDef(603979776, 1, { _drawers: 1 }),
            queryDef(603979776, 2, { _content: 0 })
        ], function (_ck, _v) {
            _ck(_v, 1, 0);
        }, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 1)._backdropOverride;
            _ck(_v, 0, 0, currVal_0);
        });
    }
    var MatDrawerContainerNgFactory = createComponentFactory('mat-drawer-container', MatDrawerContainer, View_MatDrawerContainer_Host_0, {
        autosize: 'autosize',
        hasBackdrop: 'hasBackdrop'
    }, { backdropClick: 'backdropClick' }, [
        'mat-drawer',
        'mat-drawer-content',
        '*'
    ]);
    var styles_MatSidenavContent = [];
    var RenderType_MatSidenavContent = createRendererType2({
        encapsulation: 2,
        styles: styles_MatSidenavContent,
        data: {}
    });
    function View_MatSidenavContent_0(_l) {
        return viewDef(2, [ngContentDef(null, 0)], null, null);
    }
    function View_MatSidenavContent_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'mat-sidenav-content', [[
                    'class',
                    'mat-drawer-content mat-sidenav-content'
                ]], [
                [
                    4,
                    'margin-left',
                    'px'
                ],
                [
                    4,
                    'margin-right',
                    'px'
                ]
            ], null, null, View_MatSidenavContent_0, RenderType_MatSidenavContent)),
            directiveDef(1, 1294336, null, 0, MatSidenavContent, [
                ChangeDetectorRef,
                MatSidenavContainer,
                ElementRef,
                ScrollDispatcher,
                NgZone
            ], null, null)
        ], function (_ck, _v) {
            _ck(_v, 1, 0);
        }, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 1)._container._contentMargins.left;
            var currVal_1 = nodeValue(_v, 1)._container._contentMargins.right;
            _ck(_v, 0, 0, currVal_0, currVal_1);
        });
    }
    var MatSidenavContentNgFactory = createComponentFactory('mat-sidenav-content', MatSidenavContent, View_MatSidenavContent_Host_0, {}, {}, ['*']);
    var styles_MatSidenav = [];
    var RenderType_MatSidenav = createRendererType2({
        encapsulation: 2,
        styles: styles_MatSidenav,
        data: {
            'animation': [{
                    type: 7,
                    name: 'transform',
                    definitions: [
                        {
                            type: 0,
                            name: 'open, open-instant',
                            styles: {
                                type: 6,
                                styles: {
                                    transform: 'none',
                                    visibility: 'visible'
                                },
                                offset: null
                            },
                            options: undefined
                        },
                        {
                            type: 0,
                            name: 'void',
                            styles: {
                                type: 6,
                                styles: {
                                    'box-shadow': 'none',
                                    visibility: 'hidden'
                                },
                                offset: null
                            },
                            options: undefined
                        },
                        {
                            type: 1,
                            expr: 'void => open-instant',
                            animation: {
                                type: 4,
                                styles: null,
                                timings: '0ms'
                            },
                            options: null
                        },
                        {
                            type: 1,
                            expr: 'void <=> open, open-instant => void',
                            animation: {
                                type: 4,
                                styles: null,
                                timings: '400ms cubic-bezier(0.25, 0.8, 0.25, 1)'
                            },
                            options: null
                        }
                    ],
                    options: {}
                }]
        }
    });
    function View_MatSidenav_0(_l) {
        return viewDef(2, [
            (_l()(), elementDef(0, 0, null, null, 1, 'div', [[
                    'class',
                    'mat-drawer-inner-container'
                ]], null, null, null, null, null)),
            ngContentDef(null, 0)
        ], null, null);
    }
    function View_MatSidenav_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'mat-sidenav', [
                [
                    'class',
                    'mat-drawer mat-sidenav'
                ],
                [
                    'tabIndex',
                    '-1'
                ]
            ], [
                [
                    1,
                    'align',
                    0
                ],
                [
                    2,
                    'mat-drawer-end',
                    null
                ],
                [
                    2,
                    'mat-drawer-over',
                    null
                ],
                [
                    2,
                    'mat-drawer-push',
                    null
                ],
                [
                    2,
                    'mat-drawer-side',
                    null
                ],
                [
                    2,
                    'mat-drawer-opened',
                    null
                ],
                [
                    2,
                    'mat-sidenav-fixed',
                    null
                ],
                [
                    4,
                    'top',
                    'px'
                ],
                [
                    4,
                    'bottom',
                    'px'
                ],
                [
                    40,
                    '@transform',
                    0
                ]
            ], [
                [
                    'component',
                    '@transform.start'
                ],
                [
                    'component',
                    '@transform.done'
                ]
            ], function (_v, en, $event) {
                var ad = true;
                if ('component:@transform.start' === en) {
                    var pd_0 = nodeValue(_v, 1)._animationStartListener($event) !== false;
                    ad = pd_0 && ad;
                }
                if ('component:@transform.done' === en) {
                    var pd_1 = nodeValue(_v, 1)._animationDoneListener($event) !== false;
                    ad = pd_1 && ad;
                }
                return ad;
            }, View_MatSidenav_0, RenderType_MatSidenav)),
            directiveDef(1, 3325952, null, 0, MatSidenav, [
                ElementRef,
                FocusTrapFactory,
                FocusMonitor,
                Platform,
                NgZone,
                [
                    2,
                    DOCUMENT
                ]
            ], null, null)
        ], null, function (_ck, _v) {
            var currVal_0 = null;
            var currVal_1 = nodeValue(_v, 1).position === 'end';
            var currVal_2 = nodeValue(_v, 1).mode === 'over';
            var currVal_3 = nodeValue(_v, 1).mode === 'push';
            var currVal_4 = nodeValue(_v, 1).mode === 'side';
            var currVal_5 = nodeValue(_v, 1).opened;
            var currVal_6 = nodeValue(_v, 1).fixedInViewport;
            var currVal_7 = nodeValue(_v, 1).fixedInViewport ? nodeValue(_v, 1).fixedTopGap : null;
            var currVal_8 = nodeValue(_v, 1).fixedInViewport ? nodeValue(_v, 1).fixedBottomGap : null;
            var currVal_9 = nodeValue(_v, 1)._animationState;
            _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5, currVal_6, currVal_7, currVal_8, currVal_9);
        });
    }
    var MatSidenavNgFactory = createComponentFactory('mat-sidenav', MatSidenav, View_MatSidenav_Host_0, {
        position: 'position',
        mode: 'mode',
        disableClose: 'disableClose',
        autoFocus: 'autoFocus',
        opened: 'opened',
        fixedInViewport: 'fixedInViewport',
        fixedTopGap: 'fixedTopGap',
        fixedBottomGap: 'fixedBottomGap'
    }, {
        openedChange: 'openedChange',
        _openedStream: 'opened',
        openedStart: 'openedStart',
        _closedStream: 'closed',
        closedStart: 'closedStart',
        onPositionChanged: 'positionChanged'
    }, ['*']);
    var styles_MatSidenavContainer = ['.mat-drawer-container{position:relative;z-index:1;box-sizing:border-box;-webkit-overflow-scrolling:touch;display:block;overflow:hidden}.mat-drawer-container[fullscreen]{top:0;left:0;right:0;bottom:0;position:absolute}.mat-drawer-container[fullscreen].mat-drawer-container-has-open{overflow:hidden}.mat-drawer-container.mat-drawer-container-explicit-backdrop .mat-drawer-side{z-index:3}.mat-drawer-container.ng-animate-disabled .mat-drawer-backdrop,.mat-drawer-container.ng-animate-disabled .mat-drawer-content,.ng-animate-disabled .mat-drawer-container .mat-drawer-backdrop,.ng-animate-disabled .mat-drawer-container .mat-drawer-content{transition:none}.mat-drawer-backdrop{top:0;left:0;right:0;bottom:0;position:absolute;display:block;z-index:3;visibility:hidden}.mat-drawer-backdrop.mat-drawer-shown{visibility:visible}.mat-drawer-transition .mat-drawer-backdrop{transition-duration:.4s;transition-timing-function:cubic-bezier(.25,.8,.25,1);transition-property:background-color,visibility}@media (-ms-high-contrast:active){.mat-drawer-backdrop{opacity:.5}}.mat-drawer-content{position:relative;z-index:1;display:block;height:100%;overflow:auto}.mat-drawer-transition .mat-drawer-content{transition-duration:.4s;transition-timing-function:cubic-bezier(.25,.8,.25,1);transition-property:transform,margin-left,margin-right}.mat-drawer{position:relative;z-index:4;display:block;position:absolute;top:0;bottom:0;z-index:3;outline:0;box-sizing:border-box;overflow-y:auto;transform:translate3d(-100%,0,0)}@media (-ms-high-contrast:active){.mat-drawer,[dir=rtl] .mat-drawer.mat-drawer-end{border-right:solid 1px currentColor}}@media (-ms-high-contrast:active){.mat-drawer.mat-drawer-end,[dir=rtl] .mat-drawer{border-left:solid 1px currentColor;border-right:none}}.mat-drawer.mat-drawer-side{z-index:2}.mat-drawer.mat-drawer-end{right:0;transform:translate3d(100%,0,0)}[dir=rtl] .mat-drawer{transform:translate3d(100%,0,0)}[dir=rtl] .mat-drawer.mat-drawer-end{left:0;right:auto;transform:translate3d(-100%,0,0)}.mat-drawer-inner-container{width:100%;height:100%;overflow:auto;-webkit-overflow-scrolling:touch}.mat-sidenav-fixed{position:fixed}'];
    var RenderType_MatSidenavContainer = createRendererType2({
        encapsulation: 2,
        styles: styles_MatSidenavContainer,
        data: {}
    });
    function View_MatSidenavContainer_1(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 0, 'div', [[
                    'class',
                    'mat-drawer-backdrop'
                ]], [[
                    2,
                    'mat-drawer-shown',
                    null
                ]], [[
                    null,
                    'click'
                ]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if ('click' === en) {
                    var pd_0 = _co._onBackdropClicked() !== false;
                    ad = pd_0 && ad;
                }
                return ad;
            }, null, null))], null, function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co._isShowingBackdrop();
            _ck(_v, 0, 0, currVal_0);
        });
    }
    function View_MatSidenavContainer_2(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 3, 'mat-sidenav-content', [
                [
                    'cdkScrollable',
                    ''
                ],
                [
                    'class',
                    'mat-drawer-content mat-sidenav-content'
                ]
            ], [
                [
                    4,
                    'margin-left',
                    'px'
                ],
                [
                    4,
                    'margin-right',
                    'px'
                ]
            ], null, null, View_MatSidenavContent_0, RenderType_MatSidenavContent)),
            directiveDef(1, 212992, null, 0, CdkScrollable, [
                ElementRef,
                ScrollDispatcher,
                NgZone,
                [
                    2,
                    Directionality
                ]
            ], null, null),
            directiveDef(2, 1294336, null, 0, MatSidenavContent, [
                ChangeDetectorRef,
                MatSidenavContainer,
                ElementRef,
                ScrollDispatcher,
                NgZone
            ], null, null),
            ngContentDef(0, 2)
        ], function (_ck, _v) {
            _ck(_v, 1, 0);
            _ck(_v, 2, 0);
        }, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 2)._container._contentMargins.left;
            var currVal_1 = nodeValue(_v, 2)._container._contentMargins.right;
            _ck(_v, 0, 0, currVal_0, currVal_1);
        });
    }
    function View_MatSidenavContainer_0(_l) {
        return viewDef(2, [
            queryDef(671088640, 1, { _userContent: 0 }),
            (_l()(), anchorDef(16777216, null, null, 1, null, View_MatSidenavContainer_1)),
            directiveDef(2, 16384, null, 0, NgIf, [
                ViewContainerRef,
                TemplateRef
            ], {
                ngIf: [
                    0,
                    'ngIf'
                ]
            }, null),
            ngContentDef(null, 0),
            ngContentDef(null, 1),
            (_l()(), anchorDef(16777216, null, null, 1, null, View_MatSidenavContainer_2)),
            directiveDef(6, 16384, null, 0, NgIf, [
                ViewContainerRef,
                TemplateRef
            ], {
                ngIf: [
                    0,
                    'ngIf'
                ]
            }, null)
        ], function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co.hasBackdrop;
            _ck(_v, 2, 0, currVal_0);
            var currVal_1 = !_co._content;
            _ck(_v, 6, 0, currVal_1);
        }, null);
    }
    function View_MatSidenavContainer_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 3, 'mat-sidenav-container', [[
                    'class',
                    'mat-drawer-container mat-sidenav-container'
                ]], [[
                    2,
                    'mat-drawer-container-explicit-backdrop',
                    null
                ]], null, null, View_MatSidenavContainer_0, RenderType_MatSidenavContainer)),
            directiveDef(1, 1490944, null, 2, MatSidenavContainer, [
                [
                    2,
                    Directionality
                ],
                ElementRef,
                NgZone,
                ChangeDetectorRef,
                ViewportRuler,
                MAT_DRAWER_DEFAULT_AUTOSIZE,
                [
                    2,
                    ANIMATION_MODULE_TYPE
                ]
            ], null, null),
            queryDef(603979776, 1, { _drawers: 1 }),
            queryDef(603979776, 2, { _content: 0 })
        ], function (_ck, _v) {
            _ck(_v, 1, 0);
        }, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 1)._backdropOverride;
            _ck(_v, 0, 0, currVal_0);
        });
    }
    var MatSidenavContainerNgFactory = createComponentFactory('mat-sidenav-container', MatSidenavContainer, View_MatSidenavContainer_Host_0, {
        autosize: 'autosize',
        hasBackdrop: 'hasBackdrop'
    }, { backdropClick: 'backdropClick' }, [
        'mat-sidenav',
        'mat-sidenav-content',
        '*'
    ]);
    var o = RenderType_MatSidenavContent;
    var p = View_MatSidenavContent_0;
    var s = RenderType_MatSidenav;
    var t = View_MatSidenav_0;
    var w = RenderType_MatSidenavContainer;
    var x = View_MatSidenavContainer_0;
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$I = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}.button-container[_ngcontent-%COMP%]{padding:20px}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0 20px}.mat-subheading-2[_ngcontent-%COMP%]{margin-bottom:0}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$J = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}[_nghost-%COMP%]{display:block;margin-top:20px}mat-card[_ngcontent-%COMP%]{box-shadow:none !important;border-top:1px solid #eee;border-radius:0;padding:0}.info-header[_ngcontent-%COMP%]{padding:16px;display:flex}.info-header-circle[_ngcontent-%COMP%]{display:inline-block;width:40px;height:40px;border-radius:20px;margin:5px 10px 5px 0}.info-header-content-container[_ngcontent-%COMP%]{display:inline-block;width:260px;height:50px;position:relative}.info-header-content[_ngcontent-%COMP%]{position:absolute;top:50%;transform:translateY(-50%)}.info-header-title[_ngcontent-%COMP%]{font-size:20px;font-weight:500}.info-header-subheader[_ngcontent-%COMP%]{color:#4a4a4a;font-style:italic}.info-content[_ngcontent-%COMP%]{color:#4a4a4a;font-size:16px;padding:16px;word-break:break-word}.info[_ngcontent-%COMP%]{margin-bottom:16px}.title[_ngcontent-%COMP%]{font-weight:500;margin-bottom:4px}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_BufferDetails = [styles$J];
    var RenderType_BufferDetails = createRendererType2({ encapsulation: 0, styles: styles_BufferDetails, data: {} });
    function View_BufferDetails_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 51, "div", [], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 50, "mat-card", [["class", "mat-card"]], [[2, "_mat-animation-noopable", null]], null, null, d$6, c$6)), directiveDef(2, 49152, null, 0, MatCard, [[2, ANIMATION_MODULE_TYPE]], null, null), (_l()(), elementDef(3, 0, null, 0, 48, "mat-card-content", [["class", "mat-card-content"]], null, null, null, null, null)), directiveDef(4, 16384, null, 0, MatCardContent, [], null, null), (_l()(), elementDef(5, 0, null, null, 7, "div", [["class", "info-header"]], null, null, null, null, null)), (_l()(), elementDef(6, 0, null, null, 0, "div", [["class", "info-header-circle"]], [[4, "background", null]], null, null, null, null)), (_l()(), elementDef(7, 0, null, null, 5, "div", [["class", "info-header-content-container"]], null, null, null, null, null)), (_l()(), elementDef(8, 0, null, null, 4, "div", [["class", "info-header-content"]], null, null, null, null, null)), (_l()(), elementDef(9, 0, null, null, 1, "div", [["class", "info-header-title"]], null, null, null, null, null)), (_l()(), textDef(10, null, ["", ""])), (_l()(), elementDef(11, 0, null, null, 1, "div", [["class", "info-header-subheader"]], null, null, null, null, null)), (_l()(), textDef(12, null, ["", ""])), (_l()(), elementDef(13, 0, null, null, 38, "div", [["class", "info-content"]], null, null, null, null, null)), (_l()(), elementDef(14, 0, null, null, 4, "div", [["class", "info"]], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(15, 0, null, null, 1, "div", [["class", "title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Size: "])), (_l()(), elementDef(17, 0, null, null, 1, "div", [], null, null, null, null, null)), (_l()(), textDef(18, null, ["", " MiB"])), (_l()(), elementDef(19, 0, null, null, 4, "div", [["class", "info"]], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(20, 0, null, null, 1, "div", [["class", "title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Unpadded Size: "])), (_l()(), elementDef(22, 0, null, null, 1, "div", [], null, null, null, null, null)), (_l()(), textDef(23, null, ["", " MiB"])), (_l()(), elementDef(24, 0, null, null, 4, "div", [["class", "info"]], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(25, 0, null, null, 1, "div", [["class", "title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Extra memory due to padding: "])), (_l()(), elementDef(27, 0, null, null, 1, "div", [], null, null, null, null, null)), (_l()(), textDef(28, null, ["", " MiB"])), (_l()(), elementDef(29, 0, null, null, 7, "div", [["class", "info"]], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(30, 0, null, null, 1, "div", [["class", "title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Expansion: "])), (_l()(), elementDef(32, 0, null, null, 4, "div", [], null, null, null, null, null)), (_l()(), elementDef(33, 0, null, null, 1, "span", [], null, null, null, null, null)), (_l()(), textDef(34, null, ["", ""])), (_l()(), elementDef(35, 0, null, null, 1, "span", [["class", "title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["X"])), (_l()(), elementDef(37, 0, null, null, 4, "div", [["class", "info"]], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(38, 0, null, null, 1, "div", [["class", "title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Shape (and minor-to-major order): "])), (_l()(), elementDef(40, 0, null, null, 1, "div", [], null, null, null, null, null)), (_l()(), textDef(41, null, ["", ""])), (_l()(), elementDef(42, 0, null, null, 4, "div", [["class", "info"]], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(43, 0, null, null, 1, "div", [["class", "title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Tf Op Name:: "])), (_l()(), elementDef(45, 0, null, null, 1, "div", [], null, null, null, null, null)), (_l()(), textDef(46, null, ["", ""])), (_l()(), elementDef(47, 0, null, null, 4, "div", [["class", "info"]], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(48, 0, null, null, 1, "div", [["class", "title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Allocation Type: "])), (_l()(), elementDef(50, 0, null, null, 1, "div", [], null, null, null, null, null)), (_l()(), textDef(51, null, ["", ""]))], null, function (_ck, _v) { var _co = _v.component; var currVal_0 = !_co.heapObject; _ck(_v, 0, 0, currVal_0); var currVal_1 = (nodeValue(_v, 2)._animationMode === "NoopAnimations"); _ck(_v, 1, 0, currVal_1); var currVal_2 = _co.color; _ck(_v, 6, 0, currVal_2); var currVal_3 = _co.instructionName; _ck(_v, 10, 0, currVal_3); var currVal_4 = _co.opcode; _ck(_v, 12, 0, currVal_4); var currVal_5 = !_co.size; _ck(_v, 14, 0, currVal_5); var currVal_6 = _co.size; _ck(_v, 18, 0, currVal_6); var currVal_7 = !_co.unpaddedSize; _ck(_v, 19, 0, currVal_7); var currVal_8 = _co.unpaddedSize; _ck(_v, 23, 0, currVal_8); var currVal_9 = !_co.padding; _ck(_v, 24, 0, currVal_9); var currVal_10 = _co.padding; _ck(_v, 28, 0, currVal_10); var currVal_11 = !_co.expansion; _ck(_v, 29, 0, currVal_11); var currVal_12 = _co.expansion; _ck(_v, 34, 0, currVal_12); var currVal_13 = !_co.shape; _ck(_v, 37, 0, currVal_13); var currVal_14 = _co.shape; _ck(_v, 41, 0, currVal_14); var currVal_15 = !_co.tfOpName; _ck(_v, 42, 0, currVal_15); var currVal_16 = _co.tfOpName; _ck(_v, 46, 0, currVal_16); var currVal_17 = !_co.groupName; _ck(_v, 47, 0, currVal_17); var currVal_18 = _co.groupName; _ck(_v, 51, 0, currVal_18); }); }
    function View_BufferDetails_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "buffer-details", [], null, null, null, View_BufferDetails_0, RenderType_BufferDetails)), directiveDef(1, 180224, null, 0, BufferDetails, [Store], null, null)], null, null); }
    var BufferDetailsNgFactory = createComponentFactory("buffer-details", BufferDetails, View_BufferDetails_Host_0, {}, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$K = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}[_nghost-%COMP%]{display:block;margin-top:20px}mat-card[_ngcontent-%COMP%]{box-shadow:none !important;border-top:1px solid #eee;border-radius:0;padding:0}.info-header[_ngcontent-%COMP%]{padding:16px;display:flex}.info-header-circle[_ngcontent-%COMP%]{display:inline-block;width:40px;height:40px;border-radius:20px;margin:5px 10px 5px 0}.info-header-content-container[_ngcontent-%COMP%]{display:inline-block;width:260px;height:50px;position:relative}.info-header-content[_ngcontent-%COMP%]{position:absolute;top:50%;transform:translateY(-50%)}.info-header-title[_ngcontent-%COMP%]{font-size:20px;font-weight:500}.info-header-subheader[_ngcontent-%COMP%]{color:#4a4a4a;font-style:italic}.info-content[_ngcontent-%COMP%]{color:#4a4a4a;font-size:16px;padding:16px}.info[_ngcontent-%COMP%]{margin-bottom:16px}.title[_ngcontent-%COMP%]{font-weight:500;margin-bottom:4px}.bar-container[_ngcontent-%COMP%]{background-color:#ccc;height:24px}.bar[_ngcontent-%COMP%]{height:24px;line-height:24px}.expression[_ngcontent-%COMP%]{display:block;word-wrap:break-word}.unavailable[_ngcontent-%COMP%]{font-style:italic;color:#666}.layout[_ngcontent-%COMP%]{display:table;width:100%;border-spacing:16px 5px;margin-left:-10px}.layout[_ngcontent-%COMP%] > *[_ngcontent-%COMP%]{display:table-row}.layout[_ngcontent-%COMP%] > *[_ngcontent-%COMP%] > *[_ngcontent-%COMP%]{display:table-cell}.size[_ngcontent-%COMP%], .size-x[_ngcontent-%COMP%]{text-align:center;width:20%}.size-x[_ngcontent-%COMP%]{font-weight:bold;color:#888}.semantics[_ngcontent-%COMP%]{font-size:smaller;font-weight:bold;color:#48c;text-transform:uppercase;vertical-align:middle;width:30%}.alignment[_ngcontent-%COMP%]{position:absolute;padding:8px;margin-top:-8px;width:45%;box-sizing:border-box}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_OpDetails = [styles$K];
    var RenderType_OpDetails = createRendererType2({ encapsulation: 0, styles: styles_OpDetails, data: {} });
    function View_OpDetails_1(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 11, "div", [["class", "layout"]], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 3, "div", [], null, null, null, null, null)), (_l()(), elementDef(2, 0, null, null, 2, "div", [["class", "size-x"]], null, null, null, null, null)), (_l()(), elementDef(3, 0, null, null, 1, "div", [], [[8, "hidden", 0]], null, null, null, null)), (_l()(), textDef(-1, null, ["x"])), (_l()(), elementDef(5, 0, null, null, 6, "div", [], null, null, null, null, null)), (_l()(), elementDef(6, 0, null, null, 1, "span", [["class", "size"]], null, null, null, null, null)), (_l()(), textDef(7, null, ["", ""])), (_l()(), elementDef(8, 0, null, null, 1, "span", [["class", "semantics"]], null, null, null, null, null)), (_l()(), textDef(9, null, ["", ""])), (_l()(), elementDef(10, 0, null, null, 1, "span", [["class", "alignment"]], [[4, "background-color", null]], null, null, null, null)), (_l()(), textDef(11, null, [" ", " "]))], null, function (_ck, _v) { var _co = _v.component; var currVal_0 = !_v.context.index; _ck(_v, 3, 0, currVal_0); var currVal_1 = _v.context.$implicit.size; _ck(_v, 7, 0, currVal_1); var currVal_2 = _v.context.$implicit.semantics; _ck(_v, 9, 0, currVal_2); var currVal_3 = _co.dimensionColor(_v.context.$implicit); _ck(_v, 10, 0, currVal_3); var currVal_4 = _co.dimensionHint(_v.context.$implicit); _ck(_v, 11, 0, currVal_4); }); }
    function View_OpDetails_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 56, "div", [], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 55, "mat-card", [["class", "mat-card"]], [[2, "_mat-animation-noopable", null]], null, null, d$6, c$6)), directiveDef(2, 49152, null, 0, MatCard, [[2, ANIMATION_MODULE_TYPE]], null, null), (_l()(), elementDef(3, 0, null, 0, 53, "mat-card-content", [["class", "mat-card-content"]], null, null, null, null, null)), directiveDef(4, 16384, null, 0, MatCardContent, [], null, null), (_l()(), elementDef(5, 0, null, null, 7, "div", [["class", "info-header"]], null, null, null, null, null)), (_l()(), elementDef(6, 0, null, null, 0, "div", [["class", "info-header-circle"]], [[4, "background", null]], null, null, null, null)), (_l()(), elementDef(7, 0, null, null, 5, "div", [["class", "info-header-content-container"]], null, null, null, null, null)), (_l()(), elementDef(8, 0, null, null, 4, "div", [["class", "info-header-content"]], null, null, null, null, null)), (_l()(), elementDef(9, 0, null, null, 1, "div", [["class", "info-header-title"]], null, null, null, null, null)), (_l()(), textDef(10, null, ["", ""])), (_l()(), elementDef(11, 0, null, null, 1, "div", [["class", "info-header-subheader"]], null, null, null, null, null)), (_l()(), textDef(12, null, ["", ""])), (_l()(), elementDef(13, 0, null, null, 43, "div", [["class", "info-content"]], null, null, null, null, null)), (_l()(), elementDef(14, 0, null, null, 5, "div", [["class", "info"]], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(15, 0, null, null, 1, "div", [["class", "title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["FLOPS utilization:"])), (_l()(), elementDef(17, 0, null, null, 2, "div", [["class", "bar-container"]], null, null, null, null, null)), (_l()(), elementDef(18, 0, null, null, 1, "div", [["class", "bar"]], [[4, "width", null], [4, "background-color", null]], null, null, null, null)), (_l()(), textDef(19, null, [" \u00A0", " "])), (_l()(), elementDef(20, 0, null, null, 5, "div", [["class", "info"]], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(21, 0, null, null, 1, "div", [["class", "title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Memory bandwidth utilization:"])), (_l()(), elementDef(23, 0, null, null, 2, "div", [["class", "bar-container"]], null, null, null, null, null)), (_l()(), elementDef(24, 0, null, null, 1, "div", [["class", "bar"]], [[4, "width", null], [4, "background-color", null]], null, null, null, null)), (_l()(), textDef(25, null, [" \u00A0", " "])), (_l()(), elementDef(26, 0, null, null, 4, "div", [["class", "info"]], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(27, 0, null, null, 1, "div", [["class", "title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["FLOP rate:"])), (_l()(), elementDef(29, 0, null, null, 1, "code", [["class", "expression"]], null, null, null, null, null)), (_l()(), textDef(30, null, ["", ""])), (_l()(), elementDef(31, 0, null, null, 4, "div", [["class", "info"]], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(32, 0, null, null, 1, "div", [["class", "title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Memory bandwidth:"])), (_l()(), elementDef(34, 0, null, null, 1, "code", [["class", "expression"]], null, null, null, null, null)), (_l()(), textDef(35, null, ["", ""])), (_l()(), elementDef(36, 0, null, null, 4, "div", [["class", "info"]], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(37, 0, null, null, 1, "div", [["class", "title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["XLA expression:"])), (_l()(), elementDef(39, 0, null, null, 1, "code", [["class", "expression"]], null, null, null, null, null)), (_l()(), textDef(40, null, ["", ""])), (_l()(), elementDef(41, 0, null, null, 4, "div", [["class", "info"]], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(42, 0, null, null, 1, "div", [["class", "title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Long Op Name:"])), (_l()(), elementDef(44, 0, null, null, 1, "code", [["class", "expression"]], null, null, null, null, null)), (_l()(), textDef(45, null, ["", ""])), (_l()(), elementDef(46, 0, null, null, 2, "div", [["class", "info"]], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(47, 0, null, null, 1, "div", [["class", "unavailable"]], null, null, null, null, null)), (_l()(), textDef(-1, null, [" Performance information for individual fused operations is not available. "])), (_l()(), elementDef(49, 0, null, null, 2, "div", [["class", "info"]], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(50, 0, null, null, 1, "div", [["class", "unavailable"]], null, null, null, null, null)), (_l()(), textDef(-1, null, [" Select items within this category for performace details. "])), (_l()(), elementDef(52, 0, null, null, 4, "div", [["class", "info"]], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(53, 0, null, null, 1, "div", [["class", "title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Layout:"])), (_l()(), anchorDef(16777216, null, null, 1, null, View_OpDetails_1)), directiveDef(56, 278528, null, 0, NgForOf, [ViewContainerRef, TemplateRef, IterableDiffers], { ngForOf: [0, "ngForOf"] }, null)], function (_ck, _v) { var _co = _v.component; var currVal_24 = _co.dimensions; _ck(_v, 56, 0, currVal_24); }, function (_ck, _v) { var _co = _v.component; var currVal_0 = !_co.node; _ck(_v, 0, 0, currVal_0); var currVal_1 = (nodeValue(_v, 2)._animationMode === "NoopAnimations"); _ck(_v, 1, 0, currVal_1); var currVal_2 = _co.color; _ck(_v, 6, 0, currVal_2); var currVal_3 = _co.name; _ck(_v, 10, 0, currVal_3); var currVal_4 = _co.subheader; _ck(_v, 12, 0, currVal_4); var currVal_5 = !_co.flopsUtilization; _ck(_v, 14, 0, currVal_5); var currVal_6 = _co.flopsUtilization; var currVal_7 = _co.flopsColor; _ck(_v, 18, 0, currVal_6, currVal_7); var currVal_8 = _co.flopsUtilization; _ck(_v, 19, 0, currVal_8); var currVal_9 = !_co.memoryBandwidthUtilization; _ck(_v, 20, 0, currVal_9); var currVal_10 = _co.memoryBandwidthUtilization; var currVal_11 = _co.bwColor; _ck(_v, 24, 0, currVal_10, currVal_11); var currVal_12 = _co.memoryBandwidthUtilization; _ck(_v, 25, 0, currVal_12); var currVal_13 = !_co.flopsRate; _ck(_v, 26, 0, currVal_13); var currVal_14 = _co.flopsRate; _ck(_v, 30, 0, currVal_14); var currVal_15 = !_co.memoryBandwidth; _ck(_v, 31, 0, currVal_15); var currVal_16 = _co.memoryBandwidth; _ck(_v, 35, 0, currVal_16); var currVal_17 = !_co.expression; _ck(_v, 36, 0, currVal_17); var currVal_18 = _co.expression; _ck(_v, 40, 0, currVal_18); var currVal_19 = !_co.provenance; _ck(_v, 41, 0, currVal_19); var currVal_20 = _co.provenance; _ck(_v, 45, 0, currVal_20); var currVal_21 = !_co.fused; _ck(_v, 46, 0, currVal_21); var currVal_22 = !_co.hasCategory; _ck(_v, 49, 0, currVal_22); var currVal_23 = !_co.hasLayout; _ck(_v, 52, 0, currVal_23); }); }
    function View_OpDetails_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "op-details", [], null, null, null, View_OpDetails_0, RenderType_OpDetails)), directiveDef(1, 180224, null, 0, OpDetails, [Store], null, null)], null, null); }
    var OpDetailsNgFactory = createComponentFactory("op-details", OpDetails, View_OpDetails_Host_0, {}, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles$L = [".horizontal-center[_ngcontent-%COMP%]{text-align:center}.full-width[_ngcontent-%COMP%]{width:100%}.full-height[_ngcontent-%COMP%]{height:100%}.auto-height[_ngcontent-%COMP%]{height:auto}.disabled[_ngcontent-%COMP%]{color:rgba(0,0,0,.26)}.hidden-content[_ngcontent-%COMP%]{height:0;overflow:hidden}.primary-content[_ngcontent-%COMP%]{color:#4a4a4a}.description[_ngcontent-%COMP%]{color:#5f6368;font-size:14px;font-style:italic}.item-container[_ngcontent-%COMP%]{padding:20px 20px 0}[_nghost-%COMP%]{display:block;margin-top:20px}mat-card[_ngcontent-%COMP%]{box-shadow:none !important;border-top:1px solid #eee;border-radius:0;padding:0}.info-header[_ngcontent-%COMP%]{padding:16px;font-size:20px;font-weight:500}.info-content[_ngcontent-%COMP%]{color:#4a4a4a;padding:16px}.info[_ngcontent-%COMP%]{margin-bottom:16px}.title[_ngcontent-%COMP%]{font-weight:500;margin-bottom:4px}.scroll-x-auto[_ngcontent-%COMP%]{overflow-x:auto}code[_ngcontent-%COMP%]{font-weight:normal}"];
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_PodViewerDetails = [styles$L];
    var RenderType_PodViewerDetails = createRendererType2({ encapsulation: 0, styles: styles_PodViewerDetails, data: {} });
    function View_PodViewerDetails_1(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 4, "div", [["class", "info"]], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 1, "div", [["class", "title"]], null, null, null, null, null)), (_l()(), textDef(2, null, ["", ": "])), (_l()(), elementDef(3, 0, null, null, 1, "div", [], null, null, null, null, null)), (_l()(), textDef(4, null, ["", ""]))], null, function (_ck, _v) { var currVal_0 = _v.context.$implicit.title; _ck(_v, 2, 0, currVal_0); var currVal_1 = _v.context.$implicit.value; _ck(_v, 4, 0, currVal_1); }); }
    function View_PodViewerDetails_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 24, "div", [], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 23, "mat-card", [["class", "mat-card"]], [[2, "_mat-animation-noopable", null]], null, null, d$6, c$6)), directiveDef(2, 49152, null, 0, MatCard, [[2, ANIMATION_MODULE_TYPE]], null, null), (_l()(), elementDef(3, 0, null, 0, 21, "mat-card-content", [["class", "mat-card-content"]], null, null, null, null, null)), directiveDef(4, 16384, null, 0, MatCardContent, [], null, null), (_l()(), elementDef(5, 0, null, null, 1, "div", [["class", "info-header"]], null, null, null, null, null)), (_l()(), textDef(6, null, ["", ""])), (_l()(), elementDef(7, 0, null, null, 17, "div", [["class", "info-content"]], null, null, null, null, null)), (_l()(), anchorDef(16777216, null, null, 1, null, View_PodViewerDetails_1)), directiveDef(9, 278528, null, 0, NgForOf, [ViewContainerRef, TemplateRef, IterableDiffers], { ngForOf: [0, "ngForOf"] }, null), (_l()(), elementDef(10, 0, null, null, 4, "div", [["class", "info scroll-x-auto"]], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(11, 0, null, null, 1, "div", [["class", "title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Hlo Names"])), (_l()(), elementDef(13, 0, null, null, 1, "code", [], null, null, null, null, null)), (_l()(), textDef(14, null, ["", ""])), (_l()(), elementDef(15, 0, null, null, 4, "div", [["class", "info scroll-x-auto"]], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(16, 0, null, null, 1, "div", [["class", "title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Replica Groups"])), (_l()(), elementDef(18, 0, null, null, 1, "code", [], null, null, null, null, null)), (_l()(), textDef(19, null, ["", ""])), (_l()(), elementDef(20, 0, null, null, 4, "div", [["class", "info scroll-x-auto"]], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(21, 0, null, null, 1, "div", [["class", "title"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Description"])), (_l()(), elementDef(23, 0, null, null, 1, "code", [], null, null, null, null, null)), (_l()(), textDef(24, null, ["", ""]))], function (_ck, _v) { var _co = _v.component; var currVal_3 = _co.details; _ck(_v, 9, 0, currVal_3); }, function (_ck, _v) { var _co = _v.component; var currVal_0 = !_co.info; _ck(_v, 0, 0, currVal_0); var currVal_1 = (nodeValue(_v, 2)._animationMode === "NoopAnimations"); _ck(_v, 1, 0, currVal_1); var currVal_2 = _co.name; _ck(_v, 6, 0, currVal_2); var currVal_4 = !_co.hloNames; _ck(_v, 10, 0, currVal_4); var currVal_5 = _co.hloNames; _ck(_v, 14, 0, currVal_5); var currVal_6 = !_co.replicaGroups; _ck(_v, 15, 0, currVal_6); var currVal_7 = _co.replicaGroups; _ck(_v, 19, 0, currVal_7); var currVal_8 = !_co.description; _ck(_v, 20, 0, currVal_8); var currVal_9 = _co.description; _ck(_v, 24, 0, currVal_9); }); }
    function View_PodViewerDetails_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "pod-viewer-details", [], null, null, null, View_PodViewerDetails_0, RenderType_PodViewerDetails)), directiveDef(1, 180224, null, 0, PodViewerDetails, [Store], null, null)], null, null); }
    var PodViewerDetailsNgFactory = createComponentFactory("pod-viewer-details", PodViewerDetails, View_PodViewerDetails_Host_0, {}, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_SideNav = [styles$I];
    var RenderType_SideNav = createRendererType2({ encapsulation: 0, styles: styles_SideNav, data: {} });
    function View_SideNav_1(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 2, "mat-option", [["class", "mat-option"], ["role", "option"]], [[1, "tabindex", 0], [2, "mat-selected", null], [2, "mat-option-multiple", null], [2, "mat-active", null], [8, "id", 0], [1, "aria-selected", 0], [1, "aria-disabled", 0], [2, "mat-option-disabled", null]], [[null, "click"], [null, "keydown"]], function (_v, en, $event) {
                var ad = true;
                if (("click" === en)) {
                    var pd_0 = (nodeValue(_v, 1)._selectViaInteraction() !== false);
                    ad = (pd_0 && ad);
                }
                if (("keydown" === en)) {
                    var pd_1 = (nodeValue(_v, 1)._handleKeydown($event) !== false);
                    ad = (pd_1 && ad);
                }
                return ad;
            }, j$1, i)), directiveDef(1, 8568832, [[10, 4]], 0, MatOption, [ElementRef, ChangeDetectorRef, [2, MAT_OPTION_PARENT_COMPONENT], [2, MatOptgroup]], { value: [0, "value"] }, null), (_l()(), textDef(2, 0, [" ", " "]))], function (_ck, _v) { var currVal_8 = _v.context.$implicit; _ck(_v, 1, 0, currVal_8); }, function (_ck, _v) { var currVal_0 = nodeValue(_v, 1)._getTabIndex(); var currVal_1 = nodeValue(_v, 1).selected; var currVal_2 = nodeValue(_v, 1).multiple; var currVal_3 = nodeValue(_v, 1).active; var currVal_4 = nodeValue(_v, 1).id; var currVal_5 = nodeValue(_v, 1)._getAriaSelected(); var currVal_6 = nodeValue(_v, 1).disabled.toString(); var currVal_7 = nodeValue(_v, 1).disabled; _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5, currVal_6, currVal_7); var currVal_9 = _v.context.$implicit; _ck(_v, 2, 0, currVal_9); });
    }
    function View_SideNav_2(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 2, "mat-option", [["class", "mat-option"], ["role", "option"]], [[1, "tabindex", 0], [2, "mat-selected", null], [2, "mat-option-multiple", null], [2, "mat-active", null], [8, "id", 0], [1, "aria-selected", 0], [1, "aria-disabled", 0], [2, "mat-option-disabled", null]], [[null, "click"], [null, "keydown"]], function (_v, en, $event) {
                var ad = true;
                if (("click" === en)) {
                    var pd_0 = (nodeValue(_v, 1)._selectViaInteraction() !== false);
                    ad = (pd_0 && ad);
                }
                if (("keydown" === en)) {
                    var pd_1 = (nodeValue(_v, 1)._handleKeydown($event) !== false);
                    ad = (pd_1 && ad);
                }
                return ad;
            }, j$1, i)), directiveDef(1, 8568832, [[22, 4]], 0, MatOption, [ElementRef, ChangeDetectorRef, [2, MAT_OPTION_PARENT_COMPONENT], [2, MatOptgroup]], { value: [0, "value"] }, null), (_l()(), textDef(2, 0, [" ", " "]))], function (_ck, _v) { var currVal_8 = _v.context.$implicit; _ck(_v, 1, 0, currVal_8); }, function (_ck, _v) { var _co = _v.component; var currVal_0 = nodeValue(_v, 1)._getTabIndex(); var currVal_1 = nodeValue(_v, 1).selected; var currVal_2 = nodeValue(_v, 1).multiple; var currVal_3 = nodeValue(_v, 1).active; var currVal_4 = nodeValue(_v, 1).id; var currVal_5 = nodeValue(_v, 1)._getAriaSelected(); var currVal_6 = nodeValue(_v, 1).disabled.toString(); var currVal_7 = nodeValue(_v, 1).disabled; _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5, currVal_6, currVal_7); var currVal_9 = _co.getDisplayTagName(_v.context.$implicit); _ck(_v, 2, 0, currVal_9); });
    }
    function View_SideNav_3(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 2, "mat-option", [["class", "mat-option"], ["role", "option"]], [[1, "tabindex", 0], [2, "mat-selected", null], [2, "mat-option-multiple", null], [2, "mat-active", null], [8, "id", 0], [1, "aria-selected", 0], [1, "aria-disabled", 0], [2, "mat-option-disabled", null]], [[null, "click"], [null, "keydown"]], function (_v, en, $event) {
                var ad = true;
                if (("click" === en)) {
                    var pd_0 = (nodeValue(_v, 1)._selectViaInteraction() !== false);
                    ad = (pd_0 && ad);
                }
                if (("keydown" === en)) {
                    var pd_1 = (nodeValue(_v, 1)._handleKeydown($event) !== false);
                    ad = (pd_1 && ad);
                }
                return ad;
            }, j$1, i)), directiveDef(1, 8568832, [[34, 4]], 0, MatOption, [ElementRef, ChangeDetectorRef, [2, MAT_OPTION_PARENT_COMPONENT], [2, MatOptgroup]], { value: [0, "value"] }, null), (_l()(), textDef(2, 0, [" ", " "]))], function (_ck, _v) { var currVal_8 = _v.context.$implicit; _ck(_v, 1, 0, currVal_8); }, function (_ck, _v) { var currVal_0 = nodeValue(_v, 1)._getTabIndex(); var currVal_1 = nodeValue(_v, 1).selected; var currVal_2 = nodeValue(_v, 1).multiple; var currVal_3 = nodeValue(_v, 1).active; var currVal_4 = nodeValue(_v, 1).id; var currVal_5 = nodeValue(_v, 1)._getAriaSelected(); var currVal_6 = nodeValue(_v, 1).disabled.toString(); var currVal_7 = nodeValue(_v, 1).disabled; _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5, currVal_6, currVal_7); var currVal_9 = _v.context.$implicit; _ck(_v, 2, 0, currVal_9); });
    }
    function View_SideNav_0(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 2, "div", [["class", "button-container horizontal-center"]], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 1, "capture-profile", [], null, null, null, View_CaptureProfile_0, RenderType_CaptureProfile)), directiveDef(2, 180224, null, 0, CaptureProfile, [MatDialog, MatSnackBar, DataService, Store], null, null), (_l()(), elementDef(3, 0, null, null, 25, "div", [["class", "item-container"]], null, null, null, null, null)), (_l()(), elementDef(4, 0, null, null, 4, "div", [], null, null, null, null, null)), providerDef(512, null, NgClassImpl, NgClassR2Impl, [IterableDiffers, KeyValueDiffers, ElementRef, Renderer2]), directiveDef(6, 278528, null, 0, NgClass, [NgClassImpl], { ngClass: [0, "ngClass"] }, null), pureObjectDef(7, { "mat-subheading-2": 0, "disabled": 1 }), (_l()(), textDef(8, null, [" Runs (", ") "])), (_l()(), elementDef(9, 0, null, null, 19, "mat-form-field", [["class", "full-width mat-form-field"]], [[2, "mat-form-field-appearance-standard", null], [2, "mat-form-field-appearance-fill", null], [2, "mat-form-field-appearance-outline", null], [2, "mat-form-field-appearance-legacy", null], [2, "mat-form-field-invalid", null], [2, "mat-form-field-can-float", null], [2, "mat-form-field-should-float", null], [2, "mat-form-field-has-label", null], [2, "mat-form-field-hide-placeholder", null], [2, "mat-form-field-disabled", null], [2, "mat-form-field-autofilled", null], [2, "mat-focused", null], [2, "mat-accent", null], [2, "mat-warn", null], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [2, "_mat-animation-noopable", null]], null, null, d$1, c$1)), directiveDef(10, 7520256, null, 9, MatFormField, [ElementRef, ChangeDetectorRef, [2, MAT_LABEL_GLOBAL_OPTIONS], [2, Directionality], [2, MAT_FORM_FIELD_DEFAULT_OPTIONS], Platform, NgZone, [2, ANIMATION_MODULE_TYPE]], null, null), queryDef(603979776, 1, { _controlNonStatic: 0 }), queryDef(335544320, 2, { _controlStatic: 0 }), queryDef(603979776, 3, { _labelChildNonStatic: 0 }), queryDef(335544320, 4, { _labelChildStatic: 0 }), queryDef(603979776, 5, { _placeholderChild: 0 }), queryDef(603979776, 6, { _errorChildren: 1 }), queryDef(603979776, 7, { _hintChildren: 1 }), queryDef(603979776, 8, { _prefixChildren: 1 }), queryDef(603979776, 9, { _suffixChildren: 1 }), (_l()(), elementDef(20, 0, null, 1, 8, "mat-select", [["class", "mat-select"], ["panelClass", "panel-override"], ["role", "listbox"]], [[1, "id", 0], [1, "tabindex", 0], [1, "aria-label", 0], [1, "aria-labelledby", 0], [1, "aria-required", 0], [1, "aria-disabled", 0], [1, "aria-invalid", 0], [1, "aria-owns", 0], [1, "aria-multiselectable", 0], [1, "aria-describedby", 0], [1, "aria-activedescendant", 0], [2, "mat-select-disabled", null], [2, "mat-select-invalid", null], [2, "mat-select-required", null], [2, "mat-select-empty", null]], [[null, "valueChange"], [null, "selectionChange"], [null, "keydown"], [null, "focus"], [null, "blur"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("keydown" === en)) {
                    var pd_0 = (nodeValue(_v, 22)._handleKeydown($event) !== false);
                    ad = (pd_0 && ad);
                }
                if (("focus" === en)) {
                    var pd_1 = (nodeValue(_v, 22)._onFocus() !== false);
                    ad = (pd_1 && ad);
                }
                if (("blur" === en)) {
                    var pd_2 = (nodeValue(_v, 22)._onBlur() !== false);
                    ad = (pd_2 && ad);
                }
                if (("valueChange" === en)) {
                    var pd_3 = ((_co.selectedRun = $event) !== false);
                    ad = (pd_3 && ad);
                }
                if (("selectionChange" === en)) {
                    var pd_4 = (_co.updateTags() !== false);
                    ad = (pd_4 && ad);
                }
                return ad;
            }, d$3, c$3)), providerDef(6144, null, MAT_OPTION_PARENT_COMPONENT, null, [MatSelect]), directiveDef(22, 2080768, null, 3, MatSelect, [ViewportRuler, ChangeDetectorRef, NgZone, ErrorStateMatcher, ElementRef, [2, Directionality], [2, NgForm], [2, FormGroupDirective], [2, MatFormField], [8, null], [8, null], MAT_SELECT_SCROLL_STRATEGY, LiveAnnouncer], { disabled: [0, "disabled"], panelClass: [1, "panelClass"], value: [2, "value"] }, { selectionChange: "selectionChange", valueChange: "valueChange" }), queryDef(603979776, 10, { options: 1 }), queryDef(603979776, 11, { optionGroups: 1 }), queryDef(603979776, 12, { customTrigger: 0 }), providerDef(2048, [[1, 4], [2, 4]], MatFormFieldControl, null, [MatSelect]), (_l()(), anchorDef(16777216, null, 1, 1, null, View_SideNav_1)), directiveDef(28, 278528, null, 0, NgForOf, [ViewContainerRef, TemplateRef, IterableDiffers], { ngForOf: [0, "ngForOf"] }, null), (_l()(), elementDef(29, 0, null, null, 25, "div", [["class", "item-container"]], null, null, null, null, null)), (_l()(), elementDef(30, 0, null, null, 4, "div", [], null, null, null, null, null)), providerDef(512, null, NgClassImpl, NgClassR2Impl, [IterableDiffers, KeyValueDiffers, ElementRef, Renderer2]), directiveDef(32, 278528, null, 0, NgClass, [NgClassImpl], { ngClass: [0, "ngClass"] }, null), pureObjectDef(33, { "mat-subheading-2": 0, "disabled": 1 }), (_l()(), textDef(34, null, [" Tools (", ") "])), (_l()(), elementDef(35, 0, null, null, 19, "mat-form-field", [["class", "full-width mat-form-field"]], [[2, "mat-form-field-appearance-standard", null], [2, "mat-form-field-appearance-fill", null], [2, "mat-form-field-appearance-outline", null], [2, "mat-form-field-appearance-legacy", null], [2, "mat-form-field-invalid", null], [2, "mat-form-field-can-float", null], [2, "mat-form-field-should-float", null], [2, "mat-form-field-has-label", null], [2, "mat-form-field-hide-placeholder", null], [2, "mat-form-field-disabled", null], [2, "mat-form-field-autofilled", null], [2, "mat-focused", null], [2, "mat-accent", null], [2, "mat-warn", null], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [2, "_mat-animation-noopable", null]], null, null, d$1, c$1)), directiveDef(36, 7520256, null, 9, MatFormField, [ElementRef, ChangeDetectorRef, [2, MAT_LABEL_GLOBAL_OPTIONS], [2, Directionality], [2, MAT_FORM_FIELD_DEFAULT_OPTIONS], Platform, NgZone, [2, ANIMATION_MODULE_TYPE]], null, null), queryDef(603979776, 13, { _controlNonStatic: 0 }), queryDef(335544320, 14, { _controlStatic: 0 }), queryDef(603979776, 15, { _labelChildNonStatic: 0 }), queryDef(335544320, 16, { _labelChildStatic: 0 }), queryDef(603979776, 17, { _placeholderChild: 0 }), queryDef(603979776, 18, { _errorChildren: 1 }), queryDef(603979776, 19, { _hintChildren: 1 }), queryDef(603979776, 20, { _prefixChildren: 1 }), queryDef(603979776, 21, { _suffixChildren: 1 }), (_l()(), elementDef(46, 0, null, 1, 8, "mat-select", [["class", "mat-select"], ["panelClass", "panel-override"], ["role", "listbox"]], [[1, "id", 0], [1, "tabindex", 0], [1, "aria-label", 0], [1, "aria-labelledby", 0], [1, "aria-required", 0], [1, "aria-disabled", 0], [1, "aria-invalid", 0], [1, "aria-owns", 0], [1, "aria-multiselectable", 0], [1, "aria-describedby", 0], [1, "aria-activedescendant", 0], [2, "mat-select-disabled", null], [2, "mat-select-invalid", null], [2, "mat-select-required", null], [2, "mat-select-empty", null]], [[null, "valueChange"], [null, "selectionChange"], [null, "keydown"], [null, "focus"], [null, "blur"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("keydown" === en)) {
                    var pd_0 = (nodeValue(_v, 48)._handleKeydown($event) !== false);
                    ad = (pd_0 && ad);
                }
                if (("focus" === en)) {
                    var pd_1 = (nodeValue(_v, 48)._onFocus() !== false);
                    ad = (pd_1 && ad);
                }
                if (("blur" === en)) {
                    var pd_2 = (nodeValue(_v, 48)._onBlur() !== false);
                    ad = (pd_2 && ad);
                }
                if (("valueChange" === en)) {
                    var pd_3 = ((_co.selectedTag = $event) !== false);
                    ad = (pd_3 && ad);
                }
                if (("selectionChange" === en)) {
                    var pd_4 = (_co.updateHosts() !== false);
                    ad = (pd_4 && ad);
                }
                return ad;
            }, d$3, c$3)), providerDef(6144, null, MAT_OPTION_PARENT_COMPONENT, null, [MatSelect]), directiveDef(48, 2080768, null, 3, MatSelect, [ViewportRuler, ChangeDetectorRef, NgZone, ErrorStateMatcher, ElementRef, [2, Directionality], [2, NgForm], [2, FormGroupDirective], [2, MatFormField], [8, null], [8, null], MAT_SELECT_SCROLL_STRATEGY, LiveAnnouncer], { disabled: [0, "disabled"], panelClass: [1, "panelClass"], value: [2, "value"] }, { selectionChange: "selectionChange", valueChange: "valueChange" }), queryDef(603979776, 22, { options: 1 }), queryDef(603979776, 23, { optionGroups: 1 }), queryDef(603979776, 24, { customTrigger: 0 }), providerDef(2048, [[13, 4], [14, 4]], MatFormFieldControl, null, [MatSelect]), (_l()(), anchorDef(16777216, null, 1, 1, null, View_SideNav_2)), directiveDef(54, 278528, null, 0, NgForOf, [ViewContainerRef, TemplateRef, IterableDiffers], { ngForOf: [0, "ngForOf"] }, null), (_l()(), elementDef(55, 0, null, null, 25, "div", [["class", "item-container"]], null, null, null, null, null)), (_l()(), elementDef(56, 0, null, null, 4, "div", [], null, null, null, null, null)), providerDef(512, null, NgClassImpl, NgClassR2Impl, [IterableDiffers, KeyValueDiffers, ElementRef, Renderer2]), directiveDef(58, 278528, null, 0, NgClass, [NgClassImpl], { ngClass: [0, "ngClass"] }, null), pureObjectDef(59, { "mat-subheading-2": 0, "disabled": 1 }), (_l()(), textDef(-1, null, [" Hosts "])), (_l()(), elementDef(61, 0, null, null, 19, "mat-form-field", [["class", "full-width mat-form-field"]], [[2, "mat-form-field-appearance-standard", null], [2, "mat-form-field-appearance-fill", null], [2, "mat-form-field-appearance-outline", null], [2, "mat-form-field-appearance-legacy", null], [2, "mat-form-field-invalid", null], [2, "mat-form-field-can-float", null], [2, "mat-form-field-should-float", null], [2, "mat-form-field-has-label", null], [2, "mat-form-field-hide-placeholder", null], [2, "mat-form-field-disabled", null], [2, "mat-form-field-autofilled", null], [2, "mat-focused", null], [2, "mat-accent", null], [2, "mat-warn", null], [2, "ng-untouched", null], [2, "ng-touched", null], [2, "ng-pristine", null], [2, "ng-dirty", null], [2, "ng-valid", null], [2, "ng-invalid", null], [2, "ng-pending", null], [2, "_mat-animation-noopable", null]], null, null, d$1, c$1)), directiveDef(62, 7520256, null, 9, MatFormField, [ElementRef, ChangeDetectorRef, [2, MAT_LABEL_GLOBAL_OPTIONS], [2, Directionality], [2, MAT_FORM_FIELD_DEFAULT_OPTIONS], Platform, NgZone, [2, ANIMATION_MODULE_TYPE]], null, null), queryDef(603979776, 25, { _controlNonStatic: 0 }), queryDef(335544320, 26, { _controlStatic: 0 }), queryDef(603979776, 27, { _labelChildNonStatic: 0 }), queryDef(335544320, 28, { _labelChildStatic: 0 }), queryDef(603979776, 29, { _placeholderChild: 0 }), queryDef(603979776, 30, { _errorChildren: 1 }), queryDef(603979776, 31, { _hintChildren: 1 }), queryDef(603979776, 32, { _prefixChildren: 1 }), queryDef(603979776, 33, { _suffixChildren: 1 }), (_l()(), elementDef(72, 0, null, 1, 8, "mat-select", [["class", "mat-select"], ["panelClass", "panel-override"], ["role", "listbox"]], [[1, "id", 0], [1, "tabindex", 0], [1, "aria-label", 0], [1, "aria-labelledby", 0], [1, "aria-required", 0], [1, "aria-disabled", 0], [1, "aria-invalid", 0], [1, "aria-owns", 0], [1, "aria-multiselectable", 0], [1, "aria-describedby", 0], [1, "aria-activedescendant", 0], [2, "mat-select-disabled", null], [2, "mat-select-invalid", null], [2, "mat-select-required", null], [2, "mat-select-empty", null]], [[null, "valueChange"], [null, "selectionChange"], [null, "keydown"], [null, "focus"], [null, "blur"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("keydown" === en)) {
                    var pd_0 = (nodeValue(_v, 74)._handleKeydown($event) !== false);
                    ad = (pd_0 && ad);
                }
                if (("focus" === en)) {
                    var pd_1 = (nodeValue(_v, 74)._onFocus() !== false);
                    ad = (pd_1 && ad);
                }
                if (("blur" === en)) {
                    var pd_2 = (nodeValue(_v, 74)._onBlur() !== false);
                    ad = (pd_2 && ad);
                }
                if (("valueChange" === en)) {
                    var pd_3 = ((_co.selectedHost = $event) !== false);
                    ad = (pd_3 && ad);
                }
                if (("selectionChange" === en)) {
                    var pd_4 = (_co.emitUpdateEvent() !== false);
                    ad = (pd_4 && ad);
                }
                return ad;
            }, d$3, c$3)), providerDef(6144, null, MAT_OPTION_PARENT_COMPONENT, null, [MatSelect]), directiveDef(74, 2080768, null, 3, MatSelect, [ViewportRuler, ChangeDetectorRef, NgZone, ErrorStateMatcher, ElementRef, [2, Directionality], [2, NgForm], [2, FormGroupDirective], [2, MatFormField], [8, null], [8, null], MAT_SELECT_SCROLL_STRATEGY, LiveAnnouncer], { disabled: [0, "disabled"], panelClass: [1, "panelClass"], value: [2, "value"] }, { selectionChange: "selectionChange", valueChange: "valueChange" }), queryDef(603979776, 34, { options: 1 }), queryDef(603979776, 35, { optionGroups: 1 }), queryDef(603979776, 36, { customTrigger: 0 }), providerDef(2048, [[25, 4], [26, 4]], MatFormFieldControl, null, [MatSelect]), (_l()(), anchorDef(16777216, null, 1, 1, null, View_SideNav_3)), directiveDef(80, 278528, null, 0, NgForOf, [ViewContainerRef, TemplateRef, IterableDiffers], { ngForOf: [0, "ngForOf"] }, null), (_l()(), elementDef(81, 0, null, null, 2, "div", [], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(82, 0, null, null, 1, "buffer-details", [], null, null, null, View_BufferDetails_0, RenderType_BufferDetails)), directiveDef(83, 180224, null, 0, BufferDetails, [Store], null, null), (_l()(), elementDef(84, 0, null, null, 2, "div", [], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(85, 0, null, null, 1, "op-details", [], null, null, null, View_OpDetails_0, RenderType_OpDetails)), directiveDef(86, 180224, null, 0, OpDetails, [Store], null, null), (_l()(), elementDef(87, 0, null, null, 2, "div", [], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(88, 0, null, null, 1, "pod-viewer-details", [], null, null, null, View_PodViewerDetails_0, RenderType_PodViewerDetails)), directiveDef(89, 180224, null, 0, PodViewerDetails, [Store], null, null), (_l()(), elementDef(90, 0, null, null, 0, "br", [], null, null, null, null, null))], function (_ck, _v) { var _co = _v.component; var currVal_0 = _ck(_v, 7, 0, true, !_co.runs.length); _ck(_v, 6, 0, currVal_0); var currVal_39 = !_co.runs.length; var currVal_40 = "panel-override"; var currVal_41 = _co.selectedRun; _ck(_v, 22, 0, currVal_39, currVal_40, currVal_41); var currVal_42 = _co.runs; _ck(_v, 28, 0, currVal_42); var currVal_43 = _ck(_v, 33, 0, true, !_co.tags.length); _ck(_v, 32, 0, currVal_43); var currVal_82 = !_co.tags.length; var currVal_83 = "panel-override"; var currVal_84 = _co.selectedTag; _ck(_v, 48, 0, currVal_82, currVal_83, currVal_84); var currVal_85 = _co.tags; _ck(_v, 54, 0, currVal_85); var currVal_86 = _ck(_v, 59, 0, true, !_co.hosts.length); _ck(_v, 58, 0, currVal_86); var currVal_124 = !_co.hosts.length; var currVal_125 = "panel-override"; var currVal_126 = _co.selectedHost; _ck(_v, 74, 0, currVal_124, currVal_125, currVal_126); var currVal_127 = _co.hosts; _ck(_v, 80, 0, currVal_127); }, function (_ck, _v) { var _co = _v.component; var currVal_1 = _co.runs.length; _ck(_v, 8, 0, currVal_1); var currVal_2 = (nodeValue(_v, 10).appearance == "standard"); var currVal_3 = (nodeValue(_v, 10).appearance == "fill"); var currVal_4 = (nodeValue(_v, 10).appearance == "outline"); var currVal_5 = (nodeValue(_v, 10).appearance == "legacy"); var currVal_6 = nodeValue(_v, 10)._control.errorState; var currVal_7 = nodeValue(_v, 10)._canLabelFloat; var currVal_8 = nodeValue(_v, 10)._shouldLabelFloat(); var currVal_9 = nodeValue(_v, 10)._hasFloatingLabel(); var currVal_10 = nodeValue(_v, 10)._hideControlPlaceholder(); var currVal_11 = nodeValue(_v, 10)._control.disabled; var currVal_12 = nodeValue(_v, 10)._control.autofilled; var currVal_13 = nodeValue(_v, 10)._control.focused; var currVal_14 = (nodeValue(_v, 10).color == "accent"); var currVal_15 = (nodeValue(_v, 10).color == "warn"); var currVal_16 = nodeValue(_v, 10)._shouldForward("untouched"); var currVal_17 = nodeValue(_v, 10)._shouldForward("touched"); var currVal_18 = nodeValue(_v, 10)._shouldForward("pristine"); var currVal_19 = nodeValue(_v, 10)._shouldForward("dirty"); var currVal_20 = nodeValue(_v, 10)._shouldForward("valid"); var currVal_21 = nodeValue(_v, 10)._shouldForward("invalid"); var currVal_22 = nodeValue(_v, 10)._shouldForward("pending"); var currVal_23 = !nodeValue(_v, 10)._animationsEnabled; _ck(_v, 9, 1, [currVal_2, currVal_3, currVal_4, currVal_5, currVal_6, currVal_7, currVal_8, currVal_9, currVal_10, currVal_11, currVal_12, currVal_13, currVal_14, currVal_15, currVal_16, currVal_17, currVal_18, currVal_19, currVal_20, currVal_21, currVal_22, currVal_23]); var currVal_24 = nodeValue(_v, 22).id; var currVal_25 = nodeValue(_v, 22).tabIndex; var currVal_26 = nodeValue(_v, 22)._getAriaLabel(); var currVal_27 = nodeValue(_v, 22)._getAriaLabelledby(); var currVal_28 = nodeValue(_v, 22).required.toString(); var currVal_29 = nodeValue(_v, 22).disabled.toString(); var currVal_30 = nodeValue(_v, 22).errorState; var currVal_31 = (nodeValue(_v, 22).panelOpen ? nodeValue(_v, 22)._optionIds : null); var currVal_32 = nodeValue(_v, 22).multiple; var currVal_33 = (nodeValue(_v, 22)._ariaDescribedby || null); var currVal_34 = nodeValue(_v, 22)._getAriaActiveDescendant(); var currVal_35 = nodeValue(_v, 22).disabled; var currVal_36 = nodeValue(_v, 22).errorState; var currVal_37 = nodeValue(_v, 22).required; var currVal_38 = nodeValue(_v, 22).empty; _ck(_v, 20, 1, [currVal_24, currVal_25, currVal_26, currVal_27, currVal_28, currVal_29, currVal_30, currVal_31, currVal_32, currVal_33, currVal_34, currVal_35, currVal_36, currVal_37, currVal_38]); var currVal_44 = _co.tags.length; _ck(_v, 34, 0, currVal_44); var currVal_45 = (nodeValue(_v, 36).appearance == "standard"); var currVal_46 = (nodeValue(_v, 36).appearance == "fill"); var currVal_47 = (nodeValue(_v, 36).appearance == "outline"); var currVal_48 = (nodeValue(_v, 36).appearance == "legacy"); var currVal_49 = nodeValue(_v, 36)._control.errorState; var currVal_50 = nodeValue(_v, 36)._canLabelFloat; var currVal_51 = nodeValue(_v, 36)._shouldLabelFloat(); var currVal_52 = nodeValue(_v, 36)._hasFloatingLabel(); var currVal_53 = nodeValue(_v, 36)._hideControlPlaceholder(); var currVal_54 = nodeValue(_v, 36)._control.disabled; var currVal_55 = nodeValue(_v, 36)._control.autofilled; var currVal_56 = nodeValue(_v, 36)._control.focused; var currVal_57 = (nodeValue(_v, 36).color == "accent"); var currVal_58 = (nodeValue(_v, 36).color == "warn"); var currVal_59 = nodeValue(_v, 36)._shouldForward("untouched"); var currVal_60 = nodeValue(_v, 36)._shouldForward("touched"); var currVal_61 = nodeValue(_v, 36)._shouldForward("pristine"); var currVal_62 = nodeValue(_v, 36)._shouldForward("dirty"); var currVal_63 = nodeValue(_v, 36)._shouldForward("valid"); var currVal_64 = nodeValue(_v, 36)._shouldForward("invalid"); var currVal_65 = nodeValue(_v, 36)._shouldForward("pending"); var currVal_66 = !nodeValue(_v, 36)._animationsEnabled; _ck(_v, 35, 1, [currVal_45, currVal_46, currVal_47, currVal_48, currVal_49, currVal_50, currVal_51, currVal_52, currVal_53, currVal_54, currVal_55, currVal_56, currVal_57, currVal_58, currVal_59, currVal_60, currVal_61, currVal_62, currVal_63, currVal_64, currVal_65, currVal_66]); var currVal_67 = nodeValue(_v, 48).id; var currVal_68 = nodeValue(_v, 48).tabIndex; var currVal_69 = nodeValue(_v, 48)._getAriaLabel(); var currVal_70 = nodeValue(_v, 48)._getAriaLabelledby(); var currVal_71 = nodeValue(_v, 48).required.toString(); var currVal_72 = nodeValue(_v, 48).disabled.toString(); var currVal_73 = nodeValue(_v, 48).errorState; var currVal_74 = (nodeValue(_v, 48).panelOpen ? nodeValue(_v, 48)._optionIds : null); var currVal_75 = nodeValue(_v, 48).multiple; var currVal_76 = (nodeValue(_v, 48)._ariaDescribedby || null); var currVal_77 = nodeValue(_v, 48)._getAriaActiveDescendant(); var currVal_78 = nodeValue(_v, 48).disabled; var currVal_79 = nodeValue(_v, 48).errorState; var currVal_80 = nodeValue(_v, 48).required; var currVal_81 = nodeValue(_v, 48).empty; _ck(_v, 46, 1, [currVal_67, currVal_68, currVal_69, currVal_70, currVal_71, currVal_72, currVal_73, currVal_74, currVal_75, currVal_76, currVal_77, currVal_78, currVal_79, currVal_80, currVal_81]); var currVal_87 = (nodeValue(_v, 62).appearance == "standard"); var currVal_88 = (nodeValue(_v, 62).appearance == "fill"); var currVal_89 = (nodeValue(_v, 62).appearance == "outline"); var currVal_90 = (nodeValue(_v, 62).appearance == "legacy"); var currVal_91 = nodeValue(_v, 62)._control.errorState; var currVal_92 = nodeValue(_v, 62)._canLabelFloat; var currVal_93 = nodeValue(_v, 62)._shouldLabelFloat(); var currVal_94 = nodeValue(_v, 62)._hasFloatingLabel(); var currVal_95 = nodeValue(_v, 62)._hideControlPlaceholder(); var currVal_96 = nodeValue(_v, 62)._control.disabled; var currVal_97 = nodeValue(_v, 62)._control.autofilled; var currVal_98 = nodeValue(_v, 62)._control.focused; var currVal_99 = (nodeValue(_v, 62).color == "accent"); var currVal_100 = (nodeValue(_v, 62).color == "warn"); var currVal_101 = nodeValue(_v, 62)._shouldForward("untouched"); var currVal_102 = nodeValue(_v, 62)._shouldForward("touched"); var currVal_103 = nodeValue(_v, 62)._shouldForward("pristine"); var currVal_104 = nodeValue(_v, 62)._shouldForward("dirty"); var currVal_105 = nodeValue(_v, 62)._shouldForward("valid"); var currVal_106 = nodeValue(_v, 62)._shouldForward("invalid"); var currVal_107 = nodeValue(_v, 62)._shouldForward("pending"); var currVal_108 = !nodeValue(_v, 62)._animationsEnabled; _ck(_v, 61, 1, [currVal_87, currVal_88, currVal_89, currVal_90, currVal_91, currVal_92, currVal_93, currVal_94, currVal_95, currVal_96, currVal_97, currVal_98, currVal_99, currVal_100, currVal_101, currVal_102, currVal_103, currVal_104, currVal_105, currVal_106, currVal_107, currVal_108]); var currVal_109 = nodeValue(_v, 74).id; var currVal_110 = nodeValue(_v, 74).tabIndex; var currVal_111 = nodeValue(_v, 74)._getAriaLabel(); var currVal_112 = nodeValue(_v, 74)._getAriaLabelledby(); var currVal_113 = nodeValue(_v, 74).required.toString(); var currVal_114 = nodeValue(_v, 74).disabled.toString(); var currVal_115 = nodeValue(_v, 74).errorState; var currVal_116 = (nodeValue(_v, 74).panelOpen ? nodeValue(_v, 74)._optionIds : null); var currVal_117 = nodeValue(_v, 74).multiple; var currVal_118 = (nodeValue(_v, 74)._ariaDescribedby || null); var currVal_119 = nodeValue(_v, 74)._getAriaActiveDescendant(); var currVal_120 = nodeValue(_v, 74).disabled; var currVal_121 = nodeValue(_v, 74).errorState; var currVal_122 = nodeValue(_v, 74).required; var currVal_123 = nodeValue(_v, 74).empty; _ck(_v, 72, 1, [currVal_109, currVal_110, currVal_111, currVal_112, currVal_113, currVal_114, currVal_115, currVal_116, currVal_117, currVal_118, currVal_119, currVal_120, currVal_121, currVal_122, currVal_123]); var currVal_128 = (_co.selectedTag != "memory_viewer"); _ck(_v, 81, 0, currVal_128); var currVal_129 = (_co.selectedTag != "op_profile"); _ck(_v, 84, 0, currVal_129); var currVal_130 = !_co.selectedTag.startsWith("pod_viewer"); _ck(_v, 87, 0, currVal_130); });
    }
    function View_SideNav_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "sidenav", [], null, null, null, View_SideNav_0, RenderType_SideNav)), directiveDef(1, 180224, null, 0, SideNav, [DataService, Store], null, null)], null, null); }
    var SideNavNgFactory = createComponentFactory("sidenav", SideNav, View_SideNav_Host_0, { datasets: "datasets" }, { update: "update" }, []);
    var MatProgressBarModuleNgFactory = createNgModuleFactory(MatProgressBarModule, [], function (_l) {
        return moduleDef([
            moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [
                [
                    8,
                    []
                ],
                [
                    3,
                    ComponentFactoryResolver
                ],
                NgModuleRef
            ]),
            moduleProvideDef(4608, NgLocalization, NgLocaleLocalization, [
                LOCALE_ID$1,
                [
                    2,
                    DEPRECATED_PLURAL_FN
                ]
            ]),
            moduleProvideDef(1073742336, CommonModule, CommonModule, []),
            moduleProvideDef(1073742336, BidiModule, BidiModule, []),
            moduleProvideDef(1073742336, MatCommonModule, MatCommonModule, [
                [
                    2,
                    MATERIAL_SANITY_CHECKS
                ],
                [
                    2,
                    HAMMER_LOADER
                ]
            ]),
            moduleProvideDef(1073742336, MatProgressBarModule, MatProgressBarModule, [])
        ]);
    });
    var styles_MatProgressBar = [".mat-progress-bar{display:block;height:4px;overflow:hidden;position:relative;transition:opacity 250ms linear;width:100%}._mat-animation-noopable.mat-progress-bar{transition:none;animation:none}.mat-progress-bar .mat-progress-bar-element,.mat-progress-bar .mat-progress-bar-fill::after{height:100%;position:absolute;width:100%}.mat-progress-bar .mat-progress-bar-background{width:calc(100% + 10px)}@media (-ms-high-contrast:active){.mat-progress-bar .mat-progress-bar-background{display:none}}.mat-progress-bar .mat-progress-bar-buffer{transform-origin:top left;transition:transform 250ms ease}@media (-ms-high-contrast:active){.mat-progress-bar .mat-progress-bar-buffer{border-top:solid 5px;opacity:.5}}.mat-progress-bar .mat-progress-bar-secondary{display:none}.mat-progress-bar .mat-progress-bar-fill{animation:none;transform-origin:top left;transition:transform 250ms ease}@media (-ms-high-contrast:active){.mat-progress-bar .mat-progress-bar-fill{border-top:solid 4px}}.mat-progress-bar .mat-progress-bar-fill::after{animation:none;content:'';display:inline-block;left:0}.mat-progress-bar[dir=rtl],[dir=rtl] .mat-progress-bar{transform:rotateY(180deg)}.mat-progress-bar[mode=query]{transform:rotateZ(180deg)}.mat-progress-bar[mode=query][dir=rtl],[dir=rtl] .mat-progress-bar[mode=query]{transform:rotateZ(180deg) rotateY(180deg)}.mat-progress-bar[mode=indeterminate] .mat-progress-bar-fill,.mat-progress-bar[mode=query] .mat-progress-bar-fill{transition:none}.mat-progress-bar[mode=indeterminate] .mat-progress-bar-primary,.mat-progress-bar[mode=query] .mat-progress-bar-primary{-webkit-backface-visibility:hidden;backface-visibility:hidden;animation:mat-progress-bar-primary-indeterminate-translate 2s infinite linear;left:-145.166611%}.mat-progress-bar[mode=indeterminate] .mat-progress-bar-primary.mat-progress-bar-fill::after,.mat-progress-bar[mode=query] .mat-progress-bar-primary.mat-progress-bar-fill::after{-webkit-backface-visibility:hidden;backface-visibility:hidden;animation:mat-progress-bar-primary-indeterminate-scale 2s infinite linear}.mat-progress-bar[mode=indeterminate] .mat-progress-bar-secondary,.mat-progress-bar[mode=query] .mat-progress-bar-secondary{-webkit-backface-visibility:hidden;backface-visibility:hidden;animation:mat-progress-bar-secondary-indeterminate-translate 2s infinite linear;left:-54.888891%;display:block}.mat-progress-bar[mode=indeterminate] .mat-progress-bar-secondary.mat-progress-bar-fill::after,.mat-progress-bar[mode=query] .mat-progress-bar-secondary.mat-progress-bar-fill::after{-webkit-backface-visibility:hidden;backface-visibility:hidden;animation:mat-progress-bar-secondary-indeterminate-scale 2s infinite linear}.mat-progress-bar[mode=buffer] .mat-progress-bar-background{-webkit-backface-visibility:hidden;backface-visibility:hidden;animation:mat-progress-bar-background-scroll 250ms infinite linear;display:block}.mat-progress-bar._mat-animation-noopable .mat-progress-bar-background,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-buffer,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-fill,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-fill::after,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-primary,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-primary.mat-progress-bar-fill::after,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-secondary,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-secondary.mat-progress-bar-fill::after{animation:none;transition:none}@keyframes mat-progress-bar-primary-indeterminate-translate{0%{transform:translateX(0)}20%{animation-timing-function:cubic-bezier(.5,0,.70173,.49582);transform:translateX(0)}59.15%{animation-timing-function:cubic-bezier(.30244,.38135,.55,.95635);transform:translateX(83.67142%)}100%{transform:translateX(200.61106%)}}@keyframes mat-progress-bar-primary-indeterminate-scale{0%{transform:scaleX(.08)}36.65%{animation-timing-function:cubic-bezier(.33473,.12482,.78584,1);transform:scaleX(.08)}69.15%{animation-timing-function:cubic-bezier(.06,.11,.6,1);transform:scaleX(.66148)}100%{transform:scaleX(.08)}}@keyframes mat-progress-bar-secondary-indeterminate-translate{0%{animation-timing-function:cubic-bezier(.15,0,.51506,.40969);transform:translateX(0)}25%{animation-timing-function:cubic-bezier(.31033,.28406,.8,.73371);transform:translateX(37.65191%)}48.35%{animation-timing-function:cubic-bezier(.4,.62704,.6,.90203);transform:translateX(84.38617%)}100%{transform:translateX(160.27778%)}}@keyframes mat-progress-bar-secondary-indeterminate-scale{0%{animation-timing-function:cubic-bezier(.15,0,.51506,.40969);transform:scaleX(.08)}19.15%{animation-timing-function:cubic-bezier(.31033,.28406,.8,.73371);transform:scaleX(.4571)}44.15%{animation-timing-function:cubic-bezier(.4,.62704,.6,.90203);transform:scaleX(.72796)}100%{transform:scaleX(.08)}}@keyframes mat-progress-bar-background-scroll{to{transform:translateX(-8px)}}"];
    var RenderType_MatProgressBar = createRendererType2({
        encapsulation: 2,
        styles: styles_MatProgressBar,
        data: {}
    });
    function View_MatProgressBar_0(_l) {
        return viewDef(2, [
            queryDef(671088640, 1, { _primaryValueBar: 0 }),
            (_l()(), elementDef(1, 0, null, null, 4, ':svg:svg', [
                [
                    'class',
                    'mat-progress-bar-background mat-progress-bar-element'
                ],
                [
                    'focusable',
                    'false'
                ],
                [
                    'height',
                    '4'
                ],
                [
                    'width',
                    '100%'
                ]
            ], null, null, null, null, null)),
            (_l()(), elementDef(2, 0, null, null, 2, ':svg:defs', [], null, null, null, null, null)),
            (_l()(), elementDef(3, 0, null, null, 1, ':svg:pattern', [
                [
                    'height',
                    '4'
                ],
                [
                    'patternUnits',
                    'userSpaceOnUse'
                ],
                [
                    'width',
                    '8'
                ],
                [
                    'x',
                    '4'
                ],
                [
                    'y',
                    '0'
                ]
            ], [[
                    8,
                    'id',
                    0
                ]], null, null, null, null)),
            (_l()(), elementDef(4, 0, null, null, 0, ':svg:circle', [
                [
                    'cx',
                    '2'
                ],
                [
                    'cy',
                    '2'
                ],
                [
                    'r',
                    '2'
                ]
            ], null, null, null, null, null)),
            (_l()(), elementDef(5, 0, null, null, 0, ':svg:rect', [
                [
                    'height',
                    '100%'
                ],
                [
                    'width',
                    '100%'
                ]
            ], [[
                    1,
                    'fill',
                    0
                ]], null, null, null, null)),
            (_l()(), elementDef(6, 0, null, null, 2, 'div', [[
                    'class',
                    'mat-progress-bar-buffer mat-progress-bar-element'
                ]], null, null, null, null, null)),
            providerDef(512, null, NgStyleImpl, NgStyleR2Impl, [
                ElementRef,
                KeyValueDiffers,
                Renderer2
            ]),
            directiveDef(8, 278528, null, 0, NgStyle, [NgStyleImpl], {
                ngStyle: [
                    0,
                    'ngStyle'
                ]
            }, null),
            (_l()(), elementDef(9, 0, [
                [
                    1,
                    0
                ],
                [
                    'primaryValueBar',
                    1
                ]
            ], null, 2, 'div', [[
                    'class',
                    'mat-progress-bar-primary mat-progress-bar-fill mat-progress-bar-element'
                ]], null, null, null, null, null)),
            providerDef(512, null, NgStyleImpl, NgStyleR2Impl, [
                ElementRef,
                KeyValueDiffers,
                Renderer2
            ]),
            directiveDef(11, 278528, null, 0, NgStyle, [NgStyleImpl], {
                ngStyle: [
                    0,
                    'ngStyle'
                ]
            }, null),
            (_l()(), elementDef(12, 0, null, null, 0, 'div', [[
                    'class',
                    'mat-progress-bar-secondary mat-progress-bar-fill mat-progress-bar-element'
                ]], null, null, null, null, null))
        ], function (_ck, _v) {
            var _co = _v.component;
            var currVal_2 = _co._bufferTransform();
            _ck(_v, 8, 0, currVal_2);
            var currVal_3 = _co._primaryTransform();
            _ck(_v, 11, 0, currVal_3);
        }, function (_ck, _v) {
            var _co = _v.component;
            var currVal_0 = _co.progressbarId;
            _ck(_v, 3, 0, currVal_0);
            var currVal_1 = _co._rectangleFillValue;
            _ck(_v, 5, 0, currVal_1);
        });
    }
    function View_MatProgressBar_Host_0(_l) {
        return viewDef(0, [
            (_l()(), elementDef(0, 0, null, null, 1, 'mat-progress-bar', [
                [
                    'aria-valuemax',
                    '100'
                ],
                [
                    'aria-valuemin',
                    '0'
                ],
                [
                    'class',
                    'mat-progress-bar'
                ],
                [
                    'role',
                    'progressbar'
                ]
            ], [
                [
                    1,
                    'aria-valuenow',
                    0
                ],
                [
                    1,
                    'mode',
                    0
                ],
                [
                    2,
                    '_mat-animation-noopable',
                    null
                ]
            ], null, null, View_MatProgressBar_0, RenderType_MatProgressBar)),
            directiveDef(1, 4374528, null, 0, MatProgressBar, [
                ElementRef,
                NgZone,
                [
                    2,
                    ANIMATION_MODULE_TYPE
                ],
                [
                    2,
                    MAT_PROGRESS_BAR_LOCATION
                ]
            ], null, null)
        ], null, function (_ck, _v) {
            var currVal_0 = nodeValue(_v, 1).mode === 'indeterminate' || nodeValue(_v, 1).mode === 'query' ? null : nodeValue(_v, 1).value;
            var currVal_1 = nodeValue(_v, 1).mode;
            var currVal_2 = nodeValue(_v, 1)._isNoopAnimation;
            _ck(_v, 0, 0, currVal_0, currVal_1, currVal_2);
        });
    }
    var MatProgressBarNgFactory = createComponentFactory('mat-progress-bar', MatProgressBar, View_MatProgressBar_Host_0, {
        color: 'color',
        value: 'value',
        bufferValue: 'bufferValue',
        mode: 'mode'
    }, { animationEnd: 'animationEnd' }, []);
    var c$9 = RenderType_MatProgressBar;
    var d$c = View_MatProgressBar_0;
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_MainPage = [styles$H];
    var RenderType_MainPage = createRendererType2({ encapsulation: 0, styles: styles_MainPage, data: {} });
    function View_MainPage_0(_l) {
        return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 17, "mat-sidenav-container", [["class", "mat-drawer-container mat-sidenav-container"], ["fullscreen", ""]], [[2, "mat-drawer-container-explicit-backdrop", null]], null, null, x, w)), directiveDef(1, 1490944, null, 2, MatSidenavContainer, [[2, Directionality], ElementRef, NgZone, ChangeDetectorRef, ViewportRuler, MAT_DRAWER_DEFAULT_AUTOSIZE, [2, ANIMATION_MODULE_TYPE]], null, null), queryDef(603979776, 1, { _drawers: 1 }), queryDef(603979776, 2, { _content: 0 }), (_l()(), elementDef(4, 0, null, 0, 3, "mat-sidenav", [["class", "mat-drawer mat-sidenav"], ["mode", "side"], ["opened", ""], ["tabIndex", "-1"]], [[1, "align", 0], [2, "mat-drawer-end", null], [2, "mat-drawer-over", null], [2, "mat-drawer-push", null], [2, "mat-drawer-side", null], [2, "mat-drawer-opened", null], [2, "mat-sidenav-fixed", null], [4, "top", "px"], [4, "bottom", "px"], [40, "@transform", 0]], [["component", "@transform.start"], ["component", "@transform.done"]], function (_v, en, $event) {
                var ad = true;
                if (("component:@transform.start" === en)) {
                    var pd_0 = (nodeValue(_v, 5)._animationStartListener($event) !== false);
                    ad = (pd_0 && ad);
                }
                if (("component:@transform.done" === en)) {
                    var pd_1 = (nodeValue(_v, 5)._animationDoneListener($event) !== false);
                    ad = (pd_1 && ad);
                }
                return ad;
            }, t, s)), directiveDef(5, 3325952, [[1, 4]], 0, MatSidenav, [ElementRef, FocusTrapFactory, FocusMonitor, Platform, NgZone, [2, DOCUMENT]], { mode: [0, "mode"], opened: [1, "opened"] }, null), (_l()(), elementDef(6, 0, null, 0, 1, "sidenav", [], null, [[null, "update"]], function (_v, en, $event) {
                var ad = true;
                var _co = _v.component;
                if (("update" === en)) {
                    var pd_0 = (_co.updateTool($event) !== false);
                    ad = (pd_0 && ad);
                }
                return ad;
            }, View_SideNav_0, RenderType_SideNav)), directiveDef(7, 180224, null, 0, SideNav, [DataService, Store], { datasets: [0, "datasets"] }, { update: "update" }), (_l()(), elementDef(8, 0, null, 1, 9, "mat-sidenav-content", [["class", "mat-drawer-content mat-sidenav-content"]], [[4, "margin-left", "px"], [4, "margin-right", "px"]], null, null, p, o)), directiveDef(9, 1294336, [[2, 4]], 0, MatSidenavContent, [ChangeDetectorRef, MatSidenavContainer, ElementRef, ScrollDispatcher, NgZone], null, null), (_l()(), elementDef(10, 0, null, 0, 4, "div", [["class", "progress-container"]], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(11, 0, null, null, 1, "div", [["class", "loading-message"]], null, null, null, null, null)), (_l()(), textDef(12, null, ["", ""])), (_l()(), elementDef(13, 0, null, null, 1, "mat-progress-bar", [["aria-valuemax", "100"], ["aria-valuemin", "0"], ["class", "mat-progress-bar"], ["color", "primary"], ["mode", "indeterminate"], ["role", "progressbar"]], [[1, "aria-valuenow", 0], [1, "mode", 0], [2, "_mat-animation-noopable", null]], null, null, d$c, c$9)), directiveDef(14, 4374528, null, 0, MatProgressBar, [ElementRef, NgZone, [2, ANIMATION_MODULE_TYPE], [2, MAT_PROGRESS_BAR_LOCATION]], { color: [0, "color"], mode: [1, "mode"] }, null), (_l()(), elementDef(15, 0, null, 0, 2, "div", [], [[8, "className", 0]], null, null, null, null)), (_l()(), elementDef(16, 16777216, null, null, 1, "router-outlet", [], null, null, null, null, null)), directiveDef(17, 212992, null, 0, RouterOutlet, [ChildrenOutletContexts, ViewContainerRef, ComponentFactoryResolver, [8, null], ChangeDetectorRef], null, null)], function (_ck, _v) { var _co = _v.component; _ck(_v, 1, 0); var currVal_11 = "side"; var currVal_12 = ""; _ck(_v, 5, 0, currVal_11, currVal_12); var currVal_13 = _co.datasets; _ck(_v, 7, 0, currVal_13); _ck(_v, 9, 0); var currVal_21 = "primary"; var currVal_22 = "indeterminate"; _ck(_v, 14, 0, currVal_21, currVal_22); _ck(_v, 17, 0); }, function (_ck, _v) { var _co = _v.component; var currVal_0 = nodeValue(_v, 1)._backdropOverride; _ck(_v, 0, 0, currVal_0); var currVal_1 = null; var currVal_2 = (nodeValue(_v, 5).position === "end"); var currVal_3 = (nodeValue(_v, 5).mode === "over"); var currVal_4 = (nodeValue(_v, 5).mode === "push"); var currVal_5 = (nodeValue(_v, 5).mode === "side"); var currVal_6 = nodeValue(_v, 5).opened; var currVal_7 = nodeValue(_v, 5).fixedInViewport; var currVal_8 = (nodeValue(_v, 5).fixedInViewport ? nodeValue(_v, 5).fixedTopGap : null); var currVal_9 = (nodeValue(_v, 5).fixedInViewport ? nodeValue(_v, 5).fixedBottomGap : null); var currVal_10 = nodeValue(_v, 5)._animationState; _ck(_v, 4, 0, currVal_1, currVal_2, currVal_3, currVal_4, currVal_5, currVal_6, currVal_7, currVal_8, currVal_9, currVal_10); var currVal_14 = nodeValue(_v, 9)._container._contentMargins.left; var currVal_15 = nodeValue(_v, 9)._container._contentMargins.right; _ck(_v, 8, 0, currVal_14, currVal_15); var currVal_16 = !_co.loading; _ck(_v, 10, 0, currVal_16); var currVal_17 = _co.loadingMessage; _ck(_v, 12, 0, currVal_17); var currVal_18 = (((nodeValue(_v, 14).mode === "indeterminate") || (nodeValue(_v, 14).mode === "query")) ? null : nodeValue(_v, 14).value); var currVal_19 = nodeValue(_v, 14).mode; var currVal_20 = nodeValue(_v, 14)._isNoopAnimation; _ck(_v, 13, 0, currVal_18, currVal_19, currVal_20); var currVal_23 = (_co.loading ? "hidden-content" : "full-height"); _ck(_v, 15, 0, currVal_23); });
    }
    function View_MainPage_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "main-page", [], null, null, null, View_MainPage_0, RenderType_MainPage)), directiveDef(1, 180224, null, 0, MainPage, [Router, Store], null, null)], null, null); }
    var MainPageNgFactory = createComponentFactory("main-page", MainPage, View_MainPage_Host_0, { datasets: "datasets" }, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var styles_App = [styles$G];
    var RenderType_App = createRendererType2({ encapsulation: 0, styles: styles_App, data: {} });
    function View_App_2(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 2, "div", [], null, null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 1, "main-page", [], null, null, null, View_MainPage_0, RenderType_MainPage)), directiveDef(2, 180224, null, 0, MainPage, [Router, Store], { datasets: [0, "datasets"] }, null)], function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.datasets; _ck(_v, 2, 0, currVal_0); }, null); }
    function View_App_3(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "empty-page", [], null, null, null, View_EmptyPage_0, RenderType_EmptyPage)), directiveDef(1, 49152, null, 0, EmptyPage, [], null, null)], null, null); }
    function View_App_1(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 3, "div", [], null, null, null, null, null)), (_l()(), anchorDef(16777216, null, null, 1, null, View_App_2)), directiveDef(2, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"], ngIfElse: [1, "ngIfElse"] }, null), (_l()(), anchorDef(0, [["emptypage", 2]], null, 0, null, View_App_3))], function (_ck, _v) { var _co = _v.component; var currVal_0 = _co.dataFound; var currVal_1 = nodeValue(_v, 3); _ck(_v, 2, 0, currVal_0, currVal_1); }, null); }
    function View_App_4(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 4, "div", [["class", "progress-container"]], [[8, "hidden", 0]], null, null, null, null)), (_l()(), elementDef(1, 0, null, null, 1, "div", [["class", "loading-message"]], null, null, null, null, null)), (_l()(), textDef(-1, null, ["Loading data"])), (_l()(), elementDef(3, 0, null, null, 1, "mat-progress-bar", [["aria-valuemax", "100"], ["aria-valuemin", "0"], ["class", "mat-progress-bar"], ["color", "primary"], ["mode", "indeterminate"], ["role", "progressbar"]], [[1, "aria-valuenow", 0], [1, "mode", 0], [2, "_mat-animation-noopable", null]], null, null, d$c, c$9)), directiveDef(4, 4374528, null, 0, MatProgressBar, [ElementRef, NgZone, [2, ANIMATION_MODULE_TYPE], [2, MAT_PROGRESS_BAR_LOCATION]], { color: [0, "color"], mode: [1, "mode"] }, null)], function (_ck, _v) { var currVal_4 = "primary"; var currVal_5 = "indeterminate"; _ck(_v, 4, 0, currVal_4, currVal_5); }, function (_ck, _v) { var _co = _v.component; var currVal_0 = !_co.loading; _ck(_v, 0, 0, currVal_0); var currVal_1 = (((nodeValue(_v, 4).mode === "indeterminate") || (nodeValue(_v, 4).mode === "query")) ? null : nodeValue(_v, 4).value); var currVal_2 = nodeValue(_v, 4).mode; var currVal_3 = nodeValue(_v, 4)._isNoopAnimation; _ck(_v, 3, 0, currVal_1, currVal_2, currVal_3); }); }
    function View_App_0(_l) { return viewDef(0, [(_l()(), anchorDef(16777216, null, null, 1, null, View_App_1)), directiveDef(1, 16384, null, 0, NgIf, [ViewContainerRef, TemplateRef], { ngIf: [0, "ngIf"], ngIfElse: [1, "ngIfElse"] }, null), (_l()(), anchorDef(0, [["progress_bar", 2]], null, 0, null, View_App_4))], function (_ck, _v) { var _co = _v.component; var currVal_0 = !_co.loading; var currVal_1 = nodeValue(_v, 2); _ck(_v, 1, 0, currVal_0, currVal_1); }, null); }
    function View_App_Host_0(_l) { return viewDef(0, [(_l()(), elementDef(0, 0, null, null, 1, "app", [], null, null, null, View_App_0, RenderType_App)), directiveDef(1, 114688, null, 0, App, [DataDispatcher, DataService], null, null)], function (_ck, _v) { _ck(_v, 1, 0); }, null); }
    var AppNgFactory = createComponentFactory("app", App, View_App_Host_0, {}, {}, []);
    /**
     * @fileoverview This file was generated by the Angular template compiler. Do not edit.
     *
     * @suppress {suspiciousCode,uselessCode,missingProperties,missingOverride,checkTypes}
     * tslint:disable
     */
    var AppModuleNgFactory = createNgModuleFactory(AppModule, [App], function (_l) { return moduleDef([moduleProvideDef(512, ComponentFactoryResolver, CodegenComponentFactoryResolver, [[8, [f, f$1, f$2, j, CaptureProfileDialogNgFactory, f$3, EmptyPageNgFactory, OverviewNgFactory, InputPipelineNgFactory, KernelStatsAdapterNgFactory, MemoryProfileNgFactory, MemoryViewerNgFactory, OpProfileNgFactory, PodViewerNgFactory, TfDataBottleneckAnalysisNgFactory, TensorflowStatsAdapterNgFactory, TraceViewerNgFactory, AppNgFactory]], [3, ComponentFactoryResolver], NgModuleRef]), moduleProvideDef(5120, LOCALE_ID$1, _localeFactory, [[3, LOCALE_ID$1]]), moduleProvideDef(4608, NgLocalization, NgLocaleLocalization, [LOCALE_ID$1, [2, DEPRECATED_PLURAL_FN]]), moduleProvideDef(5120, SCHEDULER, zoneSchedulerFactory, [NgZone]), moduleProvideDef(5120, APP_ID, _appIdRandomProviderFactory, []), moduleProvideDef(5120, IterableDiffers, _iterableDiffersFactory, []), moduleProvideDef(5120, KeyValueDiffers, _keyValueDiffersFactory, []), moduleProvideDef(4608, DomSanitizer, DomSanitizerImpl, [DOCUMENT]), moduleProvideDef(6144, Sanitizer, null, [DomSanitizer]), moduleProvideDef(4608, HAMMER_GESTURE_CONFIG, GestureConfig, [[2, MAT_HAMMER_OPTIONS], [2, MatCommonModule]]), moduleProvideDef(5120, EVENT_MANAGER_PLUGINS, function (p0_0, p0_1, p0_2, p1_0, p2_0, p2_1, p2_2, p2_3) { return [new DomEventsPlugin(p0_0, p0_1, p0_2), new KeyEventsPlugin(p1_0), new HammerGesturesPlugin(p2_0, p2_1, p2_2, p2_3)]; }, [DOCUMENT, NgZone, PLATFORM_ID, DOCUMENT, DOCUMENT, HAMMER_GESTURE_CONFIG, Console, [2, HAMMER_LOADER]]), moduleProvideDef(4608, EventManager, EventManager, [EVENT_MANAGER_PLUGINS, NgZone]), moduleProvideDef(135680, DomSharedStylesHost, DomSharedStylesHost, [DOCUMENT]), moduleProvideDef(4608, DomRendererFactory2, DomRendererFactory2, [EventManager, DomSharedStylesHost, APP_ID]), moduleProvideDef(5120, AnimationDriver, instantiateSupportedAnimationDriver, []), moduleProvideDef(5120, AnimationStyleNormalizer, instantiateDefaultStyleNormalizer, []), moduleProvideDef(4608, AnimationEngine, InjectableAnimationEngine, [DOCUMENT, AnimationDriver, AnimationStyleNormalizer]), moduleProvideDef(5120, RendererFactory2, instantiateRendererFactory, [DomRendererFactory2, AnimationEngine, NgZone]), moduleProvideDef(6144, SharedStylesHost, null, [DomSharedStylesHost]), moduleProvideDef(4608, Testability, Testability, [NgZone]), moduleProvideDef(4608, HttpXsrfTokenExtractor, HttpXsrfCookieExtractor, [DOCUMENT, PLATFORM_ID, XSRF_COOKIE_NAME]), moduleProvideDef(4608, HttpXsrfInterceptor, HttpXsrfInterceptor, [HttpXsrfTokenExtractor, XSRF_HEADER_NAME]), moduleProvideDef(5120, HTTP_INTERCEPTORS, function (p0_0) { return [p0_0]; }, [HttpXsrfInterceptor]), moduleProvideDef(4608, BrowserXhr, BrowserXhr, []), moduleProvideDef(6144, XhrFactory, null, [BrowserXhr]), moduleProvideDef(4608, HttpXhrBackend, HttpXhrBackend, [XhrFactory]), moduleProvideDef(6144, HttpBackend, null, [HttpXhrBackend]), moduleProvideDef(4608, HttpHandler, HttpInterceptingHandler, [HttpBackend, Injector]), moduleProvideDef(4608, HttpClient, HttpClient, [HttpHandler]), moduleProvideDef(4608, Overlay, Overlay, [ScrollStrategyOptions, OverlayContainer, ComponentFactoryResolver, OverlayPositionBuilder, OverlayKeyboardDispatcher, Injector, NgZone, DOCUMENT, Directionality, [2, Location]]), moduleProvideDef(5120, CDK_CONNECTED_OVERLAY_SCROLL_STRATEGY, CDK_CONNECTED_OVERLAY_SCROLL_STRATEGY_PROVIDER_FACTORY, [Overlay]), moduleProvideDef(5120, MAT_DIALOG_SCROLL_STRATEGY, MAT_DIALOG_SCROLL_STRATEGY_PROVIDER_FACTORY, [Overlay]), moduleProvideDef(135680, MatDialog, MatDialog, [Overlay, Injector, [2, Location], [2, MAT_DIALOG_DEFAULT_OPTIONS], MAT_DIALOG_SCROLL_STRATEGY, [3, MatDialog], OverlayContainer]), moduleProvideDef(4608, RadioControlRegistry, RadioControlRegistry, []), moduleProvideDef(4608, MutationObserverFactory, MutationObserverFactory, []), moduleProvideDef(4608, ErrorStateMatcher, ErrorStateMatcher, []), moduleProvideDef(5120, MAT_SELECT_SCROLL_STRATEGY, MAT_SELECT_SCROLL_STRATEGY_PROVIDER_FACTORY, [Overlay]), moduleProvideDef(5120, MAT_TOOLTIP_SCROLL_STRATEGY, MAT_TOOLTIP_SCROLL_STRATEGY_FACTORY, [Overlay]), moduleProvideDef(5120, MAT_MENU_SCROLL_STRATEGY, MAT_MENU_SCROLL_STRATEGY_FACTORY, [Overlay]), moduleProvideDef(5120, ActivatedRoute, rootRoute, [Router]), moduleProvideDef(4608, NoPreloading, NoPreloading, []), moduleProvideDef(6144, PreloadingStrategy, null, [NoPreloading]), moduleProvideDef(135680, RouterPreloader, RouterPreloader, [Router, NgModuleFactoryLoader, Compiler, Injector, PreloadingStrategy]), moduleProvideDef(4608, PreloadAllModules, PreloadAllModules, []), moduleProvideDef(5120, RouterScroller, createRouterScroller, [Router, ViewportScroller, ROUTER_CONFIGURATION]), moduleProvideDef(5120, ROUTER_INITIALIZER, getBootstrapListener, [RouterInitializer]), moduleProvideDef(5120, APP_BOOTSTRAP_LISTENER, function (p0_0) { return [p0_0]; }, [ROUTER_INITIALIZER]), moduleProvideDef(4608, AnimationBuilder, BrowserAnimationBuilder, [RendererFactory2, DOCUMENT]), moduleProvideDef(4608, DataService, DataService, [HttpClient, PlatformLocation]), moduleProvideDef(4608, DataDispatcher, DataDispatcher, [DataService, Store]), moduleProvideDef(1073742336, CommonModule, CommonModule, []), moduleProvideDef(1024, ErrorHandler, errorHandler, []), moduleProvideDef(1024, NgProbeToken, function () { return [routerNgProbeToken()]; }, []), moduleProvideDef(512, RouterInitializer, RouterInitializer, [Injector]), moduleProvideDef(1024, APP_INITIALIZER, function (p0_0, p1_0) { return [_createNgProbe(p0_0), getAppInitializer(p1_0)]; }, [[2, NgProbeToken], RouterInitializer]), moduleProvideDef(512, ApplicationInitStatus, ApplicationInitStatus, [[2, APP_INITIALIZER]]), moduleProvideDef(131584, ApplicationRef, ApplicationRef, [NgZone, Console, Injector, ErrorHandler, ComponentFactoryResolver, ApplicationInitStatus]), moduleProvideDef(1073742336, ApplicationModule, ApplicationModule, [ApplicationRef]), moduleProvideDef(1073742336, BrowserModule, BrowserModule, [[3, BrowserModule]]), moduleProvideDef(1073742336, HttpClientXsrfModule, HttpClientXsrfModule, []), moduleProvideDef(1073742336, HttpClientModule, HttpClientModule, []), moduleProvideDef(1073742336, BidiModule, BidiModule, []), moduleProvideDef(1073742336, MatCommonModule, MatCommonModule, [[2, MATERIAL_SANITY_CHECKS], [2, HAMMER_LOADER]]), moduleProvideDef(1073742336, MatProgressBarModule, MatProgressBarModule, []), moduleProvideDef(1073742336, PlatformModule, PlatformModule, []), moduleProvideDef(1073742336, MatRippleModule, MatRippleModule, []), moduleProvideDef(1073742336, MatButtonModule, MatButtonModule, []), moduleProvideDef(1073742336, PortalModule, PortalModule, []), moduleProvideDef(1073742336, ScrollingModule, ScrollingModule, []), moduleProvideDef(1073742336, OverlayModule, OverlayModule, []), moduleProvideDef(1073742336, MatDialogModule, MatDialogModule, []), moduleProvideDef(1073742336, MatProgressSpinnerModule, MatProgressSpinnerModule, []), moduleProvideDef(1073742336, ɵInternalFormsSharedModule, ɵInternalFormsSharedModule, []), moduleProvideDef(1073742336, FormsModule, FormsModule, []), moduleProvideDef(1073742336, CdkAccordionModule, CdkAccordionModule, []), moduleProvideDef(1073742336, MatExpansionModule, MatExpansionModule, []), moduleProvideDef(1073742336, ObserversModule, ObserversModule, []), moduleProvideDef(1073742336, MatFormFieldModule, MatFormFieldModule, []), moduleProvideDef(1073742336, TextFieldModule, TextFieldModule, []), moduleProvideDef(1073742336, MatInputModule, MatInputModule, []), moduleProvideDef(1073742336, MatRadioModule, MatRadioModule, []), moduleProvideDef(1073742336, MatPseudoCheckboxModule, MatPseudoCheckboxModule, []), moduleProvideDef(1073742336, MatOptionModule, MatOptionModule, []), moduleProvideDef(1073742336, MatSelectModule, MatSelectModule, []), moduleProvideDef(1073742336, A11yModule, A11yModule, []), moduleProvideDef(1073742336, MatTooltipModule, MatTooltipModule, []), moduleProvideDef(1073742336, CaptureProfileDialogModule, CaptureProfileDialogModule, []), moduleProvideDef(1073742336, MatSnackBarModule, MatSnackBarModule, []), moduleProvideDef(1073742336, CaptureProfileModule, CaptureProfileModule, []), moduleProvideDef(1073742336, EmptyPageModule, EmptyPageModule, []), moduleProvideDef(1073742336, MatSidenavModule, MatSidenavModule, []), moduleProvideDef(1073742336, MatCardModule, MatCardModule, []), moduleProvideDef(1073742336, BufferDetailsModule, BufferDetailsModule, []), moduleProvideDef(1073742336, OpDetailsModule, OpDetailsModule, []), moduleProvideDef(1073742336, PodViewerDetailsModule, PodViewerDetailsModule, []), moduleProvideDef(1073742336, SideNavModule, SideNavModule, []), moduleProvideDef(1073742336, PipesModule, PipesModule, []), moduleProvideDef(1073742336, TraceViewerModule, TraceViewerModule, []), moduleProvideDef(1073742336, DiagnosticsViewModule, DiagnosticsViewModule, []), moduleProvideDef(1073742336, MatIconModule, MatIconModule, []), moduleProvideDef(1073742336, PerformanceSummaryModule, PerformanceSummaryModule, []), moduleProvideDef(1073742336, RecommendationResultViewModule, RecommendationResultViewModule, []), moduleProvideDef(1073742336, RunEnvironmentViewModule, RunEnvironmentViewModule, []), moduleProvideDef(1073742336, StepTimeGraphModule, StepTimeGraphModule, []), moduleProvideDef(1073742336, TopOpsTableModule, TopOpsTableModule, []), moduleProvideDef(1073742336, NormalizedAcceleratorPerformanceViewModule, NormalizedAcceleratorPerformanceViewModule, []), moduleProvideDef(1073742336, OverviewModule, OverviewModule, []), moduleProvideDef(1073742336, AnalysisSummaryModule, AnalysisSummaryModule, []), moduleProvideDef(1073742336, ChartModule, ChartModule, []), moduleProvideDef(1073742336, DeviceSideAnalysisDetailModule, DeviceSideAnalysisDetailModule, []), moduleProvideDef(1073742336, HostSideAnalysisDetailModule, HostSideAnalysisDetailModule, []), moduleProvideDef(1073742336, MatDividerModule, MatDividerModule, []), moduleProvideDef(1073742336, InputPipelineModule, InputPipelineModule, []), moduleProvideDef(1073742336, ExportAsCsvModule, ExportAsCsvModule, []), moduleProvideDef(1073742336, MatSliderModule, MatSliderModule, []), moduleProvideDef(1073742336, KernelStatsChartModule, KernelStatsChartModule, []), moduleProvideDef(1073742336, KernelStatsTableModule, KernelStatsTableModule, []), moduleProvideDef(1073742336, KernelStatsModule, KernelStatsModule, []), moduleProvideDef(1073742336, KernelStatsAdapterModule, KernelStatsAdapterModule, []), moduleProvideDef(1073742336, MemoryProfileSummaryModule, MemoryProfileSummaryModule, []), moduleProvideDef(1073742336, MemoryTimelineGraphModule, MemoryTimelineGraphModule, []), moduleProvideDef(1073742336, MemoryBreakdownTableModule, MemoryBreakdownTableModule, []), moduleProvideDef(1073742336, MemoryProfileModule, MemoryProfileModule, []), moduleProvideDef(1073742336, MaxHeapChartModule, MaxHeapChartModule, []), moduleProvideDef(1073742336, _MatCheckboxRequiredValidatorModule, _MatCheckboxRequiredValidatorModule, []), moduleProvideDef(1073742336, MatCheckboxModule, MatCheckboxModule, []), moduleProvideDef(1073742336, ProgramOrderChartModule, ProgramOrderChartModule, []), moduleProvideDef(1073742336, MemoryViewerMainModule, MemoryViewerMainModule, []), moduleProvideDef(1073742336, MemoryViewerModule, MemoryViewerModule, []), moduleProvideDef(1073742336, _MatSlideToggleRequiredValidatorModule, _MatSlideToggleRequiredValidatorModule, []), moduleProvideDef(1073742336, MatSlideToggleModule, MatSlideToggleModule, []), moduleProvideDef(1073742336, OpTableEntryModule, OpTableEntryModule, []), moduleProvideDef(1073742336, OpTableModule, OpTableModule, []), moduleProvideDef(1073742336, OpProfileModule, OpProfileModule, []), moduleProvideDef(1073742336, StackBarChartModule, StackBarChartModule, []), moduleProvideDef(1073742336, _MatMenuDirectivesModule, _MatMenuDirectivesModule, []), moduleProvideDef(1073742336, MatMenuModule, MatMenuModule, []), moduleProvideDef(1073742336, TopologyGraphModule, TopologyGraphModule, []), moduleProvideDef(1073742336, PodViewerModule, PodViewerModule, []), moduleProvideDef(1073742336, CategoryFilterModule, CategoryFilterModule, []), moduleProvideDef(1073742336, OrgChartModule, OrgChartModule, []), moduleProvideDef(1073742336, TableModule, TableModule, []), moduleProvideDef(1073742336, TfDataBottleneckAnalysisModule, TfDataBottleneckAnalysisModule, []), moduleProvideDef(1073742336, FlopRateChartModule, FlopRateChartModule, []), moduleProvideDef(1073742336, ModelPropertiesModule, ModelPropertiesModule, []), moduleProvideDef(1073742336, OperationsTableModule, OperationsTableModule, []), moduleProvideDef(1073742336, StatsTableModule, StatsTableModule, []), moduleProvideDef(1073742336, TensorflowStatsModule, TensorflowStatsModule, []), moduleProvideDef(1073742336, TensorflowStatsAdapterModule, TensorflowStatsAdapterModule, []), moduleProvideDef(1024, ROUTER_FORROOT_GUARD, provideForRootGuard, [[3, Router]]), moduleProvideDef(512, UrlSerializer, DefaultUrlSerializer, []), moduleProvideDef(512, ChildrenOutletContexts, ChildrenOutletContexts, []), moduleProvideDef(256, ROUTER_CONFIGURATION, {}, []), moduleProvideDef(1024, LocationStrategy, provideLocationStrategy, [PlatformLocation, [2, APP_BASE_HREF], ROUTER_CONFIGURATION]), moduleProvideDef(512, Location, Location, [LocationStrategy, PlatformLocation]), moduleProvideDef(512, Compiler, Compiler, []), moduleProvideDef(512, NgModuleFactoryLoader, SystemJsNgModuleLoader, [Compiler, [2, SystemJsNgModuleLoaderConfig]]), moduleProvideDef(1024, ROUTES, function () { return [[{ path: "empty", component: EmptyPage }, { path: "overview_page", component: Overview }, { path: "overview_page@", component: Overview }, { path: "overview_page^", component: Overview }, { path: "input_pipeline_analyzer", component: InputPipeline }, { path: "input_pipeline_analyzer@", component: InputPipeline }, { path: "input_pipeline_analyzer^", component: InputPipeline }, { path: "kernel_stats", component: KernelStatsAdapter }, { path: "kernel_stats^", component: KernelStatsAdapter }, { path: "memory_profile#", component: MemoryProfile }, { path: "memory_profile^", component: MemoryProfile }, { path: "memory_viewer", component: MemoryViewer }, { path: "op_profile", component: OpProfile }, { path: "pod_viewer", component: PodViewer }, { path: "pod_viewer^", component: PodViewer }, { path: "tf_data_bottleneck_analysis^", component: TfDataBottleneckAnalysis }, { path: "tensorflow_stats", component: TensorflowStatsAdapter }, { path: "tensorflow_stats^", component: TensorflowStatsAdapter }, { path: "trace_viewer", component: TraceViewer }, { path: "trace_viewer#", component: TraceViewer }, { path: "trace_viewer@", component: TraceViewer }, { path: "trace_viewer^", component: TraceViewer }, { path: "**", component: EmptyPage }]]; }, []), moduleProvideDef(1024, Router, setupRouter, [ApplicationRef, UrlSerializer, ChildrenOutletContexts, Location, Injector, NgModuleFactoryLoader, Compiler, ROUTES, ROUTER_CONFIGURATION, [2, UrlHandlingStrategy], [2, RouteReuseStrategy]]), moduleProvideDef(1073742336, RouterModule, RouterModule, [[2, ROUTER_FORROOT_GUARD], [2, Router]]), moduleProvideDef(1073742336, MainPageModule, MainPageModule, []), moduleProvideDef(1073742336, BrowserAnimationsModule, BrowserAnimationsModule, []), moduleProvideDef(1024, _FEATURE_CONFIGS, function () { return [{}, {}, {}]; }, []), moduleProvideDef(1024, STORE_FEATURES, function () { return [{ key: "root", reducerFactory: combineReducers, metaReducers: [] }, { key: "common_data_store", reducerFactory: combineReducers, metaReducers: [] }, { key: "tensorflow_stats", reducerFactory: combineReducers, metaReducers: [] }]; }, []), moduleProvideDef(1024, _STORE_FEATURES, _createFeatureStore, [Injector, _FEATURE_CONFIGS, STORE_FEATURES]), moduleProvideDef(1024, _FEATURE_REDUCERS, function () { return [rootReducer, commonDataStoreReducer, tensorFlowStatsReducer]; }, []), moduleProvideDef(1024, _FEATURE_REDUCERS_TOKEN, function (p0_0, p1_0, p2_0) { return [p0_0, p1_0, p2_0]; }, [_FEATURE_REDUCERS, _FEATURE_REDUCERS, _FEATURE_REDUCERS]), moduleProvideDef(1024, FEATURE_REDUCERS, function (p0_0, p0_1, p0_2, p1_0, p1_1, p1_2, p2_0, p2_1, p2_2) { return [_createFeatureReducers(p0_0, p0_1, p0_2), _createFeatureReducers(p1_0, p1_1, p1_2), _createFeatureReducers(p2_0, p2_1, p2_2)]; }, [Injector, _FEATURE_REDUCERS, _FEATURE_REDUCERS_TOKEN, Injector, _FEATURE_REDUCERS, _FEATURE_REDUCERS_TOKEN, Injector, _FEATURE_REDUCERS, _FEATURE_REDUCERS_TOKEN]), moduleProvideDef(131584, ActionsSubject, ActionsSubject, []), moduleProvideDef(2048, ReducerManagerDispatcher, null, [ActionsSubject]), moduleProvideDef(256, _INITIAL_STATE, undefined, []), moduleProvideDef(1024, INITIAL_STATE, _initialStateFactory, [_INITIAL_STATE]), moduleProvideDef(256, _INITIAL_REDUCERS, {}, []), moduleProvideDef(2048, _STORE_REDUCERS, null, [_INITIAL_REDUCERS]), moduleProvideDef(1024, INITIAL_REDUCERS, _createStoreReducers, [Injector, _INITIAL_REDUCERS, _STORE_REDUCERS]), moduleProvideDef(256, _REDUCER_FACTORY, combineReducers, []), moduleProvideDef(256, _USER_RUNTIME_CHECKS, undefined, []), moduleProvideDef(1024, USER_RUNTIME_CHECKS, _runtimeChecksFactory, [_USER_RUNTIME_CHECKS]), moduleProvideDef(1024, _ACTIVE_RUNTIME_CHECKS, createActiveRuntimeChecks, [USER_RUNTIME_CHECKS]), moduleProvideDef(1024, META_REDUCERS, function (p0_0, p1_0) { return [createImmutabilityCheckMetaReducer(p0_0), createSerializationCheckMetaReducer(p1_0)]; }, [_ACTIVE_RUNTIME_CHECKS, _ACTIVE_RUNTIME_CHECKS]), moduleProvideDef(256, USER_PROVIDED_META_REDUCERS, [], []), moduleProvideDef(1024, _RESOLVED_META_REDUCERS, _concatMetaReducers, [META_REDUCERS, USER_PROVIDED_META_REDUCERS]), moduleProvideDef(1024, REDUCER_FACTORY, createReducerFactory, [_REDUCER_FACTORY, _RESOLVED_META_REDUCERS]), moduleProvideDef(131584, ReducerManager, ReducerManager, [ReducerManagerDispatcher, INITIAL_STATE, INITIAL_REDUCERS, REDUCER_FACTORY]), moduleProvideDef(2048, ReducerObservable, null, [ReducerManager]), moduleProvideDef(131584, ScannedActionsSubject, ScannedActionsSubject, []), moduleProvideDef(131584, State, State, [ActionsSubject, ReducerObservable, ScannedActionsSubject, INITIAL_STATE]), moduleProvideDef(2048, StateObservable, null, [State]), moduleProvideDef(512, Store, Store, [StateObservable, ActionsSubject, ReducerManager]), moduleProvideDef(1024, _ROOT_STORE_GUARD, _provideForRootGuard, [[3, Store]]), moduleProvideDef(1073742336, StoreRootModule, StoreRootModule, [ActionsSubject, ReducerObservable, ScannedActionsSubject, Store, [2, _ROOT_STORE_GUARD]]), moduleProvideDef(1073873408, StoreFeatureModule, StoreFeatureModule, [_STORE_FEATURES, FEATURE_REDUCERS, ReducerManager, StoreRootModule]), moduleProvideDef(1073742336, RootStoreModule, RootStoreModule, []), moduleProvideDef(1073742336, AppModule, AppModule, []), moduleProvideDef(256, APP_ROOT, true, []), moduleProvideDef(256, XSRF_COOKIE_NAME, "XSRF-TOKEN", []), moduleProvideDef(256, XSRF_HEADER_NAME, "X-XSRF-TOKEN", []), moduleProvideDef(256, ANIMATION_MODULE_TYPE, "BrowserAnimations", [])]); });
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    enableProdMode();
    platformBrowser().bootstrapModuleFactory(AppModuleNgFactory);
}());
//# sourceMappingURL=bundle.es2015.js.map
